MODULE drawatoms

implicit none

CONTAINS 

   subroutine draw_atoms(atom,legm,icon)
!
!  Interfaccia per passare da JAV alla vecchia grafica e viceversa
!
   USE Atomi
   USE atom_type_util
   USE ilmviewmod
   type(atom_type), dimension(:), allocatable, intent(in)           :: atom
   type(bond_type), dimension(:), allocatable, intent(in), optional :: legm    
   integer, dimension(:), intent(in), optional                      :: icon
!
   if (present(icon)) then
       call ilmview_draw(atom,icon=iconn)
   else
       call ilmview_draw(atom,legm)
   endif
!
   end subroutine draw_atoms

!-----------------------------------------------------------------------

   subroutine draw_xyzs(conn)
   USE Atomi
   USE ilmviewmod
   USE atom_type_util
   USE molpnew
   USE variables, only:lconn
   USE General, only: cell
   USE unit_cell
   type(atom_type), dimension(:), allocatable :: atom
   logical, optional, intent(in)              :: conn
!
   call xyz_to_atom(atom,xyzs(:3,:nats),bfac,occr=xyzs(5,:),occh=occpch,nz=nz,lab=aLab)
   if (present(conn)) then
       if (conn) then
!corr           call create_connectivity(atom,iconn)
           call create_connectivity(atom,lconn,set_cell_type(cell))
       endif
   endif
!corr   call ilmview_draw(atom,icon=iconn)
   call ilmview_draw(atom,lconn)
!
   end subroutine draw_xyzs

!-------------------------------------------------------------------------------------------------

   subroutine importa0(filename,ier,kadd)
   USE errormod
   USE general, only:StructureName
   USE molcom,  only:jscreen
   USE importexport
   USE connect_mod
   USE ilmviewmod
   USE exportfiles
   USE variables
   USE connect_mod
   USE atom_type_util
   character(len=*), intent(in) :: filename
   integer, intent(out)         :: ier
   logical, intent(in)          :: kadd
   integer                      :: code
   type(error_type)             :: err
   type(atom_type), dimension(:), allocatable :: atom
   type(bond_type), dimension(:), allocatable :: legm
!
   ier = 0
   code = code_fragfilen(filename)
   if (code == 0) then
       call err%set('File:'//trim(filename)//char(10)//'Unrecognized file type')
       call err%print()
       ier = -1                 !!mr 051007
   else
       if (kadd) then
           call copia_atoms(atom,atm)
           call copia_legm(legm,lconn)
           call add_structure(filename,atom,legm,ier)
           call remove_duplicate_labels(atom)
       else
           call import_structure(filename,code,atom,legm,.false.,ier)
       endif
       if (ier /= 0) return
!corr       call Orto(cell)
       if(jscreen>0) then
          call ilmview_open(StructureName)
          call ilmview_draw(atom,legm)
       endif
       call update_model_and_export(atom,legm, 1)
   endif
!
   end subroutine importa0

END MODULE drawatoms
