!------------------------------------------------------------------------------

  MODULE FACTOR

  USE progtype, only:reflection_type,deratom
  USE atom_basic, only: atom_type

  implicit none
  real, dimension(5)  :: corfscat
  integer                :: icorfscat=0
  CONTAINS

   subroutine fcalcan_anis(ref,atx)
   USE General, only : ff,al,cl,bs,nk,twopi,rtod,twopi 
   USE Atomi, only : nzConst
   USE Symmetry, only : nsym,pts,icent,kmat,tmat
                              !USE, intrinsic :: ieee_arithmetic
!
   type(reflection_type), dimension(:), intent(inout) :: ref    ! i riflessi
   type(atom_type), dimension(:), intent(in)          :: atx    ! modello strutturale
   integer                                            :: natoms
   !real, dimension(4,48)                              :: hkle
   real, dimension(4,nsym)                            :: hkle
   integer, dimension(3)                              :: i1
   integer                                            :: i,j,jj
   real                                               :: rho
   integer                                            :: kz
   real                                               :: contc
   real                                               :: conts
   real                                               :: tfocc
   real                                               :: act,bct
   real                                               :: faze
   real                                               :: at,bt
   real                                               :: argg
   real                                               :: anis
   real, dimension(6)                                 :: beta
   real, dimension(3)                                 :: h

   natoms = size(atx)
   loop_riflessi: do i=1,size(ref)
      i1 = ref(i)%hkl
!-- compute H*R and H*T
      do j=1,nsym
         hkle(4,j) = dot_product(i1,tmat(j,:)) ! H*T
         hkle(:3,j) = matmul(i1,kmat(j,:,:))   ! H*R
      enddo

      rho=ref(i)%slaq
!
      ff(:nk) = cl(:nk) + sum(al(:,:nk)*exp(-bs(:,:nk)*rho),dim=1)
!
      act=0.0
      bct=0.0
      loop_atomi: do jj=1,natoms
         kz=iabs(atx(jj)%nz/nzConst)
         if (atx(jj)%bij(1) > 0) then
             tfocc=pts*ff(kz)*atx(jj)%och*atx(jj)%ocry
             at=0.0
             bt=0.0
             beta(:) = atx(jj)%bij(:) ! b11,b22,b33,b12,b13,b23
             do j=1,nsym
                argg = twopi*(dot_product(hkle(:3,j),atx(jj)%xc) + hkle(4,j))
                h(:) = hkle(:3,j)
                anis =    h(1)*h(1)*beta(1)+     h(2)*h(2)*beta(2)+    h(3)*h(3)*beta(3) &
                     +2.0*h(1)*h(2)*beta(4)+ 2.0*h(1)*h(3)*beta(5)+2.0*h(2)*h(3)*beta(6)
                anis=exp(-anis)
                at = at + cos(argg)*anis
                bt = bt + sin(argg)*anis
             enddo
         else
             tfocc=pts*ff(kz)*exp(-atx(jj)%biso*rho)*atx(jj)%och*atx(jj)%ocry
             at=0.0
             bt=0.0
             do j=1,nsym
                argg = twopi*(dot_product(hkle(:3,j),atx(jj)%xc) + hkle(4,j))
                at = at + cos(argg)
                bt = bt + sin(argg)
             enddo
         endif
         if (icent == 0) then
             contc=at
             conts=bt
         else
             contc=2.0*at
             conts=0.0
         endif
         act=act+contc*tfocc
         bct=bct+conts*tfocc
      enddo loop_atomi
!
      ref(i)%fc = sqrt(act**2+bct**2)
      faze=rtod*atan2(bct,act)+360.0
      ref(i)%ph = mod(int(faze+0.5),360)
   enddo loop_riflessi
!
   end subroutine fcalcan_anis

!-----------------------------------------------------------------------

   subroutine fcalcan(ref,atx)
   USE General, only : ff,al,cl,bs,nk,twopi,rtod,twopi 
   USE Atomi, only : nzConst
   USE Symmetry, only : nsym,pts,icent,kmat,tmat
                       !USE spginfom
!
   type(reflection_type), dimension(:), intent(inout) :: ref    ! i riflessi
   type(atom_type), dimension(:), intent(in)              :: atx    ! modello strutturale
   integer                                            :: natoms
   !real, dimension(4,48)                              :: hkle
   real, dimension(4,nsym)                              :: hkle
   integer, dimension(3)                              :: i1
   integer                                            :: i,j,jj
   real                                               :: rho
   integer                                            :: kz
   real                                               :: contc
   real                                               :: conts
   real                                               :: tfocc
   real                                               :: act,bct
   real                                               :: faze
   real                                               :: at,bt
   real                                               :: argg
       !character(len=100) :: strop

   natoms = size(atx)
   if (icent == 0) then
       loop_riflessi: do i=1,size(ref)
          i1 = ref(i)%hkl
!--     compute H*R and H*T
          do j=1,nsym
            hkle(4,j) = dot_product(i1,tmat(j,:))   ! H*T
            hkle(:3,j) = matmul(i1,kmat(j,:,:))  ! H*R
          enddo
          rho=ref(i)%slaq
!      
          ff(:nk) = cl(:nk) + sum(al(:,:nk)*exp(-bs(:,:nk)*rho),dim=1)
!      
          act=0.0
          bct=0.0
          loop_atomi: do jj=1,natoms
             kz=iabs(atx(jj)%nz/nzConst)
             tfocc=pts*ff(kz)*exp(-atx(jj)%biso*rho)*atx(jj)%och*atx(jj)%ocry
             at=0.0
             bt=0.0
             do j=1,nsym
                argg = twopi*(dot_product(hkle(:3,j),atx(jj)%xc) + hkle(4,j))
                at = at + cos(argg)
                bt = bt + sin(argg)
!!!!!!!!!!!!!!!!!!!!!!
             !    if (all(ref(i)%hkl == (/3,0,3/))) then
             !        call symop_to_string(symop_type(kmat(j,:,:),tmat(j,:)),strop)
             !        write(72,'(1x,i3,")",1x,a)')j,trim(strop)
             !        write(72,'(2(1x,a,f15.5))')'cos=',cos(argg),'sin=',sin(argg)
             !        write(72,*)                'HR=',hkle(:3,j),' HT=',hkle(4,j)
             !    endif
!!!!!!!!!!!!!!!!!!!!!!
             enddo
             contc=at
             conts=bt
             act=act+contc*tfocc
             bct=bct+conts*tfocc
          enddo loop_atomi
!      
          ref(i)%fc = sqrt(act**2+bct**2)
          faze=rtod*atan2(bct,act)+360.0
          ref(i)%ph = mod(int(faze+0.5),360)
       enddo loop_riflessi
   else
       loop_riflessi1: do i=1,size(ref)
          i1 = ref(i)%hkl
!--     compute H*R and H*T
          do j=1,nsym
            hkle(4,j) = dot_product(i1,tmat(j,:))   ! H*T
            hkle(:3,j) = matmul(i1,kmat(j,:,:))  ! H*R
          enddo
          rho=ref(i)%slaq
!      
          ff(:nk) = cl(:nk) + sum(al(:,:nk)*exp(-bs(:,:nk)*rho),dim=1)
!      
          act=0.0
         ! bct=0.0
          loop_atomi1: do jj=1,natoms
             kz=iabs(atx(jj)%nz/nzConst)
             tfocc=pts*ff(kz)*exp(-atx(jj)%biso*rho)*atx(jj)%och*atx(jj)%ocry
             at=0.0
         !    bt=0.0
             do j=1,nsym
                argg = twopi*(dot_product(hkle(:3,j),atx(jj)%xc) + hkle(4,j))
                at = at + cos(argg)
         !       bt = bt + sin(argg)
             enddo
         !if (icent == 0) then
         !    contc=at
         !    conts=bt
         !else
             !contc=2.0*at
         !    conts=0.0
         !endif
             act=act+at*tfocc
         !    act=act+contc*tfocc
         !    bct=bct+conts*tfocc
          enddo loop_atomi1
!      
      !bct = 0
      !ref(i)%fc = sqrt(act**2+bct**2)
      !faze=rtod*atan2(bct,act)+360.0
      !    ref(i)%ph = mod(int(faze+0.5),360)
          if (act >= 0.0) then
              ref(i)%fc = 2.0*act
              ref(i)%ph = 0
          else
              ref(i)%fc = -2.0*act
              ref(i)%ph = 180
          endif
       enddo loop_riflessi1
   endif
!
   end subroutine fcalcan

!-----------------------------------------------------------------------

   subroutine fcalcan_old(ref,atx)
   USE General, only : ff,al,cl,bs,nk,twopi,rtod,twopi 
   USE Atomi, only : nzConst
   !USE Symmetry, only : nsym,ismat,tsmat,pts,icent,kmat,tmat
   USE Symmetry, only : nsym,pts,icent,kmat,tmat
!
   type(reflection_type), dimension(:), intent(inout) :: ref    ! i riflessi
   type(atom_type), dimension(:), intent(in)              :: atx    ! modello strutturale
   integer                                            :: natoms
   real, dimension(4,48)                              :: hkle
   integer, dimension(3)                              :: i1
   integer                                            :: i,j,jj
   real                                               :: rho
   integer                                            :: kz
   real                                               :: contc
   real                                               :: conts
   real                                               :: tfocc
   real                                               :: act,bct
   real                                               :: faze
   real                                               :: at,bt
   real                                               :: argg

   natoms = size(atx)
   loop_riflessi: do i=1,size(ref)
      i1 = ref(i)%hkl
!-- compute H*R and H*T
      do j=1,nsym
        hkle(4,j) = dot_product(i1,tmat(j,:))   ! H*T
        hkle(:3,j) = matmul(i1,kmat(j,:,:))  ! H*R
      enddo
      rho=ref(i)%slaq
!
      ff(:nk) = cl(:nk) + sum(al(:,:nk)*exp(-bs(:,:nk)*rho),dim=1)
!
      act=0.0
      bct=0.0
      loop_atomi: do jj=1,natoms
         kz=iabs(atx(jj)%nz/nzConst)
         tfocc=pts*ff(kz)*exp(-atx(jj)%biso*rho)*atx(jj)%och*atx(jj)%ocry
         at=0.0
         bt=0.0
         do j=1,nsym
            argg = twopi*(dot_product(hkle(:3,j),atx(jj)%xc) + hkle(4,j))
            at = at + cos(argg)
            bt = bt + sin(argg)
         enddo
         if (icent == 0) then
             contc=at
             conts=bt
         else
             contc=2.0*at
             conts=0.0
         endif
         act=act+contc*tfocc
         bct=bct+conts*tfocc
      enddo loop_atomi
!
      ref(i)%fc = sqrt(act**2+bct**2)
      faze=rtod*atan2(bct,act)+360.0
      ref(i)%ph = mod(int(faze+0.5),360)
          !write(0,'(3(a,g20.7))')'act=',act,' bct=',bct,' tan(bct/act)=',mod(rtod*atan2(bct,act)+360,360.0)
   enddo loop_riflessi
!
   end subroutine fcalcan_old

 END MODULE FACTOR
