enum filtri { ALL_FILES, CIF_FILE, PDB_FILE, SHELX_FILE, FRA_FILE, 
       XYZ_FILE, ZMT_FILE, MOL_FILE, MOL2_FILE, MOP_FILE,
       POV_FILE, GAMESS_OUT, NWCHEM_OUT, GAMESS_IN, NWCHEM_IN, 
       GAUSSIAN_CART_IN, GAUSSIAN_ZMAT_IN};

static const char *FilesToImport =
   "All Readable Files"
   "!(*.cif,*.mol,*.mop,*.mol2,*.ml2,*.pdb,*.ent,*.fhz,*.fh,*.fra,*.frac,*.xyz,*.ins,*.res)@"
   "Crystallographic Information File (*.cif)@"
   "MDL Molfile (*.mol)@"
   "MOPAC Input File Format (*.mop)@"
   "Tripos SYBYL Mol2 File (*.mol2,*.ml2)@"
   "Protein Data Bank (*.pdb,*.ent)@"
   "Fenske-Hall Z-matrix (*.fhz,*.fh)@"
   "Free Form Fractional (*.fra,*.frac)@"
   "XYZ Cartesian Format (*.xyz)@"
#if defined(SIR_PGM) || defined(JAV)
   "SHELXL file (*.ins,*.res)"; 
#else
   "SHELXL file (*.ins,*.res)@"
   "GAMESS Output (*.out,*.log)@" 
   "NWChem Output (*.out,*.log)@"
   "MOPAC Output File Format (*.out)";
#endif
static int FILT_IN_READ[] = {ALL_FILES, CIF_FILE, MOL_FILE, MOP_FILE, MOL2_FILE,
                      PDB_FILE, ZMT_FILE, FRA_FILE, XYZ_FILE, SHELX_FILE,
                      GAMESS_OUT, NWCHEM_OUT, NWCHEM_OUT};
