#include <utils.h>
#include <fstream>
#include <sstream>
#include <iomanip>
#include "glext.h"
#include <sir_application.h>
#include <gtkdefs.h>

#ifdef JAV
#include "callbacks.h"
#endif
#include "jav_cb.h"
#ifdef GDK_WINDOWING_X11
#include <gdk/gdkx.h>
#elif defined (GDK_WINDOWING_WIN32)
#include <gdkwin32.h>
#include <strsafe.h>
#include "resource.h"
static HINSTANCE hInst;
static HCURSOR hcCross, hcMove, hcZoom, hcNorm;
#define WGL_SAMPLE_BUFFERS_ARB  0x2041
#define WGL_SAMPLES_ARB     0x2042

#ifdef IN_GTK3
bool win_native = false;
#else
bool win_native = true; //false; //true;   090114
#define USE_GRAB 1
#endif   //!IN_GTK3
#elif defined (GDK_WINDOWING_QUARTZ)
#include <gdk/gdkquartz.h>
#endif

static std::vector<int> NSamples;
static std::vector<int> iPixelFormats;

static const float no_mat[] = {0.0f, 0.0f, 0.0f, 1.0f}
;
extern "C" void mr_setenv_(char *stringa);
namespace main_app {
       extern Application JavApp;
                   }

static bool oldOrtho = true;

double angle = 60;
double Zmin = 0.01;
double Zmax = 1.; 

static bool calcRmI = false;   // da cambiare in 'true'  in caso di problemi
#define FIVE_DEG asin(0.087155743)
static GdkEventMask EventMask = (GdkEventMask) 
                               (GDK_BUTTON_PRESS_MASK |
                                GDK_BUTTON_RELEASE_MASK |
                                GDK_BUTTON_MOTION_MASK | 
                                GDK_POINTER_MOTION_MASK | 
//                                GDK_POINTER_MOTION_HINT_MASK |
                                GDK_SCROLL_MASK );

bool have_fb = false;
#if defined(GDK_WINDOWING_X11) && !defined (MACOSX)
  #define glGetProcAddress(a) glXGetProcAddress ( \
    reinterpret_cast<const unsigned char*>(a)     \
  )
#endif

#ifndef APIENTRY
#define APIENTRY GLAPIENTRY
#endif

#ifdef GDK_WINDOWING_X11
typedef void (APIENTRY * GLGENFRAMEBUFFERSPROC) (GLsizei n, GLuint *ids);
typedef void (APIENTRY * GLGENRENDERBUFFERSPROC) (GLsizei n, GLuint *ids);
typedef void (APIENTRY * GLDELETEFRAMEBUFFERSPROC) (GLsizei n, GLuint *ids);
typedef void (APIENTRY * GLDELETERENDERBUFFERSPROC) (GLsizei n, GLuint *ids);
typedef void (APIENTRY * GLBINDFRAMEBUFFERPROC) (GLenum target, GLuint fb);
typedef void (APIENTRY * GLBINDRENDERBUFFERPROC) (GLenum target, GLuint fb);
typedef void (APIENTRY * GLRENDERBUFFERSTORAGEPROC) (GLenum target,
        GLenum internalformat, GLsizei width, GLsizei height);
typedef void (APIENTRY * GLFRAMEBUFFERRENDERBUFFERPROC)
        (GLenum target, GLenum attachment, GLenum rbtarget, GLuint rb);
typedef GLenum (APIENTRY * GLCHECKFRAMEBUFFERSTATUSPROC) (GLenum target);

#ifndef GL_GLEXT_PROTOTYPES
   GLGENFRAMEBUFFERSPROC glGenFramebuffers;
   GLGENRENDERBUFFERSPROC glGenRenderbuffers;
   GLBINDRENDERBUFFERPROC glBindRenderbuffer;
   GLBINDFRAMEBUFFERPROC glBindFramebuffer;
   GLRENDERBUFFERSTORAGEPROC glRenderbufferStorage;
   GLFRAMEBUFFERRENDERBUFFERPROC glFramebufferRenderbuffer;
   GLDELETEFRAMEBUFFERSPROC glDeleteFramebuffers;
   GLDELETERENDERBUFFERSPROC glDeleteRenderbuffers;
   GLCHECKFRAMEBUFFERSTATUSPROC glCheckFramebufferStatus;
#define GL_RENDERBUFFER                   0x8D41
#define GL_FRAMEBUFFER                    0x8D40
#define GL_COLOR_ATTACHMENT0              0x8CE0
#define GL_FRAMEBUFFER_COMPLETE_EXT       0x8CD5
#endif
#endif

#ifdef _WIN32
typedef struct {
                 int ns, pf;
               } msinfo;
#endif

void call_javs(GtkWidget *, gpointer);
void OpenGLWindow();

void FBError()
{
   g_print("Missing OpenGL extension: Framebuffer Object.\n"
           "Preview mode will not be available.\n");
   exit(1);
}

bool Okfb()
{
#ifndef GL_RENDERBUFFER
    return false;
#endif
    const char *gl_extensions = 
          reinterpret_cast<const char*>(glGetString(GL_EXTENSIONS));
    bool support_framebuffer_object = false;
    bool support_framebuffer_via_ext = false;

    if (strstr(gl_extensions, "ARB_framebuffer_object") != 0)
    {
        support_framebuffer_object = true;
        support_framebuffer_via_ext = false;
    }
    else if (strstr(gl_extensions, "EXT_framebuffer_object") != 0)
    {
        support_framebuffer_object = true;
        support_framebuffer_via_ext = true;
    }
    if(!support_framebuffer_object)
       return false;
//    g_print("ARB %s EXT %s\n", support_framebuffer_via_ext?"no":"yes", support_framebuffer_via_ext?"yes":"no");

#if defined(MACOSX) && defined(HAVE_GTKGLEXT)
       return false;
#elif defined (GDK_WINDOWING_X11) && !defined (MACOSX)
    if(support_framebuffer_via_ext)
    {
       glGenFramebuffers =  (GLGENFRAMEBUFFERSPROC)glGetProcAddress("glGenFramebuffersEXT");
       glGenRenderbuffers = (GLGENRENDERBUFFERSPROC)glGetProcAddress("glGenRenderbuffersEXT");
       glBindRenderbuffer = (GLBINDRENDERBUFFERPROC)glGetProcAddress("glBindRenderbufferEXT");
       glRenderbufferStorage = (GLRENDERBUFFERSTORAGEPROC)glGetProcAddress("glRenderbufferStorageEXT");
       glBindFramebuffer = (GLBINDFRAMEBUFFERPROC)glGetProcAddress("glBindFramebufferEXT");
       glFramebufferRenderbuffer = (GLFRAMEBUFFERRENDERBUFFERPROC)glGetProcAddress("glFramebufferRenderbufferEXT");
       glDeleteFramebuffers = (GLDELETEFRAMEBUFFERSPROC)glGetProcAddress("glDeleteFramebuffersEXT");
       glDeleteRenderbuffers = (GLDELETERENDERBUFFERSPROC)glGetProcAddress("glDeleteRenderbuffersEXT");
       glCheckFramebufferStatus = (GLCHECKFRAMEBUFFERSTATUSPROC)glGetProcAddress("glCheckFramebufferStatusEXT");
    }
    else
    {
       glGenFramebuffers =  (GLGENFRAMEBUFFERSPROC)glGetProcAddress("glGenFramebuffers");
       glGenRenderbuffers = (GLGENRENDERBUFFERSPROC)glGetProcAddress("glGenRenderbuffers");
       glBindRenderbuffer = (GLBINDRENDERBUFFERPROC)glGetProcAddress("glBindRenderbuffer");
       glRenderbufferStorage = (GLRENDERBUFFERSTORAGEPROC)glGetProcAddress("glRenderbufferStorage");
       glBindFramebuffer = (GLBINDFRAMEBUFFERPROC)glGetProcAddress("glBindFramebuffer");
       glFramebufferRenderbuffer = (GLFRAMEBUFFERRENDERBUFFERPROC)glGetProcAddress("glFramebufferRenderbuffer");
       glDeleteFramebuffers = (GLDELETEFRAMEBUFFERSPROC)glGetProcAddress("glDeleteFramebuffers");
       glDeleteRenderbuffers = (GLDELETERENDERBUFFERSPROC)glGetProcAddress("glDeleteRenderbuffers");
       glCheckFramebufferStatus = (GLCHECKFRAMEBUFFERSTATUSPROC)glGetProcAddress("glCheckFramebufferStatus");
    }
    return((glGenRenderbuffers != NULL) &&
          (glBindRenderbuffer != NULL) &&
          (glRenderbufferStorage != NULL) &&
          (glBindFramebuffer != NULL) &&
          (glFramebufferRenderbuffer != NULL) &&
          (glDeleteFramebuffers != NULL) &&
          (glDeleteRenderbuffers != NULL) &&
          (glCheckFramebufferStatus != NULL));
#elif defined (GDK_WINDOWING_WIN32)
    return((glGenRenderbuffers != NULL) &&
          (glBindRenderbuffer != NULL) &&
          (glRenderbufferStorage != NULL) &&
          (glBindFramebuffer != NULL) &&
          (glFramebufferRenderbuffer != NULL) &&
          (glDeleteFramebuffers != NULL) &&
          (glDeleteRenderbuffers != NULL) &&
          (glCheckFramebufferStatus != NULL));
#endif
    return true;
}

namespace GLextmr {

void calcolaH();
GtkWidget *GLWINDOW = NULL;
GLuint font_list_base;
std::string defaultTitle = "Jav";
std::string BufferName = " ";
std::string defaultMessage = " ";
GLuint  iTexture[8];
int defaultCell = -1;
int defaultPlotStyle = -1;
int defaultSymmetry = -1;
int defaultLabels = -1;
int defaultColor = -1;
int defaultModify = 1;
int defaultBG = -1;
float defaultBgColor[3]  = {-1, -1, -1};
float defaultBgColor1[3] = {-1, -1, -1};
float defaultBgColor2[3] = {-1, -1, -1};
int defaultFog  = -1;
int defaultClip = -1;
bool defaultDrawPar = false;
vet3 defaultV0  = {{0, 0, 0}};
vet3 defaultabc = {{0, 0, 0}};
extern bool   defCentro;
extern int SaveSize[2];

int motion_type;
int nclicked;
bool  moving = false;
bool  in_selection = false;
GLfloat Range = 1.;
GLfloat sc_factor = 1;
GLint   npixels = 1;
extern int   ifSmooth;
extern float sc_bonds0;
bool PreviewMode = false;
static int OSWidth  = 200;
static int OSHeight = 200;
#ifdef JAV
extern bool ifDebug;
void LoadGLTextures();
#endif
Vert SelectionRect[4];
#ifdef HAVE_LEGEND
std::vector<Legenda> Legend;
#endif

void sync_radios();
void sync_radio(const char *menuname, bool Flag);

void set_motion_type(int t, int flag);
void ChangeSize(GLsizei w, GLsizei h, GLWindow *gl);
void BuildRect(Vert *v, float p1[], float p2[]);
void SetupRC(GLWindow *gl);
void update_center();
void RenderSceneNormal(GLWindow *gl);
void SaveBuffer(GtkWidget *w, bool ifT=false);
GdkPixbuf *pixbuf_get_from_window (GtkWidget *w);
#ifdef GDK_WINDOWING_WIN32
#endif

GLWindow::GLWindow(GtkWidget *wid, int w, int h)
{
      int i;
      inModify = -1;
      memset(this, 0, sizeof(*this));
      for(int i=0; i<MAX_NUM_MAPS; i++)
      {
          usedC[i] = -1;
          mapvisSav[i] = true;
      }
      for(int i=0; i<MAX_NUM_MODELS; i++)
          modelvisSav[i] = true;
      memcpy(BgColor, main_app::JavApp.app_color[BGC], 3*sizeof(float));
      memcpy(BgColor1, main_app::JavApp.app_color[BGC+1], 3*sizeof(float));
      memcpy(BgColor2, main_app::JavApp.app_color[BGC+2], 3*sizeof(float));
      BgType = main_app::JavApp.Background;
      memcpy(CellColor, main_app::JavApp.app_color[CELLC], 3*sizeof(float));
      memcpy(AxesColor, main_app::JavApp.app_color[AXESC], 3*sizeof(float));
      memcpy(ColorHB, main_app::JavApp.app_color[HBC], 4*sizeof(float));
      memcpy(ColorSC, main_app::JavApp.app_color[SCC], 4*sizeof(float));
      memcpy(DistColor, main_app::JavApp.app_color[INFOS], 4*sizeof(float));
      sc_atoms = 1;
      for(int i=0; i<N_ELEMENTS; i++)
      {
          scale_atoms[i] = 1; //main_app::JavApp.ScaleAt(i);
          sc_atoms = MRmax(sc_atoms, scale_atoms[i]);
      }
      scale_atoms[N_ELEMENTS] = 1;
      CentreColor[0] = 0.f;
      CentreColor[1] = 1.f;
      CentreColor[2] = 1.f;
      ifAxes = 1;
      ifDrawAxes = 1;
      CenterOnMap = false;
      ifDrawPar = false;
      DefaultLights(lightInfo);
      nLegends  = 0;
      activeLegend = -1;
      ShowTb = true;
      ShowLegend = true;
      Scale = 1;
      deltav = 1;
      normalToV = false;
      ShowMultBonds = false;
      sc_bonds = sc_bonds0;
      ell_tr = 0;
      RadType = 0;
      subdivisions = 8;
      Widget = wid;
      Height = h;
      Width  = w;
      border = (int) ((float)w * 0.2f);
      smooth = ifSmooth;
      Clip = false;
      ClipFactor = 1.0f;
      FogDensity = 0.3f;
      ifOrtho = true;
      if(defaultCell >= 0)
         ifCell = (defaultCell != 0);
       else
         ifCell = false;
      ifGrid = false;
      nDivisions = 5;
      GridPattern = 0x00FF;
      Stereo = false;
      glasses_type = REDBLUE;
      Normalized = 0;
      Radius = 10.f;
      ifWhole = false;
      xmin=-1.0f;
      xmax=1.0f;
      ymin=-1.0f;
      ymax=1.0f;
      zmin=-1.0f;
      zmax=1.0f ;
      obj_pos = MRVectorZero;
      view_quat = MRVector4Identity;
      view_quat_diff = MRVector4Identity;
      Rotm = MRMatrixIdentity;
      RotB = MRMatrixIdentity;
      motion_type = NO_MOVE ;
      nModels = 0;
      nMaps = 0;
      activeMap = -1;
      for(i=0; i<6; i++)
          Cell[i] = 0;
      Xd.x = Xd.y = Xd.z = 0;
      xyzC.x = xyzC.y = xyzC.z = 0;
      DrawCenter = false;
      eq0[0] = 0;
      eq0[1] = 0;
      eq0[2] = 1;
      eq0[3] = 0;
      eq1[0] = 0;
      eq1[1] = 0;
      eq1[2] = -1;
      eq1[3] = 0;
      fog = false;
      NSpecies = 0;
      for(int j=0; j<MAX_NUM_MODELS*MAX_SPECIES;j++)
          ListaSpecies[j] = -1;
      fontname = DuplicaStringa( main_app::JavApp.FontP().c_str());
      xoffset = 0.5f;
      yoffset = -0.5f;
      DistAng_vet.clear();
      ifDrawPar = defaultDrawPar;
      if(ifDrawPar)
      {
         MRVectorCopy(defaultabc, &abcPar);
         MRVectorCopy(defaultV0,  &xyzC);
      }
}

void GLWindow::DefaultLights(_LightInfo l_info[])
{
//Light 0
      l_info[JAV_LIGHT0].enabled = true;
      l_info[JAV_LIGHT0].position[0] = 1.0f;
      l_info[JAV_LIGHT0].position[1] = 1.0f;
      l_info[JAV_LIGHT0].position[2] = 0.f;   //1.0f;
      l_info[JAV_LIGHT0].position[3] = 1.0f;

      l_info[JAV_LIGHT0].specular[0] = 1.0f;
      l_info[JAV_LIGHT0].specular[1] = 1.0f;
      l_info[JAV_LIGHT0].specular[2] = 1.0f;
      l_info[JAV_LIGHT0].specular[3] = 0.15f;

      l_info[JAV_LIGHT0].diffuse[0] = 0.65f;
      l_info[JAV_LIGHT0].diffuse[1] = 0.65f;
      l_info[JAV_LIGHT0].diffuse[2] = 0.65f;
      l_info[JAV_LIGHT0].diffuse[3] = 1.0f;

//Light 1
      l_info[JAV_LIGHT1].enabled = true;
      l_info[JAV_LIGHT1].position[0] = -1.0f;
      l_info[JAV_LIGHT1].position[1] = -1.0f;//0.2f;
      l_info[JAV_LIGHT1].position[2] = 1.0f;
      l_info[JAV_LIGHT1].position[3] = 1.0f;

      l_info[JAV_LIGHT1].specular[0] = 0.5f;
      l_info[JAV_LIGHT1].specular[1] = 0.5f;
      l_info[JAV_LIGHT1].specular[2] = 0.5f;
      l_info[JAV_LIGHT1].specular[3] = 1.0f;

      l_info[JAV_LIGHT1].diffuse[0] = 0.5f;
      l_info[JAV_LIGHT1].diffuse[1] = 0.5f;
      l_info[JAV_LIGHT1].diffuse[2] = 0.5f;
      l_info[JAV_LIGHT1].diffuse[3] = 1.0f;

// Ambient
      l_info[JAV_AMBIENT].enabled = true;
      l_info[JAV_AMBIENT].diffuse[0] = 0.2f;
      l_info[JAV_AMBIENT].diffuse[1] = 0.2f;
      l_info[JAV_AMBIENT].diffuse[2] = 0.2f;
      l_info[JAV_AMBIENT].diffuse[3] = 1.0f;
}

#ifdef HAVE_LEGEND
Legenda::Legenda()
{
      float lco[]  = {1.f, 1.f, 0.f, 1.f};
      float bco[]  = {0.f, 0.f, 0.f, 1.f};
      fontname = DuplicaStringa( main_app::JavApp.FontP().c_str());
      for(int i=0; i<4; i++)
      {
          colore[i]  = lco[i];
          bcolore[i] = bco[i];
      }
      testo       = NULL;
      xpos        = 50;
      ypos        = 80;
      visible     = true;
      rect.x      = 0;
      rect.y      = 0;
      rect.width  = 0;
      rect.height = 0;
}

void Legenda::freeLegend()
{
     if(fontname)
        g_free(fontname);
     fontname = DuplicaStringa( main_app::JavApp.FontP().c_str());
     if(testo)
        g_free(testo);
     testo = NULL;
}

void Legenda::SetText(const char *stringa)
{
      testo = DuplicaStringa(stringa);
}

void Legenda::SetFont(const char *nome)
{
      fontname = DuplicaStringa(nome);
}

void Legenda::GetPos(int *x, int *y)
{
      *x = xpos;
      *y = ypos;
}

void Legenda::SetPos(int x, int y)
{
      xpos = x;
      ypos = y;
}

GdkRectangle *Legenda::LegendRect()
{
     return &rect;
}

void Legenda::SetRect(int x, int y, int w, int h)
{
     rect.x = x;
     rect.y = y;
     rect.width = w;
     rect.height = h;
}

void Legenda::SetForeground(float color[])
{
     for(int i=0; i<3; i++)
         colore[i] = color[i];
}

void Legenda::SetBackground(float color[])
{
     for(int i=0; i<3; i++)
         bcolore[i] = color[i];
}

void Legenda::SetShow(bool ifShow)
{
     visible = ifShow;
}

void GLWindow::DrawLegend()
{
    for(int i=0; i<nLegends; i++)
    {
        int x, y;
        Legend[i].GetPos(&x, &y);
        float *xy = FromPixel(x, y);
//        vet3 pos = {(double) x, (double) y, -1};
        vet3 pos = {{(double) xy[0], (double) xy[1], -1}};
        Legend[i].Draw(pos);
    }
}

void Legenda::Draw(vet3 xy)
{
    if((testo == NULL) || !visible)
       return;
    glPushMatrix();
    glLoadIdentity();
    glDisable (GL_DEPTH_TEST);
    PangoFontDescription *font_desc = pango_font_description_from_string(fontname);
    PangoRectangle rect1 = {rect.x, rect.y, rect.width, rect.height};
    std::string str_out;
    parse_string(testo, str_out);
    DrawText(-1, font_desc, PANGO_ALIGN_LEFT, colore,
            xy, str_out.c_str(), &rect1);
    rect.x = rect1.x + xpos;
    rect.y = rect1.y + ypos - rect.height;
    rect.width = rect1.width;
    rect.height = rect1.height;
    glEnable (GL_DEPTH_TEST);
    glPopMatrix();
    pango_font_description_free(font_desc);
}
#endif

void LoadWinCursor(int flag)
{

   GtkWidget *drawarea = get_widget(GLWINDOW, "drawingarea");
#ifdef GDK_WINDOWING_WIN32
   if(win_native)
   {

      HWND hWndJav = (HWND) get_object(drawarea, "hwnd");
      switch(flag)
      {
      case 1:
      case 3:
           SetCursor(hcCross);
           SetClassLongPtr(hWndJav, GCLP_HCURSOR, (LONG_PTR) hcCross);
           break;
      case 2:
           SetCursor(hcMove);
           SetClassLongPtr(hWndJav, GCLP_HCURSOR, (LONG_PTR) hcMove);
           break;
      case 4:
           SetCursor(hcZoom);
           SetClassLongPtr(hWndJav, GCLP_HCURSOR, (LONG_PTR) hcZoom);
           break;
      default:
           SetCursor(hcNorm);
           SetClassLongPtr(hWndJav, GCLP_HCURSOR, (LONG_PTR) hcNorm);
           break;
      }
      return;
   }
#endif
   GdkCursor *cursor;
   switch(flag)
   {
   case 1:
   case 3:
        cursor = (GdkCursor *)get_object(GLWINDOW, "cross_cursor");
        gdk_window_set_cursor(gtk_widget_get_window(drawarea),cursor);
        break;
   case 2:
        cursor = (GdkCursor *)get_object(GLWINDOW, "move_cursor");
        gdk_window_set_cursor(gtk_widget_get_window(drawarea),cursor);
        break;
   case 4:
        cursor = (GdkCursor *)get_object(GLWINDOW, "zoom_cursor");
        gdk_window_set_cursor(gtk_widget_get_window(drawarea),cursor);
        break;
   default:
        gdk_window_set_cursor(gtk_widget_get_window(drawarea),NULL);
        break;
   }
}

#ifdef GDK_WINDOWING_WIN32

unsigned WeightPixelFormats(PIXELFORMATDESCRIPTOR& pfd, bool bForceSoftware)
{
   unsigned weight = 1;

   if ( pfd.dwFlags & PFD_DOUBLEBUFFER )
      weight *= 2; // we like double buffered

  if (!(pfd.dwFlags & PFD_SUPPORT_OPENGL) ||
      !(pfd.dwFlags & PFD_DRAW_TO_WINDOW) ||
      ( pfd.cDepthBits <= 8 ) ||
      !(pfd.iPixelType == PFD_TYPE_RGBA)  )
       return(0);
   if (!(pfd.dwFlags & PFD_GENERIC_FORMAT))
   {
      if (bForceSoftware)
         weight = 0;
      else
         weight += 1024;
   }
   return(weight);
}

void myPixelFormatSetupFunction(HDC hdc, int pixelformat_required=0)
{
    int bpp = GetDeviceCaps(hdc, BITSPIXEL);
    PIXELFORMATDESCRIPTOR pfd = {
    sizeof(PIXELFORMATDESCRIPTOR),   // size of this pfd  
    1,                     // version number  
    PFD_DRAW_TO_WINDOW |   // support window  
    PFD_SUPPORT_OPENGL |   // support OpenGL  
    PFD_DOUBLEBUFFER,      // double buffered  
    PFD_TYPE_RGBA,         // RGBA type  
    bpp,                   // color depth  
    0, 0, 0, 0, 0, 0,      // color bits ignored  
    1,                     // no alpha buffer  
    0,                     // shift bit ignored  
    0,                     // no accumulation buffer  
    0, 0, 0, 0,            // accum bits ignored  
    32,                    // 32-bit z-buffer  
    0,                     // no stencil buffer  
    0,                     // no auxiliary buffer  
    PFD_MAIN_PLANE,        // main layer  
    0,                     // reserved  
    0, 0, 0                // layer masks ignored  
    };
    int  iPixelFormat;

    if(pixelformat_required != 0)
    {
       iPixelFormat = pixelformat_required;
       if(SetPixelFormat(hdc, iPixelFormat, &pfd))
           return;
    }
    
    // get the best available match of pixel format for the device context
    iPixelFormat = ChoosePixelFormat(hdc, &pfd);
    
    if(!PreviewMode && main_app::JavApp.ForceSoftRendering())
    {
       PIXELFORMATDESCRIPTOR pfd2 = pfd;
       int iCount = 1 + DescribePixelFormat( hdc, iPixelFormat,
                sizeof(PIXELFORMATDESCRIPTOR), &pfd2);
       unsigned weight = 0;
       while(--iCount)
       {
          DescribePixelFormat(hdc, iCount, sizeof(PIXELFORMATDESCRIPTOR), &pfd);
          unsigned w = WeightPixelFormats( pfd, true );
          if(w > weight) 
          {
             weight = w;
             iPixelFormat = iCount;
          }
       }
       SetPixelFormat(hdc, iPixelFormat, &pfd2);
    }
    else
    // make that the pixel format of the device context  
       SetPixelFormat(hdc, iPixelFormat, &pfd);
}

bool GLWindow::RenderingInfo(std::string &rendering_info)
{
using namespace main_app;
    HGLRC hglrc = wglGetCurrentContext();
    if(hglrc == NULL)
      return false;
    rendering_info = g_strdup_printf(
          "OpenGL renderer vendor:   %s\n"
          "OpenGL renderer string:   %s\n"
          "OpenGL renderer version:  %s\n",
          glGetString(GL_VENDOR), glGetString(GL_RENDERER),
          glGetString(GL_VERSION));
    if(JavApp.IsMSEnabled() && JavApp.IsMSSupported())
       rendering_info.append(g_strdup_printf(
          "Multisampling enabled: resolution %dx\n", JavApp.MSBuffers()));
    return true;
}

static WPARAM BuildWParam( int low, int high )
{
    return (((WPARAM) high << 16 ) | (WPARAM) low);
}
 
LRESULT CALLBACK JavProc(HWND hWnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
using namespace main_app;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   switch (iMsg )
   {
   case WM_MOUSEACTIVATE:
        SetFocus(hWnd);
        break;
   case WM_CREATE:
        { 
           HDC      hdc ; 
           HGLRC    hglrc ; 
           hdc = GetDC(hWnd); 
           myPixelFormatSetupFunction(hdc, JavApp.MSFormat()); 
           if ((hglrc = wglCreateContext(hdc)) != NULL )
                wglMakeCurrent(hdc, hglrc) ; 
           if(JavApp.IsMSEnabled())
           {
              glEnable(GL_MULTISAMPLE ); 
              GLint  iMultiSample = 0;
              GLint  iNumSamples = 0;
              glGetIntegerv(GL_SAMPLE_BUFFERS, &iMultiSample);
              glGetIntegerv(GL_SAMPLES, &iNumSamples);
              if(!iMultiSample)
                 JavApp.Set_AA(param_ENABLE, 0);
//              g_print("Multisample %s\n", iMultiSample?"enabled":"disabled");
           }
           ReleaseDC(hWnd, hdc);
        }  
        return(TRUE);
   case WM_SHOWWINDOW:
        {
           GLenum err = glewInit();
           if(wParam)
              SetupRC(gl);
           return(0L);
        }
   case WM_PAINT:
        {
           PAINTSTRUCT ps;
           HGLRC hglrc = wglGetCurrentContext(); 
//           HDC hdc = BeginPaint( hWnd, &ps );
           BeginPaint( hWnd, &ps );
           HDC hdc = GetDC(hWnd); 
           if (wglMakeCurrent(hdc, hglrc))
           {
               glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
               gl->ResetModelMatrix(0);
               gl->RenderScene();
               SwapBuffers (hdc);
               glFinish();       // per i PC rognosi
           }
           EndPaint( hWnd, &ps );
           ReleaseDC(hWnd, hdc);
        }
        return (0L);
   case WM_SIZE:
        { 
        HDC hdc = GetDC(hWnd); 
        HGLRC hglrc = wglGetCurrentContext(); 
        wglMakeCurrent(hdc, hglrc) ; 
        gl->Width  = LOWORD( lParam );
        gl->Height = HIWORD( lParam );
        gl->border = MRmin(100, (int) ((float)gl->Width * 0.2f));
        ChangeSize (gl->Width, gl->Height, gl);
        aggiorna_dimensioni(GLWINDOW);
        PostMessage(hWnd, WM_PAINT, 0, 0);
        ReleaseDC(hWnd, hdc);
        }
        return (TRUE);
   case WM_DESTROY:
        {
        HGLRC hglrc = wglGetCurrentContext(); 
        wglMakeCurrent(NULL, NULL);
        wglDeleteContext(hglrc);
        //hWndJav = 0;
        UnregisterClass( TEXT("Jav"), hInst );
        }
        return(TRUE);
   case WM_LBUTTONDOWN:
   case WM_RBUTTONDOWN:
        {
        int x = GET_X_LPARAM(lParam); 
        int y = GET_Y_LPARAM(lParam); 
        int but;
        if(wParam & MK_LBUTTON)
           but = 1;
        else
           but = 3;
        bool ifCtrl  = ((wParam & MK_CONTROL) == MK_CONTROL);
        bool ifShift = ((wParam & MK_SHIFT) == MK_SHIFT);
//        gtk_window_present(GTK_WINDOW(GLWINDOW));
        return (gl->ManageMousePress(x, y, but, ifCtrl, ifShift));
        }
   case WM_LBUTTONUP:
   case WM_RBUTTONUP:
   case WM_MBUTTONUP:
        {
        int x = GET_X_LPARAM(lParam); 
        int y = GET_Y_LPARAM(lParam); 
        int but;
        if(wParam & MK_LBUTTON)
           but = 1;
        else if(wParam & MK_RBUTTON)
           but = 3;
        else
           but = 2;
        gtk_window_present(GTK_WINDOW(GLWINDOW));
        return (gl->ManageMouseRelease(x, y, but));
        }
   case WM_MOUSEMOVE:
        {
        int x = GET_X_LPARAM(lParam);
        int y = GET_Y_LPARAM(lParam);
        int but = -1;
        if(wParam & MK_LBUTTON)
           but = 1;
        else if(wParam & MK_RBUTTON)
           but = 3;
//        gtk_window_present(GTK_WINDOW(GLWINDOW));
        return (gl->ManageMouseMove(x, y, but));
        }
   case WM_ERASEBKGND:
        return TRUE;
   case WM_MOUSEWHEEL:
        {
        bool ifScrollUp = (GET_WHEEL_DELTA_WPARAM(wParam) > 0);
        return (gl->ManageMouseScroll(ifScrollUp));
        }
   } 
   return DefWindowProc( hWnd, iMsg, wParam, lParam );
} 

ATOM pascal RegisterJavClass( HINSTANCE hInstance ) {
   WNDCLASSEX  wndclass ;

   wndclass.hInstance     = hInstance;
   wndclass.lpszClassName = TEXT("Jav");
   wndclass.lpfnWndProc   = JavProc;
   wndclass.style         = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
   wndclass.cbSize        = sizeof( WNDCLASSEX );
   wndclass.hIcon         = NULL;
   wndclass.hIconSm       = NULL;
   wndclass.hCursor       = LoadCursor( NULL, IDC_ARROW );
   wndclass.lpszMenuName  = NULL;
   wndclass.cbClsExtra    = 0;
   wndclass.cbWndExtra    = 0;
   wndclass.hbrBackground = ( HBRUSH )( COLOR_BTNFACE + 1 );
   return( RegisterClassEx( &wndclass ) );
}
 

void gtkJavEvent(GtkWidget *w, GdkRectangle *allocation, gpointer data) 
{
   HWND hWndJav = (HWND) get_object(w, "hwnd");
   if ( hWndJav )
        MoveWindow( hWndJav, allocation->x, allocation->y, allocation->width,
         allocation->height, FALSE);
}

HDC getCurrentDC(GtkWidget *widget)
{
    HWND hWndJav = (HWND) get_object(widget, "hwnd");
    HDC   hDC    = GetDC(hWndJav);
    return hDC;
}

void GLWindow::ReleaseWinStuff()
{
    HGLRC hglrc = wglGetCurrentContext();     
    HDC hDC = getCurrentDC(Widget);
    HWND hWndJav = (HWND) get_object(Widget, "hwnd");
    wglMakeCurrent(NULL, NULL);
    wglDeleteContext(hglrc);
    ReleaseDC(hWndJav, hDC);
    if(win_native)
       DestroyWindow(hWndJav);
}

bool WGLisExtensionSupported(const char *extension)
{
    const size_t extlen = strlen(extension);
    const char *supported = NULL;
 
    // Try To Use wglGetExtensionStringARB On Current DC, If Possible
    PROC wglGetExtString = wglGetProcAddress("wglGetExtensionsStringARB");
 
    if (wglGetExtString)
        supported = ((char*(__stdcall*)(HDC))wglGetExtString)(wglGetCurrentDC());
 
    // If That Failed, Try Standard Opengl Extensions String
    if (supported == NULL)
        supported = (char*)glGetString(GL_EXTENSIONS);
 
    // If That Failed Too, Must Be No Extensions Supported
    if (supported == NULL)
        return false;
 
    // Begin Examination At Start Of String, Increment By 1 On False Match
    for (const char* p = supported; ; p++)
    {
        // Advance p Up To The Next Possible Match
        p = strstr(p, extension);
 
        if (p == NULL)
            return false;                       // No Match
 
        // Make Sure That Match Is At The Start Of The String Or That
        // The Previous Char Is A Space, Or Else We Could Accidentally
        // Match "wglFunkywglExtension" With "wglExtension"
 
        // Also, Make Sure That The Following Character Is Space Or NULL
        // Or Else "wglExtensionTwo" Might Match "wglExtension"
        if ((p==supported || p[-1]==' ') && (p[extlen]=='\0' || p[extlen]==' '))
            return true;                        // Match
    }
}

bool InitMultisample(HDC hDC, std::vector<msinfo> &ns)
{
using namespace main_app; 
    msinfo c;
    bool supported;
    if (!WGLisExtensionSupported("WGL_ARB_multisample"))
        return false;

    PFNWGLCHOOSEPIXELFORMATARBPROC wglChoosePixelFormatARB =
        (PFNWGLCHOOSEPIXELFORMATARBPROC)wglGetProcAddress("wglChoosePixelFormatARB");
 
    if (!wglChoosePixelFormatARB)
        return false;
 
    int pixelFormat;
    BOOL valid;
    UINT numFormats;
    float fAttributes[] = {0,0};
 
    int iAttributes[] = { WGL_DRAW_TO_WINDOW_ARB,GL_TRUE,
        WGL_SUPPORT_OPENGL_ARB,GL_TRUE,
        WGL_ACCELERATION_ARB,WGL_FULL_ACCELERATION_ARB,
        WGL_COLOR_BITS_ARB,24,
        WGL_ALPHA_BITS_ARB,8,
        WGL_DEPTH_BITS_ARB,16,
        WGL_STENCIL_BITS_ARB,0,
        WGL_DOUBLE_BUFFER_ARB,GL_TRUE,
        WGL_SAMPLE_BUFFERS_ARB,GL_TRUE,
        WGL_SAMPLES_ARB, 2, // Check For 2x Multisampling
        0,0};
 
    int nsamples = 2;
    for(int i=1; i<=4; i++)
    {
        valid = wglChoosePixelFormatARB(hDC,iAttributes,fAttributes,1,
             &pixelFormat,&numFormats);
        if (valid && numFormats >= 1)
        {
            supported = true;
            c.ns = nsamples;
            c.pf = pixelFormat;
            ns.push_back(c);
        }
        nsamples *= 2;
        iAttributes[19] = nsamples;
    }
    return  supported;
}

bool sort_by_ns ( msinfo elem1, msinfo elem2 )
{
   return (elem1.ns < elem2.ns);
}

bool uniq_by_ns ( msinfo elem1, msinfo elem2 )
{
   return (elem1.ns == elem2.ns);
}

LRESULT CALLBACK TestMSProc(HWND hWnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
using namespace main_app;

   switch (iMsg )
   {
   case WM_CREATE:
        { 
           HDC      hdc ; 
           HGLRC    hglrc ; 
           hdc = GetDC(hWnd); 
    int bpp = GetDeviceCaps(hdc, BITSPIXEL);
    PIXELFORMATDESCRIPTOR pfd = {
    sizeof(PIXELFORMATDESCRIPTOR),   // size of this pfd  
    1,                     // version number  
    PFD_DRAW_TO_WINDOW |   // support window  
    PFD_SUPPORT_OPENGL |   // support OpenGL  
    PFD_DOUBLEBUFFER,      // double buffered  
    PFD_TYPE_RGBA,         // RGBA type  
    bpp,                   // color depth  
    0, 0, 0, 0, 0, 0,      // color bits ignored  
    1,                     // no alpha buffer  
    0,                     // shift bit ignored  
    0,                     // no accumulation buffer  
    0, 0, 0, 0,            // accum bits ignored  
    32,                    // 32-bit z-buffer  
    0,                     // no stencil buffer  
    0,                     // no auxiliary buffer  
    PFD_MAIN_PLANE,        // main layer  
    0,                     // reserved  
    0, 0, 0                // layer masks ignored  
    };
    int  PixelFormat = ChoosePixelFormat (hdc, &pfd);	
    if(PixelFormat == 0)
       return (FALSE);
    if(SetPixelFormat(hdc, PixelFormat, &pfd) == FALSE) 
       return (FALSE);
    if ((hglrc = wglCreateContext(hdc)) != NULL )
        wglMakeCurrent(hdc, hglrc) ; 
        ReleaseDC(hWnd, hdc);
        }  
        return(TRUE);
   case WM_SHOWWINDOW:
        {
            GLenum err = glewInit();
            HDC hdc = GetDC(hWnd); 
            std::vector<msinfo> ns;
            InitMultisample(hdc, ns);
            if(!ns.empty())
            {
                sort(ns.begin(), ns.end(), sort_by_ns);
                std::vector<msinfo>::iterator it = unique(ns.begin(), ns.end(), uniq_by_ns);
                ns.resize( std::distance(ns.begin(),it) );
                JavApp.Set_AA(param_SUPPORT, 1);
                for(int j=0; j<(int)ns.size(); j++)
                {
                    NSamples.push_back(ns.at(j).ns);
                    iPixelFormats.push_back(ns.at(j).pf);
                }
            }
            ReleaseDC(hWnd, hdc);
        return(0L);
        }
   case WM_DESTROY:
        {
        HGLRC hglrc = wglGetCurrentContext(); 
        wglMakeCurrent(NULL, NULL);
        wglDeleteContext(hglrc);
        UnregisterClass( TEXT("TestMS"), hInst);
        }
        return(TRUE);
   } 
   return DefWindowProc( hWnd, iMsg, wParam, lParam );
} 

ATOM pascal RegisterTestClass( HINSTANCE hInstance ) {
   WNDCLASSEX  wndclass ;
   ZeroMemory(&wndclass, sizeof(WNDCLASSEX));
   wndclass.hInstance     = hInstance;
   wndclass.lpszClassName = TEXT("TestMS");
   wndclass.lpfnWndProc   = TestMSProc;
   wndclass.style         = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
   wndclass.cbSize        = sizeof( WNDCLASSEX );
   wndclass.hIcon         = NULL;
   wndclass.hIconSm       = NULL;
   wndclass.hCursor       = LoadCursor( NULL, IDC_ARROW );
   wndclass.lpszMenuName  = NULL;
   wndclass.cbClsExtra    = 0;
   wndclass.cbWndExtra    = 0;
   wndclass.hbrBackground = ( HBRUSH )( COLOR_BTNFACE + 1 );
   return( RegisterClassEx( &wndclass ) );
}

void TestMultiSampling()
{
using namespace main_app;
    RegisterTestClass(hInst);
    DWORD windowExtendedStyle = WS_EX_APPWINDOW;
    DWORD windowStyle = WS_OVERLAPPEDWINDOW;

    HWND hWnd  = CreateWindowEx(windowExtendedStyle,
                              TEXT("TestMS"),
                              TEXT("TestMSW"),
                              windowStyle,
                              0,
                              0,
                              200,
                              200,
                              HWND_DESKTOP,
                              NULL,
                              hInst,
                              NULL );

     ShowWindow(hWnd, SW_SHOW);
     UpdateWindow(hWnd);
     DestroyWindow(hWnd);
}
#endif

void GLWindow::Destroy(int Flag)
{
     if(g_object_get_data(G_OBJECT(GLWINDOW), SettingsWindow) !=  NULL)
        gtk_widget_destroy(get_widget(GLWINDOW, SettingsWindow));
     close_pango();
//#ifdef JAV
//     if(!PreviewMode)
//        Save();
//#else
#ifndef JAV
     DistAng_vet.clear();
#endif
     if(!PreviewMode)
     {
        ReleaseWinStuff();
        int x, y;
        gtk_window_get_position(GTK_WINDOW(GLWINDOW), &x, &y);
        main_app::JavApp.UpdatePosition(x, y);
     }
     gtk_widget_destroy(GLWINDOW);
     GLWINDOW = NULL;
#ifdef JAV
     if(this)
          delete this;
     if(Flag == -1)
        return;
     gtk_main_quit();
     if(Flag)
        exit(-1);
#endif
}

void GLWindow::SetLightForSelected(int blend, float mat_e[], float alpha)
{
  float mat_emission[4] = {1.0f, 0.8f, 1.0f,   1.0f};
  if(mat_e != NULL)
     for(int i=0; i<4; i++)
         mat_emission[i] = mat_e[i];

  SetLightSystem(mat_emission, alpha, blend);
  glDepthMask (GL_FALSE);
}

void GLWindow::ResetLightForSelected()
{
  glDepthMask (GL_TRUE);
  glDisable(GL_BLEND);
  glDisable(GL_COLOR_MATERIAL);
  glEnable(GL_LIGHTING);
  glEnable(GL_NORMALIZE);
  glMaterialfv(GL_FRONT, GL_EMISSION, no_mat);
}

void GLWindow::Redraw()
{
  if(PreviewMode)
  {
     if(MakeCurrent())
        RenderSceneNormal(this);
     return;
  }

#ifdef GDK_WINDOWING_WIN32
  HWND hWndJav = (HWND) get_object(Widget, "hwnd");
//  HWND  hWnd = static_cast<HWND> GDK_WINDOW_HWND(gtk_widget_get_window(gtk_widget_get_toplevel(Widget)));
  InvalidateRect(hWndJav, NULL, FALSE);
#else
  GtkAllocation allocation;
  gtk_widget_get_allocation(Widget, &allocation);
  gdk_window_invalidate_rect (gtk_widget_get_window(Widget), &allocation, FALSE);
#endif
}

void GLWindow::calcolaO(std::vector<double> mini, std::vector<double> maxi)
{
  cylinder = 0.36 / (double)deltav;
  for(int j=0; j<3; j++)
  {
      double delta2 = maxi[j] - mini[j];
      Xd.v[j] = (deltav - delta2) / 2. - mini[j];
  }

  vet3 VCellN1 = Trasforma(MRVectorZero);
  vet3 VCellN2 = Trasforma(MRVectorMake(Cell));
  for(int i=0; i <8; i++)
  {
      vcN[i] = Trasforma(vc[i]);
      VertParN[i] = Trasforma(VertPar[i]);
  }
  for(int j=0; j<3; j++)
  {
      CellN[j] = (float) VCellN1.v[j];
      CellN[j+3] = (float) VCellN2.v[j];
  }
  xmin = (float) vcN[4].v[0];
  ymin = (float) vcN[4].v[1];
  zmin = (float) vcN[4].v[2];
  xmax = (float) vcN[1].v[0];
  ymax = (float) vcN[1].v[1];
  zmax = (float) vcN[1].v[2];
}

void GLWindow::SetOrtho(int c)
{
  ifOrtho = (c != 0);
  ResetProjectionMatrix(1.f);
}

void GLWindow::SetBgColor(bool aggiorna)
{
   int c = BgType;
   BgColor[3] = 1.f;
   if(c <= TYPE_FLAT)
      glClearColor(BgColor[0], BgColor[1], BgColor[2], BgColor[3]);
   else
      glClearColor(BgColor1[0], BgColor1[1], BgColor1[2], BgColor1[3]);
   glMaterialfv (GL_FRONT, GL_SPECULAR, lightInfo[JAV_LIGHT0].specular);
   memcpy(main_app::JavApp.app_color[BGC], BgColor, 4*sizeof(float));
   if(c >= TYPE_HGRAD)
   {
      memcpy(main_app::JavApp.app_color[BGC+1], BgColor1, 4*sizeof(float));
      memcpy(main_app::JavApp.app_color[BGC+2], BgColor2, 4*sizeof(float));
   }
   if(aggiorna)
      aggiorna_bg(c);
   Redraw();
}

vet3 GLWindow::Trasforma(vet3 num)
{
    if(deltav == 0)
       return num;
    vet3 result = MRVectorAddScalar(
           MRVectorMultiplyScalar(MRVectorAdd(num, Xd), 2./deltav), -1);
    return result;
}

float *GLWindow::FromPixel(int x, int y)
{
     GLfloat nRange = SCALA * Range;
     float *pos;
     pos = g_new0(float, 2);
     if((x < 0) || (x > Width))
        x = Width;
     if((y < 0) || (y > Height))
        y = Height;
     y = Height - y;
     if (aspectRatio <= 1)
     {
         pos[0] = 2.f * nRange * (float) x / (float) Width  - nRange;
         pos[1] = 2.f * nRange / aspectRatio * (float) y / (float) Height  - nRange / aspectRatio;
     }
     else
     {
         pos[0] = 2.f * nRange * aspectRatio * (float) x / (float) Width  - nRange * aspectRatio;
         pos[1] = 2.f * nRange * (float) y / (float) Height  - nRange;
     }
     return pos;
}

float *GLWindow::FromPixel3D(int x, int y)
{
    GLint viewport[4];
    GLdouble modelview[16];
    GLdouble projection[16];
    GLfloat winX, winY, winZ;
    GLdouble posX, posY, posZ;

    glGetDoublev( GL_MODELVIEW_MATRIX, modelview );
    glGetDoublev( GL_PROJECTION_MATRIX, projection );
    glGetIntegerv( GL_VIEWPORT, viewport );

    winX = (float)x;
    winY = (float)viewport[3] - (float)y;
    glReadPixels( x, int(winY), 1, 1, GL_DEPTH_COMPONENT, GL_FLOAT, &winZ );

    FromWinToCoord( winX, winY, winZ, modelview, projection, viewport, &posX, &posY, &posZ);
    float *result = g_new0(float, 3);
    result[0] = (float) posX;
    result[1] = (float) posY;
    result[2] = (float) posZ;
    return result;
}

void matrix_to_quat( float a[], float q[] ) 
{
  float trace = a[0] + a[5] + a[10] + 1; 
  if( trace > 0 ) 
  {
    float s = 0.5f / (float)sqrt(trace);
    q[0] = ( a[9] - a[6] ) * s;
    q[1] = ( a[2] - a[8] ) * s;
    q[2] = ( a[4] - a[1] ) * s;
    q[3] = 0.25f / s;
  }
  else 
  {
    if ( a[0] > a[5] && a[0] > a[10] ) 
    {
      float s = 2.0f * sqrtf( 1.0f + a[0] - a[5] - a[10]);
      q[0] = 0.5f * s;
      q[1] = (a[1] + a[4]) / s;
      q[2] = (a[2] + a[8]) / s;
      q[3] = (a[6] + a[9]) / s;
    }
    else if (a[5] > a[10])
    {
      float s = 2.0f * sqrtf( 1.0f + a[5] - a[0] - a[10]);
      q[0] = (a[1] + a[4]) / s;
      q[1] = 0.5f * s;
      q[2] = (a[6] + a[9]) / s;
      q[3] = (a[2] + a[8]) / s;
    }
    else
    {
      float s = 2.0f * sqrtf( 1.0f + a[10] - a[0] - a[5]);
      q[0] = (a[2] + a[8]) / s;
      q[1] = (a[6] + a[9]) / s;
      q[2] = 0.5f * s;
      q[3] = (a[1] + a[4]) / s;
    }
  }
  float mq = (q[0]*q[0] + q[1]*q[1] + q[2]*q[2] + q[3]*q[3]);
  for (int i = 0; i < 4; i++) 
       q[i] /= mq;
}

void GLWindow::SetViewpoint(float factor)
{
    Range = factor;
    sc_factor = 1.f / Range;
    if(sc_factor < 1e-6)
       sc_factor = 1;
    double nRange = SCALA * Range;
//    if(PreviewMode)
//       nRange = Range;

    mat4x4 c;
    if(ifOrtho)
    {
       if (aspectRatio <= 1)
           c = MRMatrixMakeOrtho (-nRange, nRange, -nRange / aspectRatio,
                                  nRange / aspectRatio,
                                  -10*nRange, 10*nRange);
       else
           c = MRMatrixMakeOrtho (-nRange * aspectRatio,
                                  nRange * aspectRatio, -nRange, nRange,
                                  -10*nRange, 10*nRange);
    }
    else
    {
       mat4x4 a = MRMatrixMakePerspective( angle, (double)aspectRatio, 0.5*nRange, 3.*nRange);
       mat4x4 b = MRMatrixMakeLookAt( 0.5,0.5,2*nRange, 0.0,0.0,0.0, 0.0,1.0,0.0 );
       c = MRMatrixMultiplyGL(a, b);
    }
    glMultMatrixd(c.m);
}

void GLWindow::ViewPlane(int whichPlane, bool redraw)
{
    if((nModels + nMaps) == 0)
        return;
    float *coef;
    vet3 vec1;
    switch(whichPlane)
    {
    case 'a':
          vec1 = MRVectorSub(vcN[2], vcN[4]);
          break;
    case 'b':
          vec1 = MRVectorSub(vcN[5], vcN[4]);
          break;
    case 'c':
          vec1 = MRVectorSub(vcN[6], vcN[4]);
          break;
    case 'L':
    case 'S':
          coef = get_coeff(whichPlane);
          if(coef == NULL)
             return;
          vec1 = MRVectorMake(coef);
          g_free(coef);
          break;
    }

  vet3 V = MRVectorNormalize(vec1);
  vet3 firstPerp = MRVectorFirstPerp(V);
  vet3 secondPerp = MRVectorCrossProduct(vec1, firstPerp);
  secondPerp = MRVectorNormalize(secondPerp);

  mat4x4 Mat = {{
                 firstPerp.x, secondPerp.x, V.x, 0,
                 firstPerp.y, secondPerp.y, V.y, 0,
                 firstPerp.z, secondPerp.z, V.z, 0,
                 0, 0, 0, 1}};

  view_quat = MRMatrixToQuat(Mat);
  view_quat_diff = MRVector4Identity;
  Rotm = MRMatrix4MakeFromQuat(view_quat);

  if(!redraw)
     return;
  Redraw();
  while(gtk_events_pending())
         (void) gtk_main_iteration();
}

void GLWindow::ResetProjectionMatrix(float factor)
{
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    SetViewpoint(factor);
}

void GLWindow::ResetModelMatrix(int sign)
{
    double subd = 200. * cylinder * sc_bonds * sc_factor;

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    if(sign)
       glTranslated( obj_pos.x+sign*10.f/Width, obj_pos.y, -obj_pos.z );
    else
       glTranslated( obj_pos.x, obj_pos.y, -obj_pos.z );
//    Scale =  1.0f + (float) obj_pos.z;
    subdivisions = (Scale > 1.)? ((int) (subd * Scale)) : ((int) subd);
    subdivisions = MRmax(subdivisions, 3);
    glScalef( Scale, Scale, Scale);
    glMultMatrixd (Rotm.m);
//    print_vector(obj_pos, "obj_pos");

}

void GLWindow::ToggleFog(int flag)
{
     bool Fog = (flag != 0);
     if(Fog != fog)
     {
        fog = Fog;
        Redraw();
     }
}

void GLWindow::ToggleTb(int flag)
{
     ShowTb = (flag != 0);
     if(ShowTb)
     {
        gtk_widget_show(get_widget(GLWINDOW, "toolbar"));
        gtk_widget_show(get_widget(GLWINDOW, "vtoolbar"));
     }
     else
     {
        gtk_widget_hide(get_widget(GLWINDOW, "toolbar"));
        gtk_widget_hide(get_widget(GLWINDOW, "vtoolbar"));
     }
}

void GLWindow::ToggleStereo(int flag)
{
     Stereo = (flag != 0);
     if(Stereo && (BgType < TYPE_FLAT))
     {
        oldOrtho = ifOrtho;
        ifOrtho = false;
     }
     else
        ifOrtho = oldOrtho;
}

#ifdef HAVE_LEGEND
void on_hide_legend(GtkWidget *, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   Legend[gl->activeLegend].SetShow(false);
   gl->Redraw();
}

void on_modify_legend(GtkWidget *, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   Legend[gl->activeLegend].LegendDialog(window);
   gl->Redraw();
}

void on_delete_legend(GtkWidget *, gpointer data)
{
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   Legend[gl->activeLegend].freeLegend();
   Legend.erase(Legend.begin()+gl->activeLegend);
   gl->nLegends--;
   gl->Redraw();
}

void build_popup2(int whichType, GtkWidget *window)
{
     GtkWidget *menu1 = gtk_menu_new ();
     std::stringstream nome;
     nome << "Popup " << whichType;
     g_object_set_data(G_OBJECT(window), nome.str().c_str(), menu1);
        static const char *items[] = {"Hide Legend",
                                       "Modify Legend",
                                       "Delete Legend"};
         static GCallback cb_func[] = {G_CALLBACK(on_hide_legend),
                                       G_CALLBACK(on_modify_legend),
                                       G_CALLBACK(on_delete_legend)};
         int nitems = (int) (sizeof(items)/sizeof(items[0]));
         for (int i=0; i<nitems; i++)
         {
             std::stringstream nome;
             nome << "Popup " << items[i] ;
             GtkWidget *menu_item = gtk_menu_item_new_with_label(items[i]);
             gtk_menu_shell_append (GTK_MENU_SHELL (menu1), menu_item);
             gtk_widget_show (menu_item);
             g_object_set_data(G_OBJECT(window), nome.str().c_str(), menu_item);
             g_signal_connect(G_OBJECT(menu_item), "activate",
                       G_CALLBACK(cb_func[i]), (gpointer) window);
         }
}
bool GLWindow::ManageClickLegend(int x, int y, int button)
{
  if(nLegends > 0)
  {
     for(int kleg=0; kleg<nLegends; kleg++)
     {
         if(Legend[kleg].IsVisible())
         {
            gpointer legenda = region_rectangle(Legend[kleg].LegendRect());
            if(point_in_region(legenda, x, y))
            {
               activeLegend = kleg;
               if(button == 1)
               {
                  set_motion_type(MOVE_LEGEND, 2);
                  return true;
               }
               else
               {
                  set_motion_type(NO_MOVE, 0);
                  doPopup(LEGEND_POPUP);   
                  return true;
               }
            }
         }
     }
  }
  return false;
}

void GLWindow::ToggleLegend(int flag)
{
    ShowLegend = (flag != 0);

    for(int i=0; i<nLegends; i++)
        Legend[i].SetShow(ShowLegend);
    Redraw();
}

void GLWindow::DestroyLegend()
{
    for(int i=0; i<nLegends; i++)
        Legend[i].freeLegend();
    Legend.clear();
    nLegends = 0;
    Redraw();
}
#endif

void GLWindow::ToggleCell(int flag)
{
     bool cell = (flag != 0);
     if(cell != ifCell)
     {
        sync_radio("View Cell Edges", cell);
        ifCell = cell;
#ifdef MAPS
        RunMCAll();
#endif
//291111        ResetView();
        RiNormalizza(true);
        Redraw();
     }
}

void GLWindow::ToggleGrid(int flag)
{
     bool grid = (flag != 0);
     if(grid != ifGrid)
     {
        ifGrid = grid;
        Redraw();
     }
}

void GLWindow::DrawGrid()
{
    myreal x0 = 0, y0 = 0, z0 = 0;
    myreal x1 = 1, y1 = 1, z1 = 1;
// le seguenti per una griglia cubica (dimensioni in Angstrom)
    float delta = 2.f;
    int xdivisions = (int)(Cell[0]/delta);
    int ydivisions = (int)(Cell[1]/delta);
    int zdivisions = (int)(Cell[2]/delta);
//  questa per una griglia cristallografica
    xdivisions = ydivisions = zdivisions = nDivisions;

    float deltax = 1.f/xdivisions;
    float deltay = 1.f/ydivisions;
    float deltaz = 1.f/zdivisions;

    if(GridPattern > 0)
    {
       glLineStipple(1, (GLushort)GridPattern);
       glEnable(GL_LINE_STIPPLE);
    }
    else
       glDisable(GL_LINE_STIPPLE);
    for(int iz=0; iz<=zdivisions; iz++)
    {
    int k = 0;
    vet3 *gp;
    int size_gp = 2*(xdivisions+1);
    gp = g_new0(vet3 , size_gp);
    for(int i=0; i<=xdivisions; i++)
    {
       vet3 x = {{x0, y0, z0}};
       vet3 v1 = MRMatrix3MultiplyVector3(rmC, x);
       gp[k] = Trasforma(v1);
       vet3 xx = {{x0, y1, z0}};
       v1 = MRMatrix3MultiplyVector3(rmC, xx);
       gp[k+1] = Trasforma(v1);
       k+=2;
       x0 += deltax;
    }
    glDisable (GL_LIGHTING);
    glPushMatrix();
    float color1[3] = {0.7f, 0.7f, 0.7f};
    if(Stereo && (BgType < TYPE_FLAT))
       Desaturate(color1);
    glColor3fv(color1);
    glBegin(GL_LINES);
    for(int i=0; i<2*(xdivisions+1); i++)
        glVertex3dv(gp[i].v);
    glEnd();

    glPopMatrix();
    g_free(gp);
    z0 += deltaz;
    x0 = 0;
    }

    x0 = y0 = z0 = 0;
    for(int iz=0; iz<=zdivisions; iz++)
    {
    int k = 0;
    vet3 *gp;
    int size_gp = 2*(ydivisions+1);
    gp = g_new0(vet3, size_gp);
    for(int i=0; i<=ydivisions; i++)
    {
       vet3 x = {{x0, y0, z0}}, v1;
       v1 = MRMatrix3MultiplyVector3(rmC, x);
       gp[k] = Trasforma(v1);
       vet3 xx = {{x1, y0, z0}};
       v1 = MRMatrix3MultiplyVector3(rmC, xx);
       gp[k+1] = Trasforma(v1);
       k+=2;
       y0 += deltay;
    }
    glDisable (GL_LIGHTING);
    glPushMatrix();
    float color1[3] = {0.7f, 0.7f, 0.7f};
    if(Stereo && (BgType < TYPE_FLAT))
       Desaturate(color1);
    glColor3fv(color1);
    glBegin(GL_LINES);
    for(int i=0; i<2*(ydivisions+1); i++)
        glVertex3dv(gp[i].v);
    glEnd();

    glPopMatrix();
    g_free(gp);
    z0 += deltaz;
    y0 = 0;
    }

    x0 = y0 = z0 = 0;
    for(int iy=0; iy<=ydivisions; iy++)
    {
    int k = 0;
    vet3 *gp;
    int size_gp = 2*(xdivisions+1);
    gp = g_new0(vet3, size_gp);
    for(int i=0; i<=xdivisions; i++)
    {
       vet3 x = {{x0, y0, z0}}, v1;
       v1 = MRMatrix3MultiplyVector3(rmC, x);
       gp[k] = Trasforma(v1);
       vet3 xx = {{x0, y0, z1}};
       v1 = MRMatrix3MultiplyVector3(rmC, xx);
       gp[k+1] = Trasforma(v1);
       k+=2;
       x0 += deltax;
    }
    glDisable (GL_LIGHTING);
    glPushMatrix();
    float color1[3] = {0.7f, 0.7f, 0.7f};
    if(Stereo && (BgType < TYPE_FLAT))
       Desaturate(color1);
    glColor3fv(color1);
    glBegin(GL_LINES);
    for(int i=0; i<2*(xdivisions+1); i++)
        glVertex3dv(gp[i].v);
    glEnd();

    glPopMatrix();
    g_free(gp);
    y0 += deltay;
    x0 = 0;
    }

    x0 = 0;
    y0 = 0;
    for(int ix=0; ix<=xdivisions; ix++)
    {
    int k = 0;
    vet3 *gp;
    int size_gp = 2*(ydivisions+1);
    gp = g_new0(vet3, size_gp);
    for(int i=0; i<=ydivisions; i++)
    {
       vet3 x = {{x0, y0, z0}}, v1;
       v1 = MRMatrix3MultiplyVector3(rmC, x);
       gp[k] = Trasforma(v1);
       vet3 xx = {{x0, y0, z1}};
       v1 = MRMatrix3MultiplyVector3(rmC, xx);
       gp[k+1] = Trasforma(v1);
       k+=2;
       y0 += deltay;
    }
    glDisable (GL_LIGHTING);
    glPushMatrix();
    float color1[3] = {0.7f, 0.7f, 0.7f};
    if(Stereo && (BgType < TYPE_FLAT))
       Desaturate(color1);
    glColor3fv(color1);
    glBegin(GL_LINES);
    for(int i=0; i<2*(ydivisions+1); i++)
        glVertex3dv(gp[i].v);
    glEnd();

    glPopMatrix();
    g_free(gp);
    x0 += deltax;
    y0 = 0;
    }
    glDisable(GL_LINE_STIPPLE);
}

void GLWindow::CalcPar(vet3 v, vet3 abc)
{
     vet3 vcc = MRMatrix3MultiplyVector3(rmC, v);
     float cellpar[6] = {(float) abc.x, (float) abc.y, (float) abc.z,
                         Cell[3], Cell[4], Cell[6]};
     mat3x3 rm2, rm2I;
     CalcMats(cellpar, &rm2, &rm2I, NULL, NULL, calcRmI);
     int mord[] = {2, 5, 6, 4, 3, 0, 7, 1};

     float xv[8][3] = {{0.5f, -0.5f, -0.5f}, {-0.5f, 0.5f, -0.5f},
                        {-0.5f, -0.5f, 0.5f}, {-0.5f, -0.5f, -0.5f},
                        {0.5f, 0.5f, -0.5f}, {0.5f, -0.5f, 0.5f},
                        {-0.5f, 0.5f, 0.5f}, {0.5f, 0.5f, 0.5f}};

     for(int i=0; i<8; i++)
     {
         vet3 x1 = MRVectorMake(xv[i]);
         vet3 x2 = MRMatrix3MultiplyVector3(rm2, x1);
         VertPar[mord[i]] = MRVectorAdd(x2, vcc);
     }
}

void DrawPar(vet3 VC[8], float color1[], int sm, char *fontname=NULL)
{
    bool drawAxes=false;
    if(fontname != NULL)
       drawAxes = true;
    glDisable (GL_LIGHTING);
    glPushMatrix();
    glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
    if(sm)
    {
       glEnable (GL_LINE_SMOOTH);
       glEnable (GL_BLEND);
       glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
       glHint (GL_LINE_SMOOTH_HINT, GL_DONT_CARE);
       glLineWidth(1.5f);
    }
    glColor3fv(color1);

    glBegin(GL_QUAD_STRIP);
        glVertex3dv(VC[1].v);       //V2
        glVertex3dv(VC[0].v);       //V1
        glVertex3dv(VC[3].v);       //V4
        glVertex3dv(VC[2].v);       //V3
        glVertex3dv(VC[5].v);       //V6
        glVertex3dv(VC[4].v);       //V5
        glVertex3dv(VC[7].v);       //V8
        glVertex3dv(VC[6].v);       //V7
        glVertex3dv(VC[1].v);       //V2
        glVertex3dv(VC[0].v);       //V1
    glEnd();

    if(drawAxes)
    {
       glDepthMask (GL_FALSE);
       glDisable (GL_DEPTH_TEST);
       glBegin(GL_LINES);
           glColor4f(1, 0, 0, 1);
           glVertex3dv(VC[4].v); 
           glVertex3dv(VC[2].v);
           glColor4f(0, 1, 0, 1);
           glVertex3dv(VC[4].v); 
           glVertex3dv(VC[5].v);
           glColor4f(0, 0, 1, 1);
           glVertex3dv(VC[4].v); 
           glVertex3dv(VC[6].v);
       glEnd();
#ifdef _WIN64
    glColor3f(1.0f, 1.0f, 1.0f);
    glRasterPos3dv( VC[4].v);
    glCallLists (1, GL_UNSIGNED_BYTE, "O");
    glColor3f(1.0f, 0.0f, 0.0f);
    glRasterPos3dv( VC[2].v);
    glCallLists (1, GL_UNSIGNED_BYTE, "a");
    glColor3f(0.0f, 1.0f, 0.0f);
    glRasterPos3dv( VC[5].v);
    glCallLists (1, GL_UNSIGNED_BYTE, "b");
    glColor3f(0.0f, 0.0f, 1.0f);
    glRasterPos3dv( VC[6].v);
    glCallLists (1, GL_UNSIGNED_BYTE, "c");
#else
       PangoFontDescription *font_desc =
          pango_font_description_from_string(fontname);
       {
       GLfloat ico[] = {1, 1, 1};
       DrawText(-1, font_desc, PANGO_ALIGN_LEFT, ico, VC[4], "O", NULL, true);
       }
       {
       GLfloat ico[] = {1, 0, 0};
       DrawText(-1, font_desc, PANGO_ALIGN_LEFT, ico, VC[2], "a", NULL, true);
       }
       {
       GLfloat ico[] = {0, 1, 0};
       DrawText(-1, font_desc, PANGO_ALIGN_LEFT, ico, VC[5], "b", NULL, true);
       }
       {
       GLfloat ico[] = {0, 0, 1};
       DrawText(-1, font_desc, PANGO_ALIGN_LEFT, ico, VC[6], "c", NULL, true);
       }
       pango_font_description_free(font_desc);
#endif
       glDepthMask (GL_TRUE);
       glEnable (GL_DEPTH_TEST);
    }

    glPopMatrix();
    glDisable (GL_LINE_SMOOTH);
    glDisable (GL_BLEND);
}

void GLWindow::DrawCell()
{
    float color1[3];
    memcpy(color1, CellColor, 3*sizeof(float));
    if(Stereo && (BgType < TYPE_FLAT))
       Desaturate(color1);
    if(ifDrawAxes)
       DrawPar(vcN, color1, smooth, fontname);
    else
       DrawPar(vcN, color1, smooth);
}

void GLWindow::on_rotate(int axis, float sign)
{
     vet3 a = {{0, 0, 0}};
     a.v[axis] = 1;
     view_quat_diff = MRAxisToQuat(a, sign*FIVE_DEG);
     view_quat = MRAddQuats (view_quat_diff, view_quat);
     Rotm = MRMatrix4MakeFromQuat(view_quat);
     Redraw ();
}

void GLWindow::on_move(int axis, float val)
{
     val *= Range;
     if(axis == 2)
     {
        double oldScale = Scale;
        if(ifOrtho)
           Scale += val;
        else
           Scale -= val;
        change_clip_value();
        double mzoom = Scale / oldScale;
        obj_pos.x *= mzoom;
        obj_pos.y *= mzoom;
     }
     else
        obj_pos.v[axis] += val;
     Redraw ();
}

void GLWindow::on_move_center(int axis, int sign)
{
     float val = sign * 0.02f;
     xyzC.v[axis] += val;
     if( xyzC.v[axis] > 1)
         xyzC.v[axis] = 1;
     if( xyzC.v[axis] < 0)
         xyzC.v[axis] = 0;
     RiNormalizza();
     Redraw ();
     while(gtk_events_pending())
         (void) gtk_main_iteration();
#ifdef MAPS
     update_center();
#endif
}

void GLWindow::on_move_centerf(int axis, float sign)
{
     float val = sign;
     xyzC.v[axis] += val;
     if( xyzC.v[axis] > 1)
         xyzC.v[axis] = 1;
     if( xyzC.v[axis] < 0)
         xyzC.v[axis] = 0;
     RiNormalizza();
     Redraw ();
     while(gtk_events_pending())
         (void) gtk_main_iteration();
#ifdef MAPS
     update_center();
#endif
}

void GLWindow::change_clip_value()
{
     eq0[3] =  eq1[3] =  ClipFactor * Scale * 1.5;
}

void GLWindow::ResetView(bool azzera, bool redraw)
{
     float factor = Range;
     if(azzera)
     {
        view_quat_diff = MRVector4Identity;
        view_quat = MRVector4Identity;
        Rotm = MRMatrixIdentity;
        view_quat = MRMatrixToQuat(RotB);
        Rotm = MRMatrix4MakeFromQuat(view_quat);
        factor = 1.f;
     }
     Scale = 1;
     obj_pos = MRVectorZero;
     change_clip_value();
     ResetProjectionMatrix(factor);
     ResetModelMatrix(0);
     if(redraw)
     {
        Redraw();
        while(gtk_events_pending())
            (void) gtk_main_iteration();
     }
}

#ifdef USE_GRAB
void pointer_grab(GdkWindow *win, GdkEventMask EventMask)
{
  gdk_pointer_grab(win, TRUE, EventMask, win, NULL, GDK_CURRENT_TIME);
}
  
void pointer_ungrab()
{
  gdk_pointer_ungrab(GDK_CURRENT_TIME);
}
  
gboolean pointer_is_grabbed()
{
  return gdk_pointer_is_grabbed();
}

gboolean mouse_leave(GtkWidget *w, GdkEventCrossing *ev, gpointer )
{
     if(pointer_is_grabbed())
        pointer_ungrab();
     int x, y;
     GdkWindow *win = gdk_window_at_pointer(&x, &y);
     if(win != ev->window)
         return FALSE;
     pointer_grab(win, EventMask);
     return FALSE;
}
#endif
  
gboolean mouse_release (GtkWidget *, GdkEventButton *event, gpointer data)
{
  GLWindow *gl = (GLWindow *)data;
  int x, y, butt;
  x = (int) event->x;
  y = (int) event->y;
  butt = (int) event->button;
#ifdef USE_GRAB
  GdkWindow *win = gdk_window_at_pointer(&x, &y);
  if(win != event->window)
     return FALSE;
  if(pointer_is_grabbed())
     pointer_ungrab();
  pointer_grab(win, EventMask);
#endif
  return (gl->ManageMouseRelease(x, y, butt));
}

gboolean mouse_scroll (GtkWidget *, GdkEventScroll *event, gpointer data)
{
  GLWindow *gl = (GLWindow *)data;
  GdkScrollDirection dir = event->direction;
#ifdef USE_GRAB
  if(pointer_is_grabbed())
     pointer_ungrab();
  pointer_grab(event->window, EventMask);
#endif
  bool ifScrollUp;
  if(dir ==  GDK_SCROLL_UP)
     ifScrollUp = true;
  else if(dir ==  GDK_SCROLL_DOWN)
     ifScrollUp = false;
  else
     return FALSE;
  return(gl->ManageMouseScroll(ifScrollUp));
}

gboolean mouse_press (GtkWidget *, GdkEventButton *event, gpointer data)
{
  int x, y, butt, stato;
  GLWindow *gl = (GLWindow *)data;
#ifdef USE_GRAB
  if(pointer_is_grabbed())
     pointer_ungrab();
#endif
  x = (int) event->x;
  y = (int) event->y;
  butt = (int) event->button;
  stato = (int) event->state;
  bool ifCtrl  = ((stato & GDK_CONTROL_MASK) == GDK_CONTROL_MASK);
  bool ifShift = ((stato & GDK_SHIFT_MASK) == GDK_SHIFT_MASK);
  return (gl->ManageMousePress(x, y, butt, ifCtrl, ifShift));
}

gboolean mouse_move (GtkWidget *, GdkEventMotion *event, gpointer data)
{
  int x, y, butt, stato;
#ifdef USE_GRAB
  GdkWindow *win = gdk_window_at_pointer(&x, &y);
  if(win != event->window)
     return FALSE;
#endif
  GLWindow *gl = (GLWindow *)data;
  x = (int) event->x;
  y = (int) event->y;
  stato = (int) event->state;
  butt = -1;

  if((stato & GDK_BUTTON3_MASK) == GDK_BUTTON3_MASK )
     butt = 3;
  else if ((stato & GDK_BUTTON1_MASK) == GDK_BUTTON1_MASK )
     butt = 1;
  return (gl->ManageMouseMove(x, y, butt));
}

gboolean GLWindow::ManageMouseRelease(int x, int y, int butt)
{
  int yy = Height - y;

  if(butt == 3)
  {
     if(motion_type == TRASL)
        motion_type = NO_MOVE ;
     Redraw();
     return FALSE;
  }

  bool ifmov = moving;
  moving = false;

  if(motion_type < RECT_SELECT)
     in_selection = false;
  switch(motion_type)
  {
  case ON_SELECT:       // Select Objects
  case MOL_SELECT:       // Select Objects
//       if(!SelectAtoms(Widget, x, yy, (gpointer) this))
//          return FALSE;
       selectObject(x, yy, (gpointer) this);
       if(motion_type == MOL_SELECT)
          on_expand_sel(NULL, NULL);
       Redraw ();
       return FALSE;
       break;
#ifndef JAV
  case SELECT_DEST:     // Select atom to minimize distances
       if(selectObject(x, yy, (gpointer) this, true, true))
          do_move_atoms();
        set_motion_type(NO_MOVE, 0);
        PrintMess(" ");
        updateModify(1);
        break;
#endif
#ifdef HAVE_LEGEND
  case MOVE_LEGEND:     // Move Legend
        activeLegend = -1;
        set_motion_type(NO_MOVE, 0);
        Redraw ();
        return TRUE;
        break;
#endif
   case ZOOM_MODE:      // Zoom
        if(in_selection)
        {
            double wp = MRabs(Xstart -x);
            double hp = MRabs(Ystart -y);
            if((wp < 1e-6) && (hp < 1e-6))
            {
                float *pos2 = FromPixel(x, y);
                obj_pos.x += -pos2[0];
                obj_pos.y += -pos2[1];
                double mzoom = 2;
                obj_pos.x *= mzoom;
                obj_pos.y *= mzoom;
                Scale *= (float) mzoom;
                ResetModelMatrix(0);
            }
            else
            {
//                double mzoom = MRmax(wp/(double) Width, hp/(double) Height);
                double mzoom = MRmin((double) Width/wp, (double) Height/hp);
                float *pos2 = FromPixel(x, y);
                float *pos1 = FromPixel(Xstart, Ystart);
                BuildRect(SelectionRect, pos1, pos2);
                obj_pos.x += -((pos1[0] + pos2[0]) / 2.f);
                obj_pos.y += -((pos1[1] + pos2[1]) / 2.f);
//nuovo metodo
                obj_pos.x *= mzoom;
                obj_pos.y *= mzoom;
                Scale *= (float) mzoom;
                ResetModelMatrix(0);
//end
//                ResetProjectionMatrix((float)Range/mzoom);
            }
        }
        in_selection = false;
        Redraw ();
        return TRUE;
        break;
  case RECT_SELECT:    // Rectangular selection
        if(in_selection)
        {
           int xc = (int) ((Xstart+x)*0.5f);
           int yc = Height - (int) ((Ystart+y)*0.5f);
           double wp = MRabs(Xstart -x);
           double hp = MRabs(Ystart -y);
           if((wp < 1e-6) && (hp < 1e-6))
               selectObject(x, yy, (gpointer) this);
           else
           {
               selectObjects(xc, yc, (gpointer) this, wp, hp);
               float *pos2 = FromPixel(x, y);
               float *pos1 = FromPixel(Xstart, Ystart);
               BuildRect(SelectionRect, pos1, pos2);
           }
           in_selection = false;
//           motion_type = ON_SELECT;
        }
        else
           selectObject(x, yy, (gpointer) this);
        Redraw ();
        return TRUE;
        break;
   case GEOM+1:          // Sphere
   case GEOM+2:          // Select 2, 3 or 4 atoms
   case GEOM+3: 
   case GEOM+4: 
        if(!SelectAtoms(Widget, x, yy, (gpointer) this))
           return FALSE;
        if(nclicked == 0)
           set_motion_type(motion_type, 1);
        return FALSE;
        break;
#ifdef MAPS
   case SELECT_CENTRE: // Select atom
        SelectAtom(Widget, x, yy, (gpointer) this);
        break;
#endif
   default:
        nclicked = 0;
        break;
   }
   motion_type = NO_MOVE ;
   if(ifmov)
      Redraw ();
   return FALSE;
}

gboolean GLWindow::ManageMousePress(int x, int y, int butt,
                                 bool ifCtrl, bool ifShift)
{
    if(PreviewMode)
    {
       close_offscreen(GLWINDOW, NULL, NULL);
       return TRUE;
    }
    moving = false;
    in_selection = false;
    activeLegend = -1;
    if((butt != 1))
    {
#ifdef HAVE_LEGEND
       if(ManageClickLegend(x, y, 0))
          return TRUE;
#endif
       if(selectForPopup(x, Height-y, (gpointer)this))
       {
            ;
           return TRUE;
       }
       else if((motion_type == NO_MOVE) && (butt == 3))
           motion_type = TRASL;
       else
           return TRUE;
    }
    else
    {
       if(motion_type == RECT_SELECT)       // Select Object
       {
          Xstart = x;
          Ystart = y;
          in_selection = true;
          return TRUE;
       }
       if(motion_type == ZOOM_MODE)       // Zoom
       {
          Xstart = x;
          Ystart = y;
          in_selection = true;
          return TRUE;
       }
#ifdef HAVE_LEGEND
       if(ManageClickLegend(x, y, 1))
          return FALSE;
#endif
       if(motion_type == NO_MOVE)
       {
          if(ifCtrl)
             motion_type = TRASL ;
          else if(ifShift)
             motion_type = ZOOM ;
          else
             motion_type = ROT ;
       }
// per abilitare la rotazione durante i calcoli geometrici
       else if((motion_type < (GEOM+1)) || (motion_type >= (MOVE_LEGEND)) )
          return FALSE;
    }
    switch( motion_type )
    {
    case ROT :   // rotation
    case ZOOM :  // zoom
    case TRASL : // translation
    case ON_SELECT : // selection
    case MOL_SELECT : // selection
// per abilitare la rotazione durante i calcoli geometrici
    case GEOM+1 :             // sphere
    case GEOM+2:          // Select 2, 3 or 4 atoms
    case GEOM+3: 
    case GEOM+4: 
         Xstart = x;
         Ystart = y;
         view_quat_diff = MRVector4Identity;
         break ;
    default :
         break ;
    }
    return TRUE;
}

gboolean GLWindow::ManageMouseScroll(bool ifScrollUp)
{
  if(ifScrollUp)
     on_move(2, 40.f/Width);
  else
     on_move(2, -40.f/Width);
  return TRUE;
}

gboolean GLWindow::ManageMouseMove (int x, int y, int butt)
{
  float w = (float) Width;
  float h = (float) Height;
  gboolean redraw = FALSE;
  float val;

  if(butt < 0)            // gestione pointer move
  {
     int yy = Height - y;
// aggiunte le 4 seguenti per gestire i PC meno dotati
     if((MRabs(x-Xstart) < 10) && (MRabs(y-Ystart) < 10))
        return FALSE;
     Xstart = x;
     Ystart = y;
     if(nModels)
        IsAtom(x, yy);
     return FALSE;
//     if(nModels)
//        return selectObject(x, yy, this, false);
//     return FALSE;
  }

  if((butt == 3) && (motion_type == TRASL))
  {
     moving = true;
     val = ((float) obj_pos.x +  (float)(x-Xstart))/w;
     on_move(0, val);
     val = ((float) obj_pos.y -  (float)(y-Ystart))/h;
     on_move(1, val);
     Xstart = x;
     Ystart = y;
     Redraw ();
     return TRUE;
  }
  else if (butt != 1)
     return FALSE;

  switch( motion_type )
  {
#ifdef HAVE_LEGEND
  case MOVE_LEGEND:         // Move Legend
     if(activeLegend != -1)
     {
        Legend[activeLegend].SetPos(x, y);
        Redraw();
        while(gtk_events_pending())
         (void) gtk_main_iteration();
     }
     return TRUE;
     break;
#endif
//  case ON_SELECT:          // Selection
//     if((x == Xstart) && (y == Ystart))
//         return FALSE;
//     else
//         motion_type = RECT_SELECT;
//     break;
  case RECT_SELECT:       // Rectangular sel.
  case ZOOM_MODE:         // zoom
       if(in_selection)
       {
          float *pos2 = FromPixel(x, y);
          float *pos1 = FromPixel(Xstart, Ystart);
          BuildRect(SelectionRect, pos1, pos2);
          Redraw ();
//091213          while(gtk_events_pending())
//091213              (void) gtk_main_iteration();
          return TRUE;
       }
       break;
  case ON_SELECT:          // Selection
  case MOL_SELECT:          // Selection
  case ROT :             // rotation
// per abilitare la rotazione durante i calcoli geometrici
  case GEOM+1 :             // sphere
  case GEOM+2:          // Select 2, 3 or 4 atoms
  case GEOM+3: 
  case GEOM+4: 
       moving = true;
       if (butt == 1)
       {
          view_quat_diff = MRTrackBall (
                 (double) (2.0 * Xstart - w) / w,
                 (double) (h - 2.0 * Ystart) / h,
                 (double) (2.0 * x - w) / w,
                 (double) (h - 2.0 * y) / h,
                 0.8);
           view_quat = MRAddQuats(view_quat_diff, view_quat);
           Rotm = MRMatrix4MakeFromQuat (view_quat);
           redraw = TRUE;
       }
       break ;
  // zoom
  case ZOOM :
         moving = true;
         val =  (float)((y-Ystart)/w);
         on_move(2, val);
         redraw = TRUE;
    break ;
  }
  Xstart = x;
  Ystart = y;

  if (redraw )
     Redraw ();

  return TRUE;
}

#ifdef USE_CAIRO_TEXTURES
GdkPixbuf *PixbufFromCairoSurface(GtkWidget *, float color1[], float color2[], int type)
{
    cairo_pattern_t *pat;
    os_and_gc *rt;
    int w = 256;
    int h = 256;
    int raggio = MRmax(h, w);
    int x=w/2, y=h/2;
    rt = create_cairo_stuff(w, h, GLWINDOW);
    cairo_t *cr = (cairo_t *)rt->gc;
    cairo_set_line_width (cr, 1.0);
    double r0 = MRmax(1.0, (double)raggio/15.);

    switch(type)
    {
    default:
    case TYPE_HGRAD:
       pat = cairo_pattern_create_linear (0, 0, w, 0);  //hori 
       break;
    case TYPE_RGRAD:
       pat = cairo_pattern_create_radial (x, y, r0, x+r0, y-r0, (double) raggio);
       break;
    case TYPE_VGRAD:
       pat = cairo_pattern_create_linear (0, 0, 0, h);  //vert 
       break;
    case TYPE_DGRAD:
       pat = cairo_pattern_create_linear (0, 0, w, h);  //diag 
       break;
    }

    cairo_pattern_add_color_stop_rgba (pat, 0.1, color1[0], color1[1], color1[2], 1);
    cairo_pattern_add_color_stop_rgba (pat, 0.9, color2[0], color2[1], color2[2], 1);
    cairo_set_source (cr, pat);
    cairo_arc (cr, x, y, raggio, 0, 2 * M_PI);
    cairo_fill (cr);
    cairo_pattern_destroy (pat);

    GdkPixbuf *pixbuf = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, w, h);
    pixbuf = pixbuf_get_from_cairo_stuff (rt->os, w, h);
    cairo_destroy (cr);
    return pixbuf;
}


void GLWindow::CreateCairoTexture(Texture *pTexture)
{
    GdkPixbuf *pixbuf = PixbufFromCairoSurface(Widget, BgColor1, BgColor2, BgType);
    if(pixbuf == NULL)
       return;
    int  width = gdk_pixbuf_get_width (pixbuf);
    int  height = gdk_pixbuf_get_height (pixbuf);
    int  n_channels = gdk_pixbuf_get_n_channels (pixbuf);
    int  rowstride = gdk_pixbuf_get_rowstride (pixbuf);

    pTexture->ulDimensionX = width;
    pTexture->ulDimensionY = height;
    pTexture->n_channels = n_channels;
    if(n_channels == 4)
       pTexture->format = GL_RGBA;
    else
       pTexture->format = GL_RGB;
    pTexture->rowstride = rowstride;
    pTexture->pcData = gdk_pixbuf_get_pixels (pixbuf);
}
#endif

void GLWindow::SetLightsAndDraw()
{
    SetLights();
    Redraw();
}

void GLWindow::SetLights()
{
   glMatrixMode (GL_MODELVIEW);
   glPushMatrix();
   glLoadIdentity();

  if( lightInfo[JAV_AMBIENT].enabled)
     glLightfv(GL_LIGHT0, GL_AMBIENT, lightInfo[JAV_AMBIENT].diffuse);
  else
     glLightfv(GL_LIGHT0, GL_AMBIENT, no_mat);
  glMaterialfv (GL_FRONT, GL_SPECULAR, lightInfo[JAV_LIGHT0].specular);
  if( lightInfo[JAV_LIGHT0].enabled)
  {
     glEnable (GL_LIGHT0);
     glLightfv(GL_LIGHT0, GL_DIFFUSE, lightInfo[JAV_LIGHT0].diffuse);
     glLightfv(GL_LIGHT0, GL_POSITION, lightInfo[JAV_LIGHT0].position);
     glLightfv(GL_LIGHT0, GL_SPECULAR, lightInfo[JAV_LIGHT0].specular);
  }
  else
     glDisable (GL_LIGHT0);
  if(lightInfo[JAV_LIGHT1].enabled)
  {
     glEnable (GL_LIGHT1);
     glLightfv(GL_LIGHT1, GL_DIFFUSE, lightInfo[JAV_LIGHT1].diffuse);
     glLightfv(GL_LIGHT1, GL_POSITION, lightInfo[JAV_LIGHT1].position);
     glLightfv(GL_LIGHT1, GL_SPECULAR, lightInfo[JAV_LIGHT1].specular);
  }
  else
     glDisable (GL_LIGHT1);
   glPopMatrix();
}

void LoadTextureFile(const char *szFilename, Texture *pTexture)
{
    GdkPixbuf *pixbuf = create_pixbuf  (szFilename);
    if(pixbuf == NULL)
       return;
    int  width = gdk_pixbuf_get_width (pixbuf);
    int  height = gdk_pixbuf_get_height (pixbuf);
    int  n_channels = gdk_pixbuf_get_n_channels (pixbuf);
    int  rowstride = gdk_pixbuf_get_rowstride (pixbuf);

    pTexture->ulDimensionX = width;
    pTexture->ulDimensionY = height;
    pTexture->n_channels = n_channels;
    if(n_channels == 4)
       pTexture->format = GL_RGBA;
    else
       pTexture->format = GL_RGB;
    pTexture->rowstride = rowstride;
    pTexture->pcData = gdk_pixbuf_get_pixels (pixbuf);
}

void LoadMarbleTexture()
{
  const char *textfile = "marble.png";
  // Load Texture
  Texture *TextureImage = g_new0(Texture, 1);
  LoadTextureFile(textfile, TextureImage);
  glGenTextures(1, &(iTexture[6]));
  glBindTexture(GL_TEXTURE_2D, iTexture[6]);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glTexImage2D(GL_TEXTURE_2D, 0, TextureImage->n_channels, TextureImage->ulDimensionX, TextureImage->ulDimensionY, 0, TextureImage->format, GL_UNSIGNED_BYTE, TextureImage->pcData);
  if (TextureImage)                      // If Texture Exists
  {
     if (TextureImage->pcData)            // If Texture Image Exists
         g_free(TextureImage->pcData);        // Free The Texture Image Memory
     g_free(TextureImage);                  // Free The Image Structure
  }
}

void LoadCairoTexture(GLWindow *gl)
{
#ifndef USE_CAIRO_TEXTURES
  return;
#else
  if(gl->BgType <= TYPE_FLAT)
     return;
  // Load Texture
  Texture *TextureImage = g_new0(Texture, 1);
  gl->CreateCairoTexture(TextureImage);
  glGenTextures(1, &(iTexture[7]));
  glBindTexture(GL_TEXTURE_2D, iTexture[7]);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
  glTexImage2D(GL_TEXTURE_2D, 0, TextureImage->n_channels, TextureImage->ulDimensionX, TextureImage->ulDimensionY, 0, TextureImage->format, GL_UNSIGNED_BYTE, TextureImage->pcData);
  if (TextureImage)                      // If Texture Exists
  {
     if (TextureImage->pcData)            // If Texture Image Exists
         g_free(TextureImage->pcData);        // Free The Texture Image Memory
     g_free(TextureImage);                  // Free The Image Structure
  }
#endif
}


#if !defined (GDK_WINDOWING_QUARTZ) && defined(HAVE_GL_GLX_H)
XFontStruct *LoadXFont(const char *name, int size)
{
    XFontStruct *fnt = NULL;
    if(size == 0)
    {
       fnt = XLoadQueryFont(gdk_x11_display_get_xdisplay(gdk_display_get_default()), "fixed");
       return fnt;
    }
    const char *fmt = "-*-%s-medium-r-normal--%d-*";
    char *fontname = g_strdup_printf(fmt, name, size);
    fnt = XLoadQueryFont(gdk_x11_display_get_xdisplay(gdk_display_get_default()), fontname);
    g_free(fontname);
    if(fnt)
       return fnt;
//    fontname = g_strdup_printf("-*-*-*-r-normal--%d-*", size);
    fontname = g_strdup_printf(fmt, name, size);
    fnt = XLoadQueryFont(gdk_x11_display_get_xdisplay(gdk_display_get_default()), fontname);
    g_free(fontname);
    if(fnt)
       return fnt;
    int i = 1;
    while((fnt == NULL) && (i<=4))
    {
        int newsize = size + i;
        if(i > 0)
           i = -i;
        else
           i = 1 - i;
//        fontname = g_strdup_printf("-*-*-*-r-normal--%d-*", newsize);
        fontname = g_strdup_printf(fmt, name, newsize);
        fnt = XLoadQueryFont(gdk_x11_display_get_xdisplay(gdk_display_get_default()), fontname);
        g_free(fontname);
        if(fnt)
           return fnt;
    }
    fnt = XLoadQueryFont(gdk_x11_display_get_xdisplay(gdk_display_get_default()), "fixed");
    return fnt;
}
#endif

static GLuint fbo, render_buf, depthrender_buf;

gboolean close_offscreen (GtkWidget *w, GdkEvent *, gpointer )
{
using namespace GLextmr;
using namespace main_app;
  if(!PreviewMode)
     return FALSE;
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(w), "glwindow");
  if(gl)
     gl->Destroy(0);
#ifndef JAV
  PreviewMode = false;
  BufferName.assign(" ");
  defaultPlotStyle = -1;
  defaultColor = -1;
  defaultTitle = "";
  defaultBG = -1;
  defCentro = false;
  JavApp.Kscrx = SaveSize[0];
  JavApp.Kscry = SaveSize[1];
#endif
  return TRUE;
}

void SetBuffer()
{
      have_fb = Okfb();
//      g_print("have_fb:%s\n", have_fb?"yes":"no");
      if(!have_fb)
         return;
//         FBError();
#ifdef GL_DEPTH_ATTACHMENT
      glGenFramebuffers(1,&fbo);
      glBindFramebuffer(GL_FRAMEBUFFER,fbo);

      glGenRenderbuffers(1,&render_buf);
      glBindRenderbuffer(GL_RENDERBUFFER,render_buf);
      glRenderbufferStorage(GL_RENDERBUFFER, GL_RGBA, OSWidth, OSHeight);
      glFramebufferRenderbuffer(GL_FRAMEBUFFER, GL_COLOR_ATTACHMENT0, GL_RENDERBUFFER, render_buf);

      glGenRenderbuffers(1,&depthrender_buf);
      glBindRenderbuffer(GL_RENDERBUFFER,depthrender_buf);
      glRenderbufferStorage(GL_RENDERBUFFER, GL_DEPTH_COMPONENT, OSWidth, OSHeight);
      glFramebufferRenderbuffer(GL_FRAMEBUFFER, GL_DEPTH_ATTACHMENT, GL_RENDERBUFFER, depthrender_buf);
//      glBindRenderbuffer(GL_RENDERBUFFER,0);

      GLenum status = glCheckFramebufferStatus(GL_FRAMEBUFFER);
      if (status != GL_FRAMEBUFFER_COMPLETE_EXT)
          have_fb = false;
//           FBError();
#endif
}

void disegnaSuPreview(GtkWidget *w, GdkPixbuf *dest)
{
#ifdef HAVE_GTKGLEXT
     GtkWidget *box = gtk_widget_get_parent(w);
     gtk_container_remove(GTK_CONTAINER(box), w);
     GtkWidget *image = gtk_image_new_from_pixbuf(dest);
     gtk_container_add(GTK_CONTAINER(box), image);
     gtk_widget_show(image);
#else
     gtk_image_set_from_pixbuf(GTK_IMAGE(w), dest);
#ifdef MACOSX
     gtk_window_reshow_with_initial_size(GTK_WINDOW(GLWINDOW));
#endif
     gtk_widget_show(w);
#endif
}

guchar *readScreen(int x, int y, int width, int height)
{
//   Read in the screen information in the area specified
    glFinish();
    glPixelStorei(GL_PACK_ALIGNMENT, 4);
    glPixelStorei(GL_PACK_ROW_LENGTH, 0);
    glPixelStorei(GL_PACK_SKIP_ROWS, 0);
    glPixelStorei(GL_PACK_SKIP_PIXELS, 0);

    guchar *data = g_new0(guchar, width*height*4); 

    glReadPixels(x, y, width, height, GL_RGB, GL_UNSIGNED_BYTE, data);
    return data;
}

void SaveBuffer(GtkWidget *w, bool ifT)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   if(have_fb)
   {
#ifdef GL_DEPTH_ATTACHMENT
   GLenum status = glCheckFramebufferStatus(GL_FRAMEBUFFER);
   if (status != GL_FRAMEBUFFER_COMPLETE_EXT)
      return;
#ifdef GDK_WINDOWING_WIN32
   if(wglGetCurrentContext() == 0)
      return;
#endif
   glReadBuffer(GL_COLOR_ATTACHMENT0);
   glReadBuffer(GL_DEPTH_ATTACHMENT);
#endif
   }
   guchar *OSbuffer = readScreen(0, 0, OSWidth, OSHeight);
#ifdef GL_DEPTH_ATTACHMENT
   if(have_fb)
   {
        glBindFramebuffer(GL_FRAMEBUFFER, 0);
        glDeleteFramebuffers(1,&fbo);
        glDeleteRenderbuffers(1,&render_buf);
        glDeleteRenderbuffers(1,&depthrender_buf);
   }
#endif
   if(OSbuffer != NULL)
   {
      GdkPixbuf *dest = pixbuf_get_from_window (w);
      if(dest)
      {
         int bps = gdk_pixbuf_get_bits_per_sample (dest);
         int rs = gdk_pixbuf_get_rowstride(dest);
         GdkPixbuf *pixb = gdk_pixbuf_new_from_data (OSbuffer,
               GDK_COLORSPACE_RGB, 0,
               bps, OSWidth, OSHeight, rs, NULL, NULL);
         g_object_unref(G_OBJECT(dest));
         dest = NULL;
         if(pixb != NULL)
         {
            GdkPixbuf *pixc = gdk_pixbuf_flip(pixb, FALSE);
            g_object_unref(G_OBJECT(pixb));
//            dest = gdk_pixbuf_copy(pixc);
            if(ifT)
            {
               guchar c[3];
               for(int i=0; i<3; i++)
                   c[i] = (guchar) (gl->BgColor[i] * 255.f);// + 0.5f);
               dest = gdk_pixbuf_add_alpha(pixc, TRUE, c[0], c[1], c[2]);
            }
            else
               dest = gdk_pixbuf_copy(pixc);
            g_object_unref(G_OBJECT(pixc));
         }
//#ifdef GDK_WINDOWING_WIN32
         if(PreviewMode)
            gl->ReleaseWinStuff();
//#endif
         if(dest != NULL)
         {
            GError *error = NULL;
#ifdef JAV
            if(PreviewMode)
            {
            GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW),
                   "glwindow");
            disegnaSuPreview(gl->Widget, dest);
            gdk_window_raise(gtk_widget_get_window(GLWINDOW));
            }
#endif
            if(!str_white(BufferName.c_str()))
               gdk_pixbuf_save (dest, toUTF8(BufferName.c_str()), "png", &error, NULL);
         }
      }
      g_free(OSbuffer);
#ifndef JAV
#ifndef GDK_WINDOWING_WIN32
      static bool primavolta = true;
      if(!have_fb && primavolta)
      {
         primavolta = false;      
         return;
      }
#endif
      if(PreviewMode)
         close_offscreen(GLWINDOW, NULL, NULL);
#endif
   }
}

#ifdef GDK_WINDOWING_WIN32
void on_Screenshot(gpointer, gpointer data)
{
using namespace gtkext;
using namespace std;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   string extensions;
   vector<string> types, exts;
   int ifAxesSav = gl->ifAxes;
   int bgsav = gl->BgType;
   float colorsav[4];
   memcpy(colorsav, gl->BgColor, 4*sizeof(float));
   GtkAllocation allocation;
   gtk_widget_get_allocation(gl->Widget, &allocation);

   int ke = fill_formats(types, exts, extensions);
   if(ke == -1)
      return;

   GdkPixbuf *dest;
   GError *error = NULL;

   string curdir = getPWD();
   string fn;
   bool ifT = false;
   bool showT = true; //(gl->BgType <= TYPE_FLAT);
   fn =  dlg_select_file(window, fn, eSELECT_TO_WRITE, extensions.c_str(), showT, &ifT);
   if(str_white(fn.c_str()))
   {
       dir_set_current(curdir.c_str());
       gl->ifAxes = ifAxesSav;
       gl->Redraw();
       return;
   }
   ke = find_extension_in_list(fn, exts);
   if(ke == -1)
      return;
     
   gl->ifAxes = 0;
   if(ifT)
   {
      gl->BgType = TYPE_BLACK;
      gl->BgColor[0] = gl->BgColor[1] = gl->BgColor[2] = 0.f;
      gl->BgColor[3] = 1.f;
      gl->SetBgColor();
   }
   gl->Redraw();
   while(gtk_events_pending())
         (void) gtk_main_iteration();

   dest = pixbuf_get_from_window (gl->Widget);
#ifndef CANNOT_FLIP
     if(dest != NULL)
     {
         int bps = gdk_pixbuf_get_bits_per_sample (dest);
         int rs = gdk_pixbuf_get_rowstride(dest);

         g_object_unref(G_OBJECT(dest));
         dest = NULL;
         guchar *screendata = readScreen(0, 0,
              allocation.width, 
              allocation.height);
         if(screendata != NULL)
         {
            GdkPixbuf *pixb = gdk_pixbuf_new_from_data (screendata, 
               GDK_COLORSPACE_RGB, 0,
               bps, allocation.width, 
               allocation.height, rs, NULL, NULL);
            if(pixb != NULL)
            {
               GdkPixbuf *pixc = gdk_pixbuf_flip(pixb, FALSE);
               g_free(screendata);
               g_object_unref(G_OBJECT(pixb));
               if(ifT)
               {
                  guchar c[3];
                  for(int i=0; i<3; i++)
                      c[i] = (guchar) (gl->BgColor[i] * 255.f);// + 0.5f);
                  dest = gdk_pixbuf_add_alpha(pixc, TRUE, c[0], c[1], c[2]);
               }
               else
                  dest = gdk_pixbuf_copy(pixc);
               g_object_unref(G_OBJECT(pixc));
            }
            else
               g_print ("Error in pixbuf_new_from_data\n");
         }
         else
            g_print ("Error in readScreen\n");
     }
#endif
     if(dest != NULL)
     {
         gdk_pixbuf_save (dest, toUTF8(fn.c_str()), types[ke].c_str(), &error, NULL);
#ifndef NDEBUG
         if(error)
            g_print ("Error in crea_png: %s\n", error->message);
#endif
     }
#ifndef NDEBUG
     else
         g_print ("Error in crea_png: drawable = NULL\n");
#endif
     dir_set_current(curdir.c_str());
     gl->ifAxes = ifAxesSav;
     if(ifT)
     {
        gl->BgType = bgsav;
        memcpy(gl->BgColor, colorsav, 4*sizeof(float));
        gl->SetBgColor();
     }
     gl->Redraw();
}
#else
void on_Screenshot(gpointer, gpointer data)
{
using namespace gtkext;
using namespace std;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   string extensions;
   vector<string> types, exts;
   int ifAxesSav = gl->ifAxes;
   int bgsav = gl->BgType;
   float colorsav[4];
   memcpy(colorsav, gl->BgColor, 4*sizeof(float));
   GtkAllocation allocation;
   gtk_widget_get_allocation(gl->Widget, &allocation);

   int ke = fill_formats(types, exts, extensions);
   if(ke == -1)
      return;

   string curdir = getPWD();
   string fn;
   bool ifT = false;
   bool showT = true; //(gl->BgType <= TYPE_FLAT);
   fn =  dlg_select_file(window, fn, eSELECT_TO_WRITE, extensions.c_str(), showT, &ifT);
   if(str_white(fn.c_str()))
   {
       dir_set_current(curdir.c_str());
       gl->ifAxes = ifAxesSav;
       gl->Redraw();
       return;
   }
   ke = find_extension_in_list(fn, exts);
   if(ke == -1)
      return;
     
   gl->ifAxes = 0;
   if(ifT)
   {
      gl->BgType = TYPE_BLACK;
      gl->BgColor[0] = gl->BgColor[1] = gl->BgColor[2] = 0.f;
      gl->BgColor[3] = 1.f;
      gl->SetBgColor();
   }
   OSWidth = gl->Width;
   OSHeight = gl->Height;
   SetBuffer();
   gl->Redraw();
   while(gtk_events_pending())
         (void) gtk_main_iteration();
   BufferName = fn;
   SaveBuffer(gl->Widget, ifT);

   dir_set_current(curdir.c_str());
   gl->ifAxes = ifAxesSav;
   if(ifT)
   {
      gl->BgType = bgsav;
      memcpy(gl->BgColor, colorsav, 4*sizeof(float));
      gl->SetBgColor();
   }
   gl->Redraw();
}
#endif

void SetupRC(GLWindow *gl)
{
   int c = gl->BgType;
   gl->BgColor[3] = 1.f;
   if(PreviewMode)
   {
      ChangeSize(OSWidth, OSHeight, gl);
      if(!gl->MakeCurrent())
         return;
      SetBuffer();  // set buffers
   }
   if(c <= TYPE_FLAT)              // White Bg
      glClearColor(gl->BgColor[0], gl->BgColor[1], gl->BgColor[2], gl->BgColor[3]);
   else
      glClearColor(gl->BgColor1[0], gl->BgColor1[1], gl->BgColor1[2], gl->BgColor1[3]);
  glClearDepth (1.0);
  glMaterialf (GL_FRONT, GL_SHININESS, 100.f); 
  glMaterialfv(GL_FRONT, GL_EMISSION, no_mat);

  glFrontFace (GL_CW);
  glEnable (GL_LIGHTING);
  gl->SetLights();

  glEnable (GL_AUTO_NORMAL);
  glEnable (GL_NORMALIZE);
  glEnable (GL_DEPTH_TEST);
  glDepthFunc (GL_LESS);

  for(int i=1; i<=20; i++)
  {
    glNewList (i, GL_COMPILE);
    Sfera (TRUE, 0.03/i, i*i+3);
    glEndList ();
  }

#ifndef GDK_WINDOWING_QUARTZ
  font_list_base = glGenLists (128*3);
#ifdef HAVE_GL_GLX_H
  XFontStruct *f = LoadXFont( "fixed", 0);
  Font id = f->fid;
  glXUseXFont(id, 0, 128, font_list_base);
  XFontStruct *f1 = LoadXFont( "fixed", 15);
  Font id1 = f1->fid;
  glXUseXFont(id1, 0, 128, font_list_base+128);
  XFontStruct *f2 = LoadXFont( "fixed", 20);
  Font id2 = f2->fid;
  glXUseXFont(id2, 0, 128, font_list_base+256);
#elif defined (GDK_WINDOWING_WIN32)
  HDC hdc = getCurrentDC(gl->Widget);
  wglUseFontBitmaps(hdc, 0, 255, font_list_base);
#endif
  glListBase (font_list_base);
#endif

   LoadMarbleTexture();
   if(gl->BgType > TYPE_FLAT)
      LoadCairoTexture(gl);
// Splash Image
#ifdef JAV
  LoadGLTextures();
//  gl->on_rotate(0, 3);
//  gl->on_rotate(1, -3);
//  gl->on_rotate(2, 18);
#endif
//  Splash text & Legend - Get PangoFT2 context. 
  open_pango();
  gl->SetBgColor(false);
}

void ChangeSize(GLsizei w, GLsizei h, GLWindow *gl)
{
//#ifdef GDK_WINDOWING_QUARTZ
    if(!gl->MakeCurrent())
       return;
//#endif
    if(h == 0)
    {
        h = 1;
        gl->aspectRatio = 1.;
    }
    else
        gl->aspectRatio = (GLfloat)w / (GLfloat)h;
    if(gl->aspectRatio <= 1)
       npixels = h;
    else
       npixels = w;

    // Set Viewport to window dimensions
    glViewport(0, 0, w, h);

    // Reset coordinate system
    gl->ResetProjectionMatrix(1.f);
    gl->ResetModelMatrix(0);
}

// Resize callback

static gboolean configure_event (GtkWidget         *widget,
                 GdkEventConfigure *event,
                 gpointer           data)
{
  GLWindow *gl = (GLWindow *)data;
  GtkAllocation allocation;
  gtk_widget_get_allocation(widget, &allocation);
  int width  = allocation.width;
  int height = allocation.height;

  if(!gl->MakeCurrent())
    return FALSE;

  if((gl->Width == width) && (gl->Height == height))
    return FALSE;

  gl->Width  = width;
  gl->Height = height;
  gl->border = MRmin(100, (int) ((float)width * 0.2f));
  ChangeSize (width, height, gl);
  gl->EndCurrent();
  aggiorna_dimensioni(GLWINDOW);
  while(gtk_events_pending())
         (void) gtk_main_iteration();
  return TRUE;
}

#ifdef HAVE_GTKGLEXT
bool GLWindow::RenderingInfo(std::string &rendering_info)
{
   if(!MakeCurrent())
      return false;
    rendering_info = g_strdup_printf(
          "OpenGL renderer vendor:   %s\n"
          "OpenGL renderer string:   %s\n"
          "OpenGL renderer version:  %s\n",
          glGetString(GL_VENDOR), glGetString(GL_RENDERER),
          glGetString(GL_VERSION));
    return true;
}

int GLWindow::GetCap(std::vector<int> &ns)
{
    return 0;
}

void GLWindow::SetCap(GtkWidget *drawing_area)
{
  GdkGLConfig *glconfig = gdk_gl_config_new_by_mode ((GdkGLConfigMode) (GDK_GL_MODE_RGB | GDK_GL_MODE_DEPTH | GDK_GL_MODE_DOUBLE | GDK_GL_MODE_ACCUM));
  if (glconfig == NULL)
  {
      glconfig = gdk_gl_config_new_by_mode ((GdkGLConfigMode) (GDK_GL_MODE_RGB | GDK_GL_MODE_DEPTH | GDK_GL_MODE_DOUBLE));
      if (glconfig == NULL)
      {
          g_print ("*** Cannot find the double-buffered visual.\n");
          exit(1);
      }
  }
  gboolean is_rgba = gdk_gl_config_is_rgba (glconfig);
  if(gtk_widget_get_has_window(drawing_area))
     gtk_widget_set_gl_capability (drawing_area,
                                glconfig,
                                NULL,
                                TRUE,
                                is_rgba ? GDK_GL_RGBA_TYPE : GDK_GL_COLOR_INDEX_TYPE);
}

bool GLWindow::MakeCurrent()
{
    if(!gtk_widget_get_realized(Widget))
       return false;
    GdkGLContext *glcontext = gtk_widget_get_gl_context (Widget);
    if(glcontext == NULL)
       return false;
    GdkGLDrawable *gldrawable = gtk_widget_get_gl_drawable (Widget);
    if(gldrawable == NULL)
       return false;
    return (gdk_gl_drawable_gl_begin (gldrawable, glcontext) == TRUE);
}
void GLWindow::EndCurrent()
{
    GdkGLDrawable *gldrawable = gtk_widget_get_gl_drawable (Widget);
    gdk_gl_drawable_gl_end (gldrawable);
}
void GLWindow::mySwapBuffers()
{
    GdkGLDrawable *gldrawable = gtk_widget_get_gl_drawable (Widget);
    if (gdk_gl_drawable_is_double_buffered (gldrawable))
      gdk_gl_drawable_swap_buffers (gldrawable);
    else
      glFlush ();
}
#elif defined(GDK_WINDOWING_X11)

void GLWindow::ReleaseWinStuff()
{
#if 0
    Display *display = gdk_x11_display_get_xdisplay (gdk_display_get_default());

    GLXContext context = static_cast<GLXContext> (get_object(Widget, "glcontext"));
    glXMakeCurrent(display, None, NULL);
    glXDestroyContext(display, context);
#endif
}

bool GLWindow::MakeCurrent()
{
    GdkWindow *window = gtk_widget_get_window (Widget);
    if(window == NULL)
       return false;
    Display *display = gdk_x11_display_get_xdisplay (gdk_display_get_default());
    GLXContext context = static_cast<GLXContext> (get_object(Widget, "glcontext"));
    int id = GDK_WINDOW_XID (window);
    return (glXMakeCurrent (display, id, context) == TRUE);
}

bool GLWindow::RenderingInfo(std::string &rendering_info)
{
using namespace main_app;
   if(!MakeCurrent())
      return false;
    Display *display = gdk_x11_display_get_xdisplay (gdk_display_get_default());
    rendering_info = g_strdup_printf(
          "OpenGL renderer vendor:   %s\n"
          "OpenGL renderer string:   %s\n"
          "OpenGL renderer version:  %s\n",
          glGetString(GL_VENDOR), glGetString(GL_RENDERER), 
          glGetString(GL_VERSION));
    rendering_info.append("\nDirect rendering: ");
    GLXContext context = static_cast<GLXContext> (get_object(Widget, "glcontext"));
    if (glXIsDirect(display, context)) 
         rendering_info.append("Yes\n");
    else
         rendering_info.append("No\n");
    if(JavApp.IsMSEnabled() && JavApp.IsMSSupported())
       rendering_info.append(
         g_strdup_printf("Multisampling supported: resolution %dx\n",
           JavApp.MSBuffers()));
    return true;
}

void GLWindow::EndCurrent()
{
}

void GLWindow::mySwapBuffers()
{
    GdkWindow *window = gtk_widget_get_window (Widget);
    Display *display = gdk_x11_display_get_xdisplay (gdk_display_get_default());
    int id = GDK_WINDOW_XID (window);
    glXSwapBuffers (display, id);
}


int GLWindow::GetCap(std::vector<int> &ns)
{
#ifdef HAVE_GL_GLX_H
   Display *display = gdk_x11_display_get_xdisplay (gdk_display_get_default());
   int xscreen = DefaultScreen (display);

   static const int Visual_attribs[] =
   {
      GLX_X_RENDERABLE    , True,
      GLX_DRAWABLE_TYPE   , GLX_WINDOW_BIT,
      GLX_RENDER_TYPE     , GLX_RGBA_BIT,
      GLX_X_VISUAL_TYPE   , GLX_TRUE_COLOR,
      GLX_RED_SIZE        , 1,
      GLX_GREEN_SIZE      , 1,
      GLX_BLUE_SIZE       , 1,
//      GLX_ALPHA_SIZE      , 1,
      GLX_DEPTH_SIZE      , 12,
      GLX_STENCIL_SIZE    , 8,
      GLX_DOUBLEBUFFER    , True,
      None
    };

  int attribs [ 100 ] ;
  memcpy( attribs, Visual_attribs, sizeof( Visual_attribs ) );

  int         fbcount, alpha, bs, acs;
  GLXFBConfig *fbc = glXChooseFBConfig( display, xscreen, attribs, &fbcount );
  int best_fbc = -1, best_num_samp = -1;

  for (int i=0; i<fbcount; ++i)
  {
    XVisualInfo *vi = glXGetVisualFromFBConfig( display, fbc[i] );
    if ( vi )
    {
      int samp_buf, samples;
      glXGetFBConfigAttrib( display, fbc[i], GLX_SAMPLE_BUFFERS, &samp_buf );
      glXGetFBConfigAttrib( display, fbc[i], GLX_SAMPLES       , &samples  );
      glXGetFBConfigAttrib( display, fbc[i], GLX_ALPHA_SIZE    , &alpha  );
      glXGetFBConfigAttrib( display, fbc[i], GLX_BUFFER_SIZE   , &bs  );
      glXGetFBConfigAttrib( display, fbc[i], GLX_STENCIL_SIZE   , &acs  );

      if(!samp_buf)
         continue;
      if ( (best_fbc < 0) || (samples > best_num_samp) )
      {
           best_fbc = i;
           best_num_samp = samples;
      }
      ns.push_back(samples);
    }
    XFree( vi );
  }

  if(best_fbc >= 0)
  {
     sort(ns.begin(), ns.end());
     std::vector<int>::iterator it = unique(ns.begin(), ns.end());
     ns.resize( std::distance(ns.begin(),it) );
     XFree( fbc );
     return 1;
  }
#endif
  return 0;
}

void GLWindow::SetCap(GtkWidget *)
{
using namespace main_app;
   XVisualInfo *xvisual;
   Display *display = gdk_x11_display_get_xdisplay (gdk_display_get_default());
   int xscreen = DefaultScreen (display);

#ifdef HAVE_GL_GLX_H
   if(JavApp.IsMSSupported() && JavApp.IsMSEnabled())
   {
      static const int Visual_attribs[] =
      {
         GLX_X_RENDERABLE    , True,
         GLX_DRAWABLE_TYPE   , GLX_WINDOW_BIT,
         GLX_RENDER_TYPE     , GLX_RGBA_BIT,
         GLX_X_VISUAL_TYPE   , GLX_TRUE_COLOR,
         GLX_RED_SIZE        , 1,
         GLX_GREEN_SIZE      , 1,
         GLX_BLUE_SIZE       , 1,
//      GLX_ALPHA_SIZE      , 1,
         GLX_DEPTH_SIZE      , 12,
         GLX_STENCIL_SIZE    , 8,
         GLX_DOUBLEBUFFER    , True,
         GLX_SAMPLE_BUFFERS  , 1, 
         GLX_SAMPLES         , JavApp.MSBuffers(),
         None
       };

       int attribs [ 100 ] ;
       memcpy( attribs, Visual_attribs, sizeof( Visual_attribs ) );

       int         fbcount;
       GLXFBConfig bestFbc = NULL;
       GLXFBConfig *fbc = glXChooseFBConfig( display, xscreen, attribs, &fbcount );
       if ( fbc )
       {
         if ( fbcount >= 1 )
           bestFbc = fbc[0];
         XFree( fbc );
       }

       if(bestFbc)
       {
          xvisual = glXGetVisualFromFBConfig( display, bestFbc );
          JavApp.Set_AA(param_SUPPORT, 1); 
       }
   }
//   if(!JavApp.IsMSSupported())
   else
#endif
   {
       int attributes[] = { GLX_RGBA, GLX_RED_SIZE, 1, GLX_GREEN_SIZE, 1,
       GLX_BLUE_SIZE, 1, GLX_DOUBLEBUFFER, True, GLX_DEPTH_SIZE, 12, None };
       xvisual = glXChooseVisual (display, xscreen, attributes);
//       JavApp.Set_AA(param_SUPPORT, 0); 
    }

    if (!xvisual)
    {
        g_print("Error: unable to get valid OpenGL Visual\n");
        exit(1);
    }
    GLXContext context = glXCreateContext (display, xvisual, NULL, TRUE);
    if (!context)
    {
        g_print("Error: unable to get valid OpenGL context\n");
        exit(1);
    }
    g_object_set_data(G_OBJECT(Widget), "glcontext", context);
    free (xvisual);
}

#if 0
void GLWindow::SetCap(GtkWidget *)
{
    int attributes[] = { GLX_RGBA, GLX_RED_SIZE, 1, GLX_GREEN_SIZE, 1,
    GLX_BLUE_SIZE, 1, GLX_DOUBLEBUFFER, True, GLX_DEPTH_SIZE, 12, None };

    Display *display = gdk_x11_display_get_xdisplay (gdk_display_get_default());
    int xscreen = DefaultScreen (display);
    XVisualInfo *xvisual = glXChooseVisual (display, xscreen, attributes);
    if (!xvisual)
        g_print("Error: unable to get valid OpenGL Visual\n");
    GLXContext context = glXCreateContext (display, xvisual, NULL, TRUE);
    g_object_set_data(G_OBJECT(Widget), "glcontext", context);
    free (xvisual);
}
#endif
#elif defined(GDK_WINDOWING_WIN32) 

bool GLWindow::MakeCurrent()
{
    HDC   hDC    = getCurrentDC(Widget);
    HGLRC hglRC  = wglGetCurrentContext();
    return (wglMakeCurrent (hDC, hglRC) != 0);
}

void GLWindow::EndCurrent()
{
}

void GLWindow::mySwapBuffers()
{
    HDC   hDC    = getCurrentDC(Widget);
    SwapBuffers (hDC);
    glFinish();       // per i PC rognosi
}

void on_realize(GtkWidget *widget, gpointer )
{
using namespace main_app;
    gdk_window_ensure_native(gtk_widget_get_window(widget));
    gtk_widget_set_double_buffered(widget, FALSE);

    HWND  hWnd = static_cast<HWND> GDK_WINDOW_HWND(gtk_widget_get_window(widget));
    HDC   hDC  = GetDC(hWnd);
    HGLRC hglRC;
    myPixelFormatSetupFunction(hDC, JavApp.MSFormat());
    if ((hglRC = wglCreateContext(hDC)) != NULL )
         wglMakeCurrent(hDC, hglRC) ;
    GLenum err = glewInit();
    g_object_set_data(G_OBJECT(widget), "hwnd", (gpointer) hWnd);
    ReleaseDC(hWnd, hDC);
}

int GLWindow::GetCap(std::vector<int> &ns)
{
    return 0;
}

void GLWindow::SetCap(GtkWidget *drawing_area)
{
    if(!win_native)
       g_signal_connect(drawing_area, "realize", G_CALLBACK(on_realize), NULL);
}

#elif defined(GDK_WINDOWING_QUARTZ)
void GLWindow::ReleaseWinStuff()
{
}

bool GLWindow::MakeCurrent()
{
   GtkAllocation alloc;
   GdkWindow       *win  = gtk_widget_get_window(Widget);
   if(win == NULL)
      return false;
   gdk_window_ensure_native(win);
   gtk_widget_get_allocation(Widget, &alloc);

   NSOpenGLContext *ctx  = static_cast<NSOpenGLContext *> (get_object(Widget, "glcontext"));
   NSView          *view = gdk_quartz_window_get_nsview(win);
   NSRect           rect = NSMakeRect(alloc.x, alloc.y, alloc.width, alloc.height);

   [ctx  makeCurrentContext];
   if(gtk_widget_is_drawable(Widget))
   {
      [ctx  setView:view];
      [ctx  update];
      [view setFrame:rect];
   }
   return true;

}

bool GLWindow::RenderingInfo(std::string &rendering_info)
{
using namespace main_app;

   if(!MakeCurrent())
      return false;
    rendering_info = g_strdup_printf(
          "OpenGL renderer vendor:   %s\n"
          "OpenGL renderer string:   %s\n"
          "OpenGL renderer version:  %s\n",
          glGetString(GL_VENDOR), glGetString(GL_RENDERER), 
          glGetString(GL_VERSION));
    if(JavApp.IsMSSupported() && JavApp.IsMSEnabled())
       rendering_info.append(g_strdup_printf(
          "Multisampling enabled: resolution %dx\n", JavApp.MSBuffers()));
    return true;
}

void GLWindow::EndCurrent()
{
}

void GLWindow::mySwapBuffers()
{
   NSOpenGLContext *ctx  = static_cast<NSOpenGLContext *> (get_object(Widget, "glcontext"));
   [ctx flushBuffer];
}

int GLWindow::GetCap(std::vector<int> &ns)
{
using namespace main_app;
    // Create context 
    NSOpenGLPixelFormatAttribute attribs[] = {
                NSOpenGLPFAColorSize, 24,
                NSOpenGLPFAAlphaSize, 8,
                NSOpenGLPFADepthSize, 1,
                NSOpenGLPFADoubleBuffer,
                NSOpenGLPFAMultisample,
                NSOpenGLPFASampleBuffers, (NSOpenGLPixelFormatAttribute)1,
                NSOpenGLPFASamples, (NSOpenGLPixelFormatAttribute)16,
                0
    };
    NSOpenGLPixelFormat *pix = nil;
    while(attribs[11] > 1)
    {
       pix = [[NSOpenGLPixelFormat alloc] initWithAttributes:attribs];
       if(pix != nil)
          ns.push_back(attribs[11]);
       attribs[11] /= 2;
    }
    if(!ns.empty())
    {
        sort(ns.begin(), ns.end());
        std::vector<int>::iterator it = unique(ns.begin(), ns.end());
        ns.resize( std::distance(ns.begin(),it) );
        return 1;
    }
    return 0;
}

void GLWindow::SetCap(GtkWidget *widget)
{
using namespace main_app;
    // Create context 
    NSOpenGLPixelFormat *pix = nil;
    NSOpenGLPixelFormatAttribute attribs[] = {
                NSOpenGLPFAColorSize, 24,
                NSOpenGLPFAAlphaSize, 8,
                NSOpenGLPFADepthSize, 1,
                NSOpenGLPFADoubleBuffer,
                NSOpenGLPFAMultisample,
                NSOpenGLPFASampleBuffers, (NSOpenGLPixelFormatAttribute)1,
                NSOpenGLPFASamples, (NSOpenGLPixelFormatAttribute)JavApp.MSBuffers(),
                0 };
    if(JavApp.IsMSSupported() && JavApp.IsMSEnabled())
       pix = [[NSOpenGLPixelFormat alloc] initWithAttributes:attribs];
    if(pix == nil)
    {
       attribs[9] = attribs[10] = 0;
       pix = [[NSOpenGLPixelFormat alloc] initWithAttributes:attribs];
       JavApp.Set_AA(param_ENABLE, 0);
    }
    else if(attribs[11] > 1)
    {
       JavApp.Set_AA(param_SUPPORT, 1);
       JavApp.Set_AA(param_BUFFERS, attribs[11]);
    }
    NSOpenGLContext     *ctx = [[NSOpenGLContext     alloc] initWithFormat:pix shareContext:nil];

    // Attach to widget
    gtk_widget_set_double_buffered(widget, FALSE);

    // Save context
    g_object_set_data(G_OBJECT(widget), "glcontext", ctx);
}

#endif

void set_msaa(gpointer dlg)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   GtkWidget *b = get_widget(GTK_WIDGET(dlg), "okbutton");
   gtk_button_clicked(GTK_BUTTON(b));
   gl->Destroy(-1);
   call_javs(NULL, NULL);
}

void on_change_aa(GtkToggleButton *check, gpointer w)
{
using namespace main_app;
    int enabled = gtk_toggle_button_get_active(check);
    JavApp.Set_AA(param_ENABLE, enabled);
    int val = combo_get_val(GTK_WIDGET(w)) - 1;
    if( (val < 0) || (val > (int)NSamples.size()))
         val = 0;
    if(enabled)
    {
#ifdef GDK_WINDOWING_WIN32
       JavApp.Set_AA(param_FORMAT, iPixelFormats.at(val));
#endif
       JavApp.Set_AA(param_BUFFERS, NSamples.at(val));
    }
    else
       JavApp.Set_AA(param_BUFFERS, 0);
#if 0
#ifndef GDK_WINDOWING_WIN32
    GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(check));
    set_msaa((gpointer) dlg);
#endif
#endif
}

void on_change_nsamples(GtkWidget *w, int val)
{
using namespace main_app;
    JavApp.Set_AA(param_BUFFERS, NSamples.at(val));
#ifdef GDK_WINDOWING_WIN32
       JavApp.Set_AA(param_FORMAT, iPixelFormats.at(val));
#endif
//    GtkWidget *dlg = gtk_widget_get_toplevel(w);
//    set_msaa(dlg);
}

GtkWidget *AAFrame(GtkWidget *father)
{
  int nitems = (int) NSamples.size();
  GtkWidget *frame = NEW_FRAME("Antialiasing Settings");
  GtkWidget *hbox = hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), hbox);
  GtkWidget *check = CHECK_BUTTON_WITH_LABEL ("Enable multisampling", NULL);
  g_object_set_data(G_OBJECT(father), "msaa", check);
  gtk_box_pack_start (GTK_BOX (hbox), check, FALSE, FALSE, 0);
  GtkWidget *label = LABEL_NEW("Filter: ", NULL);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 10);
  set_alignment(label, 0, 0.5);
  GtkWidget *combons = MRcombo_new(NULL, on_change_nsamples, 0, 0);
  g_object_set_data(G_OBJECT(father), "nsamples", combons);
  for(int i=0; i<nitems; i++)
      combo_insert_text (combons, i, g_strdup_printf("%dx", NSamples.at(i)));
  gtk_box_pack_start (GTK_BOX (hbox), combons, FALSE, FALSE, 2);
  set_tip(combons, "To apply changes, the program must restart");
//#ifdef GDK_WINDOWING_WIN32
  set_tip(check, "To apply changes, the program must restart");
//#endif
  gtk_widget_set_sensitive(combons, FALSE);
  int hnd = g_signal_connect(G_OBJECT(check), "toggled",
        G_CALLBACK(on_change_aa), combons);
  g_object_set_data(G_OBJECT(check), "hnd", GINT_TO_POINTER(hnd));
  g_signal_connect(G_OBJECT(check), "toggled",
        G_CALLBACK(on_cb_attiva), combons);

  return frame;
}

void GLWindow::NormalizzasuCella()
{
  std::vector<double> tvet;
  std::vector<double> mini, maxi;
  int j;

  for(j=0; j<3; j++)
  {
      for(int i=0; i<8; i++)
          tvet.push_back(vc[i].v[j]);
      maxi.push_back(*max_element(tvet.begin(), tvet.end()));
      mini.push_back(*min_element(tvet.begin(), tvet.end()));
      tvet.clear();
  }
  for(j=0; j<3; j++)
      tvet.push_back(maxi[j]-mini[j]);
  double  delta0 = *max_element(tvet.begin(), tvet.end());
  tvet.clear();

  deltav = (float) delta0;
  calcolaO(mini, maxi);
}

void GLWindow::RiNormalizza(bool fResize)
{
  Normalized = 0;
//  ResetView(false, false);
//310714  if(!CenterOnMap)
     RiNormalizzasuModello(fResize); 
#ifdef MAPS
  RiNormalizzasuMappa(); 
  if(CenterOnMap)
  {
     ResetProjectionMatrix(1.f);
     if(!Normalized)
        RiNormalizzasuModello(fResize); 
  }
  RunMCAll();
  for(int i=0; i <8; i++)
      VertParN[i] = Trasforma(VertPar[i]);
#endif
  NormalizzaModelli();
  NormalizzaCentroids(this);
}

void GLWindow::DrawAxes()
{
    float vp[4];
    float oldRange = Range;
    const char *lb[] = {"a", "b", "c"};

    glDisable(GL_FOG);
    glEnable(GL_LIGHTING);
    glDisable(GL_COLOR_MATERIAL);
    glEnable(GL_NORMALIZE);

    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    ResetProjectionMatrix(1.f);
    glMatrixMode(GL_MODELVIEW);

    glPushMatrix();
    glGetFloatv(GL_VIEWPORT, vp);

    glViewport(10, 10, border-20, border-20);
    glLoadIdentity();
    glTranslatef( 0, 0, 0);

    glMultMatrixd (Rotm.m);

    glEnable (GL_BLEND);
    glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glPolygonMode( GL_FRONT_AND_BACK, GL_FILL ) ;

    PangoFontDescription *font_desc =
          pango_font_description_from_string(fontname);

    double rad = 0.06;
    for (int i=0; i<3; i++)
    {
         float colorlab[] = {0, 0, 0, 1};
         colorlab[i] = 1;
         glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, colorlab);
         render3DArrow(xyzsN[0], xyzsN[i+1], rad, 10);
#ifdef _WIN64
         glColor4fv(colorlab);
         glRasterPos3d(1.18*xyzsN[i+1].x, 1.18*xyzsN[i+1].y, 1.18*xyzsN[i+1].z);
         glCallLists(1, GL_UNSIGNED_BYTE, lb[i]);
#else
         DrawText(-1, font_desc, PANGO_ALIGN_LEFT, colorlab, xyzsN[i+1],
              lb[i], NULL, true);
#endif
    }
    pango_font_description_free(font_desc);

    float color1[] = {0.95f, 0.95f, 1, 1};
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, color1);
    glTranslated(xyzsN[0].x, xyzsN[0].y, xyzsN[0].z);         //O
    Sfera (TRUE, 0.1, 10);

    glColor3f(1.0f, 1.0f, 1.0f);
    glViewport((GLsizei)vp[0], (GLsizei)vp[1], (GLsizei)vp[2], (GLsizei)vp[3]);
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();
    glMatrixMode(GL_PROJECTION);
    glPopMatrix();
    ResetProjectionMatrix(oldRange);
    glMatrixMode(GL_MODELVIEW);
}

void GLWindow::PrintMess(const char *stringa)
{
    GtkWidget *statusbar = get_widget(GLWINDOW, "statusbar");
    (void) gtk_statusbar_push(GTK_STATUSBAR(statusbar), 1, toUTF8(stringa));
}

void GLWindow::DrawBackground()
{
    glDisable(GL_DEPTH_TEST);
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();
    glDisable(GL_LIGHTING);
//    glColor3f(1.0f, 1.0f, 1.0f);
//    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

#ifdef USE_CAIRO_TEXTURES
    glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );
    glBindTexture(GL_TEXTURE_2D, iTexture[7]); 
    glEnable (GL_TEXTURE_2D);
    glBegin(GL_POLYGON); 
    glTexCoord2f(0.0f, 0.0f); 
    glVertex3f(-1.0f, -1.0f,  1.0f);
    glTexCoord2f(1.0f, 0.0f); 
    glVertex3f( 1.0f, -1.0f,  1.0f);
    glTexCoord2f(1.0f, 1.0f); 
    glVertex3f( 1.0f,  1.0f,  1.0f);
    glTexCoord2f(0.0f, 1.0f); 
    glVertex3f(-1.0f,  1.0f,  1.0f);
    glEnd();
    glDisable (GL_TEXTURE_2D);
#else
    if(BgType == TYPE_VGRAD)
    {
       glBegin(GL_QUADS);
       glColor3fv(BgColor1);
       glVertex2f(-1.0,-1.0);
       glVertex2f(1.0,-1.0);
       glColor3fv(BgColor2);
       glVertex2f(1.0, 1.0);
       glVertex2f(-1.0, 1.0);
       glEnd();
    }
    else if(BgType == TYPE_HGRAD)
    {
       glBegin(GL_QUADS);
       glColor3fv(BgColor1);
       glVertex2f(-1.0,1.0);
       glVertex2f(-1.0,-1.0);
       glColor3fv(BgColor2);
       glVertex2f(1.0, -1.0);
       glVertex2f(1.0, 1.0);
       glEnd();
    }
    else
    {
       glBegin(GL_QUADS);
       glColor3fv(BgColor1);
       glVertex2f(-1.0,-1.0);
       glColor3fv(BgColor2);
       glVertex2f(1.0,-1.0);
       glColor3fv(BgColor1);
       glVertex2f(1.0, 1.0);
       glColor3fv(BgColor2);
       glVertex2f(-1.0, 1.0);
       glEnd();
    }
#endif
    glMatrixMode(GL_PROJECTION);
    glPopMatrix();
    glMatrixMode(GL_MODELVIEW);
    glPopMatrix();
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);
}

void GLWindow::EnableClip()
{
    if(Clip)
    {
       glEnable(GL_CLIP_PLANE0);
       glEnable(GL_CLIP_PLANE1);
    }
    else
    {
       glDisable(GL_CLIP_PLANE0);
       glDisable(GL_CLIP_PLANE1);
    }
}

void GLWindow::DisableClip()
{
    glDisable(GL_CLIP_PLANE0);
    glDisable(GL_CLIP_PLANE1);
}

void GLWindow::RenderScene()
{
    glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
    glDisable(GL_FOG);
    if(BgType > TYPE_FLAT)
       DrawBackground();
    else
       glClearColor(BgColor[0], BgColor[1], BgColor[2], BgColor[3]);
//    glEnable(GL_CULL_FACE);

    if( (nModels == 0) && (nMaps == 0) )
    {
        if(PreviewMode)
           return;
#ifdef JAV
         if(!DrawTrigs())
         {
         glPushMatrix();
         glRotatef(25, 1, 1, 0);
         DrawSplash();
         glPopMatrix();
         }
         if(PreviewMode)
           SaveBuffer(Widget);
#endif
         return;
    }

    glEnable (GL_LIGHTING);
    glDisable(GL_FOG);

  // draw cell

    if(ifCell)
       DrawCell();
    if(ifGrid)
       DrawGrid();
    if(ifDrawPar)
       DrawPar(VertParN, AxesColor, smooth);

  // define clip planes

    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();
    glClipPlane(GL_CLIP_PLANE0, eq0);
    glClipPlane(GL_CLIP_PLANE1, eq1);
    EnableClip();
    glPopMatrix();

  // define fog type

   if(fog)  // && (BgType <= TYPE_FLAT))
   {
      glEnable(GL_FOG);
      GLfloat fogColor[4];// = {BgColor[0], BgColor[1], BgColor[2], BgColor[3]};
      if (BgType <= TYPE_FLAT)
          for(int j=0; j<4;j++)
              fogColor[j] = BgColor[j];
      else if(BgType == TYPE_RGRAD)
          for(int j=0; j<4;j++)
              fogColor[j] = BgColor1[j];
      else
          for(int j=0; j<4;j++)
              fogColor[j] = (BgColor1[j]+BgColor2[j])/2;
//      GLint fogMode = GL_LINEAR;
      GLint fogMode = GL_EXP2;
      glFogi (GL_FOG_MODE, fogMode);
      glFogfv (GL_FOG_COLOR, fogColor);
      glFogf (GL_FOG_DENSITY, FogDensity);
      glHint (GL_FOG_HINT, GL_NICEST);  //  per pixel 
      if(fogMode == GL_LINEAR)
      {
         glFogf(GL_FOG_START, 0.4f);
         glFogf(GL_FOG_END, 10.f);
      }
   }
   else
      glDisable(GL_FOG);

  // draw model(s)
    DrawModels();
    DisableClip();
    DrawDistAng();

#ifndef JAV
    drawSphere();
#endif

    if(DrawCenter)
    {
       glPushMatrix();
       glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, CentreColor);
//       glColor3fv(CentreColor);
       vet3 v1, v2;
       v1 = MRMatrix3MultiplyVector3(rmC, xyzC);
       v2 = Trasforma(v1);
       glTranslated( v2.x, v2.y, v2.z);
       Sfera (TRUE, 0.02, 10);
       glPopMatrix();
    }
    DrawCentroids(this);

#ifdef MAPS
  // draw maps(s)
    EnableClip();
    DrawMaps();
    DisableClip();
#endif
   if(fog)
      glDisable(GL_FOG);
#ifdef HAVE_LEGEND
    DrawLegend();
#endif
    if(!PreviewMode && ifAxes)
       DrawAxes();
//   if(fog)
//      glEnable(GL_FOG);
    if(PreviewMode)
       SaveBuffer(Widget);
}

void Sfera(gboolean solid, double radius, int div)
{
    int val[2];
    glGetIntegerv(GL_POLYGON_MODE, val);
    if(solid)
       glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );
    else
       glPolygonMode( GL_FRONT_AND_BACK, GL_LINE );
    disegnaSfera(radius, div);
}

void RenderSceneNormal(GLWindow *gl)
{
  // clear
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    gl->ResetModelMatrix(0);

    gl->RenderScene();
}

void RenderSceneStereo(GLWindow *gl)
{
  // clear
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_ACCUM_BUFFER_BIT);

 // left eye
    glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE);
    switch (gl->glasses_type) 
    {
        case REDBLUE:
        case REDGREEN:
        case REDCYAN:
            glColorMask(GL_TRUE, GL_FALSE, GL_FALSE, GL_TRUE);
            break;
        case BLUERED:
            glColorMask(GL_FALSE, GL_FALSE, GL_TRUE, GL_TRUE);
            break;
        case GREENRED:
            glColorMask(GL_FALSE, GL_TRUE, GL_FALSE, GL_TRUE);
            break;
        case CYANRED:
            glColorMask(GL_FALSE, GL_TRUE, GL_TRUE, GL_TRUE);
            break;
    } 

    gl->ResetModelMatrix(-1);
    gl->RenderScene();
    glFlush();
    glColorMask(GL_TRUE,GL_TRUE,GL_TRUE,GL_TRUE);
    glAccum(GL_LOAD,1.0);
    glDrawBuffer(GL_BACK);
    glClear(GL_DEPTH_BUFFER_BIT);
 // right eye
    switch (gl->glasses_type) 
    {
        case REDBLUE:
            glColorMask(GL_FALSE, GL_FALSE, GL_TRUE, GL_TRUE);
            break;
        case REDGREEN:
            glColorMask(GL_FALSE, GL_TRUE, GL_FALSE, GL_TRUE);
            break;
        case REDCYAN:
            glColorMask(GL_FALSE, GL_TRUE, GL_TRUE, GL_TRUE);
            break;
        case BLUERED:
        case GREENRED:
        case CYANRED:
            glColorMask(GL_TRUE, GL_FALSE, GL_FALSE, GL_TRUE);
            break;
    }
    gl->ResetModelMatrix(1);
    gl->RenderScene();
    glFlush();
    glColorMask(GL_TRUE,GL_TRUE,GL_TRUE,GL_TRUE);
}

// Expose callback

#if GTK_MAJOR_VERSION < 3
static gboolean expose_event (GtkWidget *, GdkEventExpose *event,
                             gpointer data)
{
  if(event->count)
     return FALSE;
#else
static gboolean expose_event (GtkWidget *widget, cairo_t *cr,
                             gpointer data)
{
#endif
  GLWindow *gl = (GLWindow *)data;
  if (!gl->MakeCurrent())
      return FALSE;
  if(gl->Stereo && (gl->BgType < TYPE_FLAT))
     RenderSceneStereo(gl);
  else
     RenderSceneNormal(gl);

  gl->mySwapBuffers();
  gl->EndCurrent();

  return FALSE;
}
#if defined (GDK_WINDOWING_WIN32) 
#if GTK_MAJOR_VERSION < 3
static gboolean expose_eventMW (GtkWidget *, GdkEventExpose *event,
                             gpointer data)
{
  if(event->count)
     return FALSE;
#else
static gboolean expose_eventMW (GtkWidget *widget, cairo_t *cr,
                             gpointer data)
{
#endif
  GtkWidget *da = (GtkWidget *) data;
  HWND hWndJav = (HWND) get_object(da, "hwnd");
  InvalidateRect(hWndJav, NULL, FALSE);
  return FALSE;
}
#endif

void sync_radio(const char *menuname, bool Flag)
{
   if(get_object(GLWINDOW, menuname) == NULL)
      return;
   if(strstr(menuname, "Grow Fragment") || strstr(menuname, "Hydrogen Bonds") ||
      strstr(menuname, "Short Contacts") || strstr(menuname, "Polyhedra"))
   {
      gpointer tb = get_object(GLWINDOW, menuname);
      obj_set_active(tb, Flag, true);
      return;
   }
   if(strstr(menuname, "Cell"))
   {
      gpointer tb = get_object(GLWINDOW, "CellOn");
      obj_set_active(tb, Flag, true);
   }
   else if(strstr(menuname, "Label All"))
   {
      gpointer tb = get_object(GLWINDOW, "LabelsOn");
      obj_set_active(tb, Flag, true);
   }
   obj_set_active(get_object(GLWINDOW, menuname), Flag);
}

gboolean SpecialKeys(int key, int stato, GLWindow *gl)
{
    if(PreviewMode)
       return FALSE;
    int ifCtrl = 0;
    int ifShift = 0;
#ifdef USE_ACTIONS
    GtkActionGroup *ag = (GtkActionGroup *)get_object(GLWINDOW, "action_group");
#endif

    if ( (stato & GDK_CONTROL_MASK) == GDK_CONTROL_MASK )
          ifCtrl =  1;
    else if ( (stato & GDK_SHIFT_MASK) == GDK_SHIFT_MASK )
         ifShift =  1;
    else if ( (stato & GDK_MOD1_MASK) == GDK_MOD1_MASK )
         return FALSE;

    switch(key)
    {
    default:
         return FALSE;
    case KeyUp:
    case KeyKpUp:
         if(ifCtrl)         // Rotation
            gl->on_rotate(0, -1.);
         else if(ifShift)  // Move center
            gl->on_move_center(1, 1);
         else              // Move
            gl->on_move(1, 10.f/gl->Width);
            break;
    case KeyDown:
    case KeyKpDown:
         if(ifCtrl)         // Rotation
            gl->on_rotate(0, 1.);
         else if(ifShift)  // Move center
            gl->on_move_center(1, -1);
         else              // Move
            gl->on_move(1, -10.f/gl->Width);
            break;
    case KeyLeft:
    case KeyKpLeft:
         if(ifCtrl)         // Rotation
            gl->on_rotate(1, -1.);
         else if(ifShift)  // Move center
            gl->on_move_center(0, -1);
         else              // Move
            gl->on_move(0, -10.f/gl->Width);
            break;
    case KeyRight:
    case KeyKpRight:
         if(ifCtrl)         // Rotation
            gl->on_rotate(1, 1.);
         else if(ifShift)  // Move center
            gl->on_move_center(0, 1);
         else              // Move
            gl->on_move(0, 10.f/gl->Width);
            break;
    case KeyPageDown:
    case KeyKpPageDown:
         if(ifCtrl)         // Rotation
            gl->on_rotate(2, -1.);
         else if(ifShift)  // Move center
            gl->on_move_center(2, -1);
         else              // Move
            gl->on_move(2, -40.f/gl->Width);
            break;
    case KeyPageUp:
    case KeyKpPageUp:
         if(ifCtrl)         // Rotation
            gl->on_rotate(2, 1.);
         else if(ifShift)  // Move center
            gl->on_move_center(2, 1);
         else              // Move
            gl->on_move(2, 40.f/gl->Width);
            break;
#ifndef USE_ACTIONS
    case KeyEnd:        // Reset Scale
    case KeyKpEnd:
         if(get_object(GLWINDOW, "Reset Scale"))
             gtk_menu_item_activate(GTK_MENU_ITEM(get_object(GLWINDOW, "Reset Scale")));
         break;
    case KeyHome:        // Reset
    case KeyKpHome:
         if(get_object(GLWINDOW, "Reset View"))
             gtk_menu_item_activate(GTK_MENU_ITEM(get_object(GLWINDOW, "Reset View")));
         break;
    case KeyQ:           // Quit
    case Keyq:
         if(!ifCtrl)
            return FALSE;
         if(get_object(GLWINDOW, "Exit"))
             gtk_menu_item_activate(GTK_MENU_ITEM(get_object(GLWINDOW, "Exit")));
         break;
    case KeyL:           // Last Run
    case Keyl:
         if(!ifCtrl)
            return FALSE;
         if(get_object(GLWINDOW, "Last Run"))
         {
             if(gtk_widget_get_sensitive(get_widget(GLWINDOW, "Last Run")))
                gtk_menu_item_activate(GTK_MENU_ITEM(get_object(GLWINDOW, "Last Run")));
         }
         break;
    case KeyR:           // Remove Map/Model
    case Keyr:
         if(!ifCtrl)
            return FALSE;
         if(get_object(GLWINDOW, "Remove Map/Model"))
             gtk_menu_item_activate(GTK_MENU_ITEM(get_object(GLWINDOW, "Remove Map/Model")));
         break;
    case KeyH:           // Hard Copy
    case Keyh:
         if(!ifCtrl)
            return FALSE;
         if(get_object(GLWINDOW, "Screenshot"))
             gtk_menu_item_activate(GTK_MENU_ITEM(get_object(GLWINDOW, "Screenshot")));
         break;
    case KeyZ:           // Undo
    case Keyz:
         if(!ifCtrl)
            return FALSE;
         if(get_object(GLWINDOW, "Undo"))
             if(gtk_widget_get_sensitive(get_widget(GLWINDOW, "Undo")))
                gtk_menu_item_activate(GTK_MENU_ITEM(get_object(GLWINDOW, "Undo")));
         break;
    case KeyY:           // Redo
    case Keyy:
         if(!ifCtrl)
            return FALSE;
         if(get_object(GLWINDOW, "Redo"))
             if(gtk_widget_get_sensitive(get_widget(GLWINDOW, "Redo")))
                gtk_menu_item_activate(GTK_MENU_ITEM(get_object(GLWINDOW, "Redo")));
         break;
#else
    case KeyEnd:        // Reset Scale
    case KeyKpEnd:
         if(gtk_action_group_get_action(ag, "Reset Scale"))
             gtk_action_activate(gtk_action_group_get_action(ag, "Reset Scale"));
         break;
    case KeyHome:        // Reset
    case KeyKpHome:
         if(gtk_action_group_get_action(ag, "Reset View"))
             gtk_action_activate(gtk_action_group_get_action(ag, "Reset View"));
         break;
#endif
    case KeyS:
    case Keys:
         gl->smooth = !gl->smooth;
         break;
    case KeyC:
    case Keyc:
         SetClip(!gl->Clip);
         break;
    case KeyE:
    case Keye:
         sync_radio("View Cell Edges", !gl->ifCell);
         break;
    case KeyG:
    case Keyg:
         gl->ToggleGrid(!gl->ifGrid);
         break;
    case KeyP:
    case Keyp:
         gl->SetOrtho(gl->ifOrtho?0:1);
         break;
      case KeyF:
      case Keyf:
           gl->ToggleFog(!gl->fog);
           break;
      case KeyB:
      case Keyb:
           gl->BgType = TYPE_BLACK;
           gl->BgColor[0] = gl->BgColor[1] = gl->BgColor[2] = 0.f;
           gl->SetBgColor();
           break;
      case KeyW:
      case Keyw:
           gl->BgType = TYPE_WHITE;
           gl->BgColor[0] = gl->BgColor[1] = gl->BgColor[2] = 1.f;
           gl->SetBgColor();
           break;
    }
    return TRUE;
}

static gboolean key_press_event (GtkWidget *,
                                 GdkEventKey *event, gpointer data)
{
  GLWindow *gl = (GLWindow *)data;
  if(SpecialKeys (event->keyval, event->state, gl))
  {
     set_values_for_advanced();
     return TRUE;
  }
  else
     return FALSE;
}

static void realize (GtkWidget *widget, gpointer data)
{
using namespace main_app;
  GLWindow *gl = (GLWindow *)data;
//  if(gtk_widget_get_window(widget))
//     gdk_window_ensure_native(gtk_widget_get_window(widget));
  if (!gl->MakeCurrent())
    return;
  SetupRC(gl);
#ifdef GL_SAMPLE_BUFFERS
  if(JavApp.IsMSSupported() && JavApp.IsMSEnabled())
  {
     GLint  iMultiSample = 0;
     GLint  iNumSamples = 0;
     glEnable(GL_MULTISAMPLE);
     glHint(GL_MULTISAMPLE_FILTER_HINT_NV, GL_NICEST);
     glGetIntegerv(GL_SAMPLE_BUFFERS, &iMultiSample);
     glGetIntegerv(GL_SAMPLES, &iNumSamples);
     JavApp.Set_AA(param_SUPPORT, iMultiSample);
     JavApp.Set_AA(param_BUFFERS, iNumSamples);
//     g_print("Samples DOPO glEnable(GL_MULTISAMPLE) %d\n", JavApp.MSBuffers());
  }
#else
     IsMSSupported = false;
     MSBuffers = 0;
#endif
  gl->EndCurrent();
#ifdef JAV
  if(ifDebug)
     g_print("GL_VENDOR %s\nGL_RENDERER %s\nGL_VERSION %s\n", 
          glGetString(GL_VENDOR), glGetString(GL_RENDERER), glGetString(GL_VERSION));
#endif
  g_object_set_data(G_OBJECT(gtk_widget_get_toplevel(widget)), "currentPixmap",
    gtk_widget_get_window(widget));
  if(str_white(defaultMessage.c_str()))
  {
     AddWelcomeMessage(get_widget(widget, "statusbar"), jav_msgdefault);
     Re_data *re_data = g_new0(Re_data, 1);
     re_data->statusbar = get_widget(widget, "statusbar");
     re_data->msg = jav_msgdefault;
#ifdef NOADD_SECS
     g_timeout_add(7200000, RefreshWelcomeMessage, (gpointer) re_data);
#else
     g_timeout_add_seconds (7200, RefreshWelcomeMessage, (gpointer) re_data);
#endif
  }
else
     gl->PrintMess(defaultMessage.c_str());
}

void SetBgFromDefaults()
{
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  if(defaultBG != -1)
  {
     gl->BgType = defaultBG;
     if(defaultBgColor[0] != -1)
        memcpy(gl->BgColor, defaultBgColor, 3*sizeof(float));
     if(defaultBgColor1[0] != -1)
        memcpy(gl->BgColor1, defaultBgColor1, 3*sizeof(float));
     if(defaultBgColor2[0] != -1)
        memcpy(gl->BgColor2, defaultBgColor2, 3*sizeof(float));
  }
  defaultBG = gl->BgType;
  gl->BgColor[3] = 1.f;
  gl->BgColor1[3] = 1.f;
  gl->BgColor2[3] = 1.f;
  if(gtk_widget_get_realized(GLWINDOW))
     gl->SetBgColor();
}


GtkWidget *create_drawing_area(GtkWidget *mainwin, GtkWidget *box, gpointer data)
{
     GLWindow *glx = (GLWindow *) data;
     GtkWidget *drawing_area, *ebox;

     if(PreviewMode)
     {
        OSWidth  = main_app::JavApp.Kscrx;
        OSHeight = main_app::JavApp.Kscry;
        ebox = gtk_event_box_new();
#ifdef HAVE_GTKGLEXT
        drawing_area = gtk_drawing_area_new();
#else
        drawing_area = gtk_image_new();
#endif
        gtk_widget_set_size_request(drawing_area, OSWidth, OSHeight);
        gtk_container_add(GTK_CONTAINER(ebox), drawing_area);
        gtk_container_set_border_width(GTK_CONTAINER(ebox), 0);
        gtk_container_add(GTK_CONTAINER(box), ebox);
        gtk_widget_show(ebox);
     }
     else
     {
#ifdef GDK_WINDOWING_WIN32
        if(win_native)
        {
           drawing_area = gtk_frame_new(NULL);
           gtk_frame_set_shadow_type(GTK_FRAME(drawing_area), GTK_SHADOW_NONE);
        }
        else
#endif
           drawing_area = gtk_drawing_area_new();
        gtk_box_pack_end (GTK_BOX (box), drawing_area, TRUE, TRUE, 0);
     }
     glx->Widget = drawing_area;
     if(GTK_IS_WIDGET(drawing_area))
     g_signal_connect_after (G_OBJECT (drawing_area), "realize",
                          G_CALLBACK (realize),  glx);
     if(PreviewMode)
     {
        ChangeSize (OSWidth, OSHeight, glx);
        gtk_widget_add_events(ebox, EventMask);
        (void) g_signal_connect (G_OBJECT (ebox), "button_press_event",
                      G_CALLBACK (mouse_press), glx);
        return drawing_area;
     }
#ifdef GDK_WINDOWING_WIN32
     if(win_native)
     {
        gtk_widget_show(mainwin);
        GdkWindow *window = gtk_widget_get_window(mainwin);
        HWND hWndMain = static_cast<HWND> GDK_WINDOW_HWND(window);
         g_object_set_data(G_OBJECT(mainwin), "drawingarea", drawing_area);

        g_signal_connect(G_OBJECT(drawing_area), "size-allocate",
           G_CALLBACK(gtkJavEvent), (gpointer) glx);
        hInst    = (HINSTANCE) GetWindowLongPtr(hWndMain, GWLP_HINSTANCE);
        RegisterJavClass(hInst);

        GtkAllocation allocation;
        gtk_widget_get_allocation(drawing_area, &allocation);

        HWND hWndJav  = CreateWindowEx(0,
                              TEXT("Jav"),
                              TEXT("JavW"),
                              WS_CHILD | WS_VISIBLE | WS_BORDER | WS_CLIPSIBLINGS,
                              allocation.x,
                              allocation.y,
                              allocation.width,
                              allocation.height,
                              hWndMain,
                              NULL,
                              hInst,
                              NULL );
        hcCross = LoadCursor(hInst, MAKEINTRESOURCE(IDC_MYCROSS));
        hcZoom  = LoadCursor(hInst, MAKEINTRESOURCE(IDC_MYZOOM));
        hcMove  = LoadCursor(hInst, MAKEINTRESOURCE(IDC_MYMOVE));
        hcNorm  = LoadCursor( NULL, IDC_ARROW );
 
        g_object_set_data(G_OBJECT(drawing_area), "hwnd", (gpointer) hWndJav);

        ShowWindow(hWndJav, SW_SHOW);
        UpdateWindow(hWndJav);
        return drawing_area;
     }
#endif
     g_signal_connect (G_OBJECT (drawing_area), "configure_event",
                    G_CALLBACK (configure_event), glx);
     int hnd = g_signal_connect (G_OBJECT (drawing_area), DRAW_EVENT,
                    G_CALLBACK (expose_event),  glx);
     g_object_set_data(G_OBJECT(mainwin), "expose_hnd", GINT_TO_POINTER(hnd));
     (void) g_signal_connect (G_OBJECT (drawing_area), "button_press_event",
                      G_CALLBACK (mouse_press), glx);
     (void) g_signal_connect (G_OBJECT (drawing_area), "scroll-event",
                      G_CALLBACK (mouse_scroll), glx);
     (void) g_signal_connect (G_OBJECT (drawing_area), "button_release_event",
                      G_CALLBACK (mouse_release), glx);
     (void) g_signal_connect (G_OBJECT (drawing_area), "motion_notify_event",
                      G_CALLBACK (mouse_move), glx);
#ifdef USE_GRAB
     (void) g_signal_connect (G_OBJECT (drawing_area), "leave_notify_event",
                      G_CALLBACK (mouse_leave), glx);
#endif
     gtk_widget_add_events(drawing_area, EventMask | GDK_EXPOSURE_MASK |
                            GDK_LEAVE_NOTIFY_MASK);
     return drawing_area;
}


static gboolean on_jav_state_event (GtkWidget *widget,
                    GdkEventWindowState *event, gpointer data)
{
  if (event->changed_mask & (GDK_WINDOW_STATE_MAXIMIZED |
                             GDK_WINDOW_STATE_FULLSCREEN))
    {
      gboolean maximized;

      maximized = event->new_window_state & (GDK_WINDOW_STATE_MAXIMIZED |
                                             GDK_WINDOW_STATE_FULLSCREEN);
      main_app::JavApp.IfMaximized = (maximized > 0);
    }
    return FALSE;
}

void on_jav_allocate(GtkWidget *w, GdkRectangle *allocation, gpointer data)
{
    gtk_widget_queue_draw(w);
}

GtkWidget *create_GLwindow(int width, int height, const char *title,
                           int ifSmooth, int x, int y)
{
  GtkWidget *window;
  GtkWidget *vbox;
  GtkWidget *hbox;
  GtkWidget *box;
  GtkWidget *frame;
  GtkWidget *statusb;
  GtkWidget *drawing_area;
  GLWindow *glx;

  calcolaH();
  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  GLWINDOW = window;
  gtk_window_set_title (GTK_WINDOW (window), toUTF8(title));
  if(PreviewMode)
  {
//     gtk_window_set_decorated(GTK_WINDOW(window), FALSE);
     gtk_container_set_border_width(GTK_CONTAINER(window), 0);
     gtk_window_move(GTK_WINDOW(window), x, y);
     gtk_window_set_resizable(GTK_WINDOW(window), FALSE);
     gtk_window_set_default_size(GTK_WINDOW(window), width, height);
  }
  else
     gtk_window_set_default_size(GTK_WINDOW(window), width, height);
  
#ifdef JAV
#ifndef GTK_TOOLTIP
  GtkTooltips *tooltips = gtk_tooltips_new ();
  set_win_main(window);
  g_object_set_data(G_OBJECT(window), "tt", tooltips);
#endif
#endif

  /* Get automatically redrawn if any of their children changed allocation. */
  //gtk_container_set_reallocate_redraws (GTK_CONTAINER (window), TRUE);

  vbox = vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(window), vbox);
  g_object_set_data(G_OBJECT(window), "vbox", vbox);
  hbox = hbox_new(FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
  g_object_set_data(G_OBJECT(window), "hbox", hbox);
  box = hbox;

  frame = gtk_frame_new(NULL);
  gtk_box_pack_end (GTK_BOX (vbox), frame, FALSE, FALSE, 0);
  gtk_widget_show(frame);
  gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_ETCHED_IN);
  statusb = gtk_statusbar_new ();
  g_object_set_data (G_OBJECT (window), "statusbar", statusb);
  gtk_widget_show (statusb);
  if(!PreviewMode)
     gtk_container_add(GTK_CONTAINER(frame), statusb);
  gtk_widget_set_events(window, GDK_KEY_PRESS_MASK | GDK_EXPOSURE_MASK );

  if(main_app::JavApp.ForceSoftRendering())
  {
#ifdef GDK_WINDOWING_WIN32
     win_native = true;
#else
     const char *force_softrender = "LIBGL_ALWAYS_SOFTWARE=1";
     mr_setenv_(g_strdup(force_softrender));
#endif
  }
#if defined(GDK_WINDOWING_WIN32) && defined(IN_GTK3)
  else
      win_native = true;  //false;   090114
#endif

#ifdef GDK_WINDOWING_WIN32
  if(PreviewMode)
     win_native = false;
#endif
  glx = new GLWindow(NULL, width, height);
  g_object_set_data(G_OBJECT(window), "glwindow", (gpointer)glx);
  drawing_area = create_drawing_area (window, box, (gpointer) glx);
  gtk_widget_set_double_buffered (drawing_area, FALSE);
  g_object_set_data(G_OBJECT(window), "drawingarea", drawing_area);
  g_object_set_data (G_OBJECT (drawing_area), "statusbar", statusb);
  std::vector<int> ns;
#ifndef GDK_WINDOWING_WIN32
  main_app::JavApp.Set_AA(param_SUPPORT, glx->GetCap(ns));
  if(!ns.empty())
  {
//     for(int i=0; i< (int)ns.size(); i++)
//         g_print("%d: %d \n", i+1, ns.at(i));
       NSamples.assign(ns.begin(), ns.end());
  }
#endif
  glx->SetCap(drawing_area);
  memcpy(glx->BgColor, main_app::JavApp.app_color[BGC], 4*sizeof(float));
  memcpy(glx->BgColor1, main_app::JavApp.app_color[BGC+1], 4*sizeof(float));
  memcpy(glx->BgColor2, main_app::JavApp.app_color[BGC+2], 4*sizeof(float));
  memcpy(glx->AxesColor, main_app::JavApp.app_color[AXESC], 4*sizeof(float));
  memcpy(glx->DistColor, main_app::JavApp.app_color[INFOS], 4*sizeof(float));
  glx->BgType = main_app::JavApp.Background;
  SetBgFromDefaults();
  glx->smooth = ifSmooth;
  (void) g_signal_connect (G_OBJECT (window), "key_press_event",
                      G_CALLBACK (key_press_event),  (gpointer) glx);
#if defined (GDK_WINDOWING_WIN32) 
  g_signal_connect (G_OBJECT (window), DRAW_EVENT,
                     G_CALLBACK (expose_eventMW),  drawing_area);
#endif
  (void) g_signal_connect(window, "window_state_event",
                          G_CALLBACK (on_jav_state_event),
                               NULL);
  (void) g_signal_connect(window, "size-allocate",
                          G_CALLBACK (on_jav_allocate),
                               NULL);

//  gtk_widget_set_events(window, GDK_KEY_PRESS_MASK | GDK_EXPOSURE_MASK );

  for(int i=0; i<=RESID_POPUP; i++)
      build_popup(i, window);
#ifdef HAVE_LEGEND
  build_popup2(LEGEND_POPUP, window);
#endif

  gtk_widget_show_all (window);
  return window;
}

void fillInfo_for_cell(GtkWidget *father, int ifAny)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   std::stringstream label_string;
   init_string(label_string, "Cell Parameters:");
   if(ifAny)
      label_string << gl->Cell[0] << " " << gl->Cell[1]   << " " << gl->Cell[2]
                << "\n   " << gl->Cell[3]<< " " << gl->Cell[4]<< " " << gl->Cell[5];
   init_string(label_string, "Cell Volume:", 0);
   if(ifAny)
      label_string  << CellVolume(gl->Cell);
   GtkWidget *label = get_widget(father, "cellp");
   gtk_label_set_markup(GTK_LABEL(label), label_string.str().c_str());

   init_string(label_string, "Space group:");
   if(ifAny)
   {
      if(str_white (gl->sy.spg))
         label_string << "n.a." << "\n" ;
      else
         label_string << gl->sy.spg << "\n" ;
   }
   init_string(label_string, "Number of symm. operators:", 0);
   if(ifAny)
      label_string  << gl->sy.nsymop;
   label = get_widget(father, "symp");
   gtk_label_set_markup(GTK_LABEL(label), label_string.str().c_str());
}

void update_infos_cell(int ifAny)
{
     if(g_object_get_data(G_OBJECT(GLWINDOW), InfoWindow))
     {
        GtkWidget *dlg = get_widget(GLWINDOW, InfoWindow);
        GtkWidget *parent = get_widget(dlg, "box_cell");
        fillInfo_for_cell(parent, ifAny);
        gtk_widget_show_all(dlg);
     }
}

void GLWindow::CalcolaMatrici()
{
      CalcMats(Cell, &rmC, &rmI, CellR, &MMRec, calcRmI);
// Vertici Cella

      int mord[] = {2, 5, 6, 4, 3, 0, 7, 1};
      vet3 xv[8] = {{{1, 0, 0}}, {{0, 1, 0}},
                    {{0, 0, 1}}, {{0, 0, 0}},
                    {{1, 1, 0}}, {{1, 0, 1}},
                    {{0, 1, 1}}, {{1, 1, 1}}};
      for(int i=0; i<8; i++)
      {
          vet3 x2 = MRMatrix3MultiplyVector3(rmC, xv[i]);
          MRVectorCopy(x2, &vc[mord[i]]);
      }
      if(ifDrawPar)
         CalcPar(xyzC, abcPar);

}

int GLWindow::GetCurNSamples()
{
using namespace main_app;
    if(NSamples.empty())
       return -1;
    for(int i=0; i<(int) NSamples.size(); i++)
        if(NSamples.at(i) == JavApp.MSBuffers())
           return i;
    return -1;
}

}                // end namespace

void reset_jav_var()
{
using namespace GLextmr;
    defaultCell = -1;
    defaultPlotStyle = -1;
    defaultSymmetry = -1;
    defaultLabels = -1;
    defaultColor = -1;
    defaultModify = 1;
    defaultBG = -1;
    defaultBgColor[0]  = defaultBgColor[1] = defaultBgColor[2] = -1;
    defaultBgColor1[0]  = defaultBgColor1[1] = defaultBgColor1[2] = -1;
    defaultBgColor2[0]  = defaultBgColor2[1] = defaultBgColor2[2] = -1;
    defaultFog  = -1;
    defaultClip = -1;
    defaultDrawPar = false;
    defaultV0.x = defaultV0.y = defaultV0.z  = 0;
    defaultabc.x = defaultabc.y = defaultabc.z = 0;
    if(GLWINDOW == NULL)
       return;
    GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
    if(gl == NULL)
       return;
    gl->DeleteAllMapModels();
    gtk_widget_hide(gtk_widget_get_toplevel(GLWINDOW));
    gl->Destroy(0);
    gl = NULL;
    GLWINDOW = NULL;
}

#ifdef GDK_WINDOWING_QUARTZ
void splash(const char *splash_xpm)
{
   GdkPixbuf *pixbuf = create_pixbuf(splash_xpm);
   NSImage *image = gdk_quartz_pixbuf_to_ns_image_libgtk_only(pixbuf);
   NSSize s = [image size];
   
   NSColor *Transparent =
    [NSColor colorWithDeviceRed:0.0 green:0.0 blue:1.0 alpha:0.0];

   int y = gdk_screen_get_height (gdk_screen_get_default()) - 200;
   NSRect frame = NSMakeRect(200, y, s.width, s.height);
   NSImageView *view = [[NSImageView alloc] initWithFrame://frame];
                          NSMakeRect(0, 0, s.width, s.height)];
   NSWindow* window  = [[[NSWindow alloc] initWithContentRect:frame
                    styleMask:NSBorderlessWindowMask
                    backing:NSBackingStoreBuffered
                    defer:NO] autorelease];
   [view setImage:image];
   [[window contentView] addSubview:view];
   [window setOpaque:NO];
   [window setBackgroundColor:Transparent];
   [window makeKeyAndOrderFront:NSApp];
}
#endif
