#include <utils.h>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string.h>
#include <sir_application.h>
#include "glext.h"
#ifdef MAPS
#include "maps.h"
#include "callbacks.h"
#include "jav_cb.h"
#ifdef GDK_WINDOWING_X11
#include <gdk/gdkx.h>
#endif

static GdkColor colorWhite = {0, 65535, 65535, 65535};
namespace main_app {
       extern Application JavApp;
                   }

const int limVol = 20000;
namespace GLextmr {
    Mappa *MapInfo;   //[2*MAX_NUM_MAPS];
    Mappa *VWSurface;
    extern GtkWidget *GLWINDOW;
    extern GLfloat sc_factor;
    float  raggioMappa = 5.f;
    float  centroMappa[3] = {0.f, 0.f, 0.f};
    bool   defCentro = false;
    double minSigma = 0.0001;
    int    numDigits = 4;
    void  calcolava();
    void  update_infos_cell(int ifAny);
    void SetLastRun(GtkWidget *w, bool flag);

Mappa::Mappa(int ind, bool if_surface)
{
      iso = 1000.;
      ifVis = !if_surface;
      size_x = 0;
      size_y = 0;
      size_z = 0;
      ifDifference = 1;
      isSurface = false;
      multicolor = false;
      mappa = NULL;
      mc = NULL;
      created = false;
      color = NULL;
      radius = 1.2f;
      step = 0.3f;
      wireframe = 0;
      mat_emission[0] = 0.3f;
      mat_emission[1] = 0.3f;
      mat_emission[2] = 0.3f;
      mat_emission[3] = 0.6f;
      shininess = 0.088f;
      GetMapColor(color_mappa, ind);
      cx = cy = cz = 0;
      xmin[0] = xmin[1] = xmin[2] = 0;
      xmax[0] = xmax[1] = xmax[2] = 1;
}

void setMinMax(vet3 mini, vet3 maxi, float rad, float step, int k)
{
      for(int j=0;j<3;j++)
      {
          VWSurface[k].xmin[j] = (float) mini.v[j];
          VWSurface[k].xmax[j] = (float) maxi.v[j];
      }
      VWSurface[k].radius = rad;
      VWSurface[k].step = step;
}

void Mappa::freeMap()
{
     delete mc;
     if(mappa)
        g_free(mappa);
     if(color)
        g_free(color);
     mappa = NULL;
     created = false;
}

void Mappa::DrawCube(GLWindow *gl)
{
    glDisable (GL_LIGHTING);
    glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
    glColor3f(1.f, 0.f, 0.f);
    
    glPushMatrix();
    glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

    glBegin(GL_QUAD_STRIP);
        glVertex3dv(vmN[1].v);       //V2
        glVertex3dv(vmN[0].v);       //V1
        glVertex3dv(vmN[3].v);       //V4
        glVertex3dv(vmN[2].v);       //V3
        glVertex3dv(vmN[5].v);       //V6
        glVertex3dv(vmN[4].v);       //V5
        glVertex3dv(vmN[7].v);       //V8
        glVertex3dv(vmN[6].v);       //V7
        glVertex3dv(vmN[1].v);       //V2
        glVertex3dv(vmN[0].v);       //V1
    glEnd();
    glBegin(GL_QUADS);
        glVertex3dv(vmN[5].v);       //V6
        glVertex3dv(vmN[7].v);       //V8
        glVertex3dv(vmN[1].v);       //V2
        glVertex3dv(vmN[3].v);       //V4
        glVertex3dv(vmN[6].v);       //V7
        glVertex3dv(vmN[4].v);       //V5
        glVertex3dv(vmN[2].v);       //V3
        glVertex3dv(vmN[0].v);       //V1
    glEnd();

    glPopMatrix();
}
/*
double Mappa::SigmaMappa()
{
      double denmin =  1.0e25f;
      double denmax = -1.0e25f;
      double avden  =  0.0f;
      double stden  =  0.0f;
      for(int i=0;i<size_x*size_y*size_z;i++)
      {
          double xx = mappa[i];
          denmax = MRmax(denmax, xx);
          denmin = MRmin(denmin, xx);
          avden = avden + xx;
          stden = stden + xx * xx;
      }
      double prodotto = double(size_x * size_y * size_z);
      avden = avden / prodotto;
      stden = stden / prodotto - avden * avden;
      if (stden > 0.0)
      {
          stden = sqrt( stden);
          sigmaMax = (myreal) (denmax /stden);
      }
      else
      {
          stden = 0.0;
          sigmaMax = 100.f;
      }
      minimum = denmin;
      maximum = denmax;
      mean = avden;
      g_print("min %lf max %lf mean %lf sigma %lf\n", denmin,denmax,avden,stden);
      return stden;
}
*/
double Mappa::SigmaMappa()
{
      float denmin =  1.0e25f;
      float denmax = -1.0e25f;
      float avden  =  0.0f;
      float stden  =  0.0f;
      for(int i=0;i<size_x*size_y*size_z;i++)
      {
          float xx = mappa[i];
          denmax = MRmax(denmax, xx);
          denmin = MRmin(denmin, xx);
          avden = avden + xx;
          stden = stden + xx * xx;
      }
      float prodotto = (float)(size_x * size_y * size_z);
      avden = avden / prodotto;
      stden = stden / prodotto - avden * avden;
      if (stden > 0.0)
      {
          stden = sqrt( stden);
          sigmaMax = (myreal) (denmax /stden);
      }
      else
      {
          stden = 0.0;
          sigmaMax = 100.f;
      }
      minimum = (double) denmin;
      maximum = (double) denmax;
      mean = (double) avden;
//      g_print("min %f max %f mean %f sigma %f\n", denmin,denmax,avden,stden);
      return (double) stden;
}

void Mappa::run_mc(GLWindow *gl, int limx, int limy, int limz) 
{
  int i, j, k;
  int ii, jj, kk;
  int f;
  int originalMC = 0 ;

  if((gl->ifWhole) || isSurface)
     f = 1;
  else
     f = 2;

  mc->clean_all() ;
  mc->set_resolution( f*limx+1, f*limy+1, f*limz+1 ) ;
  mc->init_all() ;
  if((limx*limy*limz) == 0)
     return;

  for( k = 0 ; k <= f*limz; k++ )
  {
    kk = (MRabs(size_z + k - limz + cz)) % size_z;
    kk *= size_x*size_y;

    for( j = 0 ; j <= f*limy ; j++ )
    {
      jj = (MRabs(size_y + j - limy + cy)) % size_y;
      jj *= size_x;

      for( i = 0 ; i <= f*limx ; i++ )
      {
           ii = (MRabs(size_x + i - limx + cx)) % size_x;
           int l =  ii + jj + kk;
           if(l >= (size_x*size_y*size_z))
              g_print("Warning\n");
           double w = (double) mappa[l];
           mc->set_data( w, i,j,k ) ;
           int col = color[l];
           mc->set_color( col, i,j,k ) ;
      }
    }
  }
  double diso = (double) iso;
  mc->set_method( originalMC == 1 ) ;
  mc->run(diso) ;
  mc->clean_temps() ;

  // Rescale positions

  float Xmin = (float)vf[4].x;
  float Ymin = (float)vf[4].y;
  float Zmin = (float)vf[4].z;
  float Xmax = (float)vf[1].x;
  float Ymax = (float)vf[1].y;
  float Zmax = (float)vf[1].z;
  if((gl->ifWhole) || isSurface)
  {
      Xmin = xmin[0];
      Ymin = xmin[1];
      Zmin = xmin[2];
      Xmax = xmax[0];
      Ymax = xmax[1];
      Zmax = xmax[2];
  }
  float rx = (Xmax - Xmin) /  (f*limx);// - 1);
  float ry = (Ymax - Ymin) /  (f*limy);// - 1);
  float rz = (Zmax - Zmin) /  (f*limz);// - 1);

  for( i = 0 ; i < mc->nverts() ; ++i )
  {
    Vertex &v = mc->vertices()[i] ;
    v.x = rx * v.x + Xmin;
    v.y = ry * v.y + Ymin;
    v.z = rz * v.z + Zmin;
    myreal nrm =  (myreal) (v.nx * v.nx + v.ny * v.ny + v.nz * v.nz);
    if(nrm != 0)
    {
       nrm = 1.0f / sqrt(nrm) ;
       v.nx *= nrm ;
       v.ny *= nrm ;
       v.nz *= nrm ;
    }
//  sembra inutile (ma non lo e')
//  gestione celle non ortogonali
    vet3 v1 = {{v.x, v.y, v.z}};

// da coord frazionarie a orto
    vet3 v2 = MRMatrix3MultiplyVector3(gl->rmC, v1);
// coord. grafiche
    v1 = gl->Trasforma(v2);
    v.x = v1.x;
    v.y = v1.y;
    v.z = v1.z;
  }
}

void Mappa::FromRadTorad(GLWindow *gl)
{
     radius_x = (int) (gl->Radius *(float) size_x / gl->Cell[0] + 0.5f);
     radius_y = (int) (gl->Radius *(float) size_y / gl->Cell[1] + 0.5f);
     radius_z = (int) (gl->Radius *(float) size_z / gl->Cell[2] + 0.5f);
}

void Mappa::CalcolaC()
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   if((gl->ifWhole) || isSurface)
      cx = cy = cz = 0;
   else
   {
      double a = (gl->xyzC.x > 0)?(gl->xyzC.x):(1+gl->xyzC.x);
      double b = (gl->xyzC.y > 0)?(gl->xyzC.y):(1+gl->xyzC.y);
      double c = (gl->xyzC.z > 0)?(gl->xyzC.z):(1+gl->xyzC.z);
      if (a > 1)
          a -= 1;
      if (b > 1)
          b -= 1;
      if (c > 1)
          c -= 1;
      cx = (int) ((float) size_x * a +0.5);
      cy = (int) ((float) size_y * b +0.5);
      cz = (int) ((float) size_z * c +0.5);
   }
}

void Mappa::RunMC(GLWindow *gl, int k)
{
   if(!ifVis)
      return;
   if(!mc)
      return;
   if((gl->ifWhole) || isSurface)
   {
        if(!isSurface)
           gl->NormalizzasuCella();
        else
           gl->NormalizzasuMappa(k, isSurface);
        run_mc(gl, size_x, size_y, size_z);
   }
   else
   {
        gl->NormalizzasuMappa(k, isSurface);
        run_mc(gl, radius_x, radius_y, radius_z);
   }
}

void Mappa::fromTrianglesToVertices(GLdouble *vertices, GLdouble *normals)
{
    int k = 0;
    for( int i = 0 ; i < mc->ntrigs() ; ++i )
    {
      const Triangle *t = mc->trig(i) ;
      const Vertex   *v ;
      v = mc->vert(t->v1) ;
      vertices[k]   = v->x;
      vertices[k+1] = v->y;
      vertices[k+2] = v->z;
      normals[k]    = v->nx;
      normals[k+1]  = v->ny;
      normals[k+2]  = v->nz;
      k += 3;
      v = mc->vert(t->v2) ;
      vertices[k]   = v->x;
      vertices[k+1] = v->y;
      vertices[k+2] = v->z;
      normals[k]    = v->nx;
      normals[k+1]  = v->ny;
      normals[k+2]  = v->nz;
      k += 3;
      v = mc->vert(t->v3) ;
      vertices[k]   = v->x;
      vertices[k+1] = v->y;
      vertices[k+2] = v->z;
      normals[k]    = v->nx;
      normals[k+1]  = v->ny;
      normals[k+2]  = v->nz;
      k += 3;
    }
}

void Mappa::DrawMap(GLWindow *gl)
{
    float color1[4];
    GLenum mode = GL_TRIANGLES;
    switch(wireframe)
    {
    case 3:
       mode = GL_POINTS;
    default:
    case 0:
  // setting per wireframe
       glPolygonOffset( 0.5, -0.1f );
       glLineWidth(1.5) ;
       glPolygonMode( GL_FRONT_AND_BACK, GL_LINE ) ;
       memcpy(color1, color_mappa, 4*sizeof(float));
       if(gl->Stereo)
          Desaturate(color1);
       glColor3fv(color1);
       glDisable (GL_LIGHTING);
       glDisable (GL_LINE_SMOOTH);          // piu' veloce
       glEnable(GL_BLEND);
       glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
       break;
    case 1:
       SetLightSystem(color_mappa, 1);
       break;
    case 2:
       SetLightSystem(color_mappa, 0.6f);
       glDepthMask (GL_FALSE);
       break;
    }
    if(multicolor)
    {
    glBegin( mode ) ;
    {
      for( int i = 0 ; i < mc->ntrigs() ; ++i )
      {
        const Triangle *t = mc->trig(i) ;
        const Vertex   *v ;
        v = mc->vert(t->v1) ;
        if(v->color >= 0)
        {
           memcpy(color1, main_app::JavApp.getfCol(v->color+N_OBJS),
              4*sizeof(float));
           glColor4fv(color1);
        }
        glNormal3f( (float)v->nx, (float)v->ny, (float)v->nz ) ;
        glVertex3f( (float)v->x , (float)v->y , (float)v->z  ) ;
        v = mc->vert(t->v2) ;
        if(v->color >= 0)
        {
           memcpy(color1, main_app::JavApp.getfCol(v->color+N_OBJS),
              4*sizeof(float));
           glColor4fv(color1);
        }
        glNormal3f( (float)v->nx, (float)v->ny, (float)v->nz ) ;
        glVertex3f( (float)v->x , (float)v->y , (float)v->z  ) ;
        v = mc->vert(t->v3) ;
        if(v->color >= 0)
        {
           memcpy(color1, main_app::JavApp.getfCol(v->color+N_OBJS),
              4*sizeof(float));
           glColor4fv(color1);
        }
        glNormal3f( (float)v->nx, (float)v->ny, (float)v->nz ) ;
        glVertex3f( (float)v->x , (float)v->y , (float)v->z  ) ;
      }
    }
    glEnd() ;
    }
    else
    {
    GLdouble *vertices = g_new0(GLdouble, 9*mc->ntrigs());
    GLdouble *normals  = g_new0(GLdouble, 9*mc->ntrigs());
    fromTrianglesToVertices(vertices, normals);
    glEnableClientState(GL_VERTEX_ARRAY);
    glEnableClientState(GL_NORMAL_ARRAY);
    glVertexPointer(3, GL_DOUBLE, 0, vertices);
    glNormalPointer(GL_DOUBLE, 0, normals);
    glDrawArrays(mode, 0, 3*mc->ntrigs());
    glDisableClientState(GL_VERTEX_ARRAY);
    glDisableClientState(GL_NORMAL_ARRAY);
    g_free(vertices);
    g_free(normals);
    }

    glLineWidth(1.0) ;
    glDepthMask (GL_TRUE);
    glDisable(GL_BLEND);
    glEnable (GL_LIGHTING);
}

void GLWindow::NormalizzasuMappa(int k, bool ifSurface)
{
  int i, j;
  std::vector<double> tvet, mini, maxi;
  float rx = Radius / Cell[0];
  float ry = Radius / Cell[1];
  float rz = Radius / Cell[2];
  double ccx = xyzC.x;
  double ccy = xyzC.y;
  double ccz = xyzC.z;

  vet3 v[8] = { {{ccx + rx, ccy - ry, ccz + rz}},
                {{ccx + rx, ccy + ry, ccz + rz}},
                {{ccx + rx, ccy - ry, ccz - rz}},
                {{ccx + rx, ccy + ry, ccz - rz}},
                {{ccx - rx, ccy - ry, ccz - rz}},
                {{ccx - rx, ccy + ry, ccz - rz}},
                {{ccx - rx, ccy - ry, ccz + rz}},
                {{ccx - rx, ccy + ry, ccz + rz}} };

  vet3 v1, v2;
  Mappa *mapinfo;
  if(ifSurface)
     mapinfo = &(VWSurface[k]);
  else
     mapinfo = &(MapInfo[k]);
  for(i=0; i<8; i++)
  {
      MRVectorCopy(v[i], &v1);
      MRVectorCopy(v[i], &(mapinfo->vf[i]));
      v2 = MRMatrix3MultiplyVector3(rmC, v1);
      MRVectorCopy(v2, &(v[i]));
      MRVectorCopy(v2, &(mapinfo->vn[i]));
  }
  if(!Normalized)
  {
     for(int i=0; i<8; i++)
     {
         tvet.push_back(mapinfo->vn[i].x);
         tvet.push_back(mapinfo->vn[i].y);
         tvet.push_back(mapinfo->vn[i].z);
     }
     maxi.push_back(*max_element(tvet.begin(), tvet.end()));
     mini.push_back(*min_element(tvet.begin(), tvet.end()));
     tvet.clear();
     for(j=0; j<3; j++)
         tvet.push_back(maxi[j]-mini[j]);
     double  delta0 = *max_element(tvet.begin(), tvet.end());
     tvet.clear();
     deltav = (float) delta0;
     calcolaO(mini, maxi);
  }
  mapinfo->vnN = Trasforma(mapinfo->vn[4]);
  for(i=0; i<8; i++)
      mapinfo->vmN[i] = Trasforma(mapinfo->vn[i]);
}

void GLWindow::RunMCAll()
{ 
  for(int i=0;  i<nMaps; i++)
  {
      if(MapInfo[i].mappa != NULL)
         MapInfo[i].RunMC(this, i);
      int kk = i;
      for(int nf=0; nf < MapInfo[i].ifDifference ; nf++)
      {
          MapInfo[kk].RunMC(this, kk);
          kk += MAX_NUM_MAPS;
      }
  }
  for(int i=0;  i<nModels; i++)
  {
      if(VWSurface[i].mappa != NULL)
         VWSurface[i].RunMC(this, i);
  }
} 
  
void GLWindow::RiNormalizzasuMappa()
{
//  Normalized = 0;
  for(int i=0;  i<nMaps; i++)
  {
      if(MapInfo[i].mappa == NULL)
         continue;
      MapInfo[i].CalcolaC();
      if(MapInfo[i].ifVis)        //tmp && !Normalized)
      {
         if(ifWhole)
            NormalizzasuCella();
         else
            NormalizzasuMappa(i);
         Normalized = 2;
//         break;
      }
  }
  for(int i=0;  i<nModels; i++)
  {
      if(VWSurface[i].mappa == NULL)
         continue;
      VWSurface[i].CalcolaC();
      if(VWSurface[i].ifVis)
         NormalizzasuMappa(i, true);
  }
}

void GLWindow::DrawMaps()
{
    for(int i=0; i<nMaps;i++)
    {
        if (MapInfo[i].ifVis)
        {
            MapInfo[i].DrawMap(this);
//            MapInfo[i].DrawCube(this);    // controllo mappa
            if(MapInfo[i].ifDifference > 1)      // DifferenceMap
               MapInfo[i+MAX_NUM_MAPS].DrawMap(this);
        }
    }
}

void GLWindow::DrawSurface(int k)
{
     VWSurface[k].DrawMap(this);
}

void freeSurface(int k)
{
     VWSurface[k].freeMap();
}

// Callbacks
static const char *radioname[] = {"Wireframe", "Fill", "Transparent", "Points"};
int nstyles = G_N_ELEMENTS(radioname);

#ifdef GTK_COLOR_BUTTON
void surfaceColor(GtkWidget *cb, GParamSpec *pspec, gpointer data)
#else
void surfaceColor(GtkWidget *cb, GtkStyle *style, gpointer data)
#endif
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int whichModel = GPOINTER_TO_INT(data);
   float light[4];
   color_button_get_color(cb, light);
   memcpy(VWSurface[whichModel].color_mappa, light, 4*sizeof(float));
   gl->Redraw ();
}

void surf_style_changed(GtkWidget *combo, int whichStyle)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int whichModel = get_int(combo, "whichModel");
   VWSurface[whichModel].wireframe = whichStyle;
   gl->Redraw ();
}

void surface_radius_changed(GtkWidget *spin, gpointer data)
{
   GtkWidget *dlg = gtk_widget_get_toplevel(spin);
   int whichModel = GPOINTER_TO_INT(data);
   float radius = (float) spin_button_get_value(spin);
   if(radius != VWSurface[whichModel].radius)
   {
      VWSurface[whichModel].radius = radius;
      RicalcolaSurface(whichModel, dlg);
   }
}

void surface_step_changed(GtkWidget *spin, gpointer data)
{
   GtkWidget *dlg = gtk_widget_get_toplevel(spin);
   int whichModel = GPOINTER_TO_INT(data);
   float step = (float) spin_button_get_value(spin);
   if(step != VWSurface[whichModel].step)
   {
      VWSurface[whichModel].step = step;
      RicalcolaSurface(whichModel, dlg);
   }
}

void surf_changed(GtkToggleButton *button, gpointer data)
{
      int whichModel = GPOINTER_TO_INT(data);
      int check = gtk_toggle_button_get_active(button);
      SettaSurface(whichModel, check);
}

void  add_surface_line(GtkWidget *parent, GtkWidget *father, int i, int row)
{
   std::stringstream suffix;
   suffix << i;
   std::string name;
   const float colore[] = {1, 1, 1, 1};

   name = "surface"  + suffix.str();
   GtkWidget *frame = NEW_FRAME(NULL, false);
   gtk_box_pack_start(GTK_BOX(parent), frame, TRUE, TRUE, 2);
   g_object_set_data(G_OBJECT(father), name.c_str(), frame);
   GtkWidget *box = vbox_new(FALSE, 0);
   gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), box);
   GtkWidget *check = CHECK_BUTTON_WITH_LABEL("Draw VanDerWaals Surface", NULL);
   g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_cb_attiva), box);
   gtk_frame_set_label_widget(GTK_FRAME(frame), check);
   name = "surfacecheck"  + suffix.str();
   g_object_set_data(G_OBJECT(father), name.c_str(), check);
   int hnd = g_signal_connect_after(G_OBJECT(check), "toggled", G_CALLBACK(surf_changed), GINT_TO_POINTER(i));
   g_object_set_data(G_OBJECT(check), "hnd", GINT_TO_POINTER(hnd));

   GtkWidget *table = table_new(2, 2, FALSE);
   table_set_row_spacings(table, 16);
#ifdef IN_GTK3
   table_set_col_spacings(table, 16);
#else
   table_set_col_spacings(table, 2);
#endif
   gtk_box_pack_start(GTK_BOX(box), table, FALSE, FALSE, 2);
   gtk_container_set_border_width(GTK_CONTAINER(table), 0);
   g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_cb_attiva), table);

   box = hbox_new(FALSE, 0);
   table_attach_exp(table, box, 0, 1, row, row+1);
   frame = gtk_label_new ("Style");
   set_alignment(frame, 0., 0.5);
   gtk_box_pack_start(GTK_BOX(box), frame, TRUE, TRUE, 0);
   GtkWidget *comboS = MRcombo_new(radioname, surf_style_changed,
   VWSurface[i].wireframe, nstyles);
#ifdef IN_GTK3
   GtkWidget *a = new_alignment(GTK_ALIGN_START, GTK_ALIGN_CENTER, 0, 0);
#else
   GtkWidget *a = gtk_alignment_new(0, 0.5, 0, 0);
#endif
   gtk_container_add(GTK_CONTAINER(a), comboS);
   gtk_box_pack_start(GTK_BOX(box), a, TRUE, TRUE, 4);
   g_object_set_data(G_OBJECT(comboS), "whichModel", GINT_TO_POINTER(i));
   name = "surfacestyle"  + suffix.str();
   g_object_set_data(G_OBJECT(father), name.c_str(), comboS);
   box = hbox_new(FALSE, 0);
   frame = gtk_label_new ("Color ");
   set_alignment(frame, 0., 0.5);
   gtk_box_pack_start(GTK_BOX(box), frame, TRUE, TRUE, 0);
   GtkWidget *cb = color_button(colore, "Pick a color to be used for draw surface");
   gtk_box_pack_start(GTK_BOX(box), cb, FALSE, FALSE, 4);
   table_attach_exp(table, box, 1, 2, row, row+1);
   name = "surfacecolor"  + suffix.str();
   g_object_set_data(G_OBJECT(father), name.c_str(), cb);
#ifdef GTK_COLOR_BUTTON
   g_signal_connect(G_OBJECT(cb), "notify::color", G_CALLBACK(surfaceColor), GINT_TO_POINTER(i));
#else
   g_signal_connect(G_OBJECT(cb), COLOR_CHANGED, G_CALLBACK(surfaceColor), GINT_TO_POINTER(i));
#endif
   row++;
   GtkWidget *spin = SPIN_WITH_LABEL("Surface radius ", NULL, 1.1, 5., 1.2, 0.1, 2);
   table_attach_exp(table, spin, 0, 1, row, row+1);
   name = "surfaceradius"  + suffix.str();
   g_object_set_data(G_OBJECT(father), name.c_str(), get_widget(spin, "spin"));
   hnd = g_signal_connect(G_OBJECT( get_widget(spin, "spin")), "value-changed", G_CALLBACK(surface_radius_changed), GINT_TO_POINTER(i));
   g_object_set_data(G_OBJECT(get_widget(spin, "spin")), "hnd", GINT_TO_POINTER(hnd));
   spin = SPIN_WITH_LABEL("Grid step ", NULL, 0.1, 0.8, 0.3, 0.01, 2);
   table_attach_exp(table, spin, 1, 2, row, row+1);
   name = "surfacestep"  + suffix.str();
   g_object_set_data(G_OBJECT(father), name.c_str(), get_widget(spin, "spin"));
   hnd = g_signal_connect(G_OBJECT( get_widget(spin, "spin")), "value-changed", G_CALLBACK(surface_step_changed), GINT_TO_POINTER(i));
   g_object_set_data(G_OBJECT(get_widget(spin, "spin")), "hnd", GINT_TO_POINTER(hnd));
   gtk_widget_set_sensitive(table, FALSE);
}

#ifdef IN_GTK3
GtkWidget *sigma_button(GtkWidget *father, const char *name)
{
    GtkWidget *hbox, *label, *entry;

    hbox = hbox_new(FALSE, 0);
    gtk_widget_set_vexpand(hbox, FALSE);
    gtk_widget_set_hexpand(hbox, FALSE);
    g_object_set(G_OBJECT(hbox), "halign", GTK_ALIGN_START, NULL);
    g_object_set(G_OBJECT(hbox), "valign", GTK_ALIGN_CENTER, NULL);
    gtk_container_set_border_width(GTK_CONTAINER(hbox), 2);
    label = gtk_label_new("Sigma: ");
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
    entry = spin_button_new_with_range(minSigma, 20, 0.1);
    spin_button_set_value(entry, 1.);
    spin_button_set_digits(entry, numDigits);
    set_width_chars(GTK_ENTRY(entry), numDigits+3);
    gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 2);
    g_object_set_data(G_OBJECT(hbox), "sigma", entry);
    g_object_set_data(G_OBJECT(father), name, entry);

    gtk_widget_show_all(hbox);
    return hbox;
}
#else
GtkWidget *sigma_button(GtkWidget *father, const char *name)
{
    GtkWidget *align, *hbox, *label, *entry, *align2;

    align = gtk_alignment_new(0.1f, 0.5f, 0, 0);
    hbox = hbox_new(FALSE, 0);
    gtk_container_add(GTK_CONTAINER(align), hbox);
    gtk_container_set_border_width(GTK_CONTAINER(hbox), 2);
    label = gtk_label_new("Sigma: ");
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
    align2 = gtk_alignment_new(0.1f, 0.5f, 0, 0);
    gtk_box_pack_start(GTK_BOX(hbox), align2, FALSE, FALSE, 2);
    entry = spin_button_new_with_range(minSigma, 20, 0.1);
    spin_button_set_value(entry, 1.);
    spin_button_set_digits(entry, numDigits);
    set_width_chars(GTK_ENTRY(entry), numDigits+3);
//    gtk_widget_set_size_request(entry, 75, 22);
    gtk_container_add(GTK_CONTAINER(align2), entry);
    g_object_set_data(G_OBJECT(align), "sigma", entry);
    g_object_set_data(G_OBJECT(father), name, entry);

    gtk_widget_show_all(hbox);
    return align;
}
#endif

void set_values_for_surface(int i, GtkWidget *father, GtkWidget *window, int abi)
{
    std::stringstream suffix;
    suffix << i;
    std::string name;

    name  = "surfacecheck" + suffix.str();
    GtkWidget *check = get_widget(father, name.c_str());
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), VWSurface[i].ifVis);
    gtk_widget_set_sensitive(check, abi);
    name  = "surfacecolor" + suffix.str();
    GtkWidget *cb = get_widget(father, name.c_str());
    color_button_set_color(cb, VWSurface[i].color_mappa);

    name = "surfacestyle" + suffix.str();
    cb = get_widget(father, name.c_str());
    MRcombo_set_val(cb, VWSurface[i].wireframe);

    name = "surfaceradius" + suffix.str();
    cb = get_widget(father, name.c_str());
    spin_button_set_value(cb, VWSurface[i].radius);
    name = "surfacestep" + suffix.str();
    cb = get_widget(father, name.c_str());
    spin_button_set_value(cb, VWSurface[i].step);

}

void set_values_for_map(int i, GtkWidget *father, GtkWidget *window)
{
//using namespace GLextmr;
    GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
    std::stringstream suffix;
    suffix << i;
    std::string name;

    name  = "vischeckm" + suffix.str();
    GtkWidget *check = get_widget(father, name.c_str());
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), MapInfo[i].ifVis);
    name = "actcheckm" + suffix.str();
    check = get_widget(father, name.c_str());
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check),  (gl->activeMap == i));
    name = "sigma" + suffix.str();
    GtkWidget *spin = get_widget(father, name.c_str());
    spin_button_set_range(spin, minSigma, MRmax(0.02, MapInfo[i].sigmaMax));
    spin_button_set_value(spin, MapInfo[i].iso/MapInfo[i].sigma);
    for(int nf=0; nf < MapInfo[i].ifDifference ; nf++)
    {
       std::stringstream suffix2;
       suffix2 << i+nf*MAX_NUM_MAPS;
       name  = "colorm" + suffix2.str();
       GtkWidget *cb = get_widget(father, name.c_str());
       color_button_set_color(cb, MapInfo[i+nf*MAX_NUM_MAPS].color_mappa);

       name = "wire" + suffix2.str();
       cb = get_widget(father, name.c_str());
       MRcombo_set_val(cb, MapInfo[i+nf].wireframe);
    }
}

void sigma_changed(GtkWidget *button, gpointer data)
{
      GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
      int whichMap = GPOINTER_TO_INT(data);
      if( MapInfo[whichMap].ifDifference == 3 )
          return;
      myreal val = (myreal) spin_button_get_value(button);
      myreal iso = MapInfo[whichMap].sigma * val;
      for(int nf=0; nf < MapInfo[whichMap].ifDifference ; nf++)
          MapInfo[whichMap+nf*MAX_NUM_MAPS].iso = iso;

      if(whichMap == gl->activeMap)
      {
          gpointer entry = get_object(GLWINDOW, "Sigma");
          if(entry != NULL)
          {
             int hnd = get_int(GTK_WIDGET(entry), "hnd");
             g_signal_handler_block(G_OBJECT(entry), hnd);
             gtk_range_set_value(GTK_RANGE(entry), val);
             g_signal_handler_unblock(G_OBJECT(entry), hnd);
          }
      }
      gl->RiNormalizza();
      gl->Redraw ();
}

void mapvis_changed(GtkToggleButton *button, gpointer data)
{
      GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
      int whichMap = GPOINTER_TO_INT(data);
      if( MapInfo[whichMap].ifDifference == 3 )
          return;
      int check = gtk_toggle_button_get_active(button);
      for(int nf=0; nf < MapInfo[whichMap].ifDifference ; nf++)
          MapInfo[whichMap+nf*MAX_NUM_MAPS].ifVis = (check != 0);
      gl->RiNormalizza();
      gl->Redraw ();
}

void update_sigma_button(GtkWidget *dlg, int whichMap)
{
     std::string name;
     std::stringstream suffix;
     suffix << whichMap;
     name  = "sigma" + suffix.str(); 
     if(g_object_get_data(G_OBJECT(dlg), name.c_str()))
     {
        GtkWidget *sb = get_widget(dlg, name.c_str());
        myreal val = (myreal) spin_button_get_value (sb);
        gpointer entry = get_object(GLWINDOW, "Sigma");
        if(entry != NULL)
        {
           int hnd = get_int(GTK_WIDGET(entry), "hnd");
           g_signal_handler_block(G_OBJECT(entry), hnd);
           gtk_range_set_value(GTK_RANGE(entry), val);
           g_signal_handler_unblock(G_OBJECT(entry), hnd);
        }
     }
}

void active_changed(GtkToggleButton *button, gpointer data)
{
      GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
      int whichMap = GPOINTER_TO_INT(data);
      if((whichMap < 0) || (whichMap > gl->nMaps))
          return;
      if( MapInfo[whichMap].ifDifference == 3 )
          return;
      if(gtk_toggle_button_get_active(button))
      {
         gl->activeMap = whichMap;
         GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
         update_sigma_button(dlg, whichMap);
#ifdef JAV
         gl->UpdateTitle();
#endif
         gl->RiNormalizza();
         gl->Redraw ();
      }
}

#ifdef GTK_COLOR_BUTTON
void mapColor_changed(GtkWidget *cb, gpointer data)
#else
void mapColor_changed(GtkWidget *cb, GtkStyle *style, gpointer data)
#endif
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int whichMap = GPOINTER_TO_INT(data);
   float colore[4];
   color_button_get_color(cb, colore);
   for(int i=0; i<4; i++)
       MapInfo[whichMap].color_mappa[i] = colore[i];
   gl->RiNormalizza();
   gl->Redraw ();
}

void map_style_changed(GtkWidget *combo, int whichStyle)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int whichMap = get_int(combo, "whichMap");
   MapInfo[whichMap].wireframe = whichStyle;
   gl->RiNormalizza();
   gl->Redraw ();
}

void block_handlers_for_maps(int i, GtkWidget *father)
{
    std::stringstream suffix;
    suffix << i;
    std::string name;

    name  = "vischeckm" + suffix.str();
    GtkWidget *check = get_widget(father, name.c_str());
    int hnd = get_int(check, "hnd");
    g_signal_handler_block (G_OBJECT (check), hnd);
    name = "actcheckm" + suffix.str();
    check = get_widget(father, name.c_str());
    hnd = get_int(check, "hnd");
    g_signal_handler_block (G_OBJECT (check), hnd);
    name = "sigma" + suffix.str();
    GtkWidget *spin = get_widget(father, name.c_str());
    hnd = get_int(spin, "hnd");
    g_signal_handler_block (G_OBJECT (spin), hnd);
    for(int nf=0; nf < MapInfo[i].ifDifference ; nf++)
    {
        std::stringstream suffix2;
        suffix2 << i+nf*MAX_NUM_MAPS;
        name  = "colorm" + suffix2.str();
        GtkWidget *cb = get_widget(father, name.c_str());
        hnd = get_int(cb, "hnd");
        g_signal_handler_block (G_OBJECT (cb), hnd);
        name = "wire" + suffix2.str();
        cb = get_widget(father, name.c_str());
        hnd = get_int(cb, "hnd");
        g_signal_handler_block (G_OBJECT (cb), hnd);
    }
}

void unblock_handlers_for_maps(int i, GtkWidget *father)
{
    std::stringstream suffix;
    suffix << i;
    std::string name;

    name  = "vischeckm" + suffix.str();
    GtkWidget *check = get_widget(father, name.c_str());
    int hnd = get_int(check, "hnd");
    g_signal_handler_unblock (G_OBJECT (check), hnd);
    name = "actcheckm" + suffix.str();
    check = get_widget(father, name.c_str());
    hnd = get_int(check, "hnd");
    g_signal_handler_unblock (G_OBJECT (check), hnd);
    name = "sigma" + suffix.str();
    GtkWidget *spin = get_widget(father, name.c_str());
    hnd = get_int(spin, "hnd");
    g_signal_handler_unblock (G_OBJECT (spin), hnd);
    for(int nf=0; nf < MapInfo[i].ifDifference ; nf++)
    {
        std::stringstream suffix2;
        suffix2 << i+nf*MAX_NUM_MAPS;
        name  = "colorm" + suffix2.str();
        GtkWidget *cb = get_widget(father, name.c_str());
        hnd = get_int(cb, "hnd");
        g_signal_handler_unblock (G_OBJECT (cb), hnd);
        name = "wire" + suffix2.str();
        cb = get_widget(father, name.c_str());
        hnd = get_int(cb, "hnd");
        g_signal_handler_unblock (G_OBJECT (cb), hnd);
    }
}

void add_map(GtkWidget *window, int i, int k, GtkWidget *father, GtkWidget *parent,
             bool b=false)
{
    GtkWidget *frame, *check, *check2;
    int hnd;
    GSList *radio_group = (GSList *) g_object_get_data(G_OBJECT(father), "radio_group");

    std::stringstream suffix;
    suffix << i;

    frame = NEW_FRAME(NULL, false);
//    gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_NONE);
    gtk_box_pack_start(GTK_BOX(parent), frame, FALSE, FALSE, 2);
    gtk_container_set_border_width(GTK_CONTAINER(frame), 4);
    GtkWidget *box = table_new(2, 5, FALSE);
#ifdef GTK_GRID
    gtk_grid_set_row_homogeneous(GTK_GRID(box), TRUE);
#endif
    gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), box);
    table_set_col_spacings(box, 6);
    table_set_row_spacings(box, 6);
//    gtk_container_set_border_width(GTK_CONTAINER(box), 10);

    check = CHECK_BUTTON_WITH_LABEL(
          g_strdup_printf("Visualize Map: %s", MapInfo[i].name), MyBLUE, 0);
    g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_cb_attiva), box);
    gtk_frame_set_label_widget(GTK_FRAME(frame), check);
    check2 = RADIO_BUTTON_WITH_LABEL (radio_group, "_Active", NULL);
    radio_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (check2));
    g_object_set_data(G_OBJECT(father), "radio_group", radio_group);
    table_attach(box, check2, 0, 1, 0, 1);
    g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_cb_attiva), check2);

    hnd = g_signal_connect_after(G_OBJECT(check), "toggled", G_CALLBACK(mapvis_changed), GINT_TO_POINTER(i));
    g_object_set_data(G_OBJECT(check), "hnd", GINT_TO_POINTER(hnd));
    hnd = g_signal_connect(G_OBJECT(check2), "toggled", G_CALLBACK(active_changed), GINT_TO_POINTER(i));
    g_object_set_data(G_OBJECT(check2), "hnd", GINT_TO_POINTER(hnd));
    std::string name, name2;
    name  = "vischeckm" + suffix.str();
    name2 = "actcheckm" + suffix.str();
    g_object_set_data(G_OBJECT(father), name.c_str(), check);
    g_object_set_data(G_OBJECT(father), name2.c_str(), check2);

    name  = "sigma" + suffix.str();
    GtkWidget *sb = sigma_button(father, name.c_str());
    gtk_container_set_border_width(GTK_CONTAINER(sb), 4);
    table_attach(box, sb, 1, 2, 0, 1);
    hnd = g_signal_connect(G_OBJECT(get_widget(sb,"sigma")), "value-changed", G_CALLBACK(sigma_changed), GINT_TO_POINTER(i));
    g_object_set_data(G_OBJECT(get_widget(sb,"sigma")), "hnd", GINT_TO_POINTER(hnd));

    const char *app[] = { " (positive)", " (negative)"};
    const float colore[] = {1, 1, 1, 1};
    for(int nf=0; nf < MapInfo[i].ifDifference ; nf++)
    {
        std::stringstream suffix2;
        suffix2 << i+nf*MAX_NUM_MAPS;
        std::string title = "Style";
        if( MapInfo[i+nf*MAX_NUM_MAPS].ifDifference >1)
            title.append(app[nf]);
        frame = gtk_label_new (title.c_str());
        set_alignment(frame, 0., 0.5);
        table_attach(box, frame, 2, 3, nf, nf+1);
        GtkWidget *comboS = MRcombo_new(radioname, map_style_changed,
        MapInfo[i].wireframe, 3);
#ifdef IN_GTK3
        GtkWidget *a = new_alignment(GTK_ALIGN_START, GTK_ALIGN_CENTER, 0, 0);
#else
        GtkWidget *a = gtk_alignment_new(0, 0.5, 0, 0);
#endif
        gtk_container_add(GTK_CONTAINER(a), comboS);
        table_attach(box, a, 3, 4, nf, nf+1);
        name = "wire" + suffix2.str();
        g_object_set_data(G_OBJECT(comboS), "whichMap",
             GINT_TO_POINTER(i+nf*MAX_NUM_MAPS));
        g_object_set_data(G_OBJECT(father), name.c_str(), comboS);
        name  = "colorm" + suffix2.str();
        GtkWidget *cb = color_button(colore, "Pick a color to be used for draw map");
#ifdef IN_GTK3
        a = new_alignment(GTK_ALIGN_START, GTK_ALIGN_CENTER, 0, 0);
#else
        a = gtk_alignment_new(0, 0.5, 0, 0);
#endif
        gtk_container_add(GTK_CONTAINER(a), cb);
        table_attach(box, a, 4, 5, nf, nf+1);
        g_object_set_data(G_OBJECT(father), name.c_str(), cb);
#ifdef GTK_COLOR_BUTTON
        hnd = g_signal_connect(G_OBJECT(cb), "color-set", G_CALLBACK(mapColor_changed), GINT_TO_POINTER(i+nf*MAX_NUM_MAPS));
#else
        hnd = g_signal_connect(G_OBJECT(cb), COLOR_CHANGED, G_CALLBACK(mapColor_changed), GINT_TO_POINTER(i+nf*MAX_NUM_MAPS));
#endif
        g_object_set_data(G_OBJECT(cb), "hnd", GINT_TO_POINTER(hnd));
    }
    gtk_widget_show_all(father);
    if(b)
      block_handlers_for_maps(i, father);
    set_values_for_map(i, father, window);
    if(b)
      unblock_handlers_for_maps(i, father);
}

void map_settings(GtkWidget *window, GtkWidget *dlg, GtkWidget *vbox, bool b)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   int i, k = 0;
   GSList *radio_group = NULL;

   GtkWidget *vbox1 = vbox_new(FALSE, 0);
   GtkWidget *frame = NEW_FRAME(NULL);
   gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 0);
   gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), vbox1);
#ifdef IN_GTK3
   g_object_set(G_OBJECT(get_widget(frame, "align")), "valign", GTK_ALIGN_CENTER, NULL);
   gtk_widget_set_vexpand(get_widget(frame, "align"), TRUE);
#endif
   g_object_set_data(G_OBJECT(dlg), "frame_maps", vbox1);
   g_object_set_data(G_OBJECT(dlg), "radio_group", radio_group);
   for(i=0; i<gl->nMaps; i++)
   {
       if( MapInfo[i].ifDifference == 3 )          // Parte negativa
           continue;                               // non visualizzo
       k++;
       add_map(window, i, k, dlg, vbox1, b);
   }
   show_dialog(window, dlg);
}

void update_sigma_value(GtkWidget *dlg, GtkWidget *window)
{
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
     if((gl->activeMap < 0) || (gl->activeMap > gl->nMaps))
          return;
     std::string name;
     std::stringstream suffix;
     suffix << gl->activeMap;
     name  = "sigma" + suffix.str();
     if(g_object_get_data(G_OBJECT(dlg), name.c_str()))
     {
        GtkWidget *sb = get_widget(dlg, name.c_str());
        int hnd = get_int(sb, "hnd");
        g_signal_handler_block(G_OBJECT(sb), hnd);
        spin_button_set_value (sb,
            MapInfo[gl->activeMap].iso/MapInfo[gl->activeMap].sigma);
        g_signal_handler_unblock(G_OBJECT(sb), hnd);
     }
}

void on_sigma(GtkWidget *button, gpointer data)
{
     GtkWidget *window = (GtkWidget *) data;
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
     if((gl->activeMap < 0) || (gl->activeMap > gl->nMaps))
          return;
     MapInfo[gl->activeMap].iso = MapInfo[gl->activeMap].sigma * (myreal) gtk_range_get_value(GTK_RANGE(button));
     if((MapInfo[gl->activeMap].ifDifference == 2) && (MapInfo[gl->activeMap+MAX_NUM_MAPS].created))
        MapInfo[gl->activeMap+MAX_NUM_MAPS].iso = MapInfo[gl->activeMap+MAX_NUM_MAPS].sigma * (myreal) gtk_range_get_value(GTK_RANGE(button));
     if(g_object_get_data(G_OBJECT(window), SettingsWindow))
     {
        GtkWidget *dlg = get_widget(window, SettingsWindow);
        update_sigma_value(dlg, window);
     }
     MapInfo[gl->activeMap].RunMC(gl, gl->activeMap);
     if((MapInfo[gl->activeMap].ifDifference == 2) && (MapInfo[gl->activeMap+MAX_NUM_MAPS].created))
        MapInfo[gl->activeMap+MAX_NUM_MAPS].RunMC(gl, gl->activeMap+MAX_NUM_MAPS);
     gl->Redraw();
}

void update_maps(GtkWidget *father, GtkWidget *window)
{
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
     if(g_object_get_data(G_OBJECT(father), "frame_maps"))
     {
        GtkWidget *parent = get_widget(father, "frame_maps");
        int k = get_int(father, "lastk") + 1;
        int i = gl->nMaps - 1;
        add_map(window, i, k, father, parent);
        show_dialog(window, father);
     }
     else
     {
        GtkWidget *vbox = get_widget(father, "box_centre");
        centre_settings(window, father, vbox);
        vbox = get_widget(father, "box_maps");
        map_settings(window, father, vbox);
        show_dialog(window, father);
     }
#ifdef JAV
     gl->UpdateTitle();
#endif
}

void rewrite_maps(GtkWidget *father, GtkWidget *window)
{
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
     if(g_object_get_data(G_OBJECT(father), "frame_maps"))
     {
        GtkWidget *parent = get_widget(father, "frame_maps");
        remove_children(parent);
        g_object_set_data(G_OBJECT(father), "radio_group", NULL);
        int k = 0;
        for(int i=0; i<gl->nMaps; i++)
        {
            if( MapInfo[i].ifDifference == 3 )          // Parte negativa
                 continue;                               // non visualizzo
            k++;
            add_map(window, i, k, father, parent);
        }
        show_dialog(window, father);
     }
     set_values_for_centre(father, window);
#ifdef JAV
     gl->UpdateTitle();
#endif
}

void set_values_for_centre(GtkWidget *father, GtkWidget *window)
{
    GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");

    GtkWidget *spin = get_widget(father, "radius");
    spin_button_set_value (spin, gl->Radius);
    GtkWidget *frame = get_widget(father, "frameradius");
    gtk_widget_set_sensitive(frame, !gl->ifWhole && gl->nMaps);

    GtkWidget *check = get_widget(father, "whm");
    gtk_widget_set_sensitive(check, gl->nMaps);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), gl->ifWhole && gl->nMaps);
    for(int j=0; j<3; j++)
    {
        std::stringstream suff2;
        std::string name;
        suff2 << j + 1;
        name = "xc" + suff2.str();
        spin  = get_widget(father, name.c_str());
        spin_button_set_value (spin, gl->xyzC.v[j]);
        centroMappa[j] = (float) gl->xyzC.v[j];
    }
}

void update_center()
{
     if(g_object_get_data(G_OBJECT(GLWINDOW), SettingsWindow))
     {
        GtkWidget *dlg = get_widget(GLWINDOW, SettingsWindow);
        set_values_for_centre(dlg, GLWINDOW);
     }
}

void radius_changed (GtkWidget *button, gpointer data)
{
   GLWindow *gl = (GLWindow *) data;
   gl->Radius = (float) spin_button_get_value(button);
//         raggioMappa = gl->Radius;
   for(int i=0; i<gl->nMaps; i++)
       MapInfo[i].FromRadTorad(gl);
   gl->RiNormalizza();
   gl->Redraw ();
}

void center_changed (GtkWidget *button, gpointer data)
{
   GLWindow *gl = (GLWindow *) data;
   GtkWidget *dlg = gtk_widget_get_toplevel(button);
   gl->ifWhole = (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(button)) != 0);
   if(!gl->ifWhole)
   {
       for(int j=0; j<3; j++)
           gl->xyzC.v[j] = (float) centroMappa[j];
       GtkWidget *spin = get_widget(dlg, "radius");
       radius_changed(spin, data);
   }
   else
   {
       gl->xyzC.x = gl->xyzC.y = gl->xyzC.z =0.5;
       gl->RiNormalizza();
       gl->Redraw ();
   }
}

void ccoord_changed (GtkWidget *button, gpointer data)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int j = GPOINTER_TO_INT(data);
   gl->xyzC.v[j] = (float) spin_button_get_value(button);
   for(int i=0; i<3; i++)
       centroMappa[i] = (float)gl->xyzC.v[i];
   gl->RiNormalizza();
   gl->Redraw ();
}

void block_handlers_for_centre(GtkWidget *father)
{
  GtkWidget *check = get_widget(father, "whm");
  int hnd = get_int(check, "hnd");
  g_signal_handler_block (G_OBJECT (check), hnd);
  GtkWidget *spin = get_widget(father, "radius");
  hnd = get_int(spin, "hnd");
  g_signal_handler_block (G_OBJECT (spin), hnd);
  for(int j=0; j<3; j++)
  {
      std::stringstream suff2;
      std::string name;
      suff2 << j + 1;
      name = "xc" + suff2.str();
      spin = get_widget(father, name.c_str());
      hnd = get_int(spin, "hnd");
      g_signal_handler_block (G_OBJECT (spin), hnd);
  }
}

void unblock_handlers_for_centre(GtkWidget *father)
{
  GtkWidget *check = get_widget(father, "whm");
  int hnd = get_int(check, "hnd");
  g_signal_handler_unblock (G_OBJECT (check), hnd);
  GtkWidget *spin = get_widget(father, "radius");
  hnd = get_int(spin, "hnd");
  g_signal_handler_unblock (G_OBJECT (spin), hnd);
  for(int j=0; j<3; j++)
  {
      std::stringstream suff2;
      std::string name;
      suff2 << j + 1;
      name = "xc" + suff2.str();
      spin = get_widget(father, name.c_str());
      hnd = get_int(spin, "hnd");
      g_signal_handler_unblock (G_OBJECT (spin), hnd);
  }
}

void centre_settings(GtkWidget *window, GtkWidget *dlg, GtkWidget *vboxx, bool b)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   if(g_object_get_data(G_OBJECT(dlg), "framecentre") == NULL)
   {
      GtkWidget *table = table_new(3, 5, FALSE);
      gtk_box_pack_start(GTK_BOX(vboxx), table, FALSE, FALSE, 0);
      g_object_set_data(G_OBJECT(dlg), "framecentre", table);
      table_set_row_spacings(table, 10);
      GtkWidget *check = CHECK_BUTTON_WITH_LABEL ("Fill unit cell", NULL);
      if(CellVolume(gl->Cell) <= limVol)
         table_attach(table, check, 0, 2, 0, 1);
      g_object_set_data(G_OBJECT(dlg), "whm", check);

      GtkWidget *radspin  = SPIN_WITH_LABEL("Map radius ", NULL, 1., 100., 5., 1., 2);
      g_object_set_data(G_OBJECT(dlg), "radius", get_widget(radspin, "spin"));
      set_width_chars (GTK_ENTRY (get_widget(radspin, "spin")), 5);
      int hnd = g_signal_connect(G_OBJECT( get_widget(radspin, "spin")), "value-changed", G_CALLBACK(radius_changed), (gpointer) gl);
      g_object_set_data(G_OBJECT(get_widget(radspin, "spin")), "hnd", GINT_TO_POINTER(hnd));
//      gtk_container_set_border_width(GTK_CONTAINER(radspin), 4);
      table_attach(table, radspin, 0, 2, 1, 2);
      g_object_set_data(G_OBJECT(dlg), "frameradius", radspin);
      g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_cb_disattiva), radspin);

#ifdef IN_GTK3
      GtkWidget *align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_CENTER, 0, 0);
#else
      GtkWidget *align = gtk_alignment_new(0, 0.5, 0, 0);
#endif
      g_object_set_data(G_OBJECT(dlg), "framecentre", align);
      g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_cb_disattiva),
              align);
      hnd = g_signal_connect_after(G_OBJECT(check), "toggled", G_CALLBACK(center_changed), (gpointer) gl);
      g_object_set_data(G_OBJECT(check), "hnd", GINT_TO_POINTER(hnd));
      GtkWidget *button = myimage_button("Select Centre", "mirino.png");
      set_tip(button, "Click on an atom to select it as centre");
      table_attach(table, button, 4, 5, 2, 3);
      g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(on_clickselect),
              (gpointer) window);
      GtkWidget *hbox = hbox_new(FALSE, 0);
      gtk_container_add (GTK_CONTAINER (align), hbox);
//      gtk_container_set_border_width(GTK_CONTAINER(hbox), 4);
      table_attach(table, align, 0, 4, 2, 3);
      GtkWidget *frame = LABEL_NEW("Centre coordinates", NULL);
      gtk_box_pack_start(GTK_BOX(hbox), frame, FALSE, FALSE, 0);
      set_alignment(frame, 0., 0.5);
      for(int j=0; j<3; j++)
      {
          std::stringstream suff2;
          std::string name;
          suff2 << j + 1;
          name = "xc" + suff2.str();
          GtkWidget *spin  = spin_button_new_with_range(-1., 2., 0.01);
          spin_button_set_digits(spin, 2);
          spin_button_set_value (spin, gl->xyzC.v[j]);
//          gtk_widget_set_size_request(spin, 60, -1);
          set_width_chars (GTK_ENTRY (spin), 5);
          g_object_set_data(G_OBJECT(dlg), name.c_str(), spin);
          gtk_box_pack_start(GTK_BOX(hbox), spin, FALSE, FALSE, 4);
          hnd = g_signal_connect(G_OBJECT(spin), "value-changed", G_CALLBACK(ccoord_changed), GINT_TO_POINTER(j));
          g_object_set_data(G_OBJECT(spin), "hnd", GINT_TO_POINTER(hnd));
      }
   }
   if(b)
      block_handlers_for_centre(dlg);
   set_values_for_centre(dlg, window);
   if(b)
      unblock_handlers_for_centre(dlg);
}
void Oldcentre_settings(GtkWidget *window, GtkWidget *dlg, GtkWidget *vboxx, bool b)
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   int j;

   if(g_object_get_data(G_OBJECT(dlg), "framedicomodo") == NULL)
   {
#ifdef JAV
      GtkWidget *framedicomodo = NEW_FRAME(NULL, true);
#else
      GtkWidget *framedicomodo = NEW_FRAME(NULL);
#endif
      GtkWidget *hboxx = hbox_new(FALSE,0);
      GtkWidget *label = LABEL_BOLD("Centre", MyBLUE, 1);
      gtk_box_pack_start(GTK_BOX(hboxx), label, FALSE, FALSE, 0);
#ifdef JAV
      label = create_image("target.png");
      gtk_box_pack_start(GTK_BOX(hboxx), label, FALSE, FALSE, 10);
#endif
      gtk_frame_set_label_widget(GTK_FRAME(framedicomodo), hboxx);
      gtk_box_pack_start(GTK_BOX(vboxx), framedicomodo, FALSE, FALSE, 0);
      g_object_set_data(G_OBJECT(dlg), "framedicomodo", framedicomodo);
      GtkWidget *vbox = hbox_new(FALSE, 0);
      gtk_container_add(GTK_CONTAINER(get_widget(framedicomodo,"align")), vbox);
      GtkWidget *check = CHECK_BUTTON_WITH_LABEL ("Fill unit cell", NULL);
      if(CellVolume(gl->Cell) <= limVol)
         gtk_box_pack_start(GTK_BOX(vbox), check, FALSE, FALSE, 4);
      gtk_container_set_border_width(GTK_CONTAINER(check), 2);
      g_object_set_data(G_OBJECT(dlg), "whm", check);

      GtkWidget *radspin  = SPIN_WITH_LABEL("Map radius ", NULL, 1., 100., 5., 1., 2);
      g_object_set_data(G_OBJECT(dlg), "radius", get_widget(radspin, "spin"));
      set_width_chars (GTK_ENTRY (get_widget(radspin, "spin")), 5);
      int hnd = g_signal_connect(G_OBJECT( get_widget(radspin, "spin")), "value-changed", G_CALLBACK(radius_changed), (gpointer) gl);
      g_object_set_data(G_OBJECT(get_widget(radspin, "spin")), "hnd", GINT_TO_POINTER(hnd));
      gtk_container_set_border_width(GTK_CONTAINER(radspin), 4);
      gtk_box_pack_start(GTK_BOX(vbox), radspin, FALSE, FALSE, 4);
      g_object_set_data(G_OBJECT(dlg), "frameradius", radspin);
      g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_cb_disattiva), radspin);

      GtkWidget *frame = gtk_frame_new(NULL); //FRAME_NEW ("Centre coordinates", "blue");
      gtk_frame_set_shadow_type(GTK_FRAME(frame), GTK_SHADOW_NONE);
#ifdef IN_GTK3
      GtkWidget *align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_CENTER, 0, 0);
#else
      GtkWidget *align = gtk_alignment_new(0, 0.5, 0, 0);
#endif
      gtk_box_pack_start(GTK_BOX(vbox), align, FALSE, FALSE, 4);
      gtk_container_add(GTK_CONTAINER(align), frame);
      g_object_set_data(G_OBJECT(dlg), "framecentre", frame);
      g_signal_connect(G_OBJECT(check), "toggled", G_CALLBACK(on_cb_disattiva), get_widget(dlg, "framecentre"));
      hnd = g_signal_connect_after(G_OBJECT(check), "toggled", G_CALLBACK(center_changed), (gpointer) gl);
      g_object_set_data(G_OBJECT(check), "hnd", GINT_TO_POINTER(hnd));
      GtkWidget *hbox = hbox_new(FALSE, 0);
      gtk_container_add (GTK_CONTAINER (frame), hbox);
      gtk_container_set_border_width(GTK_CONTAINER(hbox), 4);

      frame = LABEL_NEW("Centre coordinates", NULL);
      gtk_box_pack_start(GTK_BOX(hbox), frame, FALSE, FALSE, 4);
      set_alignment(frame, 0., 0.5);
      for(j=0; j<3; j++)
      {
          std::stringstream suff2;
          std::string name;
          suff2 << j + 1;
          name = "xc" + suff2.str();
          GtkWidget *spin  = spin_button_new_with_range(-1., 2., 0.01);
          spin_button_set_digits(spin, 2);
          spin_button_set_value (spin, gl->xyzC.v[j]);
//          gtk_widget_set_size_request(spin, 60, -1);
          set_width_chars (GTK_ENTRY (spin), 5);
          g_object_set_data(G_OBJECT(dlg), name.c_str(), spin);
          gtk_box_pack_start(GTK_BOX(hbox), spin, FALSE, FALSE, 4);
          hnd = g_signal_connect(G_OBJECT(spin), "value-changed", G_CALLBACK(ccoord_changed), GINT_TO_POINTER(j));
          g_object_set_data(G_OBJECT(spin), "hnd", GINT_TO_POINTER(hnd));
      }
   }
   if(b)
      block_handlers_for_centre(dlg);
   set_values_for_centre(dlg, window);
   if(b)
      unblock_handlers_for_centre(dlg);
}

void fillInfo_for_map(GtkWidget *parent, int kmap)
{

   std::stringstream label_string;
   GtkWidget *frame = gtk_frame_new(NULL);
   gtk_box_pack_start(GTK_BOX(parent), frame, TRUE, TRUE, 2);
   gtk_container_set_border_width(GTK_CONTAINER(frame), 4);
   GtkWidget *box = vbox_new(FALSE, 0);
   gtk_container_add (GTK_CONTAINER (frame), box);
   gtk_container_set_border_width(GTK_CONTAINER(box), 2);
   GtkWidget *hbox = hbox_new(TRUE, 0);
   gtk_box_pack_start(GTK_BOX(box), hbox, TRUE, TRUE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(frame), 2);

   GtkWidget *label = LABEL_BOLD (
             g_strdup_printf("Map n. %d: %s", kmap+1, MapInfo[kmap].name), "red", 1.2f, 0);
   gtk_frame_set_label_widget(GTK_FRAME(frame), label);
   init_string(label_string, "Fourier map grid points:");
   label_string << MapInfo[kmap].size_x << " " << MapInfo[kmap].size_y << " " << MapInfo[kmap].size_z;
   init_string(label_string, "Minimum:", 3);
   label_string << MapInfo[kmap].minimum;
   init_string(label_string, "Maximum:", 3);
   label_string << MapInfo[kmap].maximum;
   init_string(label_string, "Mean:   ", 3);
   label_string << MapInfo[kmap].mean;
   init_string(label_string, "Sigma:  ", 3);
   label_string << MapInfo[kmap].sigma;
   add_label(label_string.str().c_str(), hbox);
   if( MapInfo[kmap].nrefl)
   {
       init_string(label_string, "Resolution:");
       label_string << MapInfo[kmap].resm ;
       init_string(label_string, "Number of reflections:", 0);
       label_string << MapInfo[kmap].nrefl ;
       add_label(label_string.str().c_str(), hbox);
   }
}

void update_map_info(GtkWidget *father, GtkWidget *window)
{
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
     GtkWidget *parent = get_widget(father, "box_maps");
     int i = gl->nMaps - 1;
     fillInfo_for_map(parent, i);
     gtk_widget_show_all(father);
}

void rewrite_map_info(GtkWidget *father, GtkWidget *window)
{
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
     GtkWidget *parent = get_widget(father, "box_maps");
     remove_children(parent);
     for(int i=0; i<gl->nMaps; i++)
         fillInfo_for_map(parent, i);
     gtk_widget_show_all(father);
}

void update_infos_map(int ifDelete)
{
     if(g_object_get_data(G_OBJECT(GLWINDOW), SettingsWindow))
     {
        GtkWidget *dlg = get_widget(GLWINDOW, SettingsWindow);
        if(ifDelete)
           rewrite_maps(dlg, GLWINDOW);
        else
           update_maps(dlg, GLWINDOW);
     }
     if(g_object_get_data(G_OBJECT(GLWINDOW), InfoWindow))
     {
        GtkWidget *dlg = get_widget(GLWINDOW, InfoWindow);
        if(ifDelete)
           rewrite_map_info(dlg, GLWINDOW);
        else
           update_map_info(dlg, GLWINDOW);
     }
     if(g_object_get_data(G_OBJECT(GLWINDOW), MapInfoWindow))
     {
        GtkWidget *dlg = get_widget(GLWINDOW, MapInfoWindow);
        if(ifDelete)
           rewrite_map_info(dlg, GLWINDOW);
        else
           update_map_info(dlg, GLWINDOW);
     }
}

void PrintMapInfo(gpointer,  gpointer data)
{
using namespace gtkext;
   int i;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");

   if( gl->nMaps == 0) 
   {
      dlg_errmsg(GTK_WINDOW(window), "Sorry. No maps available.");
      return;
   }

   if(g_object_get_data(G_OBJECT(window), MapInfoWindow))
   {
      GtkWidget *dlg = get_widget(window, MapInfoWindow);
      gdk_window_raise(gtk_widget_get_window(dlg));
      return;
   }

   GtkWidget *dlg = gtk_dialog_new();
   gtk_container_set_border_width (GTK_CONTAINER (dlg), 4);
   gtk_window_set_title (GTK_WINDOW (dlg), "Info");
   g_object_set_data(G_OBJECT(window), MapInfoWindow, dlg);

   GtkWidget *scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
   gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), scrolledwindow1, TRUE, TRUE, 0);
   gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 4);
   gtk_widget_set_size_request(scrolledwindow1, -1, 300);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
        GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

   GtkWidget *viewport = gtk_viewport_new(NULL, NULL);
   gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport);
   widget_modify_bg(viewport, GTK_STATE_NORMAL, &colorWhite);

   GtkWidget *vbox = vbox_new(FALSE, 0);
   gtk_container_add (GTK_CONTAINER (viewport), vbox);
   gtk_container_set_border_width(GTK_CONTAINER(vbox), 5);

   GtkWidget *frame = FRAME_BOLD ("Cell and Symmetry", "red", 1.2f);
   gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 4);
   g_object_set_data(G_OBJECT(dlg), "box_cell", frame);
   GtkWidget *hbox = hbox_new(TRUE, 0);
   gtk_container_add(GTK_CONTAINER(frame), hbox);
   gtk_container_set_border_width(GTK_CONTAINER(frame), 2);
   std::stringstream label_string;
   init_string(label_string, "Cell Parameters:");
   label_string << gl->Cell[0] << " " << gl->Cell[1]   << " " << gl->Cell[2] 
                << "\n   " << gl->Cell[3]<< " " << gl->Cell[4]<< " " << gl->Cell[5];
   init_string(label_string, "Cell Volume:", 0);
   label_string  << CellVolume(gl->Cell);
   GtkWidget *label = add_label(label_string.str().c_str(), hbox);
   g_object_set_data(G_OBJECT(frame), "cellp", label);

   init_string(label_string, "Space group:");
   if(str_white (gl->sy.spg))
      label_string << "n.a." << "\n" ;
   else
      label_string << gl->sy.spg << "\n" ;
   init_string(label_string, "Number of symm. operators:", 0);
   label_string  << gl->sy.nsymop;
   label = add_label(label_string.str().c_str(), hbox);
   g_object_set_data(G_OBJECT(frame), "symp", label);

   GtkWidget *vbox2 = vbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(vbox), vbox2, TRUE, TRUE, 0);
   g_object_set_data(G_OBJECT(dlg), "box_maps", vbox2);
   for(i=0; i<gl->nMaps; i++)
       fillInfo_for_map(vbox2, i);

   chiudi_dlg_data *st = g_new0(chiudi_dlg_data, 1);
   st->window = window;
   st->name = MapInfoWindow;

   GtkWidget *button = CLOSE_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_CANCEL);
   g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(chiudi_dlg), (gpointer) st);
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
        GTK_BUTTONBOX_SPREAD);
   gtk_widget_show_all(dlg);
   g_signal_connect_swapped(G_OBJECT(dlg), "delete-event", G_CALLBACK(gtk_button_clicked), button);
}

int IsMapVisible(int whichMap)
{
   if(!GLWINDOW)
      return 0;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   if(whichMap >= gl->nMaps)
      return 0;
   if(MapInfo[whichMap].created && MapInfo[whichMap].ifVis)
      return 1;
   return 0;
}

}  //end namespace

void SetCentreRad(float rad, float *xc=NULL)
{
using namespace GLextmr;
   if(rad > 0)
      raggioMappa = rad;
   if(xc != NULL)
   {
       for(int j=0; j<3; j++)
           centroMappa[j] = xc[j];
       defCentro = true;
   }
}

void PassaMappa(char *name, int *nmaps, int *which, int np[],
                int *nrefl, float *resm, int *ifd, float *denmin,
                float *denmax, float *avden, float *stden, float ***map,
                int ***color)
{
using namespace GLextmr;
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  
  structure_info_type StructInfo;
  Mappa *mapinfo;
  int currentModel;
  int k = *which - 1;
  int sz = (int) strlen(name) + 1;
  if(map == NULL)
     gl->nMaps = *nmaps;

  int ifDifferenceMap = *ifd;
  int iflag = 0;
  int mk = k;
  if(map != NULL)
     currentModel = mk+1;
  else
  {
     currentModel = GetActiveModel();
     if(currentModel <= 0)
        currentModel = 1;
  }
  for(int ik=0; ik<ifDifferenceMap; ik++)
  {
      if(map != NULL)
         mapinfo = &(VWSurface[mk]);
      else
         mapinfo = &(MapInfo[mk]);
      float defRad = raggioMappa;
      if(mapinfo->created)
      {
         defRad = gl->Radius;
         mapinfo->freeMap();
         if((mapinfo->ifDifference <= 1))
                gl->usedC[mk] = -1;
         iflag = 1;
      }
      mapinfo->created = true;
      mapinfo->name = g_new0(char, sz);
      CopiaStringa(mapinfo->name, sz, name);
      mapinfo->isSurface = (map != NULL);
      mapinfo->multicolor = false;

      mapinfo->ifDifference = *ifd + ik;
      int size_x = np[0];
      int size_y = np[1];
      int size_z = np[2];
      int size_m = MRmin(size_x, size_y);
      size_m = MRmin(size_m, size_z);
      size_m /= 2;
      int size_M = MRmax(size_x, size_y);
      size_M = MRmax(size_M, size_z);
      size_M /= 2;
      int ifCalc = 0;
      getstructureinfo_(&StructInfo, &ifCalc, &currentModel);
      for(int j=0; j<6; j++)
          gl->Cell[j] = StructInfo.cell[j];
      for(int i1=0; i1<16; i1++)
          gl->sy.spg[i1] = StructInfo.spaceg[i1];
      gl->sy.spg[16] = '\0';
      gl->sy.icent = StructInfo.icent;
      gl->CalcolaMatrici();
      calcolava();
      mapinfo->nrefl = *nrefl;
      mapinfo->resm = *resm;

      mapinfo->mappa = g_new0(myreal, size_x*size_y*size_z);
      mapinfo->color = g_new0(int, size_x*size_y*size_z);
      mapinfo->size_m = size_m;
      mapinfo->size_M = size_M;
      mapinfo->size_x = size_x;
      mapinfo->size_y = size_y;
      mapinfo->size_z = size_z;

      mapinfo->mc = new MarchingCubes();
      mapinfo->mc->set_resolution( size_x, size_y, size_z );
      mapinfo->mc->init_all() ;

      int index_color = 0;
      if(mapinfo->ifDifference < 2)
      {
         for(int kk=0; kk<MAX_NUM_MAPS; kk++)
         {
             if(gl->usedC[kk] == -1)
             {
                index_color = kk;
                gl->usedC[kk] = kk;
                break;
             }
         }
      }
      else if(mapinfo->ifDifference == 2)
         index_color = MAX_NUM_MAPS;
      else if(mapinfo->ifDifference == 3)
         index_color = MAX_NUM_MAPS + 1;
      GetMapColor(mapinfo->color_mappa, index_color);
  
      gl->Radius = defRad; 
      if(defCentro)
         MRVectorCopy(MRVectorMake(centroMappa), &(gl->xyzC));
      mapinfo->FromRadTorad(gl);
      int l = 0;
      for(int z=0; z<size_z; z++)
      {
            for(int y=0; y<size_y; y++)
            {
                for(int x=0; x<size_x; x++)
                {
                    if(color != NULL)
                        mapinfo->color[l] = color[x][y][z];
                    else
                        mapinfo->color[l] = -1;
                    if(map != NULL)
                        mapinfo->mappa[l++] = (myreal) map[x][y][z];
                    else if(mapinfo->ifDifference != 3)
                        mapinfo->mappa[l++] = (myreal) getxmap_(&x, &y, &z);
                    else
                        mapinfo->mappa[l++] = -(myreal) getxmap_(&x, &y, &z);
                }
            }
      }
      float rap = 1.5f;
      if(avden == NULL)
      {
         mapinfo->sigma = (myreal)mapinfo->SigmaMappa();
/*
         if(mk)
         {
            if((MRabs(MapInfo[mk].mean) > DBL_EPSILON) &&
               (MRabs(MapInfo[0].mean) > DBL_EPSILON))
                  rap = MRabs(MapInfo[mk].mean / MapInfo[0].mean);
            g_print("rap mean %f\n", rap);
            MapInfo[mk].sigma = MapInfo[0].sigma;
         }
*/
      }
      else
      {
         mapinfo->sigma = *stden;
         mapinfo->mean  = *avden;
         if(*stden)
            mapinfo->sigmaMax = (*denmax) / (*stden);
         else
            mapinfo->sigmaMax = 0;
         mapinfo->minimum = *denmin;
         mapinfo->maximum = *denmax;
      }
      mapinfo->iso   = rap * mapinfo->sigma;
      if(map != NULL)
      {
         mapinfo->iso   = 1;
         return;
      }
      if(mapinfo->ifDifference != 3)
      {
         gl->activeMap = mk;
         GtkWidget *entry = get_widget(GLWINDOW, "box_Sigma");
         if(entry != NULL)
         {
            gtk_widget_set_sensitive(entry, TRUE);
            entry = get_widget(GLWINDOW, "Sigma");
            gtk_scale_set_digits(GTK_SCALE(entry), 2); //numDigits);
            gtk_range_set_range(GTK_RANGE(entry), minSigma, MRmax(0.2, mapinfo->sigmaMax));
            gtk_range_set_value(GTK_RANGE(entry), rap);
         }
         update_infos_map(iflag);
      }
      mk += MAX_NUM_MAPS;
   }
   update_infos_cell(gl->nMaps + gl->nModels);
#ifdef JAV
   gl->UpdateTitle();
   SetLastRun(GLWINDOW, false);
#endif
   gl->RiNormalizza();
   gl->Redraw();
}

extern "C" void passamappa_(char *name, int *nmaps, int *which, int np[],
          int *nrefl, float *resm, int *ifd)
{
   PassaMappa(name, nmaps, which, np, nrefl, resm, ifd);
}

extern "C" void passamappaparz_(char *name, int *nmaps, int *which, int np[],
          int *nrefl, float *resm, float *denmin, float *denmax,
          float *avden, float *stden, int *ifd)
{
   PassaMappa(name, nmaps, which, np, nrefl, resm, ifd, denmin, denmax,
              avden, stden);
}

extern "C" void map_set_options_(float *rad, float xc[3])
{
   SetCentreRad(*rad, xc);
}

extern "C" void map_set_centre_(float xc[3])
{
   SetCentreRad(-1, xc);
}

extern "C" void map_set_rad_(float *rad)
{
   SetCentreRad(*rad);
}

extern "C" void map_set_visible_(int *which, int *code)
{
using namespace GLextmr;
   if(!GLWINDOW)
      return;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   int whichMap = *which - 1;
   if(whichMap >= gl->nMaps)
      return;
   if(MapInfo[whichMap].created)
     MapInfo[whichMap].ifVis = (*code != 0);
   gl->Redraw ();
}

extern "C" int is_map_visible_(int *which)
{
using namespace GLextmr;
   int whichMap = *which - 1;
   return IsMapVisible(whichMap);
}

#endif
