      subroutine PreMaskSirProt(jenveTipo,vol,x,FORTHi,BACKi)
      USE General
      USE Riflessi
      USE Mappa
c     USE EnvelopeModule
      USE PhaseModule
      USE Param

      real x(*)
      integer*8    ::FORTHi,BACKi

      FORTHi = 0

      select case (jenveTipo)
      case (0)
        if (ihism > 0) then
          fcoef(:)=fovet_mod(:) * wt(:)
        else
          fcoef(:)=fovet(:) * wt(:)
        endif
        call MakeMap(fcoef,iphaz,nrefl,0,x,FORTHi,BACKi)
      case (1)
        fcoef(:)=fovet(:)
        call MakeMap(fcoef,ipub,nrefl,0,x,FORTHi,BACKi)
      case (2)  ! per fourie di differenza
        if (ihism > 0) then
          fcoef(:)=fovet_mod(:) * wt(:)
        else
          fcoef(:)=fovet(:) * wt(:)
        endif
        call MakeMap(fcoef,iphaz,nrefl,0,x,FORTHi,BACKi)
      end select


      return
      end
*-----------------------------------------------------------------------*
*----               Envelope MASK  Subroutine                       ----*
*-----------------------------------------------------------------------*
      subroutine Map2EnveMask(jenveTipo,smax,vol,x,FORTHi,BACKi)
      USE General
      USE Riflessi
      USE Mappa
c     USE EnvelopeModule
      USE PhaseModule
      USE Param

      real x(*)
      integer*8    ::FORTHi,BACKi
      character (len=200)   :: strTemp


      if(kverbo>0) then
        write(lo,*)
        write(lo,*)'      **********************************'
        write(lo,*)'      *        MAP ==> ENVELOPE MASK   *'
        write(lo,*)'      **********************************'
      endif

      call zflush
      call DoSingleIteration()

      jflag=4
      if (jenveTipo == 2) then
        npunti=np(1)*np(2)*np(3)
        jflag=1
        perc=abs(vol)
        npts1=npunti*perc
        call denhist(0,x,x,npts1,0)
        write(6,*) 'prima',den_p
      endif

      sog=0.0
      call ChangeMapFlex(x,x,sog,jflag,0)
*---- Make the envelop map ----*
!!gpu call InvEnv(np(1),np(2),np(3),smax,FORTHi,BACKi)  ! gianluca 23/10/2013
      call InvEnv(np(1),np(2),np(3),smax,x,FORTHi,BACKi)


      call zflush
      call DoSingleIteration()

      if (jenveTipo == 2) then
        npunti=np(1)*np(2)*np(3)
        perc=abs(vol)
        npts1=npunti*perc
        call denhist(0,x,x,npts1,0)
        write(6,*) 'dopo',den_p
      else
        npts=vol*(np(1)*np(2)*np(3))
        ! make Mask
        call envhist(x,npts)
      endif
      call zflush
      call DoSingleIteration()

      ! make Mask
      call envmask(x,den_p,npunti)
      call zflush
      call DoSingleIteration()


      if (jenveTipo==1 .and. kverbo > 0) then
          write(lo,'("   === True Phases ===")') 
      endif
      if(kverbo>0) then
        write(lo,1000)Renve,vol*100.0,1/sqrt(smax),f000/volume,
     +             den_p/volume,npunti
      endif

 1000 format (/,'   Radius (A) ................ ',f6.2,/,
     +          '   Volume (%) ................ ',f6.2,/,
     +          '   Resolution (A) ............ ',f6.2,/,
     +          '   F000 ...................... ',f8.4,/,
     +          '   Mask Level ................ ',f7.3,/,
     +          '   Envelope grid point ....... ',i8,/)


      return
      end
*-----------------------------------------------------------------
      function g_s(r,nnh,nnk,nnl)
      USE General
!
      pi=acos(-1.0)

      s=2.0*rhof(pp,nnh,nnk,nnl)
      u=2.0*pi*s
      x=r*u

      if (x.le.0.01) then
         g_s=1.0
      else
c        y=3.0 * ( sin(x) - x*cos(x) )/ (x**3)
c        z=3.0 * ( 2.0*x*sin(x) - (x**2 -2.0)*cos(x) - 2.0)/(x**4)
c        g_s=4.0*(y - z)

         y = (sin(x)-cos(x)*x)*3.0/x**3
         z = ((x**2*3.0-6.0)*sin(x)-(x**3-6.0*x)*cos(x))*3.0/x**5
         g_s = 2.5*(y - z)

      endif

      return
      end

*---------------------------------------------------------*
      subroutine envmask(x,den,npunti)
      USE General
      USE Mappa, only : np

      real x(1:np(1),1:np(2),1:np(3))


      nnx=np(1)
      nny=np(2)
      nnz=np(3)

      npunti=0

      do 50 ix=1,nnx
        do 30 iy=1,nny
           do 20 iz=1,nnz
             xx=x(ix,iy,iz)
               if (xx.gt.den) then
                  ixx=100
                  x(ix,iy,iz) = float(ixx)
                  npunti=npunti+1
               else
                  ixx=50
                  x(ix,iy,iz) = float(ixx)
               endif
 20      continue
 30     continue

 50   continue    

      return
      end
*---------------------------------------------------------*
      subroutine envmaskDif(x,den_p,den_s,npunti)
      USE General
      USE Mappa

      real x(1:np(1),1:np(2),1:np(3))


      nnx=np(1)
      nny=np(2)
      nnz=np(3)

      npunti=0

      do iz=1,nnz
        do iy=1,nny
           do ix=1,nnx
             xx=x(ix,iy,iz)
             if (xx.gt.den_p) then
                ixx=100
                x(ix,iy,iz) = float(ixx)
                npunti=npunti+1
             elseif (xx.lt.den_s) then
                ixx=100
                x(ix,iy,iz) = float(ixx)
                npunti=npunti+1
             else
                ixx=50
                x(ix,iy,iz) = float(ixx)
             endif
         enddo
        enddo
      enddo
!
      return
      end
*---------------------------------------------------*
*----          Subroutine flatmap           --------*
*---------------------------------------------------*
      subroutine flatmap(x,x1,icont,Xflip1)

      USE General
      USE Mappa
      USE PhaseModule
      USE Param

      real x(1:np(1),1:np(2),1:np(3))
      real x1(1:np(1),1:np(2),1:np(3))

      adjden=0.0
      attun=1.0

      solden=0.0
      if (abs(icont).eq.2) solden = 0.32*volume
c     print*,'flatmap',icont
      nnx=np(1)
      nny=np(2)
      nnz=np(3)
      npunti=nnx*nny*nnz

      npt1=0
      npt2=0
      nptF=0
      nptw05=0
      nptw07=0
      nptw0=0
      do 150 ix=1,nnx
        do 100 iy=1,nny
            do 50 iz=1,nnz
               xx=x(ix,iy,iz)
               xx1=x1(ix,iy,iz)/100.0
               ixx1=int(x1(ix,iy,iz))
               if (ixx1.eq.100) then
                  npt1=npt1+1
                  if (icont < 0) x(ix,iy,iz) = 0.0
                  if (icont == 3) then
c                   x(ix,iy,iz)=nint(xx*1.5)
c                   x(ix,iy,iz)=nint(xx**4.5)
                  endif
               elseif (ixx1.eq.200) then
                  npt2=npt2+1
                  x(ix,iy,iz)=0
                  if (Xflip1.ne.0.0) then
                     xxnew=deso + Xflip1*(xx-deso)
                     if (xxnew.lt.0.0) x(ix,iy,iz) = nint(xxnew)
                     nptF=nptF+1
                  endif
               else
                  if (ixx1.eq.50) nptw05=nptw05+1
                  if (ixx1.gt.50) nptw07=nptw07+1
                  if (ixx1.eq.0)  nptw0=nptw0+1
                  if (icont.eq.1) then
                    ! cambiare il valore densita solvente ( con il valore della MASK)
                    x(ix,iy,iz)=nint(xx*xx1)
                  elseif (icont == 3) then
                    ! per MASK da four. diff.
c                   x(ix,iy,iz)=nint(xx*2.0)
                  elseif (icont == -1) then
                    ! senza cambiare il sovente
                    x(ix,iy,iz)=-x(ix,iy,iz)
                  elseif (icont == -3) then
                    ! niente
                  else
                    ! per il sovente la densita cte
c                   x(ix,iy,iz)=-nint(solden)
                    x(ix,iy,iz)=nint(solden)
                  endif
               endif 
 50         continue
 100     continue

 150  continue

      if (kverbo > 0) then
        write(lo,500)
        if (npt1.gt.0) write(lo,1000) npt1,(npt1/float(npunti))*100.0
        if (nptw05.gt.0) write(lo,1500) nptw05,
     *                 (nptw05/float(npunti))*100.0
        if (nptw07.gt.0) write(lo,1600) nptw07,
     *                 (nptw07/float(npunti))*100.0
        if (nptw0.gt.0) write(lo,2000) nptw0,
     *                 (nptw0/float(npunti))*100.0
        if (npt2.gt.0) write(lo,2000) npt2,(npt2/float(npunti))*100.0
      endif

  500 format(20x,/,'  ----- MASK ----- ')
 1000 format(6x,'W.eq.1.0 =',i10,2x,2h( ,f6.2,3h% ))
 1500 format(6x,'W.eq.0.5 =',i10,2x,2h( ,f6.2,3h% ))
 1600 format(6x,'W.gt.0.5 =',i10,2x,2h( ,f6.2,3h% ))
 2000 format(6x,'W.eq.0.0 =',i10,2x,2h( ,f6.2,3h% ),/)

      return
      end
c------------------------------------------------------------------
      subroutine envhist(x,npts)

      USE General
      USE Symmetry
      USE Mappa, only : np
c     USE PhaseModule
      USE Param
     
      real x(1:np(1),1:np(2),1:np(3))
      dimension hispL(501)


      nx=np(1)
      ny=np(2)
      nz=np(3)

      denmin=1.0e25
      denmax=-1.0e25
      call maxminG(0,nx,ny,nz,denmin,denmax,avden,stden,x)
      nrange=500
      rang=(denmax - denmin)/nrange
      npunti=0
      do 10 i=1,nrange+1
         hispL(i)=0.0
         range(i)=denmin + rang*(i-1)
 10   continue

      do 150 ky=1,ny
         do 100 kz=1,nz
           do 50 kx=1,nx
               xx=x(kx,ky,kz)
               n=int((xx-denmin)/rang) + 1
               if (n.gt.nrange) n=nrange
               if (n.le.1) n=1
               hispL(n)=hispL(n)+1.0
 50         continue
 100     continue

 150  continue

      jflag=1
      npts1=npts
      call findsog(hispL,den_p,npts1,jflag)
      npts1=nint(npunti*v_p)
      call findsog(hispL,den_s,npts1,jflag)

      return
      end

!-----------------------------------------------------------------------
!!gpu subroutine InvEnv(nu,nv,nww,smax,FORTHi,BACKi)
      subroutine InvEnv(nu,nv,nww,smax,x,FORTHi,BACKi)
 
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE PhaseModule
      USE Param
!
      integer*8    :: FORTHi,BACKi
      common /dada/ ncol, ndim1, ndim2

      integer i1(3),i2(3),lmod,hs,h

      real x(0:nu-1,0:nv-1,0:nww-1)   ! gianluca 23/10/2013

      integer,allocatable::hkl(:)
      real, allocatable::refle(:,:)

      complex fm,sf,phasec
      logical hemiFFTW
      
      external hemiFFTW,lmod,phasec

      allocate (hkl(ndim1), stat=ier)
      if (ier.ne.0) print *, 'allocate HKL in newenve error'

      allocate (refle(ncol,ndim1), stat=ier)
      if (ier.ne.0) print *, 'allocate REFLE in newenve error'

      n1 = np(1)
      n2 = np(2)
      n3 = np(3)
      n0 = np(1) / 2 + 1
      
*---- Scale ----*
      scfft=1.0/real(n1 * n2 * n3)

*---- Perform real hermitian FFT ----*
!!gpu call sfftw_execute(BACKi)
      call sfftw_executer2c(n1,n2,n3,BACKi,x,xmapC)

*---- All hkl for wang ----*

      ip5=256*(262144+512+1)
      ntt=0

      nh=2*ihmx(1)+1
      nkk=n2
      nl=ihmx(3)+1
      hs=-ihmx(1)

      m=0
      kmin=-ihmx(2)
      h=hs-1
      mk=ihmx(2) - kmin +1

 
      do 400 ih=1,nh
         h=h+1
         k=kmin-1
         do 300 ik=1,mk
            k=k+1
            l=-1
            do 200 il=1,nl
               l=l+1

*---           Eliminando (-h,-k,0) ---*
*---           Eliminando (-h, k,0) ---*
*---           Eliminando ( 0,-k,0) ---*

               if ( h.lt.0 .and. l.eq.0 ) goto 200
               if ( h.eq.0 .and. k.lt.0 .and. l.eq.0 ) goto 200
               if ( h.eq.0 .and. k.eq.0 .and. l.eq.0 ) goto 200

               s=4.0*rhof(pp,h,k,l)**2
               if (s.gt.smax) goto 200

               sf=cmplx(0.0,0.0)
               if (hemiFFTW(h,k,l)) then
                   iu = lmod(h,n0)
                   iv = lmod(k,n2)
                   iw = lmod(l,n3)
                   sf =   conjg(xmapC(iu,iv,iw)) * phasec(0.0)
                else
                   iu = lmod(-h,n0)
                   iv = lmod(-k,n2)
                   iw = lmod(-l,n3)
                   sf =       (xmapC(iu,iv,iw)) * phasec(0.0)
            endif

               wwtt=g_s(Renve,h,k,l)
               sf=sf*scfft*wwtt

               ntt=ntt+1
               hkl(ntt)=ip5+(262144*h+512*k+l)
               refle(1,ntt)=real(sf)
               refle(2,ntt)=aimag(sf)
c              write(2,*)ih,ik,il,real(sf),aimag(sf)
           
200         continue
300      continue
400   continue

      xmapC(:,:,:) = cmplx(0.0,0.0)

      do 500 i=1,ntt
         ihj=hkl(i)
         h=ihj/262144-256
         l=ihj-262144*(h+256)
         k=l/512-256
         l=l-512*(k+256)-256

         fm = cmplx(refle(1,i),refle(2,i))

         if (h.ge.0) then
            ih=  lmod(h,(nu/2+1))
            ik=  lmod(k,nv)
            il=  lmod(l,nww)
            xmapC(ih,ik,il) = conjg(fm)
         endif

         if (-h.ge.0) then
            ih=  lmod(-h,(nu/2+1))
            ik=  lmod(-k,nv)
            il=  lmod(-l,nww)
            xmapC(ih,ik,il) = fm
         endif
500   continue

      xmapC(0,0,0) = f000
!!gpu call sfftw_execute(FORTHi)
      call sfftw_executec2r(n1,n2,n3,FORTHi,xmapC,x)

      deallocate (hkl, stat=ier)
      deallocate (refle, stat=ier)

      return
      end
