MODULE STRUTIL
!
!                                    - List of procedures -
!
!  S filtra(string)                             ! Remove empty space
!  S Cutst(line1,nlong1,line2,nlong2)           ! Removes the first word of the input String.
!  S Getnum(line,vet,ivet,iv)                   ! Converts a string to numbers and write on VET/IVET if real/integer.
!  S get_words(line,wordv,nword)                ! Estrai da line tutte le stringhe separate da spazi in wordv
!  S get_words_quotes(line,wordv,nword)         ! Estrai da line solo le stringhe in parentesi
!  S get_words_quotes1(line,wordv,nword)        ! Estrai da line le stringhe in parentesi e non
!  F U_Case(Text)                               ! Conversion to upper case, text is not modified
!  S Init_Err_String()                          ! Initializes general error variables
!  F Lung (Stringa)                             ! Lenght of stringa
!  F remc0(s0)                                  ! Removes char(0) from the end of s0
!  F add_c0(str,pos)                            ! Add char(0) non oltre il carattere pos
!  S s_cat0(s1,s2)                              ! Joins s1 and s2 separated with blank. Output in s1
!  S s_catend(s1,s2)                            ! Joins s1 and s2 plus char(13)//char(10) for end of row. Output in s1
!  S svec_sort_heap_a_index ( n, sarray, indx ) ! Does a case-sensitive indexed heap sort of a vector of strings
!  S s_rep_ch ( s, c1, c2 )                     ! Replaces all occurrences of one character by another
!  S s_rep ( s, sub1, sub2, irep )              ! Replaces all occurrences of SUB1 by SUB2 in a string.
!  S s_filter(str)                              ! Filtra una stringa
!  S s_chop ( s, ilo, ihi )                     ! "Chops out" a portion of a string, and closes up the hole
!  F string_from_time(time)  result(stime)      ! Converts time in string. Time is expressed in seconds
!  S s_s_insert ( s, ipos, s2 )                 ! Inserts a substring into a string.
!  S s_ch_blank ( s, c )                        ! Replaces each occurrence of a particular character by a blank.
!  F s_blank_delete ( s )                       ! Removes blanks from a string, left justifying the remainder.
!  S s_blanks_delete ( s )                      ! Replaces consecutive blanks by one blank.
!  S s_blanks_insert ( s, ilo, ihi )            ! Inserts blanks into a string, sliding old characters over
!  S s_s_delete ( s, sub, irep )                ! Removes all occurrences of a substring from a string
!  F upper ( s )                                ! Returns an uppercase version of a string
!  F lower ( s )                                ! Returns a lowercase version of a string.
!  F s_cap_word ( s )                           ! Capitalizes the first character in a word s
!  S s_to_r                                     ! reads a real number from a string
!  S s_to_i                                     ! reads a integer number from a string
!  S ch_eqi                                     ! is a case insensitive comparison of two characters for equality
!  F s_eqi ( s1, s2 )                           ! is a case insensitive comparison of two strings for equality.  
!  F s_eqidb ( s1, s2 )                         ! compares two strings, ignoring case and blanks.
!  F match_word(string,word) result(match)      !  true if the first characters of string match with word (case insensitive)
!  S ch_cap                                     ! capitalizes a single character
!  S ch_to_digit                                ! returns the integer value of a base 10 digit.
!  F catsvector                                 ! Concatena vettore di stringhe senza rimuovere gli spazi vuoti
!  F catsvector2(string,sep)                    ! Concatena vettore di stringhe rimuovendo gli spazi vuoti 
!  F centra_str(string,n)                       ! Centra una stringa in un campo di ampiezza n
!  F catstringpar(string,par,fmtt)              ! Concatena una stringa con un reale in formato fmtt
!  F number_to_format(vet)                      ! genera un formato fortran da un numero o vettore di numeri
!  F position_stringv(str,stringv)              ! Cerca la prima posizione di str nel vettore stringv  (obsoleta)
!  F pos_string_in_vector(str,strvet,vet)       ! Cerca la prima posizione di str nel vettore strvet
!  F ch_is_alpha                                ! returns TRUE if C is an alphabetic character.
!  F ch_is_digit ( c )                          ! is TRUE if C is a decimal digit
!  F ch_is_upper ( c )                          ! is TRUE if C is an upper case letter.
!  F ch_is_lower ( c )                          ! is TRUE if C is a lower case letter.
!  F ch_is_space ( c )                          ! is TRUE if C is a whitespace character.
!  F s_is_alpha                                 ! returns TRUE if the string contains only alphabetic characters.
!  F s_is_alphanumeric ( s )                    ! returns TRUE if the string contains only alphanumeric characters.
!  S s_is_r                                     ! returns TRUE if the string represents a real number
!  S s_detag ( s )                              ! removes from a string all substrings marked by brackets.
!  F string_esd(val,std)  result(str)           ! create string: val(std)
!  F xround(num,sig)                            ! round a number to n significant digits
!  S S_DETAG                                    ! removes from a string all substrings marked by brackets.
!  F string_sigf(val,sig)                       ! genera stringa da val con sig cifre significative
!  F r_to_s(x)                                  ! writes a real into a left justified character string
!  F i_to_s ( intval )                          ! converts an integer to a left-justified string.
!  S set_row_list(vet,ktype,ival,rval,sval,kpr) ! Scrive una singola riga di una tabella
!  F s_in_quotes(string)  result(str)           ! Enclose string in double quotes
!  F rem_quotes(string)  result(str)            ! Remove quotes
!  S get_string_in_brackets(str,strb,ier)       ! Estrai la stringa tra parentesi
!  S write_svet(svet,nvet,kpr,word)             ! Scrivi sulla stessa riga un vettore di stringhe
!  S get_next_number(string,pos,numb,ier)       ! Get the next number starting from position pos
!  S get_next_number1(string,spos,numb,ier)     ! Get the next number starting from string spos
!  S write_title(kpr,title)                     ! Write title in a frame

 implicit none

 interface string_sig
     module procedure string_sigf, string_sigd
 end interface
 
 interface catstringpar
     module procedure catstringpar_r,catstringpar_i,catstringpar_vetr,catstringpar_veti
 end interface
 
 interface number_to_format
     module procedure number_to_format_veti
 end interface

 character (len=*), private, parameter :: digit="0123456789.-+"
 character (len=150), public           :: err_mess_string
 logical, public                       :: err_string

CONTAINS

   subroutine filtra(string)
!
   character(len=*), intent(inout) :: string
   integer                         :: k
!
   k = Lung(string)
   if (k.gt.0) then
       if (ichar(string(k:k)).eq.13) then
           string(k:k) = ' '
       endif
   endif
!
   end subroutine filtra

 !-----------------------------------------------------------------------

   Subroutine Cutst(line1,nlong1,line2,nlong2)
!
!  Removes the first word of the input String.
!  Provides (optionally) a string with the first word.
!
   character (len=*),           intent(in out) :: line1   !  In -> Input string
                                                          ! Out -> Input string without the first word
   character (len=*), optional, intent(   out) :: line2   ! Out -> Give the length of Line1 on Output
   integer,           optional, intent(   out) :: nlong1  ! Out -> The first word of String on Input
   integer,           optional, intent(   out) :: nlong2  ! Out -> Give the length of Line2 on Output
   integer  :: k,iniz1

   !---- Initializing variables ----!
   if (present(nlong1)) nlong1=0
   if (present(nlong2)) nlong2=0

   !---- Initializing to blank the directive ----!
   if (present(line2)) line2=" "

   !---- Elimination of possible blanks on the left ----!
   line1=adjustl(line1)
   if (len_trim(line1) <= 0) return

   k=len(line1)
   iniz1=index(line1," ")

   if (k ==1) then
      if (present(line2)) line2=line1
      if (present(nlong2)) nlong2=1
      line1=" "
   else
      if (iniz1 > 0) then
         if (present(line2))  line2=line1(1:iniz1-1)
         if (present(nlong2)) nlong2=len_trim(line1(1:iniz1-1))
         line1=line1(iniz1:)
      else
         if (present(line2))  line2=line1
         if (present(nlong2)) nlong2=len_trim(line1)
         line1=" "
      end if
   end if

   line1=adjustl(line1)
   if(present(nlong1)) nlong1=len_trim(line1)

   return
   End Subroutine Cutst

 !-----------------------------------------------------------------------

   Subroutine Getnum(line,vet,ivet,iv)
!
!  Converts a string to numbers and write on VET/IVET if real/integer. Control
!  of errors is possible by inquiring the global variables ERR_STRING and
!  ERR_MESS_STRING
!
   !!!!!
      integer, parameter :: sp = 4
   !!!!!
   character (len=*),          intent ( in) :: line    ! Input String to convert
   real(kind=sp), dimension(:),intent (out) :: vet     ! Vector of real(kind=sp) numbers
   integer, dimension(:),      intent (out), optional :: ivet    ! Vector of integer numbers
   integer,                    intent (out) :: iv      ! Number of numbers in Vet/Ivet
   logical                                  :: numero
   character (len=len(line))                :: resto,cifre
   integer                                  :: i,isum,ncharl,nchard,isegno,iniz,ipoi,idec,idig
   integer                                  :: nchart, npos,nchard1,isum_exp,ioper
   real(kind=sp)                            :: suma,segno,dec
   real(kind=sp)                            :: sum_m

   call init_err_string()
   iv=0
   if (present(ivet)) ivet=0
   vet=0.0

   resto=u_case(line)

   do
      ioper=0
      isum_exp=0
      nchard1=0
      sum_m=0.0
      suma=0.0
      isum=0
      call cutst(resto,ncharl,cifre,nchard)
      if (nchard <= 0) exit

      !---- Is a number ----!
      numero=.true.
      do i=1,nchard
         if (cifre(i:i) =='E') cycle
         npos=index(digit,cifre(i:i))
         if (npos /= 0) cycle
         numero=.false.
      end do
      if (.not. numero) then
         err_string=.true.
         err_mess_string="The variable cannot be computed as a number in GETNUM "
         return
      end if

      !---- Positive or Negative number ----!
      segno=1.0
      isegno=1
      iniz=1
      if (cifre(1:1) == digit(12:12)) then
         segno=-1.0
         isegno=-1
         iniz=2
      end if

      !---- Decimal Number ----!
      ipoi=index(cifre(1:nchard),digit(11:11))

      !---- Exponential Number ----!
      nchard1=index(cifre(1:nchard),"E")
      if (nchard1 /= 0) then
         nchart=nchard
         nchard=nchard1-1
      end if

      if (ipoi == 0) ipoi=nchard+1
      dec=real(ipoi-1-iniz)
      idec=ipoi-1-iniz
      do i=iniz,nchard
         idig=index(digit,cifre(i:i))
         if (idig >= 1 .and. idig <= 11)  then
            if (idig <= 10)  then
!!!corr               suma=suma+real(idig-1)*10.0**dec
               suma=suma+real(idig-1)*10**dec
               if (idec >= 0) isum=isum*10+(idig-1)
               dec=dec-1.0
               idec=idec-1
            end if
         else
            err_string=.true.
            err_mess_string="Limits of digit variable exceeded in GETNUM"
            return
         end if
      end do

      if (nchard1 /= 0) then
         nchard1=nchard1+1
         select case (cifre(nchard1:nchard1))
            case ("-")
               ioper=1
               nchard1=nchard1+1

            case ("+")
               nchard1=nchard1+1
         end select

         do i=nchard1,nchart
            idig=index(digit,cifre(i:i))
            if (idig >= 1 .and. idig <= 10)  then
               isum_exp=isum_exp*10+(idig-1)
            else
               err_string=.true.
               err_mess_string="Limits of digit variable exceeded in GETNUM"
               return
            end if
         end do
      end if

      iv=iv+1
      vet(iv)=suma*segno
      if (present(ivet)) ivet(iv)=isum*isegno

      if (nchard1 /= 0) then
         select case (ioper)
            case (0)
               sum_m=10.0**isum_exp

            case (1)
               sum_m=10.0**isum_exp
               sum_m=1.0/sum_m
         end select
         vet(iv)=vet(iv)*sum_m
      end if

      if (ncharl <= 0) then
         exit
      end if
   end do

   return
   End Subroutine Getnum

  !-----------------------------------------------------------------------

   subroutine get_words(line,wordv,nword)
!
!  Estrai da line tutte le stringhe separate da spazi in wordv
!
   character(len=*), intent(in)                :: line
   character(len=*), dimension(:), intent(out) :: wordv
   integer, intent(out)                        :: nword
   character(len_trim(line))                   :: resto,string
   integer                                     :: ncharl,nchard
!
   wordv(:) = ' '
   nword = 0
!
   resto = line
   do 
      call cutst(resto,ncharl,string,nchard)
      if (nchard == 0) exit
      nword = nword + 1
      wordv(nword) = string
      if (nword == size(wordv)) exit
   enddo
!
   end subroutine get_words

  !-----------------------------------------------------------------------

   subroutine read_words(word,nword,wtype,vetr,ier)
   character(len=*), dimension(:), intent(in) :: word
   integer, intent(in)                        :: nword
   character(len=*), intent(in)               :: wtype
   real, dimension(:), intent(out)            :: vetr
   integer, intent(out)                       :: ier
   integer                                    :: i
   integer                                    :: nreal
   real                                       :: rvalue
   integer                                    :: lenw
!
   nreal = 0
   do i=1,min(nword,len_trim(wtype))
      select case (wtype(i:i)) 
        case ('R')
           call s_to_r(word(i),rvalue,ier,lenw)
           if (ier == 0) then
               nreal = nreal + 1
               vetr(nreal) = rvalue
           else
               exit
           endif
      end select
   enddo
!
   end subroutine read_words

  !-----------------------------------------------------------------------

   subroutine get_words_quotes(line,wordv,nword)
!
!  Estrai da line solo le stringhe in parentesi
!
   character(len=*), intent(in)                :: line
   character(len=*), dimension(:), intent(out) :: wordv
   integer, intent(out)                        :: nword
   integer                                     :: pos1,pos2
   integer                                     :: lent
   integer                                     :: i
   integer                                     :: nw
!
   nw = size(wordv)
   wordv(:) = ' '
   nword = 0
   lent = len_trim(line)
!
   pos1 = 0
   pos2 = 0
   do i=1,lent
      if (pos1 > 0 .and. line(i:i) == "'") pos2 = i
      if (line(i:i) == "'" .and. pos1 == 0) pos1 = i
      if (pos1 > 0 .and. pos2 > 0) then
          if (pos1 + 1 /= pos2) then   ! /= da ''
              nword = nword + 1
              wordv(nword) = line(pos1+1:pos2-1)
          endif
          pos1 = 0
          pos2 = 0
          if (nword == nw) exit
      endif
   enddo
!
   end subroutine get_words_quotes

  !-----------------------------------------------------------------------

   subroutine get_words_quotes1(line,wordv,nword)
!
!  Estrai da line tutte le stringhe in parentesi e non
!
   character(len=*), intent(in)                :: line
   character(len=*), dimension(:), intent(out) :: wordv
   integer, intent(out)                        :: nword
   integer                                     :: pos1
   integer                                     :: lent
   integer                                     :: i
   integer                                     :: nw
   character(len=1)                            :: ch
   logical                                     :: word_in_quotes
!
   nw = size(wordv)
   wordv(:) = ' '
   nword = 0
   lent = len_trim(line)
!
   pos1 = 0
   !pos2 = 0
   word_in_quotes = .false.
 
   do i=1,lent
      ch = line(i:i) 
      if (ch == "'" .and. pos1 == 0) then
          word_in_quotes = .true.
          pos1 = i
          cycle
      endif
      if (word_in_quotes) then
          if (ch == "'" .and. pos1 > 0) then
              word_in_quotes = .false.
              !pos2 = i
              if (i == pos1+1) then ! situazione ''
                  nword = nword + 1
                  wordv(nword) = ' '   ! stringa vuota
              else
                  nword = nword + 1
                  wordv(nword) = line(pos1+1:i-1)
              endif
              pos1 = 0
          endif
      else
          if (ch_is_space(ch) .and. pos1 > 0) then
              nword = nword + 1
              wordv(nword) = line(pos1:i-1)
              pos1 = 0
          elseif (.not. ch_is_space(ch) .and. pos1 == 0) then  ! carattere diverso da spazio
              pos1 = i
          endif
      endif
   enddo
   if (pos1 > 0) then
          !  write(0,*)'fine line=',line(pos1:)
       if (word_in_quotes) then
           nword = nword + 1
           wordv(nword) = line(pos1+1:lent)
       else
           nword = nword + 1
           wordv(nword) = line(pos1:lent)
       endif
   endif
!
   end subroutine get_words_quotes1

  !-----------------------------------------------------------------------

   Function U_Case(Text) Result (Mtext)
!
!  Conversion to upper case, text is not modified
!
   character (len=*), intent(in) :: text      ! String:"Input Line"
   character (len=len(text))     :: mtext     ! String:"INPUT LINE"
   integer, parameter            :: inc = ICHAR("A") - ICHAR("a")
   integer                       :: leng, pos

   mtext=text
   leng=len_trim(mtext)
   do pos=1,leng
      if (mtext(pos:pos) >= "a" .and. mtext(pos:pos) <= "z")           &
          mtext(pos:pos) = CHAR ( ICHAR(mtext(pos:pos)) + inc )
   end do

   return
   End Function U_Case

 !-----------------------------------------------------------------------

   Subroutine Init_Err_String()
!
!  Initializes general error variables for this module as:
!  ERR_STRING=.false. ;  ERR_MESS_STRING=" "
!
   err_string=.false.
   err_mess_string=" "

   return
   End Subroutine Init_Err_String

 !-----------------------------------------------------------------------

   integer function Lung (Stringa)
   implicit none
!
   character(len=*), intent(in) :: stringa
   integer                      :: K
   integer                      :: I
   integer                      :: num
!
   K = len (Stringa)
   do I = K, 1, -1
       num = ichar(Stringa(I:I))
       if (num.ne.32.and.num.ne.0) then
          Lung = I
          return
       end if
   enddo
   Lung = 0
!
   end function Lung

 !-----------------------------------------------------------------------

   elemental function addc0(s0)
!
!  add char(0) to string
!
   character(len=*), intent(in) :: s0
   character(len=len(s0)) :: addc0
   addc0=trim(s0)//char(0)
   end function addc0

 !-----------------------------------------------------------------------

   elemental function remc0(s0)
!
!  remove char(0) from string
!
   character(len=*), intent(in) :: s0
   character(len=len(s0))       :: remc0
   integer                      :: pos0
!
   pos0 = index(s0,char(0))
   if (pos0 > 0) then
       remc0 = s0(1:pos0-1)
   else
       remc0 = s0
   endif
!
   end function remc0

 !-----------------------------------------------------------------------

   elemental function add_c0(s0,pos)  result(str)
!
!  Aggiungi char(0) non oltre pos
!
   character(len=*), intent(in) :: s0
   integer, intent(in)          :: pos
   character(len=len(s0)+1)     :: str
!
   if (len_trim(s0) < pos) then
       str = trim(s0)//char(0)
   else
       str = s0(:pos-1)//char(0)
   endif
!
   end function add_c0
 !-----------------------------------------------------------------------

   subroutine s_cat0(s1,s2)
!
!  Concatena 2 stringhe in s1 e s2 separandole con un blank
!
   character(len=*), intent(inout) :: s1
   character(len=*), intent(in)    :: s2
!
   s1(len_trim(s1)+1:) = ' '//s2
!
   end subroutine s_cat0

  !-----------------------------------------------------------------------

   subroutine s_catend(s1,s2)
!
!  Concatena 2 stringhe in s1 e s2 aggiungendo char(13)//char(10) per segnalare la fine della riga
!
   character(len=*), intent(inout) :: s1
   character(len=*), intent(in)    :: s2
!
   s1(len_trim(s1)+1:) = s2//char(13)//char(10)
!
   end subroutine s_catend

  !-----------------------------------------------------------------------

   subroutine svec_sort_heap_a_index ( n, sarray, indx )
!
!! SVEC_SORT_HEAP_A_INDEX does a case-sensitive indexed heap sort of a vector of strings.
!
!  Discussion:
!
!    The sorting is not actually carried out.
!    Rather an index array is created which defines the sorting.
!    This array may be used to sort or index the array, or to sort or
!    index related arrays keyed on the original array.
!
!    The ASCII collating sequence is used, and case is significant.
!    This means
!
!      A < B < C < .... < Y < Z < a < b < .... < z.
!
!    Numbers and other symbols may also occur, and will be sorted according to
!    the ASCII ordering.
!
!  Modified:
!
!    27 July 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer N, the number of entries in SARRAY.
!
!    Input, character ( len = * ) SARRAY(N), an array to be sorted.
!
!    Output, integer INDX(N), contains the sort index.  The
!    I-th element of the sorted array is SARRAY ( INDX(I) ).
!
    implicit none

    integer, parameter :: MAX_CHAR = 255
    integer n

    integer i
    integer indx(n)
    integer indxt
    integer ir
    integer j
    integer l
    character ( len = * ) sarray(n)
    character ( len = MAX_CHAR ) string

    do i = 1, n
      indx(i) = i
    end do

    l = n / 2 + 1
    ir = n

    do

      if ( 1 < l ) then

        l = l - 1
        indxt = indx(l)
        string = sarray(indxt)

      else

        indxt = indx(ir)
        string = sarray(indxt)
        indx(ir) = indx(1)
        ir = ir - 1

        if ( ir == 1 ) then
          indx(1) = indxt
          return
        end if

      end if

      i = l
      j = l + l

      do while ( j <= ir )

        if ( j < ir ) then
          if ( llt ( sarray ( indx(j) ), sarray ( indx(j+1) ) ) ) then
            j = j + 1
          end if
        end if

        if ( llt ( string, sarray ( indx(j) ) ) ) then
          indx(i) = indx(j)
          i = j
          j = j + j
        else
          j = ir + 1
        end if

      end do

      indx(i) = indxt

    end do

    return
   end subroutine svec_sort_heap_a_index

 !--------------------------------------------------------------------------------------------

   subroutine s_rep_ch ( s, c1, c2 )
!
!! S_REP_CH replaces all occurrences of one character by another.
!
!  Modified:
!
!    27 March 2002
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input/output, character ( len = * ) S, the string.
!
!    Input, character C1, C2, the character to be replaced, and the
!    replacement character.
!
   implicit none

   character c1
   character c2
   integer i
   character ( len = * ) s

   do i = 1, len ( s )
     if ( s(i:i) == c1 ) then
       s(i:i) = c2
     end if
   end do

   return
   end subroutine s_rep_ch

 !----------------------------------------------------------------------------------------------

subroutine s_rep ( s, sub1, sub2, irepp )

!*******************************************************************************
!
!! S_REP replaces all occurrences of SUB1 by SUB2 in a string.
!
!  Discussion:
!
!    This is not always true if SUB2 is longer than SUB1.  The
!    replacement is NOT recursive.  In other words, replacing all
!    occurrences of "ab" by "a" in "abbbbb" will return "abbbb"
!    rather than "a".
!
!  Modified:
!
!    14 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input/output, character ( len = * ) S.  On input,
!    the string in which occurrences are to be replaced.
!    On output, the revised string.
!
!    Input, character ( len = * ) SUB1, the string which is to be replaced.
!    Trailing blank characters are ignored.  The routine is case sensitive.  
!
!    Input, character ( len = * ) SUB2, the replacement string.
!
!    Output, integer IREP, the number of replacements made.
!    If IREP is negative, then its absolute value is the
!    number of replacements made, and SUB2 is longer than
!    SUB1, and at least one substring SUB1 could not be
!    replaced by SUB2 because there was no more space.
!    (If S = 'aab' and SUB1 = 'a' and SUB2 = 'cc'
!    then the result would be S = 'cca'.  The first 'a'
!    was replaced, the 'b' fell off the end, the second 'a'
!    was not replaced because the replacement 'cc' would have
!    fallen off the end)
!
  implicit none

  integer, intent(out), optional :: irepp
  integer ilo
  integer irep
  integer len1
  integer len2
  integer lens
  integer loc
  character ( len = * ) s
  character ( len = * ) sub1
  character ( len = * ) sub2

  irep = 0
  lens = len ( s )
 
  if ( lens <= 0 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'S_REP - Serious error!'
    write ( *, '(a)' ) '  Null string not allowed!'
    if (present(irepp)) irepp = irep
    return
  end if
 
  len1 = len_trim ( sub1 )
 
  if ( len1 <= 0 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'S_REP - Serious error!'
    write ( *, '(a)' ) '  Null SUB1 not allowed!'
    if (present(irepp)) irepp = irep
    return
  end if
 
  len2 = len_trim ( sub2 )
 
  if ( len2 == len1 ) then
 
    if ( sub1(1:len1) == sub2(1:len2) ) then
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'S_REP - Warning!'
      write ( *, '(a)' ) '  Replacement = original!'
      if (present(irepp)) irepp = irep
      return
    end if
 
    ilo = 1

    do

      loc = index ( s(ilo:lens), sub1(1:len1) )

      if ( loc == 0 ) then
        exit
      end if

      loc = loc + ilo - 1
      irep = irep + 1
      s(loc:loc+len1-1) = sub2(1:len2)
      ilo = loc + len1

      if ( lens < ilo ) then
        exit
      end if

    end do
 
  else if ( len2 < len1 ) then
 
    ilo = 1

    do

      loc = index ( s(ilo:lens), sub1(1:len1) )

      if ( loc == 0 ) then
        exit
      end if

      irep = irep + 1
      loc = loc + ilo - 1
      s(loc:loc+len2-1) = sub2(1:len2)
      call s_chop ( s, loc+len2, loc+len1-1 )
      ilo = loc + len2

      if ( lens < ilo ) then
        exit
      end if

    end do
 
  else
 
    ilo = 1

    do

      loc = index ( s(ilo:lens), sub1(1:len1) )

      if ( loc == 0 ) then
        exit
      end if

      loc = loc + ilo - 1
      irep = irep + 1
 
      if ( lens < loc + len2 - 1 ) then
        irep = -irep
        write ( *, '(a)' ) ' '
        write ( *, '(a)' ) 'S_REP - Warning!'
        write ( *, '(a)' ) '  Some replaceable elements remain!'
        exit
      end if
 
      call s_blanks_insert ( s, loc, loc+len2-1-len1 )

      s(loc:loc+len2-1) = sub2(1:len2)
      ilo = loc + len2

    end do

  end if

  if (present(irepp)) irepp = irep
  return 

  end subroutine s_rep
 !----------------------------------------------------------------------------------------------

   subroutine s_filter(str)
!
!  filtra una stringa rimuovendo tutti i caratteri speciali
   character(len=*), intent(inout) :: str
   integer                         :: i
   integer                         :: nchar
!
   do i=1,len(str)
      nchar = ichar(str(i:i))
      if (nchar < 32 .or. nchar >= 127) str(i:i) = ' '
   enddo
!
   end subroutine s_filter

 !----------------------------------------------------------------------------------------------

   subroutine s_chop ( s, ilo, ihi )
!
!! S_CHOP "chops out" a portion of a string, and closes up the hole.
!
!  Example:
!
!    S = 'Fred is not a jerk!'
!
!    call s_chop ( S, 9, 12 )
!
!    S = 'Fred is a jerk!    '
!
!  Modified:
!
!    06 July 1998
!
!  Author:
!
!    John Burkardt modified by Corrado Cuocci
!
!  Parameters:
!
!    Input/output, character ( len = * ) S, the string to be transformed.
!
!    Input, integer ILO, IHI, the locations of the first and last
!    characters to be removed.
!
   implicit none

   integer, intent(in)           :: ilo
   integer, intent(in), optional :: ihi  ! se assente taglia fino alla fine
   integer ilo2
   integer ihi2
   integer lens
   character ( len = * ) s

   lens = len ( s )
   if (present(ihi)) then
       ihi2 = min ( ihi, lens )
   else
       ihi2 = lens
   endif

   ilo2 = max ( ilo, 1 )

   if ( ihi2 < ilo2 ) then
     return
   end if

   s(ilo2:lens+ilo2-ihi2-1) = s(ihi2+1:lens)
   s(lens+ilo2-ihi2:lens) = ' '

   return
   end subroutine s_chop

 !--------------------------------------------------------------------------------------------------

   function string_from_time(time)  result(stime)
!
!  Converte tempo in stringa. Il tempo va espresso in secondi
!
   implicit none
   integer, intent(in) :: time
   character(len=15)   :: stime
!
   select case (time)
       case (:59)
!
!         tempo inferiore a 1 min: scrivo solo i secondi
          write(stime,'(i2,a4)')time,'sec'

       case (60:599)
!
!         tempo di 1-10 minuti: scrivo min e sec
          write(stime,'(i2,a5,i2,a3)')time/60,'min  ',mod(time,60),'sec'

       case (600:3599)
!
!         tempo di 10-1h: scrivo solo min
          write(stime,'(i2,a3)')time/60,'min'

       case (3600:86399)
!
!         tempo di 1-24 ore: ore e minuti
          write(stime,'(i2,a3,i2,a3)')time/3600,'h  ',mod(time,3600)/60,'min'

       case (86400:)
!
!         pi� di 1 giorno
          write(stime,'(i3,a5)') time/86400,' day'
   end select
!
   end function string_from_time

 !--------------------------------------------------------------------------------------------------

   subroutine s_s_insert ( s, ipos, s2 )
!
!  S_S_INSERT inserts a substring into a string.
!
!  Discussion:
!
!    Characters in the string are moved to the right to make room, and
!    hence the trailing characters, if any, are lost.
!
!  Modified:
!
!    14 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input/output, character ( len = * ) S, the string into which
!    the second string is to be inserted.
!
!    Input, integer IPOS, the position in S at which S2 is to be inserted.
!
!    Input, character ( len = * ) S2, the string to be inserted.
!
   implicit none

   integer ihi
   integer ipos
   integer nchar
   integer nchar2
   character ( len = * ) s
   character ( len = * ) s2

   nchar = len ( s )
   nchar2 = len_trim ( s2 )

   ihi = min ( nchar, ipos+nchar2-1 )

   call s_blanks_insert ( s, ipos, ihi )

   s(ipos:ihi) = s2

   return
   end subroutine s_s_insert

 !----------------------------------------------------------------------------------------------------

   subroutine s_ch_blank ( s, c )

!*******************************************************************************
!
!! S_CH_BLANK replaces each occurrence of a particular character by a blank.
!
!  Modified:
!
!    28 June 2000
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input/output, character ( len = * ) S, the string to be transformed.
!
!    Input, character C, the character to be removed.
!
   implicit none

   character c
   integer i
   integer nchar
   character ( len = * ) s

   nchar = len_trim ( s )

   do i = 1, nchar
 
      if ( s(i:i) == c ) then
        s(i:i) = ' '
      end if
 
   end do

   return
   end subroutine s_ch_blank

 !----------------------------------------------------------------------------------------------------

   function s_blank_delete ( s )  result(sblank)

!*******************************************************************************
!
!! S_BLANK_DELETE removes blanks from a string, left justifying the remainder.
!
!  Comment:
!
!    All TAB characters are also removed.
!
!  Modified:
!
!    26 July 1998
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input/output, character ( len = * ) S, the string to be transformed.
!
   implicit none

   character( len = * ), intent(in) :: s
   character( len = len_trim(s))    :: sblank
   character, parameter             :: TAB = char ( 9 )
   character                        :: c
   integer                          :: get
   integer                          :: put
   integer                          :: nchar

   put = 0
   nchar = len_trim ( s )

   do get = 1, nchar

     c = s(get:get)
 
     if ( c /= ' ' .and. c /= TAB ) then
       put = put + 1
       sblank(put:put) = c
     end if
 
   end do
 
   sblank(put+1:nchar) = ' '
  
   end function s_blank_delete

 !----------------------------------------------------------------------------------------------------

   subroutine s_blanks_delete ( s )

!*******************************************************************************
!
!! S_BLANKS_DELETE replaces consecutive blanks by one blank.
!
!  Discussion:
!
!    Thanks to Bill Richmond for pointing out a programming flaw which
!    meant that, as characters were slid to the left through multiple
!    blanks, their original images were not blanked out.  This problem
!    is easiest resolved by using a copy of the string.
!
!    The remaining characters are left justified and right padded with blanks.
!    TAB characters are converted to spaces.
!
!  Modified:
!
!    30 September 2004
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input/output, character ( len = * ) S, the string to be transformed.
!
   implicit none

   integer i
   integer j
   character newchr
   character oldchr
   character ( len = * ) s
   integer s_len
   character, parameter :: TAB = char ( 9 )
   character ( len = len ( s ) ) s_copy

   s_len = len ( s )

   j = 0
   s_copy(1:s_len) = s(1:s_len)
   s(1:s_len) = ' '

   newchr = ' '
 
   do i = 1, s_len
 
     oldchr = newchr
     newchr = s_copy(i:i)

     if ( newchr == TAB ) then
       newchr = ' '
     end if
 
     if ( oldchr /= ' ' .or. newchr /= ' ' ) then
       j = j + 1
       s(j:j) = newchr
     end if
 
   end do
 
   return
   end subroutine s_blanks_delete

 !----------------------------------------------------------------------------------------------------

   subroutine s_blanks_insert ( s, ilo, ihi )
!
!! S_BLANKS_INSERT inserts blanks into a string, sliding old characters over.
!
!  Discussion:
!
!    Characters at the end of the string "drop off" and are lost.
!
!  Modified:
!
!    14 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input/output, character ( len = * ) S, the string to be transformed.
!
!    Input, integer ILO, the location where the first blank is to be inserted.
!
!    Input, integer IHI, the location where the last blank is to be inserted.
!
   implicit none

   character c
   integer i
   integer get
   integer ihi
   integer ilo
   integer imax
   integer imin
   integer put
   integer nchar
   integer nmove
   character ( len = * ) s

   nchar = len ( s )

   if ( ihi < ilo .or. nchar < ilo ) then
     return
   end if

   if ( ihi <= nchar ) then
     imax = ihi
   else
     imax = nchar
   end if

   if ( 1 <= ilo ) then
     imin = ilo
   else
     imin = 1
   end if

   nmove = nchar - imax

   do i = 1, nmove
     put = nchar + 1 - i
     get = nchar - imax + imin - i
     c = s(get:get)
     s(put:put) = c
   end do

   do i = imin, imax
     s(i:i) = ' '
   end do

   return
   end subroutine s_blanks_insert

 !----------------------------------------------------------------------------------------------------

   subroutine s_s_delete ( s, sub, irepp )
!
!  S_S_DELETE removes all occurrences of a substring from a string.
!
!  Discussion:
!
!    The remainder is left justified and padded with blanks.
!
!    The deletion is not recursive.  Removing all occurrences of "ab" from
!    "aaaaabbbbbQ" results in "aaaabbbbQ" rather than "Q".
!
!  Modified:
!
!    14 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input/output, character ( len = * ) S, the string to be transformed.
!
!    Input, character ( len = * ) SUB1, the substring to be removed.
!
!    Output, integer IREP, the number of occurrences of SUB1
!    which were found.
!
   implicit none

   integer, intent(out), optional :: irepp
   integer ihi
   integer ilo
   integer irep
   integer loc
   integer nsub
   character ( len = * ) s
   character ( len = * ) sub

   nsub = len_trim ( sub )

   irep = 0
   ilo = 1
   ihi = len_trim ( s )

   do while ( ilo <= ihi )

     loc = index ( s(ilo:ihi), sub )

     if ( loc == 0 ) then
       if (present(irepp)) irepp = irep
       return
     end if

     irep = irep + 1
     loc = loc + ilo - 1
     call s_chop ( s, loc, loc+nsub-1 )
     ilo = loc
     ihi = ihi - nsub

   end do

   if (present(irepp)) irepp = irep
   return

   end subroutine s_s_delete

 !----------------------------------------------------------------------------------------------------

   function upper ( s )
!
!  UPPER returns an uppercase version of a string.
!
!  Discussion:
!
!    UPPER is a string function of undeclared length.  The length
!    of the argument returned is determined by the declaration of
!    UPPER in the calling routine.
!
!  Modified:
!
!    11 July 2000
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, character ( len = * ) S, a string.
!
!    Output, character ( len = * ) UPPER, an uppercase copy of the string.
!
   implicit none

   integer i
   integer j
   integer n
   character ( len = * ) s
   character ( len = len(s) ) upper

   upper = s
   n = len_trim ( upper )
   do i = 1, n
     j = ichar ( upper(i:i) )
     if ( 97 <= j .and. j <= 122 ) then
       upper(i:i) = char ( j - 32 )
     end if
   end do
   end function upper

 !----------------------------------------------------------------------------------------------------

   function lower ( s )
!
!  LOWER returns a lowercase version of a string.
!
!  Discussion:
!
!    LOWER is a string function of undeclared length.  The length
!    of the argument returned is determined by the declaration of
!    LOWER in the calling routine.
!
!  Modified:
!
!    11 July 2000
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, character ( len = * ) S, a string.
!
!    Output, character ( len = * ) LOWER, a lowercase copy of the string.
!
   implicit none

   integer i
   integer j
   character ( len = * ) s
   character ( len = len(s) ) lower
   integer n

   lower = s
   n = len_trim ( lower )
   do i = 1, n
      j = ichar ( lower(i:i) )
      if ( 65 <= j .and. j <= 90 ) then
        lower(i:i) = char ( j + 32 )
      end if
   end do

   end function lower

 !----------------------------------------------------------------------------------------------------

   function s_cap_word ( s )   result(s_cap)
!
!  Capitalizes the first character in a word s
!
   character ( len = * ), intent(in) :: s
   integer                           :: i
   character ( len = len(s) )        :: s_cap
   integer, parameter                :: inc = ICHAR("A") - ICHAR("a")
   integer                           :: n
   character, parameter              :: TAB = char ( 9 )

   s_cap = s
   n = len_trim ( s_cap )
   do i = 1, n
      select case (s_cap(i:i))
        case ('a':'z')
         s_cap(i:i) = char( ichar(s_cap(i:i)) + inc )
         exit
        case (' ',TAB)
        case default
         exit
      end select
   end do

   end function s_cap_word

 !----------------------------------------------------------------------------------------------------

   subroutine s_to_r ( s, r, ierror, slen )

!*******************************************************************************
!
!! S_TO_R reads a real number from a string.
!
!  Discussion:
!
!    This routine will read as many characters as possible until it reaches
!    the end of the string, or encounters a character which cannot be
!    part of the real number.
!
!    Legal input is:
!
!       1 blanks,
!       2 '+' or '-' sign,
!       2.5 spaces
!       3 integer part,
!       4 decimal point,
!       5 fraction part,
!       6 'E' or 'e' or 'D' or 'd', exponent marker,
!       7 exponent sign,
!       8 exponent integer part,
!       9 exponent decimal point,
!      10 exponent fraction part,
!      11 blanks,
!      12 final comma or semicolon.
!
!    with most quantities optional.
!
!  Examples:
!
!    S                 R
!
!    '1'               1.0
!    '     1   '       1.0
!    '1A'              1.0
!    '12,34,56'        12.0
!    '  34 7'          34.0
!    '-1E2ABCD'        -100.0
!    '-1X2ABCD'        -1.0
!    ' 2E-1'           0.2
!    '23.45'           23.45
!    '-4.2E+2'         -420.0
!    '17d2'            1700.0
!    '-14e-2'         -0.14
!    'e2'              100.0
!    '-12.73e-9.23'   -12.73 * 10.0**(-9.23)
!
!  Modified:
!
!    12 February 2001
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, character ( len = * ) S, the string containing the
!    data to be read.  Reading will begin at position 1 and
!    terminate at the end of the string, or when no more
!    characters can be read to form a legal real.  Blanks,
!    commas, or other nonnumeric data will, in particular,
!    cause the conversion to halt.
!
!    Output, real R, the real value that was read from the string.
!
!    Output, integer IERROR, error flag.
!
!    0, no errors occurred.
!
!    1, 2, 6 or 7, the input number was garbled.  The
!    value of IERROR is the last type of input successfully
!    read.  For instance, 1 means initial blanks, 2 means
!    a plus or minus sign, and so on.
!
!    Output, integer LENGTH, the number of characters read from
!    the string to form the number, including any terminating
!    characters such as a trailing comma or blanks.
!
   implicit none

   character c
   integer ierror
   integer ihave
   integer isgn
   integer iterm
   integer jbot
   integer jsgn
   integer jtop
   integer length
   integer nchar
   integer ndig
   real r
   real rbot
   real rexp
   real rtop
   character ( len = * ) s
   character, parameter :: TAB = char ( 9 )
   integer, intent(out), optional :: slen

   nchar = len_trim ( s )
   ierror = 0
   r = 0.0E+00
   length = -1
   isgn = 1
   rtop = 0.0E+00
   rbot = 1.0E+00
   jsgn = 1
   jtop = 0
   jbot = 1
   ihave = 1
   iterm = 0

   do

     length = length + 1
     c = s(length+1:length+1)
!
!   Blank or TAB character.
!
     if ( c == ' ' .or. c == TAB ) then

       if ( ihave == 2 ) then

       else if ( ihave == 6 .or. ihave == 7 ) then
         iterm = 1
       else if ( 1 < ihave ) then
         ihave = 11
       end if
!
!   Comma.
!
     else if ( c == ',' .or. c == ';' ) then

       if ( ihave /= 1 ) then
         iterm = 1
         ihave = 12
         length = length + 1
       end if
!
!   Minus sign.
!
     else if ( c == '-' ) then

       if ( ihave == 1 ) then
         ihave = 2
         isgn = -1
       else if ( ihave == 6 ) then
         ihave = 7
         jsgn = -1
       else
         iterm = 1
       end if
!
!   Plus sign.
!
     else if ( c == '+' ) then

       if ( ihave == 1 ) then
         ihave = 2
       else if ( ihave == 6 ) then
         ihave = 7
       else
         iterm = 1
       end if
!
!   Decimal point.
!
     else if ( c == '.' ) then

       if ( ihave < 4 ) then
         ihave = 4
       else if ( 6 <= ihave .and. ihave <= 8 ) then
         ihave = 9
       else
         iterm = 1
       end if
!
!   Exponent marker.
!
     else if ( ch_eqi ( c, 'E' ) .or. ch_eqi ( c, 'D' ) ) then

       if ( ihave < 6 ) then
         ihave = 6
       else
         iterm = 1
       end if
!
!   Digit.
!
     else if ( ihave < 11 .and. lle ( '0', c ) .and. lle ( c, '9' ) ) then

       if ( ihave <= 2 ) then
         ihave = 3
       else if ( ihave == 4 ) then
         ihave = 5
       else if ( ihave == 6 .or. ihave == 7 ) then
         ihave = 8
       else if ( ihave == 9 ) then
         ihave = 10
       end if

       call ch_to_digit ( c, ndig )

       if ( ihave == 3 ) then
         rtop = 10.0E+00 * rtop + real ( ndig )
       else if ( ihave == 5 ) then
         rtop = 10.0E+00 * rtop + real ( ndig )
         rbot = 10.0E+00 * rbot
       else if ( ihave == 8 ) then
         jtop = 10 * jtop + ndig
       else if ( ihave == 10 ) then
         jtop = 10 * jtop + ndig
         jbot = 10 * jbot
       end if
!
!   Anything else is regarded as a terminator.
!
     else
       iterm = 1
     end if
!
!   If we haven't seen a terminator, and we haven't examined the
!   entire string, go get the next character.
!
     if ( iterm == 1 .or. nchar <= length+1 ) then
       exit
     end if

   end do
!
!   If we haven't seen a terminator, and we have examined the
!   entire string, then we're done, and LENGTH is equal to NCHAR.
!
   if ( iterm /= 1 .and. length+1 == nchar ) then
     length = nchar
   end if
!
!   Number seems to have terminated.  Have we got a legal number?
!   Not if we terminated in states 1, 2, 6 or 7!
!
   if ( ihave == 1 .or. ihave == 2 .or. ihave == 6 .or. ihave == 7 ) then

     ierror = ihave

     if (present(slen)) slen = length
     return
   end if
!
!   Number seems OK.  Form it.
!
   if ( jtop == 0 ) then
     rexp = 1.0E+00
   else

     if ( jbot == 1 ) then
       rexp = 10.0E+00**( jsgn * jtop )
     else
       rexp = jsgn * jtop
       rexp = rexp / jbot
       rexp = 10.0E+00**rexp
     end if

   end if

   r = isgn * rexp * rtop / rbot

   if (present(slen)) slen = length

   end subroutine s_to_r

 !----------------------------------------------------------------------------------------------------

   subroutine s_to_i ( s, ival, ierror, length )

!*******************************************************************************
!
!! S_TO_I reads an integer value from a string.
!
!  Modified:
!
!    28 June 2000
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, character ( len = * ) S, a string to be examined.
!
!    Output, integer IVAL, the integer value read from the string.
!    If the string is blank, then IVAL will be returned 0.
!
!    Output, integer IERROR, an error flag.
!    0, no error.
!    1, an error occurred.
!
!    Output, integer LENGTH, the number of characters of S used to make IVAL.
!
   implicit none

   character c
   integer i
   integer ierror
   integer isgn
   integer istate
   integer ival
   integer length
   character ( len = * ) s

   ierror = 0
   istate = 0
   isgn = 1
   ival = 0

   do i = 1, len_trim ( s )

     c = s(i:i)
!
!   Haven't read anything.
!
     if ( istate == 0 ) then

       if ( c == ' ' ) then

       else if ( c == '-' ) then
         istate = 1
         isgn = -1
       else if ( c == '+' ) then
         istate = 1
         isgn = + 1
       else if ( lle ( '0', c ) .and. lle ( c, '9' ) ) then
         istate = 2
         ival = ichar ( c ) - ichar ( '0' )
       else
         ierror = 1
         return
       end if
!
!   Have read the sign, expecting digits.
!
     else if ( istate == 1 ) then

       if ( c == ' ' ) then

       else if ( lle ( '0', c ) .and. lle ( c, '9' ) ) then
         istate = 2
         ival = ichar ( c ) - ichar ( '0' )
       else
         ierror = 1
         return
       end if
!
!   Have read at least one digit, expecting more.
!
     else if ( istate == 2 ) then

       if ( lle ( '0', c ) .and. lle ( c, '9' ) ) then
         ival = 10 * ival + ichar ( c ) - ichar ( '0' )
       else
         ival = isgn * ival
         length = i - 1
         return
       end if

     end if

   end do
!
!   If we read all the characters in the string, see if we're OK.
!
   if ( istate == 2 ) then
     ival = isgn * ival
     length = len_trim ( s )
   else
     ierror = 1
     length = 0
   end if

   end subroutine s_to_i

 !---------------------------------------------------------------------------------------------

   function ch_eqi ( c1, c2 )

   !*******************************************************************************
   !
   !! CH_EQI is a case insensitive comparison of two characters for equality.
   !
   !  Examples:
   !
   !    CH_EQI ( 'A', 'a' ) is TRUE.
   !
   !  Modified:
   !
   !    28 July 2000
   !
   !  Author:
   !
   !    John Burkardt
   !
   !  Parameters:
   !
   !    Input, character C1, C2, the characters to compare.
   !
   !    Output, logical CH_EQI, the result of the comparison.
   !
     implicit none

     character c1
     character c1_cap
     character c2
     character c2_cap
     logical ch_eqi

     c1_cap = c1
     c2_cap = c2

     call ch_cap ( c1_cap )
     call ch_cap ( c2_cap )

     if ( c1_cap == c2_cap ) then
       ch_eqi = .true.
     else
       ch_eqi = .false.
     end if

   end function ch_eqi

 !---------------------------------------------------------------------------------------------

   function s_eqi ( s1, s2 )

   !*******************************************************************************
   !
   !! S_EQI is a case insensitive comparison of two strings for equality.  
   !
   !  Examples:
   !
   !    S_EQI ( 'Anjana', 'ANJANA' ) is TRUE.
   !
   !  Modified:
   !
   !    14 April 1999
   !
   !  Author:
   !
   !    John Burkardt
   !
   !  Parameters:
   !
   !    Input, character ( len = * ) S1, S2, the strings to compare.
   !
   !    Output, logical S_EQI, the result of the comparison.
   !
   implicit none

   character c1
   character c2
   integer i
   integer len1
   integer len2
   integer lenc
   logical s_eqi
   character ( len = * ), intent(in) ::  s1
   character ( len = * ), intent(in) ::  s2

   len1 = len ( s1 )
   len2 = len ( s2 )
   lenc = min ( len1, len2 )
 
   s_eqi = .false.

   do i = 1, lenc

     c1 = s1(i:i)
     c2 = s2(i:i)
     call ch_cap ( c1 )
     call ch_cap ( c2 )

     if ( c1 /= c2 ) then
       return
     end if

   end do

   do i = lenc + 1, len1
     if ( s1(i:i) /= ' ' ) then
       return
     end if
   end do

   do i = lenc + 1, len2
     if ( s2(i:i) /= ' ' ) then
       return
     end if
   end do

   s_eqi = .true.

   return
   end function s_eqi

 !---------------------------------------------------------------------------------------------

   function s_eqidb ( s1, s2 )

!*******************************************************************************
!
!! S_EQIDB compares two strings, ignoring case and blanks.
!
!  Examples:
!
!    S_EQIDB ( 'Nor Way', 'NORway' ) is TRUE.
!
!  Modified:
!
!    14 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Modified:
!
!    19 July 1998
!
!  Parameters:
!
!    Input, character ( len = * ) S1, S2, the strings to compare.
!
!    Output, logical S_EQIDB, the result of the comparison.
!
   character c1
   character c2
   integer i1
   integer i2
   integer len1
   integer len2
   logical s_eqidb
   character ( len = * ) s1
   character ( len = * ) s2
!
!  Get the length of each string to the last nonblank.
!
   len1 = len_trim ( s1 )
   len2 = len_trim ( s2 )
!
!  Assume we're going to fail.
!
   s_eqidb = .false.
!
!  Initialize the pointers to characters in each string.
!
   i1 = 0
   i2 = 0
 
   do
!
!  If we've matched all the nonblank characters in both strings,
!  then return with S_EQIDB = TRUE.
!
    if ( i1 == len1 .and. i2 == len2 ) then
      s_eqidb = .true.
      return
    end if
!
!  Get the next nonblank character in the first string.
!
    do
 
      i1 = i1 + 1
 
      if ( len1 < i1 ) then
        return
      end if
 
      if ( s1(i1:i1) /= ' ' ) then
        exit
      end if
 
    end do
 
    c1 = s1(i1:i1)
    call ch_cap ( c1 )
!
!  Get the next nonblank character in the second string.
!
    do
 
      i2 = i2 + 1
      if ( len2 < i2 ) then
        return
      end if
 
      c2 = s2(i2:i2)

      if ( c2 /= ' ' ) then
        exit
      end if
 
    end do
 
    call ch_cap ( c2 )
 
    if ( c1 /= c2 ) then
      exit
    end if
 
   end do

   return
   end function s_eqidb

 !---------------------------------------------------------------------------------------------

   subroutine ch_cap ( c )

!*******************************************************************************
!
!! CH_CAP capitalizes a single character.
!
!  Modified:
!
!    19 July 1998
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input/output, character C, the character to capitalize.
!
   implicit none

   character c
   integer itemp

   itemp = ichar ( c )

   if ( 97 <= itemp .and. itemp <= 122 ) then
     c = char ( itemp - 32 )
   end if

   end subroutine ch_cap

 !---------------------------------------------------------------------------------------------
   subroutine ch_to_digit ( c, digit )

!*******************************************************************************
!
!! CH_TO_DIGIT returns the integer value of a base 10 digit.
!
!  Example:
!
!     C   DIGIT
!    ---  -----
!    '0'    0
!    '1'    1
!    ...  ...
!    '9'    9
!    ' '    0
!    'X'   -1
!
!  Modified:
!
!    04 August 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, character C, the decimal digit, '0' through '9' or blank
!    are legal.
!
!    Output, integer DIGIT, the corresponding integer value.  If C was
!    'illegal', then DIGIT is -1.
!
   implicit none

   character, intent(in) :: c
   integer, intent(out)  :: digit

   if ( lle ( '0', c ) .and. lle ( c, '9' ) ) then

     digit = ichar ( c ) - 48

   else if ( c == ' ' ) then

     digit = 0

   else

     digit = -1

   end if

   end subroutine ch_to_digit

 !---------------------------------------------------------------------------------------------

   function catsvector(vets)  result(stringv)
!
!  Concatena un vettore di stringhe in un'unica stringa senza rimuovere gli spazi vuoti. 
!  Autore:C. Cuocci
!
   character(len=*), dimension(:), intent(in) :: vets
   character(len=len(vets(1))*size(vets))     :: stringv
   integer                                    :: i
   integer                                    :: lens
!
   lens = len(vets(1))
   stringv = vets(1)
   do i=2,size(vets)
      stringv(1:lens*i) = stringv(1:(i-1)*lens)//vets(i)
   enddo
!
   end function catsvector
   
 !---------------------------------------------------------------------------------------------

   function catsvector2(vets,sep)  result(stringv)
!
!  Concatena un vettore di stringhe in un'unica stringa rimuovendo gli spazi vuoti  e introducendo un separatore
!  Autore:C. Cuocci
!
   character(len=*), dimension(:), intent(in)                 :: vets
   character(len=*), intent(in)                               :: sep   ! separatore di stringhe
   character(len=len(vets(1))*size(vets)+len(sep)*size(vets)) :: stringv
   integer                                                    :: i
   integer                                                    :: lens
!
   lens = len_trim(vets(1))
   stringv = vets(1)
   do i=2,size(vets)
      stringv(:) = trim(stringv)//sep//trim(vets(i))
   enddo
!
   end function catsvector2

 !----------------------------------------------------------------------------------------------------

   function centra_str(string,n)  result(str)
!
!  Centra la stringa in un campo di ampiezza n
!
   implicit none
   integer, intent(in)             :: n
   character(len=*), intent(in)    :: string
   character(len=len_trim(string)) :: stringc
   character(len=n)                :: str
   integer                         :: nlt
!
   stringc = adjustl(string)
   nlt = len_trim(stringc)
   if (n > nlt) then
       str = ' '
       str(nint(n/2.0)-nint(nlt/2.0)+1:) = stringc
   else
       str = stringc(1:n)
   endif
!
   end function centra_str 
   
!----------------------------------------------------------------------------------------------------

function s_center ( string )

!
!! S_CENTER centers the non-blank portion of a string.
!
!  Modified:
!
!    07 October 2002
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input/output, character ( len = * ) STRING.  On input, a string to be
!    centered.  On output, the centered string.
!

  integer l1
  integer l2
  integer n1
  integer n2
  integer n3
  character ( len = * ), intent(in) ::  string
  character (len=len(string))       :: s_center
!
  s_center = string
!
!  How much space is in the string?
!
  n1 = len ( s_center )
!
!  Shift the string flush left and find the last nonblank.
!
  s_center = adjustl ( s_center )
  n2 = len_trim ( s_center )

  if ( n2 <= 0 ) then
    return
  end if

  if ( n2 == n1 .or. n2 == n1-1 ) then
    return
  end if

  n3 = n1 - n2
  l1 = n3 / 2
  l2 = l1 + n2 + 1

  s_center(l1+1:l2-1) = s_center(1:n2)

  s_center(1:l1) = ' '
  s_center(l2:n1) = ' '

  end function s_center

!----------------------------------------------------------------------------------------------------
  
   function catstringpar_r(string,par,fmtt) result(strr)
   character(len=*), intent(in)              :: string
   real, intent(in)                          :: par
   character(len=*), intent(in)              :: fmtt
   integer, parameter                        :: maxlens = 100
   character(len=maxlens)                    :: strp
   character(len=len_trim(string)+maxlens) :: strr   
   integer                                   :: ier
!
   write(strp,fmt=fmtt,iostat=ier)par  
!   
! c'� errore se il formato non � compatibile con la lunghezza di strp
   if (ier == 0) then
       strr = trim(string)//trim(adjustl(strp))
   else
       strr = '*'
   endif
!
   end function catstringpar_r     
   
!----------------------------------------------------------------------------------------------------
  
   function catstringpar_i(string,par,fmtt) result(strr)
   character(len=*), intent(in)            :: string
   integer, intent(in)                     :: par
   character(len=*), intent(in)            :: fmtt
   integer, parameter                      :: maxlens = 200
   character(len=maxlens)                  :: strp
   character(len=len_trim(string)+maxlens) :: strr   
   integer                                 :: ier
!
   write(strp,fmt=fmtt,iostat=ier)par  
!   
!  c'� errore se il formato non � compatibile con la lunghezza di strp
   if (ier == 0) then
       strr = trim(string)//trim(adjustl(strp))
   else
       strr = '*'
   endif
!   
   end function catstringpar_i        
   
!----------------------------------------------------------------------------------------------------
  
   function catstringpar_vetr(string,par,fmtt) result(strr)
   character(len=*), intent(in)              :: string
   real, dimension(:), intent(in)            :: par
   character(len=*), intent(in)              :: fmtt
   integer, parameter                        :: maxlens = 200
   character(len=maxlens)                    :: strp
   character(len=len_trim(string)+maxlens) :: strr   
   integer                                   :: ier
!
   write(strp,fmt=fmtt,iostat=ier)par  
!   
! c'� errore se il formato non � compatibile con la lunghezza di strp
   if (ier == 0) then
       strr = trim(string)//trim(adjustl(strp))
   else
       strr = '*'
   endif
!
   end function catstringpar_vetr     
   
!----------------------------------------------------------------------------------------------------
  
   function catstringpar_veti(string,par,fmtt) result(strr)
   character(len=*), intent(in)            :: string
   integer, dimension(:), intent(in)       :: par
   character(len=*), intent(in)            :: fmtt
   integer, parameter                      :: maxlens = 200
   character(len=maxlens)                  :: strp
   character(len=len_trim(string)+maxlens) :: strr   
   integer                                 :: ier
!
   write(strp,fmt=fmtt,iostat=ier)par  
!   
! c'� errore se il formato non � compatibile con la lunghezza di strp
   if (ier == 0) then
       strr = trim(string)//trim(adjustl(strp))
   else
       strr = '*'
   endif
!
   end function catstringpar_veti
      
!----------------------------------------------------------------------------------------------------

   function number_to_format_veti(vet) result(fformat)
   integer, dimension(:), intent(in) :: vet
   integer                           :: ns
   character(len=100)                :: fformat
!
   ns = size(vet)
   if (ns == 1) then
       write(fformat,'(a,i0,a)')'(i0)'
   elseif (ns > 1) then
       write(fformat,'(a,i0,a)')'(',ns,'(i0,1x))'
   endif
!   
   end function number_to_format_veti

   function position_stringv(str,stringv) result(pos)
!   
!  Cerca la prima posizione di str nel vettore stringv 
!  (funzione obsoleta da sostituire con la pos_string_in_vector)
!
   character(len=*), intent(in)               :: str
   character(len=*), dimension(:), intent(in) :: stringv
   integer                                    :: pos
   character(len=len_trim(str))               :: str0,str1
   integer                                    :: i
   integer                                    :: lens
!
   lens = len_trim(str)
   str0 = u_case(trim(str))
   pos = 0
   do i=1,size(stringv)
      if (len_trim(stringv(i)) /= lens) cycle
      str1 = u_case(trim(stringv(i)))
      if (str1 == str0) then
          pos = i
          exit
      endif
   enddo
!   
   end function position_stringv

function s_is_alpha ( s )
!
!*******************************************************************************
!
!! S_IS_ALPHA returns .TRUE. if the string contains only alphabetic characters.
!
!
!  Discussion:
!
!    Here, alphabetic characters are 'A' through 'Z' and 'a' through 'z'.
!
!  Modified:
!
!    14 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, character ( len = * ) S, the string to be checked.
!
!    Output, logical S_IS_ALPHA, .TRUE. if the string contains only
!    alphabetic characters, .FALSE. otherwise.
!
  implicit none
!
  integer i
  character ( len = * ) s
  logical s_is_alpha
!
  s_is_alpha = .false.

  do i = 1, len ( s )

    if ( .not. ch_is_alpha ( s(i:i) ) ) then
      return
    end if

  end do
 
  s_is_alpha = .true.

end function s_is_alpha

function s_is_alphanumeric ( s )

!*******************************************************************************
!
!! S_IS_ALPHANUMERIC = string contains only alphanumeric characters.
!
!  Discussion:
!
!    Alphanumeric characters are 'A' through 'Z', 'a' through 'z' and
!    '0' through '9'.
!
!  Modified:
!
!    14 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, character ( len = * ) S, the string to be checked.
!
!    Output, logical S_IS_ALPHANUMERIC, is TRUE if the string contains only
!    alphabetic characters and numerals.
!
  implicit none

  integer i
  integer itemp
  character ( len = * ) s
  logical s_is_alphanumeric

  s_is_alphanumeric = .false.
 
  do i = 1, len ( s )

    itemp = ichar ( s(i:i) )
 
    if ( .not. ( 65 <= itemp .and. itemp <= 90 ) ) then
      if ( .not. ( 97 <= itemp .and. itemp <= 122 ) ) then
        if ( .not. ( 48 <= itemp .and. itemp <= 57 ) ) then
          return
        end if
      end if
    end if
 
  end do
 
  s_is_alphanumeric = .true.

  return
end function s_is_alphanumeric

function ch_is_alpha ( c )
!
!*******************************************************************************
!
!! CH_IS_ALPHA returns TRUE if C is an alphabetic character.
!
!
!  Modified:
!
!    05 August 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, character C, a character to check.
!
!    Output, logical CH_IS_ALPHA is TRUE if C is an alphabetic character.
!
  implicit none
!
  character c
  logical ch_is_alpha
!
  if ( ( lle ( 'a', c ) .and. lle ( c, 'z' ) ) .or. &
       ( lle ( 'A', c ) .and. lle ( c, 'Z' ) ) ) then
    ch_is_alpha = .true.
  else
    ch_is_alpha = .false.
  end if
end function ch_is_alpha

!----------------------------------------------------------------------------------------------------

function ch_is_digit ( c )

!*******************************************************************************
!
!! CH_IS_DIGIT is TRUE if C is a decimal digit.
!
!  Modified:
!
!    09 August 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, character C, the character to be analyzed.
!
!    Output, logical CH_IS_DIGIT, is TRUE if C is a digit.
!
  implicit none

  character c
  logical ch_is_digit

  if ( lle ( '0', c ) .and. lle ( c, '9' ) ) then
    ch_is_digit = .true.
  else
    ch_is_digit = .false.
  end if

  return
end function ch_is_digit

!----------------------------------------------------------------------------------------------------

function ch_is_upper ( c )

!*******************************************************************************
!
!! CH_IS_UPPER is TRUE if C is an upper case letter.
!
!  Modified:
!
!    02 May 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, character C, the character to be analyzed.
!
!    Output, logical CH_IS_UPPER, is TRUE if C is an upper case letter.
!
  implicit none

  character c
  logical ch_is_upper

  if ( lle ( 'A', c ) .and. lle ( c, 'Z' ) ) then
    ch_is_upper = .true.
  else
    ch_is_upper = .false.
  end if
 
  return
end function ch_is_upper

!----------------------------------------------------------------------------------------------------

function ch_is_lower ( c )

!*******************************************************************************
!
!! CH_IS_LOWER is TRUE if C is a lower case letter.
!
!  Modified:
!
!    02 May 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, character C, the character to be analyzed.
!
!    Output, logical CH_IS_LOWER, is TRUE if C is a lower case letter.
!
  implicit none

  character c
  logical ch_is_lower

  if ( lle ( 'a', c ) .and. lle ( c, 'z' ) ) then
    ch_is_lower = .true.
  else
    ch_is_lower = .false.
  end if
 
  return
end function ch_is_lower

!----------------------------------------------------------------------------------------------------

function ch_is_space ( c )

!*******************************************************************************
!
!! CH_IS_SPACE is TRUE if C is a whitespace character.
!
!  Discussion:
!
!    A whitespace character is a space, a form feed, a newline,
!    a carriage return, a tab, or a vertical tab.
!
!  Modified:
!
!    02 October 2004
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, character C, a character to check.
!
!    Output, logical CH_IS_SPACE is TRUE if C is a whitespace character.
!
  implicit none

  character c
  logical ch_is_space

  if ( c == ' ' ) then
    ch_is_space = .true.
  else if ( c == char ( 12 ) ) then
    ch_is_space = .true.
  else if ( c == char ( 10 ) ) then
    ch_is_space = .true.
  else if ( c == char ( 13 ) ) then
    ch_is_space = .true.
  else if ( c == char ( 9 ) ) then
    ch_is_space = .true.
  else if ( c == char ( 11 ) ) then
    ch_is_space = .true.
  else
    ch_is_space = .false.
  end if

  return
end function ch_is_space
subroutine s_is_r ( s, r, lval )

!*******************************************************************************
!
!! S_IS_R is TRUE if a string represents a real number.
!
!  Modified:
!
!    14 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, character ( len = * ) S, the string to be checked.
!
!    Output, real R.  If the string represents a real number, then R
!    is the real number represented.  Otherwise R is 0.
!
!    Output, logical LVAL, is TRUE if the string represents a real number.
!
  implicit none

  integer ierror
  integer lenc
  integer length
  logical lval
  real r
  character ( len = * ) s

  lenc = len_trim ( s )

  call s_to_r ( s, r, ierror, length )

  if ( ierror == 0 .and. lenc <= length ) then
    lval = .true.
  else
    lval = .false.
    r = 0.0E+00
  end if

  return
end subroutine s_is_r
subroutine s_detag ( s )
!
!*******************************************************************************
!
!! S_DETAG removes from a string all substrings marked by brackets.
!
!
!  Example:
!
!    Input:
!
!      S = '10.008(0.001)  2.001(0.003)'
!
!    Output:
!
!      S = '10.008  2.001'
!
!  Discussion:
!
!    This routine was written to help extract some data that was hidden
!    inside an elaborate HTML table.
!
!  Modified:
!
!    27 September 2008
!
!  Author:
!
!    John Burkardt, Corrado Cuocci
!
!  Parameters:
!
!    Input/output, character ( len = * ) S, the string to be transformed.
!
  implicit none
!
  integer i1
  integer i2
  integer i3
  character ( len = * ) s
!
  do

    i3 = len_trim ( s )

    if ( i3 == 0 ) exit

    i1 = index ( s, "(" )

    if ( i1 <= 0 .or. i1 >= i3 ) exit

    i2 = index ( s(i1+1:), ")" )

    if ( i2 == 0 ) exit

    i2 = i2 + i1
!
!  Shift.
!
    s(i1:i3+i1-i2-1) = s(i2+1:i3)
!
!  Pad.
!
    s(i3+i1-i2:) = ' '

  end do

  return
end subroutine s_detag


      SUBROUTINE DPSTR ( X, SIGDIG, STRING )
 
! Abstract
!
!     Take a double precision number and convert it to
!     an equivalent character string representation (base 10).
!
! Required_Reading
!
!     None.
!
! Keywords
!
!      CHARACTER,  CONVERSION,  PARSING
!
! Declarations
 
      DOUBLE PRECISION X
      INTEGER          SIGDIG
      CHARACTER*(*)    STRING
 
! Brief_I/O
!
!     VARIABLE  I/O  DESCRIPTION
!     --------  ---  --------------------------------------------------
!     X          I   A double precision number
!     SIGDIG     I   The number of significant digits saved for output
!     STRING     O   A character string representation of X
!
! Detailed_Input
!
!     X          is a double precision number.
!
!     SIGDIG     is the number of significant digits that are desired
!                for the output string.
!
!
!     Local variables
!
 
      DOUBLE PRECISION POWER (0:17)
      DOUBLE PRECISION IPOWER(0:17)
 
      CHARACTER*1      DIGITS(0:9)
      DOUBLE PRECISION VALUES(0:9)
!corr
      integer, parameter :: nmaxexp = 40
!corr
      CHARACTER*2      VAXEXP(0:nmaxexp)
 
 
 
      DOUBLE PRECISION COPY
      DOUBLE PRECISION FACTOR
      INTEGER          POSTN
      INTEGER          EXPONT
      INTEGER          MAXSIG
 
      DOUBLE PRECISION EXP10
 
      INTEGER          I
      INTEGER          K
      INTEGER          LAST
 
      CHARACTER*28     ZERO
 
      CHARACTER*32     NUMSTR
 
      SAVE             POWER
      SAVE             IPOWER
      SAVE             DIGITS
      SAVE             VALUES
      SAVE             VAXEXP
 
      DATA             POWER        /  1.0D0,                              &
                                      1.0D1,  1.0D2,  1.0D3,  1.0D4,       &
                                      1.0D5,  1.0D6,  1.0D7,  1.0D8,       &
                                      1.0D9,  1.0D10, 1.0D11, 1.0D12,      &
                                      1.0D13, 1.0D14, 1.0D15, 1.0D16,      &
                                      1.0D17                          /
 
      DATA             IPOWER       /1.0D0,                                &
                                    1.0D-1,  1.0D-2,  1.0D-3,  1.0D-4,     &
                                    1.0D-5,  1.0D-6,  1.0D-7,  1.0D-8,     &
                                    1.0D-9,  1.0D-10, 1.0D-11, 1.0D-12,    &
                                    1.0D-13, 1.0D-14, 1.0D-15, 1.0D-16,    &
                                    1.0D-17                          /
 
      DATA             DIGITS       /  '0', '1', '2', '3', '4', '5', '6', '7', '8', '9'    /
 
      DATA             VALUES       /   0.0D0 ,  1.0D0 ,  2.0D0 ,      &
                                       3.0D0 ,  4.0D0 ,  5.0D0 ,       &
                                       6.0D0 ,  7.0D0 ,  8.0D0 ,       &
                                       9.0D0                     /
 
      DATA             VAXEXP       / '00', '01', '02', '03', '04',    &
                                     '05', '06', '07', '08', '09',     &
                                     '10', '11', '12', '13', '14',     &
                                     '15', '16', '17', '18', '19',     &
                                     '20', '21', '22', '23', '24',     &
                                     '25', '26', '27', '28', '29',     &
                                     '30', '31', '32', '33', '34',     &
                                     '35', '36', '37', '38', '39',     &
                                     '40'                          /
 
!
!     Transfer X to the local variable COPY and leave X alone for the
!     rest of the routine.
!
      COPY   = X
 
!
!     Wipe out anything sitting in NUMSTR
!
      NUMSTR = ' '
 
!
!     At least 1 significant digit is required.  The most allowed is 14.
!     MAXSIG is the integer in this range that is closest to SIGDIG.
!
      MAXSIG = MIN ( 14, MAX( 1, SIGDIG ) )
 
!
!     Examine COPY to see if its positive, zero, or negative.
!     This determines whether we need a minus sign and where the
!     decimal point needs to go in the output string.
!
      IF      ( COPY .LT. 0 ) THEN
 
         NUMSTR(1:1) = '-'
         COPY        =  - COPY
         POSTN       =  2
         NUMSTR(3:3) = '.'
 
      ELSE IF ( COPY .GT. 0 ) THEN
 
         NUMSTR(1:1) = ' '
         POSTN       =  2
         NUMSTR(3:3) = '.'
 
      ELSE
         ZERO        = ' 0.0000000000000000000000000'
         NUMSTR      = ZERO(1:MAXSIG+2) // 'E+00'
 
         STRING = NUMSTR
         RETURN
 
      END IF
 
 
!
!     We need a first guess at the exponent string.  Compute the LOG
!     base 10 of COPY
!
      EXP10  = DLOG10(COPY)
 
!
!     FACTOR will be a value that when multiplied times COPY will shift
!     the value of COPY to something between 1 and 10.  We initialize
!     it here and scale it as needed in the following IF block
!
      FACTOR = 1.0D0
 
      IF ( EXP10 .LT. 0 ) THEN
 
!
!        In this case the exponent will be negative.  We want the
!        largest integer exponent less than EXP10,  but the FORTRAN
!        INT function give the INTEGER closest EXP10 between EXP10
!        and zero.  As a result we have to subtract 1 from INT(EXP10).
!
         EXPONT =  INT(EXP10) - 1
         K      = -EXPONT
 
50001    IF       ( K .GT. 16 )   THEN
            FACTOR = FACTOR * 1.0D16
            K      = K - 16
            GO TO 50001
         END IF
 
         IF ( K .NE. 0 ) THEN
            FACTOR = FACTOR * POWER(K)
         END IF
 
 
      ELSE
 
         EXPONT = INT ( EXP10 )
         K      = EXPONT
 
50002    IF       ( K .GT. 16 )   THEN
            FACTOR = FACTOR * 1.0D-16
            K      = K - 16
            GO TO 50002
         END IF
 
         IF ( K .NE. 0 ) THEN
            FACTOR = FACTOR * IPOWER(K)
         END IF
 
 
      END IF
 
      COPY   = COPY * FACTOR
 
 
!
!     Round off the last significant digit.
!
      COPY   = (DNINT( COPY*POWER(MAXSIG-1)) + 0.125D0 ) * IPOWER(MAXSIG-1)
 
!
!     We might have accidently made copy as big as 10 by the
!     round off process.  If we did we need to divide by 10 and add 1
!     to the exponent value.  (COPY must always remain between 0 and 10)
!
      IF ( COPY .GE. 10.0D0 ) THEN
         COPY   = COPY * 1.0D-1
         EXPONT = EXPONT + 1
      END IF
!
!     Get the first digit of the decimal expansion of X.
!
      I                   = INT ( COPY )
      NUMSTR(POSTN:POSTN) = DIGITS(I)
 
      COPY                = ( COPY - VALUES(I) ) * 10.0D0
 
!
!     Set the string pointer to the next position and compute the
!     position of the last significant digit
!
      POSTN               = POSTN + 2
      LAST                = POSTN + MAXSIG - 1
 
!
!     Fetch digits until we fill in the last available slot for
!     significant digits.
!
50003 IF       ( POSTN  .LT. LAST )THEN
 
         I                   = INT ( COPY )
         NUMSTR(POSTN:POSTN) = DIGITS(I)
         COPY                = ( COPY - VALUES(I) ) * 10.0D0
         POSTN               = POSTN + 1
 
         GO TO 50003
      END IF
 
!
!     Tack on the exponent to the output.
!
      select case (expont)
          case (0:nmaxexp)
            NUMSTR(POSTN:) = 'E+' // VAXEXP (   EXPONT )
          case (-nmaxexp:-1)
            NUMSTR(POSTN:) = 'E-' // VAXEXP ( - EXPONT )
          case (nmaxexp+1:)
            NUMSTR(POSTN:) = 'INF'
          case (:-nmaxexp-1)
            NUMSTR(POSTN:) = '-INF'
      end select
!corr      IF ( EXPONT .GE. 0 ) THEN
!corr         NUMSTR(POSTN:) = 'E+' // VAXEXP (   EXPONT )
!corr      ELSE
!corr         NUMSTR(POSTN:) = 'E-' // VAXEXP ( - EXPONT )
!corr      END IF
 
      STRING = NUMSTR
 
!
!     That's all folks.
!
      RETURN
 
      end subroutine dpstr
 
      SUBROUTINE DPSTRF ( X, SIGDIG, FORMAT, STRING )
 
!  Abstract
!
!      Take a double precision number and convert it to an
!      equivalent formatted character string representation (base 10).
!
!  Required_Reading
!
!      None.
!
!  Keywords
!
!       CHARACTER
!       CONVERSION
!       PARSING
!
!  Declarations
 
      DOUBLE PRECISION      X
      INTEGER               SIGDIG
      CHARACTER*1           FORMAT
      CHARACTER*(*)         STRING
 
!  Brief_I/O
!
!       VARIABLE  I/O  DESCRIPTION
!      --------  ---  --------------------------------------------------
!      X          I   A double precision number
!      SIGDIG     I   The number of significant digits saved for output
!      FORMAT     I   'E' for scientific, 'F' for floating point.
!      STRING     O   A character string representation of X
!
! Detailed_Input
!
!      X          is a double precision number.
!
!      SIGDIG     is the number of significant digits that are desired
!                 for the output string.
!
!      FORMAT     is a character flag that indicates how the double
!                 precision number should be represented.  The two
!                 acceptable inputs are 'E' and 'F'.  If the input
!                 is 'E' then the number will be displayed with an
!                 exponent in scientific notation. 
!
!!!!corrr      INTEGER               BSRCHC
 
!
!     Local variables
!
      INTEGER               NEXPS
      PARAMETER           ( NEXPS = 41 )
 
      CHARACTER*2           VAXEXP ( NEXPS )
      SAVE                  VAXEXP
 
      CHARACTER*2           EXP
 
      CHARACTER*42          ZERO
      CHARACTER*64          NUMSTR
      CHARACTER*64          NEWSTR
      INTEGER               EXPLOC
      INTEGER               SGNLOC
      INTEGER               EXPNDX
      INTEGER               MAXDIG
      integer               lens
 
      DATA                  VAXEXP      / '00', '01', '02', '03', '04',   &
                                          '05', '06', '07', '08', '09',   &
                                          '10', '11', '12', '13', '14',   &
                                          '15', '16', '17', '18', '19',   &
                                          '20', '21', '22', '23', '24',   &
                                          '25', '26', '27', '28', '29',   &
                                          '30', '31', '32', '33', '34',   &
                                          '35', '36', '37', '38', '39',   &
                                          '40'                        /
 
      MAXDIG = MIN ( 14, MAX(1,SIGDIG)       )
 
      CALL DPSTR  ( X,  MAXDIG, NUMSTR )
 
 
      IF ( FORMAT .EQ. 'E' ) THEN
 
         STRING = NUMSTR
 
      ELSE
 
         ZERO   = '0.0000000000000000000000000000000000000000'
         NEWSTR = ' '
!
!        Save the sign of this string and shift everything left 1 space.
!
         EXPLOC                =  MAXDIG + 3
         SGNLOC                =  MAXDIG + 4
         EXP                   =  NUMSTR(SGNLOC+1:SGNLOC+2)
 
 
!
!        Blank out the exponent character so that we can just append
!        the stuff after the decimal place upto and including the
!        exponent character.  (This usually avoids having to worry
!        about zero length substrings.)
!
         NUMSTR(EXPLOC:EXPLOC) = ' '
 
!
!        Determine the integer represented by EXP.
!
         EXPNDX = BSRCHC ( EXP, NEXPS, VAXEXP )
 
!
!        If the exponent was negative append zeros to the front of the
!        number.
!
         IF ( NUMSTR(SGNLOC:SGNLOC) .EQ. '-' ) THEN
 
            NEWSTR =  NUMSTR ( 1 : 1      )  //    &
                      ZERO   ( 1 : EXPNDX )  //    &
                      NUMSTR ( 2 : 2      )  //    &
                      NUMSTR ( 4 : EXPLOC )
 
 
!
!        If the exponent was zero, just lop off the exponent part.
!
         ELSE IF ( EXPNDX .EQ. 1 ) THEN
 
            NEWSTR = NUMSTR ( 1 : EXPLOC )
 
!
!        If the exponent was smaller than the number of mantissa
!        digits, just move the decimal point. (We're going to be
!        a bit sneaky here.  What we want to know is how many places
!        the decimal point should be moved right.  There are only
!        MAXDIG - 1 places to move it. So if the value of the
!        exponent is less than or equal to MAXDIG-1, we can
!        push the decimal point without attatching zeros to the number.
!        But the value of the exponent is EXPNDX - 1.  Thus
!        the condition we want to test is EXPNDX - 1 .LE. MAXDIG - 1.
!        This is of cource equivalent to EXPNDX .LE. MAXDIG)
!
         ELSE IF ( EXPNDX .LE. MAXDIG ) THEN
 
            NEWSTR = NUMSTR( 1       :        2)  //    &
                     NUMSTR( 4       : EXPNDX+2)  //    &
                     '.'                          //    &
                     NUMSTR( 3+EXPNDX: EXPLOC  )
 
         ELSE
!
!           We will have to put some zeros on after the last mantissa
!           digit.
!
!           How many?  We've got MAXDIG - 1 digits following
!                      the decimal point.  We can move the decimal
!                      point MAXDIG - 1 places before we run out of
!                      room
!
!                      We need to move the decimal point EXPNDX - 1
!                      places to the right.  Once we have run out of
!                      room for shifting the decimal place right
!                      (After MAXDIG - 1 shifts right) we will still
!                      need to shift the decimal point
!                      (EXPNDX - 1) - (MAXDIG - 1) places to the right.
!                      In other words we must add EXPNDX - MAXDIG zeros
!                      on after the last mantissa digit.
!
!                      (Note we have to worry about the zero-length
!                       strings in this case NUMSTR(4:EXPLOC-1) )
!
            IF ( EXPLOC .GT. 4 ) THEN
 
               NEWSTR = NUMSTR ( 1 :                   2 )      //    &
                        NUMSTR ( 4 :     EXPLOC -      1 )      //    &
                        ZERO   ( 3 : 2 + EXPNDX - MAXDIG )
 
            ELSE
 
               NEWSTR = NUMSTR ( 1 :                   2 )      //    &
                        ZERO   ( 3 : 2 + EXPNDX - MAXDIG )
 
            END IF
 
         END IF
 
         STRING = NEWSTR
 
      END IF
!
!     Elimina eventuale punto decimale alla fine
      lens = len_trim(string)
      if (string(lens:lens) == '.') string(lens:lens) = ' '
 
      RETURN
 
      end subroutine DPSTRF

      INTEGER FUNCTION BSRCHC ( VALUE, NDIM, ARRAY )
 
! Abstract
!
!     Do a binary search for a given value within a character array,
!     assumed to be in increasing order. Return the index of the
!     matching array entry, or zero if the key value is not found.
!
! Required_Reading
!
!    None.
!
! Keywords
!
!     ARRAY,  SEARCH
!
! Declarations
 
      CHARACTER*(*)    VALUE
      INTEGER          NDIM
      CHARACTER*(*)    ARRAY ( * )
 
! Brief_I/O
!
!     VARIABLE  I/O  DESCRIPTION
!     --------  ---  --------------------------------------------------
!     VALUE      I   Value to find in ARRAY.
!     NDIM       I   Dimension of ARRAY.
!     ARRAY      I   Array to be searched.
!     BSRCHC     O   Index of VALUE in ARRAY. (Zero if not found.)
!
! Detailed_Input
!
!     VALUE       is the value to be found in the input array.
!
!     NDIM        is the number of elements in the input array.
!
!     ARRAY       is the array to be searched. The elements in
!                 ARRAY are assumed to sorted according to the
!                 ASCII collating sequence.
!
!
!    Local variables
!
      INTEGER          LEFT
      INTEGER          RIGHT
      INTEGER          I
 
 
 
!
!     Set the initial bounds for the search area.
!
      LEFT  = 1
      RIGHT = NDIM
 
50001 IF       ( LEFT .LE. RIGHT ) THEN
 
!
!        Check the middle element.
!
         I = (LEFT+RIGHT)/2
 
!
!        If the middle element matches, return its location.
!
         IF ( VALUE .EQ. ARRAY(I) ) THEN
            BSRCHC = I
            RETURN
 
!
!        Otherwise narrow the search area.
!
         ELSE IF ( LLT (VALUE, ARRAY(I)) ) THEN
            RIGHT = I-1
         ELSE
            LEFT  = I+1
         END IF
 
         GO TO 50001
      END IF
 
!
!     If the search area is empty, return zero.
!
      BSRCHC = 0
 
      RETURN
      end function BSRCHC

 !----------------------------------------------------------------------------------------------------

      function string_sigf(val,sigf)   result(str)
!
!     Genera stringa da val con sigf cifre significative
!
      real, intent(in)      :: val
      integer, intent(in)   :: sigf
      character(len=sigf+8) :: str
      real(8)               :: vald
      character(len=1)      :: cform
      integer               :: dig
!
      cform = 'F'
      vald = val
!
!     Se il numero e troppo grande rispetto a sigd
!     usa il formato esponenziale
      if (vald > 1.0) then
          dig = nint(dlog10(vald))
          if (dig > sigf) cform = 'E'
      endif
!
      call dpstrf(vald,sigf,cform,str)
      str = adjustl(str)
!
      end function string_sigf

 !----------------------------------------------------------------------------------------------------

      function string_sigd(val,sigd)   result(str)
!
!     Genera stringa da val con sigd cifre significative
!
      real(8), intent(in)   :: val
      integer, intent(in)   :: sigd
      character(len=sigd+8) :: str
      character(len=1)      :: cform
      integer               :: dig
!
      cform = 'F'
!
!     Se il numero e troppo grande rispetto a sigd
!     usa il formato esponenziale
      if (val > 1.0) then
          dig = nint(dlog10(val)) + 1
          if (dig > sigd) cform = 'E'
      endif
!
      call dpstrf(val,sigd,cform,str)
      str = adjustl(str)
!
      end function string_sigd

 !----------------------------------------------------------------------------------------------------

      function string_esd_old(val,std)  result(str)
!
!     Genera una stringa contenente val(std)
!
      real, intent(in)   :: val,std
      character(len=100) :: str,strval,strstd
      real(8)            :: stdd
      integer            :: ndig,nsig,nsigv
      real               :: rndig
!      character(len=20)  :: cform
      integer            :: dig1
      integer            :: nsigi,nsigd
      integer            :: code
!
!     code = 1 ! l'ultima cifra sig. di val e' dello stesso ordine di grandezza dell'errore (leggi Taylor)
!     code = 2 ! solo l'ultima cifra significativa di val viene arrotondata
      code = 1
!
      if (std == 0.0) then
          str = string_sig(val,7) 
      else
!
!         Calcola il numero di cifre significative per la std
          rndig = log10(abs(std))
          if (rndig < 0) then         ! std < 1
              ndig = nint(abs(rndig - 1))
              dig1 = nint(std*10**ndig)  ! dig1 e' la prima cifra significativa di std
              if (dig1 == 1) then        ! se dig1 = 1 prendi std con 2 cifre
                  nsig = 2
                  stdd = std*10.**(ndig+1)
                  nsigi = 0
                  nsigd = ndig + 1
                  ndig = ndig + 1 ! corretto bug - 10/2012
              else                    ! altrimenti prendi 1 cifra significativa
                  nsig = 1
                  stdd = std*10.**(ndig)  
                  if (std < 1 .and. std > 0.95) then
                      ndig = ndig - 1
                      stdd = std*10.**(ndig)  
                  endif
                  nsigi = 0
                  nsigd = ndig
              endif
          else                        ! std > 1
              ndig = nint(rndig)
              dig1 = nint(std/10**(ndig))
              if (dig1 == 1) then
                  nsig = 2
                  stdd = std/10.**(ndig-1)
                  if (ndig == 0) then
                      nsigi = 1
                      nsigd = 1
                  else
                      nsigi = ndig
                      nsigd = 0
                  endif
              else
                  nsig = 1
!
!                 check per numeri del tipo 9.6,98,970, etc
                  stdd = std/10.**(ndig)
                  if (stdd >= 9.5 .and. stdd < 10) then
                      ndig = ndig + 1
                  endif
!
                  nsigi = ndig
                  nsigd = 0
                  stdd = std
              endif
          endif
!
!         arrotondo std a nsig cifre significative  
          call dpstrf(stdd,nsig,'F',strstd)
          strstd = adjustl(strstd)
!
          if (code == 1) then
!
!             calcola in nsigv il numero di cifre significative per val
              rndig = log10(abs(val))
              if (rndig < 0) then
                  nsigv = nsigd
              else
                  if (nsigd > 0) then
                      nsigv = nint(rndig)+nsigd+1
                  else
                      nsigv = nint(rndig) + 1 - nsigi - nsigd
                  endif
              endif
!
!             arrotonda val a nsigv cifre significative
              if (nsigv > 0) then
                  call dpstrf(real(val,8),nsigv,'F',strval)
              else
                  strval = '0'
              endif
          elseif (code == 2) then
!
!             arrotonda solo l'ultima cifra sig.
              if (nsigd == 0) then
                  !write(strval,'(i0)')nint(val)
                  strval = i_to_s(nint(val))
              else
                  !write(cform,'(a,i0,a)')'(f0.',ndig,')'
                  !write(strval,cform)val
                  strval = r_to_s(val,ndig)
              endif
          endif
      endif
!
!     Genera la stringa
      str = trim(strval)//'('//trim(strstd)//')'
!
      end function string_esd_old

 !----------------------------------------------------------------------------------------------------

      function string_esd(val,std)  result(str)
!
!     Create string: val(std)
!     std contains 2 significant digits only if the first digit is 1
!
      real, intent(in)              :: val,std
      character(len=:), allocatable :: str,strval,strstd
      integer                       :: ndig,nsigd,ldig
      real                          :: stdd
!
      if (abs(val) > 999999.0) then
          write(str,'(a)')val
          return
      endif
      if (abs(std) < epsilon(0.0)) then
          str = string_sig(val,5) 
          return
      endif
!
      if (std < 1) then     
          ldig = floor(log10(abs(std)))  
          ndig = abs(ldig)     ! position of the first digit
          strstd = i_to_s(nint(std*10.0**(ndig+1)))
          if (strstd(1:1) == '1') then   ! first digit is 1?
              ndig = ndig + 1
          else               
              strstd = i_to_s(nint(std*10.0**(ndig)))
          endif
          nsigd = ndig
      else                    
          ldig = floor(log10(abs(std)))
          ndig = abs(ldig)     ! position of the first digit
          stdd = xround(std,2)
          if (first_digit(stdd) == 1) then
              if (stdd < 2) then                  ! es. std = 1.2
                  strstd = i_to_s(nint(stdd*10))
              else
                  strstd = i_to_s(nint(stdd))
              endif
              nsigd = 1
              if (ndig == 0) ndig = 1
          else
              strstd = i_to_s(nint(xround(std,1)))  ! round to 1 significant digit
              nsigd = 0
          endif
      endif
!
      if (nsigd == 0) then
          strval = i_to_s(nint(val))
      else
          if (ndig > 7) then
              str = r_to_s(val,7)
              return
          else
              strval = r_to_s(val,ndig) 
          endif
      endif
!
!     finally create string
      str = trim(strval)//'('//trim(strstd)//')'
!
      end function string_esd

 !----------------------------------------------------------------------------------------------------
  integer function first_digit(rnum) result(fdigit)
  real, intent(in) :: rnum
  real             :: len_num
  len_num = floor(log10(abs(rnum)))  ! this the length of number - 1
  fdigit = int(rnum / 10**len_num)
  end function first_digit

 !----------------------------------------------------------------------------------------------------

      real function xround(num,sig)
!
!     Round a number to n significant digits
!
      real, intent(in)    :: num
      integer, intent(in) :: sig
      real                :: mult
      integer             :: power
!
      if (sig == 0) then
          xround = 0
          return
      endif
      if (num > 0) then
          power =floor(log10(num))
      else
          power =floor(log10(-num))
      endif
      mult = 10.0**(sig - power -1)
      xround = nint(num * mult) / mult
!
      end function xround

 !----------------------------------------------------------------------------------------------------

      function r_to_s(x,dec) result(str)
!
!     writes a real into a left justified character string
!
      real, intent(in)              :: x
      integer, intent(in), optional :: dec
      character(len=14)             :: str
      character(len=20)             :: sform
!corr      integer :: idec
!
      if (present(dec)) then
          if (dec < 0 .and. real ( int ( x ) ) == x) then
              write ( str, '(i14)' ) int ( x )
          else
              if ( abs ( x ) < 999999.5E+00 ) then
                write(sform,'("(f14.",i0,")")')abs(dec)
                write ( str, sform ) x
              else
                write(sform,'("(g14.",i0,")")')abs(dec)
                write ( str, sform ) x
              end if
          endif
      else
          if ( real ( int ( x ) ) == x ) then
            write ( str, '(i14)' ) int ( x )
          else if ( abs ( x ) < 999999.5E+00 ) then
            write ( str, '(f14.6)' ) x
          else
            write ( str, '(g14.6)' ) x
          end if
      endif
!

      str = adjustl(str)
!
      end function r_to_s

 !----------------------------------------------------------------------------------------------------

      function i_to_s ( intval ) result(s)
!
!     I_TO_S_LEFT converts an integer to a left-justified string.
!
!     Examples:
!
!       Assume that S is 6 characters long:
!
!       INTVAL  S
!
!            1  1
!           -1  -1
!            0  0
!         1952  1952
!       123456  123456
!      1234567  ******  <-- Not enough room!
!
!     Modified:
!
!       28 July 2000
!
!     Author:
!
!       John Burkardt
!
!     Parameters:
!
!       Input, integer INTVAL, an integer to be converted.
!
!       Output, character ( len = * ) S, the representation of the integer.
!       The integer will be left-justified.  If there is not enough space,
!       the string will be filled with stars.
!
        implicit none

        character c
        integer i
        integer idig
        integer ihi
        integer ilo
        integer intval
        integer ipos
        integer ival
        character ( len = 100 ) s

        s = ' '

        ilo = 1
        ihi = len ( s )

        if ( ihi <= 0 ) then
          return
        end if
!
!        Make a copy of the integer.
!
        ival = intval
!
!        Handle the negative sign.
!
        if ( ival < 0 ) then

          if ( ihi <= 1 ) then
            s(1:1) = '*'
            return
          end if

          ival = -ival
          s(1:1) = '-'
          ilo = 2

        end if
!
!        The absolute value of the integer goes into S(ILO:IHI).
!
        ipos = ihi
!
!        Find the last digit of IVAL, strip it off, and stick it into the string.
!
        do

          idig = mod ( ival, 10 )
          ival = ival / 10

          if ( ipos < ilo ) then
            do i = 1, ihi
              s(i:i) = '*'
            end do
            return
          end if

          call digit_to_ch ( idig, c )

          s(ipos:ipos) = c
          ipos = ipos - 1

          if ( ival == 0 ) then
            exit
          end if

        end do
!
!        Shift the string to the left.
!
        s(ilo:ilo+ihi-ipos-1) = s(ipos+1:ihi)
        s(ilo+ihi-ipos:ihi) = ' '
 
        end function i_to_s
 !----------------------------------------------------------------------------------------------------

        subroutine digit_to_ch ( digit, c )

!
!  DIGIT_TO_CH returns the character representation of a decimal digit.
!
!   Example:
!
!     DIGIT   C 
!     -----  ---
!       0    '0'
!       1    '1'
!      ...    ...
!       9    '9'
!      17    '*'
!
!   Modified:
!
!    04 August 1999
!
!   Author:
!
!     John Burkardt
!
!   Parameters:
!
!     Input, integer DIGIT, the digit value between 0 and 9.
!
!     Output, character C, the corresponding character.
!
      character c
      integer digit

      if ( 0 <= digit .and. digit <= 9 ) then
        c = char ( digit + 48 )
      else
        c = '*'
      end if

      end subroutine digit_to_ch
 !----------------------------------------------------------------------------------------------------
      
      function d_to_s(d) result(str)
!
!     writes a double precision value into a left justified string.
!
      real(8), intent(in) :: d
      character(len=14) :: str
!
      write(str,'(g14.6)')d
      str = adjustl(str)
!
      end function d_to_s

 !----------------------------------------------------------------------------------------------------

      integer function string_locate(str,strvet,vet) result(pos)
!
!     true se string compare almeno una volta nel vettore svet
!
      character(len=*), intent(in)                :: str     ! stringa
      character(len=*), dimension(:), intent(in)  :: strvet  ! vettore sul quale eseguire il controllo
      integer, dimension(:), intent(in), optional :: vet     ! elementi da escludere nel controllo
      integer                                     :: i
!
      pos = 0
      if (present(vet)) then
          do i=1,size(strvet)
             if (any(vet == i)) cycle  ! salta se i e' contenuto in vet
             if (s_eqi(str,strvet(i))) then
                 pos = i
                 exit
             endif
          enddo
      else
          do i=1,size(strvet)
             if (s_eqi(str,strvet(i))) then
                 pos = i
                 exit
             endif
          enddo
      endif
!
      end function string_locate

!----------------------------------------------------------------------------------------------------

   subroutine set_row_list(vet,ktype,ival,rval,sval,kpr)
!
!  Scrive una singola riga di una tabella
!
   integer, dimension(:), intent(in)                    :: vet   ! cosa scrivere del vettore ival/rval/sval
   integer, dimension(size(vet)), intent(in)            :: ktype ! tipo: 1=intero,2=reale,3=character
   integer, dimension(:), intent(in), optional          :: ival
   real, dimension(:), intent(in), optional             :: rval
   character(len=*), dimension(:), intent(in), optional :: sval
   integer, intent(in)                                  :: kpr
   character(len=10), dimension(size(vet))              :: srow
   integer                                              :: ncol
   integer                                              :: i
   character(len=20)                                    :: sform
   character(len=100)                                   :: str !warn gfortran
   integer                                              :: deg
!
   ncol = 0
   do i=1,size(srow)
      if (vet(i) /= 0) then
          select case (ktype(i))
            case (1)      ! intero
              ncol = ncol + 1
              str = i_to_s(ival(i))    
              srow(ncol) = str(1:10)

            case (20:)      ! reale
              deg = mod(ktype(i),20)  ! cifre decimali
              ncol = ncol + 1
              str = r_to_s(rval(i),deg) 
              srow(ncol) = str(1:10)

            case (3)      ! character
              ncol = ncol + 1
              srow(ncol) = sval(i)
              srow(ncol) = s_center(srow(ncol))

          end select
      endif
   enddo
   if (ncol > 0) then
       write(sform,'("(",i0,"a)")')ncol
       write(kpr,sform)srow(1:ncol)
   endif
!
   end subroutine set_row_list

!----------------------------------------------------------------------------------------------------

   function s_in_quotes(string)  result(str)
!
!  Enclose string in double quotes
!
   character(len=*), intent(in)      :: string
   character(len=len_trim(string)+2) :: str
!
   str = "'"//trim(string)//"'"
!
   end function s_in_quotes

!----------------------------------------------------------------------------------------------------

   function rem_quotes(string)  result(str)
!
!  Remove apici all'inizio e alla fine di una stringa
!
   character(len=*), intent(in)    :: string
   character(len=len_trim(string)) :: str
   integer                         :: lens
   character(len=1) :: squot
   integer :: kpos
   integer :: i
!
   squot = ' '
   kpos = 0
   lens = len_trim(string)
   str = trim(string)
!
!  Search for the first character equal to ' or "
   do i=1,lens
      if (str(i:i) == '"' .or. str(i:i) == "'") then
          squot = str(i:i)
          kpos = i
          exit
      elseif (str(i:i) /= ' ') then
          exit
      endif
   enddo
!
!  Search for the second quote
   if (kpos > 0 .and. kpos < lens) then
       do i=lens,lens-kpos,-1
          if (str(i:i) == squot) then
              str(i:i) = ' '
              str(kpos:kpos) = ' '
              exit
          elseif (str(i:i) /= ' ') then
              exit
          endif
       enddo
   endif
!
   end function rem_quotes

!----------------------------------------------------------------------------------------------------

   subroutine get_string_in_brackets(str,strb,bpos,ier)
   character(len=*), intent(in)  :: str   ! stringa a partire dalla parentesi
   character(len=*), intent(out) :: strb  ! stringa in parentesi
   integer, intent(out)          :: bpos  ! position of seconf bracket
   integer, intent(out)          :: ier
   integer                       :: lens
   character(len=1)              :: br1,br2
   integer                       :: kbr
   integer                       :: i
   ier = 0
   strb = ' '
   br1 = str(1:1)
   bpos = 0
   select case (br1)
       case ('(')
         br2 = ')'
       case ('[')
         br2 = ']'
       case ('{')
         br2 = '}'
       case default
         ier = 1
   end select
   if (ier == 0) then
       lens = len_trim(str)
       kbr = 0
       i=1
       do 
         i=i+1
         if (i > lens) exit
         if (str(i:i) == br1) then
             kbr = kbr + 1
         elseif (str(i:i) == br2) then
             kbr = kbr - 1
             if (kbr == -1) exit
         endif
       enddo
       if (kbr == -1) then
           strb = str(2:i-1)
           bpos = i
       else
           ier = 1
       endif
   endif
   end subroutine get_string_in_brackets

!----------------------------------------------------------------------------------------------------

   subroutine write_svet(svet,nvet,kpr,word)
!
!  Scrivi sulla stessa riga un vettore di stringhe
!
   character(len=*), dimension(:), intent(in) :: svet
   integer, intent(in)                        :: nvet
   integer, intent(in)                        :: kpr
   character(len=*), intent(in), optional     :: word
   character(len=3)                           :: adv
   integer                                    :: i
   select case (nvet)
     case (1)
       if (present(word)) then
           write(kpr,'(a)') word//trim(svet(1))
       else
           write(kpr,'(a)') trim(svet(1))
       endif

     case (2:)
       adv = 'no'
       if (present(word)) write(kpr,'(a)',advance=adv)word
!corr       write(kpr,'(a)',advance=adv) trim(svet(1))//', '
       write(kpr,'(a)',advance=adv) trim(svet(1))//','
       do i=2,nvet-1
!corr          write(kpr,'(a)',advance=adv) trim(svet(i))//', '
          write(kpr,'(a)',advance=adv) trim(svet(i))//','
       enddo
       adv = 'yes'
       write(kpr,'(a)',advance=adv) trim(svet(nvet))
   end select
   end subroutine write_svet

 !----------------------------------------------------------------------------------

   subroutine get_next_number(string,pos,numb,ier)
!
!  Get the next number starting from position pos (pos is excluded)
!
   character(len=*), intent(in) :: string  
   integer, intent(inout)       :: pos     ! in out contains the last char corrisponding to number
   real, intent(out)            :: numb
   integer, intent(out)         :: ier     
   integer                      :: lens
   integer                      :: kb, kdigb 
   character(len=1)             :: ch
   integer                      :: len
   character(len=len_trim(string)-pos+1) :: digitb
!
   numb = 0
   ier = 0
   lens = len_trim(string)
   if (pos > lens) then
       ier = 1
   else
       kb = pos
       kdigb = 0
       do
         kb = kb + 1
         if (kb > lens) exit ! fine stringa
         ch = string(kb:kb)
         if (kdigb == 0 .and. ch_is_space(ch)) then
             pos = kb
         else
     !corr        if (.not. (ch_is_digit(ch) .or. ch == '.')) exit
             if (.not. (ch_is_digit(ch) .or. ch == '.' .or. (ch == '-' .and. kdigb == 0))) exit
             kdigb = kdigb + 1
             pos = kb
             digitb(kdigb:kdigb) = ch
         endif
       enddo
!
       if (kdigb > 0) then   ! digits found!
           call s_to_r(digitb(:kdigb),numb,ier,len)
       else
           ier = 2   ! non ho trovato alcun numero
       endif
   endif
!
   end subroutine get_next_number

 !----------------------------------------------------------------------------------

   subroutine get_next_number1(string,spos,numb,ier)
!
!  Get the next number starting from string spos
!
   character(len=*), intent(in) :: string  
   character(len=*), intent(in) :: spos 
   real, intent(out)            :: numb
   integer, intent(out)         :: ier     
   integer                      :: pos
!
   pos = index(string,trim(spos))
   if (pos > 0) then
       pos = pos + len_trim(spos) - 1
       call get_next_number(string,pos,numb,ier)
   else
       ier = 2
   endif
!
   end subroutine get_next_number1

 !----------------------------------------------------------------------------------

   subroutine write_title(kpr,stringvet,typevet)
!
!  Write title in a frame
!
   integer, intent(in)          :: kpr
   character(len=*), dimension(:), intent(in) :: stringvet
   character(len=1), dimension(:), intent(in), optional :: typevet
   integer, parameter           :: MAX_SPACE = 80
   integer, parameter           :: BORDER = 1
   character(len=100)           :: sform0,sform
   integer                      :: ier
   integer                      :: pos
   integer                      :: i
   sform0 = '('//trim(i_to_s(BORDER))//'x,'//trim(i_to_s(MAX_SPACE-2*BORDER))//'("+"))'
   write(kpr,sform0)
   write(kpr,*)
   if (present(typevet)) then
       do i=1,size(stringvet)
          if (typevet(i) == 'c') then
              pos = ((MAX_SPACE - 2*BORDER) - len_trim(stringvet(i))) / 2
              if (pos <= 0) pos = 1
              sform = '('//trim(i_to_s(pos))//'x,a)'
              write(kpr,sform,iostat=ier)trim(stringvet(i))
          else
              write(kpr,'(1x,a)',iostat=ier)trim(stringvet(i))
          endif
       enddo
   else
       do i=1,size(stringvet)
          pos = ((MAX_SPACE - 2*BORDER) - len_trim(stringvet(i))) / 2
          if (pos <= 0) pos = 1
          sform = '('//trim(i_to_s(pos))//'x,a)'
          write(kpr,sform,iostat=ier)trim(stringvet(i))
       enddo
   endif
   write(kpr,*)
   write(kpr,sform0)
   end subroutine write_title

 !----------------------------------------------------------------------------------

   logical function match_word(string,word) result(match)
!
!  true if the first characters of string match with word (case insensitive)
!
   character(len=*), intent(in) :: string, word
   match = s_eqi(string(1:len_trim(word)),word)
   end function match_word

END MODULE STRUTIL

MODULE strlabutil

!F slabnum(slab,num)                        Concatena label con numero d'ordine dell'atomo
!S slabvet(vatm,llab,str,ier)               Genera nella stringa str una lista di atomi separati da virgola
!S get_from_label(label,specl,numb,ierror)  Estrai dalla label la stringa e la sequenza numerica finale

implicit none

CONTAINS 

   function slabnum(slab,num)
!
!  Concatena label con numero d'ordine dell'atomo
!
   character(len=*), intent(in)     :: slab
   integer, intent(in)              :: num
   character(len=len_trim(slab)+12) :: slabnum
!
   slabnum = ' '
   write(slabnum,'(a,i0,a)')trim(slab)//'(',num,')'
!
   end function slabnum

 !----------------------------------------------------------------------------------

   function slabvet(vatm,llab,showord)  result(str)
!
!  Genera nella stringa str una lista di atomi separati da virgola
!
   integer, dimension(:), intent(in)          :: vatm    ! puntatori alle labels
   character(len=*), dimension(:), intent(in) :: llab    ! labels
   logical, intent(in), optional              :: showord ! se vero mostra il numero d'ordine
   logical                                    :: showord1
   character(len=:), allocatable              :: str    
   integer                                    :: i
   integer                                    :: ipos
   integer                                    :: natlm
!
   if (present(showord)) then
       showord1 = showord
   else
       showord1 = .false. 
   endif
!
   str = ' '
   natlm = size(vatm) 
   if (natlm == 0) return
   ipos = vatm(1)
   if (showord1) then
       str = trim(slabnum(llab(ipos),ipos))
       do i=2,natlm
          ipos = vatm(i)
          str = trim(str)//','//trim(slabnum(llab(ipos),ipos))
       enddo
   else
       str = trim(llab(ipos))
       do i=2,natlm
          ipos = vatm(i)
          str = trim(str)//','//trim(llab(ipos))
       enddo
   endif
!
   end function slabvet

 !----------------------------------------------------------------------------------

   subroutine get_from_label(label,specl,numb,ierror,letter)
!
!  Estrai dalla label la stringa e il seriale
!
   USE strutil
   character(len=*), intent(in)            :: label   !label atomo
   character(len=*), intent(out), optional :: specl   !porzione carattere
   integer, intent(out)                    :: numb    !seriale
   character(len=1), intent(out), optional :: letter  !lettera dopo il seriale
   integer, intent(out)                    :: ierror
   integer                                 :: kpos1,kpos2
   integer                                 :: lenl
   integer                                 :: lenn
   integer                                 :: i
!
   numb = 0
   lenl = len_trim(label)
!
!  Cerca una sequenza di numeri a partire dalla fine
   kpos1 = 0   ! posizione iniziale del numero
   kpos2 = 0   ! posizione finale del numero
   do i=lenl,1,-1
      if (kpos2 == 0 .and. ch_is_digit(label(i:i))) kpos2 = i
      if (kpos2 > 0 .and. .not.ch_is_digit(label(i:i))) then
          kpos1 = i+1
          exit
      endif
   enddo
!
!  Solo un carattere finale e' consentito (es. C23A ma non C23pippo)
   if (kpos1 > 1 .and. kpos2 >= lenl - 1) then
       call s_to_i(label(kpos1:kpos2),numb,ierror,lenn)
   else
       ierror = 1  ! sequenza di soli numeri o sole lettere
   endif
!
   if (present(specl)) then
       if (ierror == 0) then
           specl = label(1:kpos1-1)
       else
           specl = trim(label)
       endif
   endif
!
   if (present(letter)) then
       letter = ' '
       if (ierror == 0) then
           if (kpos2 == lenl-1 .and. ch_is_alpha(label(lenl:lenl))) letter = label(lenl:lenl)
       endif
   endif
   !write(0,*)'label=',trim(label),' numb=',numb,' lab=',trim(specl),' ier=',ierror
!
   end subroutine get_from_label

END MODULE strlabutil
