! --------------------------------------------------------------------
c      HISTOGRAM MATCHING PROCEDURE
c      dritan 09/11/2006
c
c       iTypeFunCT1 = 0 il caso particolare per sirprot HM con P(delta)
c       iTypeFunCT1 = 1 tra due sets di dati
c       iTypeFunCT1 = 2 libero per il momento
c       iTypeFunCT1 = 3 HM con la funzione  P (wt)
c       iTypeFunCT1 = 4 HM con la funzione P(E) (p.es per FreeLunch)

c       iTypeFunCT1 = 1 tra due sets di dati
c       work1(1:nrefl) = fcvet(1:nrefl)  ! Ecalc in ingresso ; Emod in uscita
c       work2(1:nrefl) = evet(1:nrefl) ! Eobs
c       nwizm1=10  ! micro
c       nwizm1=15  ! small / medium
c       nwizm1=25  ! ksize > 3
c       nden =  nstr / 10
c       nsip1 = nrefl / nden
c       nsip1 = min(nsip1,498)
c       call HistogramMatch(work1,work2,nrefl,nsip1,nwizm1,1)
c       fcvet(1:nrefl) = work1(1:nrefl)

c       iTypeFunCT1 = 4 HM con la funzione P(E) (p.es per FreeLunch)
c       work1(1:nrefl) = fcvet(1:nrefl)  ! Ecalc in ingresso ; Emod in uscita
c       work2(1:nrefl) = evet(1:nrefl)  ! non usato
c       nwizm1=10  ! micro
c       nwizm1=15  ! small / medium
c       nwizm1=25  ! ksize > 3
c       nden =  nstr / 10
c       nsip1 = nrefl / nden
c       nsip1 = min(nsip1,400)
c       nsip1 = 10  (da Patterson)
c       call HistogramMatch(work1,work2,nrefl,nsip1,nwizm1,4)
c       fcvet(1:nrefl) = work1(1:nrefl)

c----   pesi: HM con P(wt) "teorica"
c       work1(1:nrefl) = wt(1:nrefl)
c       work2(1:nrefl) = wt(1:nrefl)
c       nsip1=100
c       nwizm1=25  ! ksize > 3
c       call HistogramMatch(work1,work2,nrefl,nsip1,nwizm1,3)
c       wt(1:nrefl) = work1(1:nrefl)
c       per gianluca :  possiamo  mettere il common /HistogramMatching  dentro sircom.fi
c                       generalizzare il valore min/max per HM
c---
!--------------------------------------------------------
      subroutine HistogramMatch(hisob,hisca,ntot1,nsip1,nwizm1,
     *                          iTypeFunCT1)

      USE General
      USE HistoMatch

      common /HistogramMatching/xcalc(500),ycalc(500),
     *        xoss(500),xoss_f(500),
     *        xcalcCT(500),ycalcCT(500),
     *        xofin(500),pdo(500),
     *        xcfin(500),pdc(500),
     *        ai(500),bi(500),
     *        npuntiOss,npuntiCal,npuntiCT,nsipCS,iTypeFunCT


      real hisob(ntot1),hisca(ntot1)
*     real, allocatable  ::  hisobcoLocal(:,:)

c     write(lo,*)
c     write(lo,*)'*********************************************'
c     write(lo,*)'*                HISTOGRAM MATCHING         *'
c     write(lo,*)'*********************************************'
c     write(lo,*)

      call AllocaHistoMatch(1, ntot1)
*     allocate(hisobcoLocal(4,ntot1), stat = ierr)
*     hisobcoLocal(:,:)=0.0
c--
      iTypeFunCT = iTypeFunCT1

      nsipCS=nsip1
      nwizmCS=nwizm1

      ntotCS=0
      do i=1,ntot1
        if (hisob(i) > 0.0000000001.and.iTypeFunCT > 0) then
c       if (hisob(i) > 0.0.and.iTypeFunCT > 0) then
          ntotCS=ntotCS+1
          hisobcoLocal(1,ntotCS)=hisob(i)
          hisobcoLocal(2,ntotCS)=hisca(i)
          hisobcoLocal(3,ntotCS)=float(i)
        elseif(abs(hisob(i)) < 9000.and.iTypeFunCT==0) then
          ntotCS=ntotCS+1
          hisobcoLocal(1,ntotCS)=hisob(i)
          hisobcoLocal(2,ntotCS)=hisca(i)
          hisobcoLocal(3,ntotCS)=float(i)
        endif
      enddo  


      call sortall2(hisobcoLocal,4,1,ntotCS,ntotCS,-1)
      rmin= hisobcoLocal(1,1)
      rmax= hisobcoLocal(1,ntotCS)


 10   nwiz=nint(float(ntotCS)/float(nsipCS))
      if (nwiz > 0) then                     ! gianluca 18/07/2012
          if (nwiz.lt.nwizmCS) then
              nsipCS=nint(float(nsipCS)/2.0)
              goto 10
          end if
      endif
*     nsipCS=nint(float(ntotCS)/float(nwiz)) 
      nwizl=ntotCS-nwiz*(nsipCS-1)

c     write(lo,1000)nsipCS,nwiz,nwizl,ntotCS
c1000 format (10x,'Nr. of areas ....................',i6,/,
c    +        10x,'Nr. of ref. in one area .........',i6,/,
c    +        10x,'Nr. of ref. in the last area ....',i6,/,
c    +        10x,'Nr. of reflections ..............',i6,/)


      ! per la grafica
      xofin(:)=0.0 
      xcfin(:)=0.0 
      pdc(:)=0.0 
      pdo(:)=0.0 
      ! per il matching
      xoss(:)=0.0   ! prima HM
      xoss_f(:)=0.0 ! dopo  HM
      xcalc(:)=0.0  ! calcolato

      xoss(1)=rmin
      xoss(nsipCS+1)=rmax
      xofin(1)=rmin
      xofin(nsipCS+1)=rmax

      ic=0
      ii=1
      nwizj=nwiz
      do i=1,ntotCS
       if (ii.eq.nsipCS) nwizj=nwizl
       ic=ic+1
       if (ic.eq.nwizj) then
         ii=ii+1
         xofin(ii)=hisobcoLocal(1,i)
         xoss(ii)=hisobcoLocal(1,i)
         ic=0
       endif
      enddo    
c
c----- curva sperimentale: per la grafica
      do i=2,nsipCS+1
       xofin(i) = (xofin(i-1)+xofin(i))/2.0
       de= (xofin(i)-xofin(i-1))/2.0
       pdo(i)=float(nwiz)/(float(ntotCS)*de)
       if (i.eq.nsipCS+1) pdo(i)=float(nwizl)/(float(ntotCS)*de)
      enddo   
      npuntiOss=nsipCS+1
      xofin(npuntiOss+1)=rmax

c---- dividiamo la curva teorica/calcolata in aree uguali
      if (iTypeFunCT == 1) then
       ! il caso matching  tra due set di dati
       ! riordiniamo per i dati calcolati
        call sortall2(hisobcoLocal,4,2,ntotCS,ntotCS,-1)
        rmin= hisobcoLocal(2,1)
        rmax= hisobcoLocal(2,ntotCS)
        xcalc(1)=rmin
        xcalc(nsipCS+1)=rmax
        xcfin(1)=rmin
        xcfin(nsipCS+1)=rmax
        ic=0
        ii=1
        nwizj=nwiz
        do i=1,ntotCS
         if (ii.eq.nsipCS) nwizj=nwizl
         ic=ic+1
         if (ic.eq.nwizj) then
             ii=ii+1
             xcfin(ii)=hisobcoLocal(2,i)
             xcalc(ii)=hisobcoLocal(2,i)
             ic=0
         endif
        enddo  
       do i=2,nsipCS+1
        xcfin(i) = (xcfin(i-1)+xcfin(i))/2.0
        de= (xcfin(i)-xcfin(i-1))/2.0
        pdc(i)=float(nwiz)/(float(ntotCS)*de)
        if (i.eq.nsipCS+1) pdc(i)=float(nwizl)/(float(ntotCS)*de)
       enddo
       npuntiCal=nsipCS+1
       xcfin(npuntiCal+1)=rmax
       ! riordiniamo per i dati osservati
       call sortall2(hisobcoLocal,4,1,ntotCS,ntotCS,-1)

      else
       ! il caso matching con una curva teorica da una funzione/dati calc.

        select case (iTypeFunCT)
        case (0)
          ! P(Delta)
          aat =-2.0
          bbt = 2.0
        case (2)
          ! vuoto
        case (3)
          ! P(wt)
          aat = 0.0
          bbt = 1.0
        case (31)
          ! P(wt)
          aat = 0.0
          bbt = 1.0
        case (4)
          ! P(E)
          aat = 0.0
          bbt = 4.5
        end select

        call DividereCurvaTeorica(aat,bbt)
      endif

c---  shift la curva exp.
      call MatchTwoHM
c---  calc. nuovi valori osservati
      call newvalueHM(hisobcoLocal,ntotCS)
c-------

c     call sortall2(hisobcoLocal,4,3,ntotCS,ntotCS,-1)
c     write(6,*) 'Dopo newvalueHM'
      do i=1,ntotCS
        ii=hisobcoLocal(3,i)
        hisob(ii)=hisobcoLocal(4,i)
c       write(6,'(i8,3f15.4)')i,hisobcoLocal(1,i),hisobcoLocal(2,i),hisobcoLocal(4,i)
      enddo   


*     deallocate(hisobcoLocal, stat = ierr)   ! da deallocare alla fine(contan)

 
c     write(lo,*)
c     write(lo,*)'*********************************************'
c     write(lo,*)'*      END HISTOGRAM MATCHING               *'
c     write(lo,*)'*********************************************'
c     write(lo,*)
      return
      end
c------------------------------------------------------------
      subroutine DividereCurvaTeorica(at,bt)

      common /HistogramMatching/xcalc(500),ycalc(500),
     *        xoss(500),xoss_f(500),
     *        xcalcCT(500),ycalcCT(500),
     *        xofin(500),pdo(500),
     *        xcfin(500),pdc(500),
     *        ai(500),bi(500),
     *        npuntiOss,npuntiCal,npuntiCT,nsipCS,iTypeFunCT

      dimension YY2(500)
      Si=0.0
      sumS=0.0
      sumSsp=0.0
      iqsim=0
      s=0.0
      
  10  continue
      if (iTypeFunCT == 0) then
        call qsimp(at,bt,s,xcalcCT,ycalcCT,YY2,npuntiCT)
      else
        call qsimpHM(at,bt,s)
      endif
 
c     write(6,*)'Curva Teorica ,  S=',iTypeFunCT,s,at,bt,npuntiCT
c     print*,xcalcCT(1:npuntiCT)
c     print*,ycalcCT(1:npuntiCT)
c     stop
 
      Stot=s
      Sj=Stot/float(nsipCS)
      aj=at
      bj=bt
      bjp=bj
      j=1

  50  continue

      if (iTypeFunCT == 0) then
        call qsimp(aj,bj,s,xcalcCT,ycalcCT,YY2,npuntiCT)
      else
        call qsimpHM(aj,bj,s)
      endif

c     if (abs(s-Sj).lt.1.e-4) then
      if (abs(s-Sj).lt.1.e-6) then
         sumS=sumS+s
         sumSsp=sumSsp+abs(s-Sj)
         xcalc(j)=aj
         xcalc(j+1)=bj
         j=j+1
         if (j.eq.nsipCS) then
             xcalc(j)=bj
             xcalc(j+1)=bt
             sumS=sumS+s
             sumSsp=sumSsp+abs(s-sj)
c            write(6,*)'sumS=',sumS,sumSsp
             goto 100
         end if
         aj=bj
         bj=bt
         goto 50
      else
         if (s.gt.Sj) then
            bjp=bj
            bj = (aj+bj) /2.0
         else
            bj = (bj+bjp) /2.0
         endif
         goto 50
      end if

  100 continue

      return

      end
c-----------------------------------------------------
      SUBROUTINE QSIMP(A,B,S,XX,YY,YY2,NPU)
      PARAMETER (EPS=1.E-3, JMAX=10)
      dimension XX(NPU),YY(NPU),YY2(NPU)
      OST=-1.E30
      OS= -1.E30

      YP1=1.E30
      YPN= 1.E30

      CALL SPLINE(XX,YY,NPU,YP1,YPN,YY2)

      DO 11 J=1,JMAX
        CALL TRAPZD(A,B,ST,J,XX,YY,YY2,NPU)
        S=(4.*ST-OST)/3.
        IF (ABS(S-OS).LT.EPS*ABS(OS)) RETURN
        OS=S
        OST=ST
11    CONTINUE
c     PAUSE 'Too many steps.'
      call cstop('Too mny steps in QSIMP')
      RETURN
      END
c----------------------------------------
      SUBROUTINE TRAPZD(A,B,S,N,XX,YY,YY2,NPU)
      dimension XX(NPU),YY(NPU),YY2(NPU)
      SAVE IT

      IF (N.EQ.1) THEN
        S=0.5*(B-A)*(func(A,XX,YY,YY2,NPU)+func(B,XX,YY,YY2,NPU))
        IT=1
      ELSE
        TNM=IT
        DEL=(B-A)/TNM
        X=A+0.5*DEL
        SUM=0.
        DO 11 J=1,IT
          SUM=SUM+func(X,XX,YY,YY2,NPU)
          X=X+DEL
11      CONTINUE
        S=0.5*(S+(B-A)*SUM/TNM)
        IT=2*IT
      ENDIF
      RETURN
      END
c---------------------------------------------------------
      SUBROUTINE SPLINE(X,Y,N,YP1,YPN,Y2)
      PARAMETER (NMAX=1000)
      DIMENSION X(N),Y(N),Y2(N),U(NMAX)
      IF (YP1.GT..99E30) THEN
        Y2(1)=0.
        U(1)=0.
      ELSE
        Y2(1)=-0.5
        U(1)=(3./(X(2)-X(1)))*((Y(2)-Y(1))/(X(2)-X(1))-YP1)
      ENDIF
      DO 11 I=2,N-1
        SIG=(X(I)-X(I-1))/(X(I+1)-X(I-1))
        P=SIG*Y2(I-1)+2.
        Y2(I)=(SIG-1.)/P
        U(I)=(6.*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1))
     *      /(X(I)-X(I-1)))/(X(I+1)-X(I-1))-SIG*U(I-1))/P
11    CONTINUE
      IF (YPN.GT..99E30) THEN
        QN=0.
        UN=0.
      ELSE
        QN=0.5
        UN=(3./(X(N)-X(N-1)))*(YPN-(Y(N)-Y(N-1))/(X(N)-X(N-1)))
      ENDIF
      Y2(N)=(UN-QN*U(N-1))/(QN*Y2(N-1)+1.)
      DO 12 K=N-1,1,-1
        Y2(K)=Y2(K)*Y2(K+1)+U(K)
12    CONTINUE
      RETURN
      END
c----------------------------------------------
      function func (x,XX,YY,YY2,NPU)
      dimension XX(NPU),YY(NPU),YY2(NPU)

      call splint(XX,YY,YY2,NPU,x,y)
      if (y.lt.0) y=0.0
      func=y
      return
      end
c---------------------------------------------------------
      SUBROUTINE SPLINT(XA,YA,Y2A,N,X,Y)
      DIMENSION XA(N),YA(N),Y2A(N)
      KLO=1
      KHI=N
1     IF (KHI-KLO.GT.1) THEN
        K=(KHI+KLO)/2
        IF(XA(K).GT.X)THEN
          KHI=K
        ELSE
          KLO=K
        ENDIF
      GOTO 1
      ENDIF
      H=XA(KHI)-XA(KLO)
c     IF (H.EQ.0.) PAUSE 'Bad XA input.'
      IF (H.EQ.0.) call cstop('Bad XA in SPLINT')
      A=(XA(KHI)-X)/H
      B=(X-XA(KLO))/H
      Y=A*YA(KLO)+B*YA(KHI)+
     *      ((A**3-A)*Y2A(KLO)+(B**3-B)*Y2A(KHI))*(H**2)/6.
      RETURN
      END

c-----------------------------------------------------
      subroutine MatchTwoHM

      common /HistogramMatching/xcalc(500),ycalc(500),
     *        xoss(500),xoss_f(500),
     *        xcalcCT(500),ycalcCT(500),
     *        xofin(500),pdo(500),
     *        xcfin(500),pdc(500),
     *        ai(500),bi(500),
     *        npuntiOss,npuntiCal,npuntiCT,nsipCS,iTypeFunCT
      
c     write(6,*)'MatchTwoHM'
      do 10 i=1,nsipCS
       domin = xoss(i+1)-xoss(i)
       if (i > 1.and.domin < 0.000000001) then
         ai(i)=ai(i-1)
         bi(i)=bi(i-1)
       else
         ai(i) = (xcalc(i+1)-xcalc(i))/domin
         bi(i)=((xcalc(i)*xoss(i+1))-(xcalc(i+1)*xoss(i)))/domin
       endif
       xoss_f(i)=ai(i)*xoss(i)+bi(i)
       xoss_f(i+1)=ai(i)*xoss(i+1)+bi(i)
c      write(6,'(i8,5f10.5)')i,xoss(i),xcalc(i),ai(i),bi(i),xoss_f(i)
 10   continue

      return

      end
c-----------------------------------------------------------------------
c     Calcolo dei nuovi valori per HISOB (usare la scala-ai e lo shift-bi)
c-----------------------------------------------------------------------
      subroutine NewValueHM(hisobco,ntot)

      common /HistogramMatching/xcalc(500),ycalc(500),
     *        xoss(500),xoss_f(500),
     *        xcalcCT(500),ycalcCT(500),
     *        xofin(500),pdo(500),
     *        xcfin(500),pdc(500),
     *        ai(500),bi(500),
     *        npuntiOss,npuntiCal,npuntiCT,nsipCS,iTypeFunCT

      real hisobco(4,ntot)
      
c
      isip=2

      do 10 i=1,ntot

        if (hisobco(1,i).le.xoss(isip)) then
           hisobco(4,i)=ai(isip-1)*hisobco(1,i)+bi(isip-1)
        else
           isip=isip+1
           hisobco(4,i)=ai(isip-1)*hisobco(1,i)+bi(isip-1)
        end if

        if (hisobco(4,i) <  0.00000001) hisobco(4,i) = 0.0   ! dedi 11/03/08

   10 continue

      return

      end
c-----------------------------------------------------------------------
      subroutine qsimpHM(a,b,s)
c
      parameter (eps=1.e-3, jmax=10)
c
      ost=-1.E30
      os= -1.E30

      do j=1,jmax
        call trapzdHM(a,b,st,j)
        s=(4.*st-ost)/3.
        if (abs(s-os).lt.eps*abs(os)) return
        os=s
        ost=st
      enddo
c
      return
      end
c----------------------------------------
      subroutine trapzdHM(a,b,s,n)
c
      save it
c
      if (n.eq.1) then
          s=0.5*(b-a)*(funcHM(a)+funcHM(b))
          it=1
      else
          tnm=it
          del=(b-a)/tnm
          x=a+0.5*del
          sum=0.
          do j=1,it
            sum=sum+funcHM(x)
            x=x+del
          enddo
          s=0.5*(s+(b-a)*sum/tnm)
          it=2*it
      endif
c
      return
      end

c------------------------------------------------------------
      function funcHM(x)
      USE Trigonometria

!     iTypeFunCT = 0 distribuzione P(delta)
!     iTypeFunCT = 1 non si usa questa function (il caso matchind tra due set di dati)
!     iTypeFunCT = 2 ... libero per il momento
!     iTypeFunCT = 3 distribuzione P(wt)
!     iTypeFunCT = 4 distribuzione P(e)

      common /HistogramMatching/xcalc(500),ycalc(500),
     *        xoss(500),xoss_f(500),
     *        xcalcCT(500),ycalcCT(500),
     *        xofin(500),pdo(500),
     *        xcfin(500),pdc(500),
     *        ai(500),bi(500),
     *        npuntiOss,npuntiCal,npuntiCT,nsipCS,iTypeFunCT

      data a,x0,alfa,beta/0.4,0.3,2.0,3.0/
      data a2,x02,alfa2,beta2/4.0,0.2,2.0,1.5/

      if (iTypeFunCT.eq.0) y=p_de(x,pi) 
      if (iTypeFunCT.eq.3) y= (a*(x+x0)**alfa)*exp(-beta*x)
      if (iTypeFunCT.eq.31) y= (a2*(x+x02)**alfa2)*exp(-beta2*x)
      if (iTypeFunCT.eq.4) y= p_e(x)
      if (y.lt.0) y=0.0
      funcHM = y

      return
      end
c------------------------------------------------------------
      function p_e(x)

c     if(icentold==0) then
c--distribuzione acentrica
        arg=x**2
        fact= 2*x
c     elseif(icentold==1) then
c--distribuzione centrica
c       arg=x**2/2.
c       fact= sqrt(2.0/pi)
c     endif
c
      p_e=fact*exp(-arg)

      return
      end


c------------------------------------------------------
      function p_de(e,pi)
      common /xalfa/ alfa, delta
      real*8 I0X,QT
!g    pi=3.14
      X=2.*e*(e+delta)
      if (X.gt.3.75) then
         AA=2.*sqrt(2.)* alfa
         BB1=exp(-1.0*(delta**2))
         BB2=sqrt(e*(e+delta))
         BB3=exp(-1.0* alfa*e*e)
         QT=bessel_I0(X)
         p_de=AA*BB1*BB2*BB3*QT
      else
         AA=4.* alfa*e*(e+delta)
         bb=2.*e*e+ alfa*e*e+2.*delta*e+delta**2
         BB=exp(-1.0*bb)
         I0X=bessel_I0(X)
         p_de=AA*BB*I0X
      endif
c     print*,'PDE',e,x,p_de,QT
c     if (p_de.lt.0.001) p_de=0.0
      if (p_de.lt.0.0) p_de=0.0
    
      return
      end
!-----------------------------------------------------------------------
