#ifndef __G_EXT_H_mrt
#define __G_EXT_H_mrt

#include <exception>
#include <string>
#include <cstring>
#include <vector>
#include <ctime>

namespace gext
{
  class exception : public std::exception
  {
  public:
    exception(const gchar *msg) : strMessage(msg) {}
    exception(const std::string &msg) : strMessage(msg) {}
    virtual ~exception() throw() {}

    const std::string &get_message() const {return strMessage;}

  private:
    std::string strMessage;
  };

  gboolean str_is_white(const gchar *str);
  std::string path_get_dirpath(const gchar *fn);
  int  dir_create(const gchar *dir);
  void spawn_async(const std::string &exe, const std::vector<std::string> &args = std::vector<std::string> () );
}

#endif
