#ifndef __ILM_UTIL_H_mrt
#define __ILM_UTIL_H_mrt

#include <string>
#include <exception>
#include <vector>
#include <cmath>

#if 0
#ifdef GetMessage
// windows.h  defines GetMessage -> GetMessageA
#undef GetMessage
#endif
#endif

namespace Ilm
{
  typedef std::vector< std::string > vstring;
  typedef vstring::iterator vstring_it;
  typedef vstring::const_iterator vstring_cit;
  typedef vstring::reverse_iterator vstring_rit;
  typedef vstring::const_reverse_iterator vstring_crit;

  class UserError : public std::exception
  {
  public:
    UserError(const std::string &msg) : strMessage(msg) {;}
    virtual ~UserError() throw() {}

    const std::string & GetMessage() const {return strMessage;}

  private:
    std::string strMessage;

  };


  void edit_file(const std::string &fn);
  void view_file(const std::string &fn);
  void internet_browser(const std::string &fn);
  void internetbrowser(const std::string &fn);
  void read_anom_file(const std::string &fn, std::ostream &ostr, int &ntrials, const int typ);
  void read_anom_filePDB(const std::string &fn, std::ostream &ostr, const int typ);
  void read_PDB_file(const std::string &fn, int &nresidmin, int &nresidmax, int &nresidui);
  bool compare_names(const std::string &fn1, const std::string &fn2);
  void main_loop();

} // namespace Ilm

#endif
