      MODULE PhaseModule
          real      :: aperc(90),rperc(90)
          integer   :: npercm, nrefB
          integer   :: numbrun = 0
          real      :: errem = 0.0
          real      :: biso, oscale
          integer   :: maxcyc, jrest, nSetsFineDSR
          integer   :: ifVLD = 0
          integer   :: kWstop = 0
          integer   :: ifExamin = 1
          integer   :: ifTime = 0
!!!corrado
          real, dimension(7) :: shiftexam
          real               :: erore
!!!corrado
      END MODULE PhaseModule
!-----------------------------------------------------------------------
      MODULE DataModule
          integer :: ifPlotSpots = 0
          integer :: noSpaceGroup = 0
          integer :: ifContSuppl
          real    :: bfacPDB, wave
      END MODULE DataModule
!-----------------------------------------------------------------------
      MODULE MadModule
      common /erreMAD/ numR, NumRefR(5), rfacR(5)
      END MODULE MadModule
!-----------------------------------------------------------------------
      subroutine RotazTot()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine VecchiaExamin()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine toMolplo3(k)
!
      integer k
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GetBonds(k)
!
      integer k
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Disegna(k)
!
      integer k
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Orto(cella)
      USE General ! , only: pi
      USE Molcom
!
      implicit none
      integer :: i
      real    :: cella(6), alf, bet, gam
!
*     common /pippo/ asta(3),alf,bet,gam,sas,sbs,sgs,alfs,bets,gams,v
!
      alf = cella(4)
      bet = cella(5)
      gam = cella(6)
!
      do i=1, 3
         DeADef(i) = 3.0/cella(i)
         if ( DeADef(i) .gt. 0.5 ) DeADef(i) = 0.5
         DeA(i) = DeADef(i)
         nCell(i) = 1
      enddo
!
*     call toMolPlo1(a,b,c,alf,bet,gam)
      alf=pi/180*alf
      bet=pi/180*bet
      gam=pi/180*gam
! ---------
! ---------  sgs =  coseno di gamma star
! ---------
      sas=(cos(bet)*cos(gam)-cos(alf))/(sin(bet)*sin(gam))
      sbs=(cos(alf)*cos(gam)-cos(bet))/(sin(alf)*sin(gam))
      sgs=(cos(alf)*cos(bet)-cos(gam))/(sin(alf)*sin(bet))
! ---------
! ---------  gams =  gamma star
! ---------

      if ( sas .gt.  1.0 ) sas = 1.0
      if ( sas .lt. -1.0 ) sas =-1.0
      alfs=acos(sas)
      if ( sbs .gt.  1.0 ) sbs = 1.0
      if ( sbs .lt. -1.0 ) sbs =-1.0
      bets=acos(sbs)
      if ( sgs .gt.  1.0 ) sgs = 1.0
      if ( sgs .lt. -1.0 ) sgs =-1.0
      gams=acos(sgs)
      volume = cella(1) * cella(2) * cella(3)
      volume = volume*sqrt(sin(alf)**2+sin(bet)**2+sin(gam)**2-2+
     *         2*cos(alf)*cos(bet)*cos(gam))
      asta(1) = cella(2) * cella(3) * sin(alf) / volume
      asta(2) = cella(1) * cella(3) * sin(bet) / volume
      asta(3) = cella(1) * cella(2) * sin(gam) / volume
!
      rmi(1,1) = 1.0 / cella(1)
      rmi(2,1) = 0.0
      rmi(3,1) = 0.0
      rmi(1,2) = -cos(gam) / (cella(1)*sin(gam))
      rmi(2,2) = 1.0 / (cella(2)*sin(gam))
      rmi(3,2) = 0.0
      rmi(1,3) = asta(1) * cos(bets)
      rmi(2,3) = asta(2) * cos(alfs)
      rmi(3,3) = asta(3)
!
      call InvRmi
!
      return
      end
!----------------------------------------------------------------
      subroutine examin(nuset,mkang,khl,iphiv,iphic,mmm,numbx,wtexa,
     *                  ifmin_input)
      DIMENSION mkang(mmm),khl(3,mmm),iphiv(mmm),iphic(mmm),wtexa(mmm)
      end
!----------------------------------------------------------------
      subroutine MolPlo(iPlt, ifSingle)
      end 
!----------------------------------------------------------------
      subroutine ManageJavHydro(natsOld)
      end
!----------------------------------------------------------------
      subroutine to_coord_sir(kdstampa,numb)
      end subroutine to_coord_sir
!----------------------------------------------------------------
      subroutine outShelx(ifref)
      integer, intent(in) :: ifref
      end subroutine outShelx
!----------------------------------------------------------------
!      subroutine Open_GLWindow()
!      end subroutine Open_GLWindow
!----------------------------------------------------------------
!      subroutine Close_GLWindow()
!      end subroutine Close_GLWindow
!----------------------------------------------------------------
!      subroutine GetStructureInfo(info, icalc)
!      end subroutine GetStructureInfo
!----------------------------------------------------------------
      subroutine importa(filnam, dirnam, iAction, ier)
      end subroutine importa
!----------------------------------------------------------------

!-----------------------------------------------------------------------
      subroutine cmult2002(i1,eps,mult)
      USE General
      USE Symmetry
!
!-- compute epsilon and multiplicity by generating equivalent
!-- reflections
!-- epsylon = number of times same reflection appears in list
!-- multiplicity = number different reflections in list
!
      dimension i1(3),i2(3)
!
!pgMAD
      nsymPG = nsym
      if (kmad.ne.0.and.icent.gt.0) then
         nsymPG = nsym / 2
      end if
!pgMAD
      eps=1.0
      mult=1
!-- in triclinic space groups eps = 1.0 and mult = 1
      if (nsym.ne.1) then
          k1 = i1(1) * ifat512a + i1(2) * ifat512b + i1(3)
          ik1 = - k1
          do j=2,nsym
             i2 = 0
             do l=1,3
                do k=1,2
                   m=iabs(ismat(k,l,j))
                   if (m.gt.0) then
                       i2(m) = i2(m) + i1(l) * isign( 1,ismat(k,l,j) )
                   endif
                enddo
             enddo
             k2 = i2(1) * ifat512a + i2(2) * ifat512b + i2(3)
             if (k2.eq.k1) then
                 eps = eps + 1.0
             endif
             if (icent.ne.0.and.k2.eq.ik1) then
                 eps = eps + 1.0
             endif
             if (k2.eq.k1.or.k2.eq.ik1) then
                 mult = mult + 1
             endif
          enddo
      endif
      mult =nsymPG / mult           !pgMAD
!
      return
      end
