!-----------------------------------------------------------------------
      MODULE MappeViewer
!
         type MapView
            integer  :: np(3)
            real     :: sigma
            real, allocatable    :: xmap(:,:,:)
         end type MapView
         type(MapView),   allocatable :: Mappe(:)
!
      
      END MODULE MappeViewer
!-----------------------------------------------------------------------
      subroutine ilmv()
      USE General
      USE Symmetry
      USE ilmviewmod
!
      implicit none
      integer iargcc, i, tipo, iAction, lix1, lix2, ier, Lung
      integer nExitCode, ierr
      real celltemp(13)
      character*256 titoloV
      character*256 args(10)
      common /Args/ iargcc, args
!
      common /provaMappa/ ifPiuUno
      integer :: ifPiuUno, ifDifference
!
      SaltaUNK = .false.
      ifPiuUno = 0
      ifDifference = 0
!
      WhichProps = 1
!
      exepath = args(1) // char(0)
      call fGetProgDir(exepath, i)
      call PrimeCose(ier)               !!mr
!!mr
      if (ier /= 0) then
          return
      endif
!!end mr
      if (iprin > 0) then
          write(0,*) 'Num. args', iargcc
          write(0,*) 'exepath: ', exepath(1:Lung(exepath))
      endif
      ier = 0
      tipo = 0
!
      titoloV = 'Jav'
!     call OpenWindow(titoloV, ierr)
      if (iargcc == 1) then
          call ilmview_open()     !!Open_GLWindow()
      else
!
      !!if (iargcc > 1) then
          do i=2, iargcc
             if (iprin > 0) then
                 write(0,*) i, args(i)(1:Lung(args(i)))
             endif
             if (args(i)(1:Lung(args(i))) == '-D') then
                 iprin = 1
             elseif (args(i)(1:Lung(args(i))) == '-d') then
                 ifDifference = 1
             else if (args(i)(1:Lung(args(i))) == '-a') then
                 ifAutomatic = 1
             else
                 call TipoFile(args(i), tipo)
                 call GesFile(args(i), tipo, ifDifference)
             endif
          enddo
      endif
!
      call GtkMainLoop()
!      if (ierr == 0) then
!          call StartGtkMainLoop(0, ier)
!      endif
!
      return
   10 format('Problems with labels in MTZ file ',a)
      end
!-----------------------------------------------------------------------
      subroutine PrimeCose(ier)
      USE General
      USE Molcom
      USE elements
      USE bondtmod
      USE spginfom
!
      implicit none
      integer ier, ex2, ex3, ex4, ex5, i1, i2, k, j2, j3, j4, j5
      integer jopen, jop, nExitCode, Missing, itipo, iform, ierr, Lung
      character*256 cfgdir
      integer nfGetEnv, getCfgDir
!
      call InitJav
!
      ixv(1) = 1020
      iyv(1) = 1000      !!mr 703
      ixv(2) = 0
      iyv(2) = 0

      ifW95 = nfGetEnv()
      call GetMessagesCode
      call FillCaratteriSpeciali()
      if (ifW95 == 0) then
          slash = char(47)
      else
          slash = char(92)
      endif
!
      cfgdir = ' '
      cfgdir(256:256) = char(0)
      ier   = getCfgDir(cfgdir)
      if (ier /= 0) then
          ier = -1
          return
      endif
      if (iprin > 0) then
          write(0,*) 'FFILE:   ',ffile(1:Lung(ffile))
          write(0,*) 'IASUN:   ',iasun(1:Lung(iasun))
          write(0,*) 'EXEPATH: ',exepath(1:Lung(exepath))
      endif
      
      cardImage   = ffile     ! = '.xen'
      ffile  = 'Sir' //  cardImage(1:Lung(cardImage))
      cardImage   = iasun     ! = '.spg'
      iasun  = 'Sir' //  cardImage(1:Lung(cardImage))
      cardImage   = SymmSPG     ! = '.cnv'
      SymmSPG  = 'Sir' //  cardImage(1:Lung(cardImage))
      i1 = Lung (exepath)
      j2 = Lung(ffile)
      j3 = Lung(iasun)
      j4 = Lung(syminfo)
      j5 = Lung(SymmSPG)
!
      if (i1.gt.0) then
          cardImage=' '
          k = index(exepath, 'javdir',BACK=.true.)
          if (k > 0) then
              exepath(k:) = 'files' // slash
              i2 = Lung(exepath)
          else
              i2 = i1
          endif
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j2)=ffile
          ffile=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j3)=iasun
          iasun=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j4)=syminfo
          syminfo=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j5)=SymmSPG
          SymmSPG=cardImage
!
      endif
      j2 = j2 + i2
      j3 = j3 + i2
      j4 = j4 + i2                   !!mr
      j5 = j5 + i2                   !!mr
!
!-- check if files exist
!
      itipo = 2
      iform = 1
!
      jop=jopen(kform,ffile,itipo,iform,ierr)
      if (jop.lt.0) then
          ex2 = 0
        else
          ex2 = 1
          close(kform)
      endif
!
      jop=jopen(kform,iasun,itipo,iform,ierr)
      if (jop.lt.0) then
          ex3 = 0
        else
          ex3 = 1
          close (kform)
      endif
!
      jop=jopen(kform,syminfo,itipo,iform,ierr)
      if (jop.lt.0) then
          ex4 = 0
      else
          ex4 = 1
          call spg_set_symmetry_file(syminfo)
          close (kform)
      endif
!
      jop=jopen(kform,SymmSPG,itipo,iform,ierr)
      if (jop.lt.0) then
          ex5 = 0
      else
          ex5 = 1
          close (kform)
      endif
!
      Missing = 0
      if (ex2.ne.1) then
          if (Missing == 0) then
              write(*,10)
              Missing = 1
          endif
          write(*,'(a)') ffile(1:j2)
          ier = -2
          write(Msg,70) ffile(1:j2)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      endif
      if (ex3.ne.1) then
          if (Missing == 0) then
              write(*,10)
              Missing = 1
          endif
          write(*,'(a)') iasun(1:j3)
          ier = -2
          write(Msg,70) iasun(1:j3)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      endif
      if (ex5.ne.1) then
          if (Missing == 0) then
              write(*,10)
              Missing = 1
          endif
          write(*,'(a)') SymmSPG(1:j5)
          ier = -2
          write(Msg,70) SymmSPG(1:j5)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      endif
      if (ex4.ne.1) then
          if (Missing == 0) then
              write(*,10)
              Missing = 1
          endif
          write(*,'(a)') syminfo(1:j4)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) syminfo(1:j4)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
            else
              if (iprin > 0) then
                  write(lo,80) syminfo(1:j4)
              endif
          endif
      endif
      if (Missing > 0) then
      endif
!
!-- log file
!
      if (iprin > 0) then
          Inte = ProgName(1:lProgName) // '.log'
          itipo = 0
          iform = 1
          jop = jopen(lo, Inte, itipo, iform, ierr)
      endif
      cardImage = ProgName(1:lProgName) // ' (Version ' 
     *          // Version(1:3) // ')'
      i1 = Lung(cardImage)
!
!-- Header
!
      call sirdate(Inte, k)
      if (iprin > 0) then
          write(lo,20) cardImage(1:i1), Inte(1: k)
      endif
!     carica tabella degli elementi chimici 
      call read_chemical_elements(ffile)
!     carica tabella dei legami
      call load_bond_table()
!
      return
   10 format(//,' ***** ERROR *****',/,' Missing files:')
   20 format(/,' ',a,' starts on ',a,/)
   70 format(' File ',a,' does not exist.')
   80 format(//,' *** WARNING ***  File ',a,' does not exist.')
      end
!-----------------------------------------------------------------------
      subroutine InitJav
      USE General
      USE Symmetry
      USE Mappa
      USE RemoModule
      USE Molcom, only : ifCont
      USE ilmviewmod
!
      implicit none
      integer ifPlotSpots, noSpaceGroup, ifContSuppl, iAction
      real bfacPDB, wave, scaled, sigma
      common /dataCommon/ ifPlotSpots, bfacPDB, noSpaceGroup,
     *                    ifContSuppl, wave, scaled
      character Numdigit*13
      common /cifre/ Numdigit
!
      data Numdigit/'0123456789.-+'/
!
      QualePgm = JAVPGM
      ifCont = 0
      jspini = -1
      ifCutResidui = 0
      nLegProtein = 0
      nLegBack = 0
      nLegCalpha = 0
      Species(:) = ' '
      nk = 0
      iprin = 0
      InfoOK(:) = 0
      ifFreeLunch = 0
      noSpaceGroup = 0
      pi = 4.0 * atan(1.0)
      twopi  = 2.0 * pi
      twopis = 2.0 * pi * pi
      rtod   = 180.0 / pi
      dtor   = 1.0 / rtod
      igrid = 0
      WhichModel = 0
      WhichMonomer = 0
      MaxnumbModels = 5
      MonomerInModel(:) = 1
      numbModels = MaxnumbModels
      iAction = 0
      call AllocaModelRemo(iAction)
      call AllocaBonds(iAction)
      numbModels = 0
!!!!!corr
      call jav_init()
      num_models = 0     !!mr
!!!!!corr
!
      numbMaps = 0
      WhichMap = 0
      MaxnumbMaps = 5
      iAction = 0
      np(1:3) = 0
      sigma = 0.0
      call AllocaMappeViewer(iAction, np, sigma)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ExitIlmv()
      USE General
      USE Molcom
!
      implicit none
      integer     :: np(3), iAction, k
      real        :: sigma
!
      iAction = 2
      np(1:3) = 0
      sigma = 0.0
      call AllocaMappeViewer(iAction, np, sigma)
      call AllocaModelRemo(iAction)
      call DistruggiPianiAll
      call sirdate(Inte, k)
      if (iprin > 0) then
          write(lo,20) ProgName(1:lProgName), Inte(1: k)
      endif
      if (iprin > 0) then
          close(lo)
      endif
!
      return
   20 format(/,' ',a,' ends on ',a)
      end
!-----------------------------------------------------------------------
      subroutine TipoFile(arg, tipo)
      USE General, only: iprin
!
      implicit none
      integer tipo, ind, Lung
      character*256 arg
      character*3 ext
!
      ind = index(arg, '.',.TRUE.)
      if (ind > 0) then
          ext = arg(ind+1:ind+4)
          if (iprin > 0) then
              write(6,*) 'ARG:     ',arg(1:Lung(arg))
              write(6,*) 'EXT:     ',ext
          endif
          call lcase(ext)
          if (ext == 'mtz') then
              tipo = 1
          elseif (ext == 'fcf') then
              tipo = 2
          elseif (ext == 'phs') then
              tipo = 3
          elseif (ext == 'hkl') then
              tipo = 4
          elseif (ext == 'pdb') then
              tipo = 11
          elseif (ext == 'ent') then
              tipo = 11
          elseif (ext == 'cif') then
              tipo = 12
          elseif (ext == 'ins') then
              tipo = 13
          elseif (ext == 'res') then
              tipo = 13
          elseif (ext == 'map') then
              tipo = 21
          elseif (ext == 'xyz') then
              tipo = 22
          elseif (ext == 'dmp') then
              tipo = 23
          else
              tipo = -1
          endif
      else
          tipo = -1
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LeggiHKL(tipo, filename, ifDifference, SogliaRes,
     *                    ifHelix, ier)
      USE General
      USE Riflessi
      USE Symmetry
      USE Mappa
!
      implicit none
      integer             :: tipo, nr, jump, lh, lk, ll, lix1, lix2, ier
      integer             :: iAction, ifWei, itype, iform, L, Lung, ierr
      integer             :: jopen, ios, iex, i, hkl(3), phi
      integer             :: ifHelix, ifDifference
      real                :: celltemp(13), cellSav(9), fo, fc, peso, rho
      integer             :: ifCif, ifCifFunction
      real                :: a1, a2, a3, a4, si
      real                :: SogliaRes
      logical             :: ifEof
      character (len = *) :: filename
      character (len=20)  :: formato
!
      call CPUTime0(' ')
      ifCif = 0
      celltemp(:) = 0.0
!
      cellSav(1:9) = cell(1:9)
      MTZfile = filename
      if (tipo == 1) then                      ! MTZ
          if (iprin > 0) then
              if (ifDifference == 0) then
                  write(lo,200) filename(1:Lung(filename))
              else
                  write(lo,250) filename(1:Lung(filename))
              endif
          endif
          iAction = 1
          lix1 = 0
          lix2 = 0
          call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
          if (InfoOK(1) == 0) then
              call ManageCell(celltemp, ier)
          else
              if (cellSav(1) > 0.01) then
                  cell(1:9) = cellSav(1:9)
                  call ManageCell(celltemp, ier)
              endif
          endif
          InfoOK(2) = lix2
!
          if (ier < 0) then
              iAction = 3
              lix1 = 0
              lix2 = 0
              call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
              return
          endif
!
          iAction = 2
          lix1 = 0
          lix2 = 0
          call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
          nreflDim = nreflMTZ
          nrefl    = nreflDim
          call AllocaRiflessiIMV(1)
!
          call ManageLabels(ifWei, ifDifference, ier)
          if (ier < 0) then
              iAction = 3
              lix1 = 0
              lix2 = 0
              call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
              return
          endif
          if (iprin > 0) then
              write(0,*) 'IFWEI ',ifWei
          endif
!
          rhomax = -9999
          nr = 0
          do
             call GetHklMTZ(jump, lh, lk, ll, ifEof)
             if (ifEof) then
                 exit
             endif
             hkl(1) = lh
             hkl(2) = lk
             hkl(3) = ll
             call CalcolaRho(hkl, rho)
             resm = 0.5 / sqrt(rho)
             if (resm < SogliaRes) cycle
             if (rho > rhomax) then
                 rhomax = rho
             endif
             nr = nr + 1
             khl(1,nr) = hkl(1)
             khl(2,nr) = hkl(2)
             khl(3,nr) = hkl(3)
             fovet(nr) = valoriMTZ(1)
             iphaz(nr) = valoriMTZ(2)
             wt(nr)    = valoriMTZ(3)
          enddo
          resm = 0.5 / sqrt(rhomax)
          nrefl = nr
!
          if (iprin > 0) then
              write(0,*) 'IFWEI ',ifWei
          endif
          iAction = 3
          lix1 = 0
          lix2 = 0
          call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
          if (iprin > 0) then
              write(0,*) 'CELL',cell(1:6)
              write(0,*) 'NSYM',nsym
              write(0,*) 'NREF',nreflDim, nr
          endif
      elseif (tipo == 2) then                  ! SHELX
          L = Lung(filename)
          itype = 2
          iform = 1
          ierr =  jopen(jhost, filename, itype, iform, ios)
          if (ierr < 0) then
              write(Msg,'("Cannot load ",a," file")') filename(1:L)
              call MsgWinErr('Open file error', Msg, ERR_WINDOW, iex)
              ier = -1
              return
          endif
          formato = '(3i4,2f10.2,f7.2)'
          ifCif = ifCifFunction(jhost, formato, cardImage)
          if (ifCif == 1) then
              call LeggiFcfCIF(ier)
              close(jhost)
              if (ier < 0) then
                  write(Msg,'("Problems reading CIF file ",a)') 
     *                  filename(1:L)
                  call MsgWinErr('Read error', Msg, ERR_WINDOW, iex)
                  return
              endif
              formato = ReflFileForm
              L = Lung(ReflFileName)
              itype = 2
              iform = 1
              ierr =  jopen(jhost, ReflFileName, itype, iform, ios)
              if (ierr < 0) then
                  write(Msg,'("Cannot load ",a," file")') 
     *                  ReflFileName(1:L)
                  call MsgWinErr('Open file error', Msg, ERR_WINDOW,iex)
                  ier = -1
                  return
              endif
          endif
!         if (ifCif == 0 .and. ier == 0) then
          if (InfoOK(1) == 0 .or. InfoOK(2) == 0) then
              nr = InfoOK(1)
              call Get_1_2(nr, ier)
              if (ier < 0) then
                  close(jhost)
                  return
              endif
              celltemp(1:6) = cell(1:6)
              errcell(:) = 0
              call CreaCellInfo(celltemp) ! (1:6))
              if (InfoOK(2) == 0) then
                  call CreaSymmetryInfo(ier)
              endif
          endif
          nreflDim = 0
          do while (ier == 0)
             read(jhost,'(a)',end=100) cardImage
             nreflDim = nreflDim + 1
          enddo
  100     continue
          nrefl    = nreflDim
          call AllocaRiflessiIMV(1)
          rewind jhost
          nr = 0
          if (iprin > 0) then
              write(lo,300) filename(1:Lung(filename))
          endif
          do i=1, nrefl
             read(jhost, formato) lh, lk, ll, a1, a2, a3
             if (ifCif == 0) then
                 fo  = a1
                 fc  = a2
                 si  = 0.0
                 phi = a3
             else
                 fo  = a1
                 si  = a2
                 fc  = 0.0
                 phi = a3
             endif
             if (lh /= 0 .or. lk /= 0 .or. ll /= 0) then
                 khl(1,i) = lh
                 khl(2,i) = lk
                 khl(3,i) = ll
                 hkl(1) = lh
                 hkl(2) = lk
                 hkl(3) = ll
                 call CalcolaRho(hkl, rho)
                 resm = 0.5 / sqrt(rho)
                 if (resm < SogliaRes) cycle
                 if (rho > rhomax) then
                     rhomax = rho
                 endif
                 fovet(i)  = fo
                 fcvet(i)  = fc
                 sigmav(i) = si
                 iphaz(i)  = phi
                 nr = nr + 1
             endif
          enddo
          ifWei = 0
      elseif (tipo == 3 .or. tipo == 4) then   ! PHS or FREE
          L = Lung(filename)
          itype = 2
          iform = 1
          ierr =  jopen(jhost, filename, itype, iform, ios)
          if (ierr < 0) then
              write(Msg,'("Cannot load ",a," file")') filename(1:L)
              call MsgWinErr('Open file error', Msg, ERR_WINDOW, iex)
              ier = -1
              return
          endif
          if (InfoOK(1) == 0 .or. InfoOK(2) == 0) then
              nr = InfoOK(1)
              call Get_1_2(nr, ier)
              if (ier < 0) then
                  close(jhost)
                  return
              endif
              celltemp(1:6) = cell(1:6)
              errcell(:) = 0
              call CreaCellInfo(celltemp) ! (1:6))
              if (InfoOK(2) == 0) then
                  call CreaSymmetryInfo(ier)
              endif
          endif
          nreflDim = 0
          do while (ier == 0)
             read(jhost,'(a)',end=110) cardImage
             nreflDim = nreflDim + 1
          enddo
  110      continue
          nrefl    = nreflDim
          call AllocaRiflessiIMV(1)
          rewind jhost
          nr = 0
          if (tipo == 4) then
              if (iprin > 0) then
                  write(lo,300) filename(1:Lung(filename))
              endif
              do i=1, nrefl
                 read(jhost,*) lh, lk, ll, fo, peso, phi
                 if (lh /= 0 .or. lk /= 0 .or. ll /= 0) then
                     khl(1,i) = lh
                     khl(2,i) = lk
                     khl(3,i) = ll
                     hkl(1) = lh
                     hkl(2) = lk
                     hkl(3) = ll
                     call CalcolaRho(hkl, rho)
                     resm = 0.5 / sqrt(rho)
                     if (resm < SogliaRes) cycle
                     if (rho > rhomax) then
                         rhomax = rho
                     endif
                     fovet(i) = fo
                     iphaz(i) = phi
                     nr = nr + 1
                 endif
              enddo
              ifWei = 0
          else
              if (iprin > 0) then
                  write(lo,400) filename(1:Lung(filename))
              endif
              do i=1, nrefl
                 read(jhost,'(3i4,f8.2,f8.4,i5)') lh,lk,ll,fo,peso,phi
                 if (lh /= 0 .or. lk /= 0 .or. ll /= 0) then
                     khl(1,i) = lh
                     khl(2,i) = lk
                     khl(3,i) = ll
                     hkl(1) = lh
                     hkl(2) = lk
                     hkl(3) = ll
                     call CalcolaRho(hkl, rho)
                     resm = 0.5 / sqrt(rho)
                     if (resm < SogliaRes) cycle
                     if (rho > rhomax) then
                         rhomax = rho
                     endif
                     fovet(i) = fo
                     iphaz(i) = phi
                     wt(i)    = peso
                     nr = nr + 1
                 endif
              enddo
              ifWei = 1
          endif
          resm = 0.5 / sqrt(rhomax)
          nrefl = nr
!
      endif
!
      call CPUTime('Reading reflections', 0)
      if (iprin > 0) then
          write(lo,600) Inte(1:Lung(Inte))
      endif
      if (ier < 0) then
          call AllocaRiflessiIMV(2)
          return
      endif
      if (iprin > 0) then
          write(0,*) 'IFWEI ',ifWei
      endif
      if (ifWei == 0) then
          wt(1:nrefl) = 1.0
      endif
!
      if (iprin > 0) then
          write(lo,610) Inte(1:Lung(Inte))
      endif
      if (ifHelix == 0) then
          ifFreeLunch = 1
          call CalcGrid
          ifFreeLunch = 0
      else
          call CalcolaNP
      endif
      iAction = 1
      call AllocaMappaJav(iAction)
!
      call CPUTime0(' ')
      fcoef(1:nrefl) = fovet(1:nrefl) * wt(1:nrefl)
      call MakeMap(fcoef,iphaz,nrefl,0,xmap,FORTH,BACK)
      call CPUTime('Create Map', 0)
      if (iprin > 0) then
          write(lo,620) Inte(1:Lung(Inte))
      endif
      call AllocaRiflessiIMV(2)
!
      if (tipo > 1) then
          if (ifCif == 1) then
              close(jhost, status='delete')
          else
              close(jhost, status='delete')
          endif
      endif
          
!
      return
  200 format(/,' Load reflection file (MTZ format) ',a,/)
  250 format(/,' Load reflection file (MTZ format) ',a,/,
     *         ' (Difference map)',/)
  300 format(/,' Load reflection file (Blank separated columns) ',a,/)
  400 format(/,' Load reflection file (PHS format) ',a,/)
  600 format(' Reading reflections ', a)
  610 format(' Compute rhomax      ', a)
  620 format(' Create Map          ', a,/)
      end
!-----------------------------------------------------------------------
      integer function ifCifFunction(jhost, formato, cardImage)
!
      implicit none
      integer :: jhost, h, k, l
      real    :: Fo, Fc, Phase
      character (len=20) :: formato
      character (len=*)  :: cardImage
!
!-- LIST 5: h,k,l, Fo, Fc, and Phase (in degrees) 
!-- LIST 6: cif style
!
      cardImage = ' '
      do while (cardImage == ' ')
         read(jhost,'(a)') cardImage
      enddo
!-- Check if LIST 5
      read(cardImage, formato, err=10) h, k, l, Fo, Fc, Phase
      ifCifFunction = 0
      rewind jhost
      return
!
!-- is a LIST 6 type
!
   10 ifCifFunction = 1
      rewind jhost
      return
!
      end
!-----------------------------------------------------------------------
      subroutine LeggiFcfCIF(ier)
      USE General, only : InfoOK
      USE Symmetry
!
      implicit none
      integer           :: ifRefl, ier, ifSPG, iprn, nats, b_or_u
      integer           :: nSymCard
      real              :: celltemp(13), wave
!
      call FillCifKey()
      ifRefl = 0
      nats = 0
      celltemp(:) = 0
      call LeggiCIFinMem(ifSPG, ifRefl, nats, celltemp, iprn, 
     *                   b_or_u, nSymCard, wave, ier)
      if (ier < 0) return
      if (celltemp(1) > 0) then
          call ManageCell(celltemp, ier)
          if (ier < 0) return
      endif
      if (nSymCard > 0 .and. InfoOK(2) == 0) then
          nsym  = nSymCard
          latt  = 1
          icent = 0
          call ManageSymmCards(ier)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CalcolaNP
      USE General
      USE Mappa
!
      factr = resm / 6.0
      do 130 i=1,3
         np(i)=cell(i)/factr+0.5
!
         if (np(i).le.2*ihmx(i)) np(i)=2*ihmx(i)+1    ! Dritan
         if (i == 3) np(i) = np(i) + mod(np(i), 2)
  110    ntest=np(i)
         do 120 j=2,5
  115       if (ntest.ne.(ntest/j)*j) go to 120
            ntest=ntest/j
            if (ntest == 1) go to 130
            go to 115
  120    continue
         np(i)=np(i)+1
         if (i == 3) np(i) = np(i) + 1
         go to 110
  130 continue
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ManageLabels(ifWei, ifDifference, ier)
      USE General
      USE Dialogo
!
      implicit none
      integer   :: ier, i, k, hklPos(3), Num_Col, nCoefs, nPhases, nWT
      integer   :: ifWei, nIt, ifDifference, nExitCode
!
      Num_Col = 100
      nCoefs  = 0
      nPhases = 0
      nWT     = 0
      nIt     = 0
      k = 0
      do i=1, MTZ_Num_Col
         if (tipo_colonne(i) == 'H') then
             k = k + 1
             Lab_ch(k) = Lab_Col(i)
         endif
      enddo
      do i=1, MTZ_Num_Col
         if (tipo_colonne(i) == 'F' .or. tipo_colonne(i) == 'I') then
             nCoefs = nCoefs + 1
             nIt = nIt + 1
             SmallIt(nIt) = Lab_Col(i) // char(0)
             if (nCoefs == 1) then
                 k = k + 1
                 Lab_ch(k) = Lab_Col(i)
             endif
         endif
      enddo
      do i=1, MTZ_Num_Col
         if (tipo_colonne(i) == 'P') then
             nPhases = nPhases + 1
             nIt = nIt + 1
             SmallIt(nIt) = Lab_Col(i) // char(0)
             if (nPhases == 1) then
                 k = k + 1
                 Lab_ch(k) = Lab_Col(i)
             endif
         endif
      enddo
      if (k /= 5) then
          if (nPhases == 0) then
              Msg = 'No phases in MTZ file !!!'
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          endif
          ier = -1
          return
      endif
      nIt = nIt + 1
      SmallIt(nIt) = 'UnWeighted' // char(0)
      nWT = nWT + 1
      do i=1, MTZ_Num_Col
         if (tipo_colonne(i) == 'W') then
             nWT = nWT + 1
             nIt = nIt + 1
             SmallIt(nIt) = Lab_Col(i) // char(0)
             if (nWT == 2) then
                 k = k + 1
                 Lab_ch(k) = Lab_Col(i)
             endif
         endif
      enddo
!
      ifWei = 0
      if(ifAutomatic == 0) then
         call LabelWindow(nCoefs, nPhases, nWT, ifWei, ifDifference)
         if (ifWei < 0) then
             ier = -1
             return
         endif
      endif
!
      call Fill_lookup(Num_Col,Lab_Col,Lab_Ch,MTZlookup)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LabelWindow(nCoefs, nPhases, nWT, ifWei, ifDifference)
      USE General
      USE Dialogo
!
      implicit none
!
      integer nCoefs, nPhases, nWT, n1, n2, L, Lung, ifWei
      integer               :: ifDifference, LabelWindowC, ierr
      character(len = 256)   :: filnam
!
      n1 = nCoefs
      n2 =  n1 + nPhases
      filnam = MTZfile(1:Lung(MTZfile)) // char(0)
      ierr =  LabelWindowC(nCoefs, nPhases, nWT, ifDifference, filnam)
      if (ierr == -1) then    !! Cancel da finestra
         ifWei = -1
         return
      endif
      L = Lung(SmallIt(nCoefs))
      Lab_ch(4) = SmallIt(nCoefs)(1:L)
      n1 = n1 + nPhases
      L = Lung(SmallIt(n1))
      Lab_ch(5) = SmallIt(n1)(1:L)
      if (nWt > 1) then
          n2 = n2 + nWT
          L = Lung(SmallIt(n2))
          Lab_ch(6) = SmallIt(n2)(1:L)
          ifWei = 1
      else
          ifWei = 0
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CalcolaRhomax
      USE General
      USE Riflessi
      USE Mappa
!
      implicit none
      integer i
      real rho, ang(3), a1, a2, a3, s1, s2, s3, arg
      real q, vv,  cosas, cosbs, coscs
!
      ang(1:3) = cell(4:6)
      do i=1,3
         ang(i) = ang(i) * pi / 180.0
      enddo
      a1 = cos(ang(1))
      a2 = cos(ang(2))
      a3 = cos(ang(3))
      s1 = sin(ang(1))
      s2 = sin(ang(2))
      s3 = sin(ang(3))
      arg = 1.0-a1*a1
     1         -a2*a2
     2         -a3*a3
     3         +a1*a2*a3*2.0
      vv = cell(1)*cell(2)*cell(3) * sqrt(arg)
      asta(1) = cell(2)*cell(3)*s1         /vv
      asta(2) = cell(1)*cell(3)*s2         /vv
      asta(3) = cell(1)*cell(2)*s3         /vv
      cosas = (a2*a3-a1)/(s2*s3                 )
      cosbs = (a1*a3-a2)/(s1*s3                 )
      coscs = (a1*a2-a3)/(s1*s2                 )
!
      ihmx(:) = -100
      rhomax = -9999
      do i=1, nrefl
         if (ihmx(1) < iabs(khl(1,i))) ihmx(1) = iabs(khl(1,i))
         if (ihmx(2) < iabs(khl(2,i))) ihmx(2) = iabs(khl(2,i))
         if (ihmx(3) < iabs(khl(3,i))) ihmx(3) = iabs(khl(3,i))
!
         q = khl(1,i)*khl(1,i)*asta(1)*asta(1)
     1     + khl(2,i)*khl(2,i)*asta(2)*asta(2)
     2     + khl(3,i)*khl(3,i)*asta(3)*asta(3)
     3     + 2.0*khl(2,i)*khl(3,i)*asta(2)*asta(3)*cosas
     4     + 2.0*khl(3,i)*khl(1,i)*asta(3)*asta(1)*cosbs
     5     + 2.0*khl(1,i)*khl(2,i)*asta(1)*asta(2)*coscs
         rho=0.25*q
         rhomax=amax1(rhomax, rho)
      enddo
!
      resm = 0.5 / sqrt(rhomax)
      factr = resm / 3.0
!
      if (iprin > 0) then
          write(0,*) 'RHOMAX', rhomax
          write(0,*) 'HMAX', ihmx
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ManageCell(celltemp, ier)
      USE General
!
      implicit none
      integer i, nExitCode, ier
      real celltemp(13)
      real a1, a2, a3, arg, sqrt
!
      if (InfoOK(1) == 0) then
!!    if (InfoOK(1) /= 2) then
          if (celltemp(1) > 0.01) then
              cell(1:6) = celltemp(1:6)
          else
              cell(1:3) = 1.0
              cell(4:6) = 90.0
              celltemp(1:6) = cell(1:6)
          endif
          if (iprin > 0) then
              write(0,*) 'CELL',cell(1:6)
          endif
!
!-- Calcolo matrice ortonormalizzazione
!
          call CreaCellInfo(celltemp) ! (1:6))
!
!-- Calcolo matrice metrica
!
          xgg(1,1) = cell(1)**2
          xgg(2,2) = cell(2)**2
          xgg(3,3) = cell(3)**2
          xgg(1,2) = cell(1) * cell(2) * cos(cell(6) * dtor)
          xgg(1,3) = cell(1) * cell(3) * cos(cell(5) * dtor)
          xgg(2,3) = cell(2) * cell(3) * cos(cell(4) * dtor)
          xgg(3,1) = xgg(1,3)
          xgg(2,1) = xgg(1,2)
          xgg(3,2) = xgg(2,3)
!
!-- Calcolo volume
!
          a1  = cos(cell(4) * pi / 180.0)
          a2  = cos(cell(5) * pi / 180.0)
          a3  = cos(cell(6) * pi / 180.0)
          arg = 1.0 - a1*a1 - a2*a2 - a3*a3 + a1*a2*a3 * 2.0
          volume = cell(1) * cell(2) * cell(3) * sqrt(arg)
*         InfoOK(1) = 2
      elseif (InfoOK(1) == 1) then
          do i=1, 6
             a1 = abs(cell(i)-celltemp(i))
             a2 = a1 / cell(i)
             if (a2 > 0.01) then
                 Msg = 'Previous and actual cell parameters differ. '
     *              // 'File is abandoned.'
                 call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
                 ier = -1
                 exit
             endif
          enddo
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ManageCIF(ier)
      USE General
      USE Symmetry
      USE RemoModule
      USE MolCom, only: rm, rmi
      USE Atomi, only: nats
      USE CIF, only: cif_number, ifCartesian, n_aniso, cif_bij
!
      implicit none
      integer           :: itipo, iform, jop, jopen, ierr, ifRefl, ier
      integer           :: nbonds, i, j, IsoAnisoT, serialT, ifSPG, iprn
      integer           :: n, b_or_u, kshif(3), ishif, Lung,  kspecb
      integer           :: itype, ksp, key(10), iser, iactn, khead
      integer           :: k, nSymCard, n_a, nk_lcase
      real              :: ChemOcc, celltemp(13), x1(3), x2(3), wave
      real              :: xo(11), xn(11), occ
      character(len=16) :: Label
      character(len= 4) :: a4, Species_lcase(18)
!
      call CPUTime0(' ')
      celltemp(:) = 0.0
      itipo = 2
      iform = 1
!
      jop=jopen(jhost, filePDB, itipo, iform, ierr)
      if (jop.lt.0) then
          ier = -1
          return
      endif
!
      if (iprin > 0) then
          write(lo,200) filePDB(1:Lung(filePDB))
      endif
      call FillCifKey()
!
      if (wavel < 0.001) then
          wavel = 1.54178      !  'Cu'
      endif
!
      ifRefl = 0
      nats = 0
      call LeggiCIFinMem(ifSPG, ifRefl, nats, celltemp, iprn, 
     *                   b_or_u, nSymCard, wave, ier)
      wavel = wave
!
      numbModels = numbModels + 1
      WhichModel = WhichModel + 1
      natsInModel(WhichModel) = nats
      MonomerInModel(WhichModel) = 1
      call AllocaModelRemo(1)
!
*     if (sum(celltemp(1:6)) > 50)  then
*         InfoOK(1) = 1
*     endif
      call ManageCell(celltemp, ier)
      if (ier < 0) then
          call ErrorLoadingModel
          return
      endif
!
      if (iprin > 0) then
          write(0,*) 'NSYM',nsym
      endif
!
!
!-- Store symmetry information
!
      if (InfoOK(2) == 0) then
          k = sum(nint(celltemp(1:6)))
          if (ifSPG == 0 .and. nsym == 0 .and. k == 273) then
              Msg = 'p 1           '
              read(Msg,'(16a1)') nSpaceG(1:16)
          elseif (ifSPG == 0) then
              n = InfoOK(1)
              call Get_1_2(n, ier)
              if (ier < 0) then
                  return
              endif
          endif
          call CreaSymmetryInfo(ier)
!gl!      kshif(:) = 0
!gl!      ishif   = 0
!gl!      call insym(ishif,kshif,ier)
          if (ier < 0) then
              return
          endif
          InfoOK(2) = 1
      endif
!
      rewind jgrap
      call xspinb
      xo(:) = 0
      xn(:) = 0
      iactn = 1
      khead = 0
      itype = 0
      do i=1, nats
         read(jgrap) model(WhichModel)%Label(i), a4, 
     *               xo(1:3),
     *               ChemOcc, IsoAnisoT, 
     *               model(WhichModel)%th_fact(i,1), serialT
         iser=i
         ksp = kspecb(newvet, xo, xn, key, itype, iser, khead, iactn)
         occ = 1.0 / float(key(10))
         model(WhichModel)%atoms(1:3,i,1) = xo(1:3)
         model(WhichModel)%atoms(4,i,1)   = 100
         model(WhichModel)%atoms(5,i,1)   = occ * ChemOcc
         model(WhichModel)%HETA(i,1)      = 1
         model(WhichModel)%AtSpecies(i,1) = a4
         do j=1, nk
            if (a4 == Species(j)) then
                model(WhichModel)%specie(i,1) = j
            endif
         enddo
      enddo
!
      do i=1, nats
         if (model(WhichModel)%Label(i)(1:4) == 'Peak') then
             model(WhichModel)%specie(i,1) = 0
         endif
      enddo
!
      close(jhost)
!
      do i=1, nats
          if (ifCartesian == 1) then
              x1(1:3) = model(WhichModel)%atoms(1:3,i,1)
              call MoltMatVec(rmi, x1, x2)
              model(WhichModel)%atoms(1:3,i,1) = x2(1:3)
          endif
      enddo
      do i=1, nats
         x1(1:3) = model(WhichModel)%atoms(1:3,i,1)
         model(WhichModel)%saved(1:3,i,1)= x1(1:3)
         call MoltMatVec(rm, x1, x2)
         model(WhichModel)%ortho(1:3,i,1)= x2(1:3)
      enddo
!
!-- Anisotropic thermal factors
!
      if (n_aniso > 0) then
         do n_a=1, n_aniso
            read(jgrap) Label, cif_bij(1:6)
            j = 0
            do i=1, nats
               if (Label == model(WhichModel)%Label(i)) then
                   j = i
                   exit
               endif
            enddo
            if (j == 0) then
                call CheckAniso(Label, Species_lcase, nk_lcase,
     *                          nats, j, ier)
            endif
            if (ier == -1) then
                exit
            endif
            if (b_or_u == 1) then
                model(WhichModel)%bij(1:6,j,1) = cif_bij(1:6)
            else
                model(WhichModel)%bij(1,j,1)=cif_bij(1)*UijToBij_11
                model(WhichModel)%bij(2,j,1)=cif_bij(6)*UijToBij_12
                model(WhichModel)%bij(3,j,1)=cif_bij(5)*UijToBij_13
                model(WhichModel)%bij(4,j,1)=cif_bij(2)*UijToBij_22
                model(WhichModel)%bij(5,j,1)=cif_bij(4)*UijToBij_23
                model(WhichModel)%bij(6,j,1)=cif_bij(3)*UijToBij_33
            endif
         enddo
      endif
!
      close(jgrap)
!
      n = natsInModel(WhichModel)
      natsAsymm(WhichModel) = n
      model(WhichModel)%PDB = 0
*gl*  nw(1:nk) = cif_number(1:nk) * nsymTot
!
!-- compute the correct cell content taking into account
!-- the sum of occupancies
!
      cif_number(1:nk) = 0
      do i=1, nats
         j = model(WhichModel)%specie(i,1)
         if (j > 0) then
             occ = model(WhichModel)%atoms(5,i,1)
             cif_number(j) = cif_number(j) + occ
         endif
      enddo
      nw(1:nk) = nint( totop * cif_number(1:nk) )
*gl*  nw(1:nk) = nint( nsymTot * cif_number(1:nk) )
      call CreaConn(n, nbonds, 0, ier)

      if (ier < 0) then
          call ErrorLoadingModel
          return
      endif

      nLegProtein = nbonds
      nLegBack = 0
      nLegCalpha = 0
!!mr
      do i= 1, nk
         model(WhichModel)%al(1:4,i)     = al(1:4,i)
         model(WhichModel)%bs(1:4,i)     = bs(1:4,i)
         model(WhichModel)%cl(i)         = cl(i)
         model(WhichModel)%raggio(i,1:2) = radii(i,1:2)
         model(WhichModel)%no(i)         = no(i)
         model(WhichModel)%nw(i)         = nw(i)
         model(WhichModel)%nalf(i)       = nalf(i)
      enddo
      model(WhichModel)%nk = nk
!!mr
      call CPUTime(' ', 0)
      if (iprin > 0) then
          write(lo,600) Inte(1:Lung(Inte))
      endif
!
      return
  200 format(/,' Load model file (CIF format) ',a,/)
  600 format(' Loading model       ', a,/)
      end
!-----------------------------------------------------------------------
      subroutine CheckAniso(Label, Species_lcase, nk_lcase,
     *                      nats, j, ier)
      USE General
      USE RemoModule
!
      implicit none
      integer :: j, ier, i, k, nk_lcase, nats
      character (len= 4) :: a4, Species_lcase(18)
      character (len=16) :: Label
!
      do i=1, nats
         a4 = model(WhichModel)%Label(i)(1:4)
         call lcase(a4)
         do k=1, max0(nk_lcase, nk)
            if (a4 == Species_lcase(k)) then
                j = i
                exit
            endif
         enddo
      enddo
      if (j == 0) then
          ier = -1
          Msg = 'Error in _atom_site_aniso_label' // ' ' // Label
          call MsgWinErr('WARNING', Msg, WARN_WINDOW, i)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ManagePDB(ier)
      USE General
      USE Symmetry
      USE RemoModule
      USE MolCom, only: rm, rmi
      USE Atomi, only: nats
      USE spginfom
!
      implicit none
      integer           :: i, j, i1, i2, ifAll, ifHOH, ifHET, ifBack
      integer           :: Lung, ier, n, n1, n2, nSecondary 
      integer           :: itipo, iform, jop, jopen, ierr, nzS
      integer           :: OldRes, numeroCatene, nSpec, nbonds
      integer           :: nHelix, nSheet
      real              :: celltemp(13), uij(6), x1(3), x2(3)
      character(len=16) :: LabelS
!
      real              :: xyzsS1, xyzsS2, xyzsS3, xyzsS4, xyzsS5,bfacS6
      character (len=4) :: tipoAt
      character (len=3) :: tipoRe
      character (len=1) :: OldCat
      character (len=1) :: Alternate, Catena, Secondary
!
      call CPUTime0(' ')
      celltemp(:) = 0.0
      itipo = 2
      iform = 1
!
      jop=jopen(jhost, filePDB, itipo, iform, ierr)
      if (jop.lt.0) then
          ier = -1
          return
      endif
      if (iprin > 0) then
          write(lo,200) filePDB(1:Lung(filePDB))
      endif
!
      if (wavel < 0.001) then
          wavel = 1.54178      !  'Cu'
      endif
!
      nHelix = 0
      nSheet = 0
      ifAll  = 1
      ifHOH  = 1
      ifHET  = 1
      ifBack = 0
      nats   = 0
      call LeggiPDBinMem(ifAll, ifHOH, ifHET, ifBack, ifCutResidui,
     *                   celltemp, nats, nSpec, nSecondary, ier)
      nk = nSpec
      Species(1:18) = vSpecie(1:18)
      nw(1:18) = nSpecie(1:18) * nsymTot
      numbModels = numbModels + 1
      WhichModel = WhichModel + 1
      natsInModel(WhichModel) = nats
      MonomerInModel(WhichModel) = 1
      call AllocaModelRemo(1)
!
      call ManageCell(celltemp, ier)
      if (ier < 0) then
          call ErrorLoadingModel
          return
      endif
!
      if (InfoOK(2) == 0) then
          write(Inte,'(a)') 'p 1'
          read(Inte(1:16),'(16a1)') nSpaceG
          call CreaSymmetryInfo(ier)
      endif
!
      write(cardDiret,'(16a1)') nSpaceG
      spacegr = init_spaceg_type(cardDiret)
!
      if (iprin > 0) then
          write(0,*) 'NSYM',nsym
      endif
!
      rewind jgrap
      model(WhichModel)%Secondary(:,1) = ' '
      numeroResidui = 0
      numeroCatene = 0
      nLegBack = 0
      OldRes = 0
      OldCat = ' '
      do i=1, nats
        read(jgrap) model(WhichModel)%ortho(1:3,i,1),
     *              model(WhichModel)%atoms(4:5,i,1),
     *              nzS,
     *              model(WhichModel)%th_fact(i,1),
     *              model(WhichModel)%tipoAtomo(i,1),
     *              model(WhichModel)%Alternate(i,1),
     *              model(WhichModel)%tipoResiduo(i,1),
     *              model(WhichModel)%catena(i,1),
     *              model(WhichModel)%numResiduo(i,1),
     *              model(WhichModel)%Insertion(i,1),
     *              model(WhichModel)%Label(i),    ! catena, num. residuo, label
     *              uij(1:6),
     *              model(WhichModel)%HETA(i,1),
     *              model(WhichModel)%AtSpecies(i,1)
         model(WhichModel)%specie(i,1) = nzS
         if (model(WhichModel)%numResiduo(i,1) /= OldRes) then
             numeroResidui = numeroResidui + 1
             oldRes = model(WhichModel)%numResiduo(i,1)
         endif
         if (model(WhichModel)%catena(i,1) /= OldCat) then
             numeroCatene = numeroCatene + 1
             oldCat = model(WhichModel)%catena(i,1)
         endif
         if (uij(1) > 0.0) then
             uij(1:6) = uij(1:6) * 0.0001
             model(WhichModel)%bij(1,i,1) = UijToBij_11 * uij(1)
             model(WhichModel)%bij(2,i,1) = UijToBij_12 * uij(4)
             model(WhichModel)%bij(3,i,1) = UijToBij_13 * uij(5)
             model(WhichModel)%bij(4,i,1) = UijToBij_22 * uij(2)
             model(WhichModel)%bij(5,i,1) = UijToBij_23 * uij(6)
             model(WhichModel)%bij(6,i,1) = UijToBij_33 * uij(3)
         endif
!gl!     model(WhichModel)%Secondary(i,1) = ' '
      enddo
!
      if (nSecondary > 0) then
          do j=1, nSecondary
             read(jgrap) itipo, n1, i1, n2, i2
             if (iprin > 0)
     *       write(lo,*) char(itipo), char(i1), n1, char(i2), n2
             Secondary = char(itipo)
             if (char(i1) == ' ') then
                 oldCat = 'A'
             else
                 oldCat = char(i1)
             endif
             if (char(i2) == ' ') then
                 Catena = 'A'
             else
                 Catena = char(i2)
             endif
             do i=1, nats
                if (model(WhichModel)%catena(i,1) /= Catena) cycle
                if (model(WhichModel)%numResiduo(i,1) >= n1 .and.
     *              model(WhichModel)%numResiduo(i,1) <= n2) then
                    model(WhichModel)%Secondary(i,1) = Secondary
                endif
             enddo
          enddo
      endif
!
      close(jgrap)
      close(jhost)
!
      do i=1, nats
         x1(1:3) = model(WhichModel)%ortho(1:3,i,1)
         call MoltMatVec(rmi, x1, x2)
         model(WhichModel)%atoms(1:3,i,1)= x2(1:3)
         model(WhichModel)%saved(1:3,i,1)= x2(1:3)
         if (model(WhichModel)%tipoResiduo(i,1) == '    ') then
             model(WhichModel)%Secondary(i,1) = 'W'
         endif
!corr         write(70,*)trim(model(WhichModel)%Label(i))
      enddo
!
      if (numeroCatene == 0) then
          numeroCatene = 1
      endif
      if (iprin > 0) then
          write(0,*) 'RESIDUI', numeroResidui
          write(0,*) 'CATENE', numeroCatene
      endif
      n = natsInModel(WhichModel)
!
      nbonds = 0
      natsAsymm(WhichModel) = natsInModel(WhichModel)
      if (n > 1) then
          if (ifProtein == 0) then
              nLegBack = 0
          else
              nLegBack = numeroResidui * 3
          endif
*         call CPUTime0(' ')
              nLegBack = 0 !!mr150412
          call CreaConn(n, nbonds, 1, ier)

          if (ier < 0) then
              call ErrorLoadingModel
              return
          endif

*         call CPUTime(' ', 0)
*         write(0,"(' CreaConn ',a)") Inte(1:Lung(Inte))
!
!-- connectivity for backbone, CA-chain and Ligand
!
!!!mr150412          call CreaConnBackCA()
      endif
!
      legAsymm(WhichModel,2) = nLegBack
      legAsymm(WhichModel,3) = nLegLigand
      legAsymm(WhichModel,4) = nLegCalpha
*     write(lo,*)  'legAsymm',legAsymm(WhichModel,:)
*         do i=1, nLegBack+nLegCalpha+nLegLigand+nlegProtein
*            write(lo,'(i5,1h),2i6)') i,  Bonds(WhichModel)%Legami(1,i),
*    *                                    Bonds(WhichModel)%Legami(2,i)
*         enddo
      if (ifProtein > 0) then
          model(WhichModel)%PDB = 1
      endif
!
!-- define the secondary structure
!
      if (nSecondary == 0) then
!!mr          call xtlsstr(ier)
!!mr          if (ier < 0) then
              model(WhichModel)%Secondary(:,1) = ' '
!!mr              ier = 0
!!mr          else
!!mr              nSecondary = 1
!!mr          endif
      endif
      if (nSecondary > 0) then
          Secondary = ' '
          do i=1, nats
             Alternate = model(WhichModel)%Secondary(i,1)
             if (iprin > 0)
     *       write(lo,*) Alternate,' ',
     *                          model(WhichModel)%numResiduo(i,1),
     *                          model(WhichModel)%catena(i,1)
             if (Alternate /= Secondary) then
                 if (Alternate == 'H') then
                     nHelix = nHelix + 1
                     if (iprin > 0)
     *               write(lo,*) nHelix, Alternate,
     *                          model(WhichModel)%numResiduo(i,1),
     *                          model(WhichModel)%catena(i,1)
                 elseif (Alternate == 'E') then
                     nSheet = nSheet + 1
                     if (iprin > 0)
     *               write(lo,*) nSheet, Alternate,
     *                          model(WhichModel)%numResiduo(i,1),
     *                          model(WhichModel)%catena(i,1)
                 elseif (Alternate == ' ') then
                     if (iprin > 0)
     *               write(lo,*) nSheet, Alternate,
     *                          model(WhichModel)%numResiduo(i-1,1),
     *                          model(WhichModel)%catena(i,1)
                 endif
                 Secondary = Alternate
             endif
          enddo
      endif
      if (iprin > 0) then
          if (nHelix > 0) then
              if (nHelix > 1) then
                  write(lo,300) nHelix
              else
                  write(lo,301) nHelix
              endif
          endif
          if (nSheet > 0) then
              if (nSheet > 1) then
                  write(lo,310) nSheet
              else
                  write(lo,311) nSheet
              endif
          endif
      endif
!
      do i= 1, nk
         model(WhichModel)%al(1:4,i)     = al(1:4,i)
         model(WhichModel)%bs(1:4,i)     = bs(1:4,i)
         model(WhichModel)%cl(i)         = cl(i)
         model(WhichModel)%raggio(i,1:2) = radii(i,1:2)
         model(WhichModel)%no(i)         = no(i)
         model(WhichModel)%nw(i)         = nw(i)
         model(WhichModel)%nalf(i)       = nalf(i)
      enddo
      model(WhichModel)%nk = nk

      call CPUTime(' ', 0)
      if (iprin > 0) then
          write(lo,600) Inte(1:Lung(Inte))
      endif
!
      return
  200 format(/,' Load model file (PDB format) ',a,/)
  300 format(' -',i7,' Helices')
  301 format(' -',i7,' Helix')
  310 format(' -',i7,' Sheets')
  311 format(' -',i7,' Sheet')
  600 format(' Loading model       ', a,/)
      end
!-----------------------------------------------------------------------
      subroutine ManageSHELX(ier)
      USE General
      USE Symmetry
      USE RemoModule
      USE MolCom, only: rm, rmi
      USE Atomi, only: nats
!
      implicit none
      integer :: i, ier
      integer :: itipo, iform, jop, jopen, ierr, nzS, nbonds
      integer :: nsymTemp, lattTemp, icentTemp, found
      integer :: ifRefl, n, Lung, b1
      real    :: celltemp(13), x1(3), x2(3), wave
      real    :: uij(6), b(6)
      character (len=1) :: blank1
!
      integer :: janomal, jscfact, nscfact
      real    :: anomal, scfact, fnum, Csfac, Asfac
      common /shelx/ anomal(2,20),janomal(20),scfact(14,20),jscfact(20),
     *               nscfact(20), fnum(50), Csfac, Asfac
!
      call CPUTime0(' ')
      celltemp(:) = 0.0
      itipo = 2
      iform = 1
!
      jop=jopen(jhost, filePDB, itipo, iform, ierr)
      if (jop.lt.0) then
          ier = -1
          return
      endif
      if (iprin > 0) then
          write(lo,200) filePDB(1:Lung(filePDB))
      endif
!
      nats   = 0
      call LeggiShelxinMem(ifRefl, celltemp, nsymTemp, lattTemp,
     *                           icentTemp, nats, wave, ier)
!
      wavel = wave
      numbModels = numbModels + 1
      WhichModel = WhichModel + 1
      natsInModel(WhichModel) = nats
      MonomerInModel(WhichModel) = 1
      call AllocaModelRemo(1)
!
      call ManageCell(celltemp, ier)
      if (ier < 0) then
          call ErrorLoadingModel
          return
      endif
!
      if (InfoOK(2) == 0) then
          blank1 = ' '
          read(blank1,'(a1)') b1
          nSpaceG(1:16) = b1
          nsym  = nsymTemp
          latt  = lattTemp
          icent = icentTemp

          if (latt == 1) then
              pts = 1
          elseif (latt == 2) then
              pts = 2
          elseif (latt == 3) then
              pts = 2
          elseif (latt == 4) then
              pts = 2
          elseif (latt == 5) then
              pts = 2
          elseif (latt == 6) then
              pts = 4
          elseif (latt == 7) then
              pts = 3
          endif
          ncentr = pts
          call ManageSymmCards(ier)
          call FromSymmCardsToSpaceGroupSymbol(found)
          call InitOper
      endif
      if (ier < 0) return
!
      if (iprin > 0) then
          write(0,*) 'NSYM',nsym
      endif
!
      call SoloCaratteriAlpha(Species, 18)
!
      rewind jgrap
      do i=1, nats
         read(jgrap) nzS,
     *               model(WhichModel)%Label(i),
     *               model(WhichModel)%atoms(1:3,i,1),
     *               model(WhichModel)%atoms(5,i,1),
     *               model(WhichModel)%th_fact(i,1),
     *               uij(1:6),
     *               model(WhichModel)%AtSpecies(i,1)

         model(WhichModel)%atoms(4,i,1) = 100
         model(WhichModel)%specie(i,1)  = nzS
         model(WhichModel)%HETA(i,1)    = 1
         b(1) = UijToBij_11 * uij(1)
         b(4) = UijToBij_22 * uij(2)
         b(6) = UijToBij_33 * uij(3)
         b(5) = UijToBij_23 * uij(4)
         b(3) = UijToBij_13 * uij(5)
         b(2) = UijToBij_12 * uij(6)
         model(WhichModel)%bij(1:6,i,1) = b(1:6)
         if (uij(1) > 0.0) then
             model(WhichModel)%th_fact(i,1) = b(1) * BijToBiso(1) +
     *                                        b(2) * BijToBiso(2) +
     *                                        b(3) * BijToBiso(3) +
     *                                        b(4) * BijToBiso(4) +
     *                                        b(5) * BijToBiso(5) +
     *                                        b(6) * BijToBiso(6)
         endif
      enddo
!
      close(jgrap)
      close(jhost)
!
      do i=1, nats
         x1(1:3) = model(WhichModel)%atoms(1:3,i,1)
         model(WhichModel)%saved(1:3,i,1)= x1(1:3)
         call MoltMatVec(rm, x1, x2)
         model(WhichModel)%ortho(1:3,i,1)= x2(1:3)
      enddo
!
      n = natsInModel(WhichModel)
      natsAsymm(WhichModel) = n
      model(WhichModel)%PDB = 0
      nw(1:nk) = nint(fnum(1:nk))
      call CreaConn(n, nbonds, 0, ier)

      if (ier < 0) then
          call ErrorLoadingModel
          return
      endif

      nLegProtein = nbonds
      nLegBack = 0
      nLegCalpha = 0
      nLegLigand  = 0
!!mr
      do i= 1, nk
         model(WhichModel)%al(1:4,i)     = al(1:4,i)
         model(WhichModel)%bs(1:4,i)     = bs(1:4,i)
         model(WhichModel)%cl(i)         = cl(i)
         model(WhichModel)%raggio(i,1:2) = radii(i,1:2)
         model(WhichModel)%no(i)         = no(i)
         model(WhichModel)%nw(i)         = nw(i)
         model(WhichModel)%nalf(i)       = nalf(i)
      enddo
      model(WhichModel)%nk = nk
!!mr
!
      call CPUTime(' ', 0)
      if (iprin > 0) then
          write(lo,600) Inte(1:Lung(Inte))
      endif
!
      return
  200 format(/,' Load model file (SHELX format) ',a,/)
  600 format(' Loading model       ', a,/)
      end
!-----------------------------------------------------------------------
      subroutine SoloCaratteriAlpha(vettoreStringhe, n)
      USE General, only: Buffer1
!
      implicit none
      integer i, j, n, L, Lung, ichar, ic
      character (len=1) carattere
      character (len=*) vettoreStringhe(*)
!
      do i=1, n
         Buffer1 = vettoreStringhe(i)
         call lcase(Buffer1)
         L = Lung(Buffer1)
         if (L > 0) then
             do j=1, L
                carattere = Buffer1(j:j)
                ic = ichar(carattere)
                if (ic < 97 .or. ic > 122) then
                    Buffer1(j:j) = ' '
                endif
             enddo
             call NoBlanks(Buffer1, L)
             vettoreStringhe(i) = Buffer1(1:L)
         endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CreaConn(nats, nbonds, ifPDB, ier)
      USE General 
      USE Atomi , only: MaxBonds
      USE RemoModule
      USE connect_mod
      USE molpnew
      USE progtype
      USE javinterface
      USE variables, only:ortom
      USE Molcom, only: rm
      USE unit_cell
!
      implicit none
!
      type(bond_type), dimension(:), allocatable :: legame
      integer                                    :: i, j, k, nbonds, n
      integer                                    :: i1,i2, ier, nats
      integer                                    :: ifPDB, nAtoms
      integer                                    :: puntatore(18)
      integer                                    :: raggruppa, nExitCode
      logical                                    :: opt_m
      real                                       :: dist, dmin, dmax, di
      type(atom_type), dimension(:), allocatable :: atom
!
      call LeggiXEN(1, puntatore, ier)
      if (ier < 0) then
          write(Msg,10) Species(1:nk)
          call MsgWinErr('WARNING', Msg, ERR_WINDOW, nExitCode)
          return
      endif
      call GetFromAtmStruct
      call SincronizzaSpecie(puntatore)
!
      Allocate(atom(1:nats))
      call fromModelToAtom(atom)
!
!     crea la connettività
      ortom(:,:) = rm(:,:)     !!!ortomatrix(cell)
      
      if (nats < 500 .and. ifPDB == 0) then
          call create_connectivity(atom,legame,set_cell_type(cell),
     *         check=.true., move=.true., kpr=iprin)
          call fromAtomToModel(atom)
      else
          call create_connectivity(atom,legame,set_cell_type(cell),
     *          check=.false., move=.false., kpr=iprin)
      endif
!
      nbonds = numbonds(legame)
      MaxBonds = nbonds
      if (nbonds == 0) then
          MaxBonds = natsInModel(WhichModel) * 3.0
*         BondsInModel(WhichModel) = natsInModel(WhichModel) * 2
      endif
      if (ifProtein == 1) then
          MaxBonds = 3.0 * MaxBonds
*         BondsInModel(WhichModel) = 2 * BondsInModel(WhichModel)
      endif
      BondsInModel(WhichModel) = MaxBonds
      call AllocaBonds(1)
      do i=1, nbonds
         i1 = legame(i)%n1    ! primo atomo del legame
         i2 = legame(i)%n2    ! secondo atomo del legame
         di = legame(i)%dist  ! distanza
         Bonds(WhichModel)%Legami(1,i) = i1
         Bonds(WhichModel)%Legami(2,i) = i2
         Bonds(WhichModel)%Legami(4,i) = di
      enddo
!
      nLegProtein = nbonds
      legAsymm(WhichModel,1) = nLegProtein
      legAsymm(WhichModel,2) = 0
      legAsymm(WhichModel,3) = 0
      legAsymm(WhichModel,4) = 0
!
      return
   10 format('Error in atom species: ',18(a4,2x))
      end
!-----------------------------------------------------------------------
      subroutine CreaConnBackCA()
      USE General 
      USE RemoModule
      USE javinterface
!
      implicit none
!
      integer              :: i,j,k,n, nn,iOk, i1, i2, ier, nAtoms, ierr
      real                 :: di
      character (len=4)    :: backbone(4), a4
      character (len=3)    :: residui(20), resi
      integer, allocatable :: ifBackbone(:)
!
      if (ifProtein == 0) then
          return
      endif
!
      residui( 1: 5) = (/ 'ala','arg','val','tyr','trp' /)
      residui( 6:10) = (/ 'thr','ser','pro','phe','met' /)
      residui(11:15) = (/ 'lys','leu','ile','his','gly' /)
      residui(16:20) = (/ 'glu','gln','cys','asp','asn'/)
      backbone(1) = 'ca  '
      backbone(2) = 'n   '
      backbone(3) = 'c   '
!??!  backbone(4) = 'co  '
      backbone(4) = 'o   '
!
      nAtoms = natsInModel(WhichModel)
      allocate(ifBackbone(1:nAtoms), stat = ierr)
      ifBackbone(:) = 0
      do i=1, nAtoms
         k =   InfoOnModels(WhichModel)%iEqui(i)
!mr         a4 = model(WhichModel)%tipoAtomo(k,1)
!mr         call lcase(a4)
!mr         do j=1, 4
!mr            if (a4 == backbone(j)) then
!mr                ifBackBone(i) = j
!mr                exit
!mr            endif
!mr         enddo
!-- ligands
         if (ifBackBone(i) == 0) then
             resi =  model(WhichModel)%tipoResiduo(k,1)(1:3)
             call lcase(resi)
             iOk = 0
             do j=1, 20
                if (resi == residui(j)) then
                    iOk = 1
                    exit
                endif
             enddo
             if (iOk == 0) then
                  ifBackBone(i) = -1
!mrmr
             else
                  a4 = model(WhichModel)%tipoAtomo(k,1)
                  call lcase(a4)
                  do j=1, 4
                     if (a4 == backbone(j)) then
                         ifBackBone(i) = j
                         exit
                     endif
                  enddo
!mrmr
             endif
         endif
      enddo
!
!-- connectivity for backbone
!
      n = nLegProtein
      if (iprin > 0) then
          write(0,*) 'LEGAMI NELLA PROTEINA ', nLegProtein
      endif
      nn = n
      if (n > 0) then
          do i=1, n
             i1 = Bonds(WhichModel)%Legami(1,i)
             i2 = Bonds(WhichModel)%Legami(2,i)
             di = Bonds(WhichModel)%Legami(4,i)
             if (ifBackBone(i1) > 0 .and. ifBackBone(i2) > 0) then
                 nn = nn + 1
                 Bonds(WhichModel)%Legami(1,nn) = i1
                 Bonds(WhichModel)%Legami(2,nn) = i2
                 Bonds(WhichModel)%Legami(4,nn) = di
             endif
          enddo
      endif
      nLegBack = nn - nLegProtein
      if (iprin > 0) then
          write(0,*) 'LEGAMI NEL BACKBONE ', nLegBack
      endif
!
!-- connectivity for ligand
!
      n = nLegProtein 
      if (n > 0) then
          if (iprin > 0) then
              write(0,*) 'LEGAMI NELLA PROTEINA ', nLegProtein
          endif

          nn = n + nLegBack
          do i=1, n
             i1 = Bonds(WhichModel)%Legami(1,i)
             i2 = Bonds(WhichModel)%Legami(2,i)
             di = Bonds(WhichModel)%Legami(4,i)
             if (ifBackBone(i1) < 0 .and. ifBackBone(i2) < 0) then
                 nn = nn + 1
                 Bonds(WhichModel)%Legami(1,nn) = i1
                 Bonds(WhichModel)%Legami(2,nn) = i2
                 Bonds(WhichModel)%Legami(4,nn) = di
             endif
          enddo
      endif
      nLegLigand = nn - nLegProtein - nLegBack
      if (iprin > 0) then
          write(0,*) 'LEGAMI NEL LIGANDO ', nLegLigand
      endif
!
!-- connectivity for c-alpha
!
      i = nn
      call CreaConnCA(nn, ifBackbone)
      nLegCalpha = nn - nLegProtein - nLegBack - nLegLigand
      if (iprin > 0) then
          write(0,*) 'LEGAMI NELLA C-ALPHA ', nn-i
      endif
!
      deallocate(ifBackbone, stat = ierr)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CreaConnCA(nbonds, ifBackBone)
      USE General 
      USE RemoModule
      USE javinterface
!
      implicit none
!
      integer            :: i, j, k, l, ier, nats, nA, cicla, sizeLeg
      integer            :: ki, kj, nbonds, ca1, ca2, ifBackBone(*)
      real               :: dist, dmin, dmax
!
      dmin = 3.0
      dmax = 4.3
!
      ca2 = 0
      k = 1
      nats = natsAsymm(WhichModel)
      cicla = 1
      do while (cicla == 1)
         loop: do i=k, nats-1
            if (ifBackbone(i) /= 1) cycle
            ki = InfoOnModels(WhichModel)%iEqui(i)
            ca1 = i
            cicla = 0
            do j=i+1, nats
               if (ifBackbone(j) /= 1) cycle
               cicla = 1
               kj = InfoOnModels(WhichModel)%iEqui(j)
               ca2 = j
               dist = 0.0
               do l=1,3
                  dist = dist +
     *                   (model(WhichModel)%ortho(l,i,1) 
     *                  - model(WhichModel)%ortho(l,j,1)) ** 2
               end do
               dist = sqrt(dist)
               if (dist > dmin .and. dist < dmax) then
                   nbonds = nbonds + 1
                   Bonds(WhichModel)%Legami(1,nbonds) = i
                   Bonds(WhichModel)%Legami(2,nbonds) = j
                   if (iprin > 0) then
                       write(0,*)i,j,nbonds,
     *                           model(WhichModel)%tipoAtomo(ki,1),
     *                           model(WhichModel)%tipoAtomo(kj,1),
     *                           model(WhichModel)%Label(ki),
     *                           model(WhichModel)%Label(kj)
                   endif
               endif
               exit loop
            enddo
         enddo loop
         if (ca2 == 0 .or. ca2 >= nats) then
             cicla = 0
         endif
         if (cicla == 1) then
             k = ca2
         endif
      enddo

      go to 1

      do i=1, nats-1
         if (ifBackbone(i) /= 1) cycle
         ki = InfoOnModels(WhichModel)%iEqui(i)
         do j=i+1, nats
            if (ifBackbone(j) /= 1) cycle
            kj = InfoOnModels(WhichModel)%iEqui(j)
            dist = 0.0
            do k=1,3
               dist = dist +
     *                (model(WhichModel)%ortho(k,i,1) 
     *               - model(WhichModel)%ortho(k,j,1)) ** 2
            end do
            dist = sqrt(dist)
            if (dist > dmin .and. dist < dmax) then
                nbonds = nbonds + 1
                Bonds(WhichModel)%Legami(1,nbonds) = i
                Bonds(WhichModel)%Legami(2,nbonds) = j
                if (iprin > 0) then
                    write(0,*)i,j,nbonds,  
     *                        model(WhichModel)%tipoAtomo(ki,1),
     *                        model(WhichModel)%tipoAtomo(kj,1),
     *                        model(WhichModel)%Label(ki),
     *                        model(WhichModel)%Label(kj)
                endif
            endif
         enddo
      enddo

    1 continue
!
      nA = natsAsymm(WhichModel)
      nats = natsInModel(WhichModel)
      sizeLeg = size(Bonds(WhichModel)%Legami) / 3
      if (nats > nA) then
          do i=nA + 1, nats-1
             if (ifBackbone(i) /= 1) cycle
             ki = InfoOnModels(WhichModel)%iEqui(i)
             do j=i+1, nats
                if (ifBackbone(j) /= 1) cycle
                kj = InfoOnModels(WhichModel)%iEqui(j)
                dist = 0.0
                do k=1,3
                   dist = dist +
     *                    (model(WhichModel)%ortho(k,i,1)
     *                   - model(WhichModel)%ortho(k,j,1)) ** 2
                end do
                dist = sqrt(dist)
                if (dist > dmin .and. dist < dmax) then
                    if (nbonds < sizeLeg) then
                        nbonds = nbonds + 1
                        Bonds(WhichModel)%Legami(1,nbonds) = i
                        Bonds(WhichModel)%Legami(2,nbonds) = j
                        if (iprin > 0) then
                            write(0,*)i,j,nbonds,
     *                                model(WhichModel)%tipoAtomo(ki,1),
     *                                model(WhichModel)%tipoAtomo(kj,1),
     *                                model(WhichModel)%Label(ki),
     *                                model(WhichModel)%Label(kj)
                        endif
                    endif
                endif
             enddo
          enddo
      endif

!
      return
      end
!-----------------------------------------------------------------------
      subroutine LeggiMappa(tipo, ier)
      USE General
      USE Symmetry
      USE Mappa
      USE MappaAutre
!
      implicit none
      real               :: cellOut(6), celltemp(13)
      integer            :: nspace, npOut(3), k, ishif, kshif(3)
      integer            :: tipo, iAction, ipo, ier, ierr, Lung
      integer            :: ifail, iprintCCP4
      character (len=16) :: SpaceSav
!
      celltemp(:) = 0.0
      if (iprin > 0) then
          write(lo,200) FichierIn(1:Lung(FichierIn))
      endif
      np(:) = 1
      ifail = 1
      iprintCCP4 = 0
      call CCP4MAPIN(FichierIn, np, npOut, cellOut, nspace, 
     *               ifail, iprintCCP4, ier)
      if (ier < 0) then
          ier = -1
          return
      endif
      np(1:3) = npOut(1:3)
      cell(1:6) = cellOut(1:6)
      celltemp(1:6) = cellOut(1:6)
!      
      call CPUTime0(' ')
      if (iprin > 0) then
          write(0,*) 'NP',np
          write(0,*) 'CELL',cell(1:6)
          write(0,*) 'SpGr',nspace
      endif
!
      write(cardDiret,'(i5)') nspace
      call shift(cardDiret,k)
      read(cardDiret,'(16a1)') nSpaceG
      call CreaSymmetryInfo(ier)
*     call CheckSpaceGroupSymbol(nSpaceG,ier)
*     if (ier.ge.0) then
*         write(SpaceSav,'(16a1)') nSpaceG
*         ishif = 0
*         kshif(:) = 0
*         call insym(ishif,kshif,ier)
*     else
      if (ier < 0) then
          ier = -1
          write(0,*) 'ERRORE'
          return
      endif
!
      iAction = 1
      call AllocaMappaJav(iAction)
      xmap(:,:,:) = xmapAutre(:,:,:)
      call AllocaMappaAutre(2)
      if (iprin > 0) then
          write(0,*) 'NSYM', nsym
          write(0,*) 'VOLUME',volume
      endif
!
!-- Calcolo matrice ortonormalizzazione
!
      call CreaCellInfo(celltemp) ! (1:6))
!
      call CPUTime(' ', 0)
      if (iprin > 0) then
          write(lo,600) Inte(1:Lung(Inte))
      endif
!
      return
  200 format(/,' Load map file (CCP4 format) ',a,/)
  600 format(' Loading map         ', a,/)
      end
!-----------------------------------------------------------------------
      integer function ifXtal()
      USE General
!
      implicit none
      integer            :: ier, np(3), npOut(3), nspace
      integer            :: ifail, iprintCCP4
      real               :: cellOut(6)
!
      ifail = 1
      iprintCCP4 = -1
      call CCP4MAPIN(MTZfile, np, npOut, cellOut, nspace,
     *               ifail, iprintCCP4, ier)
      if (ier < 0) then
          ifXtal = 1
      else
          ifXtal = 0
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine  LeggiMappaXtal(tipo, ier)
      USE General
      USE Mappa
      USE MappaAutre
!
      implicit none
!
      integer            :: tipo, ier
      integer            :: titoloXtal(20), paramXtal(6), nsymXtal
      integer            :: specs, iostat, nrow, ncol, npla 
      integer            :: itipo, iform, jop, jopen, ierr
      integer            :: i, j, notUsed(3), NORN, nr, iAction
      real               :: celltemp(13), a
      integer, allocatable :: mapRow(:)
!
      call CPUTime0(' ')
      celltemp(:) = 0.0
      itipo = 0
      iform = 2
!
      jop=jopen(jgrap,MTZfile,itipo,iform,ierr)
      if (jop.lt.0) then
          ier = -1
          return
      endif
      read(jgrap, err=10) titoloXtal, paramXtal, nsymXtal, specs
*     read(jgrap, err=10) (prova(i), i=1,28)
      read(jgrap, err=10) np, notUsed(1), NORN, notUsed(2:3)
      write(6,*) 'nsymXtal,specs, np, NORN'
      write(6,*)  nsymXtal,specs, np, NORN 
      if (InfoOK(1) == 0 .or. InfoOK(2) == 0) then
          nr = InfoOK(1)
          call Get_1_2(nr, ier)
          celltemp(1:6) = cell(1:6)
          errcell(:) = 0
          call CreaCellInfo(celltemp) ! (1:6))
          if (InfoOK(2) == 0) then
              call CreaSymmetryInfo(ier)
          endif
      endif
      npAutre(1:3) = np(1:3)
      call AllocaMappaAutre(2)
      call AllocaMappaAutre(1)
      nrow = np(1)
      ncol = np(2)
      npla = np(3)
      allocate (mapRow(0:nrow-1), stat = ierr)
      a = volume
      do i=0, npla-1
         do j=0, ncol-1
            read(jgrap,iostat=ier,err=10) mapRow(0:nrow-1)
            xmapAutre(0:nrow-1, j, i) = float(mapRow(0:nrow-1)) * volume
         enddo
      enddo
      close(jgrap)
      deallocate (mapRow)
!
      iAction = 1
      call AllocaMappaJav(iAction)
      xmap(:,:,:) = xmapAutre(:,:,:)
      call AllocaMappaAutre(2)
!
      return
   10 continue
      ier = -1
      close(jgrap)
      return
      end
!-----------------------------------------------------------------------
      subroutine LeggiMappaXYZ(tipo, ier)
      USE General
      USE Symmetry
      USE Mappa
!
      implicit none
!
      integer            :: tipo, itipo, iform, jop, jopen, ier, ierr
      integer            :: i, ishif, kshif(3), npT(3), iAction, nLines
      integer            :: Lung, jump, ivet(40), iopt, iv, nchar, ifNP
      real               :: xPt(3), val, celltemp(13), vet(40)
      character (len=16) :: SpaceSav
!
      call CPUTime0(' ')
      celltemp(:) = 0.0
      itipo = 2
      iform = 1
!
      jop=jopen(jgrap,MTZfile,itipo,iform,ierr)
      if (jop.lt.0) then
          ier = -1
          return
      endif
!
      np(:) = -9999
      ifNP = 0
      if (iprin > 0) then
          write(lo,200) MTZfile(1:Lung(MTZfile))
      endif
      jump = 0
      Inte = 'p 1' 
      read(Inte,'(a16)') SpaceSav
!
      read(jgrap,'(a)',err=10) cardImage
      call shift(cardImage,nchar)
      iopt = 0
      call getnum(cardImage,vet,ivet,iv,iopt)
      if (iv >= 6) then
          celltemp(1:6) = vet(1:6) 
          val =sum(abs(celltemp(1:3)))
          if (val > 3) then
              val =sum(abs(celltemp(4:6)))
              if (val > 150) then
                  if (iv == 9) then
                      np(1) = ivet(7) - 1
                      np(2) = ivet(8) - 1
                      np(3) = ivet(9) - 1
                      ifNP = 1
                  endif
                  jump = 2
                  read(jgrap,'(a16)') SpaceSav
              endif
          endif
      endif
!
   10 if (jump == 0) then
          celltemp(1:6) = (/ 10, 10, 10, 90, 90, 90 /)
          rewind jgrap
      endif
*     InfoOK(1) = 1
      call ManageCell(celltemp, ier)
      
      if (ier < 0) then
          close(jgrap)
          return
      endif
      call lcase(SpaceSav)
      read(SpaceSav,'(16a1)') nSpaceG
      ishif = 0
      kshif(:) = 0
      call insym(ishif,kshif,ier)
      if (ier < 0) then
          close(jgrap)
          return
      endif
      if (jump == 0) then
          rewind jgrap
      endif
      nLines = 0
      do 
*        read(jgrap,*,end=10) npT(1:3), val
         read(jgrap,*,end=20,err=30) xpT(1:3), val
         nLines = nLines + 1
         if (ifNP == 0) then
             npT(1:3) = nint(xPt(1:3))
             do i=1, 3
                if (npT(i) > np(i)) then
                    np(i) = npT(i)
                endif
             enddo
         endif
      enddo
   20 np(:) = np(:) + 1
!
      iAction = 1
      call AllocaMappaJav(iAction)
!
      rewind jgrap
      if (jump == 2) then
          read(jgrap,'(a)') cardImage
          read(jgrap,'(a)') cardImage
      endif
      do i=1, nLines
*        read(jgrap,*) npT(1:3), val
         read(jgrap,*) xPt(1:3), val
         npT(1:3) = nint(xPt(1:3))
         xmap(npT(1), npT(2), npT(3)) = val
      enddo
      close(jgrap)
!
      if (iprin > 0) then
          write(0,*) 'NP',np
          write(0,*) 'CELL',cell(1:6)
          write(0,*) 'SpGr',SpaceSav
      endif
!
      call CheckSpaceGroupSymbol(nSpaceG,ier)
      if (ier.ge.0) then
          write(SpaceSav,'(16a1)') nSpaceG
          ishif = 0
          kshif(:) = 0
          call insym(ishif,kshif,ier)
      else
          ier = -1
          write(0,*) 'ERRORE'
          return
      endif
!
      if (iprin > 0) then
          write(0,*) 'NSYM', nsym
          write(0,*) 'VOLUME',volume
      endif
!
      call CPUTime(' ', 0)
      if (iprin > 0) then
          write(lo,600) Inte(1:Lung(Inte))
      endif
!
      return
   30 close(jgrap)
      ier = -1
      return
  200 format(/,' Load map file (XYZ format) ',a,/)
  600 format(' Loading map         ', a,/)
      end
!-----------------------------------------------------------------------
      subroutine LeggiMappaDMP(tipo, ier)
      USE General
      USE Symmetry
      USE Mappa
!
      implicit none
!
      integer            :: tipo, itipo, iform, jop, jopen, ier, ierr
      integer            :: i, ishif, kshif(3), iAction
      integer            :: Lung, iy, iz
      real               :: celltemp(13)
      character (len=16) :: SpaceSav
!
      call CPUTime0(' ')
      celltemp(:) = 0.0
      itipo = 2
      iform = 2
!
      jop=jopen(jgrap,MTZfile,itipo,iform,ierr)
      if (jop.lt.0) then
          ier = -1
          return
      endif
!
      if (iprin > 0) then
          write(lo,200) MTZfile(1:Lung(MTZfile))
      endif
      read(jgrap) celltemp(1:6), SpaceSav, np(1:3)
!
*     InfoOK(1) = 1
      call ManageCell(celltemp, ier)
      if (ier < 0) then
          close(jgrap)
          return
      endif
      call lcase(SpaceSav)
      read(SpaceSav,'(16a1)') nSpaceG
      ishif = 0
      kshif(:) = 0
      call insym(ishif,kshif,ier)
!
      iAction = 1
      call AllocaMappa(iAction)
!
      do iz =1, np(3)
         do iy =1, np(2)
            read(jgrap) xmap(1:np(1), iy, iz)
         enddo
      enddo
      close(jgrap)
!
      if (iprin > 0) then
          write(0,*) 'NP',np
          write(0,*) 'CELL',cell(1:6)
          write(0,*) 'SpGr',SpaceSav
      endif
!
      call CheckSpaceGroupSymbol(nSpaceG,ier)
      if (ier.ge.0) then
          write(SpaceSav,'(16a1)') nSpaceG
          ishif = 0
          kshif(:) = 0
          call insym(ishif,kshif,ier)
      else
          ier = -1
          write(0,*) 'ERRORE'
          return
      endif
!
      if (iprin > 0) then
          write(0,*) 'NSYM', nsym
          write(0,*) 'VOLUME',volume
      endif
!
      call CPUTime(' ', 0)
      if (iprin > 0) then
          write(lo,600) Inte(1:Lung(Inte))
      endif
!
      return
   30 close(jgrap)
      ier = -1
      return
  200 format(/,' Load map file (DMP format) ',a,/)
  600 format(' Loading map         ', a,/)
      end
!-----------------------------------------------------------------------
      subroutine BarraDiStato(iz,ind,ix,iy,str)
      USE Molcom
!
      common /string/ x11string
!
      character x11string*257
      character str*(*)
!
!----- code for Unix
      if (ind.eq.4) then
          lstr=Lung(str)
          if (lstr.gt.0) then
              x11string(1:lstr) = str(1:lstr)
          else
              lstr = 0
          endif
          x11string(lstr+1:lstr+1) = char(0)
      else
          x11string = ' ' // char(0)
      endif
!
      call c_barradistato(iz,ind,ix,iy,x11string )
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Get_1_2(ifLista1, ier)
      USE General
      USE Molcom
!
      dimension abcvet(13)
!
      ier = 0
      if (ifLista1 == 0) then
          abcvet = -1
      else
          do i=1,6
             abcvet(  i) = cell(i)
             abcvet(i+6) = errcell(i)
          enddo
          abcvet(13) = errcell(7)
      endif
      call c_get12(abcvet, ier)
      if (ier == -1) then
          Msg = 'No information supplied'
          call MsgWinErr('WARNING', Msg, ERR_WINDOW, nExitCode)
          return
      endif
      do i=1,6
         cell(i) = abcvet(i)
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaRiflessiIMV(iAction)
      USE General
      USE Riflessi
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(100)
!
      ierv(:) = 0
      ierr = 0
!
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(khl)) 
     *     ALLOCATE (khl(1:3,1:nreflDim) ,stat = ierv( 1))
          IF (.NOT. ALLOCATED(fovet)) 
     *     ALLOCATE (fovet(1:nreflDim)   ,stat = ierv( 2))
          IF (.NOT. ALLOCATED(iphaz)) 
     *     ALLOCATE (iphaz(1:nreflDim)   ,stat = ierv( 3))
          IF (.NOT. ALLOCATED(work1)) 
     *     ALLOCATE (work1(1:nreflDim)   ,stat = ierv( 4))
          IF (.NOT. ALLOCATED(work2)) 
     *     ALLOCATE (work2(1:nreflDim)   ,stat = ierv( 5))
          IF (.NOT. ALLOCATED(wt)) 
     *     ALLOCATE (wt(1:nreflDim)      ,stat = ierv( 6))
          IF (.NOT. ALLOCATED(fcoef)) 
     *     ALLOCATE (fcoef(1:nreflDim)   ,stat = ierv( 6))
          IF (.NOT. ALLOCATED(fcvet)) 
     *     ALLOCATE (fcvet(1:nreflDim)   ,stat = ierv( 7))
          IF (.NOT. ALLOCATED(sigmav)) 
     *     ALLOCATE (sigmav(1:nreflDim)  ,stat = ierv( 8))

!
          ierr = 0
          ierr = sum(iabs( ierv(:) ))
          if (ierr.ne.0) then
              write(*,*) 'Riflessi Allocation error'
              call cstop(' ')
          endif
          khl(:,:)  = 0
          fovet(:)  = 0
          iphaz(:)  = 0
          work1(:)  = 0
          work2(:)  = 0
          wt(:)     = 0
          fcoef(:)  = 0
          fcvet(:)  = 0
          sigmav(:) = 0
!
      else
          IF (ALLOCATED(khl))
     *        DEALLOCATE (fovet, iphaz, khl, work1, work2, wt, 
     *                    fcoef, fcvet, sigmav, stat = ierr)
          InfoOK(6) = 0
          if (ierr.ne.0) then
              write(*,*) 'Riflessi DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaMappaJav(iAction)
      USE General
      USE Mappa
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      implicit none
      integer :: iAction, ierv(6), ierr
!
      common /provaMappa/ ifPiuUno
      integer :: ifPiuUno
!
      ierv(:) = 0
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(xmap))
     *        ALLOCATE (xmap(0:np(1)-1,0:np(2)-1,0:np(3)-1),
     *                  stat = ierv(1))
          IF (.NOT. ALLOCATED(xmapC))
     *        ALLOCATE (xmapC(0:np(1)/2,0:np(2)-1,0:np(3)-1),
     *                  stat=ierv(2))
          IF (.NOT. ALLOCATED(xmapApp)) then
              if (ifPiuUno == 0) then
                  ALLOCATE (xmapApp(0:np(1)-1,0:np(2)-1,0:np(3)-1),
     *                      stat = ierv(4))
              else
                  ALLOCATE (xmapApp(0:np(1),0:np(2),0:np(3)),
     *                      stat = ierv(4))
              endif
          endif
          ierr = sum(ierv)
          if (ierr /= 0) then
              write(*,*) 'Map Allocation Error'
              call cstop(' ')
          endif
          xmap = 0.0
          xmapApp = 0.0
          call DistruggiPianiAll
      else
          IF (ALLOCATED(xmap)) then
              DEALLOCATE (xmap, xmapC, xmapApp, stat = ierv(1))
          endif
          if (ierv(1) /= 0) then
              write(*,*) 'Mappa DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaMappeViewer(iAction, np, sigma)
      USE General
      USE MappeViewer
      USE RemoModule
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      implicit none
      integer    :: iAction, np(3), ierr, i
      real       :: sigma
!
      ierr = 0
      if (iAction == 0) then
          if (.not. ALLOCATED(Mappe)) then
             allocate (Mappe(1:MaxnumbMaps), stat = ierr)
          endif
          if (ierr /= 0) then
              write(*,*) 'MappeViewer Allocation Error'
              call cstop(' ')
          endif
      elseif (iAction == 1) then
          if (allocated(Mappe)) then
              Mappe(WhichMap)%np(1:3) = np(1:3) !  + 1  gianluca 21/07/2011
              Mappe(WhichMap)%sigma   = sigma
              allocate (Mappe(WhichMap)%
     *             xmap(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat = ierr)
*    *             xmap(0:np(1)  ,0:np(2)  ,0:np(3)  ), stat = ierr)
              if (ierr /= 0) then
                  write(*,*) 'MappeViewer Allocation Error'
                  call cstop(' ')
              endif
              Mappe(WhichMap)%xmap(:,:,:) = 0.0
          else
             write(*,*) 'RemoModel Allocation-sequence Error'
             call cstop(' ')
          endif
      elseif (iAction == 2) then
          if (allocated(Mappe)) then
              do i=1, MaxnumbMaps
                 if (allocated(Mappe(i)%xmap)) then
                     deallocate (Mappe(i)%xmap)
                 endif
              enddo
              deallocate (Mappe, stat = ierr)
          endif
          if (ierr.ne.0) then
             write(*,*) 'MappeViewer DeAllocation Error'
             call cstop(' ')
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine MapToPlot(ifDifference)
      USE General
      USE Symmetry
      USE Mappa
      USE Param
      USE RemoModule
      USE MappeViewer
!
      implicit none
      integer           :: i, j , k, l, ind(3), xini, yini, zini
      integer           :: npMod(3), ifDifference, Lung, L1, L2, iAction
      integer           :: jpatt, numbMapsSav, WhichMapSav, npJav(3)
      real              :: dx, dy, dz, dxm, dym, dzm, xx, sigma
      character (len=200) :: FileMapName
!
      common /provaMappa/ ifPiuUno
      integer :: ifPiuUno
!
      if (ifPiuUno == 0) then
          npJav(1:3) = np(1:3)
          xmapApp(:,:,:) = xmap(:,:,:)
      else
          npJav(1:3) = np(1:3) + ifPiuUno
          xmapApp(0:np(1)-1,0:np(2)-1,0:np(3)-1) = 
     *            xmap(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      
          xmapApp(np(1),0:np(2)-1,0:np(3)-1)=xmap(0,0:np(2)-1,0:np(3)-1)
          xmapApp(0:np(1)-1,np(2),0:np(3)-1)=xmap(0:np(1)-1,0,0:np(3)-1)
          xmapApp(0:np(1)-1,0:np(2)-1,np(3))=xmap(0:np(1)-1,0:np(2)-1,0)
      endif
!!mr      xmapApp(:,:,:) = xmapApp(:,:,:) / volume
      xmapApp(:,:,:) = xmapApp(:,:,:) 
      call maxminSir(npJav(1),npJav(2),npJav(3),xmapApp)
      if (iprin > 0) then
          write(lo,100), np, denmin, denmax, avden, stden
      endif
!
      numbMaps = numbMaps + 1  
      WhichMap = numbMaps
      write(FileMapName,200) WhichMap
      if (nSpaceGroup > 0) then
          jpatt = 0
          call CCP4MAPOUT(jpatt, xmap, np, FileMapName)
      endif
      iAction = 1
      sigma = stden
      call AllocaMappeViewer(iAction, np, sigma)
      Mappe(WhichMap)%xmap(:,:,:) = xmapApp(:,:,:)
!
      L1 = index(MTZFile, slash, .TRUE.)
      if (L1 > 0) then
          L1 = L1 + 1
      else
          L1 = 1
      endif
      L2 = Lung(MTZFile)
      cardImage = MTZFile(L1:L2) // char(0)
      j = ifDifference + 1
!      write(0,*) denmin, denmax, avden, stden
      call PassaMappa(cardImage, numbMaps, WhichMap, npJav, nrefl, resm,
     *                j)
!
      L1 = 2
      call AllocaMappaJav(L1)
!
      return
  100 format(/,' Map properties',/,
     *         '      Grid points ',3i5,/,
     *         '      Minimum ',g15.5,/,
     *         '      Maximum ',g15.5,/,
     *         '      Mean    ',g15.5,/,
     *         '      Sigma   ',g15.5,/)
  200 format('jav_ccp4_',i1,'.map')
      end
!-----------------------------------------------------------------------
      subroutine GesFile(filenam, tipo, ifDifference)
!
      USE General
      USE Atomi
      USE RemoModule
      USE ilmviewmod
      USE proginterface
      USE fileutil
!
      implicit none
      integer               :: n, Lung, tipo, ier, nExitCode
      integer               :: ifDifference, ifXtal, ifNewModel
      real                  :: nove
      character (len = *)   :: filenam
!
      ier = 0
      filenam(Lung(filenam)+1:) = ' '
      if (tipo > 0 .and. tipo <= 10) then     ! mtz
          nove = -9999
          call LeggiHKL(tipo, filenam, ifDifference, nove, 0, ier)
*         if (ier < 0) then
*             cardImage = filenam
*             write(Msg,10) cardImage(1:Lung(cardImage))
*             call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
*         endif
      elseif (tipo > 10 .and. tipo <= 20) then  ! pdb, cif, shelx
          filePDB = filenam
          call ResettaSpecie()
          if (tipo == 11) then          ! pdb
              call jav_import_model (filenam, ier)
              !!call ManagePDB(ier)
          elseif (tipo == 12) then      ! cif
              call jav_import_model (filenam, ier)
              !call ManageCIF(ier)
          elseif (tipo == 13) then      ! shelx
              call jav_import_model (filenam, ier)
              !call ManageSHELX(ier)
          endif
          if (ier == 0) then
              call AssegnaIntensita
          endif
      elseif (tipo > 20 .and. tipo <= 30) then
          if (tipo == 21) then          ! CCP4 map
              FichierIn = filenam
              MTZfile = filenam
              if (ifXtal() == 0) then
                  call LeggiMappa(tipo, ier)
              else
                  call LeggiMappaXtal(tipo, ier)
              endif
          elseif (tipo == 22) then      ! XYZ map
              MTZfile = filenam
              call LeggiMappaXYZ(tipo, ier)
          elseif (tipo == 23) then      ! DMP map
              MTZfile = filenam
              call LeggiMappaDMP(tipo, ier)
          endif
      else
          write(Msg,'(a,a)') 'Illegal argument:', 
     *                       filenam(1:Lung(filenam))
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          call JavError()
          return
      endif
!
      if (ier < 0) then
          Msg = 'Error processing file ' // filenam(1:Lung(filenam))
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          call JavError()
          return
      endif
!!mr sperimentale
      !!if (tipo == 12 .or. tipo == 13) then
          !!return
      !!endif
!
!gl!  call GetFourierLimits()   va in errore sul p 63/m m c
!corrado
      StructureName = file_rem_ext(file_get_name(filenam))
      call nk_to_elem(celem)
!corrado
      call PrimaDelPlot
      call ilmview_open()      !!Open_GLWindow()
!
      if (tipo >= 1 .and. tipo <= 10) then
          call MapToPlot(ifDifference)
      endif
!
!corr      if (tipo > 10 .and. tipo <= 20) then
!!mr      if (tipo == 11) then ! only for PDB
!!mr          ifNewModel = 1
!!mr          call ModelToPlot(ifNewModel)
!!mr      endif
!
      if (tipo >= 21) then
          call MapToPlot(ifDifference)
      endif
!
      return
   10 format('Problems reading file ',a)
      end
!-----------------------------------------------------------------------
      subroutine PrimaDelPlot
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE RemoModule
!
      implicit none
      integer nAtoms
!
      if (iprin > 0) then
          write(lo,100) cell(1:6)
          write(lo,200) volume
          write(lo,300) nsym
      endif
      if (allocated(khl)) then
          resm = 0.5 / sqrt(rhomax)
          if (iprin > 0) then
              write(lo,400) nrefl
              write(lo,500) resm
          endif
      endif
!
      return
  100 format(' Cell parameters            =',6x,3f8.3,/,
     *       '                             ',6x,3f8.3)
  200 format(' Cell volume                =',f13.2)
  300 format(' Number of symm. operations =',i10)
  400 format(' Number of reflections      =',i10)
  500 format(' Resolution                 =',7x,f6.2)
      end
!-----------------------------------------------------------------------
      subroutine InvRm
      USE Molcom , only: rm, rmi
!
      double precision det
!
      det = 0
      i = 1
      l = i + 1
      l1 = l + 1
      do j=1, 3
         k = 1
         if (k .eq. j) then
            k = k + 1
         end if
         k1 = k + 1
         if (k1 .eq. j) then
            k1 = k1 + 1
         end if
         s = (-1.)**(i+j)
         sdet = s*rm(i,j)*(rm(l,k) * rm(l1,k1)-rm(l,k1)*rm(l1,k))
         det = det + sdet
      enddo
!
      do i=1, 3
         l=1
         if (l .eq. i) then
            l = l + 1
         end if
         l1 = l + 1
         if (l1 .eq. i) then
            l1 = l1 + 1
         end if
         do j=1, 3
            k = 1
            if (k .eq. j) then
               k = k + 1
            end if
            k1 = k + 1
            if (k1 .eq. j) then
               k1 = k1 + 1
            end if
            s = (-1.) ** (i + j)
            rmi(j,i) = (rm(l,k) * rm(l1,k1) - rm(l,k1) * rm(l1,k)) / det
            rmi(j,i) = s * rmi(j,i)
         enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine InvRmi
      USE Molcom , only: rm, rmi
!
      double precision det
!
      det = 0
      i = 1
      l = i + 1
      l1 = l + 1
      do j=1, 3
         k = 1
         if (k .eq. j) then
            k = k + 1
         end if
         k1 = k + 1
         if (k1 .eq. j) then
            k1 = k1 + 1
         end if
         s = (-1.)**(i+j)
         sdet = s*rmi(i,j)*(rmi(l,k) * rmi(l1,k1)-rmi(l,k1)*rmi(l1,k))
         det = det + sdet
      enddo
!
      do i=1, 3
       l=1
       if (l .eq. i) then
          l = l + 1
       end if
       l1 = l + 1
       if (l1 .eq. i) then
          l1 = l1 + 1
       end if
       do j=1, 3
         k = 1
         if (k .eq. j) then
            k = k + 1
         end if
         k1 = k + 1
         if (k1 .eq. j) then
            k1 = k1 + 1
         end if
         s = (-1.) ** (i + j)
         rm(j,i) = (rmi(l,k) * rmi(l1,k1) - rmi(l,k1) * rmi(l1,k)) / det
         rm(j,i) = s * rm(j,i)
       enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      real function GetXMap(i, j, k)
      USE Mappa
!
      implicit none
      integer       :: i, j, k
!
      GetXMap = xmapApp(i,j,k)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ModelToPlot(ifNewModel)
      USE General
      USE RemoModule
      USE Symmetry
      USE connect_mod
      USE atom_type_util
      USE progtype
      USE javinterface
      USE realloc
      USE ilmviewmod
      USE model_util
!
      implicit none
      integer       :: nAtoms, Lung, i, L1, L2, nb, nspec, nAt_au
      integer       :: ifNewModel, i1, i2
      real          :: di
      type(atom_type), dimension(:), allocatable :: atom
      type(bond_type), dimension(:), allocatable :: legame
!
      nAtoms = natsInModel(WhichModel)
      nAt_au = natsAsymm(WhichModel)
      L1 = index(filePDB, slash, .TRUE.)
      if (L1 > 0) then
          L1 = L1 + 1
      else
          L1 = 1
      endif
      L2 = Lung(filePDB)
      if (ifNewModel == 1) then
          cardImage = filePDB(L1:L2) // char(0)
      else
          cardImage = ' ' // char(0)
      endif
*gl*  nb = BondsInModel(WhichModel)
      nb = sum(legAsymm(WhichModel,:))
      nspec = nk
      L1 = Model(WhichModel)%PDB

      call reallocate(atom, nAtoms, .false.)
      call fromModelToAtom(atom)
      call reallocate_legm(legame, nb, .FALSE.)
      do i=1, nb
         i1 = Bonds(WhichModel)%Legami(1,i)
         i2 = Bonds(WhichModel)%Legami(2,i)
         di = Bonds(WhichModel)%Legami(4,i)
         legame(i)%n1 =   i1  ! primo atomo del legame
         legame(i)%n2 =   i2  ! secondo atomo del legame
         legame(i)%dist = di  ! secondo atomo del legame
      enddo
      num_models = numbModels
      call ilmview_draw(atom,legame,kmodel=WhichModel)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine newproject_symm(ier,SPGroup,CellConditions)
      USE General
      USE Symmetry
!
      character*(*) SPGroup
      integer ier
      integer CellConditions(14)
!
      dimension kshif(3)
!

      call shift(SPGroup,nchar)
      ier = 0
      k = index(SPGroup,':')
      if (k > 0) then
          SPGroup(k:) = ' '
      endif
      read(SPGroup,'(16a1)') nSpaceG
      call CheckSpaceGroupSymbol(nSpaceG, ier)
      if (ier.lt.0) then
          write(Msg,10) SPGroup
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          return
      endif
      ishif = 0
      kshif(1) = 0
      kshif(2) = 0
      kshif(3) = 0
      call insym(ishif,kshif,ier)
      if (ier < 0) then
          return
      endif
!      call yfrm02
!      call yfl02
      call xspinb
      kpolTrue = kpol
!
      CellConditions = -100
      CellConditions(14) = jsys
      select case (jsys)
             case (2)
                  if (kmat(2,1,1).eq.kmat(2,2,2)) then
                      CellConditions( 4) = 90
                      CellConditions( 5) = 90
                      CellConditions(10) =  0
                      CellConditions(11) =  0
                  else if (kmat(2,1,1).eq.kmat(2,3,3)) then
                      CellConditions( 4) = 90
                      CellConditions( 6) = 90
                      CellConditions(10) =  0
                      CellConditions(12) =  0
                  else if (kmat(2,2,2).eq.kmat(2,3,3)) then
                      CellConditions( 5) = 90
                      CellConditions( 6) = 90
                      CellConditions(11) =  0
                      CellConditions(12) =  0
                  endif
             case (3)
                  CellConditions( 4) =  90
                  CellConditions( 5) =  90
                  CellConditions( 6) =  90
                  CellConditions(10) =   0
                  CellConditions(11) =   0
                  CellConditions(12) =   0

             case (4)
                  CellConditions( 2) =  -1
                  CellConditions( 4) =  90
                  CellConditions( 5) =  90
                  CellConditions( 6) =  90
                  CellConditions( 8) =  -7
                  CellConditions(10) =   0
                  CellConditions(11) =   0
                  CellConditions(12) =   0

             case (5)
                  CellConditions( 2) =  -1
                  CellConditions( 4) =  90
                  CellConditions( 5) =  90
                  CellConditions( 6) = 120
                  CellConditions( 8) =  -7
                  CellConditions(10) =   0
                  CellConditions(11) =   0
                  CellConditions(12) =   0

             case (6)
                  CellConditions( 2) =  -1
                  CellConditions( 3) =  -1
                  CellConditions( 4) =  90
                  CellConditions( 5) =  90
                  CellConditions( 6) =  90
                  CellConditions( 8) =  -7
                  CellConditions( 9) =  -7
                  CellConditions(10) =   0
                  CellConditions(11) =   0
                  CellConditions(12) =   0
      end select
!
      return
   10 format('Error in Space Group Symbol:',a)
   50 format(' ')
      end
!-----------------------------------------------------------------------
      subroutine SincronizzaSpecie(puntatore)
      USE General, only : WhichProps, iprin
      USE RemoModule
      USE Properties
!
      implicit none
      integer           :: i, j, k, nats, puntatore(18)
      character (len=4) :: tempSpecies(18)
!
      tempSpecies(:) = ' '
      do i=1, AtmProperties(WhichProps)%nSpecies
         j = puntatore(i)
         tempSpecies(i) = AtmProperties(WhichProps)%Species(j) 
         if (iprin > 0) then
             write(6,*) i, AtmProperties(WhichProps)%natsInCell(i), 
     *                     AtmProperties(WhichProps)%NomeSpecie(i),
     *                     tempSpecies(i)
         endif
      enddo
      AtmProperties(WhichProps)%Species(:) = tempSpecies(:)
!
      nats = natsInModel(WhichModel)
      do i=1, nats
         j = model(WhichModel)%specie(i,1)
         if (j > 0) then
             k = puntatore(j)
             model(WhichModel)%specie(i,1) = k
         endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PeakSearch(QualeMappa, QualeMod, livello, QualiPicchi,
     *                      ifView, ier)
      USE General
      USE Symmetry
      USE Atomi
      USE RemoModule
      USE Mappa
      USE MappeViewer
      USE MolCom, only: rm
!
!-- QualeMappa  = Map to to search
!-- QualiPicchi = 1 only positive peaks will be searched
!-- QualiPicchi = 2 only negative peaks will be searched
!-- QualiPicchi = 3 both positive and negative peaks will be searched
!-- QualeMod    = Model to be used as reference
!-- QualiPicchi = 1 Only peaks in the positive part of the map
!-- QualiPicchi = 2 Only peaks in the negative part of the map
!-- QualiPicchi = 3 Peaks in the positive and negative part of the map
!-- livello     = Sigma level for the search
!-- ifView      = 1 Difference Fourier: list of peaks is showed in a window
!-- ifView      = 0 Helix: peaks are plotted
!
      implicit none
      integer      :: QualeMappa, ifPatt, iflagPKS, QualiPicchi, npic
      integer      :: QualeMod, ier, QM, iAction, ix, iy, iz, i, k, L
      integer      :: NumPeaks, NumPeaksPos, NumPeaksNeg, ifView
      integer      :: n, nbonds
      real         :: livello, div, dm, sig, xx, soglia, x1(3), x2(3)
      real         :: dmh
      real, allocatable    :: posizioni(:,:)
      character (len=16)   :: Lab
      character (len=21)   :: stringa21
!
      if (QualeMappa == 0) then
          return
      endif
!
      call InitOper
!
      div = 15.0 * nsymTot
      MaxAtoms = volume / div
      nats = MaxAtoms
      npic = MaxAtoms
      MaxAtoms = MaxAtoms * 1.2
!
      if (QualiPicchi == 3) then
          MaxAtoms = 50
      else
          MaxAtoms = 100
      endif
      nats = MaxAtoms
      npic = MaxAtoms
      MaxAtoms = MaxAtoms * 1.2
      
!
      Allocate(xmap(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat = ier)
      Allocate(xyzs(1:5,1:MaxAtoms), stat = ier)
      if (ier < 0) then
          return
      endif
!
      NumPeaksPos = 0
      NumPeaksNeg = 0
      call Init_pksrch(dm)
!
      if (QualiPicchi /= 2) then
          xyzs(:,:) = 0.0
          QM = QualeMappa
          xmap(:,:,:) = Mappe(QM)%xmap(:,:,:)
          sig = Mappe(QM)%sigma
          soglia = sig * livello
          do iz = 0, np(3)-1
             do iy = 0, np(2)-1
                do ix = 0, np(1)-1
                   xx = xmap(ix, iy, iz)
                   if (xx < soglia) then
                       xmap(ix, iy, iz) = 0.0
                   endif
                enddo
             enddo
          enddo
!
          iflagPKS = 0  ! da verificare la correttezza di xyzfou
          ifPatt = 0
          ier = 0
          if (ifView == 1) then
             call pksrch_core(xmap, np, ifPatt, iflagPKS, npic, dm,
     *                            NumPeaksPos, ier)
          else
             dmh = 2.0
             call pksrch_core(xmap, np, ifPatt, iflagPKS, npic, dmh,
     *                            NumPeaksPos, ier)
          endif
          if (NumPeaksPos > 0) then
              NumPeaksPos = min0(NumPeaksPos, nats)
              Allocate(xyz15(1:5,1:NumPeaksPos), stat = ier)
              xyz15(1:5,1:NumPeaksPos) = xyzs(1:5,1:NumPeaksPos)
          endif
      endif
!
      if (QualiPicchi /= 1) then
          xyzs(:,:) = 0.0
          QM = QualeMappa
          xmap(:,:,:) = - Mappe(QM)%xmap(:,:,:)
          sig = Mappe(QM)%sigma
          soglia = sig * livello
          do iz = 0, np(3)-1
             do iy = 0, np(2)-1
                do ix = 0, np(1)-1
                   xx = xmap(ix, iy, iz)
                   if (xx < soglia) then
                       xmap(ix, iy, iz) = 0.0
                   endif
                enddo
             enddo
          enddo
!
          iflagPKS = 0  ! dovra' essere 0 quando definiremo la lista 14
          iflagPKS = 1
          ifPatt = 0
          ier = 0
          call pksrch_core(xmap, np, ifPatt, iflagPKS, npic, dm,
     *                     NumPeaksNeg, ier)
          if (NumPeaksNeg > 0) then
              NumPeaksNeg = min0(NumPeaksNeg, nats)
              Allocate(xyz30(1:5,1:NumPeaksNeg), stat = ier)
              xyz30(1:5,1:NumPeaksNeg) = xyzs(1:5,1:NumPeaksNeg)
          endif
      endif
!
      deallocate(xmap, xyzs, stat = ier)
      NumPeaks = NumPeaksPos + NumPeaksNeg
      if (NumPeaks > 0) then
          Allocate(posizioni(1:6,1:NumPeaks), stat = ier)
          k = 0
          if (NumPeaksPos > 0) then
              do i=1, NumPeaksPos
                 k = k + 1
                 posizioni(1:5,k) = xyz15(1:5,i)
                 posizioni(4,k)   = posizioni(4,k) / sig
              enddo
          endif
          if (NumPeaksNeg > 0) then
              do i=1, NumPeaksNeg
                 k = k + 1
                 posizioni(1:5,k) = xyz30(1:5,i)
                 posizioni(4,k)   = - posizioni(4,k) / sig
              enddo
          endif
          deallocate(xyz15, xyz30, stat = ier)
      
!
          if (iprin > 0) then
              write(lo,'(/,a,/)') '      Fourier Peaks list'
          endif
          if (ifView > 0) then
              call SpostaPicchi(posizioni, NumPeaks)
              if (iprin > 0) then
                  write(lo,20)
              endif
          else
              soglia = sig * livello
              call AggregaPicchi(posizioni, NumPeaks, soglia, 3.0)
              call SelezionaPosizioni(posizioni, NumPeaks)
              call AggregaPicchi(posizioni, NumPeaks, soglia, 5.0)
              if (iprin > 0) then
                  write(lo,30)
              endif
          endif
!
          Lab = ' '
          stringa21 = ' '
          do i=1, NumPeaks
             if (ifView > 0) then
                 k = nint(posizioni(6,i))
                 Lab = model(WhichModel)%Label(k)
                 write(stringa21,'(3f7.3)')  
     *                 model(WhichModel)%atoms(1:3,k,1)
             endif
             if (iprin > 0) then
                 write(lo,10) i, posizioni(1:5,i), stringa21, Lab
             endif
          enddo
!
          if (ifView == 1) then
              call ViewPeaks(posizioni, NumPeaks, numbModels, QualeMod)
          else
              numbModels = numbModels + 1
              WhichModel = WhichModel + 1
              natsInModel(WhichModel) = NumPeaks
              MonomerInModel(WhichModel) = 1
              call AllocaModelRemo(1)
              do i=1, NumPeaks
                 x1(1:3) = posizioni(1:3,i)
                 model(WhichModel)%atoms(1:3,i,1) = x1(1:3)
                 model(WhichModel)%atoms(4,i,1) = - posizioni(4,i) / sig
                 model(WhichModel)%atoms(5,i,1) = 1.0
                 model(WhichModel)%specie(i,1) = nk
                 x1(1:3) = model(WhichModel)%atoms(1:3,i,1)
                 model(WhichModel)%saved(1:3,i,1)= x1(1:3)
                 call MoltMatVec(rm, x1, x2)
                 model(WhichModel)%ortho(1:3,i,1)= x2(1:3)
                 write(Lab,'(i5)') i
                 call shift(Lab,L)
                 model(WhichModel)%Label(i) = Lab
              enddo
*             nk = nk + 1
*             no(nk)      = 1
*             Species(nk) = 'h'
              n = natsInModel(WhichModel)
              natsAsymm(WhichModel) = n
              model(WhichModel)%PDB = 0
              call CreaConn(n, nbonds, 0, ier)

              if (ier < 0) then
                  call ErrorLoadingModel
                  return
              endif

              nbonds = 0
              BondsInModel(WhichModel) = nbonds
              nLegProtein = 0
              nLegBack    = 0
              nLegCalpha  = 0
              nLegLigand  = 0
          endif
          deallocate(posizioni, stat = ier)
!
!
      endif
!
      return
   10 format(i5,")",5f8.3,2x,a21,2x,a16)
   20 format('       ------- Peak ---------   Sigma  Distance',
     *       ' -------- from Atom -----------')
   30 format('       ------- Peak ---------   ')
      end
!-----------------------------------------------------------------------
      subroutine SelezionaPosizioni(posizioni, NumPeaks)
!
      USE General
      USE Symmetry
      USE RemoModule
!
      implicit none
      integer :: NumPeaks, i, j, k, ier, i1, i2, iOK
      real    :: posizioni(6,NumPeaks), x1(3), x2(3), x3(3), s(3), d
      real    :: dmin
      real, allocatable    :: vettore(:,:), tempVet(:)
      integer, allocatable :: puntatore(:)
!
      Allocate(vettore(1:NumPeaks,2), stat = ier)
      Allocate(puntatore(1:NumPeaks), stat = ier)
      Allocate(tempVet(1:NumPeaks), stat = ier)
!
      posizioni(5,:) = 0
      do i=1, NumPeaks
         dmin = 9999
         x1(1:3) = posizioni(1:3,i)
         vettore(:,1) = 9999
         do j=1, NumPeaks
            puntatore(j) = j
            if (i == j) cycle
            x2(1:3) = posizioni(1:3,j)
            call xdist(x1, x2, d, s)
            vettore(j,1) = d
            vettore(j,2) = j
            write(6,*) i,j,d
         enddo
         tempVet(:) = vettore(:,1)
         call sortall3(1, tempVet, 1, NumPeaks, puntatore)
         i1 = puntatore(1)
         i2 = puntatore(2)
         if (posizioni(4,i1) > posizioni(4,i) .and.
     *       posizioni(4,i2) > posizioni(4,i)) cycle
         iOK = 1
         do j=1, NumPeaks
            if (posizioni(5,j) > 0.5) then
                x2(1:3) = posizioni(1:3,j)
                call xdist(x1, x2, d, s)
                if (d < 2.0) then
                    iOK = 0
                endif
            endif
         enddo
         if (iOK == 1) then
            posizioni(5,i) = 1
         endif
         if (iprin > 0) then
             write(lo,*) i, vettore(puntatore(1:NumPeaks-1),1:2)
         endif
      enddo
!
      i = 0
      do j=1, NumPeaks
         if (posizioni(5,j) > 0.5) then
             i = i + 1
             posizioni(:,i) = posizioni(:,j)
         endif
      enddo
      NumPeaks = i
!
      deallocate(tempVet, vettore, puntatore, stat = ier)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SpostaPicchi(posizioni,npos)
      USE General
      USE Symmetry
      USE RemoModule
!
!-- Move fourier peaks close to model atoms
!
      implicit none
      real        :: posizioni(6,npos), atomo(3), picco(3), xeq(3)
      real        :: vet(2), s(3), xeqsav(3), distm, coef, d
      integer     :: npos, nats, i, j, k, kt, ifi, ifin, jpunt
!
      nats = natsInModel(WhichModel)
      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1
      do i=1, npos
         picco(1:3) = posizioni(1:3,i)
         distm=9999
         do j=1, nats
            atomo(1:3) = model(WhichModel)%atoms(1:3,j,1)
            do kt=1,ncentr
               do ifi=1,ifin
                  coef=vet(ifi)
                  do k=1,nsym
                     call xequi(picco,k,coef,xeq,kt)
                     call xdist(atomo,xeq,d,s)
                     if (d < distm) then
                         distm = d
                         jpunt = j
                         xeqsav(1:3) = xeq(1:3)
                     endif
                  enddo
               enddo
            enddo
         enddo
!
         atomo(1:3) = model(WhichModel)%atoms(1:3,jpunt,1)
         call PosizioneAssoluta(xeqsav, atomo)
         posizioni(1:3,i) = xeqsav(1:3)
         posizioni(  5,i) = distm
         posizioni(  6,i) = jpunt
!
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AggregaPicchi(posizioni,npos, soglia, sogDist)
      USE General
      USE Symmetry
      USE RemoModule
!
!-- Move fourier peaks close one to each other
!
      implicit none
      real        :: posizioni(6,npos), atomo(3), picco(3), xeq(3)
      real        :: vet(2), s(3), xeqsav(3), distm, coef, d, soglia
      real        :: sogDist
      integer     :: npos, nats, i, j, k, kt, ifi, ifin, jpunt, Continua
      integer     :: next, igian, posizioni6(100)
!
      do i=1, npos
         if (posizioni(4,i) > soglia) then
             k = i
         else
             exit
         endif
      enddo
      npos = k
      if (iprin > 0) then
          do i=1, npos
             write(lo,1) i,posizioni(1:5,i)
          enddo
      endif
    1 format(i3,1h),6f9.3)
!
      posizioni(6,:) = 0
      posizioni6(:) = 0
      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1
      Continua = 1
      next = 0
      i = 1
      posizioni(6,i) = 1
      posizioni6(i) = 1
      do while (Continua == 1)
         atomo(1:3) = posizioni(1:3,i)
         write(6,'("Atomo ",i3,3f8.3)') i, atomo(1:3)
         if (i == 45) then
             igian = 1
         endif
         distm=9999
         jpunt = 0
         Continua = 0
         do j=1, npos
            if (i == j) cycle
!           if (posizioni(6,j) > 0.5) cycle
            if (posizioni6(j) > 0.5) cycle
            picco(1:3) = posizioni(1:3,j)
         if (j == 45) then
             igian = 1
         endif
            do kt=1,ncentr
               do ifi=1,ifin
                  coef=vet(ifi)
                  do k=1,nsym
                     call xequi(picco,k,coef,xeq,kt)
                     call xdist(atomo,xeq,d,s)
                     if (d < distm) then
                         distm = d
                         jpunt = j
                         xeqsav(1:3) = xeq(1:3)
                     endif
                  enddo
               enddo
            enddo
         enddo
         if (jpunt > 0 .and. distm < sogDist) then
             call PosizioneAssoluta(xeqsav, atomo)
             write(6,'("Picco ",i3,4f8.3)') jpunt, xeqsav(1:3), distm
             posizioni(1:3,jpunt) = xeqsav(1:3)
             posizioni(  5,jpunt) = distm
             posizioni(  6,jpunt) = i
             posizioni6(jpunt) = i
             i = jpunt
             Continua = 1
         else
             next = next + 1
             if (next <= npos) then
                 i = next
                 Continua = 1
             endif
         endif
      enddo
      j = 0
      do i=1, npos
         if (posizioni(6,i) > 0.5) then
             j = j + 1
             posizioni(:,j) = posizioni(:,i)
         endif
      enddo
      npos = j
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AggregaPicchii(posizioni,npos, soglia)
      USE General
      USE Symmetry
      USE RemoModule
!
!-- Move fourier peaks close one to each other
!
      implicit none
      real        :: posizioni(6,npos), atomo(3), picco(3), xeq(3)
      real        :: vet(2), s(3), xeqsav(3), distm, coef, d, soglia
      integer     :: npos, nats, i, j, k, kt, ifi, ifin, jpunt
!
      do i=1, npos
         if (posizioni(4,i) > soglia) then
             k = i
         else
             exit
         endif
      enddo
      npos = k
      if (iprin > 0) then
          do i=1, npos
             write(lo,1) i,posizioni(1:5,i)
          enddo
      endif
    1 format(i3,1h),5f9.3)
!
      posizioni(6,:) = 0
      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1
      do i=1, npos-1
         atomo(1:3) = posizioni(1:3,i)
         distm=9999
         do j=i+1, npos
            picco(1:3) = posizioni(1:3,j)
            do kt=1,ncentr
               do ifi=1,ifin
                  coef=vet(ifi)
                  do k=1,nsym
                     call xequi(picco,k,coef,xeq,kt)
                     call xdist(atomo,xeq,d,s)
                     if (d < 6) then
                         call PosizioneAssoluta(xeq, atomo)
                         if (posizioni(6,j) < 0.5) then
                             posizioni(1:3,j) = xeq(1:3)
                             posizioni(  5,j) = d
                             posizioni(  6,j) = j
                         endif
                     endif
                  enddo
               enddo
            enddo
         enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AggregaPicchiOld(posizioni,npos, soglia)
      USE General
      USE Symmetry
      USE RemoModule
!
!-- Move fourier peaks close one to each other
!
      implicit none
      real        :: posizioni(6,npos), atomo(3), picco(3), xeq(3)
      real        :: vet(2), s(3), xeqsav(3), distm, coef, d, soglia
      integer     :: npos, nats, i, j, k, kt, ifi, ifin, jpunt
!
      do i=1, npos
         if (posizioni(4,i) > soglia) then
             k = i
         else
             exit
         endif
      enddo
      npos = k
      if (iprin > 0) then
          do i=1, npos
             write(lo,1) i,posizioni(1:5,i)
          enddo
      endif
    1 format(i3,1h),5f9.3)
!
      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1
      do i=1, npos-1
         atomo(1:3) = posizioni(1:3,i)
         distm=9999
         do j=i+1, npos
            picco(1:3) = posizioni(1:3,j)
            do kt=1,ncentr
               do ifi=1,ifin
                  coef=vet(ifi)
                  do k=1,nsym
                     call xequi(picco,k,coef,xeq,kt)
                     call xdist(atomo,xeq,d,s)
                     if (d < distm) then
                         distm = d
                         jpunt = j
                         xeqsav(1:3) = xeq(1:3)
                     endif
                  enddo
               enddo
            enddo
         enddo
!
         if (distm < 4.5) then
         call PosizioneAssoluta(xeqsav, atomo)
         posizioni(1:3,jpunt) = xeqsav(1:3)
         posizioni(  5,jpunt) = distm
         posizioni(  6,jpunt) = jpunt
         endif
!
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ViewOutputFile
      USE General
      USE MolCom
!
!-- Copy the output file in a temporary file to visualize it
!
      implicit none
      integer     :: k, nLines, ier2, irec, nExitCode
      integer     :: ier, itipo, iform, jop, jopen, ierr, Lung
!
      if (iprin <= 0) then
          return
      endif
      ier = 0
      cardImage = 'tmp.tmp'
      itipo = 0
      iform = 1
      jop=jopen(iscra, cardImage, itipo, iform, ierr)
!
      nLines = 0
      rewind lo
      do 
         read(lo,'(a)',end=200) cardImage
         write(iscra,'(a)') cardImage(1:Lung(cardImage))
         nLines = nLines + 1
      enddo
!
  200 continue
      close(lo)
      rewind iscra
!
      Inte = ProgName(1:lProgName) // '.log'
      itipo = 0
      iform = 1
      if (jopen(lo,Inte,itipo,iform,ier2) == 0) then
          do irec=1,nLines
             read(iscra,'(a)') cardImage
             k = Lung(cardImage)
             if (k == 0) k = 1
             write(lo,'(a)') cardImage(1:k)
          enddo
          close(iscra)
      else
          write(Msg,1100) ier2, Inte(1:Lung(Inte))
          call MsgWinErr('ERROR', Msg, SEVERE_ERR_WINDOW, nExitCode)
      endif
!
      return
 1100 format(' Open error #',i5,' on file:',a)
      end
!-----------------------------------------------------------------------
      subroutine Elica(NomeFile)
      USE General
      USE Riflessi
      USE Mappa
      USE MappeViewer
      USE RemoModule
!
      implicit none
      integer           :: tipo, ifDifference, ier, ifAutomaticSav, L, k
      integer           :: QualeMappa, QualeMod, QualiPicchi, ifNewModel
      real              :: SogliaRes, livello
      character (len=*) :: NomeFile
      character (len=4) :: res
!
      if (iprin > 0) then
          write(0, *) NomeFile
          write(0,*) 'Elica np', np
      endif
!
      ier = 0
      tipo = 1
      ifDifference = 0
      ifAutomaticSav = ifAutomatic
      ifAutomatic = 1
      SogliaRes = 7.0
      call LeggiHKL(tipo, NomeFile, ifDifference, SogliaRes, 1, ier)
      ifAutomatic = ifAutomaticSav
*     write(0,*) 'Elica', nrefl,sum(wt(1:nrefl)), sum(iphaz(1:nrefl))
      write(0,*) 'Elica np', np
      write(res,'(f4.1)') SogliaRes
      call shift(res,L)
      k = index(NomeFile,'.mtz')
      MTZFile = NomeFile(1:k-1) // '_' // res(1:L) // '.mtz'
      call MapToPlot(ifDifference)
      QualeMappa = WhichMap
      QualeMod = 0
      livello = 2
      QualiPicchi = 1
      call PeakSearch(QualeMappa, QualeMod, livello, QualiPicchi, 0,ier)
      filePDB = 'HelixPeaks'
      Model(WhichModel)%PDB = 0
      ifNewModel = 1
      call ModelToPlot(ifNewModel)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Ribbons(QualeModello)
      USE RemoModule
!
      implicit none
      integer     :: QualeModello
!
      WhichModel = QualeModello
*     call xtlsstr
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GetSecondary(i, c)
      USE RemoModule
      USE Atomi
!
      implicit none
      integer       :: i, j
      character (len=1)   :: c
!
      j = i    !!InfoOnModels(WhichModel)%iEqui(i)
      c = model(WhichModel)%Secondary(j, 1)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DeleteMapsModels(maps, models)
      USE General, only : Inte, InfoOK, cell
      USE RemoModule
      USE Atomi , only : MaxAtoms, MaxBonds
      USE MappeViewer
!
      implicit none
      integer       :: maps(MaxnumbMaps), models(MaxnumbMaps)
      integer       :: i, i1, j, ierr, np(3), nM, nBonds
!
!-- Delete maps
!
      nM = numbMaps
      i = sum(maps)
      if (i > 0) then
          j = 0
          do i=1, numbMaps
             if (maps(i) == 1) then
                 deallocate (Mappe(i)%xmap, stat = ierr)
                 if (ierr /= 0) then
                     write(Inte,10) i
                     write(*,*) Inte
                     call cstop(Inte)
                 endif
                 nM = nM - 1
             else
                 j = j + 1
                 if (i == j) then
                     cycle
                 else
                     np(1:3) = Mappe(i)%np(1:3)
                     Mappe(j)%np(1:3) = np(1:3)
                     Mappe(j)%sigma   = Mappe(i)%sigma
                     allocate(Mappe(j)%xmap(0:np(1)-1,0:np(2)-1,
     *                                      0:np(3)-1), stat = ierr)
                     if (ierr /= 0) then
                         write(Inte,20) j
                         write(*,*) Inte
                         call cstop(Inte)
                     endif
                     Mappe(j)%xmap   = Mappe(i)%xmap
                 endif
             endif
          enddo
          do i=nM+1, numbMaps
             if (allocated(Mappe(i)%xmap)) then
                 deallocate (Mappe(i)%xmap, stat = ierr)
                 if (ierr /= 0) then
                     write(Inte,10) i
                     write(*,*) Inte
                     call cstop(Inte)
                 endif
             endif
          enddo
          numbMaps = nM
      endif
!
!-- Delete models
!
      nM = numbModels
!!NEW mr
          do i=1, numbModels
             if (models(i) == 1) then
                 nM = nM - 1
             endif
          enddo
          numbModels = nM
      goto  1954
!!mr
      i = sum(models)
      if (i > 0) then
          j = 0
          do i=1, numbModels
             if (models(i) == 1) then
                 call DeallocaModello(i, ierr)
                 if (ierr /= 0) then
                     write(Inte,30) i
                     write(*,*) Inte
                     call cstop(Inte)
                 endif
                 deallocate(Bonds(i)%Legami)
                 nM = nM - 1
             else
                 j = j + 1
                 if (i == j) then
                     cycle
                 else
                     model(j)%trial     = model(i)%trial
                     model(j)%erre      = model(i)%erre
                     model(j)%BTot(:,:) = model(i)%BTot(:,:)
                     natsInModel(j)     = natsInModel(i)
                     MonomerInModel(j)  = MonomerInModel(i)
                     natsAsymm(j)       = natsAsymm(i)
                     legAsymm(j,:)      = legAsymm(i,:)
                     nBonds             = BondsInModel(i)
                     BondsInModel(j)    = nBonds
                     legAsymm(j,1) = legAsymm(i,1)
                     legAsymm(j,2) = legAsymm(i,2)
                     legAsymm(j,3) = legAsymm(i,3)
                     legAsymm(j,4) = legAsymm(i,4)
                     call AllocaModello(j, ierr)
                     if (ierr /= 0) then
                         write(Inte,40) j
                         write(*,*) Inte
                         call cstop(Inte)
                     endif
                     allocate (Bonds(j)%Legami(4,nBonds), stat = ierr)
                     if (ierr /= 0) then
                         write(Inte,50) j
                         write(*,*) Inte
                         call cstop(Inte)
                     endif
                     call CopyModel(i, j)
!
!--new gianluca 26 marzo 2011
!
                     call DeallocaModello(i, ierr)
                     deallocate(Bonds(i)%Legami)
!
                 endif
             endif
          enddo
          do i=nM+1, numbModels
             if (allocated(model(i)%atoms)) then
                 call DeallocaModello(i, ierr)
                 if (ierr /= 0) then
                     write(Inte,30) i
                     write(*,*) Inte
                     call cstop(Inte)
                 endif
             endif
             if (allocated(Bonds(i)%Legami)) then
                 deallocate(Bonds(i)%Legami)
             endif
          enddo
          numbModels = nM
          WhichModel = nM
      endif
 1954 continue
!
      if (numbMaps == 0 .and. numbModels == 0) then
          InfoOK(:) = 0
          cell(:)   = 0
      endif
!
      return
   10 format('MappeViewer Deallocation Error, map#',i2)
   20 format('MappeViewer Allocation Error, map#',i2)
   30 format('RemoModule Deallocation Error, model#',i2)
   40 format('RemoModule Allocation Error, model#',i2)
   50 format('RemoModule (Bonds) Allocation Error, model#',i2)
      end
!-----------------------------------------------------------------------
      subroutine ErrorLoadingModel
      USE General
      USE RemoModule
!
      implicit none
      integer :: i, ier
!
      close(jgrap)
      close(jhost)
      i = WhichModel
      call DeallocaModello(i, ier)
      numbModels = numbModels - 1
      WhichModel = WhichModel - 1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GetCellSy(cella, sy)
      USE General, only: cell
      USE Symmetry
!
      implicit none
      real            :: cella(6)
      type SymminfoC
           integer          :: nsymop, latt, icent;
           character(len=17)  spg
      end type
      type (SymminfoC)      :: sy
!
      cella(1:6) = cell(1:6)
      write(sy%spg(1:17),'(16a1,a)') nSpaceG, char(0)
      sy%nsymop  = nSymmStrings    !!nsym
      sy%latt = latt
      sy%icent = icent
!
      return
!
      end
!-----------------------------------------------------------------------
      subroutine PutNumMaps(nmappe)
      USE RemoModule, only: numbMaps
!
      implicit none
      integer       :: nmappe
!
      numbMaps = nmappe
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PutSizeMap(whMap, n1, n2, n3, ifd, sigmaC)
      USE MappeViewer
      USE RemoModule, only: WhichMap
!
      implicit none
      integer       :: whMap, n1, n2, n3, ifd
      integer       :: iAction, np(3)
      real          :: sigma
!!291011      double precision :: sigmaC
      real :: sigmaC
!
      WhichMap = whMap
      np(1) = n1
      np(2) = n2
      np(3) = n3
      iAction = 1
      sigma = REAL(sigmaC)
      call AllocaMappeViewer(iAction, np, sigma)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PutXMap(whMap, i, j, k, val)
      USE MappeViewer
      USE RemoModule, only: WhichMap
!
      implicit none
      integer       :: whMap, i, j, k
!!291011      double precision :: val
      real :: val
!
      whichMap = whMap
      Mappe(WhichMap)%xmap(i,j,k) = REAL(val)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PutCellSy(cella, sy)
      USE General, only: errcell, InfoOK
      USE Symmetry
!
      implicit none
      real            :: cella(6)
      type SymminfoC
           integer          :: nsymop, latt, icent
           character(len=17):: spg
      end type
      type (SymminfoC)      :: sy
      integer               :: ier, b1
      real                  :: celltemp(13)
      character(len= 1)     :: blank1
!
      errcell(:) = 0
      celltemp(:) = 0
      celltemp(1:6) = cella(1:6)
      call CreaCellInfo(celltemp) ! (1:6))
!
      read(sy%spg(1:16),'(16a1)') nSpaceG
      blank1 = ' '
      read(blank1,'(a1)') b1
      if (nSpaceG(1) /= b1) then
          ier = 0
          call CreaSymmetryInfo(ier)
      else
          nsym = sy%nsymop
          nsymtot = sy%nsymop
          latt = sy%latt
          icent = sy%icent
          call musym()
          call InitOper
          InfoOK(2) = 2
      endif
!
      return
!
      end
!-----------------------------------------------------------------------
      subroutine PutNumModels(nmodels)
      USE RemoModule, only: numbModels, whichModel
      USE ilmviewmod
!
      implicit none
      integer       :: nmodels
!
      numbModels = nmodels
      whichModel = nmodels
      call jav_set_num_models(nmodels)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PutSpInfo(whMod, spinfo, natsC, nats_auC, legs_au,
     *                     ifPDB, ifprot, radiiC, noC)
      USE Atomi, only: nats, MaxBonds
      USE General, only: Species, nk, WhichProps, ifProtein
      USE RemoModule
      USE connect_mod
      USE progtype
!
      implicit none
      type SpeciesInfoC
           character (len=4)   Species(18)
           integer    nk
      end type
      type (SpeciesInfoC) spinfo
      integer      :: whMod, natsC, nats_auC, ifPDB, i, iat(2), ierr
      integer      :: GetNumBondsFromC, i1, i2, noC(18), ifprot
      integer      :: legs_au(4)
      real         :: at(6), radiiC(2, 18), di
      character (len= 28) :: cat
      type(bond_type), dimension(:), allocatable :: legame
!
      WhichProps = 1
      whichModel = whMod
      nk = spinfo%nk
      nats = natsC
      Species = spinfo%Species
!
      natsInModel(WhichModel) = nats
      natsAsymm(WhichModel) = nats_auC
      MonomerInModel(WhichModel) = 1
      ifProtein = ifprot
      call AllocaModelRemo(1)
      model(WhichModel)%nk = nk
      model(WhichModel)%PDB = ifPDB
!
      do i= 1, nk
         model(WhichModel)%raggio(i,1:2) = radiiC(1:2, i)
         model(WhichModel)%no(i)         = noC(i)
      enddo
      do i=1, nats_auC
         call GetAtomsInfoFloat(WhichModel, i, at)
         model(WhichModel)%atoms(:, i, 1) = at(1:5)
         model(WhichModel)%th_fact(i,1)   = at(6)
         call GetAtomsInfoInt(WhichModel, i, iat)
         model(WhichModel)%numResiduo(i,1) = iat(1)
         model(WhichModel)%specie(i,1) = iat(2)
         call GetAtomsInfoChar(WhichModel, i, cat)
         model(WhichModel)%Label(i)         = cat(1:16)
         model(WhichModel)%tipoResiduo(i,1) = cat(17:20) 
         model(WhichModel)%tipoAtomo(i,1)   = cat(21:24)
         model(WhichModel)%catena(i,1)      = cat(25:25)
         model(WhichModel)%Secondary(i,1)   = cat(26:26)
         model(WhichModel)%Alternate(i,1)   = cat(27:27)
      end do
!
! Legami
!
      MaxBonds = GetNumBondsFromC(whichModel)
      BondsInModel(WhichModel) = MaxBonds
      call AllocaBonds(1)
      allocate(legame(1:MaxBonds), stat = ierr)
      call GetBondsFromC(whichModel, legame, nLegProtein, nLegBack, 
     *                   nLegLigand, nLegCalpha)

      do i=1, MaxBonds
         i1 = legame(i)%n1  ! primo atomo del legame
         i2 = legame(i)%n2  ! secondo atomo del legame
         di = legame(i)%n2  ! distanza
         Bonds(WhichModel)%Legami(1,i) = i1
         Bonds(WhichModel)%Legami(2,i) = i2
         Bonds(WhichModel)%Legami(4,i) = di
      enddo
      deallocate(legame, stat = ierr)

      legAsymms(WhichModel,1)  = nLegProtein
      legAsymms(WhichModel,2)  = nLegBack
      legAsymms(WhichModel,3)  = nLegLigand
      legAsymms(WhichModel,4)  = nLegCalpha
      legAsymm(WhichModel,1:4) = legs_au(1:4)
!
      return
!
      end
!-----------------------------------------------------------------------
      subroutine SalvaPDB(wm, modified, nomefile)
      USE General
      USE RemoModule
      USE Atomi, only : nzConst
!
!-- modificato(i) = 0    i-esimo atomo non modificato
!--               = 1    i-esimo atomo cancellato
!
      implicit none
      character (len = *) :: nomefile
      integer             :: Lung, itipo, iform, jop, jopen, ierr
      integer             :: numbPDB, ifFast, ifREM, i, k1, k2, wm, icod
      integer             :: modified(natsInModel(wm))    ! da dimensionare correttamente
!
!-- istruzioni temporanee (4)
!
      if (iprin > 0) then
          write(0, *) filePDB(1:Lung(filePDB))
          write(0, *) nomefile(1:Lung(nomefile))
      endif
!     modified(:) = 0
!     modified(10:20) = 1
!
      WhichModel = wm
      do i=1, natsInModel(WhichModel)
         if (modified(i) == 1) then
             model(WhichModel)%specie(i,1) = -1
         else
             k1 = model(WhichModel)%specie(i,1) * nzConst
             model(WhichModel)%specie(i,1) = k1
         endif
      enddo
!
      itipo = 0
      iform = 1
      jop=jopen(jhost, nomefile, itipo, iform, ierr)
!
      call sirdate(Inte, icod)
      k1 = index(filePDB, slash, .TRUE.) + 1
      k2 = index(nomefile, slash, .TRUE.) + 1
      card(1) = 'REM'
      card(2) = 'REM     Original file: ' // filePDB(k1:Lung(filePDB))
      card(3) = 'REM     Modified file: ' // nomefile(k2:Lung(nomefile))
      card(4) = 'REM     Created by Jav on ' // Inte(1:Lung(Inte))
      card(5) = 'REM'
      numbPDB = -1
      ifFast  = 0
      ifRem = 5
      call outPDBJav(jhost, numbPDB, ifFast, ifREM)
      close(jhost)
!
      return
!
      end
!-----------------------------------------------------------------------
      subroutine outPDBJav(nunit, numbPDB, ifFast, ifREM)
      USE General
      USE Symmetry
      USE Solutions
      USE RemoModule
      USE Atomi, only : nzConst
!
!-- nunit   = logical unit (file must be already opened)
!-- numbPDB > 0 number of atoms to export
!--         < 0 all atoms in binary file are exported
!-- ifFast  = 0  atoms coordinates are fetched from binary file
!--         = 1  atoms coordinates are fetched from xyzs (Atomi module)
!-- ifREM   = 0  no REMs are added to the file
!--         > 0  REMs are added to the file (MAD info)
!
      implicit none
      integer :: nunit, numbPDB, ifFast, ifREM, ihydr, Lung, i, j, l
      integer :: nzeta, nch, ii, nCatena, nresid, n, iser, ich, kk
      integer :: NSYMP, NSYMTZ, NSPGR, MAXSYM, uij(6) 
      parameter (MAXSYM = 192)
      real    :: origx(3,3), rmpdb(3,3), rmipdb(3,3), txxx, angoli(3)
      real    :: tempVet(5), RSYM(4,4,MAXSYM)
      character (len= 1) :: catena, LTYPE
      character (len= 2) :: a2
      character (len= 4) :: a4a, a4b
      character (len= 6) :: a6
      character (len=10) :: SPGRNAM, PGNAM
!
      ihydr = 0
*     if (QualePgm == SIRPROTPGM) then
*         call sd05pdb(nunit, ihydr, numbPDB, ifFast, ifREM)
*         return
*     endif
!
!-- HEADER
!
      write(Buffer1,1111) Titolo(1:72)
      write(nunit,'(a)') Buffer1(1:Lung(Buffer1))
!
!-- REMARKS
!
      if (ifREM > 0) then
          do i=1, ifREM
             write(nunit,'(a)') card(i)(1:Lung(card(i)))
          enddo
      endif
!
!-- CRYST1
!
      call SpaceGroupCCP4(NSPGR,SPGRNAM,PGNAM,NSYMP,NSYMTZ,RSYM,LTYPE)
      Inte = SPGRNAM
      nzeta = totop
      write(nunit,1130) cell(1:6), Inte(1:11), nzeta
!
!-- ORIGX
!
      do i=1,3
         do j=1,3
            origx(i,j)=0.0
            if (i.eq.j) origx(i,j)=1.0
         enddo
         txxx=0.0
         write(nunit,1135)i,(origx(i,j),j=1,3),txxx
      enddo
!
      do i=1,3
         angoli(i) = cell(i+3) * dtor
      enddo
!
!-- metrica diretta
!
      rmpdb(1,1) =  cell(1)                          ! a
      rmpdb(1,2) =  0
      rmpdb(1,3) =  0
      rmpdb(2,1) =  cell(2) * cos(angoli(3))         !  b*cos(gam)
      rmpdb(2,2) =  cell(2) * sin(angoli(3))         !  b*sin(gam)
      rmpdb(2,3) =  0
      rmpdb(3,1) =  cell(3) * cos(angoli(2))         !  c*cos(bet)
      rmpdb(3,2) = -cell(3) * sin(angoli(2))
     1                     * cos(angoli(1))          ! -c*sin(bet)*cos(alfs)
      rmpdb(3,3) =  1.0 / asta(3)                    !  1./cstar
!
!-- metrica inversa
!
      rmipdb(1,1) =  1.0 / cell(1)                    !  1./a
      rmipdb(1,2) =  0
      rmipdb(1,3) =  0
      rmipdb(2,1) = -cos(angoli(3)) /
     1               cell(1) * sin(angoli(3))         !  -cos(gam)/(a*sin(gam))
      rmipdb(2,2) =  1.0 / (cell(2) * sin(angoli(3))) !  1./(b*sin(gam))
      rmipdb(2,3) =  0
      rmipdb(3,1) =  asta(1) * cos(asta(5))           !  astar*cos(bets)
      rmipdb(3,2) =  asta(2) * cos(asta(4))           !  bstar*cos(alfs)
      rmipdb(3,3) =  asta(3)                          !  cstar
!
!-- SCALE
!
      do i=1, 3
         write(nunit,1136)i,(rmipdb(j,i),j=1,3), txxx
      enddo
!
!-- ATOM / HETATM
!
      nresid = 666
      nch = 64
      iser = 0
      nCatena = -1
      do ii=1, size(model)
         if (.not.allocated(model(ii)%atoms)) cycle
         do j=1, MonomerInModel(ii)
            if (ifRemo == 1) then
                if (finsolcan(WhichSolution)%flag(ii,j) < 0) cycle
            endif
            nch = nch + 1
            nCatena = nCatena + 1
            do i=1, natsInModel(ii)
               kk = model(ii)%specie(i,j)
               if (kk == -1) cycle
               kk = kk / nzConst
               if (kk == 0) cycle
               kk = iabs(kk)
               a2 = Species(kk)(1:2)
               call ucase(a2)
               if (a2(2:2) == ' ') then
                   a2(2:2) = a2(1:1)
                   a2(1:1) = ' '
               endif
               nresid = mod(model(ii)%specie(i,j), nzConst)
               tempVet(:) = 0.0
               do l=1,3
                  do n=1,3
                     tempVet(l) = tempVet(l) + 
     *                            rmpdb(n,l) * model(ii)%atoms(n,i,j)
                  enddo
               enddo
               tempVet(4) = model(ii)%atoms(5,i,j)
               tempVet(5) = model(ii)%th_fact(i,j)
               iser = iser + 1
               catena = model(ii)%Catena(i,j)
               if (catena /= ' ') then
                   ich = ichar(catena)
                   ich = ich + nCatena
                   catena = char(ich)
               endif
               model(ii)%tipoAtomo(i,j)(4:4) = model(ii)%Alternate(i,j)
               a4a = model(ii)%tipoAtomo(i,j)
               a4b = model(ii)%tipoResiduo(i,j)
               call ucase(a4a)
               call ucase(a4b)
               if (a4a == '    ') then
                   a4a = a2
               endif
               if (a4b == '    ') then
                   a4b = 'HET'
                   a6  = 'HETATM'
               else
                   a6  = 'ATOM  '
               endif
               if (model(ii)%HETA(i,j) >= 0) then
                   if (model(ii)%HETA(i,j) == 1) then
                       a6  = 'HETATM'
                   else
                       a6  = 'ATOM  '
                   endif
               endif
               if (catena == ' ') then
                   catena = 'A'
               endif
               n = model(ii)%numResiduo(i,j)
               if (n == 0) then
                   n = i
               endif
               write(nunit,10) a6, iser, a4a, a4b, catena, n, 
     *                         tempVet(:),a2
!
!-- ANISOU
!
               if (model(ii)%bij(1,i,j) > 0.0) then
                   uij(1) = model(ii)%bij(1,i,j) * 10000.0 * BijToUij_11
                   uij(4) = model(ii)%bij(2,i,j) * 10000.0 * BijToUij_12
                   uij(5) = model(ii)%bij(3,i,j) * 10000.0 * BijToUij_13
                   uij(2) = model(ii)%bij(4,i,j) * 10000.0 * BijToUij_22
                   uij(6) = model(ii)%bij(5,i,j) * 10000.0 * BijToUij_23
                   uij(3) = model(ii)%bij(6,i,j) * 10000.0 * BijToUij_33
                   a6 = 'ANISOU'
                   write(nunit,20) a6,iser,a4a,a4b, catena, n, uij(:),a2
               endif
            enddo
         enddo
      enddo
      write(nunit,1155)
!
      return
   10 format(a,i5,2x,2a4,a1,i4,4x,3f8.3,2f6.2,10x,a2)
 1110 format('HEADER',4x,18a4)
 1111 format('HEADER',4x,a)
 1130 format('CRYST1',3f9.3,3f7.2,1x,a,i4)
 1135 format('ORIGX',i1,4x,3f10.6,f15.5)
 1136 format('SCALE',i1,4x,3f10.6,f15.5)
 1155 format('END')
   20 format(a,i5,2x,2a4,a1,i4,2x,6i7,6x,a2)
!
      return
      end
!----------------------------------------------------------------------
      subroutine AssegnaIntensita
      USE General, only : no
      USE RemoModule
!
      implicit none
      integer :: i, j, nats
!
      nats = natsInModel(WhichModel)
      do i=1, nats
         j = model(WhichModel)%specie(i,1)
         if (j > 0) then
             model(WhichModel)%atoms(4,i,1) = no(j)
         else
             model(WhichModel)%atoms(4,i,1) = 1
         endif
      enddo
!
      return
      end
!----------------------------------------------------------------------
      subroutine PutStructureInfo(infoFromC, raggi)
      USE progtype, only: structure_info_type
      USE General, only:nk,nw,no,cell,radii
      USE Symmetry,only:nSpaceG,icent,nSymmStrings
!
      implicit none
      type(structure_info_type)       :: infoFromC
      real                            :: raggi(18,2)
      integer                         :: i
!
      nk =  infoFromC%nspec
      cell(1:6) = infoFromC%cell
      do i=1,nk
         nw(i) = infoFromC%vspec(i)
         no(i) = infoFromC%zspec(i)
      enddo
!!      write(infoFromC%spaceg,'(16a1)')nSpaceG
!
      icent = infoFromC%icent
      nSymmStrings = infoFromC%nsymmstr
!
      do i=1, 18
         radii(i, 1) = raggi (i, 1)
         radii(i, 2) = raggi (i, 2)
      enddo
!
      end subroutine PutStructureInfo

!-----------------------------------------------------------------------
      subroutine ResettaSpecie()
      USE General, only:nk,nw,no,Species
!
      nk = 0
      nw(:) = 0
      no(:) = 0
      Species(1:4)(:) = '    '
!
      end subroutine ResettaSpecie
!-----------------------------------------------------------------------
      subroutine PutSpeciesInfoOld(nkC, nwC, noC, radiiC, SpeciesC)
      USE General, only:nk,nw,no,radii,Species
!
      implicit none
      integer           :: nkC, nwC(18), noC(18), i
      real              :: radiiC(18, 2)
      character(len= 4) :: SpeciesC(18)
!
      nk = nkC
      nw(:) = nwC
      no(:) = noC
      do i= 1, nk
         radii(i,1:2) = radiiC(i, 1:2)
      enddo
      Species(:) = SpeciesC
!
      end subroutine PutSpeciesInfoOld
!-----------------------------------------------------------------------
      subroutine PutSpeciesInfo(nkC, nwC, noC, radiiC, stSpec)
      USE General, only:nk,nw,no,radii,Species
!
      implicit none
      integer           :: nkC, nwC(18), noC(18), i
      real              :: radiiC(18, 2)
      type StructSpecies
         character(len= 4) :: SpeciesC(18)
      end type
      type(StructSpecies)  stSpec
!
      nk = nkC
      nw(:) = nwC
      no(:) = noC
      do i= 1, nk
         radii(i,1:2) = radiiC(i, 1:2)
      enddo
      Species(:) = stSpec%SpeciesC
!
      end subroutine PutSpeciesInfo
!-----------------------------------------------------------------------
      subroutine CaricaBondTable()
!
      USE ilmviewmod
      call ilmview_load_bond_table()
!
      end subroutine CaricaBondTable
!-----------------------------------------------------------------------
      subroutine GetAu(km, atomiC, legamiC, infosC)
!
      USE connect_mod
      USE atom_type_util
      USE ilmviewmod
      USE model_util
!
      implicit none
      integer :: km, nat, nleg
      type(atom_type), dimension(:), allocatable     :: atomi
      type(bond_type), dimension(:), allocatable     :: legami
      type(symminfo_type), dimension(:), allocatable :: infos
      type(atom_type), dimension(*)                  :: atomiC
      type(bond_type), dimension(*)                  :: legamiC
      type(symminfo_type), dimension(*)              :: infosC
!
      nat = numatomtype(modelview(km)%at)
      nleg = numbonds(modelview(km)%leg)
      call model_get(modelview(km), atomi, legami, symm=infos)
      atomiC(1:nat) = atomi
      infosC(1:nat) = infos
      legamiC(1:nleg) = legami
!
      end subroutine GetAu
!-----------------------------------------------------------------------
      subroutine PutAu(km, atomiC, legamiC, infosC, nat, nleg)
!
      USE connect_mod
      USE atom_type_util
      USE ilmviewmod
      USE model_util
      USE molpnew
!
      implicit none
      integer :: km, nat, nleg, klevel
      type(atom_type), dimension(:), allocatable     :: atomi
      type(bond_type), dimension(:), allocatable     :: legami
      type(symminfo_type), dimension(:), allocatable :: infos
      type(atom_type), dimension(*)                  :: atomiC
      type(bond_type), dimension(*)                  :: legamiC
      type(symminfo_type), dimension(*)              :: infosC
      real, dimension(3)                             :: klevelv
      integer                                        :: kfitopt
!
      Allocate(atomi(1:nat))
      Allocate(infos(1:nat))
      Allocate(legami(1:nleg))
      atomi(1:nat) = atomiC(1:nat)
      infos(1:nat) = infosC(1:nat)
      legami(1:nleg) = legamiC(1:nleg)
      call model_set(modelview(km), atomi, legami, symm=infos)
      if (is_packing(km)) then    ! packing
!!         klevel = ilmview_info(5, km)
!!         call apply_symmetry_old(modelview(km)%at,modelviews(km)%at,
!!   *     modelview(km)%leg,modelviews(km)%leg,
!!   *     infos=modelviews(km)%symm,level=klevel)
           call get_packing_info(klevelv, kfitopt, km)
           call apply_symmetry(modelview(km)%at,modelviews(km)%at,
     *       modelview(km)%leg,modelviews(km)%leg,
     *       infos=modelviews(km)%symm,level=klevelv,fitopt=kfitopt)

       endif
!
      end subroutine PutAu
!-----------------------------------------------------------------------
      subroutine calljavs()
!
      USE ilmviewmod
      USE RemoModule
      implicit none
      integer        :: which
!
      call ilmview_open()
      do which=1, numbModels
         call jav_redraw(which,0)
      enddo
!
      end subroutine calljavs
!-----------------------------------------------------------------------
      subroutine jav_import_model(filename,ier)
      USE ilmviewmod
      USE importexport
      USE atom_type_util
      USE fileutil
      USE General, only: celem
      USE RemoModule
      USE pdb_frm
      character(len=*), intent(in) :: filename
      integer, intent(out)         :: ier
      integer                      :: kmodel
      integer                      :: tipo
      integer                      :: i, j, natom
      type(pdb_atom_info_type), dimension(:), allocatable :: atom_info
      type(secondary_struct_type), dimension(:), 
     *                             allocatable :: sec_struct
      integer :: nsec
      character (len=1) :: Catena, Secondary
!
      tipo = code_fragfilen(filename)
!
!     Poichè l'import può cambiare il contenuto salvo il puntatore al file xen per ogni modello
      do i=1,num_models
         modelview(i)%at(:)%nz = pxen_from_nz(modelview(i)%at(:)%nz)
      enddo
!
      num_models = num_models + 1
      kmodel = num_models
!
      if (tipo == 2) then
          call import_structure(filename,tipo,modelview(kmodel)%at,
     *                      modelview(kmodel)%leg,.true.,ier,atom_info,
     *                      nsec,sec_struct)
!!NEW mr
          if (ier /= 0) then
              num_models = num_models - 1
              kmodel = num_models
              return
          endif
!!End NEW
          Model(kmodel)%PDB = 1
          natom = size(modelview(kmodel)%at)
          allocate (model(kmodel)%HETA(natom,1), stat = ier)
          allocate (model(kmodel)%Secondary(natom,1), stat = ier)
          do i = 1, natom
             model(kmodel)%HETA(i,1) = 0
             if (atom_info(i)%atype == 'H') then
                 model(kmodel)%HETA(i,1) = 1
             endif
          enddo
          Model(kmodel)%Secondary(:,1) = ' '
          if(nsec > 0) then
             do j=1, nsec         
                if (sec_struct(j)%init_chain_id /= ' ') then
                    Catena = sec_struct(j)%init_chain_id
                else
                    Catena = 'A'
                endif
                Secondary = sec_struct(j)%stype
                n1 = sec_struct(j)%init_seq_num
                n2 = sec_struct(j)%end_seq_num
                do i=1, natom
                   if (atom_info(i)%chain_id /= Catena) cycle
                   if (atom_info(i)%res_seq >= n1 .and.
     *                 atom_info(i)%res_seq <= n2) then
                       Model(kmodel)%Secondary(i,1) = Secondary
                endif
             enddo
             enddo
          endif
      else
          call import_structure(filename,tipo,modelview(kmodel)%at,
     *                      modelview(kmodel)%leg,.true.,ier)
!!NEW mr
          if (ier /= 0) then
              num_models = num_models - 1
              kmodel = num_models
              return
!!End NEW
          endif
      endif
!
      do i=1,num_models-1     ! ricostruisco l'nz
         modelview(i)%at(:)%nz=nz_from_pxen(modelview(i)%at(:)%nz,celem)
      enddo
      do i=1,num_models
         modelview(i)%at(:)%inte = atomic_number( modelview(i)%at)
      enddo
      if (ier == 0) then
          if (.not.jav_opened()) then
              call ilmview_open()
          endif
          call jav_redraw(kmodel)
          call jav_set_name(filename, kmodel)
      else
          num_models = num_models - 1
      endif
!
      end subroutine jav_import_model

!-----------------------------------------------------------------------
