#include <jav.h>
#include <glext.h>
#include <int_main.h>
//#include <gtkdefs.h>
#include <forlink.h>
#include <models.h>
#include <maps.h>
#include <callbacks.h>
#include <jav_cb.h>
#include <gtkmrcomune.h>
#include <list>

#define prg_files_dir   "javdir"
#define program_ico     "mr-jav"
//#define program_ico     "jav16.ico"
static char *LastRunFile;
const char *Pfont();

extern "C" void calljavs_();
extern "C" void caricabondtable_();
extern "C" void ilmv_();
extern "C" void elica_(char *filnam, int idum);
extern "C" void peaksearch_(int *wm, int *wmd, float *lev, int *ifNegMap, int *flag);
extern "C" void viewoutputfile_();
extern "C" float getspinfo_(_SpeciesInfo *info);
extern "C" float putcellsy_(float cell[6], _SymmInfo *sy);
extern "C" float putspinfo_(int *which, _SpeciesInfo *info, int *nats,
                            int *nats_au, int *nlegs_au, int *ifPDB,
                            int *ifProtein, 
                            float rad[MAX_SPECIES][2], int spec[MAX_SPECIES]);
extern "C" int ccp4_liberr_verbosity(int iverb);
extern "C" void putstructureinfo_(structure_info_type *StructInfo, float rad[2][MAX_SPECIES]);
//extern "C" void putmodelinfo_(int *whichModel);
extern "C" void getau_(int *j, atom_type atomi[], f_bond_type legami[],
                       symm_info_type infos[]);
extern "C" void putau_(int *j, atom_type atomi[], f_bond_type legami[],
                       symm_info_type infos[], int *nat, int *nleg);

static GdkColor colorWhite = {0, 65535, 65535, 65535};

enum {opt_TITLE, opt_COLOR, opt_LABELS, opt_CELL, opt_STYLE, opt_HELP,
      opt_PREVIEW, opt_BLACK, opt_WHITE, opt_NOSEC, opt_DEBUG, opt_MIL,
      opt_CENTRE, opt_RADIUS, opt_POSI, opt_SIZE, N_OPTS};

static const char *numbStrings[] = 
{"Number of Coils:   ",
 "Number of Helices: ",
 "Number of Strands: ",
 "Number of Turns:   "};

extern PangoFontDescription *fontdescN, *fontdescP, *fontdescU;
void GetSpgAndCell(float abcvet[], int *ier, int *ktest, const char *filspg);

namespace GLextmr {
                    bool   ifDebug;
                    bool   ilmilione;
                    extern bool   noSecondary;
                    extern bool   PreviewMode;
                    bool   ifPreviousRun;
                    extern int ifSmooth;
                    float  sc_bonds0 = 0.7f; //1.f;
                    extern double minSigma; // = 0.0001;
                    extern int    numDigits; // = 4;
                    extern int defaultPlotStyle;
                    extern int defaultCell;
                    extern int defaultLabels;
                    extern int defaultColor;
                    extern GLfloat Range;
                    extern GLfloat sc_factor;
                    extern float  raggioMappa; // = 5.f;
                    extern float  centroMappa[3]; // = {0.f, 0.f, 0.f};
                    extern bool   defCentro; // = false;
                    extern std::string defaultTitle;
                    extern std::string BufferName;
                    extern Model *ModelInfo; //[5];
                    extern Mappa *MapInfo;   //[5];
                    extern Mappa *VWSurface;   //[5];
                    extern std::vector<Legenda> Legend;
                    extern GtkWidget *GLWINDOW;
                    extern GLuint  iTexture[8];
                    void sync_radios();
                    void fillInfo_for_map(GtkWidget *parent, int kmap);
                    float H[4][NKNOTS-2];
                    int   nknots;
                    void LoadTextureFile(const char *szFilename, Texture *pTexture);
                    void PassaModello (atom_type *atml,
                         f_bond_type *legm,
                   int *nats, int *nats_au, int *nlegs, int *nlegs_au,
                   float raggi[][MAX_SPECIES],
                   symm_info_type *info, int *nmodels, int *which,
                   int *ifPdb, char *name, bool *ifNewModel, int *het);

void LoadGLTextures()
{
  const char *textfiles[] = {"splash_front.png", "splash_back.png",
                             "splash_top.png", "splash_bottom.png",
                             "splash_right.png", "splash_left.png"};
  for(int i=0; i<6; i++)
  {
  // Load Texture
     Texture *TextureImage = g_new0(Texture, 1);
     LoadTextureFile(textfiles[i], TextureImage);
     glGenTextures(1, &(iTexture[i]));
     glBindTexture(GL_TEXTURE_2D, iTexture[i]);
     glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
     glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
     glTexImage2D(GL_TEXTURE_2D, 0, TextureImage->n_channels, TextureImage->ulDimensionX, TextureImage->ulDimensionY, 0, TextureImage->format, GL_UNSIGNED_BYTE, TextureImage->pcData);
     if (TextureImage)                      // If Texture Exists
     {
       if (TextureImage->pcData)            // If Texture Image Exists
         g_free(TextureImage->pcData);        // Free The Texture Image Memory
       g_free(TextureImage);                  // Free The Image Structure
     }
  }
}

void SetLastRun(GtkWidget *w, bool flag)
{
  gpointer cb = get_object(w, "Last Run");
  if(cb != NULL)
     obj_set_sensitive(cb, flag);
//  gtk_widget_hide(cb);            // Last Run not visible
}

size_t GLWindow::truesize()
{
    return (sizeof(*this) - sizeof(DistAng_vet)) ;
}

void GLWindow::freeStructs()
{
   if(!nModels)
      return;
   for(int k=0; k<nModels; k++)
       for(int i=0; i<ModelInfo[k].nats; i++)
           ModelInfo[k].atm[i].drawLabel = 0;
   DistAng_vet.clear();
}

bool GLWindow::Restore()
{
    std::string strfn = LastRunFile;
    if(!Restore(strfn, true))
       return false;
    if(ifDebug)
       g_print("Restore last run from: %s %s\n", getPWD(), strfn.c_str());
    return true;
}

void GLWindow::Save()
{
    std::string strfn = LastRunFile;
    Save(strfn, true);
    if(ifDebug)
       g_print("Save last run in: %s %s\n", getPWD(), strfn.c_str());
}

bool GLWindow::Restore(std::string &strfn, bool binary)
{
//    if(!GTK_IS_WIDGET(Widget))
//       g_print("non va bene\n");
//    else
//       g_print("widget ok\n");
    GtkWidget *true_wid = Widget;
    std::ifstream f;
    GLfloat oldRange;
    vet3 oldObjpos;
    char lung[6];
    size_t toread = truesize();
    if(open_project(strfn.c_str(), f))
    {
      g_print ("Could not open file: %s\n",strfn.c_str());
      return false;
    }
    else
    {
      size_t nsz = read_project(f, static_cast<char*>(static_cast<void*>(&Range)), sizeof(Range));
      sc_factor = 1.f/Range;
      oldRange = Range;
      nsz = read_project(f, static_cast<char*>(static_cast<void*>(this)), toread);
      if( nsz!=toread )
      {
        g_print ("Could not read file: %s\n",strfn.c_str());
        return false;
      }
      Widget = true_wid;
      read_project(f, lung, sizeof(lung));
      int l = atoi(lung);
      if((l < 0) || (l>=(int)MaxLenFilename))
         return false;
      char *nome = g_new0(char, l+1);
      read_project(f, nome, l+1);
      fontname = DuplicaStringa(nome);
      g_free(nome);
      MRVectorCopy(obj_pos, &oldObjpos);
      if(!RestoreLegends(f))
           return false;
      if(nModels)
         putcellsy_(Cell, &(sy));
      if(!RestoreModels(f))
           return false;
      if(!RestoreSurfaces(f))
           return false;
      if(!RestoreMaps(f))
           return false;
    }
    SetLastRun(GLWINDOW, false);
    int retval = 0;
    if(!GTK_IS_WIDGET(Widget))
       return false;
    g_signal_emit_by_name(G_OBJECT(Widget), "configure-event", NULL, &retval);
    ResetProjectionMatrix(oldRange);
    sync_radios();
    aggiornaMenuSym();
    RiNormalizza();
    MRVectorCopy(oldObjpos, &obj_pos);
    SetBgColor(false);
    Redraw();
    update_modify_menu();
    return true;
}

void GLWindow::Save(std::string &strfn, bool binary) 
{
    std::ofstream fil;
    char lung[6];

    size_t towrite = truesize();
    freeStructs();
    fil.open(strfn.c_str(), std::ios::binary|std::ios::out);
    if( !fil || !fil.is_open() )
      g_print ("Could not save file: %s\n",strfn.c_str());

    fil.write(static_cast<const char*>(static_cast<const void*>(&Range)), sizeof(Range));
    fil.write(static_cast<const char*>(static_cast<const void*>(this)), towrite);
    ScriviStringa(lung, 6, "%5.5d", (int) strlen(fontname));
    fil.write(lung,6);
    fil.write(static_cast<const char*>(fontname), strlen(fontname)+1);

    SaveLegends(fil);
    SaveModels(fil);
    SaveSurfaces(fil);
    SaveMaps(fil);
    fil.close();
}

bool GLWindow::Restore(std::string &strfn)
{
#if 0
    bool errore = false;
    char *dum;
    size_t idum;
    GLfloat OldRange, OldObjpos[3];
    FILE *fp = fOpen(strfn.c_str(), "r");
    if( !fp)
    {
       g_print ("Could not read file: %s\n",strfn.c_str());
       return false;
    }
    int val;
    for(int j=0; j<3; j++)
    {
        fscanf_s(fp, "%d", &val);
        lightInfo[j].enabled = (val != 0);
        for(int i=0; i<4; i++)
            fscanf_s(fp, "%g", &lightInfo[j].diffuse[i]);
        for(int i=0; i<4; i++)
            fscanf_s(fp, "%g", &lightInfo[j].specular[i]);
        for(int i=0; i<4; i++)
            fscanf_s(fp, "%g", &lightInfo[j].position[i]);
    }
    char eol[10];
    fscanf_s(fp, "%d %d %d", &sy.nsymop, &sy.latt, &sy.icent);
    dum = fgets(eol, 10, fp);
    if(dum == NULL)
      g_print("No EOL\n");
    idum = fread(sy.spg, sizeof(char), 16, fp);
    if((int)idum != 16)
       g_print("spacelen %d\n", (int) idum);
    dum = fgets(eol, 10, fp);

    fscanf_s(fp, "%d", &val);
    CenterOnMap = (val != 0);
    fscanf_s(fp, "%d", &val);
    Clip = (val != 0);
    fscanf_s(fp, "%d", &val);
    DrawCenter = (val != 0);
    fscanf_s(fp, "%d", &val);
    ShowLegend = (val != 0);
    fscanf_s(fp, "%d", &val);
    ShowMultBonds = (val != 0);
    fscanf_s(fp, "%d", &val);
    ShowTb = (val != 0);
    fscanf_s(fp, "%d", &val);
    Stereo = (val != 0);
    fscanf_s(fp, "%d", &val);
    fog = (val != 0);
    fscanf_s(fp, "%d", &val);
    ifCell = (val != 0);
    fscanf_s(fp, "%d", &val);
    ifDrawPar = (val != 0);
    fscanf_s(fp, "%d", &val);
    ifGrid = (val != 0);
    fscanf_s(fp, "%d", &val);
    ifOrtho = (val != 0);
    fscanf_s(fp, "%d", &val);
    ifWhole = (val != 0);
    fscanf_s(fp, "%d", &val);
    normalToV = (val != 0);

    fscanf_s(fp, "%lg", &ClipFactor);
    fscanf_s(fp, "%lg", &cylinder);
    fscanf_s(fp, "%g", &OldRange);
    sc_factor = 1.f / OldRange;
    for(int i=0; i<4; i++)
        fscanf_s(fp, "%lg", &eq0[i]);
    for(int i=0; i<4; i++)
        fscanf_s(fp, "%lg", &eq1[i]);
    fscanf_s(fp, "%lg", &sc_atoms);
    fscanf_s(fp, "%lg", &sc_bonds);
    for(int i=0; i<3; i++)
        fscanf_s(fp, "%g", &AxesColor[i]);
    for(int i=0; i<4; i++)
        fscanf_s(fp, "%g", &BgColor1[i]);
    for(int i=0; i<4; i++)
        fscanf_s(fp, "%g", &BgColor2[i]);
    for(int i=0; i<4; i++)
        fscanf_s(fp, "%g", &BgColor[i]);
    for(int i=0; i<3; i++)
        fscanf_s(fp, "%g", &CellColor[i]);
    for(int i=0; i<6; i++)
        fscanf_s(fp, "%g", &CellN[i]);
    for(int i=0; i<6; i++)
        fscanf_s(fp, "%g", &Cell[i]);
    for(int i=0; i<3; i++)
        fscanf_s(fp, "%g", &CentreColor[i]);
    for(int i=0; i<4; i++)
        fscanf_s(fp, "%g", &ColorHB[i]);
    for(int i=0; i<4; i++)
        fscanf_s(fp, "%g", &ColorSC[i]);
    for(int i=0; i<4; i++)
        fscanf_s(fp, "%g", &DistColor[i]);
    fscanf_s(fp, "%g", &FogDensity);
    fscanf_s(fp, "%g", &Radius);
    for(int i=0; i<16; i++)
        fscanf_s(fp, "%g", &RotB[i]);
    for(int i=0; i<4; i++)
        for(int j=0; j<4; j++)
            fscanf_s(fp, "%g", &Rotm[i][j]);
    fscanf_s(fp, "%g", &Scale);
    for(int i=0; i<8; i++)
        for(int j=0; j<3; j++)
            fscanf_s(fp, "%g", &VertParN[i].v[j]);
    for(int i=0; i<8; i++)
        for(int j=0; j<3; j++)
            fscanf_s(fp, "%g", &VertPar[i].v[j]);
    for(int j=0; j<3; j++)
        fscanf_s(fp, "%g", &abcPar.v[j]);
    fscanf_s(fp, "%g", &aspectRatio);
    fscanf_s(fp, "%g", &deltav);
    for(int i=0; i<3; i++)
    {
        fscanf_s(fp, "%g", &obj_pos[i]);
        OldObjpos[i] = obj_pos[i];
    }
    for(int i=0; i<3; i++)
        for(int j=0; j<3; j++)
            fscanf_s(fp, "%g", &rmC.m[3*i+j]);
    for(int i=0; i<3; i++)
        for(int j=0; j<3; j++)
            fscanf_s(fp, "%g", &rmI.m[3*i+j]);
    for(int j=0; j<=N_ELEMENTS; j++)
            fscanf_s(fp, "%g", &scale_atoms[j]);
    for(int i=0; i<8; i++)
        for(int j=0; j<3; j++)
            fscanf_s(fp, "%g", &vcN[i].v[j]);
    for(int i=0; i<8; i++)
        for(int j=0; j<3; j++)
            fscanf_s(fp, "%g", &vc[i].v[j]);
    for(int i=0; i<4; i++)
        fscanf_s(fp, "%g", &view_quat[i]);
    for(int i=0; i<4; i++)
        fscanf_s(fp, "%g", &view_quat_diff[i]);
    for(int i=0; i<3; i++)
        fscanf_s(fp, "%g", &Xd.v[i]);
    fscanf_s(fp, "%g", &xmax);
    fscanf_s(fp, "%g", &xmin);
    fscanf_s(fp, "%g", &xoffset);
    for(int i=0; i<3; i++)
        fscanf_s(fp, "%g", &xyzC.v[i]);
    for(int i=0; i<4; i++)
        for(int j=0; j<3; j++)
            fscanf_s(fp, "%g", &xyzsN[i].v[j]);
    fscanf_s(fp, "%g", &ymax);
    fscanf_s(fp, "%g", &ymin);
    fscanf_s(fp, "%g", &yoffset);
    fscanf_s(fp, "%g", &zmax);
    fscanf_s(fp, "%g", &zmin);

    fscanf_s(fp, "%d", &BgType);
    fscanf_s(fp, "%d", &GridPattern);
    fscanf_s(fp, "%d", &Height);
    for(int i=0; i<(MAX_NUM_MODELS*MAX_SPECIES); i++)
        fscanf_s(fp, "%d", &ListaSpecies[i]);
    fscanf_s(fp, "%d", &NSpecies);
    fscanf_s(fp, "%d", &Normalized);
    fscanf_s(fp, "%d", &Width);
    fscanf_s(fp, "%d", &Xstart);
    fscanf_s(fp, "%d", &Ystart);
    fscanf_s(fp, "%d", &activeLegend);
    fscanf_s(fp, "%d", &activeMap);
    fscanf_s(fp, "%d", &border);
    fscanf_s(fp, "%d", &ell_tr);
    fscanf_s(fp, "%d", &glasses_type);
    fscanf_s(fp, "%d", &ifAxes);
    fscanf_s(fp, "%d", &ifDelHang);
    fscanf_s(fp, "%d", &ifDrawAxes);
    fscanf_s(fp, "%d", &ifGrow);
    fscanf_s(fp, "%d", &ifHBonds);
    fscanf_s(fp, "%d", &ifShortc);
    fscanf_s(fp, "%d", &inModify);
    fscanf_s(fp, "%d", &nDivisions);
    fscanf_s(fp, "%d", &nLegends);
    fscanf_s(fp, "%d", &nMaps);
    fscanf_s(fp, "%d", &nModels);
    fscanf_s(fp, "%d", &smooth);
    fscanf_s(fp, "%d", &subdivisions);
    for(int i=0; i<MAX_NUM_MAPS; i++)
        fscanf_s(fp, "%d", &usedC[i]);

    int l;
    fscanf_s(fp, "%d", &l);
    if(l <= 0)
       return false;
    fontname = g_new0(char, l+1);
    dum = fgets(eol, 10, fp);
    idum = fread(fontname, sizeof(char), l, fp);
    if((int)idum != l)
         g_print("fontname %d\n", (int) idum);
    dum = fgets(eol, 10, fp);
    for(int i=0; i<3;i++)
        OldObjpos[i] = obj_pos[i];

    RestoreLegends(fp);
    putcellsy_(Cell, &(sy));
    RestoreModels(fp);
    if(!RestoreSurfaces(fp))
       errore = true;
    if(!RestoreMaps(fp))
       errore = true;
    fclose(fp);
    if(errore)
       return false;
    SetLastRun(GLWINDOW, false);
    int retval = 0;
    g_signal_emit_by_name(G_OBJECT(Widget), "configure-event", NULL, &retval);
    ResetProjectionMatrix(OldRange);
    sync_radios();
    aggiornaMenuSym();
    RiNormalizza();
    for(int i=0; i<3;i++)
        obj_pos[i] = OldObjpos[i];
    SetBgColor(false);
    Redraw();
    update_modify_menu();
#endif
    return true;
}

void GLWindow::Save(std::string &strfn)
{
#if 0
    freeStructs();
    FILE *fp = fOpen(strfn.c_str(), "w");
    if( !fp)
    {
       g_print ("Could not save file: %s\n",strfn.c_str());
       return;
    }
    for(int j=0; j<3; j++)
    {
        fprintf(fp, "%d\n", lightInfo[j].enabled?1:0);
        for(int i=0; i<4; i++)
            fprintf(fp, "%g\n", lightInfo[j].diffuse[i]);
        for(int i=0; i<4; i++)
            fprintf(fp, "%g\n", lightInfo[j].specular[i]);
        for(int i=0; i<4; i++)
            fprintf(fp, "%g\n", lightInfo[j].position[i]);
    }
    fprintf(fp, "%d %d %d\n", sy.nsymop, sy.latt, sy.icent);
    fprintf(fp, "%s\n", sy.spg);

    fprintf(fp, "%d\n", CenterOnMap?1:0);
    fprintf(fp, "%d\n", Clip?1:0);
    fprintf(fp, "%d\n", DrawCenter?1:0);
    fprintf(fp, "%d\n", ShowLegend?1:0);
    fprintf(fp, "%d\n", ShowMultBonds?1:0);
    fprintf(fp, "%d\n", ShowTb?1:0);
    fprintf(fp, "%d\n", Stereo?1:0);
    fprintf(fp, "%d\n", fog?1:0);
    fprintf(fp, "%d\n", ifCell?1:0);
    fprintf(fp, "%d\n", ifDrawPar?1:0);
    fprintf(fp, "%d\n", ifGrid?1:0);
    fprintf(fp, "%d\n", ifOrtho?1:0);
    fprintf(fp, "%d\n", ifWhole?1:0);
    fprintf(fp, "%d\n", normalToV?1:0);
    fprintf(fp, "%g\n", ClipFactor);
    fprintf(fp, "%g\n", cylinder);
    fprintf(fp, "%g\n", Range);
    for(int i=0; i<4; i++)
        fprintf(fp, "%g\n", eq0[i]);
    for(int i=0; i<4; i++)
        fprintf(fp, "%g\n", eq1[i]);
    fprintf(fp, "%g\n", sc_atoms);
    fprintf(fp, "%g\n", sc_bonds);
    for(int i=0; i<3; i++)
        fprintf(fp, "%g\n", AxesColor[i]);
    for(int i=0; i<4; i++)
        fprintf(fp, "%g\n", BgColor1[i]);
    for(int i=0; i<4; i++)
        fprintf(fp, "%g\n", BgColor2[i]);
    for(int i=0; i<4; i++)
        fprintf(fp, "%g\n", BgColor[i]);
    for(int i=0; i<3; i++)
        fprintf(fp, "%g\n", CellColor[i]);
    for(int i=0; i<6; i++)
        fprintf(fp, "%g\n", CellN[i]);
    for(int i=0; i<6; i++)
        fprintf(fp, "%g\n", Cell[i]);
    for(int i=0; i<3; i++)
        fprintf(fp, "%g\n", CentreColor[i]);
    for(int i=0; i<4; i++)
        fprintf(fp, "%g\n", ColorHB[i]);
    for(int i=0; i<4; i++)
        fprintf(fp, "%g\n", ColorSC[i]);
    for(int i=0; i<4; i++)
        fprintf(fp, "%g\n", DistColor[i]);
    fprintf(fp, "%g\n", FogDensity);
    fprintf(fp, "%g\n", Radius);
    for(int i=0; i<16; i++)
        fprintf(fp, "%g\n", RotB[i]);
    for(int i=0; i<4; i++)
        for(int j=0; j<4; j++)
            fprintf(fp, "%g\n", Rotm[i][j]);
    fprintf(fp, "%g\n", Scale);
    for(int i=0; i<8; i++)
        for(int j=0; j<3; j++)
            fprintf(fp, "%g\n", VertParN[i][j]);
    for(int i=0; i<8; i++)
        for(int j=0; j<3; j++)
            fprintf(fp, "%g\n", VertPar[i][j]);
    for(int j=0; j<3; j++)
        fprintf(fp, "%g\n", abcPar[j]);
    fprintf(fp, "%g\n", aspectRatio);
    fprintf(fp, "%g\n", deltav);
    for(int i=0; i<3; i++)
        fprintf(fp, "%g\n", obj_pos[i]);
    for(int i=0; i<3; i++)
        for(int j=0; j<3; j++)
            fprintf(fp, "%g\n", rmC[i][j]);
    for(int i=0; i<3; i++)
        for(int j=0; j<3; j++)
            fprintf(fp, "%g\n", rmI[i][j]);
    for(int i=0; i<=N_ELEMENTS; i++)
        fprintf(fp, "%g\n", scale_atoms[i]);
    for(int i=0; i<8; i++)
        for(int j=0; j<3; j++)
            fprintf(fp, "%g\n", vcN[i][j]);
    for(int i=0; i<8; i++)
        for(int j=0; j<3; j++)
            fprintf(fp, "%g\n", vc[i][j]);
    for(int i=0; i<4; i++)
        fprintf(fp, "%g\n", view_quat[i]);
    for(int i=0; i<4; i++)
        fprintf(fp, "%g\n", view_quat_diff[i]);
    for(int i=0; i<3; i++)
        fprintf(fp, "%g\n", xd[i]);
    fprintf(fp, "%g\n", xmax);
    fprintf(fp, "%g\n", xmin);
    fprintf(fp, "%g\n", xoffset);
    for(int i=0; i<3; i++)
        fprintf(fp, "%g\n", xyzC[i]);
    for(int i=0; i<4; i++)
        for(int j=0; j<3; j++)
            fprintf(fp, "%g\n", xyzsN[i][j]);
    fprintf(fp, "%g\n", ymax);
    fprintf(fp, "%g\n", ymin);
    fprintf(fp, "%g\n", yoffset);
    fprintf(fp, "%g\n", zmax);
    fprintf(fp, "%g\n", zmin);

    fprintf(fp, "%d\n", BgType);
    fprintf(fp, "%d\n", GridPattern);
    fprintf(fp, "%d\n", Height);
    for(int i=0; i<(MAX_NUM_MODELS*MAX_SPECIES); i++)
        fprintf(fp, "%d\n", ListaSpecies[i]);
    fprintf(fp, "%d\n", NSpecies);
    fprintf(fp, "%d\n", Normalized);
    fprintf(fp, "%d\n", Width);
    fprintf(fp, "%d\n", Xstart);
    fprintf(fp, "%d\n", Ystart);
    fprintf(fp, "%d\n", activeLegend);
    fprintf(fp, "%d\n", activeMap);
    fprintf(fp, "%d\n", border);
    fprintf(fp, "%d\n", ell_tr);
    fprintf(fp, "%d\n", glasses_type);
    fprintf(fp, "%d\n", ifAxes);
    fprintf(fp, "%d\n", ifDelHang);
    fprintf(fp, "%d\n", ifDrawAxes);
    fprintf(fp, "%d\n", ifGrow);
    fprintf(fp, "%d\n", ifHBonds);
    fprintf(fp, "%d\n", ifShortc);
    fprintf(fp, "%d\n", inModify);
    fprintf(fp, "%d\n", nDivisions);
    fprintf(fp, "%d\n", nLegends);
    fprintf(fp, "%d\n", nMaps);
    fprintf(fp, "%d\n", nModels);
    fprintf(fp, "%d\n", smooth);
    fprintf(fp, "%d\n", subdivisions);
    for(int i=0; i<MAX_NUM_MAPS; i++)
        fprintf(fp, "%d\n", usedC[i]);

    fprintf(fp, "%d\n", (int) strlen(fontname));
    fprintf(fp, "%s\n", fontname);
    SaveLegends(fp);
    SaveModels(fp);
    SaveSurfaces(fp);
    SaveMaps(fp);
    fclose(fp);
#endif
}

void GLWindow::SaveMaps(std::ofstream &f)
{
    for(int i=0; i<nMaps; i++)
    {
        int mk = i;
        for(int ik=0; ik<MapInfo[i].ifDifference; ik++)
        {
            MapInfo[mk].Save(f);
            mk += MAX_NUM_MAPS;
        }
    }
}

void GLWindow::SaveSurfaces(std::ofstream &f)
{
    for(int i=0; i<nModels; i++)
    {
        if(ModelInfo[i].Surface_c)
            VWSurface[i].Save(f);
    }
}

bool GLWindow::RestoreMaps(std::ifstream &f)
{
    for(int i=0; i<nMaps; i++)
    {
//        MapInfo[i] = Mappa(i);
        MapInfo[i].Restore(f);
        if(MapInfo[i].ifDifference > 1)
        {
//            MapInfo[i+MAX_NUM_MAPS] = Mappa();
            if(!MapInfo[i+MAX_NUM_MAPS].Restore(f))
               return false;
        }
    }
    GtkWidget *entry = get_widget(GLWINDOW, "box_Sigma");
    if(entry)
       gtk_widget_set_sensitive(entry, nMaps);

    RunMCAll();
    RipassaMappe();
    UpdateTitle();
    return true;
}

bool GLWindow::RestoreSurfaces(std::ifstream &f)
{
    int k = 0;
    for(int i=0; i<nModels; i++)
    {
        if(ModelInfo[i].Surface_c)
        {
           VWSurface[i].Restore(f);
           k++;
        }
    }
    if(k)
       RunMCAll();
    return true;
}

void GLWindow::SaveMaps(FILE *f)
{
    for(int i=0; i<nMaps; i++)
    {
        int mk = i;
        for(int ik=0; ik<MapInfo[i].ifDifference; ik++)
        {
            MapInfo[mk].Save(f);
            mk += MAX_NUM_MAPS;
        }
    }
}

void GLWindow::SaveSurfaces(FILE *f)
{
    for(int i=0; i<nModels; i++)
    {
        if(ModelInfo[i].Surface_c)
            VWSurface[i].Save(f);
    }
}

bool GLWindow::RestoreMaps(FILE *f)
{
    for(int i=0; i<nMaps; i++)
    {
//        MapInfo[i] = Mappa();
        if(!MapInfo[i].Restore(f))
            return false;
        if(MapInfo[i].ifDifference > 1)
        {
//            MapInfo[i+MAX_NUM_MAPS] = Mappa();
            MapInfo[i+MAX_NUM_MAPS].Restore(f);
        }
    }
    GtkWidget *entry = get_widget(GLWINDOW, "box_Sigma");
    if(entry)
       gtk_widget_set_sensitive(entry, nMaps);

    RunMCAll();
    RipassaMappe();
    UpdateTitle();
    return true;
}

bool GLWindow::RestoreSurfaces(FILE *f)
{
    int k = 0;
    for(int i=0; i<nModels; i++)
    {
        if(ModelInfo[i].Surface_c)
        {
           VWSurface[i].Restore(f);
           k++;
        }
    }
    if(k)
       RunMCAll();
    return true;
}

size_t Mappa::truesize()
{
    return(sizeof(*this) -sizeof(mc) - 3*sizeof(long));
}

void Mappa::Save(std::ofstream &fil)
{
    char lung[6];
    fil.write(static_cast<const char*>(static_cast<const void*>(this)), truesize());
    ScriviStringa(lung, 6, "%5.5d", (int) (int) strlen(name));
    fil.write(lung,6);
    fil.write(static_cast<const char*>(name), strlen(name)+1);
    fil.write(static_cast<const char*>(static_cast<const void*>(mappa)), size_x*size_y*size_z*sizeof(myreal));
    fil.write(static_cast<const char*>(static_cast<const void*>(color)), size_x*size_y*size_z*sizeof(int));
}

bool Mappa::Restore(std::ifstream &f)
{
    char lung[6];
    read_project(f, static_cast<char*>(static_cast<void*>(this)), truesize());

    read_project(f, lung, sizeof(lung));
    int l = atoi(lung);
    if((l > 0) && (l<(int)MaxLenFilename))
    {
         char *nome = g_new0(char, l+1);
         read_project(f, nome, l+1);
         name = DuplicaStringa(nome);
         g_free(nome);
    }
    else
        return false;
    if ((size_x*size_y*size_z) > 0)
    {
       mappa = g_new0(myreal, size_x*size_y*size_z);
       read_project(f, static_cast<char*>(static_cast<void*>(mappa)), size_x*size_y*size_z*sizeof(myreal));
       color = g_new0(int, size_x*size_y*size_z);
       read_project(f, static_cast<char*>(static_cast<void*>(color)), size_x*size_y*size_z*sizeof(int));
       mc = new MarchingCubes();
       mc->set_resolution( size_x, size_y, size_z );
       mc->init_all();
       return true;
    }
    else
        return false;
}

void Mappa::Save(FILE *fp)
{
#if 0
    const char *formato;
    if(sizeof(myreal) == sizeof(double))
       formato = "%lg\n";
    else
       formato = "%g\n";
    fprintf(fp, "%d\n", ifVis?1:0);
    fprintf(fp, "%d\n", (int) strlen(name));
    fprintf(fp, "%s\n", name);
    fprintf(fp, formato, maximum);
    fprintf(fp, formato, mean);
    fprintf(fp, formato, minimum);
    for(int i=0; i<4; i++)
        fprintf(fp, "%g\n", color_mappa[i]);
    fprintf(fp, formato, iso);
    for(int i=0; i<4; i++)
        fprintf(fp, "%g\n", mat_emission[i]);
    fprintf(fp, "%g\n", resm);
    fprintf(fp, "%g\n", shininess);
    fprintf(fp, formato, sigma);
    fprintf(fp, formato, sigmaMax);
    for(int i=0; i<8; i++)
        for(int j=0; j<3; j++)
            fprintf(fp, "%g\n", vf[i][j]); 
    for(int i=0; i<8; i++)
        for(int j=0; j<3; j++)
            fprintf(fp, "%g\n", vmN[i][j]);
    for(int i=0; i<8; i++)
        for(int j=0; j<3; j++)
            fprintf(fp, "%g\n", vn[i][j]); 
    for(int j=0; j<3; j++)
        fprintf(fp, "%g\n", vnN[j]);
    fprintf(fp, "%d\n", cx);
    fprintf(fp, "%d\n", cy);
    fprintf(fp, "%d\n", cz);
    fprintf(fp, "%d\n", ifDifference);
    fprintf(fp, "%d\n", nrefl);
    fprintf(fp, "%d\n", nsym);
//    fprintf(fp, "%d\n", radius);
    fprintf(fp, "%d\n", radius_x);
    fprintf(fp, "%d\n", radius_y);
    fprintf(fp, "%d\n", radius_z);
    fprintf(fp, "%d\n", size_m);
    fprintf(fp, "%d\n", size_M);
    fprintf(fp, "%d\n", size_x);
    fprintf(fp, "%d\n", size_y);
    fprintf(fp, "%d\n", size_z);
    fprintf(fp, "%d\n", wireframe);
    fprintf(fp, "%d\n",  created?1:0);
    fprintf(fp, "%d\n",  isSurface?1:0);
    fprintf(fp, "%d\n",  multicolor?1:0);
    fprintf(fp, "%f\n", radius);
    fprintf(fp, "%f\n", step);
    for(int i=0; i<size_x*size_y*size_z; i++)
        fprintf(fp, formato, mappa[i]);
    for(int i=0; i<size_x*size_y*size_z; i++)
        fprintf(fp, "%d\n", color[i]);
#endif
}

bool Mappa::Restore(FILE *fp)
{
#if 0
  try {
    int val, l;
    char eol[10], *dum;
    size_t idum;
    const char *formato;
    if(sizeof(myreal) == sizeof(double))
       formato = "%lg";
    else
       formato = "%g";
    fscanf_s(fp, "%d", &val);
    ifVis = (val != 0);
    fscanf_s(fp, "%d", &l);
    if((l<0) || (l>=(int)MaxLenFilename))
      return false;
    name = g_new0(char, l+1);
    dum = fgets(eol, 10, fp);
    idum = fread(name, sizeof(char), l, fp);
    if((int)idum != l)
       g_print("namelen %d\n", (int) idum);
    dum = fgets(eol, 10, fp);
    if(dum == NULL)
       g_print("No EOL\n");
    fscanf_s(fp, formato, &maximum);
    fscanf_s(fp, formato, &mean);
    fscanf_s(fp, formato, &minimum);
    for(int i=0; i<4; i++)
        fscanf_s(fp, "%g", &color_mappa[i]);
    fscanf_s(fp, formato, &iso);
    for(int i=0; i<4; i++)
        fscanf_s(fp, "%g", &mat_emission[i]);
    fscanf_s(fp, "%g", &resm);
    fscanf_s(fp, "%g", &shininess);
    fscanf_s(fp, formato, &sigma);
    fscanf_s(fp, formato, &sigmaMax);
    for(int i=0; i<8; i++)
        for(int j=0; j<3; j++)
            fscanf_s(fp, "%g", &vf[i][j]); 
    for(int i=0; i<8; i++)
        for(int j=0; j<3; j++)
            fscanf_s(fp, "%g", &vmN[i][j]);
    for(int i=0; i<8; i++)
        for(int j=0; j<3; j++)
            fscanf_s(fp, "%g", &vn[i][j]); 
    for(int j=0; j<3; j++)
        fscanf_s(fp, "%g", &vnN[j]);
    fscanf_s(fp, "%d", &cx);
    fscanf_s(fp, "%d", &cy);
    fscanf_s(fp, "%d", &cz);
    fscanf_s(fp, "%d", &ifDifference);
    fscanf_s(fp, "%d", &nrefl);
    fscanf_s(fp, "%d", &nsym);
    fscanf_s(fp, "%d", &radius_x);
    fscanf_s(fp, "%d", &radius_y);
    fscanf_s(fp, "%d", &radius_z);
    fscanf_s(fp, "%d", &size_m);
    fscanf_s(fp, "%d", &size_M);
    fscanf_s(fp, "%d", &size_x);
    fscanf_s(fp, "%d", &size_y);
    fscanf_s(fp, "%d", &size_z);
    fscanf_s(fp, "%d", &wireframe);
    fscanf_s(fp, "%d",  &val);
    created = (val != 0);
    fscanf_s(fp, "%d",  &val);
    isSurface = (val != 0);
    fscanf_s(fp, "%d",  &val);
    multicolor = (val != 0);
    fscanf_s(fp, "%f", &radius);
    fscanf_s(fp, "%f", &step);
    if ((size_x*size_y*size_z) <= 0)
      return false;
    mappa = g_new0(myreal, size_x*size_y*size_z);
    for(int i=0; i<size_x*size_y*size_z; i++)
        fscanf_s(fp, formato, &mappa[i]);
    color = g_new0(int, size_x*size_y*size_z);
    for(int i=0; i<size_x*size_y*size_z; i++)
        fscanf_s(fp, "%d", &color[i]);
    mc = new MarchingCubes();
    mc->set_resolution( size_x, size_y, size_z );
    mc->init_all();
    return true;
  }
  catch(...)
  {
    return false;
  }
#else
    return true;
#endif
}

void GLWindow::SaveModels(std::ofstream &f)
{
    for(int i=0; i<nModels; i++)
    {
        ModelInfo[i].Save(f);
        ModelInfo[i].SaveAU(f, i);
    }
}

void GLWindow::SaveModels(FILE *fp)
{
    for(int i=0; i<nModels; i++)
    {
        ModelInfo[i].Save(fp);
        ModelInfo[i].SaveAU(fp, i);
    }
}

bool GLWindow::RestoreModels(std::ifstream &f)
{
    for(int i=0; i<nModels; i++)
    {
        ModelInfo[i] = Model();
        if(!ModelInfo[i].Restore(f, this))
           return false;
        ModelInfo[i].RestoreAU(f, i);
    }
    RipassaModelli();
//    update_modify_menu();
    return true;
}

bool GLWindow::RestoreModels(FILE *f)
{
    for(int i=0; i<nModels; i++)
    {
        ModelInfo[i] = Model();
        if(!ModelInfo[i].Restore(f, this))
           return false;
        ModelInfo[i].RestoreAU(f, i);
    }
    RipassaModelli();
//   update_modify_menu();
    return true;
}

void Model::SaveAU(std::ofstream &fil, int i)
{
    atom_type *atomi;
    symm_info_type *infos;
    f_bond_type *legami;

    atomi = g_new0(atom_type,  nats_au);
    infos = g_new0(symm_info_type,  nats_au);
    legami = g_new0(f_bond_type,  nlegs_au);
    int j = i + 1;
    getau_(&j, atomi, legami, infos);
    if(nats_au > 0)
    {
       fil.write(static_cast<const char*>(static_cast<const void*>(atomi)), nats_au*sizeof(atom_type));
       fil.write(static_cast<const char*>(static_cast<const void*>(infos)), nats_au*sizeof(symm_info_type));
    }
    if(nlegs_au > 0)
       fil.write(static_cast<const char*>(static_cast<const void*>(legami)), nlegs_au*sizeof(f_bond_type));
    g_free(atomi);
    g_free(legami);
    g_free(infos);
}

void Model::Save(std::ofstream &fil)
{
    char lung[6];
    size_t towrite = truesize();
    freeStructs(true);
    fil.write(static_cast<const char*>(static_cast<const void*>(this)), towrite);
    char *nome = g_path_get_basename(modname);
    if(str_white(nome))
      nome = g_strdup(modname);
    ScriviStringa(lung, 6, "%5.5d", (int) strlen(nome));
    fil.write(lung,6);
    fil.write(static_cast<const char*>(nome), strlen(nome)+1);
    if(nats_au > 0)
    {
       fil.write(static_cast<const char*>(static_cast<const void*>(atm)), nats*sizeof(jav_atom_type));
       fil.write(static_cast<const char*>(static_cast<const void*>(iEqui)), nats*sizeof(int));
       fil.write(static_cast<const char*>(static_cast<const void*>(Secondary)), nats*sizeof(char));
    }
    if(nconn_prot > 0)
       fil.write(static_cast<const char*>(static_cast<const void*>(bonds)), nconn_prot*sizeof(jav_bond_type));
    if(nconn_bb > 0)
       fil.write(static_cast<const char*>(static_cast<const void*>(bonds_bb)), nconn_bb*sizeof(jav_bond_type));
    if(nconn_ca > 0)
       fil.write(static_cast<const char*>(static_cast<const void*>(bonds_ca)), nconn_ca*sizeof(jav_bond_type));
    if(nconn_lig > 0)
       fil.write(static_cast<const char*>(static_cast<const void*>(bonds_lig)), nconn_lig*sizeof(jav_bond_type));
    if(nlegsH > 0)
       fil.write(static_cast<const char*>(static_cast<const void*>(legsH)), nlegsH*sizeof(jav_bond_type));
    if(nlegsW > 0)
       fil.write(static_cast<const char*>(static_cast<const void*>(legsW)), nlegsW*sizeof(jav_bond_type));
    if(nPoly > 0)
       fil.write(static_cast<const char*>(static_cast<const void*>(Polyhedra)), nPoly*sizeof(polyhedron_type));
    if(nPolyStyles > 0)
       fil.write(static_cast<const char*>(static_cast<const void*>(PolyStyle)), nPolyStyles*sizeof(polyhedron_style));
    freeVectors(true);
}

//size_t Model::truesize()
//{
//    return (sizeof(*this) - sizeof(Chains) - sizeof(c_alpha) - sizeof(c_alphab)
//            - sizeof(atoms_sel) - sizeof(bonds_sel) -sizeof(resid_sel) 
//            - sizeof(phlist) -sizeof(atom_types) -sizeof(AtomTypes)
//            -sizeof(Conns) -sizeof(Equivs));
//}

void Model::SaveAU(FILE *fp, int i)
{
#if 0
    atom_type *atomi;
    symm_info_type *infos;
    f_bond_type *legami;

    atomi = g_new0(atom_type,  nats_au);
    infos = g_new0(symm_info_type,  nats_au);
    legami = g_new0(f_bond_type,  nlegs_au);
    int j = i + 1;
    getau_(&j, atomi, legami, infos);
    if(nats_au > 0)
    {
       for(int k=0; k<nats_au; k++)
       {
           for(int i=0; i<3; i++)
               fprintf(fp, "%g\n", atomi[k].xc[i]);
           fprintf(fp, "%g\n", atomi[k].biso);
           for(int i=0; i<6; i++)
               fprintf(fp, "%g\n", atomi[k].bij[i]);
           fprintf(fp, "%g\n", atomi[k].och);
           fprintf(fp, "%g\n", atomi[k].ocry);
           fprintf(fp, "%g\n", atomi[k].inte);
           fprintf(fp, "%d\n", atomi[k].nz);
           fprintf(fp, "%d\n", (int) strlen(atomi[k].lab));
           fprintf(fp, "%s\n", atomi[k].lab);
           for(int i=0; i<5; i++)
               fprintf(fp, "%d\n", atomi[k].rcod[i]);
       }
       for(int k=0; k<nats_au; k++)
           fprintf(fp, "%d %d %d\n", infos[k].asym, infos[k].oper,
                   infos[k].opcode);
    }
    if(nlegs_au > 0)
    {
       for(int i=0; i<nlegs_au; i++)
       {
           fprintf(fp, "%d %d\n", legami[i].n1, legami[i].n2);
           fprintf(fp, "%g %g\n", legami[i].dist, legami[i].sigma);
       }
    }
    g_free(atomi);
    g_free(legami);
    g_free(infos);
#endif
}

void Model::Save(FILE *fp)
{   
#if 0
    freeStructs(true);

    for(int i=0; i<MAX_SPECIES; i++)
    {
        for(int j=0; j<4; j++)
            fprintf(fp, "%c", info.Species[i][j]);
        fprintf(fp, "\n");
    }
    fprintf(fp, "%d\n",  info.nk);
    for(int i=0; i<NUM_COLORS; i++)
        for(int j=0; j<4; j++)
            fprintf(fp, "%g\n", light_diffuse[i][j]);

    fprintf(fp, "%d\n",  Surface_c?1:0);
    fprintf(fp, "%d\n",  created?1:0);
    fprintf(fp, "%d\n",  hasSecondary?1:0);
    fprintf(fp, "%d\n",  ifCentro?1:0);
    fprintf(fp, "%d\n",  ifChangedSymmetry?1:0);
    fprintf(fp, "%d\n",  ifDrawH?1:0);
    fprintf(fp, "%d\n",  ifDrawW?1:0);
    fprintf(fp, "%d\n",  ifLabels?1:0);
    fprintf(fp, "%d\n",  ifPoly?1:0);
    fprintf(fp, "%d\n",  ifResize?1:0);
    fprintf(fp, "%d\n",  ifSurface?1:0);
    fprintf(fp, "%d\n",  ifSymmetry?1:0);
    fprintf(fp, "%d\n",  ifVis?1:0);
    fprintf(fp, "%d\n",  isPDB?1:0);
    fprintf(fp, "%g %g\n",  Bmin, Bmax);
    fprintf(fp, "%g %g\n",  Bmin_ca, Bmax_ca);
    fprintf(fp, "%g\n",  RF);
    for(int i=0; i<3; i++)
        fprintf(fp, "%g\n",  baricentro[i]);
    for(int i=0; i<NHDistances; i++)
        fprintf(fp, "%g\n",  distHn[i]);
    for(int i=0; i<4; i++)
        fprintf(fp, "%g\n",  labelcolor[i]);
    for(int i=0; i<4; i++)
        fprintf(fp, "%g\n",  light_chain[i]);
    for(int i=0; i<3; i++)
        fprintf(fp, "%g\n",  maxRad[i]);
    fprintf(fp, "%g\n",  radMax);
    for(int i=0; i<MAX_SPECIES; i++)
        fprintf(fp, "%g %g\n",  radii[i][0], radii[i][1]);
    fprintf(fp, "%g\n",  shininess);

    for(int i=0; i<MAX_SPECIES; i++)
    {
        fprintf(fp, "%d\n",  Content[i]);
        fprintf(fp, "%d\n",  Species[i]);
    }
    fprintf(fp, "%d\n",  FitOpt);
    fprintf(fp, "%d\n",  colorMode);
    fprintf(fp, "%d\n",  drawLigand);
    for(int i=0; i<3; i++)
        fprintf(fp, "%g\n",  klevel[i]);
    fprintf(fp, "%d\n",  labelType);
    fprintf(fp, "%d\n",  nChains);
    fprintf(fp, "%d\n",  nModello);
    fprintf(fp, "%d %d\n",  nPoly, nPolyStyles);
    fprintf(fp, "%d\n",  nResAmino);
    fprintf(fp, "%d\n",  nResTot);
    fprintf(fp, "%d\n",  nangbonds);
    fprintf(fp, "%d\n",  nats);
    fprintf(fp, "%d\n",  nats_au);
    fprintf(fp, "%d\n",  nconn);
    fprintf(fp, "%d\n",  nconn_bb);
    fprintf(fp, "%d\n",  nconn_ca);
    fprintf(fp, "%d\n",  nconn_lig);
    fprintf(fp, "%d\n",  nconn_mix);
    fprintf(fp, "%d\n",  nconn_nuc);
    fprintf(fp, "%d\n",  nconn_prot);
    fprintf(fp, "%d %d\n",  nlegsH, nlegsW);
    fprintf(fp, "%d\n",  nlegs_au);
    fprintf(fp, "%d\n",  notLabelH);
    fprintf(fp, "%d\n",  ntorsions);
    fprintf(fp, "%d\n",  nucleic);
    fprintf(fp, "%d\n",  numSpec);
    fprintf(fp, "%d\n",  numT);
    for(int i=0; i<4; i++)
        fprintf(fp, "%d\n",  numbStructs[i]);
    fprintf(fp, "%d\n",  plotStyle);

    char *nome = g_path_get_basename(modname);
    if(str_white(nome))
      nome = g_strdup(modname);
    fprintf(fp, "%d\n", (int) strlen(nome));
    fprintf(fp, "%s\n", nome);
    for(int k=0; k<nats; k++)
    {
        fprintf(fp, "%d\n", atm[k].color);
        fprintf(fp, "%d\n", atm[k].Z);
        fprintf(fp, "%d\n", atm[k].oper);
        fprintf(fp, "%d\n", atm[k].opcode);
        fprintf(fp, "%d\n", atm[k].seq);
        fprintf(fp, "%d\n", atm[k].numResiduo);
        fprintf(fp, "%d\n", atm[k].ResNum);
        fprintf(fp, "%d\n", atm[k].catena);
        fprintf(fp, "%d\n", atm[k].catseq);
        fprintf(fp, "%d\n", atm[k].resseq);
        for(int i=0; i<3; i++)
            fprintf(fp, "%g\n", atm[k].xyzc[i]);
        for(int i=0; i<3; i++)
            fprintf(fp, "%g\n", atm[k].xyz[i]);
        for(int i=0; i<3; i++)
            fprintf(fp, "%g\n", atm[k].xyzN[i]);
        for(int i=0; i<3; i++)
            fprintf(fp, "%g\n", atm[k].vn[i]);
        fprintf(fp, "%d\n", atm[k].disegnato);
        for(int i=0; i<3; i++)
            fprintf(fp, "%g\n", atm[k].radN[i]);
        fprintf(fp, "%d\n", atm[k].drawLabel);
        fprintf(fp, "%g\n", atm[k].ocry);
        fprintf(fp, "%g\n", atm[k].och);
        fprintf(fp, "%g\n", atm[k].B);
        for(int i=0; i<6; i++)
            fprintf(fp, "%g\n", atm[k].Bij[i]);
        for(int i=0; i<4; i++)
            for(int j=0; j<4; j++)
                fprintf(fp, "%g\n", atm[k].mat[i][j]);
        for(int i=0; i<4; i++)
            fprintf(fp, "%g\n", atm[k].scala[i]);
        fprintf(fp, "%g\n", atm[k].semin);
        fprintf(fp, "%g\n", atm[k].seminN);
        fprintf(fp, "%g\n", atm[k].H);
        fprintf(fp, "%d\n", atm[k].deleted?1:0);
        fprintf(fp, "%d\n", atm[k].isW?1:0);
        fprintf(fp, "%d\n", atm[k].selected?1:0);
        fprintf(fp, "%d\n", atm[k].hidden?1:0);
        fprintf(fp, "%d\n", atm[k].heta);
        fprintf(fp, "%d\n", (int) strlen(atm[k].lab));
        fprintf(fp, "%s\n", atm[k].lab);
        fprintf(fp, "%d\n", iEqui[k]);
    }
    fprintf(fp, "%d\n", (int) strlen(Secondary));
    fprintf(fp, "%s\n", Secondary);
    for(int i=0; i<nconn; i++)
    {
        fprintf(fp, "%d %d\n", bonds[i].n1, bonds[i].n2);
        fprintf(fp, "%g %g\n", bonds[i].dist, bonds[i].sigma);
        fprintf(fp, "%d\n", bonds[i].selected?1:0);
        fprintf(fp, "%d\n", bonds[i].ordleg);
    }
    for(int i=0; i<nlegsH; i++)
    {
        fprintf(fp, "%d %d\n", legsH[i].n1, legsH[i].n2);
        fprintf(fp, "%g %g\n", legsH[i].dist, legsH[i].sigma);
        fprintf(fp, "%d\n", legsH[i].selected?1:0);
        fprintf(fp, "%d\n", legsH[i].ordleg);
    }
    for(int i=0; i<nlegsW; i++)
    {
        fprintf(fp, "%d %d\n", legsW[i].n1, legsW[i].n2);
        fprintf(fp, "%g %g\n", legsW[i].dist, legsW[i].sigma);
        fprintf(fp, "%d\n", legsW[i].selected?1:0);
        fprintf(fp, "%d\n", legsW[i].ordleg);
    }
    if(nPoly > 0)
    {
       for(int i=0;i <nPoly; i++)
       {
           fprintf(fp, "%d\n", Polyhedra[i].nvert);
           fprintf(fp, "%d\n", Polyhedra[i].xc);
           for(int j=0;j<8; j++)
               fprintf(fp, "%d %d %d\n", Polyhedra[i].face[j].n1,
                       Polyhedra[i].face[j].n2, Polyhedra[i].face[j].n3);
       }
    }  
    if(nPolyStyles > 0)
    {  
       for(int i=0;i <nPolyStyles; i++)
       {
           fprintf(fp, "%d\n", PolyStyle[i].visible?1:0);
           fprintf(fp, "%d\n", PolyStyle[i].transparency);
           fprintf(fp, "%d\n", PolyStyle[i].ifBorder?1:0);
           for(int j=0;j<4; j++)
               fprintf(fp, "%g %g\n", PolyStyle[i].colore[j],
                  PolyStyle[i].Bcolore[j]);
           fprintf(fp, "%g\n", PolyStyle[i].line_width);
           fprintf(fp, "%d\n", PolyStyle[i].vert);
       }
    }  

    freeVectors(true);
#endif
}

void Model::RestoreAU(std::ifstream &f, int i)
{
    atom_type *atomi;
    symm_info_type *infos;
    f_bond_type *legami;

    atomi = g_new0(atom_type,  nats_au);
    infos = g_new0(symm_info_type,  nats_au);
    legami = g_new0(f_bond_type,  nlegs_au);
    int j = i + 1;
    if(nats_au > 0)
    {
       read_project(f, static_cast<char*>(static_cast<void*>(atomi)), nats_au*sizeof(atom_type));
       read_project(f, static_cast<char*>(static_cast<void*>(infos)), nats_au*sizeof(symm_info_type));
    }
    if(nlegs_au > 0)
       read_project(f, static_cast<char*>(static_cast<void*>(legami)), nlegs_au*sizeof(f_bond_type));
    putau_(&j, atomi, legami, infos, &nats_au, &nlegs_au);
    g_free(atomi);
    g_free(legami);
    g_free(infos);
}

bool Model::Restore(std::ifstream &f, GLWindow *gl)
{
    char lung[6];
    size_t toread = truesize();
    read_project(f, static_cast<char*>(static_cast<void*>(this)), toread);
    freeVectors(false);
    read_project(f, lung, sizeof(lung));
    int l = atoi(lung);
    if((l < 0) || (l>=(int)MaxLenFilename))
       return false;
    char *nome = g_new0(char, l+1);
    read_project(f, nome, l+1);
    modname = DuplicaStringa(nome);
    g_free(nome);
    if(nats > 0)
    {
       atm = g_new0(jav_atom_type, nats);
       iEqui = g_new0(int, nats);
       Secondary = g_new0(char, nats);
       read_project(f, static_cast<char*>(static_cast<void*>(atm)), nats*sizeof(jav_atom_type));
       read_project(f, static_cast<char*>(static_cast<void*>(iEqui)), nats*sizeof(int));
       read_project(f, static_cast<char*>(static_cast<void*>(Secondary)), nats*sizeof(char));
    }
    for(int i=0; i<nats; i++)
    {
        if(atm[i].selected)
           atoms_sel.push_back(i+1);
    }
    if(nconn_prot > 0)
    {
       bonds = g_new0(jav_bond_type, nconn_prot);
       read_project(f, static_cast<char*>(static_cast<void*>(bonds)), nconn_prot*sizeof(jav_bond_type));
    }
    if(nconn_bb > 0)
    {
       bonds_bb = g_new0(jav_bond_type, nconn_bb);
       read_project(f, static_cast<char*>(static_cast<void*>(bonds_bb)), nconn_bb*sizeof(jav_bond_type));
    }
    if(nconn_ca > 0)
    {
       bonds_ca = g_new0(jav_bond_type, nconn_ca);
       read_project(f, static_cast<char*>(static_cast<void*>(bonds_ca)), nconn_ca*sizeof(jav_bond_type));
    }
    if(nconn_lig > 0)
    {
       bonds_lig = g_new0(jav_bond_type, nconn_lig);
       read_project(f, static_cast<char*>(static_cast<void*>(bonds_lig)), nconn_lig*sizeof(jav_bond_type));
    }
    if(nlegsH > 0)
    {
       legsH = g_new0(jav_bond_type, nlegsH);
       read_project(f, static_cast<char*>(static_cast<void*>(legsH)), nlegsH*sizeof(jav_bond_type));
    }
    if(nlegsW > 0)
    {
       legsW = g_new0(jav_bond_type, nlegsH);
       read_project(f, static_cast<char*>(static_cast<void*>(legsW)), nlegsW*sizeof(jav_bond_type));
    }
    if(nPoly > 0)
    {
       Polyhedra = g_new0(polyhedron_type, nPoly);
       read_project(f, static_cast<char*>(static_cast<void*>(Polyhedra)), nPoly*sizeof(polyhedron_type));
    }
    if(nPolyStyles > 0)
    {
       PolyStyle = g_new0(polyhedron_style, nPolyStyles);
       read_project(f, static_cast<char*>(static_cast<void*>(PolyStyle)), nPolyStyles*sizeof(polyhedron_style));
    }

    for(int i=0; i<nconn_prot; i++)
    {
        if(bonds[i].selected)
           bonds_sel.push_back(i+1);
    }
    PreparaEllissoidi(gl);
    GetEquivs();
    if(isPDB)
    {
       std::string msg;
       int ier = PreparaTabelle(msg);
       if(ier < 0)
          return false;
       for(int i=0; i<(int) c_alphab.size(); i++)
       {
           if(c_alphab[i].selected)
              resid_sel.push_back(i+1);
       }
    }
    return true;
}

void Model::RestoreAU(FILE *fp, int i)
{
    atom_type *atomi;
    symm_info_type *infos;
    f_bond_type *legami;
    char eol[10];

    atomi = g_new0(atom_type,  nats_au);
    infos = g_new0(symm_info_type,  nats_au);
    legami = g_new0(f_bond_type,  nlegs_au);
    int j = i + 1;
    int l;
    for(int k=0; k<nats_au; k++)
    {
        for(int i=0; i<3; i++)
            fscanf_s(fp, "%g", &atomi[k].xc[i]);
        fscanf_s(fp, "%g", &atomi[k].biso);
        for(int i=0; i<6; i++)
            fscanf_s(fp, "%g", &atomi[k].bij[i]);
        fscanf_s(fp, "%g", &atomi[k].och);
        fscanf_s(fp, "%g", &atomi[k].ocry);
        fscanf_s(fp, "%g", &atomi[k].inte);
        fscanf_s(fp, "%d", &atomi[k].nz);
        fscanf_s(fp, "%d", &l);
        char *dum = fgets(eol, 10, fp);
        size_t idum = fread(atomi[k].lab, sizeof(char), l, fp);
        if((int) idum != l)
          g_print("warning labelstring\n");
        dum = fgets(eol, 10, fp);
        if(dum == NULL)
          g_print("No EOL\n");
        for(int i=0; i<5; i++)
            fscanf_s(fp, "%d", &atomi[k].rcod[i]);
    }
    for(int k=0; k<nats_au; k++)
        fscanf_s(fp, "%d %d %d", &infos[k].asym, &infos[k].oper,
                   &infos[k].opcode);
    for(int i=0; i<nlegs_au; i++)
    {
        fscanf_s(fp, "%d %d", &legami[i].n1, &legami[i].n2);
        fscanf_s(fp, "%g %g", &legami[i].dist, &legami[i].sigma);
    }
    putau_(&j, atomi, legami, infos, &nats_au, &nlegs_au);
    g_free(atomi);
    g_free(legami);
    g_free(infos);
}

bool Model::Restore(FILE *fp, GLWindow *gl)
{   
  try {
    int val, l;
    size_t idum;
    char *dum, eol[10];

    for(int i=0; i<MAX_SPECIES; i++)
    {
        for(int j=0; j<4; j++)
            fscanf_s(fp, "%c", &info.Species[i][j]);
        dum = fgets(eol, 10, fp);
    }
    fscanf_s(fp, "%d",  &info.nk);
    for(int i=0; i<NUM_COLORS; i++)
        for(int j=0; j<4; j++)
            fscanf_s(fp, "%g", &light_diffuse[i][j]);

    fscanf_s(fp, "%d",  &val);
    Surface_c = (val != 0);
    fscanf_s(fp, "%d",  &val);
    created = (val != 0);
    fscanf_s(fp, "%d",  &val);
    hasSecondary = (val != 0);
    fscanf_s(fp, "%d",  &val);
    ifCentro = (val != 0);
    fscanf_s(fp, "%d",  &val);
    ifChangedSymmetry = (val != 0);
    fscanf_s(fp, "%d",  &val);
    ifDrawH = (val != 0);
    fscanf_s(fp, "%d",  &val);
    ifDrawW = (val != 0);
    fscanf_s(fp, "%d",  &val);
    ifLabels = (val != 0);
    fscanf_s(fp, "%d",  &val);
    ifPoly = (val != 0);
    fscanf_s(fp, "%d",  &val);
    ifResize = (val != 0);
    fscanf_s(fp, "%d",  &val);
    ifSurface = (val != 0);
    fscanf_s(fp, "%d",  &val);
    ifSymmetry = (val != 0);
    fscanf_s(fp, "%d",  &val);
    ifVis = (val != 0);
    fscanf_s(fp, "%d",  &val);
    isPDB = (val != 0);
    fscanf_s(fp, "%g %g",  &Bmin, &Bmax);
    fscanf_s(fp, "%g %g",  &Bmin_ca, &Bmax_ca);
    fscanf_s(fp, "%g",  &RF);
    for(int i=0; i<3; i++)
        fscanf_s(fp, "%g",  &baricentro[i]);
    for(int i=0; i<NHDistances; i++)
        fscanf_s(fp, "%g",  &distHn[i]);
    for(int i=0; i<4; i++)
        fscanf_s(fp, "%g",  &labelcolor[i]);
    for(int i=0; i<4; i++)
        fscanf_s(fp, "%g",  &light_chain[i]);
    for(int i=0; i<3; i++)
        fscanf_s(fp, "%g",  &maxRad[i]);
    fscanf_s(fp, "%g",  &radMax);
    for(int i=0; i<MAX_SPECIES; i++)
        fscanf_s(fp, "%g %g",  &radii[i][0], &radii[i][1]);
    fscanf_s(fp, "%g",  &shininess);

    for(int i=0; i<MAX_SPECIES; i++)
    {
        fscanf_s(fp, "%d",  &Content[i]);
        fscanf_s(fp, "%d",  &Species[i]);
    }
    fscanf_s(fp, "%d",  &FitOpt);
    fscanf_s(fp, "%d",  &colorMode);
    fscanf_s(fp, "%d",  &drawLigand);
    for(int i=0; i<3; i++)
        fscanf_s(fp, "%g",  &klevel[i]);
    fscanf_s(fp, "%d",  &labelType);
    fscanf_s(fp, "%d",  &nChains);
    fscanf_s(fp, "%d",  &nModello);
    fscanf_s(fp, "%d %d",  &nPoly, &nPolyStyles);
    fscanf_s(fp, "%d",  &nResAmino);
    fscanf_s(fp, "%d",  &nResTot);
    fscanf_s(fp, "%d",  &nangbonds);
    fscanf_s(fp, "%d",  &nats);
    fscanf_s(fp, "%d",  &nats_au);
    fscanf_s(fp, "%d",  &nconn);
    fscanf_s(fp, "%d",  &nconn_bb);
    fscanf_s(fp, "%d",  &nconn_ca);
    fscanf_s(fp, "%d",  &nconn_lig);
    fscanf_s(fp, "%d",  &nconn_mix);
    fscanf_s(fp, "%d",  &nconn_nuc);
    fscanf_s(fp, "%d",  &nconn_prot);
    fscanf_s(fp, "%d %d",  &nlegsH, &nlegsW);
    fscanf_s(fp, "%d",  &nlegs_au);
    fscanf_s(fp, "%d",  &notLabelH);
    fscanf_s(fp, "%d",  &ntorsions);
    fscanf_s(fp, "%d",  &nucleic);
    fscanf_s(fp, "%d",  &numSpec);
    fscanf_s(fp, "%d",  &numT);
    for(int i=0; i<4; i++)
        fscanf_s(fp, "%d",  &numbStructs[i]);
    fscanf_s(fp, "%d",  &plotStyle);

    fscanf_s(fp, "%d", &l);
    if((l<0) || (l>=(int)MaxLenFilename))
       return false;
    modname = g_new0(char, l+1);
    dum = fgets(eol, 10, fp);
    idum = fread(modname, sizeof(char), l, fp);
    if((int)idum != l)
       g_print("namelen %d\n", (int) idum);
    dum = fgets(eol, 10, fp);
    if(dum == NULL)
          g_print("No EOL\n");
    if(nats != 0)
    {
       atm = g_new0(jav_atom_type, nats);
       iEqui = g_new0(int, nats);
       Secondary = g_new0(char, nats);
    }
    for(int k=0; k<nats; k++)
    {
        fscanf_s(fp, "%d", &atm[k].color);
        fscanf_s(fp, "%d", &atm[k].Z);
        fscanf_s(fp, "%d", &atm[k].oper);
        fscanf_s(fp, "%d", &atm[k].opcode);
        fscanf_s(fp, "%d", &atm[k].seq);
        fscanf_s(fp, "%d", &atm[k].numResiduo);
        fscanf_s(fp, "%d", &atm[k].ResNum);
        fscanf_s(fp, "%d", &atm[k].catena);
        fscanf_s(fp, "%d", &atm[k].catseq);
        fscanf_s(fp, "%d", &atm[k].resseq);
        for(int i=0; i<3; i++)
            fscanf_s(fp, "%g", &atm[k].xyzc[i]);
        for(int i=0; i<3; i++)
            fscanf_s(fp, "%g", &atm[k].xyz[i]);
        for(int i=0; i<3; i++)
            fscanf_s(fp, "%g", &atm[k].xyzN[i]);
        for(int i=0; i<3; i++)
            fscanf_s(fp, "%g", &atm[k].vn[i]);
        fscanf_s(fp, "%d", &atm[k].disegnato);
        for(int i=0; i<3; i++)
            fscanf_s(fp, "%g", &atm[k].radN[i]);
        fscanf_s(fp, "%d", &atm[k].drawLabel);
        fscanf_s(fp, "%g", &atm[k].ocry);
        fscanf_s(fp, "%g", &atm[k].och);
        fscanf_s(fp, "%g", &atm[k].B);
        for(int i=0; i<6; i++)
            fscanf_s(fp, "%g", &atm[k].Bij[i]);
        for(int i=0; i<4; i++)
            for(int j=0; j<4; j++)
                fscanf_s(fp, "%g", &atm[k].mat[i][j]);
        for(int i=0; i<4; i++)
            fscanf_s(fp, "%g", &atm[k].scala[i]);
        fscanf_s(fp, "%g", &atm[k].semin);
        fscanf_s(fp, "%g", &atm[k].seminN);
        fscanf_s(fp, "%g", &atm[k].H);
        fscanf_s(fp, "%d", &val);
        atm[k].deleted = (val != 0);
        fscanf_s(fp, "%d", &val);
        atm[k].isW = (val != 0);
        fscanf_s(fp, "%d", &val);
        atm[k].selected = (val != 0);
        fscanf_s(fp, "%d", &val);
        atm[k].hidden = (val != 0);
        fscanf_s(fp, "%d", &atm[k].heta);
        fscanf_s(fp, "%d", &l);
        dum = fgets(eol, 10, fp);
        idum = fread(atm[k].lab, sizeof(char), l, fp);
        dum = fgets(eol, 10, fp);
        fscanf_s(fp, "%d", &iEqui[k]);
    }
    fscanf_s(fp, "%d", &l);
    if(nats != 0)
    {
       dum = fgets(eol, 10, fp);
       idum = fread(Secondary, sizeof(char), l, fp);
       dum = fgets(eol, 10, fp);
    }
    if(nconn > 0)
    {
       bonds = g_new0(jav_bond_type, nconn);
       for(int i=0; i<nconn; i++)
       {
           fscanf_s(fp, "%d %d", &bonds[i].n1, &bonds[i].n2);
           fscanf_s(fp, "%g %g", &bonds[i].dist, &bonds[i].sigma);
           fscanf_s(fp, "%d", &val);
           bonds[i].selected = (val != 0);
           fscanf_s(fp, "%d", &bonds[i].ordleg);
       }
    }
    if(nlegsH > 0)
    {
       legsH = g_new0(jav_bond_type, nlegsH);
       for(int i=0; i<nlegsH; i++)
       {
           fscanf_s(fp, "%d %d", &legsH[i].n1, &legsH[i].n2);
           fscanf_s(fp, "%g %g", &legsH[i].dist, &legsH[i].sigma);
           fscanf_s(fp, "%d", &val);
           legsH[i].selected = (val != 0);
           fscanf_s(fp, "%d", &legsH[i].ordleg);
       }
    }
    if(nlegsW > 0)
    {
       legsW = g_new0(jav_bond_type, nlegsW);
       for(int i=0; i<nlegsW; i++)
       {
           fscanf_s(fp, "%d %d", &legsW[i].n1, &legsW[i].n2);
           fscanf_s(fp, "%g %g", &legsW[i].dist, &legsW[i].sigma);
           fscanf_s(fp, "%d", &val);
           legsW[i].selected = (val != 0);
           fscanf_s(fp, "%d", &legsW[i].ordleg);
       }
    }
    if(nPoly > 0)
    {
       for(int i=0;i <nPoly; i++)
       {
           fscanf_s(fp, "%d", &Polyhedra[i].nvert);
           fscanf_s(fp, "%d", &Polyhedra[i].xc);
           for(int j=0;j<8; j++)
               fscanf_s(fp, "%d %d %d", &Polyhedra[i].face[j].n1,
                       &Polyhedra[i].face[j].n2, &Polyhedra[i].face[j].n3);
       }
    }  
    if(nPolyStyles > 0)
    {  
       for(int i=0;i <nPolyStyles; i++)
       {
           fscanf_s(fp, "%d", &val);
           PolyStyle[i].visible = (val != 0);
           fscanf_s(fp, "%d", &PolyStyle[i].transparency);
           fscanf_s(fp, "%d", &val);
           PolyStyle[i].ifBorder = (val != 0);
           for(int j=0;j<4; j++)
               fscanf_s(fp, "%g %g", &PolyStyle[i].colore[j],
                  &PolyStyle[i].Bcolore[j]);
           fscanf_s(fp, "%g", &PolyStyle[i].line_width);
           fscanf_s(fp, "%d", &PolyStyle[i].vert);
       }
    }  

    PreparaEllissoidi(gl);
    GetEquivs();
    if(isPDB)
    {
       std::string msg;
       int ier = PreparaTabelle(msg);
       if(ier < 0)
          return false;
    }
    return true;
  }
  catch(...)
  {
    return false;
  }
}

void GLWindow::SaveLegends(std::ofstream &f)
{
    for(int i=0; i<nLegends; i++)
        Legend[i].Save(f);
}

void GLWindow::SaveLegends(FILE *fp)
{
    fprintf(fp, "%d\n", nLegends);
    for(int i=0; i<nLegends; i++)
        Legend[i].Save(fp);
}

bool GLWindow::RestoreLegends(FILE *f)
{
    fscanf_s(f, "%d\n", &nLegends);
    Legend.clear();
    for(int i=0; i<nLegends; i++)
    {
        Legenda leg = Legenda();
        if(!leg.Restore(f))
           return false;
        Legend.push_back(leg);
    }
    return true;
}

bool GLWindow::RestoreLegends(std::ifstream &f)
{
    Legend.clear();
    for(int i=0; i<nLegends; i++)
    {
        Legenda leg = Legenda();
        Legend.push_back(leg);
//        Legend[i] = Legenda();

        if(!Legend[i].Restore(f))
           return false;
    }
    return true;
}

bool Legenda::Restore(std::ifstream &f)
{
      read_project(f, static_cast<char*>(static_cast<void*>(this)), sizeof(*this));
      char lung_leg[6];
      read_project(f, lung_leg, sizeof(lung_leg));
      int l = atoi(lung_leg);
      if(l != -1)
      {
         char *legenda = g_new0(char, l+1);
         read_project(f, legenda, l+1);
         SetFont(legenda);
         g_free(legenda);
      }
      else
         SetFont(Pfont());
      read_project(f, lung_leg, sizeof(lung_leg));
      l = atoi(lung_leg);
      if(l != -1)
      {
         char *legenda = g_new0(char, l+1);
         read_project(f, legenda, l+1);
         SetText(legenda);
         g_free(legenda);
      }
      return true;
}

bool Legenda::Restore(FILE *fp)
{
   try
   {
      int l;
      char eol[10];
      for(int i=0; i<4; i++)
          fscanf_s(fp, "%f",  &colore[i]);
      for(int i=0; i<4; i++)
          fscanf_s(fp, "%f",  &bcolore[i]);
      fscanf_s(fp, "%d",  &(rect.x));
      fscanf_s(fp, "%d",  &(rect.y));
      fscanf_s(fp, "%d",  &(rect.width));
      fscanf_s(fp, "%d",  &(rect.height));
      fscanf_s(fp, "%d",  &xpos);
      fscanf_s(fp, "%d",  &ypos);
      fscanf_s(fp, "%d", &l);
      visible = (l != 0);
      fscanf_s(fp, "%d", &l);
      fontname = g_new0(char, l+1);
      char *dum = fgets(eol, 10, fp);
      size_t idum = fread(fontname, sizeof(char), l, fp);
      if((int)idum != l)
         g_print("fontname %d\n", (int) idum);
      dum = fgets(eol, 10, fp);
      if(dum == NULL)
        g_print("No EOL\n");
      fscanf_s(fp, "%d", &l);
      testo = g_new0(char, l+1);
      dum = fgets(eol, 10, fp);
      idum = fread(testo, sizeof(char), l, fp);
      dum = fgets(eol, 10, fp);
      return true;
   }
   catch(...)
   {
      g_print("errore in restore legend\n");
      return false;
   }
}

void Legenda::Save(std::ofstream &fil)
{
    char lung[6];
    fil.write(static_cast<const char*>(static_cast<const void*>(this)), sizeof(*this));
    ScriviStringa(lung, 6, "%5.5d", (int) strlen(fontname));
    fil.write(lung,6);
    fil.write(static_cast<const char*>(fontname), strlen(fontname)+1);
    ScriviStringa(lung, 6, "%5.5d", (int) strlen(testo));
    fil.write(lung,6);
    fil.write(static_cast<const char*>(testo), strlen(testo)+1);
}

void Legenda::Save(FILE *fp)
{
      for(int i=0; i<4; i++)
          fprintf(fp, "%f\n",  colore[i]);
      for(int i=0; i<4; i++)
          fprintf(fp, "%f\n",  bcolore[i]);
      fprintf(fp, "%d\n",  rect.x);
      fprintf(fp, "%d\n",  rect.y);
      fprintf(fp, "%d\n",  rect.width);
      fprintf(fp, "%d\n",  rect.height);
      fprintf(fp, "%d\n",  xpos);
      fprintf(fp, "%d\n",  ypos);
      fprintf(fp, "%d\n", visible?1:0);
      fprintf(fp, "%d\n", (int)strlen(fontname));
      fprintf(fp, "%s\n", fontname);
      fprintf(fp, "%d\n", (int)strlen(testo));
      fprintf(fp, "%s\n", testo);
}

#if 0
void GLWindow::DrawSplash()
{
    glDisable (GL_LIGHTING);
    glDisable(GL_CLIP_PLANE0);
    glDisable(GL_CLIP_PLANE1);
    glDisable(GL_FOG);
    glDisable(GL_BLEND);
    glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );
    glEnable (GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, iTexture[0]);     // Select Texture
    glBegin(GL_POLYGON);                                          // Front Face 
      glTexCoord2f(0.0f, 0.0f); glVertex3f(-0.7f, -0.7f,  0.7f);  // Bottom Left Of The Texture and Quad
      glTexCoord2f(1.0f, 0.0f); glVertex3f( 0.7f, -0.7f,  0.7f);  // Bottom Right Of The Texture and Quad
      glTexCoord2f(1.0f, 1.0f); glVertex3f( 0.7f,  0.7f,  0.7f);  // Top Right Of The Texture and Quad
      glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.7f,  0.7f,  0.7f);  // Top Left Of The Texture and Quad
    glEnd();

    glBindTexture(GL_TEXTURE_2D, iTexture[1]);
    glBegin(GL_POLYGON);                                          // Back Face
      glTexCoord2f(1.0f, 0.0f); glVertex3f(-0.7f, -0.7f, -0.7f);  // Bottom Right Of The Texture and Quad
      glTexCoord2f(1.0f, 1.0f); glVertex3f(-0.7f,  0.7f, -0.7f);  // Top Right Of The Texture and Quad
      glTexCoord2f(0.0f, 1.0f); glVertex3f( 0.7f,  0.7f, -0.7f);  // Top Left Of The Texture and Quad
      glTexCoord2f(0.0f, 0.0f); glVertex3f( 0.7f, -0.7f, -0.7f);  // Bottom Left Of The Texture and Quad
    glEnd();

    glBindTexture(GL_TEXTURE_2D, iTexture[2]); 
    glBegin(GL_POLYGON);                                          // Top Face
      glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.7f,  0.7f, -0.7f);  // Top Left Of The Texture and Quad
      glTexCoord2f(0.0f, 0.0f); glVertex3f(-0.7f,  0.7f,  0.7f);  // Bottom Left Of The Texture and Quad
      glTexCoord2f(1.0f, 0.0f); glVertex3f( 0.7f,  0.7f,  0.7f);  // Bottom Right Of The Texture and Quad
      glTexCoord2f(1.0f, 1.0f); glVertex3f( 0.7f,  0.7f, -0.7f);  // Top Right Of The Texture and Quad
    glEnd();

    glBindTexture(GL_TEXTURE_2D, iTexture[3]);
    glBegin(GL_POLYGON);                                          // Bottom Face
      glTexCoord2f(1.0f, 1.0f); glVertex3f(-0.7f, -0.7f, -0.7f);  // Top Right Of The Texture and Quad
      glTexCoord2f(0.0f, 1.0f); glVertex3f( 0.7f, -0.7f, -0.7f);  // Top Left Of The Texture and Quad
      glTexCoord2f(0.0f, 0.0f); glVertex3f( 0.7f, -0.7f,  0.7f);  // Bottom Left Of The Texture and Quad
      glTexCoord2f(1.0f, 0.0f); glVertex3f(-0.7f, -0.7f,  0.7f);  // Bottom Right Of The Texture and Quad
    glEnd();

    glBindTexture(GL_TEXTURE_2D, iTexture[4]);
    glBegin(GL_POLYGON);                                           // Right face
       glTexCoord2f(1.0f, 0.0f); glVertex3f( 0.7f, -0.7f, -0.7f);  // Bottom Right Of The Texture and Quad
       glTexCoord2f(1.0f, 1.0f); glVertex3f( 0.7f,  0.7f, -0.7f);  // Top Right Of The Texture and Quad
       glTexCoord2f(0.0f, 1.0f); glVertex3f( 0.7f,  0.7f,  0.7f);  // Top Left Of The Texture and Quad
       glTexCoord2f(0.0f, 0.0f); glVertex3f( 0.7f, -0.7f,  0.7f);  // Bottom Left Of The Texture and Quad
    glEnd();

    glBindTexture(GL_TEXTURE_2D, iTexture[5]);
    glBegin(GL_POLYGON);                                           // Left Face
       glTexCoord2f(0.0f, 0.0f); glVertex3f(-0.7f, -0.7f, -0.7f);  // Bottom Left Of The Texture and Quad
       glTexCoord2f(1.0f, 0.0f); glVertex3f(-0.7f, -0.7f,  0.7f);  // Bottom Right Of The Texture and Quad
       glTexCoord2f(1.0f, 1.0f); glVertex3f(-0.7f,  0.7f,  0.7f);  // Top Right Of The Texture and Quad
       glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.7f,  0.7f, -0.7f);  // Top Left Of The Texture and Quad
    glEnd();
    glDisable (GL_TEXTURE_2D);

    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);

    glPushMatrix();
    glLoadIdentity();

    PangoFontDescription *font_desc  = get_fontN(MONOSPACE_FONT, 3.0);
    pango_font_description_set_weight (font_desc, PANGO_WEIGHT_HEAVY);
    pango_font_description_set_style (font_desc, PANGO_STYLE_OBLIQUE);

    float xy[] = {-0.8f, -1.2f};
    float ico[] = {0.8392f, 0.5098f, 0.82745f};
    GtkAllocation allocation;
    gtk_widget_get_allocation(Widget, &allocation);
    int width = 3*PANGO_SCALE*allocation.width/4;
    char *testo = g_strdup_printf("Just Another Viewer - %d.%d", MY_MAJOR_VERSION(JAV_VERSION), MY_MINOR_VERSION(JAV_VERSION)); 
    DrawText(width, font_desc, PANGO_ALIGN_CENTER, ico, xy, testo, NULL);
    DrawFlag();
}
#endif
void GLWindow::DrawSplash()
{
    glDisable (GL_LIGHTING);
    glDisable(GL_CLIP_PLANE0);
    glDisable(GL_CLIP_PLANE1);
    glDisable(GL_FOG);
    glDisable(GL_BLEND);
    glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );
    glEnable (GL_TEXTURE_2D);

    glBindTexture(GL_TEXTURE_2D, iTexture[0]);     // Select Texture
    glBegin(GL_POLYGON);                                          // Front Face 
      glTexCoord2f(0.0f, 0.0f); glVertex3f(-0.7f,  0.7f,  0.7f);  // Bottom left Of The Texture and Quad
      glTexCoord2f(1.0f, 0.0f); glVertex3f( 0.7f,  0.7f,  0.7f);  // Bottom right Of The Texture and Quad
      glTexCoord2f(1.0f, 1.0f); glVertex3f( 0.7f, -0.7f,  0.7f);  // Top right Of The Texture and Quad
      glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.7f, -0.7f,  0.7f);  // Top left Of The Texture and Quad
    glEnd();

    glBindTexture(GL_TEXTURE_2D, iTexture[1]);
    glBegin(GL_POLYGON);                                          // Back Face
      glTexCoord2f(0.0f, 0.0f); glVertex3f( 0.7f,  0.7f,  -0.7f);  // Bottom Left Of The Texture and Quad
      glTexCoord2f(1.0f, 0.0f); glVertex3f(-0.7f,  0.7f,  -0.7f);  // Bottom Right Of The Texture and Quad
      glTexCoord2f(1.0f, 1.0f); glVertex3f(-0.7f, -0.7f,  -0.7f);  // Top Right Of The Texture and Quad
      glTexCoord2f(0.0f, 1.0f); glVertex3f( 0.7f, -0.7f,  -0.7f);  // Top Left Of The Texture and Quad
    glEnd();

    glBindTexture(GL_TEXTURE_2D, iTexture[2]); 
    glBegin(GL_POLYGON);                                          // Top Face
      glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.7f,  0.7f,  0.7f);  // Bottom Left Of The Texture and Quad
      glTexCoord2f(0.0f, 0.0f); glVertex3f(-0.7f,  0.7f, -0.7f);  // Top Left Of The Texture and Quad
      glTexCoord2f(1.0f, 0.0f); glVertex3f( 0.7f,  0.7f, -0.7f);  // Top Right Of The Texture and Quad
      glTexCoord2f(1.0f, 1.0f); glVertex3f( 0.7f,  0.7f,  0.7f);  // Bottom Right Of The Texture and Quad
    glEnd();

    glBindTexture(GL_TEXTURE_2D, iTexture[3]);
    glBegin(GL_POLYGON);                                          // Bottom Face
      glTexCoord2f(1.0f, 1.0f); glVertex3f( 0.7f, -0.7f, -0.7f);  // Top Left Of The Texture and Quad
      glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.7f, -0.7f, -0.7f);  // Top Right Of The Texture and Quad
      glTexCoord2f(0.0f, 0.0f); glVertex3f(-0.7f, -0.7f,  0.7f);  // Bottom Right Of The Texture and Quad
      glTexCoord2f(1.0f, 0.0f); glVertex3f( 0.7f, -0.7f,  0.7f);  // Bottom Left Of The Texture and Quad
    glEnd();

    glBindTexture(GL_TEXTURE_2D, iTexture[4]);
    glBegin(GL_POLYGON);                                           // Right face
      glTexCoord2f(0.0f, 0.0f); glVertex3f( 0.7f,  0.7f,  0.7f);  // Bottom Left Of The Texture and Quad
      glTexCoord2f(1.0f, 0.0f); glVertex3f( 0.7f,  0.7f, -0.7f);  // Bottom Right Of The Texture and Quad
      glTexCoord2f(1.0f, 1.0f); glVertex3f( 0.7f, -0.7f, -0.7f);  // Top Right Of The Texture and Quad
      glTexCoord2f(0.0f, 1.0f); glVertex3f( 0.7f, -0.7f,  0.7f);  // Top Left Of The Texture and Quad
    glEnd();

    glBindTexture(GL_TEXTURE_2D, iTexture[5]);
    glBegin(GL_POLYGON);                                           // Left Face
       glTexCoord2f(0.0f, 0.0f); glVertex3f(-0.7f,  0.7f, -0.7f);  // Bottom Right Of The Texture and Quad
       glTexCoord2f(1.0f, 0.0f); glVertex3f(-0.7f,  0.7f,  0.7f);  // Bottom Left Of The Texture and Quad
       glTexCoord2f(1.0f, 1.0f); glVertex3f(-0.7f, -0.7f,  0.7f);  // Top Left Of The Texture and Quad
       glTexCoord2f(0.0f, 1.0f); glVertex3f(-0.7f, -0.7f, -0.7f);  // Top Right Of The Texture and Quad
    glEnd();
    glDisable (GL_TEXTURE_2D);

//    glEnable(GL_DEPTH_TEST);
    glDisable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);

    glPushMatrix();
    glLoadIdentity();

    PangoFontDescription *font_desc  = get_fontN(MONOSPACE_FONT, 3.0);
    pango_font_description_set_weight (font_desc, PANGO_WEIGHT_HEAVY);
    pango_font_description_set_style (font_desc, PANGO_STYLE_OBLIQUE);

    vet3 xy = {{-0.8, -1.2, -1}};
    float ico[] = {0.8392f, 0.5098f, 0.82745f};
    GtkAllocation allocation;
    gtk_widget_get_allocation(Widget, &allocation);
    int width = 3*PANGO_SCALE*allocation.width/4;

    int w, h, ltext=25;
    get_metrics(font_desc, &w, &h);
    float rap = (float)(ltext*w) / (float) (width/PANGO_SCALE);
    if (rap > 0.9f)
    {
         gint is = pango_font_description_get_size(font_desc);
         float news = (float)is /rap * 0.8f;
         pango_font_description_set_size(font_desc, (gint) news);
    }
    char *testo = g_strdup_printf("Just Another Viewer - %d.%2.2d", MY_MAJOR_VERSION(JAV_VERSION), MY_MINOR_VERSION(JAV_VERSION)); 
    DrawText(width, font_desc, PANGO_ALIGN_CENTER, ico, xy, testo, NULL);
#if 0
    DrawFlag();
#endif
    glEnable(GL_DEPTH_TEST);
    glPopMatrix();
//    glLoadIdentity();
}

#if 0
void GLWindow::DrawSplash()
{
    static float vertices[] =  {
                                -0.7f, -0.7f,  0.7f, 
                                 0.7f, -0.7f,  0.7f,
                                -0.7f,  0.7f,  0.7f,
                                 0.7f,  0.7f,  0.7f,
    
                                 0.7f, -0.7f,  0.7f,
                                 0.7f, -0.7f, -0.7f,    		
                                 0.7f,  0.7f,  0.7f,
                                 0.7f,  0.7f, -0.7f,
    
                                -0.7f,  0.7f,  0.7f,
                                 0.7f,  0.7f,  0.7f,    		
                                -0.7f,  0.7f, -0.7f,
                                 0.7f,  0.7f, -0.7f,
    
                                -0.7f, -0.7f, -0.7f,
                                -0.7f, -0.7f,  0.7f,    		
                                -0.7f,  0.7f, -0.7f,
                                -0.7f,  0.7f,  0.7f,
    
                                -0.7f, -0.7f, -0.7f,
                                 0.7f, -0.7f, -0.7f,    		
                                -0.7f, -0.7f,  0.7f,
                                 0.7f, -0.7f,  0.7f,
    
                                 0.7f, -0.7f, -0.7f,
                                -0.7f, -0.7f, -0.7f,    		
                                 0.7f,  0.7f, -0.7f,
                                -0.7f,  0.7f, -0.7f,
                               };
    
    static float texture[] =   {    		
                                 0.0f, 0.0f,
                                 0.0f, 1.0f,
                                 1.0f, 0.0f,
                                 1.0f, 1.0f, 
    
                                 0.0f, 0.0f,
                                 0.0f, 1.0f,
                                 1.0f, 0.0f,
                                 1.0f, 1.0f,
    
                                 0.0f, 0.0f,
                                 0.0f, 1.0f,
                                 1.0f, 0.0f,
                                 1.0f, 1.0f,
    
                                 0.0f, 0.0f,
                                 0.0f, 1.0f,
                                 1.0f, 0.0f,
                                 1.0f, 1.0f,
    
                                 0.0f, 0.0f,
                                 0.0f, 1.0f,
                                 1.0f, 0.0f,
                                 1.0f, 1.0f,
    
                                 0.0f, 0.0f,
                                 0.0f, 1.0f,
                                 1.0f, 0.0f,
                                 1.0f, 1.0f
                               };
    static GLubyte indices[] = { 0,1,3, 0,3,2,
                                 4,5,7, 4,7,6,
                                 8,9,11, 8,11,10,
                                 12,13,15, 12,15,14,
                                 16,17,19, 16,19,18,
                                 20,21,23, 20,23,22
                               };
    glEnableClientState(GL_VERTEX_ARRAY);
    glEnableClientState(GL_TEXTURE_COORD_ARRAY);
    glDisable(GL_CLIP_PLANE0);
    glDisable(GL_CLIP_PLANE1);
    glDisable(GL_FOG);
    glDisable(GL_BLEND);
    glDisable(GL_LIGHTING);
    glEnable (GL_TEXTURE_2D);
    glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );
    glFrontFace(GL_CW);

    glVertexPointer(3, GL_FLOAT, 0, vertices);
    glTexCoordPointer(2, GL_FLOAT, 0, texture);
    for(int i=0; i<6; i++)
    {
        glBindTexture(GL_TEXTURE_2D, iTexture[i]);
        glDrawElements(GL_TRIANGLES, 6, GL_UNSIGNED_BYTE, &(indices[6*i]));
    }
    glDisableClientState(GL_VERTEX_ARRAY);
    glDisableClientState(GL_TEXTURE_COORD_ARRAY);
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LIGHTING);
    glDisable (GL_TEXTURE_2D);

    glPushMatrix();
    glLoadIdentity();
    PangoFontDescription *font_desc  = get_fontN(Pfont(), 4.0);
    pango_font_description_set_weight (font_desc, PANGO_WEIGHT_HEAVY);
    pango_font_description_set_style (font_desc, PANGO_STYLE_OBLIQUE);

    float xy[] = {-0.8f, -1.2f, 0.f};
    float ico[] = {0.8392f, 0.5098f, 0.82745f};
    GtkAllocation allocation;
    gtk_widget_get_allocation(Widget, &allocation);
    int width = 3*PANGO_SCALE*allocation.width/4;
    char *testo = g_strdup_printf("Just Another Viewer - %d.%2.2d",
        MY_MAJOR_VERSION(JAV_VERSION), MY_MINOR_VERSION(JAV_VERSION)); 
    DrawText(width, font_desc, PANGO_ALIGN_CENTER, ico, xy, testo, NULL);
    DrawFlag();
} 
#endif

void GLWindow::UpdateSigma()
{
         gpointer entry = get_object(GLWINDOW, "box_Sigma");
         if(entry == NULL)
            return;
         gtk_widget_set_sensitive(GTK_WIDGET(entry), TRUE);
         entry = get_object(GLWINDOW, "Sigma");
         int hnd = get_int(GTK_WIDGET(entry), "hnd");
         g_signal_handler_block(G_OBJECT(entry), hnd);
         gtk_scale_set_digits(GTK_SCALE(entry), 2); //numDigits);
         gtk_range_set_range(GTK_RANGE(entry), minSigma, MRmax(0.2, MapInfo[activeMap].sigmaMax));
         double val = MapInfo[activeMap].iso / MapInfo[activeMap].sigma;
         gtk_range_set_value(GTK_RANGE(entry), val);
         g_signal_handler_unblock(G_OBJECT(entry), hnd);
}

}     // end namespace GLextmr

namespace main_app {

static const char *desc_about =
"Just Another Viewer\n\n"
"By G.L. Cascarano, C. Cuocci and S. Maggi\n\n"
"The program uses some CCP4 (Collaborative Computer\n"
"Project 4,  Daresbury Laboratory, UK) libraries in\n"
"accordance with the CCP4 License Agreement (clause 2.1.2),\n"
"some routines from Marching Cubes \n"
" (Thomas Lewiner - Math Dept, PUC-Rio)\n"
"and FFTw (Matteo Frigo - Copyright (c) 2003 MIT).\n\n"
"The FFTw, GTK Cairo and OpenGL libraries used in the program\n"
"are distributed under the GPL (GNU General Public License).\n"
"          ";
static const char  *about_pixmap  = "javabout.png";

Application JavApp = Application("Jav", JAV_VERSION, "jav", prg_files_dir, 
                                 "viewer", 0, desc_about, about_pixmap);

void printHelp(std::ostream &os)
{
using namespace std;
    string hlpfn = g_strdup_printf( "%s%cfiles%cviewerhelp.txt",
       g_path_get_dirname(main_app::JavApp.PkgDataDir().c_str()),
       G_DIR_SEPARATOR, G_DIR_SEPARATOR);

    ifstream f1;
    f1.open(fromUTF8(hlpfn).c_str());
    if(!f1)
    {
       cerr << "Error opening input file" << hlpfn << "\n";
       return;
    }

    int MAX_LENGTH = 120;
    char *line = g_new0(char, MAX_LENGTH);
    os << JavApp.PackageName() << " " << JavApp.PackageVersion() << "\n\n";
    os << "usage: " << JavApp.PkName() << 
            " [options] file1 [file2 ...]\n";
    while( f1.getline(line, MAX_LENGTH) ) 
      os << line << endl;
    f1.close();
    g_free(line);
}

//void CalcolaH(int n, float **Hdit)
/*
void CalcolaH(int n, float Hdit[4][NKNOTS-2])
{
   float t;
   float d = 1.f/(float)(n-1);
   for(int i=1; i<n/2; i++)
   {
       t = (float) i * d;
       Hdit[0][i-1] = (1 + 2*t) * (1 - t) * (1 - t);
       Hdit[1][i-1] = t * (1 - t) * (1 - t);
       Hdit[2][i-1] = t * t * (3 - 2*t);
       Hdit[3][i-1] = t * t * (t - 1);
       t = (float) (i + n/2) * d;
       Hdit[0][i+n/2-1] = (1 + 2*t) * (1 - t) * (1 - t);
       Hdit[1][i+n/2-1] = t * (1 - t) * (1 - t);
       Hdit[2][i+n/2-1] = t * t * (3 - 2*t);
       Hdit[3][i+n/2-1] = t * t * (t - 1);
   }
   t = 0.5;
   Hdit[0][n/2-1] = (1 + 2*t) * (1 - t) * (1 - t);
   Hdit[1][n/2-1] = t * (1 - t) * (1 - t);
   Hdit[2][n/2-1] = t * t * (3 - 2*t);
   Hdit[3][n/2-1] = t * t * (t - 1);
//   for(int i=0; i<n-2; i++)
//       g_print("%d %f, %f, %f, %f\n", i+1,Hdit[0][i],Hdit[1][i], Hdit[2][i],Hdit[3][i]);
}
*/

bool GetPreviousState()
{
    std::string fn = LastRunFile;
    return(g_file_test(fn.c_str(), G_FILE_TEST_EXISTS)!= 0);
/*
    if(g_file_test(fn.c_str(), G_FILE_TEST_EXISTS))
    {
       return dlgest_yesno(NULL, "A previous run was saved. Do you want to use it?");
    }
    return false;
*/
}

int IsValidPS(std::string para)
{
    static const char *ps_string[] = 
    {"wi", "si", "bo", "ro", "sb", "te", "vw", "bb", "ca", "ri", "st", "ct"};

    for(int k=0; k<PLOT_STYLES; k++)
    {                
        if(strstr(para.c_str(), ps_string[k]))
           return k;
    }                
    return -1;
}

int IsValidCM(std::string para)
{
    static const char *cm_string[] = 
    {"sp", "tf", "oc", "sy", "mo", "re", "ch", "ss", "po"};

    for(int k=0; k<COLOR_MODES; k++)
    {
        if(strstr(para.c_str(), cm_string[k]))
           return k;
    }
    return -1;
}

int IsValidJavOption(std::string opt)
{
   static const char *options[] = {"t", "c", "l", "e", "s", "h", "p", "b", "w", 
                                   "n", "H", "M", "C", "R", "P", "S"};
   static const char *aliases[] = {"title", "color", "labels", "cell", "style",
                                   "help", "preview", "blackbg", "whitebg",
                                   "nosec", "H", "M", "centre", "radius",
                                   "posi", "size"};
   static const char *fort_opt[] = {"a", "d", "D"};
   static int params[]          = { 5, 4, 3, 2, 1, 10, 10, 0, 10,
                                    0, 0, 0, 7, 6, 8, 9};

   std::string::size_type i1 =  opt.find_first_of("=");
   std::string trueopt = strstrip(opt);
   if(i1 != std::string::npos)
      trueopt = opt.substr(0, i1);
   int valid = -1;
   for (int i=0; i<N_OPTS; i++)
   {
       if(strcmp(trueopt.c_str(), options[i]) == 0)
       {
          valid = i*100 + params[i];
          break;
       }
   }
   if(valid != -1)
      return valid;
   for (int i=0; i<N_OPTS; i++)
   {
       if(strcmp(trueopt.c_str(), aliases[i]) == 0)
       {
          valid = i*100 + params[i];
          break;
       }
   }
   for (int i=0; i<(int)G_N_ELEMENTS(fort_opt); i++)
   {
       if(strcmp(trueopt.c_str(), fort_opt[i]) == 0)
       {
          valid = -(i + 10);
          break;
       }
   }
   return valid;
}

std::string getParamString(std::string param)
{
   std::string::size_type i1 =  param.find_first_of("=");
   std::string val = "";
   if(i1 != std::string::npos)
      val = param.substr(i1+1);
   return val;
}

#ifdef __cplusplus
extern "C" {
#endif
int Main (int argc, char **argv)
{
using namespace std;
using namespace GLextmr;
     int i, result = JavApp.Initialize(argc, argv);
     bool ifHelp = false;
     bool setDir = false;
     ifDebug = false;
     ilmilione = false;
     std::string LastRunFile_str = ".jav_b";
     LastRunFile_str.append(JavApp.PackageVersion());
     LastRunFile_str.append(".old");
     LastRunFile = g_strdup(LastRunFile_str.c_str());
     ccp4_liberr_verbosity(0);

     if(!result)
        return -1;
     ifSmooth = JavApp.Bestv;

     args->argc = 1;
     CopiaStringa(args->arg[0], MaxLenFilename, argv[0]);

     noSecondary = false;
     ifPreviousRun = false;

     for(i=1; i<argc; i++)  
     {
         std::string param = argv[i];
         if(argv[i][0] == '-')                // gestione opzioni
         {
            if(param.find_first_not_of("-") == std::string::npos)
               continue;
            std::string option = param.substr(param.find_first_not_of("-"));
            int Result = IsValidJavOption(option);
//            g_print("opt %s result %d\n", option.c_str(), Result);
            if(Result == -1)
               dlg_warning("Invalid option: %s", argv[i]);
            else if(Result > -1)
            {
               int opzione   = Result / 100;
               int parametro = Result % 100;
               std::string paramVal;
               if(parametro != 0)
                  paramVal = getParamString(option);
               switch(opzione)
               {
               case opt_TITLE:
                    defaultTitle = "";
                    if(!paramVal.empty())
                       defaultTitle = paramVal;
               break;
               case opt_CELL:
                    defaultCell = 0;
                    if(!paramVal.empty())
                       if(strstr(paramVal.c_str(), "on"))
                          defaultCell = 1;
               break;
               case opt_LABELS:
                    defaultLabels = 0;
                    if(!paramVal.empty())
                       if(strstr(paramVal.c_str(), "on"))
                          defaultLabels = 1;
               break;
               case opt_STYLE:
                    defaultPlotStyle = -1;
                    if(!paramVal.empty())
                       defaultPlotStyle = IsValidPS(paramVal);
               break;
               case opt_COLOR:
                    defaultColor = -1;
                    if(!paramVal.empty())
                       defaultColor = IsValidCM(paramVal);
               break;
               case opt_RADIUS:
                    if(!paramVal.empty())
                       raggioMappa = (float) atof(paramVal.c_str());
               break;
               case opt_CENTRE:
                    if(!paramVal.empty())
                       get_float_tokens(paramVal.c_str(), ",", 3, centroMappa);
               break;
               case opt_POSI:
                    {
                    int pos[2];
                    if(!paramVal.empty())
                       get_int_tokens(paramVal.c_str(), ",", 2, pos);
                    JavApp.XStart = pos[0];
                    JavApp.YStart = pos[1];
                    }
               break;
               case opt_SIZE:
                    {
                    int pos[2];
                    if(!paramVal.empty())
                       get_int_tokens(paramVal.c_str(), ",", 2, pos);
                    JavApp.Kscrx = pos[0];
                    JavApp.Kscry = pos[1];
                    }
               break;
               case opt_HELP:
                    ifHelp = true;
               break;
               case opt_DEBUG:
                    ifDebug = true;
               break;
               case opt_PREVIEW:
                    PreviewMode = true;
                    BufferName = "";
                    if(!paramVal.empty())
                       BufferName = paramVal;
               break;
               case opt_BLACK:
                    set_defbg(0);
               break;
               case opt_WHITE:
                    set_defbg(1);
               break;
               case opt_NOSEC:
                    noSecondary = true;
               break;
               case opt_MIL:
                    ilmilione = true;
               break;
               }
            }
            else if(Result < -1)
            {
               if(args->argc < APP_MAX_ARGS)
               {
                  ScriviStringa(args->arg[args->argc], MaxLenFilename, 
                    "-%s", option.c_str());
                  args->argc++;
               }
            }
         }
         else                               // filenames
         {
            CopiaStringa(args->arg[args->argc], MaxLenFilename, argv[i]);
            args->argc++;
         }
     }
     if(ifDebug)
     {
        g_print("start jav\n");
        for(int k=0; k<argc;k++)
            g_print("'%s'\n", argv[k]);
     }

     for(i=1; i<argc; i++)
     {
         if(argv[i][0] != '-')
         {
            dir_set_current( g_path_get_dirname(argv[i]) );
            if(ifDebug)
               g_print("curdir %s\n", g_path_get_dirname(argv[i]));
            setDir = true;
            break;
         }
     }
     nknots = NKNOTS;

     if(!setDir)
        dir_set_current( main_app::JavApp.WorkingDirectory().c_str() );
     if(ifHelp)
     {
        printHelp(cout);
        return 0;
     }
     ifPreviousRun = GetPreviousState();
     ScriviStringa(dialogo->ProgName, MaxLenFilename, "%s", JavApp.PackageName());
     ScriviStringa(dialogo->Version, 6, "%5s", JavApp.PackageVersion());
     dialogo->lProgName = (int) strlen(dialogo->ProgName);
     ScriviStringa(dialogo->PkgName, MaxLenFilename, "%s", PACKAGE_STRING);
     dialogo->lPkgName = (int) strlen(dialogo->PkgName);
     ilmv_();

     return 0;
}

#ifdef __cplusplus
}
#endif

}                       // end namespace main_app

int initGraphics()
{
   int result = main_app::JavApp.InitGraphics();
   fontdescN = pango_font_description_from_string (main_app::JavApp.FontN().c_str());
   fontdescP = pango_font_description_from_string (main_app::JavApp.FontP().c_str());
   fontdescU = pango_font_description_from_string (main_app::JavApp.FontU().c_str());
   caricabondtable_();
   return result;

}

void open_khelp_jav (gpointer, gpointer data)
{
   std::string fhelp = g_build_filename(main_app::JavApp.PkgDataDir().c_str(),
                                        main_app::JavApp.PkName(),
                                        NULL);
   fhelp.append(".kbd");
   open_khelp((GtkWidget *)data, fhelp);
}

void open_about_jav(gpointer, gpointer data)
{
    main_app::JavApp.OpenAbout((GtkWidget *)data);
}

GtkWidget* open_window (int , int , const char *, _drawarea *)
{
   return NULL;
}

extern "C" int gtkmainloop_()
{
    gtk_main ();
    return main_app::JavApp.AppError;
}

//Dummies
int MainLoop(_drawarea *, int )
{
   return 0;
}
void CloseWindow(int *, int , _drawarea *, int )
{
}
void PrimoParametro(char *)
{
}

void SecondoParametro(char *)
{
}
//End Dummies

GdkColor *get_colorgdk(int new_color)
{
   return main_app::JavApp.getgdkCol(new_color);
}

void aggiorna_cfg(std::string &fn)
{
     const char *wd = g_path_get_dirname(fn.c_str());
     main_app::JavApp.UpdateWD(wd);
}

std::string main_dir()
{
    std::string dir = main_app::JavApp.MainDir();
    return dir;
}

namespace GLextmr{
static void on_select_map(GtkToggleButton *radio, gpointer data)
{
   if(gtk_toggle_button_get_active(radio))
   {
      GtkWidget *window = gtk_widget_get_toplevel(GTK_WIDGET(radio));
      g_object_set_data(G_OBJECT(window), "whichmap", data);
      int k = GPOINTER_TO_INT(data);
      GtkWidget *spin = get_widget(window, "level");
      double val = spin_button_get_value(spin);
      spin_button_set_range(spin, minSigma, MRmax(0.02, (double)MapInfo[k-1].sigmaMax));
      spin_button_set_value(spin, val);
   }
}

static void on_select_model(GtkToggleButton *radio, gpointer data)
{
   if(gtk_toggle_button_get_active(radio))
   {
      GtkWidget *window = gtk_widget_get_toplevel(GTK_WIDGET(radio));
      g_object_set_data(G_OBJECT(window), "whichmodel", data);
   }
}

GtkWidget *createPeakSearch(GtkWidget *, int numMaps, GList *listMaps, 
                            int numModels, GList *listModels)
{

   GtkWidget *frame;
   GtkWidget *window = gtk_dialog_new();
   gtk_window_set_title(GTK_WINDOW(window), "Peak Search");
   GtkWidget *box = gtk_dialog_get_content_area(GTK_DIALOG(window));
   gtk_container_set_border_width(GTK_CONTAINER(window), 10);
   g_object_set_data(G_OBJECT(window), "whichmap", GINT_TO_POINTER(0));
   if(numMaps > 1)
   {
      frame = FRAME_BOLD("Select Difference Map", "blue", 1.1f);
      gtk_box_pack_start (GTK_BOX (box), frame, FALSE, FALSE, 10);
      gtk_container_set_border_width(GTK_CONTAINER(frame), 6);
      GtkWidget *vbox = vbox_new(FALSE, 0);
      gtk_container_add(GTK_CONTAINER(frame), vbox);
      GSList *radio_group = NULL;
      for(int i=0; i<numMaps; i++)
      {
          int k = GPOINTER_TO_INT(g_list_nth_data(listMaps, i));
          GtkWidget *radio = RADIO_BUTTON_WITH_LABEL(radio_group, MapInfo[k-1].name, NULL, 0);
          radio_group = gtk_radio_button_get_group(GTK_RADIO_BUTTON(radio));
          gtk_box_pack_start(GTK_BOX(vbox), radio, FALSE, FALSE, 2);
          g_signal_connect(G_OBJECT(radio), "toggled", G_CALLBACK(on_select_map), 
                            g_list_nth_data(listMaps, i));
      }
   }
   else
   {
      frame = FRAME_BOLD("Difference Map", "blue", 1.1f);
      gtk_box_pack_start (GTK_BOX (box), frame, FALSE, FALSE, 10);
      gtk_container_set_border_width(GTK_CONTAINER(frame), 6);
      int k = GPOINTER_TO_INT(g_list_nth_data(listMaps, 0));
      GtkWidget *label = LABEL_NEW(MapInfo[k-1].name, NULL, 0);
      set_margins(label, 4, 4, 2, 2);
      gtk_container_add(GTK_CONTAINER(frame), label);
   }
   g_object_set_data(G_OBJECT(window), "whichmap", g_list_nth_data(listMaps, 0));

   if(numModels > 1)
   {
      frame = FRAME_BOLD("Select Model", "blue", 1.1f);
      gtk_box_pack_start (GTK_BOX (box), frame, FALSE, FALSE, 10);
      gtk_container_set_border_width(GTK_CONTAINER(frame), 6);
      GtkWidget *vbox = vbox_new(FALSE, 0);
      gtk_container_add(GTK_CONTAINER(frame), vbox);
      GSList *radio_group = NULL;
      for(int i=0; i<numModels; i++)
      {
          GtkWidget *radio = RADIO_BUTTON_WITH_LABEL(radio_group,
              g_path_get_basename(ModelInfo[i].modname), NULL, 0);
          radio_group = gtk_radio_button_get_group(GTK_RADIO_BUTTON(radio));
          gtk_box_pack_start(GTK_BOX(vbox), radio, FALSE, FALSE, 2);
          g_signal_connect(G_OBJECT(radio), "toggled", G_CALLBACK(on_select_model), 
                            g_list_nth_data(listModels, i));
      }
   }
   else if (numModels == 1)
   {
      frame = FRAME_BOLD("Model", "blue", 1.1f);
      gtk_box_pack_start (GTK_BOX (box), frame, FALSE, FALSE, 10);
      gtk_container_set_border_width(GTK_CONTAINER(frame), 6);
      GtkWidget *label = LABEL_NEW(g_path_get_basename(ModelInfo[0].modname),
                            NULL, 0);
      set_margins(label, 4, 4, 2, 2);
      gtk_container_add(GTK_CONTAINER(frame), label);
   }
   if(numModels)
      g_object_set_data(G_OBJECT(window), "whichmodel", g_list_nth_data(listModels, 0));
   else
      g_object_set_data(G_OBJECT(window), "whichmodel", NULL);
   frame = FRAME_NEW("Peak Search parameters", "blue");
   gtk_box_pack_start (GTK_BOX (box), frame, FALSE, FALSE, 10);
   gtk_container_set_border_width(GTK_CONTAINER(frame), 6);
   GtkWidget *vbox2 = vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(frame), vbox2);
   gtk_container_set_border_width(GTK_CONTAINER(vbox2), 6);
   int k = GPOINTER_TO_INT(g_list_nth_data(listMaps, 0));
   GtkWidget *level_spin = SPIN_WITH_LABEL("Search peaks with sigma ", NULL, minSigma,
         MapInfo[k-1].sigmaMax, 4.0, 0.1, 2);
   g_object_set_data(G_OBJECT(window), "level", get_widget(level_spin, "spin"));
   gtk_box_pack_start (GTK_BOX (vbox2), level_spin, FALSE, FALSE, 2);
   GtkWidget *check = CHECK_BUTTON_WITH_LABEL("Positive peaks", NULL, 0);
   gtk_box_pack_start (GTK_BOX (vbox2), check, FALSE, FALSE, 2);
   g_object_set_data(G_OBJECT(window), "pp", check);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check), TRUE);
   check = CHECK_BUTTON_WITH_LABEL("Negative peaks", NULL, 0);
   gtk_box_pack_start (GTK_BOX (vbox2), check, FALSE, FALSE, 2);
   g_object_set_data(G_OBJECT(window), "np", check);

   GtkWidget *button = OK_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(window), button, GTK_RESPONSE_OK);
   button = CANCEL_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(window), button, GTK_RESPONSE_CANCEL);
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
         GTK_BUTTONBOX_SPREAD);
   gtk_widget_show_all(window);
   return window;
}

void on_PeakSearch(gpointer,  gpointer data)
{
using namespace gtkext;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   int numMaps = 0;
   int numModels = 0;
   int flag = 1;
   GList *listMaps = NULL;
   GList *listModels = NULL;
   for(int i=0; i<gl->nMaps; i++)
   {
       if(MapInfo[i].ifDifference == 2)
       {
          numMaps++;
          listMaps = g_list_append(listMaps, GINT_TO_POINTER(i+1));
       }
   }
   for(int i=0; i<gl->nModels; i++)
   {
       numModels++;
       listModels = g_list_append(listModels, GINT_TO_POINTER(i+1));
   }

   if(numMaps == 0)
   {
      dlg_errmsg(GTK_WINDOW(window), "Peak Search only possible for Difference Map.");
      return;
   }
   GtkWidget *dlg = createPeakSearch(window, numMaps, listMaps, numModels, listModels);
   int ifNegMap, whichMap, whichModel;
   float level;
   bool loop = true;
   while (loop)
   {
       int response = gtk_dialog_run(GTK_DIALOG(dlg));
       loop = false;
       switch(response)
       {
       case GTK_RESPONSE_OK:
            ifNegMap = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(get_widget(dlg, "pp"))) +
                   2 * gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(get_widget(dlg, "np"))); 
            if(ifNegMap == 0)
            {
               dlg_errmsg(GTK_WINDOW(dlg), "Which peaks are you looking for?");
               loop = true;
            }
            else
            {
               level = (float) spin_button_get_value(get_widget(dlg, "level"));
               whichMap = get_int(dlg, "whichmap");
               whichModel = get_int(dlg, "whichmodel");
               gtk_widget_hide(dlg);
               peaksearch_(&whichMap, &whichModel, &level, &ifNegMap, &flag);
            }
            break;
       case GTK_RESPONSE_CANCEL:
       default:
            break;
       }
   }
   gtk_widget_destroy(dlg);
}

void on_Elica(gpointer,  gpointer data)
{
using namespace gtkext;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
   if(gl->nMaps == 0)
   {
      dlg_errmsg(GTK_WINDOW(window), "Sorry. No map available.");
      return;
   }
   int sz = (int) strlen(MapInfo[gl->activeMap].name) + 1;
   gl->Clip = false;
   gl->fog = false;
//   gl->ifWhole = true;
   elica_(MapInfo[gl->activeMap].name, sz);
}

void fillInfo_for_model(GtkWidget *parent, int kmodel)
{
   int kfin = (int)(sizeof(ModelInfo[kmodel].numbStructs)/sizeof(ModelInfo[kmodel].numbStructs[0]));
   std::stringstream label_string;
   GtkWidget *frame = gtk_frame_new(NULL);
   gtk_box_pack_start(GTK_BOX(parent), frame, TRUE, TRUE, 2);
   std::stringstream name;
   name << "modelinfo" << kmodel;
   g_object_set_data(G_OBJECT(parent), name.str().c_str(), frame);
   gtk_container_set_border_width(GTK_CONTAINER(frame), 4);
   GtkWidget *box = vbox_new(FALSE, 0);
   gtk_container_add (GTK_CONTAINER (frame), box);
   gtk_container_set_border_width(GTK_CONTAINER(box), 2);
   name.str("");
   name << "box" << kmodel;
   g_object_set_data(G_OBJECT(parent), name.str().c_str(), box);
   GtkWidget *hbox = hbox_new(TRUE, 0);
   gtk_box_pack_start(GTK_BOX(box), hbox, TRUE, TRUE, 0);

   GtkWidget *label = LABEL_BOLD (
             g_strdup_printf("Model n. %d: %s", kmodel+1,
               g_path_get_basename(ModelInfo[kmodel].modname)), "red", 1.2f, 0);
   gtk_frame_set_label_widget(GTK_FRAME(frame), label);
   init_string(label_string, "Number of atoms in model:");
   label_string << ModelInfo[kmodel].nats;
   if(ModelInfo[kmodel].ifSymmetry)
      label_string << " (symmetry equivalent included)";
   if(ModelInfo[kmodel].nResAmino > 0)
   {
      init_string(label_string, "Number of residues:", 0);
      label_string << ModelInfo[kmodel].nResAmino;
   }
   if(ModelInfo[kmodel].nResAmino > 0)
   {
      for(int ks=0; ks<kfin/2; ks++)
      {
          init_string(label_string, numbStrings[ks], 0);
          label_string << ModelInfo[kmodel].numbStructs[ks];
      }
   }
   add_label(label_string.str().c_str(), hbox);
   if(ModelInfo[kmodel].nResAmino > 0)
   {
      init_string(label_string, "Number of chains:");
      label_string << ModelInfo[kmodel].nChains;
      init_string(label_string, "Chains:", 0);
      
      for(int kk=0; kk<ModelInfo[kmodel].nChains; kk++)
      {
          label_string << " " << ModelInfo[kmodel].Chains[kk].id;
      }
      for(int ks=0; ks<kfin/2; ks++)
      {
          init_string(label_string, numbStrings[ks+kfin/2], 0);
          label_string << ModelInfo[kmodel].numbStructs[ks+kfin/2];
      }
      add_label(label_string.str().c_str(), hbox);
      GtkWidget *hbox = hbox_new(TRUE, 0);
      gtk_box_pack_start(GTK_BOX(box), hbox, TRUE, TRUE, 0);

/*
      GtkWidget *but = gtk_button_new_with_label("  Text  ");
      gtk_box_pack_start(GTK_BOX(hbox), but, FALSE, FALSE, 2);
      g_signal_connect(G_OBJECT(but), "clicked", G_CALLBACK(ViewText),
                  GINT_TO_POINTER(kmodel));
      but = gtk_button_new_with_label("Sequence");
      gtk_box_pack_start(GTK_BOX(hbox), but, FALSE, FALSE, 2);
      g_signal_connect(G_OBJECT(but), "clicked", G_CALLBACK(ViewSequence),
                  GINT_TO_POINTER(kmodel));
      but = gtk_button_new_with_label("Secondary");
      gtk_box_pack_end(GTK_BOX(hbox), but, FALSE, FALSE, 2);
      g_signal_connect(G_OBJECT(but), "clicked", G_CALLBACK(ViewSecondary),
                  GINT_TO_POINTER(kmodel));
*/
   }
}

void update_model_info(GtkWidget *father, int whichModel)
{
     GtkWidget *parent = get_widget(father, "box_models");
     std::stringstream name;
     name << "modelinfo" << whichModel;
     GValue value = {0};
     mr_type_init();
     g_value_init(&value, G_TYPE_INT);
     g_value_set_int(&value, -1);
     if(g_object_get_data(G_OBJECT(parent), name.str().c_str()) != NULL)
     {
        gtk_container_child_get_property(GTK_CONTAINER(parent),
            get_widget(parent,  name.str().c_str()),
            "position", &value);
        gtk_widget_destroy(get_widget(parent,  name.str().c_str()));
     }
     fillInfo_for_model(parent, whichModel);
     int posi = g_value_get_int(&value);
     if(posi != -1)
        gtk_box_reorder_child(GTK_BOX(parent),
            get_widget(parent,  name.str().c_str()), posi);
     gtk_widget_show_all(father);
}

void rewrite_model_info(GtkWidget *father, GtkWidget *window)
{
     GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");
     GtkWidget *parent = get_widget(father, "box_models");
     remove_children(parent);
     for(int i=0; i<MAX_NUM_MODELS; i++)
     {
         std::stringstream name;
         name << "modelinfo" << i;
         g_object_set_data(G_OBJECT(parent), name.str().c_str(), NULL);
     }
     for(int i=0; i<gl->nModels; i++)
         fillInfo_for_model(parent, i);
     gtk_widget_show_all(father);
}

void update_infos_model(int whichModel, bool ifNewModel)
{
     if(g_object_get_data(G_OBJECT(GLWINDOW), SettingsWindow))
     {
        GtkWidget *dlg = get_widget(GLWINDOW, SettingsWindow);
        if(whichModel == -1)
           rewrite_models(dlg, GLWINDOW);
        else
           update_model(dlg, GLWINDOW);
     }
     if(g_object_get_data(G_OBJECT(GLWINDOW), InfoWindow))
     {
        GtkWidget *dlg = get_widget(GLWINDOW, InfoWindow);
        if(whichModel == -1)
           rewrite_model_info(dlg, GLWINDOW);
        else
           update_model_info(dlg, whichModel);
     }
     if(g_object_get_data(G_OBJECT(GLWINDOW), InfoAtomsW))
     {
        GtkWidget *dlg = get_widget(GLWINDOW, InfoAtomsW);
        g_object_set_data(G_OBJECT(GLWINDOW), InfoAtomsW, NULL);
        gtk_widget_destroy(dlg);
     }
     update_modify_menu(ifNewModel);
}
       
void PrintInfo(gpointer,  gpointer data)
{
using namespace gtkext;
   int i;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");

   if( (gl->nModels == 0) && (gl->nMaps == 0) )
   {
      dlg_errmsg(GTK_WINDOW(window), "Sorry. No model/map available.");
      return;
   }

   if(g_object_get_data(G_OBJECT(window), InfoWindow))
   {
      GtkWidget *dlg = get_widget(window, InfoWindow);
      gdk_window_raise(gtk_widget_get_window(dlg));
      return;
   }

   GtkWidget *dlg = gtk_dialog_new();
   gtk_container_set_border_width (GTK_CONTAINER (dlg), 4);
   gtk_window_set_title (GTK_WINDOW (dlg), "Info");
   g_object_set_data(G_OBJECT(window), InfoWindow, dlg);

   GtkWidget *scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
   gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), scrolledwindow1, TRUE, TRUE, 0);
   gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 4);
   gtk_widget_set_size_request(scrolledwindow1, -1, 300);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
        GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

   GtkWidget *viewport = gtk_viewport_new(NULL, NULL);
   gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport);
   widget_modify_bg(viewport, GTK_STATE_NORMAL, &colorWhite);

   GtkWidget *vbox = vbox_new(FALSE, 0);
   gtk_container_add (GTK_CONTAINER (viewport), vbox);
   gtk_container_set_border_width(GTK_CONTAINER(vbox), 5);

   GtkWidget *frame = FRAME_BOLD ("Cell and Symmetry", "red", 1.2f);
   gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 4);
   g_object_set_data(G_OBJECT(dlg), "box_cell", frame);
   GtkWidget *hbox = hbox_new(TRUE, 0);
   gtk_container_add(GTK_CONTAINER(frame), hbox);
   gtk_container_set_border_width(GTK_CONTAINER(frame), 2);
   std::stringstream label_string;
   init_string(label_string, "Cell Parameters:");
   label_string << gl->Cell[0] << " " << gl->Cell[1]   << " " << gl->Cell[2] 
                << "\n   " << gl->Cell[3]<< " " << gl->Cell[4]<< " " << gl->Cell[5];
   init_string(label_string, "Cell Volume:", 0);
   label_string  << CellVolume(gl->Cell);
   GtkWidget *label = add_label(label_string.str().c_str(), hbox);
   g_object_set_data(G_OBJECT(frame), "cellp", label);

   init_string(label_string, "Space group:");
   if(str_white (gl->sy.spg))
      label_string << "n.a." << "\n" ;
   else
      label_string << gl->sy.spg << "\n" ;
   init_string(label_string, "Number of symm. operators:", 0);
   label_string  << gl->sy.nsymop;
   label = add_label(label_string.str().c_str(), hbox);
   g_object_set_data(G_OBJECT(frame), "symp", label);

   GtkWidget *vbox2 = vbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(vbox), vbox2, TRUE, TRUE, 0);
   g_object_set_data(G_OBJECT(dlg), "box_models", vbox2);
   for(i=0; i<gl->nModels; i++)
       fillInfo_for_model(vbox2, i);
   vbox2 = vbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(vbox), vbox2, TRUE, TRUE, 0);
   g_object_set_data(G_OBJECT(dlg), "box_maps", vbox2);
   for(i=0; i<gl->nMaps; i++)
       fillInfo_for_map(vbox2, i);

   chiudi_dlg_data *st = g_new0(chiudi_dlg_data, 1);
   st->window = window;
   st->name = InfoWindow;

   GtkWidget *button = CLOSE_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_CANCEL);
   g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(chiudi_dlg), (gpointer) st);
   gtk_widget_show_all(dlg);
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
         GTK_BUTTONBOX_SPREAD);
   g_signal_connect_swapped(G_OBJECT(dlg), "delete-event", G_CALLBACK(gtk_button_clicked), button);
}

void PrintMapInfoOld(gpointer,  gpointer data)
{
using namespace gtkext;
   GtkWidget *window = (GtkWidget *) data;
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(window), "glwindow");

   if (gl->nMaps == 0) 
   {
      dlg_errmsg(GTK_WINDOW(window), "Sorry. No map available.");
      return;
   }

   if(g_object_get_data(G_OBJECT(window), MapInfoWindow))
   {
      GtkWidget *dlg = get_widget(window, MapInfoWindow);
      gdk_window_raise(gtk_widget_get_window(dlg));
      return;
   }

   GtkWidget *dlg = gtk_dialog_new();
   gtk_container_set_border_width (GTK_CONTAINER (dlg), 4);
   gtk_window_set_title (GTK_WINDOW (dlg), "Info");
   g_object_set_data(G_OBJECT(window), MapInfoWindow, dlg);

   GtkWidget *scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
   gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(dlg))), scrolledwindow1, TRUE, TRUE, 0);
   gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow1), 4);
   gtk_widget_set_size_request(scrolledwindow1, -1, 300);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1),
        GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

   GtkWidget *viewport = gtk_viewport_new(NULL, NULL);
   gtk_container_add (GTK_CONTAINER (scrolledwindow1), viewport);
   widget_modify_bg(viewport, GTK_STATE_NORMAL, &colorWhite);

   GtkWidget *vbox2 = vbox_new(FALSE, 0);
   gtk_container_add (GTK_CONTAINER (viewport), vbox2);
   gtk_container_set_border_width(GTK_CONTAINER(vbox2), 5);
   g_object_set_data(G_OBJECT(dlg), "box_maps", vbox2);
   for(int i=0; i<gl->nMaps; i++)
       fillInfo_for_map(vbox2, i);

   chiudi_dlg_data *st = g_new0(chiudi_dlg_data, 1);
   st->window = window;
   st->name = MapInfoWindow;

   GtkWidget *button = CLOSE_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_CANCEL);
   g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(chiudi_dlg), (gpointer) st);
   gtk_widget_show_all(dlg);
   g_signal_connect_swapped(G_OBJECT(dlg), "delete-event", G_CALLBACK(gtk_button_clicked), button);
}

/*
extern "C" void passamodellojav_(atom_type *atml, f_bond_type *legm,
       float cell[], int *nats, int *nats_au, int *nlegs, int *nlegs_au,
       int spec[], int *nspec, float raggi[][MAX_SPECIES], symm_info_type *info,
       int *icent, int *nmodels, int *which, int *ifPdb, char *name, int het[])
{
using namespace GLextmr;
  GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
  int k = *which - 1;
  bool ifNewM = true;
  PassaModello(atml, legm, nats, nats_au, nlegs, nlegs_au, 
               raggi, info, which, nmodels, ifPdb, name, &ifNewM, het);
  update_infos_model(k, ifNewM);
  update_infos_cell(gl->nMaps + gl->nModels);
  UpdateInfoAtoms();
  gl->SetSphereCentre(-1, -1, false);
  gl->SetSphereRadius(1.5f, false);
  SetLastRun(GLWINDOW, false);
  aggiornaMenuSym();
  if(g_object_get_data(G_OBJECT(GLWINDOW), SettingsWindow))
  {
      GtkWidget *dlg = get_widget(GLWINDOW, SettingsWindow);
      set_values_for_polyhedra(dlg, gl);
  }

  gl->RiNormalizza();
  if(ifNewM && (gl->nModels==1))
  {
     ifNewM = false;
     gl->ResetView(true);
     gl->ViewPlane('L');
  }
  else
     gl->Redraw();
}
*/
void Model::RipassaModello(int k)
{
  int pdb = isPDB?1:0;
  int ifprot = IsProtein();
  int legs_au[4] = {nconn_prot, nconn_bb, nconn_lig, nconn_ca};

//  putspinfo_(&k, &info, &nats, &nats_au, &nlegs_au, &pdb, &ifprot,
  putspinfo_(&k, &info, &nats, &nats_au, legs_au, &pdb, &ifprot,
             radii, Species);
//  putmodelinfo_(&k);
}

void RipassaModelli()
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   if(gl->nModels == 0)
      return;
//   putcellsy_(gl->Cell, &(gl->sy));
   putnummodels_(&(gl->nModels));

   structure_info_type *StructInfo = g_new0(structure_info_type, 1);
   float raggi[2][MAX_SPECIES];
   for(int i=0; i<MAX_SPECIES; i++)
       raggi[0][i] = raggi[1][i] = 0;
   StructInfo->nsymmstr = gl->sy.nsymop;
   StructInfo->icent = gl->sy.icent;
   for(int i1=0; i1<16; i1++)
       StructInfo->spaceg[i1] = gl->sy.spg[i1];

   for(int i=0; i<6; i++)
       StructInfo->cell[i] = gl->Cell[i];
   for(int i=0; i<gl->nModels; i++)
   {
       int k = i + 1;
       StructInfo->nspec = ModelInfo[i].numSpec;
       for (int j=0; j< ModelInfo[i].numSpec; j++)
       {
            StructInfo->zspec[j] = ModelInfo[i].Species[j];
            StructInfo->vspec[j] = ModelInfo[i].Content[j];
            raggi[0][j] = ModelInfo[i].radii[j][0];
            raggi[1][j] = ModelInfo[i].radii[j][1];
       }
       putstructureinfo_(StructInfo, raggi);
       ModelInfo[i].RipassaModello(k);
   }
}

float Model::Distance(int j1, int j2)
{
   return Distanza(atm[j1-1].xyz, atm[j2-1].xyz);
}

float Model::Ang(int j1, int j2, int j3)
{
   return Angolo(atm[j1-1].xyz, atm[j2-1].xyz, atm[j3-1].xyz);
}

float Model::Tors(int j1, int j2, int j3, int j4)
{
   return Torsione(atm[j1-1].xyz, atm[j2-1].xyz, atm[j3-1].xyz, atm[j4-1].xyz);
}

void Model::CalcAngles()
{
    bool okang = false;
    int na, nb, nc;
    std::vector<jav_anglebond_type> angle_vet;
    jav_anglebond_type ang;
    angle_vet.clear();
    for(int i=0; i< nconn_prot-1; i++)
    {
       int n1i = bonds[i].n1;
       int n2i = bonds[i].n2;
       for(int j=i; j<nconn_prot; j++)
       {
          if(j == i) 
             continue;
          int n1j = bonds[j].n1;
          int n2j = bonds[j].n2;
          okang = true;
          if (n1i == n1j)
          {
              na = n2i;
              nb = n1i;
              nc = n2j;
          }
          else if (n1i == n2j)
          {
              na = n2i;
              nb = n1i;
              nc = n1j;
          }
          else if (n2i == n1j)
          {
              na = n1i;
              nb = n2i;
              nc = n2j;
          }
          else if (n2i == n2j)
          {
              na = n1i;
              nb = n2i;
              nc = n1j;
          }
          else
              okang = false;
          if (okang)
          {
              float value = Ang(na, nb, nc);
              ang.n1 = na;
              ang.n2 = nb;
              ang.n3 = nc;
              ang.fv = value;
              ang.sigma = 3.f;
              angle_vet.push_back(ang);
          }
       }
    }
    nangbonds = (int) angle_vet.size();
    if(anglebonds)
       g_free(anglebonds);
    anglebonds = g_new0(jav_anglebond_type, nangbonds);
    for (int i=0; i<nangbonds; i++)
    {
         anglebonds[i].n1 = angle_vet.at(i).n1;
         anglebonds[i].n2 = angle_vet.at(i).n2;
         anglebonds[i].n3 = angle_vet.at(i).n3;
         anglebonds[i].fv = angle_vet.at(i).fv;
         anglebonds[i].sigma = angle_vet.at(i).sigma;
    }
    angle_vet.clear();
}

void Model::GetConns()
{
   NConns = g_new0(int, nats_au);
   for(int nat=1; nat<=nats_au; nat++)
   {
       NConns[nat-1] = 0;
       std::vector<int> con;
       Conns.push_back(con);
       for(int i=0; i<nconn_prot; i++)
       {
          if(bonds[i].n1 == nat)
             Conns[nat-1].push_back(bonds[i].n2);
          else if(bonds[i].n2 == nat)
             Conns[nat-1].push_back(bonds[i].n1);
       }
       NConns[nat-1] = (int) Conns[nat-1].size();
   }
}

void Model::CalcTors()
{
   std::vector<jav_torsion_type> tors_vet;
   jav_torsion_type tors;
   ntorsions = 0;
   tors_vet.clear();
   GetConns();
   for(int i=0; i<nconn_prot; i++)
   {
       int n2 = bonds[i].n1;
       int n3 = bonds[i].n2;
       if((n2 > nats_au) || (n3 > nats_au))
         continue;
       if((NConns[n2-1] == 1) || (NConns[n3-1] == 1))
         continue;
       for(int j=0; j<NConns[n2-1]; j++)
       {
           int n1 = Conns[n2-1].at(j);
           if(n1 > nats_au)
              continue;
           if(n1 == n3)
              continue;
           for(int k=0; k<NConns[n3-1]; k++)
           {
              int n4 = Conns[n3-1].at(k);
              if(n4 > nats_au)
                 continue;
              if(n4 == n2)
                 continue;
              tors.n1 = n1;
              tors.n2 = n2;
              tors.n3 = n3;
              tors.n4 = n4;
              tors.fv = Tors(n1, n2, n3, n4);
              tors_vet.push_back(tors);
           }
       }
   }
   ntorsions = (int) tors_vet.size();
   if(torsions)
      g_free(torsions);
   torsions = g_new0(jav_torsion_type,  ntorsions);
   for(int i=0; i<ntorsions; i++)
   {
       torsions[i].n1 = tors_vet.at(i).n1;
       torsions[i].n2 = tors_vet.at(i).n2;
       torsions[i].n3 = tors_vet.at(i).n3;
       torsions[i].n4 = tors_vet.at(i).n4;
       torsions[i].fv = tors_vet.at(i).fv;
   }
   tors_vet.clear();
}

extern "C" void getatomsinfofloat_(int *whichModel, int *whichAtom, float atoms[])
{

  for(int j=0; j<3; j++)
      atoms[j] = ModelInfo[*whichModel-1].atm[*whichAtom-1].xyzc[j];
  atoms[3] = ModelInfo[*whichModel-1].atm[*whichAtom-1].H;
  atoms[4] = ModelInfo[*whichModel-1].atm[*whichAtom-1].och;
  atoms[5] = ModelInfo[*whichModel-1].atm[*whichAtom-1].B;
}

extern "C" void getatomsinfoint_(int *whichModel, int *whichAtom, int atoms[])
{
  if(ModelInfo[*whichModel-1].isPDB)
     atoms[0] = ModelInfo[*whichModel-1].atm[*whichAtom-1].ResNum;
  else
     atoms[0] = 1;
  atoms[1] = ModelInfo[*whichModel-1].atm[*whichAtom-1].color + 1;
}

extern "C" void getatomsinfochar_(int *whichModel, int *whichAtom, char *info)
{
  int lung;

  memset(info, ' ', 27);
  jav_atom_type atom = ModelInfo[*whichModel-1].atm[*whichAtom-1];
  std::string label = atom.lab;
  if(label.length() > 16)
     lung = 16;
  else
     lung = (int) label.length();
  for(int i=0; i<lung; i++)
      info[i] =  atom.lab[i];
  for(int i=lung; i<16; i++)
      info[i] =  ' ';
  if(ModelInfo[*whichModel-1].isPDB)
  {
     const char *tipores = ModelInfo[*whichModel-1].NomeResiduo(atom.numResiduo);
     if(strlen(tipores) > 4)
        lung = 4;
     else
        lung = (int) strlen(tipores);
     for(int i=0; i<lung; i++)
         info[16+i] =  tipores[i];
     for(int i=lung; i<4; i++)
         info[16+i] =  ' ';
     const char *tipoatom = lower_case((const char *)ModelInfo[*whichModel-1].AtomTypes.at(*whichAtom-1));
//     const char *tipoatom = lower_case((const char *)g_slist_nth_data(ModelInfo[*whichModel-1].AtomTypes, *whichAtom-1));
//     const char *tipoatom = lower_case(ModelInfo[*whichModel-1].strAtomTypes.at(*whichAtom-1).c_str());
     if(strlen(tipoatom) > 4)
        lung = 4;
     else
        lung = (int) strlen(tipoatom);
     for(int i=0; i<lung; i++)
         info[20+i] =  tipoatom[i];
     for(int i=lung; i<4; i++)
         info[20+i] =  ' ';
     info[24] = ModelInfo[*whichModel-1].Chains[atom.catseq].id[0];
     info[25] = ModelInfo[*whichModel-1].Secondary[*whichAtom-1];
     info[26] = ' ';   //Alternate ?
  }
  info[27] = '\0';
}

extern "C" int getnumbondsfromc_(int *which)
{
      return(ModelInfo[*which-1].nconn);
}

extern "C" void getbondsfromc_(int *whichModel, f_bond_type *bonds, 
                              int *nconn_prot, int *nconn_bb,
                              int *nconn_lig, int *nconn_ca)
{
      int nconn = ModelInfo[*whichModel-1].nconn;
      for(int i=0; i<nconn; i++)
      {
          bonds[i].n1 = ModelInfo[*whichModel-1].bonds[i].n1;
          bonds[i].n2 = ModelInfo[*whichModel-1].bonds[i].n2;
          bonds[i].dist = ModelInfo[*whichModel-1].bonds[i].dist;
          bonds[i].sigma = ModelInfo[*whichModel-1].bonds[i].sigma;
      }
      *nconn_prot = ModelInfo[*whichModel-1].nconn_prot;
      *nconn_bb = ModelInfo[*whichModel-1].nconn_bb;
      *nconn_lig = ModelInfo[*whichModel-1].nconn_lig;
      *nconn_ca = ModelInfo[*whichModel-1].nconn_ca;
}

void RipassaMappe()
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   if(gl->nMaps == 0)
      return;
//   putcellsy_(gl->Cell, &(gl->sy));
   putnummaps_(&(gl->nMaps));
   for(int i=0; i<gl->nMaps; i++)
   {
      int j = i + 1;
      putsizemap_(&j, &(MapInfo[i].size_x), &(MapInfo[i].size_y), 
                  &(MapInfo[i].size_z), &(MapInfo[i].ifDifference),
                  &(MapInfo[i].sigma));
      int l = 0;
      for(int z=0; z<MapInfo[i].size_z; z++)
            for(int y=0; y<MapInfo[i].size_y; y++)
                for(int x=0; x<MapInfo[i].size_x; x++)
                    putxmap_(&j, &x, &y, &z, &(MapInfo[i].mappa[l++]));
   }
}

GtkWidget *createLabelWindow(int *n1, int *n2, int *n3, char *filename)
{
   int i, nCoefs, nPhases, nWt;
   GList *listCoef = NULL;
   GList *listPhases = NULL;
   GList *listWt = NULL;
   nCoefs = *n1;
   nPhases = *n2;
   nWt = *n3;
   *n1 = 1;
   *n2 = 1;
   *n3 = 1;
   for(i=0; i<nCoefs; i++)
       listCoef = g_list_append(listCoef, DuplicaStringa(dialogo->SmallIt[i]));
   for(i=nCoefs; i<nCoefs+nPhases; i++)
       listPhases = g_list_append(listPhases, DuplicaStringa(dialogo->SmallIt[i]));
   for(i=nCoefs+nPhases; i<nCoefs+nPhases+nWt; i++)
       listWt = g_list_append(listWt, DuplicaStringa(dialogo->SmallIt[i]));
   GtkWidget *window = gtk_dialog_new();
   gtk_window_set_title(GTK_WINDOW(window), "Label Window");
   GtkWidget *box = gtk_dialog_get_content_area(GTK_DIALOG(window));
   gtk_container_set_border_width(GTK_CONTAINER(window), 10);

   std::string fil = "File: ";
   fil.append(g_path_get_basename(filename));
   GtkWidget *label = FRAME_BOLD(fil.c_str(), "blue", 1.2f, 0);
   gtk_box_pack_start (GTK_BOX (box), label, FALSE, FALSE, 10);
   gtk_frame_set_shadow_type(GTK_FRAME(label), GTK_SHADOW_NONE);
   label = FRAME_BOLD("Coefficients:", "blue", 1.2f);
   gtk_box_pack_start (GTK_BOX (box), label, FALSE, FALSE, 10);
   gtk_frame_set_shadow_type(GTK_FRAME(label), GTK_SHADOW_NONE);
   GtkWidget *hbox = hbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(label), hbox);
   GtkWidget *combo = create_combo(hbox, listCoef, 1, n1);
   gtk_box_set_child_packing(GTK_BOX(hbox), get_widget(combo, "parent"), FALSE, FALSE, 30,  GTK_PACK_START);
   g_object_set_data(G_OBJECT(window), "comboCoefs", combo);

   label = FRAME_BOLD("Phases:", "blue", 1.2f);
   gtk_box_pack_start (GTK_BOX (box), label, FALSE, FALSE, 10);
   gtk_frame_set_shadow_type(GTK_FRAME(label), GTK_SHADOW_NONE);
   gtk_frame_set_label_align(GTK_FRAME(label), 0.f, 1.0f);
   hbox = hbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(label), hbox);
   combo = create_combo(hbox, listPhases, 1, n2);
   gtk_box_set_child_packing(GTK_BOX(hbox), get_widget(combo, "parent"), FALSE, FALSE, 30,  GTK_PACK_START);
   g_object_set_data(G_OBJECT(window), "comboPhases", combo);

   label = FRAME_BOLD("Weights:", "blue", 1.2f);
   gtk_box_pack_start (GTK_BOX (box), label, FALSE, FALSE, 10);
   gtk_frame_set_shadow_type(GTK_FRAME(label), GTK_SHADOW_NONE);
   hbox = hbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(label), hbox);
   combo = create_combo(hbox, listWt, 1, n3);
   gtk_box_set_child_packing(GTK_BOX(hbox), get_widget(combo, "parent"), FALSE, FALSE, 30,  GTK_PACK_START);
   g_object_set_data(G_OBJECT(window), "comboWt", combo);

   label = gtk_frame_new(NULL);
   gtk_box_pack_start (GTK_BOX (box), label, FALSE, FALSE, 10);
   gtk_frame_set_shadow_type(GTK_FRAME(label), GTK_SHADOW_NONE);
   gtk_frame_set_label_align(GTK_FRAME(label), 0.f, 1.0f);
   GtkWidget *labelt = CHECK_BUTTON_BOLD ("Difference Map", "blue", 1.2f);
   g_object_set_data(G_OBJECT(window), "ifDiff", labelt);
   gtk_frame_set_label_widget(GTK_FRAME(label), labelt);

   GtkWidget *button = OK_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(window), button, GTK_RESPONSE_OK);
   button = CANCEL_button();
   gtk_dialog_add_action_widget(GTK_DIALOG(window), button, GTK_RESPONSE_CANCEL);
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
         GTK_BUTTONBOX_SPREAD);
   gtk_window_set_transient_for(GTK_WINDOW(window), GTK_WINDOW(GLWINDOW));
   gtk_widget_show_all(window);
   return window;
}

extern "C" int labelwindowc_(int *nCoefs, int *nPhases, int *nWt, int *ifDifference, char *filnam)
{
   int n1 = *nCoefs, n2 = *nPhases, n3 = *nWt;
   
   if(!main_app::JavApp.GtkOn)
      return 1;

   GtkWidget *dlg = createLabelWindow(&n1, &n2, &n3, filnam);
   int response = gtk_dialog_run(GTK_DIALOG(dlg));
   int ifdiff = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(get_widget(dlg, "ifDiff")));
   gtk_widget_destroy(dlg);
   switch(response)
   {
   case GTK_RESPONSE_OK:
        *nCoefs = n1;
        *nPhases = n2;
        *nWt = n3;
        *ifDifference = ifdiff;
        return 1;
        break;
   case GTK_RESPONSE_CANCEL:
        *nCoefs = 1;
        *nPhases = 1;
        *nWt = 1;
        *ifDifference = 0;
        return -1;
        break;
   }
   return -1;
}

void stop_draw_center()
{
   GLWindow *gl = (GLWindow *)g_object_get_data(G_OBJECT(GLWINDOW), "glwindow");
   gl->DrawCenter = false;
}

void peak_selected(GtkTreeSelection  *sele, gpointer user_data)
{
     GtkTreeView *tree_view;
     int row;
     GList *list = (GList *) user_data;

     tree_view = gtk_tree_selection_get_tree_view(sele);
     int whichModel = get_int(GTK_WIDGET(tree_view), "whichModel");
     if(get_selection_mode(GTK_WIDGET(tree_view)) == GTK_SELECTION_MULTIPLE)
        return;
     row = row_selected(sele);
     if(row != -1)
     {
        int whichAtom = -1;
        std::string str = (const char *)g_list_nth_data(list, row+1);
        std::string str1 = str.substr(4);
        float posi[3];
        get_float_tokens(str1.c_str(),  " ", 3, posi);
//        g_print("peak %f %f %f \n",posi[0], posi[1], posi[2]);
        std::stringstream os;
        os << row;
        if(whichModel != -1)
           whichAtom = get_int(GTK_WIDGET(tree_view), os.str().c_str());
        move_center(posi, whichModel, whichAtom, true);
     }
}

void open_ViewPeaks(GList *list, int whichModel, float posi[][6])
{
  int len_row = 40 + 25 * (whichModel > -1);
  
  GtkWidget *dlg = gtk_dialog_new();
  gtk_window_set_title (GTK_WINDOW (dlg), "Fourier peaks");
  gtk_widget_set_size_request(dlg, len_row*9, 300);
  GtkWidget *vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));

  GtkWidget *frame = gtk_frame_new(NULL);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 6);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

  GtkWidget *scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_add(GTK_CONTAINER(frame), scrollwin);
  GtkWidget *dirsel = gtk_tree_view_new();
  GtkListStore *store = gtk_list_store_new (1, G_TYPE_STRING);
  GtkCellRenderer *renderer = gtk_cell_renderer_text_new ();
  GtkTreeViewColumn *column = gtk_tree_view_column_new_with_attributes (" ",
            renderer, "markup", 0, NULL);
  gtk_tree_view_column_set_clickable(column, FALSE);
  gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column);

  const char *title = (const char *)g_list_nth_data(list, 0);
  GtkWidget *label = LABEL_BOLD_WITH_FONT(title, "blue", 0.95f,
                get_fontN(MONOSPACE_FONT));

  gtk_widget_show(label);
  gtk_tree_view_column_set_widget(column, label);

  gtk_tree_view_set_model(GTK_TREE_VIEW(dirsel), GTK_TREE_MODEL (store));
  gtk_container_add (GTK_CONTAINER (scrollwin), dirsel);
  set_widget_fontN(dirsel);

  for(int i=1; i<(int)g_list_length(list); i++)
  {
      int k = (int)posi[i-1][5]-1;
      std::stringstream os;
      os << i-1;
      add_line_to_list(dirsel, g_list_nth_data(list, i));
      g_object_set_data(G_OBJECT(dirsel), os.str().c_str(), GINT_TO_POINTER(k));
  }
  g_object_set_data(G_OBJECT(dirsel), "whichModel", GINT_TO_POINTER(whichModel));
  GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(dirsel));
  (void) g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (peak_selected), (gpointer) list);
  
  GtkWidget *button = OK_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_OK);
  button = CANCEL_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dlg), button, GTK_RESPONSE_CANCEL);
  gtk_widget_show_all(dlg);
  gtk_dialog_run(GTK_DIALOG(dlg));
  gtk_widget_destroy(dlg);
}

extern "C" void viewpeaks_(float posi[][6], int *npeaks, int *nModels, int *whichModel)
{
using namespace std;
   int np = *npeaks;
   GList *peaksList = NULL;
   
   const char *title;
   int nModel = -1;
   if((*nModels > 0) && (*whichModel > 0))
   {
      title = "      -------- Peak -------   Sigma   Distance from";
      nModel = *whichModel - 1;
   }
   else
      title = "      -------- Peak -------   sigma";
   peaksList = g_list_append(peaksList, (gpointer) DuplicaStringa(title));
   for(int i=0; i<np; i++)
   {
       std::string os = g_strdup_printf("%2d)", i+1);
       for(int j=0; j<4+(*nModels > 0); j++)
           os.append(g_strdup_printf("% 8.3f", posi[i][j]));
       if(nModel > -1)
       {
           os.append(" ");
           os.append(ModelInfo[*whichModel-1].atm[(int)posi[i][5]-1].lab);
       }
       peaksList = g_list_append(peaksList, (gpointer) DuplicaStringa(os.c_str()));
   }
   open_ViewPeaks(peaksList, nModel, posi);
   stop_draw_center();
}

void on_ViewOutput(gpointer,  gpointer data)
{
using namespace gtkext;
  GtkWidget *window = (GtkWidget *) data;
  struct stat buf;
  int e, flags = 0;

  viewoutputfile_();
  e = stat("tmp.tmp", &buf);
  if(e)
  {
     dlg_errmsg(GTK_WINDOW(window), "Sorry. Output file does not exist.");
     return;
  }

  flags = gtkext::IFREADONLY;
  gtkext::text_window (GTK_WINDOW(window), "tmp.tmp", "*.txt", flags, "Output file");
}

}

extern "C" void getspeciesfromc_(len_spec Species[MAX_SPECIES], int *wm)
{
using namespace GLextmr;
    for(int i=0; i<MAX_SPECIES; i++)
        memcpy(&Species[i], ModelInfo[*wm-1].info.Species[i], 4);
}
 
extern "C" void getinfo1_(int *wm, int *nats, int *nb, int *nk, int no[],
                          int nw[], float raggi[2][MAX_SPECIES],
                          len_spec Species[MAX_SPECIES])
{
using namespace GLextmr;
   *nats = ModelInfo[*wm-1].nats_au;
   *nb = ModelInfo[*wm-1].nlegs_au;
   for(int i=0; i<MAX_SPECIES; i++)
   {
        raggi[0][i] = raggi[1][i] = 0;
        no[i] = 0;
        nw[i] = 0;
        memcpy(&Species[i], ModelInfo[*wm-1].info.Species[i], 4);
   }
   *nk = ModelInfo[*wm-1].numSpec;
   for (int j=0; j< ModelInfo[*wm-1].numSpec; j++)
   {
        no[j] = ModelInfo[*wm-1].Species[j];
        nw[j] = ModelInfo[*wm-1].Content[j];
        raggi[0][j] = ModelInfo[*wm-1].radii[j][0];
        raggi[1][j] = ModelInfo[*wm-1].radii[j][1];
   }
}

extern "C" void getinfoatoms_(int *wm, atom_type *atml, symm_info_type *info, int *ii)
{
using namespace GLextmr;
//   int nzc = *nzC;
    int i = *ii-1;
    for(int j=0; j<3; j++)
        atml->xc[j] = ModelInfo[*wm-1].atm[i].xyzc[j];
    atml->biso = ModelInfo[*wm-1].atm[i].B;
    atml->ocry = ModelInfo[*wm-1].atm[i].ocry;
    atml->och  = ModelInfo[*wm-1].atm[i].och;
    atml->inte = ModelInfo[*wm-1].atm[i].H;
    atml->nz   = (ModelInfo[*wm-1].atm[i].color+1)*nzc;
    for(int ll=0; ll<6; ll++)
          atml->bij[ll] = ModelInfo[*wm-1].atm[i].Bij[ll];
    for(int ll=0; ll<16; ll++)
        atml->lab[ll] = ' ';
    for(int ll=0; ll<(int)strlen(ModelInfo[*wm-1].atm[i].lab); ll++)
        atml->lab[ll] = ModelInfo[*wm-1].atm[i].lab[ll];

    info->oper = ModelInfo[*wm-1].atm[i].oper;
    info->opcode = ModelInfo[*wm-1].atm[i].opcode;
    info->asym = ModelInfo[*wm-1].iEqui[i] + 1;
}

extern "C" void getinfobonds_(int *wm, f_bond_type *legm, int *ii)
{
using namespace GLextmr;
    int i = *ii-1;
    legm->n1    = ModelInfo[*wm-1].bonds[i].n1;
    legm->n2    = ModelInfo[*wm-1].bonds[i].n2;
    legm->dist  = ModelInfo[*wm-1].bonds[i].dist;
    legm->sigma = ModelInfo[*wm-1].bonds[i].sigma;
}

extern "C" void c_get12_(float abcvet[], int *ier)
{
    int ktest = 0;
    std::string filspg = g_strdup_printf( "%s%cfiles%cSir.spg",
       g_path_get_dirname(main_app::JavApp.PkgDataDir().c_str()),
       G_DIR_SEPARATOR, G_DIR_SEPARATOR);
    GetSpgAndCell(abcvet, ier, &ktest, filspg.c_str());
}

const char *Pfont()
{
    return g_strdup(main_app::JavApp.FontP().c_str());
}

extern "C" void javerror_()
{
using namespace GLextmr;
   if(!gtk_main_level())
      exit(1);
}

void aggiorna_centro(vet3 v)
{
}

void call_javs(GtkWidget *, gpointer)
{
    calljavs_();
}
// For Preview use:
//           jav -p -s=ct -c=ss -P=xpos,ypos filename
