#ifdef HAVE_CONFIG_H
#  include <config.h>
#else
#  include <config_any.h>
#endif

#include "cutils.h"
#include "libcomune.h"
#include "libmath.h"
#include <cstring>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <cctype>
#include <cstdarg>

#ifdef _WIN32
#include <windows.h>
#include <direct.h>
#else
#include <sys/types.h>
#include <unistd.h>
#endif
#include <sys/stat.h>

#ifdef VERY_LOW_GVERSION
typedef gint GPid;
#endif

#define USE_GTK_FILECHOOSER 1
#define DO_SETFILENAME      1
#ifndef GTK_FILE_CHOOSER
#undef USE_GTK_FILECHOOSER
#endif
#ifdef _WIN32
#if !GTK_CHECK_VERSION(2,20,0)
#undef DO_SETFILENAME
#endif
#endif

nomefile serv_dir;

  static const int  RES_C[26][4] = {// C  N  O  S
                                   {   3, 1, 1, 0},     //'A'
                                   {   0, 0, 0, 0},     //'B'
                                   {   3, 1, 1, 1},     //'C'
                                   {   4, 1, 3, 0},     //'D'
                                   {   5, 1, 3, 0},     //'E'
                                   {   9, 1, 1, 0},     //'F'
                                   {   2, 1, 1, 0},     //'G'
                                   {   6, 3, 1, 0},     //'H'
                                   {   6, 1, 1, 0},     //'I'
                                   {   0, 0, 0, 0},     //'J'
                                   {   6, 2, 1, 0},     //'K'
                                   {   6, 1, 1, 0},     //'L'
                                   {   5, 1, 1, 1},     //'M'
                                   {   4, 2, 1, 0},     //'N'
                                   {   0, 0, 0, 0},     //'O'
                                   {   5, 1, 1, 0},     //'P'
                                   {   5, 2, 2, 0},     //'Q'
                                   {   6, 4, 1, 0},     //'R'
                                   {   3, 1, 2, 0},     //'S'
                                   {   4, 1, 2, 0},     //'T'
                                   {   0, 0, 0, 0},     //'U'
                                   {   5, 1, 1, 0},     //'V'
                                   {  11, 2, 2, 0},     //'W'
                                   {   0, 0, 0, 0},     //'X'
                                   {   9, 1, 2, 0},     //'Y'
                                   {   0, 0, 0, 0}      //'Z'
                                      };

  static const int  AMI_C[26][5] = {// H, C  N  O  P
                                   {  14,10, 5, 7, 1},  //'A'
                                   {   0, 0, 0, 0, 0},  //'B'
                                   {  14, 9, 3, 8, 1},  //'C'
                                   {   0, 0, 0, 0, 0},  //'D'
                                   {  28,30, 5, 9, 1},  //'E'
                                   {   0, 0, 0, 0, 0},  //'F'
                                   {  14,10, 5, 8, 1},  //'G'
                                   {   0, 0, 0, 0, 0},  //'H'
                                   {   0, 0, 0, 0, 0},  //'I'
                                   {   0, 0, 0, 0, 0},  //'J'
                                   {   0, 0, 0, 0, 0},  //'K'
                                   {   0, 0, 0, 0, 0},  //'L'
                                   {   0, 0, 0, 0, 0},  //'M'
                                   {   0, 0, 0, 0, 0},  //'N'
                                   {   0, 0, 0, 0, 0},  //'O'
                                   {  18,13, 5, 7, 1},  //'P'
                                   {   0, 0, 0, 0},     //'Q'
                                   {  22,18, 5, 7, 1},  //'R'
                                   {   0, 0, 0, 0, 0},  //'S'
                                   {  15,10, 2, 8, 1},  //'T'
                                   {  13, 9, 2, 9, 1},  //'U'
                                   {   0, 0, 0, 0, 0},  //'V'
                                   {   0, 0, 0, 0, 0},  //'W'
                                   {  27,27, 5,14, 1},  //'X'
                                   {  22,18, 5, 7, 1},  //'Y'
                                   {  13, 9, 2, 7, 1}   //'Z'
                                      };

/************************************************************/
/*************** Get Default Internet Browser ***************/
/************************************************************/
void mr_type_init();

#ifdef _WIN32
#include <shellapi.h>
#include <string>
 std::string m_strBrowser;
 const char* GetBrowser(void)
 {
  // Have we already got the browser?
  if (m_strBrowser.empty())
  {
   // Get the default browser from HKCR\http\shell\open\command
   HKEY hKey = NULL;
   // Open the registry
   if (::RegOpenKeyEx(HKEY_CLASSES_ROOT, "http\\shell\\open\\command",
     0, KEY_READ, &hKey) == ERROR_SUCCESS)
   {
    // Data size
    DWORD cbData = 0;
    // Get the default value
    if (::RegQueryValueEx(hKey, NULL, NULL, NULL, NULL, &cbData) 
        == ERROR_SUCCESS && cbData > 0)
    {
     // Allocate a suitable buffer
     char *psz = new char[cbData];
     // Success?
     if (psz != NULL)
     {
      if (::RegQueryValueEx(hKey, NULL, NULL,
       NULL, (LPBYTE)psz, &cbData) ==
       ERROR_SUCCESS)
      {
       // Success!
       m_strBrowser = psz;
      }
      delete [] psz;
     }
    }
    ::RegCloseKey(hKey);
   }
   // Do we have the browser?
   if (m_strBrowser.length() > 0)
   {
    // Strip the full path from the string
    int nStart = (int) m_strBrowser.find ('"');
// La seguente e' stata modificata perche' dava problemi con Firefox per via
// delle virgolette (") multiple
//mr 190109    int nEnd = (int) m_strBrowser.rfind('"');
    int nEnd = (int) m_strBrowser.find('"', nStart+1);   //mr 190109
    // Do we have either quote?
    // If so, then the path contains spaces
//mr    if (nStart >= 0 && nEnd >= 0)
    if (nStart == 0 && nEnd >= 0)
    {
     // Are they the same?
     if (nStart != nEnd)
     {   
      // Get the full path
      m_strBrowser = m_strBrowser.substr(nStart + 1, nEnd - nStart - 1);
     }
    }
    else
    {
     // We may have a pathname with spaces but
     // no quotes (Netscape), e.g.:
     //   C:\PROGRAM FILES\NETSCAPE\COMMUNICATOR\PROGRAM\NETSCAPE.EXE -h "%1"
     // or a pathname without spaces AND       (mr)
     // no quotes (Mozilla), e.g.:             (mr)
     //   C:\PROGRA~1\MOZILL~1\FIREFOX.EXE"}

        // Look for the last backslash
     int nIndex = (int) m_strBrowser.rfind('\\');
     // Success?
     if (nIndex > 0)
     {
      // Look for the next space after the final
      // backslash
      int nSpace = (int) m_strBrowser.find(' ', nIndex);
      // Do we have a space?
      if (nSpace > 0)
       m_strBrowser = m_strBrowser.substr (0, nSpace);    
     }
    }
   }
  }
  // Done
  return g_strdup(m_strBrowser.c_str());
 }
#else
const char *try_get_browser()
{
const char *browsers[] = { "xdg-open", "firefox", "opera", "konqueror", "epiphany", "mozilla", "netscape", "iceweasel", "safari" };
int nBrowsers = sizeof(browsers)/sizeof(browsers[0]);
const char *browser = NULL;
for (int count = 0; count < nBrowsers && browser == NULL; count++)
{
     std::string exe_str = "which ";
     exe_str.append(browsers[count]);
     exe_str.append(" >/dev/null 2>&1");
     if (system( exe_str.c_str()) == 0)
         browser = browsers[count];
}
if (browser == NULL)
   return "unknown";
else
   return browser;
}

#ifdef MACOSX
const char* GetDefaultApp(const char *tipo)
{
   return ("open");
}
#else
#ifdef GIO_ENV
#include <gio/gio.h>
const char* GetDefaultApp(const char *tipo)
{
    mr_type_init();
    GAppInfo *app = g_app_info_get_default_for_type (tipo, FALSE);
    if(app == NULL)
       return try_get_browser();
    return(g_app_info_get_executable (app));
}
#elif defined(VFS_ENV)
#include <libgnomevfs/gnome-vfs.h>
#include <libgnomevfs/gnome-vfs-mime-handlers.h>
#include <libgnomevfs/gnome-vfs-mime-utils.h>
const char* GetDefaultApp(const char *tipo)
{
  if (!gnome_vfs_init ()) {
    printf ("Could not initialize GnomeVFS\n");
    return try_get_browser();
  }
  GnomeVFSMimeApplication *app =  gnome_vfs_mime_get_default_application
                                                        (tipo);
  return(app->command);
}
#else
const char* GetDefaultApp(const char *tipo)
{
    if (strstr(tipo, "htm"))
        return try_get_browser();
    else if (strstr(tipo, "pdf"))
        return ("xdg-open");
    else
        return ("unknown");
}
#endif
#endif

const char* GetPDFViewer(void)
{
    return (GetDefaultApp("text/pdf"));
}

const char* GetBrowser(void)
{
    return (GetDefaultApp("text/html"));
}
#endif


/************************************************************/
/************************** System Info  ********************/
/************************************************************/
#ifdef _WIN32
#ifdef _MSC_VER
#include <atlsimpstr.h>
#include <atlstr.h>
int nCPU()
{
    CAtlString Environment;
    return Environment.GetEnvironmentVariable ("NUMBER_OF_PROCESSORS");
}
const char *SystemArch()
{
    CAtlString EnvStr;
    EnvStr.GetEnvironmentVariable(_T("PROCESSOR_ARCHITECTURE"));
    char *buffer = g_strdup(EnvStr.GetBuffer());
    return(buffer);
}
#else
int nCPU()
{
    return 1;
}
const char *SystemArch()
{
    return("i686");
}
#endif

#else
int nCPU()
{
    return sysconf((_SC_NPROCESSORS_ONLN));
}
const char *SystemArch()
{
if (sizeof(int) ==sizeof(int *))
    return "32 bit";
else
    return "64 bit";
}
#endif

std::string ArchInfo()
{
      if(strstr(SystemArch(), "64") != NULL)
         return "Compiled on 64 bit";
      else
         return "Compiled on 32 bit";
}

std::string dateinfo(char *filinfo)
{
   std::string stringa;
   stringa.assign("Created on ");
   char rigar[256];
   bool result = false;
   FILE *fp = fOpen(filinfo, "r");
   if(fp != NULL)
   {
      if((fgets(rigar,256,fp) != NULL) && (strlen(rigar) > 1))
      {
         result = true;
         stringa.append(filtranl(rigar));
      }
      fclose(fp);
   }
   if(!result)
   {
      fp = fOpen(filinfo, "w");
      if(fp)
      {
         fprintf(fp, "%s\n", get_ctime());
         fprintf(fp, "%s\n", get_jtime());
         fclose(fp);
      }
      stringa.append(get_ctime());
   }
   return stringa;
}

/*-------------------------------------------------------------*/
/*         Utilities and system dependent functions            */
/*-------------------------------------------------------------*/
std::string fromUTF8(std::string name)
{
    const gchar *ptr;
    GError *error=NULL;
    if( g_utf8_validate(name.c_str(), -1, &ptr) )
    {
        gsize fleng;
        std::string _strlocalname(g_locale_from_utf8(name.c_str(),-1,&fleng,&fleng, &error));
        if(!error)
           return _strlocalname;
    }
    return name;
}
#if 0
const gchar *fromUTF8(const gchar *name)
{
    const gchar *ptr;
    GError *error=NULL;
    if( g_utf8_validate(name, -1, &ptr) )
    {
        gchar *_localname;
        gsize fleng;
        _localname = g_locale_from_utf8(name,-1,&fleng,&fleng, &error);
        //_localname = g_locale_from_utf8(name,-1,&fleng,&fleng, NULL);
        if(!error)
           return _localname;
    }
    return name;
}
#endif

int dir_create(const gchar *dir)
{
    int ier;
#ifdef _WIN32
    ier = _mkdir(fromUTF8(dir).c_str());                 // locale support
#else
    ier = mkdir(dir, 0777);
//    ier = mkdir(dir, 0xFFFFFFFF);
#endif
    return ier;
}

void CopiaStringa(char *dest, size_t sz, const char *src)
{
    if((dest == NULL) || (src == NULL))
       return;
    if(strlen(src) >= sz)
    {
       printf("Warning: string too small in CopiaStringa\n");
       return;
     }
#if __STDC_WANT_SECURE_LIB__
    strcpy_s(dest, sz, src);
#else
    strcpy(dest, src);
#endif 
   for(size_t i=strlen(src)+1;i<sz;i++)
       dest[i] = ' ';
}

void CopiaStringan(char *dest, size_t sz, const char *src, size_t n)
{
    if((dest == NULL) || (src == NULL))
       return;
    if(n >= sz)
    {
       printf("Warning: string too small in CopiaStringan\n");
       return;
    }
#if __STDC_WANT_SECURE_LIB__
    strncpy_s(dest, sz, src, n);
#else
    strncpy(dest, src, n);
#endif
}

void AppendiStringa(char *dest, size_t sz, const char *src)
{
    if((dest == NULL) || (src == NULL))
       return;
    size_t dest_len = strlen(dest);
    size_t src_len = strlen(src);
    if(sz <= (dest_len+src_len))
    {
       printf("Warning: string too small in AppendiStringa\n");
       return;
    }
#if __STDC_WANT_SECURE_LIB__
    strcat_s(dest, sz, src);
#else
    strcat(dest, src);
#endif 
}

void AppendiStringan(char *dest, size_t sz, const char *src, size_t n)
{
    if((dest == NULL) || (src == NULL))
       return;
    size_t dest_len = strlen(dest);
    if(sz <= (dest_len+n))
    {
       printf("Warning: string too small in AppendiStringan\n");
       return;
    }
#if __STDC_WANT_SECURE_LIB__
    strncat_s(dest, sz, src, n);
#else
    strncat(dest, src, n);
#endif
   for(size_t i=strlen(dest)+1;i<sz;i++)
       dest[i] = ' ';
}

FILE *fOpen(const char *path, const char *mode)
{
    if(path == NULL)
       return NULL;
#if __STDC_WANT_SECURE_LIB__
    FILE *fp;
    fopen_s(&fp, fromUTF8(path).c_str(), mode);
    return fp;
#else
    return fopen(path, mode);
#endif
}

void ScriviStringa(char *str, size_t sz, const char *format, ...)
{
      va_list args;
      int result;

      va_start (args, format);
#if __STDC_WANT_SECURE_LIB__
      result =  vsprintf_s(str, sz, format, args);
#else
      result =  vsprintf(str, format, args);
#endif
      va_end (args);
      if (result > -1 && result < (int) sz)
      {
          memset(str+result, 0, sz-result);
          return;
      }
      printf("Warning: string too small in ScriviStringa\n");
}

#if !__STDC_WANT_SECURE_LIB__
int fscanf_s(FILE *fp, const char *format, ...)
{
      va_list argptr;
      int result;
 
      va_start( argptr, format );
 
      result =  vfscanf(fp, format, argptr);
 
      va_end( argptr );
      return result;
}
#endif
 
char *DuplicaStringa(const char *s)
{
    if(s == NULL)
       return NULL;
    return g_strdup(s);
}

int Cancella(const char *pathname)
{
    if(pathname == NULL)
       return -1;
#ifdef _WIN32
    return _unlink(fromUTF8(pathname).c_str());
#else
    return unlink(pathname);
#endif
}

const char *Ambiente(const gchar *varname)
{
    if(varname == NULL)
       return NULL;
#if __STDC_WANT_SECURE_LIB__
    char *pValue;
    size_t len;
    errno_t err = _dupenv_s( &pValue, &len, varname );
    if ( err ) return NULL;
    return( pValue );
#else
    return getenv(varname);
#endif
}

void OraFormatotm(const time_t *timep, struct tm *result)
{
#ifdef HAVE_LOCALTIME_R
  localtime_r (timep, result);
#else
#if __STDC_WANT_SECURE_LIB__
  localtime_s (result, timep);
#else
  struct tm *tmres = localtime (timep);
  if(tmres == NULL)
  {
     result->tm_mon = 0;
     result->tm_mday = 1;
     result->tm_year = 100;
  }
  else
     memcpy ((void *) result, (void *) tmres, sizeof(struct tm));
#endif
#endif
}

void OraFormatoasc(const struct tm *tm, char *buf)
{
  if(buf == NULL)
  {
     printf("Sorry. No buffer allocated for OraFormatoasc\n");
     return;
  }
#ifdef HAVE_ASCTIME_R
  asctime_r(tm, buf);
#else
#if __STDC_WANT_SECURE_LIB__
  asctime_s(buf, 26, tm);
#else
  char *tbuf = asctime(tm);
  if(buf == NULL)
     ;
  else
    CopiaStringa(buf, 26, tbuf);
#endif
#endif
}

void OraCorrente(struct tm *newtime)
{
  GTimeVal result;

  g_get_current_time (&result);
  time_t timer = result.tv_sec;
  OraFormatotm( &timer, newtime);
}

void GetMillisec(int *timer)
{
    GTimeVal tv;

    g_get_current_time (&tv);
    *timer = tv.tv_sec*1000 + tv.tv_usec/1000;
}

int mr_access(const char *filename, char cmode)
{
   int ier, mode;

   switch(cmode)
   {
    case 'r':
         mode = 4;
         break;
    case 'w':
         mode = 2;
         break;
    case 'm':
         mode = 6;
         break;
    case 'x':
         mode = 1;
         break;
    default:
         mode = 0;
         break;
   }

#ifdef _WIN32
   ier = _access( fromUTF8(filename).c_str(), mode );      // locale support
#else
   ier = access( filename, mode );
#endif
   if(ier == -1)
      return 0;
   return 1;
}

bool str_white(const char *str)
{
    const char *ch;
    if( str==NULL )
      return true;
    for( ch=str; *ch!='\0'; ++ch )
    {
      if( ((*ch)!=' ') && ((*ch)!='\t') && ((*ch)!='\v') && ((*ch)!='\r') && ((*ch)!='\n') )
        return false;
    }
    return true;
}

std::string strstrip(std::string &s)
{
using namespace std;
   string s1;
   string t = s;
   string::size_type i1 =  s.find_first_not_of(" ");
   if(i1 != string::npos)
      t = s.erase( 0, i1);
   i1 =  t.find_last_not_of(" ") ;
   if(i1 <  t.length())
      s1 = t.erase(i1+1, t.length());
   else
      s1 = t;
   return s1;
}

char *getPWD()
{
  char *tmpstr;

  tmpstr = g_new0(char, 255);
#ifdef _WIN32
  if( _getcwd(tmpstr, 255) == NULL)
     g_print("Warning: error in getPWD\n");
#else
  if( getcwd(tmpstr, 255) == NULL)
     g_print("Warning: error in getPWD\n");
#endif
  return tmpstr;
}

char* getHomeDir (void)
{
   char *homedir = (char *) malloc(MaxLenFilename);
   memset(homedir, 0, MaxLenFilename);

   if(Ambiente("HOME") != NULL)
       CopiaStringa(homedir, MaxLenFilename, Ambiente("HOME"));
   else
   {
#ifdef _WIN32
       nomefile buffer;
       if(Ambiente("USERPROFILE") != NULL)
          CopiaStringa(homedir, MaxLenFilename, Ambiente("USERPROFILE"));
       else if(Ambiente ("HOMEDRIVE") != NULL && Ambiente ("HOMEPATH") != NULL)
       {
          CopiaStringa(homedir, MaxLenFilename, Ambiente ("HOMEDRIVE"));
          AppendiStringa(homedir, MaxLenFilename, Ambiente ("HOMEPATH"));
       }
       else
          CopiaStringa(homedir, MaxLenFilename, _getcwd(buffer, 255));
#else
       CopiaStringa(homedir, MaxLenFilename, ".");
#endif
   }
   return homedir;
}

int num_el (const char *str[])
{
    int i;

    i = 0;
    while(*str[i])
      i++;
    return i;
}

/************************************************************/
/*************** formattazione messaggi  ********************/
/************************************************************/
void CutStrc(char *str, int *iz, int lriga)
{
   int i;

   i = 0;

   while( (*(str+i) != '\n') && (i < *iz) )
        i++;
   if(i > lriga)
   {
      i = *iz;
      if(i > lriga)
         i = lriga;
      while((*(str+i) != ' ') && (i > 0))
           i--;
      if(i == 0)
      {
         *(str+1) = '.';
         *(str+2) = '.';
         *(str+3) = '.';
      }
      *iz = i-1;
   }
   else
      *iz = i-1;
}

void formatta_msg(char *msgout, size_t lmsg, const char *MsgIn, int lriga)
{
   int lung, i;
   char *msgin = DuplicaStringa(MsgIn);

   *msgout = '\0';
   while((lung = (int) strlen(msgin)) > 0)
   {
       CutStrc(msgin, &lung, lriga);
       if(lung != -1)
       {
          (void) AppendiStringan(msgout, lmsg, msgin, lung+1);
          if(*(msgout+strlen(msgout)-1) != '\n')
               AppendiStringa(msgout, lmsg, "\n");
       }
       for(i=0; (i<lung+2) && (*(msgin) != '\0'); i++)
           msgin++;
   }
   AppendiStringa(msgout, lmsg, "\0");
}

void strshift(char tmpd[], int ish)
{
    int ifin = (int) strlen(tmpd) - ish;
    int i;
    for(i=0; i<ifin; i++)
        tmpd[i] = tmpd[i+ish];
    tmpd[ifin] = '\0';
}

char *SplitFilename (const char *filnam)
{
using namespace std;
  string str(filnam);
  char *dir = NULL;
  size_t found = str.find_last_of("/\\");
  if(found != string::npos)
     dir = g_strdup(str.substr(0,found).c_str());
  return dir;
}

char *get_prog_dir(const char *prognam)
{
    char *program_dir = g_new0(char, MaxLenFilename);

    if(g_path_is_absolute(prognam))
    {
       char *tmp1 = g_path_get_dirname(prognam);
       CopiaStringa(program_dir, MaxLenFilename, g_path_get_dirname(prognam));
       g_free(tmp1);
    }
    else
    {
       char tmpd[1024];
       char *nome = SplitFilename(prognam);
       if(nome == NULL)
       {
          char *tmppath = find_program_in_path(prognam);
          char *tmp1 = g_path_get_dirname(tmppath);
          CopiaStringa(tmpd, MaxLenFilename, tmp1);
          g_free(tmppath);
          g_free(tmp1);
       }
       else
       {
          CopiaStringa(tmpd, MaxLenFilename, nome);
          g_free(nome);
       }
       if(g_path_is_absolute(tmpd))
         CopiaStringa(program_dir, MaxLenFilename, tmpd);
       else if(tmpd[0] != '.')
       {
         char *tmppath = g_get_current_dir();
         ScriviStringa(program_dir, MaxLenFilename, "%s%c%s", tmppath, G_DIR_SEPARATOR, tmpd);
          g_free(tmppath);
       }
       else
       {
         if(strlen(tmpd) == 1)
         {
            char *tmppath = g_get_current_dir();
            CopiaStringa(program_dir, MaxLenFilename, tmppath);
            g_free(tmppath);
         }
         else if(tmpd[1] == G_DIR_SEPARATOR)
         {
            char *tmppath = g_get_current_dir();
            strshift(tmpd, 2);
            ScriviStringa(program_dir, MaxLenFilename, "%s%c%s", tmppath, G_DIR_SEPARATOR, tmpd);
            g_free(tmppath);
         }
         else if((tmpd[1] == '.') || (tmpd[2] == G_DIR_SEPARATOR))
         {
            char *tmppath = g_get_current_dir();
            char *tmp1 = g_path_get_dirname(tmppath);
            if(strlen(tmpd) == 2)
                ScriviStringa(program_dir, MaxLenFilename, "%s",tmp1);
            else
            {
                strshift(tmpd, 3);
                ScriviStringa(program_dir, MaxLenFilename, "%s%c%s",
                  tmp1, G_DIR_SEPARATOR, tmpd);
            }
            g_free(tmppath);
            g_free(tmp1);
         }
       }
    }
    return program_dir;
}

char *get_ctime()
{
  const char *month[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
                          "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
  struct tm TMbuf;

  OraCorrente(&TMbuf);
  return (g_strdup_printf( "%4.4d %s %2.2d", TMbuf.tm_year+1900, month[TMbuf.tm_mon], TMbuf.tm_mday));
}

char *get_jtime()
{
  struct tm TMbuf;

  OraCorrente(&TMbuf);
  return (g_strdup_printf( "%4.4d %3.3d", TMbuf.tm_year+1900, TMbuf.tm_yday));
}

char *get_mtime(const char *name)
{
  const char *month[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
                          "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
  struct tm TMbuf;
#ifdef _WIN32
  struct _stat buf;
  _stat(name, &buf);
#else
  struct stat buf;
  stat(name, &buf);
#endif
  OraFormatotm(&buf.st_mtime,&TMbuf);
  return (g_strdup_printf( "%4.4d %s %2.2d", TMbuf.tm_year+1900, month[TMbuf.tm_mon], TMbuf.tm_mday));
}

char *get_files_dir(const char *program_dir, const char *filesdirname)
{
    char *dir = g_new0(char, MaxLenFilename);
#ifdef PACKAGE
    char *tmp = g_path_get_dirname(program_dir);
    ScriviStringa(dir, MaxLenFilename, "%s%cshare%c%s%c%s",
            tmp, G_DIR_SEPARATOR, G_DIR_SEPARATOR,PACKAGE, G_DIR_SEPARATOR,
            filesdirname);
    g_free(tmp);
    if(!mr_access(dir, 'e'))
          ScriviStringa(dir, MaxLenFilename, "%s%c%s", program_dir, G_DIR_SEPARATOR, filesdirname);
#else
          ScriviStringa(dir, MaxLenFilename, "%s%c%s", program_dir, G_DIR_SEPARATOR, filesdirname);
#endif
    ScriviStringa(serv_dir, sizeof(nomefile), "%s", dir);
    return dir;
}

void get_servdir(nomefile dire)
{
    CopiaStringa(dire, sizeof(nomefile), serv_dir);
}

void put_servdir(nomefile dire)
{
    CopiaStringa(serv_dir, sizeof(nomefile), dire);
}

char *get_pkg_dir(const char *program_dir)
{
    char *dir = g_new0(char, MaxLenFilename);
#ifdef PACKAGE
    char *tmp = g_path_get_dirname(program_dir);
    ScriviStringa(dir, MaxLenFilename, "%s%cshare%c%s",
            tmp, G_DIR_SEPARATOR, G_DIR_SEPARATOR,PACKAGE);
    g_free(tmp);
#endif
    return dir;
}

/************************************************************/
/*************** BITWISE utility functions  *****************/
/************************************************************/


int b_unset (int word, int bit)
{
    if(bit >= 0)
       return (word & (~(1<<bit)));
    return word;
}
                                                                                    
int b_set (int word, int bit)
{
    if(bit >= 0)
       return (word | (1<<bit));
    return word;
}


int b_test (int word, int bit)
{
    return (word & (1<<bit));
}

const char *lower_case(const char *stringa)
{
     if(stringa == NULL)
        return NULL;
     std::string lstringa;

     lstringa.clear();
     for(int i=0; i<(int) strlen(stringa); i++)
     {
         char c = (char) tolower(stringa[i]);
         lstringa.append(1, c);
     }
//         lstringa.append(1, tolower(stringa[i]));
     return g_strdup(lstringa.c_str());
}

void  mr_CopyFile(const char *fileold, const char *filenew)
{
    if(strcmp(fileold, filenew) == 0)
       return;
#ifdef _WIN32
    CopyFile(fromUTF8(fileold).c_str(), fromUTF8(filenew).c_str(), FALSE);   // locale support
#else
    std::string riga;
    riga = "cp -f \"";
    riga.append(fileold) ;
    riga.append("\" \"");
    riga.append(filenew);
    riga.append("\"");
    int ier = system(riga.c_str());
    if(ier == -1)
       g_print("Error in mr_CopyFile\n");
#endif
}

char *filtra (const char *str, const char *delimiter)
{
using namespace std;
    string f1 = str;
    size_t found = f1.find_first_of(delimiter);
    while (found!=string::npos)
    {
       f1.erase(found,1);
       found = f1.find_first_of(".*",found);
    }
    return g_strdup(f1.c_str());
}

std::string filtranl (const char *str)
{
using namespace std;
    string f1 = str;
    string f2 = filtrastr(f1, '\r');
    f1.assign(filtrastr(f2, '\n'));
    return f1;
}

#if 0
char *filtranl (const char *str)
{
using namespace std;
    string f1 = str;
    string f2 = filtrastr(f1, '\r');
    f1.assign(filtrastr(f2, '\n'));
    return g_strdup(f1.c_str());
}
#endif

char *filtrapercb(std::string &s)
{
   std::string s1;
   for(int i=0; i<(int)s.length(); i++)
   {
       if(s.at(i) == PERCENTO)
          s1.append(1, PERCENTO);
       s1.append(1, s.at(i));
   }
   return DuplicaStringa(s1.c_str());
}

std::string filtrastr(const std::string &s, const char c)
{
   std::string s1;
   for(int i=0; i<(int)s.length(); i++)
   {
       if(s.at(i) != c)
          s1.append(1, s.at(i));
   }
   return s1;
}

char *str_cut(char *str, const char *c)
{
using namespace std;
    string f1 = str;
    size_t found = f1.find_first_of(c);
    if (found!=string::npos)
       f1.erase(found);
    return g_strdup(f1.c_str());
}
     
const gchar *toUTF8(const gchar *localname)
{
    const gchar *ptr;
    if( g_utf8_validate(localname, -1, &ptr) )
      return localname;
    else
    {
      gchar *_name;
      gsize fleng;
      _name = g_locale_to_utf8(localname,-1,&fleng,&fleng,NULL);
      if(_name == NULL)
      {
        if(fleng > 0)
        {
           std::string nome = localname;
           _name = DuplicaStringa(nome.substr(0,fleng).c_str());
        }
        else
           return " ";
      }
      return _name;
    }
}

/************************************************************/
/*************** Chemical elements management ***************/
/************************************************************/
int is_valid_symbol(const char *el, int Ntot)
{
    if(!Ntot)
       Ntot = N_ELEMENTS;
    std::string str = el;
    for(int i=0; i<Ntot; i++)
    {
      if( g_ascii_strcasecmp(trim(str).c_str(), JAV_ELEMENTY[i].szSymbol)==0 )
        return i+1;
    }
    return 0;
}

const char *get_nth_element(int num)
{
    if((num >=0) && (num < N_ELEMENTS))
       return JAV_ELEMENTY[num].szSymbol;
    return "Q";
}

const char *get_nth_element_name(int num)
{
    if((num >=0) && (num < N_ELEMENTS))
       return JAV_ELEMENTY[num].szString;
    return "Q";
}

int ZFromPtab(int ptab)
{
    if((ptab >=0) && (ptab < N_ELEMENTS))
       return JAV_ELEMENTY[ptab].Z;
    return 0;
}

float *get_elem_color(int num)
{
    float *col = g_new0(float, 4);
    if((num >=0) && (num < N_ELEMENTS))
    {
       for(int i=0; i<4; i++)
          col[i] = JAV_ELEMENTY[num].color[i];
    }
    return col;
}

float *get_amino_color(int num)
{
    float *col = g_new0(float, 4);
    if((num >=0) && (num < N_AMINO))
    {
       for(int i=0; i<4; i++)
          col[i] = JAV_AMINO[num].color[i];
    }
    return col;
}

float *get_chain_color(int num)
{
    float *col = g_new0(float, 4);
    if((num >=0) && (num < N_CHAINS))
    {
       for(int i=0; i<4; i++)
          col[i] = JAV_CHAIN[num].color[i];
    }
    return col;
}

float *get_struct_color(int num)
{
    float *col = g_new0(float, 4);
    if((num >=0) && (num < N_STRUCT))
    {
       for(int i=0; i<4; i++)
          col[i] = JAV_STRUCTURE[num].color[i];
    }
    return col;
}

float *get_base_color(int num)
{
    float *col = g_new0(float, 4);
    if((num >=0) && (num < N_DNA_NUCLEOTIDES))
    {
       for(int i=0; i<4; i++)
          col[i] = JAV_DNA_NUCLEOTIDES[num].color[i];
    }
    return col;
}

float *get_gen_color(int num)
{
    if(num < N_ELEMENTS)
       return get_elem_color(num);
    else if(num < (N_AMINO+N_ELEMENTS))
       return get_amino_color(num-N_ELEMENTS);
    else if(num < (N_ELEMENTS+N_AMINO+N_CHAINS))
       return get_chain_color(num-N_ELEMENTS-N_AMINO);
    else if(num < (N_ELEMENTS+N_AMINO+N_CHAINS+N_DNA_NUCLEOTIDES))
       return get_base_color(num-N_ELEMENTS-N_AMINO-N_CHAINS);
    else if(num < (N_ELEMENTS+N_AMINO+N_CHAINS+N_DNA_NUCLEOTIDES+N_STRUCT))
       return get_struct_color(num-N_ELEMENTS-N_AMINO-N_CHAINS-N_DNA_NUCLEOTIDES);
    else
    {
       float *col = g_new0(float, 4);
       if(num == (N_ELEMENTS+N_AMINO+N_CHAINS+N_DNA_NUCLEOTIDES+N_STRUCT))
       {
          col[0] = 0;
          col[1] = 0.8f;
          col[2] = 0.8f;
          col[3] = 1;
       }
       return col;
    }
}

int IsAmino(const char *resname)
{
    if(!resname)
       return 0;
    for(int i=0; i<N_AMINO; i++)
    {
        std::string amino = JAV_AMINO[i].szSymbol;
        if(g_ascii_strcasecmp(amino.substr(1,3).c_str(), resname) == 0)
           return (i+1);
    }
    return 0;
}

int IsDNA(const char *resname, const char *elem_name)
{
    static const char *elem_DNA[] = {"h", "c", "n", "o", "p"};
    int N_elem_DNA = (int)G_N_ELEMENTS(elem_DNA);
    if(!resname)
       return 0;
    for(int i=0; i<N_DNA_NUCLEOTIDES; i++)
    {
        std::string amino = JAV_DNA_NUCLEOTIDES[i].szSymbol;
        if(g_ascii_strcasecmp(amino.substr(2,2).c_str(), resname) == 0)
           return (i+1+N_AMINO);
    }
    for(int i=0; i<N_DNA_NUCLEOTIDES; i++)
    {
        std::string amino = JAV_DNA_NUCLEOTIDES[i].szCode;
        if(g_ascii_strcasecmp(amino.c_str(), resname) == 0)
           return (i+1+N_AMINO);
    }
    if(strlen(resname) <= 1)
       return 0;
    if(elem_name != NULL)
    {
       bool found = false;
       for(int i=0; i<N_elem_DNA; i++)
           if(strcmp(elem_name, elem_DNA[i]) == 0)
              found = true;
       if(!found)
          return 0;
    }
    char c = toupper(resname[1]);
    for(int i=0; i<N_DNA_NUCLEOTIDES; i++)
    {
        char c1 = JAV_DNA_NUCLEOTIDES[i].szCode[0];
        if(c == c1)
           return (i+1+N_AMINO);
    }
    return 0;
}

bool IsWater(const char *resname)
{
    if(!resname)
       return false;
    if(g_ascii_strcasecmp("HOH", resname) == 0)
       return true;
    if(g_ascii_strcasecmp("WAT", resname) == 0)
       return true;
    return false;
}

int IsAminoNucle(const char *resname, const char *elem_name)
{
    int n = IsAmino(resname);
    if(n)
       return(n);
    n = IsDNA(resname, elem_name);
    if(n)
       return(n);
    if(IsWater(resname))
       return(N_AMINO+N_DNA_NUCLEOTIDES+1);
    return (N_AMINO+N_DNA_NUCLEOTIDES+1);
}

const char *get_AminoCode(int num)
{
    if((num >0) && (num <= N_AMINO))
       return (JAV_AMINO[num-1].szCode);
    else if((num >N_AMINO) && (num <= (N_AMINO+N_DNA_NUCLEOTIDES)))
       return (JAV_DNA_NUCLEOTIDES[num-N_AMINO-1].szCode);
    return "X";
}

const char *get_nth_amino(int num)
{
    if((num >=0) && (num < N_AMINO))
       return (JAV_AMINO[num].szSymbol);
    return " Any";
}

const char *get_nth_chain(int num)
{
    if((num >=0) && (num < N_CHAINS))
       return (JAV_CHAIN[num].szString);
    return "   ";
}

const char *get_nth_struct(int num)
{
    if((num >=0) && (num < N_STRUCT))
       return (JAV_STRUCTURE[num].szString);
    return "   ";
}

const char *get_nth_base(int num)
{
    if((num >=0) && (num < N_DNA_NUCLEOTIDES))
       return (JAV_DNA_NUCLEOTIDES[num].szString);
    return "   ";
}

/*******************   M e s s a g e    D i a l o g s  **************************/
gboolean destroy_dlg(gpointer data )
{
     gtk_widget_destroy((GtkWidget*) data);
     return FALSE;
}

 int MessageDialog(GtkWidget *parent, GtkMessageType type, GtkButtonsType buttons,
                    const gchar *message, ...)
{
  gchar* msg = NULL;
  va_list args;
  int response;

  if (message)
  {
      va_start (args, message);
      msg = g_strdup_vprintf (message, args);
      va_end (args);
   }
   std::string msgstr = msg;
   gchar *msgf = filtrapercb(msgstr);
   response = MessageDialog(NULL, 0, 0, parent, type, buttons, msgf);
   g_free (msg);
   g_free (msgf);
   return response;
}

 int MessageDialog(const char *title, GtkWidget *parent, GtkMessageType type, GtkButtonsType buttons,
                    const gchar *message, ...)
{
  gchar* msg = NULL;
  va_list args;
  int response;

  if (message)
  {
      va_start (args, message);
      msg = g_strdup_vprintf (message, args);
      va_end (args);
   }
   std::string msgstr = msg;
   gchar *msgf = filtrapercb(msgstr);
   response = MessageDialog(title, 0, 0, parent, type, buttons, msgf);
   g_free (msg);
   g_free (msgf);
   return response;
}

double CellVolume(const double cella[])
{
    enum { a = 0, b, c, alpha, beta, gamma};
    double V, ca, cb, cg;

    ca = Cos(cella[alpha]);
    cb = Cos(cella[beta]);
    cg = Cos(cella[gamma]);

    V = 1.0 - ca*ca - cb*cb - cg*cg + 2.0*ca*cb*cg;
    if( V<0.0 )
      V = 0.0;
    V = cella[a]* cella[b]* cella[c] * sqrt(V);
    return V;
}

double CellVolume(const float cella[])
{
   const double dCell[6] = {(double) cella[0], (double) cella[1],
                            (double) cella[2], (double) cella[3],
                            (double) cella[4], (double) cella[5]};
   return CellVolume(dCell);
}

int AnalizzaSequenza(const std::string &buf)
{
     const std::string Acids = "ACEGPRTUXYZ";
     for(unsigned int i=0; i<strlen(buf.c_str()); i++)
     {
         char seqchar = buf.c_str()[i];
         if(isupper(seqchar))
         {
            bool found = false;
            for(unsigned int j=0; j<strlen(Acids.c_str()); j++)
            {
                char acid = Acids.c_str()[j];
                if(seqchar == acid)
                {
                   found = true;
                   break;
                }
            }
            if(!found)
               return 1;

         }
      }
      return 2;
}

int ContentFromSequenceFile(const char *SeqFile, int NumSpec[])
{
      int nResidui = 0;  
      bool errore = false;

      if(!str_white(SeqFile))
      {
         FILE *fp = fOpen(SeqFile, "r");
         if( fp)
         {
            gchar *buf = g_new0(gchar, MaxLen);
            if(fgets(buf, MaxLen, fp))
            {
               if(buf[0] != '>')
                  errore = true;
            }
            else
               errore = true;
            while(fgets(buf, MaxLen, fp) && !errore)
            {
               if(str_white(buf))
                  //errore = true;
                  continue;
               else if(buf[0] != '>')
               {
                  std::string buff = buf;
                  int nResLoc = 0;
                  GString *gseq = g_string_new(buff.c_str());
                  const std::string seque = g_string_ascii_up(gseq)->str;

                  int ifRSeq = AnalizzaSequenza(seque);
                  for(unsigned int i=0; i<strlen(seque.c_str()); i++)
                  {
                      char seqchar = seque.c_str()[i];
                      if(isupper(seqchar))
                      {
                         nResidui++;
                         nResLoc++;
                         int j = seqchar - 'A';
                         if ( (seqchar == 'X') && (ifRSeq == 2) )
                            continue;
                         if ( (seqchar == 'X') && (ifRSeq == 1) )
                            j = 0;
                         if(ifRSeq == 1)
                         {
                             for(int k=1; k<5; k++)
                                 NumSpec[k] += RES_C[j][k-1];
                         }
                         else
                         {
                             for(int k=0; k<4; k++)
                                 NumSpec[k] += AMI_C[j][k];
                             NumSpec[5] += AMI_C[j][4];
                         }
                      }
                      else if( (seqchar == ' ') || (seqchar == '-') )
                         ;
                      else if( (seqchar == '*') && (ifRSeq == 1) )
                         ;
                      else if( (seqchar == '\n') || (seqchar == '\r') )
                         ;
                      else
                         errore = true;
                  }
                  if(ifRSeq == 1)
                     NumSpec[0] += iround(nResLoc * DHPerResidue);
               }
            }
            fclose(fp);
            g_free(buf);
         }
      }
      if(errore)
         return -1;
      return nResidui;
}

float Minimo (float vett[], int n)
{
   return *std::min_element(vett, vett+n);
}

float Massimo (float vett[], int n)
{
   return *std::max_element(vett, vett+n);
}

bool compare_names(const std::string &fn1, const std::string &fn2)
{
#ifdef _WIN32
    return g_ascii_strcasecmp(fn1.c_str(), fn2.c_str())==0;
#else
    return strcmp(fn1.c_str(), fn2.c_str())==0;
#endif
}

const char *FindProg(const char *filter, const char *where)
{
    GDir *dir;
    const gchar *name;
    GPatternSpec *pattern = g_pattern_spec_new(filter);

    dir = g_dir_open (where, 0, NULL);
    if (!dir)
      return NULL;
    name = g_dir_read_name (dir);
    while (name != NULL)
    {
        gchar *path;
        gboolean is_dir;

        path = g_build_filename (where, name, NULL);
        is_dir = g_file_test (path, G_FILE_TEST_IS_DIR);
        if(is_dir)
        {
           if(g_pattern_match_string (pattern, g_utf8_casefold(name, -1)))
              break;
        }
        g_free (path);
        name = g_dir_read_name (dir);
   }
   return name;
}

//----------------------------------------------------------
//   Routiner chiamate dal Fortran                           
//----------------------------------------------------------
extern "C"
{

void c_copyfile_(char *src, char *dst)
{
#ifdef NDEBUG   // nessun controllo in fase di debug
    if(g_file_test (src, G_FILE_TEST_EXISTS))
#endif
       mr_CopyFile(src, dst);
}

void c_controlladir_ (char *dirname, int *ierw)
{
   *ierw = mr_access(dirname, 'm');
}

int mrchdir_ (char *NewDir)
{
   return dir_set_current(NewDir);
}

int mrgetenv_ (void)
{
#ifdef _WIN32
	return 1;
#else
	return 0;
#endif
}

void mrgetpwd_ (char *cwd, int *lstr, int *ier)
{
//   size_t sz = *lstr;
   char *curdir = getPWD();
   CopiaStringa(cwd, MaxLenFilename, curdir);
   g_free(curdir);

  *lstr = (int) strlen(cwd);

  if(*lstr > 0)
  {
     if(cwd[*lstr-1] == G_DIR_SEPARATOR)
     {
        cwd[*lstr-1] = '\0';
        (*lstr)--;
     }
     *ier = 0;
  }
  else
     *ier = -1;
}

/*-------------------------------------------------------------*/
/*   mrsirtm                      Time & date routine          */
/*-------------------------------------------------------------*/

void mrsirtm_ (char *datestring)
{
     struct tm tm;

     OraCorrente(&tm);
     OraFormatoasc(&tm, datestring);
}

int mrmillisec_ (void)
{
    int timer;

    GetMillisec(&timer);
    return (timer);
}

void fget_program_directory_(char *exedir, int *l1)
{
   size_t sz = *l1;
   nomefile servdir;
   get_servdir(servdir);
   ScriviStringa(exedir, sz, "%s%c", servdir, G_DIR_SEPARATOR);
   *l1 = (int) strlen(exedir);
}

int formatta_msgbis_(const char *MsgIn, int *plriga)
{
   int lung, lriga;
   char *msgin = DuplicaStringa(MsgIn);

   lung = -1;
   lriga = *plriga;
   if((lung = (int) strlen(msgin)) > 0)
       CutStrc(msgin, &lung, lriga);
   return (lung+1);
}

void mr_setenv_(char *string)          /* string = 'NAME=VAL' */
{
#ifdef _WIN32
_putenv(string);
#else
putenv(string);
#endif
}

void spec_char_(int *chr, char *str, int *l1)
{
    gunichar car;
    char *str1= g_new0(char, 7);
    size_t sz = *l1;

    car = gdk_keyval_to_unicode(*chr);
    g_unichar_to_utf8(car, str1);
    ScriviStringa(str, sz, "%s",str1);
}

void c_stop_(char *str, int *ifHidden)
{
   char *messaggio = g_new0(char, 500);
   CopiaStringa(messaggio, 500, "Program Stopped.\n");
   if(strlen(str))
      AppendiStringa(messaggio, 500, str);
   AppendiStringa(messaggio, 500, "\nCheck Output File.\n");

#ifdef _WIN32
   {
       int ifShow = !(*ifHidden);
       (void) AllocConsole();
       char c;
       DWORD nchar;
       HANDLE inp = GetStdHandle(STD_INPUT_HANDLE);
       HANDLE out = GetStdHandle(STD_OUTPUT_HANDLE);
       if (ifShow)
            AppendiStringa(messaggio, 500, "Press <Return> to close.\n");
       WriteConsole(out, messaggio, (DWORD) strlen(messaggio), &nchar, NULL);
       if (ifShow)
           ReadConsole (inp, &c, 1, &nchar, NULL);
       FreeConsole();
   }
#else
       printf("%s\n", messaggio);
#endif
   exit(-1);
}

void c_pause_(char *str, int *ifHidden)
{
   int ifShow = !(*ifHidden);
   char *messaggio = g_new0(char, 500);
   if(strlen(str))
      CopiaStringa(messaggio, 500, str);
   AppendiStringa(messaggio, 500, "\nPress <Return> to continue.");

#ifdef _WIN32
   {
       (void) AllocConsole();
       char c;
       DWORD nchar;
       HANDLE inp = GetStdHandle(STD_INPUT_HANDLE);
       HANDLE out = GetStdHandle(STD_OUTPUT_HANDLE);
       WriteConsole(out, messaggio, (DWORD) strlen(messaggio), &nchar, NULL);
       if (ifShow)
           ReadConsole (inp, &c, 1, &nchar, NULL);
       FreeConsole();
   }
#else
   {
       char dum;
       printf("%s\n", messaggio);
       if (ifShow)
           (void) scanf("%c", &dum);
   }
#endif
}

void toflushc_()
{
    fflush(NULL);
}

int get_configdir_(char *dirnam, int *l1)
{
      size_t sz = *l1;
      gchar *hd = getHomeDir();
#ifdef CONFIG_DIR
      gchar *cfd = Ambiente(CONFIG_DIR);
      if(cfd)
         ScriviStringa(dirnam, sz, "%s", cfd);
      else
         ScriviStringa(dirnam, sz, "%s", hd);
      if(cfd)
         g_free(cfd);
#else
      ScriviStringa(dirnam, sz, "%s", hd);
#endif
      free(hd);
      if(mr_access(dirnam, 'm') == 0)
      {
         MsgWinErr_nogtk( "You must set the environment variable\n            "
                           "SIRCFGDIR\n to a directory with write permission!\n"
                           "(see \"Installing the program\" in Help)", -SEVERE_ERR_WINDOW);
         return -1;
      }
      return 0;
}

void c_manage_console_(int *Action)
{
#ifdef _WIN32
      COORD wpos;
      HANDLE my_handle;
      BOOL status;
      switch (*Action)
      {
      case 1:
            AllocConsole();
            my_handle = GetStdHandle(STD_OUTPUT_HANDLE);
            wpos.X = 80;
            wpos.Y = 24;
            status = SetConsoleScreenBufferSize(my_handle, wpos);
            break;
      case 2:
            FreeConsole();
            break;
      }
#endif
}

int cesisteprogramma_(char *progname)
{
    char *tmp = find_program_in_path(progname);
    if(tmp)
    {
       g_free(tmp);
       return 1;
    }
    return 0;
}

int kresiduo_(char *name, char *elemento)
{
    int result = IsAminoNucle(g_strstrip(name), g_strstrip(elemento));
    if (result > (N_AMINO+N_DNA_NUCLEOTIDES))
        result = 0;
    return result;
}

int numcpu_()
{
    return nCPU();
}

void c_removefile_(char *file)
{
    Cancella(file);
}


int getccp4vars_(char *pathCCP4, char *pathPython, int *l)
{
     int ifCCP4 = 0;
     const char *ambccp4 = Ambiente("CCP4_MASTER");
     if(ambccp4 != NULL)
     {
        char *path = g_strdup(Ambiente("CBIN"));
        if(path != NULL)
        {
           ifCCP4 = 1;
           ScriviStringa(pathCCP4, *l, "%s", path);
           g_free(path);
           path = find_program_in_path("python");
           if(path == NULL)
           {
              path = g_strdup(FindProg("python*", ambccp4));
              if(path)
              {
                 char *path1 = g_build_filename (ambccp4, path, "python", NULL);
                 ScriviStringa(pathPython, *l, "%s", path1);
                 g_free(path1);
                 g_free(path);
              }
              else
                 ifCCP4 = 0;
           }
           else
           {
              ScriviStringa(pathPython, *l, "%s", path);
              g_free(path);
           }
        }
     }
     return ifCCP4;
}
}   //end extern "C"

#define MAX_LEN 512
int leggixen(const char *file1)
{
    char rigar[MAX_LEN+1];
    float co[4] = {0.f, 0.f, 0.f, 1.f};
    FILE *fp = fOpen(file1, "r");
    if( !fp)
    {
       printf ("Could not read file: %s\n",file1);
       return -1;
    }
    if(fgets(rigar,MAX_LEN,fp) == NULL)
        return -1;
    if(fgets(rigar,MAX_LEN,fp) == NULL)
        return -1;
    int stride = atoi(rigar);
    for(int i=0; i< stride*(N_TRUE_ELEMENTS+1); i++)
        if(fgets(rigar,MAX_LEN,fp) == NULL)
           break;
    int k = -1;
    int kk = 0;
    while(fgets(rigar,MAX_LEN,fp) != NULL)
    {
        k++;
        kk = k / stride;
        if((k % stride) == 0) 
        {
           std::string riga = rigar;
           std::size_t found = riga.find(" ");
           std::string temp = riga.substr(found+1);
           found = temp.find_first_not_of(' ');
           std::string elem2 = temp.substr(found);
           int z = atoi(elem2.c_str());
           JAV_ELEMENTY[N_TRUE_ELEMENTS+kk].Z = z;
        }
        else if((k % stride) == (stride-1)) 
        {
           std::string riga = rigar;
           riga.erase(riga.end()-1, riga.end());
           std::size_t found = riga.find(" ");
           std::string elem1 = riga.substr(0, found);
           std::string temp = riga.substr(found+1);
           found = temp.find_first_not_of(' ');
           std::string elem2 = temp.substr(found);
           int jfin = (int) elem1.size();
           for(int j=1; j<jfin; j++)
               JAV_ELEMENTY[N_TRUE_ELEMENTS+kk].szSymbol[j] = elem1.at(j);
           JAV_ELEMENTY[N_TRUE_ELEMENTS+kk].szSymbol[0] = toupper(elem1.at(0));
           JAV_ELEMENTY[N_TRUE_ELEMENTS+kk].szSymbol[jfin] = '\0';
           jfin = (int) elem2.size();
           for(int j=1; j<jfin; j++)
               JAV_ELEMENTY[N_TRUE_ELEMENTS+kk].szString[j] = elem2.at(j);
           JAV_ELEMENTY[N_TRUE_ELEMENTS+kk].szString[0] = toupper(elem2.at(0));
           JAV_ELEMENTY[N_TRUE_ELEMENTS+kk].szString[jfin] = '\0';
           memcpy(JAV_ELEMENTY[N_TRUE_ELEMENTS+kk].color, co, 4*sizeof(float));
        }
    }
    fclose(fp);
    for(int i=N_TRUE_ELEMENTS+kk+1; i<N_ELEMENTS; i++)
    {
        memset(JAV_ELEMENTY[i].szString, '\0', sizeof(JAV_ELEMENTY[i].szString));
        memset(JAV_ELEMENTY[i].szSymbol, '\0', sizeof(JAV_ELEMENTY[i].szSymbol));
        memcpy(JAV_ELEMENTY[i].color, co, 4*sizeof(float));
        JAV_ELEMENTY[i].Z = 0;
    }
    return(N_TRUE_ELEMENTS+kk+1);
}

char *find_program_in_path(const char *progname)
{
   const char *separator;
   char *nome = NULL;
#ifdef _WIN32
   separator = ";";
#else
   separator = ":";
#endif
   if(progname == NULL)
      return NULL;
      
   gchar *basename = g_path_get_basename(progname);
   std::string path = Ambiente("PATH");
   gchar **paths = g_strsplit(path.c_str(), separator, -1);
   std::vector<std::string> strPaths;
   int i = 0;
   while(paths[i])
   {
       strPaths.push_back(paths[i]);
       i++;
   }
   char *tmp = g_path_get_dirname(progname);
   strPaths.push_back(tmp);
   g_free(tmp);
   g_strfreev(paths);
   bool found = false;
   for(i=0; (i<(int)strPaths.size())&&!found; i++)
   {
      char *name = g_build_filename( strPaths.at(i).c_str(), basename, NULL);
#ifndef _WIN32
      if(g_file_test(name, G_FILE_TEST_IS_REGULAR))
      {
#endif
         if(g_file_test(name, G_FILE_TEST_IS_EXECUTABLE))
        {
            nome = g_strdup(name);
            found = true;
        }
#ifndef _WIN32
      }
#else
      if(!found)
      {
         if(g_file_test(name, G_FILE_TEST_EXISTS))
         {
            nome = g_strdup(name);
            found = true;
         }
         if(!found)
         {
             std::string nomecomp = name;
             nomecomp.append(".exe");
             if(g_file_test(nomecomp.c_str(), G_FILE_TEST_EXISTS))
             {
                nome = g_strdup(nomecomp.c_str());
                found = true;
            }
         }
      }
#endif
      g_free(name);
   }
   g_free(basename);
   strPaths.clear();
   return nome;
}

char *find_pattern_in_path()//std::vector<std::string> &Files)
{
    std::vector<std::string> Files;
    char *nome = NULL;
    GPatternSpec *pattern = g_pattern_spec_new("mopac*.exe");
   const char *separator;
#ifdef _WIN32
   separator = ";";
#else
   separator = ":";
#endif
   std::string path = Ambiente("PATH");
   gchar **paths = g_strsplit(path.c_str(), separator, -1);
   std::vector<std::string> strPaths;
   int i = 0;
   while(paths[i])
   {
       strPaths.push_back(paths[i]);
       i++;
   }
   g_strfreev(paths);
   for(i=0; i<(int)strPaths.size(); i++)
   {

    gchar *curdir = g_strdup(strPaths.at(i).c_str());
    GDir *dir = g_dir_open (curdir, 0, NULL);
    g_free(curdir);
    if (!dir)
      continue;
    const gchar *name = g_dir_read_name (dir);
    while (name != NULL)
    {
        gchar *path;
        gboolean is_dir;

        if (name[0] != '.')
        {
            char *cd =  g_strdup(strPaths.at(i).c_str());
            path = g_build_filename (cd, name, NULL);
            g_free(cd);
            is_dir = g_file_test (path, G_FILE_TEST_IS_DIR);
            if(!is_dir)
            {
               gchar *tmps = g_utf8_casefold(name, -1);
               if(g_pattern_match_string (pattern, tmps))
                  Files.push_back (g_strdup(path));
               g_free(tmps);
            }
            g_free (path);
        }
        name = g_dir_read_name (dir);
    }
    g_dir_close(dir);
    }
    g_pattern_spec_free(pattern);
    if(!Files.empty())
    {
       sort(Files.begin(), Files.end());
       size_t k = Files.size();
       nome = g_strdup(Files.at(k-1).c_str());
       Files.clear();
    }
    return nome;
}

void find_pattern_in_dir(const char *filtro, std::vector<std::string> &Files, const char *dir)
{
   GPatternSpec *pattern = g_pattern_spec_new(filtro);
   std::vector<std::string> strPaths;

   if(dir != NULL)
      strPaths.push_back(dir);
   else
   {
      const char *separator;
#ifdef _WIN32
      separator = ";";
#else
      separator = ":";
#endif
      std::string path = Ambiente("PATH");
      gchar **paths = g_strsplit(path.c_str(), separator, -1);
      int j = 0;
      while(paths[j])
      {
          strPaths.push_back(paths[j]);
          j++;
      }
      g_strfreev(paths);
   }

   for(int i=0; i<(int)strPaths.size(); i++)
   {

    gchar *curdir = g_strdup(strPaths.at(i).c_str());
    GDir *dir = g_dir_open (curdir, 0, NULL);
    g_free(curdir);
    if (!dir)
      continue;
    const gchar *name = g_dir_read_name (dir);
    while (name != NULL)
    {
        gchar *path;
        gboolean is_dir;

        if (name[0] != '.')
        {
            char *cd =  g_strdup(strPaths.at(i).c_str());
            path = g_build_filename (cd, name, NULL);
            g_free(cd);
            is_dir = g_file_test (path, G_FILE_TEST_IS_DIR);
            if(!is_dir)
            {
               gchar *tmps = g_utf8_casefold(name, -1);
               if(g_pattern_match_string (pattern, tmps))
                  Files.push_back (g_strdup(path));
               g_free(tmps);
            }
            g_free (path);
        }
        name = g_dir_read_name (dir);
    }
    g_dir_close(dir);
    }
    g_pattern_spec_free(pattern);
}

int IsValidOption(std::string opt, _OptStruct Opts[])
{
   std::string::size_type i1 =  opt.find_first_of("=");
   std::string trueopt = strstrip(opt);
   if(i1 != std::string::npos)
      trueopt = opt.substr(0, i1);
   int valid = -1;
   int i=0, k=0;
   while(Opts[i].str != NULL)
   {
       if(strcmp(trueopt.c_str(), Opts[i].str) == 0)
       {
          if(Opts[i].fort_opt)
             valid = -(k+1)*100 -i;
          else
             valid = (i+1)*100;
          break;
       }
       if(Opts[i].fort_opt)
          k++;
       i++;
   }
   return valid;
}

float ValoreCif(std::string str)
{
    std::stringstream S(str);
    float v;
    S >> v;
    return v;
}

std::string noBlank(std::string s)
{
   std::string t = "";
   for(size_t i=0; i<s.length(); i++)
       if(s.at(i) != ' ') t.push_back(s.at(i));
   return t;
}

bool get_matrices(const char *input, int RMatrix[3][3], float TMatrix[3])
{
using namespace std;
    vector<string> linee;
    int cifra;
    float a1, a2;

    string string0 = lower_case(input);
    string xyz = "xyz";
    string stringa = noBlank(trim(string0));

    for(int i=0; i<3; i++)
    {
        TMatrix[i] = 0;
        for(int j=0; j<3; j++)
            RMatrix[i][j] = 0;
    }
    size_t k = stringa.find(',');
    if(k == string::npos)
       return false;
    linee.push_back(stringa.substr(0, k));
    stringa.erase(0, k+1);
    k = stringa.find(',');
    if(k == string::npos)
       return false;
    linee.push_back(stringa.substr(0, k));
    stringa.erase(0, k+1);
    linee.push_back(stringa);
     
    for(int j=0; j<3; j++)
    {
        size_t ls = 0;
        for(int l=0; l<3; l++)
        {
            ls = linee.at(j).find (xyz[l]);
            if (ls != string::npos)
            {
                if(ls == 0)
                {
                   cifra = 1;
                   linee.at(j).erase(ls, 1);
                }
                else
                {
                   if(linee.at(j).at(ls-1) == '+')
                   {
                      cifra = 1;
                      linee.at(j).erase(ls-1, 2);
                   }
                   else if(linee.at(j).at(ls-1) == '-')
                   {
                      cifra = -1;
                      linee.at(j).erase(ls-1, 2);
                   }
                   else
                      return false;
                }
                RMatrix[j][l] = cifra;
            }
        }
        if(!linee.at(j).empty())
        {
           k = linee.at(j).find('/');   
           if(k != string::npos)
           {
              a1 = ValoreCif(linee.at(j).substr(0, k));
              a2 = ValoreCif(linee.at(j).substr(k+1));
              a1 = a1 / a2;
           }
           else
              a1 = ValoreCif(linee.at(j));
           TMatrix[j] = a1;
        }
    }
    return true;
}

