! ----------------------------------------------------------------------
      subroutine MoveBaric(ii, jj, iAct)
      USE Molcom
      USE TestModel
      USE Dialogo, only : ModelToCompare
!
      common /rot1/ BarVett(3), v1, v2, IfScaleO

      dimension iAct(20)
! ---
      ifScaleO = ifScale
      ifScale = 0
      iAct(3) = 0
      BarVett(1) = (xyz(1, jj) + xyz(1, ii)) / 2
      BarVett(2) = (xyz(2, jj) + xyz(2, ii)) / 2
      BarVett(3) = (xyz(3, jj) + xyz(3, ii)) / 2
      do i = 1, NatMol + NatSpi
         xyz(1, i) = xyz(1, i) - BarVett(1)
         xyz(2, i) = xyz(2, i) - BarVett(2)
         xyz(3, i) = xyz(3, i) - BarVett(3)
      enddo
      v1 = BarVett(1)
      v2 = BarVett(2)
      Xmin = Xmin - v1
      Ymin = Ymin - v2
      XMax = XMax - v1
      YMax = YMax - v2
*     if (ifViewModel == 1) then
      if (ModelToCompare == 2) then
          do i = 1, nCoordPub
             xyzPub(1, i) = xyzPub(1, i) - BarVett(1)
             xyzPub(2, i) = xyzPub(2, i) - BarVett(2)
             xyzPub(3, i) = xyzPub(3, i) - BarVett(3)
          enddo
      endif
! ---
      return
      end
! ----------------------------------------------------------------------
      subroutine RestoreBaric(iAct)
      USE Molcom
      USE TestModel
      USE Dialogo, only : ModelToCompare
!
      common /rot1/ BarVett(3), v1, v2, IfScaleO
      dimension iAct(20)
! ---
      BarVett(1) = 0.
      BarVett(2) = 0.
      BarVett(3) = 0.
      do i = 1, NatMol
         BarVett(1) = BarVett(1) + xyz(1, i)
         BarVett(2) = BarVett(2) + xyz(2, i)
         BarVett(3) = BarVett(3) + xyz(3, i)
      enddo
      BarVett(1) = BarVett(1) / NatMol
      BarVett(2) = BarVett(2) / NatMol
      BarVett(3) = BarVett(3) / NatMol
      do i = 1, NatMol + NatSpi
         xyz(1, i) = xyz(1, i) - BarVett(1)
         xyz(2, i) = xyz(2, i) - BarVett(2)
         xyz(3, i) = xyz(3, i) - BarVett(3)
      enddo
      v1 = BarVett(1)
      v2 = BarVett(2)
      Xmin = Xmin - v1
      Ymin = Ymin - v2
      XMax = XMax - v1
      YMax = YMax - v2
      ifScale = ifScaleO
      iAct(3) = ifScaleO
*     if (ifViewModel == 1) then
      if (ModelToCompare == 2) then
          do i = 1, nCoordPub
             xyzPub(1, i) = xyzPub(1, i) - BarVett(1)
             xyzPub(2, i) = xyzPub(2, i) - BarVett(2)
             xyzPub(3, i) = xyzPub(3, i) - BarVett(3)
          enddo
      endif
! ---
      return
      end
! ----------------------------------------------------------------------
      subroutine MoveAtoms(iAction)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
      USE BuildModule
!
      common /minma/ amin(3), amax(3)
! ---
! ---
      dimension cb(3), x1(3), r1(3), x2(3)
      dimension Inizio(500), ish(3), nMat(200), nCen(200)
      dimension el(3, 3), rj(3), iabc(3)
!
      krecy = 0
      nMaxAtm = 9800
      nptr = 1
      NATTrue = NatMol
!
      do 1 i = 1, 99
         if (ixp(i) .lt. 0) goto 2
    1 continue
    2 nvpol = i - 1
      n = 1
   11 n = n + 1
      if (ixp(n).eq.ixp(n - 1) .AND. iyp(n).eq.iyp(n - 1)) then
         do 12 i = n, nvpol - 1
            ixp(i) = ixp(i + 1)
            iyp(i) = iyp(i + 1)
   12    continue
         nvpol = nvpol - 1
         n = n - 1
      end if
      if (n.lt.nvpol) goto 11
   13 icont = 0
      do 16 i = 1, nvpol - 2
         do 14 j = i + 1, nvpol - 1
            if (IABS(iyp(i) - iyp(j)) .le. 2) THEN
               iyp(j) = iyp(j) - 1
               icont = -1
            end if
   14    continue
   16 continue
      if (icont .ne. 0) goto 13
!
      do 10 IJ = 1, NatMol
         if (RS(IJ) .gt. -10.) then
            ix = ipix(1,IJ)
            iy = ipix(2,IJ)
            in = Interno(ix, iy, nvPol)
            inn = Interno(ix, iy - 1, nvPol)
            if (in .eq. -2 .or. inn .eq. -2) then        !  e' interno
               nptr = nptr + 1
               kptr(nptr) = IJ                           !  al poligono
               if (nptr .eq. 1000) then
                   exit
               endif
            end if
         end if
   10 continue
! ---
      if (iAction.eq.1) then
         if (nptr.eq.1) then                             ! no atom in polygon
            iAction = -7
         end if
         return
      end if
! ---
   20 Tra(1, 1) = 1
      Tra(2, 1) = 0
      Tra(3, 1) = 0
      Tra(1, 2) = 0
      Tra(2, 2) = 1
      Tra(3, 2) = 0
      Tra(1, 3) = 0
      Tra(2, 3) = 0
      Tra(3, 3) = 1
!
      iCentrato = 0
      nce = 0
      nit = 3
      do 60 na = 1, NatMol
         xyz(1, na) = xyzs(1, na)
         xyz(2, na) = xyzs(2, na)
         xyz(3, na) = xyzs(3, na)
         iEqui(na) = na
         nOpEq(na) = 1555
   60 continue

      if (latt > 1) THEN
         call Centra(nce, Shf)
         iCentrato = -1
      end if
!RS--la routine va controllata per nOpEq()----!!!!!!!!!!!!!!!!!!!
      n = kptr(1)
      x1(1) = xyz(1, n)
      x1(2) = xyz(2, n)
      x1(3) = xyz(3, n)
      call MoltMatVec(rm,x1,x2)
      natot = NatMol
      nagr = nptr - 1    ! n. di atomi per gruppo
      do 200 n = 1, nSymMol
         Inizio(n) = natot + 1
         nMat(n) = n
         nCen(n) = 0
         do 150 i = 2, nptr
            na = kptr(i)
            call Ruota(n, na, cb, iabc, 0)
            idop = 0
            natot = natot + 1
            xyz(1, natot) = cb(1)
            xyz(2, natot) = cb(2)
            xyz(3, natot) = cb(3)
            iEqui(natot) = na
            nOpEq(natot) = n * 1000
            if (natot .eq. nMaxAtm - NatSpi) goto 480
  150    continue
  200 continue
      Inizio(nSymMol+1) = natot + 1
      IndIniz = nSymMol
      NatMol = natot
      if (iCentrato .ne. 0) THEN
         do 250 n=1, nce
            do 230 j=1, nSymMol
               iSta = Inizio(j)
               iEnd = Inizio(j + 1) - 1
               IndIniz = IndIniz + 1
               Inizio(IndIniz) = natot + 1
               nMat(IndIniz) = j
               nCen(IndIniz) = n
               do 220 na=iSta, iEnd
                  call Trasl(Shf, n, na, cb, iabc, 0)
                  natot = natot + 1
                  xyz(1, natot) = cb(1)
                  xyz(2, natot) = cb(2)
                  xyz(3, natot) = cb(3)
                  iEqui(natot) = iEqui(na)
c                  nOpEq(natot) = 10000 + (n+1) * 1000
*gl*              nnn=(n-1)*nSymMol+j           !RS--controllare!!!!!!!!!!!!
*gl*              nOpEq(natot) = nnn * 1000
                  nOpEq(natot) = 1555   ! secondo me: ora natot diventa asimm.
                  if (natot .eq. nMaxAtm - NatSpi) go to 480
  220          continue
  230       continue
  250    continue
         Inizio(IndIniz + 1) = natot + 1
      end if

      ngt = IndIniz
      natg = natot
      DistMin = 9999.
      n1 = kptr(1)
      do 450 ic = -2, 2
         do 440 ib = -2, 2
            do 430 ia = -2, 2
               do 420 ng=1, ngt
                  iSta = Inizio(ng)
                  iEnd = Inizio(ng + 1) - 1
                  Tra(1, 1) = ia
                  Tra(2, 1) = ib
                  Tra(3, 1) = ic
                  natot = natg
                  do 350 na = iSta, iEnd
                     call Trasl(Tra, 1, na, cb, iabc, 0)
                     call MoltMatVec(rm,cb,r1)
                     dist = 0.
                     do 340 ii=1, 3
                        Dist = Dist + (r1(ii) - x2(ii)) ** 2
  340                continue
                     if (Dist .lt. DistMin) then
                        DistMin = Dist
                        ngdm = ng
                        ish(1) = ia
                        ish(2) = ib
                        ish(3) = ic
                     end if
  350             continue
  420          continue
  430       continue
  440    continue
  450 continue
      iSta = Inizio(ngdm)
      iEnd = Inizio(ngdm + 1) - 1
      nMatr = nMat(ngdm)
         Tra(1, 1) = ish(1)
         Tra(2, 1) = ish(2)
         Tra(3, 1) = ish(3)
      do 460 na = 1, NATtrue
         cb(1) = xyz(1, na)
         cb(2) = xyz(2, na)
         cb(3) = xyz(3, na)
         call MoltMatVec(rm,cb,r1)
         ieq = iEqui(na)
         Lab(na) = Lab(ieq)
         rMLU(na) = rMLU(ieq)
         RS(na) = RS(ieq)
         iCol(na) = iCol(ieq)
         Lab(na) = Lab(ieq)
         xyz(1, na) = r1(1)
         xyz(2, na) = r1(2)
         xyz(3, na) = r1(3)
  460 continue
      NLeg = iconn(1)
      do 470 n = iSta, iEnd
         call Trasl(Tra, 1, n, cb, iabc, 0)
         call MoltMatVec(rm,cb,r1)
         i = n - iSta + 2
         na = kptr(i)
!
         if (nMatr .ne. 1) then
            do 462 j=1, 3
               do 464 k=1, 3
                  el(j,k) = Ell(j,k,na)
  464          continue
  462       continue
!RS            nMatr10000 = nMatr * 10000
            nMatr10000 = nMatr * 1000
            call EllEqui(el, nMatr10000)
            do 473 j=1, 3
               do 472 k=1, 3
                  Ell(j,k,na) = el(j,k)
  472          continue
  473       continue
         end if


         do 70 j=1, 3
  70     continue
         if (nOpEq(ii)/1000 .gt. 1) then
            call CDEqui(rj, nOpEq(ii))
         end if
!
!-- na e' un atomo che sto spostando.
!-- se esiste un bond tra na ed un atomo
!-- non compreso in kptr(i), il bond va eliminato.
!
         j = 0
         do 465 i = 1 , NLeg
            i1 = ( i - 1 ) * 3 + 2
            i2 = i1 + 1
            i3 = i1 + 2
            if (iconn(i3).eq.-1) go to 465
            n1 = iconn(i1)
            n2 = iconn(i2)
            if (n1.le.0.or.n2.le.0) go to 465
            if (n1.ne.na.and.n2.ne.na) go to 465
            if (n1.eq.na) then
                n3 = n2
            else
                n3 = n1
            endif
            iCancella = 1
            do 463 ii = iSta, iEnd
               iii = ii - iSta + 2
               na1 = kptr(iii)
               if (na1.eq.n3) then
                   iCancella = 0
               endif
  463       continue
            if (iCancella.eq.1) then
                iconn(i3) = 0
            endif
  465    continue
!
         xyzs(1, na) = cb(1)
         xyzs(2, na) = cb(2)
         xyzs(3, na) = cb(3)
         ieq = iEqui(na)
         Lab(na) = Lab(ieq)
         rMLU(na) = rMLU(ieq)
         RS(na) = RS(ieq)
         iCol(na) = iCol(ieq)
         xyz(1, na) = r1(1)
         xyz(2, na) = r1(2)
         xyz(3, na) = r1(3)
  470 continue
      do i=1,NatMol
         iOrd(i) = i
      end do


!
  480 NatMol = NATtrue
!
!-- check on List 5
!
      lixx = InfoOK(5)
**    rewind jhost
      do i=1,nats
         kblock(i) = 1
      enddo
c--mercedes 2mag2006
c      k = 1
c      do i=1, iconn(1)
c         k = k + 3
c         if (iconn(k) == 2) then
c             iconn(k) = 1
c         endif
c      enddo
      kact = 5
      call PrintMess('Computing connectivity. Please wait...')
      if (iconn(1) > 0) then
          iconn(1) = -iconn(1)
      endif
      call build(kact, 1)
      iAction = 1
      call GetBonds(iAction)
!
      if (lixx.gt.0) then
          call EllRest
          do i=1,nats
             lnz = iabs(nz(i)) / nzConst
             if (lnz.gt.0) then
                 kblock(i) = 0
                 VetChanges(1:5) = xyzs(1:5,i)
                 VetChanges(6) = bfac(i)
                 Labb = Lab(i)
                 iAction = 0
                 call ModModel(i,iAction,Labb,lnz,VetChanges)
                 if (bSav(i).gt.0.0) then
                     VetChanges(1) = Ell(1,1,i)
                     VetChanges(2) = Ell(1,2,i)
                     VetChanges(3) = Ell(1,3,i)
                     VetChanges(4) = Ell(2,2,i)
                     VetChanges(5) = Ell(2,3,i)
                     VetChanges(6) = Ell(3,3,i)
                     iAction = 7
                     call ModModel(i,iAction,Labb,lnz,VetChanges)
                 endif
             endif
          enddo
          iAction = 100
          call ModModel(i,iAction,Labb,lnz,VetChanges)
!
          jrest0 = 0
          call ModCom(jrest)
      endif
      call GetBonds(1)
!
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
!
      call PrintMess(' ')

      call ClearMessage()
!
      return
      end
! ----------------------------------------------------------------------
      subroutine RotByMouse(ix, iy)
      USE Molcom
      USE Poliedri
!
      common /SaveRbyM/ ifDragged, B(3,3), iDxV, iDyV,
     *                  ifLabelsDrag, iPlotTypeDrag
      common /RotMou/ iAnchorX, iAnchorY, IfDrag, IcanDrag, iDragEnabled
     *               ,mEv_fsBtn
      common /anglv/ AngoloV,iPlotTypeB,ifLabelsB
!
      integer Asse, Angolo, AngoloV
! ---
      Angolo = 0
      if(IfDrag.ne.0) then
         iDx = ix - iAnchorX
         iDy = iy - iAnchorY
         ifDragged = 1
         if(iDx.ne.0 .or. iDy.ne.0) then
            if (mEv_fsBtn.eq.1) then
               Arg = iDx*iDX + iDy*iDY
               DXY = sqrt(Arg)
               Angolo = 180. * DXY / kscry
               RK(3) = 1
               Asse = 4
               VV(1, 1) = iDy
               VV(1, 2) = iDx
               VV(1, 3) = 0
            else
               Asse = 3
               Angolo = 180. * iDx / kscry
            end if
         end if
         if (Angolo .ne. 0) then
            if (AngoloV.ne.0) then
               do i = 1 , 3
                  do j = 1 , 3
                     B(i, j) = 0
                  enddo
                  B(i, i) = 1
               enddo
               RK(1) = AngoloV
               RK(2) = asse
               if (mEv_fsBtn.eq.1) then
                   RK(3) = 1
                   VV(1, 1) = iDyV
                   VV(1, 2) = iDxV
                   VV(1, 3) = 0
               end if
               call CombRot(B)
               Asse = -iabs(Asse)
               VV(1, 1) = iDy
               VV(1, 2) = iDx
               VV(1, 3) = 0
            end if
            AngoloV = -Angolo
            call Rotaz(Angolo, Asse, B)
            iPlotType = STICKS    !  19 gennaio
            call Disegna(ifScale)
            iDxV = iDx
            iDyV = iDy
         end if
      else
         if (ifDragged.ne.0) then
            ifDragged = 0
            Angolo = 0
            if (iPlotTypeB.gt.0 .and. iPlotTypeB.lt.10) then
               iPlotType = iPlotTypeB
            else
               iPlotType = SIMPLE
            end if
            ifLabels = ifLabelsB
            call Disegna(0)
         else
         end if
      end if
! ---
      return
      end
! -------------------------------------------------------------------
      subroutine Tetrahedron(ifFromGraphic, ier)
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
!
!pgpi      common /AtomType/ nTp, kCentral, xyzTmp(3,5)
! ---
      dimension x1(3),r1(3)
      dimension xx(3, 5),xc(3),xxc(3),B(3, 3),P(3),BB(3,3)
      dimension xxo(11),xxn(11),key(10)
      dimension xxoo(11,22),kptrr(4)    
      dimension  xcr(3), xcr1(3) !pg210807,
!
      real *4 xyzn(3, 20, 16), xyzMed(3, 16)
      integer NUMxyzn(16), ipu(3), izPoint(20, 16),VetSpecSav(19)
      character *16 Labg(20, 16)
      dimension RRS(16)

! ---
      NatIndSav  = NatInd
      call FillVetSpec()
      call ResetLabelPos()
!
      kptrr(1:4) = kptr(1:4)
      nptrr = nptr

      ier = 0
      if (kCentral .eq. 0) then
         Inte = '      W A R N I N G . . '
         Msg = 'The central atom of the tetrahedron must be selected !'
         iExCode = 0
         call MsgWinErr(Inte,Msg,WARN_WINDOW,iExCode)
         ier = -1
         return
      end if

      NumAtCen = kCentral

! Ortonormalizza il catione

      if (ifFromGraphic == 1) then    !pg2409
         x1(1:3) = xyzs(1:3,kCentral)
         call MoltMatVec(rm,x1,r1)
         xx(:, 1) = r1(:)
      else
         xx(1:3, 1) = xyz(1:3, NumAtCen)
      end if

      kCentral = 0

      if (nptr .lt. 2) then
         Inte = '      W A R N I N G . . '
         Msg = 'Two atoms must be selected !'
         iExCode = 0
         call MsgWinErr(Inte,Msg,WARN_WINDOW,iExCode)
         ier = -1
         return
      end if

! Ortonormalizza gli anioni

      do i=1, nptr                    !pg2409 
         if (ifFromGraphic == 1) then          !pg210807
            x1(1:3) = xyzs(1:3,kptr(i))        !pg210807
         else                                  !pg210807
            x1(1:3) = xyztmp(1:3,i)
         end if                                !pg210807
         call MoltMatVec(rm,x1,r1)
         xx(:, i+1) = r1(:)
      enddo

      write(6,*) 'Tetrahedron A ',NumAtCen,kptr(1:2)
      write(6,'(a,2x,3f10.3)') Lab(NumAtCen),xyzs(1:3,NumAtCen)
      do i=1,nptr
         if (ifFromGraphic == 1) then          !pg2409
            write(6,'(a,2x,3f10.3)') Lab(kptr(i)),xyzs(1:3,kptr(i))
         else
            write(6,'(a,2x,3f10.3)') Lab(kptr(i)),xyztmp(1:3,i)
         end if
      end do
      write(6,*) 'Tetrahedron B'
      write(6,'(a,2x,3f10.3)') Lab(NumAtCen),xyz(1:3,NumAtCen)
      do i=1,nptr
         write(6,'(a,2x,3f10.3)') Lab(kptr(i)),xyz(1:3,kptr(i))
      end do

      MoreAtoms = 4 - nptrr
      MoreBonds = 4 - nptrr
      
      do k=NatMol + NatSpi, NatMol + 1, -1
         xyz(1:3, k + MoreAtoms) = xyz(1:3, k)
         RS(k + MoreAtoms) = RS(k)
         iCol(k + MoreAtoms) = iCol(k)
         Lab(k + MoreAtoms) = Lab(k)
         iEqui(k + MoreAtoms) = iEqui(k)
         rMLU(k + MoreAtoms) = rMLU(k)
      enddo

 
      xyzn(:,:,:) = 0.0
      NUMxyzn(:) = 0
      Nxyzn = 0
      izPoint(:,:) = 0
      
      do i = 1,nptrr
         xyzn(1:3,1,i) = xyz(1:3,kptrr(i))
         NUMxyzn(i) = 1
         Nxyzn= Nxyzn+ 1
         Labg(1,i)  = Lab(kptrr(i))
         izPoint(1,i) = kptrr(i)
      end do

!
      LE1(:,1:NumLeg) = LE(:,1:NumLeg)

      VetSpecSav(:) = VetSpec(:)

      NatMl = NatMol
      nAtInPiu = 0

      do i1=1, nptrr
         do i2 = i1+1, nptrr
            n1 = kptr(i1)
            n2 = kptr(i2)
      
            xc(1) = (xyz(1, n1) + xyz(1, n2)) / 2
            xc(2) = (xyz(2, n1) + xyz(2, n2)) / 2
            xc(3) = (xyz(3, n1) + xyz(3, n2)) / 2
      
            xxc(1) = (xx(1, i1+1) + xx(1, i2+1)) / 2
            xxc(2) = (xx(2, i1+1) + xx(2, i2+1)) / 2
            xxc(3) = (xx(3, i1+1) + xx(3, i2+1)) / 2
           
            VV(1, 1:3) = xc(1:3) - xyz(1:3, NumAtCen)

            Ang = 90
            RK(1) = Ang
            RK(2) = 4
            RK(3) = 1
            B(:,:) = 0
            do i = 1 , 3
               B(i, i) = 1
            enddo
            call CombRot(B)
            
            do i=1, 2
               nAtInPiu = nAtInPiu +1
               iap = NatMl + nAtInPiu
               
               if (i == 1) then
                  kpt = kptrr(i1)
               else
                  kpt = kptrr(i2)
               end if
               P(1) = xyz(1, kpt) - xc(1)
               P(2) = xyz(2, kpt) - xc(2)
               P(3) = xyz(3, kpt) - xc(3)
               do j = 1 , 3
                  Ppp = 0
                  do k = 1 , 3
                     Ppp = Ppp + B(j, k) * P(k)
                  enddo
                  xyz(j, iap) = - Ppp - xc(j) + 2 * xyz(j, NumAtCen)
               enddo
               lnz   = iabs(nz(kpt)/nzConst)
               RS(iap) = RS(kpt)
               
               RScr = RS(iap)
               
               iCol(iap) = iCol(kpt)
               iEqui(iap) = iEqui(kpt)
               nOpEq(iap) = nOpEq(kpt)  !?????????
               rMLU(iap) = rMLU(kpt)
               bfac(iap) = bfac(kpt)
               bSav(iap) = bSav(kpt)
               nz(iap) = nz(kpt)
               nzTot(iap) = lnz
               SinglePlotType(iap) = iPlotType
               xyzs(4, iap) = xyzs(4, kpt)
               xyzSk(4, NatInPiu) = xyzs(4, kpt)
               call CreaLab(iap,-1,lnz,Labb)
               Lab(iap) = Labb
               
!            write(6,'(a,2(3f10.5,5x))')Labb, xyz(1:3, iap),xyz(1:3,kpt)

                  
               call QualeVertice(xyzn,NUMxyzn,Nxyzn,iap,Labg,izPoint)
                  
!06-12
               if (i == 1) then
                  do ii=1, 3
                     VV(1, ii) = xxc(ii) - xx(ii, 1)
                  enddo
                  Ang = 90
                  RK(1) = Ang
                  RK(2) = 4
                  RK(3) = 1
                  BB(:, :) = 0
                  do ii = 1 , 3
                     BB(ii, ii) = 1
                  enddo
                  call CombRot(BB)  
               end if

               if (i == 1) then
                  kpt = i1 + 1
               else
                  kpt = i2 + 1
               end if
               P(1) = xx(1, kpt) - xxc(1)
               P(2) = xx(2, kpt) - xxc(2)
               P(3) = xx(3, kpt) - xxc(3)
               do j = 1 , 3
                  Ppp = 0
                  do k = 1 , 3
                     Ppp = Ppp + BB(j, k) * P(k)
                  enddo
!!!!                  xx(j, kpt) = - Ppp - xxc(j) + 2 * xx(j, 1)
                  x1(j) = - Ppp - xxc(j) + 2 * xx(j, 1)
               enddo
!!!!               x1(:) = xx(:, kpt)
        
               call MoltMatVec(rmi, x1, r1)
        
               xyzs(1:3, iap) = r1(1:3)
               xcr(1:3) = r1(1:3)   !pg210807
               xcr1(1:3) = x1(1:3)   !pg210807
!g             xyzSk(1:3, i-NatMl) = r1(1:3)
               xxoo(1:3,NatInPiu) = r1(1:3)
               
               write(6,'(3f10.5,5x,3f10.5)') r1,x1

                  NatMol = NatMol + 1
                  NatInd = NatMol


!               nptr = 1
!               kptr(1) = iap
!
!               write(6,10) NatMol,xcr
!   10          format(/,' NatMol = ',i5,/,' xcr()=',3f8.5,/)
!   
!               call Distance_pg(xcr, RScr, 3)   !pg210807
!            
!               if (kptr(1).gt.0) then
!                  NatMol = NatMol + 1
!                  NatInd = NatMol
!                  Lab(NatMol) = Labb
!                  xyz(1:3, iap) = xcr1(1:3)
!                  xyzSk(1:3, nAtInPiu) = xcr(1:3)
!               else
!                  nAtInPiu = nAtInPiu - 1
!               end if

!              else
!                 xyzSk(1:3, nAtInPiu) = r1(1:3)
!              end if
!06-12
            enddo
         enddo
      enddo

      write(lo,'(1h )')
      do j=1,20
         write(6,1313) Labg(j,:)
      end do
      write(lo,'(1h )')
 1313 format(6(a8,2x))
      do i=1,6
         do j=1,NUMxyzn(i)
             write(6,1314) i,Labg(j,i),xyzn(:,j,i)
         end do
         write(lo,'(1h )')
      end do
 1314 format (i5,3x,a8,3f10.4)
      do i=1,iap
         write(6,1315) i,Lab(i),xyz(1:3,i),xyzs(1:3,i)
      end do
      write(lo,'(1h )')
 1315 format(i5,3x,a8,3f10.4,5x,3f10.4)
 
      write(6,'(" valori medi:")')
 
      do i=1,16    !Nxyzn
       if (NUMxyzn(i) > 0) then
          xyzMed(:, i) = 0.0
          do j=1,NUMxyzn(i)
             k = izPoint(j, i)
             xyzMed(:, i) = xyzMed(:, i) + xyzs(:, k)
             write(6,'(10x,3f8.5)') xyzs(1:3,k)
          end do
          RRS(i) = RS(izPoint(1, i))
          xyzMed(:, i) = xyzMed(:, i) / NUMxyzn(i)
          write(6,'(2i5,3f8.5)') i,NUMxyzn(i),xyzMed(1:3,i)
       end if
      end do     
      
      do i=1,nptrr
         j = izPoint(1, i)
         xyzs(1:3, j) = xyzMed(1:3, i)
      end do

      write(6,"(' ')")
      write(6,'(a)') '-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ '
      do i=1,NatMl
         write(6,'(i5,3x,a8,3f10.5)') i, Lab(i), xyzs(1:3,i)
      end do 
      write(6,'(a)') '-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ '
      write(6,"(' ')")

!pg190907
      k = nptrr
      ii = NatMl
      NatMol = ii
      NatInPiu = 0
      NatInd = NatMol 
      VetSpec(:) = VetSpecSav(:) 
      do i=NatMl + 1, NatMl + MoreAtoms
         k = k + 1
         xcr(1:3) = xyzMed(1:3, k)
         RScr = RRS(k)
         nptr = 1                   
!         kptr(1) = ii              
         write(6,'(a,i5,3x,3f10.3)') 
     *             'Distanza di:',NatMol+1,xcr(1:3)                    

            call Distance_pg(xcr, RScr, 3)   !pg210807
            if (kptr(1).gt.0) then
               NatMol = NatMol + 1
               NatInd = NatMol
               NatInPiu = NatInPiu + 1
               xyzs(1:3, NatMol) = xcr(1:3)
               lnz   = iabs(nz(NatMol)/nzConst)
               call CreaLab(NatMol,-1,lnz,Labb)
               Lab(NatMol) = Labb
               xyzSk(1:3, nAtInPiu) = xcr(1:3)
            else
               dista = kptr(3)/10000.
               write (6,'(a,i6,3x,a,a,f10.4)') 'eliminato per:', 
     *         kptr(2),Lab(kptr(2)),'   distanza: ',dista
            end if
            
      end do    
   

      MoreAtoms = NatInPiu
     
      write(6,"(' ')")
      write(6,'(a)') '-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ '
      do i=1,NatInd
         write(6,'(i5,3x,a8,3f10.5)') i, Lab(i), xyzs(1:3,i)
      end do 
      write(6,'(a)') '-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ '
      write(6,"(' ')")


!06-12
!
!-- update list 5
!
      nNew = 0
      MoreAtoms = nAtInPiu
      MoreBonds = MoreAtoms
      do i=NatMl + 1, NatMl + MoreAtoms
         iser=i
         iactn=1
         khead=0
         xxo(1:3) = xyzsk(1:3,i-NatMl)
         xxo(4:11) = 0.0
         ksp=kspecb(newvet,xxo,xxn,key,itype,iser,khead,iactn)
!         xyzs(5,i) = 1.0 / float(key(10))
         xyzSk(5,i-NatMl) = 1.0 / float(key(10))
         if (ifFromGraphic == 1) then
             VetChanges(1) = xyzSk(1,i-NatMl)
             VetChanges(2) = xyzSk(2,i-NatMl)
             VetChanges(3) = xyzSk(3,i-NatMl)
             VetChanges(4) = xyzSk(4,i-NatMl)
             VetChanges(5) = xyzSk(5,i-NatMl)
             VetChanges(6) = biso
             Labb = Lab(i)
             lnz = iabs(nz(i)/nzConst)
             iAction = 1
             call ModModel(i,iAction,Labb,lnz,VetChanges)
         else
             nNew = nNew + 1
!             xyzSk(1:3,nNew) = xyzs(1:3,i)
!             xyzSk(1:3,nNew) = xyztmp(1:3,i-NatMl+2)
         end if
      enddo

!06-12

      do i = 1, NumLeg
         if (LE(1, i) .gt. NatMl) LE(1, i) = LE(1, i) + MoreAtoms
         if (LE(2, i) .gt. NatMl) LE(2, i) = LE(2, i) + MoreAtoms
      enddo
      NL = NumLeg - nlp
      do i = NumLeg, NL + 1, -1
         LE(1, i + MoreBonds) = LE(1, i)
         LE(2, i + MoreBonds) = LE(2, i)
         LE(3, i + MoreBonds) = 0
      enddo
      if (MoreBonds.ge.1) then
         LE(1, NL+1) = NumAtCen
         LE(2, NL+1) = NatMl + 1
         LE(3, NL+1) = 1
      end if
      if (MoreBonds.eq.2) then
         LE(1, NL+2) = NumAtCen
         LE(2, NL+2) = NatMl + 2
         LE(3, NL+2) = 1
      end if
      NumLeg = NumLeg + MoreBonds
      do i = 1, NumLeg
         LE1(1, i) = LE(1, i)
         LE1(2, i) = LE(2, i)
         LE1(3, i) = LE(3, i)
      enddo
      nLegInd = NumLeg
!
      if (ifFromGraphic == 1) then
          call LEtoIconn
          iAction = 100
          j       =   0
          Labb    = ' '
          call ModModel(j,iAction,Labb,lnz,VetChanges)
*gl*      call xupd05(i,iAction,Labb,lnz,VetChanges)
*gl*      iAction = 200
*gl*      call xupd05z(0)
!
          jrest0 = 0
          call Modcom(jrest0)
          call Disegna(IfScale)
      else
          nptr = nNew
          NatInd = NatIndSav
      endif
      write(6,*) 'Tetrahedron Fine, aggiunti ',nptr

      return
      end
! -------------------------------------------------------------------
      subroutine Tetrahedron_orig(ifFromGraphic, ier)
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
!
!pgpi      common /AtomType/ nTp, kCentral, xyzTmp(3,5)
! ---
      dimension x1(3),r1(3)
      dimension xx(3, 5),xc(3),xxc(3),B(3, 3),P(3),BB(3,3)
      dimension xxo(11),xxn(11),key(10)
      dimension xxoo(11,2),kptrr(2)    
      dimension  xcr(3), xcr1(3) !pg210807,
!
      NatIndSav  = NatInd
      call FillVetSpec()
      call ResetLabelPos()
!
      ier = 0
      if (kCentral .eq. 0) then
         Inte = '      W A R N I N G . . '
         Msg = 'The central atom of the tetrahedron must be selected !'
         iExCode = 0
         call MsgWinErr(Inte,Msg,WARN_WINDOW,iExCode)
         ier = -1
         return
      end if

      NumAtCen = kCentral

! Ortonormalizza il catione

      x1(1:3) = xyzs(1:3,kCentral)
      call MoltMatVec(rm,x1,r1)
      xx(:, 1) = r1(:)

      kCentral = 0

      if (nptr .lt. 2) then
         Inte = '      W A R N I N G . . '
         Msg = 'Two atoms must be selected !'
         iExCode = 0
         call MsgWinErr(Inte,Msg,WARN_WINDOW,iExCode)
         ier = -1
         return
      end if

! Ortonormalizza i due anioni

      do i=1, 2
         if (iffromgraphic == 1) then          !pg210807
            x1(1:3) = xyzs(1:3,kptr(i))        !pg210807
         else                                  !pg210807
            x1(1:3) = xyztmp(1:3,i)
         end if                                !pg210807
         call MoltMatVec(rm,x1,r1)
         xx(:, i+1) = r1(:)
      enddo

      write(6,*) 'Tetrahedron A ',NumAtCen,kptr(1:2)
      write(6,'(a,2x,3f10.3)') Lab(NumAtCen),xyzs(1:3,NumAtCen)
      write(6,'(a,2x,3f10.3)') Lab(kptr(1)),xyztmp(1:3,1)
      write(6,'(a,2x,3f10.3)') Lab(kptr(2)),xyztmp(1:3,2)
      write(6,*) 'Tetrahedron B'
      write(6,'(a,2x,3f10.3)') Lab(NumAtCen),xyz(1:3,NumAtCen)
      write(6,'(a,2x,3f10.3)') Lab(kptr(1)),xyz(1:3,kptr(1))
      write(6,'(a,2x,3f10.3)') Lab(kptr(2)),xyz(1:3,kptr(2))
      n1 = kptr(nptr-1)
      n2 = kptr(nptr)

      xc(1) = (xyz(1, n1) + xyz(1, n2)) / 2
      xc(2) = (xyz(2, n1) + xyz(2, n2)) / 2
      xc(3) = (xyz(3, n1) + xyz(3, n2)) / 2

      xxc(1) = (xx(1, 2) + xx(1, 3)) / 2
      xxc(2) = (xx(2, 2) + xx(2, 3)) / 2
      xxc(3) = (xx(3, 2) + xx(3, 3)) / 2

      MoreAtoms = 2
      MoreBonds = 2
      do k=NatMol + NatSpi, NatMol + 1, -1
         xyz(1:3, k + MoreAtoms) = xyz(1:3, k)
         RS(k + MoreAtoms) = RS(k)
         iCol(k + MoreAtoms) = iCol(k)
         Lab(k + MoreAtoms) = Lab(k)
         iEqui(k + MoreAtoms) = iEqui(k)
         rMLU(k + MoreAtoms) = rMLU(k)
      enddo

      VV(1, 1:3) = xc(1:3) - xyz(1:3, NumAtCen)

      Ang = 90
      RK(1) = Ang
      RK(2) = 4
      RK(3) = 1
      B(:,:) = 0
      do i = 1 , 3
         B(i, i) = 1
      enddo
      call CombRot(B)
!
      LE1(:,1:NumLeg) = LE(:,1:NumLeg)

      kptrr(1) = kptr(1)
      kptrr(2) = kptr(2)
      NatMl = NatMol
      nAtInPiu = 0
      do i=NatMl + 1, NatMl + MoreAtoms
         nAtInPiu = nAtInPiu +1
         iap = NatMl + nAtInPiu
         kpt = kptrr(i - NatMl)
         P(1) = xyz(1, kpt) - xc(1)
         P(2) = xyz(2, kpt) - xc(2)
         P(3) = xyz(3, kpt) - xc(3)
         do j = 1 , 3
            Ppp = 0
            do k = 1 , 3
               Ppp = Ppp + B(j, k) * P(k)
            enddo
            xyz(j, iap) = - Ppp - xc(j) + 2 * xyz(j, NumAtCen)
         enddo
         lnz   = iabs(nz(kpt)/nzConst)
         RS(iap) = RS(kpt)
         
         RScr = RS(iap)
         
         iCol(iap) = iCol(kpt)
         iEqui(iap) = iEqui(kpt)
         nOpEq(iap) = nOpEq(kpt)  !?????????
         rMLU(iap) = rMLU(kpt)
         bfac(iap) = bfac(kpt)
         bSav(iap) = bSav(kpt)
         nz(iap) = nz(kpt)
         nzTot(iap) = lnz
         SinglePlotType(iap) = iPlotType
         xyzs(4, iap) = xyzs(4, kpt)
         xyzSk(4, i-NatMl) = xyzs(4, kpt)
         call CreaLab(iap,-1,lnz,Labb)
         Lab(iap) = Labb
             write(6,'(a,2(3f10.5,5x))')Labb, xyz(1:3, iap),xyz(1:3,kpt)

!06-12
         if (i.eq.NatMl+1) then
            do ii=1, 3
              VV(1, ii) = xxc(ii) - xx(ii, 1)
            enddo
            Ang = 90
            RK(1) = Ang
            RK(2) = 4
            RK(3) = 1
            BB(:, :) = 0
            do ii = 1 , 3
               BB(ii, ii) = 1
            enddo
            call CombRot(BB)
!
*gl*        if (ifFromGraphic == 1) then
*gl*           call xupd05a(ier)
*gl*        endif
         end if
         kpt = i - NatMl + 1
         P(1) = xx(1, kpt) - xxc(1)
         P(2) = xx(2, kpt) - xxc(2)
         P(3) = xx(3, kpt) - xxc(3)
         do j = 1 , 3
            Ppp = 0
            do k = 1 , 3
               Ppp = Ppp + BB(j, k) * P(k)
            enddo
            xx(j, kpt) = - Ppp - xxc(j) + 2 * xx(j, 1)
         enddo
         x1(:) = xx(:, kpt)

         call MoltMatVec(rmi, x1, r1)

         xyzs(1:3, iap) = r1(1:3)
         xcr(1:3) = r1(1:3)   !pg210807
         xcr1(1:3) = x1(1:3)   !pg210807
!g       xyzSk(1:3, i-NatMl) = r1(1:3)
         xxoo(1:3,i-NatMl) = r1(1:3)
         
               write(6,'(3f10.5,5x,3f10.5)') r1,x1

         nptr = 1
         kptr(1) = iap
!         NatMol = NatMol + 1
!         NatInd = NatMol
!         write(6,'(i10,3f10.3)') iap,r1(1:3)
!         call Distance(3)
!         write(6,*) 'Tetrahedron Dist ',kptr(1),kptr(2),Lab(kptr(2))
!         if (kptr(1).lt.0) then
!            NatMol = NatMol - 1
!            NatInd = NatMol
!            nAtInPiu = nAtInPiu -1
!            Lab(iap) = '     '

      write(6,10) NatMol,xcr
   10 format(/,' NatMol = ',i5,/,' xcr()=',3f8.5,/)
            call Distance_pg(xcr, RScr, 3)   !pg210807
            if (kptr(1).gt.0) then
               NatMol = NatMol + 1
               NatInd = NatMol
               Lab(NatMol) = Labb
               xyz(1:3, iap) = xcr1(1:3)
               xyzSk(1:3, nAtInPiu) = xcr(1:3)
            else
               nAtInPiu = nAtInPiu - 1
            end if
!         else
!            xyzSk(1:3, nAtInPiu) = r1(1:3)
!         end if
!06-12
      enddo
!06-12
!
!-- update list 5
!
      nNew = 0
      MoreAtoms = nAtInPiu
      MoreBonds = MoreAtoms
      do i=NatMl + 1, NatMl + MoreAtoms
         iser=i
         iactn=1
         khead=0
         xxo(1:3) = xxoo(1:3,i-NatMl)
         xxo(4:11) = 0.0
         ksp=kspecb(newvet,xxo,xxn,key,itype,iser,khead,iactn)
!         xyzs(5,i) = 1.0 / float(key(10))
         xyzSk(5,i-NatMl) = 1.0 / float(key(10))
         if (ifFromGraphic == 1) then
             VetChanges(1) = xyzSk(1,i-NatMl)
             VetChanges(2) = xyzSk(2,i-NatMl)
             VetChanges(3) = xyzSk(3,i-NatMl)
             VetChanges(4) = xyzSk(4,i-NatMl)
             VetChanges(5) = xyzSk(5,i-NatMl)
             VetChanges(6) = biso
             Labb = Lab(i)
             lnz = iabs(nz(i)/nzConst)
             iAction = 1
             call ModModel(i,iAction,Labb,lnz,VetChanges)
         else
             nNew = nNew + 1
!             xyzSk(1:3,nNew) = xyzs(1:3,i)
!             xyzSk(1:3,nNew) = xyztmp(1:3,i-NatMl+2)
         end if
      enddo

!06-12

      do i = 1, NumLeg
         if (LE(1, i) .gt. NatMl) LE(1, i) = LE(1, i) + MoreAtoms
         if (LE(2, i) .gt. NatMl) LE(2, i) = LE(2, i) + MoreAtoms
      enddo
      NL = NumLeg - nlp
      do i = NumLeg, NL + 1, -1
         LE(1, i + MoreBonds) = LE(1, i)
         LE(2, i + MoreBonds) = LE(2, i)
         LE(3, i + MoreBonds) = 0
      enddo
      if (MoreBonds.ge.1) then
         LE(1, NL+1) = NumAtCen
         LE(2, NL+1) = NatMl + 1
         LE(3, NL+1) = 1
      end if
      if (MoreBonds.eq.2) then
         LE(1, NL+2) = NumAtCen
         LE(2, NL+2) = NatMl + 2
         LE(3, NL+2) = 1
      end if
      NumLeg = NumLeg + MoreBonds
      do i = 1, NumLeg
         LE1(1, i) = LE(1, i)
         LE1(2, i) = LE(2, i)
         LE1(3, i) = LE(3, i)
      enddo
      nLegInd = NumLeg
!
      if (ifFromGraphic == 1) then
          call LEtoIconn
          iAction = 100
          j       =   0
          Labb    = ' '
          call ModModel(i,iAction,Labb,lnz,VetChanges)
*gl*      iAction = 200
*gl*      call xupd05(j,iAction,Labb,lnz,VetChanges)
*gl*      call xupd05z(0)
!
          jrest0 = 0
          call Modcom(jrest0)
          call Disegna(IfScale)
      else
          nptr = nNew
          NatInd = NatIndSav
      endif
      write(6,*) 'Tetrahedron Fine, aggiunti ',nptr

      return
      end
! -------------------------------------------------------------------
      subroutine Tetrahedron_new(ifFromGraphic, ier)
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
!
!pgpi      common /AtomType/ nTp, kCentral, xyzTmp(3,5)
! ---
      dimension x1(3),r1(3)
      dimension xx(3, 5),xc(3),xxc(3),B(3, 3),P(3)
      dimension xxo(11),xxn(11),key(10)
      dimension xxoo(11,2),kptrr(2)
!
      if (ifFromGraphic == 1) then
          call FillVetSpec()
          call ResetLabelPos()
!
          ier = 0
          if (kCentral .eq. 0) then
             Inte = '      W A R N I N G . . '
             Msg = 
     *          'The central atom of the tetrahedron must be selected !'
             iExCode = 0
             call MsgWinErr(Inte,Msg,WARN_WINDOW,iExCode)
             ier = -1
             return
          end if
      end if

      NumAtCen = kCentral

      do k=1, 3
         x1(k) = xyzs(k,kCentral)
      enddo
      call MoltMatVec(rm,x1,r1)
      do k=1, 3
         xx(k, 1) = r1(k)
      enddo

      kCentral = 0

      if (ifFromGraphic == 1) then
          if (nptr .lt. 2) then
             Inte = '      W A R N I N G . . '
             Msg = 'Two atoms must be selected !'
             iExCode = 0
             call MsgWinErr(Inte,Msg,WARN_WINDOW,iExCode)
             ier = -1
             return
          end if
      end if

      NatIndSav  = NatInd

      do i=1, 2
         do k=1, 3
            x1(k) = xyzs(k,kptr(i))
         enddo
         call MoltMatVec(rm,x1,r1)
         do k=1, 3
            xx(k, i+1) = r1(k)
         enddo
      enddo

      n1 = kptr(nptr-1)
      n2 = kptr(nptr)

      xc(1) = (xyz(1, n1) + xyz(1, n2)) / 2
      xc(2) = (xyz(2, n1) + xyz(2, n2)) / 2
      xc(3) = (xyz(3, n1) + xyz(3, n2)) / 2

      xxc(1) = (xx(1, 2) + xx(1, 3)) / 2
      xxc(2) = (xx(2, 2) + xx(2, 3)) / 2
      xxc(3) = (xx(3, 2) + xx(3, 3)) / 2

      MoreAtoms = 2
      if (ifFromGraphic == 1) then

! sposta i falsi atomi degli spigoli della cella
! per far posto ai nuovi anioni

          MoreBonds = 2
          do k=NatMol + NatSpi, NatMol + 1, -1
             do kk=1, 3
                xyz(kk, k + MoreAtoms) = xyz(kk, k)
             enddo
             RS(k + MoreAtoms) = RS(k)
             iCol(k + MoreAtoms) = iCol(k)
             Lab(k + MoreAtoms) = Lab(k)
             iEqui(k + MoreAtoms) = iEqui(k)
             rMLU(k + MoreAtoms) = rMLU(k)
          enddo

! salva il vettore dei legami

          do ii = 1,NumLeg
             do jj=1,3
                LE1(jj,ii) = LE(jj,ii)
             end do
          end do
      endif

      do i=1, 3
         VV(1, i) = xc(i) - xyz(i, NumAtCen)
      enddo

      Ang = 90
      RK(1) = Ang
      RK(2) = 4
      RK(3) = 1
      do i = 1 , 3
         do j = 1 , 3
            B(i, j) = 0
         enddo
         B(i, i) = 1
      enddo
      call CombRot(B)
!

      kptrr(1) = kptr(1)
      kptrr(2) = kptr(2)
      NatMl = NatMol
      nAtInPiu = 0
      do i=NatMl + 1, NatMl + MoreAtoms
         nAtInPiu = nAtInPiu +1
         iap = NatMl + nAtInPiu
         kpt = kptrr(i - NatMl)
         P(1) = xyz(1, kpt) - xc(1)
         P(2) = xyz(2, kpt) - xc(2)
         P(3) = xyz(3, kpt) - xc(3)
         do j = 1 , 3
            Ppp = 0
            do k = 1 , 3
               Ppp = Ppp + B(j, k) * P(k)
            enddo
            xyz(j, iap) = - Ppp - xc(j) + 2 * xyz(j, NumAtCen)
         enddo
!        if (ifFromGraphic == 1) then
             lnz   = iabs(nz(kpt)/nzConst)
             RS(iap) = RS(kpt)
             iCol(iap) = iCol(kpt)
             iEqui(iap) = iEqui(kpt)
             nOpEq(iap) = nOpEq(kpt)  !?????????
             rMLU(iap) = rMLU(kpt)
             bfac(iap) = bfac(kpt)
             bSav(iap) = bSav(kpt)
             nz(iap) = nz(kpt)
             nzTot(iap) = lnz
             SinglePlotType(iap) = iPlotType
             xyzs(4, iap) = xyzs(4, kpt)
             call CreaLab(iap,-1,lnz,Labb)
             Lab(iap) = Labb
*gl*     if (ifFromGraphic == 1) then
*gl*         call xupd05a(ier)
*gl*     endif

!06-12
         if (i.eq.NatMl+1) then
            do ii=1, 3
              VV(1, ii) = xxc(ii) - xx(ii, 1)
            enddo
            Ang = 90
            RK(1) = Ang
            RK(2) = 4
            RK(3) = 1
            do ii = 1 , 3
               do j = 1 , 3
                  B(ii, j) = 0
               enddo
               B(ii, ii) = 1
            enddo
            call CombRot(B)
!
         end if
         kpt = i - NatMl + 1
         P(1) = xx(1, kpt) - xxc(1)
         P(2) = xx(2, kpt) - xxc(2)
         P(3) = xx(3, kpt) - xxc(3)
         do j = 1 , 3
            Ppp = 0
            do k = 1 , 3
               Ppp = Ppp + B(j, k) * P(k)
            enddo
            xx(j, kpt) = - Ppp - xxc(j) + 2 * xx(j, 1)
         enddo
         do k=1, 3
            x1(k) = xx(k, kpt)
         enddo

         call MoltMatVec(rmi, x1, r1)
         do k=1, 3
!           if (ifFromGraphic == 1) then
                xyzs(k, iap) = r1(k)
!           endif
            xxoo(k,i-NatMl) = r1(k)
         enddo

         nptr = 1
         kptr(1) = iap
         NatMol = NatMol + 1
         NatInd = NatMol
         call Distance(3)
         if (kptr(1).lt.0) then
            NatMol = NatMol - 1
            NatInd = NatMol
            nAtInPiu = nAtInPiu -1
            Lab(iap) = '     '
         end if
!06-12
      enddo
!06-12
!
!-- update list 5
!
      nNew = 0
      MoreAtoms = nAtInPiu
      MoreBonds = MoreAtoms
      do i=NatMl + 1, NatMl + MoreAtoms
         iser=i
         iactn=1
         khead=0
         xxo(1:3) = xxoo(1:3,i-NatMl)
         xxo(4:11) = 0.0
         ksp=kspecb(newvet,xxo,xxn,key,itype,iser,khead,iactn)
         xyzs(5,i) = 1.0 / float(key(10))
         if (ifFromGraphic == 1) then
             VetChanges(1) = xyzs(1,i)
             VetChanges(2) = xyzs(2,i)
             VetChanges(3) = xyzs(3,i)
             VetChanges(4) = xyzs(4,i)
             VetChanges(5) = xyzs(5,i)
             VetChanges(6) = biso
             Labb = Lab(i)
             lnz = iabs(nz(i)/nzConst)
             iAction = 1
             call ModModel(i,iAction,Labb,lnz,VetChanges)
         else
             nNew = nNew + 1
             xyzSk(1:3,nNew) = xyzs(1:3,i)
         end if
      enddo

!06-12

      if (ifFromGraphic == 1) then
          do i = 1, NumLeg
             if (LE(1, i) .gt. NatMl) LE(1, i) = LE(1, i) + MoreAtoms
             if (LE(2, i) .gt. NatMl) LE(2, i) = LE(2, i) + MoreAtoms
          enddo
          NL = NumLeg - nlp
          do i = NumLeg, NL + 1, -1
             LE(1, i + MoreBonds) = LE(1, i)
             LE(2, i + MoreBonds) = LE(2, i)
             LE(3, i + MoreBonds) = 0
          enddo
          if (MoreBonds.ge.1) then
             LE(1, NL+1) = NumAtCen
             LE(2, NL+1) = NatMl + 1
             LE(3, NL+1) = 1
          end if
          if (MoreBonds.eq.2) then
             LE(1, NL+2) = NumAtCen
             LE(2, NL+2) = NatMl + 2
             LE(3, NL+2) = 1
          end if
          NumLeg = NumLeg + MoreBonds
          do i = 1, NumLeg
             LE1(1, i) = LE(1, i)
             LE1(2, i) = LE(2, i)
             LE1(3, i) = LE(3, i)
          enddo
          nLegInd = NumLeg
!
          call LEtoIconn
          iAction = 100
          j       =   0
          Labb    = ' '
          call ModModel(i,iAction,Labb,lnz,VetChanges)
*gl*      iAction = 200
*gl*      call xupd05(j,iAction,Labb,lnz,VetChanges)
*gl*      call xupd05z(0)
!
          jrest0 = 0
          call Modcom(jrest0)
          call Disegna(IfScale)
      else
          nptr = nNew
          NatInd = NatIndSav
      endif

      return
      end
!-----------------------------------------------------------------------
      subroutine Octahedron_orig(ifFromGraphic,ier)
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
!
!pgpi      common /AtomType/ nTp, kCentral, xyzTmp(3,5)
      common /Distanze/ ndist, dis(300), nop(300), ifDist
! ---
      dimension x1(3),r1(3)
      dimension xx(3, 7),xc(3),xxc(3),B(3, 3),P(3)
      dimension xxo(11),xxn(11),key(10)
      dimension xxoo(11,4),kptrr(6)
      integer daPrendere(4)
!
      daPrendere(:) = 1
      NatIndSav  = NatInd
      call FillVetSpec()
      call ResetLabelPos()
!
      ier = 0
      if (kCentral .eq. 0) then
         Inte = '      W A R N I N G . . '
         Msg = 'The central atom of the octahedron must be selected !'
         iExCode = 0
         call MsgWinErr(Inte,Msg,WARN_WINDOW,iExCode)
         ier = -1
         return
      end if

      NumAtCen = kCentral

      write(6,*) 'Octahedron A ',NumAtCen,kptr(1:2)
      write(6,'(a,2x,3f10.3)') Lab(NumAtCen),xyzs(1:3,NumAtCen)
      if (ifFromGraphic == 1) then
          write(6,'(a,2x,3f10.3)') Lab(kptr(1)),xyzs(1:3,kptr(1))
          write(6,'(a,2x,3f10.3)') Lab(kptr(2)),xyzs(1:3,kptr(2))
      else
          write(6,'(a,2x,3f10.3)') Lab(kptr(1)),xyzTmp(1:3,1)
          write(6,'(a,2x,3f10.3)') Lab(kptr(2)),xyzTmp(1:3,2)
      endif
      write(6,*) 'Octahedron B'
      write(6,'(a,2x,3f10.3)') Lab(NumAtCen),xyz(1:3,NumAtCen)
      write(6,'(a,2x,3f10.3)') Lab(kptr(1)),xyz(1:3,kptr(1))
      write(6,'(a,2x,3f10.3)') Lab(kptr(2)),xyz(1:3,kptr(2))
      write(6,*) ' '

!ortonormalizza il catione centrale

      x1(1:3) = xyzs(1:3,kCentral)
      call MoltMatVec(rm,x1,r1)
      xx(1:3, 1) = r1(1:3)
!
      kCentral = 0

      if (nptr .lt. 2) then
         Inte = '      W A R N I N G . . '
         Msg = 'At least two atoms must be selected !'
         iExCode = 0
         call MsgWinErr(Inte,Msg,WARN_WINDOW,iExCode)
         ier = -1
         return
      end if

!ortonormalizza gli anioni anioni

      nAtSel = nptr
      
      do i=1, nptr
         if (ifFromGraphic == 1) then
             x1(1:3) = xyzs(1:3,kptr(i))
         else
             x1(1:3) = xyzTmp(1:3,i)
         endif
         call MoltMatVec(rm,x1,r1)
         xx(1:3, i+1) = r1(1:3)
      enddo
!
      n1 = kptr(nptr-1)
      n2 = kptr(nptr)

      xc(1:3) = xyz(1:3, NumAtCen)
      xxc(1:3) = xx(1:3, 1)

! sposta i falsi atomi degli spigoli della cella
! per far posto ai nuovi anioni

      MoreAtoms = 6 - nptr
      MoreBonds = 6 - nptr
      do k=NatMol + NatSpi, NatMol + 1, -1
         xyz(1:3, k + MoreAtoms) = xyz(1:3, k)
         RS(k + MoreAtoms) = RS(k)
         iCol(k + MoreAtoms) = iCol(k)
         Lab(k + MoreAtoms) = Lab(k)
         iEqui(k + MoreAtoms) = iEqui(k)
         rMLU(k + MoreAtoms) = rMLU(k)
      enddo

! salva il vettore dei legami

      LE1(:,1:NumLeg) = LE(:,1:NumLeg)
!
! definisce il vettore fra il primo anione ed il catione

      do i=1, 3
         VV(1, i) = xyz(i, n1) - xyz(i, NumAtCen)
      enddo

! definisci una rotazione di 90 gradi intorno al vettore VV

      Ang = 90
      RK(1) = Ang
      RK(2) = 4
      RK(3) = 1
      B(:, :) = 0
      do ii = 1 , 3
         B(ii, ii) = 1
      enddo
      call CombRot(B)

      kptrr(1) = kptr(1)
      kptrr(2) = kptr(2)
      NatMl = NatMol
      nAtInPiu = 0
      i = NatMol + 1
      nAtInPiu = nAtInPiu +1
      iap = i
      kpt = kptrr(2)

! shifta l'anione da ruotare ...

      P(1) = xyz(1, kpt) - xyz(1, NumAtCen)
      P(2) = xyz(2, kpt) - xyz(1, NumAtCen)
      P(3) = xyz(3, kpt) - xyz(1, NumAtCen)

!  ...  e ruotalo di 90 gradi....

      do j = 1 , 3
         Ppp = 0
         do k = 1 , 3
            Ppp = Ppp + B(j, k) * P(k)
         enddo
! .....   rishiftandolo indietro
         xyz(j, iap) = Ppp + xyz(j, NumAtCen)
      enddo

! Assegna le caratteristiche del nuovo atomo

      lnz   = iabs(nz(kpt)/nzConst)
      RS(iap) = RS(kpt)
      iCol(iap) = iCol(kpt)
      iEqui(iap) = iEqui(kpt)
      nOpEq(iap) = nOpEq(kpt)  !?????????
      rMLU(iap) = rMLU(kpt)
      bfac(iap) = bfac(kpt)
      bSav(iap) = bSav(kpt)
      nz(iap) = nz(kpt)
      nzTot(iap) = lnz
      SinglePlotType(iap) = iPlotType
      xyzs(4, iap) = xyzs(4, kpt)
      call CreaLab(iap,-1,lnz,Labb)
      Lab(iap) = Labb
*gl*  if (ifFromGraphic == 1) then
*gl*      call xupd05a(ier)
*gl*  endif
      
      kptrr(nptr+1) = iap

! ripeti l'operazione per ottenere il relativo xyzs()

      do ii=1, 3
         VV(1, ii) = xx(ii, 2) - xx(ii, 1)
      enddo
      Ang = 90
      RK(1) = Ang
      RK(2) = 4
      RK(3) = 1
      B(:, :) = 0
      do ii = 1 , 3
         B(ii, ii) = 1
      enddo
      call CombRot(B)
!
         
      kpt = i - NatMl + 1
      kpt = nptr + 2
      P(1) = xx(1, 3) - xxc(1)
      P(2) = xx(2, 3) - xxc(2)
      P(3) = xx(3, 3) - xxc(3)
      do j = 1 , 3
         Ppp = 0
         do k = 1 , 3
            Ppp = Ppp + B(j, k) * P(k)
         enddo
         xx(j, kpt) = Ppp + xxc(j)
      enddo

      x1(1:3) = xx(1:3, kpt)
      call MoltMatVec(rmi, x1, r1)
      
      xyzs(1:3, iap) = r1(1:3)
      xxoo(1:3,i-NatMl) = r1(1:3)
           
! commento momentaneo (?)
      nptr = 1                   !  commentata da Piero
      kptr(1) = iap              !  commentata da Piero
      NatMol = NatMol + 1
      NatInd = NatMol
      write(6,'(i10,3f10.3)') iap,xyzs(1:3,iap)
      call Distance(3)
      kkpp = iabs(kptr(1))
      write(6,*) 'Octahedron Dist ',kptr(1), Lab(kkpp),dis(1)
      if (kptr(1).lt.0) then     !  commentata da Piero
!        NatMol = NatMol - 1     !  commentata da Piero
!        NatInd = NatMol         !  commentata da Piero
!        nAtInPiu = nAtInPiu -1  !  commentata da Piero
!        Lab(iap) = '     '      !  commentata da Piero
         daPrendere(1) = 0
      end if                     !  commentata da Piero
      
! genera i centrosimmetrici rispetto al catione
      
      do j=1, 3
         nAtInPiu = nAtInPiu + 1
         iap = iap + 1
         kpt = kptrr(j)
         do i=1, 3
            xyz(i, iap) = -xyz(i, kpt) + 2 * xyz(i, NumAtCen)
         end do
         do i=1, 3
            xx(i, nAtInPiu + 3) = -xx(i, j+1) + 2 * xx(i, 1)
         end do
         x1(1:3) = xx(1:3, nAtInPiu + 3)
         call MoltMatVec(rmi, x1, r1)
   
         xyzs(1:3, iap) = r1(1:3)
         xxoo(1:3,nAtInPiu) = r1(1:3)

         nptr = 1
         kptr(1) = iap
         NatMol = NatMol + 1
         NatInd = NatMol
         write(6,'(i10,3f10.3)') iap,xyzs(1:3,iap)
         call Distance(3)
         kkpp = iabs(kptr(1))
         write(6,*) 'Octahedron Dist ',kptr(1), Lab(kkpp),dis(1)
         if (kptr(1).lt.0) then
             daPrendere(j+1) = 0
         endif
!           NatMol = NatMol - 1
!           nAtInPiu = nAtInPiu - 1
!           NatInd = NatMol
!           Lab(iap) = '     '
!        else
!           if (ifFromGraphic == 1) then
                lnz   = iabs(nz(kpt)/nzConst)
                RS(iap) = RS(kpt)
                iCol(iap) = iCol(kpt)
                iEqui(iap) = iEqui(kpt)
                nOpEq(iap) = nOpEq(kpt)  !?????????
                rMLU(iap) = rMLU(kpt)
                bfac(iap) = bfac(kpt)
                bSav(iap) = bSav(kpt)
                nz(iap) = nz(kpt)
                nzTot(iap) = lnz
                SinglePlotType(iap) = iPlotType
                xyzs(4, iap) = xyzs(4, kpt)
                call CreaLab(iap,-1,lnz,Labb)
                Lab(iap) = Labb
!           endif
            
            kptrr(nAtSel + nAtInPiu) = iap

!           do i=1, 3
!              xx(i, nAtInPiu + 3) = -xx(i, j+1) + 2 * xx(i, 1)
!           end do
!           do k=1, 3
!              x1(k) = xx(k, nAtInPiu + 3)
!           enddo
!           call MoltMatVec(rmi, x1, r1)
!     
!           do k=1, 3
!              xyzs(k, iap) = r1(k)
!              xxoo(k,nAtInPiu) = r1(k)
!           enddo
               
!        end if
      end do
!06-12
!
!-- update list 5
!
      kk = 0
      do i=NatMl + 1, NatMl + MoreAtoms
         kk = kk + 1
         write(0,*) kk,i,Lab(i),daPrendere(kk)
      end do
      nNew = 0
      MoreAtoms = nAtInPiu
      MoreBonds = MoreAtoms
      kk = 0
      ii = NatMl + 1
      do i=NatMl + 1, NatMl + MoreAtoms
         kk = kk + 1
         if (daPrendere(kk) == 0) then
             nz(i) = 0
             cycle
         endif
         iser=i
         iactn=1
         khead=0
         xxo(1:3) = xxoo(1:3,i-NatMl)
         xxo(4:11) = 0.0
         ksp=kspecb(newvet,xxo,xxn,key,itype,iser,khead,iactn)
         xyzs(5,i) = 1.0 / float(key(10))
         write(6,'("O ",3f10.4,i5)') xyzs(1:3, i)
         if (ifFromGraphic == 1) then
             VetChanges(1) = xyzs(1,i)
             VetChanges(2) = xyzs(2,i)
             VetChanges(3) = xyzs(3,i)
             VetChanges(4) = xyzs(4,i)
             VetChanges(5) = xyzs(5,i)
             VetChanges(6) = biso
             Labb = Lab(i)
             lnz = iabs(nz(i)/nzConst)
             serial(ii) = ii
             iAction = 1
             call ModModel(ii,iAction,Labb,lnz,VetChanges)
             ii = ii + 1
         else
             nNew = nNew + 1
             xyzSk(1:3,nNew) = xyzs(1:3,i)
         endif
      enddo
      nAtInPiu = 0
      do i=1, 4
         if (daPrendere(i) > 0) then
             nAtInPiu = nAtInPiu + 1
         endif
      enddo
!!    nNew = 0
      MoreAtoms = nAtInPiu
      MoreBonds = MoreAtoms
      NatInd = NatMl + MoreAtoms

!06-12

      if (ifFromGraphic == 1) then
          do i = 1, NumLeg
             if (LE(1, i) .gt. NatMl) then
                 LE(1, i) = LE(1, i) + MoreAtoms
             end if
             if (LE(2, i) .gt. NatMl) then
                 LE(2, i) = LE(2, i) + MoreAtoms
             end if
          enddo
          NL = NumLeg - nlp
          do i = NumLeg, NL + 1, -1
             LE(1, i + MoreBonds) = LE(1, i)
             LE(2, i + MoreBonds) = LE(2, i)
             LE(3, i + MoreBonds) = 0
          enddo

!      if (MoreBonds.ge.1) then
!         LE(1, NL+1) = NumAtCen
!         LE(2, NL+1) = NatMl + 1
!         LE(3, NL+1) = 1
!      end if
!      if (MoreBonds.eq.2) then
!         LE(1, NL+2) = NumAtCen
!         LE(2, NL+2) = NatMl + 2
!         LE(3, NL+2) = 1
!      end if

          do i=1, MoreBonds
             LE(1, NL+i) = NumAtCen
             LE(2, NL+i) = NatMl + i
             LE(3, NL+i) = 1
          end do
          NumLeg = NumLeg + MoreBonds
          do i = 1, NumLeg
             LE1(1, i) = LE(1, i)
             LE1(2, i) = LE(2, i)
             LE1(3, i) = LE(3, i)
          enddo
          nLegInd = NumLeg
!
          call LEtoIconn
          iAction = 100
          j       =   0
          Labb    = ' '
          call ModModel(i,iAction,Labb,lnz,VetChanges)
*gl*      iAction = 200
*gl*      call xupd05(j,iAction,Labb,lnz,VetChanges)
*gl*      call xupd05z(0)
!
          jrest0 = 0
          call Modcom(jrest0)
          call Disegna(IfScale)
      else
          nptr = nNew
          NatInd = NatIndSav
          if (nptr == 0) then
              NatMol = NatInd
          endif
      endif
      write(6,*) 'Octahedron Fine, aggiunti ',nptr
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Octahedron(ifFromGraphic,ier)
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
!
!pgpi      common /AtomType/ nTp, kCentral, xyzTmp(3,5)
      common /Distanze/ ndist, dis(300), nop(300), ifDist
! ---
      dimension x1(3),r1(3)
      dimension xx(3, 100),xc(3),xxc(3),B(3, 3),P(3)
      dimension xxo(11),xxn(11),key(10)
      dimension xxoo(3,100),kptrr(100)
      integer daPrendere(100)
      
      real *4 xyzn(3, 20, 16), xyzMed(3, 16)
      integer NUMxyzn(16), ipu(3), izPoint(20, 16),VetSpecSav(19)
      character *16 Labg(20, 16)



      dimension xyzsI(3), xyzsInv(3, 100), BTotInv(3, 3),dum(3, 3)
!
      dimension RRS(16),xcr(3)
! ---

      goto 8787
      
! P R O V A !!!!!!
      do i=1,NatInd
         do k1=1,3
            x1(k1) = xyzs(k1, i)
         enddo
         call MoltMatVec(rm,x1,r1)
         do k1=1,3
            xyz(k1,i)=r1(k1)
         enddo
         write(lo,'(2i5,3f10.4)') i,NatInd,(xyz(k1,i),k1=1,3)
      enddo

      call AggiuSpig
!      call RotazTot
      call RotAtoms(BTot, 1)
      
      do i=1,NatInd
         write(lo,'(2i5,3f10.4)') i,NatInd,(xyz(k1,i),k1=1,3)
      enddo

      call InvMat(BTot,BTotInv,icod)
      do i=1, NatInd
         x1(1:3) = xyz(1:3, i)
         call MoltMatVec(BTotInv, x1, r1)
         xyzsI(1:3) = r1(1:3)
         call MoltMatVec(rmi, xyzsI, r1)
         xyzsInv(1:3, i) = r1(1:3)
      end do

      return
 8787 continue
 
      write(6,"(' ')")
      write(6,'(a)') '-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ '
      do i=1,NatInd
         write(6,'(i5,3x,a8,3f10.5)') i, Lab(i), xyzs(1:3,i)
      end do 
      write(6,'(a)') '-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ '
      write(6,"(' ')")
 
      xyzn(:,:,:) = 0.0
      NUMxyzn(:) = 0
      Nxyzn = 0
      izPoint(:,:) = 0
      
      kptrr(1:6) = kptr(1:6)
      nptrr = nptr
 
      daPrendere(:) = 1
      NatIndSav  = NatInd
      call FillVetSpec()
      call ResetLabelPos()
!
      ier = 0
      if (kCentral .eq. 0) then
         Inte = '      W A R N I N G . . '
         Msg = 'The central atom of the octahedron must be selected !'
         iExCode = 0
         call MsgWinErr(Inte,Msg,WARN_WINDOW,iExCode)
         ier = -1
         return
      end if

      NumAtCen = kCentral

      write(6,'(a, i5,4x,6i5)') 'Octahedron A ',NumAtCen,kptrr(1:nptrr)
      write(6,'(a,2x,3f10.3)') Lab(NumAtCen),xyzs(1:3,NumAtCen)
      if (ifFromGraphic == 1) then
          write(6,'(a,2x,3f10.3)') 
     *         (Lab(kptrr(i)),xyzs(1:3,kptrr(i)), i=1, nptrr)
!          write(6,'(a,2x,3f10.3)') Lab(kptrr(2)),xyzs(1:3,kptrr(2))
      else
          write(6,'(a,2x,3f10.3)') Lab(kptrr(1)),xyzTmp(1:3,1)
          write(6,'(a,2x,3f10.3)') Lab(kptrr(2)),xyzTmp(1:3,2)
      endif
      write(6,*) 'Octahedron B'
      write(6,'(a,2x,3f10.3)') Lab(NumAtCen),xyz(1:3,NumAtCen)
      write(6,'(a,2x,3f10.3)') 
     *        (Lab(kptrr(i)),xyz(1:3,kptrr(i)), i=1, nptrr)   
!      write(6,'(a,2x,3f10.3)') Lab(kptrr(2)),xyz(1:3,kptrr(2))
      write(6,*) ' '

!ortonormalizza il catione centrale

      if (ifFromGraphic == 1) then    !pg0709
         x1(1:3) = xyzs(1:3,kCentral)
         call MoltMatVec(rm,x1,r1)
         xxc(1:3) = r1(1:3)
      else
         xxc(1:3) = xyz(1:3,NumAtCen)
      end if
               
!
      kCentral = 0

      if (nptrr .lt. 2) then
         Inte = '      W A R N I N G . . '
         Msg = 'At least two atoms must be selected !'
         iExCode = 0
         call MsgWinErr(Inte,Msg,WARN_WINDOW,iExCode)
         ier = -1
         return
      end if

!ortonormalizza gli anioni anioni

      nAtSel = nptrr
      
      do i=1, nptrr
         if (ifFromGraphic == 1) then
             x1(1:3) = xyzs(1:3,kptrr(i))
         else
             x1(1:3) = xyzTmp(1:3,i)
         endif
         call MoltMatVec(rm,x1,r1)
         xx(1:3, i) = r1(1:3)
      enddo
!
!      n1 = kptr(nptr-1)
!      n2 = kptr(nptr)

      xc(1:3) = xyz(1:3, NumAtCen)

! sposta i falsi atomi degli spigoli della cella
! per far posto ai nuovi anioni

!      MoreAtoms = 2*(6 - nptrr)
!      MoreBonds = 2*(6 - nptrr)

      MoreAtoms = 6 - nptrr
      MoreBonds = 6 - nptrr
      do k=NatMol + NatSpi, NatMol + 1, -1
         xyz(1:3, k + MoreAtoms) = xyz(1:3, k)
         RS(k + MoreAtoms) = RS(k)
         iCol(k + MoreAtoms) = iCol(k)
         Lab(k + MoreAtoms) = Lab(k)
         iEqui(k + MoreAtoms) = iEqui(k)
         rMLU(k + MoreAtoms) = rMLU(k)
      enddo

! salva il vettore dei legami

      LE1(:,1:NumLeg) = LE(:,1:NumLeg)
      
      di = 0.0
      do i=1,3
         di = di + (xx(i,1)-xxc(i))**2
      end do
      di = sqrt(di)
      
      nAtInPiu = 0
      NatMl = NatMol
      
      do i = 1,nptrr
         xyzn(1:3,1,i) = xyz(1:3,kptrr(i))
         NUMxyzn(i) = 1
         Nxyzn= Nxyzn+ 1
         Labg(1,i)  = Lab(kptrr(i))
         izPoint(1,i) = kptrr(i)
      end do
      
      VetSpecSav(:) = VetSpec(:)
      
      do i1=1,nptrr
       do i2=1,nptrr
         if (i1 == i2) then
            cycle
         end if
         
         n1 = kptrr(i1)
         n2 = kptrr(i2)
         
         ipu(1) = i1
         ipu(2) = i2
        
         di1 = 0.0
         do i=1,3
            if (ifFromGraphic == 1) then    !pg0709
               di1 = di1 + (xyz(i, n1)-xyz(i, n2))**2
            else
               di1 = di1 + (xx(i, 1)-xx(i, 2))**2
            end if
         end do
         di1 = sqrt(di1)
         if (di1 > 1.75 * di) then
            if (nptrr .eq. 2) then
               Inte = '      W A R N I N G . . .'
               Msg = 'At least two adjacent atoms must be selected !'
               iExCode = 0
               call MsgWinErr(Inte,Msg,WARN_WINDOW,iExCode)
               ier = -1
               return
            else
               cycle
            end if
         end if
!
! definisce il vettore fra il primo anione ed il catione

         do i=1, 3
            if (ifFromGraphic == 1) then    !pg0709
               VV(1, i) = xyz(i, n1) - xc(i)
            else
               VV(1, i) = xx(i, i1) - xc(i)
            end if
         enddo

! definisci una rotazione di 90 gradi intorno al vettore VV

         Ang = 90
         RK(1) = Ang
         RK(2) = 4
         RK(3) = 1
         B(:, :) = 0
         do ii = 1 , 3
            B(ii, ii) = 1
         enddo
         call CombRot(B)
    
         i = NatMol + 1
         nAtInPiu = nAtInPiu +1
         iap = i
         kpt = n2

! shifta l'anione da ruotare ...

         if (ifFromGraphic == 1) then    !pg0709
            P(1:3) = xyz(1:3, kpt) - xc(1:3)
         else
            P(1:3) = xx(1:3, i2) - xc(1:3)
         end if

!  ...  e ruotalo di 90 gradi....

         do j = 1 , 3
            Ppp = 0
            do k = 1 , 3
               Ppp = Ppp + B(j, k) * P(k)
            enddo
! .....   rishiftandolo indietro
            xyz(j, iap) = Ppp + xc(j)
         enddo

! Assegna le caratteristiche del nuovo atomo

         lnz   = iabs(nz(kpt)/nzConst)
         RS(iap) = RS(kpt)
         iCol(iap) = iCol(kpt)
         iEqui(iap) = iEqui(kpt)
         nOpEq(iap) = nOpEq(kpt)  !?????????
         rMLU(iap) = rMLU(kpt)
         bfac(iap) = bfac(kpt)
         bSav(iap) = bSav(kpt)
         nz(iap) = nz(kpt)
         nzTot(iap) = lnz
         SinglePlotType(iap) = iPlotType
         xyzs(4, iap) = xyzs(4, kpt)
         call CreaLab(iap,-1,lnz,Labb)
         Lab(iap) = Labb
*gl*     if (ifFromGraphic == 1) then
*gl*         call xupd05a(ier)
*gl*     endif
         
         kptrr(nptrr+nAtInPiu) = iap
         
         ipu(3) = nptrr+nAtInPiu

         call QualeVertice(xyzn, NUMxyzn, Nxyzn, iap, Labg, izPoint)
! ripeti l'operazione per ottenere il relativo xyzs()

         do ii=1, 3
            VV(1, ii) = xx(ii, i1) - xxc(ii)
         enddo
         Ang = 90
         RK(1) = Ang
         RK(2) = 4
         RK(3) = 1
         B(:, :) = 0
         do ii = 1 , 3
            B(ii, ii) = 1
         enddo
         call CombRot(B)
!    
            
         kpt = nptrr + nAtInPiu
         
         P(1:3) = xx(1:3, i2) - xxc(1:3)
         do j = 1 , 3
            Ppp = 0
            do k = 1 , 3
               Ppp = Ppp + B(j, k) * P(k)
            enddo
            xx(j, kpt) = Ppp + xxc(j)
         enddo
     
         x1(1:3) = xx(1:3, kpt)
         call MoltMatVec(rmi, x1, r1)
         xyzs(1:3, iap) = r1(1:3)
         xxoo(1:3,i-NatMl) = r1(1:3)
                           
         nptr = 1                   
         kptr(1) = iap              
         NatMol = NatMol + 1
         NatInd = NatMol
         write(6,'(i10,3f10.3)') iap,xyzs(1:3,iap)
!!!!        call Distance(3)
         kkpp = iabs(kptr(1))
         write(6,*) 'Octahedron Dist ',kptr(1), Lab(kkpp),dis(1)
         if (kptr(1).lt.0) then     !  commentata da Piero
!           NatMol = NatMol - 1     !  commentata da Piero
!           NatInd = NatMol         !  commentata da Piero
!           nAtInPiu = nAtInPiu -1  !  commentata da Piero
!           Lab(iap) = '     '      !  commentata da Piero
            daPrendere(1) = 0
         end if                     !  commentata da Piero
      
! genera i centrosimmetrici rispetto al catione
      
         do jj=1, 3
            nAtInPiu = nAtInPiu + 1
            iap = iap + 1
            
            j = ipu(jj)
            
            kpt = kptrr(j)
            do i=1, 3
               if (ifFromGraphic == 1) then    !pg0709
                   xyz(i, iap) = -xyz(i, kpt) + 2 * xc(i)
               else
                   xyz(i, iap) = -xx(i, j) + 2 * xc(i)
               end if
            end do
            do i=1, 3
               xx(i, nAtInPiu + nptrr) = -xx(i, j) + 2 * xxc(i)
            end do
      
            x1(1:3) = xx(1:3, nAtInPiu + nptrr)
            call MoltMatVec(rmi, x1, r1)
            xyzs(1:3, iap) = r1(1:3)
            xxoo(1:3,nAtInPiu) = r1(1:3)
      
            nptr = 1
            kptr(1) = iap
            NatMol = NatMol + 1
            NatInd = NatMol
            write(6,'(i10,3f10.3)') iap,xyzs(1:3,iap)
!!!!            call Distance(3)
            kkpp = iabs(kptr(1))
            write(6,*) 'Octahedron Dist ',kptr(1), Lab(kkpp),dis(1)
            if (kptr(1).lt.0) then
                daPrendere(j+1) = 0
            endif
            lnz   = iabs(nz(kpt)/nzConst)
            RS(iap) = RS(kpt)
            iCol(iap) = iCol(kpt)
            iEqui(iap) = iEqui(kpt)
            nOpEq(iap) = nOpEq(kpt)  !?????????
            rMLU(iap) = rMLU(kpt)
            bfac(iap) = bfac(kpt)
            bSav(iap) = bSav(kpt)
            nz(iap) = nz(kpt)
            nzTot(iap) = lnz
            SinglePlotType(iap) = iPlotType
            xyzs(4, iap) = xyzs(4, kpt)
            call CreaLab(iap,-1,lnz,Labb)
            Lab(iap) = Labb
            
            kptrr(nptrr + nAtInPiu) = iap
            
            call QualeVertice(xyzn, NUMxyzn, Nxyzn, iap, Labg, izPoint)

         end do
       end do
      end do
      
      write(lo,'(1h )')
      do j=1,20
         write(6,1313) Labg(j,:)
      end do
      write(lo,'(1h )')
 1313 format(6(a8,2x))
      do i=1,6
         do j=1,NUMxyzn(i)
             write(6,1314) i,Labg(j,i),xyzn(:,j,i)
         end do
         write(lo,'(1h )')
      end do
 1314 format (i5,3x,a,3f10.4)
      do i=1,iap
         write(6,1315) i,Lab(i),xyz(1:3,i),xyzs(1:3,i)
      end do
      write(lo,'(1h )')
 1315 format(i5,3x,a8,3f10.4,5x,3f10.4)
 
      write(6,'(" valori medi:")')
 
      do i=1,16    !Nxyzn
       if (NUMxyzn(i) > 0) then
          xyzMed(:, i) = 0.0
          do j=1,NUMxyzn(i)
             k = izPoint(j, i)
             xyzMed(:, i) = xyzMed(:, i) + xyzs(:, k)
             write(6,'(10x,3f8.5)') xyzs(1:3,k)
          end do
          RRS(i) = RS(izPoint(1, i))
          xyzMed(:, i) = xyzMed(:, i) / NUMxyzn(i)
          write(6,'(2i5,3f8.5)') i,NUMxyzn(i),xyzMed(1:3,i)
       end if
      end do     
      
      do i=1,nptrr
         j = izPoint(1, i)
         xyzs(1:3, j) = xyzMed(1:3, i)
      end do

      write(6,"(' ')")
      write(6,'(a)') '-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ '
      do i=1,NatMl
         write(6,'(i5,3x,a8,3f10.5)') i, Lab(i), xyzs(1:3,i)
      end do 
      write(6,'(a)') '-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ '
      write(6,"(' ')")

      Labsav(1:NatMl + MoreAtoms) = Lab(1:NatMl + MoreAtoms)
      
!      k = nptrr
!      ii = NatMl + 1
!      NatInPiu = MoreAtoms
!      do i=NatMl + 1, NatMl + MoreAtoms
!         k = k + 1
!!         j = izPoint(1, k)
!!         xyzs(1:3, j) = xyzMed(1:3, k)
!         xyzs(1:3, ii) = xyzMed(1:3, k)
!
!         nptr = 1                   
!         kptr(1) = ii              
!!!!         NatMol = NatMol + 1
!         NatMol = ii
!         NatInd = NatMol  
!         write(6,'(a,i5,3x,a,3f10.3)') 'Distanza di:',ii,Lab(ii),
!     *                                 xyzs(1:3,ii)
!         call Distance(3)
!         if (kptr(1).lt.0) then 
!            dista = kptr(3)/10000.
!            write (6,'(a,i6,3x,a,a,f10.4)')  'eliminato per:',kptr(2),
!     *                           Lab(kptr(2)),'   distanza: ',dista
!            NatMol = NatMol - 1     
!            NatInd = NatMol         
!            nAtInPiu = nAtInPiu -1  
!            Lab(ii) = '        '      
!         else
!            Lab(ii) = Labsav(ii)
!            ii = ii+1
!         end if
!      end do 

!pg190907
      k = nptrr
      ii = NatMl
      NatMol = ii
      NatInPiu = MoreAtoms
      NatInd = NatMol 
      VetSpec(:) = VetSpecSav(:) 
      do i=NatMl + 1, NatMl + MoreAtoms
         k = k + 1
         xcr(1:3) = xyzMed(1:3, k)
         RScr = RRS(k)
         nptr = 1                   
         kptr(1) = ii              
         write(6,'(a,i5,3x,3f10.3)') 
     *             'Distanza di:',NatMol+1,xcr(1:3)                    

            call Distance_pg(xcr, RScr, 3)   !pg210807
            if (kptr(1).gt.0) then
               NatMol = NatMol + 1
               NatInd = NatMol
               xyzs(1:3, NatMol) = xcr(1:3)
               lnz   = iabs(nz(NatMol)/nzConst)
               call CreaLab(NatMol,-1,lnz,Labb)
               Lab(NatMol) = Labb
               xyzSk(1:3, nAtInPiu) = xcr(1:3)
            else
               nAtInPiu = nAtInPiu - 1
               dista = kptr(3)/10000.
               write (6,'(a,i6,3x,a,a,f10.4)') 'eliminato per:', 
     *         kptr(2),Lab(kptr(2)),'   distanza: ',dista
            end if
            
      end do    
   

      MoreAtoms = NatInPiu
     
      write(6,"(' ')")
      write(6,'(a)') '-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ '
      do i=1,NatInd
         write(6,'(i5,3x,a8,3f10.5)') i, Lab(i), xyzs(1:3,i)
      end do 
      write(6,'(a)') '-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ '
      write(6,"(' ')")

!06-12
!
!-- update list 5
!
      kk = 0
!      do i=NatMl + 1, NatMl + MoreAtoms
!         kk = kk + 1
!         write(0,*) kk,i,Lab(i),daPrendere(kk)
!      end do

      nNew = 0
!      MoreAtoms = nAtInPiu
      MoreBonds = MoreAtoms

      do j=1, nptrr
         i = izPoint(1, j)
         
         write(6,'("Os",3f10.4,i5)') xyzs(1:3, i)
         if (ifFromGraphic == 1) then
             VetChanges(1) = xyzs(1,i)
             VetChanges(2) = xyzs(2,i)
             VetChanges(3) = xyzs(3,i)
             VetChanges(4) = xyzs(4,i)
             VetChanges(5) = xyzs(5,i)
!             VetChanges(6) = biso
             VetChanges(6) = bfac(i)
             Labb = Lab(i)
             lnz = iabs(nz(i)/nzConst)
             serial(i) = i
             iAction = 0
             call ModModel(i,iAction,Labb,lnz,VetChanges)
         endif
      enddo
     
!      kk = 0
      ii = NatMl + 1
      do i=NatMl + 1, NatMl + MoreAtoms
!         kk = kk + 1
!         if (daPrendere(kk) == 0) then
!             nz(i) = 0
!             nAtInPiu = nAtInPiu - 1
!             cycle
!         endif

!         iser=i
!         iactn=1
!         khead=0
!         xxo(1:3) = xxoo(1:3,i-NatMl)
!         xxo(4:11) = 0.0
!         ksp=kspecb(newvet,xxo,xxn,key,itype,iser,khead,iactn)
!         xyzs(5,i) = 1.0 / float(key(10))

         xyzs(5,i) = 1.0 
         
         write(6,'("O ",3f10.4,i5)') xyzs(1:3, i)
         if (ifFromGraphic == 1) then
             VetChanges(1) = xyzs(1,i)
             VetChanges(2) = xyzs(2,i)
             VetChanges(3) = xyzs(3,i)
             VetChanges(4) = xyzs(4,i)
             VetChanges(5) = xyzs(5,i)
             VetChanges(6) = biso
             Labb = Lab(i)
             lnz = iabs(nz(i)/nzConst)
             serial(ii) = ii
             iAction = 1
             call ModModel(ii,iAction,Labb,lnz,VetChanges)
             ii = ii + 1
         else
             nNew = nNew + 1
             xyzSk(1:3,nNew) = xyzs(1:3,i)
         endif
      enddo
!!    nNew = 0
!      MoreAtoms = nAtInPiu
      MoreBonds = MoreAtoms
      NatInd = NatMl + MoreAtoms

!06-12

      if (ifFromGraphic == 1) then
          do i = 1, NumLeg
             if (LE(1, i) .gt. NatMl) then
                 LE(1, i) = LE(1, i) + MoreAtoms
             end if
             if (LE(2, i) .gt. NatMl) then
                 LE(2, i) = LE(2, i) + MoreAtoms
             end if
          enddo
          NL = NumLeg - nlp
          do i = NumLeg, NL + 1, -1
             LE(1, i + MoreBonds) = LE(1, i)
             LE(2, i + MoreBonds) = LE(2, i)
             LE(3, i + MoreBonds) = 0
          enddo

!      if (MoreBonds.ge.1) then
!         LE(1, NL+1) = NumAtCen
!         LE(2, NL+1) = NatMl + 1
!         LE(3, NL+1) = 1
!      end if
!      if (MoreBonds.eq.2) then
!         LE(1, NL+2) = NumAtCen
!         LE(2, NL+2) = NatMl + 2
!         LE(3, NL+2) = 1
!      end if

          do i=1, MoreBonds
             LE(1, NL+i) = NumAtCen
             LE(2, NL+i) = NatMl + i
             LE(3, NL+i) = 1
          end do
          NumLeg = NumLeg + MoreBonds
          do i = 1, NumLeg
             LE1(1, i) = LE(1, i)
             LE1(2, i) = LE(2, i)
             LE1(3, i) = LE(3, i)
          enddo
          nLegInd = NumLeg
!
          call LEtoIconn
          iAction = 100
          j       =   0
          Labb    = ' '
          call ModModel(i,iAction,Labb,lnz,VetChanges)
*gl*      iAction = 200
*gl*      call xupd05(j,iAction,Labb,lnz,VetChanges)
*gl*      call xupd05z(0)
!
          jrest0 = 0
          call Modcom(jrest0)
          call Disegna(IfScale)
      else
          nptr = nNew
          NatInd = NatIndSav
          if (nptr == 0) then
              NatMol = NatInd
          endif
      endif
      write(6,*) 'Octahedron Fine, aggiunti ',nptr
!
      return
      end
!-----------------------------------------------------------------------
      subroutine QualeVertice(xyzn, NUMxyzn, Nxyzn, iap, Labg, izPoint)

      USE Molcom

      real *4 xyzn(3,20,16)
      integer NUMxyzn(16), izPoint(20, 16)
      character *16 Labg(20,16)
      
      dmin = 0.7
      do i=1, Nxyzn     ! loop sui vertici dell' ott.
         do j=1, NUMxyzn(i)
            dist = 0.0
            do k=1,3
               dist = dist + (xyzn(k,j,i) - xyz(k,iap))**2
            end do
            dist = sqrt(dist)
            if (dist < dmin) then
               NUMxyzn(i) = NUMxyzn(i) + 1
               xyzn(1:3,NUMxyzn(i),i) = xyz(1:3,iap)
               Labg(NUMxyzn(i),i) = Lab(iap)
               izPoint(NUMxyzn(i), i) = iap
               return
            end if
         end do
      end do
      
      Nxyzn = Nxyzn + 1
      NUMxyzn(Nxyzn) = 1
      xyzn(1:3,NUMxyzn(Nxyzn),Nxyzn) = xyz(1:3,iap)
      Labg(NUMxyzn(Nxyzn),Nxyzn) = Lab(iap)
      izPoint(NUMxyzn(Nxyzn), Nxyzn) = iap
      
      return
      end
!-----------------------------------------------------------------------
      subroutine PeekList (InteP,iActLis,num,nnn,NumUnDel,iExCode,
     *                     MultiSel)
      USE General
      USE Riflessi, only: iorde
      USE Atomi
      USE Molcom
      USE Poliedri
      USE PhaseModule
      USE LsqModule
!
      common /Distanze/ ndist, dis(300), nop(300), ifDist
! ---
      dimension num(*)
      dimension ipuntotp(100)
      character InteMsg*40
      character *(*) InteP
!
!
! --- iActLis := 0  Peek atoms for polyhedra 
!                1  Undelete atoms
!                2  Peek atoms from a list
!                3  Peek parameters from a list
!                6  Peek atoms with too large B-Fact:159
!                7  Peek new peaks (Fourier)  to delete 


!--
      selezione(:) = 0
      RSCOPY(:) = 0
!
      if (iActLis.eq.0) then      ! Polyhedra
          nva = nnn
          nnn = ndist
          do 5 i=1,nva
             ipuntotp(i) = num(i)
    5     continue
      endif
      if (iActLis .eq. 6) then                ! B-Factors too large
          do i=1, nats
             iOrd(i) = i
             bfac_dev(i) = bfac(i)
          enddo
          isort = -1
          iniz  = 1
          call sortall3(isort,bfac_dev,iniz,nats,iOrd)
      endif
      if (iActLis.eq.1) then      ! Undelete Atoms
         NumCan = 0
         do 6 i=1, NatMol
            if (RS(i) .lt. -10.) then
               NumCan = NumCan + 1
               goto 7
            end if
    6    continue
    7    if (NumCan .eq. 0) then
            InteMsg = '      W A R N I N G . . '
            Msg = 'No atom has been deleted !!!'
            iExCode = 0
            call MsgWinErr(InteMsg,Msg,WARN_WINDOW,iExCode)
            iExCode=3
            return
         end if
      end if
!--
      NumCan = 0
      NumC = 0
      ncb = 0
      do 10 i=1, nnn
         if (iActLis.eq.0) then                  ! Polyhedra 
             NumCan = NumCan + 1
             k =       kptr(i)
             L = Lung(Lab(k))
             Labb = Lab(k)
             call StringiStringa(Labb, 8)
             It(NumCan) = Labb(1:8)
             Num(NumCan) = k
             write(It(NumCan)(8:16),"('d=',f6.3, a)") dis(i), char(0)
         else
             iOK = 1
             if (iActLis.eq.1 .and. RS(i) .ge. -10.) then
                iOK = 0
             end if
             ii = i
             if (iActLis == 1 .and. iOK == 1) then
                 ii = iEqui(i)
                 RSCOPY(i) = ii
                 if (RSCOPY(ii) < 0.5) then
                     RSCOPY(ii) = ii
                 else
                     if (i /= ii) then
                         iOK = 0
                     endif
                 endif
             endif
             if (iOK == 1) then
                NumCan = NumCan + 1
                if (iActLis.le.2) then                  ! Atoms
                   L = Lung(Lab(ii))
                   Labb = Lab(ii)
                   call StringiStringa(Labb, 8)
                   It(NumCan) = Labb(1:8) // char(0)
                   Num(NumCan) = iEqui(i)
                end if
                if (iActLis .eq. 6) then                ! B-Factors too large
                    NumC = NumC + 1
                    ii = iOrd(i)
                    L = Lung(Lab(ii))
                    Labb = Lab(ii)
                    call StringiStringa(Labb, 8)
                    write(InteMsg,'(f8.2)') bfac(ii)
                    It(NumC) = 
     *                   Labb(1:8) // 'B=' // InteMsg(1:8) // char(0)
                    Num(NumC) = iEqui(ii)
                    if (bfac(ii).gt.BLimit) then
                        selezione(NumC) = -1
                    end if
                end if
             end if
         end if
   10 continue
      if (iActLis.eq.6) then
         NumCan = NumC
      end if
      It(NumCan+1) = char(0)
!
      call manPeekList(InteP, NumCan, MultiSel, selezione, iExitC, 5)
!
      if (iExitC .eq. 1) then         ! ok
          NumUnDel = 0
          do i=1, NumCan
             if (selezione(i) .eq. 1) then
                 NumUnDel = NumUnDel + 1
                 Num(NumUndel) = Num(i)
             end if
          end do  
      elseif (iExitC .eq. 2) then     ! all
          NumUnDel = NumCan
      elseif (iExitC .eq. 3) then     ! cancel
          NumUnDel = ncb
          do i=1,ncb
             Num(i) = numbTemp(i)
          end do
      end if
      iExCode = iExitC
! ---
      return
      end
! -------------------------------------------------------------------
      subroutine AddOneAtomNew
      USE General
      USE Atomi
      USE Molcom
!
      integer iClickati(3)
      character*8 NewLab
!
      call no_more_crosses ()
      call ResetLabelPos()
      call UpdateCommonAndList5(ier)
!
      vetSpec = 0
      iMax = 0
      do i=1,NatMol
         if (RS(i).gt.0.0) then
             iOK = 0
             do j=1,3
                if (i.eq.kptr(j)) then
                    iOK = 1
                    iClickati(j) = i
                endif
             enddo
             if (iOK.eq.0) then
                 RS(i) = -RS(i)
             endif
         endif
         isn = serial(i)
         kz = nzTot(i)
         if (isn.gt.vetSpec(kz)) then
             VetSpec(kz) = isn
         endif
      enddo
      do i=1,nk
         vetSpec(i) = vetSpec(i) + 1
      enddo
      kz = nzTot(kptr(1))
      nLa = vetSpec(kz)
      write(NewLab,'(a2,i5)') nalf(kz),nLa
      call NoBlanks(NewLab,i1)
      call ucase(NewLab(1:1))
!
      do i= NatMol + NatSpi, NatMol + 1, -1
         iCl = i + 1
         Lab(iCl)    = Lab(i)
         nzTot(iCl)  = nzTot(i)
         RS(iCl)     = RS(i)
         iCol(iCl)   = iCol(i)
         iOrd(iCl)   = iOrd(i)
         iEqui(iCl)  = iEqui(i)
         xyz(1,iCl)  = xyz(1,i)
         xyz(2,iCl)  = xyz(2,i)
         xyz(3,iCl)  = xyz(3,i)
         SinglePlotType(iCl) = SinglePlotType(i)
      enddo
      do i=1, NumLeg
         k = LE(1,i)
         if (k.gt.NatMol) then
             LE(1, i) = LE(1, i) + 1
             LE(2, i) = LE(2, i) + 1
         endif
      enddo
!
      NatMol = NatMol + 1
      iCl = iClickati(1)
!     write(Lab(NatMol),'(a2,1h(,i4,1h))') nalf(kz),nLa
!     call NoBlanks(Lab(NatMol),i1)
!     call ucase(Lab(NatMol)(1:1))
      Lab(NatMol)    = NewLab
      nzTot(NatMol)  = kz
      nz(NatMol)     = kz * nzConst
      RS(NatMol)     = RS(iCl)
      iCol(NatMol)   = iCol(iCl)
      iEqui(NatMol)  = iEqui(iCl)
      iOrd(NatMol)   = NatMol
      SinglePlotType(NatMol) = iPlotType
!
      ifCellSav = ifCell
      ifCell = 0
      call cAddOneAtom(iClickati,kz,NewLab)
      ifCell = ifCellSav
!
      return
      end
! -------------------------------------------------------------------
      subroutine AtomoNuovo(dist)
      USE General
      USE Atomi
      USE Molcom
!
      xyz(1,NatMol) = xyz(1,iCl1)
      xyz(2,NatMol) = xyz(2,iCl1)
      xyz(3,NatMol) = xyz(3,iCl1)
!-- orienta i tre atomi
      call LsPlane(NATV, 1)
      VecX = evec(1, 1)
      VecY = evec(2, 1)
      VecZ = evec(3, 1)
      call PlaneFound(VecX, VecY, VecZ)
!
      b = dtor * ang_b
      gamman = xyz(2,iCl2) - xyz(2,iCl1)
      gammad = xyz(1,iCl2) - xyz(1,iCl1)
      gamma  = atan2(gamman, gammad)   ! coeff. ang.
      xn = dist * cos(b)
      yn = dist * sin(b)
      xyz(1,NatMol) = xn * cos(gamma) - yn * sin(gamma) + xyz(1,iCl1)
      xyz(2,NatMol) = xn * sin(gamma) + yn * cos(gamma) + xyz(2,iCl1)
      xyz(3,NatMol) = xyz(3,iCl1)
!
      return
      end
! -------------------------------------------------------------------
      subroutine CancellaAtomoNuovo
      USE General
      USE Atomi
      USE Molcom
!
      do i= NatMol+1, NatMol + NatSpi
         iCl = i - 1
         Lab(iCl)    = Lab(i)
         nzTot(iCl)  = nzTot(i)
         RS(iCl)     = RS(i)
         iCol(iCl)   = iCol(i)
         iOrd(iCl)   = iOrd(i)
         iEqui(iCl)  = iEqui(i)
         xyz(1,iCl)  = xyz(1,i)
         xyz(2,iCl)  = xyz(2,i)
         xyz(3,iCl)  = xyz(3,i)
         SinglePlotType(iCl) = SinglePlotType(i)
      enddo
      do i=1, NumLeg
         k = LE(1,i)
         if (k.gt.NatMol) then
             LE(1, i) = LE(1, i) - 1
             LE(2, i) = LE(2, i) - 1
         endif
      enddo
!
      NatMol = NatMol - 1
!
      return
      end
! -------------------------------------------------------------------
