! ----------------------------------------------------------------------
      MODULE Eliche
             USE RemoModule
             real                 :: eff1a,eff1b,eff2a,eff2b,eff3a,eff3b
            real                 :: eff1c,eff2c,eff3c,eff4a,eff4b,eff4c
             integer              :: padding
             integer              :: EorF
             integer              :: ifDrawPatt, ifDrawPolar, ifDrawFreq
             integer              :: ifGetPatt
             integer              :: nzMin, nzMax
             integer              :: nyMin, nyMax
             integer              :: nxMin, nxMax
             integer              :: vetMax, vetMaxC
             integer              :: ifTestE = 0
             integer*8            :: FORTHe = 0
             real                 :: dr, dtheta, dphi
             real                 :: resElica, R_min, R_max
             real, allocatable    :: yy(:,:,:)
             real, allocatable    :: zz(:,:,:)
             real, allocatable    :: Patt_polar(:,:,:)
             real, allocatable    :: Patt_polar_sav(:,:,:)
             real, allocatable    :: patt_pro(:,:,:)
             real, allocatable    :: patt_mod(:,:,:)
             real, allocatable    :: Frequenze(:,:,:)
             real, allocatable    :: vettoreInp(:)
             complex, allocatable :: vettoreOut(:)
             real, allocatable    :: vettoreOutM2(:)
             real, allocatable    :: vettoreOutPh(:)
             type(remoModel),   allocatable :: ElicaTipo(:)
             integer              :: natsTipo
             integer              :: numbEliche
             integer              :: idCoor
             integer              :: nvolta
!--
             integer              :: natsId1
             real, allocatable    :: xyzId1(:,:)
             integer              :: natsId2
             real, allocatable    :: xyzId2(:,:)
             integer              :: natsId3
             real, allocatable    :: xyzId3(:,:)
!--
             type elicaStrutt
               real                 :: theta
               real                 :: phi
               real                 :: fom
               real                 :: esito
               integer              :: nresFirst
               integer              :: nresLast
               integer              :: nResi
               integer              :: inizio
               integer              :: fine
               integer              :: pos
             end type elicaStrutt
             type(elicaStrutt),   allocatable :: elica(:)
             type(elicaStrutt),   allocatable :: elicaSav(:)
             integer              :: nEliche = 0 
             integer              :: ResiduiEliche(100)
             integer, allocatable :: vetComb(:,:)
             integer              :: numbComb = 0
             type combSol
               integer                 :: numTot
               integer                 :: Sol1
               integer                 :: Sol2
               real                    :: RotVal1(1:3)
               real                    :: Rotval2(1:3)  
               real                    :: DiffMatrix(3,3)
             end type combSol
             type(combSol),     allocatable :: combHelix(:)
             type(combSol),     allocatable :: combRemoRot(:)

             
      END MODULE Eliche
!-----------------------------------------------------------------------
      subroutine ElicaMain(ier)
      USE General
      USE Eliche
      USE Atomi 
      USE Riflessi 
!
      implicit none
      integer :: ier, ksubr, iAction, ierr
      integer :: it, ip, ir, k, jop, jopen,i,j,kk
      real    :: tv, pv
      real    :: theta1,theta1r, phi1, chi1, corre, ctheta1
      integer :: itype, iform, ifFast, ifREM, numbPDB
      real :: diffp,difft,chistep
      real :: baricenter(3), somma1, natsold
      real :: resolmin,rho_min,solv_corr,res
      integer :: nfoundTrue,nsolgood,nposmax
      integer :: iftestreferee
!
c     iftestreferee=1
      iftestreferee=0
!
      call RoutineHeader('Helices search')
      call scrper('Searching for Helices ',0,0)
!
      call InitElica()
      call AllocaAtomi(1)
!
      if(nvolta>1) then
        Allocate(xyzId1(2:4,1:MaxAtoms),    stat = ierr)
        Allocate(xyzId2(2:4,1:MaxAtoms),    stat = ierr)
        Allocate(xyzId3(2:4,1:MaxAtoms),    stat = ierr)
      endif
!
      ier = 0
      call dirhel(ier)
      if (ier < 0) return
  
!
        if(nvolta>1) idCoor=10
!
        if (filePDB(1:1) /= ' ') then
          call TestHelixPDB
        endif
!
        call ReInitElica()
!
        ksubr = 4
        call LeggiRiflessi(ier,ksubr)
!----------cerca le orientazioni---------------------

        iAction=1
        call AllocaMappeElica(iAction)

        if (ifGetPatt == 0) then
          resElica = 3.0 
          call MakePatt(iAction)
        else
          call ReadPatt(ier)
        endif
        if (ier < 0) then
          return
        endif

      do ivolta=nvolta,1,-1
        if(nvolta>1) idCoor=ivolta*10
!
c       call LanciaJavPatt('Patterson')
        call MakeMat(iAction,ier)
!
!--memorizzo le soluzioni ottenute per l'idCoor corrente
!
        if(nvolta>1) then
          if(ivolta==1) then
            natsId1=nats
            xyzId1(2:4,1:nats)=xyzs(2:4,1:nats)
          elseif(ivolta==2) then
            natsId2=nats
            xyzId2(2:4,1:nats)=xyzs(2:4,1:nats)
          elseif(ivolta==3) then
            natsId3=nats
            xyzId3(2:4,1:nats)=xyzs(2:4,1:nats)
          endif
        endif
!
      enddo ! ivolta
!--------step 2: clusterizzo le direzioni ottenute------------------
!
!--eventualmente unisco le tre liste
!
      if(nvolta>1) then
        nats=natsId1+natsId2+natsId3
        xyzs(2:4,1:natsId1)=xyzId1(2:4,1:natsId1)
        xyzs(2:4,natsId1+1:natsId1+natsId2)=xyzId2(2:4,1:natsId2)
        xyzs(2:4,natsId1+natsId2+1:nats)=xyzId3(2:4,1:natsId3)
      endif
!
!--clusterizzo le direzioni ottenute, eventualmente controllando
!  che ciascun cluster ha un rappresentativo nelle tre liste
!
      if(nats>2) then
        call ClusterHelix()
        write(6,'(/,a)') 'List after clustering'
        if(idCoor<10) then
          write(6,*) '   N    Section      z        phi  Height'
        else
          write(6,*) '   N    Section      t        phi  Height'
        endif
        do i=1,nats
          write(6,'(i5,3f10.2,2x,g10.3)') i,xyzs(1:4,i)
        enddo
      endif
!
      if(numbEliche>0) then
         elica(:)%esito=1.0      ! azzera l'esito
         elica(:)%pos=9999       ! azzera l'esito
         if(nats>0) then
              call ControllaDirezioniEliche(nfoundTrue,
     &                    nsolgood,nposmax)
            else
              nfoundTrue=0
         endif
         eff2a=100*nfoundTrue/float(numbEliche)
         eff2b=100*nsolgood/float(nats)
c         eff2c=100*nposmax/float(nats)
         eff2c=nats
      endif
!--------step 3: calcola la correlazione per ogni sol----------------
      EorF = 2  ! uso comunque gli F per la correlazione
      resolmin=0.
      do i=1,nrefl 
         res = 0.5 / sqrt(rhov(i))
         if(res>resolmin) resolmin=res
      enddo
      rho_min = (0.5/resolmin)**2
      do i=1,nrefl 
       solv_corr=1.0-exp(-rhov(i)/rho_min)
       fovet(i)=solv_corr*fovet(i)/sqrt(epsv(i))
      enddo
!--calcolo baricentro: nota che questa operazione non cambia i risultati!!!
      baricenter(:)=0.0
      somma1=0.0
      do j=1, natsTipo
         kk = ElicaTipo(1)%specie(j,1)
         kk=no(kk)
         do i=1,3
           baricenter(i)=baricenter(i)+ElicaTipo(1)%ortho(i,j,1)*kk
         enddo
         somma1 = somma1 + kk 
      enddo
      do i=1,3
         baricenter(i) = baricenter(i) / somma1
      enddo
      do j=1,natsTipo
      do i=1,3
         ElicaTipo(1)%saved(i,j,1)= 
     &     ElicaTipo(1)%ortho(i,j,1)-baricenter(i)
        enddo
      enddo
c     ElicaTipo(1)%saved(1:3,:,1)= ElicaTipo(1)%ortho(1:3,:,1)
c
      resElica = 8.0 
c     write(6,*) 'Refinement with res=',resElica
      write(6,*) 'Selection by figure of merit CORR'

      if(nats>1) then
        if(iftestreferee==1) then
c-----------------------------------------------------------
c--test per referees: considero tutte le possibili orientazioni
           nats=0
           do ip = nzMin, nzMax            ! valori min e max di phi 
             do it = nyMin, nyMax          ! valori min e max di theta 
                nats=nats+1
                xyzs(2,nats) = float(it) * dtheta
                xyzs(3,nats) = float(ip) * dphi
                xyzs(4,nats) = 0.0
             enddo
           enddo
        endif
c-----------------------------------------------------------
        call RefineCandidates()
c       call RefineCandidatesNoCorr()
      endif

      if(iftestreferee==1) then
c-----------------------------------------------------------
!--eventualmente aggiungo anche la clusterizzazione per il referee
          if(nats>2) then
            call ClusterHelix()
            write(6,'(/,a)') 'List after clustering'
            if(idCoor<10) then
              write(6,*) '   N    Section      z        phi  Height'
            else
              write(6,*) '   N    Section      t        phi  Height'
            endif
            do i=1,nats
              write(6,'(i5,3f10.2,2x,g10.3)') i,xyzs(1:4,i)
            enddo
          endif
          if(numbEliche>0) then
             elica(:)%esito=1.0      ! azzera l'esito
             elica(:)%pos=9999       ! azzera l'esito
             if(nats>0) then
                call ControllaDirezioniEliche(nfoundTrue,
     &                    nsolgood,nposmax)
              else
                nfoundTrue=0
             endif
             eff2a=100*nfoundTrue/float(numbEliche)
             eff2b=100*nsolgood/float(nats)
c            eff2c=100*nposmax/float(nats)
             eff2c=nats
          endif
      endif
c-----------------------------------------------------------
!
!     call SRhelixRemo()
      
      iAction = 2
      call AllocaMappeElica(iAction)
!
      Deallocate (xyzId1, xyzId2, xyzId3,   stat=ierr)
!
      call scrper('Searching for Helices ends',0,0)
      call AllocaElicaTipo(iAction, 0, ier)
!
      return
      end
!-----------------------------------------------------------------
      subroutine RefineCandidates()
      USE General
      USE Eliche
      USE Atomi 
      USE Riflessi 
!
      implicit none
      integer :: ier, ksubr, iAction, ierr,figure
      integer :: it, ip, ir, k, jop, jopen, i
      integer :: ncont,j,n
      real    :: tv, pv
      real    :: theta1,theta1r, phi1, chi1, corre, ctheta1
      integer :: itype, iform, ifFast, ifREM, numbPDB, Lung
      real, allocatable :: Elicaorig(:,:)
      real :: diffp,difft,chistep,tol
      real :: corrmax,corrmaxmax,corrmaxmin,sog
      character*3 :: text
      integer :: corrRif,nfoundTrue,nsolgood,nposmax
  
!
      allocate (Elicaorig(1:3,natsTipo), stat = ierr) 
!
      figure=0
      figure=1
      corrRif=1
!
      if(corrRif==0) then
        iAction=1
        call MakePatt(iAction)
      
        iAction=2
        call MakeMat(iAction,ier)
        Patt_polar_sav=Patt_polar
        patt_mod = 0.0
      endif
!
      if(idCoor<10) then
        write(6,*) '       N       z        phi       chi     CORR'
      else
        write(6,*) '       N       t        phi       chi     CORR'
      endif
      corrmaxmax=-1
      corrmaxmin=1
      do k=1,nats
         ctheta1=xyzs(2,k)
         theta1=ctheta1
         if(idCoor>5) theta1 = (acos(ctheta1))*rtod
         phi1 = xyzs(3,k)
         chi1=0.
!occhio
c        theta1=90 ! asse x
c        phi1=0
c        theta1=90 ! asse y
c        phi1=90
c        theta1=0 ! asse z
c        phi1=0
!occhio
         ElicaTipo(1)%ortho(1:3,:,1) = ElicaTipo(1)%saved(1:3,:,1)
         if(figure==1) then
           cardDiret = 'orientato2.pdb'
           call NoBlanks(cardDiret, n)
           write(6,*) '1  ',cardDiret(1:Lung(cardDiret))
           itype = 0
           iform = 1
           jop = jopen(jhost,cardDiret,itype,iform,ier)
           if (FichierOut(1:1) == ' ') then
              FichierOut = cardDiret
           endif
           ifFast = 2
           ifREM = 3 ! numero di colonne da scrivere
           ifREM = 0 ! numero di commenti da scrivere
           call outPDB_mio(jhost, numbPDB, ifFast, ifREM)
           close(jhost)
         endif
         call OrientaElica(theta1,phi1,chi1)
!---se voglio stampare il pdb per vedere l'orientazione
         if(figure==1) then
           write(text,'(i3)') int(k)
           cardDiret = 'orientato_'//text//'.pdb'
           call NoBlanks(cardDiret, n)
           write(6,*) '2  ',cardDiret(1:Lung(cardDiret))
           itype = 0
           iform = 1
           jop = jopen(jhost,cardDiret,itype,iform,ier)
           if (FichierOut(1:1) == ' ') then
              FichierOut = cardDiret
           endif
           ifFast = 2
           ifREM = 3 ! numero di colonne da scrivere
           ifREM = 0 ! numero di commenti da scrivere
           call outPDB_mio(jhost, numbPDB, ifFast, ifREM)
           close(jhost)
         endif
         if(corrRif==0) then
           patt_mod(:,:,:)=-1.0
           patt_pro(:,:,:)=-1.0
           call MakePatt(iAction) 
           call LanciaJavPatt('Patt template')
           call MakeMat(iAction,ier)
           do ip = nzMin, nzMax             
             do it = nyMin, nyMax         
                do ir = nxMin, nxMax
                   tv = it*dtheta
                   if(idCoor>5) tv=acos(tv)*rtod
                   pv=ip*dphi
                   difft=tv-theta1
                   diffp=pv-phi1
                   if(ir==nxMin) write(59+k*100,*) 
     &                    it,ip,abs(difft),abs(diffp)
                   if(abs(difft)<7.and.abs(diffp)<5) then
                     patt_mod(ir, it, ip) = Patt_polar(ir, it, ip)
                     patt_pro(ir, it, ip) = Patt_polar_sav(ir, it, ip) 
                     if(figure==1) then
c                      if(abs(difft)<1.and.abs(diffp)<1) then ! per nico
                        write(57+k*100,*) ir,it,ip,patt_mod(ir,it,ip)
                        write(58+k*100,*) ir,it,ip,patt_pro(ir,it,ip)
c                      endif
                     endif
                   endif
                enddo
             enddo
           enddo
           call Correla_Mappe_Polar(patt_mod,patt_pro,corre)
         else
           call Correla_Riflessi(corre) 
         endif
         write(6,'(a,i5,3f10.2,f10.3)')"sol:",
     *             k,ctheta1,phi1,chi1,corre
!
!--ruoto l'elica intorno alla direzione considerata
!
           Elicaorig(1:3,1:natsTipo) =
     &              ElicaTipo(1)%ortho(1:3,1:natsTipo,1)
           chistep=120
c          chistep=99999999 ! occhiooooooooo
           chi1= chi1+chistep
           ncont=0
           corrmax=corre
           do while (chi1 <  360)
             ncont=ncont+1
             ElicaTipo(1)%ortho(1:3,1:natsTipo,1) =
     &                         Elicaorig(1:3,1:natsTipo)
             call OrientaElica(theta1,phi1,chi1)
             if(figure==1) then
!---se voglio stampare il pdb per vedere l'orientazione
               write(text,'(i3)') int(chi1)
               cardDiret = text//'orientato.pdb'
           call NoBlanks(cardDiret, n)
           write(6,*) '3  ',cardDiret(1:Lung(cardDiret))
               itype = 0
               iform = 1
               jop = jopen(jhost,cardDiret,itype,iform,ier)
               if (FichierOut(1:1) == ' ') then
                  FichierOut = cardDiret
               endif
               ifFast = 2
               ifREM = 3 ! numero di colonne da scrivere
               ifREM = 0 ! numero di commenti da scrivere
               call outPDB_mio(jhost, numbPDB, ifFast, ifREM)
               close(jhost)
             endif
             if(corrRif==0) then
               patt_mod(:,:,:)=-1.0
               patt_pro(:,:,:)=-1.0
               call MakePatt(iAction) 
               call MakeMat(iAction,ier)
               do ip = nzMin, nzMax             
                 do it = nyMin, nyMax         
                   do ir = nxMin, nxMax
                     tv = it*dtheta
                     if(idCoor>5) tv=acos(tv)*rtod
                     pv=ip*dphi
                     difft=tv-theta1
                     diffp=pv-phi1
                     if(abs(difft)<7.and.abs(diffp)<5) then
                       patt_mod(ir, it, ip) = Patt_polar(ir,it,ip)
                       patt_pro(ir, it, ip) = Patt_polar_sav(ir,it,ip)
                     endif
                   enddo
                 enddo
               enddo
               call Correla_Mappe_Polar(patt_mod,patt_pro,corre)
             else
               call Correla_Riflessi(corre) 
             endif
             write(6,'(a,i5,3f10.2,f10.3)')"sol:",
     *             k,ctheta1,phi1,chi1,corre
             chi1=chi1+chistep
             if(corre>corrmax) corrmax=corre
           enddo
           xyzs(5,k)=corrmax
           if(corrmax>corrmaxmax) corrmaxmax=corrmax
           if(corrmax<corrmaxmin) corrmaxmin=corrmax
           write(6,*) ' '
c          if(figure==1) then
c             stop !occhio
c          endif
      enddo
!
!--ricalcolo la lista delle direzioni in base alla correlazione
       xyz30(2:5,1:nats)=xyzs(2:5,1:nats)
!--riordino la lista in base alla correlazione
       call sortf(xyz30, 5,  nats, 5)  ! occhioooo, prova 24
!--seleziono le soluzioni migliori
c      tol=0.7
       tol=0.6
       sog=corrmaxmin+(corrmaxmax-corrmaxmin)*tol
       write(6,'(a,2f8.3,f8.2)') 'Corr min-max, tolerance',
     &             corrmaxmin,corrmaxmax,tol
       write(6,'(a,f8.3)') 'Correlation selection threshold',sog
       xyzs(:,:)=0.0
       ncont=0
       write(6,*) 'List of final directions'
       if(idCoor<10) then
         write(6,*) '         N       z        phi      CORR'
       else
         write(6,*) '         N       t        phi      CORR'
       endif
       do k=1,nats
         if(xyz30(5,k)>sog) then
            ncont=ncont+1
            xyzs(2:5,k)=xyz30(2:5,k)
            xyzs(4,k)=xyz30(5,k)
            write(6,'(a,i5,2f10.2,f10.3)')"solsel",
     *             k,xyzs(2:3,k),xyzs(4,k)
         endif
       enddo
       nats=ncont

       if(numbEliche>0) then
         elica(:)%esito=1.0      ! azzera l'esito 
         elica(:)%pos=9999       ! azzera l'esito 
         if(nats>0) then
              call ControllaDirezioniEliche(nfoundTrue,
     &                    nsolgood,nposmax)
            else
              nfoundTrue=0
         endif
         eff3a=100*nfoundTrue/float(numbEliche)
         eff3b=100*nsolgood/float(nats)
c        eff3c=100*nposmax/float(nats)
         eff3c=nats
         call esito
       endif
!--stage D
c      if(nats>10) nats=10
c      if(numbEliche>0) then
c        elica(:)%esito=1.0      ! azzera l'esito 
c        elica(:)%pos=9999       ! azzera l'esito 
c        if(nats>0) then
c             call ControllaDirezioniEliche(nfoundTrue,
c    &                    nsolgood,nposmax)
c           else
c             nfoundTrue=0
c        endif
c        eff4a=100*nfoundTrue/float(numbEliche)
c        eff4b=100*nsolgood/float(nats)
c        eff4c=nats
c        call esito 
c      endif
!
       return
       end
!-----------------------------------------------------------------
      subroutine RefineCandidatesNoCorr()
      USE General
      USE Eliche
      USE Atomi 
      USE Riflessi 
!
      implicit none
      integer :: ier, ksubr, iAction, ierr,figure
      integer :: it, ip, ir, k, jop, jopen, i
      integer :: ncont,j
      real    :: tv, pv
      real    :: theta1,theta1r, phi1, chi1, corre, ctheta1
      integer :: itype, iform, ifFast, ifREM, numbPDB
      real, allocatable :: Elicaorig(:,:)
      real :: diffp,difft,chistep,hmin,hmax
      real :: corrmax,corrmaxmax,corrmaxmin,sog
      character*3 :: text
      integer :: corrRif,nfoundTrue,nsolgood,nposmax
  
!
!--seleziono le soluzioni migliori
       hmin=xyzs(4,nats)
       hmax=xyzs(4,1)
       sog=hmin+(hmax-hmin)*0.2 ! 
       write(6,*) 'Height selection threshold',sog,hmin,hmax
       ncont=0
       write(6,*) 'List of final directions'
       if(idCoor<10) then
         write(6,*) '         N       z        phi       H'
       else
         write(6,*) '         N       t        phi       H'
       endif
       do k=1,nats
         if(xyzs(4,k)>sog) then
            ncont=ncont+1
            write(6,'(a,i5,2f10.2,f10.3)')"solsel",
     *             k,xyzs(2:3,k),xyzs(4,k)
         endif
       enddo
       nats=ncont

       if(numbEliche>0) then
         elica(:)%esito=1.0      ! azzera l'esito 
         elica(:)%pos=9999       ! azzera l'esito 
         if(nats>0) then
              call ControllaDirezioniEliche(nfoundTrue,
     &                    nsolgood,nposmax)
            else
              nfoundTrue=0
         endif
         eff3a=100*nfoundTrue/float(numbEliche)
         eff3b=100*nsolgood/float(nats)
c        eff3c=100*nposmax/float(nats)
         eff3c=nats
         call esito
       endif
!
       return
       end
!-----------------------------------------------------------------------
      subroutine InitElica()
      USE General
      USE Eliche
      USE RemoModule
!
      implicit none
      real    :: NresUser
      real    :: ttt, dxmax, R_maxUser
      integer :: ishift, sidepp, iAction, ier
      common /misc/ ttt(3,3), dxmax(3),ishift(3,19)
!
!-- set default values
!
c     idCoor=1  ! angoli polari riferiti all'asse x          ! definizione canonica
      idCoor=10 ! coordinate di campionamento uniforme: phi, theta=cos(theta)   (default)
c     idCoor=2  ! angoli polari riferiti all'asse y
c     idCoor=20 ! coordinate di campionamento uniforme: phi, theta=cos(theta) 
c     idCoor=3  ! angoli polari riferiti all'asse z               
c     idCoor=30 ! coordinate di campionamento uniforme: phi, theta=cos(theta) 
      nvolta=1
c     nvolta=3
!
c     if(nvolta==1) then
c        write(6,*) 'Parameter definition: ',idCoor
c     else
c        write(6,*) 'Parameter definition: ',30,20,10
c     endif
!
      WhichModel = 0
      MaxnumbModels = 5
      MonomerInModel(:) = 1
      numbModels = 1
      iAction = 0
      call AllocaModelRemo(iAction)
      numbModels = 0
!
      EorF = 2
      ifDrawPatt = 0
      ifDrawPolar = 0
      ifDrawFreq = 0
      ifGetPatt = 0
!
      resElica = 3.0
      dr     = 0.5 !(default)
c     dr     = 0.3333 ! occhio
!
      if(idCoor>5.or.nvolta==3) then
        dtheta = 0.03333
c       dtheta = 0.02
      else
        dtheta = 3.0
c       dtheta = 1.5
      endif
      dphi   = 3.0
c     dphi   = 1.5
!
      ishift(1:3,1) =(/ -1,  0, -1/)
      ishift(1:3,2) =(/  0, -1, -1/)
      ishift(1:3,3) =(/  0,  0, -1/)
      ishift(1:3,4) =(/  0,  1, -1/)
      ishift(1:3,5) =(/  1,  0, -1/)
      ishift(1:3,6) =(/ -1, -1,  0/)
      ishift(1:3,7) =(/ -1,  0,  0/)
      ishift(1:3,8) =(/ -1,  1,  0/)
      ishift(1:3,9) =(/  0, -1,  0/)
      ishift(1:3,10)=(/  0,  0,  0/)
      ishift(1:3,11)=(/  0,  1,  0/)
      ishift(1:3,12)=(/  1, -1,  0/)
      ishift(1:3,13)=(/  1,  0,  0/)
      ishift(1:3,14)=(/  1,  1,  0/)
      ishift(1:3,15)=(/ -1,  0, +1/)
      ishift(1:3,16)=(/  0, -1, +1/)
      ishift(1:3,17)=(/  0,  0, +1/)
      ishift(1:3,18)=(/  0,  1, +1/)
      ishift(1:3,19)=(/  1,  0, +1/)
!
c     padding=1 ! no zero padding
c     padding=2 ! con zero padding
c     padding=3 ! con zero padding
      padding=4 ! con zero padding (default)
c     padding=6 ! con zero padding
c
      call FillElicaTipo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ReInitElica()
      USE Eliche
      USE General, only : filePDB, cell,resm, ifRemo
      USE Mappa, only : np
      USE Param, only : v_s, v_m, v_p
!
      real :: Rmaxmin
!     
      write(6,210) v_m, v_p, v_s
 210  format (' Matthews coefficient         =',f12.2,/,
     *        ' Protein fraction             =',f12.2,/,
     *        ' Solvent fraction             =',f12.2)
!
!--ridetermina delle costanti alla luce di quanto letto nelle direttive
!  o dal pdb
!
!
c     R_min  = 0 ! occhiooooooooo, per fare le figure
      R_min  = 3.5 !(default)
      R_max = amax1(cell(1)/2.0, cell(2)/2.0, cell(3)/2.0)
!
      if(nEliche==0) then
!--non dato dall'Utente
        if (filePDB(1:1) /= ' ') then
!--prendo i valori letti dal pdb
           nEliche = numbEliche       
           do i=1,numbEliche
             ResiduiEliche(i) = elica(i)%nResi
           enddo
        else
!--inserisco dei valori di default
           nEliche = 10 ! numero di eliche da ricercare
           ResiduiEliche(1:nEliche)=20 ! numero di residui delle eliche da ricercare
        endif
      endif
!
c     if(nEliche>0) then
        NresUser=maxval(ResiduiEliche(1:nEliche))!lunghezza massima dell'elica da ricercare
        R_maxUser = 1.4*NresUser
        R_max = amin1(R_max,R_maxUser)
c     endif
!
      write(6,'(a,i8)') 
     &     'Number of residues of the longest helix to search:',NresUser
      write(6,'(a,2f8.2)') 'Minimum and maximum Patterson radius',
     &          R_min, R_max
!
!--controllo sullo spazio di ricerca
!
      Rmaxmin=(5.4+R_min)
      if(R_max<Rmaxmin) then
         write(6,*) 'Search space too short to find helices' 
         stop
      endif
!
!--occhio
c     resmOld=resm
c     resm=resElica
c     ifRemo=1
c     call CheckGrid()
c     resm=resmOld
c     npmax=maxval(np(1:3))
c     drnew=(R_max-R_min)/float(npmax)
c     write(6,*) 'occhio',dr,drnew,npmax
c     dr=drnew
c--occhio
!
!--calcolo la lunghezza media delle eliche nella struttura
!
      NresUserMean=0
      do i=1,nEliche
         NresUserMean=NresUserMean+ResiduiEliche(i)
      enddo
      NresUserMean=NresUserMean/float(nEliche)
      write(6,*) 'Average length of the helices',NresUserMean
!
!--aggiusto la lunghezza dell'elica campione in modo che non sia
!  maggiore della piu' lunga elica esistente nella struttura
!
      nresold=-999
      icontRes=0
      icontAtom=0
      do i=1,natsTipo
        icontAtom=icontAtom+1
        nres=ElicaTipo(1)%numResiduo(i,1)
        if(nres.ne.nresold) then
          icontRes=icontRes+1
          nresold=nres
        endif
        if(icontRes>=NresUser) exit
c       if(icontRes>=NresUserMean) exit
      enddo
      natsTipo=icontAtom
      nresTipo=icontRes
      write(6,*) 'Length of Sample Helix',natsTipo,nresTipo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine FillElicaTipo
      USE General
      USE Eliche
      USE Groups
      USE Molcom, only : rmi
!
      implicit none
      integer :: ierr, k, ifAll, ifHOH, ifHET, ifBack
      integer :: nSpec, nSecondary, ier, itype, iform, jopen, ios
      integer :: i, j, nats
      real    :: aniso(6), celltemp(13), x1(3), x2(3)
      character (len=4) :: tmpSpecies(18), a4
!
      do i=1, nk
         tmpSpecies(i) = Species(i)
         call lcase(tmpSpecies(i))
      enddo
      k = index(iasun, slash, .TRUE.)
      filePDB = iasun(1:k) // 'HelixTemplate.pdb'
      itype=2
      iform=1
      if (jopen(jhost, filePDB, itype, iform, ios) < 0) then
          call cstop('Helix template file not found')
          ier = -1
          return
      endif
      nResTot = 0
      nChains = 1
      cChains(1) = 65
      natsTipo   = 0
      ifAll = 0
      ifHOH = 0
      ifHET = 0
      ifBack = 0
      ifCutResidui = 0
      nats   = 0
      call LeggiPDBinMem(ifAll, ifHOH, ifHET, ifBack, ifCutResidui,
     *                   celltemp, nats, nSpec, nSecondary, ier)
      call AllocaElicaTipo(1, nats, ierr)
!
      rewind jgrap
!
      do i=1, natsTipo
         read(jgrap)
     *        ElicaTipo(1)%ortho(1:3,i,1),
     *        ElicaTipo(1)%atoms(4:5,i,1),
     *        ElicaTipo(1)%specie(i,1),
     *        ElicaTipo(1)%th_fact(i,1),
     *        ElicaTipo(1)%tipoAtomo(i,1),
     *        ElicaTipo(1)%Alternate(i,1),
     *        ElicaTipo(1)%tipoResiduo(i,1),
     *        ElicaTipo(1)%catena(i,1),
     *        ElicaTipo(1)%numResiduo(i,1),
     *        ElicaTipo(1)%Insertion(i,1),
     *        ElicaTipo(1)%Label(i),
     *        aniso(1:6)
         a4 = vSpecie(ElicaTipo(1)%specie(i,1))
         do j=1, nk
            if (a4 == tmpSpecies(j)) then
                ElicaTipo(1)%specie(i,1) = j
                exit
            endif
         enddo
      enddo
      ElicaTipo(1)%nk=nk 

!
      close(jgrap)
      close(jhost)
!
      do i=1, nats
         x1(1:3) = ElicaTipo(1)%ortho(1:3,i,1)
         call MoltMatVec(rmi, x1, x2)
         ElicaTipo(1)%atoms(1:3,i,1)= x2(1:3)
c        ElicaTipo(1)%saved(1:3,i,1)= x2(1:3)
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaElicaTipo(iAction, nats, ierr)
      USE Eliche
!
      implicit none
      integer :: iAction, nats, ierr, ierv(0:12)
!
      ierv(:) = 0
      if (iAction == 1) then
         natsTipo = nats
         allocate (ElicaTipo(1),                        stat = ierv( 0))
         allocate (ElicaTipo(1)%atoms(5,natsTipo,1),    stat = ierv( 1))
         allocate (ElicaTipo(1)%saved(3,natsTipo,1),    stat = ierv( 2))
         allocate (ElicaTipo(1)%ortho(3,natsTipo,1),    stat = ierv( 3))
         allocate (ElicaTipo(1)%specie(natsTipo,1),     stat = ierv( 4))
         allocate (ElicaTipo(1)%th_fact(natsTipo,1),    stat = ierv( 5))
         allocate (ElicaTipo(1)%tipoAtomo(natsTipo,1),  stat = ierv( 6))
         allocate (ElicaTipo(1)%tipoResiduo(natsTipo,1),stat = ierv( 7))
         allocate (ElicaTipo(1)%Alternate(natsTipo,1),  stat = ierv( 8))
         allocate (ElicaTipo(1)%catena(natsTipo,1),     stat = ierv( 9))
         allocate (ElicaTipo(1)%Secondary(natsTipo,1),  stat = ierv(10))
         allocate (ElicaTipo(1)%Label(natsTipo),        stat = ierv(11))
         allocate (ElicaTipo(1)%numResiduo(natsTipo,1), stat = ierv(12))
         allocate (ElicaTipo(1)%Insertion(natsTipo,1),  stat = ierv(12))
!
          ierr = sum(iabs(ierv(:)))
          if (ierr /= 0) then
              ierr = -1
          endif
      else
          deallocate (ElicaTipo(1)%atoms,
     *                ElicaTipo(1)%saved,
     *                ElicaTipo(1)%ortho,
     *                ElicaTipo(1)%specie,
     *                ElicaTipo(1)%th_fact,
     *                ElicaTipo(1)%tipoAtomo,
     *                ElicaTipo(1)%tipoResiduo,
     *                ElicaTipo(1)%Alternate,
     *                ElicaTipo(1)%catena,
     *                ElicaTipo(1)%Secondary,
     *                ElicaTipo(1)%Label,
     *                ElicaTipo(1)%numResiduo,
     *                ElicaTipo(1)%Insertion, stat = ierv(1))
          deallocate (ElicaTipo, stat = ierv(0))
          ierr = sum(iabs(ierv(:)))
          if (ierr /= 0) then
              ierr = -1
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine TestHelixPDB
      USE General
      USE Eliche
      USE Groups
      USE Molcom, only: rm, rmi
      USE Atomi, only: nzConst
!
      implicit none
      integer :: ierr, k, ifAll, ifHOH, ifHET, ifBack, lastAtom
      integer :: nSpec, nSecondary, ier, itype, iform, jopen, ios
      integer :: i, j, i1, i2, nats, itipo, n1, n2, nzS
      integer :: OldRes, numeroCatene
      real    :: aniso(6), celltemp(13), x1(3), x2(3)
      character (len=1) :: oldCat, Catena, Secondary
      character (len=4) :: tmpSpecies(18), a4
      character (len=1), allocatable :: CSecondary(:)
!
      do i=1, nk
         tmpSpecies(i) = Species(i)
         call lcase(tmpSpecies(i))
      enddo
      itype=2
      iform=1
      if (jopen(jhost, filePDB, itype, iform, ios) < 0) then
          call cstop('PDB file not found')
          ier = -1
          return
      endif
      nResTot = 0
      nChains = 1
      cChains(1) = 65
c     natsTipo   = 0
      ifAll = 0
      ifHOH = 1
      ifHET = 1
      ifBack = 0
      ifCutResidui = 0
      nats   = 0
      call LeggiPDBinMem(ifAll, ifHOH, ifHET, ifBack, ifCutResidui,
     *                   celltemp, nats, nSpec, nSecondary, ier)
!
c     numbModels = numbModels + 1
      numbModels =  1
c     WhichModel = WhichModel + 1
      WhichModel =  1
      natsInModel(WhichModel) = nats
      MonomerInModel(WhichModel) = 1
c     WhichMonomer = WhichMonomer + 1
      WhichMonomer =  1
      call AllocaModelRemo(1)
      model(WhichModel)%Secondary(:,1) = ' '
!
      numeroResidui = 0
      numeroCatene = 0
      nLegBack = 0
      OldRes = 0
      OldCat = ' '
!
      rewind jgrap
      do i=1, nats
        read(jgrap) model(WhichModel)%ortho(1:3,i,1),
     *              model(WhichModel)%atoms(4:5,i,1),
     *              nzS,
     *              model(WhichModel)%th_fact(i,1),
     *              model(WhichModel)%tipoAtomo(i,1),
     *              model(WhichModel)%Alternate(i,1),
     *              model(WhichModel)%tipoResiduo(i,1),
     *              model(WhichModel)%catena(i,1),
     *              model(WhichModel)%numResiduo(i,1),
     *              model(WhichModel)%Insertion(i,1),
     *              model(WhichModel)%Label(i),    ! catena, num. residuo, label
     *              aniso(1:6)
         model(WhichModel)%specie(i,1) = nzS * nzConst
         if (model(WhichModel)%numResiduo(i,1) /= OldRes) then
             numeroResidui = numeroResidui + 1
             oldRes = model(WhichModel)%numResiduo(i,1)
         endif
         if (model(WhichModel)%catena(i,1) /= OldCat) then
             numeroCatene = numeroCatene + 1
             oldCat = model(WhichModel)%catena(i,1)
         endif
      enddo
!
      Species(1:18) = vSpecie(1:18)
      vSpecie(1:18) = tmpSpecies(1:18)
      call SincronizzaSpecieRemo()
!
      if (nSecondary > 0) then
*         iprin = 1
          do j=1, nSecondary
             read(jgrap) itipo, n1, i1, n2, i2
             if (iprin > 0)
     *       write(lo,*) char(itipo), char(i1), n1, char(i2), n2
             Secondary = char(itipo)
             if (char(i1) == ' ') then
                 oldCat = 'A'
             else
                 oldCat = char(i1)
             endif
             if (char(i2) == ' ') then
                 Catena = 'A'
             else
                 Catena = char(i2)
             endif
             do i=1, nats
                if (model(WhichModel)%catena(i,1) /= Catena) cycle
                if (model(WhichModel)%numResiduo(i,1) >= n1 .and.
     *              model(WhichModel)%numResiduo(i,1) <= n2) then
                    model(WhichModel)%Secondary(i,1) = Secondary
                    lastAtom = i
                endif
             enddo
             call lcase(Secondary)
             model(WhichModel)%Secondary(lastAtom,1) = Secondary
          enddo
      endif
!
      close(jgrap)
      close(jhost)
!
      do i=1, nats
         x1(1:3) = model(WhichModel)%ortho(1:3,i,1)
         call MoltMatVec(rmi, x1, x2)
         model(WhichModel)%atoms(1:3,i,1)= x2(1:3)
c        model(WhichModel)%saved(1:3,i,1)= x2(1:3)
         if (model(WhichModel)%tipoResiduo(i,1) == '    ') then
             model(WhichModel)%Secondary(i,1) = 'W'
         endif
      enddo
!
      if (nSecondary == 0) then
!
!-- chiamata alla subr. in C per la definizione della struttura secondaria
!
          Allocate(CSecondary(nats))
          call SecondaryStructureInfo(nats, nSecondary, CSecondary)
          do i=1, nats
             model(WhichModel)%Secondary(i,1) = CSecondary(i)
          enddo
          Deallocate(CSecondary)
!
      endif
!
      if (nSecondary > 0) then
          call AnalyzeHelixPDB
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AnalyzeHelixPDB
      USE General
      USE Eliche
!
      implicit none
      integer           :: i,  inizio, fine, nResi, jResi, WM, nHelix
      integer           :: ierr, nresFirst, nresLast, Lung,nResiMin
      real              :: theta, phi
      character (len=1) :: Alternate, Catena, Secondary
      integer           :: ncont
!
      nResiMin=7
!
      WM = WhichModel
      iprin = 0
      if(idCoor<10) then
        write(lo,100)  filePDB(1:Lung(filePDB))
      else
        write(lo,101)  filePDB(1:Lung(filePDB))
      endif
      nHelix = 0
      Secondary = ' '
      do i=1, natsInModel(WM)
         Alternate = model(WM)%Secondary(i,1)
         if (iprin > 0)
     *   write(lo,*) Alternate,' ',
     *               model(WM)%numResiduo(i,1),
     *               model(WM)%catena(i,1)
         if (Alternate /= Secondary) then
             if (Alternate == 'H') then
                 nHelix = nHelix + 1
                 if (iprin > 0)
     *               write(lo,*) nHelix, Alternate,
     *                          model(WM)%numResiduo(i,1),
     *                          model(WM)%catena(i,1)
             endif
             Secondary = Alternate
         endif
      enddo
!
      numbEliche=nHelix
      if (.not. ALLOCATED(elica)) then
           allocate (elica(1:numbEliche), stat = ierr)
      endif
      do i=1,numbEliche
        elica(i)%theta=0.0
        elica(i)%phi=0.0
      enddo
!
      if (nHelix > 0) then
          nHelix = 0
          Secondary = ' '
          inizio = 0
          fine = 0
          nResi = 0
          jResi = 0
          do i=1, natsInModel(WM)
             Alternate = model(WM)%Secondary(i,1)
             if (Alternate == 'H') then
                if (model(WM)%numResiduo(i,1) /= jResi) then
                    nResi = nResi + 1
                    jResi = model(WM)%numResiduo(i,1)
                endif
             endif
             if (inizio > 0 .and. Alternate /= 'H') then
                 if (Alternate == 'h') then
                     fine = i
                 else
                     fine = i - 1
                 endif
                 nresFirst=model(WM)%numResiduo(inizio,1)
                 nresLast=model(WM)%numResiduo(fine,1)
                 elica(nHelix)%nresFirst=nresFirst
                 elica(nHelix)%nresLast=nresLast
                 elica(nHelix)%nResi=nResi
                 elica(nHelix)%inizio=inizio
                 elica(nHelix)%fine=fine
                 inizio = 0
                 jResi = 0
                 nResi = 0
             endif
             if (Alternate /= Secondary) then
                 if (Alternate == 'H') then
                     nHelix = nHelix + 1
                     inizio = i
                 endif
                 Secondary = Alternate
             endif
          enddo
          if (inizio > 0) then
              fine = natsInModel(WM)
              nresFirst=model(WM)%numResiduo(inizio,1)
              nresLast=model(WM)%numResiduo(fine,1)
              elica(nHelix)%nresFirst=nresFirst
              elica(nHelix)%nresLast=nresLast
              elica(nHelix)%nResi=nResi
              elica(nHelix)%inizio=inizio
              elica(nHelix)%fine=fine
          endif
!
!--ordino le eliche in base ai loro residui ed escludo quelle piu' corte
!
          if (.not. ALLOCATED(elicaSav)) then
             allocate (elicaSav(1:numbEliche), stat = ierr)
          endif
          ncont=0
          do i=1,numbEliche
            nResi=elica(i)%nResi
            if(nResi<=nResiMin) cycle
            ncont=ncont+1
            inizio=elica(i)%inizio
            fine=elica(i)%fine
            call CalcolaThetaPhi(inizio, fine, theta, phi)
            elica(i)%theta=theta
            elica(i)%phi=phi
            elicaSav(ncont)=elica(i)
          enddo
          numbEliche=ncont
          elica=elicaSav
          call CalcolaFomHelix    
      else
          write(lo,300)
      endif
!
      write(lo,500)
!
!--metto una correzione per la prima alpha elica di 3KUT: occhioooooo
!
c     elica(1)%phi=27
c     elica(1)%theta=38
!
      return
  100 format(/,14x,' Alpha-Helices Analysis (',a,')'//,
     *   '   Helix #   from res    to res      Length    Theta     Phi',
     *   '    Fom   SogDist')
  101 format(/,14x,' Alpha-Helices Analysis (',a,')'//,
     *   '   Helix #   from res    to res      Length      t       Phi',
     *   '    Fom   SogDist')
  300 format(/,' *** No Alpha-Helices found ***')
  500 format(/,' ',78('+'),/)
      end
!-----------------------------------------------------------------------
      subroutine CalcolaThetaPhi(inizio, fine, theta, phi)
      USE General
      USE Eliche
      USE Symmetry, only : nsymTot
      USE Molcom, only : rmi, rm
!
      implicit none
      integer           :: inizio, fine, j, imono, imodel, nca, nres
      integer           :: nresFirst,nresLast, nmax(1), print, id
      real              :: theta, phi, baricenter(3), valTr, valPr
      character (len=1) :: Alternate, Catena, Secondary
      real              :: inert(3,3), xc,yc,zc, avxx, avyy, avzz
      real              :: lambda(3),nplane1(3),nplane2(3),nplane3(3)
      integer           ::  itensor, ies, nresold, nresHelix,k
      character(len=4)  :: itype,itypeold
      real              :: baric1(3),baric2(3)
      real              :: xdiff,ydiff,zdiff,rdiff
      real              :: cosx,cosy,cosz,phi1a,theta1a
      real              :: iresfirst,ireslast, ires, dist, sog
      real              :: vet1(3),vet2(3), phi1b, theta1b
      real              :: xx1,yy1,zz1, xs1(3), xs(3), xs2(3)
      integer           :: inRegionHelix

!
      itensor=1  ! tensore d'inerzia
c      itensor=2  ! matrice di covarianza
!
      print=0
c     print=1
      theta = 0.0
      phi   = 0.0
!
      imodel=WhichModel
      imono=WhichMonomer
!
!--calcolo il baricentro
!
      nca=0
      baricenter(:)=0.0
      itypeold="  "
      do j=inizio,fine
        itype=model(imodel)%tipoatomo(j,imono)
        nres=model(imodel)%numResiduo(j,imono)
        ies=0
        if(model(imodel)%tipoatomo(j,imono)=="ca  ") ies=1
        if(model(imodel)%tipoatomo(j,imono)=="cb  ") ies=1
        if(model(imodel)%tipoatomo(j,imono)=="c   ") ies=1
        if(model(imodel)%tipoatomo(j,imono)=="n   ") ies=1
        if(model(imodel)%tipoatomo(j,imono)=="o   ") ies=1
        if(itype.eq.itypeold.and.nres.eq.nresold) ies=0
        if(ies==1) then
            itypeold=model(imodel)%tipoatomo(j,imono)
            nresold=model(imodel)%numResiduo(j,imono)
            xc=model(imodel)%ortho(1,j,imono)
            yc=model(imodel)%ortho(2,j,imono)
            zc=model(imodel)%ortho(3,j,imono)
            baricenter(1)=baricenter(1)+xc
            baricenter(2)=baricenter(2)+yc
            baricenter(3)=baricenter(3)+zc
            nca=nca+1
        endif
      enddo
      nresFirst=model(imodel)%numResiduo(inizio,imono)
      nresLast=model(imodel)%numResiduo(fine,imono)
      nresHelix=nresLast-nresFirst+1
      if(print>0) then
         write(6,'(3(a,i5))') 'Number of residues',nresHelix,' First:',
     &               nresFirst,' Last:',nresLast
         write(6,*) 'NCA',nca
      endif
      baricenter(:)=baricenter(:)/float(nca)
!
!--calcolo il momento d'inerzia
!
      inert(:,:)=0.0
      itypeold="  "
      do j=inizio,fine
        itype=model(imodel)%tipoatomo(j,imono)
        nres=model(imodel)%numResiduo(j,imono)
        ies=0
        if(model(imodel)%tipoatomo(j,imono)=="ca  ") ies=1
        if(model(imodel)%tipoatomo(j,imono)=="cb  ") ies=1
        if(model(imodel)%tipoatomo(j,imono)=="c   ") ies=1
        if(model(imodel)%tipoatomo(j,imono)=="n   ") ies=1
        if(model(imodel)%tipoatomo(j,imono)=="o   ") ies=1
        if(itype.eq.itypeold.and.nres.eq.nresold) ies=0
        if(ies==1) then
            itypeold=model(imodel)%tipoatomo(j,imono)
            nresold=model(imodel)%numResiduo(j,imono)
            xc=model(imodel)%ortho(1,j,imono)-baricenter(1)
            yc=model(imodel)%ortho(2,j,imono)-baricenter(2)
            zc=model(imodel)%ortho(3,j,imono)-baricenter(3)
            if(itensor==1) then
              inert(1,1)=inert(1,1)+zc*zc+yc*yc
              inert(2,2)=inert(2,2)+xc*xc+zc*zc
              inert(3,3)=inert(3,3)+xc*xc+yc*yc
              inert(1,2)=inert(1,2)-xc*yc
              inert(1,3)=inert(1,3)-xc*zc
              inert(2,3)=inert(2,3)-yc*zc
            else
              inert(1,1)=inert(1,1)+xc*xc
              inert(2,2)=inert(2,2)+yc*yc
              inert(3,3)=inert(3,3)+zc*zc
              inert(1,2)=inert(1,2)+xc*yc
              inert(1,3)=inert(1,3)+xc*zc
              inert(2,3)=inert(2,3)+yc*zc
            endif
            inert(2,1)=inert(1,2)
            inert(3,1)=inert(1,3)
            inert(3,2)=inert(2,3)
        endif
      enddo
!
!--trovo gli autovalori della matrice di inerzia
!
      call egnvl(inert,lambda)
      if(print>0) write(6,*) 'lambda',lambda
!
!--trovo gli autovettori della matrice di inerzia
!  il primo autovettore (quello minore) si riferisce all'asse principale di inerzia
!  che nel caso dell'elica coincide con l'asse dell'elica
!
      call egnvc(inert,lambda,nplane1,nplane2,nplane3)
      if(print>0) then
        write(6,*) 'autovettore 1',nplane1
        write(6,*) 'autovettore 2',nplane2
        write(6,*) 'autovettore 3',nplane3
      endif
      if(itensor==1) then
        avxx=nplane1(1)
        avyy=nplane1(2)
        avzz=nplane1(3)
      else
        avxx=nplane3(1)
        avyy=nplane3(2)
        avzz=nplane3(3)
      endif
      if(avxx<0.0) then   
        avxx=-avxx
        avyy=-avyy
        avzz=-avzz
      endif
      call CarToPol(avxx,avyy,avzz,theta1a,phi1a)
      if(print>0) write(6,*) 'angoli',theta1a,phi1a

      if(print>0) then 
        call PolToCar(theta1a,phi1a,xx1,yy1,zz1)
        call CarToPol(-xx1,-yy1,-zz1,theta,phi)
        write(6,*) 'vedo invertito ',theta,phi
      endif
!
!--confronto con versori dell'asse trovati con altri metodi
!
      if(nresHelix<6)  then
        theta=theta1a
        phi=phi1a
        return
      endif

      nca=0
      baric1(:)=0.0
      itypeold="  "
      iresfirst=model(imodel)%numResiduo(inizio,imono)
      ireslast=iresfirst+3
      do j=inizio,fine
        ires=model(imodel)%numResiduo(j,imono)
        if(ires>ireslast) exit
        itype=model(imodel)%tipoatomo(j,imono)
        nres=model(imodel)%numResiduo(j,imono)
        ies=0
        if(model(imodel)%tipoatomo(j,imono)=="ca  ") ies=1
        if(model(imodel)%tipoatomo(j,imono)=="cb  ") ies=1
        if(model(imodel)%tipoatomo(j,imono)=="c   ") ies=1
        if(model(imodel)%tipoatomo(j,imono)=="n   ") ies=1
        if(model(imodel)%tipoatomo(j,imono)=="o   ") ies=1
        if(itype.eq.itypeold.and.nres.eq.nresold) ies=0
        if(ies==1) then
            itypeold=model(imodel)%tipoatomo(j,imono)
            nresold=model(imodel)%numResiduo(j,imono)
            xc=model(imodel)%ortho(1,j,imono)
            yc=model(imodel)%ortho(2,j,imono)
            zc=model(imodel)%ortho(3,j,imono)
            baric1(1)=baric1(1)+xc
            baric1(2)=baric1(2)+yc
            baric1(3)=baric1(3)+zc
            nca=nca+1
        endif
      enddo
      baric1(:)=baric1(:)/float(nca)
c
      nca=0
      baric2(:)=0.0
      itypeold="  "
      ireslast=model(imodel)%numResiduo(fine,imono)
      iresfirst=ireslast-3
      do j=inizio,fine
        ires=model(imodel)%numResiduo(j,imono)
        if(ires<iresfirst) cycle
        itype=model(imodel)%tipoatomo(j,imono)
        nres=model(imodel)%numResiduo(j,imono)
        ies=0
        if(model(imodel)%tipoatomo(j,imono)=="ca  ") ies=1
        if(model(imodel)%tipoatomo(j,imono)=="cb  ") ies=1
        if(model(imodel)%tipoatomo(j,imono)=="c   ") ies=1
        if(model(imodel)%tipoatomo(j,imono)=="n   ") ies=1
        if(model(imodel)%tipoatomo(j,imono)=="o   ") ies=1
        if(itype.eq.itypeold.and.nres.eq.nresold) ies=0
        if(ies==1) then
            itypeold=model(imodel)%tipoatomo(j,imono)
            nresold=model(imodel)%numResiduo(j,imono)
            xc=model(imodel)%ortho(1,j,imono)
            yc=model(imodel)%ortho(2,j,imono)
            zc=model(imodel)%ortho(3,j,imono)
            baric2(1)=baric2(1)+xc
            baric2(2)=baric2(2)+yc
            baric2(3)=baric2(3)+zc
            nca=nca+1
        endif
      enddo
      baric2(:)=baric2(:)/float(nca)
      xdiff=baric2(1)-baric1(1)
      ydiff=baric2(2)-baric1(2)
      zdiff=baric2(3)-baric1(3)
      rdiff=sqrt((baric1(1)-baric2(1))**2+(baric1(2)-baric2(2))**2+
     &                                    (baric1(3)-baric2(3))**2)
      cosx=xdiff/rdiff
      cosy=ydiff/rdiff
      cosz=zdiff/rdiff
      if(cosx<0.0) then
        cosx=-cosx 
        cosy=-cosy
        cosz=-cosz
      endif
      call CarToPol(cosx,cosy,cosz,theta1b,phi1b)
      if(print>0) then
        write(6,*) 'autovettore new',cosx,cosy,cosz
        write(6,*) 'angoli new',theta1b,phi1b
      endif

      if(print>0) then 
        call PolToCar(theta1b,phi1b,xx1,yy1,zz1)
        call CarToPol(-xx1,-yy1,-zz1,theta,phi)
        write(6,*) 'vedo invertito ',theta,phi
      endif
!
!--controllo che le due determinazioni si riferiscano entrambi alla stessa semisfera
!
      call ConfrontaEliche(theta1a,phi1a,theta1b,phi1b,dist,id)
      if(id<0) then
!--decido quale vettore invertire
        vet1(1:3)=(/ avxx, avyy, avzz /)
        vet2(1:3)=(/ cosx, cosy, cosz /)
        nmax=maxloc(abs(vet1))
        if(vet1(nmax(1))>vet2(nmax(1))) then
          cosx=-cosx
          cosy=-cosy
          cosz=-cosz
          call CarToPol(cosx,cosy,cosz,theta1b,phi1b)
          if(print>0) then
            write(6,*) 'autovettore cambiato (2)',cosx,cosy,cosz
            write(6,*) 'angoli cambiati (2)',theta1b,phi1b
          endif
        else 
          avxx=-avxx
          avyy=-avyy
          avzz=-avzz
          call CarToPol(avxx,avyy,avzz,theta1a,phi1a)
          if(print>0) then
            write(6,*) 'autovettore cambiato (1)',avxx,avyy,avzz
            write(6,*) 'angoli cambiati (1)',theta1a,phi1a
          endif
        endif
      endif
!
!--decido se fare la media o no
!
c     sog=0.3
      sog=0.2
      if(dist>sog) then
!--nel caso di scostamento preferisco uno dei metodi: quale?
c       theta=theta1a
c       phi=phi1a
        theta=theta1b
        phi=phi1b
      else
        if(print>0) write(6,*) 'faccio la media',dist
!-faccio la media tra le due determinazioni
        avxx=0.5*(avxx+cosx)
        avyy=0.5*(avyy+cosy)
        avzz=0.5*(avzz+cosz)
        if(avxx<0.0) then
          avxx=-avxx
          avyy=-avyy
          avzz=-avzz
        endif
        call CarToPol(avxx,avyy,avzz,theta,phi)
      endif
c
      if(print>0) then 
        call PolToCar(theta,phi,xx1,yy1,zz1)
        call CarToPol(-xx1,-yy1,-zz1,theta1a,phi1a)
        write(6,*) 'vedo invertito ',theta1a,phi1a
      endif
!
!--riferisco theta e phi all'unita' asimmetrica scelta
!
      call Switch_to_Patterson_Group
      call PolToCar(theta,phi,xs1(1),xs1(2),xs1(3))
c     write(6,*) 'vecchio',theta,phi
c     write(6,*) 'coor1',xs1
      xs1(1:3)=4.*xs1(1:3)
      call MoltMatVec(rmi, xs1, xs)
c     write(6,*) 'coor2',xs
      do k=1,nsymTot
         call oper(k,xs1,xs(1),xs(2),xs(3))
c        write(6,*) 'coor3',xs1
         call MoltMatVec(rm, xs1, xs2)
c        write(6,*) 'coor4',xs2
         dist=sqrt(xs2(1)**2+xs2(2)**2+xs2(3)**2)
         if(abs(dist-4)>1) cycle ! non considero le direzioni con centratura
         xs2(1:3)=xs2(1:3)/dist
c        write(6,*) 'coor5',xs2
         call CarToPol(xs2(1),xs2(2),xs2(3),theta,phi)
c        write(6,*) 'nuovo',theta,phi
         if(inRegionHelix(theta,phi)>0) then
           ies=1
           exit
         endif
      enddo
      call Switch_from_Patterson_Group
!
      if(ies==0) then
         write(6,*) 'WARNINGGGGGGGGG'
         stop
      endif

!
      return
      end
!-----------------------------------------------------------------------
      subroutine CalcolaFomHelix
      USE General
      USE Atomi
      USE RemoModule
      USE Eliche
      USE Symmetry, only :  nsymTot
      USE Molcom, only : rmi, rm
!
      implicit none
      integer :: inizio, fine, i, j, k, idrogeno, nHx
      real    :: fom, theta, phi, distxyz(3), arg, dist, fom1
      real    :: valR, valTr, valPr, u(3), Aij, elle, enne1, enne1rem
      real    :: RaggioElica, LunghezzaElica,sog, fomNum,fomDen
      real    :: tolmin,tolmax
      integer :: ies1,ies2,ies
      real    :: xsio(3),xsjo(3),xs(3),xs1(3),xsi2(3),xsj2(3)
      integer    :: ki,kj,ifcalculate
      real    ::  funErrHelix
      integer    :: icontfom1
      
!
      ifcalculate=0
!
      if (no(1) == 1) then
          idrogeno = 1
      else
          idrogeno = 0
      endif
      RaggioElica=2.35
      tolmin=4.9
      tolmax=5.5
      do nHx=1, numbEliche
         inizio = elica(nHx)%inizio
         fine   = elica(nHx)%fine
         theta  = elica(nHx)%theta
         phi    = elica(nHx)%phi
         LunghezzaElica=elica(nHx)%nResi*1.40
c        fom1=-1.
         fom1=0
         icontfom1=0
         do i=1, natsInModel(WhichModel)-1
           if (i < inizio .or. i > fine) cycle
           fom1=fom1+model(1)%th_fact(i,1)
           icontfom1=icontfom1+1
         enddo
         fom1=fom1/float(icontfom1)
         if(ifcalculate==1) then
         sog    = LunghezzaElica/sqrt(LunghezzaElica**2+RaggioElica**2)
         sog=0.9*sog
!
!--considero le distanze interatomiche tra atomi appartenenti all'elica
!
         elle  = 0
         enne1 = 0
         do i=1, natsInModel(WhichModel)-1
            if (i < inizio .or. i > fine) cycle
            k = model(1)%specie(i,1) / nzConst
            if (k == idrogeno) cycle
!--considero la simmetria
            xs1(:)=model(1)%ortho(:,i,1)
            call MoltMatVec(rmi, xs1, xsio)
            do ki=1,nsymTot
              call oper(ki,xs1,xsio(1),xsio(2),xsio(3))
              call MoltMatVec(rm, xs1, xsi2)
!
              do j=i+1, natsInModel(WhichModel)
                if (j < inizio .or. j > fine) cycle
                k = model(1)%specie(j,1) / nzConst
                if (k == idrogeno) cycle
!--considero la simmetria
                xs1(:)=model(1)%ortho(:,j,1)
                call MoltMatVec(rmi, xs1, xsjo)
                do kj=1,nsymTot
                  call oper(kj,xs1,xsjo(1),xsjo(2),xsjo(3))
                  call MoltMatVec(rm, xs1, xsj2)
!
                  do k=1, 3
                    distxyz(k) = xsi2(k)-xsj2(k) 
                  enddo
                  arg = distxyz(1)**2 + distxyz(2)**2 + distxyz(3)**2
                  dist = sqrt(arg)
                  elle = elle + 1
                  ies=0
                  if (dist > tolmin .and. dist < tolmax) ies=1
                  if (dist > 2*tolmin .and. dist < 2*tolmax) ies=1
                  if (dist > 3*tolmin .and. dist < 3*tolmax) ies=1
                  if(ies==0) cycle
!
                  call PolToCar(theta,phi,u(1),u(2),u(3))
                  Aij = 0.0
                  do k=1, 3
                     Aij = Aij + distxyz(k) * u(k)
                  enddo
                  Aij = Aij / dist
                  if (abs(Aij) > sog) then
                      enne1 = enne1 + 1
                  endif
                enddo
              enddo
            enddo
         enddo
         fomNum = enne1 / elle
         enne1rem=enne1
c        write(6,*) 'dentro elica',nHx,enne1,elle
!
!--considero le altre distanze interatomiche 
!
         elle  = 0
         enne1 = 0
         do i=1, natsInModel(WhichModel)-1
            ies1=0
            if (i >= inizio .and. i <= fine) ies1=1
            k = model(1)%specie(i,1) / nzConst
            if (k == idrogeno) cycle
!--considero la simmetria
            xs1(:)=model(1)%ortho(:,i,1)
            call MoltMatVec(rmi, xs1, xsio)
            do ki=1,nsymTot
              call oper(ki,xs1,xsio(1),xsio(2),xsio(3))
              call MoltMatVec(rm, xs1, xsi2)

              do j=i+1, natsInModel(WhichModel)
               ies2=0
               if (j >= inizio .and. j <= fine) ies2=1
               k = model(1)%specie(j,1) / nzConst
               if (k == idrogeno) cycle
               if((ies1+ies2)==2) cycle
!--considero la simmetria
                xs1(:)=model(1)%ortho(:,j,1)
                call MoltMatVec(rmi, xs1, xsjo)
                do kj=1,nsymTot
                  call oper(kj,xs1,xsjo(1),xsjo(2),xsjo(3))
                  call MoltMatVec(rm, xs1, xsj2)

                  do k=1, 3
                    distxyz(k) = xsi2(k)-xsj2(k) 
                  enddo
                  arg = distxyz(1)**2 + distxyz(2)**2 + distxyz(3)**2
                  dist = sqrt(arg)
                  elle = elle + 1
                  ies=0
                  if (dist > tolmin .and. dist < tolmax) ies=1
                  if (dist > 2*tolmin .and. dist < 2*tolmax) ies=1
                  if (dist > 3*tolmin .and. dist < 3*tolmax) ies=1
                  if(ies==0) cycle
!
                  call PolToCar(theta,phi,u(1),u(2),u(3))
                  Aij = 0.0
                  do k=1, 3
                     Aij = Aij + distxyz(k) * u(k)
                  enddo
                  Aij = Aij / dist
                  if (abs(Aij) > sog) then
                      enne1 = enne1 + 1
                  endif
                enddo
              enddo
            enddo
         enddo
         fomDen = enne1 / elle
         fom = fomNum / fomDen
         fom1 = enne1rem / enne1
c        write(6,*) 'fuori elica',nHx,enne1,elle
         endif ! ifcalculate
!
         sog=funErrHelix(elica(nHx)%nResi)
         elica(nHx)%fom = fom1
         write(lo,200) nHx, elica(nHx)%nresFirst, elica(nHx)%nresLast, 
     &                 elica(nHx)%nResi, theta, phi, fom1, sog
      enddo
!
      return
  200 format(i7,8x,i5,5x,i5,6x,i5,3x,2f8.2,e10.3,f8.2)
      end
!-----------------------------------------------------------------------
      subroutine LanciaJavPatt(string)
      USE General
      USE Riflessi
      USE Eliche
!
      implicit none
      integer    :: Lung, L, kk, ier, GiaFatta, ifDifference
      character (len=*) :: string
!
      if (ifDrawPatt == 0) return
!
!-- XYZ
!
      kk = Lung(StructureName)
      cardDiret = StructureName(1:kk) // '_tmp.xyz'
      GiaFatta = 1
      ifDifference = 0
      call WriteMapXYZ(GiaFatta, ifDifference)
      card(2) = cardDiret(1:Lung(cardDiret)) // char(0)

!
!-- Start Jav
!
      write(card(1),20) char(34),string(1:Lung(string)),char(34)
*gl*  card(1) = '-a -w' // char(0)
      write(*,10) cardDiret(1:Lung(cardDiret)),card(1)
      call startJav(card, 2)
**    Jav direttiva
!
      return
   10 format(/,'Viewer started on: ',a,' with the following options:',
     *       /,'                   ',a,//)
   20 format('-a -w -t=',a,'Jav: ',a,a)
      end
!-----------------------------------------------------------------------
      subroutine LanciaJavPolar(string)
      USE General
      USE Riflessi
      USE Eliche
!
      implicit none
      integer    :: Lung, L, kk, ier, ir, it, ip
      integer    :: itype, iform, jop, jopen, ier2
      character (len=*) :: string
!
      if (ifDrawPolar == 0) return
!
!-- XYZ
!
      kk = Lung(StructureName)
      cardDiret = StructureName(1:kk) // '_tmp_polar.xyz'
!
      itype = 0
      iform = 1
      jop = jopen(jrel,cardDiret,itype,iform,ier2)
!
      do ip = nzMin, nzMax             ! valori min e max di phi
         do it = nyMin, nyMax          ! valori min e max di theta
            do ir = nxMin, nxMax       ! valori min e max di R
               write(jrel,'(3i6,g15.6)') ir-nxMin, it-nyMin, ip-nzMin,
     *                                   Patt_polar(ir, it, ip)
            enddo
         enddo
      enddo
      close (jrel)
!
      card(2) = cardDiret(1:Lung(cardDiret)) // char(0)

!
!-- Start Jav
!
      write(card(1),20) char(34),string(1:Lung(string)),char(34)
*gl*  card(1) = '-a -w' // char(0)
      write(*,10) cardDiret(1:Lung(cardDiret)),card(1)
      call startJav(card, 2)
**    Jav direttiva
!
      return
   10 format(/,'Viewer started on: ',a,' with the following options:',
     *       /,'                   ',a,//)
   20 format('-a -w -t=',a,'Jav: ',a,a)
      end
!-----------------------------------------------------------------------
      subroutine LanciaJavFreq(string)
      USE General
      USE Riflessi
      USE Eliche
!
      implicit none
      integer    :: Lung, L, kk, ier, ir, it, ip
      integer    :: itype, iform, jop, jopen, ier2
      character (len=*) :: string
!
      if (ifDrawFreq == 0) return
!
!-- XYZ
!
      kk = Lung(StructureName)
      cardDiret = StructureName(1:kk) // '_tmp_freq.xyz'
!
      itype = 0
      iform = 1
      jop = jopen(jrel,cardDiret,itype,iform,ier2)
!
      do ip = nzMin, nzMax             ! valori min e max di phi
         do it = nyMin, nyMax          ! valori min e max di theta
            do ir = nxMin, nxMax       ! valori min e max di R
               write(jrel,'(3i6,g15.5)') ir-nxMin, it-nyMin, ip-nzMin,
     *                                   Frequenze(ir, it, ip)
            enddo
         enddo
      enddo
      close (jrel)
!
      card(2) = cardDiret(1:Lung(cardDiret)) // char(0)

!
!-- Start Jav
!
      write(card(1),20) char(34),string(1:Lung(string)),char(34)
*gl*  card(1) = '-a -w' // char(0)
      write(*,10) cardDiret(1:Lung(cardDiret)),card(1)
      call startJav(card, 2)
**    Jav direttiva
!
      return
   10 format(/,'Viewer started on: ',a,' with the following options:',
     *       /,'                   ',a,//)
   20 format('-a -w -t=',a,'Jav: ',a,a)
      end
!-----------------------------------------------------------------------
      subroutine dirhel(ier)
      USE General
      USE Eliche
      USE Direttive
!
!-- read directives for this modul
!
      character fileh*256
      integer ipdirSav
!
      filePDB = ' '
      ic = 0
      icmax = icomq(icomat,2)
      ipdirSav=ipdir ! serve per il riciclo
!
      do while (ic < icmax .and. ier == 0)
         ic = ic + 1
         ipdir=ipdir+1
         cardDiret=card(ipdir)
         cardImage=cardDiret
         ldiret = Lung(cardImage)
         call cutst(cardDiret,lenp,direttiva,lend)
         call lcase(direttiva)
c-- directives with alphanumeric parameters
         if (direttiva(1:4).eq.'spac') then
         elseif (direttiva(1:4).eq.'patt') then
!
!-- check for blanks in the reflection file name
!
             call CheckBlanks(fileh, lend)
!
             if (lend > 0) then
                 FichierIn = fileh(1:lend)
                 ifGetPatt = 1
             else
                 ier = -10
             endif
         elseif (direttiva(1:3).eq.'use') then
             call cutst(cardDiret,lenp,direttiva,lend)
             if (lend == 1) then
                call lcase(direttiva)
                if (direttiva(1:1) == 'e') then
                    EorF = 1
                elseif (direttiva(1:1) == 'f') then
                    EorF = 2
                else
                    ier = -10
                endif
             else
                ier = -10
             endif
         elseif (direttiva(1:4).eq.'test') then
             call cutst(cardDiret,lenp,direttiva,lend)
             if (lend == 1) then
                call lcase(direttiva)
                if (direttiva(1:1) == 'x') then
                    ifTestE = 1
                elseif (direttiva(1:1) == 'y') then
                    ifTestE = 2
                elseif (direttiva(1:1) == 'z') then
                    ifTestE = 3
                else
                    ier = -10
                endif
             else
                ier = -10
             endif
         elseif (direttiva(1:4).eq.'draw') then
             call cutst(cardDiret,lenp,direttiva,lend)
             if (lend >= 1) then
                call lcase(direttiva)
                if (direttiva(1:4) == 'patt') then
                    ifDrawPatt = 1
                elseif (direttiva(1:4) == 'pola') then
                    ifDrawPolar = 1
                elseif (direttiva(1:4) == 'freq') then
                    ifDrawFreq = 1
                else
                    ier = -10
                endif
             else
                ier = -10
             endif
         elseif (direttiva(1:3).eq.'pdb') then
             cardImage = cardDiret
             call cutst(cardDiret,lenp,direttiva,lend)
             if (lend > 0) then
                 filePDB = cardImage
             else
                ier = -10
             endif
         else
c-- directives with numeric parameters
             iopt=0
             call getnum(cardDiret,vet,ivet,iv,iopt)
             if (iopt.ne.-1) then
                 if (direttiva(1:4).eq.'weig') then
                     if (iv.eq.1) then
                         WeightSuppl = vet(1)
                         ifWeight = 1
                     else
                         ier = -10
                     endif
                 elseif (direttiva(1:4).eq.'resi') then
                     if (iv > 0) then
                         nEliche = iv
                         if(iv>100) iv=100
                         ResiduiEliche(1:iv) = ivet(1:iv)
                     else
                         ier = -10
                     endif
                 elseif (direttiva(1:4).eq.'coor') then
                     if (iv > 0) then
                         idCoor = ivet(1)
                     else
                         ier = -10
                     endif
                 endif
             else
                 ier = -20
             endif
         endif
      enddo
!
      if (ier == -10) then
          write(Msg,6100) cardImage(1:ldiret)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
!
      if (ier == -20) then
          write(Msg,6200) cardImage(1:ldiret)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
!
      ipdir=ipdirSav ! occhio, non puo' continuare il .sir
!
      return
 6100 format(' Error in directive : ',a)
 6200 format(' Wrong directive in HELIX modulus:   ',a)
      end
!---------------------------------------------------------------------
      subroutine MakePatt(iAction)
      USE General
      USE Riflessi
      USE Eliche
      USE Mappa
!
      implicit none
      integer ::  ix, iy, iz, shi(3)
      integer :: iAction, ixx, iyy, izz, jpatt, i
      real :: res,resmOld
!
      resmOld=resm
      resm=resElica
      ifRemo=1
!
      call CheckGrid()
      call AllocaMappa(1)
!
      if(iAction==1)then
         if (EorF == 1) then
             fcoef(:) = evet(:) * evet(:)
         else
             fcoef(:) = fovet(:) * fovet(:)
         endif
      else
         fcoef(:) = fcvet(:)*fcvet(:)   
      endif  
!
!--introduco il taglio in risoluzione
!
      do i=1,nrefl
        res=0.5 / sqrt(rhov(i))
        if(res<resElica ) fcoef(i)=0.0
      enddo
c      write(6,'(a,f5.2)') 'Resolution used for calculations:',resElica
!
      call Switch_to_Patterson_Group
      jpatt = 1
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH, BACK)
      call Switch_from_Patterson_Group
!    
      if (ifTestE == 1) then
          xmap(:,:,:) =  0.0
          xmap(:,0,0) =  1.0
      elseif (ifTestE == 2) then
          xmap(:,:,:) =  0.0
          xmap(0,:,0) =  1.0
      elseif (ifTestE == 3) then
          xmap(:,:,:) =  0.0
          xmap(0,0,:) =  1.0
      endif
!
      resm=resmOld
!
      return
      end
!---------------------------------------------------------------------
      subroutine ReadPatt(ier)
      USE General
      USE Mappa
!
      implicit none
      integer :: i, ier, nExitCode
      integer :: Lung, itype, iform, jop, jopen, ier2, ix(3), n
      real    :: pat
!
      itype = 2
      iform = 1
      jop = jopen(jrel, FichierIn, itype, iform, ier2)
      if (jop < 0) then
          write(Msg,100) FichierIn(1:Lung(FichierIn))
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
      endif
!
      rewind jrel
      np(:) = -9999
      n = 0
      do
         read(jrel,*,end=10) ix(1:3), pat
         n = n + 1
         do i=1, 3
            if (ix(i) > np(i)) then
                np(i) = ix(i)
            endif
         enddo
      enddo
!
   10 rewind jrel
      np(:) = np(:) + 1
      call AllocaMappa(1)
!
      xmap(:,:,:) = 0.0
      do i=1, n
         read(jrel,*,end=10) ix(1:3), pat
         xmap(ix(1), ix(2), ix(3)) = pat
      enddo
      close(jrel)
!
      return
  100 format('File not found: ',a)
      end
!---------------------------------------------------------------------
      subroutine MakeMat(iAction,ier)
      USE General
      USE Eliche
!
      implicit none
      integer :: iAction, ier
!
      call Fill_Patt_Polar
    
      if(iAction==1)then
c        call Transform_Patt_Polar
         call Transform_Patt_Polar_class
         call CercaDirezioniEliche
         call LanciaJavFreq('Frequenze')
      endif
!
      return
      end
!---------------------------------------------------------------------
      subroutine AllocaMappeElica(iAction)
      USE General
      USE Eliche
!
      implicit none
      integer :: ierv(100)
      integer :: i, iAction
!
      ierv(:) = 0
!
      if (iAction == 1) then
          nxMin = nint(R_min / dr)
          nxMax = nint(R_max / dr)
          if(idCoor>5) then
            nyMin = nint(-1.0 / dtheta)
            nyMax = nint(+1.0 / dtheta)
          else
            nyMin = 0
            nyMax = nint(180.0 / dtheta)
          endif
          nzMin = nint(-90.0 / dphi)
          nzMax = nint( 90.0 / dphi)
          vetMax = (nxMax - nxMin + 1) !N è pari
          vetMaxC= vetMax !(vetMax+1)/2. 
          if (.not. allocated(Patt_polar)) then
            allocate (Patt_polar(nxMin:nxMax, nyMin:nyMax, nzMin:nzMax),
     *                                      stat = ierv(1))
            allocate (Frequenze(0:padding*vetMaxC-1, nyMin:nyMax, 
     *           nzMin:nzMax),stat = ierv(2))
            allocate (vettoreInp(0:padding*vetMax-1),   stat = ierv(3))
            allocate (vettoreOut(0:padding*vetMaxC-1),   stat = ierv(4))
            allocate (vettoreOutM2(0:padding*vetMax-1), stat = ierv(5))
            allocate (vettoreOutPh(0:padding*vetMax-1), stat = ierv(6))
            allocate (Patt_polar_sav(nxMin:nxMax,nyMin:nyMax,
     *                          nzMin:nzMax),stat = ierv(7))
            allocate (patt_mod(nxMin:nxMax, nyMin:nyMax, nzMin:nzMax),
     *                                      stat = ierv(8))
            allocate (patt_pro(nxMin:nxMax, nyMin:nyMax, nzMin:nzMax),
     *                                      stat = ierv(9))

            do i=1, 100
             if (ierv(i) /= 0) then
                 write(6,*) 'AllocaMappeElica Allocation Error'
                 write(6,*) 'on map #',i,' error =',ierv(i)
                 call cstop(' Allocation error')
             endif
            enddo
          endif
      else
          deallocate(Patt_polar,   stat = ierv(1))
          deallocate(Frequenze,    stat = ierv(2))
          deallocate(vettoreInp,   stat = ierv(3))
          deallocate(vettoreOut,   stat = ierv(4))
          deallocate(vettoreOutM2, stat = ierv(5))
          deallocate(vettoreOutPh, stat = ierv(6))
          deallocate(Patt_polar_sav, stat = ierv(7))
          deallocate(patt_mod, stat = ierv(8))
          deallocate(patt_pro, stat = ierv(9))
          do i=1, 100
             if (ierv(i) /= 0) then
                 write(6,*) 'AllocaMappeElica Deallocation Error'
                 write(6,*) 'on map #',i,' error =',ierv(i)
                 call cstop(' Deallocation error')
             endif
          enddo
      endif
!
      return
      end
!---------------------------------------------------------------------
      subroutine Fill_Patt_Polar
      USE General
      USE Eliche
      USE Mappa, only : np, xmap
!
      implicit none
      integer :: ir, it, ip, jR, jT, jP, nMega
      real    :: valR, valT, valP, xxv, yyv, zzv, valPatt
      real    :: R, T, P, valTr, valPr
      integer :: ix,iy,iz
!
!-faccio un taglio ellittico nella Patterson, utilizzando lo stesso
! raggio massimo che usero' per la Patterson Polare
!
c       do iz = 0, np(3)-1
c         do iy = 0, np(2)-1          ! valori min e max di theta
c           do ix = 0, np(1)-1 
c              write(96,*) ix,iy,iz, xmap(ix, iy, iz) 
c           enddo
c         enddo
c       enddo 
!
      Patt_polar(:,:,:) = 0.0
      
      do ip = nzMin, nzMax             ! valori min e max di phi 
         do it = nyMin, nyMax          ! valori min e max di theta 
            do ir = nxMin, nxMax       ! valori min e max di R     
               valR = float(ir) * dr
               valT = float(it) * dtheta
               valP = float(ip) * dphi
c              if(abs(valT)<0.01.and.valP<-89.) then
c                 write(6,*) 'uffa'
c              endif
               call PolToCar(valT,valP,xxv,yyv,zzv)
               xxv = valR * xxv
               yyv = valR * yyv
               zzv = valR * zzv
               call FindClosest(xxv, yyv, zzv, valPatt)
               Patt_polar(ir, it, ip) = valPatt
            enddo
         enddo
      enddo
!
c     write(6,*) 'Patt_polar'
c     do ir = nxMin, nxMax 
c        write(6,*) ir, Patt_polar(ir, 0, 30)
c     enddo
!
      call LanciaJavPolar('Polar')
!
      return
      end
!---------------------------------------------------------------------
      subroutine FindClosest(x, y, z, valPatt)
      USE General
      USE Eliche
      USE Mappa
      USE Molcom, only : rmi
!
      implicit none
 
      integer :: i, ix, iy, iz, jx, jy, jz, j, iesci
      integer :: iix, iiy, iiz, ix1,iy1,iz1
      real    :: x, y, z, valPatt, b(19), b1, b2
      real    :: ttt, dxmax, xs(3), xsF(3), side
      integer :: ishift, sidepp, interp
      common /misc/ ttt(3,3), dxmax(3),ishift(3,19)
!
c     interp=0  ! interpolazione nearest
      interp=1  ! interpolazione lineare
!
      xs(1) = x
      xs(2) = y
      xs(3) = z
c
      call MoltMatVec(rmi, xs, xsF)
c
      ix1=nint(xsF(1)*np(1))
      iy1=nint(xsF(2)*np(2))
      iz1=nint(xsF(3)*np(3))
c
      if (ifTestE /= 0.or.interp==0) then
!
!--interpolazione di tipo "nearest"
!
        ix=sidepp(ix1,np(1))
        iy=sidepp(iy1,np(2))
        iz=sidepp(iz1,np(3))
        iesci=0
        do j=1,3
          if(abs(xsF(j))>0.5) then
            iesci=1
            exit 
         endif 
        enddo
        if(iesci==1) then
          b(10)=0
        else
          b(10) = xmap(ix, iy, iz)  
        endif
        valPatt = b(10)
      else
!
!--interpolazione lineare
!
        do i=1, 19
          iix=ix1+ishift(1,i)
          iiy=iy1+ishift(2,i)
          iiz=iz1+ishift(3,i)
          jx = sidepp(iix, np(1))
          jy = sidepp(iiy, np(2))
          jz = sidepp(iiz, np(3))
          if(abs(iix)>0.5*np(1).or.
     &       abs(iiy)>0.5*np(2).or.
     &       abs(iiz)>0.5*np(3) ) then
            b(i)=0
          else
            b(i) = xmap(jx, jy, jz)
          endif
        enddo
        b1 = b(3) + b(7) + b(9) + b(11) + b(13) + b(17)
        b2 = b(1) + b(2) + b(4) + b(5) + b(6) + b(8) +
     &     b(12) + b(14) +  b(15) + b(16) + b(18) + b(19)
        valPatt = (9.0 * b(10) + 4.0 * b1 - b2) / 21.0
      endif
!
      return
      end
!---------------------------------------------------------------------
      subroutine Transform_Patt_Polar_class
      USE General
      USE Eliche
      USE Mappa

      implicit none
      integer i, k, iarg, ir, it, ip , kverbose
      real x1, act, bct, arg, contc, conts, fo, fc, faze
!
      kverbose=0
c     kverbose=1
!
!--stampo la Patt
!
      if(kverbose==1) then
        do ip = nzMin, nzMax
          do it = nyMin, nyMax          
            do ir = nxMin, nxMax 
               write(97,*) ir,it,ip, Patt_Polar(ir, it, ip) 
               if(ip==0.and.it==0) then
c              if(ip==nint(0.5*(nzMax-nzMin)).and.it==0) then
                 write(57,*)ir, Patt_Polar(ir, it, ip) 
               endif
            enddo
          enddo
        enddo 
      endif

      vettoreInp(:) = 0.0
      vettoreOutM2(:)=0.0
c     if(kverbose==1) then
c       write(6,*) 'punti griglia',nxMin,nxMax,vetMax,vetMaxC
c     endif
!
      do ip = nzMin, nzMax
        do it = nyMin, nyMax          
          k = 0
          do ir = nxMin, nxMax       
            vettoreInp(k) = Patt_Polar(ir, it, ip)
            k = k + 1
          enddo
c--prova con la sinusoide
c         do ir = 0, vetMax-1 
c           arg=ir*TwoPi/vetMax
c           vettoreInp(ir) = sin(arg)
c         enddo
! il termine a i=0 e' DC
          do i=1,padding*vetMaxC-1
             act=0.0
             bct=0.0
             do k=0,padding*vetMax-1
               fo= vettoreInp(k)
               arg= -i*k/(padding*float(vetMax))
               arg = twopi * arg
               contc=fo*cos(arg)
               conts=fo*sin(arg)
               act=act+contc
               bct=bct+conts
             enddo
             arg=act*act+bct*bct
             if (arg.gt.0.000001) then
c              fc=arg
               fc=arg*0.00001
c              faze=rtod*atan2(bct,act)+360.0
             else
               fc=0.0
c              faze=0.0
             endif
             vettoreOutM2(i)=fc
          enddo
          Frequenze(:, it, ip) = vettoreOutM2(:)
        enddo
      enddo
!
!--stampo la |G|**2
!
      if(kverbose==1) then
        do ip = nzMin, nzMax
          do it = nyMin, nyMax          ! valori min e max di phi
            do ir = 0, padding*vetMaxC-1
               write(98,*)ir,it,ip, Frequenze(ir, it, ip) 
               if(ip==0.and.it==0) then
                 write(58,*)ir, Frequenze(ir, it, ip) 
               endif
c              if(ip==30.and.it==0) then
c                 write(6,*)ir, Frequenze(ir, it, ip) 
c              endif
            enddo
          enddo
        enddo 
      endif
      if(kverbose==1) stop
!
! Nel caso di zero Padding:
!--nel seguito considero Frequenze da 0 a vetMaxC, in modo
!  da ignorare le frequenze negative.
! se non metto lo zero Padding, mi porto dietro le frequenze negative!
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Transform_Patt_Polar
      USE General
      USE Eliche
      USE Mappa, only : FFTW_ESTIMATE, FFTW_R2HC
!
      implicit none
      integer   :: ir, it, ip, k, iarg
      real      :: sf, phaseof
!
!-- Make plan
!
      call dfftw_plan_dft_r2c_1d(FORTHe, vetMax, vettoreInp,
     *                           vettoreOut, FFTW_ESTIMATE)
!
      vettoreInp(:) = 0.0
      vettoreOut(:) = cmplx(0.0,0.0)
      write(6,*) 'Frequenze'

!
      do ip = nzMin, nzMax
         do it = nyMin, nyMax          ! valori min e max di phi
            k = 0
            do ir = nxMin, nxMax       ! valori min e max di R
               vettoreInp(k) = Patt_Polar(ir, it, ip)
               k = k + 1
            enddo
!!gpu       call sfftw_execute(FORTHe)
            call sfftw_executer2c_1d(vetMax,FORTHe,vettoreInp,
     *                 vettoreOut)
            do k = 0, vetMaxC-1
               sf = vettoreOut(k) * conjg(vettoreOut(k))
               vettoreOutM2(k) = sf
               vettoreOutPh(k) = phaseof(vettoreOut(k))
            enddo
            Frequenze(:, it, ip) = vettoreOutM2(:)
         enddo
      enddo
      call sfftw_destroy_plan(FORTHe)
!
!--stampo la |G|**2
!
      do ip = nzMin, nzMax
        do it = nyMin, nyMax          ! valori min e max di phi
            do ir = 0, vetMaxC-1
               write(98,*)ir,ip,it, Frequenze(ir, it, ip) 
            enddo
        enddo
      enddo 
!
      return
      end
!---------------------------------------------------------------------
      subroutine CercaDirezioniEliche
      USE General
      USE Eliche
      USE Atomi
      USE Mappa, only : FFTW_ESTIMATE, FFTW_R2HC
!
      real      :: avden, stden, IntensityMin
      integer   :: npunt, tolm, tolp, pos,nsolgood,nposmax
      real      :: amin0,amax0,diff0
      real      :: amin1,amax1,diff1
      real      :: amin2,amax2,diff2
      real      :: amin3,amax3,diff3
      
      imetodo=0  ! metodo nuovo
c     imetodo=1  ! metodo di Domenica
!
!--seleziono la sezione di Frequenze corrispondente
!  alla periodicita' delle alfa-eliche
!
      drElica=5.4
!---sono equivalenti
c     kElica=padding*nint(vetMaxC*dr/drElica)-1
      kElica=padding*nint((R_max-R_min)/drElica)-1
!------------------
      write(6,*) 'Helix frequency value: ',kElica
!
!--calcolo la soglia per il taglio in intensita'
!-- e faccio il taglio in frequenza
!
      avden=0.0
      stden=0.0
      npunt=0
      if(imetodo==0) then
!--metodo nuovo
c--valori di default
c       tolp=1
c       tolm=2
c
        if(kElica<10) then
          tolp=1
          tolm=1 ! occhioooo out25
c         tolm=2 ! occhioooo out26
        else
          tolp=1
          tolm=2 
        endif
        do ip = nzMin, nzMax
          do it = nyMin, nyMax          ! valori min e max di phi
            do ir = 1, vetMaxC-1
               if(ir<kElica-tolm.or.ir>kElica+tolp) then
                  Frequenze(ir, it, ip) = 0.0
               else
                 xx=Frequenze(ir,it,ip)
                 if(xx>0) then
                   avden=avden + xx
                   stden=stden + xx * xx
                   npunt=npunt+1
                 endif
               endif
            enddo
          enddo
        enddo 
      elseif(imetodo==1) then
!--metodo di Domenica
        pos=kElica
        amax0=maxval(Frequenze(pos,:,:))
        amin0=minval(Frequenze(pos,:,:))
        diff0=amax0-amin0
        amax1=maxval(Frequenze(pos-1,:,:))
        amin1=minval(Frequenze(pos-1,:,:))
        diff1=amax1-amin1
        amax2=maxval(Frequenze(pos+1,:,:))
        amin2=minval(Frequenze(pos+1,:,:))
        diff2=amax2-amin2
        amax3=maxval(Frequenze(pos-2,:,:))
        amin3=minval(Frequenze(pos-2,:,:))
        diff3=amax3-amin3
        do ip = nzMin, nzMax
          do it = nyMin, nyMax          ! valori min e max di phi
            xx=Frequenze(pos,it,ip)
            Frequenze(pos,it,ip)=(xx-amin0)/diff0
            xx=Frequenze(pos-1,it,ip)
            Frequenze(pos,it,ip)=Frequenze(pos,it,ip)+(xx-amin1)/diff1
            xx=Frequenze(pos+1,it,ip)
            Frequenze(pos,it,ip)=Frequenze(pos,it,ip)+(xx-amin2)/diff2
            xx=Frequenze(pos-2,it,ip)
            Frequenze(pos,it,ip)=Frequenze(pos,it,ip)+(xx-amin3)/diff3
            xx=Frequenze(pos,it,ip)
            if(xx>0) then
              avden=avden + xx
              stden=stden + xx * xx
              npunt=npunt+1
            endif
            do ir = 1, vetMaxC-1
               if(ir<kElica.or.ir>kElica) then
                  Frequenze(ir, it, ip) = 0.0
               endif
            enddo
          enddo
        enddo 
      endif
!
      avden=avden/float(npunt)
      stden=stden/float(npunt) - avden*avden
      if (stden.gt.0.0) then
          stden=sqrt(stden)
      else
          stden=0.0
      endif
c     IntensityMin=avden+2*stden
      IntensityMin=avden+1*stden
      write(6,'(3(a,g15.2))') 'Intensity cut=',IntensityMin,
     &                  ' mean=',avden,' sigma= ',stden
!--deb
c     do ip = nzMin, nzMax
c       do it = nyMin, nyMax          ! valori min e max di phi
c              write(99,*)kElica,ip,it, Frequenze(kElica, it, ip) 
c       enddo
c     enddo 
!--
!
!--cerco i picchi nelle sezioni selezionate
!
c     call AllocaAtomi(1)
      call pksrc_helix(ier,IntensityMin)
      if(nats<=0) then
        write(6,*) 'ERROR: no candidate helix direction found'
        return
      endif
!
      write(6,'(/,a)') 'List before clustering'
      if(idCoor<10) then
         write(6,*) '   N    Section      z        phi  Height'
      else
         write(6,*) '   N    Section      t        phi  Height'
      endif
      do i=1,nats
        write(6,'(i5,3f10.2,2x,g10.3)') i,xyzs(1:4,i)
      enddo
!
      if(nvolta==1) then
        if(numbEliche>0) then
          elica(:)%esito=1.0      ! azzera l'esito 
          elica(:)%pos=9999       ! azzera l'esito 
          if(nats>0) then
              call ControllaDirezioniEliche(nfoundTrue,
     &                    nsolgood,nposmax)
            else
              nfoundTrue=0
          endif
          eff1a=100*nfoundTrue/float(numbEliche)
          eff1b=100*nsolgood/float(nats)
!          eff1c=100*nposmax/float(nats)
          eff1c=nats
        endif
      endif
!
!--clusterizzo le direzioni ottenute
!
c     if(nats>2) then
c       call ClusterHelix()
c       write(6,'(/,a)') 'List after clustering'
c       do i=1,nats
c         write(6,'(i5,3f10.2,2x,g8.3)') i,xyzs(1:4,i)
c       enddo
c     endif
c
c     if(numbEliche>0) then
c        elica(:)%esito=1.0      ! azzera l'esito 
c        elica(:)%pos=9999       ! azzera l'esito 
c        if(nats>0) then
c             call ControllaDirezioniEliche(nfoundTrue,
c    &                    nsolgood,nposmax)
c           else
c             nfoundTrue=0
c        endif
c        eff2a=100*nfoundTrue/float(numbEliche)
c        eff2b=100*nsolgood/float(nats)
c        eff2c=100*nposmax/float(nats)
c     endif
!      
      return
      end
!---------------------------------------------------------------------
      subroutine OrientaElica(theta1,phi1,chi1)
      USE General
      USE Molcom
      USE Eliche
      USE Groups

      dimension b(3,3),x1(3),x2(3)

      if(chi1/=0)then
!se chi!=0 effettua una rotazione di chi intorno all'asse dell'elica
         call RotationOperPolar2(b,theta1,phi1,chi1)
      else
!se chi=0 ruota il sistema di coordinate
        if(idCoor==1.or.idCoor==10) then
           call RotationOperPolar1a(b,theta1,phi1,chi1)
        elseif(idCoor==2.or.idCoor==20) then
           call RotationOperPolar1b(b,theta1,phi1,chi1)
        elseif(idCoor==3.or.idCoor==30) then
           call RotationOperPolar1c(b,theta1,phi1,chi1)
        endif
      endif
      do i=1, natsTipo
         x1(1:3)= ElicaTipo(1)%ortho(1:3,i,1)
         call MoltMatVec(b, x1, x2)
         ElicaTipo(1)%ortho(1:3,i,1)=x2(1:3)
         call MoltMatVec(rmi, x2, x1)
         ElicaTipo(1)%atoms(1:3,i,1)=x1(1:3)
      enddo
c     call calc_FSE(nrefl) 
      call calc_FSE_roc(nrefl)
c
      return
      end

!---------------------------------------------------------------------
*     subroutine dfftw_plan_dft_r2c_1d(plan, n, inp, out, flag)
*     integer*8 plan
*     integer n, flag 
*     real inp(n), out(n)
*     return
*     end
*     subroutine dfftw_execute_dft_r2c(plan, inp, out, n)
*     integer*8 plan
*     integer n
*     real inp(n), out(n)
*     return
*     end
*     subroutine dfftw_destroy_plan(plan)
*     integer*8 plan
*     return
*     end
!---------------------------------------------------------------------
*      subroutine MakeLine(FORTHe, vettoreInp, vettoreOut, vetMax)
*      USE General
*      USE Mappa, only : FFTW_ESTIMATE, FFTW_R2HC
*!
*      implicit none
*      integer    :: vetMax
*      integer*8  :: FORTHe
*      real       :: vettoreInp(vetMax)
*      real       :: vettoreOut(vetMax)
*!
*!-- Make plan
*!
*      if (FORTHe == 0) then
**         call sfftw_plan_r2r_1d(FORTHe, vetMax, vettoreInp, vettoreOut,
*    *                           FFTW_R2HC, FFTW_ESTIMATE)
*          call dfftw_plan_dft_r2c_1d(FORTHe, vetMax, 
*     *               vettoreInp, vettoreOut, FFTW_ESTIMATE)
*      endif
*!
*      call dfftw_execute_dft_r2c(FORTHe, vettoreInp, vettoreOut)
*!
*      return
*      end
!---------------------------------------------------------------------
      subroutine pksrc_helix(ier,IntensityMin)
c
c-- find positions of peaks by fitting quadratic function to 19 points
c   da usare solo per la ricerca di direzioni di alfa eliche
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Eliche
!
      common /misc/ ttt(3,3), dxmax(3),ishift(3,19)
      real xs(3)
      real b(19)
      integer sidepp,sideph,inRegionHelix
      integer nptheta, npphi
      integer it,ip,ir
      real IntensityMin
c
      nats=999
      nats = min0(MaxAtoms-20, nats)
      npic = nint(nats * 1.3)
      npic = min0(MaxAtoms-20, npic)
!
!--initialise constants
      limit = min0(MaxAtoms, npic)
c     alevel = 0.1
      alevel = IntensityMin
      NumPeaks = 0
      npphi=nint(90./dphi)
      if(idCoor>5) then
        nptheta=nint(1.0/dtheta)
      else
        nptheta=nint(180./dtheta)
      endif
!
!--initialise variables
      do ip = nzMin, nzMax
        do it = nyMin, nyMax          ! valori min e max di theta
          do_ir:  do ir = 1, vetMaxC-1
            b(10)= Frequenze(ir, it, ip)
            if (b(10) < alevel) cycle
!--locate grid point with maximum density
            do i=1,19
              if(i==10) cycle
              jr = ir+ishift(1,i)
              if(idCoor>5) then
                jt = sideph(it+ishift(2,i),nptheta)  
              else
                jt = sidepp(it+ishift(2,i),nptheta)  
              endif
              jp = sideph(ip+ishift(3,i),npphi)
              b(i)=Frequenze(jr,jt,jp)
              if (b(10) <  b(i)) then
                  cycle do_ir
              elseif (b(10) == b(i)) then
!--scarto il picco solo se ho gia' preso uno vicino 
                do j=1,NumPeaks
                   if(jr==nint(xyzs(1,j)).and.
     &                jt==nint(xyzs(2,j)/dtheta).and.
     &                jp==nint(xyzs(3,j)/dphi) ) then
                      cycle do_ir
                   endif
                enddo
              endif
            enddo
c--check if the peak is inside the asymmetric unit
            xs(1) = float(ir) * 1
            xs(2) = float(it) * dtheta
            xs(3) = float(ip) * dphi
            if(inRegionHelix(xs(2),xs(3))==0) cycle
            NumPeaks = NumPeaks+1
            xyzs(1,NumPeaks) = xs(1)
            xyzs(2,NumPeaks) = xs(2)
            xyzs(3,NumPeaks) = xs(3)
            xyzs(4,NumPeaks) = b(10)
            if (NumPeaks .ge. limit) then
              call sortf(xyzs, 5, NumPeaks, 4)
              NumPeaks = npic
              alevel = xyzs(4,npic) + 0.5
              limit = min0(MaxAtoms, 2*nats)
            endif
          enddo do_ir ! fine loop su ir
        enddo ! fine loop su itheta
      enddo ! fine loop su iphi
c-- sort peaks in order of peak height
      call sortf(xyzs,5, NumPeaks, 4)
      nats = min0(NumPeaks, nats)
      nats = min0(MaxAtoms, nats)
!
!-- check for intensities <= 0
!
      jj = 0
      do i=nats,1,-1
         if (xyzs(4,i) > 0.0) then
             jj = i
             exit
         endif
      enddo
      nats = jj
      if ( nats == 0) then
         ier = -1234
      end if
!
      if (kverbo.gt.0) then
          npic=NumPeaks
          write(lo,22) npic,nats
      endif
 22   format ('N. Helix directions npic =',i8,' nats =',i8)
!
      call DoSingleIteration()
!
      return
      end
!-------------------------------------------------------------
      function inRegionHelix(theta,phi)
      USE General
      USE Symmetry
      USE Eliche
!
      real   :: thetaRange(2)
      real   :: phiRange(2)
      real   :: id1,id2
!
      thetaRange(1:2)=(/  0 , 180 /) 
      phiRange(1:2)  =(/-90 ,  90 /)
      if(idCoor==1.or.idCoor==10) then
!----------------------------------------------------------
        select case (nSpaceGroupPatt)
          case (1)            !  triclino
            thetaRange(1:2)=(/  0 , 180 /) !ok
            phiRange(1:2)  =(/-90 ,  90 /)
          case (2,3)          !  monoclino ( asse unico b )
            thetaRange(1:2)=(/  0 , 180 /) !ok
            phiRange(1:2)  =(/  0 ,  90 /)
          case (4,5,6,7,8,9)  !  ortorombico
            thetaRange(1:2)=(/  0 ,  90 /) !ok
            phiRange(1:2)  =(/  0 ,  90 /)
          case (10,11)        !  tetragonale 4/m
            thetaRange(1:2)=(/  0 ,  90 /)
            phiRange(1:2)  =(/  0 ,  90 /)
          case (12,13)        !  tetragonale 4/mmm
            thetaRange(1:2)=(/  0 ,  90 /) !verificato
            phiRange(1:2)  =(/  0 ,  45 /)
          case (14,15)           !  trigonale  3 (non romboedrico)
c             if (ifRhombAx == 0) then
                thetaRange(1:2)=(/  0 ,  180 /)
                phiRange(1:2)  =(/  0 ,  60 /)
c             endif
          case (16,17,18)        !   trigonale  3m (non romboedrico)
c             if(ifRhombAx == 0) then
                thetaRange(1:2)=(/  0 ,  180 /) !verificato
                phiRange(1:2)  =(/  0 ,  60 /)
c             endif
          case (19)           !  esagonale  6/m
            thetaRange(1:2)=(/  0 ,  90 /) ! verificato
            phiRange(1:2)  =(/  0 ,  60 /)
          case (20)           !  esagonale  6/mmm
            thetaRange(1:2)=(/  0 ,  90 /)
c            phiRange(1:2)  =(/  0 ,  60 /)
            phiRange(1:2)  =(/  -30 ,  60 /)
          case (21,22,23)           !  cubico  m -3
            thetaRange(1:2)=(/  0 ,  90 /) !ok
            phiRange(1:2)  =(/  0 ,  90 /)
          case (24,25,26)           !  cubico  m -3 m
            thetaRange(1:2)=(/  0 ,  90 /) !ok
            phiRange(1:2)  =(/  0 ,  45 /)
        end select
c     elseif(idCoor==2.or.idCoor==20) then
      elseif(idCoor==35) then
!----------------------------------------------------------
        select case (nSpaceGroupPatt)
          case (1)            !  triclino
            thetaRange(1:2)=(/  0 , 180 /) !ok
            phiRange(1:2)  =(/-90 ,  90 /)
          case (2,3)          !  monoclino ( asse unico b )
            thetaRange(1:2)=(/  0 , 180 /) !ok
            phiRange(1:2)  =(/  0 ,  90 /)
          case (4,5,6,7,8,9)  !  ortorombico
            thetaRange(1:2)=(/  0 ,  90 /) !ok
            phiRange(1:2)  =(/  0 ,  90 /)
          case (10,11)        !  tetragonale 4/m
            thetaRange(1:2)=(/  0 ,  180 /)
            phiRange(1:2)  =(/  0 ,  90 /)
          case (12,13)        !  tetragonale 4/mmm
            thetaRange(1:2)=(/  0 ,  90 /) !verificato
            phiRange(1:2)  =(/  0 ,  90 /)
          case (14,15)           !  trigonale  3 (non romboedrico)
c             if (ifRhombAx == 0) then
                thetaRange(1:2)=(/  0 ,  180 /)
                phiRange(1:2)  =(/  0 ,  60 /)
c             endif
          case (16,17,18)        !   trigonale  3m (non romboedrico)
c             if(ifRhombAx == 0) then
                thetaRange(1:2)=(/  0 ,  180 /) !verificato
                phiRange(1:2)  =(/  0 ,  60 /)
c             endif
          case (19)           !  esagonale  6/m
            thetaRange(1:2)=(/  0 ,  90 /) ! verificato
            phiRange(1:2)  =(/  0 ,  60 /)
          case (20)           !  esagonale  6/mmm
            thetaRange(1:2)=(/  0 ,  90 /)
            phiRange(1:2)  =(/  0 ,  60 /)
          case (21,22,23)           !  cubico  m -3
            thetaRange(1:2)=(/  0 ,  90 /) !ok
            phiRange(1:2)  =(/  0 ,  90 /)
          case (24,25,26)           !  cubico  m -3 m
            thetaRange(1:2)=(/  0 ,  90 /) !ok
            phiRange(1:2)  =(/  0 ,  45 /)
        end select
c     elseif(idCoor==3.or.idCoor==30) then ! occhio
      elseif(idCoor==96) then
!----------------------------------------------------------
        select case (nSpaceGroupPatt)
          case (1)            !  triclino
            thetaRange(1:2)=(/  0 , 180 /) !ok
            phiRange(1:2)  =(/-90 ,  90 /)
          case (2,3)          !  monoclino ( asse unico b )
c           thetaRange(1:2)=(/  0 , 180 /) !ok
            thetaRange(1:2)=(/  0 , 90 /) !ok
            phiRange(1:2)  =(/ -90 ,  90 /)
          case (4,5,6,7,8,9)  !  ortorombico
            thetaRange(1:2)=(/  0 ,  90 /) !ok
            phiRange(1:2)  =(/  0 ,  90 /)
          case (10,11)        !  tetragonale 4/m
            thetaRange(1:2)=(/  0 ,  180 /)
            phiRange(1:2)  =(/  0 ,  90 /)
          case (12,13)        !  tetragonale 4/mmm
            thetaRange(1:2)=(/  0 ,  90 /) !verificato
            phiRange(1:2)  =(/  0 ,  90 /)
          case (14,15)           !  trigonale  3 (non romboedrico)
c             if (ifRhombAx == 0) then
                thetaRange(1:2)=(/  0 ,  180 /)
                phiRange(1:2)  =(/  0 ,  60 /)
c             endif
          case (16,17,18)        !   trigonale  3m (non romboedrico)
c             if(ifRhombAx == 0) then
                thetaRange(1:2)=(/  0 ,  180 /) !verificato
                phiRange(1:2)  =(/  0 ,  60 /)
c             endif
          case (19)           !  esagonale  6/m
            thetaRange(1:2)=(/  0 ,  90 /) ! verificato
            phiRange(1:2)  =(/  0 ,  60 /)
          case (20)           !  esagonale  6/mmm
            thetaRange(1:2)=(/  0 ,  90 /)
            phiRange(1:2)  =(/  0 ,  60 /)
          case (21,22,23)           !  cubico  m -3
            thetaRange(1:2)=(/  0 ,  90 /) !ok
            phiRange(1:2)  =(/  0 ,  90 /)
          case (24,25,26)           !  cubico  m -3 m
            thetaRange(1:2)=(/  0 ,  90 /) !ok
            phiRange(1:2)  =(/  0 ,  45 /)
        end select
      endif
!
      inRegionHelix = 0
      if(idCoor>5) then
        id1=thetaRange(1)
        id2=thetaRange(2)
        thetaRange(2)=cos(dtor*id1)
        thetaRange(1)=cos(dtor*id2)
      endif
!
      if(theta>=thetaRange(1).and.theta<=thetaRange(2)) then
        if(phi>=phiRange(1).and.phi<=phiRange(2)) then
           inRegionHelix = 1
        endif
      endif

c     if(inRegionHelix==0) then
c       write(6,*) 'fuori regione',theta,phi,nSpaceGroupPatt
c     endif
!
      return
      end
!---------------------------------------------------
      integer function sideph(nterm0,nbin)
c
      ntermm = nterm0
      do while(ntermm<-nbin)
          ntermm=ntermm+2*nbin
      enddo
      do while(ntermm>=nbin)
          ntermm=ntermm-2*nbin
      enddo
      sideph=ntermm
c
      return
      end
!-----------------------------------------------------
      subroutine ClusterHelix()
      USE Clustering
      USE General
      USE Eliche
      USE Atomi

      real distmin,distmax,sogth,sog
      integer natsMax
!     real*8 MpeVector(nats*(nats-1)/2)
      real*8, allocatable    :: MpeVector(:)
      integer, allocatable    :: nclu(:)
      integer, allocatable    :: iclu(:,:)
      integer istep,ktrue,length
      real valTdum,valPdum
!
!  faccio il clustering considerando la distanza dei punti
!    su una sfera di raggio 1
!
      length=nats*(nats-1)/2
      allocate (MpeVector(1:length), stat = ierr)
c
      dum=0
      distmin=9999.
      distmax=-9999.
      MpeVector=0.0
      do i=1, nats-1
        valT1 = xyzs(2,i)
        valP1 = xyzs(3,i)
        if(nvolta>1) then
          if(i<=natsId1) then
            idCoor=10
          elseif(i>natsId1.and.i<=natsId1+natsId2) then
            idCoor=20
          else
            idCoor=30
          endif
        endif
c       call PolToCar(valT1,valP1,xx1,yy1,zz1) ! da togliere
        do j=i+1, nats
          valT2 = xyzs(2,j)
          valP2 = xyzs(3,j)
          if(nvolta>1) then
            if(j<=natsId1) then
              idCoor=10
            elseif(j>natsId1.and.j<=natsId1+natsId2) then
              idCoor=20
            else
              idCoor=30
            endif
          endif
c         call PolToCar(valT2,valP2,xx2,yy2,zz2) ! da togliere
          call  ConfrontaElicheSym(valT1,valP1,valT2,valP2,dist,
     &          valTdum,valPdum)
!
c         dist1=sqrt((xx2-xx1)**2+(yy2-yy1)**2+(zz2-zz1)**2)
c         dist2=sqrt((xx2+xx1)**2+(yy2+yy1)**2+(zz2+zz1)**2)
c         dist=min(dist1,dist2)
c         dist=dist1
!--devo generare tutti gli equivalenti per simmetria dei due punti, calcolare
!  la distanza minima, e cambiare i valori di teta e phi per il secondo punto.
!
          ipunt=(j-1)*(j-2)/2+i
          MpeVector(ipunt)=dist
c         write(6,'(2(a,i6),2x,a,2x,f5.2)') 'peak ',j,' peak ',i,
c    &                                   'Dist ',dist
          if(dist<distmin) distmin=dist
          if(dist>distmax) distmax=dist
        enddo
      enddo
      write(6,55) distmin,distmax
  55  format(/,'Minimum and maximum distances',2f8.2,/)
c
c--algoritmo di clustering
c
      natsMax=nats
      call AllocaClustering(1,natsMax)
      call MakeCluster(nats,MpeVector,natsMax)
c
c--rilevo le informazioni del clustering
c
c     nclust      ! numero di clusters
c     nclu(:)     ! numero di elementi nel cluster klu
c     iclu(:,:)   ! elementi del cluster klu
      sog=0.2
c     sog=0.10 ! occhio
      if(sog>cdclust(nats-1)) then
          sogth=0.5
          sog=cdclust(1)+sogth*(cdclust(nats-1)-cdclust(1));          
      endif
      write(6,56) sog
  56  format(/,'Cluster Threshold:',f8.2,/)
!
!--determino il numero di clusters
!
      istep=0
      do i=1,nats-1
        if(cdclust(i)<sog) then
          istep=i
        else
          exit
        endif
      enddo
      if(istep/=0) then
        nclust=nats-istep
        allocate (nclu(1:nclust), stat = ierr)
        allocate (iclu(1:nclust,1:nats), stat = ierr)
        nclu(:)=0.0
        iclu(:,:)=0.0
!
        if(nclust==1) then
          nclu(1)=nats
          do l=1,nats
            iclu(1,l)=l 
          enddo
        else
!
!--determino i capo-clusters
!
          kclu=0
          do i=istep+1,nats-1
            ies1=1
            ies2=1
            if(i>istep+1) then
              do l=1,kclu
                if(iclu(l,nclu(l)).eq.ilcclust(i)) ies1=0
                if(iclu(l,nclu(l)).eq.iucclust(i)) ies2=0
              enddo
            endif
            if(ies1==1) then
              kclu=kclu+1
              nclu(kclu)=1
              iclu(kclu,nclu(kclu))=ilcclust(i) 
            endif
            if(ies2==1) then
              kclu=kclu+1
              nclu(kclu)=1
              iclu(kclu,nclu(kclu))=iucclust(i) 
            endif
          enddo
!
!--determino la composizione dei clusters lunghi 
!
          do i=istep,1,-1
            do l=1,nclust
              do k=1,nclu(l)
                if(iclu(l,k).eq.ilcclust(i)) then
                  nclu(l)=nclu(l)+1
                  iclu(l,nclu(l))=iucclust(i) 
                  exit
                elseif(iclu(l,k).eq.iucclust(i)) then
                  nclu(l)=nclu(l)+1
                  iclu(l,nclu(l))=ilcclust(i) 
                  exit
                endif
              enddo
            enddo
          enddo
!
        endif
!
!---controllo i risultati
!
        write(6,*)
        do k=1,nclust
          nn=nclu(k)
          write(6,57) k,nn,iclu(k,1:nn)
        enddo
  57    format('Cluster',i5,i5,')',1000(i8)) 
!
!
!--controllo che ciascun cluster contenga una direzione appartenente alle tre liste
!
        if(nvolta>1) then
          do k=1,nclust
            ies1=0
            ies2=0
            ies3=0
            do l=1,nclu(k)
              ik=iclu(k,l) 
              if(ik<=natsId1) ies1=1
              if(ik>natsId1.and.ik<=natsId1+natsId2) ies2=1
              if(ik>natsId1+natsId2) ies3=1
            enddo
            if(ies1+ies2+ies3<3) then
!--scarto il cluster
              nclu(k)=0
            endif
          enddo
        endif
!
!--calcolo la direzione rappresentativa di ciascun cluster
!  come media pesata delle direzioni dei clusters costituendi
!
        ktrue=0
        do k=1,nclust
          hmax=-999.
          hsum=0.0
          avxx=0.0
          avyy=0.0
          avzz=0.0
          if(nclu(k)>0) then
            ktrue=ktrue+1
            do l=1,nclu(k)
              ik=iclu(k,l) 
              h=xyzs(4,ik)
!--faccio la media usando la metrica cartesiana sulla sfera unitaria
              valT = xyzs(2,ik)
              valP = xyzs(3,ik)
              if(nvolta>1) then
                if(ik<=natsId1) then
                  idCoor=10
                elseif(ik>natsId1.and.ik<=natsId1+natsId2) then
                  idCoor=20
                else
                  idCoor=30
                endif
              endif
              call PolToCar(valT,valP,xx1,yy1,zz1)
!--controllo per effetti di bordo
              if(l==1) then
c               xx1store=xx1 
c               yy1store=yy1 
c               zz1store=zz1
                valTstore=valT
                valPstore=valP
              else
                call  ConfrontaElicheSym(valTstore,valPstore,valT,valP,
     &                dist,valTnew,valPnew)
c               if(abs(valTnew-valT)>0.01) then
c                 write(6,*) 'cambiato',valT,valP,valTnew,valPnew
c               endif
                call PolToCar(valTnew,valPnew,xx1,yy1,zz1)
c               dist1=sqrt((xx1store-xx1)**2+(yy1store-yy1)**2+
c    &                      (zz1store-zz1)**2)
c               dist2=sqrt((xx1store+xx1)**2+(yy1store+yy1)**2+
c    &                      (zz1store+zz1)**2)
c               if(dist2<dist1) then
c                 write(6,*) 'sono qui', uffa
c                 xx1=-xx1
c                 yy1=-yy1
c                 zz1=-zz1
c               endif
              endif
!----
              avxx=avxx+xx1*h
              avyy=avyy+yy1*h
              avzz=avzz+zz1*h
              if(h>hmax) hmax=h
              hsum=hsum+h
            enddo
            avxx=avxx/hsum
            avyy=avyy/hsum
            avzz=avzz/hsum
!--mi riferisco sempre alla zona angolare permessa
c           if(avxx<0.0) then
c             avxx=-avxx
c             avyy=-avyy
c             avzz=-avzz
c           endif
            if(nvolta>1) idCoor=10
            call CarToPol(avxx,avyy,avzz,avtheta,avphi)
            xyz30(2,ktrue)=avtheta
            xyz30(3,ktrue)=avphi
            xyz30(4,ktrue)=hmax
          endif
        enddo
        nclust=ktrue
!
!--ricalcolo la lista delle direzioni in base al clustering
!
        nats=nclust
        xyzs(2:4,1:nats)=xyz30(2:4,1:nats)
!
!--riordino la lista in base all'altezza
!
        call sortf(xyzs, 5,  nats, 4)
      endif
c
      deallocate (MpeVector, stat = ierr)
      deallocate (nclu, stat = ierr)
      deallocate (iclu, stat = ierr)
      call AllocaClustering(2,natsMax)
c
c
      return
      end
c-----------------------------------------------------------------------
      subroutine maxmin3dPolar(denmin,denmax,avden,stden,npunt,id)
      USE Mappa

      denmin =  1.0e25
      denmax = -1.0e25
      avden  =  0.0
      stden  =  0.0
      npunt=0
c
       if(id==0) then
         do iz = 0, np(3)-1
           do iy = 0, np(2)-1
             do ix = 0, np(1)-1
               xx=xmap(ix,iy,iz)
               denmax=amax1(denmax,xx)
               denmin=amin1(denmin,xx)
               avden=avden + xx
               stden=stden + xx * xx
               npunt=npunt+1
             enddo
           enddo
         enddo
      else
         do iz = 0, np(3)-1
           do iy = 0, np(2)-1
             do ix = 0, np(1)-1
               xx=xmap(ix,iy,iz)
               if(xx>0) then   
                 denmax=amax1(denmax,xx)
                 denmin=amin1(denmin,xx)
                 avden=avden + xx
                 stden=stden + xx * xx
                 npunt=npunt+1
               endif
             enddo
           enddo
         enddo
      endif
c
      avden=avden/float(npunt)
      stden=stden/float(npunt) - avden*avden
      if (stden.gt.0.0) then
          stden=sqrt(stden)
      else
          stden=0.0
      endif
c
      return
      end

!----------------------------------------------------------------
      subroutine calc_FSE(numb)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Eliche

      integer i1(3)
      real x1(3)
!
      do i=1,numb
         i1(1)=khl(1,i)
         i1(2)=khl(2,i)
         i1(3)=khl(3,i)
c
c-- compute H*R and H*T
c
         do j=1,nsym
            tt=1000.0
            do l=1,3
               tt=tt+float(i1(l))*tmat(j,l)
               hkle(l,j)=0
c
               do k=1,3
                  hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)
               enddo
c
            enddo
            hkle(4,j)=tt
         enddo
         rho=rhov(i)
         act=0.0
         bct=0.0
!
         do ij=1,ElicaTipo(1)%nk
            ff(ij) = ScattFact(ij, rho)
         enddo

         do jj=1, natsTipo
            kz=ElicaTipo(1)%specie(jj,1)            
            if (kz /= 0) then
                x1(1:3) =ElicaTipo(1)%atoms(1:3,jj,1)
                fkz=ff(kz)
                arg=-ElicaTipo(1)%th_fact(jj,1)*rho
                effe=pts*fkz*exp(arg)
                tfocc=effe*ElicaTipo(1)%atoms(5,jj,1)
                call sfacyyyE(x1, contc, conts)
                contc=contc*tfocc
                conts=conts*tfocc
                act=act+contc
                bct=bct+conts
            endif
         enddo
!
         args=act*act+bct*bct
         if (args.gt.0.000001) then
             fc=sqrt(args)
             faze=rtod*atan2(bct,act)+360.0
             ac=act/fc
             bc=bct/fc
         else
             fc=0.0
             faze=0.0
             ac=0.0
             bc=0.0
         endif
         fcvet(i) = fc
      enddo

      return
      end

!----------------------------------------------------------------
      subroutine calc_FSE_roc(numb)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Eliche

      integer i1(3)
      real x1(3)
!
      do i=1,numb
         fcvet(i)=0.
         res=0.5 / sqrt(rhov(i))
c        if(res<resElica ) cycle
         if(res>resElica ) cycle
c
         i1(:)=khl(:,i)
         do j=1,nsym
            do l=1,3
               hkle(l,j)=0
               do k=1,3
                  hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)
               enddo
            enddo
            hkle(4,j)=1000.0
         enddo
         rho=rhov(i)
!
         do ij=1,ElicaTipo(1)%nk
            ff(ij) = ScattFact(ij, rho)
         enddo

         args=0.0
         do j=1,nsym
           act=0.0
           bct=0.0
           do jj=1, natsTipo
              kz=ElicaTipo(1)%specie(jj,1)            
              if (kz /= 0) then
                x1(1:3) =ElicaTipo(1)%atoms(1:3,jj,1)
                fkz=ff(kz)
!--uso il B trovato nel wilson plot
!               arg=-ElicaTipo(1)%th_fact(jj,1)*rho
                arg=-bt*rho
                effe=pts*fkz*exp(arg)
                tfocc=effe*ElicaTipo(1)%atoms(5,jj,1)
                arg=amod(hkle(1,j)*x1(1)
     *                  +hkle(2,j)*x1(2)
     *                  +hkle(3,j)*x1(3)
     *                  +hkle(4,j),1.0)
                iarg=int(360.0*arg+0.5)+1
                if (iarg.eq.361) iarg=1
                act=act+cost(iarg) *  tfocc
                bct=bct+sint(iarg) *  tfocc
              endif
           enddo
           args=args+act*act+bct*bct
         enddo
         if (args.gt.0.000001) then
             fc=sqrt(args)
         else
             fc=0.0
         endif
         fcvet(i) = fc
      enddo

      return
      end

!----------------------------------------------------------------
      subroutine sfacyyyE(x1,contc,conts)
      USE General
      USE Symmetry
      USE Atomi
      USE PhaseModule
      real x1(3)
!
c
c--   structure factor calculation
c
      att=0.0
      btt=0.0
      do j=1,nsym
         arg=amod(hkle(1,j)*x1(1)
     *           +hkle(2,j)*x1(2)
     *           +hkle(3,j)*x1(3)
     *           +hkle(4,j),1.0)
         iarg=int(360.0*arg+0.5)+1
         if (iarg.eq.361) iarg=1
         if (iarg < 0 .or. iarg > 360) then
             iii = 0
         endif
         att=att+cost(iarg)
         btt=btt+sint(iarg)
      enddo
!
      if (icent.eq.0) then
          contc=att
          conts=btt
      else
          contc=2.0*att
          conts=0.0
      endif

      return
      end
!-----------------------------------------------------------------------
      subroutine Correla_Mappe_Polar(x1,x2,corre)
      USE General
      USE Eliche

! -- Attenzione le mappe da confrontare devono avere origine coincidente

      real x1(nxMin:nxMax, nyMin:nyMax, nzMin:nzMax)
      real x2(nxMin:nxMax, nyMin:nyMax, nzMin:nzMax)
c
      corre = -99.9
c
      npunti=0
      vmedt=0.0
      vmedc=0.0
      vmedtc=0.0
      vmed2t=0.0
      vmed2c=0.0

      do ip = nzMin, nzMax             
         do it = nyMin, nyMax         
            do ir = nxMin, nxMax
               xx1=x1(ir,it,ip)
               xx2=x2(ir,it,ip)
               if(xx1<0.0) cycle 
               if(xx2<0.0) cycle
               if(xx1.ne.-1 .and. xx2.ne.-1)then
                  npunti=npunti+1
                  vmedt=vmedt + xx1
                  vmedc=vmedc + xx2
                  vmedtc=vmedtc + xx1 * xx2
                  vmed2t=vmed2t + xx1 * xx1
                  vmed2c=vmed2c + xx2 * xx2
               endif
            enddo
         enddo
      enddo

      if(npunti>0) then
        vmedt=vmedt/float(npunti)
        vmedc=vmedc/float(npunti)
        vmedtc=vmedtc/float(npunti)
        vmed2t=vmed2t/float(npunti)
        vmed2c=vmed2c/float(npunti)
        rnum=vmedtc - (vmedt*vmedc)
        arg1 = vmed2t - vmedt ** 2
        arg2 = vmed2c - vmedc ** 2
        rden=sqrt(arg1) * sqrt(arg2)
        corre=rnum/rden
      else
        corre=-2.0
      endif
      
      return
      end
!-----------------------------------------------------------------------
      subroutine Correla_Riflessi(corre)
      USE General
      USE Riflessi
      USE Eliche
      USE Symmetry, only : nsym

! -- Attenzione le mappe da confrontare devono avere origine coincidente

c
      corre = -99.9
c
      apunti=0
      vmedt=0.0
      vmedc=0.0
      vmedtc=0.0
      vmed2t=0.0
      vmed2c=0.0

      do i = 1, nrefl             
               res=0.5 / sqrt(rhov(i))
c              if(res<resElica ) cycle 
c              if(res<2.0 ) cycle 
               if(res>resElica ) cycle  
               xx1=fovet(i)
               xx2=fcvet(i)
c              w=nsym/epsv(i) ! va peggio
               w=1
               apunti=apunti+w
               vmedt=vmedt + xx1*w
               vmedc=vmedc + xx2*w
               vmedtc=vmedtc + xx1 * xx2*w*w
               vmed2t=vmed2t + xx1 * xx1*w*w
               vmed2c=vmed2c + xx2 * xx2*w*w
      enddo

      if(apunti>0) then
        vmedt=vmedt/apunti
        vmedc=vmedc/apunti
        vmedtc=vmedtc/apunti
        vmed2t=vmed2t/apunti
        vmed2c=vmed2c/apunti
        rnum=vmedtc - (vmedt*vmedc)
        arg1 = vmed2t - vmedt ** 2
        arg2 = vmed2c - vmedc ** 2
        rden=sqrt(arg1) * sqrt(arg2)
        corre=rnum/rden
      else
        corre=9999.0
      endif
      
      return
      end
!-----------------------------------------------------------------------
      real function GetXYZ(i, j)
      USE RemoModule
      USE Atomi
!
      implicit none
      integer       :: i, j
!
      GetXYZ = model(WhichModel)%ortho(j,i,1)
!
      return
      end
!-----------------------------------------------------------------------
      integer function GetCatena(i)
      USE RemoModule
      USE Atomi
!
      implicit none
      integer       :: i, j
!
      j = InfoOnModels(WhichModel)%iEqui(i)
      GetCatena = ichar( model(WhichModel)%catena(j,1))
!
      return
      end
!-----------------------------------------------------------------------
      integer function GetNumResiduo(i)
      USE RemoModule
      USE Groups
!
      implicit none
      integer           :: i, j, k
      character (len=3) :: a3
!
      j = InfoOnModels(WhichModel)%iEqui(i)
      a3 =  model(WhichModel)%tipoResiduo(j,1)
      call ucase(a3)
      j = 22
      do k=1, 21
         if (a3 == AminoName3(k)) then
             j = k
             exit
         endif
      enddo
      GetNumResiduo = j
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GetLab(i, labstring)
      USE RemoModule
!
      implicit none
      integer            :: i, j, k, Lung
      character  (len=*) :: labstring
!
      j = InfoOnModels(WhichModel)%iEqui(i)
      k = Lung( model(WhichModel)%Label(j) )
      labstring = model(WhichModel)%Label(j)(1:k) // char(0)
!
      return
      end
!-----------------------------------------------------------------------
      integer function GetZ (i)
      USE RemoModule
      USE Atomi, only : nzConst
!
      implicit none
      integer            :: i, j, k
!
      j = InfoOnModels(WhichModel)%iEqui(i)
      k = model(WhichModel)%specie(j, 1) / nzConst
      GetZ = model(WhichModel)%no(k)
!
      return
      end
!---------------------------------------------------------------------------
      subroutine outPDB_mio(nunit, numbPDB, ifFast, ifREM)
      USE General
      USE Symmetry
      USE Solutions
      USE RemoModule
      USE Eliche
      USE Atomi, only : nzConst
!
!-- nunit   = logical unit (file must be already opened)
!-- numbPDB > 0 number of atoms to export
!--         < 0 all atoms in binary file are exported
!-- ifFast  = 0  atoms coordinates are fetched from binary file
!--         = 1  atoms coordinates are fetched from xyzs (Atomi module)
!-- ifREM   = 0  no REMs are added to the file
!--         > 0  REMs are added to the file (MAD info)
!
      implicit none
      integer :: nunit, numbPDB, ifFast, ifREM, ihydr, Lung, i, j, l
      integer :: nzeta, nch, ii, nCatena, nresid, n, iser, ich, kk
      integer :: NSYMP, NSYMTZ, NSPGR, MAXSYM, uij(6) 
      parameter (MAXSYM = 192)
      real    :: origx(3,3), rmpdb(3,3), rmipdb(3,3), txxx, angoli(3)
      real    :: xtemp(5), RSYM(4,4,MAXSYM)
      character (len= 1) :: catena, LTYPE
      character (len= 2) :: a2
      character (len= 4) :: a4a, a4b
      character (len= 6) :: a6
      character (len=10) :: SPGRNAM, PGNAM
!
      ihydr = 0
!
!-- HEADER
!
      write(Buffer1,1111) Titolo(1:72)
      write(nunit,'(a)') Buffer1(1:Lung(Buffer1))
!
!-- REMARKS
!
      if (ifREM > 0) then
          do i=1, ifREM
             write(nunit,'(a)') card(i)(1:Lung(card(i)))
          enddo
      endif
!
!-- CRYST1
!
      call SpaceGroupCCP4(NSPGR,SPGRNAM,PGNAM,NSYMP,NSYMTZ,RSYM,LTYPE)
      Inte = SPGRNAM
      nzeta = totop
      write(nunit,1130) cell(1:6), Inte(1:11), nzeta
!
!-- ORIGX
!
      do i=1,3
         do j=1,3
            origx(i,j)=0.0
            if (i.eq.j) origx(i,j)=1.0
         enddo
         txxx=0.0
         write(nunit,1135)i,(origx(i,j),j=1,3),txxx
      enddo
!
      do i=1,3
         angoli(i) = cell(i+3) * dtor
      enddo
!
!-- metrica diretta
!
      rmpdb(1,1) =  cell(1)                          ! a
      rmpdb(1,2) =  0
      rmpdb(1,3) =  0
      rmpdb(2,1) =  cell(2) * cos(angoli(3))         !  b*cos(gam)
      rmpdb(2,2) =  cell(2) * sin(angoli(3))         !  b*sin(gam)
      rmpdb(2,3) =  0
      rmpdb(3,1) =  cell(3) * cos(angoli(2))         !  c*cos(bet)
      rmpdb(3,2) = -cell(3) * sin(angoli(2))
     1                     * cos(asta(4))          ! -c*sin(bet)*cos(alfs)
!da annamaria?? 
!     1                     * cos(angoli(1))          ! -c*sin(bet)*cos(alfs)
      rmpdb(3,3) =  1.0 / asta(3)                    !  1./cstar
!
!-- metrica inversa
!
      rmipdb(1,1) =  1.0 / cell(1)                    !  1./a
      rmipdb(1,2) =  0
      rmipdb(1,3) =  0
      rmipdb(2,1) = -cos(angoli(3)) /
     1               cell(1) * sin(angoli(3))         !  -cos(gam)/(a*sin(gam))
      rmipdb(2,2) =  1.0 / (cell(2) * sin(angoli(3))) !  1./(b*sin(gam))
      rmipdb(2,3) =  0
      rmipdb(3,1) =  asta(1) * cos(asta(5))           !  astar*cos(bets)
      rmipdb(3,2) =  asta(2) * cos(asta(4))           !  bstar*cos(alfs)
      rmipdb(3,3) =  asta(3)                          !  cstar
!
!-- SCALE
!
      do i=1, 3
         write(nunit,1136)i,(rmipdb(j,i),j=1,3), txxx
      enddo
!
!-- ATOM / HETATM
!
      nresid = 666
      nch = 64
      iser = 0
      nCatena = -1
            do i=1, natsTipo
               kk =ElicaTipo(1)%specie(i,1)
               if (kk == 0) cycle
               kk = iabs(kk)
               a2 = Species(kk)(1:2)
               call ucase(a2)
               if (a2(2:2) == ' ') then
                   a2(2:2) = a2(1:1)
                   a2(1:1) = ' '
               endif
               nresid = mod(ElicaTipo(1)%specie(i,1), 1)
               xtemp(:) = 0.0
c              do l=1,3
c                 do n=1,3
c                 xtemp(l)=xtemp(l)+rmpdb(n,l)*ElicaTipo(1)%atoms(n,i,1)
c                 enddo
c              enddo
               xtemp(1:3)=ElicaTipo(1)%ortho(1:3,i,1)
               xtemp(4) = ElicaTipo(1)%atoms(5,i,1)
               xtemp(5) = ElicaTipo(1)%th_fact(i,1)
               iser = iser + 1
               catena = 'A'!model(ii)%Catena(i,j)
*???*          if (catena /= ' ') then
*???*              ich = ichar(catena)
*???*              ich = ich + nCatena
*???*              catena = char(ich)
*???*          endif
               ElicaTipo(1)%tipoAtomo(i,1)(4:4) =
     *                            ElicaTipo(1)%Alternate(i,1)
               a4a = ElicaTipo(1)%tipoAtomo(i,1)
               a4b = ElicaTipo(1)%tipoResiduo(i,1)
               call ucase(a4a)
               call ucase(a4b)
               if (a4a == '    ') then
                   a4a = a2
               endif
               if (a4b == '    ') then
                   a4b = 'HET'
                   a6  = 'HETATM'
               else
                   a6  = 'ATOM  '
               endif
               if (catena == ' ') then
                   catena = 'A'
               endif
               n = ElicaTipo(1)%numResiduo(i,1)
               if (n == 0) then
                   n = i
               endif
               write(nunit,10) a6, iser, a4a, a4b, catena, n,xtemp(:),a2
!
!-- ANISOU
!
      enddo
      write(nunit,1155)
!
      return
   10 format(a,i5,2x,2a4,a1,i4,4x,3f8.3,2f6.2,10x,a2)
 1110 format('HEADER',4x,18a4)
 1111 format('HEADER',4x,a)
 1130 format('CRYST1',3f9.3,3f7.2,1x,a,i4)
 1135 format('ORIGX',i1,4x,3f10.6,f15.5)
 1136 format('SCALE',i1,4x,3f10.6,f15.5)
 1155 format('END')
   20 format(a,i5,2x,2a4,a1,i4,2x,6i7,6x,a2)
!
      return
      end
!----------------------------------------------------------------------
      subroutine RotationOperPolar2(b,tetaang,piang,chiang)
      USE General, only: dtor

      implicit none
      real  b(3,3)
      real chiang,piang,tetaang,theta,phi,chi
      real mcd,lcd,ncd
      real cchi,schi,ctheta,stheta,cphi,sphi

      theta=tetaang*dtor
      phi=piang*dtor
      chi=chiang*dtor
c
      stheta=sin(theta)
      sphi=sin(phi)
      schi=sin(chi)
      ctheta=cos(theta)
      cphi=cos(phi)
      cchi=cos(chi)
c
c      b(1,1)=cchi+(1-cchi)*(stheta**2)*(cphi**2)
c      b(1,2)=-sphi*stheta*schi+(1-cchi)*ctheta*stheta*cphi
c      b(1,3)=-ctheta*schi-(1-cchi)*(stheta**2)*cphi*sphi
c      b(2,1)=stheta*sphi*schi+(1-cchi)*ctheta*stheta*cphi
c      b(2,2)=cchi+(1-cchi)*(ctheta**2)
c      b(2,3)=stheta*cphi*schi-(1-cchi)*ctheta*stheta*sphi
c      b(3,1)=ctheta*schi-(1-cchi)*(stheta**2)*cphi*sphi
c      b(3,2)=-stheta*cphi*schi-(1-cchi)*ctheta*stheta*sphi
c      b(3,3)=cchi+(1-cchi)*(stheta**2)*(sphi**2)
c
       lcd=stheta*cphi
       mcd=stheta*sphi
       ncd=ctheta

       b(1,1)=lcd**2+(mcd**2+ncd**2)*cchi
       b(1,2)=lcd*mcd*(1-cchi)-ncd*schi
       b(1,3)=ncd*lcd*(1-cchi)+mcd*schi
       b(2,1)=lcd*mcd*(1-cchi)+ncd*schi
       b(2,2)=mcd**2+(lcd**2+ncd**2)*cchi
       b(2,3)=mcd*ncd*(1-cchi)-lcd*schi
       b(3,1)=ncd*lcd*(1-cchi)-mcd*schi
       b(3,2)=mcd*ncd*(1-cchi)+lcd*schi
       b(3,3)=ncd**2+(lcd**2+mcd**2)*cchi

      return
      end

!-----------------------------------------------------------------------     
      subroutine RotationOperPolar1a(b,tetaang,piang,chiang)
      USE General, only: dtor

      implicit none
      real  b(3,3), R1(3,3), R2(3,3), R3(3,3)
      real chiang,piang,tetaang,theta1,phi1
      real mcd,lcd,ncd, ang1, ang2, ang3
      real cchi,schi,ctheta,stheta,cphi,sphi

      theta1=(90-tetaang)*dtor
      phi1=piang*dtor
c     
c--faccio una rotazione intorno all'asse y, di 90-theta     
c     
      R2(1,1)=cos(theta1)
      R2(1,2)=0
      R2(1,3)=-sin(theta1)
      R2(2,1)=0
      R2(2,2)=1
      R2(2,3)=0
      R2(3,1)=sin(theta1)
      R2(3,2)=0
      R2(3,3)=cos(theta1)
c     
c--faccio una rotazione intorno all'asse z, di phi
c     
      R3(1,1)=cos(phi1)
      R3(1,2)=-sin(phi1)
      R3(1,3)=0
      R3(2,1)=sin(phi1)
      R3(2,2)=cos(phi1)
      R3(2,3)=0
      R3(3,1)=0
      R3(3,2)=0
      R3(3,3)=1
c     
c--costruisco la matrice di rotazione combinando le due rotazioni precedenti
c     
      call MoltMatMat(R3, R2, b)!b=R3*R2
c
      return
      end
!-----------------------------------------------------------------------     
      subroutine RotationOperPolar1b(b,tetaang,piang,chiang)
      USE General, only: dtor

      implicit none
      real  b(3,3), R1(3,3), R2(3,3), R3(3,3)
      real chiang,piang,tetaang,theta1,phi1
      real mcd,lcd,ncd, ang1, ang2, ang3
      real cchi,schi,ctheta,stheta,cphi,sphi

      theta1=tetaang*dtor
      phi1=piang*dtor
c     
c--faccio una rotazione intorno all'asse z, di theta     
c     
      R2(1,1)=cos(theta1)
      R2(1,2)=-sin(theta1)
      R2(1,3)=0
      R2(2,1)=sin(theta1)
      R2(2,2)=cos(theta1)
      R2(2,3)=0
      R2(3,1)=0
      R2(3,2)=0
      R2(3,3)=1 
c     
c--faccio una rotazione intorno all'asse x, di phi
c     
      R3(1,1)=1 
      R3(1,2)=0 
      R3(1,3)=0 
      R3(2,1)=0 
      R3(2,2)=cos(phi1)
      R3(2,3)=-sin(phi1)
      R3(3,1)=0
      R3(3,2)=sin(phi1)
      R3(3,3)=cos(phi1)
c     
c--costruisco la matrice di rotazione combinando le due rotazioni precedenti
c     
      call MoltMatMat(R3, R2, b)!b=R3*R2
c
      return
      end
!-----------------------------------------------------------------------     
      subroutine RotationOperPolar1c(b,tetaang,piang,chiang)
      USE General, only: dtor

      implicit none
      real  b(3,3), R1(3,3), R2(3,3), R3(3,3)
      real chiang,piang,tetaang,theta1,phi1
      real mcd,lcd,ncd, ang1, ang2, ang3
      real cchi,schi,ctheta,stheta,cphi,sphi

      theta1=(90-tetaang)*dtor
      phi1=(90-piang)*dtor
c     
c--faccio una rotazione intorno all'asse z, di 90-theta     
c     
      R2(1,1)=cos(theta1)
      R2(1,2)=-sin(theta1)
      R2(1,3)=0
      R2(2,1)=sin(theta1)
      R2(2,2)=cos(theta1)
      R2(2,3)=0
      R2(3,1)=0
      R2(3,2)=0
      R2(3,3)=1 
c     
c--faccio una rotazione intorno all'asse y, di 90-phi
c     
      R3(1,1)=cos(phi1)
      R3(1,2)=0
      R3(1,3)=-sin(phi1)
      R3(2,1)=0
      R3(2,2)=1
      R3(2,3)=0
      R3(3,1)=sin(phi1)
      R3(3,2)=0
      R3(3,3)=cos(phi1)
c     
c--costruisco la matrice di rotazione combinando le due rotazioni precedenti
c     
      call MoltMatMat(R3, R2, b)!b=R3*R2
c
      return
      end
c -----------------------------------------------------------------
      subroutine ControllaDirezioniEliche(nfoundTrue,nsolgood,nposmax)
      USE General
      USE Eliche
      USE Atomi
!
      implicit none
      real  :: theta,phi,avdist
      integer  :: i,id,j, nfound, nfoundTrue,ierr,nsolgood,nposmax
      real     :: thetaTrue, phiTrue,dist,sog,pos
      real     :: xx1,yy1,zz1,valTr,valPr
      real, allocatable    :: check(:,:)
      real     :: funErrHelix

      allocate (check(1:3,1:nats*numbEliche), stat = ierr)
     
!
      if(numbEliche<=0) return
!
      sog=0.2
!
      nfound=0
      write(6,'(/,a,/)') 'Checking Directions'
      do i=1,nats
        write(6,'(i5,2f10.2,2x,g10.2)') i,xyzs(2:4,i)
        theta=xyzs(2,i)
        phi=xyzs(3,i)
        do j=1,numbEliche
          sog=funErrHelix(elica(j)%nResi)
c         write(6,*) 'elicaerr',j,elica(j)%nResi,sog
          thetaTrue=elica(j)%theta
          phiTrue=elica(j)%phi
c         call ConfrontaEliche(theta,phi,thetaTrue,phiTrue,dist,id)
          call  ConfrontaElicheSym(theta,phi,thetaTrue,phiTrue,dist,
     &              thetaTrue,phiTrue)
c         if(id<0) then
c--cambio le coordinate vere
c           call PolToCar(thetaTrue,phiTrue,xx1,yy1,zz1)
c           call CarToPol(-xx1,-yy1,-zz1,thetaTrue,phiTrue)
c         endif
          if(dist<sog) then
            write(6,'(a,a,i5,2f10.2,f10.3)') ' Found',
     &       ' --------------------> ',j,thetaTrue,phiTrue,dist
            nfound=nfound+1
            check(1,nfound)=j
            check(2,nfound)=dist
            check(3,nfound)=i
            if(dist<elica(j)%esito) elica(j)%esito=dist
            if(i<elica(j)%pos) elica(j)%pos=i
          endif
        enddo
      enddo
!--conto le soluzioni buone (anche considerando le soluzioni trovate piu' volte)
      nsolgood=0
      do i=1,nats
        do j=1,nfound
         if(check(3,j)==i) then
            nsolgood=nsolgood+1
            exit
         endif
        enddo
      enddo
!--escludo le direzioni trovate piu' volte
      do i=1,nfound-1
        do j=i+1,nfound
          if(check(1,i)==check(1,j)) then
            if(check(2,i)<check(2,j)) then
               check(:,j)=0.0
            else
               check(:,i)=0.0
            endif
          endif
        enddo
      enddo
      avdist=0.0
      nfoundTrue=0.0
      do i=1,nfound
         avdist=avdist+check(2,i)
         if(check(1,i)>0.0) then
            nfoundTrue=nfoundTrue+1
         endif
      enddo
!--trovo la posizione massima
      nposmax=0
      do j=1,numbEliche
         pos=elica(j)%pos
         if(pos>9000) pos=0
         if(pos>nposmax) nposmax=pos
      enddo
c     nposmax=nats-nposmax
!
      avdist=avdist/float(nfoundTrue)
!
      write(6,'(a,i5,a,f8.3)') 'Helix directions found:',nfoundTrue,
     &           ' <d>=',avdist
      write(6,'(a,3(f8.1,a))') 'Success rate:',
     &           100*nfoundTrue/float(numbEliche),' %', 
     &           100*nsolgood/float(nats),' %',
     &           100*nposmax/float(nats),' %'
c
      deallocate (check, stat = ierr)
!
      return
      end
!--------------------------------------------------------------------
      subroutine ConfrontaEliche(theta,phi,thetaTrue,phiTrue,dist,id)
      USE General
!
      implicit none
      integer :: id
      real :: valTr, valPr,theta,phi,thetaTrue,phiTrue
      real :: xx1,yy1,zz1,xx2,yy2,zz2
      real :: dist1,dist2,dist
!
      call PolToCar(theta,phi,xx1,yy1,zz1)
!
      call PolToCar(thetaTrue,phiTrue,xx2,yy2,zz2)
!
      dist1=sqrt((xx2-xx1)**2+(yy2-yy1)**2+(zz2-zz1)**2)
      dist2=sqrt((xx2+xx1)**2+(yy2+yy1)**2+(zz2+zz1)**2)
!
      dist=min(dist1,dist2)
!  
      id=1
      if(dist1>dist2) then
        id=-1
      endif
!
      return
      end
!--------------------------------------------------------------------
      subroutine ConfrontaElicheSym(teta1,phi1,teta2,phi2,distmin,
     &                                              tetamin,phimin)
      USE General
      USE Symmetry, only : nsymTot
      USE Molcom, only : rmi, rm
!
      implicit none
      real :: teta1,phi1,teta2,phi2
      real :: xxmin,yymin,zzmin,xx2,yy2,zz2
      real :: dist1,dist2,dist,distmin
      real :: xs1(3),xs(3),xs2(3)
      real :: tetamin,phimin
      real :: xx1,yy1,zz1
      integer :: k
!
      call Switch_to_Patterson_Group
!
      call PolToCar(teta1,phi1,xx1,yy1,zz1)
!
      call PolToCar(teta2,phi2,xs1(1),xs1(2),xs1(3))
      xs1(1:3)=4.*xs1(1:3)
      call MoltMatVec(rmi, xs1, xs)
      distmin=999.
      do k=1,nsymTot
         call oper(k,xs1,xs(1),xs(2),xs(3))
         call MoltMatVec(rm, xs1, xs2)
         dist=sqrt(xs2(1)**2+xs2(2)**2+xs2(3)**2)
         if(abs(dist-4)>1) cycle ! non considero le direzioni con centratura
         xs2(1:3)=xs2(1:3)/dist
         dist=sqrt((xx1-xs2(1))**2+(yy1-xs2(2))**2+(zz1-xs2(3))**2)
         if(dist<distmin) then
            distmin=dist
            xxmin=xs2(1)            
            yymin=xs2(2)            
            zzmin=xs2(3)            
         endif
      enddo
      call CarToPol(xxmin,yymin,zzmin,tetamin,phimin)
!
      call Switch_from_Patterson_Group
!
      return
      end
!-------------------------------------------------
      subroutine CarToPol(xx,yy,zz,theta,phi)
      USE General, only : rtod
      USE Eliche, only : idCoor
!
c     idCoor=1  ! angoli polari riferiti all'asse x          ! definizione canonica
c     idCoor=10 ! coordinate di campionamento uniforme: phi, theta=cos(theta)  (default)
c     idCoor=2  ! angoli polari riferiti all'asse y
c     idCoor=20 ! coordinate di campionamento uniforme: phi, theta=cos(theta) 
c     idCoor=3  ! angoli polari riferiti all'asse z               
c     idCoor=30 ! coordinate di campionamento uniforme: phi, theta=cos(theta) 
!
      implicit none
      real :: xx,yy,zz
      real :: theta,phi
      integer id
!
      if(idCoor==1) then
        phi=rtod*atan2(yy,xx)
        theta=rtod*acos(zz/sqrt(xx**2+yy**2+zz**2))
      elseif(idCoor==2) then
        phi=rtod*atan2(zz,yy)
        theta=rtod*acos(xx/sqrt(xx**2+yy**2+zz**2))
      elseif(idCoor==3) then
        phi=rtod*atan2(xx,zz)
        theta=rtod*acos(yy/sqrt(xx**2+yy**2+zz**2))
      elseif(idCoor==10) then
        phi=rtod*atan2(yy,xx)
        theta=zz                         ! out25
c       theta=zz/sqrt(xx**2+yy**2+zz**2) ! out26
      elseif(idCoor==20) then
        phi=rtod*atan2(zz,yy)
        theta=xx
c       theta=xx/sqrt(xx**2+yy**2+zz**2)
      elseif(idCoor==30) then
        phi=rtod*atan2(xx,zz)
        theta=yy
c       theta=yy/sqrt(xx**2+yy**2+zz**2)
      endif
!
      return
      end
!-------------------------------------------------
      subroutine PolToCar(theta,phi,xx,yy,zz)
      USE General, only : dtor
      USE Eliche, only : idCoor
!
c     idCoor=1  ! angoli polari riferiti all'asse x          ! definizione canonica
c     idCoor=10 ! coordinate di campionamento uniforme: phi, theta=cos(theta) (default) 
c     idCoor=2  ! angoli polari riferiti all'asse y
c     idCoor=20 ! coordinate di campionamento uniforme: phi, theta=cos(theta) 
c     idCoor=3  ! angoli polari riferiti all'asse z               
c     idCoor=30 ! coordinate di campionamento uniforme: phi, theta=cos(theta) 
!
      implicit none
      real :: xx,yy,zz
      real :: theta,phi
      integer id
      real :: valTr, valPr
!
      if(idCoor==1) then
        valTr = dtor * theta
        valPr = dtor * phi
        xx = cos(valPr) * sin(valTr)
        yy = sin(valPr) * sin(valTr)
        zz = cos(valTr)
      elseif(idCoor==2) then
        valTr = dtor * theta
        valPr = dtor * phi
        yy = cos(valPr) * sin(valTr)
        zz = sin(valPr) * sin(valTr)
        xx = cos(valTr)
      elseif(idCoor==3) then
        valTr = dtor * theta
        valPr = dtor * phi
        zz = cos(valPr) * sin(valTr)
        xx = sin(valPr) * sin(valTr)
        yy = cos(valTr)
      elseif(idCoor==10) then
        valTr=sqrt(1.0-theta**2)
        valPr = dtor * phi
        xx = cos(valPr) * valTr
        yy = sin(valPr) * valTr
        zz = theta
      elseif(idCoor==20) then
        valTr=sqrt(1.0-theta**2)
        valPr = dtor * phi
        yy = cos(valPr) * valTr
        zz = sin(valPr) * valTr
        xx = theta
      elseif(idCoor==30) then
        valTr=sqrt(1.0-theta**2)
        valPr = dtor * phi
        zz = cos(valPr) * valTr
        xx = sin(valPr) * valTr
        yy = theta
      endif
!
      return
      end
!-------------------------------------------------------------
      subroutine esito
      USE General, only : numeroResidui, resm, Pi, volume, nrefl
      USE Eliche
      USE Symmetry, only : nsymTot
      real :: theta,phi,fom,dist,posmax
      integer :: nres,pos
!
!--scrivo informazioni per fare la ntupla
!
!--numero di riflessi atteso
       NRefAtt=volume*(4.0*Pi)/(3.0*resm**3)
!--numero di riflessi effettivamente presenti
       NRefPre=nrefl*nsymTot*2.0
       Complet=float(NRefPre)/float(NRefAtt)
       Complet=min(Complet,1.0)
       ResEff=resm/(Complet)**0.3333
       write(85,200) -1,Complet,float(nsymTot),
     &          numeroResidui,resm,ResEff,numbEliche
       write(85,201) -2,eff1a,eff1b,
     &          eff2a,eff2b,eff3a,eff3b
       write(85,201) -3,eff4a,eff4b,
     &          eff4c,eff1c,eff2c,eff3c
!
      write(6,100) 
      if(idCoor<10) then
        write(6,150) 
      else
        write(6,151) 
      endif
      do j=1,numbEliche
         theta=elica(j)%theta
         phi=elica(j)%phi
         nres=elica(j)%nResi
         fom=elica(j)%fom
         dist=elica(j)%esito
         pos=elica(j)%pos
         if(pos>9000) pos=0
         write(6,200) j,theta,phi,nres,fom,dist,pos
         write(85,200) j,theta,phi,nres,fom,dist,pos
      enddo
 100  format("--------- Summary of Helix Search -------------")
 150  format("   N.  Theta   Phi    Nres     Fom    Dist Position ")
 151  format("   N.    t     Phi    Nres     Fom    Dist Position ")
 200  format(i4,2f8.2,i5,e10.2,f8.3,i5)
 201  format(i4,6f8.2)
!
      return
      end
!---------------------------------------------------
      real function funErrHelix(nres)
!
      implicit none
      integer :: nres
      real    :: m,l
!
      if(nres>30) nres=30  !per considerare il grid
c     if(nres>20) nres=20  !per considerare la curvatura e il grid
      l=1.4*nres
      m=2.35
!
      funErrHelix=m/sqrt(l*l+m*m)
!
      return
      end
!---------------------------------------------------
      subroutine combSolut(ntot)
    
      USE Eliche
!
      implicit none
      integer :: n,ntot,ierr
      real    :: m,l
c      integer, allocatable:: vetComb(:,:)!vetC(numbComb,n) 
      Integer   Cnk
   
      n = 2
      numbComb = Cnk(ntot,n)
      allocate (vetComb(1:numbComb,1:n), stat = ierr)
      call CombinazioniSemplici(vetComb,ntot,numbComb,n)

      return
      end
!---------------------------------------------------
      subroutine CalcDiffMatrix(m1,m2,m12)

!      porta il vettore v1(determinato dalla rotazione m1
!      sul vettore m2 determinato dalla rotazione m2 = m2(m1)-1      

      implicit none
      real m12(3,3), m1(3,3), m2(3,3) , m1_inv(3,3)
      real det 
       

      call inv3r(m1,det,m1_inv)
      call MoltMatMat(m2, m1_inv, m12)


      return
      end
!----------------------------------------------------------
      subroutine SRhelixRemo()
!controlla che la posizione reciproca tra eliche e rotazioni di MR sia la stessa
      Use Eliche
      USE Atomi, only:nats, xyzs
      USE Trigonometria 
      
     
      implicit none
      integer :: i,j,i1,i2, ierr
      integer :: numbSol
      integer :: WhichSol(100)
      real    :: RotFom(100),RotVal(100,1:3),Ra1(3,3),Ra2(3,3),Ra12(3,3)
      real    :: ctheta, thetaa, phia, chia, det 

         if(nats>2) then
         call combSolut(nats)
         if (.not. ALLOCATED(combHelix)) then
             allocate (combHelix(1:numbComb), stat = ierr)
         endif
         do i=1,numbComb
            combHelix(i)%numTot=numbComb
            combHelix(i)%Sol1=vetComb(i,1)
            combHelix(i)%Sol2=vetComb(i,2)

            ctheta=xyzs(2,combHelix(i)%Sol1)
            combHelix(i)%RotVal1(1)=ctheta
            if(idCoor>5) combHelix(i)%RotVal1(1)=(acos(ctheta))*rtod
            combHelix(i)%RotVal1(2) = xyzs(3,combHelix(i)%Sol1)
            combHelix(i)%RotVal1(3) = 0.
 
            ctheta=xyzs(2,combHelix(i)%Sol2)
            combHelix(i)%RotVal2(1)=ctheta
            if(idCoor>5) combHelix(i)%RotVal2(1)=(acos(ctheta))*rtod
            combHelix(i)%RotVal2(2) = xyzs(3,combHelix(i)%Sol2)
            combHelix(i)%RotVal2(3) = 0.
            
            thetaa=combHelix(i)%RotVal1(1)
            phia = combHelix(i)%RotVal1(2)
            chia = combHelix(i)%RotVal1(3)
            if(idCoor==1.or.idCoor==10) then
               call RotationOperPolar1a(Ra1,thetaa,phia,chia) 
            elseif (idCoor==2.or.idCoor==20) then
               call RotationOperPolar1b(Ra1,thetaa,phia,chia)
            elseif(idCoor==3.or.idCoor==30) then
               call RotationOperPolar1c(Ra1,thetaa,phia,chia)
            endif
            thetaa=combHelix(i)%RotVal2(1)
            phia = combHelix(i)%RotVal2(2)
            chia = combHelix(i)%RotVal1(3)
            call RotationOperPolar1a(Ra2,thetaa,phia,chia)

            call CalcDiffMatrix(Ra1,Ra2,Ra12)
            combHelix(i)%DiffMatrix(:,:)=Ra12(:,:)
         enddo 
        endif
!leggo le rotazioni di remo
         numbSol=0
         do
           numbSol=numbSol+1
           read(88,'(i4,i8,f8.3,3f7.1)',end=128) j,WhichSol(numbSol),
     &                RotFom(numbSol),RotVal(numbSol,1:3)
         enddo
128      continue
!le sistemo nel vettore combRemoRot
        if( numbSol>2)then
         call combSolut(numbSol) 
         if (.not. ALLOCATED(combRemoRot)) then
             allocate (combRemoRot(1:numbComb), stat = ierr)
         endif
         do i=1,numbComb
            i1=vetComb(i,1)
            i2=vetComb(i,2)
            combRemoRot(i)%numTot=numbComb 
            combRemoRot(i)%Sol1=WhichSol(i1)
            combRemoRot(i)%Sol2=WhichSol(i2)
            combRemoRot(i)%RotVal1(1:3)=RotVal(i1,1:3)
            combRemoRot(i)%RotVal2(1:3)=RotVal(i2,1:3)

            thetaa = combRemoRot(i)%RotVal1(1)
            phia = combRemoRot(i)%RotVal1(2)
            chia = combRemoRot(i)%RotVal1(3)
            call RotationOper1(Ra1,thetaa,phia,chia)

            thetaa = combRemoRot(i)%RotVal2(1)
            phia = combRemoRot(i)%RotVal2(2)
            chia = combRemoRot(i)%RotVal2(3)
            call RotationOper1(Ra2,thetaa,phia,chia)

            call CalcDiffMatrix(Ra1,Ra2,Ra12)
            call inv3r(Ra12,det,Ra1)
            combRemoRot(i)%DiffMatrix(:,:)=Ra12(:,:)

         enddo 

          call confrontamat()
      endif   
      return
      end
!------------------------------------------------
      subroutine  confrontamat()
      USE Eliche
      USE Symmetry
      USE Molcom, only : rmi, rm
!
      implicit none
      real, allocatable    :: VectorDist(:,:)
      integer :: length,numbComb1,numbComb2
      integer :: jj,ii,n,i1,i2,icont,ierr,jjj,i,j
      integer :: Re1_sol1,Re1_sol2,Re2_sol1,Re2_sol2
      real :: Re1(3,3),Re2(3,3),C(3,3)
      real :: M1Re1(3,3),MRc(3,3),MRcM1Re1(3,3),Re2t(3,3)
      real :: dist,distmin,distmintot,distmaxtot,rho
!
!--confronta le differenze tra rotazioni nella lista delle possibili eliche
!  e nella lista delle soluzioni di Remo
!
!--definisco la matrice delle distanze
!
      numbComb1=combHelix(1)%numTot
      numbComb2=combRemoRot(1)%numTot
!
      allocate (VectorDist(1:numbComb1,1:numbComb2), stat = ierr)
      VectorDist=0.0
!
      icont=0
      distmintot=99999
      distmaxtot=-1
      do i1=1,numbComb1
        Re1(:,:)=combHelix(i1)%DiffMatrix(:,:)
c       Re1_sol1=combHelix(i1)%Sol1
c       Re1_sol2=combHelix(i1)%Sol2
        do i2=1,numbComb2
           Re2(:,:)=combRemoRot(i2)%DiffMatrix(:,:)
c          Re2_sol1=combRemoRot(i2)%Sol1
c          Re2_sol2=combRemoRot(i2)%Sol2

           distmin=9999.
           do jjj=1,2
             if(jjj==1) then
                do i=1,3
                  do j=1,3
                    Re2t(i,j)=Re2(i,j)
                  enddo
                enddo
             else
                do i=1,3
                  do j=1,3
                    Re2t(i,j)=Re2(j,i)
                  enddo
                enddo
             endif
             do jj=1,nsym*2
                if(jj <= nsym) C(:,:)=kmat(jj,:,:)
                if(jj > nsym) C(:,:)=-kmat(jj-nsym,:,:)
                call MoltMatMat(rmi, Re1, M1Re1) ! rmi . Re1
                call MoltMatMat(rm,C, MRc) !  rm . C
                call MoltMatMat(MRc,M1Re1,MRcM1Re1)
                dist = 0.0
                do n = 1,3
                   do ii=1,3
                     dist = dist + (Re2t(n,ii)-MRcM1Re1(n,ii))**2
                   enddo
                enddo
                dist = sqrt(dist)
                write(6,*) 'dist',jj,dist
                if(dist < distmin ) then
                  distmin=dist
                endif
             enddo
           enddo

           icont=icont+1
           VectorDist(i1,i2)=distmin
           if(distmin<distmintot) distmintot=distmin
           if(distmin>distmaxtot) distmaxtot=distmin
           write(6,*) 'eccolo',i1,distmin
        enddo
      enddo
!
      do i1=1,numbComb1
        do i2=1,numbComb2
          dist=VectorDist(i1,i2)
          rho=(dist-distmintot)/(distmaxtot-distmintot)
          if(rho<0.2) then
            Re1_sol1=combHelix(i1)%Sol1
            Re1_sol2=combHelix(i1)%Sol2
            Re2_sol1=combRemoRot(i2)%Sol1
            Re2_sol2=combRemoRot(i2)%Sol2
            write(6,*) 'selezionato',rho,dist
            write(6,*) '            helix: ',Re1_sol1,Re1_sol2
            write(6,*) '            MR: ',Re2_sol1,Re2_sol2
          endif
        enddo
      enddo
!
      return
      end

