!-----------------------------------------------------------------------
!      HISTOGRAM MATCHING PROCEDURE (THEORETICAL)
!-----------------------------------------------------------------------
      subroutine InitHistMatchTheo(ntot)
      USE General
      USE Riflessi
      USE HistoStuff
      USE PhaseModule
      USE RemoModule

!
! -- attenzione: riempire sempre il vettore di appoggio
! -- operazioni fatte solo la prima volta
! -- determino il numero minimo di riflessi per intervallo
!
        vetmatchin(:) = 0.0
        if ( ntot < 0) then
!--chiamata da phase (DSR)
!         if (ksize.le.3) then
!           nwizmT=15   
!         else
!           nwizmT=25  
!         endif
          if (ksize == 1) then
              nwizmT=10  ! micro
          elseif (ksize < 4) then
              nwizmT=15  ! small/medium
          else
              nwizmT=25  ! proteins
          endif

          nden =  nstr / 10
          nsipT = nreflTot / nden
c         if(nsipT > 498) nsip = 498  ! numero di intervalli  - max. 500
          if(nsipT > 400) nsipT = 400  ! numero di intervalli  - max. 500
 15       nwizT=nint(float(nreflTot)/float(nsipT))
*         nsipT=nint(float(nreflTot)/float(nwizT))
          if (nwizT.lt.nwizmT) then
             nsipT=nint(float(nsipT)/2.0)
             goto 15
          end if
        else
c--chiamata da Patterson
          nsipT = 10 
          if (ntot < nsipT) then
             if (ntot == 0) then
                 call cstop(' ')
             elseif (ntot == 1) then
                  return
             else
                  nsipT=ntot
             endif
          else
             nwizmT=2  
 16          awizT=float(ntot)/float(nsipT)
             nwizT=nint(awizT)
             nsipT=nint(float(ntot)/awizT)
             if (nwizT.lt.nwizmT) then
                 nsipT=nint(float(nsipT)/1.5)
                 goto 16
             end if
          endif
        endif
!??!      nwizlT=nreflT-nwizT*(nsipT-1)   ! da aggiungere  ??? 
c
c---- divide la curva teorica in aree uguali
c
        xoss_Theo(1:nsipT+2)=0.0
        att = 0.0
        btt = 4.5
        call dividere(att,btt)
c
      return
      end
!-----------------------------------------------------------------------
      subroutine InitGiw()
      USE General
      USE Symmetry
      USE Atomi
      USE MadModule
c
      dimension na(18)
!
      na(:) = nw(:)
      gis(:) = 0.0
!
!-- calculate wilson (giw) and debye (gis) scattering factors
!
      iniz = 1
      ifin = nk
      do i=1,560
         t      = 0.01 * float(i-1)
         tt     = t * t
         giw(i) = 0.0
         do j=iniz,ifin
            fz = ScattFact60(j, tt)
            gis(i) = gis(i) + fz * fz * float(na(j))
            fnw    = float(nw(j))
            giw(i) = giw(i) + fz * fz * fnw
         enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CalcolaPesiExp_DSR(numb,numbMax,chope,iAll)
      USE General
      USE Riflessi
      USE HistoStuff
      USE PhaseModule

c
c--applico l'HM rispetto alle curve teoriche degli E
c
      if(ifExpanded==1.and.iAll==0) then  
        numberToUse=nreflTot
      else
        numberToUse=numbMax 
      endif
c          
      icont=0
      do i=1,numberToUse ! default
        icont=icont+1
        vetmatchin(icont)=fcvet(i)  ! default
c       write(99,'(i8,4f15.2)') i,sqrt(rhov(i)),evet(i),fcvet(i),wt(i)
      enddo
      call HistMatchTheo(icont)
      icont=0
      do i=1,numberToUse ! default
        icont=icont+1
        fcvet(i)=vetmatchin(icont)  ! default
c       write(101,'(i8,4f15.2)') i,sqrt(rhov(i)),evet(i),fcvet(i),wt(i)
      enddo

!DEDI  iTypeFunCT1 = 4 !HM con la funzione P(E)
!DEDI  work1(1:nunberToUse) = fcvet(1:nunberToUse)  ! Ecalc in ingresso ; Emod in uscita
!DEDI  work2(1:nunberToUse) = evet(1:nunberToUse)  ! non usato
!DEDI  if (ksize < 3) then
!DEDI      nwizm1=15  ! small
!DEDI  else
!DEDI      nwizm1=25  ! ksize > 3
!DEDI  endif
!DEDI  nden =  nstr / 10
!DEDI  nsip1 = nrefl / nden
!DEDI  nsip1 = min(nsip1,400)
!DEDI  call HistogramMatch(work1,work2,nunberToUse,nsip1,nwizm1,1)
!DEDI  fcvet(1:nunberToUse) = work1(1:nunberToUse)

c
c--calcolo i pesi per lo shell interno
c
      nnmm = nMicro/2 + 1
      nopeso = 0
      if(indiceMicro.eq.nnmm.and.no(nk).lt.20.and.LowRes.eq.1) nopeso=1
      if(indiceMicro.eq.nnmm.and.iwei.eq.0) nopeso=1

      do i=1,numbMax 
         EOss = evet(i)
         ECal = fcvet(i)
         SimW = chope * EOss * ECal
         if(nopeso.eq.1) then
             SimW = chope
         endif
         work1(i) = SimW
         work2(i) = SimW
c        wSimW = bes(SimW) 
c        if(nit.eq.4) coef = exp(0.1*2*sqrt(rhov(i))*resm)
c        wSimW = min(wSimW * coef,1.0)
c        work1(i) = wSimW
c        work2(i) = work1(i)
      enddo

c
c--seleziono i riflessi migliori
c
      if (iAll.eq.0) then
        call sortall(-1,work1,numbMax)
*       ncond1 = numb + nit * iDelta
        ncond1 = numb + indiceMicro * iDelta
        sog = work1(ncond1)
        if (ncond1.gt.numbMax) sog=0.0
  
        sumesq=0.0
        sumesq1=0.0
        npresimio=0
        do i=1,numbMax
          if (work2(i).lt.sog) then
             wt(i) = 0.0
           else
             wt(i) = bes ( work2(i) )
             npresimio=npresimio+1
             sumesq=sumesq+wt(i)*fcvet(i)
             sumesq1=sumesq1+wt(i)
          endif
        enddo
c--deb
        if(kverbo>0) then
        write(6,'(a,i12,2f8.2)') 'occhio1',npresimio,
     &      float(npresimio)/float(numbMax),sumesq/sumesq1
        endif
c--deb
c
c--calcolo i pesi per lo shell esterno
c
        if(ifExpanded==1) then
c     if(Iterazione==4) then
c     do  i=1,nrefl
c         write(4,111) khl(1:3,i),fovet(i),sigmav(i),evet(i),fcvet(i),
c    *                      float(iphaz(i)),float(ipub(i)),wt(i)
c     enddo
c111      format(3i4,7f8.2)
c     call toflush()
c     stop
c     endif

          call sigmaAA(fcvet,nreflTot) 
          do i=nrefl+1, numberToUse
            ii=i-nrefl
            EOss = fcvet(i)
            ECal = fcvet(i)
            SimW = chope * EOss * ECal
c           work1(ii) = SimW
            work1(ii) = SimW/work1(ii)
!           if(Iterazione==2) then
!              work2(ii) = 2.*SimW/(1+work1(ii))
!           else
               work2(ii) = SimW
!           endif
          enddo
          numbM=ii
          call sortall(-1,work1,numbM)
c
c--vario linearmente la percentuale in base al numero di microciclo
c
c         x=nit
c         x1=1
c         x2=nninv2  ! microcicli
c         y1=0.05  ! microcicli
c         y2=0.3   ! microcicli
c         call varlinear(x,x1,x2,y,y1,y2)
c         percsog=y
c         ncond1 = percsog * float(numbM)
          ncond1 = 0.5*(nstr + indiceMicro * iDelta)  ! default
          sog = work1(ncond1)
c
          npresimio=0
          sumesq=0.0
          sumesq1=0.0
          resfin = 0.5/sqrt(rhov(nreflTot))
          do i=nrefl+1,numberToUse
            ii = i-nrefl
            if(work2(ii).lt.sog) then
               wt(i) = 0.0
            else
c              if(resfin > 1.0 ) then
                 wt(i) = bes( work2(ii) )
c              else
c                wt(i) = bes( work2(ii) )**2
c              endif
               evet(i)=fcvet(i)  
               npresimio=npresimio+1
               sumesq = sumesq + wt(i)*fcvet(i)
               sumesq1 = sumesq1 + wt(i)
            endif
          enddo
c--deb
          if(kverbo>0) then
            write(6,'(a,i12,2f8.2)') 'occhio2',npresimio,
     &          float(npresimio)/float(numbM),sumesq/sumesq1
          endif
c--deb
c
        endif
      else
        do i=1,numbMax  ! default  (comunque e' ininfluente)
           wt(i) = bes ( work2(i) )
        enddo
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine CalcolaPesi_Exp(numbMax,chope,percsog,nexpand)
      USE General
      USE Symmetry
      USE Riflessi
      USE HistoStuff
!
      USE PhaseModule
      common/freeL/sumInt,sumExt
c
c--applico l'Histogram Matching ai riflessi dello shell esterno
c
      icont=0
      cut=0
      call preHistMatchTheo(1,numbMax,cut)  
      do i=1,numbMax
        if(fcvet(i)<cut) cycle
        icont=icont+1
        vetmatchin(icont)=fcvet(i)
      enddo
      call HistMatchTheo(icont)
      icont=0
      do i=1,numbMax
        if(fcvet(i)<cut) cycle
        icont=icont+1
        fcvet(i)=vetmatchin(icont)
      enddo
c
c--calcolo i pesi per lo shell interno
c
      sumesq=0.0
      sumesq1=0.0
      do i=1,nrefl  
c--commentando queste righe si risolve la cramb
         EOss = evet(i)
         ECal = fcvet(i)  
         SimW = chope * EOss * ECal   
         wt(i) =  bes( SimW )
         if (wt(i) < 0.001) wt(i) = 0.0
         sumesq = sumesq + wt(i)*fcvet(i)
         sumesq1 = sumesq1 + wt(i)
      enddo
c--deb
      if(kverbo>0) then
        write(6,'(a,i12,2f8.2)') 'Occhio1',nrefl,
     &      float(nrefl)/float(nrefl),sumesq/sumesq1
      endif
      sumInt=sumesq/sumesq1
c--deb
c
c--calcolo i pesi per lo shell esterno, selezionando una percentuale
c  di riflessi da prendere
c
c--introduco la stima probabilistica del modulo esterno
c
      call sigmaAA(fcvet,numbMax) 
c
      do i=nrefl+1, numbMax
         ii=i-nrefl
         EOss = fcvet(i) 
         ECal = fcvet(i) 
         SimW =  chope * EOss * ECal  
         work1(ii) = SimW/work1(ii)
         work2(ii) = SimW
         sigmav(i)=work1(ii) 
      enddo
      numbM=ii
      call sortall(-1,work1,numbM)
      ncond1 = percsog * float(numbM)
      sog = work1(ncond1)
c
      npresimio=0
      sumesq=0.0
      sumesq1=0.0
      do i=nrefl+1,numbMax
        ii = i-nrefl 
!       if(work2(ii).lt.sog) then   ! gianluca 6/3/2012
        if(work1(ii).lt.sog) then
           wt(i) = 0.0
        else
           wt(i) = bes( work2(ii) )
           npresimio=npresimio+1
           sumesq = sumesq + wt(i)*fcvet(i)
           sumesq1 = sumesq1 + wt(i)
        endif
      enddo
c--deb
      if(kverbo>0) then
        write(6,'(a,i12,2f8.2)') 'Occhio2',npresimio,
     &       float(npresimio)/float(numbM),sumesq/sumesq1
      endif
      sumExt=sumesq/sumesq1
c--deb
c
      return
      end
!-----------------------------------------------------------------------
      subroutine F2E()
c
      USE General
      USE Symmetry
      USE Riflessi
c
c--trasformo gli F calcolati in E osservati per i riflessi generati
c  (per gli altri il valore di E osservato l'ho gia')
!          utilizza fcvet --> fcvetv
c
      do i=nrefl+1,nreflTot
         fo = fcvet(i)
         rho = rhov(i)
         eps=epsv(i)
         multi=mult(i)
         ff0   = fo * fo / pts
         sinth=100.0*sqrt(rho)
         ind=max0(2,int(sinth+1.5))
         frac=sinth-float(ind-1)
         bf=0.5*(giw(ind+1)-giw(ind-1))
         af=bf+giw(ind-1)-giw(ind)
         form=af*frac*frac+bf*frac+giw(ind)
         denor=form*eps
         ed = ff0/denor
         esq=sc*ed*exp(2.*bt*rho)
c           write(687,'(i10,4f15.8)') i,fovet(i),evet(i),sqrt(esq),
c    &                  0.5/sqrt(rho)
         fcvetv(i)=sqrt(esq)
      enddo
c
      return
      end
!-----------------------------------------------------------------------
      subroutine E2F()
c
      USE General
      USE Symmetry
      USE Riflessi
!
!-- trasformo gli E calcolati in F osservati per i riflessi generati
!          utilizza fcvet --> fovet
!
!     sumfo = 0.0
!     sumfc = 0.0
      do i=nrefl+1, nreflTot
         ec    = fcvet(i)
         ec2   = ec * ec
         rho   = rhov(i)
         eps   = epsv(i)
         multi = mult(i)
         sinth = 100.0 * sqrt(rho)
         ind   = max0( 2, int(sinth + 1.5) )
         frac  = sinth - float( ind - 1 )
         bf    = 0.5 * ( giw(ind+1) - giw(ind-1) )
         af    = bf + giw(ind-1) - giw(ind)
         sigma = af * frac * frac + bf * frac + giw(ind)
         denor = sc * exp( 2.0 * bt * rho )
         fo    = sqrt( ec2 * pts * eps * sigma / denor )
         fovet(i) = fo
!        sumfo = sumfo + fo
!        sumfc = sumfc + worko(i)
!        risol = 0.5 / sqrt(rho)
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine E2Fnew1()
c
      USE General
      USE Symmetry
      USE Riflessi
!
!-- trasformo gli E calcolati in F osservati per i riflessi generati
!          utilizza fcvet --> fovet
!
c     iniz = nrefl+Added
      iniz = nrefl

      do i=iniz+1, nreflTot
         ec    = fcvet(i)
         ec2   = ec * ec
         rho   = rhov(i)
         eps   = epsv(i)
         multi = mult(i)
         sinth = 100.0 * sqrt(rho)
         ind   = max0( 2, int(sinth + 1.5) )
         frac  = sinth - float( ind - 1 )
         bf    = 0.5 * ( giw(ind+1) - giw(ind-1) )
         af    = bf + giw(ind-1) - giw(ind)
         sigma = af * frac * frac + bf * frac + giw(ind)
         denor = sc * exp( 2.0 * bt * rho )
         fo    = sqrt( ec2 * pts * eps * sigma / denor )
! ???         fovet(i) = fo       ???
              fcoef(i) = fo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine E2F_and_R(erreExt)
c
      USE General
      USE Symmetry
      USE Riflessi
!
!-- trasformo gli E calcolati in F osservati per i riflessi generati
!
!     sumfo = 0.0
!     sumfc = 0.0
      do i=nrefl+1, nreflTot
         ec    = fcvet(i)
!        if (ec > eCalcMax) then
!            ec = eCalcMax
!            fcvet(i) = ec
!        endif
         ec2   = ec * ec
         rho   = rhov(i)
         eps   = epsv(i)
         multi = mult(i)
         sinth = 100.0 * sqrt(rho)
         ind   = max0( 2, int(sinth + 1.5) )
         frac  = sinth - float( ind - 1 )
         bf    = 0.5 * ( giw(ind+1) - giw(ind-1) )
         af    = bf + giw(ind-1) - giw(ind)
         sigma = af * frac * frac + bf * frac + giw(ind)
         denor = sc * exp( 2.0 * bt * rho )
         fo    = sqrt( ec2 * pts * eps * sigma / denor )
         fovet(i) = fo
!        sumfo = sumfo + fo
!        sumfc = sumfc + worko(i)
!        risol = 0.5 / sqrt(rho)

*        write(6,100) i,ind,fcvet(i),wt(i),risol,eps,pts,giw(ind),
*    *                af,bf,bt
  100    format(i5,')',i8,9f9.3)
      enddo
!     scala = sumfc / sumfo
!     sumfo = 0.0
!     sumdf = 0.0
!     do i=nrefl+1, nreflTot
!        scaled fo = scala * fovet(i)
!        sumfo = sumfo + scaled fo
!        sumdf = sumdf + abs( worko(i) - scaled fo )
!     enddo
!     erreExt = sumdf / sumfo
      erreExt =  1.0
!
      return
      end
c-------------------------------------------------------
      subroutine F2ENew1()
c
      USE General
      USE Symmetry
      USE Riflessi
c
c--trasformo gli F calcolati in E osservati per i riflessi generati
c  (per gli altri il valore di E osservato l'ho gia')
!          utilizza fcvet --> fcvetv
c
c--parte da utilizzare per mettere in scala gli fcvet dei riflessi esterni
c  con gli fovet iniziali
c
      sumfo=0.0
      sumfc=0.0
      do i=1,nrefl
c         write(688,*) i,fovet(i),fovet(i)/sqrt(sc),
c    &                  evet(i),0.5/sqrt(rhov(i))
        sumfo=sumfo+fovet(i)/sqrt(sc)
        sumfc=sumfc+fcvet(i)
      enddo

! dedi 13/5/10  -  se non uso known + modello non posso calcolare  fcvet e fcvetv (Fpub e Epub)
      if (sumfc < 0.0000001) return   

      scala = sumfo/sumfc
c----
      tot=0.0
      nww=0.0
      do i=1,nreflTot
         fcvetp(i) = fcvet(i)  ! memorizzo F calcolati da modello 
c        fo = fcvet(i)
         fo = fcvet(i)*scala
         rho = rhov(i)
         eps=epsv(i)
         multi=mult(i)
         ff0   = fo * fo / pts
         sinth=100.0*sqrt(rho)
         ind=max0(2,int(sinth+1.5))
         frac=sinth-float(ind-1)
         bf=0.5*(giw(ind+1)-giw(ind-1))
         af=bf+giw(ind-1)-giw(ind)
         form=af*frac*frac+bf*frac+giw(ind)
         denor=form*eps
         ed = ff0/denor
         esq=sc*ed*exp(2.*bt*rho)
c           write(687,'(i10,3f15.8)') i,fcvet(i),sqrt(esq),
c    &                  0.5/sqrt(rho)
         fcvetv(i)=sqrt(esq)
         multt = mult(i)
         tmul=float(multt)
         tot=tot+esq*tmul
         nww=nww+multt
      enddo
      tot=tot/float(nww)
      scala=1.0/tot
      fcvetv(nrefl+1:nreflTot)=fcvetv(nrefl+1:nreflTot)*sqrt(scala)
c
      return
      end
c-------------------------------------------------------
      subroutine F2E_New()
c
      USE General
      USE Symmetry
      USE Riflessi
c
c--trasformo gli F calcolati in E osservati per i riflessi generati
c  (per gli altri il valore di E osservato l'ho gia')
!          utilizza fcvet --> fcvetv
c
c--parte da utilizzare per mettere in scala gli fcvet dei riflessi esterni
c  con gli fovet iniziali
c
      sumfo=0.0
      sumfc=0.0
      do i=1,nrefl
!       sumfo=sumfo+fovet(i)/sqrt(sc)
        sumfo=sumfo+fovet(i)
        sumfc=sumfc+fcvet(i)
      enddo
c     do i=1,nreflTot
c       write(688,'(3i4,2f15.3)') khl(1:3,i),fcvet(i),0.1
c     enddo
c----
      tot=0.0
      nww=0.0
      do i=nrefl+1,nreflTot
c        fo = fcvet(i)
         fo = fcvet(i)*sumfo/sumfc
         rho = rhov(i)
         eps=epsv(i)
         multi=mult(i)
         ff0   = fo * fo / pts
         sinth=100.0*sqrt(rho)
         ind=max0(2,int(sinth+1.5))
         frac=sinth-float(ind-1)
         bf=0.5*(giw(ind+1)-giw(ind-1))
         af=bf+giw(ind-1)-giw(ind)
         form=af*frac*frac+bf*frac+giw(ind)
         denor=form*eps
         ed = ff0/denor
c        esq=sc*ed*exp(2.*bt*rho)
c        bmodi=min(bt,21.0)
c        bmodi=max(bmodi,15.0)
         bmodi=20.0
         esq=sc*ed*exp(2.*bmodi*rho)
         fcvetv(i)=sqrt(esq)
         multt = mult(i)
         tmul=float(multt)
         tot=tot+sqrt(esq)*tmul
c        tot=tot+esq*tmul
         nww=nww+multt
      enddo
      tot=tot/float(nww)
      scala=0.886/tot
c     scala=1.0/tot
c     fcvetv(nrefl+1:nreflTot)=fcvetv(nrefl+1:nreflTot)*sqrt(scala)
      fcvetv(nrefl+1:nreflTot)=min(fcvetv(nrefl+1:nreflTot)*scala,5.0)
!     do i=1,nrefl
!       write(688,'(3i4,f15.3)') khl(1:3,i),evet(i)
!     enddo
c     do i=1+nrefl,nreflTot
c       write(688,'(3i4,f15.3)') khl(1:3,i),fcvetv(i)
c     enddo

      summa=0.0
      do i=nrefl+1,nreflTot
         summa=summa+fcvetv(i)
      enddo
      write(lo,*)'SUMMA',summa/float(nreflTot-nrefl),bt,bmodi
      return
      end
!-----------------------------------------------------------------------
!      HISTOGRAM MATCHING PROCEDURE
!-----------------------------------------------------------------------
      subroutine HistMatchTheo(ntot)
c
      USE General
      USE Riflessi
      USE HistoStuff
      USE PhaseModule
c
      if (ntot == 1) then
          vetmatchin(1)=4.0
          return
      endif
c
c--carica i dati sperimentali
c
      do i=1,ntot
         hisobco(1,i)=vetmatchin(i)
         hisobco(2,i)=float(i)
      enddo
c
c--ordina i dati sperimentali
c
      call sortall2(hisobco,2,1,ntot,ntot,-1)
      rmin= hisobco(1,1)
      rmax= hisobco(1,ntot)
c
c--fa l'istogramma dei dati sperimentali
c
      xcalc(1:nsipT+2)=0.0
      xcalc(1)=rmin
      xcalc(nsipT+1)=rmax
c
      nwizT=nint(float(ntot)/float(nsipT))
      nwizlT=ntot-nwizT*(nsipT-1)
c     write(lo,*) 'HISMATCH',nit
c
c--deb
c     if(kverbo>0) then
!       write(lo,1000) ntot
!1000   format (10x,'Nr. of reflections ..............',i6)
C       write(lo,1000) nsipT,nwizT,nwizlT,ntot,rmax
C1000   format (10x,'Nr. of areas ....................',i6,/,
C    +        10x,'Nr. of ref. in one area .........',i6,/,
C    +        10x,'Nr. of ref. in the first area ...',i6,/,
C    +        10x,'Nr. of reflections ..............',i6,/,
C    +        10x,'rmax.............................',f8.2)
c     endif
c--deb
c
      ic=0
      ii=1
      do i=1,ntot
        if (ii.eq.1) then
            nwizjT=nwizlT
        else
            nwizjT=nwizT
        endif
        ic=ic+1
        if (ic.eq.nwizjT) then
           ii=ii+1
           xcalc(ii)=hisobco(1,i)
           ic=0
        endif
      enddo
c
c---  shift la curva exp.
c
      call match12_Theo()
c
c---  calc. nuovi valori osservati
c
      call newvalue_Theo(hisobco,hiscaco,ntot)
c--deb     
c     do i=1,nsipT+2
c       write(6,'(i8,4f12.2)') i,ai(i),bi(i),xoss_Theo(i),xcalc(i)
c     enddo
c     do i=1,10
c       write(6,'(i6,2f15.4)')i,vetmatchin(i),hiscaco(1,i)
c     enddo
c     do i=ntot-10,ntot
c       write(6,'(i6,2f15.4)')i,vetmatchin(i),hiscaco(1,i)
c     enddo
c--deb     
c
      do i=1,ntot
        vetmatchin(i)=hiscaco(1,i)
      enddo
c
      return
      end
c------------------------------------------------------------
      subroutine match12_Theo()
      USE PhaseModule

!     write(6,*)'Match12_Theo'
      do 10 i=1,nsipT
         domin = xcalc(i+1)-xcalc(i)
         if (domin > 0.00000001) then
             ai(i) = (xoss_Theo(i+1)-xoss_Theo(i))/domin
             bi(i) = ((xoss_Theo(i)*xcalc(i+1))-
     *                (xoss_Theo(i+1)*xcalc(i)))/domin
         else
             ai(i) = 0.0
             bi(i) = 0.0
         endif
!        xhist(i)=ai(i)*xcalc(i)+bi(i)
!        xhist(i+1)=ai(i)*xcalc(i+1)+bi(i)
!        write(6,'(i4,5f10.5)')i,xcalc(i),xoss_Theo(i),ai(i),bi(i),xhist(i)
 10   continue
      return
      end
c------------------------------------------------------------
      function pd(x)
c
      call e_fun(x,y)
      if (y.lt.0) y=0.0
      pd=y
c
      return
      end
c------------------------------------------------------------
      subroutine dividere(at,bt)
      USE PhaseModule
c
      Si=0.0
      sumS=0.0
      sumSsp=0.0
      iqsim=0
      s=0.0
  10  call qsimp_expand(at,bt,s)
c
c     write(6,*)'Curva Teorica ,  S=',s
c
      stot=s
      sj=stot/float(nsipT)
      aj=at
      bj=bt
      bjp=bj
      j=1
  50  call qsimp_expand(aj,bj,s)
c     if(abs(s-sj).lt.1.e-6) then
      if(abs(s-sj).lt.1.e-4) then
c     if(abs(s-sj).lt.1.e-3) then
c     if(abs(s-sj).lt.1.e-2) then
         sums=sums+s
         sumssp=sumssp+abs(s-sj)
         xoss_Theo(j)=aj
         xoss_Theo(j+1)=bj
         j=j+1
         if(j.eq.nsipT) then
            xoss_Theo(j)=bj
            xoss_Theo(j+1)=bt
            sums=sums+s
            sumssp=sumssp+abs(s-sj)
c           write(6,*)'sumS=',sums,sumssp
            call toflush()
            goto 100
         endif
         aj=bj
         bj=bt
         goto 50
      else
         if(s.gt.sj) then
           bjp=bj
           bj = (aj+bj) /2.0
         else
           bj = (bj+bjp) /2.0
         endif
         goto 50
      end if
  100 continue
c
      return
      end
c-----------------------------------------------------------------------
c     Calcolo dei nuovi valori per HISOB (usare la scala-ai e lo shift-bi)
c-----------------------------------------------------------------------
      subroutine newvalue_Theo(hisobco,hiscaco,ntot)
c
      USE PhaseModule
      real hisobco(2,ntot),hiscaco(2,ntot)
c
      isip=2
      do i=1,ntot
        if(hisobco(1,i).le.xcalc(isip)) then
            hiscaco(1,i)=ai(isip-1)*hisobco(1,i)+bi(isip-1)
            hiscaco(2,i)=hisobco(2,i)
        else
            isip=isip+1
            hiscaco(1,i)=ai(isip-1)*hisobco(1,i)+bi(isip-1)
            hiscaco(2,i)=hisobco(2,i)
        endif
      enddo
c
      call sortall2(hiscaco,2,2,ntot,ntot,-1)
c
      return
      end
*----------------------------------------------------*
      subroutine e_fun(x,y)
c
      USE General
      USE PhaseModule
c
c     if(icentold==0) then
c--distribuzione acentrica
        arg=x**2 
        fact= 2*x
c     elseif(icentold==1) then
c--distribuzione centrica
c       arg=x**2/2.
c       fact= sqrt(2.0/pi)
c     endif
c
      y=fact*exp(-arg)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine qsimp_expand(a,b,s)
c
      parameter (eps=1.e-3, jmax=10)
c
      ost=-1.E30
      os= -1.E30
      yp1=1.E30
      ypn= 1.E30

      do j=1,jmax
        call trapzd_expand(a,b,st,j)
        s=(4.*st-ost)/3.
        if (abs(s-os).lt.eps*abs(os)) return
        os=s
        ost=st
      enddo
c
      return
      end
c----------------------------------------
      subroutine trapzd_expand(a,b,s,n)
c
      common /trapzdc/ it
c
      if (n.eq.1) then
          s=0.5*(b-a)*(pd(a)+pd(b))
          it=1
      else
          tnm=it
          del=(b-a)/tnm
          x=a+0.5*del
          sum=0.
          do j=1,it
            sum=sum+pd(x)
            x=x+del
          enddo
          s=0.5*(s+(b-a)*sum/tnm)
          it=2*it
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine preHistMatchTheo(numb1,numb2,cut)
      USE Riflessi
c
      aver=0.0
      anum=0.0
      amax=0.0
      do i=numb1,numb2
        aver=aver+fcvet(i)
        anum=anum+1.0
        if(fcvet(i)>amax) amax=fcvet(i)
      enddo
      aver=aver/anum
      cut=aver*0.1
      do i=numb1,numb2
        if(fcvet(i)<cut) fcvet(i)=0.0
      enddo
c
c     write(6,*) 'prehis',sqrt(cut),sqrt(amax)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine FlipDens()
!
      USE General   ! dritan
      USE Mappa
      USE PhaseModule
c
      call maxmin3d(denmin,denmax,avden,stden,npunt,0)
      if(kverbo>0) then
        write(6,*) 'denmin Flip',denmin,denmax,avden,stden
      endif
!
      pup = 2.0!liberato2009
      if(ResEff>sogResEff) pup = 1.0!liberato2009
      if(Iterazione>16.or.kWstop==1) pup = 0.0!liberato2009

      do ih = 0, np(1)-1
        do ik = 0, np(2)-1
          do il = 0, np(3)-1
!           xx = xmap(ih,ik,il)+abs(denmin)-2*stden
            xx = xmap(ih,ik,il)+abs(denmin)-pup*stden!liberato2009
!           if(xx<2*stden) then
            if(xx<pup*stden) then!liberato2009
!              xmap(ih,ik,il)=xmap(ih,ik,il)-2*xx
               xmap(ih,ik,il)=xmap(ih,ik,il)-pup*xx!liberato2009
            endif
          enddo
        enddo
      enddo


      return
      end
c-----------------------------------------------------------------------
      subroutine RiduciRippleOld()
!
      USE General
      USE Symmetry
      USE Mappa
      USE Atomi
      USE Molcom
      USE PhaseModule
c
c
!     if(iheavy==0) then
!!    if(iheavy==1) then
c       esponent=0.8
!!      esponent=0.9
!!    else
c       esponent=1.2
!!      esponent=1.01
!!    endif
      esponent=0.8!ultima mod.
      sumtot1=0.0
      sumtot2=0.0
c
      call maxmin3d(denmin,denmax,avden,stden,npunt,0)
      if(kverbo>0) then
        write(6,*) 'denmin RiduOld',denmin,denmax,avden,stden
      endif
c
      do ih = 0, np(1)-1
        do ik = 0, np(2)-1
          do il = 0, np(3)-1
            xx = xmap(ih,ik,il)+abs(denmin)
            sumtot1=sumtot1+xx
            xmap(ih,ik,il) = xx ** esponent
            sumtot2=sumtot2+xmap(ih,ik,il)
          enddo
        enddo
      enddo

c     call maxmin3d(denmin,denmax,avden,stden,npunt,0)
c     write(6,*) 'denmin',denmin,denmax,avden,stden
c
      scala=sumtot1/sumtot2
c     write(6,*) 'scala',scala,sumtot1,sumtot2

      sumtot2=0.0
      npunt1=0
      do ih = 0, np(1)-1
        do ik = 0, np(2)-1
          do il = 0, np(3)-1
            xx = xmap(ih,ik,il)
            xmap(ih,ik,il) = xx *scala 
            sumtot2=sumtot2+xmap(ih,ik,il)
            npunt1=npunt1+1
          enddo
        enddo
      enddo
      scala=sumtot2/float(npunt1)
c     write(6,*) 'scala1',scala,sumtot2,npunt1

c     call maxmin3d(denmin,denmax,avden,stden,npunt,0)
c     write(6,*) 'denmin',denmin,denmax,avden,stden

      do ih = 0, np(1)-1
        do ik = 0, np(2)-1
          do il = 0, np(3)-1
            xx = xmap(ih,ik,il)
            xmap(ih,ik,il) = xx - abs(scala)
          enddo
        enddo
      enddo
c
c     call maxmin3d(denmin,denmax,avden,stden,npunt,0)
c     write(6,*) 'denmin',denmin,denmax,avden,stden
c
      return
      end
c-----------------------------------------------------------------------
      subroutine RiduciRipple()
c
c--modifica la mappa in modo da eliminare gli errori di troncamento della serie
c
      USE General
      USE Symmetry
      USE Mappa
      USE Atomi
      USE Molcom
      USE PhaseModule
c
      esponent=1.3  
      wCentral=5.0
      wLateral=1.0
c
      call maxmin3d(denmin,denmax,avden,stden,npunt,0)
      write(6,*) 'start',denmin,denmax,avden,stden
c
      LimitSm=denmax*1.2
c
c-- stretching
c
c
c--porto la mappa al di sopra dello zero e la elevo a potenza
c
        sumtot1=0.0
        sumtot2=0.0
        do ih = 0, np(1)-1
          do ik = 0, np(2)-1
            do il = 0, np(3)-1
              xx = xmap(ih,ik,il)+abs(denmin)
              sumtot1=sumtot1+xx
              xmap(ih,ik,il) = xx ** esponent
              sumtot2=sumtot2+xmap(ih,ik,il)
c             write(6,'(a,3i4,2f20.3)') 'map',ih,ik,il,xx,xmap(ih,ik,il)
            enddo
          enddo
        enddo
c
c--riscalo la mappa in modo che abbia lo stesso integrale di quella di partenza
c
        scala=sumtot1/sumtot2
c       write(6,*) 'scala',scala,sumtot1,sumtot2
        sumtot2=0.0
        npunt1=0
        do ih = 0, np(1)-1
          do ik = 0, np(2)-1
            do il = 0, np(3)-1
              xx = xmap(ih,ik,il)
              xmap(ih,ik,il) = xx *scala 
              sumtot2=sumtot2+xmap(ih,ik,il)
              npunt1=npunt1+1
            enddo
          enddo
        enddo
c
c--riporto la mappa a media nulla
c
        shift=sumtot2/float(npunt1)
c       write(6,*) 'scala1',shift,sumtot2,npunt1
        do ih = 0, np(1)-1
          do ik = 0, np(2)-1
            do il = 0, np(3)-1
              xx = xmap(ih,ik,il)
              xmap(ih,ik,il) = xx - abs(shift)
            enddo
          enddo
        enddo
c
        call maxmin3d(denmin,denmax,avden,stden,npunt,0)
        write(6,*) 'stretching',denmin,denmax,avden,stden
c
        LimitNow=denmax
c
c--ricicli di smoothing
c
      do while(LimitNow>LimitSm)
c
c--faccio lo smoothing della mappa a media nulla
c
        do ih = 0, np(1)-1
          do ik = 0, np(2)-1
            do il = 0, np(3)-1
              xx=xmap(ih,ik,il)
              amaxmap=xx*wCentral
              acont=wCentral
              do i=-1,1,2
                ih2=ih+i
                if(ih2<0.or.ih2>np(1)-1) cycle
                xx=xmap(ih2,ik,il)
                amaxmap=amaxmap+xx*wLateral
                acont=acont+wLateral
c--deb
c             if(xmap(ih,ik,il)>70000) then
c                write(6,*) 'uffa1',acont,amaxmap,xx
c             endif
c--deb
              enddo
              do i=-1,1,2
                ik2=ik+i
                if(ik2<0.or.ik2>np(2)-1) cycle
                xx=xmap(ih,ik2,il)
                amaxmap=amaxmap+xx*wLateral
                acont=acont+wLateral
c--deb
c             if(xmap(ih,ik,il)>70000) then
c                write(6,*) 'uffa2',acont,amaxmap,xx
c             endif
c--deb
              enddo
              do i=-1,1,2
                il2=il+i
                if(il2<0.or.il2>np(3)-1) cycle
                xx=xmap(ih,ik,il2)
                amaxmap=amaxmap+xx*wLateral
                acont=acont+wLateral
c--deb
c             if(xmap(ih,ik,il)>70000) then
c                write(6,*) 'uffa3',acont,amaxmap,xx
c             endif
c--deb
              enddo
c--deb
c             if(xmap(ih,ik,il)>70000) then
c                write(6,*) 'uffa4',acont,amaxmap,amaxmap/acont
c             endif
c--deb
              xmap(ih,ik,il)=amaxmap/acont
            enddo
          enddo
        enddo
c
        call maxmin3d(denmin,denmax,avden,stden,npunt,0)
        write(6,*) 'smoothing',denmin,denmax,avden,stden
c
        LimitNow=denmax
c
      enddo
c
      return
      end
c------------------------------------------------------------------
      subroutine StatRMio()
c
c--confronta gli E calcolati (evet) con gli E osservati (fcvetv)
c
      USE General
      USE Symmetry
      USE Riflessi
      dimension nrf(30)
c
      nrefe=nreflTot
      erecum=0
c
      numint=10
c
c--calcola gli RE in intervalli di E osservato
c
      exmax=-999999.0
      exmin=999999.0
      do j=nrefl+1,nrefe
         if(wt(j)==0) cycle
         if(evet(j).gt.exmax) exmax=evet(j)
         if(evet(j).lt.exmin) exmin=evet(j)
      enddo
      eint=(exmax-exmin)/float(numint)
      write(lo,'(5x,3(a,5x),a,4x,a,4x,a)')
     *'Emin',' Emax',' |R_E|',' R_E cum.','NR','NR cum.'
      sumdfcum=0.0
      sumfccum=0.0
      do j=1,numint
        sumdf=0.0
        ere=0.0
        elim1=exmin+(j-1)*eint
        elim2=elim1+eint
        if(elim2.ge.(exmax-0.0001).and.elim2.le.(exmax+0.0001))
     *     elim2=exmax+0.0001
        sumfc=0.0
        sumdf=0.0
        numnn=0
        do k=nrefl+1,nrefe
          if(wt(k)==0) cycle
          if(evet(k).ge.elim1.and.evet(k).lt.elim2) then
            numnn=numnn+1
            sumdf=sumdf+abs( fcvetv(k)-evet(k) )
            sumfc=sumfc+fcvetv(k)
            sumdfcum=sumdfcum+abs( fcvetv(k)-evet(k) )
            sumfccum=sumfccum+fcvetv(k)
          endif
        enddo
        if(j.gt.1)then
          nrf(j)=numnn+nrf(j-1)
        else
          nrf(j)=numnn
        endif
        if(numnn.eq.0) cycle 
        if(sumfc.gt.0.0) ere=(sumdf/sumfc)*100.0
        if(sumfccum.gt.0.0) erecum=(sumdfcum/sumfccum)*100.0
        write(lo,'(4f10.3,2i10)') elim1,elim2,ere,erecum,numnn,nrf(j)
      enddo
c
c--calcola gli RE in intervalli di risoluzione
c
      ies=1
      if(ies==1) then
c
      exmax=-999999.0
      exmin=999999.0
      do j=nrefl+1,nrefe
         if(wt(j)==0) cycle
         ris=sqrt(rhov(j))
         if(ris.gt.exmax) exmax=ris
         if(ris.lt.exmin) exmin=ris
      enddo
      eint=(exmax-exmin)/float(numint)
      write(lo,'(5x,3(a,5x),a,4x,a,4x,a)')
     *'Rmin',' Rmax',' |R_E|',' R_E cum.','NR','NR cum.'
      sumdfcum=0.0
      sumfccum=0.0
      do j=1,numint
        sumdf=0.0
        ere=0.0
        elim1=exmin+(j-1)*eint
        elim2=elim1+eint
        if(elim2.ge.(exmax-0.0001).and.elim2.le.(exmax+0.0001))
     *     elim2=exmax+0.0001
        sumfc=0.0
        sumdf=0.0
        numnn=0
        do k=nrefl+1,nrefe
          if(wt(k)==0) cycle
          ris=sqrt(rhov(k))
          if(ris.ge.elim1.and.ris.lt.elim2) then
            numnn=numnn+1
            sumdf=sumdf+abs( fcvetv(k)-evet(k) )
            sumfc=sumfc+fcvetv(k)
            sumdfcum=sumdfcum+abs( fcvetv(k)-evet(k) )
            sumfccum=sumfccum+fcvetv(k)
          endif
        enddo
        if(j.gt.1)then
          nrf(j)=numnn+nrf(j-1)
        else
          nrf(j)=numnn
        endif
        if(numnn.eq.0) cycle 
        if(sumfc.gt.0.0) ere=(sumdf/sumfc)*100.0
        if(sumfccum.gt.0.0) erecum=(sumdfcum/sumfccum)*100.0
        write(lo,'(4f10.3,2i10)') elim1,elim2,ere,erecum,numnn,nrf(j)
      enddo
c
      endif
c
      return
      end
c---------------------------------------------------------------
      subroutine StatRMio1()
c
c--confronta gli F calcolati (fovet) con gli E osservati (worko)
c
      USE General
      USE Symmetry
      USE Riflessi
      dimension nrf(30)
c
      nrefe=nreflTot
c
      numint=10
      ere    = 999
      erecum = 999
c
c--calcolo la scala
c
c
c--calcola gli RE in intervalli di E osservato
c
      sumfo=0.0
      sumfo1=0.0
      exmax=-999999.0
      exmin=999999.0
      do j=nrefl+1,nrefe
         if(wt(j)==0) cycle
         if(fovet(j).gt.exmax) exmax=fovet(j)
         if(fovet(j).lt.exmin) exmin=fovet(j)
         sumfo=sumfo+worko(j)
         sumfo1=sumfo1+fovet(j)
      enddo
      scala=sumfo/sumfo1
      eint=(exmax-exmin)/float(numint)
      write(lo,'(5x,3(a,5x),a,4x,a,4x,a)')
     *'Fmin',' Fmax',' |R_F|',' R_F cum.','NR','NR cum.'
      sumdfcum=0.0
      sumfccum=0.0
      do j=1,numint
        sumdf=0.0
        ere=0.0
        elim1=exmin+(j-1)*eint
        elim2=elim1+eint
        if(elim2.ge.(exmax-0.0001).and.elim2.le.(exmax+0.0001))
     *     elim2=exmax+0.0001
        sumfc=0.0
        sumdf=0.0
        numnn=0
        do k=nrefl+1,nrefe
          if(wt(k)==0) cycle
          if(fovet(k).ge.elim1.and.fovet(k).lt.elim2) then
            numnn=numnn+1
            sumdf=sumdf+abs( worko(k)-scala*fovet(k) )
            sumfc=sumfc+worko(k)
            sumdfcum=sumdfcum+abs( worko(k)-scala*fovet(k) )
            sumfccum=sumfccum+worko(k)
          endif
        enddo
        if(j.gt.1)then
          nrf(j)=numnn+nrf(j-1)
        else
          nrf(j)=numnn
        endif
        if(numnn.eq.0) cycle 
        if(sumfc.gt.0.0) ere=(sumdf/sumfc)*100.0
        if(sumfccum.gt.0.0) erecum=(sumdfcum/sumfccum)*100.0
        write(lo,'(4f10.3,2i10)') elim1,elim2,ere,erecum,numnn,nrf(j)
      enddo
c
c--calcola gli RE in intervalli di risoluzione
c
      ies=1
      if(ies==1) then
c
      exmax=-999999.0
      exmin=999999.0
      do j=nrefl+1,nrefe
         if(wt(j)==0) cycle
         ris=sqrt(rhov(j))
         if(ris.gt.exmax) exmax=ris
         if(ris.lt.exmin) exmin=ris
      enddo
      eint=(exmax-exmin)/float(numint)
      write(lo,'(5x,3(a,5x),a,4x,a,4x,a)')
     *'Rmin',' Rmax',' |R_F|',' R_F cum.','NR','NR cum.'
      sumdfcum=0.0
      sumfccum=0.0
      do j=1,numint
        sumdf=0.0
        ere=0.0
        elim1=exmin+(j-1)*eint
        elim2=elim1+eint
        if(elim2.ge.(exmax-0.0001).and.elim2.le.(exmax+0.0001))
     *     elim2=exmax+0.0001
        sumfc=0.0
        sumdf=0.0
        numnn=0
        do k=nrefl+1,nrefe
          if(wt(k)==0) cycle
          ris=sqrt(rhov(k))
          if(ris.ge.elim1.and.ris.lt.elim2) then
            numnn=numnn+1
            sumdf=sumdf+abs( worko(k)-scala*fovet(k) )
            sumfc=sumfc+worko(k)
            sumdfcum=sumdfcum+abs( worko(k)-scala*fovet(k) )
            sumfccum=sumfccum+worko(k)
          endif
        enddo
        if(j.gt.1)then
          nrf(j)=numnn+nrf(j-1)
        else
          nrf(j)=numnn
        endif
        if(numnn.eq.0) cycle 
        if(sumfc.gt.0.0) ere=(sumdf/sumfc)*100.0
        if(sumfccum.gt.0.0) erecum=(sumdfcum/sumfccum)*100.0
        write(lo,'(4f10.3,2i10)') elim1,elim2,ere,erecum,numnn,nrf(j)
      enddo
c
      endif
c
      return
      end
!---------------------------------------------------------------
      subroutine StatRpub(ief)
!
!--confronta gli E/F calcolati da modello (work1) con gli E/F estrapolati (work2)
!
      USE General
      USE Symmetry
      USE Riflessi
      dimension nrf(30)
!
      nrefe=nreflTot
      nrefe=nrefl+Added
!
      numint=10
      ere    = 999
      erecum = 999
!
!--calcolo la scala
!
!
!--calcola gli RE/F in intervalli di E/F osservato
!
      ies = 0 
      if (ies == 1) then
!
      nrf(:) = 0
      sumfo=0.0
      sumfo1=0.0
      exmax=-999999.0
      exmin=999999.0
      do j=nrefl+1,nrefe
         if(tmpwt(j)==0) cycle
         if(work1(j).gt.exmax) exmax=work1(j)
         if(work1(j).lt.exmin) exmin=work1(j)
         sumfo=sumfo+work2(j)
         sumfo1=sumfo1+work1(j)
      enddo
      eint=(exmax-exmin)/float(numint)
      scala=sumfo/sumfo1

      if (ief == 1) then   !  F pubbl.
         write(lo,'(5x,3(a,5x),a,4x,a,4x,a)')
     *   'Fmin',' Fmax',' |R_F|',' R_F cum.','NR','NR cum.'
      elseif (ief == 0) then
         scala=1.0   !  E pubbl.
         write(lo,'(5x,3(a,5x),a,4x,a,4x,a)')
     *   'Emin',' Emax',' |R_E|',' R_E cum.','NR','NR cum.'
      endif


      sumdfcum=0.0
      sumfccum=0.0
      do j=1,numint
        sumdf=0.0
        ere=0.0
        elim1=exmin+(j-1)*eint
        elim2=elim1+eint
        if(elim2.ge.(exmax-0.0001).and.elim2.le.(exmax+0.0001))
     *     elim2=exmax+0.0001
        sumfc=0.0
        sumdf=0.0
        numnn=0
        do k=nrefl+1,nrefe
          if(tmpwt(k)==0) cycle
          if(work1(k).ge.elim1.and.work1(k).lt.elim2) then
            numnn=numnn+1
            sumdf=sumdf+abs( work2(k)-scala*work1(k) )
            sumfc=sumfc+work2(k)
            sumdfcum=sumdfcum+abs( work2(k)-scala*work1(k) )
            sumfccum=sumfccum+work2(k)
          endif
        enddo
        if(j.gt.1)then
          nrf(j)=numnn+nrf(j-1)
        else
          nrf(j)=numnn
        endif
        if(numnn.eq.0) cycle 
        if(sumfc.gt.0.0) ere=(sumdf/sumfc)*100.0
        if(sumfccum.gt.0.0) erecum=(sumdfcum/sumfccum)*100.0
        write(lo,'(4f10.3,2i10)') elim1,elim2,ere,erecum,numnn,nrf(j)
      enddo
!
      endif
!
!--calcola gli RE/F in intervalli di risoluzione
!
      ies=1
      if(ies==1) then
!
      write(lo,*) 
!
      nrf(:) = 0
      sumfo=0.0
      sumfo1=0.0
      exmax=-999999.0
      exmin=999999.0
      do j=nrefl+1,nrefe
         if(tmpwt(j)==0) cycle
         ris=0.5/sqrt(rhov(j))
         if(ris.gt.exmax) exmax=ris
         if(ris.lt.exmin) exmin=ris
         sumfo=sumfo+work2(j)
         sumfo1=sumfo1+work1(j)
      enddo
      eint=(exmax-exmin)/float(numint)
      scala=sumfo/sumfo1

      if (ief == 1) then   !  F pubbl.
          write(lo,'(5x,3(a,5x),a,4x,a,4x,a)')
     *    'Rmin',' Rmax',' |R_F|',' R_F cum.','NR','NR cum.'
      else
          write(lo,'(5x,3(a,5x),a,4x,a,4x,a)')
     *    'Rmin',' Rmax',' |R_E|',' R_E cum.','NR','NR cum.'
      endif

      sumdfcum=0.0
      sumfccum=0.0
      do j=1,numint
        sumdf=0.0
        ere=0.0
        elim1=exmin+(j-1)*eint
        elim2=elim1+eint
        if(elim2.ge.(exmax-0.0001).and.elim2.le.(exmax+0.0001))
     *     elim2=exmax+0.0001
        sumfc=0.0
        sumdf=0.0
        numnn=0
        do k=nrefl+1,nrefe
          if(tmpwt(k)==0) cycle
          ris=0.5/sqrt(rhov(k))
          if(ris.ge.elim1.and.ris.lt.elim2) then
            numnn=numnn+1
            sumdf=sumdf+abs( work2(k)-scala*work1(k) )
            sumfc=sumfc+work2(k)
            sumdfcum=sumdfcum+abs( work2(k)-scala*work1(k) )
            sumfccum=sumfccum+work2(k)
          endif
        enddo
        if(j.gt.1)then
          nrf(j)=numnn+nrf(j-1)
        else
          nrf(j)=numnn
        endif
        if(numnn.eq.0) cycle 
        if(sumfc.gt.0.0) ere=(sumdf/sumfc)*100.0
        if(sumfccum.gt.0.0) erecum=(sumdfcum/sumfccum)*100.0
        write(lo,'(4f10.3,2i10)') elim1,elim2,ere,erecum,numnn,nrf(j)
      enddo
!
      endif
!
      return
      end
!------------------------------------------------------------------------------
      subroutine StatRfac_ExtAdd(ier)

      USE General
      USE Riflessi

      character ttirang*80


! -- per statistiche di confronto su Extra (solo riflessi coincidenti con Added) 

      tmpwt(:) = fcvet(:) !salvo gli F estrapolati
      work1(:) =  0.0
      work2(:) =  0.0
      worko(:) =  0.0
      do i=nrefl+1,nrefl+Added
         if((ResEff-resm)/resm<0.065) then
         worko(i) = fcvet(i)
         else
           risolu=0.5/sqrt(rhov(i))
           if(risolu<=resm) then
            worko(i)=fcvet(i)*0.5
           else
            worko(i)=fcvet(i)*(Min(0.5,0.5+float(Iterazione-4)*0.25))
           endif
         endif
         work1(i) = 0.5 / sqrt(rhov(i))
*        work2(i) = 1.0
         if (work1(i) < 1.80) then   ! prova con file Pt3_hUb_sftools1.mtz
             work2(i) = 1.0
         endif
      enddo

      fcvet(:) = worko(:) !per il calcolo degli F estrapolati
      fcoef(:) =  0.0
      call E2Fnew1()    ! calcolo F per estrapolati da E (in fcoef)

      write(6,*) ' *** Ext-pub vs Resol  (Added) ***'
      ttirang = 'RE ext-pub'
      nRefBin = 10
      iniz = nrefl+1
      ifin = nrefl+Added
      call GetStatRfac(ttirang,work1,worko,fcvetv,ifin,iniz,
     *     work2,nRefBin,0.0)

c     ttirang = 'RF ext-pub'
c     nRefBin = 10
c     iniz = nrefl+1
c     ifin = nrefl+Added
c     call GetStatRfac(ttirang,work1,fcoef,fcvetp,ifin,iniz,
c    *     work2,nRefBin,0.0)

      write(6,*) ' *** Ext-pub vs E/Fext  (Added) ***'
      ttirang = 'RE ext-pub'
      nRefBin = 10
      iniz = nrefl+1
      ifin = nrefl+Added
      call GetStatRfac(ttirang,worko,worko,fcvetv,ifin,iniz,
     *     work2,nRefBin,0.0)

c     ttirang = 'RF ext-pub vs Fext'
c     nRefBin = 10
c     iniz = nrefl+1
c     ifin = nrefl+Added
c     call GetStatRfac(ttirang,fcoef,fcoef,fcvetp,ifin,iniz,
c    *     work2,nRefBin,0.0)

      fcvet(:) = tmpwt(:) !ripristino gli F estrapolati
      fcoef(:) = 0.0
!
      return
      end
!------------------------------------------------------------------------------
      subroutine StatRfac_ExtPub(ier)

      USE General
      USE Riflessi

      character ttirang*80


! -- per statistiche di confronto Extra - Pubb

      work1(:) =  0.0
      work2(:) =  0.0
      worko(:) =  0.0
      tmpwt(:) =  1.0
      nnn = 0 
      do i=nrefl+Added+1,nreflDim
         worko(i) = 0.5 / sqrt(rhov(i))
         if (worko(i) > 2.0) then
             work1(i) = 1.0
             nnn = nnn + 1
         else
             work2(i) = 1.0
         endif
      enddo

c     fcvet(:) = evet(:) !per il calcolo degli F estrapolati
c     fcoef(:) =  0.0
c     call E2Fnew1()    ! calcolo F per estrapolati da E (in fcoef)

      write(6,*) ' *** Ext-pub vs Resol  ***'
      ttirang = 'RE ext-pub'
      nRefBin = 10
      iniz = nrefl+Added+1
      ifin = nreflDim
      call GetStatRfac(ttirang,worko,evet,fcvetv,ifin,iniz,
     *     tmpwt,nRefBin,0.0)
      if (nnn > 0) then
          ttirang = 'RE ext-pub'
          nRefBin = 5
          iniz = nrefl+Added+1
          ifin = nreflDim
          call GetStatRfac(ttirang,worko,evet,fcvetv,ifin,iniz,
     *         work1,nRefBin,0.0)
          ttirang = 'RE ext-pub'
          nRefBin = 10
          iniz = nrefl+Added+1
          ifin = nreflDim
          call GetStatRfac(ttirang,worko,evet,fcvetv,ifin,iniz,
     *         work2,nRefBin,0.0)
      endif


c     ttirang = 'RF ext-pub'
c     nRefBin = 10
c     iniz = nrefl+Added+1
c     ifin = nreflDim
c     call GetStatRfac(ttirang,work1,fcoef,fcvetp,ifin,iniz,
c    *     work2,nRefBin,0.0)

      work1(:) =  0.0
      work2(:) =  0.0
      worko(:) =  0.0
      tmpwt(:) =  1.0
      do i=nrefl+Added+1,nreflDim
         if (evet(i) > 2.0) then
             work1(i) = 1.0
         elseif (evet(i) <= 2.0 .and. evet(i) > 1.0) then
             work2(i) = 1.0
         else
             worko(i) = 1.0
         endif
      enddo

      write(6,*) ' *** Ext-pub vs E/Fext  ***'
      ttirang = 'RE ext-pub'
      nRefBin = 10
      iniz = nrefl+Added+1
      ifin = nreflDim
      call GetStatRfac(ttirang,evet,evet,fcvetv,ifin,iniz,
     *     tmpwt,nRefBin,0.0)
      ttirang = 'RE ext-pub'
      nRefBin = 5
      iniz = nrefl+Added+1
      ifin = nreflDim
      call GetStatRfac(ttirang,evet,evet,fcvetv,ifin,iniz,
     *     work1,nRefBin,0.0)
      ttirang = 'RE ext-pub'
      nRefBin = 10
      iniz = nrefl+Added+1
      ifin = nreflDim
      call GetStatRfac(ttirang,evet,evet,fcvetv,ifin,iniz,
     *     work2,nRefBin,0.0)
      ttirang = 'RE ext-pub'
      nRefBin = 10
      iniz = nrefl+Added+1
      ifin = nreflDim
      call GetStatRfac(ttirang,evet,evet,fcvetv,ifin,iniz,
     *     worko,nRefBin,0.0)
!     ttirang = 'RE pub-ext'
!     call GetStatRfac(ttirang,fcvetv,evet,fcvetv,ifin,iniz,
!    *     work2,nRefBin,0.0)

c     ttirang = 'RF ext-pub'
c     nRefBin = 10
c     iniz = nrefl+Added+1
c     ifin = nreflDim
c     call GetStatRfac(ttirang,fcoef,fcoef,fcvetp,ifin,iniz,
c    *     work2,nRefBin,0.0)
c     ttirang = 'RF pub-ext'
c     call GetStatRfac(ttirang,fcvetp,fcoef,fcvetp,ifin,iniz,
c    *     work2,nRefBin,0.0)

      fcoef(:) = 0.0
!
      return
      end
!---------------------------------------------------------------------
      subroutine NewExpand(numbPhased,ResIniz,ResFin)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE Mappa
      USE MappaPatterson  ! per FinalFom
      USE PhaseModule
      Use Param
!
      common/freeL/sumInt,sumExt
!
      character tirang * 11
      character line * 80
      integer, allocatable :: iphazo1(:)
c
      IF (.NOT. ALLOCATED(iphazo1))
     &          ALLOCATE (iphazo1(1:nrefl),stat = ier)
      call AllocaMappaPatterson(1)
c
c--introduco gli switches di risoluzione
c
      if(ResIniz<=1.6) then
        irescut=1    ! <1.6 --> 1.0
      elseif(ResIniz>1.6.and.ResIniz<=2.0) then
        irescut=2    ! 1.6-1.8 --> 1.2
      else
        irescut=3    ! >2.0 --> 1.8
      endif
c
      numbLSQ=numbPhased
      coef = 0.0
      ifEnve = 1
      EnvePronta = 0
      RenveStart = ResIniz+6   
      if(irescut==1) RenveStart = 6.0
      RenveDyn = RenveStart 
      if (knw == 1) then
          write(lo,200)
          isum = sum(ipub(nrefl+1:nreflTot))
          if (isum > 0) then
              knwExt = 1 
              write(lo,250)
          else 
              knwExt = 0 
              write(lo,120)
          endif 
      else 
          knwExt = 0 
      endif 
      numberToUse=nreflTot
      invflag = 1  
      ifExpanded = 0
      OldFinalFom=-99999.
      wt(nrefl+1:nreflTot)=0.0
c
c--memorizzo le fasi e i pesi iniziali per la combinazione
 
      if (irescut>1) then
          iphazo(1:nrefl) = iphaz(1:nrefl)
          worko(1:nrefl)  = wt(1:nrefl)
      endif
!
      if (ifEnve.eq.1) then
          jpatt = 0
          call Long_Env_New(nrefl, jpatt)
          EnvePronta = 1
      endif
!
      fcoef(1:numberToUse) = evet(1:numberToUse) * wt(1:numberToUse)
      jpatt = 0
      call MakeMap(fcoef, iphaz, numberToUse, jpatt, xmap,
     *                     FORTH, BACK)
c
c=========================  I macrociclo ==============================
c
      call scrper(' ',0,0)
!
!--faccio i cicli di espansione
!
      if(irescut==1) then
        nMaxExpand = 50    
      else
        nMaxExpand = 10    
      endif
!
      nperc=100
      if (nperc > nMaxExpand) then
          nperc = nMaxExpand
      endif
      iperc0=nMaxExpand/nperc
      iperc=iperc0
      jperc=0
!
      do nexpand=1,nMaxExpand
         write(line,100) nexpand, nMaxExpand
!g       call scrper(line,0,-1)
         if (nexpand.eq.iperc) then
            jperc=jperc+1
            iperc=iperc+iperc0
            call scrper(line,jperc,nperc)
         endif
c
c--cambio il raggio dell'envelope  
c
         if (irescut==3) then
           RenveDyn=RenveStart
         else
           x  = nexpand
           x1 = 1
           x2 = nMaxExpand  
           y1 = RenveStart   
           y2 = ResFin  
           call varlinear(x,x1,x2,y,y1,y2)
           RenveDyn = y 
         endif
!
!--modifico la mappa
!
         x  = nexpand
         x1 = 1
         x2 = nMaxExpand 
         y1 = 0.1   
         y2 = 0.2 
         if(irescut==1) y2=0.1
         call varlinear(x,x1,x2,y,y1,y2)
         percMap = y * v_p
c
c--applico l'envelope 
c
         if (EnvePronta.gt.0.5) then
             iflat = 1
             Xflip = 0
             call flatmapOld(xmap,xenve,iflat,Xflip)
         endif
c
c--inverto la mappa
c
         call InvMap(khl,mkang,iphaz,fcvet,nreflTot)
!
!--soglia sui riflessi  crescente con il ciclo
!
         x  = nexpand
         x1 = 1
         x2 = nMaxExpand  
         y1 = 0.10 
         y2 = 0.75 
         call varlinear(x,x1,x2,y,y1,y2)
         percsog = y*float(nrefl) / float(numbGen)  
         chope = 0.5 
         call CalcolaPesi_Exp(nreflTot,chope,percsog, nexpand)
c
         call E2F_and_R(erreExt)
c
c--faccio la combinazione
c
         if (irescut>1) then
           if(mod(nexpand,2)==0) then  
             x  = nexpand
             x1 = 1
             x2 = nMaxExpand 
             y1 = 0.50  
             y2 = 0.25  
             call varlinear(x,x1,x2,y,y1,y2)
             coefOld = y
             coefNew = 1.0 - coefOld
             do i=1, nrefl
               wtOld =worko(i)
               phOld =iphazo(i) * dtor
               if (irescut==3) then
                 wtNew = wt(i) 
               else
                 wtNew = wtOld  
               endif
               phNew =iphaz(i) * dtor
               if (wtOld > 0.001 .and. wtNew > 0.001) then
                 TangNum = coefOld * besinv(wtOld) * sin(phOld) + 
     *                     coefNew * besinv(wtNew) * sin(phNew)
                 TangDen = coefOld * besinv(wtOld) * cos(phOld) + 
     *                     coefNew * besinv(wtNew) * cos(phNew)
                 phNew = atan2(TangNum, TangDen) * rtod + 3600
                 iphaz(i) = mod(nint(phNew), 360)
                 wt(i) = wtOld
               elseif (wtOld > 0.001 .and. wtNew < 0.001) then
                 iphaz(i) = iphazo(i)
                 wt(i) = wtOld
               endif
             enddo
           endif  
         endif
c
c--elevo i pesi
c
         if (irescut==1) then
           if(mod(nexpand,2)==0) then
             expTerm=sumExt/sumInt
*            write(6,'(a,3f8.2)') 'Ecco ',sumInt,sumExt,ExpTerm
             wt(1:nrefl) =  wt(1:nrefl) ** expTerm
           endif
         endif
!
!--statistiche
!
         nuset = 7000 + nexpand  ! shell interno
         izero = 0
         call examin(nuset,mkang,khl,ipub,iphaz,numbPhased,izero,wt,0)
         errInt = erore
         errIntW = erorepes
         numbInt = isumal
         if (knwExt == 1) then 
             nuset = 8000 + nexpand  ! shell esterno
             izero = nrefl
             call examin(nuset,mkang,khl,ipub,iphaz,nreflTot,izero,wt,0)
             errExt  = erore
             errExtW = erorepes
             numbExt = isumal
         endif
         if (knw == 1) then 
             kstp = 0
             call Calcola_CC_Mappa(numbPhased,corre,kstp,2)
             kstp = 0
             call Calcola_CC_Mappa(nreflTot,correTot,kstp,1)
             nPhased = count(wt(nrefl+1:nreflTot) > 0.0)
             e2med = 0
             if (knwExt == 0) then 
                 write(lo,510) nexpand, corre, correTot,
     *                         errInt, errIntW, numbInt,
     *                         nPhased, percsog
             else
                 write(lo,520) nexpand, corre, 
     *                         errInt, errIntW, numbInt,
     *                         errExt, errExtW, numbExt, 
     *                         erreExt, correTot,coef
             endif
             call toflush()
         endif
!
!--metto i nuovi valori in evet per il solo shell esterno
!
         esterni = 0
         coef = 0.0
         sumwt = 0.0
         do i=nrefl+1,nreflTot
             evet(i) = fcvet(i)
             if (wt(i) > 0.0) then
                 esterni = esterni + 1
                 coef = coef + wt(i) * evet(i)
                 sumwt = sumwt + wt(i)
             endif
         enddo
         coef = coef / sumwt
!
!-- ricalcolo l'envelope 
!
         if (ifEnve.eq.1) then 
             jpatt = 0
             call Long_Env_New(numberToUse, jpatt)
             EnvePronta = 1
         endif
!
!--faccio la nuova mappa
!
         do i=1,nreflTot
            if(i>numbLSQ.and.i<=nrefl) wt(i)=0.0  
            fcoef(i) = evet(i) * wt(i)
         enddo
         jpatt = 0
         call MakeMap(fcoef, iphaz, nreflTot, jpatt, xmap,
     *                     FORTH, BACK)
!
      enddo  ! fine loop su nexpand
c
c=========================  II macrociclo ==============================
c
!     if (ksize > 3) then
      if ((irescut == 1 .and. ksize > 3) .or. irescut > 1) then
!         expTerm1=expTerm  ! dedi 21/01/08 spostato - deve essere inizializzato expTerm!!!!
c
c--calcolo il valore di riferimento per la FinalFom
c
c         xmapShi=xmap
c         call Calcola_FOM_Lib(1)
c         xmap=xmapShi
c         fomold(1)  = CCEoEc(1)
c         fomold(2)  = CCEoEc(2)
c         fomold(3)  = FOMs(2,4)
c         write(6,*) 'fomold',fomold
c
          nMaxExpand1=20
          nchange=2  
!
          nperc=100
          if (nperc > nMaxExpand1) then
              nperc = nMaxExpand1
          endif
          iperc0=nMaxExpand1/nperc
          iperc=iperc0
          jperc=0
!
          do nexpand=1,nMaxExpand1
             write(line,110) nexpand, nMaxExpand1
!g           call scrper(line,0,-1)
             if (nexpand.eq.iperc) then
                jperc=jperc+1
                iperc=iperc+iperc0
                call scrper(line,jperc,nperc)
             endif
c
c--cambio il taglio della mappa
c
             x  = nexpand
             x1 = 1
             x2 = nMaxExpand1  
             y1 = 0.1   
             y2 = 0.3
             call varlinear(x,x1,x2,y,y1,y2)
             percMap = y * v_p
!
!-- applico l'envelope 
!
             if (irescut==3) then
               RenveDyn = RenveStart 
               if (EnvePronta.gt.0.5) then
                 iflat = 1
                 Xflip = 0
                 call flatmapOld(xmap,xenve,iflat,Xflip)
               endif
             endif
c
c--criteri alternativi di modifica di densita' elettronica
c
             call maxmin3d(denmin,denmax,avden,stden,npunt,1)  
c
             x  = nexpand
             x1 = 1
             x2 = nMaxExpand1  
             y1 = 5  
             y2 = 10
             call varlinear(x,x1,x2,y,y1,y2)
             aaterm=y
             sog1=aaterm*stden
             sog=1.0*stden 
c
*        write(6,'(a,7f8.1)') 'mappa',denmin,denmax,avden,  
*    &                    stden,sog,(denmax-avden)/stden,sog1
c
             do ih = 0, np(1)-1  
               do ik = 0, np(2)-1
                 do il = 0, np(3)-1
                   if (xmap(ih,ik,il).gt.0.0) then
                     if (xmap(ih,ik,il).lt.sog) then
                        xmap(ih,ik,il) = 0.5*xmap(ih,ik,il) 
                     endif
                   endif
                 enddo
               enddo
             enddo
c
c--tronco di tanto in tanto la mappa  
c
             if (mod(nexpand,nchange)==0) then  
               do ih = 0, np(1)-1
                 do ik = 0, np(2)-1
                   do il = 0, np(3)-1
                      if (xmap(ih,ik,il).gt.sog1) then
                         xmap(ih,ik,il) = sog1
                      endif
                   enddo
                 enddo
               enddo
             endif
c
             call InvMap(khl,mkang,iphaz,fcvet,nreflTot)
!
             chope = 0.5
             call CalcolaPesi_Exp(nreflTot,chope,percsog, nexpand)
c
             call E2F_and_R(erreExt)
c
c--faccio la combinazione
c
             if (irescut>1) then
               if(mod(nexpand,2)==0) then  
                 x  = nexpand
                 x1 = 1
                 x2 = nMaxExpand1 
                 y1 = 0.50  
                 y2 = 0.25
                 call varlinear(x,x1,x2,y,y1,y2)
                 coefOld = y
                 coefNew = 1.0 - coefOld
                 do i=1, nrefl
                    wtOld =worko(i)
                    phOld =iphazo(i) * dtor
                    if (irescut==3) then
                      wtNew = wt(i) 
                    else
                      wtNew = wtOld  
                    endif
                    phNew =iphaz(i) * dtor
                    if (wtOld > 0.001 .and. wtNew > 0.001) then
                        TangNum = coefOld * besinv(wtOld) * sin(phOld) +
     *                            coefNew * besinv(wtNew) * sin(phNew)
                        TangDen = coefOld * besinv(wtOld) * cos(phOld) +
     *                        coefNew * besinv(wtNew) * cos(phNew)
                        phNew = atan2(TangNum, TangDen) * rtod + 3600
                        iphaz(i) = mod(nint(phNew), 360)
                        wt(i) = wtOld  
                    elseif (wtOld > 0.001 .and. wtNew < 0.001) then
                        iphaz(i) = iphazo(i)
                        wt(i) = wtOld
                    endif
                 enddo
               endif  
             endif
c
c--elevo i pesi
c
             if (irescut==1) then
               if(mod(nexpand,2)==0) then  
                 expTerm1=expTerm  ! dedi 21/01/08
                 x  = nexpand
                 x1 = 1
                 x2 = nMaxExpand1 
                 y1 = expTerm1  
                 y2 = 0.50
                 call varlinear(x,x1,x2,y,y1,y2)
                 expTerm=y
*            write(6,'(a,3f8.2)') 'Ecco',sumInt,sumExt,ExpTerm
                 wt(1:nrefl) =  wt(1:nrefl) ** expTerm
               endif
             endif
!
!--statistiche
!
             nuset = 7000 + nexpand  ! shell interno
             izero = 0
             call examin(nuset,mkang,khl,ipub,iphaz,numbPhased,izero,
     *                   wt,0)
             errInt = erore
             errIntW = erorepes
             numbInt = isumal
             if (knwExt == 1) then 
                 nuset = 8000 + nexpand  ! shell esterno
                 izero = nrefl
                 call examin(nuset,mkang,khl,ipub,iphaz,nreflTot,izero,
     *                   wt,0)
                 errExt  = erore
                 errExtW = erorepes
                 numbExt = isumal
             endif
             if (knw == 1) then 
                 kstp = 0
                 call Calcola_CC_Mappa(numbPhased,corre,kstp,2)
                 kstp = 0
                 call Calcola_CC_Mappa(nreflTot,correTot,kstp,1)
                 nPhased = count(wt(nrefl+1:nreflTot) > 0.0)
                 e2med = 0
                 if (knwExt == 0) then 
                     write(lo,510) nexpand+nMaxExpand, corre, correTot,
     *                             errInt, errIntW, numbInt,
     *                             nPhased, percsog
                 else
                     write(lo,520) nexpand+nMaxExpand, corre, 
     *                             errInt, errIntW, numbInt,
     *                             errExt, errExtW, numbExt, 
     *                             erreExt, correTot,coef
                 endif
                 call toflush()
             endif
!
!--metto i nuovi valori in evet per il solo shell esterno
!
             esterni = 0
             coef = 0.0
             sumwt = 0.0
             do i=nrefl+1,nreflTot
                 evet(i) = fcvet(i)
                 if (wt(i) > 0.0) then
                     esterni = esterni + 1
                     coef = coef + wt(i) * evet(i)
                     sumwt = sumwt + wt(i)
                 endif
             enddo
             coef = coef / sumwt
!
!-- ricalcolo l'envelope 
!
             if (irescut==3) then
               if (ifEnve.eq.1) then  
                 jpatt = 0
                 call Long_Env_New(numberToUse, jpatt)
                 EnvePronta = 1
               endif
             endif
c
             if(nexpand /= nMaxExpand1) then
c
c--criterio di stop basato sulla FinalFom
c
c        if(mod(nexpand,4)==0) then
c          xmapShi=xmap 
c          call Calcola_FOM_Lib(1)
c          xmap=xmapShi
c          if (ksize > 3) then
c            diffCC = CCEoEc(2)-fomold(2)
c            FinalFom = CCEoEc(1)*FOMs(2,4)*diffCC 
c    &                            / (fomold(1)*fomold(3))
c            FinalFom = FOMs(2,4)
c            write(6,*) 'fomnew',CCEoEc(1),CCEoEc(2),FOMs(2,4)
c          else
c            FinalFom = FOMs(2,4)
c          endif
c          if (FinalFom > OldFinalFom) then
c            write(lo,30) FinalFom,OldFinalFom
c            if(OldFinalFom<-999.0) then
c              OldFinalFom = FinalFom
c            else
c              OldFinalFom = 0.5*(FinalFom + OldFinalFom)
c            endif
c          else
c            write(lo,20) FinalFom,OldFinalFom
c            exit
c          endif
c        endif
!
!--faccio la nuova mappa
!
               do i=1,nreflTot
                  if(nexpand /= nMaxExpand1-1) then
                    if(i>numbLSQ.and.i<=nrefl) wt(i)=0.0  
                  endif
                  fcoef(i) = evet(i) * wt(i)
               enddo
               jpatt = 0
               call MakeMap(fcoef, iphaz, nreflTot, jpatt, xmap,
     *                     FORTH, BACK)
            endif
c
          enddo  ! fine loop su nexpand
      endif  ! fine if su ksize
c--deb         
c     do i=1,nreflTot
c        fcoef(i) = evet(i)
c        if(i>nrefl) then
c          if (fcoef(i) > 0.886) fcoef(i) = 0.886
c        endif
c     enddo
c     fcoef(1:nreflTot)=evet(1:nreflTot)
c     fcoef(1:nreflTot)=fovet(1:nreflTot)
c     call Trasla_Origine(nreflTot) ! occhio
c     call Scrivi_Mappa_Xtal(numbPhased,3,xmap_div,1)
c     call Scrivi_Mappa_Xtal(nrefl,3,xmap_div,1)
c     call Scrivi_Mappa_Xtal(nreflTot,4,xmap_div,1)
c--deb         
c        if (knw == 1) then 
c            kstp = 1
c            call Calcola_CC_Mappa(numbPhased,corre,kstp,2)
c            call Calcola_CC_Mappa(nrefl,corre1,kstp,2)
c            kstp = 1
c            call Calcola_CC_Mappa(nreflTot,correTot,kstp,1)
c                write(lo,*) 'uffa',corre,corre1,correTot
c        endif
c--deb         
!
c
!
!--statistiche finali
!
      if(knw==1) then
        write(lo,200)
        nuset = 7000
        izero = 0
        call examin(nuset,mkang,khl,ipub,iphaz,numbPhased,izero,wt,1)
        work1(1:nrefl) = wt(1:nrefl)
        tirang = 'Int.  Wt.'
        izero = 0
        ipher = 1
        call pherrdisNew(tirang,work1,khl,mkang,numbPhased,izero,
     *                ipub,iphaz,wt,10,0.0,ipher)
        nuset = 8000
        izero = 0
        call examin(nuset,mkang,khl,ipub,iphaz,nreflTot,izero,wt,1)
        nuset = 9000
        izero = nrefl
        call examin(nuset,mkang,khl,ipub,iphaz,nreflTot,izero,wt,1)
        do i = nrefl+1,nreflTot
           work1(i) = wt(i) 
        enddo
        tirang = 'Expa. Wt.'
        izero = nrefl
        ipher = 1
        call pherrdisNew(tirang,work1,khl,mkang,nreflTot,izero,
     *                ipub,iphaz,wt,10,0.0,ipher)
!
        do i = nrefl+1,nreflTot
           work1(i) = fcvet(i)
        enddo
        tirang = 'Expa. Ecalc.'
        izero = nrefl
        ipher = 1
        call pherrdisNew(tirang,work1,khl,mkang,nreflTot,izero,
     *               ipub,iphaz,wt,10,0.0,ipher)
!
        do i = nrefl+1,nreflTot
           work1(i)  =  0.5 / sqrt(rhov(i))
c         if(wt(i)>0.0) then
c           write(96,'(5f10.5,2i5)') work1(i),evet(i),fcvetv(i),fovet(i),
c    &                worko(i),iphaz(i),ipub(i)
c         endif
        enddo
        tirang = 'Expa. Resol.'
        izero = nrefl
        ipher = 1
        call pherrdisNew(tirang,work1,khl,mkang,nreflTot,izero,
     *               ipub,iphaz,wt,10,0.0,ipher)
c
        call StatRMio()   ! con E
        call StatRMio1()  ! con F
      endif
c
   8  call ClearMessage
      call toflush()
!
      return
c
c--deallocate local dynamic vectors
c
      IF (ALLOCATED(iphazo1)) DEALLOCATE (iphazo1, stat = ier)
      call AllocaMappaPatterson(2)
c
   20 format(' Final FOM =',2f12.3,' program stopped')
   30 format(' Final FOM =',2f12.3,' program continue....')
  100 format(2x,'Free Lunch, step 1: extending batch ',i2,'/',i2)
  110 format(2x,'Free Lunch, step 2: extending batch ',i2,'/',i2)
  200 format(77('-'))
  250 format('      ------- Interni -------------    ',
     *       '----------- Esterni ----------    Tot ',/,
     *       'Cycle Corr.    MPE   WMPE      Nref',
     *       '      MPE   WMPE     Added      R    Corr.')
  120 format('Cycle',6x,'Correlations',8x,
     *       'MPE    W-MPE     Used     Added    % added')
  510 format(i3,5x,2f8.3,5x,  f6.2,' (',f6.2,')',i8,2x,i8,2x,f9.3)
  520 format(i3,f8.3,2(f7.2,' (',f6.2,')',i8,2x),3f7.3)
      end     
!-----------------------------------------------------------------------
      ! controllare se Fc o Ec sono calc. per tutti i riflessi
      subroutine sigmaAA(fcalc,numbMax)

      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule

      common/freeL/sumInt,sumExt

      real fcalc(numbMax)

      real,     allocatable   :: RES(:),midpts(:),Eobs(:),Emodi(:)
      real,     allocatable   :: ee(:),sigEobs(:)
      integer,  allocatable   :: RES_TAG(:)
      real,     allocatable   :: Eo2Shell(:),Ec2Shell(:),Eo2Ec2Shell(:)
      real,     allocatable   :: SIGnShell(:),SIGpShell(:),SIGqShell(:)
      real,     allocatable   :: scEo2Shell(:),scEc2Shell(:)
      real,     allocatable   :: SIGMAAShell(:),eeShell(:)
      real,     allocatable   :: cosErrShell(:)
      real,     allocatable   :: GsimModShell(:)
      real,     allocatable   :: xfit(:),yfit(:),sig(:)
      

      dimension shellTAB(100,2)
      allocate(RES(nrefl),RES_TAG(nrefl),Eobs(nrefl),Emodi(nrefl),
     *         ee(nrefl),sigEobs(nrefl),stat=ierr)
c
c--shell interno
c
      res(1:nrefl)=sqrt(rhov(1:nrefl))
      Nbin=30
      Nstat=floor(nrefl/float(Nbin))
      Nbin=8.0*alog10(0.05*float(max0(nrefl,100))+0.5)


      allocate (Eo2Shell(Nbin),Ec2Shell(Nbin),Eo2Ec2Shell(Nbin),
     *          SIGnShell(Nbin),SIGpShell(Nbin),SIGqShell(Nbin),
     *          scEo2Shell(Nbin),scEc2Shell(Nbin),
     *          eeShell(Nbin),midpts(Nbin),SIGMAAShell(Nbin),
     *          cosErrShell(Nbin),
     *          GsimModShell(Nbin),xfit(Nbin),yfit(Nbin),sig(Nbin),
     *          stat=ierr)


      call shells(shellTAB,midpts,RES_TAG,RES,nrefl,Nbin,1)
c
      Eo2Shell(:)=0.0
      Ec2Shell(:)=0.0
      Eo2Ec2Shell(:)=0.0
      SIGnShell(:)=0.0
      SIGpShell(:)=0.0
      SIGqShell(:)=0.0
      eeShell(:)=0.0
      scEo2Shell(:)=1.0
      scEc2Shell(:)=1.0
      SIGMAAShell(:)=0.0
      cosErrShell(:)=0.0
      GsimModShell(:)=0.0

      do i=1,nrefl
       ii=RES_TAG(i)
       eps=epsv(i)*pts
       wref=2.0
       if (mkang(i) > 1) wref=1.0
       SIGnShell(ii)=SIGnShell(ii) + (wref*fovet(i)**2)/eps
      enddo

      do i=1, Nbin
        numbShell=count(RES_TAG(:) == i)
        SIGnShell(i)=SIGnShell(i)/float(numbShell)
      enddo
c     write(lo,*)' <sigN>',sum(SIGnShell(:))/float(Nbin)
  
      ! calc Eo, Ec
      do i=1,nrefl
       ii=RES_TAG(i)
       diffERR=0.0
       if (knw > 0.and.wt(i) > 0.0) then
         diffERR=iabs(iphaz(i)-ipub(i)) * dtor
       endif
       diffERR=cos(diffERR)
       cosErrShell(ii)=cosErrShell(ii) + diffERR
       Eobs(i)=evet(i)
       Emodi(i)=fcalc(i)
       eps=epsv(i)*pts
       sigEobs(i)=sigmav(i)/(sqrt(eps*SIGnShell(ii)))
c      ee(i)=1.0 
c      ee(i)=1.0 + sigEobs(i)
       ee(i)=1.0 + (sigEobs(i))**2
       eeShell(ii)= eeShell(ii)+ee(i)
       Eo2Shell(ii)= Eo2Shell(ii)+Eobs(i)**2
       Ec2Shell(ii)= Ec2Shell(ii)+Emodi(i)**2
       Eo2Ec2Shell(ii)=Eo2Ec2Shell(ii) + ((Eobs(i)**2)*(Emodi(i)**2))
      enddo
c     write(lo,*)'<Eo>',sum(Eobs(:))/float(nrefl)
c     write(lo,*)'<Ec>',sum(Emodi(:))/float(nrefl)
c     write(lo,*)'<fovet>',sum(fovet(:))/float(nrefl)
c     write(lo,*)'<sigmav>',sum(sigmav(:))/float(nrefl)
c     write(lo,*)'<sigE>',sum(sigEobs(:))/float(nrefl)

      ! calc <Eo2>, <Ec2> <Eo2Ec2> for any shell
      do i=1, Nbin
        numbShell=count(RES_TAG(:) == i)
        Eo2Shell(i)=Eo2Shell(i)/float(numbShell)
        Ec2Shell(i)=Ec2Shell(i)/float(numbShell)
        Eo2Ec2Shell(i)=Eo2Ec2Shell(i)/float(numbShell)
        eeShell(i)=eeShell(i)/float(numbShell)
        cosErrShell(i)=cosErrShell(i)/float(numbShell)
      enddo
      scala=eeShell(1)
      do i=1,Nbin
        eeShell(i)=eeShell(i)/scala 
        scEo2Shell(i)=Eo2Shell(i)/1.0
        scEc2Shell(i)=Ec2Shell(i)/1.0
        Eo2Shell(i)=Eo2Shell(i)/scEo2Shell(i)
        Ec2Shell(i)=Ec2Shell(i)/scEc2Shell(i)
        Eo2Ec2Shell(i)=Eo2Ec2Shell(i)/(scEo2Shell(i)*scEc2Shell(i))
c       write(lo,*)'<scala>',(scEo2Shell(i)*scEc2Shell(i))
        ! calc. <sigmaA>
        if (Eo2Ec2Shell(i) <= eeShell(i)) then
          SIGMAAShell(i)=0.0
c         write(0,*) 'uff',i,Eo2Ec2Shell(i),eeShell(i)
        else
          SIGMAAShell(i)=sqrt((Eo2Ec2Shell(i)-eeShell(i)))  
        endif
c       write(0,*) 'uffa',i,Eo2Ec2Shell(i),eeShell(i),sigmaashell(i)
      enddo
c
c     do i=1,nrefl
c      ii=RES_TAG(i)
c      write(90+icycle,'(i8,2f12.3)') ii,sqrt(rhov(i)),sigmaaShell(ii)
c     enddo
c
      !------------------------------------ fit di Dritan
c     mwt=0
c     sig(:)=0.0
c     NPT=Nbin-2
c     xfit(1:NPT)=midpts(3:Nbin-1)
c     yfit(1:NPT)=SIGMAAShell(3:Nbin-1)
c     call fit(xfit,yfit,NPT,sig,mwt,a,b,siga,sigb,chi2,q)
c     aaterm=a
c     bbterm=b
c     write(6,*) 'Dritan',a,b
      !------------------------------------

c
c--determino la retta di estrapolazione in funzione della risoluzione
c
c  uso i punti estremi 
c     iresmin=minloc(rhov(1:nrefl))
c     iresmax=maxloc(rhov(1:nrefl))
c     x1=sqrt(rhov(iresmin(1)))
c     x2=sqrt(rhov(iresmax(1)))
c     y1=min(SIGMAAShell(RES_TAG(iresmin(1))),0.99)
c     y2=min(SIGMAAShell(RES_TAG(iresmax(1))),0.99)
c     bbterm=(y2-y1)/(x2-x1)
c     aaterm=y1-bbterm*x1
c     write(6,*) 'Estremi',aaterm,bbterm
c
c  uso la retta dei minimi quadrati
c
      sumx=0.0  
      sumy=0.0
      sumxx=0.0
      sumxy=0.0
      do ii=1,NBin
       x=midpts(ii)
c      y=SIGMAAShell(ii)
       y=min(SIGMAAShell(ii),0.80)
       sumx=sumx+x
       sumy=sumy+y
       sumxx=sumxx+x*x
       sumxy=sumxy+x*y
      enddo
      delta=Nbin*sumxx-sumx*sumx
      bbterm=(Nbin*sumxy-sumx*sumy)/delta
      aaterm=(sumy*sumxx-sumx*sumxy)/delta
c
      sogsigma=0.80
c     if(no(nk)<20) sogsigma = 0.99 ! occhio
      sigmaven=sum(SIGMAAShell(:))/float(Nbin)
*     write(lo,'(a,4f8.3)')'SIGMAVE',sigmaven,aaterm,bbterm
      if (knw == 1 .and. iftime == 0) then
          write(lo,99) sigmaven
      endif
 99    format(' SIGMAA:  <sigmaa>= ',f5.2)

c     do ii=1,Nbin
c        x=midpts(ii)
c        y=sigmaaShell(ii)
c        write(98,*) ii,x,y
c     enddo
c     call toflush()
c
      do i=nrefl+1,numbMax
       iu=i-nrefl
c
c--estrapolo i valori di sigma nel range non misurato
c
       x=sqrt(rhov(i))
       sigmaext=aaterm+bbterm*x 
! controllo per evitare esalazioni
       sigmaext=min(sigmaext,sogsigma) 
       fact=1.0-sigmaext**2
       work1(iu) = sqrt(3.0*(Pi/4.0)*fact)
       exxo = sqrt(1.0+sigmaext**2*(fcalc(i)**2-1.0))
       fcalc(i)=exxo
      enddo
 
      deallocate(RES,RES_TAG,Eobs,Emodi,ee,sigEobs,stat=ierr)
      deallocate (Eo2Shell,Ec2Shell,Eo2Ec2Shell,
     *          SIGnShell,SIGpShell,SIGqShell,
     *          scEo2Shell,scEc2Shell,
     *          eeShell,midpts,SIGMAAShell,
     *          cosErrShell,GsimModShell,stat=ierr)
c
      return
      end
!-------------------- NUOVE  ROUTINES ----------------------------------------
      subroutine Expand2006(chope,expTerm)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE HistoStuff
      USE Mappa
      USE PhaseModule
!
      character tirang * 11
      character ttirang * 80
      real shi(4)
      real, allocatable :: segni_mio(:)
!
!--ristabilisco gli indici massimi
!
!
      ihmx(:)=ihmxExt(:)
      rhomax = maxval(rhov(1:nreflTot))
c     write(6,*) 'nuovi massimi',ihmx,rhomax
*     write(6,*) 'Inizio Expand, nrefltot',nrefltot
      do i=1,nreflTot
         fcoef(i) = evet(i)
*        write(6,*) i,fcoef(i),wt(i),iphaz(i)
      enddo
!
!dedi! se voglio usare solo gli oss. per stimare gli ext.
!      wt(nrefl+1:nreflTot) = 0.0
       if (ifDsrVLD > 0) then
!          wt(nrefl+1:nreflTot) = 0.0  
       endif

c      if(ifDEDM>10) wt(nrefl+1:nreflTot) = 0.0 ! occhio
       if (knw == 1) then
           write(6,*) 'EXPAND - ifDEDM =', ifDEDM
       endif
       if(ifDEDM>10) then
         wt(nrefl+1:nreflTot) =sigmav2(nrefl+1:nreflTot)
         iphaz(nrefl+1:nreflTot) =fovet2(nrefl+1:nreflTot)
       endif
!occhio
!
      nuset = 6000
      izero = 0
      call examin(nuset,mkang,khl,ipub,iphaz,nreflTot,izero,wt,1)
      fcoef(:) = fcoef(:) * wt(:)
      jpatt = 0
      call MakeMap(fcoef, iphaz, nreflTot, jpatt, xmap,
     *                     FORTH, BACK)
!
      invflag = 1
!
      nMaxExpand = 1 ! default
c     nMaxExpand = 10 
      do nexpand=1,nMaxExpand
!
!        write(lo,*)'ENVELOPE in Expand',EnvePronta
         if (EnvePronta.gt.0.5) then  
             iflat = 1
             Xflip = 0
             call flatmapOld(xmap,xenve,iflat,Xflip)
!            write(lo,*)'ENVELOPE in Expand',ihmx
         endif
!
!--modifico la mappa
!
         percMapold=percMap 
c        percMap=0.1
         percMap=0.02
!        write(6,*) 'Expand2006',percMap,percMap_n
!        if (knw > 0) write(lo,*) 'Expand2006'
         if (ifOUT==1.and.knw > 0) write(lo,*) 'Expand2006'

!
!--inverto la mappa
!
         call RiduciRippleOld() 
!
         call InvMap(khl,mkang,iphaz,fcvet,nreflTot)
c
         percMap=percMapold 
!
c
c--soglia sui riflessi  crescente con il ciclo
c
         if(nexpand /= nMaxExpand) then
            x=nexpand
            x1=1
            x2=nMaxExpand
            y1=0.15  ! default
            y2=0.25  ! default
            if(ifExpanded==0) y1=0.02
            call varlinear(x,x1,x2,y,y1,y2)
            percsog=y
         else
            percsog=1.0
         endif
!
!
!--calcolo pesi per i riflessi osservati
!
          nreflDimSav=nreflDim
          nreflDim=nrefl
          do i=1, nrefl
            if (fcvet(i) > 0.00001) wt(i) = 1.
          end do
cdedi - prova 16/04/12
*         e2_ini = 0
*         do i=1, nrefl
*           if (fcvet(i) > 0.00001) wt(i) = 1.
*           e2_ini = e2_ini + fcvet(i)**2.
*         end do
*         e2_ini = e2_ini / nrefl

*         work1(1:nrefl) = fcvet(1:nrefl)
*         nwizm1=25
*         nsip1=150
*         call HistogramMatch(work1,evet,nrefl,nsip1,nwizm1,1)
*         fcvet(1:nrefl)= work1(1:nrefl)
*         e2_HM = 0
*         do i=1, nrefl
*           e2_HM = e2_HM + fcvet(i)**2.
*         end do
*         e2_HM = e2_HM / nrefl
*         write(6,*) '<E2>_ini =', e2_ini, '<E2>_HM =', e2_HM
cdedi - prova 16/04/12

          iesfast = 0
          jflag=-2
          call PresigmaA(jflag, 0)
          nreflDim=nreflDimSav
          avwt1=0.0
          avwt=0.0
          avfc=0.0
          anum=0.0
          do i=1,nrefl
            if(wt(i)>0.01) then
              avfc=avfc+fcvet(i)
              avwt=avwt+wt(i)
              avwt1=avwt1+wt(i)*fcvet(i)
              anum=anum+1.0
            endif
          enddo
          avwt1=avwt1/avwt
C         write(6,'(a,5f10.2)') 'averaged internal',
C    &            anum,avfc/anum,avwt/anum,avwt1
c         avwt=avwt/anum
c         avwt=0.0 ! occhio
!
!--calcolo pesi per i riflessi estesi
!
         call Calcola_WT_Sigmaa(avwt,avwt1,chope,expTerm)
c
c--metto i nuovi valori in evet per il solo shell esterno
c
c        do i=nrefl+1,nreflTot ! dedi 04/04/13
c           evet(i) = fcvet(i)
c        enddo

! -- per statistiche di confronto su Extra (=== Added) 
!!!     if (Added > 0) then
!!!         call StatRfac_ExtAdd(ier)
!!!     endif
! -- per statistiche di confronto su Extra (=== Added) 

! -- modifiche Liberato
         do i=nrefl+Added+1,nreflTot
            if((ResEff-resm)/resm<0.065) then
               evet(i) = fcvet(i)
            else
              risolu=0.5/sqrt(rhov(i))
              if(risolu<=resm) then
                 evet(i)=fcvet(i)*0.5
              else
                evet(i)=fcvet(i)*(Min(0.5,0.5+float(Iterazione-4)*0.25))
              endif
            endif
         enddo
! -- modifiche Liberato

! -- per statistiche di confronto su Extra (> Added) 
!!!      if (knw == 1) then
!!!          sss = sum(fcvetv(1:nreflDim))
!!!          if (sss > 0.00001) then
!!!              call StatRfac_ExtPub(ier)
!!!          endif
!!!      endif
! -- per statistiche di confronto su Extra (> Added) 

c            stop 999

         if(nexpand /= nMaxExpand) then
c
c--faccio la nuova mappa
c
           do i=1,nreflTot
              fcoef(i) = evet(i)
              if(i>nrefl.and.evet(i)>0.886) fcoef(i)=0.886  ! occhio
           enddo
           fcoef(:) = fcoef(:) * wt(:)
           call MakeMap(fcoef, iphaz, nreflTot, jpatt, xmap,
     *                     FORTH, BACK)
c
         else

!
!--statistiche 
!
         if (kverbo>0) call Trasla_Origine(nreflDim)
         nuset = 7000
         izero = 0
         call examin(nuset,mkang,khl,ipub,iphaz,nrefl,izero,wt,1)
         if (kverbo>0) then
            allocate(segni_mio(nreflDim))
            tirang = 'Expa. - Obs.'
            izero = 0
            ipher = 1
            call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                   ipub,iphaz,wt,10,0.0,ipher)
            shi(:) = 0.0
            segni_mio = 0.0
            izero1 = 1
            ttirang = 'EXPAND - OBSER'
            call ParamDistribution(ttirang,2,wt,khl,nrefl,izero1,
     *      ipub,iphaz,shi,wt,segni_mio,10,1.0)
            deallocate(segni_mio)
         endif

         if (Added > 0) then
         nuset = 8000
         izero = nrefl
         call examin(nuset,mkang,khl,ipub,iphaz,nrefl+Added,izero,wt,1)
         endif
         nuset = 9000
         izero = nrefl+Added
         call examin(nuset,mkang,khl,ipub,iphaz,nreflTot,izero,wt,1)
         if (kverbo>0) then
             tirang = 'Expa. - Gen.'
             izero = nrefl+Added
             ipher = 1
             call pherrdisNew(tirang,wt,khl,mkang,nreflTot,izero,
     *                ipub,iphaz,wt,10,0.0,ipher)
             shi(:) = 0.0
             segni_mio = 0.0
             izero1 = nrefl+Added+1
             ttirang = 'EXPAND - GENER'
             call ParamDistribution(ttirang,2,wt,khl,nreflTot,izero1,
     *       ipub,iphaz,shi,wt,segni_mio,10,1.0)

             tirang = 'Expa. Ecalc.'
             izero = nrefl+Added
             ipher = 1
             call pherrdisNew(tirang,evet,khl,mkang,nreflTot,izero,
     *               ipub,iphaz,wt,10,0.0,ipher)
 
             do i = nrefl+Added+1,nreflTot
                work1(i) = 0.5 / sqrt(rhov(i))
             enddo
             tirang = 'Expa. Resol.'
             izero = nrefl
             ipher = 1
             call pherrdisNew(tirang,work1,khl,mkang,nreflTot,izero,
     *               ipub,iphaz,wt,10,0.0,ipher)
!
c            call StatRMio()
         endif
!
c
         endif
      enddo  ! fine loop su nexpand
!
      ifExpanded = 1
!
      return
      end     
!-----------------------------------------------------------------------
      subroutine Calcola_WT_Sigmaa(avwt,avwt1int,chope,expTerm)
      USE General
      USE Symmetry
      USE Riflessi
      USE HistoStuff
!
      USE PhaseModule
      character*11 tirang
      
!
      dump = 1.0
      iniz = nrefl ! per HM e statistiche su extrap coincidenti con Added
!
c
c
c--applico l'HM rispetto alle curve teoriche degli E
c
      if(esalta>=1.1) then
      icont=0
c     cut=0
c     call preHistMatchTheo(1,nreflTot,cut)
c     do i=1,nreflTot
      do i=iniz+1,nreflTot
c       if(fcvet(i)<cut) cycle
        icont=icont+1
        vetmatchin(icont)=fcvet(i)
      enddo
      call HistMatchTheo(icont)
      icont=0
c     do i=1,nreflTot
      do i=iniz+1,nreflTot
c       if(fcvet(i)<cut) cycle
        icont=icont+1
        fcvet(i)=vetmatchin(icont)
      enddo
      endif



!
! --  prova rinormalizzazione 
!
c
c-- Rinormalizzo fcvet per riflessi aggiunti  (Added + numbGen) per statistiche su Added 
c
c          nreflSHL = nreflDim - nrefl  
c          do i = 1,nreflSHL
c             ii = nrefl + i
c             work1(i) = fcvet(ii)
c             work2(i) = rhov(ii)
c          enddo
c          call Renor2004(0)
c          do i = 1,nreflSHL
c             ii = nrefl+Added + i
c             fcvet(ii) = work1(i)
c          enddo
!
! --  prova rinormalizzazione 
!


c
!   uso la sigma per stimare il modulo e la varianza del riflesso estrapolato
!   e calcolare i pesi per lo shell esterno 

          iniz = nrefl        ! pesi per i generati + Added

          sogsigma = 0.80
c         if(esalta>=1.1) sogsigma = 0.40!LIB
          do i=iniz+1,nreflTot
             iu=i-iniz
             sigmaext=sigmaven
             sigmaext=min(sigmaext,sogsigma)
             if (iu <= Added) then
                 fcOld = evet(i)
             else
                 fcOld=fcvet(i)
             endif
             fcvet(i) = sqrt(1.0+sigmaext**2*(fcvet(i)*fcvet(i)-1.0))
             if(esalta>=1.1) fcvet(i)=fcOld
c            if(esalta>=1.1.and.ksize>5) then
c               fcvet(i)=fcOld
c            elseif(esalta>=1.1) then
c               fcvet(i)=fcOld/10.
c            endif
c--stimo il peso
             fact=sigmaext/(1-sigmaext*sigmaext)
             wref=2.0
             if (mkang(i) > 1) wref=1.0


             gsim = chope*wref * fact * fcvet(i) * fcOld
             if (esalta >= 1.1) then
                 dump = 0.6
             endif

             gsim = gsim * dump

c            work1(iu) = gsim
             work2(iu) = gsim
          enddo
          if (knw == 1) then
              write(6,*) 'DUMPING FACTOR, CHOPE =',dump,chope,esalta
          endif
C         write(6,*) 'chope',chope
!
!
!--selezione dei riflessi esterni
!
          sog=0.0
c
          avwt1=0.0
          avwt=0.0
          avfc=0.0
          anum=0.0
          do i=iniz+1,nreflTot
             iu=i-iniz
             if(work2(iu).lt.sog) then
                wt(i) = 0.0
             else
                wt(i) = bes(work2(iu))
                avfc=avfc+fcvet(i)
                avwt=avwt+wt(i)
                avwt1=avwt1+wt(i)*fcvet(i)
                anum=anum+1.0
            endif
          enddo
          expTerm=avwt1int*avwt/avwt1
C         write(6,'(a,5f10.2)') 'averaged external',anum,
C    &           avfc/anum,avwt/anum,avwt1/avwt,expTerm
!
!--statistiche
c
c        nuset = 7100  ! shell interno
c        izero = 0
c        call examin(nuset,mkang,khl,ipub,iphaz,nrefl,izero,wt,1)
c        call examin(nuset,mkang,khl,ipub,iphaz,nrefl,izero,wt,0)
c        tirang='pesi INT'
c        ipher = 1
c        call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
c    *                    ipub,iphaz,wt,10,0.0,ipher)
c        nuset = 8100  ! shell esterno
c        izero = nrefl
c        call examin(nuset,mkang,khl,ipub,iphaz,nreflTot,izero,wt,1)
c        call examin(nuset,mkang,khl,ipub,iphaz,nreflTot,izero,wt,0)
c        tirang='pesi EXT'
c        ipher = 1
c        call pherrdisNew(tirang,wt,khl,mkang,nreflTot,izero,
c    *                    ipub,iphaz,wt,10,0.0,ipher)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Calcola_WT_Sigmaa_Patt(chope)
      USE General
      USE Symmetry
      USE Riflessi
      USE HistoStuff
!
      USE PhaseModule
      character*11 tirang
c
c--applico l'HM rispetto alle curve teoriche degli E
c
      if(esalta>=1.1) then
      icont=0
      do i=nrefl+1,nreflTot
        icont=icont+1
        vetmatchin(icont)=fcvet(i)
      enddo
      call HistMatchTheo(icont)
      icont=0
      do i=nrefl+1,nreflTot
        icont=icont+1
        fcvet(i)=vetmatchin(icont)
      enddo
      endif
c
!   uso la sigma per stimare il modulo e la varianza del riflesso estrapolato
!   e calcolare i pesi per lo shell esterno
!
c         sogsigma = 0.80
          sogsigma = 0.40

          do i=nrefl+1,nreflTot
             sigmaext=sigmaven
             sigmaext=min(sigmaext,sogsigma)
             fcOld=fcvet(i)
             fcvet(i) = sqrt(1.0+sigmaext**2*(fcvet(i)*fcvet(i)-1.0))
             if(esalta>=1.1.and.resm<1.4) then
                fcvet(i)=fcOld/10.
             elseif(esalta>=1.1.and.resm>=1.4) then
                fcvet(i)=fcOld
             endif
c--stimo il peso
             fact=sigmaext/(1-sigmaext*sigmaext)
             wref=2.0
             if (mkang(i) > 1) wref=1.0
             gsim = chope*wref * fact * fcvet(i) * fcOld
             wt(i) = bes(gsim)
          enddo
!
!--statistiche
!
C        nuset = 7100  ! shell interno
C        izero = 0
C        call examin(nuset,mkang,khl,ipub,iphaz,nrefl,izero,wt,1)
c        call examin(nuset,mkang,khl,ipub,iphaz,nrefl,izero,wt,0)
c        tirang='pesi INT'
c        ipher = 1
c        call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
c    *                    ipub,iphaz,wt,10,0.0,ipher)
C        nuset = 8100  ! shell esterno
C        izero = nrefl
C        call examin(nuset,mkang,khl,ipub,iphaz,nreflTot,izero,wt,1)
c        call examin(nuset,mkang,khl,ipub,iphaz,nreflTot,izero,wt,0)
C        tirang='pesi EXT'
C        ipher = 1
C        call pherrdisNew(tirang,wt,khl,mkang,nreflTot,izero,
C    *                    ipub,iphaz,wt,10,0.0,ipher)
!
      return
      end


