c-----------------------------------------------------------------------
      subroutine MakeMapMR(xmap, xmapC, FORTH, BACK, np, FFTW_ESTIMATE)
c
c--serve a fare la TF per Molecular Replacement
c
      USE General
      USE Symmetry
      USE Riflessi
      USE riflessi_c
*     USE Mappa
      USE Molcom
      USE Param
      USE PhaseModule
!
      integer*8 :: FORTH, BACK
      integer   :: np(3), FFTW_ESTIMATE
      real      :: xmap( 0:np(1)-1, 0:np(2)-1, 0:np(3)-1)
      complex   :: xmapC(0:np(1)/2, 0:np(2)-1, 0:np(3)-1)
      dimension i2(3)
      complex fm
      integer lmod
      external lmod
c
      n1 = np(1)
      n2 = np(2)
      n3 = np(3)
      n0 = n1 / 2 + 1
!
!-- make plans
!
      if (FORTH == 0) then
          call sfftw_plan_dft_c2r_3d(FORTH, n1, n2, n3, xmapC,xmap,
     *                                         FFTW_ESTIMATE)
          call sfftw_plan_dft_r2c_3d(BACK,  n1, n2, n3, xmap,xmapC,
     *                                         FFTW_ESTIMATE)
      endif
!
      eps=0.00001
      xmapC(:,:,:) = cmplx(0.0,0.0)
c
c     generate one complete hemisphere of reflexions
c
      do jn=1, nRifDimC
         eep = fcvets(jn)
         ee  = fcvetc(jn)
         if (abs(ee) < eps .and. abs(eep) < eps) cycle
         i2(1) = khlc(1,jn)
         i2(2) = khlc(2,jn)
         i2(3) = khlc(3,jn)
         fm = cmplx(ee,eep)
         if (i2(1) >= 0) then
             ih = lmod(i2(1), n0)
             ik = lmod(i2(2), n2)
             il = lmod(i2(3), n3)
             xmapC(ih,ik,il) = conjg(fm)
         endif
         if (-i2(1) >= 0) then
             ih = lmod(-i2(1), n0)
             ik = lmod(-i2(2), n2)
             il = lmod(-i2(3), n3)
             xmapC(ih,ik,il) = fm
         endif
      enddo
!
      xmapC(0,0,0) = cmplx(f000, 0.0)
!
!!gpu call sfftw_execute(FORTH)
      call sfftw_executec2r(n1,n2,n3,FORTH,xmapC,xmap)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine MakeMapMR2(jpatt,x,FORTHi,BACKi)

      USE General
      USE Symmetry
      USE Mappa, only : np, xmapC, FFTW_ESTIMATE, FFTW_MEASURE
      USE Param
      USE Riflessi_c, only : khlc, nRifDimC, fcvetc, fcvets
!
      implicit none
      integer*8    :: FORTHi, BACKi
      integer      :: jpatt, j, jn, i2(3)
      integer      :: n1, n2, n3, n0, i, l, ih, ik, il, lmod
      real         :: x(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      real         :: fourcoef, phase, phase1, twopim, ee, eep
      complex      :: fh, phasec, fm
!
      n1 = np(1)
      n2 = np(2)
      n3 = np(3)
      n0 = n1 / 2 + 1
!
!-- make plans
!
*     if (QualePgm == JAVPGM) then
          if (FORTHi == 0) then
             call sfftw_plan_dft_c2r_3d(FORTHi, n1, n2, n3, xmapC,x,
     *                                                 FFTW_ESTIMATE)
!C!               fftwf_plan_dft_c2r_3d(*n3, *n2, *n1, xmapC,xmap, *f)
             call sfftw_plan_dft_r2c_3d(BACKi,  n1, n2, n3, x,xmapC,
     *                                                 FFTW_ESTIMATE)
          endif
*         write(6,*) 'MakeMap ',FORTHi, BACKi, n1,n2,n3,FFTW_ESTIMATE
*     else
*         if (FORTHi == 0) then
*            call sfftw_plan_dft_c2r_3d(FORTHi, n1, n2, n3, xmapC,x,
*    *                                                 FFTW_MEASURE)
*            call sfftw_plan_dft_r2c_3d(BACKi,  n1, n2, n3, x,xmapC,
*    *                                                 FFTW_MEASURE)
*         write(6,*) 'MakeMap ',FORTHi, BACKi, n1,n2,n3,FFTW_ESTIMATE
*         endif
*     endif


      xmapC(:,:,:) = cmplx(0.0,0.0)

      twopim = -twopi
      do jn=1, nRifDimC
         eep     = fcvets(jn)
         ee      = fcvetc(jn)
         fh      = cmplx(ee, eep)
         do j=1, nsym
            do l=1,3
               i2(l) = khlc(1,jn) * kmat(j,1,l)
     *               + khlc(2,jn) * kmat(j,2,l)
     *               + khlc(3,jn) * kmat(j,3,l)
            enddo
            phase1 = khlc(1,jn) * tmat(j,1)
     +             + khlc(2,jn) * tmat(j,2)
     +             + khlc(3,jn) * tmat(j,3)

            phase = twopim * phase1
            fm = fh * phasec(phase)
*           write(6,*) i2,ee,eep,phase1
            if (i2(1) >= 0) then
                ih = lmod(i2(1),n0)
                ik = lmod(i2(2),n2)
                il = lmod(i2(3),n3)
                xmapC(ih,ik,il) = conjg(fm)
            endif
            if (-i2(1) >= 0) then
                ih = lmod(-i2(1),n0)
                ik = lmod(-i2(2),n2)
                il = lmod(-i2(3),n3)
                xmapC(ih,ik,il) = fm
            endif
         enddo
      enddo

      xmapC(0,0,0) = cmplx(f000, 0.0)

!!gpu call sfftw_execute(FORTHi)
      call sfftw_executec2r(n1,n2,n3,FORTHi,xmapC,x)
!C!        fftwf_execute(*p)

      return
      end
!-----------------------------------------------------------------------
      subroutine InvMap(khl,mkang,iphi,fcv,numbMax)
      USE General
      USE Mappa
      USE Param
      USE PhaseModule
!
      dimension khl(3,nreflDim),mkang(nreflDim),iphi(nreflDim),
     *  fcv(nreflDim)
cdedi
      if (invflag.ne.0) then
          call ModificaMappa()
      endif
!!gpu call NewInv(iphi,fcv,numbMax,np(1),np(2),np(3), BACK)
      call NewInvCuda(iphi,fcv,numbMax,np(1),np(2),np(3), BACK,xmap)
cdedi
      return
      end
!-----------------------------------------------------------------------
      subroutine maxmin(nx,ny,nz,x)
      USE General
      USE Param
!
      real x(1:nx, 1:ny, 1:nz)

      denmin =  1.0e25
      denmax = -1.0e25
      avden  =  0.0
      stden  =  0.0
!     denmax=maxval(x(1:nx,1:ny,1:nz))   ! ci mette 3 volte in piu'
!     denmin=minval(x(1:nx,1:ny,1:nz))   ! utilizzando maxval, minval, sum !!!!
!     avden =sum(x(1:nx,1:ny,1:nz))
!     stden =sum(x(1:nx,1:ny,1:nz)**2)
      do iz = 1, nz
         do iy = 1, ny
            do ix = 1, nx
               xx = x(ix, iy, iz)
               denmax = amax1(denmax, xx)
               denmin = amin1(denmin, xx)
               avden = avden + xx
               stden = stden + xx * xx
            enddo
         enddo
      enddo
!
      avden = avden / float(nx * ny * nz)
      stden = stden / float(nx * ny * nz) - avden * avden
      if (stden > 0.0) then
          stden = sqrt(stden)
      else
          stden = 0.0
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ModificaMappa()
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Param
      USE PhaseModule
      USE PhaseModule
c
cdedi

*---- Parametri per la subr. changemap  ----*
*---- invflag=0 Non modifica la densita'  ----*
*---- invflag=1 Modifica la densita': troncare a " den_p "  ----*
*---- invflag=2 Modifica la densita': troncare solo la parte negativa--*
*---- invflag=3 Modifica la densita': troncare a " den_p " e a " den_n "----*
*---- invflag=4 Modifica la densita': troncare a " den_p " + tutta la parte negativa ----*
*---- invflag=5 Modifica la densita': troncare a " den_p " e a " den_n " secondo sigma

      if (invflag.eq.0) then
          return
      endif
      npts   =  np(1)*np(2)*np(3)
      npts_p =  0
      npts_n =  0

      if (invflag.ne.5) then
          if (invflag.ne.2) then
              if (percMap.gt.0.0001) then
                  perc   = percMap
                  npts_p = npts * perc
              else
                  call cstop('Error wrong value for PercMap ')
              endif
          endif
    

!  invflag = 33  prevede il Flipping della parte negativa

!         if (invflag.eq.3) then
          if ((invflag.eq.3).or.(invflag.eq.6) .or. invflag == 33) then!liberato2009
              if (percMap_n.gt.0.0001) then
                   perc_n   = percMap_n
                   npts_n = npts * perc_n
              else
                   call cstop('Error wrong value for PercMap_Neg ')
              endif
          else
              perc_n = 0
              npts_n = 0
          endif
      else
         perc = 0.1
         npts_p = npts * perc
         perc_n = -1.0
         npts_n =  0
      endif
*     if (neutro == 2) then
*         perc = perc * 10
*     endif

      call denhist(0,xmap,xmap,npts_p,npts_n)

      aCheServe = 1
      if (aCheServe < 0) then

      npupos = 0
      npuneg = 0
      npudenp =0
      npudenn = 0
      do i = 0, np(1)-1
         do j = 0,np(2)-1
            do k = 0,np(3)-1
               if (xmap(i,j,k).gt.0.0) then
                  npupos = npupos + 1
               end if
               if (xmap(i,j,k).lt.0.0) then
                  npuneg = npuneg + 1
               end if
               if (xmap(i,j,k).ge.den_p) then
                  npudenp = npudenp + 1
               end if
               if (xmap(i,j,k).le.den_n) then
                  npudenn = npudenn + 1
               end if
            end do
         end do
      end do
!      write(6,67299) np,npupos,npuneg,
!     *                den_p,den_n
!67299 format('  BBBBB ',7i10,/,2f10.4)
!      write(lo,67298) np,npupos,npuneg,npudenp,npudenn,
!     *                den_p,den_n
!67298 format('  BBBBB ',7i10,/,2f10.4)
      
      endif

      sog=0.0
      npunti=np(1)*np(2)*np(3)
      n_p=0
      n_s=0
      npu1=0
      n_pos=0
      n_neg=0

      if (invflag == 11) then
          call changemap_hybrid(xmap,xmapApp)
      else
          call changemap(xmap,sog,invflag,npu1,n_pos,n_neg)
      endif

      return
      end
!-----------------------------------------------------------------------
      subroutine ModificaEnve()
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Param
      USE PhaseModule
c
cdedi

*---- Parametri per la subr. changemap  ----*
*---- invflag=0 Non modifica la densita'  ----*
*---- invflag=1 Modifica la densita': troncare a " den_p "  ----*
*---- invflag=2 Modifica la densita': troncare solo la parte negativa--*
*---- invflag=3 Modifica la densita': troncare a " den_p " e a " den_n "----*
*---- invflag=4 Modifica la densita': troncare a " den_p " + tutta la parte negativa ----*
*---- invflag=5 Modifica la densita': troncare a " den_p " e a " den_n " secondo sigma

      if (invflag.eq.0) then
          return
      endif
      npts   =  np(1)*np(2)*np(3)
      npts_p =  0
      npts_n =  0

      if (invflag.ne.5) then
          if (invflag.ne.2) then
              if (percMap.gt.0.0001) then
                  perc   = percMap
                  npts_p = npts * perc
              else
                  call cstop('Error wrong value for PercMap ')
              endif
          endif
    
!         if (invflag.eq.3) then
          if ((invflag.eq.3).or.(invflag.eq.6)) then!liberato2009
              if (percMap_n.gt.0.0001) then
                   perc_n   = percMap_n
                   npts_n = npts * perc_n
              else
                   call cstop('Error wrong value for PercMap_Neg ')
              endif
          else
              perc_n = 0
              npts_n = 0
          endif
      else
         perc = 0.1
         npts_p = npts * perc
         perc_n = -1.0
         npts_n =  0
      endif
*     if (neutro == 2) then
*         perc = perc * 10
*     endif

      call denhist(0,xenve,xenve,npts_p,npts_n)

      aCheServe = 1
      if (aCheServe < 0) then

      npupos = 0
      npuneg = 0
      npudenp =0
      npudenn = 0
      do i = 0, np(1)-1
         do j = 0,np(2)-1
            do k = 0,np(3)-1
               if (xenve(i,j,k).gt.0.0) then
                  npupos = npupos + 1
               end if
               if (xenve(i,j,k).lt.0.0) then
                  npuneg = npuneg + 1
               end if
               if (xenve(i,j,k).ge.den_p) then
                  npudenp = npudenp + 1
               end if
               if (xenve(i,j,k).le.den_n) then
                  npudenn = npudenn + 1
               end if
            end do
         end do
      end do
!      write(6,67299) np,npupos,npuneg,
!     *                den_p,den_n
!67299 format('  BBBBB ',7i10,/,2f10.4)
!      write(lo,67298) np,npupos,npuneg,npudenp,npudenn,
!     *                den_p,den_n
!67298 format('  BBBBB ',7i10,/,2f10.4)
      
      endif

      sog=0.0
      npunti=np(1)*np(2)*np(3)
      n_p=0
      n_s=0
      npu1=0
      n_pos=0
      n_neg=0

      if (invflag == 11) then
          call changemap_hybrid(xenve,xmapApp)
      else
          call changemap(xenve,sog,invflag,npu1,n_pos,n_neg)
      endif

      return
      end
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      subroutine changemap(x,sog,jflag,npu1,n_pos,n_neg)
      USE General
      USE Mappa, only : np
      USE Param
c
      real x(1:np(1),1:np(2),1:np(3))
 
*---- jflag=0 Non modifica la densita'  ----*
*---- jflag=1 Modifica la densita': troncare a " den_p "  ----*
*---- jflag=2 Modifica la densita': troncare la parte negativa--*
*---- jflag=3 Modifica la densita': troncare a " den_p " e a " den_n "----*
*---- jflag=4 Modifica la densita': troncare a " den_p " + tutta la parte neg.
*---- jflag=5 Modifica la densita': troncare a " den_p " e a " den_n " secondo sigma


!     SOGmin=0.32*volume
!     SOGmax=2.0*volume
      nx=np(1)
      ny=np(2)
      nz=np(3)
      n_p=0
      n_s=0
      npu1=0
      n_pos=0
      n_neg=0
      if (jflag == 5) then
          write(lo,20) CoefSigma_p,CoefSigma_n, stden
   20 format(' Coefficienti per +(%) & -(%) per StD ',2f6.2,
     *       ' StD =',f10.4)
          SogSigma_p = CoefSigma_p*stden
          SogSigma_n = CoefSigma_n*stden
      endif
      do 150 k=1,nz
         do 100 j=1,ny
            do 50 i=1,nx
               xx=x(i,j,k)
               if (sog.gt.0.0.and.x(i,j,k).gt.sog) then
                    x(i,j,k)=sog
                    npu1=npu1+1
               endif

               if (jflag.eq.0) then
                  n_p=n_p+1
               elseif (jflag.eq.1) then
                  if (xx.lt.den_p.or.xx.le.0.0) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                     n_pos=n_pos+1
                  endif
               elseif (jflag.eq.2) then
                  if ( xx.le.0.0 ) then
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  else
                     n_p=n_p+1
                  endif
               elseif (jflag.eq.3) then
                  if (xx.ge.den_p.or.xx.le.den_n) then
                     n_p=n_p+1
                     if (xx.ge.den_p) then
                         n_pos=n_pos+1
                     elseif (xx.le.den_n) then
                         x(i,j,k) = x(i,j,k) * 0.75
                         n_neg=n_neg+1
                     endif
                  else
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  endif

               elseif (jflag.eq.33) then
                  if (xx.ge.den_p.or.xx.le.den_n) then
                     n_p=n_p+1
                     if (xx.ge.den_p) then
                         n_pos=n_pos+1
                     elseif (xx.le.den_n) then
                         x(i,j,k) = -x(i,j,k)   ! flipping
                         n_neg=n_neg+1
                     endif
                  else
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  endif


               elseif (jflag.eq.4) then
                  if (xx.ge.den_p.or.xx.lt.0.0) then
                     n_p=n_p+1
                     if (xx.ge.den_p) then
                         n_pos=n_pos+1
                     elseif (xx.lt.0.0) then
                         n_neg=n_neg+1
                     endif
                  else
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  endif
               elseif (jflag.eq.5) then
                  if (xx.gt.0.0) then
                     if (xx.ge.SogSigma_p) then
                        n_pos = n_pos+1
                     else
                        x(i,j,k)=0.0
                     end if
                  end if
                  if (xx.lt.0.0) then
                     if (abs(xx).ge.SogSigma_n) then
                        n_neg = n_neg+1
                     else
                        x(i,j,k)=0.0
                     end if
                  endif
               elseif (jflag.eq.6) then!liberato2009
                  if (xx.ge.den_n) then
                     n_p=n_p+1
                     if (xx.ge.den_p) then
                         n_pos=n_pos+1
c                    elseif (xx.le.den_p) then 
                     elseif (xx.le.0.0) then 
                         x(i,j,k) = -x(i,j,k)
                         n_neg=n_neg+1
                     endif
                  else
                     x(i,j,k)=0.0
                     n_s=n_s+1
                  endif
               elseif (jflag.eq.7) then!liberato2009
                     if (xx.ge.den_p) then
                         n_pos=n_pos+1
                     else
                         x(i,j,k) = -x(i,j,k)
                         n_neg=n_neg+1
                     endif
               endif
  50        continue
 100     continue
 150  continue

      if (jflag.eq.5) then
         nputot = nx*ny*nz
         p1= float(n_pos)/nputot
         percMap= float(n_pos)/nputot
         p2= float(n_neg)/nputot
         percMap_n= float(n_neg)/nputot
!         write(lo,6789) n_pos,p1,n_neg,p2
! 6789 format(' nnnnnnn ',i10,f8.4,i10,f8.4)
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine changemap_hybrid(x,x1)
      USE General
      USE Mappa, only : np
      USE Param
      USE PhaseModule, only: Iterazione
 
c
      real x(1:np(1),1:np(2),1:np(3))
      real x1(1:np(1),1:np(2),1:np(3))
 
*---- jflag=1 Modifica la densita': troncare a " den_p "  ----*


      nx=np(1)
      ny=np(2)
      nz=np(3)
      n_p=0
      n_n=0
      cof = 0.5 + 0.1 * Iterazione
      cof = min(1.0,cof)
      do 150 k=1,nz
         do 100 j=1,ny
            do 50 i=1,nx
               xx=x(i,j,k)
               xx1=x1(i,j,k) * cof
               if (xx.lt.den_p.and.xx > 0.00001) then
!              if (xx.lt.den_p) then
                   x(i,j,k)=xx-xx1
                   n_p=n_p+1
               elseif (xx < 0.00001) then
                   x(i,j,k)=0.0
                   n_n=n_n+1
               endif
  50        continue
 100     continue
 150  continue

      return
      end
!-----------------------------------------------------------------------
      subroutine ccorr(x,z,npunti,corre)

      dimension x(npunti), y(20000), z(npunti)
c
      sumx = 0.0
      sumy = 0.0
      do i=1,npunti
         y(i) = z(i)
         sumx = sumx + x(i)
         sumy = sumy + y(i)
      enddo
      scala = sumx / sumy
      do i=1,npunti
         y(i) = y(i) * scala
      enddo
      vmedt=0.0
      vmedc=0.0
      vmedtc=0.0
      vmed2t=0.0
      vmed2c=0.0
      do ix=1,npunti
         xx1 = x(ix)
         xx2 = y(ix)
         vmedt=vmedt + xx1
         vmedc=vmedc + xx2
         vmedtc=vmedtc + xx1 * xx2
         vmed2t=vmed2t + xx1 * xx1
         vmed2c=vmed2c + xx2 * xx2
      enddo
      vmedt=vmedt/float(npunti)
      vmedc=vmedc/float(npunti)
      vmedtc=vmedtc/float(npunti)
      vmed2t=vmed2t/float(npunti)
      vmed2c=vmed2c/float(npunti)

      rnum=vmedtc - (vmedt*vmedc)
      rden=sqrt(vmed2t-vmedt**2) * sqrt(vmed2c-vmedc**2)
      corre=rnum/rden
!
      return
      end
!-----------------------------------------------------------------------

