!-----------------------------------------------------------------------
      MODULE QModule
         integer :: l13, m13, md13, n13, l13a, m13a, md13a, n13a
         integer :: md13b, md13h, md13o, md13flag, l13g, n13g, sys13
         common /lst13/ l13, m13, md13, n13, l13a, m13a, md13a, n13a,
     *                  md13b, md13h, md13o, md13flag, l13g, n13g, sys13
      END MODULE QModule
!-----------------------------------------------------------------------
c-- sir code for invariants                      Release 2004.01
      subroutine invar(ier, ksubr, ifFromGraphic, ifFromPhase)
      USE General
      USE Symmetry
      USE Riflessi
      USE InvarStuff
      USE PhaseModule
c
c-- invariant main routine
c
      common /inp/  natom,fnat,atoms
      common /proc/ iftr,ifp10,ifnq,ifps,ifcoc
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common/dirps/npsa
!psie
!psie      common/dirps/npsa
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,numbQuart
     1 ,nsog,sqes,nquam,nquat,ecr1,iecr1
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
      common/esti/ib(3),ih(3,2,24),ii(2,24)
      common/nq/nor1(6),nop1(6),iseg1(6),icodqn,sumc,sums,sume
      common/wrt/icv(4,7),ishf,ifas,eewrt(3),icodx(3),iqua(1000),
     1           itac(5,24,4),eee(3)
      common/zero/argq(26),ncal(26),nver(26),ntt,fm(26),gt(26)
      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
     *                  NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!psie
!psie      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
!psie     *                   NPsie,NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
c
      character rescha(7)*32,line(2)*8, form *7
   
      integer risultati(7,2)
c
      data rescha/
     *            '     positive estimated triplets',
     *            '     negative estimated triplets',
     *            ' enantiomorph sensitive triplets',
     *            '               psi-zero triplets',
     *            '                  psi-e triplets',
     *            '     negative estimated quartets',
     *            ' enantiomorph sensitive quartets'/
c
      ier = 0
      if (nrefltot.le.0) then
          Msg = 'No reflections stored. Possible programming error'
          call MsgWinErr('Error', Msg, ERR_WINDOW, nEx)
          ier = -1
          return
      endif
      ifWarning = 0
      if (ifFromPhase == 0) then
          call RoutineHeader('Invariants')
      endif
c
c-- read directives
c
      call dirinv(ifFromGraphic, ifFromPhase, ier)
      if (ier.lt.0) then
          return
      endif
      if (ifFromPhase /= 0 .and. ifPatt > 0) then
          ifnq = 0
          ifps = 0
      endif
!
      call Cancella(34)
!
      if (kmad /= 2) then
          ksubr = 2
          call LeggiRiflessi(ier,ksubr)
      endif
      call NewMaxHKL(1)
      
c
c-- allocate work area
c
!psie
!psie      npse = nstr
!psie      ntot_pse = nstr + npse
!      if (ntot_pse > 4000) then
!          npse = 4000 - nstr 
!      end if    
!psi-e

      itabmx = (nstr + nzro) * nsym
      if (itabmx.lt.8000) then
          itabmx = 8000
      endif
      ifat1=(2*ihmx(3)+1)*(2*ihmx(2)+1)
      ifat2=(2*ihmx(3)+1)
      ifatx=ihmx(1)*ifat1+ihmx(2)*ifat2+ihmx(3)

      call AllocaInvarStuff(1)

      call inpt9
      emin = evet(nstr)
!pgMAD
      if (kmad == 1) then
         s3s2 = s3s2mad
      elseif (kmad == 2) then
         s3s2 = s3s2d(WhichDeriv)
      end if
!pgMAD
c

c-- if known structure the statistics are always performed
      if (ifp10.eq.0.and.ifcoc.eq.1) then
         numk=-1
         ifp10=2
      endif
      do i=1,7
         do j=1,2
            risultati(i,j)=0
         enddo
      enddo
c--
      if (iftr > 0) then
          call strip9(0,risultati,ifFromPhase,ier)
          if (ier.lt.0) then
              return
          endif
          numcoc=risultati(1,2)
!         write(lo,2998)
!2998     format(/,25x,'Triplets statistic ',/)
          if (ifFromPhase == 0) then
              write(lo,1410) numcoc,nstr,emin
              if (ifcoc.eq.0.and.numk.gt.0) then
                  write(lo,1420) numk
              endif
          endif
          ier = 0
          call p10n(ifWarning, risultati, ifFromPhase, ier)
!
          call PreparaIph(1, 0)
c
          write(Msg,1450) risultati(1,2),risultati(2,2),nstr
          if (kmad /= 0) then
             write(Msg,'(i8)') risultati(1,2)
             call shift(Msg, k1)
             write(Inte,'(i5)') nstr
             call shift(Inte, k2)
!pgMAD1011
             if (ifcoc.eq.0.and.numk.gt.0) then
                form = 'P10'
             else
                form = 'Cochran'
             end if
             write(Msg(k1+2:),6023) form(1:lung(form)),Inte(1:k2)
         endif
 6023    format('triplet invariants are estimated via ', a,
     *          ' formula using the best ', a,' reflections ')
          call RunToolBar(1,Msg)
!pgMAD1011
!
          call toflush()
!
          if (ier.lt.0) return
          if (ifcoc.ne.0.or.numk.le.0) then
              call Cancella(10)
              call Cancella(11)
              write(lo,1430)
          endif
      endif
      
!psie      
!psie          call strip9(2,risultati,ifFromPhase,ier)
!psie          call PreparaIph(5, 0)
!psie
!psie          if (ksize > 3) then
!psie             MaxPsi0 = 8000
!psie         end if
      
      if (kmad == 0) then
          call quintets(risultati,ifFromPhase)
!mrmr          call quintets(risultati,kverbo,ifFromPhase)
!mr kverbo e' nel modulo General e in quintets c'e' gia' USE General
      end if
c-- final print
      if (ifFromPhase == 0) then
cdedi if (ifFromPhase == 0 .or. knw == 1) then  ! dedi 21/05/10  per prova modifica conver SelAlfa
          write(lo,1500)
          do i=1,7
             if (i.ne.3.and.i.ne.5.and.i.ne.7) then
                 do j=1,2
                    if (risultati(i,j).eq.0) then
                        write(line(j),1600)
                    else
                        write(line(j),1700) risultati(i,j)
                    endif
                 enddo
                 write(lo,2100) rescha(i),(line(j),j=1,2)
             endif
          enddo
      endif
!
      call AllocaInvarStuff(2)
!
      call toflush()
      call PrintMess(' ')
      call NewMaxHKL(2)
!
      return
!
*  10 format(///,a1 ,78('+'),//,
*    1 39h Sir2002 : Invariants routine          ,26x,14hRelease  01.00
*    2 ,//,1h ,20a4,/,1h ,78('+'),/)
 1410 format(/,i8,' triplets found among ',i4,
     *            ' strongest reflections (E-min =',f6.3,')')
 1420 format(  23x,'strengthned by ',i3,
     *            ' free vectors using P-10 formula',/)
 1430 format(  20x,'+++++  Cochran formula has been used  +++++',/)
 1450 format(i6,' triplets (',i3,' negative) using ',i4,
     *       ' strong reflections   ')
 1500 format(//,41x,'number of relationships',/
     *         ,41x,'  calculated   stored   ')
 1600 format('       -')
 1700 format(i8)
 2100 format(/, 9x,a32,a8,3x,a8)
      end
c -----------------------------------------------------------
      subroutine inpt9
      USE General
      USE Symmetry
      USE InvarStuff
c
      common /inp/  natom,fnat,atoms
      common /proc/ iftr,ifp10,ifnq,ifps,ifcoc
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common/dirps/npsa
!psie      
!psie      common/dirpse/npse
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,numbQuart
     1 ,nsog,sqes,nquam,nquat,ecr1,iecr1
c
!pgMAD
      if (kmad == 1) then
         s3s2 = s3s2mad
      elseif (kmad == 2) then
         s3s2 = s3s2d(WhichDeriv)
      end if
!pgMAD
      fnat=s3s2
c---- compute the number of free vectors
      msym=nsym*(icent+1)
      atoms=(1.0/fnat)**2
      natom=int(atoms+0.05)
      if (numk.eq.0) then
          numk=natom/msym+30
          numk=min0(numk,70)
      endif
      icst1=268435456
      icst2=134217728
      icst3= 131072
      nupos=0
c -- set the max. numb. of enant. and neg. triplets to write onto jrel
      nmxtn=500
c -- set the numb. of neg. quartets to calculate and write onto jrel
      nquam = 5000
      nquat = 4000
c
      jmme=msym
      emme=float(jmme)
      ic=0
      ict=0
      alfa=0.0
c ---      set some default values
      if(nzro.gt.maxpsi) nzro=maxpsi
c
      if (numk.gt.nstr) numk=nstr
c
      nstr=max0(nstr,numk)
      if (nrefl-nzro.le.nstr) then
          nzro=nrefl-nstr
      endif

      return
      end
c-----------------------------------------------------------------------
      subroutine strip9(jpsi0,risultati,ifFromPhase,ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE InvarStuff
      USE PhaseModule, only : ifPatt
c--calculate triplets
c
      common /inp/  natom,fnat,atoms
      common /proc/ iftr,ifp10,ifnq,ifps,ifcoc
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common/dirps/npsa
!psie      
!psie      common/dirpse/npse
!psie      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
!psie     *                   NPsie,NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
      
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,numbQuart
     1 ,nsog,sqes,nquam,nquat,ecr1,iecr1
c
      common /cp10/ nor(3),dumd(156)
      common /jrtew/ ipsi0
c--
      integer risultati(7,2)
      dimension ill(3)
      dimension ist(2,3),gt(3),iphit(3),ivet(48)
c
c--description of some important settings
c
c  h1 = h2 + h3
c  i  h1 code
c  j  h2 code
c in  h3 code
c     ipsi0 = 0   ->  sigma2
c     ipsi0 = 1   ->  psi-zero !!!or psi-e
c     ipsi0 = 2   ->  psi-e
c
c*******************************************************************
!psie     
!psie      if (jpsi0 ==2) then
!psie         iprin  = 1
!psie      else
!psie         iprin = 0
!psie      end if
      
      jh1 = 0
      ipsi0 = jpsi0
      npsi0=0
      nsteps = 5
      nstep  = 0
 9999 iconts = 0
      if (ifPatt > 0) then
          call scrper('Initialize Figures of Merit    ',0,0)
          nstep = nstep + 1
      else
          if (ipsi0.eq.0) then
              call PrintMess('Computing triplet relationships.')
              nstep = nstep + 1
!psie              
!psie          elseif(ipsi0.eq.2) then
!psie              call PrintMess('Computing psi-e relationships.')
!psie             nstep = nsteps
              
          else
              call PrintMess('Computing psi-zero relationships.')
              nstep = nsteps
          endif
      endif
      if (nstep.gt.nsteps) then
          nstep = nsteps
      end if
      nreftri = nstr
c--clear the areas
      if (icent.eq.1) then
          call clrt
          call clrt1
      else
          call nclrt
!         call nclrt_Stat_Trip()
          call nclrt1
      endif
      do k=1,itabmx
         itab(k)=0
      enddo
      do i=1,ifatx
         isr(i)=0
      enddo
c--create the list
      ipu=0
      do 1900 j=1,nreftri
         ipu = (j-1) * nsym
         do 1100 i=1,nsym
            do i1=1,3
               ill(i1)=0
               do j1=1,3
                  ill(i1)=ill(i1)+khl(j1,j)*kmat(i,j1,i1)
               enddo
            enddo
            indr=ill(1)*ifat1+ill(2)*ifat2+ill(3)
            indrr=indr
            if (i.ne.1) then
                imen1=i-1
                do i1=1,imen1
                   if (indr.eq.ivet(i1)) indrr=0
                enddo
            endif
            ipu=ipu+1
            ivet(i)=indrr
            a=khl(1,j)*tmat(i,1)+khl(2,j)*tmat(i,2)+khl(3,j)*tmat(i,3)
            k=nint(a*24.)
            k=mod(k,24)
            if (k.lt.0) k=k+24
            itab(ipu)=indrr
            itabK(ipu) = ill(2)
            itabL(ipu) = ill(3)
            itabO(ipu) = k
            isgn=isign(1,indr)
            indr=iabs(indr)
            if (isr(indr).eq.0) isr(indr)=(j*100+i)*isgn
 1100    continue
 1900 continue
      n8t=300000
c
      if (ipsi0.gt.0)n8t=MaxPsi0  ! test
      jsup =nreftri-1
      if(ipsi0.ne.0) jsup=nreftri-1
c--calculate sigma 2
      jt=0
      n8=0
      n8e=0
      sgg=0.0
      if (ipsi0.eq.0) then
          call scrper('Set up sigma2 relationships',0,-1)
!psie       elseif (ipsi0.eq.2) then
!psie          call scrper('Set up psi-e relationships',0,-1)
       else
          call scrper('Set up psi-zero relationships',0,-1)
      endif

      if (iprin.gt.0) then
          if (ipsi0.eq.0)write(lo,1525)
          if (ipsi0.gt.0)write(lo,1535)
      endif

1525  format(/,' set up sigma2 relationships')
1535  format(/,' set up psi-zero relationships')
c--first loop
c
      do i=1,3
         do j=1,n8t
            isig(i,j)=0
         enddo
      enddo
      ninf=1
      nsup = nreftri- 2
      if (ipsi0.ne.0) then
          ninf=nrefl-nzro+1
          nsup=nrefl
          istart = nsup
          iend = ninf
          istep = -1
!psie      elseif(ipsi0.eq.2) then
!psie          ninf = nreftri + 1
!psie          nsup = nreftri + npse
!psie          istart = ninf
!psie         iend = nsup
!psie          istep = 1
      else
          istart = ninf
          iend = nsup
          istep = 1
      endif

      do 2000 i=istart,iend,istep
         zer=0.0001
         js=0
         if (kmad.eq.0) then
            e1Val = evet(i)
         else
! gianluca
            ke1 = int(evet(i)*100.+0.5)*512
            e1Val = float(ke1/512)/100.
! gianluca
         endif
         ityp1 = mkang(i)
         if(n8.lt.n8t) goto 1580
         if(ipsi0.gt.0)go to 1580
         jg=nint(e1Val*e1Val*e1Val*fnat*100.0)
!        if(icent.eq.0) jg=2.*jg
         jc=int(gq(n8)*100.)
         if(jg.lt.jc )go to 2400
 1580    if(iprin.lt.2) goto 2005
         ill(1) = khl(1,i)
         ill(2) = khl(2,i)
         ill(3) = khl(3,i)
         ifi = ipub(i)
         write(lo,2004) (ill(n),n=1,3),i,e1Val,ifi
 2004    format(/,' reflection ',3i4,10x,
     1            'code = ',i4,10x,
     2            'e = ',f7.2,10x,
     3            'phase =',i7,/)
 2005    if(ipsi0.eq.0) then
            inn1=(i-1)*nsym+1
            jk1 = itabK(inn1)
            jl1 = itabL(inn1)
            i1=i
         else
            jh1=khl(1,i)
            jk1=khl(2,i)
            jl1=khl(3,i)
            i1=0
         endif
c
c--second loop
c
         if (ipsi0.gt.0) then
            ih31=jh1*ifat1+jk1*ifat2+jl1
         else
            ins=(i-1)*nsym+1
            ih31=itab(ins)
         endif
         jinf=i1+1
         do 2100 j=jinf,jsup
            if (kmad.eq.0) then
                e2Val = evet(j)
            else
! gianluca
                ke2 = int(evet(j)*100.+0.5)*512
                e2Val = float(ke2/512)/100.
! gianluca
            endif
            ityp2=mkang(j)
            i0=2*nsym
            do 2110 ii=1,i0
               ivet(ii)=0
 2110       continue
            i0=0
            jn=(j-1)*nsym
            do 2200 k=1,nsym
               jnk=jn+k
               if(itab(jnk).eq.0) goto 2200
               jk2 = itabK(jnk)
               jl2 = itabL(jnk)
               do 2300 l=1,3,2
                  l1=l-2
                  ih32=itab(jnk)
                  ih3=ih31+ih32*l1
                  l3=1
                  if(ih3) 2010,2300,2020
 2010             l3=-1
                  ih3=-ih3
 2020             if(ih3.gt.ifatx) go to 2300
                  if(isr(ih3).eq.0) go to 2300
                  jk=iabs(jk1+jk2*l1)
                  if(jk.gt.ihmx(2)) go to 2300
                  jl=iabs(jl1+jl2*l1)
                  if(jl .gt.ihmx(3)) go to 2300
                  if(isr(ih3).lt.0) l3=-l3
                  isra=isr(ih3)
                  isra=iabs(isra)
                  in=isra/100
                  if(in.le.j) go to 2300
                  if (in.gt.jsup+1) goto 2300
                  if(i0.eq.0)go to 2030
                  do 2040  ii=1,i0
                     if(in.eq.ivet(ii))go to 2300
 2040             continue
 2030             i0=i0+1
                  ivet(i0)=in
                  in3=isra-in*100
                  ins=(in-1)*nsym+in3
                  ns3 = itabO(ins)
                  ns2 = itabO(jnk)
                  isp =-ns2*l1+ns3*l3+48
                  isp =mod(isp ,24)
                  iss=isp*360/24
c
c  phi(t)=phi(h1)-phi(h2)-phi(h3)+shift(fase)
c  i codici sono per  h1 = h2 + h3
c  cod(h2)= -l1 * j
c  cod(h3)=  l3 * in
c
                  iphi = ipub(i) + ipub(j)*l1 - ipub(in)*l3 + iss
                  if(iphi.lt.0)iphi=iphi+3600
                  iphi=mod(iphi,360)
                  if (kmad.eq.0) then
                      e3Val=evet(in)
                  else
! gianluca
                      ke3 = int(evet(in)*100.+0.5)*512
                      e3Val = float(ke3/512)/100.
! gianluca
                  endif
                  ityp3=mkang(in)
c --------------------------------------------------------------------
c
c   routine for triplets symmetry inconsistent
c
c --------------------------------------------------------------------
                  if(icent.gt.0) goto 5000
                  if(ityp1.eq.1.or.ityp2.eq.1.or.ityp3.eq.1) goto 5000
                  isotyp=(ityp1-1) + l1*(ityp2-1) - l3*(ityp3-1)
                  isopha=isotyp*15 + iss
                  imo=mod(isopha,180)
                  if(imo.eq.0) goto 5000
                  iconts=iconts+1
                  goto 2300
c --------------------------------------------------------------------
 5000             g=fnat*e1Val*e2Val*e3Val
c
      if(icent.eq.0) g=2.*g
c
      gb=g
      if(g.gt.20.47) gb=20.47
      jg=nint(gb*100.0)
      js=js+1
      if (ipsi0.gt.0.and.js.gt.80) then
          go to 2100
      endif
** non piu' di 80 triplette per riflesso
*     if (ipsi0.le.0.and.js.gt.80) go to 2100
      if(iprin.lt.2)go to 2027
      jt=jt+1
      ist(1,jt)=-j*l1
      ist(2,jt)=in*l3
      gt(jt)=g
      iphit(jt)=iphi
      if(jt.ne.3) go to 2027
      write(lo,2026) ((ist(n,nn),n=1,2),gt(nn),iphit(nn),nn=1,3)
 2026 format(3(2x,2i6,f7.2,i5))
      jt=0
 2027 if(n8.eq.n8t) go to 2320
      n8=n8+1
      gq(n8)=g
      sgg=sgg+gq(n8)
c *******************************************************
c **  isp  =  d-shift del tripletto
c **  i    =  code del primo riflesso
c **  j    =  code del secondo riflesso
c **  in   =  code del terzo riflesso
c **  k    =  operatore di simm. del secondo riflesso
c **  in3  =  operatore di simm. del terzo riflesso
c **  l1   =  segno del secondo riflesso
c **  l3   =  segno del terzo riflesso
c **  jg   =  int(g*100)
c **  iphi =  fase reale del tripletto
c *********************************************************
      if (ipsi0.eq.0) then
         isig(1,n8)=((i+4096)*8192+l1*j+4096)*32+iphi/15+1
      else
         isig(1,n8)=((nrefl-i+4096)*8192+l1*j+4096)*32+iphi/15+1
      end if
!psie      
!psie      if (ipsi0.eq.0) then
!psie         isig(1,n8)=((i+4096)*8192+l1*j+4096)*32+iphi/15+1
!psie      elseif (ipsi0.eq.2) then
!psie         isig(1,n8)=((i-nreftri+4096)*8192+l1*j+4096)*32+iphi/15+1
!psie      else
!psie         isig(1,n8)=((nrefl-i+4096)*8192+l1*j+4096)*32+iphi/15+1
!psie      end if
      isig(2,n8)=((-l3*in+4096)*8192+jg+4096)*32+isp+1
      isig(3,n8)=((k*32+in3)*8192+jg+4096)*32+mod(iphi,15)+1
      go to 2300
 2320 if(ipsi0.gt.0)go to 2400
      if(n8e.ne.0)go to 2330
      call sortgn(n8)
      n8m=n8
      n8l=n8
      gm=gq(n8m)
 2330 n8e=n8e+1
      if(g.lt.gm)go to 2300
      sgg=sgg-gq(n8m)+g
      gq(n8m)=g
      isig(1,n8m)=((i+4096)*8192+l1*j+4096)*32+iphi/15+1
      isig(2,n8m)=((-l3*in+4096)*8192+jg+4096)*32+isp+1
      isig(3,n8m)=((k*32+in3)*8192+jg+4096)*32+mod(iphi,15)+1
      gm=100.
      n8lm1=n8l-1
      if(n8lm1.lt.1) n8lm1=1
      do 2340 ii=n8lm1,n8
      ga=gq(ii)
      if(ga.gt.gm)go to 2340
      gm=ga
      n8m=ii
 2340 continue
      n8l=min0(n8l,n8m)
 2300 continue
 2200 continue
 2100 continue
      if(iprin.lt.2) go to 2000
      if(jt.eq.0) go to 2002
      write(lo,2026) ((ist(n,nn),n=1,2),gt(nn),iphit(nn),nn=1,jt)
      jt=0
2002  continue
      write(lo,2101) js
2101  format(' number of contributors =',i6)
      js=0
2000  continue
2400  continue
      if (iconts > 0 .and. ipsi0 == 0 .and. ifFromPhase == 0) then
          write(lo,2410) iconts
      endif
2410  format(/,' Number of symmetry inconsistent triplets rejected:',
     *       i5,/)
crocco
      n8e=n8e+n8
      if (ipsi0.eq.0) then
          if (kverbo.ne.0) then
              do i = 1, n8
                 call decom(i,g,ggv,ishi,ib)
                 b=float(ib)*dtor
                 a=cos(b)
                 an=a*gq(i)
                 if (icent.eq.1) then
c-- centrosymmetric test
                    gval=gq(i)
                    if (knw.eq.1) then
                        call sctst(gval,an,1)
                    else
                        call sctst1(gval,an)
                    endif
                 else
c-- noncentrosymmetric test
                    bb=sin(b)
                    g2=gq(i)
                    call besse(g2,coat)
                    bang=ib
                    if (ib.gt.180) bang=360.0-bang
                    if (knw.eq.1) then
                       call nctet(g2,a,bang,1)
!                      call Stat_Trip(g2,a,bang,1)
                    else
                       call nctet1(g2,coat,a)
                    endif
                    an=coat*a
                 endif
              enddo
              write(lo,2998)
 2998 format(/,25x,'Cochran statistic ',/)
              if (icent.le.0) then
c--  stampa il test (non centro)
                 if (knw.eq.1) then
                     call nstst
!                    call Prt_Stat_Trip()
                 else
                     call nstst1
                 endif
              else
c--  stampa il test (centro)
                 if (knw.eq.1) then
                     call stst
                 else
                     call stst1
                 endif
              endif
          endif
c--clear the areas
          if (kverbo.ne.0) then
              write(lo,3000)n8e,n8
          endif
          risultati(1,1)=n8e
          risultati(1,2)=n8
          if (n8.le.0) then
              Msg = 'No triplets found. Increase the number of ' //
     *              'strong reflections.'
              call MsgWinErr('Error', Msg, ERR_WINDOW, nEx)
              ier = -1
          else
              call sortgn(n8)
              igm = gq(n8) * 1000.
          endif
          ntra=n8
          else
!psie          
!psie      elseif (ipsi0.eq.1) then
          npsa=n8
          if (iprin.gt.0) write(lo,4000)n8e,n8,npsi0
          risultati(4,1)=n8e
          risultati(4,2)=n8
!psie      else
!psie          Npsie=n8
!psie          if (iprin.gt.0) write(lo,6000)n8e,n8
!psie          risultati(5,1)=n8e
!psie          risultati(5,2)=n8
          
      endif
 3000 format(/,i8,' triplets calculated and',i8,' stored')
 4000 format(/,i8,' psi-zero triplets calculated and',i8,' stored',
     1 i6,' rejected')
!psie      
!psie 6000 format(/,i8,' psi-e triplets calculated and',i8,' stored')

      return
      end
c-----------------------------------------------------------------------
      subroutine equit(x,k)
      USE Symmetry
c
c-- calcola il riflesso equivalente per la matrice  k-esima
c
      integer x(3),x1(3)
c
      do i=1,3
         x1(i)=0
         do j=1,3
            x1(i)=x1(i)+x(j)*kmat(k,j,i)
         enddo
      enddo
      do i=1,3
         x(i)=x1(i)
      enddo
!
      return
      end
c----------------------------------------------------------------
      subroutine decom(i,g,ggv,ishi,iphi)
      USE General
      USE Riflessi
      USE InvarStuff
!
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
      common /jrtew/ ipsi0
!
      isave=iabs(isig(1,i))/32
      if1=iabs(isig(1,i))-isave*32 -1
      kod1=isave/8192
      nor(2)=isave-8192*kod1-4096
      kod1=kod1-4096
      if (ipsi0.ne.0) then
         kod1 = nrefl - kod1
      endif
      nor(1) = kod1
      call unpak3Sir(isig(2,i),nor(3),ign,ishi)
      call unpak3Sir(isig(3,i),kod,igv,if2)
      g=float(ign)/100.
      ggv=float(igv)/100.
      iphi=if1*15+if2
      kod=kod+4096
      nop(1)=1
      nop(2)=kod/32
      nop(3)=mod(kod,32)
      do j=1,3
         iseg(j)=isign(1,nor(j))
         nor(j)=iabs(nor(j))
         k=nor(j)
         if (kmad.eq.0) then
             e = evet(k)
         else
! gianluca
             ke = int(evet(k)*100.+0.5)*512
             e = float(ke/512)/100.
! gianluca
         endif
         eeb(j)=e*e-1.
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine recip()
      USE General
      USE Symmetry
      USE Riflessi
      USE InvarStuff
!
c--carica il reciproco
      common /inp/  natom,fnat,atoms
      common /proc/ iftr,ifp10,ifnq,ifps,ifcoc
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common /dirps/npsa
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common /dirqn/ecros,iecros,ncode,icody,numbQuart
     1 ,nsog,sqes,nquam,nquat,ecr1,iecr1
      common /enant/ nqenex,n23m,n23l,gm,nqen
      common /esti/ib(3),ih(3,2,24),ii(2,24)
      common /nq/nor1(6),nop1(6),iseg1(6),icodqn,sumc,sums,sume
      common /wrt/icv(4,7),ishf,ifas,ee(3),icodx(3),iqua(1000),
     1           itac(5,24,4),eee(3)
c--
      dimension ill(3),ikln(60),ivet(12),vet(12)
c

      equivalence (ivet(1),vet(1))
c--
c--clear the areas
      do k=1,itabmx
         itab(k)=0
      end do 
      do i=1,ifatx
         isr(i)=0
      end do
c--create the list
      ipu=0
      do 1900 j=1,nstr
         ihh = khl(1,j)
         ik = khl(2,j) 
         il = khl(3,j)
         do 1100 i=1,nsym
            ipu = ipu + 1
            if (i.eq.1) then
               indr=ihh*ifat1+ik*ifat2+il
               itabH(ipu) = ihh
               itabK(ipu) = ik
               itabL(ipu) = il
            else
      ill(1)=ihh*kmat(i,1,1)+ik*kmat(i,2,1)+il*kmat(i,3,1)
      ill(2)=ihh*kmat(i,1,2)+ik*kmat(i,2,2)+il*kmat(i,3,2)
      ill(3)=ihh*kmat(i,1,3)+ik*kmat(i,2,3)+il*kmat(i,3,3)
      indr=ill(1)*ifat1+ill(2)*ifat2+ill(3)
               itabH(ipu) = ill(1)
               itabK(ipu) = ill(2)
               itabL(ipu) = ill(3)
            endif
            indrr=indr
            indra=iabs(indr)
            if (i.ne.1) then
c -----   elimina i doppioni
               imen1=i-1
               do 1106 i1=1,imen1
                  if (indra.eq.iabs(ikln(i1))) indrr=0
 1106          continue
            endif
            itab(ipu)=indrr
            ikln(i)=indrr
            a=ihh*tmat(i,1)+ik*tmat(i,2)+il*tmat(i,3)
            ia=nint(a*24)+480
            ia=mod(ia,24)
!            itab1(ipu)=itab1(ipu)*32+ia
            itabO(ipu) = ia
            indr=iabs(indr)
            if(isr(indr).eq.0) then
                isr(indr)=-(icst1+j)
            endif         
 1100    continue
 1900 continue
c--carica i deboli
      j400a=nrefl-nzro+1
      j400b=nrefl
      do 3000 j=j400b,j400a,-1
         ihh = khl(1,j)
         ik = khl(2,j)
         il = khl(3,j)
         do 3100 i=1,nsym
            ill(1)=ihh*kmat(i,1,1)+ik*kmat(i,2,1)+il*kmat(i,3,1)
            ill(2)=ihh*kmat(i,1,2)+ik*kmat(i,2,2)+il*kmat(i,3,2)
            ill(3)=ihh*kmat(i,1,3)+ik*kmat(i,2,3)+il*kmat(i,3,3)
            indr=ill(1)*ifat1+ill(2)*ifat2+ill(3)
            isgn=isign(1,indr)
            indr=iabs(indr)
            if(isr(indr).eq.0) then
             isr(indr)=-(2*icst1+j)
            endif
3100     continue
3000  continue
c
c--create the isr list
      jord=1
      do 2900 i=1,nrefl
         jh=khl(1,i)
         jk=khl(2,i)
         jl=khl(3,i)
*        write(lo,'(4i6)') i,jh,jk,jl
         e=evet(i)
! Cristina
         ke1 = int(evet(i)*100.+0.5)*512
         e = float(ke1/512)/100.
! Cristina
         do 2800 i1=1,nsym
        ill(1)=jh*kmat(i1,1,1)+jk*kmat(i1,2,1)+jl*kmat(i1,3,1)
        ill(2)=jh*kmat(i1,1,2)+jk*kmat(i1,2,2)+jl*kmat(i1,3,2)
        ill(3)=jh*kmat(i1,1,3)+jk*kmat(i1,2,3)+jl*kmat(i1,3,3)
            indr=ill(1)*ifat1+ill(2)*ifat2+ill(3)
            indr=iabs(indr)
            if (e.le.0.0) e=0.01
            if(isr(indr).eq.0) then
               isr(indr)=int(e*100.+0.5)*icst3+jord
            endif
 2800    continue
         jord=jord+1
         if(jord.gt.icst3) then
*           write(lo,4)jh,jk,jl
*   4 format(1x,'too much independent reflections, last reflec',
*    ,'tion stored :',3i4)
*           stop 'too much independent reflections'
            exit
         endif
 2900 continue
      if (nsym.eq.1) return
      call geest()
      return
      end
c-----------------------------------------------------------
      function iedeb(i,im,i10)
      USE General
      USE Symmetry
      USE Riflessi
      USE InvarStuff
      USE QModule
c
c--controlla esistenza,debolezza ed specialita del ii-esimo c.v.
c--(tabella ies)
c
c--iedeb=0 ok.
c--iedeb=1 rifl. forte
c--iedeb=-1 no. ord. c.v. le n.ord. primo c.v.
c
!
c
      common /inp/  natom,fnat,atoms
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee2(24,6)
      common/dirqn/ecros,iecros,ncode,icody,numbQuart
     1 ,nsog,sqes,nquam,nquat,ecr1,iecr1
      common/esti/ib(3),ih(3,2,24),ii(2,24)
      common/nq/nor1(6),nop1(6),iseg1(6),icodqn,sumc,sums,sume
      common/wrt/icv(4,7),ishf,ifas,ee(3),icodx(3),iqua(1000),
     1           itac(5,24,4),eee(3)
      common/zero/arnq(26),ncal(26),nver(26),ntt,fm(26),gt(26)

      common /miacomm/ mia(7,30000),mmcrs(2)
c
c
      if (i10.eq.0) then
         ecr=ecros
         iecr=iecros
      else
         ecr=ecr1
         iecr=iecr1
      endif
      iedeb=0
      ia=0
      i4=i+4
      i2=i+1
      do jj1=i,3
         eee(jj1)=0
         ee(jj1)=0
      end do
      do jj1=1,4
         do jj2=i4,7
            icv(jj1,jj2)=0
         end do
      end do
      ihy=icv(1,1)+icv(1,i2)
      ihyx=iabs(ihy)
c
c-- controlla se esiste il riflesso
c
      if (ihyx.gt.ifatx.or.ihyx.le.0)  goto 1900
      jk=icv(3,1)+icv(3,i2)
      if(iabs(jk).gt.ihmx(2))  goto 1900
      jl=icv(4,1)+icv(4,i2)
      if(iabs(jl).gt.ihmx(3))  goto 1900
c--controllo di debolezza.
      ie=isr(ihyx)
c            if ( nor1(2).eq.5.and.nor1(3).eq.108) then
c                if (nor(2).eq.95.and.nor(3).eq.262) then
c                  write (lo,*)jk,jl,ie
c	stop 6767
c                end if
c                endif  
      if (ie.eq.0) goto 1900
      if (ie.ge.0) then
c--riflesso non speciale forte o debole
         ia=mod(ie,icst3)
         eee(i)=float(ie/icst3)/100.
         ee(i)=eee(i)*eee(i)-1
         if(eee(i).gt.ecr) iedeb=1-i10
         goto 1800
      endif
      if (ie.eq.-4*icst1) then
c--rifl.estinto
         icodx(3)=icodx(3)+1
         eee(i)=0.
         ee(i)=0
         iflag=iflag+1
         goto 1800
      endif
      if (ie.eq.-5*icst1)  then
c--riflesso assente ma speciale
         iflag=iflag+1
         icodx(2)=icodx(2)+1
         eee(i)=1.0
         ee(i)=0.0
         goto 1800
      endif
      it=-ie/icst1
      if (it.eq.1) then
c--rifl. tra i 200 forte (lista 7)
         ie=-ie
         ie=mod(ie,icst3)
         ia=-ie

         iedeb=1-i10
         if (kmad.eq.0) then
             eee(i)=evet(ie)
         else
! gianluca
             ke = int(evet(ie)*100.+0.5)*512
             eee(i) = float(ke/512)/100.
! gianluca
         endif
         ee(i)=eee(i)*eee(i)-1
         goto 1800
      endif
      if (it.eq.2) then
c--rifl. tra i 50 piu deboli.
         ie=-ie
         ispec=ie/icst2
         ispec=mod(ispec,2) ! correzione di libero
         ie=mod(ie,icst3)
         ia=-ie
c         if (ie.lt.im) then
         if (ie.gt.im) then
            iedeb=-1
         else
            if (kmad.eq.0) then
                eee(i) = evet(ie)
            else
! gianluca
                ke = int(evet(ie)*100.+0.5)*512
                eee(i) = float(ke/512)/100.
! gianluca
            endif
            ee(i)=eee(i)*eee(i)-1
c--rifl. spec.
            if(ispec.ne.0) iflag=iflag+1
         endif
         goto 1800
      endif
c--riflesso speciale
      if (it.ne.3)  then
         write(lo,*) '**** function iedeb  ****'
         write(lo,*) '**** programming  error ****'
         write(lo,*) ' sir ends in error'
         call cstop('1234 ') 
      endif
      ie=mod(ie,icst2)
      ia=mod(ie,icst3)
      ie=ie/icst3
c--rifl.forte spec
      eee(i)=float(ie)/100.
      ee(i)=eee(i)*eee(i)-1
      if(ie.gt.iecr) iedeb=1-i10
      if(iedeb.eq.0) iflag=iflag+1
 1800 icv(2,i4)=icv(2,1)+icv(2,i2)
      icv(3,i4)=jk
      icv(4,i4)=jl
      icv(1,i4)=icv(2,i4)*ifat1+icv(3,i4)*ifat2+icv(4,i4)
      iqua(m13+i-1)=ia
      return
 1900 icodx(1)=icodx(1)+1
      ee(i)=0
      return
      end
c---------------------------------------------------------------------
      subroutine xbc9(i,k,nn)
      USE General
      USE InvarStuff
      common/wrt/icv(4,7),ishf,ifas,ee(3),icodx(3),iqua(1000),
     1           itac(5,24,4),eee(3)
c
      common /proc/ iftr,ifp10,ifnq,ifps,ifcoc
c
      in=(i-1)*nn
      do 10 n=1,nn
         inn=in+n
         itac(1,n,k)=itab(inn)
         itac(2,n,k) = itabH(inn)
         itac(3,n,k) = itabK(inn)
         itac(4,n,k) = itabL(inn)
         itac(5,n,k) = itabO(inn)
   10 continue
      return
      end
c-------------------------------------------------------------
      function iequiQ(im,liqu3)
      USE General
      USE Symmetry
      USE Riflessi
      USE InvarStuff
      USE QModule
!
c
      common /inp/  natom,fnat,atoms
      common/dirqn/ecros,iecros,ncode,icody,numbQuart
     1 ,nsog,sqes,nquam,nquat,ecr1,iecr1
      common/esti/ib(3),ih(3,2,24),ii(2,24)
      common/nq/nor1(6),nop1(6),iseg1(6),icodqn,sumc,sums,sume
      common/wrt/icv(4,7),ishf,ifas,ee(3),icodx(3),iqua(1000),
     1           itac(5,24,4),eee(3)
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee2(24,6)
c
      dimension icvv(4,7)
c--
c
      character iast(3),iblan,istar
      data istar,iblan/'*',' '/
      iequiQ=0
      iop1=nop1(2)
      do i=1,4
         do j=1,7
            icvv(i,j)=icv(i,j)
         enddo
      enddo
      do i=1,4
         icv(i,1)=itac(i,iop1,1)*iseg1(2)
      enddo
c--m13 indirizzo del quart. originale
      n13f=1
      if (icent.eq.0) then
c--  caso non centrosimmetrico
         lf=1
c--  caso centrosimmetrico
      else
         lf=3
      endif
      m13 =l13+md13
      do 3000 i=1,nsym
      if(itac(1,i,2).eq.0) goto 3000
      do 1800 l=1,lf,2
         do 2000 j=1,nsym
            if (itac(1,j,3).eq.0) goto 2000
            do 1900 ll=1,lf,2
               ll2=2-l
               ll3=2-ll
c -- ih4 = superindice del 4-to vettore base
               ih4=itac(1,iop1, 1)*iseg1(2)+itac(1,i, 2)*ll2*iseg1(3)+
     1             itac(1,j,3)*ll3*iseg(2)
               if (ih4.ne.0) then
                  ih4=-ih4*iseg(3)
                  do 1700 k1=1,nsym
                     if (ih4.eq.itac(1,k1,4)) then
                        ll4=1
                        go to 1750
                     else
                        if(icent.eq.0) goto 1700
                        ll4=-1
                        if(ih4.eq.-itac(1,k1,4)) goto 1750
                     endif
 1700             continue
                  goto 1900
 1750             ishn=itac(5,i,2)*iseg1(3)*ll2+itac(5,j,3)*iseg(2)*ll3+
     1                 itac(5,k1,4)*iseg(3)*ll4+itac(5,iop1,1)*iseg1(2)
                  ishn=-ishn
                  ishn=ishn*15+720
                  ishn=mod(ishn,360)
                  lll2=ll2*iseg1(3)
                  lll3=ll3*iseg (2)
                  lll4=ll4*iseg (3)
                  do 1752 jc=1,4
                     icv(jc,2)=itac(jc,i,2)*lll2
 1752             continue
                  do 1754 jc=1,4
                     icv(jc,3)=itac(jc,j,3)*lll3
 1754             continue
                  do 1756 jc=1,4
                     icv(jc,4)=itac(jc,k1,4)*lll4
 1756             continue
                  do 1760 k=1,3
                     ied=iedeb(k,im,1)
                     if(ied.ne.0) then
                        if (iprin.eq.2) then
                           write(lo,4)((icv(jj,kkc),jj=2,4),kkc=1,4),
     1                       ((icv(j1,k1),j1=2,4),ee(k1-4),k1=5,7),ied
    4 format(2x,4(3i3,5x),3x,3(3i3,f5.2),'quart. rejected  iedeb=',i3)
                        endif
                        goto 9000
                     endif
 1760             continue
                  do 1790 k1=1,3
                     iast(k1)=iblan
                     isto=(iqua(m13+k1-1))
                     if(isto.ne.0) then
                        m13f=l13
                        do 1785 k=1,n13f
                           do 1780 k2=1,3
                              isto1=(iqua(m13f+k2-1))
                              if(isto.eq.isto1) then
                                 iast(k1)=istar
                                 ee(k1)=0.
                                 iqua(m13+k1-1)=0
                                 goto 1790
                              endif
 1780                      continue
                           m13f=m13f+md13
 1785                   continue
                     endif
 1790             continue
                  if(iprin.eq.2) then
                     write(lo,1)((icv(jj,k),jj=2,4),k=1,4)
     2            ,((icv(j1,k1),j1=2,4),ee(k1-4),iast(k1-4),k1=5,7),ishn
                  end if
  1   format(2x,4(3i3,5x),3x,3i3,f5.2,a1,2(3i3,f5.2,a1),i5)
c--quartetto equivalente o.k. con almeno un c.v.
c  in icv(4,7) ho indici
c  in ishn     ho lo shift
c  in ee(3)    ho gli epsilon
c
                  shn=ishn*twopi/360.
                  sumep=ee(1)+ee(2)+ee(3)
                  sume=sumep+sume
                  cosx=cos(shn)
                  sinx=sin(shn)
                  sumc=sumep*cosx+sumc
                  sums=sumep*sinx+sums
                  if(iprin.eq.2) then
                     write(lo,9)sume,sumep,sumc,sums,cosx,sinx,shn,ishn
                  end if
 9    format(1x,'sume=',e10.2,'sumeps= ',e10.2,' sumcos= ',e10.2,
     ,' sumsin= ',e10.2,' cos=',e10.2,' sin=',e10.2,f10.2,i10)
                  m13=m13+md13
                  if(m13.ge.liqu3) then
                     goto 9000
                  endif
                  n13f=n13f+1
               endif
 1900       continue
 2000    continue
 1800 continue
 3000 continue
      goto 9050
 9000 iequiQ=-1
 9050 do i=1,4
         do j=1,7
            icv(i,j)=icvv(i,j)
         end do
      end do
      return
      end
c----------------------------------------------------------
      subroutine sortc(numb,inq)
c--sort the negative/enantiomorph-sensitive quartet list
c
      dimension inq(7,numb)
c--
      if(numb.eq.1) return
      m=2
 2010 in=numb/m
      if(in.le.0) in=1
      ifin=numb-in
 2040 mark=0
      do 2060 i=1,ifin
      k=i+in
      jn1=inq(6,i)/1000.0
      jn2=inq(6,k)/1000.0
      if(jn1.ge.jn2) goto 2060
      do 2055 n=1,7
      jc=inq(n,i)
      inq (n,i)=inq (n,k)
      inq (n,k)=jc
2055  continue
      mark=1
2060  continue
      if(mark.gt.0) goto 2040
      if(in.le.1) goto 2080
      m=m*2
      goto 2010
 2080 return
      end
c-------------------------------------------------------
      subroutine geest()
      USE General
      USE Symmetry
      USE InvarStuff
c--genera gli estinti
c
c
      common /inp/  natom,fnat,atoms
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common/dirps/npsa
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,numbQuart
     1 ,nsog,sqes,nquam,nquat,ecr1,iecr1
      common/esti/ib(3),ih(3,2,24),ii(2,24)
c
c--
      dimension ia(3,3),tras(3),jhk(2,24)
c--
c--definizione della matrice differenza.
c--
      do 1000 k=1,nsym
      icp1=icent+1
      do 1100 k1=1,icp1
      ii(k1,k)=0
      ll1=1
      if(k1.eq.2)ll1=-1
      do 1110 j=1,3
      do 1120 i=1,3
      ll2=0
      if(i.eq.j)ll2=1
      ia(j,i)=ll2-ll1*kmat(k,j,i)
 1120 continue
 1110 continue
c--analisi della matrice somma e differenza.
c
      do 1200 j=1,3
      ih(j,k1,k)=-1
      if(ia(j,j).eq.0)ih(j,k1,k)=0
      do 1300 i=1,3
      if(i.eq.j) goto 1300
      if(ia(i,j).ne.0) goto 1250
      if(ia(j,i).ne.0) goto 1250
 1300 continue
      ih(j,k1,k)=ih(j,k1,k)+1
 1250 if(ih(j,k1,k).eq.-1)ih(j,k1,k)=3
      ii(k1,k)=ii(k1,k)+ih(j,k1,k)
 1200 continue
c--analiza se ci sono due componenti uguali e diverse da 0
      if(ii(k1,k).lt.6) goto 1150
      do 1400 i=1,2
      i1=i
      if(ih(i,k1,k).ne.3) goto 1400
      iplus1=i+1
      do 1500 j=iplus1,3
      j1=j
      if(ih(i,k1,k).eq.ih(j,k1,k)) goto 1600
 1500 continue
 1400 continue
c--analiza se il determinante e' diverso da 0
 1600 in=ia(i1,i1)*ia(j1,j1)-ia(i1,j1)*ia(j1,i1)
      jhk(k1,k)=1
      im=isign(1,ia(i1,i1))+isign(1,ia(j1,j1))
     1  +isign(1,ia(i1,j1))+isign(1,ia(j1,i1))
      if(im.ne.0)jhk(k1,k)=-1
      if(in.eq.0) goto 1100
      ii(k1,k)=ii(k1,k)-6
      ih(j1,k1,k)=0
      ih(i1,k1,k)=0
c--analiza se c'e' un unica componente uguale a 3
 1150 if(ii(k1,k).ne.4.and.ii(k1,k).ne.3) goto 1100
      do 1160 j=1,3
      j1=j
      if(ih(j,k1,k).eq.3) goto 1161
 1160 continue
      goto 1100
 1161 ih(j1,k1,k)=0
      ii(k1,k)=ii(k1,k)-3
1100  continue
 1000 continue
c--genera gli estinti
      do 2000 k=1,nsym
      mark=0
      do 2200 i=1,3
      tras(i)=tmat(k,i)
      ib(i)=0
      if(tmat(k,i).lt.0.001) goto 2200
      mark=1
      b=1.0/tmat(k,i)
      do 2300 j=1,8
      b1=b*j+.0001
      ib(i)=int(b1)
      b2=float(ib(i))
      if((b1-b2).le..001) goto 2200
 2300 continue
 2200 continue
      icp1=icent+1
      do k1=1,icp1
      if (ii(k1,k) == 0) cycle
          iik1k=ii(k1,k)
          select case (iik1k)
             case (1)
                call screw(k1,k)
             case (2)
                call glide(k1,k)
             case (6,7)
                call tetra(k1,k,tras,jhk)
          end select
      enddo
 2000 continue
      return
      end
c-------------------------------------------------
      subroutine screw(k1,k)
      USE General
      USE Symmetry
      USE InvarStuff
c
      common /inp/  natom,fnat,atoms
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common/dirps/npsa
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,numbQuart
     1 ,nsog,sqes,nquam,nquat,ecr1,iecr1
      common/esti/ib(3),ih(3,2,24),ii(2,24)
c
      dimension ind(3)
c--
      do 100 j=1,3
      j1=j
      if(ih(j,k1,k).ne.0)  goto 200
 100  continue
  200 do 300  l=1,3
      ind(l)=0
 300  continue
      ibb=1
      if(ib(j1).ne.0)ibb=ib(j1)
      ihm=ihmx(j1)
      do 400 l=1,ihm
      ind(j1)=l
      mad=mod(l,ibb)
      if(mad.eq.0) goto 350
      indr=iabs(ind(1)*ifat1+ind(2)*ifat2+ind(3) )
      isr(indr)=-4*icst1
      if(iprin.eq.3) write(lo,10)(ind(i),i=1,3)
   10 format(1x,'rifl. estinto  ',3i4)
      goto 400
  350 call specq(ind)
 400  continue
      return
      end
c------------------------------------------------
      subroutine glide(k1,k)
      USE General
      USE Symmetry
      USE InvarStuff
c
      common /inp/  natom,fnat,atoms
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common/dirps/npsa
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,numbQuart
     1 ,nsog,sqes,nquam,nquat,ecr1,iecr1
      common/esti/ib(3),ih(3,2,24),ii(2,24)
c
      dimension ind(3)
      mad=1
      m1=0
      m2=0
      jj=0
      mark=0
      ihm1=0
      ihm2=0
      do 100 j=1,3
      ind(j)=0
      if(ih(j,k1,k).eq.0) goto 100
      jj=jj+j
      if(ib(j).ne.0)mark=1+mark
 100  continue
      if(jj.eq.0)return
      goto(500,500,110,120,130),jj
  110 m1=1
      m2=2
      goto 200
  120 m1=1
      m2=3
      goto 200
  130 m1=2
      m2=3
  200 if(ib(m1).ne.0)mad=ib(m1)
      ihm1=ihmx(m1)
      if(ib(m2).ne.0)mad=ib(m2)
      ihm2=ihmx(m2)
      ih2=-ihm2
      ihm1p1=ihm1+1
      do 300 j=1,ihm1p1
      ind(m1)=j-1
      do 400 i=ih2,ihm2
      ind(m2)=i
      if(mark.eq.0) goto 450
      if(mark.ne.2) goto 410
      in=ind(m1)+ind(m2)
      goto 420
  410 if(ib(m1).ne.0)in=ind(m1)
      if(ib(m2).ne.0)in=ind(m2)
  420 if(mod(in,mad).eq.0) goto 450
      indr=iabs(ind(1)*ifat1+ind(2)*ifat2+ind(3) )
      isr(indr)=-4*icst1
      if(iprin.eq.3) write(lo,10) ind
   10 format(1x,'rifl. estinto  ',3i4)
      goto 400
  450 call specq(ind)
 400  continue
 300  continue
  500 return
      end
c-------------------------------------------------------
      subroutine specq(ind)
      USE General
      USE Symmetry
      USE InvarStuff
c
      common /inp/  natom,fnat,atoms
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common/dirps/npsa
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,numbQuart
     1 ,nsog,sqes,nquam,nquat,ecr1,iecr1
      common/esti/ib(3),ih(3,2,24),ii(2,24)
      common/nq/nor1(6),nop1(6),iseg1(6),icodqn,sumc,sums,sume
c
      dimension ind(3)
c
      iecrx=max0(iecros,iecr1)
      indr=ind(1)*ifat1+ind(2)*ifat2+ind(3)
      indr=iabs(indr)
      if(indr.eq.0)return
      i=isr(indr)
      if (i.eq.0)  then
          isr(indr)=-5*icst1
          if(iprin.eq.3) write(lo,30)(ind(i),i=1,3)
   30     format(20x,'rifl. assente speciale  ',3i4)
          return
      else
c-- e' tra i 50 piu deboli?
          if (i.lt.0) then
              if (i.le.-4*icst1) return
              ie=i/icst1
              if (ie.eq.-2) then
                  isr(indr)=i-icst2
              endif
              if (iprin.eq.3) write(lo,10)(ind(i),i=1,3)
   10         format(20x,'rifl. spec. debolissimo  ',3i4 )
              return
          else
              ie=i/icst3
              if (ie.gt.iecrx) return
              isr(indr)=-(isr(indr)+3*icst1+icst2)
              if(iprin.eq.3) write(lo,20)(ind(i),i=1,3)
   20         format(20x,'rifl. spec. debole  ',3i4)
              return
          endif
      endif
      end
c-------------------------------------------------------
      subroutine tetra(k1,k ,tras,jhk)
      USE General
      USE Symmetry
      USE InvarStuff
c
      common /inp/  natom,fnat,atoms
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common/dirps/npsa
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,numbQuart
     1 ,nsog,sqes,nquam,nquat,ecr1,iecr1
      common/esti/ib(3),ih(3,2,24),ii(2,24)
c
      dimension ind(3),tras(3),ibi(3),ibc(3),jhk(2,24)
c--
      m1=0
      m2=0
      m3=0
      ihm1=0
      ihm2=0
      ihm3=1
      jj=0
      mark=0
      do j=1,3
         ibc(j)=ib(j)
         ind(j)=0
         if (ih(j,k1,k).ne.3) m3=j
         jj=jj+j
      enddo
      ih3=1
      ihm3=ihmx(m3)
      idif=0
      if (ih(m3,k1,k) == 0) then
          irr=0
          ihm3=1
          idif=-1
      endif
      jj=jj-m3
      m1=1
      if(jj-4)110,120,130
  110 m2=2
      goto 150
  120 m2=3
      goto 150
  130 m1=2
      m2=3
  150 tra=tras(m1)+tras(m2)*jhk(k1,k)
      ttra=abs(tra-int(tra))
      if(ttra.le.0.001) goto 155
      if (abs(tras(m1)-tras(m2)).gt.0.001) goto 151
      ibc(m1)=ibc(m1)/2
      goto 160
  151 if(ib(m1).ne.ib(m2)) goto 152
      ibc(m1)=ib(m1)/2
      goto 160
  152 ibc(m1)=max0(ibc(m1),ibc(m2))
      goto 160
  155 if(ibc(m3).eq.0.or.idif.eq.-1) goto 156
      ibi(m1)=0
      ibi(m3)=1
      imm=ibc(m3)
      goto 300
  156 ibi(m1)=0
      ibi(m3)=0
      imm=1
      goto 300
  160 if(ibc(m3).ne.0.and.idif.ne.-1) goto 170
      ibi(m1)=1
      ibi(m3)=0
      imm=ibc(m1)
      goto 300
  170 imm=max0(ibc(m1),ibc(m3))
      im=min0(ibc(m1),ibc(m3))
      ibi(m1)=imm/ibc(m1)
      ibi(m3)=imm/ibc(m3)
  300 ihm1=ihmx(m1)+1
      ihm2=ihmx(m2)+1
      if(ihm2.gt.ihm1)ihm2=ihm1
      ihm1=ihm2
      do 1000 j=1,ihm1
      ind(m1)=j-1
      ind(m2)=(j-1)*jhk(k1,k)
      do 2000 i=ih3,ihm3
      ind(m3)=i+idif
      indi=ibi(m1)*ind(m1)+ibi(m3)*ind(m3)
      indm=mod(indi,imm)
      if(indm.eq.0) goto 2100
      if(iprin.eq.3) write(lo,2200) (ind(l),l=1,3)
      indr=iabs(ind(1)*ifat1+ind(2)*ifat2+ind(3))
      isr(indr)=-4*icst1
      goto 2000
 2100 call specq(ind)
 2000 continue
 1000 continue
 2200 format(1x,'rifl. estinto  ',3i4)
      return
      end
c-----------------------------------------------------
      subroutine dirinv(ifFromGraphic, ifFromPhase, ier)
      USE General
      USE Symmetry
      USE PhaseModule
      USE Direttive
c
*gl*  common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
c
!     common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,del,ks
c
      common /inp/  natom,fnat,atoms
      common /proc/ iftr,ifp10,ifnq,ifps,ifcoc
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common/dirps/npsa
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,numbQuart
     1 ,nsog,sqes,nquam,nquat,ecr1,iecr1
*gl*  dimension vet(40),ivet(40)
      character line*80,dire*80,diret*80
c
c-- set default values
!     if (ifFromPhase == 0) ifNewPsi0 = 0
!     if (ifNewPsi0 == 0) then
!         MaxPsi0 = 8000
!     else
!         MaxPsi0 = 30000
!         MaxPsi0 = 150000
!     endif
      NewPsi0Req = 0
      if (ifFromPhase == 0) then
          ifGminReq = -99
          if (ifNewPsi0 == -1) then
              ifNewPsi0 = 0
          else
              if (kmad == 0 .and. ksize <= 3) then
                  ifNewPsi0 = 1     ! dedi 04/12/08  USO ATTIVO PSI0 migliora weitan
              else
                  ifNewPsi0 = 0
              endif
          endif
      endif
      if (ifNewPsi0 == 0) then
          MaxPsi0 = 8000
          
 !psie
 !psie        if (ksize > 3) then
 !psie           MaxPsi0 = 300000
 !psie        end if
          
      else
          if (anat < 200.0) then
              MaxPsi0 = 30000
          elseif (anat >= 200.0 .and. anat < 300.0) then
              MaxPsi0 = 45000 
          else
              MaxPsi0 = 60000
          endif
      endif

      ifps = 1
      if (ifFromGraphic.eq.0) then
          ifp10 = 1
          ifcoc = 0
          ifnq  = 1
      endif
      if (kmad == 2) then
          ifp10 = 0
          ifcoc = 1
          ifnq  = 0
      endif
      if (ifCochReq > 0) then   ! direttiva Cochran in phase
          ifp10 = 0
          ifcoc = 1
      endif
      if (ifNoQuaReq > 0) then   ! direttiva Cochran in phase
          ifnq = 0
      endif
      kverbo = 0
c_LIB
      if (ifGminReq < 0) then
          ifGmin = 0
          if (ksize <= 3) then
              if (resm < ResSogLow) then   ! dedi 13/02/08
                  sogpo = 0.8
              else
                  sogpo = 0.4
              endif
          else
              if (resm < ResSogLow) then
                  sogpo = 0.3 ! risoluzione atomica
              else
                  sogpo = 0.25
              endif
          endif
      endif
!pgMAD
      if (kmad == 0) then
          sogne=-0.2
      else
          sogpo = 0.3
          sogne = -9999.
      endif
!pgMAD
      iprin=0
      iftr=1
c-- the default formula used is p-10
      emin=0.0
      ntr10=0
      numk=0
      ntrs=0
      ecros=1.50
      ecr1=3.0
      iecros=150
      iecr1=300
      nsog=40
      sqes=0.2
      ncode=7
      icody=0
      ier=0
      coef=99999.0
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 9000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
c
c-- directives with numeric parameters
c
      if (dire(1:4).eq.'verb') then
          kverbo = 1
          go to 100
      elseif (dire(1:4).eq.'coch') then
          ifcoc=1
          ifp10=0
          go to 100
      elseif (dire(1:4).eq.'nqua') then
          ifnq=0
          go to 100
      elseif (dire(1:4).eq.'npsi') then  ! non calcola le psi0  
          ifps=0
          go to 100
      elseif (dire(1:4).eq.'psi0') then
          ifps = 1
          ifNewPsi0 = 1
          NewPsi0Req = 1
          if (anat < 200.0) then
              MaxPsi0 = 30000
          elseif (anat >= 200.0 .and. anat < 300.0) then
              MaxPsi0 = 45000  
          else
              MaxPsi0 = 60000
          endif

          go to 100
      elseif (dire(1:4).eq.'nops') then  ! non usa attivamente le psi0
          ifNewPsi0 = 0
          NewPsi0Req = -1
          MaxPsi0 = 8000
          go to 100

      endif
c
c-- directives with numeric parameters
c
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 8000
      if (dire(1:4).eq.'emin') then
          if (iv.ne.1) go to 8000
          emin = vet(1)
          go to 100
      elseif (dire(1:4).eq.'corr') then
          if (iv.ne.1) go to 8000
          coef = vet(1)
          go to 100
      elseif (dire(1:4).eq.'gmin') then
          ifGmin = 1
          if (iv.eq.1) then 
              sogpo = vet(1)
          elseif(iv.eq.0) then
              sogpo = 0.15
          else
              go to 8000
          endif
          if (sogpo.lt.0.15) sogpo = 0.15
          go to 100
      elseif (dire(1:4).eq.'prin') then
          if (iv.ne.1) go to 8000
          iprin=ivet(1)
          go to 100
      elseif (dire(1:4).eq.'numk') then
          if (iv.ne.1) go to 8000
          numk=ivet(1)
          go to 100
      endif
      write(Msg,6000) char(10),diret(1:Lung(diret))
 6000 format(' Wrong directive on following line:',a,3x,a)
      ier = -1
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      return
 8000 continue
      ier=-1
      write(Msg,"(' error in directive : ',a)") diret(1:Lung(diret))
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      return
 9000 continue
      if (neutro.ne.2) then
          if (emin.lt.1.2) emin=1.2
      else
          if (emin.lt.1.0) emin=1.0
      endif
      if (sc.lt.0.0) then
          write(Msg,9100)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier=-1
      endif
 9100 format('Reflections are not normalized')
!
      return
      end
c-----------------------------------------------------------------------
      subroutine p10n(ifWarning,risultati,ifFromPhase,ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE InvarStuff
      USE PhaseModule
c
c--p10 calculation
c
      common /inp/  natom,fnat,atoms
      common /proc/ iftr,ifp10,ifnq,ifps,ifcoc
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common/dirps/npsa
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,numbQuart
     1 ,nsog,sqes,nquam,nquat,ecr1,iecr1
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
     *                  NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!psie      
!psie      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
!psie     *                   NPsie,NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
c
c--
      dimension ill(3),iche(24),ikln(60)
      dimension vet(12),ivet(12)
      integer risultati(7,2)
      equivalence (ivet(1),vet(1))
c--
      if (numk.le.0) then
*         sogpo = 0.0
*         sogne = 0.0
      endif
      if (icent.ne.0) then
          sogne = 0.0
      endif
      if(ntr10.gt.ntra.or.ntr10.eq.0) ntr10=ntra
      if(ntr10.gt.0) ntrs=min0(ntrs,ntr10)
c--clear the areas
      do 1001 k=1,itabmx
         itab(k)=0
 1001 continue
c--  ifatx:superindice massimo
      do 1004 i=1,ifatx
         isr(i)=0
 1004 continue
c--create the list
      ipu=0
      do 1090 j=1,nstr
c-- carica le inform. relative ai riflessi forti

      ih = khl(1,j)
      ik = khl(2,j)
      il = khl(3,j)
      do 1080 i=1,nsym
         ipu = ipu+1
         if (i.eq.1) then
            indr=ih*ifat1+ik*ifat2+il
               itabK(ipu) = ik
               itabL(ipu) = il
         else
            ill(1)=ih*kmat(i,1,1)+ik*kmat(i,2,1)+il*kmat(i,3,1)
            ill(2)=ih*kmat(i,1,2)+ik*kmat(i,2,2)+il*kmat(i,3,2)
            ill(3)=ih*kmat(i,1,3)+ik*kmat(i,2,3)+il*kmat(i,3,3)
            indr=ill(1)*ifat1+ill(2)*ifat2+ill(3)
               itabK(ipu) = ill(2)
               itabL(ipu) = ill(3)
         endif
         indrr=indr
         indra=iabs(indr)
         if (i.ne.1) then
c -----   elimina i doppioni
            imen1=i-1
            do 1086 i1=1,imen1
               if (indra.eq.iabs(ikln(i1))) indrr=0
 1086       continue
         endif
         ikln(i)=indrr
         itab(ipu)=indrr
         isr(indra)=-j
1080  continue
1090  continue
c
c--create the isr list
c
      do 1220 i=1,nrefl
         if (i.gt.nstr) then
            ih=khl(1,i)
            ik=khl(2,i)
            il=khl(3,i)
            do 1210 i1=1,nsym
               if (i1.eq.1) then
                  indr=ih*ifat1+ik*ifat2+il
               else
              ill(1)=ih*kmat(i1,1,1)+ik*kmat(i1,2,1)+il*kmat(i1,3,1)
              ill(2)=ih*kmat(i1,1,2)+ik*kmat(i1,2,2)+il*kmat(i1,3,2)
              ill(3)=ih*kmat(i1,1,3)+ik*kmat(i1,2,3)+il*kmat(i1,3,3)
              indr=ill(1)*ifat1+ill(2)*ifat2+ill(3)
               endif
               indr=iabs(indr)
               e=evet(i)
               if (e.lt.0.01) e=0.01
               isr(indr)=int(e*100+.05)
 1210       continue
         endif
 1220 continue
c
c--end of loop
c--calculate p10
      fna2=fnat*fnat
      fna22=fna2/2.0
      somgc=0.
      sgg=0.0
c
      if (ifPatt > 0) then
          call scrper('Initialize Figures of Merit    ',0,0)
      else
          if (ifcoc == 1) then
              call scrper('Apply Cochran formula     ',0,0)
          else
              call scrper('Apply P-10 formula        ',0,0)
          endif
      endif
      nperc=100
      iperc0=ntr10/nperc
      iperc=iperc0
      jperc=0
c
      do 2000 i=1,ntr10
         if (i.eq.iperc) then
            jperc=jperc+1
            iperc=iperc+iperc0
            call scrper(' ',jperc,nperc)
         endif
c--  fornisce g e il no.d`ordine,gli operatori,
c     il segno e gli e dei riflessi per ogni tripl.
         call decom(i,dum,g,id1,id2)
         gv(i)=g
         sgg=sgg+g
         iseg(2)=-iseg(2)
         iseg(3)=-iseg(3)
         do 1000 k=1,nsym
            iche(k)=0
            do j=1,3
c--  nor:no.d`ordine
               nord=nor(j)
               nork=(nord-1)*nsym+k
               if (itab(nork).ne.0) go to 1000
            end do
            iche(k)=k
 1000    continue
         terr=0.
         if (numk.le.0) go to 2110
c
c--  numk:no. di rifl.k-random adoperati.
         do 2100 j=1,numk
c--elimina il quintetto e i suoi equivalenti se il vett.k coincide con
c--un elemento della tripletta.
            do  l =1,3
               if (j.eq.nor(l)) go to 2100
            end do
            jn=(j-1)*nsym
            do i2=1,nsym
               do i3=1,6
c--  ee:contiene gli epsylon dei cross-vector.
                  ee(i2,i3)=0.
               end do
            end do
            if (kmad.eq.0) then
                e2Val = evet(j)
            else
! gianluca
                ke = int(evet(j)*100.+0.5)*512
                e2Val = float(ke/512)/100.
! gianluca
            endif
c--  contiene gli epsylon dei vett. base(tripl.e k-random)
            eeb(4)=e2Val*e2Val-1
            ta=0.
            tb=0.
            do 2200 k=1,nsym
c--  controlli sulla ripetizione dei quintetti
c--  elimina l' op. di simm. se tutti i rifl.della
c--  tripl. sono speciali
               if (iche(k).gt.0) goto 2200
c--  elimina il op.di simm. se il k e`speciale
               jnk=jn+k
               if (itab(jnk).eq.0) goto 2200
                  jk2 = itabK(jnk)
                  jl2 = itabL(jnk)
c--
               do 3000 i1=1,3
                  if (i1.eq.1) then
                     mm1=1
                  else
                     mm1=-1
                  endif
                  nord=nor(i1)
c--  no. d`ordine  del op.di simm.
                  nope=nop(i1)
                  mms=mm1*iseg(i1)
                  nopd=(nord-1)*nsym+nope
                  jk1 = itabK(nopd) * mms
                  jl1 = itabL(nopd) * mms
                  ihh1=itab(nopd)*mms
                  do 2300 l=1,3,2
                     l1=l-2
                     ihh2=itab(jnk)*l1
c--  superindice del cross-vector
                     ih3=ihh1+ihh2
                     if(ih3.ne.0) then
                        if(ih3.gt.0) then
                           l3=1
                        else
                           l3=-1
                           ih3=-ih3
                        endif
c--  tre controlli sulla esistenza del vett.-cross
c--  primo controllo sul superindice.
                        if (ih3.gt.ifatx) go to 2300
                        ie=isr(ih3)
                        if (ie.eq.0) go to 2300
                        jk=iabs(jk1+jk2*l1)
c--  secondo controllo sull`indice k
                        if (jk.gt.ihmx(2))go to 2300
                        jl=iabs(jl1+jl2*l1)
c--  terzo controllo sull`indice l
                        if (jl.gt.ihmx(3))go to 2300
                        if (ie.lt.0) then
                           il=-ie
c--  due controlli che il vett.-cross sia diverso dai vett. base.
c--  1` rispetto al vett. k e anche se e(cross)>e(k)
c--  la modifica nel seguente controllo cambia leggermente i risultati
                           if (il.le.j) go to 2200
                           do n=1,3
c--  2` rispetto ai vett. della trip.
                              if (nor(n).eq.il) go to 2200
                           end do
                           if (kmad.eq.0) then
                               ie=evet(il)*100.
                           else
! gianluca
                               ke = int(evet(il)*100.+0.5)*512
                               ie = ke/512
! gianluca
                           endif
                        endif
                        e=float(ie)/100.0
                        inde=2*i1-1+(1-l1)/2
                        ee(k,inde)=e*e-1.0
                     endif
 2300             continue
 3000          continue
c--  in-line coded functions
               aterm=eeb(4)*( ee(k,1) * ( ee(k,4)+ee(k,6) ) +
     1                        ee(k,3) * ( ee(k,2)+ee(k,6) ) +
     2                        ee(k,5) * ( ee(k,2)+ee(k,4) ) )
               bterm=eeb(1)*(eeb(4)*(ee(k,1)+ee(k,2))+ee(k,3)*ee(k,6)+
     1                               ee(k,4)*ee(k,5))+
     2               eeb(2)*(eeb(4)*(ee(k,3)+ee(k,4))+ee(k,1)*ee(k,6)+
     3                               ee(k,2)*ee(k,5))+
     4               eeb(3)*(eeb(4)*(ee(k,5)+ee(k,6))+ee(k,1)*ee(k,4)+
     5                               ee(k,2)*ee(k,3))
c--
               ta=ta+aterm*fna2
               tb=tb+bterm*fna22
 2200       continue
            tb=tb+eeb(1)*eeb(2)*eeb(3)*fna22
            if (tb.lt.0.0) tb=0.0
            ter=ta/(1.0+tb)
            terr=terr+ter
 2100    continue
c
 2110 continue
      terr=terr+1
      gcor=g*terr
c ============
      gq(i)=gcor
      somgc=somgc+abs(gcor)
 2000 continue
      sgg=sgg/somgc
      if (kverbo.ne.0) then
          write(lo,*)' num. atomi equiv.=',natom,' scala =',sgg
      endif
      if (numk.le.0) sgg=1
!     if (natom.gt.200) then
!        if(sgg.le.0.6) sgg=1.0
!     endif
      if (kmad.eq.0) then            !pgMAD
         if (ifMDM == 0) then
            if (sgg.lt.0.8)  sgg = 1.0
         end if
      end if                         !pgMAD
      if (kverbo.ne.0) then
          write(lo,*)' num. atomi equiv.=',natom,' scala =',sgg
      endif
c --   riscala g - corretto
      do 4020 i=1,ntr10
         gq(i)=gq(i)*sgg
         if (gq(i).gt.20.47) gq(i)=20.47
         if (gq(i).lt.-20.47) gq(i)=-20.47
         ifa=(mod(isig(1,i),32)-1)*15
         ifa=ifa+mod(isig(3,i),32)-1
         ifffa=gq(i)*100.
         iff1=mod(isig(2,i),32)
         iff2=isig(2,i)/262144
         if (ifffa.ge.0) then
            ii=1
            iffa=ifffa
         else
            ii=-1
            iffa=-ifffa
         endif
         isig(2,i)=(iff2*8192+iffa+4096)*32+iff1
 4020 continue
      call sortgn(ntr10)
      indpo=1
c_LIB
cold  if(resm.le.ResSogLow) then
cold      RapSigma2 = 20.0
cold  else
cold      RapSigma2 = 50.0
cold  endif
      if (ksize.le.3) then
          RapSigma2 = 20.0
!         if (anat > 150.0) then
!             RapSigma2 = 30.0
!         endif
!perugia0907
          if (kmad == 1) then
              RapSigma2 = 50.0
          end if
!perugia0907
      else
!!!!      RapSigma2 = 25.0
          if(resm.le.ResSogLow) then
              RapSigma2 = 20.0
          else
              RapSigma2 = 50.0
          endif
      endif
c_LIB
 4500 indpo=1
      indne=0
      nupos=0
      nuneg=0
      do 5000 i=1,ntr10
      ggqq=abs(gq(i))
      if (indne.eq.0.and.gq(i).le.sogne) indne=i
      if (gq(i).ge.sogpo) nupos=nupos+1
      if (gq(i).le.sogne) nuneg=nuneg+1
 5000 continue
      Rap = float ( nupos ) / float ( nstr )
!     if (Rap.lt.RapSigma2.and.ifWarning.eq.0) then
      if (Rap.lt.10.and.ifWarning.eq.0.and.ifPatt==0) then    !leuven
          if (ifWillMDM == 0 .and. ifMDM == 0) then
              write(Msg,5010) sogpo,char(10), nstr
              call OpenWarning(Msg)
              ifWarning = 1
          endif
      endif
 5010 format('Not enough triplets found with G >',f5.2,
     *'. This threshold ',
     *  'will be automatically decreased.',a,'IN CASE OF FAILURE ',
     *  'use directive NREF in %DATA command to increase the ',
     *  'number of strong reflections. Actual value of NREF is ',i4)
!     if (Rap .lt. RapSigma2 .and. sogpo .gt. 0.4) then
!     if (Rap .lt. RapSigma2 .and. sogpo .gt. 0.3) then
      if (ifGmin == 0) then
          if (nint(Rap) .lt. nint(RapSigma2)) then
!     write(lo,*) ' XXXX Rap,RapSigma2,sogpo',Rap,RapSigma2,sogpo
              if (sogpo .gt. 0.15) then
corig             sogpo = sogpo - 0.05
cnew              sogpo = sogpo - 0.025
                  sogpo = sogpo - 0.05
                  go to 4500
              endif
          endif
      endif
c     write(lo,*) ' XXXX nstr,nupos,Rap,sogpo',nstr,nupos,Rap,sogpo
      if (ifFromPhase == 0) then
          write(lo,5011) nint(Rap),sogpo
      endif
 5011 format(/,' Used ',i3,' triplets per reflection.  Gmin =',f5.2)

      nuposo=nupos
      if (nuneg.le.500) then
         nunego=nuneg
      else
         nunego=nuneg
         indne=indne+nuneg-500
         nuneg=500
      endif
      do while (nuneg.gt.nmxtn) 
         iniz=indne
         indne=0
         nuneg=0
         sogne=sogne-0.05
         do 6030 i=iniz,ntr10
            if (gq(i).le.sogne) then
               if (indne.eq.0) indne=i
               nuneg=nuneg+1
            endif
 6030    continue
      end do
      if (nupos.le.0) then
          ier = -1
          Msg = 'Sorry, no triplets found.'
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      else
          risultati(1,1)=nuposo
          risultati(1,2)=nupos
          risultati(2,1)=nunego
          risultati(2,2)=nuneg
          igm=gq(nupos)*1000.
          if (kverbo > 0) then
              call test10n()
          endif
          SogPos = float(igm) * 0.001
c         SogPos = sogpo
          SogNeg = abs(sogne)
          call test10bis(ifFromPhase)
          NSigPos = nupos
          NSigNeg = nuneg
          inizNeg = indne
          numbReflTrip = nstr
*gl*      call wrtr9(igm,1)
!          if (knw /= 0 .and. kverbo /= 0) then
!              call PTot(igm)
!          endif
      endif
c
      return
      end
c---------------------------------------------------------
      subroutine test10n()
      USE General
      USE Symmetry
      USE Riflessi
      USE InvarStuff
c
c--test on p10 results
c
      common /inp/  natom,fnat,atoms
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common/dirps/npsa
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,limit(4),dume
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
      common /nctst/ ns,br(22),nbv(11,22,3),fnb(11,22,3),bcm(11,22,3),
     *                        acm(11,22,3)
c
c--
      dimension nor1(3),sdc(3),sdca(3)
c--
      njn=1
c--  prepara il buffer per il test
      if (icent.eq.0) then
         if (knw.eq.1) then
             call nclrt
         else
             call nclrt1
         endif
      else
         if (knw.eq.1) then
             call clrt
         else
             call clrt1
         endif   
      endif
c-- nusba = serial number of the first wrong and positive triplet
      if (ntrs.gt.0) write(lo,5050)
 5050 format(//,10x,'code',14x,
     1      'g(2r)',5x,'g(1r)',3x,'phi(calc)',
     2       4x,'phi(ver)',7x,'dphi',/)
c--loop per eseguire delle stampe utili
      nusba=0

c      do 5001 ii=1,3
c         if (ii.eq.2.and.icent.eq.1) go to 5001
      do 5001 ii=1,2
         mark=0
         if (ii.eq.2) mark=1
         n8w=1
         iniz=limit(ii+2)
         ifin=limit(ii)+iniz-1
         sdc(ii)=0.0
         sdca(ii)=0.0
         do 5000 i=iniz,ifin
            mark1=1
            if(ntrs.lt.n8w)mark1=0
            ia=int(gq(i)*100.)
            call decom(i,g,ggv,ishi,ib)
            b=float(ib)*dtor
            a=cos(b)
            an=a*gq(i)
            if (icent.eq.1) then
c-- centrosymmetric test
               gval=gq(i)
               if (knw.eq.1) then
                   call sctst(gval,an,1)
               else
                   call sctst1(gval,an)
               endif
               coat=1.0
               if (gval.lt.0.0) coat=-1.0
            else
c-- noncentrosymmetric test
               bb=sin(b)
               g2=gq(i)
               call besse(g2,coat)
               bang=ib
               if (ib.gt.180) bang=360.0-bang
               if (knw.eq.1) then
                   call nctet(g2,a,bang,1)
               else
                   call nctet1(g2,coat,a)
               endif
               an=coat*a
            endif
            nusba=i
            if (ii.eq.1) then
               if (.not.(nusba.eq.0.or.an.ge.0)) nusba=i
            endif
            if (knw.ne.0) then
               aa=b
               cc=acos(coat)
               dc=cc-aa
               adc=abs(dc)
               if ((adc-pi).gt.0.0) then
                  dc=twopi-adc
                  dc=-dc
               endif
               sdc(ii) =sdc(ii) +    dc
               sdca(ii)=sdca(ii)+abs(dc)
               do  k=1,3
                  nor1(k)=nor(k)*iseg(k)
               end do
               if((mark+mark1).ne.0.and.iprin.ge.1) then
                  cc=cc*180./pi
                  aa=aa*180./pi
                  dc=dc*180./pi
                  write(lo,5100)(nor1(k),k=1,3),gq(i),ggv,cc,aa,dc
               endif
            endif
         n8w=n8w+1
 5000 continue
      if (limit(ii).ne.0.and.knw.ne.0) then
         xxx=180.0/(pi*float(limit(ii)))
         sdc(ii) = sdc(ii) * xxx
         sdca(ii)=sdca(ii) * xxx
      endif
 5001 continue
!      if (knw.eq.1) write(lo,5500) nusba
 5500 format(/,1x,'serial number of the first wrong triplet =',i5)
 5100 format(4x,3i5,4x,2f10.2,3f12.2)
 5200 format(/,49x,'<dphi>',5x,'</dphi/>',
     1 /,2x,i6,' positive relationships ',12x,2f10.3,
!     2 /,2x,i6,' enantiomorph sensitive rel. ', 7x,2f10.3,
     3 /,2x,i6,' negative relationships ',12x,2f10.3,//)
      if (kverbo.ne.0) then
          write(lo,2998)
 2998 format(/,15x,'Triplets statistic (enantiomorph triplets excluded)'
     *        ,/)
          if (icent.le.0) then
             if (knw.eq.1) write(lo,5200)
     *        (limit(ii),sdc(ii),sdca(ii),ii=1,2)
c--  stampa il test (non centro)
             if (knw.eq.1) then
                 call nstst
             else
                 call nstst1
             endif
          else
c--  stampa il test (centro)
             if (knw.eq.1) then
                 call stst
             else
                 call stst1
             endif
          endif
      endif
c
      return
      end
c--------------------------------------------------------------
      subroutine test10bis(ifFromPhase)
      USE General
      USE Symmetry
      USE Riflessi
      USE InvarStuff
c
c--test on p10 results
c
      common /inp/  natom,fnat,atoms
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common/dirps/npsa
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,limit(4),dume
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
      common /nctst/ ns,br(22),nbv(11,22,3),fnb(11,22,3),bcm(11,22,3),
     *                        acm(11,22,3)
c
c--  prepara il buffer per il test
      if (icent.eq.0) then
         if (knw.eq.1) then
             call nclrt
!            call nclrt_Stat_Trip()
         else
             call nclrt1
         endif
      else
         if (knw.eq.1) then
             call clrt
         else
             call clrt1
         endif
      endif
c--loop per eseguire delle stampe utili
      do 5000 i=1,ntr10
         ia=int(gq(i)*100.)
         call decom(i,g,ggv,ishi,ib)
         if (gq(i).eq.0.0) go to 5000
         b=float(ib)*dtor
         a=cos(b)
         an=a*gq(i)
         if (icent.eq.1) then
c-- centrosymmetric test
            gval=gq(i)
            if (knw.eq.1) then
                call sctst(gval,an,1)
            else
                call sctst1(gval,an)
            endif
            coat=1.0
            if (gval.lt.0.0) coat=-1.0
         else
c-- noncentrosymmetric test
            bb=sin(b)
            g2=gq(i)
            call besse(g2,coat)
            bang=ib
            if (ib.gt.180) bang=360.0-bang
            if (knw.eq.1) then
                call nctet(g2,a,bang,1)
!               call Stat_Trip(g2,a,bang,1)
            else
                call nctet1(g2,coat,a)
            endif
            an=coat*a
         endif
c
 5000 continue
      if (ifFromPhase == 0) then
          write(lo,2998)
          if (icent.le.0) then
c--  stampa il test (non centro)
             if (knw.eq.1) then
                 call nstst
!                call Prt_Stat_Trip()
             else
                 call nstst1
             endif
          else
c--  stampa il test (centro)
             if (knw.eq.1) then
                 call stst
             else
                 call stst1
             endif
          endif
      endif
 2998 format(/,25x,'Triplets statistic ',/)
!
      return
      end
c--------------------------------------------------------------
      subroutine sortgn(numb)
      USE General
      USE Symmetry
      USE InvarStuff
!
      common /inp/  natom,fnat,atoms
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common/dirps/npsa
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,numbQuart
     1 ,nsog,sqes,nquam,nquat,ecr1,iecr1
!
!--sort the sigma 2 and the g-correct list
!
      if (numb.eq.1) return
      m=2
 2010 continue
      in=numb/m
      if (in.le.0) in=1
      ifin=numb-in
 2040 continue
      mark=0
      do i=1,ifin
         k=i+in
         if (gq(i).lt.gq(k)) then
             do n=1,3
                jc=isig(n,i)
                isig(n,i)=isig(n,k)
                isig(n,k)=jc
             enddo
             gval=gq(i)
             gq(i)=gq(k)
             gq(k)=gval
             vg=gv(i)
             gv(i)=gv(k)
             gv(k)=vg
             mark=1
         endif
      enddo
      if (mark.gt.0) go to 2040
      if (in.le.1) return
      m=m*2
      go to 2010
      end
c-----------------------------------------------------------------------
c-- sir code for quintets                        Release 2004.01
!!mr  subroutine quintets(risultati,kverbo,ifFromPhase)
!!mr  kverbo e' nel modulo General 
      subroutine quintets(risultati,ifFromPhase)
      USE General
      USE Symmetry
      USE Riflessi
      USE InvarStuff
      USE PhaseStuff
!
c
      common /inp/  natom,fnat,atoms
      common /proc/ iftr,ifp10,ifnq,ifps,ifcoc
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common/dirps/npsa
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common/dirqn/ecros,iecros,ncode,icody,numbQuart
     1 ,nsog,sqes,nquam,nquat,ecr1,iecr1
      common/enant/ nqenex,n23m,n23l,gm,nqen
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
!      common /tst/ nt,ar(26),nno(11,26,3),ppv(11,26,3)
      common /nctst/ ns,br(22),nbv(11,22,3),fnb(11,22,3),bcm(11,22,3),
     *                        acm(11,22,3)
      common/nq/nor1(6),nop1(6),iseg1(6),icodqn,sumc,sums,sume
      common/wrt/icv(4,7),ishf,ifas,eewrt(3),icodx(3),iqua(1000),
     1           itac(5,24,4),eee(3)
      common/zero/argq(26),ncal(26),nver(26),ntt,fm(26),gt(26)
c
      common /xdata1/ limref(4001),nn(8),lim1(4001)
!psie      
!psie      common /xdata1/ limref(12001),nn(8),lim1(12001)
      common /qui/ nopera(4),noptr(3),nvet(5)
      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
     *                  NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!psie      
!psie      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
!psie     *                   NPsie,NPsiZero, numbReflTrip, SogNeg, SogQuaNeg

      dimension ncoq(5),nopq(5),isegq(5),evq(15),epsiq(15),ill(3)
      dimension vet(12),ivet(12),ikln(60),nn1(8),iphq(5),
     *          isegqu(4),iphqu(4)

      integer risultati(7,2),hklq(3,15)

*     integer, allocatable :: iph(:)
      integer, allocatable :: nbinv(:)

      equivalence (ivet(1),vet(1))
c
      zer=0.1e-20
      fnat2=fnat*fnat
      if (ifps == 1) then
!
!-- calcolo psi-zero e quartetti negativi
!
          call strip9(1,risultati,ifFromPhase,ier)
!
          NPsiZero = npsa
          call PreparaIph(2, 0)
!
*gl*      call wrtr9(igm,2)
!
      endif
      if (ifnq.eq.0) return
      if (ifFromPhase == 0) then
          write(lo,1440) npsa,nstr,nzro
          write(lo,1441) npsa/nzro ! dedi
      endif
 1440 format(/,i6,' Psi-zero triplets found among ',i5,
     *            ' strongest reflections',
     *       /,25x,'and the ',i4,'  weakest reflections')
 1441 format(/,i6,' Psi-zero triplets per (weak) reflection ') ! dedi
      call negq(risultati, ifFromPhase)
c--clear the areas
      do k=1,itabmx
         itab(k)=0
      end do
c--  ifatx:superindice massimo
      do i=1,ifatx
         isr(i)=0
      end do
c--create the list
      ipu=0
      do 1090 j=1,nstr
c-- carica le inform. relative ai riflessi forti
         ih=khl(1,j)
         ik=khl(2,j)
         il=khl(3,j)
         do 1080 i=1,nsym
            ipu = ipu + 1
            if (i.eq.1) then
               indr=ih*ifat1+ik*ifat2+il
               itabK(ipu) = ik
               itabL(ipu) = il
            else
               ill(1)=ih*kmat(i,1,1)+ik*kmat(i,2,1)+il*kmat(i,3,1)
               ill(2)=ih*kmat(i,1,2)+ik*kmat(i,2,2)+il*kmat(i,3,2)
               ill(3)=ih*kmat(i,1,3)+ik*kmat(i,2,3)+il*kmat(i,3,3)
               indr=ill(1)*ifat1+ill(2)*ifat2+ill(3)
               itabK(ipu) = ill(2)
               itabL(ipu) = ill(3)
            endif
            indrr=indr
            indra=iabs(indr)
            if (i.ne.1) then
c -----   elimina i doppioni
               imen1=i-1
               do 1086 i1=1,imen1
                  if (indra.eq.iabs(ikln(i1))) indrr=0
 1086          continue
            endif
            ikln(i)=indrr
            a=ih*tmat(i,1)+ik*tmat(i,2)+il*tmat(i,3)
            k=nint(a*24.)
            k=mod(k,24)
            if(k.lt.0) k=k+24
            itab(ipu)=indrr
            isr(indra)=-(j*1000+k)
1080     continue
1090  continue
c
c--create the isr list
c
      do 1220 i=1,nrefl
         if (i.gt.nstr) then
            ih=khl(1,i)
            ik=khl(2,i)
            il=khl(3,i)
            do 1210 i1=1,nsym
               if (i1.eq.1) then
                  indr=ih*ifat1+ik*ifat2+il
               else
             ill(1)=ih*kmat(i1,1,1)+ik*kmat(i1,2,1)+il*kmat(i1,3,1)
             ill(2)=ih*kmat(i1,1,2)+ik*kmat(i1,2,2)+il*kmat(i1,3,2)
             ill(3)=ih*kmat(i1,1,3)+ik*kmat(i1,2,3)+il*kmat(i1,3,3)
                  indr=ill(1)*ifat1+ill(2)*ifat2+ill(3)
               endif
               indr=iabs(indr)
               e=evet(i)
               if (e.lt.0.01) e=0.01
               isr(indr)=int(e*100+.05)
 1210       continue
         endif
 1220 continue
c -----
c     call sub. lettura lista 8 : tripletti positivi
c -----
      iprea=-1
      if (NSigPos <= 0) then
         write(lo,5818)
 5818    format(//,' ****  error : no triplets calculated    ****',
     *       //,' ****  try with more active reflections ****',//)
         ier=-1
         return
      end if
c **********************************************************************
c -----
c     call sub. lettura lista 8 : tripletti positivi
c -----
      ntrip = NSigPos
      numb = numbReflTrip
      if (.NOT. Allocated(iph)) then
          Allocate (iph(1:3*ntrip+10000), stat = ierr)
          if (ierr.ne.0) then
              write(lo,*) 'iph Allocation error'
              call cstop(' ')
          endif
          iph(:) = 0
      endif
      if (.NOT. Allocated(nbinv)) then
          Allocate (nbinv(1:3*ntrip), stat = ierr)
          if (ierr.ne.0) then
              write(lo,*) 'nbinv Allocation error'
              call cstop(' ')
          endif
          nbinv(:) = 0
      endif
!-- j = puntatore  nel vettore iph
      j   = 1
      ntt = 0
      do 10 ii= 1,ntrip
!gl!     call unpak3Sir (isig(1,ii),n1,n2,ifaz)
!gl!     call unpak3Sir (isig(2,ii),n3,ia,ifaz)
         n1    = iet(1, ii)
         n2    = iet(2, ii)
         n3    = iet(3, ii)
         ia    = iet(4, ii)
         ifaz  = iet(5, ii)
         isave = iet(6, ii)
*        write(6,'(6i5,i10)') ii, iet(1:6,ii)
         kod1 = isave/8192
         k = kod1 / 32
         in3 = mod(kod1, 32)
         ntt = ntt + 1
         if (icent > 0) ia = 2 * ia
         if (ia > 2047) ia = 2047
         iph(j) = ((n1+4096)*8192+n2+4096)*32
         iph(j+1) = ((n3+4096)*8192 + ia + 4096)*32
         iph(j+2) = ((k+4096)*8192 + in3 + 4096)*32 + ifaz + 1
         j = j + 3
  10  continue
      idum=0
      nq=0
c =============== numero totale di relazioni considerate ===========
      nrel = ntt+nq
      nrel1 = j-1
c     write(lo,6020) nrel,ntt,nq,nrel1, numb
c6020 format(///,' num.tot.  num.sigma2.  num.quar.  ',
c    */,2x,i5,7x,i5,7x,i5,7x,i5,7x,i5)
c
c   preparation of pointers table
c
      nb1 = numb + 1
      do i = 1,nb1
         limref(i) = 0
      end do
      j = 1
      do 120 i = 1,nrel
         call depac1 (iph,ntrip,0,j,a,ifaz,iw,noptr,inop1)
         j = j + iw
         do 110 kk = 1,4
            if(nn(kk).eq.0) go to 110
            n1=iabs(nn(kk))+1
            limref(n1) = limref(n1) + 1
110      continue
120   continue
      do 130 i = 1,numb
         limref(i+1) = limref(i+1) + limref(i)
         lim1(i+1) = limref(i+1)
130   continue
      lim1(1) = 0
c
c  storage of the no. of relations for a given reflections
      j = 1
      do 150 i = 1,nrel
         call depac1 (iph,ntrip,0,j,a,ifaz,iw,noptr,inop1)
         do 140 kk = 1,4
            if(nn(kk).eq.0) go to 140
            ind=iabs(nn(kk))
            lim1(ind) = lim1(ind) + 1
            ind1= lim1(ind)
            nbinv(ind1) = j
140      continue
         j = j+iw
150   continue
!   LOOP PER EVENTUALE CONTROLLO INPACCHETTAMENTO IN IPH
      do 300 i=1,numb
         n1=0
         n2=0
         lm=limref(i)+1
         ls=limref(i+1)
         if(lm.gt.ls) goto 300
         do 220 ii=lm,ls
            ind=nbinv(ii)
            call depac1 (iph,ntrip,0,ind,a,ifaz,iw,noptr,inop1)
            if (iw.eq.3) then
               n1=n1+1
            else
               n2=n2+1
            endif
  220    continue
  300 continue
      ncont=1
      nrejec=0
      if (knw.eq.1) then
         if (icent.eq.1) then
            call clrt
         else
            call nclrt
         endif
      else
         if (icent.eq.1) then
            call clrt1
         else
            call nclrt1
         endif
      endif
      Msg = 'Improve quartets'
      call scrper(Msg,0,0)
      nperc=100
      iperc0=numbQuart/nperc
      iperc=iperc0
      jperc=0
      iiq=0
      do 8900 i = 1,numbQuart
         if (i.eq.iperc) then
            jperc=jperc+1
            iperc=iperc+iperc0
            call scrper(' ',jperc,nperc)
         endif
         somma=0.0
         nqui=0
         nn(1)=inq(1,i)/32
         nopera(1)=mod(inq(1,i),32)
         nn(2)=inq(2,i)/32
         nopera(2)=mod(inq(2,i),32)
         nn(3)=inq(3,i)/32
         nopera(3)=mod(inq(3,i),32)
         nn(4)=inq(4,i)/32
         nopera(4)=mod(inq(4,i),32)
         jg=inq(6,i)/1000
         gquar=-float(jg)/100.
         pquold=0.5+0.5*tanh(gquar)
         ifaz=mod(inq(5,i),32)
         do jcris=1,4
            nn1(jcris)=nn(jcris)
            isegqu(jcris)=sign(1,nn1(jcris))
         end do
         iphqu(1)=ipub(iabs(nn1(1)))*isegqu(1)
         iphqu(2)=ipub(iabs(nn1(2)))*isegqu(2)
         iphqu(3)=ipub(iabs(nn1(3)))*isegqu(3)
         iphqu(4)=ipub(iabs(nn1(4)))*isegqu(4)
         iphi=iphqu(1)+iphqu(2)+iphqu(3)+iphqu(4)
         if(iphi.lt.0)iphi=iphi+1800
         iphi=mod(iphi,360)
         ifas=iphi
         ifazq=ifaz
         ishf=ifaz*15
         ifass=ifas+ishf
         if(ifass.lt.0)ifass=ifass+1800
         ifass=mod(ifass,360)
         do 8881 jpun=1,4
            jj=iabs(nn1(jpun))
            isn1=sign(1,nn1(jpun))
            inop=iabs(nopera(jpun))
            j1=1
            do 7006 jcris=1,4
               if(iabs(nn1(jcris)).eq.jj) go to 7006
               ncoq(j1)=nn1(jcris)
               isegq(j1)=sign(1,nn1(jcris))
               nopq(j1)=iabs(nopera(jcris))
               j1=j1+1
 7006       continue
            lm=limref(jj)+1
            ls=limref(jj+1)
            do 8880 ii=lm,ls
               ind=nbinv(ii)
               call depac1 (iph,ntrip,jj,ind,a,ifaz,iw,noptr,inop1)
               if(inop.ne.inop1) go to 8880
               gtrip=a
               do 7012 jcris=2,3
                  do 7010 jcris1=1,3
                     if (iabs(nn(jcris)).eq.iabs(ncoq(jcris1))) then
                        nrejec=nrejec+1
                        go to 8880
                     endif
 7010             continue
 7012          continue
               ncros=0
               isnn1=sign(1,nn(1))
               nn2=nn(2)
               nn3=nn(3)
               if (isn1.ne.isnn1) then
                  nn2=-nn(2)
                  nn3=-nn(3)
               endif
               nopq(4)=noptr(2)
               nopq(5)=noptr(3)
               ncoq(4)=-nn2
               ncoq(5)=-nn3
               isegq(4)=sign(1,ncoq(4))
               isegq(5)=sign(1,ncoq(5))
               do 7030 jjj=1,5
                  ncod=iabs(ncoq(jjj))
!      evq(jjj)=evet(ncod)
! Cristina
                  ke1 = int(evet(ncod)*100.+0.5)*512
                  e = float(ke1/512)/100.
! Cristina
!      evq(jjj)=evet(ncod)
                  evq(jjj)=e
                  epsiq(jjj)=evq(jjj)*evq(jjj)-1.
 7030          continue
               isp=0
               do 7050 jjj=1,5
                  ncod=iabs(ncoq(jjj))
                  i1=nopq(jjj)
                  ih=khl(1,ncod)
                  ik=khl(2,ncod)
                  il=khl(3,ncod)
      ill(1)=ih*kmat(i1,1,1)+ik*kmat(i1,2,1)+il*kmat(i1,3,1)
      ill(2)=ih*kmat(i1,1,2)+ik*kmat(i1,2,2)+il*kmat(i1,3,2)
      ill(3)=ih*kmat(i1,1,3)+ik*kmat(i1,2,3)+il*kmat(i1,3,3)
                  hklq(1,jjj)=ill(1)*isegq(jjj)
                  hklq(2,jjj)=ill(2)*isegq(jjj)
                  hklq(3,jjj)=ill(3)*isegq(jjj)
                  indr=ill(1)*ifat1+ill(2)*ifat2+ill(3)
                  ie=isr(iabs(indr))
                  ie=iabs(ie)
                  k=mod(ie,1000)
                  isp=isp+k*isegq(jjj)
 7050          continue
               isp=isp+96
               isp=mod(isp,24)
               iss=isp*360/24
c -----
c     controllo sommatoria indici dei riflessi base del quintetto
c -----
               do 7058 jcris=1,3
                  isum=0
                  do jcris1=1,5
                     isum=isum+hklq(jcris,jcris1)
                  end do
                  if (isum.ne.0) then
                     write(lo,*) ' controllo',i,nqui
                     write(lo,7056) (ncoq(jjj),(hklq(jcris2,jjj),
     *                               jcris2=1,3),evq(jjj),jjj=1,5)
 7056 format(3(i4,'*',3i3,f6.2))
                     call cstop(' ')
                  endif
 7058          continue

            ncr1=1
            ncr2=2
            do krc=6,14 
               do jcris=1,3
                  hklq(jcris,krc)=hklq(jcris,ncr1)+hklq(jcris,ncr2)
               end do
               ncr2 = ncr2 + 1
               if (ncr2.gt. 5) then
                  ncr1 = ncr1 + 1
                  ncr2 = ncr1 + 1
               end if
               do jcris=1,3
                  ill(jcris)=hklq(jcris,krc)
               end do
               ind1=ill(1)*ifat1+ill(2)*ifat2+ill(3)
               icp2=iabs(ill(2))
               icp3=iabs(ill(3))
               if ( (iabs(ind1).gt.ifatx) .or. (icp2.gt.ihmx(2)).or.
     +            (icp3.gt.ihmx(3)) .or. (ind1.eq.0) ) then
                  evq(krc)=0.0
                  epsiq(krc)=0.0
               else
                  ie=isr(iabs(ind1))
                  if (ie.eq.0)  then
                     evq(krc)=0.0
                     epsiq(krc)=0.0
                  else
                     if (ie.gt.0) then
                        e=float(ie)/100.
                     else
                        ie=iabs(ie)
                        ie=ie/1000.
                        if (ie.eq.iabs(ncoq(1)).or.
     +                      ie.eq.iabs(ncoq(2)).or.
     +                      ie.eq.iabs(ncoq(3)).or.
     +                      ie.eq.iabs(ncoq(4)).or.
     +                      ie.eq.iabs(ncoq(5))) go to 8880
!                e = evet(ie)
! Cristina
                         ke1 = int(evet(ie)*100.+0.5)*512
                         e = float(ke1/512)/100.
! Cristina
                     endif
                     evq(krc)=e
                     epsiq(krc)=e*e-1.0
                     ncros=ncros+1
                  endif
               endif
            end do
               do jcris=1,3
          hklq(jcris,15)=hklq(jcris,1)+hklq(jcris,2)+hklq(jcris,3)
               end do
!      evq(15)=evet(jj)	 
! Cristina
               ke1 = int(evet(jj)*100.+0.5)*512
               e = float(ke1/512)/100.
! Cristina
               evq(15)=e	 
               epsiq(15)=evq(15)*evq(15)-1.
               ncros=ncros+1
               if (ncros.lt.6) go to 8880
               do jpip=1,5
                  iphq(jpip)=ipub(iabs(ncoq(jpip)))*isegq(jpip)
               end do
c *********************************************************************
c -----
c  calcolo  attendibilita'  quintetto
c -----
c **********************************************************************
               arg=evq(1)*evq(2)*evq(3)*evq(4)*evq(5)*fnat*fnat2
               a=0.0
               do jcris=6,15
                  a=a+epsiq(jcris)
               end do
               a=a-epsiq(6)-epsiq(7)-epsiq(10)-epsiq(15)
               b=epsiq(6)*epsiq(13)+epsiq(6)*epsiq(14)+
     +         epsiq(7)*epsiq(11)+epsiq(7)*epsiq(12)+
     +      epsiq(8)*epsiq(10)+epsiq(8)*epsiq(14)+epsiq(8)*epsiq(12)+
     +         epsiq(10)*epsiq(9)+epsiq(11)*epsiq(14)+
     +      epsiq(11)*epsiq(9)+epsiq(13)*epsiq(9)+epsiq(13)*epsiq(12)
               c=epsiq(1)*epsiq(4)*epsiq(8)+epsiq(1)*epsiq(5)*epsiq(9)+
     +         epsiq(1)*epsiq(11)*epsiq(14)+
     +         epsiq(1)*epsiq(13)*epsiq(12)+
     +         epsiq(2)*epsiq(4)*epsiq(11)+epsiq(2)*epsiq(5)*epsiq(12)+
     +         epsiq(2)*epsiq(8)*epsiq(14)+
     +         epsiq(2)*epsiq(13)*epsiq(9)+epsiq(3)*epsiq(4)*epsiq(13)+
     +         epsiq(3)*epsiq(5)*epsiq(14)+
     +         epsiq(3)*epsiq(8)*epsiq(12)+epsiq(3)*epsiq(11)*epsiq(9)+
     +         epsiq(4)*epsiq(5)*epsiq(15)+epsiq(4)*epsiq(6)*epsiq(14)+
     +         epsiq(4)*epsiq(7)*epsiq(12)+epsiq(4)*epsiq(10)*epsiq(9)+
     +         epsiq(5)*epsiq(6)*epsiq(13)+epsiq(5)*epsiq(7)*epsiq(11)+
     +         epsiq(5)*epsiq(8)*epsiq(10)
               c=c*fnat2*0.5
               if (c.lt.0.0) c =0.0
               g=arg*((a+b)/(1.0+c))
               g= g / (1.+6.*fnat)
               pquin=0.5+0.5*tanh(g)
               ptri=0.5+0.5*tanh(gtrip)
               pquar=pquin*(1.-ptri)+(1.-pquin)*ptri
               sogmin=.1e-06
               pquarp=1.-pquar
               if(pquarp.lt.sogmin)pquarp=sogmin
               if(pquar.lt.sogmin)pquar=sogmin
               som1=alog(pquarp)
               som2=alog(pquar)
               somma=somma+(som1-som2)
               nqui=nqui+1
 8880       continue
 8881    continue
         gnew=0.5*somma
         gnew=gnew+gquar
         gnew=gnew/2.
         b=float(ifass)*pi/180.
         a=cos(b)
         an=a*gnew
         if (icent.eq.1) then
c-- centrosymmetric test
            if (knw.eq.1) call sctst(gnew,an,1)
            call sctst1(gnew,an)
         else
c-- noncentrosymmetric test
            g2=abs(gnew)
            call besse(g2,coat)
            g2=gnew
            coat=-coat
            bang=ifass
            if (ifass.gt.180) bang=360.0-bang
            if (knw.eq.1) call nctet(g2,a,bang,1)
            call nctet1(g2,coat,a)
         endif
!         write(lo,'(5i6,f10.7)') i,nn1(1),nn1(2),nn1(3),nn1(4),gnew
         if(gnew.gt.0.0) go to 8900
         ith=0
         if (gnew.lt.0.0) ith=314
         gnew=abs(gnew)
         if (gnew.gt.20.47) gnew=20.47
         jg=nint(gnew*100)
         isp=ifazq
         icont=0
         iiq=iiq+1
         inq(1,iiq)=isegqu(1)*(iabs(nn1(1))*32+iabs(nopera(1)))
         inq(2,iiq)=isegqu(2)*(iabs(nn1(2))*32+iabs(nopera(2)))
         inq(3,iiq)=isegqu(3)*(iabs(nn1(3))*32+iabs(nopera(3)))
         inq(4,iiq)=isegqu(4)*(iabs(nn1(4))*32+iabs(nopera(4)))
         inq(5,iiq)=jg*32+ifazq
         inq(6,iiq)=jg*1000+ith
         inq(7,iiq)=(ifass*10*8+icont)
 8900 continue
      call sortc(iiq,inq)
      numbQuart=iiq
      do 8988 i=1,numbQuart
         n1=inq(1,i)/32
         n2=inq(2,i)/32
         n3=inq(3,i)/32
         n4=inq(4,i)/32
         jgc=inq(6,i)/1000
         isp=mod(inq(5,i),32)
         inq(1,i)=((n1+4096)*8192+n2+4096)*32
         inq(2,i)=((n3+4096)*8192+n4+4096)*32
         inq(3,i)=((1024+4096)*8192+jgc+4096)*32+isp+1
 8988 continue
c -----
c     call  sub.  per  scrittura  quartetti  negativi  :  lista   20
c -----
      NQuaNeg = numbQuart
      call PreparaIph(3, 0)
      iprea=0
      if (numbQuart.ne.0) then
!gl!     nxxe = 0                 ! rimozione liste relazioni 31/03/2010
!gl!     iccd = 0                 ! rimozione liste relazioni 31/03/2010
!gl!     call frmxx(iprea,20,numbQuart,numbQuart,nxxd,nxxe,iccd,inq) ! rimozione liste relazioni 31/03/2010
*        write(lo,2998)
         if (ifFromPhase == 0) then
             if (knw == 1) then
                if (icent == 1) then
                   call stst
                else
                   call nstst
                endif
             else
                if (icent == 1) then
                   call stst1
                else
                   call nstst1
                endif
             endif
          endif
      endif
 2998 format(/,20x,'             Quartets statistic',/)
      risultati(6,1)=numbQuart
      risultati(6,2)=numbQuart
      call scrper(' ',0,-1)
c
      DEALLOCATE (iph, nbinv, stat = ierr)
c
      return
      end
c--------------------------------------------------------------
      subroutine depac1 (iph,ntrip,i,ind,a,ifaz,iw,noptr,inop1)
      USE General
      USE Symmetry
      USE InvarStuff
      common /xdata1/ limref(4001),nn(8),lim1(4001)
!psie      
!psie      common /xdata1/ limref(12001),nn(8),lim1(12001)
      dimension noptr(3),nn1(8),noptr1(3)
      dimension iph(3*ntrip+10000)
!
      do j = 1,8
         nn(j) = 0
      enddo
      noptr(1)=1
      do j = 2,3
         noptr(j) = 0
      enddo
      call unpak3Sir(iph(ind),nn(1),nn(2),ifaz)
      if(ifaz.lt.0) go to 20
         write(lo,100) ind,nn(1),nn(2),iph(ind),ifaz
  100  format(' error in subroutine depac1',3i6,i20,i4)
         call cstop(' ')
20    call unpak3Sir (iph(ind+1),nn(3),nn(4),ifaz)
      if(ifaz.lt.0) go to 25
         write(lo,100) ind,nn(1),nn(2),iph(ind),ifaz
         call cstop(' ')
25    call unpak3Sir (iph(ind+2),nn(5),nn(6),ifaz)
      iw = 3
      a= 0.01*nn(4)
      noptr(2)=nn(5)
      noptr(3)=nn(6)
c     if(nn(1).eq.1.and.iabs(nn(2)).eq.3)
c    *  write(lo,*) nn(1),nn(2),nn(3),nn(4),nn(5),nn(6)
      nn(4) = 0
      nn(5) = 0
      nn(6) = 0
c  relationship solution in terms of i
      if(i.eq.0) return
      do j= 1,4
         if (nn(j).eq.0) exit
         nn1(j)=nn(j)
      enddo
      do j= 1,3
         noptr1(j)=noptr(j)
      enddo
c     if(nn(1).eq.1.and.iabs(nn(2)).eq.3)
c    * write(lo,*) i,nn(1),noptr(1),nn(2),noptr(2),nn(3),noptr(3)
      do 50 j = 1,4
      if(iabs(nn1(j)).eq.i) go to 60
50    continue
      write(lo,55)i,nn
55    format (5x,'*****error in subroutine  depac1 ******',i5,3x,4i5)
      call cstop(' ')
60    isi = isign(1,nn1(j))
      inop1=noptr(j)
      nn(1)=nn1(j)
      j1 = 2
      do 70 jcris = 1,3
      if(jcris.eq.j) go to 70
c     nn(j1) = nn(jcris)*(-isi)
      nn(j1) = nn1(jcris)
      noptr(j1)=noptr1(jcris)
      j1 = j1+1
70    continue
c     ifaz = ifaz*(-isi)
      if(ifaz.lt.0) ifaz=ifaz+24
      nn(4) = 0
      return
      end
c-----------------------------------------------------------
      subroutine negq(risultati, ifFromPhase)
      USE General
      USE Symmetry
      USE Riflessi
      USE InvarStuff
      USE QModule
!
c--calculate negative quartet
c  h1 + h2 + h3 + h4 = 0
c  i  h1 code
c  j  h2 code
c jj  h3 code
c in  h4 code
c
c
      common /inp/  natom,fnat,atoms
      common /proc/ iftr,ifp10,ifnq,ifps,ifcoc
      common /dirtr/emin,ntra,sgg,MaxPsi0
      common/dirps/npsa
      common/dir10/numk,ntrs,ntr10,sogpo,sogne,nupos,nuneg,
     1 indpo,indne,nmxtn
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee2(24,6)
      common/dirqn/ecros,iecros,ncode,icody,numbQuart
     1 ,nsog,sqes,nquam,nquat,ecr1,iecr1
      common/enant/ nqenex,n23m,n23l,gm,nqen
      common/esti/ib(3),ih(3,2,24),ii(2,24)
      common/nq/nor1(6),nop1(6),iseg1(6),icodqn,sumc,sums,sume
      common/wrt/icv(4,7),ishf,ifas,ee(3),icodx(3),iqua(1000),
     1           itac(5,24,4),eee(3)
      common/zero/arnq(26),ncal(26),nver(26),ntt,fm(26),gt(26)
c
c--
      dimension ev(7)
      integer risultati(7,2)
c

c--
c
Corig call Cancella (20)
      zer = 0.1E-10
      call recip()
c--new 12/6/92
      if(knw.eq.1) then
         if (icent.eq.1) then
             call clrt
         else
             call nclrt
         endif
      else
         if (icent.eq.1) then
             call clrt1
         else
             call nclrt1
         endif
      endif
c--endnew 12/6/92
c
c--calculate negative quartet(s) from psi-zero relationships.
c
c--ncode:codice per definire il tipo di quart.(in funzione dei c.v.)
c        da valutare.
c  ncode=0   tutti
c  ncode=1   1deb+1ass.spec.+1ass.
c  ncode=2   1deb+est.+1ass.
c  ncode=3   2deb+1ass.
c  ncode=4   2deb+1ass.spec.
c  ncode=5   2deb+1est.
c  ncode=6   3deb
c  ncode=7   2deb+1non forte(casi 3,4,5 e 6 insieme)
c  icody=1   valuta solo i quart. con equiv.
*     write(lo,1) npsa
*   1 format(/,' Negative quartets relationships estimated using ',
*    *i6,' psi-zero relationships ')
      iend=0
      niqua=0
      liqua=60
      liqu3=liqua*3
      numbQuart=0
      nquae=0
      fnatt=fnat*fnat
      atcel=1./fnatt
      if (atcel.lt.70) then
         sgnq=0.35
      else if (atcel.ge.70.and.atcel.lt.700) then
         sgnq=0.35*exp(-((atcel-70)/500.))
      else if (atcel.ge.700) then
         sgnq=0.1
      endif
      if (icent.eq.1) then
          sqes=-9999.0
      else
          sqes=sgnq
      endif
      l13=1
      m13=l13
      md13=3
      n13f=1000/md13
      nqen=0
      nqenex=0
      do i=1,7
         do j=1,5000
            inq(i,j)=0
         end do
      end do
c
      call scrper('Set up negative quartets  ',0,0)
      nperc=100
      iperc0=npsa/nperc
      iperc=iperc0
      jperc=0
c
      npsm1=npsa-1
      nqqc=0
      nsta=0
      do 1000 i=1, npsm1
         if (i.eq.iperc) then
            jperc=jperc+1
            iperc=iperc+iperc0
            call scrper(' ',jperc,nperc)
         endif
         is1=nrefl-(isig(1,i)/262144-4096)
         nop(1) = khl(1,is1)
         nop(2) = khl(2,is1)
         nop(3) = khl(3,is1)
         indr=nop(1)*ifat1+nop(2)*ifat2+nop(3)
         ispec=isr(indr)/icst2
         ispec=mod(ispec,2)
         isr1=isr(indr)
         call decom(i,g1,dum,ishi,iphi)
         do 1100 k=2,3
            k1=k-1
            call xbc9(nor(k),k1,nsym)
            do jc=1,4
               icv(jc,k1)=itac(jc,nop(k),k1)*iseg(k)
            end do
            nop1(k)=nop(k)
            nor1(k)=nor(k)
            iseg1(k)= iseg(k)
 1100    continue
         iplus1=i+1
         do 2000 j=iplus1, npsa
            is2=nrefl-(isig(1,j)/262144-4096)
            if(is1.ne.is2) goto 1000
c--quartetto
            do k=1,3
               icodx(k)=0
            end do
            iflag=0
            do k=1,4
               do k1=5,7
                  icv(k,k1)=0
                  eee(k1-4)=0
               end do
            end do
c -- v.b.
            call decom(j,g2,dum,ishi,iphi)
c --
c --  controllo di diversita' dei v.b.
            do k=2,3
               do k1=2,3
                  if (nor(k).eq.nor1(k1)) goto 2000
               enddo
            enddo
            do 1200 k=2,3
               k1=k+1
               iseg(k)=-iseg(k)
               call xbc9(nor(k),k1,nsym)
               do jc=1,4
                  icv(jc,k1)=itac(jc,nop(k),k1)*iseg(k)
               end do
 1200       continue
c-- first c.v.
            do k=1,4
               icv(k,5)= (icv(k,1)+icv(k,2))
            end do
!            eee(1)=evet(nor(1))
! Cristina
         ke1 = int(evet(nor(1))*100.+0.5)*512
         e = float(ke1/512)/100.
! Cristina
            eee(1)=e
            ee(1)=eee(1)*eee(1)-1
            iqua(l13)=-nor(1)
            if(ispec.ne.0)iflag=iflag+1
            nqqc=nqqc+1
c--c.v.
            m13=l13
            iqua(2)=0
            iqua(3)=0
            do 1301 k=2,3
               ied=iedeb(k,nor(1),0)
               if(ied.ne.0) go to 2000
 1301       continue
            do 1300 k1=1,2
               if(icodx(k1).ge.2) goto 2000
 1300       continue
            icont=6-icodx(1)*3-icodx(2)*2-icodx(3)
            if(icont.eq.0) then
               write(lo,*) '**** subroutine negq ****'
               write(lo,*) '**** programming  error ****'
               write(lo,*) ' sir ends in error'
               call cstop('1234 ')
            endif
            if(icont.lt.3) go to  2000
c--ishf=fase quart. vero (ifass)-fase quart. stan.(iphi)
            isp=itac(5,nop1(2),1)*iseg1(2)+itac(5,nop1(3),2)*iseg1(3)
     ,        +itac(5,nop(2),3)*iseg(2)+itac(5,nop(3),4)*iseg(3)
            isp=96-isp
            isp=mod(isp,24)
            iss=isp*15
            ishf=iss
c--
            sumep=ee(1)+ee(2)+ee(3)
            if(icodx(3).ne.0.or.iflag.ne.0) goto 2650
            if(sumep.gt.-1.) goto 2000
 2650       shf=float(isp)*twopi/24.
            cosx=cos(shf)
            sinx=sin(shf)
            sumc=sumep*cosx
            sums=sumep*sinx
            iph1=ipub(nor1(2))*iseg1(2)
            iph2=ipub(nor1(3))*iseg1(3)
            iph3=ipub(nor (2))*iseg (2)
            iph4=ipub(nor (3))*iseg (3)
            iphi=iph1+iph2+iph3+iph4
            if(iphi.lt.0)iphi=iphi+1800
            iphi=mod(iphi,360)
            ifas=iphi
            ifass=ifas+ishf
            if(ifass.lt.0)ifass=ifass+1800
            ifass=mod(ifass,360)
            fass=float(ifass)*pi/180.
!            ev(1) = evet(nor1(2))
! Cristina
         ke1 = int(evet(nor1(2))*100.+0.5)*512
         e = float(ke1/512)/100.
! Cristina
            ev(1) = e
!            ev(2) = evet(nor1(3))
! Cristina
         ke1 = int(evet(nor1(3))*100.+0.5)*512
         e = float(ke1/512)/100.
! Cristina
            ev(2) = e
!            ev(3) = evet(nor (2))
! Cristina
         ke1 = int(evet(nor (2))*100.+0.5)*512
         e = float(ke1/512)/100.
! Cristina
            ev(3) = e
!            ev(4) = evet(nor (3))
! Cristina
         ke1 = int(evet(nor (3))*100.+0.5)*512
         e = float(ke1/512)/100.
! Cristina
            ev(4) = e
            g=ev(1)*ev(2)*ev(3)*ev(4)
            g=g*fnat*fnat
            do k1=1,3
               ev(k1+4)=ee(k1)
            end do
            if(iflag.ne.0) then
               do 1292 k=4,liqu3
                  iqua(k)=0
 1292          continue
               niqua=niqua+1
               if(iequiQ(nor(1),liqu3).lt.0) goto 2000
            endif
      m13=l13
      gb=g
      if(g.gt.20.47) gb=20.47
      jg=nint(gb*100.0)
c--calcolo del gcorr.
      if (icodx(3).eq.0) then
         sums=sums+sin(shf)
         sumc=sumc+cos(shf)
      endif
      if (abs(sums).lt.zer.and.abs(sumc).lt.zer) go to 2000
c-------
      sum=sumc*sumc+sums*sums
      sum=sqrt(sum)
      gc=(2-icent)*g*sum
      if(gc.gt.20.47)gc=20.47
      jgc=nint(gc*100.0)
      thet =-atan2(sums,sumc)
      if(thet.lt.0)thet=thet+twopi
      theta=thet *360./twopi
      thet=thet+shf
      coseno=cos(thet)
      if(gc.gt.sqes.or.icent.eq.1) goto 1430
      goto 2000
 1430 if(coseno.ge.0.0.or.gc.lt.sgnq) goto 2000
c1430 if(coseno.lt.0.0.or.gc.lt.sgnq) goto 2000
c     if(numbQuart.lt.10) write(lo,4) nor1(2),nor1(3),nor(2),nor(3),nor(1),
c    1      ((icv(jj,kkc),jj=2,4),kkc=1,4),
c    1        ((icv(j1,k1),j1=2,4),ee(k1-4),k1=5,7)
c   4 format(1x,5i5,4(3i3),3x,3(3i3,f12.5))
      ith=nint(thet*100.0)
      if (icont.lt.5) then
         gc=gc*0.85
         jgc=nint(gc*100)
      endif
      if (numbQuart.ne.nquat) then
         numbQuart=numbQuart+1
!         write(lo,'(7i6)') numbQuart,nor1(2),nor1(3),nor(2),nor(3),jgc,ith
         inq(1,numbQuart)=iseg1(2)*(nor1(2)*32+nop1(2))
         inq(2,numbQuart)=iseg1(3)*(nor1(3)*32+nop1(3))
         inq(3,numbQuart)=iseg (2)*(nor (2)*32+nop (2))
         inq(4,numbQuart)=iseg (3)*(nor (3)*32+nop (3))
         inq(5,numbQuart)=jg*32+isp
         inq(6,numbQuart)=jgc*1000+ith
         inq(7,numbQuart)=(ifass*10*8+icont)
         goto 2000
      endif
      if (nquae.eq.0) then
         call sortc(numbQuart,inq)
         n13m=numbQuart
         n13l=numbQuart
         jjgm=inq(6,numbQuart)/1000
         gm=float(jjgm)/100.
      endif
      nquae=nquae+1
      if (nquae.eq.nquam) goto 4000
      if (jgc.ge.jjgm) then
         inq(1,n13m)=iseg1(2)*(nor1(2)*32+nop1(2))
         inq(2,n13m)=iseg1(3)*(nor1(3)*32+nop1(3))
         inq(3,n13m)=iseg (2)*(nor (2)*32+nop (2))
         inq(4,n13m)=iseg (3)*(nor (3)*32+nop (3))
         inq(5,n13m)=jg*32+isp
         inq(6,n13m)=jgc*1000+ith
         inq(7,n13m)=(ifass*10*8+icont)
         jgm = 10000
         i00=n13l-1
         if (i00.lt.1) i00=1
         do 1650 ij=i00,numbQuart
            jjga=inq(6,ij)/1000
            if (jjga.le.jgm) then
               jgm = jjga
               n13m=ij
            endif
 1650    continue
         n13l=min0(n13l,n13m)
      endif
 2000 continue
 1000 continue
 4000 continue
      call scrper('Sort quartets  ',0,0)
      call sortc(numbQuart,inq)
      call scrper('Perform statistics  ',0,0)
      nperc=100
      iperc0=numbQuart/nperc
      iperc=iperc0
      jperc=0
c
      do 8888 i=1,numbQuart
      if (i.eq.iperc) then
          jperc=jperc+1
          iperc=iperc+iperc0
          call scrper(' ',jperc,nperc)
      endif
      n1=inq(1,i)/32
      n2=inq(2,i)/32
      n3=inq(3,i)/32
      n4=inq(4,i)/32
      jgc=inq(6,i)/1000
Corig ith=mod(inq(6,i),1000)
      isp=mod(inq(5,i),32)
c--NEW 12/6/92 introduco statistica quartetti negativi
      ifass=iabs(inq(7,i)/80)
      b=float(ifass)*pi/180.
      a=cos(b)
      gval=-float(jgc)/100
      an=a*gval
      if (icent.eq.1) then
c-- centrosymmetric test
                        if (knw.eq.1) then
                            call sctst(gval,an,1)
                        else
                            call sctst1(gval,an)
                        endif
                      else
c-- noncentrosymmetric test
                        g2=jgc/100
                        g2=abs(g2)
                        call besse(g2,coat)
                        g2=gval
                        coat=coat*sign(1.,g2)
                        bang=ifass
                        if (ifass.gt.180) bang=360.0-bang
                        if (knw.eq.1) then
                            call nctet(g2,a,bang,1)
                        else
                            call nctet1(g2,coat,a)
                        endif
                      endif
c--endNEW 12/6/92 introduco statistica quartetti negativi
 8888 continue
      nquae=nquae+numbQuart
*     write(lo,2999)
 2999 format(' ')
!      write(lo,3001)nquae,numbQuart
! 3001 format(i8,' negative quartet(s) calculated and',i6,' stored')
      if (ifFromPhase == 0) then
          write(lo,2999)
          write(lo,2998)
          write(lo,3000) nquae,numbQuart,npsa
      endif
      risultati(6,1)=nquae
      risultati(6,2)=numbQuart
      risultati(7,1)=nqenex
      risultati(7,2)=nqen
 2998 format(/,25x,'Quartets statistic ',/)
!3000 format(i6,' negative quartets found (',i5,' stored )',/,    ! dedi 06/09/10
!    *       6x,' among ',i6,' psi-zero relationships',/)
 3000 format(i6,' quartets found (',i5,' stored )',
     *       ' among ',i6,' psi-zero relationships',/)
      return
      end
c-----------------------------------------------------------------------
!     CENTROSIMMETRICHE
c-----------------------------------------------------------------------
      subroutine clrt
!--prepare the test buffer (centro)
      common/tst/ntt,ar(28),nn(11,28,3),ppv(11,28,3)
      ar( 1)=.0
      ar( 2)=.2
      ar( 3)=.3
      ar( 4)=.4
      ar( 5)=.5
      ar( 6)=.6
      ar( 7)=.8
      ar( 8)=1.
      ar( 9)=1.2
      ar(10)=1.4
      ar(11)=1.6
      ar(12)=2.
      ar(13)=2.4
      ar(14)=2.8
      ar(15)=3.2
      ar(16)=3.4
      ar(17)=3.8
      ar(18)=4.2
      ar(19)=4.6
      ar(20)=5.0
      ar(21)=5.5
      ar(22)=6.0
      ar(23)=6.5
      ar(24)=7.
      ar(25)=7.5
      ar(26)=8.0
      ar(27)=8.5
      ar(28)=9.0
      ntt=28
      do k=1,11
         do l=1,3
            do i=1,ntt
               nn(k,i,l)=0
               ppv(k,i,l)=0
            enddo
         enddo
      enddo
!
      return
      end
!--------------------------------------------------
      subroutine sctst(aa,cc,j)
!--test for the correct coincidence (centro)
      common/tst/ntt,ar(28),nn(11,28,3),ppv(11,28,3)
!
      if (aa < 0.0) then
          k=2
      else
          k=1
      endif
      bb=abs(aa)
      do i=1,ntt
         if (ar(i) > bb) then
             exit
         else
             nn(j,i,k)=nn(j,i,k)+1
             if (cc >= 0.0) then
                 ppv(j,i,k)=ppv(j,i,k)+1.0
             endif
         endif
      enddo
!
      return
      end
!----------------------------------------------------------------------
      subroutine stst
      USE General
      USE Symmetry
c
!--print the test (centro)
      common/tst/ntt,ar(28),nn(11,28,3),ppv(11,28,3)
      common /inp/  natom,fnat,atoms
      common/prin/ ipt,ip0,ip10,ipq
      dimension pa(11,ntt,3)
!
      if (nn(1,1,1).eq.0.and.nn(1,1,2).eq.0) then
          return
      endif
!
      write(lo,1000)
 1000 format(/,' number of relations(nr),number of correct rel.',
     2'(nc) and percentage(%)',/,' of correct relationship ')
      write(lo,1001)
 1001 format(/)
      write(lo,1010)
 1010 format(16x,'rel. posit.',15x,'rel. negat.')
      write(lo,1015)
 1015 format(2x,' arg.',2(8x,'nr.',3x,'nc.',5x,'%',3x),/)
      do 1030 l=1,2
         do 1020 i=1,ntt
            if (nn(1,i,l).gt.0) then
                fn=float(nn(1,i,l))
                pa(1,i,l)=ppv(1,i,l)*100.0/fn
            else
                pa(1,i,l)=0.0
            endif
 1020    continue
 1030 continue
      do 1050 i=1,ntt
      if (nn(1,i,1).eq.0.and.nn(1,i,2).eq.0) go to 1050
      write(lo,1040)ar(i),(nn(1,i,l),ppv(1,i,l),pa(1,i,l),l=1,2)
 1040 format(1x,f5.1,2(5x,i7,2f7.1))
 1050 continue
      return
      end
!------------------------------------------------------
      subroutine clrt1
c--prepare the test buffer (centro) - stampa orizzon. per str. incognita

      common/tst1/nt,ar(20),nn(20),ppp(20)
      ar( 1)=.0
      ar( 2)=.2
      ar( 3)=.3
      ar( 4)=.4
      ar( 5)=.5
      ar( 6)=.6
      ar( 7)=.8
      ar( 8)=1.0
      ar( 9)=1.2
      ar(10)=1.6
      ar(11)=2.0
      ar(12)=2.5
      ar(13)=3.0
      ar(14)=3.5
      ar(15)=4.0
      ar(16)=5.0
      ar(17)=6.0
      ar(18)=7.0
      ar(19)=9.0
      ar(20)=10.0
      nt=20
      do 200 i=1,nt
      nn(i)=0
      ppp(i)=0.0
 200  continue
      return
      end
c----------------------------------------------------------
      subroutine sctst1(aa,cc)
c--test for the correct coincidence (centro)
c
      USE General
      common/tst1/nt,ar(20),nn(20),ppp(20)
      bb=abs(aa)
      do i=1,nt
         if (ar(i).le.bb) then
             nn(i)=nn(i)+1
             if (knw.eq.1) then
                 if (cc >= 0.0) then
                     ppp(i)=ppp(i)+1.0
                 endif
             endif
         endif
      enddo
!
      return
      end
c-----------------------------------------------------
      subroutine stst1
c--print the test (centro)
c
      USE General
      common/tst1/nt,ar(20),nn(20),ppp(20)
c
c
      dimension pa(20)
!
      pa(:) = 0.0
!
      write(lo,520)
      if (knw.eq.1)  write(lo,530)
      write(lo,540)(ar(i),i=1,10),(nn(i),i=1,10)
      if (knw.eq.1) then
          do i=1,10
             if (nn(i) > 0) then
                 fn=float(nn(i))
                 pa(i)=ppp(i)*100.0/fn
             endif
          enddo
          write(lo,550)(pa(i),i=1,10)
      else
          write(lo,*)' '
      endif
      write(lo,540)(ar(i),i=11,nt),(nn(i),i=11,nt)
      if (knw.eq.1) then
          do i=11,nt
          if (nn(i) > 0) then
              fn=float(nn(i))
              pa(i)=ppp(i)*100.0/fn
          endif
          enddo
          write(lo,550)(pa(i),i=11,nt)
      else
          write(lo,*)' '
      endif
  520 format(/,20x,"distribution of g - number of |g|'s .gt. limit")
  530 format(20x,'and percentage(%) of correct relationship')
  540 format(/,3x,'g  ',10f7.1,/,' ',1x,'no. ',10i7)
  550 format(' ',2x,'%  ',10f7.1)
      return
      end
c--------------------------------------------------------
!     NON CENTROSIMMETRICHE
c--------------------------------------------------------
      subroutine nclrt
!--prepare the test buffer (non-centro)
!
      common /nctst/ ns,br(22),nbv(11,22,3),fnb(11,22,3),bcm(11,22,3),
     *                        acm(11,22,3)
      br( 1)=.0
      br( 2)=.1
      br( 3)=.15
      br( 4)=.2
      br( 5)=.25
      br( 6)=.3
      br( 7)=.4
      br( 8)=.5
      br( 9)=.6
      br(10)=.8
      br(11)=1.2
      br(12)=1.6
      br(13)=2.0
      br(14)=2.6
      br(15)=3.2
      br(16)=3.8
      br(17)=4.4
      br(18)=5.5
      br(19)=6.5
      br(20)=9.0
      br(21)=15.
      br(22)=20.
      ns=22
      do k=1,11
         do j=1,3
            do i=1,ns
               nbv(k,i,j)=0
               fnb(k,i,j)=0.0
               bcm(k,i,j)=0.0
               acm(k,i,j)=0.0
            enddo
         enddo
      enddo
!
      return
      end
!--------------------------------------------------------
      subroutine nctet(aa,cc,ang,j)
      USE General
!--test for the correct coincidence (non-centro)
!
      common /nctst/ ns,br(22),nbv(11,22,3),fnb(11,22,3),bcm(11,22,3),
     *                        acm(11,22,3)
!
      if (aa < 0.0) then
          kk = 2
      else
          kk = 1
      endif
      bb = abs(aa)
      do i=1,ns
         ii=i
         if (br(i) > bb) exit
         nbv(j,ii,kk)= nbv(j,ii,kk)+1
         bcm(j,ii,kk)=bcm(j,ii,kk)+ang
         a=aa*cc
         if (a >= 0.0) then
             fnb(j,ii,kk)=fnb(j,ii,kk)+1.0
         endif
      enddo
!
      return
      end
!--------------------------------------------------------
      subroutine nstst
      USE General
      USE Symmetry
c
!--print the test (non-centro)
!
      common /inp/  natom,fnat,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common /nctst/ ns,br(22),nbv(11,22,3),fnb(11,22,3),bcm(11,22,3),
     *                        acm(11,22,3)
!
      if (nbv(1,1,1).eq.0.and.nbv(1,1,2).eq.0) then
          return
      endif
!
      write(lo,1000)
1000  format(' number of relationships(nr), percentages(%) of correct si
     *gns',/,' average errors in relationships')
      write(lo,1001)
 1001 format(/)
      write(lo,1010)
 1010 format(20x, 'positive rel.',25x,'negative rel.')
      write(lo,1020)
 1020 format(4x,'g ',1x,2(8x,'nr.    %     <|phi|>         '),/)
      do j=1,3
         do i=1,ns
            if (nbv(1,i,j) > 0) then
                fn=1.0/float(nbv(1,i,j))
                fnb(1,i,j)=fnb(1,i,j)*fn*100.0
                bcm(1,i,j)=bcm(1,i,j)*fn
            endif
         enddo
      enddo
      do i=1,ns
         if (nbv(1,i,1).eq.0.and.nbv(1,i,2).eq.0) cycle
         write(lo,1120) br(i),(nbv(1,i,j),fnb(1,i,j),bcm(1,i,j),j=1,2)
      enddo
 1120 format(1x,f5.2,3(5x,i7,f7.1,f9.3,9x))
      return
      end
c--------------------------------------------------------
      subroutine nclrt1
c--prepare the test buffer (non-centro) - stampa orizzon. per str. incognita
c
      common /nctst1/ ns,br(20),nbz(20),fnb(20)
c
      br( 1)=.0
      br( 2)=.2
      br( 3)=.3
      br( 4)=.4
      br( 5)=.5
      br( 6)=.6
      br( 7)=.8 
      br( 8)=1.0
      br( 9)=1.2
      br(10)=1.4
      br(11)=1.6
      br(12)=2.0
      br(13)=2.5
      br(14)=3.0
      br(15)=3.5
      br(16)=4.0
      br(17)=6.0
      br(18)=8.0
      br(19)=10.
      br(20)=15.0
      ns=20
      do 1150 i=1,ns
      nbz(i)=0
      fnb(i)=0.0
1150  continue
      return
      end
c------------------------------------------------------
      subroutine nctet1(aa,co,cc)
c--test for the correct coincidence (non-centro)
c
      USE General
      common /nctst1/ ns,br(20),nbz(20),fnb(20)
c
      bb=abs(aa)
      do i=1,ns
         if (br(i).le.bb)  then
             nbz(i)=nbz(i)+1
             if (knw.eq.1) then
                 a=cc*co
                 if (a >= 0.0) then
                     fnb(i)=fnb(i)+1.0
                 endif
             endif
         endif
      enddo
      return
      end
c--------------------------------------------------
      subroutine nstst1
c--print the test (non-centro)
c
      USE General
      common /nctst1/ ns,br(20),nbz(20),fnb(20)
c
      write(lo,520)
      if (knw.eq.1)  write(lo,530)
      write(lo,540)(br(i),i=1,10),(nbz(i),i=1,10)
      if (knw.eq.1) then
          do i=1,10
             if (nbz(i) > 0) then
                 fn=float(nbz(i))
                 fnb(i)=fnb(i)*100.0/fn
             endif
          enddo
          write(lo,550)(fnb(i),i=1,10)
       else
          write(lo,*)' '
      endif
      write(lo,540)(br(i),i=11,ns),(nbz(i),i=11,ns)
      if (knw.eq.1) then
          do i=11,ns
             if (nbz(i) > 0) then
                 fn=float(nbz(i))
                 fnb(i)=fnb(i)*100.0/fn
             endif
          enddo
          write(lo,550)(fnb(i),i=11,ns)
       else
          write(lo,*)' '
      endif
  520 format(/,20x,"distribution of g - number of |g|'s .gt. limit")
  530 format(20x,'and percentage(%) of correct relationship')
  540 format(/,3x,'g  ',10f7.1,/,'  ','no. ',10i7)
  550 format(' ',2x,'%  ',10f7.1)
      return
      end
!---------------------------------------------------------------------
      subroutine NewMaxHKL(iAction)
      USE General
      USE Symmetry
      USE Riflessi
!
      common /MaxHKL/ ihmx_old(3), ihmn_old(3)
!
!-- iAction = 1 determino gli indici massimi per i riflessi dello shell interno
!-- iAction = 2 reset degli indici massimi
!
      if (numbGen == 0) return
!
      if (iAction == 1) then
          ihmx_old(:) = ihmx(:)
          ihmn_old(:) = ihmn(:)
          ihmax=0; ikmax=0; ilmax=0; ihmax1=0; ikmax1=0; ilmax1=0
          do i=1,nrefl
            ihh =iabs(khl(1,i))
            if (ihh > ihmax) ihmax = ihh
            ik = iabs(khl(2,i))
            if (ik > ikmax) ikmax = ik
            il = iabs(khl(3,i))
            if (il > ilmax) ilmax = il
          enddo
          do i=1,nsym
            ihh = ihmax * kmat(i,1,1) +
     &            ikmax * kmat(i,2,1) + ilmax * kmat(i,3,1)
            ihh = iabs(ihh)
            if (ihh > ihmax1) ihmax1 = ihh
            ik = ihmax * kmat(i,1,2) +
     &           ikmax * kmat(i,2,2) + ilmax * kmat(i,3,2)
            ik = iabs(ik)
            if (ik > ikmax1) ikmax1 = ik
            il = ihmax * kmat(i,1,3) +
     &           ikmax * kmat(i,2,3) + ilmax * kmat(i,3,3)
            il = iabs(il)
            if (il > ilmax1) ilmax1 = il
          enddo
          ihmx(1) = max(ihmax, ihmax1)
          ihmx(2) = max(ikmax, ikmax1)
          ihmx(3) = max(ilmax, ilmax1)
      else
c
c--rimetto a posto gli indici massimi iniziali
c
          ihmx(:) = ihmx_old(:)
          ihmn(:) = ihmn_old(:)
      endif
!
      return
      end
!---------------------------------------------------------------------
      subroutine PreparaIph(iAction, ifinConver)
!
!-- iAction = 1   Positive and Negative Triplets
!           = 2   Psi-zero
!           = 3   Negative Quartets
!           = 4   Pointers table preparation
!           = 5   Psi-e
      USE General
      USE Symmetry
      USE InvarStuff
      USE PhaseModule
      USE PhaseStuff
      
      USE Riflessi
!
      implicit none
!psie
!psie      common/dirpse/npse      
      
      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
     *                  NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!psie      
!psie      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
!psie     *                   NPsie,NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!psie      common /dirtr/emin,ntra,sgg,MaxPsi0      
      
      integer :: NSigPos, NSigNeg, NQuaNeg, inizNeg, NPsiZero, nq, ierr
!psie
!psie      integer :: NPsie,npse, MaxPsi0, ntra
!psie      real    :: emin, sgg
      
      integer :: iAction, i, j, ia, ifaz, ia_sog, NSN
      integer :: nor1, nor2, nor3, id, ishi, isig1, npss, npsfm
      integer :: l, if1, if2, n1, nb1, nnn1(4), jcris, ifazm, j1, npunt
      integer :: nc, isi, na1, ifinConver, lim1(4001), jpp, numbReflTrip
!psie      
!psie      integer :: nc, isi, na1, ifinConver,lim1(12001), jpp, numbReflTrip
      
      real    :: SogPos, SogNeg, SogQuaNeg, a1
      integer :: nn1,nn2,nn3,nn4, ntripelimi
!
      if (iAction == 1) then
          numbTriplets = NSigPos + NSigNeg
!psie
!psie          numbTriplets = NSigPos + NSigNeg + MaxPsi0
          
          Allocate (iet(6,1:numbTriplets), stat = ierr)
          if (ierr /= 0) then
              write(lo,*) 'iet Allocation error'
              call cstop(' ')
          endif
!
!-- Positive triplets
!
          nutri = 0
          do i=1, NSigPos
             call unpak3Sir(isig(1,i), nn(1), nn(2), ifaz)
             call unpak3Sir(isig(2,i), nn(3), ia, ifaz)
             if (icent > 0) ia = 2 * ia
             if (ia > 2047) ia = 2047
             if (ia > 0) then
                 nutri = nutri+1
                 iet(1,nutri) = nn(1)
                 iet(2,nutri) = nn(2)
                 iet(3,nutri) = nn(3)
                 iet(4,nutri) = ia
                 iet(5,nutri) = ifaz
                 iet(6,nutri) = isig(3,i)/32
             endif
          enddo
          NSigPos = nutri
!
!-- Negative triplets
!
          NSN = 0
          if (NSigNeg > 0) then
              do i=1, NSigNeg
                 j = inizNeg + i - 1
!
!-- old FOMs: NEG TRIPL
!
                 negt1(i) = isig(1,i)
                 negt2(i) = isig(2,i)
!
!-- old FOMs: NEG TRIPL
!
                 call unpak3Sir(isig(1,j), nn(1), nn(2), ifaz)
                 call unpak3Sir(isig(2,j), nn(3), ia, ifaz)
                 if (ia >= 60) then      !ia = gmin
                     ia = -ia
                     ifaz = mod(ifaz+12 ,24)
                     if (icent > 0) ia = 2 * ia
                     if (ia > 2047) ia = 2047
                     nutri = nutri+1
                     NSN = NSN + 1
                     iet(1,nutri) = nn(1)
                     iet(2,nutri) = nn(2)
                     iet(3,nutri) = nn(3)
                     iet(4,nutri) = ia
                     iet(5,nutri) = ifaz

                 endif
              enddo
              NSigNeg = NSN
          endif
          InfoOK(8) = 1
!psie      elseif (iAction == 5) then
!
!-- Psi-e triplets
!
!psie          do i=1, NPsie
!psie             call unpak3Sir(isig(1,i), nn(1), nn(2), ifaz)
!psie             call unpak3Sir(isig(2,i), nn(3), ia, ifaz)
!psie             nn(1) = nn(1) + nstr
!psie             if (icent > 0) ia = 2 * ia
!psie             if (ia > 2047) ia = 2047
!psie             if (ia > 0) then
!psie                 nutri = nutri+1
!psie                 iet(1,nutri) = nn(1)
!psie                 iet(2,nutri) = nn(2)
!psie                 iet(3,nutri) = nn(3)
!psie                 iet(4,nutri) = ia
!psie                 iet(5,nutri) = ifaz
!psie                 iet(6,nutri) = isig(3,i)/32
!psie!                 if (nn(1) == 1828) then
!psie!                     write(lo,'(4i5)')nn(1),nn(2),nn(3),ia
!psie!                 end if
!psie             endif
!psie          enddo
         
!
      elseif (iAction == 2) then
!
!-- Psi zero
!
          Allocate (imat(6,1:NPsiZero), stat = ierr)
          if (ierr /= 0) then
              write(lo,*) 'imat Allocation error'
              call cstop(' ')
          endif
          npss  = nzro + nstr
          npsfm = 0
          n1    = 0
          do i=1, NPsiZero
             imat(1:3,i) = isig(1:3,i)
             isig1 = isig(1,i)
             call unpak3Sir(isig(1,i),nor1,nor2,if1)
             nor1 = nor1 + 1
            if (nor1.le.npss) then
                 call unpak3Sir(isig(2,i),nor3,id,ishi)
                 imat(1,i) = ((nor2+4096)*8192+nor3+4096)*32+ishi+1
                 imat(2,i) = ((nor1+4096)*8192+nor2+4096)*32+ishi+1
                 if (nor1 /= n1) then
                     n1 = nor1
                     imat(1,i) = -imat(1,i)
                 endif
                 npsfm = npsfm + 1
             endif
             iph0n(i) = imat(1,i)
          enddo
      elseif (iAction == 3) then
!
!-- Negative Quartets
!
          if (NQuaNeg > 0) then
              nq = min0(1000, NQuaNeg)
              Allocate (ieq(6,1:nq), stat = ierr)
              if (ierr /= 0) then
                  write(lo,*) 'ieq Allocation error'
                  call cstop(' ')
              endif
              NQuaNeg = 0
              do i=1, nq
                 call unpak3Sir(inq(1,i), nn(1), nn(2), if1)
                 call unpak3Sir(inq(2,i), nn(3), nn(4), if2)
                 call unpak3Sir(inq(3,i), l,  ia, ifaz)
                 ia_sog = 20  ! dedi
                 if (resm >= ResSogLow .and. pts /= 1) then
                     ia_sog = 10
                 endif
                 SogQuaNeg = float(ia_sog) / 100.
                 if (ia.ge.ia_sog) then
                     if (icent > 0) ia = 2 * ia
                     if (ia > 2047) ia = 2047
                     ifaz = mod(ifaz ,24)
                     ia = ia * 0.80
                     ia = -ia
                     ifaz =mod(ifaz+12 ,24)
                     NQuaNeg = NQuaNeg + 1
                     ieq(1, NQuaNeg) = nn(1)
                     ieq(2, NQuaNeg) = nn(2)
                     ieq(3, NQuaNeg) = nn(3)
                     ieq(4, NQuaNeg) = nn(4)
                     ieq(5, NQuaNeg) = ia
                     ieq(6, NQuaNeg) = ifaz
                 endif
              enddo
          endif
      elseif (iAction == 4) then
!
!-- preparation of pointers table
!
          nq = min0(1000, NQuaNeg)
          LenIPH = numbTriplets*12 + nq*20
          call AllocaPhaseStuff(1)
          numbTriplets = NSigPos + NSigNeg
!psie
!psie          numbTriplets = NSigPos + NSigNeg + NPsie
          
          nb1 = nstr + 1
          limref(:,:) = 0
          ntripelimi = 0
          ntripelimP = 0
          ntripelimN = 0
          do i = 1,numbTriplets
             nn(1) = iet(1,i)
             nn(2) = iet(2,i)
             nn(3) = iet(3,i)
             nn1=iabs(nn(1))
             nn2=iabs(nn(2))
             nn3=iabs(nn(3))
!!!!!!!!!!!!!!!!KRIS  ----  ciclo se uno dei riflessi e' quello che voglio scartare
             if (icodeli(nn1).eq.1.or.icodeli(nn2).eq.1
     *                                .or.icodeli(nn3).eq.1) then
                ntripelimi = ntripelimi + 1
                if (i <= NSigPos) then
                    ntripelimP = ntripelimP + 1
                else
                    ntripelimN = ntripelimN + 1
                endif
                cycle
             endif
!!!!!!!!!!!!!!!KRIS
             do l = 1,3
                n1 =iabs(nn(l)) + 1
                limref(1,n1) = limref(1,n1) + 1
             enddo
          enddo
          if (ncountConver == 2) then
              if (knw /= 0) then
                  write(6,*) 
!                 write(6,*) ' Num. tripl.      eliminati',ntripelimi,
!    *                                          ' su ',numbTriplets
                  write(6,*) ' Num. tripl. Pos. eliminati',ntripelimP,
     *                                          ' su ',nSigPos
                  write(6,*) ' Num. tripl. Neg. eliminati',ntripelimN,
     *                                          ' su ',nSigNeg
              endif
              NSigPos = NSigPos - ntripelimP
              NSigNeg = NSigNeg - ntripelimN
          endif
!
          nquadelimi = 0
          do i=1, NQuaNeg
             nn(1) = ieq(1,i)
             nn(2) = ieq(2,i)
             nn(3) = ieq(3,i)
             nn(4) = ieq(4,i)
             nn1=iabs(nn(1))
             nn2=iabs(nn(2))
             nn3=iabs(nn(3))
             nn4=iabs(nn(4))
!!!!!!!!!!!!!!!!KRIS  ----  ciclo se uno dei riflessi e' quello che voglio scartare
             if (icodeli(nn1).eq.1.or.icodeli(nn2).eq.1.or.
     *             icodeli(nn3).eq.1.or.icodeli(nn4).eq.1) then
                 nquadelimi = nquadelimi + 1
                 cycle
            endif
!!!!!!!!!!!!!!!!KRIS
             do l=1, 4
                n1 =iabs(nn(l)) + 1
                limref(2,n1) = limref(2,n1) + 1
             enddo
          enddo
          if (ncountConver == 2) then
              if (knw /= 0) then
                  write(6,*) ' Num. quart. Neg. eliminati',nquadelimi,
     *                                          ' su ',NQuaNeg
              endif
              NQuaNeg = NQuaNeg - nquadelimi
          endif
!
          do l=1, 2
             do i=1, ifinConver
                limref(l,i+1) = limref(l,i+1) + limref(l,i)
             enddo
          enddo
!psie
!psie          l=1
!psie          do i=1, ifinConver + npse
!psie                limref(l,i+1) = limref(l,i+1) + limref(l,i)
!psie          enddo
!psie          l=2
!psie          do i=1, ifinConver
!psie                limref(l,i+1) = limref(l,i+1) + limref(l,i)
!psie          enddo
!
!-- modifica iph e limref
!
          lim1(:) = 0

          do i=1, numbTriplets
             nnn1(1) = iet(1,i)
             nnn1(2) = iet(2,i)
             nnn1(3) = iet(3,i)
             a1 = 0.01 * iet(4,i)
             na1 = iet(4,i)
             nnn1(4) = 0
             ifaz = iet(5,i)
             do j=1, 3
                isi = isign(1,nnn1(j))
                nc = iabs(nnn1(j))
                lim1(nc) = lim1(nc) + 1
                npunt = limref(1,nc) + lim1(nc) -1
                j1 = 1
                do jcris = 1,3
                   if (jcris.ne.j) then
                       nn(j1) = nnn1(jcris)*(-isi)
                       j1 = j1+1
                   endif
                enddo
                ifazm = ifaz*(-isi)
                if (ifazm.lt.0) ifazm=ifazm+24
                jpp = npunt * 4 + 1
                iph(jpp) = nn(1)
                iph(jpp+1) = nn(2)
                iph(jpp+2) = na1
                iph(jpp+3) = ifazm
             enddo
          enddo
!
          lim1(:) = 0
          jpq = (numbTriplets*4) * 3
          do i=1, nq
             nnn1(1) = ieq(1,i)
             nnn1(2) = ieq(2,i)
             nnn1(3) = ieq(3,i)
             nnn1(4) = ieq(4,i)
             a1 = 0.01 * ieq(5,i)
             na1 = ieq(5,i)
             ifaz = ieq(6,i)
             do j=1, 4
                isi = isign(1,nnn1(j))
                nc = iabs(nnn1(j))
                lim1(nc) = lim1(nc) + 1
                npunt = limref(2,nc) + lim1(nc) -1
                j1 = 1
                do jcris = 1,4
                   if(jcris.ne.j) then
                      nn(j1) = nnn1(jcris)*(-isi)
                      j1 = j1+1
                   end if
                enddo
                ifazm = ifaz*(-isi)
                if(ifazm.lt.0) ifazm=ifazm+24
                jpp = jpq + npunt * 5 + 1
                iph(jpp) = nn(1)
                iph(jpp+1) = nn(2)
                iph(jpp+2) = nn(3)
                iph(jpp+3) = na1
                iph(jpp+4) = ifazm
             enddo
          enddo
!
          if (ncountConver == ifSelAlfa + 1) then
             deallocate(iet, ieq, stat = ierr)
          endif
      endif
!
      return
      end
!---------------------------------------------------------------------
