#define TBLABELCOLOR  "#0000A0"
//#define FRAMECOLOR    "#0000FF"
#define FRAMECOLOR    NULL
//#define LABELCOLOR    "#0000FF"
#define MSGCOLOR      "#008050"

/* Define if you have the ANSI C header files. */
#define STDC_HEADERS 1

#define MAX_LIV 3
#define REC_LEN 120
#define LAB_LEN 16
#define SYMLEN 8
#define NUMSPECIES 18

/* standard include */

#ifdef __cplusplus
#include <cstdlib>
#include <cstdio>
#include <string>
#include <cstring>
#include <cerrno>
#include <cctype>
#include <cmath>
#else
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <ctype.h>
#include <math.h>
#endif
#include <sys/types.h>
#include <sys/stat.h>
#ifdef _WIN32
#include <direct.h>
#include <io.h>
#else
#include <unistd.h>
#endif

#include <utils.h>
/*****************************************************************/
/*      parte specifica per programma                            */
/*****************************************************************/
#include "sir.h"
#include <gtkdefs.h>
#include "forcomm1.h"
#include <forcomm2.h>

#define SIR_PGM 1
#define initial_pixmap  MR_PREF"ini.png"
#define program_ico     "mr-"MR_PREF1
//#define program_ico     MR_PREF".ico"
//#define about_pixmap    MR_PREF"about.gif"
#define splash_xpm      MR_PREF1"splash.png"

#define msgdefault      " Welcome to "MR_PACKAGE" V."MR_VERSION
#ifdef GUI_ENV

typedef struct _TreeItem TreeItem;
struct _TreeItem
{
  const gchar    *label;
  TreeItem       *children;
};


gboolean key_pressed_sir (GtkWidget *widget, GdkEventKey *event, gpointer data);
gboolean button_press    (GtkWidget *widget, GdkEventButton *ev, gpointer data);
gboolean button_release  (GtkWidget *widget, GdkEventButton *ev, gpointer data);
gboolean button_scroll   (GtkWidget *widget, GdkEventScroll *ev, gpointer data);
gboolean button_move     (GtkWidget *widget, GdkEventMotion *ev, gpointer data);
gboolean close_mainwin   (GtkWidget *widget, GdkEventAny *event, gpointer data);
void load_recent_project (gpointer   widget, gchar *data);
void init_toggles        (GtkWidget *widget, gpointer data);

#define cb_for_set_tog        G_CALLBACK(init_toggles)
#define cb_for_key_press      G_CALLBACK(key_pressed_sir)
#define cb_for_mouse_scroll   G_CALLBACK(button_scroll)
#define cb_for_mouse_press    G_CALLBACK(button_press)
#define cb_for_mouse_release  G_CALLBACK(button_release)
#define cb_for_mouse_move     G_CALLBACK(button_move)
#define cb_for_delete         G_CALLBACK(close_mainwin)
#define cb_for_recproj        G_CALLBACK(load_recent_project)
#endif

/*****************************************************************/
/*      fine parte specifica per programma                       */
/*****************************************************************/
#ifdef GUI_ENV

/* ---------------------------------------------------------------- */
/*       User-defined types                                         */
/* ---------------------------------------------------------------- */

typedef struct {
                char          *title;
                char          *text;
                char          *image;
                char          *image1;
                char          *image2;
                char          *image3;
                char          *label1;
                char          *label2;
                char          *label3;
                int           format;
                int           nButtons;
                int           focus;
                int           width;
                int           height;
                GCallback cb_func1;
                GCallback cb_func2;
                GCallback cb_func3;
                gpointer      cb_data2;
                gpointer      cb_data1;
                gpointer      cb_data3;
                int           nlines;
               } DlgItem;

typedef struct {
                 int nplanes;
                 int nlines;
                 int nbaric;
                 int ngroups;
                 int nsingle;
                 stringa120 Planes[100];
                 stringa120 Lines[100];
                 stringa120 Baric[100];
                 stringa120 Groups[100];
                 stringa120 Single[100];
                } InfoGeo;

/*
typedef struct _PixText PixText;
struct _PixText
{
  GdkPixbuf *icon;
  gchar *text;
};
*/
typedef struct 
{
  gchar *colore;
  int   colonna;
} ColorText;


/* ---------------------------------------------------------------- */
/*                         utility functions                        */
/* ---------------------------------------------------------------- */
GtkWidget  *create_selection          (GtkWidget *parent, GtkWidget *parentbox,
                                       const char *title, const char *id);
GtkWidget  *mostra_lista              (const char *wtitle, const char *title, char *vec[], 
                                       int n_el, int selmode,GCallback cb2);
void       mostra_tbg1lsq             (GtkWidget *mwin, int sel_mode, int flag);
GtkWidget  *do_tree_store              (GtkWidget *window, TreeItem tops[], GCallback cb, 
                                       GtkWidget *cb_data);
void       close_dlg                  (GtkButton       *button,
                                       gpointer         user_data);
void       finestra_modale_aperta2    (GtkWidget *win);
void       finestra_modale_chiusa2    (void);
gchar      *color_markup              (const char *string, const gchar *color); 
void       mr_restore_pixmap          (void);
void       mr_send_viewer_pixmap      (GtkWidget *win);
void       mr_send_pixmap             (GtkWidget *win);
void       set_smiley                 (int come);
void       fortran_al_lavoro          (void);
void       fine_lavoro                (void);
void       elaborazione_in_corso      (void);
void       fine_elaborazione          (void);
void       palla_sfumata_java         (int x, int y, int raggio, int iFC, int plux,
                                       gpointer co, gpointer d, GdkColor Colori[], int fromSettings = 0);
void       clear_status_bar           (void);
int        cStartMainLoop             (int flag);
void       nascondi_tb                (GtkWidget *mwin);
void       abilitamb                  (GtkWidget *mwin, int stato);
void       abilitatb                  (GtkWidget *mwin, int stato);
void       call_fortran               (char *inpFile, char *outFile,
                                       const char *tipo);
void       call_fortran_bis           (char *inpFile, char *dir,
                                       int tipo);
GtkWidget* create_dialog              (GtkWidget *winmain, DlgItem *dlg_it);
int        save_restore_pm            (int tipo);
int        preview_or_file            (int espo);
gboolean   hide_dlg                   (gpointer data);
GtkWidget  *scrolled_text_new         (GtkWidget *container);
GtkWidget  *label_boxed_big           (const gchar     *string);
GtkWidget  *label_boxed_medium        (const gchar     *string);
GtkWidget  *LABEL_WITH_ENTRY          (const gchar *string, const gchar *col);
GtkWidget  *ENTRY_NEW                 ();
void       set_font                   (char c);
GtkWidget  *create_combo_colors       (GtkWidget *parentbox, int d_selected);
void       label_boxed_set_text       (GtkWidget *frame, const gchar *string);
void       on_cb_show                 (GtkToggleButton *button, GtkWidget *wid);
void       on_cb_hide                 (GtkToggleButton *button, GtkWidget *wid);
void       check_numeric              (GtkEditable *editable,
                                       const gchar *text, gint length,
                                       gint *position, gpointer data);
void       set_cell_color             (GtkWidget *list, int nrow, int ncol, const char *colore);
GtkWidget *entry_for_fileselection    (const char *label_string, const char *pix, GCallback cb,
                                       gpointer data, int ifPreview, int ifBrowse,
                                       const char *colore, const char mod = 'v');
int        load_file_into_window      (char *filnam, GtkWidget *text, 
                                       char *fore, char *back, int nlines);
gboolean   on_viewer_configure_event  (GtkWidget       *widget,
                                       GdkEventConfigure *event,
                                       gpointer         user_data);
void       stop_continue_rot          (void);
void       stringatovector            (char *str, char *strvec[], 
                                       int nElem, int lung);
void       skip_or_stop               (GtkWidget *widget,  gpointer data);
void       call_javs                  (GtkWidget *widget,  gpointer data);
void       nuovoviewer                (GtkWidget *item, gpointer data);
void       c_globalopt                (GtkWidget *item, gpointer data);

GtkWidget *createSelectionM           (GtkWidget *parent, GtkWidget *parentbox,
                                       const char *title[], const char *id, int ncol, const char *col);
void add_line_to_listM(GtkWidget *list, char *line[]);
void open_htm                         (const char *urlname, const char *subdir="");
void elaborazione_in_corso();
void fine_elaborazione();
#endif
