#include "mrconfig.h"
#include <gtkmrcomune.h>
#include "aliasx.h"
#include <sstream>

namespace main_app {
       extern Application TheApp;
                   }

enum {XYZ, B=3, OCC=10, ISO};
static const char *parametri[] = {"Fix\nXYZ","Fix\n B", "Fix\nOcc.", "   Set\nIsotropic"};
static const char *parametrit[] = {"Unfix\n XYZ","Unfix\n  B", "Unfix\n Occ.", "   Set\nAnisotropic"};
static const int   parval[] = {XYZ, B, OCC, ISO};

enum pages {PAGE_GENERAL, PAGE_PARAMETERS, PAGE_RIGIDBODY};
static const char *pagenams[] = {"page0", "page1", "page2"};
static const char *vpagenams[] = {"vpage0", "vpage1", "vpage2"};

#define NUMPAR  (int)(sizeof(parametri)/sizeof(parametri[0]))

#define MAXGROUPS 100
extern int  *iSite;
extern GdkColor *LIGHTRED, *LIGHTBLUE;
extern GtkWidget *finestre[6];
extern gboolean show_toolbar;
extern gboolean ifMenubar, ifToolbar;
extern int      *nzTot;
extern stringa  *It;
//extern gboolean ifMoveCube;

extern _Dialogo *dialogo;
extern "C" _LSQinfo *clsqgtk;
extern "C" float getmaxdim_();
extern "C" void fcube_(int *dx, int *dy);
extern "C" int get_cell_content_(int vet1[], int vet2[]);

typedef struct {
                 int   nlegati;
                 int   ibcal;
                 int   nHybcal;
                 int   nHydcal;
                 int   nHybut;
                 int   nHydut;
                 char  lab[17];
                } infohydro_type;
infohydro_type *Info;

static GtkWidget *lsq_dialog = NULL;
static GtkWidget *fourier_dialog = NULL;
static GtkWidget *hydro_dlg = NULL;
static GtkWidget *mainwin;
static int to_refine[MAXGROUPS];
static int vspace = 4;
static int curPag = 0;
#if 0
static char **AtomiC;                //[MaxAtLSQ];
static int *selezione;              //[MaxAtLSQ];
static _LSQinfo *lsqgtk;
static int *vformark;              //[MaxAtLSQ];
#endif
namespace LSQ {
char **AtomiC;                //[MaxAtLSQ];
int *selezione;              //[MaxAtLSQ];
_LSQinfo *lsqgtk;
int *vformark;              //[MaxAtLSQ];
}

static int rsoglia = 1000; // soglia per rapporto Oss/Par x 1000

typedef struct {
                 char str1[20];
                 char str2[800];
                 int  n1, n2;
               } multistringa2;

//void set_drag_cursor();
void pagelsq0(GtkWidget *notebook, GtkWidget *lsq_dlg);
void pagelsq1(GtkWidget *notebook, GtkWidget *lsq_dlg, int ele[]);
void pagelsq2(GtkWidget *notebook, GtkWidget *lsq_dlg);

GList *getInfo(const char *filename, int details, int drawsize);
void populate_list_adhoc(GtkTreeView *list, GList *values[], int numlists);
extern "C" void init_agreement_(float intervals[10][2], int *ier);
extern "C" int  noforc_        (int *natom);
extern "C" int  newinfo_hydro_ (infohydro_type *info);
extern "C" int  finish_hydro_  (int *atom, int *nhyb, int *nhyd, int *wizard,
                                float *distch);
extern "C" int   init_hydro_   (int *wizard, int *atom, multistringa2 *ms,
                                int *nhyb, float *distch);
extern "C" void checkghostsforc_(int *ier);


int  getparameters (int lkfix[]);

GtkWidget* create_lsq (int ele[]);

static int statofinale[10];
static int natsC;
static const char *pesi[] = {"#  1 : W=Fo/P(1) if Fo >= P(1); W=1/W otherwise",
                       "#  2 : W=1/(P(1)+P(2)*Fo+P(3)*Fo^2)",
                       "#  3 : W=(Sin(Theta)/Lambda)^P(1)",
                       "#  4 : W=(Lambda/Sin(Theta))^P(1)",
                       "#  5 : W=1/(Sigma(Fo))^2",
                       "#  6 : W=1.0",
                       "#  7 : W=1/(1.+((Fo-P(2))/P(1))^2",
                       "#  8 : W=1.0 if Fo<=P(1); W=P(1)/Fo if Fo>P(1)",
                       "#  9 : W=Sigma(Fo)",
                       "# 10 : W=1.0/Sigma(Fo)",
                       "# 11 : W=(Sin(theta)/Lambda)^P(1)/(P(2)+P(3)*Fo+P(4)*Fo^2)",
                       "# 12 : W=1/(Sigma(Fo))^2+P(1)*Fo+P(2)*Fo^2)",
                       "# 13 : W=Sc/(P(1)+P(2)*Fo+P(3)*Fo^2+P(4)*(Sin(Th)/L))",
                       "# 14 : W=Sc/(P(1)+P(2)*Fo+P(3)*Fo^2)",
                       "# 15 : W=Sc/(P(1)+P(2)*(Sin(Th)/L)+P(3)*(Sin(Th)/L)^2)",
                       "# 16 : W=Sc/(SUM(aj*Tj(F))j=1,n",
                       "# 17 : W=Sc*(Sin(Th)/L)^P(3)/(P(1)*Sigma(Fo))^2+P(2)*Fo^2)",
                       "# 18 : W=Sc/((P(1)+P(2)*Fo+P(3)*Fo^2+P(4)*(Sin(Th)/L)^P(5))*(Sigma(Fo))^2)"};

static int peso = 5, pesoc = 6;


/*****************************************************************/
/*              L. S. Q.                                         */
/*****************************************************************/

void c_markatomsv2 (int iaction, int nblock, int isoanisow[])
{
       markatomsv2_(&iaction, &nblock, isoanisow);
}

int updateclistavec (GtkWidget *gtklist, char *list[], int n_el, int seli[], 
                     int bitn)
{
/* inserisce in una lista gli elementi di un vettore che verificano certe
   condizioni */

    int n, i, param;
    char *riga;

    param = 1 << bitn;
    clear_list(gtklist);
    n = 0;

    for(i=0; i<n_el; i++)
    {
        if(seli[i] & param)
        {
           n++;
           riga = DuplicaStringa(list[i]);
           add_line_to_list(gtklist, (gpointer) riga);
        }
    }

    return  n;
}    

void ContaParametriC(void)
{
using namespace LSQ;
   int nParameters, kRatio, i, j;
   float Obs, ObsT, Observ, ratio;
   GtkWidget *label;
   char osservazioni[80];

   if (lsqgtk->LSQinit[0] == 1)
	  nParameters = 2;	     // diag
   else
	  nParameters = 1;	     // full and block
//
//-- Fix conditions
//
      for(j=0; j < natsC; j++)
      {
         if (lsqgtk->IsoAnisoGTK[j] == 1)
         {
             for(i=0; i<10; i++)
             {
                 if(i != 3)
                    if (lsqgtk->kFixGTK[j][i] == 0)          //061010
                       nParameters++;
             }
         }
         else
         {
             for(i=0; i<4; i++)
             {
                 if (lsqgtk->kFixGTK[j][i] == 0)          //061010
                     nParameters++;
             }
         }
         if (lsqgtk->kFixGTK[j][10] == 0)          //061010
             nParameters++;
      }

      Obs  = (float) lsqgtk->nObsGTK[lsqgtk->LSQinit[3]];
      ObsT = (float) lsqgtk->nObsGTK[0];
      Observ = 100.0f * Obs / ObsT;
      ratio = Obs / (float)nParameters;
      kRatio = (int)( ratio * 1000.0f );
      lsqgtk->LSQinit[5] = (int)Obs;    //   numb. of observations
      lsqgtk->LSQinit[6] = (int)Observ; //   perc. of observations
      lsqgtk->LSQinit[7] = nParameters; //   numb. of parameters
      lsqgtk->LSQinit[8] = kRatio;      //   ratio Obs / Param.
/* costruisco la stringa */
      ScriviStringa(osservazioni, sizeof(osservazioni), 
             "Observations: %d ( %d %% ) Parameters: %d  Ratio: %.2f",
              (int)Obs, (int)Observ, nParameters, ratio);
/* recupero il widget */
      label = get_widget(lsq_dialog, "osservazioni");
/* aggiorno il testo */
      gtk_label_set_text(GTK_LABEL(label), osservazioni);

}

void c_finishlsq (_LSQinfo *lsqi, int iCode)
{
     GtkWidget *tb, *mainwin;

     mainwin = finestre[0];
     if(show_toolbar)
        tb = lookup_widget(mainwin, "toolbar_main");
     fortran_al_lavoro();
     if(ifMenubar)
        abilitamb(mainwin, 0);
     if(ifToolbar)
        abilitatb(tb, 0);
     clsqgtk = lsqi;
     finishlsq_(&iCode, to_refine);
     fine_lavoro();
     if(ifMenubar)
        abilitamb(mainwin, 2);
     if(ifToolbar)
        abilitatb(tb, 2);
}

void ok_lsq  (GtkButton *button, gpointer user_data)
{
using namespace LSQ;
    int i, tasto;

    tasto = GPOINTER_TO_INT(user_data);

    if(tasto != -1)
    {
       for(i=0; i<natsC; i++)
       {
           int ierr = 0;
           if(lsqgtk->IsoAnisoGTK[i] == 2)       // isotropic
           {
              if((lsqgtk->kFixGTK[i][3] + lsqgtk->kFixGTK[i][10]) == 0)
                 ierr = 1;
           }
           else                                  // anisotropic
           {
               int somma = 0;
               for(int k=B+1; k<=OCC; k++)
                   somma += lsqgtk->kFixGTK[i][k];
               if(somma == 0)
                  ierr = 1;
           }
           if(ierr)
           {
               (void) MessageDialog(gtk_widget_get_toplevel(GTK_WIDGET(button)),
               GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "You cannot refine at the same time Thermal and Occupancy factor. It happens at least for atom %s ", AtomiC[i]);
               return;
           }
       }
    }

    if((lsqgtk->LSQinit[8] >= rsoglia) || (tasto == -1) || (lsqgtk->LSQinit[0] == 3))  //ratio Obs / Param.
    {
       if(gtk_widget_get_sensitive(get_widget(gtk_widget_get_toplevel(GTK_WIDGET(button)), pagenams[PAGE_RIGIDBODY])))
       {                    //gestione gruppi
          GtkWidget *list = get_widget(lsq_dialog, "groups");
          GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
          GtkTreeIter iter;
          gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
          while (valid)
          {
             char *line;
             gboolean ifSel;
             gtk_tree_model_get (model, &iter, 0, &ifSel, -1);
             if(ifSel)
             {
                gtk_tree_model_get (model, &iter, 1, &line, -1);        // name
                gtk_tree_model_get (model, &iter, 2, &line, -1);        // serial
             }
             valid = gtk_tree_model_iter_next (model, &iter);
          }
       }
       gtk_widget_hide (gtk_widget_get_toplevel(GTK_WIDGET(button)));
       finestra_modale_chiusa2();
       for(i=0; i<natsC; i++)
           g_free(AtomiC[i]);
       g_free(vformark);
       g_free(AtomiC);
       g_free(selezione);
       
       if(tasto == -1)
          return;
       lsqgtk->LSQinit[15] =  1 + gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(                                      
                     lookup_widget(GTK_WIDGET(button), "F(obs)**2")));                               
/* controllo valori in uscita da grafica
       g_print("X Y Z  B[iso] B11 B12 B13 B22 B23 B33 Occ. \n");
       for(i=0; i<natsC; i++)
           g_print("%d %d %d     %d     %d   %d   %d   %d   %d   %d   %d \n",
               lsqgtk->kFixGTK[i][0], lsqgtk->kFixGTK[i][1],
               lsqgtk->kFixGTK[i][2], lsqgtk->kFixGTK[i][3],
               lsqgtk->kFixGTK[i][4], lsqgtk->kFixGTK[i][5],
               lsqgtk->kFixGTK[i][6], lsqgtk->kFixGTK[i][7],
               lsqgtk->kFixGTK[i][8], lsqgtk->kFixGTK[i][9],
               lsqgtk->kFixGTK[i][10]);
*/
       c_finishlsq (lsqgtk, tasto);
    }
    else
    {
       (void) MessageDialog(gtk_widget_get_toplevel(GTK_WIDGET(button)), 
            GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
            "Too small value for Ratio=Observations/Parameters.\nDecrease cutoff or use restraints");
    }
}

void ref_request (GtkToggleButton *togglebutton, gpointer user_data)
{
using namespace LSQ;
    int val;
    GtkWidget *page1, *page2;
    GtkWidget *vpage1, *vpage2;
    GtkWidget *dlg, *gobut;

    val = GPOINTER_TO_INT(user_data);
    dlg        = gtk_widget_get_toplevel (GTK_WIDGET(togglebutton));
    page1 = get_widget(dlg, pagenams[PAGE_PARAMETERS]);
    page2 = get_widget(dlg, pagenams[PAGE_RIGIDBODY]);
    vpage1 = get_widget(dlg, vpagenams[PAGE_PARAMETERS]);
    vpage2 = get_widget(dlg, vpagenams[PAGE_RIGIDBODY]);
    gobut = get_widget(dlg, "ok_button"); 
    gtk_widget_set_sensitive(gobut, TRUE);

    if(gtk_toggle_button_get_active(togglebutton))
    {
       gtk_widget_set_sensitive(page1, TRUE);
       gtk_widget_set_sensitive(page2, FALSE);
       gtk_widget_set_sensitive(vpage1, TRUE);
       gtk_widget_set_sensitive(vpage2, FALSE);
       lsqgtk->LSQinit[0] = val+1;

       switch(val)
       {
       case 0:                                      /* Diagonal */
       case 1:                                      /* Full Matrix */
            break;
       case 2:                                      /* S.F.C. only */
            gtk_widget_set_sensitive(page1, FALSE);
            gtk_widget_set_sensitive(page2, FALSE);
            gtk_widget_set_sensitive(vpage1, FALSE);
            gtk_widget_set_sensitive(vpage2, FALSE);
            break;
       }
    }
}

void on_pesi_lsq (GtkWidget *combo, GtkWidget *wind)
{
using namespace LSQ;
   int pos, i;
   GtkWidget *button;

   pos = pesoc-1;
   if(pos != -1)
   {
      lsqgtk->LSQinit[4] = pos+1;
      if(lsqgtk->nParDefGTK[pos] > 0)
      {
          button = get_widget(wind, "ch_pp");
          gtk_widget_set_sensitive(button, TRUE);
//          button = get_widget(wind, "ref_pp");
//          gtk_widget_set_sensitive(button, TRUE);
      }
      else
      {
          button = get_widget(wind, "ch_pp");
          gtk_widget_set_sensitive(button, FALSE);
//          button = get_widget(wind, "ref_pp");
//          gtk_widget_set_sensitive(button, FALSE);
      }
      peso = pos;
      lsqgtk->LSQinit[11]  = lsqgtk->nParDefGTK[pos];
      for(i=0; i<4;i++)
          lsqgtk->WParGTK[i] = lsqgtk->WParDefGTK[i][pos];
   }
}

void ref_conditions (GtkWidget *spin, gpointer user_data)
{
using namespace LSQ;
    float damp;
    int   quale;

    quale = GPOINTER_TO_INT(user_data);

    switch(quale)
    {
    case 1:
         damp  = (float)spin_button_get_value(spin);
         lsqgtk->LSQinit[2] = (int) (damp*1000);
         break;
    case 2:
         lsqgtk->LSQinit[3] = spin_button_get_value_as_int(spin);
         break;
    case 3:
         lsqgtk->LSQinit[10] = spin_button_get_value_as_int(spin);
         break;
    }

/* aggiorna le osservazioni */

    ContaParametriC();
}
std::vector<std::string> DetLine;

gboolean group_details  (GtkWidget  *widget, GdkEventMotion *event, gpointer data)
{
    int ix, iy;
    GtkTreePath *path;
    GtkTreeViewColumn *column;
                                                                                                        
    ix   = (int) event->x;
    iy   = (int) event->y;
    if(gtk_tree_view_get_path_at_pos(GTK_TREE_VIEW(widget), ix, iy, &path, &column, NULL, NULL))
    {
       if(column == gtk_tree_view_get_column (GTK_TREE_VIEW(widget), 1))
       {
       int row = atoi(gtk_tree_path_to_string(path));
       GtkWidget *hwin = gtk_window_new(GTK_WINDOW_POPUP);
       gtk_window_set_position (GTK_WINDOW(hwin), GTK_WIN_POS_MOUSE);
       GtkWidget *label = LABEL_NEW((char *)DetLine[row].c_str(), "red");
       gtk_container_add(GTK_CONTAINER(hwin), label);
       gtk_container_set_border_width(GTK_CONTAINER(hwin), 4);
       (void) g_signal_connect_swapped (G_OBJECT(hwin), "button-press-event",
                 G_CALLBACK(gtk_widget_destroy), G_OBJECT(hwin));
       (void) g_signal_connect_swapped (G_OBJECT(hwin), "leave-notify-event",
                 G_CALLBACK(gtk_widget_destroy), G_OBJECT(hwin));
       gtk_widget_set_events(hwin, GDK_BUTTON_PRESS_MASK | GDK_LEAVE_NOTIFY_MASK );
       gtk_widget_show_all(hwin);
       }
    }
    return FALSE;
}

static int nSpecies;

void open_lsq_dlg(GtkWidget *win, _LSQinfo *lsqgtkl, 
                  stringa *atoms, int natsfort, int ifGrRef[])
{
using namespace LSQ;
     int i;
     GtkWidget *button;
     char nome[20];
     GList *gruppi = NULL, *gruppi2[2];
     int ngruppi, displacement = natsfort;
     std::string line;

     if(natsfort > MaxAtLSQ)
        return;
     for(i=0; i<2; i++)
         gruppi2[i] = NULL; 
     natsC = natsfort;
     lsqgtk = lsqgtkl;
     ngruppi = ngruppidef_(&displacement);
     if(ngruppi == -2)
        return;

     AtomiC = g_new0(char *, natsC);
     for(i=0; i<natsC; i++)
         AtomiC[i] = g_strdup(atoms[i]);
     selezione = g_new0(int, natsC);
     vformark = g_new0(int, natsC);
//141110     string_to_vector(atoms, AtomiC);
     for(i=0; i<ngruppi; i++)
         to_refine[i] = ifGrRef[i];
     for(i=ngruppi; i<MAXGROUPS; i++)
         to_refine[i] = 0;
     int ele[NUMSPECIES], n_in_cell[NUMSPECIES];
     nSpecies = get_cell_content_(ele, n_in_cell);

     mainwin = win;
     if(lsq_dialog != NULL)
        gtk_widget_destroy(lsq_dialog);
//     if(lsq_dialog == NULL)
        lsq_dialog = create_lsq(ele);
     for(i=0; i<natsC; i++)
        selezione[i] = 8/lsqgtk->IsoAnisoGTK[i];

     gtk_window_set_transient_for(GTK_WINDOW(lsq_dialog), GTK_WINDOW(finestre[0]));
     gtk_widget_show(lsq_dialog);
     finestra_modale_aperta2(lsq_dialog);

/* condizioni iniziali */

     button = get_widget(lsq_dialog, "ncycles");
     lsqgtk->LSQinit[10] = spin_button_get_value_as_int(button);

     ScriviStringa(nome, sizeof(nome), "radiobutton%d", lsqgtk->LSQinit[0]);
     button = get_widget(lsq_dialog, nome);
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (button), TRUE);

     if(lsqgtk->LSQinit[15] == 1)
        button = get_widget(lsq_dialog, "F(obs)");
     else
        button = get_widget(lsq_dialog, "F(obs)**2");
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);

     button = get_widget(lsq_dialog, "pesi");
     combo_set_val(button, lsqgtk->LSQinit[4]);
     pesoc = lsqgtk->LSQinit[4];
     peso = pesoc - 1;

     button = get_widget(lsq_dialog, "ch_pp");
     if(lsqgtk->nParDefGTK[lsqgtk->LSQinit[4]-1] > 0)
        gtk_widget_set_sensitive(button, TRUE);
     else
        gtk_widget_set_sensitive(button, FALSE);
     button = get_widget(lsq_dialog,"ref_pp");
//     if(lsqgtk->nParDefGTK[lsqgtk->LSQinit[4]-1] > 0)
        gtk_widget_set_sensitive(button, TRUE);
//     else
//        gtk_widget_set_sensitive(button, FALSE);
// Atomic Parameters  101010

     for(i=0; i<=nSpecies; i++)
     {
         char string[15];
         ScriviStringa(string,sizeof(string),"buttonspe%d",i);
         button = get_widget(lsq_dialog, string);
         int hnd = get_int(button, "hnd");
         g_signal_handler_block(G_OBJECT(button), hnd);
         gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), (i==nSpecies));
         g_signal_handler_unblock(G_OBJECT(button), hnd);
     }
     g_object_set_data(G_OBJECT(lsq_dialog), "parspec", GINT_TO_POINTER(nSpecies));

     for(i=0; i<NUMPAR; i++)
     {
         char string[15];
         ScriviStringa(string,sizeof(string),"buttonpar%d",parval[i]);
         button = get_widget(lsq_dialog, string);
         int hnd = get_int(button, "hnd");
         g_signal_handler_block(G_OBJECT(button), hnd);
         gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), FALSE);
         g_signal_handler_unblock(G_OBJECT(button), hnd);
     }
     for(i=0; i<natsC; i++)
     {
         char string[20];
         ScriviStringa(string,sizeof(string),"buttonlabel%d",i);
         button = get_widget(lsq_dialog, string);
         int hnd = get_int(button, "hnd");
         g_signal_handler_block(G_OBJECT(button), hnd);
         gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), FALSE);
         g_signal_handler_unblock(G_OBJECT(button), hnd);
         for(int j=0; j<NUMPAR; j++)
         {
             ScriviStringa(string,sizeof(string),"checkstru%d-%d",i,parval[j]);
             button = get_widget(lsq_dialog, string);
             if ((iSite[i] != 0) && (parval[j] == OCC))
                 gtk_widget_set_sensitive(button, FALSE);
             else
             {
                 gtk_widget_set_sensitive(button, TRUE);
                 hnd = get_int(button, "hnd");
                 g_signal_handler_block(G_OBJECT(button), hnd);
                 if(parval[j] == B)
                 {
                    if(lsqgtk->IsoAnisoGTK[i]==2)      // isotropic
                       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), 
                           lsqgtk->kFixGTK[i][B]);
                    else                              // anisotropic
                       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), 
                           lsqgtk->kFixGTK[i][B+1]);
                 }
                 else if(j < (NUMPAR-1))
                    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), 
                       lsqgtk->kFixGTK[i][parval[j]]);
                 else 
                    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), 
                       (lsqgtk->IsoAnisoGTK[i]==2));
                 g_signal_handler_unblock(G_OBJECT(button), hnd);
             }
         }
     }
     ContaParametriC();

// Groups

    if(ngruppi > 0)
    {
       int k = displacement;
       DetLine.clear();
       for(i=1; i<=ngruppi; i++)
       {
           gruppi2[0] = g_list_append(gruppi2[0], get_nth_field(It[k], " ", 1, 's'));
           gruppi2[1] = g_list_append(gruppi2[1], get_nth_field(It[k], " ", 2, 's'));
           line.clear();
           while(strstr(It[k], "&") != 0)
           {
                line.append(filtra(It[k], "&"));
                k++;
           }
           line.append(It[k]);
           DetLine.push_back(line);
           k++;
       }
       gruppi = getInfo(main_app::TheApp.GroupsFile().c_str(), 0, 200);
       button = get_widget(lsq_dialog, "groups");
       populate_list_adhoc(GTK_TREE_VIEW(button), gruppi2, 2);
       int hnd = get_int(button, "hnd");
       if(hnd)
           g_signal_handler_disconnect(G_OBJECT(button), hnd);
       hnd = g_signal_connect(G_OBJECT(button), "motion_notify_event", G_CALLBACK(group_details), NULL);
       g_object_set_data(G_OBJECT(button), "hnd", GINT_TO_POINTER(hnd));
       gtk_entry_set_text(GTK_ENTRY(get_widget(lsq_dialog, "title")), (char *) g_list_nth_data(gruppi, 0));
       g_list_free(gruppi);
       g_list_free(gruppi2[0]);
       g_list_free(gruppi2[1]);
       gtk_widget_set_sensitive(get_widget(lsq_dialog, pagenams[PAGE_RIGIDBODY]), TRUE);
       gtk_widget_set_sensitive(get_widget(lsq_dialog, vpagenams[PAGE_RIGIDBODY]), TRUE);
    }
    else
    {
       button = get_widget(lsq_dialog, "groups");
       clear_list(button);
       gtk_widget_set_sensitive(get_widget(lsq_dialog, pagenams[PAGE_RIGIDBODY]), FALSE);
       gtk_widget_set_sensitive(get_widget(lsq_dialog, vpagenams[PAGE_RIGIDBODY]), FALSE);
    }
    button = get_widget(lsq_dialog, "notebook");
    gtk_notebook_set_current_page(GTK_NOTEBOOK(button), PAGE_GENERAL);
}

extern "C" void c_open_lsq_(stringa *list, int *n_elem, int ifGrRef[])
{
    open_lsq_dlg(finestre[0], clsqgtk, list, *n_elem, ifGrRef);
}

void switchpage (GtkNotebook *nb, gint page_num,
                                             gpointer user_data)
{
    GtkWidget *label;

    label = gtk_notebook_get_tab_label (nb, 
          gtk_notebook_get_nth_page (nb, page_num));
    if(!gtk_widget_get_sensitive(label))
        gtk_notebook_set_current_page (nb, curPag);
    else
        curPag = page_num;
}

void help_lsq(GtkButton *button, gpointer data)
{
    open_htm("Refine.html#lsq");
}

GtkWidget* create_lsq (int ele[])
{
  GtkWidget *lsq_window;
  GtkWidget *vbox;
  GtkWidget *frame0;
  GtkWidget *align;
  GtkWidget *label1;
  GtkWidget *notebook;
  GtkWidget *help_button;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;

  lsq_window = gtk_dialog_new ();
  g_object_set_data (G_OBJECT (lsq_window), 
                       "lsq_window", lsq_window);
  gtk_window_set_title (GTK_WINDOW (lsq_window), "Least Squares Refinement");

  vbox = gtk_dialog_get_content_area(GTK_DIALOG(lsq_window));
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 2);

  notebook = gtk_notebook_new ();
  g_object_set_data (G_OBJECT (lsq_window), "notebook", notebook);
  gtk_box_pack_start (GTK_BOX (vbox), notebook, TRUE, TRUE, 0);
  gtk_widget_show (notebook);

  frame0 = NEW_FRAME ("Observations &amp; Parameters", true);
  g_object_set_data (G_OBJECT (lsq_window), "frame0", frame0);
  gtk_widget_show (frame0);
  gtk_box_pack_start (GTK_BOX (vbox), frame0, TRUE, TRUE, 10);

  align = get_widget(frame0, "align");
  
  label1 = gtk_label_new (" ");
  g_object_set_data (G_OBJECT (lsq_window), "osservazioni", label1);
  gtk_widget_show (label1);
  gtk_container_add (GTK_CONTAINER (align), label1);

  help_button = HELP_button();
  gtk_widget_show (help_button);
  gtk_dialog_add_action_widget (GTK_DIALOG (lsq_window), help_button, 1);
  (void) g_signal_connect (G_OBJECT(help_button), "clicked", 
  G_CALLBACK(help_lsq), NULL);

  ok_button = myimage_button("", "go.png");
  g_object_set_data (G_OBJECT (lsq_window), "ok_button", 
                            ok_button);
  gtk_dialog_add_action_widget (GTK_DIALOG (lsq_window), ok_button, 2);
  gtk_widget_show (ok_button);
  (void) g_signal_connect (G_OBJECT(ok_button), "clicked", 
  G_CALLBACK(ok_lsq), GINT_TO_POINTER(1));

  ok_button = OK_button();
  g_object_set_data (G_OBJECT (lsq_window), "accept_button", 
                            ok_button);
  gtk_dialog_add_action_widget (GTK_DIALOG (lsq_window), ok_button, 3);
  gtk_widget_show (ok_button);
  (void) g_signal_connect (G_OBJECT(ok_button), "clicked", 
  G_CALLBACK(ok_lsq), GINT_TO_POINTER(0));

  cancel_button = CANCEL_button();
  g_object_set_data (G_OBJECT (lsq_window), "cancel_button", 
                            cancel_button);
  gtk_dialog_add_action_widget (GTK_DIALOG (lsq_window), cancel_button, 4);
  gtk_widget_show (cancel_button);
  (void) g_signal_connect (G_OBJECT(cancel_button), "clicked", 
  G_CALLBACK(ok_lsq), GINT_TO_POINTER(-1));
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(ok_button)),
           GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect_swapped (G_OBJECT(lsq_window), "delete_event", 
         G_CALLBACK(gtk_button_clicked), 
         G_OBJECT(cancel_button));
  (void) g_signal_connect (G_OBJECT (lsq_window), "delete_event",
                      G_CALLBACK(true_cb), NULL);

#ifndef GTK_TOOLTIP
      GtkTooltips *tooltips = gtk_tooltips_new();
      g_object_set_data (G_OBJECT (lsq_window), "tooltips", 
                            tooltips);
#endif
  pagelsq0(notebook, lsq_window);
  pagelsq1(notebook, lsq_window, ele);
  pagelsq2(notebook, lsq_window);

  (void) g_signal_connect (G_OBJECT(notebook), "change-current-page",
          G_CALLBACK(switchpage), NULL);

  for(int i=0; i<MAXGROUPS; i++)
      to_refine[i] = 1;

  return lsq_window;
}

void ok_parameters(GtkButton *button, gpointer data)
{
using namespace LSQ;
    int ok, i;
    char entrynam[3];
    GtkWidget *entry;
  
    ok = GPOINTER_TO_INT(data);
    if(ok)
    {
        for(i=0; i<ok; i++)
        {
           ScriviStringa(entrynam, sizeof(entrynam), "p%d", i+1);
           entry = lookup_widget(GTK_WIDGET(button), entrynam);
           lsqgtk->WParGTK[i] = (float) 
             atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
        }
    }
    gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
    gtk_main_quit();
}

void refine_weight_parameters (GtkButton *chb, int *psel_w)
{
  int sel_w;

  sel_w = *psel_w + 1;
  refine_wp_(&sel_w);
}

void change_weight_parameters (GtkButton *chb, int *psel_w)
{
using namespace LSQ;
  GtkWidget *dialog;
  GtkWidget *dialog_vbox;
  GtkWidget *table;
  GtkWidget *label;
  GtkWidget *entry;
  GtkWidget *button;
  int sel_w;
  char string[15];
  int  num_parameters = 10, i;
  char lab1[7], lab2[4];

  sel_w = *psel_w;
  dialog = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog), "Modify weight parameters");

  dialog_vbox = gtk_dialog_get_content_area(GTK_DIALOG (dialog));
  gtk_container_set_border_width (GTK_CONTAINER (dialog), 10);

  table = table_new (num_parameters+1, 2, FALSE);
  gtk_widget_show (table);
  gtk_box_pack_start (GTK_BOX (dialog_vbox), table, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table), 4);
  table_set_row_spacings (table, 5);
  table_set_col_spacings (table, 5);

  for(i=num_parameters; i>=1; i--)
  {
      ScriviStringa(lab1, sizeof(lab1), "P(%2d)", i);
      ScriviStringa(lab2, sizeof(lab2), "p%d", i);
      label = gtk_label_new (lab1);
      gtk_widget_show (label);
      table_attach_exp (table, label, 0, 1, i, i+1);
      set_alignment(label, 0, 0.5);

      entry = gtk_entry_new ();
      g_object_set_data (G_OBJECT (dialog), lab2, entry);
      gtk_widget_show (entry);
      table_attach_exp (table, entry, 1, 2, i, i+1);
      if(lsqgtk->nParDefGTK[sel_w] >= i)
      {
         gtk_widget_set_sensitive(label, TRUE);
         gtk_widget_set_sensitive(entry, TRUE);
         ScriviStringa(string, sizeof(string), "%f", lsqgtk->WParDefGTK[i-1][sel_w]);
         gtk_entry_set_text(GTK_ENTRY(entry), string);
      }
      else
      {
         gtk_widget_set_sensitive(label, FALSE);
         gtk_widget_set_sensitive(entry, FALSE);
      }
   }

  label = gtk_label_new (pesi[sel_w]);
  g_object_set_data (G_OBJECT (dialog), "peso", label);
  gtk_widget_show (label);
  table_attach_exp (table, label, 0, 2, 0, 1);
  set_alignment(label, 0, 0.5);

  button = OK_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog), button, 1);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
            G_CALLBACK(ok_parameters), 
            GINT_TO_POINTER(lsqgtk->nParDefGTK[sel_w]));

  button = CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog), button, 2);
  (void) g_signal_connect(G_OBJECT(button), "clicked", 
            G_CALLBACK(ok_parameters), GINT_TO_POINTER(0));

  (void) g_signal_connect_swapped(G_OBJECT(dialog), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button)); 

  (void) g_signal_connect (G_OBJECT (dialog), "delete_event",
                      G_CALLBACK(true_cb), NULL);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
           GTK_BUTTONBOX_SPREAD);

  gtk_widget_show_all(dialog);
  gtk_widget_set_sensitive(lsq_dialog, FALSE);
  finestra_modale_aperta2(dialog);
  gtk_main();
  finestra_modale_chiusa2();
  gtk_widget_set_sensitive(lsq_dialog, TRUE);

}


void pagelsq0(GtkWidget *notebook, GtkWidget *lsq_window)
{
using namespace LSQ;
  GtkWidget *vbox1;

  GtkWidget *hbox1;
  GtkWidget *hbox;
  GtkWidget *vbox2;
  GtkWidget *vbox3;
  GtkWidget *frame2;
  GtkWidget *frame3;
  GtkWidget *frame4;
  GtkWidget *frame5;
  GtkWidget *vbox4;
  GtkWidget *vbox5;
  GSList *vbox5_group = NULL;
  GSList *group2 = NULL;
  GtkWidget *radiobutton;
  GtkWidget *label3;
  GObject *dampi_adj;
  GtkWidget *dampi;
  GtkWidget *label4;
  GObject *cutoff_adj;
  GtkWidget *cutoff;
  GtkWidget *label5;
  GObject *ncycles_adj;
  GtkWidget *ncycles;
  GtkWidget *combo1;
  GtkWidget *radio[4];
  GtkWidget *table;
  GtkWidget *table2;
  GtkWidget *change_button;
  GtkWidget *refine_button;
  int statoiniziale[10];
  int i;
  float dam;
  static const char *radio_label[] = {"Diagonal", "Full Matrix", "S.F.C. only"};
  int nradios = (int) (sizeof(radio_label)/sizeof(radio_label[0]));

  for (i=0; i<10; i++)
      statoiniziale[i] = lsqgtk->LSQinit[i];
  vbox1 = vbox_new (FALSE, vspace);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (notebook), vbox1);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 10);

  hbox1 = hbox_new (FALSE, 10);
  g_object_set_data (G_OBJECT (lsq_window), "hbox1", hbox1);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  vbox2 = vbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (lsq_window), "vbox2", vbox2);
  gtk_widget_show (vbox2);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox2, TRUE, TRUE, 0);

  frame2 = NEW_FRAME ("Refinement Request", true);
  g_object_set_data (G_OBJECT (lsq_window), "frame2", frame2);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox2), frame2, TRUE, TRUE, 0);

  vbox4 = vbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (lsq_window), "vbox4", vbox4);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (get_widget(frame2, "align")), vbox4);

  vbox5 = vbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (lsq_window), "vbox5", vbox5);
  gtk_widget_show (vbox5);
  gtk_box_pack_start (GTK_BOX (vbox4), vbox5, TRUE, TRUE, 0);

  for(int i=0; i<nradios; i++)
  {
      radio[i] = RADIO_BUTTON_WITH_LABEL (vbox5_group, radio_label[i], LABELCOLOR);
      vbox5_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio[i]));
      g_object_set_data (G_OBJECT (lsq_window), 
         g_strdup_printf("radiobutton%d", i+1), radio[i]);
      gtk_widget_show (radio[i]);
      gtk_box_pack_start (GTK_BOX (vbox5), radio[i], FALSE, FALSE, 0);
  }

  vbox3 = vbox_new(FALSE, 0);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox3, TRUE, TRUE, 0);

  frame3 = NEW_FRAME ("Refinement Conditions", true);
  g_object_set_data (G_OBJECT (lsq_window), "frame3", frame3);
  gtk_widget_show (frame3);
//180309  gtk_box_pack_start (GTK_BOX (vbox3), frame3, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox3), frame3, TRUE, TRUE, 0);

  table = table_new (3, 2, FALSE);

  /* set the spacing to 2 on x and 2 on y */
  table_set_row_spacings (table, 2);
  table_set_col_spacings (table, 2);

  gtk_container_add(GTK_CONTAINER (get_widget(frame3, "align")), table);

  gtk_widget_show (table);

  label3 = LABEL_NEW ("Damping Factor", LABELCOLOR);
  set_alignment(label3, 0.1f, 0.5f);
  gtk_widget_show (label3);

  label4 = LABEL_NEW ("Reflections cutoff", LABELCOLOR);
  set_alignment(label4, 0.1f, 0.5f);
  gtk_widget_show (label4);

  label5 = LABEL_NEW ("# of Cycles", LABELCOLOR);
  set_alignment(label5, 0.1f, 0.5f);
  gtk_widget_show (label5);

  dam = (float) statoiniziale[2] / 1000.0f;
  dampi_adj = adj_new (dam, 0.1f, 1.0f, 0.1f, 0.1f);
  dampi = spin_button_new (GTK_ADJUSTMENT (dampi_adj), 1, 0);
  g_object_set_data (G_OBJECT (lsq_window), "dampi", dampi);
  gtk_widget_set_size_request(dampi, 20, 24);
  spin_button_set_digits (dampi, 1);
  gtk_widget_show (dampi);


  cutoff_adj = adj_new ((float)statoiniziale[3], 0.f, 9.f, 
               1.f, 2.f);
  cutoff = spin_button_new (GTK_ADJUSTMENT (cutoff_adj), 1, 0);
  g_object_set_data (G_OBJECT (lsq_window), "cutoff", cutoff);
  gtk_widget_show (cutoff);
  gtk_widget_set_size_request(cutoff, 20, 24);

  ncycles_adj = adj_new (3, 0, 100, 1, 10);
  ncycles = spin_button_new (GTK_ADJUSTMENT (ncycles_adj), 1, 0);
  g_object_set_data (G_OBJECT (lsq_window), "ncycles", ncycles);
  gtk_widget_show (ncycles);
  gtk_widget_set_size_request(ncycles, 20, 24);

  table_attach (table, label3, 0, 1, 0, 1, TRUE);
  table_attach (table, label4, 0, 1, 1, 2, TRUE);
  table_attach (table, label5, 0, 1, 2, 3, TRUE);
  table_attach (table, dampi, 1, 2, 0, 1, TRUE);
  table_attach (table, cutoff, 1, 2, 1, 2, TRUE);
  table_attach (table, ncycles, 1, 2, 2, 3, TRUE);

  frame5 = NEW_FRAME ("Refinement against: ", true);
//190309  gtk_widget_show (frame5);
  gtk_box_pack_start (GTK_BOX (vbox3), frame5, FALSE, FALSE, 0);

  table2 = vbox_new (FALSE, 0);
  gtk_widget_show (table2);
  gtk_container_set_border_width (GTK_CONTAINER (table2), 4);
  gtk_container_add (GTK_CONTAINER (get_widget(frame5, "align")), table2);

  radiobutton = RADIO_BUTTON_WITH_LABEL (group2, "F(obs)", LABELCOLOR);
  group2 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
  g_object_set_data(G_OBJECT (lsq_window), "F(obs)", radiobutton);
  gtk_widget_show (radiobutton);
  gtk_box_pack_start (GTK_BOX (table2), radiobutton, TRUE, TRUE, 0);

  radiobutton = RADIO_BUTTON_WITH_LABEL (group2, "F(obs)**2", LABELCOLOR);
  group2 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
  g_object_set_data(G_OBJECT (lsq_window), "F(obs)**2", radiobutton);
  gtk_widget_show (radiobutton);
  gtk_box_pack_start (GTK_BOX (table2), radiobutton, TRUE, TRUE, 0);

  frame4 = NEW_FRAME ("Weighting Scheme", true);
  g_object_set_data (G_OBJECT (lsq_window), "frame4", frame4);
  gtk_widget_show (frame4);
  gtk_box_pack_start (GTK_BOX (vbox1), frame4, FALSE, FALSE, 0);

  vbox1 = vbox_new(FALSE,2);
  gtk_widget_show(vbox1);
  gtk_container_add(GTK_CONTAINER(get_widget(frame4, "align")), vbox1);
  gtk_container_set_border_width(GTK_CONTAINER(vbox1), 4);

  combo1 = create_combo(vbox1, pesi, 18, 5, &pesoc, NULL);
//  g_object_set_data(G_OBJECT(lsq_window),"pesi",get_widget(combo1, "entry"));
  g_object_set_data(G_OBJECT(lsq_window),"pesi",combo1);
  gtk_widget_show(combo1);
  gtk_editable_set_editable(GTK_EDITABLE(get_widget(combo1, "entry")), FALSE);

  hbox = hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox, FALSE, FALSE, 10);

  change_button = gtk_button_new_with_label("Modify weight parameters");
  g_object_set_data(G_OBJECT (lsq_window), "ch_pp", change_button);
  gtk_widget_show(change_button);
  gtk_box_pack_start (GTK_BOX (hbox), change_button, FALSE, FALSE, 0);

  refine_button = gtk_button_new_with_label("Refine weight parameters");
  g_object_set_data(G_OBJECT (lsq_window), "ref_pp", refine_button);
  gtk_widget_show(refine_button);
  gtk_box_pack_end (GTK_BOX (hbox), refine_button, FALSE, FALSE, 0);

  /*  segnali  */
  for(i=0; i<nradios; i++)
    (void) g_signal_connect (G_OBJECT (radio[i]), "toggled",
                      G_CALLBACK (ref_request),
                      GINT_TO_POINTER(i));

  (void) g_signal_connect_after (G_OBJECT (dampi), "value-changed",
                      G_CALLBACK (ref_conditions),
                      GINT_TO_POINTER(1));
  (void) g_signal_connect_after (G_OBJECT (cutoff), "value-changed",
                      G_CALLBACK (ref_conditions),
                      GINT_TO_POINTER(2));
  (void) g_signal_connect_after (G_OBJECT (ncycles), "value-changed",
                      G_CALLBACK (ref_conditions),
                      GINT_TO_POINTER(3));

#ifndef GTK_COMBO_BOX
  GtkWidget *list = get_widget(combo1, "entry");
  (void) g_signal_connect_after (G_OBJECT (list),
           "changed", G_CALLBACK (on_pesi_lsq), lsq_window);
#else
  (void) g_signal_connect_after (G_OBJECT (combo1),
           "changed", G_CALLBACK (on_pesi_lsq), lsq_window);
#endif
  (void) g_signal_connect (G_OBJECT (change_button), "clicked",
                      G_CALLBACK (change_weight_parameters), &peso);
  (void) g_signal_connect (G_OBJECT (refine_button), "clicked",
                      G_CALLBACK (refine_weight_parameters), &peso);

  set_tab_label (GTK_NOTEBOOK (notebook), PAGE_GENERAL, "General");
}

void on_buttonlabel_active(GtkWidget *widget, gpointer data)
{
   GtkWidget *button, *dlg = gtk_widget_get_toplevel(GTK_WIDGET(widget));
   char stringa[20];
   int atompos;
   int i;

   atompos = GPOINTER_TO_INT(data);

   for(i = 0; i<NUMPAR; i++)
   {
       ScriviStringa(stringa,sizeof(stringa), "checkstru%d-%d", atompos,parval[i]);
       button = get_widget(dlg, stringa);
       if(gtk_widget_get_sensitive(button))
          gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button),
               gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
   }
}

void toggle_tip(GtkWidget *widget, gpointer data)
{
   int pos = GPOINTER_TO_INT(data);

   std::string tname;
   tname.assign("Click to ");
   if( gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)) )
        tname.append(parametrit[pos]);
   else
       tname.append(parametri[pos]);
   set_tip(widget, tname.c_str());
}

void on_buttonpar_active(GtkWidget *widget, gpointer data)
{
   GtkWidget *button, *dlg = gtk_widget_get_toplevel(GTK_WIDGET(widget));

   char stringa[20];
   int parpos, pos;
   int i;

   pos = GPOINTER_TO_INT(data);
   parpos = parval[pos];

   int parspec = get_int(dlg, "parspec");

   for(i = 0; i<natsC; i++)
   {
      if ((nzTot[i] == (parspec+1)) || (parspec == nSpecies))
      {
       ScriviStringa(stringa,sizeof(stringa), "checkstru%d-%d", i,parpos);
       button = get_widget(dlg, stringa);
       if(gtk_widget_get_sensitive(button))
           gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button),
                 gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
      }
   }
}

void on_buttonspec_active(GtkToggleButton *widget, gpointer data)
{
   GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(widget));
   if(gtk_toggle_button_get_active(widget))
   {
      int parspec = GPOINTER_TO_INT(data);
      if(parspec != nSpecies)
      {
         char stringa[15];
         ScriviStringa(stringa,sizeof(stringa), "buttonspe%d",nSpecies);
         GtkWidget *button = get_widget(dlg, stringa);
         gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), FALSE);
      }
      else
      {
         for(int i=0; i<nSpecies; i++)
         {
             char stringa[15];
             ScriviStringa(stringa,sizeof(stringa), "buttonspe%d",i);
             GtkWidget *button = get_widget(dlg, stringa);
             gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), FALSE);
         }
      }
      g_object_set_data(G_OBJECT(dlg), "parspec", data);
   }
}

void riaggiustaB(int whichAtom)
{
using namespace LSQ;
    char string[20];
    ScriviStringa(string,sizeof(string),"checkstru%d-%d",whichAtom,B);
    GtkWidget *button = get_widget(lsq_dialog, string);
    if(lsqgtk->IsoAnisoGTK[whichAtom] == 2)    // isotropic
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), 
              lsqgtk->kFixGTK[whichAtom][B]);
    else
       gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button),
              lsqgtk->kFixGTK[whichAtom][B+1]);
}

void on_togparam(GtkToggleButton *but, gpointer data)
{
using namespace LSQ;
   int cb_data = GPOINTER_TO_INT(data);
   int whichAtom = cb_data / 100;
   int whichPar  = cb_data % 100;
   if(whichPar == B)
   {
      if(lsqgtk->IsoAnisoGTK[whichAtom]==2)      // isotropic
      {
         lsqgtk->kFixGTK[whichAtom][B] = 
            gtk_toggle_button_get_active(but);
         for(int k=B+1; k<OCC; k++)
             lsqgtk->kFixGTK[whichAtom][k] = 0;
      }
      else                                       // anisotropic
      {
         lsqgtk->kFixGTK[whichAtom][B] = 0;
         for(int k=B+1; k<OCC; k++)
             lsqgtk->kFixGTK[whichAtom][k] =
                 gtk_toggle_button_get_active(but);
      }
   }
   else if(whichPar < B)
   {
      for(int k=XYZ; k<B; k++)
          lsqgtk->kFixGTK[whichAtom][k] =
              gtk_toggle_button_get_active(but);
   }
   else if(whichPar == ISO)
   {
          lsqgtk->IsoAnisoGTK[whichAtom] =
           gtk_toggle_button_get_active(but)+1;
          riaggiustaB(whichAtom);
   }
   else 
          lsqgtk->kFixGTK[whichAtom][whichPar] =
           gtk_toggle_button_get_active(but);
}

void frame_atomic_parameters (GtkWidget *window1, GtkWidget *father, int ele[])
{
using namespace LSQ;
  GtkWidget *scrolled_window;
  GtkWidget *hbox1;
  GtkWidget *frame1;
  GtkWidget *vbox2;
  GtkWidget *table1;
  GtkWidget *buttonlabel;
  GtkWidget *buttonpar;
  GtkWidget *checkbutton;

  char string[20];
  int i,j;

  hbox1 = vbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_container_add (GTK_CONTAINER (father), hbox1);
  gtk_container_set_border_width (GTK_CONTAINER (hbox1), 5);

  frame1 = NEW_FRAME("Filter species");
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 5);
  gtk_box_pack_start (GTK_BOX (hbox1), frame1, FALSE, FALSE, 0);
  gtk_widget_show (frame1);

  scrolled_window = gtk_scrolled_window_new(NULL,NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW (scrolled_window),
                                 GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
  gtk_box_pack_start (GTK_BOX (hbox1), scrolled_window, TRUE, TRUE, 0);
  gtk_widget_show(scrolled_window);

  table1 = table_new (natsC+1, NUMPAR+1, FALSE);
  gtk_widget_show (table1);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 5);
  table_set_row_spacings (table1, 4);
  table_set_col_spacings (table1, 4);
  add_to_scrollwin (scrolled_window, table1);
//
//   Labels degli atomi sulla prima colonna
//
  for (i=0;i<natsC;i++)
  {
    std::string label_at = AtomiC[i];
    buttonlabel = gtk_toggle_button_new_with_label (label_at.c_str());
    gtk_widget_show (buttonlabel);
    ScriviStringa(string,sizeof(string), "buttonlabel%d",i);
    g_object_set_data(G_OBJECT (window1),string, buttonlabel);
    table_attach_exp (table1, buttonlabel, 0, 1, i+1, i+2);
    gtk_widget_set_size_request(buttonlabel, 50, 24);
    int hnd = g_signal_connect (G_OBJECT(buttonlabel), "clicked", 
            G_CALLBACK(on_buttonlabel_active), GINT_TO_POINTER(i));
    g_object_set_data(G_OBJECT (buttonlabel),"hnd", GINT_TO_POINTER(hnd));
  }
  
//
//  Tipo di parametro (x,y,z,B,occ.) sulla prima riga
//
   GtkSizeGroup *szgroup = gtk_size_group_new(GTK_SIZE_GROUP_VERTICAL);
   for(i=0; i<NUMPAR; i++)
   {
       buttonpar = gtk_toggle_button_new_with_label (parametri[i]);
       gtk_widget_show (buttonpar);
       ScriviStringa(string,sizeof(string), "buttonpar%d",parval[i]);
       table_attach(table1, buttonpar, i+1, i+2, 0, 1, TRUE);
       gtk_size_group_add_widget(szgroup, buttonpar);
       g_object_set_data(G_OBJECT (window1),string, buttonpar);
       int hnd = g_signal_connect (G_OBJECT(buttonpar), "clicked", 
              G_CALLBACK(on_buttonpar_active), GINT_TO_POINTER(i));
       g_signal_connect_after (G_OBJECT(buttonpar), "clicked", 
              G_CALLBACK(toggle_tip), GINT_TO_POINTER(i));
       g_object_set_data(G_OBJECT (buttonpar),"hnd", GINT_TO_POINTER(hnd));
       std::string tname;
       tname.assign("Click to ");
       tname.append(parametri[i]);
       set_tip(buttonpar, tname.c_str());

   }

   for(i=0; i<NUMPAR; i++)
   {
//
//  Checkbutton per ogni parametro sulle righe successive
//
    for (j=0;j<natsC;j++)
    {
        checkbutton = gtk_check_button_new();
#ifdef IN_GTK3
        GtkWidget *align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_CENTER, 0, 0);
#else
        GtkWidget *align = gtk_alignment_new(0.5, 0.5, 0, 0);
#endif
        table_attach(table1, align, i+1, i+2, j+1, j+2, TRUE);
        gtk_container_add(GTK_CONTAINER(align), checkbutton);
        ScriviStringa(string,sizeof(string),"checkstru%d-%d",j,parval[i]);
        g_object_set_data(G_OBJECT (window1),string, checkbutton);
        int hnd = g_signal_connect (G_OBJECT(checkbutton), "toggled", 
            G_CALLBACK(on_togparam), GINT_TO_POINTER(j*100+parval[i]));
        g_object_set_data(G_OBJECT (checkbutton),"hnd", GINT_TO_POINTER(hnd));
        gtk_widget_show (align);
        gtk_widget_show (checkbutton);
    }
  }

//  vbox2 = vbox_new (FALSE, 0);
  vbox2 = hbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (get_widget(frame1, "align")), vbox2);

  for (i=0;i<=nSpecies;i++)
  {
      if(i < nSpecies)
         checkbutton = gtk_check_button_new_with_label
             (get_nth_element_name(ele[i]-1));
      else
         checkbutton = gtk_check_button_new_with_label ("All");
      gtk_box_pack_start (GTK_BOX (vbox2), checkbutton, TRUE, TRUE, 2);
		gtk_widget_show (checkbutton);
      ScriviStringa(string,sizeof(string), "buttonspe%d",i);
      g_object_set_data(G_OBJECT (window1),string, checkbutton);
      int hnd = g_signal_connect(G_OBJECT(checkbutton),"clicked",G_CALLBACK(on_buttonspec_active),GINT_TO_POINTER(i)); 
      g_object_set_data(G_OBJECT (checkbutton),"hnd", GINT_TO_POINTER(hnd));
  }
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton), TRUE);
  g_object_set_data(G_OBJECT(window1), "parspec", GINT_TO_POINTER(nSpecies));

}

void pagelsq1(GtkWidget *notebook, GtkWidget *lsq_window, int ele[])
{
  GtkWidget *vbox;
  GtkWidget *title;
  GtkWidget *frame;

  vbox = vbox_new (FALSE, vspace);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (notebook), vbox);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 10);
  g_object_set_data(G_OBJECT(lsq_window), vpagenams[PAGE_PARAMETERS], vbox);

  frame = NEW_FRAME ("Atomic Parameters", true);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);
  frame_atomic_parameters(lsq_window, get_widget(frame, "align"), ele);

  set_tab_label (GTK_NOTEBOOK (notebook), PAGE_PARAMETERS, "Modify Atoms Parameters");
  title = gtk_notebook_get_tab_label(GTK_NOTEBOOK (notebook), 
     gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook), PAGE_PARAMETERS));
  g_object_set_data(G_OBJECT(lsq_window), pagenams[PAGE_PARAMETERS], title);

}

static void fixed_toggled(GtkCellRendererToggle *cell, gchar *path_str, gpointer data)
{
  GtkTreeModel *model = (GtkTreeModel *)data;
  GtkTreeIter  iter;
  GtkTreePath *path = gtk_tree_path_new_from_string (path_str);
  gboolean fixed;
  int pos;
                                                                                
  pos = atoi(path_str);
  gtk_tree_model_get_iter (model, &iter, path);
  gtk_tree_model_get (model, &iter, 0, &fixed, -1);
                                                                                
  fixed ^= 1;
  gtk_list_store_set (GTK_LIST_STORE (model), &iter, 0, fixed, -1);
  gtk_tree_path_free (path);
  to_refine[pos] = fixed;
}

void populate_list_adhoc(GtkTreeView *list, GList *values[], int numlists)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    char *entry;
    int i, j, numval;
                                                                                                
//    for(i=0; i<MAXGROUPS; i++)
//        to_refine[i] = 1;
    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(list));
    gtk_list_store_clear(GTK_LIST_STORE(list_store));
    numval = g_list_length(values[0]);
    for(i=0; i<numval; i++)
    {
        entry = (char *)g_list_nth_data (values[0], i);
        if(entry && strlen(entry))
        {
           gtk_list_store_append (list_store, &iter);
           gtk_list_store_set (list_store, &iter, 0, to_refine[i],-1);
           for(j=0; j<numlists; j++)
           {
               entry = (char *)g_list_nth_data (values[j], i);
               gtk_list_store_set (list_store, &iter, j+1, entry,-1);
           }
        }
    }
}

void globalselect(GtkTreeViewColumn *column, GtkWidget *list)
{
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
    GtkListStore *store = GTK_LIST_STORE(model);
    GtkTreeIter iter;
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    while (valid)
    {
       gtk_list_store_set (store, &iter, 0, 1,-1);
       valid = gtk_tree_model_iter_next (model, &iter);
    }
}

void globalunselect(GtkTreeViewColumn *column, GtkWidget *list)
{
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(list));
    GtkListStore *store = GTK_LIST_STORE(model);
    GtkTreeIter iter;
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    while (valid)
    {
       gtk_list_store_set (store, &iter, 0, 0,-1);
       valid = gtk_tree_model_iter_next (model, &iter);
    }
}

GtkWidget *createSelection_adhoc(GtkWidget *parent, GtkWidget *parentbox, 
        const char *title[], const char *id,  int ncol, const char *col)
{
    GtkWidget *scrollwin, *dirsel, *label, *lab1;
    GtkWidget *frame;
    GtkListStore *store;
    GtkCellRenderer *renderer;
    GtkTreeViewColumn *column;
    int i;
    int sizes[] = {50, 135, 65, 60, 60};

    frame = gtk_frame_new(NULL);
    gtk_container_set_border_width (GTK_CONTAINER (frame), 6);
    if(parentbox)
    {
       if (GTK_IS_BOX(G_OBJECT(parentbox)))
           gtk_box_pack_start (GTK_BOX (parentbox), frame, TRUE, TRUE, 0);
       else if (GTK_IS_CONTAINER(G_OBJECT(parentbox)))
           gtk_container_add(GTK_CONTAINER(parentbox), frame);
    }
    gtk_widget_show (frame);
    scrollwin = gtk_scrolled_window_new (NULL, NULL);
    gtk_container_add(GTK_CONTAINER(frame), scrollwin);

    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                   GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

    gtk_widget_show (scrollwin);
    dirsel = gtk_tree_view_new();
    g_object_set_data(G_OBJECT(dirsel), "frame", frame);
    g_object_set_data(G_OBJECT(dirsel), "scrollwin", scrollwin);
    g_object_set_data(G_OBJECT(dirsel), "formato", GINT_TO_POINTER(7));

    store = gtk_list_store_new (5, G_TYPE_BOOLEAN, G_TYPE_STRING, G_TYPE_STRING,
                                   G_TYPE_STRING, G_TYPE_STRING);
    renderer = gtk_cell_renderer_toggle_new ();
     g_signal_connect (renderer, "toggled", G_CALLBACK (fixed_toggled),
          GTK_TREE_MODEL(store));
    column = gtk_tree_view_column_new_with_attributes (title[0],
            renderer, "active", 0, NULL);
    label = LABEL_NEW(title[0], col);
    gtk_widget_show (label);
    gtk_tree_view_column_set_widget(column, label);
    gtk_tree_view_column_set_clickable(column, FALSE);
    gtk_tree_view_column_set_sizing (GTK_TREE_VIEW_COLUMN (column),
                                   GTK_TREE_VIEW_COLUMN_FIXED);
    gtk_tree_view_column_set_fixed_width(GTK_TREE_VIEW_COLUMN(column), sizes[0]);
    gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column);
    for(i=1; i<5; i++)
    {
        renderer = gtk_cell_renderer_text_new ();
        column = gtk_tree_view_column_new_with_attributes (title[i],
            renderer, "text", i, NULL);
        gtk_tree_view_column_set_sizing (GTK_TREE_VIEW_COLUMN (column),
                                   GTK_TREE_VIEW_COLUMN_FIXED);
        gtk_tree_view_column_set_fixed_width(GTK_TREE_VIEW_COLUMN(column), sizes[i]);
        if(i < 3)
        {
           gtk_tree_view_column_set_clickable(column, FALSE);
           if(title[i])
           {
              label = LABEL_NEW(title[i], col);
              gtk_widget_show (label);
              gtk_tree_view_column_set_widget(column, label);
           }
        }
        else
        {
           gtk_tree_view_column_set_clickable(column, TRUE);
           if(i == 3)
              g_signal_connect(G_OBJECT(column), "clicked", G_CALLBACK(globalselect),
                            dirsel);
           else
              g_signal_connect(G_OBJECT(column), "clicked", G_CALLBACK(globalunselect),
                            dirsel);
           if(title[i])
           {
              label = hbox_new(FALSE, 0);
              lab1 = create_image(title[i+2]);
              gtk_box_pack_start(GTK_BOX(label), lab1, FALSE, FALSE, 2);
              lab1 = LABEL_NEW(title[i], col);
              gtk_box_pack_start(GTK_BOX(label), lab1, FALSE, FALSE, 2);
              gtk_widget_show_all (label);
              gtk_tree_view_column_set_widget(column, label);
           }
        }
        gtk_tree_view_append_column (GTK_TREE_VIEW(dirsel), column);
    }
    gtk_tree_view_set_model(GTK_TREE_VIEW(dirsel), GTK_TREE_MODEL (store));
    g_object_set_data(G_OBJECT (parent), id, dirsel);
    gtk_widget_show (dirsel);
    gtk_container_add (GTK_CONTAINER (scrollwin), dirsel);
    return dirsel;
}

void pagelsq2(GtkWidget *notebook, GtkWidget *lsq_window)     // ex gianluca
{
  GtkWidget *vbox;
  GtkWidget *vbox1;
  GtkWidget *label;
  GtkWidget *title;
  GtkWidget *frame;
  GtkWidget *lista;
  const char *titles[] = {"Selected", "Group Name  ", "Serial ", "All", "None",
                    "oksmall.png", "cancelsmall.png"};

  vbox = vbox_new (FALSE, vspace);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (notebook), vbox);
  gtk_container_set_border_width (GTK_CONTAINER (vbox), 10);
  g_object_set_data(G_OBJECT(lsq_window), vpagenams[PAGE_RIGIDBODY], vbox);

  frame = NEW_FRAME ("Select Groups to be used in refinement", true);
  gtk_frame_set_shadow_type (GTK_FRAME(frame), GTK_SHADOW_IN);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);
  gtk_widget_show(frame);
  vbox1 = vbox_new(FALSE, 0);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), vbox1);
  label = LABEL_NEW("Current Group File Header", MyBLUE);
  gtk_box_pack_start (GTK_BOX (vbox1), label, FALSE, FALSE, 10);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  set_alignment(label, 0.,0.);
  label = gtk_entry_new();
  gtk_box_pack_start (GTK_BOX (vbox1), label, FALSE, FALSE, 4);
  g_object_set_data(G_OBJECT(lsq_window), "title", label);
  gtk_editable_set_editable(GTK_EDITABLE(label), FALSE);
   
  frame = NEW_FRAME("Rigid Body Groups", true);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, TRUE, TRUE, 4);
  lista = createSelection_adhoc(lsq_window, get_widget(frame, "align"), titles, "groups", 5, MyBLUE);
  gtk_widget_set_events(lista, GDK_BUTTON_MOTION_MASK);
  set_widget_fontN(lista);
   
  gtk_widget_show_all (vbox1);

  set_tab_label (GTK_NOTEBOOK (notebook), PAGE_RIGIDBODY, "Rigid Body");
  title = gtk_notebook_get_tab_label(GTK_NOTEBOOK (notebook), 
     gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook), PAGE_RIGIDBODY));
  g_object_set_data(G_OBJECT(lsq_window), pagenams[PAGE_RIGIDBODY], title);
}
/*****************************************************************/
/*              F O U R I E R                                    */
/*****************************************************************/

void cancel_fourier (GtkButton *button, gpointer user_data)
{
    gtk_widget_hide (gtk_widget_get_toplevel(GTK_WIDGET(button)));
    finestra_modale_chiusa2();
    clsqgtk->ifCubo = -1;
    ridisegna_();
}

void ok_fourier (GtkButton *button, gpointer user_data)
{
    GtkWidget *window, *add;
    int ier;

    window = gtk_widget_get_toplevel(GTK_WIDGET(button));
    add = get_widget(window, "add");

    statofinale[1] = spin_button_get_value_as_int( add);

    add = get_widget(window, "level");
    statofinale[2] = (int) (10. * spin_button_get_value( add) + 0.5 );

    add = get_widget(window, "ifViewmap");
    statofinale[3] = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(add));
    statofinale[4] = clsqgtk->ifCubo;
    add = get_widget(window, "step");
    statofinale[5] = (int) (100. * spin_button_get_value( add) + 0.5 );
    statofinale[6] = 0;

    gtk_widget_hide (gtk_widget_get_toplevel(GTK_WIDGET(button)));
    finestra_modale_chiusa2();
    fortran_al_lavoro();    
    startfourier_ (&ier, statofinale);
    clsqgtk->ifCubo = -1;
    if(ier)
       fine_lavoro();
    ridisegna_();
}

void on_change_fourier  (GtkToggleButton *togglebutton, gpointer user_data)
{
        int val;

        if(gtk_toggle_button_get_active(togglebutton))
        {
           val = GPOINTER_TO_INT(user_data);

           switch(val)
           {
           case 0:
                statofinale[0] = val+1;
                break;
           case 1:
                statofinale[0] = val+1;
                break;
           case 2:
                statofinale[0] = val+1;
                break;
           }
        }
}

void setcube(GtkToggleButton *but, gpointer data)
{
     if(gtk_toggle_button_get_active(but))
        clsqgtk->ifCubo = 1;
     else
        clsqgtk->ifCubo = -1;
     ridisegna_();
}

void changeCube(int x, int y,int action)
{
     int deltax = x - clsqgtk->ixCubo;
     int deltay = y - clsqgtk->iyCubo;
     clsqgtk->ixCubo = x;
     clsqgtk->iyCubo = y;
     clsqgtk->ifCubo = action;
     fcube_(&deltax, &deltay);
}

void on_change_edge(GtkWidget *spin, gpointer data)
{
     clsqgtk->latoCubo = (float) spin_button_get_value(spin);
     clsqgtk->ifCubo = 0;
     ridisegna_();
}

GtkWidget *frame_fourier_t(GtkWidget *father)
{
  GSList *group = NULL;
  GtkWidget *frame = NEW_FRAME ("Fourier type", true);
  gtk_widget_show (frame);
  GtkWidget *vbox2 = vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), vbox2);

  GtkWidget *radiof = RADIO_BUTTON_WITH_LABEL (group, "Observed", NULL);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiof));
  g_object_set_data (G_OBJECT (father), "obs", radiof);
  gtk_widget_show (radiof);
  gtk_box_pack_start (GTK_BOX (vbox2), radiof, FALSE, FALSE, 1);
   (void) g_signal_connect (G_OBJECT (radiof), "toggled",
           G_CALLBACK (on_change_fourier), GINT_TO_POINTER(0));

  radiof = RADIO_BUTTON_WITH_LABEL (group, "2*Fobs - Fcalc", NULL);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiof));
  g_object_set_data (G_OBJECT (father), "2fobs", radiof);
  gtk_widget_show (radiof);
  gtk_box_pack_start (GTK_BOX (vbox2), radiof, FALSE, FALSE, 1);
   (void) g_signal_connect (G_OBJECT (radiof), "toggled",
           G_CALLBACK (on_change_fourier), GINT_TO_POINTER(1));

  radiof = RADIO_BUTTON_WITH_LABEL (group, "Fobs - Fcalc", NULL);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiof));
  g_object_set_data (G_OBJECT (father), "fobs", radiof);
  gtk_widget_show (radiof);
  gtk_box_pack_start (GTK_BOX (vbox2), radiof, FALSE, FALSE, 1);
   (void) g_signal_connect (G_OBJECT (radiof), "toggled",
           G_CALLBACK (on_change_fourier), GINT_TO_POINTER(2));

  radiof = get_widget(father, "2fobs");
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radiof), TRUE);

  return frame;
}

GtkWidget *frame_fourier_c(GtkWidget *father)
{
  GtkSizeGroup *sz = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
  GtkWidget *frame = NEW_FRAME ("Fourier conditions", true);
  gtk_widget_show (frame);
  GtkWidget *vbox2 = vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (get_widget(frame, "align")), vbox2);

  GtkWidget *add = SPIN_WITH_LABEL("Peaks to add", NULL, 1, (double) MaxAtLSQ,
                   1, 1, 0);
  gtk_box_pack_start(GTK_BOX(vbox2), add, FALSE, FALSE, 1);
  g_object_set_data (G_OBJECT (father), "add", get_widget(add, "spin"));
  gtk_size_group_add_widget(sz, get_widget(add, "label"));
  gtk_widget_show_all (add);

  GtkWidget *level = SPIN_WITH_LABEL("Level (electrons / Ang^3)", NULL, 0, 100,
                       2,  0.1, 1);
  gtk_box_pack_start(GTK_BOX(vbox2), level, FALSE, FALSE, 10);
  g_object_set_data (G_OBJECT (father), "level", get_widget(level, "spin"));
  gtk_size_group_add_widget(sz, get_widget(level, "label"));
  gtk_widget_show_all (level);

  return frame;
}

void help_fourier(GtkButton *butt, gpointer data)
{
    open_htm("Refine.html#fourier");
}

GtkWidget* create_fourier (void)
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *frame1;
  GtkWidget *frame2;
  GtkWidget *table;
  GtkWidget *button1;
  GtkWidget *button2;
  GtkWidget *button3;
  GtkWidget *label0;

  window1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (window1), "Fourier Synthesis");
  gtk_container_set_border_width (GTK_CONTAINER (window1), 10);

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(window1));
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 4);

//  frame0 = FRAME_NEW ("Info", FRAMECOLOR);
//  g_object_set_data (G_OBJECT (window1), "frame0", frame0);
//  gtk_widget_show (frame0);
//  gtk_box_pack_start (GTK_BOX (vbox1), frame0, TRUE, TRUE, 0);

  label0 = gtk_label_new (" ");
  g_object_set_data (G_OBJECT (window1), "info", label0);
  set_alignment (label0, 0., 0.5);
  gtk_widget_show (label0);
  gtk_box_pack_start (GTK_BOX (vbox1), label0, FALSE, FALSE, 0);
//  gtk_container_add (GTK_CONTAINER (frame0), label0);

  hbox1 = hbox_new (FALSE, 10);
  g_object_set_data (G_OBJECT (window1), "hbox1", hbox1);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 20);

  frame1 = frame_fourier_t (window1);
  gtk_box_pack_start (GTK_BOX (hbox1), frame1, TRUE, TRUE, 0);

  frame2 = frame_fourier_c (window1);
  gtk_box_pack_start (GTK_BOX (hbox1), frame2, TRUE, TRUE, 0);

  frame1 = NEW_FRAME ("Fourier space", true);
  g_object_set_data (G_OBJECT (window1), "frame2", frame1);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox1), frame1, TRUE, TRUE, 5);

  table = table_new(2, 3, FALSE);
  gtk_widget_show (table);
  gtk_container_add (GTK_CONTAINER (get_widget(frame1, "align")), table);
  table_set_row_spacings(table, 10);
  table_set_col_spacings(table, 4);

  GSList *group = NULL;
  GtkWidget *radiob = RADIO_BUTTON_WITH_LABEL (group, "Unit Cell", NULL);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiob));
  gtk_widget_show (radiob);
  table_attach (table, radiob, 0, 1, 0, 1, TRUE);
  g_object_set_data (G_OBJECT (window1), "unitcell", radiob);

  radiob = RADIO_BUTTON_WITH_LABEL (group, "Cube", NULL);
  group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiob));
  gtk_widget_show (radiob);
  table_attach (table, radiob, 0, 1, 1, 2, TRUE);
  g_object_set_data (G_OBJECT (window1), "ifcubo", radiob);

  GtkWidget *check = CHECK_BUTTON_WITH_LABEL ("View Fourier map", NULL);
  gtk_widget_show (check);
  table_attach (table, check, 2, 3, 0, 1, TRUE);
  g_object_set_data (G_OBJECT (window1), "ifViewmap", check);

  GtkWidget *spin = SPIN_WITH_LABEL("Cube edge", NULL, 0.1, 10, 2, 0.01, 2);
  gtk_widget_show_all (spin);
  table_attach (table, spin, 2, 3, 1, 2, TRUE);
  set_width_chars (GTK_ENTRY(get_widget(spin, "spin")), 6);
  gtk_widget_set_sensitive(spin, FALSE);
  g_object_set_data (G_OBJECT (window1), "edge", get_widget(spin, "spin"));
  g_signal_connect(G_OBJECT(get_widget(spin, "spin")), "value-changed", G_CALLBACK(on_change_edge), NULL);
  g_signal_connect(G_OBJECT(radiob), "toggled", G_CALLBACK(setcube), NULL);
  g_signal_connect(G_OBJECT(radiob), "toggled", G_CALLBACK(on_cb_attiva), spin);

  spin = SPIN_WITH_LABEL("Grid Step", NULL, 0.1, 0.5, 0.2, 0.01, 2);
  gtk_widget_show_all (spin);
  table_attach (table, spin, 1, 2, 1, 2, TRUE);
  set_width_chars (GTK_ENTRY(get_widget(spin, "spin")), 6);
  gtk_widget_set_sensitive(spin, FALSE);
  g_object_set_data (G_OBJECT (window1), "step", get_widget(spin, "spin"));
  g_signal_connect(G_OBJECT(radiob), "toggled", G_CALLBACK(on_cb_attiva), spin);

  button3 = HELP_button(); 
  g_object_set_data (G_OBJECT (window1), "button3", button3);
  gtk_widget_show (button3);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button3, 1);

  button1 = myimage_button("", "go.png");
  g_object_set_data (G_OBJECT (window1), "button1", button1);
  gtk_widget_show (button1);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button1, 2);

  button2 = CANCEL_button(); 
  g_object_set_data (G_OBJECT (window1), "button2", button2);
  gtk_widget_show (button2);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button2, 3);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button1)),
           GTK_BUTTONBOX_SPREAD);

  /* default */

  statofinale[0] = 2;

  /*  segnali  */

  g_object_set_data (G_OBJECT (window1), "cancel_button", 
                            button2);
  (void) g_signal_connect (G_OBJECT(button3), "clicked", 
  G_CALLBACK(help_fourier), NULL);
  (void) g_signal_connect (G_OBJECT(button2), "clicked", 
  G_CALLBACK(cancel_fourier), NULL);
  (void) g_signal_connect_swapped(G_OBJECT(window1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button2)); 
  (void) g_signal_connect (G_OBJECT (window1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  (void) g_signal_connect (G_OBJECT(button1), "clicked", 
            G_CALLBACK(ok_fourier), NULL);

  //gtk_widget_show (window1);

  return window1;
}

void open_fourier_dlg(GtkWidget *item, gpointer data)
{
     GtkWidget *label;
     char info[80];
     int nadd;
     float maxval;
     int ier = 0;
  
     prefourier_(&natsC, &nadd, &ier);
     if(ier)
        return;
     if(fourier_dialog == NULL)
           fourier_dialog = create_fourier();
     maxval = getmaxdim_();
     gtk_window_set_transient_for(GTK_WINDOW(fourier_dialog), GTK_WINDOW(finestre[0]));
     gtk_widget_show(fourier_dialog);
     finestra_modale_aperta2(fourier_dialog);

// costruisco la stringa 
     ScriviStringa(info, sizeof(info),  
             "Info: %d atoms in current model", natsC); 
// recupero il widget 
     label = get_widget(fourier_dialog, "info");
// aggiorno il testo
     gtk_label_set_text(GTK_LABEL(label), info);

// aggiorno il valore 
     label = get_widget(fourier_dialog, "add");
     spin_button_set_value(label, (float)nadd);

     label = get_widget(fourier_dialog, "edge");
     spin_button_set_range(label, 0.1, maxval);
     spin_button_set_value(label, clsqgtk->latoCubo);
     if(clsqgtk->ifCubo > 0)
        label = get_widget(fourier_dialog, "ifcubo");
     else
        label = get_widget(fourier_dialog, "unitcell");
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(label), TRUE);
}

/*****************************************************************/
/*           C E L L   C O N T E N T                             */
/*****************************************************************/
static GtkWidget *cell_dlg = NULL;
static char *elem_in_cell[NUMSPECIES];
static int  num_in_cell[NUMSPECIES];
static char vspec[SYMLEN*NUMSPECIES+1];
static char *pspec = vspec;

void fill_cell_dlg(void)
{
   GtkWidget *entry;
   char num[5];
   int i;

   for(i=0; i<2*NUMSPECIES;i++)
   {
       ScriviStringa(num, sizeof(num), "%d", i);
       entry = lookup_widget(cell_dlg, num);
       gtk_editable_delete_text(GTK_EDITABLE(entry), 0, -1);
       if(num_in_cell[i/2])
       {
          if(i%2)
             gtk_entry_set_text(GTK_ENTRY(entry), g_strdup_printf("%d", 
                             num_in_cell[i/2]));
          else
             gtk_entry_set_text(GTK_ENTRY(entry), elem_in_cell[i/2]);
       }
  }
}

int c_endcellcontent(char *lpspec, int num_in_cell[])
{
   int ier, lstr;

   lstr = (int) strlen(lpspec);
   ier = new_cell_content_(lpspec, num_in_cell, lstr);
   return ier;
}

void end_cellc(GtkButton *button, gpointer data)
{
   GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
   GtkWidget *entry;
   char num[SYMLEN+1], num1[SYMLEN+1];
   int i, jfill, jloop;

   *pspec = '\0';
   jloop = 1;

   for(i=0; (i<2*NUMSPECIES) && jloop;i+=2)
   {
       jfill = 0;
       ScriviStringa(num, sizeof(num), "%d", i);
       entry = lookup_widget(GTK_WIDGET(button), num);
       if(strlen(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1)) >0)
       {
          jfill++;
          ScriviStringa(num, sizeof(num), "%-4.4s", 
             gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
          ScriviStringa(num1, sizeof(num1), "%-4.4s", 
             gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
          AppendiStringa(pspec, sizeof(vspec), num);
       }
       else
          AppendiStringa(pspec, sizeof(vspec), "    ");
       ScriviStringa(num, sizeof(num), "%d", i+1);
       entry = lookup_widget(GTK_WIDGET(button), num);
       if(strlen(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1)) >0)
          num_in_cell[i/2] = (int)
            atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
       else
          num_in_cell[i/2] = 0;
       if(num_in_cell[i/2] > 0)
          jfill++;
       if(jfill % 2)
          jloop = 0;
   }
   if(jloop == 0)
   {
      gtk_widget_set_sensitive(dlg, FALSE);
      MessageDialog(dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
           "You should supply number in cell for species '%s'.", num1);
      gtk_widget_set_sensitive(dlg, TRUE);
      return;
   }
//   if(jloop )
//   {
//    (void) printf("%s\n", pspec);
      gtk_widget_set_sensitive(dlg, FALSE);
      i = c_endcellcontent(pspec, num_in_cell);
      gtk_widget_set_sensitive(dlg, TRUE);
      if(!i)
         close_dlg(button, GINT_TO_POINTER(1));
      else
         fill_cell_dlg();
//   }
}

GtkWidget *create_cellc (void)
{
  GtkWidget *window1;
  GtkWidget *vbox;
  GtkWidget *table;
  GtkWidget *label;
  GtkWidget *entry;
  GtkWidget *button;
  int i;
  char num[5];

  window1 = gtk_dialog_new ();
  g_object_set_data (G_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), "New Cell Content");
  gtk_window_set_position (GTK_WINDOW(window1), GTK_WIN_POS_MOUSE);
  gtk_container_set_border_width(GTK_CONTAINER(window1), 10);
  gtk_widget_set_size_request (window1, 330, 250);

  vbox = gtk_dialog_get_content_area(GTK_DIALOG(window1));

  GtkWidget *scrollwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_box_pack_start (GTK_BOX (vbox), scrollwin, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollwin),
                                   GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);
  gtk_container_set_border_width(GTK_CONTAINER(scrollwin), 8);
  gtk_widget_show (scrollwin);

  table = table_new (NUMSPECIES+1, 2, FALSE);
  gtk_widget_show (table);
  add_to_scrollwin(scrollwin, table);
  gtk_container_set_border_width(GTK_CONTAINER(table), 5);
  table_set_col_spacings(table, 12);
  table_set_row_spacings(table, 6);

  label = LABEL_BOLD("Atomic species", LABELCOLOR, 1.2f);
  gtk_widget_show (label);
  set_alignment(label, 0.5, 0.5);
  table_attach(table, label, 0, 1, 0, 1);

  label = LABEL_BOLD("Number in cell", LABELCOLOR, 1.2f);
  gtk_widget_show (label);
  set_alignment(label, 0.5, 0.5);
  table_attach(table, label, 1, 2, 0, 1);

  for(i=0; i<2*NUMSPECIES; i++)
  {
      ScriviStringa(num, sizeof(num), "%d", i);
      entry = gtk_entry_new();
      g_object_set_data (G_OBJECT (window1), num, entry);
      gtk_widget_set_size_request(entry, 90, 24);
      gtk_widget_show (entry);
      if(i%2)
      {
         int hnd =  g_signal_connect(G_OBJECT(entry), "insert-text",
                    G_CALLBACK(check_numeric), NULL);
         g_object_set_data(G_OBJECT(entry), "hnd", GINT_TO_POINTER(hnd));
      }
      table_attach_all(table, entry, i%2, i%2+1, i/2+1, i/2+2);
  }

  button = myimage_button("   _OK", "ok.png");
  gtk_widget_show (button);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button, 1);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
                     G_CALLBACK(end_cellc), NULL);

  button = myimage_button("  _Cancel", "cancel.png");
  gtk_widget_show (button);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button, 2);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
                     G_CALLBACK(close_dlg), GINT_TO_POINTER(1));
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
           GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect_swapped(G_OBJECT(window1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button)); 
  (void) g_signal_connect (G_OBJECT (window1), "delete_event",
                      G_CALLBACK(true_cb), NULL);
  return window1;

}

void open_cellc (GtkWidget *widget, gpointer data)
{
  int ele[NUMSPECIES];
  int n = get_cell_content_(ele, num_in_cell);
  for(int i=0; i<NUMSPECIES; i++)
  {
      if(elem_in_cell[i])
         g_free(elem_in_cell[i]);
  }
  for(int i=0; i<n; i++)
      elem_in_cell[i] = g_strdup(get_nth_element(ele[i] - 1));
  if(cell_dlg == NULL)
     cell_dlg = create_cellc();
  fill_cell_dlg();
  gtk_widget_show(cell_dlg);
  finestra_modale_aperta2(cell_dlg);
}

/*****************************************************************/
/*              T A B L E S                                      */
/*****************************************************************/
static GtkWidget *table_dlg = NULL;

static const char *lab_but[] = {"Weights", "Atoms", "Distances", "Angles"};

static float tavola[9];

void end_tables(GtkButton *button, gpointer data)
{
   int i;
   GtkWidget *checkb, *spin;

   for(i=0; i<4;i++)
   {
       checkb = get_widget(table_dlg, lab_but[i]);
       tavola[i] = (float) gtk_toggle_button_get_active
                           (GTK_TOGGLE_BUTTON(checkb));
   }
   spin = get_widget(table_dlg, "minspin");
   tavola[7] = (float) spin_button_get_value(spin);

   spin = get_widget(table_dlg, "maxspin");
   tavola[8] = (float) spin_button_get_value(spin);

   create_tables_(tavola);
}

void abidist(GtkToggleButton *checkb, gpointer data)
{
   GtkToggleButton *b1, *b2;
   gboolean state;

   b1 = GTK_TOGGLE_BUTTON(lookup_widget(GTK_WIDGET(checkb), lab_but[2]));
   b2 = GTK_TOGGLE_BUTTON(lookup_widget(GTK_WIDGET(checkb), lab_but[3]));

   state = gtk_toggle_button_get_active(b1) | gtk_toggle_button_get_active(b2);
   gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET(checkb), "frameDist"),
           state);
}

GtkWidget *create_tables (void)
{
  GtkWidget *window1;
  GtkWidget *vbox;
  GtkWidget *vbox2;
  GtkWidget *hbox;
  GtkWidget *checkbutton;
  GtkWidget *frame;
  GObject *adj;
  GtkWidget *minspin;
  GtkWidget *maxspin;
  GtkWidget *label;
  GtkWidget *button;
  int i;
  static _StyleType style = {true, 1, NULL, GTK_SHADOW_ETCHED_IN, 6, 6, 6, 6};

  window1 = gtk_dialog_new ();
  g_object_set_data (G_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), "Select Tables to produce");
  gtk_window_set_position (GTK_WINDOW(window1), GTK_WIN_POS_MOUSE);
  gtk_container_set_border_width(GTK_CONTAINER(window1), 10);

  vbox = gtk_dialog_get_content_area(GTK_DIALOG(window1));

  hbox = hbox_new(FALSE, 10);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, TRUE, 0);

  frame = NEW_FRAME("Tables", &style);
  gtk_widget_show(frame);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 3);
  gtk_box_pack_start (GTK_BOX (hbox), frame, FALSE, FALSE, 0);

  vbox2 = vbox_new(TRUE, 2);
  gtk_widget_show (vbox2);
  gtk_container_set_border_width(GTK_CONTAINER(vbox2), 4);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), vbox2);

  for(i=0; i<4; i++)
  {
      checkbutton = gtk_check_button_new_with_label (lab_but[i]);
      g_object_set_data (G_OBJECT (window1), lab_but[i], checkbutton);
      gtk_widget_show (checkbutton);
      gtk_box_pack_start (GTK_BOX (vbox2), checkbutton,FALSE, FALSE, 0);
      (void) g_signal_connect(G_OBJECT(checkbutton), "toggled", 
           G_CALLBACK(abidist), GINT_TO_POINTER(i));
  }

  frame = NEW_FRAME ("Distance range", &style);
  g_object_set_data (G_OBJECT (window1), "frameDist", frame);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (hbox), frame, FALSE, FALSE, 4);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 3);
  gtk_widget_set_sensitive(frame, FALSE);

  vbox2 = vbox_new(TRUE, 2);
  gtk_widget_show (vbox2);
  gtk_container_set_border_width(GTK_CONTAINER(vbox2), 4);
  gtk_container_add(GTK_CONTAINER(get_widget(frame, "align")), vbox2);

  label = gtk_label_new ("Min. ");
  gtk_widget_show (label);
  set_alignment(label, 0, 0.5);
  gtk_box_pack_start (GTK_BOX (vbox2), label,FALSE, FALSE, 0);

  adj = adj_new (0.2f, 0.2f, 3.6f, 0.1f, 10.f);
  minspin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 3);
  g_object_set_data (G_OBJECT (window1), "minspin", minspin);
  gtk_widget_show (minspin);
  gtk_box_pack_start (GTK_BOX (vbox2), minspin,FALSE, FALSE, 0);

  label = gtk_label_new ("Max. ");
  gtk_widget_show (label);
  set_alignment(label, 0, 0.5);
  gtk_box_pack_start (GTK_BOX (vbox2), label,FALSE, FALSE, 0);

  adj = adj_new (1.7f, 0.3f, 3.6f, 0.1f, 10.f);
  maxspin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 3);
  g_object_set_data (G_OBJECT (window1), "maxspin", maxspin);
  gtk_widget_show (maxspin);
  gtk_box_pack_start (GTK_BOX (vbox2), maxspin,FALSE, FALSE, 0);

  button = OK_button();
  gtk_widget_show (button);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button, 1);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
                     G_CALLBACK(close_dlg), GINT_TO_POINTER(1));
  (void) g_signal_connect_after(G_OBJECT(button), "clicked",
                     G_CALLBACK(end_tables), NULL);

  button = CANCEL_button();
  gtk_widget_show (button);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button, 2);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
                     G_CALLBACK(close_dlg), GINT_TO_POINTER(1));
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
           GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect_swapped(G_OBJECT(window1), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button)); 
  (void) g_signal_connect (G_OBJECT (window1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return window1;

}

void open_tables (GtkWidget *widget, gpointer data)
{
  int i;

  if(table_dlg == NULL)
     table_dlg = create_tables();
  for(i=0; i<4; i++)
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(get_widget
       (table_dlg, lab_but[i])), FALSE);
  spin_button_set_value(get_widget(table_dlg, "minspin"), 0.2f);
  spin_button_set_value(get_widget(table_dlg, "maxspin"), 1.7f);
  gtk_widget_show(table_dlg);
  finestra_modale_aperta2(table_dlg);
}

/*****************************************************************/
/*    H Y D R O G E N S: Auto, Single,  Wizard  & Delete         */ 
/*****************************************************************/

int       *ind_Atoms;
int       *ifg_Atoms;
int       *sp_Atoms;
int       *spdef_Atoms;
int       *colcell;
float     *dst_Atoms;
std::vector<std::string> lab_Atoms;
std::vector<std::string> def_Atoms;

int    nCarb_eff;
int    selAtom;
static int hybtype = -2;
static int wiz_flag = 0;
static int ifbrk = 0;
static float gdistch = 0.960f;
static int nCarbons = 0;

int open_singlehydro (int wizard, int natom);
void mostra_tbg1(GtkWidget *item, gpointer data);
void cancel_tb (GtkWidget *item, gpointer data);
void c_no_more_crosses();
const char *label_h[] = {"Sp1", "Sp2", "Sp3", 
                       "carbonylic group", "alcoholic group", "water molecule", 
                       " ", " ", "No hydrogens"};
const int  MAXHYB   = (int) (sizeof(label_h)/sizeof(label_h[0]));

void c_autohydro (GtkWidget *item,  gpointer data)
{
   autohydro_();
}

int delh()
{
    int result = MessageDialog(hydro_dlg, GTK_MESSAGE_QUESTION,
        GTK_BUTTONS_OK_CANCEL, "Only generated hydrogens will be deleted.");
    if(result == GTK_RESPONSE_OK)
       return 1;
    else
       return -1;
}

void delete_hydro (GtkWidget *item,  gpointer data)
{
   int flag = delh();
   if(flag != -1)
      delhydro_(&flag);
}

void allocaVettori(int nAtoms)
{
    ind_Atoms   = g_new0(int, nAtoms);
    ifg_Atoms   = g_new0(int, nAtoms);
    sp_Atoms    = g_new0(int, nAtoms);
    spdef_Atoms = g_new0(int, nAtoms);
    colcell     = g_new0(int, nAtoms);
    dst_Atoms   = g_new0(float, nAtoms);
    Info        = g_new0(infohydro_type, nAtoms);
}

void liberaVettori()
{
    g_free(ind_Atoms);
    g_free(ifg_Atoms);
    g_free(sp_Atoms);
    g_free(spdef_Atoms);
    g_free(colcell);
    g_free(dst_Atoms);
    g_free(Info);
}

int No(int natom)
{
   int jatom = natom;
   return noforc_(&jatom);
}

int fillAtomsInfo(int natoms, int ifWizard)
{
    int jAtom, kind, *spdef, Spd;
    void c_init_becca_punti (int qualebecca);

//    if(ifWizard)
       c_init_becca_punti(26);
    spdef = g_new0(int, natoms);
    allocaVettori(natoms);
    lab_Atoms.clear();
    def_Atoms.clear();
    hybtype = -2;
    nCarbons = 0;
    kind = 0;

    newinfo_hydro_(Info);
    natoms = valore_di_nats_();
    for(jAtom=0; jAtom<natoms; jAtom++)
    {
        if(Info[jAtom].nlegati == 0)
           continue;
        Spd = Info[jAtom].nHybcal;
        int max_xsp = MAXHYB;
        if( (Spd > 0) && (Spd <= max_xsp) ) 
        {
           int xsp;

           ind_Atoms[kind] = jAtom + 1;
           sp_Atoms[kind]  = Spd;                  // codice predefinito
           spdef_Atoms[kind]  = Spd;
           ifg_Atoms[kind] = Info[jAtom].nHybut;  // codice eventualmente definito dall'utente
           if(ifg_Atoms[kind])
              xsp = ifg_Atoms[kind];
           else
              xsp = Spd;
           if((xsp >= 0) && (xsp <= max_xsp) )
           {
              lab_Atoms.push_back(Info[jAtom].lab);
              def_Atoms.push_back(" ");
              if(xsp)
                 def_Atoms[kind].assign(label_h[xsp-1]);
              kind++;
           }
           else if (xsp != MAXHYB)      //c'e' qualcosa che non va
           {
               MessageDialog(hydro_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
               "Illegal value for Sp: '%d' (Atom %s).", xsp,Info[jAtom].lab);
           }
        }
    } 
    g_free(spdef);
    return kind;
}
void singlehydro(GtkWidget *item, gpointer data)
{
    int ier;
    checkghostsforc_(&ier);
    if(ier)
       return;
    if(ifhydrogens_())
    {
       int natoms = valore_di_nats_();
       nCarb_eff = fillAtomsInfo(natoms, 0);
       mostra_tbg1(item, data);
    }
}

int atom_to_list(int jAtom)
{
  int i;
 
  for(i=0; i<nCarb_eff; i++)
     if(ind_Atoms[i] == jAtom)
       return i;
  return -1;
}

int c_hydro (int wizard, int atom, char *label1, char *label2,int *nhyb,
             float *distch)
{
    int ier;

    multistringa2 ms;
    ms.n1 = (int) strlen(label1) + 1;
    ms.n2 = (int) strlen(label2) + 1;
    CopiaStringa(ms.str1, ms.n1, label1);
    CopiaStringa(ms.str2, ms.n2, label2);

    ier = init_hydro_(&wizard, &atom, &ms, nhyb, distch);
    CopiaStringan(label1, ms.n1, ms.str1, ms.n1-1);
    CopiaStringan(label2, ms.n2, ms.str2, ms.n2-1);
    label1[ms.n1-1] = '\0';
    label2[ms.n2-1] = '\0';
    return ier;
}

int c_finish_hydro (int atom, int nhyb, int nhyd, int wizard, float distch)
{
    int ier = finish_hydro_(&atom, &nhyb, &nhyd, &wizard, &distch);
    return ier;
}
void cancel_hydro (GtkWidget *item, gpointer data)
{
   liberaVettori();
    cancel_tb (item, data);
}

void whydro(GtkWidget *item, gpointer data)
{
    int ier;
    checkghostsforc_(&ier);
    if(ier)
       return;
    int i, natom, natoms, wizard = 1;

    if(ifcarbons_xc_() && ifhydrogens_())
    {
       natoms = valore_di_nats_();
       nCarbons = 0;
       ifbrk = 0;
       nCarb_eff = fillAtomsInfo(natoms, 1);
       if(!nCarb_eff)
       {
          return;
       }
       selAtom = 0;
       while (!ifbrk)
       {
           if(selAtom >= nCarb_eff) 
              ifbrk = 1;
           else
           {
              if(selAtom < 0) 
                 selAtom = 0;
              natom = ind_Atoms[selAtom];
              i = open_singlehydro(wizard, natom);
              if(i)
                 ifbrk = 1;                //qualcuno ha fatto casino (e non sono io)
          }
       }
       if(gtk_widget_get_visible(hydro_dlg))
       {
          gtk_widget_hide(hydro_dlg);
          finestra_modale_chiusa2();
       }
       if(nCarbons > 0)
          i = MessageDialog(hydro_dlg, GTK_MESSAGE_QUESTION, GTK_BUTTONS_YES_NO,
              "Do you want to (re)generate hydrogens?");
       else
          i = GTK_RESPONSE_NO;
       c_no_more_crosses();
       if(i == GTK_RESPONSE_YES)
          i = 1;
       else
          i = 0;
//      i=0 -->Cancel   i=1 -->Ok
       generaidrogeni_(&i);
       liberaVettori();
    }
}

void set_complete_line(GtkWidget *list, gpointer line, gpointer fixed, int nrow)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    GtkTreePath *path;
    int  formato;
    char num[6];

    formato = get_int(GTK_WIDGET(list), "formato");
    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    ScriviStringa(num, sizeof(num), "%d", nrow);
    path = gtk_tree_path_new_from_string(num);
    if(gtk_tree_model_get_iter (GTK_TREE_MODEL(list_store), &iter, path))
    {
       if(formato == 0)
          gtk_list_store_set (list_store, &iter, 0, line, -1);
       else if(formato < 3)
          gtk_list_store_set (list_store, &iter, 0, line, 1, fixed, -1);
       else if(formato < 10)
          gtk_list_store_set (list_store, &iter, 0, fixed, 1, line, -1);
       else
          gtk_list_store_set (list_store, &iter, 0, fixed, 2, line, -1);
    }
}

void end_singlehydro (GtkButton *button, gpointer data)
{
  GtkWidget *rb, *list;
  int ok;
  char num[5], *rigalist;
  int i;
  int natom, ier, nhyd;
  GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));

  ok = GPOINTER_TO_INT(data);
  rb = lookup_widget(hydro_dlg, "c-hdist");
  gdistch = (float) spin_button_get_value(rb);
  hybtype = ok;
  int add_type = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(
       get_widget(dlg, "geobutton")));
  switch(ok)
  {
  case 1:                             // accept
     natom = ind_Atoms[selAtom];
     if (add_type == 0)
     {
         GtkWidget *add = get_widget(dlg, "add");
         statofinale[1] = spin_button_get_value_as_int(add);
         add = get_widget(dlg, "level");
         statofinale[2] = (int) (10. * spin_button_get_value(add) + 0.5 );
         add = get_widget(dlg, "ifViewmap");
         statofinale[3] = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(add));
         statofinale[4] = 2;
         add = get_widget(dlg, "step");
         statofinale[5] = (int) (100. * spin_button_get_value(add) + 0.5 );
         statofinale[6] = 1;

         gtk_widget_hide (dlg);
         fortran_al_lavoro();    
         startfourier_ (&ier, statofinale);
         clsqgtk->ifCubo = -1;
         if(ier)
            fine_lavoro();
         ridisegna_();
         if(ier != 100)
            gtk_main();
         gtk_widget_show (dlg);
     }
     else
     {
         for(i=1; i<=MAXHYB; i++)
         {
             ScriviStringa(num, sizeof(num), "Sp%d", i);
             rb = lookup_widget (GTK_WIDGET(button), num);
             if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(rb)))
             {
                hybtype = i;
                sp_Atoms[selAtom] = hybtype;
                dst_Atoms[selAtom] = gdistch;
                def_Atoms[selAtom].assign(label_h[hybtype-1]);
             }
         }
         rb = lookup_widget(hydro_dlg, "nhydut");
         nhyd = spin_button_get_value_as_int(rb);
         ier = c_finish_hydro(natom, hybtype, nhyd, wiz_flag, gdistch);
         if(ier)
            g_print("Errore da geometriac\n");
     }
     if(!ier && wiz_flag)
     {
        list = lookup_widget(hydro_dlg, "listahydro");
//        rigalist = g_strdup_printf("%.8s Sp%d", lab_Atoms[selAtom][0], hybtype);
        rigalist = g_strdup_printf("%.16s %s", lab_Atoms[selAtom].c_str(), def_Atoms[selAtom].c_str());
        set_complete_line(list, (gpointer) rigalist, GINT_TO_POINTER(1), selAtom);
        if(sp_Atoms[selAtom] != spdef_Atoms[selAtom])
        {
           set_cell_color(list,selAtom,0, "red");
           colcell[selAtom] = 2;
        }
        else
        {
           set_cell_color(list,selAtom,0, "blue");
           colcell[selAtom] = 1;
        }
        nCarbons++;
        selAtom++;
     }
     break;
  case 0:
     if(wiz_flag)
        nCarbons = 0;
     ifbrk = 1;
  case -1:
     selAtom++;
     break;
  case -2:
     selAtom--;
     break;
  case -3:
     ifbrk = 1;
     break;
  }
  if(!wiz_flag || !ok)
     close_dlg(button, GINT_TO_POINTER(1));
  if(!wiz_flag)
     mostra_tbg1(NULL, (gpointer) "Single");
  gtk_main_quit();
}

static void sel_carb (GtkTreeSelection *selec, GtkWidget *lista)
{
   selAtom = row_selected(selec);
   if(selAtom != -1)
   {
      hybtype = 0;
      gtk_main_quit(); //   gianlucagianluca 
   }
   else
      selAtom = 0;
}

static gboolean cb_sele(GtkTreeSelection *selection, GtkTreeModel *model,
                        GtkTreePath *path, gboolean path_currently_selected,
                        GtkWidget *list)
{
    int row = atoi(gtk_tree_path_to_string(path));;

    if(path_currently_selected)
    {
        if(colcell[row] == 1)
           set_cell_color(list, row, 0, "blue");
        else if(colcell[row] == 2)
           set_cell_color(list, row, 0, "red");
        else
           set_cell_color(list, row, 0, "black");
    }
    else
        if(colcell[row] == 1)
           set_cell_color(list, row, 0, "#ccccff");
        else if(colcell[row] == 2)
           set_cell_color(list, row, 0, "#ffcccc");
        else
           set_cell_color(list, row, 0, "white");
    return TRUE;
}

void on_hyb_changed(GtkToggleButton *button, gpointer data)
{ 
  if(gtk_toggle_button_get_active(button))
  {
     GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(button));
     GtkWidget *label = lookup_widget(dlg, "nhydut");
     int iatom = get_int(label, "natom");
     int z = No(iatom);
     int newhyb = GPOINTER_TO_INT(data);
     int maxleg = 0;
     switch(z)
     {
            case 5:                     // Boron
            case 6:                     // Carbon
                 maxleg = newhyb + 1;
                 break;
            case 7:                     // Nitrogen
                 maxleg = newhyb;
                 break;
            case 8:                     // Oxygen
                 if(newhyb < MAXHYB)
                    maxleg = newhyb - 3;
                 break;
     }
     maxleg -= Info[iatom-1].nlegati;
     if((maxleg < 0) || newhyb == 9)
        maxleg = 0;
     if(z == 7)
     {
        spin_button_set_range(label, maxleg, maxleg+1);
        gtk_editable_set_editable(GTK_EDITABLE(label), TRUE);
     }
     else
     {
        spin_button_set_range(label, maxleg, maxleg);
        gtk_editable_set_editable(GTK_EDITABLE(label), FALSE);
     }
     spin_button_set_value(label, maxleg);
  }
}

void help_hydro(GtkButton *button, gpointer data)
{
    open_htm("Refine.html#hydrogens");
}

GtkWidget* create_singlehydro (void)
{
  GtkWidget *window1;
  GtkWidget *align;
  GtkWidget *vbox1;
  GtkWidget *vbox2;
  GtkWidget *w_vbox;
  GSList *group = NULL;
  GtkWidget *radiobutton;
  GtkWidget *hbox;
  GtkWidget *hbox1;
  GtkWidget *button;
  GtkWidget *label;
  GtkWidget *lista;
  GtkWidget *frame;
  GtkWidget *spin;
  char num[20];
  int i;
  float fsize = 1.2f;

  PangoFontDescription *desc = get_fontN (MONOSPACE_FONT, 1);
  int w1, h1;
  get_metrics(desc, &w1, &h1);

  PangoFontDescription *newfdesc = get_font (1.2);

  window1 = gtk_dialog_new ();
  gtk_container_set_border_width(GTK_CONTAINER(window1), 8);

  w_vbox = gtk_dialog_get_content_area(GTK_DIALOG(window1));
  gtk_container_set_border_width(GTK_CONTAINER(w_vbox), 4);

  hbox1 = hbox_new(FALSE, 2);
  gtk_box_pack_start (GTK_BOX (w_vbox), hbox1, FALSE, FALSE, 0);
  g_object_set_data (G_OBJECT (window1), "hbox", hbox1);

#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_START, GTK_ALIGN_FILL, FALSE, TRUE);
#else
  align = gtk_alignment_new(0., 0., 0, 1);
#endif
  gtk_box_pack_start (GTK_BOX (hbox1), align, FALSE, FALSE, 0);
  vbox1 = vbox_new(FALSE, 4);
  gtk_container_add (GTK_CONTAINER (align), vbox1);
  g_object_set_data (G_OBJECT (window1), "vbox1", vbox1);

  vbox2 = vbox_new(FALSE, 4);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox2, FALSE, FALSE, 0);
  g_object_set_data (G_OBJECT (window1), "vbox2", vbox2);
  gtk_container_set_border_width(GTK_CONTAINER(vbox2), 6);

  frame = FRAME_BOLD("Distances &amp; Angles", FRAMECOLOR, fsize);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, FALSE, FALSE, 4);

  label = scrolled_text_new(frame);
  g_object_set_data (G_OBJECT (window1), "hlabel2", label);
  GtkTextBuffer *tb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(label));
  gtk_text_buffer_create_tag (tb, "myfont",
                              "font-desc", desc, NULL);

  GSList *group1 = NULL;
  frame = gtk_frame_new(NULL);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, FALSE, FALSE, 4);
  g_object_set_data (G_OBJECT (window1), "frame_geo", frame);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 4);

  radiobutton = RADIO_BUTTON_WITH_LABEL(group1, "by geometric considerations", LABELCOLOR);
  g_object_set_data (G_OBJECT (window1), "geobutton", radiobutton);
  g_object_ref(radiobutton);
  widget_modify_font(gtk_bin_get_child(GTK_BIN(radiobutton)), newfdesc);
  group1 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
  gtk_frame_set_label_widget(GTK_FRAME(frame), radiobutton);
  GtkWidget *vbox3 = vbox_new(FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame), vbox3);
  g_signal_connect(G_OBJECT(radiobutton), "toggled", G_CALLBACK(on_cb_attiva), vbox3);


  label = gtk_label_new("");
  g_object_set_data (G_OBJECT (window1), "hlabel1", label);
  gtk_box_pack_start (GTK_BOX (vbox3), label, FALSE, FALSE, 2);
  set_alignment(label, 0.5,0.5);
  widget_modify_font(label, desc);
  gtk_widget_set_size_request(label, w1*50, -1);

  label = gtk_label_new("");
  g_object_set_data (G_OBJECT (window1), "hlabel3", label);
  gtk_box_pack_start (GTK_BOX (vbox3), label, FALSE, FALSE, 4);
  set_alignment(label, 0.5,0.5);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_CENTER);

  hbox = table_new(2, 2, FALSE);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox, TRUE, TRUE, 0);

  GtkSizeGroup *sz = gtk_size_group_new(GTK_SIZE_GROUP_HORIZONTAL);
  spin = SPIN_WITH_LABEL("H Distance", NULL, 0.f, 3.f, 0.960f, 0.01f, 3);
  g_object_set_data (G_OBJECT (window1), "c-hdist", get_widget(spin, "spin"));
  gtk_size_group_add_widget(sz, get_widget(spin, "label"));
  table_attach (hbox, spin, 1, 2, 0, 1, true);

  spin = SPIN_WITH_LABEL("Nr. of Hydrogens", NULL, 0, 3, 1, 1, 0);
  g_object_set_data (G_OBJECT (window1), "nhydut", get_widget(spin, "spin"));
  gtk_size_group_add_widget(sz, get_widget(spin, "label"));
  table_attach (hbox, spin, 1, 2, 1, 2, true);

  GtkWidget *vbox4 = vbox_new(FALSE, 0);
  table_attach (hbox, vbox4, 0, 1, 0, 2, true);
  for(i=1; i<=MAXHYB; i++)
  {
     ScriviStringa(num, sizeof(num), "Sp%d", i);
     radiobutton = RADIO_BUTTON_WITH_LABEL(group, num, NULL);
     g_object_set_data (G_OBJECT (window1), num, radiobutton);
     ScriviStringa(num, sizeof(num), "labelSp%d", i);
     gtk_box_pack_start (GTK_BOX (vbox4), radiobutton, FALSE, FALSE, 1);
     g_object_set_data (G_OBJECT (window1), num, gtk_bin_get_child(GTK_BIN(radiobutton)));
     group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
     g_signal_connect(G_OBJECT(radiobutton), "toggled", G_CALLBACK(on_hyb_changed), GINT_TO_POINTER(i));
  }
  frame = gtk_frame_new(NULL);
  gtk_box_pack_start (GTK_BOX (vbox1), frame, FALSE, FALSE, 4);
  g_object_set_data (G_OBJECT (window1), "frame_four", frame);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 4);

  radiobutton = RADIO_BUTTON_WITH_LABEL(group1, "by Fourier", LABELCOLOR);
  group1 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radiobutton));
  gtk_frame_set_label_widget(GTK_FRAME(frame), radiobutton);
  widget_modify_font(gtk_bin_get_child(GTK_BIN(radiobutton)), newfdesc);
  vbox3 = vbox_new(FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame), vbox3);
  gtk_widget_set_sensitive(vbox3, FALSE);
  g_signal_connect(G_OBJECT(radiobutton), "toggled", G_CALLBACK(on_cb_attiva), vbox3);

  hbox = hbox_new(FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox, TRUE, TRUE, 0);

  frame = frame_fourier_t (window1);
  gtk_box_pack_start (GTK_BOX (hbox), frame, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 4);

  frame = frame_fourier_c (window1);
  gtk_box_pack_end (GTK_BOX (hbox), frame, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 4);

  hbox = hbox_new(FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox, TRUE, TRUE, 0);

  spin = SPIN_WITH_LABEL("Grid Step", NULL, 0.1, 0.5, 0.2, 0.01, 2);
  gtk_box_pack_start (GTK_BOX (hbox), spin, TRUE, TRUE, 0);
  gtk_widget_show_all (spin);
  g_object_set_data (G_OBJECT (window1), "step", get_widget(spin, "spin"));
  gtk_container_set_border_width(GTK_CONTAINER(spin), 4);

  GtkWidget *check = CHECK_BUTTON_WITH_LABEL ("View Fourier map", NULL);
  gtk_widget_show (check);
  g_object_set_data (G_OBJECT (window1), "ifViewmap", check);
  gtk_box_pack_end (GTK_BOX (hbox), check, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(check), 4);

// wizard
  lista = createSelection(window1, vbox2, NULL, "listahydro", 2, "yellow");
  GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(lista), 1);
  gtk_tree_view_column_set_fixed_width(column, 4);  //250309
  gtk_tree_view_column_set_visible (column, FALSE); //250309

  gtk_tree_selection_set_mode (gtk_tree_view_get_selection (GTK_TREE_VIEW (lista)),
				   GTK_SELECTION_SINGLE);
  gtk_tree_selection_set_select_function (gtk_tree_view_get_selection(GTK_TREE_VIEW(lista)),
                                         (GtkTreeSelectionFunc) cb_sele,
                                          lista, NULL);
  int hnd = g_signal_connect(G_OBJECT(gtk_tree_view_get_selection (GTK_TREE_VIEW (lista))),
        "changed", G_CALLBACK(sel_carb), lista);
  g_object_set_data(G_OBJECT(lista), "hnd", GINT_TO_POINTER(hnd));
#ifdef IN_GTK3
  align = new_alignment(GTK_ALIGN_FILL, GTK_ALIGN_END, TRUE, FALSE);
#else
  align = gtk_alignment_new(0.5, 1., 1, 0);
#endif
  gtk_box_pack_end (GTK_BOX (vbox2), align, FALSE, FALSE, 0);
  GtkWidget *hb = hbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(align), hb);
  gtk_container_set_border_width(GTK_CONTAINER(hb), 6);
  
  button = HELP_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button, 1);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
           G_CALLBACK(help_hydro), NULL);

  button = myimage_button ("  _Accept", "apply.png");
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button, 2);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
           G_CALLBACK(end_singlehydro), GINT_TO_POINTER(1));

//  button = myimage_button ("  _Previous", "previousgr.png");
  button = xpm_button ("previousgr.png");
  gtk_box_pack_start(GTK_BOX(hb), button, FALSE, FALSE, 0);
  g_object_set_data(G_OBJECT(window1), "previous", button);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
      G_CALLBACK(end_singlehydro), GINT_TO_POINTER(-2));

//  button = myimage_button ("  _Next", "nextgr.png");
  button = xpm_button ("nextgr.png");
  gtk_box_pack_end(GTK_BOX(hb), button, FALSE, FALSE, 0);
  g_object_set_data(G_OBJECT(window1), "skip", button);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
      G_CALLBACK(end_singlehydro), GINT_TO_POINTER(-1));

  button = myimage_button ("  _Stop", "stopb.png");
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button, 3);
  g_object_set_data(G_OBJECT(window1), "stop", button);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
      G_CALLBACK(end_singlehydro), GINT_TO_POINTER(-3));

  button = CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), button, 4);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
           G_CALLBACK(end_singlehydro), GINT_TO_POINTER(0));

  (void) g_signal_connect_swapped(G_OBJECT(window1), "delete_event",
           G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
  (void) g_signal_connect (G_OBJECT (window1), "delete_event",
                      G_CALLBACK(true_cb), NULL);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
           GTK_BUTTONBOX_SPREAD);

  return window1;
}

void add_complete_line_to_list(GtkWidget *list, gpointer line, gpointer fixed)
{
    GtkListStore *list_store;
    GtkTreeIter iter;
    int  formato;

    formato = get_int(GTK_WIDGET(list), "formato");
    list_store = GTK_LIST_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(list)));
    gtk_list_store_append (list_store, &iter);
    if(formato == 0)
       gtk_list_store_set (list_store, &iter, 0, line, -1);
    else if(formato < 3)
       gtk_list_store_set (list_store, &iter, 0, line, 1, fixed, -1);
    else if(formato < 10)
       gtk_list_store_set (list_store, &iter, 0, fixed, 1, line, -1);
    else
       gtk_list_store_set (list_store, &iter, 0, fixed, 2, line, -1);

}

void set_text(GtkWidget *widget, char *testo)
{
   GtkTextBuffer *tb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(widget));
   GtkTextIter iter1, iter2;
   gtk_text_buffer_get_bounds (tb, &iter1, &iter2);
   gtk_text_buffer_delete(tb, &iter1, &iter2);
   gtk_text_buffer_insert_with_tags_by_name (tb, &iter1, testo, -1,
       "myfont", "wide_margins", NULL);
}

int open_singlehydro (int wizard, int natom)
{
  int nhyb, ier, i;
  float  distch;
  GtkWidget *label, *box;
  char *rigalist;
  char *str1 = g_new0(char, LAB_LEN + 1);
  char *str2 = g_new0(char, 800);
  char testo[100], hint[100];

  wiz_flag  = wizard;
  memset(str1, ' ', LAB_LEN*sizeof(char));
  memset(str2, ' ', 799*sizeof(char));
  memset(testo, ' ', 99*sizeof(char));
  memset(hint, ' ', 99*sizeof(char));
  testo[99] = '\0';
  hint [99] = '\0';

  ier = 0;
  if(hydro_dlg == NULL)
     hydro_dlg = create_singlehydro();
    
  label = lookup_widget(hydro_dlg, "nhydut");
  g_object_set_data(G_OBJECT(label), "natom", GINT_TO_POINTER(natom));
  ier = c_hydro(wizard, natom, str1, str2, &nhyb, &distch);   

  if(!ier)
  {
     i = atom_to_list(natom);
// Se siamo in single e qualcosa non torna
     if(i == -1)
     {
        MessageDialog(hydro_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "Problems with atom %d", natom);
        return -1;
     }

     std::stringstream Msg;
     Msg << "C'e' qualcosa che non va!\n";
     Msg << "Dopo init_hydro\n" "natom = " << natom << " ("
          <<  str1 << ")\n";
     Msg << "Error = " << ier << "\n" ;
     Msg << "distch = " << distch << "\n" << "nhyb = " << nhyb <<"\n";
     Msg << "Distances and Angles\n";
     Msg << str2 << "\n";
     i = atom_to_list(natom);
     int z = No(natom);
     if( (nhyb > 0) && (nhyb <= MAXHYB) )  
     {
        switch(z)
        {
            case 5:                     // Boron
            case 6:                     // Carbon
                 ScriviStringa(testo, sizeof(testo), 
                       "Select the hybridization for %s ", g_strstrip(str1));
                 ScriviStringa(hint, sizeof(hint), "Defined as %s - Hint: %s", 
                          def_Atoms[i].c_str(), label_h[nhyb-1]);
                 break;
            case 7:                     // Nitrogen
                 ScriviStringa(testo, sizeof(testo), 
                       "Select the hybridization and\nthe number of hydrogens for %s", 
                       g_strstrip(str1));
                 ScriviStringa(hint, sizeof(hint), "Defined as %s - Hint: %s",
                          def_Atoms[i].c_str(), label_h[nhyb-1]);
                 break;
            case 8:                     // Oxygen
                 ScriviStringa(testo, sizeof(testo), 
                       "Select the n. of hydrogens to be generated for %s", 
                       g_strstrip(str1));
                 ScriviStringa(hint, sizeof(hint), "Defined as %s - Hint: %s",
                          def_Atoms[i].c_str(), label_h[nhyb-1]);
                 break;
        }
        label = lookup_widget(hydro_dlg, "vbox1");
        gtk_widget_show(label);

        label = lookup_widget(hydro_dlg, "hlabel1");
        set_label_text(label, testo, LABELCOLOR);

        label = lookup_widget(hydro_dlg, "hlabel2");
        set_text(label, str2);
//        gtk_label_set_text(GTK_LABEL(label), str2);

        label = lookup_widget(hydro_dlg, "hlabel3");
        set_label_text(label, hint, LABELCOLOR);

        ScriviStringa(testo, sizeof(testo), "Sp%d", nhyb);
        label = lookup_widget(hydro_dlg, testo);
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(label), TRUE);
        for(i=0; i<MAXHYB; i++)
        {
             ScriviStringa(testo, sizeof(testo), "labelSp%d", i+1);
             label = lookup_widget(hydro_dlg, testo);
             gtk_label_set_text(GTK_LABEL(label), label_h[i]);
        }
        label = lookup_widget(hydro_dlg, "c-hdist");
        spin_button_set_value(label, distch);
        label = lookup_widget(hydro_dlg, "nhydut");
        i = natom - 1;
        int n_id = Info[i].nHydcal;
        if(z == 7)
        {
           spin_button_set_range(label, n_id, n_id+1);
           gtk_editable_set_editable(GTK_EDITABLE(label), TRUE);
        }
        else
        {
           spin_button_set_range(label, n_id, n_id);
           gtk_editable_set_editable(GTK_EDITABLE(label), FALSE);
        }
        spin_button_set_value(label, Info[i].nHydcal);
        label = get_widget(hydro_dlg, "add");
        spin_button_set_value(label, (float)n_id);
        label = get_widget(hydro_dlg, "level");
        spin_button_set_value(label, 1.f);
        label = get_widget(hydro_dlg, "fobs");
        gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(label), TRUE);
//        gtk_widget_set_sensitive(label, (z == 7));

        if(!gtk_widget_get_visible(hydro_dlg))
        {
            gtk_widget_show_all(hydro_dlg);
            finestra_modale_aperta2(hydro_dlg);
            label = lookup_widget(hydro_dlg, "geobutton");
            gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(label), TRUE);
            if(!wizard)
            {
               selAtom = atom_to_list(natom);
               label = lookup_widget(hydro_dlg, "skip");
               gtk_widget_hide(label);
               label = lookup_widget(hydro_dlg, "stop");
               gtk_widget_hide(label);
               label = lookup_widget(hydro_dlg, "previous");
               gtk_widget_hide(label);
               label = lookup_widget(hydro_dlg, "vbox2");
               gtk_widget_hide(label);
               label = lookup_widget(hydro_dlg, "vbox1");
               box = lookup_widget(hydro_dlg, "hbox");
               gtk_box_set_child_packing(GTK_BOX(box), label, TRUE, TRUE, 6, GTK_PACK_START);
               label = lookup_widget(hydro_dlg, "frame_geo");
               if( gtk_frame_get_label_widget(GTK_FRAME(label)) == NULL)
                   gtk_frame_set_label_widget(GTK_FRAME(label), 
                      lookup_widget(hydro_dlg, "geobutton"));
               gtk_window_set_title (GTK_WINDOW (hydro_dlg), "Hydrogens");
            }
            else
            {
               gtk_window_set_title (GTK_WINDOW (hydro_dlg), "H - Wizard");
               label = lookup_widget(hydro_dlg, "vbox1");
               box = lookup_widget(hydro_dlg, "hbox");
               gtk_box_set_child_packing(GTK_BOX(box), label, FALSE, FALSE, 6, GTK_PACK_START);
               label = lookup_widget(hydro_dlg, "frame_four");
               gtk_widget_hide(label);
               label = lookup_widget(hydro_dlg, "frame_geo");
               gtk_frame_set_label_widget(GTK_FRAME(label), NULL); 
               label = lookup_widget(hydro_dlg, "listahydro");
               clear_list(label);

               for(i=0; i<nCarb_eff; i++)
               {
                   colcell[i] = 1;
//250309                colcell[i] = 0;
                   rigalist = g_strdup_printf("%.16s %s", lab_Atoms[i].c_str(), def_Atoms[i].c_str());
                   add_complete_line_to_list(label, (gpointer) rigalist, 
                    GINT_TO_POINTER(ifg_Atoms[i]));
                   if(ifg_Atoms[i] == 0)
                      set_cell_color(label, i, 0, "blue");
//250309                   set_cell_color(label, i, 0, "black");
                   else if(ifg_Atoms[i] != spdef_Atoms[i])
                   {
                      set_cell_color(label, i, 0, "red");
                      colcell[i] = 2;
                   }
                   else
                   {
                      set_cell_color(label, i, 0, "blue");
                      colcell[i] = 1;
                   }
               }
            }
        }
        switch(z)
        {
        case 5:       // Boron
        case 6:       // Carbon
             for(i=1; i<MAXHYB; i++)
             {
                 ScriviStringa(testo, sizeof(testo), "Sp%d", i);
                 label = lookup_widget(hydro_dlg, testo);
                 if(i < 4)
                    gtk_widget_show(label);
                 else
                    gtk_widget_hide(label);
             }
             ScriviStringa(testo, sizeof(testo), "Sp9");
             label = lookup_widget(hydro_dlg, testo);
             gtk_widget_show(label);
             break;
        case 7:      // Nitrogen
             ScriviStringa(testo, sizeof(testo), "Sp1");
             label = lookup_widget(hydro_dlg, testo);
             gtk_widget_hide(label);
             for(i=2; i<MAXHYB; i++)
             {
                 ScriviStringa(testo, sizeof(testo), "Sp%d", i);
                 label = lookup_widget(hydro_dlg, testo);
                 if(i < 4)
                    gtk_widget_show(label);
                 else
                    gtk_widget_hide(label);
             }
             ScriviStringa(testo, sizeof(testo), "Sp9");
             label = lookup_widget(hydro_dlg, testo);
             gtk_widget_show(label);
             break;
        case 8:      // Oxygen
             for(i=1; i<=MAXHYB; i++)
             {
                 ScriviStringa(testo, sizeof(testo), "Sp%d", i);
                 label = lookup_widget(hydro_dlg, testo);
                 if((i >= 4) && (i != 7) && (i != 8) )
                    gtk_widget_show(label);
                 else
                    gtk_widget_hide(label);
             }
             break;
        }
        if(wizard)
        {
           label = lookup_widget(hydro_dlg, "listahydro");
           i = atom_to_list(natom);
           int hnd = get_int(label, "hnd");
           g_signal_handler_block(G_OBJECT(gtk_tree_view_get_selection 
                             (GTK_TREE_VIEW (label))), hnd);
           select_row(label, i);
           g_signal_handler_unblock(G_OBJECT(gtk_tree_view_get_selection 
                             (GTK_TREE_VIEW (label))), hnd);
        }
        gtk_window_resize(GTK_WINDOW(hydro_dlg), 2, 2);
        gtk_main();
     }
     else if(!wizard)
     {
        ier = MessageDialog(hydro_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, Msg.str().c_str());
        mostra_tbg1(NULL, (gpointer) "Single");
     }
  }
  else if(!wizard)
  {
     ier = MessageDialog(hydro_dlg, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, str2);
     mostra_tbg1(NULL, (gpointer) "Single");
  }
  g_free(str1);
  g_free(str2);
  return(ier);
}


/*****************************************************************/
/*              A G R E E M E N T                                */
/*****************************************************************/


GtkWidget *agreement_dlg = NULL;
float agr_intervals[10][2];
double agrvet[5];
char agrstr[60];
const char *radiolab[] = {"Show/Omit/Reset reflections using",
                    "Show/Omit/Reset class of reflection",
                    "Show/Omit/Reset single reflection",
                    "All class/conditions"};
                    
int condizione = 1;
const char *conditions[] = { "[Sin(Theta)/Lambda]^2", "2 Theta", "Resol.", "Fo", 
                       "Fc", "Fo/Fc", "(Fo-Fc)/Fo", "h", "k", "l"};
#define num_conditions  10
const char *classes[] = {"ggg",
                   "ggu",
                   "gug",
		   "guu",
		   "ugg",
                   "ugu",
                   "uug",
                   "uuu",
                   "h00",
                   "0k0",
                   "hk0",
                   "00l",
                   "h0l",
                   "0kl",
                   "hkl",
                   "g00",
                   "u00",
                   "0g0",
		   "0u0",
		   "gk0",
                   "uk0",
                   "hg0",
                   "hu0",
                   "00g",
                   "00u",
                   "g0l",
                   "u0l",
                   "h0g",
                   "h0u",
                   "0gl",
                   "0ul",
                   "0kg",
                   "0ku"};
int num_classes = 33;
int classe = 1;

void c_finish_agreement (double agrvet[], char *agrstr)
{
   int l1;

   l1 = (int) strlen(agrstr);
   finish_agreement_(agrvet, agrstr, l1);
}

void reset_omit_show(GtkButton *button, gpointer data)
{
   int i, azione;
   GtkWidget *bt, *entry;
   char num[10];

   azione  = GPOINTER_TO_INT(data);

/* 
   azione = 1 --> show
   azione = 2 --> omit
   azione = 3 --> reset
*/

   for(i=0; i<5; i++)
       agrvet[i] = 0.;
   agrvet[0] = (double) azione;
   for(i=0; i<4; i++)
   {
     ScriviStringa(num, sizeof(num), "radio%d", i+1);
     bt = lookup_widget(GTK_WIDGET(button), num);
     if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(bt)))
     {
        agrvet[1] = (double) (i+1);
        agrstr[0] = '\0';
        switch(i)
        {
         case 0:
              entry = lookup_widget(GTK_WIDGET(button), "val1");
              agrvet[2] = atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
              entry = lookup_widget(GTK_WIDGET(button), "val2");
              agrvet[3] = atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
              entry = lookup_widget(GTK_WIDGET(button), "Internal");
              if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(entry)))
              {
                 agrvet[4] = (double) condizione;
                 switch(condizione)
                 {
                 case 1:
                      ScriviStringa(agrstr, sizeof(agrstr), "%s in the interval [%.4f - %.4f]", 
                        conditions[condizione-1], agrvet[2], agrvet[3]);
                      break;
                 case num_conditions:
                 case num_conditions-1:
                 case num_conditions-2:
                      ScriviStringa(agrstr, sizeof(agrstr), "%s in the interval [%d - %d]", 
                       conditions[condizione-1],(int)agrvet[2],(int)agrvet[3]);
                      break;
                 default:
                      ScriviStringa(agrstr, sizeof(agrstr), "%s in the interval [%.2f - %.2f]", 
                        conditions[condizione-1], agrvet[2], agrvet[3]);
                      break;
                 }
              }
              else
              {
                 agrvet[4] = -(double) condizione;
                 ScriviStringa(agrstr, sizeof(agrstr), "%s external to the interval [%f - %f]", 
                        conditions[condizione-1], agrvet[2], agrvet[3]);
              }
              break;
         case 1:
              agrvet[2] = (double) classe;
              ScriviStringa(agrstr, sizeof(agrstr), "%s", classes[classe-1]);
              break;
         case 2:
              entry = lookup_widget(GTK_WIDGET(button), "h");
              agrvet[2] = atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
              entry = lookup_widget(GTK_WIDGET(button), "k");
              agrvet[3] = atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
              entry = lookup_widget(GTK_WIDGET(button), "l");
              agrvet[4] = atof(gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
              break;
         case 3:
              break;
        }
     }
   }
   c_finish_agreement(agrvet, agrstr);
}

void radio_selected (GtkToggleButton *togglebutton, gpointer user_data)
{
   int numero, i;
   char num[6];
   GtkWidget *hbox;

   for(i=1; i<=3;i++)
   {
       ScriviStringa(num, sizeof(num), "riga%d", i);
       hbox = lookup_widget(GTK_WIDGET(togglebutton), num);
       gtk_widget_set_sensitive(hbox,  FALSE);
   }
   hbox = lookup_widget(GTK_WIDGET(togglebutton), "riga4");
   gtk_widget_set_sensitive(hbox,  TRUE);
   numero = GPOINTER_TO_INT(user_data);
   if(numero < 3)
   {
      ScriviStringa(num, sizeof(num), "riga%d", numero+1);
      hbox = lookup_widget(GTK_WIDGET(togglebutton), num);
      gtk_widget_set_sensitive(hbox, 
            gtk_toggle_button_get_active(togglebutton));
   }
   else
   {
      ScriviStringa(num, sizeof(num), "riga%d", numero+1);
      hbox = lookup_widget(GTK_WIDGET(togglebutton), num);
      gtk_widget_set_sensitive(hbox, FALSE);
   }
}

void selected_condition(GtkWidget *combo, gpointer data)
{
    GtkWidget *dlg = gtk_widget_get_toplevel(GTK_WIDGET(combo));
    GtkWidget *entry = get_widget(dlg, "val1");
    int selection = combo_get_val(combo) - 1;
    condizione = selection+1;
    if(selection >= 0)
    {
       gtk_entry_set_text(GTK_ENTRY(entry), g_strdup_printf("%.3f", agr_intervals[selection][0]));
       entry = get_widget(dlg, "val2");
       gtk_entry_set_text(GTK_ENTRY(entry), g_strdup_printf("%.3f", agr_intervals[selection][1]));
    }
}
//#endif

GtkWidget *create_agreement_dialog(void)
{
  GtkWidget *dialog, *vbox, *radio, *button,
            *table, *entry, *hbox, *vboxs, *label, *frame, *vb[4];
  GSList *group = NULL;
  GSList *group2 = NULL;
  char num[7];
  int i;

  dialog = gtk_dialog_new();
  gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_MOUSE);
  gtk_window_set_title(GTK_WINDOW(dialog), "Agreement");
  gtk_container_set_border_width(GTK_CONTAINER(dialog), 4);

  vbox = gtk_dialog_get_content_area(GTK_DIALOG(dialog));

  table = table_new(4, 1, FALSE);
  table_set_row_spacings(table, 8);
  table_set_col_spacings(table, 8);
  gtk_box_pack_start (GTK_BOX (vbox), table, TRUE, TRUE, 0);

  for(i=0; i<4; i++)
  {
      frame = gtk_frame_new(NULL);
      gtk_container_set_border_width(GTK_CONTAINER(frame), 5);
      table_attach(table, frame, 0, 1, i, i+1, TRUE);
      vb[i] =  vbox_new(FALSE, 0);
      gtk_container_add(GTK_CONTAINER(frame), vb[i]);
      ScriviStringa(num, sizeof(num), "radio%d", i+1);
      radio = RADIO_BUTTON_WITH_LABEL (group, radiolab[i], LABELCOLOR);
      group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
      g_object_set_data (G_OBJECT (dialog), num, radio);
      gtk_box_pack_start (GTK_BOX (vb[i]), radio, TRUE, FALSE, 0);
      (void) g_signal_connect(G_OBJECT(radio), "toggled", 
                G_CALLBACK(radio_selected), GINT_TO_POINTER(i));
  }

  frame = gtk_frame_new(NULL);
  gtk_container_set_border_width(GTK_CONTAINER(frame), 5);
  gtk_frame_set_shadow_type (GTK_FRAME(frame), GTK_SHADOW_NONE);
  g_object_set_data (G_OBJECT (dialog), "riga1", frame);
  gtk_box_pack_start (GTK_BOX (vb[0]), frame, TRUE, FALSE, 0);

  hbox = hbox_new(TRUE, 0);
  gtk_container_add(GTK_CONTAINER(frame), hbox);

  vboxs = vbox_new(FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), vboxs, TRUE, TRUE, 0);
  label = LABEL_NEW("Condition", NULL);
  gtk_box_pack_start (GTK_BOX (vboxs), label, TRUE, TRUE, 0); 
  entry = create_combo(vboxs, conditions, num_conditions, 0, NULL, G_CALLBACK(selected_condition));
  gtk_editable_set_editable(GTK_EDITABLE(get_widget(entry, "entry")), FALSE);
  radio = RADIO_BUTTON_WITH_LABEL(group2, "Internal", LABELCOLOR);
  group2 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  g_object_set_data (G_OBJECT (dialog), "Internal", radio);
  gtk_box_pack_start (GTK_BOX (vboxs), radio, TRUE, TRUE, 0); 

  vboxs = vbox_new(FALSE, 0);
  gtk_box_pack_start (GTK_BOX (hbox), vboxs, TRUE, TRUE, 0);
  label = LABEL_NEW("Interval", NULL);
  gtk_box_pack_start (GTK_BOX (vboxs), label, TRUE, TRUE, 0); 
  hbox = hbox_new(FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vboxs), hbox, TRUE, TRUE, 0); 

  entry = gtk_label_new(" [ ");
  gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
  entry = gtk_entry_new();
  set_width_chars (GTK_ENTRY(entry), 12);
  g_object_set_data (G_OBJECT (dialog), "val1", entry);
  gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, TRUE, 0);
  entry = gtk_label_new(" , ");
  gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
  entry = gtk_entry_new();
  set_width_chars (GTK_ENTRY(entry), 12);
  g_object_set_data (G_OBJECT (dialog), "val2", entry);
  gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, TRUE, 0);
  entry = gtk_label_new(" ] ");
  gtk_box_pack_end(GTK_BOX(hbox), entry, FALSE, FALSE, 0);

  radio = RADIO_BUTTON_WITH_LABEL (group2, "External", LABELCOLOR);
  group2 = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
  g_object_set_data (G_OBJECT (dialog), "External", radio);
  gtk_box_pack_start (GTK_BOX (vboxs), radio, TRUE, TRUE, 0); 

#ifdef IN_GTK3
  hbox = new_alignment(GTK_ALIGN_START, GTK_ALIGN_CENTER, FALSE, FALSE);
#else
  hbox = gtk_alignment_new(0, 0.5, 0, 0);
#endif
  gtk_box_pack_start (GTK_BOX (vb[1]), hbox, FALSE, FALSE, 0); 
  gtk_container_set_border_width(GTK_CONTAINER(hbox), 8);
  entry = create_combo(hbox, classes, num_classes, 0, &classe, NULL);
  gtk_editable_set_editable(GTK_EDITABLE(get_widget(entry, "entry")), FALSE);
  g_object_set_data (G_OBJECT (dialog), "riga2", entry);
  gtk_widget_set_sensitive(entry, FALSE);

  hbox = hbox_new(FALSE, 10);
  gtk_box_pack_start (GTK_BOX (vb[2]), hbox, TRUE, TRUE, 0); 
  g_object_set_data (G_OBJECT (dialog), "riga3", hbox);
  gtk_container_set_border_width(GTK_CONTAINER(hbox), 5);
  gtk_widget_set_sensitive(hbox, FALSE);

  entry = gtk_label_new("h =");
  gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
  entry = gtk_entry_new();
  set_width_chars (GTK_ENTRY(entry), 6);
  g_object_set_data (G_OBJECT (dialog), "h", entry);
  gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, FALSE, 0);

  entry = gtk_label_new("k =");
  gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
  entry = gtk_entry_new();
  set_width_chars (GTK_ENTRY(entry), 6);
  g_object_set_data (G_OBJECT (dialog), "k", entry);
  gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, FALSE, 0);

  entry = gtk_label_new("l =");
  gtk_box_pack_start(GTK_BOX(hbox), entry, FALSE, FALSE, 0);
  entry = gtk_entry_new();
  set_width_chars (GTK_ENTRY(entry), 6);
  g_object_set_data (G_OBJECT (dialog), "l", entry);
  gtk_box_pack_start(GTK_BOX(hbox), entry, TRUE, FALSE, 0);

  button = myimage_button ("   _Show", "show.png");
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog), button, 1);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
            G_CALLBACK(reset_omit_show), GINT_TO_POINTER(1));

  button = myimage_button("   _Omit", "deleteeq.png");
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog), button, 2);
  g_object_set_data (G_OBJECT (dialog), "riga4", button);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
            G_CALLBACK(reset_omit_show), GINT_TO_POINTER(2));

  button = myimage_button("  _Reset", "reset.png");
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog), button, 3);
  (void) g_signal_connect(G_OBJECT(button), "clicked",
            G_CALLBACK(reset_omit_show), GINT_TO_POINTER(3));

  button = CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog), button, 4);
  (void) g_signal_connect(G_OBJECT(button), "clicked", 
            G_CALLBACK(close_dlg), GINT_TO_POINTER(1));
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
           GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect_swapped(G_OBJECT(dialog), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button)); 
  (void) g_signal_connect (G_OBJECT (dialog), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return dialog;
}

void open_agreement_dialog (GtkWidget *item,  gpointer data)
{
   GtkWidget *radio;
   float intervals[10][2];
   int i, ier = 0;

   init_agreement_(intervals, &ier);
   if(ier)
      return;
   for(i=0; i<10; i++)
   {
       agr_intervals[i][0] = intervals[i][0];
       agr_intervals[i][1] = intervals[i][1];
   }
   if(agreement_dlg == NULL)
      agreement_dlg = create_agreement_dialog();

   gtk_widget_show_all(agreement_dlg);
   radio = lookup_widget(agreement_dlg, "radio1");
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio), TRUE);
   gdk_window_raise(gtk_widget_get_window(agreement_dlg));
   finestra_modale_aperta2(agreement_dlg);
}
