#include "mrconfig.h"
#include "aliasx.h"

static GtkToggleButton *oldb_selected = NULL;
extern int nSpec;
extern char *Specie[NUMSPECIES];
extern gchar *Sigle[NUMSPECIES];
extern gboolean viewerOpened;

extern _Dialogo *dialogo;
extern stringa     *It;
gboolean ManageExpose (GtkWidget *widget, gpointer obj, gpointer );

/*****************************************************************/
/*                        R e l a b e l                          */
/*****************************************************************/

static int iSpec;

static void c_select(GtkToggleButton *button, gpointer data)
{
    GtkWidget *indica;

    if(gtk_toggle_button_get_active(button))
    {
       if(oldb_selected)
       {
          indica = get_widget(GTK_WIDGET(oldb_selected), "pix");
          gtk_toggle_button_set_active(oldb_selected, FALSE);
          gtk_widget_hide(indica);
        }
        indica = get_widget(GTK_WIDGET(button), "pix");
        oldb_selected = button;
        gtk_widget_show (indica);
     }
}

void ok_specie (GtkButton *button, gpointer data)
{
    iSpec = 0;

    if(oldb_selected)
      iSpec = get_int(GTK_WIDGET(oldb_selected), "n") + 1;
    if(iSpec)
    {
      close_dlg(button, GINT_TO_POINTER(11));
      gtk_main_quit();
    }
}

void cancel_specie (GtkButton *button, gpointer data)
{
      iSpec = -1;
      close_dlg(button, GINT_TO_POINTER(11));
      gtk_main_quit();
}

int create_relabel(void)
{
    GtkWidget *window, *indica;
    GtkWidget *button;
    GtkWidget *table1;
    char buffer[4];
    int i;
 
    oldb_selected = NULL;   
    window = gtk_dialog_new ();
    gtk_window_set_title (GTK_WINDOW (window), "ReLabel");
    gtk_container_set_border_width (GTK_CONTAINER (window), 5);
    
    table1 = table_new (nSpec, 2, TRUE);
    
    table_set_row_spacings (table1, 5);
    table_set_col_spacings (table1, 0);
    
    gtk_box_pack_start (GTK_BOX (gtk_dialog_get_content_area(GTK_DIALOG(window))), table1, 
			FALSE, FALSE, 0);
    gtk_widget_show (table1);
    
    /* this simply creates a grid of toggle buttons on the table */

    for (i = 0; i < nSpec; i++)
    {
           ScriviStringa(buffer, sizeof(buffer), "%d", i);
       	   button = gtk_toggle_button_new_with_label(Specie[i]);
	   (void) g_signal_connect(G_OBJECT(button), "toggled" , 
                              G_CALLBACK(c_select), GINT_TO_POINTER(i));
	   table_attach(table1, button, 0, 1, i, i+1, TRUE);
           gtk_widget_show (button);
           indica = create_image("indica2.png");
           table_attach(table1, indica, 1, 2, i, i + 1, TRUE);
           g_object_set_data(G_OBJECT(button), "pix", indica);
           g_object_set_data(G_OBJECT(button), "n", GINT_TO_POINTER(i));
    }
    
/* buttons: OK & Cancel */
    button = myimage_button("   _OK", "ok.png");
    (void) g_signal_connect (G_OBJECT (button), "clicked",
			       (GCallback) ok_specie,NULL);
    gtk_dialog_add_action_widget(GTK_DIALOG(window), button, 1);
    gtk_widget_grab_focus (button);
    gtk_widget_show (button);

    button = myimage_button("  _Cancel", "cancel.png");
    (void) g_signal_connect (G_OBJECT (button), "clicked",
			       (GCallback) cancel_specie,NULL);
    gtk_dialog_add_action_widget(GTK_DIALOG(window), button, 2);
    gtk_widget_show (button);
    gtk_button_box_set_layout(GTK_BUTTON_BOX(
      gtk_widget_get_parent(button)), GTK_BUTTONBOX_SPREAD);

    (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button)); 
  (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);

    gtk_widget_show(window);
    finestra_modale_aperta2(window);
    gtk_main();
    return iSpec;
}

/*****************************************************************/
/*                       R e n u m b e r                         */
/*****************************************************************/

static int INum = -1;
static int tpref = 0;
static char text[70];
void ok_renumber (GtkButton *button, gpointer data)
{
    GtkWidget *spin;
    GtkWidget *entry;
    int ok;

    ok = GPOINTER_TO_INT(data);
    entry = lookup_widget(GTK_WIDGET(button), "entry");
    if(ok)
    {
       spin = lookup_widget(GTK_WIDGET(button), "spin");
       INum = spin_button_get_value_as_int (spin);
       spin = lookup_widget(GTK_WIDGET(button), "userdef");
       tpref = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(spin));
       ScriviStringa(text, sizeof(text), "%s", 
          gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));  
    }
    else
       INum = -1;
    close_dlg(button, GINT_TO_POINTER(11));
    gtk_main_quit();
}

int create_renumber(char *prefix, size_t lpref)
{
    GtkWidget *window;
    GtkWidget *hbox;
    GtkWidget *frame;
    GtkWidget *label;
    GtkWidget *spin;
    GtkWidget *radio;
    GtkWidget *entry;
    GtkWidget *button;
    GObject *adj;
    GSList *group = NULL;

    window = gtk_dialog_new();
    gtk_window_set_title (GTK_WINDOW (window), "ReNumber");
    gtk_container_set_border_width (GTK_CONTAINER (window), 5);

    frame = FRAME_NEW ("Label prefix", FRAMECOLOR);
    gtk_box_pack_start(GTK_BOX(gtk_dialog_get_content_area(GTK_DIALOG(window))), frame, FALSE, 
                       FALSE, 10);

    entry = gtk_entry_new();

    hbox = vbox_new(FALSE, 2);
    gtk_container_add(GTK_CONTAINER(frame), hbox);
    radio = gtk_radio_button_new_with_label (group, "Atomic species");
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 0);
    radio = gtk_radio_button_new_with_label (group, "User defined string");
    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (radio));
    gtk_box_pack_start (GTK_BOX (hbox), radio, FALSE, FALSE, 0);
    g_object_set_data (G_OBJECT (window), "userdef", radio);
    (void) g_signal_connect (G_OBJECT (radio), "toggled",
		       (GCallback) on_cb_attiva, entry);

    gtk_box_pack_start (GTK_BOX (hbox), entry, FALSE, FALSE, 0);
    gtk_widget_set_sensitive(entry, FALSE);
    g_object_set_data (G_OBJECT (window), "entry", entry);
    hbox = hbox_new(FALSE, 2);
    gtk_box_pack_start(GTK_BOX(gtk_dialog_get_content_area(GTK_DIALOG(window))), hbox, FALSE, 
                       FALSE, 10);
    gtk_widget_show(hbox);

    label = gtk_label_new("Initial Sequence Number");
    set_alignment(label, 0.,0.5);
    gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
    gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 2);

    adj = adj_new ((float) 1, (float) 1, (float) 10000,
                              (float) 1, (float) 10);
    spin = spin_button_new (GTK_ADJUSTMENT (adj), 1, 0);
    g_object_set_data(G_OBJECT(window), "spin", spin);
    spin_button_set_numeric (spin, TRUE);
    spin_button_set_update_policy (spin, GTK_UPDATE_IF_VALID);
    gtk_box_pack_start(GTK_BOX(hbox), spin, FALSE, FALSE, 2);

/* buttons: OK & Cancel */
    button = myimage_button("   _OK", "ok.png");
    (void) g_signal_connect (G_OBJECT (button), "clicked",
		       (GCallback) ok_renumber,GINT_TO_POINTER(1));
    gtk_dialog_add_action_widget(GTK_DIALOG (window), button, 1);
    gtk_widget_grab_focus (button);

    button = myimage_button("  _Cancel", "cancel.png");
    (void) g_signal_connect (G_OBJECT (button), "clicked",
		      (GCallback) ok_renumber,GINT_TO_POINTER(0));
    gtk_dialog_add_action_widget(GTK_DIALOG (window), button, 2);
    gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
            GTK_BUTTONBOX_SPREAD);
    (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
  (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);


    gtk_widget_show_all(window);
    finestra_modale_aperta2(window);
    gtk_main();
    if(tpref)
       CopiaStringa(prefix, lpref, text);
    else
       CopiaStringa(prefix, lpref, "\0");
    return INum;
}

/*****************************************************************/
/*                       Complete rings                          */
/*****************************************************************/


static int NumCase = 0;
static int BondLength = 0;

void ok_rings(GtkButton *button, gpointer tipo)
{
   NumCase = GPOINTER_TO_INT(tipo);
   close_dlg(button, GINT_TO_POINTER(11));
   gtk_main_quit();
}
 
GtkWidget* create_rings (int numrings)
{

  GtkWidget *window;
  GtkWidget *box1;
  GtkWidget *box2;

  GtkWidget *separator;
  GtkWidget *button1;
  GtkWidget *buttona;
  GtkWidget *buttonb;
  GtkWidget *buttonc;


  window = gtk_dialog_new ();
  gtk_container_set_border_width (GTK_CONTAINER (window), 7);
  gtk_window_set_title (GTK_WINDOW (window), "Select the case");
  gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_MOUSE);

  box1 = gtk_dialog_get_content_area(GTK_DIALOG(window));

  box2 = hbox_new (FALSE, 4);
  gtk_widget_show (box2);

  gtk_box_pack_start (GTK_BOX (box1), box2, TRUE, FALSE, 0);
 
  if(numrings == 2)
  {
     buttona = xpm_button("ring12.png");
     gtk_box_pack_start (GTK_BOX (box2), buttona, TRUE, FALSE, 0);
   
     separator = vseparator_new();
     gtk_widget_show (separator);
     gtk_box_pack_start (GTK_BOX (box2), separator, TRUE, FALSE, 0);
   
     buttonb = xpm_button("ring22.png");
     gtk_box_pack_start (GTK_BOX (box2), buttonb, TRUE, FALSE, 0);
     
     separator = hseparator_new();
     gtk_widget_show (separator);
     gtk_box_pack_start (GTK_BOX (box1), separator, TRUE, FALSE, 0);
     (void) g_signal_connect (G_OBJECT(buttona), "clicked", 
                  G_CALLBACK(ok_rings), GINT_TO_POINTER(4));
     (void) g_signal_connect (G_OBJECT(buttonb), "clicked", 
                  G_CALLBACK(ok_rings), GINT_TO_POINTER(5));
  }
  else
  {
     buttona = xpm_button("ring13.png");
     gtk_box_pack_start (GTK_BOX (box2), buttona, TRUE, FALSE, 0);
   
     separator = vseparator_new();
     gtk_widget_show (separator);
     gtk_box_pack_start (GTK_BOX (box2), separator, TRUE, FALSE, 0);
   
     buttonb = xpm_button("ring23.png");
     gtk_box_pack_start (GTK_BOX (box2), buttonb, TRUE, FALSE, 0);
     
     separator = hseparator_new();
     gtk_widget_show (separator);
     gtk_box_pack_start (GTK_BOX (box1), separator, TRUE, FALSE, 0);

     buttonc = xpm_button("ring33.png");
     gtk_box_pack_start (GTK_BOX (box2), buttonc, TRUE, FALSE, 0);

     (void) g_signal_connect (G_OBJECT(buttona), "clicked", 
                  G_CALLBACK(ok_rings), GINT_TO_POINTER(1));
     (void) g_signal_connect (G_OBJECT(buttonb), "clicked", 
                  G_CALLBACK(ok_rings), GINT_TO_POINTER(2));
     (void) g_signal_connect (G_OBJECT(buttonc), "clicked", 
                  G_CALLBACK(ok_rings), GINT_TO_POINTER(3));
  }

  button1 = myimage_button("  _Cancel", "cancel.png");
  gtk_widget_grab_focus (button1);
  gtk_widget_show (button1);
  gtk_dialog_add_action_widget(GTK_DIALOG (window), button1, 1);
  (void) g_signal_connect (G_OBJECT(button1), "clicked", 
                  G_CALLBACK(ok_rings), GINT_TO_POINTER(7));

  (void) g_signal_connect_swapped(G_OBJECT(window), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button1));
  (void) g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK(true_cb), NULL);


  return window;
}

void ok_bondl(GtkButton *button, GObject *adj)
{
   double value;

   if(adj)
   {
      value =  gtk_adjustment_get_value(GTK_ADJUSTMENT(adj));
      BondLength = ((int) (value*1000))*10+NumCase;
   }
   else
      BondLength = 0;
   close_dlg(button, GINT_TO_POINTER(11));
   gtk_main_quit();
}

GtkWidget *create_bond_dlg (void)
{
  GtkWidget *bond_dlg;
  GtkWidget *box1;
  GtkWidget *frame;
  GtkWidget *hscale;
  GtkWidget *button1;
  GtkWidget *button2;
  GObject *adj;

  bond_dlg = gtk_dialog_new ();
  gtk_container_set_border_width (GTK_CONTAINER (bond_dlg), 7);
  gtk_window_set_title (GTK_WINDOW (bond_dlg), "Set Bond length");
  gtk_window_set_position(GTK_WINDOW(bond_dlg), GTK_WIN_POS_MOUSE);

  box1 = gtk_dialog_get_content_area(GTK_DIALOG(bond_dlg));
  
  frame = FRAME_NEW ("Bond Length", FRAMECOLOR);
  g_object_set_data (G_OBJECT (bond_dlg), "frame", frame);
  gtk_widget_show (frame);
/* lo impacchettiamo sotto al frame4 */
  gtk_box_pack_start (GTK_BOX (box1), frame, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame), 4);
  adj = adj_new (1.390f,0.9f, 1.6f, 0.01f, 0.1f);
  hscale = hscale_new (GTK_ADJUSTMENT (adj));
  g_object_set_data (G_OBJECT (bond_dlg), "hscale", hscale);
  gtk_widget_show (hscale);
/* lo mettiamo dentro al frame */
  gtk_container_add (GTK_CONTAINER (frame), hscale);
/*  decidiamo la posizione in cui sarà visualizzato il valore numerico */
  gtk_scale_set_value_pos (GTK_SCALE (hscale), GTK_POS_BOTTOM);
/* e quante cifre decimali vogliamo */
  gtk_scale_set_digits (GTK_SCALE (hscale), 3);
  
     button1 = myimage_button("   _OK", "ok.png");
     gtk_widget_grab_focus (button1);
     gtk_widget_show (button1);
     gtk_dialog_add_action_widget(GTK_DIALOG (bond_dlg), button1, 1);
     (void) g_signal_connect(G_OBJECT(button1), "clicked",
                  G_CALLBACK(ok_bondl), adj);

     button2 = myimage_button("  _Cancel", "cancel.png");
     gtk_widget_show (button2);
     gtk_dialog_add_action_widget(GTK_DIALOG (bond_dlg), button2, 2);
     (void) g_signal_connect (G_OBJECT(button2), "clicked", 
                      G_CALLBACK(ok_bondl), NULL);

     (void) g_signal_connect_swapped(G_OBJECT(bond_dlg), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button2));
     (void) g_signal_connect (G_OBJECT (bond_dlg), "delete_event",
                      G_CALLBACK(true_cb), NULL);
     gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button1)),
       GTK_BUTTONBOX_SPREAD);

     return bond_dlg;
}

void newbondl (void)
{
  GtkWidget *bond_dlg;

  bond_dlg = create_bond_dlg();
  gtk_widget_show(bond_dlg);
  finestra_modale_aperta2(bond_dlg);
  gdk_window_raise (gtk_widget_get_window(bond_dlg));
  gtk_main();
}

int newrings(int numrings)
{
  GtkWidget *rings_dlg;

  if(numrings > 1)
  {
     rings_dlg = create_rings(numrings);
     gtk_widget_show(rings_dlg);
     finestra_modale_aperta2(rings_dlg);
     gdk_window_raise (gtk_widget_get_window(rings_dlg));
     gtk_main();
  }
  else if(numrings == 1)
     NumCase = 6;
  else if(numrings == -1)
     NumCase = 0;
  if(NumCase < 7)
  {
     newbondl();
     return(BondLength);
  }
  return 0;
}

/***********************************************************/
/*              A d d   O n e   A t o m                    */
/***********************************************************/


static GtkWidget *add_atom_dlg;
int    specie, serialc;
int    okay;
static float  distance, ang_b, ang_t;

void c_minidraw(int w, int h, float ang1, float ang2, float dist,
                int jspec)
{
       if((w > 2) && (h > 2))
           minidraw_(&w, &h, &ang1, &ang2, &dist, &jspec);
}

void end_add(GtkButton *button, gpointer data)
{

   okay = GPOINTER_TO_INT(data);

   mr_restore_pixmap();
   viewerOpened = FALSE;
   close_dlg(button, GINT_TO_POINTER(1));
   gtk_main_quit();
}

void aggiorna_lab(void)
{
  int i;
  GtkWidget *label;

  label = lookup_widget(add_atom_dlg, "info");
  std::string strt = It[0];
  for (i=1; i<4;i++)
  {
    strt.append("\n");
    strt.append(It[i]);
  }
  gtk_label_set_text(GTK_LABEL(label), strt.c_str());
}

void get_new_val (GtkAdjustment *adj, float *newval)
{
   GtkWidget *drawarea;
   GtkAllocation allocation;
   *newval = (float) gtk_adjustment_get_value(adj);
   drawarea = GTK_WIDGET(g_object_get_data(G_OBJECT(adj), "miniscreen"));
   gtk_widget_get_allocation(drawarea, &allocation);
   c_minidraw(allocation.width, allocation.height,
             ang_b, ang_t, distance, specie);
  aggiorna_lab();
}

void get_specie (GtkEditable *entry, GtkWidget *drawarea)
{
   GtkAllocation allocation;
   gtk_widget_get_allocation(drawarea, &allocation);

   if(specie > 0)
   {
      c_minidraw(allocation.width, allocation.height,
             ang_b, ang_t, distance, specie);
      aggiorna_lab();
   }
}

GtkWidget* create_dialog_add_atom (int w, int h)
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *frame;
  GtkWidget *miniscreen;
  GtkWidget *label;
  GtkWidget *hbox1;
  GtkWidget *vbox;
  GtkWidget *hscale;
  GtkWidget *combo_spec;
  GtkWidget *list;
  GtkWidget *button;
  GObject *adj;

  dialog1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog1), "Add one atom");

  dialog_vbox1 = gtk_dialog_get_content_area(GTK_DIALOG (dialog1));
  gtk_container_set_border_width (GTK_CONTAINER (dialog_vbox1), 8);

  frame = gtk_frame_new (NULL);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), frame, TRUE, TRUE, 8);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_IN);

  miniscreen = gtk_drawing_area_new ();
  g_object_set_data (G_OBJECT (dialog1), "miniscreen", miniscreen);
  gtk_container_add (GTK_CONTAINER (frame), miniscreen);
  gtk_widget_set_size_request (miniscreen, w, h);
  (void) g_signal_connect (G_OBJECT (miniscreen), "configure_event",
                   G_CALLBACK (on_viewer_configure_event), NULL);
  (void) g_signal_connect (G_OBJECT (miniscreen), DRAW_EVENT,
                   G_CALLBACK (ManageExpose), NULL);

  frame = gtk_frame_new (NULL);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), frame, FALSE, TRUE, 8);
  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_IN);

  label = gtk_label_new ("\n\n\n");
  g_object_set_data (G_OBJECT (dialog1), "info", label);
  gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
  set_alignment(label, 0.f, 0.5f);

  gtk_container_add (GTK_CONTAINER (frame), label);

  hbox1 = hbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), hbox1, FALSE, FALSE, 12);

  vbox = vbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox, TRUE, TRUE, 0);

  frame = FRAME_NEW ("Distance D", FRAMECOLOR);
  g_object_set_data (G_OBJECT (dialog1), "frame_dist", frame);
  gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, FALSE, 0);

  adj = adj_new (1.390f,0.9f, 1.6f, 0.01f, 0.1f);
  g_object_set_data(G_OBJECT (dialog1), "distance", adj);
  g_object_set_data(G_OBJECT(adj), "miniscreen", miniscreen);
  hscale = spin_button_new ( GTK_ADJUSTMENT(adj), 1, 3); 
  g_object_set_data(G_OBJECT (dialog1), "spin_distance", hscale);
  gtk_container_add (GTK_CONTAINER (frame), hscale);
  int hnd =  g_signal_connect(adj,"value_changed", 
             G_CALLBACK(get_new_val), &distance);
  g_object_set_data(G_OBJECT (adj), "hnd", GINT_TO_POINTER(hnd));

  frame = FRAME_NEW ("Torsion Angle T", FRAMECOLOR);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

  adj = adj_new (180., -180., 180., 0.5, 10.);
  g_object_set_data(G_OBJECT (dialog1), "ang_t", adj);
  g_object_set_data(G_OBJECT(adj), "miniscreen", miniscreen);
  hscale = spin_button_new ( GTK_ADJUSTMENT(adj), 1, 1); 
  gtk_container_add (GTK_CONTAINER (frame), hscale);
  hnd =  g_signal_connect(adj,"value_changed", 
             G_CALLBACK(get_new_val), &ang_t);
  g_object_set_data(G_OBJECT (adj), "hnd", GINT_TO_POINTER(hnd));

  vbox = vbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (hbox1), vbox, TRUE, TRUE, 0);

  frame = FRAME_NEW ("Bond Angle B", FRAMECOLOR);
  gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, FALSE, 0);

  adj = adj_new (0., 50., 310., 0.5, 10.);
  g_object_set_data(G_OBJECT (dialog1), "ang_b", adj);
  g_object_set_data(G_OBJECT(adj), "miniscreen", miniscreen);
  hscale = spin_button_new ( GTK_ADJUSTMENT(adj), 1, 1); 
  gtk_container_add (GTK_CONTAINER (frame), hscale);
  hnd =  g_signal_connect(adj,"value_changed", 
             G_CALLBACK(get_new_val), &ang_b);
  g_object_set_data(G_OBJECT (adj), "hnd", GINT_TO_POINTER(hnd));

  frame = FRAME_NEW ("New Species", FRAMECOLOR);
  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

  combo_spec = create_combo(frame, NULL, 0, 0, &specie, NULL);
  g_object_set_data(G_OBJECT (dialog1), "combo_spec", combo_spec);
  gtk_editable_set_editable(GTK_EDITABLE(get_widget(combo_spec, "entry")), FALSE);

  list = get_widget(combo_spec, "entry");
#ifndef GTK_COMBO_BOX
  hnd =  g_signal_connect(G_OBJECT(list), "changed", G_CALLBACK(get_specie), miniscreen);
#else
  hnd =  g_signal_connect(G_OBJECT(combo_spec), "changed", G_CALLBACK(get_specie), miniscreen);
#endif
  g_object_set_data(G_OBJECT (list), "hnd", GINT_TO_POINTER(hnd));
  
  button = OK_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, GTK_RESPONSE_OK);
  button = CANCEL_button();
  gtk_dialog_add_action_widget(GTK_DIALOG(dialog1), button, GTK_RESPONSE_CANCEL);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
       GTK_BUTTONBOX_SPREAD);

  return dialog1;
}

void add_atom(int def_spec, int serial[], int treatomi[], int *ifOk, float dmax)
{
  int i;
  GList *combo_items = NULL;
  GtkWidget *combo_spec, *drawarea, *spin_d, *list;
  GObject *adj;
  char newatom[9];
  

  stop_continue_rot();

  serialc = serial[def_spec];
  ScriviStringa(newatom, sizeof(newatom), "%s%d", Sigle[def_spec], serialc);
  if(add_atom_dlg == NULL)
     add_atom_dlg = create_dialog_add_atom (350, 280);

  drawarea = get_widget(add_atom_dlg, "miniscreen");
  mr_send_viewer_pixmap(drawarea);

  combo_spec = lookup_widget(add_atom_dlg, "combo_spec");
  list = get_widget(combo_spec,"entry"); 
  int hnd = get_int(list, "hnd");
#ifndef GTK_COMBO_BOX
  g_signal_handler_block(G_OBJECT(list), hnd);
#else
  g_signal_handler_block(G_OBJECT(combo_spec), hnd);
#endif
  for(i=0; i<nSpec;i++)
      combo_items = g_list_append(combo_items, Specie[i]);
  set_popdown_strings (combo_spec, combo_items);
  g_list_free (combo_items);
  specie = def_spec+1;
  combo_set_val(combo_spec, specie);
#ifndef GTK_COMBO_BOX
  g_signal_handler_unblock(G_OBJECT(list), hnd);
#else
  g_signal_handler_unblock(G_OBJECT(combo_spec), hnd);
#endif

  distance = 1.390f;
  ang_b = 120.;
  ang_t = 180.;

  adj = adj_new (distance, 0.9f, dmax, 0.01f, 0.1f);
  g_object_set_data(G_OBJECT (add_atom_dlg), "distance", adj);
  g_object_set_data(G_OBJECT(adj), "miniscreen", drawarea);
  spin_d = lookup_widget(add_atom_dlg, "spin_distance");
  spin_button_set_adjustment(spin_d, GTK_ADJUSTMENT(adj));
  spin_button_set_value (spin_d, distance);
  hnd =  g_signal_connect(adj,"value_changed", 
             G_CALLBACK(get_new_val), &distance);
  g_object_set_data(G_OBJECT (adj), "hnd", GINT_TO_POINTER(hnd));

  adj = G_OBJECT(get_object(add_atom_dlg, "ang_b"));
  hnd = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(adj), "hnd"));
  g_signal_handler_block(G_OBJECT(adj), hnd);
  gtk_adjustment_set_value ((GtkAdjustment *) adj, ang_b);
  g_signal_handler_unblock(G_OBJECT(adj), hnd);
  adj = G_OBJECT(get_object(add_atom_dlg, "ang_t"));
  hnd = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(adj), "hnd"));
  g_signal_handler_block(G_OBJECT(adj), hnd);
  gtk_adjustment_set_value ((GtkAdjustment *) adj, ang_t);
  g_signal_handler_unblock(G_OBJECT(adj), hnd);

  gtk_widget_show_all (add_atom_dlg);
  adj = (GObject *)get_object(add_atom_dlg, "distance");
#ifdef USE_VALUE_CHANGED
  gtk_adjustment_value_changed(GTK_ADJUSTMENT(adj));
#endif
  int result = gtk_dialog_run(GTK_DIALOG(add_atom_dlg));
  *ifOk = (result == GTK_RESPONSE_OK);
   mr_restore_pixmap();
   viewerOpened = FALSE;
   gtk_widget_hide(add_atom_dlg);
}

extern "C" {
int iopen_relabel_(void)
{
    return(create_relabel());
}

int iopen_renumber_(char *prefix, int *lprefix)
{
    return(create_renumber(prefix, *lprefix));
}

int new_rings_(int *numrings)
{
    if (*numrings != 0)
         return(newrings(*numrings));
    return 0;
}

void c_add_atom_(int *spec, int serial[], int treatomi[],int *ifOkay, float *dm)
{
     add_atom(*spec-1, serial, treatomi, ifOkay, *dm);
}
};
