      MODULE GaussModule

*     private      :: ordinatab
      public      :: ordinatab

      CONTAINS

      subroutine GaussPicco(jj,xs1,hintmx,sigma1sav)
!
      USE General,  only : knw,pi,cell
      USE Symmetry, only : icent,ncentr,nsym
      USE Mappa, only : np
      USE Atomi, only : xyzs4
      USE CorrMod
      USE MappaCorrezione
!
c     USE nr  ! in recipes.f90
!
      real,dimension(3)         :: xeq,xs,xs1,xs2,xs3,s
      real,dimension(2)         :: dmat,amt,vet
      real,dimension(2,2)       :: amat
      integer                   :: sidepp
      integer                   :: nrho
      integer, dimension(2)     :: INDX
      real, dimension(10000,2)  :: rhomap
!
!     write(6,*)  ' Gaussiana '
!
      zero = 0.0000000001
      dminneg_sav = dminneg 
!     dminneg = 1.0
!     alim = 1.5
      alim = dminneg !* 1.5
      if (knw == 1 .and. jj == 1) write(6,*)  ' Gaussiana - alim',alim

      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1

c--
! ---  GAUSSIANA
c--
!
!     write(6,'(a,i5,3f13.6,f17.6)') 'Picco Orig.',jj,xs1,hintmx

      do ii=1,3
         xs3(ii)=side(xs1(ii))
      enddo

      call MaxIntPicco(xs1,xs3,hintmx)


!     write(6,'(a,5x,3f13.6,f17.6)') 'Picco Mod. ',xs,hintmx

      j1=nint(xs3(1)*np(1))
      j2=nint(xs3(2)*np(2))
      j3=nint(xs3(3)*np(3))

      j1sav=sidepp(j1,np(1))
      j2sav=sidepp(j2,np(2))
      j3sav=sidepp(j3,np(3))
      xxxmmm=xmap2(j1sav,j2sav,j3sav)

c     write(6,*) 'Picco', jj,'  centrato in ',j1,j2,j3
c     write(6,*) 'Picco', jj,'  centrato in ',j1sav,j2sav,j3sav,xxxmmm
c     write(6,*) 'Picco orig.', jj,j1sav,j2sav,j3sav,xxxmmm

c--
      sigma1=sigma1sav
      yk=sigma1*sqrt(2.0*pi)*hintmx
!     write(6,*)'SIGMA1,HINTMX,YK ',jj,sigma1,hintmx,yk
      nrho = 0
      rhomap(:,:) = 0.0
c--
!
!  - Modifico la mappa sottaendo i ripples della f.ne correzione
!
      do kk1=1,ncentr
         do kk2=1,ifin
            coef=vet(kk2)
            do kk3=1,nsym
               call xequi(xs3,kk3,coef,xeq,kk1)
               do ii=1,3
                  xs(ii)=side(xeq(ii))
               enddo

               isz0=nint(xs(3)*np(3))
               isy0=nint(xs(2)*np(2))
               isx0=nint(xs(1)*np(1))

               iszu=nint(xs(3)*np(3)+alim*deltz)
               iszl=nint(xs(3)*np(3)-alim*deltz)
               isyu=nint(xs(2)*np(2)+alim*delty)
               isyl=nint(xs(2)*np(2)-alim*delty)
               isxu=nint(xs(1)*np(1)+alim*deltx)
               isxl=nint(xs(1)*np(1)-alim*deltx)

c     write(6,*) 'isxl,isxu ',isxl,isxu
c     write(6,*) 'isyl,isyu ',isyl,isyu
c     write(6,*) 'iszl,iszu ',iszl,iszu
c--
               do iz = iszl, iszu
                 do iy = isyl, isyu
                   do ix = isxl, isxu

                      ih = sidepp(ix,np(1))
                      ik = sidepp(iy,np(2))
                      il = sidepp(iz,np(3))

                       xx1=float(ih)*dx
                       yy1=float(ik)*dy
                       zz1=float(il)*dz
                       xs2(1)=xx1
                       xs2(2)=yy1
                       xs2(3)=zz1
                       call xdist(xs,xs2,d,s)
                       ray=d
         
                      if (ray > alim) cycle

                      if (ray.le.dminneg) then
                          nrho=nrho+1
                          rhomap(nrho,1)=ray
                          rhomap(nrho,2)=xmap2(ih,ik,il)
                      endif
         
                   enddo
                 enddo
               enddo

          enddo
        enddo
      enddo
      call ordinatab(rhomap(1:nrho,1:2),1)
      isav=1
      do i=2,nrho
         if (abs(rhomap(i,1)-rhomap(isav,1)).lt.0.001) then
             rhomap(isav,2)=(rhomap(i,2)+rhomap(isav,2))*0.5
             rhomap(i,1)=1000.0
         else
             isav=i
         endif
      enddo
      call ordinatab(rhomap(1:nrho,1:2),1)
      isav=0
      do i=1,nrho
         if (rhomap(i,1).gt.100.0) then
             isav=i-1
             exit
         endif
      enddo
      nrho=isav
      isav=0
      do i=1,nrho
         if (rhomap(i,2).lt.zero) then
             isav=i-1
             exit
         endif
      enddo
      if (isav.eq.0) then
          isav = nrho
          do i=1,nrho
             if (rhomap(i,1).gt.dminneg) then
                 isav=i-1
                 exit
             endif
          enddo
      endif
      if (isav == 0) then
          write(6,*) 'PROBLEM ... isav ',isav
      endif
      nrho=isav
      dminnegmin=rhomap(isav,1)

      if (dminnegmin < zero) return
      if (maxval(rhomap(1:nrho,2)).le.zero) return

!     write(6,*)'dminnegmin,distmax,rhomax',dminnegmin,
!    *           maxval(rhomap(1:nrho,1)),maxval(rhomap(1:nrho,2))
      isav=0
      do i=1,nrho
         if (rhomap(i,2).lt.maxval(rhomap(1:nrho,2))*0.5) then
             isav=i-1
             exit
         endif
      enddo
      if (isav.gt.1) then
          sigma1=rhomap(isav,1)
          yk=sigma1*sqrt(2.0*pi)*hintmx    
      else
          sigma1=sigma1sav
          yk=sigma1*sqrt(2.0*pi)*hintmx 
      endif
!     write(6,*)'NRHO,ISAV',nrho,isav
!     write(6,*)'sigma1,hintmx,yk ',jj,sigma1,hintmx,yk
      erremin=9999999.0
      sigma1savv=sigma1
      yksav=yk
!
! -- Cicli di LSQ
!
      do ii=1,10
         dmat=0.0
         amat=0.0
         amt=0.0
         erre=0.0
         sum1=0.0
         sum2=0.0
         do i=1,nrho
            if (rhomap(i,2).gt.zero) then
                peso = 1.0/(rhomap(i,2))

         amt(1)=(1.0/(sqrt(2.0*pi)*sigma1))*
     *           exp(-rhomap(i,1)**2/(2.0*sigma1**2))
         amt(2)=yk*(1.0/(sqrt(2.0*pi)*sigma1))*
     *          exp(-rhomap(i,1)**2/(2.0*sigma1**2))*
     *          (rhomap(i,1)**2/sigma1**2-1.0)*(1.0/sigma1)

         dmat(1)=dmat(1)+(rhomap(i,2)-yk*(1.0/(sqrt(2.0*pi)*sigma1))*
     *           exp(-rhomap(i,1)**2/(2.0*sigma1**2)))*amt(1)*peso
         dmat(2)=dmat(2)+(rhomap(i,2)-yk*(1.0/(sqrt(2.0*pi)*sigma1))*
     *           exp(-rhomap(i,1)**2/(2.0*sigma1**2)))*amt(2)*peso

                 amat(1,1) = amat(1,1)+amt(1)*amt(1)*peso 
                 amat(1,2) = amat(1,2)+amt(1)*amt(2)*peso
                 amat(2,1) = amat(2,1)+amt(2)*amt(1)*peso 
                 amat(2,2) = amat(2,2)+amt(2)*amt(2)*peso
            endif
         enddo
         call LUDCMP_E(amat,2,2,INDX,D,ier)
         call LUBKSB_E(amat,2,2,INDX,dmat)
!        if ((yk+dmat(1)).gt.0.0) yk=yk+dmat(1)
!        if ((sigma1+dmat(2)).gt.0.05) sigma1=sigma1+dmat(2)
         if ((yk+dmat(1)).gt.0.1.and.(sigma1+dmat(2)).gt.0.05.and.
     *       (sigma1+dmat(2)).lt.1.1 * sigma1savv) then 
            yk=yk+dmat(1) 
            sigma1=sigma1+dmat(2)
         endif
!        write(6,'(a,4f15.3)')'Fit parameters',dmat(1:2),yk,sigma1
         do i=1,nrho
            y=yk*(1.0/(sqrt(2.0*pi)*sigma1))*
     *        exp(-rhomap(i,1)**2/(2.0*sigma1**2))
            sum1=sum1+abs(rhomap(i,2)-y)
            sum2=sum2+rhomap(i,2)
         enddo
         erre=sum1/sum2
         if (erre.lt.erremin) then
             erremin=erre
             yksav=yk
             sigma1savv=sigma1
         else
             exit
         endif
         sigma1=sigma1savv
         yk=yksav
      enddo
      yk=sigma1*sqrt(2.0*pi)*hintmx*0.9
!     write(6,*)'SIGMA1,HINTMX,YK,SIGMA1*0.8',
!    *           jj,sigma1,hintmx,yk,sigma1*0.8
      sigma1=sigma1*0.8

!     xyzs4(jj) = sigma1  vettore di appoggio per stampa

!
!  -   Ciclo sugli equivalenti
!
      do kk1=1,ncentr
         do kk2=1,ifin
            coef=vet(kk2)
            do kk3=1,nsym
               call xequi(xs3,kk3,coef,xeq,kk1)
               do ii=1,3
                  xs(ii)=side(xeq(ii))
               enddo
               iszu=nint(xs(3)*np(3)+alim*deltz)
               iszl=nint(xs(3)*np(3)-alim*deltz)
               isyu=nint(xs(2)*np(2)+alim*delty)
               isyl=nint(xs(2)*np(2)-alim*delty)
               isxu=nint(xs(1)*np(1)+alim*deltx)
c--

               do iz = iszl, iszu
                 do iy = isyl, isyu
                   do ix = isxl, isxu

                      ih = sidepp(ix,np(1))
                      ik = sidepp(iy,np(2))
                      il = sidepp(iz,np(3))
         
                       xx1=float(ih)*dx
                       yy1=float(ik)*dy
                       zz1=float(il)*dz
                       xs2(1)=xx1
                       xs2(2)=yy1
                       xs2(3)=zz1
                       call xdist(xs,xs2,d,s)
                       ray=d

                      if (ray > alim) cycle
                      xmold=xmap2(ih,ik,il)

!                     if (ray.le.dminneg) then
                      if (ray.le.dminnegmin) then
                         xmap2(ih,ik,il)=yk*(1.0/(sqrt(2.0*pi)*sigma1))*
     *                                  exp(-ray**2/(2.0*sigma1**2))

                         xmap2sav(ih,ik,il) = xmap2(ih,ik,il)   ! per Improve_peaks
                      endif

                   enddo
                 enddo
               enddo
c--
          enddo
        enddo
      enddo  

c     write(6,*) 'Picco mod. ', jj,j1sav,j2sav,j3sav,xxxmmm

      dminneg = dminneg_sav 
c--
      end subroutine GaussPicco
!------------------------------------------------------------------------------
      subroutine ordinatab(tab,ikey)
      USE nr  ! in recipes.f90
!
      real, dimension(:,:), intent(inout)         :: tab
      integer , intent(in)                        :: ikey
      integer                                     :: i
      integer                                     :: ndim1, ndim2
      integer , allocatable                       :: iorder(:)

! modifica Dedi per le proteine: uso variabili ndim1, ndim2 
      ndim1 = size(tab,1)
      ndim2 = size(tab,2)
  
      allocate(iorder(1:ndim1), stat = ier)
!
      call indexx(tab(:,ikey),iorder)
      do i=1,ndim2
        tab(:,i)=tab(iorder,i)
      enddo
   
      deallocate(iorder, stat = ier)

      end subroutine ordinatab
     
      END MODULE GaussModule
!------------------------------------------------------------------------------
      subroutine IndagaMappa(jj,numberToUse,ier)
!
      USE General
      USE Symmetry     
      USE Riflessi
      USE TestModel
      USE PhaseModule     
      USE Atomi
      USE Mappa
      USE CorrMod
!
      USE GaussModule  ! per usare ordinatab
!
      character patom*256
!
      real, dimension(48,3)         :: tmat_sav
      real, dimension(3,24)         :: tsmat_sav
      real, dimension(5,100)        :: xpos,xneg
      real, dimension(3)            :: xo,xo1,xo2,xeq,s
      real, dimension(2)            :: vet
      real, dimension(10000)        :: distr2,fourr2,fourrmax,fourrmin
      integer, dimension(10000)     :: nfourr2
      integer, dimension(3)         :: izero
!
      integer, allocatable          :: iph_sav(:)
      real, allocatable             :: wt_sav(:)
!

c     call IndagaMappa_P1(jj,numberToUse,ier)
c     return

!
corig raylim =  4.0   ! xx singolo -  Angela = 7.0
      raylim =  7.0 
      raylim =  4.0 
      raylim0 =  raylim
!
      tmat_sav(1:48,:)  = tmat(1:48,:)
      tsmat_sav(:,:) = tsmat(:,:)
!
      numberToUse = nrefl
      ress = resm
! - dedi prova con riflessi extrapolati
c     numberToUse = nreflDim
c     rhomxx = maxval(rhov(1:nreflDim))
c     ress = 0.5 / sqrt(rhomxx)
!
      nfourr   = 0
      nmapcor  = 0
      nmaplim1  = 0
      nmaplim2  = 0
      nfourr2(:)  = 0
      mapcor(:,:) = 0.0
      distr2(:)   = 0.0
      fourr2(:)   = 0.0
      fourrmax(:) = -1.E+10
      fourrmin(:) = 1.E+10
!
      if (knw == 1) then
          write(6,*) ' Crea Mappa Correzione'

           if (jj < 0) then
               write(6,*) ' F.ne correzione teorica: coef=1 e iphaz=0'
           elseif (jj > 0) then
               write(6,*) ' F.ne  correzione calcolata da atomo',jj
           endif 
      endif

      if (jj < 0) then
          call AllocaCorrMod(1)
!
!--  F.ne correzione teorica
!
          wt(:) = 0 
          iphaz(1:numberToUse) = 0 
          wt(1:numberToUse) = 1 
          fcoef(1:numberToUse) = 1 
 
          tmat(:,:) = 0.0
          tsmat(:,:) = 0.0
          jpatt = 0
          call MakeMap(fcoef,iphaz,numberToUse,jpatt,xmap,FORTH,BACK) 
!
      elseif (jj > 0) then
!
!--  F.ne correzione con Fc per ogni atomo
!  -  SFC da un solo picco
!
          xyzs(:,1) = xyz_model(:,jj)
*         xyzs(1:3,1) = 0.0

          aperc(1) = 1
          nats = 1
          nzS = nz_model(jj) / nzConst
          nz(1) = nzS
          btt = bfac_model(jj) 
          bfac(1) = btt
!
          if (knw ==1) then
              write(6,'(a6,4f10.5,i4,f8.3)') 
     *                  'XXX',xyzs(1:3,1),xyzs(5,1),nzS,btt
          endif

          iref  = 0
          mode  = 1
          ifBreak = 0
          iCoeff = 2
          call sftryyyc(iref,mode,numberToUse,scalan,ifBreak,iCoeff)
c- calcolo wt compreso in sftryyyc
!
          wt(1:numberToUse) = 1.0
          fcoef(1:numberToUse)=fcvet(1:numberToUse) * wt(1:numberToUse)
          jpatt = 0
          call MakeMap(fcoef,iphaz,numberToUse,jpatt,xmap,FORTH,BACK) 

      endif
!
! -- Routines Angela  (indagamappa)
!
      ifin = icent + 1 
      vet(1)= 1.0
      vet(2)=-1.0

      natbb = 100

      aperc(1) = natbb
      iflagPKS = 0
      mode = -1
      nnuu = numberToUse
      krecy = 0
      call pksrch_New(mode, iflagPKS, nnuu,ier)
      if (ier /= 0) then
          return
      endif

      nats = min0(nats,natbb)
      xpos(:,1:nats) = xyzs(:,1:nats)

      x1=side(xyzs(1,1))
      y1=side(xyzs(2,1))
      z1=side(xyzs(3,1))
!     write(6,'(a,3f17.5)') 'XXX_F.ne',x1,y1,z1

          izero(:) = 1
          rrr =  raylim
          nunit = 99
          call Radial_Distrib(x1,y1,z1,nunit,rrr,izero)
     
      iprin = 0
      if (iprin == 1) then
          izero(:) = 1
          nnuu = 40 + Iterazione
          call Write_CCP4_Map(xmap, nnuu)
          nunit = 140 + Iterazione
          call Radial_Distrib(x1,y1,z1,nunit,raylim,izero)
      endif

!     write(6,*) '  Nats - pos = ', nats

      dminpos=1.E+10     
      xo2(1)=side(xyzs(1,1))
      xo2(2)=side(xyzs(2,1))
      xo2(3)=side(xyzs(3,1))
!     write(6,'(a3,3f17.5)') 'YYY',xo2(1:3)

      do i=1,nats
         xo1(1)=side(xpos(1,i))
         xo1(2)=side(xpos(2,i))
         xo1(3)=side(xpos(3,i))
         dmin=1.E+10
         do kk1=1,ncentr
            do kk2=1,ifin
               coef=vet(kk2)
               do kk3=1,nsym
                   call xequi(xo2,kk3,coef,xeq,kk1)
                   call xdist(xo1,xeq,d,s)
                   if(d.lt.dmin) dmin=d
               enddo
            enddo
         enddo
         if(dmin.lt.dminpos.and.dmin.gt.0.5)dminpos=dmin   !???  Angela > 1.5; Dedi > 0.5
         write(80,11) xeq,xo1,xyzs(4,i),dmin
      enddo
 11   format(6f10.5,f15.2,f10.5)
      if (knw == 1) 
     *    write(6,*)'distanza primo ripple positivo',dminpos
!
!  -- ricerca dei picchi megativi
!
      xmap(:,:,:) = -xmap(:,:,:)

      aperc(1) = natbb
      iflagPKS = 0
      mode = -1
      nnuu = numberToUse
      krecy = 0
      call pksrch_New(mode, iflagPKS, nnuu,ier)
      if (ier /= 0) then
          return
      endif

      nats = min0(nats,natbb)
      xneg(:,1:nats) = xyzs(:,1:nats)

!     write(6,*) '  Nats - neg = ', nats

      dminneg=1.E+10     
      do i=1,nats
         xo1(1)=side(xneg(1,i))
         xo1(2)=side(xneg(2,i))
         xo1(3)=side(xneg(3,i))
         dmin=1.E+10
         do kk1=1,ncentr
            do kk2=1,ifin
               coef=vet(kk2)
               do kk3=1,nsym
                   call xequi(xo2,kk3,coef,xeq,kk1)
                   call xdist(xo1,xeq,d,s)
                   if(d.lt.dmin) dmin=d
               enddo
            enddo
         enddo
         if(dmin.lt.dminneg)dminneg=dmin
         write(90,11) xeq,xo1,xyzs(4,i),dmin
      enddo
!
      if (knw ==1) write(6,*)'distanza primo picco negativo',dminneg
      if (dminneg.gt.dminpos) then
          ddd = dminneg
      else
          ddd = dminpos
      endif

      dminneg2=1.E+10
      do i=1,nats
         xo1(1)=side(xneg(1,i))
         xo1(2)=side(xneg(2,i))
         xo1(3)=side(xneg(3,i))
         dmin=1.E+10
         do kk1=1,ncentr
            do kk2=1,ifin
               coef=vet(kk2)
               do kk3=1,nsym
                   call xequi(xo2,kk3,coef,xeq,kk1)
                   call xdist(xo1,xeq,d,s)
                   if(d.lt.dmin) dmin=d
               enddo
            enddo
         enddo
         if(dmin.gt.ddd.and.dmin.lt.dminneg2)dminneg2=dmin
      enddo
      if (knw ==1) write(6,*)'distanza primo ripple negativo',dminneg2

      dminpos2=1.E+10
      do i=1,nats
         xo1(1)=side(xpos(1,i))
         xo1(2)=side(xpos(2,i))
         xo1(3)=side(xpos(3,i))
         dmin=1.E+10
         do kk1=1,ncentr
            do kk2=1,ifin
               coef=vet(kk2)
               do kk3=1,nsym
                   call xequi(xo2,kk3,coef,xeq,kk1)
                   call xdist(xo1,xeq,d,s)
                   if(d.lt.dmin) dmin=d
               enddo
            enddo
         enddo
         if(dmin.gt.dminneg2.and.dmin.lt.dminpos2)dminpos2=dmin
      enddo
      if (knw ==1) write(6,*)'distanza secondo ripple positivo',dminpos2

      dminneg3=1.E+10
      do i=1,nats
         xo1(1)=side(xneg(1,i))
         xo1(2)=side(xneg(2,i))
         xo1(3)=side(xneg(3,i))
         dmin=1.E+10
         do kk1=1,ncentr
            do kk2=1,ifin
               coef=vet(kk2)
               do kk3=1,nsym
                   call xequi(xo2,kk3,coef,xeq,kk1)
                   call xdist(xo1,xeq,d,s)
                   if(d.lt.dmin) dmin=d
               enddo
            enddo
         enddo
         if(dmin.gt.dminpos2.and.dmin.lt.dminneg3)dminneg3=dmin
      enddo
      if (knw ==1) write(6,*)'distanza secondo ripple negativo',dminneg3

      xmap(:,:,:) = -xmap(:,:,:)

      aperc(1) = natbb
      iflagPKS = 0
      mode = -1
      nnuu = numberToUse
      krecy = 0
      call pksrch_New(mode, iflagPKS, nnuu,ier)
      if (ier /= 0) then
          return
      endif

      dx=1.0/float(np(1))
      dy=1.0/float(np(2))
      dz=1.0/float(np(3))
      j1sav=0
      j2sav=0
      j3sav=0
      xmapmax=-1.E+10
      do j1=0,np(1)-1
        do j2=0,np(2)-1
          do j3=0,np(3)-1
              if(xmap(j1,j2,j3).gt.xmapmax)then
                 xmapmax=xmap(j1,j2,j3)
                 j1sav=j1
                 j2sav=j2
                 j3sav=j3
              endif
          enddo
        enddo
      enddo
      xo(1)=float(j1sav)*dx
      xo(2)=float(j2sav)*dy
      xo(3)=float(j3sav)*dz
      distmax=-1.E+10       
      do j3=0,np(3)-1
        do j2=0,np(2)-1
          do j1=0,np(1)-1
               xx1=float(j1)*dx
               yy1=float(j2)*dy
               zz1=float(j3)*dz
               xo1(1)=xx1
               xo1(2)=yy1
               xo1(3)=zz1
               dmin=1.E+10
               do kk1=1,ncentr
                  do kk2=1,ifin
                     coef=vet(kk2)
                     do kk3=1,nsym
                         call xequi(xo,kk3,coef,xeq,kk1)
                         call xdist(xo1,xeq,d,s)
                         if(d.lt.dmin) dmin=d
                     enddo
                  enddo
               enddo
               if (dmin.gt.distmax) distmax=dmin
               nfourr=nfourr+1
               distr(nfourr)=dmin
               fourr(nfourr)=xmap(j1,j2,j3)
          enddo
        enddo
      enddo
 10   format(3i5,2f15.3,3f10.3)

      fourrr(1:nfourr,1)=distr(1:nfourr)
      fourrr(1:nfourr,2)=fourr(1:nfourr)
      call ordinatab(fourrr(1:nfourr,1:2),1)
      distr(1:nfourr)=fourrr(1:nfourr,1)
      fourr(1:nfourr)=fourrr(1:nfourr,2)

      dminnegmin=-99999999.0
      do i=1,nfourr
        if (distr(i).lt.dminneg.and.fourr(i).gt.xmapmax*0.5.and.
     *                              distr(i).gt.dminnegmin) then
            dminnegmin=distr(i)
            sigma1=distr(i)
        endif
      enddo
!pezza - dedi 15/07/09  sigma1 /= 0
      if (sigma1 < 0.00001) then
          do i=1,nfourr
             if (distr(i).gt.0.00001) then
                 sigma1=distr(i) * 0.5
                 exit
             endif
          enddo
      endif
!pezza - dedi 15/07/09
!!!!!!!!!!!!!!!!!!!!!!!!!!!
      if (knw ==1) 
     * write(6,*)'distmax',distmax,'  sigma1',sigma1,'  resolution',ress
      if (jj < 0) then
          sigma1_indaga = sigma1
      elseif (jj > 0) then
          info_fne(1,jj) = sigma1
          info_fne(2,jj) = dminneg
      endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!
      isav=0
      dminnegmin=1.E+10
      do i=1,nfourr
         if (distr(i).lt.dminneg.and.fourr(i).lt.0.0.and.
     *                           distr(i).lt.dminnegmin) then
            dminnegmin=distr(i)
            isav=i
         endif
      enddo

      isav=0
      dminnegmin=1.E+10     
      do i=1,nfourr
        if (distr(i).lt.dminnegmin) then
            dminnegmin=distr(i)
            isav=i
        endif
      enddo

      ndstep=2000
      dstep=(distmax-distr(isav))/float(ndstep-1)
      do i=1,nfourr
         do k=1,ndstep
            dstep1=distr(isav)+(k-1)*dstep
            dstep2=distr(isav)+k*dstep
            if (k.eq.1) then
                dstep1=0.0
                dstep2=distr(isav)
            endif
            if (k.eq.ndstep) dstep2=distr(isav)+(k+1)*dstep
            if (distr(i).ge.dstep1.and.distr(i).lt.dstep2) then
                nfourr2(k)=nfourr2(k)+1
                distr2(k)=dstep2                  
                fourr2(k)=fourr2(k)+fourr(i)
                if ((fourr(i)).gt.fourrmax(k)) fourrmax(k)=fourr(i)
                if ((fourr(i)).lt.fourrmin(k)) fourrmin(k)=fourr(i)
                exit
           endif
         enddo
      enddo
      do i=1,ndstep
         if (nfourr2(i).gt.0) then
             fourr2(i)=fourr2(i)/float(nfourr2(i))
             fourr2(i)=fourrmax(i)                            
!            write(6,'(2f15.5)') distr2(i),fourr2(i)
         endif
      enddo
      isav=0
      do i=1,ndstep
         if (fourr2(i).lt.0.0) then
c        if (fourr2(i).lt.0.0.and.distr2(i).lt.2.5)then
             isav=i
             exit
          endif
      enddo
      if (isav.eq.0) then
          dminnegmin=1.E+10      
          do i=2,ndstep
            if (distr2(i).lt.dminpos.and.distr2(i).gt.0.8.and.
     *                                   fourr2(i).lt.dminnegmin) then
                dminnegmin=distr2(i)
                isav=i
                exit
            endif
          enddo
          if (dminneg.gt.1000.0) dminneg=distr2(isav)
      endif
! - Calcolo raylim
      do i=1,ndstep
         if (distr2(i).gt.dminpos .and. fourr2(i).lt.0.0) then
             raylim1 = distr2(i)
             exit
         endif
      enddo
      do i=1,ndstep
         if (distr2(i).gt.dminneg2 .and. fourr2(i).gt.0.0) then
c        if (distr2(i).gt.dminneg3 .and. fourr2(i).gt.0.0) then
             raylim2 = distr2(i)
             exit
         endif
      enddo

      raylim = max(raylim1,raylim2)
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     write(6,*)'lim1',distr2(isav)
!     write(6,*)'raylim',raylim
!!!!!!!!!!!!!!!!!!!!!!!!!!!

      do i=1,ndstep
         if (i.ge.isav) fourr2(i)=-fourr2(i)/xmapmax    
      enddo
      fourr2(1:isav-1)=0.0
      do i=1,ndstep
         if (distr2(i).gt.raylim) fourr2(i)=0.0    ! raylim 
!        if (nfourr2(i).gt.0) then
!            write(6,'(2f15.5,i5)') distr2(i),fourr2(i),nfourr2(i)
!        endif
      enddo
      isav=0
!     write(6,*)'dminpos',dminpos
      do i=2,ndstep
         if (distr2(i).gt.dminpos.and.fourr2(i).gt.0.0) then
             isav=i
             exit
         endif
      enddo
!     if (isav > 0) then
!        write(6,*)'isav',isav,distr2(isav),fourr2(isav)
!     else
!         zero = 0.0
!         write(6,*)'isav',isav,zero,zero
!     endif
      do i=1,ndstep
         if (nfourr2(i).gt.0) then
             nmapcor=nmapcor+1
             mapcor(1,nmapcor)=distr2(i)
             mapcor(2,nmapcor)=fourr2(i)
          endif
      enddo
 555  continue
!     do i=1,nmapcor
!         write(6,'(2f15.5)') mapcor(1:2,i)
!     enddo
      isav1=0
      isav2=0
      do i=1,nmapcor
         if (abs(mapcor(2,i)).gt.0.0) then
            isav1=i
            exit
         endif
      enddo
      do i=nmapcor,1,-1
         if (abs(mapcor(2,i)).gt.0.0) then
            isav2=i
            exit
          endif
      enddo
      mapcor(2,1:isav1-1)=0.0
      nmaplim1 = isav1
      do kt=1,nmapcor
         if (mapcor(1,kt) > raylim) then
             nmaplim2 = kt - 1
             exit
          endif
      enddo
      if (nmaplim2 == 0) nmaplim2 = nmapcor
      do i=1,nmapcor
          write(66,'(2f15.5)') mapcor(1:2,i)
      enddo
      
      raylim0 = raylim

*     write(6,*)'JJJJJJJJJJ',nmapcor,nmaplim1,nmaplim2
*     write(6,*)'JJJJJJJJJJ',isav1,isav2,nmapcor
!
      if (jj < 0) then
          call AllocaCorrMod(2)
          tmat(1:48,:) = tmat_sav(1:48,:)
          tsmat(:,:) = tsmat_sav(:,:)
      endif
!
      return
      end
!------------------------------------------------------------------------------
      subroutine IndagaMappa_P1(jj,numberToUse,ier)
!
      USE General
      USE Symmetry     
      USE Riflessi
      USE TestModel
      USE TestStuff, only:ifFloatOrigin
      USE PhaseModule     
      USE Atomi
      USE Mappa
      USE CorrMod
!
      USE GaussModule  ! per usare ordinatab
!
      common /cent/ tl(3,4),fs(3,3,24),mlat
      common /centsav/ tlsav(12),fsSav(216)
      common/passainp1com/numbLSQ_Sav,numbInv_Sav,
     &               nreflDim_Sav,nrefl_Sav,ifExamin_Sav,
     &               icent_Sav,pts_Sav
!
      character patom*256
!
      real, dimension(5,100)        :: xpos,xneg
      real, dimension(3)            :: xo,xo1,xo2,xeq,s
      real, dimension(2)            :: vet
      real, dimension(10000)        :: distr2,fourr2,fourrmax,fourrmin
      integer, dimension(10000)     :: nfourr2
      integer, dimension(3)         :: izero
!
      integer, allocatable          :: iph_sav(:)
      real, allocatable             :: wt_sav(:)
!
corig raylim =  4.0   ! xx singolo -  Angela = 7.0
      raylim =  7.0 
      raylim =  4.0 
      raylim0 =  raylim
!
      numberToUse = nrefl
      ress = resm
! - dedi prova con riflessi extrapolati
c     numberToUse = nreflDim
c     rhomxx = maxval(rhov(1:nreflDim))
c     ress = 0.5 / sqrt(rhomxx)
!
      nfourr   = 0
      nmapcor  = 0
      nmaplim1  = 0
      nmaplim2  = 0
      nfourr2(:)  = 0
      mapcor(:,:) = 0.0
      distr2(:)   = 0.0
      fourr2(:)   = 0.0
      fourrmax(:) = -1.E+10
      fourrmin(:) = 1.E+10
!
      write(6,*) ' PASSA IN P1'

      if (ifFloatOrigin == 0) then
          ifFloatOrigin = 1
          call AllocaTestStuff(3)
      endif

      ifExamin_Sav = ifExamin
      ifExamin = 1
      jsys_Sav  = jsys
      latt_Sav  = latt
      icent_Sav = icent
      nsym_Sav  = nsym
      pts_Sav   = pts
      anat_Sav  = anat
      natm_Sav  = natm

      numbGen_Sav  = numbGen
      numbLSQ_Sav  = numbLSQ
      numbInv_Sav  = numbInv
      nreflDim_Sav = nreflDim
      nrefl_Sav    = nrefl
      nstr_Sav     = nstr
      numberToUse_Sav = numberToUse

      ifReduced = 1
      icent = 0
      pts   = 1
      nsym  = 1
      jsys  = 1
      totop = pts * float( ( icent + 1 ) * nsym )
      nsymTot=nsym*(icent+1)*pts

      anat=float(nat)/(pts*float((icent+1)*nsym))
      natm=int(anat+0.5)

      mlat =  pts
      k = 0
      do i=1,3
         do j=1,4
            k = k + 1
            tlSav(k) = tl(i,j)
            tl(i,j) = 0
         enddo
      enddo
      k = 0
      do i=1,3
         do j=1,3
            do l=1,24
               k = k + 1
               fsSav(k) = fs(i,j,l)
               fs(i,j,l) = 0
            enddo
         enddo
      enddo
      do i=1,3
         fs(i,i,1) = 1
      enddo
c
      jspini = -1
      call xspinb
      call scrper(' ',0,-1)
      lixx = InfoOK(6)
      if (lixx.gt.0) then
          call LoadReflInfo
      else
          nrefltot = 0
          stop 'nrefltot = 0'
      endif

      write(6,*)'IN SG  nreflDim,nrefl,numberToUse,nstr',
     *                  nreflDim,nrefl,numberToUse,nstr
!
!--   Lavoro solo sui rifelssi osservati  !!!
!
      nrefltot = nrefl
      nreflDim = sum(mult(1:nrefltot))  ! gianluca 16/04/2007
      numberToUse = numberToUse * nsymTrue
      numberToUse = min(nreflDim,numberToUse)
      nrefl    = nrefl * nsymTrue
      nstr = nstr * nsymTrue
      nstr = min0(nstr,maxstr * 2)
      nstrP1 = nstr
c
      call AllocaRiflessi(2)
      call AllocaAtomi(2)
!
      call AllocaRiflessi(1)
      call AllocaAtomi(1)
!
      wt(:)    = 0.0
      iphaz(:) = 0
!
      ier = 0
      if (nrefltot.gt.0) then
          ksubr = 3
          call LeggiRiflessi(ier,ksubr)
      endif

      write(6,*)'IN P1  nreflDim,nrefl,numberToUse,nstr',
     *                  nreflDim,nrefl,numberToUse,nstr
!
      if (knw == 1) then
          write(6,*) ' Crea Mappa Correzione'

           if (jj < 0) then
               write(6,*) ' F.ne correzione teorica: coef=1 e iphaz=0'
           elseif (jj > 0) then
               write(6,*) ' F.ne  correzione calcolata da atomo',jj
           endif 
      endif

      if (jj < 0) then
          call AllocaCorrMod(1)
!
!--  F.ne correzione teorica
!
          wt(:) = 0 
          iphaz(1:numberToUse) = 0 
          wt(1:numberToUse) = 1 
          fcoef(1:numberToUse) = 1 
 
          jpatt = 0
          call MakeMap(fcoef,iphaz,numberToUse,jpatt,xmap,FORTH,BACK) 
!
      elseif (jj > 0) then
!
!--  F.ne correzione con Fc per ogni atomo
!  -  SFC da un solo picco
!
          xyzs(:,1) = xyz_model(:,jj)
*         xyzs(1:3,1) = 0.0

          aperc(1) = 1
          nats = 1
          nzS = nz_model(jj) / nzConst
          nz(1) = nzS
          btt = bfac_model(jj) 
          bfac(1) = btt
!
          if (knw ==1) then
              write(6,'(a6,4f10.5,i4,f8.3)') 
     *                  'XXX',xyzs(1:3,1),xyzs(5,1),nzS,btt
          endif

          iref  = 0
          mode  = 1
          ifBreak = 0
          iCoeff = 2
          call sftryyyc(iref,mode,numberToUse,scalan,ifBreak,iCoeff)
c- calcolo wt compreso in sftryyyc
!
          wt(1:numberToUse) = 1.0
          fcoef(1:numberToUse)=fcvet(1:numberToUse) * wt(1:numberToUse)
          jpatt = 0
          call MakeMap(fcoef,iphaz,numberToUse,jpatt,xmap,FORTH,BACK) 

      endif
!
! -- Routines Angela  (indagamappa)
!
      ifin = icent + 1 
      vet(1)= 1.0
      vet(2)=-1.0

      natbb = 100

      aperc(1) = natbb
      iflagPKS = 0
      mode = -1
      nnuu = numberToUse
      krecy = 0
      call pksrch_New(mode, iflagPKS, nnuu,ier)
      if (ier /= 0) then
          return
      endif

      nats = min0(nats,natbb)
      xpos(:,1:nats) = xyzs(:,1:nats)

      x1=side(xyzs(1,1))
      y1=side(xyzs(2,1))
      z1=side(xyzs(3,1))
!     write(6,'(a,3f17.5)') 'XXX_F.ne',x1,y1,z1

          izero(:) = 1
          rrr =  raylim
          nunit = 99
          call Radial_Distrib(x1,y1,z1,nunit,rrr,izero)
     
      iprin = 0
      if (iprin == 1) then
          izero(:) = 1
          nnuu = 40 + Iterazione
          call Write_CCP4_Map(xmap, nnuu)
          nunit = 140 + Iterazione
          call Radial_Distrib(x1,y1,z1,nunit,raylim,izero)
      endif

!     write(6,*) '  Nats - pos = ', nats

      dminpos=1.E+10     
      xo2(1)=side(xyzs(1,1))
      xo2(2)=side(xyzs(2,1))
      xo2(3)=side(xyzs(3,1))
!     write(6,'(a3,3f17.5)') 'YYY',xo2(1:3)

      do i=1,nats
         xo1(1)=side(xpos(1,i))
         xo1(2)=side(xpos(2,i))
         xo1(3)=side(xpos(3,i))
         dmin=1.E+10
         do kk1=1,ncentr
            do kk2=1,ifin
               coef=vet(kk2)
               do kk3=1,nsym
                   call xequi(xo2,kk3,coef,xeq,kk1)
                   call xdist(xo1,xeq,d,s)
                   if(d.lt.dmin) dmin=d
               enddo
            enddo
         enddo
         if(dmin.lt.dminpos.and.dmin.gt.0.5)dminpos=dmin   !???  Angela > 1.5; Dedi > 0.5
         write(80,11) xeq,xo1,xyzs(4,i),dmin
      enddo
 11   format(6f10.5,f15.2,f10.5)
      if (knw == 1) 
     *    write(6,*)'distanza primo ripple positivo',dminpos
!
!  -- ricerca dei picchi megativi
!
      xmap(:,:,:) = -xmap(:,:,:)

      aperc(1) = natbb
      iflagPKS = 0
      mode = -1
      nnuu = numberToUse
      krecy = 0
      call pksrch_New(mode, iflagPKS, nnuu,ier)
      if (ier /= 0) then
          return
      endif

      nats = min0(nats,natbb)
      xneg(:,1:nats) = xyzs(:,1:nats)

!     write(6,*) '  Nats - neg = ', nats

      dminneg=1.E+10     
      do i=1,nats
         xo1(1)=side(xneg(1,i))
         xo1(2)=side(xneg(2,i))
         xo1(3)=side(xneg(3,i))
         dmin=1.E+10
         do kk1=1,ncentr
            do kk2=1,ifin
               coef=vet(kk2)
               do kk3=1,nsym
                   call xequi(xo2,kk3,coef,xeq,kk1)
                   call xdist(xo1,xeq,d,s)
                   if(d.lt.dmin) dmin=d
               enddo
            enddo
         enddo
         if(dmin.lt.dminneg)dminneg=dmin
         write(90,11) xeq,xo1,xyzs(4,i),dmin
      enddo
!
!-- ricerca del primo minimo non negativo
!
c     if (dminneg.gt.dminpos) then
c         xmap(:,:,:) = -xmap(:,:,:)
c         call NegativePeak(xpos(1:3,1),xpos(1:3,i2),dminneg)
c         xmap(:,:,:) = -xmap(:,:,:)
c     endif
!
      if (knw ==1) write(6,*)'distanza primo ripple negativo',dminneg
      if (dminneg.gt.dminpos) then
          ddd = dminneg
      else
          ddd = dminpos
      endif

      dminneg2=1.E+10
      do i=1,nats
         xo1(1)=side(xneg(1,i))
         xo1(2)=side(xneg(2,i))
         xo1(3)=side(xneg(3,i))
         dmin=1.E+10
         do kk1=1,ncentr
            do kk2=1,ifin
               coef=vet(kk2)
               do kk3=1,nsym
                   call xequi(xo2,kk3,coef,xeq,kk1)
                   call xdist(xo1,xeq,d,s)
                   if(d.lt.dmin) dmin=d
               enddo
            enddo
         enddo
         if(dmin.gt.ddd.and.dmin.lt.dminneg2)dminneg2=dmin
      enddo
      if (knw ==1) write(6,*)'distanza secondo ripple negativo',dminneg2

      dminpos2=1.E+10
      do i=1,nats
         xo1(1)=side(xpos(1,i))
         xo1(2)=side(xpos(2,i))
         xo1(3)=side(xpos(3,i))
         dmin=1.E+10
         do kk1=1,ncentr
            do kk2=1,ifin
               coef=vet(kk2)
               do kk3=1,nsym
                   call xequi(xo2,kk3,coef,xeq,kk1)
                   call xdist(xo1,xeq,d,s)
                   if(d.lt.dmin) dmin=d
               enddo
            enddo
         enddo
         if(dmin.gt.dminneg2.and.dmin.lt.dminpos2)dminpos2=dmin
      enddo
      if (knw ==1) write(6,*)'distanza terzo ripple positivo',dminpos2

      dminneg3=1.E+10
      do i=1,nats
         xo1(1)=side(xneg(1,i))
         xo1(2)=side(xneg(2,i))
         xo1(3)=side(xneg(3,i))
         dmin=1.E+10
         do kk1=1,ncentr
            do kk2=1,ifin
               coef=vet(kk2)
               do kk3=1,nsym
                   call xequi(xo2,kk3,coef,xeq,kk1)
                   call xdist(xo1,xeq,d,s)
                   if(d.lt.dmin) dmin=d
               enddo
            enddo
         enddo
         if(dmin.gt.dminpos2.and.dmin.lt.dminneg3)dminneg3=dmin
      enddo
      if (knw ==1) write(6,*)'distanza terzo ripple negativo',dminneg3

      xmap(:,:,:) = -xmap(:,:,:)

      aperc(1) = natbb
      iflagPKS = 0
      mode = -1
      nnuu = numberToUse
      krecy = 0
      call pksrch_New(mode, iflagPKS, nnuu,ier)
      if (ier /= 0) then
          return
      endif

      dx=1.0/float(np(1))
      dy=1.0/float(np(2))
      dz=1.0/float(np(3))
      j1sav=0
      j2sav=0
      j3sav=0
      xmapmax=-1.E+10
      do j1=0,np(1)-1
        do j2=0,np(2)-1
          do j3=0,np(3)-1
              if(xmap(j1,j2,j3).gt.xmapmax)then
                 xmapmax=xmap(j1,j2,j3)
                 j1sav=j1
                 j2sav=j2
                 j3sav=j3
              endif
          enddo
        enddo
      enddo
      xo(1)=float(j1sav)*dx
      xo(2)=float(j2sav)*dy
      xo(3)=float(j3sav)*dz
      distmax=-1.E+10       
      do j3=0,np(3)-1
        do j2=0,np(2)-1
          do j1=0,np(1)-1
               xx1=float(j1)*dx
               yy1=float(j2)*dy
               zz1=float(j3)*dz
               xo1(1)=xx1
               xo1(2)=yy1
               xo1(3)=zz1
               dmin=1.E+10
               do kk1=1,ncentr
                  do kk2=1,ifin
                     coef=vet(kk2)
                     do kk3=1,nsym
                         call xequi(xo,kk3,coef,xeq,kk1)
                         call xdist(xo1,xeq,d,s)
                         if(d.lt.dmin) dmin=d
                     enddo
                  enddo
               enddo
               if (dmin.gt.distmax) distmax=dmin
               nfourr=nfourr+1
               distr(nfourr)=dmin
               fourr(nfourr)=xmap(j1,j2,j3)
          enddo
        enddo
      enddo
 10   format(3i5,2f15.3,3f10.3)

      fourrr(1:nfourr,1)=distr(1:nfourr)
      fourrr(1:nfourr,2)=fourr(1:nfourr)
      call ordinatab(fourrr(1:nfourr,1:2),1)
      distr(1:nfourr)=fourrr(1:nfourr,1)
      fourr(1:nfourr)=fourrr(1:nfourr,2)

      dminnegmin=-99999999.0
      do i=1,nfourr
        if (distr(i).lt.dminneg.and.fourr(i).gt.xmapmax*0.5.and.
     *                              distr(i).gt.dminnegmin) then
            dminnegmin=distr(i)
            sigma1=distr(i)
        endif
      enddo
!pezza - dedi 15/07/09  sigma1 /= 0
      if (sigma1 < 0.00001) then
          do i=1,nfourr
             if (distr(i).gt.0.00001) then
                 sigma1=distr(i) * 0.5
                 exit
             endif
          enddo
      endif
!pezza - dedi 15/07/09
!!!!!!!!!!!!!!!!!!!!!!!!!!!
      if (knw ==1) 
     * write(6,*)'distmax',distmax,'  sigma1',sigma1,'  resolution',ress
      if (jj < 0) then
          sigma1_indaga = sigma1
      elseif (jj > 0) then
          info_fne(1,jj) = sigma1
          info_fne(2,jj) = dminneg
      endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!
      isav=0
      dminnegmin=1.E+10
      do i=1,nfourr
         if (distr(i).lt.dminneg.and.fourr(i).lt.0.0.and.
     *                           distr(i).lt.dminnegmin) then
            dminnegmin=distr(i)
            isav=i
         endif
      enddo

      isav=0
      dminnegmin=1.E+10     
      do i=1,nfourr
        if (distr(i).lt.dminnegmin) then
            dminnegmin=distr(i)
            isav=i
        endif
      enddo

      ndstep=2000
      dstep=(distmax-distr(isav))/float(ndstep-1)
      do i=1,nfourr
         do k=1,ndstep
            dstep1=distr(isav)+(k-1)*dstep
            dstep2=distr(isav)+k*dstep
            if (k.eq.1) then
                dstep1=0.0
                dstep2=distr(isav)
            endif
            if (k.eq.ndstep) dstep2=distr(isav)+(k+1)*dstep
            if (distr(i).ge.dstep1.and.distr(i).lt.dstep2) then
                nfourr2(k)=nfourr2(k)+1
                distr2(k)=dstep2                  
                fourr2(k)=fourr2(k)+fourr(i)
                if ((fourr(i)).gt.fourrmax(k)) fourrmax(k)=fourr(i)
                if ((fourr(i)).lt.fourrmin(k)) fourrmin(k)=fourr(i)
                exit
           endif
         enddo
      enddo
      do i=1,ndstep
         if (nfourr2(i).gt.0) then
             fourr2(i)=fourr2(i)/float(nfourr2(i))
             fourr2(i)=fourrmax(i)                            
!            write(6,'(2f15.5)') distr2(i),fourr2(i)
         endif
      enddo
      isav=0
      do i=1,ndstep
         if (fourr2(i).lt.0.0) then
c        if (fourr2(i).lt.0.0.and.distr2(i).lt.2.5)then
             isav=i
             exit
          endif
      enddo
      if (isav.eq.0) then
          dminnegmin=1.E+10      
          do i=2,ndstep
            if (distr2(i).lt.dminpos.and.distr2(i).gt.0.8.and.
     *                                   fourr2(i).lt.dminnegmin) then
                dminnegmin=distr2(i)
                isav=i
                exit
            endif
          enddo
          if (dminneg.gt.1000.0) dminneg=distr2(isav)
      endif
! - Calcolo raylim
      do i=1,ndstep
         if (distr2(i).gt.dminpos .and. fourr2(i).lt.0.0) then
             raylim1 = distr2(i)
             exit
         endif
      enddo
      do i=1,ndstep
         if (distr2(i).gt.dminneg2 .and. fourr2(i).gt.0.0) then
c        if (distr2(i).gt.dminneg3 .and. fourr2(i).gt.0.0) then
             raylim2 = distr2(i)
             exit
         endif
      enddo

      raylim = max(raylim1,raylim2)
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     write(6,*)'lim1',distr2(isav)
!     write(6,*)'raylim',raylim
!!!!!!!!!!!!!!!!!!!!!!!!!!!

      do i=1,ndstep
         if (i.ge.isav) fourr2(i)=-fourr2(i)/xmapmax    
      enddo
      fourr2(1:isav-1)=0.0
      do i=1,ndstep
         if (distr2(i).gt.raylim) fourr2(i)=0.0    ! raylim 
!        if (nfourr2(i).gt.0) then
!            write(6,'(2f15.5,i5)') distr2(i),fourr2(i),nfourr2(i)
!        endif
      enddo
      isav=0
!     write(6,*)'dminpos',dminpos
      do i=2,ndstep
         if (distr2(i).gt.dminpos.and.fourr2(i).gt.0.0) then
             isav=i
             exit
         endif
      enddo
!     if (isav > 0) then
!        write(6,*)'isav',isav,distr2(isav),fourr2(isav)
!     else
!         zero = 0.0
!         write(6,*)'isav',isav,zero,zero
!     endif
      do i=1,ndstep
         if (nfourr2(i).gt.0) then
             nmapcor=nmapcor+1
             mapcor(1,nmapcor)=distr2(i)
             mapcor(2,nmapcor)=fourr2(i)
          endif
      enddo
 555  continue
!     do i=1,nmapcor
!         write(6,'(2f15.5)') mapcor(1:2,i)
!     enddo
      isav1=0
      isav2=0
      do i=1,nmapcor
         if (abs(mapcor(2,i)).gt.0.0) then
            isav1=i
            exit
         endif
      enddo
      do i=nmapcor,1,-1
         if (abs(mapcor(2,i)).gt.0.0) then
            isav2=i
            exit
          endif
      enddo
      mapcor(2,1:isav1-1)=0.0
      nmaplim1 = isav1
      do kt=1,nmapcor
         if (mapcor(1,kt) > raylim) then
             nmaplim2 = kt - 1
             exit
          endif
      enddo
      if (nmaplim2 == 0) nmaplim2 = nmapcor
      do i=1,nmapcor
          write(66,'(2f15.5)') mapcor(1:2,i)
      enddo
      
      raylim0 = raylim

*     write(6,*)'JJJJJJJJJJ',nmapcor,nmaplim1,nmaplim2
*     write(6,*)'JJJJJJJJJJ',isav1,isav2,nmapcor
!
!--------------------------------------------------------------
!
      write(6,*) ' TORNA IN SG'

      call AllocaTestStuff(2)
      ifReduced = 0
      call AllocaTestStuff(1)  ! ripristina ifFloatOrigin e FT

      call AllocaRiflessi(2)
      call AllocaAtomi(2)
!
      jsys    = jsys_Sav
      latt    = latt_Sav
      pts     = pts_Sav
      icent   = icent_Sav
      nsym    = nsym_Sav
      anat    = anat_Sav
      natm    = natm_Sav
      nsymTot = nsym*(icent+1)*mlat
      totop    = pts * float( ( icent + 1 ) * nsym )
c
      mlat =  pts
      k = 0
      do i=1,3
         do j=1,4
            k = k + 1
            tl(i,j) = tlSav(k)
         enddo
      enddo
      k = 0
      do i=1,3
         do j=1,3
            do l=1,24
               k = k + 1
               fs(i,j,l) = fsSav(k)
            enddo
         enddo
      enddo
c
      jspini = -1
      call xspinb

      numbGen  = numbGen_Sav
      numbLSQ  = numbLSQ_Sav
      numbInv  = numbInv_Sav
      nreflDim = nreflDim_Sav
      nrefl    = nrefl_Sav
      nstr     = nstr_Sav
      numberToUse = numberToUse_Sav
      ifReduced = 0
!
      call AllocaAtomi(1)
      call AllocaRiflessi(1)

      ksubr = 3
      call LeggiRiflessi(ier,ksubr)

      write(6,*)'IN SG  nreflDim,nrefl,numberToUse,nstr',
     *                  nreflDim,nrefl,numberToUse,nstr
!
      if (jj < 0) then
          call AllocaCorrMod(2)
      endif
!
      return
      end
!------------------------------------------------------------------------------
      subroutine MapCorrection(jlig,numberToUse,ier)
!
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Param
      USE Mappa
      USE MappaCorrezione
      USE CorrMod
      USE PhaseModule
      USE TestModel
      
      real,dimension(4)     :: xmin
      real,dimension(3)     :: xs,xeq,s
      real,dimension(2)     :: vet
      character * 256 patom

! -- Eo
c     fcoef(1:numberToUse)= evet(1:numberToUse) *
! -- 2Fo-Fc
      fcoef(1:numberToUse)= fcoef(1:numberToUse) *
     *                               wt(1:numberToUse)
      jpatt = 0
      call MakeMap(fcoef, iphaz, numberToUse, jpatt, xmap, FORTH, BACK) 
!
      xmapApp(:,:,:) = 0.0
      xmapApp(:,:,:) = xmap(:,:,:) 
      npksig = NatUsed
!
!     nnuu = 10
!     call Write_CCP4_Map(xmap, nnuu)

      call scrper('Map Correction Procedure        ',0,0)
      call CorreggiMappa(jlig,numberToUse,ier)

!     nnuu = 20
!     call Write_CCP4_Map(xmap, nnuu)

      xmapApp(:,:,:) = xmap(:,:,:)

      return
      end
!-----------------------------------------------------------------------
      subroutine CorreggiMappa(jlig,numberToUse,ier)
!
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE MappaCorrezione
      USE CorrMod
      USE PhaseModule     
!
      USE GaussModule  ! per usare GaussPicco
!
      common / AngelaC / jcic
      character cItera*5 , line*80
!
      real, dimension(4)       :: xmin
      real, dimension(3)       :: xo,xs,xeq,s
      real, dimension(2)       :: vet

      real, dimension(11)      :: xo2,xo3
      integer, dimension(10)   :: key
!
      zero = 0.0000000001
      raylim0 = raylim
!
      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)

      ca=cos(cell(4)*dtor)
      cb=cos(cell(5)*dtor)
      cg=cos(cell(6)*dtor)

      dx=1.0/float(np(1))
      dy=1.0/float(np(2))
      dz=1.0/float(np(3))
!
      xmap(:,:,:)     = 0.0 
      xmap2(:,:,:)    = 0.0 

      xmap(:,:,:)     = xmapApp(:,:,:) 
      xmap2(:,:,:)    = xmapApp(:,:,:) 
 

      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1

      aperc(1) = NatUsed
      iflagPKS = 0
      mode = -1
      nnuu = numberToUse
      krecy = 0
      call pksrch_New(mode, iflagPKS, nnuu,ier)
      if (ier /= 0) then
          return
      endif
!
      nne  = nats
      nz(1:nats) = jlig
      call label(nne)
      call MakeLab(1,nats)
!
      kdst = 0  !2
      call to_coord_sir(kdst, numberToUse)
!
!     goto 333

      do jcic = 1,1  !2

*     xmap(:,:,:)     = xmapApp(:,:,:) 
!
      if (knw > 0) write(lo,*) 
     *             '  ***  PERFORMING MAP CORRECTION ...  ***'
      coefmd = 0.5

      ncicT = 2
      do ncic = 1,ncicT  ! doppio ciclo  (correzione parziale x 2 volte)

         do j = 1,nats

            deqmin = 999999.9
            xs(1:3) = xyzs(1:3,j)
            do kk1=1,ncentr
               do kk2=1,ifin
                  coef=vet(kk2)
                  do kk3=1,nsym
                     call xequi(xs,kk3,coef,xeq,kk1)
                     call xdist(xeq,xs,d,s)
                     if (d > zero .and. d < deqmin) then
                         deqmin = d
                     endif
                  enddo
               enddo
            enddo
!
            write(cItera,"(i2,'/',i2)") ncic, ncicT
            call NoBlanks(cItera,ncara)
            write(line,10) cItera(1:ncara)
            call scrper(line,j,nats)
   10 format (' Map Correction Procedure'
     * ': Ripples Removing Step -  Cycle # ',a)

!
            if (deqmin < raylim0) then
                raylim = deqmin / 2
            else
                raylim = raylim0
            endif
!
                xo(1:3) = xyzs(1:3,j)
                hint = xyzs(4,j)

                call ModificaPicco(j,xo,hint,coefmd)
!
         enddo    ! nats
!
         xmap(:,:,:)     = 0.0 
         xmap(:,:,:)     = xmap2(:,:,:) 

         aperc(1) = NatUsed
         iflagPKS = 0
         mode = -1
         nnuu = numberToUse
         krecy = 0
         call pksrch_New(mode, iflagPKS, nnuu,ier)
         if (ier /= 0) then
             return
         endif
!
         nne  = nats
         nz(1:nats) = jlig
         call label(nne)
         call MakeLab(1,nats)
!
!        kdst = 0  !2
!        call to_coord_sir(kdst, numberToUse)

      enddo    ! ncic

 333  continue
!
!     write(6,*)'  ***  DOPO MAPCORRECTION  *** '
!
!     do jj = 1,nats
!        write(ipri,'(a,i5,3f15.8,f20.8)') 'Picco Mod. ',jj,xyzs(1:4,jj)
!     enddo

!     kdst = 0 !2
!     call to_coord_sir(kdst, numberToUse)
       

*          go to  999

!
!  --  Applico GAUSSIANA
!
      if (knw> 0) write(lo,*) 
     *            '  ***  APPLYING GAUSSIAN MODIFICATION ...  ***'
!     write(lo,*) '  ***  Sigma1, Sigma1_indaga  ***',
!    *                    sigma1, sigma1_indaga
      xmap2sav(:,:,:) = 0.0
      do j = 1,nats
         xo(1)=side(xyzs(1,j))
         xo(2)=side(xyzs(2,j))
         xo(3)=side(xyzs(3,j))
         hint = xyzs(4,j)
   
         if (hint.lt.0.0) write(6,*)'ERROR, ATOM',j,hint
   
         sigma1sav=sigma1_indaga
!
         write(line,20)
         call scrper(line,j,nats)
   20 format (' Map Correction Procedure: Gaussian Modification Step')

         call GaussPicco(j,xo,hint,sigma1sav)

      enddo !nats

      xmap(:,:,:)     = 0.0
      xmap(:,:,:)     = xmap2(:,:,:)

      aperc(1) = NatUsed
      iflagPKS = 0
      mode = -1
      nnuu = numberToUse
      krecy = 0
      call pksrch_New(mode, iflagPKS, nnuu,ier)
      if (ier /= 0) then
          return
      endif

!     write(6,*) '  ***  DOPO  GAUSSIANA  ***'

!     ipri = 6
!     do jj = 1,nats
!        write(ipri,'(a,i5,3f15.8,f20.8)') 'Picco Gaus.',jj,xyzs(1:4,jj)
!        write(ipri,'(a,i5,3f15.8,f20.8,f15.8)') 
!    *         'Picco Gaus.',jj,xyzs(1:4,jj),xyzs4(jj)
!     enddo

         nne  = nats
         nz(1:nats) = jlig
         call label(nne)
         call MakeLab(1,nats)
 
 999  continue

      kdst = 1 !0  !2
      call to_coord_sir(kdst, numberToUse)
!
      raylim = raylim0
!
      enddo   ! jcic
!
      return
      end 
!------------------------------------------------------------------------------
      subroutine MaxIntPicco(xs1,xs,hintmx)
!
      USE CorrMod,  only : dx,dy,dz
      USE Mappa, only : np
      USE MappaCorrezione
!
      common / AngelaC / jcic
!
      real xs(3), xs1(3), s(3)
      integer sidepp
!
!  - Definisco il massimo valore di intensità per il picco xs1 
!
      j1sav=0
      j2sav=0
      j3sav=0
      do ii=1,3
         xs1(ii)=side(xs1(ii))
      enddo
      jj1=nint(xs1(1)*np(1))
      jj2=nint(xs1(2)*np(2))
      jj3=nint(xs1(3)*np(3))

      dmin=1.E+10
      xxmmpp=0.0
      do j1=max(0,jj1-3),min(np(1)-1,jj1+3)
        do j2=max(0,jj2-3),min(np(2)-1,jj2+3)
          do j3=max(0,jj3-3),min(np(3)-1,jj3+3)
               xx1=float(j1)*dx
               yy1=float(j2)*dy
               zz1=float(j3)*dz
               xs(1)=xx1
               xs(2)=yy1
               xs(3)=zz1
               call xdist(xs1,xs,d,s)
               ray = d
               if (ray.lt.dmin.and.xmap2(j1,j2,j3).gt.xxmmpp) then
                      dmin=ray
                      j1sav=j1
                      j2sav=j2
                      j3sav=j3
               endif
          enddo
        enddo
      enddo

      xxmmpp=xmap2(j1sav,j2sav,j3sav)
      j11sav=j1sav
      j22sav=j2sav
      j33sav=j3sav
      j1sav=0
      j2sav=0
      j3sav=0
      do j1=max0(j11sav-1,0),min0(j11sav+1,np(1)-1)
        do j2=max0(j22sav-1,0),min0(j22sav+1,np(2)-1)
          do j3=max0(j33sav-1,0),min0(j33sav+1,np(3)-1)
             if(xmap2(j1,j2,j3).gt.xxmmpp)then
                xxmmpp=xmap2(j1,j2,j3)
                j1sav=j1
                j2sav=j2
                j3sav=j3
             endif
          enddo
        enddo
      enddo

      jjj = j1sav+j2sav+j3sav

      if (jjj /= 0) then
          xs(1)=float(j1sav)*dx
          xs(2)=float(j2sav)*dy
          xs(3)=float(j3sav)*dz
      else
          xs(1)=float(j11sav)*dx
          xs(2)=float(j22sav)*dy
          xs(3)=float(j33sav)*dz
      endif

      hintmx = xxmmpp
      xs1(:) = xs(:)
!
      return
      end
!------------------------------------------------------------------------------
      subroutine ModificaPicco(jj,xs1,hintmx,coefmd)
!
      USE General,  only : cell
      USE Symmetry, only : icent,ncentr,nsym
      USE Mappa, only : np
      USE CorrMod
      USE MappaCorrezione
!
      real,dimension(3)      :: xs,xs1,xs2,s
      real,dimension(2)      :: vet
      integer                :: sidepp
!
!     write(6,*)  ' Picco Modificato '
!
      zero = 0.0000000001
      alim = raylim

      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1

!     write(6,'(a,i5,3f13.6,f17.6)') 'Picco Orig.',jj,xs1,hintmx

      call MaxIntPicco(xs1,xs,hintmx)

!     write(6,'(a,5x,3f13.6,f17.6)') 'Picco Mod. ',xs1,hintmx
!
!  - Modifico la mappa sottaendo i ripples della f.ne correzione
!
      do kk1=1,ncentr
         do kk2=1,ifin
            coef=vet(kk2)
            do kk3=1,nsym
               call xequi(xs1,kk3,coef,xs,kk1)
               do ii=1,3
                  xs(ii)=side(xs(ii))
               enddo

               isz0=nint(xs(3)*np(3))
               isy0=nint(xs(2)*np(2))
               isx0=nint(xs(1)*np(1))

               iszu=nint(xs(3)*np(3)+alim*deltz)
               iszl=nint(xs(3)*np(3)-alim*deltz)
               isyu=nint(xs(2)*np(2)+alim*delty)
               isyl=nint(xs(2)*np(2)-alim*delty)
               isxu=nint(xs(1)*np(1)+alim*deltx)
               isxl=nint(xs(1)*np(1)-alim*deltx)
c
!     j1sav=sidepp(nint(xs(1)*np(1)),np(1))
!     j2sav=sidepp(nint(xs(2)*np(2)),np(2))
!     j3sav=sidepp(nint(xs(3)*np(3)),np(3))

!     xxmmpp1=xmap2(j1sav,j2sav,j3sav)
c
               do iz = iszl, iszu
                 do iy = isyl, isyu
                   do ix = isxl, isxu

                      ih = sidepp(ix,np(1))
                      ik = sidepp(iy,np(2))
                      il = sidepp(iz,np(3))

                       xx1=float(ih)*dx
                       yy1=float(ik)*dy
                       zz1=float(il)*dz
                       xs2(1)=xx1
                       xs2(2)=yy1
                       xs2(3)=zz1
                       call xdist(xs,xs2,d,s)
                       ray=d

                      if (ray > alim) cycle
 
                      do kt=nmaplim1,nmaplim2
                         if (kt.eq.1) then
                           if (ray.lt.mapcor(1,kt)) then
                              if (hintmx.gt.zero) xmap2(ih,ik,il) =
     *                        xmap2(ih,ik,il)+hintmx*mapcor(2,kt)*coefmd

                              exit
                           endif
                         elseif (kt > 1) then
                           if (ray.ge.mapcor(1,kt-1).and.
     *                                 ray.lt.mapcor(1,kt)) then
!
                              if (hintmx.gt.zero) xmap2(ih,ik,il) =
     *                        xmap2(ih,ik,il)+hintmx*mapcor(2,kt)*coefmd

                              exit
                           endif
                         endif
                      enddo

                   enddo
                 enddo
               enddo
c
!     xxmmpp2=xmap2(j1sav,j2sav,j3sav)
!     write(6,'(a,4i4,2f12.3)')
!    *      'Picco Mod.',jj,kk1,kk2,kk3,xxmmpp1,xxmmpp2
c
          enddo
        enddo
      enddo  

      return
      end
!-----------------------------------------------------------------------
      SUBROUTINE LUDCMP_E(A,N,NP,INDX,D,ier)
!
      USE General

      PARAMETER (NMAX=800,TINY=1.0E-20)
      DIMENSION A(NP,NP),INDX(N),VV(NMAX)
      ier=0
      D=1.
      DO 12 I=1,N
        AAMAX=0.
        DO 11 J=1,N
          IF (ABS(A(I,J)).GT.AAMAX) AAMAX=ABS(A(I,J))
11      CONTINUE
CANG    IF (AAMAX.EQ.0.) PAUSE 'Singular matrix.'
        IF (AAMAX.EQ.0.) then                    
        write(Msg,999) 
  999   format('Singular least squares matrix ')
        call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)        
        ier=-1
        return
                         endif
        VV(I)=1./AAMAX
12    CONTINUE
      DO 19 J=1,N
        DO 14 I=1,J-1
          SUM=A(I,J)
          DO 13 K=1,I-1
            SUM=SUM-A(I,K)*A(K,J)
13        CONTINUE
          A(I,J)=SUM
14      CONTINUE
        AAMAX=0.
        DO 16 I=J,N
          SUM=A(I,J)
          DO 15 K=1,J-1
            SUM=SUM-A(I,K)*A(K,J)
15        CONTINUE
          A(I,J)=SUM
          DUM=VV(I)*ABS(SUM)
          IF (DUM.GE.AAMAX) THEN
            IMAX=I
            AAMAX=DUM
          ENDIF
16      CONTINUE
        IF (J.NE.IMAX)THEN
          DO 17 K=1,N
            DUM=A(IMAX,K)
            A(IMAX,K)=A(J,K)
            A(J,K)=DUM
17        CONTINUE
          D=-D
          VV(IMAX)=VV(J)
        ENDIF
        INDX(J)=IMAX
        IF(A(J,J).EQ.0.)A(J,J)=TINY
        IF(J.NE.N)THEN
          DUM=1./A(J,J)
          DO 18 I=J+1,N
            A(I,J)=A(I,J)*DUM
18        CONTINUE
        ENDIF
19    CONTINUE
      RETURN
      END
!-----------------------------------------------------------------------
      SUBROUTINE LUBKSB_E(A,N,NP,INDX,B)
      DIMENSION A(NP,NP),INDX(N),B(N)
      II=0
      DO 12 I=1,N
        LL=INDX(I)
        SUM=B(LL)
        B(LL)=B(I)
        IF (II.NE.0)THEN
          DO 11 J=II,I-1
            SUM=SUM-A(I,J)*B(J)
11        CONTINUE
        ELSE IF (SUM.NE.0.) THEN
          II=I
        ENDIF
        B(I)=SUM
12    CONTINUE
      DO 14 I=N,1,-1
        SUM=B(I)
        DO 13 J=I+1,N
          SUM=SUM-A(I,J)*B(J)
13      CONTINUE
        B(I)=SUM/A(I,I)
14    CONTINUE
      RETURN
      END
!-----------------------------------------------------------------------
      subroutine Proc_Bias(ifBreak,ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE Param
      USE PhaseModule
      USE PhaseInterface
      USE Molcom
      USE MappaCorrezione
      USE CorrMod
      USE LsqModule
      USE TestModel
      USE Dialogo, only: ModelToCompare
!
      common /GedmCommon/ ifGedm, cicliFour, nBatch, nGedm,
     *                    ifCMap, CMapVet(3)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty   ! devo settare istat2 = 0 dopo ultimo build
      
      character*11 tirang
      character*8  a8
!
c            ifExamin = 0
!
      if (knw > 0) then
          write(6,*) '  ***  RESOLUTION BIAS CORRECTION PROCEDURE  ***'
      endif

      nBias = nBias + 1
      rfacSog = RSoglia

      Msg = 'Performing Resolution Bias Correction Procedure'
      call RunToolBar(1,Msg)

      nMaxLeg = 9800
      call InitMolplo()
!
! -- per build
!
      if (no(1) == 1) then
          jlig = 2 * nzConst
      else
          jlig = nzConst
      endif

      jscreenSav = jscreen


!
      inLSQ_Bias = 0
      RSoglia_Bias = RSoglia
      ippo = 0    
      noSelRef = 0
      nMapCor = 0
      lcyc_best = 0
      cc_best = -9999.99
      Rf_best =  9999.99
      ibest_stop = 0

      sigma1 = sigma1_indaga
      FcScale = 1.0  ! resetto la scala per LSQ per ogni nuovo trial
      SinglePlotType(:) = SIMPLE

   
      lfin = 5
      do lcyc = 1,lfin
          
          Rf_best_cyc = 999.9

          if (knw > 0) 
     *    write(6,*) '  *** RESOL. BIAS CORR. BLOCK   n°', lcyc,'  ***'

          wt(nrefl+1:) = 0.0
          work1(1:nrefl) = wt(1:nrefl)
          call sortall(-1,work1,nrefl)
          ncond1 = nstr 
          sog = work1(ncond1)
          do i=1,nrefl
             if (wt(i).lt.sog) then
                 wt(i) = 0.0
              endif
          enddo

         Itfin = 3
         if (lcyc == 1) then
             Itfin = 3 
         elseif (lcyc == 2 .or. lcyc == 3) then 
             Itfin = 2 
         else
             Itfin = 1 
         endif

*        Itfin = 1 
         nIterazioni = Itfin

         do Iterazione = 1,Itfin
            write(Msg,20) lcyc, lfin, Iterazione, Itfin
            call RunToolBar(1,Msg)
            call DSR_Bias(correl,ifBreak)
            if (ifBreak == 1) return
         enddo
   20 format('Resolution Bias Correction Block ',i2,' /',i2,
     *       ' - DSR procedure iteration',i2 ,' /',i2)
!
*        if (knw == 1) then
*            write(6,*) 'DSR '
*            nbru = -666
*            izero = 0
*            ifmin = 1
*            call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
*            tirang = 'DSR '
*            ipher = 1
*            call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
*    *                 ipub,iphaz,wt,10,0.0,ipher)
*        endif

!
!
!--selezione dei riflessi di partenza
!
         if (ifExpanded>0) then ! occhio
            ihmx=ihmxSav
            rhomax = maxval(rhov(1:nrefl))
            ifExpanded = 0 
         endif
!
         numberToUse = nreflDim
         numberToUse = nrefl
         wt(nrefl+1:) = 0.0
!
corig    work1(1:nrefl) = wt(1:nrefl)
corig    call sortall(-1,work1,nrefl)
         work1(1:numberToUse) = wt(1:numberToUse)
         call sortall(-1,work1,numberToUse)
         ncond1 = nint(float(nstr) * 1.25)
         sog = work1(ncond1)


c           sog = -99

corig    do i=1,nrefl
         do i=1,numberToUse
            if (wt(i).lt.sog) then
                wt(i) = 0.0
             endif
         enddo
!
         if (knw == 1) then
             write(6,*) 'DSR - SELEC'
             nbru = -666
             izero = 0
             ifmin = 1
             call examin(nbru,mkang,khl,ipub,iphaz,numberToUse,
     *                                             izero,wt,ifmin)
             tirang = 'DSR - SELEC'
             ipher = 1
             call pherrdisNew(tirang,wt,khl,mkang,numberToUse,izero,
     *                 ipub,iphaz,wt,10,0.0,ipher)
             kstp = 0
             call Calcola_CC_Mappa(numbLSQ,correl,kstp,2)
             write(lo,'(a,f8.3)') ' CC-map con fasi DSR_Bias =',correl
         endif
   
*           stop 1234

         coef = 1.35 - lcyc * 0.1
         coef = max(coef,1.0)
!        write(6,*) 'LCYC, COEF',lcyc,coef
         aann = max(anat,5.0)
         NatUsed = nint(aann*coef)
         aperc(1) = NatUsed
         rperc(1) = numberToUse

c--  2Fo-Fc
         fcoef(1:numberToUse)= evet(1:numberToUse) *
     *                                wt(1:numberToUse)  
         jpatt = 0
         call MakeMap(fcoef, iphaz, numberToUse, jpatt, xmap,
     *                     FORTH, BACK)

         numberToUse = nrefl
         wt(nrefl+1:) = 0.0

         iflagPKS = 0
         mode = -1
         nnuu = numberToUse
         krecy = 0
         call pksrch_New(mode, iflagPKS, nnuu,ier)
         if (ier /= 0) then
             return
         endif

         kdst = 0  !2
         call to_coord_sir(kdst, numberToUse)


         nne  = nats
         nz(1:nats) = jlig
         call label(nne)
         ini   = 1
         ifi   = nats
         call MakeLab(ini,ifi)

         kblock(:) = 0
         iconn(:) = 0
!        kaction = 5
!        jComplete = 2
!        jscreen = 1
!        call build(kaction, jComplete)
!        jscreen = jscreenSav

         nz(1:nats) = iabs(nz(1:nats) / nzConst)
!        bfac(1:nats) = bt     ! dedi 23/03/09 (tph)
         bfac(1:nats) = bt 
         FcScale = 1.0
!
!-- calcolo fattori termici
!
c            bfac(1:nats) = bt
c            nz1 = nz(1)
c            bfac1 = bfac(1)
c            xyzs1 = xyzs(4,1)
c            do i=2,nats
c               if (nz(i).ne.0) then
c                   if (nz(i).eq.nz1) then
c                       arg = xyzs1 / xyzs(4,i)
c                       bfac(i) = bfac1 +  sqrt(arg)
c                   else
c                       nz1 = nz(i)
c                       bfac1 = bfac(i)
c                       xyzs1 = xyzs(4,i)
c                   endif
c               else
c                   xyzs(5,i) = 0.0
c               endif
c            enddo
!
         iref  = 0
         mode  = 1
         ifBreak = 0
         iCoeff = 2    !fcoef = 2Fo-Fc
         call sftryyyc(iref,mode,numberToUse,scalan,ifBreak,iCoeff)
         if (ifBreak == 1) return
!
         RSir = erre * 100.0
         if (knw == 1) write(lo,'(a,f8.3)') '  Rf% da sftryyyc =',RSir
   
         call Sel_Refl_Bias(numbLSQ)
   
         luset =555
         izero = 0
         ifmin = 1
         call examin(luset,mkang,khl,ipub,iphaz,numberToUse,izero,wt,1)
c-- 2Fo-Fc
         nic_tot =  5  
         iniz = 1
         ifin = nic_tot

         do nic = iniz,ifin


             if (kverbo > 0 .or. knw > 0) then
                 if (nic == 1) write(lo,23)  lcyc, lfin
                 write(lo,24)  nic, ifin
             endif
   23 format(' *** Resolution Bias Correction Block ',i2,' /',i2,' ***')
   24 format(' ***  Map Correction & LSQ procedures',i2 ,' /',i2,' ***')

             write(Msg,25) lcyc, lfin, nic, ifin
             call RunToolBar(1,Msg)
   25 format('Resolution Bias Correction Block ',i2,' /',i2,
     *       ' - Map Correction procedure',i2 ,' /',i2)

             aperc(1) = NatUsed
             nats = NatUsed
             rperc(1) = numberToUse
 
             nMapCor = nMapCor + 1
*            write(6,*) ' MapCorrection Cycle # ', nMapCor, NatUsed

c            fcoef(1:numberToUse)= evet(1:numberToUse)

      goto 111

! -- calcolo Ecal (per mappa 2Eo - Ec)
      fcoef(1:numberToUse) = evet(1:numberToUse) *
     *                               wt(1:numberToUse)

      jpatt = 0
      call MakeMap(fcoef, iphaz, numberToUse, jpatt, xmap, FORTH, BACK)

      worko(1:numberToUse) = wt(1:numberToUse)
      invflag = 0
      call InvMap(khl,mkang,iphaz,fcvet,numberToUse)
      wt(1:numberToUse) = worko(1:numberToUse)  !1.0
!
!-- compute Ecal and weight
!
          do i = 1,numberToUse
             if (fcvet(i) < 0.00001) fcvet(i) = 0.0
             work1(i) = fcvet(i)**2. ! Ecalc ; Emod in uscita
             work2(i) = evet(i)**2.  ! Eobs
          enddo
          if (ksize < 3) then
              nwizm1=15  ! small / medium
          else
              nwizm1=25  ! proteins
          endif
          nden =  nstr / 10
          nsip1 = nrefl / nden
          nsip1 = min(nsip1,498)
          call HistogramMatch(work1,work2,nrefl,nsip1,nwizm1,1)
          fcvet(1:nrefl) = sqrt(work1(1:nrefl))
!
      do i=1,numberToUse
         fcoef(i) =  (2 * evet(i)) - fcvet(i) ! coef. Four = 2*Eo - Ec
         if (fcoef(i) < 0) fcoef(i) = 0.0
         gSim = 2 * evet(i) * fcvet(i)
c        wt(i) = bes(gSim)
      enddo

      nbru = -888
      izero = 0
      ifmin = 1
      call examin(nbru,mkang,khl,ipub,iphaz,numberToUse,izero,wt,ifmin)

 111  continue

             call MapCorrection(jlig,numberToUse,ier)
      
             nats = NatUsed
             if (lcyc == 1) then
                 nats = NatUsed
             elseif (lcyc == 2) then
                 nats = (NatUsed + nint(anat)) / 2
             else
                 nats = nint(anat)
             endif

             aperc(1) = nats
             rperc(1) = numberToUse

             iflagPKS = 0
             mode = -1
             nnuu = numberToUse
             krecy = 0
             call pksrch_New(mode, iflagPKS, nnuu,ier)
             if (ier /= 0) then
                 return
             endif

c            kdst = 0  !2
c            call to_coord_sir(kdst, numberToUse)

             nne  = nats
             nz(1:nats) = jlig
             call label(nne)
             ini   = 1
             ifi   = nats
             call MakeLab(ini,ifi)
  
             if (knw == 1) write(6,*) 
     *           ' BUILD dopo MapCorrection Cycle # ', nic
   
             kblock(:) = 0
!            iconn(:) = 0
             iconn(1) = -(iabs(iconn(1)))
             kaction = 5    !4
!            kaction = 4
             jComplete = 2
             jscreen = 1
             call build(kaction, jComplete)
             jscreen = jscreenSav
!
c            if (knw == 1) write(6,*) 'PRIMA di  Compatta nats =',nats
             bij(:,:) = 0
             bfac(1:nats) = bt
             nzSav(1:nats) = nz(1:nats)
             nz(1:nats) = iabs(nz(1:nats) / nzConst)
!
!-- calcolo fattori termici
!
             bfac(1:nats) = bt
             nz1 = nz(1)
             bfac1 = bfac(1)
             xyzs1 = xyzs(4,1)
             do i=2,nats
                if (nz(i).ne.0) then
                    if (nz(i).eq.nz1) then
                        arg = xyzs1 / xyzs(4,i)
                        bfac(i) = bfac1 +  sqrt(arg)
                    else
                        nz1 = nz(i)
                        bfac1 = bfac(i)
                        xyzs1 = xyzs(4,i)
                    endif
                else
                    xyzs(5,i) = 0.0
                endif
             enddo
!
             nz(1:nats) = nzSav(1:nats)
*            call frm05
             call PutModel()
!   
             call Compatta()
!
             interp = 1
             call PutGetXyzs(1, interp)
!
             ifSingle = 0
             call MolPlo(SIMPLE, ifSingle)
c            if (knw == 1) write(6,*) 'DOPO Compatta nats =',nats
!
*            call GetBonds(1)

!--  calcolo fasi da SFC
!
             nzSav(1:nats) = iabs(nz(1:nats))
             nz(1:nats) = iabs(nz(1:nats) / nzConst)
 
             if (knw > 0) write(6,*) 'SFC calculation BEFORE LSQ_BIAS'

             iref  = 0
             mode  = 1
             ifBreak = 0
             iCoeff = 2
             call sftryyyc(iref,mode,nrefl,scalan,ifBreak,iCoeff)
             if (ifBreak == 1) return
             RSir = erre * 100.0
             if (knw > 0) write(lo,10) RSir
             nz(1:nats) = nzSav(1:nats)
        
             nbru = -777
             izero = 0
             ifmin = 1
             call examin(nbru,mkang,khl,ipub,iphaz,numberToUse,
     *                                             izero,wt,ifmin)

             ifFix = 0
             FcScale = 1.0   

             write(Msg,30) lcyc, lfin, nic, ifin
             call RunToolBar(1,Msg)
   30 format('Resolution Bias Correction Block ',i2,' /',i2,
     *       ' - LSQ procedure',i2 ,' /',i2)

!            call DLSQ_Bias(lfin,ifin,RSir,ier)
             call LSQ_Bias(lfin,ifin,RSir,ier)
             if (ier /= 0) then
                 return
             endif

             if (RSir <= RSoglia_Bias) then
                 exit
             endif
! -- C-MAP
*               if (nic /= ifin) then
c               if (nic == 3) then
c                   if (ifGedm == 2) then
c                     if (ifReduced == 0) then  ! non applico GEDM in ProvainP1
c     !-- small & medie
c                       ifStop = 0
c                       icicliFour = 1  ! GEdm_GL
c                       nBatch = 1
c                       ifExtra = 0
c                       nGedm = numbLSQ   ! GEdm_dedi
c                       call Cp_Edm_Bias(icicliFour, nBatch, nGedm, 
c    *                                      ifStop, ifExtra)
c                       wt(nrefl+1:) = 0.0
c                     endif
c                   endif
c               endif
 
             if (nic == ifin) then
                iphaz(1:nrefl) = iphRB(1,1:nrefl)
                wt(1:nrefl) = wtRB(1,1:nrefl)
             endif

             if (nic == ifin .and. lcyc == lfin) noSelRef = 1
             if (noSelRef == 0) then
                call Sel_Refl_Bias(numbLSQ)
                nbru = 1999
                izero = 0
                ifmin = 1
                call examin(nbru,mkang,khl,ipub,iphaz,numberToUse,
     *                                         izero,wt,1)
             endif
     
         enddo  ! su nic

         if (RSir <= RSoglia_Bias) then
                 exit
         endif

      enddo   ! lcyc
!
      if (knw == 1) write(lo,'(a,f8.3,3i5,2f7.2,i8)') 
     * '  BEST RSir =',Rf_best,lcyc_best,nmap_best,nats_best,
     *                 erore_best,erorepes_best,nrefl

!
!    ATTENZIONE !!! - PROC-FINAL
!
      Msg = 'Performing Final Correction Procedure'
      call RunToolBar(1,Msg)

      call Proc_Final(jlig,jscreenSav,ifBreak,ier)
      if (ier /= 0 ) then
          return
      endif
!
!    ATTENZIONE !!! - PROC-FINAL
!

      if (knw == 1) write(lo,'(a,f8.3,2f7.2,i8)')
     * '  BEST RSir FINAL =',Rf_best,erore_best,erorepes_best,nrefl


      RSir = Rf_best
      if (RSir <= RSoglia_Bias) then
           kWstop = 1
      endif

      iphaz(1:nrefl) = iphRB(2,1:nrefl)
      wt(1:nrefl) = wtRB(2,1:nrefl) 
 
      call Calcola_FOM_Lib(0)
      FinalFom = FOMs(2,4)
      erre = RSir / 100.0
      errem = erre
      if (knw > 0) then
          write (lo,'(a,2f6.2)')'*** FinalFom',FinalFom,sogFinalFom
      else
          write (lo,33) FinalFom , RSir
      endif
* 33  format (8x,' Final Fom',f6.2)
  33  format (8x,'*** Final Fom',f6.2,'  Rf% =',f6.2,' ***')

      
c            ifExamin = 1

      nbru = 456
      izero = 0
      ifmin = 1
      call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)


      coef = 1.25  
      coef = max(coef,1.0)
      aann = max(anat,5.0)
      NatUsed = nint(aann*coef)
      aperc(1) = NatUsed
      rperc(1) = numberToUse

c-- 2Fo-Fc
      fcoef(1:numberToUse) = fcoefRB(1:numberToUse) *
     *                                wt(1:numberToUse)  
      jpatt = 0
      call MakeMap(fcoef, iphaz, numberToUse, jpatt, xmap,
     *                     FORTH, BACK)

      numberToUse = nrefl
      wt(nrefl+1:) = 0.0

      iflagPKS = 0
      mode = -1
      nnuu = numberToUse
      krecy = 0
      call pksrch_New(mode, iflagPKS, nnuu,ier)
      if (ier /= 0) then
          return
      endif

      kdst = 0  !2
      call to_coord_sir(kdst, numberToUse)

      nne  = nats
      nz(1:nats) = jlig
      call label(nne)
      iniz   = 1
      ifin   = nats
      call MakeLab(iniz,ifin)

      if (knw == 1) write(6,'(a,i7,f7.2,2i6)') 
     *      ' BUILD BEST MODEL ',numbrun,RSir,nCoordPub,naatoms

      kblock(:) = 0
!     iconn(:) = 0
      iconn(1) = -(iabs(iconn(1)))
      if (kverbo == 0) then
          kaction = 5
      else
          kaction = 4
      endif
      jComplete = 2
      jscreen = 1
      call build(kaction, jComplete)
      jscreen = jscreenSav
      istat2 = 0

      do i = 1,nats
         ifra = mod(izpk(i),nzConst)
         ifra = iabs(ifra)
         nz(i) = nz(i) + ifra
      enddo

c        nz(1:nats) = iabs(nz(1:nats) / nzConst)
c        iref  = 0
c        mode  = 1
c        ifBreak = 0
c        iCoeff = 2    !fcoef = 2Fo-Fc
c        call sftryyyc(iref,mode,numberToUse,scalan,ifBreak,iCoeff)
c        if (ifBreak == 1) return
!
c        RSir = erre * 100.0
c        if (knw == 1) then
c           write(lo,'(a,f8.3)') '  Rf% Finale da sftryyyc =',RSir
c        endif


      erre = RSir / 100.0
      errem = erre
      interp = 1
      call PutGetXyzs(1, interp)
      call PutModel()
      if (erre * 100.0 < erreBest) then   ! gianluca 16/03/2009   aggiunto *100
          erreBest = erre * 100.0         ! gianluca 16/03/2009
          TrerreBest = numbrun
          WhichBestSolution = numbrun
          numbrunOld = numbrun
          interp = 1
          call MiglioriErre(1) ! gianluca 8/4/11  PutGetBackUpXyzs(1)   !dedi 24/03/2011
cdedi
          call xfrm35
c         call xfrm36
      endif
!
      iAction = 3
      npunti = 1
      call DataForGraph(iAction, npunti)
!
      jscreen = jscreenSav

*     nnuu = 99
*     call Write_CCP4_Map(xmap, nnuu)
!
*     k = index(fname(1),'.bin')
*     kk = kStripTask1(k)
*     write(a8,"('_',i4)") numbrun
*     call NoBlanks(a8,k1)
*     cardDiret = fname(1)(1:kk-1) // a8(1:k1) // '.pdb'
*     itype = 0
*     iform = 1
*     jop = jopen(jhost,cardDiret,itype,iform,ier)
*     numbPDB = -1
*     ifFast = 0
*     ifREM = 0
*     call outPDB(jhost, numbPDB, ifFast, ifREM, 0)
*     close(jhost)
*     write(lo,200) cardDiret(1:Lung(cardDiret))
!
* 200 format(' Coordinates stored in ',a,' file.',/)

      return

   10 format('SFC  RSir  = ',f6.2,'%')

      end
!------------------------------------------------------------------------------
      subroutine Proc_Final(jlig,jscreenSav,ifBreak,ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE Param
      USE PhaseModule
      USE Molcom
      USE MappaCorrezione
      USE CorrMod
      USE LsqModule
      USE HistoStuff
      USE TestModel
      USE Dialogo, only: ModelToCompare
      
      character*11 tirang
      character*8  a8
!
      inLSQ_Bias = 0
      noSelRef = 0
      nMapCor = 0
      lcyc_best = 0
      numberToUse = nrefl
   
      lfin = 1
      do lcyc = 1,lfin
          
         Rf_best_cyc = 999.9

         if (knw > 0) 
     *   write(6,*) '  ***  FINAL RESOL. BIAS CORR. BLOCK ***'

c        nats = nats_best
c        xyzs(:,1:nats) = xyzSk(:,1:nats)
c        bfac(1:nats) = bfacSk(1:nats)
         iphaz(1:nrefl) = iphRB(2,1:nrefl)
         wt(1:nrefl) = wtRB(2,1:nrefl) 
!        do i = 1,nats_best
!           write(100,'(i4,4f10.4)')i,xyzSk(1:3,i),bfacSk(i)
!        enddo

         nbru = 123
         izero = 0
         ifmin = 1
         call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)

         Iterazione =  1
         nIterazioni = 0
         Msg = 'Resolution Bias Correction Final Block - DSR procedure'
         call RunToolBar(1,Msg)
         call DSR_Bias(correl,ifBreak)
         if (ifBreak == 1) return
!
!--selezione dei riflessi di partenza
!
         if (ifExpanded>0) then ! occhio
            ihmx=ihmxSav
            rhomax = maxval(rhov(1:nrefl))
            ifExpanded = 0 
         endif
!
c        wt(nrefl+1:) = 0.0
         work1(1:nrefl) = wt(1:nrefl)
         call sortall(-1,work1,nrefl)
         ncond1 = nint(float(nstr) * 1.25)
         sog = work1(ncond1)
    

c             sog = -99

         do i=1,nrefl
            if (wt(i).lt.sog) then
                wt(i) = 0.0
             endif
         enddo
!
         if (knw == 1) then
             write(6,*) 'DSR - SELEC'
             nbru = -777
             izero = 0
             ifmin = 1
             call examin(nbru,mkang,khl,ipub,iphaz,nreflDim,
     *                                             izero,wt,ifmin)
             tirang = 'DSR - SELEC'
             ipher = 1
             call pherrdisNew(tirang,wt,khl,mkang,nreflDim,izero,
     *                 ipub,iphaz,wt,20,0.0,ipher)
             kstp = 0
             call Calcola_CC_Mappa(numbLSQ,correl,kstp,2)
             write(lo,'(a,f8.3)') ' CC-map con fasi DSR_Bias =',correl
         endif
  
         numberToUse = nreflDim 

         coef = 1.05  
         coef = max(coef,1.0)
         if (knw == 1) write(6,*) 'LCYC, COEF',lcyc,coef
         aann = max(anat,5.0)
         NatUsed = nint(aann*coef)
         aperc(1) = NatUsed
         rperc(1) = numberToUse

c-- 2Fo-Fc
         fcoef(1:numberToUse)= evet(1:numberToUse) *
     *                                wt(1:numberToUse)  
         jpatt = 0
         call MakeMap(fcoef, iphaz, numberToUse, jpatt, xmap,
     *                     FORTH, BACK)

         numberToUse = nrefl
         wt(nrefl+1:) = 0.0

         iflagPKS = 0
         mode = -1
         nnuu = numberToUse
         krecy = 0
         call pksrch_New(mode, iflagPKS, nnuu,ier)
         if (ier /= 0) then
             return
         endif

         kdst = 0  !2
         call to_coord_sir(kdst, numberToUse)


         nne  = nats
         nz(1:nats) = jlig
         call label(nne)
         ini   = 1
         ifi   = nats
         call MakeLab(ini,ifi)

         kblock(:) = 0
         iconn(:) = 0
!        kaction = 5
!        jComplete = 2
!        jscreen = 1
!        call build(kaction, jComplete)
!        jscreen = jscreenSav

         nz(1:nats) = iabs(nz(1:nats) / nzConst)
!        bfac(1:nats) = bt     ! dedi 23/03/09 (tph)
         bfac(1:nats) = bt 
         FcScale = 1.0

         iref  = 0
         mode  = 1
         ifBreak = 0
         iCoeff = 2    !fcoef = 2Fo-Fc
         call sftryyyc(iref,mode,numberToUse,scalan,ifBreak,iCoeff)
         if (ifBreak == 1) return
!
         RSir = erre * 100.0
         if (knw == 1) write(lo,'(a,f8.3)') '  Rf% da sftryyyc =',RSir
   
         call Sel_Refl_Bias(numbLSQ)
   
         luset =555
         izero = 0
         ifmin = 1
         call examin(luset,mkang,khl,ipub,iphaz,numberToUse,izero,wt,1)
c-- 2Fo-Fc

         nic_tot = 3  
         iniz = 1
         ifin = nic_tot

         do nic = iniz,ifin
             
             if (kverbo > 0 .or. knw > 0) then
                 if (nic == 1) write(lo,23)
                 write(lo,24)  nic, ifin
             endif
   23 format(' *** Resolution Bias Correction Final Block  ***')
   24 format(' ***  Map Correction & LSQ procedures',i2 ,' /',i2,' ***')

            write(Msg,25) nic,ifin
            call RunToolBar(1,Msg)
   25 format('Resolution Bias Correction Final Block ',
     *       ' - Map Correction procedure',i2 ,' /',i2)

             aperc(1) = NatUsed
             nats = NatUsed
             rperc(1) = numberToUse
 
              nMapCor = nMapCor + 1
*             write(6,*) ' MapCorrection Cycle # ', nMapCor, NatUsed

c             fcoef(1:numberToUse)= evet(1:numberToUse)

      goto 111

! -- calcolo Ecal (per mappa 2Eo - Ec)
      fcoef(1:numberToUse) = evet(1:numberToUse) *
     *                               wt(1:numberToUse)

      jpatt = 0
      call MakeMap(fcoef, iphaz, numberToUse, jpatt, xmap, FORTH, BACK)

      worko(1:numberToUse) = wt(1:numberToUse)
      invflag = 0
      call InvMap(khl,mkang,iphaz,fcvet,numberToUse)
      wt(1:numberToUse) = worko(1:numberToUse)  !1.0
!
!-- compute Ecal and weight
!
          do i = 1,numberToUse
             if (fcvet(i) < 0.00001) fcvet(i) = 0.0
             work1(i) = fcvet(i)**2. ! Ecalc ; Emod in uscita
             work2(i) = evet(i)**2.  ! Eobs
          enddo
          if (ksize < 3) then
              nwizm1=15  ! small / medium
          else
              nwizm1=25  ! proteins
          endif
          nden =  nstr / 10
          nsip1 = nrefl / nden
          nsip1 = min(nsip1,498)
          call HistogramMatch(work1,work2,nrefl,nsip1,nwizm1,1)
          fcvet(1:nrefl) = sqrt(work1(1:nrefl))
!
      do i=1,numberToUse
         fcoef(i) =  (2 * evet(i)) - fcvet(i) ! coef. Four = 2*Eo - Ec
         if (fcoef(i) < 0) fcoef(i) = 0.0
         gSim = 2 * evet(i) * fcvet(i)
c        wt(i) = bes(gSim)
      enddo

      nbru = -888
      izero = 0
      ifmin = 1
      call examin(nbru,mkang,khl,ipub,iphaz,numberToUse,izero,wt,ifmin)
 111  continue

              call MapCorrection(jlig,numberToUse,ier)

              if (nic == 1) then
                  nats = NatUsed
              elseif (nic == 2) then
                  nats = (NatUsed + nint(anat)) / 2
              else
                  nats = nint(anat)
              endif

              aperc(1) = nats
              rperc(1) = numberToUse

              iflagPKS = 0
              mode = -1
              nnuu = numberToUse
              krecy = 0
              call pksrch_New(mode, iflagPKS, nnuu,ier)
              if (ier /= 0) then
                  return
              endif

c             kdst = 0  !2
c             call to_coord_sir(kdst, numberToUse)

              nne  = nats
              nz(1:nats) = jlig
              call label(nne)
              ini   = 1
              ifi   = nats
              call MakeLab(ini,ifi)
   
              if (knw == 1)
     *            write(6,*) ' BUILD dopo MapCorrection Cycle # ', nic
   
              kblock(:) = 0
!             iconn(:) = 0
              iconn(1) = -(iabs(iconn(1)))
              kaction = 5    !4
!             kaction = 4
              jComplete = 2
              jscreen = 1
              call build(kaction, jComplete)
              jscreen = jscreenSav
!
*             if (knw == 1) write(6,*) 'PRIMA di  Compatta nats =',nats
              bij(:,:) = 0
              bfac(1:nats) = bt
              nzSav(1:nats) = nz(1:nats)
              nz(1:nats) = iabs(nz(1:nats) / nzConst)
!
!-- calcolo fattori termici
!
              bfac(1:nats) = bt
              nz1 = nz(1)
              bfac1 = bfac(1)
              xyzs1 = xyzs(4,1)
              do i=2,nats
                 if (nz(i).ne.0) then
                     if (nz(i).eq.nz1) then
                         arg = xyzs1 / xyzs(4,i)
                         bfac(i) = bfac1 +  sqrt(arg)
                     else
                         nz1 = nz(i)
                         bfac1 = bfac(i)
                         xyzs1 = xyzs(4,i)
                     endif
                 else
                     xyzs(5,i) = 0.0
                 endif
              enddo
!
              nz(1:nats) = nzSav(1:nats)
*             call frm05
              call PutModel()
    
              call Compatta()
*             if (knw == 1) write(6,*) 'DOPO Compatta nats =',nats
!
!             call GetBonds(1)
!
!--  calcolo fasi da SFC
!
              nzSav(1:nats) = iabs(nz(1:nats))
              nz(1:nats) = iabs(nz(1:nats) / nzConst)
   
             if (knw > 0) write(6,*) 'SFC calculation BEFORE LSQ_BIAS'
!
              iref  = 0
              mode  = 1
              ifBreak = 0
              iCoeff = 2
              call sftryyyc(iref,mode,nrefl,scalan,ifBreak,iCoeff)
              if (ifBreak == 1) return
              RSir = erre * 100.0
              if (knw > 0) write(lo,10) RSir
              nz(1:nats) = nzSav(1:nats)
        
             nbru = -777
             izero = 0
             ifmin = 1
             call examin(nbru,mkang,khl,ipub,iphaz,numberToUse,
     *                                          izero,wt,ifmin)
!
              ifFix = 0
              FcScale = 1.0

             write(Msg,30) nic, ifin
             call RunToolBar(1,Msg)
   30 format('Resolution Bias Correction Final Block ',
     *       ' - LSQ procedure',i2 ,' /',i2)

!             call DLSQ_Bias(lfin,ifin,RSir,ier)
              call LSQ_Bias(lfin,ifin,RSir,ier)
              if (ier /= 0) then
                  return
              endif

              if (nic == ifin .and. lcyc == lfin) noSelRef = 1
              if (noSelRef == 0) then
                 call Sel_Refl_Bias(numbLSQ)
                 nbru = 1999
                 izero = 0
                 ifmin = 1
                 call examin(nbru,mkang,khl,ipub,iphaz,numberToUse,
     *                                        izero,wt,1)
              endif
     
         enddo  ! su nic
     
      enddo   ! lcyc
!
      Iterazione =  0
      return

   10 format('SFC  RSir  = ',f6.2,'%')

      end
!------------------------------------------------------------------------------
      subroutine Sel_Refl_Bias(numb)
      USE General
      USE Riflessi
!
      ncond = nrefl

      do  j=1,ncond
          work1(j)=wt(j)
      enddo 
!
      call sortall(-1,work1,ncond)
!
      sog=work1(numb)

      do  j=1,ncond
         if (wt(j).lt.sog) then
             wt(j)=0.0
         endif
      enddo
!
      return
      end
!------------------------------------------------------------------------------
      subroutine LSQ_Bias(lfin,ifin,RSir,ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom      
      USE PhaseModule
      USE LsqModule
      USE LsqStuff12
      USE CorrMod
      USE Dialogo, only: ModelToCompare
!
      real x1(3), x2(3), tutti(18)
      integer FcutOff
!
      inLSQ_Bias = 1
!gl 24/06/2009 ModelToCompare = 1
!
!-- LSQ Caos
!     LsqAct  = 1    ! calcolo fattori
!     LsqAct  = 2    ! calcolo scala
!     LsqAct  = 3    ! minimi quadrati
!     newpWei = 2    ! pesaggio per piccole molecole a risol. atomica
!
!-- calcolo fattori Caos
!
!     istampa = 0
      istampa = -1

      bij(:,:) = 0
      call cancella(12)
      call cancella(31)
*     call frm05

!
      ifSingle = 0
      call MolPlo(SIMPLE, ifSingle)
!
!     write(6,*) 'SFC calculation (runlsq)'
      if (numbGen == 0) then
          Num_Riflessi = 0
      else
          Num_Riflessi = nreflDim - numbGen
      endif

!     FcutOff = 2
!     ResCut1 = 8.0
!     ResCut2 = resm
!     isig = 1
!     isel = 0
!     call Select_Refl_LSQ(Num_Riflessi,ResCut1,ResCut2,FcutOff,isig,isel)

      newpWei = 2
!     LsqAct  = 2    ! minimi quadrati
      LsqAct  = 1    ! calcolo fattori e calcola nuova scala
      jcyc = 0
      fdum = 1.0
!
! -- dedi new 14/10/2010 : stringa12Tot(1,2) full, end 
! -- inizializzare LSQ per solo calcolo fatori e scala per i ricicli > 1
!
      if (InfoOK(62) == 1) then
          call x62start(ncard,ier)  ! inizializzo la lista 12
          if (neutro == 2) then
              call x62all(ncard, 'diag',0.0,0.0, ' ', ' ', ier)
          else
              call x62all(ncard, 'full',0.0,0.0, ' ', ' ', ier)
          endif
          call x62end(ncard)
          InfoOK(62)=1
          NumCond12_Sav=NumCond12
          call AllocaLsqStuff12_Sav(2)
          call AllocaLsqStuff12_Sav(1)
      endif
!
! -- dedi new 14/10/2010 : stringa12Tot(1,2) full, end 
! -- inizializzare LSQ per solo calcolo fatori e scala per i ricicli > 1
!
      call RunMndq(ier,LsqAct,jcyc,fdum,istampa,
     *                     Num_Riflessi, xyzs4,newpWei) ! nuovo MNQD

      if (knw == 1) then
          write(6,*) 'DOPO runlsq - solo sfc',nats
          write(lo,20) rflsq
      endif
!
!     write(6,*) 'LSQ calculation (runlsq)'
      do i=1, nats
          x1(1:3)=xyzs(1:3,i)
          call MoltMatVec(rm, x1, x2)
          xyz(1:3,i) = x2(1:3)
      enddo
      NatMol = nats

      ifBonly = 2   ! solo  Bfac
      ifFix = 0
      call CreaRestraints_Bias(ifBonly,ifFix)
!
      ifSingle = 0
      call MolPlo(SIMPLE, ifSingle)
!
!
!     FcutOff = 2
!     ResCut1 = 8.0
!     ResCut2 = resm
!     isig = 1
!     isel = 0
!     call Select_Refl_LSQ(Num_Riflessi,ResCut1,ResCut2,FcutOff,isig,isel)

      newpWei = 2
      LsqAct  = 2    ! minimi quadrati
      jcyc = 3
      fdum = 0.5
!
      call RunMndq(ier,LsqAct,jcyc,fdum,istampa,
     *                 Num_Riflessi,xyzs4,newpWei)     ! nuovo MNQD
      if (knw == 1) then
          write(6,*) 'DOPO 2a runlsq - solo Bfac',nats
          write(lo,20) rflsq
      endif
!
*     kdst = 2  !0  !2
*     call to_coord_sir(kdst, nrefl)
!
*     ksubr = 3
*     call LeggiRiflessi(ier,ksubr)
!
*     nzSav(1:nats) = iabs(nz(1:nats))
*     nz(1:nats) = iabs(nz(1:nats) / nzConst)

c     write(6,*) 'SFC calculation (sftryyyc)'

*     iref  = 0
*     mmode  = 1
*     ifBreak = 0
*     iCoeff = 2    !fcoef = 2Fo-Fc
*     call sftryyyc(iref,mmode,nrefl,scalan,ifBreak,iCoeff)
*     nz(1:nats) = nzSav(1:nats)

*     RSir = erre * 100.0
*     write(lo,'(a,f8.3)') '  Rf% da sftryyyc =',RSir

c     nbru = -888
c     izero = 0
c     ifmin = 1
c     call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)

!
!  Rigetta gli atomi se Bfac troppo alto
!
      if (ksize > 1) then

          sog0 = 4.0 * bt

c         sog0 = 5.0 * bt

*         nn0 = nats / 2
c         nn0 = 2 * nats / 3
c         work_bf(1:nats) = bfac(1:nats)
c         call sortall(-1,work_bf,nats)
c         sog = work_bf(nn0)
c         if (sog > sog0) then
c             write(lo,*) ' *** SOG0, SOG ***',sog0,sog
c             sog0 = sog
c         endif

          nn1 = nats
          do i=1, nats
             if (bfac(i) > sog0) then
                 RS(i) = -100.
                nn1 = nn1 - 1
             endif
          enddo
          if (nn1 == 0) then  ! eliminati tutti gli atomi
              write(lo,*) ' *** ERROR: All Atoms Rejected ***'
              ier = -2
              return
          endif

          if (nn1 < nats) then
              nres = 0
              vres(:) = 0.0
              call UpdateCommonAndList5(ier) !attenzione ??? serve solo per la grafica
              if (knw == 1) 
     *        write(6,*) 'DOPO Taglio in f.ne di bfac, nats =',nats
          endif
          
      endif


      if (neutro == 2) then
          goto 123
      endif


      do i=1, nats
          x1(1:3)=xyzs(1:3,i)
          call MoltMatVec(rm, x1, x2)
          xyz(1:3,i) = x2(1:3)
      enddo
      NatMol = nats

      ifBonly = 0  !affino xyz's e Bfac
c     ifBonly = 1  !affino solo xyz's 
c     ifBonly = 2  !affino solo Bfac
      ifFix = 0
      call CreaRestraints_Bias(ifBonly,ifFix)
!
      ifSingle = 0
      call MolPlo(SIMPLE, ifSingle)
!
!
!     FcutOff = 2
!     ResCut1 = 8.0
!     ResCut2 = resm
!     isig = 1
!     isel = 0
!     call Select_Refl_LSQ(Num_Riflessi,ResCut1,ResCut2,FcutOff,isig,isel)

c     istampa = 3
      newpWei = 2
      LsqAct  = 2    ! minimi quadrati
      jcyc = 3
      fdum = 1.0
!
      call RunMndq(ier,LsqAct,jcyc,fdum,istampa,
     *                 Num_Riflessi,xyzs4,newpWei)     ! nuovo MNQD
      if (knw == 1) then
          write(6,*) 'DOPO 3a runlsq - XYZ + BFAC',nats
          write(lo,20) rflsq
      endif
!     
 123  continue
!
      kdst = 0  !2
      call to_coord_sir(kdst, nrefl)
!
      if (knw > 0) write(6,*) '***  FINAL SFC calculation (sftryyyc)'

      ksubr = 3
      call LeggiRiflessi(ier,ksubr)

      nzSav(1:nats) = iabs(nz(1:nats))
      nz(1:nats) = iabs(nz(1:nats) / nzConst)
      wt(nrefl+1:) = 0.0
!
!-- compute Ecal and weight
!
      sumFo = 0
      sumFc = 0
      do i=1,nrefl
         sumFo = sumFo + fovet(i)
         sumFc = sumFc + fcvet(i)
      enddo
      scalan=sumFo/sumFc
!
      sumDiff = 0
      do i=1,nrefl
         fcvet(i) = fcvet(i) * scalan       ! fc riscalato su fo
         sumDiff = sumDiff + abs(fovet(i) -fcvet(i))
         rho = rhov(i)
         eps = epsv(i)
         sumfff = 0.0
         do ij=1,nk
            ff(ij) = ScattFact(ij, rho)
            sumfff=sumfff+nw(ij)*(ff(ij)**2)
         enddo
!
!-- E(Calc) =  F(calc) / den
!--     den =  eps * pts * coef * sig
!--     sig =  sqrt( sigma ** 2 ) )
!
         coef = 1.0
         sig = sqrt( exp(-2.0*bt*rho) * sumfff )
         den = coef * eps       * sig
         fcvet(i) =  fcvet(i) /  den
!
c        fcoef(i) =  (2 * evet(i)) - fcvet(i) ! coef. Four = 2*Eo - Ec
c        if (fcoef(i) < 0) fcoef(i) = 0.0
!
         gSim = 2 * evet(i) * fcvet(i)
         wt(i) = bes(gSim)
      enddo

      errino = sumDiff/sumFo

      iref  = 0
      mmode  = 1
      ifBreak = 0
      iCoeff = 2    !fcoef = 2Fo-Fc
      call sftryyyc(iref,mmode,nrefl,scalan,ifBreak,iCoeff)
      if (ifBreak == 1) return
      nz(1:nats) = nzSav(1:nats)
      RSir = erre * 100.0
      errem = RSir
      if (knw > 0) then
          write(lo,'(a,f8.3)') ' final sftryyyc in LSQ Rf% =',RSir
      else
          if (kverbo > 0) write(lo,'(a,f8.3)') '  Rf% =',RSir
      endif
!
      ifbarra = 1
      call scrf2004(SIMPLE, ifbarra)
!
      nbru = -999
      izero = 0
      ifmin = 1
      call examin(nbru,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)

! - dedi 
      if (RSir < Rf_best_cyc) then
          Rf_best_cyc = RSir
          iphRB(1,1:nrefl) = iphaz(1:nrefl)
          wtRB(1,1:nrefl) = wt(1:nrefl)
      endif
! - dedi 27/06/08
      if (RSir < Rf_best) then
          Rf_best = RSir
          erore_best = erore
          erorepes_best = erorepes
          lcyc_best = lcyc
          nmap_best = nMapCor
          nats_best = nats
c         xyzSk(:,1:nats) = xyzs(:,1:nats)
c         bfacSk(1:nats) = bfac(1:nats)
          fcoefRB(1:nrefl) = fcoef(1:nrefl)
          iphRB(2,1:nrefl) = iphaz(1:nrefl)
          wtRB(2,1:nrefl) = wt(1:nrefl)
!         write(50,*)'*** NMAP_BEST ***', nmap_best
!         do i = 1,nats_best
!            write(50,'(i4,4f10.4)')i,xyzSk(1:3,i),bfacSk(i)
!         enddo
      endif
! - dedi 27/06/08

 4455 continue

      dm = dm_fou    !ripristino il valore di dm dopo LSQ per il pksrch della Fourier

      inLSQ_Bias = 0
!gl 24/06/2009 ModelToCompare = 0

      return
   20 format(' SFC  RCaos = ',f6.2,'%')
      end
!------------------------------------------------------------------------------
      subroutine CreaRestraints_Bias(ifBonly,ifFix)
!
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Param
      USE LsqModule
      USE LsqStuff12
      USE CorrMod,  only: lcyc
!
      real             :: x1(3)
!
!     ifBonly = 0   affina xyz's e b[iso]
!     ifBonly = 1   fix b[iso]
!     ifBonly = 2   fix xyz's
!     ifFix = 0     nessun vincolo
!     ifFix = 1     vincoli larghi (dist. o ang. + esd)
!     ifFix = 2     vincoli stretti (valore stabilito per dist e ang)
!


      if( ifBonly == 2) then
          ifFix = 0    ! solo Bfac senza vincoli
      endif

      if( ifFix == 0) then
          bij(:,:) = 0
          call cancella(12)
          call cancella(31)
*         call frm05
          call PutModel()
c         if (ifBonly == 0) then
c            return
c         endif
      endif


!     TargetDist = 1.35
!     TargetAng  = 113.0
!     distMaxLeg = 2.5   ! ATTENZIONE valore > in caso di  atomi pesanti
      distMaxLeg = (radii(nk,1) * 2.) + 1.
      esd = 0.01
      if (ifFix == 2) then
          Angfix = 115.0
          esd = 0.01   !0.1    !0.05
      endif
!     if (lcyc == 1) then
!         alcyc = 1.00
!     elseif (lcyc == 2) then
!         alcyc = 2.00
!     else
!         alcyc = 3.00       
!     endif

      alcyc = 2.00   !lcyc

      icode = 2    !  icode = 1 per DIAG    icode = 2 per FULL

!*RS      call x12start(ncard)  ! inizializzo la lista 12
      call x62start(ncard,ier)  ! inizializzo la lista 12
      if (neutro == 2) then
!*RS          call x12all(ncard, 'diag',0.0,0.0, ' ', ' ', ier)
          call x62all(ncard, 'diag',0.0,0.0, ' ', ' ', ier)
      else
!*RS          call x12all(ncard, 'full',0.0,0.0, ' ', ' ', ier)
          call x62all(ncard, 'full',0.0,0.0, ' ', ' ', ier)
      endif

      call ContaLegami()
      call IconnToLE()  ! dedi 20/02/08   ??? serve ???

      if (ifBonly > 0) then
!
c     if (ifBonly /= 2 .and. ifFix > 0) then
      if (ifBonly == 1 .and. ifFix > 0) then
!
!-- Distances
!
      n = 0

      do i=1, nats
         if (nzo(i) == 0) cycle
         do j1=1, NumLeg
            k1 = LE(1,j1)
            if (i > k1) cycle
            k2 = LE(2,j1)
            if (k1 == i .or. k2 == i) then
                nz1 = int(nz(k1)/nzConst)
                nz2 = int(nz(k2)/nzConst)
                dist = 0.0
                do l=1,3
                   dist = dist + (xyz(l,k1)-xyz(l,k2))**2
                enddo
                dist = sqrt(dist)
                if (dist < distMaxLeg) then

                     if (ifFix == 1) then
                        TargetDist = dist
                     elseif (ifFix == 2) then
                        distfix = radii(nz1,1) + radii(nz2,1)
                        delta = dist - distfix
                        delta2 = delta / alcyc
                        adelta = abs(delta)
                        if (adelta > 0.15) then 
                            TargetDist = distfix + delta2
                        else 
                            TargetDist = distfix 
                        endif
                     endif

                     n = n + 1
                     Msg = aLab(k1)(1:Lung(aLab(k1))) // ' ' //
     *                     aLab(k2)(1:Lung(aLab(k2)))
!                    write(6,1) n, Msg(1:Lung(Msg)),dist
                     call x62all(ncard, 'dist', TargetDist,esd,
     *                           Msg,' ', ier)
!*RS                     call x12all(ncard, 'dist', TargetDist,esd,
!*RS     *                           Msg,' ', ier)
                endif
            endif
         enddo
      enddo
    1 format(i5,1h),2x,a,2x,f9.3)
      if (knw > 0) write(6,*) n,'DISTANZE'
!
!-- Angles
!

      n = 0

      do n1=1, nats
         if (nzo(n1) == 0) cycle
         do j2=1, NumLeg
            if (LE(1,j2) > nats .or. LE(2,j2) > nats) cycle
            if (LE(1,j2) == n1 .and. nzo(LE(2,j2)) > 1) then
                n2 = LE(2,j2)
            elseif (LE(2,j2) == n1 .and. nzo(LE(1,j2)) > 1) then
                n2 = LE(1,j2)
            else
                n2 = 0
            endif
            if (n2 > 0) then
                do j3=1, NumLeg

                   ies_fix = 0

                   if (LE(1,j3) > nats .or.
     *                 LE(2,j3) > nats) cycle
                   if (LE(1,j3) == n2) then
                       n3 = LE(2,j3)
                   elseif (LE(2,j3) == n2) then
                       n3 = LE(1,j3)
                   else
                       n3 = 0
                   endif
                   if (n3 > 0 .and. n3 /= n1) then
                       if (n1 < n3) then
!gl!                       Added = 1              ! 13/05/2010 a che serve ?
                           x1(1:3) = xyz(1:3,n3)
                           call VerificaAngolo(n1, n2, x1, Ang)

                           if (ifFix == 1) then
                              TargetAng = Ang
                           elseif (ifFix == 2) then

                               nz1 = int(nz(n1)/nzConst)
                               nz2 = int(nz(n2)/nzConst)
                               nz3 = int(nz(n3)/nzConst)

                               if (no(nz1) < 10 .and.
     *                           no(nz2) < 10 .and. no(nz3) < 10) then
                                 if (Ang > 75.0 .and. Ang < 160.0) then
                                     ies_fix = 1
                                 endif
                               endif

                               if (ies_fix == 1) then
                                   delta = Ang - Angfix
                                   delta2 = delta / alcyc
                                   adelta = abs(delta)
                                   if (adelta > 15.) then
                                       TargetAng = Angfix + delta2
                                   else
                                       TargetAng = Angfix
                                   endif
                               else
                                   TargetAng = Ang
                               endif

                           endif

                           n = n + 1
                           Msg = aLab(n1)(1:Lung(aLab(n1))) // ' ' //
     *                           aLab(n2)(1:Lung(aLab(n2))) // ' ' //
     *                           aLab(n3)(1:Lung(aLab(n3)))
!                          write(6,1) n, Msg(1:Lung(Msg)), Ang
!*RS                           call x12all(ncard, 'angl', TargetAng,esd,
!*RS     *                                 Msg,' ', ier)
                           call x62all(ncard, 'angl', TargetAng,esd,
     *                                 Msg,' ', ier)
                       endif
                   endif
                enddo
            endif
         enddo
      enddo
      if (knw > 0) write(6,*) n,'ANGOLI'

      endif  !(ifBonly /= 2)

!
!-- Unlinked atoms: fixed   - dedi 20/02/08
!
      if (ifBonly > 0) then
          if (ifBonly == 1) then
              call x62all(ncard, 'fix', 0.0,0.0,' ', 'b[iso]', ier)
          elseif(ifBonly == 2) then
              call x62all(ncard, 'fix', 0.0,0.0,' ', 'x y z ', ier)
          endif
          n = 0
          do i=1, nats
!            if (nzo(i) == 0) then
                    n =  n + 1
!            endif
          enddo
          if (knw > 0) then
             if (ifBonly == 1) then
                write(lo,*) n,'FIXED BFAC FOR ', n,'  ATOMS'
             elseif(ifBonly == 2) then
                write(lo,*) n,'FIXED X Y Z FOR ', n,'  ATOMS'
             endif
          endif
      endif

! -- fissa tutti gli atomi (xyz) delle specie iniz:ifin

*         n = nats
*         if (no(1) == 1) then
*             iniz = 2
*         else
*             iniz = 1
*         endif
*         if (no(nk) > 15) then
*             ifin = nk - 1
*         else
*             ifin = nk
*         endif
*         write(Msg,'(18(a4,2x))') Species(iniz:ifin)
*         call OneBlankOnly(Msg)
*         K = Lung(Msg)
*         call x62all(ncard, 'fix', Msg(1:K), 'x y z ', ier)
*         call x62all(ncard, 'fix', 'C', 'x y z ', ier)  ! tutti atomi C
*         write(6,*) n,'FIXED ATOMS (XYZ)'
 
      endif !(ifBonly /= 0)
!
         call x62end(ncard)
!         
         NumCond12_Sav=NumCond12
         call AllocaLsqStuff12_Sav(2)
         call AllocaLsqStuff12_Sav(1)
!
*     call sw12(lo,1)
!
      return
      end
!------------------------------------------------------------------------------
      subroutine IconnToLE()
      USE General
      USE Atomi
      USE Molcom
!
! ----  costruisci la tabella dei legami
!
      NumLeg = iconn(1)
*     write(6,*) ' IconnToLE', NumLeg,NatMol,nMaxLeg,nlp
      j = 0
      do i = 1 , NumLeg
         i1 = ( i - 1 ) * 3 + 2
         i2 = i1 + 1
         i3 = i1 + 2
c--mercedes 2mag2006         if (iconn(i3).eq.-1) cycle
         if (iconn(i3).eq.0) iconn(i3)=1
         n1 = iconn(i1)
         n2 = iconn(i2)
         if (n1 <= 0 .or. n2 <= 0) cycle
         if (n1 > NatMol .or. n2 > NatMol) cycle
         if (nz(n1).ne.0.and.nz(n2).gt.0) then
             j = j + 1
             LE(1, j) = iconn(i1)
             LE(2, j) = iconn(i2)
             LE(3, j) = iconn(i3)
         endif
         if (j .eq. nMaxLeg - nlp) exit
      enddo
      NumLeg = j
!
      return
      end
!------------------------------------------------------------------------------
      subroutine Select_Refl_LSQ(Num_Rif, ResCut1, ResCut2, FcutOff,
     *                           isig, isel)
      USE General
      USE Riflessi
      integer FcutOff
!
!-- isig = 1  --> seleziona rifl. in f.ne di sigma
!-- isel = 1  --> taglia i  rifl. a  bassa risoluzione (> ResCut1)
!-- isel = 2  --> taglia i  rifl. ad alta risoluzione  (< ResCut2)
!-- isel = 3  --> taglia i  rifl. a bassa ed alta risoluzione  (> ResCut1, < ResCut2)
      

      jwork1(:) = 1

      ncutoff = 0
      if (isig == 1) then
          do i = 1,nrefl
             irap = nint(fovet(i) / sigmav(i))
             if (irap <= FcutOff) then
                 jwork1(i) = 0
                 ncutoff = ncutoff + 1
             endif
          enddo
      endif

      nresoff = 0
      if (isel == 1 .or. isel == 3) then
          do i = 1,nrefl
             ris = 0.5 / sqrt(rhov(i))
             if (ris >= ResCut1) then
                 jwork1(i) = 0
                 nresoff = nresoff + 1
             endif
          enddo
      endif
      if (isel == 2 .or. isel == 3) then
          do i = 1,nrefl
             ris = 0.5 / sqrt(rhov(i))
             if (ris <= ResCut2) then
                 jwork1(i) = 0
                 nresoff = nresoff + 1
             endif
          enddo
      endif

      nr_elim = 0
      do i = 1,nrefl
         if (jwork1(i) == 0) then
             nr_elim = nr_elim + 1
         endif
      enddo

      nn = nrefl - nr_elim
      Num_Rif = Num_Rif - nr_elim
      

      if (knw > 0) then
          write(6,111) nreflDim,nrefl,ncutoff,Fcutoff,
     *                 nresoff,ResCut1,ResCut2,nr_elim,Num_Rif
      endif
 111  format(/,' Riflessi totali       = ', i10,/,
     *         ' Riflessi osservati    = ', i10,/,
     *         ' Rifl. elim. x cutoff  = ', i10, i7,/,
     *         ' Rifl. elim. x resoff  = ', i10, f7.1,' - ', f7.1,/,
     *         ' Rifl. elim.  totali   = ', i10,/,
     *         ' Riflessi  utilizzati  = ', i10,/)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DSR_Bias(correl,ifBreak)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE MappaCont
      USE Param
      USE PhaseModule
      USE HistoStuff
      USE CorrMod,  only: lcyc
!
!
!-- nBlockEDM = total number of EDM blocks
!-- nMacroTot = total number of macro cycles
!-- nMicro    = number of micro cycles per macro cycle
!-- nMacro    = number of macro cycles per EDM block
!
      common /misc/ ttt(3,3), dxmax(3), ishift(3,19)
*gl*  common /cBarra/ nbarra, npercB, perc0B, percB, iipercB, jpercB
      common /GedmCommon/ ifGedm, cicliFour, nBatch, nGedm,
     *                    ifCMap, CMapVet(3)
      integer uset
      character tirang * 11

*              return

      if (knw == 1) write(6,*) 'DSR ITERAZIONE ',Iterazione
*     call CPUTime0('inizio Iterazione')
!
      if ((nsym.eq.1.and.icent.eq.0) .or. nSpaceGroup == 144) then
          ifExamin = 0                           ! per P31
      endif
!

      numb = nstr
      ifEnve = 0
      if (lcyc == 1) then
          v_p = 0.9
      elseif (lcyc == 2) then
          v_p = 0.85
      else 
          v_p = 0.8
      endif
      v_s = 1.0 - v_p
!     write(6,*) 'V_P, V_S ',v_p,v_s

      EnvePronta = 0
      iterasog = 0 

      nanat = nint(anat)
      if (nanat > 10) then
          ifEnve = 1
      else
          ifEnve = 0
      endif
!-- attenzione NO ENVELOPE ! NEW 
          ifEnve = 0
!-- attenzione NO ENVELOPE  ! NEW
!
      nBlockEDM =  3 
      nMacroTot =  9
      nMicro = 5
!
      nbarra = nMacroTot * nMicro
      call Barra
!

      nMacro = nMacroTot / nBlockEDM
      correl   = 0.0
      correMR = 0.0
      ier = 0
      jpatt = 0
      mode = 0
      krecy = 0
      chope = 0.5
      icode = 0
!
      iniz = 1
!
      nstep = mod(nMicro,2)
      MetaMicro = (nMicro / 2) + nstep
      nMacroAppl = 0

      if (numbInv <= nstr) numbInv = numbInv + (numbLSQ - numbInv)/3

      Blocchi: do indiceBlocchi=1, nBlockEDM
         if (indiceBlocchi == 1) then
             numbDyn = numbInv
         elseif (indiceBlocchi == 2) then
                numbDyn = numbInv + (numbLSQ - numbInv)/2
         else
                numbDyn = numbLSQ
         endif

         wt(nrefl+1:) = 0.0
         work1(1:nrefl) = wt(1:nrefl)
         call sortall(-1,work1,nrefl)
         ncond1 = nstr
         sog = work1(ncond1)
         do i=1,nrefl
            if (wt(i).lt.sog) then
                wt(i) = 0.0
             endif
         enddo

         if (ifExamin /= 0.and.ifOUT==1) then
             if (knw > 0) write (lo,11)
             if (indiceBlocchi == 1) then
                 ifmin = 0 ! 10
                 luset = 555
                 izero = 0
                 call examin(luset,mkang,khl,ipub,iphaz,nreflDim,
     *                                         izero,wt,ifmin)
                 write (lo,112) erore, erorepes, isumal
             endif
         endif

         if(ifExpanded>0) then
            x  = Iterazione
            x1 = 1
c           x2 = nIterazioni
            x2 = 3 ! occhio
            y1 = 0.5
            y2 = 1.0
            call varlinear(x,x1,x2,y,y1,y2)
            chopeiniz=y
         else
            chopeiniz=0.5
         endif

         Macro: do indiceMacro=1, nMacro
            nMacroAppl = nMacroAppl + 1
            chope = chopeiniz + nMacroAppl * 0.1
            if (chope.gt.2.0) chope = 2.0

c              chope = 2

            jpatt = 0
!enve
            if (ifEnve == 1) then
                 RenveDyn = CalcolaRaggioEnve(jpatt)
                 if (knw > 0) write(6,*) 'RAGGIO ENVELOPE =',RenveDyn
                 nMacro1= 2
                 if (mod(nMacroAppl,nMacro1)==0) then
                    call Long_Env_New(numbDyn,jpatt)
                    EnvePronta = 1
                 else
                    EnvePronta = 0
                 endif
            endif
!enve
!
!--attivo il Free Lunch
!
            if (numbGen > 0 .and. Iterazione > iterasog) then
               if (ifFreeLunch < 1) then
                   nuset = 123
                   izero = 0
                   ifmin = 1
                   call examin(nuset,mkang,khl,ipub,iphaz,nreflDim,
     *                            izero,wt,ifmin)
                   call Expand2006_Bias(chope,expTerm)

!                 nuset = 456
!                 izero = 0
!                 ifmin = 1
!                 call examin(nuset,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
!                 tirang = 'EDM - OBSER'
!                 ipher = 1
!                 call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
!    *                    ipub,iphaz,wt,20,0.0,ipher)

!                 nuset = 789
!                 izero = nrefl
!                 ifmin = 1
!                 call examin(nuset,mkang,khl,ipub,iphaz,nreflDim,
!    *                                   izero,wt,ifmin)
!                 tirang = 'EDM - EXPAND'
!                 ipher = 1
!                 call pherrdisNew(tirang,wt,khl,mkang,nreflDim,izero,
!    *                    ipub,iphaz,wt,20,0.0,ipher)

               endif
            endif
!
            iDelta = ( numbDyn - nstr ) / nMicro
!
            if (kverbo.gt.0) then
                luset = nMacroAppl*1000+777
                izero = 0
                ifmin = 1
                call examin(luset,mkang,khl,ipub,iphaz,nstr,
     *                                  izero,wt,ifmin)
            endif
!
!--selezione dei riflessi osservati  
!
            if (ifExpanded == 0) then
                wt(numbDyn+1:) = 0.0
            else       
!!! Att. modifica per non usare i riflessi tra numbLSQ - nrefl !!!   DEDI
                wt(numbDyn+1:nrefl) = 0.0  ! azzero i riflessi osservati  con Eo basso
            endif
            work1(1:numbLSQ) = wt(1:numbLSQ)
            call sortall(-1,work1,numbLSQ)
!
            ncond1 = nstr 
            ratioall = float(nstr)/float(numbLSQ)
!
            if(no(nk)<=10.and.Iterazione==0) then
                 ncond1 = 1.5*nstr
                 ncond1 = min(ncond1,numbDyn)
            endif
!           write(lo,*)'nstr,ncond1,numbLSQ,nrefl,numbGen,nreflDim'
!           write(lo,'(6i10)')nstr,ncond1,numbLSQ,nrefl,numbGen,nreflDim

            sog = work1(ncond1)
            icont1=0
            do i=1,numbLSQ
              if (wt(i).lt.sog) then
                wt(i) = 0.0
              else
                icont1=icont1+1
              endif
            enddo
!
!--selezione dei riflessi estrapolati
!
         if(ifExpanded>0) then
           work1(1:numbGen) = wt(nrefl+Added+1:nreflTot)
           call sortall(-1,work1,numbGen)
           ncond1 = ncond1*float(numbGen)/float(nrefl)
           ncond1 = max(1,ncond1)
           sog=work1(ncond1)
           icont=0
           do i=nrefl+Added+1,nreflTot
              if (wt(i).lt.sog) then
                  wt(i) = 0.0
              else
                  icont=icont+1
              endif
           enddo
!          write(6,*) 'soglia',icont1,icont,float(icont1)/float(icont)
         endif

!-- statistiche
!
            if (kverbo.gt.0) then
                uset = nMacroAppl*1000+888
                izero = 0
                ifmin = 1
                call examin(uset,mkang,khl,ipub,iphaz,numbLSQ,
     *                                  izero,wt,ifmin)
                call examin(uset,mkang,khl,ipub,iphaz,nreflDim,
     *                                  izero,wt,ifmin)
            else
                if (Iterazione.ge.0.and.nMacroAppl == 1) then
                    if (ifExamin.ne.0) then
                        ifmin = 0 ! 10
!                       ifmin = 10
                        luset = 555
                        izero = 0
                        call examin(luset,mkang,khl,ipub,iphaz,nrefl,
     *                                  izero,wt,ifmin)
                        write (lo,113) erore, erorepes, isumal
                        if (ifExpanded > 0) then
                            izero = nrefl
                            call examin(luset,mkang,khl,ipub,iphaz,
     *                                  nreflDim,izero,wt,ifmin)
                            write (lo,114) erore, erorepes, isumal
                            izero = 0
                            call examin(luset,mkang,khl,ipub,iphaz,
     *                                   nreflDim,izero,wt,ifmin)
                            write (lo,115) erore, erorepes, isumal
                        endif
                    endif
                endif
           endif
!
            if (knw == 1) then
                call toflush()
            endif
!
            isogiter = 1

            Micro: do indiceMicro = 1,nMicro
*              percMap=0.05
               percMap = 0.04 + 0.005 * Iterazione
               invflag = 1
               iesnegmap = 0
!           
               call Inverti_Bias(numbDyn,chope,ifBreak)
               if (ifBreak == 1) return
               if (knw == 1) then
                   kstp = 0
                   if(ifOUT==1) then
                      iesCC = 1
                   else
                      iesCC = 0
                      if(indiceMacro.eq.nMacro.and.
     *                   indiceBlocchi.eq.nBlockEDM) iesCC = 1
                   endif
                   if ((nsym.eq.1.and.icent.eq.0) 
     *                  .or. nSpaceGroup == 144) then
                        iesCC = 0
                   endif
                   if (iesCC==1)  then
                       call Calcola_CC_Mappa(numbLSQ,correl,kstp,2)
                       write(lo,99) cicloEDM,correl,isumal
                   endif
               endif
               call Barra()

!   PROVA  Cq

                    if (ifGedm == 2) then
                      if (ifReduced == 0) then  ! non applico GEDM in ProvainP1
!-- small & medie
                        ifStop = 0
                        icicliFour = 1
                        nGedm = numbLSQ / 4
c                       nGedm = numbDyn
                        call Cp_EDM(icicliFour, numbDyn, nGedm, ifStop,
     *                            chope)
                      endif
                    endif

!   PROVA  Cq


            enddo Micro
!
            if (knw == 1) then
                call toflush()
            endif
!
            if (knw == 1) then
                kstp = 1
                write(lo,15) numbrun,Iterazione,nMacroAppl,correl
            elseif (kverbo /= 0) then
                write(lo,16) numbrun,Iterazione,nMacroAppl
            endif
            if (knw == 1) then
                call toflush()
            endif

*                        wt(nrefl+1:) = 0.0
!
         enddo Macro
!
      enddo Blocchi
!
      if (ifExamin.ne.0) then
          luset = 999
          izero = 0
          ifmin = 0 ! 10
!         ifmin = 10
          call examin(luset,mkang,khl,ipub,iphaz,numbDyn,izero,wt,ifmin)
          write (lo,117) Iterazione,erore, erorepes, isumal
      endif
!
      if ((nsym.eq.1.and.icent.eq.0) .or. nSpaceGroup == 144) then
          ifExamin = 1                     ! per P31
      endif
!
      if (knw == 1) then
          call toflush()
      endif

      iAct = knw
*     call CPUTime('fine Iterazione', iAct)
!
      return
   11 format(/,5x,' EDM  MODULE (Electron-Density Modification)',/)
   15 format(' Trial',i6,2i4,'  EDM CC_MAP =',f7.3)
   16 format(' Trial',i6,2i4)
c  99 format(5x,'CICLO EDM = ',i8,8x,'CORR = ',f6.3,6x,'FFfom = ',f8.3)
   99 format(5x,'CICLO EDM = ',i8,8x,'CORR = ',f6.3,6x,'Numb =',i8)
*  99 format(5x,'CICLO EDM = ',i8,8x,'CORR = ',f6.3,6x)
  112 format(10x,'Entering - Mean Phase Error ',f6.2,
     *       '  (',f6.2,')  over',i8,' reflections')
  113 format(10x,'Starting - MPE OBS ',f6.2,
     *       '  (',f6.2,')  over',i8,' reflections')
  114 format(10x,'Starting - MPE EXT ',f6.2,
     *       '  (',f6.2,')  over',i8,' reflections')
  115 format(10x,'Starting - MPE ALL ',f6.2,
     *       '  (',f6.2,')  over',i8,' reflections')
  117 format(' End Iteration',i4,' - Mean Phase Error ',f6.2,
     *'  (',f6.2,')  over',i8,' reflections',/)
  120 format(8x,' Final Fom',f8.3,'   Iteration #',i3)
      end
!-----------------------------------------------------------------------
      subroutine Inverti_Bias(numbDyn,chope,ifBreak)
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE Param
      USE RemoModule
      USE PhaseModule
!
      common /misc/ ttt(3,3), dxmax(3), ishift(3,19)
!
      character tirang * 11

      cicloEDM = cicloEDM + 1
!     if (knw > 0) write(lo,99) cicloEDM

      if (ifExpanded == 0) then
          numberToUse = numbLSQ
          numberToInv = nrefl
      else
          numberToUse = nreflTot
          numberToInv = nreflTot
      endif
!
      nuset = nMacroAppl*1000+555
      izero = 0
      ifmin = 1
      call examin(nuset,mkang,khl,ipub,iphaz,nreflTot,izero,wt,ifmin)

      fcoef(1:numberToUse) = evet(1:numberToUse) * 
     *                             wt(1:numberToUse)
      jpatt = 0 
*     call MakeMap(numberToUse,jpatt)
      call MakeMap(fcoef, iphaz, numberToUse, jpatt, xmap, FORTH, BACK)
!
      iesmodimap = 0
!
      if (ifBreak == 0) then
          ifBreak = ifBreakFun()
          if (ifBreak == 1) then
              return
          endif
      endif

!
! ----  esalta la mappa al microciclo MetaMicro = nMicro/2 + 1
!
      esalta=1
      nnmm = MetaMicro
!
      if (EnvePronta.gt.0.5) then
          iflat = 1
          Xflip = 0
          call flatmapOld(xmap,xenve,iflat,Xflip)
          percMap = percMap * 3.
          percMap = min(percMap,0.5)
          if (knw > 0) write(lo,11) percMap
      endif

      call InvMap(khl,mkang,iphaz,fcvet,numberToInv)
      wt(:) = 0.0 
!
!-- selezione dei pesi
!
      iAll = 0
      if (numbDyn > numbLSQ) then
          numb = nrefl
      else
          numb = numbLSQ
      endif
      call CalcolaPesi_Bias(nstr,numb,chope,iAll)

!
!     ifOUTPUT = 0
      ifOUTPUT = 1

      if(ifOUT==1.and.
     * (indiceMicro.eq.nMicro.or.kverbo.ne.0)) then
          ifOUTPUT =1
      endif
      if ((indiceMicro.eq.nMicro).and.(indiceMacro.eq.nMacro).and.
     *     (indiceBlocchi.eq.nBlockEDM).and.ifOUT==0) then
          ifOUTPUT =1
      endif
      if(ifOUTPUT == 1) then
!
!--statistiche
          if (ifExamin.ne.0) then 
!             if (kverbo.eq.0) then
!                 ifmin = 0
!                 nuset = nMacroAppl*1000+666
!                 izero = 0
!                 call examin(nuset,mkang,khl,ipub,iphaz,nreflDim,izero,wt,ifmin)
!                 write (lo,101) nMacroAppl, erore, erorepes, isumal
!             else
!-distribuzione errore
                if (ifExpanded > 0) then
                  izero = 0
                  ifmin = 1
                  nuset = nMacroAppl*1000+666
                  call examin(nuset,mkang,khl,ipub,iphaz,nrefl,
     *                                   izero,wt,ifmin)
                  izero = nrefl
                  ifmin = 1
                  call examin(nuset,mkang,khl,ipub,iphaz,nreflTot,
     *                                   izero,wt,ifmin)
!                 do i = nrefl+Added+1,nreflTot
!                    if (wt(i).lt.0.01) then
!                       tmpwt(i) = 0.0
!                    else
!                       tmpwt(i) = wt(i)
!                    endif
!                 enddo
!                 tirang = 'EDM - EXPAND'
!                 ipher = 1
!                 call pherrdisNew(tirang,wt,khl,mkang,nreflTot,izero,
!    *                    ipub,iphaz,tmpwt,10,0.0,ipher)
                endif

               ifmin = 1
               nuset = nMacroAppl*1000+666
               izero = 0
               call examin(nuset,mkang,khl,ipub,iphaz,nreflDim,
     *                                  izero,wt,ifmin)

!             endif
          endif
!
      endif  ! if (indiceMicro.eq.nMicro)
!
!--fine statistiche
!
      call DoSingleIteration()
!
      return
!  99 format(5x,'CICLO EDM = ',i10)
   11 format('ENVELOPE APPLICATO',f7.3)
  101 format(' Supercycle n.',i4,' - Mean Phase Error ',f6.2,
     *       '  (',f6.2,')  over',i8,' reflections')
      end
!-----------------------------------------------------------------------
      subroutine CalcolaPesi_Bias(numb,numbMax,chope,iAll)
      USE General
      USE Riflessi
      USE HistoStuff
      USE RemoModule
      USE PhaseModule
      USE Param
!
      if (ksize == 1 .or. kmad /= 0 .or. neutro == 2) then
          if (numbGen == 0) then
              call CalcolaPesi_Old(numb,numbMax,chope,iAll)
          else
              call CalcolaPesi_Ext(chope)
          endif
          return
      endif
      if (numbGen > 0 .and. Iterazione > iterasog) then
          call CalcolaPesiExp_Bias(numb,numbMax,chope,iAll)
          return
      endif
cdedi-MERGE_LIB
!merge!
      if (ksize <= 3) then
c----   pesi: HM tra 2 sets di dati
          do i = 1,nrefl
             if (fcvet(i) < 0.00001) fcvet(i) = 0.0
             work1(i) = fcvet(i)**2. ! Ecalc ; Emod in uscita
             work2(i) = evet(i)**2.  ! Eobs
          enddo
          if (ksize < 3) then
              nwizm1=15  ! small / medium
          else
              nwizm1=25  ! proteins
          endif
          nden =  nstr / 10
          nsip1 = nrefl / nden
          nsip1 = min(nsip1,498)
          call HistogramMatch(work1,work2,nrefl,nsip1,nwizm1,1)
          work2(1:nrefl) = work1(1:nrefl)
      else                                              ! per proteine - versione Liberato
          vetmatchin(1:nrefl) = fcvet(1:nrefl)
          call HistMatchObs()
          work2(1:nrefl) = vetmatchin(1:nrefl)
!
          sumfo = 0.0
          sumfc = 0.0
          sumfh = 0.0
          do i=1,nrefl
             sumfh=sumfh+work2(i)
             sumfo=sumfo+evet(i)**2.
             sumfc=sumfc+fcvet(i)**2.
          enddo
          sumfc=sumfc / nrefl
          sumfo=sumfo / nrefl
          sumfh=sumfh / nrefl
          if (kverbo > 0) then
              write(lo,*)'E**2obs',sumfo,'E**2calc',sumfc,'E**2histo',
     *                    sumfh
          endif
      endif
!finemerge!
!
      nnmm = MetaMicro
      nopeso = 0
      if(indiceMicro.eq.nnmm.and.no(nk).lt.20.and.LowRes.eq.1) nopeso=1
      if(indiceMicro.eq.nnmm.and.esalta.gt.1.5) nopeso=1

         if (ksize < 4) nopeso = 0

      do i=1,nrefl
         ec2i = work2(i)
         EOss = evet(i)
         if (ec2i.gt.0.00001) then
             fcvet(i) = sqrt(ec2i)
         else
             fcvet(i) = 0.0
         endif
         ECal = fcvet(i)
         SimW = chope * EOss * ECal
         if (nopeso.eq.1) then
             SimW = chope
         endif
         gSim =  bes( SimW )
         if(resm.lt.ResSogLow) then  ! LowRes = 1 ???
             coef = 1.0
         else
             coef = exp(0.1*2*sqrt(rhov(i))*resm)
         endif
         gSim = min(gSim * coef,1.0)
         work1(i) = gSim
         if (iAll /= 1 .and. i > numbMax) then
             work1(i) = 0.0
             wt(i) = 0.0
             tmpwt(i) = 0.0
             work2(i) = 0.0
         endif
         work2(i) = work1(i)
      enddo
!
      if (iAll.lt.0) then
          return
      elseif (iAll.eq.0) then
          call sortall(-1,work1,numbMax)
          ncond1 = numb + indiceMicro * iDelta
          sog = work1(ncond1)
          if (ncond1.gt.numbMax) sog=0.0
! 
          sumesq=0.0
          sumesq1=0.0
          npresimio=0
          do i=1,numbMax
             if (work2(i).lt.sog) then
                 wt(i) = 0.0
             else
                 wt(i) = work2(i)
                 npresimio=npresimio+1
                 sumesq=sumesq+wt(i)*fcvet(i)
                 sumesq1=sumesq1+wt(i)
             endif
          enddo
c--deb
          if(kverbo>0) then
             write(6,'(a,i12,2f8.2)') 'occhio0',npresimio,
     &      float(npresimio)/float(numbMax),sumesq/sumesq1
          endif
c--deb
      elseif (iAll.eq.1) then
          do i=1,nrefl
             wt(i) = work2(i)
          enddo
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CalcolaPesiExp_Bias(numb,numbMax,chope,iAll)
      USE General
      USE Riflessi
      USE HistoStuff
      USE PhaseModule

c
c--applico l'HM rispetto alle curve teoriche degli E
c
      if(ifExpanded==1.and.iAll==0) then  
        numberToUse=nreflTot
      else
        numberToUse=numbMax 
      endif
c          
      icont=0
      do i=1,numberToUse ! default
        icont=icont+1
        vetmatchin(icont)=fcvet(i)  ! default
c       write(99,'(i8,4f15.2)') i,sqrt(rhov(i)),evet(i),fcvet(i),wt(i)
      enddo
      call HistMatchTheo(icont)
      icont=0
      do i=1,numberToUse ! default
        icont=icont+1
        fcvet(i)=vetmatchin(icont)  ! default
c       write(101,'(i8,4f15.2)') i,sqrt(rhov(i)),evet(i),fcvet(i),wt(i)
      enddo

      nnmm = nMicro/2 + 1
      nopeso = 0
      if(indiceMicro.eq.nnmm.and.no(nk).lt.20.and.LowRes.eq.1) nopeso=1
      if(indiceMicro.eq.nnmm.and.iwei.eq.0) nopeso=1

         if (ksize < 4) nopeso = 0  
c
c--calcolo i pesi per lo shell interno
c
      do i=1,numbMax 
         EOss = evet(i)
         ECal = fcvet(i)
         SimW = chope * EOss * ECal
         if(nopeso.eq.1) then
             SimW = chope
         endif
         work1(i) = SimW
         work2(i) = SimW
      enddo

c
c--seleziono i riflessi migliori
c
      if (iAll.eq.0) then
        call sortall(-1,work1,numbMax)
        ncond1 = numb + indiceMicro * iDelta
        sog = work1(ncond1)
        if (ncond1.gt.numbMax) sog=0.0
  
        npresimio=0
        do i=1,numbMax
          if (work2(i).lt.sog) then
             wt(i) = 0.0
           else
             wt(i) = bes ( work2(i) )
             npresimio=npresimio+1
          endif
        enddo
c
c--calcolo i pesi per lo shell esterno
c
        if(ifExpanded==1) then

          call sigmaAA(fcvet,nreflTot) 
          do i=nrefl+Added+1, numberToUse
            ii=i-nrefl
            EOss = fcvet(i)
            ECal = fcvet(i)
            SimW = chope * EOss * ECal
            work1(ii) = SimW
            work2(ii) = SimW
          enddo
          numbM=ii
          call sortall(-1,work1,numbM)
c
          ncond1 = 0.85*(nstr + indiceMicro * iDelta)  ! default
          sog = work1(ncond1)
c
          npresimio=0
          resfin = 0.5/sqrt(rhov(nreflTot))
          do i=nrefl+Added+1,numberToUse
            ii = i-nrefl
            if(work2(ii).lt.sog) then
               wt(i) = 0.0
            else
               wt(i) = bes( work2(ii) )
               evet(i)=fcvet(i)  
               npresimio=npresimio+1
            endif
          enddo
c
        endif
      else
        do i=1,numbMax  ! default  (comunque e' ininfluente)
           wt(i) = bes ( work2(i) )
        enddo
      endif
c
      return
      end
!------------------------------------------------------------------------------
      subroutine Expand2006_Bias(chope,expTerm)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE HistoStuff
      USE Mappa
      USE PhaseModule
      USE Param
      USE CorrMod,  only: lcyc
!
      character tirang * 11
!
!--ristabilisto gli indici massimi
!
      ihmx(:)=ihmxExt(:)
      rhomax = maxval(rhov(1:nreflTot))
!     write(6,*) 'nuovi massimi',ihmx,rhomax
      do i=1,nreflTot
         fcoef(i) = evet(i)
!        write(70,88) i,khl(:,i),fcoef(i),wt(i),iphaz(i)
      enddo
 88   format(i6,1h),3i4,2f15.5,i5)
!
!dedi! se voglio usare solo gli oss. per stimare gli ext.
!      wt(nrefl+1:nreflTot) = 0.0
!
      fcoef(1:nreflTot) = fcoef(1:nreflTot) *
     *                               wt(1:nreflTot)
      jpatt = 0
*     call MakeMap(nreflTot,jpatt)
      call MakeMap(fcoef, iphaz, nreflTot, jpatt, xmap,
     *                     FORTH, BACK)
      xmapApp(:,:,:) = xmap(:,:,:)
      call maxmin_dedi(np(1),np(2),np(3),xmap)
!     write(6,*)' denmin, denmax, avden, stden ',
!    *            denmin, denmax, avden, stden
!
      invflag = 1
!
      nMaxExpand = 1 ! default
!
      if (EnvePronta.gt.0.5) then  
          iflat = 1
          Xflip = 0
          call flatmapOld(xmap,xenve,iflat,Xflip)
          if (knw > 0) write(lo,*)'ENVELOPE in Expand',ihmx
      endif
!
!--modifico la mappa
!
!        percMap=0.1
!        percMap=0.02
         percMap=0.05
         if (ifOUT==1.and.knw > 0) write(lo,*) 'Expand2006',percMap

!
!--inverto la mappa
!
c        call RiduciRippleOld() 
!
         call InvMap(khl,mkang,iphaz,fcvet,nreflTot)
         wt(:) = 0.0
c
!
!--calcolo pesi per i riflessi osservati ed estrapolati
!
         call CalcolaPesi_Ext(chope)
!

        iwork2(:) = iphaz(:)
        tmpwt(:) = wt(:)
        xmap(:,:,:) = xmapApp(:,:,:)
        percMap=0.1
        invflag = 1
        call InvMap(khl,mkang,iphaz,fcvet,nreflTot)
        iphaz(:) = iwork2(:) 
        wt(:) = tmpwt(:) 
c
c--metto i nuovi valori in evet per il solo shell esterno
c
         do i=nrefl+Added+1,nreflTot !Ultima gen
            evet(i) = fcvet(i)
         enddo
!
!--statistiche 
!
      nuset = 8000
      izero = 0
      call examin(nuset,mkang,khl,ipub,iphaz,nrefl,izero,wt,1)
      nuset = 9000
      izero = nrefl
      call examin(nuset,mkang,khl,ipub,iphaz,nreflTot,izero,wt,1)
      if (kverbo>0) then
           tirang = 'Expa. Wt.'
           izero = nrefl
           ipher = 1
           call pherrdisNew(tirang,wt,khl,mkang,nreflTot,izero,
     *                ipub,iphaz,wt,10,0.0,ipher)
           tirang = 'Expa. Ecalc.'
           izero = nrefl
           ipher = 1
           call pherrdisNew(tirang,evet,khl,mkang,nreflTot,izero,
     *               ipub,iphaz,wt,10,0.0,ipher)
 
           do i = nrefl+Added+1,nreflTot
              work1(i) = 0.5 / sqrt(rhov(i))
           enddo
           tirang = 'Expa. Resol.'
           izero = nrefl
           ipher = 1
           call pherrdisNew(tirang,work1,khl,mkang,nreflTot,izero,
     *              ipub,iphaz,wt,10,0.0,ipher)
!
           call StatRMio()
      endif
!
      ifExpanded = 1
!
      return
      end     
!-----------------------------------------------------------------------
      subroutine CalcolaPesi_Ext(chope)
      USE General
      USE Riflessi
      USE HistoStuff
      USE PhaseModule

c
c--applico l'HM rispetto alle curve teoriche degli E
c
      numberToUse=nreflDim
      numbMax=nrefl
c          
      icont=0
      do i=1,numberToUse ! default
        icont=icont+1
        vetmatchin(icont)=fcvet(i)  ! default
      enddo
      call HistMatchTheo(icont)
      icont=0
      do i=1,numberToUse ! default
        icont=icont+1
        fcvet(i)=vetmatchin(icont)  ! default
      enddo

c
c--calcolo i pesi per lo shell interno
c
      do i=1,numbMax 
         EOss = evet(i)
         ECal = fcvet(i)
         SimW = chope * EOss * ECal
         work1(i) = SimW
         work2(i) = SimW
         wSimW = bes(SimW) 
c        if(nit.eq.4) coef = exp(0.1*2*sqrt(rhov(i))*resm)
c        wSimW = min(wSimW * coef,1.0)
         wt(i) = bes(SimW)
      enddo

c
c--calcolo i pesi per lo shell esterno
c
      call sigmaAA(fcvet,nreflTot) 
      do i=nrefl+Added+1, numberToUse
         ii=i-nrefl+Added
         EOss = fcvet(i)
         ECal = fcvet(i)
         SimW = chope * EOss * ECal
         wt(i) = bes(SimW)
      enddo
c
      return
      end
!-----------------------------------------------------------------------
      subroutine Calcola_FOM_Bias(iact)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE PhaseModule
!
!-- iact = 1  - dopo DSR
!-- iact = 2  - dopo Res-Bias
!
      do i=1,nrefl
         fcoef(i) = evet(i)
         tmpwt(i) = wt(i)
      enddo

      invflag = 1
      if( iact == 1) then
          numbMax = nrefl
          percMap=0.075
      else
          numbMax = numbLSQ
          percMap=0.05
      endif

      jpatt = 0
      fcoef(1:numbMax) = fcoef(1:numbMax) *
     *                               wt(1:numbMax)
      jpatt = 0
*     call MakeMap(numbMax,jpatt)
      call MakeMap(fcoef, iphaz, numbMax, jpatt, xmap,
     *                     FORTH, BACK)
!
! --  iwork2 = nuova fase dopo inversione (per non sporcare iphaz)
!
      call InvMap(khl,mkang,iwork2,fcvet,nrefl)
      wt(:) = 0.0
!
      chope = 2.0
      iAll  = 1
      call CalcolaPesi_Bias(nrefl,nrefl,chope,iAll)
!
!--- fcvet = Ecal, wt = nuovo peso , iwork2 = nuova fase
!
      iflg = 2
      call Fom_CC_Lib(numbMax,CC,iflg)
      FOMs(2,2) = CC

      call Fom_EC2_Lib(numbMax,EC2,sgmin)
      FOMs(2,3) = EC2
      if (FOMs(2,3).gt.sgmin) then
          FOMs(2,4) = FOMs(2,2) / FOMs(2,3)
      else
          FOMs(2,4) = FOMs(2,2) / sgmin
      endif
 
      do i=1,nrefl
         wt(i) = tmpwt(i)
      enddo
 
      call Calcola_CC_EoEc(0)
      FOMs(2,1) = CCEoEc(1)

      return
      end
!-----------------------------------------------------------------------
      subroutine pherrdis_Bias(tirang,dij,khl,mkang,nrif,ic,
     *                       ia,ib,c,nrang1,rmax1,ipher)
! --- (tirang,wt,khl,numbMax,izero,
!                       ipub,iphaz,tmpwt,10,0.0,ipher) 
      USE General
      USE PhaseModule
!
      dimension khl(3,nrif),mkang(nrif),dij(nrif)
      dimension ia(nrif),ib(nrif),c(nrif),d(nrif)
      dimension his(201),cumde(201),range(201),
     * disa1(201),disb1(201),disa2(201),disb2(201),
     * cumerr1(201),cumerr2(201),cumerp1(201),cumerp2(201),
     * csegni(201),cumse(201),cmed(201),ccmed(201)
      integer his, cumde, ierv(3)
      character tirang*11

      real,    allocatable :: dijs(:)
      integer, allocatable :: jorde(:), jorde1(:)

      if (ipher < 0 .or. ifExamin == 0) return    ! 27/7/2010 dedi - per uscire dalla subroutine
      if (ifTime == 1) return

      if (ipher.eq.0) then
          lll = -444
          ifmin = 10
          call examin(lll,mkang,khl,ia,ib,nrif,ic,c,ifmin)
      endif
      if (knw.eq.0) return
      if (nrif.le.0) then
         write(lo,*) ' nrif = 0'
        return
      endif
c--
      ierv(:) = 0
      IF (.NOT. ALLOCATED(dijs))
     *    ALLOCATE (dijs(1:nreflDim),  stat = ierv(1))
      IF (.NOT. ALLOCATED(jorde))
     *    ALLOCATE (jorde(1:nreflDim), stat = ierv(2))
      IF (.NOT. ALLOCATED(jorde1))
     *    ALLOCATE (jorde1(1:nreflDim),stat = ierv(3))
      ierr = sum(iabs(ierv(:)))
      if (ierr.ne.0) then
          write(lo,*) 'PherrDisNew Allocation error'
          call cstop(' ')
      endif
      do i=1,nrif
         jorde(i) = i
      enddo
      nrang = 10
      if (nrang1.gt.0)   nrang = nrang1
      if (nrang1.gt.200) nrang = 200
      itot=0
      sumsegni=0.0
      sumdif1=0.0
      sumdisb1=0.0
      sumdif2=0.0
      sumdisb2=0.0
      sumc=0.0
      do i=1,201
         range(i)=0.0
         his(i)=0
         cumde(i)=0
         cumse(i)=0.0
         csegni(i)=0.0
         cmed(i)=0.0
         disa1(i)=0.0
         disb1(i)=0.0
         cumerr1(i)=0.0
         cumerp1(i)=0.0
         disa2(i)=0.0
         cumerr2(i)=0.0
         cumerp2(i)=0.0
         disb2(i)=0.0
         ccmed(i)=0.0
      enddo
      rmin=99999.
      rabs=99999.
      rmax=-99999.
      ii=0
      do i=1,nrif
         if (i.le.ic) cycle
         kk=jorde(i)
         if (kk.eq.0.or.kk.gt.nrif) write(lo,*)kk
         if (c(kk).le.0.0) cycle
         ii=ii+1
         dijs(ii)=dij(kk)
         jorde1(ii)=kk
         if (abs(dij(kk)).lt.rabs) rabs=abs(dij(kk))
         if (dij(kk).lt.rmin) rmin=dij(kk)
         if (dij(kk).gt.rmax) rmax=dij(kk)
      enddo
      numsort=ii
      if (rmax.eq.rmin) then
          write(lo,*) ' rmax = rmin '
          return
      endif
      call sortall3(1,dijs,1,numsort,jorde1)
      if (rmin.lt.0.0) then
          rmax=amax1(rmax,abs(rmin))
          rmin=-1.0*rmax
      endif
      rmaxg=rmax
      rming=rmin
      if (rmax1.gt.0.0) then
          rmax=rmax1
          if (rmin.lt.0.0) rmin=-1.0*rmax
      endif

c--
*     dev=rmax-rmin
*     iaa=nint(dev)
*     rang=float(nrang)
*     if (iaa.gt.0) then
*         dev=float(iaa)/rang
*     else
*         dev=dev/rang
*     end if
*     if (rmin.ge.0.0) then
*         range(1)=float(int(10.*rmin))/10.
*         do i=2,nrang
*            range(i)=range(i-1)+dev
*         enddo
*     else
*         range(1)=float(nint(10.*rmin))/10.
*         nrangi=nint(rang/2.0)
*         nrang=2*nrangi
*         dev=rmax-rabs
*         dev=dev/float(nrangi)
*         do i=2,nrangi-1
*            range(i)=range(i-1)+dev
*         enddo
*         range(nrangi)=-rabs
*         range(nrangi+1)=rabs
*         do i=nrangi+2,nrang
*            range(i)=range(i-1)+dev
*         enddo
*     endif
c     range(1)=rmin
*     range(1)=rming
*     nrang=nrang+1
*     range(nrang)=rmax
*     range(nrang+1)=rmaxg
c--
      n = 0
      do i=1, nrif
         if (c(i) > 0.00001) then
             n = n + 1
             d(n) = dij(i)
         endif
      enddo
      a = minval(d(1:n))
      b = maxval(d(1:n))
      step = (b - a) / float(nrang)
      do i=1,nrang
         range(i) = a + float(i) * step
      enddo
      range(nrang+1) = range(nrang) + step   
c--
      n=2
      do i=1,numsort
         k=jorde1(i)
         jh = khl(1,k)
         jk = khl(2,k)
         jl = khl(3,k)
         shiftp=jh*shiftexam(1)+jk*shiftexam(2)+jl*shiftexam(3)
         shiftp=360.* shiftp + ia(k)
         dif1=shiftp - ib(k)
         dif2=shiftp + ib(k)
         dif1=abs(amod(dif1,360.))
         if (dif1.gt.180.)dif1=360.-dif1
         dif2=abs(amod(dif2,360.))
         if (dif2.gt.180.)dif2=360.-dif2

   17    if (dijs(i).le.range(n)) then
             his(n)=his(n)+1
         else
             n=n+1
             if (n.gt.nrang) n=nrang+1
             goto 17
         endif
         disa1(n)=disa1(n)+dif1
         disa2(n)=disa2(n)+dif2
         disb1(n)=disb1(n)+dif1*c(k)
         disb2(n)=disb2(n)+dif2*c(k)
         cmed(n)=cmed(n)+c(k)
      enddo
*-----cumulative
      cumerp1(nrang+1)=disb1(nrang+1)
      cumerp2(nrang+1)=disb2(nrang+1)
      ccmed(nrang+1)=cmed(nrang+1)
      do i=1,nrang
         cumerp1(nrang+1-i)=cumerp1(nrang+2-i)+disb1(nrang+1-i)
         cumerp2(nrang+1-i)=cumerp2(nrang+2-i)+disb2(nrang+1-i)
         ccmed(nrang+1-i)=ccmed(nrang+2-i)+cmed(nrang+1-i)
      enddo
*-----
      do i=1,nrang+1
         if (his(i).gt.0) then
             itot=itot+his(i)
             sumdif1=sumdif1+disa1(i)
             sumdif2=sumdif2+disa2(i)
             sumdisb1=sumdisb1+disb1(i)
             sumdisb2=sumdisb2+disb2(i)
             sumc=sumc+cmed(i)
             sumsegni=sumsegni+csegni(i)
             disa1(i)=disa1(i)/float(his(i))
             disa2(i)=disa2(i)/float(his(i))
             disb1(i)=disb1(i)/cmed(i)
             disb2(i)=disb2(i)/cmed(i)
             csegni(i)=csegni(i)/float(his(i))
             csegni(i)=100.*csegni(i)
         else
             disa1(i)=0.0
             disa2(i)=0.0
             disb1(i)=0.0
             disb2(i)=0.0
             csegni(i)=0.0
             cmed(i)=0.0
         endif
      enddo
      if (itot.le.0) then
          write(lo,*) ' itot = 0'
          return
      endif
      tot=float(itot)
      segnim=100.*sumsegni/tot
      dif1m=sumdif1/tot
      dif2m=sumdif2/tot
      disb1m=sumdisb1/sumc
      disb2m=sumdisb2/sumc
c-----cumulative 
      cumde(nrang+1)  =his(nrang+1)
      cumse(nrang+1)  =float(his(nrang+1))*csegni(nrang+1)
      cumerr1(nrang+1)=float(his(nrang+1))*disa1(nrang+1)
      cumerr2(nrang+1)=float(his(nrang+1))*disa2(nrang+1)
      do i=1,nrang
         cumde(nrang+1-i)  =cumde(nrang+2-i)+his(nrang+1-i)
         cumse(nrang+1-i)  =cumse(nrang+2-i)+csegni(nrang+1-i)*
     *                      float(his(nrang+1-i))
         cumerr1(nrang+1-i)=cumerr1(nrang+2-i)+disa1(nrang+1-i)*
     *                      float(his(nrang+1-i))
         cumerr2(nrang+1-i)=cumerr2(nrang+2-i)+disa2(nrang+1-i)*
     *                      float(his(nrang+1-i))
      enddo

      if (knw.eq.1) write(lo,200) tirang
      if (knw.eq.0) write(lo,250) tirang
      do i=2,nrang+1
         if (his(i).eq.0) cycle
         if (knw > 0)then
             if (shiftexam(4).gt.0.) then
                 write(lo,100) range(i-1),range(i),his(i),
     *                 disa1(i),disb1(i),cumde(i),
     *                 cumerr1(i)/float(cumde(i)),cumerp1(i)/ccmed(i)
             else
                 write(lo,100) range(i-1),range(i),his(i),
     *                 disa2(i),disb2(i),cumde(i),
     *                 cumerr2(i)/float(cumde(i)),cumerp2(i)/ccmed(i)
             endif
         else
             write(lo,150) range(i-1),range(i),his(i),cumde(i)
         endif
      enddo

      write(lo,"(24x,42('.'))")
      if (knw.gt.0) then
          if (shiftexam(4).gt.0.) then 
              write(lo,300)itot,dif1m,disb1m
         else
              write(lo,300)itot,dif2m,disb2m
          endif
      else
          write(lo,300)itot
      end if
  100 format(f10.4,'  - ',f10.4,i8,2f7.2,'  |',i8,2f7.2)
  150 format(f10.4,'  - ',f10.4,i8,'  |',i8)
  200 format(/,11x,a11,6x,' HIS',
     *      '  <err> <w-err>',' | ',
     *      '    CUM',
     *      '  <err> <w-err>')
  250 format(11x,a11,6x,'HIS',3x,'CUM')
  300 format(34x,i8,2f7.2,/)
c
      ipher = 0
      DEALLOCATE (dijs, jorde, jorde1, stat = ierr)
      if (ierr.ne.0) then
          write(*,*) 'PherrDisNew DeAllocation Error'
          call cstop(' ')
      endif
c
      return
      end
!------------------------------------------------------------------------------
      subroutine Res_Bias(ier)  ! per applicare Res_Bias ad una mappa
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE Param
      USE PhaseModule
      USE Molcom
      USE MappaCorrezione
      USE CorrMod
!
      common /GedmCommon/ ifGedm, cicliFour, nBatch, nGedm,
     *                    ifCMap, CMapVet(3)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty   ! devo settare istat2 = 0 dopo ultimo build
!
      nMaxLeg = 9800
      call InitMolplo()
      jlig = nzConst
!
      nMapCor = 0
      sigma1 = sigma1_indaga
      numberToUse = nrefl
   
      lfin = 1
      do lcyc = 1,lfin

         wt(1:numberToUse)= 1.0
         fcoef(1:numberToUse)= fovet(1:numberToUse) 
c        fcoef(1:numberToUse)= evet(1:numberToUse) 
         iphaz(1:numberToUse) = ipub(1:numberToUse)
         NatUsed = max(anat,5.0)

         iniz = 1
         ifin = 1

         do nic = iniz,ifin

             aperc(1) = NatUsed
             nats = NatUsed
             rperc(1) = numberToUse
 
             nMapCor = nMapCor + 1

             call MapCorrection(jlig,numberToUse,ier)
      
     
         enddo  ! su nic
      enddo  ! su lcyc

      return
      end
!------------------------------------------------------------------------------
