!-----------------------------------------------------------------------
      ! sigmaA routine
      ! Dritan : 28/06/2005
c--------------------------------------
      ! input:
      ! jsigma=1  <E2Ec2>
      ! jsigma=2  R(E2Ec2)
      ! jsigma=3  <E2-Ec2>
      ! jsigma=4  nel caso di FreeLunch (jsigma = -4)
      ! jsigma=5,6  nel caso di Fourier differenza
      ! jsigma< 0  Ec instead of Fc
      ! Fo ,sigFo,--> observed data
      ! rho --> (sinT/l)^2
      ! eps
      ! Fop2 & iphi2 wtt --> calculated data  (wtt can be also 1.0)
      ! iphi --> true phase
      ! iphi2o &  wto --> observed phase/weigth for combination (icombPh=1)
      ! nrefl1 --> number of reflection (observed)
      ! nrefSi --> number of reflection (incluse non-observed)
      ! ndim --> dimension for all the arrays
      ! output:
      ! wvar , m(pesMod) and D (Dluz)
      !
      subroutine sigmaA(jflag,fop1,sigfo,eobs1,itype,rho,epsv,fop2,
     *    iphi1,iphi2,wtt,iphi2o,wto,
     *    wvar,pesMod,Dluz,Eop,Ecp,
     *    ndim,nrefl1,icombPh,iprint,ifLinear)

      USE General
      USE Symmetry
      USE ShellSIGMAA
      USE Param
      USE PhaseModule
      USE riflessi_c
      USE RemoModule


      dimension fop1(ndim),sigfo(ndim),eobs1(ndim),fop2(ndim),
     *          rho(ndim),epsv(ndim),itype(ndim),wtt(ndim)
      dimension iphi1(ndim),iphi2(ndim),iphi2o(ndim)
      dimension Dluz(ndim),wvar(ndim),Eop(ndim),Ecp(ndim)
      dimension pesMod(ndim),wto(ndim)
      real lim_midpts

      real,     allocatable   :: Eobs(:),Emodi(:)
      real,     allocatable   :: ee(:),sigEobs(:),wtnew(:)
      integer,  allocatable   :: iphinew(:)
      real,     allocatable   :: Eo2Shell(:),Ec2Shell(:),Eo2Ec2Shell(:)
      real,     allocatable   :: SIGnShell(:),SIGpShell(:),SIGqShell(:)
      real,     allocatable   :: EpsShell(:),scEo2Shell(:),scEc2Shell(:)
      real,     allocatable   :: SIGMAAShell(:),eeShell(:),
     *                           SIGMAAeShell(:),
     *                           SIGMAAShell_l(:),xfit(:),yfit(:)
      real,     allocatable   :: cosErrShell(:),FacGSIMShell(:),
     *                           cosErrEShell(:),
     *                           cosErroShell(:),cosErrcShell(:)
      real,     allocatable   :: wtnewShell(:),DluzShell(:),sig(:),
     *                           DluzShell_l(:),numbShell(:)
      real,     allocatable   :: wttShell(:),
     *                           sumDiffShell(:),sumFoShell(:),
     *                           rfacShell(:),
     *                           gsimShell(:),wtoShell(:),wtcShell(:)
      real,     allocatable   :: EomEcShell(:),SIGMAAnShell(:)

      double precision,     allocatable   :: r(:),drds(:)
   
      allocate(Eobs(nrefl1),Emodi(nrefl1),
     *         ee(nrefl1),sigEobs(nrefl1),wtnew(nrefl1),iphinew(nrefl1),
     *         stat=ierr)
      jsigmaa=iabs(jflag)
c--deb
c     iprint = 1
      if (iprint==1) then
        write(lo,*)'================================='
        write(lo,*)'=  sigmaA  routine',jflag,icombPh
        write(lo,*)'================================='
      endif

      sigAmed=0.0
      do i=1, nrefl1
*        wto(i)=0.0
*        iphi2o(i)=0
         pesMod(i)=0.0
         Dluz(i)=0.0
         wvar(i)=0.0
   
         Eobs(i)=0.0
         Emodi(i)=0.0
         ee(i)=0.0
         sigEobs(i)=0.0
         wtnew(i)=0.0
         iphinew(i)=0
      enddo

**    RES(1:nrefl1)=sqrt(rho(1:nrefl1))

**    Nbin=30
**    Nstat=floor(nrefl1/float(Nbin))
**    Nbin=8.0*alog10(0.05*float(max0(nrefl1,100))+0.5)

      allocate (Eo2Shell(Nbin),Ec2Shell(Nbin),Eo2Ec2Shell(Nbin),
     *         SIGnShell(Nbin),SIGpShell(Nbin),SIGqShell(Nbin),
     *         EpsShell(Nbin),scEo2Shell(Nbin),scEc2Shell(Nbin),
**   *         eeShell(Nbin),midpts(Nbin),SIGMAAShell(Nbin),
     *         eeShell(Nbin),             SIGMAAShell(Nbin),
     *         SIGMAAShell_l(Nbin),xfit(Nbin),yfit(Nbin),
     *         cosErrShell(Nbin),FacGSIMShell(Nbin),
     *         wtnewShell(Nbin),DluzShell(Nbin),DluzShell_l(Nbin),
**   *         sig(Nbin),shellTAB(Nbin,2),numbShell(Nbin),
     *         sig(Nbin),                 numbShell(Nbin),
     *         wttShell(Nbin),wtoShell(Nbin),sumDiffShell(Nbin),
     *         sumFoShell(Nbin),rfacShell(Nbin),
     *         cosErrEShell(Nbin),cosErroShell(Nbin),cosErrcShell(Nbin),
     *         gsimShell(Nbin),
     *         SIGMAAeShell(Nbin),wtcShell(Nbin), 
     *         EomEcShell(Nbin), SIGMAAnShell(Nbin),
     *         r(Nbin),drds(Nbin), 
     *         stat=ierr)

**    shellTAB(:,:)=0.0
**    midpts(:)=0.0
**    RES_TAG(:)=0
**    call shells(shellTAB,midpts,RES_TAG,RES,nrefl1,Nbin,1) 

      do i=1, Nbin
         Eo2Shell(i)=0.0
         Ec2Shell(i)=0.0
         Eo2Ec2Shell(i)=0.0
         SIGqShell(i)=0.0
         eeShell(i)=0.0
         scEo2Shell(i)=1.0
         scEc2Shell(i)=1.0
         SIGMAAShell(i)=0.0
         SIGMAAeShell(i)=0.0
         SIGMAAnShell(i)=0.0
         SIGMAAShell_l(i)=0.0
         DluzShell(i)=0.0
         DluzShell_l(i)=0.0
         cosErrShell(i)=0.0
         cosErroShell(i)=0.0
         cosErrcShell(i)=0.0
         cosErrEShell(i)=0.0
         FacGSIMShell(i)=0.0
         wtnewShell(i)=0.0
         wttShell(i)=0.0
         wtoShell(i)=0.0
         wtcShell(i)=0.0
         sumDiffShell(i)=0.0
         rfacShell(i)=0.0
         sumFoShell(i)=0.0
         gsimShell(i)=0.0
         EomEcShell(i)=0.0
         SIGnShell(i)=0.0
         SIGpShell(i)=0.0
         numbShell(i)=0.0
      enddo

      ! calc sihP, sigQ & sigN for any shell

      if (iprint==1) then
       write(lo,*)'Nr riflessi obs:',nrefl1
       write(lo,*)'Nr riflessi con Fc >0:',count(fop2(1:nrefl1) > 0.0)
       if (jflag > 0) then
        write(lo,*)'Nr riflessi con Fo >0:',count(fop1(1:nrefl1) > 0.0)
       else
        write(lo,*)'Nr riflessi con Eo >0:',count(eobs1(1:nrefl1) > 0.0)
       endif
       write(lo,*)'Nr riflessi con wt >0:',count(wtt(1:nrefl1) > 0.0)
      endif
      if (jflag > 0) then
        sumFo=sum(fop1(1:nrefl1)*fop2(1:nrefl1))
        sumFc=sum(fop2(1:nrefl1)**2)
      else
        sumFo=sum(eobs1(1:nrefl1))
        sumFc=sum(fop2(1:nrefl1))
      endif

      if (kmad == 0) then
            scaleFoFc=sumFo/sumFc
      else
            scaleFoFc = 1.0
      endif

      if (iprint==1) then
        if (jflag > 0) then
          write(lo,*)'scale(Fo,fc):',scaleFoFc
        else
          write(lo,*)'scale(Eo,Cc):',scaleFoFc
        endif
      endif
      if (jflag > 0) then
        sumFo=sum(fop1(1:nrefl1))
      else
        sumFo=sum(eobs1(1:nrefl1))
      endif


      sumDiff=0.0
      do i=1,nrefl1
         if(use_E)then
            k  = k_mem1(i)
         else
            k=i
         endif
         ii=RES_TAG(i)
canna
         eps=epsv(k)*pts
         wref=2.0
         if (itype(i) > 1) wref=1.0
         numbShell(ii)=numbShell(ii) + wref                                !!!!!!
         SIGnShell(ii)=SIGnShell(ii) + wref*((fop1(i)**2)/eps)                                !!!!!!
         if (jflag > 0) then
           SIGpShell(ii)=SIGpShell(ii) + wref*((fop2(i)**2)/eps)
           sumDiffShell(ii)=sumDiffShell(ii)  +
     *           abs(fop1(i) - scaleFoFc *fop2(i))
**         sumFoShell(ii)=sumFoShell(ii) + fop1(i)                                !!!!!!
           sumDiff=sumDiff  + abs(fop1(i) - scaleFoFc *fop2(i))
         else
           sumDiffShell(ii)=sumDiffShell(ii)  +
     *           abs(eobs1(i) - scaleFoFc *fop2(i))
**         sumFoShell(ii)=sumFoShell(ii) + eobs1(i)                                !!!!!!
           sumDiff=sumDiff  + abs(eobs1(i) - scaleFoFc *fop2(i))
         endif

      enddo
      do i=1,Nbin
        SIGpShell(i)=SIGpShell(i)/numbShell(i)
        SIGnShell(i)=SIGnShell(i)/numbShell(i)
      enddo

      !------------------------------
      do i=1,nrefl1
         ii=RES_TAG(i)
canna
         if(use_E)then
            k  = k_mem1(i)
         else
            k=i
         endif
         eps=epsv(k)*pts
         if (jflag > 0) then
           Eobs(i)=fop1(i)/(sqrt(eps*SIGnShell(ii)))
           Emodi(i)=fop2(i)/(sqrt(eps*SIGpShell(ii)))
         else
           Eobs(i)=eobs1(i)
           Emodi(i)=fop2(i)
         endif
      enddo
!
      sumEo=sum(Eobs(1:nrefl1))
      sumEc=sum(Emodi(1:nrefl1))
      scaleEoEc=sumEo/sumEc
!   
      if (iprint==1) then
        write(lo,*)'scale(Eo,Ec):',scaleEoEc
      endif

      sumDiffShell(:)=0.0
**    sumFoShell(:)=0.0
      sumDiff=0.0
      if(ifPatt==1) then
         sumCCfom=0.0
         sumEfom=0.0
         sumEcfom=0.0
         sumE2fom=0.0
         sumEc2fom=0.0
!
         do i=1,nrefl1
          if(Eobs(i)<0.5.or.Eobs(i)>2.0) then
            sumCCfom=sumCCfom+Eobs(i)*scaleEoEc*Emodi(i)
            sumEfom=sumEfom+Eobs(i)
            sumEcfom=sumEcfom+scaleEoEc*Emodi(i)
            sumE2fom=sumE2fom+Eobs(i)**2
            sumEc2fom=sumEc2fom+(scaleEoEc*Emodi(i))**2
          endif
         enddo
         sumCCfom=sumCCfom/nrefl1
         sumEfom=sumEfom/nrefl1
         sumEcfom=sumEcfom/nrefl1
         sumE2fom=sumE2fom/nrefl1
         sumEc2fom=sumEc2fom/nrefl1
!
         argnumfom=sumCCfom-sumEfom*sumEcfom
         argden1fom=sumE2fom-sumEfom**2
         argden2fom=sumEc2fom-sumEcfom**2
!
         if(argden1fom>0.00001.and.argden2fom>0.00001) then
            argdenfom = Sqrt(argden1fom*argden2fom)
         else
            argdenfom = 0.0
         endif
!
         if(argdenfom>0.0) then
            dphi = argnumfom / argdenfom
         else
            dphi = 0.0
         endif

       endif
      do i=1,nrefl1
         ii=RES_TAG(i)
         sumDiffShell(ii)=sumDiffShell(ii)  + 
     *           abs(Eobs(i) - scaleEoEc *Emodi(i))
         sumFoShell(ii)=sumFoShell(ii) + Eobs(i)
         sumDiff=sumDiff  + abs(Eobs(i) - scaleEoEc *Emodi(i))
       enddo

       if (ifPatt==1) then
         exposigma = min(sqrt(scaleEoEc),3.0)
         if(no(nk)<=10) exposigma = min(sqrt(scaleEoEc),1.5)
       else
         expo = exposigma
         dexpo = 0.1
         if(is3s2>5000.or.ksize>5) then
            sogwaveare = 0.15
            if(no(nk)>=20) sogwaveare = 0.25
         elseif(is3s2>2500.and.is3s2<=5000) then
            sogwaveare = 0.20
            if(no(nk)>=20) sogwaveare = 0.3
         elseif(is3s2>1500.and.is3s2<=2500) then
            sogwaveare = 0.25
            if(no(nk)>=20) sogwaveare = 0.35
         elseif(is3s2>1000.and.is3s2<=1500) then!KUKU
            sogwaveare = 0.3
            if(no(nk)>=20) sogwaveare = 0.35
         else
            sogwaveare = 0.3
            if(no(nk)>=20) sogwaveare = 0.35
            if(v_p<0.55) sogwaveare = 0.5
         endif
         if(no(nk)<=10) then
             sogwaveare=min(0.25+0.05*float(Iterazione),0.40)!KUKU
         endif
         if(Iterazione>8.and.Complet<0.9.and.LowRes==0.and.ksize<7) then
            sogwaveare = min(0.20+0.02*float(Iterazione),0.65)
         endif
         if(Iterazione>3.and.ksize==7.and.no(nk)<=20) then
            sogwaveare = min(0.20+0.05*float(Iterazione-1),0.65)
         endif
!        isogiter = 8
         isogiter = 3!liberato2009
!        if(v_p<0.4) isogiter = 16
         if(ResEff>1.99) isogiter=8!liberato2009
         if(LowRes==1) then
             if(no(nk)<20) then
                sogwaveare = 0.3
                if(is3s2>5000) sogwaveare = 0.25
             else
                sogwaveare = min(0.25+0.05*float(Iterazione),0.65)
                if(ResEff<sogResEff) then
c                  if(esalta>1.0.and.ksize>5.and.
c    *                LowRes==1.and.no(nk)>=20) then
                   if(esalta>1.0.and.is3s2>2000.and.
     *                LowRes==1.and.no(nk)>=20.and.ksize<7) then
                         expo = 1.0
                   endif
                else
                  if(Complet<0.80) then
                    sogwaveare = min(0.20+0.05*float(Iterazione),0.65)
                  else
                    sogwaveare = 0.33
                    if(Iterazione>isogiter) then!liberato2009
                      sogwaveare = 0.5
                    endif
                    if(FinalFom>1.0) then!liberato2009
                      sogwaveare = 0.6
                    endif
                  endif
                endif
             endif
         endif
         if(waveare>sogwaveare) then
             expo = expo - dexpo
         else
             expo = expo + dexpo
         endif
         if(v_p<0.6) then
            if(waveare<0.15.and.Iterazione>2) expo = expo + dexpo
         else
            if(waveare<0.10.and.Iterazione>3) expo = expo + dexpo
         endif
         if (iesfast == 0) then
           exposigma = expo
         else
           exposigma = 2.0   ! valore per il fast (solo per Calcola_Fom_Early)
         endif
       endif

       if (ifPostDSR == 1) then
           if (ifVLD == 1) then
               exposigma = 2.5
           else
               exposigma = 2.0 !2.5
           endif
       endif
!-- dedi
c      if (ifEndDSR == 1) then
c          exposigma = 2.0
c      endif
!-- dedi

       if (iesFom > 0) then    ! solo per FOM
          if (ifPostDSR > 0 .or. Itera_Imp > 0) then    ! solo per FOM
              if (ifVLD == 0) exposigma = 1.0 !1.2  !     2.0 ! provare con 1.0
          endif
       endif

c             exposigma = 1.5 !sempre!!!!!!!!!!!!!!!

!-- dedi
       if (ifRemo == 1) then
           exposigma = 2.0  ! provare anche 3.0 o 1.0
       endif
!-- dedi

       sogsig = 0.01
       if(Complet<0.9.and.LowRes==0.and.ksize>4.and.iwei==0) sogsig=0.1!KUKU
       if(LowRes==1.and.is3s2<2500) sogsig=0.1
       if (kmad/=0) then
         pdri1=-3.1334
         pdri2=0.9472
         pdri3=0.79443
         sogsig = 0.01
         pdri1res=-0.12
         pdri2res=1.54
       endif
       do i=1, Nbin
        if (sumFoShell(i) > 0.0 ) then
         rfac=sumDiffShell(i)/sumFoShell(i)
         if (kmad/=0) then
           resLimit=0.5/midpts(i)
           resCorrection=1.0
           if (resLimit > 7.0) then
             resCorrection=0.7
           elseif (resLimit < 4.5) then
             resCorrection=1.0
           else
             resCorrection=pdri1res*resLimit + pdri2res
           endif
           rfac=min(0.7,rfac)
           rfacShell(i)=rfac
           cosErrEShell(i)=pdri1*(rfac**2) + pdri2*rfac + pdri3
         else
           rfac=min(0.99,rfac)
           rfac=max(0.01,rfac)
           rfacShell(i)=rfac
           cosErrEShell(i)=1-rfac**exposigma
         endif
         cosErrEShell(i)=max(sogsig,cosErrEShell(i))
        endif
       enddo
      if (iprint==1) then
        write(lo,*)' <sigN>',sum(SIGnShell(:))/float(Nbin)
        write(lo,*)' <sigP>',sum(SIGpShell(:))/float(Nbin)
        write(lo,*)' <sigP>/<sigN>',sum(SIGpShell(:))/sum(SIGnShell(:))
      endif

      ! calc Eo, Ec
      do i=1,nrefl1
       ii=RES_TAG(i)
canna
       if(use_E)then
            k  = k_mem1(i)
         else
            k=i
       endif
       eps=epsv(k)*pts
       if(iprint>0) then
         diffERR=(iphi2(k)-iphi1(k)) * dtor
         diffERR=cos(diffERR)
         cosErrShell(ii)=cosErrShell(ii) + diffERR
       endif
       if (jflag > 0) then
         Eobs(i)=fop1(i)/(sqrt(eps*SIGnShell(ii)))
         Emodi(i)=fop2(i)/(sqrt(eps*SIGpShell(ii)))
       else
         Eobs(i)=eobs1(i)
         Emodi(i)=fop2(i)
       endif
       if (kmad /= 1) then
c        if(sigfo(i).le.0.1) sigfo(i) = 1.0 !OCCHIO
         sigEobs(i)=sigfo(k)/(sqrt(eps*SIGnShell(ii)))
       else
           sigEobs(i)=sigfo(k)  !   per MAD i sigma sono sigma(E)
       endif
       if(ifnoEE==1) then
              ee(i)=1.0 
       else
              ee(i)=1.0 + sigEobs(i)
       endif
       eeShell(ii)= eeShell(ii)+ee(i)
       Eo2Shell(ii)= Eo2Shell(ii)+Eobs(i)**2
       Ec2Shell(ii)= Ec2Shell(ii)+Emodi(i)**2
       Eo2Ec2Shell(ii)=Eo2Ec2Shell(ii) + ((Eobs(i)**2)*(Emodi(i)**2))
       EomEcShell(ii)=EomEcShell(ii) + (Eobs(i)-Emodi(i))**2
      enddo

      if (iprint==1) then
        write(lo,*)'<Eo>',sum(Eobs(:))/float(nrefl1)
        write(lo,*)'<Ec>',sum(Emodi(:))/float(nrefl1)
        write(lo,*)'<sigE>',sum(sigEobs(:))/float(nrefl1)
      endif

      ! calc <Eo2>, <Ec2> <Eo2Ec2> for any shell
      do i=1, Nbin
        numbShell1=count(RES_TAG(:) == i)
        Eo2Shell(i)=Eo2Shell(i)/float(numbShell1)
        Ec2Shell(i)=Ec2Shell(i)/float(numbShell1)
        Eo2Ec2Shell(i)=Eo2Ec2Shell(i)/float(numbShell1)
        eeShell(i)=eeShell(i)/float(numbShell1)
        if(iprint>0) then
          cosErrShell(i)=cosErrShell(i)/float(numbShell1)
        endif
        EomEcShell(i)=EomEcShell(i)/float(numbShell1)
      enddo
croc
c
c--serve per il calcolo della figura di merito Patterson
c
croc
      if (iprint==1) then
        write(lo,*)'<e>o',sum(eeShell(:))/float(Nbin)
        write(lo,*)'<Eo2>o',sum(Eo2Shell(:))/float(Nbin)
        write(lo,*)'<Ec2>o',sum(Ec2Shell(:))/float(Nbin)
        write(lo,*)'<(Eo-Ec)2>',sum(EomEcShell(:))/float(Nbin)
        write(lo,*)'<Eo2Ec2>o',sum(Eo2Ec2Shell(:))/float(Nbin)
        write(lo,*)'R(Eo,Ec)',sumDiff/sumEo
      endif
      !scale <Eo2> , <Ec2>, <Eo2Ec2> and calc <sigmaA> for any shell
      do i=1,Nbin
        scEo2Shell(i)=Eo2Shell(i)/1.0
        scEc2Shell(i)=Ec2Shell(i)/1.0
        Eo2Shell(i)=Eo2Shell(i)/scEo2Shell(i)
        Ec2Shell(i)=Ec2Shell(i)/scEc2Shell(i)
        Eo2Ec2Shell(i)=Eo2Ec2Shell(i)/(scEo2Shell(i)*scEc2Shell(i))
      enddo

       ! gsim for any shell
      do i=1,nrefl1
        ii=RES_TAG(i)
        ee1=Eobs(i)/sqrt(scEo2Shell(ii))
        ee2=Emodi(i)/sqrt(scEc2Shell(ii))
        gsimShell(ii)=gsimShell(ii) + 2.*ee1*ee2
        aa=12.*sqrt(ee(i))/pi**2
        bb=4.-(pi*sqrt(ee(i)))
        SIGMAAn=aa*(bb -2.*EomEcShell(ii))
        if (SIGMAAn > 0.0) then
          SIGMAAnShell(ii)=SIGMAAnShell(ii) + sqrt(SIGMAAn)
        else
          SIGMAAnShell(ii)=0.0
        endif
      enddo

       do i=1,Nbin
          numbShell1=count(RES_TAG(:) == i)
          SIGMAAnShell(i)=SIGMAAnShell(i)/float(numbShell1)
       enddo

       rSumSigmaan=sum(abs(SIGMAAnShell(1:Nbin)))

       if (rSumSigmaan > 0.0 ) then
         do ii=1,Nbin
          do i=1,Nbin
           if (SIGMAAnShell(i) < 0.0001) then
             if (i == Nbin) then
               SIGMAAnShell(i)=SIGMAAnShell(i-1)
             elseif (i == 1) then
               SIGMAAnShell(i)=SIGMAAnShell(i+1)
             else
               SIGMAAnShell(i)=0.5*(SIGMAAnShell(i-1) + 
     *              SIGMAAnShell(i+1))
             endif
           endif
          enddo
         enddo
        endif

      do i=1,Nbin
         numbShell1=count(RES_TAG(:) == i)
         gsimShell(i)=gsimShell(i)/float(numbShell1)
         gsimE=besinv(cosErrEShell(i))
         gsimE1=gsimShell(i)
         gg=gsimE1/gsimE
         det=gg**2 + 4.*eeShell(i)
         if (det > 0) then
          siga1=(-gg + sqrt(det))/2.0
          siga2=(-gg - sqrt(det))/2.0
          SIGMAAeShell(i)=siga1
         endif
      enddo
      rSumSigmaae=sum(abs(SIGMAAeShell(1:Nbin)))

c     if ((sum(Eo2Ec2Shell(:))/float(Nbin)) < 1.1) eeShell(1:Nbin)=1.0
!     if ((sum(Eo2Ec2Shell(:))/float(Nbin)) < 1.1
!    &                    .and.ifPatt/=1) eeShell(1:Nbin)=1.0
      do ii=1,Nbin
       do i=1,Nbin
        dif=Eo2Ec2Shell(i) - eeShell(i)
        if (dif < 0.01) then
          if (i == Nbin) then
            Eo2Ec2Shell(i)=Eo2Ec2Shell(i-1)
          elseif (i == 1) then
            Eo2Ec2Shell(i)=Eo2Ec2Shell(i+1)
          else
            Eo2Ec2Shell(i)=0.5*(Eo2Ec2Shell(i-1) + 
     *              Eo2Ec2Shell(i+1))
          endif
        endif
       enddo
      enddo

      do i=1,Nbin
       if (Eo2Ec2Shell(i) > eeShell(i)) then
         SIGMAAShell(i)=sqrt((Eo2Ec2Shell(i)-eeShell(i)))
       else
         if (Eo2Ec2Shell(i) > 1.0) then
            SIGMAAShell(i)=sqrt((Eo2Ec2Shell(i)-1.0))
         else
           SIGMAAShell(i)=0.0
         endif
        endif
        SIGMAAShell(i)=max(0.05,SIGMAAShell(i))
c       if(iprint>0) write(6,*) 'uffa',i,Eo2Ec2Shell(i),
c    &                     eeShell(i),SIGMAAShell(i)
      enddo

      select case (jsigmaa)
      case (1)
       jsigmaaT=1
      case (2)
       if (rSumSigmaae > 0.0) then
         SIGMAAShell(1:Nbin)=SIGMAAeShell(1:Nbin)
         jsigmaaT=2
       else
         jsigmaaT=1
       endif
      case (3)
       if (rSumSigmaan > 0.0) then
         SIGMAAShell(1:Nbin)=SIGMAAnShell(1:Nbin)
         jsigmaaT=3
       else
         jsigmaaT=1
       endif
      end select

      if (iprint == 1) then
          if (jsigmaa /= jsigmaaT) then
             write(lo,*) 'Cambiato da',jsigmaa,' a ',jsigmaaT
          endif
      endif

      jsigmaa=jsigmaaT
      rSumSigmaa=sum(abs(SIGMAAShell(1:Nbin)))

      if (rSumSigmaa < 0.0001) then
       write(lo,*) ' !!!!! errore sum(sigmaA)=0 '
       call cstop(' ')
      endif


      ! sigmaa refinement (max =10 cycle)
       if (jsigmaa==1) then
         do 100 iref=1,10
          r(:)=0.0d0
          drds(:)=0.0d0
          do i=1,nrefl1
           ii=RES_TAG(i)
           en=Eobs(i)
           ep=Emodi(i)
           if (en > 0.0.and.ep > 0.0) then
           x=2.0*en*ep*SIGMAAShell(ii)/(eeShell(ii)-SIGMAAShell(ii)**2)
           dxds=2.0*en*ep*(eeShell(ii)+SIGMAAShell(ii)**2)/
     *         (eeShell(ii)-SIGMAAShell(ii)**2)**2
           if (itype(i)==1) then
            rm=sim(x)
            rmbyx=0.5
            if (x.gt.0.001) rmbyx=rm/x
            r(ii)=r(ii)+2.0d0*dble(SIGMAAShell(ii)-rm*en*ep)
            drds(ii)=drds(ii)+
     +        2.0d0*dble(1.0-en*ep*(1.0-rmbyx-rm**2)*dxds)
             if (iprint > 0) then
c              write(lo,*) 'acent ',x,dxds,rm,rmbyx,drds(ii),
c    +              2.0d0*dble(1.0-en*ep*(1.0-rmbyx-rm**2)*dxds)
             endif
           else
            rm=tanh(0.5*x)
            r(ii)=r(ii)+dble(SIGMAAShell(ii)-rm*en*ep)
            drds(ii)=drds(ii)+dble(1.0-en*ep*0.5*(1.0-rm**2)*dxds)
             if (iprint > 0) then
c              write(lo,*) ' cent ',x,dxds,rm,drds(ii),
c    &                      dble(1.0-en*ep*0.5*(1.0-rm**2)*dxds)
             endif
           endif
           endif
         enddo
       ! update sigmaA
         dsmax=0.0
         do i=1,Nbin
            numbShell1=count(RES_TAG(:) == i)
            if (numbShell1.gt.0) then
!crocco
              if(drds(i)<0.0001) then
                ds=0.0
              else
                ds=real(r(i)/drds(i))
              endif
              SIGMAAShell(i)=SIGMAAShell(i)-ds
              SIGMAAShell(i)=min(SIGMAAShell(i),0.999)
              if (iprint > 0) then
                write(lo,'(2x,i8,7(2x,f9.4))')
     *                 i,midpts(i),r(i),drds(i),
     *                 SIGMAAShell_l(i),ds,SIGMAAShell(i),
     *                 wttShell(i)/numbShell1
              endif
              dsmax=max(abs(ds),dsmax)
            endif
           enddo
        if (dsmax.lt.0.0001) goto 102
 100    continue
 102    continue
        if (iprint==1) then
          write(lo,*)'sigmaA cycles:',iref
        endif
      endif

      ! linear fit per sigmaA
      mwt=0
      sig(:)=0.0

      lim_midpts = 0.5 / resm
      if (lim_midpts < 0.9) lim_midpts = 0.9
      nInit=1
      do i=1,Nbin
        if (midpts(i) > lim_midpts) then
         nInit=i
         exit
        endif
      enddo

c     print*,'nInit=',nInit
      
      nEnd=1
      NPT=Nbin - nInit + 1 - nEnd
      if (ifLinear == 1) then
!
!-- elimino i bin finali con valori di sigmaA troppo piccoli
! 
          k = NPT
          do i=NPT,1,-1
             if (SIGMAAShell(i) > 0.05) then
                 k = i
                 exit
             endif
          enddo
          NPT = k
      endif
!
      j = nInit
      do i=1, NPT
         xfit(i) =  midpts(j)
         yfit(i) = SIGMAAShell(j)
         j = j + 1
      enddo
!!      xfit(1:NPT)=midpts(nInit:Nbin-1)
!!      yfit(1:NPT)=SIGMAAShell(nInit:Nbin-1)

      call fit(xfit,yfit,NPT,sig,mwt,a,b,siga,sigb,chi2,q)

      if (iprint==1) then
          write(lo,*)'sigmaA linear fitting:'
          write(lo,'(1x,t5,a,f9.6,t24,a,f9.6)') 'A = ',a,
     *          'Uncertainty: ',siga
          write(lo,'(1x,t5,a,f9.6,t24,a,f9.6)') 'B = ',b,
     *          'Uncertainty: ',sigb
          write(lo,'(1x,t5,a,4x,f10.6)') 'Chi-squared: ',chi2
          write(lo,'(1x,t5,a,f10.6)') 'Goodness-of-fit: ',q
      endif

      do i=1,Nbin
         if (ifLinear == 1) then
             SIGMAAShell_l(i)=b*midpts(i) + a     ! era commentata
         else
             SIGMAAShell_l(i)=SIGMAAShell(i)
         endif
         SIGMAAShell_l(i)=min(1.0,SIGMAAShell_l(i)) 
         if (ifLinear == 1) then
             SIGMAAShell(i)=SIGMAAShell_l(i)
         else
             SIGMAAShell_l(i)=SIGMAAShell(i)
         endif

         FacGSIMShell(i)=SIGMAAShell_l(i)
     *                   /(eeShell(i) -SIGMAAShell_l(i)**2)

         if (a > 0.0 ) then
           DluzShell_l(i)=SIGMAAShell_l(i)/sqrt(a)
           DluzShell_l(i)=min(1.0,DluzShell_l(i))
         else
          DluzShell_l(i)=DluzShell(i)
         endif

         if (jflag > 0) then
           sigNsigP=sqrt(SIGnShell(i)/SIGpShell(i))
           sigNsigP=max(1.0,sigNsigP)
           DluzShell(i)=SIGMAAShell_l(i)*sigNsigP
           DluzShell(i)=min(1.0,DluzShell(i))
           DluzShell(i)=max(0.0,DluzShell(i))
         endif
         DluzShell_l(i)=max(0.0,DluzShell_l(i))
      enddo

cdedi
c
c  uso la retta dei minimi quadrati
c
      sumx=0.0
      sumy=0.0
      sumxx=0.0
      sumxy=0.0
      do ii=1,NBin
       x=midpts(ii)
       y=SIGMAAShell_l(ii)
       sumx=sumx+x
       sumy=sumy+y
       sumxx=sumxx+x*x
       sumxy=sumxy+x*y
      enddo
      delta=Nbin*sumxx-sumx*sumx
      bbterm=(Nbin*sumxy-sumx*sumy)/delta
      aaterm=(sumy*sumxx-sumx*sumxy)/delta
c
!     sigmaven=sum(SIGMAAShell_l(:))/float(Nbin)!ultima mod
      sigmaven=sum(cosErrEShell(:))/float(Nbin)
!     write(lo,'(a,5f8.3)')'SIGMAVE',sigmaven,aaterm,bbterm
cdedi
!     if (iprint==1) then
c     if (ifOUT==1 .and. knw == 1) then
      if (knw == 1 .and. iftime == 0) then
       write(lo,99) exposigma,RenveDyn,waveare,sigmaven
      endif
 99    format(' SIGMAA: EXP= ',f8.1,2x,'RAG.ENV= ',f4.1,
     *        2x,'PESO PRECED= ',f5.2,' <sigmaa>= ',f5.2)
      if (iprint==1) then
        write(lo,*)'<e>n',sum(eeShell(:))/float(Nbin)
        write(lo,*)'<Eo2>n',sum(Eo2Shell(:))/float(Nbin)
        write(lo,*)'<Ec2>n',sum(Ec2Shell(:))/float(Nbin)
        write(lo,*)'<Eo2Ec2>n',sum(Eo2Ec2Shell(:))/float(Nbin)
      endif

      sigAmed=sum(SIGMAAShell(:))/float(Nbin)
*gl*  Eo2Ec2Mean(:) = SIGMAAShell(:)   ! gianluca 15/03/2011  solo x articolo

      ! calc. new weigth (modified sim weigth using sigmaA)
      sumErro=0.0
      sumwto=0.0

      sumErrn=0.0
      sumwtn=0.0

      sumErrc=0.0
      sumwtc=0.0

      sumErrnc=0.0
      sumwtnc=0.0

      sumErren=0.0
      sumwten=0.0

      nwto=0
      nwte=0
      nwtn=0
      nwten=0
      nwtc=0
      nwtnc=0
      do i=1,nrefl1
        ii=RES_TAG(i)
        if(use_E)then
            k  = k_mem1(i)
         else
            k=i
        endif
        wref=2.0
        if (itype(i) > 1) wref=1.0
        ee1=Eobs(i)
        ee2=Emodi(i)
        gmod=wref*ee1*ee2*FacGSIMShell(ii)
        gmod=max(0.0,gmod)
!
        Eop(i)= gmod
!
        if (itype(i)==1) then
         wtnew(i)=sim(gmod)
        else
         wtnew(i)=tanh(0.5*gmod)
        endif
        wtnew(i)=min(1.0,wtnew(i))
c
        if(iprint>0) then
          ! errore fase nuova
          if (wtnew(i) > 0.0) then
           diffERR=(iphi2(k)-iphi1(k)) * dtor
           diffERR=cos(diffERR)
           if (wto(i) > 0.0) then
            sumErrn=sumErrn + acos(diffERR)*rtod
            sumwtn=sumwtn+wtnew(i)
            nwtn=nwtn+1
           else
            sumErren=sumErren + acos(diffERR)*rtod
            sumwten=sumwten+wtnew(i)
            nwten=nwten+1
           endif
          endif
        endif

        wtnewShell(ii)=wtnewShell(ii) + wtnew(i)
        wttShell(ii)=wttShell(ii) + wtt(i)
        wtoShell(ii)=wtoShell(ii) + wto(i)

        gold=0.0
        if (wto(i) > 0) then
          fomo=wto(i)
          ! com con wt/fasi iniziali obs
          if (itype(i)==1) then
            gold=siminv(fomo)
          else
            gold=atanhILM(fomo)
          endif
        endif
        csum=gmod*cos(iphi2(k)*dtor) + gold*cos(iphi2o(i)*dtor)
        ssum=gmod*sin(iphi2(k)*dtor) + gold*sin(iphi2o(i)*dtor)
        args=csum**2 + ssum**2
        if (args > 0.0 ) then
          fase=atan2(ssum,csum)*rtod
          fase=mod(fase+3600.,360.)
          if (itype(i) > 1) fase = favi(itype(i),fase)
          peso=sqrt(csum**2 + ssum**2)
          if (icombPh==1) then
            iphinew(i)=nint(fase)
            if (itype(i)==1) then
              pesMod(i)=sim(peso)
            else
              pesMod(i)=tanh(peso)
            endif
          else
           ! senza combinazione
           iphinew(i)=iphi2(k)
           pesMod(i)=wtnew(i)
          endif
          if (kmad/=0.and.pesMod(i)>0.0)then
            pesMod(i)=max(0.1,pesMod(i))
          endif
        else
          iphinew(i)=0
          pesMod(i)=0.0
        endif
        wtcShell(ii)=wtcShell(ii) + pesMod(i)
c
        if(iprint>0) then
          ! errore fasi obs
          if (wto(i) > 0.0) then
           diffERR=(iphi2o(i)-iphi1(k)) * dtor
           diffERR=cos(diffERR)
           cosErroShell(ii)=cosErroShell(ii) + diffERR
           sumErro=sumErro + acos(diffERR)*rtod
           sumwto=sumwto+wto(i)
           nwto=nwto+1
          endif
          ! errore fasi comb
          if (pesMod(i) > 0.0) then
            diffERR=(iphinew(i)-iphi1(k)) * dtor
            diffERR=cos(diffERR)
            cosErrcShell(ii)=cosErrcShell(ii) + diffERR
            if (wto(i) > 0.0) then
              sumErrc=sumErrc + acos(diffERR)*rtod
              sumwtc=sumwtc+pesMod(i)
              nwtc=nwtc+1
            else
              sumErrnc=sumErrnc + acos(diffERR)*rtod
              sumwtnc=sumwtnc+pesMod(i)
              nwtnc=nwtnc+1
            endif
          endif
        endif
        ! calcolo w (il peso per fourier differenza)
        var=(ee1**2) * (1.0 -wtnew(i)**2)
        if (var > 0.0) then
           wvar(i)=1.0*exp(-0.5*sqrt(var))
           wvar(i)=min(1.0,wvar(i))
        else
           wvar(i)=0.0
        endif
        if (SIGMAAShell(ii) > 0.0) then
          wvar(i)=wvar(i)*sqrt(SIGMAAShell(ii))
        endif
canna          Dluz(i)=DluzShell_l(ii)
c        Dluz(i) = Eo2Ec2Shell(ii)       
         if(use_E) then
            Dluz(i) = SIGMAAShell(ii)
         else
            Dluz(i)=DluzShell_l(ii)
         endif
      enddo

      do i=1, Nbin
        numbShell1=count(RES_TAG(:) == i)
        if (numbShell1 > 0) then
          wtnewShell(i)=wtnewShell(i)/float(numbShell1)
          wttShell(i)=wttShell(i)/float(numbShell1)
          wtoShell(i)=wtoShell(i)/float(numbShell1)
          wtcShell(i)=wtcShell(i)/float(numbShell1)
          if(iprint>0) then
            cosErroShell(i)=cosErroShell(i)/float(numbShell1)
            cosErrcShell(i)=cosErrcShell(i)/float(numbShell1)
          endif
        endif
      enddo
!Attenzione
      wtt(1:nrefl1) = pesMod(1:nrefl1)

      do i=1,nrefl1
         if(use_E)then
            k  = k_mem1(i)
         else
            k=i
         endif
         iphi2(k) = iphinew(i)
      enddo 
      !
!--stampe finali
!
c     iprint = 100

      if(iprint>0) then
        write(lo,*)'<wvar>',sum(wvar(:))/count(wvar(:) > 0.0)
        write(lo,10)
  10    format(1x,'Shell',1x,'res',2x,'sint/l',3x,'NREF',
     *         2x,'<Eo2Ec2>',1x,'R(Eo,Ec)',
     *         1x,' <Eo-Ec>',1x,'sigmaA',1x,
     *         3x,'m_o',2x,'cosERRo',3x,'m  ',2x,'cosERR ',
     *         1x,'m_c',2x,'cosERRc',3x,'D  ',3x,'D_l    ')
        do i=1,Nbin
          numbShell1=count(RES_TAG(:) == i)
           write(lo,20)i,0.5/midpts(i),midpts(i),
     *                numbShell1,
     *                Eo2Ec2Shell(i),
     *                rfacShell(i),
     *                EomEcShell(i),
     *                SIGMAAShell(i),
     *                wtoShell(i),cosErroShell(i),
     *                wtnewShell(i),cosErrShell(i),
     *                wtcShell(i),cosErrcShell(i),
     *                DluzShell(i),DluzShell_l(i)
      
  20    format(2x,i2,1x,f6.2,1x,f6.3,2x,i5,4(2x,f7.4),11(' ',f6.3))
        enddo
        nwto1=count(wto(1:nrefl1)>0.0)
        if (nwto > 0.0) then
           wtomed=sum(wto(1:nrefl1))/float(nwto1)
        else
           wtomed=0.0
        endif
        nwtn1=count(wtnew(1:nrefl1)>0.0)
        if (nwtn1 > 0.0) then
           wtnmed=sum(wtnew(1:nrefl1))/float(nwtn1)
        else
           wtnmed=0.0
        endif
        nwtc1=count(pesMod(1:nrefl1)>0.0)
        if (nwtc1 > 0.0) then
           wtcmed=sum(pesMod(1:nrefl1))/float(nwtc1)
        else
           wtcmed=0.0
        endif

        write(lo,25)
  25    format(2x,116('_'))
c       write(lo,'(20x,i5,4(2x,f7.4),11(2x,f5.3))')
        write(lo,"(20x,i5,4(2x,f7.4),8(' ',f6.3))")
     *             nrefl1,
     *             sum(Eo2Ec2Shell(:))/float(Nbin),
     *             sumDiff/sumEo,
     *             sum(EomEcShell(:))/float(Nbin),
     *             sum(SIGMAAShell(:))/float(Nbin),
     *             wtomed,
     *             sum(cosErroShell(:))/float(Nbin),    
     *             wtnmed,
     *             sum(cosErrShell(:))/float(Nbin),    
     *             wtcmed,
     *             sum(cosErrcShell(:))/float(Nbin),
     *             sum(DluzShell(:))/float(Nbin),
     *             sum(DluzShell_l(:))/float(Nbin)
        if (nwto > 0) then
          write(lo,*)'  Combination with Initial Phases'
          write(lo,30) nwto,sumErro/float(nwto),sumwto/float(nwto)
  30      format (2x,'Before: ',2x,'Nref=',i5,2x,'<dphi>=',
     *        f6.2,2x,'<m>=',f6.3)
        endif
        if (nwtn > 0) then
           write(lo,40) nwtn,sumErrn/float(nwtn),sumwtn/float(nwtn)
  40       format (2x,'After:  ',2x,'Nref=',i5,2x,'<dphi>=',
     *        f6.2,2x,'<m>=',f6.3)
        endif
        if (nwtc > 0) then
            write(lo,50) nwtc,sumErrc/float(nwtc),sumwtc/float(nwtc)
  50        format (2x,'Combine:',2x,'Nref=',i5,2x,'<dphi>=',
     *        f6.2,2x,'<m>=',f6.3)
        endif
        if (nwten > 0) then
          write(lo,*)'  Non Combine reflections'
          write(lo,60) nwten,sumErren/float(nwten),sumwten/float(nwten)
  60      format (12x,'Nref=',i5,2x,'<dphi>=',f6.2,2x,'<m>=',f6.3)
        endif
        write(lo,*)'-----------------------------'
        write(lo,*)'sigmaA calc from:'
        if (jflag > 0) then
          write(lo,*)'|F|'
        else
          write(lo,*)'|E|'
        endif
        select case (jsigmaa)
           case (1)
             write(lo,*)'<Eo2Ec2>'
           case (2)
             write(lo,*)'R(EoEc)'
           case (3)
             write(lo,*)'<Eo-Ec>'
        end select
        write(lo,*) 'nref',nrefl1
        write(lo,*) '<sigmaA>',sum(SIGMAAShell(:))/float(Nbin)
        write(lo,*) '<m>',sum(pesMod(1:nrefl1))/
     *               count(pesMod(1:nrefl1)>0.0)
        write(lo,*) '<cosPHI>',sum(cosErrShell(:))/float(Nbin)
        write(lo,*) '<D>',sum(DluzShell(:))/float(Nbin)
        write(lo,*)'-----------------------------'
        write(lo,*)'================================='
        write(lo,*)'=       end sigmaA              ='
        write(lo,*)'================================='
      endif

c     iprint = 0

      deallocate(Eobs,Emodi,ee,sigEobs,wtnew,stat=ierr)
      deallocate (Eo2Shell,Ec2Shell,Eo2Ec2Shell,
     *          SIGnShell,SIGpShell,SIGqShell,
     *          EpsShell,scEo2Shell,scEc2Shell,
**   *          eeShell,midpts,SIGMAAShell,
     *          eeShell,       SIGMAAShell,
     *          SIGMAAShell_l,xfit,yfit,
     *          cosErrShell,FacGSIMShell,
     *          wtnewShell,DluzShell,DluzShell_l,
     *          sig,         numbShell,
     *          wttShell,wtoShell,sumDiffShell,
     *          sumFoShell,rfacShell,
     *          cosErrEShell,cosErroShell,cosErrcShell,
     *          gsimShell,
     *          SIGMAAeShell,EomEcShell,SIGMAAnShell,wtcShell, 
     *          r,drds,
     *          stat=ierr)
      return
      end
!-----------------------------------------------------------------------
      subroutine shells (SH,midpts,ITAG,res,Nt,Nbin,jshell)
      dimension SH(Nbin,2),ITAG(Nt),res(Nt),nsum(Nbin+1),sumr(Nbin+1)
      real midpts(Nbin),midpts_back(Nbin)
      real,     allocatable   :: res_sort(:)
      integer,  allocatable   :: IX_sort(:),IX_aux(:)

      allocate(res_sort(Nt),IX_sort(Nt),IX_aux(Nt),stat=ierr)

      SH(:,:)     = 0.0
      midpts(:)   = 0.0
      ITAG(:)     = 0
      nsum(:)     = 0.0
      sumr(:)     = 0.0
      res_sort(:) = 0.0
      IX_sort(:)  = 0
      IX_aux(:)   = 0

      nb=Nbin
      Ndata=floor(Nt/float(nb))
c     print*,Nt,nb,Ndata

      go to (1000,2000),jshell

 1000 continue

      rmin=minval(res(1:Nt))
      rmin=rmin**2
      rmax=maxval(res(1:Nt))
      rmax=rmax**2

c     print*,nb,rmin,rmax,0.5/sqrt(rmin),0.5/sqrt(rmax)

      add=(rmax-rmin)/float(nb)
      rr=float(nb)/(rmax-rmin)
      start=rmin-add
      ends=rmin+add

      do i=1,Nt
       rho=res(i)**2
       n=min0(int(1.0+rr*(rho-rmin)),nb)
       ITAG(i)= n
       nsum(n)=nsum(n) + 1
       sumr(n)=sumr(n) + rho
      enddo

      do i=1,nb
       nsum(i)=nsum(i)+nsum(i+1)
       sumr(i)=sumr(i)+sumr(i+1)
       start=start+add
       ends=amin1(ends+add,rmax)
       SH(i,1)=sqrt(start)
       SH(i,2)=sqrt(ends)
       wr=float(nsum(i))
       div=1.0/amax1(1.0,wr)
       midpts(i)=sumr(i)*div
c      write(6,'(1h ,i3,f8.4,3h  -,f8.4,2x,f8.4,i6)')i,start,ends,
c    *        midpts(i),nsum(i)
      enddo
      midpts(nb)=rmax
      midpts_back(1:nb)=midpts(1:nb)
      nb1=nb
      ii=2
      do i=2,nb-1
       if (nsum(i).le.0) then
        ii=i - (nb-nb1)
        midpts_back(1:ii-1)=midpts_back(1:ii-1)
        midpts_back(ii:nb1-1)=midpts_back(ii+1:nb1)
        nb1=nb1-1
       endif
      enddo

      nb=nb1
      midpts(1:nb)=midpts_back(1:nb)
      Nbin=nb

      do i=1,Nt
        IX_sort(i)=i
        res_sort(i)=res(i)**2
      enddo
      call sortall3(1,res_sort,1,Nt,IX_sort)

      ITAG(:)= 0
      n=1
      do i=1,Nt
 20     sog=midpts(n)
        if (n > nb) sog=rmax
        if (res_sort(i) <= midpts(n)) then
         ITAG(IX_sort(i))= n
        else
         n=n+1
         goto 20
        endif
      enddo

c     nn=0
c     do i=1, nb
c       numbShell=count(ITAG(:) == i)
c       nn=nn + numbShell
c       print*,i,numbShell,nn
c     enddo

      midpts(1:nb)=sqrt(midpts(1:nb))

      goto 5000

 2000 continue

      do i=1,Nt
        IX_sort(i)=i
        res_sort(i)=res(i)
      enddo

      call sortall3(1,res_sort,1,Nt,IX_sort)

      do i=1,Nbin-1
         rmin=10000.0
         rmax=-10000.0
         j=0
         do ii=1+(i-1)*Ndata,i*Ndata
           j=j+1
c          print*,i,IX_sort(ii)
c          ITAG(IX_sort(ii),1)= IX_sort(ii)
           ITAG(IX_sort(ii))= i
           rmax=max(rmax,res(IX_sort(ii)))
           rmin=min(rmin,res(IX_sort(ii)))
         enddo
         SH(i,1)=rmin
         SH(i,2)=rmax
       enddo

      rmin=10000.0
      rmax=-10000.0
      j=0
      do ii=1+(Nbin-1)*Ndata,Nt
           j=j+1
c          ITAG(IX_sort(ii),1)= IX_sort(ii)
           ITAG(IX_sort(ii))= Nbin
           rmax=max(rmax,res(IX_sort(ii)))
           rmin=min(rmin,res(IX_sort(ii)))
      enddo
      SH(Nbin,1)=rmin
      SH(Nbin,2)=rmax

      midpts(1:Nbin)=0.5*(SH(1:Nbin,1) + SH(1:Nbin,2))

 5000  continue

       deallocate(res_sort,IX_sort,IX_aux,stat=ierr)

       return
       end
!-----------------------------------------------------------------------
      subroutine rescale_sigmaA(numb,iAction)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE RemoModule
      USE ShellSIGMAA
      USE Param , only :scale1
      real FacGSIMShell(100)
      real shi(4),segni_mio(numb)
      character tirang*80
!     common /anna/ sigma_media, ccost
 
      iprin=1
      if(iAction==1)then
          sigmaAshell2_l(:) = sigma_media**2
      elseif(iAction==2)then
          sigmaAshell2_l(:)=sigmaAshell2_l(:)*(scale1**2)
      endif
      do i = 1,numb
         ii = RES_TAG(i)
         ec = foper(i)
         eo = evet(i)
         sigmaAshell2_l(ii) = max(0.001,sigmaAshell2_l(ii))
         sigmaAshell2_l(ii) = min(0.999,sigmaAshell2_l(ii))
         FacGSIMShell(ii) = 1.0 - sigmaAshell2_l(ii)
         FacGSIMShell(ii) = FacGSIMShell(ii) * sqrt(ddocm(ii))
         FacGSIMShell(ii) = sqrt(sigmaAshell2_l(ii)) / FacGSIMShell(ii)
      !
      ! il peso
         gmod=2.0*eo*ec*FacGSIMShell(ii)
         gmod=max(0.001,gmod)
         pesi(i)=sim(gmod)
         pesi(i)=min(1.0,pesi(i))
!!!!     argBess(i)=gmod

      enddo
       
      sigma_media=0.0
      do i=1,Nbin
         sigma_media=sigma_media+sqrt(sigmaAshell2_l(i))
      enddo
      sigma_media=sigma_media/Nbin
 
      wt(:)  = pesi(:)
      if (iprin > 0) then
          tirang = 'weight'
          izero = 0
          ifmin = 1
          nse = 1133
          call examin(nse,mkang,khl,ipub,iphaz,nrefl,
     *                     izero,wt,ifmin)
 
           if (ksize>3)then
               shi(:) = 0.0
               segni_mio = 0.0
               call ParamDistribution(tirang,2,pesi,khl,numb,1,
     *         ipub,iphaz,shi,pesi,segni_mio,10,1.0)
           else
               izero = 0
               ipher = 0
               call pherrdisNew(tirang,wt,khl,mkang,nrefl,
     *                 izero,ipub,iphaz,wt,10,0.0,ipher)
           endif

           write(lo,25)
           do i=1,Nbin
              numbShell=count(RES_TAG(:) == i)
              write(lo,20)i,0.5/midpts(i),numbShell,
c     *                Eo2Ec2Shell(i),
     *                EomShell(i,1),EcmShell(i,1),
     *                EomShell(i,2),
     *                EcmShell(i,2),
c     *                EomShell(i,4),EcmShell(i,4),
c     *                EomShell(i,6),EcmShell(i,6),
c
     *                sqrt(sigmaAshell2(i)),
     *                sqrt(sigmaAshell2_l(i))
c     *                eeoShell(i)
          enddo
       endif
20     format(2x,i2,1x,f6.2,2x,i4,6(2x,f7.2))
25     format(' Shell res   Nref     <Eo>     <Ec>    <Eo**2>',
c     *       '  <Ec**2> <Eo**4>  <Ec**4>  <Eo**6>  <Ec**6> sigmaA ',
     *       '  <Ec**2> sigmaA ',
     *       'sigmaA_l ')
       iprin = 0


      return
      end
!-----------------------------------------------------------------------
      subroutine sigmaA_G2(isE,numb) !attenzione se isE==1 gli E si passano in foper 

      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
      USE ShellSIGMAA
 
      implicit none
      real sim
      real, allocatable   :: RES(:), shellTAB(:,:)
      real sigmaAshell2_2(100)
      integer numb, Nstat, ierr, i, ii, numbShell, nOrdine
      integer ifmin, nse, izero, ipher
      real  fo,fc, eo, ec, eps, wref, diffERR, r_M, wi, gmod
      real  EonormShell(100),EcnormShell(100)
c      integer numbShells(100)
      real  Eo1Shell(100),Ec1Shell(100)
      real  Eo2Shell(100),Ec2Shell(100),eeoShell(100)
      real  Eo2Ec2Shell(100),shi(4),segni_mio(numb)
      real  FacGSIMShell(100), wt_mio(numb)
      real  Eo4Shell(100),Ec4Shell(100)
      real  scEo2Shell(100), scEc2Shell(100)
      real  numbShells(100), eeShell(100),SIGnShell(100)
      real  ee(numb) ,sigEobs(numb)
      integer iphaz_sav(numb)
      real  sum_r, sum_t, sum_q, sum_p, scw
      real  sigma_r, sigma_rp, corr_sigma, R2Rp2
      integer isE
      character tirang*80
      logical isRenorm
      logical plusDelta
      real wtmedio, E4medio, corr_dir,erreS
      real sumFo, sumFc, sumDiff, scal,sigma_rif,scale2
      integer cicloHafr, iesHM,nmod, nCB, ipr
      logical ceck_EDM, ceck_HAFR
 
      common /anna/ E4medio,wtmedio,corr_dir, erreS
      common /anna1/ scale2,sigma_rif,cicloHafr,iesHM,nCB 
      common /anna2/ ipr

      iprin = 1
      isRenorm=.true.
      plusDelta=.false.!.true.
      ceck_EDM=.false.
      ceck_HAFR =.false.
!
      numbShells=0.0
      Nbin  = 30
      Nstat = floor( numb / float(Nbin) )
      Nbin  = 8.0*alog10( 0.05*float( max0(numb, 100) ) + 0.5 )
      allocate (RES(numb), RES_TAG(numb), stat=ierr)
      allocate (shellTAB(Nbin,2), midpts(Nbin), stat=ierr)
      RES(1:numb) = sqrt(rhov(1:numb))
      shellTAB(:,:) = 0.0
      midpts(:)     = 0.0
      RES_TAG(:)    = 0
!
      call shells(shellTAB, midpts, RES_TAG, RES, numb, Nbin, 1)
      deallocate (RES, shellTAB, stat=ierr)
     
      if (knw > 0) then
          iphaz_sav(1:nrefl)=iphaz(1:nrefl)
          call Trasla_Origine(nrefl)
      endif

      do i=1,numb
         ii=RES_TAG(i)
         eps=epsv(i)*pts
         wref=2.0
         if (mkang(i) > 1) wref=1.0
         numbShells(ii)=numbShells(ii) + wref                                !!!!!!
         SIGnShell(ii)=SIGnShell(ii) + wref*((fovet(i)**2)/eps)                                !!!!!!
      enddo
      do i=1,Nbin
        SIGnShell(i)=SIGnShell(i)/numbShells(i)
      enddo
      Eo4Shell(:) = 0.0
      Ec4Shell(:) = 0.0
      Ec2Shell(:) = 0.0
      Eo2Shell(:) = 0.0
      Eo2Ec2Shell(:) = 0.0
      eeoShell(:) = 0.0
      do i = 1,numb
         ii = RES_TAG(i)
         eps=epsv(i)*pts 
         ec = foper(i)
         eo = evet(i)
         if(knw==1)then 
            diffERR=(iphaz(i)-ipub(i)) * dtor
            diffERR=cos(diffERR)
            eeoShell(ii)=eeoShell(ii) + diffERR
         endif
         Eo4Shell(ii) = Eo4Shell(ii) + eo**4
         Eo2Shell(ii) = Eo2Shell(ii) + eo**2

         Ec4Shell(ii) = Ec4Shell(ii) + ec**4
         Ec2Shell(ii) = Ec2Shell(ii) + ec**2
         sigEobs(i)=sigmav(i)/(sqrt(eps*SIGnShell(ii)))
         if(ifnoEE==1) then
              ee(i)=1.0 
         else
              ee(i)=1.0 + sigEobs(i)
         endif
         eeShell(ii)= eeShell(ii)+ee(i)

c         if(mkang(i)==1)then
                  
            Eo2Ec2Shell(ii)=Eo2Ec2Shell(ii) + (eo*ec)**2
c
c         else
c            Eo2Ec2Shell(ii)=Eo2Ec2Shell(ii) + 0.5*(eo*ec)**2
c
c         endif
                
      enddo
!
! --  calcolo < E**2 >  for any shell
!

      do i = 1, Nbin
         numbShell = count(RES_TAG(:) == i)   
         if(knw==1) eeoShell(i)=eeoShell(i)/float(numbShell)
         Eo2Ec2Shell(i)=Eo2Ec2Shell(i)/float(numbShell)
 
         EomShell(i,2)=Eo2Shell(i)/float(numbShell)
         EomShell(i,4)=Eo4Shell(i)/float(numbShell)
         EcmShell(i,2)=Ec2Shell(i)/float(numbShell)
         EcmShell(i,4)=Ec4Shell(i)/float(numbShell)
         eeShell(i)=eeShell(i)/float(numbShell)
      enddo
      if(isRenorm)then
        do i=1,Nbin
           scEo2Shell(i)=EomShell(i,2)/1.0
           scEc2Shell(i)=EcmShell(i,2)/1.0
           EomShell(i,2)=EomShell(i,2)/scEo2Shell(i)
           EomShell(i,4)=EomShell(i,4)/(scEo2Shell(i)**2)
           EcmShell(i,2)=EcmShell(i,2)/scEc2Shell(i)
           EcmShell(i,4)=EcmShell(i,4)/(scEc2Shell(i)**2)
           Eo2Ec2Shell(i)=Eo2Ec2Shell(i)/(scEo2Shell(i)*scEc2Shell(i))
        enddo
      endif

!dritan
      do i=1,Nbin
         sigma_r = sqrt(EomShell(i,4) - EomShell(i,2)**2)
         sigma_rp = sqrt(EcmShell(i,4) - EcmShell(i,2)**2)
         if (plusDelta)then
            R2Rp2=Eo2Ec2Shell(i)/((EomShell(i,4)/2.)*(EcmShell(i,4)/2.))
         else
            R2Rp2=Eo2Ec2Shell(i)
         endif
         corr_sigma = (R2Rp2-EomShell(i,2)*EcmShell(i,2))/
     *                (sigma_r*sigma_rp)
c         write(6,*)"CORR=",corr_sigma
c         if (icent == 0) then
             scw=0.8/(1.+midpts(i)**0.75)
             sigmaAshell2(i)= max(corr_sigma,0.0001)
             sigmaAshell2_l(i)=scw * sigmaAshell2(i)**(EcmShell(i,4)/2.)
             sigmaAshell2(i)=sigmaAshell2(i)**(EcmShell(i,4)/2.) 
c             sigmaAshell2_2(i)=R2Rp2-1
c         else
c             sigmaAshell2(i) = corr_sigma/2.
c         endif  
      enddo
      sigmaAshell2(:) = max(0.001,sigmaAshell2(:))
      sigmaAshell2(:) = min(0.999,sigmaAshell2(:))
      sigmaAshell2_l(:) = max(0.001,sigmaAshell2_l(:))
      sigmaAshell2_l(:) = min(0.999,sigmaAshell2_l(:))


c        sigmaAshell2_l(:)=0.0
c        sum_r = 0.0
c        sum_q = 0.0
c        sum_t = 0.0
c        sum_p = 0.0 
c        r_M = 0.0
c        sigmaAshell2(:) = max(0.001,sigmaAshell2(:))
c        sigmaAshell2(:) = min(0.999,sigmaAshell2(:))
c
c        do ii = 1,Nbin
c          wi = 1.
c          sum_r = sum_r + wi * sigmaAshell2(ii)* (midpts(ii)**2)
c          sum_t = sum_t + wi * sigmaAshell2(ii)
c          sum_q = sum_q + wi * (midpts(ii)**2)
c          sum_p = sum_p + wi * (midpts(ii)**4) 
c          r_M = r_M + wi
c        enddo
c        acoeff = (r_M * sum_r - sum_t * sum_q)/(r_M * sum_p - sum_q**2)
c        bcoeff = (sum_p *sum_t - sum_r * sum_q)/(r_M * sum_p - sum_q**2)
        corr_dir=0.0
c        do i = 1,numb
c         ii = RES_TAG(i)
c         sigmaAshell2_l(ii) = acoeff * (midpts(ii)**2) + bcoeff
c         sigmaAshell2_l(ii) = sigmaAshell2(ii)!per non usare la linearizzazione
c        enddo
        sigma_media=(sum(sqrt(sigmaAshell2_l(1:Nbin))))/float(Nbin)
c       sigma_rif=1.0

      goto 100


!per il calcolo della scala: serve a evitare che la sigma cresca troppo rapidamente nei primi cicli
        if(ipr==2)then
           cicloHafr=cicloHafr+1
        else
           cicloHafr=0
        endif
!        ncontIter=Iterazione+1
!i primi 5 cicli delle prime due iterazioni è controllata
        if(indiceBlocchi==1.and.
     *     nCB>=1.and.nCB<=5.and.Iterazione<3)
     *     ceck_EDM=.true.

!     *     indiceMicro>=1.and.indiceMicro<=6.and.nmod==0)ceck_EDM=.true.
!        if((cicloEDM<=6.and.cicloEDM>=1).and.Iterazione)ceck_EDM=.true.
        if(cicloHafr<=2.and.cicloHafr>=1)ceck_HAFR=.true.
        if(ceck_EDM.or.ceck_HAFR)then
           if(cicloEDM==1.or.cicloHafr==1)sigma_rif=sigma_media
           scale2=sigma_rif/sigma_media
        endif
        if(iesHM==1)scale2=1.0
        write(6,*)nCB,scale2,sigma_media,sigma_rif,cicloHafr

 100  continue

        scale2=1.0
        sigmaAshell2_l(:)=sigmaAshell2_l(:)*(scale2**2)
        sigma_media=(sum(sqrt(sigmaAshell2_l(1:Nbin))))/float(Nbin)
        do i = 1,numb
         ii = RES_TAG(i)
c         if(ifPatt.ne.1)then
c           ec = foper(i)!/sqrt(scEc2Shell(ii))
c           eo = evet(i)!/sqrt(scEo2Shell(ii))
c         else
           ec = foper(i)/sqrt(scEc2Shell(ii))
           eo = evet(i)/sqrt(scEo2Shell(ii))
c         endif
         sigmaAshell2_l(ii) = max(0.001,sigmaAshell2_l(ii))
         sigmaAshell2_l(ii) = min(0.999,sigmaAshell2_l(ii))
         FacGSIMShell(ii) = !eeShell(ii) - sigmaAshell2_l(ii)
     *   1.0 - sigmaAshell2_l(ii)
         FacGSIMShell(ii) = sqrt(sigmaAshell2_l(ii)) / FacGSIMShell(ii)
      !
      ! il peso
         wref=1.7
         if(Iterazione>5)wref=1.75
         if (mkang(i) > 1) wref=1.0

         gmod=wref*eo*ec*FacGSIMShell(ii)
         gmod=max(0.0,gmod)
         if (mkang(i)==1) then
            wt_mio(i)=sim(gmod)
         else
            wt_mio(i)=tanh(0.5*gmod)
         endif
         wt_mio(i)=min(1.0,wt_mio(i))
c         wt_mio(i)=max(0.1,wt_mio(i))
         worko(i)=gmod
         corr_dir=corr_dir+ec*eo*gmod
        enddo

        work1(1:nrefl)=fcvet(1:nrefl)
        call E2FNew(1,numb)

        sumFo = 0
        sumFc = 0
        sumDiff = 0
        do i = 1,numb
          sumFo = sumFo + fovet(i)
          sumFc = sumFc + work2(i)
        enddo
        scal = sumFo / sumFc
        do i = 1,numb
          sumDiff = sumDiff + abs(fovet(i) - scal * work2(i))
        enddo


        corr_dir=corr_dir/float(numb)
        E4medio=sum(EcmShell(1:Nbin,4))/float(Nbin)
        erreS=sumDiff/sumFo
 
        wt(1:nrefl)  = wt_mio(1:nrefl)
        if (iprin > 0) then
           tirang = 'weight'
           izero = 0
           ifmin = 1
           nse = 1133
           call examin(nse,mkang,khl,ipub,iphaz,nrefl,
     *                     izero,wt,ifmin)
           
           if (ksize>3)then
               shi(:) = 0.0
               segni_mio = 0.0
               call ParamDistribution(tirang,2,wt_mio,khl,numb,1,
     *         ipub,iphaz,shi,wt_mio,segni_mio,10,1.0)
           else
               izero = 0
               ipher = 0
               call pherrdisNew(tirang,wt,khl,mkang,nrefl,
     *                 izero,ipub,iphaz,wt,10,0.0,ipher)
           endif

           write(lo,25)
           do i=1,Nbin
              numbShell=count(RES_TAG(:) == i)
              write(lo,20)i,0.5/midpts(i),numbShell,
     *                Eo2Ec2Shell(i),
     *                EomShell(i,2),
     *                EcmShell(i,2),
     *                EomShell(i,4),
     *                EcmShell(i,4),
     *                sqrt(sigmaAshell2(i)),
     *                sqrt(sigmaAshell2_l(i)),
     *                eeoShell(i)
          enddo
       endif
       
       iphaz(1:nrefl)=iphaz_sav(1:nrefl)
20     format(2x,i2,1x,f6.2,2x,i4,7(2x,f7.2),2x,f7.4)
25     format(' Shell res   Nref  <(EoEc)**2> <Eo**2>',
     *       '  <Ec**2> <Eo**4>  <Ec**4>  sigmaA ',
c     *       '  <Ec**2>  sigmaA ', 
     *       'sigmaA_l  cos(err)')


       iprin = 0

      return
      end
!-----------------------------------------------------------------------
