!-----------------------------------------------------------------------
!-- sir code for sir2006                        Release 2004.01
      subroutine sir2006main()
!     program sir2006main
      USE General
      USE Atomi
      USE Molcom
      USE Html
      USE MadModule
      USE PhaseModule
      USE elements
      USE bondtmod
      USE grafici, only: preRemo
!
!-- graphics
      common /SizeScr/ MinScX, MaxScX, MinScY, MaxScY
!--
      common /InitialPlotCommon/ ifInitial
      common /RotMou/ iAnchorX, iAnchorY, IfDrag, IcanDrag, iDragEnabled
     *               ,mEv_fsBtn
! ---
      common /sfact/ nSfCard, sfacm(18,9), kSfac(18)
!
      real    :: elTime
      character*256 file1,file2,filen,nomeStr
      character file*80,line*80
      character*8 itldef
!
      preRemo = .false.
      SaltaUNK = .false.
      ier = 0
      ifRecover = 0
      QualePgm = SIRPGM
      QualeLista6 = QualePgm
      ier = 0
      call PrimeCose(ier)
      if (ier /= 0) then
          call cstop('Program cannot start')
      endif
!
      call elapsed_time_tot(1, elTime, ' ', ' ')
      ier = 0
      jrest = 0
      call InitSir2006(0)
!
!pgMAD2507
      line = ProgName(1:lProgName)//' starts'
      call CPUTime0(line)
      call CPUTime0(line)
!      call CPUTime0(ProgName)
!pgMAD2507

!
      call BeccaSt(ier,file1,file2,filen,nomeStr)
      if (ier.lt.0) then
          call LockFile(-1, 0, 0)
          go to 1000
      endif
!
!-- set up default title
!
      itldef  = ' ' // ProgName(1:lProgName)
      do i=1,19,2
         read(itldef,'(2a4)') itle(i),itle(i+1)
      enddo
      write(Titolo,'(20a4)') itle(1:20)
!
      call CheckPath(ier)
      if (ier.lt.0) then
          go to 1000
      endif
!
!     carica tabella degli elementi chimici 
      call read_chemical_elements(ffile)  
      call load_bond_table()
!!--ex      nOpEq=10000
!!      nOpEq=1555
!
!-- set up the default names for work files
!
      k = Lung(nomeStr)
      if (k > 0) then
          cardImage = file1
          call lcase(cardImage)
          j = index(cardImage,'.ins',.TRUE.) 
          if (j > 0) then
              ifFromShelx = 1
          else
              ifFromShelx = 0
          endif
          do i=1,13
             file=nomeStr(1:k)//ext(i)
             call NoBlanks(file,lfile)
             fname(i)=file(1:lfile)
          enddo
          if (file1(1:1).eq.' ') then
              file=nomeStr(1:k)//ext(14)
              call NoBlanks(file,lfile)
              fname(14)=file(1:lfile)
          elseif (ifFromShelx == 0) then
              fname(14)=file1
              call CheckStructCommand(file1,ier)
              call updRecentProjects()
          endif
          if (file2(1:1).eq.' ') then
              file=nomeStr(1:k)//ext(15)
              call NoBlanks(file,lfile)
              fname(15)=file(1:lfile)
          else
              fname(15)=file2
          endif
      else
          line = 'New Project'
      endif
!
!-- define the number of reflections per block in scratch file
!--   nrpb = (number of words in block) / 8
!
      nrpb = knwr / 8
c
c-- check if %window is supplied in *.sir file
c
      nkscrx = 0
      nkscry = 0
      if (file1(1:1).ne.' '.and.file1(1:7).ne.'newproj') then
          Titolo = line
!gl!      call CheckWindowCommand(file1,nkscrx,nkscry,line,ier)
          if (ifFromShelx == 0) then
              call CheckWindowCommand(file1,nkscrx,nkscry,ier)
          else
              call FromShelxToSir(file1, nomeStr, ier)
          endif
          if (ier.lt.0) go to 1000
      endif
!
      if (ifGTK.eq.0) then
          kscreen = 0
      endif
!
      if (kscreen.ne.0) then
          call scr0(nkscrx,nkscry)
          if (file1(1:1).ne.' '.and.kscreen.eq.1) then   ! modifica il 
!gl!          call SetWindowTitle(line)
              call SetWindowTitle(Titolo)
              call f_FortranAlLavoro(1)
          endif
      else
          jscreen = 0
          call GoOnWithoutGraphics()
      endif
c
      setmin = 0
      erm1min  = 9999
      erm1sav  = 9999
      bestmin = 9999
      kbest = 0
c
!mr   if (file1(1:1).ne.' ') then
      if (file1(1:1).ne.' '.and.file1(1:7).ne.'newproj') then
          iFrom = 1
          call mainloop(iFrom,file1,file2,ier)
          if (ier.lt.0) go to 1000
      endif
      if (jscreen /= 0) then
          if (ifRunToolBar.eq.1) then
              call RunToolBar(-1,' ')
          endif
          call StartGtkMainLoop(ifAutomatic,ier)
      else
          if (InfoOK(15) /= 0) then
              if (jscreen == 0) then
                  SinglePlotType(:) = SIMPLE
              endif
              call PutModel
              call ExitSir2006(ier)
          endif
      endif
!--
 1000 iAction = 2
      if (ier < 0) then
          write(line,2000) ProgName(1:lProgName)
      else
           k = index(fname(1),'.')
           kk = kStripTask1(k)
           kk = kk - 1
          write(line,3000) ProgName(1:lProgName), 'on: ',
     *                     fname(1)(1:kk)
      endif
!
      if (kmad /= 0) then
          if (ier < 0) then
              call LockFile(-1, numFragsMad, ifBreak)
          else
              call LockFile(0, numFragsMad, ifBreak)
          endif
      else
!         call LockFile(-2, numFragsMad, ifBreak)
      endif
!
!
      lline = Lung(line)
      if(ier.ne.-2) call scrend(line,lline)
!      
!mr   call updRecentProjects
      close (jdir)
      if (jscreen.eq.0.or.ifAutomatic.eq.1) then
          if (ier.lt.0) then
              write(0,'(3x,a,a,a)') line(1:lline),
     *                ': check output file or ',
     *                ProgName(1:lProgName) // '.log'
          else
              write(0,'(3x,a)') line(1:lline)
          endif
      endif
!
      if (knw.ne.0) then
***       write(lo,1) erm1min,nint(setmin), bestmin,iabs(kbest)
          close(jerr)
      endif
*** 1 format(' Errore Minimo=',f6.2,' nel trial',i6,' Rmin=',f8.2,
***  *       '%  nel trial',i6)
!
      kWstop = 2
      jcpuP = 1
      call CPUTime(ProgName, 1)
      call elapsed_time_tot(2, elTime, ProgName(1:lProgName), MessH)
      write(lo,'(a)') MessH(1:Lung(MessH))
!      write(lo,1901) nSecsTot,float(nSecsTot)/60.,float(nSecsTot)/3600.
 1901 format(/,'  CPU SECs  ',i9,
     *       /,'  CPU MINs  ',f11.1,
     *       /,'  CPU HOURs ',f11.1)
      write(lo,4000,err=1950) line(1:lline)
!
      call DistruggiPianiAll
      call AllocaMappa(2)
      call AllocaRiflessi(2)
*     call AllocaRiflessi_c(2)
      call AllocaHistoStuff(2)
!
      close (lo)
!
 1950 call text_mode(1)
      if (jscreen == 0 .and. ifW95 == 1) then
!          pause
      endif
!
      return
 2000 format(a,' ends in error')
 3000 format(a,' ends OK ',a,a)
 4000 format(//,' ',a)
      end
!-----------------------------------------------------------------------
      subroutine PrimeCose(ier)
      USE General
      USE Molcom
!
      character*256 logfile, cfgdir
      integer getCfgDir
!
      ifW95 = nfGetEnv()
      call GetMessagesCode
      call FillCaratteriSpeciali()
      if (ifW95 == 0) then
          slash = char(47)
      else
          slash = char(92)
      endif
!
      cfgdir = ' '
      cfgdir(256:256) = char(0)
      ier   = getCfgDir(cfgdir)
      if (ier /= 0) then
          ier = -1
          return
      else
          logfile = cfgdir(1:Lung(cfgdir)) // slash //
     *              ProgName(1:lProgName) // '.log'
      endif
!
      ier = 0
      itipo = 0
      iform = 1
      jop=jopen(lo,logfile,itipo,iform,ier)
      if (jop /= 0) then
          ier = -1
      endif
      call CheckRecordLength
      call FillCifKey()
      call BlankGeometry
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GoOnWithoutGraphics()
      USE General
      USE Molcom
!
      if (ifDebug == 0) then
          call manage_console(1)
          if (ifW95 /= 0) then
              ifDebug = 1
          endif
      endif
!
      write(0,*) 
      write(0,'(a)') ' ' // ProgName(1:lProgName) //
     *               ' will go on without graphics.  '
      write(0,'(a)') ' Results will be written in the file   '
      write(0,'(a)') '         ' // fname(15)(1:Lung(fname(15)))
      write(0,'(a)') 
!
      return
      end
!-----------------------------------------------------------------------
      subroutine RoutineHeader(routine)
      USE General
      USE Molcom
!
      character*(*) routine
!
      write(lo,10)
      write(Inte,20) ProgName(1:lProgName), routine(1:Lung(routine))
      write(Inte(54:),30) PkgName(1:lPkgName)
      write(lo,'(a)') Inte(1:Lung(Inte))
      write(lo,40) Titolo
      call toflush()
!
      return
!
   10 format(///,' ',78('+'),/)
   20 format(' ',a,' : ',a,' routine')
   30 format('Release : ',a)
   40 format(/,' ',a,/,' ',78('+'),//)
!
      end
!-----------------------------------------------------------------------
      integer function kStripTask1(k)
      USE General
!
      implicit none
      integer :: k, kk
!
      kk = index(fname(1)(1:k-1),'_task1')
      if (kk == 0) then
          kk = index(fname(1)(1:k-1),'_remo')
          if (kk == 0) then
              kk = index(fname(1)(1:k-1),'_abi')
              if (kk == 0) then
                  kk = k
              endif
          endif
      endif
!
      kStripTask1 = kk
!
      return
      end
!-----------------------------------------------------------------------
      subroutine InitSir2006(iAction)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE TempMat
      USE Grafici
      USE Groups
*     USE Poliedri
      USE RemoModule
      USE MadModule
      USE PhaseModule
      USE RfacMatrixModule
      USE LsqModule
      USE TestStuff
      USE TestModel
      USE DataModule
      USE Direttive
      USE ilmviewmod
      USE RelaxMod
      USE sannel, only:goptim, global_init
!
      implicit none
      integer :: MinScX, MaxScX, MinScY, MaxScY, ifInitial
      integer :: iAnchorX, iAnchorY, IfDrag, IcanDrag, iDragEnabled
      integer :: mEv_fsBtn, ifDragged, iDxV, iDyV, nSfCard, kSfac
      integer :: Loop, mxa, mxt, mxx, mxl
      integer :: ncru, ncwu, ncpu, ncpt, itty, istat2, iabort, intty
      integer :: nch, image, nc, nd, ni, nt, na, ncd, idoc
      integer :: nsymbo, ifAutoBtAn
      real    :: B, sfacm, value_Bmin, value_Bmax
      integer :: nrmax, ngt512, nnsig, nFoNeg, nFoZero, nreflInp
      integer :: nnpq, nSyst, neq, isigv, isigp, kSyst, ierr
      integer :: id, ie, ib, icc, ia, ih, numb, iplus, inus, ipoint
      real    :: rhm, rhn, resol, rfac1, sigv, aveInt
!-- ??
      integer :: nspec_lab, kbest, numbFo, ifDrawMap, iAction
      integer :: ifCellOnlyOld, iPlotTypeDrag, i, jfour
      real    :: pin,  WhichFo, scaled
!
!-- graphics
      common /SizeScr/ MinScX, MaxScX, MinScY, MaxScY
!--
      common /InitialPlotCommon/ ifInitial
      common /RotMou/ iAnchorX, iAnchorY, IfDrag, IcanDrag, iDragEnabled
     *               ,mEv_fsBtn
      common /SaveRbyM/ ifDragged, B(3,3), iDxV, iDyV
! ---
      common /sfact/ nSfCard, sfacm(18,9), kSfac(18)
      common /LoopC/ Loop
      common /dimensioni/ mxa, mxt, mxx, mxl
c--
      common /xunit/ ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common /xchar/ id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/fordata0/ nsymbo
      common/minmaxB/ ifAutoBtAn, value_Bmin, value_Bmax
!
      common /WrReIn/ nrmax, ngt512, nnsig, nFoNeg, nFoZero, nreflInp,
     *                nnpq, nSyst, rhm, rhn, resol, neq, rfac1,
     *                sigv(11,4),isigv(11,2),isigp(11,2),kSyst(11,5),
     *                aveInt
!
      character (len=19) :: charx
      data charx/'() ,*#0123456789+-.'/
c                 1234567890123456789
      read(charx,'(19a1)')id,ie,ib,icc,ia,ih,numb,iplus, inus,ipoint
!
      ValCritici(1:5,1) = (/ 0.0, 0.333333, 0.5, 0.666666, 1.0 /)
      ValCritici(1:5,2) = (/ 0.0, 0.333333, 0.5, 0.666666, 0.0 /)
!
      call PutGetPseudoInfo(0,0)
!
      JAV_VIEWER = 1
!
      nScan = 0
      SpeciesSav(:) = '    '
      NatInd = 0
      rmsd = 0.0
      call jav_init()
      call global_init(goptim)
      WhichWave = -1
      jcpuP = 0
      nGraficiGR = 0
      ifVLD = 0
      ifCubo = -1
      latoCubo = 2.0                !!mr
      xyzCubo(:) = 10000
      coordCubo(:,:) = 0
      ifLaue = -1
      MonomerInModel(:) = 1
      numbModels = 0
      scaled = 1
      numbGen = 0
      ifNewPsi0 = 0
      nreflInp = 0
      ifViewModel = 0
      ifLabelsPub = 0
      distCoord = 0.6    ! distanza per la to_coord_sir
      ModelToCompare = 0
      ifPoly = 0
      sogliaRs = 10
      STICKS = 1; RODS = 2; SIMPLE = 3; STICKS_N_BALLS = 4; BUBBLES = 5
      SHADING = 6; VAN_DER_WAALS = 7; ELLIPSOIDS = 8
      ifTraccia = 0; RaggioSfera = 2.0
      nMaxLeg = 9800
!
      ifo2 = -1
      AtomiBloccati = 0
      nspec_lab = 0
      FraFilePath = ' '
      xyzTmp(:,:) = 0
      MaxAtoms = 0
      ifAutoBtAn =  0
      value_Bmin = -100000
      value_Bmax =  100000
      ifFreeLunch = 0
      ifNegativePeaks = 0
      ncondfou(:,:) = 0
      ncondpat(:,:) = 0
      setmin = 0
      erm1min  = 9999
      erm1sav  = 9999
      bestmin = 9999
      kbest = 0
!
      nsymbo = 0
      neutro = 0
      ksize  = 0
      ifDrawGroups = 0
      ifGroupsAllocated = 0
      ifRotamersAllocated = 0
      ifRigidBody = 0
      ifMottFormula(:) = 0
      ifBestModel = 0
      ifPDBfiles = 1
      ifCutResidui = 0
      MinResiduo   = 0
      MaxResiduo   = 0
      nREMcard = 0
      ifCreate = 1
      Imported = -1
      iphase = 0
      ifPDBt = 0
      ifPatt = 0
      isOverFlag = 0
      ZValue = 1
      MaxNk = 18
      PiccoFour = MaxNk + 1
      WhichFo = 1
      numbFo  = 1
!
      ifMiras = 0
      ifIsOver = 0
      ilMilione = 0
      ifHidden = 0
      numFragsMad = 0
      LeftBox = 4
      RightBox = 0
      ifDrawGR = .false.
      nLinesGR = 0
      inBoxGR(:) = 0
      ifWillMad = 0
      nWilsonPlots = 0
      ifViewer = .true.
      ifAla = 0
      ifRemoG = 0
      sc = -99
      bfacMR = 0
      nMolMR = 1
      ifMTZopened = 0
      ifDebug = 0
      ViewDist = 9.e33
      nolsq = -1
      QualeAbilita = 0
      ifDrawMap = 0
      ifSkeleton = 0
      ifSkeletonOn = 0
      nSkel = 0
      nSetsMaxFineDSR = 5
      numHeavy = 0
      occHeavy = 0.0
      WhichFom = 1
!     ResSogLow = 1.21
      ResSogLow = 1.25  !MERGE_LIB
      ifMadEnv = 0
      xyz_triadim = 380000
      ifat512  = 512
      ifat512a = ( 2 * ifat512 + 1 ) * ( 2 * ifat512 + 1 )
      ifat512b = ( 2 * ifat512 + 1 )
!
      pack3 = 512
      pack2 = pack3 * pack3
      pack1 = pack3 * pack2
      pack5 = pack3 / 2
!
      ifRunToolBar = 0
      erreBest = 9999.9
      fomBest  = -9999.9
      fomBestE = -9999.9
      nTp = 0
      kCentral = 0
      ifMovedLab = 0
      ntrSv = 0
!     
      nLabelHyd = 0
      ifHydrobase = 0
      RSoglia = -1.0
      if (iAction == 1) then
          ifCont = 0
          if (allocated(RfacMatrix)) then
              RfacMatrix(:,:,:) = 0.0
              RfacMatrix(2,:,:) = -9999.9      !!!<<<
              RfacMatrix(3,:,:) = -9999.9      !!!<<<
          endif
          kRfac = 0
          jRfac = 0
          nRfac = 0
          jrest = 0
          nres = 0
          vres = 0
          return
      endif
!
      mxa = 4000
      mxt = 4000
      mxx = 2000
      mxl = 6000
      ifProject = 0
      ifImport  = 0
      ifFirstTime = 1
      kWasReduced = 0
      ifInitial = 0
      MaxAtLSQ = 3000
      ksize = 0
      ifReduced = 0
      NumbMaxRfac = 500
      numbrun = 0
      jcpuP = 0
      kopcpu = 0
!
!-- name of scattering factors file,
!-- help file,palets file, space group file,
!-- CIF file, PostScript and groups
!
!     ffile   = 'Sir.xen'
!     sirtx   = 'Sir.htm'
!     iasun   = 'Sir.spg'
!     ciffle  = 'Sir.cif'
!     psfle   = 'Sir.ps'
!     grufle  = 'Sir.gru'
!     macfle  = 'Sir.mac'
!     f12fle  = 'Sir.f12'
!     SymmSPG = 'Sir.cnv'
!
      ifSymmCont = 0
      MinScX = kscrx
      MinScY = kscry
      ifHelpEnabled = 1
      ifChangeHM = 1
      ifRotTran = 1
      iDragEnabled = 0
      ifDrag = 1
      IcanDrag = 1
      iDragEnabled = 1
      mEv_fsBtn = 1
      iQualeBecca = 0
      ifPol = 0
      iQualePolyg = 0
      nel = 0
!!!!!!mrmrmrmr      ifLabels = 0
      iPlotTypeDrag = 0
      nRadType = 1
      ProbF = 0.5
      BLimit = 1000000
      nSfCard = 0
!
      pi     = 4.0 * atan(1.0)
      twopi  = 2.0 * pi
      twopis = 2.0 * pi * pi
      rtod   = 180.0 / pi
      dtor   = 1.0 / rtod
      BTot(:,:) = 0 ; BTot(1,1) = 1 ; BTot(2,2) = 1 ; BTot(3,3) = 1
!
!-- set up sin/cos table
!
      do i=1,450
         sint(i)=sin(dtor*float(i-1))
      enddo
      jfour=0
!
!--definisco valori per caos routine
!
      itty   = 0     
      ncwu   = lo
      ncru   = ln
      ncpu   = 57
      ncpt   = 58
      nch=4
      pin=pi
*     lfl=lflValue
c      twopisii=twopi*pi
c      twopin=twopi
c      rtdii=rtod
c      dtrii=dtor
      rtd=rtod
      dtr=dtor
*     lflmx=lflValue               
*     nlmx= lflValue     
!
!--restraints
!
      nres = 0
!
      nUltRot  = 0
!
      jjpatt = 0      !pgMAD
!
      if (.not. allocated(mat)) then
          allocate (mat(1:3,1:50000) ,stat = ierr)
      endif
!
!-- Initialize Laue info
!
      call InitLaue
!
      return
      end
!-----------------------------------------------------------------------
      subroutine spoolr(file1,ier)
      USE General
      USE Molcom
      USE MadModule
      USE PhaseModule
      USE LsqModule
      USE TestModel
      USE Direttive
      USE commandsmod
!
      character*(*) file1
      common /SizeScr/ MinScX, MaxScX, MinScY, MaxScY
      integer :: jcanc(10), nDefs, nDefsMax, k1, k2, k3
      character releas*5, com4*4
      character usefile*80
      character dire*80
      character*80 buffer
      character*6 follow
      character*4 spazio
      integer , allocatable            :: PathLen(:)
      character(len= 10) , allocatable :: PathDef(:)
      character(len=256) , allocatable :: PathVet(:)
**    logical isOpen
!
      nDefs = 0
      nDefsMax = 10
      allocate(PathDef(1:nDefsMax), stat= ierr)
      allocate(PathVet(1:nDefsMax), stat= ierr)
      allocate(PathLen(1:nDefsMax), stat= ierr)
      PathDef(:) = ' '
      PathVet(:) = ' '
      NewFileBin = 0
      NewFileBin = 1
      spazio = ' '
      lspazio = 1
      ifHidden = 0
      jfour = 0
      ReflFilePath = ' '
      kcanc = 0
      jcanc(1:10) = 0
      ifNoDraw = 0
      nFragFile = 0
!
!-- Force the input file to be closed (Necessary to restart)
!
!      inquire(unit=ln, opened=isOpen, name=file1)
!      if (isOpen) then
!          close(ln)
!      endif
!
      itipo = 2
      iform = 1
      jop = jopen(ln,file1,itipo,iform,ier1)
      if (jop.lt.0) then
          ier=-1
          write(lo,500) ier1,file1(1:Lung(file1))
  500     format(' *** error ***  open error, code =',i5,
     *           ' file is ',a)
          deallocate(PathVet, PathDef,PathLen , stat= ierr)
          return
      endif

      ifRemo = 0
      ifWasRemo = 0
      kusef = ln
      nonos = 0
      irefl = 0
      kcont = 0
      ier = 0
      init = 0
      nallc = 80
      ipcom = 0
      icomo = 2
      ipdir = 0
      nerr = 0
      ifli = 0
      icomq(:,:)=0
!
!-- read input file
!
      iEnd = 0
      do while (iEnd == 0)
         if (ifli == 0) read(kusef,'(a)',end=2000) cardImage
         call filtra(cardImage)
!
         k = index(cardImage,'!')
         if (k /= 0) then
             cardImage(k:) = ' '
         endif
!
         ifli = 0
         call shift(cardImage,nchar)
         if (nchar <=  0 .or. cardImage(1:1) == commen) cycle
!
!-- if first character is equal to '%' it is a command
!
         if (cardImage(1:1) == beg) then
!
!-- verify if the command is allowed
!
             icom = 0
             com4 = cardImage(2:5)
             call lcase(com4)
             if (com4 == 'expo') then
                 com4 = 'menu'
             endif
             lcom4 = Lung(com4)
             do i=1,nallc
                if (com4 == allcom(i)(1:lcom4)) then
                    icom = i
                    exit
                endif
             enddo
             jcom = 0
             if (icom ==2) icom = 16
!
                select case (icom)
                   case ( 0)
                      go to 3000
                   
                   case ( 7)   ! %end
                      iEnd = 1

                   case ( 8)   ! %continue
                      jcom = 1
                      if (ifRemo == 1) then
                          icomo = 4
                      endif
                      icomo = icomo + 1
                      if (icomo ==  2) icomo = 3
                      if (icomo == 24) icomo = 4
                      do ii=icomo, 4
                         if (ii /= 2) then
                             ipcom = ipcom + 1
                             if (ipcom > maxcom) then
                                 go to 6000
                             endif
                             icomq(ipcom, 1) = ii
                         endif
                      enddo
                      ipcom = ipcom + 1
                      if (ipcom > maxcom) then
                          go to 6000
                      endif
                      icomq(ipcom,1) = 7
                      iEnd = 1
                   
                   case ( 9)   ! %job
                      jcom = 1
                      call cutst(cardImage, lenp, dire, lend)
                      dire = ' '
                      ioffset = ( 80 - lenp ) / 2
                      if (ioffset <= 0) ioffset = 1
                      ioffset = 1
                      dire(ioffset:) = cardImage
                      Titolo = dire(1:80)
                      read(Titolo,'(20a4)') itle
                   
                   case (11)   ! %cancel list_number
                      jcom = 1
                      call cutst(cardImage, lenp, dire, lend)
                      iopt = 0
                      call getnum(cardImage, vet, ivet, iv, iopt)
                      list_number = ivet(1)
                      kcanc = kcanc + 1
                      jcanc(kcanc) = list_number

                   case (12)   ! %initialize
                      jcom = 1
                      init=1
                     
                   case (13)   ! %path
                      jcom = 1
                      call cutst(cardImage, lenp, dire, lend)
                      ReflFilePath = cardImage(1:lenp)
                                    
                   case (16)   ! %remo
                      ifRemo = 1
                      ifWasRemo = 1
                      ifViewer = .false.
                                      
                   case (19)   ! %use usefile
                      jcom = 1
                      call cutst(cardImage, lenp, dire, lend)
                      usefile = cardImage(1:lenp)
                      itipo = 2
                      iform = 1
                      jop=jopen(kform, usefile, itipo, iform, ierr)
                      if (jop < 0) then
                          write(Msg,270) ierr,usefile(1:lenp)
                          call MsgWinErr('ERROR', Msg,ERR_WINDOW,nExitC)
                          ier = -2
                      else
                          kusef = kform
                      endif
                   
                   case (20)   ! %return
                      jcom = 1
                      if (kusef /= ln) then
                          close (kform)
                          kusef = ln
                      else
                          go to 8000
                      endif
                    
                   case (21)   ! %automatic
                      jcom = 1
                      ifAutomatic = 1

                   case (22)   ! %structure
                      jcom = 1
                      call cutst(cardImage, lenp, dire, lend)
                      if (lenp <= 0) go to 1000
                      call cutst(cardImage,lenp,dire,lend)
                      fname(1) = dire(1:lend) // ext(1)
                      fname(2) = dire(1:lend) // ext(2)
                      fname(3) = dire(1:lend) // ext(3)
                      fname(4) = dire(1:lend) // ext(4)
                      fname(5) = dire(1:lend) // ext(5)
                      fname(9) = dire(1:lend) // ext(9) // char(0)
                                     
                   case (23)   ! %data
                      init=1

                   case (24)   ! %nowindow
                      jcom = 1
                      if (jscreen == 1) then
                          call GoOnWithoutGraphics()
                          kscreen = 1
                          call text_mode(0)
                          kscreen = 0
                      endif
                   
                   case (25)   ! %window
                      jcom = 1
                   
                   case (26)   ! %hidden
                      jcom = 1
                      ifHidden = 1
                      ifAutomatic = 1
                   
                   case (34)   ! %Resid
                      jcom = 1
                      call cutst(cardImage, lenp, dire, lend)
                      iopt = 0
                      call getnum(cardImage, vet, ivet, iv, iopt)
                      if (iv == 1) then
                          RSoglia = vet(1)
                      endif
                    
                   case (36)   ! %Debug
                      jcom = 1
                      ifDebug = 1
                      call manage_console(1)
                    
                   case (37)   ! %nodraw
                      jcom = 1
                      ifNoDraw = 1
                   
                   case (38)   ! %ilmilione
                      jcom = 1
                      call cutst(cardImage, lenp, dire, lend)
                      iopt = 0
                      call getnum(cardImage, vet, ivet, iv, iopt)
                      ilMilione = ivet(1)
                   
                   case (39)   ! %develop
                      ifWillMad = 1
                      kmad = 1
!                   
                   case (41)   ! %coordinates
                      jcom = 1
                      call cutst(cardImage, lenp, dire, lend)
                      call cutst(cardImage, lenp, dire, lend)
                      FraFilePath = dire(1:lend)
                      ifLoadHydrogen = 0
                      if (lenp > 2) then
                          call lcase(cardImage)
                          if (cardImage(1:3) == 'hyd') then
                              ifLoadHydrogen = 1
                          else
                              go to 3000
                          endif
                      endif

                   case (42)   ! %saved
                      jcom = 1
                      call cutst(cardImage, lenp, dire, lend)
                      if (lenp <= 0) go to 1000
                      call cutst(cardImage,lenp,dire,lend)
                      fname(1) = dire(1:lend) // ext(1)
                      fname(2) = dire(1:lend) // ext(2)
                      fname(3) = dire(1:lend) // ext(3)
                      fname(4) = dire(1:lend) // ext(4)
                      fname(5) = dire(1:lend) // ext(5)
                      fname(9) = dire(1:lend) // ext(9) // char(0)
                      jscreenSav = jscreen
                      ifFromGraphic = 0
                      ifRecover = 1
                      call restorebinfile(ifFromGraphic, ier)
                      if (ier < 0) then
                          ier = -2
                          deallocate(PathVet,PathDef,PathLen,stat=ierr)
                          return
                      endif
                      jscreen = jscreenSav
                   
                   case (45)   ! %recover trial_number
                      jcom = 0
                      call cutst(cardImage, lenp, dire, lend)
                      iopt = 0
                      call getnum(cardImage, vet, ivet, iv, iopt)
                      numbrun = ivet(1)
                      ifRecover = 1

                   case (51)   ! %analyze
                      ifRemo = 1

!
!-- the command is obsolete:
!--             %normal, %fourier, %menu, %graphics, %export
!
                   case (50)   ! %import
!corr                      call cutst(cardImage, lenp, dire, lend)
!corr                      if (lenp <= 0) go to 1000
!corr                      filePDB = cardImage
                      !jcom=1
                      call cutst(cardImage, lenp, dire, lend)
                      if (lenp > 0) then
                          !ipcom = ipcom + 1
                          !icomq(ipcom,1)=33
                          nFragFile = nFragFile + 1
                          if (nFragFile <= nmaxFragFile) then
                             FragFilePath(nFragFile) = cardImage(1:lenp)
                          endif
                          filePDB = cardImage
*                 write(0,*)'import file:',trim(FragFilePath(nFragFile))
                      else
                   call MsgWinErr('Warning','Error on reading command '
     *             //trim(dire)//'.'//char(10)//'Expected a file name.',
     *             WARN_WINDOW,nExitCode)
                          go to 1000
                      endif
                                    
                   case (53)   ! %helix
                                    
                   case (54)   ! %Simulated Annealing
                      ifWillSannel = 1

                   case (55)   ! %amb
                      call cutst(cardImage, lenp, dire, lend)
                      if (lenp <= 0) then
                          ifAmb = 1
                      else
                          call lcase(cardImage(1:3))
                          if (cardImage(1:3) == 'arp') then
                              ifAmb = 2
                          elseif (cardImage(1:3) == 'phe') then
                              ifAmb = 3
                          elseif (cardImage(1:3) == 'buc') then
                              ifAmb = 1
                          elseif (cardImage(1:3) == 'nau') then
                              ifAmb = 4
                          else
                              if (jscreen > 0) then
                                  Msg = 'Unknown Automated Building'
     *                              // ' program: ' // cardImage(1:lenp)
     *                              // '. Ignored.'
                                  call OpenWarning(Msg)
                              endif
                          endif
                      endif
                      jcom = 1

                   case (56)   ! %Set
                      call cutst(cardImage, lenp, dire, lend)
                      call cutst(cardImage, lenp, dire, lend)
                      call lcase(dire)
                      if (cardImage(lenp:lenp) == slash) then
                          cardImage(lenp:lenp) = ' '
                          lenp = lenp - 1
                      endif
                      nDefs = nDefs + 1
                      if (nDefs <= nDefsMax) then
                          PathDef(nDefs) = dire(1:lend)
                          PathVet(nDefs) = cardImage(1:lenp)
                          PathLen(nDefs) = lend
                      endif
                      jcom = 1
                 
                   case (1,5,6,10,14)
                       jcom=1
                   
                  case (80)   ! %cuda
                       cuda = 1  !!gpu

                end select
c
             if (jcom == 0) then
                 ipcom = ipcom + 1
                 if (ipcom > 200) go to 6000
                 icomq(ipcom,1) = icom
                 icomo = icom
             endif
         else
!
!-- it is a directive
!
             if (ipcom == 0) go to 4000
             ipdir = ipdir + 1
             if (ipdir > ncardMax) go to 5000
             buffer_ctrl_M = cardImage
             call lcase(buffer_ctrl_M)
             k1 = index(buffer_ctrl_M,'$')
             if (k1 > 0) then
                 call cutst(buffer_ctrl_M, lenp, dire, lend)
                 k2 = index(buffer_ctrl_M,'$')
                 do i=1, nDefs
                    k3 = PathLen(i)
                    if (buffer_ctrl_M(k2:k2+k3-1) == 
     *                  PathDef(i)(1:k3)) then
                        buffer_ctrl_M = dire(1:lend) // ' ' 
     *                               // PathVet(i)(1:Lung(PathVet(i)))
     *                               // slash
     *                               // cardImage(k1+k3:Lung(cardImage))
                        cardImage = buffer_ctrl_M
                        exit
                    endif
                 enddo
             endif
             com4 = cardImage(1:4)
             call lcase(com4)
             card(ipdir) = cardImage
             icomq(ipcom,2) = icomq(ipcom,2) + 1
             if (allcom(icomq(ipcom,1))(1:3) == 'lsq') then
                 nDirLsq = icomq(ipcom,2)
             endif
             if (com4 == 'mdm ') then
                 ifWillMDM = 1
             endif
             if (com4 == 'vld ') then
                 ifWillVLD = 1
             endif
             if (com4 == 'anom') then
                 ifWillMad = 1
                 call LockFile(1, 0, ifBreak)
             endif
             if (com4 == 'deri') then
                 ifWillMad = 2
                 ifMiras = 0
                 call LockFile(1, 0, ifBreak)
             endif
             if (com4 == 'dera') then
                 ifWillMad = 2
                 ifMiras = 1
                 call LockFile(1, 0, ifBreak)
             endif
             if (com4 == 'scha' .or. com4 == 'mold') then
                 call cutst(cardImage, lenp, dire, lend)
                 if (lenp > 0) then
                     fname(4) = cardImage(1:lenp)
                 endif
             endif
             if (com4 == 'refl') then
                 ReflFileName = ' '
                 call cutst(cardImage, lenp, dire, lend)
                 call cutst(cardImage, lenp, dire, lend)
                 irefl = 1
                 follow = dire(1:6)
                 call lcase(follow)
                 if (follow == 'follow') then
                     jfile = ln
                     cardDiret = ' '
                     ReflFileName(1:20) ='card reader         '
                 else
                     ReflFileName = dire(1:lend)
                 endif
             endif
             if (com4 == 'mtz ') then
                 ReflFileName = ' '
                 call cutst(cardImage, lenp, dire, lend)
                 call cutst(cardImage, lenp, dire, lend)
                 irefl = 2
                 ReflFileName = dire(1:lend)
             endif
             if (com4 == 'cont') kcont = 1
             if (com4 == 'neut') neutro = 1
             if (com4 == 'elec') neutro = 2
         endif
      enddo
      if (nerr /= 0) go to 9000
!
      if (ln /= jfile) then
          close(ln) 
      endif
!
      if (ifWillMad == 1) then
          distCoord = 0.99
      else
          distCoord = 0.60
      endif
!
      if (ier < 0) then
          deallocate(PathVet, PathDef, PathLen, stat= ierr)
          return
      endif
!
!-- check for %data command
!
      do i=1,ipcom
         j = icomq(i,1)
         if (j == 23) then   ! %data
             NewFileBin = 1
         endif
      enddo
!
!-- Cancel lists ( if any )
!
      if (kcanc > 0) then
          do i=1,kcanc
             list_number = jcanc(i)
             if (list_number.gt.0) then
                 call Cancella(list_number)
             endif
          enddo
      endif
c
      call RiordinaCodaComandi(ier)
      if (ier < 0) then
          Msg = 'Write-protected directory. ' // char(10) //
     *          'Change directory or permissions'
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
          deallocate(PathVet, PathDef, PathLen, stat= ierr)
          ier = -2
          return
      endif
c
      write(lo,215) Titolo
  215 format(' ',78('*'),/,' ',a,//)
!
      ier = 0
      kk = lo
      call PreProcessed(kk,ier)
      if (ier < 0) then
          deallocate(PathVet, PathDef, PathLen, stat= ierr)
          return
      else
          ier = 0
      endif
!
      close(kusef)
      call InitialOutPut(irefl, kcont, ier)
      call cudadetect()            !!gpu
!
      deallocate(PathVet, PathDef, PathLen, stat= ierr)
!
      return
  270 format(' Open error, code =',i5,' file is ',a)
 1000 continue
      Msg = ' No structure name specified '
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
      go to 9000
 2000 continue
      Msg = 'No %end, %continue or %return command specified!'
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
      go to 9000
 3000 continue
      write(Msg,3010) cardImage(1:nchar)
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
 3010 format(' Error in command %',a)
      go to 9000
 4000 write(Msg,4100) cardImage(1:nchar)
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
 4100 format(' No command specified for directive ',a)
      go to 9000
 5000 write(Msg,5100)
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
 5100 format(' More than 100 directives used.',
     *       ' Check for missing  %end or %continue')
      go to 9000
 6000 write(Msg,6100) maxcom
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
 6100 format(' More than ',i5,' commands used.',
     *       ' Check input file or submit two jobs.')
      go to 9000
! 7000 nrec=1
!      write(Msg,7100) ierr,nrec,ffile(1:Lung(ffile))
!      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
! 7100 format(' Error ',i5,' reading record #',i3,' in file ',a)
!      go to 9000
 8000 write(Msg,8100)
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
 8100 format(' %RETURN command out of sequence')
 9000 ier=-2
!
      close(ln)     ! gianluca 10/08/2015
      close(kusef)  ! gianluca 10/08/2015
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PreProcessed(dove, ier)
      USE General
!
      integer dove
!
      k = index(fname(1),'.bin')
      Inte = fname(1)(1:k-1) // '_prepro.txt'
      itype = 2   ! old
      iform = 1
      jop=jopen(jerr, Inte, itype, iform, ier)
      if (jop >= 0) then
          if (dove == lo) then
              call RoutineHeader('Pre Processing')
          else
              write(dove,*) '<u><b>Pre Processing Section</b></u>'
          endif
          leggi = 1
          do while (leggi == 1)
             read(jerr,'(a)',end=10) cardImage
             write(dove,'(a)') cardImage(1:Lung(cardImage))
          enddo
   10     continue
          if (dove == lo) then
              write(dove,20)
              close(jerr)
          else
              write(dove,*)'<u><b>End of Pre Processing Section</b></u>'
              write(dove,*)' '
              close(jerr, status = 'delete')
          endif
      endif
!
      return
   20 format(/,' ',78('+'),/)
      end
!-----------------------------------------------------------------------
      subroutine NuovaProc(ier)
      return
      end
!-----------------------------------------------------------------------
      subroutine RiordinaCodaComandi(ier)
      USE General
      USE PhaseModule
      USE Direttive
      USE commandsmod
!
*gl*  character beg,commen,allcom(80)*14
*gl*  common /charas/ beg,commen,allcom
c
c-- verifica se DATA e' seguito da NORMAL 
c-- senno' inserisce %normal
c
      ipunt = 0
      jcom  = 0
      do while ( jcom.lt.ipcom. and .ipunt.eq.0 )
         jcom = jcom + 1
         jallc = icomq(jcom,1)
         if (allcom(jallc)(1:3).eq.'dat') then
             ipunt = jcom
         endif
      enddo

!-- eliminata parte seguente - gianluca - 29 giugno 2003
!      if (ipunt.ne.0) then
!          ipunt = ipunt + 1
!          jallc = icomq(ipunt,1)
!          if (allcom(jallc)(1:3).ne.'nor') then
!              call Inserisci(ipunt,'%nor',ier)
!          endif
!      endif

c
c-- verifica se INVAR e' preceduto da DATA/NORMAL o se comunque
c-- i riflessi sono stati gia' normalizzati
c
      ipunt = 0
      jcom  = 0
      do while ( jcom.lt.ipcom. and .ipunt.eq.0 )
         jcom = jcom + 1
         jallc = icomq(jcom,1)
         if (allcom(jallc)(1:3).eq.'inv') then
             ipunt = jcom
         endif
      enddo
      if (ipunt.ne.0) then
          if (ipunt.gt.1) then
              jallc = icomq(ipunt-1,1)
              if (allcom(jallc)(1:3).eq.'dat'.or.
     *            allcom(jallc)(1:3).eq.'nor') then
                  ipunt = 0
              endif
          endif
      endif
      if (ipunt.ne.0) then
          lixx = InfoOK(6)
          if (lixx.gt.0) then
              call LoadReflInfo
              if (ifReduced.eq.1) then
                  nreflDim = nrefltot * nsymTrue
              else
                  nreflDim = nrefltot
              endif
              if (sc.gt.0.0) then
                  ipunt = 0
              endif
          endif
      endif
      if (ipunt.ne.0) then
          IfError = 1
          Inte = 'Invariants need normalized reflections.'
          call MsgWinErr('ERROR', Inte, SEVERE_ERR_WINDOW, nExitC)
      endif
c
c-- verifica se PHASE e' preceduto da INVAR o se comunque
c-- gli invarianti sono gia' stati calcolati
c
      ipunt = 0
      jcom  = 0
      do while ( jcom.lt.ipcom. and .ipunt.eq.0 )
         jcom = jcom + 1
         jallc = icomq(jcom,1)
         if (allcom(jallc)(1:3).eq.'pha') then
             ipunt = jcom
         endif
      enddo
      iipunt = ipunt
      if (ipunt.ne.0) then
          if (ipunt.gt.1) then
              jallc = icomq(ipunt-1,1)
              if (allcom(jallc)(1:3).eq.'inv') then
                  ipunt = 0
              endif
          endif
      endif
      if (iipunt.ne.0) then
          ipunt = iipunt + 1
          jallc = icomq(ipunt,1)
!          if (allcom(jallc)(1:3).ne.'men'.and.
!     *        allcom(jallc)(1:3).ne.'exp') then
              call Inserisci(ipunt,'%gra',ier)
!          endif
      endif
c
      return
      end
!-----------------------------------------------------------------------
      subroutine Inserisci(jcom,comando,ier)
      USE General
      USE Direttive
!
      character*(*) comando
!
      iPdire=ipdir
      icomats = icomat
      icomat = jcom - 1
      call svcard(nAddComm,ier)
      if (ier.ge.0) then
          call upcard(nAddComm,comando,4,ier)
          if (ier.ge.0) then
              call rscard(nAddComm,iPdire)
          endif
      else
          return
      endif
      icomat = icomats
      if (ier.lt.0) then
          IfError = 1
          Inte = 'Problems managing '//comando
          call MsgWinErr('ERROR', Inte, SEVERE_ERR_WINDOW, nExitC)
      endif
c
      return
      end
!-----------------------------------------------------------------------
      subroutine sircom(iEnd,ier)
      USE General
      USE Riflessi
      USE Molcom     
      USE Grafici
      USE Html
      USE MadModule
      USE PhaseModule
      USE Direttive
      USE commandsmod
      USE drawatoms
      USE LsqModule
      USE drawatoms
!
!-- main subroutine to handle sir commands
      common /xunit/ ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      logical :: addfrag
!
      ier    = 0
      iEnd   = 0
      nimport = 0
      do while (ier.eq.0.and.iEnd.eq.0)
         icomat=icomat+1
         j=icomq(icomat,1)
         if (j.ne.0) then
!
!            if (j.ne.7.or.InfoOK(15).eq.0) then
             if (ifWasRemo == 0 .and. ifWillMad == 0) then
                 if (ifMadEnv == 0) then
                     call NascondiToolbar(1)
                     call scr2_sir
                 endif
             endif
!
             select case (j)
                case (1)
                   if (kmad == 0) then
!                       ifMercedes = 0
!                       call norm2000(ifMercedes, ier)
                   endif


                case (3)     ! INVAR
                   ksubr = 2
                   ifFromGraphic = 0
                   ifFromPhase = 0
                   call invar(ier, ksubr, ifFromGraphic, ifFromPhase)
                case (4)     ! PHASE + FOURIER 
                   if (kscreen.ne.0) then
                       iVP(1) = 1
                       Lim1 = iVP(1)
                       Lim2 = iVP(2)
                       Lim3 = iVP(3)
                       Lim4 = iVP(4)
                       NPX = Lim3 - Lim1
                       NPY = Lim4 - Lim2
                       Ratio = float(NPX) / float(NPY)
                   endif
                   ksubr = 3
                   ifFromGraphic = 0
                   call Contan(ier, ksubr,ifFromGraphic)
                   if (ilMilione == 2) then
                       call SviluppaUnTrial(1, ier)
                   endif
                   if (ier < 0) then
                       call AllocaAtomi(2)
                   endif
                   if (knw == 1) then
*                      call AllocaTestStuff(2)
                   endif
                   if (kscreen.ne.0) then
                       iVP(1) = 1
                       Lim1 = iVP(1)
                       Lim2 = iVP(2)
                       Lim3 = iVP(3)
                       Lim4 = iVP(4)
                       NPX = Lim3 - Lim1
                       NPY = Lim4 - Lim2
                       Ratio = float(NPX) / float(NPY)
                   endif
                case (10)     !  GRAPHICS ex MENU / EXPORT
                   if (ifAmb == 0) then
                       call export(ier,ksubr)
                       if (ifWasMad /= 0 .and. ifPDBfiles == 1 .and.
     *                     jscreen > 0) then
                           k1 = index(fname(1), '.bin') - 1
                           if (ifBestModel == 1) then
                               Inte = fname(1)(1:k1) // '_fPlot.png' 
     *                                               // char(0)
                               call CreaPng(Inte)
                           endif
                       endif
                   endif

                   if (kmad /= 0 .and. jscreen > 0) then
                       call CPUTime(' ', 0)
                       HTMLcpu = Inte(1:Lung(Inte))
                       headersGR(2) = Inte
                       call ManageGraph(0, 0)
                       call zflush
                       call DoSingleIteration()
                       call CreaPng(fname(9))
                       call CloseViewer
                       if (ifAutomatic == 0) then
                       endif
                       
                   endif

                case (17)       ! POLPO
*                  call polyedra(ier)

                case (2,  8,9,   11,12,15,         19,20)
                   ier = -1
                case (21,22,24,25,26)
                   ier = -1
                case (7)       ! END
                   iEnd = 1
                   call sirdate(Inte,icod)
                   HTMLend = Inte(1:Lung(Inte)) // ' ' //
     *                       ProgName(1:lProgName) // ' ends'
                   if (ifMadEnv == 0) then
                       call AbInfo(4)
                   elseif(ifWasRemo == 0) then
                       call MADInfo(4)
                   endif
                   exit
!!!!!           case (13)
!!!!!              call importa(ier)
!               case (13)
!                  call import(ier)
                case (16)     ! molecular replacement
                   ksubr = 2
                   ifFromGraphic = 0
                   call Remo(ier)

                case (18)
!                   call SirFour(ier)
                case (23)      ! DATA + NORMAL
                   call datasir(ier)
                   if (ier >= 0) then
                       ier = 0
                       call CheckModelToLoad(ier)
                       if (ier >= 0) ier = 99
                   else
                       ifProject = 0
                   endif
                   if (ifWasRemo > 0 .or. ifWillMad > 0) then
                       HistoOK(:) = 0
                       call ManageGraph(-1, 0)
                   endif
                case (27)      ! LSQ
!
!--chiamata regolare a %lsq (usa i default)
!
                   call GetModel
                   QualeAbilita = 2
                   call InitMolplo()
                   kplo = 3
                   ifSingle = 0
                   call MolPlo(kplo, ifSingle)
!
                   nCycles = 3
                   LsqCF = 2           !  minimi quadrati
                   LsqType=2           !  full
                   Dampi=1.0
                   iref=0
                   ide=0
                   call Mnqdmain(idi,ier,iref)       !  nuovo MNQD
                   if (ier.ge.0) then
                       write(Msg,"(' R(F)% = ',f6.2)") rflsq
                       call scrper(Msg,0,-1)
                   endif
                case (28)
!                  call ArpVaff(ier)
!g                 call changelabel(ier)
*                  call AutoLabel(ier)  DA ELIMINARE TUTTA QUESTA PARTE
                case (29)
                   call SirHydro(ier)
                case (30)
                   call SirGeomNEW(ier)
                case (31)
                case (32)
                case (33)
                case (35)
                case (39)
                   call SviluppaUnTrial(0, ier)
                case (43)   ! %build (NEWP)
                    call NuovaProc(ier)
                case (44)   ! %differenceFourier
                    call DifferenceFourier(ier)
                case (45)   ! %recover numbrun
                    call RecoverTrial(ier)
                case (46)   ! %ligand
                    call Ligand_OLD(ier)
                case (47)   ! %dedm
                    ifFromPhase = 0
                    call PreEdmDedm(ifFromPhase, ier)
                case (48)   ! %gedm

                case (49)   ! %edm

                case (50)   ! %import
                   call InitMolplo
                   iPlotType = SHADING
                   !call importa0(filePDB, ierr)
                   if (nimport >= 1 .and. icomq(icomat-1,1) == 50) then !%fragment successivo
                       addfrag = .true.
                   else
                       addfrag = .false.
                   endif
                   nimport = nimport + 1
                   call importa0(FragFilePath(nimport),ierr,addfrag)
                   if (ierr == 0) then
                       QualeAbilita = 2
                   endif

                case (51)   ! %analyze
                    call RemoAnalysis(ier)
                case (52)   ! %biascorrect
!                   call Proc_Bias_Hydro(ier)
                case (53)   ! %helix
                    call ElicaMain(ier)
                case (54)   ! %SimulatedAnnealing
                    !call InitSA_sir
                    call sannelexe()
                case (55)   ! %Articolo
*gl*                call Articolo(ier)

             end select
         endif
      enddo
!
      if (ier <  0) then
          ifProject = 0
          call SadEnd(ier)
!mr1107
      else if (jscreen.ne.0.and.iEnd.eq.1) then
          if (ifWasRemo == 0 .and. ifWillMad == 0) then
              if (ifMadEnv == 0) then
                  call c_scr2(-1, 0, 0, 0, 0, ' ')
              endif
          endif
!mr1107
      endif
      return
 5000 write(Msg,5100) j,allcom(j)(1:Lung(allcom(j)))
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
 5100 format(' Wrong command code = ',i5,' for ',a,' command')
      if (ier.lt.0) then
          call SadEnd(ier)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine summar(ier)
      USE General
      USE Symmetry
      USE Atomi
      USE TempMat
      USE PhaseModule
      USE LsqStuff
      USE LsqStuff12
      USE LsqModule
!
!-- summarize the content of the direct access file
!
      if (InfoOK(1)  == 0) then
          iAction = 2
          mode    = 1
          call  PutGetBinaryFile(iAction, mode, ier)
      endif
!
      if (InfoOK(1) > 0) then
          write(lo,30)
      endif
      if (InfoOK(2) > 0) then
          write(lo,50) nsym
      endif
      if (InfoOK(3) > 0) then
          write(lo,96) nk
      endif
      if (InfoOK(4) > 0) then
          write(lo,97) nWeight
      endif
      if (InfoOK(5) > 0) then
          write(lo,98) nats
      endif
      if (InfoOK(13) > 0) then
          write(lo,99) NumGroup
      endif
      if (InfoOK(62) > 0) then
          write(lo,95) NumCond12
      endif
!
      lixx = InfoOK(6)
      if (lixx.gt.0) then
          call LoadReflInfo
          if (kWasReduced.eq.1) then
              ifReduced = 1 
          endif
          if (ifReduced.eq.1) then
              nreflDim = nrefltot * nsymTrue
          else
              nreflDim = nrefltot
          endif
          if (sc.lt.0.0) then
              write(lo,150) nrefl
          else
              write(lo,155) nrefl
          endif
      endif
      if (InfoOK(68) > 0) then
          write(lo,94)
      endif
      lfw = InfoOK(15)
      if (lfw.gt.0) then
          call PutGetXyzs(2,interp)
          write(lo,5060) nats
      endif
      lfw = InfoOK(34)
      if (lfw.gt.0) then
          call PutGetRfacMatrix(2)
      else
          erreBest = 9999.9
          fomBest  = -9999.9
          fomBestE = -9999.9
      endif
      lfw = InfoOK(38)
      if (lfw.gt.0) then
          call GetMad
      endif
!
      call toflush()
!
   30 format(22x,' cell parameters ')
   50 format(16x,i6,' symmetry operators ')
   96 format(16x,i6,' atomic species')
   97 format(16x,i6,' weighting scheme')
   98 format(16x,i6,' atoms')
   99 format(16x,i6,' group(s)')
   95 format(16x,i6,' refinement directives')
   94 format(22x,' reflections limits ')
  150 format(16x,i6,' not normalized reflections ')
  155 format(16x,i6,' normalized reflections ')
 5060 format(16x,i6,' atomic positions')
      return
      end
!-----------------------------------------------------------------------
      subroutine wrhead
      USE General
      USE Molcom
      USE Grafici
      USE CaratteriSpeciali
      USE Html
      USE MadModule
!
      character*40 stringa
!
!-- write the Header
!
      if (ifWillMad > 0) then
          if (ifWillMad == 1) then
              stringa = '     Mad/Sad substructure procedure'
          else
              if (ifMiras == 0) then
                  stringa = '     Mir/Sir substructure procedure'
              else
                  stringa = '     Miras/Siras substructure procedure'
              endif
          endif
          ifViewer = .false.
          ifDrawGR = .true.
      elseif (ifREmo == 1) then
          stringa = '     Molecular Replacement procedure'
          ifViewer = .false.
      else
          stringa = '     Ab Initio structure solution'
      endif
      k = index(fname(1),'.')
      kk = kStripTask1(k)
      kk = kk - 1
      ls = Lung(stringa)
      call sirdate(Inte,icod)
      if (icod.eq.0) then
          HTMLdate = ' '
          Msg = ProgName(1:lProgName) // ' starts on:   '
     *          //fname(1)(1:kk)
          write(data_ora,'(30x,a)') Msg
          headersGR(1) = stringa(1:ls) // ' starts on: 
     *                   '//fname(1)(1:kk)
      else
          HTMLdate = 'Date: ' // Inte(1:icod)
          Msg = Inte(1:icod) // '  ' //
     *          ProgName(1:lProgName) // ' starts on:   '
     *          //fname(1)(1:kk)
          write(data_ora,'(a)') Msg(1:Lung(Msg))
          headersGR(1) = Inte(1:icod)  //
     *                   stringa(1:ls) //' starts on: '//fname(1)(1:kk)
      endif
      HTMLname = 'Structure name: ' // fname(1)(1:kk)
!
      write(lo,10) Msg(1:Lung(Msg))
   10 format(' ',a,//)
      if (ifFromShelx == 0) then
          if (jscreen == 0 .or. ifAutomatic == 1) then
              write(0,'(3x,a)') Msg(1:Lung(Msg))
          endif
      endif
!
      headersGR(2) = ' '
!
      if (ifWillMad == 1) then
          kmad = 1
          ifMadEnv = 2
      elseif (ifWillMad == 2) then
          kmad = 1
          ifMadEnv = 2
      elseif (ifRemo == 1) then
          ifMadEnv = 2
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CheckPath(ier)
      USE General
      USE Molcom
      USE spginfom
!
!-- add path to data files and check if they exist
!
! ---
      implicit none
      integer :: i1, j1, j2, j3, j4, j5, j6, j7, j8, j9, j10, j11, j12
      integer :: j13, j14, j15, j16, j17, j18, j19
      integer :: ex1, ex2, ex3, ex4, ex5, ex6, ex7, ex8, ex9, ex10, ex11
      integer :: ex12, ex13, ex14, ex15, ex16, ex17, ex18, ex19
      integer :: ier, Lung, k, i2, itipo, iform, jop, jopen, Missing
      integer :: nExitC, ierr, ipcom, ifBreak, nrec
      character (len= 5) :: releas
!
      ReleaseXen = '01.12'
!
      if (ifDebug == 0) then
          call manage_console(1)
      endif
      ier = 0
!
!-- add extensions to the package name 
!
      cardImage   = ffile     ! = '.xen'
      ffile  = 'Sir' //  cardImage(1:Lung(cardImage))
      cardImage   = sirtx     ! = '.htm'
      sirtx  = ProgName(1:lProgName) //  cardImage(1:Lung(cardImage))
      cardImage   = iasun     ! = '.spg'
      iasun  = 'Sir' //  cardImage(1:Lung(cardImage))
      cardImage   = ciffle    ! = '.cif'
      ciffle = 'Sir' //  cardImage(1:Lung(cardImage))
      cardImage   = psfle     ! = '.ps'
      psfle  = 'Sir' //  cardImage(1:Lung(cardImage))
      cardImage   = rotfle    ! = '.rot'
      rotfle = 'Sir' //  cardImage(1:Lung(cardImage))
!v1.1 cardImage   = grufle    ! = '.gru'
!v1.1 grufle = 'Sir' //  cardImage(1:Lung(cardImage))
      cardImage   = extgroup  ! = '.egr'
      extgroup = 'Sir' //  cardImage(1:Lung(cardImage))
      cardImage   = macfle    ! = '.mac'
      macfle   = 'Sir' //  cardImage(1:Lung(cardImage))
      cardImage   = f12fle    ! = '.f12'
      f12fle   = 'Sir' //  cardImage(1:Lung(cardImage))
      cardImage   = imsg1     ! = '.msg'
      imsg1    = 'CaosWare' //  cardImage(1:Lung(cardImage))
      cardImage   = hlp1      ! = '.hlp'
      hlp1     = 'CaosWare' //  cardImage(1:Lung(cardImage))
      cardImage   = SymmSPG     ! = '.cnv'
      SymmSPG  = 'Sir' //  cardImage(1:Lung(cardImage))
!
!-- add path to data files
!-- exepath path to "sir2002.exe directory" //  "sirdir"
!                    directory where read-only files are stored
!-- cfgpath path to .cfg & .pal files
!                    directory where read/write files are stored
!
      i1 = Lung (exepath)
      j1 = Lung(sirtx)
      j2 = Lung(ffile)
      j3 = Lung(iasun)
      j4 = Lung(ciffle)
      j5 = Lung(psfle)
      j6 = Lung(grufle)
      j7 = Lung(extgroup)
      j8 = Lung(syminfo)
      j9 = Lung(histlib)
      j10 = Lung(rotfle)
      j11 = Lung(hetero)
      j12 = Lung(macfle)
      j13 = Lung(f12fle)
      j14 = Lung(imsg1)
      j15 = Lung(hlp1)
      j16 = Lung(SymmSPG)
      j17 = Lung(muta)
      j18 = Lung(aggiungi)
      j19 = Lung(looppa)
!
      if (i1.gt.0) then
          cardImage=' '
          cardImage(1:i1)=exepath
          cardImage(i1+1:i1+j1)=sirtx
          sirtx=cardImage
!
          cardImage=' '
          k = index(exepath, 'sirdir',BACK=.true.)
          if (k > 0) then
              exepath(k:) = 'files' // slash
              i2 = Lung(exepath)
          else
              i2 = i1
          endif

!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j2)=ffile
          ffile=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j3)=iasun
          iasun=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j4)=ciffle
          ciffle=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j5)=psfle
          psfle=cardImage
!
!v1.1     cardImage=' '
!v1.1     cardImage(1:i2)=exepath
!v1.1     cardImage(i2+1:i2+j6)=grufle
!v1.1     grufle=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j10)=rotfle
          rotfle=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j7)=extgroup
          extgroup=cardImage
!
**        cardImage=' '
**        k = index(exepath, 'sirdir',BACK=.true.)
**        if (k > 0) then
**            exepath(k:) = 'files' // slash
**            i2 = Lung(exepath)
**        else
**            i2 = i1
**        endif

!mr          k = index(exepath, 'ilmilione',BACK=.true.)
!mr          if (k > 0) then
!mr              exepath(k:) = 'ilmilione' // slash // 'files' // slash
!mr              i2 = Lung(exepath)
!mr          else
!mr              i2 = i1
!mr          endif
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j8)=syminfo
          syminfo=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j9)=histlib
          histlib=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j11)=hetero
          hetero=cardImage
!         
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j12)=macfle
          macfle=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j13)=f12fle
          f12fle=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j14)=imsg1
          imsg1=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j15)=hlp1
          hlp1=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j16)=SymmSPG
          SymmSPG=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j17)=muta
          muta=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j18)=aggiungi
          aggiungi=cardImage
!
          cardImage=' '
          cardImage(1:i2)=exepath
          cardImage(i2+1:i2+j19)=looppa
          looppa=cardImage
!
      endif
      j1 = j1 + i1
      j2 = j2 + i2
      j3 = j3 + i2
      j4 = j4 + i2
      j5 = j5 + i2
!v1.1 j6 = j6 + i2
      j7 = j7 + i2
      j8 = j8 + i2
      j9 = j9 + i2
      j10=j10 + i2
      j11=j11 + i2
      j12=j12 + i2
      j13=j13 + i2
      j14=j14 + i2
      j15=j15 + i2
      j16=j16 + i2
      j17=j17 + i2
      j18=j18 + i2
      j19=j19 + i2
!
!-- check if files exist (escluso file imsg1 )--
!
      itipo=2
      iform=1
      jop=jopen(kform,sirtx,itipo,iform,ierr)
      if (jop.lt.0) then
          ex1 = 0
        else
          ex1 = 1
          close(kform)
      endif
!
      jop=jopen(kform,ffile,itipo,iform,ierr)
      if (jop.lt.0) then
          ex2 = 0
        else
          ex2 = 1
          close(kform)
      endif
!
      jop=jopen(kform,iasun,itipo,iform,ierr)
      if (jop.lt.0) then
          ex3 = 0
        else
          ex3 = 1
          close (kform)
      endif
!
      jop=jopen(kform,ciffle,itipo,iform,ierr)
      if (jop.lt.0) then
          ex4 = 0
        else
          ex4 = 1
          close (kform)
      endif
!
      jop=jopen(kform,psfle,itipo,iform,ierr)
      if (jop.lt.0) then
          ex5 = 0
        else
          ex5 = 1
          close (kform)
      endif
!
      jop=jopen(kform,grufle,itipo,iform,ierr)
      if (jop.lt.0) then
          ex6 = 0
      else
          ex6 = 1
          close (kform)
      endif
!
      jop=jopen(kform,rotfle,itipo,iform,ierr)
      if (jop.lt.0) then
          ex10 = 0
      else
          ex10 = 1
          close (kform)
      endif
!
      jop=jopen(kform,extgroup,itipo,iform,ierr)
      if (jop.lt.0) then
          ex7 = 0
      else
          ex7 = 1
          close (kform)
      endif
!
      jop=jopen(kform,syminfo,itipo,iform,ierr)
      if (jop.lt.0) then
          ex8 = 0
      else
          ex8 = 1
          call spg_set_symmetry_file(syminfo)
          close (kform)
      endif
!
      jop=jopen(kform,histlib,itipo,iform,ierr)
      if (jop.lt.0) then
          ex9 = 0
      else
          ex9 = 1
          close (kform)
      endif
!
      jop=jopen(kform,hetero,itipo,iform,ierr)
      if (jop.lt.0) then
          ex11 = 0
      else
          ex11 = 1
          close (kform)
      endif
!
      jop=jopen(kform,macfle,itipo,iform,ierr)
      if (jop.lt.0) then
          ex12 = 0
      else
          ex12 = 1
          close (kform)
      endif
!
      jop=jopen(kform,f12fle,itipo,iform,ierr)
      if (jop.lt.0) then
          ex13 = 0
      else
          ex13 = 1
          close (kform)
      endif
!
      jop=jopen(kform,hlp1,itipo,iform,ierr)
      if (jop.lt.0) then
          ex15 = 0
      else
          ex15 = 1
          close (kform)
      endif
!
      jop=jopen(kform,SymmSPG,itipo,iform,ierr)
      if (jop.lt.0) then
          ex16 = 0
      else
          ex16 = 1
          close (kform)
      endif
!
      jop=jopen(kform,muta,itipo,iform,ierr)
      if (jop.lt.0) then
          ex17 = 0
      else
          ex17 = 1
          close (kform)
      endif
!
      jop=jopen(kform,aggiungi,itipo,iform,ierr)
      if (jop.lt.0) then
          ex18 = 0
      else
          ex18 = 1
          close (kform)
      endif
!
      jop=jopen(kform,looppa,itipo,iform,ierr)
      if (jop.lt.0) then
          ex19 = 0
      else
          ex19 = 1
          close (kform)
      endif
!
      Missing = 0
      if (ex1.ne.1) then
          write(Msg,70) sirtx(1:j1)
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
          ier = -2
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') sirtx(1:j1)
      endif
      if (ex2.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') ffile(1:j2)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) ffile(1:j2)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) ffile(1:j2)
          endif
      endif
      if (ex3.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') iasun(1:j3)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) iasun(1:j3)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) iasun(1:j3)
          endif
      endif
      if (ex4.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') ciffle(1:j4)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) ciffle(1:j4)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) ciffle(1:j4)
          endif
      endif
      if (ex5.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') psfle(1:j5)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) psfle(1:j5)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) psfle(1:j5)
          endif
      endif
      if (ex6.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') grufle(1:j6)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) grufle(1:j6)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) grufle(1:j6)
          endif
      endif
      if (ex10.ne.1) then
          if (Missing == 0) then
              write(*,10)
              Missing = 1
          endif
          write(*,'(a)') rotfle(1:j10)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) grufle(1:j10)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) grufle(1:j10)
          endif
      endif
      if (ex7.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') extgroup(1:j7)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) extgroup(1:j7)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) extgroup(1:j7)
          endif
      endif
      if (ex8.ne.1) then
          if (Missing == 0) then
              write(0,10) 
              Missing = 1
          endif
          write(0,'(a)') syminfo(1:j8)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) syminfo(1:j8)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) syminfo(1:j8)
          endif
      endif
      if (ex9.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') histlib(1:j9)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) histlib(1:j9)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) histlib(1:j9)
          endif
      endif
      if (ex11.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') hetero(1:j11)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) hetero(1:j11)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) hetero(1:j11)
          endif
      endif
      if (ex12.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') macfle(1:j12)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) macfle(1:j12)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) macfle(1:j12)
          endif
      endif
      if (ex13.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') f12fle(1:j13)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) f12fle(1:j13)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) f12fle(1:j13)
          endif
      endif
      if (ex15.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') hlp1(1:j15)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) hlp1(1:j15)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) hlp1(1:j15)
          endif
      endif
      if (ex16.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') SymmSPG(1:j16)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) SymmSPG(1:j16)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) SymmSPG(1:j16)
          endif
      endif
      if (ex17.ne.1) then
          if (Missing == 0) then
              write(*,10) 
              Missing = 1
          endif
          write(*,'(a)') muta(1:j17)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) muta(1:j17)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) muta(1:j17)
          endif
      endif
      if (ex18.ne.1) then
          if (Missing == 0) then
              write(*,10)
              Missing = 1
          endif
          write(*,'(a)') aggiungi(1:j18)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) aggiungi(1:j18)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) aggiungi(1:j18)
          endif
      endif
      if (ex19.ne.1) then
          if (Missing == 0) then
              write(*,10)
              Missing = 1
          endif
          write(*,'(a)') looppa(1:j19)
          if (kscreen.eq.1) then
              ier = -2
              write(Msg,70) looppa(1:j19)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
            else
              write(lo,80) looppa(1:j19)
          endif
      endif
!      
      if (Missing > 0) then
         ifBreak = 0
         call LockFile(-1, 0, ifBreak)
!mr250606         pause
      else
!
!-- Fill StoredSpecies array
!
         jop = jopen(kform,ffile,itipo,iform,ierr)
         read(kform,'(a5)',iostat=ierr,err=7000) releas
         close (kform)
         if (releas /= ReleaseXen) then
             ipcom = 0
             write(Msg,90) ReleaseXen
             if (kscreen.eq.1) then
                 call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
             else
                 write(lo,95) Msg(1:Lung(Msg))
             endif
             ier = -2
             return
         endif
      endif
!
      if (ier == 0 .and. ifDebug == 0) then
          call manage_console(2)
      endif
!
      return
 7000 nrec = 1
      write(Msg,7100) ierr,nrec,ffile(1:Lung(ffile))
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
      ier = -2
      return
!
   10 format(//,' ***** ERROR *****',/,' Missing files:')
   70 format(' File ',a,' does not exist.')
   80 format(//,' *** WARNING ***  File ',a,' does not exist.')
   90 format('In Sir.xen file the release should be ',a5,' !!')
   95 format(/,' ERROR: ',a,/)
 7100 format(' Error ',i5,' reading record #',i3,' in file ',a)
      end
!-----------------------------------------------------------------------
      block data sirblk
      USE PhaseModule
      USE LsqModule
      USE Direttive
!
      common /xunit/ ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
      common /setequ/ kpatt,dummy(504)
c--modificato RS 12.05.06      
      character Numdigit*13
      common /cifre/ Numdigit
      common/xcardch/CardImageX,idch(6)
      character CardImageX*80,idch*1
      data idch/' ',',','(',')','+','-'/
      data kpatt/0/
!
      data Numdigit/'0123456789.-+'/
      data ncru,ncwu,ncpu,ncpt,itty,istat2,iabort
     *    /   5,   6,   7,  62,   0,     0,     0/
!
      end
!-----------------------------------------------------------------------
      subroutine CheckWindowCommand(file1,nkscrx,nkscry,ier)
      USE General
      USE Molcom
      USE commandsmod
!
      common /SizeScr/ MinScX, MaxScX, MinScY, MaxScY
*gl*  common /charas/ beg,commen,allcom
*gl*  character beg,commen,allcom(80)*14
      character*(*) file1
      character line*80, dire*80, com3*3
      dimension vet(40),ivet(40)
!      
      itipo = 2
      iform = 1
      jop = jopen(kform,file1,itipo,iform,ier1)
      ifEnd = 0
      ifJob = 0
c
      do while ( ifEnd.eq.0)
         read(kform,'(a)',end=2000) line
         k = index(line,'!')
         if (k.ne.0) then
             line(k:) = ' '
         endif
         call shift(line,nchar)
         if (nchar.gt.0.and.line(1:1).ne.commen) then
             if (line(1:1).eq.beg) then
                 com3=line(2:4)
                 call lcase(com3)
                 if (com3.eq.'end'.or.com3.eq.'con') then
                     ifEnd = 1
                 else if (com3.eq.'win') then
                     call cutst(line,lenp,dire,lend)
                     iopt=0
                     call getnum(line,vet,ivet,iv,iopt)
                     if (iv.eq.2) then
                         if (ivet(1).gt.MinScX) then
                             nkscrx = ivet(1)
                         endif
                         if (ivet(2).gt.MinScY) then
                             nkscry = ivet(2)
                         endif
                     endif
                 else if (com3.eq.'hid') then
                     ifHidden = 1
                     call cutst(line,lenp,dire,lend)
                     iopt=0
                     call getnum(line,vet,ivet,iv,iopt)
                     if (iv.eq.2) then
                         if (ivet(1).gt.MinScX) then
                             nkscrx = ivet(1)
                         endif
                         if (ivet(2).gt.MinScY) then
                             nkscry = ivet(2)
                         endif
                     endif
                 else if (com3.eq.'now') then
                     kscreen = 0
                 else if (com3.eq.'job') then
                     call cutst(line,lenp,dire,lend)
                     ioffset = ( 80 - lenp ) / 2
                     if (ioffset.le.0) ioffset = 1
                     dire = ' '
                     ioffset = 1
                     dire(ioffset:) = line
!gl!                 read(dire,'(20a4)') itle
                     Titolo = dire(1:80)
                     ifJob = 1
                 else if (com3.eq.'rec') then
                     ifRecover = 1
                 endif
             endif
         endif
      enddo
 2000 if (ifEnd.eq.0) then
          write(lo,2010)
          ier = -1
      endif
      if (ifJob == 0) then
          k = index(fname(1), '.bin')
          dire = fname(1)(1:k-1)
!gl!      read(dire,'(20a4)') itle
          Titolo = dire(1:80)
      endif

 2010 format(' ****************** ERROR ******************',/,
     *       ' No   %end or %continue   command specified!')
!
      close(kform)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine CheckStructCommand(file1,ier)
      USE General
      USE Molcom
      USE commandsmod
!
*gl*  common /charas/ beg,commen,allcom
*gl*  character beg,commen,allcom(80)*14
      character*(*) file1
      character line*80, dire*80, com3*3, structname*80
!      
      structname = 'struct'
      itipo = 2
      iform = 1
      jop = jopen(kform,file1,itipo,iform,ier1)
      ifEnd = 0
c
      do while ( ifEnd == 0 )
         read(kform,'(a)',end=2000) line
         k = index(line,'!')
         if (k.ne.0) then
             line(k:) = ' '
         endif
         call shift(line,nchar)
         if (nchar.gt.0.and.line(1:1).ne.commen) then
             if (line(1:1).eq.beg) then
                 com3=line(2:4)
                 call lcase(com3)
                 if (com3.eq.'end'.or.com3.eq.'con') then
                     ifEnd = 1
                 else if (com3.eq.'str') then
                     call cutst(line,lenp,dire,lend)
                     if (lenp > 0) then
                         structname = line
                     endif
                 endif
             endif
         endif
      enddo
 2000 lstr = Lung(structname)
      do i=1,13
         fname(i) = structname(1:lstr) // ext(i) 
      enddo
      if (ifEnd.eq.0) then
          write(lo,2010)
          ier = -1
      endif
 2010 format(' ****************** ERROR ******************',/,
     *       ' No   %end or %continue   command specified!')
!
      close(kform)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine mainloop(iFrom,file1,file2,ier)
      USE General
      USE Molcom
      USE PhaseModule
      USE Direttive
!
! --- iFrom = 1 routine chiamata dal main program (fornito parametro): .sir
! --- iFrom = 2 routine chiamata dalla grafica                       : .sir
! --- iFrom = 3 routine chiamata dalla grafica                       : .bin
!
*gl*  common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat

!
      character*(*) file1,file2
      dimension B(3,3)
!
      iEnd = 0
      ispoolr = 0
      kcont=0
      if (ifFirstTime.eq.1.and.jscreen.ne.0) then
          ifFirstTime = 0
          InfoOK(:) = 0
          CheScale = 1
!
          NF=0
          ViewDist = 9.e33
!
          L1 = 0
          L2 = 0
          L3 = kscrx
          L4 = kscry
          ic0 = jBackGround
          call Rettangolo (L1, L2, L3, L4, ic0, ic0)
!-- il punto (L1,L2) e' il punto in alto a sinistra del viewport
!-- grafico, mentre (L3,L4) e' quello in basso a destra.
          NPX = L3 - L1
          NPY = L4 - L2
          Ratio = float(NPX) / float(NPY)!
      endif
      do i = 1 , 3
         do j = 1 , 3
            BTot(i, j) = 0
            B(i,j)     = 0
         enddo
         BTot(i, i) = 1
         B(i, i)    = 1
      enddo
      if (iFrom.le.2) then
          iExCo2 = 99
      endif
      Loop = 0
      do while (Loop.eq.0.and.ier.eq.0) 
         if (jscreen.eq.0) then
             iExCo2 = 99 + ispoolr
         endif
         if (iExCo2.eq.11) then
             call LoadFromBin(file1,file2,ier)
             file1 = ' '
             icomq(1,1) = 6
             icomq(2,1) = 7
             icomq(1,2) = 0
             icomq(2,2) = 0
             icomat = 0
             ipdir  = 0
             ipcom  = 2
             iExCo2 = 100
         endif
         if (iExCo2.eq.99) then
             if (ispoolr.eq.0) then
                 if (ifFromShelx == 0) then
                     call spoolr(file1,ier)
                 endif
!
                 k = index(fname(1),'.bin')
                 kk = kStripTask1(k) - 1
                 StructureName = fname(1)(1:kk)
                 lStructureName = kk
!
                 ipdir = 0
                 if (kmad /= 0 .or. ifWasRemo == 1) then
                     call CPUTime0(' ')
                 endif
             endif
             if (ier < 0) then
                 call SadEnd(ier)
                 iEnd = 1
                 call RunToolBar(-1,' ')
                 Loop = 1
             else
                 ispoolr = 1
                 iExCo2 = 100
             endif
         endif
         if (InfoOK(6).eq.1 .and. kmad == 0) then    !310105
             call CheckGrid()
             nreflDim = nrefltot
             call AllocaRiflessi(1)
         endif
         if (iExCo2.eq.100) then
             if (ier.eq.0) then
                 call sircom(iEnd,ier)
             endif
             if (jscreen.gt.0) then
                 if (ier.lt.0) then
!!mr                     call LockFile(-1, 0, ifBreak)
!!mr                     ier = 0
                     iEnd = 1
                     call RunToolBar(-1,' ')
                 endif
             endif
             if (iEnd.eq.0) then
                 if (ier.eq.99) then
                     ier = 0
                 else
                     Loop = 1
                 endif
             else
                 file1 = ' '
                 ispoolr = 0
                 Loop = 1
             endif
         endif
      enddo

!
      return
      end
! ----------------------------------------------------------------------
      subroutine SucchiaDati(InitializeFile,NewFileBin,ier)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE TempMat
      USE PhaseModule
      USE LsqModule
      USE TestModel
!
      character*80 acc
      character*10 rdwr
      dimension hl(12)
      character (len=4) :: header, head
!
      header = 'Head'
!
!-- check if the binary file an old style one
!
      if (InitializeFile == 0) then
          ios = 0
          head = ' '
          istat = 0
          iform = 2
          jop=jopen(jdir,fname(1),istat,iform,ierr)
          if (jop < 0) then
              write(Msg,190) ierr, fname(1)(1:Lung(fname(1)))
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
              ier = -2
              return
          endif
          read(jdir, err=10, IOSTAT = ios) head
   10     if (ios /= 0) then
              ier = -2
          else
              if (head /= header) then
                  ier = -2
              endif
          endif
          close(jdir)
          if (ier < 0) then
              write(Msg,190) ierr, fname(1)(1:Lung(fname(1)))
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
              ier = -2
              return
          endif
      endif
!
!--InfoOK(i) = 1 se la i-esima lista e' in memoria, altrimenti e' zero
!
      NewFileBin = 1
      InfoOK(:) = 0
!
      if (InitializeFile == 1) then
          NewFileBin = 1
      endif
!
      ier = 0
      jspini = -1
      if (InitializeFile == 0) then
          iAction = 2
          mode    = 1
          call PutGetBinaryFile(iAction, mode, ier)
          if (ier == 0) then
              ifProject = 1
              write(Titolo,'(20a4)') itle
              if (kscreen > 0) then
                  call SetWindowTitle(Titolo)
              endif
          endif
      endif
!
      k = index(fname(1),'.bin')
      

      if (k == 0) then
          cardDiret = fname(1)(1:k-1) // '.log'
          ierr = 0
          istat = 0
          iform = 1
          jop=jopen(jdir,cardDiret,istat,iform,ierr)
          if (jop == 0) then
              close(jdir,status='delete')
          endif
      endif

!
      if (NewFileBin.eq.0) then
          iprea = -1
          iAll = 0
          iDim = 1
          ititle = Titolo
      endif
!
      if (InfoOK(1).eq.0.or.
     *    InfoOK(2).eq.0.or.
     *    InfoOK(3).eq.0) then
          if (NewFileBin /= 0) then
              do i=1,100
                 InfoOK(i) = 0
              enddo
          endif
      endif
!
      if (InfoOK(5) == 1 .or. InfoOK(15) == 1) then

          QualeAbilita = 2

          if (nats > anat) then
              call AllocaAtomi(-1)
          else
              call AllocaAtomi(1)
          endif
          call InitMolplo
          anat=float(nat)/(pts*float((icent+1)*nsym))
          natm=int(anat+0.5)
!
          do i=1,MaxAtomsInGr
             iOrd(i) = i
          enddo
!
          call GetModel        ! gianluca 17/03/2015
          call PutGetXyzs(1,1) ! gianluca 17/03/2015
!
          iPlt = iPlotType
          ifSingle = 1
          call MolPlo(iPlt, ifSingle)
      elseif (InfoOK(17) == 1) then
          QualeAbilita = 1
          if (ifRecover == 0) then
              write(Msg,80) nSetsFineDSR
              Inte = 'Final Stage'
              call MsgWinErr(Inte, Msg, INFO_WINDOW, nExitC)
          endif
      elseif (kmad == 1 .and. InfoOK(34) == 1) then
          QualeAbilita = 1
          ifMadEnv = 2
          Inte = 'Mad data loaded'
          call PrintMess(Inte)
          call DoAllGraphs()
      endif
!
      if (allocated(mat)) then
          deallocate (mat, stat = ierr)
      endif
!
      return
   80 format(i3,' set of phases available. Click on menu item ',
     *          'Solve to manage them')
  190 format(' Open/Read Error ',i5,'  on file ',a)
  191 format('The file ',a,' is write-protected')
      end
! ----------------------------------------------------------------------
      subroutine SadEnd(ier)
      USE General
      USE Molcom
      USE Direttive
!
*gl*  common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
!
      call scrper(' ERROR !!! Check output and edit .sir file',0,-1)
      call AllocaRiflessi(2)
      icomat = ipcom
      if (ifMadEnv == 0 .and. ier /= -2) then
          call scr2_sir
      endif
      if (jscreen > 0) then
          call SadFace()
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine ProgramStopped()
      USE General
      USE Molcom
      USE Grafici
      USE MadModule
!
      character line*80
!
      k = index(fname(1),'.')
      kk = kStripTask1(k)
      kk = kk - 1
      if (ifIsOver == 1) then
          write(line,2000) ProgName(1:Lung(ProgName)), 'on: ',
     *                     fname(1)(1:kk)
      else
          write(line,3000) ProgName(1:Lung(ProgName))
      endif
      lline = Lung(line)
**    if(ier.ne.-2) call scrend(line,lline)
      call scrend(line,lline)
!      call CPUTime(ProgName, 1)   
      jcpuP = 1
      call CPUTime(' ', 0)
      write(lo,10) ProgName(1:lProgName), Inte(1:Lung(Inte))
   10 format(/,a,' ',a)
      if (ifMadEnv > 0) then
          if (ifIsOver == 0) then
              call LockFile(-1, numFragsMad, ifBreak)
              headersGR(2) = Inte
              Msg = '<b>          Run stopped by user.</b>'
              call TestoGR(Msg, color_LIGHTRED, 2, 0)
*gl*      else
*gl*          if (ifWasRemo == 0) then
*gl*              call LockFile(0, numFragsMad, ifBreak)
*gl*          endif
          endif
          if (ifPDBfiles == 1) then
              call zflush
              call ManageGraph(0, 0)
              call DoSingleIteration()
          endif
      endif
      if (ifPDBfiles == 1) then
          call CreaPng(fname(9))
      endif
      write(lo,4000) line(1:lline)
      close (lo)
!     if (ifMadEnv > 0) then
*gl*      k = index(fname(1),'.bin')
*gl*      Inte = fname(1)(1:k-1) // '.log'
*gl*      istat = 3
*gl*      iform = 1
*gl*      jop = jopen(lo, Inte, istat, iform, ierr)
*gl*      write(lo,4001) line(1:lline)
*gl*      close(lo)
!     endif
!
      return
 2000 format(a,' ends OK ',a,a)
 3000 format(a,' stopped by user')
 4000 format(//,' ',a)
*4001 format(//,' ',a)
      end
! ----------------------------------------------------------------------
      subroutine CreaIsOver
      USE General
      USE Molcom
!
      ifIsOver = 1
      if (ifMadEnv > 0) then
          if (kmad == 1) then
              Msg = 'Mad/Sad substructure procedure is over.'
          elseif (kmad == 2) then
              if (ifMiras == 0) then
                  Msg = 'Mir/Sir procedure is over.'
              else
                  Msg = 'Miras/Siras procedure is over.'
              endif
          elseif (ifRemo > 0) then
              Msg = 'Molecular Replacement procedure is over.'
          else
              Msg = 'Ab Initio structure ' //
     *              'determination is over.'
          endif
      else
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine InitGrafici(npoints)
      USE General
      USE Molcom
      USE Grafici
      USE RemoModule
      USE PhaseModule
!
      ifPlotGR = .false.
      ifSkeletonOn = 0 ! no more skeleton
      if (npoints > 0) then
          nPointsGR = npoints
      endif
!
!-- initialize histogram area
!
      if (ifRemo > 0) then
!
          kLarg = kscrx
          kAlt  = kscry
          stepGR = 1.5 * FntPixHeight / float(kAlt)
!
          xHisto(1,:) = 0.5
          xHisto(2,:) = 1.0
!
          stepGR = 1.5 * FntPixHeight / float(kAlt)
!
          if (nMolMR == 1 .or. numbModels > 1) then
              tot2 = (1.0 - 2 * stepGR) / 2.0
              nGraficiGR = 2
!
              yHisto(1,2) = 0.0 + stepGR
              yHisto(2,2) = yHisto(1,2) + tot2
!
              yHisto(1,1) = yHisto(2,2) 
              yHisto(2,1) = 1.0 - stepGR
!
          else
              tot3 = (1.0 - 2 * stepGR) / 3.0
              nGraficiGR = 3
!
              yHisto(1,3) = 0.0 + stepGR
              yHisto(2,3) = yHisto(1,3) + tot3
!
              yHisto(1,2) = yHisto(2,3)
              yHisto(2,2) = yHisto(1,2) + tot3
!
              yHisto(1,1) = yHisto(2,2)
              yHisto(2,1) = 1.0 - stepGR
          endif
!
          xHistF(:,:) = xHisto(:,:)
          yHistF(:,:) = yHisto(:,:)
          xHisto(1,:) = xHisto(1,:) + 0.15
          xHisto(2,:) = xHisto(2,:) - stepGR ! 0.10
          yHisto(1,:) = yHisto(1,:) + 1.75 * stepGR ! 0.10
          yHisto(2,:) = yHisto(2,:) - 1.25 * stepGR ! 0.05
!
          tipoGraficiGR(1) = 1
          StringGR(1,1) = 'Trials'
          StringGR(1,2) = 'Rfom'
          LegendGR(1) = 'Rotational FOM, '
     *               // 'in green after clustering'
c          LegendGR(1) = ' '
!
          tipoGraficiGR(2) = 1
          StringGR(2,1) = 'Trials'
          StringGR(2,2) = 'Tfom'
          LegendGR(2) = 'Translational FOM, '
     *               // 'in green after optimization'
c          LegendGR(2) = ' '
!
          tipoGraficiGR(3) = 1
          StringGR(3,1) = 'Solutions'
          StringGR(3,2) = 'Nfom'
          LegendGR(3) = 'NCS FOM, ' 
     *               // 'in green after optimization'
c          LegendGR(3) = ' ' 
!
      elseif (kmad > 0) then
!
          kLarg = kscrx
          kAlt  = kscry
          stepGR = 1.5 * FntPixHeight / float(kAlt)
          tot3 = (1.0 - 2 * stepGR) / 3.0
!
          xHisto(1,:) = 0.5
          xHisto(2,:) = 1.0
!
          yHisto(1,3) = 0.0 + stepGR
          yHisto(2,3) = yHisto(1,3) + tot3
!
          yHisto(1,2) = yHisto(2,3)
          yHisto(2,2) = yHisto(1,2) + tot3
!
          yHisto(1,1) = yHisto(2,2)
          yHisto(2,1) = 1.0 - stepGR
!
          xHistF(:,:) = xHisto(:,:)
          yHistF(:,:) = yHisto(:,:)
          xHisto(1,:) = xHisto(1,:) + 0.15
          xHisto(2,:) = xHisto(2,:) - stepGR ! 0.10
          yHisto(1,:) = yHisto(1,:) + 1.75 * stepGR ! 0.10
          yHisto(2,:) = yHisto(2,:) - 1.25 * stepGR ! 0.05
!
          tipoGraficiGR(1) = 2
          StringGR(1,1) = 'eFOM'
          StringGR(1,2) = 'n'
!          LegendGR(1) = 'Combined FOM histogram.'
!     *                // 'The best trials have the highest cFOM values.'
          LegendGR(1) = ' '
!
          tipoGraficiGR(2) = 1
          StringGR(2,1) = 'R%'
          StringGR(2,2) = 'f FOM'
!          LegendGR(2) = 'The best trials have the lowest R% values '
!     *            // 'and the highest RAT values.'
          LegendGR(2) = ' '
!
          tipoGraficiGR(3) = 2
          StringGR(3,1) = 'R% / f FOM'
          StringGR(3,2) = 'n'
!          LegendGR(3) = 
!     *              'The best trials have the lowest ratio values.'
          LegendGR(3) = ' '
!
**        if (allocated(ivBest)) then
             ivBest(1) = 1                       !pgMAD1512
             ivBest(2) = -1                      !pgMAD1512
             ivBest(3) = -1                      !pgMAD1512
**        end if
      elseif (ifVLD > 0 .and. ifMDM == 0) then
              kLarg = kscrx
              kAlt  = kscry
              stepGR = 1.5 * FntPixHeight / float(kAlt)
              tot3 = (1.0 - 2 * stepGR) / 2.0
              xHisto(1,:) = 0.5
              xHisto(2,:) = 1.0
!
              yHisto(1,2) = 0.0 + stepGR
              yHisto(2,2) = yHisto(1,2) + tot3
!
              yHisto(1,1) = yHisto(2,2)
              yHisto(2,1) = yHisto(1,1) + tot3
!
              yHisto(1,2) = yHisto(1,1)   ! new
              yHisto(2,2) = yHisto(2,1)
!
              xHistF(:,:) = xHisto(:,:)
              yHistF(:,:) = yHisto(:,:)
              xHisto(1,:) = xHisto(1,:) + 0.15
              xHisto(2,:) = xHisto(2,:) - stepGR ! 0.10
              yHisto(1,:) = yHisto(1,:) + 1.75 * stepGR ! 0.10
              yHisto(2,:) = yHisto(2,:) - 1.25 * stepGR ! 0.05
              tipoGraficiGR(1) = 4
              tipoGraficiGR(2) = 4
      else
!
          if (ifMadEnv == 0) then
              if (ifTang == 1) then
                  xHisto(1,:) = 0.0
                  xHisto(2,:) = 1.0
!
                  yHisto(1,1) = 0.5 
                  yHisto(2,1) = 1.0
!
                  yHisto(1,2) = 0.0 
                  yHisto(2,2) = 0.5
!
                  xHistF(:,:) = xHisto(:,:)
                  yHistF(:,:) = yHisto(:,:)
                  xHisto(1,:) = xHisto(1,:) + 0.15
                  xHisto(2,:) = xHisto(2,:) - 0.10
                  yHisto(1,:) = yHisto(1,:) + 0.15 ! + 0.10
                  yHisto(2,:) = yHisto(2,:) - 0.08
              else
                  xHisto(1,:) = 0.0
                  xHisto(2,:) = 1.0
!
                  yHisto(1,1) = 0.0 
                  yHisto(2,1) = 1.0
!
                  xHistF(:,:) = xHisto(:,:)
                  yHistF(:,:) = yHisto(:,:)
                  xHisto(1,:) = xHisto(1,:) + 0.15
                  xHisto(2,:) = xHisto(2,:) - 0.10
                  yHisto(1,:) = yHisto(1,:) + 0.15 ! + 0.10
                  yHisto(2,:) = yHisto(2,:) - 0.08
              endif
          else
              kLarg = kscrx
              kAlt  = kscry
              stepGR = 1.5 * FntPixHeight / float(kAlt)
              tot3 = (1.0 - 2 * stepGR) / 3.0
              xHisto(1,:) = 0.5
              xHisto(2,:) = 1.0
!
              yHisto(1,3) = 0.0 + stepGR
              yHisto(2,3) = yHisto(1,3) + tot3
!
              yHisto(1,2) = yHisto(2,3)
              yHisto(2,2) = yHisto(1,2) + tot3
!
              yHisto(1,1) = yHisto(2,2)
              yHisto(2,1) = 1.0 - stepGR
!
              xHistF(:,:) = xHisto(:,:)
              yHistF(:,:) = yHisto(:,:)
              xHisto(1,:) = xHisto(1,:) + 0.15
              xHisto(2,:) = xHisto(2,:) - stepGR ! 0.10
              yHisto(1,:) = yHisto(1,:) + 1.75 * stepGR ! 0.10
              yHisto(2,:) = yHisto(2,:) - 1.25 * stepGR ! 0.05
          endif
!
          if (ifMDM == 0 .or. ifMadEnv > 0) then    ! gianluca 28/01/2014
              if (ifPatt /= 0 .and. ksize <= 3) then   ! patterson per piccole/medie (forse inutile)
                  tipoGraficiGR(1) = 1
                  ivBest(1) = -1
                  StringGR(1,1) = 'R%'
                  StringGR(1,2) = 'Fom'
                  LegendGR(1) = 'Final FOM vs R% scatter plot'
                  nGraficiGR = 1
              else
                  if (ifTang == 0) then
                      tipoGraficiGR(1) = 2
                      ivBest(1) = 1
                      StringGR(1,1) = 'Final FOM'
                      StringGR(1,2) = 'n'
                      LegendGR(1) = 'Final FOM histogram'
                      nGraficiGR = 1
                  else
                      tipoGraficiGR(1) = 2
                      ivBest(1) = 1
                      StringGR(1,1) = 'eFOM'
                      StringGR(1,2) = 'n'
                      LegendGR(1) = 'Early FOM histogram'
                      nGraficiGR = 2
                  endif
              endif
          else                    ! gianluca 28/01/2014
              if (ifMadEnv > 0) then    ! gianluca 28/01/2014
                  nGraficiGR = 1
                  tipoGraficiGR(1) = 2
                  ivBest(1) = 1                      !pgMAD1512
                  StringGR(1,1) = 'Final FOM'
                  StringGR(1,2) = 'n'
                  LegendGR(1) = 'Final FOM histogram'
              else
                  nGraficiGR = 1
                  tipoGraficiGR(1) = 1
                  ivBest(1) = -1
                  StringGR(1,1) = 'R%'
                  StringGR(1,2) = 'Fom'
                  LegendGR(1) = 'Final FOM vs R% scatter plot'
                  nGraficiGR = 1
              endif
          endif
!

c         write(6,*) ' nolsq=',nolsq


          if (nolsq == 0 .and. ifMDM == 0 .and. ksize > 3) then
              tipoGraficiGR(2) = 2
              ivBest(2) = 1                      !pgMAD1512
              StringGR(2,1) = 'Final FOM'
              StringGR(2,2) = 'n'
              LegendGR(2) = 'Final FOM histogram'
          else
              if (ifMDM == 0) then
                  if (ifPatt > 0) then    ! gianluca 28/01/2014
                      nGraficiGR = 1
                      tipoGraficiGR(1) = 1
                      ivBest(1) = -1
                      StringGR(1,1) = 'R%'
                      StringGR(1,2) = 'Fom'
                      LegendGR(1) = 'Final FOM vs R% scatter plot'
                  else                                    ! tangente
                      tipoGraficiGR(2) = 1
                      ivBest(2) = -1
                      StringGR(2,1) = 'R%'
                      StringGR(2,2) = 'Fom'
                      LegendGR(2) = 'Final FOM vs R% scatter plot'
                  endif
              else                                    ! tangente
                  tipoGraficiGR(2) = 1
                  ivBest(2) = -1
                  StringGR(2,1) = 'R%'
                  StringGR(2,2) = 'Fom'
                  LegendGR(2) = 
     *                 'Final FOM vs R% scatter plot'
              endif
          endif
          if (ifMadEnv > 0) then
              LegendGR(1) = ' '
              LegendGR(2) = ' '
          endif
!
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine PutGetBinaryFile(iAction, mode, ier)
!
!-- iAction = 1  Write all informations on disk
!--         = 2  Read all informations from disk
!-- mode    = 1  file involved: .bin
!--         = 2  file involved: .sav
!
      USE General
      USE Symmetry
      USE Properties
      USE Atomi
      USE Molcom
      USE RemoModule
      USE RiflessiInfo
      USE TestModel
      USE LsqStuff
      USE PhaseModule
      USE VLDmod, only : n_abi_model, nPreviousTrials
!
      USE spginfom
!
      implicit none
      integer :: iAction, iAction1, iAction2, i, j, k, L, Lung, interp
      integer :: istat, iform, ier, ierr, jopen, jop, nExitC, iprPutGet
      integer :: nats1, nats2, nBonds1, nBonds2
      integer :: mode, procedura
      real    :: cella(6), celltemp(13), wave
      character (len=1)  :: dum1, dum2
      character (len=4)  :: dire
      character (len=4) :: header
!
      iprPutGet = 0
      header = 'Head'
!
      ier = 0
      dum1 = ' '
      dum2 = ' '
      j = 0
      Buffer1 = fname(1)
      if (mode == 2) then
          k = index(fname(1), '.bin')
          Buffer1(k+1:k+3) = 'sav'
      endif
      L = Lung(Buffer1)
      iform = 2
      if (iAction == 1) then
          istat = 0
      else
          istat = 2
      endif
      jop = jopen(jdir, Buffer1(1:L), istat, iform, ierr)
      if (ierr /= 0) then
          ier = 0
          return
      endif
!
*     if (k > 0) then
*         fname(1) = Buffer1(1:k-1) // '.bin'
*     endif
!
      if (iAction == 1) then
          if (ifVLD == 1) then
              if (ifMDM == 0) then
                  procedura = -nPreviousTrials
              else
                  procedura = 3
              endif
          elseif (ifTang == 1) then
              procedura = 1
          else
              procedura = 2
          endif

!
          WhichModel = 1     ! gianluca 07/12/2014
          refl_info%nstr = nstr_data
          iAction2 = 1
          write(jdir) header, itle, cell(1:6), errcell(1:7),
     *                 nSpaceG, nSetsFineDSR, procedura,
     *                 AtmProperties, refl_info, numbModels,
     *                 nBestModels
!         write(jdir) header
!         write(jdir) itle
!         write(jdir) cell(1:6)
!         write(jdir) errcell(1:7)
!         write(jdir) nSpaceG
!         write(jdir) AtmProperties
!         write(jdir) refl_info
!
!-- Reflections
!
          call PutGetReflections(iAction)
!
!-- Atoms
!
          if (allocated(model)) then
              if (allocated(model(WhichModel)%atoms)) then
                  nats1   = natsInModel(WhichModel)
                  nBonds1 = BondsInModel(WhichModel)
              else
                  nats1   = 0
                  nBonds1 = 0
              endif
              if (numbModels > 0) then
                  if (nBestModels > 0) then
                      call PutGetMiglioriErre(1)
                  endif
                  if (size(model(:)) > 1) then
                      if (allocated(model(WhichModel+1)%atoms)) then
                          if (size(natsInModel) > 1) then
                              nats2 = natsInModel(WhichModel+1)
                              nBonds2 = BondsInModel(WhichModel+1)
                          else
                              nats2   = 0
                              nBonds2 = 0
                          endif
                      else
                          nats2   = 0
                          nBonds2 = 0
                      endif
                  else
                      nats2   = 0
                      nBonds2 = 0
                  endif
              else
                  nats2   = 0
                  nBonds2 = 0
              endif
          else
              nats1   = 0
              nBonds1 = 0
              nats2   = 0
              nBonds2 = 0
          endif
!
!-- Atoms
          write(jdir) MaxAtoms, MaxBonds, nats1, nBonds1, NumGroup,
     *                 nats2, nBonds2, nCoordPub, nLegPub, distCoord,
     *                 iPlotType
          if (nats1 > 0) then
              call PutGetAtoms(iAction, nats1, nBonds1, nats2, nBonds2)
          endif
          if (nCoordPub > 0) then
              call PutGetAtomsPub(iAction)
          endif
!
!--Gruppi
!
          if( NumGroup.gt.0) then
              call PutGetGroup(iAction)
          endif
!
!--Parametri del pesaggio 
          call PutGetWeight(iAction)
!
!--Condizioni dell'affinamento 
          call PutGetRefi(iAction)
!
!--Limiti dei dati
          call PutGetLimit(iAction)
!          
!--Fasi finali
          if (nSetsFineDSR > 0) then
              call PutGetFinalPhasesBinary(iAction)
          endif
      else
          iAction2 = 1
          read(jdir) header, itle, cella(1:6), errcell(1:7),
     *                 nSpaceG, nSetsFineDSR, procedura,
     *                 AtmProperties, refl_info, numbModels,
     *                 nBestModels
          celltemp(1:6)  = cella(1:6)
          celltemp(7:13) = errcell(1:7)
          nstr_data = refl_info%nstr
*         write(0,*) header
*         write(0,'(20a4)') itle
*         write(0,*) cella(1:6)
*         write(0,*) errcell(1:7)
*         write(0,'(16a1)') nSpaceG
*         write(0,*) nSetsFineDSR
*         write(0,*) procedura
          if (procedura == 1) then
              ifTang = 1
              ifPatt = 0
              ifVLD  = 0
              ifMDM  = 0
          elseif (procedura == 2) then
              ifTang = 0
              ifPatt = 1
              ifVLD  = 0
              ifMDM  = 0
          elseif (procedura == 3) then
              ifTang = 0
              ifPatt = 0
              ifVLD  = 0
              ifMDM  = 1
          else
              ifTang = 0
              ifPatt = 0
              ifVLD  = 1
              nPreviousTrials = -procedura
              n_abi_model = nPreviousTrials + 1
          endif
!         read(jdir) header
!         read(jdir) itle
!         read(jdir) cella(1:6)
!         read(jdir) errcell(1:7)
!         read(jdir) nSpaceG
!         read(jdir) AtmProperties
!         read(jdir) refl_info
!
!-- Cell
!
          call CreaCellInfo(celltemp)
!
!-- Symmetry
!
          call CreaSymmetryInfo(ier)
          if (ier < 0) then
              ier = 1
              close(jdir)
              Msg = ' Error reading symmetry information'
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
              return
          endif
          write(cardDiret,'(16a1)') nSpaceG
          spacegr = init_spaceg_type(cardDiret) ! set space group in structure spacegr
!
!-- Atomic species properties
!
          call GetFromAtmStruct
!
!-- Reflections
!
          call LoadReflInfo
          nreflDim = refl_info%nrefltot
          call AllocaRiflessiNew(iAction2)
          call AllocaRiflessi(iAction2)
          call PutGetReflections(iAction)
!
!-- Atoms
!
          if (nBestModels > 0) then
              call PutGetMiglioriErre(2)
          endif
          read(jdir) MaxAtoms, MaxBonds, nats1, nBonds1, NumGroup,
     *                 nats2, nBonds2, nCoordPub, nLegPub, distCoord,
     *                 iPlotType
          if (nats1 > 0) then
              nats = nats1
              WhichModel = 1
              call PutGetAtoms(iAction, nats1, nBonds1, nats2, nBonds2)
          endif
*         if (nats2 > 0) then
*             call PutGetMiglioriErre(2)
*         endif
          if (nCoordPub > 0) then
              call PutGetAtomsPub(iAction)
              InfoOK(45) = 1
          endif
!
!--Gruppi
!
          if( NumGroup.gt.0) then
              call PutGetGroup(iAction)
          endif
!
!--Parametri del pesaggio 
          call PutGetWeight(iAction)
!
!--Condizioni dell'affinamento  
          call PutGetRefi(iAction)
!
!--Limiti dei dati 
          call PutGetLimit(iAction)
!
!--Fasi finali
          if (nSetsFineDSR > 0) then
              call PutGetFinalPhasesBinary(iAction)
          endif
!
          if (allocated(natsInModel)) then
              if (natsInModel(1) > 0) then
                  WhichModel = 1
                  call GetModel
              endif          
          endif          
          if (iprPutGet == 1) then
              call WriteCellInfo
              call WriteSymmInfo(lo)
              call WriteContInfo(j, ier)
              if (NumGroup > 0) call PrintGroup(lo)
              call PrintWeight(lo)
              call PrintRefi(lo)
              call PrintLimit(lo)
          endif
      endif
!
      close(jdir)
!
      return
  100 format('Open error #',i5,' on file ',a)
      end
! ----------------------------------------------------------------------
      subroutine PutGetMiglioriErre(iAction1)
      USE General, only : jdir
      USE Atomi, only : nats
      USE PhaseModule
      USE PhaseInterface
      USE RemoModule
!corr      USE list_model
      USE atom_type_util
!
      implicit none
      integer :: iAction1, i
!
      if (iAction1 == 1) then
          if (nBestModels > 0) then
              call MiglioriErre(7) !, i, trialvet, erreVal, ' ')
          endif
      else
          nBestModelsMax = 1
          call MiglioriErre(8, i) !, i, trialvet, erreVal, ' ')
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine PutGetAtoms(iAction, nats1, nBonds1, nats2, nBonds2)
      USE General
      USE RemoModule
      USE Molcom
      USE Atomi, only : MaxBonds
!
      implicit none
      integer :: iAction, interp, i, j, iAction2, ifin
      integer :: nats1, nBonds1, nats2, nBonds2, natsv(2), nBondsv(2)
!
      natsv(1)   = nats1
      natsv(2)   = nats2
      nBondsv(1) = nBonds1
      nBondsv(2) = nBonds2
      if (nats2 == 0) then
          ifin = 1
      else
          ifin = 2
          InfoOK(32) = 1
      endif
!
      if (iAction == 1) then
          do j=1, ifin
             write(jdir) model(j)%BTot(:,:),
     *                    model(j)%trial,
     *                    model(j)%erre,
     *                    FcScaleInModel(j),
     *                    FcBisoInModel(j),
     *                    FcExtinInModel(j),
     *                    FcPolaInModel(j),
     *                    FcTwinInModel(j),
     *                    Overall_devInModel(:,j)

             do i=1, natsInModel(j)
                write(jdir) model(j)%atoms(:,i,1),
     *                       model(j)%specie(i,1),
     *                       model(j)%th_fact(i,1),
     *                       model(j)%bij(:,i,1),
     *                       model(j)%tipoAtomo(i,1),
     *                       model(j)%tipoResiduo(i,1),
     *                       model(j)%Alternate(i,1),
     *                       model(j)%Label(i),
     *                       model(j)%catena(i,1),
     *                       model(j)%numResiduo(i,1),
     *                       model(j)%Insertion(i,1),
     *                       model(j)%SinglePlotType(i),
     *                       model(j)%IsoAniso(i,1),
     *                       model(j)%serial(i),
     *                       model(j)%iSite(i),
     *                       model(j)%SiteInfo(:,i),
     *                       model(j)%xyz_dev(:,i,1),
     *                       model(j)%occX_dev(:,i),
     *                       model(j)%th_fact_dev(i,1),
     *                       model(j)%occ_dev(i),
     *                       model(j)%bij_dev(:,i,1),
     *                       model(j)%GeomAtom(i)
             enddo
             do i=1, BondsInModel(j)
                write(jdir) Bonds(j)%Legami(1:3,i)
             enddo
          enddo
      else
          iAction2 = 1
          numbModels = 2
          call AllocaAtomi(1)
          WhichMonomer = 1
          do j=1, ifin
             WhichModel = j
             MonomerInModel(j) = 1
             BondsInModel(j) = MaxBonds
             call AllocaModelRemo(iAction2)
             call AllocaBonds(iAction2)
             natsInModel(j) = natsv(j)
             BondsInModel(j) = nBondsv(j)
             read(jdir) model(j)%BTot(:,:),
     *                   model(j)%trial,
     *                   model(j)%erre,
     *                   FcScaleInModel(j),
     *                   FcBisoInModel(j),
     *                   FcExtinInModel(j),
     *                   FcPolaInModel(j),
     *                   FcTwinInModel(j),
     *                   Overall_devInModel(:,j)

             do i=1, natsInModel(j)
                read(jdir) model(j)%atoms(:,i,1),
     *                      model(j)%specie(i,1),
     *                      model(j)%th_fact(i,1),
     *                      model(j)%bij(:,i,1),
     *                      model(j)%tipoAtomo(i,1),
     *                      model(j)%tipoResiduo(i,1),
     *                      model(j)%Alternate(i,1),
     *                      model(j)%Label(i),
     *                      model(j)%catena(i,1),
     *                      model(j)%numResiduo(i,1),
     *                      model(j)%Insertion(i,1),
     *                      model(j)%SinglePlotType(i),
     *                      model(j)%IsoAniso(i,1),
     *                      model(j)%serial(i),
     *                      model(j)%iSite(i),
     *                      model(j)%SiteInfo(:,i),
     *                      model(j)%xyz_dev(:,i,1),
     *                      model(j)%occX_dev(:,i),
     *                      model(j)%th_fact_dev(i,1),
     *                      model(j)%occ_dev(i),
     *                      model(j)%bij_dev(:,i,1),
     *                      model(j)%GeomAtom(i)
             enddo
             do i=1, BondsInModel(j)
                read(jdir) Bonds(j)%Legami(1:3,i)
             enddo
          enddo
          WhichModel = 1
          call GetModel
*         SinglePlotType(:) = SIMPLE
          InfoOK(5) = 1
          interp = 1
          call PutGetXyzs(1, interp)
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine PutGetAtomsPub(iAction)
      USE General
      USE TestModel
      USE Dialogo, only : ModelToCompare
!
      implicit none
      integer :: iAction, i, iAction2
!
      if (iAction == 1) then
          do i=1, nCoordPub
             write(jdir) nzPub(i), coordPub(1:5,i), aLabPub(i)
          enddo
          if (nLegPub > 0) then
              do i=1, nLegPub
                 write(jdir) LEPub(1:2,i)
              enddo
          endif
      else
          iAction2 = 1
          call AllocaTestModel(iAction2)
          do i=1, nCoordPub
             read(jdir) nzPub(i), coordPub(1:5,i), aLabPub(i)
          enddo
          if (nLegPub > 0) then
              do i=1, nLegPub
                 read(jdir) LEPub(1:2,i)
              enddo
          endif
          ModelToCompare = 1
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine PutGetReflections(iAction)
      USE General
      Use RiflessiNew
!
      implicit none
      integer :: iAction, i
!
      if (iAction == 1) then
          do i=1, refl_info%nreflTot
             write(jdir) refl%hkl(1:3,i),
     *                    refl%fo(i),
     *                    refl%fosq(i),
     *                    refl%sigma(i),
     *                    refl%sigmasq(i),
     *                    refl%e(i),
     *                    refl%ep(i),
     *                    refl%rho(i),
     *                    refl%fc(i),
     *                    refl%weight(i),
     *                    refl%pub(i),
     *                    refl%phase(i),
     *                    refl%phasep(i),
     *                    refl%code(i),
     *                    refl%observed(i) 
              if (kmad /= 0) then
                  write(jdir) refl%fo_meno(i),
     *                         refl%fo_piu(i),
     *                         refl%sigma_meno(i),
     *                         refl%phase_meno(i),
     *                         refl%fc_meno(i)
              endif
              if (kmad == 2 .or. ifTwin == 1) then
                  write(jdir) refl%fDeriv(i,1:nDataSets),
     *                         refl%sDeriv(i,1:nDataSets),
     *                         refl%eDeriv(i,1:nDataSets),
     *                         refl%fHeavy(i,1:nDataSets),
     *                         refl%sHeavy(i,1:nDataSets),
     *                         refl%eHeavy(i,1:nDataSets),
     *                         refl%fNativ(i),
     *                         refl%sNativ(i),
     *                         refl%eNativ(i)
              endif
          enddo
      else
          do i=1, refl_info%nreflTot
             read(jdir)  refl%hkl(1:3,i),
     *                    refl%fo(i),
     *                    refl%fosq(i),
     *                    refl%sigma(i),
     *                    refl%sigmasq(i),
     *                    refl%e(i),
     *                    refl%ep(i),
     *                    refl%rho(i),
     *                    refl%fc(i),
     *                    refl%weight(i),
     *                    refl%pub(i),
     *                    refl%phase(i),
     *                    refl%phasep(i),
     *                    refl%code(i),
     *                    refl%observed(i) 
              if (kmad /= 0) then
                  read(jdir)  refl%fo_meno(i),
     *                         refl%fo_piu(i),
     *                         refl%sigma_meno(i),
     *                         refl%phase_meno(i),
     *                         refl%fc_meno(i)
              endif
              if (kmad == 2 .or. ifTwin == 1) then
                  read(jdir)  refl%fDeriv(i,1:nDataSets),
     *                         refl%sDeriv(i,1:nDataSets),
     *                         refl%eDeriv(i,1:nDataSets),
     *                         refl%fHeavy(i,1:nDataSets),
     *                         refl%sHeavy(i,1:nDataSets),
     *                         refl%eHeavy(i,1:nDataSets),
     *                         refl%fNativ(i),
     *                         refl%sNativ(i),
     *                         refl%eNativ(i)
              endif
          enddo
          InfoOK(6) = 1
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine PutGetFinalPhasesBinary(iAction)
      USE General
      USE Riflessi
      USE PhaseModule
      USE PhaseStuff
!
      implicit none
      integer :: iAction, iAction2, i, j, n, nset
!
      if (iAction == 1) then
          call LoadFinalPhases(FomsFineDSR, iposFineDSR,
     *                         nSetsFineDSR)
          n = nReflDim
          write(jdir) nSetsFineDSR, n, FomsFineDSR, iposFineDSR
          iAction2 = 2
          do i=1, nSetsFineDSR
             j = i ! posFineDSR(i)
             call PutGetFinalPhases(iAction2, j, figMer)
             write(jdir) figMer
             write(jdir) iphaz(1:n)
             write(jdir) wt(1:n)
             write(jdir) fcvet(1:n)
          enddo
      else
          iAction2 = 1
          nset = nSetsFineDSR
          nsetFinalPhases = nSetsFineDSR
          call ManageFinalPhases(iAction2, nReflDim, nset)
          read(jdir) nSetsFineDSR, n, FomsFineDSR, iposFineDSR
          do i=1, nSetsFineDSR
             read(jdir) figMer
             read(jdir) iphaz(1:n)
             read(jdir) wt(1:n)
             read(jdir) fcvet(1:n)
             j = i ! posFineDSR(i)
             call PutGetFinalPhases(iAction2, j, figMer)
          enddo
          call UpdateFinalPhases(FomsFineDSR, iposFineDSR, nset)
          InfoOK(17) = 1
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine InitSA_sir
      USE General,     only : knw, cell, resmin, nrefl
      USE variables,   only : ortom,ortoi
      USE PhaseModule, only : ifExamin
      USE Riflessi
      USE unit_cell
!
      implicit none
      integer :: ksubr, ier, i
!
      ksubr = 2
      call LeggiRiflessi(ier, ksubr)
      ortom = orthomatrix(cell)
      ortoi = orthomatrixi(cell)
      resmin = 9999
      do i=1, nrefl
         if (rhov(i) < resmin) then
             resmin = rhov(i)
         endif
      enddo
      resmin = 0.5 / sqrt(resmin)
      if (knw > 0) then
          ifExamin = 1
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine RestoreCellContent(ier)
      USE General
!
      implicit none
      integer :: ier, puntatore(18), ifZeffDone
      real    :: zeffOrig
      common /zeffe/ ifZeffDone, zeffOrig(18)
!
      call LeggiXEN(1, puntatore, ier)
      if (neutro == 2) then
          zeff(:) = zeffOrig(:)
      endif
      call SortAtmProp
      call GetFromAtmStruct
!
      return
      end
!-------------------------------------------------------------------
      subroutine LeggiMTZPhase(ier)
      USE General
      USE Riflessi
      USE PhaseModule
      USE IsrCom
!
      implicit none
      integer :: ier, ierr, i, ii, j, kh, kk, kl, indr, jump
      integer :: idelt, jcode, isgnn, id1, ireje, phase ! , hkl(3)
      real    :: fase, peso, fc, rho, w
      logical :: ifEof
!
!
!-- probabilmente è corretta la parte commentata
!-- che serve per leggere anche i valori per gli estrapolati
!-- (se sono stati inseriti nel file mtz input per refmac)
!
*     do i=1,3
*        HklMax(i) = ihmx(i)
*        if (ihmxExt(i) > HklMax(i)) then
*            HklMax(i) = ihmxExt(i)
*        endif
!
*     enddo
*     ifat1=(2*HklMax(3)+1)*(2*HklMax(2)+1)
*     ifat2=(2*HklMax(3)+1)
*     ifatx=HklMax(1)*ifat1+HklMax(2)*ifat2+HklMax(3)
!
      ifat1=(2*ihmx(3)+1)*(2*ihmx(2)+1)
      ifat2=(2*ihmx(3)+1)
      ifatx=ihmx(1)*ifat1+ihmx(2)*ifat2+ihmx(3)
      allocate(isr(1:ifatx), stat = ier)
!
      isr(1:ifatx) = 0
!
      do i=1, nrefl
         kh = khl(1,i)
         kk = khl(2,i)
         kl = khl(3,i)
         indr = iabs( kh * ifat1 + kk * ifat2 + kl )
*        write(6,'(3i4,i10)') kh, kk, kl, indr
         isr(indr) = i
      enddo
!
*        write(6,*) 'INIZIO LETTURA'
      jump   = 0
      j = 0
!
      do
         j = j + 1
         call GetHklMTZPhase(jump, kh, kk, kl, fase, peso, fc, ifEof)

         if (ifEof) then
             exit
         endif
!
         if (jump == 1) then
             fase = 0
             peso = 0
             fc = -999
         endif
*        hkl(1) = kh ; hkl(2) = kk ; hkl(3) = kl
*        isgnn = 1
*        do i=1, 3
*           if (hkl(i) == 0) cycle
*           if (hkl(i) > 0) exit
*           isgnn = -1
*           exit
*        enddo
*        kh = kh * isgnn
*        kk = kk * isgnn
*        kl = kl * isgnn
*        fase = fase * isgnn
         call geneq(0,kh,kk,kl,idelt,jcode,isgnn,id1,rho,ireje)
         indr = iabs( kh * ifat1 + kk * ifat2 + kl )
*        write(6,'(3i4,i10)') kh, kk, kl, indr
         if (indr == 0) then
             cycle
         endif
         if (indr > ifatx) then
             cycle
         endif
         i = isr(indr)
         if (i == 0) then
             cycle
         endif
         phase = fase
         phase = phase + idelt
         phase = phase * isgnn
         phase = mod(phase, 360)
         if (phase <= 0) phase = phase + 360
         iphaz(i) = phase
         wt(i)    = peso
         fcvet(i) = fc
*        write(6,'(i8,3i4,2f10.4)') j, kh,kk,kl,fc,peso
      enddo
!
!-- x Piero e Cristina
!
*     do i=1, nrefl
*        indr = iabs( khl(1,i) * ifat1 + khl(2,i) * ifat2 + khl(3,i) )
*        iwork1(i) = i
*        work1(i) = indr
*     enddo
*     call sort_index(1, work1, iwork1, nrefl)
*     do ii=1, nrefl
*        i = iwork1(ii)
*        j = iphaz(i)
*        w = wt(i)
*        if (j < 0 .or. j > 360) then
*            j = 0
*            w = 0
*        endif
*        write(88,1) khl(1:3,i), fovet(i), sigmav(i), ipub(i), j, w
*     enddo
!
      deallocate (isr, stat = ierr)
      return
*   1 format(3i4,2f8.2,2i5,f8.5)
      end
!-------------------------------------------------------------------
      subroutine GetHklMTZPhase(jump, kh, kk, kl, fase, peso, fc, ifEof)
      USE General
!
      implicit none
      integer :: jump, kh, kk, kl, i, j
      real    :: fase, peso, fc, resolution
      logical :: ifEof, is_a_NaN, IsItaNaN
!
      call lrrefl(MTZunit, resolution, MTZdata, ifEof)
      if (ifEof) then
          return
      endif
      jump = 0
      kh    = MTZdata(MTZlookup(1))
      kk    = MTZdata(MTZlookup(2))
      kl    = MTZdata(MTZlookup(3))
      do j=4,5
         i = MTZlookup(j)
         is_a_NaN = IsItaNaN(MTZdata(i))
         if (is_a_NaN) then
            jump = 1
         end if
      enddo
      do j=8,9
         i = MTZlookup(j)
         if (i == 0) exit
         is_a_NaN = IsItaNaN(MTZdata(i))
         if (is_a_NaN) then
            jump = 1
         end if
      enddo
      if (jump == 0) then
          if (knw == 1) then
              fase = MTZdata(MTZlookup(7))
              peso = MTZdata(MTZlookup(8))
              fc   = MTZdata(MTZlookup(9))
          else
              fase = MTZdata(MTZlookup(6))
              peso = MTZdata(MTZlookup(7))
              fc   = MTZdata(MTZlookup(8))
          endif
      else
          fase  = -999.99
          peso = -999.99
      end if
!
      return
      end
!-----------------------------------------------------------------------
      subroutine FromShelxToSir(file1, nomeStr, ier)
      USE General
      USE Symmetry
      USE Molcom
      USE Direttive
!
      implicit none
      integer :: ier, itipo, iform, jop, jopen, Lung, found
      integer :: ifRefl, nsymTemp, lattTemp, icentTemp, nats
      integer :: i, j, kcentr(7), L, k, kcont, irefl, nExitC
      real    :: celltemp(13), wave
      logical :: Esiste
      character (len=*)  :: file1, nomeStr
      character (len=16) :: space
!
      nsymTemp = 1
      lattTemp = 1
      icentTemp = 1
!
      write(lo,2) file1(1:Lung(file1))
      card(:) = ' '
      itipo = 2
      iform = 1
      jop = jopen(jhost, file1, itipo, iform, ier)
      if (ier < 0) then
          Msg = 'Error processing Shelx file ' // file1(1:Lung(file1))
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
          return
      endif
      call LeggiShelxinMem(ifRefl, celltemp, nsymTemp, lattTemp,
     *                           icentTemp, nats, wave, ier)
      if (ier < 0) then
          Msg = 'Error processing Shelx file ' // file1(1:Lung(file1))
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
          return
      endif
! 

      do i=2,6
         kcentr(i) = 2
      enddo
      kcentr(1) = 1
      kcentr(6) = 4
      kcentr(7) = 3
      latt = lattTemp
      ncentr = kcentr(latt)
      nsym =  nsymTemp
      icent = icentTemp
      pts = ncentr
      close(jhost)
      close(jgrap, err = 1)
!
!-- Write sir file
!
    1 continue
      call ManageSymmCards(ier)
      if (ier < 0) then
          Msg = 'Error processing Shelx file ' // file1(1:Lung(file1))
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
          return
      endif
      call FromSymmCardsToSpaceGroupSymbol(found)
      ReflFileName = fname(2)(1:Lung(fname(2)))
!
!-- Check for missing data
!
      do i=1, 6
         if (celltemp(i) < 0.001) then
             ier = -1
             write(Inte,100) ' Wrong or missing CELL card'
         endif
      enddo
      write(space,'(16a1)') nSpaceG(1:16)
      if (space(1:1) == ' ') then
          write(Inte,100) ' Wrong or missing SYMM card'
          ier = -1
      endif
      if (Species(1)(1:1) == ' ') then
          write(Inte,100) ' Wrong or missing SFAC or UNIT card'
          ier = -1
      endif
      if (nw(1) == 0) then
          write(Inte,100) ' Wrong or missing SFAC or UNIT card'
          ier = -1
      endif
      inquire (file=ReflFileName,  exist = Esiste)
      if (.not. Esiste) then
          k = index(ReflFileName,'.',.TRUE.)
          ReflFileName(k+1:k+3) = 'HKL'
          inquire (file=ReflFileName,  exist = Esiste)
          if (.not. Esiste) then
              Msg = 'Open error on ' //  ReflFileName(1:k-1) //
     *              '.hkl or ' // ReflFileName(1:k-1) // '.HKL'
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
              ier = -1
          endif
      endif
      if (ier < 0) then
          write(lo,120) Inte(1:Lung(Inte))
          Msg = 'Error processing Shelx file ' // 
     *          file1(1:Lung(file1))
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
          return
      endif
!
      cardImage = nomeStr(1:Lung(nomeStr)) // '_sir.sir'
      write(lo,3) cardImage(1:Lung(cardImage))
!
      itipo = 0
      iform = 1
      jop = jopen(jhost, cardImage, itipo, iform, ier)
      call sirdate(direttiva, L)
      k = Lung(fname(14))
      write(jhost,5) ProgName(1:lProgName), direttiva(1:L),
     *               fname(14)(1:k)
!
!-- %Job
!
      write(jhost,10) Titolo(1:Lung(Titolo))
!
!-- %Structure
!
      write(jhost,20) nomeStr(1:Lung(nomeStr))
!
!-- %Data
!
      write(jhost,30) '%Data'
!
!-- cell
!
      write(Inte,'(6f10.4)') celltemp(1:6)
      call OneBlankOnly(Inte)
      write(jhost,40) Inte(1:Lung(Inte))
      j = 1
      write(card(j),40) Inte(1:Lung(Inte))
!
!-- errors
!
      if (sum(celltemp(7:12)) > 0.001) then
          write(Inte,'(6f9.4)') celltemp(7:12)
          call OneBlankOnly(Inte)
          write(jhost,45) Inte(1:Lung(Inte))
          j = j + 1
          write(card(j),45) Inte(1:Lung(Inte))
      endif
      j = j + 1
!
!-- spacegroup
!
      if (found == 1) then
          write(jhost,50) space
          write(card(j),50) space
      endif
!
!-- content
!
      do i=1, nk
         call lcase(Species(i))
         call ucase(Species(i)(1:1))
      enddo
      write(Msg,'(18(a4,2x,i5,2x))') (Species(i), nw(i), i=1, nk)
      call OneBlankOnly(Msg)
      write(jhost,60) Msg(1:Lung(Msg))
      j = j + 1
      write(card(j),60) Msg(1:Lung(Msg))
!
!-- reflections
!
      write(jhost,70) ReflFileName(1:Lung(ReflFileName))
      j = j + 1
      write(card(j),70) ReflFileName(1:Lung(ReflFileName))
      j = j + 1
!
!-- Fobs / Fosq
!
      if (ifo2 == 1) then
          write(jhost,75)
          write(card(j),75)
      else
          write(jhost,76)
          write(card(j),76)
      endif
!
!-- Wavelength
!
      write(jhost,80) wave
      j = j + 1
      write(card(j),80) wave
!
!-- %Phase
!
      write(jhost,30) '%Phase'
!
!-- %End
!
      write(jhost,30) '%End'
      close(jhost)
      do i=1, j
         call shift(card(i), L)
      enddo
!
      icomat = 0
      ipdir  = 0
      icomq(1,1) = 23  ! %data
      icomq(1,2) = j
      icomq(2,1) = 4   ! %phase
      icomq(2,2) = 0
      icomq(3,1) = 7   ! %end
      icomq(3,2) = 0
      ipcom = 3
!
      irefl = 1
      kcont = 1
      call InitialOutPut(irefl, kcont, ier)
!
      return
    2 format(' ',78('*'),//,' ','Creating Sir input from Shelx file:',
     *       ' ',a,//,' Shelx commands:')
    3 format(/,' ','Created Sir input file: ',a,/)
    5 format('!  ',/,
     *       '!  Sir file produced by ',a,' on ',a,/,
     *       '!  Using the Shelx file ',/,
     *       '!  ',a,/,'!')
   10 format('%Job ',a)
   20 format('%Structure ',a)
   30 format(a)
   40 format('   Cell ',a)
   45 format('   Errors ',a)
   50 format('   SpaceGroup ',a)
   60 format('   Content ',a)
   70 format('   Reflections ',a)
   75 format('   Fobs')
   76 format('   Fosq')
   80 format('   Wavelength ',f8.5)
  100 format(a)
  120 format(5x,'  ***** Error ***** ',a)
      end
!-----------------------------------------------------------------------
      subroutine InitialOutPut(irefl, kcont, ier)
      USE General
      USE Direttive
      USE Molcom
      USE commandsmod
      USE PhaseModule, only : ifReduced
!
      implicit none
      integer :: jfour, i, j, jj, nc, Lung, lspazio, ier, nrec
      integer :: NewFileBin, nchar, ierr, nExitC
      integer :: jopen, jop, itipo, iform, kcont, irefl 
      logical :: Esiste, EsisteProgramma
      character (len= 4) :: spazio, com4
      character (len=80) :: buffer
!
      if (ifFromShelx == 1) then
          write(lo,215) Titolo
      endif
      call wrhead
!
      NewFileBin = 0
      NewFileBin = 1
      spazio = ' '
      lspazio = 1
      jfour = 0
      write(lo,10)
      jj = 0
      do i=1,ipcom
         cardImage = blank
         j = icomq(i,1)
         if (j == 6) then
             jfour = 1
         endif
         write(cardImage(1:26),'(11x,a1,a14)') beg,allcom(j)
         if (icomq(i,2) == 0) then
             direttiva = 'default'
             if (icomq(i,1) == 7) then
                 direttiva = ' '
             elseif (icomq(i,1) == 1) then
                 direttiva = 'Obsolete: ignored!'
             elseif (icomq(i,1) == 5) then
                 direttiva = 'Obsolete: ignored!'
             elseif (icomq(i,1) == 6) then
                 direttiva = 'Obsolete: ignored!'
             elseif (icomq(i,1) == 14) then
                 direttiva = 'Obsolete: ignored!'
             elseif (icomq(i,1) == 50) then
                 direttiva = filePDB(1:Lung(filePDB))
             endif
             if (icomq(i,1) /= 10) then
                 write(cardImage(29:),'(a)') 
     *                 direttiva(1:Lung(direttiva))
                 write(lo,'(/,a)') cardImage(1:Lung(cardImage))
             endif
         else
             if (icomq(i,1) ==  1.or.
     *           icomq(i,1) ==  5.or.
     *           icomq(i,1) ==  6.or.
     *           icomq(i,1) == 14) then
                 direttiva = 'Obsolete: ignored!'
                 write(cardImage(29:),'(a18)') 
     *                 direttiva(1:Lung(direttiva))
                 write(lo,'(/,a)') cardImage(1:Lung(cardImage))
                 do j=1,icomq(i,2)
                    jj = jj + 1
                 enddo
             else
                 do j=1,icomq(i,2)
                    jj = jj + 1
                    nc = 0
                    call onebl(card(jj),nc,ier)
                    buffer = card(jj)(1:nc)
                    call lcase(buffer)
                    if (buffer(1:4) == 'spac' .and. ifReduced == 1) then
                        Msg = card(jj)(1:nc)//
     *                        '  ( will be solved in P 1)'
                        nc = nc + 26
                    else
                        Msg = card(jj)(1:nc)
                    endif
                    if (buffer(1:4) == 'endm') then
                        lspazio = 1
                    endif
                    if (j == 1) then
                        write(lo,'(/,a)') cardImage(1:27) //
     *                                      spazio(1:lspazio)//Msg(1:nc)
                    else
                        write(lo,'(27x,a)') spazio(1:lspazio)//Msg(1:nc)
                    endif
                    if (buffer(1:4) == 'mode') then
                        lspazio = 4
                    endif
                 enddo
             endif
         endif
      enddo
!
      if (kscreen == 1) then
!!mr      if (ifWillMad >= 1 then .or. ifWasRemo == 1) then
          if (ifWillMad >= 1) then 
              call NascondiToolbar(0)
          else
              call RunToolBar(0,' ')
          endif
!!mr      if (ifWillMad == 0 .and. ifWasRemo /= 1) then
!!mr          call RunToolBar(0,' ')
!!mr      endif

      endif
!
!
!-- check if refmac and arp/warp are installed
!
       Esiste = EsisteProgramma("refmac5")
       if (Esiste) then
           ifREFMAC = 1
           Esiste = EsisteProgramma("auto_tracing.sh")
           if (Esiste) then
               ifARPWARP = 1
           endif
           Esiste = EsisteProgramma("coot")
           if (Esiste) then
               ifCOOT = 1
           endif
           Esiste = EsisteProgramma("cbuccaneer")
           if (Esiste) then
               ifBUCCANEER = 1
           endif
           Esiste = EsisteProgramma("phenix.autobuild")
           if (Esiste) then
               ifPHENIX = 1
           endif
           Esiste = EsisteProgramma("cnautilus")
           if (Esiste) then
               ifNAUTILUS = 1
           endif
       endif
       if (ifAmb > 0) then
           if (ifREFMAC == 1) then
               if (ifAmb == 1) then
                   write(lo,280) '(Buccaneer)'
                   if (ifBUCCANEER == 0) then
                       write(lo,286)
                       ifAmb = 0
                   endif
               elseif (ifAmb == 2) then
                   write(lo,280) '(ARP/wARP)'
                   if (ifARPWARP == 0) then
                       write(lo,286)
                       ifAmb = 0
                   endif
               elseif (ifAmb == 3) then
                   write(lo,280) '(Phenix)'
                   if (ifPHENIX == 0) then
                       write(lo,286)
                       ifAmb = 0
                   endif
               elseif (ifAmb == 4) then
                   write(lo,280) '(Nautilus)'
                   if (ifNAUTILUS == 0) then
                       write(lo,286)
                       ifAmb = 0
                   endif
               endif
           else
               write(lo,285)
               ifAmb = 0
           endif
       endif
       ifAmbSav = ifAmb
!
      call DrawInitialPixmap()
      call DoSingleIteration()
!
      write(lo,290) ProgName(1:lProgName),
     *              ln,fname(14)(1:Lung(fname(14))),
     *              lo,fname(15)(1:Lung(fname(15))),
     *            jdir,fname( 1)(1:Lung(fname( 1))),iscra,jrel
      if (irefl == 1) then
          write(lo,300) jfile,ReflFileName(1:Lung(ReflFileName))
      elseif (irefl == 2) then
          write(lo,301) jfile,ReflFileName(1:Lung(ReflFileName))
      endif

      if (kcont == 1)  then
          write(lo,310) kform, ffile(1:Lung(ffile)), ReleaseXen
      endif
      if (jfour == 1)  write(lo,320) jhost,fname(3)(1:Lung(fname(3))),
     *                               jgrap,fname(4)(1:Lung(fname(4))),
     *                               ifour
  270 format(' Open error, code =',i5,' file is ',a)
  280 format(/,10x,' Automated Model Building required ',a)
  286 format(  10x,' ... but not installed')
  285 format(/,10x,' Automated Model Building required but non applied:'
     *      ,/,10x,' Refmac and/or Buccaneer and/or ARP/wARP'
     *             ' not installed.')
  290 format(//,   ' Files used in ',a,':',//,
     *     '  Channel                                  Name',/,
     1            i6,'    instruction input file           ',a,/,
     1            i6,'    printer output file              ',a,/,
     3            i6,'    project file                     ',a,/,
     4            i6,'    direct access scratch file',/,
     5            i6,'    sequential scratch file ')
  300 format(     i6,'    reflections input file           ',a)
  301 format(     i6,'    reflections from MTZ file        ',a)
  310 format(     i6,'    scattering factors file          ',a,
     1     /, 6x,    '    ( Release : ',a5,' )')
  320 format(     i6,'    fourier peaks file               ',a,/,
     *            i6,'    peaks file to be plotted         ',a,/,
     *            i6,'    sequential scratch file ',//)
*gl*  write(lo,'(/)')
      if (NewFileBin /= 1) then
          write(lo,340)
          call summar(ier)
          if (ier < 0) then
              return
          endif
          call AbInfo(0)
      endif
  340 format(6x,'Project file actually contains:'/)
!
      ipdir  = 0
      icomat = 0
      if (ier == 0) then
          ifProject = 1
      endif
!
      call create_commands(commands,ipcom,icomq,card)
!
      return
 7000 nrec=1
      write(Msg,7100) ierr,nrec,ffile(1:Lung(ffile))
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitC)
      ier = -2
      return
   10 format(' Used commands & directives:',/)
  215 format(' ',78('*'),/,' ',a,//)
 7100 format(' Error ',i5,' reading record #',i3,' in file ',a)
 8100 format(' %RETURN command out of sequence')
      end
!-----------------------------------------------------------------------
      subroutine WriteContLine
      USE General
!
      implicit none
      integer :: i, Lung
!
      write(cardImage,10) (Species(i), nw(i), i=1,nk)
      call OneBlankOnly(cardImage)
      write(lo,'(a)') cardImage(1:Lung(cardImage))
   10 format('Content ',18(a4,i5,2x))
!
      return
      end
!-----------------------------------------------------------------------
      subroutine cudadetect()
      USE General 
      USE Atomi
      USE Molcom
!
      call cudadetectc(gpuhard)
      call setcuda(cuda, gpuhard)
!
      if (cuda .eq. 0 .and. gpuhard .eq. 1 )then
        if (jscreen == 1)then
          Msg = ' '
          write(Msg,"('        GPU Device(s) present.              '
     *                '                                            '
     *                'Running using %cuda might be faster',i6)")
          call MsgWinErr('Info', Msg, INFO_WINDOW, nExitCode)
          Msg = ' '
        else
          write(0,'(a)') '                                             '
          write(0,'(a)') '*********************************************'
          write(0,'(a)') '*  ------------  INFO  --------------       *'
          write(0,'(a)') '*       GPU Device(s) present               *'
          write(0,'(a)') '* Running using %cuda might be much faster  *'
          write(0,'(a)') '*********************************************'
          write(0,'(a)') '                                             '
        end if
      endif
      if (cuda .eq. 1 .and. gpuhard .eq. 0 )then
        if (jscreen == 1)then
          Msg = ' '
          write(Msg,"('  CUDA was requested but no supported       '
     *                '        GPU hardware found                  '
     *                '    Continuing without CUDA...        ',i6)")
          call MsgWinErr('WARNING', Msg, INFO_WINDOW, nExitCode)
          Msg = ' '
        else
          write(0,'(a)') '                                             '
          write(0,'(a)') '*********************************************'
          write(0,'(a)') '*  ------------ WARNING -------------       *'
          write(0,'(a)') '* CUDA was requested but no supported GPU   *'
          write(0,'(a)') '* hardware found. Continuing without CUDA   *'
          write(0,'(a)') '*********************************************'
          write(0,'(a)') '                                             '
        end if
      endif
!
      end
!-----------------------------------------------------------------------
