      subroutine testLSQ(jCycle, iAction, code, nreflX)
      USE General
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE TestModel
      USE Dialogo, only : ModelToCompare
!
!-- jCycle        LSQ cycle
!-- iAction = 1   only phase error
!-- iAction = 2   phase error and check on published coordinates
!-- Code          if positive also enantiomorh phase error is printed
!
      integer Code, PrintCode
!
      if (iAction == 1) then
          if (Code > 0) then
              PrintCode = Code
              ifmin = 1
          else
              PrintCode = 0
              ifmin = 0
          endif
          call examin(Code,mkang,khl,ipub,iphaz,nreflX,0,wt,ifmin)
          if (PrintCode == 0) then
              write(lo,10) jCycle, erore, erorepes, isumal, rflsq, n5
          endif
      else
          if (Code > 0) then
              PrintCode = 1
          else
              PrintCode = -1
          endif
          if (ModelToCompare > 0) then
              call to_coord_sir(PrintCode, nreflX)
              if (PrintCode == -1) then
                  nused = nats
                  perc = 100.0 * vett_test(3) / float(nused)
                  write(lo,20)  nused, nint(vett_test(3)), vett_test(4),
     *                          erore, erorepes, isumal, rflsq
              endif
          endif
      endif
!
      return
   10 format(' Cycle',i3,
     *       ' MPE ',f6.2,' (',f6.2,') over',i8,' R% =',f8.3,i6)
   20 format('Atoms used: ',i5,', found: ',i5,', <dist> =', f9.4,
     *       ' MPE ',f6.2,' (',f6.2,') over',i8,' R% =',f8.3)
      end
!-----------------------------------------------------------------------
      subroutine Trasla_Origine(numb)
      USE General
      USE Riflessi
      USE PhaseModule
!
      if (ifReduced == 1) then
          return
      endif
c
      if (knw.eq.0) then
          return
      endif
c
      if (ifTime == 1) then
          return
      endif
!
      SetSav = setmin
      ErrSav = erm1min
      eroreSav = erore
      erorepesSav = erorepes
      isumalSav = isumal
!
      ifExamin_old = ifExamin
      ifExamin = 1
      if (kverbo.gt.0) then
!     if (kverbo.gt.-99) then
          ifmin = 1
      else
          ifmin = 0
      endif

      izero = 0
      nuset = 333 
      call examin(nuset,mkang,khl,ipub,iphaz,numb,izero,wt,ifmin)
      if (kverbo.gt.0) then
          write(6,*) 'Trasla Origine - Shift',shiftexam(1:3)
      endif
      do i=1,numb
         phih = iphaz(i)*dtor
         delta = khl(1,i)*shiftexam(1)+khl(2,i)*shiftexam(2)
     *                          +khl(3,i)*shiftexam(3)
***      phihr = (phih - 2.0*pi*delta) * shiftexam(4)
         phihr = shiftexam(4) * phih - 2.0 * pi * delta
         iphaz(i) = nint(phihr*rtod)+360000
         iphaz(i) = mod(iphaz(i),360)
      enddo
c
      if (kverbo.gt.0) then
!     if (kverbo.gt.-99) then
          ifmin = 1
          izero = 0
          nuset =  444 
          call examin(nuset,mkang,khl,ipub,iphaz,numb,izero,wt,ifmin)
      endif
c
      call toflush() 
      ifExamin = ifExamin_old
!
      setmin  = SetSav
      erm1min = ErrSav
      erore = eroreSav
      erorepes = erorepesSav
      isumal = isumalSav
!
      return
      end
! ----------------------------------------------------------------------
      subroutine TraslaCoords()
      USE General
      USE Symmetry
      USE Atomi
      USE PhaseModule
      USE Molcom
      USE TestModel
!
      real s(3), xo(3), xn(3), xeq(3), vet(2), xoo(3), xon(3), xpub(3)
!
      if (knw == 0 .or. ifExamin == 0) then
          return
      endif
!
      do i=1, nats
         xyzs(1:3,i) = shiftexam(4) * xyzs(1:3,i) - shiftexam(1:3)
      enddo
!
      call Trasla_Origine(nrefl)
!
      call to_coord_sir(1,nrefl)
      do j=1,nats
         xyzs(1:3,j) = coordSir(1:3,j)
      enddo

      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1
      do j=1, nats
         xo(1:3) = xyzs(1:3,j)
         if (npunt(j).eq.0) cycle
         l = npunt(j)
         xn(1:3) = coordPub(1:3,l)
         call MoltMatVec(rm, xn, xpub)
         dmin = 9999.
         iOK = 0
         do ix = -1, 1
         do iy = -1, 1
         do iz = -1, 1
         do kt=1, ncentr
            do ifi=1, ifin
               coef = vet(ifi)
               do k=1, nsym
!                 if (k.eq.1.and.ifi.eq.1.and.kt.eq.1.and.
!    *                ix.eq.0.and.iy.eq.0.and.iz.eq.0) cycle
                  call xequi(xo,k,coef,xeq,kt)
                  xeq(1) = xeq(1) + ix
                  xeq(2) = xeq(2) + iy
                  xeq(3) = xeq(3) + iz
                  call MoltMatVec(rm, xeq, xoo)
                  dist = 0.
                  do i = 1, 3
                     dist = dist + (xoo(i)-xpub(i))**2
                  enddo
                  dist = sqrt(dist)
                  if (dist < dmin) then
                      dmin = dist
                      xon(1:3) = xeq(1:3)
                      iOK = 1
                  endif
               enddo
            enddo
         enddo
         enddo
         enddo
         enddo
         if (iOK == 1) then
             write(6,11) j,xyzs(1:3,j),coordPub(1:3,l),xon,dmin
             xyzs(1:3,j) =  xon(1:3)
         endif
      enddo
   11 format(i5,4(3f10.4,5x))


!     do j=1, nats
!        xo(1:3) = xyzs(1:3,j)
!        if (npunt(j).ne.0) then
!            l = npunt(j)
!            xeq(1:3) = coordPub(1:3,l)
!            call xdist(xo,xeq,d,s)
!            write(lo,300)
!    *             aLab(j)(1:8),(coordSir(k,j),k=1,3),aLabPub(l)(1:8),l,
!    &             (coordPub(k,l),k=1,3),distv(j),s
!        endif
!     enddo

      kblock(1:nats) = 1
      kaction=5
      call build(kaction,2)
      interp = 1
!
  300 format(a8,3f6.3,7x,a8,i3,2x,3f6.3,4f10.5)
      return
      end
! ----------------------------------------------------------------------
      subroutine to_coord_Patt(ksezold)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE TestModel
      USE Dialogo, only: ModelToCompare
!
      dimension vet(40),ivet(40)
      character tipo*2,line*80,dire*80
      character a
      character patom*256
      dimension xn(3),xo(3),xeq(3),s(3),xeq1(3)
c
*     real, allocatable :: distv(:)
*     integer, allocatable :: npunt(:)
c      
      if (knw <= 0) return
      if (jsys == 1) return
c
*     IF (.NOT.ALLOCATED(distv)) ALLOCATE (distv(1:nats15),stat = ierr)
*     IF (.NOT.ALLOCATED(npunt)) ALLOCATE (npunt(1:nats15),stat = ierr)
      nats_Save = nats
!
! --- legge il file .fra (se non e' gia' stato caricato il modello)
!


      if (ModelToCompare == 0) then
          kpath = Lung(FraFilePath)
          ifName = 0
          if (kpath < 1) then
              if (ifW95 == 0) then
*                 if (ksize > 3) then
*                     FraFilePath = '/server/public/proteins/frag/'
*                 else
*                     FraFilePath = '/server/public/strutture/frag/'
*                 endif
              else
                  FraFilePath = ReflFilePath
              endif
              kpath = Lung(FraFilePath)
          else
              ifName = index(FraFilePath, '.fra', .TRUE.)
          endif

          if (ifName <= 0) then
              kpath = Lung(FraFilePath)
              k=index(fname(1),'.bin')
              patom = FraFilePath(1:kpath)//fname(1)(1:k)//'fra'
          else
              patom = FraFilePath
          endif
!
          FraFilePath = patom   ! FraFilePath deve contenere anche il nome del file
!
          call AllocaTestModel(1)  


! per file nello stesso direttorio
!         patom = fname(1)(1:k)//'fra'
! per file nello stesso direttorio

          open(unit=kform,file=patom,status='old',err=8000)
!
          natcoo=0
          do 
             read(kform,'(a)',end=2) line
             call shift(line,ls)
             iasc = ichar(line(1:1))
             if (iasc .eq. 26) then
                 exit
             end if
             a = line(1:1)
             if (a == '!' .or. a == '>') then
                cycle
             end if
             natcoo=natcoo+1
             call cutst(line,lenp,dire,lend)
             aLabPub(natcoo) = dire(1:lend)
             iopt=0
             call getnum(line,vet,ivet,iv,iopt)
             do i=1,3
                coordPub(i,natcoo)=side(vet(i))
             enddo
!            if (natcoo < 100) then
                 cycle
!            else
!                kpatom = Lung(patom)
!                write(6,*) 'WARNING : max. 100 atoms in ',patom(1:kpatom)
!                exit
!            endif
          enddo
    2     close(kform)

!         nats = nats15
      else
          natcoo = nCoordPub
!- dedi
          if (.not. allocated(npunt)) then   !non va bene se nats15 > natcoo
              call AllocaTestModel(1)
          endif
!- dedi
      endif
c     nats = nats15
      nats = min0(nCoord,nats15)   ! dedi 20/01/12 - per non sfondare il vettore npunt
!
!-- considera solo le posizioni degli atomi pesanti (se ci sono)
!
      if (ifPivot == 0) then
          nzMax = maxval(nzPub(1:natcoo))
          if (nzMax > 0) then
            if (no(nzMax) >= 16) then
              do i=1, natcoo
                 if (no(nzPub(i)) < 16) then
                
                     nzPub(i) = -nzPub(i)
                 endif
              enddo
            endif
          endif
      endif
!
! --- applica lo shift alle coordinate SIR
!
      npunt(:) = 0
!     dddmin = 0.6    !0.99
      dddmin = 0.99
      kstampa = 0
!
! --- calcola le distanze minime
!
      if (ifPivot == 2) then
          nats = 1
          dddmin = 1.99
      endif

      do i=1,min0(nats, size(npunt))
         if (ifPivot /= 2) then
             x1 = side(xyzs(1,i))
             y1 = side(xyzs(2,i))
             z1 = side(xyzs(3,i))
         else
             x1 = coord_temp(1)
             y1 = coord_temp(2)
             z1 = coord_temp(3)
         endif
         distm=9999
         jpunt = 0
         if (npunt(i).eq.0) then
             do j=1,natcoo
                if (nzPub(j) < 0) cycle
                do k=1,3
                   xo(k) = coordPub(k,j)
                   if(k==ksezold) xo(k)=0.0
                enddo
                do k=1,nsymTotRoc
                  call oper(k,xeq1,x1,y1,z1)
                  do k1=1,nOrigRoxiRoc
                    do j1=1,3
                      termm=xeq1(j1)+taboRoc(k1,j1)
                      xeq(j1)=side(termm)
                      if(j1==ksezold) xeq(j1)=0.0
                    enddo
                    call xdist(xo,xeq,d,s)
                    if(d.lt.distm.and.d.lt.dddmin) then
                       distm=d
                       npunt(i) = j
                       distv(i) = distm
                       kstampa = 1
                    endif
                  enddo
                enddo
             enddo
         endif
      enddo

!     kstampa = 1
      if (kstampa.ne.0) then
         write(lo,200)
         do j=1,min0(nats,size(npunt))
            if (npunt(j).ne.0) then
                l = npunt(j)
                if (ifPivot /= 2) then
                write(lo,310) j,(xyzs(k,j),k=1,3),aLabPub(l),l,
     &                 (coordPub(k,l),k=1,3),distv(j)
                else
                    write(lo,310) j,x1,y1,z1,aLabPub(l),l,
     &                    (coordPub(k,l),k=1,3),distv(j)
                endif
            endif
         enddo
      endif
  200 format('  --- SIR peaks  ---------         ',
     *       '------ publ. coord. -------    distance')
  310 format(i6,2x,3f6.3,7x,a8,i4,2x,3f6.3,f10.5)
!
*     DEALLOCATE(distv,npunt,stat =ierr)
!
      nats = nats_Save
      nzPub(1:natcoo) = iabs(nzPub(1:natcoo))
      call toflush()
      return
!
 8000 continue
      if (knw > 0) then
          kpatom = Lung(patom)
          write(lo,8100) patom(1:kpatom)
      endif
 8100 format(/,' OPEN ERROR - file: ',a,
     *       /,'Match between model and fragment is not possible !!!',/)
!     stop 1122
      return

      end
c--------------------------------------------------------------
      subroutine VecchiaExamin()
      USE Symmetry
      dimension nstep(3)
!
      npol = 0
      tabo = 0
      do i=1,3
         if (vpol(i) == 1) then
             tabo(1:8,i) = 256
             nstep(i) = 2
         else
             nstep(i) = 1
         endif
      enddo
      do kx = 0, 1, nstep(1)
         do ky = 0, 1, nstep(2)
            do kz = 0, 1, nstep(3)
               nOrigRoxi = nOrigRoxi + 1
               if (vpol(1) == 0) then
                   tabo(nOrigRoxi,1) = float(kx)*0.5
               endif
               if (vpol(2) == 0) then
                   tabo(nOrigRoxi,2) = float(ky)*0.5
               endif
               if (vpol(3) == 0) then
                   tabo(nOrigRoxi,3) = float(kz)*0.5
               endif
            enddo
         enddo
      enddo
!
      return
      end
c-----------------------------------------------------------------------
      subroutine Scrivi_Mappa_Vera(tipoMappa)
      USE General
      USE Mappa
      USE PhaseModule

c--   tipoMappa = 1  --> Patterson
c--   tipoMappa = 2  --> Fourier
!
      integer tipoMappa

!
      if (knw == 0 .and. ifRemo == 0 .and. tipoMappa == 2) then
          return
      endif
!
      itipo = 0
      iform = 2
      if (tipoMappa.eq.1) then
          jop =jopen(jgrap,fname(7),itipo,iform,ios)
      else
          jop =jopen(jgrap,fname(6),itipo,iform,ios)
      endif
      if (jop.lt.0) then
          call cstop('Errore in Scrivi_Mappa_Vera')
      endif
!
      nnx=np(1)-1
      nny=np(2)-1
      nnz=np(3)-1

      do iz=0,nnz
         do iy=0,nny
            write(jgrap) (xmap(ix,iy,iz),ix=0,nnx)
        enddo
      enddo

!
      close(jgrap)
!
      return
      end
c-----------------------------------------------------------------------
      subroutine Calcola_CC_Mappa(numb,correl,kstp,tipoMappa)
      USE General
      USE Riflessi
      USE Mappa
      USE PhaseModule
!
!--   tipoMappa = 1  --> Patterson
!--   tipoMappa = 2  --> Fourier
!
      integer tipoMappa
      real shiftexamSav(7)
      real, allocatable :: store(:)
c
      correl = -99.9
      if (ifReduced == 1) then
          return
      endif
      if (knw == 0 .or. ifTime == 1 .or. ifReduced == 1) then
          return
      endif
c
      iwork1(:) = iphaz(:)
      err_sav = erore
      errpes_sav = erorepes
      shiftexamSav(:) = shiftexam(:)
!
      ifmin = 0
      call Trasla_Origine(numb)
c
c--calcolo originale, nel diretto (piu' lento)
c
      ispeed=0
      if (ispeed == 0) then
        do i = 1, numb
           fcoef(i)  = fovet(i) * wt(i)
        enddo
!
        jpatt = 0
        call MakeMap(fcoef, iphaz, numb, jpatt, xmap,
     *                FORTH, BACK)
!
        itipo = 2
        iform = 2
        if (tipoMappa.eq.1) then
            jop =jopen(jgrap,fname(7),itipo,iform,ios)
        else
            jop =jopen(jgrap,fname(6),itipo,iform,ios)
        endif
        if (jop.lt.0) then
          call cstop('Errore in Calcola_CC_Mappa')
        endif
!
        nnx=np(1)-1
        nny=np(2)-1
        nnz=np(3)-1

        allocate(store(1:nnx+1), stat=ier)

        npunti=0
        vmedt=0.0
        vmedc=0.0
        vmedtc=0.0
        vmed2t=0.0
        vmed2c=0.0

        do iz=0,nnz
           do iy=0,nny
              read(jgrap) (store(ix),ix=1,nnx+1)
              do ix=0,nnx
                 npunti=npunti+1
                 xx1=store(ix+1)
                 xx2=xmap(ix,iy,iz)
                 vmedt=vmedt + xx1
                 vmedc=vmedc + xx2
                 vmedtc=vmedtc + xx1 * xx2
                 vmed2t=vmed2t + xx1 * xx1
                 vmed2c=vmed2c + xx2 * xx2
            enddo
          enddo
        enddo

        vmedt=vmedt/float(npunti)
        vmedc=vmedc/float(npunti)
        vmedtc=vmedtc/float(npunti)
        vmed2t=vmed2t/float(npunti)
        vmed2c=vmed2c/float(npunti)
c--occhio
c       write(6,'(a,3f15.1)') 'Media',vmed2t,vmed2c,vmedtc
c--occhio
        rnum=vmedtc - (vmedt*vmedc)
        arg1 = vmed2t - vmedt ** 2
        arg2 = vmed2c - vmedc ** 2
        rden=sqrt(arg1) * sqrt(arg2)
        correl=rnum/rden
c       if (correl.lt.0.0) then
c           correl = 0.0
c       endif
        close(jgrap)
!
        deallocate(store, stat=ier)
!
croc
c       iphazo(1:numb) = iphaz(1:numb)
c       call InvMap(khl,mkang,iwork2,fcvet,numb)
c       call cc_vet(fovet, fcvet, numb, Fcorre)
c       iphaz(1:numb) = iphazo(1:numb)
croc
      else
c
c--calcolo piu' veloce, a partire dall'errore di fase
c
        asum1=0.0
        asum2=0.0
        asum3=0.0
        do i=1,numb
c elimino il riflesso 0 0 0
          isum=khl(1,i)+khl(2,i)+khl(3,i)
          if(isum==0) cycle
c faccio le somme
          deltaph=iphaz(i)-ipub(i)
          aterm=cos(dtor*deltaph)
          asum1=asum1+wt(i)*evet(i)*evet(i)*aterm
          asum2=asum2+evet(i)*evet(i)
          asum3=asum3+wt(i)*wt(i)*evet(i)*evet(i)
        enddo
c--occhio
c       write(6,'(a,3f15.1)') 'Media_Rec',asum2,asum3,asum1
c--occhio
        aden=asum2*asum3
        if(aden>0.0) then
          correl=asum1/sqrt(aden)
        else
          correl=0.0
        endif
      endif
!
      if (kstp == 1) then
          if(tipoMappa==2) then
              write(lo,"(4x,'CORRELAZIONE = ',2f7.3)") correl
          else
              write(lo,"(4x,'COrRELAZIONE = ',2f7.3)") correl
          endif
          call toflush()
      endif
!
      iphaz(:) = iwork1(:)
      erore = err_sav
      erorepes = errpes_sav
      shiftexam(:) = shiftexamSav(:)
!
      return
      end
!--------------------------------------------------------------------
      subroutine Calcola_CC_Mappa_Finale_EXT(ifE, correl, kstp)
      USE General
      USE Riflessi
      USE Mappa
      USE PhaseModule
!
!--   tipoMappa = Fourier
!
      real shiftexamSav(7)
c
      numb = nrefl
      correl = -99.9
      if (knw == 0 .or. ifTime == 1 .or. ifReduced == 1) then
          return
      endif

!  -  Mappa Vera (Fo e fasi calcolate dal modello vero)

      jpatt = 0
      if (ifE == 0) then
          fcoef(1:nrefl) = fovet(1:nrefl) ! wt = 1
      else
          fcoef(1:nrefl) = evet(1:nrefl) ! wt = 1
      endif
      call MakeMap(fcoef, ipub, nrefl, jpatt, xmap,
     *             FORTH, BACK)
      xmapApp(:,:,:) = xmap(:,:,:)
!
      iwork1(:) = iphaz(:)
      err_sav = erore
      errpes_sav = erorepes
      shiftexamSav(:) = shiftexam(:)
!
      ifmin = 0
      call Trasla_Origine(nrefl)
!
!  -  Mappa Finale (Fo e fasi calcolate dal modello corrente)
      zero = 0.0000000000001
      sommetta = -99.9
      sommetta = sum(wt(nrefl+1:nreflDim))
      iniz = 1
      if (numbGen > 0 .and. sommetta > zero) then
          ifin = 2
          fcvet(:) = evet(:)
          call E2F()
      else
          ifin = 1
      endif
      do jj = iniz,ifin
         if (jj == 1) then
             numb = nrefl
         else
             numb = nreflDim
         endif
         jpatt = 0
         if (ifE == 0) then
             fcoef(1:numb) = fovet(1:numb) * wt(1:numb)
         else
             fcoef(1:numb) = evet(1:numb) * wt(1:numb)
         endif
         call MakeMap(fcoef, iphaz, numb, jpatt, xmap,
     *             FORTH, BACK)
!
         nnx=np(1)-1
         nny=np(2)-1
         nnz=np(3)-1
   
   
         npunti=0
         vmedt=0.0
         vmedc=0.0
         vmedtc=0.0
         vmed2t=0.0
         vmed2c=0.0
   
         do iz=0,nnz
            do iy=0,nny
               do ix=0,nnx
                  npunti=npunti+1
                  xx1=xmapApp(ix,iy,iz)
                  xx2=xmap(ix,iy,iz)
                  vmedt=vmedt + xx1
                  vmedc=vmedc + xx2
                  vmedtc=vmedtc + xx1 * xx2
                  vmed2t=vmed2t + xx1 * xx1
                  vmed2c=vmed2c + xx2 * xx2
             enddo
           enddo
         enddo
   
         vmedt=vmedt/float(npunti)
         vmedc=vmedc/float(npunti)
         vmedtc=vmedtc/float(npunti)
         vmed2t=vmed2t/float(npunti)
         vmed2c=vmed2c/float(npunti)
         rnum=vmedtc - (vmedt*vmedc)
         arg1 = vmed2t - vmedt ** 2
         arg2 = vmed2c - vmedc ** 2
         rden=sqrt(arg1) * sqrt(arg2)
         correl=rnum/rden
!
         if (kstp == 1) then
             if (jj == 1) then
                  write(lo,"(4x,'CORREL. FINALE OBS. = ',f7.3)") correl
             else
                  write(lo,"(4x,'CORREL. FINALE EXT. = ',f7.3)") correl
             endif
         endif
!
      enddo
!
      iphaz(:) = iwork1(:)
      erore = err_sav
      erorepes = errpes_sav
      shiftexam(:) = shiftexamSav(:)
!
      return
      end
!--------------------------------------------------------------------
      subroutine Calcola_CC_Mappa_Finale(ifE)
      USE General
      USE Riflessi
      USE Mappa
      USE Param
      USE PhaseModule
!
!
!--   tipoMappa = Fourier
!
      real shiftexamSav(7)
c 
      numb = nrefl
      correl = -99.9
      if (knw == 0 .or. ifTime == 1 .or. ifReduced == 1) then
          return
      endif
     
      write(6,*)' Calcola_CC_Mappa_Finale'

      NumPeso = 0 
      call ControllaAtomiPesanti(NumPeso)
      aperc(1) = NumPeso   ! opp. NumPes (un po' di più)
!
!  -  Mappa Vera (Fo e fasi calcolate dal modello vero)
!
      jpatt = 0
      if (ifE == 0) then
          fcoef(1:nrefl) = fovet(1:nrefl) ! wt = 1
      else
          fcoef(1:nrefl) = evet(1:nrefl) ! wt = 1
      endif
      call MakeMap(fcoef, ipub, nrefl, jpatt, xmap, FORTH, BACK)

      xmapApp(:,:,:) = xmap(:,:,:)

      iniz = 1
      ifin = 1
      ier = 0 
      if (iheavy > 0) then
          iflagPKS = 0
          mode = -1
          nnuu = nrefl
          krecy = 0
          call pksrch_New(mode, iflagPKS, nnuu,ier)
          if (ier /= 0) then
              return
          endif
          nats = aperc(1)

          radius = 2.5
          call elimHA_Map(radius,xmap)
          xmapDif(:,:,:) = xmap(:,:,:)

          ifin = 2
      endif

!
      iwork1(:) = iphaz(:)
      err_sav = erore
      errpes_sav = erorepes
      shiftexamSav(:) = shiftexam(:)
!
      ifmin = 0
      call Trasla_Origine(nrefl)

!
!  -  Mappa Finale (Fo e fasi calcolate dal modello corrente)
!
      jpatt = 0
      if (ifE == 0) then
          fcoef(1:nrefl) = fovet(1:nrefl) * wt(1:nrefl)
      else
          fcoef(1:nrefl) = evet(1:nrefl) * wt(1:nrefl)
      endif
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap, FORTH, BACK)



C---------------------------------------------------------------------
          iflagPKS = 0
          mode = -1
          nnuu = nrefl
          krecy = 0
          call pksrch_New(mode, iflagPKS, nnuu,ier)
          if (ier /= 0) then
              return
          endif
          call to_coord_sir(2,nnuu) !solo per debug
C---------------------------------------------------------------------



      do ii = iniz, ifin
         if (ii == 2) call elimHA_Map(radius,xmap)

         nnx=np(1)-1
         nny=np(2)-1
         nnz=np(3)-1

   
         npunti=0
         vmedt=0.0
         vmedc=0.0
         vmedtc=0.0
         vmed2t=0.0
         vmed2c=0.0
   
         do iz=0,nnz
            do iy=0,nny
               do ix=0,nnx
                  npunti=npunti+1
                  if (ii == 1) then
                      xx1=xmapApp(ix,iy,iz)
                  else
                      xx1=xmapDif(ix,iy,iz)
                  endif
                  xx2=xmap(ix,iy,iz)
                  vmedt=vmedt + xx1
                  vmedc=vmedc + xx2
                  vmedtc=vmedtc + xx1 * xx2
                  vmed2t=vmed2t + xx1 * xx1
                  vmed2c=vmed2c + xx2 * xx2
             enddo
           enddo
         enddo
   
         vmedt=vmedt/float(npunti)
         vmedc=vmedc/float(npunti)
         vmedtc=vmedtc/float(npunti)
         vmed2t=vmed2t/float(npunti)
         vmed2c=vmed2c/float(npunti)
         rnum=vmedtc - (vmedt*vmedc)
         arg1 = vmed2t - vmedt ** 2
         arg2 = vmed2c - vmedc ** 2
         rden=sqrt(arg1) * sqrt(arg2)
         correl=rnum/rden

            if (ii == 1) then
                write(lo,"(4x,'CORREL. FINALE = ',f7.3)") correl
                corre = correl
            else
                write(lo,"(4x,'CORREL. FINALE No HA = ',f7.3)") correl
            endif

      enddo !ii
!
      iphaz(:) = iwork1(:)
      erore = err_sav
      erorepes = errpes_sav
      shiftexam(:) = shiftexamSav(:)
!
      return
      end
!------------------------------------------------------------------------------
      subroutine elimHA_Map(radius,x)
!
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE PhaseModule
      USE Param
      dimension xs(3),xs1(3)
      dimension xs2(3),xs3(3),xss(3)
      integer sidepp
      real x(0:np(1)-1,0:np(2)-1,0:np(3)-1)

!
      denel=0.0
      npunti=0

      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)
      ca=cos(cell(4)*dtor)
      cb=cos(cell(5)*dtor)
      cg=cos(cell(6)*dtor)
c

      do iat = 1,nats

         do i=1,3
            xs1(i) = side(xyzs(i,iat))
         enddo

c        write(6,*) 'Atom #',iat, xs1(1:3), xyzs(4,iat)

      do kk1=1,ncentr
         do kk2=1,icent+1
            coef=1.0
            if(kk2==2) coef=-1.0
            do kk3=1,nsym
               call xequi(xs1,kk3,coef,xs,kk1)
               do ii=1,3
                  xs(ii)=side(xs(ii))
               enddo
               iszu=nint(xs(3)*np(3)+radius*deltz)
               iszl=nint(xs(3)*np(3)-radius*deltz)
               isyu=nint(xs(2)*np(2)+radius*delty)
               isyl=nint(xs(2)*np(2)-radius*delty)
               isxu=nint(xs(1)*np(1)+radius*deltx)
               isxl=nint(xs(1)*np(1)-radius*deltx)
c
               do iz = iszl, iszu
                 do iy = isyl, isyu
                   do ix = isxl, isxu
                     a1=ix/deltx-xs(1)*cell(1)
                     a2=iy/delty-xs(2)*cell(2)
                     a3=iz/deltz-xs(3)*cell(3)
                     ray2=a1**2 + a2**2 + a3**2 +
     &                    2.*a1*a2*cg + 2.*a1*a3*cb + 2.*a2*a3*ca
                     ray=sqrt(ray2)
                     if(ray>radius) cycle
                     ih = sidepp(ix,np(1))
                     ik = sidepp(iy,np(2))
                     il = sidepp(iz,np(3))
c                    write(6,*) 'Punti griglia #',ih,ik,il
                     xx = x(ih,ik,il)
                     npunti=npunti+1
                     denel=denel+xx
                     x(ih,ik,il) = 0.0
                   enddo
                 enddo
               enddo
 
          enddo
        enddo
      enddo  ! fine loop sulla centratura

      enddo  ! fine loop sugli atomi
 
c         write(lo,1000) radius,npunti,denel, 
c    *                                 denel/(volume*float(npunti))
 1000 format('   Radius of the sfere .................',f9.3,/,
     +       '   Number of grid point changed.........',i5,f15.2/,
     +       '   Average density eliminated ..........',f9.3,/)

      return
      end
!------------------------------------------------------------------------------
!------------------------------------------------------------------------------
      subroutine MakeMapsForCorr(ifBreak, ier)
      USE General
      USE Riflessi
      USE Mappa
      USE MapTest
      USE Param
      USE PhaseModule
!
      call AllocaMapTest(2)
      call AllocaMapTest(1)

      iphazo(1:nrefl) = iphaz(1:nrefl)
      worko(1:nrefl) = wt(1:nrefl)

      iphaz(1:nrefl) = ipub(1:nrefl)
      wt(1:nrefl) = 1.0


      call DistruggiPianiAll
      fcoef(1:nrefl) = fovet(1:nrefl) * wt(1:nrefl)
      jpatt = 0

      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmapT,
     *                FORTH, BACK)

      iphaz(1:nrefl) = iphazo(1:nrefl)
      wt(1:nrefl) = worko(1:nrefl)
      call DistruggiPianiAll

      return

      end
!------------------------------------------------------------------------------
      subroutine MakeEnveForCorr(ifBreak, ier)
      USE General
      USE Riflessi
      USE Mappa
      USE MapTest
      USE Param
      USE PhaseModule
      USE CowMod, only: ncol, ndim1, ndim2
!
      call DistruggiPianiAll
!
      rmax=0.5/sqrt(rhomax)
      rnrflc=100 + numres(rmax)
      wangmd=131.0
      wangrd=-2.0
      iwp=int(wangmd/100) + 1
      sw=sum(wt(1:nrefl)**iwp)
      Renve=abs(wangrd)*(rnrflc/sw)**0.33*rmax
      Renve=min(Renve,10.0)
!
      ncol  = 2
      smax  = rhomax * 4.0
      ndim1 = numestrefCow(smax)
      ndim1 = ndim1*2
      ndim2 = np(1) * np(2) * (np(3)+2)
!
      f000_old=f000
      f000=volume*(0.32*(1.0-v_p)+0.43*v_p)

      FORTHenv = 0

      if (knw > 0) then
        call PreMaskSirProt(1,v_p,xenveT,FORTHenv,BACKenv)
        call Map2EnveMask(1,smax,v_p,xenveT,FORTHenv,BACKenv)
        call mapcorr(xenve,xenveT,corrE)
      endif
      call PreMaskSirProt(0,v_p,xenve,FORTHenv,BACKenv)
      call Map2EnveMask(0,smax,v_p,xenve,FORTHenv,BACKenv)
      f000=f000_old
!
      call DistruggiPianiAll
!

      return

      end
!------------------------------------------------------------------------------
      subroutine Calcola_CC_Mappa_Completa(correl, kstp)
      USE General
      USE Riflessi
      USE Mappa
      USE MapTest
      USE PhaseModule
!
!--   tipoMappa = Fourier
!
      real shiftexamSav(7)
c
      correl = -99.9
      if (knw == 0 .or. ifTime == 1 .or. ifReduced == 1) then
          return
      endif
!
      iwork1(:) = iphaz(:)
      err_sav = erore
      errpes_sav = erorepes
      shiftexamSav(:) = shiftexam(:)
!
      ifmin = 0
      call Trasla_Origine(nrefl)
!
!  -  Mappa Finale (Fo e fasi calcolate dal modello corrente)
!
         jpatt = 0
         fcoef(1:nrefl) = fovet(1:nrefl) * wt(1:nrefl)
         call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *             FORTH, BACK)

         call mapcorr(xmap,xmapT,correl)
!
         if (kstp == 1) then
             write(lo,"(4x,'CORRELAZIONE = ',2f7.3)") correl
             call toflush()
         endif
!
      iphaz(:) = iwork1(:)
      erore = err_sav
      erorepes = errpes_sav
      shiftexam(:) = shiftexamSav(:)
!
      return
      end
!------------------------------------------------------------------------------
      subroutine Calcola_Enve_Vero()
      USE General
      USE Riflessi
      USE Mappa
      USE MapTest
      USE PhaseModule
!
      if (knw == 0 .or. ifTime == 1 .or. ifReduced == 1) then
          return
      endif
!
      iphazo(:) = iphaz(:)
      worko(:) = wt(:)
!
!  -  Mappa Finale (Fo e fasi calcolate dal modello vero)
!
      iphaz(:) = ipub(:)
      wt(:) = 1.0
      jpatt = 0
      call Long_Env_New(nrefl,jpatt)
      xenveT(:,:,:) = xenve(:,:,:)
!
      iphaz(:) = iphazo(:)
      wt(:) = worko(:)
!
      return
      end
!------------------------------------------------------------------------------
      subroutine controlla_indici(ivet1, ivet2)
      integer::ivet1(3)
      integer::ivet2(3)
c
      ivet2(:) = ivet1(:)
      if( (ivet2(1)<0).or.(ivet2(1)==0 .and.ivet2(2)<0).or.
     *   (ivet2(1)==0 .and.ivet2(2)==0 .and.ivet2(3)<0)) then
          ivet2(1:3)=-ivet2(1:3)
      endif
c
      end subroutine controlla_indici
!-----------------------------------------------------------------------
      subroutine Calcola_Fourier_Vera(iff)
!
!-- iff = 1  -  Fobs 
!-- iff = 2  -  Fcalc  da  PDB
!
      USE General
      USE Riflessi
      USE Atomi
      USE Mappa
      USE Param
      USE PhaseModule
!

      if (iff == 1) then
           write(lo,11) 
      elseif (iff == -1) then
           write(lo,12) 
      elseif (iff == 2) then
           write(lo,13) 
      endif

      sumfc = sum(fcvet(:))
      if (sumfc < 0.001 .and. iff == 2 .and. knw > 0) then
          write(lo,*) ' Subroutine Calcola_Fourier_Vera: 
     *     *** Fcalc not available! ***'
          return
      endif
 
         if (iff == 1) then
             fcoef(1:nrefl) = fovet(1:nrefl)
         elseif (iff == -1) then
             fcoef(1:nrefl) = evet(1:nrefl)
         elseif (iff == 2) then
             fcoef(1:nrefl) = fcvet(1:nrefl)
         endif
      do i = 1,nrefl
         wt(i) = 1.0
         iphaz(i) = ipub(i)
         fcoef(i) = fcoef(i) * wt(i)
      enddo
      jpatt = 0
      call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                FORTH, BACK)
!
      if (iabs(iff) == 1) then
          MapNumber = 11
      else
          MapNumber = 22
      endif
      call Write_CCP4_Map(xmap,MapNumber) 
!

      call maxmin_dedi(np(1),np(2),np(3),xmap)
      natm = anat
      aperc(1) = anat  !500   !anat/2.
      iflagPKS = 0
      mode = -1
      nnuu = nrefl
      krecy = 0
      call pksrch_New(mode, iflagPKS, nnuu,ier)
!     do i = 1,nats
!        write(6,14) i,xyzs(1:4,i), xyzs(4,i)/stden
!     enddo

      ncont = 0
      do i = 1,nats
         rappo = xyzs(4,i)/stden
         write(6,14) i,xyzs(1:4,i), xyzs(4,i)/stden
         if (rappo > 2.0) ncont =ncont + 1
      enddo

      if (nats > 0) then
          ifExamin = 1
          kdstampa = 2 !0  ! 2
          call to_coord_sir(kdstampa,nrefl)
          write(6,15) ncont, nats, float(ncont)/float(nats) * 100.
      endif

!
   11 format(/,'      ---  MAPPA FOURIER con Fobs e ipub  ---',/)
   12 format(/,'      ---  MAPPA FOURIER con Eobs e ipub  ---',/)
   13 format(/,'      ---  MAPPA FOURIER con Fcal e ipub  ---',/)
   14 format('PICCO ',i6,3f7.3,f15.2,f10.3)
   15 format(/,'  Picchi con intensità > 2 * stden =',i6,' su',i6,
     *       f7.1,'%')

      return
      end
!---------------------------------------------------------------------
      subroutine StatErre_perShell(numb)
c
c--confronta gli F obs (work1) con gli F calc (work2)
c
      USE General
      USE Symmetry
      USE Riflessi
      USE TestStuff
      USE RenorArrays
!
      integer nrf(101), reflres(10)
      real fosum(10), fcsum(10), dfsum(10), scalares(10)
      real minmaxres(2,10)
!
      sumfc = sum(fcvet(:))
      if (sumfc < 0.001 .and. knw > 0) then
          write(lo,*) ' Subroutine StatErre_perShell: 
     *     *** Fcalc not available! ***'
          return
      endif

      write(lo,11) 

      numint = interv
!
      work1(1:numb) = fovet(1:numb)
      call sortall(-1,work1,numb)
      nn1 = percRefl * numb
      if (nn1 <= 0) then   ! se numb < 100 ... (strutture micro, ...)
          nn1 = 1
      endif
      sogliaFo = work1(nn1)
!     sogliaSg = 10.
!     sogliaRs = 10.

      erref = 0.0
      sca = 1.0
      sumdf=0.0
      sumfo=0.0
      sumfc=0.0
      do i=1,numb
         if (wt(i) < 0.0001) cycle
         sumfo = sumfo + fovet(i) 
         sumfc = sumfc + fcvet(i) 
      enddo
      sca = sumfo / sumfc
      do i=1,numb
         if (wt(i) < 0.0001) cycle
         work1(i) = fovet(i)
         work2(i) = sca * fcvet(i)
         sumdf=sumdf+abs( work1(i)-work2(i) )
      enddo
      erref = (sumdf/sumfo) * 100
      write(lo,*) ' Subr. StatErre_perShell: Rf%', erref, ' su ',numb,
     * ' riflessi'
!
!--calcola gli RF in intervalli di F osservato
!
      exmax = sogliaFo
      exmin = minval(work1(1:numb))
      eint=(exmax-exmin)/float(numint)
!
      write(lo,101)
!
      sumdfcum=0.0
      sumfocum=0.0
      erecum=0.0
      nrf(:) =  0

      sumdf=0.0
      ere=0.0
      elim2=exmax
      sumfo=0.0
      sumdf=0.0
      numnn=0
      do k=1,numb
         if (work1(k).lt.elim2) cycle
         numnn=numnn+1
         sumdf=sumdf+abs( work1(k)-work2(k) )
         sumfo=sumfo+work1(k)
         sumdfcum=sumdfcum+abs( work1(k)-work2(k) )
         sumfocum=sumfocum+work1(k)
      enddo
      nrf(1)=numnn
      if(sumfo.gt.0.0) ere=(sumdf/sumfo)*100.0
      if(sumfocum.gt.0.0) erecum=(sumdfcum/sumfocum)*100.0
      write(lo,12) elim2,ere,erecum,numnn,nrf(1)

      do j=1,numint
        sumdf=0.0
        ere=0.0
        elim1=exmax-(j-1)*eint
        elim2=elim1-eint
        if(elim2 < 0.001) elim2=-0.0001
        sumfo=0.0
        sumdf=0.0
        numnn= 0
        do k=1,numb
          if(work1(k).lt.elim1.and.work1(k).ge.elim2) then
            numnn=numnn+1
            sumdf=sumdf+abs( work1(k)-work2(k) )
            sumfo=sumfo+work1(k)
            sumdfcum=sumdfcum+abs( work1(k)-work2(k) )
            sumfocum=sumfocum+work1(k)
          endif
        enddo
          nrf(j+1)=numnn+nrf(j)
        if(numnn.eq.0) cycle 
        if(sumfo.gt.0.0) ere=(sumdf/sumfo)*100.0
        if(sumfocum.gt.0.0) erecum=(sumdfcum/sumfocum)*100.0
        if(elim2 < 0.001) elim2=0.0
        write(lo,13) elim1,elim2,ere,erecum,numnn,nrf(j+1)
      enddo

!
!--calcola gli RF in intervalli di Fo/sigmaFo
!
      do j=1,numb
         worko(j)=fovet(j)/sigmav(j)
      enddo
      exmax = sogliaSg
      exmin = minval(worko(1:numb))
      eint=(exmax-exmin)/float(numint)

      write(lo,102)

      sumdfcum=0.0
      sumfocum=0.0
      erecum=0.0
      nrf(:) =  0

      sumdf=0.0
      ere=0.0
      elim2=exmax
      sumfo=0.0
      sumdf=0.0
      numnn=0
      do k=1,numb
         if (fovet(k) < 0.001) then
             sig = 0.0
         else
             sig=fovet(k)/sigmav(k)
         endif
         if (sig.lt.elim2) cycle
         numnn=numnn+1
         sumdf=sumdf+abs( work1(k)-work2(k) )
         sumfo=sumfo+work1(k)
         sumdfcum=sumdfcum+abs( work1(k)-work2(k) )
         sumfocum=sumfocum+work1(k)
      enddo
      nrf(1)=numnn
      if(sumfo.gt.0.0) ere=(sumdf/sumfo)*100.0
      if(sumfocum.gt.0.0) erecum=(sumdfcum/sumfocum)*100.0
      write(lo,12) elim2,ere,erecum,numnn,nrf(1)

      do j=1,numint
        sumdf=0.0
        ere=0.0
        elim1=exmax-(j-1)*eint
        elim2=elim1-eint
        if(elim2 < 0.001) elim2=-0.0001
        sumfo=0.0
        sumdf=0.0
        numnn= 0
        do k=1,numb
           if (fovet(k) < 0.001) then
               sig = 0.0
           else
               sig=fovet(k)/sigmav(k)
           endif
           if(sig.lt.elim1.and.sig.ge.elim2) then
              numnn=numnn+1
              sumdf=sumdf+abs( work1(k)-work2(k) )
              sumfo=sumfo+work1(k)
              sumdfcum=sumdfcum+abs( work1(k)-work2(k) )
              sumfocum=sumfocum+work1(k)
           endif
        enddo
        nrf(j+1)=numnn+nrf(j)
        if(numnn.eq.0) cycle
        if(sumfo.gt.0.0) ere=(sumdf/sumfo)*100.0
        if(sumfocum.gt.0.0) erecum=(sumdfcum/sumfocum)*100.0
        if(elim2 < 0.001) elim2=0.0
        write(lo,13) elim1,elim2,ere,erecum,numnn,nrf(j+1)
      enddo

!
!--calcola gli RF in intervalli di risoluzione
!

      exmax = sogliaRs
      exmin = resm
      eint=(exmax-exmin)/float(numint)

      write(lo,103)

      sumdfcum=0.0
      sumfocum=0.0
      erecum=0.0
      nrf(:) =  0

      sumdf=0.0
      ere=0.0
      elim2=exmax
      sumfo=0.0
      sumdf=0.0
      numnn=0
      do k=1,numb
         ris=0.5/sqrt(rhov(k))
         if (ris.lt.elim2) cycle
         numnn=numnn+1
         sumdf=sumdf+abs( work1(k)-work2(k) )
         sumfo=sumfo+work1(k)
         sumdfcum=sumdfcum+abs( work1(k)-work2(k) )
         sumfocum=sumfocum+work1(k)
      enddo
      nrf(1)=numnn
      if (sumfo.gt.0.0) then
          ere=(sumdf/sumfo)*100.0
      else
          ere=101
      endif
      if (sumfocum.gt.0.0) then
          erecum=(sumdfcum/sumfocum)*100.0
      else
          erecum=101
      endif
      if(ere > 100) then
         if (numnn > 0) then
             ere=100
         else
             ere=0
         endif
      endif
      if(erecum > 100) then
         if (numnn > 0) then
             erecum=100
         else
             erecum=0
         endif
      endif
      write(lo,12) elim2,ere,erecum,numnn,nrf(1)

      elim1 = exmax + eint
      numint = 100
      do j=1,numint
        sumdf=0.0
        ere=0.0
*       elim1=exmax-(j-1)*eint
        if (elim2 < 2.0) then
            eintt = 0.1
            elim1 = elim2
            elim2 = elim1 - 0.1
        else
            eintt = eint
            elim1=elim1 - eint
            elim2=elim1-eint
        endif
*       if(elim2 < 0.001) elim2=-0.0001
        if(elim2 < 0.001) exit
        sumfo=0.0
        sumdf=0.0
        numnn= 0
        do k=1,numb
           ris=0.5/sqrt(rhov(k))
           if(ris.lt.elim1.and.ris.ge.elim2) then
              numnn=numnn+1
              sumdf=sumdf+abs( work1(k)-work2(k) )
              sumfo=sumfo+work1(k)
              sumdfcum=sumdfcum+abs( work1(k)-work2(k) )
              sumfocum=sumfocum+work1(k)
           endif
        enddo
        nrf(j+1)=numnn+nrf(j)
        if(numnn.eq.0) cycle
        if(sumfo.gt.0.0) ere=(sumdf/sumfo)*100.0
        if(sumfocum.gt.0.0) erecum=(sumdfcum/sumfocum)*100.0
        if(elim2 < 0.001) elim2=0.0
        if(ere > 100) then
           if (numnn > 0) then
               ere=100
           else
               ere=0
           endif
        endif
        if(erecum > 100) then
           if (numnn > 0) then
               erecum=100
           else
               erecum=0
           endif
        endif
        write(lo,13) elim1,elim2,ere,erecum,numnn,nrf(j+1)
      enddo
!
*     if (neutro == 2) then
          fosum(:) = 0.0
          fcsum(:) = 0.0
          dfsum(:) = 0.0
          reflres(:) = 0
          scalares(:) = 0.0
          minmaxres(1,:) =  9999
          minmaxres(2,:) = -9999
          NShell = 5
          nreflSHL = numb
          call AllocaRenorArrays(1)
          nreflSHL = numb
          RES(1:nreflSHL) = 0.5 / sqrt(rhov(1:nreflSHL))
          call Ren_shells()
          do i=1, numb
             if (wt(i) < 0.0001) cycle
             j = RES_TAG(i)
*            write(6,22) i,j,khl(1:3,i),fovet(i),fcvet(i)
*  22        format(i5,")",i2," HKL",3i4,2f10.4)
             fosum(j) = fosum(j) + fovet(i)
             fcsum(j) = fcsum(j) + fcvet(i)
             reflres(j) = reflres(j) + 1
             r = RES(i)
             if (r < minmaxres(1,j)) then
                 minmaxres(1,j) = r
             endif
             if (r > minmaxres(2,j)) then
                 minmaxres(2,j) = r
             endif
          enddo
          do i=1, NShell
             scalares(i) = fcsum(i) / fosum(i)
          enddo
          sumdf = 0.0
          sumfo = 0.0
          sumfc = 0.0
          do i=1, numb
             if (wt(i) < 0.0001) cycle
             j = RES_TAG(i)
             sumfo = sumfo + scalares(j) * fovet(i)
             sumfc = sumfc + fcvet(i)
          enddo
          ovscale = sumfc / sumfo
          sumdf = 0.0
          sumfo = 0.0
          fosum(:) = 0.0
          dfsum(:) = 0.0
          totnum = 0.0
          totden = 0.0
          numtot = 0
          do i=1, numb
             if (wt(i) < 0.0001) cycle
             j = RES_TAG(i)
             fo = scalares(j) * fovet(i) * ovscale
             sumfo = sumfo + fo
             sumdf = sumdf + abs(fcvet(i) - fo)
             fosum(j) = fosum(j) + fo
             dfsum(j) = dfsum(j) + abs(fcvet(i) - fo)
             totnum = totnum + abs(fcvet(i) - fo)
             totden = totden + fo 
             numtot = numtot + 1
          enddo
          erreres = 100.0 * sumdf/sumfo
          write(6,200) erreres
          do i=1, NShell
             rfac = 100.0 * dfsum(i) / fosum(i)
             write(6,210) i, minmaxres(1,i), minmaxres(2,i),
     *                    reflres(i),fosum(i),fcsum(i),scalares(i),rfac
             fosum(j) = fosum(j) + fovet(i)
             fcsum(j) = fcsum(j) + fcvet(i)
             reflres(j) = reflres(j) + 1
          enddo
          rfac = 100.0 * totnum / totden
          write(6,220) numtot,rfac
          call AllocaRenorArrays(2)
*     endif
!
   11 format(/,'      ---  STATISTICHE  su  Rf %  ---')
c  12 format('    up  to',3f10.3,2i10)
   12 format('  inf.  to',3f10.3,2i10)
   13 format(4f10.3,2i10)
  101 format(/,' --- Rf % - Distribuzione in f.ne di Fobs ---',/,
     * '     Fmax      Fmin      |R_F|   R_F cum.      NR     NR cum.')
  102 format(/,' --- Rf % - Distribuzione in f.ne di Fo/sigmaFo ---',/,
     * '     Smax      Smin      |R_F|   R_F cum.      NR     NR cum.')
  103 format(/,' --- Rf % - Distribuzione in f.ne di Risoluzione ---',/,
     * '     Rmin      Rmax      |R_F|   R_F cum.      NR     NR cum.') 
  200 format(/,' Resolution based scale: R% = ', f8.2,/,
     * '          Shell    Number        sum(Fo)        sum(Fc)     '
     * ,'Scale    R%')
  210 format(i5,')',2f6.2,i7,2f15.3,f10.3,f8.2)
  220 format('            All   ',i7,40x,f8.2)
!
      return
      end
!---------------------------------------------------------------------
      subroutine StatErreSym_perShell(numb)
c
c--confronta gli F obs (work1) con gli F calc (work2)
c
      USE General
      USE Symmetry
      USE Riflessi
      USE TestStuff
      USE RenorArrays
!
      common /statis/ sumsym(25,9), Rsymtab(6,4), Rint_all(3), 
     *                                    NShellRsym, iOKstp
      integer nrf(31), reflres(10)
      real fosum(10), fcsum(10), dfsum(10)
      real minmaxres(2,10)
!
      fosum(:) = 0.0
      fcsum(:) = 0.0
      dfsum(:) = 0.0
      reflres(:) = 0
      minmaxres(1,:) =  9999
      minmaxres(2,:) = -9999
      NShell = 5
      nreflSHL = numb
      call AllocaRenorArrays(1)
      nreflSHL = numb
      RES(1:nreflSHL) = rhov(1:nreflSHL)
      call Ren_shells()
      totnum = 0.0
      totden = 0.0
      numtot = 0
      do i=1, numb
         j = RES_TAG(i)
         fosum(j) = fosum(j) + fovet(i)
         fcsum(j) = fcsum(j) + fcvet(i)
         reflres(j) = reflres(j) + 1
         r = RES(i)
         if (r < minmaxres(1,j)) then
             minmaxres(1,j) = r
         endif
         if (r > minmaxres(2,j)) then
             minmaxres(2,j) = r
         endif
         totnum = totnum + fcvet(i)
         totden = totden + fovet(i)
         numtot = numtot + 1
      enddo
!
      NShellRsym = NShell
      Rsymtab(:,:) = 0.0
      do i=1, NShellRsym
         rfac = 100.0 * fcsum(i) / fosum(i)
         Rsymtab(i,1) = minmaxres(1,i)
         Rsymtab(i,2) = minmaxres(2,i)
         Rsymtab(i,3) = reflres(i)
         Rsymtab(i,4) = rfac
      enddo
      rfac = 100.0 * totnum / totden
      i = NShellRsym + 1
      Rsymtab(i,3) = numtot
      Rsymtab(i,4) = rfac
      call AllocaRenorArrays(2)
!
      return
      end
!---------------------------------------------------------------------
      subroutine StatErre_perShell_ABS(a,b,scalan,numb)
c
c--confronta gli F obs (work1) con gli F calc (work2)
c
      USE General
      USE Symmetry
      USE Riflessi
      USE TestStuff
      USE RenorArrays
!
      integer reflres(10)
      real fosum(10), fcsum(10), dfsum(10), scalares(10)
      real minmaxres(2,10)
!
*        s = rhov(i)
*        asb = a + s*b
*        scalaAB = scalan / asb
*        absdf = abs(work1(i) - scalaAB * fovet_mod(i))
      totnum = 0.0
      totden = 0.0
      fosum(:) = 0.0
      fcsum(:) = 0.0
      dfsum(:) = 0.0
      reflres(:) = 0
      scalares(:) = 0.0
      minmaxres(1,:) =  9999
      minmaxres(2,:) = -9999
      NShell = 5
      nreflSHL = numb
      call AllocaRenorArrays(1)
      nreflSHL = numb
      RES(1:nreflSHL) = 0.5 / sqrt(rhov(1:nreflSHL))
      call Ren_shells()
      do i=1, numb
         j = RES_TAG(i)
         s = rhov(i)
         asb = a + s*b
         scalaAB = scalan / asb
         fosum(j) = fosum(j) + fovet(i) * scalaAB
         fcsum(j) = fcsum(j) + fcvet(i)
         reflres(j) = reflres(j) + 1
         r = RES(i)
         if (r < minmaxres(1,j)) then
             minmaxres(1,j) = r
         endif
         if (r > minmaxres(2,j)) then
             minmaxres(2,j) = r
         endif
         totnum = totnum + fcvet(i)
         totden = totden + fovet(i)
      enddo
      ovsc = totnum/totden
      do i=1, NShell
         scalares(i) = fcsum(i) / fosum(i)
      enddo
      sumdf = 0.0
      sumfo = 0.0
      sumfc = 0.0
      do i=1, numb
         j = RES_TAG(i)
         s = rhov(i)
         asb = a + s*b
         scalaAB = scalan / asb
!        sumfo = sumfo + scalares(j) * fovet(i) * scalaAB
         sumfo = sumfo +               fovet(i) * scalaAB
         sumfc = sumfc + fcvet(i)
      enddo
      ovscale = sumfc / sumfo

      ovscale = 1

      sumdf = 0.0
      sumfo = 0.0
      fosum(:) = 0.0
      dfsum(:) = 0.0
      totnum = 0.0
      totden = 0.0
      do i=1, numb
         j = RES_TAG(i)
         s = rhov(i)
         asb = a + s*b
         scalaAB = scalan / asb
!        fo = scalares(j) * fovet(i) * ovscale * scalaAB
         fo =               fovet(i) * ovscale * scalaAB
         sumfo = sumfo + fo
         sumdf = sumdf + abs(fcvet(i) - fo)
         fosum(j) = fosum(j) + fo
         dfsum(j) = dfsum(j) + abs(fcvet(i) - fo)
         totnum = totnum + abs(fcvet(i) - fo)
         totden = totden + fo 
      enddo
      erreres = 100.0 * sumdf/sumfo
      write(6,200) erreres,a,b
      do i=1, NShell
         rfac = 100.0 * dfsum(i) / fosum(i)
         write(6,210) i, minmaxres(1,i), minmaxres(2,i),
     *                reflres(i),fosum(i),fcsum(i),scalares(i),rfac
*        fosum(j) = fosum(j) + fovet(i)
*        fcsum(j) = fcsum(j) + fcvet(i)
*        reflres(j) = reflres(j) + 1
      enddo
      rfac = 100.0 * totnum / totden
      write(6,212) rfac
!
      write(6,300) 
      fosum(:) = 0.0
      dfsum(:) = 0.0
      reflres(:) = 0
      do ii = NShell, 1, -1
         do i=1, numb
            j = RES_TAG(i)
            if (j >= ii) then
                fo = fovet(i) * ovsc
                fosum(ii) = fosum(ii) + fo
                dfsum(ii) = dfsum(ii) + abs(fcvet(i) - fo)
                reflres(ii) = reflres(ii) + 1
            endif
         enddo
      enddo
      j = 0
      do i = NShell, 1, -1
         j = j + 1
         rfac = 100.0 * dfsum(i) / fosum(i)
         write(6,310) j, minmaxres(1,i), minmaxres(2,NShell),
     *                reflres(i),fosum(i),fcsum(i),rfac
      enddo
      write(6,*)
!
      call AllocaRenorArrays(2)
!
  200 format(/,' Resolution based scale: R% = ', f8.2,
     * ' A = ',f10.4,' B = ',f10.4,/,
     * '          Shell  Number      sum(Fo)        sum(Fc)     '
     * ,'Scale    R%')
  210 format(i5,')',2f5.1,i5,2f15.3,f10.3,f8.2)
  212 format(61x,f8.2)
  300 format(/,' Resolution based cumulative R',/,
     * '          Shell  Number      sum(Fo)        sum(Fc)    R%')
  310 format(i5,')',2f5.1,i5,2f15.3,f8.2)
  312 format(51x,f8.2)
!
      return
      end
!---------------------------------------------------------------------
      subroutine StatErre_perShell_ABCS(a,b,c,scalan,numb)
c
c--confronta gli F obs (work1) con gli F calc (work2)
c
      USE General
      USE Symmetry
      USE Riflessi
      USE TestStuff
      USE RenorArrays
!
      integer reflres(10)
      real fosum(10), fcsum(10), dfsum(10), scalares(10)
      real minmaxres(2,10)
!
      totnum = 0.0
      totden = 0.0
      fosum(:) = 0.0
      fcsum(:) = 0.0
      dfsum(:) = 0.0
      reflres(:) = 0
      scalares(:) = 0.0
      minmaxres(1,:) =  9999
      minmaxres(2,:) = -9999
      NShell = 5
      nreflSHL = numb
      call AllocaRenorArrays(1)
      nreflSHL = numb
      RES(1:nreflSHL) = 0.5 / sqrt(rhov(1:nreflSHL))
      call Ren_shells()
      do i=1, numb
         j = RES_TAG(i)
         s = rhov(i)
         ss = s * s
         asb = a + s*b + ss*c
         scalaAB = scalan / asb
         fosum(j) = fosum(j) + fovet(i) * scalaAB
         fcsum(j) = fcsum(j) + fcvet(i)
         reflres(j) = reflres(j) + 1
         r = RES(i)
         if (r < minmaxres(1,j)) then
             minmaxres(1,j) = r
         endif
         if (r > minmaxres(2,j)) then
             minmaxres(2,j) = r
         endif
         totnum = totnum + fcvet(i)
         totden = totden + fovet(i)
      enddo
      ovsc = totnum/totden
      do i=1, NShell
         scalares(i) = fcsum(i) / fosum(i)
      enddo
      sumdf = 0.0
      sumfo = 0.0
      sumfc = 0.0
      do i=1, numb
         j = RES_TAG(i)
         s = rhov(i)
         ss = s * s
         asb = a + s*b + ss*c
         scalaAB = scalan / asb
!        sumfo = sumfo + scalares(j) * fovet(i) * scalaAB
         sumfo = sumfo +               fovet(i) * scalaAB
         sumfc = sumfc + fcvet(i)
      enddo
      ovscale = sumfc / sumfo

      ovscale = 1

      sumdf = 0.0
      sumfo = 0.0
      fosum(:) = 0.0
      dfsum(:) = 0.0
      totnum = 0.0
      totden = 0.0
      do i=1, numb
         j = RES_TAG(i)
         s = rhov(i)
         ss = s * s
         asb = a + s*b + ss*c
         scalaAB = scalan / asb
!        fo = scalares(j) * fovet(i) * ovscale * scalaAB
         fo =               fovet(i) * ovscale * scalaAB
         sumfo = sumfo + fo
         sumdf = sumdf + abs(fcvet(i) - fo)
*        write(6,*) i, fovet(i), asb, scalaAB, sumfo
         fosum(j) = fosum(j) + fo
         dfsum(j) = dfsum(j) + abs(fcvet(i) - fo)
*        if (j == 1) then
*            write(6,*) i, asb, scalaAB, fo, fosum(j),dfsum(j)
*        endif
         totnum = totnum + abs(fcvet(i) - fo)
         totden = totden + fo 
      enddo
      erreres = 100.0 * sumdf/sumfo
      write(6,200) erreres,a,b,c
      do i=1, NShell
         rfac = 100.0 * dfsum(i) / fosum(i)
         write(6,210) i, minmaxres(1,i), minmaxres(2,i),
     *                reflres(i),fosum(i),fcsum(i),scalares(i),rfac
*        fosum(j) = fosum(j) + fovet(i)
*        fcsum(j) = fcsum(j) + fcvet(i)
*        reflres(j) = reflres(j) + 1
      enddo
      rfac = 100.0 * totnum / totden
      write(6,212) rfac
!
      write(6,300) 
      fosum(:) = 0.0
      dfsum(:) = 0.0
      reflres(:) = 0
      do ii = NShell, 1, -1
         do i=1, numb
            j = RES_TAG(i)
            if (j >= ii) then
                fo = fovet(i) * ovsc
                fosum(ii) = fosum(ii) + fo
                dfsum(ii) = dfsum(ii) + abs(fcvet(i) - fo)
                reflres(ii) = reflres(ii) + 1
            endif
         enddo
      enddo
      j = 0
      do i = NShell, 1, -1
         j = j + 1
         rfac = 100.0 * dfsum(i) / fosum(i)
         write(6,310) j, minmaxres(1,i), minmaxres(2,NShell),
     *                reflres(i),fosum(i),fcsum(i),rfac
      enddo
      write(6,*)
!
      call AllocaRenorArrays(2)
!
  200 format(/,' Resolution based scale: R% = ', f8.2,
     * ' A = ',f10.4,' B = ',f10.4,' C = ',f10.4,/,
     * '          Shell  Number      sum(Fo)        sum(Fc)     '
     * ,'Scale    R%')
  210 format(i5,')',2f5.1,i5,2f15.3,f10.3,f8.2)
  212 format(61x,f8.2)
  300 format(/,' Resolution based cumulative R',/,
     * '          Shell  Number      sum(Fo)        sum(Fc)    R%')
  310 format(i5,')',2f5.1,i5,2f15.3,f8.2)
  312 format(51x,f8.2)
!
      return
      end
!------------------------------------------------------------------------------
      subroutine Radial_Distrib(x1,y1,z1,nunit,raylim,izero)
!
!- distribuzione radiale di una Mappa  subroutine per stampa con Excell
!
      USE General
      USE Symmetry
      USE Riflessi
      USE Mappa
      USE Param
      USE PhaseModule
!
      real ::  xs(3),xs1(3),xs2(3),xeq(3)
      real ::  s(3),vet(2)
      integer :: ixyz1(3), ixyz2(3), izero(3)
      integer sidepp
      real, allocatable ::  vett2(:,:)
 
!
      write(6,'(a3,3f17.3)') 'XXX Radial_Distr.',x1,y1,z1
!     write(6,*) 'cell,np',cell(1:6),np
      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)

      ca=cos(cell(4)*dtor)
      cb=cos(cell(5)*dtor)
      cg=cos(cell(6)*dtor)

      dx=1.0/float(np(1))
      dy=1.0/float(np(2))
      dz=1.0/float(np(3))
!
      if (raylim <= 0.00001) then
          alim = 5.0  
      else
          alim = raylim
      endif
!
      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1
!
      xs(1)=x1
      xs(2)=y1
      xs(3)=z1

      xs1(:)=xs(:)
!     do i=1,3
!        xs1(i)=side(xs(i))
!     enddo
 
        isz0=nint(xs1(3)*np(3))
        isy0=nint(xs1(2)*np(2))
        isx0=nint(xs1(1)*np(1))
        isz0=sidepp(isz0,np(3))
        isy0=sidepp(isy0,np(2))
        isx0=sidepp(isx0,np(1))

!       iszu=nint(xs1(3)*np(3)+alim*deltz)
!       iszl=nint(xs1(3)*np(3)-alim*deltz)
!       isyu=nint(xs1(2)*np(2)+alim*delty)
!       isyl=nint(xs1(2)*np(2)-alim*delty)
!       isxu=nint(xs1(1)*np(1)+alim*deltx)
!       isxl=nint(xs1(1)*np(1)-alim*deltx)
        iszu=nint(isz0+alim*deltz)
        iszl=nint(isz0-alim*deltz)
        isyu=nint(isy0+alim*delty)
        isyl=nint(isy0-alim*delty)
        isxu=nint(isx0+alim*deltx)
        isxl=nint(isx0-alim*deltx)

        if (izero(3) == 0) then
            iszl= 0 
            iszu= 0
        endif
        if (izero(2) == 0) then
            isyl= 0
            isyu= 0
        endif
        if (izero(1) == 0) then
            isxl= 0
            isxu= 0
        endif

!       write(6,*) 'ufi',isxl,isxu,isyl,isyu,iszl,iszu
!       write(nunit,*) 'cell,np',cell,np

        ntot = ((isxu-isxl)+1) * ((isyu-isyl)+1) * ((iszu-iszl)+1) 
c

        IF (.NOT. ALLOCATED(vett2))
     *        ALLOCATE (vett2(1:2,1:ntot),  stat = ierr)

        npti = 0
        do iiz = iszl, iszu
          do iiy = isyl, isyu
            do iix = isxl, isxu

               ix = sidepp(iix,np(1))
               iy = sidepp(iiy,np(2))
               iz = sidepp(iiz,np(3))

               xx1=float(ix)*dx
               yy1=float(iy)*dy
               zz1=float(iz)*dz
               xs2(1)=xx1
               xs2(2)=yy1
               xs2(3)=zz1

               dmin=1.E+10
               do kk1=1,ncentr
                  do kk2=1,ifin
                     coef=vet(kk2)
                     do kk3=1,nsym
                         call xequi(xs1,kk3,coef,xeq,kk1)
                         call xdist(xs2,xeq,d,s)
                         if(d.lt.dmin) dmin=d
                     enddo
                  enddo
               enddo
               ray=dmin

!?!            a1=ix/deltx-xs1(1)*cell(1)
!?!            a2=iy/delty-xs1(2)*cell(2)
!?!            a3=iz/deltz-xs1(3)*cell(3)
!?!            ray2=a1**2 + a2**2 + a3**2 +
!?!  &               2.*a1*a2*cg + 2.*a1*a3*cb + 2.*a2*a3*ca
!?!            ray=sqrt(ray2)

               if (ray > alim) cycle

!?!            if (iz < isz0 .or. iy < isy0 .or. ix < isx0) then
!?!                ray = -ray
!?!            endif

               npti = npti + 1 
               xx=xmap(ix,iy,iz)

               vett2(1,npti) = ray
               vett2(2,npti) = xx
               write(111,10) ix,iy,iz,ray,xx,xx1,yy1,zz1

            enddo
          enddo
        enddo
!
!--ordina i dati sperimentali
!
      call sortall2(vett2,2,1,npti,npti,-1)

      do i = 1,npti
         write(nunit,20) vett2(:,i)
      enddo

      IF (ALLOCATED(vett2)) DEALLOCATE (vett2, stat = ierr)

 10   format(3i5,2f15.3,3f10.5)
 20   format(2f15.3)

      return
      end
!------------------------------------------------------------------------------
      subroutine Leggi_Frammento_Ext(patom)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE TestStuff
!
      dimension xo(11),xn(11)
      integer key(10)
      dimension vet(40),ivet(40)
      character tipo*2,line*80,dire*80
      character a
      character patom*256
      character*4 lSpecies(18)

c
      do i=1, nk
         lSpecies(i) = Species(i)
         call lcase(lSpecies(i))
      enddo

! per file nello stesso direttorio

      open(unit=kform,file=patom,status='old',err=8000)
!
      natcoo=0
      do
         read(kform,'(a)',end=2) line
         call shift(line,ls)
         iasc = ichar(line(1:1))
         if (iasc .eq. 26) then
             exit
         end if
         a = line(1:1)
         if (a == '!' .or. a == '>') then
             cycle
         end if
         natcoo=natcoo + 1
         call cutst(line,lenp,dire,lend)
         call lcase(dire)
         nz(natcoo) = 0
         lend = 2
         do i=1, nk
            if (lSpecies(i)(1:lend) == dire(1:lend)) then
                nz(natcoo) = i
            endif
         enddo
         aLab(natcoo) = dire(1:lend)
         iopt=0
         call getnum(line,vet,ivet,iv,iopt)
         do i=1,3
            xyzs(i,natcoo)=side(vet(i))
         enddo
         xyzs(4,natcoo)=nz(natcoo) * 100
         if (iv > 3) then
            bfac(natcoo)=vet(4)    ! fatt.term.
         else
            bfac(natcoo)=bt
         endif
         cycle
      enddo
    2 close(kform)
      nCoordPub = natcoo

      fnatm=float(natm)
      fnatm=amax1(anat,fnatm)
      focct=0.2*anat+anat
      iactn=1
      xo(:) = 0.0
      xn(:) = 0.0
      ifP1 = nsym*(icent+1)
      nats = natcoo 
      itype = 0
      sumOcc = 0.0
      jj = 0
      do i=1,natcoo
         if (ifP1.ne.1) then
             xo(1)=xyzs(1,i)
             xo(2)=xyzs(2,i)
             xo(3)=xyzs(3,i)
             iser=i
             iactn=1    ! da modificare
             khead=0
             ksp=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
             occ=1.0/float(key(10))
         else
             occ=1.0
         endif
         xyzs(5,i) = occ
         sumOcc = sumOcc + occ
         if (.not.(sumOcc > focct)) then
             jj = jj + 1
         endif
      enddo

      return

 8000 continue
      kpatom = Lung(patom)
      write(6,*) ' ERROR in file: ',patom(1:kpatom)

      return
      end
!---------------------------------------------------------------------
      subroutine crea_file_fra(iact)
      USE General
      USE Atomi
!
      dimension x1(3)

!--   iact = 1  stampa solo atomi pesanti
!--   iact = 2  stampa tutti atomi non-H
!--   iact = 3  stampa tutti atomi compresi H


      k  = index(fname(1),'.bin')
      msg = fname(1)(1:k-1)//'.fra'
      open(unit = 999, file = msg, form = 'formatted')

      if (iact == 1) then
          do i = 1, nats
             knz = nz(i) / nzConst
             if (no(knz) > 10) then
                 do j = 1,3
                    x1(j) = side(xyzs(j,i))
                 end do
                 write(999,111) Species(knz),x1
             end if
          end do
      elseif (iact == 2) then
          do i = 1, nats
             knz = nz(i) / nzConst
             if (no(knz) > 1) then
                do j = 1,3
                   x1(j) = side(xyzs(j,i))
                end do
                write(999,111) Species(knz),x1
             end if
          end do
      elseif (iact == 3) then
          do i = 1, nats
             knz = nz(i) / nzConst
             do j = 1,3
                x1(j) = side(xyzs(j,i))
             end do
             write(999,111) Species(knz),x1
          end do
      end if

      close(999)

 111  format(a4,3f12.5)
c

      return
      end
!---------------------------------------------------------------------
