/*****************************************************************************/
/* struct mr_action_entry tipo di item: 
                  1 - tipico bottone della toolbar
                  2 - radio
                  3 - check
                  4 - separatore
                  5 - spin
                  6 - scale
                  7 - bottone (testo e immagine) rettangolare allineato a destra
                  8 - bottone (testo e immagine) rettangolare 
                  9 - bottone animato 
                 12 - label
                 13 - campo di entry
                 47 - event_box con pixmap 
                 50 - pixmap
                 52 - label boxed
                1xx - item di tipo xx (tra i precedenti) che apre una 
                      nuova toolbar
                -xx - item di tipo xx (tra i precedenti) da non mostrare
*/
/*****************************************************************************/

#include "callbacks.h"

gboolean ifToolbar = TRUE;
gboolean ifStatusbar = TRUE;

static mr_action_entry tb_entries[] = {
{0, 1, "Exit", "Exit", "Leave ", "quit", G_CALLBACK(exit_confirm), NULL, -1, 1, 0},
{0, 1, "New", "New", "New Project", "filenew", G_CALLBACK(open_newproj_dlg), NULL, -1, 1, 0},
{0, 1, "Load", "Load", "Load input (.sir) file and start the run", "opensir", G_CALLBACK(open_file), NULL, 0, 1, 0},
{0, 1, "Old Project", "Old Project", "Load Project (.bin) file", "openbin", G_CALLBACK(open_file), NULL, 1, 1, 0},
{0, 1, "Save", "Save", "Save project file", "save", G_CALLBACK(c_savebinfile), NULL, -1, 0, 0},
{0, 1, "Restore", "Restore", "Restore project file", "restore", G_CALLBACK(c_restorebinfile), NULL, -1, 1, 0},
{0, 4},
{0, 1, "View", "Jav", "Open structure in Jav", "jav", G_CALLBACK(call_javs), NULL, -1, 0, 0},
#if 0
{0, 1, "Modify Model", "Modify Model", "Modify the model", "modify_model", G_CALLBACK(mostra_tb), NULL, -1, 0, 0},
{0, 3, "SymmOn", "SymmOn", "Symmetry On/Off", "symmon", G_CALLBACK(toggle_symm), NULL, -1, 0, 0},
{0, -3, "DrawGrOn", "DrawGrOn", "Draw groups On/Off", "drawgron", G_CALLBACK(toggle_drawgr), NULL, 0, 0, 0},
{0, 4},
{0, 1, "View", "View", "Open View Toolbar", "preview", G_CALLBACK(mostra_tb), NULL, -1, 0, 0},
{0, 3, "togbg", "togbg", "Black / White background", "bbackgoff", G_CALLBACK(toggle_bg), NULL, -1, 1, 0},
{0, 1, "Area", "Area", "Select atoms to zoom", "area", G_CALLBACK(c_init_disegnarettangolo), NULL, -1, 0, 0},
{0, 1, "NoArea", "NoArea", "Show all atoms", "showall", G_CALLBACK(c_show_all), NULL, -1, 0, 0},
{0, 1, "Reset View", "Reset View", "Reset the View", "reset", G_CALLBACK(view_options), NULL, 17, 0, 0},
{0, 3, "CellOn", "CellOn", "Cell On/Off", "cellon", G_CALLBACK(toggle_cell), NULL, -1, 0, 0},
#endif
{0, 3, "LabTog", "LabTog", "Labels On/Off", "labon", G_CALLBACK(toggle_label), NULL, -1, 0, 0},
#if 0
{0, 101, "Move Labels", "Move Labels", "Move or hide Labels", "movelab", G_CALLBACK(mostra_tbg1), NULL, -1, 0, 0},
{0, 4},
{0, 1, "Info", "Info", "Info on the structure", "info_icon", G_CALLBACK(mostra_tb), NULL, -1, 0, 0},
{0, 1, "Geometry", "Geometry", "Distances and Angles calculation", "geometry", G_CALLBACK(mostra_tb), NULL, -1, 0, 0},
#endif
{0, 1, "Map viewer", "contour", "Map viewer", "contour", G_CALLBACK(call_jav), NULL, -1, 0, 0},
{0, 1, "contour", "contour", "2D contour", "2D_contour", G_CALLBACK(mostra_tb), NULL, -1, 0, 0},
{0, -1, "terminal", "terminal", "interactive shell", "terminal", G_CALLBACK(open_terminal), NULL, -1, 0, 0}
};

#if 0
static mr_action_entry tb_view[] = {
{0, 50, "iconView", NULL, "View", "preview", NULL, NULL, -1, 1, 0},
{0, 12, "labelView", "View", NULL, NULL, NULL, NULL, -1, 1, 0},
{0, 4},
{0, 1, "hide", "hide", "Select atoms to hide", "selecthide", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 1, "display", "display", "Select atoms to display", "selectshow", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 1, "change color", "change color", "Select atoms to change color", "selectcol", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 1, "Hide/Show Species", "_Hide/Show Species", "Hide/Show species", "showhide", G_CALLBACK(HideShowSpecies), NULL, -1, 1, 0},
{0, 1, "show all", "show all", "Display all atoms ", "showall", G_CALLBACK(c_show_all), NULL, -1, 1, 0},
{0, 4},
{0, 1, "Rotate", "Rotate", "Rotate the structure", "rotate", G_CALLBACK(mostra_tb), NULL, -1, 1, 0},
{0, 1, "Translate", "Translate", "Translate the structure", "translate", G_CALLBACK(mostra_tb), NULL, -1, 1, 0},
{0, 1, "Zoom In", "Zoom In", "Zoom In", "zoom_in", G_CALLBACK(view_options), NULL, 15, 1, 0},
{0, 1, "Zoom Out", "Zoom Out", "Zoom Out", "zoom_out", G_CALLBACK(view_options), NULL, 16, 1, 0},
{0, 1, "Reset View", "Reset View", "Reset the View", "reset", G_CALLBACK(view_options), NULL, 17, 1, 0},
{0, 4},
{0, 1, "Least Squares Plane", NULL, "Least Squares Plane", "least", G_CALLBACK(view_options), NULL, 18, 1, 0},
{0, 1, "Normal to a", NULL, "Normal to a", "alonga", G_CALLBACK(view_options), NULL, 21, 1, 0},
{0, 1, "Normal to b", NULL, "Normal to b", "alongb", G_CALLBACK(view_options), NULL, 22, 1, 0},
{0, 1, "Normal to c", NULL, "Normal to c", "alongc", G_CALLBACK(view_options), NULL, 23, 1, 0},
{0, 1, "jav", "jav", "view model in Jav", "jav", G_CALLBACK(call_javs), NULL, 11, 1, 0},
{0, 80, "expanderView", NULL, "expander", "void", NULL, NULL, 0, 0, 0},
{0, 7, "Back", "Back", "Back to Main Toolbar", "back", G_CALLBACK(cancel_tb), NULL, -1, 1, 0}
};

static mr_action_entry tb_rotate[] = {
{0, 50, "iconRotate", NULL, "Rotate the model", "rotate", NULL, NULL, -1, 1, 0},
{0, 12, "labelRotate", "Rotate", NULL, NULL, NULL, NULL, -1, 1, 0},
{0, 4},
{0, 12, "Angle", "Angle", NULL, NULL, NULL, NULL, -1, 1, 0},
{0, 12, "Speed", "Speed", NULL, NULL, NULL, NULL, -1, 1, 0},
{0, 5, "spinRotate", "spin", "Step for rotation angle", "0, 5, 1, 90, 1, 5", NULL, NULL, -1, 1, 0},
{0, 5, "speed", "speed", "Rotation speed", "0, 10, 1, 10, 1, 1", G_CALLBACK(on_speed_changed), NULL, -1, 1, 0},
{0, 1, "RC", "RC", "Continuous rotation", "rotate.gif", G_CALLBACK(open_toolbox), NULL, -1, 1, 0},
{0, 1, "StopRot", "Stop", "Stop the rotation", "stopr", G_CALLBACK(stop_rot), NULL, 1, 1, 0},
{0, 1, "RXminus", "RXminus", "X-", "xminus", G_CALLBACK(move_rotate), NULL, 1, 1, 0},
{0, 1, "RXplus", "RXplus", "X+", "xplus", G_CALLBACK(move_rotate), NULL, 2, 1, 0},
{0, 1, "RYminus", "RYminus", "Y-", "yminus", G_CALLBACK(move_rotate), NULL, 3, 1, 0},
{0, 1, "RYplus", "RYplus", "Y+", "yplus", G_CALLBACK(move_rotate), NULL, 4, 1, 0},
{0, 1, "RZminus", "RZminus", "Z-", "zminus", G_CALLBACK(move_rotate), NULL, 5, 1, 0},
{0, 1, "RZplus", "RZplus", "Z+", "zplus", G_CALLBACK(move_rotate), NULL, 6, 1, 0},
{0, 1, "RVminus", "RVminus", "V-", "vminus", G_CALLBACK(move_rotate), NULL, 7, 1, 0},
{0, 1, "RVplus", "RVplus", "V+", "vplus", G_CALLBACK(move_rotate), NULL, 8, 1, 0},
{0, 8, "Define Vector", "Define Vector", "Define vector", "defv", G_CALLBACK(define_vector), NULL, -1, 1, 0},
{0, 80, "expanderRotate", NULL, "expander", "void", NULL, NULL, 0, 0, 0},
{0, 7, "Back", "Back", "Back to previous Toolbar", "back", G_CALLBACK(cancel_tb_rotate), NULL, -1, 1, 0}
};

static mr_action_entry tb_translate[] = {
{0, 50, "iconTranslate", NULL, "Translate the model", "translate", NULL, NULL, -1, 1, 0},
{0, 12, "labelTranslate", "Translate", NULL, NULL, NULL, NULL, -1, 1, 0},
{0, 4},
{0, 12, "Shift", "Shift", NULL, NULL, NULL, NULL, -1, 1, 0},
{0, 5, "spin", "spin", "Step for translation", "0, 1, 0, 40, 1, 10", NULL, NULL, -1, 1, 0},
{0, 1, "TXminus", "TXminus", "X-", "left_arrow", G_CALLBACK(move_rotate), NULL, 9, 1, 0},
{0, 1, "TXplus", "TXplus", "X+", "right_arrow", G_CALLBACK(move_rotate), NULL, 10, 1, 0},
{0, 1, "TYminus", "TYminus", "Y-", "down_arrow", G_CALLBACK(move_rotate), NULL, 11, 1, 0},
{0, 1, "TYplus", "TYplus", "Y+", "up_arrow", G_CALLBACK(move_rotate), NULL, 12, 1, 0},
{0, 1, "TZminus", "TZminus", "Z-", "zoom_out", G_CALLBACK(move_rotate), NULL, 13, 1, 0},
{0, 1, "TZplus", "TZplus", "Z+", "zoom_in", G_CALLBACK(move_rotate), NULL, 14, 1, 0},
{0, 80, "expanderTranslate", NULL, "expander", "void", NULL, NULL, 0, 0, 0},
{0, 7, "Back", "Back", "Back to previous Toolbar", "back", G_CALLBACK(cancel_tb), NULL, -1, 1, 0}
};

static mr_action_entry tb_modify[] = {
{0, 50, "iconModify", "icon", "Modify the model", "modify_model", NULL, NULL, -1, 1, 0},
{0, 12, "labelModify", "Modify the model ", "label", NULL, NULL, NULL, -1, 1, 0},
{0, 4},
{0, 101, "delete", "delete", "Select atoms to delete", "selectdel", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 101, "Delete Atoms", "Delete Atoms", "Delete Atoms", "delete", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
//{0, 1, "Undelete", "Undelete", "Undelete Atoms", "undo", G_CALLBACK(c_undelete), NULL, -1, 1, 0},
{0, 101, "ReName", "ReName", "Rename Atoms", "rename_ico", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 101, "Change species", "Change species", "Change atomic species", "relabel", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 101, "ReNumber", "ReNumber", "ReNumber Atoms", "renumber", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 1, "Sort", "Sort", "Sort by Species", "sort", G_CALLBACK(c_sortbylabel), NULL, -1, 1, 0},
{0, 101, "Add Bonds", "Add Bonds", "Add Bonds", "bondon", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 101, "Del Bonds", "Del Bonds", "Delete Bonds", "bondoff", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 1, "ReGroup", "ReGroup", "Regroup Atoms", "regroup", G_CALLBACK(c_regroup), NULL, -1, 1, 0},
{0, 101, "Move Atoms", "Move Atoms", "Move Atoms", "moveatoms", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 101, "Complete", "Complete", "Complete 6-membered ring", "complete", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 101, "Regularize", "Regularize", "Regularize 6-membered ring", "regularize", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 101, "Tetrahedron", "Tetrahedron", "Complete Tetrahedron", "tetrahedron", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 101, "Octahedron", "Octahedron", "Complete Octahedron", "ballpoloff", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 101, "Add Atom", "Add Atom", "Add one Atom", "add1atom", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 101, "Site", "Site", "Modify site", "occupancy", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 80, "expanderModify", NULL, "expander", "void", NULL, NULL, 0, 0, 0},
{0, 7, "Back", "Back", "Back to main Toolbar", "back", G_CALLBACK(cancel_tb), NULL, -1, 1, 0}
};

static mr_action_entry tb_info[] = {
{0, 50, "iconInfo", NULL, "Info", "info_icon", NULL, NULL, -1, 1, 0},
{0, 12, "labelInfo ", "Info ", "label", NULL, NULL, NULL, -1, 1, 0},
{0, 4},
{0, 1, "Atoms Table", "Atoms Table", "Numeric Table", "numtab", G_CALLBACK(c_browserv2), NULL, 3, 1, 0},
{0, 1, "Tables", "Tables", "Publication Tables", "tables_ico", G_CALLBACK(open_tables), NULL, -1, 1, 0},
{0, 1, "Bar Chart", "Bar Chart", "Intensities bar chart", "barchart", G_CALLBACK(c_histograms), NULL, -1, 1, 0},
{0, 101, "Find", "Find", "Find atoms", "find", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 101, "Who", "Who", "Info on selected atoms", "who", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 1, "Output", "Output", "View output file", "output", G_CALLBACK(c_browserv2), NULL, 5, 1, 0},
{0, 1, "Summary", "Summary", "Summary of results", "summary", G_CALLBACK(c_browserv2), NULL, 1, 1, 0},
//{0, 1, "Supplementary", "Supplementary", "Supplementary Info", "contents", G_CALLBACK(c_supplementary), NULL, 1, 1, 0},
//{0, 1, "Histogram", "Histogram", "Trials graphics", "histogram", G_CALLBACK(c_doallgraphs), NULL, -1, 1, 0},
{0, 80, "expanderInfo", NULL, "expander", "void", NULL, NULL, 0, 0, 0},
{0, 7, "Back", "Back", "Back to Main Toolbar", "back", G_CALLBACK(cancel_tb), NULL, -1, 1, 0}
};

static mr_action_entry tb_geometry[] = {
{0, 50, "iconGeometry", "icon", "Geometry", "geometry", NULL, NULL, -1, 1, 0},
{0, 12, "labelGeometry ", "Geometry ", "label", NULL, NULL, NULL, -1, 1, 0},
{0, 4},
{0, 101, "Distances", "Distances", "Two atoms distance", "distances", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 101, "Sphere", "Sphere", "Distances around one atom", "dist_sfe", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 101, "Short distances", "Short distances", "Short distances table", "short_d", G_CALLBACK(c_browserv2), NULL, 8, 1, 0},
{0, 101, "Long distances", "Long distances", "Long distances table", "long_d", G_CALLBACK(c_browserv2), NULL, 9, 1, 0},
{0, 101, "Angles", "Angles", "Angles", "angles", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 101, "Torsion Angles", "Torsion Angles", "Torsion Angles", "tangles", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 101, "Geometric Calculations", "Geometric Calculations", "Geometric Calculations", "geomc_ico", G_CALLBACK(open_geocalc), NULL, -1, 1, 0},
{0, 80, "expanderGeom", NULL, "expander", "void", NULL, NULL, 0, 0, 0},
{0, 7, "Back", "Back", "Back to Main Toolbar", "back", G_CALLBACK(cancel_tb), NULL, -1, 1, 0}
};
#endif
static mr_action_entry tb_four[] = {
{0, 50, "iconFour", NULL, "Info", "fourier", NULL, NULL, -1, 1, 0},
{0, 12, "labelManage new peaks ", "Manage new peaks ", "label", NULL, NULL, NULL, -1, 1, 0},
{0, 4},
{0, 101, "FourDist", "FourDist", "Info on selected atoms", "who", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 1, "Plot Style", "Plot Style", "Plot Style", "plot_ico", G_CALLBACK(open_cplotstyle_dlg), NULL, -1, 1, 0},
{0, 3, "LabTogF", "LabTogF", "Labels On/Off", "labon", G_CALLBACK(toggle_label), NULL, -1, 1, 0},
{0, 101, "Change species", "Change species", "Change species", "relabel", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 80, "expanderFour", NULL, "expander", "void", NULL, NULL, 0, 0, 0},
{0, 7, "Back", "Back", "Back to Main Toolbar.", "back", G_CALLBACK(ok_tbfour), NULL, 0, 1, 0}
};

static mr_action_entry tb_idro[] = {
{0, 50, "iconIdro", NULL, "Info", "fourier", NULL, NULL, -1, 1, 0},
{0, 12, "Manage new peaks ", "Manage new peaks ", "label", NULL, NULL, NULL, -1, 1, 0},
{0, 4},
{0, 101, "FourDist", "FourDist", "Info on selected atoms", "who", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 1, "Plot Style", "Plot Style", "Plot Style", "plot_ico", G_CALLBACK(open_cplotstyle_dlg), NULL, -1, 1, 0},
{0, 3, "LabTogH", "LabTogH", "Labels On/Off", "labon", G_CALLBACK(toggle_label), NULL, -1, 1, 0},
{0, 101, "Accept hydrogen", "Accept hydrogen", "Accept hydrogen", "ok_idrogeni", G_CALLBACK(mostra_tbg1), NULL, -1, 1, 0},
{0, 80, "expanderHydro", NULL, "expander", "void", NULL, NULL, 0, 0, 0},
{0, 7, "Back", "Back", "Back to Main Toolbar.", "back", G_CALLBACK(ok_tbfour), NULL, 1, 1, 0}
};

static mr_action_entry tb_contour[] = {
{0, 50, "iconCont", NULL, "Info", "2D_contour", NULL, NULL, -1, 1, 0},
{0, 12, "labelCont", "Map contour", "label", NULL, NULL, NULL, -1, 1, 0},
{0, 4},
{0, 1, "Set Levels", "Set Levels", "Set Levels", "levels", G_CALLBACK(open_cont_dlg), NULL, 1, 1, 0},
{0, 1, "Set Limits", "Set Limits", "Set Limits & drawing Resolution", "contour_limiti", G_CALLBACK(open_cont_dlg), NULL, 2, 1, 0},
{0, 1, "ModelCont", "Model", "Model On/Off", "modelcont", G_CALLBACK(open_model_cont), NULL, -1, 1, 0},
{0, 3, "CellOnC", "CellOnC", "Cell On/Off", "cellon", G_CALLBACK(toggle_cell), NULL, -1, 1, 0},
{0, 4},
{0, 1, "Zoom In", "Zoom In", "Zoom In", "zoom_in", G_CALLBACK(view_options), NULL, 15, 1, 0},
{0, 1, "Zoom Out", "Zoom Out", "Zoom Out", "zoom_out", G_CALLBACK(view_options), NULL, 16, 1, 0},
{0, 1, "Reset View", "Reset View", "Reset the View", "reset", G_CALLBACK(view_options), NULL, 17, 1, 0},
{0, 4},
{0, 1, "Normal to a", NULL, "Normal to a", "alonga", G_CALLBACK(view_options), NULL, 21, 1, 0},
{0, 1, "Normal to b", NULL, "Normal to b", "alongb", G_CALLBACK(view_options), NULL, 22, 1, 0},
{0, 1, "Normal to c", NULL, "Normal to c", "alongc", G_CALLBACK(view_options), NULL, 23, 1, 0},
{0, 1, "Previous Section", "Previous Section", "Previous section", "prev_layer", G_CALLBACK(change_section), NULL, 0, 1, 0},
{0, 1, "Next Section", "Next Section", "Next section", "next_layer", G_CALLBACK(change_section), NULL, 2, 1, 0},
{0, 1, "Multi Section", "Multi Section", "Display many sections", "multi_layer", G_CALLBACK(open_cont_dlg), NULL, 3, 1, 0},
{0, 3, "Grid On/Off", "Grid On/Off", "Grid On/Off", "gridon", G_CALLBACK(toggle_grid), NULL, -1, 1, 0},
{0, 4},
{0, 1, "InfoCont", "Info", "About the Contour routine", "info_about", G_CALLBACK(about_contour), NULL, -2, 1, 0},
{0, 80, "expanderCont", NULL, "expander", "void", NULL, NULL, 0, 0, 0},
{0, 7, "Back", "Back", "Back to Main Toolbar.", "back", G_CALLBACK(ok_tbcontour), NULL, -1, 1, 0}
};

static mr_action_entry tb_run[] = {
{0, 50, "iconRun", "icon", NULL, "go", NULL, NULL, -1, 1, 0},
{0, 4},
{0, 12, "labelRun", "Info: ", "label", NULL, NULL, NULL, -1, 1, 0},
{0, 52, "entry", "entry", NULL, NULL, NULL, NULL, -1, 1, 0},
{0, 80, "expanderRun", NULL, "expander", "void", NULL, NULL, 0, 0, 0},
//{0, 7, "Stop", "Stop", "Stop the run", "stopr", G_CALLBACK(stop_run), NULL, 1, 0, 0},
//{0, -7, "Stopping", "Stopping", "Stopping the run", "ystopr", NULL, NULL, 1, 0, 0}
};

static mr_action_entry tb_gruppi[] = {
{0, 1, "SkipAtom", "Skip", "Skip atom", "nextgr", G_CALLBACK(skip_atom), NULL, -1, 1, 0},
{0, 4},
{0, 1, "TXminus", "TXminus", "Move left", "left_arrow", G_CALLBACK(move_rotate), NULL, 9, 1, 0},
{0, 1, "TXplus", "TXplus", "Move right", "right_arrow", G_CALLBACK(move_rotate), NULL, 10, 1, 0},
{0, 1, "TYminus", "TYminus", "Move down", "down_arrow", G_CALLBACK(move_rotate), NULL, 11, 1, 0},
{0, 1, "TYplus", "TYplus", "Move up", "up_arrow", G_CALLBACK(move_rotate), NULL, 12, 1, 0},
{0, 4},
{0, 1, "RXminus", "RXminus", "Rotate X-", "xminus", G_CALLBACK(move_rotate), NULL, 1, 1, 0},
{0, 1, "RXplus", "RXplus", "Rotate X+", "xplus", G_CALLBACK(move_rotate), NULL, 2, 1, 0},
{0, 1, "RYminus", "RYminus", "Rotate Y-", "yminus", G_CALLBACK(move_rotate), NULL, 3, 1, 0},
{0, 1, "RYplus", "RYplus", "Rotate Y+", "yplus", G_CALLBACK(move_rotate), NULL, 4, 1, 0},
{0, 1, "RZminus", "RZminus", "Rotate Z-", "zminus", G_CALLBACK(move_rotate), NULL, 5, 1, 0},
{0, 1, "RZplus", "RZplus", "Rotate Z+", "zplus", G_CALLBACK(move_rotate), NULL, 6, 1, 0},
{0, 4},
{0, 1, "Zoom In", "Zoom In", "Zoom In", "zoom_in", G_CALLBACK(view_options), NULL, 15, 1, 0},
{0, 1, "Zoom Out", "Zoom Out", "Zoom Out", "zoom_out", G_CALLBACK(view_options), NULL, 16, 1, 0},
{0, 4},
{0, 1, "Least Squares Plane", NULL, "Least Squares Plane", "least", G_CALLBACK(view_options), NULL, 18, 1, 0},
{0, 4},
{0, 1, "Reset View", "Reset View", "Reset the View", "reset", G_CALLBACK(view_options), NULL, 17, 1, 0},
{0, 4},
{0, 3, "GrOn", "GrOn", "Draw groups On/Off", "drawgroff", G_CALLBACK(toggle_drawgr), NULL, 1, 1, 0},
{0, 4},
{0, 7, "Cancel", "Cancel", "Cancel", "bigcancel", G_CALLBACK(cancel_gruppi), NULL, 0, 1, 0}
};

static mr_action_entry tb_g1[] = {
{0, 50, "iconG1", "icon", NULL, "void", NULL, NULL, -1, 1, 0},
{0, 4},
{0, 12, "labelG1", "label", NULL, NULL, NULL, NULL, -1, 1, 0},
{0, 13, "entryG1", "entry", NULL, NULL, NULL, NULL, -1, 1, 0},
{0, 5, "spinG1", "spin", NULL, "3, 1.5, 0.85, 4, 0.05, 1", G_CALLBACK(on_sfrad_changed), NULL, -1, 1, 0},
{0, 50, "iconG1b", "icon", NULL, "void", NULL, NULL, -1, 0, 0},
{0, 80, "expanderG1", NULL, "expander", "void", NULL, NULL, 0, 0, 0},
{0, 47, "icon_cest", "icon_cest", "Click on safe to restore hidden labels", "cassaforte_chiusa,cassaforte_aperta.png", G_CALLBACK(trashcan), NULL, -1, 1, 0},
{0, 7, "Close Polygon", "Close Polygon", "Close Polygon", "closep", G_CALLBACK(ok_tbselect), NULL, -1, 1, 0},
{0, 7, "Ok", "Ok", "OK", "ok", G_CALLBACK(ok_tb1), NULL, -1, 1, 0},
{0, 7, "BackG1", "Back", "Back to previous toolbar", "back", G_CALLBACK(cancel_tb), NULL, -1, 1, 0}
};

static mr_action_entry tb_run2[] = {
{0, 50, "iconRun2", "icon", NULL, "go", NULL, NULL, -1, 1, 0},
{0, 4},
{0, 12, "labelRun2", "Info: ", "label", NULL, NULL, NULL, -1, 1, 0},
{0, 52, "entryRun2", "entry", NULL, NULL, NULL, NULL, -1, 1, 0},
{0, 80, "expander", NULL, "expander", "void", NULL, NULL, 0, 0, 0},
{0, 1, "jav", "jav", "open viewer", "viewmol", G_CALLBACK(call_javs), NULL, 11, 1, 0},
//{0, 1, "Viewer", "Viewer", "graph", "newviewer", G_CALLBACK(nuovoviewer), NULL, -1, 1, 0},
{0, 7, "Skip", "Skip", "Skip to the next run", "nextgr", G_CALLBACK(skip_or_stop), NULL, 1, 1, 0},
{0, 7, "SkiporStop", "Stop", "Stop the procedure", "stopr", G_CALLBACK(skip_or_stop), NULL, 2, 1, 0}
};
static const guint n_entries[] = {
                                   G_N_ELEMENTS(tb_entries),
#if 0
                                   G_N_ELEMENTS(tb_view),
                                   G_N_ELEMENTS(tb_rotate),
                                   G_N_ELEMENTS(tb_translate),
                                   G_N_ELEMENTS(tb_modify),
                                   G_N_ELEMENTS(tb_info),
                                   G_N_ELEMENTS(tb_geometry),
#endif
                                   G_N_ELEMENTS(tb_four),
                                   G_N_ELEMENTS(tb_idro),
                                   G_N_ELEMENTS(tb_contour),
                                   G_N_ELEMENTS(tb_run),
                                   G_N_ELEMENTS(tb_gruppi),
                                   G_N_ELEMENTS(tb_g1),
                                   G_N_ELEMENTS(tb_run2)};

static gpointer toolbaritems[] = {(gpointer) tb_entries,
#if 0
                                   (gpointer) tb_view,
                                   (gpointer) tb_rotate,
                                   (gpointer) tb_translate,
                                   (gpointer) tb_modify,
                                   (gpointer) tb_info,
                                   (gpointer) tb_geometry,
#endif
                                   (gpointer) tb_four,
                                   (gpointer) tb_idro,
                                   (gpointer) tb_contour,
                                   (gpointer) tb_run,
                                   (gpointer) tb_gruppi,
                                   (gpointer) tb_g1,
                                   (gpointer) tb_run2};

static const char *Nomi[] =  { "toolbar_main",
#if 0
                               "toolbar_View",
                               "toolbar_Rotate",
                               "toolbar_Translate",
                               "toolbar_Modify Model",
                               "toolbar_Info",
                               "toolbar_Geometry",
#endif
                               "toolbar_four",
                               "toolbar_idro",
                               "toolbar_contour",
                               "toolbar_run",
                               "toolbar_RigidBody",
                               "toolbar_g1",
                               "toolbar_run2"};

#ifdef USE_ACTIONS
static const gchar *tbui_info[] =
{
"<ui>"
"  <toolbar name='toolbar_main'>"
"    <toolitem action='Exit'/>"
"    <toolitem action='New'/>"
"    <toolitem action='Load'/>"
"    <toolitem action='Old Project'/>"
"    <toolitem action='Save'/>"
"    <toolitem action='Restore'/>"
"    <separator/>"
"    <toolitem action='View'/>"
#if 0
"    <toolitem action='Modify Model'/>"
"    <toolitem action='SymmOn'/>"
"    <toolitem action='DrawGrOn'/>"
"    <separator/>"
"    <toolitem action='View'/>"
"    <toolitem action='togbg'/>"
"    <toolitem action='Area'/>"
"    <toolitem action='NoArea'/>"
"    <toolitem action='Reset View'/>"
"    <toolitem action='CellOn'/>"
#endif
"    <toolitem action='LabTog'/>"
#if 0
"    <toolitem action='Move Labels'/>"
"    <separator/>"
"    <toolitem action='Info'/>"
"    <toolitem action='Geometry'/>"
#endif
"    <toolitem action='Map viewer'/>"
"    <toolitem action='contour'/>"
"    <toolitem action='terminal'/>"
"  </toolbar>"
"</ui>",
#if 0
"<ui>"
"  <toolbar name='toolbar_View'>"
"    <toolitem action='iconView'/>"
"    <toolitem action='labelView'/>"
"    <separator/>"
"    <toolitem action='hide'/>"
"    <toolitem action='display'/>"
"    <toolitem action='change color'/>"
"    <toolitem action='Hide/Show Species'/>"
"    <toolitem action='show all'/>"
"    <separator/>"
"    <toolitem action='Rotate'/>"
"    <toolitem action='Translate'/>"
"    <toolitem action='Zoom In'/>"
"    <toolitem action='Zoom Out'/>"
"    <toolitem action='Reset View'/>"
"    <separator/>"
"    <toolitem action='Least Squares Plane'/>"
"    <toolitem action='Normal to a'/>"
"    <toolitem action='Normal to b'/>"
"    <toolitem action='Normal to c'/>"
"    <toolitem action='jav'/>"
"    <toolitem action='expanderView'/>"
"    <toolitem action='Back'/>"
"  </toolbar>"
"</ui>",
"<ui>"
"  <toolbar name='toolbar_Rotate'>"
"    <toolitem action='iconRotate'/>"
"    <toolitem action='labelRotate'/>"
"    <separator/>"
"    <toolitem action='Angle'/>"
"    <toolitem action='Speed'/>"
"    <toolitem action='spinRotate'/>"
"    <toolitem action='speed'/>"
"    <toolitem action='RC'/>"
"    <toolitem action='StopRot'/>"
"    <toolitem action='RXminus'/>"
"    <toolitem action='RXplus'/>"
"    <toolitem action='RYminus'/>"
"    <toolitem action='RYplus'/>"
"    <toolitem action='RZminus'/>"
"    <toolitem action='RZplus'/>"
"    <toolitem action='RVminus'/>"
"    <toolitem action='RVplus'/>"
"    <toolitem action='Define Vector'/>"
"    <toolitem action='expanderRotate'/>"
"    <toolitem action='Back'/>"
"  </toolbar>"
"</ui>",
"<ui>"
"  <toolbar name='toolbar_Translate'>"
"    <toolitem action='iconTranslate'/>"
"    <toolitem action='labelTranslate'/>"
"    <separator/>"
"    <toolitem action='Shift'/>"
"    <toolitem action='spin'/>"
"    <toolitem action='TXminus'/>"
"    <toolitem action='TXplus'/>"
"    <toolitem action='TYminus'/>"
"    <toolitem action='TYplus'/>"
"    <toolitem action='TZminus'/>"
"    <toolitem action='TZplus'/>"
"    <toolitem action='expanderTranslate'/>"
"    <toolitem action='Back'/>"
"  </toolbar>"
"</ui>",
"<ui>"
"  <toolbar name='toolbar_Modify Model'>"
"    <toolitem action='iconModify'/>"
"    <toolitem action='labelModify'/>"
"    <separator/>"
"    <toolitem action='delete'/>"
"    <toolitem action='Delete Atoms'/>"
//"    <toolitem action='Undelete'/>"
"    <toolitem action='ReName'/>"
"    <toolitem action='Change species'/>"
"    <toolitem action='ReNumber'/>"
"    <toolitem action='Sort'/>"
"    <toolitem action='Add Bonds'/>"
"    <toolitem action='Del Bonds'/>"
"    <toolitem action='ReGroup'/>"
"    <toolitem action='Move Atoms'/>"
"    <toolitem action='Complete'/>"
"    <toolitem action='Regularize'/>"
"    <toolitem action='Tetrahedron'/>"
"    <toolitem action='Octahedron'/>"
"    <toolitem action='Add Atom'/>"
"    <toolitem action='Site'/>"
"    <toolitem action='expanderModify'/>"
"    <toolitem action='Back'/>"
"  </toolbar>"
"</ui>",
"<ui>"
"  <toolbar name='toolbar_Info'>"
"    <toolitem action='iconInfo'/>"
"    <toolitem action='labelInfo '/>"
"    <separator/>"
"    <toolitem action='Atoms Table'/>"
"    <toolitem action='Tables'/>"
"    <toolitem action='Bar Chart'/>"
"    <toolitem action='Find'/>"
"    <toolitem action='Who'/>"
"    <toolitem action='Output'/>"
"    <toolitem action='Summary'/>"
//"    <toolitem action='Supplementary'/>"
//"    <toolitem action='Histogram'/>"
"    <toolitem action='expanderInfo'/>"
"    <toolitem action='Back'/>"
"  </toolbar>"
"</ui>",
"<ui>"
"  <toolbar name='toolbar_Geometry'>"
"    <toolitem action='iconGeometry'/>"
"    <toolitem action='labelGeometry '/>"
"    <separator/>"
"    <toolitem action='Distances'/>"
"    <toolitem action='Sphere'/>"
"    <toolitem action='Short distances'/>"
"    <toolitem action='Long distances'/>"
"    <toolitem action='Angles'/>"
"    <toolitem action='Torsion Angles'/>"
"    <toolitem action='Geometric Calculations'/>"
"    <toolitem action='expanderGeom'/>"
"    <toolitem action='Back'/>"
"  </toolbar>"
"</ui>",
#endif
"<ui>"
"  <toolbar name='toolbar_four'>"
"    <toolitem action='iconFour'/>"
"    <toolitem action='labelManage new peaks '/>"
"    <separator/>"
"    <toolitem action='FourDist'/>"
"    <toolitem action='Plot Style'/>"
"    <toolitem action='LabTogF'/>"
"    <toolitem action='Change species'/>"
"    <toolitem action='expanderFour'/>"
"    <toolitem action='Back'/>"
"  </toolbar>"
"</ui>",
"<ui>"
"  <toolbar name='toolbar_idro'>"
"    <toolitem action='iconIdro'/>"
"    <toolitem action='Manage new peaks '/>"
"    <separator/>"
"    <toolitem action='FourDist'/>"
"    <toolitem action='Plot Style'/>"
"    <toolitem action='LabTogH'/>"
"    <toolitem action='Accept hydrogen'/>"
"    <toolitem action='expanderHydro'/>"
"    <toolitem action='Back'/>"
"  </toolbar>"
"</ui>",
"<ui>"
"  <toolbar name='toolbar_contour'>"
"    <toolitem action='iconCont'/>"
"    <toolitem action='labelCont'/>"
"    <separator/>"
"    <toolitem action='Set Levels'/>"
"    <toolitem action='Set Limits'/>"
"    <toolitem action='ModelCont'/>"
"    <toolitem action='CellOnC'/>"
"    <separator/>"
"    <toolitem action='Zoom In'/>"
"    <toolitem action='Zoom Out'/>"
"    <toolitem action='Reset View'/>"
"    <separator/>"
"    <toolitem action='Normal to a'/>"
"    <toolitem action='Normal to b'/>"
"    <toolitem action='Normal to c'/>"
"    <toolitem action='Previous Section'/>"
"    <toolitem action='Next Section'/>"
"    <toolitem action='Multi Section'/>"
"    <toolitem action='Grid On/Off'/>"
"    <separator/>"
"    <toolitem action='InfoCont'/>"
"    <toolitem action='expanderCont'/>"
"    <toolitem action='Back'/>"
"  </toolbar>"
"</ui>",
"<ui>"
"  <toolbar name='toolbar_run'>"
"    <toolitem action='iconRun'/>"
"    <separator/>"
"    <toolitem action='labelRun'/>"
"    <toolitem action='entry'/>"
"    <toolitem action='expanderRun'/>"
//"    <toolitem action='Stop'/>"
//"    <toolitem action='Stopping'/>"
"  </toolbar>"
"</ui>",
"<ui>"
"  <toolbar name='toolbar_RigidBody'>"
"    <toolitem action='SkipAtom'/>"
"    <separator/>"
"    <toolitem action='TXminus'/>"
"    <toolitem action='TXplus'/>"
"    <toolitem action='TYminus'/>"
"    <toolitem action='TYplus'/>"
"    <separator/>"
"    <toolitem action='RXminus'/>"
"    <toolitem action='RXplus'/>"
"    <toolitem action='RYminus'/>"
"    <toolitem action='RYplus'/>"
"    <toolitem action='RZminus'/>"
"    <toolitem action='RZplus'/>"
"    <separator/>"
"    <toolitem action='Zoom In'/>"
"    <toolitem action='Zoom Out'/>"
"    <separator/>"
"    <toolitem action='Least Squares Plane'/>"
"    <separator/>"
"    <toolitem action='Reset View'/>"
"    <separator/>"
"    <toolitem action='GrOn'/>"
"    <separator/>"
"    <toolitem action='Cancel'/>"
"  </toolbar>"
"</ui>",
"<ui>"
"  <toolbar name='toolbar_g1'>"
"    <toolitem action='iconG1'/>"
"    <separator/>"
"    <toolitem action='labelG1'/>"
"    <toolitem action='entryG1'/>"
"    <toolitem action='spinG1'/>"
"    <toolitem action='iconG1b'/>"
"    <toolitem action='expanderG1'/>"
"    <toolitem action='icon_cest'/>"
"    <toolitem action='Close Polygon'/>"
"    <toolitem action='Ok'/>"
"    <toolitem action='BackG1'/>"
"  </toolbar>"
"</ui>",
"<ui>"
"  <toolbar name='toolbar_run2'>"
"    <toolitem action='iconRun2'/>"
"    <separator/>"
"    <toolitem action='labelRun2'/>"
"    <toolitem action='entryRun2'/>"
"    <toolitem action='expander'/>"
"    <toolitem action='jav'/>"
//"    <toolitem action='Viewer'/>"
"    <toolitem action='Skip'/>"
"    <toolitem action='SkiporStop'/>"
"  </toolbar>"
"</ui>"
};
#endif
