c------------------------------------------------------------------
c     subroutine to calculate the signal to noise ratio
c             z = <alfa_h>/sigma_(alfa_h)
c     Dritan + Raimond, 21 may 1992
c     NEW VERSION JUNE 1993
c------------------------------------------------------------------
c icont=1 from invar
c icont=2 from phase
c
      subroutine cumalf_z(icont,numb,alfest,alfvar)
      
      USE General
      real alfest(*),alfvar(*)
     
      common/plotpz/disz1(101),rangenz(101),itotal

      real z(5000),rangealf(101),cumalf(101),cumnz(101),disalf(101),
     +  disalf1(101),disz(101)

      integer hisalf(101),hisnz(101)

      nrang=26

      do 5 i=1,numb
        z(i)=0.0
        if(icont.eq.1)alfvar(i)=sqrt(alfvar(i))
        if(alfvar(i).lt.0.000001) go to 5
        z(i)=alfest(i)/alfvar(i)
 5    continue

      do 10 i=1,nrang
        cumalf(i)=0.0
        cumnz(i)=0.0
        disz1(i)=0.0
        disz(i)=0.0
        disalf1(i)=0.0
        disalf(i)=0.0
        hisalf(i)=0
        hisnz(i)=0
   10 continue

      call sortall(1,z,numb)
      zmin=0.0
      zmax=z(numb)
      dev=zmax-zmin
      dev=dev/float(nrang-1)
      rangenz(1)=0.0
      do 15 i=2,nrang-1
       rangenz(i)=rangenz(i-1)+dev
   15 continue
      rangenz(nrang)=zmax


      call sortall(1,alfest,numb)
      alfmin=0.0
      alfmax=alfest(numb)
      dev=alfmax-alfmin
      dev=dev/float(nrang-1)
      rangealf(1)=0.0
      do 20 i=2,nrang-1
       rangealf(i)=rangealf(i-1)+dev
   20 continue
      rangealf(nrang)=alfmax

      m=2
      nn=0

      ma=2
      nna=0

      do 25 i=1,numb
         if (z(i).le.rangenz(m)) then
           nn=nn+1
           hisnz(m)=nn
         else
           nn=1
  23       m=m+1
           if (m.gt.nrang) m=nrang
           if (z(i).le.rangenz(m)) then
             hisnz(m)=nn
           else
             goto 23
           endif
         endif
         if (alfest(i).le.rangealf(ma)) then
           nna=nna+1
           hisalf(ma)=nna
         else
           nna=1
   24      ma=ma+1
           if (ma.gt.nrang) ma=nrang
           if (alfest(i).le.rangealf(ma)) then
              hisalf(ma)=nna
           else
              goto 24
           endif
         endif
   25 continue
      cumnz(nrang) =float(hisnz(nrang))/float(numb)
      cumalf(nrang)=float(hisalf(nrang))/float(numb)
      do 40 i=1,nrang-1
        cumnz(nrang-i) =cumnz(nrang+1-i) +hisnz(nrang-i) /float(numb)
        cumalf(nrang-i)=cumalf(nrang+1-i)+hisalf(nrang-i)/float(numb)
   40 continue
c-----------------------------------------
c calc. of P(alfa)=f(alfa) and P(z)=f(z)
c-----------------------------------------
      do i=1,nrang
        disalf(i)=float(hisalf(i))/float(numb)
        disz(i)  =float(hisnz(i))/float(numb)
      enddo     
        disz1(1)  =(disz(1)+disz(2))/2.0
        disalf1(1)=(disalf(1)+disalf(2))/2.0
      do i=2,nrang-2
        disz1(i)  =(disz(i-1)+disz(i)+disz(i+1))/3.0
        disalf1(i)=(disalf(i-1)+disalf(i)+disalf(i+1))/3.0
      enddo
        disz1(nrang-1)  =(disz(nrang-2)+disz(nrang))/2.0
        disalf1(nrang-1)=(disalf(nrang-2)+disalf(nrang))/2.0
c******** print the results:
      write(lo,*)
      write(lo,*)'          *******************************************'
      write(lo,*)'          *                                         *'
      write(lo,*)'          *   P(z):distribution of z=alfest/alfvar  *'
      write(lo,*)'          *                                         *'
      write(lo,*)'          *******************************************'
      write(lo,*)
      write(lo,90)
   90 format(/)
      write(lo,*)'              a :alfest'
      write(lo,*)'              z :alfest/alfvar'
      write(lo,*)'              H: histogram'
      write(lo,*)'              C: cumulative probability distribution
     * and'
      write(lo,*)'              P: probability distribution '
      write(lo,100) 
      do 50 i=2,nrang
        write(lo,300) rangealf(i-1)/10.,rangealf(i)/10.,
     *   hisalf(i),cumalf(i),
     *   disalf(i),rangenz(i-1)/10.,rangenz(i)/10.,
     *   hisnz(i),cumnz(i),disz(i)
   50 continue
      write(lo,500) numb
  100 format(/,1x,'  range alfest',4x,'H(a)',3x,'C(a)',3x,
     * 'P(a)',5x,'range z',6x,'H(z)',3x,'C(z)',3x,'P(z)',/)
  300 format(1x,f6.2,' - ',    f6.2,1x,i6,2(1x,f6.3),1x,f6.2,' - ',f5.2,
     1 1x,i6,2(1x,f6.3))
  500 format(//,12x,'total number of strong reflections: ',i4,/)

c     do i=1,nrang
c     write(1,*)rangenz(i),disz(i)
c     enddo

      itotal=numb
      call plotpz_z(nrang)

      return
      end
c------------------------------------------------------------------
c  SUBROUTINE TO PLOT PZ=F(Z)
c        DRITAN 23.09.1993
c------------------------------------------------------------------
     
      subroutine plotpz_z(nrang)
      USE General

      common/plotpz/disz1(101),rangenz(101),itotal
      character symb1,symb0(80),symb2(80)

                 do i=1,80
                   symb0(i)=' '
                   symb2(i)='-'
                 enddo
      symb1='x'
      pzmax=-99999.99
      do 10 i=1,nrang
c      if(disz1(i).gt.pzmax.and.rangenz(i).le.24.0)pzmax=disz1(i)
       if(disz1(i).gt.pzmax)pzmax=disz1(i)
   10 continue
      write(lo,*)'                                 P(z)'
      write(lo,'(7x,a5,4(11x,f6.3))')'0.000',
     *  pzmax/4.,pzmax/2.,(3.*pzmax/4),pzmax
      write(lo,'(7x,75a1)')(symb2(k),k=1,74),'>'
c--
      ncol=int(disz1(1)*(72.0/pzmax))
c     write(lo,'(a7,a1,$)')'  .00','|'
      write(lo,'(a7,a1)')'  .00','|'
      if(ncol.ge.2)then
                    write(lo,'(3x,72a1)')(symb0(k),k=1,ncol-1),symb1
                  else
                    write(lo,'(3x,a1)')symb1
                  endif

c--
      ir=1
      do 20 i=2,nrang
      if(disz1(i).gt.pzmax)go to 20
      ncol=int(disz1(i)*(72.0/pzmax))
      if (ir.eq.4)then
c                   write(lo,'(2x,f5.2,a1,$)')rangenz(i-1),'|'
                    write(lo,'(2x,f5.2,a1)')rangenz(i-1),'|'
                    ir=1
                  else
c                   write(lo,'(7x,a1,$)')'|'
                    write(lo,'(7x,a1)')'|'
                    ir=ir+1
                  endif
      if(ncol.ge.2)then
                    write(lo,'(3x,72a1)')(symb0(k),k=1,ncol-1),symb1
                  else
                    write(lo,'(3x,a1)')symb1
                  endif
  20  continue
      write(lo,'(7x,a1)')'|'
      write(lo,'(3x,a5)')'Z   V'
      write(lo,100)itotal
  100 format(//,12x,'total number of strong reflections: ',i4,/)
c-------------
      return
      end
