!-----------------------------------------------------------------------
      subroutine DiffFourier(iWhichHeavy,numbset,ier)

      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMIR
      USE Mappa
      USE Atomi
      USE PhaseModule
!
c     write(lo,*)'Derivato:',iWhichHeavy,sc,bt
      dimension shi(4)
!
      if (knw.gt.0) then
         write(lo,*)'Phases for Diff. Fourier'
         call esamin(khl,mkang,ipub,iphaz,nrefl,1,
     *           wtt1,wt,erm,ermw,nref1,shi)
      endif

      ! controllare se serve ancora la scala tra Fo e Fd
      scfofd=1

      do i=1,nrefl
        fo = fovet(i)
        fd=fod(iWhichHeavy,i)
        fcoef(i)=(fd - fo) * wt(i)
        if (ksigma.gt.0) then
         if (fo.lt.4.*sigmav(i)) fcoef(i)=0.0
         if (fd.lt.4.*sigfd(iWhichHeavy,i)*scfofd) fcoef(i)=0.0
         endif
      enddo

      call MakeMap(fcoef,iphaz,nrefl,0,xmap,
     *                 FORTH,BACK)

c     call denhist(0,xmap,xmap,0,0)
      npic = nwd(1) / nsymTot
      nats = npic
c     write(lo,*)'NPIC:',npic,nats
      call pksrch_NewS(iWhichHeavy,ier)
!
      irefineTemp=5
      call LSQheavyStructure(irefineTemp,numbset,iWhichHeavy,ier)
      return
      end
!-----------------------------------------------------------------------
      subroutine pksrch_NewS(iWhichHeavy,ier)
!
!-- find positions of peaks by fitting quadratic function to 19 points
!
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom
      USE PhaseModule

      common/AtomsCurrentDer/natsCurrentDer,rfacCurrentDer
      common /misc/ ttt(3,3), dxmax(3),ishift(3,19)
      dimension xs(3),xs1(3)
      dimension xo(11),xn(11),key(10)
      dimension b(19)
      integer sidepp,inRegion
      integer np1(3),np2(3)

      ! server questo ?? .. ho dei problemi nel FreeLunch per neutroni
      ! quando cerco H
*gl*  if (neutro ==0) call xfl06
      if (neutro ==0) call LoadReflInfo
!
!--initialise constants
      dx = 1.0/float(np(1))
      dy = 1.0/float(np(2))
      dz = 1.0/float(np(3))
      limit = min0(MaxAtoms, npic)
      alevel = 0.01
      NumPeaks = 0
!
!--eventualmente limito la ricerca
      do i=1,3
         np1(i)=0
         np2(i)=np(i)-1
      enddo
c     write(6,*) 'occhio',np
c     write(6,*) 'occhio',np1
c     write(6,*) 'occhio',np2
!
!--initialise variables
!
      do iz=np1(3),np2(3)
       do iy=np1(2),np2(2)
        do_ix: do ix=np1(1),np2(1)
            b(10)=xmap(ix,iy,iz)
            if (b(10) < alevel) cycle
!--locate grid point with maximum density
            do i=1,19
              if(i==10) cycle
              jx = sidepp(ix+ishift(1,i),np(1))
              jy = sidepp(iy+ishift(2,i),np(2))  
              jz = sidepp(iz+ishift(3,i),np(3))
              b(i)=xmap(jx,jy,jz)
              if (b(10) <  b(i)) then
                  cycle do_ix
              elseif (b(10) == b(i)) then
c--scarto il picco solo se ho gia' preso uno vicino 
                do j=1,NumPeaks
                   if(jx==nint(xyzs(1,j)*np(1)).and.
     &                jy==nint(xyzs(2,j)*np(2)).and.
     &                jz==nint(xyzs(3,j)*np(3))) then
                      cycle do_ix
                   endif
                enddo
              endif
            enddo
!
            xs(1) = float(ix) * dx
            xs(2) = float(iy) * dy
            xs(3) = float(iz) * dz
!
!-- fit quadratic function to 19 points
!-- dens = a + c*x + d*y + e*z - 0.5*f*(x*x + y*y + z*z)
!
            b1 = b(3) + b(7) + b(9) + b(11) + b(13) + b(17)
            b2 = b(1) + b(2) + b(4) + b(5) + b(6) + b(8) + 
     &           b(12) + b(14) +  b(15) + b(16) + b(18) + b(19)
            f = (30.0 * b(10) + 11.0 * b1 - 8.0 * b2) / 63.0
            if(abs(f)>=0.001) then
              c = (b(5)+b(12)+b(13)+b(14)+b(19)
     &            -b(1)-b(6)-b(7)-b(8)-b(15))/10.0
              deltaxf = c / f
              if(abs(deltaxf)<1.0) then
                d = (b(4)+b(8)+b(11)+b(14)+b(18)
     &              -b(2)-b(6)-b(9)-b(12)-b(16))/10.0
                deltay = d / f
                if(abs(deltay)<1.0) then
                  e = (b(15)+b(16)+b(17)+b(18)+b(19)
     &                -b(1)-b(2)-b(3)-b(4)-b(5))/10.0
                  deltaz = e / f
                  if(abs(deltaz)<1.0) then
                    xs(1) = xs(1) + deltaxf * dx
                    xs(2) = xs(2) + deltay * dy
                    xs(3) = xs(3) + deltaz * dz
                  endif
                endif
              endif
            endif
!
!-- peak height interpolation - not suitable if peak shape is poor
!-- a = (9.0 * b(10) + 4.0 * b1 - b2) / 21.0
!-- b(10) = amax1(a+0.5*(c*deltaxf+d*deltay+e*deltaz), b(10))
!
            nop1 = NumPeaks+1
            xx=side(xs(1))
            yy=side(xs(2))
            zz=side(xs(3))
            xyzs(1,nop1) = xx
            xyzs(2,nop1) = yy
            xyzs(3,nop1) = zz
            xyzs(4,nop1) = b(10)
!
!--if two peaks are closer than dm angstroms eliminate the smaller
!
            if(NumPeaks > 0) then
             ir=0
             do k=1,nsymTot
               call oper(k,xs,xx,yy,zz)
               do_pk: do jj=1,NumPeaks
                  do l=1,3
                    xs1(l)=xs(l)-xyzs(l,jj)
                    do while(abs(xs1(l))>0.5)
                      xs1(l)=xs1(l)-sign(1.0,xs1(l))
                    enddo
                    if(abs(xs1(l))>dxmax(l)) cycle do_pk
                  enddo
                  if(quadr(xs1,xs1,ttt)<=dm) then 
                    if(ir>0) xyzs(4,ir)=0.0
                    ir=0
                    if(b(10) <= xyzs(4,jj) ) cycle do_ix
                    xyzs(1,jj)= xx
                    xyzs(2,jj)= yy
                    xyzs(3,jj)= zz
                    xyzs(4,jj)= b(10)
                    ir=jj
                  endif
               enddo do_pk
             enddo 
             if(ir>0) cycle do_ix
            endif
            NumPeaks=nop1
            if (NumPeaks .ge. limit) then
              if (NumPeaks > 1) then
                  call sortfNew(NumPeaks,4)
              endif
              NumPeaks = npic
              alevel = xyzs(4,npic) + 0.5
              limit = min0(MaxAtoms, 2*nats)
            endif
          enddo do_ix ! fine loop su ix
        enddo ! fine loop su iy
      enddo ! fine loop su iz
c-- sort peaks in order of peak height
      if (NumPeaks > 1) then
          call sortfNew(NumPeaks,4)
      endif

!
!-- calculate the occupancy
!
c     fnatm=float(natm)
c     fnatm=amax1(anat,fnatm)
c     focct=0.2*anat+anat
      iactn=1
      xo(:) = 0.0
      xn(:) = 0.0
      nats = min0(NumPeaks, nats)
      itype1 = 0
      do i=1,NumPeaks
         xo(1)=xyzs(1,i)
         xo(2)=xyzs(2,i)
         xo(3)=xyzs(3,i)
         iser=i
         iactn=1    ! da modificare
         khead=0
         ksp=kspecb(newvet,xo,xn,key,itype1,iser,khead,iactn)
         occ=1.0/float(key(10))
         xyzs(5,i) = occ
         !dritan
         if (neutro == 0) xyzs(4,i)=bt
c        write(lo,*) i,xyzs(1:3,i)
      enddo
!
      nats = min0(MaxAtoms, nats)
      nz(1:nats) = iWhichHeavy
!
c     if (kverbo.gt.0) then
c         npic=NumPeaks
c         write(lo,22) npic,nats,krecy,mode
c     endif
c22   format ('PKS npic =',i8,' nats =',i8,' krecy =',i4,' mode =',i4)
!
c-- create list 15 ( E-map peaks )
      interp=0
      numbrun = numset
*gl*  call frm15(interp)
      call PutGetXyzs(1, interp)
*     write(6,*) 'PK
!
      natsCurrentDer=NumPeaks
      return
      end
!-----------------------------------------------------------------------
      integer function sidep(nterm0,isez)
!
      USE Mappa
!
      ntermm = nterm0
      if (ntermm < 0) ntermm = ntermm + np(isez)
      if (ntermm >= np(isez)) ntermm = ntermm - np(isez)
      sidep = ntermm
!
      return
      end
!-----------------------------------------------------------------------
c     sort peaks in order of peak height or in order of plotting
      subroutine sortfNew(natomi,n)
      USE Atomi
      dimension t(5)
!
      int=2
 1000 int=int+int
      if(int.lt.natomi)go to 1000
      int=min0(natomi,(3*int)/4-1)
 1020 int=int/2
      ifin=natomi-int
      do 1200 ii=1,ifin
      i=ii
      j=i+int
      if(xyzs(n,i).ge.xyzs(n,j))go to 1200
      do 1060 k=1,5
      t(k)=xyzs(k,j)
 1060 continue
 1080 do 1100 k=1,5
      xyzs(k,j)=xyzs(k,i)
 1100 continue
      j=i
      i=i-int
      if(i)1140,1140,1120
 1120 if(xyzs(n,i).lt.t(n))go to 1080
 1140 do 1160 k=1,5
      xyzs(k,j)=t(k)
 1160 continue
 1200 continue
      if(int.ne.1)go to 1020
      return
      end
!-----------------------------------------------------------------------
      subroutine LSQheavyStructure(irefi,numbset,iWhichHeavy,ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMIR
      USE Atomi
      USE PhaseModule

c     structure factor least squares
c
c     irefi = 0 only structure factor computation
c     irefi = 1 only B has to be refined
c     irefi = 2 only X's have to be refined
c     irefi = 3 B and X's have to be refined
c     irefi = 4 only Occ has to be refined
c     irefi = 5 Occ , B and X's have to be refined

      character*2 dire, diret,spa,jstep
      character*80 line,name
      character (len=200)   :: strInfo
      character (len=80)    :: strHead(3)


      dimension  vet(40), ivet(40)

      common/AtomsCurrentDer/natsCurrentDer,rfacCurrentDer
      common/sigmaHP/sigmaP
      dimension i1(3),i2(3)
      dimension f(9),shi(4),x_save(5,500)
      dimension xo(11),xn(11),keyx(10)
c     dimension itype1(80),nz_orde(500)
      dimension nz_orde(500)
      real nz_temp(500)
      real, allocatable    ::deltaCut(:)
      real, allocatable   ::xplot(:),yplot(:)
      
      character specie*2
*     dimension cost(360)
*     equivalence (sint(91),cost(1))

      real, allocatable ::fcref(:),foref(:)



      write(lo,1)
  1   format(//5x,'Derivatives Substructure Refinemet',/
     +         5x,'----------------------------------',/)

*gl*  call yfl02    !!gl
*gl*  call musym()  !!gl

      allocate(fcref(nrefl),foref(nrefl), stat=ier)
      
      shi(1)=0.0
      shi(2)=0.0
      shi(3)=0.0
      shi(4)=1.0

      itp=nalfd(iWhichHeavy)
      write(lo,40)
      do 30 i=1,nats
        do j=1,3
          xyzs(j,i)=shi(4)*xyzs(j,i)-shi(j)
          if (xyzs(j,i).lt.0.0) xyzs(j,i)=xyzs(j,i)-int(xyzs(j,i))+1.0
          if (xyzs(j,i).ge.1.0) xyzs(j,i)=xyzs(j,i)-int(xyzs(j,i))
          enddo
      write(lo,41)itp,(xyzs(j,i),j=1,5)
 30   continue
 40   format(3x,'Atom ',7x,'X',9x,'Y',9x,'Z',9x,'B',9x,'OCC')
 41   format(5x,a2,2x,5f10.4)


      write(lo,'(/," Number of Heavy Atoms: ",i4)')nats
      write(strInfo,'(24h Number of Heavy Atoms: ,i4)')nats

      iref = irefi

      if (iref.ge.2) then
      khead=0
      iactn=2
      ifspec=0
      kpol=0

      xo(:)=0.0
      xn(:)=0.0

      call xspinb
      itype1 = 0
      do 130 i=1,nats
         do 100 j=1,3
            xo(j)=xyzs(j,i)
  100    continue
         iser=i
         k=kspecb(newvet,xo,xn,keyx,itype1,iser,khead,iactn)
         !print*,'k=',k
         iflk=0
         do 110 j=1,3
            ke=keyx(j)
             !print*,'ke',ke
            if (ke.ne.0.and.ke.ne.j) iflk=1
            kcond(j,i)=keyx(j)
  110    continue
         !print*,'iflk',iflk
         if (iflk.eq.1) then
             do 120 j=1,3
                kcond(j,i)=0
  120        continue
             endif
  130 continue

      !print*,'kpol',kpol
      if (kpol.ne.0) then
                       jpol=kpol
                       i100=100
                       do 140 i=1,3
                       k=jpol/i100
                       if (k.ne.0) kcond(i,1)=0
                       jpol=jpol-k*i100
                       i100=i100/10
  140                  continue
                     endif
c
                   endif
c

      gof=100.0
      gofold=gof
      gofsold=gof
      gofmin=0.5
      if (iref.eq.4) gofmin=-1.0
      bt3=5.0*bt

      dump = 0.5
      odump = 0.2
      k1=0
      k2=0

      !kcond(:,:)=0
      if (iref.eq.1) then
                            k1=4
                            k2=4
                            jstep='B'
      else if (iref.eq.2) then
                            k1=1
                            k2=3
                            jstep='C'
      else if (iref.eq.3) then
                            k1=1
                            k2=4
                            jstep='B'
      else if (iref.eq.4) then
                            k1=5
                            k2=5
                            jstep='O'
      else if (iref.eq.5) then
                            k1=1
                            k2=5
                            jstep='T'
                          else
                            jstep='A'
                          endif
      if (4.ge.k1.and.4.le.k2) then
                                 do 150 i=1,nats
                                 kcond(4,i)=1
  150                            continue
                               endif
      if (5.ge.k1.and.5.le.k2) then
                                 do 155 i=1,nats
                                 kcond(5,i)=1
  155                            continue
                               endif

c
c     print*,'Nr. specie',nkd
      nz_temp(1:nats)=float(nz(1:nats))
      do i=1,nats
       nz_orde(i)=i
      enddo
      call sortall3(1,nz_temp,nats,nats,nz_orde)
      !print*,nz_orde(1:nats)
c     print*,'Condition ref. global:'
      itp_o=0
      !kcond(1:3,1:nats)=0
      do i=1,nats
         ii=nz_orde(i)
         itp=int(abs(nz_temp(i)))
        if (itp > 0) then
         if (itp/=itp_o.or.i==1) then
c         kcond(5,ii)= 0
          itp_o=itp
         endif
         if (itp > 100) itp=mod(itp,100)
c        print*,i,itp
         itps=nalfd(itp)
         if (k1 > 0 .and.k2 > 0) then
c          print*,'Atom',ii,itps,kcond(k1:k2,ii)
         else
c          print*,'Atom',ii,itps
         endif
        endif
      enddo


      allocate(deltaCut(nrefl),stat=ierr)
      ic=0
      do i=1,nrefl
        ic=ic+1
        deltaCut(ic)=abs(fovet(i)-fod(iWhichHeavy,i))
      enddo
      call sortall(-1,deltaCut,ic)
      perCut=0.7
      nRefCut=nint(ic*perCut)
      sogDeltaCut=deltaCut(nRefCut)
c     write(lo,*)nRefCut,sogDeltaCut
      

      jstop=0
      if (iref.eq.0) then
       jCalcPhase=1
      else
       jCalcPhase=0
      endif
      erre_old=100.0

      nlsm=100
      scale=1.0
      oscale=1.0
      sogErre=0.0001
      x_save(1:5,1:nats) = xyzs(1:5,1:nats)


      allocate(xplot(nlsm),yplot(nlsm), stat = ierr)


       select case (irefi)
          case (0)
            write(strInfo,'(34h Parameters to be refined: nothing)')
          case (1)
            write(strInfo,'(26h Parameters to be refined:, 
     *                    4h bt )')
          case (2)
            write(strInfo,'(26h Parameters to be refined:, 
     *                    7h x y z )')
          case (3)
            write(strInfo,'(26h Parameters to be refined:, 
     *                    10h x y z bt )')
          case (4)
            write(strInfo,'(26h Parameters to be refined:, 
     *                    5h occ )')
          case (5)
            write(strInfo,'(26h Parameters to be refined:, 
     *                    14h x y z occ bt )')
       end select
       write(lo,'(a)')strInfo

       strHead(1)='Cycle'
       strHead(2)='R%'
       strHead(3)='LSQ substructure Refinement'


      npunti=0
      ngrid=0
      xgrid=-1.0
      ygrid=-1.0
      do 3000 nls=1,nlsm
        if (nls.eq.nlsm) iref=0
        scale=1.0/oscale
c       if (gof.lt.gofmin) jstop=1
c       if (jstop.eq.1.and.jCalcPhase.eq.0) goto 3000
        if (jstop.eq.1.or.nls.eq.nlsm) go to 4000
        gof =0.0
        agof=0.0
        gofs=0.0
        sumfo=0.0
        sumfor=0.0
        sumfc=0.0
        sumdf=0.0
        bison=0.0
        bisod=0.0
        fcref(:)=0.0
        foref(:)=0.0
        if (iref.ge.1) then
                       df1=0.0
                       df2=0.0
                       b11=0.0
                       b22=0.0
                       b12=0.0
                       do 200 jj=1,nats
                       do 200 k=k1,k2
                       deltaf(k,jj)=0.0
  200                  qvet(k,jj)=0.0
                       deltaP = 0.0
                       qvetP = 0.0
                     endif
      nrefUsed1=0.0
      do 500 i=1,nrefl
        if(fod(iWhichHeavy,i).le.0.0) then
           foref(i)=0.0
           goto 500
        endif

        if (jCalcPhase==0.and.fovet(i)<4.*sigmav(i)) then
          foref(i)=0.0
          goto 500
        endif
        if (jCalcPhase==0.and.
     *    fod(iWhichHeavy,i)< 4.*sigfd(iWhichHeavy,i)) then
          foref(i)=0.0
          goto 500
        endif

c       foref(i)=fod(iWhichHeavy,i) - fop(i)
        foref(i)=fod(iWhichHeavy,i)

        if (jCalcPhase==0 .and.foref(i) <= 0.0) then
            foref(i)=0.0
            goto 500
        endif
        
        if (jCalcPhase==0 .and.abs(fdelta(iWhichHeavy,i)) < 0.5) then
            foref(i)=0.0
           goto 500
        endif

        if (jCalcPhase==0 .and.wt(i) < 0.01) then
            foref(i)=0.0
           goto 500
        endif

        nrefUsed1=nrefUsed1+1
        i1(1:3)=khl(1:3,i)
        eps=epsv(i)

c
c-- compute H*R and H*T
c
        do 250 j=1,nsym
        t=1000.0
        do 230 l=1,3
        t=t+float(i1(l))*tmat(j,l)
        hkle(l,j)=0
c------------
        do 240 k=1,3
  240   hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)
c------------
  230   continue
        hkle(4,j)=t
  250   continue
        rho1=rhov(i)
        act=0.0
        bct=0.0

        actp=0.0
        bctp=0.0
        actn=0.0
        bctn=0.0
        act1=0.0
        bct1=0.0
        act2=0.0
        bct2=0.0
        sigH=0.0

        f11=ffirst(iWhichHeavy,1)
        f22=fsecon(iWhichHeavy,1)


        f(iWhichHeavy)=cld(iWhichHeavy)
        do 300 ii=1,4
        f(iWhichHeavy)=f(iWhichHeavy)+ald(ii,iWhichHeavy)*
     *                 exp(-bsd(ii,iWhichHeavy)*rho1)
  300   continue
        if (iref.ge.1) then
                       do 350 jj=1,nats
                       do 350 k=k1,k2
                       apdSir(k,jj)=0.0
                       bpdSir(k,jj)=0.0
  350                  continue
                     endif

        do 400 jj=1,nats
          if (nz(jj).eq.0) go to 400
          kz=nz(jj)
          if (kz > 100)  kz=mod(kz,100)
          fkz=f(kz)
          fkz1=fkz+f11
          arg=-xyzs(4,jj)*rho1
          effe=pts*fkz*exp(arg)
          tfocc=effe*xyzs(5,jj)
          tfocp=tfocc*twopi*float(icent+1)

          tfocc1=xyzs(5,jj)*fkz1*pts*exp(arg)
          tfocc11=xyzs(5,jj)*f11*pts*exp(arg)
          tfocc2=xyzs(5,jj)*f22*pts*exp(arg)

* accum. termini derivate  per la symmetry
          at=0.0
          bt=0.0
          do 410 j=1,nsym
          argS=amod(hkle(1,j)*xyzs(1,jj)
     *            +hkle(2,j)*xyzs(2,jj)
     *            +hkle(3,j)*xyzs(3,jj)
     *            +hkle(4,j),1.0)
          iarg=int(360.0*argS+0.5)+1
          iarg=mod(iarg+3600,360)
          if(iarg.lt.0) iarg=360+iarg
          if(iarg.eq.0) iarg=1
          if(iarg.eq.361) iarg=1
          at=at+cost(iarg)
          bt=bt+sint(iarg)

         if (iref.ge.2.and.jstop.eq.0.and.jCalcPhase==0) then
          do k=1,3
             hkltf=hkle(k,j)*tfocp*twopi
             apdSir(k,jj)=apdSir(k,jj)-hkltf*sint(iarg) ! A per le derivate X, Y, Z
             bpdSir(k,jj)=bpdSir(k,jj)+hkltf*cost(iarg)
          enddo
         endif

 410     continue
         if (icent.eq.0) then
             contc=at
             conts=bt
         else
             contc=2.0*at
             conts=0.0
         endif
*----------
          contc=contc*tfocc
          conts=conts*tfocc
          act=act+contc
          bct=bct+conts

*------ caso siras
        actp=actp+contc*tfocc1 - tfocc2*conts
        bctp=bctp+conts*tfocc1 + tfocc2*contc

        actn=actn+contc*tfocc1 + tfocc2*conts
        bctn=bctn-conts*tfocc1 + tfocc2*contc

        act2=act2 + tfocc2*contc
        bct2=bct2 + tfocc2*conts

        act1=act1 + tfocc1*contc
        bct1=bct1 + tfocc1*conts
*--------------        

          if (jCalcPhase==0) then
            if (kcond(4,jj).eq.1) then
             apdSir(4,jj)=-rho1*contc
             bpdSir(4,jj)=-rho1*conts
            endif
            if (kcond(5,jj).eq.1) then
             apdSir(5,jj)=     contc
             bpdSir(5,jj)=     conts
            endif
          endif

        sigH=sigH+fkz*fkz*exp(2.0*arg)*xyzs(5,jj)**2
  400 continue

      sigH=sigH*eps*nsym*pts
      args=act*act+bct*bct
c--
      if (args.gt.0.000001) then
         fc=sqrt(args)
         faze=atan2(bct,act)
         faze=faze*rtod+360.0
         if ( faze.gt.360.) faze=amod(faze,360.)
         fcH(iWhichHeavy,i)=fc
         iphazH(iWhichHeavy,i)=nint(faze)
         eH(iWhichHeavy,i)=fcH(iWhichHeavy,i)/sqrt(pts*sigH)
         ! calc Fd (derivato)
         if (jCalcPhase==0) then
         acp=fovet(i)*cos(float(iphaz(i))*dtor)
         bcp=fovet(i)*sin(float(iphaz(i))*dtor)
         act=acp+fc*cos(faze*dtor)
         bct=bcp+fc*sin(faze*dtor)
         args=act*act+bct*bct
         fc=sqrt(args)
         faze=rtod*atan2(bct,act)+360.0
         if ( faze.gt.360.) faze=amod(faze,360.)
         ac=act/fc
         bc=bct/fc
         endif
      else
         fcH(iWhichHeavy,i)=0.0
         eH(iWhichHeavy,i)=0.0
         iphazH(iWhichHeavy,i)=0
         fc=0.0
         faze=0.0
         ac=0.0
         bc=0.0
       endif
c-----
      args=actp*actp+bctp*bctp
      if (args.gt.0.000001) then
         fcp=sqrt(args)
         faze=atan2(bctp,actp)
         ifaze=nint(faze*rtod)
         ifaze=mod(ifaze+3600,360)
         if (ifaze.le.0) ifaze=360-ifaze
         Fc1Hpos(iWhichHeavy,i)=fcp
         iphazHpos(iWhichHeavy,i)=ifaze
      else
         Fc1Hpos(iWhichHeavy,i)=0.0
         iphazHpos(iWhichHeavy,i)=0
      endif
c---
      args=actn*actn+bctn*bctn
      if (args.gt.0.000001) then
         fcn=sqrt(args)
         faze=atan2(bctn,actn)
         ifaze=nint(faze*rtod)
         ifaze=mod(ifaze+3600,360)
         if (ifaze.le.0) ifaze=360-ifaze
         Fc1Hneg(iWhichHeavy,i)=fcn
         iphazHneg(iWhichHeavy,i)=ifaze
      else
         Fc1Hneg(iWhichHeavy,i)=0.0
         iphazHneg(iWhichHeavy,i)=0
      endif

      args=act1*act1+bct1*bct1
      if (args.gt.0.000001) then
         fc1=sqrt(args)
         faze=atan2(bct1,act1)
         ifaze=nint(faze*rtod)
         ifaze=mod(ifaze+3600,360)
         if (ifaze.le.0) ifaze=360-ifaze
         FcH_prime(iWhichHeavy,i)=fc1
         iphazH_prime(iWhichHeavy,i)=ifaze
      else
         FcH_prime(iWhichHeavy,i)=0.0
         iphazH_prime(iWhichHeavy,i)=0
      endif

      args=act2*act2+bct2*bct2
      if (args.gt.0.000001) then
         fc2=sqrt(args)
         faze=atan2(bct2,act2)
         ifaze=nint(faze*rtod)
         ifaze=ifaze+90
         ifaze=mod(ifaze+3600,360)
         if (ifaze.le.0) ifaze=360-ifaze
         FcH_second(iWhichHeavy,i)=fc2
         iphazH_second(iWhichHeavy,i)=ifaze
      else
         FcH_second(iWhichHeavy,i)=0.0
         iphazH_second(iWhichHeavy,i)=0
      endif

c--
 
      fcref(i)=fc
      sumfor=sumfor+foref(i)
c     foref(i)=foref(i)*scale
      df=foref(i)*scale-fc
      sumfo=sumfo+foref(i)*scale
      sumfc=sumfc+fc
      sumdf=sumdf+abs(df)

c     print*,i,foref(i),fcref(i),scale
c     stop
c
c--  accumulation of l.s. normal equations

          if (jCalcPhase==0) then
                       fcs=fc*scale
                       sw=-rho1*fc
                       b11=b11+fcs*fcs
                       b22=b22+sw *sw
                       b12=b12+fcs*sw
                       df1=df1+df*fcs
                       df2=df2+df*sw
                       do 450 jj=1,nats
                       do 450 k=k1,k2
                       if (kcond(k,jj).eq.0) go to 450
                       if (nz(jj).eq.0) go to 450
                       dfdb=apdSir(k,jj)*ac+bpdSir(k,jj)*bc
                       qvet(k,jj)=qvet(k,jj)+dfdb*dfdb
                       deltaf(k,jj)=deltaf(k,jj)+dfdb*df
  450                  continue
          endif
  500 continue

      if (jCalcPhase==1) then
        jstop=1
        goto 3000
      endif
c
c--  compute r-factor
      scalan=sumfc/sumfo
      oscales=oscale
      oscale=1.0/scalan
      sumdf=0.0
      sumfo=0.0
      do 510 i=1,nrefl
       if (foref(i).gt.0.0) then
         fsca=scalan*foref(i)
         sumdf=sumdf+abs(fcref(i)-fsca)
         sumfo=sumfo+fsca
       endif
  510 continue
      oscale = oscales
      erre=sumdf/sumfo
      rfac=100.0*erre
c     write(lo,540) nls,nlsm,jstep,rfac,scale,scalan,oscale
      write(lo,540) nls,nlsm,jstep,rfac
  540 format(' cycle #',i3,1x,i3,1x,a2,' r-fac.=',5f10.5)

c     if (nlsT.eq.1) then
c       if (nls/=1) then
c        inBoxGr(4) = inBoxGr(4) - 1
c       endif
c       nLinesGRSavR1 = nLinesGR
c       write(strInfo,'(6h R% : ,f6.2)')rfac
c       call TestoGR(strInfo, -1, 2, 4)
c       if (nls /= 1) then
c          nLinesGR = nLinesGRSavR1
c       endif
c      endif

c
      if (iref.eq.0) go to 3000

      DiffErre=erre_old-erre
      erre_old=erre

c
c--  compute correction for scale factor and thermal factor
c
      denom =  b11 * b22 - b12 * b12
      if (abs(denom).gt.0.0) then
                               dbm=(b11*df2-b12*df1)/denom
                               dg =(b22*df1-b12*df2)/denom
                             else
                               dbm=0.0
                               dg=0.0
                             endif
      if (abs(b22).gt.0.0) then
                             dbs=df2/b22
                           else
                             dbs=0.0
                           endif
      corr= dbm- dbs
c     corr= 0.0
c
c--  compute new scale-factor
c
      oscale=oscale+dg

c     OSCALE = 1.0

c
      nrej=0
c     if (nls ==1 ) goto 610   ! il primo ciclo solo la scala
c     print*,nats,k1,k2
      do 600 jj=1,nats
      if (nz(jj).eq.0) go to 600
      kz=nz(jj)
      if (kz > 100) kz=mod(kz,100)
      do 550 k=k1,k2
      if (kcond(k,jj).eq.0) go to 550
      if (abs(qvet(k,jj)).gt.0.0) then
        shift=deltaf(k,jj)/qvet(k,jj)
      else
         shift=0.0
      endif
      if (k.le.3) then
         ashift=shift*dump
         xnew=xyzs(k,jj)+ashift
c        write(lo,2000) nalfd(kz),jj,
c    *   xyzs(k,jj),ashift,xnew,deltaf(k,jj),qvet(k,jj)
         xyzs(k,jj)=xnew
      else if (k.eq.4) then
         ashift=(shift+corr)*dump
         bnew=xyzs(k,jj)+ashift
c        print*,shift,corr,dump
c        write(lo,2001) nalfd(kz),jj,
c    *   xyzs(k,jj),ashift,bnew,deltaf(k,jj),qvet(k,jj)
c
c-- reset occupancy factor if thermal factor is negative
c
          if (bnew.lt.0.0) bnew=0.1
c
         if (nz(jj).ne.0) then
             bison=bison+bnew*nod(kz)
             bisod=bisod+nod(kz)
             gof=gof+abs(ashift)
             gofs=gofs+ashift
             agof=agof+1.0
         endif
         xyzs(k,jj)=bnew
      else if (k.eq.5) then
         ashift=shift*odump
         occnew=xyzs(k,jj)+ashift
         if (occnew.lt.0.0) occnew=0.0
c        write(lo,2002) nalfd(kz),jj,
c    *   xyzs(k,jj),ashift,occnew,deltaf(k,jj),qvet(k,jj)
         xyzs(k,jj)=occnew
       endif
  550 continue
  600 continue
  610 continue

 2000 format(2x,'xyz ',a2,i3,3f10.5,2f15.1)
 2001 format(2x,'bt  ',a2,i3,3f10.5,2f15.1)
 2002 format(2x,'occ ',a2,i3,3f10.5,2f15.1)


       write(strInfo,'(24h Nr of Reflection Used: ,i5)')nrefUsed1

       if (npunti > 1) then
        write(strInfo,'(6h R% : ,f6.2)')rfac_temp
       endif
       write(strInfo,'(6h R% : ,f6.2)')rfac

       rfac_temp=rfac
       npunti=npunti+1
       xplot(npunti)=npunti
       yplot(npunti)=rfac

       call PlotLSQCycle(strHead,xplot,yplot,npunti,xgrid,ngrid)



       if (nls.gt.2) then
        if (DiffErre.lt.sogErre.or.DiffErre.lt.-0.03.
     *           or.nls.eq.nlsm) then
c        jstop=1
         rfacCurrentDer=rfac
         jCalcPhase=1
         xyzs(1:5,1:nats)=x_save(1:5,1:nats)
         write(lo,*)
         write(lo,40)
         do jj=1,nats
          kz=iabs(nz(jj))
          if (kz > 100) kz=mod(kz,100)
          itp=nalfd(kz)
          write(lo,41)itp,(xyzs(j,jj),j=1,5)
         enddo
        else
         x_save(1:5,1:nats)=xyzs(1:5,1:nats)
        endif
      else
         x_save(1:5,1:nats)=xyzs(1:5,1:nats)
      endif
c
      if (iref.eq.2.or.iref.eq.4) go to 3000
      if (abs(agof).gt.0.0) then
                             gof =gof /agof
                             gofs=gofs/agof
                            else
                             gof = 0.0
                             gofs= 0.0
                            endif
      if (nls.eq.1) gof=10+gof
      if (bisod.gt.0.0) then
                          bisox=bison/bisod
                          if (bisox.lt.bt) then
                                             biso=bt
                                           else
                                             biso=bisox
                                           endif
                        endif
c
c     bt3=3.0*biso
c
      !if (nrej.gt.0) call pkl15(nats)
      if (gof.gt.gofold) then
                           gofold=gof
                           gofsold=gofs
                           gof=0.0
                         else
                           gofold=gof
                           gofsold=gofs
                         endif
 3000 continue
 4000 continue


      numset=numbset
      numbrun = numset
      interp=0
*gl*  call frm15(interp)   !!gl
      call PutGetXyzs(1, interp)

*     call to_coord_prot(1,1)
c     call to_coord_sir(1,nrefl)

      deallocate(fcref,foref, stat=ier)
      return
      end
c--------------------------------------------------------------------
      subroutine FullLSQAnomalous(kfrag,nsetSegno,numbset,irefi,ier)

      USE General
      USE Symmetry
      USE Grafici

      USE Riflessi
      USE RiflessiMAD
      USE Atomi
      USE Molcom
      USE ExtendModule
      USE PhaseModule

c     structure factor least squares
c
c     irefi = 0 only structure factor computation
c     irefi = 1 only B has to be refined
c     irefi = 2 only X's have to be refined
c     irefi = 3 B and X's have to be refined
c     irefi = 4 only Occ has to be refined
c     irefi = 5 Occ , B and X's have to be refined
c     irefi = 6 Occ , B, X's, df' and f" have to be refined



      character*2 dire, diret,spa,jstep
      character*200 line,namef
      dimension  vet(40), ivet(40)

      character (len=10)    :: strSET
      character (len=80)    :: strHead(3)
      character (len=80)    :: tirang
      character (len=200)   :: strLog
      character (len=200)   :: strInfo

      integer PGOPEN
      character(1) ch
c     common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /conue/shi(4),ishi,shi1(4)
      common /anomLSQ/xLSQ(5,5,500),ffirstLSQ(5,5),fseconLSQ(5,5)
      common /scales/ scalan1(5),scalan2(5,5),scalan1o(5),scalan2o(5,5),
     *          scalem12(5)

      dimension xo(11),xn(11),keyx(10)
      dimension i1(3),i2(3)

      dimension scalan1p(5),scalan2p(5,5)

      dimension apdAno(5,500),bpdAno(5,500),
     *          apdReal(5,500),bpdReal(5,500)
      dimension apdOccAno(5,500),bpdOccAno(5,500),
     *          apdOccReal(5,5,500),bpdOccReal(5,5,500)


      dimension sumfo1(5),sumfo2(5,5),sumfc1(5),sumfc2(5,5),
     *          sumdf1(5),sumdf2(5,5),sumfmed(5)
      dimension deltafAnom(5,500),qvetAnom(5,500)
      dimension deltafOccAnom(5,500),qvetOccAnom(5,500)
      dimension deltafReal(5,5,500),qvetReal(5,5,500)
      dimension xAnom(5,500),xReal(5,5,500)
      dimension OccAnom(5,500),OccReal(5,5,500)
      dimension xAnom_Save(5,500),xReal_Save(5,5,500)
      dimension x_save(5,500),x_LSQ1(5,500),ffirst_LSQ1(5,5)
      dimension sumfpos(5),sumfneg(5),scale11(5),scale12(5,2)


      dimension deanoMed(5),rfacAnom(5),dano1(5),sogDeltaDisCut(5)
      dimension FprimoMed(5)

      dimension nz_orde(500)
      real nz_temp(500)
*     dimension cost(360)
*     equivalence (sint(91),cost(1))
      real btlimitM

      integer, dimension(5)   ::nrefUsed1

      real,     allocatable   ::deltano11(:),deltano22(:),deltano12(:)
      real,     allocatable   ::foref1(:,:),fcref1(:,:),pesoLSQanom(:,:)
      real,     allocatable   ::foref2(:,:,:),fcref2(:,:,:)
      real,     allocatable   ::xplot(:),yplot(:)
      real,     allocatable   ::dmat(:),amat(:,:),deriv(:),dmat1(:,:)
      integer,  allocatable   ::INDX(:)
      


c     dimension dmat(500),amat(500,500),INDX(500),deriv(500),
c    *          dmat1(500,500),corrp(500,500),icorrpMax(1)



      write(lo,*)'--------------------------------------------------'
      write(lo,*)'-- Anomalous Substructure Refinemet             --'
      write(lo,*)'--------------------------------------------------'

c     write(2,*)twopi,dtor
c     write(2,*)cost
c     write(2,*)sint
c     stop


      if (inBoxGR(4) > 0) then
       inBoxGR(4)=0
       nLinesGR=nLinesGRsaveBox(4)
      else
       nLinesGRsaveBox(4)=nLinesGR
      endif

      rfac_lsq1=0.0
      rfac_lsq2=0.0
      write(jrel,'(5hTRIAL,i4)')numbset
**    call flush(40)


      strHead(1)='Cycle'
      strHead(2)='R%'

      strHead(3)='LSQ substructure Refinement'

*gl*  call yfl02    !!gl
*gl*  call musym()  !!gl
*---------

c     if (irefi.gt.0) then
c        namef=fname(1)
c        k = index(namef,'.',.TRUE. )
c        namef = namef(1:k-1) // '_refine.frac'
c        open(1,file=namef,status='unknown')
c     endif

      do i=1,100
        natoms(i)=0
      enddo
      
      if (kfrag.gt.0) then
        nats=1
 50     read(kfrag,'(a)',end=26) line
        if (line(1:1).eq.'<'.or.line(1:1).eq.'>') goto 50
        call lcase (line)
        call shift(line,lenp)
        call cutst(line,lens,dire,lend)
        spa=dire(1:2)
        iopt=0
        call getnum(line,vet,ivet,iv,iopt)
        if(iopt.lt.0) write(lo,*) 'error iopt'

        if (vet(1).lt.0.0) vet(1)=vet(1)-int(vet(1))+1.0
        if (vet(2).lt.0.0) vet(2)=vet(2)-int(vet(2))+1.0
        if (vet(3).lt.0.0) vet(3)=vet(3)-int(vet(3))+1.0


        if (vet(1).gt.1.0) vet(1)=vet(1)-int(vet(1))
        if (vet(2).gt.1.0) vet(2)=vet(2)-int(vet(2))
        if (vet(3).gt.1.0) vet(3)=vet(3)-int(vet(3))

        !xyzs(1,nats)=vet(1)*invSegno
        !xyzs(2,nats)=vet(2)*invSegno
        !xyzs(3,nats)=vet(3)*invSegno

        xyzs(1,nats)=vet(1)
        xyzs(2,nats)=vet(2)
        xyzs(3,nats)=vet(3)

        if (iv.gt.3) then
            xyzs(4,nats)=vet(4)
            xyzs(5,nats)=vet(5)
            !xyzs(4,nats)=vet(5)
            !xyzs(5,nats)=1.0
        else
          xyzs(5,nats)=1.0
          if (bt.gt.0) then
             xyzs(4,nats)=bt
          else
             xyzs(4,nats)=40.0
          endif
        endif


        do 15 j=1,nkd
            write(diret,'(a2)')nalfd(j)
            if(spa.eq.diret) then
              nz(nats)=j
              natoms(j)=natoms(j)+1
            endif

            if (iv.gt.5) then
              ii=6
              do ider1=1,ndrmax
                ffirst(j,ider1)=vet(ii)
                fsecon(j,ider1)=vet(ii+1)
                ii=ii+2
              enddo
            endif
  15     continue

          nats=nats+1
          goto 50
  26     nats=nats-1
         numset=1
         numbrun = numset
         interp=0
*gl*     call frm15(interp)   !!gl
*gl*     call cp1530   !!gl
         call PutGetXyzs(1, interp)
         call SaveRestoreXyzs(1)
         rewind(kfrag)
      elseif(kfrag.eq.0) then
!       call srlin (15,lsn,lixx,ljxx,lkxx,llxx)
!       if (lixx.gt.0) then
        if (InfoOK(15) == 1) then
*gl*       call sfl15(interp)  !!gl
           call PutGetXyzs(2, interp)
           numset = numbrun
           if (numset.ne.numbset) then
               write(lo,10)
               ier=-1
               return
           endif
        else
           write(lo,20)
           ier=-1
           return
        endif
      endif
  10  format(/,' *** error *** No coordinates in direct access file
     *           for this set',/)
  20  format(/,' *** error *** No coordinates in direct access file',/)

*------------------------
c     kfrag=0

      write(lo,40)
      do 30 i=1,nats
      itp=iabs(nz(i))
      if (itp > 100)  itp=mod(itp,100)
      if (itp.ne.0) then
         itp=nalfd(itp)
         write(lo,41)itp,(xyzs(j,i),j=1,3),xyzs(4,i),xyzs(5,i)
      else
         write(lo,42)(xyzs(j,i),j=1,3),bt,xyzs(5,i)
      endif
 30   continue
 40   format(3x,'Atom ',7x,'X',9x,'Y',9x,'Z',9x,'B',9x,'OCC')
 41   format(5x,a2,2x,5f10.4)
 42   format(5x,'q ',2x,5f10.4)
 43   format(4x,a2,2x,3f8.3,i6,f12.3)

      write(ktml,*)
      write(ktml,'(28h    Substructure Refinement:)')
      write(ktml,'(36h    Number of Anomalous Scatterers: ,i4)')nats
**    call flush(ktml)
    
      strInfo='<big><b>LSQ Refinement:</b></big>'
      if (kscreen > 0 ) then
        call TestoGR(strInfo, color_RED, 2, 4)
        call TestoGR('&', -1, 1, 4)
      endif

      write(strInfo,'(33h Number of Anomalous Scatterers: ,i4)')nats
      if (kscreen > 0 ) then
        call TestoGR(strInfo, -1, 1, 4)
        call zflush
        call DoSingleIteration()
      endif


      iref = irefi
      kk1=0
      kk2=0

      if (iref.ge.2) then
      khead=0
      iactn=2
      ifspec=0
      kpol=0

      call xspinb

      do 130 i=1,nats
         xo(:)=0.0
         do 100 j=1,3
            xo(j)=xyzs(j,i)
  100    continue
         iser=i
         k=kspecb(newvet,xo,xn,keyx,itype1,iser,khead,iactn)
         !print*,'k=',k,keyx(1:10)
         iflk=0
         do 110 j=1,3
            ke=keyx(j)
             !print*,'ke',ke
            if (ke.ne.0.and.ke.ne.j) iflk=1
            kcond(j,i)=keyx(j)
  110    continue
         !print*,'iflk',iflk
         if (iflk.eq.1) then
             do 120 j=1,3
                kcond(j,i)=0
  120        continue
             endif
  130 continue

      !print*,'kpol',kpol
      if (kpol.ne.0) then
                       jpol=kpol
                       i100=100
                       do 140 i=1,3
                       k=jpol/i100
                       if (k.ne.0) kcond(i,1)=0
                       jpol=jpol-k*i100
                       i100=i100/10
  140                  continue
                     endif
c
                   endif
c

      allocate(deltano11(nrefl),deltano22(nrefl),deltano12(nrefl),
     *                                         stat = ierr)
      allocate(foref1(nds-1,nrefl),fcref1(nds-1,nrefl),stat=ierr)
      allocate(pesoLSQanom(nds-1,nrefl) ,stat=ierr)
      allocate(foref2(nds-1,nds-1,nrefl),fcref2(nds-1,nds-1,nrefl),
     *                                         stat=ierr)
      if (iref > 0.and.jFullMatrix==1) then
        allocate(deriv(500),dmat(500),amat(500,500),
     *           dmat1(500,500),INDX(500), stat=ierr)
      endif

      dump=0.5

      odump = 0.2
      adump = 0.1

c     odump = 0.01
c     adump = 0.01

      btlimit=bt/2.0
      btlimitM=0.0
      btlimitM=bt*4.0
      if (btlimit.lt.0.1) btlimit=10.0
      if (btlimitM.gt.80.0.or.btlimitM.le.0.0) btlimitM=80.0
      !kcond(:,:)=0
      if (iref.eq.1) then
                            kk1=4
                            kk2=4
                            jstep='B'
      else if (iref.eq.2) then
                            kk1=1
                            kk2=3
                            jstep='C'
      else if (iref.eq.3) then
                            kk1=1
                            kk2=4
                            jstep='B'
      else if (iref.eq.4) then
                            kk1=5
                            kk1=4
                            kk2=5
                            jstep='O'
      else if (iref.eq.5) then
                            kk1=1
                            kk2=5
                            jstep='T'
             if (numLsq > 0) jstep='TA'
                          else
                            jstep='A'
                          endif
      if (iref==6) kcond(1:5,1:nats)=0
      if (4.ge.kk1.and.4.le.kk2) kcond(4,1:nats)=1
      ! test bfac=cost
      !kcond(4,1:nats)=0 
      if (5.ge.kk1.and.5.le.kk2) kcond(5,1:nats)=1

      if (kk1==5.and.kk2==5) kcond(1:3,1:nats)=0

      if (numLsq > 0) iref=6

c
c     write(lo,*)'Number of atom specie',nkd
c     print*,nz(1:nats)
c     print*,nalfd(1:nats)
      nz_temp(1:nats)=real(nz(1:nats))
      do i=1,nats
       nz_orde(i)=i
      enddo
      call sortall3(1,nz_temp,nats,nats,nz_orde)
      !print*,nz_orde(1:nats)

c     write(lo,*)'Refinement Conditions:'
      itp_o=0
      !kcond(1:3,1:nats)=0
      
      do i=1,nats
         ii=nz_orde(i)
         itp=int(abs(nz_temp(i)))
         !print*,i,itp,itp_o
        if (itp > 0) then
         if (itp/=itp_o.or.i==1) then
          kcond(5,ii)=0
          itp_o=itp
         endif
         if (itp > 100) itp=mod(itp,100)
         itps=nalfd(itp)
c        write(lo,'(i3,1h),a2,5i2)')ii,itps,kcond(1:5,ii)
        endif
      enddo

      suzp2=0.0
      do ii=1,nk
         suzp2=suzp2+real(nw(ii)*no(ii)**2)
      enddo
      suza2=0.0
      do ii=1,nkd
        suza2=suza2+real(nwd(ii)*nod(ii)**2)
      enddo
c     write(lo,*)'<fa/fna>',ider1,suza2/suzp2

      ! definire la lungezza d'onda con f'=0.0 (la remote)
      ! nel caso che c'e' solo peak e inflection non fare l'aff. sul f'
      ! ffirst(itp,ider22)
      do ider=1,ndrmax
        ValFpMinMed=sum(abs(ffirst(1:nkd,ider)))
        ii=count(abs(ffirst(1:nkd,ider)) > 0.0)
        ValFpMinMed=ValFpMinMed/float(ii)
        FprimoMed(ider)=ValFpMinMed
      enddo
c     print*,FprimoMed(1:ndrmax)
c     print*,nAnomUsed(1:ndrmax)
      call sortall3(1,FprimoMed,1,ndrmax,nAnomUsed)
c     print*,FprimoMed(1:ndrmax)
c     print*,nAnomUsed(1:ndrmax)
c     stop

      do i=1,nrefl
          danoMedMad(i)=0.0
          DeltaxLSQ(i)=0.0
          if (ndrmax.gt.1) then
            ider11=nAnomUsed(1)
            ider12Used=0
            do ider=2,ndrmax
             ider22=nAnomUsed(ider)
             if (ider22.gt.0) then
              fp1=fpos(ider11,i)
              fp2=fpos(ider22,i)
              fn1=fneg(ider11,i)
              fn2=fneg(ider22,i)
              deltaDisp(ider22,i)=0.0
              deltaDisp12 = 0.0
              if (fp1.gt.0.0.and.fn1.gt.0.0) then
               fmedp=(fpos(ider11,i)+fneg(ider11,i))*0.5
              else
               fmedp=0.0
              endif
              if (fp2.gt.0.0.and.fn2.gt.0.0) then
               fmedq=(fpos(ider22,i)+fneg(ider22,i))*0.5
              else
               fmedq=0.0
              endif
              if (fmedq.gt.0.0.and.fmedp.gt.0.0) then
               deltaDisp(ider22,i)=abs(fmedq-fmedp)
               deltaDisp12 = deltaDisp12 + abs(fmedq-fmedp)
               ider12Used=ider12Used+1
              endif
             endif
            enddo
            if (ider12Used.gt.0) then
             ddisMedMad(i)=deltaDisp12/float(ider12Used)
            endif
          endif

          if (mkang(i).eq.1) then
           dano=0.0
           ider1Used=0
           do ider=1,ndrmax
             ider1=nAnomUsed(ider)
             if (ider1.gt.0) then
              fsec=fsecon(1,ider1)
              if (fpos(ider1,i).gt.0.0.and.fneg(ider1,i).gt.0.0) then
                ider1Used=ider1Used+1
                if (abs(fsec) > 0) 
     *            dano=dano+(fpos(ider1,i)-fneg(ider1,i))/fsec
              endif
             endif
           enddo
           if (ider1Used > 0) danoMedMad(i)=dano/float(ider1Used)
          endif

         if (abs(danoMedMad(i)).gt.0.0.and.
     *          abs(ddisMedMad(i)).gt.0.0) then
           DeltaxLSQ(i)=0.5*(abs(danoMedMad(i))+abs(ddisMedMad(i)))
         endif

      enddo


        ic=0
        do i=1,nrefl
          if (mkang(i).eq.1) then
          diffDano=0.0
          sumDano=0.0
          sumDanos=0.0
          do ider=1,ndrmax
             ider1=nAnomUsed(ider)
             if (ider1.gt.0) then
              fsec=fsecon(1,ider1)
              if (fpos(ider1,i).gt.0.0.and.fneg(ider1,i).gt.0.0) then
              dano=(fpos(ider1,i)-fneg(ider1,i))/fsec
              diffDano=diffDano+(dano-danoMedMad(i))**2
              sumDano=sumdano+abs(dano)
              sumDanos=sumdanos+dano
              dano1(ider1)=dano
              endif
             endif
          enddo

          if (sumDano.gt.0.0) then
            ic=ic+1
            sigDanoMedMad(i)=sqrt(diffDano)/sumDano
            deltano11(ic)=sigDanoMedMad(i)
            danoabsMedMad(i)=sumDano
            sdanoMedMad(i)=sumDanos
            deltano22(ic)=danoabsMedMad(i)
          endif

          endif
        enddo

*------- cut with sigDelta
        if (CutSigma.gt.0.0.and.ic.gt.0) then
          call cumgen(deltano11,ic)
          call sortall(-1,deltano11,ic)
          perCut=CutSigma
          nRefCut=nint(ic*perCut)
          sogSigCut=deltano11(nRefCut)
c         write(lo,*)'Cut re. with sigma',sogSigCut,perCut,nRefCut,ic
        endif

*--- cut with <deltaAno>
        sogAbsDe=0.0
        if (CutDeltaA.gt.0.0.and.ic.gt.0) then
          tirang='|delta_ano|'
          call ParamDistribution(tirang,0,deltano22,khl,ic,1,
     *     ipub,iphaz,
     *     shi1,work1,segni1,20,0.0)

          call sortall(-1,deltano22,ic)
          perCut=CutDeltaA
          nRefCut=nint(ic*perCut)
          sogAbsDe=deltano22(nRefCut)
c         write(lo,*)'Cut re. with sum|delta|',sogAbsDe,perCut,nRefCut,
c    *                                         ic
        endif

*--- cut with deltaDis
        if (CutDeltaD.gt.0.0) then
         if (ndrmax.gt.1) then
           do ider=2,ndrmax
            ider22=nAnomUsed(ider)
            ic1=0
            if (ider22.gt.0) then
              do i=1,nrefl
               if (deltaDisp(ider22,i).gt.0) then
                ic1=ic1+1
                deltano12(ic1)=deltaDisp(ider22,i)
               endif
              enddo

             if (ic1.gt.0) then
              tirang='|delta_dis|'
              call ParamDistribution(tirang,0,deltano12,khl,
     *         ic1,1,ipub,iphaz,shi1,work1,segni1,20,0.0)
              call sortall(-1,deltano12,ic1)
              perCut=CutDeltaD
              nRefCut=nint(ic1*perCut)
              sogDeltaDisCut(ider22)=deltano12(nRefCut)
c             write(lo,*)'Cut ref. with |de|dis',ider22,
c    *                 sogDeltaDisCut(ider22),perCut,nRefCut,ic1
            endif
            endif
           enddo
         endif
        endif

*-----------------------------------------
      xAnom(:,:)=0.0
      xAnom_Save(:,:)=0.0
      xReal(:,:,:)=0.0
      xReal_Save(:,:,:)=0.0

      do i=1,nats
        itp=iabs(nz(i))
        if (itp > 100) itp=mod(itp,100)
        if (itp.gt.0) then
        do ider1=1,ndrmax
         ider11=nAnomUsed(ider1)
         if (ider11.gt.0) then
           xAnom(ider11,itp)=fsecon(itp,ider11)
           !if(i.eq.1) write(lo,*)ffirst(itp,ider11),fsecon(itp,ider11)
        endif
        do ider2=ider1+1,ndrmax
          ider22=nAnomUsed(ider2)
           !ffirst(itp,1)=0.0
          if (ider11.gt.0.and.ider22.gt.0) then
           xReal(ider11,ider22,itp)=ffirst(itp,ider22)-
     *                              ffirst(itp,ider11)
           !print*,ider11,ider22,xReal(ider11,ider22,itp)
          endif
        enddo
       enddo
       endif
      enddo



      pesoAnom=1.0
      pesoAnomPhase=1.0
      rfacAnom=1.0
      pesoDis=1.0
      pesoDisPhase=1.0

      nlsm=500
      nlsm=100

      sogErre=0.0001
      ndrmax1=ndrmax
      ndrmax2=ndrmax

      ndrmaxUsed=0
      do ider1=1,ndrmax
         if (nAnomUsed(ider1).gt.0) ndrmaxUsed=ndrmaxUsed+1
      enddo

      nlsTmin=1
      nlsTm=2
      MsgGraficiGR(1) = '<span lang="Greek">D</span><sub>ano</sub>'
      MsgGraficiGR(2) = '<span lang="Greek">D</span>'
     *                   // '<sub>disp</sub>'



      iSuperCycleMax=1
      if (numLsq.eq.0) then
         nlsTm=1
         iSuperCycleMax=1
      endif
      if (numLsq.eq.1) then
         nlsTm=1
         iSuperCycleMax=1
      endif
      if (numLsq.eq.2) then
          nlsTm=2
          nlsTmin=2
          iSuperCycleMax=1
          MsgGraficiGR(1) = MsgGraficiGR(2)
          MsgGraficiGR(2) = ' '
      endif

      if (ndrmaxUsed.eq.1) then
          nlsTm=1
          nlsTmin=1
          iSuperCycleMax=1
      endif

      icsMin=minval(ics(1:ndrmax))

      if (icsMin < 50) then
      !  nlsTm=1
      !  nlsTmin=1
         iSuperCycleMax=1
      endif

      iSuperCycleMax=1
c     write(lo,*) 'Num Ref c.s =',icsMin
c     write(lo,*) 'AnumUse=',ndrmaxUsed
c     write(lo,*) 'nlsTmin,nlsTm',nlsTmin,nlsTm
c     write(lo,*) 'iSuperCycleMax',iSuperCycleMax
      jUsoPesi=1

      allocate(xplot(2*nlsm),yplot(2*nlsm), stat = ierr)

      iderRef=nAnomUsed(1)

      ! se df' di riferimento non e' un remoto non fare l'aff. df' (nlsT=2) ==> nlsTm=1
      if (FprimoMed(1) > 3.0) then
          nlsTm=1
          nlsTmin=1
      endif

c     do i=1,nats
c       print*,xyzs(1:5,i)
c     enddo
     
      do 4000  iSuperCycle=1,iSuperCycleMax

      npunti=0
      xgrid=0.0
      ygrid=0.0
      do 3500 nlsT=nlsTmin,nlsTm

      if (nlsT.eq.1) then
         ndrmax2=0
         if (numLsq > 0) then
          scalan1=1.0
          scalan1o=1.0
         endif
c         write(lo,*)'IREFI=',irefi,numLsq
          HistoOK(1)=1
          select case (irefi)
          case (0)
            write(strInfo,'(34h Parameters to be refined: nothing)')
            HistoOK(1)=0
          case (1)
            write(strInfo,'(26h Parameters to be refined:, 
     *                    4h bt )')
            write(strLog,'(24h    Refined parameters (, 
     *                    4h bt )')
          case (2)
            write(strInfo,'(26h Parameters to be refined:, 
     *                    7h x y z )')
            write(strLog,'(24h    Refined parameters (, 
     *                    7h x y z )')
          case (3)
            write(strInfo,'(26h Parameters to be refined:, 
     *                    10h x y z bt )')
            write(strLog,'(24h    Refined parameters (, 
     *                    10h x y z bt )')
          case (4)
            write(strInfo,'(26h Parameters to be refined:, 
     *                    5h occ )')
            write(strLog,'(24h    Refined parameters (, 
     *                    10h x y z bt )')
          case (5)
            write(strInfo,'(26h Parameters to be refined:, 
     *                    14h x y z occ bt )')
            write(strLog,'(24h    Refined parameters (, 
     *                    14h x y z occ bt )')
          end select
          if (numLsq > 0 ) then
            k=len_trim(strInfo)
            strInfo=strInfo(1:k) // ' f"'
            k=len_trim(strLog)
            strLog=strLog(1:k) // ' f")'
          endif
          if (kscreen > 0 ) then
            call TestoGR(strInfo, -1, 1, 4)
            call zflush
            call DoSingleIteration()
          endif

      else
         write(strLog,'(31h    Refined parameters ( occ df,a1,2h ))')
     *        char(39)
         write(strInfo,180)
  180 format(' Parameters to be refined: occ ',
     *       '<span lang="Greek">D</span>f',"'")
         
          if (kscreen > 0 ) then
            call TestoGR(strInfo, -1, 1, 4)
            call zflush
            call DoSingleIteration()
          endif
         scalan2=1.0
         scalan2o=1.0
         x_LSQ1(:,1:nats)=xyzs(:,1:nats)  ! memorizzare il modello per LSQ=1
         ffirst_LSQ1=ffirst
         ndrmax1=1
         ndrmax1=ndrmax-1
         ndrmax2=ndrmax
         kcond(1:4,1:nats)=0  ! affinare solo OCC
      endif

**    call flush(ktml)



      erre_old=100.0

      if (iref.eq.0) then
       jstop=1
       jCalcPhase=1
      else
       jstop=0
       jCalcPhase=0
      endif

c     print*,'scalan1',scalan1o
c     print*,'scalan1',scalan1

      fcAp(:,:)=0.0
      fcAn(:,:)=0.0
      foref1(:,:)=0.0
      fcref1(:,:)=0.0
      foref2(:,:,:)=0.0
      fcref2(:,:,:)=0.0

      ngrid=0

      do 3000 nls=1,nlsm

        icyAl=mod(nls,2)+1

        if (jstop.eq.1.and.jCalcPhase.eq.0) goto 3000
        if (jCalcPhase.eq.1) then
         ndrmax2=0
         ndrmax1=ndrmax
        endif
        do jj=1,nats
           do  k=1,5
              x_save(k,jj)=xyzs(k,jj)
           enddo
        enddo

        do kz=1,nkd
         do ider1=1,ndrmax
            xAnom_save(ider1,kz)=xAnom(ider1,kz)
             do ider2=ider1+1,ndrmax
               xReal_Save(ider1,ider2,kz)=xReal(ider1,ider2,kz)
            enddo
         enddo
        enddo



      df1=0.0
      df2=0.0
      b11=0.0
      b22=0.0
      b12=0.0

      if (iref.gt.0) then
      if (jFullMatrix==1) then
       kparamx=0
       deriv(:)=0.0
       dmat(:)=0.0
       amat(:,:)=0.0
       dmat1(:,:)=0.0
      endif

      do 200 jj=1,nats
      do 200 k=kk1,kk2
      deltaf(k,jj)=0.0
  200 qvet(k,jj)=0.0
       do kz=1,nkd
         do ider1=1,5
          deltafAnom(ider1,kz)=0.0
          qvetAnom(ider1,kz)=0.0
          do ider2=1,5
            deltafReal(ider1,ider2,kz)=0.0
            qvetReal(ider1,ider2,kz)=0.0
          enddo
         enddo
       enddo
       endif


      sumfo1=0.0
      sumfc1=0.0
      sumdf1=0.0
      sumfo2=0.0
      sumfc2=0.0
      sumdf2=0.0

      nrefUsed1(:)=0

      do 1000 i=1,nrefl

      i1(1:3) = khl(1:3,i)
      eps=epsv(i)
      multt=mult(i)
c
c-- compute H*R and H*T
c
      do 250 j=1,nsym
      t=1000.0
      do 230 l=1,3
      t=t+float(i1(l))*tmat(j,l)
      hkle(l,j)=0
c--------------
      do 240 k=1,3
  240 hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)
c--------------
  230 continue
      hkle(4,j)=t
  250 continue
      rho1=rhov(i)

      ider1u=0
      ider2u=0
      do 270 ider1=1,ndrmax1
        if (jCalcPhase.eq.0) then
          ider11=nAnomUsed(ider1)
        else
          ider11=nAnomUsed2(ider1)
        endif
        if (ider11.le.0) goto 270
        act0=0.0
        bct0=0.0
        actn=0.0
        bctn=0.0
        actp=0.0
        bctp=0.0
        act2=0.0
        bct2=0.0
        act1=0.0
        bct1=0.0
        sigH1=0.0

        if (jCalcPhase.eq.0) then
        !------------------------------

c       if (dreso(i) < 3.0) then
c         foref1(ider11,i)=0.0
c         fcref1(ider11,i)=0.0
c         goto 1000
c       endif

        if (nlsT==1) then
          fomed=0.5*(fpos(ider11,i)+fneg(ider11,i))
          famed=0.5*(fcAp(ider11,i)+fcAn(ider11,i))

          if (mkang(i) /= 1) then
             foref1(ider11,i)=0.0
             fcref1(ider11,i)=0.0
             goto 1000
          endif


          if (sogAbsDe > 0.0.and.danoabsMedMad(i).lt.sogAbsDe) then
             foref1(ider11,i)=0.0
             fcref1(ider11,i)=0.0
             goto 1000
          endif

         if (DanoSigma(ider11,i) > 5.0) then
          foref1(ider11,i)=0.0
          fcref1(ider11,i)=0.0
          goto 1000
         endif

         if (nls > 8 ) then
          if (fomed/famed < 0.4 .or.fomed/famed > 30.) then
             foref1(ider11,i)=0.0
             fcref1(ider11,i)=0.0
             goto 1000
          endif
         endif

        else
          if (icsMin > 50) then
            ! usare solo i riflessi c.s
            if (mkang(i).eq.1) then
             foref1(ider11,i)=0.0
             fcref1(ider11,i)=0.0
             goto 1000
            endif
          endif
        endif

        if (fpos(ider11,i).le.0.0) then
             foref1(ider11,i)=0.0
             fcref1(ider11,i)=0.0
             goto 1000
        endif
        if (fneg(ider11,i).le.0.0) then
             foref1(ider11,i)=0.0
             fcref1(ider11,i)=0.0
             goto 1000
        endif
        aa=fpos(ider11,i)/sigfpos(ider11,i)
        if (aa.lt.3.0) then
          foref1(ider11,i)=0.0
          fcref1(ider11,i)=0.0
          goto 1000
        endif
        aa=fneg(ider11,i)/sigfneg(ider11,i)
        if (aa.lt.3.0) then
          foref1(ider11,i)=0.0
          fcref1(ider11,i)=0.0
          goto 1000
        endif
        

        !------------------------------
       endif

        nrefUsed1(ider11)=nrefUsed1(ider11)+1
        actcr1=0.0
        bctcr1=0.0


        do ij=1,nkd
          ff(ij)=cld(ij)
          do  ii=1,4
           ff(ij)=ff(ij)+ald(ii,ij)*exp(-bsd(ii,ij)*rho1)
          enddo
        enddo

        if (jstop.eq.0) then
         do  jj=1,nats
              itp=nz(jj)
              if (itp > 100) itp=mod(itp,100)
              apdAno(ider11,itp)=0.0
              bpdAno(ider11,itp)=0.0
           do  k=kk1,kk2
              apdSir(k,jj)=0.0
              bpdSir(k,jj)=0.0
           enddo
         enddo
        endif


* termini derivate parametri globali per per L1  + termini derivate per Occ Anomala (f")
        sfj=0.0 
        do 400 jj=1,nats
        kz=nz(jj)
        if (kz > 100) kz=mod(kz,100)
        if (kz.eq.0) go to 400
        arg=-xyzs(4,jj)*rho1

        if (abs(xAnom(ider11,kz)) > 0)  then
          xAnom_temp = xAnom(ider11,kz)
        else
          xAnom_temp = 1.0
        endif

        tfocp1=xAnom_temp*xyzs(5,jj)*pts*exp(arg)  ! per le derivate x,y,z
        tfocO1=xAnom_temp*pts*exp(arg)             ! per le derivate OCC
        tfocO1a=xyzs(5,jj)*pts*exp(arg)            ! per le derivate f"


* accum. termini derivate  per la symmetry


      at=0.0
      bt=0.0
      do 410 j=1,nsym
      argS=amod(hkle(1,j)*xyzs(1,jj)
     *        +hkle(2,j)*xyzs(2,jj)
     *        +hkle(3,j)*xyzs(3,jj)
     *        +hkle(4,j),1.0)

      iarg=int(360.0*argS+0.5)+1
      if(iarg.eq.361) iarg=1

c     if (iarg < 0) then
c       print*,iarg,hkle(1:4,j),xyzs(1:3,jj)
c     endif

      at=at+cost(iarg)
      bt=bt+sint(iarg)

      if (iref.ge.2.and.jstop.eq.0) then
       do k=1,3
          hkltf=hkle(k,j)*tfocp1*twopi
          apdSir(k,jj)=apdSir(k,jj)-hkltf*sint(iarg) ! A per le derivate X, Y, Z
          bpdSir(k,jj)=bpdSir(k,jj)+hkltf*cost(iarg)
       enddo
      endif

 410  continue
      if (icent.eq.0) then
          contc=at
          conts=bt
      else
          contc=2.0*at
          conts=0.0
      endif
*----------

        if (nlsT.ne.2) then
        actcr1=actcr1 + tfocp1*contc   ! A per il Dano calc.
        bctcr1=bctcr1 + tfocp1*conts   ! B     "

        if (kcond(4,jj).eq.1) then
          apdSir(4,jj)= -2.0*rho1*contc   ! A per le derivate Bt
          bpdSir(4,jj)= -2.0*rho1*conts
        endif

        if (kcond(5,jj).eq.1) then
          apdSir(5,jj)= tfocO1*contc  ! A per le derivate Occ Anom
          bpdSir(5,jj)= tfocO1*conts
        endif

        if (iref.eq.6) then
          apdAno(ider11,kz)=  apdAno(ider11,kz)+tfocO1a*contc  ! A per le derivate Occ Anom
          bpdAno(ider11,kz)=  bpdAno(ider11,kz)+tfocO1a*conts
        endif

        endif


*--- calcolo A e B per : F+a , F-, F", F'
        !if (jCalcPhase.eq.1) then

          f1_1=ffirst(kz,ider11)
          f2_1=fsecon(kz,ider11)


          sc1=scalan1(ider11)*scalan1o(ider11)
          sc2=scalan2(iderRef,ider11)*scalan2o(iderRef,ider11)

          !sc1=scalan1p(ider11)
          !sc2=scalan2p(iderRef,ider11)
          !sc1=min(1.2,sc1)
          !sc2=min(1.2,sc2)
          !sc1=max(0.8,sc1!)
          !sc2=max(0.8,sc2)


          if (sc1 < 2.5 .and. sc1 > 0.7) f2_1=f2_1*sc1
          if (sc2 < 2.5 .and. sc2 > 0.7) f1_1=f1_1*sc2

          !f2_1=f2_1*sc1
          !f1_1=f1_1*sc2

          fkz=ff(kz) + f1_1

          fz2=(xyzs(5,jj)* ff(kz))**2
          sigH1=sigH1+ fz2*exp(2.0*arg)
          tfocc0=abs(xyzs(5,jj))*ff(kz)*pts*exp(arg)
          sfj=sfj+tfocc0

          tfocc1=abs(xyzs(5,jj))*fkz*pts*exp(arg)
          tfocc11=abs(xyzs(5,jj))*f1_1*pts*exp(arg)
          tfocc2=abs(xyzs(5,jj))*f2_1*pts*exp(arg)

          act0=act0+contc*tfocc0
          bct0=bct0+conts*tfocc0

          actp=actp+contc*tfocc1 - tfocc2*conts
          bctp=bctp+conts*tfocc1 + tfocc2*contc

          actn=actn+contc*tfocc1 + tfocc2*conts
          bctn=bctn-conts*tfocc1 + tfocc2*contc

          act2=act2 + tfocc2*contc
          bct2=bct2 + tfocc2*conts

          act1=act1 + tfocc11*contc
          bct1=bct1 + tfocc11*conts
        !endif

c----
 400  continue
*--- calcolo F+a , F-, F", F'

      !if (jCalcPhase.eq.1) then
c--- sf for substructure without anom disp
      sigHna(i)=nsym*eps*pts*sigH1
      args=act0*act0+bct0*bct0
      sfj = sfj*sqrt(eps*nsym)

      if (args.gt.0.000001) then
         fc=sqrt(args)
         faze=atan2(bct0,act0)
         ifaze=nint(faze*rtod)
         ifaze=mod(ifaze+3600,360)
         if (ifaze.le.0) ifaze=360-ifaze
         FcHna(i)=fc
         EcHna(i)=fc/sfj
         iphazHna(i)=ifaze
c        write(1,'(3i4,3f10.3)')i1,fc,EcHna(i),float(ifaze)
      else
         FcHna(i)=0.0
         iphazHna(i)=0
      endif
c---
      args=act2*act2+bct2*bct2
      if (args.gt.0.000001) then
         fc=sqrt(args)
         faze=atan2(bct2,act2)
         ifaze=nint(faze*rtod)
         ifaze=ifaze+90
         ifaze=mod(ifaze+3600,360)
         if (ifaze.le.0) ifaze=360-ifaze
         fcA2(ider11,i)=fc
         iphazA2(ider11,i)=ifaze
      else
         fcA2(ider11,i)=0.0
         iphazA2(ider11,i)=0
      endif

      args=act1*act1+bct1*bct1
      if (args.gt.0.000001) then
         fc=sqrt(args)
         faze=atan2(bct1,act1)
         ifaze=nint(faze*rtod)
         ifaze=mod(ifaze+3600,360)
         if (ifaze.le.0) ifaze=360-ifaze
         fcA1(ider11,i)=fc
         iphazA1(ider11,i)=ifaze
      else
         fcA1(ider11,i)=0.0
         iphazA1(ider11,i)=0
      endif
      args=actp*actp+bctp*bctp
      if (args.gt.0.000001) then
         fc=sqrt(args)
         faze=rtod*atan2(bctp,actp)
         faze=mod(faze+3600.,360.)
         if (faze.le.0) faze=360.-faze
         fcAp(ider11,i)=fc
         riphazAp(ider11,i)=faze
      else
         fcAp(ider11,i)=0.0
         riphazAp(ider11,i)=0
         eAp(ider11,i)=0.0
      endif
      args=actn*actn+bctn*bctn
      if (args.gt.0.000001) then
         fc=sqrt(args)
         faze=rtod*atan2(bctn,actn)
         faze=mod(faze+3600.,360.)
         if (faze.le.0) faze=360.-faze
         fcAn(ider11,i)=fc
         riphazAn(ider11,i)=faze
         acn=actn/fc
         bcn=bctn/fc
      else
         fcAn(ider11,i)=0.0
         riphazAn(ider11,i)=0.0
         eAn(ider11,i)=0.0
      endif

      !endif

*------ calcolo di Dano_calc
        args=actcr1*actcr1+bctcr1*bctcr1
        fc1=0.0
        if (args.gt.0.000001) then
           fc1=sqrt(args)
c          if (nls==3) write(2,*)fc1
           faze=rtod*atan2(bctcr1,actcr1)
           faze=mod(faze+3600.,360.)
           if (faze.le.0) faze=360.-faze
           actpT= cos(faze*dtor)
           bctpT= sin(faze*dtor)

           fo1=abs(fpos(ider11,i)-fneg(ider11,i))

           sigmed=sigfpos(ider11,i)**2 +sigfneg(ider11,i)**2
           if (sigmed.le.0.0) sigmed=1.0
c          sigmed=1.0

c          afo1=fpos(ider11,i)*sin(ipubp(ider11,i)*dtor)-
c    *           fneg(ider11,i)*sin(-ipubn(ider11,i)*dtor)
c          bfo1=fpos(ider11,i)*cos(ipubp(ider11,i)*dtor)-
c    *           fneg(ider11,i)*cos(-ipubn(ider11,i)*dtor)
c          fo1=sqrt(afo1**2+bfo1**2)*0.5
c          fo1=fcA2(ider11,i)

           df11=fo1-fc1*scalan1(ider11)

           peso=1.0/sigmed
           peso=peso*pesoAnom(ider11)
           pesoLSQanom(ider11,i)=peso
           foref1(ider11,i)=fo1
           fcref1(ider11,i)=fc1*scalan1(ider11)
           sumfo1(ider11)=sumfo1(ider11)+fo1*peso
           sumfc1(ider11)=sumfc1(ider11)+fc1*peso*scalan1(ider11)
        else

           foref1(ider11,i)=0.0
           fcref1(ider11,i)=0.0
           df11=0.0
           peso=0.0
        endif



c
c--  accumulation of l.s. normal equations
c
      if (nlsT.ne.2.and.jCalcPhase.eq.0) then
              fcs1=fc1*scalan1(ider11)
              sw1=-rho1*fc1
              b11=b11+fcs1*fcs1
              b22=b22+sw1 *sw1
              b12=b12+fcs1*sw1
              df1=df1+df11*fcs1
              df2=df2+df11*sw1

              kparam=0
              do 450 jj=1,nats
                 if (nz(jj).eq.0) go to 450
                 do 451 k=kk1,kk2
                   if (kcond(k,jj).eq.0) go to 451
                   dfdb1=apdSir(k,jj)*actpT+bpdSir(k,jj)*bctpT
                   !df11 ---> diff(Fo-fc)
                   if (jFullMatrix==1) then
                    kparam=kparam+1
                    deriv(kparam)=dfdb1  ! derivate per ogni parametro
                   endif
                   qvet(k,jj)=qvet(k,jj)+dfdb1*dfdb1*peso
                   deltaf(k,jj)=deltaf(k,jj)+dfdb1*df11*peso
  451            continue
  450         continue


              if (iref.eq.6) then
                  ider1u=ider1u+1
                  kparam=kparam+ider1u-1
                  do kz=1,nkd
                   if (iTypeAnom(kz)==1) then
                     dfdb=apdAno(ider11,kz)*actpT+
     *                  bpdAno(ider11,kz)*bctpT
                     qvetAnom(ider11,kz)=qvetAnom(ider11,kz)+
     *                                  dfdb*dfdb*peso
                     deltafAnom(ider11,kz)=deltafAnom(ider11,kz)+
     *                                   dfdb*df11*peso
                     if (jFullMatrix==1) then
                       kparam=kparam+1
                       deriv(kparam)=dfdb  ! derivate per f"
                     endif
                   endif
                  enddo
              endif

              if (jFullMatrix==1) then
               kparamx=max(kparam,kparamx)
                do 452 k1=1,kparam
                  dmat(k1)=dmat(k1)+(df11*deriv(k1))*peso
                  do 453 k2=1,kparam
                    amat(k1,k2)=amat(k1,k2)+deriv(k1)*deriv(k2)*peso
  453              continue
  452           continue
              endif

       endif


*--end TUTTO sul L1

        !ider2u=0
        !ider2u=ider1-1
        do 280 ider2=ider1+1,ndrmax2

         ider22=nAnomUsed(ider2)

         if (ider22.le.0) goto 280
         if (iref.gt.1) then
            foref2(ider11,ider22,i)=0.0
            fcref2(ider11,ider22,i)=0.0
            if (icsMin < 50) then
            if (deltaDisp(ider22,i).le.sogDeltaDisCut(ider22)) goto 1000
            endif
         endif

         actpT=0.0
         bctpT=0.0

         actcr2=0.0
         bctcr2=0.0

         do ij=1,nkd
          ff(ij)=cld(ij)
          do  ii=1,4
           ff(ij)=ff(ij)+ald(ii,ij)*exp(-bsd(ii,ij)*rho1)
          enddo
         enddo

        ff2=0.0
        sigH=0.0
        sigH2=0.0

        if (iref.ge.1) then
         do jj=1,nats
              kz=nz(jj)
              if (kz > 100) kz=mod(kz,100)
              apdReal(ider22,kz)=0.0
              bpdReal(ider22,kz)=0.0
              do  k=kk1,kk2
                apdSir(k,jj)=0.0
                bpdSir(k,jj)=0.0
              enddo
         enddo
        endif


        do 500 jj=1,nats
        kz=nz(jj)
        if (kz > 100) kz=mod(kz,100)
        if (kz.eq.0) go to 500
        arg=-xyzs(4,jj)*rho1


        tfocp2=xReal(ider11,ider22,kz)*xyzs(5,jj)*pts*exp(arg) ! per le derivate
        tfocO2=xReal(ider11,ider22,kz)*pts*exp(arg)
        tfocO2a=xyzs(5,jj)*pts*exp(arg)

      at=0.0
      bt=0.0
      do 510 j=1,nsym
      argS=amod(hkle(1,j)*xyzs(1,jj)
     *        +hkle(2,j)*xyzs(2,jj)
     *        +hkle(3,j)*xyzs(3,jj)
     *        +hkle(4,j),1.0)
      iarg=int(360.0*argS+0.5)+1
      if(iarg.eq.361) iarg=1

      at=at+cost(iarg)
      bt=bt+sint(iarg)

c     at=at+cos(argS*dtor)
c     bt=bt+sin(argS*dtor)

      if (iref.ge.2) then
       do k=1,3
          hkltf=hkle(k,j)*tfocp2*twopi
          apdSir(k,jj)=apdSir(k,jj)-hkltf*sint(iarg) ! A per le derivate X,Y,Z
          bpdSir(k,jj)=bpdSir(k,jj)+hkltf*cost(iarg)
c         apdSir(k,jj)=apdSir(k,jj)-hkltf*sin(argS*dtor) ! A per le derivate X,Y,Z
c         bpdSir(k,jj)=bpdSir(k,jj)+hkltf*cos(argS*dtor)
       enddo
      endif

 510  continue
      if (icent.eq.0) then
         contc=at
         conts=bt
      else
        contc=2.0*at
        conts=0.0
      endif

         actcr2=actcr2 + tfocp2*contc
         bctcr2=bctcr2 + tfocp2*conts

        if (kcond(4,jj).eq.1) then
          apdSir(4,jj)= -2.0*rho1*contc   ! A per la derivata Bt
          bpdSir(4,jj)= -2.0*rho1*conts
        endif
        if (kcond(5,jj).eq.1) then
            apdSir(5,jj)= tfocO2*contc ! A per la derivata Occ Real
            bpdSir(5,jj)= tfocO2*conts
        endif
        if (iref.eq.6) then
            apdReal(ider22,kz)= apdReal(ider22,kz)+tfocO2a*contc ! A per la derivata Occ Real
            bpdReal(ider22,kz)= bpdReal(ider22,kz)+tfocO2a*conts
        endif

 500  continue

*------ calcolo di Dano12_calc

        args=actcr2*actcr2+bctcr2*bctcr2
        if (args.gt.0.000001) then
           fc2=sqrt(args)
           faze=atan2(bctcr2,actcr2)
           actpT= cos(faze)
           bctpT= sin(faze)

           fmedp=(fpos(ider11,i)+fneg(ider11,i))*0.5
           fmedq=(fpos(ider22,i)+fneg(ider22,i))*0.5

c          afm1=fpos(ider11,i)*sin(ipubp(ider11,i)*dtor)+
c    *           fneg(ider11,i)*sin(-ipubn(ider11,i)*dtor)
c          bfm1=fpos(ider11,i)*cos(ipubp(ider11,i)*dtor)+
c    *           fneg(ider11,i)*cos(-ipubn(ider11,i)*dtor)
c          fmedp=sqrt(afm1**2 +  bfm1**2)
c          afm2=fpos(ider22,i)*sin(ipubp(ider22,i)*dtor)+
c    *           fneg(ider22,i)*sin(-ipubn(ider22,i)*dtor)
c          bfm2=fpos(ider22,i)*cos(ipubp(ider22,i)*dtor)+
c    *           fneg(ider22,i)*cos(-ipubn(ider22,i)*dtor)
c          fmedq=sqrt(afm2**2 +  bfm2**2)
c          fo2=abs(fcA1(ider22,i)-fcA1(ider11,i))

           fo2=abs(fmedq-fmedp)

           !fo2=abs(deltaDisp(ider22,i))

           !fo2=deltaDisp(ider22,i)
           !fc2=-1.*sign(fc2,xReal(ider11,ider22,kz))

           df22=fo2-fc2*scalan2(ider11,ider22)

           fc2=abs(fc2)
           fo2=abs(fo2)

           sigmed=sigfpos(ider11,i)**2 +sigfneg(ider11,i)**2 +
     *               sigfpos(ider22,i)**2 +sigfneg(ider22,i)**2
           if (sigmed.le.0.0) sigmed=4.0
           peso=4.0/sigmed
           peso=peso*pesoDis(ider11,ider22)
           foref2(ider11,ider22,i)=fo2
           fcref2(ider11,ider22,i)=fc2*scalan2(ider11,ider22)
           sumfo2(ider11,ider22)=sumfo2(ider11,ider22)+fo2*peso
           sumfc2(ider11,ider22)=sumfc2(ider11,ider22)+
     *                           fc2*peso*scalan2(ider11,ider22)
        else
           peso=0.0
           foref2(ider11,ider22,i)=0.0
           fcref2(ider11,ider22,i)=0.0
           df22=0.0
        endif

c
c
c--  accumulation of l.s. normal equations
c
              fcs2=fc2*scalan2(ider11,ider22)
              sw2=-rho1*fc2
              b11=b11 +fcs2*fcs2
              b22=b22 +sw2 *sw2
              b12=b12 +fcs2*sw2
              df1=df1 + df22*fcs2
              df2=df2 + df22*sw2
              kparam=0
              do 550 jj=1,nats
                 do 550 k=kk1,kk2
                 !do 550 k=5,5
                   if (kcond(k,jj).eq.0) go to 550
                   if (nz(jj).eq.0) go to 550
                   dfdb=apdSir(k,jj)*actpT+bpdSir(k,jj)*bctpT
                   qvet(k,jj)=qvet(k,jj)+dfdb*dfdb*peso
                   deltaf(k,jj)=deltaf(k,jj)+dfdb*df22*peso
                   if (jFullMatrix==1) then
                     kparam=kparam+1
                     deriv(kparam)=dfdb  ! derivate per ogni parametro
                   endif
  550         continue
                 !print*,kparam

              if (iref.eq.6) then
               ider2u=ider2u+1
               do kz=1,nkd
                dfdb=apdReal(ider22,kz)*actpT+
     *               bpdReal(ider22,kz)*bctpT
                qvetReal(ider11,ider22,kz)=
     *               qvetReal(ider11,ider22,kz)+
     *               dfdb*dfdb*peso
                deltafReal(ider11,ider22,kz)=
     *               deltafReal(ider11,ider22,kz)+
     *               dfdb*df22*peso
                if (jFullMatrix==1) then
                 kparam=kparam+ider2u
                 deriv(kparam)=dfdb  ! derivate per f"
                endif
               enddo
              endif
              !print*,kparam
              if (jFullMatrix==1) then
                kparamx=max(kparam,kparamx)
                do 552 k1=1,kparam
                  dmat(k1)=dmat(k1)+(df22*deriv(k1))*peso
                  do 553 k2=1,kparam
                    amat(k1,k2)=amat(k1,k2)+deriv(k1)*deriv(k2)*peso
                    !print*,k1,k2,amat(k1,k2)
  553              continue
  552            continue
               endif

 280  continue
 270  continue
 1000 continue
c-------------------------------------

      if (kscreen > 0) then
          call zflush
          call DoSingleIteration()
      endif

      if (jCalcPhase.eq.1) goto 3500

c     if (jFullMatrix==1) then
c     write(strInfo,'(39h Nr of parameters for Full-Matrix LSQ: ,i4)')
c    *       kparam
c     endif

c--  compute new scales

c      print*,sumfo1
c      print*,sumfc1
       do 290 ider1=1,ndrmax1
         ider11=nAnomUsed(ider1)
         if (ider11.le.0) goto 290
          if (nlsT.ne.2) then
           !scalan1(ider11)=1.0
           scalan1o(ider11)=sumfo1(ider11)/sumfc1(ider11)
           if(nls.eq.1) scalan1(ider11)=sumfo1(ider11)/sumfc1(ider11)
           scalan1p(ider11)=scalan1o(ider11)*scalan1(ider11)
          endif
          sumdf1(ider11)=0.0
          sumfo1(ider11)=0.0
          do 295 ider2=ider1+1,ndrmax2
             ider22=nAnomUsed(ider2)
             if (ider22.le.0) goto 295
             !scalan2(ider11,ider22)=1.0
             if(nls.eq.1) scalan2(ider11,ider22)=
     *                               sumfo2(ider11,ider22)/
     *                               sumfc2(ider11,ider22)
             scalan2o(ider11,ider22)=sumfo2(ider11,ider22)/
     *                               sumfc2(ider11,ider22)
             scalan2p(ider11,ider22)=scalan2o(ider11,ider22)*
     *                               scalan2(ider11,ider22)
             sumdf2(ider11,ider22)=0.0
             sumfo2(ider11,ider22)=0.0
  295    continue
  290 continue


c--  compute r-factors

c      print*,scalan1o

      do 600 i=1,nrefl
c        write(2,*)foref1(1:4,i)
         do 610 ider1=1,ndrmax1
            ider11=nAnomUsed(ider1)
            if (ider11.le.0) goto 610
            if (nlsT.ne.2) then
            if (foref1(ider11,i).gt.0.0) then
              sigmed=sigfpos(ider11,i)**2 +sigfneg(ider11,i)**2
              if (sigmed.le.0.0) sigmed=1.0
c             sigmed=1.0
              peso=1.0/sigmed
              !peso=peso*pesoAnom(ider11)
              sumdf1(ider11)=sumdf1(ider11)+abs(foref1(ider11,i)-
     *        fcref1(ider11,i)*scalan1o(ider11))*peso
              sumfo1(ider11)=sumfo1(ider11)+foref1(ider11,i)*peso
            endif
            endif
        do 620 ider2=ider1+1,ndrmax2
            ider22=nAnomUsed(ider2)
            if (ider22.le.0) goto 620
            if (foref2(ider11,ider22,i).gt.0.0) then
              sigmed=sigfpos(ider11,i)**2 +sigfneg(ider11,i)**2 +
     *               sigfpos(ider22,i)**2 +sigfneg(ider22,i)**2
              if (sigmed.le.0.0) sigmed=4.0
              peso=4.0/sigmed
              !peso=peso*pesoDis(ider11,ider22)
              sumdf2(ider11,ider22)=sumdf2(ider11,ider22)+
     *            abs(foref2(ider11,ider22,i)-
     *            fcref2(ider11,ider22,i)*scalan2o(ider11,ider22))*peso
                  sumfo2(ider11,ider22)=sumfo2(ider11,ider22)+
     *            foref2(ider11,ider22,i)*peso
           endif
  620     continue
  610   continue
  600 continue



       sumdf=0.0
       sumfo=0.0
c      print*,sumdf1(1:4)
c      print*,sumfo1(1:4)
       do 700 ider1=1,ndrmax1
         ider11=nAnomUsed(ider1)
         if (ider11.le.0) goto 700
         if (nlsT.ne.2) then
         erre1=sumdf1(ider11)/sumfo1(ider11)
         rfac1=100.0*erre1
         pesoAnom1=1.0/(erre1*scalan1o(ider11))
         !if (rfac1 > 70) scalan1p(ider11)=1.0
         !if (jUsoPesi.eq.1.and.nls.gt.1) then
           pesoAnom(ider11)=pesoAnom1
           pesoAnomPhase(ider11)=pesoAnom1
         !else
         !  pesoAnom(ider11)=1.0
         !endif

         write(lo,540) nls,nlsm,ider11,ider11,rfac1
c        write(lo,540) nls,nlsm,ider11,ider11,rfac1,
c    *      scalan1(ider11),scalan1o(ider11),scalan1p(ider11),
c    *      pesoAnom1

      if (kscreen > 0) then
          call zflush
          call DoSingleIteration()
      endif


         call toflush()

         sumdf=sumdf+sumdf1(ider11)
         sumfo=sumfo+sumfo1(ider11)
         endif
          do 710 ider2=ider1+1,ndrmax2
             ider22=nAnomUsed(ider2)
             if (ider22.le.0) goto 710
             erre2=sumdf2(ider11,ider22)/sumfo2(ider11,ider22)
             rfac2=100.0*erre2
             pesoDis1=1.0/(erre2*scalan2o(ider11,ider22))
             pesoDisPhase(ider11,ider22)=pesoDis1
             !if (jUsoPesi.eq.1.and.nls.gt.1) then
               pesoDis(ider11,ider22)=pesoDis1
             !else
             !  pesoDis(ider11,ider22)=1.0
             !endif

             !if (rfac2 > 70) scalan2p(ider11,ider22)=1.0
             write(lo,540) nls,nlsm,ider11,ider22,rfac2
c            write(lo,540) nls,nlsm,ider11,ider22,rfac2,
c    *            scalan2(ider11,ider22),scalan2o(ider11,ider22),
c    *            scalan2p(ider11,ider22),
c    *            pesoDis1

             call toflush()
             if (rfac2 > 80) then
               pesoDisPhase(ider11,ider22)=
     *                       pesoDisPhase(ider11,ider22)*0.5
               pesoDis(ider11,ider22)=
     *                       pesoDis(ider11,ider22)*0.5
               !sumdf=sumdf+sumdf2(ider11,ider22)
               !sumfo=sumfo+sumfo2(ider11,ider22)
             else
              sumdf=sumdf+sumdf2(ider11,ider22)
              sumfo=sumfo+sumfo2(ider11,ider22)
             endif
  710    continue
  700 continue


      if (sumfo > 0 ) then
        erre=sumdf/sumfo
      else
        erre=0.0
        jstop=1
        jCalcPhase=1
      endif

      rfac=100.0*erre

      write(lo,545) nls,nlsm,jstep,rfac
  540 format(' cycle #',2i4,2x,2i2,' r-fac.=',10f10.5)
  545 format(' cycle #',2i4,3x,a2,1x, ' r-fac.=',9f10.5)

      if (nlsT.eq.1) then
        if (nls > 1) then
         inBoxGr(4) = inBoxGr(4) - 1
         nLinesGR = nLinesGRSavR1
        else
            nLinesGRSavR1=nLinesGR
        endif
c       call GetStatRfac(tirang,DanoSigma,fcref1,foref1,scalan1,
c    *           nrefl,1,pesoLSQanom,20,0.0)

c       call RfacStat(1,foref1,fcref1,foref2,fcref2,
c    *               scalan1,scalan2,sigfpos,sigfneg)

      else
        if (nls > 1) then
         inBoxGr(4) = inBoxGr(4) - 1
         nLinesGR = nLinesGRSavR2
        else
            nLinesGRSavR2=nLinesGR
        endif
c       call RfacStat(2,foref1,fcref1,foref2,fcref2,
c    *                scalan1,scalan2,sigfpos,sigfneg)
      endif

      select case (ndrmax)
      case (1)
        write(strInfo,'(24h Nr of Reflection Used: ,1(1x,i5),
     *        3x,6h R% : ,f6.2)')nrefUsed1(1:1),rfac
      case (2)
        write(strInfo,'(24h Nr of Reflection Used: ,2(1x,i5),
     *        3x,6h R% : ,f6.2)')nrefUsed1(1:2),rfac
      case (3)
        write(strInfo,'(24h Nr of Reflection Used: ,3(1x,i5),
     *        3x,6h R% : ,f6.2)')nrefUsed1(1:3),rfac
      case (4)
        write(strInfo,'(24h Nr of Reflection Used: ,4(1x,i5),
     *        3x,6h R% : ,f6.2)')nrefUsed1(1:4),rfac
      case (5)
        write(strInfo,'(24h Nr of Reflection Used: ,5(1x,i5),
     *        3x,6h R% : ,f6.2)')nrefUsed1(1:5),rfac
      end select
      if (kscreen > 0) then
        call TestoGR(strInfo, -1, 1, 4)
        call zflush
        call DoSingleIteration()
      endif

      DiffErre=erre_old-erre
      erre_old=erre
      if (nls.eq.1) go to 3000
      if (jstop.eq.1) go to 3000
c     if (nlsT.gt.1.and.numLsq.ne.2) go to 815
c

c
c--  compute correction for scale factor and thermal factor
c
      denom =  b11 * b22 - b12 * b12
      if (abs(denom).gt.0.0) then
                               dbm=(b11*df2-b12*df1)/denom
                               dg =(b22*df1-b12*df2)/denom
                             else
                               dbm=0.0
                               dg=0.0
                             endif
      if (abs(b22).gt.0.0) then
                             dbs=df2/b22
                           else
                             dbs=0.0
                           endif
      corr= dbm- dbs
c     write(lo,*)'Corre bt', corr
c     write(lo,*)'Corre scala', dg
      !corr=0.0
      !dg=0.0

      if (jFullMatrix==1) then
       ! shift calc. with full-matrix
       kparam=kparamx
       N=kparam
       NPP=500
       M=1
       MP=1

       write(lo,*)'Kparam=',kparam
c      do k=1,kparam
c       print*,amat(k,1:kparam)
c      enddo

       call LUDCMP(amat,N,NPP,INDX,D)
       call LUBKSB(amat,N,NPP,INDX,dmat)
       !print*,'shift'
       !print*,dmat(1:kparam)

        do  k1=1,kparam
          do  k2=1,kparam
           dmat1(k1,k2)=0.0
          enddo
          dmat1(k1,k1)=1.0
        enddo
        !print*,'variance'
        do k=1,kparam
         call LUBKSB(amat,N,NPP,INDX,dmat1(1,k))
         !print*,dmat1(k1,k2)
        enddo

*       test corr matrix
c       print*,'Correlation'
c       do  k1=1,kparam
c         do  k2=k1+1,kparam
c           dds=dmat1(k1,k1)*dmat1(k2,k2)
c           dd=abs(dmat1(k1,k1)*dmat1(k2,k2))
c           dd1=sqrt(dd)
c           dd1=sign(dd1,dds)
c           corrp(k1,k2)=dmat1(k1,k2)/dd1
c         enddo
c           !print*,corrp(k1,k1+1:kparam)
c           icorrpMax=0
c           icorrpMax = maxloc(corrp(k1,k1+1:kparam),1,
c    *             mask=abs(corrp(k1,k1+1:kparam))>0.8)
c           if (icorrpMax(1)>0) then
c           print*,'Param:',k1,k1+icorrpMax(1),corrp(k1,k1+icorrpMax(1))
c           endif
c       enddo
      endif


      kparam=0
      do 800 jj=1,nats
      if (nz(jj).eq.0) go to 800
      do 810 k=kk1,kk2
       if (kcond(k,jj).eq.0) go to 810
       !if (nlsT > 1.and.k <= 5) goto 810

        if (abs(qvet(k,jj)).gt.0.0) then
            shiff=deltaf(k,jj)/qvet(k,jj)
        else
            shiff=0.0
        endif

        if (jFullMatrix==1) then
          kparam=kparam+1
          shiff=dmat(kparam)
        endif

       if (k.le.3) then
         ashift=shiff*dump
         if (ashift > 1.0) ashift=0.0
         xnew=xyzs(k,jj)+ashift
c        print*,kparam,'=xyz-->',xnew,xyzs(k,jj),ashift,shiff,shifd
         xyzs(k,jj)=xnew
       else if (k.eq.4) then
         ashift=(shiff+corr)*dump
         bnew=xyzs(k,jj)+ashift
         if (bnew.lt.btlimit) bnew=btlimit
         if (bnew.gt.btlimitM) bnew=btlimitM
c        print*,kparam,'=Bt-->',bnew,xyzs(k,jj),ashift,shiff,shifd
         xyzs(k,jj)=bnew
       else if (k.eq.5) then
         ashift=shiff*odump
         occnew=xyzs(k,jj)+ashift
         occnew=max(0.05,occnew)
c        print*,kparam,'=Occ-->',occnew,xyzs(k,jj),ashift,shiff,shifd
         xyzs(k,jj)=occnew
      endif
  810 continue
  800 continue
  815 continue

      if (iref.eq.6) then
      do kz=1,nkd
       if (iTypeAnom(kz)==1) then

      do 900 ider1=1,ndrmax1
        ider11=nAnomUsed(ider1)
        if (ider11.le.0) goto 900
        if (nlsT.ne.2) then

         aa=qvetAnom(ider11,kz)
         bb=deltafAnom(ider11,kz)
         if (aa.gt.0.0) then
            shiff=bb/aa
         else
            shiff=0.0
         endif

        if (jFullMatrix==1) then
          kparam=kparam+1
          shiff=dmat(kparam)
        endif

         ashiftA=shiff*adump
         occnewA=xAnom(ider11,kz)+ashiftA
c        print*,kparam,'=f"-->',occnewA,xAnom(ider11,kz),
c    *          ashiftA,shiff,shifd
         xAnom(ider11,kz)=occnewA
        endif
         do 950 ider2=ider1+1,ndrmax2
           ider22=nAnomUsed(ider2)
           if (ider22.le.0) goto 950

           aa=qvetReal(ider11,ider22,kz)
           bb=deltafReal(ider11,ider22,kz)

           if (aa.gt.0.0) then
             shiff=bb/aa
           else
             shiff=0.0
           endif

           if (jFullMatrix==1) then
             kparam=kparam+1
             shiff=dmat(kparam)
           endif

           ashiftR=shiff*adump
           occnewR=xReal(ider11,ider22,kz)+ashiftR
c          print*,kparam,'=df-->',occnewR,xReal(ider11,ider22,kz),
c    *             ashiftR,shiff,shifd
           xReal(ider11,ider22,kz)=occnewR
 950  continue
 900  continue

      endif
      enddo
      endif

 2000 format(2x,a2,2i3,3f10.5,2f14.1)
 2002 format(2x,a2,2i3,1x,2i3,2x,3f10.5,2f14.1)
 2003 format(2x,a2,1x,2i3,2x,3f10.5,2f14.1)
c


       if (npunti > 1) then
        write(strInfo,'(6h R% : ,f6.2)')rfac_temp
        if (nlsT==1) then
        else
        endif
       endif
       write(strInfo,'(6h R% : ,f6.2)')rfac
       if (nlsT==1) then
       else
       endif
       rfac_temp=rfac

       npunti=npunti+1

       xplot(npunti)=npunti
       yplot(npunti)=rfac

       if (nlsT==2.and.nls==2.and.nlsTmin /=2) then
        xgrid= xplot(npunti-1)
        ygrid= yplot(npunti-1)
        ngrid=npunti-1
       endif
       call PlotLSQCycle(strHead,xplot,yplot,npunti,xgrid,ngrid)

c      read(*,"(A1)") ch

       if (nls.gt.2) then
c        if (abs(DiffErre).lt.sogErre.or.DiffErre.lt.0.0.
         if (abs(DiffErre).lt.sogErre.or.DiffErre.lt.-0.03.
     *           or.nls.eq.nlsm) then


          occMax=0.0
          do jj=1,nats
            if (x_save(5,jj).gt.occMax) occMax=x_save(5,jj)
            do  k=1,5
               xyzs(k,jj)=x_save(k,jj)
            enddo
          enddo

c         do jj=1,nats
c           if (xyzs(5,jj).lt.occMax/5.0)xyzs(5,jj)=0.0
c         enddo


          do kz=1,nkd
            do ider1=1,ndrmax
              ider11=nAnomUsed(ider1)
              xAnom(ider1,kz)=xAnom_save(ider1,kz)
              if (ider11.gt.0.and.nlsT==1) then
                fsecon(kz,ider11)=xAnom(ider11,kz)
*-------------save the Model--------------------------
                fseconLSQ(kz,ider11)=fsecon(kz,ider11)
                do jj=1,nats
                  do  k=1,5
                     xLSQ(ider11,k,jj)=xyzs(k,jj)
                  enddo
                enddo
*----------------------------------------------------
              endif
              do ider2=ider1+1,ndrmax
                 ider22=nAnomUsed(ider2)
                 if (ider1.eq.1) then
                 xReal(ider1,ider2,kz)=xReal_Save(ider1,ider2,kz)
                 if (ider11.gt.0.and.ider22.gt.0)
     *            ffirst(kz,ider22)= xReal(ider11,ider22,kz)+
     *                               ffirst(kz,ider11)
                 endif

              enddo
            enddo
          enddo

          jstop=1
          sumOcc=sum(xyzs(5,1:nats))
c --------- write output Model
         if (nlsT==2.and.rfac > 70.0.and.sumOcc < 0.01) then
           xyzs(:,:)=x_LSQ1(:,:)
           ffirst=ffirst_LSQ1
           scalan2=1.0
           scalan2o=1.0
           pesoDisPhase=1.0
         else
           scalan1=1.0
           scalan1o=1.0
         endif

         if (nlsT==1) rfac_lsq1=rfac
         if (nlsT==2) rfac_lsq2=rfac

         k=len_trim(strLog)
         strLog=strLog(1:k) //' with R%='
         k=len_trim(strLog)
         write(ktml,'(a,f6.2)') strLog(1:k),rfac
         write(lo,'(a,f6.2)') strLog(1:k),rfac
         
c        write(jrel,'(4hSET ,i4,f8.2)')nsetSegno,rfac

c        if (nlsT.eq.nlsTm) then
           jCalcPhase=1
           write(lo,40)
           do jj=1,nats
            kz=iabs(nz(jj))
            if (kz > 100)  kz=mod(kz,100)
            itp=nalfd(kz)
            write(lo,41)itp,(xyzs(j,jj),j=1,5)
c           write(jrel,'(a2,1x,5f10.4,10f10.4)')
c    *            itp,(xyzs(j,jj),j=1,5),
c    *            (ffirst(kz,j),fsecon(kz,j),j=1,ndrmax)
           enddo
           write(lo,'("   Atom   nw    dfp     fsec")')
           do kz=1,nkd
           do ider1=1,ndrmax
            ider11=nAnomUsed(ider1)
            if (ider11.gt.0) then
            write(lo,'(5x,a2,i4,2f10.4)')nalfd(kz),ider11,
     *            ffirst(kz,ider11),fsecon(kz,ider11)
            endif
           enddo
           enddo
c        endif
        else
          do jj=1,nats
           do  k=1,5
              x_save(k,jj)=xyzs(k,jj)
           enddo
          enddo
          do kz=1,nkd
           do ider1=1,ndrmax
              ider11=nAnomUsed(ider1)
              xAnom_save(ider1,kz)=xAnom(ider1,kz)
              fsecon(kz,ider2)=xAnom(ider2,kz) ! per calc. l modello (F/fase) dopo ogni ciclo
             do ider2=ider1+1,ndrmax
                ider22=nAnomUsed(ider2)
                xReal_Save(ider1,ider2,kz)=xReal(ider1,ider2,kz)
                if (ider1==1) then
                ffirst(kz,ider22)= xReal(ider11,ider22,kz)+
     *                               ffirst(kz,ider11)
                endif
             enddo
           enddo
          enddo
        endif
       endif

 3000 continue
 3500 continue
 4000 continue

      deallocate(deltano11,deltano22,deltano12,stat = ierr)
      deallocate(foref1,fcref1,stat=ierr)
      deallocate(foref2,fcref2,stat=ierr)

      if (irefi > 0) then
       write(jrel,'(4hlsq ,2i1)')irefi,numLsq
      else
       write(jrel,'(4hlsq ,i1)')irefi
      endif

      toto=0.0
      write(jrel,'(1h#,12x,9hR%(step1),2x,9hR%(step2))')
      write(jrel,'(4hFOM ,3(3x,f6.2))')toto,rfac_lsq1,rfac_lsq2

      write(jrel,'(17hwl parameters (df,a,5h f"):)')char(39)
      do kz=1,nkd
        write(jrel,'(a2,10f10.4)')nalfd(kz),
     *       (ffirst(kz,j),fsecon(kz,j),j=1,ndrmax)
      enddo
      write(jrel,'(16hatom parameters:)')
      write(jrel,'(5hCOORD)')

      do jj=1,nats
         kz=iabs(nz(jj))
         if (kz > 100)  kz=mod(kz,100)
         itp=nalfd(kz)
           write(jrel,'(a2,5f10.3)')itp,(xyzs(j,jj),j=1,5)
       enddo
      write(jrel,'(3hEND)')
**    call flush(40)
      ! scrivere il frammento affinato in un file pdb
c     call pre_list05(1)
c     call frm05
c     itype = 0
c     iform = 1
c     namef='test.pdb'
c     jop = jopen(ifour,namef,itype,iform,ier)
c     numbPDB = -1
c     numbPDB = nats
c     ifFast = 1
c     ifREM = numbset
c     call outPDB(ifour,numbPDB,ifFast,ifREM,0)
c     stop

      numset=numbset
      numbrun=numbset
      interp=0
*gl*  call frm15(interp)   !!gl
      call PutGetXyzs(1, interp)
*     call to_coord_prot(1,1)
c     call to_coord_sir(1,nrefl)

      return
      end

c-----------------------------------------------------------
!mr      subroutine centre(j,l)

!mr      common /cent/ tl(3,4),fs(216),mlat
!mr      dimension tst(21)
!mr      data tst/0.,0.,0., 0.,0.5,0.5, 0.5,0.,0.5, 0.5,0.5,0., 0.5,0.5,0.5
!mr     1 , 0.333333,0.666667,0.666667, 0.666667,0.333333,0.333333/
!mr      mlat=j
!mr      m=3*l-2
!mr      tl(1,j)=tst(m)
!mr      tl(2,j)=tst(m+1)
!mr      tl(3,j)=tst(m+2)
!mr      return
!mr      end
!-----------------------------------------------------------------------
      subroutine CalcSF()
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule

      dimension  vet(40), ivet(40)

      dimension i1(3),i2(3)
*     dimension cost(360)
*     equivalence (sint(91),cost(1))

      write(lo,1)
  1   format(//5x,'Structure Factors calc. ',/
     +       5x,'---------------------------',/)

*gl*  call yfl02    !!gl
*gl*  call musym()  !!gl

      

      do 500 i=1,nreflTot

        i1(1:3)=khl(1:3,i)
        eps=epsv(i)

c
c-- compute H*R and H*T
c
        do 250 j=1,nsym
        t=1000.0
        do 230 l=1,3
        t=t+float(i1(l))*tmat(j,l)
        hkle(l,j)=0
c------------
        do 240 k=1,3
  240   hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)
c------------
  230   continue
        hkle(4,j)=t
  250   continue
        rho1=rhov(i)
        act=0.0
        bct=0.0

        sfj = 0.0
        do 400 jj=1,nats
          if (nz(jj).eq.0) go to 400
          kz=nz(jj) / nzConst

          fkz = cl(kz)
          do  ii = 1,4
             fkz = fkz + al(ii,kz)*exp(-bs(ii,kz)*rho1)
          enddo

c         arg=-xyzs(4,jj)*rho1
          arg=-bfac(jj)*rho1
          effe=pts*fkz*exp(arg)
          tfocc=effe*xyzs(5,jj)
          tfocp=tfocc*twopi*float(icent+1)

          sfj = sfj + tfocc

* accum. termini derivate  per la symmetry
          at=0.0
          bt=0.0
          do 410 j=1,nsym
          argS=amod(hkle(1,j)*xyzs(1,jj)
     *            +hkle(2,j)*xyzs(2,jj)
     *            +hkle(3,j)*xyzs(3,jj)
     *            +hkle(4,j),1.0)
          iarg=int(360.0*argS+0.5)+1
          iarg=mod(iarg+3600,360)
          if(iarg.lt.0) iarg=360+iarg
          if(iarg.eq.0) iarg=1
          if(iarg.eq.361) iarg=1
          at=at+cost(iarg)
          bt=bt+sint(iarg)
 410     continue

         if (icent.eq.0) then
             contc=at
             conts=bt
         else
             contc=2.0*at
             conts=0.0
         endif

         contc=contc*tfocc
         conts=conts*tfocc

         act=act+contc
         bct=bct+conts

  400 continue

      sfj = sfj*sqrt(eps*nsym)
      args=act*act+bct*bct
c--
      if (args.gt.0.000001) then
         fc=sqrt(args)
         faze=atan2(bct,act)
         faze=faze*rtod
         if (mkang(i).ne.1) then
             faze1= favi(mkang(i),faze)
             faze=faze1
         endif
         faze=mod(faze+3600.,360.)
         fmod(i)=fc
         emod(i)=fc/sfj
         ipub(i)=nint(faze)
         wtt1(i)=1.0
c        write(1,'(3i4,4f10.2)')i1,fovet(i),sigmav(i),
c    *         fmod(i),float(ipub(i))
      else
         fmod(i)=0.0
         ipub(i)=0
         wtt1(i)=0.0
       endif
  500 continue

c     stop
      return
      end
