!-----------------------------------------------------------------------
c-- sir code for invariants                      Release 88.12
      subroutine invar(ier)
      USE General
      USE Symmetry
      USE InvarData
      USE Riflessi
      USE Grafici
      USE Molcom

c
c-- invariant main routine
c
      character cff
      character*200,strLog
      character *200 strTime
*     common/sinte/ abc(3),ang(3),astar,bstar,cstar,cosas,cosbs,coscs
c
      common /inp/  natom,fnat,satm,atoms
      common /prin/ ipt,ip0,ip10,ipq
      common /proc/ ifps,ifweig,jbig
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nweak,sgg
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/ sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ne1,ne2,ne3,ne4,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1,itest
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
      common /tst/ nt,ar(26),nn(11,26,3),ppv(11,26,3)
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
      common/esti/ib(3),ih(3,2,24),ii(2,24)
      common/nq/nor1(6),nop1(6),iseg1(6),icodqn,sumc,sums,sume
      common/wrt/icv(4,7),ishf,ifas,eewrt(3),icodx(3),iqua(1000),
     1           itac(5,24,4),eee(3)
      common/lst13/l13,m13,md13,l13f,m13f,n13f
      common/zero/argq(26),ncal(26),nver(26),ntt,fm(26),gt(26)
      common/alfz/icum
      common /new/TRD,dfmin,dfmax,deldif,sogweak,icumde,perc,perct
c--
      character rescha(7)*32,line(2)*8,fmt*36
      integer result(7,2)
      data rescha/
     *            '     positive estimated triplets',
     *            '     negative estimated triplets',
     *            ' enantiomorph sensitive triplets',
     *            '               psi-zero triplets',
     *            '                  psi-e triplets',
     *            '                                ',
     *            '                                '/
c
      call RoutineHeader('Invariants Routine','05.12')
c
c-- read directives
*gl*  write(strLog,'(30h <b>Direct Methods Section</b>)')
      strLog='<big><b>Direct Methods Section</b></big>'
      if (kscreen > 0) then
       if (inBoxGr(2) > 0) then
         HistoOK(:)=0
         inBoxGr(2:)=0
         nLinesGR=nLinesGRsaveBox(2)
         call ManageGraph(0,0)
       else
         nLinesGRsaveBox(2)=nLinesGR
       endif
       call TestoGR(strLog, color_RED, 2, 2)
       call zflush
       call DoSingleIteration()
      endif
      write(strLog,'(23h Direct Methods Section)')

      write(strLog,'(24h________________________)')


*gl*  call xfl06
      call LoadReflInfo
      call dirinv(sogdf,rhomad,icum,nrel1,ier)

      if (ier.lt.0) return

*gl*  call pre06  ! update preamb. lista 7 per il derivato corrente
      call UpdateReflInfo

      write(strLog,'(18h Derivative Used: ,a2)')nalfd(jderi)
      if (kscreen > 0) then
       call TestoGR(strLog, -1, 2, 2)
       write(strLog,'(24h <b>Current Derivative: ,a2,4h</b>)')
     *       nalfd(jderi)
       call TestoGR(strLog, color_LIGHTRED, 2, 1)
       call zflush
       call DoSingleIteration()
      endif

      call AllocaInvar(1)

      if (InfoOK(7)==0) then
        call LeggiRiflessiSP
        call OrdinareRiflessiTripletti(sogdf,rhomad,itest)
      else
        call OrdinareRiflessiTripletti(sogdf,rhomad,itest)
      endif

      if (ier.lt.0) goto 1000

      call inpt9(ier,coefs)
      if (ier.lt.0) goto 1000
      do 100 i=1,7
      do 100 j=1,2
  100 result(i,j)=0
c-----------------
    5 ipp=ip0+ipt+ip10+ipq
      ili0=0
      if(ipp.gt.0) call outp
      iprin=ip0
      if (ifps.gt.0)then
         call deri(nrel1,1,result,ili0)
      else
      endif
      iprin=ipq

      iprin=ipt
      ili0=0
      call deri(nrel1,0,result,ili0)
      numcoc=result(1,2)
      write(lo,1402)
 1402 format(/,'  triplets have been estimated using ',
     *         ' isomorfous derivative formula',/)
          iprin=ip10
 1451 if (icum.eq.1) call cumalf_z(1,nreft,alfestinv,alfvarinv)

c-- final print
 1452 write(lo,1500)
 1500 format(/,10x,31x,'number of relationships',/,
     *         10x,32x,' calculated   stored   ',/)
      do 2000 i=1,5
      do 1800 j=1,2
      if (result(i,j).eq.0) then
                              write(line(j),1600)
                            else
                              write(line(j),1700) result(i,j)
                            endif
 1600 format('       -')
 1700 format(i8)
 1800 continue
      write(lo,2100) rescha(i),(line(j),j=1,2)
 2100 format(9x,a32,a8,3x,a8)
 2000 continue
 1000 strTime='Invar'
      call CPUTIMEtot(strTime)
      call AllocaInvar(2)
      return
      end
c -----------------------------------------------------------
      subroutine inpt9(ier,coefs)

      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMIR
      USE InvarData
c
      common /inp/  natom,fnat,satm,atoms
      common /proc/ ifps,ifweig,jbig
      common/prin/ ipt,ip0,ip10,ipq
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nweak,sgg
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/ sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ne1,ne2,ne3,ne4,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1,itest
      common /trre/ rho(3),eps(3),sq(3),sn(3),fn(3,18),ipcod(3),msym,
     *              naold(18),nanew(18)
c
      common /new/TRD,dfmin,dfmax,deldif,sogweak,icumde,perc,perct
c--
      integer hkl(3)
      dimension vet(64),ivet(64)
      equivalence(vet(1),ivet(1))
c
c     write(6,*)'INPT9:',jderi,jderi
c     set up sin/cos table
c     do 10 i=1,450
c     sint(i)=sin(dtor*float(i-1))
c  10 continue
c
c -----
c     call sub. per lettura lista 1 : parametri della cella
c -----
*gl*  call xfl01   !!gl
*     do i=1,3
*        abc(i)=cell(i)
*        ang(i)=cell(i+3)
*     enddo
c -----
c     call sub. per lettura lista 2 : simmetria
c -----
*gl*  call yfl02   !!gl
c -----
c     call sub. per lettura lista 3 : contenuto cella
c -----
*gl*  call yfl03   !!gl
c      if (jderi.gt.0) call mod03   ! server ancora ??

!     do 23 i=1,8    ???? gianluca 13/12/2005
!     nw(i)=nz(i)
!  23 no(i)=ny(i)
c -----
c     call sub. per lettura lista 33 : derivati
      if(jderi.gt.0) then
       call yfl33
c      write(6,*)'deri attivo:',jderi
      end if
c-- segue il blocco 1 frammento traslato
      fnat=s3s2
c---- compute the number of free vectors
      msym=nsym*(icent+1)
      atoms=(1.0/s3s2d(jderi))**2.0
      natom=int(atoms+0.05)
!
      itabmx=2500000
      icst1=268435456
      icst2=134217728
      icst3=32768
      nupos=0
c -- set the max. numb. of enant. and neg. triplets to write onto jrel
      nmxte=500
      nmxtn=50000
c -- set the numb. of neg. quartets to calculate and write onto jrel
      nquam=30000
      nquat=20000
c -- set the numb.of enant. quart. to calculate and write onto jrel
      nqenm=500
      nqent=500
c
      ifat1=(2*ihmx(3)+1)*(2*ihmx(2)+1)
      ifat2=(2*ihmx(3)+1)
      ifatx=ihmx(1)*ifat1+ihmx(2)*ifat2+ihmx(3)
      if (ifatx.gt.itabmx) go to 1100
      jmme=msym
      emmePS=float(jmme)
!
      ic=0
      ict=0
      alfa=0.0
c ---      set some default values
      if(nreft.eq.0) nreft=nstr
      if(nzro.gt.maxpsi) nzro=maxpsi
      if(nrefp.eq.0) nrefp=nzro
      
 500  continue
      return

 1100 write(lo,1200) itabmx,ifatx
 1200 format(//,'actual size of isr ( =',i8,' ) is less then maximum sup
     1er-index = ',i8)
      ier=-1
 2000 return
      end
c -----------------------------------------------
      subroutine outp
      USE General
      common /proc/ ifps,ifweig,jbig
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nweak,sgg
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      write(lo,10) nstr
   10 format('   list of the',i4,'  strongest reflections'/)
      call outp1 (1,nstr)
      iniz=nstr+1
      ifin=nstr+nrefp
      write(lo,40) nrefp
   40 format('0  list of the',i4,'  weakest reflections for psizero and/
     1or negative quartets cross-vectors'/)
      call outp1(iniz,ifin)
      return
      end
c -----------------------------------------------
      subroutine outp1(iniz,ifin)
     
      USE General
      USE Riflessi
      USE RiflessiMIR
      USE InvarData

      common /proc/ ifps,ifweig,jbig
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nweak,sgg
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      dimension icod(5),ihkl(3,5),e(5),iphi(5),delta(5)

      nr=0
      do 30 i=iniz,ifin
      nr=nr+1
      ihkl(1:3,nr)=khl(1:3,i)
      delta(nr)=fdelta(jderi,i)
      e(nr)=evet(i)
      icod(nr)=i
      iphi(nr)=iphaz(i)
      if(nr.lt.3.and.i.lt.ifin) goto 30
      write(lo,20)(icod(j),(ihkl(k,j),k=1,3),e(j),delta(j),
     *   iphi(j),j=1,nr)
   20 format(' ',3(i5,'*',3i4,2f5.2,i4,2x))
      nr=0
   30 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine dirinv(sogdf,rhomad,icum,nrel,ier)

      USE General
      USE Symmetry

      character line*80,dire*40,diret*80
      character Numdigit*13
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /cifre/ Numdigit
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common /proc/ ifps,ifweig,jbig
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nweak,sgg
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/ sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ne1,ne2,ne3,ne4,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1,itest
      common /new/TRD,dfmin,dfmax,deldif,sogweak,icumde,perc,perct
      dimension vet(40),ivet(40),ibuf(10)

      
c
c-- set default values
      nrel=50000
      icumde=0
      jderi=0
      sogdf=0.8
      dfmin=0.0
      perc=0.6
      perct=0.75
      dfmax=0.2
      sogweak=0.0
*------------------------
      rhomad=1.0
      rhomad=1.0/(2.0*6.0)**2
      perc=1.0
      sogdf=0.7
*------------------------
      icum=1
      sogpo=0.21
      sogen=0.2
      sogne=-0.2
      iprin=0
      jbig=1
      ifps=1
      ifps0=0
      nreft=0
      emin=0.0
      ntrt=0
      nrefp=0
      emax=0.4
c----
      itest=0
      ecros=1.0
      ecr1=3.0
      iecros=100
      iecr1=300
c----
      nsog=40
      sqes=0.2
      ne1=0
      ne2=0
      ne3=0
      ne4=0
      ncode=7
      icody=0
      ier=0
      coef=99999.0
c -- set the size of  ish  matrix
      ishSize=maxstr+maxpsi
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 9000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(line)
c-- directives with alphanumeric parameters
      if (dire(1:4).eq.'deri') then
          call cutst(line,lenp,dire,lend)
          if (lend.gt.0) then
            read(dire,'(a2)') ibuf(1)
            call yfl33
            jderi=kcomp(1,ibuf,nalfd,nkd,1)
          else
             jderi=1
          endif
          go to 100
          endif
c
c-- directives wih numeri parameters
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 8000
      if (dire(1:3).eq.'end') go to 100
      if (dire(1:4).eq.'nsig') then
          if (iv.ne.0) go to 8000
          icum=0
          go to 100
          endif
      if (dire(1:4).eq.'npsi') then
          if (iv.ne.0) go to 8000
          ifps=0
          go to 100
          endif
      if (dire(1:4).eq.'emin') then
          if (iv.ne.1) go to 8000
          emin=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'nrtr') then
          if (iv.ne.1) go to 8000
          nreft=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'corr') then
          if (iv.ne.1) go to 8000
          coef=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'gmin') then
          if (iv.ne.1) go to 8000
          sogpo=vet(1)
c         if (sogpo.lt.sogen) sogpo=sogen+0.0001
          go to 100
          endif
      if (dire(1:4).eq.'gwea') then
          if (iv.ne.1) go to 8000
          sogweak=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'reso') then
          if (iv.gt.1) go to 8000
          rhomad=1.0/(2.0*vet(1))**2
          perc=1.0
          sogdf=0.7
          go to 100
          endif
      if (dire(1:4).eq.'rhom') then
          if (iv.gt.1) go to 8000
          rhomad=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'cumd') then
          if (iv.gt.1) go to 8000
          icumde=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'prin') then
          if (iv.ne.1) go to 8000
          iprin=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'emax') then
          if (iv.ne.1) go to 8000
          emax=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'nrps') then
          if (iv.ne.1) go to 8000
          nrefp=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'nocu') then
          if (iv.ne.0) go to 8000
          icum=0
          go to 100
          endif
      if (dire(1:4).eq.'dfmi') then
          if (iv.gt.1) go to 8000
          sogdf=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'dfma') then
          if (iv.gt.1) go to 8000
          dfmax=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'rela') then
          if (iv.eq.0) go to 8000
          nrel=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'perc') then
          if (iv.eq.0) go to 8000
          perct=vet(1)
          go to 100
          endif
      write(Msg,6000) diret(1:Lung(diret))
 6000 format(' Wrong directive in INVAR modulus:   ',a)
      ier=-1
      return
 8000 continue
      ier=-1
      write(Msg,'(22h Error in directive : ,a)') diret(1:Lung(diret))
      return
 9000 continue
c-----

      jderi=max(jderi,1)

      if (nrefp.gt.nzro) nrefp=nzro
      ipt=iprin
      ip0=iprin
      ip10=iprin
      ipq=iprin

      return
      end
c--------------------------------------------
      function bzt(z,t)
      USE General

      n=15
      n=10
     
      sum0=sin(z)/z
      fact1=sqrt(pi/(2.0*z))

      sum=0.0
      do 10 i=1,n
        fact2=t**(2*i)
        fact3=1.0
        do j=1,i
         fact3=fact3*j
        enddo
        fact3=fact3**2
        fact4=besselni(z,2*i)
        sum=sum+(fact2/fact3)*fact4
        bzt=fact1*sum
c       write(8,*)i,fact2,fact3,fact4,sum,bzt*10000.0
 10   continue

      bzt=sum0 + fact1*sum

c     write(6,*) bzt*10000.
      return
      end

c----------------------------------------------
c  Spherical Bessel Function of the First Kind
c----------------------------------------------
      function sbessel(x,n)
      USE General

      real fp(0:100)
      real fm(0:100)

      f0=1.0/x
      f1=1.0/(x*x)
      fp(0)=f0
      fm(0)=f0
      fm(1)=-f1 + f0/x
      fp(1)=-fm(1) + f0/x

      do 10 i=1,n
        ii=-i
        fm(iabs(ii-1))=-fm(iabs(ii+1)) + fm(iabs(ii)) *(2*ii+1)/x
        fp(i+1)=-fp(i-1) + fp(i) *(2*i+1)/x
 10   continue

      sbessel=fp(n)*sin(x) + (-1.0) **(n+1) * fm(n+1) * cos(x)

      return
      end

c----------------------------------------------
c  Bessel Function of nonintegral order
c ----------------------------------------------
      function besselni(x,n)
      USE General

      besselni=sbessel(x,n)/sqrt(pi/(2.0*x))

      return
      end

c-------------------------------------------------------------
      subroutine deri(ndim,ipsi0,result,ili0)
      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMIR
      USE InvarData
      USE Grafici
      USE CaratteriSpeciali
      USE Molcom

      character*200,strLog

c--calculate triplets
c
      common /proc/ ifps,ifweig,jbig
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nweak,sgg
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/ sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ne1,ne2,ne3,ne4,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1,itest
      common /cp10/ nor(3),dumd(156)
      common /new/TRD,dfmin,dfmax,sogdf,sogweak,icumde,perc,perct
      common/alfz/icum

      character rescha(13)*9,linex(3)*9
      dimension ill(3),jvet(3),mh(3),mk(3),ml(3),vet( 7),kvet(16)
      dimension ist(2,3),gt(3),iphit(3),ivet(48),ndr(3)
      integer result(7,2)
      data rescha/'   any   ','         ','  30,210 ','  45,225 ',
     *'  60,240 ','         ','  90,270 ','         ',' 120,300 ',
     *' 135,315 ',' 150,330 ','         ','   0,180 '/

      integer,allocatable::isr(:)

c*******************************************************************
c--description of some important settings
c
c  h1 = h2 + h3
c  i  h1 code
c  j  h2 code
c in  h3 code
c mh  h,k,l first  reflection
c mk  h,k,l second reflection
c ml  h,k,l third  reflection
c     ipsi0 = 0   ->  sigma2
c     ipsi0 = 1   ->  psi-zero

c*******************************************************************


      segnoc=0.0
      allocate(isr(ifatx),stat=ier)
      limmi=10
      limma=4*nint(50000./float(nreft))

      alfvarinv(:)=0.0
      alfestinv(:)=0.0

      if (ipsi0.eq.0) then
         write(6,*)'|G|min=',sogpo
         if (sogpo.ne.0.0)then
            sogpo=3.0*s3s2d(jderi)*(dfmin**3)
            sogpo=min(sogpo,0.8)
            sogpo=max(sogpo,0.2)
            sogne=-1.0*(sogpo)
         end if
         write(6,*)'|G|min=',sogpo
         write(6,*)'s3s2d=',s3s2d(jderi)
      endif

c-- segue il blocco 2 frammento traslato


    5 iconts=0
      if (ipsi0.eq.0) then
        write(lo,10) nreft,dfmin,emin
c       write(strLog,'(38h Nr of strong reflections to be phased,
c    *    16h (|\gD\diso\u| >,f5.2,5h and ,6h|E| > ,f5.2,1h),2h :,i5)')
c    *    dfmin,emin,nreft
        write(Msg,6) dfmin,emin,nreft
    6 format(' Nr of strong reflections to be phased',
     *       ' (|<span lang="Greek">D</span><sub>iso</sub>| >',f5.2,
     *       ' and |E| > ',f5.2,') :',i5)
         if (kscreen > 0) then
!          inBoxGr(2)=inBoxGr(2)+1
           call TestoGR(Msg, -1, 2, 2)
           call zflush
           call DoSingleIteration()
         endif
      else
        write(lo,20) nreft,nrefp
      endif
   10 format(/,' Sigma2 relationships estimated among the: ',/,
     * 1x,i4,' strongest reflections - (|De|min =',
     * f5.2,'  emin =',f5.2,')',/)
   20 format(/,' Psizero relationships estimated among the: ',/,
     *        1x,i4,' strongest and the ',i4,'  weakest reflections',/)
c--clear the areas
      if (icent.eq.0) then
         if (knw.eq.1) call nclrt
         if (knw.eq.0) call nclrt1
      else
         if (knw.eq.1) call clrt
         if (knw.eq.0) call clrt1
      endif

      njn=0
c--------------------------------------------------------------
      if (knw.eq.0) go to 1005

 1005 continue
      do 1001 k=1,ndim
      itab(k)=0
1001  continue
      do 1004 i=1,ifatx
      isr(i)=0
1004  continue
c--create the list
      ipu=0
      do 1900 j=1,nreft
      jvet(1:3)=khl(1:3,j)

      do 1100 i=1,nsym
      do 1111 i1=1,3
      ill(i1)=0
      do 1111 j1=1,3
      ill(i1)=ill(i1)+jvet(j1)*kmat(i,j1,i1)
 1111 continue
      indr=ill(1)*ifat1+ill(2)*ifat2+ill(3)
      indrr=indr
      if (i.eq.1) go to 1113
      imen1=i-1
      do 1112 i1=1,imen1
      if (indr.eq.ivet(i1)) indrr=0
 1112 continue
 1113 ipu=ipu+1
      ivet(i)=indrr
      a=jvet(1)*tmat(i,1)+jvet(2)*tmat(i,2)+jvet(3)*tmat(i,3)
      k=nint(a*24.)
      k=mod(k,24)
      if(k.lt.0) k=k+24
      if (ipu.gt.ndim) then
         write(6,*) ' ERROR: riflesso numero',j,ipu,ndim
         call cstop(' ')
      endif

      itab(ipu)=indrr
      itab1(ipu)=((ill(2)+128)*256+ill(3)+128)*32+k
      isgn=isign(1,indr)
      indr=iabs(indr)
      if(isr(indr).eq.0)isr(indr)=(j*100+i)*isgn
 1100 continue
 1900 continue
      n8t=ndim
      if (ipsi0.gt.0) then
        n8t=20000
        limma=nint(float(n8t)/float(nrefp))
        limma=min0(limma,80)
      endif

      jsup =nreft-1
c
c--first loop
      jt=0
      sumse=0.0
      isum=0.0
      n8=0
      n8e=0
      n8epos=0
      n8eneg=0
      np=0
      ng=0
      nrel(:)=0
      isig(:,:)=0
      isigpos(:,:)=0
      isigneg(:,:)=0
      gq(:)=0.0
      gqpos(:)=0.0
      gqneg(:)=0.0

      if (ipsi0.eq.0) then
         ninf = 1
         nsup = nreft - 2
      else
        ninf=nreft+1
        nsup=nreft+nrefp
c       ninf = nrefc - nrefp +1
c       nsup = nrefc
      endif

      inn1=1-nsym 
      do 2000 i=ninf,nsup
      if (ipsi0.eq.0) then
        ilista7 = i
      else
        ikoti=i-ninf +1
c       ilista7 = nrefc - nrefp + ikoti
        ilista7 = nrefl - nrefp + ikoti
c       print*,i,ikoti,ilista7
c       stop
      endif
      ee1=evet(ilista7)
      fd1=fdelta(jderi,ilista7)
      sig1=1+1.*sigde(jderi,ilista7)**2
      ityp1=mkang(ilista7)
      if(iprin.lt.2) goto 2005
      ill(1:3)=khl(1:3,ilista7)
      ifi=ipub(ilista7)
      write(lo,2004) (ill(n),n=1,3),i,e1,fd1,ifi
 2004 format(/,' reflection ',3i4,10x,
     1 'code = ',i6,10x,
     2 'e = ',f7.2,10x,
     3 'de = ',f7.2,10x,
     4 'phase =',i7,/)
      js=0
 2005 if(ipsi0.gt.0)go to 2007
      inn1=inn1+nsym
      itt=itab1(inn1)/32
      jk1=itt/256-128
      jl1=itt-(jk1+128)*256-128
      i1=i
      go to 2008
 2007 jvet(1:3)=khl(1:3,ilista7)
      jh1=jvet(1)
      jk1=jvet(2)
      jl1=jvet(3)
      i1=0
c
c--second loop
c
 2008 ins=(i-1)*nsym+1

      if(ipsi0.eq.0)then
        ih31=itab(ins)
      else
        ih31=jh1*ifat1+jk1*ifat2+jl1
      endif

      jinf=i1+1
      do 2100 j=jinf,jsup
      ee2=evet(j)
      fd2=fdelta(jderi,j)
      sig2=1+1.*sigde(jderi,j)**2
      ityp2=mkang(j)
      i0=2*nsym
      do 2110 ii=1,i0
      ivet(ii)=0
 2110 continue
      i0=0
      jn=(j-1)*nsym
      do 2200 k=1,nsym
      jnk=jn+k
      if(itab(jnk).eq.0) goto 2200
      itt=itab1(jnk)/32
      jk2=itt/256-128
      jl2=itt-(jk2+128)*256-128
      do 2300 l=1,3,2
      l1=l-2
      ih32=itab(jnk)
      ih3=ih31+ih32*l1
      l3=1
      if(ih3) 2010,2300,2020
 2010 l3=-1
      ih3=-ih3
 2020 if(ih3.gt.ifatx) go to 2300
      if(isr(ih3).eq.0) go to 2300
      jk=iabs(jk1+jk2*l1)
      if(jk.gt.ihmx(2)) go to 2300
      jl=iabs(jl1+jl2*l1)
      if(jl .gt.ihmx(3)) go to 2300
      if(isr(ih3).lt.0) l3=-l3
      isra=isr(ih3)
      isra=iabs(isra)
      in=isra/100
      if(in.le.j) go to 2300
      if(in.gt.jsup+1) goto 2300
      if(i0.eq.0)go to 2030
      do 2040  ii=1,i0
      if(in.eq.ivet(ii))go to 2300
 2040 continue
 2030 i0=i0+1
      ivet(i0)=in
      in3=isra-in*100
      ins=(in-1)*nsym+in3
      ns3=mod(itab1(ins),32)
      ns2=mod(itab1(jnk),32)
      is =-ns2*l1+ns3*l3+48
      is =mod(is ,24)
      iss=is*360/24
c
c  phi(t)=phi(h1)-phi(h2)-phi(h3)+shift(fase)
c  i codici sono per  h1 = h2 + h3
c  cod(h2)= -l1 * j
c  cod(h3)=  l3 * in
c -----------------------------------------------------------
c  il tripletto e' costruito   : h1 + l1 * h2(R) = l3 * h3(R)
c  il tripletto e' memorizzato : h1 + l1 * h2(R) - l3 * h3(R)
c -----------------------------------------------------------
c
c

      iphi= ipub(ilista7) + ipub(j)*l1 - ipub(in)*l3 + iss
      if(iphi.lt.0)iphi=iphi+3600
      iphi=mod(iphi,360)

      ee3=evet(in)
      fd3=fdelta(jderi,in)
      sig3=1+1.*sigde(jderi,in)**2
      ityp3=mkang(in)
c --------------------------------------------------------------------
c
c   routine for triplets symmetry inconsistent
c
c --------------------------------------------------------------------
      if(icent.gt.0) goto 5000
      if(ityp1.eq.1.or.ityp2.eq.1.or.ityp3.eq.1) goto 5000
      isotyp=(ityp1-1) + l1*(ityp2-1) - l3*(ityp3-1)
      isopha=isotyp*15 + iss
      imo=mod(isopha,180)
      if(imo.eq.0) goto 5000
      iconts=iconts+1
      if(iconts.gt.10) goto 2300
      do 4475 ini1=1,3
 4475 linex(ini1)=' ??????? '
c     write(6,*)' i  ityp1 =',i,ityp1
      write(linex(1),4485) rescha(ityp1)
      write(linex(2),4485) rescha(ityp2)
      write(linex(3),4485) rescha(ityp3)
 4485 format(a9)
      if(ili0.ne.0) goto 4600
      ili0=1
      write(lo,4500)
 4500 format(//, '  the following triplets are symmetry inconsistent',
     1 ': they have been excluded from the procedure',//,
     2 10x,3('code',2x,'ph.rest.',5x),/)
 4600 write(lo,4700) i,linex(1),j,linex(2),in,linex(3)
 4700 format(10x,3(1x,i5,1x,a9,5x))
      if(iconts.eq.10) write(lo,4710)
 4710 format(10x,' ..... and so on',/)
      goto 2300
 5000 continue

      gcoch=fnat*ee1*ee2*ee3
      if (ipsi0.gt.0)then
         g=s3s2d(jderi)*fd2*fd3
         if (nrel(i).gt.limma) goto 2300
         nrel(i)=nrel(i)+1
      else
         g=gcoch+s3s2d(jderi)*fd1*fd2*fd3
CCC      g=gcoch+s3s2d(jderi)*(fd1/sig1)*(fd2/sig2)*(fd3/sig3)
c        segnoVero=cos(iphi*dtor)
c        if (segnoVero < 0) then
c          g=-(abs(g))
c        else
c          g=abs(g)
c        endif
         if (knw.gt.0) then
           segnc=deltaV(jderi,i)*deltaV(jderi,j)*deltaV(jderi,in)
           segno=fdelta(jderi,i)*fdelta(jderi,j)*fdelta(jderi,in)
           segno=sign(1.0,segno)
           segnc=sign(1.0,segnc)
           segnoc=segno*segnc
           if (segnoc.gt.0.0) segnoc=0.0
           if (segnoc.lt.0.0) segnoc=1.0
         endif
      
c       if (nrel(i).gt.limma) goto 2300
c       if (nrel(j).gt.limma) goto 2300
c       if (nrel(in).gt.limma) goto 2300

        if (ipsi0.eq.0.and.abs(2.0*g).lt.sogpo)goto 2300
        nrel(i)=nrel(i)+1
        nrel(j)=nrel(j)+1
        nrel(in)=nrel(in)+1
      endif


 2033 if(icent.eq.0) g=2.*g
c******* calc. <alfa> and alfavar:***********
      if (ipsi0.eq.0)then
          gj=abs(g)
          if(icent.gt.0)then
             t2=tanh(gj*0.5)
             alfvarinv(i)=alfvarinv(i)+gj*gj*(1.0-t2*t2)
             alfvarinv(j)=alfvarinv(j)+gj*gj*(1.0-t2*t2)
             alfvarinv(in)=alfvarinv(in)+gj*gj*(1.0-t2*t2)
          else
             t2=bes(gj)
             alfvarinv(i)=alfvarinv(i)+gj*gj*(1.0-t2*(1.0/gj+t2))
             alfvarinv(j)=alfvarinv(j)+gj*gj*(1.0-t2*(1.0/gj+t2))
             alfvarinv(in)=alfvarinv(in)+gj*gj*(1.0-t2*(1.0/gj+t2))
          endif
          alfestinv(i)=alfestinv(i)+gj*t2     
          alfestinv(j)=alfestinv(j)+gj*t2     
          alfestinv(in)=alfestinv(in)+gj*t2     
      end if
c*****************
c-- segue il blocco 3 frammento traslato
      gb=g
      gcochb=gcoch
      if(g.gt.20.47) gb=20.47
      if(g.lt.-20.47) gb=-20.47
      if(gcoch.gt.20.47) gcochb=20.47
      jg=nint(gb*100.0)
      jgcoch=nint(gcochb*100.0)
      if(iprin.lt.2)go to 2027
      js=js+1
      jt=jt+1
      ist(1,jt)=-j*l1
      ist(2,jt)=in*l3
      gt(jt)=g
      iphit(jt)=iphi
      if(jt.ne.3) go to 2027
      write(lo,2026) ((ist(n,nn),n=1,2),gt(nn),iphit(nn),nn=1,3)
 2026 format(3(2x,2i6,f7.2,i5))
      jt=0
c+++++++++++pour une statistic pour toutes les G+++++++++++++
2027  continue
      gg=g
      b=float(iphi)*pi/180.0
      a=cos(b)
      an=a*gg
      bang=iphi
      if (iphi.gt.180) bang=360.0-bang
      if(knw.eq.1)then
                   call nctet(gg,a,bang,1)
                  else
                   call nctet1(gg,a,bang)
                  endif
c *******************************************************
c **  is   =  d-shift del tripletto
c **  i    =  code del primo riflesso
c **  j    =  code del secondo riflesso
c **  in   =  code del terzo riflesso
c **  k    =  operatore di simm. del secondo riflesso
c **  in3  =  operatore di simm. del terzo riflesso
c **  l1   =  segno del secondo riflesso
c **  l3   =  segno del terzo riflesso
c **  jg   =  int(g*100)
c **  iphi =  fase reale del tripletto
c ********************************************************
 2028 if(n8.eq.n8t) go to 2320
      if (knw.gt.0) then
          sumse=sumse+segnoc
          isum=isum+1
      endif
      n8=n8+1
      if (ipsi0.eq.0) then
       if (g.ge.0.0)then
         np=np+1
         gqpos(np)=gb
         isigpos(1,np)=((i+2048)*4096+l1*j+2048)*32+iphi/15+1
         isigpos(2,np)=((-l3*in+2048)*4096+jg+2048)*32+is+1
         isigpos(3,np)=((k*32+in3)*4096+jg+2048)*32+mod(iphi,15)+1
         go to 2300
       elseif (g.lt.0.0)then
         ng=ng+1
         gqneg(ng)=gb
         isigneg(1,ng)=((i+2048)*4096+l1*j+2048)*32+iphi/15+1
         isigneg(2,ng)=((-l3*in+2048)*4096+iabs(jg)+2048)*32+is+1
         isigneg(3,ng)=((k*32+in3)*4096+iabs(jg)+2048)*32+mod(iphi,15)+1
         go to 2300
       end if              
      else
        gq(n8)=gb
        isig(1,n8)=((i+2048)*4096+l1*j+2048)*32+iphi/15+1
        isig(2,n8)=((-l3*in+2048)*4096+jg+2048)*32+is+1
        isig(3,n8)=((k*32+in3)*4096+jg+2048)*32+mod(iphi,15)+1
        go to 2300
      endif
c
2320  if (ipsi0.gt.0) goto 2400
      if(n8e.ne.0)goto 2330 
c
      n8mpos=np
      n8lpos=np
      if(ng.gt.0)then
         n8mneg=ng
         n8lneg=ng
      else
         n8mneg=0
         n8lneg=0
      endif
c     call sortg_mem(gqpos,isigpos,np)
      gq(:)=gqpos(:)
      isig(3,:)=isigpos(3,:)
      call sortg_mem(np)
      gqpos(:)=gq(:)
      isigpos(3,:)=isig(3,:)
      gmpos=gqpos(n8mpos)
      if (ng.gt.0)then
         gq(:)=gqneg(:)
         isig(3,:)=isigneg(3,:)
         call sortg_mem(ng)
         gqneg(:)=gq(:)
         isigneg(3,:)=isig(3,:)
         gmneg=gqneg(n8mneg)
      endif

      n8lpos=n8mpos
      n8lneg=n8mneg

 2330 continue
      if (knw.gt.0) then
          sumse=sumse+segnoc
          isum=isum+1
      endif
      if (gb.ge.0.0) then
      n8e=n8e+1
      n8epos=n8epos+1

      call  unpak3(isigpos(1,n8mpos),ndr(1),ndr(2),idium)
      call  unpak3(isigpos(2,n8mpos),ndr(3),idum1,idium)
      do 2222 nni=1,3
         ndr(nni)=iabs(ndr(nni))
         if(ndr(nni).eq.i.or.ndr(nni).eq.j.or.ndr(nni).eq.in)
     *   go to 2223
         if(nrel(ndr(nni)).lt.limmi) go to 2300
2222  continue

2223  if(gb.le.gmpos)go to 2300


      nrel(i)=nrel(i)+1
      nrel(j)=nrel(j)+1
      nrel(in)=nrel(in)+1
      nrel(iabs(ndr(1)))=nrel(iabs(ndr(1)))-1
      nrel(iabs(ndr(2)))=nrel(iabs(ndr(2)))-1
      nrel(iabs(ndr(3)))=nrel(iabs(ndr(3)))-1
      gqpos(n8mpos)=gb
      isigpos(1,n8mpos)=((i+2048)*4096+l1*j+2048)*32+iphi/15+1
      isigpos(2,n8mpos)=((-l3*in+2048)*4096+jg+2048)*32+is+1
      isigpos(3,n8mpos)=((k*32+in3)*4096+jg+2048)*32+mod(iphi,15)+1
          gmpos=100.
          n8lmpos1=n8lpos-1
          if(n8lmpos1.lt.1) n8lmpos1=1
        do 2343 ii=n8lmpos1,np
          gapos=gqpos(ii)
          if(gapos.gt.gmpos)go to 2343
          gmpos=gapos
          n8mpos=ii
 2343   continue 
      elseif(gb.lt.0.0)then
         n8e=n8e+1
         n8eneg=n8eneg+1
	 call  unpak3(isigneg(1,n8mneg),ndr(1),ndr(2),idium)
         call  unpak3(isigneg(2,n8mneg),ndr(3),idum1,idium)
         do 2224 nni=1,3
	   ndr(nni)=iabs(ndr(nni))
           if(ndr(nni).eq.i.or.ndr(nni).eq.j.or.ndr(nni).eq.in)
     *    go to 2225
          if(nrel(ndr(nni)).lt.limmi) go to 2300
2224     continue

2225  if(gb.ge.gmneg)go to 2300
      nrel(i)=nrel(i)+1
      nrel(j)=nrel(j)+1
      nrel(in)=nrel(in)+1
      nrel(iabs(ndr(1)))=nrel(iabs(ndr(1)))-1
      nrel(iabs(ndr(2)))=nrel(iabs(ndr(2)))-1
      nrel(iabs(ndr(3)))=nrel(iabs(ndr(3)))-1
      gqneg(n8mneg)=gb
      isigneg(1,n8mneg)=((i+2048)*4096+l1*j+2048)*32+iphi/15+1
      isigneg(2,n8mneg)=((-l3*in+2048)*4096+iabs(jg)+2048)*32+is+1
      isigneg(3,n8mneg)=((k*32+in3)*4096+iabs(jg)+2048)*
     * 32+mod(iphi,15)+1
          gmneg=-100.
          n8lmneg1=n8lneg-1
          if(n8lmneg1.lt.1) n8lmneg1=1
        do 2344 ii=n8lmneg1,ng
          ganeg=gqneg(ii)
          if(ganeg.lt.gmneg)go to 2344
          gmneg=ganeg
          n8mneg=ii
 2344   continue
      endif
       if (gb.ge.0.0) n8lpos=min0(n8lpos,n8mpos)
       if (gb.lt.0.0) n8lneg=min0(n8lneg,n8mneg)
 2300 continue
 2200 continue
 2100 continue
      if(iprin.lt.2) go to 2000
      if(jt.eq.0) go to 2002
      write(lo,2026) ((ist(n,nn),n=1,2),gt(nn),iphit(nn),nn=1,jt)
      jt=0
 2002 continue
      write(lo,2101) js
 2101 format(' number of contributors =',i6)
      js=0
 2000 continue
 2400 continue
c-------------------------------------------------------------------------
2500  n8e=n8e+n8
      if (ipsi0.gt.0) goto 2600
      nuposo=0
      nunego=0
      nuenao=0
      gminp=0.0
      call outsg(ipsi0,n8,n8t,np,ng,n8e,n8epos,n8eneg,
     *           nuposo,nunego,nuenao,gminp)
      if (iprin.gt.0) then
          write(lo,6100)nuposo,nupos,nunego,nuneg
          if (icent.eq.0) write(lo,6110)nuenao,nuena
          write(lo,6090)
      endif
 2600 continue
      if (ipsi0.eq.0)then 
         result(1,1)=nuposo
         result(1,2)=nupos
         result(2,1)=nunego
         result(2,2)=nuneg
         result(3,1)=nuenao
         result(3,2)=nuena

         ! prin Triplets Results on the Graphic
         write(strLog,'(1x,i5,23h positive triplets and ,i5,
     *       28h negative triplets are found)')np,ng
         if (kscreen > 0) then
!         inBoxGr(2)=inBoxGr(2)+1
          call TestoGR(strLog, -1, 2, 2)
          call zflush
          call DoSingleIteration()
         endif
      else
         result(4,1)=n8e
         result(4,2)=n8
      endif
 6090 format(1h )
 6100 format(//,
     *i8,' positive estimated triplets     ',5x,'(',i5,' stored)',/,
     1i8,' negative estimated triplets     ',5x,'(',i5,' stored)')
 6110 format(i8,' enantiomorph sensitive triplets ',5x,'(',i5,' stored)'
     *)

      if (ipsi0.eq.0)then
         igm=gq(nupos)*1000.
         call wrtr9_mem(ndim,1,igm,0)
         if(nuena.eq.0)call Cancella(11)
      else
         igm=gq(n8)*1000.
         npsa=n8
         ntra=n8
         call wrtr9_mem(ndim,2,igm,0)
      endif

      deallocate (isr,stat=ier)

      return
      end
c-----------------------------------------------------------------------
      subroutine outsg(ipsi0,n8,n8t,np,ng,n8e,n8epos,n8eneg,
     *                 nuposo,nunego,nuenao,gminp)
      USE General
      USE Symmetry
      USE InvarData

      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nweak,sgg
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/ sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn

        write(lo,*)'---------------------------------------------------'
        write(lo,*)'          TRIPLETS INFORMATION'
        write(lo,*)' Total    Positive     Negative'
        write(lo,'(1x,i6,4x,i6,7x,i6)') n8e,np+n8epos,ng+n8eneg
        write(lo,*)'          TRIPLETS  THAT CAN BE STORED'
        write(lo,'(1x,i6,4x,i6,7x,i6)')n8,np,ng
        write(lo,*)'---------------------------------------------------'
c       if (iprin.gt.0) then
        WRITE(lo,*)
        write(lo,*)'        STATISTIC FOR CALCULATE TRIPLETS'
        WRITE(lo,*)
        if (icent.eq.0) then
           if (knw.eq.1) call nstst
           if (knw.eq.0) call nstst1
        else
           if (knw.eq.1) call stst
           if (knw.eq.0) call stst1
        end if

c       end if
c---we put all the triplets in the gq and isig

      if (np.gt.0)then
           do 40 i=1,np
             gq(i)=gqpos(i)
             isig(1,i)=isigpos(1,i)
             isig(2,i)=isigpos(2,i)
             isig(3,i)=isigpos(3,i)
 40        continue
        end if

      if (ng.gt.0)then
           do 50 i=1,ng
             ii=np+i
             gq(ii)=gqneg(i)
             isig(1,ii)=isigneg(1,i)
             isig(2,ii)=isigneg(2,i)
             isig(3,ii)=isigneg(3,i)
 50         continue
      endif
      ntra=n8
      if (ipsi0.eq.1) return
c     if (n8.lt.n8t) call sortg_mem(ntra)
         indpo=1
         inden=0
         indne=0
         nupos=0
         nuena=0
         nuneg=0
         nuposo=np+n8epos
         nunego=ng+n8eneg
         do 80  i=1,ntra
            ggqq=abs(gq(i))
            if(inden.eq.0.and.ggqq.le.sogen) inden=i
            if(indne.eq.0.and.gq(i).le.sogne) indne=i
            if(gq(i).ge.sogpo) nupos=nupos+1
            if(ggqq.le.sogen) nuena=nuena+1
            if(gq(i).le.sogne) nuneg=nuneg+1
 80       continue
         nuenao=nuena
 6000    if(nuena.le.nmxte) goto 6040
          ifin=inden+nuena-1
          iniz=inden
          inden=0
          nuena=0
          sogen=sogen-0.05
          do 6010 i=iniz,ifin
           ggqq=abs(gq(i))
           if(ggqq.gt.sogen) goto 6010
           if(inden.eq.0) inden=i
           nuena=nuena+1
 6010     continue
           go to 6000
      
c-----per sigma2 troviamo gmin,e memoriziamo nr. tot. dei tripletti
 6040 if (ipsi0.eq.0)then
          !call test10_mem(isig,gq,ntra)
          call test10_mem(ntra)
          if (indne.gt.1) then
            gmin1=gq(indne-1)
            gmin2=abs(gq(indne))
            gmin=min(gmin1,gmin2)
          endif
      endif
      return
      end
c--------------------------------------------------------------
      subroutine sortg_mem(numb)
      USE General
      USE Symmetry
      USE InvarData
       
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nweak,sgg
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/ sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ne1,ne2,ne3,ne4,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1,itest

c--sort the sigma 2 and the g-correct list
c
c--
      if(numb.eq.1) return
      m=2
2010  continue
      in=numb/m
      if(in) 2020,2020,2030
2020  continue
      in=1
2030  continue
      ifin=numb-in
2040  continue
      mark=0
      do 2060 i=1,ifin
      k=i+in
      if(gq(i)-gq(k)) 2050,2060,2060
2050  continue
      do 2055 n=1,3
      jc=isig(n,i)
      isig(n,i)=isig(n,k)
      isig(n,k)=jc
2055  continue
      gg=gq(i)
      gq(i)=gq(k)
      gq(k)=gg
      mark=1
2060  continue
      if(mark) 2065,2065,2040
2065  continue
      if(in-1) 2080,2080,2070
2070  continue
      m=m*2
      go to 2010
2080  continue
      return
      end
c---------------------------------------------------------
      subroutine test10_mem(ntrip)
      USE General
      USE Symmetry
      USE InvarData
c
c--test on p10 results
c
      common /inp/  natom,fnat,satm,atoms
      common/prin/ ipt,ip0,ip10,ipq
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nweak,sgg
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/ sogpo,sogen,sogne,limit(6),dume(2)
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
      common /nctst/ ns,br(15),nb(11,15,3),fnb(11,15,3),bcm(11,15,3),
     *                        acm(11,15,3)
c--
      dimension nor1(3),sdc(3),sdca(3)
c--
      njn=1
c--  prepara il buffer per il test 
      if (icent.eq.0) then
          if (knw.eq.1) call nclrt
          if (knw.eq.0) call  nclrt1
      else
          if (knw.eq.1) call  clrt
          if (knw.eq.0) call  clrt1
      endif
c--loop per eseguire delle stampe utili
      nusba=0
      do 5001 ii=1,3
      if (ii.eq.2.and.icent.eq.1) go to 5001
      mark=0
      if (ii.eq.3) mark=1
      n8w=1
      iniz=limit(ii+3)
      ifin=limit(ii)+iniz-1
      sdc(ii)=0.0
      sdca(ii)=0.0
c     write(6,*) ' iniz,ifin,limit(6)',iniz,ifin,limit
      do 5000 i=iniz,ifin
      mark1=1
      mark1=0
      ia=int(gq(i)*100.)
      !call decom_mem(ntrip,i,g,ggv,ishi,ib,itest)
      call decom_mem(ntrip,i,g,ggv,ishi,ib,0)
      b=float(ib)*pi/180.

*--------
c     if (gq(i).lt.0.0) then
c      ib=ib+180
c      ib=mod(ib+360,360)
c      b=float(ib)*pi/180.
c      endif
c     gq(i)=abs(gq(i))
*--------

      a=cos(b)
      an=a*gq(i)
      if (icent.eq.1) then
c-- centrosymmetric test
                        gg=gq(i)
                        if (knw.eq.1) call sctst(gg,an,1)
                        if (knw.eq.0) call sctst1(gg,an)
                        coat=1.0
                        if (gg.lt.0.0) coat=-1.0
                      else
c-- noncentrosymmetric test
                        bb=sin(b)
      g2=gq(i)
      call besse(g2,coat)
                        bang=ib
                        if (ib.gt.180) bang=360.0-bang
                        if (knw.eq.1) call nctet(g2,a,bang,1)
                        if (knw.eq.0) call nctet1(g2,coat,a)
      an=coat*a
                      endif
      if (ii.ne.1) go to 4001
      if(nusba.ne.0.or.an.ge.0)go to 4001
      nusba=i
 4001 continue
      aa=b
      cc=acos(coat)
      dc=cc-aa
      adc=abs(dc)
      if(adc-pi) 4030,4030,4020
4020  continue
      dc=twopi-adc
      dc=-dc
4030  continue
      sdc(ii) =sdc(ii) +    dc
      sdca(ii)=sdca(ii)+abs(dc)
      do 5080 k=1,3
      nor1(k)=nor(k)*iseg(k)
 5080 continue
      cc=cc*180./pi
      aa=aa*180./pi
      dc=dc*180./pi
      if((mark+mark1).ne.0.and.iprin.ge.1)
     *write(lo,5100)(nor1(k),k=1,3),gq(i),ggv,cc,aa,dc
      n8w=n8w+1
 5000 continue
      if (limit(ii).eq.0) go to 5001
      xxx=180.0/(pi*float(limit(ii)))
      sdc(ii) = sdc(ii) * xxx
      sdca(ii)=sdca(ii) * xxx
 5001 continue
      if (knw.eq.1) write(lo,5500) nusba
 5500 format(//,1x,'serial number of the first wrong triplet =',i5)
 5100 format(4x,3i5,4x,2f10.2,3f12.2)
 5200 format(//,49x,6h<dphi>,5x,8h</dphi/>,
     1 /,2x,i6,' positive relationships ',12x,2f10.3,
     2 /,2x,i6,' enantiomorph sensitive rel. ', 7x,2f10.3,
     3 /,2x,i6,' negative relationships ',12x,2f10.3,//)
      if(icent)4300,4300,4400
 4300 continue
      if (knw.eq.1) write(lo,5200)(limit(ii),sdc(ii),sdca(ii),ii=1,3)
c--  stampa il test (non centro)
      if (knw.eq.1) call nstst
      if (knw.eq.0) call nstst1
      go to 4500
 4400 continue
c--  stampa il test (centro)
      if (knw.eq.1) call stst
      if (knw.eq.0) call stst1
 4500 continue
      return
      end
c----------------------------------------------------------
      subroutine decom_mem(ntrip,i,g,ggv,ishi,iphi,itest)

      USE General
      USE Riflessi
      USE RiflessiMIR
      USE InvarData

      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)

      call unpak3(isig(1,i),nor(1),nor(2),if1)
      call unpak3(isig(2,i),nor(3),ign,ishi)
      call unpak3(isig(3,i),kod,igv,if2)
      g=float(ign)/100.
      ggv=float(igv)/100.
      iphi=if1*15+if2
      kod=kod+2048
      nop(1)=1
      nop(2)=kod/32
      nop(3)=mod(kod,32)
      do 10 j=1,3
      iseg(j)=isign(1,nor(j))
      nor(j)=iabs(nor(j))
      k=nor(j)
      e=evet(j)
c     arg=2.0*epd1(iabs(k))*epp1(iabs(k))
c     xx=epd1(iabs(k))**2+epp1(iabs(k))**2
c     e=xx-2.0*epp1(iabs(k))*epd1(iabs(k))*bes(arg)
      e=abs(e)
      if (e.gt.0.0) e=sqrt(e)
      eeb(j)=e*e-1.
   10 continue
      return
      end
c--------------------------------------------------------------
      subroutine wrtr9_mem(nrel1,jump1,igm,jlist)
      USE General
      USE Symmetry
      USE InvarData


      common/prin/ ipt,ip0,ip10,ipq
      common /proc/ ifps,ifweig,jbig
      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nweak,sgg
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common/dir10/ sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      common/dirqn/ecros,iecros,ne1,ne2,ne3,ne4,ncode,icody,nquar
     1 ,nsog,sqes,nquam,nquat,nqenm,nqent,ecr1,iecr1,itest
      common /cp10/ nor(3),nop(3),iseg(3),eeb(6),ee(24,6)
      dimension ipu(6)
c--
c-- scrive le triplette su file
c ---  jump1=1   scrive le triplette
c ---  jump1=2   scrive le psi0
      i230=2**30
      npss=nrefp+nreft
      iz=0
      goto(100,1000),jump1
  100 continue
      ipu(1)=indpo
      ipu(2)=nupos
      ipu(3)=inden
      ipu(4)=inden+nuena-1
      ipu(5)=indne
      ipu(6)=indne+nuneg-1

c -----
c     call sub. scrittura relazioni tripletti positivi : lista  8
c -----
      ifp10=0
      iprea=0
      if (nupos.ne.0) then
*gl*      call frmxx(iprea,8,ntra,nupos,nreft,ifp10,igm,isig(1,indpo))
          call PreparaIph(8, ntra, nreft, igm, isig, indpo)
      endif
c
c -----
c     call  sub.  scrittura  tripletti negativi  :  lista 10
c -----
      if (nuneg.ne.0) then
*gl*     call frmxx (iprea,10,nuneg,nuneg,nreft,ifp10,igm,isig(1,indne))
         call PreparaIph(10, nuneg, nreft, igm, isig, indne)
      endif
c -----
c     call sub. scrittura tripletti enantiomorfi :  lista 11
c -----
      if (icent.eq.0.and.nuena.ne.0) then
*gl*     call frmxx (iprea,11,nuena,nuena,nreft,ifp10,igm,isig(1,inden))
         call PreparaIph(11, nuena, nreft, igm, isig, inden)
      endif

c-- update the preamble block of list 7 respect to strong reflections
c
c     nstr=nreft
c     iy=-1
c     call spb07(iy)
      return
c ---  scrive le psi0
 1000 npsfm=0
      n1=0
      do 50 i=1,npsa
      index=isig(1,i)
      call unpak3(index,nor1,nor2,if1)
      itab(i)=isig(1,i)
      itab1(i)=isig(2,i)
      if(nor1.gt.npss) goto 50
      call unpak3(isig(2,i),nor3,id,ishi)
      isig(1,i)=((nor2+2048)*4096+nor3+2048)*32+ishi+1
      isig(2,i)=((nor1+2048)*4096+nor2+2048)*32+ishi+1
      if(nor1.eq.n1) goto 40
      n1=nor1
      isig(1,i)=isig(1,i)+i230
   40 npsfm=npsfm+1
   50 continue
c -----
c     call  sub.  scrittura  relazioni  psizero  :  lista  9
c -----
      iprea=0
      nxxe=0
      iccd=0
*gl*  call frmxx (iprea,9,npsfm,npsfm,nrefp,nxxe,iccd,isig(1,1))
      call PreparaIph(9, npsfm, nrefp, iccd, isig, 1)
      do 60 i=1,npsa
      isig(2,i)=itab1(i)
   60 isig(1,i)=itab(i)
      return
      end
!-----------------------------------------------------------------------
      subroutine PreparaIph(iAction, nRel, nRefX, iGval, mat, ind)
!
      USE General
      USE PhaseModule, only: ntrip, nneg, npsi
      USE ListeXX
!
!-- Manage invariants relationships
!
!  iAction = 8   store positive triplets
!            9   store psi zero
!           10   store negative triplets
!           11   store enantiomorphous triplets
!  nRel    =     number of relationships to be stored
!  nRefX   =     number of reflections involved
!  iGval   =     Value of G * 100
!  mat     =     array containing the relationships
!
      implicit none
      integer :: iAction, nRel, nRefX, iGval, mat(3,*), ind
      integer :: ierv(4), ierr, i, j
!
      ierr = 0
      ierv = 0
!
      select case (iAction)

          case ( 8) !   positive triplets

             IF (.NOT. ALLOCATED(Lista08))
     *           ALLOCATE (Lista08(3, nRel), stat = ierv(1))
             if (ierv(1) == 0) then
                 do i=1, nRel
                    j = ind + i - 1
                    Lista08(1:3,i) = mat(1:3,j)
                 enddo
                 NSigPos = nRel
                 NRefPos = nRefX
                 iGmPos  = iGval
                 ntrip   = NSigPos
             endif

          case ( 9) !   psi zero

             IF (.NOT. ALLOCATED(Lista09))
     *           ALLOCATE (Lista09(3, nRel), stat = ierv(2))
             if (ierv(2) == 0) then
                 do i=1, nRel
                    j = ind + i - 1
                    Lista09(1:3,i) = mat(1:3,j)
                 enddo
                 NPsiZero = nRel
                 NRefZero = nRefX
                 iGmZero = iGval
                 npsi    = NPsiZero
             endif

          case (10) !   negative triplets

             IF (.NOT. ALLOCATED(Lista10))
     *           ALLOCATE (Lista10(3, nRel), stat = ierv(3))
             if (ierv(3) == 0) then
                 do i=1, nRel
                    j = ind + i - 1
                    Lista10(1:3,i) = mat(1:3,j)
                 enddo
                 NSigNeg = nRel
                 NRefNeg = nRefX
                 iGmNeg  = iGval
                 nneg    = NSigNeg
             endif

          case (11) !   enantiomorphous triplets

             IF (.NOT. ALLOCATED(Lista11))
     *           ALLOCATE (Lista11(3, nRel), stat = ierv(4))
             if (ierv(4) == 0) then
                 do i=1, nRel
                    j = ind + i - 1
                    Lista11(1:3,i) = mat(1:3,j)
                 enddo
                 NSigEna = nRel
                 NRefEna = nRefX
                 iGmEna  = iGval
             endif

          case ( 0) !   deallocates all

             if (allocated(Lista08)) deallocate(Lista08, stat = ierv(1))
             if (allocated(Lista09)) deallocate(Lista09, stat = ierv(2))
             if (allocated(Lista10)) deallocate(Lista10, stat = ierv(3))
             if (allocated(Lista11)) deallocate(Lista11, stat = ierv(4))

      end select
!
      ierr = sum(iabs(ierv(:)))
      if (ierr == 0) then
          if (iAction > 0) then
              InfoOK(iAction) = 1
          endif
      else
          write(6,*) 'PreparaIph (de)Allocation error: ', iAction
          call cstop(' Allocation error')
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine clrt1
c--prepare the test buffer (centro)
      common/tst1/nt,ar(19),nn(19),pp(19)
      ar( 1)=.0
      ar( 2)=.2
      ar( 3)=.4
      ar( 4)=.6
      ar( 5)=.8
      ar( 6)=1.
      ar( 7)=1.2
      ar( 8)=1.4
      ar( 9)=1.6
      ar(10)=2.
      ar(11)=2.5
      ar(12)=3.0
      ar(13)=3.5
      ar(14)=4.0
      ar(15)=5.0
      ar(16)=6.0
      ar(17)=8.0
      ar(18)=10.0
      ar(19)=15.0
      nt=19
      do 200 i=1,nt
      nn(i)=0
      pp(i)=0.0
 200  continue
      return
      end
c----------------------------------------------------------
      subroutine sctst1(aa,cc)
c--test for the correct coincidence (centro)
      common/tst1/nt,ar(19),nn(19),pp(19)
      bb=abs(aa)
      do 1100 i=1,nt
      if(ar(i).le.bb) then
                        nn(i)=nn(i)+1
                        if(cc)1100,1030,1030
 1030                   continue
                        pp(i)=pp(i)+1.0
                       endif
 1100 continue
      return
      end
c--------------------------------------------------------
      subroutine nclrt1
c--prepare the test buffer (non-centro)
c
      common /nctst1/ ns,br(19),nb(19),fnb(19)
c
      br( 1)=.0
      br( 2)=.2
      br( 3)=.4
      br( 4)=.6
      br( 5)=.8
      br( 6)=1.
      br( 7)=1.2
      br( 8)=1.4
      br( 9)=1.6
      br(10)=2.
      br(11)=2.5
      br(12)=3.0
      br(13)=3.5
      br(14)=4.0
      br(15)=5.0
      br(16)=6.0
      br(17)=8.0
      br(18)=10.0
      br(19)=15.0
      ns=19
      do 1150 i=1,ns
      nb (i)=0
      fnb(i)=0.0
1150  continue
      return
      end
c------------------------------------------------------
      subroutine nctet1(aa,co,cc)
c--test for the correct coincidence (non-centro)
c
      common /nctst1/ ns,br(19),nb(19),fnb(19)
c
      bb=abs(aa)
      do 1060 i=1,ns
      if(br(i).le.bb)  then
                         nb(i)=nb(i)+1
                         a=cc*co
                         if(a) 1060,1050,1050
1050                     continue
                         fnb(i)=fnb(i)+1.0
                       endif
1060  continue
      return
      end
c-----------------------------------------------------
      subroutine stst1
c--print the test (centro)
      USE General
      common/tst1/nt,ar(19),nn(19),ppv(19)
c
      dimension pa(19)
      data pa /19*0./
c
      write(lo,520)
  520 format(/1h0,38x,44hdistribution of g - number of g   .gt. limit)
      if (knw.eq.1)  write(lo,530)
  530 format(40x,41hand percentage(%) of correct relationship)
      write(lo,540)(ar(i),i=1,19),(nn(i),i=1,19)
  540 format(1h0,2x,3hg  ,19f6.1/1h ,1x,4hno. ,19i6)
      if (knw.eq.0) return
      do 1020 i=1,nt
      if(nn(i))1020,1020,1015
 1015 continue
      fn=float(nn(i))
      pa(i)=ppv(i)*100.0/fn
 1020 continue
      write(lo,550)(pa(i),i=1,19)
  550 format(1h ,2x,3h%  ,19f6.1)
      return
      end
c--------------------------------------------------
      subroutine nstst1
c--print the test (non-centro)
c
      USE General
      common /nctst1/ ns,br(19),nb(19),fnb(19)
c
      write(lo,520)
  520 format(/1h0,38x,44hdistribution of g - number of g   .gt. limit)
c
      if (knw.eq.1)  write(lo,530)
  530 format(40x,41hand percentage(%) of correct relationship)
      write(lo,540)(br(i),i=1,ns),(nb(i),i=1,ns)
  540 format(1h0,2x,3hg  ,19f6.1/1h ,1x,4hno. ,19i6)
      if (knw.eq.0) return
      do 1020 i=1,ns
      if(nb(i))1020,1020,1015
 1015 continue
      fn=float(nb(i))
      fnb(i)=fnb(i)*100.0/fn
 1020 continue
      write(lo,550)(fnb(i),i=1,ns)
  550 format(1h ,2x,3h%  ,19f6.1)
      return
      end

c***********************************************************
c  Preparare lista 6 nel caso del derivato  dove i riflessi sono sortati 
c  rispetto a DELTA ed E:
c  riflessi forti per sigma2 ( forti in delta ed E)
c  rifleesi deboli per tripletti PSI-0 ( deboli in delta ed E)
c***********************************************************
      subroutine OrdinareRiflessiTripletti(sogdf,rhomad,itest)

      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMIR

      common/dirtr/nreft,emin,ntra,ntrt,ntrmx,nweak,sgg
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      common /new/TRD,dfmin,dfmax,deldif,sogweak,icumde,perc,perct
      real,allocatable:: vat(:,:)

      if (.not.allocated(vat))
     *   allocate (vat(3,nrefl),stat=ierr)

      nreft=800+nint(480./float(nsym))
      ideb0=nreft/3
      ideb0=min0(nzro,ideb0)
      ideb0=min0(250,ideb0)
      write(lo,2000) nreft,sogdf

      ii1 = 0
      ii2 = nrefl + 1
      work1(:) = 0.0
      work2(:) = 0.0
      e1(:) = 0.0
      vat(:,:)=0.0

      ifund=0

      rhomaxT=0.0
      do i=1, nrefl
        if (fdelta(jderi,i)  > 9000) then
         ii2 = ii2 - 1
         iorde(ii2) = i
        else
         ii1 = ii1 + 1
         iorde(ii1) = i
         vat(1,ii1) = rhov(i)                ! (sint/l)**2
         vat(2,ii1) = abs(fdelta(jderi,i))   ! |delta_sir|
         vat(3,ii1) = evet(i)                   ! Enat
         if (rhov(i) > rhomaxT) rhomaxT = rhov(i)
        endif
      enddo

      dminT=0.5/sqrt(rhomaxT)

      nrefc = ii1
      call sortallM(1,vat,1,3,1,nrefc,iorde)

  110 continue
      if (rhomad.lt.1.0) then
        dmin=0.5/sqrt(rhomad)
        numbResolution = 0
        do i=1,nrefc
          ii=iorde(i)
          dd=0.5/sqrt(vat(1,i))
          if (dd < dmin) exit
          numbResolution = numbResolution + 1
        enddo


        nsup1=nint(perct*numbResolution)
        nsup=nint(perc*nsup1)

        write(lo,2500)dmin,numbResolution
        if (nsup < nreft) then
           dmin = dmin - 0.25
           rhomad = (0.5/dmin)**2
           dmin = amax1(dmin,dminT)
           rhomad = (0.5/dmin)**2
           goto 110
        endif

      else
          nsup1=nint(perct*nrefc)
          nsup=nint(perc*nsup1)
      endif

      ! sort x Enat
      call sortallM(-1,vat,3,3,1,numbResolution,iorde)
      init=1
      iend=nsup
      call sortallM(-1,vat,2,3,init,iend,iorde)

 380  ipos=0
      ineg=0
      dfmin=999.0
      emin=999.0
      iforti=0
      sumse=0.0
      do i=init,iend
         ii = iorde(i)
         de=fdelta(jderi,ii)
         ee=vat(3,i)
         rho2=vat(1,i)
         iforti=iforti+1
         if (de.gt.0) ipos=ipos+1
         if (de.lt.0) ineg=ineg+1
         if (knw.eq.1) then
             deV=deltaV(jderi,ii)
             se1=sign(1.0,de)
             se2=sign(1.0,deV)
             if (se1.ne.se2) sumse=sumse+1
         endif
         if (abs(de).lt.dfmin) dfmin=abs(de)
         if (ee.lt.emin) emin=ee
         if (nreft.gt.0) then
             if (iforti.eq.nreft) exit
         else
             if (abs(de).lt.sogdf) then
                nreft=iforti
                ifund=2
                exit
             endif
         endif
         enddo
         rap=0.0
         if (ineg.gt.0) rap=float(ipos)/float(ineg)
         sumse=100.0*sumse/float(iforti)
         write(lo,3000)iforti,dfmin,sumse,rap,emin,perc*perct*100.0
         if (ifund /= 2) then
             if (dfmin.lt.sogdf.and.ifund.eq.0) then
                 dmin=dmin-0.25
                 rhomad=(0.5/dmin)**2
                 dmin=amax1(dmin,dminT)
                 rhomad=(0.5/dmin)**2
                 if (dmin.eq.dminT) ifund=1
                 goto 110
             elseif (dfmin.lt.sogdf.and.ifund.eq.1) then
                 nreft=0
                 goto 380
             endif
         endif


c---- i deboli
      init=numbResolution-nzro+1
      if (perct.lt.1.0) init=max0(init,nsup1+1)
      iend=numbResolution

      call sortallM(-1,vat,2,3,init,iend,iorde)
      ideboli=0
      ideb0=nreft/3
      ideb0=min0(nzro,ideb0)
      ideb0=min0(250,ideb0)
      ipos=0
      ineg=0
      dfmax=0.0
      emax=0.0
      do i=iend,init,-1
         ii=iorde(i)
         ideboli=ideboli+1
         de=fdelta(jderi,ii)
         ee=evet(ii)
         if (de.gt.0) ipos=ipos+1
         if (de.lt.0) ineg=ineg+1
         if (abs(de).gt.dfmax) dfmax=abs(de)
         if (ee.gt.emax) emax=ee
         if (ideboli.eq.ideb0) exit
          if (abs(de).gt.0.4) exit
      enddo
      rap=0.0
      if (ineg.gt.0) rap=float(ipos)/float(ineg)
      write(lo,3500)ideboli,dfmax,rap,emax,(1.0-perc*perct)*100.0

*------spostiamo i deboli alla fine della lista
      if (rhomad.lt.1.0) then
        k=nrefc
        do i=iend,iend-ideboli,-1
          ii1=iorde(i)
          ii2=iorde(k)
          iorde(i)=ii2
          iorde(k)=ii1
        enddo
      endif


      if (allocated(vat)) 
     *     deallocate(vat, stat = ierr)


*gl*  call riCreaLista6g()
      call riCreaRiflessiSirprotG()

      nstr=iforti
      iy=-1
*gl*  call pre06
      call UpdateReflInfo

      iy=-4
      nzro=ideboli

*gl*  call pre06
      call UpdateReflInfo

      iy=-5
*gl*  call pre06
      call UpdateReflInfo


 2000 format('  Nr. of strong reflection to be found ......',i6,/,
     *       '  with |Delta|min ...........................',f6.2,/)
 2500 format('  Nr. of reflections up to',f6.2,' (A).........',i6,/)
 3000   format(14x,'Nr. of strong refl. ...........',i6,/,
     *         14x,'  |Delta|min...................',f6.2,/,
     *         14x,'  %inversion Delta sign........',f6.2,/,
     *         14x,'  Pos/Neg .....................',f6.2,/,
     *         14x,'  Emin    .....................',f6.2,/,
     *         14x,'  % of reflections ............',f6.2,/)
 3500   format(14x,'Nr. of weak refl. .............',i6,/,
     *         14x,'  |Delta|max ..................',f6.2,/,
     *         14x,'  Pos/Neg .....................',f6.2,/,
     *         14x,'  Emax    .....................',f6.2,/,
     *         14x,'  % of reflections ............',f6.2,/)


      return
      end
!---------------------------------------------------------------------
      subroutine PreparaIph_da_cancellare(iAction, ifinConver)
!
!-- iAction = 1   Positive and Negative Triplets
!           = 2   Psi-zero
!           = 4   Pointers table preparation
!
      USE General
      USE Symmetry
      USE InvarStuff
      USE PhaseModule
      USE PhaseStuff
      USE PhaseData
*     USE Triplets
!
      implicit none
      integer :: nupos, nuena, nuneg, indpo, inden, indne, nmxte, nmxtn
      real    :: sogpo, sogen, sogne
      common/dir10/ sogpo,sogen,sogne,nupos,nuena,nuneg,
     1 indpo,inden,indne,nmxte,nmxtn
      integer :: nrefp, npsa, nrefpl, npsmx
      real    :: emax
      common/dirps/nrefp,emax,npsa,nrefpl,npsmx
      integer :: NSigPos, NSigNeg, NQuaNeg, inizNeg, NPsiZero, nq, ierr
      integer :: iAction, i, j, ia, ifaz, ia_sog, NSN
      integer :: nor1, nor2, nor3, id, ishi, isig1, npss, npsfm
      integer :: l, if1, if2, n1, nb1, nnn1(4), jcris, ifazm, j1, npunt
      integer :: nc, isi, na1, ifinConver, lim1(4001), jpp, numbReflTrip
      real    :: SogPos, SogNeg, SogQuaNeg, a1
      integer :: nn1,nn2,nn3,nn4, ntripelimi
!
      return
      end
!sir  NSigPos = nupos
!sir  NSigNeg = nuneg
!sir  NPsiZero = npsa
!sir  if (iAction == 1) then
!sir      numbTriplets = NSigPos + NSigNeg
!sir      Allocate (iet(6,1:numbTriplets), stat = ierr)
!sir      if (ierr /= 0) then
!sir          write(lo,*) 'iet Allocation error'
!sir          call cstop(' ')
!sir      endif
!
!-- Positive triplets
!
!sir      nutri = 0
!sir      do i=1, NSigPos
!sir         call unpak3Sir(isig(1,i), nn(1), nn(2), ifaz)
!sir         call unpak3Sir(isig(2,i), nn(3), ia, ifaz)
!sir         if (icent > 0) ia = 2 * ia
!sir         if (ia > 2047) ia = 2047
!sir         if (ia > 0) then
!sir             nutri = nutri+1
!sir             iet(1,nutri) = nn(1)
!sir             iet(2,nutri) = nn(2)
!sir             iet(3,nutri) = nn(3)
!sir             iet(4,nutri) = ia
!sir             iet(5,nutri) = ifaz
!sir             iet(6,nutri) = isig(3,i)/32
!sir         endif
!sir      enddo
!sir      NSigPos = nutri
!
!-- Negative triplets
!
!sir      NSN = 0
!sir      if (NSigNeg > 0) then
!sir          do i=1, NSigNeg
!sir             j = inizNeg + i - 1
!
!-- old FOMs: NEG TRIPL
!
!sir             negt1(i) = isig(1,i)
!sir             negt2(i) = isig(2,i)
!
!-- old FOMs: NEG TRIPL
!
!sir             call unpak3Sir(isig(1,j), nn(1), nn(2), ifaz)
!sir             call unpak3Sir(isig(2,j), nn(3), ia, ifaz)
!sir             if (ia >= 60) then      !ia = gmin
!sir                 ia = -ia
!sir                 ifaz = mod(ifaz+12 ,24)
!sir                 if (icent > 0) ia = 2 * ia
!sir                 if (ia > 2047) ia = 2047
!sir                 nutri = nutri+1
!sir                 NSN = NSN + 1
!sir                 iet(1,nutri) = nn(1)
!sir                 iet(2,nutri) = nn(2)
!sir                 iet(3,nutri) = nn(3)
!sir                 iet(4,nutri) = ia
!sir                 iet(5,nutri) = ifaz
!sir
!sir             endif
!sir          enddo
!sir          NSigNeg = NSN
!sir      endif
!sir      InfoOK(8) = 1
!
!sir  elseif (iAction == 2) then
!
!-- Psi zero
!
!sir      Allocate (imat(6,1:NPsiZero), stat = ierr)
!sir      if (ierr /= 0) then
!sir          write(lo,*) 'imat Allocation error'
!sir          call cstop(' ')
!sir      endif
!sir      npss  = nzro + nstr
!sir      npsfm = 0
!sir      n1    = 0
!sir      do i=1, NPsiZero
!sir         imat(1:3,i) = isig(1:3,i)
!sir         isig1 = isig(1,i)
!sir         call unpak3Sir(isig(1,i),nor1,nor2,if1)
!sir         nor1 = nor1 + 1
!sir        if (nor1.le.npss) then
!sir             call unpak3Sir(isig(2,i),nor3,id,ishi)
!sir             imat(1,i) = ((nor2+4096)*8192+nor3+4096)*32+ishi+1
!sir             imat(2,i) = ((nor1+4096)*8192+nor2+4096)*32+ishi+1
!sir             if (nor1 /= n1) then
!sir                 n1 = nor1
!sir                 imat(1,i) = -imat(1,i)
!sir             endif
!sir             npsfm = npsfm + 1
!sir         endif
!sir         iph0n(i) = imat(1,i)
!sir      enddo
!sir  elseif (iAction == 4) then
!
!-- preparation of pointers table
!
!sir!          nq = 0
!sir!          LenIPH = numbTriplets*12 + nq*20
!sir!          call AllocaPhaseStuff(1)
!sir!          numbTriplets = NSigPos + NSigNeg
!sir!          nb1 = nstr + 1
!sir!          limref(:) = 0
!sir!          ntripelimi = 0
!sir!          ntripelimP = 0
!sir!          ntripelimN = 0
!sir!          do i = 1,numbTriplets
!sir!             nn(1) = iet(1,i)
!sir!             nn(2) = iet(2,i)
!sir!             nn(3) = iet(3,i)
!sir!             nn1=iabs(nn(1))
!sir!             nn2=iabs(nn(2))
!sir!             nn3=iabs(nn(3))
!sir!!!!!!!!!!!!!!!!!KRIS  ----  ciclo se uno dei riflessi e' quello che voglio scartare
!sir!             if (icodeli(nn1).eq.1.or.icodeli(nn2).eq.1
!sir!     *                                .or.icodeli(nn3).eq.1) then
!sir!                ntripelimi = ntripelimi + 1
!sir!                if (i <= NSigPos) then
!sir!                    ntripelimP = ntripelimP + 1
!sir!                else
!sir!                    ntripelimN = ntripelimN + 1
!sir!                endif
!sir!                cycle
!sir!             endif
!sir!!!!!!!!!!!!!!!!KRIS
!sir!             do l = 1,3
!sir!                n1 =iabs(nn(l)) + 1
!sir!!sir!           limref(1,n1) = limref(1,n1) + 1
!sir!                limref(n1) = limref(n1) + 1
!sir!             enddo
!sir!          enddo
!sir!          if (ncountConver == 2) then
!sir!              write(6,*) 
!sir!!             write(6,*) ' Num. tripl.      eliminati',ntripelimi,
!sir!!    *                                      ' su ',numbTriplets
!sir!              write(6,*) ' Num. tripl. Pos. eliminati',ntripelimP,
!sir!     *                                      ' su ',nSigPos
!sir!              write(6,*) ' Num. tripl. Neg. eliminati',ntripelimN,
!sir!     *                                      ' su ',nSigNeg
!sir!              NSigPos = NSigPos - ntripelimP
!sir!              NSigNeg = NSigNeg - ntripelimN
!sir!          endif
!sir!!
!sir!!sir!     do l=1, 2
!sir!             do i=1, ifinConver
!sir!!sir!           limref(l,i+1) = limref(l,i+1) + limref(l,i)
!sir!                limref(i+1) = limref(i+1) + limref(i)
!sir!             enddo
!sir!!sir!     enddo
!sir!!
!sir!!-- modifica iph e limref
!sir!!
!sir!          lim1(:) = 0
!sir!
!sir!          do i=1, numbTriplets
!sir!             nnn1(1) = iet(1,i)
!sir!             nnn1(2) = iet(2,i)
!sir!             nnn1(3) = iet(3,i)
!sir!             a1 = 0.01 * iet(4,i)
!sir!             na1 = iet(4,i)
!sir!             nnn1(4) = 0
!sir!             ifaz = iet(5,i)
!sir!             do j=1, 3
!sir!                isi = isign(1,nnn1(j))
!sir!                nc = iabs(nnn1(j))
!sir!                lim1(nc) = lim1(nc) + 1
!sir!                npunt = limref(nc) + lim1(nc) -1
!sir!                j1 = 1
!sir!                do jcris = 1,3
!sir!                   if (jcris.ne.j) then
!sir!                       nn(j1) = nnn1(jcris)*(-isi)
!sir!                       j1 = j1+1
!sir!                   endif
!sir!                enddo
!sir!                ifazm = ifaz*(-isi)
!sir!                if (ifazm.lt.0) ifazm=ifazm+24
!sir!                jpp = npunt * 4 + 1
!sir!                iph(jpp) = nn(1)
!sir!                iph(jpp+1) = nn(2)
!sir!                iph(jpp+2) = na1
!sir!                iph(jpp+3) = ifazm
!sir!             enddo
!sir!          enddo
!sir!!
!sir!          lim1(:) = 0
!sir!          jpq = (numbTriplets*4) * 3
!sir!!
!sir!          if (ncountConver == ifSelAlfa + 1) then
!sir!             deallocate(iet, ieq, stat = ierr)
!sir!          endif
!sir  endif
!
!sir  return
!sir  end
!---------------------------------------------------------------------
