! ----------------------------------------------------------------------
      MODULE BigStore
!
            integer              :: lflValue
            integer              :: lflValue_buffer
            real,    allocatable :: store(:)

            common /StoreBuffer/ shuttle
            dimension shuttle(1000),ishuttle(1000)
            equivalence (shuttle,ishuttle)

!
      END MODULE BigStore
! ----------------------------------------------------------------------
      MODULE DataModule
          integer :: ifPlotSpots = 0
          integer :: noSpaceGroup = 0
          integer :: ifContSuppl
          real    :: bfacPDB, wave
      END MODULE DataModule
! ----------------------------------------------------------------------
      MODULE InvarStuff
      USE IsrCom
             integer, allocatable :: itab(:)
             integer, allocatable :: itabH(:)
             integer, allocatable :: itabK(:)
             integer, allocatable :: itabL(:)
             integer, allocatable :: itabO(:)
!
             integer, allocatable :: isig(:,:)
             integer, allocatable :: inq(:,:)
             real,    allocatable :: gq(:)
             real,    allocatable :: gv(:)
      END MODULE InvarStuff
! ----------------------------------------------------------------------
      MODULE Liste
!
c--list 1 : parametri della cella
      integer l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g
      real gg,gr
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
c--list 2 : gruppo spaziale
      integer ic,il,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     * l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,noric
      real g2
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     * l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,noric
c--list 3 : contenuto cella
      real sys03
      integer l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
c--list 4 : schema di pesaggio
      integer iw4,l4,m4,n4,l4s,l4d,n4d
      common/lst04/iw4,l4,m4,n4,l4s,l4d,n4d
c--list 5 : parametri atomici
      integer l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz,l5c
      real xMatTwin(3,3)
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz,l5c, xMatTwin
c--list 12 : condizioni per l'affinamento least squares
      integer l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2  n12c,md12b,iover12,igroup,jfirst12,irotam
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(5),igroup,jfirst12,irotam
c--list 13 : groups
      integer l13,m13,md13,n13,l13a,m13a,md13a,n13a,md13b,
     2	md13h,md13o,md13flag,l13g,n13g
      real sys13
      common/lst13/l13,m13,md13,n13,l13a,m13a,md13a,n13a,md13b,
     2	md13h,md13o,md13flag,l13g,n13g,sys13
c--list 14 : limiti mappe di fourier
      integer l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f
      real sys14
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
c--list 15 : picchi localizzati da mappe
      integer l15,m15,md15,n15,l15aa,m15a,md15a,n15a
      common/lst15/ l15,m15,md15,n15,l15aa,m15a,md15a,n15a
c--list 16 : set di fasi da M.D.
      integer l16,ld16p,m16,m16d,md16d,n16,n16p,l16p,n16r,
     1 l16a,l16k,n16k,numb16
      common/lst16/l16,ld16p,m16,m16d,md16d,n16,n16p,l16p,n16r,
     1 l16a,l16k,n16k,numb16
c--list 17 : set di fasi estese dal Direct Space Refinement.
      integer l17,ld17p,m17,m17d,md17d,n17,n17p,l17p,
     1 l17a,l17k,n17k,numb17
      common/lst17/l17,ld17p,m17,m17d,md17d,n17,n17p,l17p,
     1 l17a,l17k,n17k,numb17
c--list 18 : limiti min&max dati sperimentali
      integer l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d,nrif18,lrif18,mrif18,ncla18,lcla18
      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d,nrif18,lrif18,mrif18,ncla18,lcla18
c--list 22 : indirizzi assoluti in store per least squares (run time)
      integer l22,m22,md22,n22,l22a,m22a,md22a,n22a,n22x,n22y,n22z,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22,iadov22,igroup22,irotam22
      common/lst22/l22,m22,md22,n22,l22a,m22a,md22a,n22a,n22x,n22y,n22z,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(5),iadov22(5),igroup22,irotam22
c--list 26 : rotamer (su disco No=26, in common No=126)
      integer l126,m126,md126,n126,l126a,m126a,md126a,n126a,md126b,
     2	md126h,md126o,md126flag,l126g,n126g
      real sys126
      common/lst126/l126,m126,md126,n126,l126a,m126a,md126a,n126a,
     2	md126b,md126h,md126o,md126flag,l126g,n126g,sys126    
c--list sperimental conditions for CIF file
      integer l29,m29,md29,n29,l29d,n29d,
     1 noce,nstand,ncountCIF,istand,ntotale
      real ceth,size,tmnx,averr,uneti
      real stor29(31)
      equivalence (stor29,noce)
      common/lst29/ l29,m29,md29,n29,l29d,n29d,
     1 noce,ceth(2),size(3),tmnx(2),nstand,ncountCIF,istand(3,6),
     2 ntotale,averr,uneti
c--list 33 : profile in Rietveld procedure (Expo)
      integer nlung33(10)
c--list 34 : NEW LIST matrice informazioni
      integer l34,m34,md34,n34,l34d,n34d,n34a
      real stor34
      common/lst34/ l34,m34,md34,n34,l34d,n34d,n34a,
     1	stor34(10,500)
c--list 35 : parametri atomici (lista di appoggio SAVE/RESTORE)
      integer l35,m35,md35,n35,l35o,m35o,md35o,n35o
     2 ,n35g,l35d,n35d
      common/lst35/l35,m35,md35,n35,l35o,m35o,md35o,n35o
     2 ,n35g,l35d,n35d
c--list 36 : condizioni affinamento (lista di appoggio SAVE/RESTORE)
      integer l36,m36,md36,n36,nbl36,jdra,jdrb,l36d,n36d,
     2	n36c,md36b,iover36
      common/lst36/l36,m36,md36,n36,nbl36,jdra,jdrb,l36d,n36d,
     2	n36c,md36b,iover36(5)
c--list 37 : Profile counts (Expo)
      integer l37,l37a,l37d,ld37p,m37,m37dk,n37dk,md37d,n37d,n37,
     *n37p,l37rs,l37rk,l37in,l37p
      common/lst37/l37,l37a,l37d,ld37p,m37,m37dk,n37dk,md37d,n37d,n37,
     *n37p,l37rs,l37rk,l37in,l37p
c--list 38 : NEW LIST MAD/SAD information 
      integer l38,m38,md38,n38,l38d,n38d,n38a
      common/lst38/ l38,m38,md38,n38,l38d,n38d,n38a
c--indirizzi in store list like
c--list 25, 26, 27 : liste temporanee per calcoli geometrici
      integer l25,m25,md25,n25,l26,m26,md26,n26,
     1 l27,m27,md27,n27,l27a,l27b,n27b
      common/lst25/l25,m25,md25,n25
      common/lst26/l26,m26,md26,n26
      common/lst27/ l27,m27,md27,n27,l27a,l27b,n27b
c--list 45 : parametri atomici da modello pubblicato
      integer l45,m45,md45,n45,n45d,l45d
*     common/lst35/l45,m45,md45,n45,n45d,l45d
c--list 50      
      integer l50,m50,md50,n50
      common/lst50/l50,m50,md50,n50
c--list 55 : parametri gruppo (corpo rigido) run time
      integer l55,m55,md55,n55,md55b,md55flag,
     2 l55d,n55d,md55h,md55xyz,md55angle,md55der,md55loca,md55fin
      common/lst55/l55,m55,md55,n55,md55b,md55flag,
     2 l55d,n55d,md55h,md55xyz,md55angle,md55der,md55loca,md55fin
c--list 56 : parametri rotamero  run time
      integer l56,m56,md56,n56,md56b,md56flag,
     2 l56d,n56d,md56h,md56xyz,md56angle,md56der,md56loca,md56fin
      common/lst56/l56,m56,md56,n56,md56b,md56flag,
     2 l56d,n56d,md56h,md56xyz,md56angle,md56der,md56loca,md56fin
c--indirizzi del vettore matrice equazioni normali per least squares
      integer l11r,m11r,md11r,n11r,l11s,m11s,md11s,n11s,nfld,lfld,nld
      common /xlst11/ l11r,m11r,md11r,n11r,l11s,m11s,md11s,n11s
      common /xlim11/ nfld,lfld,nld
c--indirizzi in store di appoggio per liste temporanee
      integer lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c--strings
      character carctr*256, ifmt*80
      common /cfile/ carctr,ifmt
!
      END MODULE Liste
! ----------------------------------------------------------------------
      MODULE ListeXX
        integer              :: NSigPos, NSigNeg, NPsiZero, NSigEna
        integer              :: NRefPos, NRefNeg, NRefZero, NRefEna
        integer              :: iGmPos, iGmNeg, iGmZero, iGmEna
        integer, allocatable :: Lista08(:,:) !   positive triplets
        integer, allocatable :: Lista09(:,:) !   psi zero
        integer, allocatable :: Lista10(:,:) !   negative triplets
        integer, allocatable :: Lista11(:,:) !   enantiomorphous triplets
      END MODULE ListeXX
! ----------------------------------------------------------------------
      MODULE StrLogModule
!
      real                  :: perRsir
      integer               :: strInfoC(10)
      character (len=200)   :: strLogS,strLogMa,strLogMi
      character (len=200)   :: strLogSp,strLogMap,strLogMip
      character (len=200)   :: strInfo(10)

      common/strGraph/strLogS,strLogMa,strLogMi,
     *                strLogSp,strLogMap,strLogMip,
     *                strInfo,strInfoC

!
      END MODULE StrLogModule
! ----------------------------------------------------------------------
      MODULE ExtendModule
             real                 :: trip1m, rDataCalc
             integer              :: iOldLSQ, ntra, jsir
             integer              :: nDeriUsed(5), invSegno, ifFourDif
             integer              :: janom, nAnomUsed(5), jjpos, ncyclm
             integer              :: natoms(100), numLsq, nAnomUsedCheck
             integer              :: jFullMatrix, nAnomUsed2(5)
             integer              :: nofop, iflex, noscale
             real                 :: sogDEflex, bwil
             real                 :: CutSigma, CutDeltaA, CutDeltaD
             integer              :: ncycleT, kheavyEx, nsetBD
             integer              :: ihismF, icoeff
             real                 :: PON(2,5), PONderi(4,500)
      END MODULE ExtendModule
! ----------------------------------------------------------------------
      MODULE MadModule
!
      integer, parameter      :: MaxNrefExt = 200000
      common/xdata_mad/fpos(5,MaxNrefExt),epos(5,MaxNrefExt),
     1                 sigfpos(5,MaxNrefExt),
     2                 fneg(5,MaxNrefExt),eneg(5,MaxNrefExt),
     3                 sigfneg(5,MaxNrefExt),
     4                 iphazp(5,MaxNrefExt),iphazn(5,MaxNrefExt),
     4                 wtp(5,MaxNrefExt),wtn(5,MaxNrefExt),
     4                 ipubp(5,MaxNrefExt),ipubn(5,MaxNrefExt),
     4                 fposT(5,MaxNrefExt),fnegT(5,MaxNrefExt),
     4                 fcAp(5,MaxNrefExt),iphazAp(5,MaxNrefExt),
     5                 eAp(5,MaxNrefExt),sigAp(5,MaxNrefExt),
     6                 fcAn(5,MaxNrefExt),iphazAn(5,MaxNrefExt),
     7                 eAn(5,MaxNrefExt),sigAn(5,MaxNrefExt),
     8                 fcA2(5,MaxNrefExt),iphazA2(5,MaxNrefExt),
     9                 fcA1(5,MaxNrefExt),iphazA1(5,MaxNrefExt),
     +                 deltaA(5,MaxNrefExt),deltaAv(5,MaxNrefExt),
     +                 sigfsec(5,MaxNrefExt),finv(MaxNrefExt),
     +                 iphazAltri(MaxNrefExt),wtAltri(MaxNrefExt),
     +                 sigA(5,MaxNrefExt),sigNa(MaxNrefExt),
     +                 sigNa_bis(MaxNrefExt),sigNa_ter(MaxNrefExt),
     +                 sigNa_quater(MaxNrefExt),epsi(MaxNrefExt)
      real  :: valoriPDB(3)
      common /cmad/ nWave,kAnom(8),fPrimoSecondo(8,5,2),normm(5),
     *              nAn(8), nkAnom(8), nAnom,
     *              bWilsonM(5),scaleWilsonM(5),
     *              nWaveAct,
     *              nwl(5),numbWL,
     *              eMadMax,
     *              NumFiltri,nFiltro(10),SogFiltro(10),
     *              iks,ikess,SogEss,ifEsuSigma,ikepers,ifCreate,
     *              ifNative,ifClick
      common /RANGO/ Rank(31),iCombC(31),Peso3,Peso4,PercCorr,cut_d(31),
     *               n_WL_Comb,isRank(31)
!
      common /erreMAD/ numR, NumRefR(5), rfacR(5)
!
      END MODULE MadModule
! ----------------------------------------------------------------------
      MODULE PhaseModule
!
      integer :: kverboCow = 0
      integer :: ifErrMin = 1
      common /const/ nset,numset,npic, iyrandSav
      common /ureqph/ jtabl,jproc,nneg,nngq,lasts,ipesi,nfisso,ifP1
      common /Soglia/ RSoglia, rfacSog
      common /xdataph/ ntrip, ntrn, nquar, LenIPH, nstartTang, 
     *                 ntrneg, nutri, jpq, nn(8)
      common /BackToTangent/ BackWT(8000),BackPh(8000),BackEmod(4000,2),
     *                       numbB,numbInv,numbLSQ,nEmod
      common /FastC/ kfast,ifPost,kWriMap,iWriMap,kSolMap
      common /appo/ pmax,nninv1,nninv2,nit1,nit2,
     *              ifShort,inizia,ifLib,rapdenini
      integer nSuper, nMacro, nMacroTot, nMicro
      integer indiceSuper, indiceMacro, indiceMicro, nMacroAppl
      common /dsrC/ nSuper, nMacro, nMacroTot, nMicro,
     *        indiceSuper, indiceMacro, indiceMicro, nMacroAppl
      common /appoHafr/khafr,nhafr1,nhafr2,ifHafr
      integer trialVett
      common /solvec/ IYsolve, itria, numbTrials, numbTrialsAtt,
     *                trialVett(50),ntria
      common /WildRun/ kWstop, iverbo, errev(101)
c     common /errori/ erm1,ermpes1,erm2,ermpes2,
      common /errori/ erm1,ermw1,erm2,ermw2,
     * error1(302,2),error2(302,2),shif(302,3),isumal,sumalfa
      common /erroriminimi/ shiftexam(7), setmin, erm1min, bestmin, 
     *        kbestr, erore, erorepes, errstp(36), errtp(12)
      common /MultiRun/ numbrun,MaxRun,nTotTrials
      integer  :: jrecyc, krecy, nemap, lsx, maxcyc, jrest
      real     :: biso, oscale, errem, fobmin, tsigma
      real     :: erre  = 0.0
      real     :: erreo = 0.0
      common /SmallOrMacro/ idel,isma,ismah,jsaved
      common /sdir/ dm,npc,nproj,nojoin,kheavy,ChemOcc
     *             ,deltab,nobfac,natHeavy
      common/dedimiss/numbmis,ResSog_Ph,LowRes
      common/iterac/  percMap, percMap_n, invflag, esalta
      common/preb/ipreb,ifLsqh,iwei,NumPes,NumPes1,NumPes2,pip,iheavy
      common /vagria/ aperc(90),rperc(90),npercm, nrefB
      common /CicliInv/ nit,nDelta,iDelta,numtot,mtotn,mtot(5)
!sir! common /xdata99/            alfest(4000),alfvar(4000),
!sir!2        alphaVet(4000),irefin(4000),limref(2,4001),wtPseudo(4000)
      common /xdata99/ wtPseudo(4000)
!
!-- FOMs
!
      common /stampac/ cfom(502), ipos(502), figMer(11), stampa(14)
      common /psi0/npsi,num0,alfest0(1000),alfvar0(1000),llll(1000),
     1 lim0n(1001),iph0n(20000)
      common /oldxdata/ negt1(4000),negt2(4000),iqu1(750),
     * iqu2(750),iqu3(750)
      common /paramPh/ numbPhase,nant(4),nral,alra,sumalf,
     *               ckae,ckae0,ssig,nsxx,salfe
      common /ureq1/ npuntEquiv,jjpunt(4001),ksacc,jseteq,jumpp,jmpsie,
     *               nsec
      common/fom4/attl2,attl3,nqen,nen,ns1,ns2,nphas,nfom0,nfoml,coeco
       common /fomcom/ ntrSv, aminco,
     1 cfomx,mxsac,absfom,resid,al2,al2m1,almed,nundet,error,errpes,
     2 fomps0,foms1,coms,fomrt(302,10),f1mx,f1mn,f2mx,f2mn,f21mx,f21mn,
     3 f22mx,f22mn,f23mx,f23mn,f3mx,f3mn,f4mx,f4mn,f5mx,f5mn,f6mx,f6mn,
     4 f7mx,f7mn,f8mx,f8mn,f9mx,f9mn,f10mx,f10mn,f11mx,f11mn,f12mx,
     5 f12mn,f13mx,f13mn,f14mx,f14mn,f15mx,f15mn,f16mx,f16mn,f17mx,
     6 f17mn,f18mx,f18mn,ff1mx,ff1mn,ff3mx,ff3mn,ff4mx,ff4mn,ff5mx,
     7 ff5mn
      common /NewFoms/ fomrtN(300,6), fomBuff(6), ifCombinedFom,
     * averlar, aversma, avewe, avewenum, aveweden, averat, avemaxM,
     * stdrlar, stdrsma, stdwe, stdwenum, stdweden, stdrat, stdmaxM
      integer QualeIterazione
      common/numiter/ Iterazione, nIterazioni, QualeIterazione, itera, 
     *                fom(11), ntr, SogliaCorre, Fcorre
      integer WhichBlock
      common /BlockComm/ nBlocksPh, jBlocksPh(2,10), nTotBlocksPh, 
     *        jBlock, nSetStored, nVolteFour, nFour, WhichBlock
      common /errevetcomm/FOMs(2,4), FOM_Mad(6), errevet(100),
     *        nerrevet, CoefFom, CCEoEc(2),fomold(3),EarlyFom,FinalFom
      common /Libcomm/CC_Shelx,Fom_Trip,Fom_TripM,Fom_Trip_sca
      common /RATcomm/ BestRatVet(8)
      integer WhichFom
      common /BestValues/ fomBest,fomBestE,erreBest,IstoFOMRfac(2,100),
     *                    jRfac,kRfac,nRfac,NumbMaxRfac,FomsMin,
     *                    kFomsMin,RfacMatrix(8,300,10),vmin,vmax,
     *                    TrerreBest,TrBestFom, WhichFom,
     *                    VXmin(3),VXMax(3),VYmin,VYMax
      common /figmer/ RfacMato,RfacMind,RfacMave,RfacMaso,facMaso,
     *                facMato,facMind,facMave,facMasc,itotsir,facMasold,
     *                ratmxnosol

      common /VariFlags/ ifExamin, nolsq, ifRescale, ifCorr, ifTime,
     *                   ifImprove, ifExpanded, ifSigma, ifPDB,
     *                   ifPert, ifFree, ifPatt, ifTang
      common /r_free/ nincfr, ninc, nexcfr, nexc
      common /envDyn/ ifEnve,RenveStart,RenveDyn,RenveStep,EnvePronta
!
      common /ChemCom/ ifChemFra,jChem,natomChem,
     *                 caChem,cbChem,cgChem,deltChem
!
!-- RELAX
!
!gl   common /reducec/ ifReduced,nsymTrue,icentTrue,natmTrue,nstrSav,
!gl nsymTrue,icentTrue spostati in MODULE Symmetr
      common /reducec/ ifReduced,                   natmTrue,nstrSav,
     *                 nstrP1,kpolTrue, ifRelax, ntrRelax
!
!-- Gestione dei set di fasi in uscita da DSR
!
      common /FineDSR/ nSetsMaxFineDSR, nSetsFineDSR, 
     *                 FomsFineDSR(500), iposFineDSR(500),
     *                 OldTRialsForDLSQ(10,11)
!
!-- Procedura affinamento ridotta x MAD/SAD       !pgMAD2907
!
      common /ProcRid/ ifRidotta
!
      common /matchH/ifirstHM,nsip,nwiz,nwizl,
     *               ifirstHMT,nsipT,nwizT,nwizlT,
     *               xoss_Theo(500),xoss_Obs(500),xcalc(500),xhist(500),
     *               ai(500),bi(500)
      integer   :: ifVLD = 0
!
      END MODULE PhaseModule

! ----------------------------------------------------------------------
      MODULE RiflessiMAD
             real,    allocatable ::fpos(:,:)
             real,    allocatable ::epos(:,:)
             real,    allocatable ::sigfpos(:,:)
             real,    allocatable ::fneg(:,:)
             real,    allocatable ::eneg(:,:)
             real,    allocatable ::sigfneg(:,:)
             integer, allocatable ::iphazp(:,:)
             integer, allocatable ::iphazn(:,:)
             real,    allocatable ::wtp(:,:)
             real,    allocatable ::wtn(:,:)
             integer, allocatable ::ipubp(:,:)
             integer, allocatable ::ipubn(:,:)
             real,    allocatable ::fposT(:,:)
             real,    allocatable ::fnegT(:,:)
             real,    allocatable ::fcAp(:,:)
             integer, allocatable ::iphazAp(:,:)
             real,    allocatable ::eAp(:,:)
             real,    allocatable ::sigAp(:,:)
             real,    allocatable ::fcAn(:,:)
             integer, allocatable ::iphazAn(:,:)
             real,    allocatable ::eAn(:,:)
             real,    allocatable ::sigAn(:,:)
             real,    allocatable ::fcA2(:,:)
             integer, allocatable ::iphazA2(:,:)
             real,    allocatable ::fcA1(:,:)
             integer, allocatable ::iphazA1(:,:)
             real,    allocatable ::deltaA(:,:)
             real,    allocatable ::deltaAv(:,:)
             real,    allocatable ::sigfsec(:,:)
             real,    allocatable ::finv(:)
             real,    allocatable ::sigA(:,:)
             real,    allocatable ::rloc(:,:,:)
             real,    allocatable ::danoMedMad(:)
             real,    allocatable ::sigDanoMedMad(:)
             real,    allocatable ::ddisMedMad(:)
             real,    allocatable ::danoabsMedMad(:)
             real,    allocatable ::sdanoMedMad(:)
             real,    allocatable ::deltaDisp(:,:)
             real,    allocatable ::DeltaxLSQ(:)
             real,    allocatable ::pesoAnom(:)
             real,    allocatable ::pesoDis(:,:)
             real,    allocatable ::pesoDisPhase(:,:)
             real,    allocatable ::pesoAnomPhase(:)
             real,    allocatable ::ics(:)
             real,    allocatable ::FacSigmaP(:)
             real,    allocatable ::FacSigmaN(:)
             real,    allocatable ::DanoSigma(:,:)
!------------------
             real,    allocatable ::ripubp(:,:)
             real,    allocatable ::ripubn(:,:)
             real,    allocatable ::riphazAp(:,:)
             real,    allocatable ::riphazAn(:,:)
             real,    allocatable ::FcHna(:)
             real,    allocatable ::EcHna(:)
             integer, allocatable ::iphazHna(:)
             real,    allocatable ::sigHna(:)
!------------------

      END MODULE RiflessiMAD
! ----------------------------------------------------------------------
      MODULE RiflessiMIR
             real,    allocatable ::fod(:,:)
             real,    allocatable ::ed(:,:)
             real,    allocatable ::epp(:,:)
             real,    allocatable ::epd(:,:)
             real,    allocatable ::sigde(:,:)
             real,    allocatable ::sigfd(:,:)
             real,    allocatable ::fcH(:,:)
             integer, allocatable ::iphazH(:,:)
             real,    allocatable ::eH(:,:)
             real,    allocatable ::sighh(:,:)
             real,    allocatable ::fcHmu(:,:)
             integer, allocatable ::iphazHmu(:,:)
             real,    allocatable ::fdelta(:,:)
             real,    allocatable ::fdeltan(:,:)
             real,    allocatable ::deltaV(:,:)
             real,    allocatable ::fodpos(:,:)
             real,    allocatable ::sigfdpos(:,:)
             real,    allocatable ::fodneg(:,:)
             real,    allocatable ::sigfdneg(:,:)
             real,    allocatable ::fc1Hpos(:,:)
             integer, allocatable ::iphazHpos(:,:)
             real,    allocatable ::eHpos(:,:)
             real,    allocatable ::fc1Hneg(:,:)
             integer, allocatable ::iphazHneg(:,:)
             real,    allocatable ::eHneg(:,:)
             real,    allocatable ::FcH_prime(:,:)
             integer, allocatable ::iphazH_prime(:,:)
             real,    allocatable ::FcH_second(:,:)
             integer, allocatable ::iphazH_second(:,:)
      END MODULE RiflessiMIR
! ----------------------------------------------------------------------
      MODULE InvarData
        integer, allocatable   ::itab(:)
        integer, allocatable   ::itab1(:)
        integer, allocatable   ::isig(:,:)
        integer, allocatable   ::isigpos(:,:)
        integer, allocatable   ::isigneg(:,:)
        real, allocatable      ::gq(:)
        real, allocatable      ::gqpos(:)
        real, allocatable      ::gqneg(:)
        real, allocatable      ::gv(:)
        real, allocatable      ::gold(:)
        real, allocatable      ::alfestinv(:)
        real, allocatable      ::alfvarinv(:)
        integer, allocatable   ::nrel(:)
      END MODULE InvarData
! ----------------------------------------------------------------------
      MODULE PhaseData

      integer, allocatable     :: imat(:,:)
      integer, allocatable     :: iee(:)
      integer, allocatable     :: iee1(:)
      integer, allocatable     :: iph(:)
      integer, allocatable     :: nbinv(:)

      integer, allocatable     ::icont(:)
      real, allocatable        ::z(:)
      real, allocatable        ::alfest(:)
      integer, allocatable     ::iz(:)
      integer, allocatable     ::ih(:)
      integer, allocatable     ::limref(:)
      real, allocatable        ::alfvar(:)
      integer, allocatable     ::ifstor(:)
      real, allocatable        ::zp(:)
      integer, allocatable     ::irefin(:)
      integer, allocatable     ::limi1(:)
      real, allocatable        ::enil(:,:)
      integer, allocatable     ::iphh(:)
      integer, allocatable     ::line(:,:)
      real, allocatable        ::zph(:)
!     integer, allocatable     ::nn(:)
      integer, allocatable     ::kdstor(:)
      integer, allocatable     ::mkg(:)
      real, allocatable        ::control(:)
      integer, allocatable     ::ianto(:)
      integer, allocatable     ::jpunt(:)
      real, allocatable        ::alfran(:)
!---- for f.o.m
      real, allocatable        ::psivet(:)
      real, allocatable        ::comb1(:,:)
      END MODULE PhaseData
! ----------------------------------------------------------------------
      MODULE Triplets
        integer, allocatable ::nrel(:)
        integer, allocatable ::itab(:)
        integer, allocatable ::itab1(:)
        integer, allocatable ::imat(:,:)
        integer, allocatable ::isigp(:,:)
        integer, allocatable ::isigne(:,:)
        real,    allocatable ::gq(:)
        real,    allocatable ::gqp(:)
        real,    allocatable ::gqn(:)
        integer, allocatable ::ieeT(:)
        integer, allocatable ::ieeT1(:)
        integer, allocatable ::ieeT2(:)
        integer, allocatable ::iphT(:)
        integer, allocatable ::nbinvT(:)
      END MODULE Triplets
!-----------------------------------------------------------------------
      MODULE PlotsData
             real, allocatable    ::xplotEnd(:,:)
             real, allocatable    ::yplotEnd(:,:)
             real, allocatable    ::xgridEnd(:)
             real, allocatable    ::ygridEnd(:)
             save                 ::npuntiPlotEnd,ngridPointEnd
      END MODULE PlotsData
! ----------------------------------------------------------------------
      subroutine AllocaISR(iAction)
      USE General
      USE IsrCom

*gl*  if (iAction > 0) call xfl06
      if (iAction > 0) call LoadReflInfo

      ifat1=(2*ihmx(3)+1)*(2*ihmx(2)+1)
      ifat2=(2*ihmx(3)+1)
      ifatx=ihmx(1)*ifat1+ihmx(2)*ifat2+ihmx(3)

      if (iAction == 1.or. iAction == 0) then
        IF (.NOT. ALLOCATED(isr)) 
     *  allocate(isr(1:ifatx),stat=ier)

        isr(:)=0
        
      else
        IF (ALLOCATED(isr))
     *  deallocate(isr,stat=ier)
      endif

      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaInvar(iAction)
      USE General
      USE InvarData

*gl*  call xfl06
      call LoadReflInfo

      nTripMax=50000
      ierr = 0

      if (iAction == 1) then
        allocate(alfestinv(1:nrefl),stat=ier)
        allocate(alfvarinv(1:nrefl),stat=ier)
        allocate(itab(1:nTripMax),stat=ier)
        allocate(itab1(1:nTripMax),stat=ier)
        allocate(isig(1:3,1:nTripMax),stat=ier)
        allocate(isigpos(1:3,1:nTripMax),stat=ier)
        allocate(isigneg(1:3,1:nTripMax),stat=ier)
        allocate(gq(1:nTripMax),stat=ier)
        allocate(gqpos(1:nTripMax),stat=ier)
        allocate(gqneg(1:nTripMax),stat=ier)
        allocate(gv(1:nTripMax),stat=ier)
        allocate(gold(1:nTripMax),stat=ier)
        allocate(nrel(1:nTripMax),stat=ier)
!----------------------
      else
        deallocate(alfestinv,stat=ier)
        deallocate(alfvarinv,stat=ier)
        deallocate(itab,stat=ier)
        deallocate(itab1,stat=ier)
        deallocate(isig,stat=ier)
        deallocate(isigpos,stat=ier)
        deallocate(isigneg,stat=ier)
        deallocate(gq,stat=ier)
        deallocate(gqpos,stat=ier)
        deallocate(gqneg,stat=ier)
        deallocate(gv,stat=ier)
        deallocate(gold,stat=ier)
        deallocate(nrel,stat=ier)
!----------------------
      endif

      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaPhase(iAction)
      USE General
      USE PhaseData
      USE PhaseModule
      USE ListeXX

      dimension ierv(50),imatkoti(1)

      ierv(:) = 0
      ierr = 0

      if (iAction == 1) then

*---- preambolo tripletti
        ntrpos = NSigPos
        ntrneg = 0
*gl*    iprea=-1
*gl*    iDim = 1
*gl*    call sflxx(iprea,8,nxxa,ntrpos,numb,ipten,igm,1,imatkoti,iDim)
*gl*    call srlin (10,lsn,lfw,llw,lpb,ll)
        lfw = InfoOK(10)
*gl*    if (lfw.gt.0) call sflxx(iprea,10,nxxa,ntrneg,numb,
*gl* *      ipten,igm,1,imatkoti,iDim)
        if (lfw > 0) then
            ntrneg = NSigNeg
        endif
        ndim=ntrpos+ntrneg
*--- preambolo tripletti psi0
*gl*    call sflxx(iprea,9,npsi,npsi,num0,nxxe,iccd,1,imatkoti,iDim)
        npsi = NPsiZero
        ndim=ndim+npsi

*gl*    call xfl06
        call LoadReflInfo

        numb=nrefl


        allocate(imat(3,1:ndim),stat=ierv(1))
        allocate(iee(ndim),stat=ierv(2))
        allocate(iee1(ndim),stat=ierv(3))
        allocate(iph(4*ndim),stat=ierv(4))
        allocate(nbinv(4*ndim),stat=ierv(5))
        allocate(icont(3),stat=ierv(6))
        allocate(z(1:numb),stat=ierv(7))
        allocate(alfest(1:numb),stat=ierv(8))
        allocate(iz(1:numb),stat=ierv(9))
        allocate(ih(1:numb),stat=ierv(10))
        allocate(limref(1:numb),stat=ierv(11))
        allocate(alfvar(1:numb),stat=ierv(12))
        allocate(ifstor(1:numb),stat=ierv(13))
        allocate(zp(1:numb),stat=ierv(14))
        allocate(irefin(1:numb),stat=ierv(15))
        allocate(limi1(1:numb),stat=ierv(16))
        allocate(enil(1:numb,2),stat=ierv(17))
        allocate(iphh(1:numb),stat=ierv(18))
        allocate(line(1:numb,6),stat=ierv(19))
        allocate(zph(1:numb),stat=ierv(20))
        allocate(kdstor(1:numb),stat=ierv(21))
        allocate(mkg(1:numb),stat=ierv(22))
        allocate(control(1:numb),stat=ierv(23))
        allocate(ianto(1:numb),stat=ierv(24))
        allocate(jpunt(1:numb),stat=ierv(25))
        allocate(alfran(1:numb),stat=ierv(26))
        allocate(psivet(500),stat=ierv(27))
        allocate(comb1(5,500),stat=ierv(28))

        ierr = 0
        do i=1,50
             ierr = ierr + iabs( ierv(i) )
        enddo
        if (ierr.ne.0) then
           write(6,*) 'Phase Allocation error'
           call cstop(' Allcation error')
        endif
      else

        deallocate(imat,stat=ierv(1))
        deallocate(iee,stat=ierv(2))
        deallocate(iee1,stat=ierv(3))
        deallocate(iph,stat=ierv(4))
        deallocate(nbinv,stat=ierv(5))
        deallocate(icont,stat=ierv(6))
        deallocate(z,stat=ierv(7))
        deallocate(alfest,stat=ierv(8))
        deallocate(iz,stat=ierv(9))
        deallocate(ih,stat=ierv(10))
        deallocate(limref,stat=ierv(11))
        deallocate(alfvar,stat=ierv(12))
        deallocate(ifstor,stat=ierv(13))
        deallocate(zp,stat=ierv(14))
        deallocate(irefin,stat=ierv(15))
        deallocate(limi1,stat=ierv(16))
        deallocate(enil,stat=ierv(17))
        deallocate(iphh,stat=ierv(18))
        deallocate(line,stat=ierv(19))
        deallocate(zph,stat=ierv(20))
        deallocate(kdstor,stat=ierv(21))
        deallocate(mkg,stat=ierv(22))
        deallocate(control,stat=ierv(23))
        deallocate(ianto,stat=ierv(24))
        deallocate(jpunt,stat=ierv(25))
        deallocate(alfran,stat=ierv(26))
        deallocate(psivet,stat=ierv(27))
        deallocate(comb1,stat=ierv(28))

        ierr = 0
        do i=1,50
             ierr = ierr + iabs( ierv(i) )
        enddo
        if (ierr.ne.0) then
           write(6,*) 'Phase DeAllocation error'
           call cstop(' Allcation error')
        endif
      endif

      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaTriplets(iAction)
      USE General
      Use Triplets
      dimension ierv(14)

      ierv(:) = 0
      ierr = 0

*gl*  call xfl06
      call LoadReflInfo

      nTripMaxB=50000
      nTripMax=200000

      if (iAction == 1) then
        IF (.NOT. ALLOCATED(nrel))
     *    ALLOCATE (nrel(nrefl), stat = ierv(1))
        IF (.NOT. ALLOCATED(itab))
     *    ALLOCATE (itab(nTripMaxB), stat = ierv(2))
        IF (.NOT. ALLOCATED(itab1))
     *    ALLOCATE (itab1(nTripMaxB), stat = ierv(3))
        IF (.NOT. ALLOCATED(gq))
     *    ALLOCATE (gq(nTripMaxB), stat = ierv(4))
        IF (.NOT. ALLOCATED(gqp))
     *    ALLOCATE (gqp(nTripMaxB), stat = ierv(5))
        IF (.NOT. ALLOCATED(gqn))
     *    ALLOCATE (gqn(nTripMaxB), stat = ierv(6))
        IF (.NOT. ALLOCATED(imat))
     *    ALLOCATE (imat(3,nTripMaxB), stat = ierv(7))
        IF (.NOT. ALLOCATED(isigp))
     *    ALLOCATE (isigp(3,nTripMaxB), stat = ierv(8))
        IF (.NOT. ALLOCATED(isigne))
     *    ALLOCATE (isigne(3,nTripMaxB), stat = ierv(9))

! -------------
        IF (.NOT. ALLOCATED(ieeT))
     *    ALLOCATE (ieeT(nTripMax), stat = ierv(10))
        IF (.NOT. ALLOCATED(ieeT1))
     *    ALLOCATE (ieeT1(nTripMax), stat = ierv(11))
        IF (.NOT. ALLOCATED(ieeT2))
     *    ALLOCATE (ieeT2(nTripMax), stat = ierv(12))
        IF (.NOT. ALLOCATED(iphT))
     *    ALLOCATE (iphT(3*nTripMax), stat = ierv(13))
        IF (.NOT. ALLOCATED(nbinvT))
     *    ALLOCATE (nbinvT(4*nTripMax), stat = ierv(14))

          ierr = 0
          do i=1,14
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              write(6,*) 'Triplets Allocation error'
              call cstop(' Allcation error')
          endif

      else
        IF (ALLOCATED(nrel))
     *    DEALLOCATE (nrel, stat = ierv(1))
        IF (ALLOCATED(itab))
     *    DEALLOCATE (itab, stat = ierv(2))
        IF (ALLOCATED(itab1))
     *    DEALLOCATE (itab1, stat = ierv(3))
        IF (ALLOCATED(gq))
     *    DEALLOCATE (gq, stat = ierv(4))
        IF (ALLOCATED(gqp))
     *    DEALLOCATE (gqp, stat = ierv(5))
        IF (ALLOCATED(gqn))
     *    DEALLOCATE (gqn, stat = ierv(6))
        IF (ALLOCATED(imat))
     *    DEALLOCATE (imat, stat = ierv(7))
        IF (ALLOCATED(isigp))
     *    DEALLOCATE (isigp, stat = ierv(8))
        IF (ALLOCATED(isigne))
     *    DEALLOCATE (isigne, stat = ierv(9))
        IF (ALLOCATED(ieeT))
     *    DEALLOCATE (ieeT, stat = ierv(10))
        IF (ALLOCATED(ieeT1))
     *    DEALLOCATE (ieeT1, stat = ierv(11))
        IF (ALLOCATED(ieeT2))
     *    DEALLOCATE (ieeT2, stat = ierv(12))
        IF (ALLOCATED(iphT))
     *    DEALLOCATE (iphT, stat = ierv(13))
        IF (ALLOCATED(nbinvT))
     *    DEALLOCATE (nbinvT, stat = ierv(14))

          ierr = 0
          do i=1,14
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              write(6,*) 'Triplets DeAllocation error'
              call cstop(' Allcation error')
          endif
      endif
!

      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaMappaOld(iAction)
      USE Mappa

!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
c     print*,'AllocaMappa',np
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(xmap))
     *    ALLOCATE (xmap(0:np(1)-1,0:np(2)-1,0:np(3)+1), stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'Map Allocation Error'
              call cstop(' Allcation error')
          endif
          IF (.NOT. ALLOCATED(xmapDif))
     *    ALLOCATE (xmapDif(0:np(1)-1,0:np(2)-1,0:np(3)+1), stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'MapDif Allocation Error'
              call cstop(' Allcation error')
          endif
          IF (.NOT. ALLOCATED(xmapC))
     *    ALLOCATE (xmapC(0:np(1)/2,0:np(2)-1,0:np(3)-1), stat=ierr)
          if (ierr.ne.0) then
              write(*,*) 'MapC Allocation Error'
              call cstop(' Allcation error')
          endif
      else
          IF (ALLOCATED(xmap))
     *        DEALLOCATE (xmap,xmapDif, xmapC,stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'Maps Deallocation Error'
              call cstop(' Allcation error')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaEnve(iAction)
      USE Mappa
c     USE Envelope

!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(xenve))
     *    ALLOCATE (xenve(0:np(1)-1,0:np(2)-1,0:np(3)+1), stat = ierr)

          if (ierr.ne.0) then
              write(*,*) 'Envelope Allocation Error'
              call cstop(' Allcation error')
          endif

          IF (.NOT. ALLOCATED(xenveT))
     *    ALLOCATE (xenveT(0:np(1)-1,0:np(2)-1,0:np(3)+1), stat = ierr)

          if (ierr.ne.0) then
              write(*,*) 'EnvelopeT Allocation Error'
              call cstop(' Allcation error')
          endif

      else
          IF (ALLOCATED(xenve))
     *        DEALLOCATE (xenve, stat = ierr)

          if (ierr.ne.0) then
              write(*,*) 'Envelope DeAllocation Error'
              call cstop(' Allcation error')
          endif

          IF (ALLOCATED(xenveT))
     *        DEALLOCATE (xenveT, stat = ierr)

          if (ierr.ne.0) then
              write(*,*) 'EnvelopeT DeAllocation Error'
              call cstop(' Allcation error')
          endif

      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaRiflessiMAD(iAction)
      USE General
      USE RiflessiMAD
      USE RiflessiNew

      dimension ierv(100)

      ndsD=nds-1
      ierv(:) = 0

*gl*  call xfl06
      call LoadReflInfo
c     if (iAction == 1) then

c         IF (.NOT. ALLOCATED(fpos))
c    *     ALLOCATE (fpos(ndsD,1:nreflDim) ,stat = ierv( 1))
c         IF (.NOT. ALLOCATED(epos))
c    *     ALLOCATE (epos(ndsD,1:nreflDim) ,stat = ierv( 1))
c         IF (.NOT. ALLOCATED(sigfpos))
c    *     ALLOCATE (sigfpos(ndsD,1:nreflDim) ,stat = ierv( 1))

c         IF (.NOT. ALLOCATED(fneg))
c    *     ALLOCATE (fneg(ndsD,1:nreflDim) ,stat = ierv( 1))
c         IF (.NOT. ALLOCATED(eneg))
c    *     ALLOCATE (eneg(ndsD,1:nreflDim) ,stat = ierv( 1))
c         IF (.NOT. ALLOCATED(sigfneg))
c    *     ALLOCATE (sigfneg(ndsD,1:nreflDim) ,stat = ierv( 1))

c         IF (.NOT. ALLOCATED(iphazp))
c    *     ALLOCATE (iphazp(ndsD,1:nreflDim) ,stat = ierv( 1))
c         IF (.NOT. ALLOCATED(iphazn))
c    *     ALLOCATE (iphazn(ndsD,1:nreflDim) ,stat = ierv( 1))
c         IF (.NOT. ALLOCATED(wtp))
c    *     ALLOCATE (wtp(ndsD,1:nreflDim) ,stat = ierv( 1))
c         IF (.NOT. ALLOCATED(deltaAv))
c    *     ALLOCATE (deltaAv(ndsD,1:nreflDim) ,stat = ierv( 1))
c     else
c     endif
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(fpos))
     *     ALLOCATE (fpos(ndsD,1:nreflDim) ,stat = ierv( 1))
          IF (.NOT. ALLOCATED(epos))
     *     ALLOCATE (epos(ndsD,1:nreflDim) ,stat = ierv( 2))
          IF (.NOT. ALLOCATED(sigfpos))
     *     ALLOCATE (sigfpos(ndsD,1:nreflDim) ,stat = ierv( 3))
          IF (.NOT. ALLOCATED(fneg))
     *     ALLOCATE (fneg(ndsD,1:nreflDim) ,stat = ierv( 4))
          IF (.NOT. ALLOCATED(eneg))
     *     ALLOCATE (eneg(ndsD,1:nreflDim) ,stat = ierv( 5))
          IF (.NOT. ALLOCATED(sigfneg))
     *     ALLOCATE (sigfneg(ndsD,1:nreflDim) ,stat = ierv( 6))
          IF (.NOT. ALLOCATED(iphazp))
     *     ALLOCATE (iphazp(ndsD,1:nreflDim) ,stat = ierv( 7))
          IF (.NOT. ALLOCATED(iphazn))
     *     ALLOCATE (iphazn(ndsD,1:nreflDim) ,stat = ierv( 8))
          IF (.NOT. ALLOCATED(wtp))
     *     ALLOCATE (wtp(ndsD,1:nreflDim) ,stat = ierv( 9))
          IF (.NOT. ALLOCATED(wtn))
     *     ALLOCATE (wtn(ndsD,1:nreflDim) ,stat = ierv( 10))
          IF (.NOT. ALLOCATED(ipubp))
     *     ALLOCATE (ipubp(ndsD,1:nreflDim) ,stat = ierv( 11))
          IF (.NOT. ALLOCATED(ipubn))
     *     ALLOCATE (ipubn(ndsD,1:nreflDim) ,stat = ierv( 12))
          IF (.NOT. ALLOCATED(fposT))
     *     ALLOCATE (fposT(ndsD,1:nreflDim) ,stat = ierv( 13))
          IF (.NOT. ALLOCATED(fnegT))
     *     ALLOCATE (fnegT(ndsD,1:nreflDim) ,stat = ierv( 14))
          IF (.NOT. ALLOCATED(fcAp))
     *     ALLOCATE (fcAp(ndsD,1:nreflDim) ,stat = ierv( 15))
          IF (.NOT. ALLOCATED(iphazAp))
     *     ALLOCATE (iphazAp(ndsD,1:nreflDim) ,stat = ierv( 16))
          IF (.NOT. ALLOCATED(eAp))
     *     ALLOCATE (eAp(ndsD,1:nreflDim) ,stat = ierv( 17))
          IF (.NOT. ALLOCATED(sigAp))
     *     ALLOCATE (sigAp(ndsD,1:nreflDim) ,stat = ierv( 18))
          IF (.NOT. ALLOCATED(fcAn))
     *     ALLOCATE (fcAn(ndsD,1:nreflDim) ,stat = ierv( 19))
          IF (.NOT. ALLOCATED(iphazAn))
     *     ALLOCATE (iphazAn(ndsD,1:nreflDim) ,stat = ierv( 20))
          IF (.NOT. ALLOCATED(eAn))
     *     ALLOCATE (eAn(ndsD,1:nreflDim) ,stat = ierv( 21))
          IF (.NOT. ALLOCATED(sigAn))
     *     ALLOCATE (sigAn(ndsD,1:nreflDim) ,stat = ierv( 22))
          IF (.NOT. ALLOCATED(fcA2))
     *     ALLOCATE (fcA2(ndsD,1:nreflDim) ,stat = ierv( 23))
          IF (.NOT. ALLOCATED(iphazA2))
     *     ALLOCATE (iphazA2(ndsD,1:nreflDim) ,stat = ierv( 24))
          IF (.NOT. ALLOCATED(fcA1))
     *     ALLOCATE (fcA1(ndsD,1:nreflDim) ,stat = ierv( 25))
          IF (.NOT. ALLOCATED(iphazA1))
     *     ALLOCATE (iphazA1(ndsD,1:nreflDim) ,stat = ierv( 26))
          IF (.NOT. ALLOCATED(deltaA))
     *     ALLOCATE (deltaA(ndsD,1:nreflDim) ,stat = ierv( 27))
          IF (.NOT. ALLOCATED(deltaAv))
     *     ALLOCATE (deltaAv(ndsD,1:nreflDim) ,stat = ierv( 28))
          IF (.NOT. ALLOCATED(sigfsec))
     *     ALLOCATE (sigfsec(ndsD,1:nreflDim) ,stat = ierv( 29))
          IF (.NOT. ALLOCATED(finv))
     *     ALLOCATE (finv(1:nreflDim) ,stat = ierv( 30))
          IF (.NOT. ALLOCATED(sigA))
     *     ALLOCATE (sigA(ndsD,1:nreflDim) ,stat = ierv( 33))
          IF (.NOT. ALLOCATED(rloc))
     *     ALLOCATE (rloc(2*ndsD,2*ndsD,1:nreflDim) ,stat = ierv( 34))
          IF (.NOT. ALLOCATED(danoMedMad))
     *     ALLOCATE (danoMedMad(1:nreflDim) ,stat = ierv( 35))
          IF (.NOT. ALLOCATED(sigDanoMedMad))
     *     ALLOCATE (sigDanoMedMad(1:nreflDim) ,stat = ierv( 36))
          IF (.NOT. ALLOCATED(ddisMedMad))
     *     ALLOCATE (ddisMedMad(1:nreflDim) ,stat = ierv( 37))
          IF (.NOT. ALLOCATED(danoabsMedMad))
     *     ALLOCATE (danoabsMedMad(1:nreflDim) ,stat = ierv( 38))
          IF (.NOT. ALLOCATED(sdanoMedMad))
     *     ALLOCATE (sdanoMedMad(1:nreflDim) ,stat = ierv( 39))
          IF (.NOT. ALLOCATED(deltaDisp))
     *     ALLOCATE (deltaDisp(ndsD,1:nreflDim) ,stat = ierv( 40))
          IF (.NOT. ALLOCATED(deltaxLSQ))
     *     ALLOCATE (deltaxLSQ(1:nreflDim) ,stat = ierv( 41))
          IF (.NOT. ALLOCATED(pesoAnom))
     *     ALLOCATE (pesoAnom(ndsD) ,stat = ierv( 42))
          IF (.NOT. ALLOCATED(pesoDis))
     *     ALLOCATE (pesoDis(ndsD,ndsD) ,stat = ierv( 43))
          IF (.NOT. ALLOCATED(pesoDisPhase))
     *     ALLOCATE (pesoDisPhase(ndsD,ndsD) ,stat = ierv( 44))
          IF (.NOT. ALLOCATED(pesoAnomPhase))
     *     ALLOCATE (pesoAnomPhase(ndsD) ,stat = ierv( 45))
          IF (.NOT. ALLOCATED(ics))
     *     ALLOCATE (ics(ndsD) ,stat = ierv( 46))
          IF (.NOT. ALLOCATED(FacSigmaP))
     *     ALLOCATE (FacSigmaP(ndsD) ,stat = ierv( 47))
          IF (.NOT. ALLOCATED(FacSigmaN))
     *     ALLOCATE (FacSigmaN(ndsD) ,stat = ierv( 48))
          IF (.NOT. ALLOCATED(ripubp))
     *     ALLOCATE (ripubp(ndsD,1:nreflDim) ,stat = ierv( 49))
          IF (.NOT. ALLOCATED(ripubn))
     *     ALLOCATE (ripubn(ndsD,1:nreflDim) ,stat = ierv( 50))
          IF (.NOT. ALLOCATED(riphazAp))
     *     ALLOCATE (riphazAp(ndsD,1:nreflDim) ,stat = ierv( 51))
          IF (.NOT. ALLOCATED(riphazAn))
     *     ALLOCATE (riphazAn(ndsD,1:nreflDim) ,stat = ierv( 52))
          IF (.NOT. ALLOCATED(DanoSigma))
     *     ALLOCATE (DanoSigma(ndsD,1:nreflDim) ,stat = ierv( 53))

          IF (.NOT. ALLOCATED(FcHna))
     *     ALLOCATE (FcHna(1:nreflDim) ,stat = ierv( 54))
          IF (.NOT. ALLOCATED(EcHna))
     *     ALLOCATE (EcHna(1:nreflDim) ,stat = ierv( 55))
          IF (.NOT. ALLOCATED(iphazHna))
     *     ALLOCATE (iphazHna(1:nreflDim) ,stat = ierv( 56))
          IF (.NOT. ALLOCATED(sigHna))
     *     ALLOCATE (sigHna(1:nreflDim) ,stat = ierv( 57))
          ierr = 0
          ierr = sum(iabs(ierv(:)))
          if (ierr.ne.0) then
              write(6,*) 'MADData Allocation error'
              call cstop(' Allcation error')
          endif

      else

          IF (ALLOCATED(fpos))
     *     DEALLOCATE (fpos ,stat = ierv( 1))
          IF (ALLOCATED(epos))
     *     DEALLOCATE (epos ,stat = ierv( 2))
          IF (ALLOCATED(sigfpos))
     *     DEALLOCATE (sigfpos ,stat = ierv( 3))
          IF (ALLOCATED(fneg))
     *     DEALLOCATE (fneg ,stat = ierv( 4))
          IF (ALLOCATED(eneg))
     *     DEALLOCATE (eneg ,stat = ierv( 5))
          IF (ALLOCATED(sigfneg))
     *     DEALLOCATE (sigfneg ,stat = ierv( 6))
          IF (ALLOCATED(iphazp))
     *     DEALLOCATE (iphazp ,stat = ierv( 7))
          IF (ALLOCATED(iphazn))
     *     DEALLOCATE (iphazn ,stat = ierv( 8))
          IF (ALLOCATED(wtp))
     *     DEALLOCATE (wtp ,stat = ierv( 9))
          IF (ALLOCATED(wtn))
     *     DEALLOCATE (wtn ,stat = ierv( 10))
          IF (ALLOCATED(ipubp))
     *     DEALLOCATE (ipubp ,stat = ierv( 11))
          IF (ALLOCATED(ipubn))
     *     DEALLOCATE (ipubn ,stat = ierv( 12))
          IF (ALLOCATED(fposT))
     *     DEALLOCATE (fposT ,stat = ierv( 13))
          IF (ALLOCATED(fnegT))
     *     DEALLOCATE (fnegT ,stat = ierv( 14))
          IF (ALLOCATED(fcAp))
     *     DEALLOCATE (fcAp ,stat = ierv( 15))
          IF (ALLOCATED(iphazAp))
     *     DEALLOCATE (iphazAp ,stat = ierv( 16))
          IF (ALLOCATED(eAp))
     *     DEALLOCATE (eAp ,stat = ierv( 17))
          IF (ALLOCATED(sigAp))
     *     DEALLOCATE (sigAp ,stat = ierv( 18))
          IF (ALLOCATED(fcAn))
     *     DEALLOCATE (fcAn ,stat = ierv( 19))
          IF (ALLOCATED(iphazAn))
     *     DEALLOCATE (iphazAn ,stat = ierv( 20))
          IF (ALLOCATED(eAn))
     *     DEALLOCATE (eAn ,stat = ierv( 21))
          IF (ALLOCATED(sigAn))
     *     DEALLOCATE (sigAn ,stat = ierv( 22))
          IF (ALLOCATED(fcA2))
     *     DEALLOCATE (fcA2 ,stat = ierv( 23))
          IF (ALLOCATED(iphazA2))
     *     DEALLOCATE (iphazA2 ,stat = ierv( 24))
          IF (ALLOCATED(fcA1))
     *     DEALLOCATE (fcA1 ,stat = ierv( 25))
          IF (ALLOCATED(iphazA1))
     *     DEALLOCATE (iphazA1 ,stat = ierv( 26))
          IF (ALLOCATED(deltaA))
     *     DEALLOCATE (deltaA ,stat = ierv( 27))
          IF (ALLOCATED(deltaAv))
     *     DEALLOCATE (deltaAv ,stat = ierv( 28))
          IF (ALLOCATED(sigfsec))
     *     DEALLOCATE (sigfsec ,stat = ierv( 29))
          IF (ALLOCATED(finv))
     *     DEALLOCATE (finv ,stat = ierv( 30))
          IF (ALLOCATED(sigA))
     *     DEALLOCATE (sigA ,stat = ierv( 33))
          IF (ALLOCATED(rloc))
     *     DEALLOCATE (rloc ,stat = ierv( 34))
          IF (ALLOCATED(danoMedMad))
     *     DEALLOCATE (danoMedMad ,stat = ierv( 35))
          IF (ALLOCATED(sigDanoMedMad))
     *     DEALLOCATE (sigDanoMedMad ,stat = ierv( 36))
          IF (ALLOCATED(ddisMedMad))
     *     DEALLOCATE (ddisMedMad ,stat = ierv( 37))
          IF (ALLOCATED(danoabsMedMad))
     *     DEALLOCATE (danoabsMedMad ,stat = ierv( 38))
          IF (ALLOCATED(sdanoMedMad))
     *     DEALLOCATE (sdanoMedMad ,stat = ierv( 39))
          IF (ALLOCATED(deltaDisp))
     *     DEALLOCATE (deltaDisp ,stat = ierv( 40))
          IF (ALLOCATED(deltaxLSQ))
     *     DEALLOCATE (deltaxLSQ ,stat = ierv( 41))
          IF (ALLOCATED(pesoAnom))
     *     DEALLOCATE (pesoAnom ,stat = ierv( 42))
          IF (ALLOCATED(pesoDis))
     *     DEALLOCATE (pesoDis ,stat = ierv( 43))
          IF (ALLOCATED(pesoDisPhase))
     *     DEALLOCATE (pesoDisPhase ,stat = ierv( 44))
          IF (ALLOCATED(pesoAnomPhase))
     *     DEALLOCATE (pesoAnomPhase ,stat = ierv( 45))
          IF (ALLOCATED(ics))
     *     DEALLOCATE (ics ,stat = ierv( 46))
          IF (ALLOCATED(FacSigmaP))
     *     DEALLOCATE (FacSigmaP ,stat = ierv( 47))
          IF (ALLOCATED(FacSigmaN))
     *     DEALLOCATE (FacSigmaN ,stat = ierv( 48))
          IF (ALLOCATED(ripubp))
     *     DEALLOCATE (ripubp ,stat = ierv( 49))
          IF (ALLOCATED(ripubn))
     *     DEALLOCATE (ripubn ,stat = ierv( 50))
          IF (ALLOCATED(riphazAp))
     *     DEALLOCATE (riphazAp ,stat = ierv( 51))
          IF (ALLOCATED(riphazAn))
     *     DEALLOCATE (riphazAn ,stat = ierv( 52))
          IF (ALLOCATED(DanoSigma))
     *     DEALLOCATE (DanoSigma ,stat = ierv( 53))
          IF (ALLOCATED(FcHna))
     *     DEALLOCATE (FcHna ,stat = ierv( 54))
          IF (ALLOCATED(EcHna))
     *     DEALLOCATE (EcHna ,stat = ierv( 55))
          IF (ALLOCATED(iphazHna))
     *     DEALLOCATE (iphazHna ,stat = ierv( 56))
          IF (ALLOCATED(sigHna))
     *     DEALLOCATE (sigHna ,stat = ierv( 57))

          ierr = 0
          ierr = sum(iabs(ierv(:)))
          if (ierr.ne.0) then
              write(6,*) 'MADData DeAllocation error'
              call cstop(' Allcation error')
          endif


      endif

      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaRiflessiMIR(iAction)
      USE General
      USE RiflessiMIR

!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(50)
!
*gl*  call xfl06
      call LoadReflInfo

      ndsD=nds-1

      ierv(:) = 0

      ierr = 0

      if (iAction == 1) then
          IF (.NOT. ALLOCATED(fod))
     *     ALLOCATE (fod(ndsD,1:nreflDim) ,stat = ierv( 1))
          IF (.NOT. ALLOCATED(ed))
     *     ALLOCATE (ed(ndsD,1:nreflDim)    ,stat = ierv( 2))
          IF (.NOT. ALLOCATED(epp))
     *     ALLOCATE (epp(ndsD,1:nreflDim)    ,stat = ierv( 3))
          IF (.NOT. ALLOCATED(epd))
     *     ALLOCATE (epd(ndsD,1:nreflDim)    ,stat = ierv( 4))
          IF (.NOT. ALLOCATED(sigde))
     *     ALLOCATE (sigde(ndsD,1:nreflDim)    ,stat = ierv( 6))
          IF (.NOT. ALLOCATED(fcH))
     *     ALLOCATE (fcH(ndsD,1:nreflDim)    ,stat = ierv( 7))
          IF (.NOT. ALLOCATED(iphazH))
     *     ALLOCATE (iphazH(ndsD,1:nreflDim)    ,stat = ierv( 8))
          IF (.NOT. ALLOCATED(eH))
     *     ALLOCATE (eH(ndsD,1:nreflDim)    ,stat = ierv( 9))
          IF (.NOT. ALLOCATED(sighh))
     *     ALLOCATE (sighh(ndsD,1:nreflDim)    ,stat = ierv(10))
          IF (.NOT. ALLOCATED(fcHmu))
     *     ALLOCATE (fcHmu(ndsD,1:nreflDim)    ,stat = ierv(11))
          IF (.NOT. ALLOCATED(iphazHmu))
     *     ALLOCATE (iphazHmu(ndsD,1:nreflDim)    ,stat = ierv(12))
          IF (.NOT. ALLOCATED(fdelta))
     *     ALLOCATE (fdelta(ndsD,1:nreflDim)    ,stat = ierv(13))
          IF (.NOT. ALLOCATED(fdeltan))
     *     ALLOCATE (fdeltan(ndsD,1:nreflDim)    ,stat = ierv(14))
          IF (.NOT. ALLOCATED(deltaV))
     *     ALLOCATE (deltaV(ndsD,1:nreflDim)    ,stat = ierv(15))
          IF (.NOT. ALLOCATED(fodpos))
     *     ALLOCATE (fodpos(ndsD,1:nreflDim)    ,stat = ierv(16))
          IF (.NOT. ALLOCATED(fodneg))
     *     ALLOCATE (fodneg(ndsD,1:nreflDim)    ,stat = ierv(17))
          IF (.NOT. ALLOCATED(fc1Hpos))
     *     ALLOCATE (fc1Hpos(ndsD,1:nreflDim)    ,stat = ierv(18))
          IF (.NOT. ALLOCATED(iphazHpos))
     *     ALLOCATE (iphazHpos(ndsD,1:nreflDim)    ,stat = ierv(19))
          IF (.NOT. ALLOCATED(eHpos))
     *     ALLOCATE (eHpos(ndsD,1:nreflDim)    ,stat = ierv(20))
          IF (.NOT. ALLOCATED(fc1Hneg))
     *     ALLOCATE (fc1Hneg(ndsD,1:nreflDim)    ,stat = ierv(21))
          IF (.NOT. ALLOCATED(iphazHneg))
     *     ALLOCATE (iphazHneg(ndsD,1:nreflDim)    ,stat = ierv(22))
          IF (.NOT. ALLOCATED(eHneg))
     *     ALLOCATE (eHneg(ndsD,1:nreflDim)    ,stat = ierv(23))
          IF (.NOT. ALLOCATED(FcH_prime))
     *     ALLOCATE (FcH_prime(ndsD,1:nreflDim)    ,stat = ierv(24))
          IF (.NOT. ALLOCATED(iphazH_prime))
     *     ALLOCATE (iphazH_prime(ndsD,1:nreflDim)    ,stat = ierv(25))
          IF (.NOT. ALLOCATED(FcH_second))
     *     ALLOCATE (FcH_second(ndsD,1:nreflDim)    ,stat = ierv(26))
          IF (.NOT. ALLOCATED(iphazH_second))
     *     ALLOCATE (iphazH_second(ndsD,1:nreflDim)    ,stat = ierv(27))
          IF (.NOT. ALLOCATED(sigfd))
     *     ALLOCATE (sigfd(ndsD,1:nreflDim)    ,stat = ierv(28))
          IF (.NOT. ALLOCATED(sigfdpos))
     *     ALLOCATE (sigfdpos(ndsD,1:nreflDim)    ,stat = ierv(29))
          IF (.NOT. ALLOCATED(sigfdneg))
     *     ALLOCATE (sigfdneg(ndsD,1:nreflDim)    ,stat = ierv(30))

          ierr = 0
          do i=1,30
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              write(6,*) 'MIRData Allocation error'
              call cstop(' Allcation error')
          endif
      else

          IF (ALLOCATED(fod))
     *     DEALLOCATE (fod ,stat = ierv( 1))
          IF (ALLOCATED(ed))
     *     DEALLOCATE (ed    ,stat = ierv( 2))
          IF (ALLOCATED(epp))
     *     DEALLOCATE (epp    ,stat = ierv( 3))
          IF (ALLOCATED(epd))
     *     DEALLOCATE (epd    ,stat = ierv( 4))
          IF (ALLOCATED(sigde))
     *     DEALLOCATE (sigde    ,stat = ierv( 6))
          IF (ALLOCATED(fcH))
     *     DEALLOCATE (fcH    ,stat = ierv( 7))
          IF (ALLOCATED(iphazH))
     *     DEALLOCATE (iphazH    ,stat = ierv( 8))
          IF (ALLOCATED(eH))
     *     DEALLOCATE (eH    ,stat = ierv( 9))
          IF (ALLOCATED(sighh))
     *     DEALLOCATE (sighh    ,stat = ierv(10))
          IF (ALLOCATED(fcHmu))
     *     DEALLOCATE (fcHmu    ,stat = ierv(11))
          IF (ALLOCATED(iphazHmu))
     *     DEALLOCATE (iphazHmu    ,stat = ierv(12))
          IF (ALLOCATED(fdelta))
     *     DEALLOCATE (fdelta    ,stat = ierv(13))
          IF (ALLOCATED(fdeltan))
     *     DEALLOCATE (fdeltan    ,stat = ierv(14))
          IF (ALLOCATED(deltaV))
     *     DEALLOCATE (deltaV    ,stat = ierv(15))
          IF (ALLOCATED(fodpos))
     *     DEALLOCATE (fodpos    ,stat = ierv(16))
          IF (ALLOCATED(fodneg))
     *     DEALLOCATE (fodneg    ,stat = ierv(17))
          IF (ALLOCATED(fc1Hpos))
     *     DEALLOCATE (fc1Hpos    ,stat = ierv(18))
          IF (ALLOCATED(iphazHpos))
     *     DEALLOCATE (iphazHpos    ,stat = ierv(19))
          IF (ALLOCATED(eHpos))
     *     DEALLOCATE (eHpos    ,stat = ierv(20))
          IF (ALLOCATED(fc1Hneg))
     *     DEALLOCATE (fc1Hneg    ,stat = ierv(21))
          IF (ALLOCATED(iphazHneg))
     *     DEALLOCATE (iphazHneg    ,stat = ierv(22))
          IF (ALLOCATED(eHneg))
     *     DEALLOCATE (eHneg    ,stat = ierv(23))
          IF (ALLOCATED(FcH_prime))
     *     DEALLOCATE (FcH_prime    ,stat = ierv(24))
          IF (ALLOCATED(iphazH_prime))
     *     DEALLOCATE (iphazH_prime    ,stat = ierv(25))
          IF (ALLOCATED(FcH_second))
     *     DEALLOCATE (FcH_second    ,stat = ierv(26))
          IF (ALLOCATED(iphazH_second))
     *     DEALLOCATE (iphazH_second    ,stat = ierv(27))
          IF (ALLOCATED(sigfd))
     *     DEALLOCATE (sigfd    ,stat = ierv(28))
          IF (ALLOCATED(sigfdpos))
     *     DEALLOCATE (sigfdpos    ,stat = ierv(29))
          IF (ALLOCATED(sigfdneg))
     *     DEALLOCATE (sigfdneg    ,stat = ierv(30))

          ierr = 0
          do i=1,30
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              !write(6,*) 'MIRData Deallocation error'
              call cstop(' Allcation error')
          endif

      endif
!
      return
      end
!----------------
! ----------------------------------------------------------------------
      subroutine AllocaRiflessiMADnew(iAction)
      USE General
      USE RiflessiNew
!
      implicit none
      integer :: iAction, ierv(10), ndsD, ierr
!
      ndsD = nds - 1
      ierv(:) = 0
!
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(refl%fpos))
     *     ALLOCATE (refl%fpos(ndsD,1:nreflDim)    ,stat = ierv(1))
          IF (.NOT. ALLOCATED(refl%sigfpos))
     *     ALLOCATE (refl%sigfpos(ndsD,1:nreflDim) ,stat = ierv(2))
          IF (.NOT. ALLOCATED(refl%epos))
     *     ALLOCATE (refl%epos(ndsD,1:nreflDim)    ,stat = ierv(3))
          IF (.NOT. ALLOCATED(refl%fneg))
     *     ALLOCATE (refl%fneg(ndsD,1:nreflDim)    ,stat = ierv(4))
          IF (.NOT. ALLOCATED(refl%sigfneg))
     *     ALLOCATE (refl%sigfneg(ndsD,1:nreflDim) ,stat = ierv(5))
          IF (.NOT. ALLOCATED(refl%eneg))
     *     ALLOCATE (refl%eneg(ndsD,1:nreflDim)    ,stat = ierv(6))
          IF (.NOT. ALLOCATED(refl%deltaV))
     *     ALLOCATE (refl%deltaV(ndsD,1:nreflDim)  ,stat = ierv(7))
          IF (.NOT. ALLOCATED(refl%deltaAv))
     *     ALLOCATE (refl%deltaAv(ndsD,1:nreflDim) ,stat = ierv(8))
          ierr = 0
          ierr = sum(iabs(ierv(:)))
          if (ierr /= 0) then
              write(6,*) 'MADDataNew Allocation error'
              call cstop(' Allocation error')
          endif

      else

          IF (ALLOCATED(refl%fpos))
     *     DEALLOCATE (refl%fpos    ,stat = ierv(1))
          IF (ALLOCATED(refl%sigfpos))
     *     DEALLOCATE (refl%sigfpos ,stat = ierv(2))
          IF (ALLOCATED(refl%epos))
     *     DEALLOCATE (refl%epos    ,stat = ierv(3))
          IF (ALLOCATED(refl%fneg))
     *     DEALLOCATE (refl%fneg    ,stat = ierv(4))
          IF (ALLOCATED(refl%sigfneg))
     *     DEALLOCATE (refl%sigfneg ,stat = ierv(5))
          IF (ALLOCATED(refl%eneg))
     *     DEALLOCATE (refl%eneg    ,stat = ierv(6))
          IF (ALLOCATED(refl%deltaV))
     *     DEALLOCATE (refl%deltaV  ,stat = ierv(7))
          IF (ALLOCATED(refl%deltaAv))
     *     DEALLOCATE (refl%deltaAv ,stat = ierv(7))

          ierr = 0
          ierr = sum(iabs(ierv(:)))
          if (ierr /= 0) then
              write(6,*) 'MADDataNew DeAllocation error'
              call cstop(' DeAllocation error')
          endif

      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaRiflessiMIRnew(iAction)
      USE General
      USE RiflessiNew
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      implicit none
      integer :: iAction, ierv(50), ierr, ndsD, i
!
      ndsD = nds - 1
      ierv(:) = 0
      ierr = 0

      if (iAction == 1) then
          IF (.NOT. ALLOCATED(refl%fod))
     *     ALLOCATE(refl%fod(ndsD,1:nreflDim)          ,stat = ierv( 1))
          IF (.NOT. ALLOCATED(refl%ed))
     *     ALLOCATE(refl%ed(ndsD,1:nreflDim)           ,stat = ierv( 2))
          IF (.NOT. ALLOCATED(refl%epp))
     *     ALLOCATE(refl%epp(ndsD,1:nreflDim)          ,stat = ierv( 3))
          IF (.NOT. ALLOCATED(refl%epd))
     *     ALLOCATE(refl%epd(ndsD,1:nreflDim)          ,stat = ierv( 4))
          IF (.NOT. ALLOCATED(refl%sigde))
     *     ALLOCATE(refl%sigde(ndsD,1:nreflDim)        ,stat = ierv( 6))
          IF (.NOT. ALLOCATED(refl%fcH))
     *     ALLOCATE(refl%fcH(ndsD,1:nreflDim)          ,stat = ierv( 7))
          IF (.NOT. ALLOCATED(refl%iphazH))
     *     ALLOCATE(refl%iphazH(ndsD,1:nreflDim)       ,stat = ierv( 8))
          IF (.NOT. ALLOCATED(refl%eH))
     *     ALLOCATE(refl%eH(ndsD,1:nreflDim)           ,stat = ierv( 9))
          IF (.NOT. ALLOCATED(refl%sighh))
     *     ALLOCATE(refl%sighh(ndsD,1:nreflDim)        ,stat = ierv(10))
          IF (.NOT. ALLOCATED(refl%fcHmu))
     *     ALLOCATE(refl%fcHmu(ndsD,1:nreflDim)        ,stat = ierv(11))
          IF (.NOT. ALLOCATED(refl%iphazHmu))
     *     ALLOCATE(refl%iphazHmu(ndsD,1:nreflDim)     ,stat = ierv(12))
          IF (.NOT. ALLOCATED(refl%fdelta))
     *     ALLOCATE(refl%fdelta(ndsD,1:nreflDim)       ,stat = ierv(13))
          IF (.NOT. ALLOCATED(refl%fdeltan))
     *     ALLOCATE(refl%fdeltan(ndsD,1:nreflDim)      ,stat = ierv(14))
          IF (.NOT. ALLOCATED(refl%deltaV))
     *     ALLOCATE(refl%deltaV(ndsD,1:nreflDim)       ,stat = ierv(15))
          IF (.NOT. ALLOCATED(refl%fodpos))
     *     ALLOCATE(refl%fodpos(ndsD,1:nreflDim)       ,stat = ierv(16))
          IF (.NOT. ALLOCATED(refl%fodneg))
     *     ALLOCATE(refl%fodneg(ndsD,1:nreflDim)       ,stat = ierv(17))
          IF (.NOT. ALLOCATED(refl%fc1Hpos))
     *     ALLOCATE(refl%fc1Hpos(ndsD,1:nreflDim)      ,stat = ierv(18))
          IF (.NOT. ALLOCATED(refl%iphazHpos))
     *     ALLOCATE(refl%iphazHpos(ndsD,1:nreflDim)    ,stat = ierv(19))
          IF (.NOT. ALLOCATED(refl%eHpos))
     *     ALLOCATE(refl%eHpos(ndsD,1:nreflDim)        ,stat = ierv(20))
          IF (.NOT. ALLOCATED(refl%fc1Hneg))
     *     ALLOCATE(refl%fc1Hneg(ndsD,1:nreflDim)      ,stat = ierv(21))
          IF (.NOT. ALLOCATED(refl%iphazHneg))
     *     ALLOCATE(refl%iphazHneg(ndsD,1:nreflDim)    ,stat = ierv(22))
          IF (.NOT. ALLOCATED(refl%eHneg))
     *     ALLOCATE(refl%eHneg(ndsD,1:nreflDim)        ,stat = ierv(23))
          IF (.NOT. ALLOCATED(refl%FcH_prime))
     *     ALLOCATE(refl%FcH_prime(ndsD,1:nreflDim)    ,stat = ierv(24))
          IF (.NOT. ALLOCATED(refl%iphazH_prime))
     *     ALLOCATE(refl%iphazH_prime(ndsD,1:nreflDim) ,stat = ierv(25))
          IF (.NOT. ALLOCATED(refl%FcH_second))
     *     ALLOCATE(refl%FcH_second(ndsD,1:nreflDim)   ,stat = ierv(26))
          IF (.NOT. ALLOCATED(refl%iphazH_second))
     *     ALLOCATE(refl%iphazH_second(ndsD,1:nreflDim),stat = ierv(27))
          IF (.NOT. ALLOCATED(refl%sigfd))
     *     ALLOCATE(refl%sigfd(ndsD,1:nreflDim)        ,stat = ierv(28))
          IF (.NOT. ALLOCATED(refl%sigfdpos))
     *     ALLOCATE(refl%sigfdpos(ndsD,1:nreflDim)     ,stat = ierv(29))
          IF (.NOT. ALLOCATED(refl%sigfdneg))
     *     ALLOCATE(refl%sigfdneg(ndsD,1:nreflDim)     ,stat = ierv(30))

          ierr = 0
          do i=1,30
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              write(6,*) 'MIRData Allocation error'
              call cstop(' Allcation error')
          endif
      else
          IF (ALLOCATED(refl%fod))
     *     DEALLOCATE(refl%fod           ,stat = ierv( 1))
          IF (ALLOCATED(refl%ed))
     *     DEALLOCATE(refl%ed            ,stat = ierv( 2))
          IF (ALLOCATED(refl%epp))
     *     DEALLOCATE(refl%epp           ,stat = ierv( 3))
          IF (ALLOCATED(refl%epd))
     *     DEALLOCATE(refl%epd           ,stat = ierv( 4))
          IF (ALLOCATED(refl%sigde))
     *     DEALLOCATE(refl%sigde         ,stat = ierv( 6))
          IF (ALLOCATED(refl%fcH))
     *     DEALLOCATE(refl%fcH           ,stat = ierv( 7))
          IF (ALLOCATED(refl%iphazH))
     *     DEALLOCATE(refl%iphazH        ,stat = ierv( 8))
          IF (ALLOCATED(refl%eH))
     *     DEALLOCATE(refl%eH            ,stat = ierv( 9))
          IF (ALLOCATED(refl%sighh))
     *     DEALLOCATE(refl%sighh         ,stat = ierv(10))
          IF (ALLOCATED(refl%fcHmu))
     *     DEALLOCATE(refl%fcHmu         ,stat = ierv(11))
          IF (ALLOCATED(refl%iphazHmu))
     *     DEALLOCATE(refl%iphazHmu      ,stat = ierv(12))
          IF (ALLOCATED(refl%fdelta))
     *     DEALLOCATE(refl%fdelta        ,stat = ierv(13))
          IF (ALLOCATED(refl%fdeltan))
     *     DEALLOCATE(refl%fdeltan       ,stat = ierv(14))
          IF (ALLOCATED(refl%deltaV))
     *     DEALLOCATE(refl%deltaV        ,stat = ierv(15))
          IF (ALLOCATED(refl%fodpos))
     *     DEALLOCATE(refl%fodpos        ,stat = ierv(16))
          IF (ALLOCATED(refl%fodneg))
     *     DEALLOCATE(refl%fodneg        ,stat = ierv(17))
          IF (ALLOCATED(refl%fc1Hpos))
     *     DEALLOCATE(refl%fc1Hpos       ,stat = ierv(18))
          IF (ALLOCATED(refl%iphazHpos))
     *     DEALLOCATE(refl%iphazHpos     ,stat = ierv(19))
          IF (ALLOCATED(refl%eHpos))
     *     DEALLOCATE(refl%eHpos         ,stat = ierv(20))
          IF (ALLOCATED(refl%fc1Hneg))
     *     DEALLOCATE(refl%fc1Hneg       ,stat = ierv(21))
          IF (ALLOCATED(refl%iphazHneg))
     *     DEALLOCATE(refl%iphazHneg     ,stat = ierv(22))
          IF (ALLOCATED(refl%eHneg))
     *     DEALLOCATE(refl%eHneg         ,stat = ierv(23))
          IF (ALLOCATED(refl%FcH_prime))
     *     DEALLOCATE(refl%FcH_prime     ,stat = ierv(24))
          IF (ALLOCATED(refl%iphazH_prime))
     *     DEALLOCATE(refl%iphazH_prime  ,stat = ierv(25))
          IF (ALLOCATED(refl%FcH_second))
     *     DEALLOCATE(refl%FcH_second    ,stat = ierv(26))
          IF (ALLOCATED(refl%iphazH_second))
     *     DEALLOCATE(refl%iphazH_second, stat = ierv(27))
          IF (ALLOCATED(refl%sigfd))
     *     DEALLOCATE(refl%sigfd         ,stat = ierv(28))
          IF (ALLOCATED(refl%sigfdpos))
     *     DEALLOCATE(refl%sigfdpos      ,stat = ierv(29))
          IF (ALLOCATED(refl%sigfdneg))
     *     DEALLOCATE(refl%sigfdneg      ,stat = ierv(30))

          ierr = 0

          ierr = 0
          do i=1,30
             ierr = ierr + iabs( ierv(i) )
          enddo
          if (ierr.ne.0) then
              !write(6,*) 'MIRData Deallocation error'
              call cstop(' Allcation error')
          endif

      endif
!
      return
      end
!----------------
      subroutine AllocaPlots(iAction,n1,n2)
      USE PlotsData

      dimension ierv(4)
!
      ierv(:)=0
      ierr = 0

c     print*,'Allocate/Deallocate plots',n1,n2

      if (iAction == 1) then
        IF (.NOT. ALLOCATED(xplotEnd))
     *    ALLOCATE (xplotEnd(n1,n2) ,stat = ierv( 1))
        IF (.NOT. ALLOCATED(yplotEnd))
     *    ALLOCATE (yplotEnd(n1,n2) ,stat = ierv( 2))

        IF (.NOT. ALLOCATED(xgridEnd))
     *    ALLOCATE (xgridEnd(n2) ,stat = ierv( 3))
        IF (.NOT. ALLOCATED(ygridEnd))
     *    ALLOCATE (ygridEnd(n2) ,stat = ierv( 4))

          ierr = sum(iabs(ierv(:)))
          if (ierr.ne.0) then
            write(6,*) 'Plots  Allocation error'
            call cstop(' Allcation error')
          endif
       xplotEnd(:,:)=0.0
       yplotEnd(:,:)=0.0

       xgridEnd(:)=0.0
       ygridEnd(:)=0.0
       else
        IF (ALLOCATED(xplotEnd))
     *    DEALLOCATE (xplotEnd ,stat = ierv( 1))
        IF (ALLOCATED(yplotEnd))
     *    DEALLOCATE (yplotEnd ,stat = ierv( 2))

        IF (ALLOCATED(xgridEnd))
     *    DEALLOCATE (xgridEnd ,stat = ierv( 3))
        IF (ALLOCATED(ygridEnd))
     *    DEALLOCATE (ygridEnd ,stat = ierv( 4))

          ierr = sum(iabs(ierv(:)))
          if (ierr.ne.0) then
            write(6,*) 'Plots  DEAllocation error'
            call cstop(' Allcation error')
          endif

       endif

      return
      end

! ----------------------------------------------------------------------
      subroutine AllocaBigStore(iAction)
      USE General
      USE BigStore
*      implicit none
!
      integer ierr, iAction, value, nExitCode
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(store))
     *        ALLOCATE (store(1:lflValue), stat = ierr)
          if (ierr == 0)store(:) = 0.0
      else
          IF (ALLOCATED(store))
     *        DEALLOCATE (store, stat = ierr)
      endif

      if (ierr /= 0) then
          iAction = -1
          value = 4 * float(lflValue) / 1024 ** 2
          write(Msg,10) value
   10     format('Required ',f8.2,' Mb of memory, too much',
     *           ' for your computer !!! Program stops')
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LeggiRiflessi(ksubr, ier)
      integer ::  ksubr, ier
      return
      end
!-----------------------------------------------------------------------
      subroutine NewInv(iphi2,fop2,numbMax,n1,n2,n3,BACKi)
 
      USE General
      USE Symmetry
      USE Riflessi, only : khl,mkang,wt
      USE Mappa
      USE PhaseModule
      USE Param

      integer*8    ::BACKi
      dimension iphi2(nreflDim),fop2(nreflDim)

 
      integer i1(3),i2(3),lmod
      real phaseof
      complex sf,phasec
      logical hemiFFTW
      external hemiFFTW,lmod,phasec,phaseof
      
      n0 = n1 / 2 + 1
*---- Scale ----*
      scfft1 = 1.0/ real(n1 * n2 * n3 * nsym)

!!gpu call sfftw_execute(BACKi)
!!mr per gpu
      if(BACKi == BACKenv) then
         call sfftw_executer2c(n1,n2,n3,BACKi,xenve,xmapC)
      else
         call sfftw_executer2c(n1,n2,n3,BACKi,xmap,xmapC)
      endif
*---- Fill the reflection list ----*
      do 200 i=1,numbMax
         i1(1:3)=khl(1:3,i)
         wt(i) = 0.0
*---- Average over symmetry equivalents for this reflection ----*
         sf=cmplx(0.0,0.0)

         do j=1,nsym

            do l=1,3
               i2(l)=0
               do k=1,3
                  i2(l)=i2(l)+i1(k)*kmat(j,k,l)
               enddo
            enddo


            phim=twopi*(i1(1)*tmat(j,1)+i1(2)*tmat(j,2)
     *                 +i1(3)*tmat(j,3))

            if (hemiFFTW(i2(1),i2(2),i2(3))) then
               iu = lmod(i2(1),n0)
               iv = lmod(i2(2),n2)
               iw = lmod(i2(3),n3)
               sf = sf + conjg(xmapC(iu,iv,iw)) * phasec(phim)
            else
               iu = lmod(-i2(1),n0)
               iv = lmod(-i2(2),n2)
               iw = lmod(-i2(3),n3)
               sf = sf + xmapC(iu,iv,iw) * phasec(phim)
            endif
         enddo

         sf=sf*scfft1
         fop2(i)=abs(sf)   ! F.d.S calc.
         faze=phaseof(sf)*rtod
         if (mkang(i).ne.1.and.nsym.ne.1) then
             faze1= favi(mkang(i),faze)
             faze=faze1
         endif
         faze=mod(faze+3600.,360.)
         iphi2(i)=faze   ! la fase calc.
         if (QualePgm == 2 .or. kmad /= 0 .or. ifDsrVLD /= 0) then
cG       if (QualePgm == 2 .or. kmad /= 0) then
             wt(i) = 1.0    ! dritan : non cancellare, (serve per il sirprot)
         endif
c        write(1,'(3i4,5f10.2,2x,i4)')i1,fovet(i),sigmav(i),fcvet(i),
c    *                      float(ipub(i)),float(iphaz(i)),mkang(i)
200   continue

      return
      end
