!-----------------------------------------------------------------------
      subroutine ManageGraph(iAction, npoints)
      USE General
      USE GrexpoMod
      USE Grafici
      USE Molcom
      USE PhaseModule
!
!-- iAction = -1  initialize graphic area
!--         =  0  plot all histograms
!--         =  n  plot histogram # n
!

      character stringx*50, stringy*50, top*100
!
      if (iAction < 0) then
          if (iAction == -1) then
              call InitGrafici(npoints, 1)
          elseif (iAction == -2) then
              call InitGrafici(0, 0)
          endif
!
          if (.not. ifViewer) then
              stepGR = 1.5 * FntPixHeight / float(kAlt)
              stepGR0 = 1.0
              stepGRi = stepGR0
              headGR(1,1) = 0.0
              headGR(2,1) = 1.0
              headGR(3,1) = 1.0
              headGR(4,1) = 1.0 - stepGR
              headGR(1,2) = 0.0
              headGR(2,2) = 1.0
              headGR(3,2) = 0.0
              headGR(4,2) = 0.0 + stepGR
          endif
!
!-- create and open viewer
!
          if (ifViewer) then
              ind = 1
              iot = 0
              Message = 'FOMs Statistics'
              call Visualizzatore(ind, kLarg, kAlt, Message)
          endif
!
          HistoBack = color_BRIGHTWHITE
          call gr_init(1, kLarg, kAlt) 
          call gr_setbackground(HistoBack)
!
          do i=1, nGraficiGR
             if (HistoOK(i) == 1) then
                 call gr_frame(kLarg, kAlt,
     *                         xHistF(1,i), xHistF(2,i), 
     *                         yHistF(1,i), yHistF(2,i),
     *                         HistoBack, HistoBack)
                 call gr_area(xHisto(1,i), xHisto(2,i), 
     *                        yHisto(1,i), yHisto(2,i))
                 call gr_clear_area(xHisto(1,i), xHisto(2,i), 
     *                              yHisto(1,i), yHisto(2,i))
                 stringx = StringGR(i,1)
                 stringy = StringGR(i,2)
                 top     = LegendGR(i)
                 kk = tipoGraficiGR(i)
                 Tic = QualeTic(i)
                 call DoGraph(i, kk, stringx, stringy, top, Tic)
                 call zflush
             endif
          enddo
!
!-- close viewer
!
          if (ifViewer) then
              ind = 3
              iot = 0
              call Visualizzatore(ind, ix, iy, ' ')
          endif
      elseif (iAction == 0) then
!
!-- plot all histograms
!
          if (ifViewer) then
              ind = 4
              iot = 0
              call Visualizzatore(ind, ix, iy, ' ')
          endif
!
          call gr_setbackground(HistoBack)
          do i=1, nGraficiGR
             if (HistoOK(i) == 1) then
                 call gr_frame(kLarg, kAlt,
     *                         xHistF(1,i), xHistF(2,i), 
     *                         yHistF(1,i), yHistF(2,i), 
     *                         HistoBack, HistoBack)
                 call gr_area(xHisto(1,i), xHisto(2,i), 
     *                        yHisto(1,i), yHisto(2,i))
                 call gr_clear_area(xHisto(1,i), xHisto(2,i), 
     *                              yHisto(1,i), yHisto(2,i))
                 kk = tipoGraficiGR(i)
                 stringx = StringGR(i,1)
                 stringy = StringGR(i,2)
                 top     = LegendGR(i)
                 Tic = QualeTic(i)
                 call DoGraph(i, kk, stringx, stringy, top, Tic)
             endif
          enddo
!
          call zflush
          if (ifViewer) then
              ind = 3
              iot = 0
              call Visualizzatore(ind, ix, iy, ' ')
          endif
!
      else
!
!-- plot iAction-th histogram
!
          if (ifViewer) then
              ind = 4
              iot = 0
              call Visualizzatore(ind, ix, iy, ' ')
          endif
          i = iAction
          HistoOK(i) = 1
          stringx = StringGR(i,1)
          stringy = StringGR(i,2)
          top     = LegendGR(i)
          call gr_frame(kLarg, kAlt,
     *                  xHistF(1,i), xHistF(2,i), 
     *                  yHistF(1,i), yHistF(2,i),
     *                  HistoBack, HistoBack)
          call gr_area(xHisto(1,i), xHisto(2,i), 
     *                 yHisto(1,i), yHisto(2,i))
          call gr_clear_area(xHisto(1,i), xHisto(2,i), 
     *                       yHisto(1,i), yHisto(2,i))
          kk = tipoGraficiGR(i)
          Tic = QualeTic(i)
          call DoGraph(i, kk, stringx, stringy, top, Tic)
          call zflush
          if (ifViewer) then
              ind = 3
              iot = 0
              call Visualizzatore(ind, ix, iy, ' ')
          endif
      endif
!
!-- Text part
!
      if (.not. ifViewer .and. ifDrawGR) then
          call gr_frame(kLarg, kAlt, 0.0, 0.5, 0.0, 1.0,
     *              color_BRIGHTWHITE, color_BRIGHTWHITE)
          call gr_area( 0.0, 0.5, 0.0, 1.0)
          call TestoGR(' ', -1, 2, 0)
*         call TestoGR(' ', -1, 2)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine TestoGR(stringa, colore, size, Box)
      USE General
      USE GrexpoMod
      USE Grafici
      USE Molcom
      character(len=*)                 :: stringa
      integer                          :: size, colore
      integer, intent(in)              :: Box

      if (kscreen.eq.0) then
         return
      end if

!
      lstr = Lung(stringa)
          nnnn = nLinesGR + 1
*     if (present(Box)) then
          if (Box > 0) then
              inBoxGR(Box) = inBoxGR(Box) + 1
!             if (lstr > 0) then 
!             write(6,1) nnnn,Box,inBoxGR(Box),stringa(1:Lung(stringa))
!             endif
!         else
!             if (lstr > 0) then
!             write(6,2)                  stringa(1:Lung(stringa))
!             endif
          endif
*     endif
!   1 format('TESTO  ',i3,' Box ',i1,' n ',i2,' ',a)
!   2 format('TESTO                 ',a)
      stepGRi = stepGR0
      if (lstr == 1 .and. stringa(1:1) == '&') then
          nLinesGR = nLinesGR + 1
          cardGR(nLinesGR) = ' '
          WhichBoxGR(nLinesGR) = Box
          sizeLinesGR(nLinesGR) = size
          if (colore > 0) then
              colorLinesGR(nLinesGR) = colore
          else
              colorLinesGR(nLinesGR) = color_LIGHTBLUE
          endif
      elseif (lstr > 0) then
          nLinesGR = nLinesGR + 1
          call MarkUpGR(stringa, lstr)
          cardGR(nLinesGR) = ' '
          cardGR(nLinesGR) = stringa(1:lstr)
          WhichBoxGR(nLinesGR) = Box
          sizeLinesGR(nLinesGR) = size
          if (colore > 0) then
              colorLinesGR(nLinesGR) = colore
          else
              colorLinesGR(nLinesGR) = color_LIGHTBLUE
          endif
      endif
!
      if (.not. ifDrawGR) return
      call gr_area(0.0, 1.0, 0.0, 1.0)
      xp = 0.01
!
!-- header
!
      call gr_setcolor(color_RED)
      call gr_frame(kLarg, kAlt,
     *              headGR(1,1), headGR(2,1), 
     *              headGR(3,1), headGR(4,1),
     *              color_YELLOW, color_YELLOW)
      stepGRi = stepGRi - stepGR
      yp = stepGRi
      call gr_drawtext(xp,yp,0.0,headersGR(1),2)
!
!-- text
!
      stepGRi = stepGRi + stepGR / 2
      if (nLinesGR > 0) then
*          call gr_frame(kLarg, kAlt,
*     *              0.0, 0.5, 
*     *              stepGR*1.01, 1.0 - stepGR*1.01,
*     *              color_BRIGHTWHITE, color_BRIGHTWHITE)
          call gr_frame(kLarg, kAlt,
     *              0.0, 0.5, 
     *              headGR(4,1) - stepGR / 2, headGR(4,2) + stepGR / 2,
     *              color_BRIGHTWHITE, color_BRIGHTWHITE)
          call gr_setcolor(color_LIGHTBLUE)
          xpb = xp + stepGR
          xpb1 = xp + stepGR / 2
          ypb1 = stepGRi - stepGR / 2
          ypb2 = 0
          stepGRi = ypb1
          PixMax = -99
          inBoxGR_T = 0
!
          do nbx=1, 5
             if (nbx >= 4 .and. inBoxGR(nbx) >= 1) then
                 call gr_frame(kLarg, kAlt, 
*    *                         xHistF(1,3)+stepGR , xHistF(2,3)-stepGR ,
*    *                         yHistF(1,3)+stepGR , yHistF(2,3)-stepGR ,
     *                         xHistF(1,3)        , xHistF(2,3)        ,
     *                         yHistF(1,3)        , yHistF(2,3)        ,
     *                         color_BRIGHTWHITE, color_BRIGHTWHITE)
             endif
!
             ifBox4 = 0
             do i=1, nLinesGR
                if (WhichBoxGR(i) /= nbx) cycle
                call gr_setcolor(colorLinesGR(i))
                stepGRi = stepGRi - stepGR *0.9
                if (nbx < 4) then
                    xpb = xp + stepGR
                    xpb1 = xp + stepGR / 2
                    yp  = stepGRi
                else
                    xpb = xHistF(1,3) + 1.5 * stepGR 
                    if (ifBox4 == 0) then
                        ifBox4 = 1
                        yp  = yHistF(2,3) - stepGR ! - 2*stepGR ! gianluca 05/05/09
                    else
                        if (sizeLinesGR(i) == 1) then
                            yp  = yp - stepGR/2
                        else
                            yp  = yp - stepGR
                        endif
                    endif
                endif
                if (index(cardGR(i),'<big>') > 0) then  ! gianluca 05/05/09
                    if (nbx < 4) then                   ! gianluca 05/05/09
                        xpbb = xpb / 2                  ! gianluca 05/05/09
                    else                                ! gianluca 05/05/09
                        xpbb = xHistF(1,3)              ! gianluca 05/05/09
     *                       + (xpb-xHistF(1,3))/2      ! gianluca 05/05/09
                    endif                               ! gianluca 05/05/09
                else                                    ! gianluca 05/05/09
                    xpbb = xpb                          ! gianluca 05/05/09
                endif                                   ! gianluca 05/05/09
                call gr_drawtext(xpbb,yp,0.0,cardGR(i),
     *                           sizeLinesGR(i))
                fx = LenInPix(cardGR(i),sizeLinesGR(i))
                if (fx > PixMax) then
                    PixMax = fx
                endif
             enddo
             if (inBoxGR(nbx) >= 1) then
                 if (nbx < 4) then
                     ypb2 = yp - stepGR / 2
                     xpb2 = xpb + PixMax / float(kLarg) + xpb - xpb1
**                   call gr_frame(kLarg, kAlt, xpb1, xpb2, ypb1, ypb2, 
**   *                       color_LIGHTBLUE, -1)
                 else
**                   call gr_frame(kLarg, kAlt, 
**   *                       xHistF(1,3)+stepGR , xHistF(2,3)-stepGR,
**   *                       yHistF(1,3)+stepGR , yHistF(2,3)-stepGR,
**   *                       color_LIGHTBLUE, -1)
             endif
             endif
*****        stepGRi = stepGRi - stepGR     ! gianluca 05/05/09

             inBoxGR_T = inBoxGR_T + inBoxGR(nbx)
             ypb1 = ypb2 - stepGR / 3
             ypb2 = ypb1 - stepGR

          end do
!
          if (inBoxGR(4) == 0) then
              call gr_frame(kLarg, kAlt, 
     *                 xHistF(1,3)+stepGR , xHistF(2,3)-stepGR , 
     *                 yHistF(1,3)+stepGR , yHistF(2,3)-stepGR , 
     *                 color_BRIGHTWHITE, color_BRIGHTWHITE)
          endif

!         do i=inBoxGR_T + 1, nLinesGR
          do i=1, nLinesGR
             if (WhichBoxGR(i) > 0) cycle
             call gr_setcolor(colorLinesGR(i))
             stepGRi = stepGRi - stepGR
             yp = stepGRi
             if (index(cardGR(i),'<big>') > 0) then  ! gianluca 05/05/09
                 xpbb = xp / 2                       ! gianluca 05/05/09
             else                                    ! gianluca 05/05/09
                 xpbb = xp                           ! gianluca 05/05/09
             endif                                   ! gianluca 05/05/09
             call gr_drawtext(xpbb,yp,0.0,cardGR(i), sizeLinesGR(i))
          enddo
      endif
!
!-- footer
!
      call gr_setcolor(color_RED)
      if (Lung(headersGR(2)) > 0) then
          call gr_frame(kLarg, kAlt,
     *                  headGR(1,2), headGR(2,2), 
     *                  headGR(3,2), headGR(4,2),
     *                  color_YELLOW, color_YELLOW)
          call CreaIsOver()
          yp = stepGR / 4
          call gr_drawtext(xp,yp,0.0,Msg, 2)
          fx = LenInPix(headersGR(2),2) * 1.1
          xp = 1.0 - fx / float(kscrx)
          call gr_drawtext(xp,yp,0.0,headersGR(2), 2)
      endif
!
      call zflush
!
      return
      end
!-----------------------------------------------------------------------
*     INTERFACE
*         subroutine TestoGR(stringa, colore, size, Box)
*            character(len=*)                 :: stringa
*            integer                          :: size, colore
*            integer,    optional, intent(in) :: Box
*         end subroutine
*     END INTERFACE
!-----------------------------------------------------------------------
      subroutine MarkUpGR(stringa, lstr)
      USE General
      USE CaratteriSpeciali
!
!-- This routine manages the following MarkUps  
!          <span lang="A">A</span>              Angstrom symbol
!          <span lang="Greek">stringa</span>    Greek characters
!
!-- The following are managed directly by GTK
!          <b>text</b>          Bold 
!          <big>text</big>      Makes font relatively larger
!          <sub>text</sub>      Subscript 
!          <sup>text</sup>      Superscript 
!          <small>text</small>  Makes font relatively smaller
!          <tt>text</tt>        Monospace font 
!          <u>text</u>          Underline 
 
      character*(*) stringa
!
      cardDiret = ' '
      cardImage = stringa
      call lcase(cardImage)
      k1 = index(cardImage,'<span lang="a">')
      k2 = index(cardImage,'<span lang="greek">')
      if (k1 > 0) then
          do while (k1 > 0)
             call SpecialChar(SpecCode(59), Inte, InteL)
             cardDiret(1:k1-1) = stringa(1:k1-1)
             cardDiret(k1:k1+InteL-1) = Inte(1:InteL)
             cardDiret(k1+InteL:) = stringa(k1+23:)
             stringa = cardDiret
             cardImage = stringa
             call lcase(cardImage)
             k1 = index(cardImage,'<span lang=a>')
          enddo
      endif
      if (k2 > 0) then
          do while (k2 > 0)
             kn = index(cardImage,'</span>') - 1
             k3 = k2 + 19
             cardDiret(1:k2-1) = stringa(1:k2-1)
             do k = k3, kn
                kk = ichar(stringa(k:k))
                kk = kk - 64
                call SpecialChar(SpecCode(kk), Inte, InteL)
                cardDiret(k2:k2+InteL-1) = Inte(1:InteL)
                k2 = k2+InteL
             enddo
             cardDiret(k2:) = stringa(kn+8:)
             stringa = cardDiret
             cardImage = stringa
             call lcase(cardImage)
             k2 = index(cardImage,'<span lang="greek">')
          enddo
      endif
      lstr = Lung(stringa)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DoGraph(Quale, tipo, stringx, stringy, legenda, Tic)
      USE General
      USE GREXPOMOD
      USE Grafici
      USE Molcom
!
!-- tipo = 1   Scatter plot (Markers)
!-- tipo = 2   Histogram
!-- tipo = 3   Arrows   
!-- tipo = 4   Scatter plot (Markers) + strings in gr. area
!
      integer, intent(in) :: tipo
      integer, intent(in) :: Quale
      real, intent(in)    :: Tic
      real                :: minx, maxx, miny, maxy
      real                :: diff, delta
      integer             :: i, col
      character(len=*)    :: stringx, stringy, legenda
!
!-- Set viewport
!
      delta = -2

      minx = MinMaxGR(1,Quale) 
      maxx = MinMaxGR(2,Quale)
      miny = MinMaxGR(3,Quale) 
      maxy = MinMaxGR(4,Quale)
      if (tipo == 2) then     ! Histogram
          miny = 0
          k = lPlots(Quale)
          if (k > 0) then
              maxy = maxval(gr_distrib(xpoints(1:k,Quale),
     *                      minx, maxx, 100))
          else
              maxy = 1
          endif
      endif
      call gr_setwin(minx, maxx, miny, maxy)
!

!
!-- Axis
!
      call gr_setcolor(color_BLUE)
      if (tipo == 2) then    ! Scatter plot
          call gr_box_sir('AILTS', Tic, 0, 'AILT', delta, 0,
     *                 0, LabTrialsV)
c    *                 LabTrials, LabTrialsV)
      elseif (tipo == 3) then    ! con i Labels .. (dritan)
          call gr_box_sir('ABILTS', Tic, 0, 'ABILT', delta, 0,
     *                 LabTrials, LabTrialsV)
      else                   ! Histogram
          call gr_box_sir('ABILTS', Tic, 0, 'ABILT', delta, 0,
     *                 0, LabTrialsV)
c    *                 LabTrials, LabTrialsV)
      endif
!
!-- Grids
!
!     call gr_setcolor(color_GRAY)
!     call gr_setlinestyle(2)
!     call gr_box('G',0.0,0,'G',0.0,0)
!     call gr_setlinestyle(1)
!
!-- Line
!
!     call gr_setcolor(color_BLACK)
!     call gr_drawline(xpoints(:n),ypoint(:n))
!
      if (tipo == 1 .or. tipo == 4) then
!
!-- Scatter plot (Markers)
!
          call gr_setsize(2)
          k = lPlots(Quale)
          if (k > 0) then 
              call gr_setcolor(color_RED)
              if (tipo == 4.and.ianom==6) then
                  xxx = (maxx - minx ) / 30.0
                  yyy = 0.97 * maxy
c                 Msg = '<span lang="Greek">D</span><sub>ano</sub>'
                  Msg = MsgGraficiGR(1)
                  call MarkUpGR(Msg, lstr)
                  call gr_drawtext(xxx,yyy,0.0,Msg,2)
              endif
              do j=1, k
                 xxp = xpoints(j,Quale)
                 yyp = ypoints(j,Quale)
                 if (colorGR(j, Quale) < 0) then
                     call gr_setcolor(color_RED)
                     call gr_drawvline(xxp)
c                    Msg = '<span lang="Greek">D</span>'
c    *                   // '<sub>disp</sub>'
                     Msg = MsgGraficiGR(2)
                     call MarkUpGR(Msg, lstr)
                     xxx = xxp * 1.05
                     call gr_drawtext(xxx,yyy,0.0,Msg,2)
!                    call gr_line(xxp,0.0,xxp,1.0)
                 else
                     call gr_setcolor(colorGR(j, Quale))
                     call gr_draw1marker(xxp, yyp, 5)
                 endif
              enddo
          endif
      elseif (tipo == 2) then
!
!-- Histogram
!
          if (lPlots(Quale) > 0) then
              k = lPlots(Quale)
              call gr_setcolor(color_LIGHTRED)
              call gr_sfs(1)
              nbin = 100
              i = 1
              ifColor = 1
              iv = 1
!             call gr_hist(xpoints(1:k,Quale), nbin, i)
              call gr_hist_sir(xpoints(1:k,Quale), nbin, i,
     *                    ifColor, color_LIGHTGREEN, color_LIGHTRED, iv)
!
          endif
      elseif (tipo == 3) then
!
!-- Arrows
!
          call gr_setsize(2)
          k = lPlots(Quale)
          if (k > 0) then
              do j=1, k
                 xxp = xpoints(j,Quale)
                 yyp = ypoints(j,Quale)
                 kc = colorGR(j, Quale)
                 kcmod = mod(kc, 1000)
                 call gr_setcolor(kcmod)
                 call gr_drawarrow(xxp, yyp)
c                if (kc > 1000.and.ianom/=3) then
                 if (kc > 1000.and.ianom/=0) then
                     call gr_cerchioBest(xxp,yyp, color_LIGHTBLUE)
                 endif
              enddo
          endif
      endif
!
!-- Text
!
      call gr_setcolor(color_BLUE)
      call gr_reldrawtext('B',2.5,0.5,0.5,stringx,2)
      call gr_reldrawtext('L',1.5,0.5,0.5,stringy,2)
      if (Lung(legenda) > 0) then
          if (QualePgm == SIRPROTPGM) then
              call gr_reldrawtext('T', -0.01, 0.5, 0.5, legenda, 2)
          else
              call gr_reldrawtext('T', -0.01, 0.5, 0.5, legenda, 1)
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      real function CheckTic(maxx, Quale)
      USE Grafici
      real, intent(in)    :: maxx
      integer, intent(in) :: Quale
      real                :: Tic
      integer             :: i, xArea
      character(len=10)   :: numero
!
      write(numero,'(i10)') nint(maxx)
      call shift(numero,i)
      i = LenInPix2(numero,i, 2)
      i = i * maxx
      xArea = nint( (xHisto(2,Quale) - xHisto(1,Quale)) * float(kLarg))
      if (i > xArea) then
          Tic = 0.0
      else
          Tic = 1.0
      endif
      CheckTic = Tic
!
      return
      end
! ----------------------------------------------------------------------
      subroutine gr_frame(kLarg, kAlt, xminGR, xmaxGR, yminGR, ymaxGR,
     *                    ic1GR, ic2GR)
      USE Molcom
!
      ix1 = nint(kLarg * xminGR)
      ix2 = nint(kLarg * xmaxGR)
      iy1 = kAlt - nint(kAlt * yminGR)
      iy2 = kAlt - nint(kAlt * ymaxGR)
!     
      call Rettangolo (ix1, iy1, ix2, iy2, ic1GR, ic2GR)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine  gr_Poligono(xvet, yvet, iz, iColor, jFill)
      USE Molcom
      integer  xvet(iz), yvet(iz)
!
      ixv(1:iz) = xvet(1:iz) 
      iyv(1:iz) = yvet(1:iz) 
      call  Poligono(iz, iColor, jFill)
!
      return
      end
! ----------------------------------------------------------------------
