! ----------------------------------------------------------------------
      MODULE Clustering
             real*8, allocatable    :: cdclust(:)
             real*8, allocatable    :: dordclust(:)
             integer, allocatable    :: ilcclust(:)
             integer, allocatable    :: iucclust(:)
             integer, allocatable    :: iordclust(:)
      END MODULE Clustering
! ----------------------------------------------------------------------
      MODULE Trigonometria
             real       :: pi, twopi, dtor, rtod, twopis, rtd, dtr
      END MODULE Trigonometria
! ----------------------------------------------------------------------
      MODULE SAmodule
          real    :: cellaFrag(6)
          real    :: traslaVetSA(3)
      END MODULE SAmodule
! ----------------------------------------------------------------------
      MODULE Deprecato
          common /xtemp/ itemp(80)
          integer :: itemp
          real    :: temp(80)
          equivalence(itemp, temp)
      END MODULE Deprecato
! ----------------------------------------------------------------------
      MODULE General
      USE Trigonometria
      USE elements, only:element_type
      USE spginfom, only:spaceg_type
!!!corrado: da sistemare meglio
!!!rimuovere la variabile version dal common dialogo
#define PACKAGE_NAME "IlMilione"
#define PACKAGE_STRING "IlMilione 15.07"
!temp      character(len=*), parameter :: version = VERSION
      character(len=*), parameter :: package_name = PACKAGE_NAME
      character(len=*), parameter :: package_string = PACKAGE_STRING
      character(len=*),
     *parameter :: package_alt_name = package_string
!
!-- Test for new code
!
      integer :: cuda           !!gpu
      integer :: gpuhard        !!gpu
!
! I/O units, trig
!
      logical :: GuessFormat = .false.
      integer :: ln    =   5
      integer :: lo    =   6
      integer :: jlog =   29
      integer :: jdir  =  30
      integer :: iscra =  31
      integer :: jrel  =  32
      integer :: ifour =  33
      integer :: jfile =  34
      integer :: jhost =  35
      integer :: jgrap =  36
      integer :: jerr  =  37
      integer :: kform =  41
      integer :: ktml  =  46 ! log file for ILMILIONE
      integer :: itle(20)
      integer :: jout  =   0
      integer :: jpfile
      integer  :: ncmu = 51
      integer  :: nctu = 52
      integer  :: ncau = 54
      integer  :: ncsu = 54
      integer  :: nclg = 55
      integer  :: nccf = 56
      integer  :: jrelT  = 42
      integer  :: jrelET = 43
      integer  :: jrelE  = 44
      integer  :: jrelSK = 45
      real     :: sint(450)
      real     :: cost(360)
      equivalence (sint(91),cost(1))
***********************************************************************
      character(len=80)  ::  ititle  = ' '
************************************************************************
* Implementation common
!
      integer  :: ifDebug = 0
      integer  :: ifW95 = 0
!     knwr   =  number of integer words in direct access file record
!              *** warning *** for VAX/VMS implementation the record
!              lenght and the number of words have the same value
!              (i.e. nlenBin=knwr)
!     kenvir =  0 for standard implementation
!     kenvir =  1 for enraf-nonius environment
!     kenvir =  2 for m.s.c.       environment
!     kenvir =  3 for INCRYS       environment
      integer  :: knwr = 512
      integer  :: nlenBin
      integer  :: kenvir = 0
      integer  :: kstory(99)

************************************************************************
* Cell parameters
      real     :: pp(6), cell(9), xgg(3,3), xgr(3,3), errcell(7)
      real     :: xgg9(9), xgr9(9)
      real     :: gdist(18)
      real     :: BisoToBij(6),BijToBiso(6),UisoToBiso,BisoToUiso
      real     :: UijToBij_11,UijToBij_22,UijToBij_33
      real     :: UijToBij_23,UijToBij_13,UijToBij_12
      real     :: BijToUij_11,BijToUij_22,BijToUij_33
      real     :: BijToUij_23,BijToUij_13,BijToUij_12
      real     :: xortr(3,3), xorti(3,3)
      real     :: rhomax, en, er, th, rhomin, volume
      real     :: rhomax_obs, resol_obs_max, resol_obs_min
      integer  :: nbWils
      real     :: qd(4,4), qt(4,4), cstar(6)
      real     :: rcm11, rcm12, rcm13, rcm22, rcm23, rcm33
      real     :: rlm11, rlm12, rlm13, rlm22, rlm23, rlm33
      real     :: asta(6), costar(3), volumer, sas, sbs, sgs
      real     :: alfs, bets, gams
      real     :: atvol
     
************************************************************************
* Cell content
*      al, bs, cl,      coeff. per calcolo fattore di scatt.
*      fprimo,fsecondo  valori anomali del fattore di scattering
*      nw               numero di atomi della specie i-esima
*      no               valore di Z per la specie i-esima
*      nk               numero di specie atomiche
*      nat              numero di atomi non H nella cella
*      natm             numero di atomi non H nella unita' asimmetrica
*      anat             numero di atomi non H nella unita' asimmetrica
*      ff               fattore di scattering
*      ff_m             ff per modello       
*      nalf             simbolo della specie atomica + '  ' per i picchi Four.
*      radii(1)         raggio covalente, radii(2) raggio per Van der Waals
*      nomeat           nome completo della specie atomica (Carbon Oxigen etc.)
*      wavel            Wave Length
*      BontTable        Min & Max value of the bonding distance
*      vetSpec          number of at. of the model in asymm. unit & ghosts
*      ZValue           number of molecules in unit cell ( i.e. Z )
      dimension   al(4,18), bs(4,18), cl(18), nw(18), no(18),
     *            ff(19),ff_m(19,10), nalf(19), radii(18,2), fmuro(18),
     *            AtomWeight(18),BondTable(2,18,18), vetSpec(19)  
      real fprimo(18),fsecondo(18),fsecondoMnqd(18)
      real        al, bs, cl, ff, radii, fmuro,AtomWeight, BondTable, 
     *            anat, wavel, Theta2
      integer     MaxNk, nk, nw, no, nalf, nat, natm, is3s2, 
     *            vetSpec, ZValue, PiccoFour
      dimension   ald(4,5),bsd(4,5),cld(5),nwd(5),nod(5),
     1            nalfd(5),ffirst(5,5),fsecon(5,5),nanomv(5),dfact(5)
      integer :: ifMottFormula(18)
      integer :: WhichWave = -1
      real    :: ald, bsd, cld, fd, ffirst, fsecon, dfact
      integer :: nwd, nod, nkd, natd, nalfd, nanomv
      integer :: numeroResidui = 0   
      integer :: WhichProps = 0
************************************************************************
      real nSpecie
      integer NumSpec
      dimension nSpecie(18)
      character(len=4):: vSpecie, Species, SpeciesSav
      character(len=5):: ReleaseXen
      character(len=12):: nomeat
      dimension  vSpecie(18), Species(18), nomeat(18), SpeciesSav(18)
************************************************************************
      type(element_type), dimension(:), allocatable :: celem
      type(spaceg_type)                             :: spacegr
************************************************************************
* Neutrons
      integer         ifNegativePeaks, natsNeg
      real            percNegativePeaks
************************************************************************
* Extrapolated reflections
      integer       ifGener, ifExpand, nrunob, iffsq, indmb, nresm
      integer       ihmxSav(3), ifCalcF, ifFreeLunch, ifCalcScBt
      integer       ihmxLow(3)
      integer       jnowilson, nrefExt, ifDemiFL
      real          tabmiss(25), resolMiss, total(5), fosig(25,3)
      real          fosigAll(3)
      integer       nmiss(25,4), kpercmiss(25,2), itotMiss(25), nendMiss
      integer       nex, jall, isetPhase(20), icomuni, macroFL, irescut
      real          rGenTeorico, percExtreIn, rGenStep(5)
      real          sogRhoMaxMap, sogSigmaMap
      integer       nrsetMin, nrsetMax
      integer       nresmax, nresmin
************************************************************************
* Normalization and pseudotranslation informations
      real     :: gis(560), giw(560), gisd(560), giwd(560)
      integer  :: listRefl
      real    rpseud, percPseudo, aPse, bPse
      integer numbpseud, llpse,ifpseud,pseudo_lowres,lpseuv(12), numbPse
!     wilson plot parameters
      integer  :: ks
      real     :: flgw(30), flgd(30), avr(30), dcv(50), slope, flgk, del
************************************************************************
      integer  :: NRefAtt, NRefPre
      real     :: ResEff, sogResEff, Complet
*     common /creaFra/ifFileFra
      integer  :: ifFileFra, ifLoadHydrogen
************************************************************************
* Riflessi
*      nrefltot         No. riflessi totali (input+generati)
*      nrefl            No. riflessi indipendenti in input
*      nreflObs         No. riflessi osservati
*      nonoss           No. riflessi non osservati
*      nescl            No. riflessi esclusi (dall'utente, via lista 18)
*      cutoff           valore di chop
*      nstr		      No. E's piu' forti
*      nzro		      No. E's piu' deboli
*      ihmx(3)		H(max),K(max),L(max) 
*      ihmn(3)		H(min),K(min),L(min) 
*      iLent (sir)
*      iVelox (sir)
*      ifPDBfiles	      flag per dati da file PDB
*      knw 		      flag per struttura nota
*      bt  		      b(medio) di Wilson
*      sc   		scala di Wilson
*      TrueSc   	scala di Wilson
*      s3s2
*      nvsfc		No. variabili affinate (last s.f.c.)
*      icdd             Code dati differenza  (anom.disper.) 
*      deltahkl(3) 	Delta(h),Delta(k),Delta(l) for sorting  (sir)
*      rflsq		R%
*      rwflsq		RW%
*      slsq	        S
*      btd(5)
*      scd(5)
*      s3s2d(5)
*      ihmxExt(3)       SIR  
*      uvwt2(2)		EXPO: 
*      nsyn             EXPO: 
*      kequirip		EXPO:
*      pfwhm		EXPO:
*      QualeLista6      Codice tipo lista6 diverso da QualePgm 
*                          solo se viene letto il file binario di un 
*                          programma differente
*                       1 (SIR), 
*                       2 (SIRPROT), 
*                       3 (EXPO)     
*      shiftesd(2)	Shift/esd (max)	, Shift/esd (mean)
*      rhodiff(3)	      RHO(diff.) max, min, rms
*      ifo2		      flag per fo o fo**2 in input
*      npseud  		codice per pseudo traslazioni
*      iyrand		ultimo seme per random
*      fosog		soglia sugli Fo
*      ksigma 		flag per sigma(Fo) in input
*      neutro		tipo di radiazione
*      lproj		tipo di proiezione
*			lproj=0 --> 3D data
*			lproj=1 --> 2D data	X section
*			lproj=2 --> 2D data	Y section
*			lproj=3 --> 2D data	Z section
*      pack3            coeff. per il packing dei riflessi = 2*exp(9) = 512
*      pack2            coeff. per il packing dei riflessi = pack3 * pack3
*      pack1            coeff. per il packing dei riflessi = pack2 * pack3
*      pack5            coeff. per il packing dei riflessi = pack3 / 2
*         		code = 1
*         		code * pack1 + ( H + pack5 ) * pack2 
*                                    + ( K + pack5 ) * pack1 
*                                    + ( L + pack5 )
*      kWasReduced      = 1 se e' stato precedentemente usato il comando %reduce
*                       = 0 in default
*      kmad             kmad /= 0 se abbiamo dati MAD 
*      s3s2mad          s3s2 per MAD
*      resm             max value for resolution
*      numbGen          number of generated reflections
*      ksize            "size" of the structure ( i.e. micro, small, medium ...)     
*      nds
*      ianom
*      jderi
*      machkl           EXPO           
*      ifTwin 
*      iyrand           seed for pseudo-random values generator
*      iprioroX,ipriorpX,ipriorsX,ipriofrX,ipriopaX,iprefX,            
*      jplaneX(3),gmaxX,iprandomX,iprandomaxX,icomatsavX,     
*      ipdirsavX,idummya(5)                                                
*
      integer  :: minNrefl = 150
      integer  :: nstr_MDM = 0
      integer  :: nstr_data = 0
      integer  :: useSigma
      integer  :: ifRIP ! = 0
      real     :: TrueSc
!     real stor6(101)
!     equivalence(stor6(1),nrefltot)
*
      common /riflComm/ nrefltot,nrefl,nonoss,nescl,cutoff,nstr,nzro,   !   7
     *        nreflObs,ihmx(3),ihmn(3),ilent,ivelox,                    !  16
     *        ifPDBfiles,knw,bt,sc,s3s2,nvsfc,icdd,deltahkl(3),         !  26
     *        rflsq,rwflsq,slsq,btd(5),scd(5),s3s2d(5),ihmxExt(3),      !  47
     *        uvwt2(2),nsyn,kequirip,pfwhm, QualeLista6,                !  53
     *        shiftesd(2),rhodiff(3),ifo2,                              !  59
     *        npseud,iyrandc,fosog,ksigma,neutro,lproj,pack3,           !  66
     *        pack2,pack1,pack5,kWasReduced,kmad,s3s2mad,resm,numbGen,  !  74
     *        ksize,nds,ianom,jderi,machkl,ifRIP, ifTwin, gmaxX,        !  82
     *        iprioroX,ipriorpX,ipriorsX,ipriofrX,ipriopaX,iprefX,      !  88
     *        jplaneX(3),icomatsavX,ipdirsavX,                          !  93
     *        sh_su_max,sh_su_mean,diff_d_max,diff_d_min,diff_d_rms,    !  98
     *        iprandomX,iprandomaxX,iyrand                              ! 101
      real     :: perc_refl = 1.4
      ! dritan (serve per il derivato sirprot)
      integer nrefc 
!
      integer  :: ifSizeProtein 
      real     :: Rint_thr  ! soglia su Rint riflessi mergiati
      real     :: ifOmit    ! per omettere i riflessi con Rint > Rint_thr
      real     :: ifExport  ! per creare file senza i riflessi omessi (opp. Fo = 0)
!
      integer  :: neutro = 0
      integer  :: nrefltot,nrefl,nonoss,nescl,nstr,nzro,ihmx,ihmn,ilent
      integer  :: nreflObs,ivelox,knw,nvsfc,icdd,ihmxExt,QualeLista6
      integer  :: ifo2,npseud,iyrandc,ksigma,lproj,pack3,pack2
      integer  :: pack1,pack5,kWasReduced,kmad,numbGen,ksize,nds,ianom
      integer  :: jderi, ifTwin,ifPDBfiles, iyrand
      integer  :: knwgethkl,ifPhases
      integer  :: iprioroX,ipriorpX,ipriorsX,ipriofrX,ipriopaX
      integer  :: iprefX,jplaneX,icomatsavX,ipdirsavX,idummya
      integer  :: iprandomX,iprandomaxX
      real     :: gmaxX
      integer  :: nsyn, kequirip, machkl
      integer  :: Added = 0

      real    cutoff,bt,sc,s3s2,deltahkl,rflsq,rwflsq,slsq,btd,
     *        scd,s3s2d,shiftesd,rhodiff,fosog,s3s2mad,resm,resmin
!
!-- per il file CIF
!--list sperimental conditions for CIF file
!
      integer  :: numbRiflInput
      real     :: erreInt, resolutionMin, resolutionMax
      integer  :: noce,nstand,ncountCIF,istand(3,6),ntotale
      real     :: ceth(2),sizecry(3),tmnx(2),averr,uneti
!
c  l6    disc location for writing
c  l6a   saved disc location for writing
c  l6d   disc location for reading
c  m6    location of the core buffer at which the results are found
c  m6dk  location of the input (or output) disc buffer
c  n6dk  number of integer words in the disc buffer
c  md6d  number of real words per reflections on read
c  l6p   address in store of the preamble block
c  n6p   length of the preamble block
c  ld6p  disc location of the preamble block
c  md6f  disc location of the input format
c  lfl6  lenght of the allocatable vector = nrefl*md6d
c  sys06 =-200.0   new list6
c--
      integer l6
      integer l6a
      integer l6d
      integer ld6p
      integer m6
      integer m6dk
      integer n6dk
      integer md6d
      integer n6d
      integer n6
      integer n6p
      integer l6p
      integer md6f
      integer lfl6
      integer sys06
      integer                  ::  nVarRecord = 25   
      integer nVarRecordTot
*
      character*80 formatrif
************************************************************************
* scratch file reflexion arrays
      integer  nrpb, iarray6(23,64)
      real     array6(23,64)
      equivalence (array6(1,1),iarray6(1,1))
* buffer reflexion arrays
      integer ivet6(100)
      real     vet6(100)
      equivalence (ivet6(1), vet6(1))
************************************************************************
!--   maxstr = maximum number of strong reflections
!--   maxpsi = maximum number of weak reflections
!--   numbMaxTrip = maximum number of triplets
!--   numbMaxnQ   = maximum number of negative quartets
*     common /bigcom/ maxstr,maxpsi, numbMaxTrip, numbMaxNQ
      integer, parameter      :: maxstr = 4000
      integer, parameter      :: maxpsi = 1000
      integer, parameter      :: numbMaxTrip = 300000
      integer, parameter      :: numbMaxNQ = 90000
c
c-- structure files
c
      character ReflFileForm*80
      character *256 ReflFileName, ReflFilePath, FraFilePath
      character *256 StructureName
      character *256 path(2)
      integer :: lStructureName
      integer   :: lnome
      character (len=80)  :: nome
!
      integer, parameter                          :: nmaxFragFile = 10
      character(len=256), dimension(nmaxFragFile) :: FragFilePath
      integer                                     :: nFragFile
!
c
c-- sir constants files

      character(len=256)  ::   ffile    = '.xen'
      character(len=256)  ::   sirtx    = '.htm'
      character(len=256)  ::   iasun    = '.spg'
      character(len=256)  ::   ciffle   = '.cif'
      character(len=256)  ::   psfle    = '.ps'
      character(len=256)  ::   grufle   = '.gru'
      character(len=256)  ::   rotfle   = '.rot'
      character(len=256)  ::   macfle   = '.mac'
      character(len=256)  ::   f12fle   = '.f12'
      character(len=256)  ::   extgroup = '.egr'
      character(len=256)  ::   hetero   = 'hetero.txt'
      character(len=256)  ::   syminfo  = 'syminfo.lib'
      character(len=256)  ::   histlib  = 'hist.lib'
      character(len=256)  ::   exepath  = ' '
      character(len=256)  ::   cfgpath  = ' '
      character(len=256)  ::   imsg1    = '.msg'
      character(len=256)  ::   hlp1     = '.hlp'
      character(len=256)  ::   SymmSPG  = '.cnv'
      character(len=256)  ::   muta     = 'mutate-res.scm'
      character(len=256)  ::   aggiungi = 'add-res.scm'
      character(len=256)  ::   looppa   = 'loop.scm'
!            
!-- default name for work files
      integer, parameter :: OUT_FILE=15  !corrado
      character(len=80), dimension(15) :: fname=(/
     *                                            'struct',
     *                                            'struct',
     *                                            'struct',
     *                                            'struct',
     *                                            'struct',
     *                                            '      ',
     *                                            '      ',
     *                                            '      ',
     *                                            '      ',
     *                                            '      ',
     *                                            'struct',
     *                                            'struct',
     *                                            'struct',
     *                                            'struct',
     *                                            'struct'/)
      character(len= 4), dimension(15) :: ext=(/ '.bin','.hkl','.res',
     *                                           '.plt','.err','.mpt',
     *                                           '.pat','    ','.png',
     *                                           '    ','    ','    ',
     *                                           '    ','.sir','.out'/)
c
c-- Run-Time common
c
      integer            :: ifRunToolBar, Imported, ifRecovered
      integer            :: ifRecover
      integer            :: ifDsrVLD = 0
      integer            :: ifPattVLD = 0
      integer            :: ifREFMAC = 0 
      integer            :: ifCOOT = 0 
      integer            :: ifARPWARP = 0 
      integer            :: ifBUCCANEER = 0 
      integer            :: ifPHENIX = 0 
      integer            :: ifNAUTILUS = 0 
      integer            :: ifLigand = 0
c
      real               :: zeff(18)
      real               :: rminimo = 99999.999
      integer            :: kminimo, kaminimo
      real               :: VetChanges(8)
      integer            :: cicloMut = 1
!
!           common /xtemp/ itemp(80)   ! MODULE Deprecato
!           dimension temp(80)         ! MODULE Deprecato
!           equivalence(itemp, temp)   ! MODULE Deprecato
!
!
!--InfoOK(i) = 1 se la i-esima lista e' in memoria, altrimenti e' zero
!
      common /ListeOK/ InfoOK
      integer          InfoOK(100)
!
*
c
************************************************************************
*     Reflections packing constants
      integer           ifat512, ifat512a, ifat512b
************************************************************************
*     Mir/Sir common
      integer :: WhichDeriv, nItemPerRef, nDataSets, nFields 
      integer :: nItemPerRefStd = 8
      integer :: nstrMir(5), nzroMir(5), nwMir(18), ifMiras
      real    :: fosogMir(5), btMir(5), scMir(5)
      integer :: numHeavy
      real    :: occHeavy
      integer :: ifDEDM = 0
!
      real    :: xyzMM(5,500), bfacMM(500)
      integer :: nzMM(500)
*
************************************************************************
      integer :: ifResBias = 0
      integer :: ifFromShelx = 0
      integer :: ifElimFo = 0 
      real :: elimFo = 0.0
************************************************************************
*  number of refletions respect to Ksubr=10-14
      integer :: NreflKsubr = 0
      integer :: iprin = 0, kverbo =0
      integer :: nreflDim, nonos, iflag, nPerCard, ifImport
      integer :: ifMatOr, MatOr(3,3)
*
************************************************************************
*     Renor2004 constants
      integer        ifDefineNorm, ifRenor,ifRenorReq, NShell, nreflSHL
      real           ResSog, E_Cut
************************************************************************
*     Invariants constants
      integer       ifat1,ifat2,ifatx,itabmx,icst1,icst2,icst3
************************************************************************
*     Constants
      real         :: costanteMatthews = 1.34
* Message Window codes [1-6]
      integer INFO_WINDOW, QUEST_WINDOW, QUEST_WINDOW_R, 
     *          QUEST_WINDOW_YES_NO, QUEST_WINDOW_NO_YES,
     *          WARN_WINDOW, ERR_WINDOW, SEVERE_ERR_WINDOW
      common /WindoMess/ INFO_WINDOW, QUEST_WINDOW, QUEST_WINDOW_R, 
     *          QUEST_WINDOW_YES_NO, QUEST_WINDOW_NO_YES,
     *          WARN_WINDOW, ERR_WINDOW, SEVERE_ERR_WINDOW
************************************************************************
* Strings
      character(len=  1) :: blank = ' '
      character(len=  1) :: slash
      character(len= 16) :: Labb
      character(len= 16) :: SpaceGroup
      character(len= 80) :: MessH = ' '
      character(len= 80) :: Titolo
      character(len=120) :: Message
      character(len=128) :: Inte
      character(len=256) :: cardImage, cardDiret, direttiva 
      character(len=256) :: buffer_ctrl_M
      character(len=256) :: FichierIn, FichierOut
      character(len=256) :: filePDB, AmbPDB
      character(len=780) :: Msg, Buffer1
      character(len=780) :: card(100)

*
      integer            :: ncardMax = 100
************************************************************************
* common per timing del programma
      real               :: Secs, SecsTot, Ore, Minuti, Secondi
      real               :: t1vet(10), t1, ttot
      integer            :: jcpuP, kopcpu
      character(len=256) :: data_ora
************************************************************************
* common per Cheshire / Unita' asimmetrica
      real       CheCell, CheMat, Gridv, AsymmUnitIniz, alimUp
      integer    nGridv
      dimension  CheCell(3), CheMat(3,3), nGridv(3),Gridv(3),
     *           AsymmUnitIniz(3), alimUp(3)
************************************************************************
      real              ResSogLow
      integer           numbGenSav
************************************************************************
      dimension       hkle(4,24),newvet(48,3), xyztot(3,30000)
      integer         newvet
      real            hkle, xyztot
************************************************************************
* MTZ stuff
      integer :: ifRFree = 0
      real MTZdata, MTZranges, ScaleDM, BtDM
      real valoriMTZ(100)
      character MTZfile*256, MTZSubrVers*10
      character (len=256) :: AddedMTZlabel = ' '
      character tipo_colonne
      integer ifMTZ, MTZunit, MTZprint, ifMTZlab, knwExt, jpartial
      integer nMTZlab, nreflMTZ, MTZ_Num_Col, MTZlookup, ifMTZopened 
      integer ifSeq, iphase, ifPDBt, nREMcard
      logical :: SaltaUNK = .true.
      dimension MTZdata(100), MTZranges(2,100), MTZlookup(100), 
     *          tipo_colonne(100)
      character(len=30), dimension(100) :: Lab_Ch=(/
     *                   'H       ','K       ','L       ',
     *                   'F1      ','SIGF1   ','DANO1   ','SIGDANO1',
     *                   'F3      ','SIGF3   ','DANO3   ','SIGDANO3',
     *                   'F2      ','SIGF2   ','DANO2   ','SIGDANO2',
     *                   'F4      ','SIGF4   ','DANO4   ','SIGDANO4',
     *                                (/('        ',iiiiii=1,81)/)/)
      character(len=30) :: Lab_Col(100)
      logical :: printMTZerror = .true.
************************************************************************
* common per varie procedure
*      QualePgm         Codice programma:
*                       1 (SIR), 
*                       2 (SIRPROT), 
*                       3 (EXPO)  
*                       4 (terminal like CAOS)    
      integer, parameter      :: SIRPGM     = 1
      integer, parameter      :: SIRPROTPGM = 2
      integer, parameter      :: EXPOPGM    = 3
      integer, parameter      :: CAOSPGM    = 4
      integer, parameter      :: JAVPGM     = 5

      integer   :: ifProtein = 0
      integer   :: ifRemo, ifWasRemo, ifWasMad, ifWillMad, numFragsMad
      integer   :: ifWillVLD = 0
      integer   :: ifWillMDM = 0
      integer   :: ifWillSannel = 0
      integer   :: nActSetStored
      integer   :: ifCompareFragments        !pgMAD290409
      integer   :: ifAutomatic = 0
      integer isOverFlag, QualePgm
      integer   :: ifAmb = 0
      integer   :: ifAmbSav = 0
      integer   :: ifAmbEnan = 0
      character (len=80) :: line_VLD
*     numFragsMad = numero di frammenti memorizzati sul file frag
*               ilMilione = 0   sir stand-alone run
*                         = 1   sir-sirprot batch mode
*                         = 2   sir-sirprot alternate mode
*                         > 2   sir-sirprot parallel mode
************************************************************************
* multiple data set common
      integer lcf, knorm, jheavy, ndrmax, icut
      real difbfac, rhomaxD, rhominD, rhomaxP, rhominP
      integer, dimension(5) :: iTypeAnom
      character(len=256) :: PDBfile
      integer   :: lPDB
************************************************************************
!     ext( 1)  = '.bin'
!     ext( 2)  = '.hkl'
!     ext( 3)  = '.res'
!     ext( 4)  = '.plt'
!     ext( 5)  = '.err'
!     ext( 6)  = '.mpt'
!     ext( 7)  = '.pat'
!     ext( 8)  = '    '
!     ext( 9)  = '.png'
!     ext(10)  = '    '
!     ext(11)  = '    '
!     ext(12)  = '    '
!     ext(13)  = '    '
!     ext(14)  = '.sir'
!     ext(15)  = '.out'
************************************************************************
      integer   :: ifPlotting = 0
************************************************************************
* partial
      integer  :: ipart, irefc, npumod, ivolta, nivolta
      integer  :: idritan, nivoltaD, idritanD
      real     :: soge2, percmod, sigmaold, sigPsigNOld

*------parte di giuliana
      logical  :: primavolta = .true. , secondavolta = .true.  !giuli start
      real     :: RfI, sigAI, rhoMaxUpgrade
      real     :: RtotOld=1.0, RfVld=1.0, DRtot=0.0, rhoIniG
      real     :: RtotEnd=1.0, Rg1=0.0, Rg2=1.0, Rg11=1.0
      real     :: DDPHI, errm12old, Err12old=0.0, DErr12old=0.0
      logical  :: primavoltaComb = .true., interruttore=.false.
      real     :: wBef=0.5, wAft=1.0, Dab, wBefOld
      logical  :: primoifconv = .true. , stopErr12=.false.
      logical  :: primoMax=.false., FirstDedm= .true.
      logical  :: primaCallEdm = .true., secondaCallEdm = .true. !Edm Cowtan
      logical  :: primaCallEdmN = .true.                         !Edm Nostra
      integer  :: nCallEdm=1, nCallEdmN=1, nStop=0
      integer  :: ngiuli = 0 , nrefl_ext           !giuli end
      real     :: dumpSigmaA = 1.0
      integer  :: nmicro4sigA
      real, allocatable    :: foIn(:),sigIn(:)
*------parte di giuliana



* patterson mad
      integer  :: jjpatt
      real     :: cutoffPatt
!
*  nuovo sistema per il passaggio di piu' stringhe al C
      type multistringa
         character (len = 256) :: str1, str2,str3, str4
         integer               :: n1, n2, n3, n4
      end type
      type MyStringa
         character (len = 256) :: f1
         integer               :: n1
      end type
!
!-- Program Configuration File
      character (len = 256) :: SWRC                ! Configuration File Name
      character (len = 256) :: HOMEdir             ! Home Directory
      character (len = 256) :: WorkingDirectory    ! Working Directory
      character (len = 256) :: OldWorkingDirectory ! Previous Working Directory
      common /SWareRC/ SWRC, HOMEdir, WorkingDirectory
!
      END MODULE General
! ----------------------------------------------------------------------
      MODULE Limits
!--actual values  (Min - Max)
!-- nella finestra di Sir
!   1   [Sin(Theta)/Lambda]^2
!   2   2 Theta
!   3   Resol.
!   4   Fo
!   5   Fc
!   6   Fo/Fc
!   7   (Fo-Fc)/Fo
!   8   h
!   9   k
!  10   l
!
             integer              :: numCondition = 10
             real                 :: VetCondition(5,10)
!
             integer              :: NumLimit = 14
             integer              :: NumOmit
             integer              :: TotClassiParita = 33
             integer              :: VetClassiParita(33)
             integer              :: VetOmit(3,100)
             integer              :: CodeLimit(14)
             integer              :: HLimitMin(3)
             integer              :: HLimitMax(3)
!
          type ModLimit
             real                 :: Rho           ! 1 (sin(th)/lamda)2
             real                 :: Th2           ! 2 2(th)
             real                 :: Resol         ! 3 resol
             real                 :: Fo            ! 4 fo
             real                 :: Fc            ! 5 fc
             real                 :: FoFc          ! 6 fo/fc
             real                 :: R             ! 7 (fo-fc)/fo
             integer              :: HKL(3)        ! 8 h, 9 k, 10 l
             real                 :: P             ! 11 (fo+2*fc)/3
             real                 :: P2            ! 12 (fo2+2*fc2)/3
             real                 :: Fo2           ! 13 fo2
             real                 :: Rhoroot       ! 14 (sin(th)/lamda)
          end type  ModLimit
!
             type(ModLimit)  :: DataMinLim
             type(ModLimit)  :: DataMaxLim
             type(ModLimit)  :: UserMinLim
             type(ModLimit)  :: UserMaxLim
             type(ModLimit)  :: AgreMinLim
             type(ModLimit)  :: AgreMaxLim
             type(ModLimit)  :: TempMinLim
             type(ModLimit)  :: TempMaxLim
!
      END MODULE Limits
! ----------------------------------------------------------------------
      MODULE Symmetry
!
! Symmetry informations
!--
            integer         :: ifRhombAx, ifTrigonal
            integer         :: jsys
            integer         :: norigin 
            integer         :: nGenerators
            integer         :: nSpaceGroup, nSpaceGroupPatt
            integer         :: ifLaue, nLaue
            integer         :: kmat(192,3,3)
            integer         :: nSpaceG(16)
            integer         :: nSpaceGSav(16)
            integer         :: irot(48,48)
            integer         :: jsvet(10) 
            integer         :: isvet(8)
            integer         :: modul(3)
            integer         :: nss(3)
            integer         :: jsmat(3,3)
            real            :: tmat(192,3)
            integer         :: nlatt
            integer         :: nScan, TotalScan, vScan(30), nSgScan(30)
            integer         :: SpgScan(30)
            real            :: ScfBtScan(2,30)
            character (len=16) :: SgScan(30)
            logical         :: SpaceScan = .false.
            real            :: lattvett(3,4)
!--
!      kmat(192,3,3)   rotation matrices (sir notation)
!      tmat(192,3)     translation matrices (sir notation)
!      nSpaceG(16)    space group symbol (alphanumeric)
!      jsys           crystal family
!      ifRhombAx      flag for rhombohedral axes
!      ifTrigonal     flag for trigonal crystal family
!      irot(48,48)    multiplication matrix
!      jsvet(10)      seminvariant conditions (numeric)
!      isvet(8)       seminvariant conditions (alphanumeric)
!      norigin        number of refl. to fix the origin
!      modul(3)       ????
!      nss(3)         ????
!--
            real            :: UnoPiuIcent
            real            :: UnoMenoIcent
            integer         :: ismat(2,3,24)
            integer         :: nsym, ksys, icent, neqv
            integer         :: latt = 0
            integer         :: nsymTot, nsymTrue, icentTrue
            real            :: pts, emme, totop, s3s2p, CentXNlatt
            real            :: tsvet(72)
            real            :: tsmat(3,24)
            equivalence     (tsvet,tsmat)
!--
!      ismat(2,3,24)  rotation matrices    (multan notation)
!      tsmat(3,24)    translation matrices (multan notation)
!      nsym           number of  independent symmetry operators
!      pts            number of lattice translations
!      ksys           ???
!      icent          c.s. / n.c.s  code
!      latt           lattice code
!      emme           ???
!      nsymTot        number of symmetry operators used by fourier
!      totop          number of symmetry operators (center and lattice incl.)
!--
            integer         :: ncentr, kpol
            integer         :: vpol(3)
            real            :: aaa(6)
!      ncentr         number of lattice translations
!      kpol           when /= 0, floating origin
!      vpol           when vpol(i) /= 0, floating origin alog i-th direction
!
      integer         :: jspini = -1
      real            :: ddmin = 0.6
      real, dimension(7,12) :: centrt=RESHAPE((/
!        P     A     B     C     I     F     R
     * .0000,.0000,.0000,.0000,.0000,.0000,.0000,
     * .0000,.0000,.0000,.0000,.0000,.0000,.0000,
     * .0000,.0000,.0000,.0000,.0000,.0000,.0000,
     * .0000,.0000,.5000,.5000,.5000,.0000,.6666,
     * .0000,.5000,.0000,.5000,.5000,.5000,.3333,
     * .0000,.5000,.5000,.0000,.5000,.5000,.3333,
     * .0000,.0000,.0000,.0000,.0000,.5000,.3333,
     * .0000,.0000,.0000,.0000,.0000,.0000,.6666,
     * .0000,.0000,.0000,.0000,.0000,.5000,.6666,
     * .0000,.0000,.0000,.0000,.0000,.5000,.0000,
     * .0000,.0000,.0000,.0000,.0000,.5000,.0000,
     * .0000,.0000,.0000,.0000,.0000,.0000,.0000/), (/7,12/))
*gl* * .0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000
*gl* *,.0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000
*gl* *,.0000,.5000,.5000,.5000,.5000,.6666,.0000,.5000,.0000,.5000,.5000
*gl* *,.5000,.3333,.0000,.5000,.5000,.0000,.5000,.0000,.3333,.0000,.0000
*gl* *,.0000,.0000,.0000,.0000,.3333,.0000,.0000,.0000,.0000,.0000,.5000
*gl* *,.6666,.0000,.0000,.0000,.0000,.0000,.5000,.6666,.0000,.0000,.0000
*gl* *,.0000,.0000,.5000,.0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000
*gl* *,.0000,.0000,.0000,.0000,.0000,.5000,.0000/), (/7,12/))

      integer, dimension(64) :: mpv=(/
     *        273,139537,140563, 65697, 16545,131857,135961,  2132,
     *      32852,  8977,  9498,  4875,  1290,  4362,  1291,  4378,
     *     131338,136458,   673,  8276, 43092, 82593,   140,    98,
     *      33890,  6284, 17506, 69772, 49250, 67724,139545,131859,
     *     140049,   785,   787, 17057, 66209,  8465,  8473, 41044,
     *      10324,131345,135450,132363,135434,132362,135947,140570,
     *       5386,   266, 82081, 34900,    84,   161, 71820, 50274,
     *      16482, 65676, 32866,  2188,  1122,  4236,  4889,  9491/)
      integer, dimension(32) :: indv=(/1,2,2,4,4,2,2,4,4,2,3,3,4,4,6,6,
     *                                 2,2,2,2,2,2,3,3,3,3,3,3,3,3,2,2/)
!-- common per la stampa della simmetria
      character(len=12), dimension(7) :: texc=(/
     *     'Triclinic   ','Monoclinic  ','Orthorhombic',
     *     'Tetragonal  ','Hexagonal   ','Cubic       ','Trigonal    '/)
      character(len=1), dimension(9) :: hbr=(/
     *                       'p','a','b','c','f','i','r','y',' '/)
      character(len=1), dimension(15)  :: hsymm=(/
     *     'm','a','b','c','n','d','-','0','1','2','3','4','5','6','/'/)
      character(len=2), dimension(42)  :: ntex=(/
     *     '  ', '  ', '  ', '  ', '  ', '  ', '+1', '/8', '+1',
     *     '/6', '  ', '  ', '+1', '/4', '  ', '  ', '+1', '/3',
     *     '+3', '/8', '  ', '  ', '  ', '  ', '+1', '/2', '  ',
     *     '  ', '  ', '  ', '  ', '  ', '+2', '/3', '  ', '  ',
     *     '+3', '/4', '  ', '  ', '+5', '/6'/)
      character(len=2), dimension(2,9)  :: teb=RESHAPE((/
     *     '  ','-z','  ','-y',' x','-y','  ','-x','  ','  ','  ',
     *     ' x',' y','-x','  ',' y','  ',' z'/),(/2,9/))
      character(len=2), dimension(3,11)  :: txa=RESHAPE((/
     *     ' 0',' 0',' 0',' g',' 0',' 0',' 0',' g',' 0',' 0',' 0',
     *     ' g',' 0',' g',' g',' g',' 0',' g',' g',' g',' 0',' g',
     *     ' g',' g',' h',' k',' 0',' h',' k',' g',' h',' k',' l'/),
     *     (/3,11/))
      character(len=2), dimension(5,7)  :: txb=RESHAPE((/
     *     '  ','  ','  ','  ','  ','h+','k=','2n','  ','  ','h+',
     *     'k+','l=','2n','  ','2h','+4','k+','g=','6n','2h','+k',
     *     '=3','n ','  ','h+','k+','l=','4n','  ','2h','+2','k+',
     *     'g=','4n'/),(/5,7/))
      character(len=55) :: NewSymmVet(52)
!
!--
!  condizioni sui limiti della unita' asimmetrica
!  vettori caricati da xfl14
!  xyz...(1,1)	     X(min)
!  xyz...(1,2)	     X(max)
!  xyz...(1,3)	     X(step)
!  xyz...(1,4)	     X(dimensione asse)
!  xyz...(2,1)	     Y(min)
!  xyz...(2,2)	     Y(max)
!  xyz...(2,3)	     Y(step)
!  xyz...(2,4)	     Y(dimensione asse)
!  xyz...(3,1)	     Z(min)
!  xyz...(3,2)	     Z(max)
!  xyz...(3,3)	     Z(step)
!  xyz...(3,4)	     Z(dimensione asse)
!  ncond.(1,1)	     numero condizioni su X(min) (max=4)
!  ncond.(1,2)	     numero condizioni su X(max)    "
!  ncond.(2,1)	     numero condizioni su Y(min)    "
!  ncond.(2,2)	     numero condizioni su Y(max)    "
!  ncond.(3,1)	     numero condizioni su Z(min)    "
!  ncond.(3,2)	     numero condizioni su Z(max)    "
!  xcond.(1,1,1,1:5) condizione 1a su X(min)
!  xcond.(1,1,2,1:5) condizione 2a su X(min)
!  xcond.(1,1,3,1:5) condizione 3a su X(min)
!  xcond.(1,1,4,1:5) condizione 4a su X(min)
!  xcond.(1,2,1,1:5) condizione 1a su X(max)
!  xcond.(1,2,2,1:5) condizione 2a su X(max)
!  xcond.(1,2,3,1:5) condizione 3a su X(max)
!  xcond.(1,2,4,1:5) condizione 4a su X(max)
!  xcond.(2,1,1,1:5) condizione 1a su Y(min)
!  xcond.(2,1,2,1:5) condizione 2a su Y(min)
!  xcond.(2,1,3,1:5) condizione 3a su Y(min)
!  xcond.(2,1,4,1:5) condizione 4a su Y(min)
!  xcond.(2,2,1,1:5) condizione 1a su Y(max)
!  xcond.(2,2,2,1:5) condizione 2a su Y(max)
!  xcond.(2,2,3,1:5) condizione 3a su Y(max)
!  xcond.(2,2,4,1:5) condizione 4a su Y(max)
!  xcond.(3,1,1,1:5) condizione 1a su Z(min)
!  xcond.(3,1,2,1:5) condizione 2a su Z(min)
!  xcond.(3,1,3,1:5) condizione 3a su Z(min)
!  xcond.(3,1,4,1:5) condizione 4a su Z(min)
!  xcond.(3,2,1,1:5) condizione 1a su Z(max)
!  xcond.(3,2,2,1:5) condizione 2a su Z(max)
!  xcond.(3,2,3,1:5) condizione 3a su Z(max)
!  xcond.(3,2,4,1:5) condizione 4a su Z(max)
!
            integer         :: ifR3Cheshire = 0
            integer         :: iorizfou, ivertfou,iorizpat, ivertpat
            integer         :: ncondfou(3,2)
            integer         :: ncondpat(3,2)
            integer         :: ncondMappa(3,2)
            integer         :: ncondche(3,2)
            real            :: xyzfou(3,4)
            real            :: xyzpat(3,4)
            real            :: xyzMappa(3,4)
            real            :: xcondfou(3,2,4,5)
            real            :: xcondpat(3,2,4,5)
            real            :: xcondMappa(3,2,4,5)
            real            :: xcondche(3,2,4,5)
            real            :: xlimSPGfou(3,2)
            real            :: xlimSPGpat(3,2)
      common /limfour/ xyzfou, ncondfou, xcondfou

!-- Allowed origins
            integer         :: OkOrig, nOrigRoxi, if3den
            real            :: tabo(32,3)
            real            :: xyzmax(3)
!--
            real            :: xyzEquiv(192,3)
            integer         :: nSymmStrings
            character (len=30) :: SymmStrings(192)
            character (len=80) , allocatable :: SymmCard(:)
            integer*8       :: ConvVett(192), ConvInp(192)
!
      END MODULE Symmetry
! ----------------------------------------------------------------------
      MODULE Properties

             type AtmProps
                integer            :: nSpecies
                integer            :: nat
                integer            :: z(18)
                integer            :: natsInCell(18)
                real               :: a(4,18)
                real               :: b(4,18)
                real               :: c(18)
                real               :: zeff(18)
                integer            :: ifMottFormula(18)
                real               :: radii(18,2)
                real               :: AtmW(18)
                real               :: fprimo(18,5)
                real               :: fsecondo(18,5)
                real               :: fmuro(18)
                real               :: BondTable(2,18,18)
                real               :: lambda
                integer            :: radiation
                character (len= 4) :: Species(18)
                character (len=12) :: NomeSpecie(18)
!
                integer            :: nkd
                integer            :: natd
                integer            :: nSpeciesd
                integer            :: atpos(18)
                integer            :: nalfd(18)
                integer            :: nanomv(18)
                integer            :: nwd(18)
                real               :: ffirst(18,5)
                real               :: fsecon(18,5)
             end type AtmProps

             type(AtmProps)        :: AtmProperties(0:5)

      END MODULE Properties
! ----------------------------------------------------------------------
      MODULE PhaseStuff
             integer, allocatable :: iph(:)
             integer, allocatable :: iet(:,:)
             integer, allocatable :: ieq(:,:)
             integer, allocatable :: imat(:,:)
             integer              :: numbTriplets
             integer              :: nFoms = 11
             integer              :: nReflInitialPhases
             integer              :: nsetInitialPhases = 0
             integer, allocatable :: puntatoreIP(:)
             real, allocatable    :: cfomIP(:)
             integer              :: nReflFinalPhases
             integer              :: nsetFinalPhases = 0
             integer, allocatable :: puntatoreFP(:)
             real, allocatable    :: cfomFP(:)

             type phases
                real, allocatable    :: foms(:)
                integer, allocatable :: wp(:)
                integer, allocatable :: iphaz(:)
                real, allocatable    :: wt(:)
                real, allocatable    :: fcalc(:)
             end type phases

             type(phases), allocatable :: initialPhases(:)
             type(phases), allocatable :: finalPhases(:)
      END MODULE PhaseStuff
! ----------------------------------------------------------------------
      MODULE WrReIn
             integer :: nrmax, ngt512, nnsig, nFoNeg, nFoZero
             integer :: nreflInp, nnpq, nSyst, neq, TotalAdded
             integer :: isigv(11,2), isigp(11,2), kSyst(11,5)
             integer :: ihmxAdd(3)
             real    :: rhm, rhn, resol, rfac1, aveInt
             real    :: sigv(11,4), resolAdd
      END MODULE WrReIn
! ----------------------------------------------------------------------
      MODULE Riflessi
             integer              :: numbSigma
             integer              :: ifHypercentr
             integer, allocatable :: CodeRefl(:)
             real, allocatable    :: epsv(:)
             real, allocatable    :: evet(:)
             real, allocatable    :: fcoef(:)
             real, allocatable    :: fcvet(:)
             real, allocatable    :: fovet(:)
             integer, allocatable :: iphaz(:)
             integer, allocatable :: iphazo(:)
             integer, allocatable :: ipub(:)
             integer, allocatable :: iwork1(:)
             integer, allocatable :: jwork1(:)
             integer, allocatable :: iwork2(:)
             integer, allocatable :: khl(:,:)
             integer, allocatable :: mkang(:)
             integer, allocatable :: mult(:)
             real, allocatable    :: rhov(:)
             real, allocatable    :: sigmav(:)
             real, allocatable    :: varia(:)
             real, allocatable    :: tmpwt(:)
             real, allocatable    :: work1(:)
             real, allocatable    :: work2(:)
             real, allocatable    :: worko(:)
             real, allocatable    :: wt(:)
             real, allocatable    :: wvar(:)
             real, allocatable    :: Dluz(:)
             real, allocatable    :: pesMod(:)
             integer, allocatable :: iworkt(:)
             real, allocatable    :: fovet_mod(:)   ! fo corretto
             real, allocatable    :: fovet2(:)      ! fo**2
             real, allocatable    :: sigmav2(:)     ! sigma(fo**2)
             integer              :: WhichFo
             integer              :: numbFo
             integer, allocatable :: iworkMod(:)
             integer, allocatable :: vettoreSigma(:)
             real, allocatable    :: tmp_ec(:)
!-- MAD o twinning
             real, allocatable    :: fDeriv(:,:)
             real, allocatable    :: sDeriv(:,:)
             real, allocatable    :: eDeriv(:,:)
             real, allocatable    :: fHeavy(:,:)
             real, allocatable    :: sHeavy(:,:)
             real, allocatable    :: eHeavy(:,:)
             real, allocatable    :: fNativ(:)
             real, allocatable    :: sNativ(:)
             real, allocatable    :: eNativ(:)
             integer, allocatable :: iorde(:)
!-- sirprot
             integer, allocatable :: jjhkl(:)
             real, allocatable    :: ecvet(:)
             real, allocatable    :: e1(:)
             real, allocatable    :: e2(:)
             real, allocatable    :: dreso(:)
             integer, allocatable :: inobs(:)
             real, allocatable    :: wtt1(:)
             integer, allocatable :: iphad(:)
             real, allocatable    :: wtd(:)
             integer, allocatable :: iphi2_in(:)
             real, allocatable    :: wtt_in(:)
             integer, allocatable :: iphi2_o(:)
             real, allocatable    :: wtt_o(:)
             integer, allocatable :: ifasi(:) ! x il starting set
             real, allocatable    :: pesi(:)  ! x il starting set
             real, allocatable    :: fmod(:)
             real, allocatable    :: emod(:)
             integer, allocatable :: iphimod(:)
             real, allocatable    :: free1(:)
             real, allocatable    :: free2(:)
             real, allocatable    :: rfree1(:)
             real, allocatable    :: jinc1(:)
             real, allocatable    :: ecoef(:)
             real, allocatable    :: sigfcoef(:)
             real, allocatable    :: SigmaaVal(:)
             real, allocatable    :: fper(:)
             integer, allocatable :: iphper(:)
             real, allocatable    :: foper(:)
             integer, allocatable :: iphoper(:)
             real, allocatable    :: alpha(:)
             real, allocatable    :: sigNa(:)
             real,    allocatable :: segni1(:)
             real,    allocatable :: segni(:,:)
             integer, allocatable :: iphazCO(:)
             integer, allocatable :: iconto(:)
             real,    allocatable :: mFoDFc(:)
             real,    allocatable :: twomFoDfc(:)
             integer, allocatable :: phimFoDFc(:)
             integer, allocatable :: phitwomFoDfc(:)
!-- RiflessiSigmaa
             real,    allocatable :: wto(:)    ! pesi ciclo precedente (sigmaA)
             integer, allocatable :: iphio(:)  ! fasi ciclo precedente (sigmaA)
             real,    allocatable :: wt_in(:)   ! peso iniziale
             integer, allocatable :: iphaz_in(:) ! fasi iniziali
!--ex Riflessi1
             real,    allocatable :: fcvetp(:) ! E stimati da Patt.
             real,    allocatable :: fcvetv(:) ! E veri
!--caso atomo pesante posizionato
             real,     allocatable :: sumffMod(:,:)
             real,     allocatable :: sumff (:) 
             real,     allocatable :: fc_burla (:) 
             real,     allocatable :: wt_burla (:) 
             integer,  allocatable :: iphaz_burla (:)
      END MODULE Riflessi
! ----------------------------------------------------------------------
      MODULE RiflessiInfo
             type reflectionsInfo
                integer :: nrefltot   ! No. riflessi totali (input+generati)
                integer :: nrefl      ! No. riflessi indipendenti in input
                integer :: nreflObs   ! No. riflessi osservati
                integer :: nonoss     ! No. riflessi non osservati
                integer :: nescl      ! No. riflessi esclusi
                real    :: cutoff
                integer :: nstr
                integer :: nstr_data
                integer :: nzro
                integer :: ihmx(1:3)
                integer :: ihmn(1:3)
                integer :: ilent
                integer :: ivelox
                integer :: ifPDBfiles
                integer :: knw
                real    :: bt
                real    :: sc
                real    :: s3s2
                integer :: nvsfc
                integer :: icdd
                real    :: deltahkl(1:3)
                real    :: rflsq
                real    :: rwflsq
                real    :: slsq
                real    :: btd(1:5)
                real    :: scd(1:5)
                real    :: s3s2d(1:5)
                integer :: ihmxExt(1:3)
                real    :: uvwt2(1:2)
                integer :: nsyn
                integer :: kequirip
                real    :: pfwhm
                integer :: QualeLista6
                real    :: shiftesd(1:2)
                real    :: rhodiff(1:3)
                integer :: ifo2
                integer :: npseud
                integer :: iyrandc
                real    :: fosog
                integer :: ksigma
                integer :: neutro
                integer :: lproj
                integer :: pack3
                integer :: pack2
                integer :: pack1
                integer :: pack5
                integer :: kWasReduced
                integer :: kmad
                real    :: s3s2mad
                real    :: resm
                integer :: numbGen
                integer :: ksize
                integer :: nds
                integer :: ianom
                integer :: jderi
                integer :: machkl
                integer :: ifRIP
                integer :: ifTwin
                real    :: gmaxX
                integer :: iprioroX
                integer :: ipriorpX
                integer :: ipriorsX
                integer :: ipriofrX
                integer :: ipriopaX
                integer :: iprefX
                integer :: jplaneX(1:3)
                integer :: icomatsavX
                integer :: ipdirsavX
                real    :: sh_su_max
                real    :: sh_su_mean
                real    :: diff_d_max
                real    :: diff_d_min
                real    :: diff_d_rms
                integer :: iprandomX
                integer :: iprandomaxX
                integer :: iyrand
                integer :: numbRiflInput
                real    :: erreInt
                real    :: resolutionMin
                real    :: resolutionMax
             end type reflectionsInfo

             type(reflectionsInfo)       :: refl_info

      END MODULE RiflessiInfo
! ----------------------------------------------------------------------
      MODULE RiflessiNew
             USE RiflessiInfo
             type reflections
!
                integer, allocatable :: hkl(:,:)
                real, allocatable    :: fo(:)
                real, allocatable    :: fosq(:)
                real, allocatable    :: sigma(:)
                real, allocatable    :: sigmasq(:)
                real, allocatable    :: e(:)
                real, allocatable    :: ep(:)
                real, allocatable    :: rho(:)
                real, allocatable    :: fc(:)
                real, allocatable    :: weight(:)
                integer, allocatable :: pub(:)
                integer, allocatable :: phase(:)
                integer, allocatable :: phasep(:)
                integer, allocatable :: code(:)
                integer, allocatable :: fmod(:)
                integer, allocatable :: observed(:)
!
                real, allocatable    :: fo_meno(:)
                real, allocatable    :: fo_piu(:)
                real, allocatable    :: sigma_meno(:)
                integer, allocatable :: phase_meno(:)
                real, allocatable    :: fc_meno(:)
!
                real, allocatable    :: fDeriv(:,:)
                real, allocatable    :: sDeriv(:,:)
                real, allocatable    :: eDeriv(:,:)
                real, allocatable    :: fHeavy(:,:)
                real, allocatable    :: sHeavy(:,:)
                real, allocatable    :: eHeavy(:,:)
                real, allocatable    :: fNativ(:)
                real, allocatable    :: sNativ(:)
                real, allocatable    :: eNativ(:)
!--expo
                real, allocatable    :: twotheta(:)
                real, allocatable    :: range(:)
!-- sirprot
                real, allocatable    :: freeflag(:)
                real, allocatable    :: epp(:,:)
                real, allocatable    :: fdelta(:,:)
                real, allocatable    :: deltaV(:,:)
                real, allocatable    :: deltaAv(:,:)
                real, allocatable    :: ed(:,:)
                real, allocatable    :: fod(:,:)
                real, allocatable    :: sigde(:,:)
                real, allocatable    :: sigfd(:,:)
                real, allocatable    :: epos(:,:)
                real, allocatable    :: eneg(:,:)
                real, allocatable    :: fpos(:,:)
                real, allocatable    :: fneg(:,:)
                real, allocatable    :: sigfpos(:,:)
                real, allocatable    :: sigfneg(:,:)
                real, allocatable    :: fodpos(:,:)
                real, allocatable    :: fodneg(:,:)
                real, allocatable    :: sigfdpos(:,:)
                real, allocatable    :: sigfdneg(:,:)
!-- MIR
                real, allocatable    :: epd(:,:)
                real, allocatable    :: fcH(:,:)
                real, allocatable    :: iphazH(:,:)
                real, allocatable    :: eH(:,:)
                real, allocatable    :: sighh(:,:)
                real, allocatable    :: fcHmu(:,:)
                real, allocatable    :: iphazHmu(:,:)
                real, allocatable    :: fdeltan(:,:)
                real, allocatable    :: fc1Hpos(:,:)
                real, allocatable    :: iphazHpos(:,:)
                real, allocatable    :: eHpos(:,:)
                real, allocatable    :: fc1Hneg(:,:)
                real, allocatable    :: iphazHneg(:,:)
                real, allocatable    :: eHneg(:,:)
                real, allocatable    :: FcH_prime(:,:)
                real, allocatable    :: iphazH_prime(:,:)
                real, allocatable    :: FcH_second(:,:)
                real, allocatable    :: iphazH_second(:,:)
                
             end type reflections

             type(reflections)       :: refl

      END MODULE RiflessiNew
! ----------------------------------------------------------------------
      subroutine AllocaRiflessiNew(iAction)
      USE General
      USE RiflessiNew
!
      implicit none
      integer :: iAction, ierv(100), ier, nD
!
      ierv(:) = 0
      if (iAction == 1) then
          if (.not.allocated(refl%hkl)) then
              allocate(refl%hkl(3,nreflDim)             , stat=ierv( 1))
              allocate(refl%fo(nreflDim)                , stat=ierv( 2))
              allocate(refl%fosq(nreflDim)              , stat=ierv( 3))
              allocate(refl%sigma(nreflDim)             , stat=ierv( 4))
              allocate(refl%sigmasq(nreflDim)           , stat=ierv( 5))
              allocate(refl%e(nreflDim)                 , stat=ierv( 6))
              allocate(refl%ep(nreflDim)                , stat=ierv( 7))
              allocate(refl%rho(nreflDim)               , stat=ierv( 9))
              allocate(refl%fc(nreflDim)                , stat=ierv(10))
              allocate(refl%weight(nreflDim)            , stat=ierv(11))
              allocate(refl%pub(nreflDim)               , stat=ierv(12))
              allocate(refl%phase(nreflDim)             , stat=ierv(13))
              allocate(refl%phasep(nreflDim)            , stat=ierv(14))
              allocate(refl%code(nreflDim)              , stat=ierv(15))
              allocate(refl%observed(nreflDim)          , stat=ierv(16))
              allocate(refl%fmod(nreflDim)              , stat=ierv(17))
!
              if (kmad /= 0) then
                  allocate(refl%fo_meno(nreflDim)       , stat=ierv(18))
                  allocate(refl%fo_piu(nreflDim)        , stat=ierv(19))
                  allocate(refl%sigma_meno(nreflDim)    , stat=ierv(20))
                  allocate(refl%phase_meno(nreflDim)    , stat=ierv(21))
                  allocate(refl%fc_meno(nreflDim)       , stat=ierv(22))
              endif
              if (kmad == 2 .or. ifTwin == 1) then
                  nD = nDataSets
                  allocate(refl%fDeriv(nreflDim,nD)    ,stat = ierv(23))
                  allocate(refl%sDeriv(nreflDim,nD)    ,stat = ierv(24))
                  allocate(refl%eDeriv(nreflDim,nD)    ,stat = ierv(25))
                  allocate(refl%fHeavy(nreflDim,nD)    ,stat = ierv(26))
                  allocate(refl%sHeavy(nreflDim,nD)    ,stat = ierv(27))
                  allocate(refl%eHeavy(nreflDim,nD)    ,stat = ierv(28))
                  allocate(refl%fNativ(nreflDim)       ,stat = ierv(29))
                  allocate(refl%sNativ(nreflDim)       ,stat = ierv(30))
                  allocate(refl%eNativ(nreflDim)       ,stat = ierv(31))
              endif
              if (QualePgm == SIRPROTPGM) then
                  allocate(refl%freeflag(nreflDim)     ,stat = ierv(32))
              endif
          endif
!
          ier = sum(iabs(ierv(:)))
          if (ier /= 0) then
              write(*,*) 'RiflessiNew Allocation Error'
              call cstop(' ')
           endif
!
           refl%hkl(:,:)   = 0 ;  refl%fo(:)      = 0
           refl%fosq(:)    = 0 ;  refl%sigma(:)   = 0
           refl%sigmasq(:) = 0 ;  refl%e(:)       = 0
           refl%ep(:)      = 0 ;  refl%fmod(:)    = 0
           refl%rho(:)     = 0 ;  refl%fc(:)      = 0
           refl%weight(:)  = 0 ;  refl%pub(:)     = 0
           refl%phase(:)   = 0 ;  refl%phasep(:)  = 0
           refl%code(:)    = 0 ;  refl%observed(:)= 0
           if (QualePgm == SIRPROTPGM) then
               refl%freeflag(:)= 0
           endif
!
           if (kmad /= 0) then
               refl%fo_meno(:)    = 0 ;  refl%fo_piu(:)     = 0
               refl%sigma_meno(:) = 0 ;  refl%phase_meno(:) = 0
               refl%fc_meno(:)    = 0
           endif
           if (kmad == 2 .or. ifTwin == 1) then
               refl%fDeriv(:,:) = 0 ; refl%sDeriv(:,:) = 0 
               refl%eDeriv(:,:) = 0 ; refl%fHeavy(:,:) = 0
               refl%sHeavy(:,:) = 0 ; refl%eHeavy(:,:) = 0
               refl%fNativ(:)   = 0 ; refl%sNativ(:)   = 0 
               refl%eNativ(:)   = 0
           endif
      else
           if (allocated(refl%hkl)) then
               deallocate(refl%hkl            , stat=ierv( 1))
               deallocate(refl%fo             , stat=ierv( 2))
               deallocate(refl%fosq           , stat=ierv( 3))
               deallocate(refl%sigma          , stat=ierv( 4))
               deallocate(refl%sigmasq        , stat=ierv( 5))
               deallocate(refl%e              , stat=ierv( 6))
               deallocate(refl%ep             , stat=ierv( 7))
               deallocate(refl%rho            , stat=ierv( 9))
               deallocate(refl%fc             , stat=ierv(10))
               deallocate(refl%weight         , stat=ierv(11))
               deallocate(refl%pub            , stat=ierv(12))
               deallocate(refl%phase          , stat=ierv(13))
               deallocate(refl%phasep         , stat=ierv(14))
               deallocate(refl%code           , stat=ierv(15))
               deallocate(refl%observed       , stat=ierv(16))
               deallocate(refl%fmod           , stat=ierv(17))
!
               if (kmad /= 0) then
                   deallocate(refl%fo_meno    , stat=ierv(18))
                   deallocate(refl%fo_piu     , stat=ierv(19))
                   deallocate(refl%sigma_meno , stat=ierv(20))
                   deallocate(refl%phase_meno , stat=ierv(21))
                   deallocate(refl%fc_meno    , stat=ierv(22))
               endif
               if (kmad == 2 .or. ifTwin == 1) then
                   deallocate(refl%fDeriv     ,stat = ierv(23))
                   deallocate(refl%sDeriv     ,stat = ierv(24))
                   deallocate(refl%eDeriv     ,stat = ierv(25))
                   deallocate(refl%fHeavy     ,stat = ierv(26))
                   deallocate(refl%sHeavy     ,stat = ierv(27))
                   deallocate(refl%eHeavy     ,stat = ierv(28))
                   deallocate(refl%fNativ     ,stat = ierv(29))
                   deallocate(refl%sNativ     ,stat = ierv(30))
                   deallocate(refl%eNativ     ,stat = ierv(31))
               endif
               if (QualePgm == SIRPROTPGM) then
                   deallocate(refl%freeflag   ,stat = ierv(32))
               endif
           endif
           ier = sum(iabs(ierv(:)))
           if (ier /= 0) then
               write(*,*) 'RiflessiNew DeAllocation Error'
               call cstop(' ')
           endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      MODULE TempMat
             integer, allocatable :: mat(:,:)
      END MODULE TempMat
! ----------------------------------------------------------------------
*     MODULE Liste
!        volutamente vuoto, da eliminare in seguito assieme a ListeOld
*     END MODULE Liste
! ----------------------------------------------------------------------
      MODULE ListeOld
!
c--list 1 : parametri della cella
      integer l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g
      real gg,gr
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
c--list 2 : gruppo spaziale
      integer ic,il,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     * l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,noric
      real g2
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     * l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,noric
c--list 3 : contenuto cella
      real sys03
      integer l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
c--list 4 : schema di pesaggio
      integer iw4,l4,m4,n4,l4s,l4d,n4d
      common/lst04/iw4,l4,m4,n4,l4s,l4d,n4d
c--list 5 : parametri atomici
      integer l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz,l5c
      real xMatTwin(3,3)
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz,l5c, xMatTwin
c--list 12 : condizioni per l'affinamento least squares
      integer l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2  n12c,md12b,iover12,igroup,jfirst12,irotam
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(5),igroup,jfirst12,irotam
c--list 13 : groups
      integer l13,m13,md13,n13,l13a,m13a,md13a,n13a,md13b,
     2	md13h,md13o,md13flag,l13g,n13g
      real sys13
      common/lst13/l13,m13,md13,n13,l13a,m13a,md13a,n13a,md13b,
     2	md13h,md13o,md13flag,l13g,n13g,sys13
c--list 14 : limiti mappe di fourier
      integer l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f
      real sys14
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
c--list 15 : picchi localizzati da mappe
      integer l15,m15,md15,n15,l15aa,m15a,md15a,n15a
      common/lst15/ l15,m15,md15,n15,l15aa,m15a,md15a,n15a
c--list 16 : set di fasi da M.D.
      integer l16,ld16p,m16,m16d,md16d,n16,n16p,l16p,n16r,
     1 l16a,l16k,n16k,numb16
      common/lst16/l16,ld16p,m16,m16d,md16d,n16,n16p,l16p,n16r,
     1 l16a,l16k,n16k,numb16
c--list 17 : set di fasi estese dal Direct Space Refinement.
      integer l17,ld17p,m17,m17d,md17d,n17,n17p,l17p,
     1 l17a,l17k,n17k,numb17
      common/lst17/l17,ld17p,m17,m17d,md17d,n17,n17p,l17p,
     1 l17a,l17k,n17k,numb17
c--list 18 : limiti min&max dati sperimentali
      integer l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d,nrif18,lrif18,mrif18,ncla18,lcla18
      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d,nrif18,lrif18,mrif18,ncla18,lcla18
c--list 22 : indirizzi assoluti in store per least squares (run time)
      integer l22,m22,md22,n22,l22a,m22a,md22a,n22a,n22x,n22y,n22z,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22,iadov22,igroup22,irotam22
      common/lst22/l22,m22,md22,n22,l22a,m22a,md22a,n22a,n22x,n22y,n22z,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(5),iadov22(5),igroup22,irotam22
c--list 26 : rotamer (su disco No=26, in common No=126)
      integer l126,m126,md126,n126,l126a,m126a,md126a,n126a,md126b,
     2	md126h,md126o,md126flag,l126g,n126g
      real sys126
      common/lst126/l126,m126,md126,n126,l126a,m126a,md126a,n126a,
     2	md126b,md126h,md126o,md126flag,l126g,n126g,sys126    
c--list sperimental conditions for CIF file
      integer l29,m29,md29,n29,l29d,n29d,
     1 noce,nstand,ncountCIF,istand,ntotale
      real ceth,size,tmnx,averr,uneti
      real stor29(31)
      equivalence (stor29,noce)
      common/lst29/ l29,m29,md29,n29,l29d,n29d,
     1 noce,ceth(2),size(3),tmnx(2),nstand,ncountCIF,istand(3,6),
     2 ntotale,averr,uneti
c--list 33 : profile in Rietveld procedure (Expo)
      integer nlung33(10)
c--list 34 : NEW LIST matrice informazioni
      integer l34,m34,md34,n34,l34d,n34d,n34a
      real stor34
      common/lst34/ l34,m34,md34,n34,l34d,n34d,n34a,
     1	stor34(10,500)
c--list 35 : parametri atomici (lista di appoggio SAVE/RESTORE)
      integer l35,m35,md35,n35,l35o,m35o,md35o,n35o
     2 ,n35g,l35d,n35d
      common/lst35/l35,m35,md35,n35,l35o,m35o,md35o,n35o
     2 ,n35g,l35d,n35d
c--list 36 : condizioni affinamento (lista di appoggio SAVE/RESTORE)
      integer l36,m36,md36,n36,nbl36,jdra,jdrb,l36d,n36d,
     2	n36c,md36b,iover36
      common/lst36/l36,m36,md36,n36,nbl36,jdra,jdrb,l36d,n36d,
     2	n36c,md36b,iover36(5)
c--list 37 : Profile counts (Expo)
      integer l37,l37a,l37d,ld37p,m37,m37dk,n37dk,md37d,n37d,n37,
     *n37p,l37rs,l37rk,l37in,l37p
      common/lst37/l37,l37a,l37d,ld37p,m37,m37dk,n37dk,md37d,n37d,n37,
     *n37p,l37rs,l37rk,l37in,l37p
c--list 38 : NEW LIST MAD/SAD information 
      integer l38,m38,md38,n38,l38d,n38d,n38a
      common/lst38/ l38,m38,md38,n38,l38d,n38d,n38a
c--indirizzi in store list like
c--list 25, 26, 27 : liste temporanee per calcoli geometrici
      integer l25,m25,md25,n25,l26,m26,md26,n26,
     1 l27,m27,md27,n27,l27a,l27b,n27b
      common/lst25/l25,m25,md25,n25
      common/lst26/l26,m26,md26,n26
      common/lst27/ l27,m27,md27,n27,l27a,l27b,n27b
c--list 45 : parametri atomici da modello pubblicato
      integer l45,m45,md45,n45,n45d,l45d
*     common/lst35/l45,m45,md45,n45,n45d,l45d
c--list 50      
      integer l50,m50,md50,n50
      common/lst50/l50,m50,md50,n50
c--list 55 : parametri gruppo (corpo rigido) run time
      integer l55,m55,md55,n55,md55b,md55flag,
     2 l55d,n55d,md55h,md55xyz,md55angle,md55der,md55loca,md55fin
      common/lst55/l55,m55,md55,n55,md55b,md55flag,
     2 l55d,n55d,md55h,md55xyz,md55angle,md55der,md55loca,md55fin
c--list 56 : parametri rotamero  run time
      integer l56,m56,md56,n56,md56b,md56flag,
     2 l56d,n56d,md56h,md56xyz,md56angle,md56der,md56loca,md56fin
      common/lst56/l56,m56,md56,n56,md56b,md56flag,
     2 l56d,n56d,md56h,md56xyz,md56angle,md56der,md56loca,md56fin
c--indirizzi del vettore matrice equazioni normali per least squares
      integer l11r,m11r,md11r,n11r,l11s,m11s,md11s,n11s,nfld,lfld,nld
      common /xlst11/ l11r,m11r,md11r,n11r,l11s,m11s,md11s,n11s
      common /xlim11/ nfld,lfld,nld
c--indirizzi in store di appoggio per liste temporanee
      integer lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c--strings
      character carctr*256, ifmt*80
      common /cfile/ carctr,ifmt
!
      END MODULE ListeOld
! ----------------------------------------------------------------------
      MODULE Plotter
!
!--vettori dinamici per plotter------------------------------
             integer                 :: natsPlo
             integer, allocatable    :: AdrPloto5(:)
             character(len=16) , allocatable :: aLabPlo(:)
             real, allocatable       :: xyzsPlo(:,:)
             real, allocatable       :: bijPlo(:,:)
             real, allocatable       :: bfacPlo(:)

             real, allocatable       :: xyzsPloCopia(:,:)
             real, allocatable       :: bijPloCopia(:,:)
             real, allocatable       :: bfacPloCopia(:)
!--
             real,     allocatable   :: ParamEll(:,:)
             real,     allocatable   :: ParamEllabc(:,:,:)
             integer,  allocatable   :: BondAB(:,:)
             real,     allocatable   :: ABaseBond(:,:,:)
             real,     allocatable   :: BBaseBond(:,:,:)
!-----------------------------------------------------------
!--vettore per memorizzare le interruzioni
!  allocato a un valore prefissato (ipotetico...)
             real,     allocatable   :: Finter(:)
             integer :: nFloc
!
!--include file for plot common
!
      integer istroke, jcolore
      real xplo2, yplo2, p2x, p2y, scax, scay
!
!--the values are referred to the origin points (cm, pixel)
      real  :: xplo1 = 0.0
      real  :: yplo1 = 0.0
      real  :: p1x = 0.0
      real  :: p1y = 0.0
!--the values are referred to HP 7550 PLUS
      real  :: xplo2p = 27.175
      real  :: yplo2p = 19.000
      real  :: p2xp = 10870.0
      real  :: p2yp = 7600.0
!--the values are referred ro the screen (480x640) (640/480=1.33333)
!                                                  (24.0/18.0=1.33333)
      real  :: xplo2s = 24.0
      real  :: yplo2s = 18.0
      real  :: p2xs = 640.0
      real  :: p2ys = 480.0
!--the values are referred to A4 page for PostScript printer (210x297)
!  reduced by 20 mm
      real  :: xplo2a = 27.7
      real  :: yplo2a = 19.0
      real  :: p2xa = 277.0
      real  :: p2ya = 190.0
!
      integer :: iqplot = 0
      integer :: icolore = 63
      integer :: itrmn = 3
      integer :: iscreen = 1
      real, dimension(1) :: h=(/0.2/)
      real, dimension(1) :: r=(/0.5/)
!--
      integer ilbl(17)
      real scadis
!--      
      common /gian/ NNLeg, LEdum(2,9800)
!--
      integer iro(4), limit1, limit2
      real gdd(3,3),vd,grr(3,3),vr,bij_single(3,3),tinv(3,3),
     2 t(3,3),rotx(3,3),roty(3,3),rotz(3,3),rotv(3,3),ro(4),co(3),
     3 ur(3),sk(1),dk(1),skn,dkn,skdk,zmax,add,
     4 epst,epsa,xrm,bomax,disPlot(2),dvd,tm(3,3),rr(9),tr(3)

!--
      integer jdim, nn1, nn2, nn3, nn4, nn5, nn6, nn7, nn8,
     2 nbon, nst, iline, istep, lcom1, ielem, kstep, nind, mind,
     3 ivett, intl, icost(130)
      real zero, sbn(50), eps0
!-- hydrogen bond
      integer jhydro, nCoppieHBond, ifDashed
!
      END MODULE Plotter
! ----------------------------------------------------------------------
      MODULE ZMatrix
!
!-- Z-Matrix variables
!
      integer                            :: nzm
      integer, dimension(500)            :: iesz, ispefra, iloc, jserZ
      integer, dimension(3,500)          :: nloc
      real                               :: thetas, phis, psis
      real, dimension(3)                 :: xor, x_orig
      real, dimension(3,3)               :: t_ortho, t_cryst
      real, dimension(3,500)             :: xloc, xortolocal
      real, dimension(500)               :: bisoZ, occZ
      character (len= 16), dimension(500) :: atfra
      character (len=20)                 :: namefra
!
      END MODULE ZMatrix
! ----------------------------------------------------------------------
      MODULE Grafici
             real,       allocatable :: xpoints(:,:)
             real,       allocatable :: ypoints(:,:)
             integer,    allocatable :: nClust(:)    !pgMAD1512
             real,       allocatable :: MinMaxGR(:,:)
             integer,    allocatable :: lPlots(:)
             integer,    allocatable :: colorGR(:,:)
             character(len=4), allocatable :: LabTrialsV(:)
             character(len=80)       :: MsgGraficiGR(3)
             character(len=80)       :: NomePng
             integer                 :: ivBest(3)    !pgMAD1512
             integer                 :: tipoGraficiGR(3)
             integer                 :: nPointsGR
             integer                 :: nGraficiGR
             integer                 :: nMaxSolutionsGR
             integer                 :: kLarg
             integer                 :: kAlt
             integer                 :: HistoBack
             integer                 :: HistoOK(3)
             real                    :: xHisto(2,3)
             real                    :: yHisto(2,3)
             real                    :: xHistF(2,3)
             real                    :: yHistF(2,3)
             real                    :: headGR(4,2)
             real                    :: QualeTic(3)
             integer                 :: LabTrials
             character(len=50)       :: StringGR(3,2)
             character(len=100)      :: LegendGR(3)
             character(len=100)      :: headersGR(2)
             character(len=256)      :: cardGR(50)
             integer                 :: WhichBoxGR(50)
             integer                 :: lastBox
             real                    :: stepGR, stepGR0, stepGRi
             real                    :: xpb1, xpb2, ypb1, ypb2
             integer                 :: inBoxGR(5), nLinesGR,
     *                                  nLinesGRsaveBox(5),nLinesGRTrial
             integer                 :: nLinesGR_Amb, Box_Amb
             integer                 :: inBoxGR_Amb, nLinesGR_Wr_Amb
             integer                 :: sizeLinesGR(50)
             integer                 :: colorLinesGR(50)
             integer                 :: LeftBox, RightBox, nLinesGRSav
             real                    :: sinistra
             logical                 :: first_write_Amb = .true.
             logical                 :: ifDrawGR
             logical                 :: NewPoint = .true.
             logical                 :: ifPlotGR = .false.
             integer                 :: PlotGR_x,PlotGR_y
             integer                 :: PlotGR_w,PlotGR_h
             logical                 :: preRemo = .false.
      END MODULE Grafici
!-----------------------------------------------------------------------
      MODULE CaratteriSpeciali
!
              integer         ::  SpecCode( 60)
!
      END MODULE CaratteriSPeciali
! ----------------------------------------------------------------------
      SUBROUTINE FillCaratteriSPeciali()
      USE CaratteriSpeciali
!
!-- Definitions in gdkkeysyms.h
!
             SpecCode( :) = 0

             SpecCode(  1) = 1985  !  SPC_ALPHA =   A
             SpecCode(  2) = 1986  !  SPC_BETA =    B
             SpecCode(  3) = 2007  !  SPC_CHI =     C
             SpecCode(  4) = 1988  !  SPC_DELTA =   D
             SpecCode(  5) = 1989  !  SPC_EPSILON = E
             SpecCode(  6) = 2006  !  SPC_PHI =     F
             SpecCode(  7) = 1987  !  SPC_GAMMA =   G
             SpecCode(  8) = 1991  !  SPC_ETA =     H
             SpecCode(  9) = 1993  !  SPC_IOTA =    I
             SpecCode( 10) = 1993  !  DUMMY    =    J
             SpecCode( 11) = 1994  !  SPC_KAPPA =   K
             SpecCode( 12) = 1995  !  SPC_LAMDA =   L
             SpecCode( 13) = 1996  !  SPC_MU =      M
             SpecCode( 14) = 1997  !  SPC_NU =      N 
             SpecCode( 15) = 1999  !  SPC_OMICRON = O
             SpecCode( 16) = 2000  !  SPC_PI =      P
             SpecCode( 17) = 1992  !  SPC_THETA =   Q
             SpecCode( 18) = 2001  !  SPC_RHO =     R
             SpecCode( 19) = 2002  !  SPC_SIGMA =   S
             SpecCode( 20) = 2004  !  SPC_TAU =     T
             SpecCode( 21) = 2005  !  SPC_UPSILON = U
             SpecCode( 22) = 1997  !  DUMMY     =   V
             SpecCode( 23) = 2009  !  SPC_OMEGA =   W
             SpecCode( 24) = 1998  !  SPC_XI =      X
             SpecCode( 25) = 2008  !  SPC_PSI =     Y
             SpecCode( 26) = 1990  !  SPC_ZETA =    Z

             SpecCode( 33) = 2017  !  SP_alpha =    a
             SpecCode( 34) = 2018  !  SP_beta =     b
             SpecCode( 35) = 2039  !  SP_chi =      c
             SpecCode( 36) = 2020  !  SP_delta =    d
             SpecCode( 37) = 2021  !  SP_epsilon =  e
             SpecCode( 38) = 2038  !  SP_phi =      f
             SpecCode( 39) = 2019  !  SP_gamma =    g
             SpecCode( 40) = 2023  !  SP_eta =      h
             SpecCode( 41) = 2025  !  SP_iota =     i
             SpecCode( 42) = 2025  !  DUMMY    =    j
             SpecCode( 43) = 2026  !  SP_kappa =    k
             SpecCode( 44) = 2027  !  SP_lamda =    l
             SpecCode( 45) = 2028  !  SP_mu =       m
             SpecCode( 46) = 2029  !  SP_nu =       n
             SpecCode( 47) = 2031  !  SP_omicron =  o
             SpecCode( 48) = 2032  !  SP_pi =       p
             SpecCode( 49) = 2024  !  SP_theta =    q
             SpecCode( 50) = 2033  !  SP_rho =      r
             SpecCode( 51) = 2034  !  SP_sigma =    s
             SpecCode( 52) = 2036  !  SP_tau =      t
             SpecCode( 53) = 2037  !  SP_upsilon =  u
             SpecCode( 54) = 2029  !  dummy    =    v
             SpecCode( 55) = 2041  !  SP_omega =    w
             SpecCode( 56) = 2030  !  SP_xi =       x
             SpecCode( 57) = 2040  !  SP_psi =      y
             SpecCode( 58) = 2022  !  SP_zeta =     z
             SpecCode( 59) =  197  !  SP_Aring  = Angstrom
!
      return
      end
! ----------------------------------------------------------------------
      MODULE Param
!
      ! for Flex input
      real        ::   f000, scale1, v_s, v_p, v_m, pv_p, volumeTemp,
     +                 Renve,stepE,sogrho,elimhe,solc,Xflip,
     +                 sogDEflex1,sogsigFlex,vp0_init,
     +                 gammav,frpr,frsr,frpx,frpy,frpz,frsx,frsy,frsz
      integer     ::   nnobs,isuper1,ifromExt,
     +                 jnobs,isfhm,icomb,
     +                 jrecom,ilistFlex,ifree,
     +                 jsigmaa,jgamma,isuperNew,ifreweight,
     +                 ifextref,ifsolv,if2fofc,ifreem,
     +                 ifconv,ifExtra,ihism,ifEDM,iflat

      ! flex results
      real        :: corr,corre,errm1,errmw1,errm12,
     *               errinv,errinvp,Rtot,rfree,RAT,RAT1,
     *               corrDeboli1,corrForti1,
     *               cfom_FLEX,corrFoFc,
     *               RATMax,RtotMin,rfreeMin,corrMax,corrMin,
     *               realfreeR2,realfreeR4,Rsir,Rsir_p

      integer        :: nref1,nref12,icycl,nsetTotal
      real, dimension(200)   :: realr,xtrialPhase,cfomPhase

      ! map
      real         :: den_p, den_s, perc, den_m, den_n, denmin, denmax
      integer      :: n_p, n_s
      real         :: CoefSigma_p, CoefSigma_n, SogSigma_p, SogSigma_n
      real         :: avden, stden
      real         :: depr, rmsp, deso, rmss
      integer      :: irecom, nresll, nrange   ! nresll == nresl
c     integer      :: nhist = 100
c     real, dimension(50)     :: vresl, vrmin, vrmax, vrave, vrstd
      real, dimension(501)    :: range, hisp, dip, range1, hisp1, dip1
c     real, dimension(200,50) :: hdata
      ! soglie per cut-off fase/peso per il flex-edm
      real           :: sogres,sogw,sogres2,soge

      Integer        ::  ifPDBheavy
!
      END MODULE Param
! ----------------------------------------------------------------------
      MODULE Groups
!
! - nResid               numero di residui memorizzati nel file .gru in uso
! - nResidStored         numero totale di residui nella sequenza
! - AminoContent(i,1:4)  numero di C,N,O,S del residuo i-esimo
! - ResidCoords(i,1:3,j) coordinate del residuo i-esimo, atomo j-esimo (usate nel C)
! - ResidConn(i,1:2,j)   connettivita' del residuo i-esimo, legame j-esimo  (usate nel C)
! - AminoName(i)         Nome (max 4 caratteri) del residuo i-esimo (i.e. ALA)
! - AminoNameLong(i)     Nome completo del residuo i-esimo (i.e. Alanine)
! - ResidAtoms(i,1:2,j)  label e specie del residuo i-esimo, atomo j-esimo
! - ResidTable1(i,1:2)   numero di atomi, codice ascii del nome del residuo i-esimo
!   ResidTable1(i,3:5)   No. d'ordine del CA (o =0), No. torsion-flexible ,
!                        No. di configurazioni  
! - ResidTable2(i,1:7,j) condizioni geometriche del residuo i-esimo, atomo j-esimo
! - ResidRotamers(i,j,1:5) valori angoli di torsione (Rotamers)(max=5) del residuo
!                          i-esimo della configurazione j-esima
!
*      real           :: ResidCoords(22,3,15)
*      integer        :: ResidConn(22,2,16)
*      common /ResidCo/ ResidCoords, ResidConn

      integer        :: ifGroupsAllocated 
      integer        :: ifRotamersAllocated
      integer        :: nResid, nAcid, nResTot, nResidStored
      integer        :: MaxAtomsInGroups 
      integer        :: nChains               ! Number of chains
      integer        :: nChainsInput          ! Number of chains (to save value)
      integer        :: nValidChains          ! Number of chains for PIR
      integer        :: cChains(100)          ! Chains ID
      integer        :: tChains(100)          ! Chain type (res. or nucl. acids)
      integer        :: ResInChains(100)      ! Number of res. in i-th chain
      integer        :: Sequence(5000)
      integer        :: nMonomer = 1          ! Number of monomers in Remo
      character(len=256) :: SeqFile

      integer, allocatable            :: nitro(:)
      integer, allocatable            :: ResidConn(:,:,:)
      integer, allocatable            :: ResidTable1(:,:)
      real, allocatable               :: ResidCoords(:,:,:)
      real, allocatable               :: ResidTable2(:,:,:)
      integer, allocatable            :: AminoContent(:,:)
      real, allocatable               :: ResidRotamers(:,:,:)
      character(len=3), allocatable   :: ResidAtoms(:,:,:)
      character(len=4), allocatable   :: AminoName(:)
      character(len=20), allocatable  :: AminoNameLong(:)
      character(len=3), dimension(40) :: TipoAtomo = (/
!        1      2      3      4      5      6      7      8      9
     * 'C  ', 'CA ', 'CB ', 'CD ', 'CD1', 'CD2', 'CE ', 'CE1', 'CE2',
!
!       10     11     12     13     14     15     16     17     18
     * 'CE3', 'CG ', 'CG1', 'CG2', 'CH2', 'CZ ', 'CZ2', 'Cz3', 'N  ',
!
!       19     20     21     22     23     24     25     26     27
     * 'ND1', 'ND2', 'NE ', 'NE1', 'NE2', 'NH1', 'NH2', 'NZ ', 'O  ',
!
!       28     29     30     31     32     33     34     35     36
     * 'OD1', 'OD2', 'OE1', 'OE2', 'OG ', 'OG1', 'OH ', 'SD ', 'SE ',
!
!       37     38     39     40
     * 'SG ', '   ', '   ','DUM'/)
!
      character(len=22)               :: AminoCodes = 
     *                                        'ARNDCQEGHILKM0FPSTWYVU'
      integer, dimension(21)          :: AminoCode = (/
!        A   R   N   D   C   Q   E   G   H   I   L
     *  65, 82, 78, 68, 67, 81, 69, 71, 72, 73, 76,
!
!        K   M   0   F   P   S   T   W   Y   V'
     *  75, 77, 48, 70, 80, 83, 84, 87, 89, 86 /)
!
      character(len=3), dimension(22) :: AminoName3 = (/
     *  'ALA', 'ARG', 'ASN', 'ASP', 'CYS', 'GLN', 'GLU', 'GLY',
     *  'HIS', 'ILE', 'LEU', 'LYS', 'MET', 'MSE', 'PHE', 'PRO',
     *  'SER', 'THR', 'TRP', 'TYR', 'VAL', 'DUM'/)
!
      END MODULE Groups
! ----------------------------------------------------------------------
      MODULE Html
!
            character(len=60)  :: HTMLdate, HTMLname, HTMLend, HTMLcpu
            character(len=256) :: HTMLstr
!
      END MODULE Html
! ----------------------------------------------------------------------
      MODULE Dialogo


            integer         :: STICKS, RODS, SIMPLE, STICKS_N_BALLS
            integer         :: BUBBLES, SHADING, VAN_DER_WAALS
            integer         :: ELLIPSOIDS
!
            integer         :: color_BLACK, color_BLUE, color_GREEN
            integer         :: color_CYAN, color_RED, color_MAGENTA
            integer         :: color_BROWN, color_WHITE, color_GRAY
            integer         :: color_LIGHTBLUE, color_LIGHTGREEN
            integer         :: color_LIGHTCYAN, color_LIGHTRED
            integer         :: color_LIGHTMAGENTA, color_YELLOW
            integer         :: color_BRIGHTWHITE
            integer         :: color_GHOST, color_BONDS, color_LABS
            integer         :: color_CELL, color_RESTR
            integer         :: viewerOpened
!
            integer         :: NatMol,ifBrekke,ixBr,iyBr, iRotSpeed
            integer         :: ifBestVisual, jBackGround
            integer         :: icoWire, ifLabels
            integer         :: ifCell,ifNoDraw, N_OBJS, NToAdd
            integer         :: nRadType, kptrc, lProgName, lPkgName 
            integer         :: ifGTK, ifCentro, ifGS_P1, ifMadEnv, Madx
            integer         :: Mady, QualeAbilita, ifCellOnly
            integer         :: ifCont, ifPDBcoded, ifSkeletonOn
            integer         :: ifRemoG, MaxAtomsInGr, ifIsOver
            integer         :: ifFour, nAided, jAided, kktest
            integer         :: ifDrawGroups
            integer         :: ilMilione, SirProtError, ModelToCompare
            integer         :: iPlotType = 0
            real            :: ViewDist, RaggioSfera, ProbF
            integer         :: JAV_VIEWER = 0
            integer         :: NOCFG = 0        !!22/07/2016
            character(len=256)   :: ProgName
            character(len=256)   :: PkgName
            character(len=256)   :: FileNameMod
            character(len=6)     :: input_ext
            character(len=60)    :: SmallIt(24)
            character(len=6)     :: Version
!
      common /Dialogo_c_f/ NatMol, ifBrekke,ixBr, iyBr, iRotSpeed,
     *          ifBestVisual, jBackGround, icoWire, 
     *          ifLabels, ifCell, ifNoDraw, nToAdd, 
     *          iPlotType, N_OBJS, ifFour, ViewDist,  RaggioSfera,
     *          STICKS, RODS, SIMPLE, STICKS_N_BALLS, BUBBLES,
     *          SHADING, VAN_DER_WAALS, ELLIPSOIDS, 
     *          nAided, jAided(100), kktest,
     *          color_BLACK, color_BLUE,color_GREEN, color_CYAN,
     *          color_RED, color_MAGENTA, color_BROWN, color_WHITE, 
     *          color_GRAY, color_LIGHTBLUE, color_LIGHTGREEN, 
     *          color_LIGHTCYAN, color_LIGHTRED, color_LIGHTMAGENTA, 
     *          color_YELLOW, color_BRIGHTWHITE, color_GHOST, 
     *          color_BONDS, color_LABS, color_CELL, color_RESTR,  
     *          nRadType, ProbF,
     *          kptrc(1000), ProgName, lProgName, ifGTK, ifCentro,
     *          ifGS_P1, ifMadEnv, Madx, Mady, QualeAbilita, ifCellOnly,
     *          ifCont, ifPDBcoded, ifSkeletonOn, ifRemoG, MaxAtomsInGr,
     *          ifIsOver, viewerOpened, ifDrawGroups, ilMilione, 
     *          SirProtError,
!!22/07/2016     *          ModelToCompare, lPkgName, JAV_VIEWER, input_ext,
     *          ModelToCompare, lPkgName, JAV_VIEWER, NOCFG, input_ext,
!!END 22/07/2016
     *          SmallIt, PkgName, Version, FileNameMod
!
!--copia del common della grafica di LSQ per interfaccia GTK
!
      character*8 AtomsGTK
      integer :: ifCubo, ixCubo, iyCubo
      real    :: latoCubo, xyzCubo
      common /lsqGTK/ LSQinit(20),
     *                IsoAnisoGTK(3000),
     *                kFixGTK(19,3000),
     *                nObsGTK(10),
     *                WParDefGTK(20,10),
     *                nParDefGTK(20),
     *                WParGTK(10),
     *                nresGTK,
     *                vresGTK(6000),
     *                natsGTK,
     *                nGruppiDefined,
     *                AtomsGTK(3001),
     *                ifCubo,
     *                latoCubo,
     *                xyzCubo(3),
     *                ixCubo,
     *                iyCubo,
     *                ipxCubo(3,9)

      END MODULE Dialogo
! ----------------------------------------------------------------------
      MODULE Molcom
      USE Dialogo
!
            real,    allocatable :: xyz(:,:)
            real,    allocatable :: RSCOPY(:)
            real,    allocatable :: rMLU(:)
            real,    allocatable :: RS(:)
            real,    allocatable :: xyLab(:,:)
            integer, allocatable :: iCol(:)
            integer, allocatable :: iOrd(:)
            integer, allocatable :: iEqui(:)
            integer, allocatable :: nOpEq(:)
            integer, allocatable :: jdoppio(:)
            integer, allocatable :: LE(:,:)
            integer, allocatable :: LE1(:,:)
            integer, allocatable :: ipix(:,:)
            integer, allocatable :: ipixLab(:,:)
            integer, allocatable :: selezione(:)
            integer, allocatable :: nOpEqBaric(:)
            integer, allocatable :: nfragm(:)
           
            integer, allocatable :: ifLabelsVis(:)
            character*60, allocatable::  It(:)      
            integer,allocatable  :: SinglePlotType(:)
*           integer,allocatable  :: nzTot(:)             
            character(len=2)     :: dummyString
            character(len=16) , allocatable :: Lab(:)
            integer              :: SelectingSites = 0
!
!-- ex molcom.fi
!
      integer         :: ifHydro, nLabelHyd, LabelHyd, ifHydrobase
      common /LabeHyd/ ifHydro, nLabelHyd, LabelHyd(200), ifHydrobase
      integer         :: icolBaseMono, MaxBondsInGr, nLegInd, NumLeg
      integer         :: nlp, nMaxLeg, LegCol, NLL, ifSolidLeg, nssh
      real            :: zmin, spess, p1, p2, p3, p4, RAP, DLegN
      integer         :: ifTraccia
      common/legami/ icolBaseMono, MaxBondsInGr, nLegInd,
     *               NumLeg, nlp, nMaxLeg, LegCol, zmin, spess,
     *               NLL, ifSolidLeg, p1, p2, p3, p4, RAP, DLegN, nssh,
     *               ifTraccia

      integer         :: nfrag_ini
      common/ApSymOp/ nfrag_ini

            real            :: Rmin1, Rmin2, RMAX1, RMAX2, Xmin, Ymin
            real            :: XMax, YMax, DDX, DDY, minmaxSav
            real            :: DrawDeltX, DrawDeltY, DrawBard(3)
            integer         :: NPX, NPY, Lim1, Lim2, Lim3, Lim4
      common /scrMol/ Rmin1, Rmin2, RMAX1, RMAX2, Xmin, Ymin, XMax,YMax,
     *          NPX, NPY, DDX, DDY, Lim1, Lim2, Lim3, Lim4, minmaxSav(4)
            integer         :: ifFirstTime, ifScale, kplty, ifDrRes
            integer         :: ifContour, ifGhost, ifDrHydr, ifDrHBond
            integer         :: ifHardC, ifPersp, ifChangedXYZ,IfChangeHM
            integer         :: IfHelpEnabled, IfRotTran, ifLabelsPoly 
            integer         :: ifContPoly, natsPoly, iActive, nUltRot 
            integer         :: ifSymmCont, AngDef   
            real            :: PercTra, FProb, ViewDistPoly
            logical         :: ifViewer
      common /PlotOpts/ ifFirstTime, ifScale,
     *                kplty, ifDrRes, AngDef, PercTra, ifContour,
     *                ifGhost,ifDrHydr,ifDrHBond,FProb,ifHardC, ifPersp,
     *                ifChangedXYZ,IfChangeHM, IfHelpEnabled, IfRotTran,
     *                ifContPoly, ViewDistPoly, natsPoly, iActive(20),
     *                nUltRot, ifSymmCont, ifViewer
            real            :: BTot, RK, VV
            integer         :: ifBestModel, ifRigidBody
      common /piero/ BTot(3,3), RK(4), VV(10,3), ifBestModel,
     *               ifRigidBody
!
!-- per bloccare gli atomi nelle rotazioni e FindMinMax
!
            integer         :: AtomiBloccati
      
! mr per expo
            integer         :: jpatterntype
            integer         :: jmarkertype, jsizemarker, klegend
      common /coloriCommon/ jpatterntype,
     *                jmarkertype, jsizemarker, klegend
! end mr per expo
            real            :: x11scale, x11disp, ragmed, DistMax
            integer         :: iVP, NatSpi, icoloresettato
      common /scale/ x11scale(2), x11disp(2), ragmed
      common /parfin/ iVP(4), NatSpi, icoloresettato, DistMax
            real            :: FntAscent = 10.0
            real            :: FntPixWidth = 10.0
            real            :: FntPixHeight = 10.0

!     common /fonte/ FntAscent, FntPixWidth, FntPixHeight
            integer         :: ixv, iyv, kptr, nptr
            integer         :: kptrcopy, nptrc, ixp, iyp
      common/bufferg/ixv(1536), iyv(1536), kptr(10000), nptr,
     *               kptrcopy(10000), nptrc, ixp(107), iyp(107)
            integer         :: kscreen = 1
            integer         :: jscreen = 0
            integer         :: kscrx = 1020
            integer         :: kscry = 713
            integer         :: ifHidden = 0
            real            :: DeA, DeADef, Shf , Tra
            integer         :: nCell, nSymMol, NatInd
            character(len=1):: nt1
      common /GeneraC/ DeA(3), DeADef(3), nCell(3),
     *                 Shf(3, 3), Tra(3, 20), nSymMol, NatInd, nt1
            integer         :: ifProject 
      common /Project/ ifProject
!
            integer         :: lspec = -1
            integer         :: lser, iCl1, iCl2, iCl3 
            real            :: dist1atm, ang_b, ang_t, gamma 
            character(len=8):: Lab1, Lab2, Lab3, Lab4
      common /add1atm/ lspec, lser(8), iCl1, iCl2, iCl3, 
     *                 Lab1, Lab2, Lab3, Lab4, 
     *                 dist1atm, ang_b, ang_t, gamma
            integer         :: ifPoly
            integer         :: nvert, ntriang, ktl, kbo, natold
            integer         :: kco            
            real            :: ra, RSsav
            character(len=8) :: Labsav
      common /poliedriC/ ifPoly,nvert,ntriang,ktl(4,4000),kbo(2,6000),
     1        ra(4000),kco(4000),RSsav(1000),Labsav(1000),natold
            integer         :: nTp, kCentral
            real            :: xyzTmp(3,10)
corrado
            integer         :: ipix_copy
            real            :: rksx,rksy
      common /copia_punti/ipix_copy(2,100),rksx,rksy
corrado
! ---
!
            integer         :: iQualeBecca, nonDoppio, ifPol,iQualePolyg
            integer         :: nel, ixPol, iyPol, nvPol
      common /BeccaPunti/ iQualeBecca, nonDoppio, ifPol,
     *                    iQualePolyg, nel, ixPol, iyPol, nvPol
!
            integer          :: itasto_premuto, ifShift, ifCtrl, ifFkey
            integer          :: ifMovedLab
!
      common /tasti/ itasto_premuto, ifShift, ifCtrl, ifFkey, ifMovedLab
!
            integer          :: sezione0, sezioneN, ifDrawContour
            integer          :: nLevels, ifLevel
            integer          :: LevelCol, nPuntiCont, nPuntiLev
            integer          :: Layer, ifModel, massimoMappa  
            integer          :: ifGrid, WhichLimit, WhichRes 
            integer          :: ifSkeleton, nSkel, nSkelLeg, noSkeleton
            integer          :: numCell
            integer          :: xyz_triadim, Max_Points, ifOriented
            real             :: SoglieCont, centerCont 
            real             :: deltaCont, xyzlimCont
!
            integer          :: ifAlreadyProduced, Shapes
            integer          :: indrLev, kSpiCont, ngridCont
            integer          :: morePoints, moreLines, moreBox
            integer          :: lineBox
            real             :: sigmaMappa, ContBox
            character(len=4) :: Method
!
      common /contour/ ifDrawContour, nLevels(2), ifLevel(5),
     *        SoglieCont(15), LevelCol(5), nPuntiCont, nPuntiLev(15), 
     *        Layer, sezione0, sezioneN, 
     *        centerCont(3), deltaCont(3), xyzlimCont(2,3), 
     *        ifModel, massimoMappa, ifGrid, WhichLimit, WhichRes,
     *        xyz_triadim, Max_Points, ifOriented,
     *        numCell(3,2), ifSkeleton, nSkel, nSkelLeg, noSkeleton
      common /contourM/ ifAlreadyProduced, sigmaMappa, Shapes(6),
     *                  indrLev(5), kSpiCont(36,2), ngridCont(3),
     *                  morePoints, moreLines,
     *                  moreBox, lineBox(12,2), Method, ContBox(3,2)

!
!-- ex povray.fi
!
            integer          :: QualeEllisse
            real             :: xyzPov(3,9800), scalapov, RaggioSph
            real             :: RaggioCyl, Wire, opi2, radmed
            real             :: baricExpo(3)
            character(len=12):: ambient
!
            real             :: rm(3,3),rmi(3,3),eval(3)
            real             :: evec(3,3),ainer(3,3),bard(3)
      common /PovRayEtc/ QualeEllisse, xyzPov, scalapov, RaggioSph,
     *                    RaggioCyl, Wire, opi2, radmed,
     *                    rm, rmi, eval,evec,ainer,bard,baricExpo
      common /PovRayChar/ ambient
!
            integer :: ifViewModel, ifLabelsPub
            integer :: legaCubo(12, 2)
            real    :: coordCubo(3, 9)
!-- Remo Legend
            integer :: ifRemoLegend = 0
            character(len=80):: RemoLegend
!

      END MODULE Molcom
! ----------------------------------------------------------------------
      MODULE IsrCom
        integer, allocatable   ::isr(:)
      END MODULE IsrCom
!-------------------------------------------------------------------------------------
      MODULE TestModel
             integer              :: nCoord
             integer              :: nCoordPub = 0, nLegPub = 0
             integer              :: nCaPub = 0
             integer              :: ifNoMatch
             integer              :: naatoms
             real                 :: vett_test(10)
             real                 :: distCoord
             real                 :: rmsd
             logical              :: CaOnly = .false.
             integer, allocatable :: nzPub(:)
             integer, allocatable :: npunt(:)
             integer, allocatable :: ixyPub(:,:)
             integer, allocatable :: LEPub(:,:)
             integer, allocatable :: tipoPub(:)
             real, allocatable    :: coordSir(:,:)
             real, allocatable    :: coordPub(:,:)
             real, allocatable    :: xyzPub(:,:)
             real, allocatable    :: distv(:)
             real, allocatable    :: distRms(:)
             character(len=16) , allocatable :: aLabPub(:)
      END MODULE TestModel
! ----------------------------------------------------------------------
      MODULE RemoModule
!
             integer  :: Model_PDB = 0
             integer  :: ifOverlap = 0
             real     :: WasNegative = 1.0
             real     :: TranslAppl(3), RotAppl(3), globval(2)
             real     :: Buffer16(11), resol1, resol2, resol3, resol4
             real     :: step, step1, bfacMR, oldMR
             real     :: rapp, rapp1, rapp_sp              ! Coeff. diffic.
             real     :: rhoSog1, rhoSog1a, rhoSog2,rhoSog3, RfreeThre
             real     :: avrgRot, sigmaRot, idSeq, rmsStr
             integer  :: ifRotOnly, ifTraOnly, ifPositioned, ifTraSel
             integer  :: nstrMol, natsModel, ifModify
             integer  :: kCosto, nFasiMR, LeggiHetam, ifShelx, ifSolvent
             integer  :: nSolToExplore,  nreflMR, ifNorm, ifAla
             integer  :: ifCutResidui, MinResiduo, MaxResiduo
             integer  :: natsMR, matriceMR(10,2), nSolToExploreTrasl
             integer  :: nSolToExploreRot, nSolToExplorePrima
             integer  :: nMolMR,nMolMRTot,jMolMR,inizMR,ifinMR,
     *                   nGridMR(3), nMon_pseudo !si usa se c'è pseudo
             logical  :: use_sigmaA, use_E, use_jpd, use_resplus,
     *                   use_pseudo
             logical  :: ifLoadedPDB = .false.
             integer  :: noPseudo, nMolMR_pseudo, nMolMRPS
             real     :: rhomaxPseudo, eSubO, eSuperO
             real     :: cellSav(6), errcellSav(7), waveSav, anatSav
             real     :: totopSav, aaaSav(6), zeffSav(18)
             real     :: BondTableSav(2,18,18)
             integer  :: nalfSav(19), nwSav(18), nkSav, nsymSav,icentSav
             integer  :: noSav(18)
             integer  :: ismatSav(2,3,24), ncentrSav, nsymTotSav
             integer  :: nMaxSolutions, WhichSolution, WhichTrial
             real     :: bariVLD(3)
             integer  :: WhichBestSolution
             real     :: correMappa,packRemo
             real     :: bmedio
             character (len=16) :: SpaceSav
             dimension:: alSav(4,18), bsSav(4,18), clSav(18)
             real     :: alSav, bsSav, clSav
             real     :: indexDiff = 1.0
             real     :: coeffCompl = 1.0

!
             integer  :: numbMaps, WhichMap, MaxnumbMaps
             integer  :: numbModels, WhichModel, WhichMonomer
             integer  :: MaxnumbModels, MonomerInModel(20)
             integer  :: natsAsymm(5), legAsymm(5,4), legAsymms(5,4)
             integer  :: ifImproveMR = 0
             integer  :: ifFreeLunchMR = 0
             integer  :: ifFreeLunchMR_Sav = 0
             integer  :: ifItera = 0
             integer  :: ifOutDsr = 0
             integer  :: ifMutate = 0
             integer  :: MutateReq = 0
             integer  :: NoMutateReq = 0
             integer  :: ifMtzMap = 1
             integer  :: ies_thre(4) = 0
             integer  :: preMutazioni = -999
             integer  :: preMutazioniReq 
             integer  :: nuovoBl 
             integer  :: ciclaRefmac = 1
             
             real, allocatable    :: FcScaleInModel(:) 
             real, allocatable    :: FcBisoInModel(:)
             real, allocatable    :: FcExtinInModel(:)
             real, allocatable    :: FcPolaInModel(:)
             real, allocatable    :: FcTwinInModel(:)
             real, allocatable    :: Overall_devInModel(:,:)

             integer, allocatable :: natsInModel(:)
             
             type remoModel
                real, allocatable    :: atoms(:,:,:)
                real, allocatable    :: saved(:,:,:)
                real, allocatable    :: ortho(:,:,:)
                integer, allocatable :: specie(:,:)
                integer, allocatable :: serial(:)
                real, allocatable    :: th_fact(:,:)
                real, allocatable    :: bij(:,:,:)
                real, allocatable    :: al(:,:)
                real, allocatable    :: bs(:,:)
                real, allocatable    :: cl(:)
                real, allocatable    :: raggio(:,:)
                integer, allocatable :: no(:)
                integer, allocatable :: nw(:)
                integer, allocatable :: nalf(:)  
                integer, allocatable :: SinglePlotType(:)  
                character(len=4) , allocatable :: tipoAtomo(:,:)
                character(len=4) , allocatable :: tipoResiduo(:,:)
                character(len=1) , allocatable :: Alternate(:,:)
                character(len=16) , allocatable :: Label(:)
                character(len=1) , allocatable :: catena(:,:)
                character(len=1) , allocatable :: Secondary(:,:)
                character(len=1) , allocatable :: Insertion(:,:)
                integer, allocatable :: numResiduo(:,:)
                integer, allocatable :: considerato(:)
                integer, allocatable :: IsoAniso(:,:)
                integer              :: nk
                integer              :: PDB
                integer              :: trial
                real                 :: erre
                real                 :: BTot(3,3)
                integer, allocatable :: iSite(:)
                real, allocatable    :: SiteInfo(:,:)
                real, allocatable    :: xyz_dev(:,:,:)
                real, allocatable    :: occ_dev(:)
                real, allocatable    :: occX_dev(:,:)
                real, allocatable    :: th_fact_dev(:,:)
                real, allocatable    :: bij_dev(:,:,:)
                integer, allocatable :: GeomAtom(:)
                integer, allocatable :: HETA(:,:)
                character(len=4) , allocatable :: AtSpecies(:,:)
             end type remoModel
             type(remoModel),   allocatable :: model(:)
             type(remoModel),   allocatable :: modelTemp(:)
!
             integer, allocatable :: BondsInModel(:)
             type BondsTab
*gl*            integer, allocatable :: Legami(:,:)
                real, allocatable :: Legami(:,:)
             end type BondsTab
             type(BondsTab),   allocatable :: Bonds(:)
             type(BondsTab),   allocatable :: BondsTemp(:)
             type InfoModel
                integer, allocatable :: iEqui(:)
                integer, allocatable :: SymOp(:)
             end type InfoModel
             type(InfoModel),   allocatable :: InfoOnModels(:)
!
             real     :: RotAppl1Vet(20,3)
             integer  :: CutResiduiVet(20,3), bfacMRVet(20)
             integer  :: AlaVet(20), LeggiHetamVet(20)
             integer  :: ifTraOnlyVet(20), ifRotSelVet(20)
             integer  :: ifPositionedVet(20),ifTranslApplVet(20)
             integer  :: ifRotApplVet(20)
             real     :: RotApplVet(20,3), TranslApplVet(20,3)
             real     :: TraAppl1Vet(20,3)
             integer  :: nLigandi
             integer  :: nLegProtein, nLegBack, nLegCalpha, nLegLigand
c            integer  :: group_sol(100,100)
             integer  :: group_sol(5000,5000)
!
      END MODULE RemoModule
! ----------------------------------------------------------------------
      MODULE Solutions
             type solution
                real RotVal(3)
                real TraVal(3)
                real RotFom
                real TraFom
                real MolMPE
                integer ipunt
                integer trial
                integer accepted
                real RFom(5)
             end type solution
             type(solution),   allocatable :: solcan(:)
             integer solnum
             integer,    allocatable:: iwork3 (:)
             real,       allocatable ::work3 (:)
!
             type Finalsolution
                real, allocatable    :: RotVal(:,:,:)
                real, allocatable    :: TraVal(:,:,:)
                real                 :: Corr
                real                 :: Fom
                real                 :: MPE
                integer, allocatable :: flag(:,:)
             end type Finalsolution
             type(Finalsolution),   allocatable :: finsolcan(:)
             integer                 :: nFinalSolution = 0
      END MODULE Solutions
! ----------------------------------------------------------------------
      MODULE LsqModule
      USE Dialogo
!
      common /xlsq/ jCodeTwin,jCodeFlack,jflackON
!
      integer  :: nreflX = -1      ! no. riflessi usati in LSQ
      
      integer  :: IcodeFo4 = 1
      integer  :: NoRefl = 0
      integer  :: NoTest = 0
      integer  :: IcodeFo = 1
      integer  :: nWeight = -100
      integer  :: nCycles = 3
      integer  :: iCutoff = 3
      integer  :: iverb = -1
      integer  :: iautoLsq = 1
      integer  :: LsqType = 2
      integer  :: LsqCF = 2       ! = 2 minimi quadrati; = 1 calcolo fattori
      integer  :: ifDefault = 0
      integer  :: iW12 = 0
      integer  :: nCycleTot
      integer  :: nCycleCurr
      real     :: Dampi = 1.0
      real     :: sumWDiff
      real     :: sumWDiff_Prev
      common /lsq2/ nPar,WPar(10),ifWr4,WParDef(20,10),nBlocks,
     *              nParDef(20),IWFo2
      common /lsq3/ MaxAtLSQ,nObservation(10),nParameters, ObsByParam
!     common /lsql/ nAddComm,iPdire,icomatB,ipcomB,amult,BLimit
      integer  :: nAddComm = 0
      integer  :: iPdire = 0
      integer  :: icomatB = 0
      integer  :: ipcomB = 0
      integer  :: OverallNumBlock(5)
      real     :: amult  = 0.0
      real     :: BLimit
      character*80 ParamVet
      common /lsqp/ ParamVet(10), ifGiaDef
      common /lsqd/ nDirLsq, lsqTest
      common /lsqdlg/ kInitStateSav(20)   ! copia di LSQinit(20)
      real     :: buffo(200)
      integer  :: nbadx, nbad
c
c-- restraints
c
      common /restr/ nres, vres(6000), nresSav, vresSav(6000),ifDrResSav
c
c-- constraints
c
      common /constr/ nconstr, iconstr(80,100)
c
c-- fourier
c
      common /FourierComm/ NatsOld, natsSav, heimin, iCoef
!
      data OverallNumBlock/0,0,0,0,0/
!      
      END MODULE LsqModule
! ----------------------------------------------------------------------
      MODULE Atomi
             integer              :: MaxAtoms
             integer              :: nats
             integer              :: NatsSymm
             integer              :: MaxBonds
             integer              :: MaxBondH
             integer              :: NumOverall = 5
             real                 :: FcScale = -1.0
             real                 :: FcBiso  = 3.0
             real                 :: FcExtin = 0.0
             real                 :: FcPola  = 0.0
             real                 :: FcTwin  = 0.0
             real                 :: Overall_dev(5)
             real                 :: Overall_shift(5)
             integer              :: ninf(10)
             integer              :: nag(10)
             integer              :: nHs, nDeu   ! nr di H/D in a.u: caso neutroni
             integer              :: nFlagAtom  ! numero di atomi flagati in jFlagAtomi
!
!-- common /atoms/ + /atoml/
!
             real, allocatable    :: xyzs(:,:)
             real, allocatable    :: bfac(:)
             real, allocatable    :: bij(:,:)
             real, allocatable    :: xyzs_dev(:,:)
             real, allocatable    :: bfac_dev(:)
             real, allocatable    :: occpch(:)
             real, allocatable    :: bij_dev(:,:)
             real, allocatable    :: SiteInfo(:,:)
             real, allocatable    :: Occ_dev(:)
             real, allocatable    :: OccX_dev(:,:)
             integer, allocatable :: nz(:)
             integer, allocatable :: nzHydro(:)
             integer, allocatable :: serial(:)
             integer, allocatable :: kblock(:)
             integer, allocatable :: jSingleColor(:)
             integer, allocatable :: ibridgl(:)
             integer, allocatable :: nGrCode(:)
             integer, allocatable :: nGrAtCode(:)
             integer, allocatable :: jFlagAtom(:)
             integer, allocatable :: jFlagAtom1(:)
             integer, allocatable :: iBridiz(:)
             integer, allocatable :: iGeomAtom(:)             
             integer, allocatable :: iSite(:)             
             integer,allocatable  :: nzTot(:)             
             integer,allocatable  :: noAtom(:)
             character(len=16) , allocatable :: aLab(:)
!
!-- common /atomo/ + /atomlOld/
!
             real, allocatable    :: xyzo(:,:)
             real, allocatable    :: bSav(:)
             integer, allocatable :: nzo(:)
             character(len=16) , allocatable :: aLabOld(:)
!
!-- ex-Lista 25
!
             integer              :: nats25
             integer, allocatable :: Adr25to5(:)
             real, allocatable    :: work25(:)
             character(len=16) , allocatable :: aLab25(:)
             real, allocatable    :: xyzs25(:,:)
             real, allocatable    :: xyzs25_dev(:,:)
             real, allocatable    :: bij25(:,:)
             real, allocatable    :: bfac25(:)
!             
!-- ex-Lista 26
!
             integer              :: nats26
             integer, allocatable :: Adr26to5(:)
             real, allocatable    :: work26(:)
             character(len=16) , allocatable :: aLab26(:)
             real, allocatable    :: xyzs26(:,:)
             real, allocatable    :: xyzs26_dev(:,:)
             real, allocatable    :: bij26(:,:)
             real, allocatable    :: bfac26(:)
!
!-- Liste virtuali - common /list15v/ + /atoml30/
!
             integer              :: nats15
             real, allocatable    :: xyz15(:,:)
             real, allocatable    :: bfac15(:)
             real                 :: preamb15(10)
             real                 :: BTot15(3,3)
             integer, allocatable :: nz15(:)
             integer, allocatable :: serial15(:)
             character(len=16) , allocatable :: aLab15(:)
!
!-- Liste virtuali - common /list30v/ + /atoml30/ + skeleton
!
             integer              :: nats30
             real, allocatable    :: xyz30(:,:)
             real, allocatable    :: bfac30(:)
             real                 :: preamb30(10)
             real                 :: BTot30(3,3)
             integer, allocatable :: nz30(:)
             integer, allocatable :: serial30(:)
             character(len=16) , allocatable :: aLab30(:)
             real, allocatable    :: xyzSk(:,:)
             real, allocatable    :: bfacSk(:)
             integer, allocatable :: iconnSk(:)
!
!-- neutrons 
!
             real, allocatable    :: xyzNeutrons(:,:)
!
!-- connectivity 
!
             integer, allocatable :: iconn(:)
             integer, allocatable :: jconn(:)
             integer, allocatable :: iconnH(:)
             integer, allocatable :: iconn15(:)
             integer, allocatable :: iconn30(:)
             integer, allocatable :: iconnSav(:)
             integer, allocatable :: iconnori(:)
!
!-- vettori di appoggio
!
             real, allocatable    :: occsav(:)
             real, allocatable    :: fvar(:)
             real, allocatable    :: qvar(:)
             real, allocatable    :: qq(:)
             real, allocatable    :: xyzs4(:)
             integer, allocatable :: nzsav(:)
             integer, allocatable :: numbTemp(:)
!
!-- Sir Least Squares ( /MinQua/ )
!
             real, allocatable    :: deltaf(:,:)
             real, allocatable    :: qvet(:,:)
             real, allocatable    :: apdSir(:,:)
             real, allocatable    :: bpdSir(:,:)
             integer, allocatable :: kcond(:,:)
!
!-- Caos Least Squares ( /lsqc/, IsoAniso di /lsqg/ )
!
             integer, allocatable :: ifChanged(:) 
             integer, allocatable :: ifChangedB(:)
             integer, allocatable :: IsoAniso(:)  ! =1 if Aniso, =2 if Iso
!
!-- ellissoidi ( /ellips/ )
!
             real, allocatable    :: Ell(:,:,:)
             real, allocatable    :: semax(:,:)
             real, allocatable    :: cd(:,:,:)
!
!-- miscell. ( /costanti/, /geomcalc/, /xizpk/)
!
             integer, parameter   :: nzConst = 10000
             integer              :: nGroupsGeo  
             integer              :: nSingleAtoms
             integer, allocatable :: izpk(:)
             integer, allocatable :: InfoResidui(:,:)
!
      END MODULE Atomi
! ----------------------------------------------------------------------
      MODULE EnvelopeModule
             integer*8            :: FORTHenv,BACKenv
             real, allocatable    :: xenve(:,:,:)
             real, allocatable    :: xenveT(:,:,:)
      END MODULE EnvelopeModule
! ----------------------------------------------------------------------
      MODULE Mappa
             USE EnvelopeModule
             integer              :: igrid
             integer              :: np(3)
             real                 :: factr
             integer*8            :: FORTH = 0,    BACK = 0
c            integer*8            :: FORTHini = 0, BACKini = 0
             integer*8            :: FORTHdif = 0, BACKdif = 0
             integer              :: WhichFFTMethod
             real, allocatable    :: xmap(:,:,:)
             real, allocatable    :: xmapDif(:,:,:)
             complex, allocatable :: xmapC(:,:,:)
             real, allocatable    :: xmapApp(:,:,:)
             include 'fftw3.f'

      CONTAINS

             subroutine AllocaUnaMappa(mappa, np, iAction)
!
              integer              :: np(3)
              real, allocatable    :: mappa(:,:,:)

!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
              ierr = 0
              if (iAction == 1) then
                  IF (.NOT. ALLOCATED(mappa))
     *            ALLOCATE (mappa(0:np(1)-1,0:np(2)-1,0:np(3)-1),
     *                      stat = ierr)
                  if (ierr.ne.0) then
                      write(*,*) 'Map Allocation Error'
                      call cstop(' Allocation error')
                  endif
              else
                  IF (ALLOCATED(mappa))
     *                DEALLOCATE (mappa,stat = ierr)
                  if (ierr.ne.0) then
                      write(*,*) 'Maps Deallocation Error'
                      call cstop(' Allocation error')
                  endif
              endif
!
      return
      end subroutine AllocaUnaMappa

      END MODULE Mappa
! ----------------------------------------------------------------------
      MODULE MapTest
             real, allocatable :: xmodel(:,:,:)
             real, allocatable :: xmapT(:,:,:)
             real, allocatable :: xmapQT(:,:,:)
      END MODULE MapTest
! ----------------------------------------------------------------------
      MODULE MappaAutre
             integer              :: npAutre(3)
             integer*8            :: FORTHa = 0,    BACKa = 0
             real, allocatable    :: xmapAutre(:,:,:)
             complex, allocatable :: xmapCa(:,:,:)
      END MODULE MappaAutre
! ----------------------------------------------------------------------
      MODULE Skeleton

           character*256          :: BonesFileName
           integer                :: nmap,iskelet,lungSK,nSparePoints
           integer                :: iBonesIn
           real                   :: sogMapSK,sogLevSK
           integer                :: nBonesPoint
           integer,  allocatable  :: ndenSK(:)
           real, allocatable      :: maskSK(:,:,:)
           real, allocatable      :: xyzBones(:,:)

           integer                :: maxp,maxb,maxc
           parameter (maxp = 50000)
           parameter (maxb = maxp)
           parameter (maxc = 2* maxp)
           integer                :: conlis(3,maxc),brnlis(maxp,6)
           real                   :: pntlis(maxp,3)
           integer                :: levlis(maxp),newcon(maxc)

           !
           parameter (maxfrg = 16)
           integer, dimension(maxfrg) ::frgsz,nfrg
           integer                    ::finlis,even,odd,unkn,
     *                                  side,main,unus
           data finlis/3/,even/0/,odd/1/,unkn/1/,side/2/,main/3/,unus/4/
           data frgsz/1,2,3,4,5,6,7,8,9,10,15,20,25,50,100,100/

      END MODULE Skeleton

! ----------------------------------------------------------------------
      MODULE CIF
!
      character(len= 1), dimension(60) :: val_cifkey = (/
     *  'a', 'a', 'a', 'a', 'a', 'a', 'a', 'a', 'a', 'a', 'a', 'a',  ! 12
     *  'f', 'f', 'f', 'f', 'f', 'f', 'a', 'f', 'f', 'f', 'a', 'a',  ! 24
     *  'f', 'a', 'a', 'a', 'a', 'a', 'a', 'f', 'f', 'f', 'f', 'f',  ! 36
     *  'f', 'f', 'f', 'f', 'f', 'f', 'f', 'a', ' ', 'f', 'f', 'f',  ! 48
     *  'f', 'f', 'f', 'f', 'f', 'f', 'f', ' ', ' ', ' ', ' ', ' '/) ! 60
      character(len= 2), dimension(60) :: sir_cifval = (/
     *  '  ', '  ', '  ', '  ', 'la', '  ', '  ', '  ', '  ', '  ',
     *  'sy', '  ', 'xf', 'yf', 'zf', 'xc', 'yc', 'zc', 'ia', 'ui',
     *  'bi', 'oc', 'ad', '  ', 'sm', 'rf', '  ', '  ', '  ', 'al',
     *  'at', 'u1', 'u2', 'u3', 'u4', 'u5', 'u6', 'b1', 'b2', 'b3',
     *  'b4', 'b5', 'b6', 'wy', '  ', 'ih', 'ik', 'il', 'o2', 'c2',
     *  's2', 'ob', 'c1', 's1', 'ph', '  ', '  ', '  ', '  ', '  '/)
      character(len=40), dimension(60) :: cifkey ! = (/
!    * '_ccdc_atom_site_atom_id_number', '_ccdc_atom_site_symmetry', !  2
!    * '_atom_site_id', '_atom_site_group_pdb', '_atom_site_label',  !  5
!    * '_atom_site_label_seq_id', '_atom_site_label_atom_id',        !  7
!    * '_atom_site_label_comp_id', '_atom_site_label_asym_id',       !  9
!    * '_atom_site_label_alt_id', '_atom_site_type_symbol',          ! 11
!    * '_atom_site_auth_seq_id ', '_atom_site_fract_x',              ! 13
!    * '_atom_site_fract_y', '_atom_site_fract_z', '_atom_site_cartn_x',! 16
!    * '_atom_site_cartn_y', '_atom_site_cartn_z',                      ! 18
!    * '_atom_site_thermal_displace_type', '_atom_site_u_iso_or_equiv', ! 20
!    * '_atom_site_b_iso_or_equiv', '_atom_site_occupancy',             ! 22
!    * '_atom_site_adp_type', '_atom_site_symmetry_multiplicity',       ! 24
!    * '_atom_site_calc_flag', '_atom_site_refinement_flags',           ! 26
!    * '_atom_site_disorder_assembly', '_atom_site_disorder_group',     ! 28
!    * '_ccdc_atom_site_base', '_atom_site_aniso_label',                ! 30
!    * '_atom_site_aniso_u_11', '_atom_site_aniso_u_22',                ! 32
!    * '_atom_site_aniso_u_33', '_atom_site_aniso_u_23',                ! 34
!    * '_atom_site_aniso_u_13', '_atom_site_aniso_u_12',                ! 36
!    * '_atom_site_aniso_b_11', '_atom_site_aniso_b_22',                ! 38
!    * '_atom_site_aniso_b_33', '_atom_site_aniso_b_23',                ! 40
!    * '_atom_site_aniso_b_13', '_atom_site_wyckoff_symbol',            ! 42
!    * '_atom_site_attached_hydrogens', '              ',               ! 44
!    * '_refln_index_h', '_refln_index_k', '_refln_index_l',            ! 47
!    * '_refln_f_squared_meas', '_refln_f_squared_calc',                ! 49
!    * '_refln_f_squared_sigma', '_refln_f_meas', '_refln_f_calc',      ! 52
!    *  '_refln_f_sigma',                                               ! 53
!    * ' ', ' ', ' ', ' ', ' ', ' ', ' '/)                              ! 60

      integer, dimension(60)           :: l_cifkey
      integer, dimension(20) :: limiti_cif=(/
     *  29, 45, 55, 58,  0,  0,  0,  0,  0,  0,
     *   0,  0,  0,  0,  0,  0,  0,  0,  0,  0/)
      integer, dimension(18)           :: cif_serial
      real, dimension(6)               :: cif_bij
      real, dimension(18)              :: cif_number
      integer                          :: allowed_cifkey = 60
      integer, dimension(60)           :: punt_cifkey
      integer                          :: n_cifkey
      integer                          :: max_cif_loops = 4
      integer                          :: n_aniso
      integer                          :: LoopType
      integer                          :: ifCartesian
************************************************************************
      integer            :: nkey = 13
      integer, dimension(8) :: nkeyn=(/ 4, 13, 4, 3, 4, 15, 11, 16 /)

      character(len=80), dimension( 4) :: keyx = (/
     1   'constr                          ' ,
     2   'Int. Tab. C, 4.2.6.8, 6.1.1.4   ',
     3   'sigma                           ' ,
     4   'calc                            '/)

      character(len=32), dimension(13) :: keyw = (/
     1   '_publ_section_title             ',
     2   '_chemical_formula_moiety        ',
     3   '_cell_length_a                  ',
     4   '_symmetry_cell_setting          ',
     5   '_exptl_crystal_size_max         ',
     6   '_exptl_crystal_density_diffrn   ',
     7   '_exptl_absorpt_correction_T_min ',
     8   '_diffrn_radiation_wavelength    ',
     9   '_diffrn_standards_number        ',
     *   '_diffrn_reflns_reduction_process',
     1   '_reflns_number_total            ',
     2   '_refine_ls_matrix_type          ',
     2   '_computing_structure_solution   '/)

      character(len=32), dimension( 4) :: key1 = (/
     1   '_chemical_formula_sum           ',
     2   '_chemical_formula_moiety        ',
     3   '_chemical_formula_structural    ',
     4   '_chemical_formula_weight        '/)

      character(len=32), dimension(13) :: key2 = (/
     1   '_cell_length_a                  ',
     2   '_cell_length_b                  ',
     3   '_cell_length_c                  ',
     4   '_cell_angle_alpha               ',
     5   '_cell_angle_beta                ',
     6   '_cell_angle_gamma               ',
     7   '_cell_volume                    ',
     8   '_cell_formula_units_Z           ',
     9   '_cell_measurement_radiation     ',
     *   '_cell_measurement_wavelength    ',
     1   '_cell_measurement_reflns_used   ',
     2   '_cell_measurement_theta_min     ',
     3   '_cell_measurement_theta_max     '/)

      character(len=32), dimension( 3) :: key22 = (/
     5   '_exptl_crystal_size_max         ',
     5   '_exptl_crystal_size_mid         ',
     5   '_exptl_crystal_size_min         '/)

      character(len=32), dimension( 5) :: key3 = (/
     1   '_symmetry_cell_setting          ',
     2   '_symmetry_space_group_name_H-M  ',
     3   '_symmetry_Int_Tables_number     ',
     4   '_symmetry_equiv_pos_site_id     ',
     5   '_symmetry_equiv_pos_as_xyz      '/)

      character(len=32), dimension( 3) :: key4 = (/
     1   '_exptl_crystal_density_diffrn   ',
     2   '_exptl_crystal_F_000            ',
     3   '_exptl_absorpt_coefficient_mu   '/)

      character(len=32), dimension( 2) :: key44 = (/
     1   '_exptl_absorpt_correction_T_min ',
     2   '_exptl_absorpt_correction_T_max '/)

      character(len=32), dimension( 2) :: key5 = (/
     1   '_diffrn_radiation_wavelength    ',
     2   '_diffrn_radiation_type          '/)

      character(len=32), dimension(10) :: key55 = (/
     1   '_diffrn_standards_number        ',  
     2   '_diffrn_standards_interval_count',
     3   '_diffrn_standards_interval_time ',
     4   '_diffrn_standards_decay_%       ',       
     5   '_diffrn_standard_refln_index_h  ',
     6   '_diffrn_standard_refln_index_k  ',
     7   '_diffrn_standard_refln_index_l  ',
     8   '_diffrn_reflns_number           ',
     9   '_diffrn_reflns_av_R_equivalents ',
     *   '_diffrn_reflns_av_unetI/netI    '/)

      character(len=32), dimension(15) :: key6 = (/
     1   '_diffrn_reflns_reduction_process',
     2   '_diffrn_reflns_theta_min        ',
     3   '_diffrn_reflns_theta_max        ',
     4   '_diffrn_reflns_limit_h_max      ',
     5   '_diffrn_reflns_limit_h_min      ',
     6   '_diffrn_reflns_limit_k_max      ',
     7   '_diffrn_reflns_limit_k_min      ',
     8   '_diffrn_reflns_limit_l_max      ',
     9   '_diffrn_reflns_limit_l_min      ',
     *   '_atom_type_symbol               ',
     1   '_atom_type_number_in_cell       ',
     2   '_atom_type_description          ',
     3   '_atom_type_scat_dispersion_real ',
     4   '_atom_type_scat_dispersion_imag ',
     5   '_atom_type_scat_source          '/)

      character(len=32), dimension(12) :: key7 = (/
     1   '_reflns_number_total            ',
     2   '_reflns_number_gt               ',
     3   '_reflns_threshold_expression    ',
     4   '_reflns_limit_h_max             ',
     5   '_reflns_limit_h_min             ',
     6   '_reflns_limit_k_max             ',
     7   '_reflns_limit_k_min             ',
     8   '_reflns_limit_l_max             ',
     9   '_reflns_limit_l_min             ',
     *   '_reflns_d_resolution_high       ',
     1   '_reflns_d_resolution_low        ',
     2   '_refine_ls_structure_factor_coef'/)

      character(len=32), dimension(19) :: key8 = (/
     1   '_refine_ls_matrix_type          ',
     2   '_refine_ls_hydrogen_treatment   ',
     3   '_refine_ls_weighting_scheme     ',
     4   '_refine_ls_weighting_details    ',
     5   '_refine_ls_number_reflns        ',
     6   '_refine_ls_number_parameters    ',
     7   '_refine_ls_number_restraints    ',
     8   '_refine_ls_number_constraints   ',
     9   '_refine_ls_R_factor_all         ',
     *   '_refine_ls_R_factor_gt          ',
     1   '_refine_ls_wR_factor_all        ',
     2   '_refine_ls_wR_factor_gt         ',
     3   '_refine_ls_goodness_of_fit_all  ',
     4   '_refine_ls_goodness_of_fit_gt   ',
     5   '_refine_ls_shift/su_max         ',
     6   '_refine_ls_shift/su_mean        ',
     7   '_refine_diff_density_max        ',
     8   '_refine_diff_density_min        ',
     9   '_refine_diff_density_rms        '/)

      character(len=32), dimension( 3) :: key13 = (/
     1   '_computing_structure_refinement ',
     2   '_computing_molecular_graphics   ',
     3   '_computing_publication_material '/)

!
      END MODULE CIF
!-----------------------------------------------------------------------
      MODULE Poliedri
!
      integer                    :: kpunt
      integer                    :: nva, ipco(10), LastSite
      integer                    :: ipuntx(96), limitipol(100,3)
      integer                    :: ifUpdated = 0
      integer, dimension(4000)   :: iEquinew, ipuntot
      real                       :: box(3,2)
      real, dimension(3,2000)    :: xp
      real, dimension(3,4000)    :: xx
!
      END MODULE Poliedri
!-----------------------------------------------------------------------
      MODULE BuildStuff
             integer              :: MaxAtomsBuild
             integer              :: nats600
             integer              :: nats20
             integer              :: lflValue
             integer              ::num_legami_max
!
!             integer, allocatable :: nconten(:)
!             integer, allocatable :: nordori(:)
!             integer, allocatable :: mg(:)
!             integer, allocatable :: kkblock(:)
!             integer, allocatable :: iizpk(:)
!             integer, allocatable :: nzsa(:)
!             integer, allocatable :: kblocksav(:)
!             integer, allocatable :: nnz(:)
             integer, allocatable :: numfr(:)
             integer, allocatable :: idfrag(:)
             integer, allocatable :: jdfrag(:)
             integer, allocatable :: ianel(:)
             integer, allocatable :: isol(:)
             integer, allocatable :: movefr(:)
             integer, allocatable :: mfra(:)
             integer, allocatable :: jfisspk(:)
             integer, allocatable :: jfissfr(:)
             integer, allocatable :: jfrag(:)
             integer, allocatable :: kvet(:,:)
             integer, allocatable :: icogr(:)
             integer, allocatable :: icopf(:)
!             integer, allocatable :: kvett(:,:)
             real,    allocatable :: baric(:,:)
             real,    allocatable :: xyzbu(:,:)
!             real,    allocatable :: xyzsav(:,:)
             real,    allocatable :: rxyzs(:,:)
             real,    allocatable :: groupatomi(:)
!
             integer, allocatable :: nord_coppia(:)
             integer, allocatable :: nord_picco1_coppia(:)
             integer, allocatable :: nord_picco2_coppia(:)
             integer, allocatable :: nopsym_picco2_coppia(:)
             integer, allocatable :: kodice_dist(:)
             real,    allocatable :: dist_coppia(:)
             real,    allocatable :: distxyz_coppia(:,:)
             integer, allocatable :: atomo_in_coppie(:,:)
             integer, allocatable :: atomo_in_angoli(:,:)
             integer, allocatable :: legami_atomo(:,:)
             integer, allocatable :: LongConnect(:,:)
             integer, allocatable :: kluster(:)
             integer, allocatable :: intens_legati(:)
             integer, allocatable :: incomp_atomi(:,:)
             real,    allocatable :: storeb(:)
      common/avvis/mosso(2500),mosso2(2500),kpsfra(2500),numpsfr(2500)
     1 ,tabdst(6,2500),numcop0,numcop1,numcop2,numang,tabang(10,5000)
     1 ,angolomn,angolomx

      END MODULE BuildStuff
!-----------------------------------------------------------------------
      MODULE BuildModule
!
!-- 28/03/07 -- build dimensionato a 1000 atomi
!
      common/inpcl/ntype,ttype(10,5),nprojj,nbond,dmaxi,radnew(8)
      dimension ltype(10,5)
      equivalence(ttype,ltype)
!
!g    common/xbuil/ift1,ift2,ift3,nflb,npeahi,ngrup,nfrag,ngh,ngl
!g   1,dmax,dmin,g(18),dmn(9),dmx(9),dmnmx(9,9,2),angi(3),angs(3)
!g   2,l3dum,md,lclus,mclus,laddr,ldis,mddis,lang,lnegl,mnegl,nnegl
!g   3,ladcon,lcon,mcon,ncon,mdcon,ladinc,linc,minc,mdinc,lcon1
!g   4,ive(9),ive3i(9),ive3s(9),ive15i(9),ive15s(9)
!g   5,icopk(9),icoel(9), groupatomi(180)
      common/xbuil/ift1,ift2,ift3,nflb,npeahi,ngrup,nfrag,ngh,ngl
!g   1,dmax,dmin,g(18),dmn(18),dmx(18),dmnmx(18,18,2),angi(3),angs(3)
     1,dmax,dmin,      dmn(18),dmx(18),dmnmx(18,18,2),angi(3),angs(3)
     2,l3dum,md,lclus,mclus,laddr,ldis,mddis,lang,lnegl,mnegl,nnegl
     3,ladcon,lcon,mcon,ncon,mdcon,ladinc,linc,minc,mdinc,lcon1
     4,ive(18),ive3i(18),ive3s(18),ive15i(18),ive15s(18)
     5,icopk(18), icoel(18) !??!,groupatomi(180)
!
*     common /chgx/ rxyzs(5,9000)             ,kgru(3000),nkgru
      common /chgx/                            kgru(3000),nkgru
c     1,intnew(3000),intsom(2,500),kooktab(2,500,500)
     1,intnew(3000),intsom(2,1000),kooktab(2,1000,1000)
*    2,nkook(2,500), norang(4,10000),lpicen(30,500),npicen
c     2,nkook(2,500),norang(4,10000),lpicen(100,500),npicen
c     3,nnor(500),maxnkook(500),incomp(2,3000)
     2,nkook(2,1000), norang(4,10000),lpicen(100,1000),npicen
     3,nnor(1000),maxnkook(1000),incomp(3,3000),angolo(10000)
!!mrc--genhy
!!mr      common/xhidro/lconbuf,ipa1,ipa2,pa3,pa4,distch
!!mr     1,ionly,iup,n5max,n5sym,lcon2
!
!      common /prevbuild/ lapp, lappleg, nflbld, ninsiemi, nnats,
!     1        distres, kinsieme, barisav(3), barx(3), nulim, nulim2,
!     2        nsansym, nsancentr, nsaicent, angmnmx(2,9), cangmnmx(2,9)
       common /prevbuild/  barisav(3), barx(3)
!
      END MODULE BuildModule
! ----------------------------------------------------------------------
      MODULE TestStuff
             complex, allocatable :: FT(:)
             integer              :: ifFloatOrigin ! use sum(vpol)
             integer              :: interv
             real                 :: percRefl, sogliaSg, sogliaRs
      END MODULE TestStuff
!-----------------------------------------------------------------------
      MODULE HistoMatch
             real, allocatable    ::  hisobcoLocal(:,:)
      END MODULE HistoMatch
!-----------------------------------------------------------------------
      MODULE Geometry
             integer              :: numtable
             integer              :: lunglist(10)
             integer              :: jcif
             integer              :: isave
             integer              :: idev
             integer              :: ndev
             integer              :: ncol
             integer              :: nfix
             integer              :: NumPlane = 0
             integer              :: NumLine = 0
             integer              :: NumPlaneCurr = 0
             integer              :: NumLineCurr = 0
             character(len=60)    :: TitlePlane(100)
             character(len=16)    :: LabPlane(100)
             real                 :: CoefPlane(4,100)
             real                 :: CoefPlane_dev(4,100)
             integer              :: IndPlaneCurr(2)
             character(len=60)    :: TitleLine(100)
             character(len=16)    :: LabLine(100)
             real                 :: CoefLineXG(3,100)
             real                 :: CoefLineXG_dev(3,100)
             real                 :: CoefLineU(3,100)
             real                 :: CoefLineU_dev(3,100)
             integer              :: IndLineCurr(2)
!--from parst96--
             integer              :: nn
             real*8               :: m1dp
             real*8               :: m2dp
             real*8               :: m3dp
             real*8               :: m4dp
             real*8               :: cpp
             real*8               :: up
!--end
      END MODULE Geometry
!-----------------------------------------------------------------------
      MODULE SuperFast
          real , allocatable :: ScattVett(:,:)
      END MODULE SuperFast
!-----------------------------------------------------------------------
      MODULE CowMod
         common /super4/ ncycl4(100), percc4(100), nmaMa4
         integer :: nmaMa4, ncycl4
         real    :: percc4
!
         common /dada/ ncol, ndim1, ndim2
         integer :: ncol, ndim1, ndim2
         integer :: LoadedWt = 0
         real,    allocatable :: distrPesi(:)
!
      END MODULE CowMod
!-----------------------------------------------------------------------
      subroutine StartSuperFast
      USE General
      USE Riflessi
      USE SuperFast
!
      implicit none
      integer :: i, j, ier
      real    :: ScattFact
!
      if (.not. allocated(ScattVett)) then
          allocate (ScattVett(1:nk, 1:nrefl), stat = ier)
          do i=1, nrefl
             do j=1, nk
                ScattVett(j,i) = ScattFact(j, rhov(i))
             enddo
          enddo
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaHistoMatch(iAction, npunti)
      USE HistoMatch
!
      integer ier(4), iAction, npunti, k
!
      ier(:) = 0
      if (iAction == 1) then
          if (.not. allocated(hisobcoLocal)) then
              allocate (hisobcoLocal(4,npunti), stat = ier(1))
          else
              k = size(hisobcoLocal(4,:))
              if (npunti > k) then
                  deallocate (hisobcoLocal, stat = ier(2))
                  allocate (hisobcoLocal(4,npunti), stat = ier(1))
              endif
          endif
          hisobcoLocal(:,:) = 0.0
          ierr = 0
          ierr = sum(iabs( ier(:) ))
          if (ierr /= 0) then
              write(lo,*) 'HistoMatc Allocation/Deallocation error'
              call cstop(' ')
          endif
      else
          IF (allocated(hisobcoLocal))
     *        deallocate (hisobcoLocal, stat = ier(1))
          if (ier(1) /= 0) then
              write(lo,*) 'HistoMatc Deallocation error'
              call cstop(' ')
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaRiflessi(iAction)
      USE General
      USE Riflessi
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      ierr = 0
!
      if (iAction == 1) then
          if (.not. allocated(khl)) then
              call AllocaVeramenteRiflessi(nreflDim, kmad, ifTwin, 
     *                                     nDataSets, nds)
          else
              k = size(khl(3,:))
              if (nreflDim > k) then
                  deallocate (CodeRefl, epsv, evet, fcoef, fcvet, fovet,
     *            iphaz,ipub, iwork1, iwork2, khl, mkang, mult, rhov, 
     *            sigmav, tmpwt, work1, work2, wt, iphazo, worko, wvar,
     *            Dluz,pesMod, iworkt, varia, jwork1, fovet_mod, fovet2,
     *            sigmav2, wto, iphio, wt_in, iphaz_in, fcvetp, fcvetv,
     *            vettoreSigma, tmp_ec, sumff, sumffMod, rfree1, 
     *            wtt_o, foper, fc_burla, iphaz_burla, 
     *            wt_burla, stat = ierr)


                  if (QualePgm == SIRPROTPGM) then
                      if (allocated(jjhkl))
     *                    deallocate (jjhkl, ecvet, e1, e2, 
     *                    dreso, inobs, wtt1, iphad, wtd, iphi2_in, 
     *                    wtt_in, iphi2_o, ifasi, pesi, fmod, 
     *                    emod, free1, free2, jinc1, ecoef, 
     *                    sigfcoef, fper, iphper,
     *                    iphoper, alpha, sigNa, segni1, segni, 
     *                    iphazCO, iconto, mFoDFc, twomFoDfc, phimFoDFc,
     *                    phitwomFoDfc, stat = ierr)
                  endif
                  if (kmad /= 0) then
                      if (allocated(fDeriv))
     *                    deallocate (fDeriv, sDeriv , eDeriv,
     *                                fHeavy, sHeavy , eHeavy,
     *                                fNativ, sNativ , eNativ,
     *                                iorde, SigmaaVal, stat = ierr)
                  endif
                  InfoOK(6) = 0
                  if (ierr.ne.0) then
                      write(*,*) 'Riflessi DeAllocation Error'
                      call cstop(' ')
                  endif
                  call AllocaVeramenteRiflessi(nreflDim, kmad, ifTwin,
     *                                         nDataSets, nds)
              endif
          endif
!
          khl(:,:)   = 0 ; evet(:)   = 0 ; fovet(:)     = 0 
          mkang(:)   = 0 ; sigmav(:) = 0 ; varia(:)     = 0
          ipub(:)    = 0 ; rhov(:)   = 0 ; iwork1(:)    = 0
          jwork1(:)  = 0 ; iwork2(:) = 0 ; iphaz(:)     = 0
          iphazo(:)  = 0 ; fcvet(:)  = 0 ; work1(:)     = 0
          work2(:)   = 0 ; worko(:)  = 0 ; epsv(:)      = 0
          wt(:)      = 0 ; fcoef(:)  = 0 ; tmpwt(:)     = 0
          pesMod(:)  = 0 ; fovet2(:) = 0 ; fovet_mod(:) = 0
          sigmav2(:) = 0 ; CodeRefl(:) = 0 ; rfree1     = 0
          wto        = 0 ; iphio     = 0 ; wt_in        = 0
          iphaz_in   = 0 ; fcvetp    = 0 ; fcvetv       = 0
          sumff(:)   = 0 ; sumffMod(:,:) = 0 ; wtt_o    = 0
          foper(:)   = 0 ; tmp_ec(:) = 0
          do i=1, nreflDim
             vettoreSigma(i) = i
          enddo

          if (QualePgm == SIRPROTPGM) then
              jjhkl      = 0 ; ecvet     = 0 ; phitwomFoDfc = 0 
              e1         = 0 ; e2        = 0 
              dreso      = 0 ; inobs     = 0 ; wtt1         = 0
              iphad      = 0 ; wtd       = 0 ; iphi2_in     = 0
              wtt_in     = 0 ; iphi2_o   = 0 
              ifasi      = 0 ; pesi      = 0 ; fmod         = 0
              emod       = 0 ; free1     = 0 ; free2        = 0
              jinc1      = 0 ; ecoef     = 0
              sigfcoef   = 0                 ; fper         = 0
              iphper     = 0                 ; iphoper      = 0
              alpha      = 0 ; sigNa     = 0 ; segni1       = 0
              segni      = 0 ; iphazCO   = 0 ; iconto       = 0
              mFoDFc     = 0 ; twomFoDfc = 0 ; phimFoDFc    = 0
          endif

          if (kmad /= 0) then
              fDeriv(:,:) = 0 ; sDeriv(:,:) = 0 ; eDeriv(:,:) = 0
              fHeavy(:,:) = 0 ; sHeavy(:,:) = 0 ; eHeavy(:,:) = 0
              fNativ(:)   = 0 ; sNativ(:)   = 0 ; eNativ(:)   = 0
              iorde(:)    = 0 ; SigmaaVal   = 0
          endif
!
          InfoOK(6) = 2
!
      else
          if (allocated(khl))
     *        deallocate (CodeRefl, epsv, evet, fcoef, fcvet, fovet,
     *        iphaz,ipub, iwork1, iwork2, khl, mkang, mult, rhov,
     *        sigmav, tmpwt, work1, work2, wt, iphazo, worko, wvar,
     *        Dluz,pesMod, iworkt, varia, jwork1, fovet_mod, fovet2,
     *        sigmav2, wto, iphio, wt_in, iphaz_in, fcvetp, fcvetv,
     *        vettoreSigma, tmp_ec, sumff, sumffMod, rfree1, 
     *        wtt_o, foper, fc_burla, iphaz_burla, wt_burla,stat = ierr)


              if (QualePgm == SIRPROTPGM) then
                  if (allocated(jjhkl))
     *                deallocate (jjhkl, ecvet, e1, e2,
     *                dreso, inobs, wtt1, iphad, wtd, iphi2_in,
     *                wtt_in, iphi2_o, ifasi, pesi, fmod,
     *                emod, free1, free2, jinc1, ecoef,
     *                sigfcoef, fper, iphper,
     *                iphoper, alpha, sigNa, segni1, segni,
     *                iphazCO, iconto, mFoDFc, twomFoDfc, phimFoDFc,
     *                phitwomFoDfc, stat = ierr)
              endif

          if (kmad /= 0) then
              if (allocated(fDeriv))
     *            deallocate (fDeriv, sDeriv , eDeriv,
     *                        fHeavy, sHeavy , eHeavy,
     *                        fNativ, sNativ , eNativ,
     *                        iorde, SigmaaVal, stat = ierr)
          endif
          InfoOK(6) = 0
          if (ierr.ne.0) then
              write(*,*) 'Riflessi DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaVeramenteRiflessi(nreflDim, kmad, ifTwin, 
     *                                   nDataSets, nds)
      USE General, only : QualePgm, SIRPROTPGM
      USE Riflessi
!
!-- Allocate Reflections arrays  -- Versione DEDI
!
      implicit none
      integer  :: ierr, ierv(100), nreflDim, kmad, ifTwin
      integer  :: nds, nDataSets
!
      ierv(:) = 0
      if (.not. allocated(CodeRefl))
     *     allocate (CodeRefl(1:nreflDim) ,stat = ierv(83))
      if (.not. allocated(khl)) 
     *     allocate (khl(1:3,1:nreflDim) ,stat = ierv( 1))
      if (.not. allocated(evet)) 
     *     allocate (evet(1:nreflDim)    ,stat = ierv( 2))
      if (.not. allocated(fovet)) 
     *     allocate (fovet(1:nreflDim)   ,stat = ierv( 3))
      if (.not. allocated(mkang)) 
     *     allocate (mkang(1:nreflDim)   ,stat = ierv( 4))
      if (.not. allocated(sigmav)) 
     *     allocate (sigmav(1:nreflDim)  ,stat = ierv( 5))
      if (.not. allocated(ipub)) 
     *     allocate (ipub(1:nreflDim)    ,stat = ierv( 6))
      if (.not. allocated(rhov)) 
     *     allocate (rhov(1:nreflDim)    ,stat = ierv( 7))
      if (.not. allocated(iwork1)) 
     *     allocate (iwork1(1:nreflDim)  ,stat = ierv( 8))
      if (.not. allocated(iwork2)) 
     *     allocate (iwork2(1:nreflDim)  ,stat = ierv( 9))
      if (.not. allocated(iphaz)) 
     *     allocate (iphaz(1:nreflDim)   ,stat = ierv(10))
      if (.not. allocated(fcvet)) 
     *     allocate (fcvet(1:nreflDim)   ,stat = ierv(11))
      if (.not. allocated(work1)) 
     *     allocate (work1(1:nreflDim)   ,stat = ierv(12))
      if (.not. allocated(work2)) 
     *     allocate (work2(1:nreflDim)   ,stat = ierv(13))
      if (.not. allocated(epsv)) 
     *     allocate (epsv(1:nreflDim)    ,stat = ierv(14))
      if (.not. allocated(wt)) 
     *     allocate (wt(1:nreflDim)      ,stat = ierv(15))
      if (.not. allocated(fcoef)) 
     *     allocate (fcoef(1:nreflDim)   ,stat = ierv(16))
      if (.not. allocated(tmpwt)) 
     *     allocate (tmpwt(1:nreflDim)   ,stat = ierv(17))
      if (.not. allocated(mult)) 
     *     allocate (mult(1:nreflDim)    ,stat = ierv(18))
      if (.not. allocated(iphazo))
     *     allocate (iphazo(1:nreflDim)  ,stat = ierv(19))
      if (.not. allocated(worko))
     *     allocate (worko(1:nreflDim)   ,stat = ierv(20))
      if (.not. allocated(wvar))
     *     allocate (wvar(1:nreflDim)   ,stat = ierv(21))
      if (.not. allocated(Dluz))
     *     allocate (Dluz(1:nreflDim)   ,stat = ierv(22))
      if (.not. allocated(pesMod))
     *     allocate (pesMod(1:nreflDim)   ,stat = ierv(23))
      if (.not. allocated(iworkt))
     *     allocate (iworkt(1:nreflDim)   ,stat = ierv(24))
      if (.not. allocated(varia))
     *     allocate (varia(1:nreflDim)   ,stat = ierv(25))
      if (.not. allocated(jwork1)) 
     *     allocate (jwork1(1:nreflDim)  ,stat = ierv(29))
      if (.not. allocated(fovet_mod))
     *     allocate (fovet_mod(1:nreflDim)   ,stat = ierv(30))
      if (.not. allocated(fovet2))
     *     allocate (fovet2(1:nreflDim)   ,stat = ierv(31))
      if (.not. allocated(sigmav2))
     *     allocate (sigmav2(1:nreflDim)   ,stat = ierv(32))
      if (.not. allocated(iphimod))
     *        allocate (iphimod(1:nreflDim), stat = ierv(81))
      if (.not. allocated(vettoreSigma))
     *        allocate (vettoreSigma(1:nreflDim), stat = ierv(82))
      if (.not. allocated(fc_burla))
     *        allocate (fc_burla(1:nreflDim), stat = ierv(84))
      if (.not. allocated(wt_burla))
     *        allocate (wt_burla(1:nreflDim), stat = ierv(85))
      if (.not. allocated(iphaz_burla))
     *        allocate (iphaz_burla(1:nreflDim), stat = ierv(86))
      if (.not. allocated(tmp_ec)) 
     *        allocate (tmp_ec(1:nreflDim),    stat = ierv(87))
! -- RiflessiSigmaa
      if (.not. allocated(wto))
     *     allocate (wto(1:nreflDim)           ,stat = ierv(72))
      if (.not. allocated(iphio))
     *     allocate (iphio(1:nreflDim)         ,stat = ierv(73))
      if (.not. allocated(wt_in))
     *     allocate (wt_in(1:nreflDim)         ,stat = ierv(74))
      if (.not. allocated(iphaz_in))
     *     allocate (iphaz_in(1:nreflDim)      ,stat = ierv(75))
!-- ex Riflessi1
      if (.not. allocated(fcvetp))
     *     allocate (fcvetp(1:nreflDim)   ,stat = ierv(76))
      if (.not. allocated(fcvetv))
     *     allocate (fcvetv(1:nreflDim)   ,stat = ierv(77))
          if (.not. allocated(rfree1))
     *     allocate (rfree1(1:nreflDim)        ,stat = ierv(78))
         if (.not. allocated(wtt_o))
     *     allocate (wtt_o(1:nreflDim)         ,stat = ierv(46))
         if (.not. allocated(foper))
     *     allocate (foper(1:nreflDim)         ,stat = ierv(60))
!-- REMO
      if (.not. allocated(sumffMod))
     *        allocate (sumffMod(1:nreflDim,1:10), stat = ierv(79))
      if (.not. allocated(sumff))
     *        allocate (sumff(1:nreflDim), stat = ierv(80))

      if (kmad /= 0 .or. ifTwin == 1) then
          if (.not. allocated(fDeriv))
     *     allocate (fDeriv(1:nreflDim,1:nDataSets)  ,stat = ierv(26))
          if (.not. allocated(sDeriv))
     *     allocate (sDeriv(1:nreflDim,1:nDataSets)  ,stat = ierv(27))
          if (.not. allocated(eDeriv))
     *     allocate (eDeriv(1:nreflDim,1:nDataSets)  ,stat = ierv(28))
          if (.not. allocated(fHeavy))
     *     allocate (fHeavy(1:nreflDim,1:nDataSets)  ,stat = ierv(26))
          if (.not. allocated(sHeavy))
     *     allocate (sHeavy(1:nreflDim,1:nDataSets)  ,stat = ierv(27))
          if (.not. allocated(eHeavy))
     *     allocate (eHeavy(1:nreflDim,1:nDataSets)  ,stat = ierv(27))
          if (.not. allocated(fNativ))
     *     allocate (fNativ(1:nreflDim)  ,stat = ierv(28))
          if (.not. allocated(sNativ))
     *     allocate (sNativ(1:nreflDim)  ,stat = ierv(28))
          if (.not. allocated(eNativ))
     *     allocate (eNativ(1:nreflDim)  ,stat = ierv(28))
          if (.not. allocated(iorde))
     *     allocate (iorde(1:nreflDim)         ,stat = ierv(37))
          if (.not. allocated(SigmaaVal))
     *     allocate (SigmaaVal(1:nreflDim)     ,stat = ierv(57))
      endif

!-- sirprot
      if (QualePgm == SIRPROTPGM) then

         if (.not. allocated(jjhkl))
     *     allocate (jjhkl(1:nreflDim)         ,stat = ierv(33))
         if (.not. allocated(ecvet))
     *     allocate (ecvet(1:nreflDim)         ,stat = ierv(34))
         if (.not. allocated(e1))
     *     allocate (e1(1:nreflDim)            ,stat = ierv(35))
         if (.not. allocated(e2))
     *     allocate (e2(1:nreflDim)            ,stat = ierv(36))
         if (.not. allocated(dreso))
     *     allocate (dreso(1:nreflDim)         ,stat = ierv(38))
         if (.not. allocated(inobs))
     *     allocate (inobs(1:nreflDim)         ,stat = ierv(39))
         if (.not. allocated(wtt1))
     *     allocate (wtt1(1:nreflDim)          ,stat = ierv(40))
         if (.not. allocated(iphad))
     *     allocate (iphad(1:nreflDim)         ,stat = ierv(41))
         if (.not. allocated(wtd))
     *     allocate (wtd(1:nreflDim)           ,stat = ierv(42))
         if (.not. allocated(iphi2_in))
     *     allocate (iphi2_in(1:nreflDim)      ,stat = ierv(43))
         if (.not. allocated(wtt_in))
     *     allocate (wtt_in(1:nreflDim)        ,stat = ierv(44))
         if (.not. allocated(iphi2_o))
     *     allocate (iphi2_o(1:nreflDim)       ,stat = ierv(45))
         if (.not. allocated(ifasi))
     *     allocate (ifasi(1:nreflDim)         ,stat = ierv(47))
         if (.not. allocated(pesi))
     *     allocate (pesi(1:nreflDim)          ,stat = ierv(48))
         if (.not. allocated(fmod))
     *     allocate (fmod(1:nreflDim)          ,stat = ierv(49))
         if (.not. allocated(emod))
     *     allocate (emod(1:nreflDim)          ,stat = ierv(50))
         if (.not. allocated(free1))
     *     allocate (free1(1:nreflDim)         ,stat = ierv(51))
         if (.not. allocated(free2))
     *     allocate (free2(1:nreflDim)         ,stat = ierv(52))
         if (.not. allocated(jinc1))
     *     allocate (jinc1(1:nreflDim)         ,stat = ierv(54))
         if (.not. allocated(ecoef))
     *     allocate (ecoef(1:nreflDim)         ,stat = ierv(55))
         if (.not. allocated(sigfcoef))
     *     allocate (sigfcoef(1:nreflDim)      ,stat = ierv(56))
         if (.not. allocated(fper))
     *     allocate (fper(1:nreflDim)          ,stat = ierv(58))
         if (.not. allocated(iphper))
     *     allocate (iphper(1:nreflDim)        ,stat = ierv(59))
         if (.not. allocated(iphoper))
     *     allocate (iphoper(1:nreflDim)       ,stat = ierv(61))
         if (.not. allocated(alpha))
     *     allocate (alpha(1:nreflDim)         ,stat = ierv(62))
         if (.not. allocated(sigNa))
     *     allocate (sigNa(1:nreflDim)         ,stat = ierv(63))
         if (.not. allocated(segni1))
     *     allocate (segni1(1:nreflDim)        ,stat = ierv(64))
         if (.not. allocated(segni))
     *     allocate (segni(nds-1,1:nreflDim)   ,stat = ierv(65))
         if (.not. allocated(iphazCO))
     *     allocate (iphazCO(1:nreflDim)       ,stat = ierv(66))
         if (.not. allocated(iconto))
     *     allocate (iconto(1:nreflDim)        ,stat = ierv(67))
         if (.not. allocated(mFoDFc))
     *     allocate (mFoDFc(1:nreflDim)        ,stat = ierv(68))
         if (.not. allocated(twomFoDfc))
     *     allocate (twomFoDfc(1:nreflDim)     ,stat = ierv(69))
         if (.not. allocated(phimFoDFc))
     *     allocate (phimFoDFc(1:nreflDim)     ,stat = ierv(70))
         if (.not. allocated(phitwomFoDfc))
     *     allocate (phitwomFoDfc(1:nreflDim)  ,stat = ierv(71))

      endif 
!
      ierr = sum(iabs(ierv(:)))
      if (ierr /= 0) then
          write(*,*) 'Riflessi Allocation error'
          call cstop(' ')
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaAtomi(iAction)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE RemoModule
!
      integer           :: YYY
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      integer ierv(100)
!
*     if (iAction == 1 .and. Allocated(xyzs)) then
*         return
*     endif
      ierv(:) = 0
      ierr = 0
      
!
      if (iAction <= 1) then
!
!-- compute MaxAtoms
!
          if (iAction < 0) then
              Hydrogens=0.
              if (nats.lt.3000) then
                  do i=1,nk
                     noi=no(i)
                     if (noi >= 6 .and. noi <= 8) then
                         Hydrogens = Hydrogens + nw(i)
                     endif
                  enddo
                  Hydrogens=2*Hydrogens
              endif
              MaxAtoms=nint((float(nats)+Hydrogens)*1.5)+20
              if (ksize <= 3) then
                  MaxAtoms = 3 * MaxAtoms
              endif
          else
              if (no(1) == 1) then
                  Hydrogens = float( nw(1) ) / totop
              else
                  Hydrogens =  0.0
              endif
              MaxAtoms = nint( anat * 1.5 + Hydrogens ) + 20
!             if (ksize <= 2 .and. neutro == 2) MaxAtoms = 3 * MaxAtoms
              if (ksize <= 3) then
                  MaxAtoms = 3 * MaxAtoms
              endif
          endif
          MaxBonds = 9 * MaxAtoms
          if (MaxBonds <= 9800 .or. ifRemo == 1) MaxBonds = 9800
          MaxBondH = MaxBonds
          MaxBond3 = 3 * MaxBonds
          if (.not. allocated(xyzs)) then
            call AllocaVeramenteAtomi(MaxBond3, ifRemo, neutro)
            call AllocaMolcom(1)
            if (.not. allocated(natsInModel)) then
                call AllocaModelRemo(0)
            endif
            if (.not. allocated(BondsInModel)) then
                call AllocaBonds(0)
            endif
            natsInModel(:) = MaxAtoms
          else
            k = size(xyzs(5,:))
            if (MaxAtoms > k) then
              Deallocate (xyzs,nz, nzHydro ,serial, bfac, stat=ierv( 1))
              Deallocate (kblock,bij ,jSingleColor, iconn,stat=ierv( 2))
              Deallocate (jconn,iconn15 ,iconn30,iconnori,stat=ierv( 3))
              Deallocate (iconnSav,iconnSk ,iconnH,       stat=ierv( 4))
              Deallocate (xyzs_dev,bij_dev,bfac_dev,      stat=ierv( 5))
              Deallocate (ibridgl,aLab, xyzo, nzo, bSav,  stat=ierv( 6))
              Deallocate (aLabOld,xyz15, nz15, serial15,  stat=ierv( 7))
              Deallocate (bfac15,aLab15, xyz30, nz30,     stat=ierv( 8))
              Deallocate (serial30,bfac30, aLab30, occsav,stat=ierv( 9))
              Deallocate (nzsav,fvar, qvar, qq, xyzs4,    stat=ierv(10))
              Deallocate (izpk,numbTemp, ifChanged,       stat=ierv(11))
              Deallocate (IfChangedB,noAtom,              stat=ierv(12))
              Deallocate (IsoAniso,Ell, semax, cd,xyzSk,  stat=ierv(13))
              Deallocate (SiteInfo, InfoResidui,          stat=ierv(14))
              Deallocate (iGeomAtom,jFlagAtom,iBridiz,    stat=ierv(15))
              Deallocate (jFlagAtom1, Occ_dev,OccX_dev,   stat=ierv(16))
              Deallocate (occpch,                         stat=ierv(17))
              Deallocate (iSite,nGrCode,nGrAtCode,        stat=ierv(18))
              Deallocate (aLab25,work25,xyzs25,           stat=ierv(19))
              Deallocate (xyzs25_dev,Adr25to5,            stat=ierv(20))
              Deallocate (bfac25,bij25,                   stat=ierv(21))
              Deallocate (aLab26,work26,xyzs26,           stat=ierv(22))
              Deallocate (xyzs26_dev,Adr26to5,            stat=ierv(23))
              Deallocate (bfac26,bij26,                   stat=ierv(24))
              if (Allocated(deltaf)) then
              Deallocate (deltaf,qvet,apdSir,bpdSir,kcond,stat=ierv(25))
              endif
              call AllocaMolcom(2)
              call AllocaVeramenteAtomi(MaxBond3, ifRemo, neutro)
              call AllocaMolcom(1)
            endif
          endif
!
          bij(:,1:MaxAtoms)      = 0 ; bij_dev(:,1:MaxAtoms)     = 0
          SiteInfo(:,1:MaxAtoms) = 0 ; Occ_dev(1:MaxAtoms)       = 0
          OccX_dev(:,1:MaxAtoms) = 0 ; bfac(1:MaxAtoms)          = 0
          bfac_dev(1:MaxAtoms)   = 0 ; IsoAniso(1:MaxAtoms)      = 2 !tutti iso
          serial(1:MaxAtoms)     = 0 ; serial15(1:MaxAtoms)      = 0
          serial30(1:MaxAtoms)   = 0 ; xyzs(:,1:MaxAtoms)        = 0
          xyzs_dev(:,1:MaxAtoms) = 0 ; InfoResidui(:,1:MaxAtoms) = 0
          iconn(1:MaxBond3)      = 0 ; aLab(1:MaxAtoms)          = ' '
          jconn(1:MaxBond3)      = 0 ; iconn15(1:MaxBond3)       = 0
          iconn30(1:MaxBond3)    = 0 ; iconnSav(1:MaxBond3)      = 0
          iconnSk(1:MaxBond3)    = 0 ; iconnH(1:MaxBondH)        = 0
          iconnori(1:MaxBond3)   = 0 ; nz(1:MaxAtoms)            = 0
          iGeomAtom(1:MaxAtoms)  = 0 ; jFlagAtom(1:MaxAtoms)     = 0
          jFlagAtom1(1:MaxAtoms) = 0 ; iBridiz(1:MaxAtoms)       = 0
          iSite(1:MaxAtoms)      = 0 ; nGrCode(1:MaxAtoms)       = 0
!                occpch: al momento = 1, da sistemare (occ. chimica)
          nGrAtCode(1:MaxAtoms)  = 0 ; occpch(1:MaxAtoms)        = 1
          nzTot(1:MaxAtomsInGr)  = 0 ; noAtom(1:MaxAtoms)        = 0
      else
          nats = 0
          NatMol = 0
          IF (Allocated(xyzs) .or. Allocated(bfac)) then
              MaxAtoms = 0
              Deallocate (xyzs,nz,                        stat=ierv( 1))
              Deallocate (nzHydro ,serial, bfac,          stat=ierv( 1))
              Deallocate (kblock,bij ,jSingleColor, iconn,stat=ierv( 2))
              Deallocate (jconn,iconn15 ,iconn30,iconnori,stat=ierv( 3))
              Deallocate (iconnSav,iconnSk ,iconnH,       stat=ierv( 4))
              Deallocate (xyzs_dev,bij_dev,bfac_dev,      stat=ierv( 5))
              Deallocate (ibridgl,aLab, xyzo, nzo, bSav,  stat=ierv( 6))
              Deallocate (aLabOld,xyz15, nz15, serial15,  stat=ierv( 7))
              Deallocate (bfac15,aLab15, xyz30, nz30,     stat=ierv( 8))
              Deallocate (serial30,bfac30, aLab30, occsav,stat=ierv( 9))
              Deallocate (nzsav,fvar, qvar, qq, xyzs4,    stat=ierv(10))
              Deallocate (izpk,numbTemp, ifChanged,       stat=ierv(11))
              Deallocate (IfChangedB,                     stat=ierv(12))
              Deallocate (IsoAniso,Ell, semax, cd,xyzSk,  stat=ierv(13))
              Deallocate (SiteInfo, InfoResidui,          stat=ierv(14))
              Deallocate (iGeomAtom,jFlagAtom,iBridiz,    stat=ierv(15))
              Deallocate (jFlagAtom1, Occ_dev,OccX_dev,   stat=ierv(16))
              Deallocate (occpch, nzTot,noAtom,           stat=ierv(17))
              Deallocate (iSite,nGrCode,nGrAtCode,        stat=ierv(18))
              Deallocate (aLab25,work25,xyzs25,           stat=ierv(19))
              Deallocate (xyzs25_dev,Adr25to5,            stat=ierv(20))
              Deallocate (bfac25,bij25,                   stat=ierv(21))
              Deallocate (aLab26,work26,xyzs26,           stat=ierv(22))
              Deallocate (xyzs26_dev,Adr26to5,            stat=ierv(23))
              Deallocate (bfac26,bij26,                   stat=ierv(24))
              if (Allocated(deltaf)) then
              Deallocate (deltaf,qvet,apdSir,bpdSir,kcond,stat=ierv(25))
              endif
              if (Allocated(xyzNeutrons)) then
                  DeAllocate (xyzNeutrons, stat=ierv(26))
              endif
              call AllocaMolcom(2)
          endif
          ierr = sum(ierv(2:))
          if (ierr.ne.0) then
              write(*,*) 'Atomi DeAllocation Error'
              call cstop(' ')
          endif
          call AllocaMolcom(2)

      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaVeramenteAtomi(MaxBond3, ifRemo, neutro)
      USE Atomi
      USE Molcom
!
!-- Allocate Reflections arrays
!
      implicit none
      integer   :: YYY, ierr, ierv(100), MaxBond3, ifRemo, neutro
!
      ierv(:) = 0
!
      MaxAtomsInGr = 30000
      YYY = 1
      if (.not.Allocated(xyzs))
     *        Allocate(xyzs(1:5,1:MaxAtoms),     stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(xyzs_dev))
     *        Allocate(xyzs_dev(1:3,1:MaxAtoms), stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(nz))
     *        Allocate(nz(1:MaxAtoms),           stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(noAtom))
     *        Allocate(noAtom(1:MaxAtoms),       stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(nzHydro))
     *        Allocate(nzHydro(1:MaxAtoms),      stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(serial))
     *        Allocate(serial(1:MaxAtoms),       stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(bfac))
     *        Allocate(bfac(1:MaxAtoms),         stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(bfac_dev))
     *        Allocate(bfac_dev(1:MaxAtoms),     stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(kblock))
     *        Allocate(kblock(1:MaxAtoms),       stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(bij))
     *        Allocate(bij(1:6,1:MaxAtoms),      stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(SiteInfo))
     *        Allocate(SiteInfo(1:4,1:MaxAtoms), stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(bij_dev))
     *        Allocate(bij_dev(1:6,1:MaxAtoms),  stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(jSingleColor))
     *        Allocate(jSingleColor(1:MaxAtoms), stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(iconn))
     *        Allocate(iconn(1:MaxBond3+1),      stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(jconn))
     *        Allocate(jconn(1:MaxBond3+1),      stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(iconn15))
     *        Allocate(iconn15(1:MaxBond3+1),    stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(iconn30))
     *        Allocate(iconn30(1:MaxBond3+1),    stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(iconnSav))
     *        Allocate(iconnSav(1:MaxBond3+1),   stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(iconnSk))
     *        Allocate(iconnSk(1:MaxBond3),      stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(iconnH))
     *        Allocate(iconnH(1:MaxBondH),       stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(iconnori))
     *        Allocate(iconnori(1:MaxBond3+1),   stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(ibridgl))
     *        Allocate(ibridgl(1:MaxAtoms),      stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(nGrCode))
     *        Allocate(nGrCode(1:MaxAtoms),      stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(nGrAtCode))
     *        Allocate(nGrAtCode(1:MaxAtoms),    stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(jFlagAtom))
     *        Allocate(jFlagAtom(1:MaxAtoms),    stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(jFlagAtom1))
     *        Allocate(jFlagAtom1(1:MaxAtoms),   stat = ierv(YYY))
      YYY = YYY + 1
       if (.not.Allocated(iBridiz))   
     *        Allocate(iBridiz(1:MaxAtoms),      stat = ierv(YYY))
      YYY = YYY + 1
       if (.not.Allocated(iGeomAtom))
     *        Allocate(iGeomAtom(1:MaxAtoms),    stat = ierv(YYY))
      YYY = YYY + 1
       if (.not.Allocated(iSite))  then
              Allocate(iSite(1:MaxAtoms),        stat = ierv(YYY))
              call PassaVettoreInt(iSite, 4, MaxAtoms)
      endif
      YYY = YYY + 1
      if (.not.Allocated(aLab))
     *        Allocate(aLab(1:MaxAtoms),         stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(xyzo))
     *        Allocate(xyzo(1:5,1:MaxAtoms),     stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(nzo))
     *        Allocate(nzo(1:MaxAtoms),          stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(bSav))
     *        Allocate(bSav(1:MaxAtoms),         stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(aLabOld))
     *        Allocate(aLabOld(1:MaxAtoms),      stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(xyz15))
     *        Allocate(xyz15(1:5,1:MaxAtoms),    stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(nz15))
     *        Allocate(nz15(1:MaxAtoms),         stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(serial15))
     *        Allocate(serial15(1:MaxAtoms),     stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(bfac15))
     *        Allocate(bfac15(1:MaxAtoms),       stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(aLab15))
     *        Allocate(aLab15(1:MaxAtoms),       stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(xyz30))
     *        Allocate(xyz30(1:5,1:MaxAtoms),    stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(nz30))
     *        Allocate(nz30(1:MaxAtoms),         stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(serial30))
     *        Allocate(serial30(1:MaxAtoms),     stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(bfac30))
     *        Allocate(bfac30(1:MaxAtoms),       stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(aLab30))
     *        Allocate(aLab30(1:MaxAtoms),       stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(Occ_dev))
     *        Allocate(Occ_dev(1:MaxAtoms),      stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(OccX_dev))
     *        Allocate(OccX_dev(1:4,1:MaxAtoms), stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(occsav))
     *        Allocate(occsav(1:MaxAtoms),       stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(nzsav))
     *        Allocate(nzsav(1:MaxAtoms),        stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(fvar))
     *        Allocate(fvar(1:MaxAtoms),         stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(qvar))
     *        Allocate(qvar(1:MaxAtoms),         stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(qq))
     *        Allocate(qq(1:MaxAtoms),           stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(xyzs4))
     *        Allocate(xyzs4(1:MaxAtoms),        stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(izpk))
     *        Allocate(izpk(1:MaxAtoms),         stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(numbTemp))
     *        Allocate(numbTemp(1:MaxAtoms),     stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(ifChanged))
     *        Allocate(ifChanged(1:MaxAtoms),    stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(ifChangedB))
     *        Allocate(ifChangedB(1:MaxAtoms),   stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(IsoAniso))
     *        Allocate(IsoAniso(1:MaxAtoms),     stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(Ell))
     *        Allocate(Ell(1:3,1:3,1:MaxAtoms),  stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(semax))
     *        Allocate(semax(1:3,1:MaxAtoms),    stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(cd))
     *        Allocate(cd(1:3,1:3,1:MaxAtoms),   stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(xyzSk))
     *        Allocate(xyzSk(1:5,1:MaxAtoms),    stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(bfacSk))
     *        Allocate(bfacSk(1:MaxAtoms),       stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(occpch))
     *        Allocate(occpch(1:MaxAtoms),       stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(InfoResidui))
     *        Allocate(InfoResidui(4,1:MaxAtoms),stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(nzTot)) then
              Allocate(nzTot(MaxAtomsInGr)      ,stat = ierv(YYY))
              call PassaVettoreInt(nzTot, 3, MaxAtomsInGr)
          endif
!--ex list 25
      YYY = YYY + 1
      if (.not.Allocated(aLab25))
     *        Allocate(aLab25(1:MaxAtoms),       stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(work25))
     *        Allocate(work25(1:MaxAtoms),       stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(xyzs25))
     *        Allocate(xyzs25(1:5,1:MaxAtoms),   stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(xyzs25_dev))
     *        Allocate(xyzs25_dev(3,1:MaxAtoms), stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(Adr25to5))
     *        Allocate(Adr25to5(1:MaxAtoms),     stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(bfac25))
     *        Allocate(bfac25(1:MaxAtoms),         stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(bij25))
     *        Allocate(bij25(1:6,1:MaxAtoms),      stat = ierv(YYY))
!--end ex lista 25
!--ex list 26
      YYY = YYY + 1
      if (.not.Allocated(aLab26))
     *        Allocate(aLab26(1:MaxAtoms),       stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(work26))
     *        Allocate(work26(1:MaxAtoms),       stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(xyzs26))
     *        Allocate(xyzs26(1:5,1:MaxAtoms),   stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(xyzs26_dev))
     *        Allocate(xyzs26_dev(3,1:MaxAtoms), stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(Adr26to5))
     *        Allocate(Adr26to5(1:MaxAtoms),     stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(bfac26))
     *        Allocate(bfac26(1:MaxAtoms),         stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(bij26))
     *        Allocate(bij26(1:6,1:MaxAtoms),      stat = ierv(YYY))
!--end ex lista 26
      if (ifRemo == 0) then
          YYY = YYY + 1
          if (.not.Allocated(deltaf))
     *        Allocate(deltaf(1:5, 1:MaxAtoms),  stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(qvet))
     *        Allocate(qvet(1:5, 1:MaxAtoms),    stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(apdSir))
     *       Allocate(apdSir(1:5, 1:MaxAtoms),   stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(bpdSir))
     *       Allocate(bpdSir(1:5, 1:MaxAtoms),   stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(kcond))
     *        Allocate(kcond(1:5, 1:MaxAtoms),   stat = ierv(YYY))
      endif
      if (neutro == 1) then
          YYY = YYY + 1
          if (.not.Allocated(xyzNeutrons))
     *        Allocate(xyzNeutrons(1:5,1:MaxAtoms), stat = ierv(YYY))
      endif
!
      ierr = sum(ierv(1:YYY))
      if (ierr.ne.0) then
          write(*,*) 'Atomi Allocation Error'
          call cstop(' ')
      endif
      xyz15(:,:) = 0
      nz15(:) = 0
      bfac15(:) = 0
      nats15 = 0
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaMolcom(iAction)
      USE General
      USE Symmetry
      USE Molcom
!
      integer           :: YYY
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      dimension ierv(100)
!
      if (iAction == 1 .and. Allocated(xyz)) then
          return
      endif
      ierv(:) = 0
      ierr = 0
      
!
      if (iAction == 1) then
!
!-- compute MaxAtomsInGr & MaxBondsInGr
!
          MaxAtomsInGr = 30000
          MaxBondsInGr = 30000
!
          YYY = 1
          if (.not.Allocated(ipix)) then
              Allocate(ipix(1:3,1:MaxAtomsInGr),   stat = ierv(YYY))
              call PassaMatriceInt(ipix, YYY, 3, MaxAtomsInGr)
          endif
          YYY = YYY + 1
          if (.not.Allocated(ipixLab)) then
              Allocate(ipixLab(1:2,1:MaxAtomsInGr),stat = ierv(YYY))
              call PassaMatriceInt(ipixLab, YYY, 2, MaxAtomsInGr)
          endif
          YYY = YYY + 1
          if (.not.Allocated(It)) then
              Allocate(It(MaxAtomsInGr),stat = ierv(YYY))
              call PassaVettoreStr(It, MaxAtomsInGr)
          endif
          YYY = YYY + 1
          if (.not.Allocated(ifLabelsVis)) then
              Allocate(ifLabelsVis(MaxAtomsInGr),stat = ierv(YYY))
              IfLabelsVis(:) = 1
              call PassaVettoreInt(ifLabelsVis, 1, MaxAtomsInGr)
          endif
          YYY = YYY + 1
          if (.not.Allocated(SinglePlotType)) then
              Allocate(SinglePlotType(MaxAtomsInGr),stat = ierv(YYY))
              call PassaVettoreInt(SinglePlotType, 2, MaxAtomsInGr)
          endif
          YYY = YYY + 1
          if (.not.Allocated(xyz))
     *        Allocate(xyz(1:3,1:MaxAtomsInGr),    stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(xyLab))
     *        Allocate(xyLab(1:2,1:MaxAtomsInGr),  stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(LE))
     *        Allocate(LE(1:3,1:MaxBondsInGr),     stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(LE1))
     *        Allocate(LE1(1:3,1:MaxBondsInGr),    stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(RSCOPY))
     *        Allocate(RSCOPY(1:MaxAtomsInGr), stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(rMLU))
     *        Allocate(rMLU(1:MaxAtomsInGr),       stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(RS))
     *        Allocate(RS(1:MaxAtomsInGr),         stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(iCol))
     *        Allocate(iCol(1:MaxAtomsInGr),       stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(iOrd))
     *        Allocate(iOrd(1:MaxAtomsInGr),       stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(iEqui))
     *        Allocate(iEqui(1:MaxAtomsInGr),      stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(nOpEq))
     *        Allocate(nOpEq(1:MaxAtomsInGr),      stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(jdoppio))
     *        Allocate(jdoppio(1:MaxAtomsInGr),    stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(Lab))
     *        Allocate(Lab(1:MaxAtomsInGr),        stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(selezione))
     *        Allocate(selezione(1:MaxAtomsInGr),  stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(nOpEqBaric))
     *        Allocate(nOpEqBaric(1:MaxAtomsInGr), stat = ierv(YYY))
          YYY = YYY + 1
          if (.not.Allocated(nfragm))
     *        Allocate(nfragm(1:MaxAtomsInGr),     stat = ierv(YYY))
          ierr = sum(ierv(1:YYY))
          if (ierr.ne.0) then
              write(*,*) 'Molcom Allocation Error'
              call cstop(' ')
          endif
          nOpEq(:)  = 1555
          iCol(:)   = 0
          ipix(:,:) = 0
          xyz(:,:)  = 0.0
          RS(:)     = 0.0
*gl*      nOpEqBaric(:)  = 10000 ! sara' 1555
          nOpEqBaric(:)  = 1555
          nfragm(:)=0
          nfrag_ini=0
          LE(:,:) = 0
      else
          nats = 0
          NatMol = 0
          IF (Allocated(xyz)) then
              MaxAtoms = 0
              Deallocate (xyz,RSCOPY,rMLU,RS,xyLab,iCol,iOrd,iEqui, 
     *           nOpEq,jdoppio,LE,LE1,ipix,ipixLab,It, 
     *           SinglePlotType,ifLabelsVis,Lab,nOpEqBaric,
     *           nfragm,stat = ierr)
          endif
          if (ierr.ne.0) then
              write(*,*) 'Molcom DeAllocation Error'
              call cstop(' ')
          endif

      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaGrafici(iAction, npunti, ifTang)
      USE General
      USE Grafici
      USE Molcom
      integer :: ifTang
!
      if (iAction == 1) then

          if (.not. allocated(xpoints)) then
              nPointsGR = npunti
              if (ifRemo > 0) then
                  nGraficiGR = 3
                  kLarg = kscrx
                  kAlt  = kscry
                  HistoOK(:)  = 0
                  im  = 2
              elseif(kmad > 0) then
                  nGraficiGR = 3
                  kLarg = kscrx
                  kAlt  = kscry
                  HistoOK(:)  = 0
                  im  = 1
              else
                  if (ifTang == 1) then
                      nGraficiGR = 2
                  else
                      nGraficiGR = 1
                  endif
                  if (ifMadEnv == 0) then
                      if (ifTang == 1) then
                          kLarg = 300
                          kAlt  = 300
                      else
                          kLarg = 400
                          kAlt  = 280
                      endif
                  else
                      kLarg = kscrx
                      kAlt  = kscry
                  endif
                  HistoOK(:)  = 1
                  im  = 1
              endif
              allocate (xpoints(1:im*npunti,1:nGraficiGR), stat = ierv)
              allocate (ypoints(1:im*npunti,1:nGraficiGR), stat = ierv)
              allocate (colorGR(1:im*npunti,1:nGraficiGR), stat = ierv)
              allocate (MinMaxGR(1:4,1:nGraficiGR), stat = ierv)
              allocate (lPlots(1:nGraficiGR), stat = ierv)
              allocate (LabTrialsV(1:im*npunti), stat = ierv)

              allocate (nClust(1:im*npunti), stat = ierv)        !pgMAD1512

              lPlots(:) = 0
              xpoints(:,:) = 0
              ypoints(:,:) = 0
              MinMaxGR(1,:) = 0
              MinMaxGR(3,:) = 0
              MinMaxGR(2,:) = 1
              MinMaxGR(4,:) = 1
              QualeTic(:) = 0.0
!             LabTrials = 0
              LabTrialsV(:) = ' '
              nClust(:) = 0                                       !pgMAD1512
          endif
      else
          if (allocated(xpoints))
     *        deallocate(xpoints, ypoints, lPlots, colorGR, nClust,
     *                   MinMaxGR, LabTrialsV, stat = ierr)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaModelRemo(iAction)
      USE RemoModule
!     USE General, only: nk
!
!-- Allocate / Deallocate arrays  ( iAction = 0 / 1 / 2 )
!
      dimension ierv(30)
!
      ierv(:) = 0
      ierr = 0
c      nscont = 0
!
      if (iAction == 0) then
        if (.not. ALLOCATED(natsInModel)) then
           allocate (natsInModel(1:numbModels), stat = ierr)
           
           allocate (FcScaleInModel(1:numbModels), stat = ierr) 
           allocate (FcBisoInModel(1:numbModels), stat = ierr) 
           allocate (FcExtinInModel(1:numbModels), stat = ierr) 
           allocate (FcPolaInModel(1:numbModels), stat = ierr) 
           allocate (FcTwinInModel(1:numbModels), stat = ierr) 
           allocate (Overall_devInModel(1:5,1:numbModels), stat = ierr) 
           
           natsInModel(:)    = 0
c          MonomerInModel(:) = 1
           FcScaleInModel(:) = -1.0
           FcBisoInModel(:)  = 3.0
           FcExtinInModel(:) = 0.0
           FcPolaInModel(:)  = 0.0
           FcTwinInModel(:)  = 0.0
           Overall_devInModel(:,:) = 0.0

        endif
        if (.not. ALLOCATED(model)) then
           allocate (model(1:numbModels), stat = ierr)
        endif
        if (.not. ALLOCATED(InfoOnModels)) then
           allocate (InfoOnModels(1:numbModels), stat = ierr)
        endif
      elseif (iAction == 1) then
c        do i=1,18
c           if(nSpecie(i)>0)nscont=nscont+1
c        enddo
        if (allocated(model)) then
            call AllocaModello(WhichModel, ierr)
            if (ierr /= 0) then
                write(*,*) 'RemoModel Allocation Error'
                call cstop(' ')
            endif
        else
           write(*,*) 'RemoModel Allocation-sequence Error'
           call cstop(' ')
        endif
!
        if (ierr.ne.0) then
           write(*,*) 'RemoModel Allocation Error'
           call cstop(' ')
        endif
        
      else
      
        if (allocated(natsInModel)) then
            deallocate (natsInModel, stat = ierr)
            
            deallocate (FcScaleInModel, stat = ierr)
            deallocate (FcBisoInModel, stat = ierr)
            deallocate (FcExtinInModel, stat = ierr)
            deallocate (FcPolaInModel, stat = ierr)
            deallocate (FcTwinInModel, stat = ierr)
            deallocate (Overall_devInModel, stat = ierr)
            
        endif
        
        if (allocated(model)) then
           if (allocated(model(1)%atoms)) then
               do i=1,size(model)
                  call DeallocaModello(i, ierr)
               enddo
           endif
           deallocate (model, InfoOnModels, stat = ierr)
        endif
!
        if (ierr.ne.0) then
           write(*,*) 'RemoModel DeAllocation Error'
           call cstop(' ')
        endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaModello(i, ierr)
      USE RemoModule
!
      implicit none
      integer :: i, j, ierr, ierv(100), natom, Mono
!
      ierr    = 0
      ierv(:) = 0
      natom = natsInModel(i)
      Mono = MonomerInModel(i)
!
      if (allocated(model(i)%atoms)) then
          return
      endif
      allocate (model(i)%atoms(5,natom,Mono),     stat = ierv( 1))
      allocate (model(i)%saved(3,natom,Mono),     stat = ierv( 2))
      allocate (model(i)%ortho(3,natom,Mono),     stat = ierv( 3))
      allocate (model(i)%specie(natom,Mono),      stat = ierv( 4))
      allocate (model(i)%th_fact(natom,Mono),     stat = ierv( 5))
      allocate (model(i)%tipoAtomo(natom,Mono),   stat = ierv( 6))
      allocate (model(i)%tipoResiduo(natom,Mono), stat = ierv( 7))
      allocate (model(i)%Alternate(natom,Mono),   stat = ierv( 8))
      allocate (model(i)%catena(natom,Mono),      stat = ierv( 9))
      allocate (model(i)%Secondary(natom,Mono),   stat = ierv(10))
      allocate (model(i)%Label(natom),            stat = ierv(11))
      allocate (model(i)%numResiduo(natom,Mono),  stat = ierv(12))
      allocate (model(i)%considerato(Mono),       stat = ierv(13))
      allocate (model(i)%IsoAniso(natom,Mono),    stat = ierv(14))
      allocate (model(i)%al(4,18),                stat = ierv(15))
      allocate (model(i)%bs(4,18),                stat = ierv(16))
      allocate (model(i)%cl(18),                  stat = ierv(17))
      allocate (model(i)%raggio(18,2),            stat = ierv(18))
      allocate (model(i)%no(18),                  stat = ierv(19))
      allocate (model(i)%nw(18),                  stat = ierv(20))
      allocate (model(i)%nalf(18),                stat = ierv(21))
      allocate (model(i)%bij(6,natom,Mono),       stat = ierv(22))
      allocate (InfoOnModels(i)%iEqui(natom),     stat = ierv(23))
      allocate (InfoOnModels(i)%SymOp(natom),     stat = ierv(24))
      allocate (model(i)%serial(natom),           stat = ierv(25))
      allocate (model(i)%SinglePlotType(natom),   stat = ierv(26))
      
      allocate (model(i)%iSite(natom),            stat = ierv(27))
      allocate (model(i)%SiteInfo(4,natom),       stat = ierv(28))
      allocate (model(i)%xyz_dev(3,natom,Mono),   stat = ierv(29))
      allocate (model(i)%occX_dev(4,natom),       stat = ierv(30))
      allocate (model(i)%th_fact_dev(natom,Mono), stat = ierv(31))
      allocate (model(i)%occ_dev(natom),          stat = ierv(32))
      allocate (model(i)%bij_dev(6,natom,Mono),   stat = ierv(33))
      allocate (model(i)%GeomAtom(natom),         stat = ierv(34))
      allocate (model(i)%Insertion(natom,Mono),   stat = ierv(35))
      allocate (model(i)%HETA(natom,Mono),        stat = ierv(36))
      allocate (model(i)%AtSpecies(natom,Mono),   stat = ierv(37))
!
      ierr = sum(iabs(ierv(:)))
      if (ierr == 0) then
          do j=1, natom
             model(i)%atoms(1:5,j,Mono)   = 0.0
             model(i)%saved(1:3,j,Mono)   = 0.0
             model(i)%ortho(1:3,j,Mono)   = 0.0
             model(i)%specie(j,Mono)      = 0
             model(i)%th_fact(j,Mono)     = 0.0
             model(i)%tipoAtomo(j,Mono)   = ' '
             model(i)%tipoResiduo(j,Mono) = ' '
             model(i)%Alternate(j,Mono)   = ' '
             model(i)%catena(j,Mono)      = ' '
             model(i)%Secondary(j,Mono)   = ' '
             model(i)%numResiduo(j,Mono)  = 0
             model(i)%Insertion(j,Mono)   = ' '
             model(i)%bij(1:6,j,Mono)     = 0
             model(i)%SinglePlotType(j)   = 0
             InfoOnModels(i)%iEqui(j)     = j
             InfoOnModels(i)%SymOp(j)     = 1
             
             model(i)%iSite(j)            = 0
             model(i)%SiteInfo(1:4,j)     = 0.0
             model(i)%xyz_dev(1:3,j,Mono) = 0.0
             model(i)%occX_dev(1:4,j)     = 0.0
             model(i)%th_fact_dev(j,Mono) = 0.0
             model(i)%occ_dev(j)          = 0.0
             model(i)%bij_dev(1:6,j,Mono) = 0.0
             model(i)%GeomAtom(j)         = 0
             model(i)%HETA(j,Mono)        = -1
             model(i)%AtSpecies(j,Mono)   = ' '
          end do
          model(i)%considerato(1:Mono) = 0
          model(i)%IsoAniso(:,:) = 0
          model(i)%al(1:4,:)   = 0.0
          model(i)%bs(1:4,:)   = 0.0
          model(i)%cl(:)       = 0.0
          model(i)%raggio(:,:) = 0.0
          model(i)%no(:)       = 0
          model(i)%nw(:)       = 0
          model(i)%nalf(:)     = 0
          model(i)%Label(:)    = ' '
          model(i)%serial(:)   = 0
          model(i)%nk          = 0
          model(i)%PDB         = 0
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DeallocaModello(i, ierr)
      USE RemoModule
!
      implicit none
      integer :: i, ierr, ierv(100)
!
      ierv(:) = 0
!
      deallocate (model(i)%atoms,          stat = ierv( 1))
      deallocate (model(i)%saved,          stat = ierv( 2))
      deallocate (model(i)%ortho,          stat = ierv( 3))
      deallocate (model(i)%specie,         stat = ierv( 4))
      deallocate (model(i)%th_fact,        stat = ierv( 5))
      deallocate (model(i)%tipoAtomo,      stat = ierv( 6))
      deallocate (model(i)%tipoResiduo,    stat = ierv( 7))
      deallocate (model(i)%Alternate,      stat = ierv( 8))
      deallocate (model(i)%catena,         stat = ierv( 9))
      deallocate (model(i)%Secondary,      stat = ierv(10))
      deallocate (model(i)%numResiduo,     stat = ierv(11))
      deallocate (model(i)%considerato,    stat = ierv(12))
      deallocate (model(i)%IsoAniso,       stat = ierv(13))
      deallocate (model(i)%al,             stat = ierv(14))
      deallocate (model(i)%bs,             stat = ierv(15))
      deallocate (model(i)%cl,             stat = ierv(16))
      deallocate (model(i)%raggio,         stat = ierv(17))
      deallocate (model(i)%no,             stat = ierv(18))
      deallocate (model(i)%nw,             stat = ierv(19))
      deallocate (model(i)%nalf,           stat = ierv(20))
      deallocate (model(i)%Label,          stat = ierv(21))
      deallocate (model(i)%bij,            stat = ierv(22))
      deallocate (model(i)%serial,         stat = ierv(23))
      deallocate (model(i)%SinglePlotType, stat = ierv(24))
      deallocate (InfoOnModels(i)%iEqui,   stat = ierv(25))
      deallocate (InfoOnModels(i)%SymOp,   stat = ierv(26))
      
      deallocate (model(i)%iSite,          stat = ierv(27))
      deallocate (model(i)%SiteInfo,       stat = ierv(28))
      deallocate (model(i)%xyz_dev,        stat = ierv(29))
      deallocate (model(i)%occX_dev,       stat = ierv(30))
      deallocate (model(i)%th_fact_dev,    stat = ierv(31))
      deallocate (model(i)%occ_dev,        stat = ierv(32))
      deallocate (model(i)%bij_dev,        stat = ierv(33))
      deallocate (model(i)%GeomAtom,       stat = ierv(34))
      deallocate (model(i)%Insertion,      stat = ierv(35))
      deallocate (model(i)%HETA,           stat = ierv(36))
      deallocate (model(i)%AtSpecies,      stat = ierv(37))
!
      ierr = sum(iabs(ierv(:)))
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaBonds(iAction)
      USE RemoModule
      USE Atomi, only : MaxBonds
!
!-- Allocate / Deallocate arrays  ( iAction = 0 / 1 / 2 / 99)
!
      dimension ierv(5)
!
      ierv(:) = 0
      ierr = 0
!
      if (iAction == 0) then
        if (.not. ALLOCATED(BondsInModel)) then
           allocate (BondsInModel(1:numbModels), stat = ierr)
           BondsInModel(:) = 0
        endif
        if (.not. ALLOCATED(Bonds)) then
           allocate (Bonds(1:numbModels), stat = ierv(1))
        endif
      elseif (iAction == 1) then
        if (allocated(Bonds)) then
            nBonds = BondsInModel(WhichModel)
            if (.not.allocated(Bonds(WhichModel)%Legami)) then
                allocate (Bonds(WhichModel)%Legami(4,MaxBonds),
     *                    stat = ierv(2))
            endif
            do i=1,size(ierv)
               ierr = ierr + iabs( ierv(i) )
            enddo
            if (ierr == 0) then
                do j=1, nBonds
                   Bonds(WhichModel)%Legami(1:4,j)   = 0.0
                end do
            else
                write(*,*) 'Connectivity Allocation Error'
                call cstop(' ')
            endif
        else
           write(*,*) 'Connectivity Allocation-sequence Error'
           call cstop(' ')
        endif
!
        if (ierr.ne.0) then
           write(*,*) 'Connectivity Allocation Error'
           call cstop(' ')
        endif
      elseif (iAction == 99) then
        if (allocated(BondsInModel)) then
            deallocate (BondsInModel, stat = ierr)
        endif
        if (allocated(Bonds)) then
           do i=1,numbModels
              if (allocated(Bonds(i)%Legami)) then
                  deallocate (Bonds(i)%Legami)
              endif
           end do
           deallocate (Bonds, stat = ierr)
        endif
!
        if (ierr.ne.0) then
           write(*,*) 'Connectivity DeAllocation Error'
           call cstop(' ')
        endif
      else
        if (allocated(Bonds(WhichModel)%Legami)) then
            deallocate (Bonds(WhichModel)%Legami, stat = ierr)
        endif
      endif

!
      return
      end
!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
      subroutine AllocaMappaAutre(iAction)
      USE MappaAutre

!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      ierr = 0
      if (iAction == 1) then
          if (.NOT. Allocated(xmapAutre)) then
              Allocate (xmapAutre(0:npAutre(1)-1,0:npAutre(2)-1,
     *                  0:npAutre(3)-1), stat = ierr)
              Allocate (xmapCa( 0:npAutre(1)/2,
     *                          0:npAutre(2)-1,
     *                          0:npAutre(3)-1), stat=ierr)
              if (ierr.ne.0) then
                  write(*,*) 'Map Allocation Error'
                  call cstop(' Allocation error')
              endif
              xmapAutre(:,:,:) = 0.0
              xmapCa(:,:,:) = cmplx(0.0, 0.0)
              FORTHa = 0
              BACKa = 0
          endif
      else
          IF (Allocated(xmapAutre))
     *        Deallocate (xmapAutre, xmapCa, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'Maps Deallocation Error'
              call cstop(' Allocation error')
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaBuildStuff(iAction)
      USE General, only: nk
      USE BuildStuff
      USE Atomi
!
      implicit none
      integer :: iAction, n, nn, ierv(100), ierr, rialloca
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
!
      ierv(:) = 0
      if (MaxAtomsBuild < 500) then
          MaxAtomsBuild = 500
      endif
      nn=2+2*num_legami_max
!      nats20=20*nats
!      nats600=600*nats

!
      if (iAction == 1) then
          rialloca = 0
          if (.not.Allocated(numfr)) then
              rialloca = 1
          elseif (MaxAtomsBuild > size(numfr)) then
              rialloca = 1
          elseif (nats20 > size(nord_coppia)) then
              rialloca = 1
          elseif (nats > size(kluster)) then
              rialloca = 1
          elseif (nats20*nn > size(LongConnect)) then
              rialloca = 1
          endif
          if (rialloca == 1) then  
              call DeAllocaBuildStuff
!
              n = 0
              n = n + 1
              if(.not.Allocated(numfr))
     *            Allocate(numfr(1:MaxAtomsBuild),       stat = ierv(n))
              n = n + 1
              if(.not.Allocated(idfrag))
     *            Allocate(idfrag(1:MaxAtomsBuild),      stat = ierv(n))
              n = n + 1
              if(.not.Allocated(jdfrag))
     *            Allocate(jdfrag(1:MaxAtomsBuild),      stat = ierv(n))
              n = n + 1
              if(.not.Allocated(ianel))
     *            Allocate(ianel(1:MaxAtomsBuild),       stat = ierv(n))
              n = n + 1
              if(.not.Allocated(isol))
     *            Allocate(isol(1:MaxAtomsBuild),        stat = ierv(n))
              n = n + 1
              if(.not.Allocated(movefr))
     *            Allocate(movefr(1:MaxAtomsBuild),      stat = ierv(n))
              n = n + 1
               if(.not.Allocated(mfra))
     *            Allocate(mfra(1:MaxAtomsBuild),        stat = ierv(n))
              n = n + 1
              if(.not.Allocated(jfisspk))
     *            Allocate(jfisspk(1:MaxAtomsBuild),     stat = ierv(n))
              n = n + 1
              if(.not.Allocated(jfissfr))
     *            Allocate(jfissfr(1:MaxAtomsBuild),     stat = ierv(n))
              n = n + 1
              if(.not.Allocated(jfrag))
     *            Allocate(jfrag(1:MaxAtomsBuild),       stat = ierv(n))
              n = n + 1
              if(.not.Allocated(kvet))
     *            Allocate(kvet(1:3,1:MaxAtomsBuild),    stat = ierv(n))
              n = n + 1
              if(.not.Allocated(icogr))
     *            Allocate(icogr(1:MaxAtomsBuild),       stat = ierv(n))
              n = n + 1
              if(.not.Allocated(icopf))
     *            Allocate(icopf(1:MaxAtomsBuild),       stat = ierv(n))
              n = n + 1
              if(.not.Allocated(baric))
     *            Allocate(baric(1:3,1:MaxAtomsBuild),   stat = ierv(n))
              n = n + 1
              if(.not.Allocated(xyzbu))
     *            Allocate(xyzbu(1:8,1:MaxAtomsBuild),   stat = ierv(n))
              n = n + 1
              if(.not.Allocated(rxyzs))
     *            Allocate(rxyzs(1:5,1:MaxAtomsBuild),   stat = ierv(n))
              n = n + 1
              if(.not.Allocated(groupatomi))
     *            Allocate(groupatomi(1:9*nk),           stat = ierv(n))
!
              n = n + 1
              if(.not.Allocated(nord_coppia))
     *            Allocate (nord_coppia(1:nats20),       stat = ierv(n))
              n = n + 1
              if(.not.Allocated(nord_picco1_coppia))
     *            Allocate (nord_picco1_coppia(1:nats20),stat = ierv(n))
              n = n + 1
              if(.not.Allocated(nord_picco2_coppia))
     *            Allocate (nord_picco2_coppia(1:nats20),stat = ierv(n))
              n = n + 1
              if(.not.Allocated(kodice_dist))
     *            Allocate (kodice_dist(1:nats20),       stat = ierv(n))
              n = n + 1
              if(.not.Allocated(dist_coppia))
     *            Allocate (dist_coppia(1:nats20),       stat = ierv(n))
              n = n + 1
              if(.not.Allocated(distxyz_coppia))
     *            Allocate (distxyz_coppia(1:nats20,1:3),stat = ierv(n))
              n = n + 1
              if(.not.Allocated(nopsym_picco2_coppia))
     *            Allocate (nopsym_picco2_coppia(1:nats20),stat=ierv(n))
              n = n + 1
              if(.not.Allocated(atomo_in_coppie))
     *            Allocate (atomo_in_coppie(1:nats20,1:nn),stat=ierv(n))
              n = n + 1
              if(.not.Allocated(atomo_in_angoli))
     *            Allocate (atomo_in_angoli(1:nats20,1:nn),stat=ierv(n))
              n = n + 1
              if(.not.Allocated(legami_atomo))
     *            Allocate (legami_atomo(1:nats20,1:nn), stat = ierv(n))
              n = n + 1
              if(.not.Allocated(LongConnect))
     *            Allocate (LongConnect(1:nats20,1:nn),  stat = ierv(n))
              n = n + 1
              if(.not.Allocated(kluster))
     *            Allocate (kluster(1:nats),             stat = ierv(n))
              n = n + 1
              if(.not.Allocated(intens_legati))
     *            Allocate (intens_legati(1:nats),       stat = ierv(n))
              n = n + 1
              if(.not.Allocated(incomp_atomi))
     *            Allocate (incomp_atomi(1:nats,1:nn),   stat = ierv(n))
!
              ierr = sum(ierv(1:n))
              if (ierr /= 0) then
                  write(*,*) 'BuildStuff Allocation Error'
                  call cstop(' ')
              endif
          endif
      else
          call DeAllocaBuildStuff
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine DeAllocaBuildStuff
      USE BuildStuff
!
      implicit none
      integer :: ier
!
      ier = 0
      IF (Allocated(numfr))
     *    Deallocate (numfr, idfrag, jdfrag, ianel, isol, movefr,
     *    mfra, jfisspk, jfissfr, jfrag, kvet, icogr, icopf,
     *    baric, xyzbu, rxyzs, groupatomi,
     *    nord_coppia,
     *    nord_picco1_coppia, nord_picco2_coppia, kodice_dist,
     *    dist_coppia, distxyz_coppia,nopsym_picco2_coppia,
     *    atomo_in_coppie, atomo_in_angoli,legami_atomo,LongConnect,
     *    kluster, intens_legati,incomp_atomi,    stat = ier)
      if (ier /= 0) then
          write(*,*) 'BuildStuff DeAllocation Error'
          call cstop(' ')
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaTestStuff(iAction)
      USE General
      USE Symmetry
      USE Atomi
      USE TestStuff
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!-- Allocate FT per Relax (P1)    ( iAction = 3 )
!
      dimension ierv(7)
!
      ierv(:) = 0
      ierr = 0
      if (iAction == 1) then
          ifFloatOrigin = sum( vpol(1:3) )
      elseif (iAction == 3) then
          ifFloatOrigin = 3
      endif
#if 0
      ierr = 0
      if (iAction == 1 .or. iAction == 3) then
          IF (.NOT. ALLOCATED(FT) .and. ifFloatOrigin > 0)
     *         ALLOCATE (FT(1:2097152),  stat = ierv(1))  !128*128*128
          ierr = sum(ierv)
          if (ierr.ne.0) then
              write(lo,*) 'TestStuff Allocation error '
              call cstop(' ')
          endif
      else
          IF (ALLOCATED(FT))
     *        DEALLOCATE (FT, stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'TestStuff DeAllocation Error'
              call cstop(' ')
          endif
      endif
#endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaTestModel(iAction)
      USE General
      USE Symmetry
      USE Atomi
      USE TestModel
      USE Dialogo, only : ModelToCompare
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      implicit none
      integer :: iAction, iAct, ierv(12), ierr, nMaxLeg
!
      ierv(:) = 0
      ierr = 0
      if (MaxAtoms == 0) then
          nCoord = 2500
      else
          nCoord = MaxAtoms * 1.5
      endif
      nCoord = max0(nCoord, 500)
      nMaxLeg = nCoord * 1.5
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(coordSir)) 
     *         ALLOCATE (coordSir(1:4,1:nCoord),  stat = ierv(1))
          IF (.NOT. ALLOCATED(coordPub)) 
     *         ALLOCATE (coordPub(1:5,1:nCoord),  stat = ierv(2))
          IF (.NOT. ALLOCATED(distv)) 
     *         ALLOCATE (distv(1:nCoord),         stat = ierv(3))
          IF (.NOT. ALLOCATED(npunt)) 
     *         ALLOCATE (npunt(1:nCoord),         stat = ierv(4))
          IF (.NOT. ALLOCATED(nzPub)) 
     *         ALLOCATE (nzPub(1:nCoord),         stat = ierv(5))
          IF (.NOT. ALLOCATED(aLabPub)) 
     *         ALLOCATE (aLabPub(1:nCoord),       stat = ierv(6))
          if (.not.Allocated(LEPub))
     *        Allocate(LEPub(1:2,1:nMaxLeg),      stat = ierv(7))
          if (.not.Allocated(ixyPub))
     *        Allocate(ixyPub(1:2,1:nCoord),      stat = ierv(8))
          if (.not.Allocated(xyzPub))
     *        Allocate(xyzPub(1:3,1:nCoord),      stat = ierv(9))
          IF (.NOT. ALLOCATED(distRms)) 
     *         ALLOCATE (distRms(1:nCoord),       stat = ierv(10))
          IF (.NOT. ALLOCATED(tipoPub))
     *         ALLOCATE (tipoPub(1:nCoord),       stat = ierv(11))
          ierr = sum(ierv)
          if (ierr.ne.0) then
              write(lo,*) 'TestModel Allocation error '
              call cstop(' ')
          endif
          npunt(:) = 0
          distv(:) = 0
          nzPub(:) = 0
          if (ModelToCompare > 0) then
              iAct = 2   ! restore
              call Save_Restore_Modello_Publ(iAct)
          endif
      else
          IF (ALLOCATED(coordSir))
     *        DEALLOCATE (coordSir, coordPub, distv, npunt, nzPub,
     *            aLabPub, LEPub, ixyPub, xyzPub, distRms, tipoPub,
     *            stat = ierr)
          if (ierr.ne.0) then
              write(*,*) 'TestModel DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end

! ----------------------------------------------------------------------
      subroutine AllocaMappa(iAction)
      USE General
      USE Mappa
c     USE PhaseModule
*     USE Envelope
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
!
      dimension ierv(6)
!
      ierv(:) = 0

      ierr = 0
      if (iAction == 1) then
          IF (.NOT. ALLOCATED(xmap))
     *    ALLOCATE (xmap(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat = ierv(1))
          IF (.NOT. ALLOCATED(xmapDif))
     *    ALLOCATE (xmapDif(0:np(1)-1,0:np(2)-1,0:np(3)-1), 
     *            stat = ierv(1))
*         if ( ifPatt > 0 .or. ksize > 3 .or. ifRemo > 0) then     !090205 roccopatt
              IF (.NOT. ALLOCATED(xenve))
     *    ALLOCATE (xenve(0:np(1)-1,0:np(2)-1,0:np(3)-1),stat = ierv(2))
*         endif
          IF (.NOT. ALLOCATED(xmapC))
     *    ALLOCATE (xmapC(0:np(1)/2,0:np(2)-1,0:np(3)-1), stat=ierv(3))
!
          if (ifRemo == 0) then
              IF (.NOT. ALLOCATED(xmapApp))
     *        ALLOCATE (xmapApp(0:np(1)-1,0:np(2)-1,0:np(3)-1),
     *                                                  stat = ierv(4))
              xmapApp = 0.0
          endif
!
          if (ierv(1).ne.0.or.ierv(2).ne.0.or.ierv(3).ne.0.
     *                    .or.ierv(4).ne.0.or.ierv(5).ne.0) then
              write(*,*) 'Map Allocation Error'
              call cstop(' ')
          endif
          xmap = 0.0
          xenve = 0.0
          xmapC(:,:,:) = cmplx(0.0, 0.0)
          call DistruggiPianiAll
      else
          IF (ALLOCATED(xmap)) then
              DEALLOCATE (xmap, stat = ierv(1))
          endif
          IF (ALLOCATED(xmapDif)) then
              DEALLOCATE (xmapDif, stat = ierv(2))
          endif
          IF (ALLOCATED(xmapC)) then
              DEALLOCATE (xmapC, stat = ierv(4))
          endif
          IF (ALLOCATED(xenve)) then
              DEALLOCATE (xenve, stat = ierv(5))
          endif
          IF (ALLOCATED(xmapApp)) then
              DEALLOCATE (xmapApp, stat = ierv(6))
          endif
          if (ierv(1).ne.0.or.ierv(2).ne.0.or.ierv(3).ne.0.
     *       .or.ierv(4).ne.0.or.ierv(5).ne.0.or.ierv(6).ne.0) then
              write(*,*) 'Mappa DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end

! ----------------------------------------------------------------------
      subroutine AllocaMapTest(iAction)
      USE Mappa
      USE MapTest
      dimension ierv(50)

      ierr = 0
      ierv(:)=0
      if (iAction == 1) then
       IF (.NOT. ALLOCATED(xmodel))
     *  ALLOCATE (xmodel(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat = ierv(1))

       IF (.NOT. ALLOCATED(xmapT))
     *  ALLOCATE (xmapT(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat = ierv(2))

       IF (.NOT. ALLOCATED(xenveT))
     *  ALLOCATE (xenveT(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat = ierv(3))

       IF (.NOT. ALLOCATED(xmapQT))
     *  ALLOCATE (xmapQT(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat = ierv(4))

       ierr = sum(iabs(ierv(:)))
       if (ierr.ne.0) then
          write(6,*) 'Maptest Allocation Error'
          call cstop(' Allcation error')
        endif

        xmodel(:,:,:) = 0.0
        xmapT(:,:,:)  = 0.0
        xenveT(:,:,:) = 0.0
        xmapQT(:,:,:) = 0.0

      else

       IF (ALLOCATED(xmodel))
     *    DEALLOCATE (xmodel, stat = ierv(1))
       IF (ALLOCATED(xmapT))
     *    DEALLOCATE (xmapT, stat = ierv(2))
       IF (ALLOCATED(xenveT))
     *    DEALLOCATE (xenveT, stat = ierv(3))
       IF (ALLOCATED(xmapQT))
     *    DEALLOCATE (xmapQT, stat = ierv(4))

       ierr = sum(iabs(ierv(:)))
       if (ierr.ne.0) then
          write(6,*) 'Maptest DeAllocation Error'
          call cstop(' Allcation error')
       endif
      endif

      return
      end

! ----------------------------------------------------------------------
      subroutine AllocaSkeleton(iAction)
      USE Skeleton
      USE Mappa, only: np
      dimension ierv(2)

      ierr = 0
      ierv(:)=0

      if (iAction == 1) then
       IF (.NOT. ALLOCATED(ndenSK))
     *  ALLOCATE (ndenSK(nmap), stat = ierv(1))

       IF (.NOT. ALLOCATED(maskSK))
     *  ALLOCATE (maskSK(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat = ierr)

       ierr = sum(iabs(ierv(:)))
       if (ierr.ne.0) then
          write(6,*) 'Skeleton Allocation Error'
          call cstop(' Allocation error')
        endif
      else
       IF (ALLOCATED(ndenSK))
     *    DEALLOCATE (ndenSK, stat = ierv(1))

       ierr = sum(iabs(ierv(:)))
       if (ierr.ne.0) then
          write(6,*) 'Skeleton DeAllocation Error'
          call cstop(' Allocation error')
       endif
      endif

      return
      end
! ----------------------------------------------------------------------
      subroutine AllocaPlotter(iAction,KK)
      USE Atomi
      USE Plotter
!
!-- Allocate / Deallocate arrays  ( iAction = 1 / 2 )
!
      integer   YYY
      dimension ierv(50)
!
      ierv(:) = 0
!
      ierr = 0
      YYY = 0
      
      if (iAction == 1) then
      
      YYY = YYY + 1
      if (.not.Allocated(Finter))
     *        Allocate(Finter(1:10000),          stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(aLabPlo))
     *        Allocate(aLabPlo(1:natsPlo),       stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(AdrPloto5))
     *        Allocate(AdrPloto5(1:natsPlo),     stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(xyzsPlo))
     *        Allocate(xyzsPlo(1:5,1:natsPlo),   stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(bfacPlo))
     *        Allocate(bfacPlo(1:natsPlo),         stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(bijPlo))
     *        Allocate(bijPlo(1:6,1:natsPlo),      stat = ierv(YYY))

      YYY = YYY + 1
      if (.not.Allocated(xyzsPloCopia))
     *        Allocate(xyzsPloCopia(1:5,1:natsPlo),   stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(bfacPloCopia))
     *        Allocate(bfacPloCopia(1:natsPlo),      stat = ierv(YYY))
      YYY = YYY + 1
      if (.not.Allocated(bijPloCopia))
     *        Allocate(bijPloCopia(1:6,1:natsPlo),  stat = ierv(YYY))

!  dipende dal valore di KK (o idr, sono uguali)
!  ParamEll(19,nats25)
      YYY = YYY + 1
      if (.not. allocated(ParamEll)) 
     *     allocate (ParamEll(1:19,1:natsPlo),     stat = ierv(YYY))
     
!  ParamEllabc(8,3,nats25)  solo se kk=3
	if(KK.eq.3) then 
         YYY = YYY + 1
         if (.not. allocated(ParamEllabc)) 
     *       allocate (ParamEllabc(1:8,1:3,1:natsPlo),stat = ierv(YYY))
      endif
!     
      YYY = YYY + 1
         if (.not. allocated(BondAB)) 
     *        allocate (BondAB(1:2,1:NNLeg),          stat = ierv(YYY))

      YYY = YYY + 1
         if (.not. allocated(ABaseBond)) 
     *       allocate (ABaseBond(1:4,1:jdim,1:NNLeg),stat = ierv(YYY))

      YYY = YYY + 1
         if (.not. allocated(BBaseBond)) 
     *       allocate (BBaseBond(1:4,1:jdim,1:NNLeg),stat = ierv(YYY))

         ierr = sum(ierv)
	   if (ierr.ne.0) then 
	       write(ncwu,*) 'Plotter Allocation error'
	       call cstop(' ')
	   endif

      else

          IF (Allocated(xyzsPlo)) then
              natsPlo = 0

              Deallocate (aLabPlo,xyzsPlo,         stat=ierv(1))
              Deallocate (AdrPloto5,               stat=ierv(2))
              Deallocate (bfacPlo,bijPlo,          stat=ierv(3))
      
              Deallocate (xyzsPloCopia,            stat=ierv(4))
              Deallocate (bfacPloCopia,            stat=ierv(5))
              Deallocate (bijPloCopia,             stat=ierv(6))
      
              Deallocate (Finter,                  stat=ierv(7))
     
              DEALLOCATE(ParamEll,                 stat =ierv(8))
	        if(KK.eq.3) then 
                  DEALLOCATE(ParamEllabc,              stat =ierv(9))
              endif
              DEALLOCATE(BondAB,                   stat =ierv(10))
              DEALLOCATE(ABaseBond,                stat =ierv(11))
              DEALLOCATE(BBaseBond,                stat =ierv(12))
          endif
     
         ierr = sum(ierv)
         if (ierr.ne.0) then
              write(*,*) 'Plotter DeAllocation Error'
              call cstop(' ')
         endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PassaVettoreInt(vett, indice, nelems)
!
      implicit none

      integer vett(*)
      integer indice, nelems
!
      call put_vett_int (vett, indice, nelems)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PassaMatriceInt(mat, indice, nrighe, ncolonne)
!
      implicit none

      integer indice, nrighe, ncolonne
      integer mat(nrighe,ncolonne)
!
      call put_matrice (mat, indice, nrighe, ncolonne)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PassaVettoreStr(vettstr, dimensione)
!
      implicit none

      integer dimensione
      character*(*) vettstr(dimensione)
!
      call put_vett_str (vettstr, dimensione)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaClustering(iAction,nmaxclust)
      USE Clustering
      dimension ierv(50)

      ierr = 0
      ierv(:)=0
      if (iAction == 1) then
       IF (.NOT. ALLOCATED(cdclust))
     *  ALLOCATE (cdclust(1:nmaxclust-1), stat = ierv(1))

       IF (.NOT. ALLOCATED(dordclust))
     *  ALLOCATE (dordclust(1:nmaxclust), stat = ierv(2))

       IF (.NOT. ALLOCATED(ilcclust))
     *  ALLOCATE (ilcclust(1:nmaxclust-1), stat = ierv(3))

       IF (.NOT. ALLOCATED(iucclust))
     *  ALLOCATE (iucclust(1:nmaxclust-1), stat = ierv(4))

       IF (.NOT. ALLOCATED(iordclust))
     *  ALLOCATE (iordclust(1:nmaxclust), stat = ierv(5))


       ierr = sum(iabs(ierv(:)))
       if (ierr.ne.0) then
          write(6,*) 'Maptest Allocation Error'
          call cstop(' Allcation error')
        endif

        cdclust(:) = 0.0
        dordclust(:)  = 0.0
        ilcclust(:) = 0.0
        iucclust(:) = 0.0
        iordclust(:) = 0.0

      else

       IF (ALLOCATED(cdclust))
     *    DEALLOCATE (cdclust, stat = ierv(1))
       IF (ALLOCATED(dordclust))
     *    DEALLOCATE (dordclust, stat = ierv(2))
       IF (ALLOCATED(ilcclust))
     *    DEALLOCATE (ilcclust, stat = ierv(3))
       IF (ALLOCATED(iucclust))
     *    DEALLOCATE (iucclust, stat = ierv(4))
       IF (ALLOCATED(iordclust))
     *    DEALLOCATE (iordclust, stat = ierv(5))

       ierr = sum(iabs(ierv(:)))
       if (ierr.ne.0) then
          write(6,*) 'Maptest DeAllocation Error'
          call cstop(' Allcation error')
       endif
      endif

      return
      end


