!-----------------------------------------------------------------------
!    SYMMETRY routines
!-----------------------------------------------------------------------
c
code for CreaSymmetryInfo
      subroutine CreaSymmetryInfo(ier)
!
!--riempie i vettori SIR per Symmetry and Limiti Fourier
!  nSpaceG, vettore contenente il simbolo del G.S.
!
      USE General
      USE Symmetry
      USE Molcom, only: nsymMol
!
      dimension kshif(3),Buffer(120)
      integer nSpaceGBackUp(16)
      character (len=16) :: spgTmp
!
      write(spgTmp,'(16a1)') nSpaceG(1:16)
      call lcase(spgTmp)
      read(spgTmp,'(16a1)') nSpaceG(1:16)
      nSpaceGBackUp(1:16) = nSpaceG(1:16)
      call ti1983(nSpaceG)
!
      ier=0
      call CheckSpaceGroupSymbol(nSpaceG, ier)
      jspini  = -1
      ishif   = 0
      kshif   = 0
      call insym(ishif,kshif,ier)
      if (ier < 0) then
          return
      endif
      nSpaceG(1:16) = nSpaceGBackUp(1:16)
      CentXNlatt=pts*float(icent+1)
      g2=CentXNlatt
      nsymTot = pts * (float( (icent+1) * nsym ))
      totop = nsymTot
      nsymMol=nsym * (icent+1)   !RS--inserita la definizione
      if (nsym.eq.1.and.icent.eq.0) then
          ifReduced = 0
      endif
      nsymTrue = nsym
      icentTrue = icent
      call xspinb
      kpolTrue = kpol
      UnoPiuIcent  = 1 + icent
      UnoMenoIcent = 1 - icent
!
!--define the asymmetric unit
!
      n102=ipuac(nSpaceG,Buffer,n,ngspat)
      nSpaceGroup = n102
      nSpaceGroupPatt=ngspat
      m102=1
      call scx14Fou(Buffer,m102,n102)
      call scx14Pat(Buffer,m102,n102)
c--stampa limiti (test)
c      ired=1
c      call xprtcond(ired)
!
      call InitOper
!
      k=1
      lattvett=0
      do i=1,4
         do j=1,3
            lattvett(j,i)=centrt(latt,k)
            k=k+1
         enddo
      enddo
!
      call MakeSymmOperators
!
      InfoOK(2) = 1
!
      return
      end
c
code for scx14Fou
      subroutine scx14Fou(Buffer,m102,n102)
c--insert the limits onto list 14
c
      USE General
      USE Symmetry
!
      dimension Buffer(*)
c--
      do i=1,3
         xyzfou(i,1 )= 0.0               
         xyzfou(i,2 )= 0.5              
         if(i.eq.3) xyzfou(i,2 )= 1.0   
         xyzfou(i,3)=0.3                
      enddo
      if(jsys.eq.1) xyzfou(2,2 )= 1.0     
      if(jsys.ge.3) xyzfou(3,2 )= 0.5    
      do i=1,3
         do j=1,2
            xlimSPGfou(i,j)=xyzfou(i,j )
         enddo
      enddo
      if(n102.gt.0) then  
c          
c--insert the limits for standard asymmetric unit
         jz=0
         do i=1,3
            xyzfou(i,1 )=Buffer(m102  )
            xyzfou(i,2 )=Buffer(m102+1)
            xlimSPGfou(i,1)=xyzfou(i,1 )
            xlimSPGfou(i,2)=xyzfou(i,2 )
            m102=m102+2
         enddo
         do i=1,3
            do j=1,2
               n=Buffer(m102)
               m102=m102+1
               if(n.ne.0) then 
                  jz=jz+1
                  ncondfou(i,j) = n    
                  do k=1,n
                     do m=1,5
                        xcondfou(i,j,k,m)=Buffer(m102)     
c                        xcondfou(i,2,k,m)=Buffer(m102)     
                        m102=m102+1
                     enddo
                  enddo
               endif
            enddo
         enddo
      endif
c------------------------------      
      nmin=10000
      nmax=0
      do i=1,3
         n = cell(i)/xyzfou(i,3)
         if(n.lt.4) n=4
1010     continue
         if(n.ne.n/4*4) then   
            n=n-1
            go to 1010
         endif
         xyzfou(i,4)=n                    
         xyzfou(i,3)=1                   
         xyzfou(i,2)=xyzfou(i,2)*n       
         xyzfou(i,1)=xyzfou(i,1)*n      
         n=xyzfou(i,2)                   
         nmin=min0(n,nmin)
         nmax=max0(n,nmax)
      enddo
      do i=1,3
         n=xyzfou(i,2)    
         if(n.eq.nmin) then     
            k=i
            exit
         endif
      enddo
      do i=1,3
         n=xyzfou(i,2)          
         if(n.ne.nmax) cycle     
         if(i.eq.k) cycle       
         j=i
         exit
      enddo
      n=6-k-j
      iorizfou=n
      ivertfou=j
      return
      end
c
code for scx14pat
      subroutine scx14pat(Buffer,m102,n102)
c--insert the limits onto list 14
c
      USE General
      USE Symmetry
!
      dimension Buffer(*)
c--
      do i=1,3
         xyzpat(i,1 )= 0.0               
         xyzpat(i,2 )= 0.5              
         if(i.eq.3) xyzpat(i,2 )= 1.0   
         xyzpat(i,3)=0.3                
      enddo
      if(jsys.eq.1) xyzpat(2,2 )= 1.0     
      if(jsys.ge.3) xyzpat(3,2 )= 0.5    
      do i=1,3
         do j=1,2
            xlimSPGpat(i,j)=xyzpat(i,j )
         enddo
      enddo
      if(n102.gt.0) then  
c          
c--insert the limits for standard asymmetric unit
         jz=0
         do i=1,3
            xyzpat(i,1 )=Buffer(m102  )
            xyzpat(i,2 )=Buffer(m102+1)
            xlimSPGpat(i,1)=xyzpat(i,1 )
            xlimSPGpat(i,2)=xyzpat(i,2 )
            m102=m102+2
         enddo
         do i=1,3
            do j=1,2
               n=Buffer(m102)
               m102=m102+1
               if(n.ne.0) then 
                  jz=jz+1
                  ncondpat(i,j) = n    
                  do k=1,n
                     do m=1,5
                        xcondpat(i,j,k,m)=Buffer(m102)     
c                        xcondpat(i,2,k,m)=Buffer(m102)     
                        m102=m102+1
                     enddo
                  enddo
               endif
            enddo
         enddo
      endif
c------------------------------      
      nmin=1000
      nmax=0
      do i=1,3
         n = cell(i)/xyzpat(i,3)
         if(n.lt.4) n=4
1010     continue
         if(n.ne.n/4*4) then   
            n=n-1
            go to 1010
         endif
         xyzpat(i,4)=n                    
         xyzpat(i,3)=1                   
         xyzpat(i,2)=xyzpat(i,2)*n       
         xyzpat(i,1)=xyzpat(i,1)*n      
         n=xyzpat(i,2)                   
         nmin=min0(n,nmin)
         nmax=max0(n,nmax)
      enddo
      do i=1,3
         n=xyzpat(i,2)    
         if(n.eq.nmin) then     
            k=i
            exit
         endif
      enddo
      do i=1,3
         n=xyzpat(i,2)          
         if(n.ne.nmax) cycle     
         if(i.eq.k) cycle       
         j=i
         exit
      enddo
      n=6-k-j
      iorizpat=n
      ivertpat=j
      return
      end
!
!-------------------------------------------------------------
      subroutine insym(ishif,kshif,ier)
!-- read space group symbol as in international tables and
!-- determine lattice multiplicity (pts) and crystal system (ksys)
!
      USE General
      USE Symmetry
      dimension ltc(7),kshif(3)
      character ltcc(7)                      ! dopo
*     data ltc/1hp,1ha,1hb,1hc,1hi,1hf,1hr/  ! prima
      data ltcc/'p','a','b','c','i','f','r'/ ! dopo
!
      do i=1,7                               ! dopo
         read(ltcc(i),'(a1)') ltc(i)         ! dopo
      enddo                                  ! dopo
      if (ifRhombAx == 0) then
          call symm(ishif,kshif,ier)
      else
          call symmRhomb()
      endif
      if (ier < 0) then
          return
      endif
!
!-- determine lattice multiplicity
!
!-- primitive
      pts=1.0
      do 250 i=1,7
      if (latt.eq.ltc(i)) go to 260
  250 continue
      call cstop(' ')
  260 latt=i
      if(latt.eq.7) go to 300
!-- a, b, c or i centred
      if(latt.ne.1) pts=2.0
!-- f centred
      if(latt.eq.6) pts=4.0
      go to 400
  300 do 310 i=1,nsym
!-- primitive rhombohedral  (pts=1.0)
      if(iabs(ismat(1,1,i)).eq.3) go to 400
  310 continue
!-- centred hexagonal
      pts=3.0
!-- determine crystal system
  400 do 450 i=1,2
      do 440 j=1,nsym
      do 430 in=1,2
      if(iabs(ismat(in,1,j)).eq.4-i) go to 460
  430 continue
  440 continue
  450 continue
!-- 1 - triclinic, 2 - monoclinic, 3 - orthorhombic
      ksys=min0(nsym,3)
      go to 500
  460 if(i.eq.1) go to 480
!-- tetragonal
      ksys=4
      if(nsym.eq.4.or.nsym.eq.8) go to 500
!-- trigonal or rhombohedral indexed on hexagonal axes
      ksys=5
!-- test for 6-fold axis - general form -x, -y, z + t
      do 470 j=2,nsym
      if(iabs(ismat(1,1,j)).gt.1.or.iabs(ismat(2,1,j)).gt.1) go to 470
      if(iabs(ismat(1,2,j)).eq.1.or.iabs(ismat(2,2,j)).eq.1) go to 470
!-- hexagonal
      ksys=6
  470 continue
      go to 500
!-- cubic
  480 ksys=8
!-- primitive rhombohedral
      if (latt.eq.7) then
          ksys = 7
      endif
      if (ksys.eq.7) then
          latt = 1
      endif
  500 return
      end
!-----------------------------------------------------------------------
      subroutine symm(ishif,kshif,ier)
      USE General
      USE Symmetry
!
      character oshift*33,oshp*5
      character space*16
      integer  kshif(3)
      integer sys,ges(3,3,36),net(3),in(3,4),iscont(3),get(3,34),
     *iss(59),lsh(2,78),s(3),lgt(48),
     *mst1(3,6),mst2(3,6),lf(216),q(3,4,5),nsm(45),sem(3,3,18)
     *,scy(3,3),lgn(3,45),atx(18),t(48,3)
      equivalence (j2,in(2,2)),(j3,in(2,3)),(k2,in(3,2)),(k3,in(3,3)),
     *(i3,in(1,3)),(i2,in(1,2)),(i1,in(1,1)),(j1,in(2,1)),(k1,in(3,1))
     *,(i4,in(1,4)),(j4,in(2,4)),(k4,in(3,4))
      data sem/1,3*0,1,3*0,1,96,3*0,1,3*0,1,1,3*0,96,3*0,1,1,3*0,1,3*0,9
     *6,1,3*0,96,3*0,2*96,3*0,1,3*0,2*96,3*0,96,3*0,1,96,3*0,96,3*0,3*96
     *,3*0,1,3*0,2*96,3*0,96,5*0,96,6*0,3*96,8*0,1,6*0,64,128,32,6*0,128
     *,64,3*0,1,3*0,128,64,3*0,96,3*0,3*48,96,3*0,96,0,2*96,2*0,96,48,2*
     *0,96/,nsm/1,2,3,4,5,6,7,5,6,7,8,10,9,9,10,10,10,15,15,13,11,16,16,
     *13,13,16,11,11,12,12,12,8,8,8,8,8,11,10,10,11,11,11,11,12,12/,
     *q/4*0,2*12,9*0,12,0,12,9*0,2*12,11*0,3*12,0,3*12,4*0,3*12,6*0/
!orig data lsh/2,26,6,11,5,15,7,26,435,28,603,26,453,28,645,15,747,26,
      data lsh/2,26,6,11,5,15,7,26,435,28,603, 1,453,28,645,15,747,26,
     *771,15,2287,30,2383,32,2299,31,1622,11,899,9,1319,10,1209,10,1749,
     *11,954,9,1601,11,898,9,1221,10,1770,11,955,9,1307,10,2401,13,2547,
     *13,2421,13,5105,16,7303,15,7205,15,29187,12,29687,12,31662,12,1372
     *1,21,13202,11,13210,21,13691,22,17219,21,17221,15,17223,23,17227,
     *13,17229,15,17231,24,17721,24,14137,21,14147,11,14164,21,14170,
     *21,14638,3,14689,25,14692,26,15183,15,15160,21,15185,13,16229,15,
     *16228,11,16230,12,16729,15,15708,34,17122,3,17149,3,17102,21,171
     *29,21,17120,11,17148,11,17155,3,17132,3,17135,21,17112,11,17153,11
     *,17131,11,17603,3,17659,29,17662,15,5204,14,5104,14,5205,16/
      data mst1/3*1,0,2,2,3,0,3,4,4,0,5,6,7,9,10,11/,mst2/3*1,2,0,0,3,3,
     *0,0,4,4,7,5,8,11,0,12/,sys/2/,
     *n,net,iscont,k/8*1/,id,il,lt,nrt/4*0/
      data lgn/1,0,0,2,0,0,2,0,0,2,0,0,2,0,0,2,0,0,2,0,0,3,4,0,3,4,0,
     *3,4,0,3,4,0,3,0,0,3,0,0,5,7,0,5,3,0,5,3,0,3,5,0,2,0,0,4,2,0,4,2,0,
     *4,2,0,4,2,0,5,0,0,5,0,0,7,10,0,7,4,0,7,4,0,7,10,0,2,5,0,5,14,0,
     *5,14,0,2,0,0,4,2,0,4,2,0,4,2,0,7,8,6,5,0,0,6,3,0,10,11,13,10,8,0,
     *10,8,0,14,19,22,8,5,0,26,37,5,14,5,0/,mcc,ngo,ncs,s,in,lgt/66*0/
      data lf/1,1,-2,1,-3,1,-4,1,2,1,3,1,4,1,2,-3,-4,1,3,-2,-4,1,4,-2,-3
     *,1,4,2,3,1,4,-15,-14,1,4,15,14,1,4,15,14,-2,-3,-13,-16,1,4,2,3,-13
     *,-16,-14,-15,1,4,13,16,-2,-3,-14,-15,1,4,2,3,13,16,14,15,1,3,5,1,3
     *,5,-9,-11,-7,1,3,5,-10,-8,-12,1,3,5,9,11,7,1,3,5,10,8,12,1,3,5,-4,
     *-2,-6,1,4,3,5,2,6,1,4,3,5,2,6,-9,-11,-7,-10,-8,-12,1,3,5,10,8,12,-
     *9,-11,-7,-4,-2,-6,1,3,5,9,11,7,-10,-8,-12,-4,-2,-6,1,4,3,5,2,6,9,1
     *1,7,10,8,12,1,4,2,3,5,9,7,12,8,10,6,11,1,4,2,3,5,9,7,12,8,10,6,11,
     *-13,-16,-14,-15,-17,-21,-19,-24,-20,-22,-18,-23,1,4,2,3,5,9,7,12,8
     *,10,6,11,13,16,14,15,17,21,19,24,20,22,18,23/,t  /144*0/
      data ges/1,3*0,1,3*0,1,1,3*0,-1,3*0,2*-1,3*0,1,3*0,2*-1,3*0,
     *-1,3*0,1,0,1,3*0,1,1,3*0,1,3*0,2*-1,3*0,-1,3*0,1,-1,3*0,-1,3*0,-1,
     *1,4*0,1,1,3*0,1,3*0,1,-1,3*0,-1,3*0,-1,1,3*0,-1,3*0,2*-1,3*0,
     *1,2*0,-1,0,-1,4*0,-1,0,-1,0,1,4*0,1,0,1,0,-1,4*0,1,0,1,0,1,4*0,
     *2*-1,4*0,-1,0,-1,0,-1,4*0,1,0,1,0,1,4*0,-1,0,1,0,1,4*0,1,0,-1,
     *3*0,-1,0,-1,0,-1,4*0,-1,0,1,0,1,4*0,1,0,-1,0,1,4*0,1,0,1,0,-1,0,0,
     *1,3*0,1,3*0,1,1,1,0,-1,4*0,1,0,1,0,2*-1,3*0,1,-1,3*0,-1,3*0,1,2*-1
     *,0,1,4*0,1,0,-1,0,1,1,3*0,1,0,1,0,1,4*0,-1,1,1,0,0,-1,3*0,-1,1,0,
     *0,2*-1,3*0,-1,0,-1,0,-1,4*0,3*-1,0,0,1,3*0,2*-1,0,0,1,1,3*0,-1/
      data iss/111,711,171,117,211,121,112,277,727,772,222,-389,411,477,
     *-373,-328,422,311,371,317,321,312,-589,611,677,-528,-573,622,231,-
     *363,432,-89,218,128,119,777,-289,418,484,-229,-283,684,618,737,731
     *,1,5,6,7,11,18,13,17,21,22,28,24,31,29/
!
*     data hbr/1hp,1ha,1hb,1hc,1hf,1hi,1hr,1hy,1h /
*    *,hs/1hm,1ha,1hb,1hc,1hn,1hd,1h-,1h0,1h1,1h2,1h3,1h4,1h5,1h6,1h//
*     data ntex/2h  ,2h  ,4*0,2h+1,2h/8,2h+1,2h/6,2*0,2h+1,2h/4,2*0,2h+1
*    *,2h/3,2h+3,2h/8,4*0,2h+1,2h/2,6*0,2h+2,2h/3,2*0,2h+3,2h/4,2*0,2h+5
*    *,2h/6/,teb/2h  ,2h-z,2h  ,2h-y,2h x,2h-y,2h  ,2h-x,0,0,2h  ,2h x,
*    *2h y,2h-x,2h  ,2h y,2h  ,2h z/,txa/3*2h 0,2h g,3*2h 0,2h g,3*2h 0,
*    *2
*    *h g,2h 0,3*2h g,2h 0,3*2h g,2h 0,3*2h g,2h h,2h k,2h 0,2h h,2h k,2
*    *h g,2h h,2h k,2h l/,txb/5*2h  ,2hh+,2hk=,2h2n,2*2h  ,2hh+,2hk+,2hl
*    *=
*    *,2h2n,2h  ,2h2h,2h+4,2hk+,2hg=,2h6n,2h2h,2h+k,2h=3,2hn ,2h  ,2hh+,
*    *2hk+,2hl=,2h4n,2h  ,2h2h,2h+2,2hk+,2hg=,2h4n/
!
      data atx/11,21,31,41,51,61,71,81,92,102,101,113,91,104,95,
     *         105,86,107/
      data get/3*0,12,3*0,12,3*0,12,0,3*12,0,3*12,0,3*12,0,3*6,0,3*6,0,
     *3*6,18,2*6,0,0,4,0,0,6,0,0,8,
     *0,0,12,0,0,16,0,0,18,0,0,20,18,6,0,18,12,6,18,6,3,18,6,9,0,18,0,0,
     *6,0,0,6,3,6,0,0,0,12,6,9,9,0,9,0,9,0,9,9,6,18,18,0,18,9/
      data oshift /'                                 '/
c--
c     read the symbol,determine bravais lattice and crystal family.
      ngc = 9999
      write(space,'(16a1)') nSpaceG
      call lcase(space)
!
!-- Check on Space Group Symbol conversion from
!-- International Table (1983) into the notation used in
!-- International Table (1974).
!
      if (space(5:6).eq.'-3') then
          space = space(1:4) // '3' // space(7:16) // ' '
      endif
!
      il=0
      lt=0
      id=0
      n=1
      k=1
      do i=1,3
         net(i)=1
         iscont(i)=1
         s(i)=0
         do j=1,4
            in(i,j)=0
         enddo
      enddo
      do i=1,48
         lgt(i)=0
         do j=1,3
            t(i,j)=0
         enddo
      enddo
      mcc=0
      ncs=0
      nrt=0
      ngo=0
      sys=2
*     i=hbr(8)
      do i=1,7
         if (space(1:1).eq.hbr(i)) then
             nbr=i
         endif
      enddo
c     standardization of the symbol
      in(:,:) = 0
      do i=3,16
         if (space(i:i) == hbr(9)) then
             k=0
             n=n+1
         else
             if (space(i:i) == hsymm(11) .or. 
     *           space(i:i) == hsymm(14)) sys=5
             do j=1,15
                if (space(i:i).eq.hsymm(j)) in(n,k)=j-8
             enddo
         endif
         k=k+1
      enddo
      if(i1.eq.4.or.i1.eq.-1.and.i2.eq.4) sys=4
      if(j1.eq.3) sys=6
      if(j1.eq.0.and.i1.eq.1.or.i1.eq.-1.and.i2.eq.1)sys=1
      if(sys.eq.2.and.j1.eq.0)goto 105
      if(sys.eq.2.and.i1.ne.1.and.j1.ne.1.and.k1.ne.1)sys=3
      goto 107
  105 do 106 i=1,4
      in(2,i)=in(1,i)
      in(1,i)=0
  106 continue
      i1=1
      k1=1
c     determination of code no. ngc for the point group
  107 do 97 i=1,3
      if(in(i,1).ne.0) iscont(i)=in(i,1)
      if(iscont(i).eq.-1) iscont(i)=-in(i,2)
      if(in(i,1).lt.-1) iscont(i)=7
      if(in(i,1).gt.-2) goto 94
      in(i,4)=in(i,1)
      in(i,1)=1
   94 if(in(i,2).ne.7) goto 97
      in(i,4)=in(i,3)
      in(i,3)=7
      in(i,2)=0
   97 continue
      if(k1.eq.2.and.(j1.eq.2.or.j1.eq.3))nrt=1
      m=100*iscont(1)+10*iscont(2)+iscont(3)+i3+j3+k3
      do i=1,45
         if (m == iss(i)) ngc=i
      enddo
c     fix code no. ncs for centrosymmetry
      if(ngc.le.31) ncs=1
      nd=ngc
      if (nd.gt.31) then
          if (nd == 9999) then
              call ucase(space(1:1))
              write(Msg,1110) char(10),space(1:Lung(space)),char(10)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
              ier = -1
              return
          else
              nd=iss(ngc+14)
          endif
      endif
 1110 format('Problems handling space group symbol:',a,a,a,
     *              'Please check it !!!')
c     rotation parts
      do i=1,216
         if (lf(i).eq.1) id=id+1
         if ((id-nd) > 0) then
             exit
         elseif ((id-nd) == 0) then
             m=lf(i)*isign(1,lf(i))+24*(5/sys)*(sys/5)
             ngo=ngo+1
             do k=1,3
                do l=1,3
                   kmat(ngo,k,l)=ges(k,l,m)*isign(1,lf(i))
               enddo
             enddo
         endif
      enddo
c     multiplcation table
  120 do 91 i=1,ngo
      do j=1,3
         do k=1,3
            if (ncs.eq.0) kmat(ngo+i,j,k)=-kmat(i,j,k)
         enddo
      enddo
      do 90 j=1,ngo
      do k=1,3
         do l=1,3
            scy(k,l)=0
         enddo
      enddo
      do k=1,3
         do l=1,3
            do m=1,3
               scy(k,l)=scy(k,l)+kmat(i,k,m)*kmat(j,m,l)
            enddo
         enddo
      enddo
      do 93 k=1,ngo
      do l=1,3
         do m=1,3
            if (scy(l,m).ne.kmat(k,l,m)) goto 93
         enddo
      enddo
      irot(i,j)=k
      if(ncs.eq.0)irot(ngo+i,j)=k+ngo
      if(ncs.eq.0)irot(i,ngo+j)=k+ngo
      if(ncs.eq.0)irot(ngo+i,ngo+j)=k
      goto 90
   93 continue
   90 continue
   91 continue
      if(ncs.eq.0)ngo=ngo+ngo
c     select translation parts for generators
      if(ngc.eq.30.or.ngc.eq.31) il=1
      if(sys.eq.3) mcc=400*nbr+i4*49+j4*7+k4+399
      if(sys.ge.4)mcc=1000*nd+100*nbr+25*((k4+7)/2)+5*i4+j4+42+4*i2+j2*2
      if(sys.eq.5)mcc=3000+100*ngc+i2+j1+k1
      if(ngc.eq.11) mcc=i2*4+j2*2+k2
      do 122 i=1,3
      l=in(i,4)+8
      if(l.ge.7) goto 122
      il=il+1
      net(il)=mst1(i,l)
      if(sys.gt.3) net(il)=mst2(i,l)
  122 continue
      if(ngc.eq.30.and.k4.eq.-2) net(il)=13
      if(il.ge.2) goto 130
      do 123 i=1,3
      if(in(i,1).ne.2) goto 123
      il=il+1
      net(il)=1+i*in(i,2)
      if(sys.gt.3.and.in(i,1).ne.-1) net(il)=1+in(i,2)
      if(sys.eq.6) net(il)=1+5*in(i,2)
  123 continue
      if(i1.lt.3.or.i1.gt.6.or.i2.eq.0) goto 130
      il=il+1
      net(il)=13+(10*i2)/i1-(i2+i2)/i1
  130 n=net(3)
      if(ngc.eq.31)n=1+7*(i2/2)+i2/3+i2*(10*i2*i2-42*i2+43+mod(nbr,5))
      do i=1,3
         m = net(i)
         if (m == 0) then
             call ucase(space(1:1))
             write(Msg,137) space(1:Lung(space))
             call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
             ier = -1
             return
         endif
  137 format('Problematic Space Group Symbol: ',a,' !!!')
         id=lgn(i,ngc)
         if (id.ne.0) then
             do j=1,3
                t(id,j)=get(j,m)-nrt*(i/2)*(2/i)*(1-2*(sys/6))*get(j,n)
                if (nrt.eq.0.and.sys.lt.4.and.nbr.ne.5) then
                    s(j)=get(j,m)/2+s(j)
                endif
             enddo
         endif
      enddo
c     complete translation parts
  128 do 131 i=1,3
      if(lgn(i,ngc).eq.0) goto 131
      lt=lt+1
      lgt(lt)=lgn(i,ngc)
  131 continue
  135 if(lt.eq.ngo) goto 200
      n=0
      do i=1,lt
         do 132 j=1,lt
         il=lgt(i)
         jl=lgt(j)
         kl=irot(il,jl)
         do 133 m=1,ngo
         if(lgt(m).eq.kl) goto 132
  133    continue
         do k=1,3
            do l=1,3
               t(kl,k)=t(kl,k)+kmat(il,k,l)*t(jl,l)
            enddo
            t(kl,k)=t(kl,k)+t(il,k)+48
            t(kl,k)=mod(t(kl,k),24)
         enddo
         n=n+1
         lgt(lt+n)=kl
  132    continue
      enddo
      lt=lt+n
      goto 135
c     selection of origin
  200 continue
      l=ishif+1
      if (l.eq.1) go to 219
      do l=1,3
         s(l)=kshif(l)
      enddo
      oshift(1:16)='( origin shift ='
      oshift(33:33)=')'
      iniz=18
      do l=1,3
         if (kshif(l).eq.0) then
             oshp='  0  '
         else
             kk=24/kshif(l)
             if (kk.le.9) then
                 write(oshp,1000) kk
             else
                 write(oshp,1100) kk
             endif
         endif
         oshift(iniz:iniz+4)=oshp
         iniz=iniz+5
      enddo
 1000 format('1/',i1,'  ')
 1100 format('1/',i2,' ')
  219 n=0
      do i=1,78
         if (mcc.eq.lsh(1,i)) n=lsh(2,i)
      enddo
      if(n.eq.0) goto 210
      do i=1,3
         s(i)=s(i)+get(i,n)
      enddo
  210 do 211 i=1,ngo
      do j=1,3
         t(i,j)=t(i,j)+kmat(i,j,1)*s(1)+kmat(i,j,2)*s(2)+
     *                 kmat(i,j,3)*s(3)-s(j)+48
         t(i,j)=mod(t(i,j),24)
      enddo
      if(nbr.eq.1.or.nbr.eq.7) goto 211
      nd=72
      do 214 l=1,4
      ne=0
      do k=1,3
         iscont(k)=t(i,k)+q(k,l,nbr-1)
         ne=ne+mod(iscont(k),24)
      enddo
      if(nd.le.ne) goto 214
      nd=ne
      do k=1,3
         t(i,k)=mod(iscont(k),24)
      enddo
  214 continue
  211 continue
      call ucase(space(1:1))
!-- seminvariants
      nse=nsm(ngc)
      if(sys.eq.6.and.nbr.eq.5) nse=8
      if(nbr.eq.5.and.(ngc.eq.11.or.ngc.eq.29.or.ngc.eq.30)) nse=17
      if(nbr.eq.6.and.(ngc.eq.12.or.ngc.eq.16)) nse=18
      if(nbr.eq.7.and.(ngc.eq.37.or.ngc.eq.21.or.ngc.eq.40)) nse=14
      m=atx(nse)/10
      n=atx(nse)-10*m
      do jj=1,3
         read(txa(jj,m),'(a2)') isvet(jj)
      enddo 
      do jj=1,5
         read(txb(jj,n),'(a2)') isvet(jj+3)
      enddo 
      jsys=sys
      isv=1
      do i=1,3
         do j=1,3
            jsem=sem(i,j,nse)
            jsvet(isv)=jsem
            isv=isv+1
         enddo
      enddo
      jsvet(10)=3
      k = 0
      do i=1, 3
         do j=1, 3
            k = k + 1
            jsmat(j,i) = jsvet(k)
         enddo
      enddo
      nGenerators=0
      do i=1,3
         if (lgn(i,ngc).ne.0) then
             nGenerators=nGenerators+1
         endif
      enddo
!
!-- calcola tmat
!
      do i=1,ngo
         do j=1,3
            tmat(i,j)=0.0
            if (t(i,j).ne.0) then
                tmat(i,j)=float(t(i,j))/24.
            endif
         enddo
      enddo
      call modif(ngo,ncs)
      call calmod(ngc,nbr,ncs,sem,nse)
!
!-- Check for trigonal crystal family
!
      ifTrigonal = 0
      if (space(3:3) == '3') then
          ifTrigonal = 1
      elseif (space(3:3) == '-' .and. space(4:4) == '3') then
          ifTrigonal = 1
      endif
!
      return
      end
c-----------------------------------------------------------------------
      subroutine modif(ngo,ncs)
      USE General
      USE Symmetry
!
      icent = 1 - ncs
      nsym = ngo
!
!-- If centrosymmetric, check if R(i) = -R(i+nsym)
!
      if (icent == 1) then
          nsym = nsym / 2
          call CheckCentro(ngo)
      endif
!
      latt = nSpaceG(1)
      call musym()
!
      return
      end
!---------------------------------------------------------------------
      subroutine CheckCentro(ngo0)
!
      USE General
      USE Symmetry
!
      integer kmatLoc(192,3,3), x3(3,3)
      real    tmatLoc(192,3), x1(3), x2(3)
!
      character lattici*7, nSp
!
      lattici = 'pabcifr'
      write(nSp,'(a1)') nSpaceG(1)
      call lcase(nSp)
      latt = index(lattici, nSp)
      jspini = -1
      call xspinb
      jspini = -1
      ncwu = lo
      ngo = ngo0
      nsym0 = ngo / 2
      
!
      kmatLoc(:,:,:) = 0
      tmatLoc(:,:)   = 0
      kmatLoc(1:ngo,:,:) = kmat(1:ngo,:,:)
      tmatLoc(1:ngo,:)   = tmat(1:ngo,:)
!
      if (ncentr > 1) then
          do kt=2, ncentr
             do l=1,3
                ktl=(kt-1)*3+l
                x1(l) = centrt(latt, ktl)
             enddo
             do i=1, ngo0
                ngo = ngo + 1
                kmatLoc(ngo,1:3,1:3) = kmatLoc(i,1:3,1:3)
                x2(1:3) = tmatLoc(i,1:3) + x1(1:3)
                tmatLoc(ngo,1:3) = amod(x2(1:3),1.0)
             enddo
          enddo
      endif
!
!-- check for centrosymmetry: rearrange operators order
!
      do i=1, nsym0
         do j=i+1, ngo
            iOk = 1
            do k1=1, 3
               do k2=1, 3
                  if (kmatLoc(i,k1,k2) /= -kmatLoc(j,k1,k2)) iOK = 0
               enddo
               tdiff = tmatLoc(i,k1) - tmatLoc(j,k1)
               if (abs(tdiff) > 0.1) iOK = 0
            enddo
            jj = nsym0 + i
            if (iOk == 1 .and. j /= jj) then
                x3(1:3,1:3) = kmatLoc(jj,1:3,1:3)
                kmatLoc(jj,1:3,1:3) = kmatLoc(j,1:3,1:3)
                kmatLoc(j,1:3,1:3) = x3(1:3,1:3)
                x1(1:3) = tmatLoc(jj,1:3)
                tmatLoc(jj,1:3) = tmatLoc(j,1:3)
                tmatLoc(j,1:3) = x1(1:3)
            endif
         enddo
      enddo
!
      kmat(1:ngo0,:,:) = kmatLoc(1:ngo0,:,:)
      tmat(1:ngo0,:)   = tmatLoc(1:ngo0,:)
!
      return
      end
!---------------------------------------------------------------------
      subroutine calmod(ngc,nbr,ncs,sem,nse)
      USE General
      USE Symmetry
      integer jmat(3,3),norv(3),sem(3,3,18)
      data jmat,norv/12*0/
c
      do j=1,3
         nss(j)=0
         modul(j)=256
      enddo
      do j=1,3
         do i=1,3
            isem=sem(i,j,nse)
            norv(j)=norv(j)+isem
            if (isem.lt.modul(j).and.isem.gt.1) modul(j)=isem
            jmat(i,j)=isem
         enddo
      enddo
      do j=1,3
         if (modul(j).ne.0) then
             do i=1,3
                jmat(i,j)=jmat(i,j)/modul(j)
             enddo
             modul(j)=192/modul(j)
         endif
      enddo
      norigin=3
      do i=1,3
         j=3-i+1
         if (norv(j).gt.0) then
             exit
         else
             norigin=norigin-1
         endif
      enddo
      do i=1,3
         do j=1,3
            if (sem(i,j,nse) == 1) then
               jmat(i,j)=1
            endif
         enddo
         do j=1,3
            nss(i)=nss(i)+jmat(i,j)
         enddo
      enddo
!
!-- nbr is the lattice code  p=1, a=2, b=3, c=4, f=5, i=6, r=7
!
      select case (nbr)

          case ( 1)       !  P
             if (ncs == 0) return
             if (ngc /= 22 .and. ngc /= 23 .and. ngc /= 26) return
             norigin = 1
             nss(2) = 4
             nss(3) = 3
             modul(1) = 6
             modul(2) = 0

          case ( 2,4,6)        !  A, C, I
             norigin = norigin - 1
             if (norigin <= 0) then
                 do k=1,3
                    modul(k) = 1
                 enddo
                 return
             endif
             do k=1,2
                j1 = 2 - k + 1
                j2 = j1
                if (nbr == 6 .and. norigin == 2) j1 = k
                if (modul(j1) /= 0) then
                    nss(j1) = 0
                    modul(j2) = 0
                    exit
                endif
             enddo
             if (nbr /= 4) then
                 if (nbr /= 6) return
                 if (ngc == 12 .or. ngc == 16) then
                     norigin = 1
                     nss(1) = 0
                     nss(2) = 2
                     nss(3) = -1
                     modul(1) = 4
                     modul(2) = 0
                     modul(3) = 0
                     return
                 endif
             endif
             if (norigin /= 1) then
                 modul(2) = modul(3)
                 modul(3) = 0
                 return
             endif
             nss(1) = 0
             nss(2) = 0
             return

          case ( 3)        !  B  
             return

          case ( 5)        !  F  
             norigin = 1
             modul(2) = 0
             modul(3) = 0
             if (ngc /= 10) then
                 nss(1) = 1
                 nss(2) = 1
                 modul(1) = 2
                 if (ncs == 1) modul(1) = 4
             else
                 nss(1) = 0
                 nss(2) = 0
                 modul(1) = 0
             endif


          case ( 7)        !  R  
             if (ncs == 0) return
             if (ngc /= 18 .and. ngc /= 19) return
             norigin =1
             nss(3) = 0

      end select
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CheckRhombAx(nSpaceG, cell, ifRhombAx)
!
      dimension nSpaceG(16) ,cell(13)
      character*16 mt
!
      write(mt,'(16a1)')(nSpaceG(i),i=1,16)
      call lcase(mt)
      if (mt(1:1) == 'r') then
!
!-- R lattice: check cell parametrs
!--      rhombohedral axes :  A = B  = C, ALPHA = BETA = GAMMA 
!--         hexagonal axes :  A = B /= C, ALPHA = BETA = 90, GAMMA = 120
!
         if (abs(cell(2)-cell(3)).lt.0.1.and.
     *       abs(cell(5)-cell(6)).lt.0.1) then
             ifRhombAx = 1
         endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine symmRhomb()
      USE Symmetry
!
      character*16 space, stringa
!
      write(space,'(16a1)') nSpaceG
      call lcase(space)
      call ucase(space(1:1))
!
!
      kmat(1:192,1:3,1:3) = 0
      tmat(1:192,1:3)     = 0
      do i=1,3
         kmat(1,i,i) = 1
      enddo
!
      if (space(1:4) == 'R -3') then
          stringa = ' h k lh+k+l=2n  '
          jsvet = (/ 96,  0,  0, 96,  0,  0, 96,  0,  0,  3/)
          icent = 1
          kmat(2,1,1:3) = (/ 0, 0, 1 /)
          kmat(2,2,1:3) = (/ 1, 0, 0 /)
          kmat(2,3,1:3) = (/ 0, 1, 0 /)
          kmat(3,1,1:3) = (/ 0, 1, 0 /)
          kmat(3,2,1:3) = (/ 0, 0, 1 /)
          kmat(3,3,1:3) = (/ 1, 0, 0 /)
          if (Lung(space).eq.4) then
              nsym = 3
              jsys  = 7
              ifTrigonal = 1
          else
              nsym = 6
              jsys  = 7
              ifTrigonal = 1
              kmat(4,1,1:3) = (/  0,-1, 0 /)
              kmat(4,2,1:3) = (/ -1, 0, 0 /)
              kmat(4,3,1:3) = (/  0, 0,-1 /)
              kmat(5,1,1:3) = (/ -1, 0, 0 /)
              kmat(5,2,1:3) = (/  0, 0,-1 /)
              kmat(5,3,1:3) = (/  0,-1, 0 /)
              kmat(6,1,1:3) = (/  0, 0,-1 /)
              kmat(6,2,1:3) = (/  0,-1, 0 /)
              kmat(6,3,1:3) = (/ -1, 0, 0 /)
          endif
          if (space(1:6) == 'R -3 c') then
              do i=1,3
                 do j=1,3
                    tmat(3+i,j) = 0.5
                 enddo
              enddo
          endif
      elseif (space(1:4) == 'R 3 ') then
          stringa = ' h k lh+k+l= 0  '
          jsvet = (/  1,  0,  0,  1,  0,  0,  1,  0,  0,  3/)
          icent = 0
          kmat(2,1,1:3) = (/ 0, 0, 1 /)
          kmat(2,2,1:3) = (/ 1, 0, 0 /)
          kmat(2,3,1:3) = (/ 0, 1, 0 /)
          kmat(3,1,1:3) = (/ 0, 1, 0 /)
          kmat(3,2,1:3) = (/ 0, 0, 1 /)
          kmat(3,3,1:3) = (/ 1, 0, 0 /)
          if (Lung(space).eq.3) then
              nsym = 3
              jsys  = 7
              ifTrigonal = 1
          else
              nsym = 6
              jsys  = 7
              ifTrigonal = 1
              kmat(4,1,1:3) = (/  0, 1, 0 /)
              kmat(4,2,1:3) = (/  1, 0, 0 /)
              kmat(4,3,1:3) = (/  0, 0, 1 /)
              kmat(5,1,1:3) = (/  1, 0, 0 /)
              kmat(5,2,1:3) = (/  0, 0, 1 /)
              kmat(5,3,1:3) = (/  0, 1, 0 /)
              kmat(6,1,1:3) = (/  0, 0, 1 /)
              kmat(6,2,1:3) = (/  0, 1, 0 /)
              kmat(6,3,1:3) = (/  1, 0, 0 /)
              if (space(1:5) == 'R 3 2') then
                  stringa = ' h k lh+k+l=2n  '
                  jsvet = (/ 96,  0,  0, 96,  0,  0, 96,  0,  0,  3/)
                  do i=1,3
                     do j=1,3
                        do k=1,3
                           kmat(3+i,j,k) = -kmat(3+i,j,k)
                        enddo
                     enddo
                  enddo
              elseif (space(1:5) == 'R 3 c') then
                  do i=1,3
                     do j=1,3
                        tmat(3+i,j) = 0.5
                     enddo
                  enddo
              endif
          endif
      endif
      read(stringa,'(8a2)') isvet
      latt = nSpaceG(1)
      if (icent == 1) then
          do i=1,nsym
             do j=1,3
                do k=1,3
                   kmat(nsym+i,j,k) = -kmat(i,j,k)
                enddo
                tmat(nsym+i,j) = tmat(i,j)
             enddo
          enddo
      endif
!
      k = 0
      do i=1, 3
         do j=1, 3
            k = k + 1
            jsmat(j,i) = jsvet(k)
         enddo
      enddo
!
      call musym()
!
      nsymTot = nsym * (icent + 1)
      call MakeSymmStrings
!
      return
!
      end
!-----------------------------------------------------------------------
      subroutine WriteSymmInfo(ncwu)
      USE Symmetry
!
      implicit none
      integer :: ncwu, iscont(3), k, Lung, i, j, m, ne, kpolTrue
      integer :: ired, id, l, n, nd, ngo
      real    :: t(48,3)
      character*16 space
      character buffer(24)*78
      character*2 tx(2,6,3), ll(2,3,2), lattice
!
!-- initializations
!
      iscont(:) = 1
      t(:,:)    = 0
!
      if (ifTrigonal == 0) then
          write(buffer(1),'(a)') texc(jsys)
      else
          write(buffer(1),'(a)') texc(7)
      endif
      if (ifRhombAx == 1) then
          k= Lung(buffer(1))
          buffer(1)(k+1:) = ' - Rhombohedral axes'
      endif
      write(ncwu,19) buffer(1)(1:Lung(buffer(1)))
      write(space,'(16a1)') nSpaceG
      call ucase(space(1:1))
      if (icent.eq.1) then
          write(ncwu,20) space
          ngo = nsym * 2
      else
          write(ncwu,21) space
          ngo = nsym
      endif
!
      do i=1, ngo
         do j=1,3
            if (abs(tmat(i,j)).gt.0.01) then
                t(i,j) = iabs (nint( tmat(i,j) * 24 ) )
            else
                t(i,j) = 0
            endif
         enddo
      enddo
!
      write(ncwu,27)

      ne = ( ngo + 1 ) / 2
      buffer(ne) = ' '
      do n=1,ne
         id = 2 - ( n + n - 1 ) / ngo
         do l=1,2
            iscont(l) = l + ( n - 1 ) * 2
            i = iscont(l)
            do j=1,3
               nd = kmat(i,j,1) + kmat(i,j,2)*3 + kmat(i,j,3)*4 + 5
               tx(1,j,l) = teb(1,nd)
               tx(2,j,l) = teb(2,nd)
               do k=1,2
                  m = t(i,j)*2 + k
                  ll(k,j,l) = ntex(m)
               enddo
            enddo
         enddo
         write(buffer(n),13) (iscont(m),
     *                       (tx(1,j,m),tx(2,j,m),ll(1,j,m),ll(2,j,m),
     *                        j=1,3),m=1,id)
      enddo
      write(ncwu,32) (buffer(m),m=1,ne)
!
!-- seminvariants
!
      write(ncwu,15) isvet
!
      kpolTrue = kpol
!
      write(ncwu,50)
      if (nSpaceGroup > 0) then
          write(ncwu,60) nSpaceGroup
      else
          write(ncwu,70)
      endif
!
!-- lattice translations
!
      lattice = ' '
      lattice(2:2) = space(1:1)
      call ucase(lattice)
      if (lattice(2:2).eq.'P') then
          buffer(1) = lattice // '-lattice: (0,0,0)        '
      elseif (lattice(2:2).eq.'A') then
          buffer(1) = lattice // '-lattice: (0,0,0) '
     *                // '+ (0,1/2,1/2) '
      elseif (lattice(2:2).eq.'B') then
          buffer(1) = lattice // '-lattice: (0,0,0) '
     *                // '+ (1/2,0,1/2) '
      elseif (lattice(2:2).eq.'C') then
          buffer(1) = lattice // '-lattice: (0,0,0) '
     *                // '+ (1/2,1/2,0) '
      elseif (lattice(2:2).eq.'I') then
          buffer(1) = lattice // '-lattice: (0,0,0) '
     *                // '+ (1/2,1/2,1/2) '
      elseif (lattice(2:2).eq.'F') then
          buffer(1) = lattice // '-lattice: (0,0,0) '
     *                // '+ (0,1/2,1/2) '
     *                // '+ (1/2,0,1/2) '
     *                // '+ (1/2,1/2,0) '
      elseif (lattice(2:2).eq.'R') then
          if (ifRhombAx == 0) then
              buffer(1) = lattice // '-lattice: (0,0,0) '
     *                    // '+ (2/3,1/3,1/3) '
     *                    // '+ (1/3,2/3,2/3) '
          else
              buffer(1) = lattice // '-lattice: (0,0,0)        '
          endif
      endif
      write(ncwu,32) ' '
      write(ncwu,32) buffer(1)
!
!-- Allowed origin translations
!
      call StampaOriginiRoxi(ncwu)
!
!-- Fourier & Patterson asymmetric unit
!
      if (ifRhombAx == 0) then
          call ChangeNcwu(1,ncwu)
          ired=1
          call xprtcond(ired, ncwu)
          call ChangeNcwu(2,ncwu)
      endif
!
      return
   13 format(2(' ',i3,') ',2(4a2,','),4a2,4x))
   15 format(//,' Seminvariant condition : ',3a2,4x,5a2)
   19 format (/,' Crystal family',29x,':  ',a)
   20 format (/,' Space group (centrosymmetric)',14x,':  ',a16,a)
   21 format (/,' Space group (noncentrosymmetric)',11x,':  ',a16,a)
   27 format(/,' Symmetry-operations'/)
   32 format(a78)
   50 format(' ')
   60 format(' Space Group Number =',i4)
   70 format(' Space Group Symbol not found in Sir Data Base')
      end
!-----------------------------------------------------------------------
code for xprtcond
      subroutine xprtcond(ired, ncwu)
!
!--print list 14, fourier limits dai vettori in common
!
!  ired=0/1  legge/non legge	lista 14 da disco
!
      USE Symmetry
!
      dimension jc1(3),jc2(2,2),jc3(2)
      character*6 jc1ch
      character*2 jc2ch(2,2) 
      character*2 jc3ch
      data jc1ch/'x y z '/
      data jc3ch/'><'/
      data jc2ch(1,1)/'mi'/,jc2ch(2,1)/'n)'/
      data jc2ch(1,2)/'ma'/,jc2ch(2,2)/'x)'/
!
      read(jc1ch,'(3a2)')jc1
      read(jc3ch,'(2a1)')jc3
      do i=1,2
         do j=1,2
            read(jc2ch(j,i),'(a2)')jc2(j,i)
         enddo
      enddo
!
      if (nSpaceGroup <= 0) then
          return
      endif
      do i=1,3
         a=xlimSPGfou(i,1)
         b=xlimSPGfou(i,2)
         if (i.eq.1) then
             write(ncwu,1306) a,jc1(i),b
         else
             write(ncwu,1305) a,jc1(i),b
         endif
      enddo
      do i=1,3
         do j=1,2
            n14a=ncondfou(i,j)
            if (n14a.gt.0) then
                write(ncwu,1240) n14a,jc1(i),(jc2(k,j),k=1,2)
                do m=1,n14a
                   write(ncwu,1260) jc1(i),(jc2(k,j),k=1,2),jc3(j),
     2                              (xcondfou(i,j,m,l),l=1,5)
                 enddo
            endif
         enddo
      enddo
      do i=1,3
         a=xlimSPGpat(i,1)
         b=xlimSPGpat(i,2)
         if (i.eq.1) then
           write(ncwu,1307) a,jc1(i),b
         else
           write(ncwu,1305) a,jc1(i),b
         endif
      enddo
      do i=1,3
         do j=1,2
            n14a=ncondpat(i,j)
            if (n14a.gt.0) then
                write(ncwu,1240) n14a,jc1(i),(jc2(k,j),k=1,2)
                do m=1,n14a
                   write(ncwu,1260) jc1(i),(jc2(k,j),k=1,2),jc3(j),
     2                              (xcondpat(i,j,m,l),l=1,5)
                enddo
            endif
         enddo
      enddo
!
      return
 1240 format(i3,' condition on ',a1,'(',2a2)
 1260 format(1x,a1,'(',2a2,1x,a1,' [ (',f5.2,' * x )',
     1                           ' + (',f5.2,' * y )',
     2                           ' + (',f5.2,' * z )',
     3                           ' +',f5.2,' ] /',f5.2)
 1305 format(20x,f6.3,' <   ',a1,'   < ',f6.3)
 1306 format(/,' Fourier limits   : ' ,f6.3,' <   ',a1,'   < ',f6.3)
 1307 format(/,' Patterson limits : ' ,f6.3,' <   ',a1,'   < ',f6.3)
      end
!-----------------------------------------------------------------------
      subroutine ChangeNcwu(iAction, new)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      save ncwuSav
!
      if (iAction == 1) then
          ncwuSav = ncwu
          ncwu = new
      else
          ncwu = ncwuSav
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ti1983(nSpaceG)
c
c-- This subroutine is used to convert the input string in
c-- lower case and to convert the notation used in
c-- International Table (1983) into the notation used in
c-- International Table (1974).
c
      integer nSpaceG(16)
      character*16 mt
c
      write(mt,'(16a1)')(nSpaceG(i),i=1,16)
      do i=1,16
         j=ichar(mt(i:i))
         if (j.ge.65.and.j.le.90) j=j+32
         mt(i:i)=char(j)
      enddo
      if (mt(5:6).eq.'-3') then
          mt = mt(1:4) // '3' // mt(7:16) // ' '
      endif
      read(mt,'(16a1)')(nSpaceG(i),i=1,16)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine musym()
      USE Symmetry
      implicit none
      integer i, l, j, ja, jb, jc, m
!
!     purpose
!             conversion of matricies in multan notation
!
!             kmat  - 3-dimensionale array containing the rotational
!                     matricies computed by subroutine symm
!             tmat  - bidimensional array containing the traslational
!                     matricies computed by subroutine symm
!             nsym  - number of symmetry operators not related by
!                     a centre of symmetry
!             ismat - 3-dimensional array containing the rotational
!                     matricies in multan notation
!             tsmat - bidimensional array containing the traslational
!                     matricies in multan notation
!
      do j=1,2
         do ja=1,3
            do jb=1,nsym
               ismat(j,ja,jb)=0
               tsmat(  ja,jb)=0
            enddo
         enddo
      enddo
      do jc=1,nsym
         do l=1,3
            m=1
            do i=1,3
               if (kmat(jc,l,i).ne.0) then
                   ismat(m,l,jc)=kmat(jc,l,i)*i
                   m=2
               endif
            enddo
         enddo
         do ja=1,3
            tsmat(ja,jc)=tmat(jc,ja)
         enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine MakeSymmOperators
      USE General, only : lo
      USE Symmetry
!
      implicit none
      integer :: ifi, ifin(2), i, kt, kt1, l, n, nTot
      real    :: tr, centra(3)
!
      nTot = nsym
      if (icent == 1) then
!
!-- Centrosymmetry
!
          do i=1, nsym
             kmat(nTot+i,1:3,1:3) = -kmat(i,1:3,1:3)
             tmat(nTot+i,1:3)     = -tmat(i,1:3)
          enddo
          nTot = nTot + nsym
      endif
      if (ncentr > 1) then
!
!-- Centring
!
          n = nTot
          do kt=2, ncentr
             do l=1, 3
                kt1 = (kt-1) * 3 + l
                centra(l) = centrt(latt, kt1)
             enddo
             do i=1, nTot
                n = n + 1
                kmat(n,1:3,1:3) = kmat(i,1:3,1:3)
                do l=1, 3
                   tr = tmat(i,l) + centra(l)
                   if (abs(tr - 1.0) < 0.001) tr = 0.0
                   tmat(n,l) = tr
                enddo
             enddo
          enddo
      endif
!
!      do i=1,nsymTot
!         write(lo,'(i5)') i
!         write(lo,'(3f10.5)') tmat(i,1:3)
!         do l=1,3
!            write(lo,'(3i5)') kmat(i,l,1:3)
!         enddo
!      enddo
!
      call MakeSymmStrings
!
      return
      end
!-----------------------------------------------------------------------
      subroutine MakeSymmStrings
      USE Symmetry
!
      implicit none
      integer :: ifi, ifin(2), nfin, i, j, k, kt, kt1, l
      integer :: ip, iplus, ii, coef
      real    :: traslav(3), tr
      character (len=1) :: xyzshe(3)
      character (len=3) :: trasla
!
!
!-- Make strings
!
      SymmStrings(:) = ' '
      xyzshe(1:3) = (/'x', 'y', 'z'/)
      do i=1, nsymTot
         ip = 1
         do j=1, 3
            tr = tmat(i,j)
            if (tr < 0) tr = tr + 1.0
            traslav(j) = amod(tr, 1.0)
         enddo
         do j=1, 3
            iplus = 0
            if (traslav(j) > 0.001) then
                call TmatToCharNew(traslav(j), trasla)
                SymmStrings(i)(ip:ip+2) = trasla
                ip = ip + 3
                iplus = 1
            endif
            do k=1, 3
               ii = kmat(i,j,k)
               if (ii /= 0) then
                   if (ii < 0) then
                       SymmStrings(i)(ip:ip)='-'
                       ip =  ip + 1
                   else
                       if (iplus == 1) then
                           SymmStrings(i)(ip:ip)='+'
                           ip = ip + 1
                       endif
                   endif
                   write(SymmStrings(i)(ip:ip),'(a1)') xyzshe(k)
                   ip = ip + 1
                   iplus = 1
               endif
            enddo
            if (j < 3) then
                write(SymmStrings(i)(ip:ip),'(a1)') ','
                ip = ip + 1
                iplus = 0
            endif
         enddo
         ip = 1
         iplus = 0
      enddo
!
      nSymmStrings = nsymTot
!     do i=1, nSymmStrings
!        write(6,'(i,1h),2x,a)') i, SymmStrings(i)
!     enddo
!
      return
      end
!---------------------------------------------------------------------
      subroutine TmatToCharNew(input, trasla)
!
      implicit none
      integer :: n
      real    :: input
      character*(*) trasla
!
      n = nint(input * 100)
      if (n.eq.50) then
          trasla = '1/2'
      elseif (n.eq.33) then
          trasla = '1/3'
      elseif (n.eq.67) then
          trasla = '2/3'
      elseif (n.eq.25) then
          trasla = '1/4'
      elseif (n.eq.75) then
          trasla = '3/4'
      elseif (n.eq.17) then
          trasla = '1/6'
      elseif (n.eq.83) then
          trasla = '5/6'
      else
          trasla = '   '
      endif
!
      return
      end
!---------------------------------------------------------------------
      subroutine FromSymmCardsToSpaceGroupSymbol(found)
      USE Symmetry
      USE General
!
!-- Converts symmetry operators in integer*8 numbers
!
      implicit none
      integer :: found, i, jopen, jop, itype, jform, ier, nTot, OK
      integer :: dummy(2)
      character (len=1)  :: LattCh
      character (len=16) :: spg
!
      found = 0
      call Codifica
      itype = 2
      jform = 1
      jop = jopen(jhost, SymmSPG, itype, jform, ier)
!
      do
         read(jhost,'(a16,3i5)', end=100) spg, nTot, dummy(1:2)
         read(jhost,'(5i15)') ConvInp(1:nTot)
         if (nTot == nsymTot) then
             OK = 1
             do i=1, nsymTot
                if (ConvInp(i) /= ConvVett(i)) then
                    OK = 0
                    exit
                endif
             enddo
             if (OK == 1) then
                 found = 1
                 call lcase(spg)
                 call ucase(spg(1:1))
                 read(spg,'(16a1)') nSpaceG
                 exit
             endif
         endif
      enddo
  100 continue
      close(jhost)
      if (found == 0) then
          if (nsym == 1) then
              LattCh = hbr(latt)
              call ucase(LattCh)
              spg = LattCh // ' 1             '
              found = 1
          else
              spg = '                '
          endif
          read(spg,'(16a1)') nSpaceG
      endif
!
      return
      end
!---------------------------------------------------------------------
      subroutine Codifica
      USE Symmetry
      USE General
!
!-- Converts symmetry operators in integer*8 numbers
!
      implicit none
      integer*8 :: tmp, n, dieci, espo
      integer   :: i, j, k, l, tvet(3), rmat(3,3), esp, t(3)
      real      :: a
!
      ConvVett(:) = 0
      dieci = 10
      do k=1, nSymTot
         rmat(1:3,1:3) = kmat(k,1:3,1:3) + 1
         tmp = 0
         esp = 11
         do i=1, 3
            do j=1, 3
               n = rmat(i,j)
               espo = dieci ** esp
               tmp = tmp + n * espo
               esp = esp - 1
            enddo
         enddo
!
         do i=1, 3
            a = tmat(k,i)
            if (a < 0.0) then
                a = a + 1.0
            elseif (a > 1.0) then
                a = a - 1.0
            endif
            j = a * 100
            if (j == 0) then        ! 0
                t(i) = 0
            elseif (j == 50) then    ! 1/2
                t(i) = 2
            elseif (j == 33) then    ! 1/3
                t(i) = 3
            elseif (j == 25) then    ! 1/4
                t(i) = 4
            elseif (j == 16) then    ! 1/6
                t(i) = 6
            elseif (j == 66) then    ! 2/3
                t(i) = 7
            elseif (j == 75) then    ! 3/4
                t(i) = 8
            elseif (j == 83) then    ! 5/6
                t(i) = 9
            else
                write(6,*) tmat(k,i)
                stop
            endif
         enddo
         do i=1, 3
            n = t(i)
            espo = dieci ** esp
            tmp = tmp + n * espo
            esp = esp - 1
         enddo
         ConvVett(k) = tmp
      enddo
!
      call sort3_int8(ConvVett, nSymTot)
!
!-- per creare nuove entries nel file Sir.cnv
!
!gl!  write(14,'(16a1,3i5)') nSpaceG(1:16), nsymTot, icent, latt
!
!gl!  write(14,'(5i15)') ConvVett(1:nSymTot)
!
      return
      end
!---------------------------------------------------------------------
      subroutine OriginiRoxi()
      USE General
      USE Symmetry
!
!-- fornisce le origini permesse, per tutti i gruppi spaziali
!
!-- I422, I4122, I-42m, I-42d hanno solo (0,0,0), (0,0,1/2),
!-- I-4, I-4m2, I-4c2 hanno anche (1/2,0,1/4) e (1/2,0,3/4)
!                         ORA CORRETTO.
!-- Forse ci sono problemi su:
!--       F d d 2  (no55)
!   sul libro blu risulta solo (0,0,z) mentre nel programma
!   veniva prima utilizzata anche (1/4,1/4,z) ora commentata.
!   DA VERIFICARE !!!
!
      implicit none
      integer :: AsseUnico, i, j
      real    :: zero, uno, due, tre, qua, cin, sei, a50, a33, a66 
      real    :: a16, a83, a25, a75
!
      if (jsys == 2) then
          do i=1,3
             if (kmat(2,i,i) == 1) then
                 AsseUnico = i
             endif
          enddo
      endif
!
      if3den = 0
      nOrigRoxi = 0
      tabo(:,:) = 0.0
      xyzmax(1:3) = -9999
      zero = 0.0
      uno = 1.0
      due = 2.0
      tre = 3.0
      qua = 4.0
      cin = 5.0
      sei = 6.0
      a50 = uno / due
      a33 = uno / tre
      a66 = due / tre
      a16 = uno / sei
      a83 = cin / sei
      a25 = uno / qua
      a75 = tre / qua
!
      if (icent == 1) then
          if (latt == 1 .or. latt == 7) then
!
!---gruppi spaziali primitivi c.s.--------
!
              if (ifRhombAx == 1) then
                  nOrigRoxi=2
                  tabo(1,1:3) = zero
                  tabo(2,1:3) =  a50
              endif

              select case (jsys)
!
                case (1,2,3)         ! Triclinic, Monoclinic, Orthorombic
!
                   nOrigRoxi=8
                   tabo(1,1:3)=zero
                   tabo(2,1:3)=(/  a50, zero, zero/)
                   tabo(3,1:3)=(/ zero,  a50, zero/)
                   tabo(4,1:3)=(/ zero, zero,  a50/)
                   tabo(5,1:3)=(/ zero,  a50,  a50/)
                   tabo(6,1:3)=(/  a50, zero,  a50/)
                   tabo(7,1:3)=(/  a50,  a50, zero/)
                   tabo(8,1:3)= a50 
!
                case (4)             ! Tetragonal
!
                   nOrigRoxi=4
                   tabo(1,1:3)=zero
                   tabo(2,1:3)=(/ zero, zero,  a50/)
                   tabo(3,1:3)=(/  a50,  a50, zero/)
                   tabo(4,1:3)= a50
!
                case (5)                ! Hexagonal
!
                   if (latt == 7) then
                       if3den = 1
                       nOrigRoxi=6
                       tabo(1,1:3)=zero
                       tabo(2,1:3)=(/ zero, zero,  a50/)
                       tabo(3,1:3)=(/  a66,  a33,  a33/)
                       tabo(4,1:3)=(/  a66,  a33,  a83/)
                       tabo(5,1:3)=(/  a33,  a66,  a16/)
                       tabo(6,1:3)=(/  a33,  a66,  a66/)
                   else
                       nOrigRoxi=2
                       tabo(1,1:3)=zero
                       tabo(2,1:3)=(/ zero, zero,  a50/)
                   endif
!
                case (6)                ! Cubic
!
                   nOrigRoxi=2
                   tabo(1,1:3)=zero
                   tabo(2,1:3)=(/  a50, a50, a50/)
              end select
          else
!
!---gruppi spaziali non primitivi c.s.--------
!
              select case (jsys)
!
! -- Dedi per gestire casi tipo C1, etc...
!
                case (1)         ! Triclinic
!
                   nOrigRoxi=8
                   tabo(1,1:3)=zero
                   tabo(2,1:3)=(/  a50, zero, zero/)
                   tabo(3,1:3)=(/ zero,  a50, zero/)
                   tabo(4,1:3)=(/ zero, zero,  a50/)
                   tabo(5,1:3)=(/ zero,  a50,  a50/)
                   tabo(6,1:3)=(/  a50, zero,  a50/)
                   tabo(7,1:3)=(/  a50,  a50, zero/)
                   tabo(8,1:3)= a50
!
!
!
                case (2)             ! Monoclinic
!
                   nOrigRoxi=4
                   tabo(1,1:3)=zero
                   if (AsseUnico == 1) then            ! Asse unico "a"
                       tabo(2,1:3)=(/ zero, a50 , zero/)
                       tabo(3,1:3)=(/ zero, zero, a50 /)
                       tabo(4,1:3)=(/ zero, a50 , a50/)
                   elseif (AsseUnico == 2) then        ! Asse unico "b"
                       tabo(2,1:3)=(/ zero, zero,  a50/)
                       tabo(3,1:3)=(/  a50, zero, zero/)
                       tabo(4,1:3)=(/  a50, zero, a50/)
                   elseif (AsseUnico == 3) then        ! Asse unico "c"
                       tabo(2,1:3)=(/  a50, zero, zero/)
                       tabo(3,1:3)=(/ zero,  a50, zero/)
                       tabo(4,1:3)=(/  a50,  a50, zero/)
                   endif
!
                case (3)                       !  Orthorhombic
!
                   if (latt == 4) then             ! Cella C
                       nOrigRoxi=4
                       tabo(1,1:3)=zero
                       tabo(2,1:3)=(/ zero, zero,  a50/)
                       tabo(3,1:3)=(/  a50, zero, zero/)
                       tabo(4,1:3)=(/  a50, zero, a50/)
                   elseif (latt == 5) then         ! Cella I
                       nOrigRoxi=4
                       tabo(1,1:3)=zero
                       tabo(2,1:3)=(/ zero, zero,  a50/)
                       tabo(3,1:3)=(/ zero,  a50, zero/)
                       tabo(4,1:3)=(/  a50, zero, zero/)
                   elseif (latt == 6) then         ! Cella F
                       nOrigRoxi=2
                       tabo(1,1:3)=zero
                       tabo(2,1:3)=(/  a50, a50, a50/)
                   endif
!
                case (6)             ! Cubic
!
                   if (latt == 6) then   ! Cella F
                       nOrigRoxi=2
                       tabo(1,1:3)=zero
                       tabo(2,1:3)=(/  a50, a50, a50/)
                   elseif (latt == 5) then   ! Cella I 
                       nOrigRoxi=1
                       tabo(1,1:3)=zero
                   endif
!
                case (4)             ! Tetragonal
!
                   nOrigRoxi=2
                   tabo(1,1:3)=zero
                   tabo(2,1:3)=(/ zero, zero,  a50/)
              end select
          endif
      else
!
          if (latt == 1 .or. latt == 7) then
!
!---gruppi spaziali primitivi non c.s.--------
!
              if (ifRhombAx == 1) then
                  if (kpol.ne.0) then
                      nOrigRoxi=1
                      tabo(1,1:3)=128.0
                  else
                      nOrigRoxi=2
                      tabo(1,1:3)=zero
                      tabo(2,1:3)=(/  a50, a50, a50/)
                  endif
              endif
!
              select case (jsys)
!
                case (1)                ! Triclinic
!
                   nOrigRoxi=1
                   tabo(1,1:3)=128.0
!
                case (2)                ! Monoclinic
!
                   if (kpol == 10) then        ! Floating origin along y
                       nOrigRoxi=4
                       tabo(1,1:3)=(/ zero, 256.0, zero/)
                       tabo(2,1:3)=(/ zero, 256.0,  a50/)
                       tabo(3,1:3)=(/  a50, 256.0, zero/)
                       tabo(4,1:3)=(/  a50, 256.0, a50/)
                   elseif (kpol == 100) then        ! Floating origin along x
                       nOrigRoxi=4
                       tabo(1,1:3)=(/ 256.0, zero, zero/)
                       tabo(2,1:3)=(/ 256.0, zero,  a50/)
                       tabo(3,1:3)=(/ 256.0,  a50, zero/)
                       tabo(4,1:3)=(/ 256.0,  a50, a50/)
                   elseif (kpol == 1) then        ! Floating origin along z
                       nOrigRoxi=4
                       tabo(1,1:3)=(/ zero, zero, 256.0/)
                       tabo(2,1:3)=(/ zero,  a50, 256.0/)
                       tabo(3,1:3)=(/  a50, zero, 256.0/)
                       tabo(4,1:3)=(/  a50, a50, 256.0/)
                   elseif (kpol == 101) then        ! Floating origin along x e z
                       nOrigRoxi=2
                       tabo(1,1:3)=(/ 128.0, zero, 128.0/)
                       tabo(2,1:3)=(/ 128.0,  a50, 128.0/)
                   elseif (kpol == 110) then        ! Floating origin along x e y
                       nOrigRoxi=2
                       tabo(1,1:3)=(/ 128.0, 128.0, zero/)
                       tabo(2,1:3)=(/ 128.0, 128.0,  a50/)
                   elseif (kpol == 11) then        ! Floating origin along y e z
                       nOrigRoxi=2
                       tabo(1,1:3)=(/ zero, 128.0, 128.0/)
                       tabo(2,1:3)=(/  a50, 128.0, 128.0/)
                   endif
!
                case (3)                     !  Orthorhombic
!
                   if (kpol == 1) then         ! Floating origin along z
                       nOrigRoxi=4
                       tabo(1,1:3)=(/ zero, zero, 256.0/)
                       tabo(2,1:3)=(/ zero,  a50, 256.0/)
                       tabo(3,1:3)=(/  a50, zero, 256.0/)
                       tabo(4,1:3)=(/  a50, a50, 256.0/)
                   elseif (kpol == 10) then         ! Floating origin along y
                       nOrigRoxi=4
                       tabo(1,1:3)=(/ zero, 256.0, zero/)
                       tabo(2,1:3)=(/ zero, 256.0,  a50/)
                       tabo(3,1:3)=(/  a50, 256.0, zero/)
                       tabo(4,1:3)=(/  a50, 256.0, a50/)
                   elseif (kpol == 100) then         ! Floating origin along x
                       nOrigRoxi=4
                       tabo(1,1:3)=(/ 256.0, zero, zero/)
                       tabo(2,1:3)=(/ 256.0, zero,  a50/)
                       tabo(3,1:3)=(/ 256.0,  a50, zero/)
                       tabo(4,1:3)=(/ 256.0,  a50, a50/)
                   else
                       nOrigRoxi=8
                       tabo(1,1:3)=zero
                       tabo(2,1:3)=(/  a50, zero, zero/)
                       tabo(3,1:3)=(/ zero,  a50, zero/)
                       tabo(4,1:3)=(/ zero, zero,  a50/)
                       tabo(5,1:3)=(/ zero,  a50, a50/)
                       tabo(6,1:3)=(/  a50, zero, a50/)
                       tabo(7,1:3)=(/  a50, a50, zero/)
                       tabo(8,1:3)= a50 
                   endif
!
                case (4)                !  Tetragonal
!
                   if (kpol == 1) then         ! Floating origin along z
                       nOrigRoxi=2
                       tabo(1,1:3)=(/ zero, zero, 256.0/)
                       tabo(2,1:3)=(/  a50, a50, 256.0/)
                   else
                        nOrigRoxi=4
                        tabo(1,1:3)=zero
                        tabo(2,1:3)=(/ zero, zero,  a50/)
                        tabo(3,1:3)=(/  a50, a50, zero/)
                        tabo(4,1:3)=(/  a50, a50, a50/)
                   endif
!
                case (5)                !    Hexagonal
!
                   if (latt == 1) then
                       if (kpol == 1) then         ! Floating origin along z
                           if3den = 1
                           if (jsvet(1) == 128) then
                               nOrigRoxi=3
                               tabo(1,1:3)=(/ zero, zero, 128.0/)
                               tabo(2,1:3)=(/  a33,  a66, 128.0/)
                               tabo(3,1:3)=(/  a66,  a33, 128.0/)
                           else
                               nOrigRoxi=1
                               tabo(1,1:3)=(/ zero, zero, 256.0/)
                           endif
                       else
                           if (jsvet(1) == 128) then
                               if3den = 1
                               nOrigRoxi=6
                               tabo(1,1:3)=zero
                               tabo(2,1:3)=(/ zero, zero,  a50/)
                               tabo(3,1:3)=(/  a33,  a66, zero/)
                               tabo(4,1:3)=(/  a33,  a66,  a50/)
                               tabo(5,1:3)=(/  a66,  a33, zero/)
                               tabo(6,1:3)=(/  a66,  a33,  a50/)
                           else
                               nOrigRoxi=2
                               tabo(1,1:3)=zero
                               tabo(2,1:3)=(/ zero, zero,  a50/)
                           endif
                       endif
                   else
                       if (kpol == 1) then
                           nOrigRoxi=3
                           tabo(1,1:3)=(/ zero, zero, 256.0/)
                           tabo(2,1:3)=(/  a66,  a33, 256.0/)
                           tabo(3,1:3)=(/  a33,  a66, 256.0/)
                       else
                           nOrigRoxi=6
                           tabo(1,1:3)=zero
                           tabo(2,1:3)=(/ zero, zero,  a50/)
                           tabo(3,1:3)=(/  a66,  a33,  a33/)
                           tabo(4,1:3)=(/  a33,  a66,  a16/)
                           tabo(5,1:3)=(/  a66,  a33,  a83/)
                           tabo(6,1:3)=(/  a33,  a66,  a66/)
                       endif
                   endif
!
                case (6)                !  Cubic
!
                   nOrigRoxi=2
                   tabo(1,1:3)=zero
                   tabo(2,1:3)=(/  a50, a50, a50/)
              end select
           else
!
!---gruppi spaziali non primitivi non c.s.--------
!
              select case (jsys)
!
! -- Dedi per gestire casi tipo C1, etc...
!
                case (1)                ! Triclinic
!
                   nOrigRoxi=1
                   tabo(1,1:3)=128.0
!
!
!
                case (2)                !  Monoclinic
!
                   if (kpol == 10) then    ! Floating origin along y
                       nOrigRoxi=2
                       tabo(1,1:3)=(/ zero, 256.0, zero/)
                       tabo(2,1:3)=(/ zero, 256.0,  a50/)
                   else
                       nOrigRoxi=1
                       tabo(1,1:3)=(/ 128.0, zero, 128.0/)
                   endif
!
                case (3)                ! Orthorhombic
                   if (latt == 4) then      ! cella C
                       if (kpol == 1) then   ! Floating origin along z
                           nOrigRoxi=2
                           tabo(1,1:3)=(/ zero, zero, 256.0/)
                           tabo(2,1:3)=(/  a50, zero, 256.0/)
                       else
                           nOrigRoxi=4
                           tabo(1,1:3)=zero
                           tabo(2,1:3)=(/ zero, zero,  a50/)
                           tabo(3,1:3)=(/  a50, zero, zero/)
                           tabo(4,1:3)=(/  a50, zero, a50/)
                       endif
                   elseif (latt == 2) then
                       nOrigRoxi=2
                       tabo(1,1:3)=(/ zero, zero, 256.0/)
                       tabo(2,1:3)=(/  a50, zero, 256.0/)
                   elseif (latt == 5) then
                       if (kpol == 1) then     ! Floating origin along z
                           nOrigRoxi=2
                           tabo(1,1:3)=(/ zero, zero, 256.0/)
                           tabo(2,1:3)=(/  a50, zero, 256.0/)
                       else
                           nOrigRoxi=4
                           tabo(1,1:3)=zero
                           tabo(2,1:3)=(/ zero, zero,  a50/)
                           tabo(3,1:3)=(/ zero,  a50, zero/)
                           tabo(4,1:3)=(/  a50, zero, zero/)
                       endif
                   elseif (latt == 6) then
                       if (kpol == 1) then     ! Floating origin along z
                           nOrigRoxi=1
                           tabo(1,1:3)=(/ zero, zero, 256.0/)
*                          nOrigRoxi=2    ! fdd2 (no55)
*                          tabo(2,1:3)=(/  a25,  a25, 256.0/)
                          else
                           nOrigRoxi=4
                           tabo(1,1:3)=zero
                           tabo(2,1:3)=(/  a25, a25, a25/)
                           tabo(3,1:3)=(/  a50, a50, a50/)
                           tabo(4,1:3)=(/  a75, a75, a75/)
                       endif
                   endif
!
                case (6)             ! Cubic
!
                   if (latt == 5) then
                       nOrigRoxi=1
                       tabo(1,1:3)=zero
                   else
                       if (jsvet(9) == 96) then
                           nOrigRoxi=2
                           tabo(1,1:3)=zero
                           tabo(2,1:3)=(/  a50, a50, a50/)
                       else
                           nOrigRoxi=4
                           tabo(1,1:3)=zero
                           tabo(2,1:3)=(/  a25, a25, a25/)
                           tabo(3,1:3)=(/  a50, a50, a50/)
                           tabo(4,1:3)=(/  a75, a75, a75/)
                       endif
                   endif
!
                case (4)             ! Tetragonal
!
                   if (kpol == 1) then     ! Floating origin along z
                       nOrigRoxi=1
                       tabo(1,1:3)=(/ zero, zero, 256.0/)
                   else 
!
!-- errore sul libro blu: I422 e I4122 hanno solo (0,0,0), (0,0,1/2),
!--                       I-42m, I-42d, I-4, I-4m2, I-4c2  hanno anche
!                         (1/2,0,1/4) e (1/2,0,3/4)
                       if (latt == 5) then    ! diole
                           nOrigRoxi=2
                           tabo(1,1:3)=zero
                           tabo(2,1:3)=(/ zero, zero,  a50/)
                           if (nSpaceGroup == 82  .or. 
     *                         nSpaceGroup == 119 .or.
     *                         nSpaceGroup == 120) then
                               nOrigRoxi=4
                               tabo(3,1:3)=(/  a50, zero,  a25/)
                               tabo(4,1:3)=(/  a50, zero,  a75/)
                           endif
                       else
                           if (jsvet(9) == 0) then
                               nOrigRoxi=2
                               tabo(1,1:3)=zero
                               tabo(2,1:3)=(/ zero, zero,  a50/)
                           else
                               nOrigRoxi=4
                               tabo(1,1:3)=zero
                               tabo(2,1:3)=(/ zero, zero,  a50/)
                               tabo(3,1:3)=(/  a50, zero,  a25/)
                               tabo(4,1:3)=(/  a50, zero,  a75/)
                           endif
                       endif
                   endif
              end select
           endif
      endif
!
!-- errore: nessuna traslazione trovata
!
      if (nOrigRoxi == 0) then
          OkOrig = 0
          call VecchiaExamin
      else
          OkOrig = 1
      endif
!
      do i=1,nOrigRoxi
         do j=1,3
            if (tabo(i,j) > xyzmax(j)) then
                xyzmax(j) = tabo(i,j)
            endif
         end do
      end do
      do j=1,3
         if (xyzmax(j) < 0.6) then
             xyzmax(j) = 2.0
         elseif (xyzmax(j) < 0.7) then
             xyzmax(j) = 32.0   !  caso 1/3, 2/3 
         elseif (xyzmax(j) < 0.9) then
             xyzmax(j) = 32.0   !  caso 1/6, 5/6 
         elseif (xyzmax(j) < 1.0) then
             xyzmax(j) = 4.0
         endif
      end do
!
      return
      end
!-----------------------------------------------------------------------
      subroutine StampaOriginiRoxi(lunit)
      USE General
      USE Symmetry
      USE Molcom
!
!--stampa le origini permesse per il dato gruppo spaziale
!
!
      character(len=3)   :: xyzb(3)
!
      if (okOrig == 0) then
          write(lunit,10)
      endif
      write(lunit,20)
      xyzb = (/' x ',' y ',' z '/)
      do i=1, nOrigRoxi
         SmallIt(i) = '(   ,   ,   )  '
         iniz = 2
         do j=1,3
            valore = tabo(i,j)
            if (valore < 0.1) then
                SmallIt(i)(iniz:iniz+2) = ' 0 '
            elseif (valore < 0.2) then
                SmallIt(i)(iniz:iniz+2) = '1/6'
            elseif (valore < 0.3) then
                SmallIt(i)(iniz:iniz+2) = '1/4'
            elseif (valore < 0.4) then
                SmallIt(i)(iniz:iniz+2) = '1/3'
            elseif (valore < 0.6) then
                SmallIt(i)(iniz:iniz+2) = '1/2'
            elseif (valore < 0.7) then
                SmallIt(i)(iniz:iniz+2) = '2/3'
            elseif (valore < 0.8) then
                SmallIt(i)(iniz:iniz+2) = '3/4'
            elseif (valore < 0.9) then
                SmallIt(i)(iniz:iniz+2) = '5/6'
            elseif (valore < 1.0) then
                SmallIt(i)(iniz:iniz+2) = '3/4'
            else
                if (ifRhombAx == 1) then
                    SmallIt(i)(iniz:iniz+2) = xyzb(1)
                else
                    SmallIt(i)(iniz:iniz+2) = xyzb(j)
                endif
            endif
            iniz = iniz + 4
         enddo
      enddo
      write(lunit,30) (SmallIt(i)(1:15),i=1,nOrigRoxi)
!
      return
   10 format(/,' WARNING: the program has been unable to compute the',/,
     *         '          correct origin translations.',/,
     *         '          Standard translations assumed.')
   20 format(/,' Allowed origin translations:')
   30 format(2(8x,4a15,/))
      end
!-----------------------------------------------------------------------
!        special position library flow diagram
!
! --->-----+---------------------------+--------------->----
!        xspinb(*)                  kspecb
!        xflori       +-----------+----+-----+----------+
!                  xnuova       xelles      xtherm    xprint
!            +--------+---------+
!          xequi    xdist     xdepa
!                             xcmat
!
!   also available xwrifl to print information about float. origin
!
!   (*) this subroutine is the only package-specific one
!
!
!-----------------------------------------------------------------------
      subroutine xspinb
      USE General
      USE Symmetry
!--
!-- initialization subroutine for special positions
!--
!-- soper  symmetry operators matrix
!-- centrt translation matrix for non primitive lattice
!-- aaa    constants to compute atoms distances
!-- nsym   number of symmetry operators
!-- ncentr number of translation matricies
!-- icent  = 0  noncentrosymmetric space group
!--        = 1  centrosymmetric space group
!-- kpol   = 0  no floating origin
!--        > 0  floating origin (see subr. florig)
!-- jsys   crystal family
!--           p   a   b   c   f   i   r
!-- latt   =  1   2   3   4   5   6   7   (multan)
!-- indv,mpv  utility array
!-- jspini = +2 common /spec/ already filled  (sir)
!--        = -1 common /spec/ actually not initialized
!--        =  0  sir environment - do not mind about initialization
!-- ddmin  minimun distance to define a peak
!--        being in general position
      dimension kcentr(7),abc(3),ang(3)
!
      if (jspini.gt.0) return
!
!-- cell parameters, cent and lattice code needed
!
      do i=2,6
         kcentr(i)=2
      enddo
      kcentr(1)=1
Corig kcentr(5)=4
      kcentr(6)=4
      kcentr(7)=3
      do i=1,3
         abc(i)=cell(i)
         ang(i)=cell(i+3)
      enddo
      aaa(1)=abc(1)*abc(1)
      aaa(2)=abc(2)*abc(2)
      aaa(3)=abc(3)*abc(3)
      aaa(4)=2.0*abc(1)*abc(2)*cos(ang(3)*dtor)
      aaa(5)=2.0*abc(1)*abc(3)*cos(ang(2)*dtor)
      aaa(6)=2.0*abc(2)*abc(3)*cos(ang(1)*dtor)
!
      ncentr=kcentr(latt)
!
!-- compute floating origin code
!
      call xflori
      jspini=2
!
!-- compute allowed origin shifts
!
      call OriginiRoxi()
      if (ifRhombAx == 1) then
          kcentr(7)=1
      endif
!
      return
      end
!------------------------------------------------------------------
      subroutine xflori
      USE Symmetry
!
!-- floating origin subroutine
!
!-- kpol code is computed to take
!-- into account floating origin.
!-- if kpol.eq.0 then no floating origin
!-- if kpol.ne.0 then the floating direction
!--                   corresponds to 1's in the code
!                     e.g.   kpol=001 float. origin along z
!                            kpol=100 float. origin along x
!
      dimension jfl(3)
!
      jfl(1:3) = 0
      if (icent.eq.1) then
          kpol=0
      else
          do 60 k=1,3
             jfl(k)=0
             do 50 i=1,nsym
                do 40 j=1,3
                   jfl(k)=jfl(k)+kmat(i,j,k)
   40           continue
   50        continue
             if (jfl(k).ne.nsym) then
c--  non - floating direction
                 jfl(k)=0
             else
c--  floating direction
                 jfl(k)=1
             endif
   60     continue
          mult=100
          kpol=0
          do 70 i=1,3
             kpol=kpol+jfl(i)*mult
             mult=mult/10
   70     continue
      endif
!
      vpol = jfl
!
      return
      end
code for kspecb
c----------------------------------------------------------------------
      function kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
      USE Symmetry
c
c-- function to handle atoms in special position
c
c   return value
c          kspecb = +1 atom in general position
c                 = -1 atom in special position
c-- meaning of parameters
c     xo    = array containing original values for x,y,z,occ,u's,c-occ
c     xn    = array containing modified values for x,y,z,occ,u's,c-occ
c    key    = array containing conditions for      x,y,z,    u's,c-occ
c  itype    = type of atom
c   iser    = serial number
c  khead    =  0  heading for special position to be print
c           =  1  heading not to be printed
c     iactn =     action to be taken :
c           =  1  compute crystallographic occupation
c           =  2  generate key array and update x's and u's
c           =  3  print information
c    newvet = matrix containing information about
c             the symmetry operators involved
      dimension xo(11),xn(11),key(10),newvet(48,3)
c
      do i=1,9
         key(i)=i
      enddo
      key(10)=1
      call xnuova(xo,xn,key,n,newvet)
      kspecb=1
      if (key(10).gt.1) then
          kspecb=-1
          if (iactn.gt.1) then
              if (key(10).ne.1) then
                  call xelles(newvet,n,key)
                  call xtherm(newvet,n,key)
              endif
              if (iactn.gt.2) call xprint(key,itype,iser,khead)
          endif
      endif
!
      return
      end
code for xnuova
c------------------------------------------------------------------
      subroutine xnuova(xo,xn,key,nr,newvet)
      USE Symmetry
c--
c-- subroutines to recognize if a peak is in a special position.
c-- if it is very close to it, the peak is "moved" in it.
c--
c-- check if atoms are in special position
c-- computing the distance between an atom
c-- and its symmetry equivalents
c--
      dimension xo(11),xn(11),key(10),vet(2)
      dimension xeq(3),m(3,3),s(3),xb1(3),xb2(3),newvet(48,3)
c
      vet(1)= 1.0
      vet(2)=-1.0
      do i=1,11
         xn(i)=xo(i)
      enddo
      do i=1,3
         xb1(i)=xo(i)
         xb2(i)=xo(i)
      enddo
      ifin=icent+1
      nr=0
      do kt=1,ncentr
         do ifi=1,ifin
            coef=vet(ifi)
            do k=1,nsym
               if (k.eq.1.and.ifi.eq.1.and.kt.eq.1) cycle
               call xequi(xb2,k,coef,xeq,kt)
               call xdist(xb2,xeq,d,s)
               if (d.le.ddmin) then
                   nr=nr+1
                   newvet(nr,3)=k*coef
                   do j=1,3
                      xb1(j)=xb1(j)+xb2(j)+s(j)
                   enddo
               endif
            enddo
         enddo
      enddo
      if (nr.ne.0) then
          do l=1,nr
             k=newvet(l,3)
             coef=1.0
             if (k.lt.0) then
                 k=-k
                 coef=-1.0
             endif
             do ii=1,3
                do j=1,3
                   m(ii,j)=coef*kmat(k,ii,j)
                enddo
             enddo
             call xdepac(m,ind,inew)
             newvet(l,1)=inew
             newvet(l,2)=ind
          enddo
          do j=1,3
             xb1(j)=xb1(j)/float(nr+1)
          enddo
      else
          do j=1,3
             newvet(1,j)=1
          enddo
      endif
c
      kcond=nr+1
      do i=1,3
         xn(i)=xb1(i)
      enddo
      xn(11)=1.0/float(kcond)
      key(10)=kcond
      return
      end
!--------------------------------------------------------------------
      subroutine xequi(xb2,k,coef,xeq,kt)
      USE Symmetry
!
!-- computes the symmetry equivalent of an atom
!
      dimension xb2(3), xeq(3), tt(3)
!
!      do l=1,3
!         ktl=(kt-1)*3+l
!         xeq(l)=coef*tmat(k,l)+centrt(latt,ktl)
!         do j=1,3
!            xeq(l)=xeq(l)+xb2(j)*coef*kmat(k,l,j)
!         enddo
!      enddo
!
!--07.nov.08  Mercedes
!
      tt(1:3) = tmat(k,1:3)
      do l=1,3
         if (coef == -1) then
             if (abs(tmat(k,l)) > 0.01) tt(l) = 1 - tmat(k,l)
         endif
         ktl = (kt - 1) * 3 + l
         xeq(l) = tt(l) + centrt(latt,ktl)
         do j=1,3
            xeq(l) = xeq(l) + xb2(j) * coef * kmat(k,l,j)
         enddo
      enddo
!
      return
      end
!--------------------------------------------------------------------
      subroutine xequiTot(k, xold, xeq,iexit)
      USE Symmetry
!-- gli equivalenti generati sono arrotondati alla 6 cifra decimale
!-- computes the symmetry equivalent of the atom xold
!-- iexit = 0 equivalente unico
!           1 e' un doppione
!
      implicit none
      integer :: k, i, j, ieq, iexit
      real    :: xold(3), xeq(3), diffe
      character (len=80) :: linea
!
      do i=1,3
         xeq(i) = tmat(k,i)
         do j=1,3
            xeq(i) = xeq(i) + xold(j) * kmat(k,i,j)
         enddo
      enddo
      if (iexit == -1) then
          iexit = 0
          return
      endif
!
!--arrotondamento
!
*gl*  write(linea,'(3f20.6)') xeq(1:3)    ! gianluca 20/12/2011
*gl*  read(linea,'(3f20.6)') xeq(1:3)     ! gianluca 20/12/2011
!
!--check se l'equivalente e' unico
!
      if (k == 1) xyzEquiv(1:nsymTot,1:3) = 0.0
      do j=1,3
         xyzEquiv(k,j) = xeq(j)
      enddo
      if (k > 1) then
          do i=1,k-1
             ieq = 0
             do j=1,3
*gl*            if (xyzEquiv(i,j) == xeq(j)) ieq = ieq + 1 ! gianluca 20/12/2011
                diffe = abs(xyzEquiv(i,j) - xeq(j))        ! gianluca 20/12/2011
                if (diffe < 0.0001) ieq = ieq + 1
             enddo
             if (ieq == 3) then
                 iexit = 1
                 return
             endif
          enddo
      endif
      iexit = 0
!
      return
      end
code for xdist
c----------------------------------------------------------------------
      subroutine xdist(xb2,xeq,d,s)
      USE Symmetry
c--
c-- subroutine used to compute the distance between
c-- an atom and its equivalent
c--
      dimension xeq(3),xb2(3),delta(8,3),dp(3),ds(3),s(3)
c
      do 20 i=1,3
         d=xeq(i)-xb2(i)
         dp(i)=d-int(d)
         if (dp(i).le.0.0) then
             ds(i)=dp(i)+1.0
         else
             ds(i)=dp(i)-1.0
         endif
   20 continue
      delta(1,1)=dp(1)
      delta(1,2)=dp(2)
      delta(1,3)=dp(3)
      delta(2,1)=dp(1)
      delta(2,2)=dp(2)
      delta(2,3)=ds(3)
      delta(3,1)=dp(1)
      delta(3,2)=ds(2)
      delta(3,3)=dp(3)
      delta(4,1)=dp(1)
      delta(4,2)=ds(2)
      delta(4,3)=ds(3)
      delta(5,1)=ds(1)
      delta(5,2)=dp(2)
      delta(5,3)=dp(3)
      delta(6,1)=ds(1)
      delta(6,2)=dp(2)
      delta(6,3)=ds(3)
      delta(7,1)=ds(1)
      delta(7,2)=ds(2)
      delta(7,3)=dp(3)
      delta(8,1)=ds(1)
      delta(8,2)=ds(2)
      delta(8,3)=ds(3)
      dimi=99999.9
      do 40 i=1,8
         d2=delta(i,1)*delta(i,1)*aaa(1)
     &     +delta(i,2)*delta(i,2)*aaa(2)
     &     +delta(i,3)*delta(i,3)*aaa(3)
     &     +delta(i,1)*delta(i,2)*aaa(4)
     &     +delta(i,1)*delta(i,3)*aaa(5)
     &     +delta(i,2)*delta(i,3)*aaa(6)
         d=sqrt(d2)
         if (d.lt.dimi) then
                        dimi=d
                        do 30 j=1,3
                           s(j)=delta(i,j)
   30                   continue
                        endif
   40 continue
      d=dimi
      return
      end
code for xdepac
c-----------------------------------------------------------------------
      subroutine xdepac(m,ind,inew)
      USE General
      USE Symmetry
c--
c-- using a code associated to the matrix in use
c-- finds out which kind of symmetry operator
c-- is involved
c--
      dimension m(3,3)
c
      call xcmat(m,mp)
c
      in=0
      do 10 i=1,64
         if (mp.eq.mpv(i)) in=i
   10 continue
c
      if (in.eq.0) then
                      write(lo,*) 'stop speclib - xdepac '
                      write(lo,'(3i4)') ((m(i,j),j=1,3),i=1,3)
                      write(lo,'(i10)')      mp
                      call cstop('speclib - xdepac ') 
                    endif
c
      ind=in
      inw=1
      if (in.gt.32) then
                      inw=-1
                      in=in-32
                     endif
      inew=inw*indv(in)
      return
      end
code for xcmat
c------------------------------------------------------------------
      subroutine xcmat(m,mp)
c--
c-- this subroutine is used to transform a rotational
c-- matrix in a unique number to use like a pointer
c-- to recognize which kind of operator is involved
c-- ( mirror , 2-fold axis etc. )
c--
      dimension m(3,3)
c
      mp=0
      iexp=-1
      do i=1,3
         do j=1,3
            iexp=iexp+1
            if (m(i,j).ge.0) then
                mp=mp+m(i,j)*2**iexp
            else
                mp=mp+2**iexp+2**(iexp+9)
            endif
         enddo
      enddo
!
      return
      end
code for xwrifl
c----------------------------------------------------------------------
      subroutine xwrifl
      USE General
      USE Symmetry
c
c-- write information about freely floating origin
c
      character*3 xyz,xyzfr
c
      kdummy=kpol
      xyz='xyz'
      do 10 i=1,3
      j=4-i
      ipr=mod(kdummy,10)
      kdummy=kdummy/10
      xyzfr(j:j)=' '
      if (ipr.eq.1) xyzfr(j:j)=xyz(j:j)
   10 continue
      if (kpol.ne.0) write(lo,30) xyzfr
   30 format(/' *** warning *** freely floating origin along ',a3,/)
      return
      end
code for xelles
c------------------------------------------------------------------
      subroutine xelles(newvet,n,key)
      USE Symmetry
c
c-- this subroutine computes the
c-- conditions for least squares shifts
c
 
      integer xeq(3),xyz(3),xyo(3),iflc(3),key(10)
      integer mult(3),newvet(48,3)
c
      nn=n+1
      mult(1)=-1
      mult(2)= 1
      mult(3)= 2
      xyo(1)=3
      xyo(2)=11
      xyo(3)=13
      do i=1,3
         xyz(i)=xyo(i)
      enddo
      do m=1,n
         coef=1.0
         k=newvet(m,3)
         if (k.lt.0) then
             k=-k
             coef=-1
         endif
         do l=1,3
            xeq(l)=0
            do j=1,3
               xeq(l)=xeq(l)+xyo(j)*kmat(k,l,j)*coef
            enddo
         enddo
         do j=1,3
            if (xyz(j).ne.0) then
                xyz(j)=xyz(j)+xeq(j)
            endif
         enddo
      enddo
      ifl=0
      do i=1,3
         if (xyz(i).ne.0) then
             if (mod(xyz(i),nn).ne.0) ifl=1
         endif
      enddo
      if (ifl.eq.0) then
          do i=1,3
             xyz(i)=xyz(i)/nn
          enddo
      endif
c
      do i=1,3
         iflc(i)=0
      enddo
      k=0
      do i=1,3
         if (xyz(i).ne.0) then
             if (k.eq.0) then
                 k=1
                 if (xyz(i).lt.0) then
                     do j=1,3
                        xyz(j)=-xyz(j)
                     enddo
                 endif
             endif
         endif
      enddo
      do i=1,2
         if (iflc(i).eq.0) then
             if (xyz(i).ne.0) then
                 k=1
                 ifl2=0
                 do j=i+1,3
                    ifl1=0
                    do l=1,3
                       if (xyz(i)*mult(l).eq.xyz(j)) then
                           iflc(j)=mult(l)
                           iflc(i)=1
                           ifl1=1
                       endif
                       if (ifl1.eq.0) then
                           if (xyz(i).eq.xyz(j)*mult(l)) then
                               iflc(i)=mult(l)
                               iflc(j)=1
                               ifl1=1
                           endif
                       endif
                    enddo
                    ifl2=ifl2+ifl1
                 enddo
                 if (ifl2.ne.0) then
                     l=0
                     do j=1,3
                        if (iflc(j).ne.0) then
                            if (l.eq.0) l=j
                        endif
                     enddo
                     do j=1,3
                        if (iflc(j).ne.0) xyz(j)=xyo(l)*iflc(j)
                     enddo
                 endif
             endif
         endif
      enddo
      do i=1,3
         ifl=0
         if (xyz(i).ne.0) then
             do j=1,3
                do k=1,3
                   if (xyz(i).eq.xyo(j)*mult(k)) ifl=1
                enddo
             enddo
             if (ifl.eq.0) xyz(i)=xyo(i)
         endif
      enddo
      do j=1,3
         if (xyz(j).ne.0) then
             do k=1,3
                if (xyz(j).eq.xyo(k)) then
                    xyz(j)=k
                else if (xyz(j).eq.2*xyo(k)) then
                    xyz(j)=20+k
                else if (xyz(j).eq.-xyo(k))  then
                    xyz(j)=-k
                endif
             enddo
         endif
      enddo
      do i=1,3
         ix=xyz(i)
         ifl=0
         if (ix.lt.0) then
             do j=1,3
                if (xyz(j).eq.-ix) ifl=1
             enddo
             if (ifl.eq.0) xyz(i)=-xyz(i)
         endif
      enddo
      do i=1,3
         key(i)=xyz(i)
      enddo
      if (key(3).eq.23.or.key(3).eq.-3) key(3)=3
      return
      end
code for xprint
c----------------------------------------------------------------------
      subroutine xprint(key,itype,iser,khead)
      USE General
      USE Symmetry
c
c-- print symmetry restrictions on atomic parametrs
c
c--   key  array containing symmetry restrictions
c   itype  atom type (hollerith*4)
c    iser  serial
c
      common /atpos/ cbuff
      dimension key(10)
      character line*42,keyc(9)*2
      character cbuff*124
      data keyc/' x',' y',' z','11','22','33','23','13','12'/
c
      k=1
      mm=5
      do j=1,9
         if (j.le.4) then
             mm=4
         else
             mm=5
         endif
         kj=key(j)
         l=k+5
         if (kj.ge.0) then
             if (kj.eq.0) then
                 write(line(k:l),"('  0  ')")
             else if (kj.le.j) then
                 write(line(k:l),"(' ',a2,'   ')") keyc(kj)
             else if (kj.gt.9) then
                 if (kj.gt.20) then
                     kj=kj-20
                     write(line(k:l),"(a2,'*2 ')") keyc(kj)
                 else
                     kj=kj-10
                     write(line(k:l),"(a2,'/2 ')") keyc(kj)
                 endif
             else if (kj.lt.j) then
                 write(line(k:l),"(' ',a2,'  ')") keyc(kj)
             endif
         else
             kj=-kj
             if (j.le.3) then
                 write(line(k:l),"(' -',a1,'  ')")keyc(kj)(2:2)
             else
                 write(line(k:l),"('-',a2,'  ')") keyc(kj)
             endif
         endif
         k=k+mm
      enddo
c
      if (jspini.eq.1) then
c
c-- crystals output
c
         if (khead.eq.0) then
             write(lo,100)
             khead=1
         endif
         write(lo,200) itype,iser,line
      else
c
c-- sir output
c
Csir92   write(cbuff(47:124),300) (xn(i),i=1,3),xn(11),line
         cbuff(20:61) = line
      endif
c
  100 format(
     *' type serial    symmetry restrictions on atomic parameters')
  200 format(2x,a4,i4,4x,a42)
c
      return
      end
code for xtherm
c-----------------------------------------------------------------------
      subroutine xtherm(newvet,nr,key)
      USE Symmetry
c
c-- this subroutine computes the conditions for
c-- thermal parameters according to:
c
c           w.j.a.m. peterse and j.h. palme
c           acta cryst. (1966). 20, 147
c
 
      integer newvet(48,3),ivet(48),s,q(3,3),binv(9,6),ijt(6,2),itt(6)
      integer q12,q13,q23,vterm(6),bin1(6,6),key(10)
c
      do i=1,6
         vterm(i)=99
      enddo
      itt(1)=1
      itt(2)=5
      itt(3)=9
      itt(4)=6
      itt(5)=3
      itt(6)=2
      do k=1,6
         ict=0
         do i=1,3
            do j=1,3
               ict=ict+1
               if (ict.eq.itt(k)) then
                   ijt(k,1)=i
                   ijt(k,2)=j
               endif
            enddo
         enddo
      enddo
      ivet(1)=1
      do i=1,nr
         ivet(i+1)=newvet(i,3)
      enddo
      n=nr+1
      kk=0
      do i=1,3
         do j=1,3
            do k=1,3
               do l=1,3
                  q(k,l)=0
                  do js=1,n
                     coef=1.0
                     s=ivet(js)
                     if (s.lt.0) then
                         s=-s
                         coef=-1
                     endif
                     q(k,l)=q(k,l)+kmat(s,i,k)*kmat(s,j,l)
                  enddo
               enddo
            enddo
            q12=q(1,2)+q(2,1)
            q13=q(1,3)+q(3,1)
            q23=q(2,3)+q(3,2)
            kk=kk+1
            do k=1,3
               binv(kk,k)=q(k,k)
            enddo
            binv(kk,4)=q12
            binv(kk,5)=q13
            binv(kk,6)=q23
         enddo
      enddo
      do k=1,6
         isk=0
         i=ijt(k,1)
         j=ijt(k,2)
         kk=itt(k)
         do l=1,6
            bin1(k,l)=binv(kk,l)
         enddo
      enddo
      if (jsys.eq.5) then
          do i=4,6
             do l=1,6
                bin1(i,l)=2*bin1(i,l)
             enddo
          enddo
      endif
      do i=1,6
         ki=ijt(i,1)
         kj=ijt(i,2)
         ifl=0
         do j=1,6
            if (bin1(i,j).ne.0) ifl=1
         enddo
         if (ifl.eq.0) vterm(i)=0
      enddo
      kk=1
      do i=1,5
         ich=0
         if (vterm(i).eq.99) then
             do k=i+1,6
                 do iscont=-1,1,2
                    do js=0,1
                       jsc=mod(js+1,2)
                       do ls=0,1
                          lsc=mod(ls+1,2)
                          mi=ls*2**js+lsc
                          mk=ls*2**jsc+lsc
                          ifls=0
                          do j=1,6
                             ibi=bin1(i,j)*mi
                             ibk=bin1(k,j)*iscont*mk
                             if (ibi.ne.ibk) ifls=1
                          enddo
                          if (ifls.eq.0) then
                              if (ich.eq.0) kk=kk+1
                              ich=1
                              vterm(i)=kk*mk
                              vterm(k)=kk*iscont*mi
                          endif
                       end do
                    end do
                 end do
             end do
             if (vterm(i).eq.99) vterm(i)=1
         endif
      enddo
      if (vterm(6).eq.99) vterm(6)=1
      jpreva=0
      jprevb=0
      do i=1,6
         vterm(i)=6-vterm(i)
         if (vterm(i).eq.0) then
             if (jprevb.eq.0) then
                 vterm(i)=20+i
                 jprevb=i
             else
                 vterm(i)=20+jprevb
             endif
         else if (vterm(i).eq.3) then
             if (jprevb.eq.0) then
                 vterm(i)=i
                 jprevb=i
             else
                 vterm(i)=jprevb
             endif
         else if (vterm(i).eq.4) then
             if (jpreva.eq.0) then
                 vterm(i)=i
                 jpreva=i
             else
                 vterm(i)=jpreva
             endif
         else if (vterm(i).eq.5) then
             vterm(i)=i
         else if (vterm(i).eq.6) then
             vterm(i)=0
         else if (vterm(i).eq.9) then
             if (jprevb.eq.0) then
                 vterm(i)=-i
                 jprevb=i
             else
                 vterm(i)=-jprevb
             endif
         endif
      enddo
      do j=4,9
         i=j-3
         jv=vterm(i)
         if (jv.ne.0) then
             if (jv.le.9) then
                 jv=jv+3*isign(1,jv)
             else
                 jv=(mod(jv,20)+3)+20
             endif
         endif
         key(j)=jv
      enddo
      if (key(9).le.6.and.key(9).ge.4) key(9)=key(9)+10
!
      return
      end
c----------------------------------------------------------------------
      block data utabli
c
c--utility tables initialization
c
      character lsqt(28)*6,itrt(30)*12,sitin(85)*6
      integer jsiti(194),cvet(194),vcoll(25,2),mpv(64),ksiti(64)
      common /tab1/ jsiti,vcoll,cvet,ksiti,mpv
      common /tab2/ sitin,lsqt,itrt
      common /tab3/ ijt(6,2),iit(6),numpr(29),ktlsq(28)
      common /tab4/ lsqv(28),ktlsn(28)
      data ijt/1,2,3,1,1,2,1,2,3,2,3,3/
      data iit/1,5,9,2,3,6/
      data numpr/   555656,555566,555665,555666,445566,445533,445539,
     *445666,544665,544335,544935,544666,545456,545466,545430,445466,
     *444666,444333,555555,455403,455465,455466,444393,444339,444399,
     *454359,454353,454666,454656/
      data ktlsq/535050,506150,505063,506163,535063,536150,505050,
     *           535350,534750,535363,534763,536163,535650,565350,
     *           535663,565363,506161,506139,535053,535047,536139,
     *           536161,536153,536147,535353,535347,534753,534747/
      data ksiti/1219,103,115,112,112,201,220,228,228,302,316,316,308,
     *308,316,316,807,906,1711,1926,2027,1810,2518,2518,2824,2824,2723,
     *2723,2625,2625,1421,1313,719,403,1515,712,712,501,1620,728,728,
     *602,716,716,708,708,716,716,1107,1006,2111,2426,2327,2210,718,718,
     *724,724,723,723,725,725,421,513/
      data mpv/
     *        273,139537,140563, 65697, 16545,131857,135961,  2132,
     *      32852,  8977,  9498,  4875,  1290,  4362,  1291,  4378,
     *     131338,136458,   673,  8276, 43092, 82593,   140,    98,
     *      33890,  6284, 17506, 69772, 49250, 67724,139545,131859,
     *     140049,   785,   787, 17057, 66209,  8465,  8473, 41044,
     *      10324,131345,135450,132363,135434,132362,135947,140570,
     *       5386,   266, 82081, 34900,    84,   161, 71820, 50274,
     *      16482, 65676, 32866,  2188,  1122,  4236,  4889,  9491/
      data jsiti/0,11417,16666,16906,17170,17434,17674,17938,20826,21074
     *,21458,21722,21850,22098,22490,22738,34570,34578,34586,16667,16907
     *,17171,17435,17675,17939,33059,33315,33571,34571,34579,34587,34595
     *,67363,-16668,-16908,17172,17436,17676,17940,18492,18740,18996
     *,19260,33316,33572,33580,33604,34580,34596,34604,34612,34620,34628
     *,34860,35116,66372,67364,67372,-67396,67404,132932,16765,17061
     *,17173,17581,17773,17941,18493,18741,18997,19261,19821,20141,20349
     *,20645,25477,33141,33461,33581,33653,33717,34581,34605,34613,34621
     *,34669,34677,34685,34725,34733,34741,34861,35117,36213,36533
     *,-50053,-51077,67445,99205,-100229,198533,16670,16910,18494,18742
     *,20830,21078,21462,21726,31126,31438,31678,31942,33102,33518,34590
     *,34598,34606,34638,34790,-34798,34862,35118,37198,37454,37870
     *,38126,-51094,-51134,-51142,-51150,55702,56014,56254,56518,65894
     *,66278,66374,-67398,67406,-67430,-67558,67566,-100238,100246
     *,100286,100294,100302,132934,132966,133094,-198542,395150,16767
     *,17063,18495,25479,-51079,18329,17678,17438,17942,33062,33318
     *,33574,33126,33510,33606,18998,19262,22102,22494,22742,17174,67509
     *,67373,67366,34574,34582,67374,34588,34572,33582,34662,34630,19263
     *,20351,34623,34687,34727,50055,100231,20647,21854/
c
      data lsqt/' x 0 0',' 0 y 0',' 0 0 z',' 0 y z',' x 0 z',
     *          ' x y 0',' 0 0 0',' x x 0',' x-x 0',' x x z',
     *          ' x-x z',' x y z',' x2x 0','2x x 0',' x2x z',
     *          '2x x z',' 0 y y',' 0 y-y',' x 0 x',' x 0-x',
     *          ' x y-y',' x y y',' x y x',' x y-x',' x x x',
     *          ' x x-x',' x-x x',' x-x-x'/
      data itrt/
     *' - - - 0 - 0' , ' - - - - 0 0' , ' - - - 0 0 -' , ' - - - 0 0 0',
     *' a a - - 0 0' , ' a a - - b b' , ' a a - - b-b' , ' a a - 0 0 0',
     *' - a a 0 0 -' , ' - a a b b -' , ' - a a-b b -' , ' - a a 0 0 0',
     *' - a - a - 0' , ' - a - a 0 0' , ' - a - a b2b' , ' a a - a 0 0',
     *' a a a 0 0 0' , ' a a a b b b' , ' - - - - - -' , ' a - - a2b b',
     *' a - - a 0 -' , ' a - - a 0 0' , ' a a a b-b b' , ' a a a b b-b',
     *' a a a b-b-b' , ' a - a b --b' , ' a - a b - b' , ' a - a 0 0 0',
     *' a - a 0 - 0' , ' ? ? ? ? ? ?'/
c
      data sitin/        'h.y.s.'
     *,'1     ','-1    ','2..   ','.2.   ','..2   ','..2   ','..2   '    8
     *,'..2   ','..2   ','m 011 ','m 101 ','m -101','m 01-1','m..   '   15
     *,'.m.   ','..m   ','2/m.. ','.2/m. ','..2/m ','222   ','222.  '   22
     *,'222.. ','2mm   ','m2m   ','mm2   ','mmm   ','2.mm  ','2.22  '   29
     *,'m.2m  ','m.m2  ','m.mm  ','4..   ','-4..  ','422   ','42.2  '   36
     *,'4m2   ','-42m  ','-4m2  ','4m.m  ','-42.m ','-4m.2 ','4/m.. '   43
     *,'4/mmm ','4/mm.m','3..   ','-3..  ','.3.   ','32.   ','3.2   '   50
     *,'.32   ','3m.   ','.3m   ','.-3m  ','-3m.  ','-3.m  ','.-3m  '   57
     *,'m-3.  ','m-3m  ','6..   ','-6..  ','6mm   ','-6m2  ','6/m.. '   63
     *,'622   ','6/mmm ','23.   ','-43m  ','432   ','mmm.  ','2mm.  '   71
     *,'m2m.  ','.-3.  ','32    ','3.    ','.2    ','4mm   ','3.m   '   78
     *,'-3m   ','3m    ','mm2.. ','mmm.. ','.m    ','.2/m  ','-3.   '/
      data cvet/1, 2, 4, 5, 6,15,16,17, 7,10, 8, 9,11,14,13,12,19,20,18,
     * 4, 5, 6,15,16,17,24,25,26,19,20,18,21,27, 5, 5, 4,16,16,15, 6, 6,
     *17,17,72,71,28,33,18,22,29,20,20,34,30,30,77,70,32,38,32,44, 5, 5,
     * 4,17,17,15, 5, 6,17,16, 6, 6,16,16,46,25,25,24,24,24,18,21,20,19,
     *20,21,19,19,20,21,25,26,26,26,49,50,27,62,55,66, 4, 4, 6, 6, 6, 6,
     * 6, 6,48,48,48,48,28,28,18,23,29,29,34,29,31,31,31,31,31,31,51,51,
     *73,51,53,53,53,53,40,40,40,43,32,41,41,32,54,54,54,54,54,45,45,45,
     *68,59,76,76,76,75,74, 3,15,15,15,81,81,81,33,33,33,17,17,17,17,17,
     * 4,27,27,82,18,18,32,19,19,28,34,34,83,83,84,84,84,80,79,83,17/
c
      data vcoll/64208,56006,56106,44208,-53312,53306,53006,63012,-53006
     *,44008,42002,62004,-63324,-44108,64024,-63006,-64108,63006,64008,
     *56412,56012,-56112,64624,-73006,73006,42,60,61,39,79,80,74,67,47,
     *35,5,29,58,43,69,73,43,51,36,63,65,64,68,85,74/
      data lsqv/    111010,101210,101013,101213,111013,111210,101010,
     *111110,110910,111113,110913,111213,113110,311110,113113,311113,
     *101212,101208,111011,111009,111208,111212,111211,111209,111111,
     *111109,110911,110909/
      data ktlsn/0144,0414,0441,0411,0141,0114,0444,
     *           1224,1204,1221,1201,0111,1234,1324,
     *           1231,1321,2422,2420,1242,1240,2120,
     *           2122,1212,1210,1222,1220,1202,1200/
      end
c-----------------------------------------------------------------------
      subroutine site(key,jump,k)
      USE General
      USE Symmetry
c
      character*80 buff
      character*124 cbuff
c
      dimension key(10),lsqv(28),lterm(2,30)
      character         string*6
      character lsqt(28)*6,itrt(30)*12,sitin(85)*6
      integer jsiti(194),cvet(194),vcoll(25,2),mpvv(64),ksiti(64)
      common /tab1/ jsiti,vcoll,cvet,ksiti,mpvv
      common /tab2/ sitin,lsqt,itrt
      common /tab4/ lsqvx(28),ktlsn(28)
      common /atpos/ cbuff
c
c
c--   lsq shifts  code           therm. param. restr.  code
c--
c--
c--      x 0 0      110000             - - - 0 - 0      1
c--      0 y 0      001200             - - - - 0 0      2
c--      0 0 z      000013             - - - 0 0 -      3
c--      0 y z      001213             - - - 0 0 0      4
c--      x 0 z      110013             a a - - 0 0      5
c--      x y 0      111200             a a - - b b      6
c--      0 0 0      000000             a a - - b-b      7
c--      x x 0      111100             a a - 0 0 0      8
c--      x-x 0      110900             - a a 0 0 -      9
c--      x x z      111113             - a a b b -     10
c--      x-x z      110913             - a a-b b -     11
c--      x y z      111213             - a a 0 0 0     12
c--      x2x 0      113100             - a - a - 0     13
c--     2x x 0      311100             - a - a 0 0     14
c--      x2x z      113113             - a - a b2b     15
c--     2x x z      311113             a a - a 0 0     16
c--      0 y y      001212             a a a 0 0 0     17
c--      0 y-y      001208             a a a b b b     18
c--      x 0 x      110011             - - - - - -     19
c--      x 0-x      110009             a - - a2b b     20
c--      x y-y      111208             a - - a 0 -     21
c--      x y y      111212             a - - a 0 0     22
c--      x y x      111211             a a a b-b b     23
c--      x y-x      111209             a a a b b-b     24
c--      x x x      111111             a a a b-b-b     25
c--      x x-x      111109             a - a b --b     26
c--      x-x x      110911             a - a b - b     27
c--      x-x-x      110909             a - a 0 0 0     28
c--
      data lsqv/    111010,101210,101013,101213,111013,111210,101010,
     *111110,110910,111113,110913,111213,113110,311110,113113,311113,
     *101212,101208,111011,111009,111208,111212,111211,111209,111111,
     *111109,110911,110909/
      data lterm/141516,101810,141516,101019,141516,171010,141516,101010
     *          ,141416,101019,141416,171719,141416,170319,141416,101010
     *          ,141515,171010,141515,171818,141515,171802,141515,101010
     *          ,141516,101825,141516,101025,141516,371725,141416,101024
     *          ,141414,101010,141414,171717,141516,171819,141516,173724
     *          ,141516,171024,141516,101024,141414,170317,141414,170303
     *          ,141414,171703,141514,171803,141514,171817,141514,101010
     *          ,141514,101810,101010,101010/
c
      mult=10000
      ilsq=0
      do i=1,3
         ilsq=ilsq+(key(i)+10)*mult
         mult=mult/100
      enddo
      k=0
      do i=1,28
         lsqvx(i)=lsqv(i)
         if (ilsq.eq.lsqv(i)) k=i
      enddo
      mult=10000
      it1=0
      it2=0
      do i=1,3
         i1=i+3
         i2=i+6
         it1=it1+(key(i1)+10)*mult
         it2=it2+(key(i2)+10)*mult
         mult=mult/100
      enddo
      kk=0
      do i=1,30
         if (it1.eq.lterm(1,i).and.it2.eq.lterm(2,i)) kk=i
      enddo
      ibuff=0
      if (k.eq.0.or.kk.eq.0) then
          ibuff=1
          write(buff,2000) key,ilsq,it1,it2,k,kk
      endif
 2000 format(' errore ',10i3,3i8,5x,2i4)
      ilsqs=k
      iterm=kk
      nm=key(10)
      k=nm*10000+ilsqs*100+iterm
      ifin=194
      msys=jsys
      if (latt.eq.7) msys=7
      kkk=msys*1000000+k
      kcoll=0
      icont=0
      ks=1
      jj=msys
      if (k.eq.11219.or.k.eq.20719) jj=1
      num=nm*8192+ilsqs*256+iterm*8+jj
      do i=2,ifin
         if (num.eq.iabs(jsiti(i))) then
             icont=icont+1
             ks=i
         endif
      enddo
      if (jsiti(ks).ge.0) then
          kkss=cvet(ks)
          string=sitin(kkss)
      else
          maxo =0
          meno1=1
          mm   =0
c -- look for the maximum order operator, for -1 and for mirrors
          do i=1,nm-1
             if (iabs(newvet(i,1)).gt.maxo) maxo=iabs(newvet(i,1))
             if (newvet(i,1).eq.-1) meno1=-1
             if (newvet(i,1).eq.-2) mm=mm+1
          enddo
          kcoll=meno1*(msys*10000+maxo*1000+mm*100+nm)
          kkss=1
          do i=1,25
             if (vcoll(i,1).eq.kcoll) kkss=vcoll(i,2)
          enddo
          string=sitin(kkss)
      endif
      if (jump.ne.0) then
Csir92    write(cbuff(119:124),'(a6)') string
          cbuff(65:70) = string
          if (ibuff.eq.1) then
              write(lo,'(a)') buff
              write(lo,"(' ')")
          endif
      endif
c  90 format(1h+,117x,a6)
      if (kkss.eq.1) k=-1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine InitOper
      USE General
      USE Symmetry
!
      implicit none
      integer ihalf, i, j, k, m, mlat
      real tl, fs
      common /cent/ tl(3,4),fs(3,3,24),mlat
!
c-- halve y-axis by c.of.s. or lattice type if possible
      ihalf=0
      if (icent.eq.1) ihalf=-1
      if (ihalf == 0) then
          if (latt == 2 .or. latt == 4 .or. 
     *        latt == 5 .or. latt == 6) then
              ihalf = 1
          endif
      endif
      call centre (1,1)
!
!-- expand to full space group symmetry
!-- put centring translations in tl(i,j)
!
      select case (latt)

          case (2,3,4,5)
             call centre(2,latt)

          case (6)
             call centre(2,2)
             call centre(3,3)
             call centre(4,4)

          case (7)
             call centre(2,6)
             call centre(3,7)

      end select
!
      do i=1,nsym
         do j=1,3
            do k=1,3
               fs(k,j,i) = 0.0
            enddo
            do k=1,2
               m=iabs(ismat(k,j,i))
               if (m > 0) then
                   fs(m,j,i) = float(isign(1,ismat(k,j,i)))
               endif
            enddo
         enddo
         if (i == 1 .or. ihalf /= 0) cycle
!
!-- halve y-axis by symmetry op. if possible
!
         do j=1,3
            if (iabs(ismat(1,j,i)) /= j .or. 
     *          ismat(2,j,i) /= 0) goto 1000
         enddo
         if (ismat(1,2,i).eq.(-2).and.abs(tsmat(2,i)).lt.1e-6) ihalf= -1
         if (ismat(1,2,i).eq.2.and.abs(tsmat(2,i)-0.5).lt.1e-6) ihalf=1
 1000    continue
      enddo
!
      nsymTot=nsym*(icent+1)*mlat
!
      return
      end
!-----------------------------------------------------------------------
      subroutine centre(j,l)
!
!     retrieve centring translations
      common /cent/ tl(3,4),fs(216),mlat
!
      dimension tst(21)
      data tst/0.,0.,0., 0.,0.5,0.5, 0.5,0.,0.5, 0.5,0.5,0., 0.5,0.5,0.5
     1 , 0.333333,0.666667,0.666667, 0.666667,0.333333,0.333333/
      mlat=j
      m=3*l-2
      tl(1,j)=tst(m)
      tl(2,j)=tst(m+1)
      tl(3,j)=tst(m+2)
      return
      end
!-----------------------------------------------------------------------
!code for ipuac
      function ipuac(icode,vet,lvet,ngspat)
!--function to define the grid of the map
!         n102=ipuac(nSpaceG,Buffer,n,ngspat)
!
      USE General
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      character*60  jscr,iscr,kscr,lscr,iasun1,iform,imsg,jasun,
     2 kkscr,llscr,psfle1
      common/xscru/ jscr,iscr,kscr,lscr,iasun1,iform,imsg,jasun,
     2 kkscr,llscr,psfle1
c--
      character*16 strin1,strin2,idol
c      character*60 ifil
      dimension icode(16),icode1(16),vet(120),buf(120)
      integer sei(6)
c--
      idol='$$$$'
      do 10 i=1,120
         vet(i)=9.9
10    continue
      l=0
      k=1
      do i=1,16
         if(icode(i).eq.ib) then
            if((k.eq.1).or.(l.ne.1)) cycle
            icode1(k)=icode(i)
            k=k+1
            l=0
         else
            icode1(k)=icode(i)
            k=k+1
            l=1
         endif
      enddo
      ip=ib
      do i=k,16
         icode1(i)=ib
      enddo
      write(strin1,1000)(icode1(n),n=1,16)
1000  format(16a1)
c
c--open the file with the s.g. information
      itype=2
      jform=1
      jop=jopen(ncau,iasun,itype,jform,ierr)
      if (jop.lt.0) then
         write(Msg,270) ierr,iasun(1:Lung(iasun))
  270    format(' Open error, code =',i5,' file is ',a)
         call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
         ier=-2
         return
      endif
c
c--find the space group
40    continue
      read(unit=ncau,fmt=1016,end=900) buffer_ctrl_M
      call filtra(buffer_ctrl_M)
!
!     read(buffer_ctrl_M,fmt=1010) strin2,jump,ngs,(buf(j),j=1,60)
!1010 format(a12,i3,i5,6f5.1,1x,6f2.0,1x,20(3f3.0,2f5.1))
!
      read(buffer_ctrl_M,fmt=1010) strin2,jump,ngs,
     *    (buf(j),j=1,6),
     *    (sei(j),j=1,6),
     *    (buf(j),j=13,60)
      buf(7:12) = sei(1:6)
1010  format(a12,i3,i5,
     *       6f5.1,1x,
     *       6i2,1x,
     *       20(3f3.0,2f5.1))
1016  format(a)
c      write(lo,'(2(a1,a,a1))')'$',strin1,'$','$',strin2,'$'
      if(index(strin1,strin2).ne.0) go to 50
      if(index(idol,strin2).ne.0) goto 900
      go to 40
50    continue
      ipuac=ngs
      ngspat=jump
      lvet=12
      call insua(strin2,vet,buf,lvet)
c      if(jump) 1055,1055,1040
      if(jump.gt.0) then
c1020  continue
c     i=iabs(jump)+2
c     do 1025 k=1,i
c1025  backspace ncau
c     read(unit=ncau,fmt=1016,end=900) buffer_ctrl_M
c     call filtra(buffer_ctrl_M)
c     read(buffer_ctrl_M,fmt=1010) strin2,jump,ngs,(buf(j),j=1,60)
c     goto 1050
c1040  continue
         rewind ncau
         if(jump.gt.1) then
            i=jump-1
            do k=1,i
               read(unit=ncau,fmt=1016,end=900) buffer_ctrl_M
               call filtra(buffer_ctrl_M)
*              read(buffer_ctrl_M,fmt=1010) 
*    *                        strin2,jump1,ngs,(buf(j),j=1,60)
               read(buffer_ctrl_M,fmt=1010) strin2,jump1,ngs,
     *             (buf(j),j=1,6),
     *             (sei(j),j=1,6),
     *             (buf(j),j=13,60)
               buf(7:12) = sei(1:6)
            enddo
         endif
c--read the correspondent laue space group
         read(unit=ncau,fmt=1016,end=900) buffer_ctrl_M
         call filtra(buffer_ctrl_M)
*        read(buffer_ctrl_M,fmt=1010) strin2,jump1,ngs,(buf(j),j=1,60)
         read(buffer_ctrl_M,fmt=1010) strin2,jump1,ngs,
     *       (buf(j),j=1,6),
     *       (sei(j),j=1,6),
     *       (buf(j),j=13,60)
         buf(7:12) = sei(1:6)
         if(iabs(jump1).ne.jump) goto 900
      endif
c--salta qui se fourier = patterson
c1055  continue
      j=lvet+1
      lvet=lvet+12
      call insua(strin2,vet(j),buf,lvet)
      goto 920
c
c--error messages
900   continue
      if(istat2.ne.0) write(ncwu,1011)
1011  format(2x,'string not found')
910   continue
      ipuac=0
      lvet=0
920   continue
      close(unit=ncau)
      return
c9000  continue
c      if(istat2.ne.0) write(ncwu,1012)
c1012  format(2x,'**error on open file asunit.dat')
c      goto 910
      end
c      
code for insua
      subroutine insua(strin2,vet,buf,lvet)
c--insert in "vet" the values read from the disc
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      character*16 strin2
      dimension vet(120),buf(120)
c--
      do 60 i=1,6
      if(buf(i).ne.0.0) then
      vet(i)=1/buf(i)
      else
      vet(i)=buf(i)
      endif
60    continue
      j=13
      k=7
      do 90 i=1,6
      vet(k)=buf(i+6)
      k=k+1
      lvet=lvet+buf(i+6)*5
      if(buf(i+6).eq.0.0) go to 90
      nm=buf(i+6)
      do 80 n=1,nm
      do 70 j=j,j+2
      vet(k)=buf(j)
      k=k+1
70    continue
      if(buf(j).ne.0.0) buf(j)=1/buf(j)
      vet(k)=buf(j)
      vet(k+1)=buf(j+1)
      k=k+2
      j=j+2
80    continue
90    continue
      if(istat2.ne.0)  write(ncwu,11) strin2,lvet,(vet(j),j=1,60)
11    format(1x,a16,i5,6(/,1x,10f7.3))
      return
      end
!-----------------------------------------------------------------------
!    CELL related routines
!-----------------------------------------------------------------------
      subroutine CreaCellInfo(cella)
      USE General
      USE Molcom , only: rm, rmi
!--nel modulo General-----------------------------------------      
!      real     :: pp(6), cell(9), xgg(3,3), xgr(3,3), errcell(7)
!      real     :: xgg9(9), xgr9(9)
!      real     :: gdist(18)
!      real     :: BisoToBij(6),BijToBiso(6),UisoToBiso
!      real     :: UijToBij(6),BijToUij(6),BisoToUiso
!      real     ::    volume
!      real     :: xortr(3,3), xorti(3,3)
!      real     :: asta(6), costar(3), volumer, sas, sbs, sgs
!      real     :: alfs, bets, gams
!-------------------------------------------------------------      
!     
!-----------assi,angoli(rad),coseni,seni 
      real celld(3),angd(3),cosed(3),senod(3)   ! diretto
      real cellr(3),angr(3),coser(3),senor(3)   ! reciproco
      real add(9),sdd(9)
!      
      real cella(13)
      real alf, bet, gam, xortrTrasp(3,3),xortiTrasp(3,3)
      integer :: i, ij, ji ,n , k, j
!
      celld(1:3)=cella(1:3)
      angd(1:3)=cella(4:6)*dtor
      errcell(1:7) = cella(7:13)
      cosed(1:3)=cos(angd(1:3))
      senod(1:3)=sin(angd(1:3))
c--calculate the reciprocal parameters
      j=2
      k=3
      do i=1,3
        coser(i)=(cosed(j)*cosed(k)-cosed(i))/(senod(j)*senod(k))
        senor(i)=sqrt(1.0-coser(i)*coser(i))
        angr(i)=atan2(senor(i),coser(i))
        j=j+1
        if(j.gt.3) j=j-3
        k=k+1
        if(k.gt.3) k=k-3
      enddo
      j=2
      k=3
      do i=1,3
        cellr(i)=1.0/(celld(i)*senod(j)*senor(k))
        j=j+1
        if(j.gt.3) j=j-3
        k=k+1
        if(k.gt.3) k=k-3
      enddo
!--------------------------------------------------    
! vettori nel MODULE General      
!--------------------------------------------------    
      cell(1:6)=cella(1:6)  
      asta(1:3)=cellr(1:3)  
      asta(4:6)=angr(1:3) 
      costar(1:3)=coser(1:3)
      alfs=asta(4)
      bets=asta(5)
      gams=asta(6)
      
! ---------
! ---------  sgs =  coseno di gamma star
! ---------
      sas=coser(1)
      sbs=coser(2)
      sgs=coser(3)
! ---------
! ---------  gams =  gamma star
! ---------
      if ( sas .gt.  1.0 ) sas = 1.0
      if ( sas .lt. -1.0 ) sas =-1.0
      alfs=acos(sas)
      if ( sbs .gt.  1.0 ) sbs = 1.0
      if ( sbs .lt. -1.0 ) sbs =-1.0
      bets=acos(sbs)
      if ( sgs .gt.  1.0 ) sgs = 1.0
      if ( sgs .lt. -1.0 ) sgs =-1.0
!      
      volumer=cellr(1) * cellr(2) * cellr(3) * 
     *        senor(1) * senor(2) * senod(3)
      volume=1.0/volumer
!-------------------------------------------------------------
!--calcolo  matrici di ortogonalizzazione rmi e rm (usate nella grafica)
!-------------------------------------------------------------
      alf=angd(1)
      bet=angd(2)
      gam=angd(3)
!      
      rmi(1,1)=1./cella(1)
      rmi(2,1)=0
      rmi(3,1)=0
      rmi(1,2)=-cos(gam)/(cella(1)*sin(gam))
      rmi(2,2)=1./(cella(2)*sin(gam))
      rmi(3,2)=0
      rmi(1,3)=asta(1)*cos(bets)
      rmi(2,3)=asta(2)*cos(alfs)
      rmi(3,3)=asta(3)
      call InvRmi
!-------------------------------------------------------------
!  calcolo matrici di ortogonalizzazione      
!  from j.s. rollett [computing methods in crystallography],
!  pag.23.oxford: pergamon press.
!-------------------------------------------------------------     
!--spazio diretto
      xortr(1,1) =  celld(1) * senod(2) * senor(3)
      xortr(1,2) =  0.0
      xortr(1,3) =  0.0
      xortr(2,1) = -celld(1) * senod(2) * coser(3)
      xortr(2,2) =  celld(2) * senod(1)
      xortr(2,3) =  0.0
      xortr(3,1) =  celld(1) * cosed(2)
      xortr(3,2) =  celld(2) * cosed(1)
      xortr(3,3) =  celld(3)
!-------------------------------------------------------------
!--calcolo di XGG utilizzando le subroutine Trasp e MoltMatMat     
!      call Trasp(xortr, xortrTrasp)   ! da scommentare
!-------------------------------------------------------------
!--la metrica dello  spazio [G] è ottenuta dal prodotto della 
!--matrice di ortogonalizzazione [O] trasposta per la matrice stessa : [O]^T * [O] = [G]      
!-------------------------------------------------------------
!      call MoltMatMat(xortrTrasp, xortr, xgg)   ! da scommentare
!-------------------------------------------------------------
!--calcolo di XGG utilizzando la subroutine XMTMT      
!-------------------------------------------------------------
      n=1
      do i=1,3
         do j=1,3
            add(n)=xortr(i,j)
            n=n+1
         enddo     
      enddo   
      call xmtmt (add,add,sdd,3,3,3)
      n=1
      do i=1,3
         do j=1,3
            xgg(i,j)=sdd(n)
            n=n+1
         enddo     
      enddo
!-------------------------------------------------------------
!--fine calcolo utilizzando la subroutine XMTMT      
!-------------------------------------------------------------
!--analogamente nello spazio reciproco      
!-------------------------------------------------------------
      xorti(1,1) =  cellr(1) 
      xorti(1,2) =  cellr(2) * coser(3)
      xorti(1,3) =  cellr(3) * coser(2) 
      xorti(2,1) =  0.0
      xorti(2,2) =  cellr(2) * senor(3)
      xorti(2,3) = -cellr(3) * senor(2) * cosed(1) 
      xorti(3,1) =  0.0
      xorti(3,2) =  0.0
      xorti(3,3) =  1.0/celld(3)
!-------------------------------------------------------------
!--calcolo di XGR utilizzando le subroutine Trasp e MoltMatMat      
!      call Trasp(xorti, xortiTrasp)   ! da scommentare
!-------------------------------------------------------------
!--la metrica dello  spazio [G*] è ottenuta dal prodotto della 
!--matrice di ortogonalizzazione [O] trasposta per la matrice stessa : [O]^T * [O] = [G*]      
!-------------------------------------------------------------
!      call MoltMatMat(xortiTrasp, xorti, xgr)   ! da scommentare
!-------------------------------------------------------------
!--calcolo di XGR utilizzando la subroutine XMTMT      
!-------------------------------------------------------------
      n=1
      do i=1,3
         do j=1,3
            add(n)=xorti(i,j)
            n=n+1
         enddo     
      enddo   
      call xmtmt (add,add,sdd,3,3,3)
      n=1
      do i=1,3
         do j=1,3
            xgr(i,j)=sdd(n)
            n=n+1
         enddo     
      enddo 
!-------------------------------------------------------------
!--fine calcolo utilizzando la subroutine XMTMT      
!-------------------------------------------------------------
      i = 1
      do ij=1,3
         do ji=1,3
            gdist(i)   = xgg(ij,ji)
            gdist(i+9) = xgr(ij,ji)
            xgg9(i) = xgg(ij,ji)
            xgr9(i) = xgr(ij,ji)
            i=i+1
         enddo
      enddo
!-----------------------------------------------------------      
!--coefficienti per calcolare (sin(T)/lambda)**2
!-----------------------------------------------------------
      do i=1,3
         pp(i)=0.25 * xgr(i,i)
      enddo
      pp(4)= 0.5 * xgr(1,2)
      pp(5)= 0.5 * xgr(1,3)
      pp(6)= 0.5 * xgr(2,3)
!-----------------------------------------------------------      
!--coefficienti per calcolare b(ij) da b(iso)
!-----------------------------------------------------------      
      BisoToBij(1)= pp(1)     ! 0.25*xgr*(1,1)   
      BisoToBij(2)= pp(4)     ! 0.50*xgr*(1,2)    
      BisoToBij(3)= pp(5)     ! 0.50*xgr*(1,3)     
      BisoToBij(4)= pp(2)     ! 0.25*xgr*(2,2)     
      BisoToBij(5)= pp(6)     ! 0.50*xgr*(2,3)     
      BisoToBij(6)= pp(3)     ! 0.25*xgr*(3,3)  
!-----------------------------------------------------------      
!--coefficienti per calcolare b(iso) da b(ij)
!-----------------------------------------------------------      
!  b(iso) = b(1) * BijToBiso(1) + 
!           b(2) * BijToBiso(2) + 
!           b(3) * BijToBiso(3) + 
!           b(4) * BijToBiso(4) + 
!           b(5) * BijToBiso(5) + 
!           b(6) * BijToBiso(6) 
!-----------------------------------------------------------      
      BijToBiso(1)= (4.0/ 3.0) * xgg(1,1)     
      BijToBiso(2)= (4.0/ 3.0) * xgg(1,2)     
      BijToBiso(3)= (4.0/ 3.0) * xgg(1,3)       
      BijToBiso(4)= (4.0/ 3.0) * xgg(2,2)       
      BijToBiso(5)= (4.0/ 3.0) * xgg(2,3)      
      BijToBiso(6)= (4.0/ 3.0) * xgg(3,3)       
!-----------------------------------------------------------      
!--coefficienti per calcolare b(iso) da u(iso)
!-----------------------------------------------------------      
!  b(iso)=u(iso)*UisoToBiso
!----------------------------------------------------------- 
      UisoToBiso = 2.0*twopi*twopi   
!-----------------------------------------------------------      
!--coefficienti per calcolare b(ij) da u(ij)
!-----------------------------------------------------------      
!  la sequenza in sir  : 11 12 13 22 23 33
!  la sequenza in shelx: 11 22 33 23 13 12
!  la sequenza in pdb  : 11 22 33 12 13 23
!-----------------------------------------------------------      
!--sequenza u(ij) PDB
!
!  29 - 35 Integer u[0][0] U(1,1)
!  36 - 42 Integer u[1][1] U(2,2)
!  43 - 49 Integer u[2][2] U(3,3)
!  50 - 56 Integer u[0][1] U(1,2)
!  57 - 63 Integer u[0][2] U(1,3)
!  64 - 70 Integer u[1][2] U(2,3)
!
!--sequenza u(ij) SHELX
!
!  The exponential factor takes the form: 
!  exp(-8p2U[sin(q)/l]2) 
!  for an isotropic displacement parameter U and:
!  exp ( -2p2 [ h^2 (a*)^2 U11 + k^2 (b*)^2 U22 + ... + 2hk a*b* U12 ] )
!  for anisotropic Uij. 
!  An atom is specified as follows in the .ins file:
!
!  atom name sfac x y z sof [11] U [0.05] or U11 U22 U33 U23 U13 U12
!-----------------------------------------------------------
!  SHELX:
!                        (1)(2)(3)(4)(5)(6)       
!  la sequenza in shelx: 11 22 33 23 13 12
!  la sequenza in sir  : 11 12 13 22 23 33
!  quindi: b(1) = UijToBij_11*u(1)
!          b(4) = UijToBij_22*u(2)
!          b(6) = UijToBij_33*u(3)
!          b(5) = UijToBij_23*u(4)
!          b(3) = UijToBij_13*u(5)
!          b(2) = UijToBij_12*u(6)
!  PDB:
!                        (1)(2)(3)(4)(5)(6)       
!  la sequenza in pdb  : 11 22 33 12 13 23
!  la sequenza in sir  : 11 12 13 22 23 33
!  quindi: b(1) = UijToBij_11*u(1)
!          b(4) = UijToBij_22*u(2)
!          b(6) = UijToBij_33*u(3)
!          b(2) = UijToBij_12*u(4)
!          b(3) = UijToBij_13*u(5)
!          b(5) = UijToBij_23*u(6)
!-----------------------------------------------------------      
      UijToBij_11= twopis*xgr(1,1)                 ! 2*pi*pi*xgr*(1,1) 
      UijToBij_22= twopis*xgr(2,2)                 ! 2*pi*pi*xgr*(2,2) 
      UijToBij_33= twopis*xgr(3,3)                 ! 2*pi*pi*xgr*(3,3)  
      UijToBij_23= 2.*twopis*cellr(2)*cellr(3)     ! 4*pi*pi*b(*)*c(*) 
      UijToBij_13= 2.*twopis*cellr(1)*cellr(3)     ! 4*pi*pi*a(*)*c(*) 
      UijToBij_12= 2.*twopis*cellr(1)*cellr(2)     ! 4*pi*pi*a(*)*b(*)  
!
!-----------------------------------------------------------      
!--coefficienti per calcolare u(ij) da b(ij)
!-----------------------------------------------------------   
!                        (1)(2)(3)(4)(5)(6)       
!  la sequenza in sir  : 11 12 13 22 23 33
!  la sequenza in shelx: 11 22 33 23 13 12
!  quindi: u(1) = BijToUij_11*b(1)
!          u(6) = BijToUij_12*b(2)
!          u(5) = BijToUij_13*b(3)
!          u(2) = BijToUij_22*b(4)
!          u(4) = BijToUij_23*b(5)
!          u(3) = BijToUij_33*b(6)
!-----------------------------------------------------------   
!                        (1)(2)(3)(4)(5)(6)       
!  la sequenza in sir  : 11 12 13 22 23 33
!  la sequenza in pdb  : 11 22 33 12 13 23
!  quindi: u(1) = BijToUij_11*b(1)
!          u(4) = BijToUij_12*b(2)
!          u(5) = BijToUij_13*b(3)
!          u(2) = BijToUij_22*b(4)
!          u(6) = BijToUij_23*b(5)
!          u(3) = BijToUij_33*b(6)
!-----------------------------------------------------------   
      BijToUij_11= 1.0/UijToBij_11
      BijToUij_12= 1.0/UijToBij_12               
      BijToUij_13= 1.0/UijToBij_13    
      BijToUij_22= 1.0/UijToBij_22  
      BijToUij_23= 1.0/UijToBij_23      
      BijToUij_33= 1.0/UijToBij_33      
!-----------------------------------------------------------      
!--coefficienti per calcolare u(iso) da b(iso)
!-----------------------------------------------------------      
!  u(iso)=b(iso)*BisoToUiso
!----------------------------------------------------------- 
      BisoToUiso =1.0/( 2.0*twopi*twopi )  
!-----------------------------------------------------------   
!
      InfoOK(1) = 1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CalcolaRho(hkl, rho)
      USE General
      USE Riflessi
!
      implicit none
      integer   :: hkl(3)
      real      :: q, rho
!
         q = hkl(1)*hkl(1)*asta(1)*asta(1)
     1     + hkl(2)*hkl(2)*asta(2)*asta(2)
     2     + hkl(3)*hkl(3)*asta(3)*asta(3)
     3     + 2.0*hkl(2)*hkl(3)*asta(2)*asta(3)*costar(1)
     4     + 2.0*hkl(3)*hkl(1)*asta(3)*asta(1)*costar(2)
     5     + 2.0*hkl(1)*hkl(2)*asta(1)*asta(2)*costar(3)
         rho = 0.25 * q
!
      return
      end
!-----------------------------------------------------------------------
!    Atom properties related routines
!-----------------------------------------------------------------------
      subroutine CreaAtmPropInfo(i, ier)
      USE General
!
      implicit none
      integer  :: i, ier, puntatore(18)
!
*     return
!
      ier = 0
      call LeggiXEN(i, puntatore, ier)
      call SortAtmProp
!
      if (ier == 0) then
          InfoOK(3) = 1
      else
          InfoOK(3) = 0
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LeggiXEN(k, puntatore, ier)
      USE General
      USE Properties
!
      implicit none
      integer           :: itipo, iform, jop, jopen, ier, ierr, ncards
      integer           :: i, j, k, lenp, lend, nfound, iOK, iopt, iv
      integer           :: ivet(40), puntatore(18), NoAt,  nwTmp(18)
      integer           :: nComments
      real              :: Valore, vet(40), somma, EnXKeV, EnX, Y, Y1x
      real              :: F2x, YY, tmpVet(9)
      character (len=5) :: InElem
!
      do i=1, nk
         call lcase(Species(i))
      enddo
      WhichProps = k
      vSpecie(:) = Species(:)
      nwTmp(:) = nw(:)
      AtmProperties(k)%ifMottFormula(:) = 0
      AtmProperties(k)%zeff(:) = 0
      puntatore(:) = 0
      itipo = 2
      iform = 1
!
      jop=jopen(kform,ffile,itipo,iform,ierr)
      if (jop.lt.0) then
          ier = -1
          return
      endif
!
      call LeggiXENHeader(kform, cardImage, ncards, nComments)
      do i=1, nComments
         read(kform,'(a)') cardImage      ! comments
      enddo
!
      nfound = 0
      do
         read(kform,'(a)',end=100) cardImage      ! first 
         call cutst(cardImage,lenp,direttiva,lend)
         iOK = 0
         do j=1, nk
            if (direttiva(1:4) == Species(j)) then
                iOK = j
                exit
            endif
         enddo
         if (iOK > 0) then
             nfound = nfound + 1
             vSpecie(nfound) = Species(j)
             read(vSpecie(nfound),'(a4)') nalf(nfound)
             nwTmp(nfound)   = nw(j)
             puntatore(iOK) = nfound
!-- Z, Atomic Weight, coval_radius, vanderWaals_radius
             iopt = 0
             call getnum(cardImage,vet,ivet,iv,iopt)
!            read(cardImage,*) ivet(1),vet(2:4)
!
             no(nfound)=ivet(1)    ! Riccardo 9/10/2010
!
             AtmProperties(k)%z(nfound)       = ivet(1)
             AtmProperties(k)%zeff(nfound)    = ivet(1)
             AtmProperties(k)%AtmW(nfound)    = vet(2)
             AtmProperties(k)%radii(nfound,1) = vet(3)
             AtmProperties(k)%radii(nfound,2) = vet(4)
             read(kform,'(a)') cardImage
             call cutst(cardImage,lenp,direttiva,lend)
             if (neutro == 0) then
                 iopt = 0
                 call getnum(cardImage,vet,ivet,iv,iopt)
!                read(cardImage,*) vet(1:6)
!-- (x_ray) a(1), b(1), a(2), b(2), a(3), b(3)
                 AtmProperties(k)%a(1,nfound) = vet(1)
                 AtmProperties(k)%b(1,nfound) = vet(2)
                 AtmProperties(k)%a(2,nfound) = vet(3)
                 AtmProperties(k)%b(2,nfound) = vet(4)
                 AtmProperties(k)%a(3,nfound) = vet(5)
                 AtmProperties(k)%b(3,nfound) = vet(6)
                 read(kform,'(a)') cardImage
                 call cutst(cardImage,lenp,direttiva,lend)
                 iopt = 0
                 call getnum(cardImage,vet,ivet,iv,iopt)
!                read(cardImage,*) vet(1:3)
!-- (x_ray) a(4), b(4), c      Int. Tab. C, 6.1.1.4 
                 AtmProperties(k)%a(4,nfound) = vet(1)
                 AtmProperties(k)%b(4,nfound) = vet(2)
                 AtmProperties(k)%c(nfound)   = vet(3)
                 read(kform,'(a)') cardImage
                 call cutst(cardImage,lenp,direttiva,lend)
                 iopt = 0
                 call getnum(cardImage,vet,ivet,iv,iopt)
!                read(cardImage,*) vet(1:3)
!-- (x_ray) f'(Mo), f''(Mo), mu/rho       Int. Tab. C, 4.2.6.8, 4.2.4.3
                 AtmProperties(k)%fprimo(nfound,1)   = vet(1)
                 AtmProperties(k)%fsecondo(nfound,1) = vet(2)
                 AtmProperties(k)%fmuro(nfound)    = vet(3)
                 read(kform,'(a)') cardImage
                 if (WhichWave == 2) then
                     call cutst(cardImage,lenp,direttiva,lend)
                     iopt = 0
                     call getnum(cardImage,vet,ivet,iv,iopt)
!                    read(cardImage,*) vet(1:3)
!-- (x_ray) f'(Cu), f''(Cu), mu/rho       Int. Tab. C, 4.2.6.8, 4.2.4.3
                     AtmProperties(k)%fprimo(nfound,1)   = vet(1)
                     AtmProperties(k)%fsecondo(nfound,1) = vet(2)
                     AtmProperties(k)%fmuro(nfound)    = vet(3)
                 elseif (WhichWave == 3) then
                     NoAt = no(nfound)
                     InElem = Species(iOK)
                     EnXKeV = 12.3984428 / wavel
                     EnX = EnXKeV / 1000.0
                     call smac(InElem, EnX, Y)
                     Y = exp(Y)
                     call sff(NoAt, wavel, Y1x, F2x)
                     YY = Y1x - float(NoAt)
                     AtmProperties(k)%fprimo(nfound,1)   = YY
                     AtmProperties(k)%fsecondo(nfound,1) = F2x
                     AtmProperties(k)%fmuro(nfound)    = Y
                 endif
                 do i=1, 3
                    read(kform,'(a)') cardImage
                 enddo
             elseif (neutro == 1) then
                 do i=1, 6
                    read(kform,'(a)') cardImage
                 enddo
                 call cutst(cardImage,lenp,direttiva,lend)
                 iopt = 0
                 call getnum(cardImage,vet,ivet,iv,iopt)
!                read(cardImage,*) vet(1)
!-- (neutrons) fact
                 AtmProperties(k)%a(:,nfound) = 0.0
                 AtmProperties(k)%b(:,nfound) = 0.0
                 AtmProperties(k)%c(nfound)   = vet(1)
                 AtmProperties(k)%zeff(nfound) = vet(1)
                 AtmProperties(k)%fprimo(nfound,1)   = 0
                 AtmProperties(k)%fsecondo(nfound,1) = 0
                 AtmProperties(k)%fmuro(nfound)      = 0
             elseif (neutro == 2) then
                 iopt = 0
                 call getnum(cardImage,vet,ivet,iv,iopt)
!                read(cardImage,*) vet(1:6)
!-- (x_ray) a(1), b(1), a(2), b(2), a(3), b(3)
                 tmpVet(1) = vet(1)
                 tmpVet(5) = vet(2)
                 tmpVet(2) = vet(3)
                 tmpVet(6) = vet(4)
                 tmpVet(3) = vet(5)
                 tmpVet(7) = vet(6)
                 read(kform,'(a)') cardImage
                 call cutst(cardImage,lenp,direttiva,lend)
                 iopt = 0
                 call getnum(cardImage,vet,ivet,iv,iopt)
!                read(cardImage,*) vet(1:3)
!-- (x_ray) a(4), b(4), c      Int. Tab. C, 6.1.1.4 
                 tmpVet(4) = vet(1)
                 tmpVet(8) = vet(2)
                 tmpVet(9) = vet(3)
                 do i=1, 3
                    read(kform,'(a)') cardImage
                 enddo
                 call cutst(cardImage,lenp,direttiva,lend)
                 iopt = 0
                 call getnum(cardImage,vet,ivet,iv,iopt)
!                read(cardImage,*) vet(1:6)
!-- (electr.) a(1), b(1), a(2), b(2), a(3), b(3)
                 AtmProperties(k)%a(1,nfound) = vet(1)
                 AtmProperties(k)%b(1,nfound) = vet(2)
                 AtmProperties(k)%a(2,nfound) = vet(3)
                 AtmProperties(k)%b(2,nfound) = vet(4)
                 AtmProperties(k)%a(3,nfound) = vet(5)
                 AtmProperties(k)%b(3,nfound) = vet(6)
                 read(kform,'(a)') cardImage
                 call cutst(cardImage,lenp,direttiva,lend)
                 iopt = 0
                 call getnum(cardImage,vet,ivet,iv,iopt)
!                read(cardImage,*) vet(1:3)
!-- (electr.) a(4), b(4), c      
                 AtmProperties(k)%a(4,nfound) = vet(1)
                 AtmProperties(k)%b(4,nfound) = vet(2)
                 AtmProperties(k)%c(nfound)   = vet(3)
                 somma = sum(abs(AtmProperties(k)%a(:,nfound)))
     *                 + sum(abs(AtmProperties(k)%b(:,nfound)))
     *                 + AtmProperties(k)%c(nfound)
                 if (somma < 0.1) then
                     AtmProperties(k)%ifMottFormula(nfound) = 1
                     AtmProperties(k)%a(1:4,nfound) = tmpVet(1:4)
                     AtmProperties(k)%b(1:4,nfound) = tmpVet(5:8)
                     AtmProperties(k)%c(nfound)     = tmpVet(9)
                 endif
                 read(kform,'(a)') cardImage
                 AtmProperties(k)%fprimo(nfound,1)   = 0
                 AtmProperties(k)%fsecondo(nfound,1) = 0
                 AtmProperties(k)%fmuro(nfound)      = 0
             endif
             read(kform,'(a)') cardImage
             call cutst(cardImage,lenp,direttiva,lend)
             AtmProperties(k)%NomeSpecie(nfound) = cardImage(1:12)
         else
             do i=1, ncards-1
                read(kform,'(a)') cardImage
             enddo
         endif
         if (nfound == nk) exit
      enddo
  100 close(kform)
      if (nfound /= nk) then
          ier = -1
      endif
!
      AtmProperties(k)%Species(:)    = vSpecie(:)
      AtmProperties(k)%natsInCell(:) = nwTmp(:)
      AtmProperties(k)%radiation     = neutro
      AtmProperties(k)%lambda        = wavel
      nat = 0
      do i=1, nk
*gl*     if (neutro.eq.0) then
             if (AtmProperties(k)%z(i) > 1) then
                 nat = nat + AtmProperties(k)%natsInCell(i)
             endif
*gl*     else
*gl*         nat = nat + AtmProperties(k)%natsInCell(i)
*gl*     endif
      enddo
      AtmProperties(k)%nSpecies = nk
      AtmProperties(k)%nat = nat
!
      return
      end
!-----------------------------------------------------------------------
      subroutine smac(InElem,EnX,Y)
cccccccccccc          SUBROUTINES          ccccccccccccccccc
!
!The program is constituted by the "smac routine",
!that provides the attenuation and energy absorption of x-ray and
!gamma-ray photons in the 92 elements.
!It's based on tables from NIST report 5632,
!by J. Hubbell and S.M. Seltzer [1]
!covering the photon energy range from 0.001 MeV to 20 MeV.
!The routine requires the symbol element and the energy wavelength [Angstrom],
!and returns the Mass Attenuation Coefficient [cm^2/g]
!
!Input: Element[Symbol], Energy[Angstrom]
!Output: Mass Attenuation Coefficient [cm^2/g]
!
!The mass attenuation coefficient, at a given energy, is obtained by
!interpolation of log-log NIST coefficients (read in the Nist.tab file)
!as function of energy, using the Piecewise Cubic Hermite Interpolating Polynomial
!subroutine, named "isp_sds".
!
!Written by Gaetano Campi, Roma, 20-12-2007
!
!References:
!
![1] J. Hubbell and S.M. Seltzer,
!"Tables of X-Ray Mass Attenuation Coefficients and
!Mass Energy-Absorption Coefficients 1 keV to 20 MeV
!for Elements Z = 1 to 92 and 48 Additional Substances of Dosimetric Interest",
!National Institute of Standards and Technology report NISTIR 5632 (1995).
!(http://physics.nist.gov/PhysRefData/XrayMassCoef/cover.html)
!
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

cccccccccccccccccccccc subroutine cccccccccccccccccccccccccc
c                                                          c
c        Calculate the Mass Attenuation Coefficient        c
c                                                          c
cccccccccccccccccccccc    smac    cccccccccccccccccccccccccc
c
      USE General, only: macfle, jpfile
c
      PARAMETER (N=36)
      REAL XEn(N,100), Macn(N,100), Meacn(N,100), AtW(100), Den(100)
      REAL E(100), Mac(100)

      REAL h(N,100), delta(N,100), d(N,100), s(100), w1(N,100)
      REAL w2(N,100), c(N,100), b(N,100)

      REAL Y, EnX
      CHARACTER * 5 Elem(100), InElem
      INTEGER  Z

ccccccccccccccc  read NIST Table  ccccccccccccccccccccc

      OPEN(jpfile,file=macfle,status='unknown')

      j=0
      DO
      j=j+1
        READ (jpfile,900,END=100) Elem(j)
        call lcase(Elem(j))
        READ (jpfile,*,END=100) AtW(j)
        READ (jpfile,*,END=100) Den(j)
        READ (jpfile,*,END=100) XEn(:,j)
        READ (jpfile,*,END=100) Macn(:,j)
        READ (jpfile,*,END=100) Meacn(:,j)
      ENDDO
  100 CLOSE (jpfile)
      NElem = j-1
  900 FORMAT (A2)

ccc   Search Elements in Nist.tab   ccccccccccccccc
c
c      OPEN(7,file='NIST.tab',status='unknown')
c
       DO 200, i = 1 , NElem
          if (InElem.EQ.Elem(i)) then
          Z = i
          exit
          endif
c          go to 200
  200  CONTINUE

ccc   Build ID E, Mac Vectors   cccccccccccccccccccc

      J=0
      DO 300, I=1,N
      J=J+1
      E(J) = XEn(I,Z)
      Mac(J) = Macn(I,Z)
  300 CONTINUE

cccccccccccccccccccc  interpolate  cccccccccccccccccccccc

      call isp_sds(N,log(E),log(Mac),log(EnX),Y)

      RETURN
      END
!-----------------------------------------------------------------------
      subroutine isp_sds(N,x,y,xi,yi)
!
!-- Interpolate Single Point _ Single Data Set
!

      REAL x(N), y(N)
      REAL h(N), delta(N), d(N), w1(N)
      REAL w2(N), c(N), b(N)
      REAL s, xi, yi
      INTEGER N
!
      DO  470 i = 1, N-1
      h(i) = x(i+1)-x(i)
      delta(i) = (y(i+1)-y(i))/h(i)
  470 CONTINUE 

      d(1)=((2*h(1)+h(2))*delta(1)
     *-h(1)*delta(2))/(h(1)+h(2))
      if (d(1)*delta(1).LT.0) then
      d(1)=0
      elseif ((delta(1)*delta(2).LT.0).And.
     *(abs(d(1)).GT.abs(3*delta(1)))) then
      d(1)=3*delta(1)    
      end if

      d(N)=((2*h(N-1)+h(N-2))*delta(N-1)
     *-h(N-1)*delta(N-2))/(h(N-1)+h(N-2))
      if (d(1)*delta(N-1).LT.0) then
      d(N)=0
      elseif ((delta(N-1)*delta(N-2).LT.0).And.
     *(abs(d(N)).GT.abs(3*delta(N-1)))) then
      d(N)=3*delta(N-1)    
      end if

       c(1) = (3*delta(1)-2*d(1)-d(2))/h(1)
       b(1) = (d(1)-2*delta(1)+d(2))/(h(1)*h(1))

       c(N) = (3*delta(N-1)-2*d(N-1)-d(N))/h(N-1)
       b(N) = (d(N-1)-2*delta(N-1)+d(N))/(h(N-1)*h(N-1))

      DO  490 i=2, N-1
       if ((delta(i))*(delta(i+1)).LT.0) then
       d(i)=0
       else
       w1(i) = 2*h(i) + h(i-1)
       w2(i) = h(i) + 2*h(i-1)
       d(i)=(w1(i)+w2(i))/((w1(i)/delta(i-1)+w2(i)/delta(i)))     
       end if 
  490 CONTINUE

       DO  520 i = 2, N-1
       c(i) = (3*delta(i)-2*d(i)-d(i+1))/h(i)
       b(i) = (d(i)-2*delta(i)+d(i+1))/(h(i)*h(i))
c      WRITE (*,*) 'b,c,i:', b(i), c(i), Z, i 
  520 CONTINUE


       DO  550, i = 2, N-1
       if ((xi.GT.x(i)).AND.(xi.LT.x(i+1))) then              
       s = xi-x(i)
c       WRITE (*,*) s
       yi = y(i)+s*(d(i)+s*(c(i) + s*b(i)))
       elseif (xi.EQ.x(i)) then
       yi = y(i) 
       END IF 
  550  CONTINUE

      RETURN
      END
!-----------------------------------------------------------------------
      subroutine sff(Z, EnXA, Y1x, F2x)
      USE General, only: f12fle, jpfile

      REAL E(910,92), F1(910,92), F2(910,92)
      REAL En(910), F1n(910), F2n(910)
      REAL  dE, Ein, Efin, Ex, Y1x, F2x, EnXKeV, EnX, EnXA 
      INTEGER I, J, K, NE, N, Nint, Z, Zj

     
      open(jpfile,file=f12fle,status='unknown')

      EnXKeV = 12.3984428/EnXA;
      EnX = EnXKeV*1000
!
!cccccccccccccccccc    read HENK TABLE  ccccccccccccccccc 
!
      J=0
      DO
      J=J+1
        READ (jpfile,*,END=100) Zj
        READ (jpfile,*,END=100) E(:,J)
        READ (jpfile,*,END=100) F1(:,J) 
        READ (jpfile,*,END=100) F2(:,J)
      ENDDO
  100 CLOSE (jpfile)
      NE = J-1
!
!ccccccccccccccc  cancel bad data points  ccccccccccccccc
!
      J=0
      DO 200, I=1,910
      IF ((E(I,Z).NE.0).AND.(F1(I,Z).NE.-9999.)) THEN
      J=J+1
      En(J) = E(I,Z)
      F1n(J) = F1(I,Z)
      F2n(J) = F2(I,Z)
      ENDIF
  200 CONTINUE

      N = J
!
!cccccccccccc  interpolate single value  ccccccccccccccccc
!
      call isp_sds(N,log(En),(F1n),log(EnX),Y1x)
      call isp_sds(N,log(En),(F2n),log(EnX),F2x) 
!     
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!
      RETURN
      END
!-----------------------------------------------------------------------
      subroutine CalcolaBondTable()
      USE General
      USE Properties
!
!-- crea tabella distanze min-max tra specie
!
      implicit none
      integer :: i, j, k, n1, n2, nnk
      real    :: raggio1, raggio2, rap, distanza, distmin, distmax
!
      k = WhichProps
      nnk = AtmProperties(k)%nSpecies
!
      do i=1, nnk
c--Mercedes 3nov04      rap=0.3
         rap = 0.20
         n1 = AtmProperties(k)%z(i)
         raggio1 = AtmProperties(k)%radii(i,1)
         if (n1 == 1) then
             raggio1 = 0.18
             rap = 0.1
         endif
         do j=1, nnk
            n2 = AtmProperties(k)%z(j)
            raggio2 = AtmProperties(k)%radii(j,1)
c--Mercedes 3nov04       if(n1.ne.1) rap=0.3
            if (n1 /= 1) rap=0.20
            if (n2 == 1) then
                raggio2 = 0.18
                rap = 0.1
            endif
            distanza = raggio1 + raggio2
            if (n1 == 1 .and. n2 == 1) distanza = 0.64
c--Mercedes 3nov04       BondTable(1,i,j)=distanza-rap*distanza
            distmin = distanza -2 * rap * distanza
            distmax = distanza + rap * distanza
            AtmProperties(k)%BondTable(1,i,j) = distmin
            AtmProperties(k)%BondTable(2,i,j) = distmax
         enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine updBondTable(cBondTable, cRadii)
!
!--update tabella delle distanze
!
      USE General
      USE Properties
!
      implicit none
      integer :: i, j, k
      real    :: cBondTable(2,18,18), cRadii(18,2)
!
      k = WhichProps
      AtmProperties(k)%nSpecies = nk
      do i=1, nk
         AtmProperties(k)%radii(i,1:2)  = cRadii(i,1:2)
         do j=1, nk
            AtmProperties(k)%BondTable(1:2,i,j) = cBondTable(1:2,i,j)
         enddo
      enddo
!
      call GetFromAtmStruct
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SortAtmProp
      USE General
      USE Properties
!
      implicit none
      real              :: vet(18)
      integer           :: i, j, k, nnk, puntatore(18), isort, ierr
      character(len=12) :: nomeatTmp(18)
      real, allocatable :: propMat(:,:)
!
      k = WhichProps
      nnk = AtmProperties(k)%nSpecies
      if (neutro /= 0) then
          allocate (propMat(1:nnk,1:19), stat = ierr)
          do i=1, nnk
             propMat(i,1:4)   = AtmProperties(k)%a(1:4,i)
             propMat(i,5:8)   = AtmProperties(k)%b(1:4,i)
             propMat(i, 9)    = AtmProperties(k)%c(i)
             propMat(i,10)    = AtmProperties(k)%fprimo(i,1)    ! da sistemare
             propMat(i,11)    = AtmProperties(k)%fsecondo(i,1)  ! da sistemare
             propMat(i,12)    = AtmProperties(k)%fmuro(i)
             propMat(i,13)    = AtmProperties(k)%AtmW(i)
             propMat(i,14:15) = AtmProperties(k)%radii(i,1:2)
             propMat(i,16)    = AtmProperties(k)%z(i)
             propMat(i,17)    = AtmProperties(k)%natsInCell(i)
             propMat(i,18)    = AtmProperties(k)%ifMottFormula(i)
             propMat(i,19)    = AtmProperties(k)%zeff(i)
             nomeatTmp(i)     = AtmProperties(k)%NomeSpecie(i)
             vSpecie(i)       = AtmProperties(k)%Species(i)
             puntatore(i)     = i
          enddo
          if (neutro == 1) then
              vet(1:nnk) = AtmProperties(k)%c(1:nnk)
          elseif (neutro == 2) then
              vet(1:nnk) = AtmProperties(k)%zeff(1:nnk)
          endif
          isort = 1
          call sortall3(isort, vet, 1, nnk, puntatore)
          do i=1, nnk
              j = puntatore(i)
              AtmProperties(k)%a(1:4,i)         = propMat(j,1:4)
              AtmProperties(k)%b(1:4,i)         = propMat(j,5:8)
              AtmProperties(k)%c(i)             = propMat(j, 9)
              AtmProperties(k)%fprimo(i,1)      = propMat(j,10) ! da sistemare
              AtmProperties(k)%fsecondo(i,1)    = propMat(j,11) ! da sistemare
              AtmProperties(k)%fmuro(i)         = propMat(j,12)
              AtmProperties(k)%AtmW(i)          = propMat(j,13)
              AtmProperties(k)%radii(i,1:2)     = propMat(j,14:15)
              AtmProperties(k)%z(i)             = nint(propMat(j,16))
              AtmProperties(k)%natsInCell(i)    = nint(propMat(j,17))
              AtmProperties(k)%ifMottFormula(i) = nint(propMat(j,18))
              AtmProperties(k)%zeff(i)          = propMat(j,19)
              AtmProperties(k)%NomeSpecie(i)    = nomeatTmp(j)
              AtmProperties(k)%Species(i)       = vSpecie(j)
          enddo
          deallocate (propMat, stat = ierr)
      endif
!
      call CalcolaBondTable()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine FillAtmStruct
      USE General
      USE Properties
!
      implicit none
!
      AtmProperties(WhichProps)%nSpecies         = nk
      AtmProperties(WhichProps)%nat              = nat
      AtmProperties(WhichProps)%z(1:18)          = no(1:18)
      AtmProperties(WhichProps)%natsInCell(1:18) = nw(1:18)
      AtmProperties(WhichProps)%a(1:4,1:18)      = al(1:4,1:18)
      AtmProperties(WhichProps)%b(1:4,1:18)      = bs(1:4,1:18)
      AtmProperties(WhichProps)%c(1:18)          = cl(1:18)
      AtmProperties(WhichProps)%zeff(1:18)       = zeff(1:18)
      AtmProperties(WhichProps)%ifMottFormula(:) = ifMottFormula(:)
      AtmProperties(WhichProps)%radii(1:18,1:2)  = radii(1:18,1:2)
      AtmProperties(WhichProps)%AtmW(1:18)       = AtomWeight(1:18)
      AtmProperties(WhichProps)%fprimo(1:18,1)   = fprimo(1:18)  ! da sistemare
      AtmProperties(WhichProps)%fsecondo(1:18,1) = fsecondo(1:18)! da sistemare
      AtmProperties(WhichProps)%fmuro(1:18)      = fmuro(1:18)
      AtmProperties(WhichProps)%Species(1:18)    = Species(1:18)
      AtmProperties(WhichProps)%NomeSpecie(1:18) = nomeat(1:18)
      AtmProperties(WhichProps)%BondTable(:,:,:) = BondTable(:,:,:)
      AtmProperties(WhichProps)%radiation        = neutro
      AtmProperties(WhichProps)%lambda           = wavel
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GetFromAtmStruct
      USE General
      USE Properties
      USE Symmetry, only : nsymTot
!
      implicit none
      integer :: i
!
      nk = AtmProperties(WhichProps)%nSpecies
      if (WhichProps == 0 .and. nk == 0) then
          AtmProperties(0) = AtmProperties(1)
      endif
      nk                 = AtmProperties(WhichProps)%nSpecies
      nat                = AtmProperties(WhichProps)%nat
      no(1:18)           = AtmProperties(WhichProps)%z(1:18)
      nw(1:18)           = AtmProperties(WhichProps)%natsInCell(1:18)
      al(1:4,1:18)       = AtmProperties(WhichProps)%a(1:4,1:18)
      bs(1:4,1:18)       = AtmProperties(WhichProps)%b(1:4,1:18)
      cl(1:18)           = AtmProperties(WhichProps)%c(1:18)
      zeff(1:18)         = AtmProperties(WhichProps)%zeff(1:18)
      ifMottFormula(1:18)= AtmProperties(WhichProps)%ifMottFormula(1:18)
      radii(1:18,1:2)    = AtmProperties(WhichProps)%radii(1:18,1:2)
      AtomWeight(1:18)   = AtmProperties(WhichProps)%AtmW(1:18)
      fprimo(1:18)       = AtmProperties(WhichProps)%fprimo(1:18,1) ! da sistemare
      fsecondo(1:18)     = AtmProperties(WhichProps)%fsecondo(1:18,1) ! da sistemare
      fmuro(1:18)        = AtmProperties(WhichProps)%fmuro(1:18)
      Species(1:18)      = AtmProperties(WhichProps)%Species(1:18)
      nomeat(1:18)       = AtmProperties(WhichProps)%NomeSpecie(1:18)
      BondTable(:,:,:)   = AtmProperties(WhichProps)%BondTable(:,:,:)
      neutro             = AtmProperties(WhichProps)%radiation
      wavel              = AtmProperties(WhichProps)%lambda
!
      WhichWave = 3
      if (abs(wavel - 0.71073) < 0.0001) WhichWave = 1
      if (abs(wavel - 1.54178) < 0.0001) WhichWave = 2
!
      anat = 0.0
      do i=1, nk
         read(Species(i),'(a4)') nalf(i)
         if (no(i) > 1) then
             anat = anat + nw(i)
         endif
      enddo
      anat = anat / float(nsymTot)
      InfoOK(3) = 1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AggiornaProperties(ier)
      USE General
!
      implicit none
      integer :: i, ier
!
      do i=1, nk
         write(Species(i),'(a4)') nalf(i)
      enddo
!
      call CreaAtmPropInfo(WhichProps, ier)
      call GetFromAtmStruct
!
      return
      end

!-----------------------------------------------------------------------
!    Phases storage related routines
!-----------------------------------------------------------------------
      subroutine ManageInitialPhases(iAction, numb, nset)
!
!-- iAction =  1/2  Allocate/Deallocate phases structure
!-- numb    =  Number of reflections involved
!-- nset    =  Number of sets of phases to store
!
      USE PhaseStuff
!
      implicit none
      integer :: iAction, numb, ier1, ier2, ier3, nset, i
!
      if (iAction == 1) then
cerr      nsetInitialPhases = nset
cerr      nReflInitialPhases = numb
          if (Allocated(initialPhases)) then
              do i=1, nsetInitialPhases
                 deallocate(initialPhases(i)%foms,  stat=ier1)
                 deallocate(initialPhases(i)%wp,    stat=ier2)
              enddo
              deallocate(initialPhases, puntatoreIP, cfomIP, stat=ier3)
              if ((iabs(ier1)+iabs(ier2)+iabs(ier3)) /= 0) then
                  write(*,*) 'initialPhases DeAllocation Error'
                  call cstop(' ')
              endif
          endif
          nsetInitialPhases = nset
          nReflInitialPhases = numb
          Allocate(initialPhases(nset), stat=ier1)
          Allocate(puntatoreIP(nset),   stat=ier2)
          Allocate(cfomIP(nset),        stat=ier3)
          if ((iabs(ier1)+iabs(ier2)+iabs(ier3)) /= 0) then
              write(*,*) 'initialPhases Allocation Error'
              call cstop(' ')
          endif
          do i=1, nsetInitialPhases
             Allocate(initialPhases(i)%foms(nFoms), stat=ier1)
             Allocate(initialPhases(i)%wp(numb),    stat=ier2)
             initialPhases(i)%foms(:)  = 0
             initialPhases(i)%wp(:)    = 0
             puntatoreIP(i) = i
          enddo
          if ((iabs(ier1)+iabs(ier2)) /= 0) then
              write(*,*) 'initialPhases Allocation Error'
              call cstop(' ')
          endif
      else
          do i=1, nsetInitialPhases
             deallocate(initialPhases(i)%foms,  stat=ier1)
             deallocate(initialPhases(i)%wp,    stat=ier2)
          enddo
          if ((iabs(ier1)+iabs(ier2)) /= 0) then
              write(*,*) 'initialPhases DeAllocation Error'
              call cstop(' ')
          endif
          deallocate(initialPhases, puntatoreIP, cfomIP, stat=ier1)
          if (ier1 /= 0) then
              write(*,*) 'initialPhases DeAllocation Error'
              call cstop(' ')
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PutGetInitialPhases(iAction, nset, figs, pesi, fasi)
!
!-- ex snw16 snr16
!-- iAction =  1/2  Put/Get phases and weights
!-- nset    =  Set of phases involved
!-- figs    =  Figures of Merit array
!-- pesi    =  Weights array
!-- fasi    =  Phases array
!
      USE PhaseStuff
!
      implicit none
      integer :: idum, iAction, nset, i, k, n, fasi(nReflInitialPhases)
      real    :: dum, figs(nFoms), pesi(nReflInitialPhases)
!
      n = nReflInitialPhases
      if (iAction == 1) then
          initialPhases(nset)%foms(1:nFoms) = figs(1:nFoms)
          do i=1, n
             if (pesi(i) > 1.0) pesi(i) = 1.0
             dum = pesi(i) * 1000000
             idum = nint(dum)
             k = fasi(i) + idum * 512
             initialPhases(nset)%wp(i) = k
          enddo
      else
          figs(1:nFoms) = initialPhases(nset)%foms(1:nFoms)
          do i=1, n
             k = initialPhases(nset)%wp(i)
             idum    =  k / 512
             fasi(i) = k - idum * 512
             pesi(i) = float(idum) / 1000000.
          enddo
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine UpdateInitialPhases(cfom, puntatore, nset)
!
!-- cfom      =  Combined Figures of Merit array
!-- puntatore =  Pointer to sets of phases
!-- nset      =  Number of sets of phases
!
      USE PhaseStuff
!
      implicit none
      integer :: puntatore(nsetInitialPhases), nset, i
      real    :: cfom(nsetInitialPhases)
!
      if (nset < nsetInitialPhases) then
          nsetInitialPhases = nset
      endif
      do i=1, nsetInitialPhases
         cfomIP(i)      = cfom(i)
         puntatoreIP(i) = puntatore(i)
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LoadInitialPhases(cfom, puntatore, nset)
!
!-- cfom      =  Combined Figures of Merit array
!-- puntatore =  Pointer to sets of phases
!-- nset      =  Number of sets of phases
!
      USE General, only : InfoOK
      USE PhaseStuff
!
      implicit none
      integer :: puntatore(nsetInitialPhases), nset, i
      real    :: cfom(nsetInitialPhases)
!
      nset = nsetInitialPhases
      if (nset > 0) then
          do i=1, nset
             cfom(i)      = cfomIP(i)
             puntatore(i) = puntatoreIP(i)
          enddo
          InfoOK(16) = 1
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ManageFinalPhases(iAction, numb, nset)
!
!-- ex nfrm17
!-- iAction =  1/2  Allocate/Deallocate phases structure
!-- numb    =  Number of reflections involved
!-- nset    =  Number of sets of phases to store
!
      USE PhaseStuff
!
      implicit none
      integer :: iAction, numb, ier1, ier2, ier3, ier4, nset, i
!
      if (iAction == 1) then
          nsetFinalPhases = nset
          nReflFinalPhases = numb
          if (Allocated(finalPhases)) then
              Deallocate(finalPhases, puntatoreFP, cfomFP, stat=ier1)
          endif
          Allocate(finalPhases(nset), stat=ier1)
          Allocate(puntatoreFP(nset), stat=ier2)
          Allocate(cfomFP(nset),      stat=ier3)
          if ((ier1 + ier2 + ier3) /= 0) then
              write(*,*) 'finalPhases Allocation Error'
              call cstop(' ')
          endif
          do i=1, nsetFinalPhases
             Allocate(finalPhases(i)%foms(nFoms), stat=ier1)
             Allocate(finalPhases(i)%iphaz(numb), stat=ier2)
             Allocate(finalPhases(i)%wt(numb),    stat=ier3)
             Allocate(finalPhases(i)%fcalc(numb), stat=ier4)
             finalPhases(i)%foms(:)  = 0
             finalPhases(i)%iphaz(:) = 0
             finalPhases(i)%wt(:)    = 0
             finalPhases(i)%fcalc(:) = 0
          enddo
          if ((ier1 + ier2 + ier3 + ier4) /= 0) then
              write(*,*) 'finalPhases Allocation Error'
              call cstop(' ')
          endif
      else
          if (nsetFinalPhases > 0) then
              do i=1, nsetFinalPhases
                 deallocate(finalPhases(i)%foms,  stat=ier1)
                 deallocate(finalPhases(i)%iphaz, stat=ier2)
                 deallocate(finalPhases(i)%wt,    stat=ier3)
                 deallocate(finalPhases(i)%fcalc, stat=ier4)
              enddo
              if ((ier1 + ier2 + ier3 + ier4) /= 0) then
                  write(*,*) 'finalPhases DeAllocation Error'
                  call cstop(' ')
              endif
              deallocate(finalPhases, puntatoreFP, cfomFP, stat=ier1)
              if (ier1 /= 0) then
                  write(*,*) 'finalPhases DeAllocation Error'
                  call cstop(' ')
              endif
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PutGetFinalPhases(iAction, nset, figs)
!
!-- iAction =  1/2  Put/Get phases and weights
!-- nset    =  Set of phases involved
!-- figs    =  Figures of Merit array
!-- pesi    =  Weights array
!-- fasi    =  Phases array
!
      USE Riflessi
      USE PhaseStuff
!
      implicit none
      integer :: iAction, nset, i, n
      real    :: figs(nFoms)
!
      n = nReflFinalPhases
      if (iAction == 1) then
          finalPhases(nset)%foms(1:nFoms) = figs(1:nFoms)
          do i=1, n
             finalPhases(nset)%iphaz(i) = iphaz(i)
             finalPhases(nset)%wt(i)    = wt(i)
             finalPhases(nset)%fcalc(i) = fcvet(i)
          enddo
      else
          figs(1:nFoms) = finalPhases(nset)%foms(1:nFoms)
          do i=1, n
             iphaz(i) = finalPhases(nset)%iphaz(i)
             wt(i)    = finalPhases(nset)%wt(i)
             fcvet(i) = finalPhases(nset)%fcalc(i)
          enddo
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PutFinalPhases(nset, figs, ww, ffasi)
!
!-- nset    =  Set of phases involved
!-- figs    =  Figures of Merit array
!-- ww      =  Weights array
!-- ffasi   =  Phases array
!
      USE General, only: nreflDim
      USE Riflessi
      USE PhaseStuff
!
      implicit none
      integer :: nset, ffasi(nreflDim)
      real    :: figs(nFoms), ww(nreflDim)
!
      finalPhases(nset)%foms(1:nFoms) = figs(1:nFoms)
      wt(1:nreflDim)                  = ww(1:nreflDim)
      iphaz(1:nreflDim)               = ffasi(1:nreflDim)
      call PutGetFinalPhases(1, nset, figs)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GetFinalPhases(nset, figs, ww, ffasi)
!
!-- nset    =  Set of phases involved
!-- figs    =  Figures of Merit array
!-- ww      =  Weights array
!-- ffasi   =  Phases array
!
      USE General, only: nreflDim
      USE Riflessi
      USE PhaseStuff
!
      implicit none
      integer :: nset, ffasi(nreflDim)
      real    :: figs(nFoms), ww(nreflDim)
!
      call PutGetFinalPhases(2, nset, figs)
      figs(1:nFoms)     = finalPhases(nset)%foms(1:nFoms)
      ww(1:nreflDim)    = wt(1:nreflDim)
      ffasi(1:nreflDim) = iphaz(1:nreflDim)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine UpdateFinalPhases(cfom, puntatore, nset)
!
!-- cfom      =  Combined Figures of Merit array
!-- puntatore =  Pointer to sets of phases
!-- nset      =  Number of sets of phases
!
      USE PhaseStuff
!
      implicit none
      integer :: puntatore(nsetFinalPhases), nset, i
      real    :: cfom(nsetFinalPhases)
!
      if (nset < nsetFinalPhases) then
          nsetFinalPhases = nset
      endif
      do i=1, nsetFinalPhases
         cfomFP(i)      = cfom(i)
         puntatoreFP(i) = puntatore(i)
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LoadFinalPhases(cfom, puntatore, nset)
!
!-- ex sfl17
!-- cfom      =  Combined Figures of Merit array
!-- puntatore =  Pointer to sets of phases
!-- nset      =  Number of sets of phases
!
      USE General, only : InfoOK, QualePgm, SIRPROTPGM
      USE PhaseStuff
      USE PhaseModule, only : nSetsFineDSR
!
      implicit none
      integer :: puntatore(nsetFinalPhases), nset, i
      real    :: cfom(nsetFinalPhases)
!
      nset = nsetFinalPhases
      if (nset > 0) then
          do i=1, nset
             cfom(i)      = cfomFP(i)
             puntatore(i) = puntatoreFP(i)
          enddo
          InfoOK(17) = 1
      endif
      if (QualePgm == SIRPROTPGM) then
          nSetsFineDSR   = nsetFinalPhases
      endif
!
      return
      end
!-----------------------------------------------------------------------
!    Atoms storage related routines
!-----------------------------------------------------------------------
      subroutine GetModel()
      USE General
      USE RemoModule
      USE Atomi
      USE PhaseModule, only : numbrun, errem
      USE Molcom, only : BTot, SinglePlotType
!
      implicit none
      integer           :: i, j, nBonds
!
      numbrun   = model(WhichModel)%trial
      errem     = model(WhichModel)%erre
      BTot(:,:) = model(WhichModel)%BTot(:,:)
      
      nats      = natsInModel(WhichModel)
      
      FcScale   = FcScaleInModel(WhichModel)
      FcBiso    = FcBisoInModel(WhichModel)
      FcExtin   = FcExtinInModel(WhichModel)
      FcPola    = FcPolaInModel(WhichModel)
      FcTwin    = FcTwinInModel(WhichModel) 
      Overall_dev(:) = Overall_devInModel(:,WhichModel)
      
      do i=1, nats
         xyzs(:,i)         = model(WhichModel)%atoms(:,i,1)
         nz(i)             = model(WhichModel)%specie(i,1)
         nzTot(i)          = iabs(nz(i)) / nzConst
         bfac(i)           = model(WhichModel)%th_fact(i,1)
         aLab(i)           = model(WhichModel)%Label(i)
         serial(i)         = model(WhichModel)%serial(i)
         SinglePlotType(i) = model(WhichModel)%SinglePlotType(i)
         IsoAniso(i)       = model(WhichModel)%IsoAniso(i,1)
         bij(:,i)          = model(WhichModel)%bij(:,i,1)
         
         iSite(i)          = model(WhichModel)%iSite(i)
         SiteInfo(:,i)     = model(WhichModel)%SiteInfo(:,i)
         xyzs_dev(:,i)     = model(WhichModel)%xyz_dev(:,i,1)
         occX_dev(:,i)     = model(WhichModel)%occX_dev(:,i)
         bfac_dev(i)       = model(WhichModel)%th_fact_dev(i,1)
         occ_dev(i)        = model(WhichModel)%occ_dev(i)
         bij_dev(:,i)      = model(WhichModel)%bij_dev(1:6,i,1)
         iGeomAtom(i)      = model(WhichModel)%GeomAtom(i)
!
*gl*     bsav(i) = bfac(i)
         IsoAniso(i) = 2
         if (bij(1,i) > 0.0) then
!--i termini fuori diagonale andrebbero divisi per 2.0, ma questo viene fatto
!  nella routine toMolPlo3(leggi) in molplocomune.f
             IsoAniso(i) = 1
             Ell(1,1,i) = bij(1,i)
             Ell(1,2,i) = bij(2,i)
             Ell(2,1,i) = bij(2,i)
             Ell(1,3,i) = bij(3,i)
             Ell(3,1,i) = bij(3,i)
             Ell(2,2,i) = bij(4,i)
             Ell(2,3,i) = bij(5,i)
             Ell(3,2,i) = bij(5,i)
             Ell(3,3,i) = bij(6,i)
*gl*     else
*gl*         bSav(i) = bSav(i) - 100000.0
         endif
      enddo
!
      nBonds = BondsInModel(WhichModel)
      j = 1
      do i=1, nBonds
         iconn(j+1) = Bonds(WhichModel)%Legami(1,i)
         iconn(j+2) = Bonds(WhichModel)%Legami(2,i)
         iconn(j+3) = Bonds(WhichModel)%Legami(3,i)
         j = j + 3
      end do
      iconn(1) = nBonds
!
      InfoOK(15) = 1
*     InfoOK(5)  = 1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PutModel()
      USE General
      USE RemoModule
      USE Atomi
      USE PhaseModule, only : numbrun, errem
      USE Molcom, only : BTot, SinglePlotType
!
      implicit none
      integer           :: iAction, i, j, nBonds, k
!
      if (.not.allocated(model)) then
          iAction = 0
          call AllocaModelRemo(iAction)
          natsInModel(WhichModel) = MaxAtoms
          natsInModel(:) = MaxAtoms
      endif
      if (.not.allocated(model(WhichModel)%atoms)) then
          iAction = 1
          call AllocaModelRemo(iAction)
      endif
      if (.not. allocated(Bonds)) then
          call AllocaBonds(0)
          BondsInModel(:) = MaxBonds
      endif
      model(WhichModel)%trial     = numbrun
      model(WhichModel)%erre      = errem
      model(WhichModel)%BTot(:,:) = BTot(:,:)
!     model(WhichModel)%BTot(:,:) = 101
      natsInModel(WhichModel)     = nats
      
      FcScaleInModel(WhichModel) = FcScale
      FcBisoInModel(WhichModel)  = FcBiso
      FcExtinInModel(WhichModel) = FcExtin
      FcPolaInModel(WhichModel)  = FcPola
      FcTwinInModel(WhichModel)  = FcTwin
      Overall_devInModel(:,WhichModel) = Overall_dev(:)
      
*     k = size(model(WhichModel)%atoms(5,:,1))
*     if (nats > k) then
*         call CopyModel(1, 2)
*     endif

      do i=1, nats
         model(WhichModel)%atoms(:,i,1)      = xyzs(:,i)
         model(WhichModel)%specie(i,1)       = nz(i)
         model(WhichModel)%th_fact(i,1)      = bfac(i)
         model(WhichModel)%Label(i)          = aLab(i)
         model(WhichModel)%serial(i)         = serial(i)
         model(WhichModel)%SinglePlotType(i) = SinglePlotType(i)
         model(WhichModel)%IsoAniso(i,1)     = IsoAniso(i)
         model(WhichModel)%bij(:,i,1)        = bij(:,i)
         
         model(WhichModel)%iSite(i)          = iSite(i) 
         model(WhichModel)%SiteInfo(:,i)     = SiteInfo(:,i)    
         model(WhichModel)%xyz_dev(:,i,1)    = xyzs_dev(:,i)  
         model(WhichModel)%occX_dev(:,i)     = occX_dev(:,i)     
         model(WhichModel)%th_fact_dev(i,1)  = bfac_dev(i)  
         model(WhichModel)%occ_dev(i)        = occ_dev(i)    
         model(WhichModel)%bij_dev(1:6,i,1)  = bij_dev(:,i)  
         model(WhichModel)%GeomAtom(i)       = iGeomAtom(i)
      enddo
!
!-- Connectivity
!
      nBonds = iconn(1)
*gl*  if (iconn(1) <= 0) then
*gl*      BondsInModel(WhichModel) = MaxBonds
*gl*  else
          BondsInModel(WhichModel) = nBonds
*gl*  endif
      if (.not.allocated(Bonds(WhichModel)%Legami)) then
          iAction = 1
          call AllocaBonds(iAction)
      endif
      j = 1
      do i=1, nBonds
         Bonds(WhichModel)%Legami(1,i) = iconn(j+1)
         Bonds(WhichModel)%Legami(2,i) = iconn(j+2)
         Bonds(WhichModel)%Legami(3,i) = iconn(j+3)
         j = j + 3
      end do
!
      InfoOK(15) = 1
*     InfoOK(5)  = 1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ModModel(nx, iAction, alabc, lnz, vet)
      USE General
      USE RemoModule
      USE Atomi
      USE PhaseModule, only : numbrun, errem
      USE Molcom, only : SinglePlotType, iPlotType
!
!--routine for updating an atom in the model
!
!  nx	     = current n. of atom
!  iAction = 0 generic modify
!	       1 add
!	       2 delete
!	       3 isotropic thermal factor
!	       4 specie	   not used
!	       5 serial	   not used
!            6 x,y,z 
!            7 anisotropic parameters
!            100 connectivity
!            200 single atom plot style
!  alabc     = label of atom (character string)
!  lnz	     = n. of specie in list 3
!  vet(1..3) = x,y,z
!  vet(4)    = height peak
!  vet(5)    = occ
!  vet(6)    = b(iso)
!
!
      implicit none
      integer            :: nx, iAction, lnz, isn, i, j, natom, nBonds
      integer            :: n, kiso, resto, kk, isign, segno
      real               :: vet(8), biso
      character (len=16) :: alabc
!
      natom = natsInModel(WhichModel)
      select case(iAction)

         case (0)                      ! generic update
             n = nx
             if (alabc /= ' ') then
                 isn = serial(nx)
                 model(WhichModel)%Label(n) = alabc
                 model(WhichModel)%serial(n) = isn
             endif
             model(WhichModel)%atoms(1:3,n,1) = vet(1:3)
             if (vet(4) > 0.0001) model(WhichModel)%atoms(4,n,1)=vet(4)
             if (vet(5) > 0.0001) model(WhichModel)%atoms(5,n,1)=vet(5)
             if (vet(6) > 0.01)   model(WhichModel)%th_fact(n,1)=vet(6)
             kk = model(WhichModel)%specie(n,1)
             segno = isign(1,kk)
             resto = mod(iabs(kk), nzConst)
             kk = segno * (lnz * nzConst + resto)
             model(WhichModel)%specie(n,1)       = kk

         case (1)                      ! add an atom
             n = natom + 1
             natsInModel(WhichModel) = n
             isn = serial(nx)
             model(WhichModel)%SinglePlotType(n) = iPlotType
             model(WhichModel)%Label(n)          = alabc
             model(WhichModel)%serial(n)         = isn
             model(WhichModel)%atoms(1:5,n,1)    = vet(1:5)
             model(WhichModel)%th_fact(n,1)      = vet(6)
             model(WhichModel)%specie(n,1)       = lnz * nzConst
             model(WhichModel)%HETA(n,1)         = 0
             if (iabs(lnz) > 0) then
                 if (lnz < PiccoFour) then
                     model(WhichModel)%AtSpecies(n,1)= Species(lnz)
                 else
                     model(WhichModel)%AtSpecies(n,1)= ' '
                 endif
             else
                 model(WhichModel)%AtSpecies(n,1)= ' '
             endif

         case (2)                      ! delete the nx atom
             j = 0
             do i=1, natom
                if (i == nx) cycle
                j = j + 1
                model(WhichModel)%atoms(:,j,1)      =
     *                           model(WhichModel)%atoms(:,i,1)      
                model(WhichModel)%specie(j,1)       =
     *                           model(WhichModel)%specie(i,1)       
                model(WhichModel)%th_fact(j,1)      =
     *                           model(WhichModel)%th_fact(i,1)      
                model(WhichModel)%Label(j)          =
     *                           model(WhichModel)%Label(i)          
                model(WhichModel)%serial(j)         =
     *                           model(WhichModel)%serial(i)         
                model(WhichModel)%SinglePlotType(j) =
     *                           model(WhichModel)%SinglePlotType(i) 
                model(WhichModel)%IsoAniso(j,1)     =
     *                           model(WhichModel)%IsoAniso(i,1)     
                model(WhichModel)%bij(:,j,1)        =
     *                           model(WhichModel)%bij(:,i,1)   
     
                model(WhichModel)%iSite(j)          = 
     *                           model(WhichModel)%iSite(i)            
                model(WhichModel)%SiteInfo(:,j)     = 
     *                           model(WhichModel)%SiteInfo(:,i)    
                model(WhichModel)%xyz_dev(:,j,1)    = 
     *                           model(WhichModel)%xyz_dev(:,i,1)  
                model(WhichModel)%occX_dev(:,j)     = 
     *                           model(WhichModel)%occX_dev(:,i)  
                model(WhichModel)%th_fact_dev(j,1)  = 
     *                           model(WhichModel)%th_fact_dev(i,1) 
                model(WhichModel)%occ_dev(j)      = 
     *                           model(WhichModel)%occ_dev(i)    
                model(WhichModel)%bij_dev(1:6,j,1)  = 
     *                           model(WhichModel)%bij_dev(1:6,i,1) 
                model(WhichModel)%GeomAtom(j)          = 
     *                           model(WhichModel)%GeomAtom(i)
                model(WhichModel)%HETA(j,1)            =
     *                           model(WhichModel)%HETA(i,1)      
                model(WhichModel)%AtSpecies(j,1)            =
     *                           model(WhichModel)%AtSpecies(i,1)      
             enddo
             natsInModel(WhichModel) = natom - 1

         case (3)                      ! isotropic thermal factor
             n = nx
             kiso = vet(6)
             if (kiso == 0) then
*gl*             if (model(WhichModel)%bij(1,i,1) > 0.0) then
                 if (model(WhichModel)%bij(1,n,1) > 0.0) then
                     biso = model(WhichModel)%bij(1,n,1) * BijToBiso(1)
     1              +       model(WhichModel)%bij(2,n,1) * BijToBiso(2)
     2              +       model(WhichModel)%bij(3,n,1) * BijToBiso(3)
     3              +       model(WhichModel)%bij(4,n,1) * BijToBiso(4)
     4              +       model(WhichModel)%bij(5,n,1) * BijToBiso(5)
     5              +       model(WhichModel)%bij(6,n,1) * BijToBiso(6)

                 end if
             else
                 biso = vet(6)
             endif
             model(WhichModel)%th_fact(n,1) = biso
             model(WhichModel)%IsoAniso(n,1) = 1
             model(WhichModel)%bij(:,n,1) = 0

         case (4)                      ! specie  (not used)

         case (5)                      ! serial  (not used)

         case (6)                      ! x,y,z
             n = nx
             model(WhichModel)%atoms(1:3,n,1) = vet(1:3)

         case (7)                      ! bij
             n = nx
             model(WhichModel)%bij(1:6,n,1) = vet(1:6)

         case (100)                    ! connettivity
             if (iconn(1) > 0 .and. iconn(1) < 9999) then
                 nBonds = iconn(1)
                 BondsInModel(WhichModel) = nBonds
                 j = 1
                 do i=1, nBonds
                    Bonds(WhichModel)%Legami(1,i) = iconn(j+1)
                    Bonds(WhichModel)%Legami(2,i) = iconn(j+2)
                    Bonds(WhichModel)%Legami(3,i) = iconn(j+3)
                    j = j + 3
                 end do
             endif

         case (200)                    ! single plot style
             do i=1, natom
                model(WhichModel)%SinglePlotType(i) = SinglePlotType(i)
             enddo

      end select
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CopyModel(from, to)
      USE RemoModule
!
      implicit none
      integer :: j, from, to, natom, Mono
!
      natom = natsInModel(from)
      Mono = MonomerInModel(from)
!
      model(to)%trial     = model(from)%trial
      model(to)%erre      = model(from)%erre
      model(to)%BTot(:,:) = model(from)%BTot(:,:)
      natsInModel(to)     = natsInModel(from)
      
      FcScaleInModel(to) = FcScaleInModel(from)
      FcBisoInModel(to)  = FcBisoInModel(from)
      FcExtinInModel(to) = FcExtinInModel(from)
      FcPolaInModel(to)  = FcPolaInModel(from)
      FcTwinInModel(to)  = FcTwinInModel(from)
      Overall_devInModel(:,to) = Overall_devInModel(:,from)
!
      do j=1, natom
         model(to)%atoms(1:5,j,Mono)   = model(from)%atoms(1:5,j,Mono)
         model(to)%saved(1:3,j,Mono)   = model(from)%saved(1:3,j,Mono)
         model(to)%ortho(1:3,j,Mono)   = model(from)%ortho(1:3,j,Mono)
         model(to)%specie(j,Mono)      = model(from)%specie(j,Mono)
         model(to)%th_fact(j,Mono)     = model(from)%th_fact(j,Mono)
         model(to)%tipoAtomo(j,Mono)   = model(from)%tipoAtomo(j,Mono)
         model(to)%tipoResiduo(j,Mono) = model(from)%tipoResiduo(j,Mono)
         model(to)%Alternate(j,Mono)   = model(from)%Alternate(j,Mono)
         model(to)%catena(j,Mono)      = model(from)%catena(j,Mono)
         model(to)%Secondary(j,Mono)   = model(from)%Secondary(j,Mono)
         model(to)%numResiduo(j,Mono)  = model(from)%numResiduo(j,Mono)
         model(to)%Insertion(j,Mono)   = model(from)%Insertion(j,Mono)
         model(to)%bij(1:6,j,Mono)     = model(from)%bij(1:6,j,Mono)
         model(to)%SinglePlotType(j)   = model(from)%SinglePlotType(j)
         InfoOnModels(to)%iEqui(j)     = InfoOnModels(from)%iEqui(j)
         InfoOnModels(to)%SymOp(j)     = InfoOnModels(from)%SymOp(j)
         
         model(to)%iSite(j)            = model(from)%iSite(j) 
         model(to)%SiteInfo(1:4,j)     = model(from)%SiteInfo(1:4,j)    
         model(to)%xyz_dev(1:3,j,Mono) = model(from)%xyz_dev(1:3,j,Mono)
         model(to)%occX_dev(1:4,j)     = model(from)%occX_dev(1:4,j)
         model(to)%th_fact_dev(j,Mono) = model(from)%th_fact_dev(j,Mono)
         model(to)%occ_dev(j)          = model(from)%occ_dev(j)    
         model(to)%bij_dev(1:6,j,Mono) = model(from)%bij_dev(1:6,j,Mono)
         model(to)%GeomAtom(j)         = model(from)%GeomAtom(j) 
         model(to)%HETA(j,Mono)        = model(from)%HETA(j,Mono)
         model(to)%AtSpecies(j,Mono)   = model(from)%AtSpecies(j,Mono)
      end do
      model(to)%IsoAniso(1:natom,:) = model(from)%IsoAniso(1:natom,:)
      model(to)%Label(1:natom)      = model(from)%Label(1:natom)
      model(to)%serial(1:natom)     = model(from)%serial(1:natom)
      model(to)%al(1:4,:)   = model(from)%al(1:4,:)
      model(to)%bs(1:4,:)   = model(from)%bs(1:4,:)
      model(to)%cl(:)       = model(from)%cl(:)
      model(to)%raggio(:,:) = model(from)%raggio(:,:)
      model(to)%no(:)       = model(from)%no(:)
      model(to)%nw(:)       = model(from)%nw(:)
      model(to)%nalf(:)     = model(from)%nalf(:)
      model(to)%nk          = model(from)%nk
      model(to)%PDB         = model(from)%PDB
!
      BondsInModel(to) = BondsInModel(from)
      do j=1, BondsInModel(from)
         Bonds(to)%Legami(1:3,j) = Bonds(from)%Legami(1:3,j)
      end do
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CopyAtom(from, to, Mono, i_from, i_to, iEq)
      USE RemoModule
!
      implicit none
      integer :: from, to, Mono, i, j, i_from, i_to, iEq

!
      j = i_from
      i = i_to
!
      model(to)%atoms(1:5,i,Mono)   = model(from)%atoms(1:5,j,Mono)
      model(to)%saved(1:3,i,Mono)   = model(from)%saved(1:3,j,Mono)
      model(to)%ortho(1:3,i,Mono)   = model(from)%ortho(1:3,j,Mono)
      model(to)%specie(i,Mono)      = model(from)%specie(j,Mono)
      model(to)%th_fact(i,Mono)     = model(from)%th_fact(j,Mono)
      model(to)%tipoAtomo(i,Mono)   = model(from)%tipoAtomo(j,Mono)
      model(to)%Alternate(i,Mono)   = model(from)%Alternate(j,Mono)
      model(to)%tipoResiduo(i,Mono) = model(from)%tipoResiduo(j,Mono)
      model(to)%catena(i,Mono)      = model(from)%catena(j,Mono)
      model(to)%Secondary(i,Mono)   = model(from)%Secondary(j,Mono)
      model(to)%numResiduo(i,Mono)  = model(from)%numResiduo(j,Mono)
      model(to)%Insertion(i,Mono)   = model(from)%Insertion(j,Mono)
      model(to)%bij(1:6,i,Mono)     = model(from)%bij(1:6,j,Mono)
      model(to)%SinglePlotType(i)   = model(from)%SinglePlotType(j)
      InfoOnModels(to)%iEqui(i)     = iEq
      InfoOnModels(to)%SymOp(i)     = InfoOnModels(from)%SymOp(j)

      model(to)%iSite(i)            = model(from)%iSite(j)
      model(to)%SiteInfo(1:4,i)     = model(from)%SiteInfo(1:4,j)
      model(to)%xyz_dev(1:3,i,Mono) = model(from)%xyz_dev(1:3,j,Mono)
      model(to)%occX_dev(1:4,i)     = model(from)%occX_dev(1:4,j)
      model(to)%th_fact_dev(i,Mono) = model(from)%th_fact_dev(j,Mono)
      model(to)%occ_dev(i)          = model(from)%occ_dev(j)
      model(to)%bij_dev(1:6,i,Mono) = model(from)%bij_dev(1:6,j,Mono)
      model(to)%GeomAtom(i)         = model(from)%GeomAtom(j)
      model(to)%HETA(i,Mono)        = model(from)%HETA(j,Mono)
      model(to)%AtSpecies(i,Mono)   = model(from)%AtSpecies(j,Mono)
!
      model(to)%IsoAniso(i,:) = model(from)%IsoAniso(j,:)
      model(to)%Label(i)      = model(from)%Label(j)
      model(to)%serial(i)     = model(from)%serial(j)
      model(to)%al(1:4,:)   = model(from)%al(1:4,:)
      model(to)%bs(1:4,:)   = model(from)%bs(1:4,:)
      model(to)%cl(:)       = model(from)%cl(:)
      model(to)%raggio(:,:) = model(from)%raggio(:,:)
      model(to)%no(:)       = model(from)%no(:)
      model(to)%nw(:)       = model(from)%nw(:)
      model(to)%nalf(:)     = model(from)%nalf(:)
      model(to)%nk          = model(from)%nk
      model(to)%PDB         = model(from)%PDB
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PruneModel(MD, prune)
      USE RemoModule
!
!-- Questa routine va completata: non usarla !!!
!
      implicit none
      integer :: MD, prune(natsInModel(MD))
      integer :: i, j, natom, Mono
!
      natom = natsInModel(MD)
      Mono = MonomerInModel(MD)
!
      natsInModel(MD) = natsInModel(MD) - sum(prune(1:natom))
!
      i = 0
      do j=1, natom
         if (prune(j) == 1) cycle
         i = i + 1
         model(MD)%atoms(1:5,i,Mono)   = model(MD)%atoms(1:5,j,Mono)
         model(MD)%saved(1:3,i,Mono)   = model(MD)%saved(1:3,j,Mono)
         model(MD)%ortho(1:3,i,Mono)   = model(MD)%ortho(1:3,j,Mono)
         model(MD)%specie(i,Mono)      = model(MD)%specie(j,Mono)
         model(MD)%th_fact(i,Mono)     = model(MD)%th_fact(j,Mono)
         model(MD)%tipoAtomo(i,Mono)   = model(MD)%tipoAtomo(j,Mono)
         model(MD)%Alternate(i,Mono)   = model(MD)%Alternate(j,Mono)
         model(MD)%tipoResiduo(i,Mono) = model(MD)%tipoResiduo(j,Mono)
         model(MD)%catena(i,Mono)      = model(MD)%catena(j,Mono)
         model(MD)%Secondary(i,Mono)   = model(MD)%Secondary(j,Mono)
         model(MD)%numResiduo(i,Mono)  = model(MD)%numResiduo(j,Mono)
         model(MD)%Insertion(i,Mono)   = model(MD)%Insertion(j,Mono)
         model(MD)%bij(1:6,i,Mono)     = model(MD)%bij(1:6,j,Mono)
         model(MD)%SinglePlotType(i)   = model(MD)%SinglePlotType(j)
         InfoOnModels(MD)%iEqui(i)     = i
         InfoOnModels(MD)%SymOp(i)     = InfoOnModels(MD)%SymOp(j)
         model(MD)%HETA(i,Mono)        = model(MD)%HETA(j,Mono)
         model(MD)%AtSpecies(i,Mono)   = model(MD)%AtSpecies(j,Mono)
      end do
!
      return
!
      model(MD)%IsoAniso(:,:) = model(MD)%IsoAniso(:,:)
      model(MD)%al(1:4,:)   = model(MD)%al(1:4,:)
      model(MD)%bs(1:4,:)   = model(MD)%bs(1:4,:)
      model(MD)%cl(:)       = model(MD)%cl(:)
      model(MD)%raggio(:,:) = model(MD)%raggio(:,:)
      model(MD)%no(:)       = model(MD)%no(:)
      model(MD)%nw(:)       = model(MD)%nw(:)
      model(MD)%nalf(:)     = model(MD)%nalf(:)
      model(MD)%Label(:)    = model(MD)%Label(:)
      model(MD)%serial(:)   = model(MD)%serial(:)
      model(MD)%nk          = model(MD)%nk
      model(MD)%PDB         = model(MD)%PDB
!
      BondsInModel(MD) = BondsInModel(MD)
      do j=1, BondsInModel(MD)
         Bonds(MD)%Legami(1:3,j) = Bonds(MD)%Legami(1:3,j)
      end do
!
      return
      end
!
!-----------------------------------------------------------------------
!    Reflections related routines
!-----------------------------------------------------------------------
      subroutine UpdateReflInfo
      USE General
      USE RiflessiInfo
*gl*  USE WrReIn
!
      refl_info%nrefltot      = nrefltot
      refl_info%nrefl         = nrefl
      refl_info%nreflObs      = nreflObs
      refl_info%nonoss        = nonoss
      refl_info%nescl         = nescl
      refl_info%cutoff        = cutoff
      refl_info%nstr          = nstr
      refl_info%nstr_data     = nstr_data
      refl_info%nzro          = nzro
      refl_info%ihmx(1:3)     = ihmx(1:3)
      refl_info%ihmn(1:3)     = ihmn(1:3)
      refl_info%ilent         = ilent
      refl_info%ivelox        = ivelox
      refl_info%ifPDBfiles    = ifPDBfiles
      refl_info%knw           = knw
      refl_info%bt            = bt
      refl_info%sc            = sc
      refl_info%s3s2          = s3s2
      refl_info%nvsfc         = nvsfc
      refl_info%icdd          = icdd
      refl_info%deltahkl(1:3) = deltahkl(1:3)
      refl_info%rflsq         = rflsq
      refl_info%rwflsq        = rwflsq
      refl_info%slsq          = slsq
      refl_info%btd(1:5)      = btd(1:5)
      refl_info%scd(1:5)      = scd(1:5)
      refl_info%s3s2d(1:5)    = s3s2d(1:5)
      refl_info%ihmxExt(1:3)  = ihmxExt(1:3)
      refl_info%uvwt2(1:2)    = uvwt2(1:2)
      refl_info%nsyn          = nsyn
      refl_info%kequirip      = kequirip
      refl_info%pfwhm         = pfwhm
      refl_info%QualeLista6   = QualeLista6
      refl_info%shiftesd(1:2) = shiftesd(1:2)
      refl_info%rhodiff(1:3)  = rhodiff(1:3)
      refl_info%ifo2          = ifo2
      refl_info%npseud        = npseud
      refl_info%iyrandc       = iyrandc
      refl_info%fosog         = fosog
      refl_info%ksigma        = ksigma
      refl_info%neutro        = neutro
      refl_info%lproj         = lproj
      refl_info%pack3         = pack3
      refl_info%pack2         = pack2
      refl_info%pack1         = pack1
      refl_info%pack5         = pack5
      refl_info%kWasReduced   = kWasReduced
      refl_info%kmad          = kmad
      refl_info%s3s2mad       = s3s2mad
      refl_info%resm          = resm
      refl_info%numbGen       = numbGen
      refl_info%ksize         = ksize
      refl_info%nds           = nds
      refl_info%ianom         = ianom
      refl_info%jderi         = jderi
      refl_info%machkl        = machkl
      refl_info%ifRIP         = ifRIP
      refl_info%ifTwin        = ifTwin
      refl_info%iprioroX      = iprioroX
      refl_info%ipriorpX      = ipriorpX
      refl_info%ipriorsX      = ipriorsX
      refl_info%ipriofrX      = ipriofrX
      refl_info%ipriopaX      = ipriopaX
      refl_info%iprefX        = iprefX
      refl_info%jplaneX(1:3)  = jplaneX(1:3)
      refl_info%icomatsavX    = icomatsavX
      refl_info%ipdirsavX     = ipdirsavX
      refl_info%sh_su_max     = sh_su_max
      refl_info%sh_su_mean    = sh_su_mean
      refl_info%diff_d_max    = diff_d_max
      refl_info%diff_d_min    = diff_d_min
      refl_info%diff_d_rms    = diff_d_rms
      refl_info%iprandomX     = iprandomX
      refl_info%iprandomaxX   = iprandomaxX
      refl_info%iyrand        = iyrand
      refl_info%numbRiflInput = numbRiflInput
      refl_info%erreInt       = erreInt
      refl_info%resolutionMin = resolutionMin
      refl_info%resolutionMax = resolutionMax
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LoadReflInfo
      USE General
      USE RiflessiInfo
*gl*  USE WrReIn
!
*gl*  nreflDim      = refl_info%nrefltot
      nrefltot      = refl_info%nrefltot
      nrefl         = refl_info%nrefl
      nreflObs      = refl_info%nreflObs
      nonoss        = refl_info%nonoss
      nescl         = refl_info%nescl
      cutoff        = refl_info%cutoff
      nstr          = refl_info%nstr
      nstr_data     = refl_info%nstr_data
      nzro          = refl_info%nzro
      ihmx(1:3)     = refl_info%ihmx(1:3)
      ihmn(1:3)     = refl_info%ihmn(1:3)
      ilent         = refl_info%ilent
      ivelox        = refl_info%ivelox
      ifPDBfiles    = refl_info%ifPDBfiles
      knw           = refl_info%knw
      bt            = refl_info%bt
      sc            = refl_info%sc
      s3s2          = refl_info%s3s2
      nvsfc         = refl_info%nvsfc
      icdd          = refl_info%icdd
      deltahkl(1:3) = refl_info%deltahkl(1:3)
      rflsq         = refl_info%rflsq
      rwflsq        = refl_info%rwflsq
      slsq          = refl_info%slsq
      btd(1:5)      = refl_info%btd(1:5)
      scd(1:5)      = refl_info%scd(1:5)
      s3s2d(1:5)    = refl_info%s3s2d(1:5)
      ihmxExt(1:3)  = refl_info%ihmxExt(1:3)
      uvwt2(1:2)    = refl_info%uvwt2(1:2)
      nsyn          = refl_info%nsyn
      kequirip      = refl_info%kequirip
      pfwhm         = refl_info%pfwhm
      QualeLista6   = refl_info%QualeLista6
      shiftesd(1:2) = refl_info%shiftesd(1:2)
      rhodiff(1:3)  = refl_info%rhodiff(1:3)
      ifo2          = refl_info%ifo2
      npseud        = refl_info%npseud
      iyrandc       = refl_info%iyrandc
      fosog         = refl_info%fosog
      ksigma        = refl_info%ksigma
      neutro        = refl_info%neutro
      lproj         = refl_info%lproj
      pack3         = refl_info%pack3
      pack2         = refl_info%pack2
      pack1         = refl_info%pack1
      pack5         = refl_info%pack5
      kWasReduced   = refl_info%kWasReduced
      kmad          = refl_info%kmad
      s3s2mad       = refl_info%s3s2mad
      resm          = refl_info%resm
      numbGen       = refl_info%numbGen
      ksize         = refl_info%ksize
      nds           = refl_info%nds
      ianom         = refl_info%ianom
      jderi         = refl_info%jderi
      machkl        = refl_info%machkl
      ifRIP         = refl_info%ifRIP
      ifTwin        = refl_info%ifTwin
      iprioroX      = refl_info%iprioroX
      ipriorpX      = refl_info%ipriorpX
      ipriorsX      = refl_info%ipriorsX
      ipriofrX      = refl_info%ipriofrX
      ipriopaX      = refl_info%ipriopaX
      iprefX        = refl_info%iprefX
      jplaneX(1:3)  = refl_info%jplaneX(1:3)
      icomatsavX    = refl_info%icomatsavX
      ipdirsavX     = refl_info%ipdirsavX
      sh_su_max     = refl_info%sh_su_max
      sh_su_mean    = refl_info%sh_su_mean
      diff_d_max    = refl_info%diff_d_max
      diff_d_min    = refl_info%diff_d_min
      diff_d_rms    = refl_info%diff_d_rms
      iprandomX     = refl_info%iprandomX
      iprandomaxX   = refl_info%iprandomaxX
      iyrand        = refl_info%iyrand
      numbRiflInput = refl_info%numbRiflInput
      erreInt       = refl_info%erreInt
      resolutionMin = refl_info%resolutionMin
      resolutionMax = refl_info%resolutionMax
!
      InfoOK(6) = 1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Cancella(iln)
!--clear the entry for a list in InfoOK(iln)
!--iln = the list type number
!
      USE General
!
      InfoOK(iln) = 0
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CaricaFasiNote(iphao, ipha)
      USE General
      USE RiflessiNew
!
      integer none
      integer :: i, iphao(nrefl), ipha(nrefl)
!
      do i=1, nrefl
         refl%phase(i) = iphao(i)
         refl%pub(i)   = ipha(i)
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AggiornaFasiPesiNew(ksubr,wei,ipha,fcvet)
      USE General
      USE RiflessiNew
!
      implicit none
      integer :: ksubr, i, ipha(nreflTot), in, ij, obsCode, n
      real    :: wei(nreflTot), fcvet(nreflTot)
!
      n = size(ipha)
      if (ksubr < 10) then
!--fetch the next reflection
!         do i=1, nrefl
          do i=1, n
             refl%fc(i)     = fcvet(i)
             refl%phase(i)  = ipha(i)
             refl%weight(i) = wei(i)
          enddo
      elseif (ksubr >= 10 .and. ksubr <= 14) then
!  ksubr = 10   LSQ old flag  0 only observed reflections
!          11   LSQ           1 all the reflections
!          12   LSQ          -1 all but unobserved
!          13   LSQ          -2 observed and unobserved
!          14   LSQ          -3 only unobserved
          ij = 1
          do i=1, nreflTot
*??*      do i=1, n    ! dovrebbe essere giusto cosi: da controllare
                 obsCode = refl%observed(i)
                 if (obsCode /= 0 .and. ksubr == 10) cycle
                 if (obsCode == 1 .and. ksubr == 12) cycle
                 if (obsCode <  0 .and. ksubr == 13) cycle
                 if (obsCode /= 1 .and. ksubr == 14) cycle
                 refl%fc(i)     = fcvet(ij)
                 refl%phase(i)  = ipha(ij)
                 refl%weight(i) = wei(ij)
                 ij = ij + 1
          enddo
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AggiornaFobsNew(fovet, sigmav)
      USE General
      USE RiflessiNew
!
      integer none
      integer :: i
      real    :: fovet(nrefl), sigmav(nrefl)
!
      do i=1, nrefl
         refl%fo(i)    = fovet(i)
         refl%sigma(i) = sigmav(i)
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AggiornaFasiNoteNew(ifFfromModel, fasi, fcal)
      USE General
      USE RiflessiNew
!
      integer none
      integer :: ifFfromModel, i, mkang, idv, id1, id2, CalcPhase
      integer :: fasi(nreflDim)
      real    :: CalcF, fcal(nreflDim)
!
      do i=1, nreflDim
         mkang     = refl%code(i)
*        CalcPhase = refl%phase(i)
         CalcPhase = fasi(i)
!
!-- set phase values to the restricted values
!
         if (iabs(mkang) /= 1) then
             idv = 15*mod(iabs(mkang)-1,12)
             id1 = iabs(idv-CalcPhase)
             id2 = iabs(idv+180-CalcPhase)
             id1 = min0(id1,360-id1)
             id2 = min0(id2,360-id2)
             if (id1 < id2) then
                 CalcPhase = idv
             else
                 CalcPhase = idv + 180
             endif
         endif
         CalcPhase = mod(CalcPhase + 36000, 360)
         if (CalcPhase <= 0) CalcPhase = CalcPhase + 360
         refl%pub(i) = CalcPhase
         if (ifCalcF == 1 .or. ifFfromModel == 1) then
*            CalcF         = refl%fc(i)
             CalcF         = fcal(i)
             refl%fo(i)    = CalcF
             refl%sigma(i) = sqrt(CalcF)
          endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AggiornaFC(fcvet, wt)
      USE General
      USE RiflessiNew
!
      integer none
      integer :: i
      real    :: fcvet(nreflDim), wt(nreflDim)
!
      do i=1, nreflDim
         refl%fc(i)    = fcvet(i)
         refl%weight(i) = wt(i)
      enddo
!
      if (numbGen > 0 .and. ifPhases == 1) then
          do i=nrefl+1, nreflDim
             refl%fo(i)     = fcvet(i)
          enddo
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ChopRiflessiNew(icho)
      USE General
      USE RiflessiNew
!
!--update reflection info
!  icho = integer chop value
!
      implicit none
      integer :: icho, i, obsCode, n6a, n6s
      real    :: xchop
!
      call LoadReflInfo
      iCut = nint(cutoff)
      xchop = float(icho)
      n6  = 0
      n6a = 0
      n6s = 0
!
      do i=1, nreflTot
         obsCode = refl%observed(i)
         if (obsCode >= 0) then
             obsCode = 0
             if (refl%fo(i) < refl%sigma(i) * xchop) then
                 obsCode = 1
             endif
         endif
         if (obsCode == 0) then
!--nuber of observed reflection
             n6 = n6 + 1
         else if(obsCode == 1) then
!--number of unobserved reflections
             n6a = n6a + 1
         else if(obsCode < 0) then
             n6s = n6s + 1
         endif
!--store the last reflection
         refl%observed(i) = obsCode
      enddo
!
!--rewrite reflection info
!
!gl!  nrefl  = n6
      nreflObs  = n6
      nonoss    = n6a
      nescl     = n6s
      cutoff    = xchop
      call UpdateReflInfo
!
      return
      end
!-----------------------------------------------------------------------
!    REFLECTION PACKING UTILITY
!-----------------------------------------------------------------------
      subroutine pack2002(index,ih,ik,il)
      USE General
!
      ih = ih + 512
      ik = ik + 512
      il = il + 512

      index = ih * ifat512a + ik * ifat512b + il
!
      return
      end
!-----------------------------------------------------------------------
      subroutine unpack2002(index,ih,ik,il)
      USE General
!
      is = index
      ih = is / ifat512a
      is = is - ifat512a * ih
      ik = is / ifat512b
      il = is - ifat512b * ik
!
      ih = ih - 512
      ik = ik - 512
      il = il - 512
!
      return
      end
!-----------------------------------------------------------------------
!    PSEUDO-SYMMETRY routines
!-----------------------------------------------------------------------
      subroutine PutGetPseudoInfo(iAction, ipik)
      USE General
!
      implicit none
      integer :: iAction, PseudoCond, ipik, QualePseudo
      real    :: PseudoVet
      common /PseudoInfo/ PseudoVet(3), PseudoCond(12), QualePseudo
!
      if (iAction == 0) then
         PseudoVet(:)  = 0.0
         PseudoCond(:) = 0
      elseif (iAction == 1) then
         PseudoVet(1)  = aPse
         PseudoVet(2)  = bPse
         PseudoVet(3)  = percPseudo
         PseudoCond(:) = lpseuv(:)
         QualePseudo   = ipik
      else
         aPse       = PseudoVet(1)
         bPse       = PseudoVet(2)
         percPseudo = PseudoVet(3)
         lpseuv(:)  = PseudoCond(:)
         ipik       = QualePseudo
      endif
!
      InfoOK(19) = 1
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PutGetXyzs(iAction, interp)
!--ex frm15/sfl15
      USE General
      USE Atomi
      USE Molcom
      USE PhaseModule
!
      implicit none
      integer :: iAction, interp, i, j, nconn
!
      if (iAction == 1) then
          preamb15(1) = errem
          preamb15(2) = biso
          preamb15(3) = oscale
          preamb15(4) = numbrun
          preamb15(5) = interp
          preamb15(6) = maxcyc
          preamb15(7) = jrest
!
          nats15 = nats
          do i=1,nats
             nz15(i)     = nz(i)
             bfac15(i)   = bfac(i)
             aLab15(i)   = aLab(i)
             serial15(i) = serial(i)
             do j=1,5
                xyz15(j,i) = xyzs(j,i)
             enddo
          enddo
!
          do i=1,3
             do j=1,3
                BTot15(j,i) = BTot(j,i)
             enddo
          enddo
!
!-- connectivity
!
          if (interp == 1) then
              nconn=iconn(1)
              do i=1,nconn*3+1
                 iconn15(i) = iconn(i)
              enddo
          endif
          InfoOK(15) = 1
      else
          errem  =      preamb15(1)
          biso   =      preamb15(2)
          oscale =      preamb15(3)
          numbrun= nint(preamb15(4))
          interp = nint(preamb15(5))
          maxcyc = nint(preamb15(6))
          jrest  = nint(preamb15(7))
!
          nats = nats15
          NatMol = nats
          do i=1,nats
             nz(i)     = nz15(i)
             bfac(i)   = bfac15(i)
             aLab(i)   = aLab15(i)
             serial(i) = serial15(i)
             do j=1,5
                xyzs(j,i)     = xyz15(j,i)
             enddo
          enddo
          do i=1, NatMol + NatSpi
             iOrd(i) = i
          enddo
!
          do i=1,3
             do j=1,3
                BTot(j,i) = BTot15(j,i)
             enddo
          enddo
!
!-- connectivity
!
          if (interp.eq.1) then
              nconn=iconn15(1)
              do i=1,nconn*3+1
                 iconn(i)=iconn15(i)
              enddo
!
*gl*          call RotazTot
!
          endif
          if (nats > 0) then
              InfoOK(15) = 1
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SaveRestoreXyzs(iAction)
!-- ex cp1530/cp3015
      USE General
      USE Atomi
      implicit none
      integer :: iAction, i, j, interp, nconn
!
      if (iAction == 1) then
          preamb30(1) = preamb15(1)
          preamb30(2) = preamb15(2)
          preamb30(3) = preamb15(3)
          preamb30(4) = preamb15(4)
          preamb30(5) = preamb15(5)
          preamb30(6) = preamb15(6)
          preamb30(7) = preamb15(7)
!
          nats30      = nats15
          do i=1,nats15
             nz30(i)     = nz15(i)
             bfac30(i)   = bfac15(i)
             aLab30(i)   = aLab15(i)
             serial30(i) = serial15(i)
             do j=1,5
                xyz30(j,i)     = xyz15(j,i)
             enddo
          enddo
!
          do i=1,3
             do j=1,3
                BTot30(j,i) = BTot15(j,i)
             enddo
          enddo
!
!-- connectivity
!
          interp = nint(preamb15(5))
          if (interp.eq.1) then
              iconn30(:) = iconn15(:)
          endif
!
          InfoOK(30) = 1
      else
          preamb15(1) = preamb30(1)
          preamb15(2) = preamb30(2)
          preamb15(3) = preamb30(3)
          preamb15(4) = preamb30(4)
          preamb15(5) = preamb30(5)
          preamb15(6) = preamb30(6)
          preamb15(7) = preamb30(7)
!
          nats15 = nats30
          do i=1,nats15
             nz15(i)     = nz30(i)
             bfac15(i)   = bfac30(i)
             aLab15(i)   = aLab30(i)
             serial15(i) = serial30(i)
             do j=1,5
                xyz15(j,i)     = xyz30(j,i)
             enddo
          enddo
!
          do i=1,3
             do j=1,3
                BTot15(j,i) = BTot30(j,i)
             enddo
          enddo
!
!-- connectivity
!
          interp = nint(preamb15(5))
          if (interp.eq.1) then
              nconn=iconn30(1)
              do i=1,nconn*3+1
                 iconn15(i)=iconn30(i)
              enddo
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PutGetBackUpXyzs(iAction)
c-- ex cp1532/cp3215 (save/restore list 15 in list 32)
!-- list 32, coordinates of the fragments ( backup list )
!
      USE General
      USE Atomi, only : nats, MaxAtoms

      USE RemoModule
      USE PhaseModule                        ! gianluca 03/02/2011
!gl!  USE VLDmod, only : erreBestVLD      ! gianluca 03/02/2011
!
      implicit none
      integer :: iAction, interp, numbrunSav ! gianluca 03/02/2011
!
!gl!  write(6,'(a,2x,f8.2)') 'erreBestVLD',erreBestVLD*100.0
      if (iAction == 1) then
          WhichModel = WhichModel + 1
          natsInModel(WhichModel) = MaxAtoms ! nats   ! gianluca 10/08/2011
          call PutModel()
          natsInModel(WhichModel) = nats
          WhichModel = WhichModel - 1
          InfoOK(32) = 1
      else
          numbrunSav = numbrun               ! gianluca 03/02/2011
          WhichModel = WhichModel + 1
          call GetModel()
          if (ifVLD == 1 .and. numbrunSav /= numbrun) then !gianluca 03/02/2011
!-- caso in cui, nel VLD, per un trial non entra mai in dlsq
              numbrun = numbrunSav           !gianluca 03/02/2011
              errem = 9999                   !gianluca 03/02/2011
          endif                              !gianluca 03/02/2011
          WhichModel = WhichModel - 1
          interp =  1
          call PutGetXyzs(1, interp)
          InfoOK(15) = 1
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GetBackXyzo(natsTmp,numset,interp)
!-- ex sfl30
      USE Atomi
!
      implicit none
      integer :: natsTmp, i, j
!-- ma a che servono ?
      integer :: numset, interp, maxcyc, jrest
      real    :: errem, biso, oscale
!
      errem  =      preamb15(1)
      biso   =      preamb15(2)
      oscale =      preamb15(3)
      numset = nint(preamb15(4))
      interp = nint(preamb15(5))
      maxcyc = nint(preamb15(6))
      jrest  = nint(preamb15(7))
c
      natsTmp = nats30
      do i=1,natsTmp
         nzo(i)     = nz30(i)
         bSav(i)    = bfac30(i)
         aLabOld(i) = aLab30(i)
         do j=1,5
           xyzo(j,i)= xyz30(j,i)
         enddo
      enddo
!
      return
      end
!-----------------------------------------------------------------------
code for xfrm35
      subroutine xfrm35
c--form list 35 from list 5
      USE RemoModule
!
      natsInModel(2) = natsInModel(1)
      k = WhichModel
      WhichModel = 2
      call PutModel
      WhichModel = k
!
      return
      end
!-----------------------------------------------------------------------
      subroutine xrst05
c--form list 35 from list 5
      USE RemoModule
!
      natsInModel(1) = natsInModel(2)
      WhichModel = 2
      call GetModel
      WhichModel = 1
      call PutModel
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Save_Restore_Modello_Publ(iAct)
c--salva/ripristina atomic parameters of a model
c  iAct = 1 Save
c       = 2 Restore
c--from sir vectors
c             real, allocatable    :: coordPub(:,:)
c             integer, allocatable :: nzPub(:)
c             integer              :: nCoordPub
c             character(len=16) , allocatable :: aLabPub(:)
c
      USE General
      USE TestModel
!
!--- DA COMPLETARE
      if (iAct.eq.1) then
          InfoOK(45) = 1
      else
      endif
!
      return
      end
!-----------------------------------------------------------------------
