!---------------------------------------------------------------------
c     prepare coordinate file to use in other programs
c           output code(jout)          meaning
c                        0             standard shelx output
c                        1             standard crystals output
c
      subroutine export(ier,ksubr)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Molcom
      USE Html
      USE PhaseModule
      USE PhaseInterface
      USE Direttive
      USE VLDmod, only : nPreviousTrials
      USE model_util
!
      common /dd/ a2,b2,c2,ab,ac,bc,bterm,wscale
      common /LoopC/ Loop
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
      character nomeFile*80
      character*11 StringaErre
      dimension vett(18),ivett(18)
      equivalence (vett(1),ivett(1))
!
      istat2 = 0
      if (ifRecovered == 0) then
          call MiglioriErre(10)
      endif
*     if (TotalScan > 0 .and. nScan == TotalScan) then
*         nBestModels = nBestModels * TotalScan
*     endif
!
      if (ksize <= 3 .and. nolsq /= 0 .and. kfast > -1) then
          if (TotalScan == 0 .or. nScan == TotalScan) then
              nBestModels = nummodels(BestModels)
              call MiglioriErre(4)
              if (nBestModels > 0) then
                  rfac = errem * 100.0
                  write(Msg,10) rfac,numbrun
                  call OneBlankOnly(Msg)
                  call MiglioriErre(2)    ! gianluca 18/02/2015
                  call PutModel           ! gianluca 18/02/2015
              else
                  Msg = 'No structural model available'
                  InfoOK(15) = 0
              endif
              call PrintMess(Msg)
          endif
      endif
!
      if (kmad /= 0) then
          nats = 0
          return
      endif
      if (InfoOK(15) == 0) then
          nats = 0
          return
      endif
      if (ifVLD == 0) then
          call GetModel()
      else
          if (InfoOK(15) == 1) then
              call GetModel()
          elseif(nSetsFineDSR > 0 .and. jscreen == 0) then
              call exportVLD
          endif
      endif
!
! dedi: da controllare la seguente istruzione 
      if (ifResBias == 1) nolsq = -1   ! dedi per fare DLSQ su piccole con resol. bias
c     if (ksize <= 3 .and. LowRes == 1) nolsq = -1   ! dedi per grafica
c
      kcompl = 0
      igraph = 0
c
      if (icomat.eq.1.and.jscreen.eq.0) then
          call RoutineHeader('Export')
      endif
c
      erremsav = errem
      if (nats == 0) then
          if (InfoOK(5) == 0) then
              write(Msg,20)
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
              ier = -1
              return
          endif
      endif
!
   20 format('No coordinates available')
!
      call AllocaRiflessi(1)
      ksubr = 4
      call LeggiRiflessi(ier,ksubr)
!--
!gl!
          lixx = InfoOK(6)
!gl!
      if (lixx.gt.0) then
c          call LoadReflInfo
          if (ifReduced.eq.1) then
              nreflDim = nrefltot * nsymTrue
          else
              nreflDim = nrefltot
          endif
          bterm=bt
          wscale=sc
       else
          errem =0.0
       endif
  30  format(/,' *** error *** No reflections in direct access file',/)
!
      StringaErre = ' n.a.  '
      errem = erremsav
      rfac=errem*100.0
      if (rfac > 0.0) then
          if (nolsq /= 0) then
              if (errem.gt.9998) then
                  StringaErre = ' n.a.  '
              else
                  write(StringaErre,'(f10.2,1h%)') errem * 100.
              endif
              if (ifVLD == 0 .and. knw == 1) then 
                  if (ifResBias < 1) then
                     write(lo,35) StringaErre,numbLSQFinal,
     *                                        WhichBlock,ntrSv,nFour
                  else
                     write(lo,35) StringaErre,numbLSQFinal,
     *                                        WhichBlock,ntrSv,nBias
                  endif
              else
                write(lo,34) StringaErre,numbLSQFinal
              endif
          else
              write(StringaErre,'(f10.2,1h%)') errem * 100.
          endif
      endif
      call CPUTime(' ', 0)
      HTMLcpu = Inte(1:Lung(Inte)) 
      HTMLstr = ' '
      call AbInfo(3)
      write(HTMLstr,36) StringaErre, numbLSQFinal
      call AbInfo(3)
      HTMLstr = ' '
      write(Msg,38) StringaErre, numbrun
      call OneBlankOnly(Msg)
      call PrintMess(Msg)
!
!-- if m.s.c. environment ..........(kenvir = 2)
!-- if enraf-nonius environment ....(kenvir = 1)
!
      if (jscreen == 0 .and. nBestModels == 0) then
!
          nomeFile = fname(3)
          itype=0
          iform=1
          jop=jopen(jhost,nomeFile,itype,iform,ierr)
          if (jop.lt.0) go to 9000
!
          if (kenvir.ne.0) then
              if (kenvir.eq.1) then
                  call outenr
                  write(lo,80) fname(3)(1:Lung(fname(3)))
              endif
              if (kenvir.eq.2) then
                  call outmsc
                  write(lo,85) fname(3)(1:Lung(fname(3)))
              endif
          else
              write(lo,40)
              if (jout.eq.0) then
                  call outShelx(0)
                  write(lo,70) fname(3)(1:Lung(fname(3)))
              else
                  call outcry(kcompl)
                  write(lo,75) fname(3)(1:Lung(fname(3)))
              endif
              close(jhost)
              nomeFile = fname(4)
              itype=0
              iform=1
              jop=jopen(jhost,nomeFile,itype,iform,ierr)
              if (jop.lt.0) go to 9000
              if (igraph.eq.1) then
                  write(lo,50) fname(4)(1:Lung(fname(4)))
                  call outmold
              endif
              if (igraph.eq.2) then
                  write(lo,60) fname(4)(1:Lung(fname(4)))
                  call outsha
              endif
              if (igraph.eq.4) then
                  write(lo,68) fname(4)(1:Lung(fname(4)))
                  call outxyz
              endif
              close(jhost)
          endif
      endif
!
      kplo = iPlotType
      ifSingle = 0
      call MolPlo(kplo, ifSingle)
!
      if (TotalScan > 0) then
          if (nScan < TotalScan) then
              call AllocaRiflessi(2)
              InfoOK(8) = 0
              call CloseAllViewers()
              ksize = 0
              nPreviousTrials = 0
              call CPUTime0(' ')
          endif
      endif
      return
!
   10 format(' Final R% = ',f7.2,' in trial ',i9)
   34 format(//,' Final R value is ',a11,' using ',i6,' reflections',/)     !pgVLD
   35 format(//,' Final R value is ',a11,' using ',i6,' reflections',/,
     *  ' (Block ',i2,', Set ',i3,',  # of LSQ Refinement ',i5,')')
   36 format(' Final R value is ',a11,' using ',i6,' reflections')
   37 format(//,' Final R value is ',a11,' using ',i6,' reflections',/,
     *  ' (Block ',i2,', Set ',i3,',  # of Set Explored ',i5,')')
   38 format(' Final R value is ',a11,' in trial ',i6)
   40 format(///,'   Atoms informations files produced:',//,
     *           '   Format        File Name ',/)
   50 format(    '   MOLDRAW       ',a)
   60 format(    '   SCHAKAL       ',a)
   68 format(    '   Cartesian     ',a)
   70 format(    '   SHELX         ',a)
   75 format(    '   CRYSTALS      ',a)
   80 format(    '   MolEN         ',a)
   85 format(    '   TeXan         ',a)
 9000 write(lo,9010) ierr, nomeFile
 9010 format(' *** error ***  open error, code =',i5,' file is ',a)
      end
!---------------------------------------------------------------------
      subroutine importa(filnam, dirnam, iAction, ier)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE RemoModule
      USE Properties
      USE importexport
      USE connect_mod
      USE sinterface
      USE proginterface, only:nk_to_elem
      USE spginfom
!
!     filnam = nome del frammento o file da importare
!     dirnam = directory in cui si trova il file
!     iAction = 20 --> sir fragment
!             = 21 --> caos fragment
!             = 22 --> shelx file
!             = 23 --> PDB file
!             = 24 --> CIF file
!             = 25 --> z-matrix fragment
!             = 26 --> mop fragment
!             = 27 --> mol fragment
!             = 28 --> mol2 fragment
!
!
      integer :: jumpData, nstrData, negF
      real    :: btData, enData
      common /DataToNormal/ jumpData, btData, nstrData, enData, negF
      integer :: trasforma, found, key(10)
      real    :: nwTmp(18), xo(11), xn(11)
      logical :: make_conn
      character (len=*)   :: filnam, dirnam
      character (len=80)  :: formt
      character (len=256) :: filenam
      type(atom_type), allocatable, dimension(:) :: atom
      type(bond_type), allocatable, dimension(:) :: legm
!--
!
      interface
         subroutine MiglioriErre(iAction, trial, trialv, erreV, str)
         USE General, only: MyStringa
           integer   :: iAction
           type(MyStringa), optional  :: str(*)
           integer, optional :: trial
           integer, optional :: trialv(*)
           real, optional    :: erreV(*)
        end subroutine MiglioriErre
       end interface
!
      if (InfoOK(3) /= 0) then
          WhichProps = WhichProps + 1
      endif
!
      trasforma = 0
      numbModels = 1
      ifRefl = 0
      icomat   = 1
      jumpData = -1
      ifo2 = 2
      ier = 0
      istat2=0
c
      do i=1,3
         do j=1,3
            BTot(i,j)=101.0
         enddo
      enddo
!
      filenam = dirnam(1:Lung(dirnam)) // filnam(1:Lung(filnam))
      itype=2
      iform=1
      if (jopen(jhost,filenam,itype,iform,ios).lt.0) go to 9500
!

      Msg = 'Imported file: ' // filenam(1:Lung(filenam))
      call PrintMess(Msg)
      call toflush()
!
      if (iAction >= 25 .and. iAction <= 28) then
          call AllocaAtomi(1)
      endif
      if (iAction.eq.20) then
          jpfile = jhost
          call getplt(0, 0, ier)
!!!!corr-set celem
          call nk_to_elem(celem)
!!!!corr
      elseif (iAction.eq.21) then
          call ManageCaosSir(ifRefl,0,ier)
!!!!corr-set celem
          call nk_to_elem(celem)
!!!!corr
      elseif (iAction.eq.22) then
          call ManageShelxSir(ifRefl, 0, nwTmp, ier)
          call ManageSymmCards(ier)
          call FromSymmCardsToSpaceGroupSymbol(found)
          if (found == 1) then
              call CreaSymmetryInfo(ier)
          endif
          WhichModel = 1
          BondsInModel(WhichModel) = 0
!!!!corr-set celem and space group
          call nk_to_elem(celem)
          spacegr = init_spaceg_type(spaceg_string())
!!!!corr
*         call LeggiShelx(ifRefl, 0, ier)
      elseif (iAction.eq.23) then
          call AllocaAtomi(2)
          call ManagePDBSir(1, 1, 1, 0, 0, ier)
          WhichModel = 1
          BondsInModel(WhichModel) = 0
!!!!corr-set celem and space group
          call nk_to_elem(celem)
          spacegr = init_spaceg_type(spaceg_string())
!!!!corr
      elseif (iAction.eq.24) then
          if (InfoOK(3) == 1) then
              vSpecie = Species
          endif
          call LeggiCIF(ifRefl, 0, ier)
          WhichModel = 1
          BondsInModel(WhichModel) = 0
          natsInModel(:) = nats
!!!!corr-set celem and space group
          call nk_to_elem(celem)
          spacegr = init_spaceg_type(spaceg_string())
!!!!corr
      elseif (iAction.eq.25) then
          if (InfoOK(1) == 0) then
              cell(1:6) = (/ 1, 1, 1, 90, 90, 90 /)
              trasforma = 1
          else
              trasforma = 0
          endif
          close(jhost)
          call import_structure
     *         (filenam,ZMT_FILE,atom,legm,.false.,ier)
      elseif (iAction.eq.26) then
          close(jhost)
          call import_structure
     *         (filenam,MOP_FILE,atom,legm,.false.,ier)
      elseif (iAction.eq.27) then
          make_conn = .false.
          close(jhost)
          call import_structure
     *         (filenam,MOL_FILE,atom,legm,.false.,ier)
      elseif (iAction.eq.28) then
          make_conn = .false.
          close(jhost)
          call import_structure
     *         (filenam,MOL2_FILE,atom,legm,.false.,ier)
      endif
      if ((iAction >= 25 .and. iAction <= 28) .and. ier == 0) then
          WhichModel = 1
          call update_model(atom,legm)
          call bond_to_iconn(legm,iconn)
          call PutModel
      endif
      if (nats <= 0) then
          ier = -1
          Msg = 'No coordinates in file ' // filenam(1:Lung(filenam))
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      endif
      if (ier.lt.0) then
          Msg = 'Error importing the file ' // filenam(1:Lung(filenam))
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      else
!
!-- check if some information is missing
!
        call SetWindowTitle(Titolo)
        if (InfoOK(2).eq.0) then
            jj = InfoOK(1)
            call Get_1_2(jj, ier)
            if (ier == 0) then
                write(lo,10) nsym
            else
                return
            endif
        endif
!
        if (iAction >= 25 .and. iAction <= 28) then
            call PutModelInCell(trasforma)
        endif
!
        if (InfoOK(3).eq.0) then
            call Get_3(iAction)
        else
            if (sum(nw(1:nk)) == 0) then
                nw(1:18) = nint(nwTmp(1:18) * totop)
                nat = 0
                do i=1, nk
                   if (AtmProperties(WhichProps)%z(i) > 1) then
                       nat = nat + nw(i)
                   endif
                enddo
                AtmProperties(WhichProps)%natsInCell(1:18) = nw(1:18)
                AtmProperties(WhichProps)%nat = nat
            endif
        endif
!
        model(WhichModel)%SinglePlotType(:) = iPlotType
        call GetModel()
        InfoOK(5) = 1
!
        jspini = -1
        if (ifLaue == -1) then
            call xspinb
        endif
        if (iAction.eq.19) then
!            iconn(1) = -9999 
            nco= iconn(1)         
            iactn=1
            do j=1,nats
               xo(1)=xyzs(1,j)
               xo(2)=xyzs(2,j)
               xo(3)=xyzs(3,j)
               itype = nalf( iabs(nz(j)/nzConst) )
               iser=j
               iactn=1
               khead=0
               ksp=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
               xyzs(5,j) = 1.0/float(key(10))
            enddo
            call PutModel
        endif
        lixx = InfoOK(5)
c--fine atoms updating
         if (neutro < 0 .or. neutro > 2) neutro = 0
         call WriteContInfo(npq,ier)
*gl*     call ScriviFrammento
         lixx = InfoOK(6)
         if (lixx.gt.0) then
               call LoadReflInfo
               leggi = 0
               iOK = 1       ! RS 29.03.10
         else
               leggi = 1
               if (ifRefl == 1) then
                   listRefl = 10
                   nzro = maxpsi
                   call LeggiHklImported(ier)
                   if (ier == 0) then
                       leggi = 0
                       iOK = 1
                   endif
               endif
         endif
         if (leggi.eq.1) then
              call MsgWinErr('Missing Data','Do you need reflections ?',
     *                       QUEST_WINDOW_YES_NO, nExitCode)
              if (nExitCode.eq.1) then
                  iOK = 1
                  call GetRefl(ier)
                  if (ier == 0) then
                      write(lo,20) nreflDim
                  else
                      ier = 0
                      iOK = 0
                      Msg = 'No reflection file selected'
                      call MsgWinErr('WARNING', Msg,
     *                      ERR_WINDOW, nExitCode)
                  endif
              else
                  iOK = 0
              endif
         endif
         if (iOK.eq.1) then
               if (sc.lt.0.0) then
                   call Get_6(iAction, leggi, formt, ier)
               endif
         endif
!
*gl*     natsSav = nats
*gl*     call AllocaAtomi(2)
*gl*     nats = natsSav
*gl*     call AllocaAtomi(-1)
!-- check if the connectivity was done
         nco=iconn(1)
c        if (nco <= 0 .and. iAction /= 23) then
         if (nco <= 0 ) then
             call PrintMess('Computing connectivity. Please wait...')
             call DoSingleIteration()
             do i=1,nats
                kblock(i) = 1
             enddo
             kact=5
c--	     kact=4
             iconn(1) = -9999
             call build(kact, 2)
!
             call AggiornaCoordinateAtomi(ier)
!
             call ClearMessage
         endif
!
!-- creates Labels (only if Sir fragment) and writes List 15 
!
         BTot(1,1) = 101.0
         interp = 1
         call PutGetXyzs(1, interp)
         call ScriviFrammento()
!
         close(jhost)
!
         nBestModelsMax = 1
         call MiglioriErre(0)
         call MiglioriErre(1)
!
         QualeAbilita = 2
         call InitMolplo()
         if (iPlotType.ge.STICKS.and.iPlotType.le.ELLIPSOIDS) then
             iPlt = iPlotType
         else
             iPlt = 2
         endif
         ifSingle = 0
         call MolPlo(iPlt, ifSingle)
         ifLabels  = 0
         call reset_plot_style
         iz = 0
         call EnableSingleIteration(iz)
!
         call AbInfo(0) 
!
      endif
!
      WhichProps = 0
      call GetFromAtmStruct
!
      return
!
    1 format('Is the information to be imported from ',a,
     *       ' related to ',a,'?')
   10 format(/,' - Stored ',i2,' symmetry operators')
   20 format(/,' - Stored ',i7,' reflections')
 9500 write(Msg,9510) ios,filenam(1:Lung(filenam))
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
 9510 format(' Open error, code =',i5,' file is ',a,
     *      '. Coordinates expected')
!
      return
      end
c------------------------------------------------------------------
      subroutine Get_3(iAction)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom     
      USE PhaseModule
!
      dimension sum(18), nzpdb(18)
      dimension xo(11), xn(11), key(10)
      character (len=4) :: SpeciesTmp(18)
!
      nk = 0
      do i=1,18
         if (nSpecie(i) < 0.001) then
             vSpecie(i) = '  '
         else
             nk = nk + 1
         endif
!gl!     read(vSpecie(i),'(a4)') nalf(i)
         nw(i) = 0  ! trovare il num.nella cella (occ*nsymTot)
         sum(i) = 0
      enddo
      jspini = -1
      call xspinb
      iactn = 1
      khead = 0
      do i=1,nats
         xo(1:3) = xyzs(1:3,i)
         j     = iabs(nz(i)/nzConst)
         itype = nalf( j )
         iser=i
         ksp=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
         xyzs(5,i) = 1.0/float(key(10))
         sum(j) = sum(j) + nsymTot * xyzs(5,i)
      enddo
      do i=1,nk
         nw(i) = nint(sum(i))
      enddo
! 
      Species(1:nk) = vSpecie(1:nk)
      SpeciesTmp(1:nk) = vSpecie(1:nk)
      wavel = 0.71073
      call CreaAtmPropInfo(WhichProps, ier)
      call GetFromAtmStruct
!gl!  call yfrm03(wavel,ier)
!gl!  if (ier.ge.0) call yfl03
      if (iAction == 23 .or. iAction == 20) then    ! sincronizzare nz
!gl!      do i=1,nk
!gl!         write(Species(i),'(a4)') nalf(i)
!gl!      enddo
          Species(1:nk) = SpeciesTmp(1:nk)
          do i=1,nats
             izz = nz(i) / nzConst
             do j=1,nk
                if (vSpecie(izz).eq.Species(j)) then
                    jzz = j
                endif
             enddo
             nz(i) = jzz * nzConst
          enddo
      endif
      anat=float(nat)/(pts*float((icent+1)*nsym))
!
      call DefineSize()
!
      if (iAction == 20) then
          iniz = 1
          ifin = nats
          call MakeLab(iniz,ifin)
          call PrintMess('Computing connectivity. Please wait...')
          call DoSingleIteration()
          do i=1,nats
             kblock(i) = 1
          enddo
          kact=5
          iconn(1) = -9999
          call build(kact, 2)
          call PutModel
      endif
!
      return
      end
c------------------------------------------------------------------
      subroutine PutModelInCell(trasforma)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
!
      implicit none
      integer :: i, itype, iser, iactn, khead, ksp, kspecb, key(10)
      integer :: ier, trasforma
      real    :: x1(3), x2(3), x1_1(11), x2_1(11)
!
      call Orto(cell)
!
      do i=1, nk
         nw(i) = nw(i) * totop
      enddo
      WhichProps = 0
      ier = 0
      if (InfoOK(3) == 0) then
          call CreaAtmPropInfo(WhichProps, ier)
          call GetFromAtmStruct
      endif
!
      x1_1(:) = 0.0
      x2_1(:) = 0.0
      do i=1, nats
         if (trasforma == 1) then
             x1(1:3) = xyzs(1:3,i)
             call MoltMatVec(rmi, x1, x2)
             xyzs(1:3,i) = x2(1:3)
         endif
!
         x1_1(1:3) = x1(1:3)
         x2_1(1:3) = x2(1:3)
!
         itype = 0 !nalf( iabs(nz(j)/nzConst) )
         iser  = i
         iactn = 1
         khead = 0
         ksp =kspecb(newvet, x2_1, x1_1, key, itype, iser, khead, iactn)
         xyzs(5,i) = 1.0 / float(key(10))
         xyzs(4,i) = xyzs(4,i)  / nzConst
      enddo
!
      call PutModel
!
      return
      end
c------------------------------------------------------------------
      subroutine Get_6(iAction, leggi, formt, ier)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom     
      USE PhaseModule
!
      character*(*) formt
      character name
!
!-- calculate number of reflexions for (sem)invariant searching
!
      mn = int(4.5*anat+100.5)
      if (nsym.eq.1) then
          mn = mn + 50
      endif
      nstr = min0(mn,maxstr)
      nstr=mn+min0(maxstr-mn,100)/2
      if (leggi == 1) then
          itype = 2
          iform = 1
          iop = jopen(jfile,ReflFileName,itype,iform,ios)
          if (iop.lt.0) then
              call MsgWinErr('ERROR', 'Reflection file?', 
     *                        ERR_WINDOW, nExitCode)
          else
              close(jfile)
          endif
!
          call scrper(' Reading data ',0,-1)
!
!-- read reflexion data from cards
          itype=1
          iform=2
          kop=kopen(iscra,name,nlenBin,itype,ierr)
          ier = 0
          nPerCard = -1
          th      = 99999999
          ifGener = -1
c          ifo2    = 2    !  CONTROLLARE!! LeggiShelx lo ha gia' definito
          ksigma  = 1
          nzro    = maxpsi
          call datain(formt,nrefp,ier,npq)
          if (ier.eq.0) then
!--create list 6 ( reflections )
              call CreaRiflessiNew(npq)
              InfoOK(6) = 1
          endif
          close(iscra)
      endif
!
      if (InfoOK(6).eq.1) then
          call CheckGrid()
          nreflDim = nrefltot
          call AllocaRiflessi(1)
          jscreenSav = jscreen
**        jscreen    = 3
          ifMercedes = 0
          call norm2000(ifMercedes, ier)
          jscreen = jscreenSav
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ScriviFrammento()
      USE General
      USE Symmetry
      USE Atomi
      USE PhaseModule
!
      implicit none
      integer :: j, jj, k, dividi, L, Lung
      real    :: ottopi2, uiso
      character (len=4) :: diret
!
      if (iabs(nz(1)) >= nzConst) then
          dividi = nzConst
      else
          dividi = 1
      endif
      ottopi2 = 8.0 * pi * pi
      write(lo,100) nats, nsymTot
      do j=1,nats
         k = nz(j) / dividi
         if (k > 0) then
             diret = Species(k)
         else
             diret = 'q'
         endif
         call ucase(diret(1:1))
         uiso = bfac(j) / ottopi2
         write(lo,200) aLab(j),diret,(xyzs(jj,j),jj=1,3),
     *                          xyzs(5,j),bfac(j),uiso
      enddo
      write(lo,250)
      if (erre > 0.01) then
          if (numbgen == 0) then
              Msg = ' '
              write(Inte,300) erre*100, nrefl
              call OneBlankOnly(Inte)
              L = Lung(Inte)
              Msg(6:) = Inte(1:L)         
              Msg(3:3) = 'I' ; Msg(76:76) = 'I'
              write(lo,'(a)') Msg(1:76)
          else
              Msg = ' '
              write(Inte,350) erre*100, nrefl
              call OneBlankOnly(Inte)
              L = Lung(Inte)
              Msg(6:) = Inte(1:L)         
              Msg(3:3) = 'I' ; Msg(76:76) = 'I'
              write(lo,'(a)') Msg(1:76)
              Msg = ' '
              write(Inte,360) numbGen
              call OneBlankOnly(Inte)
              L = Lung(Inte)
              Msg(6:) = Inte(1:L)         
              Msg(3:3) = 'I' ; Msg(76:76) = 'I'
              write(lo,'(a)') Msg(1:76)
          endif
      endif
      write(lo,400)
!
  100 format(//,2x,'+',72('-'),'+',/,2x,'I',2x,
     * 'Fragment : known positions for',i5,
     1 '  atoms. Multiplicity =',i5,7x,'I',/,2x,
     2 'I',72x,'I',/,2x,'I',2x,
     3 'Label',4x,'Type',4x,'X',8x,'Y',8x,'Z',6x,'Occ',6x,'B(iso)',3x,
     4 'U(iso)',4x,'I',/,2x,'I',72x,'I')
  200 format(2x,'I',2x,a8,2x,a4,f7.4,5f9.4,4x,'I')
  250 format(2x,'I',72x,'I')
  300 format('Structure Factor Calculation R% =',f7.2,' using',i10,
     *       ' reflections')
  350 format('Structure Factor Calculation R% =',f7.2,' using',i10,
     *       ' observed')
  360 format(' + ',i10,' generated reflections')
  400 format(2x,'+',72('-'),'+')
!
      return
      end
!-----------------------------------------------------------------------
!               Z-Matrix general routines
!-----------------------------------------------------------------------
      subroutine ManageZMatrixSir(icodZ, inMemoryOnly, ier)
c--read file
c**Z-matrix format**
c
      USE General
      USE Symmetry
      USE Atomi
      USE PhaseModule
      USE RemoModule
!
      implicit none
      integer :: i, j, k, ier, icodZ, nt(16)
      integer :: itipo, iform, jop, jopen, ierr, nzS, nbonds
      integer :: inMemoryOnly
      integer :: n, Lung, natsSav
      real    :: celltemp(13), x1(3), x2(3)
      real    :: uij(6)
      character (len=4) :: SpeciesTmp(18)
      real    :: xwave(2), wave
      character*4 iwave(2)
      data iwave /'mo  ','cu  '/
      data xwave/0.71073,1.54178/
!
      SpeciesTmp(:) = Species(:)
      if (inMemoryOnly == 0) then
          write(lo,10)
      endif
      call LeggiZMatrixinMem(icodZ, celltemp, nt,nats, ier)
!
      if (InfoOK(1) == 0) then
          call CreaCellInfo(celltemp)
          write(lo,2032)
2032      format(/,' - Stored cell parameters')
      endif
!      
!--inserisce G.S. P 1
      if (InfoOK(2) == 0) then
          nSpaceG=nt
          call ti1983(nSpaceG)
          call CreaSymmetryInfo(ier)
          write(lo,1012)
1012      format(' - Stored symmetry information')
      endif
!
      if (InfoOK(3) == 0) then
          WhichWave=1
          wave=xwave(WhichWave)
          wavel = wave
!!!       neutro = 0
          do i=1, nk
             nw(i) = nSpecie(i) *  nsymTot
             Species(i) = vSpecie(i)
          enddo
          call CreaAtmPropInfo(WhichProps, ier)
          vSpecie(1:18) = Species(1:18)
          if (inMemoryOnly == 0) then
              call GetFromAtmStruct
          endif
          SpeciesTmp(1:18) = Species(1:18)
          Species(1:18) = vSpecie(1:18)
          vSpecie(1:18) = SpeciesTmp(1:18)
          write(lo,1013)
1013      format(' - Stored species content information')
      else
          vSpecie(:) = SpeciesTmp(:)
      endif
!
      if (inMemoryOnly == 0) then
          WhichModel = 1
          numbModels = 1
          natsSav = nats
          call AllocaAtomi(2)
          nats = natsSav
          call AllocaAtomi(-1)
          iconn(1) = -9999
          natsInModel(WhichModel) = nats
          MonomerInModel(WhichModel) = 1
! se il file z-matrix e' relativo al file .bin esistente, si incasina
!  in questa routine...GIANLUCA, please check it!          
          call AllocaModelRemo(1)         
      else
          call AllocaModelRemo(1)
      endif
!
      rewind jgrap
      do i=1, nats
         read(jgrap) nzS,
     *               model(WhichModel)%Label(i),
     *               model(WhichModel)%atoms(1:3,i,1),
     *               model(WhichModel)%atoms(5,i,1),
     *               model(WhichModel)%th_fact(i,1)

         model(WhichModel)%atoms(4,i,1) = 100
         model(WhichModel)%specie(i,1) = nzS * nzConst
      enddo
      natsInModel(WhichModel) = nats
!
      close(jgrap)
      close(jhost)
!
      call SincronizzaSpecieRemo()
!
      do i=1, nats
         j = model(WhichModel)%specie(i,1)  / nzConst
         model(WhichModel)%atoms(4,i,1) = no(j)
      enddo
      infoOK(5) = 1
!
      return
!
9200  continue
   10 format(/,'Importing a Z-matrix file:')
      end
!-----------------------------------------------------------------------
      subroutine ManageCaosSir(ifRefl, inMemoryOnly,ier)
c--read file
c**Caos program format**
c
      USE General
      USE Symmetry
      USE Atomi
      USE PhaseModule
      USE RemoModule
!
      implicit none
      integer :: i, j, k, m, ier
      integer :: itipo, iform, jop, jopen, ierr, nzS, nbonds
      integer :: nsymTemp, lattTemp, icentTemp, inMemoryOnly
      integer :: ifRefl, n, Lung, nt(16),idiffr, imix
      real    :: celltemp(13), x1(3), x2(3)
      real    :: uij(6)
      real    :: occS(4,2)
      real    ::  wave
      real    :: atomo(14),atomo_dev(11)
      character(len=4)   :: SpecieCurr, SpecieMix(4)
      character (len=4)  :: SpeciesTmp(18)
      character (len=16) :: LabelS
!
      SpeciesTmp(:) = Species(:)
      nats = 0
!!!   neutro = 0
      if (inMemoryOnly == 0) then
          write(lo,10)
      endif
      call LeggiCaosinMem(ifRefl, celltemp,  nt, idiffr,wave, nats, ier)
*     numbModels = numbModels + 1
*     WhichModel = WhichModel + 1
*     natsInModel(WhichModel) = nats
*     MonomerInModel(WhichModel) = 1
*     call AllocaModelRemo(1)
!
      if (InfoOK(1) == 0) then
          errcell(1:7) = celltemp(7:13)
          call CreaCellInfo(celltemp) ! (1:6))
          write(lo,2032)
 2032     format(/,' - Stored cell parameters')
      endif
!      
!--inserisce G.S. P 1
      if (InfoOK(2) == 0) then
          nSpaceG=nt
          call ti1983(nSpaceG)
          call CreaSymmetryInfo(ier)
          write(lo,1012)
1012      format(' - Stored symmetry information')
      endif
!
      if (InfoOK(3) == 0) then
          wavel = wave
          neutro = idiffr-1
          do i=1, nk
             nw(i) = nSpecie(i)
             Species(i) = vSpecie(i)
          enddo
          k = WhichProps
          call CreaAtmPropInfo(k, ier)
          vSpecie(1:18) = Species(1:18)
          if (inMemoryOnly == 0) then
              call GetFromAtmStruct
          endif
          SpeciesTmp(1:18) = Species(1:18)
          Species(1:18) = vSpecie(1:18)
          vSpecie(1:18) = SpeciesTmp(1:18)
      else
          vSpecie(:) = SpeciesTmp(:)
      endif
!
!??!  call SoloCaratteriAlpha(Species, 18)
!
      if (inMemoryOnly == 0) then
          WhichModel = 1
          numbModels = 1
          call AllocaAtomi(-1)
          natsInModel(WhichModel) = nats
          MonomerInModel(WhichModel) = 1
          call AllocaModelRemo(1)
      else
          call AllocaModelRemo(1)
      endif

!
      rewind jgrap
      do i=1, nats
         read(jgrap) SpecieCurr, LabelS, atomo,  atomo_dev
         imix=nint(atomo(8)+0.001)
         if(imix.gt.0) read(jgrap) SpecieMix,occS
!--analizza i record letti         
          do n=1, nk
             if(Species(n).eq.SpecieCurr)then
                nzS=n 
                exit
             endif
          enddo
          model(WhichModel)%specie(i,1) = nzS * nzConst
          model(WhichModel)%Label(i)=LabelS
          model(WhichModel)%atoms(1:3,i,1)=atomo(2:4)
          model(WhichModel)%serial(i)=atomo(1)
          model(WhichModel)%th_fact(i,1)=atomo(5)
          model(WhichModel)%atoms(4,i,1) = 100
          model(WhichModel)%atoms(5,i,1)=atomo(6)
          model(WhichModel)%iSite(i)=imix
          model(WhichModel)%bij(1:6,i,1)=atomo(9:14)
!          
          model(WhichModel)%xyz_dev(1:3,i,1)=atomo_dev(1:3)
          model(WhichModel)%th_fact_dev(i,1)=atomo_dev(4)
          model(WhichModel)%occ_dev(i)=atomo_dev(5)
          model(WhichModel)%bij_dev(1:6,i,1)=atomo_dev(6:11)
!          
          if (atomo(5). le. 0.0) then
              model(WhichModel)%IsoAniso(i,1) = 1
          else
              model(WhichModel)%IsoAniso(i,1) = 2
          endif
          if (imix.gt.0) then
              do m=1,imix
                 do n=1,nk
                    if(Species(n).eq.SpecieMix(m))then
                       nzS=n 
                       exit
                    endif
                 enddo
                 model(WhichModel)%SiteInfo(m,i) = nzS*10 + occS(m,1) 
                 model(WhichModel)%occX_dev(m,i) =          occS(m,2)
              enddo
          endif
      enddo
!      
      natsInModel(WhichModel) = nats
!
      close(jgrap)
      close(jhost)
!
      call SincronizzaSpecieRemo()
!
      do i=1, nats
         j = model(WhichModel)%specie(i,1)  / nzConst
         model(WhichModel)%atoms(4,i,1) = no(j)
      enddo
!
      model(WhichModel)%BTot(1:3,1:3) = 101
!
      infoOK(5) = 1
!
      return
!
9200  continue
   10 format(/,'Importing a Caos file:')
      end

!-----------------------------------------------------------------------
      subroutine LeggiZMatrixinMem(icodZ, add, nt,numzm, ier)
!--ex readzmat routine
!--read file in **Z-Matrix format**
!  icodZ = 1  formato z-matrix originale
!          2  formato z-matrix generic MOP format
!          3  formato z-matrix ACD program (.mop)
!          4  formato z-matrix DASH program (.mop)
!
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom     
      USE ZMatrix
      USE PhaseModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!
      character*2 diret
      character*80  line,dire
      dimension add(13), nt(16),xx1(3),xx2(3)
      character*16 ntchar
!     
      character linea*100,linea1*100, namezmt*8
      data ntchar/'p 1'/
!
      itype = 1
      iform = 2
      jop = jopen(jgrap,'  ',itype,iform,ier)
      if (jop < 0) then
          ier = -1
          return
      endif
!
      if (bt < 0.001) then
          bt = 3.0
      endif
c
      if (InfoOK(1) == 0) then
!--inserisce valori della cella unitaria
	    add(1)=1.0
	    add(2)=1.0
	    add(3)=1.0
          do i=4,6
             add(i)=90
          enddo
          xorti(:,:)=0.0
          do i=1,3
             xorti(i,i)=1.0
          enddo
      endif
!--stringa del G.S. P 1      
      if (InfoOK(2) == 0) read(ntchar,'(16a1)') nt
!--azzero variabili      
      jserZ(:) = 0
      bisoZ(:) = 0.0
      occZ(:)  = 0.0
      nSpec = 0
      nSpecie(:) = 0
!      
!--selezione tipo di file input
      select case (icodZ)
!      
!--format originale SIR      
        case (1)      
c--read name and No. of atoms
           read(jhost,'(a4,i5)')namezmt,numzm
c--read atoms in z-matrix format
           do i=1,numzm
              read(jhost,'(i5,2x,a8,2x,a4,4x,3f10.3,3i5)') iloc(i),
     2        atfra(i),ispefra(i),(xloc(n,i),n=1,3),(nloc(n,i),n=1,3)
              write(lo ,'(i5,2x,a8,2x,a4,4x,3f10.3,3i5)') iloc(i),
     2        atfra(i),ispefra(i),(xloc(n,i),n=1,3),(nloc(n,i),n=1,3)
              write(dire,'(a4)') ispefra(i)
              bisoZ(i)= bt
              occZ(i)= 1.0
              jserZ(i)=i 
!
              call AnalysisSpecies(nSpec,izz,dire,ier)
!	   
           enddo 
!      
!-- generic MOP format
        case (2)
           call LeggiMOP(nSpec,numzm, ier)
!           
!-- programma (ACD)
        case (3)
!-- read the first 3 line
           do i=1,3
              read(jhost,'(a)',end=1010) linea
           enddo
           namezmt='ACD'
           i=1
1000       continue 
           read(jhost,'(a)',end=1010) linea  
           linea1=linea
           call shift(linea1,len)
           if(len.le.0) goto 1000  
           call lcase(linea)
           read(linea,'(2x,a2,3(f12.4,6x),3i6)') 
     2          ispefra(i),(xloc(n,i),n=1,3),(nloc(n,i),n=1,3)
           iloc(i) = i
           write(dire,'(a4)') ispefra(i)
           a=i
           call nomev2New(dire,a,atfra(i))
           write(lo ,'(i5,2x,a8,2x,a4,4x,3f10.3,3i5)') iloc(i),atfra(i),
     2           ispefra(i),(xloc(n,i),n=1,3),(nloc(n,i),n=1,3)
           bisoZ(i)= bt
           occZ(i)= 1.0 
           jserZ(i)=i 
! 
           call AnalysisSpecies(nSpec,izz,dire,ier)
!          
           i=i+1
           goto 1000
1010       continue  
           numzm=i-1  
!        
!-- programma (DASH)
        case (4)
!-- read the first 2 line
           do i=1,2
              read(jhost,'(a)') linea
           enddo
           namezmt='ToolKit'
           read(jhost,'(i4)') numzm 
           do i=1,numzm
              read(jhost,'(a)') linea  
              call lcase(linea)
              read(linea,'(2x,a2,1x,3(f13.7,3x),3i5,2f5.1,i5)') 
     2             ispefra(i),(xloc(n,i),n=1,3),
     3             (nloc(n,i),n=1,3),bisoZ(i),occZ(i),jserZ(i)
              iloc(i)=i
              a=jserZ(i)
              write(dire,'(a4)') ispefra(i)
              call nomev2New(dire,a,atfra(i))
              write(lo ,'(i5,2x,a8,2x,a4,4x,3f10.3,3i5,2f5.1)') 
     2             iloc(i),atfra(i),ispefra(i),(xloc(n,i),n=1,3),    
     3             (nloc(n,i),n=1,3),bisoZ(i),occZ(i),jserZ(i)
!
              call AnalysisSpecies(nSpec,izz,dire,ier)
!	         
           enddo         
      end select
!           
!--fine input file        
      write(lo,'(a,i5,a)')' - Read',numzm,' atoms from Zmatrix fragment'
!--setto no. specie atomiche , se il contenuto non e' gia' presente      
      if (InfoOK(3) == 0) then
          nk=nSpec
      endif
!	   
!--calcolo coordinate ortogonali dal formato z-matrix 
      nzm=numzm
      call zmatr_new(ier)
      do i=1, nzm
         xx1(1:3)=xortolocal(1:3,i)
!--se si prevede di fornire la cella cristallina, 
!  le coordinate ortogonali vanno moltiplicate per la matrice inversa di 
!  ortogonalizzazione......          
c--moltiplico per la matrice di ortogonalizzazione inversa xorti(i,j)
         call moltv(xorti,xx1,xx2)
	   write(dire,'(a4)') ispefra(i)
!--setta il no. d'ordine della specie chimica	   
         if (InfoOK(3) == 0) then
 	      do j=1,nSpec
               if (vSpecie(j).eq.dire(1:2)) then
                   izz = j
                   exit
               endif
            enddo
         else
            do j=1,nk
               if (nalf(j).eq.ispefra(i)) then
                   izz = j
                   exit
               endif
           enddo
         endif    
!--scrive su file temporaneo jgrap 
!         write(lo,'(i5,1x,a8,3f10.4,2f10.2)')
!     *    izz, atfra(i), xx2(1:3), occZ(i),bisoZ(i)                 
         write(jgrap) izz, atfra(i), xx2(1:3), occZ(i),bisoZ(i)
!         
      enddo
!
      return
9000  continue
      write(ncwu,*)' Error!'
      ier=1
      return
      end
!-----------------------------------------------------------------------
      subroutine LeggiMOP(nSpec, numzm, ier)
      USE General
      USE Atomi
      USE ZMatrix
!
!      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
!
!
!-- skip first 3 lines
      do j=1, 3
         read(jhost,'(a)',end=1010) buffer_ctrl_M
      enddo
!
      i = 0
      do
         read(jhost,'(a)',err=1010, end=100) buffer_ctrl_M
         call filtra(buffer_ctrl_M)
         call shift(buffer_ctrl_M, k)
         if (k <= 1) cycle
         call lcase(buffer_ctrl_M)
         i = i + 1
!
!-- extract species
!
         call cutst(buffer_ctrl_M,lenp,Inte,lend)
!
         a=i
         call nomev2New(Inte,a,atfra(i))
         read(Inte,'(a2)') ispefra(i)
*RS         
*RS         read(Inte,'(a2)') ispefra(i)
*RS         a=i
*RS         call xlabel(ispefra(i),a,itemp)
*RS         write(atfra(i),'(a4)') itemp(1)
*RS         write(Inte,'(a4)') ispefra(i)
         bisoZ(i) = bt
         occZ(i)  = 1.0 
!
         call AnalysisSpecies(nSpec,izz,Inte,ier)
!
!-- extract 3 floating values (skipping 3 integer values)
!
         do j=1, 3
            call cutst(buffer_ctrl_M,lenp,Inte,lend)
            xloc(j,i) = Valore(Inte)
            call cutst(buffer_ctrl_M,lenp,Inte,lend)
         enddo
*          read(linea,'(2x,a2,1x,3(f13.7,3x),3i5,2f5.1,i5)')
*    2        ispefra(i),(xloc(n,i),n=1,3),
*    3        (nloc(n,i),n=1,3),bisoZ(i),occZ(i),jserZ(i)
*          iloc(i)=i
*          a=jserZ(i)
*          call xlabel(ispefra(i),a,itemp)
*          write(atfra(i),'(a4)')itemp(1)
*          write(lo ,'(i5,2x,a8,2x,a4,4x,3f10.3,3i5,2f5.1)')
*    2      iloc(i),atfra(i),ispefra(i),(xloc(n,i),n=1,3),
*    3      (nloc(n,i),n=1,3),bisoZ(i),occZ(i)
*          write(dire,'(a4)') ispefra(i)
!
!-- extract 3 integer values
!
         do j=1, 3
            call cutst(buffer_ctrl_M,lenp,Inte,lend)
            nloc(j,i) = nint(Valore(Inte))
         enddo
         iloc(i) = i
!
!-- extract supplementary information (if any)
!
         if (lenp <= 0) cycle
         call cutst(buffer_ctrl_M,lenp,Inte,lend)
         bisoZ(i) = Valore(Inte)
         if (lenp <= 0) cycle
         call cutst(buffer_ctrl_M,lenp,Inte,lend)
         occZ(i) = Valore(Inte)
         if (lenp <= 0) cycle
         call cutst(buffer_ctrl_M,lenp,Inte,lend)
         jserZ(i) = nint(Valore(Inte))
         a=jserZ(i)
!         
         write(Inte,'(a2)') ispefra(i)
         call nomev2New(Inte,a,atfra(i))
*RS         
*RS         call xlabel(ispefra(i),a,itemp)
*RS         write(atfra(i),'(a4)') itemp(1)
!
      enddo
  100 continue
      numzm = i
      do i=1, numzm
         write(lo ,'(i5,2x,a8,2x,a4,4x,3f10.3,3i5,2f5.1)') 
     2      iloc(i),atfra(i),ispefra(i),(xloc(n,i),n=1,3),    
     3      (nloc(n,i),n=1,3),bisoZ(i),occZ(i)
      enddo
      return
 1010 ier = -1
      Msg = 'Error reading MOP file: truncated'
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, n)
      return
      end
!-----------------------------------------------------------------------
!  routine di input file tipo CAOS
!-----------------------------------------------------------------------
!code for LeggiCaosinMem
      subroutine LeggiCaosinMem(ifRefl,celltemp,nt,idiffr,wave,nats,ier)
!--input a Caos file
!      
      USE General
      USE Deprecato
      USE Atomi
      USE Symmetry
      USE PhaseModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!      
      character (len=16) LabelS
      dimension xtemp(80)
      character*3 charX
      character*1 ih
      character*4  iwave(2),ldiffr(3)
      dimension xwave(2), nt(16), celltemp(13)
      data ih /'#'/
      data ldiffr/'x-ra','neut','elec'/
      data iwave /'mo  ','cu  '/
      data xwave/0.71073,1.54178/
      data charX/'end'/
!
      ier=0
!  set unita' di lettura
      ncpu_Sav=ncpu
      ncpu=jhost 
!  set unita' temp per gli atomi        
      itype = 1
      iform = 2
      jop = jopen(jgrap,'  ',itype,iform,ier)
      if (jop < 0) then
          ier = -1
          return
      endif
!
      nSpec = 0
      nSpecie(:) = 0
      vSpecie(:) = ' '
      ifRefl = 0
      idiffr=1
      WhichWave=1
      wave=xwave(WhichWave)
      idev=0
      nk = 0
      iCaos=0
!--loop on directives
      do while (iCaos == 0)
         call LeggiCardImage(ifUguale, ifEOF, ier)
         if (ifEOF < 0 .or. ier < 0) exit
         if(cardImage(1:1).eq.ih) then
!--e' una direttiva primaria
            cardDiret=cardImage(2:)
            call lcase(cardDiret)
            call cutst(cardDiret,lenp,direttiva,lend)
            if (lend <= 0) cycle                   ! blank card
!                
!--direttiva 'end' 
            if(direttiva(1:3).eq.'end') then 
               iCaos=1
               exit
            endif       
!                
!--direttiva 'title' 
            if(direttiva(1:5).eq.'title') then 
               Titolo = cardDiret
               cycle
            endif       
!
!--direttiva 'read' or 'list'
            if(direttiva(1:4).eq.'read'.or.
     *         direttiva(1:4).eq.'list') then    
               call cutst(cardDiret,lenp,direttiva,lend)
!--direttiva #read weig or #list 12    ! salto il contenuto            
               if(direttiva(1:4).eq.'cond'.or.
     *            direttiva(1:2).eq.'12') then 
                  call SkipCardImageNO(charX,ier)
                  write(lo,'(a)')cardImage
                  cycle
               endif   
!--direttiva #read cell or #list 1               
               if(direttiva(1:4).eq.'cell'.or.
     *            direttiva(1:1).eq.'1') then 
                  call LeggiCardImage(ifUguale, ifEOF, ier)
                  iopt = 6
                  call getnum(cardImage,xtemp,itemp,iv,iopt)
                  if (iopt < 0) then
                      ier = -1
                      iCaos=1
                      cycle
                  else
                      celltemp(1:6) = xtemp(1:6)
                  endif
                  call LeggiCardImage(ifUguale, ifEOF, ier)
                  iopt = 6
                  call getnum(cardImage,xtemp,itemp,iv,iopt)
                  if (iopt < 0) then
                      ier = -1
                      iCaos=1
                      cycle
                  else
                      celltemp(7:12) = xtemp(1:6)
                  endif
                  cycle
               endif   
!--direttiva #read symm or #list 2               
               if(direttiva(1:4).eq.'symm'.or.
     *            direttiva(1:1).eq.'2') then 
                  LabelS=cardDiret(1:lenp)
                  read(LabelS,'(16a1)')nt
                  cycle
               endif   
!--direttiva #read cont or #list 3               
               if(direttiva(1:4).eq.'cont'.or.
     *            direttiva(1:1).eq.'3') then
                  iendX = 0
                  do while (iendX == 0)
                     call LeggiCardImageShift(ifUguale, ifEOF, ier)
                     call lcase(cardImage)
                     call cutst(cardImage,lenp,direttiva,lend)
!--direttiva end               
                     if(direttiva(1:4).eq.'end') then
                        iendX=1
                        cycle
                     endif 
!--direttiva wavelenght              
                     if(direttiva(1:4).eq.'wave') then 
                        cardDiret=cardImage
!--lettura se Mo o Cu                     
                        call cutst(cardImage,lenp,direttiva,lend)
                        n=KompareString(direttiva,iwave,2,0)
                        if(n.gt.0) then
                           WhichWave=n
                           wave=xwave(WhichWave)
                        else  
!--lettura valore della wave                    
                           WhichWave=3
                           cardImage=cardDiret
                           iopt = 1
                           call getnum(cardImage,xtemp,itemp,iv,iopt)
                           if (iopt < 0) then
                               ier = -1
                               iCaos=1
                               iendX=1
                               cycle
                           else
                               wave = xtemp(1)
                           endif
                        endif
                        cycle
                     endif
!--direttiva diffraction              
                     if(direttiva(1:4).eq.'diff') then 
                        call cutst(cardImage,lenp,direttiva,lend)
                        n=KompareString(direttiva,ldiffr,3,0)
                        if(n.gt.0) then
                           idiffr=n
                        else
                           ier = -1
                           iCaos=1
                           iendX=1
                        endif
                        cycle
                     endif
!--non e' una direttiva, ma un nome di una specie
                     nSpec = nSpec + 1
                     vSpecie(nSpec) = direttiva(1:4)
                     iopt = 1
                     call getnum(cardImage,xtemp,itemp,iv,iopt)
                     if (iopt < 0) then
                         ier = -1
                         iCaos=1
                         iendX=1
                         cycle
                     else
                         nSpecie(nSpec) = itemp(1)
                     endif
                  enddo
                  nk = nSpec  
                  cycle               
               endif   
!--direttiva #read weig or #list 4               
               if(direttiva(1:4).eq.'weig'.or.
     *            direttiva(1:1).eq.'4') then 
                  call LeggiCardImage(ifUguale, ifEOF, ier)
                  cycle
               endif   
!--direttiva #read atom or #list 5               
               if(direttiva(1:4).eq.'atom'.or.
     *            direttiva(1:1).eq.'5') then
                  iuij=0
                  call sr05NEW(iuij,ier)
                  if(ier.lt.0) goto 9000
                  cycle
               endif   
!--direttiva #read refl or #list 6               
               if(direttiva(1:4).eq.'refl'.or.
     *            direttiva(1:1).eq.'6') then
                  call LeggiRiflessiCaos(ifRefl, ier)
                  if(ier.lt.0) goto 9000
                  cycle
               endif   
            endif   
!                
!--direttiva 'update' 
            if(direttiva(1:6).eq.'update') then 
               call cutst(cardDiret,lenp,direttiva,lend)
               if(direttiva(1:4).eq.'refl'.or.
     *            direttiva(1:1).eq.'6') then    
                  call LeggiCardImage(ifUguale, ifEOF, ier)
                  call lcase(cardImage)
                  call cutst(cardImage,lenp,direttiva,lend)
                  if(direttiva(1:6).eq.'cutoff') then 
                     iopt=0
                     call getnum(cardImage,xtemp,itemp,iv,iopt)
                     if (iopt.eq.-1) go to 9000   ! error
                     if (iv.ne.1) go to 9000
                     cutoff=xtemp(1)
                  endif
               endif
            endif       
         endif    
      enddo
!-----------------------------------
*      Save_itty=itty
*      itty=0
*      Save_intty=intty
*      intty=0
*      Save_ln=ln     
*      ln=jhost
*      Save_ncru=ncru      
*      ncru=jhost
*!--Main loop
*      call Main_Loop(ier)
*!--End of loop
*      write(lo,3830)
*3830  format(/,1h ,78('+'),//)
*      ln=Save_ln     
*      ncru=Save_ncru      
*      itty=Save_itty
*      intty=Save_intty
!-----------------------------------
      ncpu=ncpu_Sav
      return
!--error
9000  continue
      write(lo,'(a)')' Input file Error'
      ier=-1
      return      
      end
!-----------------------------------------------------------------------
c
code for sr05NEW
      subroutine sr05NEW(iuij,ier)
c--read list 5 , atomic parameters
c  nru = temporary output file
c  iuij = 0 b(ij) input
c	    1 u(ij)
c
      USE General
      USE Deprecato
      USE Atomi
      USE PhaseModule
!      
      common/xcardch/CardImageX,idch(6)
      character CardImageX*80,idch*1
c
      dimension jav(1)
c
c--sir common
      common /piero/ BTot(3,3), RK(4), VV(10,3), ifBestModel,
     *               ifRigidBody

c--end sir common
c
      dimension xtemp(80),iadr(3,3)
      character*16 vetch
      character*80 ibuf
!      character*60 iarg
      character*4 itargch(2),itarg2ch(10)
!      data iarg/'Scale, B(overall), Extinction, Polarity, Twinning'/
      data ntarg/2/,ntarg2/10/
      data itargch /'proj','more'/
      data itarg2ch/'scal','bove','exti','pola','twin',      
     2              'proj','atom','more','conn','end '/
c--
      ier  = 0
      nats = 0
      nco=0
c--start loop sulle direttive interne
      iendX = 0
      do while (iendX == 0)
         call LeggiCardImage(ifUguale, ifEOF, ier)
         if (ifEOF < 0 .or. ier < 0) exit
         call lcase(cardImage)
         call cutst(cardImage,lenp,direttiva,lend)
!--direttiva end               
         if(direttiva(1:4).eq.'end') exit
c--check the directives
         idc=KompareString(direttiva,itarg2ch,ntarg2,0)
         if(idc.le.0) then
            ier = -1
            iendX=1
            exit
         endif
c--process the directives
         select case (idc)
!         
!--overall's directives 
            case(1,2,3,4,5)
               iopt = 0
               call getnum(cardImage,xtemp,itemp,iv,iopt)
               if (iopt < 0) then
                   ier = -1
                   iendX=1
                   exit
               else if(iv.eq.2) then
                   Overall_dev(idc)=xtemp(2)
               endif
               if(idc.eq.1)  FcScale=xtemp(1)
               if(idc.eq.2)  FcBiso=xtemp(1)
               if(idc.eq.3)  FcExtin=xtemp(1)
               if(idc.eq.4)  FcPola=xtemp(1)
               if(idc.eq.5)  FcTwin=xtemp(1)
!
!--'projection' directive
            case(6)
               do i=1,3
                  call LeggiCardImage(ifUguale, ifEOF, ier)
                  if (ifEOF < 0 .or. ier < 0) exit
                  iopt = 3
                  call getnum(cardImage,xtemp,itemp,iv,iopt)
                  if (iopt < 0) then
                      ier = -1
                      iendX=1
                      exit
                  endif
                  if(iv.ne.3) then
                      ier = -1
                      iendX=1
                      exit
                  endif
                  BTot(i,1:3)=xtemp(1:3)
               enddo
c
c--'atoms' directive
            case(7)
               iopt = 1
               call getnum(cardImage,xtemp,itemp,iv,iopt)
               if (iopt < 0) then
                   ier = -1
                   iendX=1
                   exit
               endif
               nats = itemp(1)
               do l=1,nats
                  call sratomNEW(iuij,ier)
                  if(ier.lt.0) then
                     iendX=1
                     exit
                  endif
               enddo   
c
c--'more' directive  (not used)
            case(8)
               do l=1,nats
                  call LeggiCardImage(ifUguale, ifEOF, ier)
               enddo
c
c--'connectivity' directive (not used)
            case(9)
               iopt = 1
               call getnum(cardImage,xtemp,itemp,iv,iopt)
               if (iopt < 0) then
                   ier = -1
                   iendX=1
                   exit
               endif
               nco = itemp(1)
               nlin=nco/3 
               nrest=nco - nlin*3
               if(nrest.gt.0) nlin = nlin + 1
               j = 2
               nbo=1
               do l=1,nlin
                  call LeggiCardImage(ifUguale, ifEOF, ier)
                  iopt = 0
                  call getnum(cardImage,xtemp,itemp,iv,iopt)
                  if (iopt < 0) then
                      ier = -1
                      iendX=1
                      exit
                  endif
                  iadr(:,:)=0
                  m=1
                  do kl=1,3
                     kc=kl
                     if(nbo.gt.nco) then
                        kc=kc-1
                        exit
                     endif
                     iadr(kl,1)=itemp(m)
                     iadr(kl,2)=itemp(m+1)
                     iadr(kl,3)=itemp(m+2)
                     nbo=nbo+1
                     m=m+3
                  enddo
!                  do i=1,kc
!                     iconn(j:j+2)=iadr(i,1:3)
!                     j=j+3
!                  enddo
               enddo   
c
c--end of reading list 5
         end select
      enddo
      return
c--error conditions      
3000  continue
      ier=-1
      return
      end
c
code for sratomNEW
      subroutine sratomNEW(iuij,ierr)
c--read one atom
c
      USE General
      USE Deprecato
      USE PhaseModule
      USE Atomi
      USE Molcom
!
      real  atomo(14),atomo_dev(11), xtemp(80)
      character(len=4):: SpecieCurr, SpecieMix(4)
      character (len=16) LabelS
       dimension occS(4,2)
c--
      ierr=0
      atomo(:)=0.0
      atomo_dev(:)=0.0
      occS(:,:)=0.0
      SpecieMix(:)=' '
!
!--read 1o record serial,x,y,z,b(iso)....
      call LeggiCardImageShift(ifUguale, ifEOF, ierr)
      if (ifEOF < 0 .or. ierr < 0) return
      call lcase(cardImage)
      call cutst(cardImage,lenp,direttiva,lend)
!--analisi 1o record (run 1)
      SpecieCurr = direttiva
      cardDiret=cardImage
      iopt = 0
      call getnum(cardImage,xtemp,itemp,iv,iopt)
c      if (iopt < 0) then
c          ierr = -1
c          return
c      endif
      do j=1,iv
         atomo(j)=xtemp(j)
      enddo
!--analisi 1o record (run 2)
      cardImage=cardDiret
      do j=1,iv
         call cutst(cardImage,lenp,direttiva,lend)
      enddo
      if(lenp.le.0) then
         call nomev2New(SpecieCurr,atomo(1),LabelS)
c         LabelS=' '
      else
         LabelS=cardImage
      endif
!--fine analisi 1o record
      if(atomo(5).le.0.0) then
!--read 2o record b(ij)
         call LeggiCardImageShift(ifUguale, ifEOF, ierr)
         call cutst(cardImage,lenp,direttiva,lend)
         iopt = 6
         call getnum(cardImage,xtemp,itemp,iv,iopt)
         if (iopt < 0) then
             ierr = -1
             return
         endif
         atomo(9:14)=xtemp(1:iv)
      endif
!--fine analisi 2o record
      if(atomo(7).gt.0.0) then
!--read 3o record s.d. x,y,z....
         call LeggiCardImageShift(ifUguale, ifEOF, ierr)
         call cutst(cardImage,lenp,direttiva,lend)
         iopt = 0
         call getnum(cardImage,xtemp,itemp,iv,iopt)
         if (iopt < 0) then
             ierr = -1
             return
         endif
         atomo_dev(1:iv)=xtemp(1:iv)
      endif
!--fine analisi 3o record
      if(atomo(5).le.0.0) then
!--read 4o record s.d. b(ij)
         call LeggiCardImageShift(ifUguale, ifEOF, ierr)
         call cutst(cardImage,lenp,direttiva,lend)
         iopt = 6
         call getnum(cardImage,xtemp,itemp,iv,iopt)
         if (iopt < 0) then
             ierr = -1
             return
         endif
         atomo_dev(6:11)=xtemp(1:6)
      endif
!--fine analisi 4o record
      imix=nint(atomo(8)+0.001)
      if(imix.gt.0) then
c--read 5th atomic record		Mixed atom sites
         do j=1,imix
            call LeggiCardImageShift(ifUguale, ifEOF, ierr)
            call cutst(cardImage,lenp,direttiva,lend)
            SpecieMix(j)=direttiva
            iopt = 0
            call getnum(cardImage,xtemp,itemp,iv,iopt)
            if (iopt < 0) then
                ierr = -1
                return
            endif
            occS(j,1:iv)=xtemp(1:iv)
         enddo
      endif
!--fine analisi 5o record
c--end of reading atomic records
      write(jgrap) SpecieCurr, LabelS, atomo,  atomo_dev
      if(imix.gt.0) write(jgrap) SpecieMix,occS
c      
      return
3000  continue
      ierr=-1
      return
      end
!-----------------------------------------------------------------------
      subroutine LeggiRiflessiCaos(ifRefl,ier)
      USE General
!
      character*3 charX
      data charX/'end'/
!
              call SkipCardImageNO(charX,ier)
              ReflFileName = 'tmp_shelx_refl_file.hkl'
              ReflFileForm = '(3i4,2f12.4,f7.2)'
              itype = 0
              iform = 1
              jop = jopen(iscra, ReflFileName, itype, iform, ier)
              do
                 read(jhost,'(3i4,2f10.4)',end=10) kh,kk,kl,fob,sfob
                 if (kh == 0 .and. kk == 0 .and. kl == 0) exit
                 if (kh == 512 .and. kk == 512 .and. kl == 512) exit
                 write(iscra,'(3i4,2f8.2)') kh,kk,kl,fob,sfob
              enddo
   10         continue
              close(iscra)
              ifRefl = 1
!
      return
      end
!-------------------------------------------------------------------------------      
      subroutine LeggiHklImported(ier)
      USE General
!
      itype = 1
      iform = 2
      kop = kopen(iscra, ' ', nlenBin, itype, ier)
      if (ier < 0) return
      ifGener  = -1
      th       = 99999999
      resm     = -99999
      resmin   = 99999
      knw      = 0
      kmad     = 0
      ifLaue   = -1
      ifCalc   = 0
      CheckRef = 0
      ifMTZ    = 0
      ifTwin   = 0
!!!   neutro   = 0
      ksigma   = 1
      nPerCard = 1
      ifMatOr  = 0
      ifPlotSpots  = 0
      call LoadReflections(ReflFileForm, nrefp, npq, ier)
      if (ier.ge.0) then
!
!-- create list 6 ( reflections )
!
          call CreaRiflessiNew(npq)
          nreflDim = nrefltot
          call AllocaRiflessi(1)
          ifMercedes = 0
          call norm2000(ifMercedes, ier)
          close(iscra)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Visualizza_Mappa(numbM,MapNumber,iesMap,jphas)
!
!  DA RIVEDERE
!

      USE General
      USE Symmetry
      USE Mappa
      USE MappaPrint
      USE Riflessi
      USE Atomi
      USE Param
      USE PhaseModule
c
!     iesMap = 0  esiste gia' la mappa
!     iesMap = 1  devo fare la mappa
!     jphas = 0   fasi gia' su origine pubb.
!     jphas = 1   calcola coeff e trasla le fasi


      if (iesMap == 1) then
         call AllocaMappaPrint(1)
         xmap_prt(:,:,:) = xmap(:,:,:)
         if (jphas == 1) then
             invflag = 0
             call InvMap(khl,mkang,iphaz,fcvet,numbM)
             fcoef(1:numbM) = fcvet(1:numbM)
             call Trasla_Origine(numbM)
!            ifmin = 1
!            luset = 999
!            izero = 0
!            call examin(luset,mkang,khl,ipub,iphaz,numbM,izero,wt,ifmin)
         endif
         fcoef(:) = fcoef(:) * wt(:)
         jpatt = 0
         call MakeMap(fcoef, iphaz, numbM, jpatt, xmap,
     *                FORTH, BACK)
      endif
      
      iAct1 = 2  !CCP4
      iAct1 = 1  !Xtal 
      iAct2 = 2  !Map + Phases
      call Write_Phases_Map(iAct1,iAct2,numbM,MapNumber)

      if (iesMap == 1) then
         xmap(:,:,:) = xmap_prt(:,:,:) 
         call AllocaMappaPrint(2)
      endif

      return
      end
!-----------------------------------------------------------------------
      subroutine Write_Phases_Map(iAct1,iAct2,numbM,MapNumber)
      USE General
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE Mappa
!
!  MODIFICATA per mappa CCP4
!
!
!-- iAct1 = 1   Xtal
!         = 2   CCP4
!-- iAct2 = 1   only phases
!         = 2   phases and map
!         = 3   only map
!
      character*7 string_map, string_phs
      character*80 filename_map,filename_phs
!
      if (MapNumber < 0 .or. MapNumber > 99) then
         write(lo,*) 'ERROR: MapNumber  must be in range 0-99',MapNumber
         return
      endif
      if (iAct1.eq.1) then
          write(lo,20) MapNumber
      else
          write(lo,30) MapNumber
      endif

      if (MapNumber <= 9) then
          write(string_phs,'(2h_0,i1,4h.phs)') MapNumber
          if (iAct2 >= 2) then
              write(string_map,'(2h_0,i1,4h.map)') MapNumber
          endif
      elseif (MapNumber > 9 .and. MapNumber <= 99) then
          write(string_phs,'(1h_ ,i2,4h.phs)') MapNumber
          if (iAct2 >= 2) then
              write(string_map,'(1h_ ,i2,4h.map)') MapNumber
          endif
      endif

      k = index(fname(1),'.bin')
      if (iAct1.eq.1) then
          filename_phs = fname(1)(1:k-1) // '_Xtal' // string_phs
          Msg = ' The file ' // filename_phs(1:Lung(filename_phs)) //
     *          ' has been written in Xtal format.'
          if (iAct2 >= 2) then
              filename_map = fname(1)(1:k-1) // '_Xtal' // string_map
                Msg = ' The files ' // 
     *          filename_phs(1:Lung(filename_phs)) //
     *          ' and ' // filename_map(1:Lung(filename_map)) //
     *          ' have been written in Xtal format.'
          endif
      else
          filename_phs = fname(1)(1:k-1) // '_CCP4' // string_phs
          if (iAct2 >= 2) then
              filename_map = fname(1)(1:k-1) // '_CCP4' // string_map
          endif
      endif

      if (iAct2 <= 2) then   ! MAP
          itype = 0
          iform = 1
          if (jopen(jrel,filename_phs,itype,iform,ios) < 0) go to 9400
!
          fMax = -9999
          do i=1,numbM
             if (fcoef(i).gt.fMax) then
                 fMax = fcoef(i)
             endif
          enddo
          if (fMax.gt.9998.0) then
              scalaF = 9998.0 / fMax
          else
              scalaF = 1.0
          endif
          do i=1,numbM
             write(jrel,'(3i4,f8.2,f8.4,i5)')
     *            (khl(j,i),j=1,3),fcoef(i)*scalaF,wt(i),iphaz(i)
          enddo
    
          zero = 0.0
          i0   = 0
          i1   = 1
          if (lproj.eq.1) then
             write(jrel,'(3i4,f8.2,f8.4,i5)') i1,i0,i0,zero,zero,i0
          elseif (lproj.eq.2) then
             write(jrel,'(3i4,f8.2,f8.4,i5)') i0,i1,i0,zero,zero,i0
          elseif (lproj.eq.3) then
             write(jrel,'(3i4,f8.2,f8.4,i5)') i0,i0,i1,zero,zero,i0
          endif
    
          close(jrel)

      endif

      if (iAct2 >= 2) then   ! MAP
c
c-- prepara la mappa ( se necessario )
c
          if (iAct1 == 1) then     ! XTAL
              itype=0
              iform=2
              if (jopen(jhost,filename_map,itype,iform,ios).lt.0) 
     *                   go to 9500
c
c-- analizza e normalizza la mappa
c
              call Analizza_Mappa_Xtal(xmap_coef)
c
c-- scrive l'header
c
              nByte = 4
              call scrivi_header_Xtal(nByte,jhost,filename_map,ierr)
c
c-- scrive la mappa
c
              call ScriviMappaXtal(nByte,jhost,xmap_coef,xmap_div,ierr)
c
          else                      ! CCP4
c
              nSpaceGroup_Sav = nSpaceGroup
              nSpaceGroup = 1 ! faccio la mappa sempre in P1

              call CCP4MAPOUT(1,xmap,np,filename_map)

              nSpaceGroup = nSpaceGroup_Sav 
c
          endif  !iAct1 = 1

      close(jhost)
      endif  !iAct2 = 2
c
      return
c
   20 format('  ... exporting phases and/or map in Xtal format ...',
     *       ' MapNumber = ',i4,/)
   30 format('  ... exporting phases and/or map in CCP4 format ...',
     *       ' MapNumber = ',i4,/)

 9400 write(Msg,9410) ios,filename_phs(1:Lung(filename_phs))
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
 9410 format(' Open  error, code =',i5,' file is ',a)
      ierr = -1
      return
c
 9500 write(Msg,9410) ios,filename_map(1:Lung(filename_map))
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      ierr = -1
c
      end
!-----------------------------------------------------------------------
      subroutine outXtal_CCP4(iAction, filename, filename2)
      USE General
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE RemoModule, only : WhichBestSolution
      USE Mappa
!
      character (len=*) :: filename, filename2
!
!-- iAction = 1   Xtal
!           = 2   CCP4
!
!
      call RoutineHeader('Export')
      if (iAction.eq.1) then
          write(lo,20)
      else
          write(lo,30)
      endif
   20 format('  ... exporting map & phases files in Xtal format ...',/)
   30 format('  ... exporting map file in CCP4 format ...',/)
      nstrP1 = nstr
      kSumPh = 0
      if (allocated(iphaz)) then
          kSumPh = sum(iphaz(:))
      endif
!      write(0,*) 'kSumPh =', kSumPh 
      numb    = nreflDim
      if (kSumPh == 0) then
          if (InfoOK(6).eq.1) then
              call CheckGrid()
              nreflDim = nrefltot
              call AllocaRiflessi(1)
              ksubr = 3
              call LeggiRiflessi(ier,ksubr)
          endif
!
          do i=1,nats
             nzo(i) = nz(i)
             nz(i)  = iabs(nz(i)) / nzConst
          enddo
!
          ifBreak = 0
          iCoeff  = 1
          mode    = 1
          iref    = 0
          numb    = nreflDim
          numtot  = 0
          call sftryyyc(iref,mode,numb,scalan,ifBreak,iCoeff)
          fcvet(:) = work1(:)
          do i=1,nats
             nz(i) = nzo(i)
          enddo
      endif
      call AllocaMappa(1)         
      if (knw.gt.0) then
          call Trasla_Origine(numb)
      endif
      MapNumber = figMer(1)
*gl*  fcoef(:) = fcoef(:) * wt(:)
      fcoef(:) = fovet(:) * wt(:)
      jpatt = 0
      call MakeMap(fcoef, iphaz, numb, jpatt, xmap,
     *                FORTH, BACK)
      if (iAction.eq.1) then
          call Scrivi_Fasi_Mappa_Xtal(numb,MapNumber)
      else
          call Scrivi_Mappa_CCP4(filename)
      endif
!
      call AllocaMappa(2)         
!
      return
      end
c------------------------------------------------------------------
code for Dump_Caos
      subroutine Dump_Caos(nunit)
c--main routine to output caos file
c**caos program format --> name.fil
c  dump list 1,2,3,4,5,13,6,12,18
c	 save chop value
c--menu: file menubar.h ; riga 65 (tolto il commento //)
      USE General
      USE Symmetry
      USE Atomi
      USE LsqModule
      USE LsqStuff
      USE LsqStuff12
      USE LsqGroupsStuff
!
      dimension coord_shift(3)
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      character*1 ih
      character*4  iwave(2),ldiffr(3)
      data ih /'#'/
      data ldiffr/'x-ra','elec','neut'/
      data iwave /'Mo  ','Cu  '/
c--
      ier=0
!--questo valore deve essere conservato quando si crea CONTENT (ex list 3) per SIR      
      WhichWave=1     
      ncpu=nunit
!---------------------------------------------------------------
c--dump title
!gl!  write(ncpu,1000) ih,itle
      write(ncpu,1000) ih, Titolo
1000  format(a,'title ',a)
!---------------------------------------------------------------
c--dump list 1
      write(ncpu,1010) ih
1010  format(a1,'list 1 ')
      write(ncpu,1030) cell(1:6),volume
      write(ncpu,1030) errcell(1:7)
1030  format(1x,3f8.3,4f8.2)
!---------------------------------------------------------------
c--dump list 2
      write(ncpu,1012) ih,nSpaceG
1012  format(a1,'list 2 ',16a1)
!---------------------------------------------------------------
c--dump list 3
      write(ncpu,1013) ih
1013  format(a1,'list 3 ')
      write(ncpu,701)ldiffr(neutro+1)
701   format('diffraction ',a)
      i=WhichWave
      if (i.eq.3) then
          write(ncpu,702) wavel
702       format('wavelenght ',f10.5)
      else
          write(ncpu,703)iwave(i)
703       format('wavelenght ',a)
      end if
      do i=1,nk
         call ucase(Species(i)(1:1))
         write(ncpu,1040) Species(i),nw(i)
1040     format(1x,a4,1x,i10)
      enddo
      write(ncpu,2301)
2301  format('end ')
!---------------------------------------------------------------
c--dump list 4
      if(InfoOK(4).eq.1) then
         write(ncpu,1014) ih
1014     format(a1,'list 4 ')
         if (nPar.gt.0) then
             if (nWeight.eq.16) then
                 j=nPar+2
             else
                 j=nPar+1
             endif
         else
             j=1
         endif      
         if (nWeight.eq.16) then
	       write(ncpu,2801) nWeight,nPar,WPar(j),
     *            (WPar(l),l=1,nPar+1)
2801	       format(1x,i4,i5,10f8.3)
         else
	       write(ncpu,2801) nWeight,nPar,WPar(j),
     *            (WPar(l),l=1,nPar)
         endif
      endif
!---------------------------------------------------------------
c--dump list 5
      if(InfoOK(5).eq.1) then
         in=1
         call Dump_Atoms(ncpu)
      endif
!---------------------------------------------------------------
c--dump list 13     
c--check if a list 13 exists
      if(InfoOK(13).eq.1) then
         write(ncpu,1023) ih
1023     format(a1,'list 13 ')
         do kk=1,NumGroup
            write(ncpu,3000) TypeGroup(kk),NserialGroup(kk),
     *                       NumAtomsGroup(kk)     
3000        format(1x,a4,2i10)
            n=0
            ncard=NumAtomsGroup(kk)
            aLabPrintGroup(1:ncard,kk) = ' '
            do i=1,ncard
               nord=NordAtomsGroup(i,kk)
               aLabPrintGroup(i,kk) = aLab(nord)
            enddo  
            write(ncpu,3001) (aLabPrintGroup(i,kk),i=1,ncard)
3001        format(10a8)      
        enddo
      endif
!---------------------------------------------------------------
c--dump list 12
c--check if a list 12 exists
      if(InfoOK(62).eq.1) then
         write(ncpu,1022) ih
1022     format(a1,'list 12 ')
         do k=1,NumCond12
            call shift(stringa12Tot(k),l1)
            write(ncpu,'(a)')stringa12Tot(k)(1:l1)
         enddo
      endif
!---------------------------------------------------------------
c--dump list 6
c--check if a list 6 exists
      if(InfoOK(6).eq.1) then
         write(ncpu,1016) ih
1016     format(a1,'list 6 ',/,'end')
         in=0
         call Dump_Reflections(in,ncpu)
c--write chop value
         if(cutoff.gt.0.05) then
            write(ncpu,1060) ih
1060        format(a1,'update reflect')
            write(ncpu,1061) cutoff
1061        format('cutoff ',f6.2,/,'end')
         endif
      endif
!---------------------------------------------------------------
c--end of dump                 
      write(ncpu,9000) ih
9000  format(a1,'end ')
      endfile ncpu
      close(ncpu)
      return
      end
!------------------------------------------------------------------
code for Dump_Atoms
      subroutine Dump_Atoms(nunit)
c--dump list 5, atomic parameters
c**caos system format**
c--
      USE General
      USE Molcom
      USE Atomi
!      
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension iadr(3,3)
      character*10 itarg2(10)
      character*1 ih
      data ih /'#'/
      data itarg2/'Scale','Boverall','Extinction','Polarity',
     2    'Twinning','Projection','Atoms','More','Connect','End'/
c--
      ncpu=nunit
c--
      write(ncpu,1000) ih
1000  format(a1,6hlist 5)
c--write overall parameters
      write(ncpu,1031) itarg2(1),FcScale,Overall_dev(1),
     *                 itarg2(2),FcBiso,Overall_dev(2),
     *                 itarg2(3),FcExtin,Overall_dev(3),
     *                 itarg2(4),FcPola,Overall_dev(4),
     *                 itarg2(5),FcTwin,Overall_dev(5)
1031  format(a10,2f10.5)
c--write  projection matrix
      write(ncpu,'(a)')itarg2(6)
      do i=1,3
         write(ncpu,1165)( BTot(i,j),j=1,3)
1165     format(1x,3f10.5)
      enddo
c--end
      write(ncpu,'(a,i6)')itarg2(7),nats     
      do i=1,nats
         lnz = nzTot(i)
         imix = iSite(i)
         a=0.0
         if(isoaniso(i).eq.2) a=bfac(i) 
         L = Lung(aLab(i))
c--dump 1th record
         write(ncpu,1085) nalf(lnz),serial(i),xyzs(1:3,i),
     2        a,xyzs(5,i),imix,aLab(i)(1:l)
1085     format(1x,a4,1x,i5,5f10.5,2x,'1',1x,i1,2x,a)
         if(isoaniso(i).eq.1) then 
c--dump 2nd record
             write(ncpu,1087) nalf(lnz), bij(1:6,i)
1087         format(1x,a4,6x,6f10.5)
         endif
         a=0.0
         if(isoaniso(i).eq.2) a=bfac_dev(i)
c--dump 3th record
         write(ncpu,1185) nalf(lnz),xyzs_dev(1:3,i),
     2        a,Occ_dev(i)
1185     format(1x,a4,6x,5f10.5)
         if(isoaniso(i).eq.1) then
c--dump 4th record
            write(ncpu,1087)  nalf(lnz), bij_dev(1:6,i)
         endif
         if(imix.gt.0) then
c--dump 5th (imix)record		Mixed atom sites + s.d(occ)
            do j=1,imix
               ksp1 = int(SiteInfo(j,i)) / 10    ! specie   
               occ  = amod(SiteInfo(j,i),10.0)   ! occupazione  
               write(ncpu,1191) nalf(ksp1),occ,OccX_dev(j,i)
1191           format(1x,a4,2x,2f8.5)
            enddo
         endif
      enddo
c--connectivity
      if(iconn(1).gt.0) then
         nco=iconn(1)
         write(ncpu,'(a,i6)') itarg2(9),nco
         nlin=nco/3 
         nrest=nco - nlin*3
         if(nrest.gt.0) nlin = nlin + 1
         j = 2
         nbo=1
         do l=1,nlin
            iadr(:,:)=0
            do kl=1,3
               kc=kl
               if(nbo.gt.nco) then
                  kc=kc-1
                  exit
               endif
               lj=iconn(j)
               kj=iconn(j+1)
               nj=iconn(j+2)
               iadr(kl,1)=lj
               iadr(kl,2)=kj
               iadr(kl,3)=nj
               nbo=nbo+1
               j=j+3
            enddo
            write(ncpu,1250)((iadr(i,n),n=1,3),i=1,kc)
 1250       format(1x,3(3i5,4x))
         enddo   
      endif
      write(ncpu,'(a)') itarg2(10)
      return
      end
!-----------------------------------------------------------------------
      subroutine Analizza_Mappa_Xtal(coef)
      USE General
      USE Mappa
      USE PhaseModule
c
      common /header/ amin, amax, amean, arms, nsymbt
c
      nnx = np(1) 
      nny = np(2) 
      nnz = np(3) 
      denom = np(1) * np(2) * np(3)
c
      amin  = 1.0e25
      amax  = -1.0e25
      rhomedio  = 0.0
      rhomedio2 = 0.0
      do i=0,nnx-1
         do j=0,nny-1
            do k=0,nnz-1
               xx = xmap(i,j,k)
               rhomedio  = rhomedio  + xx
               rhomedio2 = rhomedio2 + xx * xx
            enddo
         enddo
      enddo
      coef = sqrt(50.0*denom/rhomedio2)
      amin  = 1.0e25
      amax  = -1.0e25
      amean = 0.0
      arms  = 0.0
      do i=0,nnx-1
         do j=0,nny-1
            do k=0,nnz-1
               xx = xmap(i,j,k) * coef
               amax=amax1(amax,xx)
               amin=amin1(amin,xx)
               amean = amean + xx
               arms = arms + xx * xx
            enddo
         enddo
      enddo
      amean = amean / denom
      rhomedio2 = arms / denom
!     write(lo,*) 'amin,amax,amean,arms,rhomedio2',
!    *            amin,amax,amean,arms,rhomedio2
c
      return
      end
c ----------------------------------------------------------------------
      subroutine RT_to_IntTab(jRot,Tra,line)
      USE General
!
      dimension jRot(3,3), Tra(3), line(20)
      character*80 linl
      character cTra(9)*3, xyzshe(3)
c
      cTra(1) = '   '
      cTra(2) = '1/6'
      cTra(3) = '1/4'
      cTra(4) = '1/3'
      cTra(5) = '   '
      cTra(6) = '1/2'
      cTra(7) = '2/3'
      cTra(8) = '3/4'
      cTra(9) = '5/6'
      xyzshe(1) ='X'
      xyzshe(2) ='Y'
      xyzshe(3) ='Z'
c
      linl = ' '
      ip = 1
      do j=1,3
         iplus = 0
         aTra = Tra(j)
         if (aTra.lt.0.0) aTra = aTra + 1.0
         if (aTra.gt.0.9) aTra = aTra - 1.0
         jTra = int(aTra*10) + 1
         if (jTra.gt.1) then
             linl(ip:ip+2) = cTra(jTra)
             ip = ip + 3
             iplus = 1
         endif
         do i=1,3
            ii = jRot(j,i)
            if (ii.ne.0) then
                if (ii.lt.0) then
                    linl(ip:ip) = '-'
                    ip = ip + 1
                else
                    if (iplus.eq.1) then
                        linl(ip:ip) = '+'
                        ip = ip + 1
                    endif
                endif
                write(linl(ip:ip),'(a1)') xyzshe(i)
                ip=ip+1
                iplus=1
            endif
         enddo
         if (j.lt.3) then
             write(linl(ip:ip),'(a1)') ','
             ip=ip+1
             iplus=0
         endif
      enddo
      read(linl,'(20a4)') line
      write(lo,'(a)') linl
c
      return
      end
c -----------------------------------------------------------------
      subroutine scrivi_header_Xtal(nByte,iunit,filename,ierr)
      USE General
      USE Symmetry
      USE Mappa
      USE PhaseModule
c
c-- write header + symmetry + dimension in XtalView map file
c
      integer :: tmpVet(100)
      character*80 filename
      common /header/ amin, amax, amean, arms, nsymbt
c
      character*4 blanks

      blanks = '    '
c
c-- HEADER
c
      i = 0
      do j=1,20              ! title
         i = i + 1
         read(blanks,'(4a2)') tmpVet(i)
      enddo
      do j=1,6               ! param
         i = i + 1
         tmpVet(i) = 0
      enddo
      i = i + 1
      tmpVet(i) = 0         ! nsym = 0
      i = i + 1
      tmpVet(i) = 0         ! not in specs, = 0
c
      write(iunit,iostat=ier,err=1000) (tmpVet(j),j=1,i)
!
!-- DIMENSIONS
!
!-- NORN = 0 for XZ sections
!        = 1 for YZ sections
!        = 2 for XY sections
      tmpVet( 1) = 7*nByte   ! dimensions lenght
      tmpVet( 2) = np(1)     ! number of rows
      tmpVet( 3) = np(2)     ! number of columns
      tmpVet( 4) = np(3)     ! number of planes
      tmpVet( 5) = 0         ! not used
      tmpVet( 6) = 2         ! NORN
      tmpVet( 7) = 0         ! not used
      tmpVet( 8) = 0         ! not used
      write(iunit,iostat=ier,err=1000) (tmpVet(j),j=2, 8)
c
      return
 1000 continue
      write(lo,950) filename(1:Lung(filename))
  950 format(a,':  write error')
      ierr = -1
      return
 2000 write(lo,2100) ier
 2100 format(' Write Error',i5)
      ierr = -1
c
      return
      end
c -----------------------------------------------------------------
      subroutine moltm(b, d, w)
        dimension b(3,3), d(3,3), w(3,3)
c
c ---  matrix * matrix
c
      do 30 i = 1 , 3
         do 20 j = 1 , 3
            dum = 0
            do 10 k = 1 , 3
               dum = dum + b(i, k) * d(k, j)
   10       continue
            w(i, j) = dum
   20    continue
   30 continue
c
      return
      end
c----------------------------------------------------------------
      subroutine moltv(b, d, w)
        dimension b(3,3), d(3), w(3)
c
c ---  matrix * matrix
c
      do 30 i = 1 , 3
            dum = 0
            do 10 k = 1 , 3
               dum = dum + b(i, k) * d(k)
   10       continue
            w(i) = dum
   30 continue
c
      return
      end
c ------------------------------------------------------------------
      subroutine Orto_new(a, b, c, alfa, beta, gamma)
c ---
c     definizione della matrice rm per trasformazione
c     da spazio triclino ad ortonormale
c ---
      common /matr/rmnew(3,3),rminew(3,3)
c
      pi = 4*datan(1.d0)
      alf = pi/180*alfa
      bet = pi/180*beta
      gam = pi/180*gamma
c---- sistema scelto
c-    e2 along  b  e1 along b x c

      cosome=(cos(bet)-cos(alf)*cos(gam))/(sin(alf)*sin(gam))

      if (cosome .gt.  1.0) cosome = 1.0
      if (cosome .lt. -1.0) cosome =-1.0
      ome = acos(cosome)
c
      rmnew(1,1) = a*sin(gam)*sin(ome)
      rmnew(1,2) = 0
      rmnew(1,3) = 0
      rmnew(2,1) = a*cos(gam)
      rmnew(2,2) = b
      rmnew(2,3) = c*cos(alf)
      rmnew(3,1) = a*sin(gam)*cos(ome)
      rmnew(3,2) = 0
      rmnew(3,3) = c*sin(alf)
c----
      return
      end
c -----------------------------------------------------------------
      subroutine Orto_newi(a, b, c, alfa, beta, gamma)
c ---
c     definizione della matrice rm per trasformazione
c     da spazio triclino ad ortonormale
c ---
      common /matr/rmnew(3,3),rminew(3,3)
c
      pi = 4*datan(1.d0)
      alf = pi/180*alfa
      bet = pi/180*beta
      gam = pi/180*gamma
c---- sistema scelto
c-    e2 along  b  e1 along b x c

      cosome=(cos(bet)-cos(alf)*cos(gam))/(sin(alf)*sin(gam))

      if (cosome .gt.  1.0) cosome = 1.0
      if (cosome .lt. -1.0) cosome =-1.0
      ome = acos(cosome)
c
      rminew(1,1) = 1.0/(a*sin(gam)*sin(ome))
      rminew(1,2) = 0
      rminew(1,3) = 0
      rminew(2,1) = 1.0/(b*tan(alf)*tan(ome))-1.0/(b*tan(gam)*sin(ome))
      rminew(2,2) = 1.0/b
      rminew(2,3) = -1.0/(b*tan(alf))
      rminew(3,1) = -1.0/(c*sin(alf)*tan(ome))
      rminew(3,2) = 0
      rminew(3,3) = 1.0/(c*sin(alf))
c ---
      return
      end
c -----------------------------------------------------------------
      subRoutine molt1_rot(a, b, c)
      dimension a(3,3), b(3), c(3)
c
c ---  matrix * vector
c
      do 20 i=1, 3
         c(i) = 0
         do 10 j=1, 3
            c(i) = c(i) + a(i,j) * b(j)
   10    continue
   20 continue
c
      return
      end
c----------------------------------------------------------------
      subroutine Write_CCP4_Map(x, MapNumber)
      USE General
      USE Symmetry
      USE Mappa , only: np
!
      real x(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      character*7 string_map
      character*200 filename_map
      
      nSpaceGroup_Sav = 0
!
      if (MapNumber < 0 .or. MapNumber > 99) then
         write(lo,*) 'ERROR: MapNumber  must be in range 0-99',MapNumber
         return
      endif
      write(lo,30) MapNumber

      if (MapNumber <= 9) then
          write(string_map,'(2h_0,i1,4h.map)') MapNumber
      elseif (MapNumber > 9 .and. MapNumber <= 99) then
          write(string_map,'(1h_ ,i2,4h.map)') MapNumber
      endif

      k = index(fname(1),'.bin')
      filename_map = fname(1)(1:k-1) // '_CCP4' // string_map

c     if (jpatt == 1 ) then
          nSpaceGroup_Sav = nSpaceGroup
c         nSpaceGroup = nSpaceGroupPatt
          nSpaceGroup = 1 ! faccio la mappa sempre in P1
c     endif

      call CCP4MAPOUT(1,x,np,filename_map)

c     if (jpatt == 1 ) then
          nSpaceGroup = nSpaceGroup_Sav
c     endif
c
   30 format(' ... exporting map in CCP4 format ...  MapNumber = ',i4,/)

      return
      end
!-----------------------------------------------------------------------
      subroutine Scrivi_Mappa_CCP4(filename)
      USE General
      USE Symmetry
      USE Mappa
!
      implicit none
      integer :: nSpaceGroup_Sav
      character (len=*) :: filename
      character (len=200) :: filename_map
!
      nSpaceGroup_Sav = 0
!
      nSpaceGroup_Sav = nSpaceGroup
      nSpaceGroup = 1 ! faccio la mappa sempre in P1
      filename_map = filename
!
      call CCP4MAPOUT(1,xmap,np,filename_map)
!
      nSpaceGroup = nSpaceGroup_Sav
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Scrivi_Fasi_Mappa_XTAL(numbM,MapNumber)
      USE General
      USE Riflessi
      USE Atomi
      USE PhaseModule
!
      integer trial
      character a8*8
      character*200 filename_map,filename_phs
!
      k = index(fname(1),'.bin')
      kk = kStripTask1(k)
      write(a8,"('_',i4)") MapNumber
      call NoBlanks(a8,k1)
      filename_phs = fname(1)(1:kk-1) // a8(1:k1) // '_Xtal.phs'
      filename_map = fname(1)(1:kk-1) // a8(1:k1) // '_Xtal.map'
!
      itype = 0
      iform = 1
      if (jopen(jrel,filename_phs,itype,iform,ios) < 0) go to 9400
!
      Msg = ' The files ' // filename_phs(1:Lung(filename_phs)) //
     *      ' and ' // filename_map(1:Lung(filename_map)) //
     *      ' have been written in Xtal format.'
      fMax = -9999
      do i=1,numbM
         if (fcoef(i).gt.fMax) then
             fMax = fcoef(i)
         endif
      enddo
      if (fMax.gt.9998.0) then
          scalaF = 9998.0 / fMax
      else
          scalaF = 1.0
      endif
      do i=1,numbM
         write(jrel,'(3i4,f8.2,f8.4,i5)')
     *        (khl(j,i),j=1,3),fcoef(i)*scalaF,wt(i),iphaz(i)
      enddo
    
      zero = 0.0
      i0   = 0
      i1   = 1
      if (lproj.eq.1) then
         write(jrel,'(3i4,f8.2,f8.4,i5)') i1,i0,i0,zero,zero,i0
      elseif (lproj.eq.2) then
         write(jrel,'(3i4,f8.2,f8.4,i5)') i0,i1,i0,zero,zero,i0
      elseif (lproj.eq.3) then
         write(jrel,'(3i4,f8.2,f8.4,i5)') i0,i0,i1,zero,zero,i0
      endif
    
      close(jrel)
!
      itype=0
      iform=2
      if (jopen(jhost,filename_map,itype,iform,ios).lt.0)  go to 9500
!
!-- analizza e normalizza la mappa
!
      call Analizza_Mappa_Xtal(xmap_coef)
!
!-- scrive l'header
!
      nByte = 4
      call scrivi_header_Xtal(nByte,jhost,filename_map,ierr)
!
!-- scrive la mappa
!
      call ScriviMappaXtal(nByte,jhost,xmap_coef,xmap_div,ierr)
      close(jhost)
!
      return

 9400 write(Msg,9410) ios,filename_phs(1:Lung(filename_phs))
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
 9410 format(' Open  error, code =',i5,' file is ',a)
      ierr = -1
      return

 9500 write(Msg,9410) ios,filename_map(1:Lung(filename_map))
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      ierr = -1
c
      end
!-----------------------------------------------------------------------
      subroutine AggiornaCoordinateAtomi(ier)
      USE General
      USE Atomi
      USE RemoModule
      implicit none
      integer :: ier, i, j, nBonds, iAction
!
      do i=1,nats
         model(WhichModel)%atoms(1:5,i,1) = xyzs(1:5,i)
         model(WhichModel)%specie(i,1)    = nz(i)
      enddo
!
!-- update connectivity
!
      nBonds = iconn(1)
      BondsInModel(WhichModel) = nBonds
      if (.not.allocated(Bonds(WhichModel)%Legami)) then
          iAction = 1
          call AllocaBonds(iAction)
      endif
      j = 1
      do i=1, nBonds
         Bonds(WhichModel)%Legami(1,i) = iconn(j+1)
         Bonds(WhichModel)%Legami(2,i) = iconn(j+2)
         Bonds(WhichModel)%Legami(3,i) = iconn(j+3)
         j = j + 3
      end do
!
      return
      end
!-----------------------------------------------------------------------
      subroutine save_restore_model(iAction, mdl, ier)
      USE General
      USE Atomi
      USE RemoModule
      USE Molcom
!
      implicit none
      integer :: iAction, mdl, ier, i, niconn, interp
!
      if (iAction == 1) then
          niconn = iconn(1) * 3 + 1
          write(mdl,10)
          write(mdl,20) nats, NatMol, iconn(1), NumLeg, nlp, ifCont
          write(mdl,200) BTot
          write(mdl,30)
!
!-- asymmetric coordinates
!
          do i=1, nats
             write(mdl,40) aLab(i), nz(i), serial(i), xyzs(:,i), bfac(i)
             write(mdl,50) bij(:,i)
             write(mdl,50) xyzs_dev(:,i), Occ_dev(i), bfac_dev(i)
             write(mdl,60) bij_dev(:,i), SiteInfo(:,i), iGeomAtom(i)
             write(mdl,60) bij_dev(:,i), SiteInfo(:,i), iGeomAtom(i)
          enddo
!
!-- connectivity
!
          write(mdl,70) 
          write(mdl,20) iconn(1:niconn)
!
!-- On screen positions
!
          write(mdl,80) 
          do i=1, NatMol + NatSpi
             write(mdl,90) Lab(i), nzTot(i), iOrd(i), iCol(i), iEqui(i),
     *                     nOpEq(i), SinglePlotType(i)
             write(mdl,100) xyz(:,i), Rs(i), rMLu(i)
             write(mdl,100) Ell(:,:,i)
             write(mdl,100) cd(:,:,i)
          enddo
!
!-- On screen connectivity
!
          write(mdl,110) 
          write(mdl,20) LE(1:3,1:NumLeg + nlp)
          
      else
          read(mdl,'(a)') Inte   ! skip comment ##
          read(mdl,'(a)') Inte   ! skip comment ##
          read(mdl,20) nats, NatMol, iconn(1), NumLeg, nlp, ifCont
          read(mdl,200) BTot
!
!-- asymmetric coordinates
!
          read(mdl,'(a)') Inte   ! skip comment ##
          read(mdl,'(a)') Inte   ! skip comment ##
          read(mdl,'(a)') Inte   ! skip comment ##
          read(mdl,'(a)') Inte   ! skip comment ##
          read(mdl,'(a)') Inte   ! skip comment ##
          do i=1, nats
             read(mdl,40) aLab(i), nz(i), serial(i), xyzs(:,i), bfac(i)
             read(mdl,50) bij(:,i)
             read(mdl,50) xyzs_dev(:,i), Occ_dev(i), bfac_dev(i)
             read(mdl,60) bij_dev(:,i), SiteInfo(:,i), iGeomAtom(i)
             read(mdl,60) bij_dev(:,i), SiteInfo(:,i), iGeomAtom(i)
          enddo
!
!-- connectivity
!
          niconn = iconn(1) * 3 + 1
          read(mdl,'(a)') Inte   ! skip comment ##
          read(mdl,20) iconn(1:niconn)
!
!-- On screen positions
!
          read(mdl,'(a)') Inte   ! skip comment ##
          read(mdl,'(a)') Inte   ! skip comment ##
          read(mdl,'(a)') Inte   ! skip comment ##
          read(mdl,'(a)') Inte   ! skip comment ##
          read(mdl,'(a)') Inte   ! skip comment ##
          do i=1, NatMol + NatSpi
             read(mdl,90) Lab(i), nzTot(i), iOrd(i), iCol(i), iEqui(i),
     *                     nOpEq(i), SinglePlotType(i)
             read(mdl,100) xyz(:,i), Rs(i), rMLu(i)
             read(mdl,100) Ell(:,:,i)
             read(mdl,100) cd(:,:,i)
          enddo
*         call AggiuSpig
!
!-- On screen connectivity
!
          read(mdl,'(a)') Inte   ! skip comment ##
          read(mdl,20) LE(1:3,1:NumLeg + nlp)
!
          interp = 1
          call PutGetXyzs(1, interp)
          call PutModel
      endif
!
      return
   10 format('## nats, NatMol, iconn(1), NumLeg, nlp',
     *     /,'## BTot')
   20 format(20i4)
   30 format('## Asymmetric coordinates, for each atom:',
     *     /,'## aLab, nz, serial, xyzs, bfac',
     *     /,'##       bij',
     *     /,'##       xyzs_dev, Occ_dev, bfac_dev',
     *     /,'##       bij_dev, SiteInfo, iGeomAtom')
   40 format(a16,2i8,12f10.4)
   50 format(16x,15f10.4)
   60 format(16x,10f10.4,i8)
   70 format('## connectivity')
   80 format('## Symmetry equivalent coordinates, for each atom:',
     *     /,'## Lab, nzTot, iOrd, iCol, iEqui, nOpEq, SinglePlotType',
     *     /,'##      xyz, Rs, rMLu',
     *     /,'##      Ell',
     *     /,'##      cd')
   90 format(a16,10i6)
  100 format(16x,9f10.4)
  110 format('## On screen connectivity')
  200 format(9f10.4)
      end
!-----------------------------------------------------------------------
!corr      subroutine LeggiMolFile(ier) 
!corr      USE atom_type_util
!corr      USE General
!corr      USE chem_file_fmt
!corr      USE strutil
!corr      USE Atomi
!corr      USE errormod
!corr      implicit none
!corr      integer, intent(out)                       :: ier
!corr      type(atom_type), allocatable, dimension(:) :: atom
!corr      type(error_type)                           :: err_read
!corr!
!corr!     Leggi informazioni da file esterno
!corr      call read_molfile(jhost,cell,Species(:nk),atom,iconn,err_read)
!corr      if (err_read%signal) then
!corr          ier = -1
!corr      else
!corr          ier = 0
!corr!
!corr!         crea informazioni addizionali sul modello
!corr          call build_model_info(atom)
!corr      endif
!corr!   
!corr      end subroutine LeggiMolFile            
!-----------------------------------------------------------------------
!corr      subroutine LeggiMol2File(ier) 
!corr      USE atom_type_util
!corr      USE General
!corr      USE chem_file_fmt
!corr      USE strutil
!corr      USE Atomi
!corr      USE errormod
!corr      implicit none
!corr      integer, intent(out)                       :: ier
!corr      type(atom_type), allocatable, dimension(:) :: atom
!corr      type(error_type)                           :: err_read
!corr!
!corr!     Leggi informazioni da file esterno
!corr      call read_mol2file(jhost,cell,Species(:nk),atom,iconn,err_read)
!corr      if (err_read%signal) then
!corr          ier = -1
!corr      else
!corr          ier = 0
!corr!
!corr!         crea informazioni addizionali sul modello
!corr          call build_model_info(atom)
!corr      endif
!corr!   
!corr      end subroutine LeggiMol2File            
!-----------------------------------------------------------------------
!corr      subroutine LeggizmtFile(ier)
!corr      USE General
!corr      USE chem_file_fmt
!corr      USE errormod
!corr      USE Atomi
!corr      USE atom_type_util
!corr      USE strutil
!corr      USE ptable
!corr      implicit none
!corr      integer, intent(out)                       :: ier
!corr      type(atom_type), allocatable, dimension(:) :: atom
!corr      type(error_type)                           :: err_read
!corr!
!corr          integer                                :: pos, i
!corr          integer :: nums
!corr          integer, dimension(18) :: nvspec,zvspec
!corr!      
!corr      call read_zmtfile(jhost,cell,atom,err_read)
!corr      if (.not.err_read%signal) then
!corr          if (InfoOK(3) == 0) then
!corr              call info_specie_from_z(atom(:)%nz,nums,nvspec,zvspec)
!corr              nk = nums
!corr              do i=1, nk
!corr                 Species(i) = specie_from_z(zvspec(i))
!corr                 nw(i)      = nvspec(i)
!corr              enddo
!corr          endif
!corr          do i=1,size(atom)
!corr             pos = position_stringv(atom(i)%lab,Species(:nk))
!corr             atom(i)%nz = pos*nzConst
!corr          enddo
!corr          call atom_string(atom)  ! genera label
!corr          ier = 0
!corr!
!corr!         crea informazioni addizionali sul modello
!corr          call build_model_info(atom)
!corr      else
!corr          ier = -1
!corr      endif
!corr!      
!corr      end subroutine LeggizmtFile
!-----------------------------------------------------------------------
      subroutine LeggiXYZFile(ier)
      USE atom_type_util
      USE General
      USE chem_file_fmt
      USE errormod
      USE Atomi
      integer, intent(out)                       :: ier
      type(atom_type), allocatable, dimension(:) :: atom
      type(error_type)                           :: err_read
!
!     Prova a leggere il file come se fosse un expo fragment file
      call read_xyzfile(jhost,cell(1:6),atom,err_read)
!      
      if (err_read%signal) then
          ier = -1
      else
          ier = 0
          iconn(:) = 0
!
!         crea informazioni addizionali sul modello
          call build_model_info(atom)
      endif    
!
      end subroutine LeggiXYZFile
!-----------------------------------------------------------------------
!corr      subroutine LeggimopFile(ier)
!corr      USE atom_type_util
!corr      USE General
!corr      USE chem_file_fmt
!corr      USE errormod
!corr      USE Atomi
!corr      implicit none
!corr      integer, intent(out)                        :: ier
!corr      type(atom_type), allocatable, dimension(:)  :: atom
!corr      type(error_type)                            :: err_read
!corr!
!corr      call read_mopintfile(jhost,cell,atom,err_read)
!corr!      
!corr!     se si genera errore leggi il file come mop a coordinate cartesiane
!corr      if (err_read%signal) then
!corr          call reallocate(atom,0)
!corr          rewind (jhost)
!corr          call read_mopcartfile(jhost,cell,atom,err_read)
!corr      endif
!corr!      
!corr      if (err_read%signal) then
!corr          !call print_error_message(err_read)
!corr          ier = -1
!corr      else
!corr          ier = 0
!corr!
!corr!         crea informazioni addizionali sul modello
!corr          call build_model_info(atom)
!corr      endif    
!corr!      
!corr      end subroutine LeggimopFile
!-----------------------------------------------------------------------
      subroutine Ricicla(VettRisultati, doRicicla, stampaInfo, ier)
      USE General
      USE Riflessi
      USE PhaseModule
      USE ArpWarp
      USE Molcom, only : jscreen
      USE Groups
      USE Grafici
!
      implicit none
      integer :: ier, iAction, lix1, lix2, nExitCode, ksubr
      integer :: Lung, cod, ifmin, knwSav, ifBreak, doRicicla
      integer :: k, kk, k1, kStripTask1, stampaInfo, ipher
      integer :: itype, iform, jop, jopen
      real    :: celltemp(13), correl, VecchioCoverage
      real    :: VettRisultati(10)
      logical :: Esiste
      character tirang * 11
      character stringa *20
      character(len=256) :: MTZfileSav, FichierOut_SAV
!
      kWstop = 0
c     if (ifRemo > 0) then
      if (ifRemo > 0 .and. jscreen > 0) then
          nLinesGR = nLinesGR_Amb
          lastBox = Box_Amb
          inBoxGR(lastBox) = inBoxGR_Amb
      endif
!
      
!TEST!numbGen = 0
      ier = 0
      k = index(fname(1),'.bin')
      kk = kStripTask1(k) - 1
      nome = fname(1)(1:kk)
      lnome = Lung(nome)
!
!--- Check for heavy atoms
!
      if (nAcid > 0 .and. nResidStored == 0) then
          call HeavyPDB
      else
          ifHeavyPDB = 0
      endif
!
      if (ifAmb == 1) then
          call PreparaBuccaneer(doRicicla, kWstop, stampaInfo, ier)
      elseif (ifAmb == 2) then
          call PreparaArpWarp(doRicicla, kWstop, stampaInfo, ier)
      elseif (ifAmb == 3) then
          call PreparaPhenix(doRicicla, kWstop, stampaInfo, ier)
      elseif (ifAmb == 4) then
          call PreparaNautilus(doRicicla, kWstop, stampaInfo, ier)
      endif
!
!-- check if Buccaneer, ARP/wARP, Phenix or Nautilus worked correctly
!-- ifAMB =     1          2        3          4
!
      if (ifAmb == 2) then
          cardDiret = WorkingDirectory(1:Lung(WorkingDirectory))
     *             // slash // nome(1:lnome) // '_refmac.mtz '
      else
          cardDiret = MTZfile
      endif
      inquire (file=cardDiret,  exist = Esiste)
      if (.not. Esiste) then
          ifAmb = 0
      endif
      if (ifAmb == 1) then
          cardDiret = WorkingDirectory(1:Lung(WorkingDirectory))
     *             // slash // nome(1:lnome) // '_buccaneer.log '
      elseif (ifAmb == 2) then
          cardDiret = WorkingDirectory(1:Lung(WorkingDirectory))
     *             // slash // nome(1:lnome) // '_arp.log '
      elseif (ifAmb == 3) then
          cardDiret = WorkingDirectory(1:Lung(WorkingDirectory))
     *             // slash // nome(1:lnome) // '_phenix.log '
      elseif (ifAmb == 4) then
          cardDiret = WorkingDirectory(1:Lung(WorkingDirectory))
     *             // slash // nome(1:lnome) // '_nautilus.log '
      endif
      inquire (file=cardDiret,  exist = Esiste)
      if (.not. Esiste) then
          ifAmb = 0
      endif
      if (ifAmb == 0) then
          return
      endif

      if (ifAmb == 2 .or. ifAmb == 3) then
          MTZfileSav = MTZfile
          MTZfile = WorkingDirectory(1:Lung(WorkingDirectory)) // slash
     *       // nome(1:lnome) // '_refmac.mtz '
      endif
!
      if (knw > 0) then
          write(lo,10) MTZfile(1:Lung(MTZfile))
      endif
      lix1 = 1
      lix2 = 1
      Lab_Ch(1) = 'H'
      Lab_Ch(2) = 'K'
      Lab_Ch(3) = 'L'
      Lab_Ch(4) = 'F'
      Lab_Ch(5) = 'SIGF'
      Lab_Ch(6) = 'PHIC_ALL' ! fase
      Lab_Ch(7) = 'FOM'      ! peso
      Lab_Ch(8) = 'FC_ALL'   ! fc
      ifMTZlab = 1
      do iAction =1, 2
         call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
         if (ier /= 0) then
             Msg = 'Error reading MTZ file ' // MTZfile(1:Lung(MTZfile))
             call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
             doRicicla = 0
             return
         endif
      enddo
!
      iAction = 1
      call AllocaRiflessi(iAction)
      ksubr = 4
      call LeggiRiflessi(ier, ksubr)
!
      knwSav = knw
      knw = 0
      call LeggiMTZPhase(ier)
!
      iAction = 3
      call ManageMTZ(iAction, celltemp, lix1, lix2, ier)     !mr
!
      if (ifAmb == 2 .or. ifAmb == 3) then
          MTZfile = MTZfileSav
      endif
!
      knw = knwSav
      if (knw > 0) then
          ifmin = 1
          cod = 1000
          call examin(cod, mkang, khl, ipub, iphaz, nrefl, 0, wt, ifmin)
          
          tirang = 'Distr. AMB '
          ipher = 1
          call pherrdisNew(tirang,wt,khl,mkang,nrefl,0,
     *                    ipub,iphaz,wt,10,0.0,ipher)

          VettRisultati(4) = erore
          if (ifAmb == 1) then
              write(lo,20) 'Buccaneer',erore, erorepes, isumal
          elseif (ifAmb == 2) then
              write(lo,20) 'Arp/Warp',erore, erorepes, isumal
          elseif (ifAmb == 3) then
              write(lo,20) 'Phenix',erore, erorepes, isumal
          elseif (ifAmb == 4) then
              write(lo,20) 'Nautilus',erore, erorepes, isumal
          endif
          write(lo,30) resol_obs_max, nint(VettRisultati(1:4))
      endif
!
      FichierOut_SAV = FichierOut

      write(stringa,15) ncontAMB
      call NoBlanks(stringa,k1)
      k = index(FichierOut,'.')
      kk = kStripTask1(k)-1
c     kk = k-1

*** spostate sotto
***   FichierOut = FichierOut(1:kk)//stringa(1:k1)//'.pdb'
***   call cCopyFile(FichierOut_SAV, FichierOut)
!

      if (stampaInfo == 0) then
          call LoadPDBfromAmb(0)
      else
          call LoadPDBfromAmb(1)
      endif
!
      FichierOut = FichierOut(1:kk)//stringa(1:k1)//'.pdb'
      call cCopyFile(FichierOut_SAV, FichierOut)

      inquire (file=FichierOut,  exist = Esiste)
      if (Esiste) then
          itype = 2
          iform = 1
          jop = jopen(jhost, FichierOut, itype, iform, ier)
          close(jhost, status='delete')
      endif
      FichierOut = FichierOut_SAV
!
      if (kWstop == 0) then
          VecchioCoverage =  coverageOld + 3
          if (coverage < VecchioCoverage) then
              doRicicla = 0
          else
              coverageOld = coverage
              if (coverage > 0.0) then
                  UpdateMTZ = .true.
              endif
          endif
       endif
!
      return
   10 format(//,2x,'Reading phases from ',a)
   15 format ('_',i4)
   20 format(/,2x,'After ',a,' - Mean Phase Error ',f6.2,
     *       '  (',f6.2,')  over',i8,' reflections')
   30 format('TESTVETA ',';',f6.2,' ;',5(i3,' ;'))
      end
!-----------------------------------------------------------------------
      subroutine RestoreAmbEnan
      USE General
      USE ArpWarp
      USE Dialogo,only: ifMadEnv, color_RED, color_GREEN, color_LIGHTRED
      USE Grafici
      USE Properties
!
      implicit none
      integer :: box, Lung, k
      logical :: Esiste
!
      box = 3
      if (ifAmbEnan == 1) then
          write(Msg,'(a,a)') ' Buccaneer results: ', erreAW
      elseif (ifAmbEnan == 2) then
          write(Msg,'(a,a)') ' ARP/wARP results: ', erreAW
      elseif (ifAmbEnan == 4) then
          write(Msg,'(a,a)') ' Nautilus results: ', erreAW
      endif
      write(lo,'(/,a)') Msg(1:Lung(Msg))
      if (ifMadEnv > 0) then
          call TestoGR(Msg, color_GREEN, 2, box)
      endif
      if (residuesAW >= 0) then
          write(Msg,40) ' Sequenced residues = ', residuesAW
          write(lo,'(/,a)') Msg(1:Lung(Msg))
          if (ifMadEnv > 0) then
              call TestoGR(Msg, color_GREEN, 2, box)
          endif
          write(Msg,45) ' Sequence coverage  = ', nint(coverage), '%'
          write(lo,'(a)') Msg(1:Lung(Msg))
          if (ifMadEnv > 0) then
              call TestoGR(Msg, color_GREEN, 2, box)
          endif
      else
          write(Msg,40) ' Sequenced residues = n.a.'
          write(lo,'(/,a)') Msg(1:Lung(Msg))
          if (ifMadEnv > 0) then
              call TestoGR(Msg, color_GREEN, 2, box)
          endif
          write(Msg,40) ' Sequence coverage  = n.a.'
          write(lo,'(/,a)') Msg(1:Lung(Msg))
          if (ifMadEnv > 0) then
              call TestoGR(Msg, color_GREEN, 2, box)
          endif
      endif
!
      Msg = 'Files produced after Automated Model Building:'
      call TestoGR(Msg, -1, 2, box)
      write(lo,60) Msg(1:Lung(Msg))
      k = index(MTZfile, slash, .TRUE.) + 1
      Msg = '    ' // MTZfile(k:)
      k = Lung(Msg) + 1
      inquire (file = FichierOut,  exist = Esiste)
      if (Esiste) then
          Msg(k+2:) = FichierOut(1:Lung(FichierOut))
      else
          Msg(k+2:) = 'no PDB file created'
      endif
      k = Lung(Msg)
      call TestoGR(Msg, color_GREEN, 2, box)
      write(lo,"(' ',a)") Msg(1:Lung(Msg))
!
      WhichProps = 1
      call FillAtmStruct
      call SaveLists123
!
      call LoadPDBfromAmb(1)
!
      call GetFromAtmStruct
      call PutGetXyzs(1, 0)
      call RestoreLists123(2)
!
      return
!
   40 format(a,i5)
   45 format(a,i5,a)
   60 format(/,' ',a,/,'     MTZ format',12x,' PDB format')
      end
!-----------------------------------------------------------------------
      subroutine PreparaArpWarp(doRicicla, kWstop, stampaInfo, ier)
      USE PhaseModule, only : erore
      USE General
      USE Groups
      USE ArpWarp
      USE Dialogo,only: ifMadEnv, color_RED, color_GREEN, color_LIGHTRED
      USE Grafici
!
      implicit none
      integer :: k, Lung, ier, box, segno
      integer :: istat, iform, jop, jopen, ierr, n_cicloAW, nPDB
      integer :: doRicicla, kWstop, stampaInfo
      real    :: elTime
      logical :: ToBeUpdated = .false.
      logical :: Esiste
      character (len=3) :: csegno
!
*     coverageSog = -1   ! PEZZA
      nAcid = 0
      if (stampaInfo == 1) then
          if (ncontAMB <= 1) then
              Msg =
     *          "<big><b>Automated Model Building (ARP/wARP)</b></big>"
          else
              write(csegno,'(a,i2)') '#', ncontAMB
              Msg =
     *        "<big><b>Automated Model Building " // csegno //
     *        " (ARP/wARP)</b></big>"
          endif

          if (ifMadEnv /= 0) then
              box = lastBox + 1
              call TestoGR(Msg, color_RED, 2, box)
              Msg =
     *         'The best set of phases will be used to build the model.'
              call TestoGR(Msg, -1, 2, box)
              Msg = 'Be patient, it will take some time ...'
              call TestoGR(Msg, color_LIGHTRED, 2, box)
          endif
      endif
      call zflush
      call DoSingleIteration()
!
!-- Write pir file
!
      SeqFile = nome(1:lnome) // '.pir'
      call WritePirSequence(Buffer1, lo, jhost, stampaInfo)
!
      if (doRicicla == 1) then
          n_cicloAW = 3
      else
          n_cicloAW = 1
      endif
!
      n_cicloAW = 1
!
      do cicloAW=1, n_cicloAW
         ToBeUpdated = .true.
!
!-- remove old ARP/wARP files
!
         cardDiret = WorkingDirectory(1:Lung(WorkingDirectory)) // slash
     *            // nome(1:lnome) // '_refmac.mtz '

*      go to 1

         inquire (file=cardDiret,  exist = Esiste)
         if (Esiste) then
             istat = 2
             iform = 1
             jop = jopen(jhost, cardDiret, istat, iform, ierr)
             close(jhost, status='delete',err=9000)
         endif

         cardDiret = WorkingDirectory(1:Lung(WorkingDirectory)) // slash
     *            // nome(1:lnome) // '_arp.log'
         inquire (file=cardDiret,  exist = Esiste)
         if (Esiste) then
             istat = 2
             iform = 1
             jop = jopen(jhost, cardDiret, istat, iform, ierr)
             close(jhost, status='delete',err=9000)
         endif
         cardDiret = WorkingDirectory(1:Lung(WorkingDirectory)) // slash
     *            // nome(1:lnome) // '_refmac.log'
         inquire (file=cardDiret,  exist = Esiste)
         if (Esiste) then
             istat = 2
             iform = 1
             jop = jopen(jhost, cardDiret, istat, iform, ierr)
             close(jhost, status='delete',err=9000)
         endif


         cardDiret = nome(1:lnome) // 'arp.mtz '
         inquire (file=cardDiret,  exist = Esiste)
         if (Esiste) then
             istat = 2
             iform = 1
             jop = jopen(jhost, cardDiret, istat, iform, ierr)
             close(jhost, status='delete',err=9000)
         endif

         cardDiret = nome(1:lnome) // '_arp.pdb '
         inquire (file=cardDiret,  exist = Esiste)
         if (Esiste) then
             istat = 2
             iform = 1
             jop = jopen(jhost, cardDiret, istat, iform, ierr)
             close(jhost, status='delete',err=9000)
         endif

*   1              continue
!
         if (nAcid > 0) then !  .and. nResidStored == 0) then
!
!-- Write nuce_arp.sh file
!
             if (ifAmb == 2) then
                 call WriteShellScript('nuce_arp.sh', stampaInfo)
             endif
!
         endif
!
!-- Weight supplied instead of Sequence
!
         if (nResidStored == 0 .and. numeroResidui > 0) then
             nResidStored = numeroResidui
             coverageSog = -100
         endif
         if (nResidStored > 0) then
!
!-- Write arprun_phases.sh
!
             call WriteShellScript('arprun_phases.sh', stampaInfo)
         endif
!
!-- Write refmac_arp.sh
!
         call WriteShellScript('refmac_arp.sh', stampaInfo)
!
!-- Write structurename_run_arp.sh
!
         Inte = 'run_arp.sh'
         call WriteShellScript(Inte, stampaInfo)
!
!-- Start arp/warp shell script
!   
         if (knw == 1) then
             call CheckMtzMpe(segno)
             if (segno > 0) then
                 csegno = '(+)'
             else
                 csegno = '(-)'
             endif
*            if (stampaInfo == 1)
*    *       write(lo,'(a,f6.2,2x,a)') 
             write(lo,'(a,f6.2,2x,a)') 
     *             ' Starting ARP/wARP ... MPE =', erore, csegno
         else
             if (stampaInfo == 1)
     *       write(lo,'(a)') ' Starting ARP/wARP ...'
         endif
         Buffer1 = WorkingDirectory(1:Lung(WorkingDirectory)) // slash
     *          // nome(1:lnome) // '_' // Inte
         k = Lung(Buffer1)
         Buffer1(k+1:k+1) = char(0)
         Msg = 
     *       ' Running ARP/wARP. Please wait, this can take some time.'
         call PrintMess(Msg)
         call DoSingleIteration()
         call zflush
!
         if (stampaInfo == 1) then
             call elapsed_time(1, elTime, ' ', ' ')
         endif
         call Lanciash(Buffer1)
         if (stampaInfo == 1) then
             call elapsed_time(2, elTime, 'ARP/wARP', MessH)
         endif
*        endif                     ! PEZZA
!
*        if (stampaInfo == 1) then
*            write(0,'(a)') ' ... done'
*        endif
!
!-- add arp/warp log info to output file
!
         call AppendArpPhenixLog(stampaInfo, nPDB)
!
         if (.not.(cicloAW == 1. and. ifHeavyPDB > 0)) then
             if (coverage >= 0) then
                 if (coverage > coverageSog .or. coverage < 2) then
                     exit
                 endif
             else
                 exit
             endif
         endif
         if (cicloAW >= 1 .and. cicloAW < n_cicloAW) then
             write(lo,10) ' Re-Starting ARP/wARP ...'
         endif
         numbGen = 0
         call UpdatePDB(nPDB)
         ToBeUpdated = .false.
!
      enddo
      if (coverage < 0) then
          if (nint(coverage) /= -1 .or. nint(coverageSog) /= -100) then
              ToBeUpdated = .false.
          endif
      endif
      if (ToBeUpdated) then ! .and. stampaInfo == 1) then
          call UpdatePDB(nPDB)
      endif
!
      if (ifAmb /= 0) then
!*!   if (stampaInfo == 1) then
!*!       write(lo,*)
!*!       if (ifMadEnv /= 0) then
!*!           if (coverage >= 0) then
!*!               write(Msg,'(a,i3,a1)') 
!*!  *                  'Sequence coverage =', nint(coverage), '%'
!*!           else
!*!               write(Msg,'(a)') 
!*!  *                  'Sequence coverage n.a.'
!*!           endif
!*!           call TestoGR(Msg, color_GREEN, 2, box)
!*!       endif
!*!       if (ifMadEnv /= 0 .and. erreAW(1:1) /= ' ') then
!*!           Msg = 'ARP/wARP results: ' // erreAW
!*!           call TestoGR(Msg, color_GREEN, 2, box)
!*!       endif

          MTZfile = nome(1:lnome) // '_arp.mtz '
          cardDiret = WorkingDirectory(1:Lung(WorkingDirectory)) //
     *                  slash // nome(1:lnome) // '_refmac.mtz '
          call cCopyFile(cardDiret, MTZfile)
          cardImage = nome(1:lnome) // "_arp.pdb"
          inquire (file=cardImage,  exist = Esiste)
          if (Esiste) then
             FichierOut = nome(1:lnome) // '_arp.pdb'
             AmbPDB = FichierOut
          endif

      endif
!
      if (ifMadEnv /= 0) then ! . and. stampaInfo == 1) then
         if (doRicicla /= 1) then 
             call WriteAmbResults(stampaInfo)
         endif
!     if (stampaInfo == 1) then
!         if (ifAmb /= 0) then
!             MTZfile = WorkingDirectory(1:Lung(WorkingDirectory)) //
!    *                  slash // nome(1:lnome) // '_refmac.mtz '
!             Msg = 'Files produced after Automated Model Building:'
!             write(lo,60) Msg(1:Lung(Msg))
!             box = lastBox
!             call TestoGR(Msg, -1, 2, box)
!             k = index(MTZfile, slash, .TRUE.) + 1
!             Msg = '    ' // MTZfile(k:)
!             Msg(28:) = FichierOut(1:Lung(FichierOut))
!             k = Lung(Msg)
!             call TestoGR(Msg, color_GREEN, 2, box)
!             write(lo,"(' ',a)") Msg(1:Lung(Msg))
!         endif
      endif
!
c     if (coverage > coverageSog .and. stampaInfo == 1) then
c         kWstop = 1
c     endif
!
      return
 9000 ier = -1
      return
   10 format(///,' ',78('+'),//,a,/)
   60 format(/,' ',a,/,'     MTZ format',12x,' PDB format')
      end
!-----------------------------------------------------------------------
      subroutine PreparaPhenix(doRicicla, kWstop, stampaInfo, ier)
      USE General
      USE PhaseModule, only : erore
      USE Groups
      USE ArpWarp
      USE Dialogo,only: ifMadEnv, color_RED, color_GREEN, color_LIGHTRED
      USE Grafici
!
      implicit none
      integer :: k, Lung, ier, box, doPhenix, segno
      integer :: istat, iform, jop, jopen, ierr, n_cicloAW, nPDB
      integer :: doRicicla, kWstop, stampaInfo
      real    :: elTime
      logical :: ToBeUpdated = .false.
      logical :: Esiste
      character (len=3) :: csegno
!
*     coverageSog = -1   ! PEZZA
      if (stampaInfo == 1) then
          Msg = "<big><b>Automated Model Building (Phenix)</b></big>"
          if (ifMadEnv /= 0) then
              box = lastBox + 1
              call TestoGR(Msg, color_RED, 2, box)
              Msg =
     *         'The best set of phases will be used to build the model.'
              call TestoGR(Msg, -1, 2, box)
              Msg = 'Be patient, it will take some time ...'
              call TestoGR(Msg, color_LIGHTRED, 2, box)
          endif
      endif
!
!-- Write pir file
!
      SeqFile = nome(1:lnome) // '.pir'
      call WritePirSequence(Buffer1, lo, jhost, stampaInfo)
!
      n_cicloAW = 1
      do cicloAW=1, n_cicloAW
         ToBeUpdated = .true.
!
!-- remove old phenix files
!
         cardDiret = WorkingDirectory(1:Lung(WorkingDirectory)) // slash
     *            // nome(1:lnome) // '_refmac.mtz '

       go to 1

         inquire (file=cardDiret,  exist = Esiste)
         if (Esiste) then
             istat = 2
             iform = 1
             jop = jopen(jhost, cardDiret, istat, iform, ierr)
             close(jhost, status='delete',err=9000)
         endif
    1              continue

         cardDiret = WorkingDirectory(1:Lung(WorkingDirectory)) // slash
     *            // nome(1:lnome) // '_refmac.log'
         inquire (file=cardDiret,  exist = Esiste)
         if (Esiste) then
             istat = 2
             iform = 1
             jop = jopen(jhost, cardDiret, istat, iform, ierr)
             close(jhost, status='delete',err=9000)
         endif

         cardDiret = nome(1:lnome) // 'phenix.mtz '
         inquire (file=cardDiret,  exist = Esiste)
         if (Esiste) then
             istat = 2
             iform = 1
             jop = jopen(jhost, cardDiret, istat, iform, ierr)
             close(jhost, status='delete',err=9000)
         endif

         cardDiret = nome(1:lnome) // '_phenix.pdb '
         inquire (file=cardDiret,  exist = Esiste)
         if (Esiste) then
             istat = 2
             iform = 1
             jop = jopen(jhost, cardDiret, istat, iform, ierr)
             close(jhost, status='delete',err=9000)
         endif

*   1              continue
!
         if (nResidStored > 0 .or. nAcid > 0) then
             if (ifAmbModel == 0) then ! Starting from phases
                 call WriteShellScript('phenixrun_phases.sh',stampaInfo)
             else                      ! Starting from model
                 call WriteShellScript('phenixrun_model.sh', stampaInfo)
             endif
         endif
!
!-- Write refmac_phenix.sh file
!
         call WriteShellScript('refmac_phenix.sh', stampaInfo)
!
!-- Write structurename_run_phenix.sh file
!
         Inte = 'run_phenix.sh'
         call WriteShellScript(Inte, stampaInfo)
!
         if (knw == 1) then
             call CheckMtzMpe(segno)
             if (segno > 0) then
                 csegno = '(+)'
             else
                 csegno = '(-)'
             endif
             write(lo,'(a,f6.2,2x,a)') 
     *             ' Starting Phenix ... MPE =', erore, csegno
         else
             write(lo,'(a)') ' Starting Phenix ...'
         endif
!
!-- Start phenix shell script
!
         Buffer1 = WorkingDirectory(1:Lung(WorkingDirectory)) // slash
     *          // nome(1:lnome) // '_' // Inte
         k = Lung(Buffer1)
         Buffer1(k+1:k+1) = char(0)
         Msg = ' Running Phenix ...'
         call PrintMess(Msg)
         call DoSingleIteration()
         call zflush
!
         call elapsed_time(1, elTime, ' ', ' ')
         doPhenix = 1
         if (doPhenix == 1) then
            call Lanciash(Buffer1)
         endif
         call elapsed_time(2, elTime, 'Phenix', MessH)
*        endif                     ! PEZZA
!
*        write(0,'(a)') ' ... done'
!
!-- add phenix log info to output file
!
         call AppendArpPhenixLog(stampaInfo, nPDB)
!
         if (.not.(cicloAW == 1. and. ifHeavyPDB > 0)) then
             if (coverage >= 0) then
                 if (coverage > coverageSog .or. coverage < 2) then
                     exit
                 endif
             else
                 exit
             endif
         endif
         if (cicloAW >= 1 .and. cicloAW < n_cicloAW) then
             write(lo,10) ' Re-Starting Phenix ...'
         endif
         numbGen = 0
*        call UpdatePDB(nPDB)
*        ToBeUpdated = .false.
!
      enddo
      if (coverage < 0) then
          ToBeUpdated = .false.
      endif
c     FichierOut = nome(1:lnome) // '_phenix.pdb'
c     AmbPDB = FichierOut

      if (ifAmb /= 0) then
          MTZfile = nome(1:lnome) // '_phenix.mtz '
          cardDiret = WorkingDirectory(1:Lung(WorkingDirectory)) //
     *                  slash // nome(1:lnome) // '_refmac.mtz '
          call cCopyFile(cardDiret, MTZfile)
          cardImage = nome(1:lnome) // "_phenix.pdb"
          inquire (file=cardImage,  exist = Esiste)
          if (Esiste) then
             FichierOut = nome(1:lnome) // '_phenix.pdb'
             AmbPDB = FichierOut
          endif
      endif

*     if (ToBeUpdated) then
*         call UpdatePDB(nPDB)
*     endif
!
      write(lo,*)
!*!   if (ifMadEnv /= 0 .and. coverage >= 0) then
!*!       write(Msg,'(a,i3,a1)') 
!*!  *          'Sequence coverage =', nint(coverage), '%'
!*!       call TestoGR(Msg, color_GREEN, 2, box)
!*!   endif
!*!   if (ifMadEnv /= 0 .and. erreAW(1:1) /= ' ') then
!*!       Msg = 'Phenix results: ' // erreAW
!*!       call TestoGR(Msg, color_GREEN, 2, box)
!*!   endif
!
!*!   if (ifAmb /= 0) then
!*!       MTZfile = WorkingDirectory(1:Lung(WorkingDirectory)) // slash
!*!  *            // nome(1:lnome) // '_refmac.mtz '
!*!       Msg = 'Files produced after Automated Model Building:'
!*!       write(lo,60) Msg(1:Lung(Msg))
!*!       box = lastBox
!*!       call TestoGR(Msg, -1, 2, box)
!*!       k = index(MTZfile, slash, .TRUE.) + 1
!*!       Msg = '    ' // MTZfile(k:)
!*!       Msg(28:) = FichierOut(1:Lung(FichierOut))
!*!       k = Lung(Msg)
!*!       call TestoGR(Msg, color_GREEN, 2, box)
!*!       write(lo,"(' ',a)") Msg(1:Lung(Msg))
!*!   endif
!
c     if (coverage > coverageSog) then
c         kWstop = 1
c     endif
      if (ifMadEnv /= 0) then ! . and. stampaInfo == 1) then
          if (doRicicla /= 1) then 
              call WriteAmbResults(stampaInfo)
          endif
      endif
!
      return
 9000 ier = -1
      return
   10 format(///,' ',78('+'),//,a,/)
   60 format(/,' ',a,/,'     MTZ format',12x,' PDB format')
      end
!-----------------------------------------------------------------------
      subroutine PreparaBuccaneer(doRicicla, kWstop,stampaInfo, ier)
      USE General
      USE PhaseModule, only : erore
      USE Groups
      USE ArpWarp
      USE Dialogo,only: ifMadEnv, color_RED, color_GREEN, color_LIGHTRED
      USE Grafici
!
      implicit none
      integer :: k, Lung, ier, box, stampaInfo, segno
      integer :: istat, iform, jop, jopen, ierr, n_cicloAW, nPDB
      integer :: doRicicla, kWstop
      real    :: elTime
      logical :: Esiste
      character (len=3) :: csegno
      character (len=256) :: pathCCP4, pathPython
!
      coverageSog = 1000  !-1  PEZZA
!
      if (stampaInfo == 1) then
          write(lo,20)
          if (ncontAMB <= 1) then
              Msg = 
     *        "<big><b>Automated Model Building (Buccaneer)</b></big>"
          else
              write(csegno,'(a,i2)') '#', ncontAMB
              Msg = 
     *        "<big><b>Automated Model Building " // csegno // 
     *        " (Buccaneer)</b></big>"
          endif
          if (ifMadEnv /= 0) then
              box = lastBox + 1
              call TestoGR(Msg, color_RED, 2, box)
              Msg =
     *         'The best set of phases will be used to build the model.'
*         call TestoGR(Msg, color_GREEN, 2, box)
              call TestoGR(Msg, -1, 2, box)
              Msg = 'Be patient, it will take some time ...'
              call TestoGR(Msg, color_LIGHTRED, 2, box)
          endif
      endif
!
!-- remove old Buccaneer files
!

*     go to 22

      cardDiret = nome(1:lnome) // '_buccaneer.mtz '
      inquire (file=cardDiret,  exist = Esiste)
      if (Esiste) then
          istat = 2
          iform = 1
          jop = jopen(jhost, cardDiret, istat, iform, ierr)
          close(jhost, status='delete',err=9000)
      endif
!
      cardDiret = nome(1:lnome) // '_buccaneer.log '
      inquire (file=cardDiret,  exist = Esiste)
      if (Esiste) then
          istat = 2
          iform = 1
          jop = jopen(jhost, cardDiret, istat, iform, ierr)
          close(jhost, status='delete',err=9000)
      endif
!
      cardDiret = nome(1:lnome) // '_buccaneer.pdb '
      inquire (file=cardDiret,  exist = Esiste)
      if (Esiste) then
          istat = 2
          iform = 1
          jop = jopen(jhost, cardDiret, istat, iform, ierr)
          close(jhost, status='delete',err=9000)
      endif

   22 continue

!
!-- Write Buccaneer input file
!
!seqin 2qu5.pir
!mtzin 2qu5_remo.mtz
!colin-fo F,SIGF
!colin-phifom PHIMR,WTMR
!colin-free FreeR_flag
!pdbin-mr pdb/2qu5.pdb
!prefix 2qu5_bdir/
!pdbout 2qu5_buccaneer.pdb
!cycles 5
      if (ifW95 == 0) then
          Inte = nome(1:lnome) // '_run_buccaneer.sh '
      else
          Inte = nome(1:lnome) // '_run_buccaneer.bat '
      endif
      cardDiret = nome(1:lnome) // '_buccaneer.inp '
      if (stampaInfo == 1) then
          write(lo,200) cardDiret(1:Lung(cardDiret))
          write(lo,100) Inte(1:Lung(Inte))
      endif
      istat = 0
      iform = 1
      jop = jopen(jhost, cardDiret, istat, iform, ierr)
      Msg = '  seqin        ' // SeqFile(1:Lung(SeqFile))
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  mtzin        ' // MTZfile(1:Lung(MTZfile))
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  colin-fo     F,SIGF'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  colin-phifom PHIC,FOM'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  colin-free   FreeR_flag'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  prefix       ' // nome(1:lnome) 
     *   // '_bdir/' ! // slash
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  pdbout       ' // nome(1:lnome) 
     *   // '_buccaneer.pdb'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  cycles       5'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) then
          write(lo,'(a)') Msg(1:Lung(Msg))
          if (knw == 1) then
              Msg = '  pdbin-mr     ' 
     *           // FraFilePath(1:Lung(FraFilePath))
              write(jhost,'(a)') Msg(1:Lung(Msg))
              write(lo,'(a)') Msg(1:Lung(Msg))
          endif
      endif
      close(jhost)
      if (stampaInfo == 1) write(lo,300)
!
!-- Write structurename_run_buccaneer.sh
!
      istat = 0
      iform = 1
      call getCCP4vars(pathCCP4, pathPython, 256)
      jop = jopen(jhost, Inte, istat, iform, ierr)
!python $CBIN/buccaneer_pipeline.py -stdin<bu.inp
      Msg = pathPython(1:Lung(pathPython)) // ' ' //
     *      pathCCP4(1:Lung(pathCCP4)) // 
     *'/buccaneer_pipeline -stdin<'
     *    // nome(1:lnome) // '_buccaneer.inp >'
     *    // nome(1:lnome) // '_buccaneer.log 2>'
     *    // nome(1:lnome) // '_buccaneer.err'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      close(jhost)
      k = Lung(Inte)
      Inte(k+1:k+1) = char(0)
      call MakeExec(Inte)
!
!-- Start buccaneer shell script
!
      if (knw == 1) then
          call CheckMtzMpe(segno)
          if (segno > 0) then
              csegno = '(+)'
          else
              csegno = '(-)'
          endif
          if (stampaInfo == 1) then
             write(lo,'(a,f6.2,2x,a)') 
     *             ' Starting Buccaneer ... MPE =', erore, csegno
          endif
      else
          if (stampaInfo == 1) then
              write(lo,'(a)') ' Starting Buccaneer ...'
          endif
      endif
      Buffer1 = WorkingDirectory(1:Lung(WorkingDirectory)) 
     *       // slash // Inte
      k = Lung(Buffer1)
      Buffer1(k+1:k+1) = char(0)
      Msg = 
     *' Running Buccaneer. Please wait, this can take some time.'
      call PrintMess(Msg)
      call zflush
      call DoSingleIteration()
!
      if (stampaInfo == 1) then
          call elapsed_time(1, elTime, ' ', ' ')
      endif
      call Lanciash(Buffer1)
      if (stampaInfo == 1) then
          call elapsed_time(2, elTime, 'Buccaneer', MessH)
      endif
!
*     if (stampaInfo == 1) then
*         write(0,'(a)') ' ... done'
*     endif
!
!-- add buccaneer log info to output file
!
      call AppendBuccaneerLog(stampaInfo)
!
      if (stampaInfo == 1) write(lo,*)
!
      if (ifAmb /= 0) then
!*!       if (ifMadEnv /= 0. and. stampaInfo == 1) then
!*!           if (erreAW(1:1) /= ' ') then
!*!               Msg = 'Buccaneer results: ' // erreAW
!*!               call TestoGR(Msg, color_GREEN, 2, box)
!*!           endif
!*!           if (coverage >= 0) then
!*!               write(Msg,'(a,i3,a1)') 
!*!  *                  'Sequence coverage =', nint(coverage), '%'
!*!               call TestoGR(Msg, color_GREEN, 2, box)
!*!           endif
!*!       endif
*         if (ifAmb > 0) then
              MTZfile = nome(1:lnome) // '_buccaneer.mtz '
              cardDiret = WorkingDirectory(1:Lung(WorkingDirectory))
     *                  // slash // nome(1:lnome) // '_bdir'
     *                  // slash // 'refine.mtz '
              call cCopyFile(cardDiret, MTZfile)
              cardImage = nome(1:lnome) // "_buccaneer.pdb"
              inquire (file=cardImage,  exist = Esiste)
              if (Esiste) then
                  FichierOut = nome(1:lnome) // '_buccaneer.pdb'
                  AmbPDB = FichierOut
              endif
*         endif
          if (ifMadEnv /= 0) then ! . and. stampaInfo == 1) then
              if (doRicicla /= 1) then 
                  call WriteAmbResults(stampaInfo)
              endif
!*!           Msg = 'Files produced after Automated Model Building:'
!*!           write(lo,60) Msg(1:Lung(Msg))
!*!           box = lastBox
!*!           call TestoGR(Msg, -1, 2, box)
!*!           k = index(MTZfile, slash, .TRUE.) + 1
!*!           Msg = '    ' // MTZfile(k:)
!*!           if (Esiste) then
!*!               Msg(28:) = FichierOut(1:Lung(FichierOut))
!*!           else
!*!               Msg(28:) = 'no PDB file created'
!*!           endif
!*!           k = Lung(Msg)
!*!           call TestoGR(Msg, color_GREEN, 2, box)
!*!           write(lo,"(' ',a)") Msg(1:Lung(Msg))
          endif
      endif
!
c     if (coverage > coverageSog) then
c         kWstop = 1
c     endif
!
      return
 9000 ier = -1
      return
   10 format(///,' ',78('+'),//,a,/)
   20 format(/,
     *  ' Please reference',/,
     *  '    The Buccaneer software for automated model building',/,
     *  '    Cowtan K. (2006) Acta Cryst. D62, 1002-1011',/)
!*!60 format(/,' ',a,/,'     MTZ format',12x,' PDB format')
  100 format(' Starting Buccaneer using the script ',a)
  200 format(' Buccaneer input file ',a,':',/,/,60('#'))
  300 format(60('#'),/)
      end
!-----------------------------------------------------------------------
      subroutine PreparaNautilus(doRicicla, kWstop, stampaInfo, ier)
      USE General
      USE PhaseModule, only : erore
      USE Groups
      USE ArpWarp
      USE Dialogo,only: ifMadEnv, color_RED, color_GREEN, color_LIGHTRED
      USE Grafici
!
      implicit none
      integer :: k, Lung, ier, box, stampaInfo, segno
      integer :: istat, iform, jop, jopen, ierr, n_cicloAW, nPDB
      integer :: doRicicla, kWstop
      real    :: elTime
      logical :: Esiste
      character (len=3) :: csegno
      character (len=2) :: LineCont
      character (len=256) :: pathCCP4, pathPython
!
      if (ifW95 == 0) then
          LineCont = ' \'
      else
          LineCont = ' ^'
      endif
      if (stampaInfo == 1) then
          write(lo,20)
          Msg = "<big><b>Automated Model Building (Nautilus)</b></big>"
          if (ifMadEnv /= 0) then
              box = lastBox + 1
              call TestoGR(Msg, color_RED, 2, box)
              Msg =
     *         'The best set of phases will be used to build the model.'
*         call TestoGR(Msg, color_GREEN, 2, box)
              call TestoGR(Msg, -1, 2, box)
              Msg = 'Be patient, it will take some time ...'
              call TestoGR(Msg, color_LIGHTRED, 2, box)
          endif
      endif
!
!-- Write pir file
!
      SeqFile = nome(1:lnome) // '.pir'
      call WritePirSequence(Buffer1, lo, jhost, stampaInfo)
!
!
!-- remove old Nautilus files
!

*     go to 22

      cardDiret = nome(1:lnome) // '_nautilus.mtz '
      inquire (file=cardDiret,  exist = Esiste)
      if (Esiste) then
          istat = 2
          iform = 1
          jop = jopen(jhost, cardDiret, istat, iform, ierr)
          close(jhost, status='delete',err=9000)
      endif
!
      cardDiret = nome(1:lnome) // '_nautilus.log '
      inquire (file=cardDiret,  exist = Esiste)
      if (Esiste) then
          istat = 2
          iform = 1
          jop = jopen(jhost, cardDiret, istat, iform, ierr)
          close(jhost, status='delete',err=9000)
      endif
!
      cardDiret = nome(1:lnome) // '_nautilus.pdb '
      inquire (file=cardDiret,  exist = Esiste)
      if (Esiste) then
          istat = 2
          iform = 1
          jop = jopen(jhost, cardDiret, istat, iform, ierr)
          close(jhost, status='delete',err=9000)
      endif

   22 continue

!
!-- Write Nautilus input file
!
!seqin 2qu5.pir
!mtzin 2qu5_remo.mtz
!colin-fo F,SIGF
!colin-phifom PHIMR,WTMR
!colin-free FreeR_flag
!pdbin-mr pdb/2qu5.pdb
!prefix 2qu5_bdir/
!pdbout 2qu5_buccaneer.pdb
!cycles 5
!!      -mtzin <filename>               COMPULSORY
!!      -seqin <filename>
!!      -pdbin <filename>
!!      -pdbout <filename>
!!      -colin-fo <colpath>
!!      -colin-hl <colpath> or -colin-phifom <colpath>
!!      -colin-fc <colpath>
!!      -colin-free <colpath>
!!      -cycles <number>
!!      -anisotropy-correction <number>
!!      -fragments <number>
!!      -resolution <resolution/A>
!!      -pdbin-ref <filename>
      if (ifW95 == 0) then
          Inte = nome(1:lnome) // '_run_nautilus.sh '
      else
          Inte = nome(1:lnome) // '_run_nautilus.bat '
      endif
      cardDiret = nome(1:lnome) // '_nautilus.inp '
      if (stampaInfo == 1) then
          write(lo,200) cardDiret(1:Lung(cardDiret))
          write(lo,100) Inte(1:Lung(Inte))
      endif
      istat = 0
      iform = 1
      jop = jopen(jhost, cardDiret, istat, iform, ierr)
      Msg = '  seqin        ' // SeqFile(1:Lung(SeqFile))
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  mtzin        ' // MTZfile(1:Lung(MTZfile))
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  colin-fo     F,SIGF'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  colin-phifom PHIC,FOM'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  colin-free   FreeR_flag'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      if (ifHeavyPDB > 0) then
          Msg = '  pdbin        ' // PDBfile(1:Lung(PDBfile))
          write(jhost,'(a)') Msg(1:Lung(Msg))
          if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      endif
      Msg = '  pdbout       ' // nome(1:lnome) 
     *   // '_nautilus.pdb'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  cycles       5'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      close(jhost)
      if (stampaInfo == 1) write(lo,300)
!
!-- Write structurename_refmac_nautilus.sh
!
      if (ifW95 == 0) then
          cardImage = nome(1:lnome) // '_refmac_nautilus.sh'
      else
          cardImage = nome(1:lnome) // '_refmac_nautilus.bat'
      endif
      istat = 0
      iform = 1
      jop = jopen(jhost, cardImage, istat, iform, ierr)
      if (ifW95 == 0) then
          write(jhost,'(a)') '#! /bin/bash'
      endif
      cardDiret = nome(1:lnome) // '_refmac.inp' 
      write(jhost,'(a)') 'refmac5' // LineCont
      Msg = 'hklin  '  // MTZfile(1:Lung(MTZfile)) // LineCont
      write(jhost,'(a)') Msg(1:Lung(Msg))
      Msg = 'xyzin  '  // nome(1:lnome) // '_nautilus.pdb' // LineCont
      write(jhost,'(a)') Msg(1:Lung(Msg))
      Msg = 'xyzout '  // nome(1:lnome) // '_refmac.pdb' // LineCont
      write(jhost,'(a)') Msg(1:Lung(Msg))
      Msg = 'hklout '  // nome(1:lnome) // '_refmac.mtz < ' //
     *       cardDiret(1:Lung(cardDiret))
      write(jhost,'(a)') Msg(1:Lung(Msg))
      close(jhost)
      jop = jopen(jhost, cardDiret, istat, iform, ierr)
      write(jhost,'(a)') 'labin FP=F SIGFP=SIGF FREE=FreeR_flag'
      write(jhost,'(a)') 'refi -'
      write(jhost,'(a)') '    type UNRE -'
      write(jhost,'(a)') '    resi MLKF -'
      write(jhost,'(a)') '    meth CGMAT'
      write(jhost,'(a)') 'ncyc 0'
      close(jhost)
      k = Lung(cardImage)
      cardImage(k+1:k+1) = char(0)
      call MakeExec(cardImage)
!
!-- Write structurename_run_nautilus.sh
!
      istat = 0
      iform = 1
      jop = jopen(jhost, Inte, istat, iform, ierr)
      call getCCP4vars(pathCCP4, pathPython, 256)
      Msg = pathPython(1:Lung(pathPython)) // ' ' //
     *      pathCCP4(1:Lung(pathCCP4)) //
     *'/nautilus_pipeline -stdin<'
     *    // nome(1:lnome) // '_nautilus.inp >'
     *    // nome(1:lnome) // '_nautilus.log 2>'
     *    // nome(1:lnome) // '_nautilus.err'
      write(jhost,'(a)') Msg(1:Lung(Msg))
!
      Msg = './' // cardImage(1:k) // ' >> '
     *           // nome(1:lnome) // '_nautilus.log'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      close(jhost)
      k = Lung(Inte)
      Inte(k+1:k+1) = char(0)
      call MakeExec(Inte)
!
!-- Start nautilus shell script
!
      if (knw == 1) then
          call CheckMtzMpe(segno)
          if (segno > 0) then
              csegno = '(+)'
          else
              csegno = '(-)'
          endif
          if (stampaInfo == 1) then
             write(lo,'(a,f6.2,2x,a)') 
     *             ' Starting Nautilus ... MPE =', erore, csegno
          endif
      else
          if (stampaInfo == 1) then
              write(lo,'(a)') ' Starting Nautilus ...'
          endif
      endif
      Buffer1 = WorkingDirectory(1:Lung(WorkingDirectory)) 
     *       // slash // Inte
      k = Lung(Buffer1)
      Buffer1(k+1:k+1) = char(0)
      Msg = 
     *' Running Nautilus. Please wait, this can take some time.'
      call PrintMess(Msg)
      call DoSingleIteration()
      call zflush
!
      if (stampaInfo == 1) then
          call elapsed_time(1, elTime, ' ', ' ')
      endif
      call Lanciash(Buffer1)
      if (stampaInfo == 1) then
          call elapsed_time(2, elTime, 'Nautilus', MessH)
      endif
!
*     if (stampaInfo == 1) then
*         write(0,'(a)') ' ... done'
*     endif
!
!-- add Nautilus log info to output file
!
      call AppendNautilusLog(stampaInfo)
!
      if (stampaInfo == 1) write(lo,*)
!
      if (ifAmb /= 0) then
          if (ifMadEnv /= 0. and. stampaInfo == 1) then
              if (erreAW(1:1) /= ' ') then
                  Msg = 'Nautilus results: ' // erreAW
                  call TestoGR(Msg, color_GREEN, 2, box)
              endif
              if (coverage >= 0) then
                  write(Msg,'(a,i4,a,i4,a)') 
     *                  'Nucleic acids built =', nint(coverage),
     *                  ' (', nAcid, ' in sequence)'
                  call OneBlankOnly(Msg)
                  call TestoGR(Msg, color_GREEN, 2, box)
              endif
          endif
          if (ifAmb > 0) then
              MTZfile = nome(1:lnome) // '_nautilus.mtz '
              cardDiret = nome(1:lnome) // '_refmac.mtz '
              call cCopyFile(cardDiret, MTZfile)
              cardImage = nome(1:lnome) // "_nautilus.pdb"
              inquire (file=cardImage,  exist = Esiste)
              if (Esiste) then
                  FichierOut = nome(1:lnome) // '_nautilus.pdb'
                  cardImage = nome(1:lnome) // '_refmac.pdb'
** da verificare  call cCopyFile(cardImage, FichierOut)
              endif
          endif
          if (stampaInfo == 1) then
              Msg = 'Files produced after Automated Model Building:'
              write(lo,60) Msg(1:Lung(Msg))
              box = lastBox
              call TestoGR(Msg, -1, 2, box)
              k = index(MTZfile, slash, .TRUE.) + 1
              Msg = '    ' // MTZfile(k:)
              k = Lung(Msg) + 1
              if (Esiste) then
                  Msg(k+2:) = FichierOut(1:Lung(FichierOut))
              else
                  Msg(k+2:) = 'no PDB file created'
              endif
              k = Lung(Msg)
              call TestoGR(Msg, color_GREEN, 2, box)
              write(lo,"(' ',a)") Msg(1:Lung(Msg))
          endif
      endif
!
c     if (coverage > coverageSog) then
c         kWstop = 1
c     endif
!
      return
 9000 ier = -1
      return
   10 format(///,' ',78('+'),//,a,/)
   20 format(/,
     *  ' Please reference',/,
     *  '    Nautilus software for automated nucleic acid building',/,
     *  '    by K. Cowtan',/,
     *  '    Collaborative Computational Project, Number 4. 1994.',/,
     *  '    The CCP4 Suite: Programs for Protein Crystallography.',/,
     *  '    Acta Cryst. D50, 760-763.',/)
   60 format(/,' ',a,/,'     MTZ format',12x,' PDB format')
  100 format(' Starting Nautilus using the script ',a)
  200 format(' Nautilus input file ',a,':',/,/,60('#'))
  300 format(60('#'),/)
      end
!-----------------------------------------------------------------------
      subroutine WriteAmbResults(stampaInfoDum)
      USE General
      USE ArpWarp
      USE Grafici
      USE Dialogo,only: ifMadEnv, color_RED, color_GREEN, color_LIGHTRED
!
!  ifAmb = 1  Buccaneer 
!  ifAmb = 2  ARP/wARP 
!  ifAmb = 3  Phenix 
!  ifAmb = 4  Nautilus 
!
      implicit none
      integer :: k, Lung, box, stampaInfo, stampaInfoDum, L
      logical :: Esiste
!
       stampaInfo = 0
       if (first_write_Amb) then
           nLinesGR_Wr_Amb = nLinesGR
       else
           nLinesGR = nLinesGR_Wr_Amb
       endif
       ifFailAW = 0
!
       if (ifMadEnv /= 0) then !  .and. stampaInfo == 1) then
           inquire (file=AmbPDB,  exist = Esiste)
           box = lastBox
           if (ifAMB == 1) then
!
!  Buccaneer
!
              if (erreAW(1:1) /= ' ') then
                  Msg = 'Buccaneer results: ' // erreAW
                  if (stampaInfo == 1) then
                      call TestoGR(Msg, color_GREEN, 2, box)
                  endif
                  if (ifAmbEnan == 0) then
                      write(lo,'(1x,a)') Msg(1:Lung(Msg))
                  endif
              else
                  write(Msg,'(a)') 'Buccaneer failure !!!'
                  ifFailAW = 1
              endif
              if (residuesAW > 0) then
                  write(Msg,'(a,i5)') 'Sequenced residues = ',residuesAW
              else
                  write(Msg,'(a)') 'Sequenced residues = n.a.'
              endif
              L = Lung(Msg) + 4
*             if (stampaInfo == 1) then
*                 call TestoGR(Msg, color_GREEN, 2, box)
*             endif
*             if (ifAmbEnan == 0) then
*                 write(lo,'(1x,a)') Msg(1:Lung(Msg))
*             endif
              if (coverage >= 0) then
                  write(Msg(L:),'(a,i3,a1)')
     *                  'Sequence coverage =', nint(coverage), '%'
              else
                  write(Msg(L:),'(a)')
     *                  'Sequence coverage n.a.'
              endif
              if (stampaInfo == 1) then
                  call TestoGR(Msg, color_GREEN, 2, box)
              endif
              if (ifAmbEnan == 0) then
                  write(lo,'(1x,a)') Msg(1:Lung(Msg))
              endif
!
           elseif (ifAMB == 2) then
!
!  ARP/wARP
!
c             MTZfile = WorkingDirectory(1:Lung(WorkingDirectory)) //
c    *                  slash // nome(1:lnome) // '_refmac.mtz '
              if (erreAW(1:1) /= ' ') then
                  Msg = 'ARP/wARP results: ' // erreAW
                  if (stampaInfo == 1) then
                      call TestoGR(Msg, color_GREEN, 2, box)
                  endif
              else
                  write(Msg,'(a)') 'ARP/wARP failure !!!'
                  ifFailAW = 1
              endif
              if (coverage >= 0) then
                  write(Msg,'(a,i3,a1)')
     *                  'Sequence coverage =', nint(coverage), '%'
              else
                  write(Msg,'(a)')
     *                  'Sequence coverage n.a.'
              endif
              if (stampaInfo == 1) then
                  call TestoGR(Msg, color_GREEN, 2, box)
              endif
!
           elseif (ifAMB == 3) then
!
!  Phenix
!
c             MTZfile = WorkingDirectory(1:Lung(WorkingDirectory)) //
c    *                  slash // nome(1:lnome) // '_refmac.mtz '
              if (erreAW(1:1) /= ' ') then
                  Msg = 'Phenix results: ' // erreAW
                  call TestoGR(Msg, color_GREEN, 2, box)
              else
                  write(Msg,'(a)') 'Phenix failure !!!'
                  ifFailAW = 1
              endif
              if (coverage >= 0) then
                  write(Msg,'(a,i3,a1)')
     *                  'Sequence coverage =', nint(coverage), '%'
              else
                  write(Msg,'(a)')
     *                  'Sequence coverage n.a.'
              endif
              call TestoGR(Msg, color_GREEN, 2, box)
           elseif (ifAMB == 4) then
!
!  Nautilus
!
!  ??????????????????  !
!
           endif
!
           if (stampaInfo == 1) then
               Msg = 'Files produced after Automated Model Building:'
               write(lo,60) Msg(1:Lung(Msg))
               box = lastBox
               call TestoGR(Msg, -1, 2, box)
               k = index(MTZfile, slash, .TRUE.) + 1
               Msg = '    ' // MTZfile(k:)
               k = Lung(Msg) + 1
               if (Esiste) then
                   Msg(k+2:) = AmbPDB(1:Lung(AmbPDB))
               else
                   Msg(k+2:) = 'no PDB file created'
               endif
               k = Lung(Msg)
               call TestoGR(Msg, color_GREEN, 2, box)
               write(lo,"(' ',a)") Msg(1:Lung(Msg))
           endif
       endif
!
       first_write_Amb = .false.
!
      return
   60 format(/,' ',a,/,'     MTZ format',12x,' PDB format')
      end
!-----------------------------------------------------------------------
      subroutine OLD_PreparaNautilus(doRicicla, kWstop, stampaInfo, ier)
      USE General
      USE PhaseModule, only : erore
      USE Groups
      USE ArpWarp
      USE Dialogo,only: ifMadEnv, color_RED, color_GREEN, color_LIGHTRED
      USE Grafici
!
      implicit none
      integer :: k, Lung, ier, box, stampaInfo, segno
      integer :: istat, iform, jop, jopen, ierr, n_cicloAW, nPDB
      integer :: doRicicla, kWstop
      real    :: elTime
      logical :: Esiste
      character (len=3) :: csegno
      character (len=2) :: LineCont
!
      if (ifW95 == 0) then
          LineCont = ' \'
      else
          LineCont = ' ^'
      endif
      if (stampaInfo == 1) then
          write(lo,20)
          Msg = "<big><b>Automated Model Building (Nautilus)</b></big>"
          if (ifMadEnv /= 0) then
              box = lastBox + 1
              call TestoGR(Msg, color_RED, 2, box)
              Msg =
     *         'The best set of phases will be used to build the model.'
*         call TestoGR(Msg, color_GREEN, 2, box)
              call TestoGR(Msg, -1, 2, box)
              Msg = 'Be patient, it will take some time ...'
              call TestoGR(Msg, color_LIGHTRED, 2, box)
          endif
      endif
!
!-- remove old Nautilus files
!

*     go to 22

      cardDiret = nome(1:lnome) // '_nautilus.mtz '
      inquire (file=cardDiret,  exist = Esiste)
      if (Esiste) then
          istat = 2
          iform = 1
          jop = jopen(jhost, cardDiret, istat, iform, ierr)
          close(jhost, status='delete',err=9000)
      endif
!
      cardDiret = nome(1:lnome) // '_nautilus.log '
      inquire (file=cardDiret,  exist = Esiste)
      if (Esiste) then
          istat = 2
          iform = 1
          jop = jopen(jhost, cardDiret, istat, iform, ierr)
          close(jhost, status='delete',err=9000)
      endif
!
      cardDiret = nome(1:lnome) // '_nautilus.pdb '
      inquire (file=cardDiret,  exist = Esiste)
      if (Esiste) then
          istat = 2
          iform = 1
          jop = jopen(jhost, cardDiret, istat, iform, ierr)
          close(jhost, status='delete',err=9000)
      endif

   22 continue

!
!-- Write Nautilus input file
!
!seqin 2qu5.pir
!mtzin 2qu5_remo.mtz
!colin-fo F,SIGF
!colin-phifom PHIMR,WTMR
!colin-free FreeR_flag
!pdbin-mr pdb/2qu5.pdb
!prefix 2qu5_bdir/
!pdbout 2qu5_buccaneer.pdb
!cycles 5
!!      -mtzin <filename>               COMPULSORY
!!      -seqin <filename>
!!      -pdbin <filename>
!!      -pdbout <filename>
!!      -colin-fo <colpath>
!!      -colin-hl <colpath> or -colin-phifom <colpath>
!!      -colin-fc <colpath>
!!      -colin-free <colpath>
!!      -cycles <number>
!!      -anisotropy-correction <number>
!!      -fragments <number>
!!      -resolution <resolution/A>
!!      -pdbin-ref <filename>
      if (ifW95 == 0) then
          Inte = nome(1:lnome) // '_run_nautilus.sh '
      else
          Inte = nome(1:lnome) // '_run_nautilus.bat '
      endif
      cardDiret = nome(1:lnome) // '_nautilus.inp '
      if (stampaInfo == 1) then
          write(lo,200) cardDiret(1:Lung(cardDiret))
          write(lo,100) Inte(1:Lung(Inte))
      endif
      istat = 0
      iform = 1
      jop = jopen(jhost, cardDiret, istat, iform, ierr)
      Msg = '  seqin        ' // SeqFile(1:Lung(SeqFile))
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  mtzin        ' // MTZfile(1:Lung(MTZfile))
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  colin-fo     F,SIGF'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  colin-phifom PHIC,FOM'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  colin-free   FreeR_flag'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  pdbout       ' // nome(1:lnome) 
     *   // '_nautilus.pdb'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      Msg = '  cycles       5'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      if (ResEff < 1.4) then 
          Msg = '  resolution   1.4'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          if (stampaInfo == 1) write(lo,'(a)') Msg(1:Lung(Msg))
      endif
*     if (stampaInfo == 1) then
*         write(lo,'(a)') Msg(1:Lung(Msg))
*         if (knw == 1) then
*             Msg = '  pdbin-mr     ' 
*    *           // FraFilePath(1:Lung(FraFilePath))
*             write(jhost,'(a)') Msg(1:Lung(Msg))
*             write(lo,'(a)') Msg(1:Lung(Msg))
*         endif
*     endif
      close(jhost)
      if (stampaInfo == 1) write(lo,300)
!
!-- Write structurename_refmac_nautilus.sh
!
      if (ifW95 == 0) then
          cardImage = nome(1:lnome) // '_refmac_nautilus.sh'
      else
          cardImage = nome(1:lnome) // '_refmac_nautilus.bat'
      endif
      istat = 0
      iform = 1
      jop = jopen(jhost, cardImage, istat, iform, ierr)
      if (ifW95 == 0) then
          write(jhost,'(a)') '#! /bin/bash'
      endif
      cardDiret = nome(1:lnome) // '_refmac.inp' 
      write(jhost,'(a)') 'refmac5' // LineCont
      Msg = 'hklin  '  // MTZfile(1:Lung(MTZfile)) // LineCont
      write(jhost,'(a)') Msg(1:Lung(Msg))
      Msg = 'xyzin  '  // nome(1:lnome) // '_nautilus.pdb' // LineCont
      write(jhost,'(a)') Msg(1:Lung(Msg))
      Msg = 'xyzout '  // nome(1:lnome) // '_refmac.pdb' // LineCont
      write(jhost,'(a)') Msg(1:Lung(Msg))
      Msg = 'hklout '  // nome(1:lnome) // '_refmac.mtz < ' //
     *       cardDiret(1:Lung(cardDiret))
      write(jhost,'(a)') Msg(1:Lung(Msg))
      close(jhost)
      jop = jopen(jhost, cardDiret, istat, iform, ierr)
      write(jhost,'(a)') 'labin FP=F SIGFP=SIGF FREE=FreeR_flag'
      write(jhost,'(a)') 'refi -'
      write(jhost,'(a)') '    type UNRE -'
      write(jhost,'(a)') '    resi MLKF -'
      write(jhost,'(a)') '    meth CGMAT'
      write(jhost,'(a)') 'ncyc 5'
      close(jhost)
      k = Lung(cardImage)
      cardImage(k+1:k+1) = char(0)
      call MakeExec(cardImage)
!
!-- Write structurename_run_nautilus.sh
!
      istat = 0
      iform = 1
      jop = jopen(jhost, Inte, istat, iform, ierr)
      Msg = 'cnautilus -stdin<'
     *    // nome(1:lnome) // '_nautilus.inp >'
     *    // nome(1:lnome) // '_nautilus.log 2>'
     *    // nome(1:lnome) // '_nautilus.err'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      Msg = './' // cardImage(1:k) // ' >> '
     *           // nome(1:lnome) // '_nautilus.log'
      write(jhost,'(a)') Msg(1:Lung(Msg))
      close(jhost)
      k = Lung(Inte)
      Inte(k+1:k+1) = char(0)
      call MakeExec(Inte)
!
!-- Start nautilus shell script
!
      if (knw == 1) then
          call CheckMtzMpe(segno)
          if (segno > 0) then
              csegno = '(+)'
          else
              csegno = '(-)'
          endif
          if (stampaInfo == 1) then
             write(lo,'(a,f6.2,2x,a)') 
     *             ' Starting Nautilus ... MPE =', erore, csegno
          endif
      else
          if (stampaInfo == 1) then
              write(lo,'(a)') ' Starting Nautilus ...'
          endif
      endif
      Buffer1 = WorkingDirectory(1:Lung(WorkingDirectory)) 
     *       // slash // Inte
      k = Lung(Buffer1)
      Buffer1(k+1:k+1) = char(0)
      Msg = 
     *' Running Nautilus. Please wait, this can take some time.'
      call PrintMess(Msg)
      call DoSingleIteration()
!
      if (stampaInfo == 1) then
          call elapsed_time(1, elTime, ' ', ' ')
      endif
      call Lanciash(Buffer1)
      if (stampaInfo == 1) then
          call elapsed_time(2, elTime, 'Nautilus', MessH)
      endif
!
*     if (stampaInfo == 1) then
*         write(0,'(a)') ' ... done'
*     endif
!
!-- add Nautilus log info to output file
!
      call AppendNautilusLog(stampaInfo)
!
      if (stampaInfo == 1) write(lo,*)
!
      if (ifAmb /= 0) then
          if (ifMadEnv /= 0. and. stampaInfo == 1) then
              if (erreAW(1:1) /= ' ') then
                  Msg = 'Nautilus results: ' // erreAW
                  call TestoGR(Msg, color_GREEN, 2, box)
              endif
              if (coverage >= 0) then
                  write(Msg,'(a,i3)') 
     *                  'Nucleic acids built =', nint(coverage)
                  call TestoGR(Msg, color_GREEN, 2, box)
              endif
          endif
          if (ifAmb > 0) then
              MTZfile = nome(1:lnome) // '_nautilus.mtz '
              cardDiret = nome(1:lnome) // '_refmac.mtz '
              call cCopyFile(cardDiret, MTZfile)
              cardImage = nome(1:lnome) // "_nautilus.pdb"
              inquire (file=cardImage,  exist = Esiste)
              if (Esiste) then
                  FichierOut = nome(1:lnome) // '_nautilus.pdb'
                  cardImage = nome(1:lnome) // '_refmac.pdb'
** da verificare  call cCopyFile(cardImage, FichierOut)
              endif
          endif
          if (stampaInfo == 1) then
              Msg = 'Files produced after Automated Model Building:'
              write(lo,60) Msg(1:Lung(Msg))
              box = lastBox
              call TestoGR(Msg, -1, 2, box)
              k = index(MTZfile, slash, .TRUE.) + 1
              Msg = '    ' // MTZfile(k:)
              k = Lung(Msg) + 1
              if (Esiste) then
                  Msg(k+2:) = FichierOut(1:Lung(FichierOut))
              else
                  Msg(k+2:) = 'no PDB file created'
              endif
              k = Lung(Msg)
              call TestoGR(Msg, color_GREEN, 2, box)
              write(lo,"(' ',a)") Msg(1:Lung(Msg))
          endif
      endif
!
      if (coverage > coverageSog) then
          kWstop = 1
      endif
!
      return
 9000 ier = -1
      return
   10 format(///,' ',78('+'),//,a,/)
   20 format(/,
     *  ' Please reference',/,
     *  '    Nautilus software for automated nucleic acid building',/,
     *  '    by K. Cowtan',/,
     *  '    Collaborative Computational Project, Number 4. 1994.',/,
     *  '    The CCP4 Suite: Programs for Protein Crystallography.',/,
     *  '    Acta Cryst. D50, 760-763.',/)
   60 format(/,' ',a,/,'     MTZ format',12x,' PDB format')
  100 format(' Starting Nautilus using the script ',a)
  200 format(' Nautilus input file ',a,':',/,/,60('#'))
  300 format(60('#'),/)
      end
!-----------------------------------------------------------------------
      subroutine LookForEnantiomorph
      USE General
      USE Riflessi
      USE PhaseModule
      USE Molcom, only : ifMadEnv, color_LIGHTRED
      USE Groups
      USE ArpWarp
!
      implicit none
      integer :: i, doRicicla, ier, stampaInfo, nset
      integer :: residuesVet(2), coverVet(2)
      integer :: MSetsFineDSR, istat, iform, jop, jopen, ierr, Lung, L
      integer :: programma
      real    :: VettRisultati(10), r(2), rf(2), elTime
      logical :: Esiste
      character (len=10) :: errech(2), errefch(2), coverch(2)
!
      if (kfast /= 0) then
          return
      endif
!
      
      programma = 0
      if (nResidStored > 0) then
          programma = 1
      elseif(nAcid > 0 .and. ifNAUTILUS == 1) then
          programma = 4
      endif

      if (programma == 0) then
          return
      endif

      ifAmbSav = ifAmb
      ifAmb = programma
      ifAmbEnan = programma
      call elapsed_time(1, elTime, ' ', ' ')
!
      write(lo,10)
      if (programma == 1) then
          write(lo,15)
          Msg = 'Check for enantiomorph using Buccaneer ...'
      elseif (programma == 2) then
          write(lo,16)
          Msg = 'Check for enantiomorph using ARP/wARP ...'
      elseif (programma == 4) then
          write(lo,17)
          Msg = 'Check for enantiomorph using Nautilus ...'
      endif
!
      if (ifMadEnv > 0) then
          call TestoGR(Msg, color_LIGHTRED, 2, 3)
          call zflush
*         call DoSingleIteration()
      endif


*     go to 1

      doRicicla = 0
      kWstop = 0
      ier = 0
      doRicicla = 0
      stampaInfo = 0
      nset = iposFineDSR(1)
      call PutGetFinalPhases(2, nset, figMer)
      do i=1, 2
         if (i == 2) then
             call PutGetFinalPhases(2, nset, figMer)
             iphaz(:) = -iphaz(:)
             call PutGetFinalPhases(1, nset, figMer)
         endif
         MSetsFineDSR = 1
         call MTZfiles(MSetsFineDSR, 0, stampaInfo)
         if (programma == 1) then
             call PreparaBuccaneer(doRicicla, kWstop, stampaInfo, ier)
         elseif (programma == 2) then
             ifAmbSav = ifAmb
             ifAmb = 2
             call PreparaArpWarp(doRicicla, kWstop, stampaInfo, ier)
             ifAmb = ifAmbSav
         elseif (programma == 4) then
             call PreparaNautilus(doRicicla, kWstop, stampaInfo, ier)
         endif
!
!-- copia i file mtz e pdb dei due enantiomorfi in file di appoggio
!
         Msg = MTZfile
         L = Lung(Msg)
         write(Msg(L+1:L+1),'(i1)') i
         call cCopyFile(MTZfile, Msg)
         Msg = FichierOut
         L = Lung(Msg)
         if (L > 0) then
             write(Msg(L+1:L+1),'(i1)') i
             call cCopyFile(FichierOut, Msg)
         endif
!
         residuesVet(i) = residuesAW
         coverVet(i) = coverage
         r(i) = RfacAW
         rf(i) = RfreAW
         if (coverVet(i) >= 0) then
             if (programma == 4) then
                 write(coverch(i),41) coverVet(i)
             else
                 write(coverch(i),40) coverVet(i)
             endif
         else
             coverch(i) = '      n.a.'
         endif
         if (r(i) > 0.001) then
             write(errech(i),'(f10.3)') r(i)
         else
             errech(i) = '      n.a.'
             r(i) = 1.0
         endif
         if (rf(i) > 0.001) then
             write(errefch(i),'(f10.3)') rf(i)
         else
             errefch(i) = '      n.a.'
             rf(i) = 1.0
         endif
*        write(6,*) errech(i), errefch(i), coverage
*        pause
         RfacAW = 0
         RfreAW = 0
!
**       if (knw == 1) then
**           call AmbMPEvalues()  ! questa subr deve essere testata meglio
**       endif
!
!-- bisogna cancellare mtz e pdb
!
         if (programma == 1) then
             cardDiret = nome(1:lnome) // '_buccaneer.mtz '
         else
             cardDiret = nome(1:lnome) // '_refmac.mtz '
         endif
         inquire (file=cardDiret,  exist = Esiste)
         if (Esiste) then
             istat = 2
             iform = 1
             jop = jopen(jhost, cardDiret, istat, iform, ierr)
             close(jhost, status='delete',err=9100)
         endif
 9100    continue
         if (programma == 1) then
             cardDiret = nome(1:lnome) // '_buccaneer.pdb '
         elseif (programma == 2) then
             cardDiret = nome(1:lnome) // '_arp.pdb '
         elseif (programma == 4) then
             cardDiret = nome(1:lnome) // '_nautilus.pdb '
         endif
         inquire (file=cardDiret,  exist = Esiste)
         if (Esiste) then
             istat = 2
             iform = 1
             jop = jopen(jhost, cardDiret, istat, iform, ierr)
             close(jhost, status='delete',err=9200)
         endif
 9200    continue
      enddo
      if (programma == 4) then
*         cover(:) = 0
          write(lo,21) errech, errefch, coverch
      else
          write(lo,20) errech, errefch, coverch
      endif
      if (coverVet(1) > coverVet(2)) then
          i = 1
      elseif (coverVet(2) > coverVet(1)) then
          i = 2
      else
          if (r(1) < r(2)) then
              i = 1
          else
              i = 2
          endif
      endif
      call elapsed_time(2, elTime, 'Enantiomorph procedure', MessH)
      if (i == 1) then
          write(lo,30) '+', MessH(1:Lung(MessH))
          iphaz(:) = -iphaz(:)
          call PutGetFinalPhases(1, nset, figMer)
      else
          write(lo,30) '-', MessH(1:Lung(MessH))
      endif
      write(lo,10)
      residuesAW = residuesVet(i)
      coverage   = coverVet(i)
      errem = r(i)
!
!-- restore dei file corretti rispetto all'enantiomorfo
!
      Msg = MTZfile
      L = Lung(Msg)
      write(Msg(L+1:L+1),'(i1)') i
      call cCopyFile(Msg, MTZfile)
      Msg = FichierOut
      L = Lung(Msg)
      if (L > 0) then
          write(Msg(L+1:L+1),'(i1)') i
          call cCopyFile(Msg, FichierOut)
          ifAmbEnan = programma
          write(erreAW,50) r(i), rf(i)
          coverage = coverVet(i)
      else
          ifAmbEnan = 0
      endif
!
    1 continue

      if (ifMadEnv > 0) then
          if (programma == 1) then
              Msg = 'Check for enantiomorph using Buccaneer ... done!'
          elseif (programma == 2) then
              Msg = 'Check for enantiomorph using ARP/wARP ... done!'
          elseif (programma == 4) then
              Msg = 'Check for enantiomorph using Nautilus ... done!'
          endif
          call SameLine(Msg, color_LIGHTRED, 3)
          call zflush
      endif
!
      ifAmb = ifAmbSav
!
      if (ifAmb == 0) then
          if (ifAmbEnan > 0) then
              call RestoreAmbEnan
              ifAmb = 0
          endif
      else
          if (ifAmbEnan == ifAmb) then
              call RestoreAmbEnan
              ifAmb = 0
          else
              ifAmbEnan = 0
          endif
      endif
!
      ifAmbEnan = 0
!
      return
   10 format(78('-'))
   15 format(/,
     *  22x,'Check on enantiomorph using Buccaneer',//,
     *  ' Please reference',/,
     *  '    The Buccaneer software for automated model building',/,
     *  '    Cowtan K. (2006) Acta Cryst. D62, 1002-1011',/)
   16 format(/,
     *  22x,'Check on enantiomorph using ARP/wARP',//,
     *  ' Please reference',/,
     *  '    Automated protein model building combined with',/,
     *  '    iterative structure refinement.',/,
     *  '    Perrakis, A., Morris, R.M. & Lamzin, V.S. (1999)',/,
     *  '    Nature Struct. Biol. 6, 458-463',/)
   17 format(/,
     *  22x,'Check on enantiomorph using Nautilus',//,
     *  ' Please reference',/,
     *  '    Nautilus software for automated nucleic acid building',/,
     *  '    by K. Cowtan',/,
     *  '    Collaborative Computational Project, Number 4. 1994.',/,
     *  '    The CCP4 Suite: Programs for Protein Crystallography.',/,
     *  '    Acta Cryst. D50, 760-763.',/)
!
   20 format(30x,'Hand +    Hand - '/,
     *       16x,'R factor  ',2a10,/,
     *       16x,'  R free  ',2a10,/,
     *       16x,'Coverage  ',2a10,/)
   21 format(30x,'Hand +    Hand - '/,
     *       '               R factor  ',2a10,/,
     *       '                 R free  ',2a10,/,
     *       '    Nucleic acids built  ',2a10,/)
   30 format(' Selected: Hand ',a,/,' ',a)
   40 format(i9,'%')
   41 format(i9)
   50 format('R =',f7.4,'  (Rfree =',f7.4,')')
      end
!-----------------------------------------------------------------------
      subroutine AmbMPEvalues()
      USE General
      USE Riflessi
      USE PhaseModule
!
      implicit none
      integer :: lix1, lix2, iAction, ier, nExitCode, doRicicla, ksubr
      integer :: knwSav, cod, ifmin, Lung
      real    :: celltemp(13)
!
      ier = 0
!
      if (ifAmb == 2 .or. ifAmb == 3) then
          MTZfile = WorkingDirectory(1:Lung(WorkingDirectory)) // slash
     *       // nome(1:lnome) // '_refmac.mtz '
      endif
!
      if (knw > 0) then
          write(lo,10) MTZfile(1:Lung(MTZfile))
      endif
      lix1 = 1
      lix2 = 1
      Lab_Ch(1) = 'H'
      Lab_Ch(2) = 'K'
      Lab_Ch(3) = 'L'
      Lab_Ch(4) = 'F'
      Lab_Ch(5) = 'SIGF'
      Lab_Ch(6) = 'PHIC_ALL' ! fase
      Lab_Ch(7) = 'FOM'      ! peso
      Lab_Ch(8) = 'FC_ALL'   ! fc
      ifMTZlab = 1
      do iAction =1, 2
         call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
         if (ier /= 0) then
             Msg = 'Error reading MTZ file ' // MTZfile(1:Lung(MTZfile))
             call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
             doRicicla = 0
             return
         endif
      enddo
!
      go to 1

      iAction = 1
      call AllocaRiflessi(iAction)
      ksubr = 4
      call LeggiRiflessi(ier, ksubr)

    1 continue
!
      knwSav = knw
      knw = 0
      call LeggiMTZPhase(ier)
!
      iAction = 3
      call ManageMTZ(iAction, celltemp, lix1, lix2, ier)     !mr
!
      knw = knwSav
      if (knw > 0) then
          ifmin = 1
          cod = 1000
          call examin(cod, mkang, khl, ipub, iphaz, nrefl, 0, wt, ifmin)
          if (ifAmb == 1) then
              write(lo,20) 'Buccaneer',erore, erorepes, isumal
          elseif (ifAmb == 2) then
              write(lo,20) 'Arp/Warp',erore, erorepes, isumal
          elseif (ifAmb == 3) then
              write(lo,20) 'Phenix',erore, erorepes, isumal
          endif
      endif
!
      return
   10 format(//,2x,'Reading phases from ',a)
   20 format(/,2x,'After ',a,' - Mean Phase Error ',f6.2,
     *       '  (',f6.2,')  over',i8,' reflections')
      end
!-----------------------------------------------------------------------
      subroutine CheckMtzMpe(segno)
      USE General
      USE Riflessi
      USE PhaseModule
!
      implicit none
      integer :: lix1, lix2, knwSav, ifmin, cod, iAction, ier
      integer :: nExitCode, Lung, segno
      real    :: celltemp(13)
!
      write(6,*) MTZfile(1:Lung(MTZfile))
      ier = 0
      lix1 = 1
      lix2 = 1
      Lab_Ch(1) = 'H'
      Lab_Ch(2) = 'K'
      Lab_Ch(3) = 'L'
      Lab_Ch(4) = 'F'
      Lab_Ch(5) = 'SIGF'
      Lab_Ch(6) = 'PHIC'  ! fase
      Lab_Ch(7) = 'FOM'   ! peso
      Lab_Ch(8) = 'FC'    ! fc
      ifMTZlab = 1
      do iAction =1, 2
         call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
         if (ier /= 0) then
             Msg = 'Error reading MTZ file ' // MTZfile(1:Lung(MTZfile))
             call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
             return
         endif
      enddo
!
      knwSav = knw
      knw = 0
      call LeggiMTZPhase(ier)
!
      iAction = 3
      call ManageMTZ(iAction, celltemp, lix1, lix2, ier)     !mr
!
      knw = knwSav
      ifmin = 1
      cod = 1000
      call examin(cod, mkang, khl, ipub, iphaz, nrefl, 0, wt, ifmin)
      segno = shiftexam(4)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine LoadPDBfromAmb(showJav)
      USE General
      USE Atomi
      USE RemoModule
      USE ArpWarp
      USE Align
      USE TestModel
!
      implicit none
      integer :: jop, jopen, istat, iform, ier, inizio, fine, CA, m1
      integer :: i, j, k, l, n1, n3, nCA, oldRes, CodiceResiduo1, n
      integer :: jumpR, stampa, ifHet, nSecondary, showJav
      character (len=1) :: a1
      character (len=4) :: SpeciesTmp(18), a4, tipoA, tipoR
!
      ifHet = 0
      jumpR = jumpRes
      istat = 2
      iform = 1
      AmbPDB = FichierOut
*     write(0,*) 'Loading ', FichierOut
      jop = jopen(jhost, FichierOut, istat, iform, ier)
      if (jop < 0) then
          ifAmb = 0
          return
      endif
!
      WhichModel = 1
!!mr      if (allocated(model(WhichModel))) then
      if (allocated(model)) then
          call DeallocaModello(WhichModel, ier)
      endif
      nMolMR = 1
      WhichModel = 1
      call AllocaModelRemo(2)
      call AllocaAtomi(2)
      nats = anat * 1.1
      numbModels = 1
      call AllocaModelRemo(0)
      call AllocaAtomi(-1)
      if (natsInModel(WhichModel) <= 0) then
          natsInModel(WhichModel) = MaxAtoms
      endif
      SaltaUNK = .false.
      call ManagePDBSir(0, 0, 0, 0, 1, ier)
      SaltaUNK = .true.
      if (ier < 0) then
          return
      endif
      close(jhost)
!
      SpeciesTmp(1:18) = Species(1:18)
      call RestoreLists123(3)   ! modificato dalla lettura del PDB
!
      do i=1, natsInModel(WhichModel)
         k = model(WhichModel)%specie(i,1) / nzConst
         a4 = SpeciesTmp(k)
         do j=1, nk
            if (a4 == Species(j)) then
                k = j
                exit
            endif
         enddo
         model(WhichModel)%specie(i,1) = k * nzConst
      enddo
!
      call GetModel
!
      if (knw == 1 .and. index(FichierOut,'_arp.pdb') > 0) then
          call Overlap(2)
          call UpdatePDBCoords(FichierOut, 'provaOver.pdb')
      endif
!dopo!if (ifAMB == 4) then
!dopo!    CCP4map = nome(1:lnome) // '_ccp4_map.map'
!dopo!    call MutateNucleicAcid
!dopo!endif
!
!!      call LanciaJavPreview()
      if (showJav == 1) then
!*!       if (ifRemo == 1) then
!*!           call LanciaJavPreview()
!*!       else
!*!           call LanciaJavPreviewNew()
!*!       endif
          if (ifRemo /= 1) then
              call LanciaJavPreviewNew()
          endif
      endif
      Model_PDB = model(WhichModel)%PDB
!
      if (knw == 1 .and. nCoordPub > 0) then
          if (ifAMB == 4) then
              CaOnly = .false.
          else
              CaOnly = .true.
          endif
!*!       if (.not.allocated(xyzs)) then
!*!           n = nats
!*!           allocate(xyzs(1:5,n), stat=ier)
!*!           allocate(xyzo(1:5,n), stat=ier)
!*!           allocate(nz(n), stat=ier)
!*!           allocate(aLab(n), stat=ier)
!*!           allocate(kblock(n), stat=ier)
!*!           allocate(xyzs4(n), stat=ier)
!*!           allocate(bfac(n), stat=ier)
!*!           allocate(npunt(n), stat=ier)
!*!           allocate(distv(n), stat=ier)
!*!       endif
          call to_coord_sir(1, nrefl)
          write(lo,10) nint(vett_test(3)), nint(vett_test(2)), 
     *                 nint(vett_test(1))
      endif
!
      return
   10 format('FOUND |',3(i4,' |'))
      end
!-----------------------------------------------------------------------
      subroutine MutateNucleicAcid
!
      call AllocaMappa(2)
      call CalcGrid
      call AllocaMappa(1)
      call WriteMapForCoot
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Overlap(stage)
!
!-- overlap model to target
!
!-- stage = 1 at the end of Remo
!-- stage = 2 after AMB
!
      USE General
      USE Riflessi
      USE Symmetry
      USE Atomi
      USE RemoModule
      USE TestModel
      USE PhaseModule
      USE Molcom
!
      implicit none
      integer :: nbru, izero, ifmin, i, i1, i2, i3, kt, ia, ib, ic
      integer :: n, ns, trasla(3), j, k, SavensymTot, ifAtomi, ier
      integer :: stage, foundMax
      real    :: bariPub(3), bariMod(3), x1(3), xeq(3), dist, dmin
      real    :: xP(3), xM(3), found
!
      if (nCoordPub == 0) then
          return
      endif
      nbru=881
      izero = 0
      ifmin = 1
      call examin(nbru, mkang, khl, ipub, iphaz, nrefl, izero, wt,ifmin)
!
      if (allocated(xyzs))   deallocate(xyzs,   stat=ier)
      if (allocated(xyzo))   deallocate(xyzo,   stat=ier)
      if (allocated(nz))     deallocate(nz,     stat=ier)
      if (allocated(aLab))   deallocate(aLab,   stat=ier)
      if (allocated(kblock)) deallocate(kblock, stat=ier)
      if (allocated(xyzs4))  deallocate(xyzs4,  stat=ier)
      if (allocated(bfac))   deallocate(bfac,   stat=ier)
      if (allocated(npunt))  deallocate(npunt,  stat=ier)
      if (allocated(distv))  deallocate(distv,  stat=ier)

      if (allocated(xyzs)) then
          ifAtomi = 1
      else
          n = 0
          do i3=1, numbModels
             do i2=1, MonomerInModel(i3)
                do i1=1, natsInModel(i3)
                   n = n + 1
                enddo
             enddo
          enddo
          allocate(xyzs(1:5,n), stat=ier)
          allocate(xyzo(1:5,n), stat=ier)
          allocate(nz(n), stat=ier)
          allocate(aLab(n), stat=ier)
          allocate(kblock(n), stat=ier)
          allocate(xyzs4(n), stat=ier)
          allocate(bfac(n), stat=ier)
          allocate(npunt(n), stat=ier)
          allocate(distv(n), stat=ier)
          ifAtomi = 0
          nats = n
          MaxAtoms = nats
      endif
!
!-- load all is needed to use "to_coord"
!
      n = 0
      do i3=1, numbModels
         do i2=1, MonomerInModel(i3)
            do i1=1, natsInModel(i3)
               x1(1:3) = model(i3)%atoms(1:3,i1,i2)
               n = n + 1
               xyzs(1:3,n) = x1(1:3)
               xyzs(4:5,n) = model(i3)%atoms(4:5,i1,i2)
               bfac(n) = model(i3)%th_fact(i1,i2)
               nz(n) = model(i3)%specie(i1,i2) / nzConst
               aLab(n) = model(i3)%label(i1)
            enddo
         enddo
      enddo
      xyzo(1:5,1:n) = xyzs(1:5,1:n)
!
!-- define the correct symmetry operator to overlap the model
!
      found = -1
      foundMax = -1
      ns = nsymTot
      SavensymTot = nsymTot
      nsymTot = 1
      do i=1, ns
         do j=1, n
            x1(1:3) = xyzo(1:3,j)
            kt = -1
            call xequiTot(i, x1, xeq, kt)
            xyzs(1:3,j) = xeq(1:3)
         enddo
         call to_coord_sir(0, nrefl)
         if (vett_test(3) > found) then
             found = vett_test(3)
             if (found > foundMax) then
                 k = i
                 foundMax = found
             endif
         endif
      enddo
      nsymTot = SavensymTot
      if (found <= 0) then
          k = 1
      endif
!
!-- apply origin shifts and the correct symmetry operator
!
      do i3=1, numbModels
         do i2=1, MonomerInModel(i3)
            do i1=1, natsInModel(i3)
               x1(1:3) = model(i3)%atoms(1:3,i1,i2)
               if (shiftexam(4) > 0.0) then
                   x1(1:3) = x1(1:3) - shiftexam(1:3)
               else
                   x1(1:3) = - (x1(1:3) + shiftexam(1:3) )
               endif
               kt = -1
               call xequiTot(k, x1, xeq, kt)
               model(i3)%atoms(1:3,i1,i2) = xeq(1:3)
            enddo
         enddo
      enddo
!
!-- move the model in the same cell of the target
!
      bariPub(1:3) = 0
      do i=1, nCoordPub
         bariPub(1:3) = bariPub(1:3) + coordPub(1:3,i)
      enddo
      bariPub(1:3) = bariPub(1:3) / float(nCoordPub)
      call MoltMatVec(rm, bariPub, xP)
!
      n = 0
      bariMod(1:3) = 0
      do i3=1, numbModels
         do i2=1, MonomerInModel(i3)
            do i1=1, natsInModel(i3)
               x1(1:3) = model(i3)%atoms(1:3,i1,i2)
               bariMod(1:3) = bariMod(1:3) + x1(1:3)
               n = n + 1
            enddo
         enddo
      enddo
      bariMod(1:3) = bariMod(1:3) / float(n)
!
      dmin = 9999
      do ia=-2, 2
         do ib=-2, 2
            do ic=-2, 2
               x1(1) = bariMod(1) + ia
               x1(2) = bariMod(2) + ib
               x1(3) = bariMod(3) + ic
               call MoltMatVec(rm, x1, xM)
               dist = 0.0
               do k=1, 3
                  dist = dist + ( xP(k) - xM(k) ) **2
               end do
               dist = sqrt(dist)
               if (dist < dmin) then
                   dmin = dist
                   trasla(1) = ia
                   trasla(2) = ib
                   trasla(3) = ic
               endif
            enddo
         enddo
      enddo
!
      do i3=1, numbModels
         do i2=1, MonomerInModel(i3)
            do i1=1, natsInModel(i3)
               x1(1:3) = model(i3)%atoms(1:3,i1,i2)
               x1(1:3) = x1(1:3) + trasla(1:3)
               model(i3)%atoms(1:3,i1,i2) = x1(1:3)
            enddo
         enddo
      enddo
!*!   if (ifAtomi == 0) then
!*!       deallocate(xyzs, xyzo, nz, aLab, kblock, xyzs4, bfac,stat=ier)
!*!       nats = 0
!*!   endif
!
      if (stage == 1) then
!
!-- recompute phases
!
          call ChemInfo_MR_Final()
          call NewInv_MR_Final()
          nbru=882
          izero = 0
          ifmin = 1
          call examin(nbru, mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine WriteShellScript(stringa, stampaInfo)
      USE General
      USE Groups
      USE ArpWarp
!
      implicit none
      integer :: Lung, itype, iform, jop, jopen, ier, i, k, kk
      integer :: lwork, lmtz, lcard, lstringa, numCpu, stampaInfo
      character (len=*) :: stringa
!
      lstringa = Lung(stringa)
      cardImage = nome(1:lnome) // '_' // stringa(1:lstringa)
      lcard = Lung(cardImage)
      itype = 0
      iform = 1
      jop = jopen(jhost,cardImage(1:lcard),itype,iform,ier)
!
      nResid = sum(iabs(ResInChains(1:nChains)))
      lwork = Lung(WorkingDirectory)
      lmtz  = Lung(MTZfileAW)
      cardImage = WorkingDirectory(1:lwork)
     *         // slash // MTZfileAW(1:lmtz)
      lcard = Lung(cardImage)
!
      if (stringa(1:lstringa) == 'arprun_phases.sh') then
          if (stampaInfo == 1)
     *    write(lo,100) stringa(1:lstringa)
          write(jhost,'(a)') '#!/bin/sh'
          if (stampaInfo == 1)
     *    write(lo   ,'(a)') '#!/bin/sh'
          Msg = 'echo "Running ARP/wARP AutoBuilding on ' 
     *        // nome(1:lnome)
     *        // ' data..."'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          if (stampaInfo == 1)
     *    write(lo   ,'(a)') Msg(1:Lung(Msg))
          write(jhost,'(a)') 'auto_tracing.sh \'
*         Msg = '   datafile ' // WorkingDirectory(1:lwork) // slash
*    *              // MTZfile(1:Lung(MTZfile)) // ' \'
          Msg = '   datafile ' // MTZfile(1:Lung(MTZfile)) // ' \'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          if (stampaInfo == 1)
     *    write(lo   ,'(a)') Msg(1:Lung(Msg))
          if (cicloAW > 1) then
              Msg = '   modelin ' // WorkingDirectory(1:lwork) // slash
     *                  // FichierOut(1:Lung(FichierOut)) // ' \'
              write(jhost,'(a)') Msg(1:Lung(Msg))
              if (stampaInfo == 1)
     *        write(lo   ,'(a)') Msg(1:Lung(Msg))
          endif
*         Msg = 'compareto calmopb.pdb \'
*         write(jhost,'(3x,a)') Msg(1:Lung(Msg))
          write(Msg,'(a,i10,a)') 'residues', nResidStored, ' \'
          call OneBlankOnly(Msg)
          write(jhost,'(3x,a)') Msg(1:Lung(Msg))
          if (stampaInfo == 1)
     *    write(lo   ,'(3x,a)') Msg(1:Lung(Msg))
          Msg = '   workdir ' // WorkingDirectory(1:lwork) // ' \'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          if (stampaInfo == 1)
     *    write(lo   ,'(a)') Msg(1:Lung(Msg))
          if (numbGen == 0) then
              Msg = '   fp F sigfp SIGF phibest PHIC fom FOM '
     *           // ' freelabin FreeR_flag \'
          else
              Msg = '   fp F sigfp SIGF '
     *           // ' fbest FWT phibest PHI_EDM '
     *           // ' freelabin FreeR_flag \'
          endif
          write(jhost,'(a)') Msg(1:Lung(Msg))
          if (stampaInfo == 1)
     *    write(lo   ,'(a)') Msg(1:Lung(Msg))
          if (nValidChains > 0) then
              Msg = '   seqin ' // WorkingDirectory(1:lwork) // slash 
     *            // SeqFile(1:Lung(SeqFile)) // ' \'
*    *            // 'modellook.pir' // ' \'
              write(jhost,'(a)') Msg(1:Lung(Msg))
              if (stampaInfo == 1)
     *        write(lo   ,'(a)') Msg(1:Lung(Msg))
*??*          if (ifHeavyPDB == 1) then
*??*              Msg = '   modelin ' // WorkingDirectory(1:lwork) 
*??* *            // slash 
*??* *            // PDBfile(1:Lung(PDBfile)) // ' \'
*??*          endif
          endif
!
          if (cicloAW == 1. and. ifHeavyPDB > 0) then     ! PEZZA
              write(jhost,'(a)') '   buildingcycles 1 \'
              if (stampaInfo == 1)
     *        write(lo   ,'(a)') '   buildingcycles 1 \'
          endif
!
          write(Inte,'("cgr",i5)') nMonomer
          call OneBlankOnly(Inte)
          Msg = '   ' // Inte
          write(jhost,'(a)') Msg(1:Lung(Msg))
          if (stampaInfo == 1)
     *    write(lo   ,'(a)') Msg(1:Lung(Msg))
          if (stampaInfo == 1)
     *    write(lo,300)
      elseif (stringa(1:lstringa) == 'phenixrun_phases.sh') then
          write(lo,200) stringa(1:lstringa)
          write(jhost,'(a)') '#!/bin/sh'
          write(lo   ,'(a)') '#!/bin/sh'
          write(jhost,'(a)') 'echo "Running AutoBuild on ' //
     *                       nome(1:lnome) // '  data..."'
          write(lo   ,'(a)') 'echo "Running AutoBuild on ' //
     *                       nome(1:lnome) // '  data..."'
          Msg = 'phenix.autobuild  write_run_directory_to_file=' //
     *           nome(1:lnome) // '_phenix.log \'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          write(lo   ,'(a)') Msg(1:Lung(Msg))
          Msg = '   seq_file=' // WorkingDirectory(1:lwork) // slash 
     *          // SeqFile(1:Lung(SeqFile)) // ' \'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          write(lo   ,'(a)') Msg(1:Lung(Msg))
          Msg = '   input_data_file=' // MTZfile(1:Lung(MTZfile))// ' \'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          write(lo   ,'(a)') Msg(1:Lung(Msg))
          Msg = '   input_labels="F SIGF PHIC FOM ' //
     *          'HLA HLB HLC HLD FreeR_flag" \'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          write(lo   ,'(a)') Msg(1:Lung(Msg))
          write(Inte,'("ncs_copies=",i5, " \")') nMonomer
          call OneBlankOnly(Inte)
          Msg = '   ' // Inte
          write(jhost,'(a)') Msg(1:Lung(Msg))
          write(lo   ,'(a)') Msg(1:Lung(Msg))
          write(Inte,'("nproc=",i5)') numCpu()
          call OneBlankOnly(Inte)
          Msg = '   ' // Inte
          write(jhost,'(a)') Msg(1:Lung(Msg))
          write(lo   ,'(a)') Msg(1:Lung(Msg))
          write(lo,300)
      elseif (stringa(1:lstringa) == 'nuce_arp.sh') then
          write(jhost,'(a)') '#!/bin/sh'
          write(jhost,'(a)') 'echo'
          write(jhost,'(a)') 'echo'
          Msg = 'echo "Running Nucleotide Building on ' 
     *        // nome(1:lnome)
     *        // ' data..."'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          write(jhost,'(a)') 'auto_nuce.sh \'
          if (nResid == 0) then
              Msg = '   datafile ' // WorkingDirectory(1:lwork) // slash
     *              // nome(1:lnome) // '_arp_out.mtz \'
          else
              Msg = '   datafile ' // WorkingDirectory(1:lwork) // slash
     *              // nome(1:lnome) // '_refmac.mtz \'
          endif
          write(jhost,'(a)') Msg(1:Lung(Msg))
*         write(Msg,'(a,i10,a)') 'residues', nResidStored, ' \'
*         call OneBlankOnly(Msg)
          write(jhost,'(3x,a)') Msg(1:Lung(Msg))
          write(Msg,'(a,i10,a)') 'nucleotides', nAcid, ' \'
          call OneBlankOnly(Msg)
          write(jhost,'(3x,a)') Msg(1:Lung(Msg))
          Msg = '   workdir ' // WorkingDirectory(1:lwork) // ' \'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          if (nResid == 0) then
              Msg = '   fp F sigfp SIGF phib PHI_EDM fom WT_EDM '
          else
              Msg = '   fp F_ILM sigfp SIGF_ILM phib PHIC fom FOM '
          endif
          write(jhost,'(a)') Msg(1:Lung(Msg))
      elseif (stringa(1:lstringa) == 'phenixrun_model.sh') then
          write(jhost,'(a)') '#!/bin/sh'
          write(jhost,'(a)') 'echo "Running AutoBuild on ' //
     *                       nome(1:lnome) // '  data..."'
          Msg = 'phenix.autobuild  write_run_directory_to_file=' //
     *           nome(1:lnome) // '_phenix.log \'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          Msg = '   seq_file=' // WorkingDirectory(1:lwork) // slash 
     *          // SeqFile(1:Lung(SeqFile)) // ' \'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          Msg = '   input_data_file=' // WorkingDirectory(1:lwork) // 
     *          slash // MTZfile(1:Lung(MTZfile)) // ' \'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          Msg = '   input_labels="F SIGF ' //
     *          'None None None None None FreeR_flag" \'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          write(Inte,'("ncs_copies=",i5, "\")') nMonomer
          call OneBlankOnly(Inte)
          Msg = '   ' // Inte
          write(jhost,'(a)') Msg(1:Lung(Msg))
          write(Inte,'("nproc=",i5)') numCpu()
          call OneBlankOnly(Inte)
          Msg = '   ' // Inte
          write(jhost,'(a)') Msg(1:Lung(Msg))
      elseif (stringa(1:lstringa) == 'refmac_arp.sh') then
          write(jhost,'(a)') '#!/bin/sh'
          write(jhost,'(a)') "echo 'ARP/wARP working directory: ' "//
     *                       "$1 $2 $3"
          write(jhost,'(a)') 'refmac5 \'
          Msg = 'hklin ' // MTZfile(1:Lung(MTZfile)) // ' \'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          if (nAcid > 0 .and. nResidStored == 0) then
              write(jhost,'(a)') 'xyzin ' //
     *                           '$1/' // nome(1:lnome) 
     *                        // '_arp_out_warp_nuce.pdb \'
          else
              k = index(MTZfile,'.mtz') - 1
              write(jhost,'(a)') 'xyzin ' //
     *                           '$1/' // MTZfile(1:k)
     *                        // '_warpNtrace.pdb \'
          endif
          Msg = 'hklout ' // nome(1:lnome) // '_refmac.mtz <<END'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          write(jhost,'(a)') 'labin FP=F SIGFP=SIGF ' //
     *                       'FREE=FreeR_flag'
          write(jhost,'(a)') 'refi -'
              write(jhost,'(a)') '    type UNRE -'
              write(jhost,'(a)') '    resi MLKF -'
              write(jhost,'(a)') '    meth CGMAT'
          write(jhost,'(a)') 'ncyc 0'
          write(jhost,'(a)') 'END'
      elseif (stringa(1:lstringa) == 'refmac_phenix.sh') then
          write(jhost,'(a)') '#!/bin/sh'
          write(jhost,'(a)') "echo 'PHENIX working directory: ' "//
     *                       "$1 $2"
          write(jhost,'(a)') 'refmac5 \'
          Msg = 'hklin ' // MTZfile(1:Lung(MTZfile)) // ' \'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          write(jhost,'(a)') 'xyzin ' //
     *                       '$1/' // 'overall_best.pdb \'
          Msg = 'xyzout ' // nome(1:lnome) // '_phenix.pdb \'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          Msg = 'hklout ' // nome(1:lnome) // '_refmac.mtz <<END'
          write(jhost,'(a)') Msg(1:Lung(Msg))
          write(jhost,'(a)') 'labin FP=F SIGFP=SIGF ' //
     *                       'FREE=FreeR_flag'
          write(jhost,'(a)') 'refi -'
              write(jhost,'(a)') '    type UNRE -'
              write(jhost,'(a)') '    resi MLKF -'
              write(jhost,'(a)') '    meth CGMAT'
          write(jhost,'(a)') 'ncyc 0'
          write(jhost,'(a)') 'END'
      else
          if (ifAmb == 2) then    !  arp/warp
              write(jhost,'(a)') '#! /bin/bash'
              if (nAcid > 0 .and. nResidStored == 0) then
                  Msg = '# starts nuce.sh'
                  write(jhost,'(a)') Msg(1:Lung(Msg))
                  Msg = './' // nome(1:lnome) // '_nuce_arp.sh  >> '
     *                // nome(1:lnome) // '_arp.log'
                  write(jhost,'(a)') Msg(1:Lung(Msg))
              else
                  Msg = '# starts arp/warp'
                  write(jhost,'(a)') Msg(1:Lung(Msg))
                  Msg = 
     *               './' // nome(1:lnome) // '_arprun_phases.sh 1 0 > '
     *               // nome(1:lnome) // '_arp.log'
                  write(jhost,'(a)') Msg(1:Lung(Msg))
              endif
              Msg = 
     *        "a=`fgrep 'Job ID is set to' "  //
     *            nome(1:lnome) // "_arp.log" // "  | cut -c23-37 `"
              write(jhost,'(a)') Msg(1:Lung(Msg))
              Msg = '# starts refmac'
              write(jhost,'(a)') Msg(1:Lung(Msg))
              Msg = './' // nome(1:lnome) // '_refmac_arp.sh $a 1 0 >> '
     *            // nome(1:lnome) // '_refmac.log'
              write(jhost,'(a)') Msg(1:Lung(Msg))
              if (nAcid > 0 .and. nResidStored > 0) then
                  Msg = '# starts nuce.sh'
                  write(jhost,'(a)') Msg(1:Lung(Msg))
                  Msg = './' // nome(1:lnome) // '_nuce_arp.sh  >> '
     *                // nome(1:lnome) // '_arp.log'
                  write(jhost,'(a)') Msg(1:Lung(Msg))
              endif
              Msg = '# end of the procedure'
              write(jhost,'(a)') Msg(1:Lung(Msg))
          elseif (ifAmb == 3) then  !  phenix                    
              write(jhost,'(a)') '#! /bin/bash'
              Msg = '# prepare the mtz files to be used'
              write(jhost,'(a)') Msg(1:Lung(Msg))
              Msg = '# starts phenix'
              write(jhost,'(a)') Msg(1:Lung(Msg))
              if (ifAmbModel == 0) then ! Starting from phases
                  Msg = './' // nome(1:lnome) // 
     *                  '_phenixrun_phases.sh 1 0 > ' //
     *                  nome(1:lnome) // '_phenix.log'
              else                      ! Starting from model
                  Msg = './' // nome(1:lnome) // 
     *                  '_phenixrun_model.sh 1 0 > ' //
     *                  nome(1:lnome) // '_phenix.log'
              endif
              write(jhost,'(a)') Msg(1:Lung(Msg))
              Msg = 
     *        "a=`tail -n1 "  //
     *            nome(1:lnome) // "_phenix.log" // " `"
              write(jhost,'(a)') Msg(1:Lung(Msg))
              Msg = 'grep  Placed  $a/*run*.log > ' //
     *              nome(1:lnome) // '_tmp.log'
              write(jhost,'(a)') Msg(1:Lung(Msg))
              Msg = 'echo $a >> ' //
     *              nome(1:lnome) // '_tmp.log'
              write(jhost,'(a)') Msg(1:Lung(Msg))
              Msg = '# starts refmac'
              write(jhost,'(a)') Msg(1:Lung(Msg))
              Msg = 
     *           './' // nome(1:lnome) // '_refmac_phenix.sh $a 1 0 >> '
     *           // nome(1:lnome) // '_refmac.log'
              write(jhost,'(a)') Msg(1:Lung(Msg))
              Msg = '# less $a/AutoBuild_run_*.log  >> ' //
     *              nome(1:lnome) // "_phenix.log"
              write(jhost,'(a)') Msg(1:Lung(Msg))
              Msg = '# end of the procedure'
              write(jhost,'(a)') Msg(1:Lung(Msg))
          endif
      endif
!
      close(jhost)
      cardImage = nome(1:lnome) // '_' // stringa(1:lstringa)
      lcard = Lung(cardImage)
      cardImage(lcard+1:lcard+1) = char(0)
      call MakeExec(cardImage)
!
      return
  100 format(' Starting ARP/wARP using the script ',a,':',/,/,60('#'))
  200 format(' Starting Phenix using the script ',a,':',/,/,60('#'))
  300 format(60('#'),/)
      end
!-----------------------------------------------------------------------
      subroutine AppendArpPhenixLog(stampaInfo, nPDB)
      USE General
      USE PhaseModule
      USE ArpWarp
      USE Grafici
      USE Dialogo
      USE Groups
!
      implicit none
      integer :: Lung, itype, iform, jop, jopen, ier
      integer :: lcard, k, L, box, nPDB, residues, LL, stampaInfo
      real    :: Valore
      logical :: Esiste, normal
      character (len=9) :: AmbPgm
      character(len=128) :: Inte_R
!
      if (ifAmb == 2) then
          AmbPgm = 'ARP/wARP'
      elseif (ifAmb == 3) then
          AmbPgm = 'Phenix'
      endif
      LL = Lung(AmbPgm)
      box = lastBox
      nPDB = 0
      normal = .false.
      cardDiret = ' '
      if (ifAmb == 2) then
          cardImage = nome(1:lnome) // "_arp.log"
      else
          cardImage = nome(1:lnome) // "_tmp.log"
      endif
      lcard = Lung(cardImage)
      itype = 2
      iform = 1
      jop = jopen(jhost,cardImage(1:lcard),itype,iform,ier)
      if (jop == 0) then
          if (ifAmb == 2 .and. stampaInfo == 1) then
              write(lo,20) 'ARP/wARP',cardImage(1:lcard)
          endif
!
          coverage = -1
          if (ifAmb == 2) then
              do
                 read(jhost,'(a)',end=10) cardImage
                 if (ifAmb == 2) then
                     lcard = Lung(cardImage)
                     if (stampaInfo == 1) then
                         write(lo,'(a)') cardImage(1:lcard)
                     endif
                     k = index(cardImage, 'Creating directory')
                     if (k > 0) then
                         direttorioAW = cardImage(22:)
                         nPDB = nPDB + 1
                         call shift(direttorioAW, lendirAW)
                         card(nPDB) = direttorioAW(1:lendirAW)
                     endif
                     k = index(cardImage, 'Sequence coverage')
                     if (k > 0) then
                         Inte = cardImage(23:)
                         call shift(Inte, k)
                         Inte(k:k) = ' '
                         coverage = Valore(Inte)
                     endif
                     k = index(cardImage, 'After refmac, R =')
                     if (k > 0) then
                         cardDiret = cardImage
                     endif
                     k = index(cardImage, 'Normal termination of warp')
                     if (k > 0) then
                         normal = .true.
                     endif
                 endif
              enddo
   10         close(jhost)
          else
              normal = .true.
              do 
                read(jhost,'(a)',end=12) Inte
                if (Inte(1:5) == 'Cycle') then
                    cardImage = Inte
                else
                    direttorioAW = Inte
                    exit
                endif
              enddo
   12         continue
              nPDB = nPDB + 1
              call shift(direttorioAW, lendirAW)
              card(nPDB) = direttorioAW(1:lendirAW)
              k = index(cardImage, 'Place')
              Inte = cardImage(1:k-1)
              cardImage(1:k+6) = ' '
              residues = nint(Valore(cardImage))
              if (residues >= 0) then
                  write(lo,'(a,a)') ' ', MessH(1:Lung(MessH))
                  write(lo,*)
                  if (numeroResidui > 0) then
                     coverage=100.0*float(residues)/float(numeroResidui)
                     coverage=min(100.0,coverage)
                  endif
                  normal = .true.
              else
                  ifAmb = 0
                  erreAW = ' '
                  if (ifSeq == 0) then
                      write(lo,65) AmbPgm(1:LL)
                  else
                      write(lo,70) AmbPgm(1:LL)
                  endif
                  if (ifMadEnv /= 0) then
                      if (ifSeq == 0) then
                          Msg = '        !!! Sequence not provided: ' //
     *                    AmbPgm(1:LL) // ' failure !!!'
                      else
                          Msg = '        !!! ' // AmbPgm(1:LL) // 
     *                      ' failure !!!'
                      endif
                      call TestoGR(Msg, color_LIGHTRED, 2, box)
                  endif
              endif
   11         close(jhost)
          endif
!
!-- estract R & Rfree values
!
          erreAW = ' '
          if (normal) then
              if (ifAmb == 2) then
                  if (nAcid > 0 .and. nResidStored == 0) then
                      call RefmacResults(0)
                  else
                      if (stampaInfo == 1) then
                          write(lo,60) AmbPgm(1:LL)
                          write(lo,'(a,a)') ' ', MessH(1:Lung(MessH))
                      endif
                      k = index(cardDiret, 'R =')
                      if (k > 0) then
                          erreAW = cardDiret(k:k+25)
                          k = Lung(erreAW)
                          if (erreAW(k:k) == '.') erreAW(k:k) = ' '
                      else
                          erreAW = ' '
                      endif
                      k = index(erreAW, 'R =')
                      if (k > 0) then
                          Inte = erreAW(k+3:k+8)
                          RfacAW = Valore(Inte)
                          errem = RfacAW
                          k = index(erreAW, '=',.true.)
                          Inte = erreAW(k+2:k+6)
                          RfreAW = Valore(Inte)
                      endif
                  endif
              elseif (ifAmb == 3) then
                  k = index(Inte,'=')
                  Inte(1:k) = ' '
                  call shift(Inte, k)
                  k = index(Inte,'/')
                  L = index(Inte,' ')
                  erreAW = 'R = ' // Inte(1:k-1) // ' (Rfree = ' //
     *                     Inte(k+1:L-1) // ')'

                  Inte_R = Inte(1:k-1)
                  RfacAW = Valore(Inte_R)
                  errem = RfacAW
                  Inte_R = Inte(k+1:L-1)
                  RfreAW = Valore(Inte_R)
!Cycle 1  R/Rfree=0.28/0.32  Built=169  Placed=160
              endif
!-- Update PDB file name (Best Model)
!
          else
              if (stampaInfo == 1) then
                  ifAmb = 0
                  erreAW = ' '
                  if (ifSeq == 0) then
                      write(lo,65) AmbPgm(1:LL)
                  else
                      write(lo,70) AmbPgm(1:LL)
                  endif
                  if (ifMadEnv /= 0) then
                      if (ifSeq == 0) then
                          Msg = '        !!! Sequence not provided: ' //
     *                    AmbPgm(1:LL) // ' failure !!!'
                      else
                          Msg = '        !!! ' // AmbPgm(1:LL) // 
     *                      ' failure !!!'
                      endif
                      call TestoGR(Msg, color_LIGHTRED, 2, box)
                  endif
              endif
          endif
      endif
      if (stampaInfo == 1) then
          write(lo,30) ' Created directory: ',direttorioAW(1:lendirAW)
          if (coverage >= 0) then
              write(lo,40) ' Sequence coverage =', nint(coverage)
          else
              write(lo,50) ' Sequence coverage = n.a.'
          endif
          if (erreAW(1:1) /= ' ') then
              write(lo,'(a,a)') ' ' // AmbPgm(1:LL) // ' results: ' 
     *                          // erreAW
          endif
      endif
!
      return
   20 format(/,72('-'),/,' Copy of the ',a,' log file (',a,')',/)
   30 format(/,a,a)
   40 format(/,a,i3,'%')
   50 format(/,a)
   60 format(/,' Normal termination of ',a)
   65 format(/,' !!! Sequence not provided: ',a,' failure !!!')
   70 format(/,' !!! ',a,' failure !!!')
      end
!-----------------------------------------------------------------------
      subroutine AppendBuccaneerLog(stampaInfo)
      USE General
      USE PhaseModule
      USE ArpWarp
      USE Grafici
      USE Dialogo
      USE Groups
      USE Direttive, only: vet, ivet
!
      implicit none
      integer :: Lung, itype, iform, jop, jopen, ier, iopt, iv, k1
      integer :: lcard, k, box, residues, stampaInfo
      real    :: Valore
      logical :: Esiste
      logical :: start
!
      box = lastBox
      start = .false.
      residues = -1
      coverage = -1
      cardDiret = ' '
      cardImage = nome(1:lnome) // "_buccaneer.log"
      lcard = Lung(cardImage)
      itype = 2
      iform = 1
      jop = jopen(jhost,cardImage(1:lcard),itype,iform,ier)
      if (jop == 0) then
      erreAW = ' '
*         cardImage = nome(1:lnome) // "_buccaneer.pdb"
*         inquire (file=cardImage,  exist = Esiste)
*         if (Esiste) then
!
              do
                 read(jhost,'(a)',end=10) Inte
                 k = index(Inte, 'residues were sequenced, after pru')
                 if (k > 0) then
                     cardImage = Inte(1:k-1)
                     residues = nint(Valore(cardImage))
                 endif
                 if (start) then
                     read(jhost,'(a)', end=10) Inte
                     k = index(Inte, 'R factor')
                     if (k > 0) then
                         erreAW = 'R = ' // Inte(k+21:k+26)
                         Inte(k:k+7) = '        '
                         iopt = 0
                         call getnum(Inte, vet, ivet, iv, iopt)
                         RfacAWi = vet(1)
                         RfacAW  = vet(2)
                         errem = RfacAWi
                     endif
                     read(jhost,'(a)', end=10) Inte
                     k = index(Inte, 'R free')
                     if (k > 0) then
                         k1 = Lung(erreAW) + 1
                         erreAW(k1:) = '  (Rfree = ' // Inte(k+19:k+24) 
     *                               // ')'
                         Inte(k:k+5) = '      '
                         iopt = 0
                         call getnum(Inte, vet, ivet, iv, iopt)
                         RfreAWi = vet(1)
                         RfreAW  = vet(2)
                     endif
                     start = .false.
                 endif
                 if (index(Inte, '$$ Final results $$') > 0) then
                     start = .true.
                 endif
              enddo
   10         close(jhost)
*         endif
!
!-- print results
!
          residuesAW = residues
          if (residues >= 0) then
              if (stampaInfo == 1) then
                  write(lo,'(a,a)') ' ', MessH(1:Lung(MessH))
                  write(lo,*)
!*!               write(lo,'(a,a)') ' Buccaneer results: ', erreAW

           if (knw > 0)
     *     write(lo,*) ' Prova results: ',RfacAWi,RfacAW,RfreAWi,RfreAW

              endif
              if (numeroResidui > 0) then
                  if (residues > 0) then
                     coverage = float(residues)/float(numeroResidui)
                     coverage = 100.0*coverage
                     coverage=min(100.0,coverage)
                  else
                     coverage=0
                  endif
              endif
          else
              if (stampaInfo == 1) then
                  ifAmb = 0
                  erreAW = ' '
                  if (ifSeq == 0) then
                      write(lo,60)
                  else
                      write(lo,70)
                  endif
                  if (ifMadEnv /= 0) then
                      if (ifSeq == 0) then
                          Msg = '        !!! Sequence not provided: ' //
     *                         'Buccaneer failure !!!'
                      else
                          Msg = '        !!! Buccaneer failure !!!'
                      endif
                      call TestoGR(Msg, color_LIGHTRED, 2, box)
                  endif
              endif
          endif
      else
          if (stampaInfo == 1) then
              ifAmb = 0
              erreAW = ' '
               if (ifSeq == 0) then
                   write(lo,60)
               else
                   write(lo,70)
               endif
               if (ifMadEnv /= 0) then
                   if (ifSeq == 0) then
                       Msg = '        !!! Sequence not provided: ' //
     *                       'Buccaneer failure !!!'
                   else
                       Msg = '        !!! Buccaneer failure !!!'
                   endif
                  call TestoGR(Msg, color_LIGHTRED, 2, box)
               endif
          endif
      endif

!*!   if (stampaInfo == 1) then
!*!       if (residues >= 0) then
!*!           write(lo,40) ' Sequenced residues = ', residues
!*!           write(lo,45) ' Sequence coverage  = ', nint(coverage), '%'
!*!       else
!*!           write(lo,40) ' Sequenced residues = n.a.'
!*!           write(lo,40) ' Sequence coverage  = n.a.'
!*!       endif
!*!   endif
!
      return
   30 format(/,a,a)
   40 format(/,a,i5)
   45 format(a,i5,a)
   50 format(/,a)
   60 format(/,' !!! Sequence not provided: Buccaneer failure !!!')
   70 format(/,' !!! Buccaneer failure !!!')
      end
!-----------------------------------------------------------------------
      subroutine AppendNautilusLog(stampaInfo)
      USE General
      USE PhaseModule
      USE ArpWarp
      USE Grafici
      USE Dialogo
      USE Groups
      USE Direttive, only: vet, ivet
!
      implicit none
      integer :: Lung, itype, iform, jop, jopen, ier, iopt, iv, k1
      integer :: lcard, k, box, residues, stampaInfo
      real    :: Valore
      logical :: Esiste
      logical :: start
!
      box = lastBox
      start = .false.
      residues = -1
      coverage = -1
      cardDiret = ' '
      cardImage = nome(1:lnome) // "_nautilus.log"
      lcard = Lung(cardImage)
      itype = 2
      iform = 1
      jop = jopen(jhost,cardImage(1:lcard),itype,iform,ier)
      if (jop == 0) then
!
          do
             read(jhost,'(a)',end=10) Inte
             k = index(Inte, 'SEQNC:')
             if (k > 0) then
                 Inte(1:6) = ' '
                 call shift(Inte, k)
                 k = index(Inte, 'nucleic acids built')
                 cardImage = Inte(1:k-1)
                 residues = nint(Valore(cardImage))
             endif
             if (start) then
                 read(jhost,'(a)', end=10) Inte
                 k = index(Inte, 'R factor')
                 if (k > 0) then
                     erreAW = 'R = ' // Inte(k+21:k+26)
                     Inte(k:k+7) = '        '
                     iopt = 0
                     call getnum(Inte, vet, ivet, iv, iopt)
                     RfacAWi = vet(1)
                     errem = RfacAWi
                     RfacAW  = vet(2)
                 endif
                 read(jhost,'(a)', end=10) Inte
                 k = index(Inte, 'R free')
                 if (k > 0) then
                     k1 = Lung(erreAW) + 1
                     erreAW(k1:) = '  (Rfree = ' // Inte(k+19:k+24) 
     *                           // ')'
                     Inte(k:k+5) = '      '
                     iopt = 0
                     call getnum(Inte, vet, ivet, iv, iopt)
                     RfreAWi = vet(1)
                     RfreAW  = vet(2)
                 endif
                 start = .false.
             endif
             if (index(Inte, '$$ Final results $$') > 0) then
                 start = .true.
             endif
          enddo
   10         close(jhost)
*         endif
!
!-- print results
!
          if (residues >= 0) then
              if (stampaInfo == 1) then
                  write(lo,'(a,a)') ' ', MessH(1:Lung(MessH))
                  write(lo,*)
                  write(lo,'(a,a)') ' Nautilus results: ', erreAW
              endif
              if (numeroResidui > 0) then
*                 coverage=100.0*float(residues)/float(numeroResidui)
                  coverage = residues
              endif
          else
              if (stampaInfo == 1) then
                  ifAmb = 0
                  erreAW = ' '
                  if (ifSeq == 0) then
                      write(lo,60)
                  else
                      write(lo,70)
                  endif
                  if (ifMadEnv /= 0) then
                      if (ifSeq == 0) then
                          Msg = '        !!! Sequence not provided: ' //
     *                         'Nautius failure !!!'
                      else
                          Msg = '        !!! Nautius failure !!!'
                      endif
                      call TestoGR(Msg, color_LIGHTRED, 2, box)
                  endif
              endif
          endif
      else
          if (stampaInfo == 1) then
              ifAmb = 0
              erreAW = ' '
              if (ifSeq == 0) then
                  write(lo,60)
              else
                  write(lo,70)
              endif
              if (ifMadEnv /= 0) then
                  if (ifSeq == 0) then
                      Msg = '        !!! Sequence not provided: ' //
     *                      'Nautilus failure !!!'
                  else
                      Msg = '        !!! Nautilus failure !!!'
                  endif
                  call TestoGR(Msg, color_LIGHTRED, 2, box)
              endif
          endif
      endif

      if (stampaInfo == 1) then
          if (residues >= 0) then
              write(lo,40) ' Nucleic acids built = ', residues,
     *                     ' (', nAcid, ' in sequence)'
          else
              write(lo,40) ' Sequenced residues = n.a.'
          endif
      endif
!
      return
   30 format(/,a,a)
   40 format(/,a,i5,a,i5,a)
   45 format(a,i5,a)
   50 format(/,a)
   60 format(/,' !!! Sequence not provided: Nautilus failure !!!')
   70 format(/,' !!! Nautilus failure !!!')
      end
!-----------------------------------------------------------------------
      subroutine UpdatePDB(nPDB)
      USE General
      USE Atomi
      USE Molcom
      USE ArpWarp
      USE Groups
!
      implicit none
      integer :: nPDB, i, j, k, L, Lung, ier, n, nCatena, nResi, oldResi
      integer :: jop, jopen, itype, iform
      real, allocatable :: FattoreTermico(:)
      real    :: x1(3), x2(3)
      character (len=1) :: Catena, oldCatena
      character (len=2) :: a1, a2
!
      if (ifAmb == 2) then
          Inte = nome(1:lnome) // '_arp.pdb'
      elseif (ifAmb == 3) then
          Inte = nome(1:lnome) // '_phenix.pdb'
      endif
      cardDiret = WorkingDirectory(1:Lung(WorkingDirectory))
     *         // slash // Inte(1:Lung(Inte))
      FichierOut = Inte
      AmbPDB = FichierOut
      itype = 0
      iform = 1
      jop = jopen(jhost, FichierOut, itype, iform, ier)
! 
      nCatena = ichar('A') - 1
      oldCatena = '*'
      nResi = 0
      oldResi = -1
      n = 0
      do i=1, nPDB
         L = Lung(card(i))
         if (i == 1 .and. nResidStored == 0 .or. i == 2) then
             cardImage = card(i)(1:L) // slash
     *                // nome(1:lnome) // '_refmac_warp_nuce.pdb'
         else
             if (ifAmb == 2) then
                 k = index(MTZfile,'.mtz') - 1
                 cardImage = card(i)(1:L) // slash
     *                    // MTZfile(1:k) // '_warpNtrace.pdb'
             else
             endif
         endif
         itype = 0
         iform = 1
         jop = jopen(jrel, cardImage, itype, iform, ier)
         do
            read(jrel,'(a)',end=10) Inte
            if (Inte(1:6) == 'CRYST1' .or.
     *          Inte(1:5) == 'SCALE') then
                if (i == 1) then
                    L = Lung(Inte)
                    write(jhost,'(a)') Inte(1:L)
                endif
            elseif (Inte(1:4) == 'ATOM') then
                if (Inte(18:20) == 'DUM') cycle
                n = n + 1
                write(Inte(7:11),'(i5)') n
                catena = Inte(22:22)
                if (catena /= oldCatena) then
                    nCatena = nCatena + 1
                    oldCatena = catena
                endif
                Inte(22:22) = char(nCatena)
                read(Inte(23:26),'(i4)') k
                if (k /= oldResi) then
                    nResi = nResi + 1
                    oldResi = k
                endif
                write(Inte(23:26),'(i4)') nResi
                L = Lung(Inte)
                write(jhost,'(a)') Inte(1:L)
            endif
         enddo
   10    continue
         if (cicloAW == 1. and. ifHeavyPDB > 0) then
             do j=1, ifHeavyPDB
                k = iabs(nz(j)) / nzConst
                a2(1:2) = Species(k)(1:2)
                call ucase(a2)
                a1 = a2
                if (a2(2:2) == ' ') then
                    a2(2:2) = a2(1:1)
                    a2(1:1) = ' '
                endif
                x1(1:3) = xyzs(1:3,j)
                call MoltMatVec(rm, x1, x2)
                write(Inte,20) a1(1:2), a1(1:2), x2(1:3), xyzs(5,j), bt,
     *                         a2(1:2)
                n = n + 1
                write(Inte(7:11),'(i5)') n
                nResi = nResi + 1
                write(Inte(23:26),'(i4)') nResi
                nCatena = nCatena + 1
                Inte(22:22) = char(nCatena)
                write(jhost,'(a)') Inte(1:80)
             enddo
         endif
         close(jrel)
      enddo
!
      close(jhost)
!
      return
   20 format('HETATM      ',a2,4x,a2,10x,3f8.3,2f6.2,10x,a2)
      end
!-----------------------------------------------------------------------
      subroutine UpdatePDBCoords(In, Out)
      USE General
      USE RemoModule
      USE Molcom
!
      implicit none
      integer :: i, nAtoms, n, itype, iform, jop, jopen, ier, Lung
      real    :: xo(3), xn(3)
      logical :: leggiB
      character (len=*) :: In, Out
!
      itype = 0
      iform = 1
      jop = jopen(jrel, In, itype, iform, ier)
      itype = 0
      iform = 1
      jop = jopen(jhost, Out, itype, iform, ier)

      leggiB = .false.
      n = 0
      do
         read(jrel,'(a)',end=10) Inte
         if (Inte(1:6) == 'CRYST1') then
             leggiB = .true.
         endif
         if (leggiB) then
             if (Inte(1:4) == 'ATOM' .or. Inte(1:4) == 'HETA') then
                 n = n + 1
                 xo(1:3) = model(1)%atoms(1:3,n,1)
                 call MoltMatVec(rm, xo, xn)
                 write(Inte(31:54),'(3f8.3)') xn(1:3)
             endif
             write(jhost,'(a)') Inte(1:Lung(inte))
         else
             write(jhost,'(a)') Inte(1:Lung(inte))
         endif
      enddo
   10 continue
!
      close(jrel)
      close(jhost)
!
      call cCopyFile(Out, In)
      itype = 0
      iform = 1
      jop = jopen(jhost, Out, itype, iform, ier)
      close(jhost, status='delete')
!
      return
      end
!-----------------------------------------------------------------------
      subroutine HeavyPDB
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE Molcom
      USE PhaseModule
      USE ArpWarp
      USE RemoModule
!
      implicit none
      integer :: i, HeavyInPDB, mode, numb, ier, iflagPKS, nne, jlig
      integer :: k, kk, Lung, jop, jopen, itype, iform
      integer :: kStripTask1
      real    :: x1(3), x2(3)
      character (len=2) :: a1, a2
      character (len=4) :: a4
!
      jlig = 0
      HeavyInPDB = 0
      do i=1, nk
         if (no(i) > 20) then
             HeavyInPDB = HeavyInPDB + float(nw(i)) / totop
             if (jlig == 0) then
                 jlig = i
             endif
         endif
      
      enddo
      if (HeavyInPDB == 0) then
          ifHeavyPDB = 0
          return
      endif
      ifHeavyPDB = HeavyInPDB
!
      fcoef(:) = evet(:) * wt(:)
      call MakeMap(fcoef, iphaz, nrefl, 0, xmap, FORTH, BACK)
      nats = ifHeavyPDB
      aperc(1) = ifHeavyPDB
      ifFour = 1
      iflagPKS = 0
      mode = 0
      krecy = 0
      numb = nrefl
      ier = 0
      call pksrch_New(mode, iflagPKS, numb, ier)
      nne = nats
      nz(1:nne) = jlig * nzConst
      call to_coord_sir(1, nrefl)
*     call label(nne)
      ifHeavyPDB = nw(nk) / totop
      nats = ifHeavyPDB
      do i=1, ifHeavyPDB
         k = iabs(nz(i)) / nzConst
         a2(1:2) = Species(k)(1:2)
         call ucase(a2)
         a1 = a2
         if (a2(2:2) == ' ') then
             a2(2:2) = a2(1:1)
             a2(1:1) = ' '
         endif
         x1(1:3) = xyzs(1:3,i)
         call MoltMatVec(rm, x1, x2)
         write(Inte,10) a1(1:2),x2(1:3),xyzs(5,i),bt,a2(1:2)
         write(lo,'(a)') Inte(1:80)
      enddo
   10 format('HETATM      ',a2,3x,'HET',10x,3f8.3,2f6.2,10x,a2)
!
*     return
!
      call PutModel
!
!-- Write PDB file for heavy atoms
!
      natsInModel(1) = HeavyInPDB
      do i=1, natsInModel(1)
         model(1)%numResiduo(i,1) = i
         kk = model(1)%specie(i,1) / nzConst
         a4 = Species(kk)
         call ucase(a4)
         model(1)%tipoAtomo(i,1)   = a4
         model(1)%tipoResiduo(i,1) = ' ' // a4(1:3)
         model(1)%HETA(i,1)        = 1
      enddo
      PDBfile = nome(1:lnome)  // '_heavy' // '.pdb'
      kk = Lung(PDBfile)
      itype = 0
      iform = 1
      jop = jopen(jhost,PDBfile(1:kk),itype,iform,ier)
      call outPDB(jhost, HeavyInPDB, 1, 0, 0)
      close(jhost)
!
      return
      end
!-----------------------------------------------------------------------
