!-----------------------------------------------------------------------
! file geom2010.f   date: 13 October 2010    
!-----------------------------------------------------------------------
      subroutine SirGeomNEW(ier)
!      
      USE General
      USE Direttive
!---
      character line*80,diret*80
!
      itype=1  
      iform=1
      jop=jopen(jhost,' ',itype,iform,ier)
      if (jop.lt.0) go to 9000
!
      ic=0
      icmax=icomq(icomat,2)
!
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 1000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call lcase(line)
      call shift(line,lch)
      write(jhost,'(a80)') line  
      go to 100
 1000 continue
      line = 'end'
      write(jhost,'(a80)') line
      rewind jhost
      jcod=0
      jscre=0
      call CaosGeomNEW(jscre,jhost,ier,jcod)  
      close(jhost)
!
      return
!
 9000 continue
      write(lo,9020) ier
      ier=-1
      return
 9020 format(' Open error #',i5,' on Geom scratch file ')
      end
!---------------------------------------------------------------------
!code for CaosGeomNEW
      subroutine CaosGeomNEW(jscre,jhost1,ier,jcod)
!-- ex  subroutine weox(idev)
!--read molecular geometry directives
!  jscre 0 read atoms from disc (xfl05)
!        1 read atoms from screen (to_Plot)
!  jcod  :
!   -1 prepara_calcoli (non legge direttive)
!   -2  read directives  (CAOS)
!    0  read directives  (SIR)
!    1  dist for cif file
!    2  ang for cif file
!--
      USE General
      USE Molcom
      USE Atomi
      USE Hydrostuff
      USE BuildModule
      USE Geometry
!
      common/xcardch/CardImageX,idch(6)
      character CardImageX*80,idch*1
      dimension vet(40),ivet(40)
!--
      character *80 nomeFile
      character dire*80,diret*80
      character *160 line
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common/workc/dx(4),icomc(196)
      common/xxhyd/lcon2
      dimension x1(3),x2(3),temp1(80)
      character*16 vetch, vetch1
      character*60 vetch2
      dimension hl(12)
      character*40 jname
      character*60 iarg
      data iarg/'instruction(s), ## to run, abort to quit, ? for help'/
      data jname/' '/
!--
      if(jcod.eq.0) then
          write(lo,1030)
 1030     format(1h ,78(1h-))
          write(lo,1031)
 1031     format(/, ' Geometry  calculations',/)
      endif
!-------------------------------------
!
      MaxAtomsBuild = MaxAtoms
      MaxAtomsH=MaxAtoms
      MaxBond3=MaxBonds*3
      call AllocaBuildStuff(1)
      call AllocaHydroStuff(1)
!
!--define variable parst96
      m1dp=32007779d0
      m2dp=23717810d0
      m3dp=52636370d0
      cpp=1d-3
      nn=200
      up=1d0/(cpp*dsqrt(1d0*nn))
!-------------------------------------
!--define variable caos
      numtable=0
      idev=1
      idv = idev
      ncru=jhost1
      idv=1
      ncol=0
      ndev=0
      nfix=0
      isave=0
      jcif=0
      ier=0
!--start loop main directives
1000  continue
      jFlagAtom(1:nats)=0
      nFlagAtom=0
      nats25=0
      nats26=0
      nSingleAtoms=0
      nGroupsGeo   = 0
      NumLineCurr=0
      NumPlaneCurr=0
      IndPlaneCurr(:)=0
      IndLineCurr(:)=0
      j1=0
      j2=0
      if(jcod.eq.-1) then
         ncru=ln
         return
      endif
      if(jcod.gt.0)then
!--write cif file by external call
         itype=1
         iform=2
         if(jopen(nctu,jname,itype,iform,ier).lt.0) goto 9100
         jcif=1
         isave=1
         ncol=1
         idv=1
         aa=0.0
         bb=0.0
         if(jcod.eq.1) then
!-------bond distances   
            call cdisNEW(aa,bb)
         else if(jcod.eq.2) then
!-------bond angles
            call cansNEW(aa,bb)
         endif
         icod=0
         write(nctu) icod
         call ptableNEW
         close(nctu)
         ncru=ln
         return
       end if
!
!--main loop for processing input instructions
!--fetch the next card
!--start loop for directives 'atom','line' & 'plane'
!      write(lo,*)' Directive(s) used:'
1100  continue
      if(jcod.eq.0) then
         read(jhost,'(a80)') line
!        write(lo,'(a,a80,a)') '$:',line,'$'
         call lcase(line)
      endif 
      if(line.eq.' ') goto 1000
      if(line(1:4).eq.'abor')return         
      if(line(1:3).eq.'end'.or.line(1:2).eq.'##') go to 9000
      if(line(1:1).eq.'?'.or.line(1:4).eq.'help') then
         call swmenu('geometry')
         return
      endif   
!--sir card to caos image
      call shift(line,ldiret)
      call cutst(line,lenp,dire,lend) 
!            
      image(:)=ib
      read(line,'(80a1)') (image(i),i=2,lenp+1)
      write(CardImageX,'(80a1)')image
      nc=1
!      
!--process the directives
!
!--'atom' directive
      if (dire(1:4).eq.'atom') then
          jFlagAtom(1:nats)=0
          if(lenp.le.0) then
             jFlagAtom(1:nats)=1
          else
             ix=0
             call FindAtomMnqd(ix,ier)
             if(ier.ne.0) goto 9100           !--error
          endif                   
          do ka=1,nats
             if(jFlagAtom(ka).ne.0)then
                nats25=nats25+1
                Adr25to5(nats25)=ka
                aLab25(nats25)=aLab(ka)
                xyzs25(1:3,nats25)=xyzs(1:3,ka)
                xyzs25_dev(1:3,nats25)=xyzs_dev(1:3,ka)
             endif
          enddo  
          go to 1100
      endif
!
!--'line' directive
      if (dire(1:4).eq.'line') then
          if(lenp.le.0) goto 9100         !--error
          if(NumLine.eq.0) goto 9100
          call cutst(line,lenp,dire,lend)
          do ka=1,NumLine 
             call shift(LabLine(ka),l)
             if(dire(1:lend).eq.LabLine(ka)(1:l)) then
                NumLineCurr=NumLineCurr+1
                if(NumLineCurr.gt.2) NumLineCurr=2
                IndLineCurr(NumLineCurr)=ka
                go to 1100
             endif
          enddo
          goto 9100
      endif
!
!--'plane' directive
      if (dire(1:4).eq.'plan') then
          if(lenp.le.0) goto 9100         !--error
          if(NumPlane.eq.0) goto 9100
          call cutst(line,lenp,dire,lend)
          do ka=1,NumPlane 
             call shift(LabPlane(ka),l)
             if(dire(1:lend).eq.LabPlane(ka)(1:l)) then
                NumPlaneCurr=NumPlaneCurr+1
                if(NumPlaneCurr.gt.2) NumPlaneCurr=2
                IndPlaneCurr(NumPlaneCurr)=ka
                go to 1100
             endif
          enddo
          goto 9100
      endif
!
!--plane's calculation directives 'p3p','pnr','pqm'---------------------OK
      if (dire(1:3).eq.'p3p'.or.
     2    dire(1:3).eq.'pnr'.or. 
     4    dire(1:3).eq.'pqm') then
          if(nats25.eq.0) goto 2060
          vetch1=dire(1:3)
          call cutst(line,lenp,dire,lend)
          vetch=dire(1:lend)
          vetch2=' '
          if(lenp.gt.0) vetch2=line(1:lenp)
!--'p3p' directive
          if (vetch1(1:3).eq.'p3p') then
              iprint=0
              call cp3pNEW(vetch,vetch2,iprint)
              go to 1000
          endif
!--'pnr' directive
          if (vetch1(1:3).eq.'pnr') then
            call cpnrNEW(vetch,vetch2)
            go to 1000
         endif
!--'pqm' directive
         if (vetch1(1:3).eq.'pqm') then
            iprint=0
            call cpqmNEW(vetch,vetch2,iprint)
            go to 1000
         endif
      endif
!
!--'prz' directive--------------------------OK
      if (dire(1:3).eq.'prz') then
         if(nats25.eq.0) goto 2060
         call cprzNEW
         goto 1000
      endif
!
!--'rqm' directive--------------------------OK
      if (dire(1:3).eq.'rqm') then
          if(nats25.eq.0) goto 2060
          call cutst(line,lenp,dire,lend)
          vetch=dire(1:lend)
          vetch2=' '
          if(lenp.gt.0) vetch2=line(1:lenp)
          call crqmNEW( vetch,vetch2)
         go to 1000
      endif
!
!--'tor' directive--------------------------OK
      if (dire(1:3).eq.'tor') then
         if(nats25.eq.0) goto 2060
         call ctorNEW
         go to 1000
      endif
!
!--'app' directive---------------------------OK
      if (dire(1:3).eq.'app') then
         if(NumPlane.eq.0) goto 2060
         call cappNEW
         go to 1000
      endif
!
!--'arp' directive---------------------------OK
      if (dire(1:3).eq.'arp') then
         if(NumPlane.eq.0) goto 2060
         if(NumLine.eq.0) goto 2060
         call carpxNEW
!         if (j1.eq.1.and.j2.eq.2) call carpx(l27,l27+md27)
!         if (j1.eq.2.and.j2.eq.1) call carpx(l27+md27,l27)
         go to 1000
      endif
!
!--'all' directive---------------------------OK
      if (dire(1:3).eq.'all') then
         if(NumLine.eq.0) goto 2060
         call callcxNEW
         go to 1000
      endif
!
!--'dpa' directive---------------------------OK
      if (dire(1:3).eq.'dpa') then
         if(nats25.eq.0.or.NumPlane.eq.0) goto 2060
         call cdpaNEW
         go to 1000
      endif
!
!--'dra' directive---------------------------OK
      if (dire(1:3).eq.'dra') then
         if(nats25.eq.0.or.NumLine.eq.0) goto 2060
         call cdraNEW
         go to 1000
      endif
!
!--'pm ' directive---------------------------OK
      if (dire(1:2).eq.'pm') then
         if(nats25.eq.0) goto 2060
         vetch=' '
         call cpmNEW(vetch,x1,x2)
         goto 1000
      endif
!
!--'ang' directive--------------------------OK
      if (dire(1:4).eq.'angl') then
         aa=0.2
         bb=1.7
         iopt=0
         call getnum(line,vet,ivet,iv,iopt)
         if (iopt.ne.-1) then
             if (iv.ge.1) aa=vet(1)
             if (iv.ge.2) bb=vet(2)
         endif
         call cansNEW(aa,bb)
         go to 1000
      endif
!
!---'dist' directive--------------------------OK
      if (dire(1:4).eq.'dist') then
         aa=0.2
         bb=1.7
         iopt=0
         call getnum(line,vet,ivet,iv,iopt)
         if (iopt.ne.-1) then
             if (iv.ge.1) aa=vet(1)
             if (iv.ge.2) bb=vet(2)
         endif
         call cdisNEW(aa,bb)
         go to 1000
      endif
!
!--'reset' directive--------------------------OK
      if (dire(1:4).eq.'rese') then
         call BlankGeometry
         goto 1000
      endif 
!
!--'show' directive--------------------------OK
      if (dire(1:4).eq.'show') then
         if(NumLine.gt.0) then
            do ind=1,NumLine
               call cwrlineNEW(ind)
            enddo
         endif
         if(NumPlane.gt.0) then
            jli5=1
            do ind=1,NumPlane
               call cwrplaneNEW(ind,jli5)
            enddo
         endif
         goto 1000
      endif 
!
!--'save' directive--------------------------OK
      if (dire(1:4).eq.'save') then
         if(isave.eq.0) then
           numtable=0
           itype=1
           iform=2
           if(jopen(nctu,jname,itype,iform,ier).lt.0) goto 9100
           isave=1
         endif
         go to 1000
      endif
!
!--'table' directive--------------------------OK
      if (dire(1:4).eq.'tabl') then
         if(isave.eq.0) goto 2060
         iopt=0
         call getnum(line,vet,ivet,iv,iopt)
         if (iopt.ne.-1) then
             if (iv.ge.1) ncol=ivet(1)
             if (iv.ge.2) ndev=ivet(2)
             if (iv.ge.3) nfix=ivet(3)
         endif
         icod=0
         write(nctu) icod
         call ptableNEW
         close(nctu)
         isave=0
         goto 1000
      endif
!
!--'cif  ' directive--------------------------OK
      if (dire(1:3).eq.'cif') then
         itype=1
         iform=2
         if(jopen(nctu,jname,itype,iform,ier).lt.0) goto 2060
!--open file for cif file
         k = index(fname(1),'.bin')
         nomeFile = fname(1)(1:k) // 'cif'
         itype=0
         iform=1
         if(jopen(ncpu, nomeFile,itype,iform,ier).lt.0) then 
            write(lo,8110) ier
8110        format(' geom error:',i5)
            ncru=ln
            return
         endif  
         jcif=1
         isave=1
         ncol=1
         idv=1
         goto 1000
      endif
!
!--'calc ' directive---------------------------OK
      if (dire(1:4).eq.'calc') then
         if(nats25.ne.2) goto 2060
         iopt=0
         call getnum(line,vet,ivet,iv,iopt)
         if (iopt.eq.-1) go to 2060
         if (iv.ne.1) go to 2060
         aa=vet(1)
         call atcalcNEW(aa)
         goto 1000
      endif
!
!--'short ', 'any ', 'long ' directives
      if (dire(1:5).eq.'short'.or.
     2    dire(1:3).eq.'any'.or. 
     3    dire(1:4).eq.'long') then
          dx(:)=0.0
          iopt=0
          call getnum(line,vet,ivet,iv,iopt)
          if (iopt.ne.-1) then
              do j=1,4
                 if (iv.ge.j) dx(j)=vet(j)
              enddo
          endif
          nOpEq(1:Nats)=1555      
          do j=1,nats
             iEqui(j)=j
          enddo
          ifrag=0
          jconn=iconn
          call longconnNEW(ifrag)
!  ja = -2  distanze senza limiti or angle senza limiti (jangle)
!	  -1  short distances
!	   0  distances and angles
!	   1  long distances
!  juno =  1  una sola lista (indirizzi identici)
!	   2  due liste
!  jangle = -1 solo angoli
!	     0 solo distanze
!	     1 distanze e angoli
          if (dire(1:5).eq.'short')ja=-1
          if (dire(1:3).eq.'any') ja=0
          if (dire(1:4).eq.'long') ja=1
          juno=1
          jangle=1
          if(ja.eq.1) jangle=0
!---------------------------------------------------      
!--riposiziono il no. specie      
!---------------------------------------------------      
          do i=1,nats
             nzo(i) = nz(i)
             nz(i)  = iabs(nz(i)) / nzConst
          enddo
!---------------------------------------------------      
!--jFlagAtom(:) indica atomi del primo loop
!--jFlagAtom1(:) indica atomi del secondo loop           
!---------------------------------------------------      
          jFlagAtom1(1:nats)=jFlagAtom(1:nats)
          iprGS=1
          call ziangNEW(ja,juno,jangle,iprGS)
!---------------------------------------------------      
!--riposiziona il vettore nz      
!---------------------------------------------------      
          do i=1,nats
             nz(i) = nzo(i)
          enddo
!---------------------------------------------------      
          go to 1000
      endif
!
!--'end' directive
      if (dire(1:3).ne.'end') goto 2060
9000  continue
      if(jcif.ne.0.or.isave.ne.0) then
         icod=0
         write(nctu) icod
         call ptableNEW
         close(nctu)
         isave=0
      else
         write(lo,1030)
      endif
      ncru=ln
      call AllocaBuildStuff(2)
      call AllocaHydroStuff(2)
      return
9100  continue
      write(lo,9110) ier
9110  format(' Warning! (CaosGeom) ier:',i5)
      goto 1100
2060  continue
      write(lo,2061)
2061  format(' Warning! (CaosGeom) Give correct information!')
      goto 1000
      return
      end
!-----------------------------------------------------------------------
!
!code for BlankGeometry
      subroutine BlankGeometry
!--azzera vettori per piani e linee
!
      USE Geometry
!
      NumLine=0
      NumPlane=0
      TitlePlane(:)=' '
      LabPlane(:)=' '
      CoefPlane(:,:)=0.0
      CoefPlane_dev(:,:)= 0.0
      TitleLine(:)=' '
      LabLine(:)=' '
      CoefLineXG(:,:)=0.0
      CoefLineXG_dev(:,:)=0.0
      CoefLineU(:,:)=0.0
      CoefLineU_dev(:,:)=0.0
      return
      end            
!-----------------------------------------------------------------------
!
!code for ptableNEW
      subroutine ptableNEW
!--print distances or angles for publication
!
      USE General
      USE Atomi
      USE Geometry
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih ,numb(10),iplus, inus,ipoint
!--
      dimension nord(3),kinea(16)
      character*16 ilab1,ilab2,ilab3,ilab4,tab(5,200)
      character*5 punt(2),yesno(3),ilab5,punto
      character*120 linea,lin1,lin2
      character*3 tratto,trat2,tratt(2)
!--
      rewind nctu
      sumdist=0.0
      numdist=0.0
      sumdev2=0.0
!-- setta format stampa
      tratt(1)=' - '
      tratt(2)='   '
      punt(1)='     '
      punt(2)='   . '
      yesno(1)='  yes'
      yesno(2)='   no'
      yesno(3)='     '
      tratto=tratt(jcif+1)
      punto=punt(jcif+1)
      if(ncol.le.0.or.ncol.gt.2) ncol=2
      if(jcif.eq.1)ncol=1
!--
      if(ndev.eq.0) ndev=1
      ndeci=3
      if(nfix.gt.0) then
        ndeci=nfix
        nfix=1
      end if
      lengx=0
      do i=1,nats
        ilab1=aLab(i)
        call shift(ilab1,lengb)
        lengx=max0(lengx,lengb)
      enddo
!      lengx=lengx+2
!-- calcola la massima lunghezza della stringa angle (jcif=0)
       ncolang=0
       lstring=3*lengx+6+12
       if(lstring.lt.40)ncolang=2
!--
      do k0=1,numtable
        jn=50     !no. righe per pag.      
        jblocco=jn*ncol     !no. di dati per pag.
        numdati=lunglist(k0)
        if(numdati.le.0)cycle
        if(numdati.le.jblocco)jblocco=numdati
        numpag=numdati/jblocco
        lastblocco=jblocco
        if(numpag*jblocco.lt.numdati)then
          lastblocco=numdati-jblocco*numpag
          numpag=numpag+1
        endif  
        read(nctu) icod
        ncol=1
        if(jcif.eq.0.and.icod.lt.0)ncol=2
        if(jcif.eq.0.and.icod.gt.0)ncol=ncolang
        trat2=tratto
        if(jcif.eq.0.and.icod.lt.0)trat2='   '
        nfin=3
        if(icod.lt.0)nfin=2
!-- setta valori per dev.stan. 
        je=0
        jf=8
        ndeci1=ndeci
        if(icod.gt.0) then
          ndeci1=1  
        else
          ndeci1=3
        endif
!
        do k1=1,numpag
          tab(:,:)=' '
!-- scrive titoli
          if(k1.eq.1)then
            if(icod.lt.0)then
              if(jcif.eq.1) then
                 write(ncpu,1350)
1350           format('  ',/,'  ',/,
     1         'loop_',/,
     1         '_geom_bond_atom_site_label_1',/,
     2         '_geom_bond_atom_site_label_2',/,
     3         '_geom_bond_distance',/,
     4         '_geom_bond_site_symmetry_1',/,
     5         '_geom_bond_site_symmetry_2',/,
     6         '_geom_bond_publ_flag',/)
              else
               write(lo,'(1h ,78(1h-))')
               write(lo,1166)
1166           format(/,' Table   . Bond lengths (A) with e.s.d.',1h',
     1         's in parentheses',/)
              end if
            else if(icod.gt.0)then
              if(jcif.eq.1) then
                write(ncpu,1351)
1351	          format('  ',/,'  ',/,
     1         'loop_',/,
     1         '_geom_angle_atom_site_label_1',/,
     2         '_geom_angle_atom_site_label_2',/,
     2         '_geom_angle_atom_site_label_3',/,
     3         '_geom_angle',/,
     4         '_geom_angle_site_symmetry_1',/,
     5         '_geom_angle_site_symmetry_2',/,
     4         '_geom_angle_site_symmetry_3',/,
     6         '_geom_angle_publ_flag',/)
              else
               write(lo,'(1h ,78(1h-))')
               write(lo,1175)
1175           format(/,' Table    . Bond angles   with e.s.d.',1h',
     1         's in parentheses',/)
              end if
            end if
          else     
            if(jcif.eq.0) write(lo,1168)
1168        format(/,10x,'continuing..........',/)
          endif
!        
          if(k1.eq.numpag)jblocco=lastblocco
            do k2=1,jblocco
              read(nctu)nord(1:3),a,b,c
!              write(lo,'(a,4i5,3f10.3)')'k2,nord(1:3),a,b,c '
!     1         ,k2,nord(1:3),a,b,c
!--sommo i valori
              sumdist=sumdist+a
              numdist=numdist+1
              sumdev2=sumdev2+b*b
              kdati=k2
              do i=1,nfin
                ii=nord(i)
                tab(i,k2)=aLab(ii)
              enddo
              call snum(a,b,ndeci,ndeci1,je,jf,kinea,ndev,nfix)
              write(ilab4,'(16a1)')kinea(1:16)
              call shift(ilab4,leng4)
              tab(4,k2)=ilab4
              il5=nint(c)
              ilab5=yesno(il5)
              if(jcif.eq.0)ilab5='   '
              tab(5,k2)=ilab5

!              write(lo,'(5a)')tab(1:5,k2)
            enddo
!-- stampa
            do k3=1,jblocco,ncol
              ilab1=' '
              ilab2=' '
              ilab3=' '
              ilab1=tab(1,k3)
              ilab2=tab(2,k3)
              ilab3=tab(3,k3)
              ilab4=tab(4,k3)
              ilab5=tab(5,k3)
              if(icod.lt.0) then
              lin1=ilab1(1:lengx)//tratto//ilab2(1:lengx)//
     1              '  '//ilab4(1:10)//punto//punto//ilab5
              else if(icod.gt.0) then
              lin1=ilab1(1:lengx)//tratto//ilab2(1:lengx)//trat2//
     1              ilab3(1:lengx)//'  '//ilab4(1:10)//punto//punto//
     3              punto//ilab5
              endif
              lin2=' '
              if(ncol.eq.2.and.k3+1.le.jblocco)then
                kk3=k3+1
                ilab1=' '
                ilab2=' '
                ilab3=' '
                ilab1=tab(1,kk3)
                if(ilab1.ne.' ')then
                  ilab2=tab(2,kk3)
                  ilab3=tab(3,kk3)
                  ilab4=tab(4,kk3)
                  ilab5=tab(5,kk3)
                  if(icod.lt.0) then
                    lin2=ilab1(1:lengx)//tratto//ilab2(1:lengx)//
     1              '  '//ilab4(1:10)//punto//punto//ilab5
                  else if(icod.gt.0) then
                  lin2=ilab1(1:lengx)//tratto//ilab2(1:lengx)//trat2//
     1                 ilab3(1:lengx)//'  '//ilab4(1:10)//punto//punto//
     2                 punto//ilab5
                  endif
                endif
              endif
              if(jcif.eq.1)then
              linea=lin1
              call shift(linea,len)
              write(ncpu,'(a)') linea(1:len)
              else if(jcif.eq.0)then
              linea=lin1(1:40)//'  '//lin2(1:40)
              call shift(linea,len)
              write(lo,'(a)') linea(1:len)
              endif
            enddo   
        enddo   
      read(nctu)nord(1:3)    !legge fine lista
      enddo   
      numtable=0
      return
      end
!
!code for cansNEW
      subroutine cansNEW(rmn,rmx)
!
      USE General
      USE Atomi
      USE Geometry
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
!
      dimension x1(3),x2(3),x3(3),s1(3),s2(3),s3(3)
     1 ,ggwc(9),grwc(9)
      dimension kinea(130)
      dimension listdist(1000,3)
      character*130 ikan,kkinea
      character*16 ilab1,ilab2,ilab3
      character*20 ilabn
!--
      zero0=0.00001
      if(isave.eq.1)numtable=numtable+1
      if(rmn.eq.0.0) rmn=0.3
      if(rmx.eq.0.0) rmx=1.7
      rad = 57.29578
      nfix=0
      ndev=1
      icod= 10
      numang=0
!--controllo se ci sono atomi flagatti
      nFlagAtom=0
      nx=0
      do i=1,nats
        if(jFlagAtom(i).eq.1)nFlagAtom=nFlagAtom+1
        ilab1=aLab(i)
        call shift(ilab1,lengb)
        nx=max0(nx,lengb)
      enddo
      kUsaConn=0
      if(nFlagAtom.eq.0)kUsaConn=1
      if(isave.eq.1)    then
          write(nctu) icod
      else if(isave.eq.0)then
          if(nFlagAtom.gt.0) write(lo,1030) rmn,rmx
          if(nFlagAtom.eq.0) write(lo,'(a)')' Angles from connectivity'
1030  format(/,' Angles around atoms in the limits',2f10.3)
      endif
!--controllo se ho la connettivita'
      if(kUsaConn.eq.1)then
         if(iconn(1).gt.0)then
           nco=iconn(1)
           nlong=3*nco+1
!--duplica la connettivita' in jconn
           if(MaxBonds*3.gt.3*nco*2)then
             if(kUsaConn.eq.1)then
               rmn=1000.
               rmx=0.
             endif
             j=1
             do i=2,nlong,3
               i1=iconn(i)
               i2=iconn(i+1)
               if(kUsaConn.eq.1)then
                 x1(1:3)=xyzs(1:3,i1) 
                 x2(1:3)=xyzs(1:3,i2) 
                 call vlen (xgg9,x1,x2,r)
                 if(r.lt.rmn)rmn=r 
                 if(r.ge.rmx)rmx=r 
                 if(jFlagAtom(i1).eq.0)nFlagAtom=nFlagAtom+1
                 if(jFlagAtom(i2).eq.0)nFlagAtom=nFlagAtom+1
                 jFlagAtom(i1)=10
                 jFlagAtom(i2)=10
               endif    
               jconn(j)=i1
               jconn(j+4)=i1
               jconn(j+1)=i2
               jconn(j+3)=i2
               jconn(j+2)=iconn(i+2)
               jconn(j+5)=iconn(i+2)
               j=j+6
             enddo
           endif
           nun=2*nco
           nun2=3*nun
           call sortya(jconn,1,nun,3,0)
!         write(lo,*)'jconn'
!         write(lo,'(5(3i3,2x))')jconn(1:6*nco+1)
         endif   
      endif   
      if(nFlagAtom.gt.0) then
         idlist=0
!--angles between the given atoms
         do k1=1,nats-1
            if(jFlagAtom(k1).eq.0)cycle
            x1(1:3)=xyzs(1:3,k1)
            i1=k1 
            idlist=0  
            do k2=1,nats
              if(jFlagAtom(k2).eq.0)cycle
              if(k1.eq.k2) cycle
              kk=1
              if(kUsaConn.eq.1)then
                 if(jFlagAtom(k1).eq.10.and.jFlagAtom(k2).eq.10)then
                    kk=0
                    do ii=1,nun2,3
                       if(jconn(ii).eq.k1)then
                          if(jconn(ii+1).ne.k2)cycle
                          kk=1
                          exit                    
                       endif
                    enddo
                 endif
              endif 
              if(kk.eq.0) cycle
              x2(1:3)=xyzs(1:3,k2) 
              call vlen (xgg9,x1,x2,r)
              if(r.ge.rmn.and.r.le.rmx) then
                 cova=-1.0
                 s1(1:3)=xyzs_dev(1:3,k1) 
                 s2(1:3)=xyzs_dev(1:3,k2) 
                 sum1=s1(1)+s1(2)+s1(3)
                 sum2=s2(1)+s2(2)+s2(3)
                 if(sum1.gt.zero0.and.sum2.gt.zero0)
     1           call vstd (xgg9,x1,x2,s1,s2,cova)
! 
                 if(idlist.le.998)then
                    idlist=idlist+1
                    listdist(idlist,1)=k2
                    listdist(idlist,2)=nint(r*1000)
                    listdist(idlist,3)=nint(cova*1000)
                 endif
              endif
            enddo
            id2=idlist+1
            idlist2=id2
            if(idlist.gt.1) then
              ilab1=aLab(i1)
              call shift(ilab1,leng1)
              if(leng1.lt.6)leng1=6
              if(isave.eq.0) then
                 kinea(:)=ib
                 je=4
                 call salf(je,idlist,kinea)
                 write(ilab3,'(16a1)')kinea(1:16)
                 call shift(ilab3,leng3)
                 ikan= 'Angles around '//ilab1(1:leng1)//' (there are '
     1             //ilab3(1:leng3)//' atoms in the limits)'
                 write(lo,'(a)')ikan
              endif
!----- calculate angle
              do j1=1,idlist
                i3=listdist(j1,1)
                r=float(listdist(j1,2))/1000.
                cova=float(listdist(j1,3))/1000.
                ilab3=aLab(i3)
                call shift(ilab3,leng3)
                if(leng3.lt.6)leng3=6
                x3(1:3)=xyzs(1:3,i3) 
                if(isave.eq.0)then
                   kinea(:)=ib
                   je=0
                   jf=10
                   jd=3
                   jd1=jd
                   call snum(r,cova,jd,jd1,je,jf,kinea,ndev,nfix)
                   write(ilab2,'(16a1)')kinea(1:16)
                   call shift(ilab2,leng2)
                   ilabn= ilab3(1:leng3)//' * '//ilab2(1:leng2)
                   leng=20
                   if(j1.eq.1)write(lo,'(a)')ilabn
                endif
                if(j1.eq.1)cycle
                do j2=1,j1-1
                   i2=listdist(j2,1)
                   ilab2=aLab(i2)
                   call shift(ilab2,leng2)
                   x2(1:3)=xyzs(1:3,i2) 
                   call anamp (xgg9,x1,x2,x3,teta)
                   an = teta*rad
                   std=0.0
                   if(idev.gt.0)then
                     s1(1:3)=xyzs_dev(1:3,i1) 
                     s2(1:3)=xyzs_dev(1:3,i2) 
                     s3(1:3)=xyzs_dev(1:3,i3) 
                     u1=s1(1)+s1(2)+s1(3)
                     u2=s2(1)+s2(2)+s2(3)
                     u3=s3(1)+s3(2)+s3(3)
                     yesno=1
                     if(u1.eq.0.or.u2.eq.0.or.u3.eq.0)yesno=2
                     if(u1.gt.zero0.and.u2.gt.zero0.and.u3.gt.zero0)then
                        call anstd (xgg9,x1,x3,x2,s1,s2,s3,teta,detet)
                        std = detet*rad
                     endif
                   endif
!
                   if(isave.gt.0)then
                         if(jcif.eq.0)yesno=3
                         write(nctu)i2,i1,i3,an,std,yesno
                         numang=numang+1
                   else
                         if(idlist2.le.999)then
                           listdist(idlist2,1)=nint(an*1000)
                           listdist(idlist2,2)=nint(std*1000)
                           idlist2=idlist2+1 
                         endif
                   endif
                enddo         
                idlist2=idlist2-1 
                if(isave.eq.0)then
                  ikan=' '
                  lengg=1
                  idlist=1
                  jf=7
                  do ik1=id2-1,idlist2,5
                       kinea(:) = ib
                       kfin=idlist2-id2+1
                       if(kfin.gt.5)kfin=5
                       do k=1,kfin
                         an= float(listdist(ik1+k,1))/1000
                         std=float(listdist(ik1+k,2))/1000
                         je=0
                         jd=1
                         jd1=jd
                         nfix=0
                         ndev=1
                         call snum(an,std,jd,jd1,je,jf,kinea,ndev,nfix)
                         jf=jf+10
                       enddo
                       write(ikan,'(130a1)')kinea(1:130)
                       call shift(ikan,lengg)
                       kkinea=ilabn(1:leng)//'  * '//ikan(1:lengg)
                       write(lo,'(a)')kkinea
!                       write(lo,'(a)')'-----'
!                       write(lo,42)
42                     format(1h0)
                  enddo
                endif
              enddo
            endif  
         enddo
      end if
      nfin=2*nats+numang
!      if(isave.eq.1) write(nctu) istar,istar,istar,icod,icod
      if(isave.eq.1)then
      lunglist(numtable)=numang
      write(nctu) nfin,nfin,nfin,icod,icod
      endif
      return
      end
!      
!code for cdisnew
      subroutine cdisnew (rmn,rmx)  
!
!
      USE General
      USE Atomi
      USE Geometry
!
!
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
!
      dimension x1(3),x2(3),s1(3),s2(3)
      dimension kinea(16)
      dimension listdist(1000,2)
      character*16 ilab1,ilab2,ilab3,ilab4
      character*40 ilabn(2)
      character*80 kkinea,linea
!--   
      if(isave.eq.1)numtable=numtable+1
      nx=0
      nndist=0
      if(rmn.eq.0.0) rmn=0.2
      if(rmx.eq.0.0) rmx=1.7
      ndev=1
      nfix=0
      kfat1=10000
      ifat1=500
      icod=-10
      if(isave.eq.1) then
         write(nctu) icod
      else
        if(nFlagAtom.gt.0) write(lo,1030) rmn,rmx
1030    format(/,' Distances in the limits',2f10.3,/)
      endif
!-- trova la lunghezza massima dei nomi      
      do i=1,nats
            ilab1=aLab(i)
            call shift(ilab1,lengb)
            nx=max0(nx,lengb)
      enddo
!-- setta il formato della distanza con dev.st.  (per call snum)
         je=0
         jf=10
         jd=3
         jd1=jd
      if(nFlagAtom.gt.0) then    !viene da atom
!--distances between the given atoms
         j1=0
         do i1=1,nats-1
              if(jFlagAtom(i1).eq.0)cycle
              ilab1=aLab(i1)
              call shift(ilab1,leng1)
              x1(1:3)=xyzs(1:3,i1) 
              do i2=i1+1,nats
                if(jFlagAtom(i2).eq.0)cycle 
                ilab2=aLab(i2)
                call shift(ilab2,leng2)
                x2(1:3)=xyzs(1:3,i2) 
                call vlen (xgg9,x1,x2,r)
                if(r.ge.rmn.and.r.le.rmx) then
                    nndist=nndist+1
                    cova=-1.0
                    s1(1:3)=xyzs_dev(1:3,i1) 
                    s2(1:3)=xyzs_dev(1:3,i2) 
                    sum1=s1(1)+s1(2)+s1(3)
                    sum2=s2(1)+s2(2)+s2(3)
                    yesno=1
                    if(sum1.eq.0.or.sum2.eq.0)yesno=2
                    if(sum1.gt.0.0.and.sum2.gt.0.0)
     1              call vstd (xgg9,x1,x2,s1,s2,cova)
                    if(isave.eq.0) then
                        j1=j1+1
                        ilab1=aLab(i1)
                        ilab2=aLab(i2)
                        kinea(:)=ib
                        call snum(r,cova,jd,jd1,je,jf,kinea,ndev,nfix)
                        write(ilab3,'(16a1)')kinea(1:16)
                        call shift(ilab3,leng3)
                        ilabn(j1)=ilab1(1:nx)//' - '//ilab2(1:nx)//' '
     1                            //ilab3(1:leng3)
                        linea=ilabn(1)//ilabn(2)
                        if(j1.eq.2)then
                          write(lo,'(a)')linea
                          linea=' '
                          ilab3=' '
                          ilabn(:)=' '
                          j1=0
                        endif
                    else if(isave.gt.0) then
                      if(jcif.eq.0)yesno=3
                      write(nctu)i1,i2,i2,r,cova,yesno
                    endif
                endif
              enddo
            enddo
            if(isave.eq.0)then
            if(j1.eq.1)write(lo,'(a)')linea
            if(nndist.eq.0) 
     1      write(lo,*)' Warning: no distance(s) in the limit!'
            endif
      else if(nFlagAtom.eq.0) then
!--distances from the connectivity table
         j1=0
         if(iconn(1).lt.1)return
         nco=3*iconn(1)+1
         do kl=2,nco,3
            nndist=nndist+1
            nor1=iconn(kl)
            nor2=iconn(kl+1)
            x1(1:3)=xyzs(1:3,nor1)
            x2(1:3)=xyzs(1:3,nor2)
            call vlen (xgg9,x1,x2,r)
            cova=0.0
            s1(1:3)=xyzs_dev(1:3,nor1)
            s2(1:3)=xyzs_dev(1:3,nor2)
            sum1=s1(1)+s1(2)+s1(3)
            sum2=s2(1)+s2(2)+s2(3)
            yesno=1
            if(sum1.eq.0.or.sum2.eq.0)yesno=2
            if(sum1.gt.0.0.and.sum2.gt.0.0)then
              call vstd (xgg9,x1,x2,s1,s2,cova)
            endif
            if(isave.eq.0) then
               j1=j1+1
               ilab1=aLab(nor1)
               ilab2=aLab(nor2)
               kinea(:)=ib
               call snum(r,cova,jd,jd1,je,jf,kinea,ndev,nfix)
               write(ilab3,'(16a1)')kinea(1:16)
               call shift(ilab3,leng3)
               ilabn(j1)=ilab1(1:nx)//' - '//ilab2(1:nx)//' '
     1         //ilab3(1:leng3)
               linea=ilabn(1)//ilabn(2)
                        if(j1.eq.2)then
                        write(lo,'(a)')linea
                        linea=' '
                        ilab3=' '
                        ilabn(:)=' '
                        j1=0
                        endif
            else if(isave.gt.0)then
              write(nctu)nor1,nor2,nor2,r,cova,yesno
            endif
         enddo
      if(isave.eq.0)write(lo,'(a)')linea
      end if
      if(isave.gt.0)then
        nn=2*nats+nndist
        write(nctu) nn,nn,nn,icod,icod
        lunglist(numtable)=nndist
      endif
      return
      end
!
!code for CreaIzpkNumfrNEW
      subroutine CreaIzpkNumfrNEW
      USE GENERAL, only: lo
      USE Atomi
      USE Molcom
      USE BuildStuff
      USE BuildModule
!
!--da jconn  crea  in izpk=nzpk la separazion in frag. 
!---izpk(n)=no(i)*nzconst+n.del frag. di n
!--da izpk  crea numfr(1:nfrag)=n. di atomi in ogni frag. 
!
      common /BuildAtomi/ storeatomi(20000)
!
!--izpk
!
      izpk(1:nats)=0
      do m=1,nats
         mm=iEqui(m)
         izpk(m)=nzConst*(nz(mm)/nzConst)
      enddo
!-- tutti gli atomi isolati,ogni atomo diventa un fragm. a se'      
      if(jconn(1).eq.0)then
         nfrag=nats
         do m=1,nats
            iss=isign(1,izpk(m))
            izpk (m)=iss*(iabs(izpk(m))+m)   
            numfr(m)=1
         enddo
         return
      endif
!
      ifrag0=1
      ifrag=ifrag0
      ini=2
      do i=1,nats
         m=jconn(ini)
         if(izpk(m).eq.0)then
            ini=ini+1
            cycle
         endif
            iss=isign(1,izpk(m))
            izpk (m)=iss*(iabs(izpk(m))+ifrag)
         exit
      enddo
!
      inn=1
      do while(inn==1)
      inn=0
      i0=0
!
      ncopie=jconn(1)
      ll=1+ncopie*3             
         do i=2,ll,3
         iflag=0
         j1=jconn(i)
         j2=jconn(i+1)
         ia=0
         if (j1 == 0 .or. j2 == 0) cycle
         if(izpk(j1).eq.0.or.izpk(j2).eq.0)cycle
         if(mod(izpk(j1),nzConst).eq.ifrag
     1                      .and.mod(izpk(j2),nzConst).eq.0)ia=1
         if(mod(izpk(j1),nzConst).eq.0
     1                      .and.mod(izpk(j2),nzConst).eq.ifrag)ia=2
         if(ia.gt.0)then
            inn=1
            if(ia.eq.2)izpk(j1)=izpk(j1)+ifrag
            if(ia.eq.1)izpk(j2)=izpk(j2)+ifrag
         endif
         enddo
      ifin=0
           do i=1,nats
           if(izpk(i).ne.0.and.mod(izpk(i),nzConst).eq.0) then
              ifin=i
              exit
           endif
           enddo
!      write(lo,*)'izpk ',izpk(1:nats)     
!      write(lo,*)'ifin,inn ',ifin,inn     
!
      if(inn.eq.0.and.ifin.gt.0)then
      ifrag0=ifrag0+1
      ifrag=ifrag0
!      izpk(ifin)=izpk(ifin)+ifrag0
            iss=isign(1,izpk(ifin))
            izpk (ifin)=iss*(iabs(izpk(ifin))+ifrag0)
      inn=1
      endif
      enddo
      nfrag=ifrag0
!--numfr
      numfr(:)=0
      do i=1,nats
      nn=mod(izpk(i),nzConst)
      if(nn.gt.0)numfr(nn)=numfr(nn)+1
      enddo
!      write(lo,*)'nfrag,numfr ',nfrag,numfr(1:nfrag)     
      return
      end
!
!code for cappNEW
      subroutine cappNEW
!--main routine per il calcolo angolo tra due piani
!
      USE General
      USE Geometry
      USE Dialogo, only : SmallIt
!
      common/workc/ggwc(9),grwc(9),xr1(8),xr2(8),icomc(166)
      character*40 string, linea
!--
      write (lo,10)
   10 format (/,' The angle between the two planes:')
      ind=IndPlaneCurr(1)
      jli5=1
      call cwrplaneNEW(ind,jli5)
      ind1=IndPlaneCurr(2)
      call cwrplaneNEW(ind1,jli5)
      xr1(1:4)=CoefPlane(1:4,ind)
      xr1(5:8)=CoefPlane_dev(1:4,ind)
      xr2(1:4)=CoefPlane(1:4,ind1)
      xr2(5:8)=CoefPlane_dev(1:4,ind1)
      call xappcNEW (xr1,xr2,xgr,ang,sa)
!      call appcold (xr1,xr2,xgr,ang,sa)
!      call appc (xr1,xr2,xgr,ang,sa)
      call xnumst(ang,sa,1,string,lstr)
      SmallIt(1) = ' '                        !mr
      SmallIt(1) = string(1:lstr)             !mr
      SmallIt(1)(lstr+1:lstr+1) = char(0)     !mr
      write(lo,21)string(1:lstr)
   21 format (' is...',a10,'degrees')
      write(Msg,30) string(1:lstr)
   30 format ('Angle between the two planes = ',a,' degrees')
      call PrintMess(Msg)
      return
      end
!code for xappcNEW
      subroutine xappcNEW(pr1,pr2,gr,ang,sa)
!--plane-plane angle
!
      USE General, only: lo
      USE Geometry
!
      dimension pr1(*),pr2(*),gr(*)
      dimension p1(3),p2(3),p1s(3),p2s(3)
      double precision xu(3),xou(3),cst,snt,s1,s2,th,st,sx,sxo
      dimension sx(3),sxo(3)
!
      rd = 57.29578
      ns1=0
      st=0d0
      do i=1,3
         xu(i)=pr1(i)
         xou(i)=pr2(i)
      enddo
2     continue
      call mv(gr,pr1,p1)
      call mv(gr,pr1(5),p1s)
      call mv(gr,pr2,p2)
      call mv(gr,pr2(5),p2s)
      call ospr(pr1,p1,b)
      call ospr(pr2,p2,c)
      call ospr(pr1,p2,a)
      b = sqrt(b)
      c = sqrt(c)
      csgam = a/(b*c)
      if (csgam.gt.1)   csgam =1.0
      if (csgam.lt.-1.) csgam =-1.
      gam = acos(csgam)
!--salvo valore iniziale
      if(ns1.eq.0)th=gam
      ns1=ns1+1
      s2=dabs(gam-th)
      if(s2.gt.1d-7)st=st+s2**2
      if((ns1-nn-1).eq.0)go to 9
      do i=1,3
         call urnNEW
         da = pr1(4+i) * cpp
         if(m3dp.ge.5d7)pr1(i)=xu(i)+da
         if(m3dp.lt.5d7)pr1(i)=xu(i)-da
         call urnNEW
         da = pr2(4+i) * cpp
         if(m3dp.ge.5d7)pr2(i)=xou(i)+da
         if(m3dp.lt.5d7)pr2(i)=xou(i)-da
      enddo
      go to 2
9     sa=0.0
      if(st.gt.1d-16)sa=(up*dsqrt(st))
      ang=th
      ang=ang*rd
      sa=sa*rd
!      write(lo,*) 'th,ang,sa',th,ang,sa
      do i=1,3
         pr1(i)=xu(i)
         pr2(i)=xou(i)
      enddo
      return
      end
!code for cp3pNEW
      subroutine cp3pNEW(vetch,vetch2,iprint)
!--
      USE General
      USE Atomi
      USE Geometry
!
      character*(*) vetch, vetch2
!
      common/workc/ggwc(9),grwc(9),x1(6),x2(6),x3(6),xr(6),icomc(158)
!--
      write(Msg,30)
   30 format ('Calculate the coefficients of the plane')
      call PrintMess(Msg)
      if(iprint.eq.0) then
         write(lo,21)
   21    format(/,' Calculation of the plane for three atoms',/,
     *            ' (the plane is in the form a*x+b*y+c*z=d)')
      endif
      x1(1:3)=xyzs25(1:3,1)
      x2(1:3)=xyzs25(1:3,2)
      x3(1:3)=xyzs25(1:3,3)
      call p3p (x1,x2,x3,xgg,xgr,xr)
      NumPlane=NumPlane+1
      LabPlane(NumPlane)= vetch     
      TitlePlane(NumPlane)= vetch2     
      CoefPlane(1:4,NumPlane)=xr(1:4)
      CoefPlane_dev(1:4,NumPlane)=0.0
      jli5=0
      call cwrplaneNEW(NumPlane,jli5)
      return
      end
!
!code for cpnrNEW
      subroutine cpnrNEW(vetch,vetch2)
!--Plane perpendicular a line and through an atom
!
      USE General
      USE Atomi
      USE Geometry
!
      character*(*) vetch,vetch2
!
      common/workc/ggwc(9),grwc(9),x1(6),x2(6),x3(6),xr(6),icomc(158)
c--
      write(Msg,30)
   30 format ('Calculate the coefficients of the plane')
      call PrintMess(Msg)
      write(lo,2)
    2 format (/,' Calculation of the plane normal to the line:',/,
     *            ' (the plane is in the form a*x+b*y+c*z=d)')
      ind=IndLineCurr(1)
      call cwrlineNEW(ind)
      write(lo,3)
    3 format(' ... and through the atom:')
      call xwrlgNEW(1,nats25)
      x1(1:3)=CoefLineU(1:3,ind)
      x2(1:3)=CoefLineXG(1:3,ind)
      x3(1:3)=xyzs25(1:3,1)
      call pnrc(x1,x2,x3,xgg,xr)
      NumPlane=NumPlane+1
      LabPlane(NumPlane)= vetch     
      TitlePlane(NumPlane)= vetch2     
      CoefPlane(1:4,NumPlane)=xr(1:4)
      CoefPlane_dev(1:4,NumPlane)=0.0
      jli5=1
      call cwrplaneNEW(NumPlane,jli5)
      return
      end
!
!code for urnNEW
      subroutine urnNEW
!-----this routine calculates 8-digit pseudo-random numbers
!-----following c.g.swain & m.s.swain, j.chem.inf.comput.sci.
!-----(1980),20, p. 56
      USE Geometry
!--
      m4dp=m1dp+m2dp+m3dp
      if(m2dp.lt.5d7)m4dp=m4dp+1357d0
      if(m4dp.ge.1d8)m4dp=m4dp-1d8
      if(m4dp.ge.1d8)m4dp=m4dp-1d8
      m1dp=m2dp
      m2dp=m3dp
      m3dp=m4dp
      return
      end
!
!code for cpqmNEW
      subroutine cpqmNEW(vetch,vetch2,iprint)
!--main routine per calcolo pqm
!
      USE General
      USE Atomi
      USE Geometry
!
      character*(*) vetch,vetch2
!      
      double precision 
     1 SDM(3),DR(3),DD,SDD,AM(3),SAM(3),ppm(3),
     3 D1,DF,DY,DEP
!
      common/workc/ggwc(9),grwc(9),x1(6),x2(6),x3(6),x4(6),x5(6),
     1     x6(6),eval(3),eve(3,3),ever(3,3),
     2     ainer(3,3),vv(3),vr(3),
     3     caa(3,3),xb(3),varxb(3,3),
     4     ggbis(3,3),grbis(3,3),varian(4),l28,m28,md28,n28,icomc(63)
      dimension xbb(3),varxbb(3,3)
!--
      write(Msg,30)
   30 format ('Calculation of the l.s. plane')
      call PrintMess(Msg)
      if(nats25.lt.3) then
         if(iprint.lt.0) return
         write(lo,70)
   70    format(/,5x,'***** please enter some more atom ',/)
         return
      endif
      if(nats25.eq.3) then
         call cp3pNEW(vetch, vetch2 ,iprint)
         return
      endif
      if(iprint.eq.0) then
         write(lo,10)
   10    format(/,' Calculation of the l.s. plane',/,
     *            ' (the plane is in the form a*x+b*y+c*z=d)')
      endif
!--salvo coordinate originali      
      do i=1,nats25
         xyzo(1:3,i) = xyzs25(1:3,i)
      enddo
!--inizializzo valori      
      ier=0
      ns1=0
      sdm(:)=0d0
      sdd=0d0
      NumPlane=NumPlane+1
1000  continue
      call xpqmMNQD(ier)
      if(ier.ne.0) then
         if(NS1.eq.0) then   ! 
            if(iprint.eq.0) then
               write(lo,11)
   11          format(' ERROR from the l.s. plane calculation')
            endif
            NumPlane=NumPlane-1
            nats25=3
            call cp3pNEW(vetch, vetch2 ,iprint)
            return
         else
            goto 47   ! vuol dire che il primo calcolo e' corretto
         endif
      endif   
      TitlePlane(NumPlane)= vetch2     
      LabPlane(NumPlane)= vetch     
      ind = 1
      vr(1) = ever(ind,1)
      vr(2) = ever(ind,2)
      vr(3) = ever(ind,3)
      call ospr(vr,xb,ddist)
      ppm(1:3)=ever(ind,1:3)
      d1=ddist
      IF(NS1.NE.0)GO TO 44
!--salvo i valori iniziali      
      do I=1,3
         AM(I)=PPM(I)
         xbb(i)=xb(i)
         do j=1,3
            varxbb(i,j)=varxb(i,j)
         enddo
      enddo
      DF=D1
44    NS1=NS1+1
      DO I=1,3
         DR(I)=DABS(PPM(I)-AM(I))
         IF(DR(I).GT.1D-7)SDM(I)=SDM(I)+DR(I)**2
      enddo
      DD=DABS(D1-DF)
      IF(DD.GT.1D-7)SDD=SDD+DD**2
!      write(lo,'(a,5x,4d12.4)')' dif:',sdm,sdd
      IF((NS1-NN-1).EQ.0)GO TO 47
      do i=1,nats25
         do j=1,3
            call urnNEW
            da = xyzs25_dev(j,i) * cpp
            if(m3dp.ge.5d7) xyzs25(j,i)=xyzo(j,i)+da
            if(m3dp.lt.5d7) xyzs25(j,i)=xyzo(j,i)-da
         enddo
      enddo
      GO TO 1000 
47    CONTINUE
      DO I=1,3
         SAM(I)=0.0
         IF(SDM(I).GT.1D-16)SAM(I)=UP*DSQRT(SDM(I))
      enddo
      SD=0.0
      IF(SDD.GT.1D-16)SD=UP*DSQRT(SDD)
      CoefPlane(1:3,NumPlane)=am(1:3)
      CoefPlane(4,NumPlane)=df
      CoefPlane_dev(1:3,NumPlane)=sam(1:3)
      CoefPlane_dev(4,NumPlane)=sd
!--ripristino  coordinate originali      
      do i=1,nats25
         xyzs25(1:3,i)=xyzo(1:3,i)
      enddo
      vr(1:3)=CoefPlane(1:3,NumPlane)
      do i=1,3
         do j=1,3
            varxb(i,j)=varxbb(i,j)
         enddo
      enddo
      jli5=0
      call cwrplaneNEW(NumPlane,jli5)
      if(iprint.eq.0) then
         write(lo,31)
   31    format(' Distance(s) from the l.s. plane with e.s.d.:',/)
      endif
      call xdpaNEW(NumPlane)
      write(lo,'(1h )')
      return
      end
!
!code for xpqmMNQD
      subroutine xpqmMNQD(ier)
!--main routine for l.s. plane calculation
!
      USE GENERAL
      USE Geometry
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workc/ggwc(9),grwc(9),x1(6),x2(6),x3(6),x4(6),x5(6),
     1     x6(6),eval(3),eve(3,3),ever(3,3),
     2     ainer(3,3),vv(3),vr(3),
     3     caa(3,3),xb(3),varxb(3,3),
     4	   ggbis(3,3),grbis(3,3),varian(4),l28,m28,md28,n28,icomc(63)
!
      ier=0
!---- set normal equations matrix for the best plane
      call xneqpgMNQD(ainer,xb,idev,varxb)
      if(istat2.gt.0.and.knw>0) then
         write(lo,1020) ((ainer(i,j),j=1,3),i=1,3)
 1020    format(15x,'normal equat. matrix',/,3(10x,3f15.5,/))
      endif
!--search for the eigenvalues and eigenvectors
      call eign3(xgg, xgr,ainer,eval,eve,ever,ier)
      if(ier.ne.0)return
      do i=1,3
         vv(1:3)=eve(i,1:3)
         call mv(xgg9,vv,vr)
         ever(i,1:3)=vr(1:3)
      enddo
      istat2=0
      if(istat2.gt.0) then 
         write(lo,1070) (i,eval(i),(eve(i,j),j=1,3)
     1    ,                (ever(i,j),j=1,3),i=1,3)
1070     format(/,'eigenvalue',5x,'real eigenvectors'
     3        ,5x,'dual eigenvectors',/,5x,i5,2x,7f9.4)
         cin32=eval(3)/eval(2)
         cin31=eval(3)/eval(1)
         cin21=eval(2)/eval(1)
         write(lo,1080) cin32,cin31,cin21
 1080    format (/,5x,'indici di confidenza ',/,5x,3(f8.2,2x),/)
      endif
      istat2=0
      return
      end
!
!code for xneqpgMNQD
      subroutine xneqpgMNQD(tmab,bard ,ivar,gamba)
!--      
      USE GENERAL
      USE Atomi
!      
      dimension tmab(3,3),barr(3),bard(3),xd(3),xr(3)
      dimension gamba(3,3)
!--
      bard(:) = 0.0
      barr(:) = 0.0
      tmab(:,:) = 0.0
      gamba(:,:) = 0.0
      do n= 1,nats25
         bard(1:3) = bard(1:3)+xyzs25(1:3,n)
      enddo
      bard(1:3)=bard(1:3)/nats25
      call mv (xgg9,bard,barr)
      if(ivar.gt.0) call xvarbMNQD(gamba)
      do n=1,nats25
         xyzs25(1:3,n)=xyzs25(1:3,n)-bard(1:3)
      enddo
      do n= 1,nats25
         xd(1:3)=xyzs25(1:3,n)
         call mv(xgg9,xd,xr)
!         call ospr(xr,xd,xx)
         do k=1,3
            do l=1,3
               tmab(k,l) =tmab(k,l)+xd(k)*xr(l)
            enddo
         enddo
      enddo
      return
      end
!
!code for xvarbMNQD
      subroutine xvarbMNQD(var)
!--
      USE Atomi
      dimension var(3,3)
!--
      var(:,:) = 0.0
      do n=1,nats25
         var(1,1) = var(1,1)+xyzs25_dev(1,n)*xyzs25_dev(1,n)
         var(2,2) = var(2,2)+xyzs25_dev(2,n)*xyzs25_dev(2,n)
         var(3,3) = var(3,3)+xyzs25_dev(3,n)*xyzs25_dev(3,n)
      enddo
      var(1,1) = var(1,1)/nats25
      var(2,2) = var(2,2)/nats25
      var(3,3) = var(3,3)/nats25
      return
      end
!
!code for cdpaNEW
      subroutine cdpaNEW
!--main routine per il calcolo delle distanze da un piano
!
      USE General
      USE Atomi
      USE Geometry
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!--
      write(Msg,30)
   30 format ('Calculate distance(s) of the atom(s) from the plane')
      call PrintMess(Msg)
!
      ind=IndPlaneCurr(1)
      write(lo,10)
   10 format (/,' Distance(s) of the atom(s):')
      call xwrlgNEW(1,nats25)
      write(lo,20)
   20 format(' ... from the plane:')
      jli5=1
      call cwrplaneNEW(ind,jli5)
      write(lo,31)
   31 format(' ... are the following:',/)
      call xdpaNEW(ind)
      write(lo,'(1h )')
      return
      end
!
!code for xdpaNEW
      subroutine xdpaNEW(ind)
!--calcolo delle distanze da un piano
!
      USE GENERAL
      USE Atomi
      USE Geometry
!
      character*80 linea
!
      common/workc/ggwc(9),grwc(9),x1(6),x2(6),x3(6),x4(6),
     *             icomc(158) 
      dimension caa(3,3),gamba(3,3)
      character*40 string,string1
!--
      if(idev.gt.0) then
         call xvarbMNQD(gamba)
      endif
      linea=' '
      lin=1
      ili=0
      varba=0.0
      sumdis=0.0
      dsumdis=0.0
      do i=1,nats25
         x1(1:4)=CoefPlane(1:4,ind)
         x2(1:3)=xyzs25(1:3,i)
         call mv(xgr9,x1,x3)
         call norm(x3,x1)
         call ospr(x2,x1,da)
         dfp = da-x1(4)
         sumdis=sumdis+abs(dfp)
         stdfp=0.0
         if(idev.gt.0) then
            caa(:,:) = 0.0
            call vardi(xgr9,gamba,x1,varba)
!---- calculate the variances acros the best plane
            do j=1,3
               caa(j,j) = xyzs25_dev(j,i)*xyzs25_dev(j,i)
            enddo    
            call vardi(xgr9,caa,x1,var)
            stdfp = varba+var
            if(stdfp.lt.0.and.stdfp.gt.-.10)stdfp=0.
            dsumdis=dsumdis+stdfp
            stdfp = sqrt(stdfp)
         endif
         call xnumst(dfp,stdfp,3,string,lstr)
!         
         call AllineaNumb(blank,string,lstr,5)
!         
          write(string1,'(2a)')aLab25(i)(1:8),string(1:lstr)
!
!         if(dfp.ge.0.0) write(string1,'(a,1x,a)')aLab25(i)(1:8),
!     *                   string(1:lstr)
!         if(dfp.lt.0.0) write(string1,'(a,a)')aLab25(i)(1:8),
!     *                   string(1:lstr)
         call shift(string1,lstr1)
         linea=linea(1:lin)//string1(1:25)
         lin=lin+25
         ili=ili+1
         ii=mod(i,3)
         if(ii.eq.0)ii=3
         if(ii.eq.3)then
            write(lo,'(a)')linea(1:lin)
            linea=' '
            ili=0
            lin=1
         endif
      enddo
      if(ili.gt.0)write(lo,'(a)')linea(1:lin)
      return
      end
!
!code for xwrlgNEW
      subroutine xwrlgNEW(nfirst,nlast)
!--stampa atomi (ex lista 25)
!      
      USE GENERAL, only: lo
      USE Atomi
!
      character*80 linea
!--
      call shift(aLab25(nfirst),l)
      linea=aLab25(nfirst)(1:l)
      if(nats25.gt.1) then
         do i=nfirst+1,nlast
            call shift(aLab25(i),l)
            call shift(linea,lin)
            if(lin.gt.60) then
               write(lo,'(1x,a)')linea(1:lin)
               linea=aLab25(i)(1:l)
               cycle
            endif   
            linea=linea(1:lin)//'-'//aLab25(i)(1:l)
         enddo      
      endif
      call shift(linea,lin)
      write(lo,'(1x,a)')linea(1:lin)
      return
      end
!
!code for cwrplaneNEW
      subroutine cwrplaneNEW(ind,jli5)
!--stampo coefficienti del piano 
!  ind  no. ord. piano
!  jli5 = 0 inserisco nomi atomi
!         1 solo coeff. piano
!     
      USE GENERAL, only: lo
      USE Atomi
      USE Geometry
!      
      character*80 linea
!--
      write(lo,'(1h )')
      linea=' '
      call shift(TitlePlane(ind),l)
      write(lo,'(1x,a)')TitlePlane(ind)(1:l)
!--insert the name of the plane
      call shift(LabPlane(ind),l)
!--check s.d.
      do i=1,4
         if( CoefPlane_dev(i,ind) > 9999.) CoefPlane_dev(i,ind)=9999.0
      enddo 
      if(jli5.eq.0) then
         linea=LabPlane(ind)(1:l)
!--insert the label of the atoms         
         lung=6
         call shift(aLab25(1),l)
         linea(lung+1:lung+l+1)=aLab25(1)(1:l)
         call shift(linea,lin)
         linea=linea(1:lin)//'-'
         lin=lin+1
         numli=0
         ippp=0
         do i=2,nats25
            call shift(aLab25(i),l)
            linea=linea(1:lin)//aLab25(i)(1:l)
            lin=lin+l
            if(i.eq.nats25)then
               ippp=1
            else
               call shift(aLab25(i+1),l)
               if(lin+l+1.gt.34) ippp=2
            endif
            if(ippp.ne.0) then
               numli=numli+1
               if(numli.eq.1)then
                  write(lo,'(1x,a,4f10.5)')linea(1:34),
     *                                  CoefPlane(1:4,ind)
               else if(numli.eq.2)then
                  write(lo,'(1x,a,4f10.5)')linea(1:34),
     *                                  CoefPlane_dev(1:4,ind)
               else if(numli.gt.2)then
                  write(lo,'(1x,a,4f10.5)')linea(1:34)
               endif
               linea=' '
               lin=lung
               if(ippp.eq.1) exit
               ippp=0
            endif
            linea=linea(1:lin)//'-'
            lin=lin+1
         enddo      
         if(numli.eq.1) write(lo,'(35x,4f10.5)')CoefPlane_dev(1:4,ind)
      else
         write(lo,80) LabPlane(ind)(1:l),CoefPlane(1:4,ind)
  80     format(5x,a4,5x,4f10.5)   
         write(lo,81) CoefPlane_dev(1:4,ind)
  81     format(14x,4f10.5) 
      endif  
      write(lo,'(1h )')
      return
      end
!
!code for cwrlineNEW
      subroutine cwrlineNEW(ind)
!--stampo coefficienti della linea
!     
      USE GENERAL, only: lo
      USE Geometry
!--
      call shift(TitleLine(ind),l)
      write(lo,'(/,1x,a)')TitleLine(ind)(1:l)
!--print the coeff. of a line
      call shift(LabLine(ind),l)
      write(lo,80) LabLine(ind)(1:l),CoefLineXG(1:3,ind),
     2                CoefLineXG_dev(1:3,ind),
     3                CoefLineU(1:3,ind),CoefLineU_dev(1:3,ind)
   80 format (5x,a4,' xg(i) = ',3f10.5,/,
     2          18x,3f10.5,/,
     3           5x,4x,' u(i)  = ',3f10.5,/,
     4          18x,3f10.5)
      return
      end
!
!code for crqmNEW
      subroutine crqmNEW(vetch,vetch2)
!--calcola retta quadratica media
!
      USE General
      USE Atomi
      USE Geometry
!
      character*(*) vetch,vetch2
      character*80 linea
!      
      double precision 
     1 SDM(3),DR(3),DD,SDD,AM(3),SAM(3),ppm(3),
     3 D1,DF,DY,DEP
!
      common/workc/ggwc(9),grwc(9),x1(6),x2(6),x3(6),x4(6),
     1 x5(6),x6(6),icomc(146)
      dimension eval(3),eve(3,3),ever(3,3)
      dimension ainer(3,3),vv(3),vr(3),ua(3),ur(3),va(3)
      dimension xb(3),varxb(3,3)
      dimension ggloc(3,3),grloc(3,3)
      dimension xbb(3),varxbb(3,3)
      dimension gort(9)
      character*40 string,string1
!--
      write(Msg,30)
   30 format ('Calculation  of the l.s. line')
      call PrintMess(Msg)
      istat2=0
      write(lo,10)
   10 format (/,' The least squares line through the atom(s):')
      call xwrlgNEW(1,nats25)
!--salvo coordinate originali      
      do i=1,nats25
         xyzo(1:3,i) = xyzs25(1:3,i)
      enddo
!--inizializzo valori      
      ierr=0
      ns1=0
      do i=1,3
       sdm(i)=0d0
      enddo
      sdd=0d0
      NumLine=NumLine+1
      TitleLine(NumLine)= vetch2 
      LabLine(NumLine)= vetch     
!--calcolo l'equazione della retta
1000	continue
      if(nats25.eq.2) then
         xb(1:3)=xyzs25(1:3,1)
         x2(1:3)=xyzs25(1:3,2)
         call vcmp(xb,x2,ua)
         call mv(xgg,ua,ur)
         call ospr(ua,ur,b)
         b=sqrt(b)
         do i=1,3
            vv(i)=ua(i)/b
            eve(3,i)=vv(i)
            ppm(i)=eve(3,i)
         enddo
      else
!---- set normal equations matrix for the best plane
         call xneqpgMNQD(ainer,xb,idev,varxb)
         if(istat2.gt.0.and.NS1.eq.0) then
            write(lo,*)' xb',xb
            write(lo,1020) ((ainer(i,j),j=1,3),i=1,3)
 1020	      format(10x,5x,'normal equat. matrix',/,3(10x,3f10.5,/))
         endif
!---- sherch for the eigenvalues and eigenvectors
         call eignv3g(xgg,xgr,ainer,eval,eve,ever)
         do i=1,3
            vv(1:3)=eve(i,1:3)
            call mv(xgg9,vv,vr)
            ever(i,1:3)=vr(1:3)
         enddo
         if(istat2.gt.0.and.NS1.eq.0)then
            write(lo,1070) (i,eval(i),(eve(i,j),j=1,3)
     1,                (ever(i,j),j=1,3),i=1,3)
 1070	      format (/,5x,'eigenvalue',5x,'real eigenvectors'
     3             ,5x,'dual eigenvectors',/,5x,i5,2x,7f9.4)
            cin32=eval(3)/eval(2)
            cin31=eval(3)/eval(1)
            cin21=eval(2)/eval(1)
            write(lo,1080) cin32,cin31,cin21
 1080	      format (/,5x,'indici di confidenza',/,5x,3(f8.2,2x),/)
         endif
         ind = 3
         ppm(1:3)=eve(ind,1:3)
      endif
!	write(lo,'(a,i4,1x,4d12.4)')' ppm:',ns1,ppm
      IF(NS1.NE.0)GO TO 44
      DO I=1,3
         AM(I)=PPM(I)
         xbb(i)=xb(i)
         do j=1,3
            varxbb(i,j)=varxb(i,j)
         enddo
      enddo
44	NS1=NS1+1
      DO  I=1,3
          DR(I)=DABS(PPM(I)-AM(I))
          IF(DR(I).GT.1D-7)SDM(I)=SDM(I)+DR(I)**2
      enddo
      IF((NS1-NN-1).EQ.0)GO TO 47
      do i=1,nats25
         do j=1,3
            call urnNEW
            da = xyzs25_dev(j,i) * cpp
            if(m3dp.ge.5d7) xyzs25(j,i)=xyzo(j,i)+da
            if(m3dp.lt.5d7) xyzs25(j,i)=xyzo(j,i)-da
         enddo
      enddo
      GO TO 1000
47    CONTINUE
      DO I=1,3
         SAM(I)=0.0
         IF(SDM(I).GT.1D-16)SAM(I)=UP*DSQRT(SDM(I))
      enddo
      CoefLineU(1:3,NumLine)=am(1:3)
      CoefLineU_dev(1:3,NumLine)=sam(1:3)
!--ripristino  coordinate originali      
      do i=1,nats25
         xyzs25(1:3,i)=xyzo(1:3,i)
      enddo
!--calcolo l'errore sulle coordinate del baricentro
      if(nats25.eq.2) then
         sdm(1:3)=xyzs25_dev(1:3,1) 
      else
         sdm(1:3)=0.0
         do i=1,nats25
            sdm(1:3)=sdm(1:3)+xyzs25_dev(1:3,i)**2 
         enddo
         do i=1,3
            sdm(i)=dsqrt(sdm(i))/nats25
         enddo
      endif
      CoefLineXG(1:3,NumLine)=xbb(1:3)
      CoefLineXG_dev(1:3,NumLine)=sdm(1:3)
!--
      vv(1:3)=CoefLineU(1:3,NumLine)
      call mv(xgg,vv,vr)
      do i=1,3
         do j=1,3
            varxb(i,j)=varxbb(i,j)
         enddo
      enddo
      write(lo,20)
   20 format('...is (in the form x(i)=xg(i)+u(i)*tau ):')
      call cwrlineNEW(NumLine)
!------------------------------------------------------------      
      if(nats25.gt.2) then
         write(lo,85)
   85    format(' Distance(s) from the line')
         call xdraNEW(NumLine)
      endif
      write(lo,'(1h )')
      return
      end
!
!code for cprzNEW
      subroutine cprzNEW
!--projection of the atoms on the lpt device
!
      USE GENERAL, only: lo
      USE Atomi
      USE Geometry
!
      common/workc/ggwc(9),grwc(9),x1(6),x2(6),x3(6),x4(6),x5(6),x6(6),
     1     eval(3),eve(3,3),ever(3,3),
     2     ainer(3,3),vv(3),vr(3),
     3     caa(3,3),xb(3),varxb(3,3),
     4     ggbis(3,3),grbis(3,3),varian(4),l28,m28,md28,n28,icomc(63)
      dimension  xmax(3), xmin(3),deltax(3)
      character*120 ifmtx
      character*2 inux
      character*4 vetch
!--
      istat2=0
      if(nats25.le.3) then
         write(lo,70)
   70    format(/,5x,'***** please enter some more atom ',/)
         return
      endif
      write(lo,10)
   10 format(/,' Plot projection on the l.s. plane:')
      call xwrlgNEW(1,nats25)
      call xpqmMNQD(ier)
      istat2=0
      xmax(1:3)=-100000.
      xmin(1:3)= 100000.
      do  k=1,nats25
         x2(1:3)=xyzs25(1:3,k)
         do i=1,3
            x3(i)=0.0
            do j=1,3
               x3(i)=x3(i)+x2(j)*ever(i,j)
            enddo
            xmax(i)=amax1(xmax(i),x3(i))
            xmin(i)=amin1(xmin(i),x3(i))
         enddo
         if(istat2.ne.0) then
            call shift(aLab25(k),l)
            write(lo,20) aLab25(k)(1:l),(x3(i),i=1,3)
   20       format (1x,a8,3f10.4)
         endif
         xyzs25(1:3,k)= x3(1:3)
      enddo
!--number of lines per inch on lineprinter
      deltax(1:3)=xmax(1:3)-xmin(1:3)
      if(istat2.ne.0) write(lo,'(10x,3f10.5)') deltax
      aln=6
      n1 = 3
      n2 = 2
      if (70.0/deltax(2).lt. 2.0/0.254) then
          n1 = 2
          n2 = 3
      endif
!--calculate scale factor to fill page or give 2.5 cms/a
      amax = amax1(deltax(n2), deltax(n1))
      scale = amin1(70.0/amax, 2.5/0.254)
      if(istat2.ne.0) write(lo,'(10x,a,2f10.5)')
     * 'amax,scale=',amax,scale
      scl = 0.254 * scale
!--sort peaks in order of plotting
      do  k=1,nats25
          jFlagAtom1(k)=k
          work25(k)=xyzs25(n1,k)
      enddo    
      call SortInd(nats25,jFlagAtom1,work25)
!--output heading and plot peaks
      write(lo,1260)scl
 1260 format(' Scale :',f6.2,' cms/a',
     1//,1x,79(1h*))
      do j=1,3
       write(lo,1380)
 1380  format(2h *,77x,1h*)
      enddo
      ix=0
      offset = 0.5 * (70.0 - deltax(n2) * scale) + 1.5
      if(istat2.ne.0) write(lo,'(10x,a,f10.5)') 'offset=',offset
      do k=1,nats25
         i=jFlagAtom1(nats25+1-k)    ! ordine inverso
         x2(1:3)=xyzs25(1:3,i)
         ixrel = 0.1 * aln * scale * (xmax(n1)-x2(n1)) - float(ix) + 0.5
         if(istat2.ne.0) write(lo,'(10x,a,i10)') 'ixrel=',ixrel
         if(ixrel.gt.0) then
            do j=1,ixrel
               write(lo,1380)
            enddo
         endif
         ix=ix+ixrel
         iy=scale*(x2(n2)-xmin(n2))+offset
         ichp=10
         write(inux,'(i2)')iy
         ifmtx = '(1h ,1h*,'//inux
         call shift(ifmtx,l)
         ifmtx=ifmtx(1:l)//'x,a,'
         call shift(aLab25(i),le)
         irest=77-iy-le
         write(inux,'(i2)')irest
         call shift(ifmtx,l)
         ifmtx=ifmtx(1:l)//inux//'x,1h*)'
         write(lo,ifmtx)aLab25(i)(1:le)
      enddo
      do j=1,2
         write(lo,1380)
      enddo
      write(lo,1386)
 1386 format(1x,79(1h*),/)
      istat2=0
      return
      end
!-----------------------------------------------------------------------
      subroutine SortInd(numb,ind,work)
!--sort in ordine crescente
!  numb dimensione dei vettori 
!  ind  vettore contenebte numero d'ordine
!  work contiene la grandezza da sortizzare
!
      USE GENERAL, only: lo
!
      dimension ind(*),work(*)
!      
      if (numb.le.1) then
          return
      endif
      ja = 2
      kVai = 1
      do while (kVai.eq.1)
         jb = numb / ja
         if (jb.le.0) then 
             jb = 1
         endif
         jc = numb - jb
 2040    continue
         jd = 0
!         m  = lind
         do m=1,jc
            mk = m + jb 
            if ((work(m)-work(mk)).gt.0) then
                   f        = work(m)
                   work(m)  = work(mk)
                   work(mk) = f
                   i        = ind(m)
                   ind(m)   = ind(mk)
                   ind(mk)  = i
                jd = 1
            endif
         enddo
         if (jd.gt.0) then
             go to 2040
         endif
         if (jb.gt.1) then
             ja = ja * 2
         else
             kVai = 0
         endif
      enddo
!
      return
      end
!
!code for ctorNEW
      subroutine ctorNEW
!--main routine per il calcolo di angoli di torsione
!
      USE General
      USE Atomi
      USE Geometry
      USE Dialogo, only : SmallIt
!
      common/workc/ggwc(9),grwc(9),x1(6),x2(6),x3(6),x4(6),icomc(158)
      character*40 string
!
      ntorang=nats25-3
      if(ntorang.lt.1)then
         write(Msg,11)
   11    format('Error! Increase the number of atoms!')		 
         call PrintMess(Msg)
         write(lo,'(a35)') Msg
         return
      endif
      write(Msg,30)
   30 format ('Calculate torsion angle(s) along the chain of atoms')
      call PrintMess(Msg)
      write (lo,10)
   10 format(/,' Torsion angle(s) along the chain of atoms:')
      call xwrlgNEW(1,nats25)
      write(lo,20)
   20 format(' ... are the following:')
      nfirst=1
      do i=1,ntorang
      nlast=nfirst+3
      call xwrlgNEW(nfirst,nlast)
      x1(1:3)=xyzs25(1:3,nfirst)
      x1(4:6)=xyzs25_dev(1:3,nfirst)
      x2(1:3)=xyzs25(1:3,nfirst+1)
      x2(4:6)=xyzs25_dev(1:3,nfirst+1)
      x3(1:3)=xyzs25(1:3,nfirst+2)
      x3(4:6)=xyzs25_dev(1:3,nfirst+2)
      x4(1:3)=xyzs25(1:3,nfirst+3)
      x4(4:6)=xyzs25_dev(1:3,nfirst+3)
!--il calcolo della s.d. e` fatto se sdtau > 0.0
      sdtau = 1.0
      if(idev.eq.0) sdtau=0.0
      call torcsNEW (x1,x2,x3,x4,xgg,xgr,tau,sdtau)
!      write(lo,31) tau,sdtau
!   31 format(' Angle (degree)=',f7.2,'(',f7.2,')')
      call xnumst(tau,sdtau,2,string,lstr)
      SmallIt(1) = ' '                        !mr
      SmallIt(1) = string(1:lstr)             !mr
      SmallIt(1)(lstr+1:lstr+1) = char(0)     !mr
      write(lo,32) string(1:lstr)
   32 format(' Angle (degree)= ',a)
      nfirst=nfirst+1
      enddo
      return
      end
!
!code for torcsNEW
      subroutine torcsNEW(x1,x2,x3,x4,g,gr,tau,sdtau)
!---- torsion angle calculation
!---- and standard deviation
!----
      USE GENERAL, only: lo
      dimension x1(6),x2(6),x3(6),x4(6)
      dimension g(*),gr(*)
      dimension a(3),b(3),c(3),d(3),f(3),hr(3)
      dimension dr(3),fr(3)
      dimension u(3),v(3),p1(3),p2(3),pr1(3),pr2(3)
      dimension c11(9),c22(9),c33(9),c44(9)
      dimension gamqa(9),gamqb(9),gamqq(9)
      dimension  ut1(9), ut2(9), ut3(9)
!--
      rad = 57.29578
      call vcmp (x3,x4,a)
      call vcmp (x2,x3,b)
      call vcmp (x1,x2,c)
!      write(lo,'(a)') 'x1,x2,x3,x4,a,b,c'
!      write(lo,'(3f10.4)') (x1(i),i=1,3),(x2(i),i=1,3),
!     2   	 (x3(i),i=1,3),(x4(i),i=1,3),(a(i),i=1,3),(b(i),i=1,3),
!     3     (c(i),i=1,3)
      call vpr (g,a,b,dr)
      call vpr (g,b,c,fr)
      call mv (gr,fr,f)
      call mv (gr,dr,d)
!      write(lo,'(a)') 'dr,fr,f,d'
!      write(lo,'(3f10.4)') (dr(i),i=1,3),(fr(i),i=1,3),
!     2   	 (f(i),i=1,3),(d(i),i=1,3) 
      call ospr (d,fr,aa)
      call ospr (d,dr,qa)
      call ospr (f,fr,qb)
!      write(lo,'(a)') 'aa,qa,qb'
!      write(lo,'( 3f15.5)') aa,qa,qb
      if (qa.lt.0.000.and.qa.gt.-0.001) qa = 0.0000
      if (qb.lt.0.000.and.qb.gt.-0.001) qb = 0.0000
      qa = sqrt(qa)
      qb = sqrt(qb)
!      write(lo,'( 3f15.5)') aa,qa,qb
      if(qa.eq.0.0.or.qb.eq.0.0) then
       sdtau = 0.0
       cstau = 0.0
      else
       cstau = aa/(qa*qb)
      endif
      call vpr (g,c,a,hr)
      call ospr (hr,b,s)
!      write(lo,'(a)') 'cstau,s'
!      write(lo,'( 3f15.5)') cstau,s 
      if (cstau.gt.1)	cstau =1.0
      if (cstau.lt.-1.) cstau =-1.
      tau = acos (cstau)
!---- controlla che -s- non sia zero
       if(s) 100,200,100
  200 continue
      s = 1.0
  100 continue
      tau = sign(tau,s)
      tau = tau*rad
      if(sdtau) 1000,1000,300
  300 continue
      do 310 i=1,9
      c11(i) = 0.0
      c22(i) = 0.0
      c33(i) = 0.0
      c44(i) = 0.0
      gamqa(i) = 0.0
      gamqb(i) = 0.0
      gamqq(i) = 0.0
      ut1(i) = 0.0
      ut2(i) = 0.0
      ut3(i) = 0.0
  310 continue
!---  variance-covariance matrix  in contrav. repres.
      do 320 i=1,3
      j = (i-1)*3+i
      ii = i+3
      c11(j) = x1(ii)*x1(ii)
      c22(j) = x2(ii)*x2(ii)
      c33(j) = x3(ii)*x3(ii)
      c44(j) = x4(ii)*x4(ii)
  320 continue
      do 330 i=1,3
      u(i) = -a(i)-b(i)
      v(i) = -b(i)-c(i)
  330 continue
!---  calculation of gamma(qa) dyadic
      call vudy(g,b,ut1)
      call mmm( ut1,c44, ut1, ut2)
      do 401 i=1,9
      gamqa(i) = - ut2(i)+gamqa(i)
  401 continue
      call vudy(g,u,ut1)
      call mmm( ut1,c33, ut1, ut2)
      do 402 i=1,9
      gamqa(i) = - ut2(i)+gamqa(i)
  402 continue
      call vudy(g,a,ut1)
      call mmm( ut1,c22, ut1, ut2)
      do 403 i=1,9
      gamqa(i) = - ut2(i)+gamqa(i)
  403 continue
!---  calculation of gamma(qb) dyadic
      call vudy(g,c,ut1)
      call mmm( ut1,c33, ut1, ut2)
      do 411 i=1,9
      gamqb(i) = - ut2(i)+gamqb(i)
  411 continue
      call vudy(g,v,ut1)
      call mmm( ut1,c22, ut1, ut2)
      do 412 i=1,9
      gamqb(i) = - ut2(i)+gamqb(i)
  412 continue
      call vudy(g,b,ut1)
      call mmm( ut1,c11, ut1, ut2)
      do 413 i=1,9
      gamqb(i) = - ut2(i)+gamqb(i)
  413 continue
!---  calculation of gamma(qa,qb) dyadic
      call vudy(g,u,ut1)
      call vudy(g,c,ut2)
      call mmm( ut1,c33, ut2, ut3)
      do 421 i=1,9
      gamqq(i) = - ut3(i)+gamqq(i)
  421 continue
      call vudy(g,a,ut1)
      call vudy(g,v,ut2)
      call mmm( ut1,c22, ut2, ut3)
      do 422 i=1,9
      gamqq(i) = - ut3(i)+gamqq(i)
  422 continue
!---  p1 and p2  components
      call vpr(g,d,b,pr1)
      call mv(gr,pr1,p1)
      call norm (pr1,p1)
      call vpr(g,b,f,pr2)
      call mv(gr,pr2,p2)
      call norm(pr2,p2)
!---  sigma(tau) calculation
      call vmv(gamqa,p1,p1,sig21)
      sig21 = sig21/(qa*qa)
      call vmv(gamqb,p2,p2,sig22)
      sig22 = sig22/(qb*qb)
      call vmv(gamqq,p1,p2,sig23)
      sig23 = sig23*2./(qa*qb)
      sdtau = sig21+sig22+sig23
      sdtau = sqrt(sdtau)
      sdtau = sdtau*rad
 1000 continue
      return
      end
!
!code for carpxNEW
      subroutine carpxNEW
!
      USE General
      USE Geometry
      USE Dialogo, only : SmallIt
!
!
      common/workc/ggwc(9),grwc(9),x1(8),x2(8),xr(8),icomc(158)
      character*40 string
!--
      write(lo,10)
   10 format (/,' The angle between the line:')
      indL=IndLineCurr(1)
      call cwrlineNEW(indL)
      write(lo,20)
   20 format(' ... and the plane:')
      indP=IndPlaneCurr(1)
      jli5=1
      call cwrplaneNEW(indP,jli5)
      x1(:)=0.0
      x1(1:3)=CoefLineU(1:3,indL)
      x1(5:7)=CoefLineU_dev(1:3,indL)
      xr(1:4)=CoefPlane(1:4,indP)
      xr(5:8)=CoefPlane_dev(1:4,indP)
      call xarpcNEW(x1,xr,xgg,xgr,ang,sa)
      call xnumst(ang,sa,1,string,lstr)
      SmallIt(1) = ' '                        !mr
      SmallIt(1) = string(1:lstr)             !mr
      SmallIt(1)(lstr+1:lstr+1) = char(0)     !mr
      write(lo,21) string(1:lstr)
   21 format (' ... is = ',a,' degrees',/)
      write(Msg,30) string(1:lstr)
   30 format ('Angle between the line and the plane = ',a,' degrees')
      call PrintMess(Msg)
      return
      end
!
!code for xarpcNEW
      subroutine xarpcNEW(pr1,pr2,gg,gr,ang,sa)
!--plane-plane angle
!
      USE GENERAL, only: lo
      USE Geometry
!      
      dimension pr1(*),pr2(*),gr(*),gg(*)
      dimension p1(3),p2(3),p1s(3),p2s(3)
!
      double precision  xu(3),xou(3),cst,snt,s1,s2,th,st,sx,sxo
      dimension sx(3),sxo(3)
!
      rd = 57.29578
      ns1=0
      st=0d0
      do i=1,3
         xu(i)=pr1(i)
         xou(i)=pr2(i)
      enddo
2     continue
      call mv(gg,pr1,p1)
      call mv(gg,pr1(5),p1s)
      call mv(gr,pr2,p2)
      call mv(gr,pr2(5),p2s)
      call ospr(pr1,p1,b)
      call ospr(pr2,p2,c)
      call ospr(pr1,p2,a)
      b = sqrt(b)
      c = sqrt(c)
      csgam = a/(b*c)
      if (csgam.gt.1)	csgam =1.0
      if (csgam.lt.-1.) csgam =-1.
      gam = acos(csgam)
!      ang = gam*rd
      if(ns1.ne.0)go to 6
      th=gam
6     ns1=ns1+1
!      write(lo,*) 'th,st,ns1,nn',th,st,ns1,nn
      s2=dabs(gam-th)
      if(s2.gt.1d-7)st=st+s2**2
      if((ns1-nn-1).eq.0)go to 9
      do i=1,3
         call urnNEW
         da = pr1(4+i) * cpp
         if(m3dp.ge.5d7)pr1(i)=xu(i)+da
         if(m3dp.lt.5d7)pr1(i)=xu(i)-da
         call urnNEW
         da = pr2(4+i) * cpp
         if(m3dp.ge.5d7)pr2(i)=xou(i)+da
         if(m3dp.lt.5d7)pr2(i)=xou(i)-da
      enddo
      go to 2
9     sa=0.0
      if(st.gt.1d-16)sa=(up*dsqrt(st))
      ang=th
      ang=ang*rd
      sa=sa*rd
!      write(lo,*) 'th,ang,sa',th,ang,sa
      do i=1,3
         pr1(i)=xu(i)
         pr2(i)=xou(i)
      enddo
      return
      end
!
!code for callcxNEW
      subroutine callcxNEW
!--main rouitne calcolo angolo linea-linea
      USE General
      USE Geometry
      USE Dialogo, only : SmallIt                     !mr
!
      common/workc/ggwc(9),grwc(9),x1(8),x2(8),x3(4),x4(4),icomc(158)
      character*40 string
!--
      write(lo,1)
    1 format (/,' The angle between the two lines:')
      indL=IndLineCurr(1)
      call cwrlineNEW(indL)
      indL1=IndLineCurr(2)
      call cwrlineNEW(indL1)
      x1(:)=0.0
      x1(1:3)=CoefLineU(1:3,indL)
      x1(5:7)=CoefLineU_dev(1:3,indL)
      x2(:)=0.0
      x2(1:3)=CoefLineU(1:3,indL1)
      x2(5:7)=CoefLineU_dev(1:3,indL1)
      call xallcNEW(x1,x2,xgg,ang,sa)
      call xnumst(ang,sa,1,string,lstr)
      SmallIt(1) = ' '                        !mr
      SmallIt(1) = string(1:lstr)             !mr
      SmallIt(1)(lstr+1:lstr+1) = char(0)     !mr
      write(lo,21) string(1:lstr)
   21 format (' ... is = ',a,' degrees',/)
      write(Msg,30) string(1:lstr)
   30 format ('Angle between the two lines = ',a,' degrees')
      call PrintMess(Msg)
      return
      end
!
!code for xallcNEW
      subroutine xallcNEW(pr1,pr2,gr,ang,sa)
!--calcolo angolo linea-linea
!
      USE GENERAL, only: lo
      USE Geometry
!      
      dimension pr1(*),pr2(*),gr(*)
      dimension p1(3),p2(3),p1s(3),p2s(3)
!
      double precision  xu(3),xou(3),cst,snt,s1,s2,th,st,sx,sxo
      dimension sx(3),sxo(3)
!
      rd = 57.29578
      ns1=0
      st=0d0
      do i=1,3
         xu(i)=pr1(i)
         xou(i)=pr2(i)
         pr1(i+4)=pr1(i+4)*cpp
         pr2(i+4)=pr2(i+4)*cpp
      enddo
2     continue
      call mv(gr,pr1,p1)
      call mv(gr,pr1(5),p1s)
      call mv(gr,pr2,p2)
      call mv(gr,pr2(5),p2s)
      call ospr(pr1,p1,b)
      call ospr(pr2,p2,c)
      call ospr(pr1,p2,a)
      b = sqrt(b)
      c = sqrt(c)
      csgam = a/(b*c)
      if (csgam.gt.1)	csgam =1.0
      if (csgam.lt.-1.) csgam =-1.
      gam = acos(csgam)
!      ang = gam*rd
      if(ns1.ne.0)go to 6
      th=gam
6     ns1=ns1+1
!      write(lo,*) 'th,st,ns1,nn',th,st,ns1,nn
      s2=dabs(gam-th)
      if(s2.gt.1d-7)st=st+s2**2
      if((ns1-nn-1).eq.0)go to 9
      do i=1,3
         call urnNEW
         if(m3dp.ge.5d7)pr1(i)=xu(i)+pr1(4+i)
         if(m3dp.lt.5d7)pr1(i)=xu(i)-pr1(4+i)
         call urnNEW
         if(m3dp.ge.5d7)pr2(i)=xou(i)+pr2(4+i)
         if(m3dp.lt.5d7)pr2(i)=xou(i)-pr2(4+i)
      enddo
      go to 2
9     sa=0.0
      if(st.gt.1d-16)sa=(up*dsqrt(st))
      ang=th
      ang=ang*rd
      sa=sa*rd
!      write(lo,*) 'th,ang,sa',th,ang,sa
      do i=1,3
         pr1(i)=xu(i)
         pr2(i)=xou(i)
      enddo
      return
      end
!
!code for cdraNEW
      subroutine cdraNEW
!--main routine per il calcolo delle distanze di atomi da una linea
!
      USE General
      USE Geometry
      USE Atomi
!
      common/workc/ggwc(9),grwc(9),x1(3),x2(3),x3(3),x4(3),icomc(170)
      dimension caa(3,3),gamba(3,3)
!--
      write(Msg,30)
   30 format ('Calculate distance(s) of the atom(s) from the line')
      call PrintMess(Msg)
      write(lo,10)
   10 format (/,' Distance(s) of the atom(s):')
      call xwrlgNEW(1,nats25)
      write(lo,20)
   20 format(' ... from the line:')
      ind=IndLineCurr(1)
      call cwrlineNEW(ind)
      write(lo,31)
   31 format(' ... are the following:')
      call xdraNEW(ind)   
      write(lo,'(1h )')
      return
      end
!
!code for xdraNEW
      subroutine xdraNEW(ind)
!--calcolo delle distanze da una linea
!
      USE GENERAL
      USE Atomi
      USE Geometry
      USE Dialogo, only : SmallIt
!
      character*80 linea
!
      common/workc/ggwc(9),grwc(9),x1(6),x2(6),x3(6),x4(6),icomc(158) 
      dimension caa(3,3),gamba(3,3)
      character*40 string,string1
!--
      if(idev.gt.0) then
         call xvarbMNQD(gamba)
      endif
      linea=' '
      lin=1
      ili=0
      varba=0.0
      sumdis=0.0
      dsumdis=0.0
      x1(1:3)=CoefLineU(1:3,ind)
      x3(1:3)=CoefLineXG(1:3,ind)
      do i=1,nats25
         x2(1:3)=xyzs25(1:3,i)
         x2(1:3)=x2(1:3)-x3(1:3)
         call drac(x1,x2,xgg,dst)
         sumdis=sumdis+dst
         stdfp=0.0
         if(idev.gt.0) then
            caa(:,:) = 0.0
            call vardi(xgr9,gamba,x1,varba)
!---- calculate the variances acros the best plane
            do j=1,3
               caa(j,j) = xyzs25_dev(j,i)*xyzs25_dev(j,i)
            enddo    
            call vardi(xgr9,caa,x1,var)
            stdfp = varba+var
            if(stdfp.lt.0.and.stdfp.gt.-.10)stdfp=0.
            dsumdis=dsumdis+stdfp
            stdfp = sqrt(stdfp)
         endif
!--stampa      
         call xnumst(dst,stdfp,3,string,lstr)
         SmallIt(1) = ' '                        !mr
         write(SmallIt(1), '(f8.3)') dst         !mr
         SmallIt(1)(9:9) = char(0)               !mr
         call shift( aLab25(i),l)
         write(string1,'(a,3x,a)')aLab25(i)(1:8), string(1:lstr)
         call shift(string1,lstr1)
         linea=linea(1:lin)//string1(1:25)
         lin=lin+25
         ili=ili+1
         ii=mod(i,3)
         if(ii.eq.0)ii=3
         if(ii.eq.3)then
            write(lo,'(a)')linea(1:lin)
            linea=' '
            ili=0
            lin=1
         endif
      enddo
      if(ili.gt.0)write(lo,'(a)')linea(1:lin)
!      if(nats25.gt.1) then
!      sumdis=sumdis/nats25
!      write(lo,41) sumdis
!   41 format(/,' Mean Val',f10.4)
!      endif
      return
      end
!
!code for cpmNEW
      subroutine cpmNEW(vetch,x1,x2)
!
      USE GENERAL
      USE Atomi
      USE Geometry
!
      character*16 vetch
      dimension x1(*),x2(*)
!
      common/workc/ggwc(9),grwc(9),xx1(6),xx2(6),x3(6),x4(6),icomc(158)
!--
      write(Msg,30)
   30 format ('Calculate the coordinates of mean point')
      call PrintMess(Msg)
      write(lo,1)
    1 format (/,' The coordinates of mean point through the atoms:')
      call xwrlgNEW(1,nats25)
      write(lo,2)
  2   format(' ... is :')
      x1(1:3)=0.0
      x2(1:3)=0.0
      do i=1,nats25
         do j=1,3
            x1(j)=x1(j)+xyzs25(j,i)
            x2(j)=x2(j)+xyzs25_dev(j,i)**2
         enddo
      enddo
      do i=1,3
         x1(i)=x1(i)/nats25
         x2(i)=sqrt(x2(i)/nats25)
      enddo
      write(lo,410)vetch,(x1(i),i=1,3),(x2(i),i=1,3)
410   format(1x,a4,3f10.5,/,5x,3f10.5)
      return
      end
!
!code for atcalcNEW
      subroutine atcalcNEW(dist)
!--calcola la posizione di un atomo distante d
!  da atom1 lungo la retta (atom1-atom2)
!
      USE GENERAL
      USE Atomi
      USE Geometry
!
      common/workc/ggwc(9),grwc(9),x1(6),x2(6),x3(6),x4(6),icomc(158)
      dimension uu(3),ur(3)
!-- 
      write(lo,1)
    1 format (/,' The coordinates of a point between two atoms:')
      call xwrlgNEW(1,nats25)
      x1(1:3)=xyzs25(1:3,1)
      x2(1:3)=xyzs25(1:3,2)
      call vcmp(x2,x1,uu)
      call mv(xgg,uu,ur)
      call ospr(uu,ur,b)
      bond=sqrt(b)
      write(lo,'(a,f10.3,a)')' (having a distance :',bond,')'
      write(lo,2) dist
  2   format(' at a distance from the first atom of :',f10.3,/,
     1      ' ... is :')
      do i=1,3
         x2(i)=x1(i)+dist*uu(i)/bond
      enddo
      x3(1:3)=xyzs25_dev(1:3,1)**2
      x4(1:3)=xyzs25_dev(1:3,2)**2
      ur(1:3)=(x3(1:3)+x4(1:3))/2
      ur(1:3)=sqrt(ur(1:3))
      write(lo,410)x2(1:3),ur(1:3)
410   format(' P(x,y,z) :',3f10.4,/,11x,3f10.4)
      return
      end
!
!code for DistAng2526      
      subroutine DistAng2526(juno,jangle)
!--distances and angles calculations
!  distanze senza limiti or angle senza limiti (jangle)
!  juno   =  1 un solo gruppo di atomi
!            2  due gruppi di atomi
!  jangle = -1 solo angoli
!	       0 solo distanze
!	       1 distanze e angoli
!
      USE General
      USE Atomi
      USE Symmetry
      USE BuildModule 
      USE Dialogo, only : SmallIt                     !mr
      USE HydroStuff
      USE Molcom
      USE Geometry
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!--
      dimension AngleParz(13,1000)
      character*80 kinea      
!--
c      common/xbaco/natsSymm,noptable(100),nopt,vett(3,4)
!--
      dimension x1(3),x2(3),x3(3),s1(3),s2(3),s3(3),x2a(3)
      dimension xmx(3),li(12),xdon(3),sdon(3)
      dimension uac(3),cac(3),trac(3)
      dimension symt(12),hl(12)
      dimension tr(3)
      dimension iatco(6),jatco(6)
      dimension xxx(3),yyy(3),zzz(3)                    ! ,ggg(9)
!
      character*40 string,string2,iarg
      character*160 linea,linea2
!--
      if(jangle.eq.-1) then
        write(Msg,35)
35	  format ('Bond angles calculation')
        write(lo,10)
10	  format(/,' Bond angles calculation')
        write(lo,11)
11      format(  ' (Distances without limit)')
      else if(jangle.eq.0) then
        write(Msg,36)
36	  format ('Bond distances calculation')
        write(lo,20)
20	  format(/,' Bond distances calculation')
        write(lo,11)
      else if(jangle.eq.1) then
        write(Msg,37)
37	  format ('Bond distances & angles calculation')
        write(lo,30)
30	  format(/,' Bond distances & angles calculation')
        write(lo,11)
      endif
      call PrintMess(Msg)
!---------------------------------------------
!--check numero di gruppi
!---------------------------------------------
      if(juno.eq.1) then
         nats26=nats25
         do jn=1,nats25
            aLab26(jn)=aLab25(jn)
            xyzs26(1:3,jn)=xyzs25(1:3,jn)
            xyzs26_dev(1:3,jn)=xyzs25_dev(1:3,jn)
         enddo
      endif
!      
      lengx=0
      do i=1,nats25
         call shift(aLab25(i),lengb)
         lengx=max0(lengx,lengb)
      enddo
      if(juno.eq.2) then
         do i=1,nats26
            call shift(aLab26(i),lengb)
            lengx=max0(lengx,lengb)
         enddo
      endif
!--
!----------------------------------
!--set jflagA=1 calcola anche angoli       
      jflagA=0
      if(jangle.ne.0)jflagA=1
!----------------------------------
!---- write some explanation
      if(jangle.ne.-1) write(lo,400)
  400    format(/,2x,'atom(i)-(j)',10x,'dist(s.u.)',/)
      if(jangle.ne.0) write(lo,401)
  401    format(/,4x,'atom(k)---------atom(i)------atom(j)',
     2             5x,'angle(s.u.)',/)
!--set minima distanza     
      z = 0.1
      istat2=0
!=======================================================
!--first loop on the atoms list
!=======================================================
      nna1=nats25
      if(juno.eq.1) then
         if(jflagA.eq.0) nna1=nats25-1
      endif
      ili=0
      lung0a=1
      linea2=' '
      do jn=1,nna1
 !--azzero area per calcolo angoli 
         AngleParz(:,:)=0.0       
         nato = 0
         x1(1:3)=xyzs25(1:3,jn)
         s1(1:3)=xyzs25_dev(1:3,jn)
         kinea = ' '
         call slineaNEW(aLab25(jn),lengx,1,inext,kinea)
!         call shift(aLab25(jn),l1)
!=======================================================
!--second loop on the atoms list
!=======================================================
!-------jl run over the atom list 
         if(juno.eq.1) then
           jll=jn+1
           if(jflagA.eq.1) then
              jllX=jll
              jll=1
           endif
         else    ! juno=2
           jll=1
         endif
!-------jl run over the atom list 
         do jl=jll,nats26
            x2(1:3)=xyzs26(1:3,jl)    
            s2(1:3)=xyzs26_dev(1:3,jl)
            call shift(aLab26(jl),l2)
!-----------------------------------------------------------	                    
            call vlen(xgg,x1,x2,d)
            if(d.lt.z) cycle
            p = x1(1)-x2(1)
            q = x1(2)-x2(2)
            r = x1(3)-x2(3)
!-----------------------------
!      a = store(l1m1  )*p*p
!      b = store(l1m1+4)*q*q
!      c = store(l1m1+8)*r*r
!      d = store(l1m1+1)*p*q*2.
!      e = store(l1m1+2)*p*r*2.
!      f = store(l1m1+5)*q*r*2.
!      d = a+b+c+d+e+f     
            if(jangle.ne.0) then
!--memorizzo atomi entro la distanza per calcolo angoli
               nato = nato+1
               AngleParz(1 ,nato)=jl
               AngleParz(2 ,nato)=d
               AngleParz(3 ,nato)=p
               AngleParz(4 ,nato)=q
               AngleParz(5 ,nato)=r
!               AngleParz(6 ,nato)=code1
!               AngleParz(7 ,nato)=code2
               AngleParz(8 ,nato)=x2(1)
               AngleParz(9 ,nato)=x2(2)
               AngleParz(10,nato)=x2(3)
               AngleParz(11,nato)=s2(1)
               AngleParz(12,nato)=s2(2)
               AngleParz(13,nato)=s2(3)
            endif
!-----------------------------
!--calcolo e stampo distanza           
            iprint=1
            if(jflagA.eq.1) then
               if(jll.gt.jllX) then 
                  iprint=0            
               endif
            endif
            if(iprint.eq.1) then
!--calcolo standard deviations------------------------------------------
               sum1=0.0
               sum2=0.0
               do j=1,3
                  sum1=sum1+s1(j)
                  sum2=sum2+s2(j)
               enddo
               cova=0
               nodev=0
               if(sum1.le.0.0) nodev=nodev+1
               if(sum2.le.0.0) nodev=nodev+1
               if(nodev.eq.0)call vstd (xgg,x1,x2,s1,s2,cova)
!------------------------------------------------------------------------
               tau=d
               std=cova
               string=' '
               call xnumst(tau,std,3,string,lstr)
               if(jangle.ge.0) then
!--stampo distanza    
                  kinea(lengx+1:80)=' '
                  kinea(lengx+1:lengx+2)=' -'
                  j2 = lengx+4
                  call slineaNEW(aLab26(jl),lengx,j2,inext,kinea)
                  inext=inext+4
                  lengy=max0(inext,20)
                  kinea=kinea(1:lengy)//string(1:lstr)
                  call shift(kinea,lx)
                  write(lo,'(4x,a)')kinea(1:lx)
               endif
            endif
!--end of second loop on the atom list
         enddo
!--check se devono essere calcolati gli angoli
         if (jangle.ne.0) then
!--loop di calcolo degli angoli tra atomi 
             do jm1=1,nato-1
                jlx=AngleParz(1 ,jm1)
                x2(1:3)=AngleParz(8 :10,jm1)
                s2(1:3)=AngleParz(11:13,jm1)
!--preparo prima parte della linea di stampa
                kinea(:)=' '
                j3=1
                call slineaNEW(aLab26(jlx),lengx,j3,inext,kinea)
                kinea(inext+2:inext+2)='-'
                j3 = inext + 4
                call slineaNEW(aLab25(jn),lengx,j3,inext,kinea)
                kinea(inext+2:inext+2)='-'
                inexta =inext + 4
!--fine prima parte della linea di stampa
                loop3: do jm2=jm1+1,nato
                   jly=AngleParz(1 ,jm2)
                   x3(1:3)=AngleParz(8 :10,jm2)
                   s3(1:3)=AngleParz(11:13,jm2)
!--preparo seconda parte della linea di stampa
!--preparo seconda parte della linea di stampa
                   j3=inexta
                   kinea(j3:80)=' '
                   call slineaNEW(aLab26(jly),lengx,j3,inext,kinea)
                   inext=inext+4
!--fine seconda parte della linea di stampa
!--controlla stessa posizione per x2 e x3
                   do i=1,3
                      if(abs(x2(i)-x3(i)).le.0.00001) cycle loop3
                   enddo
!---- check null value for angle
c             if((AngleParz(3,jm1)-AngleParz(3,jm2)).gt.0.00001)goto 4260
c             if((AngleParz(4,jm1)-AngleParz(4,jm2)).gt.0.00001)goto 4260
c             if((AngleParz(5,jm1)-AngleParz(5,jm2)).le.0.00001)goto 4110
c 4260              continue
c             if(AngleParz(2,jm1).le.0.00001)goto 4110
c             if(AngleParz(2,jm2).gt.0.00001)goto 4130
c 4110              continue
c                   teta = 0.0
c                   go to 4020
c 4130              continue
!---- angle calculation
                   call anamp(xgg,x1,x2,x3,teta)
c 4020              continue
                   ang = teta*rtd
                   std=0.0
                   sum1=0.0
                   sum2=0.0
                   sum3=0.0
                   do j=1,3
                      sum1=sum1+s1(j)
                      sum2=sum2+s2(j)
                      sum3=sum3+s3(j)
                   enddo
                   if(sum1.le.0.0) goto 4051
                   if(sum2.le.0.0) goto 4051
                   if(sum3.le.0.0) goto 4051
                   call anstd (xgg,x1,x2,x3,s1,s2,s3,teta,detet)
                   std = detet*rtd
 4051              continue
c                   if(istat2.gt.1) then
c                      write(lo,405)  aLab26(jlx)(1:l2) ,x2
c                      write(lo,405)  aLab25(jn)(1:l1)  ,x1  
c                      write(lo,405)  aLab26(jly)(1:l2) ,x3
c                   endif
                   string=' '
                   call xnumst(ang,std,2,string,lstr)
!                   
                   lengy=max0(inext,30)
                   kinea=kinea(1:lengy)//string(1:lstr)
                   call shift(kinea,lx)
                   write(lo,'(4x,a)')kinea(1:lx)
                enddo  loop3
             enddo
!--end of loop of angle calculation
         endif
!--end of first loop on the atom list
      enddo
c**********************************
!
!           SmallIt(1) = ' '                        ! gianluca 05/01/10
!           write(SmallIt(1), '(f8.3)') d           ! gianluca 05/01/10
!           SmallIt(1)(9:9) = char(0)               ! gianluca 05/01/10
!
      write(lo,'(1h )')
      return
      end
!
!code for ziangNEW      
      subroutine ziangNEW(inter,juno,jangle,iprGS)
!--distances and angles calculations
!  common variables
!  inter= -2  distanze senza limiti or angle senza limiti (jangle)
!	    -1  short distances
!	     0  distances and angles
!	     1  long distances
!  juno =  1  una sola lista (indirizzi identici)
!	     2  due liste
!  jangle = -1 solo angoli
!	       0 solo distanze
!	       1 distanze e angoli
!  iprGS = 0 non stampa Operatori
!          1 stampa operatori
!--jFlagAtom(:) indica atomi del primo loop
!--jFlagAtom1(:) indica atomi del secondo loop           
!  dx(4)   min max min max (dist and dist for angles)
!
      USE General
      USE Atomi
      USE Symmetry
      USE BuildModule 
      USE Dialogo, only : SmallIt                     !mr
      USE HydroStuff
      USE Molcom
      USE Geometry
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common/worka/a,b,c,d,e,f,gxx,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,mnnfl,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2		   jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
!--
      common/workc/dx(4),icomc(196)
!--
      dimension AngleParz(13,1000)
      character*80 kinea,fmtch
      character*16 ilab1      
!--
c      common/xbaco/natsSymm,noptable(100),nopt,vett(3,4)
!--
      dimension x1(3),x2(3),x3(3),s1(3),s2(3),s3(3),x2a(3)
      dimension xmx(3),li(12),xdon(3),sdon(3)
      dimension nux(3),nnx(3)
      dimension uac(3),cac(3),trac(3)
      dimension symt(12),hl(12)
      dimension tr(3)
      dimension iatco(6),jatco(6)
      dimension xxx(3),yyy(3),zzz(3)                    ! ,ggg(9)
      dimension icoup(30,30),acoup(30,30),atn(30)
      dimension ijcoup(30,30),occu(30),rcov(18),dcov(18,18),iponteH(9)
      character nnamh*1,iihh*2,jph*3
!
      character*6 spazio
      character*40 string,string2,iarg
      character*160 linea,linea2
      character(len=30)  :: alfabeto
      data alfabeto/'abcdefghijklmnopqrstuvwxyz'/
!--
!     data iarg/'the limits'/
!--
!-- inter,lint0 and lintr long distances parameters
!-- inter =  1 calculate long distances
!-- inter =  0 calculate distances and angles
!-- inter = -1 calculate short distances
!-- inter = -2 calculate distances without limits
!      
!--
      call scrper('                                               ',0,0)
      if(jcif.eq.0) then
         if(jangle.eq.-1) then
            write(Msg,35)
35	      format ('Bond angles calculation')
         else if(jangle.eq.0) then
            write(Msg,36)
36	      format ('Bond distances calculation')
         else if(jangle.eq.1) then
            write(Msg,37)
37	      format ('Bond distances & angles calculation')
         endif
         call PrintMess(Msg)
      endif
      if(inter.eq.-2) then
        write(lo,11)
11	  format(/,' Bond distances without limit')
      else if(inter.eq.-1) then
        write(lo,10)
10	  format(/,' Bond distances and angles within the sum of',
     1 ' covalent radii (see Table Bond Distances)')
      else if(inter.eq.0) then
        write(lo,20)
20	  format(/,' Bond distances and angles within the user range')
      endif
!----------------------------------
!--set jflagA=1 calcola anche angoli       
      jflagA=0
      if(inter.eq.0.or.jangle.ne.0)jflagA=1
!----------------------------------
      lengx=0
      do i=1,nats
        call shift(aLab(i),lengb)
        lengx=max0(lengx,lengb)
      enddo
!--
      rad = 180./pi
!
      w=1.0
      if(inter.ne.-2) then          !-1,0,1,2
         if(inter.eq.0) then        !0
            if(dx(2)+dx(4).le.0.0) then
               dx(1)=0.1
               dx(2)=1.7
               dx(3)=dx(1)
               dx(4)=dx(2)
            endif
         endif
!-------   	call sprtn
!*********************************************
!----          
!---- long and short distances parameters
!----        
         if(inter.ne.0) then        !-1.1,2
            if(dx(1).eq.0.0) dx(1) = 0.1
            if(dx(2).eq.0.0) dx(2) = 0.3
            if(dx(4).ne.0.0) dx(3) = dx(1)
            if(inter.eq.1)then
               call scrper(' H-Bond(s) Geometry',0,0)
               do i=1,nk
                  rcov(i) = radii(i,2)
                  if(rcov(i).eq.0.0) rcov(i) = 2.0
               enddo
               do i = 1,nk
                  do j = 1,nk
                     dcov(i,j) = rcov(i) + rcov(j) + dx(2)
                  enddo
               enddo
               if(jcif.eq.0)then
                   write(lo,30)dx(2)
 30                format(/,' Hydrogen Bonds and Contacts (*) within',
     1                ' the sum of van der Waals radii plus',f6.2)
                   write(lo,'(a,a)')' Intramolecular contacts between',
     1                      ' atoms closer than four bonds are omitted'
                   write(lo,581)
  581              format(/,' Species to species',5x,'limit')
                   do i=1,nk
                      iloca=nalf(i)
                      do j=i,nk
                         ilocb=nalf(j)
                         write(lo,582)iloca,ilocb,dcov(i,j)
  582                    format(3x,a4,8x,a4,f10.3)
                      enddo
                   enddo
                   write(lo,402)
c                   write(lo,'(a)')' '  
               else
                   write(ncpu,1352)
1352	             format('  ',/,'  ',/,
     1              'loop_',/,
     1              '_geom_contact_atom_site_label_1',/,
     2              '_geom_contact_atom_site_label_2',/,
     3              '_geom_contact_distance',/,
     4              '_geom_contact_site_symmetry_1',/,
     5              '_geom_contact_site_symmetry_2',/,
     6              '_geom_contact_publ_flag',/)
               endif
            else 
               call scrper(' Distances & Angles Calculation',0,0)
               if(inter.eq.-1) then
                  do i = 1,nk
                     do j = 1,nk
                        dcov(i,j) = BondTable(2,i,j)
                     enddo
                  enddo
               endif
            endif
!--definisco la distanza massima
            w1 = -1.
            do i = 1,nk
               do j = 1,nk
                  w1 = amax1(w1,dcov(i,j))
               enddo
            enddo
            dx(2) = w1
            if(dx(4).ne.0.0) dx(4) = dx(2)
         else
            call scrper(' Distances & Angles Calculation',0,0)
            Write(lo,583) dx
  583       format(/,' Limits for interatomic bonds & angles:',/,4f8.3)
         endif
         w = amax1(dx(2),dx(4))
         if(inter.ne.0) w=w1
      endif
!************************************
      if(inter.eq.1)then
!-- specie che si  considera partecipano a ponteH:c,n,o,f,s,cl,se,br,i
         npontH=9
         iponteH(:)=0
         iponteH(1:9)=0
         iponteH(1)=6
         iponteH(2)=7
         iponteH(3)=8
         iponteH(4)=9
         iponteH(5)=16
         iponteH(6)=17
         iponteH(7)=34
         iponteH(8)=35
         iponteH(9)=53
         nangh=0
!-- se ci sono piu' di 200 atomi non stampa le dist. di contatto degli H
         nodisth=0      
!merc 20ott10         if(nats.ge.200.and.no(1).eq.1)nodisth=1      
         if(nats.le.200.and.no(1).eq.1)nodisth=1      
!--crea una longcon per le distanze di contatto per gli atomi non H 
!-- =0 puo' formare ponteH, =1 non, -1 e' un H
!--numbTemp(:)
         numbTemp(:)=0
         jFlagAtom(1:nats)=0
         do i=1,nats
            n3jn = nzTot(i)
            if(n3jn.eq.0)cycle  !esclude i ghost
            nzjn=no(n3jn)
            if(nzjn.gt.1)then
               do j=1,npontH
                  if(iponteH(j).eq.nzjn)then
                     numbTemp(i)=1
                     jFlagAtom(i)=1
                     exit
                  endif
               enddo
            else if(nzjn.eq.1)then
                  jFlagAtom(i)=1
                  numbTemp(i)=-1
            endif        
         enddo
         jFlagAtom1=jFlagAtom   
      endif
!--      
!--w e' la distanza di legame massima prevista 
      do i=1,3
         x=xgr(i,i)
         xmx(i)=w*sqrt(x)
      enddo
!--xmx e' la distanza lungo un asse espresso in frazione d'asse
      if(inter.ne.1)then
!---- write some explanation
         write(lo,402)
  402    format (/
     *     ,1x,'Atom code : label.N_lmn     ',/
     1     ,1x,'label     : atom label       ',/
     3     ,1x,'N         : No.of symmetry operator in the Table,',/
     6     ,1x,'l,m,n     : lattice translation (l-5) for x, ' 
     7     ,'(m-5) for y, (n-5) for z',/)
         if(jangle.ne.-1) write(lo,400)
  400    format ('atom(i)--atom(j)',20x,'x',7x,'y',7x,'z'
     4     ,4x,'dist.(s.u.)')
         if(jangle.ne.0) then
            write(lo,401)
  401       format(2x,'atom(k)--atom(i)--atom(j)',
     2             13x,'angle(s.u.)',/)
         else
            write(lo,'(1x)')
         endif
      endif
      x = dx(1)
      if(dx(3).gt.0.0) then
         x = amin1(dx(1),dx(3))
      endif
      y = w*w      ! distanza massima al quadrato
      z = x*x      ! distanza minima al quadrato
      if(inter.eq.-2) z = 0.1
      ncod = 6
      istat2=0
!=======================================================
!--first loop on the atoms list
!=======================================================
      lint0=1555
      nna1=nats
      if(juno.eq.1) then
         if(jflagA.eq.0) nna1=nats-1
      endif
      ili=0
      lung0a=1
      linea2=' '
      do jn=1,nna1
         if(jFlagAtom(jn).eq.0) cycle 
 !--azzero area per calcolo angoli 
         AngleParz(:,:)=0.0       
         nato = 0
         x1(1:3)=xyzs(1:3,jn)
         s1(1:3)=xyzs_dev(1:3,jn)
         n3jn = nzTot(jn)
         if(n3jn.eq.0)cycle  !esclude i ghost
         nzjn = no(n3jn)
         ia1=0
         if(nzjn.eq.1) ia1=1
         if(inter.eq.1)then
            kponH1=numbTemp(jn)
         endif
         if(inter.eq.-2) then
            nux(:) = 0
            nnx(:) = 0
         else
            call unnl (x1,xmx,nux,nnx)
         endif
         do i=1,3
            nux(i) = nux(i)+50
            nnx(i) = nnx(i)+50
         enddo
         nsg = 0
         do i=1,3
            if(nux(i).gt.99) then
               nux(i) = 99
               nsg = 1
            endif
         enddo
         do i=1,3
           if(nnx(i).lt.0) then
              nnx(i) = 0
              nsg = 1
           endif
         enddo
         if(nsg.gt.0) then
            call shift(aLab(jn),l)
            write(lo,970) aLab(jn)(1:l) 
  970       format (/,5x,'*****Warning***** too large limits for dist.'
     2       ,/,24x,'or',/,24x,'atom ',a8,' too far from the origin',/)
            return
         endif
         kinea = ' '
         call slineaNEW(aLab(jn),lengx,1,inext,kinea)
!=======================================================
!--second loop on the atoms list
!=======================================================
         if(juno.eq.1) then
           jll=jn+1
           if(jflagA.eq.1) then
              jllX=jll
              jll=1
           endif
           if(inter.eq.1.and.nzjn.eq.1)then
              jll=1
           endif
         else    ! juno=2
           jll=1
         endif
!-------jl run over the atom list 
         do jl=jll,nats
c           call XTimeIN(2,'2 loop Time')
           if(jFlagAtom1(jl).eq.0) cycle 
           n3jl = nzTot(jl)
           if(n3jl.eq.0)cycle  !esclude i ghost
           nzjl = no(n3jl)
           if(nzjl.eq.1.and.inter.eq.1)cycle 
           xxx(1:3)=xyzs(1:3,jl)
           s2(1:3)=xyzs_dev(1:3,jl)
           ia2=0
           if(nzjl.eq.1)  ia2=2
           if(inter.eq.1) kponH2=numbTemp(jl)
!=======================================================
!--loop over symmetry operation
!=======================================================
           itx = 1
c           n2c=nsym
           n2c=nsymTot
           if(inter.eq.-2) n2c=1
!----------js run over all the symmetry operation 
           do js=1,n2c
              ieqX=0
              call xequiTot(js, xxx, cac,ieqX)
              if(ieqX.eq.1) cycle
!=======================================================
!--loop of cell translations
!=======================================================
              do jtx=nnx(1),nux(1)
                 tr(1) = float(jtx)-50.
                 do jty=nnx(2),nux(2)
                    tr(2) = float(jty)-50.
                    do jtz=nnx(3),nux(3)
c                       call XTimeIN(3,'loop interno Time')
                       tr(3) = float(jtz)-50.
!--sommo traslazioni di cella         
                       call lop(cac,tr,x2)
!--arrotondamento            
                       fmtch=' '           
                       write(fmtch,'(3f20.6)') x2(1:3)
                       read(fmtch,'(3f20.6)')  x2(1:3)
!--controllo se puo' essere un equivalente gia' generato
                       ieq=0
                       if(js.gt.1) then
                          do i=1,js-1
                             ieq=0
                             do j=1,3
                                if( xyzEquiv(i,j) == x2(j)) ieq=ieq+1
                             enddo
                             if(ieq == 3) exit        
                          enddo
                       endif 
                       if(ieq == 3) cycle         ! fine loop 3 trasl
!                       
!--long distances directive skip if lintr=1555
!--costruisco codice operatore + traslazioni
!-------------------------------N.OpSym---N.Tras a-- -N.Tras b---N,Tras c   
                       istras=cistras(tr)    !--crea codifica ORTEP delle traslazioni
                       lintr=js*1000 + istras
c                      write(lo,'(10i7)')jn,jl,js,jtx,jty,jtz,lintr
!--start controllo connettivita' se long distance 
                       ieq=0
                       if(lintr.eq.lint0.and.inter.eq.1) then
                          nlega=lconlun(2,jn) 
                          nlegb=lconlun(2,jl) 
                          do i=1,nlegb
                             ieq=0
                             nordb=lconlun(2+i,jl)
                             do j=1,nlega  ! loop sugli atomi legati a jn (1o atomo)
                                if(nordb.eq.lconlun(2+j,jn)) then 
                                   ieq=1
                                   exit
                                 endif
                             enddo
                             if(ieq /= 0) exit
!-- elimino il controllo sui vicini a piu di 2 legami                
                             iaa=1
                             if(iaa.ne.0)then
                                nlegc=lconlun(2,nordb) ! no. di legami del 2o atomo 
                                do n=1,nlegc
                                   nordc=lconlun(2+n,nordb)
                                   do j=1,nlega   ! loop sugli atomi legati a jn (1o atomo)
                                      if(nordc.eq.lconlun(2+j,jn)) then 
                                         ieq=1
                                         exit
                                      endif
                                   enddo
                                   if(ieq /= 0) exit
                                   nlegd=lconlun(2,nordc) ! no. di legami del 3o atomo 
                                   do n1=1,nlegd
                                      nordd=lconlun(2+n1,nordc)
                                      do j=1,nlega   ! loop sugli atomi legati a jn (1o atomo)
                                        if(nordd.eq.lconlun(2+j,jn))then
                                           ieq=1
                                           exit
                                        endif
                                      enddo
                                      if(ieq /=0) exit
                                   enddo
                                   if(ieq /=0) exit
                                enddo
                             endif
                             if(ieq /= 0) exit      
                          enddo
                       endif 
                       if(ieq /= 0) cycle            ! fine loop 3 trasl
!--fine loop controllo connettivita' se long distance  
                       call vlen(xgg,x1,x2,d)
                       p = x1(1)-x2(1)
                       q = x1(2)-x2(2)
                       r = x1(3)-x2(3)
!------------------------------------------------
!      a = store(l1m1  )*p*p
!      b = store(l1m1+4)*q*q
!      c = store(l1m1+8)*r*r
!      d = store(l1m1+1)*p*q*2.
!      e = store(l1m1+2)*p*r*2.
!      f = store(l1m1+5)*q*r*2.
!      d = a+b+c+d+e+f     
!------------------------------------------------
!-- inter =  1 calculate long distances
!-- inter =  0 calculate distances and angles
!-- inter = -1 calculate short distances
!-- inter = -2 calculate distances without limits
!------------------------------------------------
                       if(inter.ne.1)then
                          d=d*d
                          if(inter.ne.-2) then
                             if(d.gt.y)  cycle                    !***********3300
                             if(inter.ne.0) then
                                dcov1 = dcov(n3jn,n3jl)
                                dcov2 = dcov1*dcov1
                                if(d.gt.dcov2) cycle              !***********3300
                             endif
                          endif
                          if(d.lt.z) cycle                        !***********3300
                          d = sqrt(d)
                          cova=0.0
                          if(d.lt.0.00001) cycle                  !***********3300 
                       else if(inter.eq.1)then
                          zz=bondTable(2,n3jn,n3jl)
                          dcov1 = dcov(n3jn,n3jl)
c                          write(lo,'(3f15.5)')d,dcov1,zz
c                          call XTimeOUT(3)
                          if(d.gt.dcov1.or.d.le.zz)cycle           !***********3300
                       endif
!--calcolo standard deviations------------------------------------------
                       sum1=0.0
                       sum2=0.0
                       do j=1,3
                          sum1=sum1+s1(j)
                          sum2=sum2+s2(j)
                       enddo
                       cova=0
                       nodev=0
                       if(sum1.le.0.0.and.n3jn.eq.1) nodev=nodev+1
                       if(sum2.le.0.0.and.n3jl.eq.1) nodev=nodev+1
                       if(nodev.eq.0)call vstd (xgg,x1,x2,s1,s2,cova)
!------------------------------------------------------------------------
                       if(inter.eq.1)then   ! calculate long distances
!-- e' una dist. di contatto?
                          jph='   '
                          if(kponH1.eq.0.and.kponH2.eq.0)jph='(*)'
!-- calcola geometria dei ponteH: 
!  ia1=1: primo atomo e' un H; kponH2=1 :secondo atomo puo' fare legame h
                          if(ia1.eq.1.and.kponH2.eq.1)then
!--questi contatti sono scritti su jrel e stampati alla fine 
                             dishac=d             
                             dev3=cova 
!--prendo il primo atomo legato a jn ! (controllare se atomo selezionato)                                           
                             nordon=lconlun(3,jn)  
                             xdon(1:3)=xyzs(1:3,nordon)
                             sdon(1:3)=xyzs_dev(1:3,nordon)
                             call vlen(xgg,xdon,x1,dishdon)
                             sum3=0.0
                             do j=1,3
                                sum3=sum3+sdon(j)
                             enddo
                             dev1=0.
                             nodev1=0
                             if(sum1.le.0.0) nodev1=nodev1+1
                             if(nodev1.eq.0)
     *                          call vstd(xgg,xdon,x1,sdon,s1,dev1)
                             call vlen(xgg,x2,xdon,disacdon)   
                             dev2=0.
                             nodev2=0
                             if(sum2.le.0.0) nodev2=nodev2+1
                             if(sum3.le.0.0) nodev2=nodev2+1
                             if(nodev2.eq.0)
     *                          call vstd(xgg,x2,xdon,s2,sdon,dev2)
!---- angle calculation--------------------------------------------
                             call anamp(xgg,x1,xdon,x2,tet)
                             teta = tet*rtod
                             if(teta.lt.80) cycle                  !***********3300
                             detet=0.
                             if(nodev1.eq.0.and.nodev2.eq.0) call anstd 
     1                            (xgg,x1,xdon,x2,s1,sdon,s2,teta,detet)
                             dev4 = detet*rtod
                             nangh=nangh+1
!-- scrive su jrel-----------------------------------------------
!          1        2         3         4         5         6     
!1234567890123456789012345678901234567890123456789012345678901234567890
!C18 -- H1  .. C13                 0.64   3.03   3.08(1)   88.37
!C18 -- H2  .. C19_4744            1.15   3.23   3.67(1)   103.10
!C9  -- H3  .. O6 _2554            1.08   3.06   3.380(8)   97.65

                             li(1)=nordon
                             li(2)=1555       !--sempre 1555 
                             li(3)=jn
                             li(4)=1555       !--sempre 1555    
                             li(5)=jl
                             li(6)=lintr        
                             linea=' '  
                             lung0=1
                             if(jcif.eq.0) then
!--format per supplementary material-------------------------                             
                                do jli=1,5,2
                                   iin=li(jli)
                                   call shift(aLab(iin),leng)
                                   inext=lung0+leng
                                   linea(lung0:inext)=aLab(iin)(1:leng)
                                   call acodNEW(inext,li(jli+1),
     *                                           linea)
                                   lung2=inext           
                                   if(inext.lt.lung0+lengx) 
     *                                           lung2=lung0+lengx
                                   if(jli.eq.1)then
                                      linea(lung2:lung2+3)=' -- '
                                   else if(jli.eq.3)then
                                      linea(lung2:lung2+3)=' .. '
                                   endif
                                   lung0=lung2+4
                                enddo
                                lung0=35
                             else
!--format per CIF----------------------------------------------
                                do jli=1,5,2
                                   iin=li(jli)
                                   linea(lung0:lung0+lengx)=
     *                                     aLab(iin)(1:lengx)
                                   lung0=lung0+lengx+2
                                enddo   
c                                lung0=max0(lung0,25)   
                             endif
!--format a comune----------------------------------------------                             
                             string=' '
                             call xnumst(dishdon,dev1,2,string,lstr)  ! -- 1a distanza
                             linea(lung0:lung0+lstr)=string(1:lstr)
                             call shift(linea,lungx)
                             lung0=lungx+3
                             string=' '
                             call xnumst(dishac,dev3,2,string,lstr)   ! --2a distanza
                             linea(lung0:lung0+lstr)=string(1:lstr)
                             call shift(linea,lungx)
                             lung0=lungx+3
                             string=' '
                             call xnumst(disacdon,dev2,2,string,lstr) ! --3a distanza
                             linea(lung0:lung0+lstr)=string(1:lstr)
                             call shift(linea,lungx)
                             lung0=lungx+3
                             if(jcif.eq.0) lung0=max0(lung0,60)   
                             if(teta.lt.100.0)lung0=lung0+1
                             if(teta.lt. 10.0)lung0=lung0+1
                             string=' '
                             lstr=0
                             call xnumst(teta,dev4,2,string,lstr)     ! -- angolo di contatto
                             linea(lung0:lung0+lstr)=string(1:lstr)
                             call shift(linea,lungx)
                             lung0=lungx+2
  !--parte finele e scrittura su area jrel temporanea                           
                             if(jcif.eq.0) then
                                write(jrel,'(a)')linea(1:lung0)        ! stampa su jrel
                             else
                                do jli=1,5,2
                                   string='.'
                                   inext=1
                                   call acodNEW(inext,li(jli+1),
     *                                           string)           
                                   linea(lung0:lung0+inext)=
     *                                            string(1:inext)
                                   lung0=lung0+inext+2
                                enddo   
                                linea(lung0:lung0+3)='yes'
                                call shift(linea,lungx)
                                write(jrel,'(a)')linea(1:lungx)
                             endif
                          else
!-- distanze contatto-------------------------------------------
                             tau=d
                             std=cova
                             if(nodisth.eq.1.and.nzjn.gt.1.
     *                          and.nzjl.gt.1)then
                                call xnumst(tau,std,2,string,lstr)
                                li(1)=jn
                                li(2)=1555     ! sempre 1555
                                li(3)=jl
                                li(4)=lintr
                                linea2=' '
                                lung0a=1 
                                if(jcif.eq.0) then
!--stampa supplementary material                                
                                   do jli=1,3,2
                                      iin=li(jli)
                                      call shift(aLab(iin),leng)
                                      inext=lung0a+leng
                                      linea2(lung0a:inext)=
     *                                           aLab(iin)(1:leng)
                                      call acodNEW(inext,li(jli+1),
     *                                           linea2)
                                      lung2=inext           
                                      if(inext.lt.lung0a+lengx) 
     *                                           lung2=lung0a+lengx
                                      if(jli.eq.1)then
                                         linea2(lung2:lung2+1)='- '
                                      endif
                                      lung0a=lung2+2
                                   enddo
                                   linea2(lung2:lung2+2)=jph(1:3)
                                   lung2=lung2+2
                                   lung0a=max0(25,lung2)
                                   linea2(lung0a:lung0a+lstr)=
     *                                         string(1:lstr)
                                   lungx=lung0a+lstr
                                   write(lo,'(a)')linea2(1:lungx)
                                else
!--stampa CIF                                
                                   do jli=1,3,2
                                      iin=li(jli)
                                      linea2(lung0a:lung0a+lengx)=
     *                                     aLab(iin)(1:lengx)
                                      lung0a=lung0a+lengx+2
                                   enddo   
                                   lung0a=max0(lung0a,17)   
                                   linea2(lung0a:lung0a+lstr)=
     *                                         string(1:lstr)
                                   lung0a=lung0a+lstr+2
                                   do jli=1,3,2
                                      string='.'
                                      inext=1
                                      call acodNEW(inext,li(jli+1),
     *                                              string)           
                                      linea2(lung0a:lung0a+inext)=
     *                                               string(1:inext)
                                      lung0a=lung0a+inext+2
                                   enddo   
                                   linea2(lung0a:lung0a+3)='yes'
                                   call shift(linea2,lungx)
                                   write(ncpu,'(a)')linea2(1:lungx)
c                                   write(lo,'(a)')linea2(1:lungx)
                                   ili=0
                                endif
                             endif  
                          endif       
                       endif         ! fine calcolo e stampa inter=1
 !                      
                       if(jangle.ne.0) then
!--memorizzo atomi entro la distanza richiesta
                          nato = nato+1
                          AngleParz(1 ,nato)=jl
                          AngleParz(2 ,nato)=d
                          AngleParz(3 ,nato)=p
                          AngleParz(4 ,nato)=q
                          AngleParz(5 ,nato)=r
                          AngleParz(6 ,nato)=lintr
                          AngleParz(7 ,nato)=0           ! not more used
                          AngleParz(8 ,nato)=x2(1)
                          AngleParz(9 ,nato)=x2(2)
                          AngleParz(10,nato)=x2(3)
                          AngleParz(11,nato)=s2(1)
                          AngleParz(12,nato)=s2(2)
                          AngleParz(13,nato)=s2(3)
                       endif
                       if(jangle.ge.0.and.inter.ne.1) then
!--stampo distanza           
                          iprint=1
                          if(jflagA.eq.1.and.inter.ne.1) then
                             if(jll.gt.jllX) then 
                                iprint=0            
                             endif
                          endif
                          if(iprint.eq.1) then
                             string=' '
                             call xnumst(d,cova,2,string,lstr)
                             kinea(lengx+1:80)=' '
                             kinea(lengx+1:lengx+2)=' -'
                             j2 = lengx+4
                           call slineaNEW(aLab(jl),lengx,j2,inext,kinea)
                             call acodNEW(inext,lintr,kinea)
!---- atom code: label(+sy,l,+x,+y,+z)
!---- maximum 22 characters    
                             write(lo,200) kinea(1:31),
c     1 	                               (x2(i),i=1,3),d,cova
     1 	                               (x2(i),i=1,3),string(1:lstr)
  200                        format(1x,a31,3f8.4,3x,a)
                          endif
                       endif
!--end of cell translations
c                       call XTimeOUT(3)
                    enddo
                 enddo
              enddo
!--fine loop on symmetry operations
           enddo
!--end of second loop on the atom list
c           call XTimeOUT(2)
         enddo
!--check se devono essere calcolati gli angoli
         if (jangle.ne.0) then
!--loop di calcolo degli angoli tra atomi entro la distanza richiesta
!         ld = mnfl
            do jm1=1,nato-1
               jlx=AngleParz(1 ,jm1)
               x2(1:3)=AngleParz(8 :10,jm1)
               s2(1:3)=AngleParz(11:13,jm1)
               lintr=AngleParz(6 ,jm1)
!--preparo prima parte della linea di stampa
               j3=1
               kinea=' '
               call slineaNEW(aLab(jlx),lengx,j3,inext,kinea)
               call acodNEW(inext,lintr,kinea)
               kinea(inext+2:inext+2)='-'
c               j3 = 24
               j3 = inext + 4
               call slineaNEW(aLab(jn),lengx,j3,inext,kinea)
               kinea(inext+2:inext+2)='-'
               inexta =inext + 4
!--fine prima parte della linea di stampa
               do jm2=jm1+1,nato
                  jly=AngleParz(1 ,jm2)
                  x3(1:3)=AngleParz(8 :10,jm2)
                  s3(1:3)=AngleParz(11:13,jm2)
                  lintr=AngleParz(6 ,jm2)
!--preparo seconda parte della linea di stampa
                  j3=inexta
                  kinea(j3:80)=' '
                  call slineaNEW(aLab(jly),lengx,j3,inext,kinea)
                  call acodNEW(inext,lintr,kinea)
!--fine seconda parte della linea di stampa
!--controlla stessa posizione per x2 e x3
                  ieguale=0
                  do i=1,3
                     if(abs(x2(i)-x3(i)).le.0.00001) ieguale=ieguale+1
                  enddo
                  if(ieguale == 3) goto 4190
!---- check null value for angle
c             if((AngleParz(3,jm1)-AngleParz(3,jm2)).gt.0.00001)goto 4260
c             if((AngleParz(4,jm1)-AngleParz(4,jm2)).gt.0.00001)goto 4260
c             if((AngleParz(5,jm1)-AngleParz(5,jm2)).le.0.00001)goto 4110
c 4260             continue
                  if(AngleParz(2,jm1).le.0.00001)goto 4110
                  if(AngleParz(2,jm2).gt.0.00001)goto 4130
 4110             continue
                  teta = 0.0
                  go to 4020
 4130             continue
!---- angle calculation
                  call anamp(xgg,x1,x2,x3,teta)
 4020             continue
                  ang = teta*rad
                  std=0.0
                  sum1=0.0
                  sum2=0.0
                  sum3=0.0
                  do j=1,3
                     sum1=sum1+s1(j)
                     sum2=sum2+s2(j)
                     sum3=sum3+s3(j)
                  enddo
                  n3jn = iabs(nzTot(jn))
                  n3jlx= iabs(nzTot(jlx))
                  n3jly= iabs(nzTot(jly))
                  if(sum1.le.0.0.and.no(n3jn).eq.1) goto 4051
                  if(sum2.le.0.0.and.no(n3jlx).eq.1) goto 4051
                  if(sum3.le.0.0.and.no(n3jly).eq.1) goto 4051
                  call anstd (xgg,x1,x2,x3,s1,s2,s3,teta,detet)
                  std = detet*rad
 4051             continue
                  string=' '
                  call xnumst(ang,std,2,string,lstr)
c                  write(lo,300)  kinea(1:34),ang,std
c  300             format (4x,a34,2f8.3)
                  write(lo,300)  kinea(1:34),string(1:lstr)
  300             format (4x,a34,3x,a)
 4190             continue
               enddo
            enddo
!--end of loop of angle calculation
         endif
!--end of first loop on the atom list
      enddo
c**********************************
!
      if (inter == -2) then                        ! gianluca 05/01/10
           SmallIt(1) = ' '                        ! gianluca 05/01/10
           write(SmallIt(1), '(f8.3)') d           ! gianluca 05/01/10
           SmallIt(1)(9:9) = char(0)               ! gianluca 05/01/10
      endif                                        ! gianluca 05/01/10
!
      if(inter.eq.1)then
          if(nangh.gt.0) then
             rewind jrel
             if(jcif.eq.0) then
                write(lo,'(a)')'  '
                write(lo,'(a)')' H-Bond(s) Geometry '
                write(lo,'(a)')'  '
             else
                write(ncpu,1353)
1353	          format('  ',/,'  ',/,
     1              'loop_',/,
     1              '_geom_hbond_atom_site_label_D',/,
     2              '_geom_hbond_atom_site_label_H',/,
     2              '_geom_hbond_atom_site_label_A',/,
     3              '_geom_hbond_distance_DH',/,
     3              '_geom_hbond_distance_HA',/,
     3              '_geom_hbond_distance_DA',/,
     3              '_geom_hbond_angle_DHA',/,
     4              '_geom_hbond_site_symmetry_D',/,
     4              '_geom_hbond_site_symmetry_H',/,
     4              '_geom_hbond_site_symmetry_A',/,
     6              '_geom_hbond_publ_flag',/)
             endif
             do i=1,nangh
                read(jrel,'(a)')linea
                call shift(linea,lung2)
                if(jcif.eq.0) then
                   write(lo,'(a)')linea(1:lung2)
                else
                   write(ncpu,'(a)')linea(1:lung2)
c                   write(lo,'(a)')linea(1:lung2)
                endif
             enddo
          endif
          close(jrel,status = 'delete')
!      
      endif
!--stampa operatori di simmetria      
      if(iprGS.eq.1) then
c      write(lo,'(1h )')
      write(lo,'(/,a)')' Symmetry Operations '
      do i=1, nsymTot
         k = Lung(SymmStrings(i))
         write(lo,'(1x,i5,1h),3x,a)') i, SymmStrings(i)(1:k)
      enddo
      endif
      write(lo,'(1h )')
      return
      end
!
!code for longconnNEW
      subroutine longconnNEW(ifrag)
!--crea la tabella di connet. lunga, per tutti gli atomi  con passo 12
!
      USE GENERAL
      USE Atomi
      USE Molcom
      USE HydroStuff
      USE BuildStuff
      USE BuildModule      
!
!--da jconn  crea la conn. lunga  in lconlun(12,Maxatoms)  
! se ifrag==0 in lconlun ci sono tutti gli atomi
! se ifrag=n.gt.0 in lconlun ci sono solo gli atomi del frammento n
!---lconlun(1,nord)=nord
!---lconlun(2,nord  )=nleg
!---lconlun(3:10,nord  )=nord degli atomi legati
!
      lconlun(:,:)=0
      ncopie=jconn(1)
      ll=1+ncopie*3             
      do i=2,ll,3
         j1=jconn(i)
         j2=jconn(i+1)
         j3=jconn(i+2)      !j3<0 legame deleted dall'utente
         nleg1=lconlun(2,j1)
         nleg2=lconlun(2,j2)
         if(j3.lt.0.or.nleg1.ge.10.or.nleg2.ge.10) cycle  
         jfra=mod(izpk(j1),nzConst)
         if(ifrag.eq.0)jfra=0
         if(iabs(jfra).ne.ifrag) cycle
         k=0
         do while (k.lt.2)
               lconlun(1,j1)=j1
               lconlun(2,j1)=lconlun(2,j1)+1
               leg=lconlun(2,j1)
               if(leg.gt.1)then
                  do ii=1,leg-1
                     ia=lconlun(2+ii,j1)
                     if(j2.le.ia)then
                        lconlun(2+ii,j1)=j2
                        j2=ia
                     endif
                  enddo
               endif
               lconlun(2+leg,j1)=j2
               if(k.le.1)then
                  k=k+1
                  j2=jconn(i)
                  j1=jconn(i+1)
               endif
         enddo
      enddo
      kpri=0
      if(kpri.eq.1)then
      write(lo,*)'LongConnNew '
      do i=1,Nats
      write(lo,'(i4,i9,12i6)')i,lconlun(1:12,i)
      enddo
      endif
      return
      end
!
!code for conecsym1NEW
      subroutine conecsym1NEW(madre, iniz)
      USE General
      USE Atomi
      USE Symmetry
      USE HydroStuff
      USE BuildModule
      USE Molcom
!
!-- include nella longcon gli atomi equiv. legati ad ogni atomo
!-- esclude (ibridc(i)=99) gli atomi che hanno legami troppo corti
!-- d<1.1 che vengono storizzati in idisorder(3000)
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c      common/xbaco/natsSymm,noptable(100),nopt,vett(3,4)
      dimension yx(3,200),x(3),y(3),yy(3),z(3),iseg(2)
     1 ,d(3),d2(3),sss(3)
      character*2 iwatch
      data iwatch/'h '/
      read(iwatch,'(a2)')nameh
!--
!-- madre=1   genhy
!-- madre=2   geom
!
      NatsSymm=iniz
      madreseg=-1
      if(madre.eq.2)then
         nz30(:)=0
         ibtab(:,:)=0
         madreseg=1
      endif
      e10=1.0e-10
      jdisor=0
      iseg(1)=1
      iseg(2)=-1
      ifin=icent+1
      do k=1,nats
         if(madre.eq.1.and.nz30(k).eq.1) cycle
         if(nzTot(k).eq.0) cycle    !esclude i ghost
         z(1:3)=xyzs(1:3,k)
c         write(lo,'(i4,1h*,i8,12i6)')k,lconlun(1:12,k)
         do kk=1,nats
            if(madre.eq.1)then  ! salta gli H generati da genhy
               if(nz30(kk).eq.1.and.iGeomAtom(kk).eq.1)cycle
            endif
            if(nzTot(kk).eq.0) cycle    !esclude i ghost
            x(1:3)=xyzs(1:3,kk)
            mg1=nzTot(k)
            mg2=nzTot(kk)
            dmax=BondTable(2,mg1,mg2)
            mm0=1
            yx(1:3,mm0)=x(1:3)
c            if(k.eq.2.and.kk.eq.13) 
c     *        write(lo,'(2i5,1h$,3f10.4)')k,kk,yx(1:3,mm0)
            do kt=1,nsymTot
               ieqX=0
               call  xequiTot(kt, x, yy,ieqX)
               if(ieqX.eq.1.or.kt.eq.1) cycle
!               if(kt.eq.1.and.k.eq.kk) cycle ! escludo atomi asim uguali
               mm0=mm0+1
               yx(1:3,mm0)=yy(1:3)
c               if(k.eq.2.and.kk.eq.13) 
c     *           write(lo,'(3i5,1h$,3f10.4)')kk,kt,mm0,yx(1:3,mm0)
               mm=mm0-1
               if(mm.gt.0)then
                  do n=1,mm
c                     if(k.eq.2.and.kk.eq.13) 
c     *                write(lo,'(3i5,1h@,3f10.4)')kt,mm0,n,yx(1:3,n)
                     d2(1:3)=yy(1:3)-yx(1:3,n)
                     call reddst(d2,sss)
                     distt=cdist(gdist,d2,dist2)
c                     if(k.eq.2.and.kk.eq.13) 
c     *               write(lo,'(3i5,1h@,4f10.4)')kt,mm0,n,sss(1:3),distt
                     if(distt.lt.0.1)then
                        mm0=mm0-1
                        exit
                     endif
                  enddo
               endif
               if(distt.lt.0.1)cycle
               sss(1:3)=0   
               d(1:3)=z(1:3)-yy(1:3)
               call reddst(d,sss)
               dist0=cdist(gdist,d,dist2)
               if(dist0.lt.0.001)cycle
!               if(dist0.lt.0.001.and.k.eq.kk)cycle
!              write(lo,'(a,i3,3f6.3,i3,f4.0,3f6.3,i3,2f6.3)')
!     1             'kk,x,ksym,coef,yy,kt,dist2,dist0',
!     1              kk,x,ksym,coef,yy,kt,dist2,dist0
               if(dist0.gt.dmax)cycle
               if(madre.eq.1.and.dist0.lt.1.10)disorder=dist0
               do nnn=1,3
                  if(abs(d(nnn)).lt.e10)d(nnn)=sign(e10,d(nnn))
               enddo
c                     if(k.eq.2.and.kk.eq.13) 
c     *             write(lo,'(3i5,1h#,6f10.4)')k,kk,kt,yy(1:3),sss(1:3)
               NatsSymm=NatsSymm+1  
               xyz15(1:5,NatsSymm)=xyzs(1:5,kk)
               xyz15(1:3,NatsSymm)=yy(1:3)+sss(1:3)
               xyz30(1:3,NatsSymm)=xyzs_dev(1:3,kk)
               iEqui(NatsSymm)=kk
               istras=cistras(sss) 
               nop2 = kt*1000 + istras 
               nOpEq(NatsSymm)=nop2        !memorizza codice
!              write(lo,*)'storiz. kk,NatsSymm ',kk,NatsSymm,xyz15(1:3,NatsSymm)
!--controlla se gia esiste nella conect.
               ist=lconlun(2,k)
               kigual=-1
               if(ist.ge.0.and.ist.le.10)then
                  if(ist.gt.0)then
                     kigual=0
                     do nny=3,2+ist
                        if(-kk.eq.lconlun(nny,k))then
                           lconlun(nny,k)=-NatsSymm
                           kigual=1
                        endif
                        if(kigual.eq.1)exit  
                     enddo
                  endif
               endif
!--inserisce nella conect.
               if(ist.le.9.and.kigual.eq.0)then
                  lconlun(1,k)=k
                  lconlun(2,k)=ist+1
                  lconlun(3+ist,k)=madreseg*NatsSymm
               endif
               if(natsSymm.ge.MaxAtoms)then
                  ifWarn=1
                  Msg=' '
                  write(Msg,11)
                  call MsgWinErr('Warning',Msg,WARN_WINDOW,iExitC)
                  ifWarn=0
                  ier=-1
11                format(' Too much atoms in equivalent position')
                  return
               endif
            enddo
         enddo
c         write(lo,'(i4,1h*,i8,12i6)')k,lconlun(1:12,k)
      enddo
      kpri=0
      if(kpri.eq.1)then
      write(lo,*)'ConecSym1New '
c      write(lo,'(9i8)')noptable(1:9)
      do i=1,NatsSymm
      write(lo,'(i4,3f8.3,2i6)')i,xyz15(1:3,i),iEqui(i),nOpEq(i)
      enddo
      do i=1,NatsSymm
      write(lo,'(i4,i9,12i6)')i,lconlun(1:12,i)
      enddo
      endif
      return
      end
!
!code for slineaNEW
      subroutine slineaNEW(vetch,nx,istart,inext,linea)
!--insert in the printing buffer
!
!  vetch   atom name  
!  nx      maximum lenght (in character)  of the name
!  istart  address in the buffer
!  inext   next free address in the buffer
!  linea : printing character buffer
!
      USE GENERAL
!
      character*16 vetch
      character*(*) linea
      character*40 AtName
!--
      write(AtName,'(a)')vetch
      call ucase(AtName)
      read(AtName,'(a)')vetch
      call shift(vetch,l)
      if(l.gt.nx) l=nx
      linea(istart:istart+l-1)=vetch(1:l)
      inext=istart+l
      return
      end
!
!code for AllineaNumb
      subroutine AllineaNumb(icar,linea,nlen,npos1)
!--allinea il vettore contenete un numero floating 
!  aggiungendo davanti i carattri necessari
!
!  icar carattere da aggiungere
!  linea  stringa contenete il numero floating
!  nlen  lunghezza della stringa
!  npos  posizione del '.' nella stringa
!
      character*1 icar,ipointe,par
      character*(*) linea
      character*40 lineax
      data ipointe/'.'/,par/'('/
!
      npos=npos1
      i=index(linea,ipointe)
      if(i.le.0) then
         i1=index(linea,par)
         if(i1.le.0) then
            i1=npos
         endif
         i=i1
      endif
      n=0
      if(i.lt.npos) then
         n=npos-i
         lineax(1:1)=icar
         if(n.gt.1) then
            do j=1,n-1
               lineax=lineax(1:j)//icar
            enddo      
         endif
         linea=lineax(1:n)//linea(1:nlen)
      endif
      nlen=nlen+n
      return
      end       
!
!code for acodNEW
      subroutine acodNEW(j,icod,ivet)
!---- tranform atomic code in alphanumeric characters
!     icod is code n555
!     ivet is the output vector for printing
!     icod = n.op.sym *1000 + jtx*100 + jty*10 +jtz
!-----
      USE Geometry
!      
      character*(*) ivet
      character*10 ibuf
      dimension jt(4)
!--      
      if(icod.eq.1555) return
      if(jcif.eq.0) then
         ivet(j:j) = '.'
         j = j+1
      endif
      jt(1)=icod/1000
      ir=mod(icod,1000)
      jt(2)=ir
      do i=1,2
         ix = jt(i)
         write(ibuf,'(i5)')ix
         call shift(ibuf,lbu)
         ivet(j:j+lbu-1)=ibuf(1:lbu)
         j=j+lbu
         if(i.eq.1) then
            ivet(j:j) = '_'
            j = j+1
         endif
      enddo
      return
      end
!
!code for ShortLongDistancesNEW
      subroutine ShortLongDistancesNEW(iAction)
      USE General
      USE Atomi
      USE BuildStuff
      USE BuildModule
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workc/dx(4),icomc(196)
      common/xxhyd/lcon2
!
      ncwuSav = ncwu
      loSav = lo
      ncwu = iscra
      lo   = iscra
      jcod=-1
      jhost1=0
      jscre=0
      if (iAction == 1) jscre=1
      call CaosGeomNEW(jscre,jhost1,ier,jcod)
      dx(1:4)=0.0
!---------------------------------------------------      
!--jFlagAtom(:) indica atomi del primo loop
!--jFlagAtom1(:) indica atomi del secondo loop           
!--------------------------------------------------- 
      jFlagAtom(1:nats)=1     
      jFlagAtom1(1:nats)=jFlagAtom(1:nats)
!      
      if (iAction == 1) then
          inter=-1
          juno=1
          jangle=1
          iprGS=1
          write(lo,*) 'Short distances'
          call ziangNEW(inter,juno,jangle,iprGS)
      else
          inter=1
          juno=1
          jangle=0
          write(lo,*) 'Long distances'
          jconn=iconn
          ifrag=0
          iprGS=1
          call longconnNew(ifrag)  !ok
          call ziangNEW(inter,juno,jangle,iprGS)
      endif
      ncwu = ncwuSav
      lo = loSav
!
      return
      end
!
!code for SupMatGeomNEW
      subroutine SupMatGeomNEW    ! da eliminare
      end
!
!
!-----------------------------------------------------------------------
!--Calcoli Geometrici da grafica
!-----------------------------------------------------------------------
!
      subroutine Prepara_Calcoli()
      USE General
      USE Atomi
!
      write(Msg,30)
   30 format ('Geometric calculations')
      call UpdateCommonAndList5(ier)
          call PrintMess(Msg)
          nGroupsGeo   = 0
          jcod=-1
          jhost1=0
          jscre=1    ! legge atomi dello schermo
          call CaosGeomNew(jscre,jhost1,ier,jcod)
!          
      return
      end
!-----------------------------------------------------------------------
!
!code for fr5v2New
      subroutine fr5v2New(kptrc)
!--form a list type 25 
!
!  kptrc vettore contenente numero d'ordine atomi selezionati
!
      USE General
      USE Atomi
!
      dimension kptrc(*)
!--
      do n=1,nats25
         m5=kptrc(n)
         Adr25to5(n)=m5
         aLab25(n)=aLab(m5)
         xyzs25(1:5,n) = xyzs(1:5,m5)           
         xyzs25_dev(1:3,n) = xyzs_dev(1:3,m5)
      enddo
      return
      end
!
!code for fr6v2New
      subroutine fr6v2New(kptrc)
!--form a list type 26 
!
!  kptrc vettore contenente numero d'ordine atomi selezionati
!
      USE General
      USE Atomi
!
      dimension kptrc(*)
!--
      do n=1,nats26
         m5=kptrc(n)
         Adr26to5(n)=m5
         aLab26(n)=aLab(m5)
         xyzs26(1:5,n) = xyzs(1:5,m5)           
         xyzs26_dev(1:3,n) = xyzs_dev(1:3,m5)
      enddo
      return
      end
!
!code for printnats25
      subroutine printnats25
!--print a list type 25 
!
      USE General
      USE Atomi
!      
      write(lo,'(a)')'Coordinate lista 25'
      do n=1,nats25
         call shift(aLab25(n),nn)
         write(lo,'(a,2x,3f10.5)')aLab25(n)(1:nn),xyzs25(1:3,n)
      enddo
      return
      end
!
!code for printnats26
      subroutine printnats26
!--print a list type  26
!
      USE General
      USE Atomi
!      
      write(lo,'(a)')'Coordinate lista 26'
      do n=1,nats26
         call shift(aLab26(n),nn)
         write(lo,'(a,2x,3f10.5)')aLab26(n)(1:nn),xyzs26(1:3,n)
      enddo
      return
      end
!
!code for nomev2New
      subroutine nomev2New(illi,fn,nnam)
!--form the name
!
      USE GENERAL
!
      character*(*) nnam,illi
!
      character*80 buf,linea,linea1
!--
      call shift(illi,len)
      write(linea,'(f10.0)') fn
      n=index(linea,'.') 
      linea1=linea(1:n-1)
      call shift(linea1,l)
      nnam=' '
      nnam=illi(1:len)//linea1(1:l)
      return
      end
!
!code for FindPlane
      subroutine FindPlane(dire,lend)
!--trova il piano indicato
!  
      USE General
      USE Geometry
!
      character*(*) dire
!                
      do ka=1,NumPlane 
         call shift(LabPlane(ka),l)
         if(dire(1:lend).eq.LabPlane(ka)(1:l)) then
            NumPlaneCurr=NumPlaneCurr+1
            if(NumPlaneCurr.gt.2) NumPlaneCurr=2
            IndPlaneCurr(NumPlaneCurr)=ka
            return
         endif
      enddo
!--piano non trovato
!  Messaggio di errore      
!-------------------
      return
      end
!
!code for FindLine
      subroutine FindLine(dire,lend)
!--trova il piano indicato
!  
      USE General
      USE Geometry
!
      character*(*) dire
!                
      do ka=1,NumLine 
         call shift(LabLine(ka),l)
         if(dire(1:lend).eq.LabLine(ka)(1:l)) then
            NumLineCurr=NumLineCurr+1
            if(NumLineCurr.gt.2) NumLineCurr=2
            IndLineCurr(NumLineCurr)=ka
            return
         endif
      enddo
!--piano non trovato
!  Messaggio di errore      
!-------------------
      return
      end
!
!-----------------------------------------------------------------------
      subroutine calcolaNew(jscre,iAction, fcoe, ferr, ier)
!--main routine per calcoli geometrici da interfaccia grafica
!
!--stack delle chiamate:
!     ier = c_finish_define(geoAction, fort_coef, fort_err);
!     prepara_calcoli_();
!     finish_define_(&action, coef, ferr, &ier);
!     call calcola(jscre,iAction, fcoe, ferr, ier)
!
c  jscre 0 read atoms from disc (xfl05)
c        1 read atoms from screen (to_Plot)
c
!-- Definition of possible items
!     iAction =  1 --> Mean Quadratic Plane
!     iAction =  2 --> Quadratic Line
!     iAction =  3 --> Baricentrum
!     iAction =  4 --> Group of atoms
!     iAction =  5 --> Single atom
!-- selected atoms are in kptrc
!-- results have to be stored in fcoe(1:4) and ferr(1:4) for plane
!                                fcoe(1:6) and ferr(1:6) for line
!                                fcoe(1:3) and ferr(1:3) for baric
!     if iAction = 4 or 5, no calculation has to be performed...
!---------------------------------------------
!     iAction = 11 --> Distance
!     iAction = 12 --> Angle
!     iAction = 13 --> Perpendicular plane
!     iAction = 14 --> Torsion angle
!
!     items type   are in fcoe(1) & fcoe(9)
!     items serial are in fcoe(2) & fcoe(10)
! for items 1:3
!     items Plane: coeff. are in fcoe(3:6) & fcoe(11:14)
!     items Line : coeff. are in fcoe(3:8) & fcoe(11:16)
!     items Baricentrum : x,y,z in fcoe(3:5) & fcoe(11:13)
!     errors on coefficients are in ferr(1:6) for the first item
!     errors on coefficients are in ferr(7:12) for the second item
! for item 4
!     items Group :
!     pointer to iconn30 is in fcoe(3) & fcoe(11)
!            iconn30 contains: group number, number of atoms in the group,
!                              list of atoms, for each group
! for item 5
!     items Single:
!--------------- single item selected -----------------
!     fcoe(9) == 0   and fcoe(15) == limt on distance [0.8 - 3.0]
!
      USE General
      USE Atomi
      USE Geometry
      USE Molcom
!      
      character*60 vetch2
      character*16 nnam
      real fcoe(*),ferr(*)
      character *80 nomeFile, line
      character *11 items(5)
      character *8 azione(3)
!
      character*80 buf
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/workc/dx(4),icomc(196)
      dimension x1(3),x2(3)
      character*1  inno(4)
      data inno/'P','L','B','G'/
!
!      jscre=0
      ier = 0
      iprGeom=0
      npunti = 0
      do i=1, 1000
         if(kptrc(i).eq.0) exit
         npunti = npunti + 1
      end do
      nats25=npunti     
      NumPlaneCurr=0
      NumLineCurr=0
      jFlagAtom(1:nats)=0     
      jFlagAtom1(1:nats)=jFlagAtom(1:nats)
!
      items(1) = 'Plane'
      items(2) = 'Line'
      items(3) = 'Baricentrum'
      items(4) = 'Group of at'
      items(5) = 'Single atom'
      azione(1) = 'distance'
      azione(2) = 'angle'
      azione(3) = 'p. plane'
!-- open file for geometric calculations results
      nomeFile = 'tmp.tmp'
      itype = 0
      iform = 1
      jop = jopen(jrel, nomeFile, itype, iform, ierr)
      if (jop.eq.0) then
!-- recover previous results
          itype = 1
          iform = 1
          jop = jopen(iscra, ' ', itype, iform, ierr)
          do 
              read(jrel,'(a80)',end=10) line
              write(iscra,'(a80)') line
          enddo
   10     close(jrel)
      else
         write(Msg,9000) ierr,nomeFile(1:Lung(nomeFile))
         call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
         return
      endif
!
      ncwua=ncwu
      ncwua=lo
      ncwu=iscra
      lo=iscra
!--
      select case (iAction)
         case (1)                                !--piano pqm
!--		    write(iscra,100) items(iAction), nint(fcoe(1))
!--		    write(iscra,200) (Lab(kptrc(i)),i=1,npunti)
            call fr5v2New(kptrc)   ! crea pseudo lista 25 con gli atomi del piano 
            if(iprGeom.eq.1) call printnats25
            call nomev2New(inno(1),fcoe(1),nnam)  ! crea nome piano
            vetch2=' '
            iprint=0
            call cpqmNEW(nnam,vetch2,iprint)
            fcoe(1:4)=CoefPlane(1:4,NumPlane)
            ferr(1:4)=CoefPlane_dev(1:4,NumPlane)
         case (2)                               !--linea lqm
!--		    write(iscra,100) items(iAction), nint(fcoe(1))
!--		    write(iscra,200) (Lab(kptrc(i)),i=1,npunti)
            if(nats25.lt.2) then
               write(Msg,31)
   31          format ('Warning: Increase the number of atoms!')
               call PrintMess(Msg)
               write(lo,'(a35)') Msg
               ier = -1     !!mr
               goto 2000     ! exit
            endif
            call fr5v2New(kptrc)
            if(iprGeom.eq.1) call printnats25
            call nomev2New(inno(2),fcoe(1),nnam)
            call crqmNEW(nnam,vetch2)
            fcoe(1:3)=CoefLineXG(1:3,NumLine)
            ferr(1:3)=CoefLineXG_dev(1:3,NumLine)
            fcoe(4:6)=CoefLineU(1:3,NumLine)
            ferr(4:6)=CoefLineU_dev(1:3,NumLine)
         case (3)                                     !--baricentro
!--		    write(iscra,100) items(iAction), nint(fcoe(1))
!--		    write(iscra,200) (Lab(kptrc(i)),i=1,npunti)
            call fr5v2New(kptrc)
            if(iprGeom.eq.1) call printnats25
            call nomev2New(inno(3),fcoe(1),nnam)
            call cpmNEW(nnam,x1,x2)
            fcoe(1:3)=x1(1:3)
            ferr(1:3)=x2(1:3)
            fcoe(4)=0.0
            ferr(4)=0.0
         case (4)
!--		    write(iscra,100) items(iAction), nint(fcoe(1))
            write(iscra,103)  nint(fcoe(1))
            write(iscra,200) (Lab(kptrc(i)),i=1,nats25)
            write(iscra,'(1h )')
            kk = 1
            if (nGroupsGeo.gt.0) then
                do i=1,nGroupsGeo
                   kk = kk + iconn30(kk+1) + 2
                enddo
            endif
            iconn30(kk) = nint(fcoe(1))
            iconn30(kk+1) = nats25
            kk = kk+1
            do i=1,nats25
               iconn30(i+kk) = kptrc(i)
            enddo
            nGroupsGeo = nGroupsGeo + 1
            fcoe(1) = nats25
         case (5)                                     ! single atom
!--		    write(iscra,100) items(iAction), nint(fcoe(1))
            write(iscra,104)  nint(fcoe(1))
            write(iscra,200) (Lab(kptrc(i)),i=1,nats25)
            fcoe(1) = kptrc(1)
            nSingleAtoms = nSingleAtoms + 1
            iconn15(nSingleAtoms) = kptrc(1)
!            
!--iAction = 11,12 --> Distance or Angle
         case (11,12)                                 !--distances or angles
!--		    write(iscra,300) azione(iAction-10)
            jstep = 1
            nats25=0
            nats26=0
            do nitem=1,2
               j1 = nint(fcoe(jstep))
               if (j1.eq.1) then                               !--piano
!			       write(iscra,400) items(j1), nint(fcoe(jstep+1)),
!    *					(fcoe(i),i=2+jstep,5+jstep)
                   icodpl=j1
                   call nomev2New(inno(j1),fcoe(jstep+1),nnam)
                   call shift(nnam,lend)
                   call FindPlane(nnam,lend)
               elseif (j1.eq.2) then                           !--linea
!			       write(iscra,400) items(j1), nint(fcoe(jstep+1)),
!    *					(fcoe(i),i=2+jstep,7+jstep)
                  icodpl=j1
                   call nomev2New(inno(j1),fcoe(jstep+1),nnam)
                   call shift(nnam,lend)
                   call FindLine(nnam,lend)
               elseif (j1.eq.3) then                            !--Baricentro
!  	             write(iscra,400) items(j1), nint(fcoe(jstep+1)),
!    *					(fcoe(i),i=2+jstep,5+jstep)
                   call nomev2New(inno(3),fcoe(jstep+1),nnam)
                   if(nats25.eq.0) then
                      nats25=1
                      Adr25to5(1)=0
                      aLab25(1)=nnam
                      xyzs25(1:3,1) = fcoe(jstep+2:jstep+4)
                      xyzs25_dev(1:3,1) = 0.0
                      if(iprGeom.eq.1) call printnats25
                   else
                      nats26=1
                      Adr26to5(1)=0
                      aLab26(1)=nnam
                      xyzs26(1:3,1) = fcoe(jstep+2:jstep+4)
                      xyzs26_dev(1:3,1) = 0.0
                      if(iprGeom.eq.1) call printnats26
                   endif
               elseif (j1.eq.4) then                         !--gruppo di atomi
                   kserial = nint(fcoe(jstep+1))
                   kk = 1
                   if (kserial.gt.1) then
                       do i=1,kserial-1
                          kk = kk + iconn30(kk+1) + 2
                       enddo
                   endif
                   npunti  = iconn30(kk+1)
                   iniz = kk + 2
                   ifin = kk + 2 + npunti - 1
!			       write(iscra,500) items(j1), kserial, npunti
!			       write(iscra,600) (Lab(iconn30(i)),i=iniz,ifin)
                   fcoe(jstep+2) = kk
                   ii=1
                   do i=iniz,ifin
                      kptrc(ii)= iconn30(i)
                      ii=ii+1
                   enddo
                   if(nats25.eq.0) then
                      nats25=npunti
                      call fr5v2New(kptrc)
                      if(iprGeom.eq.1) call printnats25
                   else
                      nats26=npunti
                      call fr6v2New(kptrc)
                      if(iprGeom.eq.1) call printnats26
                   endif
               elseif (j1.eq.5) then                       !--atomo singolo
                   kserial = nint(fcoe(jstep+1))
                   npunto  = iconn15(kserial)
!			       write(iscra,700) items(j1), kserial,Lab(npunto)
!--		           fcoe(jstep+2) = npunto
                   kptrc(1)= npunto
                   if(nats25.eq.0) then
                      nats25=1
                      call fr5v2New(kptrc)
                      if(iprGeom.eq.1) call printnats25
                   else
                      nats26=1
                      call fr6v2New(kptrc)
                      if(iprGeom.eq.1) call printnats26
                   endif
               endif
               jstep = 9
            enddo
            if(iAction.eq.11) then                     !--distances
               if(nats25.eq.0) then
                  write(Msg,30)
   30             format ('Warning: Operation not allowed!')
                  call PrintMess(Msg)
                  write(lo,'(a35)') Msg
                  ier = -1     !!mr
                  goto 2000     ! exit
               endif
               if(NumPlaneCurr.eq.1) then
                  call cdpaNEW
                  goto 2000     ! exit
               endif 
               if(NumLineCurr.eq.1) then
                  call cdraNEW
                  goto 2000     ! exit
               endif
               if(nats26.eq.0.and.nats25.eq.0) then
                  write(Msg,30)
                  call PrintMess(Msg)
                  write(lo,'(a35)') Msg
                  ier = -1     !!mr
                  goto 2000     ! exit
               endif
               jangle=0
               juno=1
               if(nats26.gt.0) juno=2
               call DistAng2526(juno,jangle)
            else if(iAction.eq.12) then                  !--angoli
               if(NumPlaneCurr.eq.2) then
                  call cappNEW
                  goto 2000     ! exit
               endif
               if(NumLineCurr.eq.2) then
                  call callcxNEW
                  goto 2000     ! exit
               endif
               if(NumPlaneCurr.eq.1.and.NumLineCurr.eq.1) then
                  call carpxNEW
                  goto 2000     ! exit
               endif
               if(nats25.eq.0.and.nats26.eq.0) then
                  write(Msg,30)
                  call PrintMess(Msg)
                  write(lo,'(a35)') Msg
                  ier = -1     !!mr
                  goto 2000     ! exit
               endif
               jangle=-1
               juno=1
               if(nats26.gt.0) juno=2
               call DistAng2526(juno,jangle)
            endif
!            
!--iAction = 13 --> Perpendicular plane
         case (13)                                 !--Perpendicular plane
!--		    write(iscra,300) azione(iAction-10)
            jstep = 1
            nats25=0
            nats26=0
            do nitem=1,2
               j1 = nint(fcoe(jstep))
               if (j1.eq.2) then                               !--linea
!			       write(iscra,400) items(j1), nint(fcoe(jstep+1)),
!    *					(fcoe(i),i=2+jstep,7+jstep)
                  icodpl=j1
                   call nomev2New(inno(j1),fcoe(jstep+1),nnam)
                   call shift(nnam,lend)
                   call FindLine(nnam,lend)
               elseif (j1.eq.3) then                            !--Baricentro
!  	             write(iscra,400) items(j1), nint(fcoe(jstep+1)),
!    *					(fcoe(i),i=2+jstep,5+jstep)
                   call nomev2New(inno(3),fcoe(jstep+1),nnam)
                   if(nats25.eq.0) then
                      nats25=1
                      Adr25to5(1)=0
                      aLab25(1)=nnam
                      xyzs25(1:3,1) = fcoe(jstep+2:jstep+4)
                      xyzs25_dev(1:3,1) = 0.0
                      if(iprGeom.eq.1) call printnats25
                   else
                      nats26=1
                      Adr26to5(1)=0
                      aLab26(1)=nnam
                      xyzs26(1:3,1) = fcoe(jstep+2:jstep+4)
                      xyzs26_dev(1:3,1) = 0.0
                      if(iprGeom.eq.1) call printnats26
                   endif
               elseif (j1.eq.5) then                       !--atomo singolo
                   kserial = nint(fcoe(jstep+1))
                   npunto  = iconn15(kserial)
!			       write(iscra,700) items(j1), kserial,Lab(npunto)
!--		           fcoe(jstep+2) = npunto
                   kptrc(1)= npunto
                   if(nats25.eq.0) then
                      nats25=1
                      call fr5v2New(kptrc)
                      if(iprGeom.eq.1) call printnats25
                   else
                      nats26=1
                      call fr6v2New(kptrc)
                      if(iprGeom.eq.1) call printnats26
                   endif
               endif
               jstep = 9
            enddo
            if(nats25.gt.0.and.NumLineCurr.gt.0) then
               call nomev2NEW(inno(1),fcoe(1),nnam)
               vetch2=' '
               call cpnrNEW(nnam,vetch2)
               fcoe(1:4)=CoefPlane(1:4,NumPlane)
               ferr(1:4)=CoefPlane_dev(1:4,NumPlane)
            endif
!            
!-- iAction = 14 --> Torsion angle
         case (14)                                 !--Torsion angle
!--		    write(iscra,300) azione(iAction-10)
            j1  = nint(fcoe(1))
            if(j1.eq.4) then                         !--gruppo di atomi
               kserial = nint(fcoe(2))
               kk = 1
               if(kserial.gt.1) then
                  do i=1,kserial-1
                     kk = kk + iconn30(kk+1) + 2
                  enddo
               endif
               npunti  = iconn30(kk+1)
               iniz = kk + 2
               ifin = kk + 2 + npunti - 1
!			   write(iscra,500) items(j1), kserial, npunti
!			   write(iscra,600) (aLab(iconn30(i)),i=iniz,ifin)
               fcoe(3) = kk
               ii=1
               do i=iniz,ifin
                  kptrc(ii)= iconn30(i)
                  ii=ii+1
               enddo
               nats25=npunti
               call fr5v2New(kptrc)
               if(iprGeom.eq.1) call printnats25
               call ctorNEW
            else
               write(Msg,30)
               call PrintMess(Msg)
               write(lo,'(a35)') Msg
               ier = -1          !!mr
               goto 2000     ! exit
           endif
      end select 
2000  continue        
      lo=ncwua
      ncwu=ncwua
      rewind iscra
      itype = 0
      iform = 1
      jop = jopen(jrel, nomeFile, itype, iform, ierr)
      do 
         read(iscra,'(a80)',end=20) line
         write(jrel,'(a80)') line
      enddo
   20 close(iscra)
      close(jrel)
!
      return
  100 format(a11,' #',i3,' defined by the following atoms:')
  103 format(/,'Group of atoms: G',i3,
     *  ' defined by the following atoms:')
  104 format(/,'Single atom: S',i3,' defined by the atom:')
  101 format(a11, ' by the following atoms:')
  102 format(a11,'#',i3,'  Coeff.: ',4f10.4,/)
  200 format(10a8)
  300 format('Computed ',a8,' between the following items:',/,
     *       a11,'#',i3,'  Coeff.: ',4f10.4,/,
     *       a11,'#',i3,'  Coeff.: ',4f10.4,/)
  400 format(a11,'#',i3,'  Coeff.: ',4f10.4)
  500 format(a11,'#',i3,', number of atoms = ',i3,': ',4f10.4)
  600 format(10a8)
  700 format(a11,'#',i3,', atom: ',a8)
 9000 format(' Open error, code =',i5,' file is ',a)
      end
!
!-----------------------------------------------------------------------
!--routine da PLOT2006.f
!-----------------------------------------------------------------------
c
code for vrgv
      subroutine vrgv(ve,c,vu)
c**moltiplicazione di una matrice 3x3 ed un vettore a 3
c  componenti
      dimension ve(3),c(3,3),vu(3)
c
      do i=1,3
      vu(i)=0.0
      do j=1,3
      vu(i)=vu(i)+c(i,j)*ve(j)
      enddo
      enddo
      return
      end
c
code for orcor
      subroutine orcor(xo,yo,zo,c,xn,yn,zn)
c**fornisce le coordinate atomiche ortogonalizzate
      dimension c(3,3)
c
      xn=c(1,1)*xo+c(1,2)*yo+c(1,3)*zo
      yn=c(2,1)*xo+c(2,2)*yo+c(2,3)*zo
      zn=c(3,1)*xo+c(3,2)*yo+c(3,3)*zo
      return
      end
c
code for mxmxm
      subroutine mxmxm(c1,c2)
c**prodotto righexcolonne
c
      dimension c1(3,3),c2(3,3),c3(3,3)
c
      do 5 i=1,3
      do 5 j=1,3
      c3(i,j)=0.0
      do 5 k=1,3
      c3(i,j)=c3(i,j)+c1(i,k)*c2(k,j)
    5 continue
      do 10 i=1,3
      do 10 j=1,3
      c2(i,j)=0.0
      do 10 k=1,3
      c2(i,j)=c2(i,j)+c3(i,k)*c1(j,k)
   10 continue
      return
      end
c
code for prodm
      subroutine prodm(a,b,prod)
c-- rows x coloumns
      dimension a(3,3),b(3,3),prod(3,3)
c
      do i=1,3
      do j=1,3
      prod(i,j)=0.
      enddo
      enddo
      do k=1,3
      do i=1,3
      do j=1,3
      prod(k,i)=prod(k,i)+a(k,j)*b(j,i)
      enddo
      enddo
      enddo
      return
      end
c
code for seq
      subroutine seq(i,j,k)
c--
      j=mod(i,3)+1
      k=mod(i+1,3)+1
      end
c
code for normer
      subroutine normer(vt,am,vtn)
c**normalizzazione di un vettore
      dimension vt(3),am(3,3),vtn(3)
c
      vtvt=0.0
      do i=1,3
      do j=1,3
      vtvt=vtvt+vt(i)*vt(j)*am(i,j)
      enddo
      enddo
      if(vtvt.le.0.0) then
      do i=1,3
      vtn(i)=0.0
      enddo
      return
      endif
      cost=sqrt(vtvt)
      do i=1,3
      vtn(i)=vt(i)/cost
      enddo
      return
      end
c
code for prodv
      subroutine prodv(dt,am,ar,v1,v2,vr3,v3)
c**calcola il prodotto vettoriale
      dimension v1(3),v2(3),v3(3),am(3,3),ar(3,3),vr3(3)
c
      do i=1,3
      call seq(i,j,k)
      vr3(i)=(v1(j)*v2(k)-v1(k)*v2(j))/dt
      enddo
      call vrgv(vr3,ar,v3)
      return
      end
c
code for lngto
      subroutine lngto(x1,x2,dist)
      dimension x1(3),x2(3)
c--
      dist=(x2(1)-x1(1))**2+(x2(2)-x1(2))**2+(x2(3)-x1(3))**2
      dist=sqrt(dist)
      return
      end
!-----------------------------------------------------------------------
!--routine da GEOM.f
!-----------------------------------------------------------------------
!
code for zmatr_follow
      subroutine zmatr_follow(nordZ,ier)
c--calcola coordinate locali dai valori espressi nella z-matrix
c--(chiamata da fullrotamers in commonfiles.f)
      USE General
      USE ZMatrix
c
      dimension xortol(3,500) 
      dimension amat(9,9),dmat(9),INDX(9),v(3,3)
      dimension aa(3,3),w(3),bb(3,3),ww(3,3),www(3)
      dimension x11(3),x1(3),x2(3),rr(3,3)
      double precision sintheta, costheta,sinphi,cosphi,sinpsi,cospsi
      double precision rrd(3,3)
c
      ier=0
c--coordinate definite precedentemente fino all'atomo nordZ-1
      do ja=1,nordZ-1
        xortol(1:3,ja)=xortolocal(1:3,ja)
      enddo
c--coordinate degli atomi seguenti da nzm,nfin
      do icard=nordZ,nzm
	i=iloc(icard)
	j=nloc(1,icard)
      k=nloc(2,icard)
	l=nloc(3,icard)
      r=xloc(1,icard)
	theta=xloc(2,icard)
      phi=xloc(3,icard)
	call coordinate_ijkl ( xortol, i, j, k, l, r, theta, phi )
      enddo
      do ja=nordZ,nzm
        xortolocal(1:3,ja)=xortol(1:3,ja)
      enddo
      return
      end
!      
c--------------------------------------------------------------
code for coordinate_ij
      subroutine coordinate_ij (coordinates, i, j,       r,      option)
!-----------------------------------------------------------------
! subroutine coordinate_ij ( coordinates, i, j, r, option )
!-----------------------------------------------------------------
      dimension coordinates(3,500),direction(3)
	character*1  option
!
	do m=1,3
      coordinates(m,i)=0.0
	direction(m) =0.0
	enddo
! . Branch on the option.
      select case ( option )
c        case ( "r" ) ; direction = normalize ( random_vector ( 3 ) )
        case ( "x" ) ; direction(1) =  1.0 
        case ( "y" ) ; direction(2) =  1.0 
        case ( "z" ) ; direction(3) =  1.0 
        case default ; return
      end select
! . Calculate the coordinates of i.
      coordinates(1:3,i) = coordinates(1:3,j) + r * direction
      end subroutine coordinate_ij
c
code for coordinate_ijk  
      subroutine coordinate_ijk(coordinates, i, j, k,    r,theta,option)
!----------------------------------------------------------------------------
! subroutine coordinate_ijk ( coordinates, i, j, k, r, theta, option )
!----------------------------------------------------------------------------
      dimension coordinates(3,500),drlk(3),dra(3), drkj(3)
	character*1  option
!
! . Parameter declarations.
      pi     = 4.0 * atan(1.0)
      rtod   = 180.0 / pi
      dtor   = 1.0 / rtod
      to_radians = dtor
      small = 1.0e-9 
	do m=1,3
      coordinates(m,i)=0.0
	drlk(m) =0.0
	enddo
! . Branch on the option.
      select case ( option )
!        case ( "r" ) ; drlk    = normalize ( random_vector ( 3 ) )
        case ( "x" ) ; drlk(1) =  1.0 
        case ( "y" ) ; drlk(2) =  1.0 
        case ( "z" ) ; drlk(3) =  1.0 
        case default ; return
      end select
! . Calculate some trigonometric functions.
      cost = cos ( to_radians * theta )
      sint = sin ( to_radians * theta )
! . Calculate the jk displacement vector.
      drkj = coordinates(1:3,k) - coordinates(1:3,j)
! . Calculate the length of drkj.
      rkj = sqrt ( dot_product ( drkj, drkj ) )
! . Check that j and k are not too close.
      if ( rkj > small ) then
! . normalize drkj.
      drkj = drkj / rkj
! . Calculate the cross product of drlk and drkj.
      call cross_product ( drlk, drkj, dra )
! . Calculate the length of dra.
      ra = sqrt ( dot_product ( dra, dra ) )
! . Check the length of dra.
      if ( ra > small ) then
! . Normalize dra.
         dra = dra / ra
! . Calculate the cross product of drkj and dra (put in drlk).
         call cross_product ( drkj, dra, drlk )
! . Calculate the coordinate displacements (spherical polars).
         wa = r * cost
         wb = r * sint
! . Calculate the coordinates of i.
         coordinates(1:3,i) = coordinates(1:3,j) + wa*drkj + wb*drlk
      end if
      end if
      end subroutine coordinate_ijk
c
code for coordinate_ijkl
      subroutine coordinate_ijkl (coordinates, i, j, k, l, r, theta,phi)
!-----------------------------------------------------------------------------
! subroutine coordinate_ijkl ( coordinates, i, j, k, l, r, theta, phi )
!-----------------------------------------------------------------------------
      dimension coordinates(3,500),drlk(3),dra(3), drkj(3)
!
! . Parameter declarations.
      pi     = 4.0 * atan(1.0)
      rtod   = 180.0 / pi
      dtor   = 1.0 / rtod
      to_radians = dtor
      small = 1.0e-9
! . Initialize the coordinates for i.
	do m=1,3
        coordinates(m,i)=0.0
	  drlk(m) =0.0
	enddo
! . Check j, k and l.
!   IF ( ( j <= 0 ) .or. ( j > n ) .or. ( any ( coordinates(1:3,j) == undefined ) ) .or. &
!        ( k <= 0 ) .or. ( k > n ) .or. ( any ( coordinates(1:3,k) == undefined ) ) .or. &
!        ( l <= 0 ) .or. ( l > n ) .or. ( any ( coordinates(1:3,l) == undefined ) ) ) return
! . Calculate some trigonometric functions.
      cosp = cos ( to_radians * phi   )
      sinp = sin ( to_radians * phi   )
      cost = cos ( to_radians * theta )
      sint = sin ( to_radians * theta )
! . Calculate some displacement vectors.
      drkj = coordinates(1:3,k) - coordinates(1:3,j)
      drlk = coordinates(1:3,l) - coordinates(1:3,k)
! . Calculate the length of drkj.
      rkj = sqrt ( dot_product ( drkj, drkj ) )
! . Check that J and K are not too close.
      if ( rkj > small ) then
! . Normalize drkj.
      drkj = drkj / rkj
! . Calculate the cross product of drlk and drkj.
      call cross_product ( drlk, drkj,dra  )
! . Calculate the length of dra.
      ra = sqrt ( dot_product ( dra, dra ) )
! . Check the length of dra.
      if ( ra > small ) then
! . Normalize dra.
         dra = dra / ra
! . Calculate the cross product of drkj and ra (put in drlk).
      call cross_product ( drkj, dra, drlk )
! . Calculate the coordinate displacements (spherical polars).
         wa = r * cost
         wb = r * sint * cosp
         wc = r * sint * sinp
! . Calculate the coordinates of i.
         coordinates(1:3,i) = coordinates(1:3,j) + wa * drkj 
     2	   + wb * drlk + wc * dra
      end if
      end if
      end subroutine coordinate_ijkl
!------------------------------
      subroutine cross_product ( a, b, c )
!------------------------------
      dimension a(3),b(3),c(3)
! . Function declarations.
!      real ( kind = dp ), dimension(1:3) :: cross_product

! . Array arguments.
!      real , dimension(1:3), intent(in) :: a, b, c
! . Calculate the cross product a x b.
      c(1) = a(2) * b(3) - a(3) * b(2)
      c(2) = a(3) * b(1) - a(1) * b(3)
      c(3) = a(1) * b(2) - a(2) * b(1)
      end subroutine cross_product
c--------------------------------------------------------------
c
code for deter3
      subroutine deter3(g,d)
c--calcola determinante matrice(3,3)
c
      dimension g(3,3)
c
      d =     g(1,1)*g(2,2)*g(3,3) + g(1,2)*g(2,3)*g(3,1) +
     2	  g(1,3)*g(2,1)*g(3,2) - g(1,3)*g(2,2)*g(3,1) -
     3	  g(1,1)*g(2,3)*g(3,2) - g(1,2)*g(2,1)*g(3,3)
      return
      end
c
code for vlen
      subroutine vlen (g,x1,x2,d)                                               
c----                                                                           
c---- vector lenght                                                             
c----                                                                           
      dimension x1(*),x2(*),g(*)
      dimension a(3)                                                            
      call vcmp(x1,x2,a)                                                        
      call vmv(g,a,a,d)                                                         
      d = sqrt(d)                                                               
      return                                                                    
      end                                                                       
c
code for vstd
      subroutine vstd (g,x1,x2,var1,var2,std)
c-----vector length standard deviation
c-----in diagonal covariance matrix approximation
      USE GENERAL, only: lo
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension x1(*),x2(*),var1(*),var2(*),g(9)
      dimension caa(9),cbb(9),gam(9),v(3),vr(3)
c      write(lo,'(a,3(3f15.5))')'g',(g(j),j=1,9)
      do 100 i=1,9
      caa(i) = 0.0
      cbb(i) = 0.0
  100 continue
      do 200 i=1,3
      j = (i-1)*3+i
      caa(j) = var1(i)*var1(i)
      cbb(j) = var2(i)*var2(i)
      caa(j) = caa(j)*g(j)
      cbb(j) = cbb(j)*g(j)
  200 continue
      do 300 i=1,9
      gam(i) = caa(i)+cbb(i)
  300 continue
      call vcmp(x2,x1,v)
      call mv(g,v,vr)
      call norm(v,vr)
      v(1) = v(1)*sqrt(g(1))
      v(2) = v(2)*sqrt(g(5))
      v(3) = v(3)*sqrt(g(9))
      call vmv(gam,v,v,divar)
c	write(lo,*) 'divar=',divar
      if(divar.lt.0.000001.or.divar.gt.1000.) then
	divar=0.0
	std=0.0
	return
      endif
      std = sqrt(divar)
      return
      end
c
code for anamp
      subroutine anamp (g,x1,x2,x3,alfa)                                        
c--angle amplitude
c                                                                               
      dimension x1(*),x2(*),x3(*),g(*)
      dimension a(3),b(3),ar(3)                                                 
      call vlen(g,x2,x1,aa)                                                     
      call vlen(g,x3,x1,bb)                                                     
      call vcmp(x2,x1,a)                                                        
      call vcmp(x3,x1,b)                                                        
      call mv(g,a,ar)                                                           
      call ospr(ar,b,cc)                                                        
      csalf = cc/(aa*bb)                                                        
      if (csalf.gt.1)    csalf=1.0
      if (csalf.lt.-1.)  csalf=-1.
      alfa = acos(csalf)                                                        
      return                                                                    
      end                                                                       
c
code for anstd
      subroutine anstd(g,x1,x2,x3,var1,var2,var3
     1,                alfa,std)
c     angle amplitude standard deviation
c     in diagonal covariance matrix approximation
      dimension var1(*),var2(*),var3(*)
      dimension g(*),x1(*),x2(*),x3(*)
      dimension caa(9),cbb(9),ccc(9)
      dimension anbl(3),bnbl(3),cnbl(3)
      dimension buv(3),cuv(3)
      dimension bvc(3),cvc(3)
c--
      std=0.0
      rad=57.29578
      do i=1,9
      caa(i)=0.0
      cbb(i)=0.0
      ccc(i)=0.0
      enddo
      do i=1,3
      j=(i-1)*3+i
      caa(j)=var1(i)*var1(i)*g(j)
      cbb(j)=var2(i)*var2(i)*g(j)
      ccc(j) =var3(i)*var3(i)*g(j)
      enddo
      csalfa=cos(alfa)
      snalfa=sin(alfa)
      call vcmp(x2,x1,cvc)
      call vmv (g,cvc,cvc,d12)
      if(d12.le.0.0) then
	std=0.0
      else
	d12 = sqrt(d12)
	call vcmp(x1,x3,bvc)
	call vmv(g,bvc,bvc,d13)
	if(d13.le.0.0) then
	  std=0.0
	else
	  d13 = sqrt(d13)
	  do i=1,3
	    j = (i-1)*3+i
	    cuv(i) = cvc(i)*sqrt(g(j))/d12
	    buv(i) = bvc(i)*sqrt(g(j))/d13
	  enddo	  
	  c = d12
	  b = d13
	  do i=1,3
	    bnbl(i)=(buv(i)+cuv(i)*csalfa)/(c*snalfa)
	    cnbl(i)=-(cuv(i)+buv(i)*csalfa)/(b*snalfa)
	    anbl(i)=-(bnbl(i)+cnbl(i))
	  enddo
	  call vmv(caa,anbl,anbl,std1)
	  call vmv(cbb,bnbl,bnbl,std2)
	  call vmv(ccc,cnbl,cnbl,std3)
	  stdx=std1+std2+std3
	  if(stdx.gt.0.0) then
	  std=sqrt(stdx)
	  else
	  std=0.0
	  endif
	endif
      endif
      return
      end
c
code for vpr
      subroutine vpr(g,a,b,c)
c----- vector product
c-----                                                                          
      dimension a(*),b(*),c(*)
      dimension g(*)
      call dt3(g,d)
      e = sqrt(d)
      c(1)= e*(a(2)*b(3)-a(3)*b(2))
      c(2)= e*(a(3)*b(1)-a(1)*b(3))
      c(3)= e*(a(1)*b(2)-a(2)*b(1))
      return
      end
c
code for vcmp
      subroutine vcmp(a,b,c)
c--vector components
c
      dimension a(*),b(*),c(*)
      do i=1,3
      c(i)=a(i)-b(i)
      enddo
      return
      end
c
code for ospr
      subroutine ospr(a,b,c)
c--orthogonal scalar product
c
      dimension a(*),b(*)
      c=0.0
      do i=1,3
      c = c+a(i)*b(i)
      enddo
      return
      end
c
code for p3p
      subroutine p3p(x1,x2,x3,g,gr,pr)
      USE general
c--plane defined by 3 points
c
      dimension x1(3),x2(3),x3(3),g(9),gr(9)
      dimension a(3),b(3),c(3),cr(3),pr(4)
      call vcmp(x1,x2,a)
      call vcmp(x3,x2,b)
!      write(lo,*)'p3p x1 ',x1
!      write(lo,*)'p3p x2 ',x2
!      write(lo,*)'p3p x3 ',x3
      call vpr(g,a,b,cr)
      call mv(gr,cr,c)
      call ospr(c,cr,q)
      ier=0
      if(abs(q).lt.0.0001)then      
      write(Msg,11)
      call MsgWinErr('Warning',Msg,WARN_WINDOW,iExitC)
11    format(' The 3 points chosen can not define a plane ')
      ier=-1
      return
      endif
      q=sqrt(q)
      do i=1,3
      if(q.ne.0)cr(i)=cr(i)/q
      pr(i)=cr(i)
      enddo
      call ospr(cr,x2,d)
      pr(4)=d
      return
      end
c
code for pnrc
      subroutine pnrc (x1,x2,x3,g,pr)
c     plane perprndicular to the line
c     and conteining point x3
c
      dimension x1(*),x2(*),x3(*),g(*)
      dimension p(4),pr(4)
      call mv(g,x1,pr)
      call norm(x1,pr)
      call ospr(x3,pr,b)
      pr(4) = b
      return
      end
c
code for eign3
      subroutine eign3(g,gr,tm,eival,eivec,reivec,ier)                              
      USE General, only: pi,lo
      dimension g(3,3),gr(3,3),tm(3,3),eival(3),eivec(3,3)                      
      dimension reivec(3,3)                                                     
      dimension tx(3,3)                                                  
      double precision a,atrem,b,bimez,discr,p,q,r,tmdp(3,3)                              
!g    pi=3.14159                                                                
c     eigenvalues and eigenvectors of                                           
c     a 3x3 matrix in the mixed-indices                                         
c     representation                                                            
c     first index in contravariant position                                     
c     second index in covariant position                                        
c     referred to unitary axes                                                  
c                                                                               
c     set up the coefficients of secular equation                               
c     y**3+p*y**2+q*y+r=0                                                       
c     which is then reduced in the form                                         
c                                                                               
c     x**3+a*x+b=0                                                              
c     with y=x-p/3                                                              
c          a=1/3(3q-p**2)                                                       
c          b=1/27(2p**3-9p*q+27r)                                               
c                         
      ier=0
c       
      tmdp(:,:)=tm(:,:)                                                     
      p=tmdp(1,1)+tmdp(2,2)+tmdp(3,3)                                                 
      q=tmdp(1,1)*tmdp(2,2)-tmdp(1,2)*tmdp(2,1)                                         
     1 +tmdp(1,1)*tmdp(3,3)-tmdp(1,3)*tmdp(3,1)                                         
     2 +tmdp(2,2)*tmdp(3,3)-tmdp(2,3)*tmdp(3,2)                                         
      r=tmdp(1,1)*tmdp(2,2)*tmdp(3,3)                                                 
     1 +tmdp(1,2)*tmdp(2,3)*tmdp(3,1)                                                 
     2 +tmdp(2,1)*tmdp(3,2)*tmdp(1,3)                                                 
     3 -tmdp(3,1)*tmdp(2,2)*tmdp(1,3)                                                 
     4 -tmdp(3,2)*tmdp(2,3)*tmdp(1,1)                                                 
     5 -tmdp(2,1)*tmdp(1,2)*tmdp(3,3)                                                 
      p=-p                                                                      
      r = -r                                                                    
      a=(3.*q-p**2)/3.                                                          
      b=(2.*p**3-9.*p*q+27.*r)/27.                                              
      bimez=b/2.                                                                
      atrem=-a**3/27.                                                           
      discr=bimez**2-atrem                                                      
c---                                                                            
c     iwu = 7                                                                   
c     write(iwu,102) p,q,r,a,b,bimez,atrem,discr                                
      if(discr) 100,100,900                                                     
  100 continue                                                                  
      csfi=-bimez/dsqrt(atrem)                                                  
      if (csfi.gt.1)   csfi =1.0
      if (csfi.lt.-1.) csfi =-1.
      fi=acos(csfi)
      fistre=fi/3.                                                              
      csfi1=cos(fistre)                                                         
      csfi2=cos(fistre+2.*pi/3.)                                                
      csfi3=cos(fistre+4.*pi/3.)                                                
      a3sq=dsqrt(-a/3.)                                                         
c---                                                                            
c     write(iwu,102) p,q,r,a,b,bimez,atrem,discr                                
c     write(iwu,101) csfi,fi,fistre,csfi1,csfi2,csfi3,a3sq                      
c 102 format (5x,d15.8)                                                         
c 101 format(5x,f15.8)                                                          
      root1=2.*csfi1*a3sq                                                       
      root2=2.*csfi2*a3sq                                                       
      root3=2.*csfi3*a3sq                                                       
      root1=root1-p/3.                                                          
      root2=root2-p/3.                                                          
      root3=root3-p/3.                                                          
c---                                                                            
c     write(iwu,'(a,3e14.4)') 'roots:',root1,root2,root3                                          
      eival(1)=amin1(root1,root2,root3)                                         
      eival(3)=amax1(root1,root2,root3)                                         
      eival(2)=root1+root2+root3-eival(1)-eival(3)                              
      do 200 i=1,3                                                              
      tx(1,1)=tm(1,1)-eival(i)                                                  
      tx(2,2)=tm(2,2)-eival(i)                                                  
      tx(3,3)=tm(3,3)-eival(i)                                                  
      do 210 j=1,3                                                              
      eivec(i,j)=0.0                                                            
  210 continue                                                                  
      go to (201,202,203) ,i                                                    
  201 continue                                                                  
      eivec(1,1)=tx(2,2)*tx(3,3)-tm(2,3)*tm(3,2)                                
      eivec(1,2)=tm(3,1)*tm(2,3)-tm(2,1)*tx(3,3)                                
      eivec(1,3)=tm(2,1)*tm(3,2)-tm(3,1)*tx(2,2)                                
      go to 204                                                                 
  202 continue                                                                  
      eivec(2,1)=tm(1,3)*tm(3,2)-tm(1,2)*tx(3,3)                                
      eivec(2,2)=tx(1,1)*tx(3,3)-tm(1,3)*tm(3,1)                                
      eivec(2,3)=tm(1,2)*tm(3,1)-tm(3,2)*tx(1,1)                                
      go to 204                                                                 
  203 continue                                                                  
      eivec(3,1)=tm(1,2)*tm(2,3)-tm(1,3)*tx(2,2)                                
      eivec(3,2)=tm(2,1)*tm(1,3)-tm(2,3)*tx(1,1)                                
      eivec(3,3)=tx(1,1)*tx(2,2)-tm(1,2)*tm(2,1)                                
  204 continue                                                                  
      fll=0.0                                                                   
      do 250 j=1,3                                                              
      do 250 k=1,3                                                              
c-----                                                                          
c----- g(i,j) is not an unitary metric                                          
c-----                                                                          
      fll =  g(j,k)*eivec(i,k)*eivec(i,j)                                       
     1    +fll                                                                  
  250 continue                                                                  
      fll=sqrt(fll)                                                             
c                                                                               
c     contravariant components                                                  
c     of eigenvectors                                                           
c                                                                               
      eivec(i,1)=eivec(i,1)/fll                                                 
      eivec(i,2)=eivec(i,2)/fll                                                 
      eivec(i,3)=eivec(i,3)/fll                                                 
  200 continue                                                                  
c----                                                                           
c     write(iwu,1)                                                              
c   1 format (/)                                                                
c     write(iwu,103) ((eivec(i,j),j=1,3),i=1,3)                                 
  103 format(5x,3f10.5)                                                         
c----                                                                           
c                                                                               
c     covariant components                                                      
c     of eigenvectors                                                           
c                                                                               
      do 300 i=1,3                                                              
      do 310 j=1,3                                                              
      reivec(i,j) = 0.0                                                         
      do 310 k=1,3                                                              
      reivec(i,j) = reivec(i,j)+g(j,k)*eivec(i,k)                               
  310 continue                                                                  
      flr = 0.0                                                                 
      do 350 j=1,3                                                              
      do 350 k=1,3                                                              
      flr = gr(j,k)*reivec(i,j)*reivec(i,k)+flr                                 
  350 continue                                                                  
      flr = sqrt(flr)                                                           
      reivec(i,1) = reivec(i,1)/flr                                             
      reivec(i,2) = reivec(i,2)/flr                                             
      reivec(i,3) = reivec(i,3)/flr                                             
  300 continue                                                                  
c----                                                                           
c     write(iwu,1)                                                              
c     write(iwu,103) ((reivec(i,j),j=1,3),i=1,3)                                
c----                                                                           
      return                                                                
  900 continue 
      ier=-1                                                                 
c     write(lo,10) discr                                                      
c   10 format  (10x,d15.8 )                                                      
      return                                                                    
      end                                                                       
c
code for eignv3g
      subroutine eignv3g(g,gr,tm,eival,eivec,reivec)
      USE General, only: pi,lo
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension g(3,3),gr(3,3),tm(3,3),eival(3),eivec(3,3)
      dimension reivec(3,3)
      dimension tx(3,3)
      double precision a,atrem,b,bimez,discr,p,q,r
cold  pi=3.14159
!g    pi=4.0*atan(1.0)
c     eigenvalues and eigenvectors of
c     a 3x3 matrix in the mixed-indices
c     representation
c     first index in contravariant position
c     second index in covariant position
c     referred to unitary axes
c
c     set up the  coefficients of secular equation
c     y**3+p*y**2+q*y+r=0
c     which is then reduced in the form
c
c     x**3+a*x+b=0
c     with y=x-p/3
c          a=1/3(3q-p**2)
c          b=1/27(2p**3-9p*q+27r)
c
      p=tm(1,1)+tm(2,2)+tm(3,3)
      q=tm(1,1)*tm(2,2)-tm(1,2)*tm(2,1)
     1 +tm(1,1)*tm(3,3)-tm(1,3)*tm(3,1)
     2 +tm(2,2)*tm(3,3)-tm(2,3)*tm(3,2)
      r=tm(1,1)*tm(2,2)*tm(3,3)
     1 +tm(1,2)*tm(2,3)*tm(3,1)
     2 +tm(2,1)*tm(3,2)*tm(1,3)
     3 -tm(3,1)*tm(2,2)*tm(1,3)
     4 -tm(3,2)*tm(2,3)*tm(1,1)
     5 -tm(2,1)*tm(1,2)*tm(3,3)
      p=-p
      r = -r
      a=(3.*q-p**2)/3.
      b=(2.*p**3-9.*p*q+27.*r)/27.
      bimez=b/2.
      atrem=-a**3/27.
      discr=bimez**2-atrem
c---
c     iwu = 7
c     write(lo,102) p,q,r,a,b,bimez,atrem,discr
      if(discr) 100,100,900
  100 continue
      csfi=-bimez/dsqrt(atrem)
      if (csfi.gt.1)   csfi =1.0
      if (csfi.lt.-1.) csfi =-1.
      fi=acos(csfi)
      fistre=fi/3.
      csfi1=cos(fistre)
      csfi2=cos(fistre+2.*pi/3.)
      csfi3=cos(fistre+4.*pi/3.)
      a3sq=dsqrt(-a/3.)
c---
c     write(lo,102) p,q,r,a,b,bimez,atrem,discr
c     write(lo,101) csfi,fi,fistre,csfi1,csfi2,csfi3,a3sq
c 102 format (5x,d15.8)
c 101 format(5x,f15.8)
      root1=2.*csfi1*a3sq
      root2=2.*csfi2*a3sq
      root3=2.*csfi3*a3sq
      root1=root1-p/3.
      root2=root2-p/3.
      root3=root3-p/3.
c---
c     write(lo,101) root1,root2,root3
      eival(1)=amin1(root1,root2,root3)
      eival(3)=amax1(root1,root2,root3)
      eival(2)=root1+root2+root3-eival(1)-eival(3)
      do 200 i=1,3
      tx(1,1)=tm(1,1)-eival(i)
      tx(2,2)=tm(2,2)-eival(i)
      tx(3,3)=tm(3,3)-eival(i)
      do 210 j=1,3
      eivec(i,j)=0.0
  210 continue
      go to (201,202,203) ,i
  201 continue
      eivec(1,1)=tx(2,2)*tx(3,3)-tm(2,3)*tm(3,2)
      eivec(1,2)=tm(3,1)*tm(2,3)-tm(2,1)*tx(3,3)
      eivec(1,3)=tm(2,1)*tm(3,2)-tm(3,1)*tx(2,2)
      go to 204
  202 continue
      eivec(2,1)=tm(1,3)*tm(3,2)-tm(1,2)*tx(3,3)
      eivec(2,2)=tx(1,1)*tx(3,3)-tm(1,3)*tm(3,1)
      eivec(2,3)=tm(1,2)*tm(3,1)-tm(3,2)*tx(1,1)
      go to 204
  203 continue
      eivec(3,1)=tm(1,2)*tm(2,3)-tm(1,3)*tx(2,2)
      eivec(3,2)=tm(2,1)*tm(1,3)-tm(2,3)*tx(1,1)
      eivec(3,3)=tx(1,1)*tx(2,2)-tm(1,2)*tm(2,1)
  204 continue
      fll=0.0
      do 250 j=1,3
      do 250 k=1,3
c----- g(i,j) is not an unitary metric
      fll =  g(j,k)*eivec(i,k)*eivec(i,j)
     1    +fll
  250 continue
      fll=sqrt(fll)
c
c     contravariant components
c     of eigenvectors
c
      eivec(i,1)=eivec(i,1)/fll
      eivec(i,2)=eivec(i,2)/fll
      eivec(i,3)=eivec(i,3)/fll
  200 continue
c----
      if(istat2.lt.5) goto 260
      write(lo,1)
    1 format (/)
      write(lo,103) ((eivec(i,j),j=1,3),i=1,3)
  103 format(5x,3f10.5)
c----
c
c     covariant components
c     of eigenvectors
c
260   do 300 i=1,3
      do 310 j=1,3
      reivec(i,j) = 0.0
      do 310 k=1,3
      reivec(i,j) = reivec(i,j)+g(j,k)*eivec(i,k)
  310 continue
      flr = 0.0
      do 350 j=1,3
      do 350 k=1,3
      flr = gr(j,k)*reivec(i,j)*reivec(i,k)+flr
  350 continue
      flr = sqrt(flr)
      reivec(i,1) = reivec(i,1)/flr
      reivec(i,2) = reivec(i,2)/flr
      reivec(i,3) = reivec(i,3)/flr
  300 continue
c----
      if(istat2.lt.5) goto 999
      write(lo,1)
      write(lo,103) ((reivec(i,j),j=1,3),i=1,3)
c----
      go to 999
900   continue
c     write(lo,10) discr
   10 format  (10x,d15.8 )
  999 continue
      return
      end
c
code for mv
      subroutine mv(g,a,b)
c--matrix * vector multiplicatio
c
      dimension g(*)
      dimension a(*),b(*)
      idm =3
      do 10 i=1,idm
      j=(i-1)*idm
      b(i)=0.0
      do 20 l=1,idm
      b(i)=b(i)+g(j+l)*a(l)
   20 continue
   10 continue
      return
      end
c
code for vmv
      subroutine vmv(g,a,b,c)
c--vector * matrix * vector multiplication
c
      dimension g(*)
      dimension a(*),b(*)
      c=0.0
      idm = 3
      do i=1,idm
      j=(i-1)*idm
      do l=1,idm
      c=c+g(j+l)*a(i)*b(l)
      enddo
      enddo
      return
      end
c
code for mmm
      subroutine mmm(a1,a2,a3,a4)                                               
c---                                                                            
c---- matrix*matrix*matrix multiplication                                       
c---                                                                            
      dimension a1(*),a2(*),a3(*),a4(*)                                         
      dimension a5(9)                                                           
      do 10 i=1,9                                                               
      a5(i) = 0.0                                                               
   10 continue                                                                  
      call mm(a2,a3,a5)                                                         
      call mm(a1,a5,a4)                                                         
      return                                                                    
      end                                                                       
c
code for mm
      subroutine mm(a,b,c)                                                      
c---- matrix * matrix multiplication                                            
c---- matrices are supposed unidimensional                                      
c----      c(i,j) = a(i,k)*b(k,j)                                               
      dimension a(*),b(*),c(*)                                                  
      ndim = 3                                                                  
      i = 1                                                                     
      do 40 j=1,ndim                                                            
      l = (j-1)*ndim+1                                                          
c-----  l = 1, 4, 7,                                                            
      do 50 m=1,ndim                                                            
c----- m = 1, 2, 3,                                                             
      c(i) = 0.0                                                                
      do 60 n=1,ndim                                                            
      n1 = n-1                                                                  
c-----  n1 = 0, 1, 2,                                                           
      n2 = n1*ndim                                                              
c----- n2 = 0, 3, 6,                                                            
      c(i) =c(i)+a(l+n1)*b(m+n2)                                                
   60 continue                                                                  
      i = i+1                                                                   
   50 continue                                                                  
   40 continue                                                                  
      return                                                                    
      end                                                                       
c
code for dt3
      subroutine dt3 (g,d)                                                      
c--determinant of a (3*3) matrix
c
      dimension g(*)
      d=g(1)*g(5)*g(9)+                                                         
     1  g(2)*g(6)*g(7)+                                                         
     2  g(3)*g(4)*g(8)                                                          
     3 -g(3)*g(5)*g(7)                                                          
     4 -g(1)*g(6)*g(8)                                                          
     5 -g(2)*g(4)*g(9)                                                          
      return                                                                    
      end                                                                       
c
code for norm
      subroutine norm(a,ar)                                                     
c--components normalization
c
      dimension a(3),ar(3)                                                      
      call ospr(a,ar,q)                                                         
      q=sqrt(q)                                                                 
      do i=1,3
      ar(i)= ar(i)/q                                                            
      a(i)= a(i)/q                                                              
      enddo
      return                                                                    
      end                                                                       
c
code for drac
      subroutine drac(r,s,g,d)
c--calcolo distanza retta-atomo
c
      dimension g(*)
      dimension r(*),rr(3),s(*),sr(3)
      call mv(g,r,rr)
      call ospr(rr,s,b)
      call vmv(g,s,s,a)
      b=b*b
      d=abs(a-b)
      d=sqrt(d)
      return
      end
c
code for vardi
      subroutine vardi (gr,var,xr,vardir)
      dimension gr(*),var(3,3),xr(*),gamma(9)
c---- variance-covariance matrix is supposed to be
c---- in contravariant representation
c---- and referred to crystal axes
      call vmv(gr,xr,xr,x2)
      call m3m1(var,gamma)
      call vmv(gamma,xr,xr,vardir)
      vardir = vardir/x2
      return
      end
c
code for m3m1
      subroutine m3m1(tdm,udm)
      dimension tdm(3,3),udm(9)
      do i=1,3
      do j=1,3
      k = (i-1)*3+j
      udm(k) = tdm(i,j)
      enddo
      enddo
      return
      end
c
code for m1m3
      subroutine m1m3 (udm,tdm)
      dimension udm(9), tdm(3,3)
      do i = 1,3
         do j= 1,3
            k = (i-1)*3+j
            tdm(i,j) = udm(k)
         enddo
      enddo
      return
      end
c
cdoe for vudy
      subroutine vudy(g,v,udy)
c---- vector cros unit dyadic
c----  dyadic is in contravariant representation
c----
      dimension  v(*),udy(*)
      dimension g(*)
      call dt3 (g,vol)
      vol = sqrt(vol)
      do 10 i=1,9
      udy(i) =0.0
   10 continue
      udy(2) = -v(3)
      udy(3) =  v(2)
      udy(4) =  v(3)
      udy(6) = -v(1)
      udy(7) = -v(2)
      udy(8) =  v(1)
      do 20 i=1,9
      udy(i) = udy(i)*vol
   20 continue
      return
      end
!
!code for unnl
      subroutine unnl(x,xmx,nul,nnl)
!--upper and lower limits for lattice operator
!--x(i)    atomo corrente
!--xmx(i)  e' la distanza lungo un asse espresso in frazione d'asse
!-----
      dimension x(*),xmx(*),nul(*),nnl(*)
!      
!--limiti su nul() upper
      do i=1,3
      ax = 1.
      fx = x(i)+xmx(i)   !--distanza massima intorno all'atomo
      if(fx) 10,20,20
   10 continue
      ax = -1.
      go to 22
   20 continue
      if(fx-1.) 21,22,22
   22 continue
      fx = fx+ax
   21 continue
      nul(i) = int(fx)
      enddo
c--limiti su nnl() lower
      do i=1,3
      ax = 1.
      fx = x(i)-xmx(i)
      if(fx) 30,40,40
   30 continue
      ax = -1.
      go to 42
   40 continue
      if(fx-1.) 41,41,42
   42 continue
      fx = fx+ax
   41 continue
      nnl(i) = int(fx)
      enddo
c----- enlarge the limits
      do i=1,3
      nul(i) = nul(i)+1
      if(nul(i).lt.0)nul(i)=0
      nnl(i) = nnl(i)-1
      if(nnl(i).gt.0)nnl(i)=0
      enddo
      return
      end
c
code for sop
      subroutine sop(sy,tr,ap,uap,it)
c----- symmetry operator for atomic parameters
c---- it = 1  atomic coordinates
c---- it = 2  atomic temperature factors
c-----
      dimension sy(*),tr(*),ap(*),uap(*)
      go to (1,2) it
    1 continue
      call mv(sy,ap,uap)
      uap(1) = uap(1)+tr(1)
      uap(2) = uap(2)+tr(2)
      uap(3) = uap(3)+tr(3)
      go to 3
    2 continue
      call mmm(ap,sy,ap,uap)
    3 continue
      return
      end
c
code for lop
      subroutine lop (x,tr,ux)
c---- lattice opetator
c----
      dimension x(*),tr(*),ux(*)
      ux(1) = x(1)+tr(1)
      ux(2) = x(2)+tr(2)
      ux(3) = x(3)+tr(3)
      return
      end
c
code for adec
      subroutine adec(code1,code2,ivet)
c-------code1 =  ser*1000 + sym*10 + plt
c-------code2 =  (tx+50)*10000 + (ty+50)*100 + (tz+50)
c-------ivet  is the output vector for printing
c-------
      dimension ivet(*)
c----
      acode = code1
      is = 1
      if(acode.lt.0) then
      is = -1
      acode = -acode
      endif
      isn = int(acode/1000.)
      fl = isn*1000.
      acode = acode - fl
      isc = int(acode/10.)
      fl = isc*10.
      acode = acode - fl
      iplt = int(acode)
      ivet(1) = isn
      ivet(2) = isc*is
      ivet(3) = iplt
c-----------
      acode = code2
      itx = int(acode/10000.)
      fl = itx*10000.
      acode = acode - fl
      ity = int(acode/100.)
      fl = ity*100.
      acode = acode - fl
      itz = int(acode)
      ivet(4) = itx
      ivet(5) = ity
      ivet(6) = itz
      return
      end
!
!code for AddAtomo
      subroutine AddAtomo(NewLab,ier)
!--genera un atomo (Z-matrix)
!  chiamata da    subroutine cAddOneAtom(iClickati, kz, NewLab)
!  in spec2006.f
!
      USE General
      USE Atomi
      USE Molcom
      USE ZMatrix
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
!--
      dimension ResIn(3,3),ResOut(3,3) 
      character NewLab*8
      dimension xmatr(3,3),xx1(3),xx2(3)
!--
      itest=0
      ier=0
!-------------------------------------------------------------------------
!--creo lista del frammento con i tre atomi selezionati: iCl1 iCl2 iCl3
!-------------------------------------------------------------------------
      n=3
      aLab26(n)=aLab(iCl1)
      xyzs26(1:5,n) = xyzs(1:5,iCl1)
      ResIn(1:3,n) = xyzs26(1:3,n)            
      Adr26to5(n)=iCl1        
      n=n-1
      aLab26(n)=aLab(iCl2)
      xyzs26(1:5,n) = xyzs(1:5,iCl2)           
      ResIn(1:3,n) = xyzs26(1:3,n)            
      Adr26to5(n)=iCl2        
      n=n-1
      aLab26(n)=aLab(iCl3)
      xyzs26(1:5,n) = xyzs(1:5,iCl3)           
      ResIn(1:3,n) = xyzs26(1:3,n)            
      Adr26to5(n)=iCl3 
      n=4
      aLab26(n)=NewLab       
      loo=1
      lx =2
      ly =3
!--salvo coordinate dell'origine
      x_orig(1:3)=xyzs26(1:3,loo)
!--ortogonalizzo frammento
      call OrtoGru(3,ResIn,ResOut,loo,lx,ly,3)    
      if(itest.ge.1) then
         write(ncwu,*)' coordinate orto nel nuovo riferimento'
         do ja=1,3
             call shift(aLab26(ja),len)
             write(ncwu,'(a,2x,10f10.5)') aLab26(ja)(1:len),
     *                                      ResOut(1:3,ja)
         enddo
      endif
      do ja=1,3
         xyzs26(1:3,ja)=ResOut(1:3,ja)
      enddo
!--definisco le informazioni per la z-matrix routine
      nzm=4
      do i=1,nzm
	  do n=1,3
	     nloc(n,i)=0
	     xloc(n,i)=0.0
	  enddo
	enddo
!
      iloc(1)=1
      iloc(2)=2
      iloc(3)=3
      iloc(4)=4
!      
      nloc(1,2)=1
      nloc(1,3)=2
      nloc(2,3)=1
      nloc(1,4)=3
      nloc(2,4)=2
      nloc(3,4)=1
!      
!--calcolo distanze 0--1 ,  1--2 e angolo 1--2--3
      do i=1,3
         call zmatcalcNEW(iloc(i),nloc(1,i),nloc(2,i),nloc(3,i),
     2     ispefra(i),atfra(i),xloc(1,i),xloc(2,i),xloc(3,i))
! 	   write(ncwu,'(i5,1h),i5,2x,a8,2x,a4,4x,3f10.3,3i5)') i,iloc(i),
!     *     atfra(i),ispefra(i),(xloc(n,i),n=1,3),(nloc(n,i),n=1,3)
      enddo
!      
      xloc(1,4)=dist1atm
      xloc(2,4)=ang_b
      xloc(3,4)=ang_t
!
      if(itest.ge.1) then
         write(lo,*)' coordinate da Z-matrix'
         do ja=1,4
            call shift(aLab26(ja),len)
            write(lo,60) aLab26(ja)(1:len),(xloc(n,ja),n=1,3),
     *           (nloc(n,ja),n=1,3)
         enddo
      endif
!--calcolo coordinate ortogonali dal formato z-matrix 
      call zmatr_new(ier)
      if(itest.ge.1) then
         write(lo,*)' coordinate locali da Z-matrix ordinate'
         do ja=1,4
            call shift(aLab26(ja),len)
            write(lo,60) aLab26(ja)(1:len),(xortolocal(n,ja),n=1,3)
   60       format(2x,a8,1x,3f10.3,3i5)
         enddo
      endif
      if(itest.ge.1) then
         write(lo,*)' coordinate crystallografiche da Z-matrix ordinate'
         do ja=1,4
            call shift(aLab26(ja),len)
            xx1(1:3)=xortolocal(1:3,ja)
            call moltv( t_cryst,xx1,xx2)
            xx1(1:3)=xx2(1:3)+ x_orig(1:3)
            write(lo,60) aLab26(ja)(1:len),(xx1(n),n=1,3)
         enddo
      endif
!--riporto le coordinate dell'atomo generato in cella
      xx2(1:3)=xortolocal(1:3,4)
      call moltv( t_cryst,xx2,xx1)
!--aggiungo il nuovo atomo alla lista atomica
      ispe1=nzTot(iCl1)
!      
      nats=nats+1
      aLab(nats)= NewLab      
      xyzs(1:3,nats)=xx1(1:3)+ x_orig(1:3)
      xyzs(4:5,nats)=xyzs(4:5,iCl1)
      bfac(nats)=bfac(iCl1)
      IsoAniso(nats)=2
      bij(1:6,nats)=0.0
      nzTot(nats)=lspec
      nz(nats)=lspec*nzConst
      serial(nats)=lser(lspec)
      iEqui(nats) = nats
!--controllo se devo legare l'atomo generato
      ilega=0
      if(dist1atm.ge.BondTable(1,ispe1,lspec).and.
     2	 dist1atm.le.BondTable(2,ispe1,lspec)) ilega=1
      if(ilega.eq.1) then
         nco=iconn(1)
         j=nco*3+2
         iconn(j)=iCl1
         iconn(j+1)=nats
         iconn(j+2)=0
         nco=nco+1
         iconn(1)=nco
      endif   
      if(itest.ge.1) call PrintAtoms
      write(ncwu,'(/,70(1h-))') 
      i=nats 
      lnz = nzTot(i)
      write(ncwu,'(a)')' A new atom was generated'
      write(lo,1110) aLab(i)(1:8), nalf(lnz),serial(i),
     1        xyzs(1:3,i),bfac(i),xyzs(5,i)
1110     format(1x,a ,1x,a4,i5,3f10.5,2f10.3)
      write(ncwu,'(70(1h-),/)') 
!           
      return
      end
c--------------------------------------------------------------
code for zmatr_new
      subroutine zmatr_new(ier)
c--calcola coordinate locali dai valori espressi nella z-matrix
c
      USE General
      USE ZMatrix
c
      dimension xortol(3,500) 
      dimension amat(9,9),dmat(9),INDX(9),v(3,3)
      dimension aa(3,3),w(3),bb(3,3),ww(3,3),www(3)
      dimension x11(3),x1(3),x2(3),rr(3,3)
      double precision sintheta, costheta,sinphi,cosphi,sinpsi,cospsi
      double precision rrd(3,3)
c
c--nzm e' il numero di atomi nella sequenza descritta dalla Z-matrix
c--Esempio:
c-- i  iloc(i)   nloc(1,i)  xloc(1,i)  nloc(2,i)  xloc(2,i) nloc(3,i)  xloc(3,i)
c-- 1    3         0         0           0          0.0       0         0.0
c-- 2    2         3         1.54        0          0.0       0         0.0
c-- 3    5         2         1.5         3         120.0      0         0.0
c-- 4    8         5         1.52        2         122.0      3        210.0
c-- in questo caso nzm=4
c-- nzm,iloc,nloc,xloc devono essere note                          
c--xortol e xortolocal sono le coordinate ortonormali locali 
c--calcolate a partire dalle precedenti
c--xortol e' la coordinata locale dell'i-esimo atomo nella sequenza Z-matrix
c--xortolocal e' la coordinata locale dell' atomo nella mappa, corrispondente
c--all'i-esimo atomo nella sequenza Z-matrix
c--xor e' l'origine del sistema di riferimento, ossia la posizione
c--del penultimo atomo nella sequenza della Z-matrix nel sistema cristallino
c
      ier=0
      itest=0
      do i=1,nzm
	  iesz(i)=0
      enddo
c--coordinate dell'atomo 1 origine
	k=1
	k1=iloc(k)
      xortol(1,k)=0.0
      xortol(2,k)=0.0
      xortol(3,k)=0.0
      xortolocal(1,k1)=xortol(1,k)
      xortolocal(2,k1)=xortol(2,k)
      xortolocal(3,k1)=xortol(3,k)
      iesz(k1)=1
c--coordinate degli atomi seguenti da 2-->nzm
      do icard=2,nzm
	  i=iloc(icard)
	  j=nloc(1,icard)
        k=nloc(2,icard)
	  l=nloc(3,icard)
        r=xloc(1,icard)
	  theta=xloc(2,icard)
        phi=xloc(3,icard)
c        write(lo,'(4i5,3f10.3)')i,j,k,l,r,theta,phi
	  select case (icard)
	    case(2) 
	      call coordinate_ij   ( xortol, i, j,       r,        "x" )
          case(3)
            call coordinate_ijk  ( xortol, i, j, k,    r, theta, "y" )
          case default
	      call coordinate_ijkl ( xortol, i, j, k, l, r, theta, phi )
        end select
      enddo
      do ja=1,nzm
c        write(lo,60)ja, (xortol(n,ja),n=1,3)
   60   format(i5,3f10.5)
        xortolocal(1:3,ja)=xortol(1:3,ja)
      enddo
      if(itest.eq.1) then
        write(lo,*)' coordinate da Z-matrix attuali'
        do ja=1,nzm
          write(lo,60)ja, (xortolocal(n,ja),n=1,3)
        enddo      
      endif
      return
      end

!-----------------------------------------------------------------------
code for swmenu
      subroutine swmenu(icomm)
c--print available directive(s)
c
      USE General
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      character(*) icomm
c--
      itipo=2
      iform=1
      jop=jopen(ncpt,hlp1,itipo,iform,ierr)
      call shift(icomm,lcomm)
      i1=1
      do while (i1 > 0)
             read(ncpt,'(a80)',end=7000) Buffer1
             call shift(Buffer1,nchar)
             if(Buffer1(1:nchar) == icomm(1:lcomm)) exit
             if(Buffer1(1:6) == 'finish') then
                close (ncpt)
                return
             endif
      enddo
      if(itty.lt.0) then
         i1=1
         write(intty,'(1h )')
         do while (i1 > 0)
             read(ncpt,'(a80)',end=7000) Buffer1
             call zshift(Buffer1,nchar)
             if (Buffer1(1:4) == '####') exit
             write(intty,'(1x,a)')Buffer1(1:nchar)
         enddo
         write(intty,'(1h )')
      endif
7000  continue
      close(ncpt)
      return
      end
!-----------------------------------------------------------------------
      subroutine zshift(string,lenp)
*     USE General
      character string*(*)
!
      k=len(string)
!
!-- TAB filter
!
      do i=1,k
         j = ichar(string(i:i))
c--      if (j.eq.9) then
         if (j.lt.32.or.j.ge.127) then
             string(i:i)=' '
         endif
      enddo
      ifin=1
      iniz=1
   20 do 30 i=k,1,-1
        if (string(i:i).ne.' ') then
             ifin=i
             go to 40
         endif
   30 continue
   40 continue
      lenp=ifin-iniz+1
c
      return
      end
!-----------------------------------------------------------------------
      subroutine sortya(ibuffer,lind,numb,minc,jump)
c--general sorting routine
c
c  ibuffer : array to be used
c--lind :first address in the list
c--numb :number of elements in the list
c--minc :number of words per element
c--jump :function of the relative address(jaddress) of the variable
c  to be sort   (0.ge.jaddress.le.minc)
c  jump>0 increasing sorting ( jaddress=jump )
c  jump<0 decreasing sorting ( jaddress=iabs(jump)-1 )
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension  ibuffer(*)
c
      if(numb.eq.1)return
      jsign=1
      if(jump.lt.0)then ! go to 2000
      jump=iabs(jump)-1
      jsign=-1
      endif
c2000  continue
      ja=2
 2010 continue
      jb=numb/ja
      if(jb.le.0) jb=1 ! 2020,2020,2030
c 2020 continue
c      jb=1
c 2030 continue
      jc=numb-jb
 2040 continue
      jd=0
      m =lind
      do i=1,jc
      mk =m +jb*minc
      if ((ibuffer(m +jump)-ibuffer(mk +jump))*jsign > 0) then
          mm=m
          mmk=mk
          do je=1,minc
             jf=ibuffer(mm)
             ibuffer(mm)=ibuffer(mmk)
             ibuffer(mmk)=jf
             mm=mm+1
             mmk=mmk+1
          enddo
          jd=1
      endif
 2060 continue
      m =m +minc
      enddo
      if(jd.gt.0)goto 2040 ! 2080,2080,2040
 2080 continue
      if(jb.gt.1) then ! 2100,2100,2090
c 2090 continue
        ja=ja*2
        go to 2010
      endif
c 2100 continue
      return
      end
!-----------------------------------------------------------------------
      subroutine sortza(stored,lind,numb,minc,jump)
c--general sorting routine
c
c  stored : array to be used
c--lind   : first address in the list
c--numb   : number of elements in the list
c--minc   : number of words per element
c--jump   : function of the relative address(jaddress) of the variable
c  to be sort   (0.ge.jaddress.le.minc)
c  jump>0 increasing sorting ( jaddress=jump )
c  jump<0 decreasing sorting ( jaddress=iabs(jump)-1 )
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension  stored(*)
c
      if(numb.eq.1)return
      jsign=1
      if(jump.lt.0)then ! go to 2000
      jump=iabs(jump)-1
      jsign=-1
      endif
c2000  continue
      ja=2
 2010 continue
      jb=numb/ja
      if(jb.le.0) jb=1  ! 2020,2020,2030
c 2020 continue
c      jb=1
c 2030 continue
      jc=numb-jb
 2040 continue
      jd=0
      m =lind
      do i=1,jc
      mk =m +jb*minc
      if (( stored(m +jump) - stored(mk +jump))*jsign > 0.0) then
          mm=m
          mmk=mk
          do je=1,minc
             f= stored(mm)
             stored(mm)= stored(mmk)
             stored(mmk)= f
             mm=mm+1
             mmk=mmk+1
          enddo
          jd=1
      endif
 2060 continue
      m =m +minc
      enddo
      if(jd.gt.0)goto 2040 ! 2080,2080,2040
c 2080 continue
      if(jb.gt.1)then ! 2100,2100,2090
c 2090 continue
        ja=ja*2
        go to 2010
      endif
c 2100 continue
      return
      end
!-----------------------------------------------------------------------
