c===============================REM===============================
c   Se trovo una struttura con F222 (ncentr=3) rivedere le routines
c   RompiCentroSimmetria, RompiSimmetria3d, RestoreSymmetry
c   per inserire la cancellazione degli equivalenti dei picchi
c   centrati (in questo caso la centratura e' presente anche
c   nella SMF. 
c===============================History===============================
c--Gennaio 2004
c  introduzione del riciclo a bassa risoluzione
c  aggiornamento delle chiamate al Cluster Finder, correzione di NsymTot
c--06/05/04
c  versione modificata (Atomi allocati dinamicamente)
c--01/06/04
c  estensine ai gruppi centrosimmetrici
c--01/09/04
c  adattamento alla grafica della release sir2004
c--20/10/05
c  velocizzazione e miglioramento
c--9/11/05
c  ImproveRiciclo e introduzione della sigmaa nel riciclo. Nuovo Peak search
c--31/01/06
c  Introduzione della struttura a blocchi e nuova organizzazione in subroutines
c--10/11/06
c  ksezold=-1 per triclino
c  ksezold= 0 per 3D
c  ksezold>0 per 1D
c--8/2/07
c  introduzione del pesaggio della Patterson
c  nuova deconvoluzione, piu' adatta per strutture a bassa risoluzione
c  nuova CercaPicchi con simmetria SMF e clusterizzazione
c  funzioni di Pavelcik di secondo ordine: AMS, ImproveSmap
c  procedura di selezione dei picchi Pivot: ConvergiPivot, ConvergiPivot1
c--23/2/07
c  procedura ottimizzata per piccole e medie
c=====================================================================
      subroutine Patterson(inizTrial, ifinTrial, ierr)
!
!--sfrutto il metodo alternativo: trasformo la mappa Patterson in una Fourier
!
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Molcom
      USE PhaseModule
      USE RemoModule !for Cmap
c_ULTIM
      USE Param
c_ULTIM
      character*9 cara
      character*3 testo_ON, testo_OFF
      character*80 line
      character*11 tirang

!pgMAD150206
      character*10 reje
!pgMAD150206
!
      dimension xor(3),xnew(3),s(3),xs(3)
!
      common /stampafasi/ fasipatt(100)
      integer :: fasipatt
!
      fasipatt(:) = 0
      ier = 0
      Msg = 'Starting Patterson procedure'
      call PrintMess(Msg)
!     if(jBlock==1) then
         write(Msg,1)
!     else
!        write(Msg,2) jBlock
!     endif
    1 format('Compute starting phases by means of Patterson procedure')
    2 format('Compute starting phases by means of Patterson procedure',
     *        ' for Block #',i2)
      call RunToolBar(1,Msg)
c
c--clear xmap
c
      call AllocaMappa(2)
      call AllocaMappa(1)
c
c--aumenta lo spazio disponibile per i vettori del peak search
c
      if(jBlock>1) then
        if (no(1) == 1) then
           Hydrogens = float( nw(1) ) / totop
        else
           Hydrogens =  0.0
        endif
        MaxAtoms = nint( anat * 1.5 + Hydrogens ) + 20
        if (ksize <= 3) then
           MaxAtoms = 3 * MaxAtoms
        endif
      endif
      natsSav = 2 * MaxAtoms
      call AllocaAtomi(2)
      nats = natsSav
      call AllocaAtomi(-1)
c
c--clear Patt map
c
      call AllocaMappaPatterson(2)
      call AllocaMappaPatterson(1)

c       iesCmap=0 ! senza Cmap
c       iesCmap=1 ! con Cmap, 1 ciclo !!!
c       iesCmap=2 ! con Cmap, 2 cicli
c       iesCmap=3 ! con Cmap, 3 cicli
c
c       iesSnip=1 ! con Snip
c       if(ResEff<1.5) then
c          if(iwei==0) iesSnip=0 
c          if(jsys>3) iesSnip=0 
c       endif

        testo_ON = 'ON'
        call NoBlanks(testo_ON, icara)
        testo_OFF = 'OFF'
        call NoBlanks(testo_OFF, icara2)

        if (jBlock == 1) then
            write(lo,3)
            if (iesSnip >0 .and. iesCmap >0) then
               write(lo,4) testo_ON(1:icara), testo_ON(1:icara)
            elseif (iesSnip >0 .and. iesCmap==0) then
               write(lo,4) testo_ON(1:icara), testo_OFF(1:icara2)
            elseif (iesSnip==0 .and. iesCmap >0) then
               write(lo,4) testo_OFF(1:icara2), testo_ON(1:icara)
            elseif (iesSnip==0 .and. iesCmap==0) then
               write(lo,4) testo_OFF(1:icara2), testo_OFF(1:icara2)
            endif
        endif

    3 format(/,' ',78('-'),//,' Patterson deconvolution strategy:')
    4 format (' SNIP Procedure ',a,' - CMAP Procedure ',a)
c
c--applica il metodo di deconvoluzione Patterson
c
      call DoSingleIteration()
      call Deconvolution(ksezold,ierr)
      if(ierr<0) goto 51
      numbModelsOld=numbModels 

        if(iesCmap>0) then
          numbModels=1 
          MonomerInModel(1)=1
          num=0
c         sog=20
          sog=10
          do i=nk,1,-1
            if(no(i)>sog) then
              num=num+nint(nw(i)/(pts*float((icent+1)*nsym)))
            endif
          enddo
          numCmap=max(num,2)
c         write(6,*) 'Alloco model',numCmap
          natsInModel(1)=numCmap
          call AllocaModello(1,ier)
        endif
c
c--procedura multi-soluzione
c
      npunti = sum(jBlocksPh(1,:))
      call AllocaGrafici(1, npunti, ifTang)
!
!d!   if (ksize > 3) then
!d!       jBlocksPh(1,jBlock) = min0(jBlocksPh(1,jBlock), nats15)
!d!       MaxToStore = nats15
!d!   endif
!
      call scrper('Compute phases            ',0,0)
c
c--loop sui picchi della Patterson
c
      if (jBlock == 1) then
          kats15 = nats15
      else
          kats15 = nats15 - sum(jBlocksPh(1,1:jBlock-1))
      endif
      if (kats15 < jBlocksPh(1,jBlock)) then
          jBlocksPh(1,jBlock) = kats15
          if (kats15 < jBlocksPh(2,jBlock)) then
              jBlocksPh(2,jBlock) = kats15
          endif
      endif
      if (kats15 <= 0) then
          if (jBlock == 1) then
              Msg ='No Patterson peaks available. Program aborted.'
              if (jscreen > 0) then
                  call TestoGR(Msg, color_RED, 2, 2)
              endif
              ierr = -3
              write(lo,6) Msg(1:Lung(Msg))
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          else
              ierr = -2
              Msg ='No more Patterson peaks available. Program stops.'
              call OpenWarning(Msg)
              write(lo,6)
          endif
          goto 51
      endif
      write(lo,5)
    5 format(/,' ',78('-'),//,
     *       ' List of the Patterson peaks used as pivot',//,
     *       '       Serial   Height      ','X',9x,'Y',9x,'Z')
    6 format(' ',78('-'),/,a,/)
      MaxRun = jBlocksPh(1,jBlock)
      MaxToStoreSav = MaxToStore
      MaxToStore = MaxRun
!d!   if (ksize > 3) go to 2000

! - per scalare foma=h1 nel caso di stampa
       h1=xyzo(4,1)
       denom = 1
       do i = 5,1,-1
          denom = 10 ** i
          intfoma = int(h1/denom)
          if (intfoma > 0) exit
      enddo

      do ntrbl=1, MaxRun
!d!      call CalcolaFasiPatt(ntrbl, ier)
!d!      if (ier < 0) then
!d!          ier = 0
!d!          exit
!d!      endif
!d!      go to 1000
         jCountRun = jCountRun + 1
         if (numbTrials > 0) then
             numbrun = trialVett(ntrbl)
         elseif (numbTrials < 0) then
             numbrun = itriaPatt
             numbTrials = 0
         elseif (numbTrials == 0) then
             numbrun = ntrbl
         endif

         if (ifTrial == 2) then
             numbrun = itriaPatt - 1 + ntrbl
         endif
c        nrun = numbrun    ! per restart 

         if (jBlock > 1) then
             numbrun = numbRun + sum(jBlocksPh(1,1:jBlock-1))
         endif

c        if (MaxRun .gt.1) then
c            if (jBlock == 1) then
c                kOffSet = 0
c            else
c                kOffSet = sum(jBlocksPh(1,1:jBlock-1))
c            endif
c            write(cara,10) ntrbl+kOffSet,MaxRun+kOffSet
c        else
c            write(cara,15) numbrun
c        endif

         if (MaxRun == 1 .or. ifPatt > 0) then
             write(cara,15) numbrun
         else
             if (jBlock == 1) then
                 kOffSet = 0
             else
                 kOffSet = sum(jBlocksPh(1,1:jBlock-1))
             endif
             write(cara,10) ntrbl+kOffSet,MaxRun+kOffSet
         endif

c        endif
         call NoBlanks(cara,icara)
         write(line,20) nstr,cara(1:icara)
         call scrper(line,ntrbl,MaxRun)
   10 format(i3,'/',i3)
   15 format(i3)
   20 format('Compute starting phases for',i5,
     *       ' reflections in Patterson trial ',a)
c
        if (numbrun > nats15) then
            write(6,*) 'peak ',numbrun,' not found within',
     &                                   nats15,' peaks' 
            exit
        endif

        if (ntrbl == 1) then
            inizTrial = numbrun
        endif
        if (ntrbl == MaxRun) then
            ifinTrial = numbrun
        endif
        
*       if (neutro == 1) then
*           numbrun = 1
*           xyzo(1,numbrun) = 0.2989  ! coordinate del ferro per 1iu6
*           xyzo(2,numbrun) = 0.3015
*           xyzo(3,numbrun) = 0.0904
*       endif
        x1=side(xyzo(1,numbrun))
        y1=side(xyzo(2,numbrun))
        z1=side(xyzo(3,numbrun))
        h1=xyzo(4,numbrun)
!
!--stampo informazioni circa la distanza dall'origine
!
        if(kverbo>0) then
          xor(1:3)=xyzo(1:3,numbrun)
          distmin=999.
          do k=2,nsymTot
            call oper(k,xs,x1,y1,z1)
            call xdist(xs,xor,dist,s)
            if(dist<distmin) distmin=dist
          enddo
        endif
c
        itria=numbrun
        if (ifPivot == 1) then
            x1 = coord_temp(1)
            y1 = coord_temp(2)
            z1 = coord_temp(3)
            ifPivot = 2
            if(knw==1.and.ifTime==0) call to_coord_Patt(ksezold)
        endif

        if(kverbo==0) then
            write(lo,'(a,i5,f11.1,3f10.4)') '  PEAK',
     *          numbrun,h1,x1,y1,z1
        else
            atermNorm=volume*(4.0*Pi)/(pts*3.0*ResEff**3)
            backg=atermNorm*g_s_Patt(dist)
            write(lo,'(a,i5,f11.1,3f10.4,2f10.2)') 'PEAK',
     *          numbrun,h1,x1,y1,z1,distmin,backg
        endif

c
c--procedura per creare la mappa Fourier
c
        call DoSingleIteration()
!        
! -- dedi -- per azzerare le variabili della sigmaa  9/11/12
! -- azzera le variabili per ogni picco (come in Cicli_DSR, per ogni trial)       
        waveare = 0.0
        exposigma = 2.0
        RenveDyn = 0.0
! -- dedi -- per azzerare le variabili della sigmaa
        
c
c     nu = -123
c     izero = 0
c     ifmin = 1
c     call examin(nu,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)

        call DoFourier(x1,y1,z1,ksezold, ier)
        if (ier < 0) then
            ierr = -1
            ier  = 0
            goto 51
        endif
c
c
c--procedura di riciclo Patterson
c
        call Riciclo3d(ksezold)
!
        esaltaPatt = esalta
!       write(6,*) 'ESALTAPATT ',esaltaPatt
c
c
c--nuovi pesi
c
c----   pesi: HM con P(wt) "teorica"

!!!!! -- PROVARE CON NUOVI PESI  -- !!!!!

!!!!!   izero = 0
!!!!!   ifmin = 1
!!!!!   call examin(numbrun,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
!!!!!   tirang = 'NREFL'
!!!!!   ipher = 1
!!!!!   call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
!!!!!*                    ipub,iphaz,wt,10,0.0,ipher)
!!!!!   work1(1:nrefl) = wt(1:nrefl)
!!!!!   work2(1:nrefl) = wt(1:nrefl)
!!!!!   nsip1=100
!!!!!   nwizm1=25
!!!!!   call HistogramMatch(work1,work2,nrefl,nsip1,nwizm1,3)
!!!!!   wt(1:nrefl) = work1(1:nrefl)
c       izero = 0
c       ifmin = 1
c       call examin(numbrun,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
c       tirang = 'NREFL_HM'
c       ipher = 1
c       call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
c    *                    ipub,iphaz,wt,10,0.0,ipher)
!
        call DoSingleIteration()
c
c--statistiche
c
!        if(knw == 1 .and. ifOUT == 1) then    !pgMAD290409
        if(knw == 1) then
          izero = 0
          ifmin = 1
          kstp = 1
          ipher = 1
          if (kmad == 1) ipher = 0       ! patterson MAD pg230407

          call examin(numbrun,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
          tirang = 'NREFL_Patt'
          call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                    ipub,iphaz,wt,10,0.0,ipher)

          call examin(numbrun,mkang,khl,ipub,iphaz,numbLSQ,izero,wt,
     *                ifmin)
          tirang = 'NumbLSQ'
          ipher = 1
          if (kmad == 1) ipher = 0       ! patterson MAD pg230407
          call pherrdisNew(tirang,wt,khl,mkang,numbLSQ,izero,
     *                    ipub,iphaz,wt,10,0.0,ipher)
          call Calcola_CC_Mappa(numbLSQ,corre,kstp,2)

          call examin(numbrun,mkang,khl,ipub,iphaz,nstr,izero,wt,ifmin)
!
c         fasipatt(numbrun) = nint(erore)
!
          tirang = 'NSTR'
          ipher = 1
          if (kmad == 1) ipher = 0       ! patterson MAD pg230407
          call pherrdisNew(tirang,wt,khl,mkang,nstr,izero,
     *                    ipub,iphaz,wt,10,0.0,ipher)
          call Calcola_CC_Mappa(nstr,corre,kstp,2)
  
c         ns = nstr
c         if (ksize == 7 .and. LowRes == 0) then
c             ns   = 0.15 * numbLSQ 
c         endif
c             ncond1 = max(nstr,ns)
c         work1(1:numbLSQ) = wt(1:numbLSQ)
c         call sortall(-1,work1,numbLSQ)
c   
c         sog = work1(ncond1)
c         icont1=0
c         do i=1,numbLSQ
c            if (wt(i).lt.sog) then
c                wt(i) = 0.0
c             else
c                icont1=icont1+1
c             endif
c         enddo
c         write(lo,*)'NSTR,NSTRdyn,ICONT',nstr,ncond1,icont1
c         call examin(numbrun,mkang,khl,ipub,iphaz,numbLSQ,izero,wt,ifmin)
c         tirang = 'NSTART'
c         ipher = 1
c         call pherrdisNew(tirang,wt,khl,mkang,numbLSQ,izero,
c    *                    ipub,iphaz,wt,10,0.0,ipher)
c         call Calcola_CC_Mappa(numbLSQ,corre,kstp,2)
        endif
c-deb
!
!pgMAD150206
        if (kmad /= 0) then
           call Calcola_FOM_Early(corre)
           if (ifInvar == 1) then
              call absnew()
C--
              nuset = numbrun
              call fomsp(nuset, reje)
              stampa( 7) = FOMs(1,1)
              stampa(11) = FOMs(1,2)
              stampa(12) = FOMs(1,3)
              stampa(13) = FOMs(1,4)
              stampa(14) = corre
c--
              if (knw.gt.0) then
                    if (kverbo /= 0) then
                        write(lo,50)
     *                       (stampa(i),i=3,5),(stampa(i),i=8,10),
     *                       (stampa(i),i=11,14),reje(1:Lung(reje))
                    endif
                    call toflush()
              endif
c--
              if (knw.ne.0.and.erm1min.lt.999.0) then
                    write(lo,'(a,f6.2,a,f9.0,i12)')
     *                    '    Errore minimo=',erm1min,
     *                    '    nel trial ',setmin
              endif
           else              !!!!   CHIEDERE A PIERO PER CANCELLARE LA PARTE SUCC.
              fomrt(ntrbl,1:)= 1.0-(ntrbl-1)/float(MaxRun)
              fomrt(ntrbl,5)= FOMs(1,4)
              fomrt(ntrbl,6)= 0.0
              fomrt(ntrbl,7)= erore
              fomrt(ntrbl,8)= erorepes
              fomrt(ntrbl,10)= numbrun
!
              figMer(1:10) = fomrt(ntrbl,1:10)
!gl!          call snw16(ntrbl,figMer,wt,iphaz)
              call PutGetInitialPhases(1, ntrbl, figMer, wt, iphaz)
              SetsStored = SetsStored + 1
           end if

        else

           if(ksize<=3.or.icent==1.or.lproj/=0) then
!--per le piccole/medie uso la RAT
             call Calcola_FOM_Early(corre)
             foma= FOMs(1,4)
           else
!--per le proteine uso la FFfom  
             if(no(nk)>=20) then
               if(pts==1) then
                  foma=FFfom0/10.
               else
                  foma=1000/FFfom0
               endif
             else
               if(pts==1) then
                  foma=1000/FFfom0
               else
                  foma=FFfom0/10.
               endif
             endif
             if(LowRes==1.and.ksize>5) foma=FFfom0/10.

!!!          foma = h1/denom   
           endif

!-dedi-  altezza picco  = fom da usare in Sir2014 per S/M e Prot.
          foma = h1/denom   
!dedi


           FOMs(1,4) = foma

! le seguenti servono a forzare l'ordine se si richiedono piu' trials
         if (ntria == 1) then
             FOMs(1,4) = 11 - jCountRun
         endif

           absfom = 0.0
           coms   = 0.0
           nundet = 0
           nuset = numbrun
           call fomsp(nuset, reje)
c          write(6,*) 'numbrun,foma',numbrun,foma
        endif
        corre = 0.0
        call ManageEarlyFom(FOMs(1,4), corre, erore)
!d!1000   continue
      enddo  ! fine loop su ntrbl
!d!2000 continue
!
        if(iesCmap>0) then
           call DeallocaModello(1,ier)
        endif
!
      MaxToStore = MaxToStoreSav
c
c--deallocate Patt map
c
  51  continue
      call AllocaMappaPatterson(2) 
      call AllocaModelRemo(2)  !dedi 23/3/12
      nats = 0
      numbModels=numbModelsOld
!
c      if (knw == 1) then
c          write(6,'(a,20i3)') 'FASI ',fasipatt(1:20)
c      endif
 !
      return

   50 format(' FOMs',4f7.3,1x,2f6.2,4f7.3,2x,a)
      end
c-----------------------------------------------------------------------
      subroutine CalcolaFasiPatt_da_definire(ntrbl, ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Molcom
      USE PhaseModule
      USE Param
!
      character*9 cara
      character*80 line
      character*11 tirang

!
      character*10 reje
      dimension xor(3),xnew(3),s(3),xs(3)
!
      ier = 0
         jCountRun = jCountRun + 1
         if (numbTrials > 0) then
             numbrun = trialVett(ntrbl)
         else
             numbrun = ntrbl
         endif
         if (jBlock > 1) then
             numbrun = numbRun + sum(jBlocksPh(1,1:jBlock-1))
         endif
c        if (MaxRun .gt.1) then
c            if (jBlock == 1) then
c                kOffSet = 0
c            else
c                kOffSet = sum(jBlocksPh(1,1:jBlock-1))
c            endif
c            write(cara,10) ntrbl+kOffSet,MaxRun+kOffSet
c        else
c            write(cara,15) numbrun
c        endif

         if (MaxRun == 1 .or. ifPatt > 0) then
             write(cara,15) numbrun
         else
             if (jBlock == 1) then
                 kOffSet = 0
             else
                 kOffSet = sum(jBlocksPh(1,1:jBlock-1))
             endif
             write(cara,10) ntrbl+kOffSet,MaxRun+kOffSet
         endif

c        endif
         call NoBlanks(cara,icara)
         write(line,20) nstr,cara(1:icara)
         call scrper(line,ntrbl,MaxRun)
   10 format(i3,'/',i3)
   15 format(i3)
   20 format('Compute starting phases for',i5,
     *       ' reflections in Patterson trial ',a)
c
        if (numbrun > nats15) then
            write(6,*) 'peak ',numbrun,' not found within',
     &                                   nats15,' peaks' 
            ier = -1
            return
        endif

        if (ntrbl == 1) then
            inizTrial = numbrun
        endif
        if (ntrbl == MaxRun) then
            ifinTrial = numbrun
        endif
        
        x1=side(xyzo(1,numbrun))
        y1=side(xyzo(2,numbrun))
        z1=side(xyzo(3,numbrun))
        h1=xyzo(4,numbrun)
!
!--stampo informazioni circa la distanza dall'origine
!
        xor(1:3)=xyzo(1:3,numbrun)
        distmin=999.
        do k=2,nsymTot
          call oper(k,xs,x1,y1,z1)
          call xdist(xs,xor,dist,s)
          if(dist<distmin) distmin=dist
        enddo
c
        itria=numbrun

        if(kverbo==0) then
            write(lo,'(a,i5,f11.1,3f10.4,f10.2)') ' PEAK ',
     *          numbrun,h1,x1,y1,z1,distmin
        else
            atermNorm=volume*(4.0*Pi)/(pts*3.0*ResEff**3)
            backg=atermNorm*g_s_Patt(dist)
            write(lo,'(a,i5,f11.1,3f10.4,2f10.2)') 'PEAK',
     *          numbrun,h1,x1,y1,z1,distmin,backg
        endif

c
c--procedura per creare la mappa Fourier
c
        call DoSingleIteration()

!       
! -- dedi -- per azzerare le variabili della sigmaa  9/11/12
! -- azzera le variabili per ogni picco (come in Cicli_DSR, per ogni trial)       
        waveare = 0.0
        exposigma = 2.0
        RenveDyn = 0.0
! -- dedi -- per azzerare le variabili della sigmaa        


        call DoFourier(x1,y1,z1,ksezold, ier)
        if (ier < 0) return
c
c
c--procedura di riciclo Patterson
c
        call Riciclo3d(ksezold)
c
c--nuovi pesi
c
c----   pesi: HM con P(wt) "teorica"
c       izero = 0
c       ifmin = 1
c       call examin(numbrun,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
c       tirang = 'NREFL'
c       ipher = 1
c       call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
c     *                    ipub,iphaz,wt,10,0.0,ipher)
c       work1(1:nrefl) = wt(1:nrefl)
c       work2(1:nrefl) = wt(1:nrefl)
c       nsip1=100
c       nwizm1=25
c       call HistogramMatch(work1,work2,nrefl,nsip1,nwizm1,3)
c       wt(1:nrefl) = work1(1:nrefl)
c       izero = 0
c       ifmin = 1
c       call examin(numbrun,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
c       tirang = 'NREFL_HM'
c       ipher = 1
c       call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
c    *                    ipub,iphaz,wt,10,0.0,ipher)
!
        call DoSingleIteration()
c
c--statistiche
c
        if(knw==1) then
          izero = 0
          ifmin = 1
          kstp = 1
          ipher = 1
          call examin(numbrun,mkang,khl,ipub,iphaz,numbLSQ,izero,
     *                   wt,ifmin)
          tirang = 'NumbLSQ'
          ipher = 1
          call pherrdisNew(tirang,wt,khl,mkang,numbLSQ,izero,
     *                    ipub,iphaz,wt,10,0.0,ipher)
          call Calcola_CC_Mappa(numbLSQ,corre,kstp,2)
          call examin(numbrun,mkang,khl,ipub,iphaz,nstr,izero,wt,ifmin)
          tirang = 'NSTR'
          ipher = 1
          call pherrdisNew(tirang,wt,khl,mkang,nstr,izero,
     *                    ipub,iphaz,wt,10,0.0,ipher)
          call Calcola_CC_Mappa(nstr,corre,kstp,2)
  
c         ns = nstr
c         if (ksize == 7 .and. LowRes == 0) then
c             ns   = 0.15 * numbLSQ 
c         endif
c             ncond1 = max(nstr,ns)
c         work1(1:numbLSQ) = wt(1:numbLSQ)
c         call sortall(-1,work1,numbLSQ)
c   
c         sog = work1(ncond1)
c         icont1=0
c         do i=1,numbLSQ
c            if (wt(i).lt.sog) then
c                wt(i) = 0.0
c             else
c                icont1=icont1+1
c             endif
c         enddo
c         write(lo,*)'NSTR,NSTRdyn,ICONT',nstr,ncond1,icont1
c         call examin(numbrun,mkang,khl,ipub,iphaz,numbLSQ,izero,wt,ifmin)
c         tirang = 'NSTART'
c         ipher = 1
c         call pherrdisNew(tirang,wt,khl,mkang,numbLSQ,izero,
c    *                    ipub,iphaz,wt,10,0.0,ipher)
c         call Calcola_CC_Mappa(numbLSQ,corre,kstp,2)
        endif
c-deb
!
!pgMAD150206
        if (kmad /= 0) then
           call Calcola_FOM_Early(corre)
           if (ifInvar == 1) then
              call absnew()
C--
              nuset = numbrun
              call fomsp(nuset, reje)
              stampa( 7) = FOMs(1,1)
              stampa(11) = FOMs(1,2)
              stampa(12) = FOMs(1,3)
              stampa(13) = FOMs(1,4)
              stampa(14) = corre
c--
              if (knw.gt.0) then
                    if (kverbo /= 0) then
                        write(lo,50)
     *                       (stampa(i),i=3,5),(stampa(i),i=8,10),
     *                       (stampa(i),i=11,14),reje(1:Lung(reje))
                    endif
                    call toflush()
              endif
c--
              if (knw.ne.0.and.erm1min.lt.999.0) then
                    write(lo,'(a,f6.2,a,f9.0,i12)')
     *                    '    Errore minimo=',erm1min,
     *                    '    nel trial ',setmin
              endif
           else              !!!!   CHIEDERE A PIERO PER CANCELLARE LA PARTE SUCC.
              fomrt(ntrbl,1:)= 1.0-(ntrbl-1)/float(MaxRun)
              fomrt(ntrbl,5)= FOMs(1,4)
              fomrt(ntrbl,6)= 0.0
              fomrt(ntrbl,7)= erore
              fomrt(ntrbl,8)= erorepes
              fomrt(ntrbl,10)= numbrun
!
              figMer(1:10) = fomrt(ntrbl,1:10)
!gl!          call snw16(ntrbl,figMer,wt,iphaz)
              call PutGetInitialPhases(1, ntrbl, figMer, wt, iphaz)
              SetsStored = SetsStored + 1
           end if

        else
           if(ksize<=3) then
!--per le piccole/medie calcolo la early FOM
             call FomTrip_Patt() 
             foma=Fom_TripM
             if (no(nk) >= 20 .and. jsys > 1) then ! da verificare
                 fcoef(:) = fcoef(:) * wt(:)
                 jpatt = 0
                 call MakeMap(fcoef, iphaz, nrefl, jpatt, xmap,
     *                FORTH, BACK)
                 call maxminSir(np(1),np(2),np(3),xmap)
                 fomastd=stden/5000.0
                 foma=Fom_TripM*fomastd
             endif
           else
!--per le proteine uso l'altezza del picco come FOM 
             foma=0.0 
           endif

           FOMs(1,4) = foma
           absfom = 0.0
           coms   = 0.0
           nundet = 0
           nuset = numbrun
           call fomsp(nuset,reje)
c          write(6,*) 'numbrun,foma',numbrun,foma
        endif
        corre = 0.0
        call ManageEarlyFom(FOMs(1,4), corre, erore)
!
      return
   50 format(' FOMs',4f7.3,1x,2f6.2,4f7.3,2x,a)
      end
!---------------------------------------------------------
      subroutine Deconvolution(ksezold,ierr)
      USE General
      USE Symmetry     
      USE Riflessi
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE MappaCorrezione
      USE Seminvariants
      USE Molcom
      USE PhaseModule
      USE Param, only: ifExtra
      USE CorrMod
      USE Riflessi_Pub
!
      common /cent/ tl(12),fs(216),mlat ! occhio
      integer cicliFour
!
      integer h(3,3)
      dimension h1(3,3)
      character*3 xyzc
      dimension Hvet(50,3,3),Tvet(50,3)
      integer Htype(50,3)
      dimension al1(4),bs1(4)

      character*200 FileMapName
!
      real, dimension(3)            :: xo,xo1,xo2,xeq,s
      real, dimension(2)            :: vet
      ifin = icent + 1
      vet(1)= 1.0
      vet(2)=-1.0
!
*     nOrigRoxi = nOrigRoxi / 2   !!! PEZZA
*     tabo(3,1:3) = (/0.25, 0.0, 0.0 /)
*     tabo(4,1:3) = (/0.25, 0.0, 0.5 /)
!
      if(kverbo>0) then
        write(6,*) 'Grid sampling:',np
        do i=1,nOrigRoxi
          write(6,'(a,i4,3f8.3)') 'origini permesse',i,tabo(i,1:3)
        enddo
        xyzc = 'xyz'
      endif
c
c-- inizializzazioni
c
c     if(numbGen>0) then
c       numbMax = nreflTot
c       write(6,*) 'Sto usando i riflessi estrapolati',
c    &                    numbLSQ,nrefl,nreflTot
c     else
        numbMax = numbLSQ
c     endif
c
c--- azzeramenti
c
      ksezold=0
      iswitch_3D=0
      xmap(:,:,:)=0.0
      Hvet(:,:,:)=0
      Tvet(:,:)=0
      Htype(:,:)=0
      NsezHarker=0
c
c-- calcolo della jtable 
c
      call seminv(ier)
!
!
!-- create the Patterson Map
!
*gl*  evet(:) = fovet(:)    !!!! TEST
      fcoef(:)=0.0
      wt(:)=0.0
!
      if(kverbo>0) then
        write(6,'(a,/,4(a,i2))') 'Structure main parameters: ',
     &     'ksize=',ksize,' iwei=',iwei,' LowRes=',LowRes,' jsys=',jsys
      endif
!
!--interruttore per vecchia procedura
!
      if(ksize<=4.and.iwei==0.and.jsys<=3) then
        iold=1
      else
        iold=0
      endif
      if(ksize<=3) iold=0
c
c--interruttore di pesaggio della Patterson
c
      if(LowRes==0.or.no(nk)>16) then
         iesPatt=1
      else
         iesPatt=0
         if(iold==1) iesPatt=-1
      endif
      if(ksize<=3.or.
     &    (LowRes==1.and.no(nk)<=20.and.is3s2<3000)) iesPatt=-1
 
      if (kmad == 1) then    ! patterson MAD pg230407
         iesPatt = -1
         iold = 1
      endif
 
      if (neutro == 1) then    ! patterson per neutroni gianluca 14/05/08
         iesPatt = -1
         iold = 1
      endif

      if (nowei == 1) then
         iesPatt = -1   ! Patterson non pesata
      endif
c
c--pesaggio della Patterson
c
      if(iesPatt<0) then
        if (knw == 1) then
            write(6,*) 'Patterson not weighted'
        endif
      elseif(iesPatt==1) then
        if (knw == 1) then
            write(6,*) 'Patterson weighted using scattering factors'
        endif
        rhominP=0.0
!!!!!   rhominP = minval(rhov(1:nrefl)) 
        rhomaxP = maxval(rhov(1:nrefl)) 
        if(no(nk)>16) then
c--considero il fattore di scattering dell'atomo piu' pesante
          ff(nk)=cl(nk)
          do ii=1,4
             ff(nk)=ff(nk)+al(ii,nk)*exp(-bs(ii,nk)*rhominP)
          enddo
          ffnkmin=ff(nk)
          ff(nk)=cl(nk)
          do ii=1,4
             ff(nk)=ff(nk)+al(ii,nk)*exp(-bs(ii,nk)*rhomaxP)
          enddo
          ffnkmax=ff(nk)
        else
c--carico i fattori di scattering dello zolfo come rappresentativo
c  dell'atomo piu' pesante
           cl1=0.86690
           al1(1:4)=(/6.9053,  5.2034,  1.4379,   1.5863 /)
           bs1(1:4)=(/1.4679, 22.2151,  0.25360, 56.172  /)
           ff(nk)=cl1
           do ii=1,4
              ff(nk)=ff(nk)+al1(ii)*exp(-bs1(ii)*rhominP)
           enddo
           ffnkmin=ff(nk)
           ff(nk)=cl1
           do ii=1,4
              ff(nk)=ff(nk)+al1(ii)*exp(-bs1(ii)*rhomaxP)
           enddo
           ffnkmax=ff(nk)
        endif
!
!--scelgo il tipo di atomo di riferimento (carbonio, se presente)
!
        iatom=0
        do i=1,nk
          if(no(i)==6) iatom=i
        enddo
        if(iatom==0)  iatom=1
c       write(6,*) 'atomo di riferimento',iatom,no(iatom),no(nk),LowRes
!
        ff(iatom)=cl(iatom)
        do ii=1,4
          ff(iatom)=ff(iatom)+al(ii,iatom)*exp(-bs(ii,iatom)*rhominP)
        enddo
        ff2min=ff(iatom)
        ff(iatom)=cl(iatom)
        do ii=1,4
          ff(iatom)=ff(iatom)+al(ii,iatom)*exp(-bs(ii,iatom)*rhomaxP)
        enddo
        ff2max=ff(iatom)
c
      else
         if (jBlock == 1) then
             write(6,*) 'Patterson weighted with empiric function'
         endif
!
!-- calculate curve
!
          resol = 5.0
          sog = resol - 0.5
          nsog = numbMax * 0.025
          kVai = 1
          Cicli: do while (kVai.eq.1)
             do i=1,numbMax
                work1(i) = 0.5 / sqrt(rhov(i))
             enddo
             call sortall(-1,work1,numbMax)
             sog = sog + 0.5
             ncont = 0
             do i=1,numbMax
                if (work1(i).gt.sog) then
                    ncont = ncont + 1
                endif
             enddo
             if (ncont <= nsog) then
                 resol = sog
                 kVai = 0
             endif
          end do Cicli

c         write(6,*) 'soglia in risoluzione',resol
          rhosog = 0.5 / resol
          rhosog = rhosog **2
          rho11 = -999  !max
          rho22 =  999  !min
          do i=1,numbMax
             rho = rhov(i)
             if (rho > rho11) then
               rho11 = rho
             elseif (rho < rho22) then
               rho22 = rho
             endif
          enddo
          deltarho = rho11 - rho22
          argsog = (rhosog - rho22) / deltarho
      endif
c
*     write(6,*) 'WT',iesPatt,no(nk),iatom,ffnkmin,ff2min
*     write(6,*) 'WT',ffnkmin,ff2min,ffnkmax,ff2max
*     write(6,*) 'WT',Complet,LowRes,ksize,resm

      do i=1,numbMax
        rho=rhov(i)
        if(iesPatt<0) then
          wt(i)=1.0
        elseif(iesPatt==1) then
          if(no(nk)>16) then
            ff(nk)=cl(nk)
            do ii=1,4
              ff(nk)=ff(nk)+al(ii,nk)*exp(-bs(ii,nk)*rho)
            enddo
          else
            ff(nk)=cl1
            do ii=1,4
              ff(nk)=ff(nk)+al1(ii)*exp(-bs1(ii)*rho)
            enddo
          endif
          ff(iatom)=cl(iatom)
          do ii=1,4
            ff(iatom)=ff(iatom)+al(ii,iatom)*exp(-bs(ii,iatom)*rho)
          enddo
          wt(i)=(ff(nk)/ff(iatom)   -  ffnkmin/ff2min)/
     &        (ffnkmax/ff2max -  ffnkmin/ff2min)
          if(0.5/sqrt(rhov(i))>5.0) wt(i)=0.0 
        else
          arg = ( rho - rho22 ) / deltarho
          arg = (arg / argsog) - 1
          pesetto  = 1 - (0.5 * (1 - tanh(twopi * arg)))
          wt(i) = pesetto * pesetto
        endif
        if(Complet<0.9.and.LowRes==0.and.ksize<7) wt(i)=1
        if(ksize<7) then
           fcoef(i) = evet(i) * evet(i)
        else
           if(resm<1.0.and.no(nk)>=20) then
              fcoef(i) = evet(i) * evet(i) - resm * resm
           else
              fcoef(i) = evet(i) * evet(i)
           endif
        endif
      enddo
!
c     if (jBlock == 1) then
c        ppmax = -99.9
c        ppmin =  99.9
c        zero = 0.00001
c        sum1 = 0
c        sum2 = 0
c        do i=1, nrefl
c           resi = 0.5 / sqrt(rhov(i))
c           write(6,*) 'wt(i)',i,evet(i),resi,wt(i)
c           if (wt(i) > ppmax) ppmax = wt(i)
c           if (wt(i) < ppmin .and. wt(i) > zero) ppmin = wt(i)
c           sum1 = sum1 + wt(i)
c           if (i <= numbMax) sum2 = sum2 + wt(i)
c        enddo
c        sum1 = sum1 / nrefl
c        sum2 = sum2 / numbMax
c        write(6,*) '<wt(i)>', nrefl,sum1,numbMax,sum2
c     endif
!
!-- switch to the Patterson Space Group
!
      icent=1
      tmat(:,:)=0.
      call musym()
      nsymTot=nsym*(icent+1)*pts
c
c--faccio la mappa patterson con il gruppo Patterson
c

!!!   fcoef(:) = fcoef(:) * wt(:)

      if (numbGen == 0 .or. ifNewPat == 0) then

         fcoef(:) = fcoef(:) * wt(:)
         jpatt = 1
         call MakeMap(fcoef, iphaz, numbMax, jpatt, xmap,
     *                FORTH, BACK)

      else
!
          numb = numbMax
c         numb = nrefl

          numberToUse = numb
!
!!!
!!!--faccio la mappa patterson e uso gli estrapolati
!!!   

c        wtobs = 0.85
c        do i = 1, numbMax
c           wt(i) = wtobs   ! 1.0  !!!!!!!!!!!!!!
c           ressa = 0.5 / sqrt(rhov(i))
!           if (ressa > 5.0) wt(i) = 0.0
c        enddo
c        wt(numbMax+1:) = 0.0  !!!!!!!!!!!!!!

         fcoef(:) = evet(:) * evet(:) * wt(:)
         fcvet(:) = 0.0

         jpatt = 1
         call MakeMap(fcoef, iphaz, numberToUse, jpatt, xmap,
     *                FORTH, BACK)
!
         inizio = 1 
         ifine = 3 
         wtext = 0.15 
c        wtext = 0.0
         do ii = inizio, ifine
               nnuu = numberToUse * 0.5 !3 / 5 
               numberToInv = min0(nrefl + nnuu,nreflDim)  

               invflag =  1
               percMap = 0.2 !0.3

c              invflag =  33 ! Flipping parte negativa
c              percMap = 0.2 
c              percMap_n = 0.05 
            
            if (ii == 1 .and. iheavy == 1) then
                call Esalta_Patterson(ier)
                invflag =  1
                percMap = 0.3
            endif

               call InvMap(khl,mkang,iphaz,fcvet,numberToInv)

               resA = 0.5 / sqrt(rhov(nrefl))
               resB = 0.5 / sqrt(rhov(numberToInv))

!
!-- Rinormalizzo Ecalc per riflessi generati
!
              work1(:) = 0.0
              work2(:) = 0.0
              nreflSHL = numberToInv
              do i = 1,nreflSHL
                 jj = i
                 work1(i) = sqrt(fcvet(jj))
                 work2(i) = rhov(jj)
              enddo
              call Renor2004(1)
c          write(6,*) 'XXXXXXXXXXXXXXXXXXXXXXxxxxxxxxxxxxxxxxxxxxxxxx'
!             somEp = 0
!             somEc = 0
              do i = 1,nreflSHL
                 jj = i
                 if (work1(i) > evet(1)) then
                    work1(i) = evet(1) * 0.9
                 endif
                 fcvet(jj) = work1(i) **2
                 ressa = 0.5 / sqrt(rhov(jj))
!                if (i > nrefl) then
c                    write(6,*) jj, Epub(jj), work1(i), ressa 
!                    somEp = somEp + Epub(jj)
!                    somEc = somEc + work1(i)
!                endif
              enddo
   
!          sca = somEp / somEc
!          delEpEc = 0.0
!          do i = nrefl+1,nreflSHL
!             delEpEc = delEpEc + abs(Epub(i) - sca*work1(i))
!          enddo
!          rrr = delEpEc / somEp
              
              if (LowRes == 0) then
                  wtext = 0.30
              else
                  wtext = 0.20
              endif

c             wtext = wtext + 0.1

               write(6,'(a,i4,3(i9,f7.3),2f7.3)')'INVERSIONE PATTERSON', 
     *     ii, nrefl, resA, numberToInv, resB, nnuu, percMap, wtext  !, rrr

c       fcoef(1:numbMax) = evet(1:numbMax) * evet(1:numbMax) * wtobs
c              fcoef(numbMax+1:nrefl) = 0.0

               do i = nrefl+1, numberToInv
                  wt(i) = wtext
                  fcoef(i) = fcvet(i) * wt(i)
c                 fcoef(i) = (Epub(i) ** 2.) * wt(i)
                  ressa = 0.5 / sqrt(rhov(i))
c                 if (ressa > 5.0) fcoef(i) = 0.0 
                   tmpwt(i) = wt(i)
               enddo

               jpatt = 1
               call MakeMap(fcoef, iphaz, numberToInv, jpatt, xmap,
     *                FORTH, BACK)

         enddo ! ii

12345    continue
!!!
      endif

!     aperc(1) = 100
!     iflagPKS = 0
!     mode = -1
!     krecy = 0
!     call pksrch_New(mode, iflagPKS, numb,ier)

!     ii = 0
c     call pksrch_big_RocPat(1,ier)
!     write(6,'(a,2i9)') ' Info peaks in Patterson:',ii, nats
!     do i = 1, nats
!        write(6,'(i6,5f15.3)') i,xyzs(:,i)
!     enddo

!
!-- TEST JAV
!
*     call ViewMaps(xmap, np)
!
*     aperc(1) = 100
*     iflagPKS = 0
*     mode = -1
*     krecy = 0
*     call pksrch_New(mode, iflagPKS, numb,ier)

!     call pksrch_big_RocPat(1,ier)
!     write(6,'(a,i9)') ' Info peaks in Patterson pksRP:',nats
!     do i = 1, nats
!        write(6,'(i6,5f15.3)') i,xyzs(:,i)
!     enddo
!
*     k = index(fname(1),'.bin')-1
*     FileMapName = fname(1)(1:k) // '_patt.map'
*     call CCP4MAPOUT(jpatt,xmap,np,FileMapName)
!

c--deb
c     nnp2 = np(2)/2
c     do ix=0,np(1)-1     !  scrittura mappa patterson su fort.79
!     do iy=0,np(2)-1
c     do iy=nnp2,nnp2
c     do iz=0,np(3)-1
c       write(79,*) ix,iy,iz,xmap(ix,iy,iz)
c     enddo
c     enddo
c     enddo
c--deb
!
!-- restore the original Space Group
!
      call CreaSymmetryInfo(ier)
!
c
c--riduco l'altezza dei picchi nell'intorno dell'origine della Patterson
c
*     aperc(1) = 100
*     iflagPKS = 0
*     mode = -1
*     krecy = 0
*     call pksrch_New(mode, iflagPKS, numb,ier)

*     write(6,'(a,i9)')'Info peaks in Patterson: gruppo spaz. Fourier'
*     do i = 1, nats
*        write(6,'(i6,5f15.3)') i,xyzs(:,i)
*     enddo


      call RiduciOrigine(0)  ! da non fare se uso la Patterson con E*E-1  
!
*     aperc(1) = 100
*     iflagPKS = 0
*     mode = -1
*     krecy = 0
*     call pksrch_New(mode, iflagPKS, numb,ier)
c     call pksrch_big_RocPat(1,ier)

*     write(6,'(a,i9)') ' Info peaks dopo RiduciOrigine:'
*     do i = 1, nats
*        write(6,'(i6,5f15.3)') i,xyzs(:,i)
*     enddo

!     call pksrch_big_RocPat(1,ier)
!     write(6,'(a,i9)') ' Info peaks dopo RiduciOrigine pksRP:',nats
!     do i = 1, nats
!        write(6,'(i6,5f15.3)') i,xyzs(:,i)
!     enddo
!

c
c--provo a fare un taglio sulla Patterson generale
c
      if(ksize>=3) then ! da verificare
        if(iesSnip==1) then
          call snipmap(xmap,2)
c--deb
c     nnp2 = np(2)/2
c     do ix=0,np(1)-1     !  scrittura mappa patterson su fort.89
!     do iy=0,np(2)-1
c     do iy=nnp2,nnp2
c     do iz=0,np(3)-1
c       write(89,*) ix,iy,iz,xmap(ix,iy,iz)
c     enddo
c     enddo
c     enddo
c--deb
        else
          invflag = 10
          call maxmin3dPatt(denmin,denmax,avden,stden)
          if(iold==0) then
            sog=avden+1.0*stden
          else
            sog=avden+0.66*stden
          endif
          if (neutro == 1) then
            sog=avden+0.50*stden
          endif
          call changesection3d(sog,nmod,denmin) 
          if (kverbo > 0) then
            denom=np(1)*np(2)*np(3)
            write(6,'(a,4f15.2,f8.3,a)') 'change Patterson  first',
     &      denmax,avden,stden,sog,100*((denom-float(nmod))/denom),'%'
          endif
c--deb
c     nnp2 = np(2)/2
c     do ix=0,np(1)-1     !  scrittura mappa patterson su fort.99
!     do iy=0,np(2)-1
c     do iy=nnp2,nnp2
c     do iz=0,np(3)-1
c       write(99,*) ix,iy,iz,xmap(ix,iy,iz)
c     enddo
c     enddo
c     enddo
c--deb
        endif
      endif
c
!-- save the Patterson Map in Patt
!
      Patt = xmap
!
!-- loop on different Harker Sections:
!--    by means of the working table ( jtable ) consider
!--    only indipendent symmetry operators.
c attenzione: le sezioni indipendenti si trovano solo sul primo
c indice, per i2=1, mentre per gli altri i2=2,..,iimax si trovano
c le sezioni non indipendenti
!
c--deb
*     write(6,*) 'jtab  ',iimax,jmax
*     do jj1=1,iimax
*        write(6,*) 'jtable',jtable(jj1,1:jmax)
*     enddo
c--deb
!
      do j2=1,jmax 
         kkk = jtable(1,j2) 
         if (kkk<=0) cycle
!
!-- compute the matrix  h = ( i - rs )  where  s = jtable(i,j)
!-- calcola traccia e determinante della matrice  rs   dove  s = jtable(i,j)
!
         ntraccia=0
         do i1=1,3

           do j1=1,3
             h(i1,j1) = -kmat(kkk,j1,i1)
             h1(i1,j1) = kmat(kkk,j1,i1)
           enddo
           h(i1,i1) = h(i1,i1) + 1
           ntraccia=ntraccia+h1(i1,i1)
         enddo
c--deb
*        write(6,*) 'kkk',kkk
*        do i=1,3
*           write(6,*) 'kmat',kmat(kkk,1:3,i)
*        enddo
*        write(6,*) 'tmat',tmat(kkk,1:3)
*        do i=1,3
*           write(6,*) 'eccolo',h(1:3,i)
*        enddo
c--deb
         call deter3(h1,deter)
!
! prende solo lo spazio per g .s. centro
!
         if (ksize <= 3) then       ! patterson per piccole
             if(icent==1 .and. deter*ntraccia/=3 .and. jsys>3) cycle
         end if
!
         if(j2==jmax.and.ntraccia==-3.and.jsys/=1) then
              if(kverbo>0) write(6,*) 'Matrice eliminata'
              cycle  ! elimino la matrice -1 in piu'
         endif
c
c--calcolo inum = numero di righe nulle di H 
c
         inum1=0
         inum=0
         do i=1,3
           if (h(i,i).eq.0) then
             inum1=0
             do j=1,3
               if(i==j) cycle
               if (h(j,i).eq.0) inum1=inum1+1
             enddo
             if(inum1==2) inum=inum+1
           endif
         enddo
c
c--single out the current section
c
c-------    REM:
c  sezioni perpendicolari
c  ksez=3: z costante /   ksez=1: x costante /   ksez=2: y costante /   
c  linee   perpendicolari
c  ksez=13: z costante /  ksez=11: x costante /  ksez=12: y costante /   
c-------    REM:
c
         if(inum==3) then
c--Matrice nulla 
           if (kverbo > 0) then
             write(6,*) 'Null H, not processed'
           endif
           cycle
         elseif(inum==2) then
c--Linea di Harker perpendicolare
           ksez=0
           do i=1,3
             if (h(i,i).ne.0) then
               ksez = 10 + i
             else
             endif
           enddo
           if (jmax > 1) then    !patterson per gruppo spaziale C c
             if (kverbo > 0) then
               write(6,*) 'Perpendicular Harker Line'
             endif
             cycle
           endif
         elseif(inum==1) then
c--Sezione di Harker perpendicolare
           alim=0
           ksez=0
           do i=1,3
             if (h(i,i).eq.0) then
               alim = -tmat(kkk,i)
               if (alim.lt.0.0) then
                 alim = alim + 1
               endif
               ksez = i
               lsez = nint( alim * np(i) )
             endif
           enddo
           if (kverbo > 0) then
              write(lo,10) xyzc(ksez:ksez),alim,lsez,ksez
           endif
         else
c--Spazio di Harker, oppure Sezione o Linea di Harker non perpendicolare
           ksez=0
         endif
         if(kverbo>0) then
           write(6,'(a,i4,f8.2,2i4)') 'traccia,det,ksez,inum'
     &                        ,ntraccia,deter,ksez,inum
         endif
c
c--conto le sezioni di Harker indipendenti e memorizzo il loro puntatore
c
         NsezHarker=NsezHarker+1
         do i1=1,3
           Tvet(NsezHarker,i1)=side(-tmat(kkk,i1))
           do j1=1,3
            Hvet(NsezHarker,i1,j1)=h(i1,j1)
           enddo
         enddo
         Htype(NsezHarker,1)=ksez
         Htype(NsezHarker,2)=ntraccia
         Htype(NsezHarker,3)=deter
         if(iswitch_3D==0) then
           if(NsezHarker==1) then
             ksezold=ksez
             if(ksez==0) iswitch_3D=1
           else
             if(ksez<10) then
               if(ksez/=ksezold) then
                  iswitch_3D=1
               endif
             else
               kksez=mod(ksez,10)
               if(kksez==ksezold) then
                  iswitch_3D=1
               endif
             endif
           endif
         endif
c
         if(iold==1.or.ksize<=3) then   
           if(ksez==0.or.ksez>10) cycle 
           xmap = Patt
           if(Lowres==0.and.ksize>3) then
             call ZeroHarkermio(ksez,alim,1)
           else
             call ZeroHarkermio(ksez,alim,0)
           endif

           if(iesSnip==1) then
             call snipmap2D(xmap,ksez,1)
           else
             invflag = 31
             call maxminnew(denmin,denmax,avden,stden,npunt,ksez)
             stdenn = stden
             call changesectionnew(stdenn,nmod,denmin,ksez)
           endif

           call ZeroHarkertuo(ksez,alim)
         endif
      enddo   ! enddo sulle possibili sezioni di Harker
c
ccc    NsezHarker=1  ! occhio
c
      if(kverbo>0) then
        do i=1,NsezHarker
          write(6,'(a,i4)') 'SEZ',i
          write(6,'(a,3(3f8.2))') 'Hvet',Hvet(i,1:3,1:3)
          write(6,'(a,3f8.2)') 'Tvet',Tvet(i,1:3)
        enddo
      endif
c
c--procedura per creare la mappa SMF
c
      call DoSingleIteration()
!
!--interruttore per accedere alla procedura per il triclino
!
      if(jsys==1.and.icent==0) iswitch_3D=-1
c
      if(iswitch_3D<0) then  
c--triclino 
c       if(icent==1) ifRelax=1
c       ifRelax=1 ! da controllare
        if(kverbo>0) write(6,*) 'DoSMF_tricl'
        ksezold=-1
        call DefineSMFSymmetry(ksezold)
        call DoSMF_tricl(ksezold,ierr)
      elseif(iswitch_3D==0) then
c--Sezioni di Harker in una sola direzione
        if(kverbo>0) write(6,*) 'DoSMF_1D'
        call DefineSMFSymmetry(ksezold)
        call DoSMF_1D(NsezHarker,Hvet,Tvet,Htype,ksezold,ierr)
      else
c--Sezioni di Harker in piu' di una direzione
        if(kverbo>0) write(6,*) 'DoSMF_3D'
        ksezold=0
        call DefineSMFSymmetry(ksezold)
        call DoSMF_3D(NsezHarker,Hvet,Tvet,Htype,ksezold,iold,ierr)
      endif
      call DoSingleIteration()
c
      PattOrig = Patt
!
      return
  10  format(' Harker section ',a1,' = ',f6.3,'  Layer = ',i3,
     &                             ' ksez=',i3)
c
      end
c-----------------------------------------------------------------------
      subroutine DoSMF_3D(NsezHarker,Hvet,Tvet,Htype,ksezold,iold,ierr)
c
c--Patterson method for Harker in 3 dimensions
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Riflessi
      USE Seminvariants
      USE Molcom
      USE PhaseModule
      integer sidepp
      dimension iuvw(3)
      dimension Harkerheight(50)
      dimension Hvet(50,3,3),Tvet(50,3)
      integer Htype(50,3)
c
      if(jsys<=3) then
        pesomin=0.9
      else
        pesomin=1.0
      endif
c     write(6,*) 'pesomin',pesomin,jsys
c     pesomin=0.8
c     pesomin=0.5
c     pesomin=0.2
c     pesomin=0.0
c
c--per la costruzione della SMF elimino del tutto il picco all'origine nella
c  Patterson
c
cdedi-150507    xmapApp == xenve  versione precedente
      xmapApp=Patt
      call DropZeroPeak()
      SMF=0.0
c
c--faccio il tagli alla Patterson
c
      xmap=Patt
c
      if(iesSnip==1) then
        call snipmap(xmap,1)
      else
        invflag = 10
        call maxmin3d(denmin,denmax,avden,stden,npunt,1)
        if (neutro == 0) then
          sog=avden+1.0*stden
        else
          sog=avden+0.5*stden
        endif
        call changesection3d(sog,nmod,denmin)
        if (kverbo > 0) then
            denom=np(1)*np(2)*np(3)
            write(6,'(a,4f15.2,f8.3,a)') 'change Patterson ',
     &      denmax,avden,stden,sog,100*((denom-float(nmod))/denom),'%'
        endif
      endif
c       
c--anticipo del calcolo di FOM e ImproveRiciclo
c       
      call CercaPicchiPatt()   
      Patt=xmap
      xmapShi=Patt
c
c--regola la molteplicità della sezione di Harker
c  vale solo per l'asse 4 o 6. Sono sempre le ultime sezioni di Harker!!
c
      HarkerMult=1.0
!--se non ho componenti traslazionali.....
      if(sum(Tvet(NsezHarker,1:3))<0.01)  then
!--e ho asse 4 o 6
        if(jsys>3.and.Hvet(NsezHarker,2,2)<2.01.and.ifRhombAx==0) then
           HarkerMult=0.5
           if (jBlock == 1) then
               write(6,*) 'Harker Multiplicity set on...'
           endif
        endif
      endif
c
c--costruisco la SMF
c
      iassepari=0
      do iz = 0, np(3)-1
        do iy = 0, np(2)-1
          do ix = 0, np(1)-1
            do k=1,NsezHarker
              do i1=1,3
                ntermm=Hvet(k,1,i1)*ix+Hvet(k,2,i1)*iy+Hvet(k,3,i1)*iz
                ntermm=ntermm+nint(Tvet(k,i1)*np(i1))
                iuvw(i1)=sidepp(ntermm,np(i1))
              enddo
!--elimino le sezioni di Harker nel Riciclo
              call CancSpread(iuvw(1),iuvw(2),iuvw(3))
              ksez    = Htype(k,1)
              ntraccia= Htype(k,2)
              kdet    = Htype(k,3)
              if(ntraccia*kdet==2) then
c--asse 6
                iassepari=1
                Harkerheight(k)=HarkerMult*
     &             spreadpeak_clever(iuvw(1),iuvw(2),iuvw(3))
              elseif(ntraccia*kdet==1) then
c--asse 4
                iassepari=1
                Harkerheight(k)=HarkerMult*
     &             spreadpeak_clever(iuvw(1),iuvw(2),iuvw(3))
              elseif(ntraccia*kdet==0) then
c--asse 3
                if(ksez==0) then
c         diagonale
                  Harkerheight(k)=
     &             spreadpeak_clever(iuvw(1),iuvw(2),iuvw(3))
                else
c         perpendicolare
                  Harkerheight(k)=
     &             spreadpeak_clever(iuvw(1),iuvw(2),iuvw(3))
                endif
              elseif(ntraccia*kdet==-1) then
c--asse 2
                if(ksez==0) then
c         diagonale
                  Harkerheight(k)=
     &             spreadpeak_clever(iuvw(1),iuvw(2),iuvw(3))
                elseif(ksez>10) then
c         linea di Harker
                  Harkerheight(k)=
     &            spreadpeak_linea(xmapApp,iuvw(1),iuvw(2),iuvw(3),ksez)
                else
c         perpendicolare
                  if(jsys==3) then
                    if(iold==0) then
                      Harkerheight(k)= 
     &            spreadpeak_asse2(xmapApp,iuvw(1),iuvw(2),iuvw(3),ksez)
                    else
                      Harkerheight(k)=xmapApp(iuvw(1),iuvw(2),iuvw(3))  ! occhio
                    endif
                  else
                    Harkerheight(k)=
     &               spreadpeak_clever(iuvw(1),iuvw(2),iuvw(3))
                  endif
                endif
              elseif(ntraccia*kdet==3) then
c--centro di inversione
                  Harkerheight(k)=xmapApp(iuvw(1),iuvw(2),iuvw(3))
              endif
            enddo
c
            Nstart=1+iassepari
c           Nnum=NsezHarker-Nstart+1
            xx=minval(Harkerheight(Nstart:NsezHarker)) 
            yy=sum(Harkerheight(Nstart:NsezHarker)) 
c           yy=yy/float(Nnum)
c           write(6,*) 'peso 3D',xx,yy,pesomin
            xx=pesomin*xx+(1.-pesomin)*yy
c           write(6,*) 'peso new',xx
c           if(abs(ix-77)<3.and.abs(iy-103)<3.and.abs(iz-36)<3) then
c              write(6,*) ix,iy,iz,Harkerheight(1:NsezHarker),xx  ! deb
c           endif
            if(xx<0.0) xx=0.0
            xmap(ix,iy,iz)=xx
          enddo
        enddo
      enddo
c
c--modifico la SMF in modo che le posizioni equivalenti secondo
c     la simmetria SMF abbiano la stessa altezza
c
c     if(iold==0) call RestoreSMF(0)     ! occhio
      if(iesSnip==1) then
        call snipmap(xmap,2)
      endif
      call RestoreSMF(0)     
c
c--conserva la SMF finale per la procedura multi-soluzione
c
      SMFtrue=xmap
c
c--ricerca i picchi da considerare
c
      call CercaPicchi(NsezHarker,Hvet,Tvet,Htype,ksezold,ierr)
c
      return
      end
!-------------------------------------------------------------
      subroutine DoSMF_1D(NsezHarker,Hvet,Tvet,Htype,ksezold,ierr)
c
c--Patterson method for Harker in 1 dimension
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Riflessi
      USE Seminvariants
      USE Molcom
      USE PhaseModule
      dimension iuvw(3)
      dimension Harkerheight(50)
      dimension Hvet(50,3,3),Tvet(50,3)
      integer Htype(50,3)
      integer sidepp

c
      pesomin=0.9
c     pesomin=0.8
c     pesomin=0.2
c     pesomin=0.5
c     write(6,*) 'pesomin',pesomin,jsys,NsezHarker
c
c--per la costruzione della SMF elimino del tutto il picco all'origine nella
c  Patterson
c
      xmapApp=Patt
      call DropZeroPeak()
      SMF=0.0
c
c  costruisco la SMF per colonne e la memorizzo 
c                 per la procedura multisoluzione
c
      xmapShi=Patt
c
c--regola la molteplicità della sezione di Harker
c  vale solo per l'asse 4 o 6. Sono sempre le ultime sezioni di Harker!!
c
      HarkerMult=1.0
!--se non ho componenti traslazionali.....
      if(sum(Tvet(NsezHarker,1:3))<0.01)  then
!--e ho asse 4 o 6
        if(jsys>3.and.Hvet(NsezHarker,2,2)<2.01.and.latt/=7) then
           HarkerMult=0.5
           write(6,*) 'Harker Multiplicity set on...'
        endif
      endif
      iassepari=0
      do iz = 0, np(3)-1
        do iy = 0, np(2)-1
          do ix = 0, np(1)-1
            do k=1,NsezHarker
              do i1=1,3
                ntermm=Hvet(k,1,i1)*ix+Hvet(k,2,i1)*iy+Hvet(k,3,i1)*iz
                ntermm=ntermm+nint(Tvet(k,i1)*np(i1))
                iuvw(i1)=sidepp(ntermm,np(i1))
              enddo
!--elimino le sezioni di Harker nel Riciclo
              call CancSpread(iuvw(1),iuvw(2),iuvw(3))
c
              ksez    = Htype(k,1)
              ntraccia= Htype(k,2)
              kdet    = Htype(k,3)
              if(ntraccia*kdet==2) then
c--asse 6
                iassepari=1
                Harkerheight(k)=HarkerMult*
     &              spreadpeak_clever(iuvw(1),iuvw(2),iuvw(3))
              elseif(ntraccia*kdet==1) then
c--asse 4
                Harkerheight(k)=HarkerMult*
     &              spreadpeak_clever(iuvw(1),iuvw(2),iuvw(3)) 
                iassepari=1 
              elseif(ntraccia*kdet==0) then
c--asse 3
!--elimino le sezioni di Harker nella SMF
                if(lproj==0) Patt(iuvw(1),iuvw(2),iuvw(3))=0.0  
!--fa lo spread solo se c'e' solo l'asse 3
                Harkerheight(k)=HarkerMult*
     &            spreadpeak_asse3(xmapApp,iuvw(1),iuvw(2),iuvw(3),ksez)
              elseif(ntraccia*kdet==-1) then
c--asse 2
!--elimino le sezioni di Harker nella SMF
                if(lproj==0) Patt(iuvw(1),iuvw(2),iuvw(3))=0.0   ! occhio
                if(ksez>10) then
c         linea di Harker
                  Harkerheight(k)=
     &            spreadpeak_linea(xmapApp,iuvw(1),iuvw(2),iuvw(3),ksez)
                else
                  Harkerheight(k)=
     &            spreadpeak_asse2(xmapApp,iuvw(1),iuvw(2),iuvw(3),ksez)
                endif
              endif
c             if(iz==0.0) write(80+k,*) ix,iy,iz,Harkerheight(k) 
            enddo
c--elimino eventualmente l'asse 2 parallelo a quello 4 o 6
            Nstart=1+iassepari
            Nnum=NsezHarker-Nstart+1
            xx=minval(Harkerheight(Nstart:NsezHarker)) 
            yy=sum(Harkerheight(Nstart:NsezHarker)) 
            yy=yy/float(Nnum)
c           write(6,*) 'peso',xx,yy,pesomin
            xx=pesomin*xx+(1.-pesomin)*yy
c           write(6,*) 'pesoNew',xx
c           if(abs(ix-118)<2.and.abs(iy-15)<2.and.abs(iz-0)<2) then
c              write(6,*) ix,iy,iz,Harkerheight(1:NsezHarker),xx  ! deb
c           endif
            if(xx<0.0) xx=0.0
            xmap(ix,iy,iz)=xx
          enddo
        enddo
      enddo
c
c--conserva la SMF finale per la procedura multi-soluzione
c
c
c--modifico la SMF in modo che le posizioni equivalenti secondo
c     la simmetria SMF abbiano la stessa altezza
c
      if(iesSnip==1) then
        call snipmap2D(xmap,ksezold,2)
      endif
      call RestoreSMF(ksezold)   
c
      SMFtrue=xmap
c
c--anticipo del calcolo della ImproveRiciclo
c
      xmap=Patt  
c
c--considero una sola sezione della Patterson nel caso 2D
c
      if(lproj==1) then
        xmap(1:np(1)-1,0:np(2)-1,0:np(3)-1)=0.0
      elseif(lproj==2) then
        xmap(0:np(1)-1,1:np(2)-1,0:np(3)-1)=0.0
      elseif(lproj==3) then
        xmap(0:np(1)-1,0:np(2)-1,1:np(3)-1)=0.0
      endif
c
      call CercaPicchiPatt()   
c
      xmap=Patt   ! occhio su lproj
c
c--faccio il taglio alla Patterson
c
      if(iesSnip==1) then
        call snipmap(xmap,1)
      else
        invflag = 10
        call maxmin3d(denmin,denmax,avden,stden,npunt,1)
        if(lproj==0) then
          sog=avden+1.5*stden 
        else
          sog=avden+1.0*stden 
        endif
        call changesection3d(sog,nmod,denmin)
        if (kverbo > 0) then
          denom=np(1)*np(2)*np(3)
          write(6,'(a,4f15.2,f8.3,a)') 'change Patterson ',
     &      denmax,avden,stden,sog,100*((denom-float(nmod))/denom),'%'
        endif
      endif
      Patt=xmap
c
      xmap=SMFtrue
c
c--ricerca i picchi sulla mappa bidimensionale (non lo posso fare sulla mappa
c   per colonne)   
c
      n1=0
      if(ksezold==1) then
        xmap(1:np(1)-1,0:np(2)-1,0:np(3)-1)=0.0
      elseif(ksezold==2) then
        xmap(0:np(1)-1,1:np(2)-1,0:np(3)-1)=0.0
      elseif(ksezold==3) then
        xmap(0:np(1)-1,0:np(2)-1,1:np(3)-1)=0.0
      elseif(ksezold==11) then  
        ikc=sidepp(nint(Tvet(1,2)*np(2)),np(2))
        ilc=sidepp(nint(Tvet(1,3)*np(3)),np(3))
        do il=0,np(3)-1
         do ik=0,np(2)-1
           do ih=0,np(1)-1
            if(ik==ikc) then
              if(il==ilc) cycle
            endif
            xmap(ih,ik,il)=0.0
          enddo
         enddo
        enddo
      elseif(ksezold==12) then  
        ihc=sidepp(nint(Tvet(1,1)*np(1)),np(1))
        ilc=sidepp(nint(Tvet(1,3)*np(3)),np(3))
        do il=0,np(3)-1
         do ik=0,np(2)-1
          do ih=0,np(1)-1
            if(ih==ihc) then
              if(il==ilc) cycle
            endif
            xmap(ih,ik,il)=0.0
          enddo
         enddo
        enddo
      elseif(ksezold==13) then  
        ihc=sidepp(nint(Tvet(1,1)*np(1)),np(1))
        ikc=sidepp(nint(Tvet(1,2)*np(2)),np(2))
        do il=0,np(3)-1
         do ik=0,np(2)-1
           do ih=0,np(1)-1
            if(ih==ihc) then
              if(ik==ikc) cycle
            endif
            xmap(ih,ik,il)=0.0
          enddo
         enddo
        enddo
      endif
c
      call CercaPicchi(NsezHarker,Hvet,Tvet,Htype,ksezold,ierr)
c
      return
      end 
c-----------------------------------------------------------------------
      subroutine DoSMF_tricl(ksezold,ierr)
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Riflessi
      USE Seminvariants
      USE Molcom
      USE PhaseModule
      dimension Hvet(50,3,3),Tvet(50,3)
      integer Htype(50,3)
c
c--per la ricerca dei picchi elimino del tutto il picco all'origine nella
c  Patterson
c
      xmapApp=Patt
      call DropZeroPeak()  
      SMF=0.0
c
c--conserva la SMF finale per la procedura multi-soluzione
c
      SMFtrue=Patt
c
c--faccio il tagli alla Patterson
c
      xmap=Patt
      if(iesSnip==1) then
        call snipmap(xmap,2)
      else
        invflag = 10
        call maxmin3d(denmin,denmax,avden,stden,npunt,1)
        sog=avden+1.5*stden  
        call changesection3d(sog,nmod,denmin)
        if (kverbo > 0) then
          denom=np(1)*np(2)*np(3)
          write(6,'(a,4f15.2,f8.2,a)') 'change Patterson ',
     &    denmax,avden,stden,sog,100*((denom-float(nmod))/denom),'%'
        endif
      endif
c
c--anticipo del calcolo della ImproveRiciclo
c
      call CercaPicchiPatt()  
      Patt=xmap
c
c--la SMF coincide con la Patterson
c
      xmap=xmapApp
c
c--ricerca i picchi da considerare
c
      call CercaPicchi(NsezHarker,Hvet,Tvet,Htype,ksezold,ierr)
c
      return
      end 
c------------------------------------------------------------------
      subroutine DoFourier(x1,y1,z1,ksezold, ier)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Riflessi
      USE Seminvariants
      USE Molcom
      USE PhaseModule
      USE Param
      integer sidepp
      character*11 tirang
      dimension xnew(3),xs(3),xr(3)
c
c     pesomin=0.2
c
c     xmap=PattOrig
c     aperc(1)=min(500.,float(maxAtoms)/float(nsymTot))
c     call pksrch_big_RocPat(1,ier)
c     do i=1,nats
c       write(6,'(a,3f8.3,f15.1)') 'lista picchi Patt sel',xyzs(1:4,i)
c     enddo
c
      xmap=SMFtrue   ! SMF
      Patt=PattOrig  ! Patterson originale
c
c--elimino dalla mappa SMF gli equivalenti per simmetria SMF
c  del picco PIVOT scelto
c
      if(jsys>1.and.ksize<=3.and.lproj==0) then
         if (kverbo > 0) write(6,*) 'ClearSMF'
         call ClearSMF(x1,y1,z1,ksezold)  
      endif 
c
      if(ksezold==0) then
        if(jsys==3) then  
c--ortorombico
          call RompiSimmetria3d(x1,y1,z1)
        else
c--da chiamare negli altri casi
          factDump=0.7
          call RestoreSymmetry(factDump)      
        endif
      endif
!
      bfac(1)=bt
!
      xyzs(1,1)=x1
      xyzs(2,1)=y1
      xyzs(3,1)=z1
      xyzs(4,1)=1.0
      xyzs(5,1)=1.0
c
      ncicli=1 
      if(iesCmap>0) ncicli=iesCmap
      do iciclo=1,ncicli
c
c--faccio i minimi quadrati sull'atomo pivot
c
      if(iciclo==1) then
        nats=1
        nz(1)=nk
        numb=nrefl
        scalan=1
        krecy = 0  ! Dedi 23/02/15  per riprodurre il singolo trial > 1 di SM
        ifBreak=0
c       if(knw>0.and.kverbo>0) then
           iref=0
           nlsm=1
           call sftryyy(iref,mode,nlsm,numb,scalan,ifBreak)
           if (knw > 0) then
               write(6,*) 'prima LSQ',xyzs(1:3,1),bfac(1)
           endif
           kverboOld=kverbo
!!!        kverbo=1
! ho commentato la seguente, serve questa stringa per Buccaneer
*          FraFilePath=' ' ! per far fare la to_coord alle piccole
!!!!!      call to_coord_sir(1,numb) !solo per debug
           kverbo=kverboOld
c        endif
        if(no(nk)>20) then
          do i=1,nats
            xyzs26(1:3,i)=xyzs(1:3,i)
          enddo
          xyzs(4,1)=1.0
          xyzs(5,1)=1.0
          nz(1)=nk
          iref=3 ! affino anche il B
          mode=1
          nlsm=10
          call sftryyy(iref,mode,nlsm,numb,scalan,ifBreak)
c         if(knw>0.and.kverbo>0) then
          if (knw > 0) write(6,*) 'dopo LSQ',xyzs(1:3,1),bfac(1),scalan
            kverboOld=kverbo
!!!         kverbo=1
!!!!!       call to_coord_sir(1,numb) !solo per debug
            kverbo=kverboOld
c         endif
          if (AbortLSQ == 1) then
              AbortLSQ = 0
              if (knw > 0) write(6,*) 'LSQ annullato'
              do i=1,nats
                 xyzs(1:3,i)=xyzs26(1:3,i)
              enddo
          endif
        endif
      endif
      x1=xyzs(1,1)
      y1=xyzs(2,1)
      z1=xyzs(3,1)
c
      if(iesCmap > 0) then
        iflagg=-1 
        call DoCmap(x1,y1,z1,iflagg,ksezold)  
      endif
c
c--sposto la Patterson originale del vettore (x1,y1,z1)
c     P0 = Patt  ---> P0 spostata = xmapApp
cc    Patt=PattOrig ! occhio
c
      if(iciclo<ncicli) then
         iesAMS=1
      else
         iesAMS=0
      endif
      if(jsys==1) iesAMS=0
      if(jsys==6) iesAMS=0
      iesAMS=0 ! out7 
 80   continue
      xmapApp(:,:,:)=0.0
      io1=sidepp(nint(x1*np(1)),np(1))
      io2=sidepp(nint(y1*np(2)),np(2))
      io3=sidepp(nint(z1*np(3)),np(3))
      if(iesAMS==0) then
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
              if(abs(Patt(ih,ik,il))>0.0) then
                ih1=sidepp(ih+io1,np(1))
                ik1=sidepp(ik+io2,np(2))
                il1=sidepp(il+io3,np(3))
                xmapApp(ih1,ik1,il1)=Patt(ih,ik,il)
              endif
            enddo
          enddo
        enddo
      else
        write(6,*) 'AMS map'
 
c--calcolo mappa AMS: Min[Patt(r-Cs*rp)]
        xs(1)=x1
        xs(2)=y1
        xs(3)=z1
        kk3=2
        call xequi(xs,kk3,1.0,xnew,1)
        iu1=sidepp(nint(xnew(1)*np(1)),np(1))
        iu2=sidepp(nint(xnew(2)*np(2)),np(2))
        iu3=sidepp(nint(xnew(3)*np(3)),np(3))

        do il = 0, np(3)-1
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
              ih1=sidepp(ih-io1,np(1))
              ik1=sidepp(ik-io2,np(2))
              il1=sidepp(il-io3,np(3))

              ih2=sidepp(ih-iu1,np(1))
              ik2=sidepp(ik-iu2,np(2))
              il2=sidepp(il-iu3,np(3))

              if(ksezold>10) then
                xx1=spreadpeak_linea(Patt,ih1,ik1,il1,ksezold)
                xx2=spreadpeak_linea(Patt,ih2,ik2,il2,ksezold)
              else
                xx1=spreadpeak_asse2(Patt,ih1,ik1,il1,ksezold) ! out6
                xx2=spreadpeak_asse2(Patt,ih2,ik2,il2,ksezold)
              endif
              xmapApp(ih,ik,il)=min(xx1,xx2)
            enddo
          enddo
        enddo
      endif
c
c--calcola la mappa min(P0 spostata * F0) = min(xmapApp * SMFtrue)
c
      ies=0
      do il = 0, np(3)-1
        do ik = 0, np(2)-1
          do ih = 0, np(1)-1
             xx1=SMFtrue(ih,ik,il)
             xx2=xmapApp(ih,ik,il)
             if(iesAMS==0) then
               xmap(ih,ik,il)=min( xx1, xx2 )  ! default
c              xx=min(xx1,xx2)
c              yy=0.5*(xx1+xx2)
c              xmap(ih,ik,il)=pesomin*xx+(1.-pesomin)*yy
             else
               xmap(ih,ik,il)= xx2  
             endif
             if(xmap(ih,ik,il)<0.0) xmap(ih,ik,il)=0.0
               if(xmap(ih,ik,il)>0.0) then
                 ies=1
               endif
          enddo
        enddo
      enddo
      if(ies==0) then
        if(iesAMS==1) then
          iesAMS=0
          write(6,*) 'no AMS map'
          goto 80
        else
          write(6,*) 'zero map for this peak'
          return
        endif
      endif
!
c-- cerco di ristabilire la simmetria del gruppo spaziale nella nuova
c   Fourier, cancellando la rimanente simmetria Patterson
c
      if(jsys/=1) then   
        factDump=0.7
        if(jsys==2) factDump=0.3 
        call RestoreSymmetry(factDump) 
      endif
!
!--miglioro la mappa con la doppia sovrapposizione
!
c     if(ksize<=3.and.jsys<=3) then
c        if(Lowres==1) then
!--modifica piu' marcata, pixel per pixel
! va bene per bpti9
c           write(6,*) 'S map improved'
c           call ImproveSmap(x1,y1,z1,ksezold)
c        else
!--modifica piu' blanda
! va bene per metaxia
c           write(6,*) 'S map smoothly improved'
c           call ImproveSmapLast(x1,y1,z1,ksezold)
c        endif
c     endif
c
      esponent=1.3
      do il = 0, np(3)-1
        do ik = 0, np(2)-1
          do ih = 0, np(1)-1
            if (xmap(ih,ik,il).lt.0.0) then
                 xmap(ih,ik,il) = 0.0
            else
                 xmap(ih,ik,il) = xmap(ih,ik,il) ** esponent
            endif
          enddo
        enddo
      enddo
      esalta=esponent
c
c--modifico nuovamente la mappa
c
c--snip
      if(iesSnip==1) then
        call snipmap(xmap,2)
      else
        invflag = 10
        call maxmin3d(denmin,denmax,avden,stden,npunt,1)
        if(lproj==0) then
          sog=0.666*stden
        else
          sog=0.5*stden
        endif
        call changesection3d(sog,nmod,denmin)
        if (kverbo > 0 ) then
          denom=np(1)*np(2)*np(3)
          write(6,'(a,3f15.2,f8.3,a)') 'change section ',
     &      denmax,avden,stden,100*((denom-float(nmod))/denom),'%'
        endif
      endif

       if (ksize == 7 .and. LowRes == 0.and.no(nk)>20) then 
          kprint = 1
          iciclo1 = -99
c         write(6,*) 'sono qui'
          call Modifica_Mappa_NEW(iciclo1, ier) 
          if (ier < 0) return
       endif 


c     if (ksize == 3 .and. LowRes == 0.and.no(nk)<20) then 
c         call RiduciPiccoPivot()
c     endif
c
c-- stimo gli h  generici e gli H  di secondo rango
c
      invflag = 0  
      numbMax=nrefl
      call InvMap(khl,mkang,iphaz,fcvet,numbMax)
      fcvet=sqrt(fcvet)
c
      if (kmad == 1) then    ! patterson MAD pg230407
          call PresigmaA(-2, 0)
          wt=pesMod
      else
         if (ksize <= 3) then   ! patterson per piccole
            chope=0.5
            call CalcolaPesi(0,numbMax,chope,1)
         else
            if (knw > 0) then
                write(6,*) ' Sigmaa di DoFourier'
            endif
            wt(:) = 1.0
            call PresigmaA(-2, 0)
            wt=pesMod
         endif
      endif              ! patterson MAD pg230407
c
      if (kverbo == 1 .and. knw == 1) then
          nu = 123
          izero = 0
          ifmin = 1
          call examin(nu,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
      endif
c
      if(iciclo<ncicli) then
!
        fcoef(1:nrefl) = evet(1:nrefl)
        fcoef(:) = fcoef(:) * wt(:)
        jpatt = 0
        if (kmad /= 0) then            !pgMAD090206
            call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xmap,
     *                FORTH, BACK)
        else
            call MakeMap(fcoef, iphaz, numbMax, jpatt, xmap,
     *                FORTH, BACK)
        endif
!---ricalcolo la Cmap per sovrascrivere la Patt
        iflagg=-(iciclo)
        call DoCmap(x1,y1,z1,iflagg,ksezold)  
      else
!--faccio le statistiche
        if(kverbo>0.and.knw==1) then
          do i=1,numbMax
            if(jsys==1) then
              iwork1(i)=0
            else
              jhkl(1) = khl(1,i)
              jhkl(2) = khl(2,i)
              jhkl(3) = khl(3,i)
              ks = modulo_sir(jhkl)
              if (ks.eq.0) then
               iwork1(i)=1
              else
               iwork1(i)=0
              endif
            endif
          enddo
          call CalcolaStatisticheH3d(numbMax)
        endif
      endif 
c
      enddo ! iciclo
c
      return
      end 
c------------------------------------------------------------------
      subroutine ZeroHarkermio(ksez,alim,id)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE PhaseModule
      USE Param
c
c--id==1: faccio la pulizia vedendo le sezioni vicine
c
      n11=0
      n1 = nint(np(ksez) * alim)
      if(n1==0) then
        n1m=np(ksez)-1 
       else
        n1m=n1-1
      endif
c
c--modifico la sezione di Harker vedendo quelle vicine
c
      icont=0
      avden=0
      denmax=0
      if(ksez==1) then
        if(id>0) then
          denom=np(2)*np(3)
          do ik = 0, np(2)-1
            do il = 0, np(3)-1
              if(xmap(n1,ik,il)>0.0) then  
c               diff=(xmap(n1m,ik,il)-xmap(n1,ik,il))/xmap(n1,ik,il)
c               diff=xmap(n1,ik,il)
                if(xmap(n1m,ik,il)>xmap(n1,ik,il)) then
c               if(xmap(n1m,ik,il)>diff.and.diff<5*stden) then
c               if(diff>0.10) then
c                  write(6,'(a,4f15.3)') 'sez 1',xmap(n1,ik,il),
c    &                      xmap(n1m,ik,il)-xmap(n1,ik,il),
c    &          100*(xmap(n1m,ik,il)-xmap(n1,ik,il))/xmap(n1,ik,il)
c    &          ,xmap(n1,ik,il)/stden
                   icont=icont+1
                   avden=avden+xmap(n1,ik,il)
                   if(xmap(n1,ik,il)>denmax) then
                      denmax=xmap(n1,ik,il)
                      denwrong=xmap(n1m,ik,il)
                   endif
                   if(id==1) then
                     xmap(n1,ik,il) = 0.0 
                   else
                     xmap(n1,ik,il) = xmap(n1,ik,il)*0.8
                   endif
                endif
              endif
            enddo
          enddo
        endif
c
c--isolo  la sezione di Harker dalla mappa Patterson
c
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
              if(ih.lt.n1.or.ih.gt.n1) then
                xmap(ih,ik,il) = 0.0
              endif
            enddo
          enddo
        enddo
c
c-- sposto la sezione di Harker nella prima posizione della mappa
c
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
              xmap(n11,ik,il) = xmap(n1,ik,il)
          enddo
        enddo
      elseif(ksez==2) then
        if(id>0) then
          denom=np(1)*np(3)
          do il = 0, np(3)-1
            do ih = 0, np(1)-1
              if(xmap(ih,n1,il)>0.0) then  
c               diff=xmap(ih,n1,il)
c               diff=(xmap(ih,n1m,il)-xmap(ih,n1,il))/xmap(ih,n1,il)
c               if(xmap(ih,n1m,il)>diff.and.diff<5*stden) then
                if(xmap(ih,n1m,il)>xmap(ih,n1,il)) then
c               if(diff>0.10) then
c                  write(6,'(a,4f15.3)') 'sez 2',xmap(ih,n1,il),
c    &                      xmap(ih,n1m,il)-xmap(ih,n1,il),
c    &          100*(xmap(ih,n1m,il)-xmap(ih,n1,il))/xmap(ih,n1,il)
c    &          ,xmap(ih,n1,il)/stden
                   icont=icont+1
                   avden=avden+xmap(ih,n1,il)
                   if(xmap(ih,n1,il)>denmax) then
                      denmax=xmap(ih,n1,il)
                      denwrong=xmap(ih,n1m,il)
                   endif
                   if(id==1) then
                     xmap(ih,n1,il) = 0.0 
                   else
                     xmap(ih,n1,il) = xmap(ih,n1,il)*0.8
                   endif
                endif
              endif
            enddo
          enddo
        endif
c
c--isolo  la sezione di Harker dalla mappa Patterson
c
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
              if(ik.lt.n1.or.ik.gt.n1) then
                xmap(ih,ik,il) = 0.0
              endif
            enddo
          enddo
        enddo
c
c-- sposto la sezione di Harker nella prima posizione della mappa
c
        do il = 0, np(3)-1
          do ih = 0, np(1)-1
              xmap(ih,n11,il) = xmap(ih,n1,il)
          enddo
        enddo
      elseif(ksez==3) then
        if(id>0) then
          denom=np(1)*np(2)
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
              if(xmap(ih,ik,n1)>0.0) then  
c               diff=xmap(ih,ik,n1)
c               diff=(xmap(ih,ik,n1m)-xmap(ih,ik,n1))/xmap(ih,ik,n1)
c               if(xmap(ih,ik,n1m)>diff.and.diff<5*stden) then
                if(xmap(ih,ik,n1m)>xmap(ih,ik,n1)) then
c               if(diff>0.10) then
c                  write(6,'(a,4f15.3)') 'sez 3',xmap(ih,ik,n1),
c    &                   xmap(ih,ik,n1m)-xmap(ih,ik,n1),
c    &          100*(xmap(ih,ik,n1m)-xmap(ih,ik,n1))/xmap(ih,ik,n1)
c    &          ,xmap(ih,ik,n1)/stden
                   icont=icont+1
                   avden=avden+xmap(ih,ik,n1)
                   if(xmap(ih,ik,n1)>denmax) then
                      denmax=xmap(ih,ik,n1)
                      denwrong=xmap(ih,ik,n1m)
                   endif
                   if(id==1) then
                     xmap(ih,ik,n1) = 0.0 
                   else
                     xmap(ih,ik,n1) = xmap(ih,ik,n1)*0.8
                   endif
                endif
              endif
            enddo
          enddo
        endif
c
c--isolo  la sezione di Harker dalla mappa Patterson
c
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
              if(il.lt.n1.or.il.gt.n1) then
                xmap(ih,ik,il) = 0.0
              endif
            enddo
          enddo
        enddo
c
c-- sposto la sezione di Harker nella prima posizione della mappa
c
        do ik = 0, np(2)-1
          do ih = 0, np(1)-1
              xmap(ih,ik,n11) = xmap(ih,ik,n1)
          enddo
        enddo
      endif
c       
      if (kverbo > 0) then
          if (id == 1) then
              if (icont > 0) then
                  write(6,'(a,i8,f8.2,a,3f10.2)') 'azzeramenti',icont,
     &                             (100.*float(icont))/(denom),'% ',
     &                              avden/icont,denmax,denwrong
              endif
          elseif (id == 2) then
              if (icont > 0) then
                  write(6,'(a,i8,f8.2,a,3f10.2)') 'riempimenti',icont,
     &                 (100.*float(icont))/(denom),'% ',
     &                  avden/icont,denmax,denwrong
              endif
          else
              write(6,*) 'no azzeramenti '
          endif
      endif
!
      return
      end
c------------------------------------------------------------------
      subroutine ZeroHarkertuo(ksez,alim)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
c
      n11=0
      n1 = nint(np(ksez) * alim)
c
c-- inserisco la sezione di Harker modificata al suo posto
c
      if(ksez==1) then
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
              Patt(n1,ik,il) = xmap(n11,ik,il)
          enddo
        enddo
      elseif(ksez==2) then
        do il = 0, np(3)-1
          do ih = 0, np(1)-1
              Patt(ih,n1,il) = xmap(ih,n11,il)
          enddo
        enddo
      elseif(ksez==3) then
        do ik = 0, np(2)-1
          do ih = 0, np(1)-1
              Patt(ih,ik,n1) = xmap(ih,ik,n11)
          enddo
        enddo
      endif
!
      return
      end
c---------------------------------------------------------------
      subroutine maxminnew(denmin,denmax,avden,stden,npunt,ksez)
      USE Mappa

      denmin =  1.0e25
      denmax = -1.0e25
      avden  =  0.0
      stden  =  0.0
      npunt=0
c
      n1=0
c
      if(ksez==1) then
       do iz = 0, np(3)-1
        do iy = 0, np(2)-1
          do ix = n1, n1
            if(iy<=2.and.iz<=2) cycle  ! non considero l'origine
            if(iy<=2.and.iz>=np(3)-3) cycle  ! non considero l'origine
            if(iy>=np(2)-3.and.iz<=2) cycle  ! non considero l'origine
            if(iy>=np(2)-3.and.iz>=np(3)-3) cycle  ! non considero l'origin
            xx=xmap(ix,iy,iz)
            if(xx.ne.0) then   
              denmax=amax1(denmax,xx)
              denmin=amin1(denmin,xx)
              avden=avden + xx
              stden=stden + xx * xx
            endif
            npunt=npunt+1
           enddo
         enddo
       enddo
      elseif(ksez==2) then
       do iz = 0, np(3)-1
         do iy = n1, n1
           do ix = 0, np(1)-1
            if(ix<=3.and.iz<=3) cycle  ! non considero l'origine
            if(ix<=3.and.iz>=np(3)-3) cycle  ! non considero l'origine
            if(ix>=np(1)-3.and.iz<=3) cycle  ! non considero l'origine
            if(ix>=np(1)-3.and.iz>=np(3)-3) cycle  ! non considero l'origi
            xx=xmap(ix,iy,iz)
            if(xx.ne.0) then   
              denmax=amax1(denmax,xx)
              denmin=amin1(denmin,xx)
              avden=avden + xx
              stden=stden + xx * xx
            endif
            npunt=npunt+1
           enddo
         enddo
       enddo
      elseif(ksez==3) then
       do iz = n1, n1
         do iy = 0, np(2)-1
           do ix = 0, np(1)-1
            if(ix<=3.and.iy<=3) cycle  ! non considero l'origine
            if(ix<=3.and.iy>=np(2)-3) cycle  ! non considero l'origine
            if(ix>=np(1)-3.and.iy<=3) cycle  ! non considero l'origine
            if(ix>=np(1)-3.and.iy>=np(2)-3) cycle  ! non considero l'origine
            xx=xmap(ix,iy,iz)
            if(xx.ne.0) then   
              denmax=amax1(denmax,xx)
              denmin=amin1(denmin,xx)
              avden=avden + xx
              stden=stden + xx * xx
            endif
            npunt=npunt+1
           enddo
         enddo
       enddo
      endif
c
      avden=avden/float(npunt)
      stden=stden/float(npunt) - avden*avden
      if (stden.gt.0.0) then
          stden=sqrt(stden)
      else
          stden=0.0
      endif
c
      return
      end
*----------------------------------------------------------------------------*
      subroutine changesectionnew(sog,nmod,denmin,ksez)
      USE Mappa
      USE PhaseModule
*---- invflag=1 taglia la mappa > sog (solo parte positiva)
*---- invflag=2 azzera la mappa > sog (solo parte positiva)
*---- invflag=3 taglia la mappa > sog 
*---- invflag=4 azzera la mappa > sog 
*---- invflag=10 azzera la mappa < sog (solo parte positiva)
*---- invflag=20 azzera la mappa < sog 
*---- invflag=30 azzera la mappa > sog partendo dal basso 
*---- invflag=31 taglio combinato
*---- invflag=32 taglio combinato ridotto
*---- invflag=40 azzera la parte negativa 

      nmod=0
c
      n1=0
c
      if(ksez==1) then
        nu=n1
        nv=np(2)-1
        nww=np(3)-1
      elseif(ksez==2) then
        nu=np(1)-1
        nv=n1
        nww=np(3)-1
      elseif(ksez==3) then
        nu=np(1)-1
        nv=np(2)-1
        nww=n1
      endif
c
      do 150 k=0,nww
         do 100 j=0,nv
            do 50 i=0,nu
               xx=xmap(i,j,k)
c
c--applico la soglia
c
               if (sog.gt.0.0.and.abs(xx)>0.) then
                 if (invflag==1) then
                   if(xmap(i,j,k).gt.sog) then
                      xmap(i,j,k)=sog
                      nmod=nmod+1
                   endif
                 elseif (invflag==2) then
                   if(xmap(i,j,k).gt.sog) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==3) then
                   if(abs(xmap(i,j,k)).gt.sog) then
                      xmap(i,j,k)=sog
                      nmod=nmod+1
                   endif
                 elseif (invflag==4) then
                   if(abs(xmap(i,j,k)).gt.sog) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==10) then
                   if(xmap(i,j,k).lt.sog) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==20) then
                   if(abs(xmap(i,j,k)).lt.sog) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==30) then
                   sog1=denmin+sog
                   if(xmap(i,j,k).lt.sog1) then
                      xmap(i,j,k)=0.7*xmap(i,j,k)
                      nmod=nmod+1
                   endif
                 elseif (invflag==31) then
                   sog1=0.6666*sog
                   if(abs(xmap(i,j,k)).lt.sog1) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==32) then
                   sog1=0.3333*sog
                   if(abs(xmap(i,j,k)).lt.sog1) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                   sog1=denmin+2*sog
                   if(xmap(i,j,k).lt.sog1) then
                      xmap(i,j,k)=0.7*xmap(i,j,k)
                   endif
                 elseif (invflag==40) then
                   if(xmap(i,j,k).lt.0.0) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 endif
               endif
c
  50        continue
 100     continue
 150  continue

      return
      end
c---------------------------------------------------------
      subroutine CercaPicchi(NsezHarker,Hvet,Tvet,Htype,ksezold,ierr)
c
c--compila la lista dei picchi da considerare nella multisoluzione
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom
      USE PhaseModule
      dimension pik(3,800),pikstore(3,800)
      dimension xor(3),s(3),xs(3),xcentr(3),xor1(3)
      dimension Hvet(50,3,3),Tvet(50,3)
      integer Htype(50,3)

      zero=0.001
      zeroz=0.0001
      ierr=0
c
c--cerco i picchi (esclusi gli equivalenti di simmetria)
c
      aperc(1)=MaxAtoms
      call pksrch_big_RocPat(1,ier) ! non funziona la ricerca in Fourier!!
c
      if (kverbo > 0) then
          do i=1,nats
              write(6,'(a,i8,3f10.4,f20.3,f10.0)')
     &            'peak found',i,xyzs(1:5,i)
          enddo
      endif
c
c--fisso i limiti sul taglio in distanza
c      (devo cercare i picchi Harker, cioe' le distanze
c       interatomiche tra un atomo e il suo equivalente)
c
      if(ksize<=3) then
         iorig=0
         distLimit=0.0
      else
         iorig=0
         do i=1,nsym
           do j=1,3
             if(tmat(i,j)>0.0) iorig=1
           enddo
         enddo
         distLimit=7.0 
         if(iorig==0) distLimit=13. 
         if(jsys==1) distLimit=5.
      endif
c
      if(ifRhombAx==0) then
c     iroc=0  ! occhio
c     if(iroc==1) then ! occhio
c--deb
c       if(knw>0) then
c         nats15=nats
c         call to_coord_Patt(ksezold) 
c       endif
c--deb
c
c
c-- scelgo come  picco quello piu' vicino all'origine
c   clusterizzo i picchi
c-- e medio sui picchi appartenenti allo stesso cluster
c
        hmax=xyzs(4,1)
        nats15=0
        do_1: do i=1,nats
c
          h1=xyzs(4,i)
          if(h1<1.01) cycle do_1
!
!--genero gli equivalenti nella SMF
!
          pik(:,:)=0.0
          x1=xyzs(1,i)
          y1=xyzs(2,i)
          z1=xyzs(3,i)
          npik=0
          do k=1,nsymTotRoc
            call oper(k,xs,x1,y1,z1)
            do k1=1,nOrigRoxiRoc
               npik=npik+1
               do j=1,3
                 termm=xs(j)+taboRoc(k1,j)
                 pik(j,npik)=side(termm)
                 if(j==ksezold) pik(j,npik)=0.0
               enddo
               if (npik == 800) exit
            enddo
            if (npik == 800) exit
          enddo
          if(kverbo>0) then
             write(6,*) 'prima',xyzs(1:4,i)
             do l=1,npik
               write(6,*) 'pik a ',l,pik(1:3,l)
             enddo
          endif
!
!--seleziono l'equivalente campione (quello piu' vicino
!  all'origine
!
          distmin=999.
          x1min=999.
          x2min=999.
          x3min=999.
          x1min=minval(pik(1,1:npik))
c         write(6,*) 'deb0',x1min
          npik1=0
          do k=1,npik
            xs(1:3)=pik(1:3,k)
            if(abs(xs(1)-x1min)<zeroz) then
              npik1=npik1+1
              pikstore(1:3,npik1)=xs(1:3)
              if(xs(2)<x2min) x2min=xs(2)
c             write(6,*) 'deb1',k,xs
            endif
            if (npik1 == 800) exit
          enddo
c               write(6,*) 'deb2',x2min
          npik=0
          pik(:,:)=0.0
          do k=1,npik1
            xs(1:3)=pikstore(1:3,k)
            if(abs(xs(2)-x2min)<zeroz) then
                npik=npik+1
                pik(1:3,npik)=xs(1:3)
c               write(6,*) 'deb3',xs
            endif
          enddo
          do k=1,npik
            xs(1:3)=pik(1:3,k)
            if(xs(3)<x3min) then
              x3min=xs(3)
              kmem=k
c               write(6,*) 'deb4',xs
            endif
          enddo
          xyzs(1:3,i)=pik(1:3,kmem)
!
!--scarto i picchi in posizioni particolari
!
          if(jsys>1.and.ksize>3) then
            iel=0
            do j=1,3
              if(j==ksezold) cycle
!--elimino sempre i picchi a 0.0
              disA=abs(xyzs(j,i)-0.0)
              disB=abs(xyzs(j,i)-1.0)
              if(disA<zero.or.disB<zero) iel=1
              if(ifTrigonal/=1) then
!--elimino i picchi a 0.5 (tranne che per il trigonale)
                disC=abs(xyzs(j,i)-1./2.)
                if(disC<zero) iel=1
              endif
              if(jsys==4) then
!--elimino i picchi a 0.25 e 0.75
                disC=abs(xyzs(j,i)-1./4.)
                if(disC<zeroz) iel=1
                disD=abs(xyzs(j,i)-3./4.)
                if(disC<zeroz.or.disD<zeroz) iel=1
              endif
              if(jsys==5) then
!--elimino i picchi a 0.33 e 0.667
                disC=abs(xyzs(j,i)-1./3.)
                if(disC<zeroz) iel=1
                disD=abs(xyzs(j,i)-2./3.)
                if(disC<zeroz.or.disD<zeroz) iel=1
                if(ifTrigonal==0) then
!--elimino i picchi a 0.166 e 0.833 solo per l'esagonale
                  disC=abs(xyzs(j,i)-1./6.)
                  if(disC<zeroz) iel=1
                  disD=abs(xyzs(j,i)-5./6.)
                  if(disC<zeroz.or.disD<zeroz) iel=1
                endif
              endif
              if(iel==1) then
                 if(kverbo>0) then
                   write(6,*) 'Special peak eliminated '
                 endif
                 cycle do_1
              endif
            enddo
          endif
!
          if(kverbo>0) then
            write(6,*) 'dopo',xyzs(1:3,i)
            write(6,'(a,i10,3f8.3,2f8.2,2i5)') 
     &          'che ',i,x1,y1,z1,distmin,distLimit,iorig,jsys
          endif
!
!--inserisco il picco in una lista di appoggio
!
          nats15=nats15+1
          xyz15(1:3,nats15)=xyzs(1:3,i)
          xyz15(4,nats15)=xyzs(4,i)
!
        enddo do_1
!
!--clusterizzo la nuova lista e e creo una ulteriore lista
!  contenente le medie di ogni cluster  
!
        xyz15(5,:)=0.0
        xyzs(:,:)=0.0
        xyzo(:,:)=0.0
        npiktot=0
c--restringo il cluster nel caso 1D
        do_2: do i=1,nats15
           if(xyz15(5,i)>0.0) cycle do_2
           xor(1:3)=xyz15(1:3,i)
           xor1(1:3)=xyz15(1:3,i)
           icont=1
           xyzs(1:3,icont)=xyz15(1:3,i)
           xyzs(4,icont)=xyz15(4,i)
           bterm=xyzs(4,icont)
           xcentr(1:3)=xyzs(1:3,icont)*xyzs(4,icont)
c          write(6,*) 'prima',i,xor
!--clusterizzo intorno a questo picco
           do_3: do j=1,nats15
             if(j==i) cycle do_3
             if(xyz15(5,j)>0.0) cycle do_3
             xs(1:3)=xyz15(1:3,j)
c--definisco il cluster
             iprendi=0
             if(ksezold>0) then
                call xdist(xs,xor,dist,s)
                if(dist<0.6) iprendi=1
             else 
               if(abs(xs(1)-xor(1))<2./float(np(1)).and.
     &            abs(xs(2)-xor(2))<2./float(np(2)).and.
     &            abs(xs(3)-xor(3))<2./float(np(3))) iprendi=1
             endif
             if(iprendi==1) then
               xyz15(5,j)=1.0 ! soluzione gia' presa
               icont=icont+1
               xyzs(1:3,icont)=xyz15(1:3,j)
               xyzs(4,icont)=xyz15(4,j)
               if(kverbo>0) write(6,*) 'contributo',icont,j
!-- centro mobile del cluster 
               bterm=bterm+xyzs(4,icont)
               do jj=1,3
                xcentr(jj)=xcentr(jj)+xyzs(jj,icont)*xyzs(4,icont)
                xor(jj)=xcentr(jj)/bterm
               enddo
c          write(6,*) 'dopo',j,xor
             endif
           enddo do_3
           npiktot=npiktot+1
           xyzo(1:3,npiktot)=xor(1:3)
           xyzo(4,npiktot)=xyz15(4,i)
!-deb
           if(kverbo>0) then
             do ll=1,icont
               write(6,*) 'ufi ',ll,xyzs(1:3,ll)
               write(6,*) '    ',npiktot,xyzo(1:3,npiktot),i
             enddo
           endif
        enddo do_2
c
c--controllo sul totale dei picchi utili per la multi-soluzione
c
        if (npiktot <= 0) then
          write(lo,10) 
          if (jscreen > 0) then
              Msg = 'Patterson Procedure unable to provide trials.'
     *              // char(10) //
     *              'The program skips the Block.'
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          endif
          ierr=-1
          call PrintMess('Patterson Procedure aborted.')
          return
        endif
!
!--rifaccio la lista eliminando i picchi con distanza Harker troppo 
!  piccola
!
        nats15=0
        xyzs(:,:)=0.0
        do ii=1,npiktot
!              write(6,*) 'prima ',ii,xyzo(1:4,ii)
!
!--calcolo la distanza Harker = distanza da equivalenti per simmetria
!  o dall'origine nel caso del triclino
!
          if(jsys==1) then
            xor(1:3)=0.0
          else
            xor(1:3)=xyzo(1:3,ii)
          endif
          distmin=999.
          x1=xyzo(1,ii)
          y1=xyzo(2,ii)
          z1=xyzo(3,ii)
          do k=2,nsymTot
            call oper(k,xs,x1,y1,z1)
            call xdist(xs,xor,dist,s)
            if(dist<distmin) distmin=dist
c           write(6,*) 'Harker distance',k,dist,distmin
          enddo
!
!--scarto i picchi con distanza Harker troppo piccola
!--provo a non farlo per i primi 3 picchi
!
          if(distmin<distLimit) then
!!!!!     if(distmin<distLimit.and.ii>3) then
            if(kverbo>0) then
              write(6,*) 'Harker peak distance  =',
     &                distmin,' peak rejected'
            endif
          else
            nats15=nats15+1
            xyzs(1:5,nats15)=xyzo(1:5,ii)
          endif
        enddo
c
c--uso la variabile xyzo per memorizzare i picchi della SMF per la
c  procedura multi-soluzione
c
c       nats15=npiktot
c       xyzs=xyzo
        xyzo=xyzs
c
      else
c
c--peak search vecchio
c
c--selezione dei picchi da considerare per lo shift
c   (caso generale)
c
        npiktot=0
        goodmax=-999.
        heigh=xyzs(4,1)
        do_4: do i=1,nats
          h1=xyzs(4,i)
          if(h1<1.01) cycle do_4
          if(abs(h1-heigh)>0.1) then
            goodmax=-999.
            heigh=h1
            npiktot=npiktot+1
            xyzs(1:5,npiktot)=xyzs(1:5,igoodmin)
            if (kverbo > 0) then
              write(6,'(a,i5,3f10.4,2f10.1)') 
     &              'peak sel',npiktot,xyzs(1:5,npiktot)
            endif
          endif
          if(xyzs(5,i)>goodmax) then
             goodmax=xyzs(5,i)
             igoodmin=i
          endif
        enddo do_4
c
c--metto anche l'ultimo
c
        npiktot=npiktot+1
        xyzs(1:5,npiktot)=xyzs(1:5,igoodmin)
        if (kverbo > 0) then
          write(6,'(a,i5,3f10.4,2f10.1)') 
     &            'peak sel',npiktot,xyzs(1:5,npiktot)
        endif
c
c--controllo sul totale dei picchi utili per la multi-soluzione
c
        if (npiktot <= 0) then
          write(lo,10) 
          ierr=-1
        endif
c
c--uso la variabile xyzo per memorizzare i picchi della SMF per la
c  procedura multi-soluzione
c
        xyzo=xyzs 
        nats15=npiktot
c
      endif

!      do ii=1,nats15
!        write(6,*) 'dopo',ii,xyzs(1:4,ii)
!      enddo
c
c--deb
      if (knw == 1) then
          write(6,'(a,i10)') ' Number of peaks to be explored:',nats15
c      if (jBlock == 1) then
c       do ii=1,nats15
c        write(6,'(a,i6,4f15.3)') 'prima',ii,xyzo(1:4,ii)
c       enddo
c      endif
      endif
      if(knw>0) then
        if(ifTime==0.and.knw>0) call to_coord_Patt(ksezold)
c       stop 121
      endif

c-deb
c
c--controllo i picchi scelti
c
c     if(jBlocksPh(1,jBlock)==1) return  ! solo per test (singolo trial)
c     if(nats15<10) return
      if(jsys==1) return ! non vale per il P1
      if(ksize<=3) return! non va bene per le piccole molecole

      if(kmad == 1) return ! patterson MAD pg230407

!--limitazione sui picchi da esplorare
      if(nats15>3000) then
        nats15=3000 ! attenzione!!!
        if (jBlock == 1) then
            write(6,'(a,i10)') ' Number of peaks reduced to:',nats15
        endif
      endif
      xfommax=-99999999.
      yfommax=-99999999.
      xfommin=99999999.
      yfommin=99999999.
      do i=1,nats15
        call ConvergiPivot(i,NsezHarker,Hvet,Tvet,Htype,xfom)
        if(xfom>xfommax) xfommax=xfom
        if(xfom<xfommin) xfommin=xfom
        xyzs(4,i)=xfom
        call ConvergiPivot1(i,ksezold,yfom)
        if(yfom>yfommax) yfommax=yfom
        if(yfom<yfommin) yfommin=yfom
        xyzs(5,i)=yfom
      enddo
      iescartopicco = 1 !KUKU
c     iescartopicco = 0
!!!   kverbo=1
      if(kverbo>0) write(6,*) 'Norm',xfommin,xfommax,yfommin,yfommax
      if(xfommax-xfommin>0.001.and.yfommax-yfommin>0.01) then
        do i=1,nats15
          xnorm=(xyzs(4,i)-xfommin)/(xfommax-xfommin)
          ynorm=(xyzs(5,i)-yfommin)/(yfommax-yfommin)
          if(kverbo>0) write(6,*) 'norm',i,xnorm,ynorm,xnorm+ynorm
          ies=0
          if(iescartopicco==1) then
c           if (resm > 1.5) then
            if (ResEff > 1.5) then
c             if(xnorm<0.15.and.ynorm<0.15) ies=1
              if(xnorm<0.10.and.ynorm<0.10) ies=1
            else
              if(xnorm+ynorm<0.4) ies=1
            endif
          endif
          if(ies==1) then
             if(kverbo>0) write(6,*)
     &         'scarto il picco',i,'con fom',xnorm,ynorm
              xyzo(4,i)=0.0
          endif
        enddo
      endif
c
c--elimino dalla lista i picchi scartati
c
      npicchiOld=nats15
      xyz15(1:3,1:nats15)=xyzo(1:3,1:nats15)
      xyz15(4,1:nats15)=xyzo(4,1:nats15)
      nats15=0
      do i=1,npicchiOld
        if(xyz15(4,i)>0.0) then
          nats15=nats15+1
          xyzo(1:3,nats15)=xyz15(1:3,i)
          xyzo(4,nats15)=xyz15(4,i)
        endif
      enddo
c--deb
      if (knw == 1) then
          write(6,'(a,i9)') ' Number of peaks after rejection:',nats15
c      if (jBlock == 1) then
c       do ii=1,nats15
c        write(6,'(a,i6,4f15.3)') 'dopo',ii,xyzo(1:4,ii)
c       enddo
c      endif
      endif
      if(knw>0) then
        xyzs=xyzo
        if(ifTime==0.and.knw>0) call to_coord_Patt(ksezold)
c       stop 122
      endif
c
c--elimino dalla lista i picchi scartati
c
c     npicchiOld=nats15
c     xyz15(1:3,1:nats15)=xyzo(1:3,1:nats15)
c     xyz15(4,1:nats15)=xyzo(4,1:nats15)
c     nats15=0
c     do i=1,npicchiOld
c       if(xyz15(4,i)>0.0) then
c         nats15=nats15+1
c         xyzo(1:3,nats15)=xyz15(1:3,i)
c         xyzo(4,nats15)=xyz15(4,i)
c       endif
c     enddo
c--deb
c     if (knw == 1) then
c         write(6,'(a,i9)') ' Number of peaks after second rejection:',
c    &                      nats15
c     endif
c     if(knw>0) then
c       xyzs=xyzo
c       if(ifTime==0.and.knw>0) call to_coord_Patt(ksezold)
c     endif
c
c-deb
c
c     do npk = 1,nats15
c        write(lo,*) 'PICCO SELEZIONATO',npk,xyzs(1:3,npk)
c        x2 = side(xyzs(1,npk) * 2)
c        y2 = side(xyzs(2,npk) * 2)   ! C2
!        y2 = 0.5                     ! P21
c        z2 = side(xyzs(3,npk) * 2)
c        if (npk == 50) then
c            x1 = 0.3206
c            y1 = 0.
c            z1 = 0.4363
c            write(lo,*) 'PICCO SELEZIONATO',npk,x1,y1,z1
c            x2 = side(x1 * 2)
c            y2 = side(y1 * 2)
c            z2 = side(z1 * 2)
c        endif
c        hei = xyzs(4,npk)
c        call dist_Patt_new(npk,x2,y2,z2,nct,z1z2)
c        if (nct > 0) then
c            z1z2med = z1z2 / float(nct)
c        else
c            z1z2med = 0.0
c        endif
c        write(lo,111) npk,hei,nct,z1z2,z1z2med
c     enddo
c111  format('PICCO SELEZ. - n. contributi',i8,f12.2,i8,2f10.3)
c     stop 122
c--deb
c
   10 format(' Patterson Procedure unable to provide trials.',/,
     *       ' The program skips the Block.',/)
      return
      end
c---------------------------------------------------------
      subroutine CercaPicchiPatt()  
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Molcom
      USE PhaseModule
      dimension xor(3),xnew(3),s(3),xs(3)
!
      if(iwei==0.and.ksize>3) then
         disttol=10.0
      else
         disttol=1.0
      endif
!
!-- switch to the Patterson Space Group
!
      icent=1
      tmat(:,:)=0.
      call musym()
      nsymTot=nsym*(icent+1)*pts
!
!-ricerca dei picchi piu' alti  ( e lontani dall'origine)
!
      aperc(1)=min(500.,float(maxAtoms)/float(nsymTot))
      if (aperc(1) < 1.0) return  ! PEZZA ROCCO 11/03/2008
c     aperc(1)=min(1000.,float(maxAtoms)/float(nsymTot))
c     aperc(1)=float(maxAtoms)/float(nsymTot)
      call pksrch_big_RocPat(1,ier)
c
      hold=0.0
      nats30=0
      do i=1,nats
c       write(6,'(a,3f8.3,f15.1)') 'lista picchi Patt',xyzs(1:4,i)
        xnew(1:3)=xyzs(1:3,i)
        hnew=xyzs(4,i)
c
        if(abs(hnew-hold)<0.001) cycle 
!
!-elimino quelli vicini all'origine
!
        distmin=999.
        xs(:)=0.0
        do kk1=1,ncentr
          coef=1.0
          kk3=1
          call xequi(xs,kk3,coef,xor,kk1)
          call xdist(xnew,xor,dist,s)
          if(dist<distmin) distmin=dist
        enddo
        if(distmin>disttol) then    
C!        if(distmin > disttol .and. distmin < distanzamassima) then    
!
!
!-genero i picchi equivalenti 
!
          hold=hnew
          do kk1=1,ncentr
          do kk2=1,icent+1
          coef=1.0
          if(kk2==2) coef=-1.0
          do kk3=1,nsym
            call xequi(xnew,kk3,coef,xs,kk1)
            nats30=nats30+1
            xyz30(1,nats30)=side(xs(1))
            xyz30(2,nats30)=side(xs(2))
            xyz30(3,nats30)=side(xs(3))
c           write(6,'(a,2i5,5f10.4)') 'picchi Patterson',nats30,i
c    &                      ,xyz30(1:3,nats30),xyzs(4,i), bfac30(nats30)
          enddo
          enddo
          enddo
        endif
      enddo 
!
!-- restore the original Space Group
!
      call CreaSymmetryInfo(ier)
!
      return
      end
c--------------------------------------------------
      subroutine Riciclo3d(ksezold)
c
c--affina le fasi dei seminvarianti (2h,2k,2l) usando  i riflessi del tipo
c           (h,k,l) mediante un riciclo
c
c--ora nSemi e kSemi denotano solo i seminvarianti! 
c     iwork1 distingue  H    (1)  da h         (0)
c
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Seminvariants
      USE Molcom
      USE PhaseModule
      character*11 tirang
      logical :: ifPrimaVolta
      integer :: cicloVLD
      dimension prM(40)
      data prM /1.5, 2.5, 3.6, 5.0, 1.5, 2.5, 1.5, 5.0, 5.0, 7.5,
     *          30 * 2.5/
c
      ifPrimaVolta = .true.
      if(no(nk)>20.and.LowRes==0) then
        ncicli=10
      else
        ncicli=8

!!!!        ncicli=12

      endif
      if (kmad == 0 .and. ksize <= 3) ncicli = 40
      if (kmad==1) ncicli = 12   !pgMAD070206
      if (kmad==2) ncicli = 8   !pgMAD070206

      ier=0
      iprima=0
      nchange=2
      iciclochmax=(ncicli-1)/nchange
c
c     if(numbGen>0) then
c       numbMax=nreflTot
c     else
        numbMax=nrefl
c     endif
c
      if(icent==0 .and. lproj == 0) then
        call Mappa_Su(sufom)
        xmapShi=xmap
      else
        sufom=0
      endif
      sufom0=sufom
c     write(6,*) 'Sufom',sufom,sufom0/sufom
!
      cicloVLD = ncicli / 2
!
c
c--fa i cicli di inversione
c
      do iciclo=0,ncicli-1
c
!                             iciclo   ! 0 1 2 3 4 5 6 7
        iciclomod=mod(iciclo,nchange)  ! 0 1 0 1 0 1 0 1 
        icicloch=iciclo/nchange        ! 0 0 1 1 2 2 3 3
c
        if(kverbo > 0) then
           write(6,'(a,i5,a)') '============  Riciclo n. ',
     &            (iciclo+1),' ============'
        endif
c
c--faccio la mappa Fourier con gli H + h
c
        fcoef(1:nrefl) = evet(1:nrefl) 
c       if(numbGen>0) then
c          fcoef(nrefl+1:nreflTot) = fcvet(nrefl+1:nreflTot)
c       endif
        fcoef(:) = fcoef(:) * wt(:)
        jpatt = 0
        if (kmad /= 0) then            !pgMAD090206
            call MakeMap(fcoef, iphaz, numbLSQ, jpatt, xmap,
     *                FORTH, BACK)
        else
            call MakeMap(fcoef, iphaz, numbMax, jpatt, xmap,
     *                FORTH, BACK)
        endif
!
!---ricalcolo la Cmap per sovrascrivere la Patt
c       call DoCmap(0,0,0,1,ksezold) 
c
c--modifico la mappa
c
        if (kmad /= 0) then            !pgMAD100206
            call ModificaMap3d_MAD(iciclo,ncicli,esponent)
        else
          if(ksize>3) then
            call ModificaMap3d(icicloch,iciclomod,esponent,ksezold) 
          else
            call ModificaMap3dPiero(icicloch,iciclomod,esponent,ksezold)
          endif
        endif
        if (ksize == 7 .and. LowRes == 0.and.no(nk)>20) then
            kprint = 1  !0
            call Modifica_Mappa_NEW(iciclo, ier)
            if (ier < 0) return
        endif
c
c--inverto la mappa modificata
c
        invflag = 1 
        percMap=0.025 

        if (kmad == 0) then    ! patterson MAD pg230407

        if (ksize < 3) then     ! patterson per piccole
c--pesaggio chiamato 20AB
           if (iciclo <10) then
              percMap = prM(iciclo+1)/100.
           else
              ich = iciclo / 5
              if(mod(ich,2) == 1) then
                  percMAP = 0.075       
              else
                  percMAP = 0.025       
              end if
           end if
           if(kverbo>0) write(lo,'(a,i5,a,f8.5)') 
     &            ' iciclo+1',(iciclo+1),' percMap =',percMap
        elseif(ksize==3) then
c--pesaggio chiamato 20A3B
           if (iciclo <10) then
              percMap = prM(iciclo+1)/100.
           elseif (iciclo < 20) then
              ich = iciclo / 5
              if(mod(ich,2) == 1) then
                  percMAP = 0.075       !20A
              else
                  percMAP = 0.025       !20A
              end if
           else
              if ( iciclo > 19 .and. iciclo < 25 )then
                 x=iciclo
                 x1 = 20
                 x2=ncicli-16
                 y1 = 0.015
                 y2 = 0.020
              else if ( iciclo > 24 .and. iciclo < 30 )then
                 x=iciclo
                 x1 = 25
                 x2=ncicli-11
                 y1 = 0.01
                 y2=0.075
              else if ( iciclo > 29 .and. iciclo < 35 )then
                 x=iciclo
                 x1 = 30
                 x2=ncicli-6
                 y1 = 0.01
                 y2=0.075
              else if (iciclo > 34 ) then
                 x=iciclo
                 x1 = 35
                 x2=ncicli-1
                 y1 = 0.01
                 y2=0.075
              end if
              call varlinear(x,x1,x2,y,y1,y2)
              percMAP = y
           end if
           if(kverbo>0) write(lo,'(a,i5,a,f8.5)') 
     &           ' iciclo+1',(iciclo+1),' percMap =',percMap
        endif

        endif                  ! patterson MAD pg230407
c
        if (ifNegativePeaks == 1) then
            percMap_n =  percMap * 1.2
            invflag = 3
        endif
c
c--occhio
c       invflag=0
c       call snipmap(xmap,2)
c--occhio
        call InvMap(khl,mkang,iphaz,fcvet,numbMax)
c
c      if(numbGen>0) then
c        nreflDimSav=nreflDim
c        nreflDim=nrefl
c        do i=1, nrefl
c         if (fcvet(i) > 0.00001) wt(i) = 1.
c        end do
c      endif
c

        if (kmad == 1) then    ! patterson MAD pg230407
          call PresigmaA(-2, 0)
          wt=pesMod
        else                   ! patterson MAD pg230407

           if (ksize <= 3) then   ! patterson per piccole
             x  = iciclo
             x1 = 0
             x2 = ncicli-1
             y1 = 0.3
             y2 = 1.0
             call varlinear(x,x1,x2,y,y1,y2)
             chope=y
             call CalcolaPesi(0,numbMax,chope,1)
           else
             if (knw > 0) then
                 write(6,*) ' Sigmaa di Riciclo3d'
             endif
             wt(:) = 1.0
             call PresigmaA(-2, 0)
             wt=pesMod
c
      if (kverbo == 1 .and. knw == 1) then
          nu = 456
          izero = 0
          ifmin = 1
          call examin(nu,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
      endif
c
c--nuovi pesi
c
c----   pesi: HM con P(wt) "teorica"
             if(iciclomod==1.and.esponent>1.2) then
c--deb
c           izero = 0
c           ifmin = 1
c           call examin(numbrun,mkang,khl,ipub,iphaz,nrefl,izero,wt,ifmin)
c           tirang = 'NREFL'
c           ipher = 1
c           call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
c    *                    ipub,iphaz,wt,10,0.0,ipher)
c--deb
               work1(1:nrefl) = wt(1:nrefl)
               work2(1:nrefl) = wt(1:nrefl)
               nsip1=100
               nwizm1=25
               call HistogramMatch(work1,work2,nrefl,nsip1,nwizm1,3)
               wt(1:nrefl) = work1(1:nrefl)
               if (ifTime == 0 .and. knw > 0) then
                  izero = 0
                  ifmin = 1
                  call examin(numbrun,mkang,khl,ipub,iphaz,nrefl,izero,
     *                   wt,1)
                  tirang = 'NREFL_HM'
                  ipher = 1
                  call pherrdisNew(tirang,wt,khl,mkang,nrefl,izero,
     *                    ipub,iphaz,wt,10,0.0,ipher)
               endif
             endif
           endif

        endif                  ! patterson MAD pg23040

c
c     if(numbGen>0) then
c       nreflDim=nreflDimSav
c       x  = iciclo
c       x1 = 0
c       x2 = ncicli-1
c       y1 = 1.0
c       y2 = 2.0
c       call varlinear(x,x1,x2,y,y1,y2)
c       chope = y
c       call Calcola_WT_Sigmaa_Patt(chope)
c     endif
c
c--calcolo della FOM
c
        if(iciclomod==1) then
          if(icent==0 .and. lproj == 0) then
            call Mappa_Su(sufom)
            xmapShi=xmap
          else
            sufom=0
          endif
        endif       
c       write(6,*) 'Sufom',sufom,sufom0/sufom
c
c--faccio le statistiche sulle fasi ottenute
c
        if(knw==1 .and. kverbo > 0) then
           call CalcolaStatisticheH3d(numbMax)
        endif
c
      enddo  ! fine ciclo
c--ufi
c     if(numbGen>0) then
c       do i=nrefl+1,nreflTot
c          if(fcvet(i)>10.) fcvet(i)=10.
c          wt(i)=wt(i)*fcvet(i)*0.1
c       enddo
c     endif
c--ufi
c
c--scrivo la mappa per XtalView
c
c     call Trasla_Origine(nrefl)
c     do i=1,nrefl
c      write(79,'(3i4,2f8.3,i5)') khl(1:3,i),evet(i),wt(i),iphaz(i)
c     enddo
c     fcoef(1:nrefl)=evet(1:nrefl)
c     fcoef(:) = fcoef(:) * wt(:)
c     call MakeMap(fcoef, iphaz, nrefl,0, xmap,
c    *                FORTH, BACK)
c     call ScriviMappa("FourierFinale")
      FFfom0=sufom
!
      return
      end
c-----------------------------------------------------------------------
      subroutine ModificaMap3d(icicloch,iciclomod,esponent,ksezold)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom
      USE PhaseModule
      USE Param
c       ciclo      ! 1 2 3 4 5 6 7 8
c       iciclomod  ! 0 1 0 1 0 1 0 1 
c       icicloch   ! 0 0 1 1 2 2 3 3
c
      zero=0.001
      esponent=1.0
      if (iciclomod==0) then
c
c--cerco di rompere la simmetria Patterson residua
c
        if(iwei>0) then
          factdump=0.0
          if(jsys>1) factdump=0.8
          if(ksize==7.and.no(nk)<=20) factdump=0.0
          call ImproveRicicloPat(ksezold,factdump)    
          if(icicloch==1) call ImproveRiciclo(factdump)
        else
          call ImproveRicicloPatNew(ksezold)    
        endif
c       call snipmap(xmap,1) 
c
      else
c
c--elevo a potenza la mappa
c
c       call snipmap(xmap,1)  
        if (resm < ResSogLow) return
        if(no(nk)>=20) then
           esponent=1.3
        else
           esponent=1.4
        endif
        if(ResEff>sogResEff.and.numbrun>10) esponent = 1.5
c
        if(knw>0) write(lo,'(a,2i4,f8.2)') 'PATT-ESP',
     &                iciclomod,icicloch,esponent

        if (ifNegativePeaks == 0) then
c           do il = 0, np(3)-1
c              do ik = 0, np(2)-1
c                 do ih = 0, np(1)-1
c                    if (xmap(ih,ik,il).le.zero) then
c                        xmap(ih,ik,il) = 0.0 
c                    else
c                        xmap(ih,ik,il) = xmap(ih,ik,il) ** esponent
c                    endif
c                 enddo
c              enddo
c           enddo
            call snipmap(xmap,2) 
        else
            do il = 0, np(3)-1
               do ik = 0, np(2)-1
                  do ih = 0, np(1)-1
                     xx = xmap(ih,ik,il)
                     if (xmap(ih,ik,il) < zero) then
                         xx = - xx
                         xx = xx ** esponent
                         xx = - xx
                     else
                         xx = xx ** esponent
                     endif
                     xmap(ih,ik,il) = xx
                  enddo
               enddo
            enddo
        endif
c
      endif ! su iciclomod
c
      return
      end
c-----------------------------------------------------------------------
      subroutine ModificaMap3dPiero(icicloch,iciclomod,esponent,ksezold)
      USE Atomi
      USE Mappa
      USE PhaseModule
      USE General
      USE Symmetry
      USE Molcom
      USE Param 
c       ciclo      ! 1 2 3 4 5 6 7 8
c       iciclomod  ! 0 1 0 1 0 1 0 1 
c       icicloch   ! 0 0 1 1 2 2 3 3
c
      zero=0.001
      esponent=1.0
      iciclo = 2*icicloch + iciclomod
      ich = iciclo / 5
      if (iciclo <10) then
         esponent = 0.8
      else
         if(mod(ich,2) == 1) then
            esponent = 0.8       
         else
            esponent = 1.2       
         end if
      end if

      if (iciclomod==0) then
c
c--opera la trasformazione dei picchi
c
        factdump = 0.8
        if(icicloch==0) call ImproveRicicloPat(ksezold,factdump)
        if (icicloch == 1) call ImproveRiciclo(factdump)

!  per forzare l'elevamento a potenza nei cicli pari

        if (iciclo > 3) then
          if(kverbo>0) write(6,'(a,f8.2)') 'esponent',esponent
           do il = 0, np(3)-1
             do ik = 0, np(2)-1
               do ih = 0, np(1)-1
                 if (xmap(ih,ik,il).lt.0.0) then
                   xmap(ih,ik,il) = 0.0
                 else
                   xmap(ih,ik,il) = xmap(ih,ik,il) ** esponent
                 endif
               enddo
             enddo
           enddo
        end if
c
      else
c
c--elevo a potenza la mappa
c
        if(kverbo>0) write(6,'(a,f8.2)') 'esponent',esponent
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
              if(xmap(ih,ik,il).le.zero) then
                xmap(ih,ik,il) = 0.0 
              else
                xmap(ih,ik,il) = xmap(ih,ik,il) ** esponent
             endif
            enddo
          enddo
        enddo
c
      endif ! su iciclomod
c
      return
      end
c-----------------------------------------------------------------------
      subroutine maxmin3d(denmin,denmax,avden,stden,npunt,id)
      USE Mappa

      denmin =  1.0e25
      denmax = -1.0e25
      avden  =  0.0
      stden  =  0.0
      npunt=0
c
       if(id==0) then
         do iz = 0, np(3)-1
           do iy = 0, np(2)-1
             do ix = 0, np(1)-1
               xx=xmap(ix,iy,iz)
               denmax=amax1(denmax,xx)
               denmin=amin1(denmin,xx)
               avden=avden + xx
               stden=stden + xx * xx
               npunt=npunt+1
             enddo
           enddo
         enddo
      else
         do iz = 0, np(3)-1
           do iy = 0, np(2)-1
             do ix = 0, np(1)-1
               xx=xmap(ix,iy,iz)
               if(xx>0) then   
                 denmax=amax1(denmax,xx)
                 denmin=amin1(denmin,xx)
                 avden=avden + xx
                 stden=stden + xx * xx
                 npunt=npunt+1
               endif
             enddo
           enddo
         enddo
      endif
c
      avden=avden/float(npunt)
      stden=stden/float(npunt) - avden*avden
      if (stden.gt.0.0) then
          stden=sqrt(stden)
      else
          stden=0.0
      endif
c
      return
      end
c-----------------------------------------------------------------------
      subroutine maxmin3dPatt(denmin,denmax,avden,stden)
      USE General
      USE Symmetry
      USE Mappa
      USE Molcom
      USE PhaseModule
      dimension xs(3),xs1(3),xs2(3),s(3)

      denmin =  1.0e25
      denmax = -1.0e25
      avden  =  0.0
      stden  =  0.0
      npunt=0
      xs1(:)=0.0
      alim=5 ! in Amstrongs
c
      do iz = 0, np(3)-1
        do iy = 0, np(2)-1
          do ix = 0, np(1)-1
c
            itake=1
            do kk1=1,ncentr
              coef=1.0
              kk3=1
              call xequi(xs1,kk3,coef,xs,kk1)
              xs2(1)=ix/float(np(1))
              xs2(2)=iy/float(np(2))
              xs2(3)=iz/float(np(3))
              call xdist(xs,xs2,dist,s)
              if(dist<alim) then
                 itake=0
                 cycle
              endif
            enddo
            if(itake==1) then
              xx=xmap(ix,iy,iz)
              denmax=amax1(denmax,xx)
              denmin=amin1(denmin,xx)
              avden=avden + xx
              stden=stden + xx * xx
              npunt=npunt+1
            endif
          enddo
        enddo
      enddo
c
      avden=avden/float(npunt)
      stden=stden/float(npunt) - avden*avden
      if (stden.gt.0.0) then
          stden=sqrt(stden)
      else
          stden=0.0
      endif
c
      return
      end
*----------------------------------------------------------------------------*
      subroutine changesection3d(sog,nmod,denmin)
      USE General, only : ifNegativePeaks
      USE Mappa
      USE PhaseModule
*---- invflag=1 taglia la mappa > sog (solo parte positiva)
*---- invflag=2 azzera la mappa > sog (solo parte positiva)
*---- invflag=3 taglia la mappa > sog 
*---- invflag=4 azzera la mappa > sog 
*---- invflag=10 azzera la mappa < sog (solo parte positiva)
*---- invflag=20 azzera la mappa < sog 
*---- invflag=30 azzera la mappa > sog partendo dal basso 
*---- invflag=31 taglio combinato
*---- invflag=40 azzera la parte negativa 

      nmod=0
c
      do 150 k=0,np(3)-1
         do 100 j=0,np(2)-1
            do 50 i=0,np(1)-1
               xx=xmap(i,j,k)
               if(abs(xx)<=0.0) cycle
c
c--applico la soglia
c
               if (sog.gt.0.0) then
                 if (invflag==1) then
                   if(xmap(i,j,k).gt.sog) then
                      xmap(i,j,k)=sog
                      nmod=nmod+1
                   endif
                 elseif (invflag==2) then
                   if(xmap(i,j,k).gt.sog) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==3) then
                   if(abs(xmap(i,j,k)).gt.sog) then
                      xmap(i,j,k)=sog
                      nmod=nmod+1
                   endif
                 elseif (invflag==4) then
                   if(abs(xmap(i,j,k)).gt.sog) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==10) then
                   if (ifNegativePeaks == 0) then
                       if(xmap(i,j,k).lt.sog) then
                          xmap(i,j,k)=0.0
                          nmod=nmod+1
                       endif
                   else
                       if(abs(xmap(i,j,k)).lt.sog) then
                          xmap(i,j,k)=0.0
                          nmod=nmod+1
                       endif
                   endif
                 elseif (invflag==20) then
                   if(abs(xmap(i,j,k)).lt.sog) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 elseif (invflag==30) then
                   sog1=denmin+sog
                   if(xmap(i,j,k).lt.sog1) then
                      xmap(i,j,k)=0.7*xmap(i,j,k)
                      nmod=nmod+1
                   endif
                 elseif (invflag==31) then
                   sog1=0.6666*sog
                   if(abs(xmap(i,j,k)).lt.sog1) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                   sog1=denmin+2*sog
                   if(xmap(i,j,k).lt.sog1) then
                      xmap(i,j,k)=0.7*xmap(i,j,k)
                   endif
                 elseif (invflag==40) then
                   if(xmap(i,j,k).lt.0.0) then
                      xmap(i,j,k)=0.0
                      nmod=nmod+1
                   endif
                 endif
               endif
c
  50        continue
 100     continue
 150  continue
c

      return
      end
c-----------------------------------------------------------------------
      subroutine DrawMap3d(id,tar,isez)
c
      USE Mappa
c
      tar=side(tar)
c
      do il = 0, np(3)-1
        do ik = 0, np(2)-1
          do ih = 0, np(1)-1
             if(isez==1) then
               if(ih==nint(tar*np(1))) then
                 write(id+0,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               elseif(ih==nint((1.-tar)*np(1))) then
                 write(id+1,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               elseif(ih==nint((0.5+tar)*np(1))) then
                 write(id+2,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               endif
             elseif(isez==2) then
               io1=nint(tar*np(2))
               io2=nint((0.5+tar)*np(2))
               io3=nint((1.-tar)*np(2))
               tar1=side(0.5-tar)
               io4=nint(tar1*np(2))
               if(io1>=np(2)) then
                   io1=io1-np(2)
               elseif(io1<0) then
                   io1=io1+np(2)
               endif
               if(io2>=np(2)) then
                   io2=io2-np(2)
               elseif(io2<0) then
                   io2=io2+np(2)
               endif
               if(io3>=np(2)) then
                   io3=io3-np(2)
               elseif(io3<0) then
                   io3=io3+np(2)
               endif
               if(io4>=np(2)) then
                   io4=io4-np(2)
               elseif(io4<0) then
                   io4=io4+np(2)
               endif
               if(ik==io1) then  
                 write(id+0,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               elseif(ik==io2) then
                 write(id+1,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               elseif(ik==io3) then
                 write(id+2,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               elseif(ik==io4) then
                 write(id+3,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               endif
             elseif(isez==3) then
               io1=nint(tar*np(3))
               io2=nint((0.5+tar)*np(3))
               io3=nint(tar*np(2)+2)
               io4=nint(tar*np(2)-2)
               if(io1>=np(3)) then
                   io1=io1-np(3)
               elseif(io1<0) then
                   io1=io1+np(3)
               endif
               if(io2>=np(3)) then
                   io2=io2-np(3)
               elseif(io2<0) then
                   io2=io2+np(3)
               endif
               if(io3>=np(3)) then
                   io3=io3-np(3)
               elseif(io3<0) then
                   io3=io3+np(3)
               endif
               if(io4>=np(3)) then
                   io4=io4-np(3)
               elseif(io4<0) then
                   io4=io4+np(3)
               endif
               if(il==io1) then  
                 write(id+0,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               elseif(il==io2) then
                 write(id+1,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               elseif(il==io3) then
                 write(id+2,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               elseif(il==io4) then
                 write(id+3,'(3i5,f10.2)') ih,ik,il,xmap(ih,ik,il)
               endif
             endif
          enddo
        enddo
      enddo
!
      return
      end
c-----------------------------------------------------------------------
      subroutine CalcolaStatisticheH3d(numbMax)
c
c--id=1: statistiche di H e h
c
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE Seminvariants
      real, allocatable :: wt_serv(:)
c
      IF (.NOT. ALLOCATED(wt_serv))
     *    ALLOCATE (wt_serv(1:numbMax),    stat = ierr)
c
      wt_serv(:)=0.
      write(6,*) ' special reflections'
      icont=0
      do i=1,numbMax
        if(iwork1(i).eq.1) then
          wt_serv(i)=wt(i)
          icont=1
        endif
      enddo
      if(icont>0) then
        nbru = +31
        izero = 0
        ifmin = 1
        call examin(nbru,mkang,khl,ipub,iphaz,numbMax,izero,wt_serv,
     *                        ifmin)
        nbru = +21
        izero = 0
        ifmin = 1
        call examin(nbru,mkang,khl,ipub,iphaz,nstr,izero,wt_serv,
     *                        ifmin)
      endif
c
      wt_serv(:)=0.
      write(6,*) ' general reflections'
      do i=1,numbMax
        if(iwork1(i).eq.0) then
          wt_serv(i)=wt(i)
        endif
      enddo
      nbru = +51
      izero = 0
      ifmin = 1
      call examin(nbru,mkang,khl,ipub,iphaz,numbMax,izero,wt_serv,
     *                        ifmin)
      nbru = +41
      izero = 0
      ifmin = 1
      call examin(nbru,mkang,khl,ipub,iphaz,nstr,izero,wt_serv,
     *                        ifmin)
c
      IF (ALLOCATED(wt_serv))
     *        DEALLOCATE (wt_serv, stat = ierr)
!
      return
      end
c-----------------------------------------------------------------------
      subroutine RompiSimmetria3d(x1,y1,z1)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom
      USE PhaseModule
      dimension pik(3,200)
      dimension xs(3),xs1(3),s(3)
      integer sidepp
c
c--genero i suoi equivalenti per simmetria
c
      pik(:,:)=0.0
      npiktot=0
      ndrop=3
      do k=1,nsymTot
        call oper(k,xs,x1,y1,z1)
c
c--rimetto la posizione del picco equivalente nella cella
c  e genero gli 8 picchi della simmetria residua dei seminvarianti
c
        do k1=2,nOrigRoxi
          npiktot=npiktot+1
          do j=1,3
            termm=xs(j)+tabo(k1,j)
            pik(j,npiktot)=side(termm)
          enddo
        enddo
      enddo
c
c--cancello nella mappa tutti i 28 picchi equivalenti al primo, traslati
c     di 1/2 (quelli centrosimmetrici sono stati gia' cancellati)
c
      do_1: do i=1,npiktot
c
        do j=1,3
          termm=pik(j,i)
          xs(j)=side(termm)
        enddo
c
c--controllo che il picco da modificare non coincida con alcuno
c  degli equivalenti secondo il gruppo spaziale
c
        do k=1,nsymTot
          call oper(k,xs1,x1,y1,z1)
          call xdist(xs1,xs,dist,s)
          if(dist<1.2) then
            if(kverbo>0) then
              write(6,'(a,3f8.2)') 'picco non modificato',xs
             endif
             cycle do_1
          endif
        enddo
c
        io1=nint(xs(1)*np(1))
        io2=nint(xs(2)*np(2))
        io3=nint(xs(3)*np(3))
c
        do il = -ndrop, ndrop
          do ik = -ndrop, ndrop
            do ih = -ndrop, ndrop 
               ih1=sidepp(io1+ih,np(1))
               ik1=sidepp(io2+ik,np(2))
               il1=sidepp(io3+il,np(3))
               xmap(ih1,ik1,il1) = 0.0
            enddo
          enddo
        enddo
      enddo do_1
!
      return
      end
c-----------------------------------------------------------------------
      function spreadpeak_clever(ih,ik,il)
c
c--fa lo spread  su tutti i 19 punti 
c
      USE Mappa
      common /misc/ ttt(3,3), dxmax(3), ishift(3,19)
      dimension b(19)
      integer sidepp
c
      do i=1,19
        ih1=sidepp(ih+ishift(1,i),np(1))
        ik1=sidepp(ik+ishift(2,i),np(2))
        il1=sidepp(il+ishift(3,i),np(3))
        b(i)=xmapApp(ih1,ik1,il1)
      enddo
      spreadpeak_clever=b(10)
      b1 = b(3) + b(7) + b(9) + b(11) + b(13) + b(17)
      b2 = b(1) + b(2) + b(4) + b(5) + b(6) + b(8) +
     &     b(12) + b(14) +  b(15) + b(16) + b(18) + b(19)
      f = (30.0 * b(10) + 11.0 * b1 - 8.0 * b2) / 63.0
      if(abs(f)>0.001) then
        c = (b(5)+b(12)+b(13)+b(14)+b(19)
     &      -b(1)-b(6)-b(7)-b(8)-b(15))/10.0
        deltaxf = c / f
        if(abs(deltaxf)<1.0) then
          d = (b(4)+b(8)+b(11)+b(14)+b(18)
     &        -b(2)-b(6)-b(9)-b(12)-b(16))/10.0
          deltay = d / f
          if(abs(deltay)<1.0) then
            e = (b(15)+b(16)+b(17)+b(18)+b(19)
     &          -b(1)-b(2)-b(3)-b(4)-b(5))/10.0
            deltaz = e / f
            if(abs(deltaz)<1.0) then
               ih2=sidepp(nint(ih+deltaxf),np(1))
               ik2=sidepp(nint(ik+deltay),np(2))
               il2=sidepp(nint(il+deltaz),np(3))
c              write(6,*) 'uf ',deltaxf,deltay,deltaz,
c    &                  ih,ik,il,ih2,ik2,il2,xmapApp(ih2,ik2,il2)
               spreadpeak_clever=xmapApp(ih2,ik2,il2)
            endif
          endif
        endif
      endif
c
      return 
      end
c-----------------------------------------------------------------------
      function spreadpeak_asse4(xmapmod,ih,ik,il,ksez)
c
c
c--fa lo spread    +      che va bene per l'asse 4 
c                + * +
c                  +
c
c  ksez=0 serve per l'eventuale spread sulla Patterson per la mappa S
c
      USE Mappa
      real xmapmod(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      integer sidepp
c
      spreadpeak_asse4=0.0
      if(ksez==0) then
c--spread nello spazio  (serve per la Patterson)
        ih1=sidepp(ih-1,np(1))
        ih2=sidepp(ih+1,np(1))
        ik1=sidepp(ik-1,np(2))
        ik2=sidepp(ik+1,np(2))
        il1=sidepp(il-1,np(3))
        il2=sidepp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih1,ik,il)
        xx3=xmapmod(ih2,ik,il)
        xx4=xmapmod(ih,ik1,il)
        xx5=xmapmod(ih,ik2,il)
        xx6=xmapmod(ih,ik,il1)
        xx7=xmapmod(ih,ik,il2)
        spreadpeak_asse4=max(xx1,xx2,xx3,xx4,xx5,xx6,xx7)
      elseif(ksez==1) then
c--spread nella sezione yz
        ik1=sidepp(ik-1,np(2))
        ik2=sidepp(ik+1,np(2))
        il1=sidepp(il-1,np(3))
        il2=sidepp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih,ik1,il)
        xx3=xmapmod(ih,ik2,il)
        xx4=xmapmod(ih,ik,il1)
        xx5=xmapmod(ih,ik,il2)
        spreadpeak_asse4=max(xx1,xx2,xx3,xx4,xx5)
      elseif(ksez==2) then
c--spread nella sezione xz
        ih1=sidepp(ih-1,np(1))
        ih2=sidepp(ih+1,np(1))
        il1=sidepp(il-1,np(3))
        il2=sidepp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih1,ik,il)
        xx3=xmapmod(ih2,ik,il)
        xx4=xmapmod(ih,ik,il1)
        xx5=xmapmod(ih,ik,il2)
        spreadpeak_asse4=max(xx1,xx2,xx3,xx4,xx5)
      elseif(ksez==3) then
c--spread nella sezione xy
        ih1=sidepp(ih-1,np(1))
        ih2=sidepp(ih+1,np(1))
        ik1=sidepp(ik-1,np(2))
        ik2=sidepp(ik+1,np(2))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih1,ik,il)
        xx3=xmapmod(ih2,ik,il)
        xx4=xmapmod(ih,ik1,il)
        xx5=xmapmod(ih,ik2,il)
        spreadpeak_asse4=max(xx1,xx2,xx3,xx4,xx5)
      endif
c
      return 
      end
c-------------------------------------------------------
      function spreadpeak_asse2(xmapmod,ih,ik,il,ksez)
c
c--fa lo spread +   + che va bene per l'asse 2 perpendicolare
c                 *
c               +   +
c
      USE Mappa
      real xmapmod(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      common /misc/ ttt(3,3), dxmax(3), ishift(3,19)
      integer sidepp
c
      spreadpeak_asse2=0.0
      if(ksez==1) then
c--spread nella sezione yz
        ik1=sidepp(ik-1,np(2))
        ik2=sidepp(ik+1,np(2))
        il1=sidepp(il-1,np(3))
        il2=sidepp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih,ik1,il1)
        xx3=xmapmod(ih,ik2,il2)
        xx4=xmapmod(ih,ik2,il1)
        xx5=xmapmod(ih,ik1,il2)
        spreadpeak_asse2=max(xx1,xx2,xx3,xx4,xx5)
      elseif(ksez==2) then
c--spread nella sezione xz
        ih1=sidepp(ih-1,np(1))
        ih2=sidepp(ih+1,np(1))
        il1=sidepp(il-1,np(3))
        il2=sidepp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih1,ik,il1)
        xx3=xmapmod(ih2,ik,il2)
        xx4=xmapmod(ih1,ik,il2)
        xx5=xmapmod(ih2,ik,il1)
        spreadpeak_asse2=max(xx1,xx2,xx3,xx4,xx5)
      elseif(ksez==3) then
c--spread nella sezione xy
        ih1=sidepp(ih-1,np(1))
        ih2=sidepp(ih+1,np(1))
        ik1=sidepp(ik-1,np(2))
        ik2=sidepp(ik+1,np(2))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih1,ik1,il)
        xx3=xmapmod(ih2,ik2,il)
        xx4=xmapmod(ih1,ik2,il)
        xx5=xmapmod(ih2,ik1,il)
        spreadpeak_asse2=max(xx1,xx2,xx3,xx4,xx5)
        elseif(ksez<=0) then
          do i=1,19
            ih1=sidepp(ih+ishift(1,i),np(1))
            ik1=sidepp(ik+ishift(2,i),np(2))
            il1=sidepp(il+ishift(3,i),np(3))
            bterm=xmapmod(ih1,ik1,il1)
            if(bterm>spreadpeak_asse2) spreadpeak_asse2=bterm
          enddo
      endif
c
      return 
      end
c-------------------------------------------------------
      function spreadpeak_linea(xmapmod,ih,ik,il,ksez)
c
c--fa lo spread + + + che va bene per la linea di Harker
c               + * +
c               + + +
c  nella sezione perpendicolare alla linea
c
      USE Mappa
      real xmapmod(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      integer sidepp
c
      spreadpeak_linea=0.0
      if(ksez==11) then
        ik1=sidepp(ik-1,np(2))
        ik2=sidepp(ik+1,np(2))
        il1=sidepp(il-1,np(3))
        il2=sidepp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih,ik1,il1)
        xx3=xmapmod(ih,ik2,il2)
        xx4=xmapmod(ih,ik2,il1)
        xx5=xmapmod(ih,ik1,il2)
        xx6=xmapmod(ih,ik1,il)
        xx7=xmapmod(ih,ik2,il)
        xx8=xmapmod(ih,ik,il1)
        xx9=xmapmod(ih,ik,il2)
      elseif(ksez==12) then
        ih1=sidepp(ih-1,np(1))
        ih2=sidepp(ih+1,np(1))
        il1=sidepp(il-1,np(3))
        il2=sidepp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih2,ik,il1)
        xx3=xmapmod(ih1,ik,il2)
        xx4=xmapmod(ih1,ik,il1)
        xx5=xmapmod(ih2,ik,il2)
        xx6=xmapmod(ih2,ik,il)
        xx7=xmapmod(ih1,ik,il)
        xx8=xmapmod(ih,ik,il1)
        xx9=xmapmod(ih,ik,il2)
      elseif(ksez==13) then
        ih1=sidepp(ih-1,np(1))
        ih2=sidepp(ih+1,np(1))
        ik1=sidepp(ik-1,np(2))
        ik2=sidepp(ik+1,np(2))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih1,ik1,il)
        xx3=xmapmod(ih2,ik2,il)
        xx4=xmapmod(ih1,ik2,il)
        xx5=xmapmod(ih2,ik1,il)
        xx6=xmapmod(ih,ik1,il)
        xx7=xmapmod(ih,ik2,il)
        xx8=xmapmod(ih1,ik,il)
        xx9=xmapmod(ih2,ik,il)
      endif
      spreadpeak_linea=max(xx1,xx2,xx3,xx4,xx5,xx6,xx7,xx8,xx9)
c
      return 
      end
c-------------------------------------------------------
      function spreadpeak_asse3(xmapmod,ih,ik,il,ksez)
c
c--fa lo spread    + che va bene per l'asse 3 perpendicolare
c                *
c              +
c
      USE Mappa
      real xmapmod(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      integer sidepp
c
      spreadpeak_asse3=0.0
      if(ksez==1) then
c--spread nella sezione yz
        ik1=sidepp(ik-1,np(2))
        ik2=sidepp(ik+1,np(2))
        il1=sidepp(il-1,np(3))
        il2=sidepp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih,ik1,il1)
        xx3=xmapmod(ih,ik2,il2)
        spreadpeak_asse3=max(xx1,xx2,xx3)
      elseif(ksez==2) then
c--spread nella sezione xz
        ih1=sidepp(ih-1,np(1))
        ih2=sidepp(ih+1,np(1))
        il1=sidepp(il-1,np(3))
        il2=sidepp(il+1,np(3))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih1,ik,il1)
        xx3=xmapmod(ih2,ik,il2)
        spreadpeak_asse3=max(xx1,xx2,xx3)
      elseif(ksez==3) then
c--spread nella sezione xy
        ih1=sidepp(ih-1,np(1))
        ih2=sidepp(ih+1,np(1))
        ik1=sidepp(ik-1,np(2))
        ik2=sidepp(ik+1,np(2))
        xx1=xmapmod(ih,ik,il)
        xx2=xmapmod(ih1,ik1,il)
        xx3=xmapmod(ih2,ik2,il)
        spreadpeak_asse3=max(xx1,xx2,xx3)
      endif
c
      return 
      end
c-----------------------------------------------------------------------
      subroutine RestoreSMF(ksezold)
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom
      USE PhaseModule
      dimension xs(3)
      dimension alimit(3,2)
      integer ipixeq(2000,3)
      integer sidepp
c
      if(ifRhombAx==1) return
c
c--determino l'unita' asimmetrica 
c
      do i=1,3
        alimit(i,1)=xyzpat(i,1)/xyzpat(i,4)
        alimit(i,2)=xyzpat(i,2)/xyzpat(i,4)
      enddo
c
c--esploro l'unita' asimmetrica
c
      dx = 1.0/float(np(1))
      dy = 1.0/float(np(2))
      dz = 1.0/float(np(3))
      factDump=0.7 
c
      ipixeq=0
      if(ksezold==0) then
c--caso 3D
        xx=alimit(1,1)
        do while (xx<=alimit(1,2))
          xx=xx+dx
          yy=alimit(2,1)
        do while (yy<=alimit(2,2))
          yy=yy+dy
          zz=alimit(3,1)
          do while (zz<=alimit(3,2))
            zz=zz+dz
c
c--considero tutti i pixels equivalenti
c
            pixmin=99999999.0
            avpix=0.0
            icont=0
            npik=0
            fact=1.0
            do k=1,nsymTotRoc
              call oper(k,xs,xx,yy,zz)
              do k1=1,nOrigRoxiRoc
                npik=npik+1
                do j=1,3
                  termm=xs(j)+taboRoc(k1,j)
                  ipixeq(npik,j)=sidepp(nint(termm*np(j)),np(j))
                enddo
c
c--considero i corrispondenti valori della mappa e la loro media
c
                pixva=xmap(ipixeq(npik,1),ipixeq(npik,2),ipixeq(npik,3))
                avpix=avpix+pixva
                icont=icont+1
                if(pixva<0.01) fact=factDump
                if(pixva<pixmin) pixmin=pixva
              enddo
            enddo
            avpix=avpix/float(icont)
c
c--cambio i valori della mappa
c
           do k=1,npik
c             xmap(ipixeq(k,1),ipixeq(k,2),ipixeq(k,3))=pixmin 
              xmap(ipixeq(k,1),ipixeq(k,2),ipixeq(k,3))=avpix*fact
           enddo
c
          enddo
        enddo
        enddo
      elseif(ksezold==1) then
        xx=0.0
        yy=alimit(2,1)
        do while (yy<=alimit(2,2))
          yy=yy+dy
          zz=alimit(3,1)
          do while (zz<=alimit(3,2))
            zz=zz+dz
c
c--considero tutti i pixels equivalenti
c
c           pixmin=9999999.0
            pixmax=0.0
            npik=0
            do k=1,nsymTotRoc
              call oper(k,xs,xx,yy,zz)
              do k1=1,nOrigRoxiRoc
                npik=npik+1
                do j=1,3
                  if(j==ksezold) cycle
                  termm=xs(j)+taboRoc(k1,j)
                  ipixeq(npik,j)=sidepp(nint(termm*np(j)),np(j))
                enddo
c
c--considero i corrispondenti valori della mappa e la loro media
c
                pixva=xmap(ipixeq(npik,1),ipixeq(npik,2),ipixeq(npik,3))
                if(pixva>pixmax) pixmax=pixva
c               if(pixva<pixmin) pixmin=pixva
              enddo
            enddo
c
c--cambio i valori della mappa
c
           do k=1,npik
             do ix=0,np(1)-1
                xmap(ix,ipixeq(k,2),ipixeq(k,3))=pixmax
c               xmap(ix,ipixeq(k,2),ipixeq(k,3))=pixmin
             enddo
           enddo
c
          enddo
        enddo
      elseif(ksezold==2) then
        yy=0.0
        xx=alimit(1,1)
        do while (xx<=alimit(1,2))
          xx=xx+dx
          zz=alimit(3,1)
          do while (zz<=alimit(3,2))
            zz=zz+dz
c
c--considero tutti i pixels equivalenti
c
c           pixmin=999999.0
            pixmax=0.0
            npik=0
            do k=1,nsymTotRoc
              call oper(k,xs,xx,yy,zz)
              do k1=1,nOrigRoxiRoc
                npik=npik+1
                do j=1,3
                  if(j==ksezold) cycle
                  termm=xs(j)+taboRoc(k1,j)
                  ipixeq(npik,j)=sidepp(nint(termm*np(j)),np(j))
                enddo
c
c--considero i corrispondenti valori della mappa e la loro media
c
                pixva=xmap(ipixeq(npik,1),ipixeq(npik,2),ipixeq(npik,3))
                if(pixva>pixmax) pixmax=pixva
c               if(pixva<pixmin) pixmin=pixva
              enddo
            enddo
c
c--cambio i valori della mappa
c
           do k=1,npik
             do iy=0,np(2)-1
                xmap(ipixeq(k,1),iy,ipixeq(k,3))=pixmax
c               xmap(ipixeq(k,1),iy,ipixeq(k,3))=pixmin
             enddo
           enddo
c
          enddo
        enddo
      elseif(ksezold==3) then
        zz=0.0
        xx=alimit(1,1)
        do while (xx<=alimit(1,2))
          xx=xx+dx
          yy=alimit(2,1)
          do while (yy<=alimit(2,2))
            yy=yy+dy
c
c--considero tutti i pixels equivalenti
c
c           pixmin=999999.0
            pixmax=0.0
            npik=0
            do k=1,nsymTotRoc
              call oper(k,xs,xx,yy,zz)
              do k1=1,nOrigRoxiRoc
                npik=npik+1
                do j=1,3
                  if(j==ksezold) cycle
                  termm=xs(j)+taboRoc(k1,j)
                  ipixeq(npik,j)=sidepp(nint(termm*np(j)),np(j))
                enddo
c
c--considero i corrispondenti valori della mappa e la loro media
c
                pixva=xmap(ipixeq(npik,1),ipixeq(npik,2),ipixeq(npik,3))
                if(pixva>pixmax) pixmax=pixva
c               if(pixva<pixmin) pixmin=pixva
              enddo
            enddo
c
c--cambio i valori della mappa
c
           do k=1,npik
             do iz=0,np(3)-1
                xmap(ipixeq(k,1),ipixeq(k,2),iz)=pixmax
c               xmap(ipixeq(k,1),ipixeq(k,2),iz)=pixmin
             enddo
           enddo
c
          enddo
        enddo
c
      endif
c
      return 
      end
c---------------------------------------------------------
      subroutine RestoreSymmetry(factDump)
c
c--Rompe la simmetria Patterson, ristabilendo quella del gruppo spaziale
c    originario
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom
      dimension xs(3)
      dimension alimit(3,2)
      integer ipixeq(2000,3)
      integer sidepp
c
c
c--determino l'unita' asimmetrica 
c
      do i=1,3
        alimit(i,1)=xyzfou(i,1)/xyzfou(i,4)
        alimit(i,2)=xyzfou(i,2)/xyzfou(i,4)
      enddo
c     write(6,*) 'asymmetric unit X:',alimit(1,1),alimit(1,2)
c     write(6,*) 'asymmetric unit Y:',alimit(2,1),alimit(2,2)
c     write(6,*) 'asymmetric unit Z:',alimit(3,1),alimit(3,2)
c
c--esploro l'unita' asimmetrica
c
      dx = 1.0/float(np(1))
      dy = 1.0/float(np(2))
      dz = 1.0/float(np(3))
c
      xx=alimit(1,1)
      do while (xx<=alimit(1,2))
        xx=xx+dx
        yy=alimit(2,1)
        do while (yy<=alimit(2,2))
          yy=yy+dy
          zz=alimit(3,1)
          do while (zz<=alimit(3,2))
            zz=zz+dz
c
c--considero le posizioni equivalenti
c
            fact=1.0
            pixsum=0.0
            do k=1,nsymTot
              call oper(k,xs,xx,yy,zz)
c
c--considero tutti i pixels equivalenti
c
              do j=1,3
                ipixeq(k,j)=sidepp(nint(xs(j)*np(j)),np(j))
              enddo
c
c--considero i corrispondenti valori della mappa e la loro media
c
              pixval=xmap(ipixeq(k,1),ipixeq(k,2),ipixeq(k,3))
              if(pixval==0.0) fact=factDump
              pixsum=pixsum+pixval
            enddo
            avpix=pixsum/float(nsymTot)
c
c--cambio i valori della mappa
c
            do k=1,nsymTot
                xmap(ipixeq(k,1),ipixeq(k,2),ipixeq(k,3))=avpix*fact
            enddo
c
          enddo
        enddo
      enddo
c
      return
      end
c---------------------------------------------------------
      subroutine RestoreSymmetry_mono(x1,y1,z1,isez)
c
c--Rompe la simmetria Patterson, ristabilendo quella del gruppo spaziale
c    originario
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom
      dimension xs1(3)
      dimension xs2(3)
      integer sidepp
c
c--genero i suoi equivalenti per simmetria
c
      xs1(1)=x1
      xs1(2)=y1
      xs1(3)=z1
      k=2  ! considero solo la seconda matrice di rotazione del monoclino
      call oper(k,xs2,x1,y1,z1)
      do j=1,3
        termm=xs2(j)
        xs2(j)=side(termm)
      enddo
c
      isect1=sidepp(nint(xs1(isez)*np(isez)),np(isez))
      isect2=sidepp(nint(xs2(isez)*np(isez)),np(isez))
      if(isect2==isect1) isect2=isect1+np(isez)
c
      if(isez==1) then
        do ih1 = isect1, isect2-1
          ih2=sidepp(ih1+isect2,np(1))
          do il1 = 0, np(3)-1
            do ik1 = 0, np(2)-1
               ik2=np(2)-ik1
               ik2=sidepp(np(2)-ik1,np(2))
               il2=np(3)-il1
               il2=sidepp(np(3)-il1,np(3))
               xx1=xmap(ih1,ik1,il1)
               xx2=xmap(ih2,ik2,il2)
               xxt=(xx1+xx2)/2.  
               if(xx1==0.0.or.xx2==0.0) then
                 xxt=xxt*0.3
               endif
               xmap(ih1,ik1,il1)=xxt
               xmap(ih2,ik2,il2)=xxt
            enddo
          enddo
        enddo
      elseif(isez==2) then
        do ik1 = isect1, isect2-1
          ik2=ik1+isect2
          ik2=sidepp(ik1+isect2,np(2))
          do il1 = 0, np(3)-1
            do ih1 = 0, np(1)-1
               ih2=np(1)-ih1
               ih2=sidepp(np(1)-ih1,np(1))
               il2=np(3)-il1
               il2=sidepp(np(3)-il1,np(3))
               xx1=xmap(ih1,ik1,il1)
               xx2=xmap(ih2,ik2,il2)
               xxt=(xx1+xx2)/2.  
               if(xx1==0.0.or.xx2==0.0) then
                 xxt=xxt*0.3
               endif
               xmap(ih1,ik1,il1)=xxt
               xmap(ih2,ik2,il2)=xxt
            enddo
          enddo
        enddo
      elseif(isez==3) then
        do il1 = isect1, isect2-1
          il2=il1+isect2
          il2=sidepp(il1+isect2,np(3))
          do ik1 = 0, np(2)-1
            do ih1 = 0, np(1)-1
               ih2=np(1)-ih1
               ih2=sidepp(np(1)-ih1,np(1))
               ik2=np(2)-ik1
               ik2=sidepp(np(2)-ik1,np(2))
               xx1=xmap(ih1,ik1,il1)
               xx2=xmap(ih2,ik2,il2)
               xxt=(xx1+xx2)/2.  
               if(xx1==0.0.or.xx2==0.0) then
                 xxt=xxt*0.3
               endif
               xmap(ih1,ik1,il1)=xxt
               xmap(ih2,ik2,il2)=xxt
            enddo
          enddo
        enddo
      endif
!
      return
      end
c---------------------------------------------------------
      subroutine RiduciOrigine(ifKillZero)
!
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom
      USE PhaseModule
!
      dimension xs(3),xs1(3)
      integer sidepp
!
!-- ifKillZero = 0 Riduce l'intorno del picco all'origine tranne (0,0,0)
!-- ifKillZero = 1 Riduce l'intorno del picco all'origine e anche (0,0,0)
!

      if (ifKillZero == 0) then
          rayLimit = 1.0
      else
          rayLimit = -9999
      endif
c
c--considero picchi diversi da quello nell'origine in gruppi centrati
c
      nnp=min(np(1),np(2),np(3))
      if (ksize > 3) then      !patterson per piccole
         alim=15.0
      else
         alim=5.0
      end if
      nnp=nnp/2.
      if(alim>nnp) then
        alim=nnp
        if (kverbo > 0 ) then
          write(6,*) 'limite raggiunto',nnp,alim
        endif
      endif
      ndrop=alim
      fact=1./alim
c
      ca=cos(cell(4)*dtor)
      cb=cos(cell(5)*dtor)
      cg=cos(cell(6)*dtor)
c
      xs1(:)=0.0
      do kk1=1,ncentr
        coef=1.0
        kk3=1
        call xequi(xs1,kk3,coef,xs,kk1)
        if (kverbo > 0) 
     &      write(6,*) 'equivalenti di origine',kk1,xs(1:3)
        ih0=nint(xs(1)*np(1))
        ik0=nint(xs(2)*np(2))
        il0=nint(xs(3)*np(3))
c
        do iz = -ndrop, ndrop
          do iy = -ndrop, ndrop
            do ix = -ndrop, ndrop
c
              ray=ix**2+iy**2+iz**2+
     &            2.*ix*iy*cg + 2.*ix*iz*cb + 2.*iy*iz*ca
              ray=sqrt(ray)
c
              if (ray > rayLimit .and. ray < alim) then
                  ih=sidepp(ih0+ix,np(1))
                  ik=sidepp(ik0+iy,np(2))
                  il=sidepp(il0+iz,np(3))
                  xx=xmap(ih,ik,il)
                  if (xx > 0.0) then
                      factt=ray*fact
                      xmap(ih,ik,il) = factt*xx
                  endif
              endif
c
            enddo
          enddo
        enddo
c
      enddo  ! fine loop sulla centratura
!
      if (ifKillZero == 1) then
          xmap(0,0,0) = xmap(1,0,0) / 2.0
      endif
!PEZZA
      go to 666
      xs1(1)=0.5
      xs1(2)=0.0
      xs1(3)=0.0
      do kk1=1,ncentr
        coef=1.0
        kk3=1
        call xequi(xs1,kk3,coef,xs,kk1)
        if (kverbo > 0) 
     &      write(6,*) 'equivalenti di origine',kk1,xs(1:3)
        ih0=nint(xs(1)*np(1))
        ik0=nint(xs(2)*np(2))
        il0=nint(xs(3)*np(3))
c
        do iz = -ndrop, ndrop
          do iy = -ndrop, ndrop
            do ix = -ndrop, ndrop
c
              ray=ix**2+iy**2+iz**2+
     &            2.*ix*iy*cg + 2.*ix*iz*cb + 2.*iy*iz*ca
              ray=sqrt(ray)
c
              if(ray>1.0.and.ray<alim) then
                ih=sidepp(ih0+ix,np(1))
                ik=sidepp(ik0+iy,np(2))
                il=sidepp(il0+iz,np(3))
                xx=xmap(ih,ik,il)
                if(xx>0.0) then
                  factt=ray*fact
                  xmap(ih,ik,il) = factt*xx
                endif
              endif
c
            enddo
          enddo
        enddo
c
      enddo  ! fine loop sulla centratura

 666  continue

!PEZZA
c
      return
      end
!-----------------------------------------------------------------------
      function g_s_Patt(u)
      USE General
!
      x=(twopi*u)/ResEff
!
      if (x.le.0.01) then
         g_s_Patt=0.0
      else
        g_s_Patt=3.0 * ( sin(x) - x*cos(x) )/ (x**3)
      endif
!
      return
      end
c---------------------------------------------------------
      function g_s_Gen(u)
      USE General
!
      x=(twopi*u)/resolMiss
!
      if (x.le.0.01) then
         g_s_Gen  = 0.0
      else
         g_s_Gen = 3.0 * ( sin(x) - x*cos(x) ) / (x**3)
      endif
!
      return
      end
c---------------------------------------------------------
      subroutine DropZeroPeak()
c
c--elimina brutalmente il picco all'origine
c
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom
      USE PhaseModule
      dimension xs(3),xs1(3)
      integer sidepp
c
      ndrop=2
      factt=0
      xs1(:)=0.0
c
      do kk1=1,ncentr
        coef=1.0
        kk3=1
        call xequi(xs1,kk3,coef,xs,kk1)
        if (kverbo > 0) then
          write(6,*) 'equivalenti di origine',kk1,xs(1:3)
        endif
        ih0=nint(xs(1)*np(1))
        ik0=nint(xs(2)*np(2))
        il0=nint(xs(3)*np(3))
c
        do iz = -ndrop, ndrop
          do iy = -ndrop, ndrop
            do ix = -ndrop, ndrop
c
              ih=ih0+ix
              ik=ik0+iy
              il=il0+iz
c
              ray=(ih-ih0)**2+(ik-ik0)**2+(il-il0)**2
              ray=sqrt(ray)
c
              if(ray<1.5) then
                ih1=sidepp(ih,np(1))
                ik1=sidepp(ik,np(2))
                il1=sidepp(il,np(3))
                xmapApp(ih1,ik1,il1) = factt*xmapApp(ih1,ik1,il1)
              endif
c
            enddo
          enddo
        enddo
c
      enddo  ! fine loop sulla centratura 
c
      return
      end
c-----------------------------------------------------------------------
      subroutine ImproveRicicloPat(ksezold,factdump)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Molcom
      USE PhaseModule
      dimension xs(3),xs1(3),s(3)
      dimension xs2(3,200),xs3(3)
      integer kvetmax(1)
      dimension rhovet(200)
      integer sidepp
    
      jmin = 0
c
c--considero una sola sezione della mappa nel caso 2D
c
      xmapApp=xmap
      if(lproj==1) then
        xmap(1:np(1)-1,0:np(2)-1,0:np(3)-1)=0.0
      elseif(lproj==2) then
        xmap(0:np(1)-1,1:np(2)-1,0:np(3)-1)=0.0
      elseif(lproj==3) then
        xmap(0:np(1)-1,0:np(2)-1,1:np(3)-1)=0.0
      endif
c
c--cerco i picchi (esclusi gli equivalenti di simmetria)
c
      eps=0.01
      aperc(1)=10  
      call pksrch_big_RocPat(0,ier)
      xmap=xmapApp
c
c--seleziono il picco piu' alto (nell'intorno del PIVOT)
c
      ipeak=1
c     xs(1:3)=xyzo(1:3,itria)  ! picco PIVOT
c     do_peak: do i=1,nats
c       xs1(1:3)=xyzs(1:3,i)
c       do kk1=1,ncentr
c       do kk2=1,icent+1
c       coef=1.0
c       if(kk2==2) coef=-1.0
c       do kk3=1,nsym
c          call xequi(xs1,kk3,coef,xs3,kk1)
c          call xdist(xs,xs3,dist,s)
c          if(dist<1.2) then
c            ipeak=i
c            write(6,*) 'picco preso',i,dist
c            exit do_peak
c           else
c            write(6,*) 'picco scartato',xyzs(1:4,i),dist
c          endif
c       enddo
c       enddo
c       enddo
c     enddo do_peak
c
      x0=xyzs(1,ipeak)
      y0=xyzs(2,ipeak)
      z0=xyzs(3,ipeak)
      h0=xyzs(4,ipeak)
      xs1(1:3)=xyzs(1:3,ipeak)
c
      if(kverbo>0) write(6,'(a,3f8.3,f15.1)') 
     &                        'Fourier peak 1',x0,y0,z0,h0
c
c--faccio la sovrapposizione tra FF e Patt per modificare la mappa
c
      if(icent/=1.and.lproj==0) call SovrapponiSuPatt(x0,y0,z0) 
c
c--seleziono il secondo picco piu' alto
c
      atermNorm=h0
      nsymPat=nsym*(1+1)*pts
      distmin=999.
      contmax=0.0
      do_1: do j=1,nats30
c       write(6,'(a,i8,3f8.3)') 'Patt',j,xyz30(1:3,j)
        jj=mod(j,nsymPat)
        if(jj==0) jj=nsymPat
c
c--elimino qui i picchi Harker
c
        if(jj==1) ino=0
        if(jsys/=1.and.ksize>3.and.lproj==0) then  
          ix=sidepp(nint(xyz30(1,j)*np(1)),np(1))
          iy=sidepp(nint(xyz30(2,j)*np(2)),np(2))
          iz=sidepp(nint(xyz30(3,j)*np(3)),np(3))
          if(SMF(ix,iy,iz)>0.0) ino=1
        endif
c
        xs2(1,jj)=side(xyz30(1,j)+x0)  ! picco nella Patterson 1 shiftata
        xs2(2,jj)=side(xyz30(2,j)+y0)
        xs2(3,jj)=side(xyz30(3,j)+z0)
        rhovet(jj)=PattFou(xs2(1,jj),xs2(2,jj),xs2(3,jj))
c       write(6,'(a,3f8.3,i8,f8.1,i4)') 
c    &          '                ',xs2(1:3,jj),jj,rhovet(jj),ino
        if(jj==nsymPat) then
          if(ino==1) cycle  
          kvetmax=maxloc(rhovet(1:nsymPat))
!--considero il picco vincente
          xs(1)=side(xs2(1,kvetmax(1)))
          xs(2)=side(xs2(2,kvetmax(1)))
          xs(3)=side(xs2(3,kvetmax(1)))
c         write(6,'(a,3f8.3,f8.1)') 'scelto ',xs(1:3),rhovet(kvetmax(1))
c
c--elimino il picco se e' troppo vicino all'origine (0,0,0) nel triclino
c
          if (jsys == 1) then
              xs3 = 0.0
              call xdist(xs,xs3,dist,s)
              if (dist < 0.5) cycle do_1
          endif
c
c--elimino il picco se e' troppo vicino a quello PIVOT
c    (o ai suoi equivalenti)
c
          distmin=9999.
          do kk1=1,ncentr
          do kk2=1,icent+1
          coef=1.0
          if(kk2==2) coef=-1.0
          do kk3=1,nsym
             call xequi(xs1,kk3,coef,xs3,kk1)
             call xdist(xs,xs3,dist,s)
             if(dist<distmin) distmin=dist
c            if(lproj/=1.and.abs(xs(1)-xs3(1))<0.001) cycle do_1 
c            if(lproj/=2.and.abs(xs(2)-xs3(2))<0.001) cycle do_1
c            if(lproj/=3.and.abs(xs(3)-xs3(3))<0.001) cycle do_1
             if(lproj/=1.and.abs(s(1))<0.001) cycle do_1 
             if(lproj/=2.and.abs(s(2))<0.001) cycle do_1
             if(lproj/=3.and.abs(s(3))<0.001) cycle do_1
c            if(ksezold>0.and.ksezold<=3) then
c                do ii=1,3
c                   xs3(ii)=side(xs3(ii))
c                enddo
c               if(abs(xs3(ksezold)-0.5)<0.001) cycle do_1
c            endif
          enddo
          enddo
          enddo
c         write(6,*) 'distmin',distmin
          if(distmin<1.5) cycle do_1 
c         backg=atermNorm*g_s_Patt(dist)
c         if(distmin<5.0.and.backg>0.1) cycle do_1 
c
          cont=rhovet(kvetmax(1))
c
          if(cont>contmax) then
            contmax=cont
            x1=xs(1)
            y1=xs(2)
            z1=xs(3)
            jmin=j
          endif
        endif
      enddo do_1
c
      if(jmin==0) then
         write(6,*) 'Second peak not found'
         return
      endif
      if(kverbo>0) then
        write(6,'(a,3f8.3,i8,3f8.3,f8.1)') 
     &      'Fourier peak 2',x1,y1,z1,jmin,xyz30(1:3,jmin),contmax
      endif
      if(contmax<0.1) return
c
!--azzero  la maschera
      xmapApp(:,:,:)=0.0
c
c--premio i picchi scelti
c
      call SetMask(x0,y0,z0,-1.2)
      call SetMask(x1,y1,z1,-1.2)
c
c--nats30, xyz30(1:3,i)  picchi Patterson nella cella della Patterson   
c
      do j1=1,nats30
        xs(1)=side(xyz30(1,j1)+x0)  ! picco nella Patterson 1 shiftata
        xs(2)=side(xyz30(2,j1)+y0)
        xs(3)=side(xyz30(3,j1)+z0)
        distmin=999. 
        do j2=1,nats30
          xs1(1)=side(xyz30(1,j2)+x1)  ! picco nella Patterson 2 shiftata
          xs1(2)=side(xyz30(2,j2)+y1)
          xs1(3)=side(xyz30(3,j2)+z1)
          call xdist(xs,xs1,dist,s)
c
c--premio i picchi in sovrapposizione
c
          if(dist<distmin) then
            distmin=dist
            jmin=j2
            x2=xs1(1)
            y2=xs1(2)
            z2=xs1(3)
          endif
        enddo
c       write(6,*) 'distmin',j1,jmin,distmin
        if(distmin<0.5) then
          call SetMask(xs(1),xs(2),xs(3),-1.2)
          call SetMask(x2,y2,z2,-1.2)
c         write(6,*) 'vince ',j1,j2,xs,xs1,dist
        endif
      enddo
c
c--deprimo tutti gli altri picchi
c
      do j1=1,nats30
        xs(1)=side(xyz30(1,j1)+x0)  ! picco nella Patterson 1 shiftata
        xs(2)=side(xyz30(2,j1)+y0)
        xs(3)=side(xyz30(3,j1)+z0)
        xs1(1)=side(xyz30(1,j1)+x1)  ! picco nella Patterson 2 shiftata
        xs1(2)=side(xyz30(2,j1)+y1)
        xs1(3)=side(xyz30(3,j1)+z1)
c--deb
c       check=PattFou(xs(1),xs(2),xs(3))  ! deb
c       write(6,*) 'perde ',xs(1:3),check
c       check=PattFou(xs1(1),xs1(2),xs1(3))  ! deb
c       write(6,*) 'perde ',xs1(1:3),check
c--deb
        call SetMask(xs(1),xs(2),xs(3),factdump)
        call SetMask(xs1(1),xs1(2),xs1(3),factdump)
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine ImproveRicicloPatNew(ksezold)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Molcom
      USE PhaseModule
      dimension xs(3),xs1(3),s(3),xsmem(3),xsPat(3),xs3(3),xs2(3)
      integer sidepp
c
c--considero una sola sezione della mappa nel caso 2D
c
      xmapApp=xmap
      if(lproj==1) then
        xmap(1:np(1)-1,0:np(2)-1,0:np(3)-1)=0.0
      elseif(lproj==2) then
        xmap(0:np(1)-1,1:np(2)-1,0:np(3)-1)=0.0
      elseif(lproj==3) then
        xmap(0:np(1)-1,0:np(2)-1,1:np(3)-1)=0.0
      endif
c
c--cerco i picchi (esclusi gli equivalenti di simmetria)
c
c     aperc(1)=1000
      aperc(1)=500 
      call pksrch_big_RocPat(0,ier)
      xmap=xmapApp
c
c--seleziono il picco piu' alto (nell'intorno del PIVOT)
c
      ipeak=1
      xs(1:3)=xyzo(1:3,itria)  ! picco PIVOT
      do_peak: do i=1,nats
        xs1(1:3)=xyzs(1:3,i)
        do kk1=1,ncentr
        do kk2=1,icent+1
        coef=1.0
        if(kk2==2) coef=-1.0
        do kk3=1,nsym
           call xequi(xs1,kk3,coef,xs3,kk1)
           call xdist(xs,xs3,dist,s)
           if(dist<1.2) then
             ipeak=i
c            write(6,*) 'picco preso',i,dist
             exit do_peak
            else
c            write(6,*) 'picco scartato',xyzs(1:4,i),dist
           endif
        enddo
        enddo
        enddo
      enddo do_peak
c
      x0=xyzs(1,ipeak)
      y0=xyzs(2,ipeak)
      z0=xyzs(3,ipeak)
      h0=xyzs(4,ipeak)
      xs1(1:3)=xyzs(1:3,ipeak)
c
      if(kverbo>0) write(6,'(a,3f8.3,f15.1)') 
     &                        'Fourier peak 1',x0,y0,z0,h0
c
c--faccio la sovrapposizione tra FF e Patt per modificare la mappa
c
      if(icent/=1.and.lproj==0) call SovrapponiSuPatt(x0,y0,z0) 
c
c--seleziono il secondo picco piu' alto
c
      nsymPat=nsym*(1+1)*pts
      fommax=-1.
      jPatBest=0
      do_1: do j=1,nats
c
        xs(1:3)=xyzs(1:3,j)
        h1=xyzs(4,j)
c
c--elimino il picco se e' troppo vicino all'origine (0,0,0) nel triclino
c
        if(jsys == 1) then
          xs3 = 0.0
          call xdist(xs,xs3,dist,s)
          if (dist < 0.5) cycle do_1
        endif
c
c--elimino il picco se e' troppo vicino a quello PIVOT
c    (o ai suoi equivalenti)
c
        distmin=9999.
        do kk1=1,ncentr
        do kk2=1,icent+1
        coef=1.0
        if(kk2==2) coef=-1.0
        do kk3=1,nsym
           call xequi(xs1,kk3,coef,xs3,kk1)
           call xdist(xs,xs3,dist,s)
           if(dist<distmin) then
               distmin=dist
               xsmem(1:3)=s(1:3)
           endif
c... o se e' sulla stessa colonna del picco PIVOT
c          if(lproj/=1.and.abs(xs(1)-xs3(1))<0.001) cycle do_1
c          if(lproj/=2.and.abs(xs(2)-xs3(2))<0.001) cycle do_1
c          if(lproj/=3.and.abs(xs(3)-xs3(3))<0.001) cycle do_1
           if(lproj/=1.and.abs(s(1))<0.001) cycle do_1
           if(lproj/=2.and.abs(s(2))<0.001) cycle do_1
           if(lproj/=3.and.abs(s(3))<0.001) cycle do_1
c          if(ksezold>0.and.ksezold<=3) then
c              do ii=1,3
c                 xs3(ii)=side(xs3(ii))
c              enddo
c             if(abs(xs3(ksezold)-0.5)<0.001) cycle do_1
c          endif
        enddo
        enddo
        enddo
c       write(6,'(a,3f8.3)') 'xs1',xs1
c       write(6,'(a,3f8.3)') 'xs',xs
c       write(6,'(a,3f8.3,f8.3)') 'xsmem',xsmem,distmin
        if(distmin<10.0) cycle do_1 ! occhio
c
c--scelgo solo i picchi in prossimita' di un picco della Patterson shiftata
c  o, equivalentemente, quelli che formano col picco pivot  un vettore
c  interatomico vicino a quelli della Patterson
        distPat=999.
        do jPat=1,nats30
c
c--scarto il picco Patterson se e' stato gia' preso
c
c
          xsPat(1)=xyz30(1,jPat)  ! picco nella Patterson 
          xsPat(2)=xyz30(2,jPat)
          xsPat(3)=xyz30(3,jPat)
c
c--elimino qui i picchi Harker
c
          if(jsys/=1.and.ksize>3.and.lproj==0) then  
            ix=sidepp(nint(xsPat(1)*np(1)),np(1))
            iy=sidepp(nint(xsPat(2)*np(2)),np(2))
            iz=sidepp(nint(xsPat(3)*np(3)),np(3))
            if(SMF(ix,iy,iz)>0.0) cycle
          endif
c
          call xdist(xsmem,xsPat,dist,s)
          if(dist<distPat) then
            distPat=dist
            jPatmin=jPat
          endif
        enddo
        if(distPat>0.6) cycle do_1 
c       write(6,'(a,i8,3f8.3,i8,f8.3)') 'picco',j,xs,jPatmin,distPat
c
c--calcolo la figura di merito per l'accettazione del picco
c
      nfast=500
      icont=0
      do j1=1,nfast
        xs2(1)=side(xyz30(1,j1)+x0)  ! picco nella Patterson 1 shiftata
        xs2(2)=side(xyz30(2,j1)+y0)
        xs2(3)=side(xyz30(3,j1)+z0)
        distmin=999. 
        do j2=1,nfast
          xs3(1)=side(xyz30(1,j2)+xs(1))  ! picco nella Patterson 2 shiftata
          xs3(2)=side(xyz30(2,j2)+xs(2))
          xs3(3)=side(xyz30(3,j2)+xs(3))
          call xdist(xs2,xs3,dist,s)
          if(dist<distmin) distmin=dist
        enddo
        if(distmin<0.6) icont=icont+1
      enddo
      fomPat=icont/h1
c     write(6,'(a,i8,3f8.3,2i8)') 'figura',j,xs(1:3),jPatmin,icont
c     else
c     acont=0.0
c     do j1=1,nfast
c       xs2(1)=side(xyz30(1,j1)+xs(1))  ! picco nella Patterson 1 shiftata
c       xs2(2)=side(xyz30(2,j1)+xs(2))
c       xs2(3)=side(xyz30(3,j1)+xs(3))
c       check=PattFou(xs2(1),xs2(2),xs2(3))  ! deb
c       acont=acont+check
c     enddo
c     write(6,*) 'acont',j,jPatmin,acont
c     fomPat=acont
c
c--prendo il picco della Fourier con fomPat piu' grande
c
c       if(jPatmin==1006) then
        if(fomPat>fommax) then
          fommax=fomPat
          x1=xs(1)
          y1=xs(2)
          z1=xs(3)
          jPatBest=jPatmin
c         exit do_1
        endif
      enddo do_1
c
      if(jPatBest==0) then
         write(6,*) 'Second peak not found'
         return
      endif
      if(kverbo>0) then
        write(6,'(a,3f8.3,i8,3f8.3,f8.3)') 
     &     'Fourier peak 2',x1,y1,z1,jPatBest,xyz30(1:3,jPatBest),fommax
      endif
c
c
!--azzero  la maschera
      xmapApp(:,:,:)=0.0
c
c--premio i picchi scelti
c
      call SetMask(x0,y0,z0,-1.0)
      call SetMask(x1,y1,z1,-1.0)
c
c--nats30, xyz30(1:3,i)  picchi Patterson nella cella della Patterson   
c
      do j1=1,nats30
        xs(1)=side(xyz30(1,j1)+x0)  ! picco nella Patterson 1 shiftata
        xs(2)=side(xyz30(2,j1)+y0)
        xs(3)=side(xyz30(3,j1)+z0)
        distmin=999. 
        do j2=1,nats30
          xs1(1)=side(xyz30(1,j2)+x1)  ! picco nella Patterson 2 shiftata
          xs1(2)=side(xyz30(2,j2)+y1)
          xs1(3)=side(xyz30(3,j2)+z1)
          call xdist(xs,xs1,dist,s)
c
c--premio i picchi in sovrapposizione
c
          if(dist<distmin) then
            distmin=dist
            jmin=j2
            x2=xs1(1)
            y2=xs1(2)
            z2=xs1(3)
          endif
        enddo
c       write(6,*) 'distmin',j1,jmin,distmin
c       if(distmin<0.5) then
        if(distmin<0.6) then
          call SetMask(xs(1),xs(2),xs(3),-1.0)
          call SetMask(x2,y2,z2,-1.0)
c         write(6,*) 'vince ',j1,j2,xs,xs1,dist
        endif
      enddo
c
c--deprimo tutti gli altri picchi
c
      do j1=1,nats30
        xs(1)=side(xyz30(1,j1)+x0)  ! picco nella Patterson 1 shiftata
        xs(2)=side(xyz30(2,j1)+y0)
        xs(3)=side(xyz30(3,j1)+z0)
        call SetMask(xs(1),xs(2),xs(3),0.5)
        xs1(1)=side(xyz30(1,j1)+x1)  ! picco nella Patterson 2 shiftata
        xs1(2)=side(xyz30(2,j1)+y1)
        xs1(3)=side(xyz30(3,j1)+z1)
        call SetMask(xs1(1),xs1(2),xs1(3),0.5)
      enddo
c
      do il=0,np(3)-1
        do ik=0,np(2)-1
          do ih=0,np(1)-1
            if(xmapApp(ih,ik,il)>-0.5) then
              xx=xmap(ih,ik,il)
              if(xx>0) then
                xmap(ih,ik,il)=xx**0.25
              endif
            endif
          enddo
        enddo
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine ImproveRiciclo(factdump) 
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Molcom
      USE PhaseModule
      dimension xs(3),xs1(3,200),xs2(3),s(3),xs3(3)
      integer kvetmax(1)
      dimension rhovet(200)
      integer sidepp
c
c         x=icicloch
c         x1=0
c         x2=9  
c         y1=1.2   
c         y2=1.0   
c         call varlinear(x,x1,x2,y,y1,y2)
c         fact=y
c
c
c--considero una sola sezione della mappa nel caso 2D
c
      xmapApp=xmap
      if(lproj==1) then
        xmap(1:np(1)-1,0:np(2)-1,0:np(3)-1)=0.0
      elseif(lproj==2) then
        xmap(0:np(1)-1,1:np(2)-1,0:np(3)-1)=0.0
      elseif(lproj==3) then
        xmap(0:np(1)-1,0:np(2)-1,1:np(3)-1)=0.0
      endif
c
c--cerco i picchi (esclusi gli equivalenti di simmetria)
c
      eps=0.01
      aperc(1)=10  
      call pksrch_big_RocPat(0,ier)
      xmap=xmapApp
c
!--azzero la maschera
      xmapApp(:,:,:)=0.0
c
c--seleziono il picco piu' alto 
c
      ipeak=1
      xs(1:3)=xyzo(1:3,itria)  ! picco PIVOT
c     write(6,*) 'pivot',xs
      do_peak: do i=1,nats
        xs2(1:3)=xyzs(1:3,i)
        do kk1=1,ncentr
        do kk2=1,icent+1
        coef=1.0
        if(kk2==2) coef=-1.0
        do kk3=1,nsym
           call xequi(xs2,kk3,coef,xs3,kk1)
           call xdist(xs,xs3,dist,s)
           if(dist<1.2) then
             ipeak=i
c            write(6,*) 'picco preso',i,dist
             exit do_peak
            else
c            write(6,*) 'picco scartato',xyzs(1:4,i),dist
           endif
        enddo
        enddo
        enddo
      enddo do_peak
c
      x0=xyzs(1,ipeak)
      y0=xyzs(2,ipeak)
      z0=xyzs(3,ipeak)
      h0=xyzs(4,ipeak)
c
      if(kverbo>0) write(6,'(a,3f8.3,f15.1)') 
     &                    'Fourier peak 1',x0,y0,z0,h0
c
c--faccio la sovrapposizione tra FF e Patt per modificare la mappa
c
      if(icent/=1.and.lproj==0) call SovrapponiSuPatt(x0,y0,z0) 
c
c--nats30, xyz30(1:3,i)  picchi Patterson nella cella della Patterson   
c
      nsymPat=nsym*(1+1)*pts
      do j=1,nats30
c--deb
        xp=xyz30(1,j)   ! picco Patterson
        yp=xyz30(2,j)
        zp=xyz30(3,j)
c       write(6,*) 'picco Patterson',xp,yp,zp
c--deb
c
        jj=mod(j,nsymPat)
        if(jj==0) jj=nsymPat
c
c--elimino qui i picchi Harker
c
        if(jj==1) ino=0
        if(jsys/=1.and.ksize>3.and.lproj==0) then  
          ix=sidepp(nint(xyz30(1,j)*np(1)),np(1))
          iy=sidepp(nint(xyz30(2,j)*np(2)),np(2))
          iz=sidepp(nint(xyz30(3,j)*np(3)),np(3))
          if(SMF(ix,iy,iz)>0.0) ino=1
        endif
c
        xs1(1,jj)=side(xyz30(1,j)+x0)  ! picco nella Patterson shiftata
        xs1(2,jj)=side(xyz30(2,j)+y0)
        xs1(3,jj)=side(xyz30(3,j)+z0)
        rhovet(jj)=PattFou(xs1(1,jj),xs1(2,jj),xs1(3,jj))
c       write(6,*) '               ',xs1(1:3,jj),jj,rhovet(jj)
c
c--scelgo un solo picco da premiare, gli altri li deprimo 
c
        if(jj==nsymPat) then
          if(ino==1) cycle 
          kvetmax=maxloc(rhovet(1:nsymPat))
          iok=0
          do k=1,nsymPat
             if(k==kvetmax(1)) cycle
             if((rhovet(kvetmax(1))-rhovet(k))<0.0001) cycle 
c            write(6,*) 'ufi',rhovet(kvetmax(1)),rhovet(k)
             iok=1
          enddo
          if(rhovet(kvetmax(1))<0.001) cycle 
          if(iok==0) cycle 
!--considero prima il picco vincente
          xs(1)=side(xs1(1,kvetmax(1)))
          xs(2)=side(xs1(2,kvetmax(1)))
          xs(3)=side(xs1(3,kvetmax(1)))
          call SetMask(xs(1),xs(2),xs(3),-1.2) 
c         write(6,*) 'vince ',xs(1:3),rhovet(kvetmax(1))
c--deb
c         check=PattFou(xs(1),xs(2),xs(3))  ! deb
c         write(6,*) 'vince ',xs(1:3),rhovet(kvetmax(1)),check
c--deb
!--  ....poi quelli perdenti
          do i=1,nsymPat
            if(i==kvetmax(1)) cycle
            xs(1)=side(xs1(1,i))
            xs(2)=side(xs1(2,i))
            xs(3)=side(xs1(3,i))
            call SetMask(xs(1),xs(2),xs(3),factdump)
c           write(6,*) 'perde ',xs(1:3),rhovet(i)
c--deb
c           check=PattFou(xs(1),xs(2),xs(3))  ! deb
c           write(6,*) 'perde ',xs(1:3),rhovet(i),check
c--deb
          enddo
        endif
      enddo
c
      return
      end
c-----------------------------------------------------------------------
      subroutine SetMask(x1,y1,z1,flag)
c
      USE Mappa
      USE MappaPatterson
      USE Symmetry
      integer sidepp
      dimension xs(3),xs1(3)
c
      eps=0.0001
      ndrop=2
c
c--genero gli equivalenti per simmetria
c
      xs1(1)=x1
      xs1(2)=y1
      xs1(3)=z1
      do kk1=1,ncentr
      do kk2=1,icent+1
      coef=1.0
      if(kk2==2) coef=-1.0
      do kk3=1,nsym
        call xequi(xs1,kk3,coef,xs,kk1)
        io1=sidepp(nint(xs(1)*np(1)),np(1))
        io2=sidepp(nint(xs(2)*np(2)),np(2))
        io3=sidepp(nint(xs(3)*np(3)),np(3))
c
        if(flag>0.0-eps) then
c--riduci
          do il1 = io3-ndrop, io3+ndrop
            do ik1 = io2-ndrop, io2+ndrop
              do ih1 = io1-ndrop, io1+ndrop 
                ih=sidepp(ih1,np(1))
                ik=sidepp(ik1,np(2))
                il=sidepp(il1,np(3))
                xx=xmap(ih,ik,il)
                if(xmapApp(ih,ik,il)>-0.5) then
                   if(xx>0.0) then
                     xmap(ih,ik,il) = xx*flag
c                    xmap(ih,ik,il) = -xx ! va bene per metaxia
                   endif
                endif
              enddo
            enddo
          enddo
        else
c--incrementa o crea dal nulla
          do il1 = io3-ndrop, io3+ndrop
            do ik1 = io2-ndrop, io2+ndrop
              do ih1 = io1-ndrop, io1+ndrop 
                ih=sidepp(ih1,np(1))
                ik=sidepp(ik1,np(2))
                il=sidepp(il1,np(3))
                xx=xmap(ih,ik,il)
                if(xmapApp(ih,ik,il)>-0.5) then
                  xmapApp(ih,ik,il)=-1.0
                  if(xx>0.0) xmap(ih,ik,il) = xx*abs(flag)
c                 if(xx<0.0) xmap(ih,ik,il) = -xx*0.5 ! occhio
                endif
              enddo
            enddo
          enddo
        endif
c
      enddo
      enddo
      enddo
!
      return
      end
c-------------------------------------------------------
      real function PattFou(x1,y1,z1)
      USE Mappa
      USE MappaPatterson
      integer sidepp
c
        ndrop=1
c
        io1=nint(x1*np(1))
        io2=nint(y1*np(2))
        io3=nint(z1*np(3))
c
        sum=0.0
        icont=0
        do il1 = io3-ndrop, io3+ndrop
          do ik1 = io2-ndrop, io2+ndrop
            do ih1 = io1-ndrop, io1+ndrop 
              ih=sidepp(ih1,np(1))
              ik=sidepp(ik1,np(2))
              il=sidepp(il1,np(3))
              xx1=xmap(ih,ik,il)
              sum=sum+xx1 
              icont=icont+1
            enddo
          enddo
        enddo
c
      PattFou=sum/float(icont)
!
      return
      end
c---------------------------------------------------------------
      subroutine DrawHarker(ksez,id)
      USE Mappa
c
c--100+id sez x    200+id sez y   300+id  sez z
c
c
c--scritta per visualizzare la sezione di Harker
c
      n1=0
c
c--scrivi la mappa fourier dopo la esaltazione 
c
c     idd=id+100*ksez
      idd=id
      if(ksez==1) then
       do il = 0, np(3)-1
         do ik = 0, np(2)-1
           do ih = n1, n1
             write(idd,'(3i6,2x,f15.3)') ih,ik,il,xmap(ih,ik,il)
           enddo
         enddo
       enddo
      elseif(ksez==2) then
       do il = 0, np(3)-1
         do ik = n1, n1
           do ih = 0, np(1)-1
             write(idd,'(3i6,2x,f15.3)') ih,ik,il,xmap(ih,ik,il)
           enddo
         enddo
       enddo
      elseif(ksez==3) then
       do il = n1, n1
         do ik = 0, np(2)-1
           do ih = 0, np(1)-1
             write(idd,'(3i6,2x,f15.3)') ih,ik,il,xmap(ih,ik,il)
           enddo
         enddo
       enddo
      endif
c
      return
      end
!======================================================================
!
!  ------------------------ S E M I N V A R -------------------------
!
!======================================================================
      subroutine seminv(ier)
      USE Riflessi
      USE General
      USE Symmetry
      USE Seminvariants
!
      common/sym2/msym,nsym2,icents
      dimension ivet(12),vet(12)
      equivalence (vet(1),ivet(1))
!
      ier=0
      iprin = 0
      nsem=0
      nlis=0
      iphiv=0
!-- check if the space group is ' p 1 '
      icents = icent + 1
      msym=nsym*icents
      nsym2=(3-icents)*msym
      if (msym == 1 .and. knw == 1) then
          write(lo,1040)
          ier = 1
          return
      endif
 1040 format(//,' * Warning *  No seminvariants are estimated',
     *          ' when the space group is P 1',/)
!-- calculation of inverse matricies
      call invers
!-- calculation of generalized inverse matricies
      call geninv
!-- set up the working table
      call choice
!
      return
      end
c----------------------------------------------------------------------
      subroutine invers
      USE General
      USE Symmetry
      USE Seminvariants
c
      common/sym2/msym,nsym2,icents
c
      integer v(3,3)
c
      invet(1)=1
      do 30 i=2,msym
         call invs(i,v)
         do 20 j=1,msym
            do k=1,3
               do l=1,3
                  if (kmat(j,k,l).ne.v(k,l)) go to 20
               enddo
            enddo
            invet(i)=j
            go to 30
   20    continue
   30 continue
      return
      end
c---------------------------------------------------------------------
      subroutine invs(j,v)
      USE General
      USE Symmetry
!
      common/sym2/msym,nsym2,icents
c
      integer v(3,3),a(3,3)
c
      do i1=1,3
         do j1=1,3
            a(i1,j1)=kmat(j,i1,j1)
         enddo
      enddo
c
c---- calcola v, la inversa di a
c
      call inv3(a,idet,v)
      if (idet.eq.0) then
                       write(lo,100) j
                       write(lo,*) '****  programming  error  ****'
                       write(lo,*) ' sir ends in error'
                       call cstop('1234')
                      endif
  100 format(1x,'error computing invers no.',i2,' - det.=0  ')
      return
      end
c----------------------------------------------------------------------
      subroutine geninv
      USE General
      USE Symmetry
      USE Seminvariants
c
c-- calcola le generalizzate inverse
c-- memorizzandole in 'invma' ed in 'idivv'
c
c
      common/sym2/msym,nsym2,icents
c
      integer a(3,3),v(3,3),va(3,3)
c
      lo=6
      do k=1,nsym2
c
c---- calcola la inversa generalizzata   v  della matrice  a
c---- dove  a  e' uguale alla matrice unita' meno la
c---- trasposta della k-esima matrice di rotazione
c
         if (k == 1) cycle
         do i=1,3
            do j=1,3
               a(i,j)=-kmat(k,j,i)
            enddo
            a(i,i)=1+a(i,i)
         enddo
         call g12sp(a,v,idiv)
c
c---- calcola  va = v * a
c
         do i=1,3
            do j=1,3
               va(i,j)=0
               do l=1,3
                  va(i,j)=va(i,j)+v(i,l)*a(l,j)
               enddo
            enddo
         enddo
c
c---- memorizza  v  ed  va  in invma
c
         do i=1,3
            do j=1,3
               invma(k+48,i,j)=va(i,j)
               invma(k   ,i,j)= v(i,j)
            enddo
         enddo
         idivv(k)=idiv
c
      enddo
!
      return
      end
c-----------------------------------------------------------------------
      subroutine g12sp(a,v,idiv)
      integer s(3,3),com(3,3),v(3,3),hold(3,3)
      integer a(3,3),p(3,3),q(3,3)
      do i=1,3
         do j=1,3
            p(i,j)=0
            q(i,j)=0
            s(i,j)=0
            hold(i,j)=a(i,j)
         enddo
         p(i,i)=1
         q(i,i)=1
      enddo
      do ir=1,3
         irr=ir
c
c---- trova il minimo elemento diverso da zero
c
         ip=0
         jp=0
         imin=999
         do i=ir,3
            do j=ir,3
               int=iabs(hold(i,j))
               if (int.eq.0.or.int.ge.imin) cycle
               imin=int
               ip=i
               jp=j
            enddo
         enddo
         if (ir < ip) then
c
c---- scambia le righe
c
             call rowop(hold,ip,ir,ih,p,1)
         endif
         if (ir < jp) then
c
c---- scambia le colonne
c
             call colop(hold,jp,ir,ih,q,1)
         endif
         iflo=hold(ir,ir)
         if (iflo == 0) cycle
c
c---- azzera la colonna
c
         ip=ir+1
         if (ip <= 3) then
             do i=ip,3
                if (hold(i,ir).eq.0) cycle
                ih=-1*hold(i,ir)/iflo
                call rowop(hold,i,ir,ih,p,2)
             enddo
         endif
c
c---- azzera la riga
c
         jp=ir+1
         if (jp <= 3) then
             do j=jp,3
                if (hold(ir,j).eq.0) cycle
                ih=-1*hold(ir,j)/iflo
                call colop(hold,j,ir,ih,q,2)
             enddo
         endif
      enddo
      ir=irr
      ia=hold(irr,irr)
      if (ia /= 0) then
          irr1=irr-1
          ib=hold(irr1,irr1)
          iflo=mod(ia,ib)
          if (iflo /= 0) then
              call colop(hold,irr,irr,ib,q,2)
          endif
      endif
   22 idiv=hold(ir,ir)
      if (idiv == 0) then
          ir=ir-1
          if (ir) 22,23,22
      endif
      i=ir
   15 i=i-1
      if (i /= 0) then
          s(i,i)=idiv/hold(i,i)
          go to 15
      endif
      s(ir,ir)=1
      do i=1,3
         do j=1,3
            com(i,j)=0
            do l=1,3
               com(i,j)=com(i,j)+q(i,l)*s(l,j)
            enddo
         enddo
      enddo
      do i=1,3
         do j=1,3
            v(i,j)=0
            do l=1,3
               v(i,j)=v(i,j)+com(i,l)*p(l,j)
            enddo
         enddo
      enddo
   23 continue
!
      return
      end
c-----------------------------------------------------------------------
      subroutine colop(a,il,ir,ii,q,ind)
      integer a(3,3),q(3,3),r(3,3),com(3,3),temp(3,3)
      do i=1,3
         do j=1,3
            r(i,j)=0
         enddo
      enddo
      if (ind <= 1) then
          i=6-1*(il+ir)
          r(i,i)=1
          r(il,ir)=1
          r(ir,il)=1
      else
          do i=1,3
             r(i,i)=1
          enddo
          r(ir,il)=ii
      endif
      do i=1,3
         do j=1,3
            com(i,j)=0
            temp(i,j)=0
            do l=1,3
               temp(i,j)=temp(i,j)+q(i,l)*r(l,j)
               com(i,j)=com(i,j)+a(i,l)*r(l,j)
            enddo
         enddo
      enddo
      do i=1,3
         do j=1,3
            q(i,j)=temp(i,j)
            a(i,j)=com(i,j)
         enddo
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine rowop(a,il,ir,ii,p,ind)
      integer a(3,3),p(3,3),r(3,3),com(3,3),temp(3,3)
      do i=1,3
         do j=1,3
            r(i,j)=0
         enddo
      enddo
      if (ind <= 1) then
          i=6-1*(ir+il)
          r(i,i)=1
          r(il,ir)=1
          r(ir,il)=1
      else
          do i=1,3
             r(i,i)=1
          enddo
          r(il,ir)=ii
      endif
      do i=1,3
         do j=1,3
            com(i,j)=0
            temp(i,j)=0
            do l=1,3
               temp(i,j)=temp(i,j)+r(i,l)*p(l,j)
               com(i,j)=com(i,j)+r(i,l)*a(l,j)
            enddo
         enddo
      enddo
      do i=1,3
         do j=1,3
            p(i,j)=temp(i,j)
            a(i,j)=com(i,j)
         enddo
      enddo
      return
      end
c-----------------------------------------------------------------------
      subroutine choice
      USE General
      USE Symmetry
      USE Seminvariants
c
c-- calcola la 'working table' memorizzandola in 'jtable'
c
      common/sym2/msym,nsym2,icents
c
      integer v(3,3),vscar(48),mscar(48,3),jrot(48,48)
      data vscar/48*-1/
      data mscar/144*-1/
c
      nsy = 0
      jrot(:,:)=0
      maxi=1
      ima=1
      jmax=0
      if (nGenerators.eq.1.and.iprin.gt.2) write(lo,3000)
      if (icents.eq.1.and.iprin.gt.2) write(lo,9002)
      if (icents.eq.2.and.iprin.gt.2) write(lo,9000)
c
c---- elimina la matrice unita
c
      do i=2,msym
         vscar(i)=i
         mscar(i,1)=i
      enddo
      if (iprin.gt.2) write(lo,113)
      vscar(1)=-1
c
c---- stiamo trattando un gruppo spaziale fino a ortorombico ?
c
      if (jsys.le.3) go to 500
c
c---- poiche' e' un gruppo spaziale con simmetria superiore
c---- all'ortorombico ci chiediamo se e' abeliano
c
      if (nGenerators.eq.1) go to 700
c
c---- non essendo abeliano isoliamo la matrice  -i (se esiste)
c---- memorizzando la sua posizione (*-1) in  nsy
c
      if (icents.eq.1) go to 61
      nsy=msym/2+1
      if (iprin.gt.2) write(lo,9001) nsy
      vscar(nsy)=0
      nsy=-nsy
   61 continue
c
c---- eliminiamo le matrici inverse e le matrici  rj (?)
c----
c----              -1
c----             rj * ri * rj     (k=j+1,m)
c----
      m1m=msym-1
      do 99 i=2,msym
      iflag=0
      do 100 j=2,msym
      if (i.eq.j) go to 100
      iflag=0
c
c---- controlla che la matrice   ri  sia
c---- diversa dalla inversa di  rj .
c
      call invs(j,v)
      do k=1,3
         do l=1,3
         if (kmat(i,k,l).ne.v(k,l)) iflag=1
         enddo
      enddo
      if (iflag.ne.0) go to 100
      mscar(i,2)=j
      if (iprin.gt.2) write(lo,112) j,i
      go to 99
  100 continue
   99 continue
      do 854 i=2,msym
      do 853 j=2  ,msym
      if (i.eq.j) go to 853
      call invs(j,v)
c
c---- elimina le matrici equivalenti
c
      call prodms(i,j,v)
      j1p=j+1
      do 852 jj=2  ,msym
      if (jj.eq.i.or.jj.eq.j) go to 852
      do k=1,3
         do l=1,3
            if (kmat(jj,k,l).ne.v(k,l)) go to 852
         enddo
      enddo
      if (iprin.gt.2) write(lo,204) jj,i,j
      jrot(j,jj)=i
  852 continue
  853 continue
  854 continue
      do 860 j=2,msym
      jrot(1,j)=j
  860 continue
      do 855 j=2,msym
      do 856 i=1,msym
      jj=jrot(i,j)
      if (jj.eq.0) go to 856
      if (jj.eq.j) go to 856
      iflag=0
      jrot(1,jj)=0
      do 857 k=2,msym
      if (jrot(k,jj).eq.0) go to 857
      iflag=1
      jrot(k,jj)=0
  857 continue
      if (iflag.eq.0) jrot(i,j)=0
  856 continue
  855 continue
      jmax=0
      ima =0
      do 861 j=2,msym
      iflag=0
      do 862 i=1,msym
      jj=jrot(i,j)
      if (jj.eq.0) go to 862
      if (mscar(jj,1).eq.0) go to 862
      if (iflag.eq.1) go to 863
      iflag=1
      jmax=jmax+1
      ima =0
  863 continue
      ima=ima+1
      if (ima.gt.maxi) maxi=ima
      jtable(ima,jmax)=jj
      jj=mscar(jj,2)
      if (jj.lt.0) go to 862
      mscar(jj,1)=0
  862 continue
  861 continue
      go to 600
  700 continue
c
c---- essendo un gruppo abeliano deve solo eliminare le inverse
c
      if (iprin.gt.2) write(lo,4000)
      m1m=msym-1
      do 50 i=1,m1m
      if (vscar(i).le.0) go to 50
      iflag=0
      i1p=i+1
      do 45 j=i1p,msym
      if (vscar(j).le.0) go to 45
      call invs(j,v)
      do k=1,3
         do l=1,3
         if (kmat(i,k,l).ne.v(k,l)) iflag=1
         enddo
      enddo
      if (iflag.eq.0) go to 44
      iflag=0
      go to 45
   44 continue
      vscar(j)=0
      if (iprin.gt.2) write(lo,112) j,i
      go to 50
   45 continue
   50 continue
  500 continue
      do 505 i=1,msym
      if (vscar(i).le.0) go to 505
      jmax=jmax+1
      jtable(1,jmax)=vscar(i)
  505 continue
      go to 605
  600 continue
      if (icents.eq.1) go to 605
      if (nGenerators.gt.1.and.jsys.gt.3) go to 605
      jmax=jmax+1
      jtable(1,jmax)=iabs(nsy)
      nsy=0
  605 continue
      mm=jmax
      if (iprin.lt.2) go to 225
      write(lo,221)
      do i=1,maxi
         write(lo,223) (jtable(i,jj),jj=1,jmax)
      enddo
      write(lo,224)
      write(lo,9004) mm
  225 continue
      if (nsy.lt.0) nsy=0
c &&&&&&&&&&&&&&&&&&&&&&&
c &&&&&&&&&   questa istruzione serve ad evitare l'errore
c &&&&&&&&&   in compilazione - il 2000 non e' riferito
c &&&&&&&&&&&&&&&&&&&&&&&
      ihdgtd=0
      if(ihdgtd.eq.2323) goto 2000
      go to 9900
 2000 continue
      mm=-1
 9900 continue
      iimax=maxi
      ns=nsy
      return
  221 format(///,  5x,'  kk     w o r k i n g     t a b l e',/,
     *           5x,'==kk===========================================',/
     *            ,5x,'  kk')
  223 format(5x,'  kk     ',16i3)
  224 format(5x,'  kk',
     *     /,5x,    '==kk===========================================',/
     *        ,5x,'  kk',//)
  204 format(1x,'matrix # ',i2,' has been eliminated being equivalent to
     * matrix # ',i2,'  j=',i2)
  112 format(1x,'matrix # ',i2,' has been eliminated being the inverse o
     *f matrix # ',i2)
  113 format(1x,'matrix # 1 has been eliminated being the unitary one')
 3000 format(1x,'this is an abelian space group      ')
 4000 format(1x,'space group above orthorombic')
 9000 format(1x,'centrosimmetric space group')
 9002 format(1x,'non-centrosimmetric space group')
 9001 format(1x,'matrix number ',i2,'  is equal to  -i   ')
 9004 format(1x,'..... therefore we get ',i2,' different classes',//)
      end
c-----------------------------------------------------------------------
      subroutine prodms(ind1,ind2,v)
      USE General
      USE Symmetry
c
      common/sym2/msym,nsym2,icents
c
      integer v(3,3),com1(3,3),com2(3,3)
c
      do i=1,3
         do j=1,3
            com1(i,j)=0
            do l=1,3
               com1(i,j)=com1(i,j)+v(i,l)*kmat(ind1,l,j)
            enddo
         enddo
      enddo
      do i=1,3
         do j=1,3
            com2(i,j)=0
            do l=1,3
               com2(i,j)=com2(i,j)+com1(i,l)*kmat(ind2,l,j)
            enddo
         enddo
      enddo
      do i=1,3
         do j=1,3
            v(i,j)=com2(i,j)
         enddo
      enddo

      return
      end
c---------------------------------------------------------------------
      function modulo_sir(hkl)
      USE Symmetry
      USE Seminvariants
!
!-- check if a reflection is a seminvariant
!
      integer hkl(3)
c
      modulo_sir=1
      do 30 ic=1,3
      isum=0
      do i=1,3
         isum=isum+jsmat(ic,i)*hkl(i)
      enddo
      if (mod(isum,192).ne.0) return
   30 continue
      modulo_sir=0
!
      return
      end
c---------------------------------------------------------------------
      subroutine CheckPatt()
!
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Molcom
      USE PhaseModule
      dimension xs(3),xsp(3),s(3),xs1(3)

c
      nsymPat=nsym*(1+1)*pts
c     ncheck=nats30
      ncheck=min(50*nsymPat,nats30)
      do_1: do i=1,nats30
        ii=mod(i,nsymPat)
        if(ii==0) ii=nsymPat
        if(ii/=nsymPat) cycle
        xsp(1)=side(xyz30(1,i))  
        xsp(2)=side(xyz30(2,i))
        xsp(3)=side(xyz30(3,i))
        icont=0
        avdist=0.0
        pafom=0.0
        do_2: do j=1,ncheck-1
          xs(1:3)=xyz30(1:3,j)+xsp(1:3)  
!--calcolo il numero di sovrapposizioni
          do_3: do k=j+1,ncheck
            xs1(1:3)=xyz30(1:3,k)  
            call xdist(xs,xs1,dist,s)
            if(dist<1.0) then
              icont=icont+1
              avdist=avdist+dist
            endif
          enddo do_3
        enddo do_2
        if(icont>0) then
         avdist=avdist/float(icont)
         pafom=icont/avdist
        endif
        write(6,*) 'analizz',xsp,i,icont,avdist,pafom
        xyz30(4,i)=avdist
      enddo do_1
c
      return
      end
c---------------------------------------------------------------------
      subroutine CancSpread(ih,ik,il)
c
      USE Mappa
      USE MappaPatterson
      common /misc/ ttt(3,3), dxmax(3), ishift(3,19)
      integer sidepp
c
      do i=1,19
        ih1=sidepp(ih+ishift(1,i),np(1))
        ik1=sidepp(ik+ishift(2,i),np(2))
        il1=sidepp(il+ishift(3,i),np(3))
        SMF(ih1,ik1,il1)=1.0
      enddo
c
      return
      end
c------------------------------------------------------------------
      subroutine Mappa_Su(sufom)
      USE General
      USE Symmetry     
      USE Riflessi
      USE Atomi
      USE Mappa
      USE MappaCont
      USE MappaPatterson  ! solo per xmapShi
      USE PhaseModule     
      USE Param     
!--
      numbMax=nstr
!--prova
c     iyrand=67543
c     ix=iyrand
!--prova
!--
                icont=0 !deb
                do i=1,numbMax
                   worko(i) = wt(i)
                   iphazo(i) = iphaz(i)
!--metto fasi casuali (prova)
c                  call SirRandom(ix,iyrand,yfl)
c                  ix=iyrand
c                  iphaz(i)=nint(yfl*360.0)
!--metto fasi vere (prova)
c                  iphaz(i)=ipub(i)
!---
                   if (mkang(i) /= 1) then
                       wt(i) = 0.0
                   else
                       wt(i) = 1.0 
                   endif
                   fcoef(i) = evet(i) * evet(i) * wt(i)
                   iphaz(i) = 2.0 * iphaz(i)
c                  if(wt(i)>0.0) icont=icont+1 ! deb
                enddo
!
!-- switch to P2 Space Group
!
c              icent=0
c              tmat(:,:)=0.
c              call musym()
c              nsymTot=nsym*(icent+1)*pts

               jpatt = 0
!
!--serve per creare la mappa F*F
!
!g             call MakeMap_mod(numbMax, jpatt) ! twopi * 2
               twopiSav = twopi
               twopi = twopi * 2.0
               call MakeMap(fcoef, iphaz, numbMax, jpatt, xmap,
     *                FORTH, BACK)
               twopi = twopiSav
!
c
c--prova
c              aperc(1)=10
c              call pksrch_big_RocPat(1,ier) 
c              aver=0.0
c              do i = 1,nats
c                  write(6,99) i,xyzs(1:4,i)
c                  if(i>1) aver=aver+xyzs(4,i)
c              enddo
c99            format(i5,1h),4f15.3)
c--prova
c              aver=aver/float(nats)
c              sufom=xyzs(4,1)/aver
c              write(6,*) 'Mappa FF',xyzs(4,1),aver,sufom
               call maxmin3d(denmin,denmax,avden,stden,npunt,1)
               sufom=(denmax-avden)/stden
               if(kverbo>0) then
                 write(6,'(a,3f10.1,f8.2)') 'Mappa FF ',
     &                    denmax,avden,stden,sufom ! deb
               endif
!
!-- restore the original Space Group
!
!--rimetto a posto
c
      do i=1,numbMax
        iphaz(i)  =  iphazo(i)
        wt(i) = worko(i)
      enddo
!--
      return
      end
c---------------------------------------------------------------------
      subroutine SovrapponiSuPatt(x1,y1,z1)
      USE General
      USE Symmetry     
      USE Riflessi
      USE Atomi
      USE Mappa
      USE MappaPatterson  
      USE MappaCont
      USE PhaseModule     
      USE Param     
      integer sidepp

!--
        io1=sidepp(nint(x1*np(1)),np(1))
        io2=sidepp(nint(y1*np(2)),np(2))
        io3=sidepp(nint(z1*np(3)),np(3))

        xmapApp(:,:,:)=0.0
        xmapmod2(:,:,:)=0.0
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
c
              ih1=sidepp(ih+io1,np(1))
              ik1=sidepp(ik+io2,np(2))
              il1=sidepp(il+io3,np(3))
              xmapApp(ih1,ik1,il1)=Patt(ih,ik,il)
c
              ih2=sidepp(ih-io1,np(1))
              ik2=sidepp(ik-io2,np(2))
              il2=sidepp(il-io3,np(3))
              xmapmod2(ih2,ik2,il2)=xmapShi(ih,ik,il)
            enddo
          enddo
        enddo
c
        if(kverbo>0) write(6,*) 'Patt+FF map'
c
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
              xx1=xmapApp(ih,ik,il)
              xx2=xmapmod2(ih,ik,il)
              xx3=min(xx1,xx2)
              if(xx3>10.0) xmap(ih,ik,il)=1.5*xmap(ih,ik,il)
            enddo
          enddo
        enddo
!--
      return
      end
c---------------------------------------------------------------------
      subroutine ScriviMappa(filename_map)
      USE General
      USE Riflessi
      USE PhaseModule
      character*80 filename_map
c
c     filename_map="XtalMap"
      itype=0
      iform=2
      if (jopen(jhost,filename_map,itype,iform,ios).lt.0)
     *          go to 9500
c
c-- analizza e normalizza la mappa
c
      call Analizza_Mappa_Xtal(xmap_coef)
c
c-- scrive l'header
c
      nByte = 4
      call scrivi_header_Xtal(nByte,jhost,filename_map,ierr)
c
c-- scrive la mappa
c
      call ScriviMappaXtal(nByte,jhost,xmap_coef,xmap_div,ierr)
c
      close(jhost)
 9410 format(' Open  error, code =',i5,' file is ',a)
      ierr = -1
      return
c
 9500 write(Msg,9410) ios,filename_map(1:Lung(filename_map))
      call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
      ierr = -1
!--
      return
      end
c---------------------------------------------------------
      subroutine ModificaMap3d_MAD(iciclo,ncicli,esponent)
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE Molcom
      USE PhaseModule
      USE Param
c
      if(iciclo == 0) then
      elseif (iciclo == 2) then
        factdump = 0.0  
        call ImproveRiciclo(factdump)
      else 
        if (mod((iciclo+1),2) /= 0) then       !pgMAD170206
          esponent = 1.2
          if(kverbo>0) write(6,'(a,f8.2)') 'esponent',esponent
          do il = 0, np(3)-1
            do ik = 0, np(2)-1
              do ih = 0, np(1)-1
                if (xmap(ih,ik,il).lt.0.0) then
                  xmap(ih,ik,il) = 0.0
                else
                  xmap(ih,ik,il) = xmap(ih,ik,il) ** esponent
               endif
              enddo
            enddo
          enddo
        end if               !pgMAD170206
      endif ! su iciclo
!
      return
      end
c---------------------------------------------------------
      subroutine maxmin_dedi(nx,ny,nz,x)
      USE General
      USE Param
c
      real x(0:nx-1,0:ny-1,0:nz-1)

      denmin =  1.0e25
      denmax = -1.0e25
      avden  =  0.0
      stden  =  0.0
      do 30 iz = 0, nz-1
       do 20 iy = 0, ny-1
        do 10 ix = 0, nx-1
            xx=x(ix,iy,iz)
            if (xx > denmax) then
                denmax=xx
                ixmx = ix
                iymx = iy
                izmx = iz
            endif
            if (xx < denmin) then
                denmin=xx
                ixmn = ix
                iymn = iy
                izmn = iz
            endif
!           write(55,*) ix,iy,iz,xx
            avden=avden + xx
            stden=stden + xx * xx
 10     continue
 20    continue
 30   continue

      avden=avden/float(nx*ny*nz)
      stden=stden/float(nx*ny*nz) - avden*avden
      if (stden.gt.0.0) then
          stden=sqrt(stden)
      else
          stden=0.0
      endif
      rapden = denmax/stden

!     write(6,*) 'DenMax =',denmax,ixmx,iymx,izmx
!     write(6,*) 'DenMin =',denmin,ixmn,iymn,izmn
!     write(6,*) 'Average, Stand_dev, Rapden =',avden,stden,rapden
!     write(6,110) denmax, denmin,  stden,   rapden

  110 format ('Denmax, Denmin, St_dev, Rapden =',4f10.2)
      return
      end
!-----------------------------------------------------------------------
      subroutine Find_Peak_Dist(kprint, ier)
      USE General
      USE Symmetry     
      USE Riflessi
      USE Atomi
      USE Mappa
      USE PhaseModule     
      USE Param     
      USE Molcom
!
      dimension x1(3),rrv(3)
      dimension xs1(3),xs(3)
      dimension xx1(3,192),xxeq(3,192)
      dimension xxx(3,500),dista(500),jj(500)
!

!     call calc_dist_pubb(ier)
!     if (ier < 0) then
!         write (6,*) 'ier = ',ier
!         stop 9999
!     endif

      if (kprint > 0) then
          call maxmin_dedi(np(1),np(2),np(3),xmap)
      endif

      iflagPKS = -1
      mode = 1
      aperc(mode) = 30   !20     ! massimo 500 picchi 
      call pksrch_New(mode, iflagPKS, nrefl, ier)


      if (ier < 0 .or. kprint == 0) then
          return
      endif


      do i = 1, nats
         do ii=1,3
            xyzs(ii,i) = side(xyzs(ii,i))
            x1(ii) = xyzs(ii,i)
         enddo
         call MoltMatVec(rm, x1, rrv)
         xxx(1:3,i) = rrv(1:3)
         nz(i) = 1
      end do

      if (ifTime == 0) then
          call to_coord_sir(1,numbLSQ)

          xx1(1:3,1) = xyzs(1:3,1)

          xs1(1)=xx1(1,1)
          xs1(2)=xx1(2,1)
          xs1(3)=xx1(3,1)

          call Dist_Peak_EQ(xs1)
      endif

      return
      end
!-----------------------------------------------------------------------
      subroutine Dist_Peak_EQ(xs1)
      USE General
      USE Symmetry     
      USE Riflessi
      USE Atomi
      USE Mappa
      USE PhaseModule     
      USE Param     
!
      dimension x1(3),s(3)
      dimension xs1(3),xs(3)
      dimension xx1(3,192)
      dimension dista(500),jj(500)
!


      write(6,*) 'PICCO',xs1
      do ii=1,3
         xs1(ii) = side(xs1(ii))
      enddo

      jeq = 0
      do kk1=1,ncentr
         do kk2=1,icent+1
            coef = 1.0
            if(kk2==2) coef = -1.0
            do kk3=1,nsym
               jeq = jeq + 1
               call xequi(xs1,kk3,coef,xs,kk1)
               do ii=1,3
                  xx1(ii,jeq) = side(xs(ii))
               enddo
            enddo
         enddo
      enddo

      do j1=1,jeq   !1  !jeq
         do ii=1,3
             x1(ii) = xx1(ii,j1) 
         enddo
         do j2=2,nats
            do ii=1,3
                xs(ii) = side(xyzs(ii,j2)) 
            enddo
            dist = 0
            call xdist(x1,xs,dist,s)
            if (j1 == 1) then
                dista(j2) = dist
                jj(j2) = j1
            else
                if (dist < dista(j2)) then
                    dista(j2) = dist
                    jj(j2) = j1
                endif
            endif
         enddo
      enddo

      j1 = 1     
      write(6,11) j1,xyzs(1:5,j1)
      do j2=2,nats
          write(6,11) j2,xyzs(1:5,j2),dista(j2),jj(j2)
      enddo

      return

 11   format (i6,1h),3f10.4,f15.4,2f10.4,i6)

      end
!-----------------------------------------------------------------------
      subroutine calc_dist_pubb(ier)
      USE General
      USE Symmetry
      USE Atomi
      USE PhaseModule
      USE Molcom
!
      character patom*256
      character aa,line*80,dire*80
      dimension xpub(3,500)
      dimension vet(40),ivet(40)
      dimension x1(3),rrv(3)
c           
      call spy(patom)
!
! --- legge il file .fra
!
      open(unit=kform,file=patom,status='old',err=8000)
      kpatom=1
      natspub=0
1     read(kform,'(a)',end=2) line
          iasc = ichar(line(1:1))
          if (iasc .eq. 26) then
             goto 2
          end if
          aa = line(1:1)
          if (aa == '!' .or. aa == '>') then
             goto 1
          end if
          natspub=natspub+1
          call cutst(line,lenp,dire,lend)
          aLabOld(natspub) = dire(1:lend)
          iopt=0
          call getnum(line,vet,ivet,iv,iopt)
          do 44 i=1,3
             xpub(i,natspub)=vet(i)
   44     continue
          goto 1
2     continue
      close(kform)
c
      a = cell(1)
      b = cell(2)
      c = cell(3)
      alfa = cell(4)
      beta = cell(5)
      gam  = cell(6)
      call Orto_new(a,b,c,alfa,beta,gam)
      do i = 1, natspub
         x1(1:3)=xpub(1:3,i)
         call MoltMatVec(rm, x1, rrv)
         xyzSk(1:3,i) = rrv(1:3)
      end do
c
      ciclo: do j2=2,natspub

          dist = 0
          do i=1,3
             dist = dist + (xyzSk(i,1)-xyzSk(i,j2))**2
           end do
           dist = sqrt(dist)
*          write(55,10) aLabOld(j2),j2,dist

      end do ciclo

  10  format ('Fe - ',a8,i5,f10.5)
c
!      call cstop ('9999')

 8000 ier = -1
      return 
      end
!---------------------------------------------------------------------
      subroutine Modifica_Mappa_NEW(iciclo, ier)
      USE General
      USE Symmetry     
      USE Riflessi
      USE Atomi
      USE Mappa
      USE PhaseModule     
      USE Param     

!
!-- modifica solo in caso di atomi pesanti 
!
      if (no(nk) < 20) return
!
      call maxmin_dedi(np(1),np(2),np(3),xmap)

      rapden = denmax / stden

      rappo = 1 
      rappo1 = 1
      if (no(nk) == 20) then
          rappo = 50
          rappo1 = 30
      elseif (no(nk) > 20 .and. no(nk) < 40) then
          rappo = 100
          rappo1 = 60
      elseif (no(nk) >= 40 ) then!ultima
!         rappo = 200
!         rappo1 = 60
          rappo = no(nk)*2.5
          rappo1 = no(nk)
      else
          rappo = 150!liberato2009
          rappo1 = 90
      endif
      xlimit =  stden * 1.3 * rappo
      xlimit1 =  stden * 1.3 * rappo1
      xlimitlow =  40.0 * stden
c     xlimitlow =  0.99 * xlimit1

c     call InitMolplo

      kprint = 0   !0
      call Find_Peak_Dist(kprint, ier)
      if (ier < 0) return

      nonmodifica=0
      if (denmax < xlimit) then
c         write(6,*)'NON APPLICO MODIFICA - denmax,xlimit',denmax,xlimit
          if (denmax > xlimit1) then
             nonmodifica=1
             if (ifOUT == 1 .and. knw > 0) then
                 write(6,*)'APPLICO MODIFICA P- denmax,xlimit1', ! dedi
     *                      denmax,xlimit1
             endif
          else
             if (denmax < xlimitlow .and.no(nk)>20) then
                nonmodifica=2
             else
                return
             endif
c            return
          endif
      else
          if (ifOUT == 1 .and. knw > 0) then
              write(6,*)'APPLICO MODIFICA - denmax,xlimit',denmax,xlimit
          endif
      endif


      npeaks = 1
      rapwt = float(no(nk)) / float(no(nk-1))
      if (rapwt > 1.2) then
         npeaks =  nint(float(nw(nk)) / totop)
      else
         npeaks = 0
         do i = nk,1,-1
            if (no(i) >= 20) then
                npeaks =  npeaks + nint(float(nw(i)) / totop)
            endif
         enddo
      endif
      if (npeaks > 2) then
         if (mod(npeaks,2) == 0) then
             npks = npeaks / 2
         else
             npks = (npeaks / 2) + 1
         endif
      else
         npks = npeaks
      endif
      npeaks = max(1,npks)

        if(jsys == 1) then
          jfin = npks
        else
          jfin = 1
        endif

        rap_int = 0.5
        coef = 1.1
        do jj = 1,jfin
         if (iciclo < 0) then
            rap_int =  xyzs(4,2) / xyzs(4,1)
c           rap_int =  (1.3*xyzs(4,2)) / xyzs(4,1)
         else
             if (jfin > 1) then
                 coef = coef - 0.05
                 coef = max(coef,0.75)
                 xlimit = xyzs(4,2) * coef
                 rap_int = xlimit / xyzs(4,jj)
             else
c                rap_int = max(rap_int,0.85)  !1.0 / rapwt  !0.85
                 rap_int = max(rap_int,0.8)
                 if(LowRes==1) rap_int = max(rap_int,0.85)
             endif
             if (rap_int > 1.1) then
                 rap_int = rap_int * 0.9
                 rap_int = max(rap_int,1.0)  
             elseif (rap_int < 0.75) then
                 rap_int = 0.75
             endif
         endif
         if(nonmodifica==1) rap_int=0.99
         if(nonmodifica==2) rap_int=1.1
         if((FinalFom>0.8).and.(nonmodifica==1)) rap_int= 0.95!liberato2009
c
         x1 = xyzs(1,jj)
         y1 = xyzs(2,jj)
         z1 = xyzs(3,jj)
         h1 = xyzs(4,jj)
         call RiduciPeakRipples(x1,y1,z1,h1,rap_int)  ! mia, vale ad ogni risoluzione
      enddo
c     write(6,*)  ' Mappa Modificata - COEF, Rap_Int, rapden, rappo',
c    *                                 coef, rap_int, rapden, rappo

c     kprint = 0
c     call Find_Peak_Dist(kprint, ier)
c
      return
      end
!----------------------------------------------------------------------
      subroutine RiduciPiccoPivot()
      USE General
      USE Symmetry     
      USE Riflessi
      USE Atomi
      USE Mappa
      USE PhaseModule     
      USE Param     

!
!-- modifica nel caso di atomi leggeri
!
      aperc(1)=20
      call pksrch_big_RocPat(1,ier) 
      do i=1,20
        write(6,*) 'prima',i,xyzs(1:4,i)
      enddo

      npeaks = 1
      rap_teoric = float(no(nk-1)) / float(no(nk))
c     rap_teoric = 1.0
      rap_sperim = xyzs(4,2) / xyzs(4,1)
      rap_int = rap_sperim/rap_teoric 
      write(6,*) 'rapporto',rap_teoric,rap_sperim,rap_int

      x1 = xyzs(1,1)
      y1 = xyzs(2,1)
      z1 = xyzs(3,1)
      h1 = xyzs(4,1)
      call RiduciPeakRipples(x1,y1,z1,h1,rap_int)  

      aperc(1)=20
      call pksrch_big_RocPat(1,ier) 
      do i=1,20
        write(6,*) 'dopo',i,xyzs(1:4,i)
      enddo
c
      return
      end
!-----------------------------------------------------------------------
      subroutine RiduciPeakRipples(x1,y1,z1,h1,rap_int)
!
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE PhaseModule
      USE Param
      dimension xs(3),xs1(3)
      dimension xs2(3),xs3(3),xss(3)
      integer sidepp

*gl*  if(knw>0) write(6,*) 'Rap_Int_NEW',rap_int
!
      atermNorm=h1
c     write(6,*) 'intensities',atermNorm,stden
      alim=5
c
c  - Modifico la mappa abbattendo i ripples del picco pivot 
c

      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)
      ca=cos(cell(4)*dtor)
      cb=cos(cell(5)*dtor)
      cg=cos(cell(6)*dtor)
c
      xs1(1)=x1
      xs1(2)=y1
      xs1(3)=z1

      do kk1=1,ncentr
         do kk2=1,icent+1
            coef=1.0
            if(kk2==2) coef=-1.0
            do kk3=1,nsym
               call xequi(xs1,kk3,coef,xs,kk1)
               do ii=1,3
                  xs(ii)=side(xs(ii))
               enddo
               iszu=nint(xs(3)*np(3)+alim*deltz)
               iszl=nint(xs(3)*np(3)-alim*deltz)
               isyu=nint(xs(2)*np(2)+alim*delty)
               isyl=nint(xs(2)*np(2)-alim*delty)
               isxu=nint(xs(1)*np(1)+alim*deltx)
               isxl=nint(xs(1)*np(1)-alim*deltx)
c
               do iz = iszl, iszu
                 do iy = isyl, isyu
                   do ix = isxl, isxu
                     a1=ix/deltx-xs(1)*cell(1)
                     a2=iy/delty-xs(2)*cell(2)
                     a3=iz/deltz-xs(3)*cell(3)
                     ray2=a1**2 + a2**2 + a3**2 +
     &                    2.*a1*a2*cg + 2.*a1*a3*cb + 2.*a2*a3*ca
                     ray=sqrt(ray2)
                     if(ray>alim) cycle
                     ih = sidepp(ix,np(1))
                     ik = sidepp(iy,np(2))
                     il = sidepp(iz,np(3))
                     xx = xmap(ih,ik,il)
                     if(xx<0.0) cycle
                     backg=atermNorm*g_s_Patt(ray)
                     if(backg<stden) cycle
                     if((FinalFom<0.8).and.(backg<stden)) cycle!ultima2009
                     if (ray < 1.000000001) then
                       xx = xx * rap_int
                     else
                       xx = xx * 0.9
                     endif
                     xmap(ih,ik,il) = xx
                   enddo
                 enddo
               enddo
c
          enddo
        enddo
      enddo  ! fine loop sulla centratura
c
      return
      end
!-----------------------------------------------------------------------
      subroutine RiduciPeakRipplesPat(x1,y1,z1,h1,itogli)
!
      USE General
      USE Symmetry
      USE Atomi
      USE Mappa
      USE PhaseModule
      USE Param
      dimension xs(3),xs1(3)
      dimension xs2(3),xs3(3),xss(3)
      integer sidepp
!
      atermNorm=h1
c
      alim=10
c     if(jsys==1)  alim=3
c     alim=5
c
      nnp=min(np(1),np(2),np(3))
      nnp=nnp/2.
      if(alim>nnp) then
        alim=nnp
        if (kverbo > 0 ) then
          write(6,*) 'limite raggiunto',nnp,alim
        endif
      endif

c
c  - Modifico la mappa abbattendo i ripples del picco pivot 
c

      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)
      ca=cos(cell(4)*dtor)
      cb=cos(cell(5)*dtor)
      cg=cos(cell(6)*dtor)
c
      xs1(1)=x1
      xs1(2)=y1
      xs1(3)=z1

      do kk1=1,ncentr
         do kk2=1,icent+1
            coef=1.0
            if(kk2==2) coef=-1.0
            do kk3=1,nsym
               call xequi(xs1,kk3,coef,xs,kk1)
               do ii=1,3
                  xs(ii)=side(xs(ii))
               enddo
               iszu=nint(xs(3)*np(3)+alim*deltz)
               iszl=nint(xs(3)*np(3)-alim*deltz)
               isyu=nint(xs(2)*np(2)+alim*delty)
               isyl=nint(xs(2)*np(2)-alim*delty)
               isxu=nint(xs(1)*np(1)+alim*deltx)
               isxl=nint(xs(1)*np(1)-alim*deltx)
c
               do iz = iszl, iszu
                 do iy = isyl, isyu
                   do ix = isxl, isxu
                     a1=ix/deltx-xs(1)*cell(1)
                     a2=iy/delty-xs(2)*cell(2)
                     a3=iz/deltz-xs(3)*cell(3)
                     ray2=a1**2 + a2**2 + a3**2 +
     &                    2.*a1*a2*cg + 2.*a1*a3*cb + 2.*a2*a3*ca
                     ray=sqrt(ray2)
                     if(ray>alim) cycle
                     ih = sidepp(ix,np(1))
                     ik = sidepp(iy,np(2))
                     il = sidepp(iz,np(3))
                     xx = xmap(ih,ik,il)
                     if(xx<=0.0) cycle 
                     if (ray < 1.01.and.itogli==0) cycle
                     backg=atermNorm*g_s_Patt(ray)
                     if(backg>0.0) xx=xx*0.8
                     xmap(ih,ik,il) = xx
c                    xmap(ih,ik,il) = backg
                   enddo
                 enddo
               enddo
c
          enddo
        enddo
      enddo  ! fine loop sulla centratura
c
      return
      end
!-----------------------------------------------------------------------
      subroutine dist_Patt_new(npk,x2,y2,z2,nct,z1z2)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule     
!
      common /dista_pat/ natcoo, xcoo(3,2500)
      character line*80,dire*80
      character a
      character(len=16) tipo(20)
      character patom*256
      integer zizj
      dimension d(8),s(8,3)
      dimension vet(40),ivet(40),nz1z2(10)
      dimension xn(3),xo(3),xeq1(3),xeq2(3)
c      
      write(lo,*) 'PICCO PATTERSON',x2,y2,z2
!
! --- legge il file .fra
!
      if (npk == 1) then

!         patom = 'runt_A_br1.fra'
          patom = 'runt_Bbr1A.fra'
!         patom = 'deoxy_pdb.fra'
          kpatom=0
          open(unit=kform,file=patom,status='old',err=8000)
!
          kpatom=1
          natcoo=0
1         read(kform,'(a)',end=2) line
              iasc = ichar(line(1:1))
              if (iasc .eq. 26) then
                 goto 2
              end if
              a = line(1:1)
              if (a == '!' .or. a == '>') then
                 goto 1
              end if
              natcoo=natcoo+1
              call cutst(line,lenp,dire,lend)
              aLabOld(natcoo) = dire(1:lend)
              iopt=0
              call getnum(line,vet,ivet,iv,iopt)
              do i=1,3
                 xcoo(i,natcoo)=side(vet(i))
              enddo
              goto 1
2         continue
          close(kform)

      endif

      tipo(1) = 'c               '
      tipo(2) = 'n               '
      tipo(3) = 'o               '
      tipo(4) = 'br              '
!     tipo(4) = 's               '
!     tipo(5) = 'fe              '
!
      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1
      dddmin = 0.0075 ! * 2  ! per deoxy
!
! --- calcola le distanze minime
!
      nct = 0
      z1z2 = 0.0
      nz1z2(:) = 0
      do i=1,natcoo
         if (aLabOld(i) == tipo(1)) then
             zi = 6
         elseif (aLabOld(i) == tipo(2)) then
             zi = 7
         elseif (aLabOld(i) == tipo(3)) then
             zi = 8
         elseif (aLabOld(i) == tipo(4)) then
             zi = 35        !br
!            zi = 16
!        elseif (aLabOld(i) == tipo(5)) then
!            zi = 26
         endif
         do k=1,3
            xo(k) = xcoo(k,i)
         enddo
         do ki=1,ncentr
            do ifi=1,ifin
               coef=vet(ifi)
               do li=1,nsym
                  call xequi(xo,li,coef,xeq1,ki)

                  do j=i,natcoo
                     if (aLabOld(j) == tipo(1)) then
                         zj = 6
                     elseif (aLabOld(j) == tipo(2)) then
                         zj = 7
                     elseif (aLabOld(j) == tipo(3)) then
                         zj = 8
                     elseif (aLabOld(j) == tipo(4)) then
                         zj = 35        !br
!                        zj = 16
!                    elseif (aLabOld(i) == tipo(5)) then
!                        zj = 26
                     endif
                     do k=1,3
                        xn(k) = xcoo(k,j)
                     enddo
                     do kj=1,ncentr
                        do ifj=1,ifin
                           coef=vet(ifj)
                           do lj=1,nsym
                              call xequi(xn,lj,coef,xeq2,kj)
                              do k=1,3
                                 xeq1(k) = side(xeq1(k))
                                 xeq2(k) = side(xeq2(k))
                              enddo
                              call xdistPatt(xeq1,xeq2,d,s)
                              
                              do ii = 1,8
                                  dsx = abs(s(ii,1) - x2)
                                  dsy = abs(s(ii,2) - y2)
                                  dsz = abs(s(ii,3) - z2)

                              if (dsx < dddmin .and.
     *                            dsy < dddmin .and.
     *                            dsz < dddmin) then 
                                  write(lo,310) i,aLabOld(i),xeq1,
     *                                          j,aLabOld(j),xeq2,
     *                                          s(ii,1:3),d(ii),ii

                                  nct = nct + 1
                                  zizj = zi * zj
                                  if (zizj == 1225) then ! br * br
                                      write(lo,*) 'Picco Br * Br',npk 
                                  endif
!                                 if (zizj == 676) then ! fe * fe
!                                     write(lo,*) 'Picco Fe * Fe',npk 
!                                 endif
                                  z1z2 = z1z2 + zizj
                              endif

                              enddo
                           enddo
                        enddo
                     enddo
                  enddo     ! su j

               enddo
            enddo
         enddo
      enddo   ! su i

  310 format(2(i6,2x,a2,3f9.3,2x),4f9.3,i5)
!
 8000 call toflush()
!
      return
      end
c----------------------------------------------------------------------
      subroutine xdistPatt(xb2,xeq,d,s)
      USE Symmetry
c--
c-- subroutine used to compute the distance between 2 atoms
c--
      dimension xeq(3),xb2(3),delta(8,3),dp(3),ds(3)
      dimension d(8),s(8,3)
c
      do 20 i=1,3
         dd=xeq(i)-xb2(i)
         dp(i)=dd-int(dd)
         if (dp(i).le.0.001) then
             ds(i)=dp(i)+1.0
         else
             ds(i)=dp(i)-1.0
         endif
   20 continue
      delta(1,1)=dp(1)
      delta(1,2)=dp(2)
      delta(1,3)=dp(3)
      delta(2,1)=dp(1)
      delta(2,2)=dp(2)
      delta(2,3)=ds(3)
      delta(3,1)=dp(1)
      delta(3,2)=ds(2)
      delta(3,3)=dp(3)
      delta(4,1)=dp(1)
      delta(4,2)=ds(2)
      delta(4,3)=ds(3)
      delta(5,1)=ds(1)
      delta(5,2)=dp(2)
      delta(5,3)=dp(3)
      delta(6,1)=ds(1)
      delta(6,2)=dp(2)
      delta(6,3)=ds(3)
      delta(7,1)=ds(1)
      delta(7,2)=ds(2)
      delta(7,3)=dp(3)
      delta(8,1)=ds(1)
      delta(8,2)=ds(2)
      delta(8,3)=ds(3)
      do i=1,8
         d2=delta(i,1)*delta(i,1)*aaa(1)
     &     +delta(i,2)*delta(i,2)*aaa(2)
     &     +delta(i,3)*delta(i,3)*aaa(3)
     &     +delta(i,1)*delta(i,2)*aaa(4)
     &     +delta(i,1)*delta(i,3)*aaa(5)
     &     +delta(i,2)*delta(i,3)*aaa(6)
         d(i)=sqrt(d2)
         do j=1,3
            s(i,j)=abs(delta(i,j))
         enddo
      enddo
c
      return
      end
c---------------------------------------------
      subroutine ClearSMF(x1,y1,z1,ksezold)
c
      USE Mappa
      USE MappaPatterson
      USE PhaseModule
      USE Symmetry
      USE General
      USE Molcom
      integer sidepp
      dimension xs(3),pik(3,800)
!
!--definisco il numero di equivalenti presenti nella SMF caso per caso
!
!--cerco l'eventuale componente translazionale sull'asse 6,4,3
!
      if(ifRhombAx==1) return 
!
!--genero gli equivalenti nella SMF del picco PIVOT
!
      pik(:,:)=0.0
      npik=0
      do k=1,nsymTotRoc
        call oper(k,xs,x1,y1,z1)
        do k1=1,nOrigRoxiRoc
           npik=npik+1
           do j=1,3
             termm=xs(j)+taboRoc(k1,j)
             pik(j,npik)=side(termm)
             if(j==ksezold) pik(j,npik)=0.0
           enddo
           if (npik == 800) exit
        enddo
        if (npik == 800) exit
      enddo
      if(kverbo>0) then
         do l=1,npik
           write(6,*) 'pik ',l,pik(1:3,l)
         enddo
      endif
!
!--azzero la maschera
!
      xmapApp(:,:,:)=0.0
!
!--preservo il picco PIVOT con i suoi equivalenti per la simmetria
!  di gruppo spaziale
!
      call SetMask(x1,y1,z1,-1.0)
c--deb
c       io1=sidepp(nint(x1*np(1)),np(1))
c       io2=sidepp(nint(y1*np(2)),np(2))
c       io3=sidepp(nint(z1*np(3)),np(3))
c       write(6,'(a,3i4,3f8.3,f15.2)') 'eccolo',
c    &            io1,io2,io3,x1,y1,z1,xmap(io1,io2,io3)
c--deb
!
!--cancello i picchi equivalenti al PIVOT per simmetria di seminvarianza
!
      ndrop=2
      flag=0.0
      do i=2,npik
c     do i=1,npik
        x2=pik(1,i)
        y2=pik(2,i)
        z2=pik(3,i)
c       if(ksezold==0) then
c         if(i==1) cycle
          call SetMask(x2,y2,z2,0.0)
c       else
!--cancello tutte le colonne corrispondenti nel caso unidimensionale
c         io1=sidepp(nint(x2*np(1)),np(1))
c         io2=sidepp(nint(y2*np(2)),np(2))
c         io3=sidepp(nint(z2*np(3)),np(3))
c         if(ksezold==1) then
c           do iz=io3-ndrop,io3+ndrop
c           do iy=io2-ndrop,io2+ntrop
c           do ix=0,np(1)-1
c             ih=sidepp(ix,np(1))
c             ik=sidepp(iy,np(2))
c             il=sidepp(iz,np(3))
c             xx=xmap(ih,ik,il)
c             if(xmapApp(ih,ik,il)>-0.5) then
c               if(xx>0.0) then
c                  xmap(ih,ik,il) = xx*flag
c               endif
c             endif
c           enddo
c           enddo
c           enddo
c         elseif(ksezold==2) then
c           do iz=io3-ndrop,io3+ndrop
c           do iy=0,np(2)-1
c           do ix=io1-ndrop,io1+ntrop
c             ih=sidepp(ix,np(1))
c             ik=sidepp(iy,np(2))
c             il=sidepp(iz,np(3))
c             xx=xmap(ih,ik,il)
c             if(xmapApp(ih,ik,il)>-0.5) then
c               if(xx>0.0) then
c                  write(6,'(a,3i4,3f8.3,f15.2)') 'qui',ih,ik,il,
c    &            ih/float(np(1)),ik/float(np(2)),il/float(np(3)),
c    &            xmap(ih,ik,il)
c                  xmap(ih,ik,il) = xx*flag
c               endif
c             endif
c           enddo
c           enddo
c           enddo
c         elseif(ksezold==3) then
c           do iz=0,np(3)-1
c           do iy=io2-ndrop,io2+ntrop
c           do ix=io1-ndrop,io1+ntrop
c             ih=sidepp(ix,np(1))
c             ik=sidepp(iy,np(2))
c             il=sidepp(iz,np(3))
c             xx=xmap(ih,ik,il)
c             if(xmapApp(ih,ik,il)>-0.5) then
c               if(xx>0.0) then
c                  xmap(ih,ik,il) = xx*flag
c               endif
c             endif
c           enddo
c           enddo
c           enddo
c         endif
c       endif
      enddo
c
      return
      end
!--------------------------------------------------------
      subroutine ImproveSmap(x1,y1,z1,ksezold)
c
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE PhaseModule
      USE Symmetry
      USE General
      USE Molcom
      dimension xs(3),xs1(3),s(3),xs3(3),xr(3)
      dimension  xsdum(3),xs3dum(3),xnew(3)
      integer sidepp
c
c--definisco il picco pivot
c
      xs1(1)=x1
      xs1(2)=y1
      xs1(3)=z1
c
c--cerco i picchi (esclusi gli equivalenti di simmetria)
c
      eps=0.01
      aperc(1)=100
      call pksrch_big_RocPat(0,ier)
c
c--seleziono il secondo picco piu' alto
c
      fommax=-9999999999.
      jBest=0
      do_1: do j=1,nats
        xs(1:3)=xyzs(1:3,j)
        h1=xyzs(4,j)
c
c--elimino il picco se e' troppo vicino all'origine (0,0,0) nel triclino
c
        if(jsys == 1) then
          xs3 = 0.0
          call xdist(xs,xs3,dist,s)
          if (dist < 0.5) cycle do_1
        endif
c
c--elimino il picco se e' troppo vicino a quello PIVOT
c    (o ai suoi equivalenti)
c
        distmin=9999.
        do kk1=1,ncentr
        do kk2=1,icent+1
        coef=1.0
        if(kk2==2) coef=-1.0
        do kk3=1,nsym
           call xequi(xs1,kk3,coef,xs3,kk1)
           call xdist(xs,xs3,dist,s)
           if(dist<distmin) distmin=dist
c... o se e' sulla stessa colonna del picco PIVOT
           do jdum=1,3
             if(jdum==ksezold) cycle
             xsdum(1:3)=0.0
             xs3dum(1:3)=0.0
             xsdum(jdum)=xs(jdum)
             xs3dum(jdum)=xs3(jdum)
             call xdist(xsdum,xs3dum,dist,s)
             if(dist<0.01) cycle do_1
           enddo
        enddo
        enddo
        enddo
        if(distmin<3.0) cycle do_1 ! occhio
c
c--calcolo la figura di merito per questo picco
c
        call FomPivot(xs,ksezold,xfom)
c       call FomPivot1(xs,xs1,ksezold,yfom)
c       write(6,*) 'qui   ',j,xfom,yfom,fommax
c       write(6,*) 'qui   ',j,xfom,fommax,distmin
c       xfom=xfom*yfom
c
        if(xfom>fommax) then 
          fommax=xfom
          x1=xs(1)
          y1=xs(2)
          z1=xs(3)
          jBest=j
        endif
      enddo do_1
c
      if(jBest==0) then
         write(6,*) 'Second peak not found'
         return
      endif
c
      if(kverbo>0) then
        write(6,'(a,3f8.3,i8,f20.1)')
     &     'Fourier peak 2',x1,y1,z1,jBest,fommax
      endif
c
c--calcolo la nuova AMS con la doppia sovrapposizione
c
      xs(1)=x1
      xs(2)=y1
      xs(3)=z1
c     area=0.0
      do il = 0, np(3)-1
        xr(3)=il/float(np(3))
        do ik = 0, np(2)-1
          xr(2)=ik/float(np(2))
          do ih = 0, np(1)-1
            xr(1)=ih/float(np(1))
            xxmin=9999999.
c           xav=0.0
            do kk3=1,nsym
              call xequi(xs,kk3,1.0,xnew,1)
              ih1=sidepp(nint((xr(1)-xnew(1))*np(1)),np(1))
              ik1=sidepp(nint((xr(2)-xnew(2))*np(2)),np(2))
              il1=sidepp(nint((xr(3)-xnew(3))*np(3)),np(3))
              xx=Patt(ih1,ik1,il1)
c             xx=spreadpeak_asse2(Patt,ih1,ik1,il1,0)
c             xav=xav+xx
              if(xx<xxmin) xxmin=xx 
            enddo
c           xav=xav/float(nsym)
c           xmapApp(ih,ik,il)=xav
            xmapApp(ih,ik,il)=xxmin
c           if(xxmin>0.0) area=area+xxmin
          enddo
        enddo
      enddo
c     denom=np(1)*np(2)*np(3)
c     write(6,*) 'area',area/denom
c
c--calcola la mappa min(P0 spostata * F0) = min(xmapApp * SMFtrue)
c
c     area=0.0
      do il = 0, np(3)-1
        do ik = 0, np(2)-1
          do ih = 0, np(1)-1
             xx1=xmap(ih,ik,il)
             xx2=xmapApp(ih,ik,il)
c            if(xx1>0) area=area+xx1
c            xmap(ih,ik,il)=min( xx1, xx2 ) 
             xmap(ih,ik,il)=( xx1 + xx2 )*0.5 
c            if(xmap(ih,ik,il)<0.0) xmap(ih,ik,il)=0.0
          enddo
        enddo
      enddo
c     write(6,*) 'area mappa s',area/denom
c
      return
      end 
!--------------------------------------------------------
      subroutine ImproveSmapLast(x0,y0,z0,ksezold)
c
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE PhaseModule
      USE Symmetry
      USE General
      USE Molcom
      dimension xs(3),xs1(3),s(3),xs3(3),xr(3)
      dimension  xsdum(3),xs3dum(3),xnew(3)
      integer sidepp
c
      zero=0.001
      zeroz=0.0001
c
c--definisco il picco pivot
c
      xs1(1)=x0
      xs1(2)=y0
      xs1(3)=z0
c
c--cerco i picchi (esclusi gli equivalenti di simmetria)
c
      eps=0.01
      aperc(1)=100
      call pksrch_big_RocPat(0,ier)
c
c--seleziono il secondo picco piu' alto
c
      fommax=-9999999999.
      jBest=0
      do_1: do j=1,nats
        xs(1:3)=xyzs(1:3,j)
        h1=xyzs(4,j)
c
c--elimino il picco se e' troppo vicino all'origine (0,0,0) nel triclino
c
        if(jsys == 1) then
          xs3 = 0.0
          call xdist(xs,xs3,dist,s)
          if (dist < 0.5) cycle do_1
        endif
c
c--elimino il picco se e' troppo vicino a quello PIVOT
c    (o ai suoi equivalenti)
c
        distmin=9999.
        do kk1=1,ncentr
        do kk2=1,icent+1
        coef=1.0
        if(kk2==2) coef=-1.0
        do kk3=1,nsym
           call xequi(xs1,kk3,coef,xs3,kk1)
           call xdist(xs,xs3,dist,s)
           if(dist<distmin) distmin=dist
c... o se e' sulla stessa colonna del picco PIVOT
           do jdum=1,3
             if(jdum==ksezold) cycle
             xsdum(1:3)=0.0
             xs3dum(1:3)=0.0
             xsdum(jdum)=xs(jdum)
             xs3dum(jdum)=xs3(jdum)
             call xdist(xsdum,xs3dum,dist,s)
             if(dist<0.01) cycle do_1
           enddo
        enddo
        enddo
        enddo
        if(distmin<3.0) cycle do_1 ! occhio
c
c--elimino picchi in posizioni particolari
c
          if(jsys>1) then
            iel=0
            do jj=1,3
              if(jj==ksezold) cycle
!--elimino sempre i picchi a 0.0
              disA=abs(xyzs(jj,j)-0.0)
              disB=abs(xyzs(jj,j)-1.0)
              if(disA<zero.or.disB<zero) iel=1
              if(ifTrigonal/=1) then
!--elimino i picchi a 0.5 (tranne che per il trigonale)
                disC=abs(xyzs(jj,j)-1./2.)
                if(disC<zero) iel=1
              endif
              if(jsys==4) then
!--elimino i picchi a 0.25 e 0.75
                disC=abs(xyzs(jj,j)-1./4.)
                if(disC<zeroz) iel=1
                disD=abs(xyzs(jj,j)-3./4.)
                if(disC<zeroz.or.disD<zeroz) iel=1
              endif
              if(jsys==5) then
!--elimino i picchi a 0.33 e 0.667
                disC=abs(xyzs(jj,j)-1./3.)
                if(disC<zeroz) iel=1
                disD=abs(xyzs(jj,j)-2./3.)
                if(disC<zeroz.or.disD<zeroz) iel=1
                if(ifTrigonal==0) then
!--elimino i picchi a 0.166 e 0.833 solo per l'esagonale
                  disC=abs(xyzs(jj,j)-1./6.)
                  if(disC<zeroz) iel=1
                  disD=abs(xyzs(jj,j)-5./6.)
                  if(disC<zeroz.or.disD<zeroz) iel=1
                endif
              endif
              if(iel==1) then
                 if(kverbo>0) then
                   write(6,*) 'Special peak eliminated '
                 endif
                 cycle do_1
              endif
            enddo
          endif
c
c--calcolo la figura di merito per questo picco
c
        call FomPivot(xs,ksezold,xfom)
        call FomPivot1(xs,xs1,ksezold,yfom)
c       write(6,*) 'qui   ',j,xfom,yfom,fommax
c       write(6,*) 'qui   ',j,xfom,fommax
        xfom=xfom*yfom
c       xfom=yfom
c
        if(xfom>fommax) then 
          fommax=xfom
          x1=xs(1)
          y1=xs(2)
          z1=xs(3)
          jBest=j
        endif
      enddo do_1
c
      if(jBest==0) then
         write(6,*) 'Second peak not found'
         return
      endif
c
c     if(kverbo>0) then
        write(6,'(a,3f8.3,i8,f20.1)')
     &     'Fourier peak 2',x1,y1,z1,jBest,fommax
c     endif
c
c--calcolo la nuova AMS con la doppia sovrapposizione
c
      xs(1)=x1
      xs(2)=y1
      xs(3)=z1
      area=0.0
      stdenn=0.0
      do il = 0, np(3)-1
        xr(3)=il/float(np(3))
        do ik = 0, np(2)-1
          xr(2)=ik/float(np(2))
          do ih = 0, np(1)-1
            xr(1)=ih/float(np(1))
            xxmin=9999999.
c           avx=0.0
            do kk3=1,nsym
              call xequi(xs,kk3,1.0,xnew,1)
              ih1=sidepp(nint((xr(1)-xnew(1))*np(1)),np(1))
              ik1=sidepp(nint((xr(2)-xnew(2))*np(2)),np(2))
              il1=sidepp(nint((xr(3)-xnew(3))*np(3)),np(3))
              xx=Patt(ih1,ik1,il1)
c             xx=spreadpeak_asse2(Patt,ih1,ik1,il1,0)
c             call xequi(xs1,kk3,1.0,xnew,1)
c             ih1=sidepp(nint((xr(1)-xnew(1))*np(1)),np(1))
c             ik1=sidepp(nint((xr(2)-xnew(2))*np(2)),np(2))
c             il1=sidepp(nint((xr(3)-xnew(3))*np(3)),np(3))
c             xx2=spreadpeak_asse2(Patt,ih1,ik1,il1,0)
c             xx=max(xx1,xx2)
c             avx=avx+xx
              if(xx<xxmin) xxmin=xx 
            enddo
c           xxmin=avx/float(nsym)
            xmapApp(ih,ik,il)=xxmin
            stdenn=stdenn+xxmin*xxmin
            area=area+xxmin
          enddo
        enddo
      enddo
      denom=np(1)*np(2)*np(3)
      area=area/denom
      stdenn=stdenn/denom-area*area
      if (stdenn.gt.0.0) then
          stdenn=sqrt(stdenn)
      else
          stdenn=0.0
      endif
c     write(6,*) 'stdenn',stdenn
c
c--calcola la mappa min(P0 spostata * F0) = min(xmapApp * SMFtrue)
c
c     area=0.0
      do il = 0, np(3)-1
        do ik = 0, np(2)-1
          do ih = 0, np(1)-1
             xx1=xmap(ih,ik,il)
             xx2=xmapApp(ih,ik,il)
c            if(xx1>0) area=area+xx1
c            xmap(ih,ik,il)=min( xx1, xx2 ) 
c            xmap(ih,ik,il)=( xx1 + xx2 )*0.5 
             if(xx2<stdenn) then
                 xx1=xx1*0.8
             endif
c            if(xx2<2*stdenn) xx1=xx1*0.8
c            if(xx2>stdenn) xx1=xx1*1.2
             xmap(ih,ik,il)=xx1 
c            if(xmap(ih,ik,il)<0.0) xmap(ih,ik,il)=0.0
          enddo
        enddo
      enddo
c     write(6,*) 'area mappa s',area/denom
c
      return
      end 
c-------------------------------------------------------------------
      subroutine ConvergiPivot(i,NsezHarker,Hvet,Tvet,Htype,xfom)
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Riflessi
      USE Seminvariants
      USE PhaseModule
      USE Symmetry
      USE General
      USE Molcom
      dimension Harkerheight(50)
      dimension Hvet(50,3,3),Tvet(50,3)
      integer Htype(50,3)
      dimension xr(3),xv(3),iuvw(3)
      integer sidepp
c
        xfom=0.0
        xr(1:3)=xyzo(1:3,i)
        do j = 1, nats30
          do i1=1,3
            xv(i1)=side(xr(i1)+xyz30(i1,j))
          enddo
          do k=1,NsezHarker
            do i1=1,3
              termm=Hvet(k,1,i1)*xv(1)+Hvet(k,2,i1)*xv(2)+
     &                                  Hvet(k,3,i1)*xv(3)
              termm=termm+Tvet(k,i1)-xyz30(i1,j)
              iuvw(i1)=sidepp(nint(termm*np(i1)),np(i1))
            enddo
c           Harkerheight(k)=Patt(iuvw(1),iuvw(2),iuvw(3))
            Harkerheight(k)=xmapShi(iuvw(1),iuvw(2),iuvw(3))
c           write(6,*) 'uf',k,iuvw,Harkerheight(k)
          enddo
          xx=sum(Harkerheight(1:NsezHarker)) 
          xfom=xfom+xx
c         write(6,*) 'ufi',j,xx,xfom
        enddo
c       write(6,*) 'eccolo',i,xfom
c
      return
      end 
c-----------------------------------------------------------------------
      subroutine ConvergiPivot1(i,ksezold,xfom)
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Riflessi
      USE Seminvariants
      USE PhaseModule
      USE Symmetry
      USE General
      USE Molcom
      dimension xr(3),xs(3),xnew(3),iuvw(3)
      dimension Harkerheight(50)
      integer sidepp
c
      xfom=0.0
      xr(1:3)=xyzo(1:3,i)
      do j = 1, nats15
        if(j==i) cycle
        if(xyzo(4,j)<0.001) cycle
        xxmax=0.0
        do kk1=1,nOrigRoxi
          do kk2=1,2
            coef=1.0
            if(kk2==2) coef=-1.0
            do i1=1,3
              tterm=coef*xyzo(i1,j)+tabo(kk1,i1)
              xs(i1)=side(tterm)
            enddo
            do kk3=1,nsym
              call xequi(xs,kk3,1.0,xnew,1)
              do i1=1,3
                aterm=xr(i1)-xnew(i1)
                iuvw(i1)=sidepp(nint(aterm*np(i1)),np(i1))
              enddo
              Harkerheight(kk3)=
     &        spreadpeak_asse2(xmapShi,iuvw(1),iuvw(2),iuvw(3),ksezold) ! occhio
c    &          spreadpeak_asse2(Patt,iuvw(1),iuvw(2),iuvw(3),ksezold) ! occhio
c              write(6,*) 'uf',i,j,kk3,iuvw,Harkerheight(kk3)
            enddo
            xx=sum(Harkerheight(1:nsym)) 
            if(xx>xxmax) xxmax=xx
          enddo
        enddo
        xfom=xfom+xxmax
      enddo
c     write(6,*) 'ECCOLO',i,xfom
c
      return
      end 
c---------------------------------------------------------------
      subroutine FomPivot1(xs,xs1,ksezold,xfom)
c
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Riflessi
      USE Seminvariants
      USE PhaseModule
      USE Symmetry
      USE General
      USE Molcom
      dimension Harkerheight(50)
      dimension xnew(3),xv(3),iuvw(3)
      integer sidepp
      dimension xs(3),xs1(3),xs2(3)
c
        xfom=0.0
        do kk1=1,nOrigRoxi
          do kk2=1,2
            coef=1.0
            if(kk2==2) coef=-1.0
            do i1=1,3
              tterm=coef*xs1(i1)+tabo(kk1,i1)
              xs2(i1)=side(tterm)
            enddo
            do kk3=1,nsym
              call xequi(xs2,kk3,1.0,xnew,1)
              do i1=1,3
                aterm=xs(i1)-xnew(i1)
                iuvw(i1)=sidepp(nint(aterm*np(i1)),np(i1))
              enddo
c             Harkerheight(kk3)=Patt(iuvw(1),iuvw(2),iuvw(3))
              Harkerheight(kk3)=
     &            spreadpeak_asse2(Patt,iuvw(1),iuvw(2),iuvw(3),ksezold)
            enddo
c           xx=minval(Harkerheight(1:nsym)) 
            xx=sum(Harkerheight(1:nsym)) 
            if(xx>xfom) xfom=xx
          enddo
        enddo
c
      return
      end 
c---------------------------------------------------------------
      subroutine FomPivot(xs,ksezold,xfom)
c
      USE Atomi
      USE Mappa
      USE MappaPatterson
      USE Riflessi
      USE Seminvariants
      USE PhaseModule
      USE Symmetry
      USE General
      USE Molcom
      dimension Harkerheight(50)
      dimension xnew(3),xv(3),iuvw(3)
      integer sidepp
      dimension xs(3)
c
        xfom=0.0
        do j = 1, nats30
          do i1=1,3
            xv(i1)=side(xs(i1)+xyz30(i1,j))
          enddo
          do k=1,nsym
            do i1=1,3
              call xequi(xv,k,1.0,xnew,1)
              termm=xs(i1)-xnew(i1)
              iuvw(i1)=sidepp(nint(termm*np(i1)),np(i1))
            enddo
            Harkerheight(k)=
     &            spreadpeak_asse2(Patt,iuvw(1),iuvw(2),iuvw(3),ksezold)
c           Harkerheight(k)=Patt(iuvw(1),iuvw(2),iuvw(3))
          enddo
          xx=minval(Harkerheight(1:nsym)) 
          xfom=xfom+xx
        enddo
c
      return
      end 
!---------------------------------------------------------------
      subroutine DefineSMFSymmetry(ksezold)
      USE PhaseModule
      USE Symmetry
!
!--definisce la simmetria della SMF. Dipende da quali sezioni di Harker
!  usiamo per costruire la SMF
!
      if(ifRhombAx==1) then
!--in questo caso ho una SMF con colonne diagonali, che non tratto
         nOrigRoxiRoc=0
         nsymTotRoc=0
         taboRoc(:,:)=0.
         return
      endif
!
!--definisco il numero di equivalenti presenti nella SMF caso per caso
!
!--cerco l'eventuale componente translazionale sull'asse 6,4,3
!
        itrasla=0
        do i=1,nsym
          do j=1,3
             if(tmat(i,j)>0.0.and.tmat(i,j)<0.5) itrasla=1
          enddo
        enddo
        nOrigRoxiRoc=nOrigRoxi
        nsymTotRoc=nsymTot ! non includo i centrosimmetrici
        taboRoc(:,:)=tabo(:,:)
        if(ksezold<0) then
!--caso del triclino
        elseif(ksezold>0) then
!--caso unidimensionale
          if(jsys==5) then
!--trigonale senza componente traslazionale
            if(itrasla==0) nsymTotRoc=2*nsymTot  ! includo anche i centrosimmetrici nella SMF
            if(latt==7) then
!--per produrre gli equivalenti nel R3 esagonale
!  (trucco per simulare la simmetria Patterson nella sezione SMF)
!  dato che OriginiRoxi da erroneamente 3 shift di origine permessi
!  nel caso R3 esagonale
              nOrigRoxiRoc=1 
              nsymTotRoc=2*nsymTot
            endif
          endif
        else
!--caso tridimensionale
! eventualmente includo anche i centrosimmetrici nella SMF
          if(itrasla==0.and.icent==0) nsymTotRoc=2*nsymTot 
          if(icent==1 .and. jsys>3) then
!--avendo usato solo lo spazio di Harker, ho degli shift di origine diversi
!  nel caso di strutture centrosimmetriche, in particolare sono quelli del P-1
             nOrigRoxiRoc=8
             taboRoc(1,1:3)=(/0.0,0.0,0.0/)
             taboRoc(2,1:3)=(/0.5,0.0,0.0/)
             taboRoc(3,1:3)=(/0.0,0.5,0.0/)
             taboRoc(4,1:3)=(/0.0,0.0,0.5/)
             taboRoc(5,1:3)=(/0.5,0.5,0.0/)
             taboRoc(6,1:3)=(/0.5,0.0,0.5/)
             taboRoc(7,1:3)=(/0.0,0.5,0.5/)
             taboRoc(8,1:3)=(/0.5,0.5,0.5/)
          endif
        endif
c
       return
       end
c--------------------------------------------------
      subroutine ScaleWeights(nref,wt,g)

      dimension wt(nref),wtsort(nref),g(nref)
      dimension peso(100),sogg(100),iorde(nref)

      eps=0.000001
      ic=0
      do i=1,nref
        if(wt(i).lt.eps) then
          wt(i)=0.0
          g(i)=0.0
        else
          ic=ic+1
          iorde(ic)=i
          wtsort(ic)=g(i)
        endif
      enddo
      nsort=ic
      if(nsort==0) return
      call sortall3(-1,wtsort,1,nsort,iorde)
c
      nstep=20
      rstep2=1.0/nstep
      rstep1=0.1/nstep
c
      nalfa1=-1
      term=1.0/(nstep*3.0)
      perc1=term
      do while(nalfa1<=0)
        nalfa1=nint(perc1*nsort)
        perc1=perc1+term/10.
      enddo
c
      sogg(1)=wtsort(nalfa1)
      peso(1)=1.0
c
      do i=2,nstep
        peso(i)=peso(i-1)-rstep2
        peso(i)=max(peso(i),0.01)
        perc1=perc1 + rstep1*i
        perc1=min(perc1,1.0)
        nalfa1=nint(perc1*nsort)
        sogg(i)=wtsort(nalfa1)
      enddo
c
      sogg(nstep)=wtsort(nsort)
c
      n=1
      do i=1,nsort
         k=iorde(i)
   17   if (wtsort(i).gt.(sogg(n)-eps)) then
            wt(k)=peso(n)
        else
            n=n+1
            if (n.gt.nstep) n=nstep
            goto 17
        endif
      enddo
c
      return
      end
!-----------------------------------------------------------------------
      subroutine SwitchRestorePattersonSpaceGroup(iAction)
      USE General
      USE Symmetry
!
!-- iAction = 1 switch to the Patterson Space Group
!-- iAction = 2 restore the original Space Group
!
      if (iAction == 1) then
          icent = 1
          tmat(:,:) = 0.
          call musym()
          nsymTot = nsym * (icent + 1) * pts
      else
!
!-- restore the original Space Group
!
          call CreaSymmetryInfo(ier)
!
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CmapForPat()
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE PhaseModule
      USE Mappa
      USE MappaPatterson
!
      numberToUse = numbLSQ
!
      nGedm=-99
      if (nGedm < 0) then
          do i = 1,numberToUse
             if (evet(i) < 1.2) then
                 exit
             endif
          enddo
          nGedm =  i -1
      endif
!
!--rinormalizzo gli Ep
!-- Histogram Matching  Ecalc su Eobs  
!
      work1(1:numberToUse) = fcvet(1:numberToUse)
      work2(1:numberToUse) = evet(1:numberToUse)
      nden =  nGedm / 10
      nwizm1= nden
      nsip1 = numberToUse / nden
      nsip1 = min(nsip1,498)
      call HistogramMatch(work1,work2,numberToUse,nsip1,nwizm1,1)
      fcvet(1:numberToUse) = work1(1:numberToUse)
!
!--calcolo i pesi
!
      if(ksize<=3) then
        chope=0.5
        do i=1,numberToUse
           EOss = evet(i)
           ECal = fcvet(i)
           pesMod(i) =  2.0 * EOss * ECal
           SimW = chope * EOss * ECal
           wt(i) =  bes(SimW)
        enddo
      else
        wt(:)=1.0
        call PresigmaA(-2, 0)
        wt(:)=pesMod(:)
      endif
!
!-- switch to the Patterson Space Group
!
      icent=1
      tmat(:,:)=0.
      call musym()
      nsymTot=nsym*(icent+1)*pts
!
!-- faccio la Cmap
!
      jpatt = 1
      iphaz(:) = 0
      do i=1,numberToUse
        fcoef(i)=wt(i)*evet(i)*fcvet(i)
      enddo
      call MakeMap(fcoef, iphaz, numberToUse, jpatt, xmap,
     *                      FORTH,BACK)

c--solo per debug
c     kverboOld=kverbo
c     kverbo=1
c     aperc(1)=500
c     ier=0
c     call pksrch_big_RocPat(1,ier)
c     do j=1,nats
c         write(6,'(a,3f8.3,f15.1)') 'lista picchi Cmap do ',xyzs(1:4,j)
c     enddo
c     kverbo=kverboOld
c--solo per debug
!
!-- restore the original Space Group
!
      call CreaSymmetryInfo(ier)
!
      call RiduciOrigine(0)  
!
c     call snipmap(xmap,1)  ! snipmap su Cmap out5a - out5aa
      call snipmap(xmap,2)  ! snipmap su Cmap out5b
      return
c
c--provo a fare un taglio sulla Patterson generale
c
      if(ksize<=4.and.iwei==0.and.jsys<=3) then
        iold=1
      else
        iold=0
      endif
      if(ksize<=3) iold=0
      if(ksize>=3) then ! da verificare
        invflag = 10
        call maxmin3dPatt(denmin,denmax,avden,stden)
        if(iold==0) then
          sog=avden+1.0*stden
        else
          sog=avden+0.66*stden
        endif
        if (neutro == 1) then
          sog=avden+0.50*stden
        endif
        call changesection3d(sog,nmod,denmin)
c       if (kverbo > 0) then
          denom=np(1)*np(2)*np(3)
          write(6,'(a,4f15.2,f8.3,a)') 'change Cmap first',
     &    denmax,avden,stden,sog,100*((denom-float(nmod))/denom),'%'
c       endif
      endif
!
      invflag = 10
      call maxmin3d(denmin,denmax,avden,stden,npunt,1)
      if(iswitch_3D<0) then
!--procedura taglio di DoSMF_tricl
         sog=avden+1.5*stden
      elseif(iswitch_3D==0) then
!--procedura taglio di DoSMF_1D
        if(lproj==0) then
          sog=avden+1.5*stden
        else
          sog=avden+1.0*stden
        endif
      else
!--procedura taglio di DoSMF_3D
        if (neutro == 0) then
            sog=avden+1.0*stden
        else
            sog=avden+0.5*stden
        endif
      endif
      call changesection3d(sog,nmod,denmin)
c     if (kverbo > 0) then
          denom=np(1)*np(2)*np(3)
          write(6,'(a,4f15.2,f8.3,a)') 'change Cmap ',
     &      denmax,avden,stden,sog,100*((denom-float(nmod))/denom),'%'
c     endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CalcEpForCmap(x1,y1,z1,iflagg,ksezold)
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa 
      USE RemoModule
c     USE PhaseModule, only : numbLSQ

      integer i1(3)
!
!--calcolo attraverso una mappa
        if(iflagg==0) then
          natsInModel(1)=1
          model(1)%considerato(1)=1
          model(1)%atoms(1,1,1)=x1
          model(1)%atoms(2,1,1)=y1
          model(1)%atoms(3,1,1)=z1
          model(1)%atoms(5,1,1)=1
          model(1)%specie(1,1)=nk*nzConst
c         model(1)%th_fact(1,1)=bt
          model(1)%th_fact(1,1)=bfac(1)
        elseif(iflagg<0) then
!--costruisco un modello atomico a due atomi a partire dalla mappa Fourier ultima
          call BuildModelForCmapFirst(x1,y1,z1,iflagg,ksezold)
c         call BuildModelForCmapSecond(x1,y1,z1)
        elseif(iflagg>0) then
!--costruisco un modello atomico a partire dalla mappa Fourier ultima
          call BuildModelForCmap()
        endif
        model(1)%no(1:nk)=no(1:nk)
        model(1)%al(:,:)=al(:,:)
        model(1)%bs(:,:)=bs(:,:)
        model(1)%cl(:)=cl(:)
        call ChemInfo_MR_Final()
c--deb
!       do i=1,natsInModel(1)
!         write(6,*) 'atomi modello',model(1)%atoms(1:3,i,1),
!    &                 model(1)%specie(i,1),iflagg
!       enddo
c--deb
        call NewInv_MR_Final()
!
!--trasforma gli Fp in Ep: fcvet --> fcvetv 
!
      call F2ENew1()
!
      fcvet(1:nrefl)=fcvetv(1:nrefl)
c     fcvet(1:numbLSQ)=fcvetv(1:numbLSQ)
!
      return
      end
!---------------------------------------------
      subroutine BuildModelForCmapSecond(x1,y1,z1)
      USE General
      USE Riflessi
      USE Atomi
      USE PhaseModule, only : aperc, AbortLSQ
      USE Symmetry
      USE Molcom
      USE Mappa
      USE MappaPatterson
      USE RemoModule
      real, allocatable :: wt_serv(:)
      dimension xs(3),xs1(3),s(3),xs3(3)
!
      IF (.NOT. ALLOCATED(wt_serv))
     *    ALLOCATE (wt_serv(1:100),    stat = ierr)
!
      kverboOld=kverbo
!!!   kverbo=1
!
c--cerco i picchi (esclusi gli equivalenti di simmetria)
c
      aperc(1)=50
      call pksrch_big_RocPat(1,ier) 
c
c     do j=1,nats
c         write(6,'(a,3f8.3,f15.1)') 'lista picchi S map',xyzs(1:4,j)
c     enddo
c
c--seleziono il picco piu' alto (nell'intorno del PIVOT)
c
      xs1(1)=x1
      xs1(2)=y1
      xs1(3)=z1
      distmin=9999.
      do_0: do j=1,nats
          xs(1:3)=xyzs(1:3,j)
          do kk1=1,ncentr
          do kk2=1,icent+1
          coef=1.0
          if(kk2==2) coef=-1.0
          do kk3=1,nsym
             call xequi(xs1,kk3,coef,xs3,kk1)
             call xdist(xs,xs3,dist,s)
             if(dist<distmin) then
                distmin=dist
                ipeak=j
             endif
          enddo
          enddo
          enddo
      enddo do_0
      x0=xyzs(1,ipeak)
      y0=xyzs(2,ipeak)
      z0=xyzs(3,ipeak)
      h0=xyzs(4,ipeak)
      xyzs(1:5,ipeak)=xyzs(1:5,1)
      xyzs(1,1)=x0
      xyzs(2,1)=y0
      xyzs(3,1)=z0
      xyzs(4,1)=h0
 
      if(kverbo>0) write(6,'(a,3f8.3,f15.1)') 
     &                        'Fourier peak 1',x0,y0,z0,h0

c
c--seleziono il secondo picco piu' alto
c
      xs1(1:3)=xyzs(1:3,1)
      fompmax=-9999
      fompmin=9999
      wt_serv(:)=0.0
      do_1: do j=2,nats
          xs(1:3)=xyzs(1:3,j)
c
c--elimino il picco se e' troppo vicino all'origine (0,0,0) nel triclino
c
          if (jsys == 1) then
              xs3 = 0.0
              call xdist(xs,xs3,dist,s)
              if (dist < 0.5) cycle do_1
          endif
c
c--elimino il picco se e' troppo vicino a quello PIVOT
c    (o ai suoi equivalenti)
c
          distmin=9999.
          do kk1=1,ncentr
          do kk2=1,icent+1
          coef=1.0
          if(kk2==2) coef=-1.0
          do kk3=1,nsym
             call xequi(xs1,kk3,coef,xs3,kk1)
             call xdist(xs,xs3,dist,s)
             if(dist<distmin) distmin=dist
c            if(lproj/=1.and.abs(xs(1)-xs3(1))<0.001) cycle do_1 
c            if(lproj/=2.and.abs(xs(2)-xs3(2))<0.001) cycle do_1
c            if(lproj/=3.and.abs(xs(3)-xs3(3))<0.001) cycle do_1
             if(lproj/=1.and.abs(s(1))<0.01) cycle do_1 
             if(lproj/=2.and.abs(s(2))<0.01) cycle do_1
             if(lproj/=3.and.abs(s(3))<0.01) cycle do_1
          enddo
          enddo
          enddo
          if(distmin<2.0) cycle do_1 
!
!--calcolo la figura di merito per picco
!
          call FOMPeak(xs1,xs,fomp)
!--seleziono un solo picco
c         if(fomp>fompmax) then
c           distp=distmin
c           fompmax=fomp
c           ipeak=j
c         endif
!--seleziono i migliori picchi
          if(fomp>fompmax) fompmax=fomp
          if(fomp<fompmin) fompmin=fomp
          wt_serv(j)=fomp
      enddo do_1
c     xyzs(1:5,2)=xyzs(1:5,ipeak)
c     if(kverbo>0) write(6,'(a,3f8.3,f15.1,i4,f8.3)')
c    &                        'Fourier peak 2',xyzs(1:4,2),ipeak,distp
      icont=1
      sogth=0.5
      do j=2,nats
        rhovar=(wt_serv(j)-fompmin)/(fompmax-fompmin)
        write(6,*) 'occhio',j,wt_serv(j),rhovar
        if(rhovar>sogth) then
          icont=icont+1  
          xyzSk(1:5,icont)=xyzs(1:5,j)
        endif
      enddo
      nats=icont
      do j=2,nats
          xyzs(1:5,j)=xyzSk(1:5,j)
          if(kverbo>0) write(6,'(a,3f8.3,f15.1,i4,f8.3)')
     &                        'Fourier peaks',xyzs(1:4,j)
      enddo
c     nats=2
      nats=min(nats,numCmap)
      write(6,*) 'sono in BuildModelFromCmapSecond',nats
c
c--faccio i minimi quadrati 
c
      bfac(1:nats)=bt
      lsq=1 ! occhio
      if(lsq==1) then
        do i=1,nats
          xyzs26(1:3,i)=xyzs(1:3,i)
        enddo
        xyzs(4,1:nats)=1.0
        xyzs(5,1:nats)=1.0
        icont=0
        icont1=0
        ikpunt=nk
        do i=1,nats
          icont1=icont1+1
          icont=icont+1
          sog=nint(nw(ikpunt)/(pts*float((icent+1)*nsym)))
          if(icont>sog) then
             icont=0
             ikpunt=ikpunt-1
          endif
          nz(i)=ikpunt
          if(no(nz(i))<20) then
            icont1=icont1-1
            exit
          endif
          if(ikpunt==0) exit
        enddo
        natsold=nats
        nats=icont1
        iref=3 ! affino anche il B
        mode=1
        nlsm=10
        numb=nrefl
        scalan=1
        ifBreak=0
        work1(:)=wt(:)
        call sftryyy(iref,mode,nlsm,numb,scalan,ifBreak)
        wt(:)=work1(:)
        nats=natsold
        if(knw>0.and.kverbo>0) then
           call to_coord_sir(1,numb) !solo per debug
        endif
        if (AbortLSQ == 1) then
            AbortLSQ = 0
            if (knw > 0) write(6,*) 'LSQ annullato'
            do i=1,nats
               xyzs(1:3,i)=xyzs26(1:3,i)
            enddo
        endif
      endif
!--speciazione
      natsInModel(1)=nats
      model(1)%considerato(1)=1
      ikpunt=nk
      icont=0
      do i=1,nats
        model(1)%atoms(1:3,i,1)=xyzs(1:3,i)
        model(1)%atoms(5,i,1)=1
        model(1)%th_fact(i,1)=bfac(i)
        icont=icont+1
        sog=nint(nw(ikpunt)/(pts*float((icent+1)*nsym)))
        if(icont>sog) then
           icont=0
           ikpunt=ikpunt-1
        endif
        model(1)%specie(i,1)=ikpunt*nzConst
        if(ikpunt==0) exit
      enddo
!
      kverbo=kverboOld
      IF (ALLOCATED(wt_serv))
     *        DEALLOCATE (wt_serv, stat = ierr)

!
      return
      end
!---------------------------------------------
      subroutine DoCmap(x1,y1,z1,iflagg,ksezold)
      USE General
      USE Mappa
      USE MappaPatterson
!
      USE Atomi
      USE Symmetry
      USE Molcom
      USE PhaseModule
      dimension xs(3),xs1(3),xs2(3),s(3)

        xmapSav=xmap  

        call CalcEpForCmap(x1,y1,z1,iflagg,ksezold)
        call CmapForPat()
!
!--determino il fattore di scala Cmap/Patterson
        SumPatt=0
        SumCmap=0
        SumOvl=0
        corrx=0.
        corry=0.
        corrxx=0.
        corryy=0.
        corrxy=0.
        do il = 0, np(3)-1
          do ik = 0, np(2)-1
            do ih = 0, np(1)-1
              xx1=xmap(ih,ik,il)
              if(xx1>0) SumCmap=SumCmap+xx1
              xx2=PattOrig(ih,ik,il)
              if(xx2>0) SumPatt=SumPatt+xx2
              if(xx1>0.and.xx2>0) SumOvl=SumOvl+1
              corrx=corrx+xx1
              corry=corry+xx2
              corrxx=corrxx+xx1*xx1
              corryy=corryy+xx2*xx2
              corrxy=corrxy+xx1*xx2
            enddo
          enddo
        enddo
        acont=float(np(1)*np(2)*np(3))
        corrx=corrx/acont
        corry=corry/acont
        corrxy=corrxy/acont
        corrxx=corrxx/acont
        corryy=corryy/acont
        corrnum=corrxy - corrx*corry
        if(corrxx>corrx*corrx.and.corryy>corry*corry) then
          corrden=sqrt(corrxx-corrx*corrx)*sqrt(corryy-corry*corry)
          corre=corrnum/corrden
        else
          corre=0.
        endif
        SumOvl=SumOvl/acont
        fact=SumPatt/SumCmap
!       write(6,*) 'Fom Cmap-Patt',SumOvl,fact,corre
!--metto la Cmap al posto della Patterson
        Patt=xmap*fact
!
c--solo per debug
c     kverboOld=kverbo
c     kverbo=1
c     aperc(1)=500
c     ier=0
c     call pksrch_big_RocPat(1,ier)
c     do j=1,nats
c         write(6,'(a,3f8.3,f15.1)') 'lista picchi Cmap',xyzs(1:4,j)
c     enddo
c     kverbo=kverboOld
c     stop
c--solo per debug
!
        xmap=xmapSav   
!
      return
      end
!-------------------------------------------
      subroutine BuildModelForCmap()
      USE General
      USE Riflessi
      USE Atomi
      USE PhaseModule, only : aperc, AbortLSQ
      USE Symmetry, only : pts, icent, nsym
      USE RemoModule
!
      kverboOld=kverbo
!!!   kverbo=1
      numb=nrefl
        
!
        icode=1
        nsog=10
c       nsog=20
        npeaks=0
        do i=1,nk
          if(no(i)>=nsog) then
            npeaks=npeaks+nw(i)
          endif
        enddo
        aperc(icode)=nint(float(npeaks)/(pts*float((icent+1)*nsym)))
        write(6,*) 'picchi1 ',npeaks,nk,nw(1:nk),aperc(icode)
        if(aperc(icode)<=1) then
          npeaks=0
c         do i=nk-1,nk
          do i=nk,nk
            npeaks=npeaks+nw(i)
          enddo
          aperc(icode)=nint(float(npeaks)/(pts*float((icent+1)*nsym)))
        endif
        write(6,*) 'picchi2 ',npeaks,aperc(icode),nats
!
        numbb=0
        call Search99(1,ier,numbb) ! va molto meglio questo di pksrch_big_RocPat
        write(6,*) 'sono in BuildModelFromCmap'
c
c--faccio i minimi quadrati 
c
      bfac(1:nats)=bt
      lsq=0
      if(lsq==1) then
        do i=1,nats
          xyzs26(1:3,i)=xyzs(1:3,i)
        enddo
        xyzs(4,1:nats)=1.0
        xyzs(5,1:nats)=1.0
        icont=0
        icont1=0
        ikpunt=nk
        do i=1,nats
          icont=icont+1
          icont1=icont1+1
          sog=nint(nw(ikpunt)/(pts*float((icent+1)*nsym)))
          if(icont>sog) then
             icont=0
             ikpunt=ikpunt-1
          endif
          nz(i)=ikpunt
          if(no(nz(i))<20) then
            icont1=icont1-1
            exit
          endif
          if(ikpunt==0) exit
        enddo
        natsold=nats
        nats=icont1
c       iref=3 ! affino anche il B
        iref=1 ! affino solo il B
        mode=1
        nlsm=10
        numb=nrefl
        scalan=1
        ifBreak=0
        call sftryyy(iref,mode,nlsm,numb,scalan,ifBreak)
        nats=natsold
        if(knw>0.and.kverbo>0) then
           call to_coord_sir(1,numb) !solo per debug
        endif
        if (AbortLSQ == 1) then
            AbortLSQ = 0
            if (knw > 0) write(6,*) 'LSQ annullato'
            do i=1,nats
               xyzs(1:3,i)=xyzs26(1:3,i)
            enddo
        endif
      else
        if(knw>0.and.kverbo>0) then
          call to_coord_sir(1,numb) !solo per debug
        endif
      endif
!--speciazione
      natsInModel(1)=nats
      model(1)%considerato(1)=1
      ikpunt=nk
      icont=0
      do i=1,nats
        model(1)%atoms(1:3,i,1)=xyzs(1:3,i)
        model(1)%atoms(5,i,1)=1
c       model(1)%th_fact(i,1)=bt
        model(1)%th_fact(i,1)=bfac(i)
        icont=icont+1
        sog=nint(nw(ikpunt)/(pts*float((icent+1)*nsym)))
        if(icont>sog) then
           icont=0
           ikpunt=ikpunt-1
        endif
        model(1)%specie(i,1)=ikpunt*nzConst
        if(ikpunt==0) exit
      enddo
!
      kverbo=kverboOld
!
      return
      end
!-------------------------------------------
      subroutine BuildModelForCmapFirst(x1,y1,z1,iflagg,ksezold)
      USE General
      USE Riflessi
      USE Atomi
      USE PhaseModule, only : aperc, AbortLSQ
      USE Symmetry
      USE Molcom
      USE Mappa
      USE MappaPatterson
      USE RemoModule
!
      dimension xs(3),xs1(3),s(3)
      dimension xs3(3)

!
!--determino il numero di atomi del modello per la Cmap     
c     natsnew=-iflagg+1
      natsnew=-iflagg
      if(natsnew>2) natsnew=2 ! indispensabile
!
      kverboOld=kverbo
!!!   kverbo=1
c
c--cerco i picchi (esclusi gli equivalenti di simmetria)
c
      sogdist=2.0
c     sogdist=5.5
c     aperc(1)=10  
      aperc(1)=50  
      call pksrch_big_RocPat(0,ier) ! va bene per proteine???
c     call pksrch_big_RocPat(1,ier) ! va bene per ksizez=3

c     do j=1,nats
c         write(6,*) 'lista picchi S map',xyzs(1:4,j)
c     enddo
c
c--seleziono il picco piu' alto (nell'intorno del PIVOT)
c
      xs1(1)=x1
      xs1(2)=y1
      xs1(3)=z1
      distmin=9999.
      do_0: do j=1,nats
          distpeak=999.
          xs(1:3)=xyzs(1:3,j)
          do kk1=1,ncentr
          do kk2=1,icent+1
          coef=1.0
          if(kk2==2) coef=-1.0
          do kk3=1,nsym
             call xequi(xs1,kk3,coef,xs3,kk1)
             call xdist(xs,xs3,dist,s)
             if(dist<distpeak) distpeak=dist
             if(dist<distmin) then
                distmin=dist
                ipeak=j
!               write(6,*) 'minimo',ipeak,distmin,xyzs(4,j)
             endif
          enddo
          enddo
          enddo
c         write(6,'(a,3f8.3,f8.1,f8.3)') 'lista picchi S map',
c    &                           xyzs(1:4,j),distpeak
      enddo do_0
      x0=xyzs(1,ipeak)
      y0=xyzs(2,ipeak)
      z0=xyzs(3,ipeak)
      h0=xyzs(4,ipeak)
      xyzs(1:5,ipeak)=xyzs(1:5,1)
      xyzs(1,1)=x0
      xyzs(2,1)=y0
      xyzs(3,1)=z0
      xyzs(4,1)=h0
 
      if(kverbo>0) write(6,'(a,3f8.3,f15.1)') 
     &                        'Fourier peak 1',x0,y0,z0,h0
c
c--seleziono il secondo picco piu' alto
c
      if(natsnew>1) then
        xs1(1:3)=xyzs(1:3,1)
        do_1: do j=2,nats
          xs(1:3)=xyzs(1:3,j)
c
c--elimino il picco se e' troppo vicino all'origine (0,0,0) nel triclino
c
          if (jsys == 1) then
              xs3 = 0.0
              call xdist(xs,xs3,dist,s)
              if (dist < 0.5) cycle do_1
          endif
c
c--elimino il picco se e' troppo vicino a quello PIVOT
c  o sta sullo stesso piano
          if(ksezold>0.and.ksezold<=3) then
           term1 = 0.0
           do i=1,nsym
             term=side(-tmat(i,ksezold))
             if(term>0) term1=term
            enddo
          endif
c
          distmin=9999.
          do kk1=1,ncentr
          do kk2=1,icent+1
          coef=1.0
          if(kk2==2) coef=-1.0
          do kk3=1,nsym
             call xequi(xs1,kk3,coef,xs3,kk1)
             call xdist(xs,xs3,dist,s)
             if(dist<distmin) distmin=dist
             if(lproj/=1.and.abs(s(1))<0.01) cycle do_1 
             if(lproj/=2.and.abs(s(2))<0.01) cycle do_1
             if(lproj/=3.and.abs(s(3))<0.01) cycle do_1
             if(ksezold>0.and.ksezold<=3) then
                 do ii=1,3
                    xs3(ii)=side(xs3(ii))
                 enddo
c               if(abs(xs3(ksezold)-0.5)<0.001) cycle do_1 
                if(abs(xs3(ksezold)-term1)<0.001) cycle do_1 
             endif
          enddo
          enddo
          enddo
          if(distmin<sogdist) cycle do_1 
          xyzs(1:5,2)=xyzs(1:5,j)
          exit do_1
        enddo do_1
        if(kverbo>0) write(6,'(a,3f8.3,f15.1,i4,f8.3)') 
     &                        'Fourier peak 2',xyzs(1:4,2),j,dist
      endif

      nats=natsnew
!     write(6,*) 'sono in BuildModelFromCmapFirst',nats
c
c--faccio i minimi quadrati 
c
      bfac(1:nats)=bt
      lsq=1 ! occhio
c     lsq=0 ! occhioMA
      if(lsq==1) then
        do i=1,nats
          xyzs26(1:3,i)=xyzs(1:3,i)
        enddo
        xyzs(4,1:nats)=1.0
        xyzs(5,1:nats)=1.0
        icont=0
        icont1=0
        ikpunt=nk
        do i=1,nats
          icont1=icont1+1
          icont=icont+1
          sog=nint(nw(ikpunt)/(pts*float((icent+1)*nsym)))
          if(icont>sog) then
             icont=0
             ikpunt=ikpunt-1
          endif
          nz(i)=ikpunt
          if(no(nz(i))<20) then
            icont1=icont1-1
            exit
          endif
          if(ikpunt==0) exit
        enddo
        natsold=nats
        nats=icont1
        iref=3 ! affino anche il B
        mode=1
        nlsm=10
        numb=nrefl
        scalan=1
        ifBreak=0
        work1(:)=wt(:)
        call sftryyy(iref,mode,nlsm,numb,scalan,ifBreak)
        wt(:)=work1(:)
        nats=natsold
        if(knw>0.and.kverbo>0) then
           call to_coord_sir(1,numb) !solo per debug
        endif
        if (AbortLSQ == 1) then
            AbortLSQ = 0
            if (knw > 0) write(6,*) 'LSQ annullato'
            do i=1,nats
               xyzs(1:3,i)=xyzs26(1:3,i)
            enddo
        endif
      endif
!--speciazione
      natsInModel(1)=nats
      model(1)%considerato(1)=1
      ikpunt=nk
      icont=0
      do i=1,nats
        model(1)%atoms(1:3,i,1)=xyzs(1:3,i)
        model(1)%atoms(5,i,1)=1
        model(1)%th_fact(i,1)=bfac(i)
        icont=icont+1
        sog=nint(nw(ikpunt)/(pts*float((icent+1)*nsym)))
        if(icont>sog) then
           icont=0
           ikpunt=ikpunt-1
        endif
        model(1)%specie(i,1)=ikpunt*nzConst
        if(ikpunt==0) exit
      enddo
!
      kverbo=kverboOld
!
      return
      end
!-------------------------------------------
      subroutine FOMPeak(xs1,xs2,SumOvl)
      USE Mappa
      USE MappaPatterson
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE RemoModule
      dimension xs1(3),xs2(3)
!
      kverboOld=kverbo
      kverbo=0
!
!--calcolo la Cmap col modello corrente
!
      natsnow=2
      bfac(1:natsnow)=bt
!--speciazione
      natsInModel(1)=natsnow
      model(1)%considerato(1)=1
      ikpunt=nk
      icont=0
      do i=1,natsnow
        if(i==1) then
          model(1)%atoms(1:3,i,1)=xs1(1:3)
        else
          model(1)%atoms(1:3,i,1)=xs2(1:3)
        endif
        model(1)%atoms(5,i,1)=1
        model(1)%th_fact(i,1)=bfac(i)
        icont=icont+1
        sog=nint(nw(ikpunt)/(pts*float((icent+1)*nsym)))
        if(icont>sog) then
           icont=0
           ikpunt=ikpunt-1
        endif
        model(1)%specie(i,1)=ikpunt*nzConst
        if(ikpunt==0) exit
      enddo
      model(1)%no(1:nk)=no(1:nk)
      model(1)%al(:,:)=al(:,:)
      model(1)%bs(:,:)=bs(:,:)
      model(1)%cl(:)=cl(:)
      call ChemInfo_MR_Final()
      call NewInv_MR_Final()
      call F2ENew1()
      fcvet(1:nrefl)=fcvetv(1:nrefl)
      call CmapForPat()
!
!--calcolo la sovrapposizione tra la Patt e la Cmap 
!
      sogth=0.
      SumOvl=0.
      corrx=0.
      corry=0.
      corrxx=0.
      corryy=0.
      corrxy=0.
      do iz=0,np(3)-1
        do iy=0,np(2)-1
          do ix=0,np(1)-1
            xx1 = PattOrig(ix,iy,iz)
            xx2 = xmap(ix,iy,iz)
            corrx=corrx+xx1
            corry=corry+xx2
            corrxx=corrxx+xx1*xx1
            corryy=corryy+xx2*xx2
            corrxy=corrxy+xx1*xx2
            if (xx1 > sogth .and. xx2 > sogth) then
              SumOvl=SumOvl+1
            endif
          enddo
        enddo
      enddo
!
      acont=float(np(1)*np(2)*np(3))
      corrx=corrx/acont
      corry=corry/acont
      corrxy=corrxy/acont
      corrxx=corrxx/acont
      corryy=corryy/acont
      corrnum=corrxy - corrx*corry
      if(corrxx>corrx*corrx.and.corryy>corry*corry) then
        corrden=sqrt(corrxx-corrx*corrx)*sqrt(corryy-corry*corry)
        corre=corrnum/corrden
      else
        corre=0.
      endif
      SumOvl=(100.*SumOvl)/acont
      SumOvl=corre*SumOvl
      write(6,'(a,f15.4,f8.3,3f8.3)') 'Fom Peak ',SumOvl,corre,xs2(1:3)
!
      kverbo=kverboOld
!
      return
      end
!------------------------------------------------------------------------
      subroutine CorrectSmap()
!
      return
      end
!------------------------------------------------------------------------
      subroutine CalcolaR(erre)
!
      return
      end
!------------------------------------------------------------------------
      subroutine snipmap(xmappa,id)
!
!da NIM A (1997) 113-132
!--parametro id: 1: taglio severo
!--parametro id: >1: taglio sempre meno severo.
!--in ogni caso viene tagliata tutta la parte negativa
!--ho inserito le condizioni di periodicita' (non presenti nell'articolo
!        originale)
!
      USE Mappa
      USE General, only : cell
      real ::  xmappa(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      real, allocatable :: xmapOld(:,:,:), xmapNew(:,:,:)
      integer sidepp,p
!
      allocate(xmapOld(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat=ier2)
      allocate(xmapNew(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat=ier3)     
!
      m=int((np(1)-0.5)/cell(1))
      m=int(m*id)
!     write(6,*) 'SNIP window',m,id
      
!
      xmapOld=xmappa           

!--LLS operator
c     do iz=0,np(3)-1
c     do iy=0,np(2)-1
c     do ix=0,np(1)-1
c       xx1=xmapOld(ix,iy,iz)
c       if(xx1>0.) then
c         xmapOld(ix,iy,iz)=log(log(sqrt(xx1+1)+1)+1)
c       endif
c     enddo
c     enddo
c     enddo
!
      do p=m,1,-1
        do iz=0,np(3)-1
          izp=sidepp(iz+p,np(3))
          izm=sidepp(iz-p,np(3))
        do iy=0,np(2)-1
          iyp=sidepp(iy+p,np(2))
          iym=sidepp(iy-p,np(2))
        do ix=0,np(1)-1
          ixp=sidepp(ix+p,np(1))
          ixm=sidepp(ix-p,np(1))
!--single point (1)
!--single point (1)
!--single point (1)
          xx1=xmapOld(ix,iy,iz)
!--double points (3)
          xr4=xmapOld(ixp,iy,iz)
          xr3=xmapOld(ixm,iy,iz)
          xr5=xmapOld(ix,iyp,iz)
          xr6=xmapOld(ix,iym,iz)
          xr2=xmapOld(ix,iy,izp)
          xr1=xmapOld(ix,iy,izm)
!--quadruple points (3)
          xs12=xmapOld(ixp,iyp,iz)
          xs10=xmapOld(ixm,iym,iz)
          xs11=xmapOld(ixp,iym,iz)
          xs9=xmapOld(ixm,iyp,iz)
          xs5=xmapOld(ixp,iy,izp)
          xs3=xmapOld(ixm,iy,izm)
          xs1=xmapOld(ixp,iy,izm)
          xs7=xmapOld(ixm,iy,izp)
          xs6=xmapOld(ix,iyp,izp)
          xs4=xmapOld(ix,iym,izm)
          xs2=xmapOld(ix,iyp,izm)
          xs8=xmapOld(ix,iym,izp)
!--ottuple points (1)
          xp1=xmapOld(ixp,iyp,izm)
          xp2=xmapOld(ixm,iyp,izm)
          xp3=xmapOld(ixp,iym,izm)
          xp4=xmapOld(ixm,iym,izm)
          xp5=xmapOld(ixp,iyp,izp) 
          xp6=xmapOld(ixm,iyp,izp)
          xp7=xmapOld(ixm,iym,izp)
          xp8=xmapOld(ixp,iym,izp)
!--coicidences
          xs1=max(xs1,0.5*(xp1+xp3))-0.5*(xp1+xp3)
          xs2=max(xs2,0.5*(xp1+xp2))-0.5*(xp1+xp2)
          xs3=max(xs3,0.5*(xp2+xp4))-0.5*(xp2+xp4)
          xs4=max(xs4,0.5*(xp3+xp4))-0.5*(xp3+xp4)
          xs5=max(xs5,0.5*(xp5+xp7))-0.5*(xp5+xp7)
          xs6=max(xs6,0.5*(xp5+xp6))-0.5*(xp5+xp6)
          xs7=max(xs7,0.5*(xp6+xp8))-0.5*(xp6+xp8)
          xs8=max(xs8,0.5*(xp7+xp8))-0.5*(xp7+xp8)
          xs9=max(xs9,0.5*(xp2+xp6))-0.5*(xp2+xp6)
          xs10=max(xs10,0.5*(xp4+xp8))-0.5*(xp4+xp8)
          xs11=max(xs11,0.5*(xp1+xp5))-0.5*(xp1+xp5)
          xs12=max(xs12,0.5*(xp3+xp7))-0.5*(xp3+xp7)
          xx=0.5*(xs1+xs3)+0.5*(xs2+xs4)+0.25*(xp1+xp2+xp3+xp4)
          xr1=max(xr1,xx)-xx
          xx=0.5*(xs5+xs7)+0.5*(xs6+xs8)+0.25*(xp5+xp6+xp7+xp8)
          xr2=max(xr2,xx)-xx
          xx=0.5*(xs3+xs7)+0.5*(xs9+xs10)+0.25*(xp2+xp4+xp6+xp8)
          xr3=max(xr3,xx)-xx
          xx=0.5*(xs1+xs5)+0.5*(xs11+xs12)+0.25*(xp1+xp3+xp5+xp7)
          xr4=max(xr4,xx)-xx
          xx=0.5*(xs9+xs11)+0.5*(xs2+xs6)+0.25*(xp1+xp2+xp5+xp6)
          xr5=max(xr5,xx)-xx
          xx=0.5*(xs4+xs8)+0.5*(xs10+xs12)+0.25*(xp3+xp4+xp7+xp8)
          xr6=max(xr6,xx)-xx
!--overall calculations
          xx21=0.5*(xr3+xr4)
          xx22=0.5*(xr5+xr6)
          xx23=0.5*(xr1+xr2)
          xx41=0.25*(xs9+xs10+xs11+xs12)
          xx42=0.25*(xs1+xs3+xs5+xs7)
          xx43=0.25*(xs2+xs4+xs6+xs8)
          xx81=0.125*(xp1+xp2+xp3+xp4+xp5+xp6+xp7+xp8)
          term=xx21+xx22+xx23+xx41+xx42+xx43+xx81
          xmapNew(ix,iy,iz)=min(xx1,term)
        enddo
        enddo
        enddo
        if(p>1) xmapOld=xmapNew
      enddo       
!
!--inverse LLS operator
!
c     do iz=0,np(3)-1
c     do iy=0,np(2)-1
c     do ix=0,np(1)-1
c       xx1=xmapOld(ix,iy,iz)
c       xmapNew(ix,iy,iz)=exp(exp(xx1-1)-1)*exp(exp(xx1-1)-1)-1
c     enddo
c     enddo
c     enddo
!
      xmappa=xmappa-xmapNew
      
!
      deallocate(xmapOld, xmapNew, stat=ier3)
!
      return
      end
!------------------------------------------------------------------------
      subroutine snipmapOld(xmappa,id)
!
!da NIM A (1997) 113-132
!--parametro id: 1: taglio severo
!--parametro id: >1: taglio sempre meno severo.
!--in ogni caso viene tagliata tutta la parte negativa
!
      USE Mappa
      USE General, only : cell
      integer :: p
      real ::  xmappa(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      real, allocatable :: xmapOld(:,:,:), xmapNew(:,:,:)
!
      allocate(xmapOld(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat=ier2)
      allocate(xmapNew(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat=ier3)     
!
      m=int((np(1)-0.5)/cell(1))
      m=int(m*id)
!     write(6,*) 'SNIP window',m,id
!
      xmapOld=xmappa           

!
      do p=m,1,-1
        nx=np(1)-p-1
        ny=np(2)-p-1
        nz=np(3)-p-1
        do iz=p,nz
        do iy=p,ny
        do ix=p,nx
!--single point (1)
          xx1=xmapOld(ix,iy,iz)
!--double points (3)
          xr4=xmapOld(ix+p,iy,iz)
          xr3=xmapOld(ix-p,iy,iz)
          xr5=xmapOld(ix,iy+p,iz)
          xr6=xmapOld(ix,iy-p,iz)
          xr2=xmapOld(ix,iy,iz+p)
          xr1=xmapOld(ix,iy,iz-p)
!--quadruple points (3)
          xs12=xmapOld(ix+p,iy+p,iz)
          xs10=xmapOld(ix-p,iy-p,iz)
          xs11=xmapOld(ix+p,iy-p,iz)
          xs9=xmapOld(ix-p,iy+p,iz)
          xs5=xmapOld(ix+p,iy,iz+p)
          xs3=xmapOld(ix-p,iy,iz-p)
          xs1=xmapOld(ix+p,iy,iz-p)
          xs7=xmapOld(ix-p,iy,iz+p)
          xs6=xmapOld(ix,iy+p,iz+p)
          xs4=xmapOld(ix,iy-p,iz-p)
          xs2=xmapOld(ix,iy+p,iz-p)
          xs8=xmapOld(ix,iy-p,iz+p)
!--ottuple points (1)
          xp1=xmapOld(ix+p,iy+p,iz-p)
          xp2=xmapOld(ix-p,iy+p,iz-p)
          xp3=xmapOld(ix+p,iy-p,iz-p)
          xp4=xmapOld(ix-p,iy-p,iz-p)
          xp5=xmapOld(ix+p,iy+p,iz+p) 
          xp6=xmapOld(ix-p,iy+p,iz+p)
          xp7=xmapOld(ix-p,iy-p,iz+p)
          xp8=xmapOld(ix+p,iy-p,iz+p)
!--coicidences
          xs1=max(xs1,0.5*(xp1+xp3))-0.5*(xp1+xp3)
          xs2=max(xs2,0.5*(xp1+xp2))-0.5*(xp1+xp2)
          xs3=max(xs3,0.5*(xp2+xp4))-0.5*(xp2+xp4)
          xs4=max(xs4,0.5*(xp3+xp4))-0.5*(xp3+xp4)
          xs5=max(xs5,0.5*(xp5+xp7))-0.5*(xp5+xp7)
          xs6=max(xs6,0.5*(xp5+xp6))-0.5*(xp5+xp6)
          xs7=max(xs7,0.5*(xp6+xp8))-0.5*(xp6+xp8)
          xs8=max(xs8,0.5*(xp7+xp8))-0.5*(xp7+xp8)
          xs9=max(xs9,0.5*(xp2+xp6))-0.5*(xp2+xp6)
          xs10=max(xs10,0.5*(xp4+xp8))-0.5*(xp4+xp8)
          xs11=max(xs11,0.5*(xp1+xp5))-0.5*(xp1+xp5)
          xs12=max(xs12,0.5*(xp3+xp7))-0.5*(xp3+xp7)
          xx=0.5*(xs1+xs3)+0.5*(xs2+xs4)+0.25*(xp1+xp2+xp3+xp4)
          xr1=max(xr1,xx)-xx
          xx=0.5*(xs5+xs7)+0.5*(xs6+xs8)+0.25*(xp5+xp6+xp7+xp8)
          xr2=max(xr2,xx)-xx
          xx=0.5*(xs3+xs7)+0.5*(xs9+xs10)+0.25*(xp2+xp4+xp6+xp8)
          xr3=max(xr3,xx)-xx
          xx=0.5*(xs1+xs5)+0.5*(xs11+xs12)+0.25*(xp1+xp3+xp5+xp7)
          xr4=max(xr4,xx)-xx
          xx=0.5*(xs9+xs11)+0.5*(xs2+xs6)+0.25*(xp1+xp2+xp5+xp6)
          xr5=max(xr5,xx)-xx
          xx=0.5*(xs4+xs8)+0.5*(xs10+xs12)+0.25*(xp3+xp4+xp7+xp8)
          xr6=max(xr6,xx)-xx
!--overall calculations
          xx21=0.5*(xr3+xr4)
          xx22=0.5*(xr5+xr6)
          xx23=0.5*(xr1+xr2)
          xx41=0.25*(xs9+xs10+xs11+xs12)
          xx42=0.25*(xs1+xs3+xs5+xs7)
          xx43=0.25*(xs2+xs4+xs6+xs8)
          xx81=0.125*(xp1+xp2+xp3+xp4+xp5+xp6+xp7+xp8)
          term=xx21+xx22+xx23+xx41+xx42+xx43+xx81
          xmapNew(ix,iy,iz)=min(xx1,term)
        enddo
        enddo
        enddo
        do iz=p,nz
        do iy=p,ny
        do ix=p,nx
          xmapOld(ix,iy,iz)=xmapNew(ix,iy,iz)
        enddo
        enddo
        enddo
      enddo       
!
      xmappa=xmappa-xmapNew
      
!
      deallocate(xmapOld, xmapNew, stat=ier3)
!
      return
      end
!------------------------------------------------------------------------
      subroutine snipmap2D(xmappa,ksez,id)
!
!da NIM A (1997) 113-132
!
      USE Mappa
      USE General, only : cell
      real ::  xmappa(0:np(1)-1,0:np(2)-1,0:np(3)-1)
      real, allocatable :: xmapOld(:,:,:), xmapNew(:,:,:)
      integer sidepp,p
!
      allocate(xmapOld(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat=ier2)
      allocate(xmapNew(0:np(1)-1,0:np(2)-1,0:np(3)-1), stat=ier3)     
!
      m=int((np(1)-0.5)/cell(1))
      m=int(m*id)
      write(6,*) 'SNIP 2D window',m,ksez,id
!
      xmapOld=xmappa           
!
      do p=m,1,-1
       if(ksez==3) then
        iz=0
        do iy=0,np(2)-1
          iyp=sidepp(iy+p,np(2))
          iym=sidepp(iy-p,np(2))
        do ix=0,np(1)-1
          ixp=sidepp(ix+p,np(1))
          ixm=sidepp(ix-p,np(1))
!--single point (1)
          xx1=xmapOld(ix,iy,iz)
!--double points (4)
          xs1=xmapOld(ixp,iy,iz)
          xs2=xmapOld(ix,iyp,iz)
          xs3=xmapOld(ix,iym,iz)
          xs4=xmapOld(ixm,iy,iz)
!--quadruple points (4)
          xp1=xmapOld(ixp,iyp,iz)
          xp2=xmapOld(ixm,iyp,iz)
          xp3=xmapOld(ixp,iym,iz)
          xp4=xmapOld(ixm,iym,iz)
!--coicidences
          xs1=max(xs1,0.5*(xp1+xp3))-0.5*(xp1+xp3)
          xs2=max(xs2,0.5*(xp1+xp2))-0.5*(xp1+xp2)
          xs3=max(xs3,0.5*(xp3+xp4))-0.5*(xp3+xp4)
          xs4=max(xs4,0.5*(xp2+xp4))-0.5*(xp2+xp4)
          term=0.5*(xs1+xs4)+0.5*(xs2+xs3)+0.25*(xp1+xp2+xp3+xp4)
          xmapNew(ix,iy,iz)=min(xx1,term)
        enddo
        enddo
        do iy=0,np(2)-1
        do ix=0,np(1)-1
          xmapOld(ix,iy,iz)=xmapNew(ix,iy,iz)
        enddo
        enddo
       elseif(ksez==2) then
        iy=0
        do iz=0,np(3)-1
          izp=sidepp(iz+p,np(3))
          izm=sidepp(iz-p,np(3))
        do ix=0,np(1)-1
          ixp=sidepp(ix+p,np(1))
          ixm=sidepp(ix-p,np(1))
!--single point (1)
          xx1=xmapOld(ix,iy,iz)
!--double points (4)
          xs1=xmapOld(ixp,iy,iz)
          xs2=xmapOld(ix,iy,izp)
          xs3=xmapOld(ix,iy,izm)
          xs4=xmapOld(ixm,iy,iz)
!--quadruple points (4)
          xp1=xmapOld(ixp,iy,izp)
          xp2=xmapOld(ixm,iy,izp)
          xp3=xmapOld(ixp,iy,izm)
          xp4=xmapOld(ixm,iy,izm)
!--coicidences
          xs1=max(xs1,0.5*(xp1+xp3))-0.5*(xp1+xp3)
          xs2=max(xs2,0.5*(xp1+xp2))-0.5*(xp1+xp2)
          xs3=max(xs3,0.5*(xp3+xp4))-0.5*(xp3+xp4)
          xs4=max(xs4,0.5*(xp2+xp4))-0.5*(xp2+xp4)
          term=0.5*(xs1+xs4)+0.5*(xs2+xs3)+0.25*(xp1+xp2+xp3+xp4)
          xmapNew(ix,iy,iz)=min(xx1,term)
        enddo
        enddo
        do iz=0,np(3)-1
        do ix=0,np(1)-1
          xmapOld(ix,iy,iz)=xmapNew(ix,iy,iz)
        enddo
        enddo
       elseif(ksez==1) then
        ix=0
        do iz=0,np(3)-1
          izp=sidepp(iz+p,np(3))
          izm=sidepp(iz-p,np(3))
        do iy=0,np(2)-1
          iyp=sidepp(iy+p,np(2))
          iym=sidepp(iy-p,np(2))
!--single point (1)
          xx1=xmapOld(ix,iy,iz)
!--double points (4)
          xs1=xmapOld(ix,iyp,iz)
          xs2=xmapOld(ix,iy,izp)
          xs3=xmapOld(ix,iy,izm)
          xs4=xmapOld(ix,iym,iz)
!--quadruple points (4)
          xp1=xmapOld(ix,iyp,izp)
          xp2=xmapOld(ix,iym,izp)
          xp3=xmapOld(ix,iyp,izm)
          xp4=xmapOld(ix,iym,izm)
!--coicidences
          xs1=max(xs1,0.5*(xp1+xp3))-0.5*(xp1+xp3)
          xs2=max(xs2,0.5*(xp1+xp2))-0.5*(xp1+xp2)
          xs3=max(xs3,0.5*(xp3+xp4))-0.5*(xp3+xp4)
          xs4=max(xs4,0.5*(xp2+xp4))-0.5*(xp2+xp4)
          term=0.5*(xs1+xs4)+0.5*(xs2+xs3)+0.25*(xp1+xp2+xp3+xp4)
          xmapNew(ix,iy,iz)=min(xx1,term)
        enddo
        enddo
        do iz=0,np(3)-1
        do iy=0,np(2)-1
          xmapOld(ix,iy,iz)=xmapNew(ix,iy,iz)
        enddo
        enddo
       endif
      enddo       
!
      xmappa=xmappa-xmapNew
      
!
      deallocate(xmapOld, xmapNew, stat=ier3)
!
      return
      end
!------------------------------------------------------------------------------
      subroutine Esalta_Patterson(ier)
!
      USE General
      USE Symmetry
      USE Riflessi
      USE Atomi
      USE Mappa
      USE CorrMod
      USE PhaseModule     
!
!
      real, dimension(3)       :: xs,xeq,s
      real, dimension(3)       :: xs1,xs2
      real, dimension(2)       :: vet
      integer                  :: sidepp,hintmx
      integer, allocatable     :: is00(:,:)
!

      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1

c     ndime = ncentr * ifin * nsym
c     allocate(is00(1:3,1:ndime), stat = ier)
c     is00(:,:) = -99

      zero = 0.0000000001
!     alim = 1.5 !raylim
      alim = raylim
      esalta = 1.1

      deltx=np(1)/cell(1)
      delty=np(2)/cell(2)
      deltz=np(3)/cell(3)

      ca=cos(cell(4)*dtor)
      cb=cos(cell(5)*dtor)
      cg=cos(cell(6)*dtor)

      dx=1.0/float(np(1))
      dy=1.0/float(np(2))
      dz=1.0/float(np(3))
 
      j1sav=0
      j2sav=0
      j3sav=0

      xmapmax=-1.E+10
      do j1=0,np(1)-1
        do j2=0,np(2)-1
          do j3=0,np(3)-1
              if(xmap(j1,j2,j3).gt.xmapmax)then
                 xmapmax=xmap(j1,j2,j3)
                 j1sav=j1
                 j2sav=j2
                 j3sav=j3
              endif
          enddo
        enddo
      enddo
      xs1(1)=float(j1sav)*dx
      xs1(2)=float(j2sav)*dy
      xs1(3)=float(j3sav)*dz
      hintmx = xmap(j1sav,j2sav,j3sav)
!

      if (knw > 0) write(lo,*) 
     *             '  ***  PERFORMING MAP POWERING ...  ***',alim


      call maxmin3d(denmin,denmax,avden,stden,npunt,0)
      write(6,*) 'Prima Esalta_Patt',denmin,denmax,avden,stden


!
!  - Esalta la mappa escludendo il picco all'origine
!
      do kk1=1,ncentr
c        do kk2=1,ifin
c           coef=vet(kk2)
c           do kk3=1,nsym

               kk2 = 1
               kk3 = 1
               coef = 1

c              ncont = ncont + 1
c              if (ncont > 1) then
c                  is00(3,ncont-1) = isz0
c                  is00(2,ncont-1) = isy0
c                  is00(1,ncont-1) = isx0
c              endif

               call xequi(xs1,kk3,coef,xs,kk1)
               do ii=1,3
                  xs(ii)=side(xs(ii))
               enddo

c              iesco = 0
c              if (ncont > 1) then
c                 do jj = 1, ncont-1
c                     if (is00(3,jj) == isz0 .and. 
c    *                    is00(2,jj) == isy0 .and. 
c    *                    is00(1,jj) == isx0) then
c                         iesco = 1
c                         exit
c                     endif
c                 enddo
c                 if (iesco == 1) cycle
c              endif

!
               do iz = 0, np(3)-1
                 do iy = 0, np(2)-1
                   do ix = 0, np(1)-1

                      ih = sidepp(ix,np(1))
                      ik = sidepp(iy,np(2))
                      il = sidepp(iz,np(3))

                       xx1=float(ih)*dx
                       yy1=float(ik)*dy
                       zz1=float(il)*dz
                       xs2(1)=xx1
                       xs2(2)=yy1
                       xs2(3)=zz1
                       call xdist(xs,xs2,d,s)
                       ray=d

!                     if (ray < alim) cycle


c                     if (xmap(ih,ik,il).lt.0.00000001) then
c                         xmap(ih,ik,il) = 0.0
c                     else
c                         if (ray > alim) xmap(ih,ik,il) = 
c    *                                         xmap(ih,ik,il) ** esalta
!                         xmap(ih,ik,il) = xmap(ih,ik,il) ** esalta
c                     endif

                      if (xmap(ih,ik,il).gt.0.00001) then
                          if (ray > alim) xmap(ih,ik,il) = 
     *                                         xmap(ih,ik,il) ** esalta
                      endif


                   enddo
                 enddo
               enddo
!
c         enddo
c       enddo
      enddo  
!


      call maxmin3d(denmin,denmax,avden,stden,npunt,0)
      write(6,*) 'Dopo Esalta_Patt',denmin,denmax,avden,stden

c     deallocate(is00, stat = ier)
!
      return
      end 
!------------------------------------------------------------------------------
      subroutine CercaRipplesPatt(ray,numb,ier)
!
      USE General
      USE Symmetry     
      USE Riflessi
      USE TestModel
      USE PhaseModule     
      USE Atomi
      USE Mappa
      USE CorrMod
!
      real, dimension(5,100)        :: xpos,xneg
      real, dimension(3)            :: xo,xo1,xo2,xeq,s
      real, dimension(2)            :: vet
      real                          :: intepos0, intepos, inteneg
      real, dimension(10)           :: intep, inten, dmp, dmn
!
!  -- ricerca dei picchi positivi su xmap
!
      ifin = icent + 1 
      vet(1)= 1.0
      vet(2)=-1.0

      natbb = 100

      aperc(1) = natbb
      iflagPKS = 0
      mode = -1
      nnuu = numb
      krecy = 0
      call pksrch_New(mode, iflagPKS, nnuu,ier)
      if (ier /= 0) then
          return
      endif

      nats = min0(nats,natbb)
      xpos(:,1:nats) = xyzs(:,1:nats)

!     write(6,*) '  Nats - pos = ', nats

!
!  -- ricerca dei picchi negativi su xmap = -xmap 
!
      xmap(:,:,:) = -xmap(:,:,:)

      aperc(1) = natbb
      iflagPKS = 0
      mode = -1
      nnuu = numb
      krecy = 0
      call pksrch_New(mode, iflagPKS, nnuu,ier)
      if (ier /= 0) then
          return
      endif

      nats = min0(nats,natbb)
      xneg(:,1:nats) = xyzs(:,1:nats)

!     write(6,*) '  Nats - neg = ', nats

      xmap(:,:,:) = -xmap(:,:,:) ! rimetto a posto la mappa

! Picco all'origine
      xo2(:)=0
!     write(6,'(a3,3f17.5)') 'YYY',xo2(1:3)


      ray = raylim0

!
!  -- ricerca dei picchi positivi
!
      dminpos0=1.E+10     
      dminpos=1.E+10     
      intepos0=0.0
      intepos=0.0
      iprog = 1

      do i=1,nats
         xo1(1)=side(xpos(1,i))
         xo1(2)=side(xpos(2,i))
         xo1(3)=side(xpos(3,i))
         dmin=1.E+10
         do kk1=1,ncentr
            do kk2=1,ifin
               coef=vet(kk2)
               do kk3=1,nsym
                   call xequi(xo2,kk3,coef,xeq,kk1)
                   call xdist(xo1,xeq,d,s)
                   if(d.lt.dmin) dmin=d
               enddo
            enddo
         enddo
         if(dmin.lt.dminpos0) then
            dminpos0=dmin
            intepos0=xpos(4,i)
         endif
         if(dmin.gt.0.5.and.dmin.lt.dminpos) then
            dminpos=dmin   !???  Angela > 1.5; Dedi > 0.5
            intepos=xpos(4,i)
            dmp(iprog)=dmin
            intep(iprog)=xpos(4,i)
         endif
c        write(80,11) xeq,xo1,xpos(4,i),dmin
      enddo
 11   format(6f10.5,f15.2,f10.5)
!
!  -- ricerca dei picchi negativi
!
      dminneg=1.E+10     
      inteneg=0.0
      do i=1,nats
         xo1(1)=side(xneg(1,i))
         xo1(2)=side(xneg(2,i))
         xo1(3)=side(xneg(3,i))
         dmin=1.E+10
         do kk1=1,ncentr
            do kk2=1,ifin
               coef=vet(kk2)
               do kk3=1,nsym
                   call xequi(xo2,kk3,coef,xeq,kk1)
                   call xdist(xo1,xeq,d,s)
                   if(d.lt.dmin) dmin=d
               enddo
            enddo
         enddo
         if(dmin.lt.dminneg) then
            dminneg=dmin
            inteneg=-xneg(4,i)
         endif
c        write(90,11) xeq,xo1,xneg(4,i),dmin
      enddo
!
      if (knw == 1) then
          write(6,100)iprog,dminpos0,intepos0
      endif

      if (dminneg.gt.dminpos) then
          ddd = dminneg
          if (knw == 1) then
              write(6,120)iprog,dminpos,intepos
              write(6,110)iprog,dminneg,inteneg
          endif
      else
          ddd = dminpos
          if (knw == 1) then
              write(6,110)iprog,dminneg,inteneg
              write(6,120)iprog,dminpos,intepos
          endif
      endif

      dminnegC=1.E+10
      inteneg=0.0
      do i=1,nats
         xo1(1)=side(xneg(1,i))
         xo1(2)=side(xneg(2,i))
         xo1(3)=side(xneg(3,i))
         dmin=1.E+10
         do kk1=1,ncentr
            do kk2=1,ifin
               coef=vet(kk2)
               do kk3=1,nsym
                   call xequi(xo2,kk3,coef,xeq,kk1)
                   call xdist(xo1,xeq,d,s)
                   if(d.lt.dmin) dmin=d
               enddo
            enddo
         enddo
         if(dmin.gt.ddd.and.dmin.lt.dminnegC) then
            dminnegC=dmin
            inteneg=-xneg(4,i)
            dmn(iprog)=dmin
            inten(iprog)=-xneg(4,i)
         endif
      enddo
      if (knw ==1) write(6,130)iprog,dminnegC,inteneg

      
      iprog = 1 
      kRip = 1
      CicliRipples: do while (kRip.eq.1)
      
         dminneg2 = dminnegC

      iprog = iprog + 1
      kPicP = 0
      kPicN = 0
     
      dminposC=1.E+10
      intepos=0.0
      do i=1,nats
         xo1(1)=side(xpos(1,i))
         xo1(2)=side(xpos(2,i))
         xo1(3)=side(xpos(3,i))
         dmin=1.E+10
         do kk1=1,ncentr
            do kk2=1,ifin
               coef=vet(kk2)
               do kk3=1,nsym
                   call xequi(xo2,kk3,coef,xeq,kk1)
                   call xdist(xo1,xeq,d,s)
                   if(d.lt.dmin) dmin=d
               enddo
            enddo
         enddo
         if(dmin.gt.dminnegC.and.dmin.lt.dminposC) then
            dminposC=dmin
            intepos=xpos(4,i)
            dmp(iprog)=dmin
            intep(iprog)=xpos(4,i)
            kPicP = 1
         endif
      enddo

      dminnegC=1.E+10
      inteneg=0.0
      do i=1,nats
         xo1(1)=side(xneg(1,i))
         xo1(2)=side(xneg(2,i))
         xo1(3)=side(xneg(3,i))
         dmin=1.E+10
         do kk1=1,ncentr
            do kk2=1,ifin
               coef=vet(kk2)
               do kk3=1,nsym
                   call xequi(xo2,kk3,coef,xeq,kk1)
                   call xdist(xo1,xeq,d,s)
                   if(d.lt.dmin) dmin=d
               enddo
            enddo
         enddo
         if(dmin.gt.dminposC.and.dmin.lt.dminnegC) then
            dminnegC=dmin
            inteneg=-xneg(4,i)
            dmn(iprog)=dmin
            inten(iprog)=-xneg(4,i)
            kPicN = 1
         endif
      enddo

      if (dminposC >= ray .or. dminnegC >= ray .or. iprog == 10) then
          kRip = 0
      endif

      if (knw == 1 .and. kPicP == 1) write(6,120)iprog,dminposC,intepos
      if (knw == 1 .and. kPicN == 1) write(6,130)iprog,dminnegC,inteneg

      end do CicliRipples

!
      if (iprog >= 3) then
          ray = (dmn(2) + dmp(3))/2
      endif

      write(6,*) 'ALIM =', ray
!
      return
!
  100 format('distanza  Picco # ', i5,' positivo',2f15.3)
  110 format('distanza  Picco # ', i5,' negativo',2f15.3)
  120 format('distanza ripple # ', i5,' positivo',2f15.3)
  130 format('distanza ripple # ', i5,' negativo',2f15.3)
!
      end
!------------------------------------------------------------------------------
