!---------------------------------------------------------------------
      subroutine manage_console(iAction)
!
      call c_manage_console(iAction)
!
      return
      end
!---------------------------------------------------------------------
      subroutine RunToolBar(iAction,string)
      USE General
      USE Molcom
      USE PhaseModule
!
!-- iAction =  0     Open "Run" toolbar
!-- iAction =  1     Update text entry in "Run" toolbar
!-- iAction =  2     Just close the FOM window (no more used)
!-- iAction = -1     Close "Run" toolbar
!
      character *(*) string
!     character* 80 testo
!
      if (jscreen.le.0.or.jscreen.eq.3) then
          return
      endif
!
      if (kmad /= 0) then
!         testo(1:2) = ' ' // char(0)
          Buffer1(1:2) = ' ' // char(0)
          ind = 2
!         call c_runtoolbar(ind,testo)
          call c_runtoolbar(ind,Buffer1)
          ifRunToolBar = 0
          return
      endif
      if (iAction.eq.0) then
          ifRunToolBar = 1
!         testo = ' '
          Buffer1 = ' '
          iz = 1
          ind = 1           !       155
      elseif (iAction.eq.-1) then
          ifRunToolBar = 0
          ind = 5       !          148
          iz = 0
          ind = 2           !       156
      elseif (iAction.eq.1) then
          iz = Lung(string)
!         testo = string(1:iz)
          Buffer1 = string(1:iz)
          ind = 3           !       157
      endif
!
      if (iAction.ne.2) then
!         testo(iz+1:iz+1) = char(0)
!         call c_runtoolbar(ind,testo)
          Buffer1(iz+1:iz+1) = char(0)
          call c_runtoolbar(ind,Buffer1)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Vista(iAct,ival)
      USE Molcom
!
      integer iAct
      integer ival
!
      integer Asse, Angolo
      dimension B(3, 3)
!
      Asse    = 1
      ifScale = 0
      ifMovedLab = 0

      iAction = iAct
      select case (iAction)

             case (1,2,3,4,5,6,7,8,               ! Rotate
     *             31,32,33,34,35,36,37,38)       ! Rotate cont.
                   iAction = MOD(iAct, 10)
                   if (nUltRot.eq.4) then         !mr1707
                       call RestoreBaric(iActive) !mr1707
                       nUltRot = 0                !mr1707
                   endif                          !mr1707
                   AngDef = iVal
                   Asse = (iAction + 1) / 2
                   Angolo = AngDef
                   if (iAction.eq.1 .or. iAction.eq.3 .or.
     *                 iAction.eq.5 .or. iAction.eq.7) then
                       Angolo = -Angolo
                   end if
                   if (Asse .eq. 4) then    ! chi sono iActive e nUltRot ??
                       RK(3) = 1
                       ii = kptr(99)
                       jj = kptr(100)
                       do i=1, 3
                          VV(1, i) = xyz(i, jj) - xyz(i, ii)
                       enddo
                       if (nUltRot.ne.4) then
                           nUltRot = 4
                           call MoveBaric(ii, jj, iActive)
                       end if
                   end if
                   if (iAct. le. 8) then
                       call Rotaz(Angolo, Asse, B)
                   else
                       jjkkjj = iPlotType
                       if (iPlotType.eq.VAN_DER_WAALS.or.
     *                     iPlotType.eq.RODS) then
                           Angolo = 2 * Angolo
                       endif
                       ifBrekke = 0
                       do while (ifBrekke.ne.1)
                          call Rotaz(Angolo, Asse, B)
                          do i=1,(11 - iRotSpeed)
                             call Disegna(0)
                             call DoSingleIteration()
                             if (ifBrekke.eq.1) exit
                          enddo
                       enddo
                       iPlotType = jjkkjj
                       call Disegna(ifScale)
                   endif

             case (9,10,11,12,13,14)              ! Translate
                   iScelta = iAction - 8
                   Val = iVal
                   call Translate(iScelta, Val)

             case (15)                            ! Zoom In
                   call Translate(6,10.)

             case (16)                            ! Zoom Out
                   call Translate(5,10.)

             case (17)                            ! Reset View
                   if (ifDrawContour == 0) then
                       ifScale = 1
                       call SetScale(0)
                       call FindMinMax
                   else
                       call SetScaleMap()
                   endif


             case (18,19,20,21,22,23)             ! View Plane
                   iScelta = iAction - 17
                   ifDrC = ifDrawContour

                   call ChePiano (iScelta)
                   call FindMinMax
                   if (ifDrawContour == 1) then
                       Layer = iAction - 20
                       sezione0 = 0             !mrmrmr
                       sezioneN = 0             !mrmrmr
                       call LeggiSezioni()
                   endif
                   ifDrawContour = ifDrC             !pg2
!
                   if (ifDrawContour == 1) then
                       call SetScaleMap()
                       ifOriented = 0
                   endif
!
             case (25)                            ! 3-atoms Plane
                   iScelta = 7
                   call ChePiano (iScelta)
                   call FindMinMax

             case (39, 40, 41, 42, 43, 44)
                   return
      end select

      call Disegna(ifScale)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine GetBinV2(nomeStr,file1,file2)
      USE General
!
      implicit none
      character*(*) nomeStr, file1, file2
      character*80  file
      integer       ier, Lung, i, k, lfile, iTipo
!
      ier = 0
      fname(1) = file1
      fname(15) = file2
      k = Lung(nomeStr)
      StructureName = nomeStr
      lStructureName = k
      do i=2,14
         file=nomeStr(1:k)//ext(i)
         call NoBlanks(file,lfile)
         fname(i)=file(1:lfile)
      enddo
!
      iTipo = 2
      call updSWRC(iTipo,file1,file2)
      call updRecentProjects()
      call LoadFromBin(file1,file2,ier)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine ManageOutputFile(nomeStr)
      USE General
!
      character*(*) nomeStr
      character*80 file2, newproj, line
!
      lung1 = Lung(nomeStr)
      lung2 = Lung(Titolo)
      newproj = 'newprojX.txt'
!
      close(lo)
!
      file2 = nomeStr(1:lung1) // '.out'
      itype=0
      iform=1
      jop=jopen(lo,file2,itype,iform,ier)
!
      write(lo,215) Titolo(1:lung2)
  215 format(' ',78('*'),/,' ',a,//)
      call wrhead
      leggi = 1
      i = 0
      do while (leggi.eq.1)
         i = i + 1
         write(newproj(8:8),'(i1)') i
         itype=2
         iform=1
         jop=jopen(jhost,newproj,itype,iform,ier)
         if (jop.ge.0) then
             iEnd = 0
             write(lo,10)
             do while (iEnd.eq.0)
                read(jhost,'(a)') line
                if (line(1:1).eq.'#') then
                    iEnd = 1
                elseif (line(1:1).ne.'&') then
                    write(lo,'(a)') line
                endif
             enddo
             close(jhost)
         else
             leggi = 0
         endif
      enddo
!
      return
   10 format(/,78('+'),/)
      end
! ----------------------------------------------------------------------
      subroutine ExitSir2006(ier)
      USE General
      USE Atomi
      USE Molcom
      USE PhaseStuff
      USE RemoModule
      USE VLDmod, only : nPreviousTrials
!
      implicit none
      integer ier, iAction, nset
!
      integer :: i, Lung
      integer :: mode, lista, lsn, lixx, ljxx, lkxx, llxx, somma
!
*     ifMadEnv = 0
      ifDrawContour = 0
!
      if (nrefl == 0 .and. nats == 0) then
          return
      endif
!
      if (allocated(nz)) then
          somma = sum(abs(nz(1:nats)))
          if (somma == 0) then
              nats = 0
          endif
          if (.not.allocated(model)) then
              nats = 0
          else
              if (.not.allocated(model(1)%atoms)) then
                  nats = 0
              endif
          endif
      else
          nats = 0
      endif

      if (nats > 0) then
          if (ifSkeletonOn == 1) then
              call LeggiSkeleton(1)
          endif
!
!-- check on ghosts
!
          call CheckGhosts(ier)
          if (ier < 0) return
!
          if (nats > 0) then
              do i=1, nats
                 if (nz(i) == 0) then
                     RS(i) = -100.0
                 endif
              enddo
          endif
          if (InfoOK(15) > 0) then
              if (jscreen > 0) then
                  call UpdateCommonAndList5(ier)
              else
                  SinglePlotType(:) = SIMPLE
              endif
!
!-- check on List 5
!
              if (ier < 0) return
              call PutModel
          endif
      endif
!
      if (ifWasRemo == 0) then
          iAction = 1
          mode = 1
          call PutGetBinaryFile(iAction, mode, ier)
      endif
!
      call AllocaRiflessi(2)
      iAction = 2
      nset = nsetFinalPhases
      call ManageFinalPhases(iAction, nReflDim, nset)
!
      call AllocaGrafici(2, 0, 0)
      nPreviousTrials = 0
!
      if (neutro == 2) then
          close(jrel)
      endif
!
      return
      end
! ----------------------------------------------------------------------
      integer function kridisegna(newkscrx,newkscry,ifResetLab)
      USE General
      USE Atomi
      USE Molcom
      USE Grafici
!
      implicit none
      integer :: newkscrx, newkscry, ifResetLab
!
      kridisegna = 0                   !mr021104

      if (ifResetLab.eq.1) then
          call ResetLabelPos()
      endif
      kscrx = newkscrx
      kscry = newkscry
      iVP(1) = 1
      iVP(2) = 1
      iVP(3) = kscrx
      iVP(4) = kscry
      if (preRemo) then
          call ManageGraph(0, 0)
          kridisegna = 0
          return
      endif
      if (ifMadEnv == 2) then
** NEW
          if (.not.allocated(MinMaxGR)) then 
!!mr              kridisegna = -1
              kridisegna = 0
          else
              Rmin1 = minmaxSav(1)
              Rmin2 = minmaxSav(2)
              RMAX1 = minmaxSav(3)
              RMAX2 = minmaxSav(4)
** NEW
              call Disegna(ifScale)
          endif
      else
          if (InfoOK(15).ne.0 .or. ifDrawContour == 1) then
              if (ifViewModel == 0) then
                  call FindMinMax
              endif
!
              call Disegna(ifScale)
              kridisegna = 0
          else
              kridisegna = -1
          endif
      endif
      if (nats <= 0 .and. ifMadEnv /= 2) then
          kridisegna = -1
      endif
!
      return
      end
! ----------------------------------------------------------------------
      integer function ridisegna()
      USE General
      USE Atomi
      USE Molcom
!
      implicit none
      integer :: ifs
!
      ridisegna = 0
      if (ifMadEnv == 2) then
          call Disegna(ifScale)
      else if (InfoOK(15).ne.0 .or. ifDrawContour == 1) then
!          call Disegna(0)
          call FindMinMax
          ifs = ifScale
          call Disegna(ifs)
      else
          ridisegna = -1
      endif
      if (nats <= 0 .and. ifMadEnv /= 2) then
          ridisegna = -1
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine putlab95(input_par, ierr)
      USE General
      USE Molcom
      USE LsqModule
      USE VLDmod, only : nPreviousTrials
      USE PhaseModule, only : RSoglia
!
      type (multistringa)  ::input_par

      character*256 file1, file2, nomeStr
      character*3 tipo
      character*80 file
!
      integer n1
      integer n2
      integer n3
      integer n4
      integer ierr
!
      n1 = input_par%n1
      n2 = input_par%n2
      n3 = input_par%n3
      n4 = input_par%n4
      ier = 0
      if (ifProject.ne.0) then
          cardImage = fname(1)
          fname(1) = OldWorkingDirectory(1:Lung(OldWorkingDirectory)) //
     *               cardImage(1:Lung(cardImage))
          iflag = 2
          call chiudi_bin(iflag, ierr)
          if (ierr < 0) return
          nPreviousTrials = 0
          call AllocaAtomi(2)
          InfoOK(:) = 0
          BLimit = 1000000
          jcpuP = 0
          call sirtime(nomeStr,icod)
          if (icod.eq.0) then
              MessH = ProgName(1:lProgName) //' starts on: ' //
     *                char(10) // '.'
          else
              MessH = nomeStr(1:icod) // char(10) //
     *                ProgName(1:lProgName) //' starts on: ' //
     *                     char(10) // '.'
          endif
          call CPUTime0(MessH)
          call CPUTime0(MessH)
      endif
!
!-- per il restart del programma
!
      SpeciesSav(:) = '    '
      InfoOK(:) = 0
      jcpuP = 2
      nPreviousTrials = 0
      RSoglia = -1
!
      OldWorkingDirectory = WorkingDirectory
!
      file1 = input_par%str1(1:n1)
      file2 = input_par%str2(1:n2)
      nomeStr  = input_par%str3(1:n3)
      tipo  = input_par%str4(1:3)
!
      cardImage = file1
      call lcase(cardImage)
      j = index(cardImage,'.ins',.TRUE.) 
      if (j > 0) then
          ifFromShelx = 1
          tipo  = 'ins'
      else
          ifFromShelx = 0
      endif
      if (tipo(1:3).eq.'sir' .or. tipo(1:3).eq.'ins') then
          k = Lung(nomeStr)
          do i=1,13
             file=nomeStr(1:k)//ext(i)
             call NoBlanks(file,lfile)
             fname(i)=file(1:lfile)
          enddo
          fname(14) = file1
          fname(15) = file2
          itype = 0
          iform = 1
          jop = jopen(lo,file2,itype,iform,ier2)
          if (ifFromShelx == 0) then
              call CheckWindowCommand(file1,nkscrx,nkscry,ier)
          else
              call FromShelxToSir(file1, nomeStr, ier)
          endif
          if (ier < 0) then
              ierr = ier
              return
          endif
          iTipo = 1
          call updSWRC(iTipo,file1,file2)
          if (ifFromShelx == 0) then
              call CheckStructCommand(file1,ier)
              call updRecentProjects()
          endif
          call shift(Titolo,iz)
          call SetWindowTitle(Titolo)
          ier = 0
          iFrom = 2
          call mainloop(iFrom,file1,file2,ier)
          if (jscreen.ne.0) then
              if (ifRunToolBar.eq.1) then
                  call RunToolBar(-1,' ')
              endif
          endif
          k = index(fname(1), '.bin')
          input_par%str3 = fname(1)(1:k-1) // char(0)
      else
          fname(15) = file2
          call GetBinV2(nomeStr,file1,file2)
      endif
      ierr = ier
!
      return
      end
!-----------------------------------------------------------------------
      subroutine draggapol(ix1,iy1,ix2,iy2,nCol1,nSegm)
!
      implicit none
      integer :: ix1(*), iy1(*), ix2(*), iy2(*), nCol1(*), nSegm
!
      call mrdraggapol (ix1,iy1,ix2,iy2,nCol1,nSegm)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine f_skip_or_stop (iCod)
      USE Molcom
!
      implicit none
      integer :: iCod
!
      ifBrekke = iCod
!
      return
      end

! ----------------------------------------------------------------------
      subroutine init_becca_punti (iCod)
      USE General, only : Message
      USE Molcom
!
! --- iQualeBecca = iCod = 1     Who
! ---                    = 2     Delete
! ---                    = 3     Relabel
! ---                    = 4     Renumber
! ---                    = 5     Add bonds
! ---                    = 6     Del bonds
! ---                    = 7     Move atoms
! ---                    = 8     Complete
! ---                    = 9     Regularize
! ---                    = 10    Tetrahedron (II parte)
! ---                    = 11    Add Atom
! ---                    = 12    Distances
! ---                    = 13    Angles
! ---                    = 14    Torsion angles
! ---                    = 15    Set restraints on distance
! ---                    = 16    Set restraints on angles
! ---                    = 17    Set restraints on plane
! ---                    = 18    Delete restraints on distance
! ---                    = 19    Delete restraints on angles
! ---                    = 20    Delete restraints on plane
! ---                    = 21    3-atoms Plane
! ---                    = 22    2-atoms vector
! ---                    = 23    Mouse click in LSQ
! ---                    = 24    Info in fourier
! ---                    = 25    Single Hydrogen
! ---                    = 26    Hydrogens Wizard
! ---                    = 30    Add Polyhedra
! ---                    = 31    Rename atoms
! ---                    = 32    Add Hydrogen bond
! ---                    = 33    Delete Hydrogen bond
! ---                    = 34    Reset Hydrogen bond
! ---                    = 35    Accept Fourier Hydrogen
! ---                    = 41    Modify site
! ---                    = 80    Select center of contour box
! ---                    = 110   Tetrahedron (I parte)
!
      integer iCod
!g    common /AtomType/ nTp, kCentral, xyzTmp(3,5)
!     common /LabeHyd/ nLabelHyd, LabelHyd(20), ifHydrobase
!
      Message = ' '
      nptr = 0
      iQualeBecca = iCod
      if (iQualeBecca.ne.12.and.
     *    iQualeBecca.ne.13.and.
     *    iQualeBecca.ne.14) then
          nptrc = 0
      endif
!
      if (iQualeBecca.eq.5.or.           ! add bonds
     *    iQualeBecca.eq.6.or.           ! del bonds
     *    iQualeBecca.eq.32.or.          ! hydrogen bonds
     *    iQualeBecca.eq.23) then        ! mouse click in LSQ
          nonDoppio = 0
      else
          nonDoppio = 1
      endif
      if (iQualeBecca.eq.25) then        ! mouse click in hydrogens
          call UpdateCommonAndList5(ier)
          call StringiLabel()
          iautoHy=0   
          call HydroBase(ierr)
          ifHydrobase = 1
      endif
      if (iQualeBecca.eq.26) then        ! hydrogens wizard
          call UpdateCommonAndList5(ier)
          call StringiLabel()
          iautoHy=0
          call HydroBase(ierr)
          iQualeBecca = 0
      endif

      ifPol = 0
      if (iQualeBecca.eq.30) then
**        call Poly0(1, 0)
      endif

!     write(*,*) 'Init_becca_punti - iQualeBecca = ',iQualeBecca
!
      return
      end

! ----------------------------------------------------------------------
      subroutine becca_punti (ix,iy, ier)
      USE General
      USE Atomi
      USE Molcom
!
      implicit none
      integer :: ix, iy, ier, j1, l1, Lung, IndividuaLab, Individua, kk
      character (len=80) :: TmpLab
!
      ier = 0
!
      if (ifPol.eq.0) then

          if (iQualeBecca.eq.40) then
              ier = IndividuaLab(ix, iy)
          else
              ier = Individua(ix, iy)
          endif
!
          if(ier.eq.-1) then
             return
          endif
!
          ier = kptr(1)
          if (iQualeBecca.eq.31) then
              j1 = kptr(1)
              l1 = Lung(Lab(j1))
              TmpLab = Lab(j1)
              It(1)(1:Lung(TmpLab)+1) = TmpLab(1:Lung(TmpLab))
     *                                // char(0)
              It(2) = char(0)
          elseif (iQualeBecca.eq.24) then
              RaggioSfera = 2.0
              call Distance(2)
              nptr = 0
          else if (iQualeBecca.eq.80) then
              j1 = kptr(1)
              l1 = Lung(Lab(j1))
              TmpLab = Lab(j1)
              l1 = iEqui(j1)
              if (TmpLab(1:1).ne.' ') then
                  write(Message,187) TmpLab,(xyzs(kk,l1), kk=1,3)
              else
                  write(Message,188) TmpLab,(xyzs(kk,l1), kk=1,3)
              endif
              do kk = 1, 3
                  write(It(kk),'(f6.3, a1)') xyzs(kk,l1), char(0)
              end do
              It(4) = char(0)
              nptr = 0
          else if (iQualeBecca.eq.50) then
              j1 = kptr(1)
              l1 = Lung(Lab(j1))
              TmpLab = Lab(j1)
              It(1)(1:Lung(TmpLab)+1) = TmpLab(1:Lung(TmpLab))
     *                                // char(0)
              write(It(2), '(i6, a)') j1, char(0)
              It(3) = char(0)
              nptr = 0
          endif
          call PrintMess(Message)
      else
          call GetPolygonV2(ix, iy)
      end if
!
      return
  187 format('Atom ', a,'(x,y,z)=(', 2(f6.3,','),f6.3,')')
  188 format('Peak #',a,'(x,y,z)=(', 2(f6.3,','),f6.3,')')
      end
! ----------------------------------------------------------------------
      subroutine finish_becca_punti (iExitCode)            !mr
      USE General
      USE Molcom
!
! --- iQualeBecca = iCod = 1     Who
! ---                    = 2     Delete
! ---                    = 3     Relabel
! ---                    = 4     Renumber
! ---                    = 5     Add bonds
! ---                    = 6     Del bonds
! ---                    = 7     Move atoms
! ---                    = 8     Complete
! ---                    = 9     Regularize
! ---                    = 10    Tetrahedron (II parte)
! ---                    = 11    Add Atom
! ---                    = 12    Distances
! ---                    = 13    Angles
! ---                    = 14    Torsion angles
! ---                    = 15    Set restraints on distance
! ---                    = 16    Set restraints on angles
! ---                    = 17    Set restraints on plane
! ---                    = 18    Delete restraints on distance
! ---                    = 19    Delete restraints on angles
! ---                    = 20    Delete restraints on plane
! ---                    = 21    3-atoms Plane
! ---                    = 22    2-atoms vector
! ---                    = 23    Mouse click in LSQ
! ---                    = 24    Info in fourier
! ---                    = 25    Single Hydrogen
! ---                    = 26    Hydrogens Wizard
! ---                    = 30    Add Polyhedra
! ---                    = 31    Rename atoms
! ---                    = 32    Add Hydrogen bond
! ---                    = 33    Delete Hydrogen bond
! ---                    = 34    Reset Hydrogen bond
! ---                    = 35    Accepy Fourier Hydrogen
! ---                    = 41    Modify site
! ---                    = 80    Select center of contour box
! ---                    = 110   Tetrahedron/Octahedron (I parte)
! ---                    = 210   Octahedron (II parte)
!
!g    common /AtomType/ nTp, kCentral, xyzTmp(3,5)
      character*80 stringa
!
      iExitCode = 0
      if (nptr > 0) then
          select case (iQualeBecca)
              case (1)
                  j1 = kptr(1)
                  call ManageWho(j1)
                  nptr = 0
              case (2)               ! Delete
                  call DelAt
                  ifChangedXYZ = 1
                  newkscrx = kscrx
                  newkscry = kscry
                  k = kridisegna(newkscrx,newkscry,0)
                  call AggiornaJav()
              case (3)              ! ReLabel
                  k = iopen_relabel()
                  if (k.ne.-1) then
                      call ReLabel(k)
                      ifChangedXYZ = 1
                      call Disegna(0)
                      call AggiornaJav()
                  endif
              case (4)                            ! ReNumber
                  stringa = ' ' // char(0)
                  k = iopen_renumber(stringa, len(stringa))
                  if (k.ne.-1) then
                      call ReNumber(k, stringa)
                      ifChangedXYZ = 1
                      call Disegna(0)
                      call AggiornaJav()
                  endif
              case (5,6)                          ! Add/Del Bonds
                  iAction = iQualeBecca - 4
                  ifHBond = 0
                  call AddDelBonds(iAction, NatInd, ifHBond)
              case (7)                            ! Move Atoms
                  iActMove = 2
                  call MoveAtoms(iActMove)
                  ifChangedXYZ = 1
                  nel = 0
                  call FindMinMax
                  call Disegna(ifScale)
                  call AggiornaJav()
                  if (iActMove.lt.0) then
                      iExitCode = -iActMove
                  endif
              case (8)                            ! Complete
                  if (nptr.ge.3.and.nptr.le.5) then
                      numRings = 6 - nptr
                      k =  new_rings(numRings)
                      if (k.gt.0) then
                          kbondl = k / 10
                          NumCase = mod(k,10)
                          bondl = float(kbondl) / 1000.
                          call NewAtomsV2(NumCase,bondl, iExitCode)
                          call Disegna(0)
                          call AggiornaJav()
                      endif
                  else
                      iExitCode = 2
                  end if
              case (9)                            ! Regularize
                  numRings = -1;
                  k =  new_rings(numRings)
                  kbondl = k / 10
                  bondl = float(kbondl) / 1000.
                  call Regular6(bondl)
                  ifChangedXYZ = 1
              case (10)                           ! Tetrahedron
                  ifFromGraphic = 1
                  call Tetrahedron(ifFromGraphic, ier)
              case (11)                           ! Add Atom
                  call AddOneAtomNew
              case (12)                            ! Distances
                  call Distance(1)
              case (13)                            ! Angles
                  call CalcAngle(1,AngDummy)
              case (14)                            ! Torsion Angles
                  call TorsAngle
              case (21)                            ! 3-atoms Plane
                  ival = 0
                  iAction = 25
                  call Vista(iAction,ival)
              case (22)                            ! 2-atoms Vector
                  if (nUltRot.eq.4) then              !mr1707
                      call RestoreBaric(iActive)      !mr1707
                      nUltRot = 0                     !mr1707
                  end if                              !mr1707
                  kptr( 99) = kptr(1)
                  kptr(100) = kptr(2)
              case (23,25,30)                   ! Mouse click in ...
                  nTp = 0
                  kptrc = 0
                  if (nptr .gt. 0) then
                      do i=1, nptr
                         kptrc(i) = kptr(i)
                      enddo
                      nptr = 0
                  endif
              case (32,33)                   ! Hydrogen bonds
                  iAction = iQualeBecca - 31
                  ifHBond = 1
                  call AddDelBonds(iAction, NatInd, ifHBond)
              case (35)                      ! Fourier Hydrogens
                  idrogeno = 1
                  call ReLabel(idrogeno)
                  ifChangedXYZ = 1
                  call Disegna(0)
              case (41)
                  j1 = kptr(1)
                  call ManageModifySite(j1)
                  nptr = 0
              case (110)                  ! Tetrahedron/Octahedron (central at)
                  kCentral = kptr(nptr)
              case (210)                           ! Octahedron
                  ifFromGraphic = 1
                  call Octahedron(ifFromGraphic, ier)

          end select
      else
          if (iQualeBecca.eq.80) then                  ! (center in Contour)
!              write(0, *)'selected center'
          else if (iQualeBecca.ne.1) then
              iExitCode = 5
          endif
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine init_polygon (iCod)
      USE Molcom
!
      integer iCod
! --- iQualePolyg = iCod = 1     Delete
! ---                    = 2     Hide
! ---                    = 3     Display
! ---                    = 4     Show all
! ---                    = 5     Change color
! ---                    = 7     Move atoms
! ---                    = 8     Polygon in LSQ
! ---
!
      iQualePolyg = iCod
      nel = 0
      ifPol = 1
      if (iQualePolyg ==7) then
          call UpdateCommonAndList5(ier)
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine GetPolygonV2(ix, iy)
      USE Molcom
!
      integer ix
      integer iy
! ---
      nel = nel + 1
      ixp(nel) = ix
      iyp(nel) = iy
      if (nel.gt.1) then
         call Linea_dash(ix, iy, ixPol, iyPol, icoWire)
      else
         call Linea_dash(ix, iy, ix, iy, icoWire)
      end if
      call zflush            !mr1701
      ixPol = ix
      iyPol = iy
!
      return
      end
! ----------------------------------------------------------------------
      subroutine finish_polygon(ier)
      USE Molcom
!
! --- iQualePolyg = 1     Delete
! ---             = 2     Hide
! ---             = 3     Display
! ---             = 4     Show all
! ---             = 5     Change color
! ---             = 7     Move Atoms
! ---             = 8     Polygon in LSQ
! ---
! ---
!
      ier = 0
      if (iQualePolyg.eq.4) then
          call DelHide(iQualePolyg)
          if (ifScale.ne.0) then
              call FindMinMax
          end if
          call Disegna(ifScale)
      elseif (nel.ge.3) then
          ixp(nel+1) = ixp(1)             ! Close Polygon
          iyp(nel+1) = iyp(1)
          ixp(nel+2) = -1
          iyp(nel+2) = -1
          if (iQualePolyg.eq.7) then
              iActMove = 1
              call MoveAtoms(iActMove)
              if (iActMove.lt.0) then
                  ier = -iActMove
                  call Disegna(0)
              endif
              return
          else if (iQualePolyg.eq.5) then
              call DelHide(iQualePolyg)
          else if (iQualePolyg.eq.8) then
              call SelectLSQ()
              kptrc = 0
              do i=1,nptr
                 kptrc(i) = kptr(i)
              enddo
              nptr = 0
          else
              call DelHide(iQualePolyg)
          endif
          if (ifScale.ne.0) then
              call FindMinMax
          end if
          call Disegna(ifScale)
      else                                                ! No Polygon
          ier = 6
          call Disegna(0)
      end if
      iQualePolyg = 0
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SelectLSQ()
      USE General
      USE Atomi
      USE Molcom
!
!-- in kptr(..) ci sono i num. seq. degli atomi selezionati
!
      do i = 1, 99
         if (ixp(i).lt.0) then
             exit
         endif
      enddo
   20 nvpol = i - 1
      n = 1
   21 n = n + 1
      if (ixp(n).eq.ixp(n - 1) .AND. iyp(n).eq.iyp(n - 1)) then
         do i = n, nvpol - 1
            ixp(i) = ixp(i + 1)
            iyp(i) = iyp(i + 1)
         enddo
         nvpol = nvpol - 1
         n = n - 1
      end if
      if (n.lt.nvpol) goto 21
   23 icont = 0
      if (nvPol.lt.4) then
         Msg = 'Errore in SelectLSQ'
         call MsgWinErr('Error',Msg, SEVERE_ERR_WINDOW, nEx)
      end if
      do i = 1, nvpol - 2
         do j = i + 1, nvpol - 1
            if (IABS(iyp(i) - iyp(j)) .le. 2) then
               iyp(j) = iyp(j) - 1
               icont = -1
            end if
         enddo
      enddo
      if (icont .ne. 0) goto 23
! ---
      nptr = 0
      do III = NatMol + NatSpi, 1 , -1
         IJ = iOrd(III)
         if (IJ .LE. NatMol. AND. RS(IJ). GT. 0) then
             ix = ipix(1,IJ)
             iy = ipix(2,IJ)
             in = Interno(ix, iy, nvpol)
             inn = Interno(ix, iy - 1, nvpol)
             if (in.eq.-2 .or. inn.eq.-2) then
                nptr = nptr + 1
                kptr(nptr) = IJ
             end if
         end if
      enddo
!
      return
   70 format(a5,2x,a8)
      end
!-----------------------------------------------------------------------
      subroutine finish_disegnarettangolo(ix0,iy0,iw,ih)
      USE Molcom
!
      integer ix0,iy0,iw,ih
!
      ixp(1) = ix0
      iyp(1) = iy0
      ixp(2) = ix0 + iw - 1
      iyp(2) = iy0
      ixp(3) = ix0 + iw - 1
      iyp(3) = iy0 + ih - 1
      ixp(4) = ix0
      iyp(4) = iy0 + ih - 1
      nel = 4
      iQualePolyg = 3
      call finish_polygon(ier)
!
      return
      end
! -----------------------------------------------------------------
      subroutine undelete()
      USE General
      USE Atomi
      USE Molcom
!
      character*80 stringa
!
      NumCan = 0
      nzsav(:) = 0
      do ii=1, NatMol
         if (RS(ii) .lt. -10.0) then
             NumCan = NumCan + 1
             i = iEqui(ii)
             L = Lung(Lab(i))
             Labb = Lab(i)
             It(NumCan) = Labb(1:Lung(Labb)) // char(0)
         endif
      enddo
      if (NumCan > 0) then
          iActLis = 1
          iMultiSel = 1
          It(NumCan) = It(NumCan)(1:(Lung(It(NumCan))-1)) // char(0)
          Msg='Select atoms to undelete'
          Inte = 'Atoms deleted'
          nnn = NatMol
          call PeekList (Inte,iActLis,nzsav,nnn,NumUnDel,iExCode,
     *                   iMultiSel)
          if(iExCode.ne.3) then
             do i=1, NumUnDel
                k = nzsav(i)
                do jj=1, NatMol
                   KK = nint(RSCOPY(jj))
                   if (KK == k) then
                       RS(jj) = -(RS(jj) + 10.)
                   endif
                enddo
                do j=1, NumLeg - nlp
                   k = nzsav(i)
                   do jj=1, NatMol
                      KK = nint(RSCOPY(jj))
                      if (KK == k) then
                          if (LE(1, j) == jj .or.
     *                        LE(2, j) == jj) then
                              if (LE(3,j).lt.-10.0) then
                                  LE(3, j) = -(10 + LE(3,j))
                              end if
                          endif
                      endif
                   enddo
                end do

             enddo
             call Disegna(ifScale)
          endif
      else
          Msg = 'No atoms to undelete !!!'
          call MsgWinErr('Undelete', Msg, WARN_WINDOW, nExitCode)
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine apri_toolbar (stringa)
      USE General
!
      character *(*) stringa
!
      character *5 QualeToolbar
!
      QualeToolbar(1:4) = stringa(1:4)
      QualeToolbar(5:5) = char(0)
      call c_open_toolbar(QualeToolbar)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine open_lsq()
      USE Atomi
      USE Molcom
      USE LsqModule
      USE LsqStuff    !! mr
!
      call c_open_lsq(It, nats, ifGroupRefined)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine finish_restraints(iExitC, numItems)
      USE General
      USE Molcom
      USE LsqModule
      USE LsqStuff
!
      integer iExitC
      integer numItems
!
!   iexitC = 0 (Cancel); = 1 (OK)
c
c             nres         = number of restraints
c             vres         = array containing restraints
c
c   restraint code         = 1 DISTANCE
c                            2 ANGLE
c                            3 TORSION
c                            4 PLANE
c                            5 SUM
c                            6 LIMIT
c                            7 SITE
c                            8 DISORDER
c
c   vres(jp)               = restraint code
c   vres(jp+1)             = number of atoms involved
c                          0 = tutti gli atomi    if SUM & LIMIT
c   vres(jp+2.....)        = atoms codes          if SITE
c   vres(jp+2)             = sigma
c                            sigma(x)             if LIMIT
c   vres(jp+3)             = distance             if DISTANCE
c                            angle                if ANGLE
c                            angle                if TORSION
c                            zero                 if PLANE
c                            number of parameters if SUM
c                            sigma(B)             if LIMIT
c
c   vres(jp+4)             = sigma(bij)           if LIMIT
c   vres(jp+4....)       = parameters codes only  if SUM
c   vres(jp+4[+params]....)= atoms codes          if DIST, ANGLE, PLANE, SUM, SITE
c   vres(jp+5....)       = atoms codes            if LIMIT
c

!
      if (iExitC.eq.1) then
          ifChangedRestraints = 0
          if (nresGTK.ne.nresSav) then
              ifChangedRestraints = 1
          else
              do i=1, numItems
                 if (vresGTK(i).ne.vresSav(i)) then
                     ifChangedRestraints = 1
                     exit
                 endif
              enddo
          endif
          if (ifChangedRestraints.eq.1) then
!--ricreo le direttive di refinement
c              call DefaultRefi(2,ier)
c              if (ier.lt.0) then
c                  write(lo,*)' Error(a) subroutine finish_restraints!'
c                  return
c              endif
c              call OutRestraintFrom12(ier)
              if (nresGTK.gt.0) then
                  kstampa = 0      ! trasferisce da GTK a standard enviroment
                  call BackFromGTK(kstampa)
c                  call PrintRestraint(-1)
c                  call InRestraintTo12(ierx)
c                  call PrintRefi(lo)
              endif
c              if (NumGroup.gt.0) then
c                  call InGroupTo12MNQD(ier)
c              endif
          endif
      else
          nres = nresSav
          vres = vresSav
      endif
!     if (numitems.gt.0) then
!         write(lo,'(8(i3,f5.1,2x))') (i,vres(i),i=1,numitems)
!     endif
      ifDrRes = ifDrResSav
      call Disegna(0)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine finish_dlsq(iExitC, dampf, ncicl)
      USE General
      USE Molcom
      USE PhaseModule
      USE LsqModule
!
      integer iExitC
      integer ncicl
      real dampf
!
!     iexitC = 0 (Cancel); = 1 (OK)
!--
      if (iexitC.eq.0) return
      LsqCF = 2
      nCycles=ncicl
      Dampi=dampf
      if (nCycles.gt.11) then
          nCycles= 11
      endif
c--controllo se ci sono restraints
c      write(lo,*)' nres=',nres
      if (nres.gt.0) then
c--chiamata alla routine dell'affinamento
          iref=1
          ide=2
          call Mnqdmain(idi,ier,iref)       !  nuovo MNQD
          if (ier.ge.0) then
              rfac = errem / 100.0
              write(Msg,"(' R = ',f6.2,'%')") rfac
              call scrper(Msg,0,-1)
          endif
      endif
!----------------------------------------------------
      interp = 1                        ! RS 08/07/11
      call PutGetXyzs(1, interp)        
!
      call PutModel
!----------------------------------------------------
      iPlt = iPlotType
      ifSingle = 1
      call MolPlo(iPlt, ifSingle)
!
      ifFromLSQ = 1
      call ThFacTooBig(ifFromLSQ)
!
      return
      end
!-----------------------------------------------------------------------
      integer function restart(valori, blocchi, iAction)
      USE General
      USE Symmetry
      USE Molcom
      USE PhaseModule
      USE Riflessi, only : iphaz
!
      real valori(*)
      integer blocchi(*)
      integer iAction, sommaFasi
      dimension fig(11)
      integer trial
      character*10 Patt_or_Tang
!
      ier = 0
      lfw = InfoOK(17)
      no17 = 0
      if (lfw.gt.0) then
          call AllocaRiflessi(1)
          ksubr = 3
          call LeggiRiflessi(ier, ksubr)
          call LoadFinalPhases(FomsFineDSR, iposFineDSR,
     *                         nsetFinalPhases)
          if (nSetsFineDSR <= 0 .or. ier < 0) then
              no17 = 1
          else
              do i=1, nSetsFineDSR
                 nset = iposFineDSR(i)
                 call PutGetFinalPhases(2, nset, fig)
                 OldTRialsForDLSQ(i,1:11) = fig(1:11)
              enddo
          endif
      else
          no17 = 1
      endif
      if (no17.eq.1) then
          sommaFasi = sum(iabs(iphaz(1:nrefl)))
          if (sommaFasi == 0) then
              write(Msg,11)
              call MsgWinErr('Error',Msg,ERR_WINDOW,iex)
          endif
          ier = -1
      else
          rSoglia = 25
          if (anat.lt.5) then
              anatLSQ = 7
          else
              anatLSQ = float(nint(anat * 1.2))
          endif
          if (ifNegativePeaks == 1) then
              anat = sum(nw(1:nk))
              anat=anat / (pts*float((icent+1)*nsym))
          endif
          ObsPar = float(numbLSQ) / ( 4.0 * anatLSQ )
          Valori(1) = ObsPar
          SmallIt = ' '
          do i=1, nSetsFineDSR
             trial = nint(OldTRialsForDLSQ(i,1))
             eFom = OldTRialsForDLSQ(i,2)
             fFom = OldTRialsForDLSQ(i,3)
             kPat = nint(OldTRialsForDLSQ(i,7))
             if (kPat == 1) then
                 Patt_or_Tang = ' Patterson'
             elseif (kPat == 2) then
                 Patt_or_Tang = '   Tangent'
             elseif (kPat == 3) then
                 Patt_or_Tang = '    Remo'
             elseif (kPat == 0) then
                 Patt_or_Tang = '    VLD '
             endif
             write(SmallIt(i),12) trial, Patt_or_Tang,
     *                       eFom, fFom, char(0)
          enddo
          SmallIt(nSetsFineDSR+1) = char(0)
          Valori(6) = nBlocksPh ! numero di blocchi di default
          Valori(7) = 10        ! numero massimo di blocchi
          Valori(8) = ifRelax
          j = 0
          do i=1,nBlocksPh
             blocchi(j+1) = jBlocksPh(1,i)
             blocchi(j+2) = jBlocksPh(2,i)
             j = j + 2
          enddo
          if (iAction == 1) then
              Valori(10) = nint( anat * 1.1 )
          else if (iAction == 5) then
              Valori(9) = 1               ! default trial number
              Valori(10) = 9999           ! max trial number
              call ControllaAtomiPesanti(NumPeso)
!!!!!         ifPatt = 0
!
              Valori(6) = 1   ! in caso disperato corrisponde a MDM
              if (ifMDM == 1) then
                  Valori(6) = 1
              elseif (ifTang == 1) then
                  Valori(6) = 2
              elseif (ifMDM == 0 .and. ifVLD == 1) then
                  Valori(6) = 3
              elseif (ifPatt /= 0) then
                  Valori(6) = 4
              endif
!
              if (ksize > 3) then
                  nolsq = 0
                  if (iwei > 0) then
                      if (ksize < 6 ) then
                          ifPatt = 1
                      else
                          if (resm < ResSogLow .or. iheavy > 0) then
                              ifPatt = 1
                          endif
                      endif
                  endif
              else
                  nolsq = -1
              endif
!!mr          Valori(6) = 1
              Valori(7) = -1
          else
              Valori(5)  = nSetsFineDSR
              Valori(10) = rSoglia
          endif
      endif
!
      restart = ier
!
      return
   11 format('No phases stored, sorry.')
   12 format(i5,a,' ',f9.2,' ',f9.2,a9,a)
      end
! ----------------------------------------------------------------------
      subroutine esporta(iCod, iAction, nomeStr)
      USE General
      USE Molcom
      USE Atomi, only : nats, jSingleColor
      USE PhaseModule, only : itria
!
      implicit none
      integer :: iCod, iAction, ier, nomel, kcompl, ifBW, istereo
      integer :: lstring, itype, iform, jop, ifSave, ifSave2
      integer :: Lung, jopen, numbPDB, ifFast, ifREM, k
      integer :: kStripTask1, kk, k1
      character (len=256) :: wd
      character (len= 80) :: filename, filename2
      character (len= *)  :: nomeStr
      character (len= 10) :: formato
      character (len=  4) :: estensione(2)
      character (len=  8) :: a8
!
!   iCod =  1 Shelx
!   iCod =  2 Crystals
!   iCod =  3 Xtal
!   iCod =  4 CCP4
!   iCod =  5 PDB
!   iCod =  6 Caos
!   iCod =  7 PostScript
!   iCod =  9 Schakal
!   iCod = 10 Moldraw
!   iCod = 11 XYZ
!   iCod = 12 PovRay
!   iCod = 13 CIF
!   iCod = 14 Z-Matrix
!
!   PostScript & HPGL
!      iAction = 1    preview only
!      iAction = 2    file only
!      iAction = 3    preview & file
!   C.I.F.
!      iAction = 2    coordinates and reflection files
!      iAction = 3    coordinates only
!
      ier = 0
*     if (iCod.ne.7.and.iCod.ne.8.and.iCod.ne.12) then
      if (nats > 0) then
          call UpdateCommonAndList5(ier)
      endif
!
      if (knw == 1) then
          call AllocaTestStuff(1)
      endif
      nomel = index(fname(1),'.bin')
      filename = fname(1)(1:nomel) // 'ins'
      select case (iCod)
             case(1)
                  formato = 'Shelx'
                  estensione(1) = 'res'
             case(2)
                  formato = 'Crystals'
                  estensione(1) = 'cry'
                  kcompl = 0
             case(3)
                  formato = 'Xtal'
                  estensione(1) = 'map'
                  estensione(2) = 'phs'
             case(4)
                  formato = 'CCP4'
                  estensione(1) = 'map'
                  estensione(2) = 'phs'
             case(5)
                  formato = 'PDB'
                  estensione(1) = 'pdb'
             case(6)
                 formato = 'Caos'
                 estensione(1) = 'fil'
             case(7)
                  formato = 'Postscript'
                  estensione(1) = 'ps'
                  ifBW = mod(iAction,10)
                  istereo = mod(ifBW, 2)
                  ifBW = ifBW / 2
                  iAction = iAction / 10
             case(8)
                  formato = 'HPGL'
                  estensione(1) = 'hpgl'
                  ifBW = mod(iAction,10)
                  istereo = mod(ifBW, 2)
                  ifBW = ifBW / 2
                  iAction = iAction / 10
             case(9)
                  formato = 'Schakal'
                  estensione(1) = 'sch'
             case(10)
                  formato = 'Moldraw'
                  estensione(1) = 'mol'
             case(11)
                  formato = 'XYZ'
                  estensione(1) = 'xyz'
             case(12)
                  formato = 'PovRay'
                  estensione(1) = 'pov'
             case(13)
                  formato = 'C.I.F'
                  estensione(1) = 'cif'
             case(14)
                  formato = 'Z-matrix'
                  estensione(1) = 'fhz'
      end select
!
      call fGetPWD(wd,lstring,ier)
      if (iCod.eq.13) then
          filename = fname(1)(1:nomel) // estensione(1)
          call SalvaConNome(filename, estensione(1), ifSave)
          if (ifSave == 0) then
              close(jrel)
              call ClearMessage()
              return
          endif
          itype = 0
          iform = 1
          jop = jopen(jhost,filename,itype,iform,ier)
          if (jop.lt.0) then
              go to 9000
          endif
      else if (iCod.ne.3.and.iCod.ne.4) then
          filename = fname(1)(1:nomel) // estensione(1)
!
          call SalvaConNome(filename, estensione(1), ifSave)
          if (ifSave == 0) then
              close(jrel)
              call ClearMessage()
              return
          endif
!
          itype = 0
          iform = 1
          if (iAction.gt.1) then
              jop = jopen(jhost,filename,itype,iform,ier)
              if (jop.lt.0) then
                  go to 9000
              endif
              Msg = ' The file ' // filename(1:Lung(filename)) //
     *              ' has been written in ' // formato(1:Lung(formato))
     *           // ' format.'
          endif
      else
          k = index(fname(1),'.bin')
          kk = kStripTask1(k)
          write(a8,"('_',i4)") itria
          call NoBlanks(a8,k1)
          if (iCod == 3 .or . iCod == 4) then
              filename = fname(1)(1:kk-1) // a8(1:k1) // '_' //
     *                   formato(1:Lung(formato)) // '.' // 
     *                   estensione(1)
              call SalvaConNome(filename, estensione(1), ifSave)
              if (ifSave == 0) then
                  close(jrel)
                  call ClearMessage()
                  return
              endif
          endif
          
          if (iCod == 3) then
              filename2 = fname(1)(1:kk-1) // a8(1:k1) // '_' //
     *                    formato(1:Lung(formato)) // '.' // 
     *                    estensione(2)
              call SalvaConNome(filename2, estensione(2), ifSave2)
              if (ifSave2 == 0) then
                  close(jrel)
                  call ClearMessage()
                  return
              endif
          endif
!
          if (iCod == 4) then
              Msg = ' The file ' // filename(1:Lung(filename)) //
     *              ' has been written in ' // formato(1:Lung(formato))
     *              // ' format.'
          endif
          if (iCod == 3) then
              itype = 0
              iform = 2
              jop = jopen(jhost,filename,itype,iform,ier)
              if (jop.lt.0) then
                  go to 9000
              endif
              itype = 0
              iform = 1
              jop = jopen(jrel,filename2,itype,iform,ier)
              if (jop.lt.0) then
                  go to 9000
              endif
              Msg = ' The files ' // filename(1:Lung(filename)) //
     *              ' and ' // filename2(1:Lung(filename2)) //
     *              ' have been written in ' // formato(1:Lung(formato))
     *              // ' format.'
          endif
      endif
!
      nomeStr = filename(1:Lung(filename)) // char(0)
      select case (iCod)
             case(1)
                  call outShelx(0)
             case(2)
                  kcompl = 0
                  call outcry(kcompl)
             case(3)
                  call outXtal_CCP4(1, filename, filename2) ! Xtal
             case(4)
                  call outXtal_CCP4(2, filename, filename2) ! CCP4
             case(5)
                  numbPDB = -1
                  ifFast = 0
                  ifREM = 0
                  call outPDB(jhost, numbPDB, ifFast, ifREM, 0)
             case(6)
                  call Dump_Caos(jhost)
             case(7, 8)
                  ifPlotting = 1
                  if (ifBW == 1) then
                      jSingleColor(1:NatMol) = color_BLACK
                  else
                      jSingleColor(1:NatMol) = iCol(1:NatMol)
                  endif
                  if (iAction.eq.1) then           !solo preview
                      call NewGraph(10+iCod-6, istereo)
                  elseif (iAction == 2) then       !solo file
                      call NewGraph(iCod-6, istereo)
                  else                             !preview & file
                      call NewGraph(20+iCod-6, istereo)
                  endif
                  if (ifBW == 1) then
                      jSingleColor(1:NatMol) = iCol(1:NatMol)
                  endif
                  ifPlotting = 0
             case(9)
                  call outsha
             case(10)
                  call outmold
             case(11)
                  call outxyz
             case(12)
                  QualeEllisse = iAction - 1
                  call PovRay
             case(13)
                  call outCif(iAction)
          Msg = ' The file ' // filename(1:Lung(filename)) //
     *          ' has been written in ' // formato(1:Lung(formato)) //
     *          ' format.'
             case(14)
                  k = min0(index(fname(1),'.')-1, 4)
                  cardImage= ' '
                  cardImage(1:4) = fname(1)(1:k)
                  call ucase(cardImage(1:4))
!gl!              write(cardImage(5:),'(20a4)') itle
                  cardImage(5:) = Titolo
                  call outzmatNEW(ier)
!                  call AggiungiGruppo()
!                  call CancellaGruppo('Tyrosine')
      end select
!
      if (iAction > 1 .or. iCod == 3 .or. iCod == 4) then
          call OpenWarning(Msg)
      endif
!
      if (iCod == 3 .or. iCod == 13) then
          if (iCod == 3) then
              close(jhost)
          endif
          close(jrel)
      endif
!
      call ClearMessage()
!
      return
!
 9000 write(lo,9010) ier,filename(1:Lung(filename))
      return
 9010 format(' *** error ***  open error, code =',i5,' file is ',a)
      end
! ----------------------------------------------------------------------
      subroutine SymmOnOff(nAdd)
      USE Molcom
!
      implicit none
      integer :: ifDentro, iZero, kbuild, nAdd, ifContSav, iAction
!
      iAction = 1
      call ClessidraOnOff(iAction)
!
      ifContSav = ifCont               !mrmrmr
      nAdd = 0                         ! gianluca 16/9/2009

      if (ifCont == 0) then
         call SoloInd(NatInd)
         call ClearMessage()
      else
         call SoloInd(NatInd)   
         NATind = NatMol
         ifDentro = 1
         iZero = 0
         kbuild = 0
         call GeneraAppSym(ifDentro, iZero, kbuild, nAdd)
      end if
!
      if (nAdd >= 0) then                   ! gianluca 16/9/2009
          ifCont = ifContSav                !mrmrmr
      endif
!
      iAction = 2
      call ClessidraOnOff(iAction)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine plot_opt(iAction,iAct)
      USE Molcom
!
      integer iAction
!

      common /SalvaPlotOpt/ ifCellB, ifContB, ifScaleB, ifGhostB,
     *        ifDrResB, ifDrHydrB, ifPerspB, ViewDistB, ifDrHBondB
      integer iAct(20)

      if (iAction.eq.1) then
!mr         ifCellB  = ifCell
         ifContB  = ifCont
         ifScaleB = ifScale
         ifGhostB = ifGhost
         ifDrResB = ifDrRes
         ifDrHydrB= ifDrHydr
         ifDrHBondB= ifDrHBond
         ifPerspB = ifPersp
         if (ViewDist.gt.2.e7) then
             ViewDist = 2.e7
         end if
         ViewDistB= ViewDist

!mr         iAct(1) = ifCell
         iAct(1) = ifCont
         iAct(2) = ifScale
         iAct(3) = ifGhost
         iAct(4) = ifDrRes
         iAct(5) = ifDrHydr
         iAct(6) = ifDrHBond
         iAct(7) = ifPersp
         iAct(8) = int(ViewDist*10)
         iAct(9) = nCell(1)
         iAct(10) = nCell(2)
         iAct(11) = nCell(3)
         iAct(12) = int(DeA(1)*100)
         iAct(13) = int(DeA(2)*100)
         iAct(14) = int(DeA(3)*100)
         iAct(15) = 1
         iAct(16) = 1
         iAct(17) = 1
         iAct(18) = int(DeADef(1)*100)
         iAct(19) = int(DeADef(2)*100)
         iAct(20) = int(DeADef(3)*100)

      else
!mr         ifCell  = iAct(1)
         ifCont  = iAct(1)
         ifScale = iAct(2)
         ifGhost = iAct(3)
         ifDrRes = iAct(4)
         ifDrHydr= iAct(5)
         ifDrHBond= iAct(6)
         ifPersp = iAct(7)
         ViewDist = iAct(8) / 10.0
         nCell(1) = iAct(9)
         nCell(2) = iAct(10)
         nCell(3) = iAct(11)
         DeA(1) = iAct(12) / 100.
         DeA(2) = iAct(13) / 100.
         DeA(3) = iAct(14) / 100.
         ok = 0
!mr         if (ifCell .ne. ifCellB) ok = 1
         if (ifPersp .eq. 0) then
            ViewDist = 2.e7
         end if
         if (ifPersp .ne. ifPerspB) then
            ok = 1
         end if
         if (ViewDist .ne. ViewDistB) ok = 1
         if (ifGhost .ne. ifGhostB) ok = 1
         if (ifDrHydr .ne. ifDrHydrB) ok = 1
         if (ifDrHBond .ne. ifDrHBondB) ok = 1
         if (ifDrRes .ne. ifDrResB) ok = 1
         if (ifCont - ifContB .eq. -1) then
            call SoloInd(NatInd)
            ok = 1
         end if
         if (ifCont .eq. 1) then
               call SoloInd(NatInd)
               NATind = NatMol
               ifDentro = 1
               iZero = 0
               kbuild=0
!               call Genera(ifDentro, iZero)
               call GeneraAppSym(ifDentro, iZero, kbuild, nadd)
               ok = 1
               ifCont = 1
         end if
         if (ifScale - ifScaleB .eq. 1) then
            ok = 1
            call SetScale(0)
         end if
         if (ok .eq. 1) then
            call FindMinMax
            call Disegna(ifScale)
         end if
      end if

      return
      end
! ----------------------------------------------------------------------
      subroutine BrowserV2(kBro)
      USE General
      USE Symmetry
      USE Molcom
      USE LsqModule
      USE LsqStuff
      USE LsqGroupsStuff
      USE LsqStuff22Abs
!
      integer kBro
!
      character*80 filename
      logical Esiste
!
      l = Lung(fname(15))
      if (l == 0) then
          Msg = 'No information available at the moment, try later.'
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
      if (kBro /= 3 .and. kBro /= 6) then
          if (nrefl == 0) then
              Msg = 'No LSQ info available: reflections needed.'
              call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
              ier = -1
              return
          endif
      endif
!
      ier = 0
      filename = 'tmp.tmp'
      istat = 0
      iform = 1
      if (kBro == 1) then
          jop=jopen(jrel,filename,istat,iform,ierr)
      else
          jop=jopen(iscra,filename,istat,iform,ierr)
      endif
!
      select case (kBro)

         case (1)
              k = index(fname(1),'.bin')
              Msg = fname(1)(1:k-1) // '.log'
              Inte = 'Summary (file ' // Msg(1:k+3) // ')'
              inquire (file=Msg,  exist = Esiste)
              if (Esiste) then
                  call CopyLog(jrel)
              else
                  if (kmad == 0) then
                     call AbInfo(0)
                     Msg = fname(1)(1:k-1) // '.log'
                     call CopyLog(jrel)
                  else
                     call MADInfo(-1)
                  end if
              endif
         case (2)
              Msg = 'Results on Geometric Calculations'
              call MsgWinErr('Error',Msg,ERR_WINDOW,iex)
         case (3)
              Inte = 'List of Atoms'
              call AtomTable()
         case (4)
              Inte = 'Refinement conditions and atoms info'
                  call UpdateCommonAndList5(ier)
                  jgraf=1
                  iref=0
                  Num_Riflessi=0
                  jCode_Peso=0
                  call StartMNQD(jgraf,iref, Num_Riflessi, jCode_Peso)
c--number of partial derivatives per parameter (1,2 or 4)
                  NumDerParz=(2-icent)
!--definisco dimensioni e alloco vettori per Eq. Normali      
                  call MappaEqNor(ierM)
                  call MNQDStampaRefCond(erres)
                  call MNQDStampaAtCond
                  if (InfoOK(5) == 1 .and. NumGroup > 0) then
                      call PrintGroup(iscra)
                  endif
         case (5)
              write(Inte,"('Viewing printer output file : ',a)")
     *              fname(15)(1:Lung(fname(15)))
              call StampaOutput(ier)
         case (6)
              Inte = 'Tables'
              call MoveTables(ier)
              if (ier.lt.0) then
                  ier = 0
                  Msg = 'No tables are possible !!!'
                  call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
              endif
         case (7)
              Inte = 'Show reflections'
              call MoveTables(ier)
              if (ier.lt.0) then
                  ier = 0
                  Msg = 'Problems showing reflections !!!'
                  call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
              endif
         case (8,9)
              iAction = kBro - 7
                  call ShortLongDistancesNEW(iAction)
         case (10)
              Inte = 'Coordinates of the model'
              call StampaModello()
      end select
! ---
      if (kBro == 1) then
         close(jrel)
      else
         close(iscra)
      endif
! ---
      if (ier == 0) then
          if (kBro.eq.5) then
              iTipo = 4
          else
              iTipo = 1
          endif
!
!mr150606          call Dialogo (Inte, filename, iTipo)
          call CDialogo (Inte, filename, kBro)
      endif
      ier = 0
!
      return
      end
! -----------------------------------------------------------------
      subroutine rotbymousev2(ix,iy,iQualeBottone)
      USE Molcom
!
!mrchange
      integer ix
      integer iy
      integer iQualeBottone
!endmrchange
!
! --- iQualeBottone =  1    bottone di sinistra del mouse
!                   =  2    bottone di destra del mouse
!                   = 11    SHIFT + bottone di sinistra del mouse
!                   = 12    SHIFT + bottone di destra del mouse
!
      common /SaveRbyM/ ifDragged, B(3,3), iDxV, iDyV,
     *                  ifLabelsDrag, iPlotTypeDrag
      common /RotMou/ iAnchorX, iAnchorY, IfDrag, IcanDrag, iDragEnabled
     *               ,mEv_fsBtn
      common /anglv/ AngoloV,iPlotTypeB,ifLabelsB
      integer AngoloV
! ---
      if (ifDragged.eq.0) then
          mEv_fsBtn = mod(iQualeBottone,10)
          ifLabelsDrag  = ifLabels
          iPlotTypeDrag = iPlotType
          ifLabels      = 0
!         if (iPlotType.eq.VAN_DER_WAALS) then
              iPlotType     = STICKS     ! 19 gennaio forse si puo' draggare
!         endif                          ! con tutti i plot styles tranne...
          do i=1,3
             do j=1,3
                B(i,j) = 0
             enddo
             B(i,i) = 1
          enddo
          iAnchorX = ix
          iAnchorY = iy
          iDxV = 0
          iDyV = 0
          AngoloV = 0
      endif
      if (iQualeBottone.lt.10) then
*         call RotByMouse(ix, iy, ifDragged, B, iDxV, iDyV)
          call RotByMouse(ix, iy)
      else
*         call TraByMouse(ix, iy, ifDragged,    iDxV, iDyV)
          call TraByMouse(ix, iy)
      endif
! ---
      return
      end
! -----------------------------------------------------------------
*     subroutine TraByMouse(ix, iy, ifDragged,    iDxV, iDyV)
      subroutine TraByMouse(ix, iy)
      USE Molcom
!
      common /SaveRbyM/ ifDragged, B(3,3), iDxV, iDyV,
     *                  ifLabelsDrag, iPlotTypeDrag
      common /RotMou/ iAnchorX, iAnchorY, IfDrag, IcanDrag, iDragEnabled
     *               ,mEv_fsBtn
      common /anglv/ AngoloV,iPlotTypeB,ifLabelsB
!
      iDx = ix - iAnchorX
      iDy = iy - iAnchorY
      iAnchorX = ix
      iAnchorY = iy
      ifDragged = 1
      ifScale = 0
      if (iDx.ne.0 .or. iDy.ne.0) then
          if (iDx.lt.0) then
              Perc = 100*abs(float(iDx)/kscrx)
              call Translate(1,Perc)
          end if
          if (iDx.gt.0) then
              Perc = 100*float(iDx)/kscrx
              call Translate(2,Perc)
          end if
          if (iDy.gt.0) then
              Perc2 = 100*float(iDy)/kscry
              if (mEv_fsBtn.eq.1) then
                  call Translate(3,Perc2)
              else
                  call Translate(5,Perc2)
              end if
          end if
          if (iDy.lt.0) then
              Perc2 = 100*abs(float(iDy)/kscry)
              if (mEv_fsBtn.eq.1) then
                  call Translate(4,Perc2)
              else
                  call Translate(6,Perc2)
              end if
          end if
          Angolo = 0
          call Disegna(0)
      end if
! ---
      return
      end
! -----------------------------------------------------------------
      subroutine stopdragv2(iAction)
      USE Molcom
!
      integer iAction
!
!-- iAction = 1   termina la rotazione/traslazione del modello
!--         = 2   termina la definizione dell'area da zoommare
! ---
      common /SaveRbyM/ ifDragged, B(3,3), iDxV, iDyV,
     *                  ifLabelsDrag, iPlotTypeDrag
! ---
      ifDragged  = 0
      if (iAction.eq.1) then
          ifLabels   = ifLabelsDrag
          iPlotType  = iPlotTypeDrag
          newkscrx   = kscrx
          newkscry   = kscry
          iPlotTypeDrag = 0
      else
          newkscrx   = kscrx
          newkscry   = kscry
      endif
      k = kridisegna(newkscrx,newkscry,1)
! ---
      return
      end
! ----------------------------------------------------------------------
      subroutine savebinfile()
      USE General
      USE Atomi
      USE RemoModule
!
      implicit none
      integer             :: ier, iAction, mode, k, Lung, nExitC
      character (len=256) :: filename
!
      if (nats > 0) then
          call UpdateCommonAndList5(ier)
      endif
!
      k = index(fname(1),'.bin')
      filename = fname(1)(1:k) // 'sav'
      iAction = 1
      mode    = 2
      call PutGetBinaryFile(iAction, mode, ier)
      if (natsInModel(1) > 0) then
          WhichModel = 1
          call GetModel
      endif
!
      if (ier == 0) then
          write(Msg,10) filename(1:Lung(filename))
          call MsgWinErr('Info', Msg, INFO_WINDOW, nExitC)
      endif
   10 format('The project binary file has been saved in ',a,'.')
!
      return
      end
! ----------------------------------------------------------------------
      subroutine restorebinfile(ifFromGraphic, ierr)
      USE General
!     USE F90_UNIX_ENV                  ! NAG f95 Compiler
      USE Molcom
!
      integer ifFromGraphic, ierr
!
      common /unitbak/ jdirbak
!
      character*256 file1, file2, nomeStr
      character *80 filebak
!mr210406      integer system

!
      k = index(fname(1),'.bin')
      filebak = fname(1)(1:k) // 'sav'
      nomeStr  = fname(1)(1:k-1)
      file1 = fname(1)(1:k) // 'bin'
      if (ifFromGraphic == 1) then
          file2 = fname(1)(1:k) // 'out'
      else
          k = index(fname(15), slash, .TRUE.)
          if (k <= 0) then
              k = 0
          endif
          file2 = fname(15)(k+1:)
      endif
      jdirbak = jfile
      ifFileOK = 1
!
!-- does restored file exist ?
!
      istat = 2
      iform = 2
      kop = jopen(jfile, filebak, istat, iform, ierr)  ! madrid (era kopen)
      if (kop < 0) then
          ifFileOK = 0
      else
          close(jfile)
      endif

!-- controllare che il file .sav esista
!-- e sia un file binario valido
!
      if (ifFileOK == 1) then
          iAction = 2
          call chiudi_bin(iAction, ierr)
          if (ierr < 0) return
          call cCopyFile(filebak, fname(1))

          write(Msg,10) filebak(1:Lung(filebak))
!g        call MsgWinErr('Info', Msg, INFO_WINDOW, nExitC)
          call OpenWarning(Msg)
!
          call GetBinV2(nomeStr,file1,file2)
      else
          ierr = -1
          Msg = 'Impossible to restore '
     *         // filebak(1:Lung(filebak)) // ' !!!'
          call MsgWinErr('Open file error', Msg, WARN_WINDOW, nExitC)
      endif
!
   10 format('The project binary file has been restored from ',a,'.')
!
      return
      end
! ----------------------------------------------------------------------
      subroutine PrintIt(String, nIt)
      USE Molcom
!
      character*(*) String
!
      call cprintit(String//char(0), nIt)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine AbilitaSkipeStop()
!
      call ab_stop_run()
!
      return
      end
! ----------------------------------------------------------------------
      subroutine newproject_gene(ier, input_par)
      USE General
      USE Symmetry
!
      type (multistringa)  ::input_par
      character*256 WDir
      character*80 nomeStr
      character*80 title
      integer ier
!
      Wdir =  input_par%str1(1:input_par%n1)
      nomeStr =  input_par%str2(1:input_par%n2)
      title = input_par%str3(1:input_par%n3)
      nsym  = 1
      icent = 0
      totop = 1
!
      lend = Lung(nomeStr)
      Inte = ' '
      Inte = nomeStr(1:lend) // '_prepro.txt'
      itype=1   ! scratch
      itype=0   ! NON scratch
      iform=1
      jop=jopen(jerr,Inte,itype,iform,ier)
      close(jerr, status = 'delete')
!
      fname( 1) = nomeStr(1:lend)//ext(1)
      fname( 2) = nomeStr(1:lend)//ext(2)
      fname( 3) = nomeStr(1:lend)//ext(3)
      fname( 4) = nomeStr(1:lend)//ext(4)
      fname( 5) = nomeStr(1:lend)//ext(5)
      fname( 6) = nomeStr(1:lend)//ext(5)
      fname( 9) = nomeStr(1:lend)//ext(9)
      fname(14) = nomeStr(1:lend)//ext(14)
      fname(15) = nomeStr(1:lend)//ext(15)
!
!gl!  read(title,'(20a4)') itle
!!mr     title = Titolo
!
      NewFileBin = 0
      InitializeFile = 1
      call SucchiaDati(InitializeFile,NewFileBin,ier)

      itype=1   ! scratch
      itype=0   ! NON scratch
      iform=1
      jop=jopen(jhost,'newproj1.txt',itype,iform,ier)
      loSav = lo
      lo = jhost
!
      write(jhost,10) nomeStr(1:Lung(nomeStr))
      write(jhost,20) WDir(1:Lung(WDir))
      write(jhost,30) title(1:Lung(title))
!
      close(jhost)
      lo = loSav
!
      return
   10 format('Structure name    : ',a)
   20 format('Working directory : ',a)
   30 format('Job title         : ',a)
      end
! ----------------------------------------------------------------------
      subroutine newproject_symm(ier,SPGroup,CellConditions)
      USE General
      USE Symmetry
!
      character*(*) SPGroup
      integer ier
      integer CellConditions(14)
!
      dimension kshif(3)
!

      call shift(SPGroup,nchar)
      ier = 0
      k = index(SPGroup,':')
      if (k > 0) then
          SPGroup(k:) = ' '
      endif
      read(SPGroup,'(16a1)') nSpaceG
      call CheckSpaceGroupSymbol(nSpaceG, ier)
      if (ier.lt.0) then
          write(Msg,10) SPGroup
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          return
      endif
      call CreaSymmetryInfo(ier)
      if (ier < 0) then
          return
      endif
      call xspinb
      kpolTrue = kpol
!
      CellConditions = -100
      CellConditions(14) = jsys
      select case (jsys)
             case (2)
                  if (kmat(2,1,1).eq.kmat(2,2,2)) then
                      CellConditions( 4) = 90
                      CellConditions( 5) = 90
                      CellConditions(10) =  0
                      CellConditions(11) =  0
                  else if (kmat(2,1,1).eq.kmat(2,3,3)) then
                      CellConditions( 4) = 90
                      CellConditions( 6) = 90
                      CellConditions(10) =  0
                      CellConditions(12) =  0
                  else if (kmat(2,2,2).eq.kmat(2,3,3)) then
                      CellConditions( 5) = 90
                      CellConditions( 6) = 90
                      CellConditions(11) =  0
                      CellConditions(12) =  0
                  endif
             case (3)
                  CellConditions( 4) =  90
                  CellConditions( 5) =  90
                  CellConditions( 6) =  90
                  CellConditions(10) =   0
                  CellConditions(11) =   0
                  CellConditions(12) =   0

             case (4)
                  CellConditions( 2) =  -1
                  CellConditions( 4) =  90
                  CellConditions( 5) =  90
                  CellConditions( 6) =  90
                  CellConditions( 8) =  -7
                  CellConditions(10) =   0
                  CellConditions(11) =   0
                  CellConditions(12) =   0

             case (5)
                  CellConditions( 2) =  -1
                  CellConditions( 4) =  90
                  CellConditions( 5) =  90
                  CellConditions( 6) = 120
                  CellConditions( 8) =  -7
                  CellConditions(10) =   0
                  CellConditions(11) =   0
                  CellConditions(12) =   0

             case (6)
                  CellConditions( 2) =  -1
                  CellConditions( 3) =  -1
                  CellConditions( 4) =  90
                  CellConditions( 5) =  90
                  CellConditions( 6) =  90
                  CellConditions( 8) =  -7
                  CellConditions( 9) =  -7
                  CellConditions(10) =   0
                  CellConditions(11) =   0
                  CellConditions(12) =   0
      end select
!
      return
   10 format('Error in Space Group Symbol:',a)
   50 format(' ')
      end
!-----------------------------------------------------------------------
      subroutine newproject_cell(ier, MegaStringa, Valori)
      USE General
      USE Symmetry
!
      character*(*) MegaStringa
      integer ier
      real Valori(10)
!
      character*10 ValCel(13)
      dimension celltemp(13)
!
      Msg = Megastringa
      ifLaue = nint(Valori(1))
      if (ifLaue > 0) then
           ifLaue = ifLaue - 1 + 10
      endif
!
      do i=1,13
         call Chiocciola(Msg, ValCel(i),0)
      enddo
!
      if (ifLaue == -1) then
          if (jsys.eq.4) then
              ValCel(2) = ValCel(1)
              ValCel(8) = ValCel(7)
          elseif (jsys.eq.5) then
              ValCel(2) = ValCel(1)
              ValCel(8) = ValCel(7)
          elseif (jsys.eq.6) then
              ValCel(2) = ValCel(1)
              ValCel(3) = ValCel(1)
              ValCel(8) = ValCel(7)
              ValCel(9) = ValCel(7)
          endif
      endif
      do i=1,13
         call shift(ValCel(i),kkk)
         celltemp(i) = Valore( ValCel(i) )
      enddo
      itype=1   ! scratch
      itype=0   ! NON scratch
      iform=1
      jop=jopen(jhost,'newproj2.txt',itype,iform,ier)
      loSav = lo
      lo = jhost
      call CreaCellInfo(celltemp)! (1:6))
      if (ifLaue == -1) then
          call WriteSymmInfo(jhost)
      endif
      call WriteCellInfo
      close(jhost)
      lo = loSav
      Valori(1) = volume
!
      call newproject_end(1)
!
      return
      end
!---------------------------------------------------------------------------
      subroutine newproject_cont(ier, MegaStringa, Valori)
      USE General
      USE PhaseModule, only: ksizeReq
!
      character*(*) MegaStringa
      integer ier
      real Valori(10)
!     Valori(2) = 0 ----> X Ray
!               = 1 ----> Neutron
!               = 2 ----> Electron
!
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common /LunghezzadOnda/ ValWave
      dimension fpfs(2,18)
      character*10 Buffer
!
      Msg = Megastringa
!
      ksizeReq = -1
      ValWave = Valori(1)
      Buffer = ' '
      if (ValWave.lt.0.0) then
          iva = nint( -ValWave )
          if (iva.eq.1) then
              wavel = 1.54178      !  'Cu'
          else
              wavel = 0.71073      !  'Mo'
          endif
      else
          wavel = ValWave
      endif
*     if (Valori(2).gt.0.5) then
*         neutro = 2
*     endif
      neutro = nint(Valori(2))
      nk = 0
      ii = 0
      do j=1,MaxNk
         ii = ii + 1
         call Chiocciola(Msg, Buffer,1)
         if (Buffer(1:1).ne.' ') then
             nk = nk + 1
!            read(Buffer,'(a4)') nalf(nk)
             Species(nk) = Buffer(1:4)
             call Chiocciola(Msg, Buffer,0)
             nw(nk) = nint( Valore(Buffer) )
             call Chiocciola(Msg, Buffer,0)
             if (Buffer.ne.' ') then
                 fpfs(1,nk) = Valore(Buffer)
             endif
             call Chiocciola(Msg, Buffer,0)
             if (Buffer.ne.' ') then
                 fpfs(2,nk) = Valore(Buffer)
             endif
         endif
      enddo
!
      itype=1   ! scratch
      itype=0   ! NON scratch
      iform=1
      jop=jopen(jhost,'newproj3.txt',itype,iform,ier)
      loSav = lo
      lo = jhost
      ncwu = lo
      WhichProps = 1
      call CreaAtmPropInfo(WhichProps, ier)
      call GetFromAtmStruct
      if (ier.ge.0) then
          if (neutro /= 2) then
              call WriteContInfo(npq,ier)
          endif
      endif
      close(jhost)
      lo = loSav
!
      return
      end
!---------------------------------------------------------------------
      subroutine Chiocciola(Megastringa, Buffer,ifLcase)
!
      character*(*) MegaStringa, Buffer
!
      ik = index(MegaStringa,'@')
      if (ik.le.1) then
          Buffer = ' '
      else
          Buffer = Megastringa(1:ik-1)
      endif
      Megastringa(1:ik) = ' '
      call shift(Megastringa,lenp)
      call shift(Buffer,lenp)
      if (ifLcase.eq.1) then
          call lcase(Buffer)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine newproject_refl(ier, iff2, Valori, Elist, blocchi,
     *                           input_par)
      USE General
      USE Symmetry
      USE Riflessi
      USE Molcom
      USE PhaseModule
      USE RiflessiInfo
      USE WrReIn
!
      type megastringa
         character (len = 1000) :: stringa
         integer                :: n1
      end type
      type (megastringa) input_par
!!      character*(*) MegaStringa
      integer ier
      integer iff2
      real Valori(10)
      real Elist(4000)
!psie
!psie      real Elist(4000)
      integer blocchi(20)
!
      integer :: jumpData, nstrData, negF
      real    :: btData, enData
      common /DataToNormal/ jumpData, btData, nstrData, enData, negF
      character*80 formt, Buffer
!
!!      Msg = Megastringa
      Msg = input_par%stringa(1:input_par%n1)
!
      th      = 99999999
      resmin  = 99999
      iffsq = iff2
      ifo2  = iff2
! -- calculate number of reflexions for (sem)invariant searching
      mn = int(4.5*anat+100.5)
      if (nsym.eq.1) mn = mn + 50
      nstr = min0(mn,maxstr)
      nstr=mn+min0(maxstr-mn,100)/2
!
      call Chiocciola(Msg, ReflFileName,0)
      call Chiocciola(Msg, formt,1)
      LL = Len_Trim(formt)
      if (formt(LL:LL).eq.'k'.or.formt(LL:LL).eq.'K') then
         formt(LL:LL) = ' '
         knw = 1
      end if
!
      ReflFileForm = formt
      call Chiocciola(Msg, Buffer,0)
      ifUserThFact = Len_Trim(Buffer)
      if (ifUserThFact.ne.0) then
          jumpData = 0
          btData   = Valore( Buffer )
      else
          jumpData = -1
          btData   = 0.0
      endif
!
      call Chiocciola(Msg, Buffer,0)
      if (Buffer(1:1).ne.' ') then
          resm = Valore( Buffer )
      else
          resm = -99999
      endif
      ifMatOr = 0
      ij=0
      do i=1,3
         do j=1,3
            ij = ij+1
            call Chiocciola(Msg, Buffer,0)
            MatOr(i,j) = nint( Valore( Buffer ) )
            if (i.eq.j.and.MatOr(i,j).ne.1) then
                ifMatOr = 1
            elseif (i.ne.j.and.MatOr(i,j).ne.0) then
                ifMatOr = 1
            endif
         enddo
      enddo
!
      call Chiocciola(Msg, Buffer,0)
      nPerCard = nint( Valore( Buffer ) )
!
      listRefl = 10
      ifGener  = -1
      nzro = maxpsi
      ksigma = 1
      jscreenS = jscreen
**    jscreen = 3
!
      call scrper(' Reading data ',0,-1)
!
      itype=1
      iform=2
      kop=kopen(iscra,' ',nlenBin,itype,ierr)
      itype=1   ! scratch
      itype=0   ! NON scratch
      iform=1
      jop=jopen(jhost,'newproj4.txt',itype,iform,ier)
      loSav = lo
      lo = jhost
      if (neutro == 2) then
*         call WriteContInfo(formt,npq,ier)
          npq = 0
          call WriteContInfo(npq,ier)
      endif
      call DefineSize()
      icomat = 1
! -- read reflexion data from cards
      call LoadReflections(formt, nrefp, npq, ier)
      if (ier.ge.0) then
! --
! -- create list 6 ( reflections )
! --
          call CreaRiflessiNew(npq)
          InfoOK(6) = 1
          nreflDim = nrefltot
          call AllocaRiflessi(1)

          ifMercedes = 0
          call norm2000(ifMercedes, ier)
          if (ier.ge.0) then
              if (nsym.eq.1.and.icent.eq.0) then
                  ifP1 = 1
              else
                  ifP1 = 0
              endif
              call DefineBlocksEtc()
              do i=1,4000
!psie                  
!psie              do i=1,12000
                 if (evet(i).ge.1.2) then
                     Elist(i) = evet(i)
                     nstrmax = i
                 else
                     exit
                 endif
              enddo
              nstrmax = min0(nstrmax, maxstr)
              Valori(1) = nstr
*             Valori(2) = nstrmax         !  gianluca 07032009
              Valori(2) = bt              !  gianluca 07032009
*             Valori(3) = evet(nstrmax)   !  gianluca 07032009
              Valori(3) = resol           !  gianluca 07032009
              Valori(4) = evet(1)
              Valori(5) = ksize
              Valori(6) = nBlocksPh ! numero di blocchi di default
              Valori(7) = 10        ! numero massimo di blocchi
              Valori(8) = ifRelax
              j = 0
              do i=1,nBlocksPh
                 blocchi(j+1) = jBlocksPh(1,i)
                 blocchi(j+2) = jBlocksPh(2,i)
                 j = j + 2
              enddo
              call AllocaRiflessi(2)
              if (refl_info%nrefl > 0) then
                  InfoOK(6) = 1
              endif
          endif
      endif
      close(jhost)
      close(iscra)
      jscreen = jscreenS
      lo = loSav
      call scrper(' ',0,-1)
      call newproject_end(2)
!
      return
      end
!---------------------------------------------------------------------
      subroutine newproject_solve(ier, Valori, blocchi, fragFile)
      USE General
      USE Symmetry
      USE PhaseModule
      USE VLDmod
!
      integer :: ier, ifSannel
      real    :: Valori(10)
      integer :: blocchi(20)
!
      common /proc/ e ftr,ifp10,ifnq,ifps,ifcoc
      character *20 Sizes(5)
      character (len=*) fragFile
!
!-- Save the results if FindSpace procedure has been called
!
      if (ifLaue >= 0) then
          itype=1   ! scratch
          itype=0   ! NON scratch
          iform=1
          jop=jopen(jhost,'newproj4.txt',itype,iform,ier)
          k = index(fname(1),'.bin')
          Inte = fname(1)(1:k-1) // '_prepro.txt'
          itype=1   ! scratch
          itype=0   ! NON scratch
          iform=1
          jop=jopen(jerr,Inte,itype,iform,ier)
          leggi = 1
          do while (leggi == 1)
             read(jhost,'(a)',end=10) cardImage
             if (cardImage(1:30) == 
     *           ' - Stored symmetry information') then
                 leggi = 0
             else
                 write(jerr,'(a)') cardImage(1:Lung(cardImage))
             endif
          enddo
   10     close(jerr)
          close(jhost)
      endif
!
      Sizes(1) = '  XS : Very Small'
      Sizes(2) = '  S  : Small'
      Sizes(3) = '  M  : Medium'
      Sizes(4) = '  L  : Large'
      Sizes(5) = '  XL : Very large'
!
      nTrialsVLD  = 0
      nIterVLD    = 0
      ifVLDdirect = 0
!
      itype=1   ! scratch
      itype=0   ! NON scratch
      iform=1
      jop=jopen(jhost,'newproj5.txt',itype,iform,ier)
      loSav = lo
      lo = jhost
      filePDB = ' '
      ifSannel = 0
*gl*  ifPatt = nint(Valori(1))
      k = nint(Valori(1))
      if (k == 3) then
          ifSannel = 1
          filePDB = fragFile(1:Lung(fragFile))
      elseif (k == 2) then
          ifVLD = 1
      else
          ifPatt = k
          ifVLD = 0
      endif
!      nstr = nint(Valori(2))
!      emin = Valori(3)

      if (ifSannel == 0) then
          if (ifVLD == 0) then
              if (Valori(2).gt.0.5) then
                  nBlocksPh = nint(Valori(2))
                  write(lo,150) nBlocksPh
                  k = 0
                  do i=1,nBlocksPh
                     do j=1,2
                        k = k + 1
                        jBlocksPh(j,i) = blocchi(k)
                     enddo
                  enddo
                  do i=1,nBlocksPh
                     if (ifPatt == 0) then
                         write(lo,160) i,(jBlocksPh(j,i),j=1,2)
                     else
                         write(lo,161) i,(jBlocksPh(j,i),j=1,2)
                     endif
                  enddo
              else
                  nBlocksPh = 0
              endif
          else
              k = nint(Valori(2))
              if (k > 0) then
                  nBlocksPh = 1
                  nTrialsVLD  = blocchi(1)
                  nIterVLD    = blocchi(2)
              else
                  nBlocksPh = 0
              endif
              ifVLDdirect = blocchi(3)
          endif
!         MaxRun  = nint( Valori(2) )
          if (ifVLD == 1) then
              write(jhost,141) 'VLD'
          elseif (ifPatt == 0) then
              write(jhost,141) 'Tangent Formula'
          else
              write(jhost,141) 'Patterson'
          endif
          k = nint(Valori(3))
          ifRelax = k - 3
          if (ifRelax == -1) then
              write(jhost,142)
          else if (ifRelax == 0) then
              write(jhost,143)
          else if (ifRelax == 1) then
              write(jhost,144)
          endif
          RSoglia = Valori(4)
          write(jhost,165) RSoglia
!

          ksize = nint( Valori(5) )
          write(jhost,190) Sizes(ksize)
!
      else
          write(jhost,200) filePDB(1:Lung(filePDB))
      endif
      close(jhost)
      lo = loSav
      jproc  = 1
      call newproject_end(3)
!
      return
  110 format('Triplets will be estimated using the Cochran formula',/,
     *       'among the',i5,' strongest reflections ( Emin = ',f8.3,
     *       ' )',/)
  120 format('Triplets will be estimated using the P 10 formula',/,
     *       'among the',i5,' strongest reflections ( Emin = ',f8.3,
     *       ' )',/)
  130 format('Negative quartets will be evaluated',/)
  140 format('Negative quartets will be not evaluated',/)
  141 format('Phasing algorithm: ',a,/)
  142 format('Relax procedure will not be used',/)
  143 format('Relax procedure will be used once per block',/)
  144 format('Relax procedure will be used for every trial',/)
  150 format(' Number of blocks to be used:',i3,/,
     *       15x,' Block     Trials    to explore    Procedure')
  160 format(15x,i3,2i12,8x,'Tangent')
  161 format(15x,i3,2i12,8x,'Patterson')
  165 format('The program will stop when R% will be less than',f8.3,/)
  170 format('Negative triplets (if any) will be used',/)
  180 format('Negative triplets (if any) will be not used',/)
  190 format('Consider the structure size as : ',a)
  200 format('Simulated annealing will be applied using the fragment',
     *       /,a)
      end
!-----------------------------------------------------------------------
      subroutine newproject_end(iCommand)
      USE General
      USE Symmetry
      USE PhaseModule
      USE VLDmod
!
!-- iCommand  =  1  write .sir file for %Data ( cell & symmetry ) only
!--           =  2  write .sir file for %Data
!--           =  3  write .sir completely
!
      integer :: jumpData, nstrData, negF
      real    :: btData, enData
      common /DataToNormal/ jumpData, btData, nstrData, enData, negF
      common /proc/ iftr,ifp10,ifnq,ifps,ifcoc
      common /LunghezzadOnda/ ValWave
      character *2 Sizes(5)
!
      Sizes(1) = 'XS'
      Sizes(2) = 'S '
      Sizes(3) = 'M '
      Sizes(4) = 'L '
      Sizes(5) = 'XL'
!
      itype=1   ! scratch
      itype=0   ! NON scratch
      iform=1
!     jop=jopen(jhost,fname(14),itype,iform,ier)
      jop=jopen(jhost,'tmptmptmp.sir',itype,iform,ier)
      write(jhost,110)
      k = index(fname(1),'.bin')
      Buffer1 = fname(1)(1:k-1)
      write(jhost,120) Buffer1(1:k-1)
!gl!  write(Buffer1,'(20a4)') itle
      Buffer1 = Titolo
      call shift(Buffer1,lenB)
      if (lenB.gt.75) then
          lenB = 75
      endif
      write(jhost,140) Buffer1(1:lenB)
      write(jhost,150)
      write(jhost,160) (cell(i),i=1,6)
      if (errcell(1).gt.0.00001) then
          if (errcell(7).gt.0.00001) then
              write(jhost,165) (errcell(i),i=1,7)
          else
              write(jhost,165) (errcell(i),i=1,6)
          endif
      endif
      write(Buffer1,'(16a1)') nSpaceG
      k = Lung(Buffer1)
      if (k > 1) then
          call ucase(Buffer1(1:1))
          write(jhost,170) Buffer1(1:16)
      endif
      if (iCommand.eq.1) then
          write(jhost,500)
      else
          do i=1, nk
             write(Species(i),'(a4)') nalf(i)
             call lcase(Species(i))
             call ucase(Species(i)(1:1))
          enddo
          write(Inte,'(18(a4,i5,2x))') (Species(i), nw(i), i=1,nk)
          call OneBlankOnly(Inte)
          write(jhost,180) Buffer1(1:Lung(Inte))
          if (neutro == 1) then
              write(jhost,181)
          elseif (neutro == 2) then
              write(jhost,182)
          endif

          write(jhost,190) ReflFileName(1:Lung(ReflFileName))
          if (ifMatOr == 1) then
              write(jhost,195) ((MatOr(i,j),j=1,3),i=1,3)
          endif

          if (ReflFileForm(1:4) == 'free') then
              write(jhost,200) ReflFileForm(1:Lung(ReflFileForm))
          else
              write(jhost,201) ReflFileForm(1:Lung(ReflFileForm))
          endif
          if (resm > 0) then
              write(jhost,202) resm
          endif
              
          if (knw.eq.1) then
              write(jhost,205)
          endif
          if (ifo2.eq.2) then
              write(jhost,210)
          else
              write(jhost,215)
          endif
          if (jumpData.eq.0) then
              write(jhost,220) btData
          endif
!          write(jhost,230) nstr
          Buffer1 = ' '
          if (ValWave < 0.0) then
              iva = nint( -ValWave )
              if (iva.eq.1) then
                  Buffer1(1:2) = 'Cu'
              else
                  Buffer1(1:2) = 'Mo'
              endif
          elseif (ValWave > 0.0001) then
              write(Buffer1,'(f9.6)') ValWave
          else
              Buffer1(1:1) = 'X'       
          endif
          if (Buffer1(1:1) /= 'X') then
              write(jhost,240) Buffer1(1:Lung(Buffer1))
          endif
          if (iCommand.eq.2) then
              write(jhost,500)
          else
              if (filePDB(1:1) /= ' ') then
                  write(jhost,403) filePDB(1:Lung(filePDB))
                  write(jhost,405)
              else
                  write(jhost,400)
                  if (ifVLD == 0) then
                      if (nBlocksPh > 0) then
                          if (ifPatt == 0) then
                              write(jhost,410)
     *                         ((jBlocksPh(i,j),i=1,2),j=1,nBlocksPh)
                          else
                              write(jhost,412)
     *                         ((jBlocksPh(i,j),i=1,2),j=1,nBlocksPh)
                          endif
                      else
                          if (ifPatt == 0) then
                              write(jhost,410)
                          else
                              write(jhost,412)
                          endif
                      endif
                  else
                      if (nBlocksPh > 0) then
                          if (ifVLDdirect == 0) then
                              write(jhost,415) nIterVLD, nTrialsVLD
                          else
                              write(jhost,416) nIterVLD, nTrialsVLD
                          endif
                      else
                          if (ifVLDdirect == 0) then
                              write(jhost,418) 'VLD '
                          else
                              write(jhost,418) 'VLDd'
                          endif
                      endif
                  endif
                  write(jhost,420) RSoglia
                  write(jhost,430) Sizes(ksize)
                  if (ifRelax == -1) then
                      write(jhost,450)
                  else if (ifRelax == 1) then
                      write(jhost,460)
                  endif
              endif
              write(jhost,500)
          endif
      endif
      close(jhost)
!
  110 format('%Window')
  120 format('%Structure ',a)
  140 format('%Job ',a)
  150 format('%Data')
  160 format('   Cell ',6f10.4)
  165 format('   Errors',f9.4,6f10.4)
  170 format('   Spacegroup  ',a)
  180 format('   Content     ',a)
  181 format('   Neutrons    ',a)
  182 format('   Electrons   ',a)
  190 format('   Reflections ',a)
  195 format('   Orient ',9i4)
  200 format('   Format ',a)
  201 format('   Format',a)
  202 format('   ResM  ',f5.2)
  205 format('   Known')
  210 format('   Fosq')
  215 format('   Fobs')
  220 format('   BFactor',f10.3)
  230 format('   nReflections ',i5)
  240 format('   Wavelength ',a)
  300 format('%Invariants')
  310 format('   Cochran')
  320 format('   nQuartets')
  400 format('%Phase')
  403 format('%Import ',a)
  405 format('%Sannel')
  406 format('%Phase')
  410 format('   DM        ',10(i5,i4))
  412 format('   Patterson ',10(i5,i4))
  415 format('   ','VLD ',2x,2i5)
  416 format('   ','VLDd',2x,2i5)
  418 format('   ',a)
  420 format('   Resid ',f8.2)
  430 format('   size  ',a)
  440 format('   nNegativeTriplets')
  450 format('   UnRelax')
  460 format('   Relax')
  500 format('%End')
!
      return
      end
!-----------------------------------------------------------------------
      integer*4 function init_tune(elist, Valori, blocchi)
      USE General
      USE Symmetry
      USE Riflessi
      USE PhaseModule
!
      implicit none
      integer :: ier, iAction, nstrmax, i, j, ksubr, nExitCode
      integer :: blocchi(*)
      real    :: elist(*), Valori(*)
!
      Valori(1) = -999
      ier = 0
      init_tune = ier
      if (nreflDim <= 0) then
          ier = -1
          Msg = 'No reflections supplied !!!'
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          init_tune = ier
          return
      endif
!
      if (InfoOK(6).ne.2) then
          call AllocaRiflessi(1)
          ksubr = 3
          call LeggiRiflessi(ier,ksubr)
          if (ier < 0) then
              init_tune = ier
              return
          else
              InfoOK(6) = 2
          endif
      endif
      do i=1,4000
!psie          
!psie      do i=1,12000
         if (evet(i).ge.1.2) then
             elist(i) = evet(i)
             nstrmax = i
         else
             exit
         endif
      enddo
      nstrmax = min0(nstrmax, maxstr)
!
      call DefineBlocksEtc()
      if (ksize == 0) then
          ksizeReq = -1
          call DefineSize()
          if (ksize <= 3) then
              ifVLD = 1
          else
              ifVLD = 0
          endif
      endif
!
      Valori(1) = nstr
      Valori(2) = nstrmax
      Valori(3) = evet(nstrmax)
      Valori(4) = evet(1)
      Valori(5) = ksize
      Valori(6) = nBlocksPh ! numero di blocchi di default
      Valori(7) = 10        ! numero massimo di blocchi
      Valori(8) = ifRelax
      j = 0
      do i=1,nBlocksPh
         blocchi(j+1) = jBlocksPh(1,i)
         blocchi(j+2) = jBlocksPh(2,i)
         j = j + 2
      enddo
!
!-- Valori(9) contiene la procedura (tangente/Patterson/VLD)
!-- usata nel run precedente
!
      if (ifVLD == 1) then
          Valori(9)  = 2
      elseif (ifTang == 1) then
          Valori(9)  = 0
      else
          Valori(9)  = 1
      endif 
!
      Valori(10) = RSoglia
      if (RSoglia < 0) then
          Valori(10) = 25
      endif
      if (neutro == 2) then
          Valori(10) = -1
      endif
      init_tune = ier
!
      return
      end
!-----------------------------------------------------------------------
      subroutine finish_tune(valori, blocchi)
      USE General
      USE Symmetry
      USE Atomi, only: nats
      USE PhaseModule
      USE Direttive
      USE VLDmod
      USE Grafici, only : headersGR
      USE RemoModule, only : numbModels
!
!-- kstato( 1) = 1 /2 ( Cochran, P10 )
!-- kstato( 2) = nstr
!-- kstato( 3) = nstrmax
!-- kstato( 4) = 0 / 1 Quartets
!-- kstato( 5) = nTrials
!-- kstato( 6) = ksize
!-- kstato( 7) = 0 / 1 (reset starting trial)
!-- kstato( 8) = 0 / 1 (Negative Triplets)
!-- kstato( 9) = RSoglia
!-- kstato(10) = 0 / 1 (Use RELAX)
!
      implicit none
      integer :: iftr, ifp10, ifnq, ifps, ifcoc, numbReflTrip
      integer :: NSigPos, NSigNeg, NQuaNeg, inizNeg,NPsiZero
      integer :: blocchi(*)
      integer :: ier, i, j, k, ilist, iAction, ksubr, ifFromGraphic
      integer :: ifFromPhase
      real    :: SogPos, SogNeg, SogQuaNeg
      real    :: valori(*)
      common /proc/ iftr,ifp10,ifnq,ifps,ifcoc
      common /ConvComm/ NSigPos, SogPos, NSigNeg, NQuaNeg, inizNeg,
     *                  NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!psie      
!psie     *            NPsie,NPsiZero, numbReflTrip, SogNeg, SogQuaNeg
!
      ifMDM = 0
      ifVLD = 0
      ifTang  = 0
      ifPatt  = 0
      kWstop = 0
      nstr = nstr_data
      k = nint(Valori(1))

      select case(k)

         case (1) ! Let the program decide
            call DefaultAbInitio()

         case (2) ! MDM
            ifWillMDM = 1
            ifMDM = 1

         case (3) ! SDM
            ifTang = 1

         case (4) ! Patterson
            ifPatt = 1

         case (5) ! VLD
            ifVLD = 1
            ifWillVLD = 1
            n_abi_model = nPreviousTrials + 1
            n_abi_model = 1
            nPreviousTrials = 0
            if (Valori(2) < 0.5) then
                if (neutro == 2) then
                    blocchi(1) = 5
                else
                    blocchi(1) = 20
                endif
                blocchi(2) = 300
            endif
            jBlocksPh(1,1) = blocchi(1)
            jBlocksPh(2,1) = blocchi(1)
            n_cicli = blocchi(2)

      end select
!
      if (ifVLD == 0) then
          if (Valori(2).gt.0.5) then
              nBlocksPh = nint(Valori(2))
              k = 0
              do i=1,nBlocksPh
                 do j=1,2
                    k = k + 1
                    jBlocksPh(j,i) = blocchi(k)
                 enddo
              enddo
              MaxRun  = nint( Valori(2) )
          else
              MaxRun  = -1
          endif
      endif
!
*     k = nint(Valori(3))
*     ifRelax = k - 3
!
*     RSoglia = Valori(4)
      ksize = nint(Valori(5))
!
      if (ifPatt == 1) then
          NQuaNeg = 0
          ifNewPsi0 = 0
          jproc = 0
      else
          jproc = 1 - nint(Valori(9))
      endif
!
      call AllocaAtomi(2)
      call AllocaModelRemo(2)
!
      iAction = 99
      call AllocaBonds(iAction)
      numbModels = 2
      iAction = 0
      call AllocaBonds(iAction)
!
      ilist = 5
      call Cancella(ilist)
      ilist = 15
      call Cancella(ilist)
      nats = 0
!
      icomq(1,1) = 4
      icomq(1,2) = 0
      icomq(2,1) = 7
      icomq(2,2) = 0
      icomat = 1
      ipcom = 2
!
      if (ksize >= 3) then
          call CPUTime0(' ') 
          call CPUTime0(' ') 
          headersGR(2) = ' '
      endif
!
      iAction = 0
      call RunToolBar(iAction,' ')
      ksubr = 2
      ifFromGraphic = 1
      ifFromPhase = 0
      call scr2_sir
      call RoutineHeader('Phase')
      ier = 0
      ksubr = 3
      itria = 0
      numbTrials = 0
      nolsq = -1
      ifFromGraphic = 1
      call CheckGrid()
      InfoOK(8) = 0
      call CloseViewer()
      call Contan(ier, ksubr, ifFromGraphic)
!
      if (ksize >= 3) then
          call export(ier, ksubr)
      endif
!
      call c_scr2(-1, 0, 0, 0, 0, ' ')
      call RunToolBar(-1,' ')
!
      return
      end
!-----------------------------------------------------------------------
      subroutine prefourier(natsC, nadd, ier)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
!
      integer :: ier, natsC, nadd, ridisegna
!
!!mr      ifCubo = 1
      ier = 0
      if (nrefl == 0) then
          write(Msg,140)
  140     format('Fourier cannot be used, no reflections supplied.')
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif

!
!-- deletes ghosts
!-- applies modifications to model
!
      do i=1,nats
         if (nz(i).eq.0) RS(i) = -100.0
      enddo
      call ResetLabelPos()
      jrests = 0
      call ModCom(jrests)
      natsC = nats
!
!-- computes number of peaks to add
!
      amult  = pts * float(nsym * ( icent + 1 ) )
      anat0 = 0
      anat1 = 0
      do i = 1 , nats
         nzi = iabs(nz(i)) / nzConst
         if (nzi.gt.0) then
             anat1 = anat1 + xyzs(5,i) * amult
         endif
      enddo
      if (neutro.eq.0.and.no(1).eq.1) then
          iniz = 2
      else
          iniz = 1
      endif
      do i = iniz , nk
         anat0 = anat0 + nw(i)
      enddo
      DeltaAt = ( anat0 - anat1 ) / amult
      nadd = nint(DeltaAt)
      if (nadd.lt.5) then
          nadd = 5
      endif
!
      k = ridisegna()
      call zflush
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PeekColV2(ncol, ires)
!
      call c_peek_color(ncol, ires)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine chiudi_bin(flag, ier)
      USE General
      USE Atomi, only : nats
      USE Molcom
      USE PhaseModule
      USE LsqStuff
!
      implicit none
      integer :: flag, ier, iAction, mode
      logical :: isOpen
!
      if (flag == 1) then
         close(jdir, status = 'delete')
      elseif (ifProject ==1) then
         cardImage = fname(1)
         close(jrel)
         close(jhost)
!
         call UpdateCommonAndList5(ier)
         if (ier < 0) return
         if (nats > 0) then
             call PutModel
         endif
         iAction = 1
         mode = 1
         call PutGetBinaryFile(iAction, mode, ier)
*         close(jdir)
         nats = 0
         ifProject = 0
         ifVLD = 0
         jscreen = 1
         iAction = 2
         call AllocaRiflessi(iAction)
         call AllocaRiflessiNew(iAction)
         call AllocaPhaseStuff(iAction)
         call AllocaMappa(iAction)
         call AllocaModelRemo(iAction)
         call AllocaAtomi(iAction)
         call AllocaBuildStuff(iAction)
         call AllocaHistoStuff(iAction)
         call AllocaLsqStuff(iAction)
         iAction = 99
         call AllocaBonds(iAction)
!
         CodeGroup = 0
         NumGroup = 0
!
      endif
!
      jrest = 0
      call InitSir2006(1)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine manPeekList(String, NumCan, MultiSel, sel, iExitC, ifl)
      USE General
      USE Atomi
      USE Molcom
!
      character*(*) String
      integer sel(*)
!
!     ifl -> bitmask per i tasti da visualizzare
!     OK=1, All=2, Cancel=4
!
      lMsg = Lung(String) + 1
      String(lMsg:lMsg) = char(0)
      lMsg = Lung(Msg) + 1
      Msg(lMsg:lMsg) = char(0)

      call c_peek_list (String, NumCan, MultiSel, sel, iExitC, nats,
     *                  Msg, ifl)
!
      return
      end
! ---------------------------------------------------------------------
      integer function new_cell_content(specie,ivet)
      USE General
      USE Atomi
      USE RemoModule
!
      character*(*) specie
      integer ivet(18), resto
!
*     fpri(:) = fprimo(:)
*     fsec(:) = fsecondo(:)
!
c--check if a list 5 exists
!!mr060814      call UpdateCommonAndList5(ier)
!         
!-- Save List 3
!
      nalfSav(:) = nalf(:)
      nwSav(:)   = nw(:)
      noSav(1:18)   = no(1:18)
      waveSav    = wavel
      nkSav      = nk
      anatSav = anat
      call lcase(specie)
      nk = 0
      do i=1,18
         if (ivet(i) > 0) then
             j1 = (i - 1) * 4 + 1
             j2 = j1 + 3
             nk = nk + 1
             nw(nk) = ivet(i)
             read(specie(j1:j2),'(a4)') nalf(nk)
             Species(i) = specie(j1:j2)
         endif
      enddo
!
      modifica = 0
      if (nk /= nkSav) then
          modifica = 1
      else
          do i=1,nk
             if (nalf(i) /= nalfSav(i)) then
                 modifica = 1
                 exit
             endif
             if (nw(i) /= nwSav(i)) then
                 modifica = 1
                 exit
             endif
          enddo
      endif
!
!
      if (modifica == 1) then
          call CreaAtmPropInfo(WhichProps, ier)
          call GetFromAtmStruct
      endif
      if (ier < 0) then
          call RestoreLists123(Lista)
      endif
!
      new_cell_content = ier
      call WriteContInfo(npq,ier)
      if (modifica == 1) then
          do i=1, nats
             lnz = nz(i)/nzConst
             resto = mod(nz(i), nzConst)
             noS = noSav(lnz)
             do j=1, nk
                if (noS == no(j)) then
                    nz(i) = j * nzConst + resto
                    nzTot(i) = j
                    exit
                endif
             enddo
          enddo
          call PutModel
          call InitMolplo()
      endif
!
      return
      end
! ---------------------------------------------------------------------
      integer function get_cell_content(ivet1, ivet2)
      USE General
      USE progtype, only:NMAXSPECIE
      implicit none
      integer, dimension(NMAXSPECIE)     :: ivet1, ivet2
!
      get_cell_content = nk
      ivet1 = no(1:NMAXSPECIE)
      ivet2 = nw(1:NMAXSPECIE)
!
      return
      end
! ---------------------------------------------------------------------
      subroutine InitContour(ngrid, ier)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Mappa
      USE MappaCont
      USE Iso_Surfaces
      USE Param
      USE PhaseModule
!
      integer ngrid(3)
      integer ier
!
      ier = 0
      if (InfoOK(6) == 0) then
          Inte = 'Contour procedure'
          Msg = 'No reflections stored'
          call MsgWinErr(Inte, Msg, ERR_WINDOW, nExitCode)
          ier = -1
          return
      endif
!
      if (ifDrawContour == 0) then
          ifContPoly = ifCont  !Save this variable to be used restoring env.
      endif
      ifCont = 1
      call PrintMess('Initializing contour environment')
      call DoSingleIteration()
      if (ifSkeleton == 0 .and. NatMol > 0) then
          if (ifSymmCont == 0) then
              ifSymmCont = 1
              call SoloInd(NatInd)
              NATind = NatMol
              do i=1,3
                 DeA(i) = 0.01
*                DeA(i) = 0.0
              enddo
              ifDentro = 0
              iZero = 0
              call Genera(ifDentro, iZero)
           endif
      endif
      ifDrawContour = 1
      call AllocaContorno(1)
      xyz_tria = 0.0

      if (ifAlreadyProduced == 0) then
          call ProduciMappa()
          call AllocaMappaCont(1)
          ifAlreadyProduced = 1
!
          RhoNew = xmap
!
          nnx=np(1)
          nny=np(2)
          nnz=np(3)
          call maxminSir(nnx,nny,nnz,rhonew)
          massimoMappa = denmax
          massimoMappa = max0(massimoMappa, int(5*sigmaMappa))
          sigmaMappa = stden
!          write(0,*) 'massimoMappa',massimoMappa
          sigma3 = sigmaMappa / 3.0
          do i=1,15
             SoglieCont(i) = sigma3 * i
          enddo
!
      endif
!
      ngrid     = np
      ngridCont = np
      call PreparaContour
!
      call zflush
!
      return
      end
! ---------------------------------------------------------------------
      subroutine FinishContour()
      USE Molcom
!
      ifDrawContour = 0
      ifAlreadyProduced = 0
      call AllocaMappa(2)
      call AllocaMappaCont(2)
      call AllocaContorno(2)
      call ClearMessage()
!
      if (NatMol == 0) then
         return
      end if
!
!-- show all
!
      do i = 1 , NatMol
         if (RS(i) .gt. -10.) then
             RS(i) = abs(RS(i))
         end if
      enddo
!
      call SoloInd(NatInd)
      ifCont = ifContPoly
      ifSymmCont = 0
      do i=1,3
         DeA(i) = DeaDef(i)
      enddo
      if (ifCont.eq.1) then
          NATind = NatMol
          ifDentro = 1
          iZero = 0
          call Genera(ifDentro, iZero)
      endif
!
      call FindMinMax
      kscala = 1
      call Disegna(kscala)
!
      return
      end
! ---------------------------------------------------------------------
      subroutine ThFacTooBig(iFromLSQ)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE PhaseModule
      USE LsqModule
      USE PhaseInterface
!
      implicit none
      integer :: iFromLSQ, i, iOK, iActLis, iMultiSel, nnn
      integer :: NumUnDel, iExCode, jrest0, interp
!
      character*22 bchar
!
      if (jscreen.eq.0) then
          return
      endif
      if (TotalScan > 0) then
          if (nScan < TotalScan) then
              return
          endif
      endif
!
      do i=1, nats
         Lab(i) = aLab(i)
      enddo
!gl?! if (BLimit.gt.999999) then
          BLimit = 0.0
          do i=1, nats
             BLimit = BLimit + bfac(i)
          enddo
*         BLimit = 2 * BLimit / float(NatInd)
          BLimit = 2 * BLimit / float(nats)
!gl?! endif
!
!--Gianluca 7 Feb 2003
!
      if (iFromLSQ == 0) then
          iOK = 1
      else
!
!-- if electrons no question
!
          if (neutro == 2) then
              iOK = 0
          else
              iOK = 0
              do i=1, nats
                 nzsav(i) = 0
                 if (bfac(i).gt.BLimit .and. RS(i).gt.0) then
                    iOK = 1
                 end if
              enddo
          endif
      endif
!
      if (iOK.eq.1) then
          write(bchar,"('( Threshold = ',f6.1,' )')") BLimit
          Msg='Select to discard the listed atoms with ' // char(10) //
     *        'too big thermal factors' // char(10) //  bchar
          Inte = 'Select atoms to delete'
          iActLis = 6
          iMultiSel = 1
          nnn = nats
          call PeekList (Inte,iActLis,nzsav,nnn,NumUnDel,iExCode,
     *                   iMultiSel)
          if (iExCode.lt.3) then
              if (NumUnDel > 0) then
                  nptr = NumUnDel
                  do i=1,nptr
                     kptr(i) = nzsav(i)
                  enddo
                  call DelAt
                  if (InfoOK(5) > 0) then
                      jrest0 = 0
                      call Modcom(jrest0)
                      call Disegna(IfScale)
                  else
                      call Upd15()
                      call MiglioriErre(1)     ! Gianluca 16/04/2015
                      interp = 1
                      call PutGetXyzs(1, interp)
                      call PutModel
                  endif
                  if (iFromLSQ /= 2) then
!                     AGGIORNA JAV 
                      call AggiornaJav
                  endif
              endif
           end if
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine UpdateLabelString(i, NewLab)
      USE General
      USE Atomi
      USE Molcom
      USE ilmviewmod
      USE RemoModule
!
      implicit none
      integer :: i, j, k, kk, cambia, iAction, lnz, ridisegna
      character (len=16) :: aLabc
      character*(*) NewLab
!
      cambia = i
      Lab(i) = NewLab
      j = iEqui(i)
      if (ifCont == 1) then
          cambia = 0
          do k=1, NatMol
             kk = iEqui(k)
             if (kk == j) then
                 Lab(k) = NewLab
                 cambia = kk
             endif
          enddo
      endif
      if (cambia > 0) then
          aLabc = NewLab
          aLab(cambia) = aLabc
          VetChanges(1) = xyzs(1, cambia)
          VetChanges(2) = xyzs(2, cambia)
          VetChanges(3) = xyzs(3, cambia)
          VetChanges(4) = xyzs(4, cambia)
          VetChanges(5) = xyzs(5, cambia)
          VetChanges(6) = bfac(cambia)
          lnz = nzTot(cambia)
          iAction = 0
          call ModModel(cambia, iAction, aLabc, lnz, VetChanges)
      endif
      if (ifChanged(j).eq.0) then
          ifChanged(j) = 4
      else if (ifChanged(j).le.10) then
          ifChanged(j) = ifChanged(i) + 40
      else
          ifChanged(j) = 100
      endif
!
      k = ridisegna()
!
      if (jav_opened()) then
          do i=1, NatInd
             model(WhichModel)%Label(i) = Lab(i)
          enddo
          call AggiornaJav
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine init_move_labels(ier)
      USE Molcom
!
      integer ier
!
      if (ifLabels.eq.0) then
            ier = 1
        else
          if (ifMovedLab == 0) then
              call DefineLabelPos(0)
          endif
          ier = 0
          ifMovedLab = 1
        endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine init_move_labels_new(ier)
      USE General
      USE Atomi, only: nzTot
      USE Molcom
!
      integer ier
!
      if (ifLabels.eq.0) then
          ier = 1
      else
          ifOK = 1
          do i=1, NatMol
             if (nzTot(i) == 0 .or. RS(i) < -10.0) then
                 ifOK = 0
                 exit
             endif
          enddo
          if (ifOK == 0) then
              Msg = 'Buffer contains some atoms or ' //
     *              'there are ghosts: OK to delete them ?'
              call MsgWinErr('Warning', Msg, QUEST_WINDOW_NO_YES,
     *                       nExitCode)
              if (nExitCode == 2) then
                  ier = 1
                  return
              else
                  call UpdateCommonAndList5(ier)
              endif
          endif

          if (ifMovedLab.eq.0) then
              call DefineLabelPos(0)
          endif
          ier = 0
          ifMovedLab = 1
        endif
!
      return
      end
! ---------------------------------------------------------------------
      subroutine finish_move_labels()
      USE Molcom
!
      do i=1, NatMol
         xyLab(1,i) = float(ipixLab(1,i)) / float(kscrx)
         xyLab(2,i) = 1.0 - float(ipixLab(2,i)) / float(kscry)
      enddo
!
      return
      end
! ---------------------------------------------------------------------
      subroutine reset_plot_style
      USE Molcom
!
      call c_reset_plot_style(iPlotType, ifLabels)
!
      return
      end
! ---------------------------------------------------------------------
      subroutine save_restore_mdl(input_par, iAction)
      USE General
      USE Atomi
      USE Molcom
!
!-- iAction = 1 Save
!-- iAction = 2 Restore
!
      implicit none
      type (multistringa)  ::input_par
      integer n1
      integer n2
!
      integer           :: iAction, ier, jop, jopen, itype, iform
      integer           :: i, L, Lung, nExitCode
!!mr      character (len=*) :: filnam, dirnam
      character*256     filnam, dirnam
      character*256 filename
!
      ier = 0
      jop = 0
!!mr
      n1 = input_par%n1
      n2 = input_par%n2
      filnam = input_par%str1(1:n1)
      dirnam = input_par%str2(1:n2)
!!mr
      cardDiret = dirnam(1:n2) // filnam(1:n1)

      if (iAction == 2) then
         itype = 2
      else
         if (nats <= 0) then
             jop = -2
             ier = -2
         endif
         itype = 0
      endif
      if (jop == 0) then
          iform = 1
          jop = jopen(jhost, cardDiret, itype, iform, ier)
      endif
!
      if (jop == 0) then
          call save_restore_model(iAction, jhost, ier)
      else
          ier = -1
      endif
!
      if (ier == 0) then
          if (iAction == 2) then
              BTot(:,:) = 0
              do i=1,3
                 BTot(i,i) = 1
              enddo
              IfScale= 1
              call RotazTot
              call GetBonds(2)
              call Disegna(ifScale)
          endif
      elseif (ier == -1) then
          L = Lung(cardDiret)
          Msg = 'Problems with file' // char(10) // cardDiret(1:L)
          call MsgWinErr('Save/Restore', Msg, ERR_WINDOW, nExitCode)
      else
          Msg = 'No model to save!!!'
          call MsgWinErr('Save/Restore', Msg, ERR_WINDOW, nExitCode)
      endif
!
      close(jhost)
!
      return
      end
! ---------------------------------------------------------------------
      integer function ifCarbons_xC()
!
      ifCarbons_xC = ifCarbons()
!
      return
      end
! ----------------------------------------------------------------------
      subroutine importa_fileoldXXX(filnam, dirnam, iAction)
      USE General
      USE Molcom
      USE PhaseModule
!
!     filnam = nome del frammento o file da importare
!     dirnam = directory in cui si trova il file
!     iAction = 20 --> sir fragment
!             = 21 --> caos fragment
!             = 22 --> shelx file
!             = 23 --> PDB file
!             = 24 --> z-matrix fragment
!
      integer iAction
      character*(*) filnam
      character*(*) dirnam
      character*256 nomeStr
!
!-- check if a project is active
!
      ier = 0
      ifImport = 1
      if (ifProject.eq.0) then
          k = index(filnam,'.')
          if (k.gt.0) then
              nomeStr = filnam(1:k-1)
          else
              nomeStr = 'struct'
              k = 7
          endif
          fname( 1) = nomeStr(1:k-1) // '.bin'
          fname(15) = nomeStr(1:k-1) // '.out'
          itype = 0
          iform = 1
          jop = jopen(lo,fname(15),itype,iform,ier2)
          Inte = 'Imported data for: ' // nomeStr(1:k-1)
!gl!      read(Inte,'(20a4)') itle
          Titolo = Inte(1:80)
!gl!      write(lo,215) itle
          write(lo,215) Titolo
  215     format(' ',78('*'),/,' ',a,//)
          Imported = 1
          call wrhead
          init = 0
          iTipo = 2
          call updSWRC(iTipo,fname(1),fname(15))
          call updRecentProjects()
          WhichProps = WhichProps + 1
      endif
      call importa(filnam, dirnam, iAction, ier)
      ifImport = 0
      if (ier < 0) then
          iAction = -iAction
          QualeAbilita = -1
          call SadEnd(ier)
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine importa_file(input_par, iAction)
      USE General
      USE Molcom
      USE PhaseModule
          !USE drawatoms
!      USE ilmviewmod
!
      type (multistringa)  ::input_par
!     input_par%str1 = nome del frammento o file da importare
!     input_par%str2 = directory in cui si trova il file
!     iAction = 20 --> sir fragment
!             = 21 --> caos fragment
!             = 22 --> shelx file
!             = 23 --> PDB file
!             = 24 --> z-matrix fragment
!
      integer iAction
      character*256 nomeStr
!
!-- check if a project is active
!
      ier = 0
      ifImport = 1
      if (ifProject.eq.0) then
          k = index(input_par%str1,'.')
          if (k.gt.0) then
              nomeStr = input_par%str1(1:k-1)
          else
              nomeStr = 'struct'
              k = 7
          endif
          fname( 1) = nomeStr(1:k-1) // '.bin'
          fname(15) = nomeStr(1:k-1) // '.out'
          itype = 0
          iform = 1
          jop = jopen(lo,fname(15),itype,iform,ier2)
          Inte = 'Imported data for: ' // nomeStr(1:k-1)
!gl!      read(Inte,'(20a4)') itle
          Titolo = Inte(1:80)
!gl!      write(lo,215) itle
          write(lo,215) Titolo
  215     format(' ',78('*'),/,' ',a,//)
          Imported = 1
          call wrhead
          init = 0
          iTipo = 2
          call updSWRC(iTipo,fname(1),fname(15))
          call updRecentProjects()
          WhichProps = WhichProps + 1
          if (InfoOK(3) == 0) then
              WhichProps = 0
          endif
      endif
!test-corrado      
      call importa(input_par%str1, input_par%str2, iAction, ier)
!      call ilmview_open(input_par%str1)
!      n1 = input_par%n1
!      n2 = input_par%n2
!      call jav_import_structure
!     *  (input_par%str2(1:n2)//input_par%str1(1:n1)//char(0),1)
!!      call importa0(input_par%str2(1:n2)//input_par%str1(1:n1)//char(0),
!!     *ier,.false.)
!test-corrado
      ifImport = 0
      if (ier < 0) then
          iAction = -iAction
          QualeAbilita = -1
          call SadEnd(ier)
      else
          kk = index(fname(1),'.bin')
          Inte = fname(1)(1:kk-1) // ' successfully imported'
          call scrper(Inte,0,-1)
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine save_as(filnam, dirnam)
      USE General
      USE Molcom
      USE PhaseModule
!
!     filnam = nome del file da scrivere
!     dirnam = directory del file da scrivere
!
      character*(*) filnam
      character*(*) dirnam
      character*80 line, filename
!
      Msg = dirnam(1:Lung(dirnam)) // filnam(1:Lung(filnam))
      istat = 0
      iform = 1
      jop=jopen(99,Msg,istat,iform,ierr)
!
      filename = 'tmp.tmp'
      istat = 0
      iform = 1
      jop=jopen(iscra,filename,istat,iform,ierr)
      iEOF = 0
      do while (iEOF.eq.0)
         read(iscra,'(a)',end=100) line
         write(99,'(a)') line
      enddo
!
  100 close(iscra)
      close(99)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine Get_1_2(ifLista1, ier)
      USE General
      USE Molcom
!
      character * 80 lista
      dimension abcvet(13)
!
      ier = 0
      if (ifLista1 == 0) then
          abcvet = -1
      else
          do i=1,6
             abcvet(  i) = cell(i)
             abcvet(i+6) = errcell(i)
          enddo
          abcvet(13) = errcell(7)
      endif
      call c_get12(abcvet, ier)
      if (ier == -1) then
          Msg = 'No information supplied'
          call MsgWinErr('WARNING', Msg, ERR_WINDOW, nExitCode)
          return
      endif
      do i=7, 13
         if (abcvet(i) < 0) then
             abcvet(i) = 0
         endif
      enddo
      if (ifLista1 == 0) then
          call CreaCellInfo(abcvet)    ! gianluca 5/10/2014
      endif
!
      lista = 'newproj2.txt'
      itype=2
      iform=1
      jop=jopen(jhost,lista,itype,iform,ier)
      if (jop.ge.0) then
          do
              read(jhost,'(a)',end=100) lista
              write(lo,'(a)') lista(1:Lung(lista))
          enddo
  100     close(jhost)
      endif
!
      return
      end
! ----------------------------------------------------------------------
*     subroutine GetRefl(filename, ier)
      subroutine GetRefl(ier)
      USE General
*     character*(*) filename
      character*256 filenam
      character*80  formato
!
!-- filename e' il nome del file che si sta importando
!-- serve a definire il default name per il file dei riflessi
!
      ier = 0
      ik = index(fname(1), '.')
      if (ik.eq.0) then
          filenam = fname(1)(1:Lung(fname(1))) // char(0)
      else if (ik.eq.1) then
          filenam = char(0)
      else
          filenam = fname(1)(1:ik-1) // char(0)
      endif
      formato = '(3i4,2f8.2)' // char(0)
      filenam = ' '
      call c_getrefl(filenam, formato, ifo2, ier)
      if (ier == -1) then
          return
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine ResetBuild
      USE General
      USE Molcom
!
      nAided = 0
      call SoloInd(NatInd)
      ifCont = 0
      call FindMinMax
      call Disegna(ifScale)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine finishlsq(iCode, ifGroupRefinedC)
!
      USE General
      USE LsqStuff    !! mr
!
      integer iCode
      integer ifGroupRefinedC(*)
!
!               iCode = 0 --> OK
!               iCode = 1 --> Go
!
          ifGroupRefined(1:100) = ifGroupRefinedC(1:100)         !!mr
          call finish_MNQD(iCode,ier)   !!mr, ifGroupRefined)       !  nuovo MNQD
          do j=1, nk                          !!mr 02082015
             call lcase(Species(j))           !!mr 02082015
             call ucase(Species(j)(1:1))      !!mr 02082015
          end do                              !!mr 02082015
!
      return
      end
! -----------------------------------------------------------------
      subroutine scriviora(iPs, ist)
!
      USE General
!
      common/miotempo/ T0mio, T1mio
      integer T0mio, T1mio
!
      if(ist.eq.0) then
         T0mio = mrmillisec()
      else
         T1mio = mrmillisec()
         nSecsTot = T1mio - T0mio
!         write(0, *) 'p.s.',iPs, ' millisecs',nSecsTot
      endif
 1800 format(/,' p.s.',i6,'   CPU milliSECs ',i8)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine init_aided_build(nsymComplete)
      USE Symmetry
      USE Molcom
!
      implicit none
      integer :: nsymComplete, NatIn
!
      NatIn  = NatInd
      NatMol = NatInd
      call SoloInd(NatIn)
      ifCont = 0
!
      nsymComplete = nsymTot
!
      return
      end
!-----------------------------------------------------------------------
      subroutine finish_aided_build(kplt)
      USE Molcom
!
      integer kplt
!
      call Genera_aided(kplt)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine init_setbd(cBondTable, cRadii)
      USE General
!
      real cBondTable(2,18,18), cRadii(18,2)
!
      do i = 1, 2
         do j = 1, MaxNk
            do k = 1, MaxNk
               cBondTable(i,j,k) = BondTable(i,j,k)
            end do
            cRadii(j,i) = radii(j,i)
         end do
      end do
!
      return
      end
!-----------------------------------------------------------------------
      subroutine finish_setbd(cBondTable, cRadii, iAction)
      USE General
!
!-- iAction = 1  Update BondTable using values from graphics
!--         = 2  Reset BondTable to default values
!--
!
      real cBondTable(2,18,18), cRadii(18,2)
!
      if (iAction == 1) then
          ifToBeUpdated = 0
          do i = 1, 2
             do j = 1, MaxNk
                do k = 1, MaxNk
                   a = abs( cBondTable(i,j,k) - BondTable(i,j,k) )
                   if (a.gt.0.001) then
                       ifToBeUpdated = 1
                       cBondTable(i,k,j) = cBondTable(i,j,k)
                   endif
                end do
                a = abs( cRadii(j,i) - radii(j,i) )
                if (a.gt.0.0001) then
                    ifToBeUpdated = 1
                endif
             end do
          end do
      else
          cBondTable(:,:,:) = 0.0
          cRadii(:,:) = 0.0
          do i=1, nk
             rap = 0.20
             nu  = no(i)
             dis = radii(i,1)
             if (nu == 1) then
                 dis = 0.18
                 rap = 0.1
             endif
             do j=1,nk
                if (nu /= 1) then
                    rap = 0.20
                endif
                nu1  = no(j)
                dis1 = radii(j,1)
                if (nu1 == 1) then
                    dis1 = 0.18
                    rap  = 0.1
                endif
                xleg = dis + dis1
                if (nu1 == 1 .and. nu == 1) then
                    xleg = 0.64
                endif
                cBondTable(1,i,j) = xleg - 2 * rap * xleg
                cBondTable(2,i,j) = xleg + rap * xleg
             enddo
          enddo
          cRadii(1:nk, 1) = radii(1:nk, 1)
          cRadii(1:nk, 2) = radii(1:nk, 2)
          ifToBeUpdated = 1
      endif
      if (ifToBeUpdated == 1 ) then
          call updBondTable(cBondTable, cRadii)
          call BuildBonds(1)                       !perugia1312
          call LEtoIconn                           !perugia1312
          call Disegna(1)                          !perugia1312
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine cAddOneAtom(iClickati, kz, NewLab)
      USE General
      USE Atomi
      USE Molcom
!
      integer iClickati(3)
      character NewLab*(*)
!
      ifScaleSav = ifScale
      ifLabelsSav = ifLabels
      iPlotTypeSav = iPlotType
      kscrxSav = kscrx
      kscrySav = kscry
      NatMolSav = NatMol
      ifScale = 1
!
      lspec   = kz
      iCl1 = iClickati(1)
      l1 = Lung(Lab(iCl1))
      Lab1 = Lab(iCl1)
      iCl2 = iClickati(2)
      l1 = Lung(Lab(iCl2))
      Lab2 = Lab(iCl2)
      iCl3 = iClickati(3)
      l1 = Lung(Lab(iCl3))
      Lab3 = Lab(iCl3)
!
      dist = 1.350
      ang_b = 120
      ang_t = 0
      call AtomoNuovo(dist)
!
      dmassima = amax1(cell(1), cell(2), cell(3) )

      do i=1,8
         lser(i) = vetSpec(i)
      enddo
      call c_add_atom(lspec, lser, iClickati, ifOkay, dmassima)
      if (ifOkay.eq.0) then
          call CancellaAtomoNuovo()
      else
          i = NatMol
          vetSpec(lspec) = lser(lspec) - 1
          call CreaLab(i,-1,lspec,NewLab)
          call AddAtomo(NewLab,ierr)
          IfScale= 1
!
          call PutModel
!
          leggi = 1
          call toMolPlo3(leggi)
          call RotazTot
          call GetBonds(1)
      endif
!
      lspec   = -1
      ifScaleSav = ifScale
      ifLabels = ifLabelsSav
      iPlotType = iPlotTypeSav
      do i=1, NatMol
         if (RS(i).lt.0.0) then
             RS(i) = -RS(i)
         endif
      end do
!
      kscrx = kscrxSav
      kscry = kscrySav
      k = kridisegna(kscrx,kscry,0)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine minidraw(newkscrx, newkscry, angb, angt, dist, jspe)
      USE General
      USE Atomi
      USE Molcom
!
      integer newkscrx
      integer newkscry
      real    angb
      real    angt
      real    dist
      integer jspe
!
      character TempStr*40
!
      ifLabels = 1
      dist1atm = dist
      ang_b = angb
      ang_t = angt
!
      lspec = jspe
      write(Labb,'(a2,i5)') nalf(lspec),lser(lspec)
      call NoBlanks(Labb,i0)
      call ucase(Labb(1:1))
      Lab(NatMol)  = Labb
      iCol(NatMol) = no(lspec) + N_OBJS
      i1 = Lung(Lab1)
      i2 = Lung(Lab2)
      i3 = Lung(Lab3)

      write(It(1), 10) Labb(1:i0), char(0)
!
      write(TempStr,"(a,'-',a)") Labb(1:i0),Lab1(1:i1)
      call NoBlanks(TempStr,i4)
      write(It(2), 20) TempStr(1:i4), dist, char(0)
!
      write(TempStr,"(a,'-',a,'-',a)") Labb(1:i0),Lab1(1:i1),
     *                                 Lab2(1:i2)
      call NoBlanks(TempStr,i4)
      write(It(3), 30) TempStr(1:i4),nint(ang_b), char(0)
!
      write(TempStr,"(a,'-',a,'-',a,'-',a)") Labb(1:i0),Lab1(1:i1),
     *                                       Lab2(1:i2),Lab3(1:i3)
      call NoBlanks(TempStr,i4)
      write(It(4), 40) TempStr(1:i4),nint(ang_t), char(0)
!
      It(5) = char(0)
!
      call AtomoNuovo(dist)
      k = kridisegna(newkscrx,newkscry,0)
!     ifScale = 0
!
      return
   10 format(' New Atom =      ',  a, a)
   20 format(' Distance D = ',a,' = ', f7.3, a)
   30 format(' Bond Angle B = ',a,' =',i5, a)
   40 format(' Torsion Angle T = ',a,' =',i5, a)
      end
!-----------------------------------------------------------------------
      subroutine finish_define(iAction, fcoe, ferr, ier)
      USE General
      USE Atomi
      USE Molcom
!
      integer iAction
      real      fcoe(*)
      real      ferr(*)
      integer ier
!
      SmallIt(1) = ' '
      call calcolaNew(jscre,iAction, fcoe, ferr, ier)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine RiempiListaAtomi()
      USE General
      USE Molcom
      USE Atomi
!
!mr190106      NatMolC = NatMol
      do natom = 1, NatMol
         It(natom) = Lab(natom) // char(0)
      end do
      It(NatMol+1) = char(0)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine Finish_Levels(lvis, lval, lcol)
      USE Molcom
!
      integer lvis(5)      ! 0/1  i-th level off/on
      integer lval(5)      ! level values
      integer lcol(5)      ! associated colors
!
      ifChanged = 0
      write(6,'(5i6)') lcol
      write(6,'(5i6)') levelcol
      write(6,'(5i6)') lval
      write(6,'(3i6)') (nint(Sogliecont(i)),i=1,15)
      do i=1,5
         if (ifLevel(i).ne.lvis(i)) then
             ifChanged = ifChanged + 1
             ifLevel(i)  = lvis(i)
         endif
         k = 3 * i
         if (lval(i).ne.nint(SoglieCont(k))) then
             soglia3 = float(lval(i)) / 3.0
             SoglieCont(k-2)   = soglia3
             SoglieCont(k-1)   = soglia3 * 2.0
             SoglieCont(k  )   = soglia3 * 3.0
             ifChanged = ifChanged + 10
         endif
!mr         if (LevelCol(i).ne.(lcol(i) - 1)) then
!mr             LevelCol(i)     = lcol(i) - 1
         if (LevelCol(i).ne.lcol(i)) then
             LevelCol(i)     = lcol(i)
             ifChanged = ifChanged + 1
         endif
      enddo
!
      if (ifChanged.ge.10) then
*         write(6,*) 'Changed:'
*         write(6,'(5i6)') levelcol
*         write(6,'(3i6)') (nint(Sogliecont(i)),i=1,15)
          call PreparaContour
          call zflush
      elseif (ifChanged.ge.1) then
          call Disegna(0)
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine refine_wp(icriterio)
      USE General
      USE LsqModule
!
      integer icriterio
!
!     numero di parametri =  nParDefGTK(icriterio)
!     parametri           =  WParDefGTK(icriterio, 1:numero di parametri)
!
!     I parametri nella matrice WParDefGTK sono quelli della grafica.
!     I nuovi valori devono essere rimessi in WParDefGTK in modo che
!     risultino aggiornati nella grafica
!
!      write(0, *) 'refine weight parameters criterio ', icriterio
!
          call RefineWParMNQD(icriterio)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine c_scr2(iAction, iC1, iC2, iC3, iC4, string)
      USE Molcom
      USE PhaseModule
!
!-- iAction = 0  starts the left window ( header & commands )
!                iCurrent not used
!                string contains the header
!           = -1 close the left window
!                iCurrent not used
!                string not used
!           = -2 manage the pie & label pie
!                iCurrent = ntrSv + MaxToStore*1000 + jBlock*1000000       !mr
!                string not used
!           > 0  points to a generic command in the command queue
!                iCurrent = command to be executed
!                string contains the command name
!

      implicit none
      character *(*) string
      integer :: iAction, iC1, iC2, iC3, iC4, Lung, seVLD
!
*     return
! codice originale
!      if ( (MaxToStore /= 1) .or. (iAction /= -2) ) then
!          call c_scr(iAction, iCurrent, ifVLD, 
!     *               string(1:Lung(string))//char(0))
!       endif
!
      seVLD = ifVLD
      if (seVLD == 1) then
          if (ifMDM == 1) then
              seVLD = 0
          else
              seVLD = 1
          endif
      endif
      if ( MaxToStore /= 1) then
          call c_scr(iAction, iC1, iC2, iC3, iC4, seVLD, 
     *               string(1:Lung(string))//char(0))
      elseif (iAction /= -2) then
          call c_scr(iAction, iC1, iC2, iC3, iC4, seVLD, 
     *               string(1:Lung(string))//char(0))
      endif
!
      return
      end
! ----------------------------------------------------------------------
      integer function c_index(string, substring)
!
      character *(*) string, substring
!
      c_index = index(string, substring)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine wow()
!
      call c_splash()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine aggiorna_prob(ProbNew)
      USE Atomi
      USE Molcom
!
      real ProbNew
!
      FP = FProb
      ProbF = ProbNew
      P = ProbF
      if (ProbF.le. 0.975) then
          FProb = (((((23.326*P)-55.693)*P+51.552)*P-22.75)*P+
     *            6.447)*P+0.296
      else
          FProb = -136.496 + 141.072 * P
      end if
      FP = (FP * FP) / (FProb * FProb)
      do i=1,NatInd
         do jj=1,3
            do kk=1, 3
               Ell(jj,kk,i) = Ell(jj,kk,i) * FP
            end do
         end do
      end do
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SadFace()
      USE Molcom
      USE PhaseModule
!
      call c_sadface()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine f_FortranAlLavoro(iflag)
!
      call c_fortran_al_lavoro(iflag)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine f_FineLavoro(iflag)
!
      call c_fine_lavoro(iflag)
!
      return
      end
!======================================================================
!
!  ------------------------ S P E C 2 0 0 3  -------------------------
!
!======================================================================
      subroutine BarraDiStato(iz,ind,ix,iy,str)
      USE Molcom
!
      common /string/ x11string
!
      character x11string*257
      character str*(*)
!
!----- code for Unix
      if (ind.eq.4) then
          lstr=Lung(str)
          if (lstr.gt.0) then
              x11string(1:lstr) = str(1:lstr)
          else
              lstr = 0
          endif
          x11string(lstr+1:lstr+1) = char(0)
      else
          x11string = ' ' // char(0)
      endif
!
      call c_barradistato(iz,ind,ix,iy,x11string )
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Visualizzatore(ind,ix,iy,str)
      USE Molcom
!
      common /string/ x11string
!
      character x11string*257
      character str*(*)
!
!----- code for Unix
      x11string = ' '
      if (ind.le.2) then
          lstr=Lung(str)
          if (lstr.gt.0) then
              x11string(1:lstr) = str(1:lstr)
          else
              lstr = 0
          endif
          x11string(lstr+1:lstr+1) = char(0)
      else
          x11string = ' ' // char(0)
      endif
!
      call c_visualizzatore(ind,ix,iy,x11string )
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CDialogo(title, filnam, itipo)
      USE Molcom
!
      common /string/ x11string
!
      character x11string*257
      character title*(*)
      character filnam*(*)
!
!----- code for Unix
       lstr = Lung(title)
       if (lstr.gt.0) then
          title(lstr+1:lstr+1) = char(0)
       else
          title(1:1) = char(0)
       endif
       lstr = Lung(filnam)
       if (lstr.gt.0) then
          filnam(lstr+1:lstr+1) = char(0)
       else
          filnam(1:1) = char(0)
       endif
!
!      call c_Dialogo(title, filnam, itipo)
      call viewfile(title, filnam, itipo)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine Sirchdir(direttorio, ier)
      character*(*) direttorio
!
      ier = mrchdir(direttorio)
!
      return
      end
! ----------------------------------------------------------------------
!!mr      subroutine xwinnew(ix1,iy1,ix2,iy2,ix3,iy3,nCol1,nCol2,nSegm,iClr)
!
!!mr      integer ix1(*), iy1(*), ix2(*), iy2(*),
!!mr     .	ix3(*), iy3(*), nCol1(*), nCol2(*), nSegm, iClr
!
!!mr      call mrwinnew (ix1,iy1,ix2,iy2,ix3,iy3,nCol1,nCol2,nSegm,iClr)
!
!!mr      return
!!mr      end
! ----------------------------------------------------------------------
!!mr      subroutine xwinnew2(ix1,iy1,ix2,iy2,nCol1,nPoints)
!!mr      integer ix1(*), iy1(*), ix2(*), iy2(*),
!!mr     .	nCol1(*), nPoints
!
!!mr      call mrwinnew2 (ix1,iy1,ix2,iy2,nCol1,nPoints)
!
!!mr      return
!!mr      end
! ----------------------------------------------------------------------
      subroutine tihocambiatoicolori(iFlag)
      USE General, only: no
      USE Molcom
      USE Atomi, only: nzTot
!
      integer iFlag

      if (NatMol == 0) then
          return
      endif
!
      if (iflag.ne.0) then
          do j=1, NatMol
             if (nzTot(j).eq.0) then
                iCol(j) = color_GHOST
             else
                iCol(j) = no(nzTot(j)) + N_OBJS
             end if
          end do

          do j=NatMol+1,NatMol+NatSpi
             iCol(j) = color_CELL
          end do
      else                              ! Poliedri
          do j=1, NatInd
             if (nzTot(j).eq.0) then
                iCol(j) = color_GHOST
             else
                iCol(j) = no(nzTot(j)) + N_OBJS
             end if
          end do
      endif
! ---
      return
      end
! ----------------------------------------------------------------------
      subroutine SfumaPalle(X11, Y11, ir, iFC)
!
      integer X11, Y11
!
      call cSfumaPalle(X11, Y11, ir, iFC)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine SfumaPalleBelle(X11, Y11, ir, iFC)
!
      integer X11, Y11
!
      call cSfumaPallejava(X11, Y11, ir, iFC)
!
      return
      end
! ---------------------------------------------------------------------
      subroutine ControllaDir(dir,ierw)
!
      character*(*) dir
!
      k = Lung(dir)
      dir(k+1:k+1) = char(0)
      call c_controlladir(dir,ierw)
      if (ierw == 0) then
          ierw = -1
      else
          ierw = 0
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine punto_e_basta(ix, iy)
!
      call cpunto_e_basta(ix,iy)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine getRGB(indice_colore, rgb)
      USE General
      USE Molcom
!
      dimension rgb(3)
!
      call c_getrgb(indice_colore, rgb)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine UpdateMenu()
      USE General
      USE Molcom
!
      call c_update_menu_recprj()
!
      return
      end
!-----------------------------------------------------------------------
      integer function f_checkisnumeric(stringa)
!
      character *(*) stringa
!
      f_checkisnumeric = Lung(stringa)
      read(stringa, *, err=99) fnum
      return
  99  f_checkisnumeric = -1
!
      return
      end
! ----------------------------------------------------------------------
      integer function ifEllipsoids()
      USE General
      USE Atomi
      USE Molcom
!
      ifEllipsoids = 0
      do i = 1, nats
          if (SinglePlotType(i) == ELLIPSOIDS) then
              ifEllipsoids = 1
              exit
          endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      integer function valore_di_nats()
      USE Atomi
!
      valore_di_nats = nats
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ManageModifySite(j1)
      USE General
      USE Symmetry
      USE Atomi
      USE Molcom
      USE Poliedri
!
      character *9 TmpLab
      real occs(5)
      integer NumSpecie
      integer QualeSpecie(5)
      character*5 Lspecie(5), str1, str2
!
      Lspecie(:) = ' '
      QualeSpecie(:) = 0
      occs(:) = 0.0
      NumSpecie = 1
      Lspecie(1) = Species(nzTot(j1))
      call ucase(Lspecie(1)(1:1))
      occs(1) = xyzs(5,j1)
      call GetSiteConditions(j1, NumSpecie, occs, Lspecie)
      if (NumSpecie < 0) return
!
      do i=1, 5
         k = Lung(Lspecie(i))
         Lspecie(i)(k+1:k+1) = char(0)
      end do
      l0 = Lung(Lab(j1))
      TmpLab = Lab(j1)(1:l0) // char(0)
      iExitCode = msite(TmpLab, Lspecie, occs, NumSpecie)
      if (iExitCode == 0) return
!--elabora il risultato della grafoca      
      xyzs(5,j1) = occs(1)
      NumSpecie = 1
      QualeSpecie(NumSpecie) = nzTot(j1)
      do i=2, 5
         if (occs(i) > 0.0) then
             NumSpecie = NumSpecie + 1
             str1 = Lspecie(i)
             call lcase(str1)
             l1 = Lung(str1)
             call shift(str1, l1)
             do j=1, nk
                str2 = Species(j)
                call lcase(str2)
                l2 = Lung(str2)
                if (str1(1:l1) == str2(1:l2)) then
                    QualeSpecie(NumSpecie) = j
                endif
             enddo
         endif
      enddo
      iSite(j1) = NumSpecie-1
      do j=2,NumSpecie
         n=QualeSpecie(j)
         SiteInfo(j-1,j1)=n*10 + occs(j)
      enddo
!
      call PutModel
!
      ifChanged(j1)=1
c      
!--crea lista 62 default-------------------------      
!      call DefaultRefi(2,ier)
!-------------------------------------------------
      return
      end
!-----------------------------------------------------------------------
      subroutine provacho(n, n2, A, B, X, ier)
!
      implicit none
!
      integer n, n2, ier
      real*8 A(n2), B(n), X(n)
!
!
      call call_Choleski(n, A(1), B, X, ier)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine BestModel(ifDifference, ifMap)
      USE General
      USE Atomi
      USE Molcom
      USE Grafici
      USE Html
      USE PhaseModule
      USE RemoModule
!
      integer :: ifMap, ifDifference
      character (len=4)    :: dire
!

      ifRemo = 0
      ier = 0

      if (ifMadEnv == 0) then
          QualeAbilita = 2
          call NascondiToolbar(1)
      endif
!
      k = index(fname(1),'.bin')
      kk = kStripTask1(k)
!
      if (ifWasRemo > 0) then
          write(Labb,"('_',i4)") WhichBestSolution
      elseif (kmad == 1 .and. ifPDBfiles == 1) then
              write(Labb,"('_',i4)") WhichBestSolution
      elseif (kmad == 2) then
              write(Labb,"('_',a2,'_',i4)") nalf(1), WhichBestSolution
      else
              write(Labb,"('_',i4)") WhichBestSolution
      endif

*     if (ier == 0) then
      if (ifAmb == 0 .and. ifAmbEnan == 0) then
          call NoBlanks(Labb,k1)
          if (ifExportShelx == 1) then
              cardDiret = fname(1)(1:kk-1) // Labb(1:k1) // '.res'
          else
              cardDiret = fname(1)(1:kk-1) // Labb(1:k1) // '.pdb'
          endif
          FichierOut = cardDiret
       else
          cardDiret = FichierOut
       endif
          iAc = 1
          call FilesInfo(iAc, 0)
          write(lo,10)  cardDiret(1:Lung(cardDiret))
          HTMLstr = ' '
          call AbInfo(3)
          write(HTMLstr,20)  cardDiret(1:Lung(cardDiret))
          call AbInfo(3)
          HTMLstr = ' '
!
          if (ifWasRemo == 1) then
              call LanciaJavRemo(ifMap, ifDifference)
              return
          else
!!              ifMap = 1
!!              ifDifference = 1
              call LanciaJavAbi(ifMap, ifDifference)
          endif
!
          if (ifMadEnv == 0) then
              itype = 2
              iform = 1
              jop = jopen(jhost,cardDiret,itype,iform,ier)
              nSkel = 0
              nSkelLeg = 0
              nMolMR = 1
              ifHOH = 0
              LeggiHetam = 1
              call ManagePDBSir(1, ifHOH, LeggiHetam, 0, 0, ier)
              call GetModel
!
              close(jhost)
              if (kmad == 0 .and. ifWasRemo == 1) then
                  call LeggiSkeleton(1)
              else
                  kmad = 0
                  call UpdateReflInfo
                  do i=1,3
                     do j=1,3
                        BTot(i,j) = 0
                     enddo
                     BTot(i,i) = 1
                  enddo
                  interp = 1
                  call PutGetXyzs(1, interp)
                  ifSingle = 0
                  kplot    = SIMPLE
                  call MolPlo(kplot, ifSingle)
                  call zflush
                  call DoSingleIteration()
              endif
              k1 = index(fname(1), '.bin') - 1
              Inte = fname(1)(1:k1) // '_fPlot.png' // char(0)
              call CreaPng(Inte)
          endif
*     endif
!
      ifBestModel = 1
!
      return
   10 format(/,' Loading best model from file: ',a)
   20 format(' Loading best model from file: ',a)
      end
!-----------------------------------------------------------------------
      subroutine AutoBestModel
      USE General
      USE Atomi
      USE Molcom
      USE Grafici
      USE Html
      USE RemoModule
      USE PhaseModule
!
      character (len=4)    :: dire
!
      ier = 0
      k = index(fname(1),'.bin')
      kk = kStripTask1(k)
!
      if (ifWasRemo > 0) then
          write(Labb,"('_',i4)") WhichBestSolution
      elseif (kmad == 1 .and. ifPDBfiles == 1) then
              write(Labb,"('_',i4)") WhichBestSolution
      elseif (kmad == 2) then
              write(Labb,"('_',a2,'_',i4)") nalf(1), WhichBestSolution
      else
          call CreaBestModel(0, ier)
          if (ier == 0) then
              write(Labb,"('_',i4)") WhichBestSolution
          endif
      endif

      if (ier == 0) then
          call NoBlanks(Labb,k1)
          cardDiret = fname(1)(1:kk-1) // Labb(1:k1) // '.pdb'
          iAc = 1
          call FilesInfo(iAc, 0)
!
          if (ifMadEnv /= 0) then
              call StampaMtzPdb
          endif
!
          cardDiret = FichierOut(1:Lung(FichierOut))
          HTMLstr = ' '
          call AbInfo(3)
          HTMLstr = ' '
!
!TEST!    call AllocaModelRemo(2)
!TEST!    call AllocaAtomi(2)
!TEST!    InfoOK(15) = 0
          QualeAbilita = 2
!
      endif
!
      ifBestModel = 1
!
      return
   20 format(' Loading best model from file: ',a)
      end
!-----------------------------------------------------------------------
      subroutine NascondiToolbar(ifToolBar)
!
      implicit none
!
!-- ifToolbar = 0  Hide toolbar & menu
!-- ifToolbar = 1  show toolbar & menu
!
      integer ifToolbar
!
      call c_nasconditoolbar(ifToolbar)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine cpause(messaggio)
      USE Molcom
      implicit none

      character*(*) messaggio
!
      call c_pause (messaggio // char(0), ifHidden)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ProcOver(itipo, irisp)
!
      USE General
      USE Atomi, only : nats
      USE Riflessi
      USE PhaseModule, only: erore
      USE Molcom
      USE Grafici
      USE ArpWarp
      USE RemoModule, only: ifImproveMR
!
      implicit none
      integer :: itipo, irisp, ifGuiButton, box, Lung, k, L
      integer :: lix1, lix2, iAction, ier, nExitCode, ksubr, knwSav
      integer :: nMTZread
      real    :: celltemp(13)

      logical :: Esiste
      character (len=80) :: stringa
!
!-- Terminates the ITIPO procedure where:
!                  ITIPO = 0 Ab Initio
!                  ITIPO = 1 Mad/Sad
!                  ITIPO = 2 Mir/Sir
!                  ITIPO = 3 Miras/Siras
!                  ITIPO = 4 ReMo
!
      if (kmad == 0 .or. (kmad == 1 .and. nats > 10)) then
          if (ifPDBfiles == 1) then
              if (InfoOK(15) == 0) then
                  if (ifAmb == 0) then
                      call AutoBestModel   ! creazione automatica best model
                  else
*                     if (ifRecover == 1) then
                          write(lo,10) FichierOut(1:Lung(FichierOut))
*                     endif
                  endif
              endif
              if (jscreen > 0 .and. ifAutomatic == 0) then
                  if (ksize <= 3) then
                      ifGuiButton = 1
                  else
                      ifGuiButton = 0
                  endif
                  call c_proc_over(ifGuiButton)
              else
                  irisp = 1
              endif
          else
              irisp = 2
          endif
      else
          irisp = 1
      endif
*     if (kmad == 0) then
*         if (ifRemo == 1) then
*             if (ifPDBfiles == 1) then
*                 call c_proc_over(itipo, irisp)
*             else
*                 irisp = 2
*             endif
*         else
*             irisp = 2
*         endif
*     elseif (nats > 10) then
*         if (ifPDBfiles == 1) then
*             call c_proc_over(itipo, irisp)
*         else
*             irisp = 2
*         endif
*     endif
      if (itipo == 0) then
          box = lastBox
          Msg =
     *       '<big><b>Ab-Initio procedure is over</b></big>'
          call TestoGR(Msg, color_RED, 2, box)
          Msg = '<big> </big>'
          call TestoGR(Msg, color_RED, 2, box)
          Msg = 'Ab-Initio procedure is over. '
      endif
      if (itipo == 4) then
          box = lastBox
          Msg =
     *       '<big><b>Molecular Replacement procedure is over</b></big>'
          call TestoGR(Msg, color_RED, 2, box)
          Msg = '<big> </big>'
          call TestoGR(Msg, color_RED, 2, box)
          Msg = 'Molecular Replacement procedure is over. '
      endif
!
      write(lo,'(/,a,a)')  ' ', Msg(1:Lung(Msg))
      call PrintMess(Msg)
!
      Msg = '<big><b>Best final model</b></big>'

      write(lo,80) '++++++++++ Best final model ++++++++++ '
      write(lo,*) 
      box = lastBox
      call TestoGR(Msg, color_RED, 2, box)
      if (ifAmb /= 0 .or. ifImproveMR /= 0) then

          stringa = ' '
          if (erreAW(1:1) /= ' ') then
              write(Msg,50) RfacAW , RfreAW
              write(lo,"(' ',a)") Msg(1:Lung(Msg))
              k = Lung(Msg)
              stringa = Msg(1:k)
              call TestoGR(Msg, color_GREEN, 2, box)
          endif
          if (ifAmb /= 0) then
              if (ifAmb == 1) then
                  if (residuesAW > 0) then
                      write(Msg,'(a,i5)') 'Sequenced residues = ',
     *                                        residuesAW
                  else
                      write(Msg,'(a)') 'Sequenced residues = n.a.'
                      coverage = -1
                  endif
                  L = Lung(Msg) + 4
              else
                  L = 1
              endif
              if (coverage >= 0) then
                  write(Msg(L:),'(a,i3,a1)')
     *                      'Sequence coverage =', nint(coverage), '%'
                  write(stringa(k+3:),'(a,i3,a1)')
     *                      'Sequence coverage =', nint(coverage), '%'
              else
                  write(Msg(L:),'(a)')
     *                      'Sequence coverage n.a.'
                  write(stringa(k+3:),'(a,i3,a1)')
     *                      'Sequence coverage n.a.'
              endif
              write(lo,"(' ',a)") Msg(1:Lung(Msg))
              call TestoGR(Msg, color_GREEN, 2, box)
          endif
      endif
      Msg = ' '
      box = lastBox
      call TestoGR(Msg, -1, 2, box)
      Msg = 'Files produced at the end of the run:'
      write(lo,60) Msg(1:Lung(Msg))
      box = lastBox
      call TestoGR(Msg, -1, 2, box)
      k = index(MTZfile, slash, .TRUE.) + 1
      Msg = '    ' // MTZfile(k:)
      k = Lung(Msg) + 1
      inquire (file=FichierOut,  exist = Esiste)
      if (Esiste) then
          Msg(k+2:) = FichierOut(1:Lung(FichierOut))
      else
          Msg(k+2:) = 'no PDB file created'
      endif
      k = Lung(Msg)
      write(lo,"(' ',a)") Msg(1:k)
      call TestoGR(Msg, color_GREEN, 2, box)
!
      if (itipo == 4) then
          call LanciaJavPreview()
      endif
!
      ier = 0
      if (knw > 0) then
          mtz: do nMTZread=1, 2
             lix1 = 1
             lix2 = 1
             Lab_Ch(1) = 'H'
             Lab_Ch(2) = 'K'
             Lab_Ch(3) = 'L'
             Lab_Ch(4) = 'F'
             Lab_Ch(5) = 'SIGF'
             if (nMTZread == 1) then
                 printMTZerror = .false.
                 Lab_Ch(6) = 'PHIC_ALL' ! fase
                 Lab_Ch(7) = 'FOM'      ! peso
                 Lab_Ch(8) = 'FC_ALL'   ! fc
             else
                 printMTZerror = .true.
                 Lab_Ch(6) = 'PHIC'     ! fase
                 Lab_Ch(7) = 'FOM'      ! peso
                 Lab_Ch(8) = 'FC'       ! fc
             endif
             ifMTZlab = 1
             do iAction =1, 2
                call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
                if (ier /= 0) then
                    if (nMTZread == 1) then
                        k = 3
                        call ManageMTZ(k, celltemp, lix1, lix2, ier)
*                       write(lo,100)
                        ier = 0
                        cycle mtz
                    else
                        Msg = 'Error reading MTZ file ' 
     *                     // MTZfile(1:Lung(MTZfile))
                        call MsgWinErr('ERROR',Msg,ERR_WINDOW,nExitCode)
                        return
                    endif
                endif
             enddo
!
             printMTZerror = .true.
!
             iAction = 1
             call AllocaRiflessi(iAction)
             ksubr = 4
             call LeggiRiflessi(ier, ksubr)
!
             knwSav = knw
             knw = 0
             call LeggiMTZPhase(ier)
!
             iAction = 3
             call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
!
             knw = knwSav
             call examin(1, mkang, khl, ipub, iphaz, nrefl, 0, wt, 1)
             write(lo,90) erore, stringa(1:Lung(stringa))
             exit
          enddo mtz
      endif
!
      return
   10 format(/,' Recovering the AMB model from ',a)
   50 format('R =',f7.4,'  (Rfree =',f7.4,')')
   60 format(/,' ',a,/,'     MTZ format',12x,' PDB format')
   80 format(/,' ',a)
   90 format('Final MPE = ',f8.2,2x,a)
* 100 format(/,2x,20('*'),'   Retry with different labels  ',20('*'),/)
      end
!-----------------------------------------------------------------------
      subroutine cCopyFile(fsrc, fdst)
!
      implicit none
      integer :: Lung
      logical :: Esiste
      character*(*) fsrc, fdst
!
      inquire (file=fsrc,  exist = Esiste)
      if (Esiste) then
          call c_copyfile(fsrc(1:Lung(fsrc))//char(0),
     *                    fdst(1:Lung(fdst))//char(0))
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine cRemoveFile(fsrc)
!
      implicit none
      integer Lung
      character*(*) fsrc
!
      call c_removefile(fsrc(1:Lung(fsrc))//char(0))
!
      return
      end
!-----------------------------------------------------------------------
      subroutine f_RigidBody(nrighe, righe)
!--nrighe = n  ; no. di gruppi (e righe in output)
!         = 0  ; nessun gruppo (deletati se esistevano)
!         = -1 ; tasto "CANCEL" , nessuna modifica fatta
!
      USE General
      USE Molcom
      USE Groups
      USE LsqStuff
      implicit none
!
      type megastringa
         character (len = 1000) :: stringa
         integer                :: n1
      end type
      type (megastringa) righe
      integer ierres,iStampa,ix,inext,nsched
      integer*4    ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      integer*4     nrighe
      integer ier, itype, iform, jop, jopen, jcod, K, KK, iniz, index
      integer i, L, Lung, iflagAmb
!
      if(nrighe.lt.0) return
      ifRigidBody = 0                               !!mr
      ifLabelsVis(:) = 1
!
      if (nrighe > 0) then
         ier = 0
         itype = 1
         iform = 1
         jop=jopen(jhost, 'tmp.out', itype, iform, ier)
         write(jhost, '(a)') righe%stringa(1:righe%n1)
!
         write(jhost,"('end')")
         rewind jhost
!         write(6,*) ' '
!         write(6,*) '----- File per CaosGroup -----'
!         do
!            read(jhost,'(a)') Msg
!            write(lo, '(a)') Msg(1:Lung(Msg))
!            if (Msg(1:3) == 'end') exit
!         enddo
!         write(6,*) '-----       EOF          -----'
!         write(6,*) ' '
!
!         rewind jhost
      endif
!
!--chiamo la nuova routine per creare i gruppi o azzerrare
      call ReadGroup(jhost,nrighe,ier)
!
      if (NumGroup.gt.0) then
          ifGroupRefined(1:NumGroup)=1
c          call InGroupTo12MNQD(ier)
      endif
!
      if (ifDrawGroups == 1) then
          do i = 1, NumLeg
             if (LE(3, i) > 4) LE(3, i) = 1
          enddo
          ifDrawGroups = 0
          ier = 0
          iflagAmb = 1
          call DrawGroups(ier, iflagAmb)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      integer*4 Function LabToAtom(ixx, iyy, ms)
      USE General
      USE Molcom
!
      implicit none
!
      integer i
      integer ixx
      integer iyy
      character*16 tmpLab1, tmpLab2
      type (multistringa) ms
!
      tmpLab1 = ms%str1(1:ms%n1)
      call lcase(tmpLab1)
      do i=1, MaxAtomsInGr
         tmpLab2 = Lab(i)
         call lcase(tmpLab2)
         if (tmpLab1 == tmpLab2) then
             LabToAtom = i
             ixx = ipix(1,i)
             iyy = ipix(2,i)
             return
         endif
      enddo
      LabToAtom = -1
!
      return
      end
!-----------------------------------------------------------------------
      integer*4 Function NGruppiDef(jump)
      USE General
      USE Molcom
!
      implicit none
      integer jump
!
      integer lsn,lixx,ljxx,lkxx,llxx, nIt, kk, m, l, mx, ncard
      integer ier, nchv, Len1, i, ll, iser, lz1, lz2, lz3
      integer n, Lung, NrotaC, NatomC, iflagAmb
      integer NGruppiDefMNQD
!
      n = NGruppiDefMNQD(jump)
      NGruppiDef = n
      if (n == -2) return ! non ha eliminato i ghosts
!
      if (ifDrawGroups == 1) then
          ifDrawGroups = 0
          ier = 0
          iflagAmb = 0
          call DrawGroups(ier, iflagAmb)
      endif
!
      return
   10 format('Contenuto di It per ',i3,' gruppi:',/,
     *       '===============================')
      end
!-----------------------------------------------------------------------
      subroutine PassaCoordsAndConn()
!
      USE General
      USE Groups
!
      implicit none
      integer i, j, k, kk, nzm
*     real ResidCoo(22,3,15), coords(1000)   ! test only for Sir.gru
*     equivalence (ResidCoo(1,1,1), coords(1))
*     ResidCoo(:,:,:) = ResidCoords(:,:,:)
!
*     do i=1, nResid   ! test only for Sir.gru
*        nzm = ResidTable1(i,1)
*        write(6, 10) i, (ResidCoords(i, 1:3, j), j=1, nzm)
* 10     format(i3, 2x, 15(3f8.3, 2x))
*     end do

*     i=1
*     do j=1,3
*        do k=1,15
*            kk = i+(j-1)*NResid+(k-1)*3*NResid
*            write(6,*) i,j, k, kk, ResidCoords(i, j, k), coords(kk)
*        enddo
*     enddo

      call Put_Coords(ResidCoords, ResidConn, nResid, MaxAtomsInGroups)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Subroutine_in_C(numbExt, numbSpg, gs1, gs2, sys, ierr)
!
      USE General
      USE Laue, only: spgtxt
      implicit none
      integer gs1(*), gs2(*), numbExt(2), numbspg, ierr, SelectGroup,sys
!
!-- sys = 0  triclinic
!-- sys = 1  monoclinic a
!-- sys = 2  monoclinic b
!-- sys = 3  monoclinic c
!-- sys = 4  orthorombic
!-- sys = 5  tetragonal
!-- sys = 6  hexagogal
!-- sys = 7  cubic 
!-- sys = 8  rhombohedric
!-- numbExt(1) = elementi della prima tabella
!-- numbExt(2) = elementi della seconda tabella (pseudo)
!
!!      numbExt(1) = numbExt(1) + numbExt(2)
!!      numbExt(2) = 0
      ierr = SelectGroup(numbExt, numbSpg, gs1, gs2, sys, 
     *                   spgtxt//char(0))
!     write(0, *) 'Ext. group ', ierr
!     se torna -1, vuol dire che mi sono stufato e voglio sospendere il run
!
      return
      end
!-----------------------------------------------------------------------
      subroutine Get_AllCom (c_AllComm)
!
      USE Direttive
      USE commandsmod
      implicit none
!
*gl*  character beg,commen,allcom(80)*14
*gl*  common /charas/ beg,commen,allcom
!
      character c_AllComm(80)*14
      integer i, j, k, Lung
!
      do i=1,ipcom
         j=icomq(i,1)
         k=Lung(allcom(j))
         c_AllComm(j) = allcom(j)
         c_AllComm(j)(k+1:k+1) = char(0)
      end do
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AggiungiGruppo(ms)
!--main routine per 'Group Manager'
      USE General
!
      implicit none
!
      integer :: L, Lung, jopen, itipo, iform, jop, ier
      type (multistringa) :: ms
      character(len=256) :: groupfile, toAdd, code
!
      groupfile = ms%str1(1:ms%n1)
      toAdd     = ms%str2(1:ms%n2)
      code      = ms%str3(1:ms%n3)
      L = Lung(code)
      L = min0(L, 4)
      ier = 0
      call UpdateCommonAndList5(ier)
      itipo = 3
      iform = 1
      jop = jopen(jhost, groupfile, itipo, iform,ier)
      cardImage(1:4) = code(1:L)! codice del gruppo (i.e. VAL)
      cardImage(5:)  = toAdd    ! nome completo del gruppo (i.e. Valine)
      call outzmatNEW(ier)
      close(jhost)
!
      call DeallocaGruppi()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CancellaGruppo(ms)
      USE General
!
      implicit none
!
      integer :: jopen, itipo, iform, jop, ier, n, i
      integer :: Len1, Len2, Lung, k, k1, ka, kb
      character(len=256) :: groupfile, toDelete
      type (multistringa) :: ms
!
      ier = 0
!
      groupfile = ms%str1(1:ms%n1)
      toDelete = ms%str2(1:ms%n2)
      itipo = 2
      iform = 1
      jop = jopen(jhost, groupfile, itipo, iform,ier)
!
      itipo = 1
      iform = 1
      jop = jopen(iscra, ' ', itipo, iform,ier)
!
      Len1 = Lung(toDelete)
      read(jhost,'(a)') cardImage
      write(iscra,'(a)') cardImage
      read(jhost,'(a)') cardImage
      write(iscra,'(a)') cardImage
!
      k = 2
      do
         k = k + 1
         k1 = k
         cardImage = ' '
         read(jhost,'(a)',end = 10) cardImage
         read(cardImage,'(4x,i5)') n
         write(iscra,'(a)') cardImage
         do i=1, n
            k = k + 1
            read(jhost,'(a)') cardImage
            write(iscra,'(a)') cardImage
         enddo
         k = k + 1
         read(jhost,'(a)') cardImage
         write(iscra,'(a)') cardImage
         Len2 = Lung(cardImage)
         if (toDelete(1:Len1) == cardImage(1:Len2)) then
             ka = k1
             kb = k
         endif
      enddo
   10 rewind iscra
      rewind jhost
      k = 0
      do
         read(iscra,'(a)',end = 20) cardImage
         k = k + 1
         if (k < ka .or. k > kb) then
             write(jhost,'(a)') cardImage(1:Lung(cardImage))
         endif
      enddo

   20 close(jhost)
      close(iscra)
!
      call DeallocaGruppi()
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CopiaGruppo(ms, ier)
      USE General
!
      implicit none
      integer  ier
!
      integer :: jopen, itipo, iform, jop, n, i
      integer :: Len1, Len2,Lung, ifCopy
      character(len=256) :: source, destination, toCopy
      type (multistringa) :: ms
!
      ier = 0
      source      = ms%str1(1:ms%n1)
      destination = ms%str2(1:ms%n2)
      toCopy      = ms%str3(1:ms%n3)
      Len1 = Lung(toCopy)
      Len2 = Lung(destination)
!
      itipo = 2
      iform = 1
      jop = jopen(iscra, destination, itipo, iform,ier)
!
      read(iscra,'(a)') cardImage
      read(iscra,'(a)') cardImage
      do
         cardImage = ' '
         read(iscra,'(a)',end = 10) cardImage
         if (cardImage(1:Len1) == toCopy(1:Len1)) then
!mr             Msg = 'Group ' // toCopy(1:Len1) // ' already stored in ' //
!mr     *             char(10) // destination(1:Len2) // ' file !!!'
!mr             call MsgWinErr('Error',Msg, ERR_WINDOW, jop)
             ier = -1
             exit
         endif
         read(cardImage,'(4x,i5)') n
         do i=1, n
            read(iscra,'(a)') cardImage
         enddo
         read(iscra,'(a)') cardImage
      enddo
   10 close(iscra)
!
      if (ier < 0) return
!
      itipo = 2
      iform = 1
      jop = jopen(jhost, source, itipo, iform,ier)
!
      itipo = 3
      iform = 1
      jop = jopen(iscra, destination, itipo, iform,ier)
!
      read(jhost,'(a)') cardImage
      read(jhost,'(a)') cardImage
!
      ifCopy = 0
      do
         cardImage = ' '
         read(jhost,'(a)',end = 20) cardImage
         read(cardImage,'(4x,i5)') n
         if (cardImage(1:Len1) == toCopy(1:Len1)) then
             ifCopy = 1
             write(iscra,'(a)') cardImage(1:Lung(cardImage))
         endif
         do i=1, n
            read(jhost,'(a)') cardImage
            if (ifCopy == 1) then
                write(iscra,'(a)') cardImage
            endif
         enddo
         read(jhost,'(a)') cardImage
         if (ifCopy == 1) then
             write(iscra,'(a)') cardImage
             exit
         endif
      enddo
   20 close(iscra)
      close(jhost)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SetGruppoDefault(ms)
      USE General
      USE Groups
!
      implicit none
!
      integer :: L, Len1, Len2, Len3,Lung, ierr, ios
      type (multistringa) :: ms
      character(len=256) :: groupfile
!
      call DeallocaGruppi()
!
      groupfile = ms%str1(1:ms%n1)
      L = Lung(groupfile)
      grufle = groupfile(1:L)
      Len3 = Lung(fname(15))
      inquire (UNIT = lo, NAME = cardImage, IOSTAT = IOS, ERR =  10)
      Len1 = index(cardImage, char(47),.TRUE.)
      Len2 = index(cardImage, char(92),.TRUE.)
      Len1 = max0(Len1, Len2) + 1
      Len2 = Lung(cardImage)
      if (fname(15)(1:Len3) == cardImage(Len1:Len2)) then
          write(lo,20) grufle(1:L)
      endif
!
   10 return
   20 format(/,' Default Group File set to:',/,8x,a,/)
      end
!-----------------------------------------------------------------------
      subroutine DeallocaGruppi()
      USE Groups
!
      implicit none
!
      integer :: ierr
!
      if (ifGroupsAllocated == 1) then
          ifGroupsAllocated = 0
          deallocate (ResidCoords, ResidConn, ResidTable1, ResidTable2,
     *      ResidAtoms, AminoName, AminoNameLong, AminoContent, nitro,
     *      stat = ierr)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DrawGroups(ier, ifRBamb)
      USE General
      USE Molcom
      USE Atomi
      USE Groups
    
      implicit none
    
      integer ier
      integer ifRBamb
    
      integer           :: lsn, lixx, ljxx, lkxx, llxx, kBond
      integer           :: ll, kk, iFound, iser, mx, ncard, lz1, lz2,lz3
      integer           :: n, Lung, kridisegna, m, L, nchv, nh
      integer           :: nExitCode, i, ngr, nn1, nn2, NrotaC, kBondR
      character (len=16):: TmpLab
    
      return
      end
!-----------------------------------------------------------------------
      subroutine DrawOneGroup(iAction, ngr, ncard, ms)
!
!-- iAction = 1   -> Draw One Group
!--         = 0   -> Erase One Group
!
      USE General
      USE Molcom
      USE Atomi
      USE Groups
!
      implicit none
!
      integer iAction
      integer ngr
      integer ncard
      character (len=256) :: Gruppo
      type (multistringa) :: ms
!
      integer           :: ll, iFound, kBond
      integer           :: L, Len1, Lung, kridisegna, nh
      integer           :: i, kk, nn1, nn2
      character (len=16):: TmpLab
!
      Gruppo = ms%str1(1:ms%n1)
      if (iAction == 1) then
          kBond = 5
      else
          kBond = 1
      endif
!
      call shift(Gruppo, L)
      Buffer1 = Gruppo(1:L)
      iFound = 0
      do ll=1,ncard
         call cutst(Buffer1,Len1,Inte,L)
         call ucase(Inte(1:1))
         if (Inte(1:4) == 'Skip') then
             iFound = iFound + 1
             nzsav(iFound) = -1
         else
             do nh=1, NatMol
                TmpLab = Lab(nh)(1:Lung(Lab(nh)))
                if (TmpLab == Inte(1:16)) then
                    iFound = iFound + 1
                    nzsav(iFound) = nh
                    exit
                endif
             enddo
         endif
      enddo
!
      i = 0
      do
         i = i + 1
         nn1 = ResidConn(ngr,1,i)
         nn2 = ResidConn(ngr,2,i)
         if (nn1 == 0) exit
         nn1 = nzsav(nn1)
         nn2 = nzsav(nn2)
         if (nn1 < 0 .or. nn2 < 0) cycle
         do L=1, numLeg
            if ((LE(1,L) == nn1 .and. LE(2,L) == nn2) .or.
     *          (LE(1,L) == nn2 .and. LE(2,L) == nn1)) then
                 LE(3,L) = kBond
                 exit
            endif
         enddo
      enddo
!
      kk = kridisegna(kscrx,kscry,0)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine f_Rotamers(nrighe, input_par)
!--vecchio sistema
!
      USE General
      USE Molcom
      USE Groups
      implicit none
!
      integer*4     nrighe
      type megastringa
         character (len = 1000) :: stringa
         integer                :: n1
      end type
      type (megastringa) input_par
!
      integer itype, iform, jop, jopen, jcod
      integer kk, m, L, mx, ncard
      integer ier, nchv, L0, Len1, Len2, Lf, i, j, ll, iser, 
     *        lz1, lz2, lz3, iflagAmb
      integer n, Lung, NGruppi, iname
      real    Valore
!
      return
      end
!-----------------------------------------------------------------------
      subroutine DrawOneRotamer(iAction, ms)
!
!-- iAction = 1   -> Draw One Rotamer
!--         = 0   -> Erase One Rotamer
!
      USE General
      USE Molcom
      USE Atomi
      USE Groups
!
      implicit none
!
      integer iAction
      type (multistringa) :: ms
      character (len=256) :: Rotamero
!g    include 'molcom.fi'
!
      integer           :: ll, iFound, kBond
      integer           :: L, Len1, Lung, kridisegna, nh
      integer           :: i, kk, nn1, nn2
      character (len=16):: TmpLab
!
      Rotamero = ms%str1(1:ms%n1)
      if (iAction == 1) then
          kBond = 6
      else
          kBond = 5
      endif
!
      call shift(Rotamero, L)
      Buffer1 = Rotamero(1:L)
      nh = index(Rotamero, '-')
      Buffer1(nh:nh) = ' '
      iFound = 0
      do ll=1,2
         call cutst(Buffer1,Len1,Inte,L)
         call ucase(Inte(1:1))
         do nh=1, NatMol
            TmpLab = Lab(nh)(1:Lung(Lab(nh)))
            if (TmpLab == Inte(1:16)) then
                iFound = iFound + 1
                nzsav(iFound) = nh
                exit
            endif
         enddo
      enddo
!
      nn1 = nzsav(1)
      nn2 = nzsav(2)
      do L=1, numLeg
         if ((LE(1,L) == nn1 .and. LE(2,L) == nn2) .or.
     *       (LE(1,L) == nn2 .and. LE(2,L) == nn1)) then
              LE(3,L) = kBond
              exit
         endif
      enddo
!
      kk = kridisegna(kscrx,kscry,0)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine HideShowSpecies(ifShow, iSpecVet)
      USE General
      USE Atomi, only: nzTot
      USE Molcom
!
!-- ifShow  = 1   -> Show specie(s)
!--         = 0   -> Hide specie(s)
!-- iSpecVet(1:nSpec) dice se la specie e' selezionata oppure no
!
      implicit none
      integer  :: ifShow, iSpecVet(18), segno, i, j, nzt, kscala
      real     :: rrs
!
      if (ifShow  == 1) then
          segno = 1
      else
          segno = -1
      endif
      do i=1, NatMol
         rrs = abs(RS(i))
         if (rrs > 10.0) cycle
         nzt = nzTot(i)
         do j=1, nk
            if (iSpecVet(j) == 1 .and. j == nzt) then
                RS(i) = segno * rrs
            endif
         enddo
      enddo
!
      call FindMinMax
      kscala = 1
      call Disegna(kscala)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine CompareAtoms(cdist)
      USE General
      USE Dialogo
      USE Riflessi
      USE Atomi, only: nats, nz, nzSav, nzConst
      USE PhaseModule, only: ifExamin, ifTime
      USE TestModel, only: nzPub, distCoord
      USE Molcom, only: ifViewModel, SinglePlotType, selezione
!
      implicit none
      integer    :: iex, itype, iform, loSav, jop, jopen, ierr, interp
      integer    :: iref, ier, ksubr, knwSav, mode, ifBreak, iCoeff
      real       :: cdist, scalan
!
      if (nrefl <= 0) then
          call MsgWinErr('Error','No reflections loaded',ERR_WINDOW,iex)
          return
      endif
      if (ModelToCompare > 0) then
!
!-- save the current situation
!
          interp = 1
          call PutGetXyzs(1, interp)
          call SaveRestoreXyzs(1)
          if (allocated(selezione)) selezione(:) = SinglePlotType(:)
!
          if (.not. allocated(khl)) then
              call AllocaRiflessi(1)
              ksubr = 4
              call LeggiRiflessi(ier, ksubr)
              iex = sum(iphaz(1:nrefl))
              if (iex == 0) then
                  nzsav(1:nats) = nz(1:nats)
                  nz(1:nats) = nz(1:nats) / nzConst
                  iref = 0
                  mode = 0
                  scalan = 1.0
                  ifBreak = 0
                  iCoeff = 1
                  call sftryyyc(iref,mode,nrefl,scalan,ifBreak,iCoeff)
                  nz(1:nats) = nzsav(1:nats)
              endif
          endif
          if (khl(1,1) == 0 .and. 
     *        khl(2,1) == 0 .and. 
     *        khl(3,1) == 0) then
              ksubr = 4
              call LeggiRiflessi(ier, ksubr)
          endif
!
          loSav = lo
          lo = iscra
          cardImage = 'tmp.tmp'
          itype = 0
          iform = 1
          jop = jopen(iscra, cardImage, itype, iform, ierr)
          call AllocaTestStuff(1)
*         if (.not.allocated(nzPub)) then
*             call AllocaTestModel(1)
*         endif
          if (abs(distCoord - cdist) > 0.01) then
              distCoord = cdist
          endif
!
          call DoSingleIteration()
!
          ifExamin = 1
          knwSav = knw
          knw = 1
          ifTime = 0
          call to_coord_sir(1,nrefl)
          knw = knwSav
          iex = ifViewModel
          ifViewModel = 0
          ModelToCompare = 2
          call ModificaCoordinate()
          ifViewModel = iex
          call Disegna(0)
          lo = loSav
          close(iscra)
          Inte = 'Comparison results'
          call CDialogo (Inte, cardImage, -1)
      else
          call MsgWinErr('Error','No model loaded',ERR_WINDOW,iex)
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine PalleAlCentro(stringa)
      USE General
      USE Atomi
      USE Molcom
      USE TestModel
!
      implicit none
      integer L1, L2, Lung, i, found, ifsca, iAction
      real xd, yd, zd, zoom
      character*(*) stringa
!
      call shift(stringa,L1)
      L1 = index(stringa,' ') - 1
      found = 0
      do i=1, nats
         L2 = Lung(aLab(i))
         if (stringa(1:L1) == aLab(i)(1:L2)) then
             found = i
             exit
         endif
      enddo
      if (found == 0) then
          return
      endif
!
!-- reset the view
!
      ifScale = 1
      call SetScale(0)
      call FindMinMax
      call Disegna(ifScale)
!
!-- compute shift to apply
!
*     call MoveBaric(found, found, iActive)
*     go to 1
      xd = xyz(1, found)
      yd = xyz(2, found)
      zd = xyz(3, found)
!
!-- shift SIR coordinates
!
      do i=1, NatMol
         xyz(1, i) = xyz(1, i) - xd
         xyz(2, i) = xyz(2, i) - yd
         xyz(3, i) = xyz(3, i) - zd
      enddo
!
!-- shift Model coordinates
!
      do i=1, nCoordPub
         xyzPub(1, i) = xyzPub(1, i) - xd
         xyzPub(2, i) = xyzPub(2, i) - yd
         xyzPub(3, i) = xyzPub(3, i) - zd
      enddo
!
!-- Zoom in
!
       iAction = 6
       zoom = 20
       call Translate(iAction, zoom)
!
!-- shift Min & Max values
!
*     Xmin = Xmin - xd
*     Ymin = Ymin - yd
*     YMax = YMax - yd
*     XMax = XMax - xd
*     RMAX1 = XMax
*     RMAX2 = YMax
!
!-- draw !!!
!
      ifScale = 0
      call Disegna(ifScale)
      call DoSingleIteration()
!
      return
      end
!-----------------------------------------------------------------------
!!mr      subroutine Supplementary(ier)
!!mr      USE General
!!mr      USE Dialogo, only : iPlotType
!!mr      USE Html
!
!!mr      implicit none
!!mr      integer :: ier, l, Lung, kk, itype, iform, jop, jopen
!!mr      integer :: loSav, iPlt, ifSingle, nExitCode, icod
!
!!mr      l = Lung(fname(15))
!!mr      if (l == 0) then
!!mr          Msg = 'No information available at the moment, try later.'
!!mr          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
!!mr          ier = -1
!!mr          return
!!mr      endif
!
!!mr      ier = 0
!!mr      call UpdateCommonAndList5(ier)
!
!!mr      kk = index(fname(1),'.bin')
!!mr      cardImage = fname(1)(1:kk-1) // '_supplementary.txt'
!!mr      itype=0
!!mr      iform=1
!!mr      jop=jopen(ktml,cardImage,itype,iform,ier)
!!mr      itype=1
!!mr      iform=1
!!mr      jop=jopen(jrel ,'       ',itype,iform,ier)
!!mr      call sirdate(Inte,icod)
!!mr      HTMLdate = 'Date: ' // Inte(1:icod)
!!mr      HTMLname = 'Structure name: ' // fname(1)(1:kk-1)
!!mr      Inte = 'Supplementary information'
!!mr      call HTML_header(ktml,' ',Inte)
!
!!mr      write(ktml,20)
!!mr      loSav = lo
!!mr      lo = ktml
!!mr      call  SupMaterialwrtNEW(ier)
!!mr      lo = loSav
!
!-- fine
!
!!mr      close(jrel)
!!mr      close(ktml)
!
!-- redraw
!
!!mr      call PrintMess(' ')
!!mr      iPlt = iPlotType
!!mr      ifSingle = 1
!!mr      call MolPlo(iPlt, ifSingle)
!
!!mr      return
!!mr   20 format('<pre><font size="2" ',
!!mr     *       'style="font-family: courier new,courier,monospace;">')
!!mr      end
!-----------------------------------------------------------------------
      subroutine view_coord()
!
      kBro = 10
      call BrowserV2(kBro)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine GetDistance(cdist)
      USE TestModel
!
      real cdist
!
      cdist = distCoord
!
      return
      end
!-----------------------------------------------------------------------
      subroutine SetToggles(cifViewMod, cifLabelsPub)
      USE Molcom, only: ifViewModel, ifLabelsPub, ifScale
!
      implicit none
      integer    cifViewMod, cifLabelsPub, iex
!
      ifViewModel = cifViewMod
      ifLabelsPub = cifLabelsPub
!
!-- reset the view
!
      ifScale = 1
      call SetScale(0)
      call FindMinMax
      call Disegna(ifScale)
!
      if (ifViewModel == 1) then
          ifScale = 0
          iex = 0
          call Disegna(iex)
      else
!
!-- reset the view
!
          ifScale = 1
          call SetScale(0)
          call FindMinMax
          call Disegna(ifScale)
      endif

!
      return
      end
!-----------------------------------------------------------------------
      subroutine ChiusaCompare
      USE Atomi
      USE Molcom
*     USE RemoModule, only : SinglePlotType
!
      implicit none
      integer :: ifDentro, iZero, kbuild, nadd, i, j, NATV, lista
      real    :: x1(3), x2(3), B(3, 3)
      ModelToCompare = 1
      ifViewModel = 0
!
!-- restore the previous situation
!
      call SaveRestoreXyzs(2)
      lista = 15
      if (allocated(selezione)) SinglePlotType(:) = selezione(:)
      call Leggi15_5(lista)
      call PutModel
!
      call GetModel
      if (ifCont == 1) then
         NATind = nats
         ifDentro = 1
         iZero = 0
         kbuild = 0
         call GeneraAppSym(ifDentro, iZero, kbuild, nadd)
         call FindMinMax
      else
         do i=1, NatMol
             x1(1:3)=xyzs(1:3,i)
             call MoltMatVec(rm, x1, x2)
             xyz(1:3,i) = x2(1:3)
             SinglePlotType(i) = iPlotType
         enddo
         call AggiuSpig
         call LsPlane(NATV, 1)
         call GetBonds(1)
!
         Rmin1 = 99999.
         Rmin2 = 99999.
         RMAX1 = -99999.
         RMAX2 = -99999.
!
         do i = 1 , 3
            do j = 1 , 3
               BTot(i, j) = 0
            enddo
            BTot(i, i) = 1
         enddo
         call FindOr(B, 1)
!
      end if
      call Disegna(0)
      call DoSingleIteration()
!
      return
      end
!-----------------------------------------------------------------------
      integer function ifOxigen(k)
!
      USE General
      USE Atomi
!
      implicit none
      integer i, k
!
      i = iabs(nz(k)) / nzConst
      if (no(i) == 8) then
          ifOxigen = 1
      else
          ifOxigen = 0
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine StringiLabel()
!
      USE General
      USE Atomi
!
      implicit none
      integer i, k, Lung, lLab
!
      lLab = 8
      do i=1, nats
         aLab30(i) = ' '
         Labb = aLab(i)
         call StringiStringa(Labb, 8)
*        k = Lung(Labb)
*        if (k > lLab) then
*            aLab30(i)(1:3) = Labb(1:3)
*            aLab30(i)(4:5) = '..'
*            aLab30(i)(6:8) = Labb(k-2:k)
*        else
*            aLab30(i) = Labb
*        endif
         aLab30(i) = Labb
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine StringiStringa(stringa, nChars)
!
      USE General
      USE Atomi
!
      implicit none
      integer i, k, Lung, nChars
      character*(*) stringa
!
      Buffer1 = stringa
      k = Lung(Buffer1)
      if (k > nChars) then
          i = (nChars - 2) / 2
          stringa(1:i) = Buffer1(1:i)
          stringa(i+1:i+2) = '..'
          stringa(i+3:) = Buffer1(k-2:k)
      endif
!
      return
      end
! -----------------------------------------------------------------------
      subroutine GetCrystFamily(formt, ier)
      USE General
      USE Symmetry, only : ifLaue
      USE Molcom, only : jscreen
!
      implicit none
      integer :: i, ki, ko, msys, ier
      real   :: ac(6), errac(6)
      character (len=80) formt
!
!
!-- set msys 
!     msys=0  tricl. 
!     msys=1  mono a
!     msys=2  mono b
!     msys=3  mono c
!     msys=4  ortor. 
!     msys=5  tetrag. 
!     msys=6  hexag. 
!     msys=7  cubic 
!     msys=8  rhombo. 
!
      msys = 0
      ac(1:6)    = cell(1:6)
      errac(1:6) = errcell(1:6)
      if (errcell(1) <= 0.0) then
          errac(1:6) = ac(1:6) / 1000.0
      endif
!
!--alfa=beta=gamma
!
      if (abs(ac(4)-ac(5)).le.0.5*(errac(4)+errac(5)).and.
     1    abs(ac(4)-ac(6)).le.0.05) then 
!
!--a=b=c
!
          if (abs(ac(1)-ac(2)).le.0.5*(errac(1)+errac(2)).and.
     1        abs(ac(1)-ac(3)).le.0.5*(errac(1)+errac(3))) then 
              msys = 8 
              if (abs(ac(4)-90.).le.0.05) msys = 7 
!
!--a=b
!
          elseif (abs(ac(1)-ac(2)).le.0.5*(errac(1)+errac(2))) then
              msys = 5 
          else                                   
!
!--a.ne.b.ne.c
!
              msys = 4 
          endif                                    
!
!--alfa=beta=90
!
      elseif (abs(ac(4)-ac(5)).le.0.5*(errac(4)+errac(5)).and.
     1        abs(ac(4)-90.).le.0.05) then
              msys = 3
              if (abs(ac(6)-120.).le.0.05) msys = 6
!
!--alfa=gamma=90
!
      elseif (abs(ac(4)-ac(6)).le.0.5*(errac(4)+errac(6)).and.
     1        abs(ac(4)-90.).le.0.05) then
              msys = 2
!
!--beta=gamma=90
!
      elseif (abs(ac(5)-ac(6)).le.0.5*(errac(5)+errac(6)).and.
     1        abs(ac(5)-90.).le.errac(5)) then
              msys = 1
      endif
!
*     write(0,*)       
*    1      '      Crystal System determination',
*    1     ' by geometrical analysis of the cell:'
*     if (msys == 0) write(0,*)
*    1    '                         TRICLINIC  '
*     if (msys == 1) write(0,*)
*    1    '                        MONOCLINIC Unique axis a '
*     if (msys == 2) then
*             write(0,*)
*    1'                        MONOCLINIC Unique axis b '
*     elseif (msys == 3) then
*             write(0,*)
*    1'                        MONOCLINIC Unique axis c '
*     elseif (msys == 4) then
*             write(0,*)
*    1'                        ORTHORHOMBIC  '
*     elseif (msys == 5) then
*             write(0,*)
*    1'                        TETRAGONAL  '
*     elseif (msys == 6) then
*             write(0,*)
*    1'                    TRIGONAL or HEXAGONAL  '
*     elseif (msys == 7) then
*             write(0,*)
*    1'                          CUBIC'
*     elseif (msys == 8) then
*             write(0,*)
*    1'                        RHOMBOHEDRAL  '
*     endif
*     write(0,*)' '
!
      call CheckDifferentCrystFamily(formt, msys, ier)
      if (ier < 0) then
          if (ier == -2) then
              ier = 0
          endif
          return
      endif
      if (jscreen > 0) then
          ki = msys + 1
!         call GetCrystFamilyFromGraphic(ac, ki, ko)
          ko = 1
*         write(0,*) 'ifLaue',ifLaue,' In uscita',ko
      else
          ko = 1
      endif
      if (ko > 1) then
          ifLaue = (ko - 2) + 10
      endif
*     write(0,*) 'ifLaue',ifLaue
!
      return
      end
! -----------------------------------------------------------------------
      subroutine ClickForSite(iAction)
      USE Atomi
      USE Molcom
!
      implicit none
      integer :: iAction, i, XX1, YY1, ira, IfF, iColRestr
!
      iColRestr = color_RESTR
      if (iAction == 1) then    !deve evidenziare gli atomi
          SelectingSites = 1
          do i=1, nats
             if (iSite(i) == 0) cycle
             XX1 = ipix(1, i)
             YY1 = ipix(2, i)
!gl!         write(0,*) i, XX1, YY1
             if (iPlotType == STICKS) then
                 ira = 25
             else
                 ira = 15
             endif
             IfF = 0
             Call Cerchio(XX1, YY1, ira, iColRestr, IfF, iColRestr)
          enddo
!gl!      write(0, *) 'Evidenzia'
      else                      !basta evidenziare
          SelectingSites = 0
!gl!      write(0, *) 'Non evidenzia'
      endif
!
      call DoSingleIteration()
!
      return
      end
! -----------------------------------------------------------------------
      subroutine SalvaConNome(filename, estensione, ex)
      USE General
      USE Dialogo
!
!-- ex = 1 Overwrite
!-- ex = 0 Cancel
!
      implicit none
      integer :: L, Lung, nExitC, c_saveas, ex, k
      logical :: Esiste
      character (len=*) :: filename, estensione
!
      ex = 1
      inquire (file=filename,  exist = Esiste)
      if (Esiste) then
          L = Lung(filename)
          Msg = 'The file ' // filename(1:L) //
     *          ' already exists. Do you want to overwrite it?'
          call MsgWinErr(Inte, Msg, QUEST_WINDOW_YES_NO, nExitC)
          if (nExitC == 2) then
              FileNameMod = filename(1:L) // char(0)
              ex = c_saveas(estensione//char(0))
              if (ex == 1) then
                  L = Lung(FileNameMod)
!!mr                  k = index(FileNameMod,slash, .TRUE.)
!!mr                  filename = FileNameMod(k+1:L)
                  filename = FileNameMod(1:L)
              endif
          endif
      endif
!
      return
      end
! -----------------------------------------------------------------------
      subroutine LanciaJavs(ifMappa, ifDifference)
      USE General, only: StructureName, nrefl, celem
      USE Riflessi
      USE variables
      USE Atomi
      USE ilmviewmod
      USE atom_type_util
      USE sinterface
      USE proginterface
!
      implicit none
      integer :: ier, ksubr, ifMappa, ifDifference
!
      if (nats > 0) then
!!mr          call ModCom(0)
!!mr
          ier = 0     !! mr
          call UpdateCommonAndList5(ier)
          if(ier /= 0) return
!!mr
!corr          if (.not.allocated(atm)) then
*             call xyz_to_atom(atm,xyzs(:3,:nats),
*    *             bfac,bij,xyzs(5,:),occpch,nz,aLab,xyzs(4,:))
              call xyzs_to_atom(atm)
              call nk_to_elem(celem)             !!mr
!corr          endif
!
!-- check on reflections
!
          if (nrefl > 0) then
              if (.not.allocated(fovet)) then
                  call AllocaRiflessi(1)
              endif
              if (sum(fovet(1:nrefl)) < 0.01) then
                  ksubr = 4
                  ier   = 0
                  call LeggiRiflessi(ier, ksubr)
              endif
          endif
!!mr          call jav_set_style(5, 1)
!!        call ilmview_open()
          call ilmview_open(StructureName)
          call ilmview_load_bond_table()
          call ilmview_draw(atm,icon=iconn)
      endif
!
      if(ifMappa == 1) then
         call ViewMap(ifDifference+1)
      endif
!
      return
      end subroutine LanciaJavs
!-----------------------------------------------------------------------
      subroutine ViewMap(ifDiff)
      USE General
      USE Mappa
!
      integer     :: ifDiff
!
      xmapDif(:,:,:) = xmap(:,:,:)
      call PassaMappa('mappa'//char(0), 1, 1, np, nrefl, resm, ifDiff)
!     call PassaMappa
!
      return
      end subroutine ViewMap
!-----------------------------------------------------------------------
      subroutine AggiornaJav
      USE Atomi
      USE variables
      USE ilmviewmod
      USE atom_type_util
      USE RemoModule, only: WhichModel
      USE sinterface, only: bij_atom             !!mr
!
      implicit none
!
      if (jav_opened()) then
          call PutModel
          call xyz_to_atom(atm, xyzs(:3,:nats),
!!mr *         bfac, bij,xyzs(5,:), occpch, nz, aLab, xyzs(4,:))
     *         bfac, bij_atom(bij),xyzs(5,:), occpch, nz, aLab,
     *         xyzs(4,:))
          call ilmview_draw(atm, icon=iconn, kmodel=WhichModel)
*         call PassaModello(atom, legm, cell, natom, natom, numlegs, 
*    *                     no, nk, radii, nzConst, kreset, infos, icent)
      endif
!
      return
      end
! -----------------------------------------------------------------------
      subroutine ManageJavHydro(natsOld)
!
!-- gestisce gli eventuali idrogeni generati da Jav 
!
      USE Atomi
      USE Molcom, only : rm, iPlotType, SinglePlotType
!
      implicit none
      integer :: i, j, k, nzNew, nzOld, natsOld
      real    :: xc(3), xh(3), xc1(3), xh1(3), arg, dist
!
      nzo(natsOld+1:) = 0
      do i=1, nats
         nzOLd = nzo(i) / nzConst
         nzNew = nz(i) / nzConst
         if (nzNew == 1 .and. nzOLd == 0) then
             SinglePlotType(i) = iPlotType
             xh(1:3) = xyzs(1:3,i)
             call MoltMatVec(rm, xh, xh1)
             do j=1, natsOld
                if (i == j) cycle
                xc(1:3) = xyzs(1:3,j)
                call MoltMatVec(rm, xc, xc1)
                arg = 0.0
                do k=1, 3
                   arg = arg + (xh1(k) - xc1(k)) ** 2
                enddo
                dist = sqrt(arg)
                if (dist < 1.15) then
                    iGeomAtom(i) = j
                    exit
                endif
             enddo
         endif
      enddo
!
      return
      end
!-----------------------------------------------------------------------
! -----------------------------------------------------------------------
      real function GetMaxDim()
      USE General, only: cell
!
      implicit none
!
      GetMaxDim = maxval(cell(1:3))
!
      end function GetMaxDim
!-----------------------------------------------------------------------
      subroutine fCube(idx, idy)
      USE Molcom
!
      implicit none
      common /SaveRbyM/ ifDragged, B(3,3), iDxV, iDyV,
     *                  ifLabelsDrag, iPlotTypeDrag
      integer :: i, j, idx, idy, ifs, ifscaleSav, ifDraggedSav
      integer :: ifDragged, iDxV, iDyV, ifLabelsDrag, iPlotTypeDrag
      integer :: ifLabelSav
      real    :: B, delta(3)
!
      if (ifCubo == 1) then
          ifs = 0
          call Disegna(ifs)
      else
          delta(1) = float(idx) / x11scale(1)
          delta(2) = float(idy) / x11scale(2)
          do i=1,9
             j = NatMol + NatSpi + i
             xyz(1, j) = xyz(1, j) + delta(1)
             xyz(2, j) = xyz(2, j) - delta(2)
          enddo

          j = NatMol + NatSpi + 9
          
          ifDraggedSav = ifDragged
          ifscaleSav = ifscale
*         ifLabelSav = ifLabels
          ifDragged = 1
*         ifLabels  = 0
          ifs = 0
          call Disegna(ifs)
          ifDragged = ifDraggedSav
          ifscale = ifscaleSav
*         ifLabels  = ifLabelSav
          ifCubo = 1
      endif
!
      end subroutine fCube
!-----------------------------------------------------------------------
      subroutine BeccaAtomi(atomi_per_c, n)
!
      USE Molcom, only: Lab
!
      implicit none
      character  (len=17) :: atomi_per_c
      integer             :: n
!
      atomi_per_c = Lab(n+1) // char(0)
      
!
      end subroutine BeccaAtomi
!-----------------------------------------------------------------------
      subroutine ClessidraOnOff(iAction)
      USE Molcom, only : jscreen
!
!-- iAction = 1 Clessidra on
!-- iAction = 2 Clessidra off
!
      implicit none
      integer :: iAction
!
      if (jscreen > 0) then
          call c_clessidra_on_off(iAction)
          call DoSingleIteration()
          call zflush            !mr1701
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine UpdateCellContent(newNW)
      USE General
      USE Properties
!
      implicit none
      integer :: newNW(18), k, c_updatecellcontent
!
      k = c_updatecellcontent(newNW)
      if (k == 1) then     !  se OK nella finestra di update
          nw(1:nk) = newNW(1:nk)
          AtmProperties(WhichProps)%natsInCell(1:nk) = nw(1:nk)
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine GetNewNw(nw_forC)
!
      USE General, only: nw
      implicit none
      integer nw_forC(*)
!
      nw_forC(1:18) = nw(1:18)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine PutNewNw(nw_forC)
!
      USE General, only: nw
      implicit none
      integer nw_forC(*)
!
      nw(1:18) = nw_forC(1:18)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine StartStopMsg(iAction)
!
      implicit none
      integer :: iAction
!
      if (iAction == 1) then
          call showmesg()
      else
          call hidemesg()
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine NVisualizzatore(ind,ix,iy,str)
!
!     ind = 1  ! Open Viewer
!     ind = 3  ! Restore Main Window
!     ind = 4  ! Restore Viewer
!     ind = 5  ! Destroy Viewer
!
      implicit none
      integer             :: ind, ix , iy , ifRes, lstr, Lung
      external OnResize, OnZoom
      common /string/ x11string
!
      character x11string*257
      character str*(*)
!
!-----code for Unix
      x11string = ' '
      if (ind.le.2) then
          lstr=Lung(str)
          if (lstr.gt.0) then
              x11string(1:lstr) = str(1:lstr)
          else
              lstr = 0
          endif
          x11string(lstr+1:lstr+1) = char(0)
      else
          x11string = ' ' // char(0)
      endif
!
      ifRes = 1
!!!mr      ifRes = 0
      call NuovoVisualizzatore(ind, ix , iy , ifRes, x11string,
     *                         OnResize, OnZoom)
!
      return
      end
! ----------------------------------------------------------------------
      integer function IfFortranWork()
      USE grexpomod
      implicit none
!
      if (fortran_work) then
          IfFortranWork = 1
      else
          IfFortranWork = 0
      endif
!
      return
      end function IfFortranWork
! ----------------------------------------------------------------------
      subroutine OnZoom_event(action)
      USE grexpomod
      !USE sannel
      implicit none
      integer       ::action
      integer :: np,nrid
!
      select case(action)
         case (0)         ! Resize dell'immagine
           grgraph%zoom = .false.
         case (1,-1)      ! Zoom +/-
           call gr_zoom_graph(grgraph,action,0.2)
      end select
      call gr_select_viewer(1)
      call gr_clear_area(0.0,1.0,0.0,1.0)
      call gr_area(0.08, 0.99, 0.10, 0.99)     ! perche? 
      call gr_draw_graph(grgraph,grplot)
      call zflush()
      call gr_select_viewer(0)
!
      return
      end
! ----------------------------------------------------------------------
      subroutine OnClose()
      USE Dialogo, only : viewerOpened
      USE grexpomod
      USE molcom
      implicit none
!      
      if (fortran_work) then
          ifBrekke = 8
      else
          viewerOpened = 1
          call gr_close_viewer()
      endif
!
      end subroutine OnClose
! ----------------------------------------------------------------------
      subroutine OnResize(x , y)
      USE grexpomod
      USE molcom
      implicit none
      integer :: x,y
      xresize = x
      yresize = y
      if (fortran_work) then
!         delego al fortran il redraw del grafico - necessario per computer lenti
          ifBrekke = 6
      else
          call OnResize_event(x , y)
      endif
      return
      end

! ----------------------------------------------------------------------
      subroutine OnResize_event(xsize, ysize)
      USE grexpomod
!
      implicit none
      integer       :: xsize,ysize
!
      if (allocated(grplot)) then
         !call new_viewer_size(xsize,ysize)
          call gr_select_viewer(1)
          call gr_init(1,xsize,ysize)
          call gr_clear_area(0.0,1.0,0.0,1.0)
          call gr_area(0.08, 0.99, 0.10, 0.99)
          call gr_draw_graph(grgraph,grplot)
          call zflush()
          call gr_select_viewer(0)
      endif
!
      return
      end
! ----------------------------------------------------------------------
      subroutine OnZoom(action)
      USE Molcom
      USE grexpomod, only:fortran_work
      implicit none
      integer :: action
      if (fortran_work) then
          select case(action)
            case (1)           ! Zoom + 
              ifBrekke = 3
            case (-1)          ! Zoom -
              ifBrekke = 4
            case (0)
              ifBrekke = 5     ! Show All
          end select
      else
          call OnZoom_event(action)
      endif
      return
      end
! ----------------------------------------------------------------------
      subroutine OnOpen()
      USE molcom
      USE grexpomod
      implicit none
!      
      if (viewerOpened == 0) then
          if (fortran_work) then
              ifBrekke = 7
          else
              call OnOpen_event()
          endif
      endif
      end subroutine OnOpen
! ----------------------------------------------------------------------
      subroutine OnOpen_event()
      USE molcom
      USE grexpomod
      implicit none
!      
      call gr_open_viewer(500,270,"CF vs. number of moves",
     *newv=.true.)
      call gr_area(0.08, 0.99, 0.10, 0.99)
      call gr_draw_graph(grgraph,grplot)
!!corr      call zflush()
      call gr_select_viewer(0)
      end subroutine OnOpen_event
! ----------------------------------------------------------------------
      subroutine CheckGhostsForC(ier)
!
      implicit none
      integer   ::ier
!
      call UpdateCommonAndList5(ier)
!
      end subroutine CheckGhostsForC
! ----------------------------------------------------------------------
      integer function c_putrefl(Megastringa, iff2)
      USE General
      USE Symmetry
      USE Riflessi
      USE Molcom
      USE PhaseModule
      USE RiflessiInfo
      USE WrReIn
!
      character*(*) MegaStringa
      integer ier
      integer iff2
!
      common /DataToNormal/ jumpData, btData, nstrData, enData, negF
      character*80 formt, Buffer
!
      Msg = Megastringa(1:Lung(Megastringa))
      ier = 0
!
      th      = 99999999
      resmin  = 99999
      iffsq = iff2
      ifo2  = iff2
! -- calculate number of reflexions for (sem)invariant searching
      mn = int(4.5*anat+100.5)
      if (nsym.eq.1) mn = mn + 50
      nstr = min0(mn,maxstr)
      nstr=mn+min0(maxstr-mn,100)/2
!
      call Chiocciola(Msg, ReflFileName,0)
      call Chiocciola(Msg, formt,1)
      LL = Len_Trim(formt)
      if (formt(LL:LL).eq.'k'.or.formt(LL:LL).eq.'K') then
         formt(LL:LL) = ' '
         knw = 1
      end if
!
      ReflFileForm = formt
      call Chiocciola(Msg, Buffer,0)
      ksigma = Valore(Buffer)
      call Chiocciola(Msg, Buffer,0)
      ifUserThFact = Len_Trim(Buffer)
      if (ifUserThFact.ne.0) then
          jumpData = 0
          btData   = Valore( Buffer )
      else
          jumpData = -1
          btData   = 0.0
      endif
!
      call Chiocciola(Msg, Buffer,0)
      if (Buffer(1:1).ne.' ') then
          resm = Valore( Buffer )
      else
          resm = -99999
      endif
      ifMatOr = 0
      ij=0
      do i=1,3
         do j=1,3
            ij = ij+1
            call Chiocciola(Msg, Buffer,0)
            MatOr(i,j) = nint( Valore( Buffer ) )
            if (i.eq.j.and.MatOr(i,j).ne.1) then
                ifMatOr = 1
            elseif (i.ne.j.and.MatOr(i,j).ne.0) then
                ifMatOr = 1
            endif
         enddo
      enddo
!
      call Chiocciola(Msg, Buffer,0)
      nPerCard = nint( Valore( Buffer ) )
!
      listRefl = 10
      ifGener  = -1
      nzro = maxpsi
!!    ksigma = 1
      jscreenS = jscreen
**    jscreen = 3
!
      call scrper(' Reading data ',0,-1)
!
      itype=1
      iform=2
      kop=kopen(iscra,' ',nlenBin,itype,ierr)
      itype=1   ! scratch
      itype=0   ! NON scratch
      iform=1
      jop=jopen(jhost,'newproj4.txt',itype,iform,ier)
      loSav = lo
      lo = jhost
      if (neutro == 2) then
*         call WriteContInfo(formt,npq,ier)
          npq = 0
          call WriteContInfo(npq,ier)
      endif
      call DefineSize()
      icomat = 1
! -- read reflexion data from cards
      call LoadReflections(formt, nrefp, npq, ier)
      if (ier.ge.0) then
! --
! -- create list 6 ( reflections )
! --
          call CreaRiflessiNew(npq)
          InfoOK(6) = 1
          nreflDim = nrefltot
          call AllocaRiflessi(1)

          ifMercedes = 0
          call norm2000(ifMercedes, ier)
          if (ier.ge.0) then
              if (nsym.eq.1.and.icent.eq.0) then
                  ifP1 = 1
              else
                  ifP1 = 0
              endif
              call DefineBlocksEtc()
              call AllocaRiflessi(2)
              if (refl_info%nrefl > 0) then
                  InfoOK(6) = 1
              endif
          endif
      endif
      close(jhost)
      close(iscra)
      jscreen = jscreenS
      lo = loSav
      call scrper(' ',0,-1)
      call newproject_end(2)
      c_putrefl = ier
!
      return
      end
!---------------------------------------------------------------------
      subroutine no_more_crosses ()
      USE Molcom
!
      nptrc = 0
      nLabelHyd = 0
      ifHydrobase = 0
      call Disegna(0)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ModelToPlot2(wM)
      USE General
      USE RemoModule
      USE Symmetry
      USE connect_mod
      USE atom_type_util
      USE progtype
      USE javinterface
      USE realloc
      USE ilmviewmod
      USE model_util
!
      implicit none
      integer       :: nAtoms, nb, nspec, nAt_au
      integer       :: i, i1, i2, wM
      real          :: di
      type(atom_type), dimension(:), allocatable :: atom
      type(bond_type), dimension(:), allocatable :: legame
!
      WhichModel = wM
      nAtoms = natsInModel(WhichModel)
      nAt_au = nAtoms
      nb = BondsInModel(WhichModel)
      nspec = Model(wM)%nk
      nw(1:18) = Model(wM)%nw(1:18)
      modelview(1)%at(:)%nz = pxen_from_nz(modelview(1)%at(:)%nz)


      call reallocate(atom, nAtoms, .false.)
      call fromModelToAtom(atom)
      call reallocate_legm(legame, nb, .FALSE.)
      do i=1, nb
         i1 = Bonds(WhichModel)%Legami(1,i)
         i2 = Bonds(WhichModel)%Legami(2,i)
         di = Bonds(WhichModel)%Legami(4,i)
         legame(i)%n1 =   i1  ! primo atomo del legame
         legame(i)%n2 =   i2  ! secondo atomo del legame
         legame(i)%dist = di  ! secondo atomo del legame
      enddo
      num_models = 2
      call ilmview_draw(atom,legame,kmodel=WhichModel)
      do i=1,wM     ! ricostruisco l'nz
         modelview(i)%at(:)%nz=nz_from_pxen(modelview(i)%at(:)%nz,celem)
      enddo
      call Set_Style(4, WhichModel)          ! Rods
!
      return
      end
!-----------------------------------------------------------------------
      real function GetXMap(i, j, k)
      USE Mappa
!    
      implicit none
      integer       :: i, j, k
!    
      GetXMap = xmapDif(i,j,k)
!    
      return
      end
!-----------------------------------------------------------------------
      subroutine GetLigandInfo(ifLig, vett, cella)
      USE General, only: cell
      implicit none
      integer ifLig, i
      real    vett(3), cella(3)
!
      do i = 1, 3
         vett(i) = 0
         cella(i) = cell(i)
      end do
      ifLig = 0
!
      return
      end

!-----------------------------------------------------------------------
      subroutine PassaNewVolume(abc, xc, iFlag)
      implicit none
      integer i, iFlag
      real    abc(3), xc(3)
!
      return
      end

!-----------------------------------------------------------------------
      subroutine ResetVolumeInfo()
      USE General
      USE Mappa
      USE Param
!
      implicit none
!
      xmapDif(:,:,:) = xmapApp(:,:,:)
      call PassaMappaParz(trim(cardDiret)//char(0), 1, 1, np, nrefl,
     *                    resm, denmin, denmax, avden, stden, 1)
!
      return
      end

!-----------------------------------------------------------------------
      integer function get_content_from_formula(line, v1, v2)
!
      USE elements
      implicit none
      character(len=*)                              :: line
      type(element_type), dimension(:), allocatable :: celem
      integer, dimension(*)                         :: v1, v2
      integer                                       :: ier, Lung, i, n
!
      call read_chemformula(line,ier,elem=celem)
      if (ier > 0) then
          get_content_from_formula = -1
      else
          n = size(celem)
          get_content_from_formula = n
          do i=1, n
             v1(i) = celem(i)%nw
             v2(i) = celem(i)%z
          end do
      endif
!
      return
      end

!-----------------------------------------------------------------------
      subroutine CloseAllViewers()
!
      call CloseViewers()
!
      return
      end

!-----------------------------------------------------------------------
      subroutine importa_file2(input_par)
      USE Molcom
      USE General
      USE ilmviewmod
!!!!!!FIXME - si potrebbe passare una sola stringa che contiene dir + name
!
!     input_par%str1 = nome del frammento o file da importare
!     input_par%str2 = directory in cui si trova il file
!
      implicit none
      type (multistringa)  ::input_par
      integer :: n1,n2
!
      call ilmview_open(input_par%str1)
      n1 = input_par%n1
      n2 = input_par%n2
      call jav_import_structure
     *  (input_par%str2(1:n2)//input_par%str1(1:n1)//char(0),0,1)
!
      return
      end
!-----------------------------------------------------------------------

