!-----------------------------------------------------------------------
      MODULE RFreeModule
!
          real, allocatable :: RFreeVett(:)
!
      END MODULE RFreeModule
!-----------------------------------------------------------------------
      MODULE ArpWarp
             real      :: RfacAW = 0.999
             real      :: RfreAW = 0.999
             real      :: RfacAWi = 0.999
             real      :: RfreAWi = 0.999
             character (len=50)  :: erreAW
!
      END MODULE ArpWarp
!-----------------------------------------------------------------------
c-- sir code for data command                            Release 90.01
      subroutine datasir(newf,ier)
      USE General
      USE Symmetry
      USE Riflessi
      USE Grafici
      USE Atomi
      USE PhaseModule
      USE Param
c--
c          struttura del buffer vet/ivet
c
c     h   k   l   fo sigma  fasi 
c     1   2   3   4    5     6  
c----------------------------------------------------------------------
c   lista 7
c     h+k+l    e       fo   e'+e'p    phi'+phi+code  sigma 
c       1      2       3       4            5          6
c   scompattati in                       
c     h   k   l   e   fo    e'   e'p  fasi  sigma 
c     1   2   3   4    5     6    7     8     9
c----------------------------------------------------------------------
c

      character*200 fileh,formt,name,strf1f2,strLog
      character cff
      character *200 strTime
c  partial structure procedure common
      common /frgmt/ mmold,mzold,ihmax(3),knowo,sumn,sumd,ntype(80)
c     sapi
      common/rsc/ibgr,mg,mig(8),scl,bts(9),scsa(9),ip(8,3,5)
c     multiple data set common
      character*80,strSP
      character*4 a4
      character knwfile*256
      character tirang(2)*11

      dimension ipsv(12),shi1(4)
c
      call RoutineHeader('Data ','05.12')
c     set up initial values
      kuser = 15000
      nsym=0
      nrefl=0
      rhomax=0.0
c
      iform=2
      itypeF=1
      kop=kopen(iscra,name,nlenBin,itypeF,ierr)
  350 continue
      call dirdat(newf,jump,s3s2o,fileh,formt,knwfile,ier)
      if (ier.lt.0) go to 900

      if (knw == 1) then
          call AllocaTestStuff(1)
      endif

      
c--------------------
      k0 = Lung(headersGR(1)) + 1
      if (ianom==0) then
        write(strLog,'(12h Condition: ,a)')' EDM PROCEDURE'
        write(headersGR(1)(k0:),400)
        call HTML_header(ktml,' ','EDM PROCEDURE')
        call HTML_header(jlog,' ','EDM PROCEDURE')
  400   format('    EDM procedure starts on:')
      elseif (ianom==3) then
        write(strLog,'(12h Condition: ,a)')' MIR/SIR PHASING'
        write(strLog,'(23h Number of Derivatives: ,i2)')nds-1
        write(headersGR(1)(k0:),410)
        call HTML_header(ktml,'task2','MIR/SIR PHASING')
        call HTML_header(jlog,'task2','MIR/SIR PHASING')
  410   format('    MIR/SIR PHASING procedure starts on:')
      elseif (ianom==6) then
        write(strLog,'(12h Condition: ,a)')
     * ' Substructure LSQ Refinement and MAD/SAD PHASING'
        write(strLog,'(23h Number of Wavelengths: ,i2)')nds-1
        write(headersGR(1)(k0:),420)
        call HTML_header(ktml,'task2','MAD/SAD PHASING')
        call HTML_header(jlog,'task2','MAD/SAD PHASING')
  420   format('    MAD/SAD PHASING procedure starts on:')
      elseif (ianom==9) then
        write(headersGR(1)(k0:),420)
        call HTML_header(ktml,'task2','MIRAS/SIRAS PHASING')
        call HTML_header(jlog,'task2','MIRAS/SIRAS PHASING')
  430   format('    MIRAS/SIRAS PHASING procedure starts on:')
      endif
!
      k0 = Lung(headersGR(1)) + 2

      write(headersGR(1)(k0:),'(a)')StructureName(1:Lung(StructureName))
!
      write(ktml,'(/," <b><u>Crystallographic Data</b></u>",/)')
      write(ktml,1000)(cell(i),i=1,6)
      if (ifTrigonal == 0) then
       write(ktml,'(/,18h  Crystal family: ,a12)') texc(jsys)
      else
       write(ktml,'(/,18h  Crystal family: ,a12)') texc(7)
      endif
      write(strSP,'(16a1)') nSpaceG
      call ucase(strSP(1:1))
      write(ktml,'(18h  Space Group:    ,a16)')strSP

 1000 format(/,8h  Cell: ,3x,3ha =,f8.3,8x,3hb =,f8.3,8x,
     1 3hc =,f8.3,/,
     2 7x,7halpha =,f8.3,5x,6hbeta =,f8.3,4x,7hgamma =,f8.3)

c--------------------

      anat=float(nat)/(pts*float((icent+1)*nsym))
      aa=s3s2*s3s2*pts
c  s3s2p is related to the number of atoms in the primitive cell
      s3s2p=aa*sqrt(1.0/aa)
      s3s2=s3s2p
      is3s2=1./(s3s2p*s3s2p)+0.5
      a1=cos(cell(4)*pi/180.0)
      a2=cos(cell(5)*pi/180.0)
      a3=cos(cell(6)*pi/180.0)
      arg=1.0-a1*a1
     1       -a2*a2
     2       -a3*a3
     3       +a1*a2*a3*2.0
      volume=cell(1)*cell(2)*cell(3)*sqrt(arg)
      atvol = volume / float(nat)
c
      write(ktml,'(27h  Number of Atoms in a.u. =,f8.2)')
     *              anat

      write(lo,370) anat,is3s2,atvol
  370 format(/,18x,'Native:',/,
     + 18x,'******',/,
     + 18x,'Number of atoms in asymmetric unit =',f8.2,/,
     + 18x,'Equivalent number of equal atoms in primitive cell =',i6,/,
     + 18x,'Volume per atom =',f7.2)

      nasu=int(anat+0.5)

      ! stuff per DM
c     volume=v
      v_m=0.0
      f000=0.0
      den = 0.0                     !mr 040606
      do i=1,nk
        f000=f000+float(nw(i)*no(i))
        den=den+float(nw(i)*nw(i)*no(i))
        if (no(i) > 1) then
           v_m=v_m+14.0*float(nw(i))
        endif
      enddo
*---- Matthews' number
      v_m=volume/v_m
*---- Percent of Protein
*-----  protein density=1.23 (from CCP4 1.34)
c      v_p=1.23/v_m
       v_p=1.34/v_m
       f000=volume*(0.32*(1.0-v_p)+0.43*v_p)
       write(lo,'(18x,"The Matthews Coefficient=",f7.2)')v_m
       write(lo,'(18x,"Solvent Fraction        =",f7.2,/)')1-v_p
c      write(lo,*) 'F000=',f000/volume
c      atvol = atvol*v_p 

c
c  s3s2d is related to the number of atoms in the primitive cell
c	 for the derivative

      if (ianom==3.or.ianom==9) then
       write(ktml,'(a)') '  Heavy Atoms:'
       write(ktml,'(a)')'                     Symbol   N. Atoms in a.u'
      elseif (ianom==6) then
       write(ktml,'(a)')'  Anomalous Scatterer:'
       write(ktml,'(12x,24hSymbol   N. Atoms in a.u,10x,
     *                      1hf,a,4x,2hf")')char(39)
      endif

      if (nds.gt.1) then
       do ider=1,nkd
        anatd=float(nwd(ider))/(pts*float((icent+1)*nsym))
        aa=s3s2d(ider)*s3s2d(ider)*pts
        s3s2d(ider)=aa*sqrt(1.0/aa)
        is3s2d=1./(s3s2d(ider)*s3s2d(ider))+0.5
        write(a4,'(a4)') nalfd(ider)
        call ucase(a4(1:1))
*       write(lo,371) nalfd(ider),anatd,is3s2d
        write(lo,371) a4         ,anatd,is3s2d
*       write(ktml,'(13x,a2,5x,f6.2,14x,2f8.3)')nalfd(ider),anatd,
        write(ktml,'(13x,a2,5x,f6.2,14x,2f8.3)')a4         ,anatd,
     *               ffirst(ider,1),fsecon(ider,1)

c       write(strf1f2,'(5(2f8.3))')(ffirst(ider,ia),
c    *          fsecon(ider,ia),ia=1,nds-1)
c       k=(nds-1)*16
c       write(ktml,'(13x,a2,5x,f6.2,14x,a)')nalfd(ider),anatd,
c    *               strf1f2(1:k)

       do ia=2,nds-1
        write(ktml,'(40x,2f8.3)') ffirst(ider,ia),fsecon(ider,ia)
       enddo

       enddo
      endif

**    call flush(ktml)

  371  format(/,18x,'Derivative(Anomalous):',2x,a2,/,
     + 18x,'*********************',/,
     + 18x,'Number of atoms in asymmetric unit =',f6.2,/,
     + 18x,'equivalent number of equal atoms in primitive cell =',i6,/)

c
c-- if reflections aren't supplied finish
c
      if (jfile.eq.ln) go to 900
c
c     calculate number of reflexions for (sem)invariant searching
      mn1 = int(4.0*anat+100.5)
c     if (icent.eq.1) mn1 = mn1 + 50
      if (nsym.eq.1) mn1 = mn1 + 50
c     write(6,*)
c     write(6,*) ' NNNNNNNNNN Number of strong reflections (1) ',mn1
      if (ianom.gt.0) then
         mn=800+nint(480./float(nsym))
      else
         mn=mn1
      endif
c     write(6,*) ' NNNNNNNNNN Number of strong reflections (2) ',mn
      mn = min0(mn,maxstr)
      mm=mn+min0(maxstr-mn,100)/2
      mn=min0(mn,mn1)
c     write(6,*) ' NNNNNNNNNN Number of strong reflections (3) ',mn
c     write(6,*)
      nstr=mm
c     read reflexion data from cards
      npsedd=0       

      call datain(fileh,formt,newf,kuser,nrefp,ier)
      if (ier.lt.0) go to 900
c ----
c ---- create list 7 ( e's )
c ----
      ksize = 100
      call CreaRiflessiSirprot()
*gl*  call CreaLista6
*gl*  call xdump
      InfoOK(7) = 1

      call LeggiRiflessiSP

      ! normal. Fo/Fanom/Fderi

c     if (nrefExt==0) call normalAll(ier)
! se non voglio applicare un fattore di scala agli osservati
! da mettere nel caso di fattori di struttura calcolati
      if (jnowilson == 0) call normalAll(ier)

c     ihmx(:) = ihmxSav(:)

      if (ianom==3.or.ianom==9) then
        do kheavy = 1, nds -1
         call sigmaAheavy(kheavy,0)
         call SigHEstimate(2,kheavy)
        enddo
      endif

      !calc. map grid
      call CalcGrid
      ! calc sc & bt 

      call AllocaISR(1)
      if (ifCalcScBt > 0) then
         ScaleDM=0.0
         BtDM=0.0
         call CalcScale
         sigmav(1:nrefl)=sqrt(ScaleDM)*sigmav(1:nrefl)
      endif
      ! stat. riflessi
c      sumPair = 0.0
c      sumUPair = 0.0
c      npair = 0
c      nupair = 0
c      work1(:) = 0.0
c      work2(:) = 0.0
c      do i=1, nrefl
c         if (khl(3,i) == 0) cycle
c        if(mod(abs(khl(3,i)),2)==1) then
c          sumUPair = sumUPair + fovet(i)
c          nupair = nupair + 1
c          work1(i) = 1.0
c        else
c          sumPair = sumPair + fovet(i)
c          npair = npair + 1
c          work2(i) = 1.0
c        endif
c      enddo
c      write(lo,*)'L pari',npair,sumPair/float(npair)
c      write(lo,*)'L dispari',nupair,sumUPair/float(nupair)
c      tirang(1) = 'L pari'
c      call disgen(tirang(1),dreso,nrefl,1,fovet,work2,30,0.0)
c      tirang(1) = 'L dispari'
c      call disgen(tirang(1),dreso,nrefl,1,fovet,work2,30,0.0)

      call AllocaISR(2)
      call Orto(cell)
      if (ifPDBt == 1) then
          call esamin(khl,mkang,ipub,iphaz,
     *        nrefl,1,wt,wt,errt1,errtw1,nref1,shi1)
        knw = 1
        knwExt = 1
        ifHOH = 1
        kAla = 0
        LeggiHetam = 1
        nMolMr = 1
        nats=100000
        call AllocaAtomi(-2)
        call LeggiPDB(0, ifHOH, LeggiHetam, kAla, 0, ier)
        if (neutro >0) write(lo,*) 'Calc. struttura finale'
        call CalcSF()

        call esamin(khl,mkang,iphimod,ipub,
     *        nrefl,1,wt,wt,errt1,errtw1,nref1,shi1)

c       ipub(:) = iphimod(:)
c       fovet(:) = fmod(:)  ! test

        if (neutro == 1.and.iphase==3) then
         ! prendiamo solo Fc (le fasi usiamo quelle calc. da Marat
          work1(:) = fmod(:) ! backup Fc
         ! eliminare H/D --> calcolare la fase vera modello "xray"
          nHs = 0
          nDeu = 0
          do i = 1, nats
             kz=nz(i) / nzConst
             ! eliminiamo H/D dalla lista dei atomi
            if (kz.eq.1) then
                nHs = nHs + 1
                nz(i) = 0
                write(1,'(3hH  ,5F10.5)') xyzs(1:3,i),bfac(i),xyzs(5,i)
            endif
            if (kz.eq.5) then
              nDeu = nDeu + 1
              nz(i) = 0
               write(2,'(3hD  ,5F10.5)') xyzs(1:3,i),bfac(i),xyzs(5,i)
            endif
          enddo
          write(lo,*)' #Hs,D in PDB', nHs, nDeu

          write(lo,*) 'Calc. struttura parziale ("x-ray")'
          call CalcSF()
          sumf1= sum(fcvet(1:nrefl))
          sumf2= sum(fmod(1:nrefl))
          scf1f2=sumf1/sumf2
          sumdif = 0.0 
          do i=1, nrefl
           sumdif = sumdif + abs(fcvet(i) - fmod(i)*scf1f2)
          enddo
          write(lo,*) 'Scale, R',scf1f2,sumdif/sumf1
          
          wt(1:nrefl) = 1.0

          call esamin(khl,mkang,iphimod,iphaz,
     *        nrefl,1,wt,wt,errt1,errtw1,nref1,shi1)

          call esamin(khl,mkang,ipub,iphaz,
     *        nrefl,1,wt,wt,errt1,errtw1,nref1,shi1)

c         iphaz(:) = iphimod(:)
          fcvet(:) = fmod(:)
          fmod(:) = work1(:)
c         do i=1, nrefl
c            write(3,'(3i4,4f8.2)') khl(1:3,i),fmod(i),
c    *       float(ipub(i)),fcvet(i),float(iphaz(i))
c         enddo
        endif
      endif

  900 close(iscra,status='delete')
!
!-- Gianluca 28 novembre 2016
!
      if (knwfile(1:1) /= ' ') then
          call examin(0, mkang, khl, ipub, iphaz, nrefl, 0, wt, 1)
          write(lo,10)  knwfile(1:Lung(knwfile))
          knw = 0
          call ComputePhasesFromCoords(knwfile, ier)
          if (ier >= 0) then
              knw = 1
          endif
      endif


c     call frm39
      strTime='Data'
      call CPUTIMEtot(strTime)
!
!-- check if a model has to be loaded
!
      call AllocaAtomi(1)
      call CheckModelToLoad(ier)
      call AllocaAtomi(2)
!
      return
  10  format (//,' +++++  KNOWN PHASES FROM EXTERNAL FILE  +++++',/,
     *         /,'        Computing phases from ',a)
      end
c------------------------------------------------------------
c     read reflexions 
c
      subroutine datain(fileh,formt,newf,kuser,nrefp,ier)
      USE General
      USE Symmetry
      USE RFreeModule
!
      character*200 fileh,formt
      character*780 line,buff
      common /checkcom/nitem,nrefd(5),nrmax,ngt512,nfoneg
      common/resderi/rhoderi(2,5)
      common/anomnative/nofop
      dimension vet(512)
      dimension ivet(512),kv(3),f(50)
      equivalence (vet(1),ivet(1))
      integer sizes(1),itipo(1)
      integer vsym(24),ibrav(6,13),phy
      logical ifEof
      data ibrav/4*1,3,1,0,3*1,0,-1,1,0,6*1,0,3*1,5*2,3,4*0,1,11*0,1,
     ,5*0,2,5*0,1,5*0,1,11*0,2,0/
c
c     external checkref

c     print*,fileh
c     print*,formt
      nitem=6+(ianom-lcf+knw+jheavy*2)*(nds-1)
      if (iphase > 0) then
c       nitem=nitem + iphase*2 + knw
        nitem=nitem + iphase + knw
      endif

c     write(6,*)'nitem=',nitem
c     write(6,*)'ianom=',ianom
c     write(6,*)'nds=',nds
c     write(6,*)'lcf=',lcf
c     write(6,*)'nofop=',nofop
c     write(6,*)'iphase=',iphase

      nrpb = knwr/nitem
      ngt512 = 0
      nfoneg =0
      fosog =-999.9
      mxbg =673038
      nex =0
c  ksym=number of translational matrices different from ( 0.0 0.0 0.0 )
      ksym=0
      do 20 i=2,nsym
      ifl=0
      do 10 j=1,3
      if (abs(tsmat(j,i)).gt.0.00001) ifl=1
   10 continue
      if (ifl.eq.0) go to 20
      ksym=ksym+1
      vsym(ksym)=i
   20 continue
      klatt=latt-1

      if (ifMTZ == 0) then
          jfile=iabs(jfile)
          if (jfile.ge.0) then
              if (jfile.ne.ln) then
                  itype=2
                  iform=1
                  if (jopen(jfile,fileh,itype,iform,ios)
     *                                  .lt.0) go to 9000
              endif
          endif
      endif

***   jfile=iabs(jfile)
***   itype=2
***   iform=1
***   if (jopen(jfile,fileh,itype,iform,ios).lt.0) go to 9000
      nrefl=0
      nrefp=0
      do i=1,5
       nrefd(i)=0
      enddo
      do 7035 i=1,3
 7035 ihmx(i)=-100
c
c
***   if (nPerCard.gt.0) then
***                   iffsq=1
***                   nn=nPerCard
***                 else
***                   iffsq=-1
***                   nn=-nPerCard
***                 endif
      nrec=0
      nnn=0
      nuobs=0
      nrefc=0
      nrmax=0
      rhm=-99.9
      rhmi=99.9

      do i=1,5
         rhoderi(1,i)=-99.9   
         rhoderi(2,i)=99.9
      enddo

      if (ifMTZ == 0) then
          Buffer1(1:1) = '>'
          do while (Buffer1(1:1) == '>')
             read(jfile,'(a)',end=7000) line
             Buffer1=line
             call shift(Buffer1,nchar)
          enddo
      else
          iAction = 2
          ix1 = 0
          ix2 = 0
          call ManageMTZ(iAction, flgd, ix1, ix2, ier)
      endif

      nline=1
CCC   nmax=(ianom-1+knw)*(nds-1)
CCC   nmax=(ianom-lcf/nkd+knw)*(nds-1)
      nmax=(ianom-lcf+knw)*(nds-1)
c     if (iphase > 0) nmax= iphase*2
      if (iphase > 0) nmax= iphase
      if (jheavy.gt.0) nmax=nmax+(nds-1)*2
c     write(6,*)'nmax',nmax

**    go to 121
      iv = 0
      ifEof = .false.
      ifLine = 1
      call ContaRiflessi
      do
          fo=0.0
          sigmav=0.0
          phyr=0.0
          f(:)=0.0
          if (ifMTZ == 0) then
              call GetHkl(ifLine, line, formt, kh, kk, kl, fo, phyr, f, 
     *                  sigma, nmax, nofop, rfreeval, ier, ios, ifEof)
          else
              call GetHklMTZD(jump, kh, kk, kl, fo, phyr, f,
     *                  sigma, nmax, nofop, rfreeval, ier, ios, ifEof)
          endif

          if (ifEof) then
              exit
          endif
          if (ier < 0) then
              go to 8000
          endif
!
!-- RFree
!
c         print*,kh,kk,kl,fo,sigma,(f(i),i=1,nmax)
          if (knw==0) phyr=.0
c         if (fo.le.0.0) then
c             print*,kh,kk,kl,fo,sigma,(f(i),i=1,nmax)
c             fo=-1.0
c             sigma=0.0
c        endif
c        if (sigma.lt.0.0) sigma=0.0
     
         if (iphase > 0.and.icent==1) then
             phyrA=f(1)
             phyrA=dtor*phyrA               
             phyrA=cos(phyrA)
             if (phyrA.gt.0) then
                 phyrA=0.0
             else
                 phyrA=180.0
             endif 
             f(1)=phyrA
          endif
c----- per PHh del atomo pesante
          if (jheavy.gt.0) then
              phyrh=f(nmax)
              if (icent.eq.1) then
                  phyrh=dtor*phyrh               
                  phyrh=cos(phyrh)
                  if (phyrh.gt.0) then
                      phyrh=0.0
                  else
                      phyrh=180.0
                  endif 
              endif
          endif
c--------------
          if (icent.eq.1.and.knw.eq.1) then
              phyr=dtor*phyr               
              phyr=cos(phyr)
              if (phyr.gt.0) then
                  phyr=0.0
              else
                  phyr=180.0
              endif 
          endif
          phy=phyr
          nrefl=nrefl+1
          if (iabs(kh).gt.512.or.
     *        iabs(kk).gt.512.or.
     *        iabs(kl).gt.512) then
              ngt512=ngt512+1
              cycle
          endif
          if (nofop.eq.0.and.fo.lt.0.0) then
              if (ianom==6) then
                  fomed=0.0
                  sfomed=0.0
                  ndsUsed=0.0
                  do ider=1,nds-1
                     ider1=knw+1+(ianom-lcf+knw+jheavy*2)*(ider-1)
                     fpos=max(0.0,f(ider1))
                     fneg=max(0.0,f(ider1+2))
                     sfpos=max(0.0,f(ider1+1))
                     sfneg=max(0.0,f(ider1+3))
                     if (fpos.gt.0.0.or.fneg.gt.0.0) ndsUsed=ndsUsed+1
                     fomed=fomed+(fpos+fneg)*0.5
                     sfomed=sfomed+(sfpos+sfneg)*0.5
                  enddo
                  if (ndsUsed > 0.0) then
                      fo=fomed/float(ndsUsed)
                      sigma=sfomed/float(ndsUsed)
                  else
                      nfoneg=nfoneg+1
                      cycle
                  endif
              else
                  nfoneg=nfoneg+1
                  cycle
              endif
          endif
     
          if (icomuni.eq.1) then
              do ider=1,nds-1
                 ider1=1+knw+ (ianom-1+knw)*(ider-1)
                 ider1=2+(ianom-lcf+knw+jheavy*2)*(ider-1)
                 if (f(ider1).le.0.0) then
                     nfoneg=nfoneg+1
                     cycle
                 endif
              enddo
          endif

          if (nds.gt.1) then
              fomed=0.0
              sfomed=0.0
              ndsUsed=0
              do ider=1,nds-1
                 ider1=knw+1+(ianom-lcf+knw+jheavy*2)*(ider-1)
                 if (ider1 > 0 ) then
                     if (knw == 1 .and. ider1 > 1) then
                         if (f(ider1-1) < -900.0) then
                             f(ider1-1) = 0.0
                         endif
                     endif
                     if (f(ider1).le.0.0) f(ider1)=-1.0
                     if (f(ider1+1).lt.0.0) f(ider1+1)=0.0
                 endif

                 if (ianom.eq.6) then
                     if (f(ider1+2).le.0.0) f(ider1+2)=-1.0
                     if (f(ider1+3).lt.0.0) f(ider1+3)=0.0
                     fpos=max(0.0,f(ider1))
                     fneg=max(0.0,f(ider1+2))
                     sfpos=max(0.0,f(ider1+1))
                     sfneg=max(0.0,f(ider1+3))
                     if (fpos.gt.0.0.or.fneg.gt.0.0) ndsUsed=ndsUsed+1
                     fomed=fomed+(fpos+fneg)*0.5
                     sfomed=sfomed+(sfpos+sfneg)*0.5
                 endif
              enddo
              if (nofop==1) then
                  if (ndsUsed > 0) then
                      fo=fomed/float(ndsUsed)
                      sigma=sfomed/float(ndsUsed)
                  else
                      fo=-1.0
                      sigma=0.0
                  endif
              endif
          endif
          ! attenzione solo per i dati da marat
*gl*      if (fo.le.0.0) then   ! scommentata la seguente
          if (fo.lt.0.0) then
              nfoneg=nfoneg+1
              cycle
          endif
         if (sigma.lt.0.0) sigma=0.0

          call extin(jex,kh,kk,kl,ibrav,klatt,ksym,vsym)
          if (jex.eq.1) then
              nex=nex+1
              if (nex.le.10) write(lo,35) kh,kk,kl,fo,sigma
              if (nex.eq.11) write(lo,36)
   35 format(' Systematically absent :',3i4,'   Fobs =',f10.3,
     *           '   Sigma(Fobs) =',f10.3)
   36 format(/,' ....  and  so  on ')
          else
              call geneq(1,kh,kk,kl,idelt,jcode,isgnn,id1,rho,ireje)
              ireje=0
              if (rho.gt.th .or. rho.lt.rhomin) then
                  ireje=1
                  nrmax=nrmax+1
              endif
              if (ireje.eq.0) then
                  if (rho.gt.rhm) rhm=rho   
                  if (rho.lt.rhmi) rhmi=rho   
c                 th=0.25/(vet(1)**2)
c                 write(1,'(3i4,3f10.2)')kh,kk,kl,fo,sigma,1.0/sqrt(4.*rho)
                  do ider=1,nds-1
c                    ider1=2+(ianom-lcf+knw+jheavy*2)*(ider-1)
                     ider1=knw+1+(ianom-lcf+knw+jheavy*2)*(ider-1)
                     if (f(ider1).gt.0.0) then
                        nrefd(ider)=nrefd(ider)+1
                        if (rho.gt.rhoderi(1,ider)) rhoderi(1,ider)=rho
                        if (rho.lt.rhoderi(2,ider)) rhoderi(2,ider)=rho
                     endif
                  enddo
                  nrefp=nrefp+1
                  nnn=nnn+1
                  RFreeVett(nrefp) = rfreeval
                  if (knw > 0) then
                      phy=phy+idelt
                      phy=phy*isgnn
                      phy=mod(phy,360)
                      if(phy.le.0) phy=phy+360
                  endif
                  phy=phy*32+jcode

                  if (iphase > 0) then
                      iphyA=nint(f(1))
                      iphyA=iphyA+idelt
                      iphyA=iphyA*isgnn
                      iphyA=mod(iphyA,360)
                      if (iphyA.le.0) iphyA=iphyA+360
                      iphyA=iphyA*32+jcode
                      phyA=mod(iphyA,2**15)
                      iphyA = phyA/32
                      f(1)=float(iphyA)
                  endif

                  if (jheavy.gt.0) then
                      iphyrh=int(phyrh)
                      iphyrh=iphyrh+idelt
                      iphyrh=iphyrh*isgnn
                      iphyrh=mod(iphyrh,360)
                      if(iphyrh.le.0) iphyrh=iphyrh+360
c                     f(nmax)=float(iphyrh)
                  end if
                  if (fo.gt.fosog) fosog=fo
                  ivet(iv+1)=kh
                  ivet(iv+2)=kk
                  ivet(iv+3)=kl
                   vet(iv+4)=fo
                   vet(iv+5)=sigma
                  ivet(iv+6)=phy 
                  lci=6
                  ib=0
                  do lc1=1,nmax
                     ib=ib+1
                     lci=lci+1
                     vet(iv+lci) = f(ib)
                  enddo
c                 write(6,1250) nrefp,kh,kk,kl,fo,sigma
c    *                         ,(vet(lc1),lc1=iv+7,iv+lci)
 1250 format(i6,3i4,2f9.2,28f9.2)
                  iv=iv+nitem
                  if (nnn.eq.nrpb) then
                      nrec=nrec+1
                      write(iscra,rec=nrec) vet
                      nnn=0
                      iv=0
                  endif
              endif
          endif

      enddo    ! fine lettura riflessi


**    go to 30
   60 nrec=nrec+1
      write(iscra,rec=nrec) vet
!
      if (ifMTZ == 1) then
          iAction = 3
          ix1 = 0
          ix2 = 0
          call ManageMTZ(iAction, flgd, ix1, ix2, ier) 
      endif
c
c
c
c-- at this point the allowed reflections are on the scratch file(iscra)
c-- it is possible to eliminate symmetry equivalents and add (optionally
c-- unobserved reflections
c
c        set values for some constants
c----------------------------------------------
      nob=0
      nobi=0
      nnob=0
      lag=0
c
      kv(1)=(2*ihmx(3)+1)*(2*ihmx(2)+1)
      kv(2)=(2*ihmx(3)+1)
      indmb=ihmx(1)*kv(1)+ihmx(2)*kv(2)+ihmx(3)
      nrefl=nrefp
      rhomax=rhm
      rhomin=rhmi


*---- tipo 1: integer
*---- tipo 2: real
c     sizes(1)=indmb       ! ibig
c     itipo(1)=1
c     jflag=0
c     call memory(checkref,1,itipo,sizes,jflag)
c     if (jflag.eq.1) ier=-1

      call checkref

      if (jfile.ne.ln) close(jfile)
      nrefl=nrefp
c     nrefc=0
      return

 7000 continue
      write(lo,7010) jfile
 7010 format(' *** error ***    eof on channel ',i2)
      go to 9020
 8000 write(lo,8010) jfile,ios,nline
 8010 format(' *** error ***   read error on channel ',i2,' code =',i5,/
     *       '                 line number ',i5,/)
      go to 9020
 9000 write(lo,9010) ios,fileh
 9010 format(' *** error ***  open error, code =',i5,' file is ',a)
 9020 write(lo,9030)
 9030 format('                 reflections expected')
      ier=-1
      return
      end

*--------------------------------------*
*------ check the equiv. and unobs ----*
*--------------------------------------*
c     subroutine checkref(nla,ibig)
c     dimension ibig(*)
      subroutine checkref
      USE General
      USE Symmetry
      USE Grafici
      USE Molcom

      character*200 strLog

      common /checkcom/nitem,nrefd(5),nrmax,ngt512,nfoneg
      common/resderi/rhoderi(2,5)
**      dimension del(15),ivet(512),kv(3)
      dimension vet(512)
      dimension ivet(512),kv(3)
      equivalence (vet(1),ivet(1))
      integer vsym(24),ibrav(6,13)
      data ibrav/4*1,3,1,0,3*1,0,-1,1,0,6*1,0,3*1,5*2,3,4*0,1,11*0,1,
     ,5*0,2,5*0,1,5*0,1,11*0,2,0/

      integer, allocatable::  ibig(:),ibigD(:,:)

      allocate(ibig(indmb), stat = ierr)
      allocate(ibigD(nds-1, indmb), stat = ierr)

c  ksym=number of translational matrices different from ( 0.0 0.0 0.0 )
      ksym=0
      do 20 i=2,nsym
      ifl=0
      do 10 j=1,3
      if (abs(tsmat(j,i)).gt.0.00001) ifl=1
   10 continue
      if (ifl.eq.0) go to 20
      ksym=ksym+1
      vsym(ksym)=i
   20 continue
      klatt=latt-1

      ibig(:)=0
      ibigD(:,:)=0

      nrec=nrefl/nrpb
      if (mod(nrefl,nrpb).gt.0) nrec=nrec+1

      kv(1)=(2*ihmx(3)+1)*(2*ihmx(2)+1)
      kv(2)=(2*ihmx(3)+1)

      nperc=10
      iperc0=nrefl/nperc
      iperc=iperc0
      jperc=0
      nr=0
      npq=0
      neq=0
      do 232 nnn=1,nrec
      read(iscra,rec=nnn) vet
      iv=0
      do 230 i=1,nrpb
      nr=nr+1
      if (nr.gt.nrefl) go to 230
      if (nr.eq.iperc) then
          jperc=jperc+1
          iperc=iperc+iperc0
      endif
      lh=ivet(iv+1)
      lk=ivet(iv+2)
      ll=ivet(iv+3)
      fo=vet(iv+4)

      inbl=lh*kv(1) + lk*kv(2) + ll


      do ider=1,nds-1
       ider1=7+knw+(ianom-lcf+knw+jheavy*2)*(ider-1)
       fd=vet(iv+ider1)
       if (fd > 0.0 ) then
         lagD=ibigD(ider,inbl)
         if (lagD==0) ibigD(ider,inbl)=nr
       endif
      enddo

      lag=ibig(inbl)
c
c     lag=0 if ibig(inbl) is empty,
c     lag=1 if ibig(inbl) was filled up
c
      if (lag.ne.0) go to 210
      ibig(inbl)=nr 

      go to 220

  210 continue
      neq=neq+1
      absv4=abs(vet(iv+4))
      if (absv4.gt.0.00001) then
                              vet(iv+4)=-absv4
                            else
                              vet(iv+4)=-99.9
                            endif
      iv=iv+nitem
      go to 230

  220 continue
c-- npq contains the number of observed
c-- independent reflections
      npq=npq+1
      iv=iv+nitem
  230 continue
      write(iscra,rec=nnn) vet
  232 continue

      ifat1=(2*ihmx(3)+1)*(2*ihmx(2)+1)
      ifat2=(2*ihmx(3)+1)
      ifatx=ihmx(1)*ifat1+ihmx(2)*ifat2+ihmx(3)
c--
      write(ktml,'(/," <b><u>Reflections Data Information</b></u>",/)')

      if (ifMTZ == 1) then
          call WriteMTZCont()
      endif

  235 write(lo,300) nrefl
      write(ktml,300) nrefl
      resmax=0.5/sqrt(rhomax)
      resmin=0.5/sqrt(rhomin)
      if (nrmax.gt.0)  then
          write(lo,311) nrmax,th,rhomin
          write(ktml,311) nrmax,th,rhomin
      endif
      if (ngt512.gt.0) then
         write(lo,312) ngt512
         write(ktml,312) ngt512
      endif
      if (nfoneg.gt.0) then
         write(lo,313) nfoneg
         write(ktml,313) nfoneg
      endif


      write(lo,320) npq,nex,neq,ihmx,rhomax,resmax,rhomin,resmin,
     *  (nrefd(j),0.5/sqrt(rhoderi(1,j)),
     *   0.5/sqrt(rhoderi(2,j)),j=1,nds-1)

      write(ktml,320) npq,nex,neq,ihmx,rhomax,resmax,rhomin,resmin,
     *  (nrefd(j),0.5/sqrt(rhoderi(1,j)),
     *   0.5/sqrt(rhoderi(2,j)),j=1,nds-1)

  300 format(9x,i6,'  input reflections')
  311 format(9x,i6,'  rejected reflections with s**2 > ',f7.4,' or < ',
     .  f7.4)
  312 format(9x,i6,'  rejected reflections with indices .gt.512')
  313 format(9x,i6,'  rejected reflections Fo.eq.-1.0')

  320 format(  9x,i6, '  independent input reflections',
     *       /,9x,i6, '  systematically absent reflections rejected',
     *       /,9x,i6, '  symmetry equivalent reflections rejected',
     *       /, 3x,3i4,'  maximum  h,k,l  values',
     *       /,8x,f7.4,'  maximum s**2 = (sin(theta)/lambda)**2',
     *                   2x,'--->',f7.2, '(Angstrom)',
     *       /,8x,f7.4,'  minimum s**2 = (sin(theta)/lambda)**2',
     *                   2x,'--->',f7.2, '(Angstrom)',
     *       5(/,8x,i7  ,1x,' derivative(anomalous) reflections',
     *       ' (',f7.2,' - ' ,f7.2,' Angstrom )'))

      ! write "Reflection Data" on GUI

!
      if (kscreen > 0) then
!gl     strLog=' <b>Reflection Data:                      </b>'
!gl     call TestoGR(strLog, -1, 2, 1)
        strLog='<big><b>Reflection Data:</b></big>'
        call TestoGR(strLog, color_RED, 2, 1)
      endif

c     print*,nds,ianom

      select case (nds-1)
      case (0)
        write(strLog,'(17h Nr. Reflections:1x,5x,i6)')nrefl
        Msg = strLog
        if (kscreen > 0) then
          call TestoGR(Msg, -1, 2, 1)
        endif
        write(strLog,'(18h Resolution Range:1x,2(f5.1,2h -,f5.1))')
!!!  *                0.5/sqrt(rhomax),0.5/sqrt(rhomin)
     *                0.5/sqrt(rhomin),0.5/sqrt(rhomax)
        Msg = strLog
        if (kscreen > 0) then
          call TestoGR(Msg, -1, 2, 1)
        endif
      case (1)
        if (ianom==3) then
         write(strLog,'(19h Native/Derivative:,
     *       5x,6hNative,6x,a2)') nalfd(1:1)
         Msg = strLog
        elseif(ianom==6) then
         write(strLog,'(12h Wavelength:,15x,6h\gl\d1)')
         write(Msg,410) 
        else
         write(strLog,'(" Data sets:",10x,
     *       5x,6hNative,6x,a2)')
     *       nalfd(1:1)
         Msg = trim(strLog) // 
     *           ' <span lang="Greek">l</span><sub>1</sub>'
        endif
  410 format(' Wavelength:',
     *      12x,'  <span lang="Greek">l</span><sub>1</sub>')
!
        if (kscreen > 0) then
          call TestoGR(Msg, -1, 2, 1)
        endif
!
        if (ianom==3) then
        write(strLog,'(17h Nr. Reflections:1x,2(5x,i6))')
     *        nrefl,nrefd(1:1)
        elseif (ianom==6) then
        write(strLog,'(17h Nr. Reflections:1x,1(5x,i6))')nrefd(1:1)
        else
        write(strLog,'(17h Nr. Reflections:1x,2(5x,i6))')
     *        nrefl,nrefd(1:1)
        endif
!
        if (kscreen > 0) then
         call TestoGR(strLog, -1, 2, 1)
        endif
!
        if (ianom==6) then
        write(strLog,'(18h Resolution Range:2x,f5.1,1h-,f5.1)')
     *   0.5/sqrt(rhoderi(1,1:1)),
     *   0.5/sqrt(rhoderi(2,1:1))
        else
        write(strLog,'(18h Resolution Range:1x,2(f5.1,1h-,f5.1))')
     *   0.5/sqrt(rhomax),0.5/sqrt(rhomin),
     *   (0.5/sqrt(rhoderi(1,j)),0.5/sqrt(rhoderi(2,j)),j=1,1)
        endif
!
        if (kscreen > 0) then
!        inBoxGr(1) = inBoxGr(1) +1
         call TestoGR(strLog, -1, 2, 1)
        endif
!
      case (2)
        if (ianom==3) then
         write(strLog,500) nalfd(1:2)
  500 format(' Native/Derivative:',5x,'Native',6x,a2,(11x,a2))
         Msg = strLog
        elseif(ianom==6) then
          write(Msg,420) 
          write(strLog,'(12h Wavelength:,3x,11x,8h\gl\d1\u
     *    10x,8h\gl\d2\u)')
        else
         write(strLog,'(" Data sets:",10x,
     *       5x,"Native",6x,a2,
     *       1x,40h <span lang="Greek">l</span><sub>1</sub>,
     *       5x,a2,
     *       1x,40h <span lang="Greek">l</span><sub>1</sub>)')
     *       nalfd(1:2)
         Msg = trim(strLog)
c        Msg = trim(strLog) // 
c    *           ' <span lang="Greek">l</span><sub>1</sub>'
        endif
  420 format(' Wavelength:',
     *      12x,'  <span lang="Greek">l</span><sub>1</sub>',
     *       3x,'  <span lang="Greek">l</span><sub>2</sub>')
!
        if (kscreen > 0) then
         call TestoGR(Msg, -1, 2, 1)
        endif
!
        if (ianom==3) then
          write(strLog,'(17h Nr. Reflections:1x,3(5x,i6))')
     *         nrefl,nrefd(1:2)
        elseif(ianom==6) then
          write(strLog,'(17h Nr. Reflections:1x,2(5x,i6))')nrefd(1:2)
        else
          write(strLog,'(17h Nr. Reflections:1x,3(5x,i6))')
     *          nrefl,nrefd(1:2)
        endif
!
        if (kscreen > 0) then
!        inBoxGr(1) = inBoxGr(1) +1
         call TestoGR(strLog, -1, 2, 1)
        endif
!
        if (ianom==3) then
        write(strLog,'(18h Resolution Range:1x,3(f5.1,1h-,f5.1))')
     *   0.5/sqrt(rhomax),0.5/sqrt(rhomin),
     *   (0.5/sqrt(rhoderi(1,j)),0.5/sqrt(rhoderi(2,j)),j=1,2)
        elseif (ianom==6) then
        write(strLog,'(18h Resolution Range:1x,2(f5.1,1h-,f5.1))')
     *   (0.5/sqrt(rhoderi(1,j)),0.5/sqrt(rhoderi(2,j)),j=1,2)
        else
        write(strLog,'(18h Resolution Range:1x,3(f5.1,1h-,f5.1))')
     *   0.5/sqrt(rhomax),0.5/sqrt(rhomin),
     *   (0.5/sqrt(rhoderi(1,j)),0.5/sqrt(rhoderi(2,j)),j=1,2)
        endif
!
        if (kscreen > 0) then
         call TestoGR(strLog, -1, 2, 1)
        endif
!
      case (3)
        if (ianom==3) then
         write(strLog,'(" Native/Derivative:",5x,
     *       "Native",6x,a2,2(11x,a2))')nalfd(1:3)
         Msg = strLog
        else
        write(strLog,'(12h Wavelength:,3x,11x,8h\gl\d1\u
     *   10x,8h\gl\d2\u,10x,8h\gl\d3\u)')
         if (kscreen > 0) then
             write(Msg,430) 
         endif
        endif
  430 format(' Wavelength:',
     *      12x,'  <span lang="Greek">l</span><sub>1</sub>',
     *       3x,'  <span lang="Greek">l</span><sub>2</sub>',
     *       3x,'  <span lang="Greek">l</span><sub>3</sub>')
!
        if (kscreen > 0) then
!        inBoxGr(1) = inBoxGr(1) +1
         call TestoGR(Msg, -1, 2, 1)
        endif
!
        write(strLog,'(17h Nr. Reflections:1x,3(5x,i6))')nrefd(1:3)
!
        if (kscreen > 0) then
         call TestoGR(strLog, -1, 2, 1)
        endif
!
        write(strLog,'(18h Resolution Range:1x,3(f5.1,1h-,f5.1))')
     *   (0.5/sqrt(rhoderi(1,j)),0.5/sqrt(rhoderi(2,j)),j=1,3)
!
        if (kscreen > 0) then
         call TestoGR(strLog, -1, 2, 1)
        endif
!
      case (4)
        if (ianom==3) then
         write(strLog,'(" Native/Derivative:",5x,
     *       "Native",6x,a2,3(11x,a2))') nalfd(1:4)
         Msg = strLog
        else
c       write(strLog,'(12h Wavelength:,3x,11x,8h\gl\d1\u
c    *   10x,8h\gl\d2\u,10x,8h\gl\d3\u,10x,8h\gl\d4\u)')
         if (kscreen > 0) then
             write(Msg,440) 
         endif
        endif
  440 format(' Wavelength:',
     *      12x,'  <span lang="Greek">l</span><sub>1</sub>',
     *       3x,'  <span lang="Greek">l</span><sub>2</sub>',
     *       3x,'  <span lang="Greek">l</span><sub>3</sub>',
     *       3x,'  <span lang="Greek">l</span><sub>4</sub>')

!
        if (kscreen > 0) then
         call TestoGR(Msg, -1, 2, 1)
        endif
!
        write(strLog,'(17h Nr. Reflections:1x,4(5x,i6))')nrefd(1:4)
!
        if (kscreen > 0) then
         call TestoGR(strLog, -1, 2, 1)
        endif
!
        write(strLog,'(18h Resolution Range:1x,4(f5.1,1h-,f5.1))')
     *   (0.5/sqrt(rhoderi(1,j)),0.5/sqrt(rhoderi(2,j)),j=1,4)
!
        if (kscreen > 0) then
         call TestoGR(strLog, -1, 2, 1)
        endif
!
      end select

**    call flush(ktml)
      if (kscreen > 0) then
          call zflush
          call DoSingleIteration()
      endif
c     nrefl=nrefp
c-- check for unobserved reflections
c
      ihmxSav(:) = ihmx(:)
      if (abs(rGenTeorico) > 0.0) then
         res_obs = 0.5/sqrt(rhomax)
         ! nel caso di default assegnare rGenTeorico in funzione della res. osser
         if (rGenTeorico < 0) then
            if ( res_obs < 1.7) then
              rGenTeorico = 2.0
            else
              rGenTeorico = 2.2
            endif
         endif
         call AllocaISR(0)
         num_obs_teo = numres(res_obs)
         percExtreIn = float(nrefl)/float(num_obs_teo)
         res_ext_teo = (res_obs)/
     *         (percExtreIn*(1.0 + rGenTeorico))**(1./3.)
         ifGener = nint(res_ext_teo * 1000)
         write(6,*)'GEN =',rGenTeorico
         write(6,*)'RES_obs=',res_obs
         write(6,*)'perc=',percExtreIn
         write(6,*)'RES_ext=',res_ext_teo
c        num_ext_true = numres(res_ext_teo)
c        rGenTrue = float(num_ext_true - num_obs_teo)/float(num_obs_teo)
c        write(6,*)rGenTrue,num_ext_true,num_obs_teo
      endif

      if (ifGener <= 0) then
          rhomax1 = rhomax
          resolMax = 0.5/sqrt(rhomax)
      else
          res = float( ifGener ) / 1000.0
          resolMax = res
          rhomax1 = 0.25/(res*res)
          call NewHmax(rhomax1)
          deallocate(ibig, ibigD, stat = ierr)
          kv(1) = ( 2 * ihmx(3) + 1 ) * ( 2 * ihmx(2) + 1 )
          kv(2) = ( 2 * ihmx(3) + 1 )
          indmb = ihmx(1) * kv(1) + ihmx(2) * kv(2) + ihmx(3)
          allocate(ibig(indmb), stat = ierr)
          allocate(ibigD(nds-1, indmb), stat = ierr)
          if (ierr.ne.0) then
              write(lo,*) 'ibig Allocation error'
              call cstop(' ')
          endif
          call Reload_ibig(ibig, ibigD, nitem, kv)
      endif
!
      call unobs(ibig,ibigD,nrefd,kv,ibrav,klatt,ksym,vsym,nitem)

      ihmxExt(:) = ihmx(:)
      ihmx(:) = ihmxSav(:)
c
      deallocate(ibig,ibigD,stat=ierr)
      return
      end
!--------------------------------------------------------------------
      subroutine Reload_ibig(ibig, ibigD, nitem, kv)
      USE General


      dimension vet(512),ivet(512)
      equivalence (vet(1),ivet(1))
      dimension ibig(indmb), ibigD(nds-1,indmb),kv(3)
!
      ibig(:) = 0
      nrec = nrefl / nrpb
      if (mod(nrefl, nrpb) > 0) then
          nrec = nrec + 1
      endif
!
      nr = 0
      do nnn=1,nrec
!        write(6,*) 'datain read nrec=',nrec
         read(iscra,rec=nnn) vet
         iv=0
         do i=1,nrpb
            nr = nr + 1
            lh = ivet(iv + 1)
            lk = ivet(iv + 2)
            ll = ivet(iv + 3)
            fo = vet(iv + 4)
            inbl = lh * kv(1) + lk * kv(2) + ll
            lag = ibig(inbl)
            if (lag == 0) ibig(inbl) = nr 
            ibig(inbl) = 1
            do ider=1, nds-1
               ider1 = 7 + knw + (ianom - lcf + knw + jheavy*2)*(ider-1)
               fd=vet(iv + ider1)
               if (fd > 0.0 ) then
                   lagD = ibigD(ider, inbl)
                   if (lagD == 0) ibigD(ider, inbl) = nr
               endif
            enddo
            iv = iv + nitem
         enddo
      enddo
!
      return
      end
!--------------------------------------------------------------------
      subroutine NewHmax(rhomax1)
      USE General
      dimension vet(6,85)
      dimension ivet(6,85)
      equivalence (vet(1,1),ivet(1,1))
      integer, allocatable :: ibig(:)
      integer tempMax(3), add(3), kv(3)
!
!      write(0,*) 'Old hmax', ihmx  ! deb
      add(:)     = 0
      tempMax(:) = 0
      do i=1,3
         tempMax(i) = ihmx(i)
         do j=1,9999
            tempMax(i) = ihmx(i) + j
            rho = rhof(pp, tempMax(1), tempMax(2), tempMax(3))
            rho = rho * rho
            if (rho > rhomax1) then
                exit
            else
                add(i) = j
            endif
         enddo
         tempMax(i) = 0
         ihmx(i) = ihmx(i) + add(i)
      enddo
!      write(0,*) 'New hmax', ihmx  ! deb
!
      return
      end
!--------------------------------------------------------------------
      subroutine CreaRiflessiSirprot()
      USE General
      USE Riflessi
      USE RiflessiNew
!
      USE RiflessiMAD
      USE RiflessiMIR

      implicit none
      integer :: ivet(512)
      real    :: vet(512)
      equivalence (vet(1),ivet(1))
      integer :: iAction, i, nrec, nr, nc, nneg
      integer :: ia, j, nnn, ianom1, lc1, lci, ib, iphi8, n01
      integer :: iCaExiste, iv, nitem
      real    :: fo, sigma, aref, dsig, sumsig, sumdsig, sig01
      real    :: phiv, rho, rhof, perct
     
!
      nreflDim = nrefl
      nrefltot = nrefl

*gl*  iAction = 1                        ! commentata il 17/01/2012
*gl*  call AllocaRiflessiNew(iAction)    ! commentata il 17/01/2012
!
      select case (ianom)
         case (3)
            call AllocaRiflessiMIRnew(1)
         case (6)
            call AllocaRiflessiMADnew(1)
         case (9)
            call AllocaRiflessiMIRnew(1)
      end select
!
!-- create preamble
!
      nrefltot = nrefl + numbGen    ! numbGen aggiunto il 17/01/2012
      nonoss   = 0
      nescl    = 0
      cutoff   = 3.0       ! SISTEMARE IL CUTOFF: quando parte MNQD applica
!                            il cutoff e modifica nrefl che poi rimane con
      iLent    = 0
      iVelox   = 0
      bt       = 0.0
      sc       = -99.0
      nvsfc    = 0
      icdd     = 0
      npseud   = 0
      fosog    = 0.0
      btd(:)   = 0.0
      scd(:)   = -99.0
      shiftesd(:) = 0.0
      rhodiff(:)  = 0.0
      deltahkl(:) = 0.0
      rflsq    = 0
      rwflsq   = 0
      slsq     = 0
!
      nreflDim = nrefl + numbGen    ! numbGen aggiunto il 17/01/2012
      iAction = 1
      call AllocaRiflessiNew(iAction)
!
!-- create preamble
!
      refl_info%nrefltot = nreflDim
      refl_info%nrefl    = nrefl
      refl_info%nonoss   = 0
      refl_info%nescl    = 0
      refl_info%cutoff   = 3.0
      refl_info%iLent    = 0
      refl_info%iVelox   = 0
      refl_info%bt       = 0.0
      refl_info%sc       = -99.0
      refl_info%nvsfc    = 0
      refl_info%icdd     = 0
      refl_info%npseud   = 0
      refl_info%fosog    = 0.0
      refl_info%lproj    = 0
      refl_info%shiftesd(:) = 0.0
      refl_info%rhodiff(:)  = 0
      refl_info%deltahkl(:) = 0
      refl_info%rflsq    = 0
      refl_info%rwflsq   = 0
      refl_info%slsq     = 0
      refl_info%btd(:)   = 0.0
      refl_info%scd(:)   = -99.0
      refl_info%ksize    = ksize
!
      pack3 = 1024
      pack2 = pack3 * pack3
      pack1 = pack3 * pack2
      pack5 = pack3 / 2
!
      call UpdateReflInfo
!
      nitem = 6 + ( ianom - lcf + knw + jheavy * 2 ) * ( nds - 1 )
      if (iphase > 0) nitem = 6 + knw + iphase
      nrec=nreflDim/nrpb
      if (mod(nreflDim,nrpb).gt.0) nrec=nrec+1
      nr     = 0
      nc     = 0
      n01    = 0
      nneg   = 0
      sig01  = 0.0
      sumsig = 0.0
!
!-- trasferisce i riflessi da scratch alla struttura in memoria
!
      records: do nnn=1, nrec
         read(iscra,rec=nnn) vet
         iv = 0
         blocks: do i=1,nrpb
            nr = nr + 1
            if (nr > nreflDim) exit records

            if (vet(iv+4) < 0.0) then
                nneg=nneg+1   ! contare i riflessi con F < 0.0 (attenzione quando sono i riflessi generati
                iCaExiste=0
            else
                iCaExiste=1
            endif
            nc=nc+1
            fo=vet(iv+4)
            sigma=vet(iv+5)
            iphi8=mod(ivet(iv+6),2**15)
            if (knw == 1) then
               phiv = iphi8/32          ! la fase vera
            else
               phiv = 0
            endif 
            if (sigma > 0.0) then
               sig01 =sig01 + sigma
               n01 = n01 + 1
            endif

            sumsig=sumsig+sigma
            if (abs(sigma).lt.0.001) sigma=0.1
            rho = rhof( pp, ivet(iv+1), ivet(iv+2), ivet(iv+3) )
            rho = rho * rho
!
            refl%hkl(1,nc)  = ivet(iv+1)
            refl%hkl(2,nc)  = ivet(iv+2)
            refl%hkl(3,nc)  = ivet(iv+3)
            refl%e(nc)      = nreflDim-nc+1       ! dopo ci sara E (normal.)
            refl%fo(nc)     = fo
            refl%ep(nc)     = 0.0
            refl%phasep(nc) = 0.0
            refl%pub(nc)    = phiv
            refl%code(nc)   = mod(iphi8,32)     ! tipo riflesso itype/mkang
            refl%sigma(nc)  = sigma
            refl%fc(nc)     = 0.0
            refl%phase(nc)  = 0.0
            refl%rho(nc)    = rho
            refl%weight(nc) = 0.0
            if (ianom == 0) then
                if (iphase > 0) then
                    ! fase e peso esterno
                    refl%phase(nc)  = vet(iv+7)    ! fase
                    refl%weight(nc) = vet(iv+8)    ! peso (nel caso che legg. PHI/wt)
                    if (iphase == 3) then
                        refl%fc(nc) = vet(iv+9) ! Fc (nel caso che legg. PHI/wt/F
                    endif
                else
                    lci = nitem
                endif
            else
                ib=6
                lci = 18
                do lc1=1, nds-1
                   if (ianom == 3) then
                       refl%fdelta(lc1,nc) = 0.0
                       refl%sigde(lc1,nc)  = 0.0
                       if (knw.gt.0) then
                           ib = ib + 1
                           refl%deltaV(lc1,nc) = vet(iv+ib)
                       endif
                       ib = ib + 1
                       refl%fod(lc1,nc)    = vet(iv+ib)
                       ib = ib + 1
                       refl%sigfd(lc1,nc)   = vet(iv+ib)
                       refl%ed(lc1,nc)      = 0.0
                       if (refl%fod(lc1,nc) > 0.0) then
                           iCaExiste=1
                       else
                           iCaExiste=0
                       endif
                   elseif (ianom == 6) then
                       if (knw.gt.0) then
                           ib = ib + 1
                           refl%deltaAv(lc1,nc) = vet(iv+ib)
                       endif
                       ib = ib + 1
                       refl%fpos(lc1,nc)    = vet(iv+ib)
                       ib = ib + 1
                       refl%sigfpos(lc1,nc) = vet(iv+ib)
                       ib = ib + 1
                       refl%fneg(lc1,nc)    = vet(iv+ib)
                       ib = ib + 1
                       refl%sigfneg(lc1,nc) = vet(iv+ib)
                       refl%epos(lc1,nc)    = 0.0
                       refl%eneg(lc1,nc)    = 0.0
                       if (refl%fpos(lc1,nc) > 0.0 .or.
     *                     refl%fneg(lc1,nc) > 0.0) then
                           iCaExiste=1
                       else
                           iCaExiste=0
                       endif
                   elseif (ianom == 9) then
                       refl%fdelta(lc1,nc) = 0.0
                       refl%sigde(lc1,nc)  = 0.0
                       if (knw.gt.0) then
                           ib = ib + 1
                           refl%deltaV(lc1,nc) = vet(iv+ib)
                       endif
                       ib = ib + 1
                       refl%fod(lc1,nc)    = vet(iv+ib)
                       ib = ib + 1
                       refl%sigfd(lc1,nc)   = vet(iv+ib)
                       ib = ib + 1
                       refl%fodpos(lc1,nc)      = vet(iv+ib)
                       ib = ib + 1
                       refl%sigfdpos(lc1,nc)      = vet(iv+ib)
                       ib = ib + 1
                       refl%fodneg(lc1,nc)      = vet(iv+ib)
                       ib = ib + 1
                       refl%sigfdneg(lc1,nc)      = vet(iv+ib)
                       refl%ed(lc1,nc)      = 0.0
                       if (refl%fod(lc1,nc) > 0.0) then
                           iCaExiste=1
                       else
                           iCaExiste=0
                       endif
                   endif
                enddo
            endif
            if (iCaExiste == 1) nrefc = nrefc + 1
            iv = iv + nitem
         enddo blocks
      enddo records
!

      nrefl=nc-nneg    ! server solo se elim. dei riflessio
      nreflDim=nc     ! server solo se elim. dei riflessi

      perct=0.75      ! come era prima nella vecchia normal
      nzro=(1.-perct) *nrefc
*gl*  call pre06  ! update nr. dei riflessi deboli
      call UpdateReflInfo

      aref    = float(nrefl)
      sumsig  = sumsig / aref
      sumdsig = 0.0
!
      do i=1, nreflDim
         sigma = refl%sigma(nc)
         if (ksigma > 0) then
!original   dsig = abs( sumsig - vat(9) )
            dsig = abs( sumsig - refl%pub(nc) )  ! ????
            sumdsig = sumdsig + dsig
          endif
      enddo

      sumdsig = sumdsig / aref
      if (sumdsig < 0.1) ksigma = 0
      if (nint(sig01) == n01) ksigma = 0
      if (ksigma.eq.0) write(lo,385)
!
      nrefltot = nreflDim
!
      call UpdateReflInfo
!
      return
  385 format(/,' *** warning ***  sigma(F) values are meaningless',/)
      end
!--------------------------------------------------------------------
      subroutine riCreaRiflessiSirprot()

      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiNew
      USE RiflessiMAD
      USE RiflessiMIR
      USE RFreeModule
!
      implicit none
      integer :: i, ii, ia
      real    :: sc_save, bt_save, scd_save(5), btd_save(5)
!
      sc_save=sc
      bt_save=bt
!
      scd_save(1:5)=scd(1:5)
      btd_save(1:5)=btd(1:5)
!
c     write(6,*)'riCreare Lista7',nreflDim,nds,sc,bt
c     write(6,*)'riCreare Lista7',scd(1:nds-1),btd(1:nds-1)
!
*gl*  call xfl06
      call LoadReflInfo
!
      sc=sc_save
      bt=bt_save
!
      scd(1:5)=scd_save(1:5)
      btd(1:5)=btd_save(1:5)
!
*gl*  call sfr06
      call UpdateReflInfo
!
c     write(6,*)'riCreare Lista7',nreflDim,nds,sc,bt
c     write(6,*)'riCreare Lista7',scd(1:nds-1),btd(1:nds-1)
c     write(6,*)ianom
!
      do i=1,nreflDim
         ii=iorde(i)
!
         if (i <= nrefl) then
             refl%freeflag(i) = RFreeVett(ii)
         endif
!
         refl%hkl(1:3,i) = khl(1:3,ii)
         refl%e(i)       = evet(i)
         refl%fo(i)      = fovet(ii)
         refl%rho(i)     = rhov(ii)
         ! controllare 
         refl%ep(i)      = 0.0   !E'
         refl%ep(i)      = 0.0   !E'p    ?????
         !
         refl%phasep(i)  = 0.0    ! phi
         refl%pub(i)     = ipub(ii)
         refl%code(i)    = mkang(ii)
         refl%sigma(i)   = sigmav(ii)
         refl%fmod(i)    = fmod(ii) ! conservare F calcolato per la struttura vera

         if (iphase > 0) then
             refl%phase(i)  = iphaz(ii)
             refl%weight(i) = wt(ii)
             refl%fc(i)     = fcvet(ii)
         endif

         do ia=1,nds-1
            select case (ianom)
              case (0)
              case (3)
                 refl%fdelta(ia,i) = fdelta(ia,ii)    ! delta 
                 refl%sigde(ia,i)  = sigde(ia,ii)     ! sig(delta)
                 if (knw > 0) then
                     refl%deltav(ia,i) = deltav(ia,ii)
                 endif
                 refl%fod(ia,i)   = fod(ia,ii)
                 refl%sigfd(ia,i) = sigfd(ia,ii)
                 refl%ed(ia,i)    = ed(ia,ii)
              case (6)
*                refl%fdelta(ia,i) = 0.0              ! delta 
*                refl%sigde(ia,i)  = 0.0              ! sig(delta)
                 if (knw > 0) refl%deltaV(ia,i) = deltaV(ia,ii)
                 refl%fpos(ia,i)    = fpos(ia,ii)
                 refl%sigfpos(ia,i) = sigfpos(ia,ii)
                 refl%epos(ia,i)    = epos(ia,ii)
                 refl%fneg(ia,i)    = fneg(ia,ii)
                 refl%sigfneg(ia,i) = sigfneg(ia,ii)
                 refl%eneg(ia,i)    = eneg(ia,ii)
              case (9)
                 refl%fdelta(ia,i)   = fdelta(ia,ii)    ! delta 
                 refl%sigde(ia,i)    = sigde(ia,ii)     ! sig(delta)
                 if (knw > 0) refl%deltaV(ia,i) = deltaV(ia,ii)
                 refl%fod(ia,i)      = fod(ia,ii)
                 refl%sigfd(ia,i)    = sigfd(ia,ii)
                 refl%ed(ia,i)       = ed(ia,ii)
                 refl%fodpos(ia,i)   = fodpos(ia,ii)
                 refl%sigfdpos(ia,i) = sigfdpos(ia,ii)
!                refl% ...           = 0.0  ! forse Edpos?
                 refl%fodneg(ia,i)   = fodneg(ia,ii)
                 refl%sigfdneg(ia,i) = sigfdneg(ia,ii)
!                refl%  ...          = 0.0  ! forse Edneg?
            end select
         enddo
*gl*    call xslr(inp,vat)
      enddo
*gl*  call xert
*gl*  call xdump
      call LeggiRiflessiSP
!
      return
      end
!--------------------------------------------------------------------
      subroutine riCreaRiflessiSirprotG()

      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiNew
      USE RiflessiMAD
      USE RiflessiMIR
!
      implicit none
      integer :: i, ii, ia
      real    :: sc_save, bt_save, scd_save(5), btd_save(5)
!
      sc_save=sc
      bt_save=bt
!
      scd_save(1:5)=scd(1:5)
      btd_save(1:5)=btd(1:5)
!
c     write(6,*)'riCreare Lista7',nreflDim,nds,sc,bt
c     write(6,*)'riCreare Lista7',scd(1:nds-1),btd(1:nds-1)
!
*gl*  call xfl06
      call LoadReflInfo
!
      sc=sc_save
      bt=bt_save
!
      scd(1:5)=scd_save(1:5)
      btd(1:5)=btd_save(1:5)
!
*gl*  call sfr06
      call UpdateReflInfo
!
c     write(6,*)'riCreare Lista7',nreflDim,nds,sc,bt
c     write(6,*)'riCreare Lista7',scd(1:nds-1),btd(1:nds-1)
c     write(6,*)ianom
!
      do i=1,nreflDim
         ii=iorde(i)
         refl%hkl(1:3,i) = khl(1:3,ii)
         refl%e(i)       = evet(ii)
         refl%fo(i)      = fovet(ii)
         refl%rho(i)     = rhov(ii)
         ! controllare 
         refl%ep(i)      = 0.0   !E'
         refl%ep(i)      = 0.0   !E'p    ?????
         !
         refl%phasep(i)  = 0.0    ! phi
         refl%pub(i)     = ipub(ii)
         refl%code(i)    = mkang(ii)
         refl%sigma(i)   = sigmav(ii)
         refl%fmod(i)    = fmod(ii) ! conservare F calcolato per la struttura vera

         if (iphase > 0 .or. iabs(ifFreeLunch) > 0) then
             refl%phase(i)  = iphaz(ii)
             refl%weight(i) = wt(ii)
             refl%fc(i)     = fcvet(ii)
         endif

         do ia=1,nds-1
            select case (ianom)
              case (0)
              case (3)
                 refl%fdelta(ia,i) = fdelta(ia,ii)    ! delta 
                 refl%sigde(ia,i)  = sigde(ia,ii)     ! sig(delta)
                 if (knw > 0) then
                     refl%deltav(ia,i) = deltav(ia,ii)
                 endif
                 refl%fod(ia,i)   = fod(ia,ii)
                 refl%sigfd(ia,i) = sigfd(ia,ii)
                 refl%ed(ia,i)    = ed(ia,ii)
                 case (6)
                 refl%fdelta(ia,i) = 0.0              ! delta 
                 refl%sigde(ia,i)  = 0.0              ! sig(delta)
                 if (knw > 0) refl%deltaV(ia,i) = deltaV(ia,ii)
                 refl%fpos(ia,i)    = fpos(ia,ii)
                 refl%sigfpos(ia,i) = sigfpos(ia,ii)
                 refl%epos(ia,i)    = epos(ia,ii)
                 refl%fneg(ia,i)    = fneg(ia,ii)
                 refl%sigfneg(ia,i) = sigfneg(ia,ii)
                 refl%eneg(ia,i)    = eneg(ia,ii)
              case (9)
                 refl%fdelta(ia,ii)   = fdelta(ia,ii)    ! delta 
                 refl%sigde(ia,ii)    = sigde(ia,ii)     ! sig(delta)
                 if (knw > 0) refl%deltaV(ia,i) = deltaV(ia,ii)
                 refl%fod(ia,ii)      = fod(ia,ii)
                 refl%sigfd           = sigfd(ia,ii)
                 refl%ed(ia,ii)       = ed(ia,ii)
                 refl%fodpos(ia,ii)   = fodpos(ia,ii)
                 refl%sigfdpos(ia,ii) = sigfdpos(ia,ii)
!                refl% ...            = 0.0  ! forse Edpos?
                 refl%fodneg(ia,ii)   = fodneg(ia,ii)
                 refl%sigfdneg(ia,ii) = sigfdneg(ia,ii)
!                refl%  ...           = 0.0  ! forse Edneg?
            end select
         enddo
*gl*    call xslr(inp,vat)
      enddo
*gl*  call xert
*gl*  call xdump
      call LeggiRiflessiSP
!
      return
      end
!--------------------------------------------------------------------
      subroutine LeggiRiflessiSP

      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiNew
      USE RiflessiMAD
      USE RiflessiMIR
      USE PhaseModule
      USE Param
      USE RFreeModule
!
      implicit none
      integer :: i, ix, iy, multt, ia
      real    :: eps, yfl, flag, rho
*gl*  integer :: ivat(64), ivet(512)
*gl*  real    :: vat(64), vet(512)
!
*gl*  equivalence (vat(1),ivat(1))
*gl*  equivalence (vet(1),ivet(1))
!
      call AllocaRiflessi(1)
      select case (ianom)
         case (3)
            call AllocaRiflessiMIR(1)
         case (6)
            call AllocaRiflessiMAD(1)
         case (9)
            call AllocaRiflessiMIR(1)
      end select

*gl*  call xfl06
      call LoadReflInfo
      if (ifPDBt > 0) knw = 1
c     print*,'LeggiRiflessiSP:',nreflDim,nrefl,nrefc
c     stop
c     print*,pp
c     nrefc=nrefl
      ifat1=(2*ihmx(3)+1)*(2*ihmx(2)+1)
      ifat2=(2*ihmx(3)+1)
      ifatx=ihmx(1)*ifat1+ihmx(2)*ifat2+ihmx(3)

      iy = 67543
      ix = iy

      ndrmax=nds-1

      rhomax=0.0
      rhomin=999.0

c     rhomaxp=0.0
c     rhominp=999.0

c     rhomaxd=1.0
c     rhomind=0.0

      do i=1, nreflDim
         iorde(i)=i
*gl*     inp=262144*ivat(1) +512*ivat(2) +ivat(3) +131328
c        inp=((ivat(1)+128)*256 +
c    *         ivat(2)+128)*256 +
c    *         ivat(3)+128
c        jjhkl(i)=inp
         khl(1:3,i) = refl%hkl(1:3,i)
         call calc_mult(khl(1:3,i), eps, multt)
         mult(i) = multt
         epsv(i) = eps

         rhov(i) = refl%rho(i)
         if (i <= nrefl) then
             rhomax = max(rhomax, rhov(i))
             rhomin = max(rhomin, rhov(i))
         endif
         dreso(i) = 0.5 / sqrt(rhov(i))

         if (knw > 0) then
             ipub(i) = refl%pub(i)
             wtt1(i) = 1.0
             fmod(i) = refl%fc(i) ! F calcolato per la struttura vera
         else
             ipub(i) = 0
             wtt1(i) = 0.0
         endif

         mkang(i)  = refl%code(i)
         fovet(i)  = refl%fo(i)
         sigmav(i) = refl%sigma(i)
         evet(i)   = refl%e(i)
         if (ifCalcScBt == 0) fovet_mod(i) = fovet(i)

         ! per il calcolo di Rfree, se non in input
         !
         if (ifRFree == 0) then
             call randu1(ix,iy,yfl)
             flag = real(int(yfl*20.0)+1)
             ix = iy
             rfree1(i) = flag
         else
             rfree1(i) = refl%freeflag(i)
         endif
         !
         free1(i)  = 0.0
         free2(i)  = 0.0
         jinc1(i)  = 0
         !
         inobs(i)=0
 
         if (iphase > 0 .or. iabs(ifFreeLunch) > 0) then
             iphaz(i) = refl%phase(i)
             wt(i)    = refl%weight(i)
             fcvet(i) = refl%fc(i)
             if (wt(i) < 0.0 ) wt(i) = 0.0
             if (wt(i) > 1.0 ) wt(i) = 1.0
         endif

         select case (ianom)
            case (0)
               if (iphase > 0) then
                   iphaz(i) = refl%phase(i)
                   wt(i)    = refl%weight(i)
                   fcvet(i) = refl%fc(i)
                   if (wt(i) < 0.0 ) wt(i) = 0.0
                   if (wt(i) > 1.0 ) wt(i) = 1.0
               endif 
            case (3)
               do ia = 1,nds - 1
                  fdelta(ia,i) = refl%fdelta(ia,i)
                  sigde(ia,i)  = refl%sigde(ia,i)
                  fod(ia,i)    = refl%fod(ia,i)
                  sigfd(ia,i)  = refl%sigfd(ia,i)
                  ed(ia,i)     = refl%ed(ia,i)
                  if (knw > 0) deltaV(ia,i) = refl%deltaV(ia,i)
               enddo
            case (6)
               do ia = 1,nds - 1
                  deltaAv(ia,i) = refl%deltaAv(ia,i)
                  fpos(ia,i)    = refl%fpos(ia,i)
                  sigfpos(ia,i) = refl%sigfpos(ia,i)
                  epos(ia,i)    = refl%epos(ia,i)
                  fneg(ia,i)    = refl%fneg(ia,i)
                  sigfneg(ia,i) = refl%sigfneg(ia,i)
                  eneg(ia,i)    = refl%eneg(ia,i)
               enddo
            case (9)
               do ia = 1,nds - 1
                  fdelta(ia,i)   = refl%fdelta(ia,i)
                  sigde(ia,i)    = refl%sigde(ia,i)
                  fod(ia,i)      = refl%fod(ia,i)
                  sigfd(ia,i)    = refl%sigfd(ia,i)
                  ed(ia,i)       = refl%ed(ia,i)
                  fodpos(ia,i)   = refl%fodpos(ia,i)
                  sigfdpos(ia,i) = refl%sigfdpos(ia,i)
                  fodneg(ia,i)   = refl%fodneg(ia,i)
                  sigfdneg(ia,i) = refl%sigfdneg(ia,i)
                  if (knw > 0) deltaV(ia,i) = refl%deltaV(ia,i)
c                 print*,khl(1:3,i),fod(ia,i),sigfd(ia,i),
c    *                    fodpos(ia,i),sigfdpos(ia,i),
c    *                   fodneg(ia,i),sigfdneg(ia,i)
               enddo
         end select
      enddo

c     print*,0.5/sqrt(maxval(rhov(1:nrefl))),0.5/sqrt(rhomax)
c     print*,0.5/sqrt(minval(rhov(1:nrefl))),0.5/sqrt(rhomin)
!
      return
      end
!--------------------------------------------------------------------
      subroutine UpdateRiflessi(ixnor,jposition)

      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMAD
      USE RiflessiMIR


c     common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
c     common/cd/btd,scd,difbfac,icut,rhomaxD,rhominD,rhomaxP,rhominP


c     print*,'UpdateRiflessi',nreflDim,jposition,sc
      do i=1,nreflDim
       if (jposition==0) then
         ! dati Nativa
         scf=sqrt(sc)
         evet(i)=ecoef(i)
         fovet(i)=fovet(i)*scf
         sigmav(i)=sigmav(i)*scf
       else
         if (ixnor==2) then
           ! dati MAD
           scf=sqrt(sc)
           if (fpos(jposition,i) > 0.0)then
            epos(jposition,i)=ecoef(i)
            fpos(jposition,i)=fpos(jposition,i)*scf
            sigfpos(jposition,i)=sigfpos(jposition,i)*scf
           else
            epos(jposition,i)=0.0
            fpos(jposition,i)=-1.0
            sigfpos(jposition,i)=0.0
           endif
           if (fpos(jposition,i) > 0.0)then
            eneg(jposition,i)=ecoef(i)
            fneg(jposition,i)=fneg(jposition,i)*scf
            sigfneg(jposition,i)=sigfneg(jposition,i)*scf
           else
            eneg(jposition,i)=0.0
            fneg(jposition,i)=-1.0
            sigfneg(jposition,i)=0.0
           endif
         else
           ! dati MIR
           scf=sqrt(scd(jposition))
           if (fod(jposition,i) > 0.0)then
            fod(jposition,i)=fod(jposition,i)*scf
            sigfd(jposition,i)=sigfd(jposition,i)*scf
           ! dati MIRAS
            if (ianom==9) then
              if (fodpos(jposition,i) > 0.0.and.
     *           fodneg(jposition,i) > 0.0) then
               fodpos(jposition,i)=fodpos(jposition,i)*scf
               sigfdpos(jposition,i)=sigfdpos(jposition,i)*scf
               fodneg(jposition,i)=fodneg(jposition,i)*scf
               sigfdneg(jposition,i)=sigfdneg(jposition,i)*scf
              elseif (fodpos(jposition,i) > 0.0.and.
     *           fodneg(jposition,i) < 0.0) then
               fodpos(jposition,i)=fodpos(jposition,i)*scf
               sigfdpos(jposition,i)=sigfdpos(jposition,i)*scf
               fodneg(jposition,i)=fodpos(jposition,i)
               sigfdneg(jposition,i)=sigfdpos(jposition,i)
              elseif (fodpos(jposition,i) < 0.0.and.
     *           fodneg(jposition,i) > 0.0) then
               fodneg(jposition,i)=fodneg(jposition,i)*scf
               sigfdneg(jposition,i)=sigfdneg(jposition,i)*scf
               fodpos(jposition,i)=fodneg(jposition,i)
               sigfdpos(jposition,i)=sigfdneg(jposition,i)
              else
               fodneg(jposition,i)=-1.0
               sigfdneg(jposition,i)=0.0
               fodpos(jposition,i)=-1.0
               sigfdpos(jposition,i)=0.0
              endif
            endif
           else
            ed(jposition,i)=0.0
            fod(jposition,i)=-1.0
            sigfd(jposition,i)=0.0
            fdelta(jposition,i)= 9999.9
            if (ianom==9) then
              if (fodpos(jposition,i) > 0.0.and.
     *           fodneg(jposition,i) > 0.0) then
               fodpos(jposition,i)=fodpos(jposition,i)*scf
               sigfdpos(jposition,i)=sigfdpos(jposition,i)*scf
               fodneg(jposition,i)=fodneg(jposition,i)*scf
               sigfdneg(jposition,i)=sigfdneg(jposition,i)*scf
              elseif (fodpos(jposition,i) > 0.0.and.
     *           fodneg(jposition,i) < 0.0) then
               fodpos(jposition,i)=fodpos(jposition,i)*scf
               sigfdpos(jposition,i)=sigfdpos(jposition,i)*scf
               fodneg(jposition,i)=fodpos(jposition,i)
               sigfdneg(jposition,i)=sigfdpos(jposition,i)
              elseif (fodpos(jposition,i) < 0.0.and.
     *           fodneg(jposition,i) > 0.0) then
               fodneg(jposition,i)=fodneg(jposition,i)*scf
               sigfdneg(jposition,i)=sigfdneg(jposition,i)*scf
               fodpos(jposition,i)=fodneg(jposition,i)
               sigfdpos(jposition,i)=sigfdneg(jposition,i)
              else
               fodneg(jposition,i)=-1.0
               sigfdneg(jposition,i)=0.0
               fodpos(jposition,i)=-1.0
               sigfdpos(jposition,i)=0.0
              endif
            endif
           endif
          endif
       endif
      enddo

      return
      end
c--------------------------------------------------------------
      subroutine dirdat(newf,jump,s3s2o,fileh,formt,knwfile, ier)
      USE General
      USE Symmetry
      USE Mappa
      USE Atomi
      USE Groups
      USE PhaseModule
!
      character specie(18)*4
      character line*200,dire*200,diret*200,fileh*200,formt*200
      character Numdigit*13
      common /cifre/ Numdigit
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /frgmt/ mmold,mzold,ihmax(3),knowo,sumn,sumd,n(80)
      common/gpt/nanew(18),naold(18),sn,sq
      common/old/sco,bto,dumm1
      common/occup/occH(5,20)

      common/anomnative/nofop
      common/mtzlabels/Lab_sirprot,NCol_sirprot
      character Lab_sirprot(200)*30

      dimension na(18),cr(9,10),vet(40),ivet(40),wn(18),kshif(3),nnw(18)
      dimension celltemp(13), Moltiplica(18)
      character knwfile*256
c
c-- set default values
c  ifGener = 1 genera i riflessi dello shell esterno
c  ifGener = 0 genera i riflessi non osservati fino al (sin theta)/lambda
c         max degli osservati
c  ifGener =-1 controlla l'esistenza di riflessi non-obs senza memorizzarli
c         sul file ad accesso diretto (default)
c
      knwfile = ' '
      neutro=0
      wavel = 1.54178      !  'Cu'
      Moltiplica(:) = 0
      WeightSuppl = 0.0
      ifWeight = 0
      ifSeq = 0
      ifHetam = 0
      ZValue  = -1
      ifPDB = 0
      ifPDBt = 0
      ifGener = -1
      rGenTeorico = 0.0
      OkOrig    = 1
      ifRhombAx = 0
      ifTrigonal = 0
      lcf=0

      ! grid
      factr = 3.0/4.0
      igrid = 1
      !
      rhomax=0.0
      rhomin=999.0

      rhomaxp=0.0
      rhominp=999.0

      rhomaxd=1.0
      rhomind=0.0

      nrefExt = 0
      jnowilson = 0

c
c-- nds = number of data sets 
      nds=1
      nkd=0
c
c---iphase=1 leggere fasi dei altri per fare flex
c-- ianom = number of supplementary F's:
c-- ianom=0 only Fp,
c-- ianom=3 Fp and Fph
c-- ianom=6 Fp,FP1+,FP1-,......
c-- ianom=9 Fp,Fph,FPH+,FPH-,...
      do i=1,5
        nanomv(i)=0
        do j=1,5
         occH(i,j)=1.0
         occH(i,j)=1.0
        enddo
      enddo
***   ifMTZfile=0
      iphase=0
      jpartial=0
***   nrResidue=0
      ifCalcScBt=1  ! calc. Sc&bt nuovo (non wilson)
      nofop = 0
      icomuni = 0
      ianom = 0
      jheavy = 0
      knorm = 0
      jderi = 0
      iffsq= 1
      iyRand=67543
      iprin=0
      jj=0
      do 10 i=1,19,2
      jj=jj+1
      nag(jj)=0
      ninf(jj)=0
      j=i+20
      formt(i:i+1)='  '
   10 formt(j:j+1)='  '
      formt(1:11)='(3i4,2f8.2)'
      ishif=0
      do 20 i=1,3
   20 kshif(i)=0
      ksigma=1
      jump=-1
      bt=0.0
      sc=-99.9
      btd(1:5)=0.0
      scd(1:5)=-99.9
      knw=0
      knwExt=0
      nstr=0
      nzro=499
      th=1.98
      rhomin=0.0
      en=1.2
      er=0.6
      ngp=0
      jpart=0
      jtran=0
c     nonos=0
      npseud=0
      llpse=0
***   nPerCard=1
      jjfile=ln
***   do 30 i=1,200
***   xyzs(4,i)=1.0
***   nz(i)=ibl2
***   do 30 j=1,3
***30 xyzs(j,i)=0.0
      lix1=0
      lix2=0
      lix3=0
      lix33=0
      lix7=0
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 8200
      ipdir=ipdir+1
*     line=card(ipdir)
*     diret=line

      cardDiret=card(ipdir)
      cardImage=cardDiret
      call cutst(cardDiret,lenp,direttiva,lend)
      call lcase(direttiva)
c-- directives with alphanumeric parameters
      if (direttiva(1:3).eq.'pdb') then
         read(cardDiret,'(a)') filePDB
!
!-- check for blanks in the fragment file name
!
          call CheckBlanks(filePDB, lend)
!
          if (lend > 0) then
              if (jopen(jhost, filePDB, 2, 1, ios) == 0) then
c                 close(jhost)
                  ifPDBt = 1
              else
                  Msg = 'PDB file '// filePDB(1:Lung(filePDB)) // 
     *                  ' not found !!!'
                  call MsgWinErr('Open error', Msg, ERR_WINDOW, k)
                  ier = -1
                  return
              endif
          else
              go to 8000
          endif
          go to 100
      endif
      if (direttiva(1:4).eq.'spac') then
          if (lenp.gt.1) then
              read(cardDiret,'(16a1)') nSpaceG
              call CheckSpaceGroupSymbol(nSpaceG, ier)
              if (ier.ge.0) then
                  lix2=1
c                 jspini = -1
              else
                  ier = -10         ! errore nella direttiva
              endif
          else
             ier = -10              ! errore nella direttiva
          endif

          go to 100
          endif

      if (direttiva(1:4).eq.'cont') then
          call lcase(cardDiret)
          ifMolt = 0
          call getcon(cardDiret,direttiva,Moltiplica,ifMolt,nk)
          if (nk.le.0) go to 8000
          lix3=1
          go to 100
      endif
      if (direttiva(1:4).eq.'wave') then
*         if (iv.eq.1) then
*             WeightSuppl = vet(1)
*             ifWeight = 2
*         else
*             go to 8000
*         endif
          go to 100
      endif
      if (direttiva(1:4).eq.'anom') then
          call lcase(cardDiret)
          call getanom(cardDiret,direttiva,nwd,nalfd,ffirst,fsecon,
     *                 nkd,nanomv,nkd1)
          if (nkd1.le.0) go to 8000
!         nk = nkd
!         nw(nk) = nwd(nk)
!         nalf(nk) = nalfd(nk)
!         Moltiplica(nk) = 1
          lix33=1
          if (nkd.eq.1) then
            lcf=lcf+2
            ianom=ianom+6
            nds=nds+nanomv(nkd)
            if (nds.lt.1.or.nds.gt.25) go to 8000
          endif
          go to 100
          endif
      if (direttiva(1:4).eq.'deri') then
          call lcase(cardDiret)
          call getder(cardDiret,direttiva,nwd,nalfd,ffirst,fsecon,
     *                nkd,nanomv)
          if (nkd.le.0) go to 8000
          lix33=1

          nds=nds+1

          if (nkd==1) then
           lcf=lcf+1
           ianom=ianom+3
          endif

          if (nds.lt.1.or.nds.gt.25) go to 8000

          go to 100
          endif
      if (direttiva(1:4).eq.'dera') then
          call lcase(cardDiret)
          call getder(cardDiret,direttiva,nwd,nalfd,ffirst,fsecon,
     *                nkd,nanomv)
          if (nkd.le.0) go to 8000
          lix33=1

          nds=nds+1

          if (nkd==1) then
           lcf=lcf+1
           ianom=ianom+3
           lcf=lcf+2
           ianom=ianom+6
          endif
c         print*,'NKD=',nkd,lcf,ianom,nanomv

          if (nds.lt.1.or.nds.gt.25) go to 8000

          go to 100
          endif
c     if (direttiva(1:4).eq.'dano') then
c         lcf=lcf+2
c         ianom=ianom+6
c         go to 100
c         endif
      if (direttiva(1:4).eq.'neut') then
          neutro=1
          go to 100
          endif
      if (direttiva(1:4).eq.'nofo') then
          nofop=1
          go to 100
          endif
      if (direttiva(1:4).eq.'refl') then
          read(cardDiret,'(a)') fileh
          if (fileh(1:4).ne.'foll') then
              jjfile=jfile
          else 
              jjfile=-ln
          endif
          go to 100
          endif
      if (direttiva(1:4).eq.'form') then
          k=index(cardImage,'(')
          if (k.eq.0) go to 8000
          formt=cardImage(k:)
          k = Lung(formt)
          call lcase(formt(k:k))
          if (formt(k:k).eq.'k') then
              formt(k:k) = ' '
              knw = 1
          endif
          go to 100
          endif
      if (direttiva(1:4).eq.'fosq') then
          iffsq=-1
          go to 100
          endif

      if (direttiva(1:3).eq.'mtz') then
!
!-- check for blanks in the reflection file name
!
          call CheckBlanks(fileh, lend)
!
          if (lend > 0) then
              ReflFileName = fileh(1:lend)
              jjfile=jfile
              fileh   = ReflFileName
              MTZfile = ReflFileName
              ifMTZ   = 1
          else
              go to 8000
          endif
          go to 100
      endif
      if (direttiva(1:3).eq.'lab') then
          k = 0
          Lab_Ch(:) = ' '
          lenp = 1
          do while (lenp > 0)
             call cutst(cardDiret,lenp,direttiva,lend)
             k = k + 1
             Lab_Ch(k) = direttiva
          enddo
          if (k < 5) then
              go to 8000
          else
              ifMTZlab = 1
              nMTZlab  = k
          endif
          go to 100
      endif
      if (direttiva(1:3).eq.'seq') then
!
!-- check for blanks in the reflection file name
!
          call CheckBlanks(fileh, lend)
!
          if (lend > 0) then
              ReflFileName = fileh(1:lend)
              jjfile=jfile
              SeqFile = ReflFileName
              ifSeq  = 1
          else
              go to 8000
          endif
          go to 100
      endif
      if (direttiva(1:4).eq.'heta') then
          call lcase(cardDiret)
          ifMolt = 1
          call getcon(cardDiret, direttiva, Moltiplica, ifMolt, nkk)
          nk = nkk
          if (nk.gt.0) then
             lix3=1
          ifHetam = 1
          else
             go to 8000
          endif
          go to 100
      endif
      if (direttiva(1:4).eq.'know' .or. direttiva(1:4).eq.'refm') then
**        if (iv.ne.0) go to 8000
          cardImage = cardDiret
          call cutst(cardDiret,lenp,direttiva,lend)
          if (lend > 0) then
              knw = 0
              knwfile = cardImage
              knwgethkl = 1
          else
              knw = 1
          endif
          go to 100
      endif
c-- directives with alphanumeric parameters
      if (direttiva(1:4).eq.'nosi') then
          ksigma=0
          go to 100
          endif
c-- directives with numeric parameters
      iopt=0
      call getnum(cardDiret,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 8000
      if (direttiva(1:4).eq.'weig') then
          if (iv.eq.1) then
              WeightSuppl = vet(1)
              ifWeight = 1
          else
              go to 8000
          endif
          go to 100
      endif
      if (direttiva(1:4).eq.'nres') then
          if (iv.eq.1) then
              WeightSuppl = vet(1)
              ifWeight = 2
          else
              go to 8000
          endif
          go to 100
      endif
      if (direttiva(1:4).eq.'nmol') then
          if (iv.eq.1) then
              ZValue = vet(1)
          else
              go to 8000
          endif
          go to 100
      endif
***   if (dire(1:3).eq.'set') then
***       iphase=1
***       ifMTZfile=1
***       NCol_sirprot  = 8
***       Lab_sirprot(1) = 'H'
***       Lab_sirprot(2) = 'K'
***       Lab_sirprot(3) = 'L'
***       Lab_sirprot(4) = 'F'
***       Lab_sirprot(5) = 'SIGF'
***       Lab_sirprot(6) = 'PUB'
***       Lab_sirprot(7) = 'PHI_001'
***       Lab_sirprot(8) = 'WT_001'
***       go to 100
***       endif
      if (direttiva(1:4).eq.'part') then
          jpartial = ivet(1) 
          go to 100
          endif
      if (direttiva(1:4).eq.'phas') then
c         iphase = 1
          iphase = 2
          if (iv > 0) then
            iphase=ivet(1)
          endif
c         if (iv > 0) then
c            nrefExt=ivet(1)
c            jnowilson = 1
c         endif
          go to 100
          endif
      if (direttiva(1:4).eq.'cell') then
          if (iv.ne.6) go to 8000
          do 200 i=1,6
  200     celltemp(i)=vet(i)
          lix1=1
*gl*      call frm01(celltemp)   !!gl
          call CreaCellInfo(celltemp)
          go to 100
          endif
      if (direttiva(1:4).eq.'shif') then
          if (iv.ne.3) go to 8000
          ishif=1
          do 250 i=1,3
          ksh=ivet(i)
          if (ksh.ne.0) then
              if (mod(24,ksh).ne.0) then
                                      write(lo,230)
                                      go to 8000
                                    endif
                        endif
          kshif(i)=ksh
  250     continue
          go to 100
          endif
      if (direttiva(1:4).eq.'gene') then
          if (iv > 0) then
            rGenTeorico = vet(1)
            ifGener = 0
          endif
          go to 100
          endif
      if (direttiva(1:4).eq.'extr') then
          if (iv == 0) then
              ifGener = 0
c             rGenTeorico = 2.0 ! in default x strutture con dres < 1.7 A
c             rGenTeorico = 2.2 ! in default x strutture con dres > 1.7 A
              rGenTeorico = -1.0
          else
              ifGener = nint(vet(1)*1000)
          endif
          go to 100
          endif
      if (direttiva(1:4).eq.'heav') then
        if(iv.gt.0)go to 8000
          jheavy=1
          go to 100
          endif
      if (direttiva(1:4).eq.'comu') then
        if(iv.gt.0)go to 8000
          icomuni=1
          go to 100
          endif
  230   format(///' origin shift components must be integral multiples',
     * ' of 1/24 ')
      if (direttiva(1:5).eq.'rhomx') then
          if (iv.gt.2) go to 8000
          th=vet(1)
          rhomin=vet(2)
          if (th.lt.0.0.or.th.gt.1.0) go to 8000
          go to 100
          endif
      if (direttiva(1:5).eq.'rhomi') then
          if (iv.gt.1) go to 8000
          rhomin=vet(1)
          go to 100
          endif
      if (direttiva(1:5).eq.'dmax') then
          if (iv.gt.1) go to 8000
          rhomin=0.25/(vet(1)**2)
          go to 100
          endif
      if (direttiva(1:5).eq.'rhoma') then
          if (iv.gt.1) go to 8000
          th=vet(1)
          if (th.lt.0.0.or.th.gt.1.0) go to 8000
          go to 100
          endif
      if (direttiva(1:5).eq.'dmin') then
          if (iv.gt.1) go to 8000
          th=0.25/(vet(1)**2)
          go to 100
          endif
      if (direttiva(1:4).eq.'prin') then
          if (iv.ne.1) go to 8000
          iprin=ivet(1)
          go to 100
          endif
      if (direttiva(1:5).eq.'nowil') then
          jnowilson = 1
          go to 100
          endif
      if (direttiva(1:5).eq.'sc&bt') then
          if (iv.gt.0) then
            ifCalcScBt=ivet(1)
          else
            ifCalcScBt=1
          endif
          go to 100
          endif
      if (direttiva(1:4).eq.'grid') then
          if (iv.gt.1) go to 8000
          if (iv.eq.1) then
           factr=vet(1)
           igrid=0
          else
           igrid=1
          endif
          go to 100
          endif
***   if (direttiva(1:4).eq.'reco') then
***       if (iv.ne.1) go to 8000
***       nPerCard=ivet(1)
***       go to 100
***       endif
      write(lo,6000) direttiva
 6000 format(' wrong directive on following line:',/a)
      write(Msg,'("Wrong  directive : ",a)') 
     *            direttiva(1:Lung(direttiva))
      call MsgWinErr('Error', Msg, ERR_WINDOW, k)
      ier=-1
      return
 8000 continue
      ier=-1
      write(lo,'(22h error in directive : ,a80)') direttiva
      write(Msg,'(22h error in directive : ,a)') 
     *            direttiva(1:Lung(direttiva))
      call MsgWinErr('Error', Msg, ERR_WINDOW, k)
      return
 8200 continue
***   nPerCard=nPerCard*iffsq
      jfile=jjfile
      if (jpart.ne.0) npseud=0
      if (jpart.eq.-1.and.lix7.gt.0.and.jfile.eq.ln) jpart=1
!
!-- MTZ
!
      if (ifMTZ == 1) then
          iAction = 1
          call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
*gl*      call frm01(celltemp)
          call CreaCellInfo(celltemp)
      endif
!mr 040706
      if (ier < 0) then
          return
      endif
!
***   if (ifMTZfile==0) then
      if (lix1.le.0) then
          write(lo,8220)
          ier=-1
      else
*gl*      call xfl01   !!gl
          write(lo,8230) (cell(i),i=1,6)
          call RealReciprocalMetric
          write (lo,8231)((qd(i,j),j=1,3),(qt(i,j),j=1,3),i=1,3)
c         call calcmetric
      endif
***   endif
 8220 format(/,' *** error *** no cell parameters supplied')
 8230 format(/,12h Direct cell,9x,3ha =,f8.3,8x,3hb =,f8.3,8x,
     1 3hc =,f8.3,/,
     2 17x,7halpha =,f8.3,5x,6hbeta =,f8.3,4x,7hgamma =,f8.3)
 8231 format (/,' Orthogonalisation matrices:',3(/1x,3f8.3,8x,3f8.3))
***   if (ifMTZfile==0) then
      if (lix2.le.0) then
          write(lo,8240)
          ier=-1
      else
          call CreaSymmetryInfo(ier)
          call WriteSymmInfo(lo)
      endif
***   endif
 8240 format(/,' *** error *** no space group symbol supplied')
!
      if (ZValue < 0) then
          ZValue = 1
      endif

      ! dritan
      if (neutro == 1.and.ifWeight > 0 ) then
        nkd = nk
        nwd(1:nkd) = nw(1:nk)
      endif
!
!-- Sequence used
!
      if (ifSeq == 1) then
            call GetSequence(lix3, Moltiplica, ier)
            if (ier < 0) return
      endif
!
!-- Weight or nResid used
!
      if (ifWeight > 0) then
          call ManageWeight(WeightSuppl, ifWeight, Moltiplica)
          lix3 = 1
      endif
!
!-- if HetAtm or Anom used the cell content hat to be computed
!
      do i = 1, nkd
         nwd(i) = nwd(i) * totop * ZValue
      enddo

      do i=1, nk
         if (Moltiplica(i) == 1) then
             nw(i)  = nw(i)  * totop * ZValue
         endif
      enddo
c ---
c --- read scattering factors
c ---
c      check first if nr residues is supplied
***   if (nrResidue > 0 )then
***    nalf(1)='c'
***    nw(1)=nint(nrResidue*8.0)*(pts*float((icent+1)*nsym))
***    nk=1
***    !dire='cont'
***    !call getcon(line,dire,nw,nalf,nk)
***    lix3=1
***   endif

      if (lix3.le.0) then
          write(lo,8250)
 8250 format(/,' *** error *** no cell content supplied')
          ier=-1
      else
          wave = 0.71073
*gl*      call yfrm03(wave,ier)   !!gl
*gl*      call yfl03   !!gl
*gl*      if (neutro ==1) call upd03NeutronsElectrons   !!gl
          do i=1, nk
             write(Species(i),'(a4)') nalf(i)
          enddo
          WhichProps = 1
          call CreaAtmPropInfo(WhichProps, ier)
          call GetFromAtmStruct
      endif
*gl*  call xdump
      if (ier.lt.0) return
c ---
      do 9010 i=1,nk
       write(specie(i),'(a4)') nalf(i)
       call ucase(specie(i)(1:1))
 9010 na(i)=nw(i)

      if (neutro == 0) then
         write(lo,110)
  110   format(/,30x,'X-RAY data',/,26x,
     * ' Unit cell contents and scattering factor constants')
      write(lo,9020)(specie(i),nw(i),no(i),i=1,nk)
 9020 format(/,12x,'Symbol',3x,'Number in cell',3x,
     *             'Atomic number',/,(15x,a2,i13,i16))

      write(lo,9025)(specie(i),(al(ii,i),bs(ii,i),ii=1,4),cl(i),i=1,nk)
 9025 format(/,20x,'f = sum (  a(i) * exp(-b(i)*s2)  )  i=1,4 + c ',//,
     3 7x,'a(1)',4x,'b(1)',4x,'a(2)',4x,'b(2)',4x,'a(3)',4x,'b(3)',4x,
     4 'a(4)',4x,'b(4)',4x,' c',/,(1h ,a2,9f8.3))
       else
          write(lo,120)
 120      format(/,30x,'Neutron data',/,11x,
     * ' Unit cell contents and scattering factor constants')

      write(lo,9030)(specie(i),nw(i),no(i),zeff(i),i=1,nk)
 9030 format(/,12x,'Symbol',3x,'Number in cell',3x,
     *             'Atomic number',3x,'f',/,(15x,a2,i13,i16,3x,f9.3))

       endif


      s3=0
      s2=0
      do 9060 i=1,nk
         ss=float(na(i))*no(i)*no(i)
         s2=s2+ss
         s3=s3+ss*no(i)
 9060 continue
      s3s2=s3/sqrt(s2**3)
      do 9090 i=1,8
 9090 wn(i)=float(nw(i))

      if (iphase > 0) goto 9265
c--derivatives
c --- read scattering factors
c ---
      if (lix33.le.0) then
       if (nds.gt.1) then
                      write(lo,8251)
 8251 format(/,' *** error *** no derivatives supplied')
                       ier=-1
                      endif
                     else
                       call yfrm33(ier)
                       if (ier.ge.0) call yfl33
                     endif
*gl*  call xdump
      if (ier.lt.0) goto 9265
c ---
      do 9210 i=1,nkd
       write(specie(i),'(a4)') nalfd(i)
       call ucase(specie(i)(1:1))
 9210 na(i)=nw(i)

      write(lo,9220)(specie(i),nwd(i),nod(i),i=1,nkd)
 9220 format(/,12x,'Symbol',3x,'Number in cell',3x,
     *             'Atomic number',/,(15x,a2,i13,i16))

      write(lo,9225)(specie(i),(ald(ii,i),bsd(ii,i),ii=1,4),
     +               cld(i),(ffirst(i,ia),fsecon(i,ia),
     +               ia=1,5),i=1,nkd)
 9225 format(/,20x,'f = sum (  a(i) * exp(-b(i)*s2)  )  i=1,4 + c ',//,
     3 7x,'a(1)',4x,'b(1)',4x,'a(2)',4x,'b(2)',4x,'a(3)',4x,'b(3)',4x,
     4 'a(4)',4x,'b(4)',4x,' c',/,(1h ,a2,9f8.3,
     5 5(/,40x,'dfp',f8.3,1x,'fsec',f8.3)))


      do 9260 i=1,nkd
         s3d=0
         s2d=0
         ssd=float(nwd(i))*nod(i)*nod(i)
         s2d=s2d+ssd
         s3d=s3d+ssd*nod(i)
         if (lix33.gt.0) s3s2d(i)=s3d/sqrt(s2d**3)
 9260 continue

c--fragment
9265  if (ngp.gt.0) then
      nf=0
      nats=0
      do 9190 i=1,ngp
      ns=nf+1
      nf=nf+nag(i)
      write(lo,9100) i,nag(i)
 9100 format(/,27h fragment number          =,i3,/,
     1         27h no. of atoms in fragment =,i3,/,
     2 5x,'type',7x,'x',9x,'y',9x,'z',7x,'occ.   number in cell')
      do 9170 j=ns,nf
      do 9120 k=1,nk
      if(nz(j).eq.nalf(k)) goto 9140
 9120 continue
      write(lo,9130) nz(j)
 9130 format('  *** error *** ',a2,
     *       ' type not present in the declared content')
      ier=-1
      return
 9140 nz(j)=k
 9150 k=nz(j)
c     intpo=int(pop+0.5)
c     popx4=pop*xyzs(4,j)
c     wn(k)=wn(k)-popx4
c     inthec=int(popx4)
c     write(lo,9160) nalf(k),(xyzs(jj,j),jj=1,4),inthec
c9160 format(1h ,5x,a2,4f10.3,2x,i8)
c     if(abs(wn(k)).lt.0.001) wn(k)=0.0
c     if(wn(k).lt.0.0) then
c                      call yfl03
c                      write(lo,9165) nalf(k),nw(k)
c9165 format(
c    *' *** warning *** the number of  ',a2,'  atoms in the fragment',/,
c    *'                 exceedes the cell content',/,
c    *'                 ( max = ',i8,' )')
c                     endif
      nz(j)=nz(j)*100+1
      nats=nats+1
 9170 continue
 9190 continue
           numset=0
           numbrun=0
*gl*       call frm15(0)   !!gl
           call PutGetXyzs(1, 0)
      endif
!
!
      return
      end
c---------------------------------------------------------------------
      subroutine RealReciprocalMetric
      USE General
!
      qd(:,:) = 0.0
      qt(:,:) = 0.0
      qd(1:3,1:3) = xortr(1:3,1:3)
      qt(1:3,1:3) = xorti(1:3,1:3)
!
!-- Calculate real space metric tensor
!
      rlm11 =        qd(1,1)*qd(1,1)+qd(2,1)*qd(2,1)+qd(3,1)*qd(3,1)
      rlm12 = 2.0 * (qd(1,1)*qd(1,2)+qd(2,1)*qd(2,2)+qd(3,1)*qd(3,2))
      rlm13 = 2.0 * (qd(1,1)*qd(1,3)+qd(2,1)*qd(2,3)+qd(3,1)*qd(3,3))
      rlm22 =        qd(1,2)*qd(1,2)+qd(2,2)*qd(2,2)+qd(3,2)*qd(3,2)
      rlm23 = 2.0 * (qd(1,2)*qd(1,3)+qd(2,2)*qd(2,3)+qd(3,2)*qd(3,3))
      rlm33 =        qd(1,3)*qd(1,3)+qd(2,3)*qd(2,3)+qd(3,3)*qd(3,3)
!
!-- Calculate reciprocal space metric tensor
!
      rcm11 =        qt(1,1)*qt(1,1)+qt(1,2)*qt(1,2)+qt(1,3)*qt(1,3)
      rcm12 = 2.0 * (qt(1,1)*qt(2,1)+qt(1,2)*qt(2,2)+qt(1,3)*qt(2,3))
      rcm13 = 2.0 * (qt(1,1)*qt(3,1)+qt(1,2)*qt(3,2)+qt(1,3)*qt(3,3))
      rcm22 =        qt(2,1)*qt(2,1)+qt(2,2)*qt(2,2)+qt(2,3)*qt(2,3)
      rcm23 = 2.0 * (qt(2,1)*qt(3,1)+qt(2,2)*qt(3,2)+qt(2,3)*qt(3,3))
      rcm33 =        qt(3,1)*qt(3,1)+qt(3,2)*qt(3,2)+qt(3,3)*qt(3,3)
!
      return
      end
! ----------------------------------------------------------------------
!     print of reflexions to be used in SIRprot
      subroutine out90(nrefOut, mmOut, mzOut)
      USE General
      USE Riflessi
      USE RiflessiMAD
      USE RiflessiMIR
!
      dimension j(4),k(4),l(4),e(4),kode(4),iph(4),sigma(4)
!
      write(lo,700) mmOut
  700 format(///,1h ,i6,38h  largest e-values for (sem)invariants,/)
      if (knw.eq.0) then
          npr=4
          if (jderi.eq.0) then
             write(lo,10)
             else
             write(lo,11)
          endif
             else
          npr=3
          if (jderi.eq.0) then
             write(lo,15)
             else
             write(lo,16)
          endif
      endif
   10 format(1x,4(1x,'code  h  k  l   e     fo/sig.',1x))
   11 format(1x,4(1x,'code  h  k  l   e	    delta  ',1x))
   15 format(3(3x,'code    h  k  l   e    sigma phase',3x))
   16 format(3(3x,'code    h  k  l   e    delta phase',3x))
      kk=0
      do 300 i=1,mmOut
*gl*     call snr07(vet)
         kk=kk+1
         j(kk)=khl(1,i)
         k(kk)=khl(1,i)
         l(kk)=khl(1,i)
         e(kk)=evet(i)
         iph(kk)=ipub(i)
         kode(kk)=i
         if (jderi.eq.0) then
             sigma(kk)=sigmav(i)
c   11 jan adam   print sigma for native fo always ??
c	if (sigma(kk).gt.0.0) sigma(kk)=vet(5) / sigma(kk)
         else
*gl*         iii=11+(ianom+knw+4)*(jderi-1)
*gl*         sigma(kk)=vet(iii)
             sigma(kk)= sigfd(jderi,i)
         end if
c
c
         if (kk.lt.npr) go to 300
         if (knw.eq.0) then
             write(lo,25)
     1            (kode(ii),j(ii),k(ii),l(ii),e(ii),sigma(ii),ii=1,npr)
         else
             write(lo,30)
     1            (kode(ii),j(ii),k(ii),l(ii),e(ii),sigma(ii),iph(ii),
     2             ii=1,npr)
         endif
         kk=0
  300 continue
   25 format(1x,4(i5,3i3,f7.3,f7.2,3x))
   30 format(3(i7,1x,3i3,f7.3,f7.2,i5,4x))
      if (kk.eq.0) go to 400
      if (knw.eq.0) then
          write(lo,25)
     1     (kode(ii),j(ii),k(ii),l(ii),e(ii),sigma(ii),ii=1,kk)
      else
          write(lo,30)
     1     (kode(ii),j(ii),k(ii),l(ii),e(ii),sigma(ii),iph(ii),ii=1,kk)
      endif
c
c       write weak reflection
c
  400 continue
      write(lo,710) mzOut
  710 format(1h0,i6,46h  smallest e-values for psi0 and neg. quartets,/)
      if (knw.eq.0) then
          npr=4
          if (jderi.eq.0) then
             write(lo,10)
             else
             write(lo,11)
          endif
      else
          npr=3
          if (jderi.eq.0) then
              write(lo,15)
          else
              write(lo,16)
          endif
      endif
      jj=mmOut
      nrf=nrefOut-mmOut-mzOut
*gl*      do 500 i=1,nrf
*gl*      jj=jj+1
*gl*      call snr07(vet)
*gl*  500 continue
      kk=0
      do 600 iii=1,mzOut
      i = iii + nrefOut-mmOut-mzOut
*gl*      call snr07(vet)
      kk=kk+1
      jj=jj+1
      j(kk)=khl(1,i)
      k(kk)=khl(2,i)
      l(kk)=khl(3,i)
      e(kk)=evet(i)
      iph(kk)=ipub(i)
      kode(kk)=jj
      if (jderi.eq.0) then
          sigma(kk)=sigmav(i)
      else
*gl*      iii=11+(3+ianom)*(jderi-1)
*gl*      sigma(kk)=vet(iii)
          sigma(kk)= sigfd(jderi,i)
      end if
c
c
      if(kk.lt.npr) go to 600
      if(knw.eq.0) then
                     write(lo,25)
     1     (kode(ii),j(ii),k(ii),l(ii),e(ii),sigma(ii),ii=1,npr)
                    else
                     write(lo,30)
     1     (kode(ii),j(ii),k(ii),l(ii),e(ii),sigma(ii),iph(ii),ii=1,npr)
                     endif
      kk=0
  600 continue
      if(kk.eq.0) return
      if (knw.eq.0) then
           write(lo,25)
     1     (kode(ii),j(ii),k(ii),l(ii),e(ii),sigma(ii),ii=1,kk)
                  else
           write(lo,30)
     1     (kode(ii),j(ii),k(ii),l(ii),e(ii),sigma(ii),iph(ii),ii=1,kk)
                  endif
      return
      end
c------------------------
      subroutine provasn(ist,ihhh,ikkk,illl)
      kk3=128
      kk2=128*kk3
      kk1=128*kk2
c--unpack the values
      in=ist/kk1
      ihkl=ist-in*kk1
      in=in-1
      ih=ihkl/kk2
      ikl=ihkl-ih*kk2
      ik=ikl/kk3
      il=ikl-ik*kk3
      ihhh=ih-64
      ikkk=ik-64
      illl=il-64
      return
      end
***********************************
!-----------------------------------------------------------------------
      subroutine extin(jex,kg1,kg2,kg3,ibrav,klatt,ksym,vsym)
c   check for extinction (jex=0/1 allowed/absent)
c   first: check bravais lattice type
c   type  p   a  b    c   i    f   r
c   latt: 1   2   3   4   5    6   7
c   ibrav(    1   2   3   4    5   6  )  x  13
      USE General
      USE Symmetry
      integer ibrav(6,13),kg(3),vsym(24),mr(3)
c
      kg(1)=kg1
      kg(2)=kg2
      kg(3)=kg3
      do 10 i=1,3
      if (kg(i).ne.0) go to 20
   10 continue
      jex=1
      return
   20 jex=0
      if(klatt.eq.0) go to 420
      nbrav=ibrav(klatt,1)
      do 410 i=1,nbrav
      isum=0
      do 400 j=1,3
      lb=1+(i-1)*4+j
 400  isum=isum+kg(j)*ibrav(klatt,lb)
      lb=4*i+1
      if(mod(isum,ibrav(klatt,lb)).eq.0) go to 410
      jex=1
      go to 700
410   continue
420   continue
c   second: check translations from symmetry operators
c         first condition for h to absent:  h*ri=h   (h=kg)
      if (ksym.eq.0) go to 700
      jc=icent+1
      do 490 kc=1,jc
      do 480 lsym=1,ksym
      isym=vsym(lsym)
        ca=0.
      do 470 jj=1,3
      nh=0
      do 430 j=1,3
430     mr(j)=0
      do 450 i=1,2
      do 440 j=1,3
      ikk=ismat(i,j,isym)
       ka=iabs(ikk)
      if(ka.ne.jj)goto 440
      if(kc.eq.2) ikk=-ikk
      mr(j)=isign(1,ikk)
440   continue
450   continue
      do 460 j=1,3
460   nh=kg(j)*mr(j)+nh
      if(kg(jj).ne.nh)goto 480
      ca=float(nh)*tsmat(jj,isym)   +  ca
470   continue
c  second condition:    h*ts ; integer, for an ext. reflexion.
      ca=abs(ca)
      ica=(ca+0.0005)*1000
      if(mod(ica,1000).eq.0)goto 480
c  variable ca is not an integer number,the reflexion is absent.
      jex=1
      goto 700
480     continue
490   continue
700     continue
      return
      end
c------------------------------------------------------------
      subroutine geneq(lty,ih,kk,il,idelt,jcode,isnn,istd,rho,ireje)
      USE General
      USE Symmetry
      dimension kl1(24),kl2(24),kl3(24),i1(3),i1s(3),i2(3),ise(24)
c
      ireje = 0    ! aggiunto ireje per compatibil. con sir
      isnn=1
      rho1=rhof(pp,ih,kk,il)
      rho=rho1*rho1
c     if (rho.lt.th) then
         i1(1)=ih
         i1(2)=kk
         i1(3)=il
         jcode=13
         ido=1
         maxi=1
         ise(maxi)=1
         do 250 j=1,nsym
            kl1(j)=2400
            kl2(j)=2400
            do 200 i=1,3
               i2(i)=0
               kl1(j)=kl1(j)-i1(i) * int(tsmat(i,j)*24+0.01)
               kl2(j)=kl2(j)-i1(i) * int(tsmat(i,j)*12+0.01)
  200       continue
            kl1(j)=mod(kl1(j),24)
            do 220 i=1,3
               do 210 k=1,2
                  m=iabs(ismat(k,i,j))
                  if(m.gt.0) i2(m)=i2(m)+i1(i)*isign(1,ismat(k,i,j))
  210          continue
  220       continue
            if(icent.eq.1.or.ido.ne.1) goto 230
            jcode=1
            do 225 i=1,3
               if (i1(i)+i2(i).ne.0) goto 230
  225       continue
            jcode=mod(kl2(j),12)+1
            if (jcode.le.1) jcode=jcode+12
            ido=0
  230       ind=262144 * i2(1) + 512 * i2(2) + i2(3)
            kl3(j)=131328 + iabs(ind)
            if (lty.eq.1) then
               rhomax=amax1(rhomax,rho1)
               if(ihmx(1).lt.iabs(i2(1))) ihmx(1)=iabs(i2(1))
               if(ihmx(2).lt.iabs(i2(2))) ihmx(2)=iabs(i2(2))
               if(ihmx(3).lt.iabs(i2(3))) ihmx(3)=iabs(i2(3))
            endif
            if (j.ne.1) then
               jm1=j-1
               do 240 i=1,jm1
                  if(kl3(i).eq.kl3(j)) kl3(j)=0
  240          continue
               if (kl3(j).gt.kl3(maxi)) then
                  maxi=j
                  ise(maxi)=isign(1,ind)
               endif
            endif
  250    continue
         isnn=ise(maxi)
         call unpack (kl3(maxi),ih,kk,il)
         idelt=kl1(maxi)*15
         istd=0
         jcodes = jcode
         if (icent.eq.0) then
            ido=1
            i1s(1)=ih
            i1s(2)=kk
            i1s(3)=il
            do 300 j=1,nsym
               kl1(j)=24000
               do 260 i=1,3
                  i2(i)=0
                  kl1(j)=kl1(j)+i1s(i) * nint(tsmat(i,j)*12)
  260          continue
               do 280 i=1,3
                  do 270 k=1,2
                     m=iabs(ismat(k,i,j))
                     if(m.gt.0) i2(m)=i2(m)+i1s(i)*isign(1,ismat(k,i,j))
  270             continue
  280          continue
               if (ido.eq.1) then
                  jcode=1
                  ifl = 0
                  do 290 i=1,3
                     if (i1s(i)+i2(i).ne.0) ifl = 1
  290             continue
                  if (ifl.eq.0) then
                     jcode1 = mod ( kl1(j) , 24 ) 
                     jcode2 = mod ( ( jcode1 + 12 ), 24 ) 
                     jcode = min0 ( jcode1 , jcode2 )
                     jcode = jcode + 1
                     if (jcode.le.1) jcode=jcode+12
                     ido=0
                  endif
               endif
  300       continue
         endif
*        if (jcodes.ne.jcode) write(6,*)'jcodes,jcode,i1s',jcodes,
*    +                        jcode,i1s
         if (lty.eq.1) return
         if (i1(1).eq.ih.and.i1(2).eq.kk.and.i1(3).eq.il) istd=1
c     endif
      return
      end
c-----------------------------------------------------------
      function rhof(p,jh,jk,jl)
      dimension p(6)
c
      rho2=p(1)*float(jh*jh)+p(2)*float(jk*jk)
     1 +p(3)*float(jl*jl)+p(4)*float(jh*jk)
     2 +p(5)*float(jh*jl)+p(6)*float(jk*jl)
      rhof=sqrt(rho2)
      return
      end
c------------------------------------------------------------
      function igf(del,nsh,rho)
      dimension del(15)
c
      do 10 l=1,nsh
      dg=del(l)+0.000001
      if (rho.lt.dg) go to 20
   10 continue
   20 igf=l
      return
      end
!-----------------------------------------------------------------------
      subroutine getcon(line, dire, Moltiplica, ifMolt, ier)
      USE General
      character*(*) line,dire
      dimension vet(40), ivet(40), Moltiplica(18)
c
      ier = 0
      do i=1, MaxNk
         call cutst(line,lenp,dire,lend)
         if (lenp.le.0) then
             ier = -1
             exit
         endif
         ier = ier + 1
         read(dire,'(a4)') nalf(i)
         Species(i) = dire
         iopt = 1
         call getnum(line,vet,ivet,iv,iopt)
         if (iopt.eq.-1) then
             ier = -1
             exit
         endif
         nw(i) = ivet(1)
         if (ifMolt == 1) then
             Moltiplica(i) = 1
         endif
         call cutst(line,lenp,dire,lend)
         if (lenp.le.0) exit
      enddo
!
      return
      end
!-----------------------------------------------------------------------
      subroutine getder(line,dire,nw,nalf,ffirst,fsecon,ier,nanomv)
      character*(*) line,dire
      dimension nalf(5),nw(5),vet(40),ivet(40),ffirst(5,5),fsecon(5,5)
      dimension nanomv(5)
c
c     ier=0
c     do 150 i=1,5
      do 150 i=1,1
      call cutst(line,lenp,dire,lend)
      if (lenp.le.0) go to 300
      ier=ier+1
      read(dire,'(a4)') nalf(ier)
c     read(dire,'(a2)') nalf(i)
      iopt=3
c     iopt=11
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 300
c     nw(i)=ivet(1)
      nw(ier)=ivet(1)
      call cutst(line,lenp,dire,lend)
      if (lenp.le.0) go to 200
      nanom1=0
      do ii=2,iv-1,2
       nanom1=nanom1+1
       ffirst(ier,nanom1)=vet(ii)
       fsecon(ier,nanom1)=vet(ii+1)
       call cutst(line,lenp,dire,lend)
       call cutst(line,lenp,dire,lend)
       if (lenp.le.0) go to 200
      enddo
      nanomv(ier)=nanom1
c     nanomv(i)=nanom1
  150 continue
  200 continue
      nanomv(ier)=nanom1
c     nanomv(i)=nanom1
      return
  300 continue
      ier=-1
      return
      end

c-----------------------------------------------------------------------
      subroutine getanom(line,dire,nw,nalf,ffirst,fsecon,nkd,nanomv,ier)
      character*(*) line,dire
      dimension nalf(5),nw(5),vet(40),ivet(40),ffirst(5,5),fsecon(5,5)
      dimension nanomv(5)
c
      ier=0
      call cutst(line,lenp,dire,lend)
      if (lenp.le.0) go to 300
      ier=1
      nkd=nkd+1
      read(dire,'(a4)') nalf(nkd)
      iopt=11 ! 5 lungh. d'onda (df', f2) + nr. dei atomi
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 300
      nw(nkd)=ivet(1)
      call cutst(line,lenp,dire,lend)
      if (lenp.le.0) go to 200
      nanom1=0
      do ii=2,iv-1,2
       nanom1=nanom1+1
       ffirst(nkd,nanom1)=vet(ii)
       fsecon(nkd,nanom1)=vet(ii+1)
       call cutst(line,lenp,dire,lend)
       call cutst(line,lenp,dire,lend)
       if (lenp.le.0) go to 200
      enddo
      nanomv(nkd)=nanom1
  200 continue
      nanomv(nkd)=nanom1
      return
  300 continue
      ier=-1
      return
      end

c-----------------------------------------------------------------------
*      subroutine onebl(string,lenstr,ier)
*      character blank,string*(*),buff*120,poss*22
*      dimension in(7)
*c
*      ier=0
*      poss='pabcifrmabcnd-123456/ '
*      blank=poss(22:22)
*      k=len(string)
*      if (lenstr.eq.0) then
*          lunghezza = k
*      else
*          lunghezza = 16
*      endif
*c
*c-- check the number of blanks between items in space
*c-- group symbol ( max one blank allowed )
*c
*      buff = ' '
*      ic=0
*      j=1
*      do 10 i=1,k
*         if (string(i:i).ne.blank) then
*             buff(j:j)=string(i:i)
*             j=j+1
*             if (j.gt.lunghezza) go to 15
*             ic=0
*         else
*             if (ic.eq.0) then
*                 ic=ic+1
*                 buff(j:j)=string(i:i)
*                 j=j+1
*                 if (j.gt.lunghezza) go to 15
*             endif
*         endif
*   10 continue
*   15 do 20 i=1,lunghezza
*   20 string(i:i)=buff(i:i)
*      if (lenstr.eq.0) then
*          lenstr = Lung(string)
*          return
*      endif
*c
*c-- now check the correctness of the space group symbol
*c
*c     poss='pabcifrmabcnd-123456/ '
*c                  123456789012345
*c-- ifoll = possible following character
*c         = 0   initial state ( actual char = blank )
*c         = 1   only numbers < 7 ( not 5 )
*c         = 2   only numbers < actual number or / or blank
*c         = 3   only letters
*c         = 4   only blank
*      if (string(2:2).ne.blank) go to 800
*      n=0
*      k=0
*      iz=0
*      nbr=0
*      do 99 i=1,7
*      in(i)=0
*  99  if (string(1:1).eq.poss(i:i)) nbr=i
*      if(nbr.eq.0) go to 800
*      do 100 i=2,lenstr
*      if(string(i:i).ne.blank) go to 101
*      minus=1
*      num=0
*      ifoll=0
*      k=k+1
*      go to 100
* 101  m=0
*      do 102 j=1,14
* 102  if(string(i:i).eq.poss(j+7:j+7)) m=j
*      if(m.eq.0.or.k.gt.3) go to 800
*c     poss='pabcifrmabcnd-123456/ '
*c                  123456789012345
*           if (m.ge.1.and.m.le.6.and.ifoll.eq.3) then
*                                        ifoll=4
*      else if (m.ge.1.and.m.le.6.and.ifoll.eq.0) then
*                                        ifoll=4
*      else if (m.eq.7.and.ifoll.eq.0) then
*                                        ifoll=1
*                                        minus=-1
*                                        num=num+1
*      else if (m.ge.8.and.m.le.13.and.ifoll.le.1) then
*                                        ifoll=2
*                                        iold=m-7
*                                        if (iold.eq.5) go to 800
*                                        num=num+1
*                                        if (num.gt.2) go to 800
*      else if (m.ge.8.and.m.le.13.and.ifoll.eq.2) then
*                                        inew=m-7
*                                        if (inew.ge.iold) go to 800
*                                        num=num+1
*                                        if (num.gt.2) go to 800
*                                        ifoll=2
*      else if (m.eq.14.and.ifoll.eq.2) then
*                                        ifoll=3
*                                      else
*                                        go to 800
*                                      endif
* 100  continue
*      if (minus.lt.0.and.num.eq.1) go to 800
*c
*c-- space group symbol ok
*c
*      return
*c
*c-- error
*c
*  800 continue
*      ier=-1
*      return
*      end
c------------------------------------------------------------
      subroutine unobs(ibig,ibigD,nrefd,kv,ibrav,klatt,ksym,vsym,nitem)
      USE General
      USE Symmetry
      USE Grafici
      USE Molcom
      USE StrLogModule

      character*80,strFile,strHead(3)
      character*200,strLog

      common/resderi/rhoderi(2,5)
      integer vsym(24),ibrav(6,13),nruD(5)
      integer  hmin,hmax,kmin,kmax,lmin,lmax ,his(100),his1(100),
     *         cum1(100),cum(100)
      real rcompD(5)
      dimension vet(512)
      dimension ivet(512),kv(3),range(100),range1(100),percUnobs(100)
c     real, allocatable :: ResObs(:),ResUnobs(:)
      equivalence (vet(1),ivet(1))
      dimension ibig(indmb), ibigD(nds-1,indmb),nrefd(5)
      integer PGBEG
      integer PGOPEN

c     ALLOCATE (ResObs(nrefl),ResUnobs(10*nrefl), stat = ierr)


      if (ifGener <= 0) then
!       rhomax1 = rhomax
        if (ifGener == 0) then
         res = 0.5/sqrt(rhomax) - 0.5
        else
          res = 0.5/sqrt(rhomax) 
        endif
        res = max(1.0,res)
        resolMax = res
        rhomax1 = 0.25/(res*res)
        if (ifGener ==0) then
          ifGener = nint(resolMax*1000)
         else
          ifGener = -nint(resolMax*1000)
        endif
      else
        res = float( ifGener ) / 1000.0
        resolMax = res
        rhomax1 = 0.25/(res*res)
      endif


      ! rhomax --> resol. mass. oss.
      ! rhomax1 --> resol. mass. gene.

      nrang = 10
      div = (rhomax1 - rhomin) / float(nrang - 1)
      range(nrang)  = rhomax1
      range1(nrang) = 0.5 / sqrt(range(nrang))
      his(nrang)    = 0
      his1(nrang)   = 0
      cum(nrang)    = 0
      cum1(nrang)   = 0
      do i=nrang-1,1,-1
         range(i)  = range(i+1) - div
         range1(i) = 0.5 / sqrt(range(i))
         his(i)    = 0
         his1(i)   = 0
         cum(i)    = 0
         cum1(i)   = 0
      enddo
 
      npunti1 = 0
      npunti2 = 0
      numbGen = 0
      nreflDim = nrefl
c---
      lty = 0
c
c-- at this point the allowed reflections are on the scratch file(iscra)
c-- it is possible to add (optionally)  unobserved reflections
c
      nrec = nrefl / nrpb
      if (mod(nrefl, nrpb) > 0) nrec = nrec + 1
c
c-- ibig has been already filled with observed reflections
c
      nru = 0
      nruD(:) = 0
      nr = nrefl
c --
c --
      nnn = nrec
      nr2 = 0
      i = mod(nrefl, nrpb)
      if (i == 0) then
         nnn = nnn + 1
      else
        read(iscra, rec=nnn) vet
        nr2 = i * nitem
      endif
c--------------------
      call indmm(hmin, hmax, kmin, kmax, lmin, lmax)
c---------------------------------------------------------------
      nhmax = hmin
      nkmax = kmin
      nlmax = lmin
c-------------
      do indh=hmin, hmax
         do indk=kmin, kmax
            do indl=lmin, lmax
               if (indh == 0 .and. indk == 0 .and. indl == 0) cycle
!
!-- vedere se il nuovo riflesso generato e' equivalente
!-- ad uno gia' considerato, in questo caso :
!
c  
c    TRIGONALE : va' considerata la condizione aggiuntiva /h/>/k/
c                nel caso (+-+)
c
               if (jsys == 5 .and. indk < 0. and. 
     *             iabs(indh) < iabs(indk)) cycle
c  
c    CUBICO :  va' considerata la condizione aggiuntiva h<=k<=l
c   
               if (jsys == 6 .and. (indk < indh.and.indk > indl)) cycle
c
               indh1 = indh
               indk1 = indk
               indl1 = indl
               inbl  = indh1 * kv(1) + indk1 * kv(2) + indl1
               inbl  = iabs(inbl)
               if (ibig(inbl) /= 0) then
                   call geneq(lty,indh1,indk1,indl1,idelt,jcode,isgnn,
     *                        id1,rho,ireje)
                   m = int( (rho - rhomin) / div) + 1
                   his1(m) = his1(m) + 1
                   npunti1 = npunti1 + 1
c                  ResObs(npunti1) = 0.5 / sqrt(rho)
                   cycle
               endif
               call extin(jex,indh1,indk1,indl1,ibrav,klatt,ksym,vsym)
               if (jex /= 1) then
                   call geneq(lty,indh1,indk1,indl1,idelt,jcode,isgnn,
     *                        id1,rho,ireje)
                   if (rho > rhomax1) cycle
                   if (iabs(indh1) > ihmx(1) .or.
     *                 iabs(indk1) > ihmx(2) .or.
     *                 iabs(indl1) > ihmx(3)) cycle
                   inbl=indh1*kv(1) + indk1*kv(2) + indl1
                   inbl=iabs(inbl)
                   if (ibig(inbl) /= 0) cycle
!
!-- fill ibig using unobserved reflection and its equivalents
!
                   ibig(inbl)=-10
    
                   do ider=1, nds-1
                      if (rho <= rhoderi(1,ider)) then
                          if (ibigD(ider,inbl) == 0) then
                              ibigD(ider,inbl)=-10
                              if (rho < rhomax) nruD(ider)=nruD(ider)+1
c                             nruD(ider)=nruD(ider)+1
                          endif
                      endif
                   enddo
c
                   if (rho < rhomax) nru=nru+1
                   m=int((rho-rhomin)/div)+1
                   his(m)=his(m)+1
                   npunti2=npunti2+1
c                  ResUnobs(npunti2)=0.5/sqrt(rho)
                   if (ifGener >= 0) then
                       numbGen = numbGen + 1
                       ivet(nr2+1)=indh1
                       ivet(nr2+2)=indk1
                       ivet(nr2+3)=indl1
c                      vet(nr2+4) =  9999.9
                       vet(nr2+4) =  -1.0
c
c -- sigma field set to 0 for generated reflection
c
c
                       vet(nr2+5)= 0.0
                       ivet(nr2+6)=jcode
                       do ii=7,nitem
                          vet(nr2+ii)=0.0
                       enddo
                       i=i+1
                       nr2=nr2+nitem
                       nr=nr+1
                       if (i == nrpb) then
                           write(iscra,rec=nnn) vet
                           i = 0
                           nr2 = 0
                           nnn = nnn + 1
                       endif
                   endif
               endif
            enddo
         enddo
      enddo
!
      if (ifGener >= 0) then
          if (nr2 > 0) write(iscra,rec=nnn)vet
          nreflDim = nr
          if (numbGen > 0) then
              write(lo,310) numbGen
              write(ktml,310) numbGen
              upto = float(ifGener) / 1000.0
              write(strLog,315)numbGen,upto
              call OneBlankOnly(strLog)
              strInfo(1) = strLog
c             if (kscreen > 0) then
c              call TestoGR(strLog, -1, 2, 1)
c             endif
          endif
      else
          if (nru > 0) then
              write(lo,320) nru
              write(ktml,320) nru
          endif
      endif
  310 format(i6,' reflections (not in input data) have been added',f8.2)
  315 format(' FreeLunch data: ',i8,
     * ' reflections will be extrapolated up to ',f8.2,
     * ' <span lang="A">A</span>')


  320 format(10x,i5,'  reflections are not in input data')
**    call flush(ktml)
      rcompP=100.*(1-float(nru)/float(nrefl))
      rcompD(:)=100.
      do ider=1,nds-1
       rcompD(ider)=1-float(nruD(ider))/float(nrefd(ider))
       rcompD(ider)=rcompD(ider)*100.
      enddo

      if (ianom==3) then
        select case (nds-1)
        case (1)
        write(strLog,'(17h Completeness(%):,2(5x,f6.1))')
     *   rcompP,rcompD(1)
        case (2)
        write(strLog,'(17h Completeness(%):,3(5x,f6.1))')
     *   rcompP,rcompD(1:2)
        case (3)
        write(strLog,'(17h Completeness(%):,4(5x,f6.1))')
     *   rcompP,rcompD(1:3)
        case (4)
        write(strLog,'(17h Completeness(%):,5(5x,f6.1))')
     *   rcompP,rcompD(1:4)
        case (5)
        write(strLog,'(17h Completeness(%):,6(5x,f6.1))')
     *   rcompP,rcompD(1:5)
        end select
      elseif (ianom==6) then
        select case (nds-1)
        case (1)
        write(strLog,'(17h Completeness(%):,2(5x,f6.1))')
     *   rcompD(1)
        case (2)
        write(strLog,'(17h Completeness(%):,3(5x,f6.1))')
     *   rcompD(1:2)
        case (3)
        write(strLog,'(17h Completeness(%):,4(5x,f6.1))')
     *   rcompD(1:3)
        case (4)
        write(strLog,'(17h Completeness(%):,5(5x,f6.1))')
     *   rcompD(1:4)
        case (5)
        write(strLog,'(17h Completeness(%):,6(5x,f6.1))')
     *   rcompD(1:5)
        end select
      elseif (ianom==9) then
        select case (nds-1)
        case (1)
        write(strLog,'(17h Completeness(%):,2(5x,f6.1))')
     *   rcompP,rcompD(1)
        end select
      else
        write(strLog,'(17h Completeness(%):,5x,f6.1)')rcompP
      endif
!
       call TestoGR(strLog, -1, 2, 1)
       if (numbGen > 0) then
        call TestoGR(strInfo(1), color_LIGHTRED, 2, 1)
       endif
       call zflush
       call DoSingleIteration()
!

      rhomax=rhomax1
      percUnobs(:)=100.0
      cum(1)=his(1)
      cum1(1)=his1(1)
      if (his1(1) > 0) then
       percUnobs(1)=100.*float(his(1))/float(his1(1))
      endif
      do i=2,nrang
        cum(i)=cum(i-1)+his(i)
        cum1(i)=cum1(i-1)+his1(i)
        if (his1(i) > 0) then
         percUnobs(i)=100.*float(his(i))/float(his1(i))
        endif
      enddo
      write(lo,1000)
      do 500 i=nrang,1,-1
      write (lo,2000)range(i),range1(i),cum1(i),cum(i)
 500  continue
1000  format(/,3x,'[sin(t)/l]2',4x,'[A]',3x,'NR(obs)',3x,'NR(nobs)')
2000  format (' ',f7.4,8x,f5.2,2x,i6,4x,i6)


c     DEALLOCATE (ResObs,ResUnobs, stat = ierr)
3000  continue

      return
      end
c-----------------------------------------------------------------------
      subroutine indmm(hmin,hmax,kmin,kmax,lmin,lmax)
c
      USE General
      USE Symmetry
      integer  hmin,hmax,kmin,kmax,lmin,lmax
      character ntc*16
c
      write(ntc,'(16a1)') nSpaceG
c --
c --   calcolo hmin e hmax , kmin e kmax , lmin e lmax
c --
        hmin=-ihmx(1)
        hmax=ihmx(1)
        kmin=-ihmx(2)
        kmax=ihmx(2)
        lmin=-ihmx(3)
        lmax=ihmx(3)
c --
c -- TRICLINO
c --
      if (jsys.eq.1) then
        hmin=0
c --
c -- MONOCLINO
c --
      else if (jsys.eq.2) then
       if (ntc(3:3).eq.'1') then
        if (ntc(5:5).eq.'1') then
c -- 2//c
            hmin=0
            lmin=0
        else
c -- 2//b
            hmin=0
            kmin=0
        endif
      else
        if (ntc(4:4).eq.'1') then
         if (ntc(6:6).eq.'1') then
c -- 2//a
            hmin=0
            kmin=0
         else
c -- 2//b
            hmin=0
            kmin=0
         endif
        else
         if(ntc(5:5).eq.'1') then
c -- 2//a
            kmin=0
            hmin=0
         else
c -- 2//b
            hmin=0
            kmin=0
         endif
        endif
       endif
c --
c -- ORTOROMBICO
c --
      else if (jsys.eq.3) then
          hmin=0
          kmin=0
          lmin=0
c --
c -- ESAGONALE E TRIGONALE :
c --
      else if (jsys.eq.5) then
            hmin=0
            lmin=0
c --
c -- CUBICO :  va' considerata la condizione aggiuntiva h<=k<=l
c --
      else if (jsys.eq.6) then
           hmin=0
           kmin=0
           lmin=0
      endif
c --
      return
      end
!-----------------------------------------------------------------------
      function jopenNew(ncsu,name,istat,iform,ier)
!--connect a unit to an external file
!  file properties:
!  sequential
!  formatted
!  ncsu = number identifies the unit
!  name = file name
!  istat = 0 means status unknown
!        = 1 means status scratch
!        = 2 means status old
!  iform = 1 means formatted
!        = 2 means unformatted
!  ier  = integer variable to receive a status indicator
!--
      character *(*) name
      character form(2)*11
!
      form(1)='formatted  '
      form(2)='unformatted'
      jopenNew=0
      jump=istat+1
      if(iform.eq.2)go to 5000
c     print*,jump
      go to (1000,2000,3000),jump
 1000 continue
c     print*,'kuku'
!-- status = 'unknown'
      open(unit=ncsu,file=name,iostat=ier,err=9000,
     1 status='unknown',form=form(iform))
      go to 8000
 2000 continue
!-- status = 'scratch'
      open(unit=ncsu,iostat=ier,err=9000,
     1 status='scratch',form=form(iform))
      go to 8000
 3000 continue
!-- status = 'old'
      open(unit=ncsu,file=name,iostat=ier,err=9000,
     1 status='old',form=form(iform))
      go to 8000
5000  continue
      go to (1100,2100,3100),jump
 1100 continue
!-- status = 'unknown'
      open(unit=ncsu,file=name,iostat=ier,err=9000,
     1 status='unknown',form=form(iform))
      go to 8000
 2100 continue
!-- status = 'scratch'
      open(unit=ncsu,iostat=ier,err=9000,
     1 status='scratch',form=form(iform))
      go to 8000
 3100 continue
!-- status = 'old'
      open(unit=ncsu,file=name,iostat=ier,err=9000,
     1 status='old',form=form(iform))
 8000 continue
c     rewind ncsu
      return
9000  jopenNew=-1
      return
      end
!------------------------------------------------------------------------------
      block data theo_distib

      common /Estat/ nst,nrw,stl(10),rsv(10),rhr(10),nhr(10),nu(25),
     *               ava(10),avc(10),avh(10),cph(25),
     *               vst(10),zt(25),ee(10)
                                                                                                        
!     tables of theoretical distributions  (normalized SFs)
      data ava/0.886,1.0,1.329,2.0,3.323,6.0,0.736,1.0,2.0,2.415/
      data avc/0.798,1.0,1.596,3.0,6.383,15.0,0.968,2.0,8.0,8.691/
      data avh/0.718,1.0,1.916,4.5,12.26,37.5,1.145,3.5,26.0,26.903/
      data cph/0.368,0.463,0.526,0.574,0.612,0.643,0.670,0.694,0.715,
     * 0.733,0.765,0.791,0.813,0.832,0.848,0.863,0.875,0.886,0.896,
     * 0.905,0.913,0.920,0.926,0.932,0.938/
!
       end
!------------------------------------------------------------------------------
      subroutine EcalStatistics(iflR)
      USE General
      USE Symmetry
      USE Riflessi
c     USE BigStore
!
      character line(25,3),star,cbuff*81
c     common /c/ flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,del,ks
c     common/cd/btd,scd,difbfac,icut,rhomaxD,rhominD,rhomaxP,rhominP
      common /Estat/ nst,nrw,stl(10),rsv(10),rhr(10),nhr(10),nu(25),
     *               ava(10),avc(10),avh(10),cph(25),
     *               vst(10),zt(25),ee(10)
!
      dimension ctest(3)
      data star /'*'/
!     
!-     output statistics 
!
!-- set initial values
      rho1 = rhomaxP
c     rho2 = minval(rhov(1:nrefl))
      rho2 = rhominP
      delta = sqrt(rho1) - sqrt(rho2)
c     write(6,*) 'RHOMAX, RHOMIN',sqrt(rho1),sqrt(rho2)
      rr = 10.0 / delta

      if (iflR > 0) then     ! calcola i valori per le statistiche

           do  i=1,10
              rhr(i)=0.0
              nhr(i)=0
              vst(i)=0.0
           enddo
           nst=0
           nrw=0
           do  i=1,25
              zt(i)=0.0
              nu(i)=0
           enddo
           do 100 i = 1,nrefl     !nreflDim
!g            if (fcoef(i) < 0.0) goto 100
              if (fcoef(i) > 0.0) then
                  rho=rhov(i)
                  e=ecoef(i) * ecoef(i)    ! E**2
                  multt = mult(i)
!-- calculate E
                  esq=e
                  e=sqrt(esq)
                  ed=e
                  ew=e
!-- work out final statistics
                  tmul=float(multt)
!-- distribution of E with sin(theta)/lambda
!mr               n=min0(10,int(1.0+rr*(sqrt(rho)-sqrt(rho2))))
                  n=min0(10,1 + int(rr*(sqrt(rho)-sqrt(rho2))))
                  nhr(n)=nhr(n)+multt
                  rhr(n)=rhr(n)+esq*tmul
                  nzr=int(10.0*esq)+1
                  if(nzr.gt.10) nzr=10+(nzr-9)/2
                  ee(1)=ed
                  do j=2,6
                     ee(j)=ee(j-1)*ed
                  enddo
                  ee(7)=esq-1.0
                  ee(8)=ee(7)*ee(7)
                  ee(9)=ee(8)*ee(7)
                  ee(10)=abs(ee(9))
                  ee(7)=abs(ee(7))
!-- add functions of E to appropriate zones
                  do j=1,10
                     ee(j)=tmul*ee(j)
                     vst(j)=vst(j)+  ee(j)
                  enddo
                  nst=nst+multt
                  if(nzr.le.25) zt(nzr)=zt(nzr)+tmul
!-- distribution of E for complete data
                  net=min0(25,int(10.0*ed))
                  if (net.ne.0) then
                      nu(net)=nu(net)+1
                  endif
                  nrw=nrw+multt
              endif
 100       continue

      endif 

      rr = 1.0 / rr
      do i = 1,10
         stl(i)=sqrt(rho2) + rr*float(i)
         rsv(i) = 0.5 / stl(i)
         if(nhr(i).gt.0) rhr(i)=rhr(i)/float(nhr(i))
         if(nst.gt.0) vst(i)=vst(i)/float(nst)
      enddo
      write(lo,330)
     * (stl(j),j=1, 5),(rsv(j),j=1, 5),(rhr(j),j=1, 5),(nhr(j),j=1, 5),
     * (stl(j),j=6,10),(rsv(j),j=6,10),(rhr(j),j=6,10),(nhr(j),j=6,10)
  330 format(/,22x,'***   Final statistics section   ***',//,1h ,10x,
     * 60hDistribution of <E**2> with sin(th)/lambda and Resol. (Ang.),
     * /,2(13h sinth/lambda,3x,5f10.4,/,
     *   1h ,4x,8hResol.  ,3x,5f10.2,/,
     *   1h ,4x,8h<E**2>  ,3x,5f10.4,/,
     *   1h ,4x,8hnumber  ,3x, 5i10,//))
      write(lo,340)
  340 format(38x,14hAverage values)
      write(lo,345)
  345 format(/,5x,7hAverage,
     *        29x,7hNumeric,19x,7hGraphic,/)
      write(cbuff,350)
  350 format( 21x,8hall data,2x,8hacentric,3x,7hcentric,
     *         2x,12hhypercentric,2x,'a. c. h.')
      write(lo,'(a)') cbuff
      do i=1,10
         do j=1,3
            line(i,j)=blank
         enddo
         if (i.eq.2) cycle
         ctest(1)=abs(vst(i)-ava(i))
         ctest(2)=abs(vst(i)-avc(i))
         ctest(3)=abs(vst(i)-avh(i))
         cmin=9999.9
         do j=1,3
            if (ctest(j).lt.cmin) then
                cmin=ctest(j)
                llim=j
            endif
         enddo
         line(i,llim)=star
      enddo
      write(lo,430) (vst(i),ava(i),avc(i),avh(i),
     *              (line(i,j),j=1,3),i=1,10)
  430 format(1h ,5x,6hmod(E),7x,  4f10.3,6x,3(a1,2x),/
     1 1h ,6x,4hE**2,8x,          4f10.3,6x,3(a1,2x),/
     2 1h ,6x,4hE**3,8x,          4f10.3,6x,3(a1,2x),/
     3 1h ,6x,4hE**4,8x,          4f10.3,6x,3(a1,2x),/
     4 1h ,6x,4hE**5,8x,          4f10.3,6x,3(a1,2x),/
     5 1h ,6x,4hE**6,8x,          4f10.3,6x,3(a1,2x),/
     6 1h ,2x,11hmod(E**2-1),5x,  4f10.3,6x,3(a1,2x),/
     7 1h ,2x,11h(E**2-1)**2,5x,  4f10.3,6x,3(a1,2x),/
     8 1h ,2x,11h(E**2-1)**3,5x,  4f10.3,6x,3(a1,2x),/
     9 1h ,16h(mod(E**2-1))**3,2x,4f10.3,6x,3(a1,2x))
      write(lo,450)
  450 format(//,21x,40hn(z) cumulative probability distribution,/)
      cbuff(7:7)='z'
      write(lo,'(a)') cbuff
      do i=1,25
         if(nst.gt.0) zt(i)=zt(i)/float(nst)
         if(i.ne.1) zt(i)=zt(i)+zt(i-1)
!     theoretical distributions
         zz=0.1*float(i)
         if(i.gt.10) zz=2.0*zz-1.0
!     acentric
         cpa=1.0-exp(-zz)
!     centric
         xx=sqrt(0.5*zz)
         t=1.0/(1.0+0.47047*xx)
         cpc=1.0-((0.74786*t-0.09588)*t+0.34802)*t*exp(-0.5*zz)
         do j=1,3
            line(i,j)=blank
         enddo
         ctest(1)=abs(zt(i)-cpa   )
         ctest(2)=abs(zt(i)-cpc   )
         ctest(3)=abs(zt(i)-cph(i))
         cmin=9999.9
         do j=1,3
            if (ctest(j).lt.cmin) then
                cmin=ctest(j)
                llim=j
            endif
         enddo
         line(i,llim)=star
         write(lo,480) zz,zt(i),cpa,cpc,cph(i),(line(i,j),j=1,3)
      enddo
  480    format(1h ,f7.1,11x,4f10.3,6x,3(a1,2x))
      do i=1,24
         j=25-i
         nu(j)=nu(j)+nu(j+1)
      enddo
         write(lo,520)
  520    format(//,18x,44hDistribution of E - number of E s .gt. limit)

         do i=1,25
            avr(i)=0.1*float(i)
         enddo

         write(lo,560) (avr(i),i= 6,15),(nu(i),i= 6,15),
     *                 (avr(i),i=16,25),(nu(i),i=16,25)
  560    format(/,2(6x,4hE   ,10f6.1,/,3x,7hnumber ,10i6,//))

!     output reflexions for sir

      return
      end
!-----------------------------------
      subroutine CorrectBassoTeta(ipri)
      USE General
      USE Riflessi
c
      dimension tetp(30,3)
c
      ResSog = 5.0
c     kverbo = ipri
      if (iprin.gt.0)  write(lo,*) 'CorrectBassoTeta ' 
      if (iprin.gt.0)  write(lo,*) ' ' 
      call StatLow(tetp,iren,ipri,ier)
      if (ier.lt.0) then
          return
      endif
c
      resol = ResSog
      rhosog = (0.5 / resol) **2.
      nfin = nrefl   ! nreflDim
      nnref = 0
      mmref = 0
      deltamin = 99999.9
      BBmin = 0.0
      gcomin = 0.0
c
      do 100 ii = 1,4
         gco = 0.5 + ii*0.1
         do 200 j = 1,4
            BB = 50. + j*100.           
            sume2 = 0.0
            ave2 = 0.0
            do 300 i=1,nfin
               rho = rhov(i)
               if(rho.le.rhosog) then
                  if(ii.eq.1.and.j.eq.1) then
                     nnref = nnref +1
                     mmref = mmref + mult(i)
                  endif
c                 tmult = float(mult(i)) 
                  tmult = mult(i)
                  e = ecoef(i)
                  e2_temp = e * e
                  denom =  1-(gco*exp(-BB*rhov(i)))
                  e2_temp = (e / denom)**2.
                  sume2 = sume2 + e2_temp * tmult
               endif
 300        continue
            ave2 = sume2/mmref 
            delta = (ave2 - 1)**2.
            if(delta.lt.deltamin) then
               deltamin = delta
               gcomin = gco
               BBmin  = BB
            endif
 200     continue
 100  continue
      do 400 i=1,nfin
         rho = rhov(i)
         if(rho.le.rhosog) then
            e = ecoef(i)
            denom =  1-(gcomin*exp(-BBmin*rhov(i)))
            ecoef(i) = e / denom
         endif
 400  continue
!
      if (iprin.gt.0)  write(lo,*) ' ' 
      call StatLow(tetp,iren,ipri,ier)
      iren = -1
      if (iren.eq.1) then
          call RenLow(tetp)
          if (iprin.gt.0)  write(lo,*) ' ' 
          call StatLow(tetp,iren,ipri,ier)
      endif
c
          if (iprin.gt.0)  write(lo,*) 'Fine BassoTeta ' 
c
      return
      end
c-------------------------------------------------------------------
      subroutine StatLow(tetp,iren,ipri,ier)
      USE General
      USE Symmetry
      USE Riflessi
c
      dimension sw2(30),sr(30),nsum(30),avr_temp(30),avw2(30)
      dimension tetp(30,3)
c
c     kverbo = ipri
      ier = 0
      iren = 0
      rhosog = (0.5 / ResSog) **2.
      rhoshmin =  0.0000001
      nfin = nreflDim
      nnref = 0
      mmref = 0
      do i=1,nfin
         if (rhov(i).ge.rhoshmin.and.rhov(i).le.rhosog) then
             nnref = nnref + 1
             mmref = mmref + mult(i)
         endif
      enddo
c
      if (nnref.eq.0) then
          ier = -1
          return
      endif
      nbWils = 9
      add=rhosog/float(nbWils)
      rr=float(nbWils)/rhosog
c
      start=-add
      end=add
      number=0
      do 50 i=1,30
         sw2(i)=0.0
         sr(i)=0.0
         nsum(i)=0
         avr_temp(i)=0.0
         avw2(i)=0.0
   50 continue
c
      do 200 i=1,nfin
         rho=rhov(i)
         if(rho.gt.rhosog) go to  200
         ew=ecoef(i)
c-- n stores range of rho
         n=min0(int(1.0+rr*rho),nbWils)
         mmult=mult(i)
         tmul=float(mmult)
!        write(lo,22) i,(khl(ii,i),ii=1,3),mmult,ew,rho
c-- weighted sums
c-- number of reflexions
         nsum(n)=nsum(n)+mmult
c-- E**2
         ew2 = ew**2.
         sw2(n)=sw2(n)+ew2*tmul
c-- rho
         sr(n)=sr(n)+rho*tmul
  200 continue
      do 300 i=1,nbWils
c-- smooth curve by adding adjacent ranges
         number=number+nsum(i)
         nsum(i)=nsum(i)+nsum(i+1)
         sw2(i)=sw2(i)+sw2(i+1)
         sr(i)=sr(i)+sr(i+1)
c-- calculate weighted averages and total summations
         peso=float(nsum(i))
         if(nsum(i).gt.0)  then
            div=1.0/amax1(1.0,peso)
            avr_temp(i)=sr(i)*div
            avw2(i)=(sw2(i)*div)
            avri  = 1.0 / ( 2.0*sqrt(avr_temp(i))) 
          else
            avr_temp(i)= 0.0
            avw2(i)= 0.0
            avri  = 0.0
         endif
         start=start+add
         end=end+add
         end=amin1(end,rhosog)
         if (start.gt.0.0001) then
             startp = 1.0 / ( 2.0*sqrt(start)) 
         else
             startp = 999
         endif
         endp  = 1.0 / ( 2.0*sqrt(end)  ) 
         tetp(i,1) = startp
         tetp(i,2) = endp
         tetp(i,3) = avw2(i)
         if (iprin.gt.0) then
             write(lo,280) i,startp,endp,nsum(i),avri,avw2(i)
         endif
         if (tetp(i,3).gt.1.5) iren = 1
  300 continue
  280 format(' ',i3,f15.4,'  -',f8.4,i11,2f14.4)
 
      return
      end
c---------------------------------------------------------------
      subroutine RenLow(tetp)
      USE General
      USE Symmetry
      USE Riflessi
c
      dimension tetp(30,3)
c
      nfin = nreflDim
      rhosog = (0.5 / ResSog) **2.
      do i=1,nfin
         rho = rhov(i)
         rhop = 1.0 / ( 2.0*sqrt(rho))
         if (rho.lt.rhosog) then
             e = ecoef(i)
             e2_temp = e * e
             do j=nbWils,1,-1
                if (tetp(j,1).gt.rhop.and.rhop.ge.tetp(j,2)) then
                    ii = j
                endif
             enddo
             ren = 1.0
             if(tetp(ii,3).gt.1.5) ren = 1.5 / tetp(ii,3)
             e2_temp = e2_temp * ren
             ecoef(i) = sqrt(e2_temp)
!        write(lo,55) i,rhop,tetp(ii,1),tetp(ii,2),tetp(ii,3),ren,
!    *               e*e, e2, e, ecoef(i)
         endif
      enddo
 55   format(' ',i9,')',f10.4,f12.4,'  -',f8.4,6f10.4)
c
      return
      end
!-----------------------------------
      subroutine normalAll(ier)

      USE General
      USE Symmetry
      USE Grafici
      USE Riflessi
      USE RiflessiMAD
      USE RiflessiMIR
      USE Molcom

      character*200 strLog


c     write(lo,*) '================================================='
c     write(lo,*) '            Normalization Section'
c     write(lo,*) '================================================='

      write(ktml,'(/," <b><u>Normalization Section </b></u>",/)')

      ixnor=0
      knorm=0
      iflagx=0
      jposition=0

      select case (ianom)
      case (3)
       ixnor=1
       jposition=1
      case (6)
       ixnor=2
       jposition=1
      case (9)
       ixnor=1
       jposition=1
      end select
      write(lo,*)
      write(lo,*)'   ====== Native: Wilson Plot ======'
      write(lo,*)

      write(ktml,'("   -Native Wilson Plot")')

      ! norma. la nativa
      call PrepNorm(0,0)
      call fcalN(0,0,nrefNorm)
      nbWils=8.0*alog10(0.05*float(max0(nrefNorm,100))+0.5)
c     maximum of 30 points on wilson plot
c     if(nbWils.gt.30) nbWils=30
      if(nbWils.gt.29) nbWils=29
c     write(lo,442) nbWils
      call sumN(0,0,0.0,0.0)
      call plotwN
      call rescaN(0,0,0)
      call ecalN()
      call UpdateRiflessi(0,0)
      scNative=sc
      btNative=bt
c     write(lo,*)'Native (sc/bt):',nrefNorm,sc,bt
      write(lo,*)
      if (ixnor==0) goto 200

 100  continue

      if (ixnor==1) then
       call SigHEstimate(1,jposition)
       write(lo,*)
       write(lo,*)'   ====== SIR data: Wilson Plot ======'
       write(ktml,'("   -SIR ",a2, " data:  Wilson Plot <br>")')
     *       nalfd(jposition)
      endif
      if (ixnor==2) then
       write(lo,*)
       write(lo,*)'   ====== SAD data: Wilson Plot ======'
       write(ktml,'("   -SAD data ",i1, "  Wilson Plot")')jposition
       write(lo,*)
      endif

      call PrepNorm(ixnor,jposition)

      call fcalN(ixnor,jposition,nrefNorm)

      nbWils=8.0*alog10(0.05*float(max0(nrefNorm,100))+0.5)

c     maximum of 30 points on wilson plot
c     if(nbWils.gt.30) nbWils=30
      if(nbWils.gt.29) nbWils=29
c     write(lo,442) nbWils
c 442 format(34h number of points on wilson plot =,i3)

c     xsc=sc
c     xbt=bt
      call sumN(ixnor,jposition,scNative,btNative)
      if (ixnor==1) then
        scd(jposition)=scNative/sc
        btd(jposition)=btNative-bt
        sc=scNative
        bt=btNative
         write(lo,'(//,18x,22hDIFFERENCE WILSON PLOT,/)')
         write(lo,'(  18x,22h**********************)')
         write(lo,'(  18x,21hNative reflections = ,i6)')nrefl
         write(lo,'(  18x,31hDerivative/Native reflections = ,i6)')
     *                   nrefNorm
         write(lo,'(  18x,15hdmin (Native)= ,f5.2)')
     *         1.0/(2.0*sqrt(rhomaxP))
         write(lo,'(  18x,6hsc  = ,f10.3)')sc
         write(lo,'(  18x,6hBt  = ,f10.3)')bt
         write(lo,'(  18x,19hdmin (Derivative)= ,f5.2)')
     *         1.0/(2.0*sqrt(rhomaxD))
         write(lo,'(  18x,6hscd = ,f10.3)')scd(jposition)
         write(lo,'(  18x,6hBtd = ,f10.3,/)')btd(jposition)
c--
         write(ktml,'(8x,"<b><u>DIFFERENCE Native/Derivative",
     *               " WILSON PLOT</b></u><br>")')
         write(ktml,'(8x,21hNative reflections = ,i6)')nrefl
         write(ktml,'(8x,31hDerivative/Native reflections = ,i6)')
     *                   nrefNorm
         write(ktml,'(8x,15hdmin (Native)= ,f5.2)')
     *         1.0/(2.0*sqrt(rhomaxP))
         write(ktml,'(8x,6hsc  = ,f10.3)')sc
         write(ktml,'(8x,6hBt  = ,f10.3)')bt
         write(ktml,'(8x,19hdmin (Derivative)= ,f5.2)')
     *         1.0/(2.0*sqrt(rhomaxD))
         write(ktml,'(  8x,6hscd = ,f10.3)')scd(jposition)
         write(ktml,'(  8x,6hBtd = ,f10.3,/)')btd(jposition)

         call rescaN(ixnor,jposition,0)
         call decalN(jposition,nrefNorm)
      else
        call plotwN
        call rescaN(ixnor,0,0)
        call ecalN()
        scd(jposition)=sc
        btd(jposition)=bt
      endif
    
      call UpdateRiflessi(ixnor,jposition)

      if (jposition > 0 .and. jposition < (nds-1)) then
         jposition = jposition +1
         goto 100
      elseif(jposition > 0 .and. jposition==nds-1) then
         ixnor = 0
         jposition = 0
c        goto 100
      else
        ! finito
      endif


 200  continue
      ! dopo la normaliz. della nativa 
      ! ordiniamo i riflessi in funzione di E e riscriviamo la lista 7
      do i=1,nrefl
         iorde(i) = i
      enddo
c     if (numbGen > 0) then
c         do i=nrefl+1, nreflDim
c            evet(i) = -rhov(i)
c            evet(i) = -1.0
c         enddo
c     endif

      isort = -1
      iuno = 1
      call sortall3(isort,evet,iuno,nrefl,iorde)

      sc=scNative
      bt=btNative
*gl*  call riCreaLista6()
      call riCreaRiflessiSirprot()
      
!---------------------------
      if (ianom==0) then
        write(strLog,'(16h Thermal Factor:,4x,5x,f6.1)')bt
      elseif (ianom == 6) then
      select case (nds-1)
      case (1)
        write(strLog,'(16h Thermal Factor:,4x,1(5x,f6.1))')btd(1:1)
      case (2)
        write(strLog,'(16h Thermal Factor:,4x,2(5x,f6.1))')btd(1:2)
      case (3)
        write(strLog,'(16h Thermal Factor:,4x,3(5x,f6.1))')btd(1:3)
      case (4)
        write(strLog,'(16h Thermal Factor:,4x,4(5x,f6.1))')btd(1:4)
      end select
      elseif (ianom == 3) then
      select case (nds-1)
      case (1)
        write(strLog,'(16h Thermal Factor:,4x,2(5x,f6.1))')
     *  bt,btd(1:1)
      case (2)
        write(strLog,'(16h Thermal Factor:,4x,3(5x,f6.1))')
     *    bt,btd(1:2)
      case (3)
        write(strLog,'(16h Thermal Factor:,4x,4(5x,f6.1))')
     *   bt,btd(1:3)
      case (4)
        write(strLog,'(16h Thermal Factor:,4x,5(5x,f6.1))')
     *   bt,btd(1:4)
      end select
      elseif (ianom == 9) then
       select case (nds-1)
       case (1)
        write(strLog,'(16h Thermal Factor:,4x,2(5x,f6.1))')
     *  bt,btd(1:1)
      end select
      endif

      if (kscreen > 0) then
       call TestoGR(strLog, -1, 2, 1)
       call zflush
       call DoSingleIteration()
      endif
!---------------------------

      return

      end
!--------------------------------------------------------------------
      subroutine PrepNorm(ixnor,jposition)

      USE General
      USE Symmetry

      common/HeavyEstimate/s3s2de(5),sigHPe(5),sigHe(5),numHeavye(5),
     *                     occupe(5)

c     print*,'PrepNorm',ixnor,jposition


      gis(:)=0.0
      giw(:)=0.0
      gisd(:)=0.0
      giwd(:)=0.0
c     calculate wilson (giw) and debye (gis) scattering factors for native/derivative
       do 9230 i=1,142
        t=0.01*float(i-1)
        tt=t*t
        giw(i)=0.0
        do 9220 j=1,nk
          fz = cl(j)
          do  jj=1,4
            bst=bs(jj,j)*tt
            if(bst.le.60.)  fz=fz+al(jj,j)*exp(-bst)
          enddo
          if (ixnor == 2) then
            do ja=1,nkd
              if (nalf(j).eq.nalfd(ja)) then
                arg=(fz+ffirst(ja,jposition))**2 +
     *                 fsecon(ja,jposition)**2
                fz=sqrt(arg)
                exit
              endif
            enddo

          endif
          fz2=fz*fz
          gis(i)=gis(i)+fz2*float(nw(j))
          fnw=float(nw(j))
          giw(i)=giw(i)+fz2*fnw
 9220   continue
         if (ixnor==1) then
           gisd(i)=gis(i)
           giwd(i)=giw(i)
           do ia=1,nkd
            if (ia==jposition) then
             fz = cld(ia)
             do  jj=1,4
               bst=bsd(jj,ia)*tt
               if(bst.le.60.)  fz=fz+ald(jj,ia)*exp(-bst)
             enddo
             fz2=fz*fz
             nheavy=numHeavye(jposition)
             socc2= nheavy*nsym*pts*occupe(jposition)**2

c            gisd(i)=gis(i)+fz2*float(nwd(ia))
c            fnw=float(nwd(ia))
             gisd(i)=gis(i)+fz2*socc2
             fnw=socc2
             giwd(i)=giwd(i)+fz2*fnw
            endif
           enddo
          endif
 9230   continue
c       if (ixnor==1) then
c       do i=1, 142
c        write(1,*) gisd(i),giwd(i)
c       enddo
c       stop
c       endif

        return
        end
!--------------------------------------------------------------------
c     least squares plot, including summation over nb ranges of rho
      subroutine sumN(ixnor,jposition,xsc,xbt)
      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMAD
      USE RiflessiMIR

c     common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/shell/zme(2,30),enr,ewmin(30),zmed(2,30),enrd,ewmind(30)
      common/eqcoe/ppp,q,r,t,s
c     common/cd/btd,scd,difbfac,icut,rhomaxD,rhominD,rhomaxP,rhominP

      dimension sw(30),sd(30),sr(30),nsum(30),si(30),nsum1(30)
      dimension swd(30),sdd(30),srd(30),sid(30)
      dimension sip(30),nsump(30)
      
c     iprin=1
c     print*,'SUM=',ixnor,jposition,pts

      if0=0
      ppp=0.0
      q=0.0
      r=0.0
      s=0.0
      t=0.0
      number=0
      if (ixnor == 1) then
        rmin=rhominD
        rmax=rhomaxD
      else
        rmin=rhominP
        rmax=rhomaxP
      endif

c     if (iphase > 0) rmin=0.0

      add=(rmax-rmin)/float(nbWils)
      start=-add
      end=add
      rr=float(nbWils)/(rmax-rmin)

      do 50 i=1,30
      sw(i)=0.0
      sd(i)=0.0
      sr(i)=0.0
      si(i)=0.0
      nsum(i)=0
      nsum1(i)=0
      ewmin(i)=99.9

      nsump(i)=0
      sip(i)=0.0

      swd(i)=0.0
      sdd(i)=0.0
      sr(i)=0.0
      sid(i)=0.0
      ewmind(i)=99.9
 50   continue

      do 100 i=1,nrefl
         fo=fcoef(i)
         rho=rhov(i)
         if (rho.gt.rmax.or.rho.lt.rmin.or.fo.lt.0.0) goto 100
         if (ixnor == 1) then
           fd=fod(jposition,i)
           edd=e2(i)
           ewd=e1(i)
         endif
         edp=work1(i)
         ewp=work2(i)

         if (ixnor == 1.and.fd < 0.0) then
           n=min0(int(1.0+rr*(rho-rmin)),nbWils)
           multt = mult(i)
           eps = epsv(i)
           tmul=float(multt)
           nsump(n)=nsump(n)+1
           sip(n)=sip(n)+tmul*fo*fo/(eps*pts)
           goto 100
         endif


c-- n stores range of rho
         n=min0(int(1.0+rr*(rho-rmin)),nbWils)
         
         multt = mult(i)
         eps = epsv(i)
         tmul=float(multt)
c-- weighted sums
c-- number of reflexions
         nsum(n)=nsum(n)+multt
         nsum1(n)=nsum(n)+1
c-- wilson
         sw(n)=sw(n)+ewp*tmul
         if (ewp.lt.ewmin(n)) then
             ewmin(n) = ewp
         endif
c-- debye
         edi=edp
         if (edi.lt.0.) edi=0.
         sd(n)=sd(n)+edi*tmul
c-- rho
         sr(n)=sr(n)+rho*tmul
c-- intensity
         fo2=fo*fo
         if (fo2.lt.0.) fo2 = 0.
         si(n)=si(n)+tmul*fo2/(eps*pts)

         if (ixnor == 1) then
c-- wilson
           swd(n)=swd(n)+ewd*tmul
           if (ewd.lt.ewmind(n)) then
               ewmind(n) = ewd
           endif
c-- debye
           edid=edd
           if (edid.lt.0.) edid=0.
           sdd(n)=sdd(n)+edid*tmul
c-- intensity
           fd2=fd*fd
           if (fd2.lt.0.) fd2 = 0.
           sid(n)=sid(n)+tmul*fd2/(eps*pts)

         endif

 100  continue

      do i=1,nbWils
         if (nsum(i) > 0) then
             nbW = i
         else
             exit
         endif
      enddo
      if (nbW < nbWils) then
          write(lo,*) 
          write(lo,*) 
     *    '     *********************************************'
          write(lo,*) 
     *    '     ** Some problems in Wilson-plot procedure. **'
          write(lo,*) 
     *    '     **   If program fails, check reflections.  **'
          write(lo,*) 
     *    '     *********************************************'
          write(lo,*) 
c         Msg = 'Some problems in Wilson-plot procedure.'
c    *          // char(10) // 'If program fails, check reflections'
c         call OpenWarning(Msg)
      endif
      nbWils = nbW
      iflag = 0
      do while (iflag.eq.0.and.nbWils.gt.0)
         if (nsum(nbWils).eq.0.or.
     *         sw(nbWils).lt.0.000001.or.
     *         sd(nbWils).lt.0.000001) then
             nbWils = nbWils - 1
         else
             iflag = 1
         endif
      enddo
      if (nbWils.le.1) then
c         write(Msg,301)
c         call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          ier=-1
          return
      endif
      nnpn = 0
      do 300 i=1,nbWils
c-new 19/04/93
         if (nsum(i).eq.0.or.sw(i).lt.0.000001.or.
     *         sd(i).lt.0.000001) then
c-new 28/06/2002
             if (nnpn.eq.0) then
                goto 300
             end if
c-
c            write(Msg,301)
c            call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
             ier=-1
             return
         endif
         nnpn = 1
c-- smooth curve by adding adjacent ranges
         number=number+nsum(i)
         nsum(i)=nsum(i)+nsum(i+1)
         nsum1(i)=nsum1(i)+nsum1(i+1)
         ! native
         sw(i)=sw(i)+sw(i+1)
         sd(i)=sd(i)+sd(i+1)
         sr(i)=sr(i)+sr(i+1)
         si(i)=si(i)+si(i+1)
         ! derivative
         if (ixnor == 1) then
          swd(i)=swd(i)+swd(i+1)
          sdd(i)=sdd(i)+sdd(i+1)
          srd(i)=srd(i)+srd(i+1)
          sid(i)=sid(i)+sid(i+1)
          sip(i)=sip(i)+sip(i+1)
          nsump(i)=nsump(i)+nsump(i+1)
         endif

c-- calculate weighted averages and logs
         peso=float(nsum(i))
         div=1.0/amax1(1.0,peso)
         esqav=sd(i)*div
         if (ixnor == 1) then
           esqavd=sdd(i)*div
           esqav=esqav/esqavd
         endif
         flgd(i)=alog(esqav)
         avi=si(i)*div
         avr(i)=sr(i)*div
         if (ixnor == 1) then
          divp=1.0/amax1(1.0,float(nsump(i)))
          avip=sip(i)*divp
          avid=sid(i)*div
          avi=avi/avid
          aad=swd(i)*div
          aa=sw(i)*div
          aa=aa/aad
         endif

         if (ixnor == 1) then
           flgw(i)=alog(aa)
         else
           flgw(i)=alog(sw(i)*div)
         endif
         start=start+add
         
         end=amin1(end+add,rmax)
         if (nsum(i).eq.0) then
             flgd(i)=-20
             flgw(i)=-20
         endif
         if (iprin.gt.0) then
             if (if0.eq.0) then
                 if0=1
                 write(lo,40)
             endif
             write(lo,280) i,start,end,nsum(i),avr(i),avi,
     *                     esqav,flgd(i),flgw(i)
         endif
c-- coefficients of normal equations
         ppp=ppp+peso*avr(i)*avr(i)
         q=q+peso*avr(i)
         r=r+peso*avr(i)*flgd(i)
         s=s+peso*flgd(i)
         t=t+peso
  300 continue
   40 format(///,20x,18hleast squares plot//6h range,6x,
     1 18hrho=(sinth/lam)**2,6x,6hnumber,6x,8hmean rho,7x,6hmean i,
     2 7x,23hmean exp(-2*b*rho)*E**2,3x,5hdebye,7x,6hwilson)
  280 format(1h ,i3,f15.4,3h  -,f8.4,i11,f14.4,f14.1,f23.4,f15.4,f13.4)
  301 format('Wilson-plot procedure in error. Check reflections')
      if (iprin.gt.0) write(lo,320) ppp,q,r,q,t,s
  320 format(17h0normal equations/(1h ,e11.3,10h * slope +,e11.3,
     1 14h * intercept =,e11.3))
c-- least squares
      div=ppp*t-q*q
      slope=(r*t-q*s)/div
      flgk=(ppp*s-q*r)/div
      sc=exp(-flgk)
      bt=-0.5*slope
      if (iprin.gt.0) write(lo,340) slope,flgk,bt,sc
  340 format(/,7hslope =,f8.4,4x,11hintercept =,f8.4,4x,
     1 24htemperature factor (b) =,f8.4,4x,7hscale =,f8.4/
     2 51x,37hf(absolute)**2 = scale*f(observed)**2)
c
      if (ixnor == 1.and.bt > 0) then
          write(lo,*)' Btd < Btp'
          write(lo,'(5hBtd =,f10.3)')  xbt-bt
          write(lo,'(5hScd = ,f10.3)') xsc/sc
          bt=0.0
          slope=0.0
          flgk1=r/q
          flgk2=s/t
          flgk=(flgk1+flgk2)/2.0
          sc=exp(-flgk)
      endif

      return
      end
!----------------------------------------
      subroutine fcalN(ixnor,jposition,nrefNorm)

      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMAD
      USE RiflessiMIR

      dimension i1(3),i2(3)

c     print*, ' ******************'
c     print*, ' subroutine fcal, scale:',sc
c     print*, ' ixnor' ,ixnor
c     print*, ' jposition' ,jposition
c     print*, ' ******************'
c
c     scf = 1.0
      rhomaxP=0.0
      rhominP=999.0
      rhomaxD=0.0
      rhominD=999.0
      nrefNorm=0

      do i=1,nrefl
         i1(1) = khl(1,i)
         i1(2) = khl(2,i)
         i1(3) = khl(3,i)

         if (ixnor == 2.and.jposition > 0) then
          fpiu=fpos(jposition,i) 
          sfpiu=sigfpos(jposition,i) 
          fmeno=fneg(jposition,i) 
          sfmeno=sigfneg(jposition,i) 
          if (fpiu > 0.0.and.fmeno > 0.0) then
            fcoef(i)=0.5*(fpiu+fmeno)
            sigfcoef(i)=0.5*(sfpiu+sfmeno)
          elseif (fpiu > 0.0) then
            fcoef(i)=fpiu
            sigfcoef(i)=sfpiu
          elseif (fmeno > 0.0) then
            fcoef(i)=fmeno
            sigfcoef(i)=sfmeno
          else
            fcoef(i)=-1.0
            sigfcoef(i)=0.0
          endif
         elseif (ixnor == 1.and.jposition > 0) then
           fcoef(i)=fovet(i)/sqrt(sc)
           sigfcoef(i)=sigmav(i)/sqrt(sc)
         else
           fcoef(i)=fovet(i)
           sigfcoef(i)=sigmav(i)
         endif

         fo    = fcoef(i)
         if (fo < 0.0) fo=0.0
         if (ixnor == 1 )then
           fd=fod(jposition,i)
           if (fd < 0.0) fd=0.0
         else
           nrefNorm=nrefNorm+1
         endif
         rho   = rhov(i)
         sig   = sigmav(i)

         if (fcoef(i) > 0.0) then
          rhomaxP=max(rhomaxP,rho)
          rhominP=min(rhominP,rho)
         endif
         if (ixnor == 1 .and.fd > 0.0)then
           fd=fod(jposition,i)
           rhomaxD=max(rhomaxD,rho)
           rhominD=min(rhominD,rho)
         endif

c-- compute epsilon and multiplicity by generating equivalent
c-- reflexions
c-- epsylon = number of times same reflexion appears in list
c-- multiplicity = number different reflexions in list
c-- in triclinic space groups eps = 1.0 and mult = 1

         call calc_mult(i1,eps,multt)

         ff0 = fo * fo / pts
         fff = ff0
         mult(i) = multt
         epsv(i) = eps
!
!-- look up scattering factor tables
!
         sinth = 100.0 * sqrt(rho)
         ind = max0( 2, int( sinth + 1.5 ) )
         frac = sinth - float(ind-1)
         bf = 0.5 * ( giw(ind+1) - giw(ind-1) )
         af = bf + giw(ind-1) - giw(ind)
         form = af * frac * frac + bf * frac + giw(ind)
         denor = form * eps
!
!-- 'wilson' structure factor or e'(p)
!
!-- 'wilson' structure factor or e'(p)
!
         work2(i) = fff / denor
!
!-- 'debye' structure factor or e'
!
         work1(i) = ff0 / denor

!    per il derivato

         if (ixnor==1.and.fo > 0.0.and.fd > 0.0) then
          nrefNorm=nrefNorm+1
          ff0 = fd * fd / pts
          fff = ff0
          bf = 0.5 * ( giwd(ind+1) - giwd(ind-1) )
          af = bf + giwd(ind-1) - giwd(ind)
          form = af * frac * frac + bf * frac + giwd(ind)
          denor = form * eps
          e2(i) = fff / denor
          e1(i) = ff0 / denor
         endif


      enddo
c
c     print*,'end fcalNew:',rhomaxP,rhominP,rhomaxD,rhominD
      return
      end
c     ------------------------------------------------------------------
c     reflection rescaling
      subroutine rescaN(ixnor,jposition,jump)
      USE General
      USE Riflessi
      USE RiflessiMAD
      USE RiflessiMIR


c     common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
c     common/cd/btd,scd,difbfac,icut,rhomaxD,rhominD,rhomaxP,rhominP

      common/shell/zme(2,30),enr,ewmin(30),zmed(2,30),enrd,ewmind(30)

c     print*,'rescaNew',jump,ixnor
c     print*,'rescaNew',sc,bt

      tot=0.0
      nww=0
      totd=0.0
      ii=0
      do i=1,nrefl
       multt = mult(i)
       tmul=float(multt)
       if (ixnor==1) then
        if (fod(jposition,i) > 0.0) then
         ii=ii+1
         edd=e2(i)
         esqd=scd(jposition)*edd*exp(2.*btd(jposition)*rhov(i))
         ed(jposition,i)=esqd   ! per i-essimo derivato
         tot=tot+esqd*tmul
         nww=nww+multt
        endif
       else
        if (fcoef(i) > 0.0.or.iphase > 0) then
         ii=ii+1
         edp=work1(i)
         esq=sc*edp*exp(2.*bt*rhov(i))
         ecoef(i)=esq
         tot=tot+esq*tmul
         nww=nww+multt
        endif
       endif
      enddo
c
      tot=tot/float(nww)
      scala=1.0/tot
c     write(6,*) '**resca**  scala = ',scala,ii
c     if (jump.eq.0) then
c         sc =  scala
c     endif
      do 290 i=1,nrefl
       if (ixnor==1) then
         esqd = ed(jposition,i)
         ed(jposition,i)=esqd*scala
       else
         esq = ecoef(i)
         ecoef(i)=esq*scala
       endif
  290 continue
      return
      end
c     ------------------------------------------------------------------
c     calculate final e-values and rescaled f's
c     output reflexions for sir
c     prepare tables of statistics
c
      subroutine ecalN()

      USE General
      USE Symmetry
      USE BigStore
      USE BuildStuff
      USE Riflessi
      USE RiflessiMAD
      USE RiflessiMIR
!
      common/gpt/nanew(18),naold(18),sn,sq
      common/shell/zme(2,30),enr,ewmin(30),zmed(2,30),enrd,ewmind(30)
      common/dritan/igatt,suzp2,suzh2,icos,jt,isca,iscdf,scdf,
     *      iposder,ixnor,kheavy,icnew,bfac(2),factor,ideg,scdp
      common/occup/occH(5,20)
      common/HeavyEstimate/s3s2de(5),sigHPe(5),sigHe(5),numHeavye(5),
     *                     occupe(5)
      common/truedelta/iftrue
      common /anomalous/iposanom,ixAnom

      common /Estat/ nst,nrw,stl(10),rsv(10),rhr(10),nhr(10),nu(25),
     *               ava(10),avc(10),avh(10),cph(25),
     *               vst(10),zt(25),ee(10)
can
      dimension sigv(10,4),isigv(10,2),isigp(10,2)

c--
c
c     data star /'*'/
c     tables of theoretical distributions
c     data ava/0.886,1.0,1.329,2.0,3.323,6.0,0.736,1.0,2.0,2.415/
c     data avc/0.798,1.0,1.596,3.0,6.383,15.0,0.968,2.0,8.0,8.691/
c     data avh/0.718,1.0,1.916,4.5,12.26,37.5,1.145,3.5,26.0,26.903/
c     data cph/0.368,0.463,0.526,0.574,0.612,0.643,0.670,0.694,0.715,
c    1 0.733,0.765,0.791,0.813,0.832,0.848,0.863,0.875,0.886,0.896,
c    2 0.905,0.913,0.920,0.926,0.932,0.938/
c
      
c     write(6,*)'ECAL',jderi,jheavy,kheavy,ixnor
c     write(6,*)'ECAL',npseud,rhomaxP,en
      en=1.2
      er=0.6


c-- set initial values
      do i=1,10
         rhr(i) = 0.0
         nhr(i) = 0
         vst(i) = 0.0
      enddo
      nst=0
      do i=1,25
         zt(i) = 0.0
         nu(i) = 0
      enddo
      nrw = 0
      lim = 1000
      nc  = 0
      ns  = 0
      nl  = 0
      scf = sqrt(sc)
      rr  = 10.0 / sqrt(rhomaxP)
      nr  = 0
      bt2=2.*bt
!
      nperc = 10
      iperc0 = nrefl / nperc
      iperc = iperc0
      jperc = 0
!
      do i=1,nrefl
         if (i == iperc) then
             jperc = jperc + 1
             iperc = iperc + iperc0
c            call scrper(' ',jperc,nperc)
         endif
         lh  = khl(1,i)
         lk  = khl(2,i)
         ll  = khl(3,i)
         fo  = fcoef(i)
         rho = rhov(i)
         sigm = sigfcoef(i)
         e  =ecoef(i)
         edp =work1(i)
         ewp =work2(i)
         d = sc * exp(bt2 * rho)
         multt = mult(i)
         eps = epsv(i)
!
!-- calculate E
!
         if (npseud < 1) then
             esq = e
             e   = sqrt(esq)
             edp  = e
             ewp  = e
         else
             esq = ewp
             e   = sqrt(esq)
             edp  = e
             ewp  = work2(i)
             ewp  = sqrt(ewp)
         endif
!
         ecoef(i) = e
         nl = nl + 1
         if (e <= en) then
             nl = nl - 1
             if (e <= er) then
                 ns = ns + 1
             endif
         endif
         nc = nc + 1
!
!-- work out final statistics
!
         tmul = float(multt)
!
!-- distribution of E with sin(theta)/lambda
!
         n=min0(10,int(1.0+rr*sqrt(rho)))
         nhr(n)=nhr(n)+multt
         rhr(n)=rhr(n)+esq*tmul
         nzr=int(10.0*esq)+1
         if(nzr.gt.10) nzr=10+(nzr-9)/2
         ee(1)=edp
         do j=2,6
            ee(j)=ee(j-1)*edp
         enddo
         ee(7)=esq-1.0
         ee(8)=ee(7)*ee(7)
         ee(9)=ee(8)*ee(7)
         ee(10)=abs(ee(9))
         ee(7)=abs(ee(7))
!
!-- add functions of E to appropriate zones
!
         do j=1,10
            ee(j)=tmul*ee(j)
            vst(j)=vst(j)+  ee(j)
         enddo
         nst=nst+multt
         if(nzr.le.25) zt(nzr)=zt(nzr)+tmul
!
!-- distribution of E for complete data
!
         net=min0(25,int(10.0*edp))
         if (net.ne.0) then
             nu(net)=nu(net)+1
         endif
         nrw=nrw+multt
      enddo   !   fine ciclo sui riflessi
!
c     call scrper(' Sorting reflexions',0,-1)
!
      iflR = 1
      call EcalStatistics(iflR)

c     call CorrectBassoTeta(1)

c             nreflSHL = nrefl
c             do i = 1,nreflSHL
c           write(lo,'(3i4,f10.2)') khl(1:3,i), ecoef(i)
c                work1(i) = evet(i)
c                work2(i) = rhov(i)
c             enddo
c             call Renor2004()
c             evet(1:nreflSHL) = work1(1:nreflSHL)
c             iflR = 2
c             call EcalStatistics(iflR)
c         endif
c     endif
c
      mr=nc
c
      nstr=min0(nstr,nl)
c
      nstr=min0(nstr,maxstr)
   
      nzro=min0(nzro,ns)
      !le due righe soto, prima erano solo per jderi=0
      !mmz=nint(float(nstr)/3.0)
      !nzro=min0(nzro,mmz)

      nzro=min0(nzro,maxpsi)
      ms=mr-nzro

      if (npseud.gt.0) then
          nstr = nc - nzro
          nstr = min0(maxstr,nstr)
          if (nstr.gt.nc) nstr=nc
          nstr=min0(nstr,nl)
      endif

c     write(lo,*)'nstr=',nstr
c     write(lo,*)'nzro=',nzro

      value=0.0
      do i=1,10
         value=value+0.5
         sigv(i,1)=value
         sigv(i,2)=0.0
      enddo
      aref=0.0
      ndata=0      
c     print*,'ksigma=',ksigma
      do i=1,nrefl
         aref=aref+1.0
         fo=fcoef(i)
         sgm=sigfcoef(i)
         if (ksigma.gt.0.and.sgm.gt.0.0) then
             do jsig=1,10
                asig=sigv(jsig,1)
                asigm=asig*sgm
                if (fo.gt.asigm) sigv(jsig,2)=sigv(jsig,2)+1
             enddo
         endif
         if (.not.(sgm.lt.0.0)) then
             ndata=ndata+1
             store(ndata)=fo
         endif
      enddo
c
c-- print F's statistics
c
      if (ksigma.gt.0) then
          do i=1,10
             isigv(i,1)=nint(sigv(i,2))
             isigp(i,1)=nint(100.0*sigv(i,2)/aref)
          enddo
      endif
      iniz=1
      istep=1
      jump=-1
      call sortz(iniz,ndata,istep,jump)
      ist=0
      istep=ndata/10
      do i=1,10
         ist=ist+istep
         isigv(i,2)=ist
         isigp(i,2)=nint(100.0*float(ist)/aref)
         sigv(i,3)=store(ist)
      enddo
      if (ksigma.gt.0) then
          write(lo,730) (isigv(i,1),isigp(i,1),sigv(i,1),
     *                   isigv(i,2),isigp(i,2),sigv(i,3),i=1,10)
      else
          write(lo,740) (isigv(i,2),isigp(i,2),sigv(i,3),i=1,10)
      endif
c
c-- Check on the threshold
      fosog=sigv(7,3)
  680 format('     number',10i8,/,
     *       ' percentage',10(i7,'%'),/,
     *       '      param',10f8.2)
  710 format(//,35x,
     *38hnumber and percentage of  F's > limit ,/)
  720 format('     number',10i8,/,
     *       ' percentage',10(i7,'%'),/,
     *       '      limit',10f8.2)
  730 format(//,10x,'Number and percentage',16x,'Number and percentage',
     1        /,7x,26hof  F's > param * sigma(F),18x,15hof  F's > limit,
     2        //,7x,'number    percentage  param',
     3          10x,'number    percentage  limit',/,
     4        10(   2(i13,i11,1h%,f9.2,3x),/ )   )
  740 format(//,10x,'Number and percentage',
     1        /,13x,15hof  F's > limit,
     2        //,7x,'number    percentage  param',/,
     4        10(     i13,i11,1h%,f9.2,     / )   )
c
c-- riscrive i riflessi su disco (lista 7)
c        call riCreaLista6(1)
c-- scrive i riflessi in output
c        call out2000()
!
c     IF (ALLOCATED(fdee)) deallocate(fdee)

c     if (jderi.gt.0.or.jheavy.gt.0.or.knorm.gt.1) return

      return
      end
c     ------------------------------------------------------------------
c     calculate final e-values and rescaled f's
c     output reflexions for sir
c     prepare tables of statistics
c
      subroutine decalN(jposition,nrefD)

      USE General
      USE Symmetry
      USE BigStore
      USE Riflessi
      USE RiflessiMAD
      USE RiflessiMIR

c     common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
c     common/cd/btd(5),scd(5),difbfac,icut,rhomaxD,rhominD,rhomaxP,
c    *          rhominP

      common/gpt/nanew(18),naold(18),sn,sq
      common/shell/zme(2,30),enr,ewmin(30),zmed(2,30),enrd,ewmind(30)
      common/occup/occH(5,20)
      common/HeavyEstimate/s3s2de(5),sigHPe(5),sigHe(5),numHeavye(5),
     *                     occupe(5)

      common /Estat/ nst,nrw,stl(10),rsv(10),rhr(10),nhr(10),nu(25),
     *               ava(10),avc(10),avh(10),cph(25),
     *               vst(10),zt(25),ee(10)

c     common /HistogramMatching/xcalc(500),ycalc(500),
c    *        xofin(500),pdo(500),pdc(500),
c    *        xcfin(500),xoss(500),xoss_f(500),
c    *        ai(500),bi(500),
c    *        npuntiOss,npuntiCal,npuntiCT,nsipCS,iTypeFunCT

      dimension sigv(10,4),isigv(10,2),isigp(10,2)
      dimension range(100),disde(100)

      
c     write(6,*)'DECAL',jposition,nrefD

*-- calcoliamo la curva teorica per il valore del SIGhp e RPMteorico
c        iTypeFunCT = 0
         sighp=sigHPe(jposition)
         call pdcalc (sighp,RPMt,0)
c        write(6,'(3x,7hsigHP =,f6.3)')sighp
         write(6,'(3x,6hRPMt =,f5.2)')RPMt

c-- set initial values
      do i=1,10
         rhr(i) = 0.0
         nhr(i) = 0
         vst(i) = 0.0
      enddo
      nst=0
      do i=1,25
         zt(i) = 0.0
         nu(i) = 0
      enddo
      nrw = 0
      lim = 1000
      nc  = 0
      ns  = 0
      nl  = 0
      scf = sqrt(sc)
c     scf = 1.0 ! la nativa e' gia' in scala
      scfd = sqrt(scd(jposition))
      rr  = 10.0 / sqrt(rhomaxD)
      nr  = 0
      bt2=2.*bt
      btd2=2.*btd(jposition)
!
      nperc = 10
c     iperc0 = nrefl / nperc
      iperc0 = nrefD / nperc
      iperc = iperc0
      jperc = 0
!
       nDeltapos=0
       nDeltaneg=0
      do 100 i=1,nrefl
         fo  = fcoef(i)
         fd  = fod(jposition,i)

         if (fo < 0.0.or. fd < 0.0) then
           fdelta(jposition,i)= 9999.9
           goto 100
         endif

         if (i == iperc) then
             jperc = jperc + 1
             iperc = iperc + iperc0
c            call scrper(' ',jperc,nperc)
         endif
         lh  = khl(1,i)
         lk  = khl(2,i)
         ll  = khl(3,i)

         rho = rhov(i)
         multt = mult(i)
         eps = epsv(i)

         ! derivato
         sig = sigfcoef(i)*scf
         sigm = sigfd(jposition,i)*scfd
         e  =ed(jposition,i)
c        edp =e1(i)
c        ewp =e2(i)
         edd =e1(i)
         ewd =e2(i)
         d = scd(jposition) * exp(btd2 * rho)
!
!-- calculate E
!
         if (npseud < 1) then
             esq = e
             e   = sqrt(esq)
             edp  = e
             ewp  = e
         else
             esq = ewd
             e   = sqrt(esq)
             edp  = e
             ewp  = sqrt(ewd)
         endif
!
        ed(jposition,i) = e

        fz=cld(jposition)
        do ii=1,4
        fz=fz+ald(ii,jposition)*exp(-bsd(ii,jposition)*rho)
        enddo  
        fz=fz*fz
        socc2=numHeavye(jposition)*occupe(jposition)**2
        socc2=socc2*nsym*pts
        fz=fz*eps*socc2
        xxx=exp(-btd2*rho)
        fz=fz*xxx*pts
        fz=sqrt(fz)

        ep_p=fo*scf/fz

        ed_p=fd*scfd/fz

        epp(jposition,i)=ep_p  
        epd(jposition,i)=ed_p

        fdelta(jposition,i)=ed_p - ep_p   ! delta norm.
         
        if (fdelta(jposition,i) > 0.0) then
         nDeltapos=nDeltapos +1
        else
         nDeltaneg=nDeltaneg +1
        endif
        if (knw > 0) deltaV(jposition,i)=deltaV(jposition,i)/fz
        ! calc. sigdelta
        if (sig > 0.0.and.sigm > 0.0) then
          sigde(jposition,i)=sqrt(sig**2 + sigm**2)/fz
c         write(1,*)sig,sigm,sigde(jposition,i)
        endif
!
!-- work out final statistics
!
         tmul = float(multt)
!
!-- distribution of E with sin(theta)/lambda
!
         n=min0(10,int(1.0+rr*sqrt(rho)))
         nhr(n)=nhr(n)+multt
         rhr(n)=rhr(n)+esq*tmul
         nzr=int(10.0*esq)+1
         if(nzr.gt.10) nzr=10+(nzr-9)/2
         ee(1)=edp
         do j=2,6
            ee(j)=ee(j-1)*edp
         enddo
         ee(7)=esq-1.0
         ee(8)=ee(7)*ee(7)
         ee(9)=ee(8)*ee(7)
         ee(10)=abs(ee(9))
         ee(7)=abs(ee(7))
!
!-- add functions of E to appropriate zones
!
         do j=1,10
            ee(j)=tmul*ee(j)
            vst(j)=vst(j)+  ee(j)
         enddo
         nst=nst+multt
         if(nzr.le.25) zt(nzr)=zt(nzr)+tmul
!
!-- distribution of E for complete data
!
         net=min0(25,int(10.0*edp))
         if (net.ne.0) then
             nu(net)=nu(net)+1
         endif
         nrw=nrw+multt
 100  continue  !   fine ciclo sui riflessi
!
c     call scrper(' Sorting reflexions',0,-1)
!
      iflR = 1
c     call EcalStatistics(iflR)
c
      value=0.0
      do i=1,10
         value=value+0.5
         sigv(i,1)=value
         sigv(i,2)=0.0
      enddo
      aref=0.0
      ndata=0      
c     print*,'ksigma=',ksigma
      do i=1,nrefl
       fo=fod(jposition,i)
       if (fo > 0.0) then
         aref=aref+1.0
         sgm=sigfd(jposition,i)
         if (ksigma.gt.0.and.sgm.gt.0.0) then
             do jsig=1,10
                asig=sigv(jsig,1)
                asigm=asig*sgm
                if (fo.gt.asigm) sigv(jsig,2)=sigv(jsig,2)+1
             enddo
         endif
         if (.not.(sgm.lt.0.0)) then
             ndata=ndata+1
             store(ndata)=fo
         endif
       endif
      enddo
c
c-- print F's statistics
c
      if (ksigma.gt.0) then
          do i=1,10
             isigv(i,1)=nint(sigv(i,2))
             isigp(i,1)=nint(100.0*sigv(i,2)/aref)
          enddo
      endif
      iniz=1
      istep=1
      jump=-1
      call sortz(iniz,ndata,istep,jump)
      ist=0
      istep=ndata/10
      do i=1,10
         ist=ist+istep
         isigv(i,2)=ist
         isigp(i,2)=nint(100.0*float(ist)/aref)
         sigv(i,3)=store(ist)
      enddo
c     if (ksigma.gt.0) then
c         write(lo,730) (isigv(i,1),isigp(i,1),sigv(i,1),
c    *                   isigv(i,2),isigp(i,2),sigv(i,3),i=1,10)
c     else
c         write(lo,740) (isigv(i,2),isigp(i,2),sigv(i,3),i=1,10)
c     endif
c
c-- Check on the threshold
c     fosog=sigv(7,3)
  680 format('     number',10i8,/,
     *       ' percentage',10(i7,'%'),/,
     *       '      param',10f8.2)
  710 format(//,35x,
     *38hnumber and percentage of  F's > limit ,/)
  720 format('     number',10i8,/,
     *       ' percentage',10(i7,'%'),/,
     *       '      limit',10f8.2)
  730 format(//,10x,'Number and percentage',16x,'Number and percentage',
     1        /,7x,26hof  F's > param * sigma(F),18x,15hof  F's > limit,
     2        //,7x,'number    percentage  param',
     3          10x,'number    percentage  limit',/,
     4        10(   2(i13,i11,1h%,f9.2,3x),/ )   )
  740 format(//,10x,'Number and percentage',
     1        /,13x,15hof  F's > limit,
     2        //,7x,'number    percentage  param',/,
     4        10(     i13,i11,1h%,f9.2,     / )   )
c

      ! H.M. per i fdelta 

      rappone=float(nDeltapos)/float(nDeltaneg)
      write(6,'(3x,6hRPMo =,f5.2)')rappone

      work1(:)=fdelta(jposition,:)
      nsip1=150
      nwizm1=25
      call HistogramMatch(work1,work1,nrefl,nsip1,nwizm1,0)
      fdelta(jposition,:)=work1(:)
      ntotD=0
      do i=1,nrefl
        if (abs(fdelta(jposition,i)) < 9000) then
          ntotD=ntotD+1
          work1(ntotD)=fdelta(jposition,i)
        endif
      enddo
      call cumdeg(work1,ntotD,range,disde)

      return
      end
c     ------------------------------------------------------------------
      subroutine plotwN
      
      USE General
c     INTEGER PGOPEN
      character*80,strFile,strHead(3),strTXT
      character*200,strLog

c     common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /anomalous/iposanom,ixAnom
c--
      character itit(5)*6,icar(4),resval(14)*14,reslab(14)*20
      dimension store(251)
      data icar/'w','d','*',' '/
      data itit/'s**2  ','ln i/s','wilson','debye ','calc  '/
      dimension avr_g(30),flgw_c(30),avr_c(30)

c
      ubt=bt/(8.0*pi*pi)

c----print in LOG file
      write(ktml,'(/,5x,34h**********************************)')
      write(ktml,'(5x,20h*        intercept =,f12.5,2h *)')flgk
      write(ktml,'(5x,20h*            slope =,f12.5,2h *)')slope
      write(ktml,'(5x,20h*           b(iso) =,f12.5,2h *)')bt
      write(ktml,'(5x,20h*           u(iso) =,f12.5,2h *)')ubt
      write(ktml,'(5x,20h*            scale =,f12.5,2h *)')sc
      write(ktml,'(5x,34h* scale*f(obs.)**2 =  f(abs.)**2 *)')
      write(ktml,'(5x,34h**********************************,/)')

c---------------


c--load results labels (reslab) array
      write(reslab( 1),'(20h********************)')
      write(reslab( 2),'(20h*      y   = s**2   )')
      write(reslab( 3),'(20h*      x   = ln <i> )')
      write(reslab( 4),'(20h*    ( w ) = wilson )')
      write(reslab( 5),'(20h*    ( * ) = calc   )')
      write(reslab( 6),'(20h********************)')
      write(reslab( 7),'(20h*        intercept =)')
      write(reslab( 8),'(20h*            slope =)')
      write(reslab( 9),'(20h*           b(iso) =)')
      write(reslab(10),'(20h*           u(iso) =)')
      write(reslab(11),'(20h*            scale =)')
      write(reslab(12),'(20h* scale*f(obs.)**2 =)')
      write(reslab(13),'(20h********************)')
c--load results values (resval) array
      write(resval( 1),4)
      write(resval( 2),7)
      write(resval( 3),8)
      write(resval( 4),7)
      write(resval( 5),7)
      write(resval( 6),4)
      write(resval( 7),5) flgk
      write(resval( 8),5) slope
      write(resval( 9),5) bt
      write(resval(10),5) ubt
      write(resval(11),5) sc
      write(resval(12),6)
      write(resval(13),4)
    4 format(14('*'))
    5 format(f12.5,2h *)
    6 format('  f(abs.)**2 *')
    7 format('             *')
    8 format('/ sigfsq     *')
      nres=13
c--load store array
      j=0
      do 20 i=1,nbWils
      store(j+1)=avr(i)
      store(j+2)=flgw(i)
      store(j+3)=0.0
   20 j=j+3
      icar(2)=icar(3)
      itit(4)=itit(5)
      do 40 i=1,nbWils
      store(j+1)=avr(i)
      store(j+2)=slope*avr(i)+flgk
      store(j+3)=0.0
   40 j=j+3
      nstore=j
      n2=nbWils
      n3=2
      nd=3
      call xplotN(store,nstore,n2,n3,nd,icar,resval,reslab,nres)

**    call flush(ktml)
c----Plot Graph
      strFile=fname(1)
      k=index(strFile,'.',.TRUE.)
      strHead(1)=''
      strHead(2)=''
      strHead(3)=''

      if (ixAnom==1) then
       strFile=strFile(1:k-1) // '_anomalous_WilsonPlot.gif/GIF'
c      strHead(3)='Wilson Plot: Anomalous data'
      elseif (knorm==1) then
       strFile=strFile(1:k-1) // '_native_WilsonPlot.gif/GIF'
       strHead(3)='Wilson Plot: Native data'
      else
       strFile=strFile(1:k-1) // '_derivative_WilsonPlot.gif/GIF'
       strHead(3)='Wilson Plot: Derivative data'
      endif



      k1=index(strFile,'/')
      k2=len_trim(strHead(3))
      strLog=' $GRAPH:' //strFile(1:k1-1)//' $TITLE: '//strHead(3)(1:k2)
      k=len_trim(strLog)
c     write(ktml,'(/,a)')strLog(1:k)

      avr_g(1:nbWils)=-avr(1:nbWils)
      ymax=maxval(avr_g(1:nbWils))
      ymin=minval(avr_g(1:nbWils))
      xmax=maxval(flgw(1:nbWils))
      xmin=minval(flgw(1:nbWils))

c     flgw_c(1:nbWils)=slope*avr(1:nbWils)+flgk

      flgw_c(1)=slope*avr(1)+flgk
      flgw_c(2)=slope*avr(nbWils)+flgk

      avr_c(1)=-avr(1)
      avr_c(2)=-avr(nbWils)


      return
      end

c-----------------------------------------------------------------------
      subroutine xplotN(wrk,nwrk,n2,n3,nd,n4,k6,n7,n8)
      USE General
c--plot routine
c
c  wrk    work array
c  nwrk   dimension of work array
c  lo     printer logical unit
c  n2     number of points
c  n3     number of sets of points
c  nd     number of words per each point
c  n4     vector containing the characters
c  n5     vector containing the name(s)
c  k6     vector containing variables values
c  n7     vector containing variables names
c  n8     dimension of k6 and n7
c
c--
      dimension asc(11),wrk(nwrk)
      dimension r(4),t(4),a(4)
      character k6(n8)*14,n7(n8)*20
      character its*14,n4(4),ic,ia,ib,ista,istrip(106)
c
      ic  ='x'
      ib  =' '
      ista='*'
      a(1)=0.00001
c--
      nnr=0
      xoriz=50.
      yvert=25.
      noriz=50
      nvert=25
      iniz=nvert-n8+1
      l1=1
      l1b=l1
      n2b=n2*n3
      fx1=wrk(l1b)
      fx2=wrk(l1b)
      fy1=wrk(l1b+1)
      fy2=wrk(l1b+1)
      do 1000 n=1,n2b
         e=wrk(l1b)
         f=wrk(l1b+1)
         fx1=amin1(fx1,e)
         fx2=amax1(fx2,e)
         fy1=amin1(fy1,f)
         fy2=amax1(fy2,f)
         l1b=l1b+nd
 1000 continue
      dif=fy2-fy1
      sc1=xoriz/dif
      dif=fx2-fx1
      sc2=yvert/dif
      rsc1=1./sc1
      rsc2=1./sc2
      asc(1)=fy1
      npoint=noriz/10+1
      do 1100 i=1,npoint
         asc(i)=asc(1)+10.*(i-1)*rsc1
 1100 continue
      write(lo,1101)	 (asc(i),i=1,npoint)
      write(lo,1102)
      write(lo,1103)
      write(lo,1104)
      write(lo,1104)
 1101 format(/,1h ,11f10.3)
 1102 format(6(9x,1h*))
 1103 format(6x,57(1h*))
 1104 format(6x,1h*,55x,1h*)
c--controllo titolo
      jj=1
      jjj=1
      jj1=1
      j1=4
c--loop analogo normal
      n2b=n2-2
      j=1
      q=fx1
      do 1600 m=1,nvert+1
         do 1502 i=1,14
 1502       its(i:i)=ib
         do 1505 i=1,noriz+6
            istrip(i)=ib
 1505    continue
         istrip(noriz+4)=ista
         if (j.eq.1) go to 1500
         if (j.eq.n2b) go to 1515
         l1b=l1+j*nd
         if (q.lt.wrk(l1b)) go to 1515
 1500    continue
         j=j+1
         l1ba=l1+(j-2)*nd
         l1bx=l1ba
         do 1510 k=1,4
            r(k)=wrk(l1bx)
            l1bx=l1bx+nd
 1510    continue
 1515    continue
         l1bx=l1ba
         do 1570 n=1,n3
            l1bb=l1bx
            do 1530 k=1,4
               t(k)=wrk(l1bb+1)
               l1bb=l1bb+nd
 1530       continue
            call xfitN (r,t,a)
            alpt=(a(4)+q*(a(3)+q*(a(2)+q*a(1)))-fy1)*sc1
            if (alpt.gt.noriz+2) alpt=noriz+2
            il=alpt+1
            if (il.gt.noriz+1) il=noriz+1
            if (il.lt.  1) il=1
            if (istrip(il).eq.ib) go to 1540
            ia=ic
            go to 1560
 1540       continue
            ia=n4(n)
 1560       continue
            istrip(il)=ia
            l1bx=l1bx+n2*nd
 1570    continue
c--controllo titolo
         if (jj1.gt.2) go to 1430
         jj1=jj1+1
         go to 1440
1430     continue
         if (jj.gt.n3) go to 1400
         jj=jj+1
1440     continue
         jjj=jjj+1
1400     continue
         j1=j1+1
         if (j1.eq.5) istrip(noriz+5)=ista
         if (n8.ne.0) then
            if (m.ge.iniz.and.m.le.nvert) then
               jnr=m-iniz+1
               its=k6(jnr)
               do 1248 j2=noriz-13,noriz+6
                  j3=j2-noriz+14
 1248          istrip(j2)=n7(jnr)(j3:j3)
            endif
         endif
         if (j1-5) 1300,1250,1300
 1250    continue
         write(lo,1251) q,(istrip(i),i=1,noriz+6),its
         j1=0
         go to 1350
 1300    continue
         write(lo,1301)(istrip(i),i=1,noriz+6),its
 1350    continue
         q = q + rsc2
 1600 continue
 1251 format(f6.3,1h*,2x,56a1,a14)
 1301 format(6x,1h*,2x,56a1,a14)
      write(lo,1104)
      write(lo,1104)
      write(lo,1103)
      write(lo,1102)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine xfitN(r,t,a)
c--fit curve to y = a1*rho**3 +a2*rho**2 +a3*rho +a4
c
      dimension r(4),t(4),a(4)
c--
      a1old=a(1)
      b2=r(4)*(r(4)+r(1))
      b1=(t(4)-t(1))/(r(4)-r(1))
      c31=(t(2)-t(1))/(r(2)-r(1))-b1
      c32=(t(3)-t(1))/(r(3)-r(1))-b1
      c11= r(2)     *(r(2)+r(1))-b2
      c12= r(3)     *(r(3)+r(1))-b2
      c21= r(2)-r(4)
      c22= r(3)-r(4)
      denom=c22*c11-c12*c21
      if (abs(denom).lt.0.00000001) then
                                   a(1)=a1old
                                 else
                                   a(1)=(c31*c22-c32*c21)/denom
                                 endif
c     a(1)=(c31*c22-c32*c21)/(c22*c11-c12*c21)
      a(2)=(c31-c11*a(1))/c21
      a(3)=b1-(r(4)*r(4)+r(1)*r(1)+r(4)*r(1))*a(1)
     1  -(r(4)+r(1))*a(2)
      a(4)=t(1)-r(1)*(a(3)+r(1)*(a(2)+r(1)*a(1)))
      return
      end


!-----------------------------------------------------------------------
!
      subroutine SigHEstimate(jcondition,jposition)
c     jcondition=1 --> num. of heavy atoms estimate
c     jcondition=2 --> |Fh|,sigFh estimates
      
      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMIR

      common/HeavyEstimate/s3s2de(5),sigHPe(5),sigHe(5),numHeavye(5),
     *                     occupe(5)

      dimension i1(3),xx(200),yy(200),SumDelta2(201),nrDelta2(201)
      dimension sig(200),ia(1),a(1),alfa(1,1),covar(1,1)
      dimension sumFpRes(20),nrFpRes(20)

      dimension errorSigma(100), NumError(100),RES(100),sigHmed(100),
     *          sigDmed(100),sigPmed(100)
      dimension deMed(100),ehMed(100),ehEst1(100),ehEst2(100),
     *          ehEst3(100)
      dimension sumFheavy(100),dif0Med(100),dif1Med(100),dif2Med(100),
     *          dif3Med(100)              

      real, allocatable ::sigHeavy(:),sigEhEst(:),FheavyCalc(:)
      real, allocatable ::Delta2(:),sigEhEstn(:)
      real, allocatable ::FheavyEst0(:),FheavyEst1(:),FheavyEst2(:),
     *                    FheavyEst3(:)
      character tirang1*80
      external PdeltaFit

      allocate(sigHeavy(nrefl),sigEhEst(nrefl),FheavyCalc(nrefl),
     *        Delta2(nrefl),FheavyEst0(nrefl),FheavyEst1(nrefl),
     *        FheavyEst2(nrefl),FheavyEst3(nrefl),sigEhEstn(nrefl),
     *        stat=ierr)


      ider=jposition
      MaxShelReso=12
      sumFpRes(:)=0.0
      nrFpRes(:)=0
      rhomax=maxval(rhov(1:nrefl))
      rhomin=minval(rhov(1:nrefl))
c     print*,0.5/sqrt(rhomax),0.5/sqrt(rhomin)

      select case (jcondition)
      case (1)
      write(lo,*) '******************************************'
      write(lo,*) '*      <sigH>  Estimate                   *'
      write(lo,*) '******************************************'

      do 100 i=1, nrefl
       lh=khl(1,i)
       lk=khl(2,i)
       ll=khl(3,i)
       rho2=rhov(i)
       fo=fovet(i)
       NumReso =
     +   INT((rho2-rhomin)*MaxShelReso/ (rhomax-rhomin)) + 1
       IF (NumReso.GT.MaxShelReso) NumReso = MaxShelReso
       IF (NumReso.LT.1) NumReso = 1
       sumFpRes(NumReso) = sumFpRes(NumReso) + fo**2
       nrFpRes(NumReso) = nrFpRes(NumReSo) + 1

 100  continue

      do j=1,MaxShelReso
        if (nrFpRes(j).gt.0.0) then
         sumFpRes(j)= sumFpRes(j)/float(nrFpRes(j))
        else
         sumFpRes(j)=0.0
        endif
      enddo

      MaxBin=150
      sumfo=sum(fovet(:),mask=fod(ider,:)>0.0) 
      sumfd=sum(fod(ider,:),mask=fod(ider,:) >0.0) 

c     print*,count(fovet(:) >0.0),sumfo
c     print*,count(fod(ider,:) >0.0),sumfd

      scaleFoFd=sumfo/sumfd
c     print*,'Scale Fp/Fd',scaleFoFd
c     scaleFoFd=1.0
c     scaleFoFd=1.03
      nrDelta2Tot=0
      Delta2Max=0.0
      Delta2Min=99999.0
      SumDelta2(:)=0.0
      nrDelta2(:)=0
      Delta2(:)=-9999.

c     print*,'Bt_heavy=',bt
      bt=15.0
      sogDe2=1.5

      rhomaxD=0.0
      rhominD=999.0
      nrefDeri=0
      do 200 i=1,nrefl
         if (fod(ider,i) < 0.0) goto 200
         nrefDeri=nrefDeri+1
         lh=khl(1,i)
         lk=khl(2,i)
         ll=khl(3,i)
         i1(1)=lh
         i1(2)=lk
         i1(3)=ll
         rho2=rhov(i)
         if (rho2 > rhomaxD) rhomaxD=rho2
         if (rho2 < rhominD) rhominD=rho2

         NumReso =
     +    INT((rho2-rhomin)*MaxShelReso/ (rhomax-rhomin)) + 1
         IF (NumReso.GT.MaxShelReso) NumReso = MaxShelReso
         IF (NumReso.LT.1) NumReso = 1
         sigNa1=sumFpRes(NumReso)
         fnative=fovet(i)
         fderivative=fod(ider,i)*scaleFoFd
c        write(1,'(3i4,2f10.2)')i1(1:3),fcoef(i),fcvet(i)
         De2=abs(fderivative**2-fnative**2)/sigNa1
         if (de2.le.sogDe2) then
          Delta2(i)=de2
          Delta2Max=max(Delta2Max,de2)
          Delta2Min=min(Delta2Min,de2)
         else
            Delta2(i)=-9999.0
         endif
 200  continue

c     print*,nrefl,nrefDeri
      de2Max=0.0
      de2Min=9999.
      do 300 i=1,nrefl
        de2=Delta2(i)
        if (de2.lt.0.) goto 300
        de2Max=Delta2Max
        de2Min=Delta2Min
        NumBin =
     +     INT((de2-de2Min)*MaxBin/ (de2Max-de2Min)) + 1
           IF (NumBin.GT.MaxBin) NumBin = MaxBin
           IF (NumBin.LT.1) NumBin = 1
        SumDelta2(NumBin)=SumDelta2(NumBin)+de2
        nrDelta2(NumBin)=nrDelta2(NumBin)+1
        nrDelta2Tot=nrDelta2Tot+1
 300  continue

        varbin=(Delta2Max - Delta2Min)/float(MaxBin)
        yy(1)=nrDelta2(1)/(varbin*nrDelta2Tot)
        xx(1)=0.0
        sig(1)=0.001*yy(1)
c         write(6,*)xx(1),nrDelta2(1),yy(1)
        do 500 i=2,MaxBin
          yy(i)=nrDelta2(i)/(varbin*nrDelta2Tot)
          xx(i)=xx(i-1) + varbin
          sig(i)=0.001*yy(i)
c         write(6,*)xx(i),nrDelta2(i),yy(i)
          if (nrDelta2(i).eq.0) then
            MaxBinFinal=i-1
            goto 550
          endif
 500    continue

        MaxBinFinal= MaxBin
 550    continue

         MA=1
         mfit=MA
         ia(1)=1
         a(1)=yy(1)
         NPT=MaxBinFinal

        write(lo,'(1x,t5,a,f8.4,i6)') 'A initial=',a(1),MaxBinFinal
        do iter=1,2
        alamda=-1.0
        call mrqmin(xx,yy,sig,NPT,a,ia,ma,covar,alfa,
     *       MA,chisq,PdeltaFit,alamda)
        k=1
        itst=0
 1      write(lo,'(/1x,t5,a,i2,t18,a,f12.1,t43,a,e9.2)') 
     *   'Iteration #',k,' Chi-squared: ',chisq,' ALAMDA: ',alamda
        write(lo,'(1x,t5,a,f8.4)') 'A estimate=',a(1)
        goto 1000
        k=k+1
        ochisq=chisq
        call mrqmin(xx,yy,sig,NPT,a,ia,ma,covar,alfa,
     *       MA,chisq,PdeltaFit,alamda)
        if (chisq.gt.ochisq) then
          itst=0
        else if (abs(ochisq-chisq).lt.0.1) then
          itst=itst+1
        endif
        if (itst.lt.4) then
          goto 1
        endif

        alamda=0.0
        call mrqmin(xx,yy,sig,NPT,a,ia,ma,covar,alfa,
     *       MA,chisq,PdeltaFit,alamda)
        write(lo,*) 'Uncertainties:'
        write(lo,'(1x,f8.4/)')sqrt(covar(1,1))
        enddo

 1000   continue

        s2=0.0
        s3=0.0

        resmaxD=0.5/sqrt(rhomaxD)
        resminD=0.5/sqrt(rhominD)
c       print*,resmaxD,resminD
        pesosigHP=(resmaxD-resminD)/(resmaxD+resminD)
        pesosigHP=pesosigHP**2
        pesosigHP=min(1.0,pesosigHP)

        sigHP=pesosigHP/(a(1)**2-1.0)
        sigmaP=0.0
        do i=1,nk
c        if (i/=ider) then
          sigmaP=sigmaP+float(nw(i))*no(i)*no(i)
c        endif
        enddo
        sigH=sigHP*sigmaP
        sumZh2=nod(ider)**2
        numHeavy=nint(sigH/(0.5*sumZh2*nsym*pts))
        numHeavy=max(1,numHeavy)
        anat=numHeavy
        aa=numHeavy*nsym*pts
        nwd(ider) = int(aa)
        occHeavy=sqrt(sigH/(aa*sumZh2))
        occHeavy=min(1.0,occHeavy)

        numHeavye(ider)=numHeavy
        occupe(ider)=occHeavy

        s2=sigH
        s3=s2*nod(ider)
        s3s2d(ider)=s3/sqrt(s2**3)
        aa=s3s2d(ider)*s3s2d(ider)*pts
        s3s2d(ider)=aa*sqrt(1.0/aa)

        s3s2de(ider)=s3s2d(ider)
        sigHPe(ider)=sigHP
        sigHe(ider)=sigH

        write(lo,371) nalfd(ider),sigHP,sigH,s3s2d(ider),numHeavy,
     *               occHeavy

  371  format(/,18x,'Derivative:',2x,a2,/,
     + 18x,'*********************',/,
     + 18x,'sigH/sigP =',f7.3,/,
     + 18x,'sigH =',f10.3,/,
     + 18x,'s3s2 =',f7.3,/,
     + 18x,'n. atom in u.a  =',i5,/,
     + 18x,'<occ>  =',f5.2)

       iy=-7
*gl*   call pre06
       call UpdateReflInfo
       ier=0
       call yfrm33(ier)
       if (ier.ge.0) call yfl33
c      stop
      write(lo,*) '******************************************'

      case (2)
c     if (iprint==1) then
c      write(lo,*) '******************************************'
c      write(lo,*) '*                 |Fh| Estimate          *'
c      write(lo,*) '******************************************'
c     endif
      ! la stima di  Fh & sig(Fh))
    
      ! calc Fh and PHh true
      if (knw==1) call SFCalc_mir(ider)

      MaxShelReso = 8
      nrefc=count(fod(ider,1:nrefl) > 0.0)
      MaxShelReso=30
      Nstat=floor(nrefc/float(MaxShelReso))
      MaxShelReso=8.0*alog10(0.05*float(max0(nrefc,100))+0.5)


      sigHmed(:)=0.0
      sigPmed(:)=0.0
      sigDmed(:)=0.0
      errorSigma(:) =  0.0
      ehMed(:) =  0.0
      deMed(:) =  0.0
      ehEst2(:) =  0.0
      ehEst3(:) =  0.0
      dif0Med(:) =  0.0
      dif2Med(:) =  0.0
      dif3Med(:) =  0.0
      sumFheavy(:) =  0.0
      NumError(:) =  0
      FheavyEst0(:)=0.0
      FheavyEst1(:)=0.0
      FheavyEst2(:)=0.0
      FheavyEst3(:)=0.0
      sigEhEst(:)=0.0
      sigEhEstn(:)=0.0
      wt(:)=0.0

      numHeavy=numHeavye(ider)
      occHeavy=occupe(ider)
c     print*,ider,numHeavy,occHeavy,btd(ider)

      socc2=nsym*numHeavy*occHeavy**2
      sumFheavyEst0=0.0
      sumFheavyEst1=0.0
      sumFheavyC=0.0


      do 1100 i=1,nrefl
         wt(i)=0.0
         if (fod(ider,i) < 0.0) goto 1100
         i1(1)=khl(1,i)
         i1(2)=khl(2,i)
         i1(3)=khl(3,i)
         eps=epsv(i)
         rho2=rhov(i)

         sigNa1=0.0
         do ink=1,nk
            fz=cl(ink)
            do ii=1,4
              fz=fz+al(ii,ink)*exp(-bs(ii,ink)*rho2)
            enddo
            fz2=nw(ink)*nsym*pts*fz**2
            sigNa1=sigNa1+fz2*exp(-2.0*bt*rho2)
         enddo
         sigNa1=eps*sigNa1*pts

         sigH1=0.0
         sigD1=0.0
         fz=cld(ider)
         do ii=1,4
          fz=fz+ald(ii,ider)*exp(-bsd(ii,ider)*rho2)
         enddo
         fz2=socc2*fz**2
         sigH1=fz2*exp(-2.0*btd(ider)*rho2)
         sigH1=eps*pts*sigH1
         sigD1=sigNa1+sigH1
         sigHeavy(i)=sigH1
         NumReso =
     +    INT((rho2-rhominD)*MaxShelReso/ (rhomaxD-rhominD)) + 1
         IF (NumReso.GT.MaxShelReso) NumReso = MaxShelReso
         IF (NumReso.LT.1) NumReso = 1
         if (ksigma > 0) then
           sigf1=sigmav(i)  ! sigFp
           sigf2=sigfd(ider,i)  ! sigFd
         else
           sigf1=0.0
           sigf2=0.0
         endif
         sigdelta=sigf1**2 + sigf2**2
         sigdelta=sigdelta/sigH1
         errorSigma(NumReso)=errorSigma(NumReso)+sigdelta
         sigHmed(NumReso)=sigHmed(NumReso)+sigH1
         sigDmed(NumReso)=sigDmed(NumReso)+sigD1
         sigPmed(NumReso)=sigPmed(NumReso)+sigNa1
         de=(fod(ider,i)-fovet(i))**2
         de=de/sigH1
         deMed(NumReso)=deMed(NumReso)+de
c        FheavyEst0(i)=sqrt(de)*sqrt(sigH1)
         FheavyEst0(i)=sqrt(de)
         sumFheavyEst0=sumFheavyEst0+FheavyEst0(i)

         if (knw==1 ) then
           ehMed(NumReso)=ehMed(NumReso)+eH(ider,i)**2 ! calc. per la strutt. vera
c          sumFheavyC=sumFheavyC+fcH(ider,i)
c          sumFheavy(NumReso)=sumFheavy(NumReso)+fcH(ider,i)
c          FheavyCalc(i)=fcH(ider,i)
           sumFheavyC=sumFheavyC+eH(ider,i)
           sumFheavy(NumReso)=sumFheavy(NumReso)+eH(ider,i)
           FheavyCalc(i)=eH(ider,i)
         endif

         sigEhEst(i)=(1.0-pi/4.0)*(sigdelta/(1.+sigdelta))
         if (sigEhEst(i) > 0.0) sigEhEst(i)=sqrt(sigEhEst(i))

         NumError(NumReso) =  NumError(NumReso)+1
 1100 continue


      sumNum=0
      sumerrorSigma=0.0
      sumSigHMed=0.0
      sumeHMed=0.0
      sumdeMed=0.0
      sumEhEst1=0.0
      do 1020 j=1,MaxShelReso
         sumNum=sumNum+NumError(j)
         sumerrorSigma=sumerrorSigma+errorSigma(j)
         sumSigHMed=sumSigHMed+sigHmed(j)
         if (knw==1)sumeHMed=sumeHMed+ehMed(j)
         sumdeMed=sumdeMed+deMed(j)
         if (NumError(j).gt.0.0) then
          errorSigma(j)=errorSigma(j)/NumError(j)
          sigHmed(j)=sigHmed(j)/NumError(j)
          sigDmed(j)=sigDmed(j)/NumError(j)
          sigPmed(j)=sigPmed(j)/NumError(j)
          deMed(j)=deMed(j)/NumError(j)
          if (knw==1) ehMed(j)=ehMed(j)/NumError(j)
         endif
 1020   continue

      sumFheavyEst1=0.0
      sumFheavyEst2=0.0
      sumFheavyEst3=0.0
      work2(:)=0.0
      work1(:)=0.0
      do 1030 i=1,nrefl
         if (fod(ider,i) < 0.0) goto 1030
         i1(1)=khl(1,i)
         i1(2)=khl(2,i)
         i1(3)=khl(3,i)
         rho2=rhov(i)
         NumReso =
     +    INT((rho2-rhominD)*MaxShelReso/ (rhomaxD-rhominD)) + 1
         IF (NumReso.GT.MaxShelReso) NumReso = MaxShelReso
         IF (NumReso.LT.1) NumReso = 1
         de=(fod(ider,i)-fovet(i))**2
         de=de/sigHeavy(i)
         errSig=100.0*errorSigma(NumReso)
         aa=(de+errSig)/(1.+errSig)
         ehEst2(NumReso)=ehEst2(NumReso)+aa
c        FheavyEst2(i)=sqrt(aa)
c        fhe=FheavyEst2(i)*sqrt(sigHeavy(i))
c        sigfhe=sigEhEst(i)*sqrt(sigHeavy(i))

c        FheavyEst2(i)=sqrt(aa)*sqrt(sigHeavy(i))
         FheavyEst2(i)=sqrt(aa)
         sumFheavyEst2=sumFheavyEst2+FheavyEst2(i)

         ! nuova formula ...
         sigHD=sigHmed(NumReso)/sigDmed(NumReso)
         SigmaaVal(i)=max(0.9, SigmaaVal(i))
         aa=1. - SigmaaVal(i)**2

         bb=1. - sigHD - SigmaaVal(i)**2
         rL11=aa/bb
         aa=SigmaaVal(i) * sqrt(sigHD)
         rL12=aa/bb
         aa=-sqrt(sigHD)
         rl13=aa/bb
         xx1=rL12*fod(ider,i)/sigHeavy(i) + rL13*fovet(i)/sigHeavy(i)
         aa=1.0/rL11 + xx1*(1.0/rL11)**2

         aa=(sigDmed(NumReso) -(Dluz(i)**2)*sigPmed(NumReso))

         aa1=sigHmed(NumReso)/aa
         work2(numReso)=work2(numReso) + aa1
c        work1(numReso)=work1(numReso) + Dluz(i)
         rrp=fovet(i)
         rrd=fod(ider,i)
         cc=(rrd -Dluz(i) * rrp)**2
c        rrh=(1.0 + aa1) + (cc / aa -1.0)
         rrh=1.0 + aa1*(cc/aa -1.0)

         if (rrh < 0.0) then
           rrh=0.0
         else
           wt(i)=1.0
           rrh=sqrt(rrh)
         endif
         ehEst3(NumReso)=ehEst3(NumReso)+rrh
         FheavyEst3(i)=sqrt(rrh)
         sumFheavyEst3=sumFheavyEst3+FheavyEst3(i)
         sigEhEstn(i)=(1.0-pi/4.0)*(1/rL11)
         if (sigEhEstn(i) > 0.0) sigEhEstn(i)=sqrt(sigEhEstn(i))
       
         ! valori finali per Fh e sigFh
c        fovet(i)=fhe
c        sigmav(i)=sigfhe

c        ! test output
c        de=abs(fcvet(i)-fcoef(i))
c        sigdelta=sqrt(work1(i)**2 + work2(i)**2)
c        write(1,'(3i4,10f10.2)')i1(1),i1(2),i1(3),
c    *   fcvet(i),fcoef(i),de,sigdelta,fhe,sigfhe,float(ipub(i))
c        !----

 1030  continue

      if (knw==1) then
       sc0=sumFheavyEst0/sumFheavyC
       sc2=sumFheavyEst2/sumFheavyC
       sc3=sumFheavyEst3/sumFheavyC
       write(lo,*)'Scale0=',sc0
       write(lo,*)'Scale2=',sc2
       write(lo,*)'Scale3=',sc2
       sumdif0=0.0
       sumdif2=0.0
       sumdif3=0.0
       sumFheavyEst0=0.0
       sumFheavyEst2=0.0
       sumFheavyEst3=0.0

       do 1035 i=1,nrefl
         rho2=rhov(i)
         NumReso =
     +    INT((rho2-rhominD)*MaxShelReso/ (rhomaxD-rhominD)) + 1
         IF (NumReso.GT.MaxShelReso) NumReso = MaxShelReso
         IF (NumReso.LT.1) NumReso = 1
         sumFheavyEst0=sumFheavyEst0+FheavyEst0(i)/sc0
         sumFheavyEst2=sumFheavyEst2+FheavyEst2(i)/sc2
         sumFheavyEst3=sumFheavyEst3+FheavyEst3(i)/sc3
         dif0=abs(FheavyCalc(i)-FheavyEst0(i)/sc0)
         sumdif0=sumdif0+dif0
         dif2=abs(FheavyCalc(i)-FheavyEst2(i)/sc2)
         sumdif2=sumdif2+dif2
         dif3=abs(FheavyCalc(i)-FheavyEst3(i)/sc3)
         sumdif3=sumdif3+dif3
         dif0Med(NumReso)=dif0Med(NumReso)+dif0
         dif2Med(NumReso)=dif2Med(NumReso)+dif2
         dif3Med(NumReso)=dif3Med(NumReso)+dif3
         aa=FheavyEst3(i)/sigEhEstn(i)
         if (FheavyEst3(i)/sc3 > 0.7.and.FheavyCalc(i) < 0.3) then
           write(1,*)FheavyCalc(i),FheavyEst3(i)/sc3,
     *      FheavyEst3(i),aa,FheavyEst0(i)
         endif
 1035  continue

       write(lo,*)'R0=',sumdif0/sumFheavyC
       write(lo,*)'R2=',sumdif2/sumFheavyC
       write(lo,*)'R3=',sumdif3/sumFheavyC

      sumEhEst2=0.0
      sumEhEst3=0.0
      do 1040 j=1,MaxShelReso
        sumEhEst2=sumEhEst2+ehEst2(j)
        sumEhEst3=sumEhEst3+ehEst3(j)
        if (NumError(j).gt.0.0) then
         ehEst2(j)=ehEst2(j)/NumError(j)
         ehEst3(j)=ehEst3(j)/NumError(j)
c        work2(j)=work2(j)/NumError(j)
c        work1(j)=work1(j)/NumError(j)
c        print*,j,NumError(j),work2(j),work1(j)
         if (knw==1) then
          dif0Med(j)=dif0Med(j)/sumFheavy(j)
          dif2Med(j)=dif2Med(j)/sumFheavy(j)
          dif3Med(j)=dif3Med(j)/sumFheavy(j)
         endif
        endif
 1040  continue

      U = (rhomaxD-rhominD)/REAL(MaxShelReso)
      do i=1,MaxShelReso-1
       RES(i) = 0.5/ sqrt(REAL(i)*U+rhominD)
      enddo
      RES(MaxShelReso) = 0.5/ sqrt(rhomaxD)

c     if (knw==1) then
c     WRITE (lo,2000)nalfd(ider),
c    +    (RES(j),J=1,MaxShelReso),RES(MaxShelReso),
c    +    (NumError(j),j=1,MaxShelReso),int(sumNum),
c    +    (100.*errorSigma(j),j=1,MaxShelReso),
c    *    100.*sumerrorSigma/sumNum,
c    +    (deMed(j),j=1,MaxShelReso),sumdeMed/sumNum,
c    +    (ehMed(j),j=1,MaxShelReso),sumeHMed/sumNum,
c    +    (ehEst2(j),j=1,MaxShelReso),sumEhEst2/sumNum,
c    +    (ehEst3(j),j=1,MaxShelReso),sumEhEst3/sumNum,
c    +    (dif2Med(j),j=1,MaxShelReso),sumdif2/sumFheavyC,
c    +    (dif3Med(j),j=1,MaxShelReso),sumdif3/sumFheavyC,
c    +    (dif0Med(j),j=1,MaxShelReso),sumdif0/sumFheavyC
c2000     format (/2X,'Derivative',1x,a2,71x,'TOTAL',
c    +            /2x,'______________',69x,'______',
c    +            /2X,'Res (A)      ',2X,8f8.2,2h |,f8.2,
c    +            /2x,'Nr. of refl. ',2x,8i8,2h |,i8,
c    +            /2x,'<|sig|2>     ',2x,8f8.2,2h |,f8.2,
c    +            /2x,'<|de|2>      ',2x,8f8.2,2h |,f8.2,
c    +            /2x,'<|eH|2>      ',2x,8f8.2,2h |,f8.2,
c    +            /2x,'<|eHest|2>   ',2x,8f8.2,2h |,f8.2,
c    +            /2x,'<|eHestN|2>  ',2x,8f8.2,2h |,f8.2,
c    +            /2x,'<R>          ',2x,8f8.2,2h |,f8.2,
c    +            /2x,'<Rn>         ',2x,8f8.2,2h |,f8.2,
c    +            /2x,'<Rde>        ',2x,8f8.2,2h |,f8.2/)
c     else
c     WRITE (lo,3000)nalfd(ider),
c    +    (RES(j),J=1,MaxShelReso),RES(MaxShelReso),
c    +    (NumError(j),j=1,MaxShelReso),int(sumNum),
c    +    (errorSigma(j),j=1,MaxShelReso),sumerrorSigma/sumNum,
c    +    (deMed(j),j=1,MaxShelReso),sumdeMed/sumNum,
c    +    (ehEst2(j),j=1,MaxShelReso),sumEhEst2/sumNum 
c3000     format (/2X,'Derivative',1x,a2,71x,'TOTAL',
c    +            /2x,'______________',69x,'______',
c    +            /2X,'Res (A)      ',2X,8f8.2,2h |,f8.2,
c    +            /2x,'Nr. of refl. ',2x,8i8,2h |,i8,
c    +            /2x,'<|sig|2>     ',2x,8f8.2,2h |,f8.2,
c    +            /2x,'<|de|2>      ',2x,8f8.2,2h |,f8.2,
c    +            /2x,'<|eHest|2>   ',2x,8f8.2,2h |,f8.2/)
c     endif


      FheavyEst2(:)=FheavyEst2(:)/sc2
      tirang1='|Eh|old'
      call GetStatRfac(tirang1,FheavyEst2,FheavyCalc,FheavyEst2,
     *           nrefl,1,wt,30,0.0)

      do i=1, nrefl
       if (sigEhEst(i) > 0.0) then
         work1(i)=FheavyEst2(i)/sigEhEst(i)
       else
         work1(i)=0.0
       endif
      enddo
      tirang1='(|Eh|/sigEh)old'
      call GetStatRfac(tirang1,work1,FheavyCalc,FheavyEst2,
     *           nrefl,1,wt,30,0.0)

      tirang1='|Eh|new'
      FheavyEst3(:)=FheavyEst3(:)/sc3
      call GetStatRfac(tirang1,FheavyEst3,FheavyCalc,FheavyEst3,
     *           nrefl,1,wt,30,0.0)
      do i=1, nrefl
       if (sigEhEstn(i) > 0.0) then
         work1(i)=FheavyEst3(i)/sigEhEstn(i)
       else
         work1(i)=0.0
       endif
      enddo

      tirang1='(|Eh|/sigEh)new'
      call GetStatRfac(tirang1,work1,FheavyCalc,FheavyEst3,
     *           nrefl,1,wt,30,0.0)

      endif
      end select
      deallocate(sigHeavy,sigEhEst,FheavyCalc,Delta2,sigEhEstn,
     *           FheavyEst0,FheavyEst1,FheavyEst2,FheavyEst3,
     *           stat=ierr)

c     write(lo,*) '******************************************'
c     write(lo,*) '*           END                           *'
c     write(lo,*) '******************************************'

      return
      end
!-------------------------------------------------------------
      subroutine OrdeList6(nderi,sogDelta,sogRES,ier)

      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMIR

*gl*  call xfl06
      call LoadReflInfo

c     dfmin=0.7 ... ! valore finale di delta

      nreft=800+nint(480./float(nsym))
      ideb0=nreft/3
      ideb0=min0(nzro,ideb0)
      ideb0=min0(250,ideb0)

      ifund=0
      perc=1.0
      perct=0.75


      write(lo,2000)nreft,sogDelta
 2000 format('  Nr. of strong reflection to be found ......',i6,/,
     *       '  with |Delta|min ...........................',f6.2,/)
c--

      dmax=9999.0
      do i=1,nrefl
       if (abs(fdelta(nderi,i)) < 9000.0) dmax=min(dmax,dreso(i))
      enddo

      ! il vettore temp. per il sort (work1)
      sogRESd=0.5/sqrt(sogRES)
     
110   nrefSOG=count(dreso(1:nrefl) > sogRESd)
      
      nsup1=nint(perct*nrefSOG)
      nsup=nint(perc*nsup1)

      write(lo,2500)sogRESd,nrefSOG
 2500 format('  Nr. of reflections up to',f6.2,' (A).........',i6,/)

       if (nsup.lt.nreft) then
          sogRESd=sogRESd-0.25
          sogRESd=amax1(sogRESd,dmax)
          goto 110
        endif

      do i=1,nrefl
       iorde(i)=i
       work1(i)=abs(fdelta(nderi,i))
       if (work1(i) > 9000) work1(i)=-work1(i)
      enddo   

      isort = -1
      iuno = 1
      call sortall3(isort,work1,iuno,nrefl,iorde)

 380  continue

      dfmin=9999.0
      emin=9999.0
      iforti=0
      sumse=0.0
      do i=1,nsup
        ii=iorde(i)
        de = fdelta(nderi,ii)
        dfmin=min(dfmin,abs(de))
        emin=min(emin,evet(ii))
        iforti=iforti+1
        if (de.gt.0) ipos=ipos+1
        if (de.lt.0) ineg=ineg+1
        if (knw.eq.1) then
          deV=deltaV(nderi,ii)
          se1=sign(1.0,de)
          se2=sign(1.0,deV)
          if (se1.ne.se2) sumse=sumse+1
        endif
        if (nreft.gt.0) then
          if (iforti.eq.nreft) exit
        else
          if (abs(de) < sogDelta) then
           nreft=iforti
           ifund=2
           exit
          endif
        endif
      enddo
      rap=0.0
      if (ineg.gt.0) rap=float(ipos)/float(ineg)
      sumse=100.0*sumse/float(iforti)

      write(lo,3000)iforti,dfmin,sumse,rap,emin,perc*perct*100.0
 3000 format(14x,'Nr. of strong refl. ...........',i6,/,
     *         14x,'  |Delta|min...................',f6.2,/,
     *         14x,'  %inversion Delta sign........',f6.2,/,
     *         14x,'  Pos/Neg .....................',f6.2,/,
     *         14x,'  Emin    .....................',f6.2,/,
     *         14x,'  % of reflections ............',f6.2,/)

      if (ifund.eq.2) goto 480

      if (dfmin.lt.sogDelta.and.ifund.eq.0) then
           sogRESd=sogRESd-0.25
           sogRESd=amax1(sogRESd,dmax)
           if (sogRESd.eq.dmax) ifund=1
           goto 110
       elseif (dfmin.lt.sogDelta.and.ifund.eq.1) then
           nreft=0
           goto 380
       endif


 480  continue
      ! i deboli


      return
      end

!-----------------------------------------------------------------------
      subroutine SFCalc_mir(kheavy)
      USE General
      USE Symmetry
      USE Riflessi
      USE RiflessiMIR
      USE Atomi
      USE Molcom
! ----
!      structure factor calculation
! ----

      integer i1(3)
      character nomeFile*256
      dimension ffnk(18), cb(3)

      character cisp*2
      character *80 line, dire
      dimension vet(40),ivet(40)
      dimension xo(11),xn(11),keyx(10)
*     dimension cost(360)
*     equivalence (sint(91),cost(1))
!--
      k = index(fname(1), '.bin')
      k1=index(fname(1)(1:k),'_task')
      if (k1==0) k1 = k
      nomeFile = fname(1)(1:k1-1)//'.coor'
!
      write(lo,*)'calc. (FH,phiH) from true fragment: ',nomeFile

*gl*  call yfl02     !!gl
*gl*  call musym()   !!gl


      itype1=2
      iform=1
      jop=jopen(44,nomeFile,itype1,iform,ierr)
      if (jop.lt.0) then
         return
      end if
!--
      iAction = -2
      nats = 10 
      call AllocaAtomi(iAction)
      nats = 0
!--
      j = 0
      do
         read(44,'(a)',end = 20) line
         call shift(line, nchar)
         if (line(1:1) /= '>' .and. line(1:1) /= '!' ) then
             call cutst(line,lenp,dire,lend)
             call lcase(dire)
             read(dire(1:2),'(a2)') cisp
             call lcase(cisp)
             read(cisp,'(a2)') isp
             if (isp.eq.nalfd(kheavy)) then
                j = j + 1
                nz(j) = kheavy
             else 
                 goto 10
             end if
             iopt=0
             call getnum(line,vet,ivet,iv,iopt)
             if (iopt .ne. -1) then
                do i=1,iv
                   xyzs(i,j)= vet(i)
                enddo
             endif
             if (iv == 3) then
                 xyzs(4,j) = bt
                 xyzs(5,j) = 1.0
             end if
             if (iv == 4) then
                 xyzs(5,j) = 1.0
             end if
         endif
   10 continue
      end do
   20 close(44)
      nats = j

c     print*,nats

      sumfor = 0.
      sumfc = 0.
!

c     nnn=nats
c     itype1 = 0
c     do i=1,nnn
c        xo(1)=xyzs(1,i)
c        xo(2)=xyzs(2,i)
c        xo(3)=xyzs(3,i)
c        iser=i
c        iactn=1
c        khead=0
c        ksp=kspecb(newvet,xo,xn,keyx,itype1,iser,khead,iactn)
c        if (ksp < 0) xyzs(5, i) = 1.0/float(keyx(10))
c     enddo


      do i=1,nrefl
         i1(1)=khl(1,i)
         i1(2)=khl(2,i)
         i1(3)=khl(3,i)

         eps=epsv(i)
         multt=mult(i)
!
!-- compute H*R and H*T
!
         do j=1,nsym
            tt=1000.0
            do l=1,3
               tt=tt+float(i1(l))*tmat(j,l)
               hkle(l,j)=0

               do k=1,3
                  hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)
               enddo

            enddo
            hkle(4,j)=tt
         enddo
         rho=rhov(i)
         
         act=0.0
         bct=0.0
         
         ffnk(kheavy) = cld(kheavy)
         do ii=1,4
            ffnk(kheavy) = ffnk(kheavy) + ald(ii,kheavy) * 
     *                     exp(-bsd(ii,kheavy)*rho)
         end do

         sfj = 0.
         do jj=1,nats
            if (nz(jj).ne.0) then
                arg=-xyzs(4,jj)*rho
                effe=pts*ffnk(nz(jj))*exp(arg)
                tfocc=effe*xyzs(5,jj)
                sfj = sfj + tfocc
!
                att=0.0
                btt=0.0
                do  j=1,nsym
                   arg=amod(hkle(1,j)*xyzs(1,jj)
     *                     +hkle(2,j)*xyzs(2,jj)
     *                     +hkle(3,j)*xyzs(3,jj)
     *                     +hkle(4,j),1.0)
                   iarg=int(360.0*arg+0.5)+1
                   if (iarg.eq.361) iarg=1
                   att=att+cost(iarg)
                   btt=btt+sint(iarg)
                enddo
                if (icent.eq.0) then
                    contc=att
                    conts=btt
                else
                    contc=2.0*att
                    conts=0.0
                endif
!
                contc=contc*tfocc
                conts=conts*tfocc
                act=act+contc
                bct=bct+conts
            endif
         enddo

         sfj = sfj*sqrt(eps*nsym)

         args=act*act+bct*bct
         if (args.gt.0.000001) then
             fc=sqrt(args)
             faze=rtod*atan2(bct,act)+360.0
         else
             fc=0.0
             faze=0.0
         endif

         iphazH(kheavy,i) = mod(int(faze+0.5), 360)
         eH(kheavy,i) = fc/sfj
         fcH(kheavy,i) = fc  ! test dritan
         if (iphazH(kheavy,i).eq.0) then
            iphazH(kheavy,i) = 360
         end if

c        write(1,*)i,i1,fc,fc/sfj,faze
      enddo
!
      iAction = 2
      call AllocaAtomi(iAction)
!
      return
      end 
!----------------------------------------------------------------------
      subroutine GetHkl(ifLine, line, formt, kh, kk, kl, fo, phyr, f, 
     *                  sigma, nmax, nofop, rfreev, ier, ios, ifEof)
      USE General
!
      logical ifEof
      character*(*) line, formt
      dimension f(50)
!
      rfreeval = 0
      if (ifLine == 1) then
          ifLine = 0
          if (nofop == 0) then
              if (knw == 0) then
                  read(line,formt,end=10,err=20,iostat=ios)
     *                       kh,kk,kl,fo,sigma,f(1:nmax)
              else
                  read(line,formt,end=10,err=20,iostat=ios)
     *                       kh,kk,kl,fo,sigma,phyr,f(1:nmax)
              endif
          else
              if (knw == 0) then
                  read(line,formt,end=10,err=20,iostat=ios)
     *                       kh,kk,kl,f(1:nmax)
              else
                  read(line,formt,end=10,err=20,iostat=ios)
     *                       kh,kk,kl,phyr,f(1:nmax)
              endif
          endif
      else
          if (nofop == 0) then
              if (knw == 0) then
                  read(jfile,formt,end=10,err=20,iostat=ios)
     *                       kh,kk,kl,fo,sigma,f(1:nmax)
              else
                  read(jfile,formt,end=10,err=20,iostat=ios)
     *                       kh,kk,kl,fo,sigma,phyr,f(1:nmax)
              endif
          else
              if (knw == 0) then
                  read(jfile,formt,end=10,err=20,iostat=ios)
     *                       kh,kk,kl,f(1:nmax)
              else
                  read(jfile,formt,end=10,err=20,iostat=ios)
     *                       kh,kk,kl,phyr,f(1:nmax)
              endif
          endif
      endif
!
      return
   10 ifEof = .true.
      return
   20 ier = -1
      return
      end
!-----------------------------------------------------------------------
      subroutine GetHklMTZD(jump, kh, kk, kl, fo, phyr, f,
     *                  sigma, nmax, nofop, rfreeval, ier, ios, ifEof)
      USE General
!
      logical ifEof, is_a_NaN, IsItaNaN
      dimension f(50)
!
      call lrrefl(MTZunit, resolution, MTZdata, ifEof)
      if (ifEof) then 
          return
      endif
!
      kh    = MTZdata(MTZlookup(1))
      kk    = MTZdata(MTZlookup(2))
      kl    = MTZdata(MTZlookup(3))
      phyr  = 0
      rfreeval = 0
!
      k = 3
      n = knw + nmax
      if (nofop == 0) n = n + 2
      do j=1,n
         i = MTZlookup(j+k)
         is_a_NaN = IsItaNaN(MTZdata(i))
         if (is_a_NaN) then
             MTZdata(i) = -999.00
         end if
      enddo
!
      if (knw == 1) then
          k = k + 1
          phyr = MTZdata(MTZlookup(k))
      endif
!
c     ifo2 = 0
      ifo2N = 0
      if (nofop == 0) then
          k = k + 1
          fo  = MTZdata(MTZlookup(k))
          k = k + 1
          sigma = MTZdata(MTZlookup(k))
c         kk = MTZlookup(k)
c         if (tipo_colonne(k) == 'J'.or.
c    *               tipo_colonne(k) == 'K') then
c            ifo2N = 1
c            fdi = sqrt(fo)
c            sdi = sigma
c            if (fo.ge.sdi) then
c                 if (fdi.gt.0.0) then
c                     sdi = 0.5 * sdi / fdi
c                 endif
c             else
c                 sdi = 0.5 * sdi
c             endif
c             fo = fdi
c             sigma = sdi
c         endif
      endif
!

      fdi = 0.0
      k = k + ifRFree
      do j=1,nmax
         i = MTZlookup(j+k)
c        if (iphase == 0 ) then
c         if (tipo_colonne(i) == 'J'.or.
c    *               tipo_colonne(i) == 'K') then
c            fdi = MTZdata(i) 
c            sdi = MTZdata(i+1) 
c            fdf = sqrt(fdi)
c            sdf = sdi
c            if (fdi.ge.sdi) then
c                 if (fdf.gt.0.0) then
c                     sdf = 0.5 * sdf / fdf
c                 endif
c             else
c                 sdf = 0.5 * sdf
c             endif
c          MTZdata(i) = fdf
c          MTZdata(i+1) = sdf
c         endif
c        endif
         f(j) = MTZdata(i)
      enddo
!
      if (ifRFree == 1) then
          rfreeval = MTZdata(MTZlookup(k))
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ContaRiflessi
      USE General 
      USE RFreeModule
!
      implicit none
      integer :: n
!
      if (ifMTZ == 0) then
          n = 0
          do
              read(jfile,'(a)', end=10) Inte
              n = n + 1
          enddo
   10     rewind(jfile)
      else
          n = nreflMTZ
      endif
!
      call AllocaRFreeVett(1, n)
!
      return
      end
!-----------------------------------------------------------------------
      subroutine AllocaRFreeVett(iAction, n)
      USE General, only : lo
      USE RFreeModule
!
      implicit none
      integer :: iAction, n, ier
!
      if (iAction == 1) then
          allocate(RFreeVett(1:n), stat=ier)
          if (ier == 0) then
              RFreeVett(:) = 0
          else
              write(lo,*) 'RFreeVett Allocation error'
              call cstop(' ')
          endif
      else
          deallocate(RFreeVett, stat=ier)
          if (ier /= 0) then
              write(lo,*) 'RFreeVett deAllocation error'
              call cstop(' ')
          endif
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine ComputePhasesFromCoords(knwfile, ier)
      USE General
      USE Riflessi
!
      implicit none
      integer :: ier, itipo, iform, jopen, ios, nExitCode, Lung
      integer :: k, kk, kStripTask1, jop, ierr, nRefi
      logical :: Esiste
      character (len=256) :: knwfile
!
      itipo = 2
      iform = 1
      if (jopen(jhost,knwfile,itipo,iform,ios).lt.0) then
          ier = -1
          knw = 0
          Msg = 'Coordinate file: '// knwfile(1:Lung(knwfile))//
     *                            ' not found'
          call MsgWinErr('ERROR', Msg, ERR_WINDOW, nExitCode)
          return
      endif
!
      jwork1(:) = iphaz(:)
      tmpwt(:) = wt(:)
!
      k = index(fname(1),'.bin')
      kk = kStripTask1(k) - 1
      direttiva = fname(1)(1:kk) // '_copy_refmac.pdb'
      call cCopyFile(knwfile, direttiva)
!
!-- remove old Refmac file
!
      cardDiret = WorkingDirectory(1:Lung(WorkingDirectory))
     *    // slash // nome(1:lnome) // '_refmac0.mtz '
      inquire (file=cardDiret,  exist = Esiste)
      if (Esiste) then
          itipo = 2
          iform = 1
          jop = jopen(jhost, cardDiret, itipo, iform, ierr)
          close(jhost, status='delete')
      endif
!
!-- start Refmac
!
      nRefi = 0
      call UseRefmac(knwfile, nRefi, 0, 0, 0, ierr)
      jop=jopen(jhost, direttiva, itipo, iform, ier)
      close(jhost, status = 'delete')
      if (ierr == 0) then
          ipub(:) = iphaz(:)
          iphaz(:) = jwork1(:)
          wt(:) = tmpwt(:)
          knw = 1
          call examin(2, mkang, khl, ipub, iphaz, nrefl, 0, wt, 1)
          call UpdateReflInfo
      endif
!
      return
      end
!-----------------------------------------------------------------------
      integer function kStripTask1(k)
      USE General
!
      implicit none
      integer :: k, kk
!
      kk = index(fname(1)(1:k-1),'_task1')
      if (kk == 0) then
          kk = index(fname(1)(1:k-1),'_remo')
          if (kk == 0) then
              kk = index(fname(1)(1:k-1),'_abi')
              if (kk == 0) then
                  kk = index(fname(1)(1:k-1),'_edm')
                  if (kk == 0) then
                      kk = k
                  endif
              endif
          endif
      endif
!
      kStripTask1 = kk
!
      return
      end
!-----------------------------------------------------------------------
      subroutine cCopyFile(fsrc, fdst)
!
      implicit none
      integer :: Lung
      logical :: Esiste
      character*(*) fsrc, fdst
!
      inquire (file=fsrc,  exist = Esiste)
      if (Esiste) then
          call c_copyfile(fsrc(1:Lung(fsrc))//char(0),
     *                    fdst(1:Lung(fdst))//char(0))
      endif
!
      return
      end
!-----------------------------------------------------------------------
      subroutine UseRefmac(knwfile, nRefi, ifDiff, ncy, scrivi, ier)
      USE General
      USE Riflessi
      USE PhaseModule
*     USE ArpWarp
!
      implicit none
      integer :: ier, iAction, lix1, lix2, nExitCode, ksubr
      integer :: Lung, ncy, ifmin, knwSav, ifBreak
      integer :: nreflDimSav, nRefi
      integer :: k, kk, kStripTask1, ifDiff, scrivi
      real    :: celltemp(13), correl
      character (len=*) :: knwfile
!
      ier = 0
      k = index(fname(1),'.bin')
      kk = kStripTask1(k) - 1
      nome = fname(1)(1:kk)
      lnome = Lung(nome)
!
      nreflDimSav = nreflDim
      if (nRefi > 0) then
          nreflDim    = nrefl
      endif
*     call WriteMTZ_Refmac(0, ier)
      nreflDim = nreflDimSav
      call LanciaRefmac(knwfile, nRefi)
!
      lix1 = 1
      lix2 = 1
      Lab_Ch(1) = 'H'
      Lab_Ch(2) = 'K'
      Lab_Ch(3) = 'L'
      Lab_Ch(4) = 'F'
      Lab_Ch(5) = 'SIGF'
      Lab_Ch(7) = 'FOM'      ! peso
      Lab_Ch(6) = 'PHIC_ALL' ! fase
      Lab_Ch(8) = 'FC_ALL'   ! fc
      knwSav = knw
      ifMTZlab = 1
      do iAction =1, 2
         call ManageMTZ(iAction, celltemp, lix1, lix2, ier)
         if (ier /= 0) then
             return
         endif
      enddo
      knw = 0
      call LeggiMTZPhase(ier)
!
      iAction = 3
      call ManageMTZ(iAction, celltemp, lix1, lix2, ier)     !mr
!
      call RefmacResults(1)
!
      knw = knwSav
!
      return
   10 format(/,5x,'Reading FC, WT, PHIC from ',a)
   20 format(/,2x,'After Refmac - Mean Phase Error ',f6.2,
     *       '  (',f6.2,')  over',i8,' reflections')

      end
!-----------------------------------------------------------------------
      subroutine LanciaRefmac(knwfile, nRefi)
      USE General
*     USE ArpWarp
!
      implicit none
      integer :: Lung, istat, iform, jop, jopen, ierr, lcard, lstringa
      integer :: LungMtzName, k, nRefi, QuantiSets, ier
      real    :: LowResolValue
      logical :: Esiste
      character (len=20) :: stringa
      character (len=*) :: knwfile
      character(len=2)  :: LineCont
!
      cardDiret = nome(1:lnome) // '_start.mtz '
      call cCopyFile(MTZfile, cardDiret)
      MTZfile = cardDiret
!
      k = index(fname(2), '.', .TRUE.)
      if (k <= 0) then
          k = 1
      endif
      direttiva = fname(2)(1:k-1) // '_refmac.log'
      cardDiret = nome(1:lnome) // '_refmac.pdb'
!
!-- create shell script
!
      LowResolValue = 8
!!mr      stringa = 'run_refmac.sh'
      if (ifW95 == 0) then
          stringa = 'run_refmac.sh'
      else
          stringa = 'run_refmac.bat'
      endif
!!end mr

      lstringa = Lung(stringa)
      cardImage = nome(1:lnome) // '_' // stringa(1:lstringa)
      istat = 0
      iform = 1
      jop = jopen(jrel, cardImage, istat, iform, ierr)

      if (ifW95 == 0) then
          write(jrel,'(a)') '#!/bin/sh'
          LineCont = ' \'
      else
          LineCont = ' ^'
      endif

      write(jrel,'(a)') 'refmac5' // LineCont
      Msg = 'hklin     ' // MTZfile(1:Lung(MTZfile)) // LineCont
      write(jrel,'(a)') Msg(1:Lung(Msg))
      write(jrel,'(a)') 'xyzin     '
     *                    // knwfile(1:Lung(knwfile)) // LineCont
      write(jrel,'(a)') 'xyzout    '
     *                    // cardDiret(1:Lung(cardDiret)) // LineCont
      cardImage = nome(1:lnome) // '_refmac.inp'
      Msg = 'hklout    ' // nome(1:lnome) // '_refmac0.mtz > '
     *                    // direttiva(1:Lung(direttiva)) // ' <' //
     *                     cardImage(1:Lung(cardImage))
!!mr     *                    // direttiva(1:Lung(direttiva)) // ' <<END'
      write(jrel,'(a)') Msg(1:Lung(Msg))
      close(jrel)
      istat = 0
      iform = 1
      jop = jopen(jhost, cardImage, istat, iform, ierr)
!
      write(jhost,'(a)') 'labin     FP=F SIGFP=SIGF ' //
     *                   'FREE=FreeR_flag'
!
      write(jhost,'(a)') 'refi -'
      write(jhost,'(a)') '    type REST -'
      write(jhost,'(a)') '    resi MLKF -'
      write(jhost,'(a)') '    meth CGMAT'
      write(jhost,'(a,i2)') 'ncyc ', nRefi
      close(jhost)
!
      lstringa = Lung(stringa)
      cardImage = nome(1:lnome) // '_' // stringa(1:lstringa)
      lcard = Lung(cardImage)
      cardImage(lcard+1:lcard+1) = char(0)
      call MakeExec(cardImage)
!
      direttiva = stringa(1:lstringa)
!
!-- start refmac
!
      Buffer1 = WorkingDirectory(1:Lung(WorkingDirectory)) // slash
     *          // nome(1:lnome) // '_' // direttiva(1:Lung(direttiva))
      call Lanciash(Buffer1(1:Lung(Buffer1)) // char(0))
      MTZfile = nome(1:lnome) // '_refmac0.mtz'
!!mr
!-- delete input file
      istat = 0
      iform = 1
      cardImage = nome(1:Lung(nome)) // '_refmac.inp' 
      jop=jopen(jhost, cardImage, istat, iform, ierr)
      close(jhost, status = 'delete')
!!end mr
!
 9000 return
   10 format(4x,'type REST RESOLUTION ',2f8.2,' -')
      end
!-----------------------------------------------------------------------
      subroutine LeggiMTZPhase(ier)
      USE General
      USE Riflessi
      USE PhaseModule
      USE IsrCom
!
      implicit none
      integer :: ier, ierr, i, ii, j, kh, kk, kl, indr, jump
      integer :: idelt, jcode, isgnn, id1, ireje, phase
      real    :: fase, peso, fc, rho, w
      logical :: ifEof
!
      ifat1=(2*ihmx(3)+1)*(2*ihmx(2)+1)
      ifat2=(2*ihmx(3)+1)
      ifatx=ihmx(1)*ifat1+ihmx(2)*ifat2+ihmx(3)
      allocate(isr(1:ifatx), stat = ier)
!
      isr(1:ifatx) = 0
!
      do i=1, nrefl
         kh = khl(1,i)
         kk = khl(2,i)
         kl = khl(3,i)
         indr = iabs( kh * ifat1 + kk * ifat2 + kl )
         isr(indr) = i
      enddo
!
      jump   = 0
      j = 0
!
      do
         j = j + 1
         call GetHklMTZPhase(jump, kh, kk, kl, fase, peso, fc, ifEof)

         if (ifEof) then
             exit
         endif
!
         if (jump == 1) then
             fase = 0
             peso = 0
             fc = -999
         endif
         call geneq(0,kh,kk,kl,idelt,jcode,isgnn,id1,rho,ireje)
         indr = iabs( kh * ifat1 + kk * ifat2 + kl )
         if (indr == 0) then
             cycle
         endif
         if (indr > ifatx) then
             cycle
         endif
         i = isr(indr)
         if (i == 0) then
             cycle
         endif
         phase = fase
         phase = phase + idelt
         phase = phase * isgnn
         phase = mod(phase, 360)
         if (phase <= 0) phase = phase + 360
         iphaz(i) = phase
         wt(i)    = peso
         fcvet(i) = fc
      enddo
!
      deallocate (isr, stat = ierr)
!
      return
      end
!-------------------------------------------------------------------
      subroutine GetHklMTZPhase(jump, kh, kk, kl, fase, peso, fc, ifEof)
      USE General
!
      implicit none
      integer :: jump, kh, kk, kl, i, j
      real    :: fase, peso, fc, resolution
      logical :: ifEof, is_a_NaN, IsItaNaN
!
      call lrrefl(MTZunit, resolution, MTZdata, ifEof)
      if (ifEof) then
          return
      endif
      jump = 0
      kh    = MTZdata(MTZlookup(1))
      kk    = MTZdata(MTZlookup(2))
      kl    = MTZdata(MTZlookup(3))
      do j=4,5
         i = MTZlookup(j)
         is_a_NaN = IsItaNaN(MTZdata(i))
         if (is_a_NaN) then
            jump = 1
         end if
      enddo
      do j=8,9
         i = MTZlookup(j)
         if (i == 0) exit
         is_a_NaN = IsItaNaN(MTZdata(i))
         if (is_a_NaN) then
            jump = 1
         end if
      enddo
      if (jump == 0) then
          if (knw == 1) then
              fase = MTZdata(MTZlookup(7))
              peso = MTZdata(MTZlookup(8))
              fc   = MTZdata(MTZlookup(9))
          else
              fase = MTZdata(MTZlookup(6))
              peso = MTZdata(MTZlookup(7))
              fc   = MTZdata(MTZlookup(8))
          endif
      else
          fase  = -999.99
          peso = -999.99
      end if
!
      return
      end
!-----------------------------------------------------------------------
      subroutine RefmacResults(scrivi)
      USE General
      USE ArpWarp
!
      implicit none
      integer :: i, k, k1, istat, iform, jop, jopen, ierr, Lung
      integer :: iopt, iv, scrivi
      real    :: Valore
      integer :: ivet(40)
      real    :: vet(40)
      logical :: start
      
!
      start = .false.
      k = index(fname(2), '.', .TRUE.)
      if (k <= 0) then
          k = 1
      endif
      direttiva = fname(2)(1:k-1) // '_refmac.log'
      istat = 0
      iform = 1
      jop = jopen(jhost, direttiva, istat, iform, ierr)
      do
         read(jhost,'(a)', end=10) Inte
         if (start) then
             if (scrivi == 1) then
                 write(lo,20)
                 write(lo,30)
                 write(lo,'(a)') trim(Inte)
             endif
             read(jhost,'(a)', end=10) Inte
             if (scrivi == 1) then
                 write(lo,'(a)') trim(Inte)
             endif
             k = index(Inte, 'R factor')
             if (k > 0) then
                 erreAW = 'R = ' // Inte(k+21:k+26)
                 Inte(k:k+7) = '        '
                 iopt = 0
                 call getnum(Inte, vet, ivet, iv, iopt)
                 RfacAWi = vet(1)
                 RfacAW  = vet(2)
             endif
             read(jhost,'(a)', end=10) Inte
             if (scrivi == 1) then
                 write(lo,'(a)') trim(Inte)
             endif
             k = index(Inte, 'R free')
             if (k > 0) then
                 k1 = Lung(erreAW) + 1
                 erreAW(k1:) = '  (Rfree = ' // Inte(k+19:k+24) // ')'
                 Inte(k:k+5) = '      '
                 iopt = 0
                 call getnum(Inte, vet, ivet, iv, iopt)
                 RfreAWi = vet(1)
                 RfreAW  = vet(2)
             endif
             if (scrivi == 1) then
                 write(lo,20)
             endif
             exit
         endif
         if (index(Inte, '$$ Final results $$') > 0) then
             start = .true.
         endif
      enddo
!
   10 close(jhost)
!
      return
   20 format(4x,' ---------------------------------------')
   30 format(4x,' Final Refmac results:                  ')
      end
!-----------------------------------------------------------------------
